(* ::Package:: *)

(* ::Section:: *)
(*UpWise integration of a generic expression*)


(* ::Subsection::Closed:: *)
(*misc*)


subusu={\[ScriptU]$[var_][sh_:0]:>(u+var+I sh/2/.v0->v00)};


Generic\[Eta]List[{1},n_/;n>=0]:=Block[{z,t,u},Normal@Series[\[Eta]$[1][0]/.subtoPolyGammas,{u,\[Infinity],n}]/.u->1/z//t^-Range[0,n] (CoefficientList[#,z]//(Join[#,ConstantArray[0,(n+1)-Length@#]]&))/.z->1/t&];


Generic\[Eta]List[L_,A_/;A<0]:=First@Generic\[Eta]List[L,Total@L];


DownValues@Generic\[Eta]List=DeleteDuplicates[Join[Cases[DownValues@Generic\[Eta]List,\!\(\*
TagBox[
StyleBox[
RowBox[{"_", "[", 
RowBox[{
RowBox[{"_", "[", 
RowBox[{"_", "[", 
RowBox[{
RowBox[{"_", "[", 
RowBox[{"L", ",", "_"}], "]"}], ",", 
RowBox[{"_", "[", 
RowBox[{
RowBox[{"_", "[", 
RowBox[{"A", ",", "_"}], "]"}], ",", 
RowBox[{"Less", "[", 
RowBox[{"A", ",", "0"}], "]"}]}], "]"}]}], "]"}], "]"}], ",", "_"}], "]"}],
ShowSpecialCharacters->False,
ShowStringCharacters->True,
NumberMarks->True],
FullForm]\)],
DownValues@Generic\[Eta]List]]


DownValues@Generic\[Eta]List=DeleteDuplicates[Join[Cases[DownValues@Generic\[Eta]List,\!\(\*
TagBox[
StyleBox[
TagBox[
StyleBox[
RowBox[{"_", "[", 
RowBox[{
RowBox[{"_", "[", 
RowBox[{"_", "[", 
RowBox[{
RowBox[{"_", "[", 
RowBox[{
RowBox[{"_", "[", 
RowBox[{"L", ",", "_"}], "]"}], ",", 
RowBox[{"_", "[", 
RowBox[{"A", ",", "_"}], "]"}]}], "]"}], ",", 
RowBox[{"Less", "[", 
RowBox[{"A", ",", 
RowBox[{"_", "[", 
RowBox[{"_", "[", 
RowBox[{"L", ",", 
RowBox[{"-", "1"}]}], "]"}], "]"}]}], "]"}]}], "]"}], "]"}], ",", "_"}], "]"}],
ShowSpecialCharacters->False,
ShowStringCharacters->True,
NumberMarks->True],
FullForm],
ShowSpecialCharacters->False,
ShowStringCharacters->True,
NumberMarks->True],
FullForm]\)],
DownValues@Generic\[Eta]List]]


(* ::Subsubsection::Closed:: *)
(*dealing with important warning messages*)


(* ::Text:: *)
(*if the flag \[Section]QuitAtMessage is set, then make everything stop when an important message occurs :*)


SetAttributes[ImportantMessage,HoldAll];
ImportantMessage[A___]:=(Message[A];If[\[Section]Verbose,Print["Warning issued, stopping other outputs"];\[Section]Verbose=False;];If[\[Section]QuitAtMessage,Quit[]];);


(* ::Subsection::Closed:: *)
(*Implementation of the recursive integration procedure (returns a result with generalized eta functions)*)


Off[Attributes::ssle];
Off[Attributes];


FractionQ[e_,v_]:=PolynomialQ[Denominator@Together@e,v] && PolynomialQ[Numerator@Together@e,v];


Module[{R1,R2},
R1=(\[Eta]$[a__][b___,c_List]/;Length@c==Length@{a}:>Block[{V},Which[Length@{b}==0,V=u,
Length@{b}==1,V={b}[[1]],
True,ImportantMessage[Shift\[Eta]::Pb]];
(1/(V + (I/2)*c[[1]]))^{a}[[1]](\[Eta]$@@({a}[[2;;]]))[b,2+c[[2;;]]]+\[Eta]$[a][b,c+2]/.\[Eta]$[][___]->1]);
R2=(\[Eta]$b[a__][b___,c_List]/;Length@c==Length@{a}:>Block[{V},Which[Length@{b}==0,V=u,
Length@{b}==1,V={b}[[1]],
True,ImportantMessage[Shift\[Eta]::Pb]];
(1/(V + (I/2)*c[[1]]))^{a}[[1]]*(\[Eta]$b @@ {a}[[2;;]])[b,-2+c[[2;;]]]+\[Eta]$b[a][b,c-2]/.\[Eta]$b[][___]->1]);

shiftp\[Eta]g={R1,R2,
(Hd:\[Eta]$|\[Eta]$b)[a__][b___,c_?NumericQ]:>(Hd[a][b,ConstantArray[c,Length@{a}]]/.R1/.R2/.(
Hd[x__][y___,z_List]/;Length[Union[z]]==1:>Hd[x][y,z[[1]]])),
(Hd:\[Eta]$|\[Eta]$b)[][v___,{}]:>Hd[][v,{}],
(\[Eta]$|\[Eta]$b)[___][___]:>ImportantMessage[Shift\[Eta]::Pb]}];


Module[{R1,R2},
R1=(\[Eta]$[a__][b___,c_List]/;Length@c==Length@{a}:>Block[{V},Which[Length@{b}==0,V=u,
Length@{b}==1,V={b}[[1]],
True,ImportantMessage[Shift\[Eta]::Pb]];
-(1/(V + (I/2)(c[[1]]-2)))^{a}[[1]](\[Eta]$@@({a}[[2;;]]))[b,c[[2;;]]]+\[Eta]$[a][b,c-2]/.\[Eta]$[][___]->1]);
R2=(\[Eta]$b[a__][b___,c_List]/;Length@c==Length@{a}:>Block[{V},Which[Length@{b}==0,V=u,
Length@{b}==1,V={b}[[1]],
True,ImportantMessage[Shift\[Eta]::Pb]];
-(1/(V + (I/2)*(c[[1]]+2)))^{a}[[1]](\[Eta]$b@@{a}[[2;;]])[b,c[[2;;]]]+\[Eta]$b[a][b,c+2]/.\[Eta]$b[][___]->1]);

shiftm\[Eta]g={R1,R2,
(Hd:\[Eta]$|\[Eta]$b)[a__][b___,c_?NumericQ]:>(Hd[a][b,ConstantArray[c,Length@{a}]]/.R1/.R2/.(
Hd[x__][y___,z_List]/;Length[Union[z]]==1:>Hd[x][y,z[[1]]])),
(\[Eta]$|\[Eta]$b)[___][___]:>ImportantMessage[Shift\[Eta]::Pb]}];


subshifttolist={(*(Hd:(\[Eta]$|\[Eta]$b))[a__][x_]:>Hd[a][u,x],*)(Hd:(\[Eta]$|\[Eta]$b))[a___][v___,xx_]/;(Head@xx=!=List):>Hd[a][v,ConstantArray[xx,Length@{a}]]};


subshiftfromlist={(Hd:(\[Eta]$|\[Eta]$b))[a__][b___,xx_List]/;Length[Union[xx]]===1:>Hd[a][b,xx[[1]]]};


TaylorExpand:=With[{X=OptionValue[Taylor,Variable]},{e_:>(If[OptionValue[Taylor,Series]===Keep,Identity,Normal]@Series[
e/.(Hd:\[Eta]$|\[Eta]$b)[][___]:>1/.(Hd:\[Eta]$|\[Eta]$b)[a__][b_]:>Hd[a][X OptionValue[Taylor,\[Eta]Factor],b]/.(Hd:\[Eta]$|\[Eta]$b)[a__][b_,c_?NumericQ]:>Hd[a][b,ConstantArray[c,Length@{a}]]//.{
\[Eta]$[a__][b_,c_]/;(Or@@(PositiveIntegerQ[((b/.X->OptionValue[Taylor,Point])+I #/2)/-I]&/@c)):>(\[Eta]$[a][b,c]/.shiftp\[Eta]g),
\[Eta]$b[a__][b_,c_]/;(Or@@(PositiveIntegerQ[((b/.X->OptionValue[Taylor,Point])+I #/2)/I]&/@c)):>(\[Eta]$b[a][b,c]/.shiftp\[Eta]g)
},{X,OptionValue[Taylor,Point],OptionValue[Taylor,Order]}]//.{
(PP:(\[Eta]$|\[Eta]$b))[a__][OptionValue[Taylor,Point] OptionValue[Taylor,\[Eta]Factor],b_]:>PP[a][(OptionValue[Taylor,Point]OptionValue[Taylor,\[Eta]Factor])/(I/2)+b],
Derivative[r_,{0..}][\[Eta]$[a__]][A_,b_]:>(\[Eta]D[\[Eta]$[a][0],r]/.\[Eta]$[x__][0]:>\[Eta]$[x][A,b]),
Derivative[r_,{0..}][\[Eta]$b[a__]][A_,b_]:>(\[Eta]D[\[Eta]$[a][0],r]/.\[Eta]$[x__][0]:>\[Eta]$b[x][A,b])}/.{
(Hd:\[Eta]$|\[Eta]$b)[a__][b___,c_List]/;Length[Union[c]]==1:>Hd[a][b,c[[1]]]
}/.sub\[Eta]\[Zeta])}]


Residu:=With[{X=OptionValue[Taylor,Variable]},{e_:>(Residue[
e/.(Hd:\[Eta]$|\[Eta]$b)[][___]:>1/.(Hd:\[Eta]$|\[Eta]$b)[a__][b_]:>Hd[a][X ,b]/.(Hd:\[Eta]$|\[Eta]$b)[a__][b_,c_?NumericQ]:>Hd[a][b,ConstantArray[c,Length@{a}]]//.{
\[Eta]$[a__][b_,c_]/;(Or@@(PositiveIntegerQ[((b/.X->OptionValue[Taylor,Point])+I #/2)/-I]&/@c)):>(\[Eta]$[a][b,c]/.shiftp\[Eta]g),
\[Eta]$b[a__][b_,c_]/;(Or@@(PositiveIntegerQ[((b/.X->OptionValue[Taylor,Point])+I #/2)/I]&/@c)):>(\[Eta]$b[a][b,c]/.shiftp\[Eta]g)
},{X,OptionValue[Taylor,Point]}]//.{
PP_[a__][OptionValue[Taylor,Point],b_]/;MemberQ[{\[Eta]$,\[Eta]$b},PP]:>PP[a][(OptionValue[Taylor,Point])/(I/2)+b],
Derivative[r_,{0..}][\[Eta]$[a__]][A_,b_]:>(\[Eta]D[\[Eta]$[a][0],r]/.\[Eta]$[x__][0]:>\[Eta]$[x][A,b]),
Derivative[r_,{0..}][\[Eta]$b[a__]][A_,b_]:>(\[Eta]D[\[Eta]$[a][0],r]/.\[Eta]$[x__][0]:>\[Eta]$b[x][A,b])}/.{
(Hd:\[Eta]$|\[Eta]$b)[a__][b___,c_List]/;Length[Union[c]]==1:>Hd[a][b,c[[1]]]
})}];


sub\[Eta]0={\[Eta]$[0,a_,b___][v___,xx_List]/;Length@{v}<=1 (*&& Plus[a,b]>=3*) && a>0 :>-I \[Eta]$[a-1,b][v,xx[[2;;]]]+I(If[{v}=={},u,v]+I/2 xx[[2]])\[Eta]$[a,b][v,xx[[2;;]]],
\[Eta]$[0,a_,b___][v___,xx_]/;Length@{v}<=1 (*&& Plus[a,b]>=3*) && a>0:>-I \[Eta]$[a-1,b][v,xx]+I(If[{v}=={},u,v]+I/2 xx)\[Eta]$[a,b][v,xx],
\[Eta]$[0,0,a_,b___][v___,xx_]/;Length@{v}<=1 (*&& Plus[a,b]>=4*) && a>0:> If[Head@xx===List,-I \[Eta]$[0,a-1,b][v,xx[[2;;]]]+1/2 (\[Eta]$[a-2,b][v,xx[[3;;]]]-\[Eta]$[0,a,b][v,xx[[2;;]]] -(If[{v}=={},u,v]+I/2 xx[[3]])^2 \[Eta]$[a,b][v,xx[[3;;]]])
,\[Eta]$[0,0,a,b][v,xx]/.subshifttolist/.sub\[Eta]0/.subshiftfromlist]
};


subto\[Eta]0={
p_. v_ \[Eta]$[a___][v_,c_List]/;(And@@((#1>=1&)/@{a})):>(p(-I/2 c[[1]] \[Eta]$[a][v,c]+1/I(\[Eta]$[0,a][v,{If[IntegerQ[First@c],First@c,Last@c]}~Join~c]+I (\[Eta]$@@({a}-((Boole[#==1]&)/@(Range@Length@{a}))))[v,c])))};


DenFactorize[a_ b_,c_]:=DenFactorize[a,c]DenFactorize[b,c];
DenFactorize[(a_)^b_.,v_]/; PolynomialQ[a,v] && Exponent[a,v]==1:=Block[{m,p},
{p,m}=CoefficientList[a,v];m^b (v+p/m)^b];
DenFactorize[(a_)^b_. c_. ,v_]/; PolynomialQ[a,v] && Exponent[a,v]==1:=a^b DenFactorize[c,v];
DenFactorize[eE_,v_]/;PolynomialQ[Denominator@eE,v]:=(Block[{e=Together@eE,n,d},
d=Denominator@e;
n=Exponent[d,v];
If[n==0,e,
Numerator[e]/(Coefficient[d,v^n]Product[
rr/.((a48798_->b48798_):>(a48798-b48798)),{rr,First/@Solve[d==0,v]/.{a_/;(Head@a===Root)||(NumericQ@a):>(FullSimplify@Re@a+I FullSimplify@Im@a)}
}])]]//If[FullSimplify[MySimp[#-eE]==0]=!=True,ImportantMessage[DenFactorize::Pb];eE,#]&);


(* ::Text:: *)
(*Below defines a function UpIntegrate such that UpIntegrate[f[xx],xx] integrates the function f over a contour made of the real axis closed at +I\[Infinity]*)


\[Epsilon]t0={E_:>Quiet[Check[E/.\[Epsilon]->0,Limit[E,{\[Epsilon]->0}]]]}


UpIntegrate[a_. ((Hd : \[Eta]$|\[Eta]$b)[b___][c_])^p_.,v_]:=UpIntegrate[a  Hd[b][v,c]^p/.subshifttolist ,v];
UpIntegrate[a_. ((Hd : \[Eta]$|\[Eta]$b)[b___][vv_,c_/;Head@c=!=List])^p_.,v_]:=UpIntegrate[a  Hd[b][vv,c]^p/.subshifttolist ,v];
UpIntegrate[a_. ((Hd : \[Eta]$|\[Eta]$b)[b___][x_,c_List])^p_.,v_]/;(Expand[x-v]//(NumericQ[#/.\[Epsilon]t0] && (#=!=0) )&):=UpIntegrate[a  Hd[b][v,c+Expand[x-v]/(I/2)]^p ,v];
UpIntegrate[a_Plus,v_]:=UpIntSimp[(UpIntegrate[#1,v]&)/@a(*/.\[Epsilon]t0*)];
UpIntegrate[a_. \[Eta]$b[][___],v_]:=UpIntegrate[a,v];


UpIntegrate[a_. \[Eta]$[b___][vv_,c_List]\[Eta]$[d___][vv_,e_List],v_]:=UpIntegrate[a (\[Eta]$[b][vv,c]\[Eta]$[d][vv,e]/.subfromproduct),v];
UpIntegrate[a_. \[Eta]$b[b___][vv_,c_List]\[Eta]$b[d___][vv_,e_List],v_]:=UpIntegrate[a (\[Eta]$b[b][vv,c]\[Eta]$b[d][vv,e]//Conjugate//#/.fromConj/.subfromproduct&//Conjugate[#]/.fromConj&),v];


UpIntegrate[a_. \[Eta]$[b___][vv_,c_List]^2,v_]:=UpIntegrate[a (\[Eta]$[b][vv,c]^2/.subfromproduct),v];
UpIntegrate[a_. \[Eta]$b[b___][vv_,c_List]^2,v_]:=UpIntegrate[a (\[Eta]$b[b][vv,c]^2//Conjugate//#/.fromConj/.subfromproduct&//Conjugate[#]/.fromConj&),v];


UpIntegrate[a_?NumericQ b_.,v_]:=a UpIntegrate[b,v];


MyEquiv[\[Eta]$[L__][v_,sh_]/P_,v_]/;PolynomialQ[P,v] && (Total[{L}-1] >(2-Exponent[P,v]))  &&(Quiet[Check[Generic\[Eta]List[{L},3];False,True]]):=0
(*My equiv goes only up to the term in 1/u^2*)


MyEquiv[Expr_,v_]:=(Expr/.subshiftfromlist//.sub\[Eta]0/.(Hd:\[Eta]$|\[Eta]$b)[][___]->1/.(Hd:\[Eta]$|\[Eta]$b)[II___][j___,k_List]:>(*Warning : This subsitution is inacurate for non-leading terms*)Hd[II][j,First@k]/.A_. \[Eta]$[II___][j___,k_?NumericQ]:>(A (Total@Generic\[Eta]List[{II},2+FracDeg[A,v]]/.t:>(First@If[(Length@{j})===1,{j},{v}]+I/2 k)))/.A_. \[Eta]$b[II___][j___,k_?NumericQ]:>(A (Conjugate@Total@Generic\[Eta]List[{II},2+FracDeg[A,v]]/.t:>(First@If[(Length@{j})===1,{j},{v}]-I k/2)/.fromConj))//Series[#,{v,\[Infinity],2}]&//Normal);


DoubtUpIntegrate[A_,v_]/;(ExpaCol[A,(\[Eta]$|\[Eta]$b)[___][___],DenFactorize[#,v]&]=!=A ):=DoubtUpIntegrate[ExpaCol[A,(\[Eta]$|\[Eta]$b)[___][___],DenFactorize[#,v]&],v]


DoubtUpIntegrate[A_Plus,v_]:=(DoubtUpIntegrate[#,v]&/@A);


DoubtUpIntegrate[A_ b_/;Quiet[NumericQ[b/.\[Zeta]$[II___][0]:>Zeta[1,5,II]]],v_]:=b DoubtUpIntegrate[A,v]


DoubtUpIntegrate[A:c_. (a_. w_+b_.)^p_. \[Eta]$b[II___][w_,sh_List],w_]/;(\[Section]AllowDown=!=False) && ((b/.\[Epsilon]t0)=!=0) && Quiet@Check[TimeConstrained[A//Conjugate[#]/.fromConj&//UpIntegrate[#,u]&;
Limit[Abs[MyEquiv[A/.\[Epsilon]t0/.v->0,w]w^(1/2)],w->\[Infinity]]===0,3,1/0],False]:=Block[{BisTerm,dd},dd=D[First@sh,\[Epsilon]];If[!NumericQ[dd]||dd===0,dd=-2];
BisTerm=c (a(w+dd \[Epsilon] I/2))^p \[Eta]$b[II][w,sh];
1/a^p DoubtUpIntegrate[a^p BisTerm,w]+ ( (A-BisTerm) //Conjugate[#]/.fromConj&//UpIntegrate[#,u]&//Conjugate[#]/.fromConj&)];


Doubtfull[Expr_,w_]:=Quiet@Check[(\[Section]CheckCV=!=False && Quiet[Block[{quiv,AbsSum,expr},
expr=Expr/.\[Zeta]$[II___][0]:>Zeta[1,5,II];
quiv=MyEquiv[expr/.\[Epsilon]t0/.v->0,w];
(Abs[Limit[quiv w,w->\[Infinity]]]===\[Infinity]) || ((!FreeQ[expr,\[Eta]$b[__][___]])&& (Limit[MyEquiv[expr/.\[Epsilon]t0/.v->0/.subshifttolist/.\[Eta]$b[II___][j___,k_List]:>
(w+I/2 k[[1]])^-{II}[[1]] (\[Eta]$b@@{II}[[2;;]])[j,k[[2;;]]],w]w^2,w->\[Infinity]])//Abs//(#===\[Infinity] ||(NumericQ[#] && #=!=0))&)],
Zeta::nonopt]),True];
UpIntegrate[A_,w_]/;(Doubtfull[A,w]):=If[\[Section]CheckCV===True,
Block[{R=DoubtUpIntegrate[A,w]},
If[!FreeQ[R,DoubtUpIntegrate],Message[UpIntegrate::Doubtful,A,w]];R],
Message[DoubtFull::desactivating];\[Section]CheckCV=False;UpIntegrate[A,w]];


DoubtFull::desactivating="Warning : Some convergence issue may arise in the recursive evaluation of integrals.
Please check that this cannot affect the final the final result.
No further convergency check will be performed, but if you want the package to be more carefull about his, you may wish to set '\[Section]CheckCV=True'. If you do so, Mathematica will try to deal with convergence issues, and will give a non-evaluated result if it fails to deal with convergency issues.";


UpIntegrate::Doubtful="The integral UpIntegrate[`1`,`2`] was not computed due to doubts about the covergence in its computation.
The package will however try to solve the problem.

The present check can be removed by running '\[Section]CheckCV=False'
";


FracDeg[e_, v_] := Exponent[Numerator[Together[e]], v] - 
    Exponent[Denominator[Together[e]], v]; 
Protect[\[Epsilon]]; 
Module[{Positive\[Epsilon]Q0}, Positive\[Epsilon]Q0[e_] := (Im[e] /. \[Epsilon]t0) > 0 || 
      ((Im[e] /. \[Epsilon]t0) == 0 && (Im[e] /. \[Epsilon] -> 10^(-5)) > 0); 
    Positive\[Epsilon]Q[eE_] := (*If[FreeQ[eE, a_Symbol /; Context[a] =!= "System`" && 
         a =!= \[Epsilon]], Positive\[Epsilon]Q0[eE],*) Block[{tt = Positive\[Epsilon]Q0[eE]}, 
       Which[MemberQ[{True, False}, tt], tt, tt = FullSimplify[tt]; 
         MemberQ[{True, False}, tt], tt,(* True,*)
         Block[{Lst}, Lst = Union[Reap[eE /. {a_Symbol /; Context[a] =!= "System`" && 
                    a =!= \[Epsilon] :> (Sow[a]; a)}][[2,1]]]; 
           Lst = (#1 -> Rationalize[Random[],0] & ) /@ Lst; 
           ImportantMessage[Positive\[Epsilon]Q::Substitution, Lst]; tt=tt /. Lst];
MemberQ[{True, False}, tt], tt,
tt=tt//FullSimplify;MemberQ[{True, False}, tt], tt,
True,ImportantMessage[Positive\[Epsilon]Q::NonBoolean,tt];tt
]]](*]*); 
UpIntegrate[a_, v_] /; FreeQ[a, \[Eta]$] := UpIntegrate[a*\[Eta]$[][2], v]; 
UpIntegrate[ee_, v_] /; (ee /. {} /. {\[Eta]$[0][___] -> 0}) === 0 := 0; 
UpIntegrate[e:(a_.)*\[Eta]$[b___][vv_, c_List], v_] /; FractionQ[a, v] && 
     FreeQ[a, \[Eta]$ | \[Eta]$b] && PolynomialQ[vv, v] && Exponent[vv, v] == 1 := 
   UpIntSimp[UpIntSimp[Block[{Pl, Exprforpoles, n}, 
      Pl = Last /@ Last /@ Solve[Denominator[MyTogether[a]] == 0, v]; 
       Pl = Select[Pl, Positive\[Epsilon]Q]; Pl = Union[Pl]; 
       ((Exprforpoles = vv + (I/2)*#1; Exprforpoles = CoefficientList[Exprforpoles, 
            v]; n = -(Exprforpoles[[1]]/Exprforpoles[[2]]); While[Positive\[Epsilon]Q[n], 
           AppendTo[Pl, n]; n = n - I/Exprforpoles[[2]]]) & ) /@ 
        (c + Range[0, 2*(Length[{b}] - 1), 2]); Pl = Union[Pl]; 
       2*I*Pi*Sum[e /. \[Eta]$[][__] -> 1 /. ResiduePt[v, P], {P, Pl}] /. \[Epsilon]t0 //. 
            subto\[Eta]bar\[Eta]0 /. sub\[Eta]\[Zeta] /. {(Hd:\[Eta]$ | \[Eta]$b)[II___][vvv___, 
             ccc_] :> Hd[II][vvv, sqrt3Simp[ccc]]} //. 
         {\[Eta]$[x__][0] :> (\[Eta]$[x][0] /. shiftp\[Eta][0] /. u -> 0), 
          \[Eta]$[x__][s_] /; Element[s, Reals] && s > 2 :> 
           (\[Eta]$[x][s] /. shiftm\[Eta][s] /. u -> 0)} /. sub\[Eta]\[Zeta]]]]; 


ExpaCol[expr_,var_]:=Expand[Collect[expr,var],var];
ExpaCol[expr_,var_,f_]:=Expand[Collect[expr,var,f],var];


UpIntegrate[a_Times,v_]/;ExpaCol[a,(\[Eta]$|\[Eta]$b)[___][___]|(_)^(p_/;p<0)]=!=a:=(UpIntegrate[#,v]& @ExpaCol[a,(\[Eta]$|\[Eta]$b)[___][___]|(_)^(p_/;p<0)]);


MyIntegrate[ee:a_. \[Eta]$[b___][v_,c_List] \[Eta]$b[d___][v_,e_List],{v_,PtmI,\[Infinity]}]/;((ee/.\[Epsilon]t0)=!=0) && FractionQ[a,v]&&FreeQ[a,(\[Eta]$|\[Eta]$b)]&& (!Positive\[Epsilon]Q[I(3/2-(Max@Re@e-Min@Re@e))]):=Block[
{Tmp},Tmp=Block[{\[Section]changeImaginaryShift=Identity},Conjugate[\[Eta]$b[d][v,e]]/.fromConj/.standardizestrangeshifts]//Conjugate@#/.fromConj&;
MyIntegrate[a \[Eta]$[b][v,c] Tmp,{v,-\[Infinity],\[Infinity]}]];
MyIntegrate[ee:a_. \[Eta]$[b___][v_,c_List] \[Eta]$b[d___][v_,e_List],{v_,PtmI,\[Infinity]}]/;((ee/.\[Epsilon]t0)=!=0) && FractionQ[a,v]&&FreeQ[a,(\[Eta]$|\[Eta]$b)]&& (Positive\[Epsilon]Q[I(3/2-(Max@Re@e-Min@Re@e))]):=Block[
{Pl,Exprforpoles,n,p,m,x,Tmp},Which[
Tmp=Apart[DenFactorize[a,v],v];
Head@Tmp===Plus,MyIntegrate[# \[Eta]$[b][v,c] \[Eta]$b[d][v,e],{v,-\[Infinity],\[Infinity]}]&/@Tmp,
Tmp=!=a && (!FreeQ[a,v]) && (!MatchQ[a,xx_. (f_. v+pp_.)^mm_./;mm<=0&&FreeQ[xx,v]&&FreeQ[pp,v]]),MyIntegrate[Tmp \[Eta]$[b][v,c] \[Eta]$b[d][v,e],{v,-\[Infinity],\[Infinity]}],
Positive\[Epsilon]Q[ I e[[1]]]||(Length@c>=1 && Positive\[Epsilon]Q[-I  c[[1]]]),MyIntegrate[ee/.shiftp\[Eta]g,{v,-\[Infinity],\[Infinity]}],
(FreeQ[a,v] && (p=I;m=0;x=a;True)) || MatchQ[a//DenFactorize[#,v]&,xx_. (f_. v+pp_.)^mm_./;mm<=0&&FreeQ[xx,v]&&FreeQ[pp,v] &&(
 p=pp/f;m=mm;x=xx f^m;True)],
Block[{shfm=-Re[e[[1]]]-\[Epsilon]/.Re@\[Epsilon]->\[Epsilon]},
Which[Positive\[Epsilon]Q[p],0,
Positive\[Epsilon]Q[-p] && Positive\[Epsilon]Q[I/2 shfm+p],2 I \[Pi] ee/.ResiduePt[v,-p]//.subto\[Eta]bar\[Eta]0/.sub\[Eta]\[Zeta]
,True,Message[MyIntegrate::xx];$Failed]//If[#===$Failed,MyIntegrate[ee/.shiftp\[Eta]g,{v,-\[Infinity],\[Infinity]}]
,#+MyIntegrate[x*(1/(v + (I/2)*(e[[1]]+shfm)))^{d}[[1]] \[Eta]$b[d][[2;;]][v,-2+e[[2;;]]+shfm](\[Eta]$@@Join[{-m},{b}])[v,Join[{shfm+p/(I/2)},shfm+c-2]],{v,-\[Infinity],\[Infinity]}]
]&
],MatchQ[a,xx_. v /;FreeQ[xx,v]&&(x=xx;True)],
x MyIntegrate[(v \[Eta]$[b][v,c] /.subto\[Eta]0) \[Eta]$b[d][v,e],{v,-\[Infinity],\[Infinity]}],
True,ImportantMessage[MyIntegrate::nonrecognized];$Failed]
]


UpIntegrate[ee:a_. \[Eta]$[b___][v_,c_List] \[Eta]$b[d___][v_,e_List],v_]/;((ee/.\[Epsilon]t0)=!=0) && FractionQ[a,v]&&FreeQ[a,(\[Eta]$|\[Eta]$b)]&& (Positive\[Epsilon]Q[I(3/2-(Max@Re@e-Min@Re@e))]):=UpIntSimp@Block[
{Pl,Exprforpoles,n,p,m,x,Tmp},Which[
Tmp=Apart[DenFactorize[a,v],v];
Head@Tmp===Plus,UpIntegrate[# \[Eta]$[b][v,c] \[Eta]$b[d][v,e],v]&/@Tmp,
Tmp=!=a && (!FreeQ[a,v]) && (!MatchQ[a,xx_. (f_. v+pp_.)^mm_./;mm<=0&&FreeQ[xx,v]&&FreeQ[pp,v]]),UpIntegrate[Tmp \[Eta]$[b][v,c] \[Eta]$b[d][v,e],v],
Positive\[Epsilon]Q[ I e[[1]]]||(Length@c>=1 && Positive\[Epsilon]Q[-I  c[[1]]]),UpIntegrate[ee/.shiftp\[Eta]g,v],
(FreeQ[a,v] && (p=I;m=0;x=a;True)) || MatchQ[a//DenFactorize[#,v]&,xx_. (f_. v+pp_.)^mm_./;mm<=0&&FreeQ[xx,v]&&FreeQ[pp,v] &&(
 p=pp/f;m=mm;x=xx f^m;True)],
Block[{shfm=-Re[e[[1]]]-\[Epsilon]/.Re@\[Epsilon]->\[Epsilon]},
Which[Positive\[Epsilon]Q[p],0,
Positive\[Epsilon]Q[-p] && Positive\[Epsilon]Q[I/2 shfm+p],2 I \[Pi] ee/.ResiduePt[v,-p]//.subto\[Eta]bar\[Eta]0/.sub\[Eta]\[Zeta]
,True,$Failed]//If[#===$Failed,UpIntegrate[ee/.shiftp\[Eta]g,v]
,#+UpIntegrate[x*(1/(v + (I/2)*(e[[1]]+shfm)))^{d}[[1]] \[Eta]$b[d][[2;;]][v,-2+e[[2;;]]+shfm//Expand](\[Eta]$@@Join[{-m},{b}])[v,Join[{shfm+p/(I/2)},shfm+c-2]//Expand],v]
]&
],MatchQ[a,xx_. v /;FreeQ[xx,v]&&(x=xx;True)],
x UpIntegrate[(v \[Eta]$[b][v,c] /.subto\[Eta]0) \[Eta]$b[d][v,e],v],
True,ImportantMessage[MyIntegrate::nonrecognized];$Failed]
]


(* ::Text:: *)
(*bellow changes the priority order for these various defs*)


Block[{n=First@First@Position[DownValues[UpIntegrate],_[_[Z_[a,P_[Plus]],Z_[v,P_[]]]]:>_]},
DownValues[UpIntegrate]=({DownValues[UpIntegrate][[n]]}~Join~DownValues[UpIntegrate][[1;;n-1]]~Join~DownValues[UpIntegrate][[n+1;;-1]])];


Block[{n=First@First@Position[DownValues[UpIntegrate],\!\(\*
TagBox[
StyleBox[
RowBox[{"_", "[", 
RowBox[{"_", "[", 
RowBox[{
RowBox[{"_", "[", 
RowBox[{
RowBox[{"P_", "[", 
RowBox[{"ee", ",", 
RowBox[{"B_", "[", "]"}]}], "]"}], ",", 
RowBox[{"P_", "[", 
RowBox[{"v", ",", 
RowBox[{"B_", "[", "]"}]}], "]"}]}], "]"}], ",", 
RowBox[{"_", "[", 
RowBox[{
RowBox[{"R_", "[", 
RowBox[{
RowBox[{"R_", "[", 
RowBox[{"ee", ",", "_"}], "]"}], ",", 
RowBox[{"List", "[", 
RowBox[{"Rule", "[", 
RowBox[{
RowBox[{
RowBox[{"\\[Eta]$", "[", "0", "]"}], "[", 
RowBox[{"BN_", "[", "]"}], "]"}], ",", "0"}], "]"}], "]"}]}], "]"}], ",", "0"}], "]"}]}], "]"}], "]"}],
ShowSpecialCharacters->False,
ShowStringCharacters->True,
NumberMarks->True],
FullForm]\):>_]},
DownValues[UpIntegrate]=({DownValues[UpIntegrate][[n]]}~Join~DownValues[UpIntegrate][[1;;n-1]]~Join~DownValues[UpIntegrate][[n+1;;-1]])];


(* ::Subsection::Closed:: *)
(*simplify non-standard shifts*)


PrependTo[subtoPolyGammas,Module[{sh},(Hd:\[Eta]$|\[Eta]$b)[a_][var_,b_]:>(Hd[a][sh]/.subtoPolyGammas/.u->0/.sh->Expand[b+var/(I/2)])]]


(* ::Text:: *)
(*the code above calls the function UpIntSimp on its final result... Let us then define it as follows : (collect, standard shift, etc)*)


subto\[Eta]bar\[Eta]0={\[Eta]$b[d__][a_+v00/(I/2)]/;Im[a]==0:>\[Eta]0$b[d][a//Expand],\[Eta]$b[d__][a_-v00/(I/2)]/;Im[a]==0:>(-1)^Plus[d] \[Eta]0$[d][-a//Expand],
\[Eta]$b[d__][a_/;Im[a]!=0]:>\[Eta]$b[d][FullSimplify@Re[a]+I FullSimplify@Im[a]],\[Eta]$b[d__][-2]:>(-1)^Plus[d] \[Eta]$[d][2](*/.shiftm\[Eta][2]*),
\[Eta]$[d__][a_+v00/(I/2)]/;Im[a]==0:>\[Eta]0$[d][a//Expand],\[Eta]$[d__][a_-v00/(I/2)]/;Im[a]==0:>(-1)^Plus[d] \[Eta]0$b[d][-a//Expand],
\[Eta]$[d__][a_,b_]:>(\[Eta]$[d][b+a/(I/2)]/.subto\[Eta]bar\[Eta]0/.\[Eta]$[II___][cc_]:>\[Eta]$[II][a,cc-a/(I/2)//Expand]),
\[Eta]$b[d__][a_,b_]:>(\[Eta]$b[d][b+a/(I/2)]/.subto\[Eta]bar\[Eta]0/.\[Eta]$b[II___][cc_]:>\[Eta]$b[II][a,cc-a/(I/2)//Expand]),\[Eta]$[d__][a_/;Im[a]!=0]:>\[Eta]$[d][FullSimplify@Re[a]+I FullSimplify@Im[a]]};


fromConj=Module[{DUI},{Re[a_Symbol]->Re[a],Conjugate[a_]:>Block[{X},X=a//.fromConj;
X/.DoubtUpIntegrate->DUI/.aa_?NumericQ:>Conjugate@aa/.{(Hd:\[Eta]$|\[Eta]0$|\[Eta]$b|\[Eta]0$b(*|\[Eta]\[Eta]$*))[x___][v___,y_]:>(Hd/.{\[Eta]$->\[Eta]$b,\[Eta]0$->\[Eta]0$b,\[Eta]$b->\[Eta]$,\[Eta]0$b->\[Eta]0$(*,\[Eta]\[Eta]$->\[Eta]\[Eta]$b*)})[x][v,-(*Conjugate@*)y]}/.{
\[Eta]$b[II_][0,c_]:>(-1)^Plus[II] \[Eta]$[II][0,-(*Conjugate@*)c](*,
\[Eta]\[Eta]$b[xxx___][yy_]:>(-1)^Plus[xxx] \[Eta]\[Eta]$[xxx][-yy]*)}/.{DUI[JJ_,KK_]:>Conjugate[DoubtUpIntegrate[Conjugate[JJ],Conjugate[KK]]/.fromConj]}],(*Here, conjugate is commented out because Complex[x_,y_]:>Complex[x,-y] already performs a complex-conjugacy*)
Re[a_]:>((Conjugate[a]//.fromConj)+(a//.fromConj))/2,
Im[a_]:>(-(Conjugate[a]//.fromConj)+(a//.fromConj))/(2 I)}];


Module[{Collisions,fF,Xx,vv},
Collisions[nN_,0]:=Collisions[nN,0]={Range@nN};
Collisions[nN_,n_]/;2n>nN={};
Collisions[nN_,n_]:=Collisions[nN,n]=Join@@Table[Join[Range@k,{{k+1,k+2}},k+2+#]&/@Collisions[nN-k-2,n-1],{k,0,nN-2n}];
Collisions[nN_]:=Collisions[nN]=Join@@Table[Collisions[nN,n],{n,1,Floor[nN/2]}];


subfromproduct={\[Eta]$[a_][vv_,b_]^2:>(\[Eta]$[2 a][vv,b]+2 \[Eta]$[a,a][vv,b]/.subshiftfromlist),
(*\[Eta]$[a__][vv_,b_]^2:>(\[Eta]$[a][vv,b]+\[Eta]$[{a}[[1]]+\[Epsilon],Sequence@@({a}[[2;;]])][vv,b]/.subfromproduct/.\[Epsilon]t0),
*)\[Eta]$[a__][b_]^2:>(\[Eta]$[a][vv,b]^2/.subshifttolist/.subfromproduct/.subshiftfromlist/.vv->Sequence@@{}),
\[Eta]$[a__][b_]\[Eta]$[c__][d_]:>(\[Eta]$[a][u,b]\[Eta]$[c][u,d]/.subshifttolist/.subfromproduct/.\[Eta]$[aA__][u,bB_]:>\[Eta]$[aA][bB]/.subshiftfromlist),
\[Eta]$[IIa___][0,Sha_List]\[Eta]$[IIb___][0,Shb_List]:>(\[Eta]$[IIa][Xx,Sha]\[Eta]$[IIb][Xx,Shb]/.subfromproduct/.Xx->00),
\[Eta]$[IIa___][0,Sha_List]^2:>(\[Eta]$[IIa][Xx,Sha]^2/.subfromproduct/.Xx->00),
\[Eta]$[IIa___][v_,Sha_List]\[Eta]$[IIbt___][v_,Shbt_List]|\[Eta]$[IIa___][v_,Sha_List]^2:>(
Block[{Shb,IIb},If[{IIbt}==={},IIb=IIa;Shb=Sha;,IIb=IIbt;Shb=Shbt;];
Block[{LL,MM,NiT=Plus@@Length/@{Sha,Shb},Colis,Rsh={n_Integer:>If[n<=Length@Sha,Sha[[n]],Shb[[n-Length@Sha]]],
fF[EeE_]:>(EeE/.{aa_. (ff_. Xx +pp_.)^mm_:>(pp/ff/(I/2)),_:>ImportantMessage[subfromproduct::Pb]})},
Rid={n_Integer:>If[n<=Length@Sha,{IIa}[[n]],{IIb}[[n-Length@Sha]]],
fF[EeE_]:>(EeE/.{aa_. (ff_. Xx +pp_.)^mm_:>(-mm),_:>ImportantMessage[subfromproduct::Pb]})},
RFac={n_Integer->1,fF[EeE_]:>(EeE/.{aa_. (ff_. Xx +pp_.)^mm_:>(aa ff^mm ),_:>ImportantMessage[subfromproduct::Pb]})},
XX},
(*Terms without collisions :*)
LL=Block[{R=Range@NiT},R[[#]]=Range@Length@Sha;R[[Complement[Range@NiT,#]]]=(Length@Sha+Range@Length@Shb);R]&/@Subsets[Range@NiT,{Length@Sha}];
Total[(\[Eta]$@@(#/.Rid))[Xx,#/.Rsh]&/@LL
]+(MM=Join@@Table[cl/.n_Integer:>l[[n]],{cl,Collisions[Length@First@LL]},{l,LL}];
MM=Union@MM;MM=Select[MM,FreeQ[(fF@@#),{a_,b_}/;(a>Length@Sha)||(b<=Length@Sha)]&];
(*MM is now the list of all possible collisions*)
Sum[
XX=List@@((fF@@cl)/.{a_,b_}:>(DenFactorize[#,Xx]&/@IntoList@Apart[(1/(Xx+I/2(a/.Rsh)))^(a/.Rid) (1/(Xx+I/2(b/.Rsh)))^(b/.Rid)]));
XX={XX}//.{A___,{B___,EE_List,cC___},dD___}:>{A,Table[{B,fF[xxx],cC},{xxx,EE}]//(Sequence@@#)&,dD};
Sum[
(Times@@(xxx/.RFac))(\[Eta]$@@(xxx/.Rid))[Xx,xxx/.Rsh]
,{xxx,XX}]
,{cl,MM}])]]/.subshiftfromlist/.Xx->v),
A:((\[Eta]$b[II___][___]\[Eta]$b[JJ___][___] )| \[Eta]$b[___][___]^2):>(Conjugate[Conjugate[A]/.fromConj/.subfromproduct]/.fromConj)
};]

Block[{XX},XX=subfromproduct;ClearAll[subfromproduct,subfromproduct0];
XX=XX/.subfromproduct->subfromproduct0;
subfromproduct0=XX];
subfromproduct={a_.(B:Hd_[___][___])(C:Hd_[___][___])/;MemberQ[{\[Eta]$,\[Eta]$b},Hd]:>a (B C/.subfromproduct0),
a_. (B:Hd_[___][___])^p_/;(MemberQ[{\[Eta]$,\[Eta]$b},Hd] && p>=2):>(a (B^2/.subfromproduct0)B^(p-2)/.subfromproduct)}


Module[{mgen2,mgen3,mgen2list,fun,gen\[Eta],v0},mgen2[{a_},-1]:=\[Eta]0$[a][2];
mgen2[{a__},-1]:=Block[{k,tmp,len=Length[{a}]-1,spec},Expand[Collect[Sum[tmp = Drop[fun[a], {k}]; spec = {a}[[k]]; 
   tmp = FoldList[Expand[#1/#2 /. fun[b__] :> 
         -Sum[{b}[[r]] ReplacePart[fun[b],r->{b}[[r]]+1], {r, len}]] & , tmp, 
     Range[spec - 1]]; 
   Total[MapIndexed[#1/. fun[b__]:>(-1)^Total[{b}[[1;;k-1]]] \[Eta]$[Sequence@@Reverse[{b}[[1;;k-1]]],spec-#2[[1]]+1][2] gen\[Eta][{b}[[k;;-1]],-1]&,tmp]]/. gen\[Eta][{},-1] \[Eta]$[bb__][2]:>\[Eta]0$[bb][2], {k, len + 1}]/. gen\[Eta]->mgen2/. sub\[Eta]\[Zeta]/. xxx:\[Eta]0$[b__][2]:>(xxx/. sub\[Eta]0\[Eta]//. {}/. sub\[Eta]\[Eta]0),\[Eta]0$[__][2]],\[Eta]0$[__][2]]];
mgen2[{a__},b_]/;b===Length[{a}]:=mgen2[{a},-1];
mgen2[{a__},b_]/;b>0&&b<Length[{a}]:=Block[{spec,n},Expand[(\[Eta]$@@{a}[[b+1;;-1]])[0] \[Eta]$[Sequence@@{a}[[1;;b-1]],spec][0]-((\[Eta]$@@{a}[[b+1;;-1]])[0] \[Eta]$[Sequence@@{a}[[1;;b-1]],spec][0]/. subtoMHZbasis)+\[Eta]$[Sequence@@ReplacePart[{a},b->spec]][0]]/. {\[Eta]$[x1___,spec+y1_,x2___][0]:>(Apart[1/(n^y1*(v0 + n)^{a}[[b]]),n]/. {(n+v0)^pow_:>mgen2[{x1,-pow,x2},Length[{x1}]+1],n^(pow_/;pow<0):>\[Eta]$[x1,-pow,x2][2]/. sub\[Eta]\[Zeta]}),\[Eta]$[x1___,spec,x2___][0]:>mgen2[{x1,{a}[[b]],x2},Length[{x1}]+1],\[Eta]$[x1__][0]:>(\[Eta]$[x1][2]/. sub\[Eta]\[Zeta])}];
mgen2list=DownValues[mgen2]/. mgen2->mgen3;
mgen[{a__},b_]:=mgen[{a},b]=Block[{rlt},rlt=Collect[FixedPoint[Collect[#1/. mgen2list,mgen3[__]]&,mgen3[{a},b]]/. sub\[Eta]0\[Eta]/. v0->u,\[Eta]list];(*If[{a}[[-1]]=!=1,rlt,*)Collect[rlt-(rlt/. TaylorOptions[Order->0,Series->False])+(\[Eta]$[a][2]/. sub\[Eta]\[Zeta]),\[Eta]list]](*]*);];


Module[{strangeshiftpfrom,strangeshiftmfrom,(*lastshiftSimp,othshiftSimp,*)ZZZ},
strangeshiftpfrom[n_/;n>=2][\[Eta]$[a__][c_List]]:=
Which[n>Length@{a},\[Eta]$[a][c],
{a}[[n]]==0,strangeshiftpfrom[n+1][\[Eta]$[a][c+(2 Boole[#==n]&)/@(Range@Length@{a})]],
True,
(\[Eta]$[a][c+(2 Boole[#>=n]&)/@(Range@Length@{a})] +Block[
{TT=DenFactorize[#,u]&/@IntoList@Apart[(1/(u+I/2 c[[n-1]]))^{a}[[n-1]] (1/(u+I/2 (c[[n]]+2)))^{a}[[n]],u]},
(*If[Head@TT===Plus,TT=List@@TT,TT={TT}];*)
Total@Table[tt/.{
x_. (f_. u+p_.)^m_/;m<=0&&FreeQ[x,u]&&FreeQ[p,u]:>x f^m  (\[Eta]$@@Join[{a}[[;;n-2]],{-m},{a}[[n+1;;]]])@Join[c[[;;n-2]],{(p/f)/(I/2)},2+c[[n+1;;]]],
_:>ImportantMessage[\[Eta]Simp::Pb]},{tt,TT}]]/.\[Eta]$[aa__][bb_]:>\[Eta]$[aa][FullSimplify@Re@bb+I FullSimplify@Im@bb])];
strangeshiftpfrom[1][\[Eta]$[a__][c_List]]:=\[Eta]$[a][c]/.shiftp\[Eta]g/.u->0;
strangeshiftmfrom[1][\[Eta]$[a__][c_List]]:=\[Eta]$[a][c]/.shiftm\[Eta]g/.u->0;
strangeshiftmfrom[n_/;n>=2][\[Eta]$[a__][c_List]]:=Block[{In,Out},In=\[Eta]$[a][c];
In=(Head@In)@@(List@@In//FullSimplify@Re@#+ I FullSimplify@Im@#&);
Out=\[Eta]$[a][c-(2 Boole[#>=n]&)/@(Range@Length@{a})];Out=(Head@Out)@@(List@@Out//FullSimplify@Re@#+ I FullSimplify@Im@#&);
Expand[In/.First@Solve[Out==strangeshiftpfrom[n][Out],In]]];



standardizestrangeshifts0={\[Eta]$[a__][c_List]:>(\[Eta]$[a][c]//.{
\[Eta]$[aa__][cc_List]/;Max[Abs[Re@cc-3/2]]>1:>Block[{nn},
nn=First@First@Position[Re@cc-3/2,_?(Abs[#]>1&)];
Which[Re[cc[[nn]]]<1,strangeshiftpfrom[nn][\[Eta]$[aa][cc]],
Min[Re[cc[[nn+1;;]]]]>2,strangeshiftmfrom[nn][\[Eta]$[aa][cc]],
True,(*strangeshiftmfrom[nn][*)strangeshiftpfrom[nn+1][\[Eta]$[aa][cc]]](*]*)],
\[Eta]$[aa__][cc_List]:>\[Eta]$[aa][FullSimplify@Re@cc+I FullSimplify@Im@cc]
}),
\[Eta]$[a__][0,c__List]:>(\[Eta]$[a][c/.u-> \[Pi]^E]/.standardizestrangeshifts//.\[Pi]^(n_. E +p_.):>u^n \[Pi]^p/.\[Eta]$[xx__][yy_]:>\[Eta]$[xx][0,yy])
,
\[Eta]$[a__][b_,c__List]:>(\[Eta]$[a][c+ \[Pi]^E/(I/2)]/.standardizestrangeshifts//.\[Pi]^(n_. E +p_.):>b^n \[Pi]^p/.\[Eta]$[xx__][yy_]:>\[Eta]$[xx][b,Expand[yy-b/(I/2)]])
};

standardizestrangeshifts={e_:>(e/.subshifttolist/.standardizestrangeshifts0/.subshiftfromlist//.{
\[Eta]0$[II___][c_]:>(\[Eta]$[II][v00,c]/.standardizestrangeshifts/.\[Eta]$[JJ___][v00,d_]:>\[Eta]0$[JJ][d]),
A:\[Eta]$[II__][0,{B:(2...),sh_,C:(2...)}]/;Length@{B,C}>0:>(mgen[{II},1+Length@{B}]/.u->I/2 (sh-2)/.\[Eta]$[JJ__][ssh_]:>\[Eta]$[JJ][ssh+sh-2])
})};];


\[Eta]0Simp={
A:\[Eta]$[II__][v___,e_(*List*)]/;Min[II]>0 && Block[{T},T=Sum[Boole[i==Max[II]],{i,{II}}];
((*T==1 && *) Last@{II}!=Max[II]) || (T==Length@{II} && T>1 && (Head[e]=!=List || Length@Union@e===1))]:>If[
Head@e=!=List,(A/.subshifttolist/.\[Eta]0Simp/.subshiftfromlist),
Block[{prd,eq,ps},
ps=First@If[Last@{II}==Max[II],First,Last]@Position[{II},Max@II];
prd=((\[Eta]$@@({II}[[;;ps]]))@@{v,e[[;;ps]]})((\[Eta]$@@({II}[[ps+1;;]]))@@{v,e[[ps+1;;]]})/.subshifttolist;
eq=(prd==(prd/.subfromproduct)/.subshiftfromlist);
Last@Last@First@Solve[eq,\[Eta]$[II][v,e]/.subshiftfromlist]
]],
A:\[Eta]$[b_,b_][v___,c_(*List*)]/;b>0 && ! (Head@c===List && Length@Union[c]>1):>If[
Head@c=!=List,(A/.subshifttolist/.\[Eta]0Simp/.subshiftfromlist),Block[{prd,eq},
prd=(\[Eta]$[b][v,c[[{1}]]])^2 /.subshifttolist;
eq=(prd==(prd/.subfromproduct)/.subshiftfromlist);
Last@Last@First@Solve[eq,\[Eta]$[b][v,c[[1]]]]]],


\[Eta]0$[b_,c_][d_]/;b>=c:>Block[{prd,eq},
prd=\[Eta]$[b][u,d]\[Eta]$[c][u,d]/.subshifttolist;
eq=(prd==(prd/.subfromproduct)/.subshiftfromlist);
prd=Last@Last@First@Solve[eq,\[Eta]$[b,c][u,d]];prd/.u->v00/.subto\[Eta]bar\[Eta]0],
\[Eta]0$[a_,b_,c_][d_]/;(b>c && b>=a)||(a==b && b==c)||(a>b && a>=c):>Block[{prd,eq},
prd=Which[
(b>c && b>=a)||(a==b && b==c),\[Eta]$[a,b][u,d]\[Eta]$[c][u,d],
a>b && a>=c,\[Eta]$[b,c][u,d]\[Eta]$[a][u,d]
]/.subshifttolist;
eq=(prd==(prd/.subfromproduct)/.subshiftfromlist);
prd=Last@Last@First@Solve[eq,\[Eta]$[a,b,c][u,d]];prd/.u->v00/.subto\[Eta]bar\[Eta]0],



\[Eta]0$b[II___][d_]:>(Conjugate[\[Eta]0$[II][-d]/.\[Eta]0Simp]/.fromConj),


A:\[Eta]$b[___][___]:>(Conjugate[A]/.fromConj/.\[Eta]0Simp//Conjugate[#]/.fromConj&),

(Hd:\[Eta]0$|\[Eta]0$b)[II___][n___]:>((Hd/.sub\[Eta]0\[Eta])[II][n+v00/(I/2)]/.\[Eta]0Simp/.subto\[Eta]bar\[Eta]0)


};


SqrtTogether[Expr_]:=((Expr/.{Sqrt[n_]:>X$gh87[n],1/Sqrt[n_]:>1/X$gh87[n]})//Together[#]/.X$gh87[n_]^p_:>X$gh87[n]^Mod[p,2] n^Quotient[p,2]/.X$gh87->Sqrt&)


MyTogether::Bug1="Mathematica came arround expression `3`, which is numerically `1`.
Acting on it by Together gave something numerically equal to `2`, which was thrown out";
MyTogether::Bug2="Mathematica came arround expression `3`, which is numerically `1`.
Acting on it by Together gave something numerically equal to `2`, which was thrown out and replaced by an artisanal simplification";
MyTogether::Bug3="Mathematica came arround expression `3`, which is numerically `1`.
Acting on it by Together gave something numerically equal to `2`, which was thrown out but not successfully replaced by an artisanal simplification";
MyTogether::Zero="Mathematica came arround expression `2`, which is numerically `1`.
Nevertheless, assumes this expression is zero...";
SqrtTogether::bug="Mathematica apparently completely bugged with `1`.";


MyTogether0[A_Integer]:=A;


MyTogether0[Expr_?NumericQ]:=Block[{A=N[Expr],B=Together[Expr]},
Which[
Abs[A]<10^-6 && (B===0),0,
(B===0) && (Expand[Expr]===0 || (SqrtTogether[Expr]===0)),If[Abs[A]<10^-3,Null,Message[MyTogether::Zero,A,Expr]];0,
FreeQ[Expr,_^b_/;Abs[b]==1/2],
  Which[Abs[N[B-A]]>10^-5 Abs[A],ImportantMessage[MyTogether::Bug1,A,B,Expr];Expr,
			True,B],
True,Block[{C=SqrtTogether[Expr],L},
L=(Abs[#]<=10^-5 (Abs[A]//(#+10^5 Boole[#<10^-2])&))&/@({B//N,C//N}-A);
Switch[L,
{True,True},B,
{True,False},ImportantMessage[SqrtTogether::bug,Expr];B,
{False,True},Message[MyTogether::Bug2,A,N@B,Expr];C,
{False,False},ImportantMessage[MyTogether::Bug3,A,N@B,Expr];Expr,
_,ImportantMessage[MyTogether::Bug]]]]];


MyTogether0[Expr_]:=Together[Expr];


MyTogether[E_]:=MyTogether0[sqrt3Simp@E];


UpIntSimp[e_DoubtUpIntegrate]=e;
UpIntSimp[e_/;!FreeQ[e,DoubtUpIntegrate]]:=(UpIntSimp/@ExpaCol[e,_DoubtUpIntegrate]);


UpIntSimp[e_/;FreeQ[e,DoubtUpIntegrate]]:=(* Should expectly
 - collect guys
 - make (real parts of) shifts standards
 - subto\[Eta]bar\[Eta]0
 - Say what's going on for remaining non-standard blurbs (if any)
*)ExpaCol[e/.\[Epsilon]t0/.(A:(\[Eta]$|\[Eta]$b)[___])[c_]:>A[0,c]//.{\[Eta]$[II__][v___,c_]/;Positive\[Epsilon]Q[I(1/2-Min[Re@c])/.u->0]:>(\[Eta]$[II][v,c]/.subshifttolist/.shiftp\[Eta]g),
\[Eta]$b[II__][v___,c_]/;Positive\[Epsilon]Q[I(Max[Re@c]+1/2)/.u->0]:>(\[Eta]$b[II][v,c]/.subshifttolist/.shiftp\[Eta]g)}//.sub\[Eta]0/.subshiftfromlist/.\[Eta]$[II___][0,s_ + 2*I*u]:>(-1)^Plus[II] \[Eta]$b[II][u,-s]/.\[Eta]$[II___][0,s_ -2*I*u]:>\[Eta]$[II][u,s]/.\[Eta]$b[II___][0,s_ + 2*I*u]:>(-1)^Plus[II] \[Eta]$[II][u,-s]/.\[Eta]$b[II___][0,s_ -2*I*u]:>\[Eta]$b[II][u,s]/.{
(Hd:\[Eta]$|\[Eta]$b)[II___][vvv___,ccc_]:>Hd[II][vvv,sqrt3Simp@ccc]}//.{
(A:(\[Eta]$|\[Eta]$b)[__])[y_.+x_?NumericQ/;x=!=0,s_]:>A[y,s+x/(I/2)/.sqrt3Simp],
\[Eta]$[II__][v___,s_]/;(s\[Element]Reals) && s>2:>(\[Eta]$[II][s]/.shiftm\[Eta][s]/.u->Plus[v]/.\[Eta]$[a___][b_]:>\[Eta]$[a][v,b]),
\[Eta]$b[II__][v___,s_]/;(s\[Element]Reals) && s<-2:>(\[Eta]$[II][-s]/.shiftm\[Eta][-s]/.u->Plus[v]/.\[Eta]$[a___][b_]:>\[Eta]$b[a][v,-b]/.a_?NumericQ:>Conjugate[a])}/.{A:(\[Eta]$|\[Eta]$b)[___][0,aa_/;Abs[aa]==2]:>(A[[2;;]]/.sub\[Eta]\[Zeta])}
,((\[Eta]$|\[Eta]0$|\[Eta]$b|\[Eta]0$b|\[Zeta]$)[___][___] | g),(MyTogether[#]//(ExpandAll@Numerator@#/ExpandAll@Denominator@# /. {a_?NumericQ:>FullSimplify@Re@a+I FullSimplify@Im@a}&)(*/.{a_:>Expand@Numerator@a/Expand@Denominator@a}*))&]//.{
\[Eta]0$[II__][s_]/;(s\[Element]Reals) && s>2:>(\[Eta]$[II][s]/.shiftm\[Eta][s]/.u->v00/.\[Eta]$->\[Eta]0$),
\[Eta]0$b[II__][s_]/;(s\[Element]Reals) && s<-2:>(\[Eta]$[II][-s]/.shiftm\[Eta][-s]/.u->v00/.\[Eta]$[a___][b_]:>\[Eta]0$b[a][-b]/.a_?NumericQ:>Conjugate[a])
}//.standardizestrangeshifts/.\[Eta]0Simp//ExpaCol[#,((\[Eta]$|\[Eta]0$|\[Eta]$b|\[Eta]0$b|\[Zeta]$)[___][___] | g),(MyTogether[#]//(ExpandAll@Numerator@#/ExpandAll@Denominator@# /. {a_?NumericQ:>FullSimplify@Re@a+I FullSimplify@Im@a}&)(*/.{a_:>Expand@Numerator@a/Expand@Denominator@a}*))&]&


MySimp[XX_]:=ExpaCol[XX,(\[Eta]$|\[Eta]$b|\[Eta]0$(*|\[Eta]\[Eta]$|\[Eta]0$b*))[___][___],e\[Function](MyTogether@e//ExpandAll@Numerator@#/ExpandAll@Denominator@#&)];


(* ::Subsection::Closed:: *)
(*further simplifications*)


(*Module[{\[Eta]0Simpb},*)
Module[{a,b,Tmp,A,\[Eta]0SimpList,PreList},
\[Eta]0SimpList={{\[Zeta]$[aNn328_,0,bNn328_][0]/;aNn328>=2, \[Eta]$[bNn328][u - I*\[Epsilon], 4] \[Eta]$b[aNn328,1][u-I \[Epsilon],-2]}};
PreList={(Hd: \[Eta]$|\[Eta]$b)[III_][-u,c_]:>(-1)^Plus[III] (Hd/.{\[Eta]$->\[Eta]$b,\[Eta]$b->\[Eta]$})[III][u,-c],
(\[Eta]$|\[Eta]$b)[][List[]]->1,
\[Zeta]$[0][0]->0,
\[Eta]$[n_][0,1]:>Which[n==1,-I Log[4]-I EulerGamma,n>=2,(2^n-1)\[Eta]$[n][0,2],True,\[Eta]$[n][0,1]],
A:\[Zeta]$[0,___][___]:>(A/.sub\[Zeta]\[Eta]//.sub\[Eta]0/.sub\[Eta]\[Zeta]/.u->0),
A:\[Zeta]$[Pre___,n_,0,__][___]:>(*Block[{R},*)((A/.sub\[Zeta]\[Eta]/.((\[Eta]$@@(Head@A))[2]->(((\[Eta]$@@(A[[0,2+Length[{Pre}];;]]))[2]//.sub\[Eta]0/.\[Eta]$[0][___]->0)/u^n//ExpaCol[#,\[Eta]$[___][___],Total[DenFactorize[#,u]&/@IntoList[Apart[#1,u]]]&]&//Expand//IntoList//(#/.(R={
x_. (u)^m_. \[Eta]$[II___][2]/;m<=0 && NumericQ@x:>x \[Eta]$[Pre,-m,II][2],
x_. \[Eta]$[II___][2]/;NumericQ@x:>x \[Eta]$[Pre,0,II][2],
_:>ImportantMessage[\[Eta]0Simpb::Pb]
}))&/@#&//Total//#/.sub\[Eta]\[Zeta] &))))
};

Options[\[Eta]0Simpb]={UpTo->\[Infinity](*,Simp->True*),ZetaTo->\[Infinity]};
\[Eta]0Simpb[OptionsPattern[]]:=PreList~Join~Table[(RuleDelayed@@{A: \[Eta]0SimpList[[xxx,1]],Tmp[A,xxx(*,Simp->OptionValue[Simp]*)]})/.Tmp->\[Eta]0Sp,{xxx,Min[OptionValue[UpTo],Length@\[Eta]0SimpList]}];
];
Options[\[Eta]0Sp]={(*Simp->True*)};
\[Eta]0Sp[A_,xxx_,OptionsPattern[]]:=Module[{Eqn,Op,AAA,BBB,XXX,R},
Op=Options[\[Eta]0Simpb];SetOptions[\[Eta]0Simpb,UpTo->(xxx-1)(*,Simp->False*)];
XXX=A/.(RuleDelayed@@{\[Eta]0SimpList[[xxx,1]],\[Eta]0SimpList[[xxx,2]]}/.Hold->Identity);(*1/0;*)
AAA=UpIntegrate[XXX,u]  /.\[Epsilon]t0 /.EndSimplify;
BBB=(UpIntegrate[Conjugate[XXX]/.fromConj,u]  /.\[Epsilon]t0 /. EndSimplify//Conjugate)/.fromConj/.EndSimplify;
Eqn=AAA-BBB/.EndSimplify;
Eqn=Factor@Together@Eqn;
(*SetOptions[\[Eta]0Simpb,UpTo->Length@\[Eta]0SimpList];
*)
If[Flatten[R=Solve[Eqn==0,A]]==={},R=A,R=Last@Last@Last@R(*/.EndSimplify*)];
\[Eta]0Sp[A,xxx(*,Simp->False*)]=R//Together;
SetOptions[\[Eta]0Simpb,UpTo->\[Infinity](*,Simp->True*)];
\[Eta]0Sp[A,xxx(*,Simp->True*)]=If[R===A,R,Together[R]/.EndSimplify//Factor];
Options[\[Eta]0Simpb]=Op;
\[Eta]0Sp[A,xxx(*,Simp->OptionValue[Simp]*)]
];


(* ::Text:: *)
(*Have a code which finishes the simplifications, adding a few relations*)


ZetaS[A: \[Zeta]$[II___][0]/;Min[II]>0]:=ZetaS[A]=(A/.subZetaReduce/.sub\[Zeta]\[Eta]/.subtopowerbasis/.sub\[Eta]\[Zeta]);
ZetaS[eEe_]:=eEe/.{A: \[Zeta]$[II___][0]/;Min[II]>0:>ZetaS[A]};

ZetaS/:eEe_/.ZetaS:=ZetaS[eEe];
ZetaS/:eEe_//.ZetaS:=FixedPoint[ZetaS,eEe];


EndSimplify0={ee_:>Block[{XX},XX=If[FreeQ[ee,(\[Eta]$|\[Eta]$b)[___][_,_] | (\[Eta]$|\[Eta]$b)[___][_List] | ((\[Eta]$|\[Eta]$b)[___][a_]/;!FreeQ[a,u]) ],
ee/.(Hd:\[Eta]$|\[Eta]$b)[III___][n_]:>Hd[III][u,n],ee]//.{e_:>(UpIntSimp[e]/.\[Epsilon]t0(*/.\[Eta]\[Eta]$->\[Eta]$/.\[Eta]\[Eta]$b->\[Eta]$b*)/. A: (\[Eta]$|\[Eta]$b)[___][___]:>ExpandAll@A/.(Hd:\[Eta]$|\[Eta]$b)[III___][w___]:>((Hd[III])@@({w}//FullSimplify))/.{\[Eta]$b[II___][0,c_List]:>(-1)^Plus[II] \[Eta]$[II][0,-c]}/.subto\[Eta]bar\[Eta]0//.\[Eta]0Simp/.\[Eta]0Simpb[]//.RidOfBar//.ZetaS)//If[
OptionValue[PeriodicSimp,PeriodPower]===False,Subs\[Eta]1bp,Identity]};
If[(\[Section]CheckConsistency===True) && !FreeQ[XX,(\[Eta]$|\[Eta]$b)[II___][x___,y_]/;(({x}=!={u} || (! NumericQ@y)) && (!MatchQ[{II},{___,1,1}]))], Message[EndSimplify::Suspicious]];
XX/.((Hd:\[Eta]$|\[Eta]$b)[II___][u,y_]:>Hd[II][y])]};


EndSimplify[e_DoubtUpIntegrate]=e;
EndSimplify[e_/;!FreeQ[e,DoubtUpIntegrate]]:=(EndSimplify/@ExpaCol[e,_DoubtUpIntegrate]);
EndSimplify[e_/;FreeQ[e,DoubtUpIntegrate]]:=(e/.EndSimplify0);


EndSimplify/:eEe_/.EndSimplify:=EndSimplify[eEe];
EndSimplify/:eEe_//.EndSimplify:=FixedPoint[EndSimplify,eEe];


(* ::Subsection::Closed:: *)
(*Yet more simplifications, from periodicity and factorization*)


Options[PeriodicSimp]={NoCheck->True,PeriodPower->\[Section]PeriodPower};


Module[{XX,Cc,PeriodicTable},
PeriodicTable[n_]:=PeriodicTable[n]=CoefficientList[(\!\(
\*SubsuperscriptBox[\(\[Sum]\), \(a = 0\), \(n\)]\(Cc[a] 
\*SuperscriptBox[\((\(\[Eta]$[1]\)[1] + \(\[Eta]$b[1]\)[\(-1\)])\), \(a\)]\)\))/.TaylorOptions[Point->I/2,Order->0]//Normal[#]/.u-I/2->1/XX&,XX];
PeriodicSimp[Eee_,OptionsPattern[]]:=If[(OptionValue[NoCheck]===True) || PeriodicQ[Eee],Block[{A,B,n},
A=CoefficientList[Eee/.TaylorOptions[Point->I/2,Order->0]//Normal[#]/.u-I/2->1/XX&,XX];
n=Length@A-1;B=PeriodicTable[n];
\!\(
\*SubsuperscriptBox[\(\[Sum]\), \(a = 0\), \(n\)]\(Cc[a] 
\*SuperscriptBox[\((\(\[Eta]$[1]\)[1] + \(\[Eta]$b[1]\)[\(-1\)])\), \(a\)]\)\)/.First@Solve[A==B,Cc/@Range[0,n]]],
Message[Periodic::Pb];Eee]];


Module[{ThisFun},
ThisFun[EEE_]:=Collect[EEE,\[Eta]$b[1][-1]]/.(\[Eta]$b[1][-1]^n_:>(
(\[Eta]$b[1][-1]^n-PeriodicSimp[\[Eta]$[n][1] + \[Eta]$b[n][-1]] + (\[Eta]$[n][1] + \[Eta]$b[n][-1])//Collect[#,\[Eta]$b[1][-1]]&)));


Subs\[Eta]1bp[EEE_]:=FixedPoint[ThisFun,EEE];];
Subs\[Eta]1bp/:eEe_/.Subs\[Eta]1bp:=Subs\[Eta]1bp[eEe];
Subs\[Eta]1bp/:eEe_//.Subs\[Eta]1bp:=FixedPoint[Subs\[Eta]1bp,eEe];


PeriodicQ[eEe_]:=eEe/.(Hd:(\[Eta]$|\[Eta]$b))[II___][d_]:>Hd[II][u,d]/.subshifttolist//(#-(#/.u->u-I))/.EndSimplify&//#==0&


Module[{RR},
RR[n_]:=eEe_:>Which[
MatchQ[eEe,\[Eta]$b[II__][-1]],eEe/.{\[Eta]$b[II__][-1]:>(
(\[Eta]$[n,II][(*u,*)Prepend[ConstantArray[-1,Length@{II}],1]]/.standardizestrangeshifts0(*//UpIntSimp*)//Conjugate)/.fromConj/.subshiftfromlist)},
MatchQ[eEe,\[Eta]$b[II__][-1]^(p_/;p>=2)],eEe/.\[Eta]$b[II__][-1]^(p_/;p>=2):>((
((\[Eta]$[II][1]^2/.subfromproduct//Conjugate)/.fromConj/.subshiftfromlist)\[Eta]$b[II][-1]^(p-2))/.RR[n]),
MatchQ[eEe,A_?NumericQ  B_],eEe/.A_?NumericQ  B_:>A (B/.RR[n]),
MatchQ[eEe,\[Eta]$[II__][1]\[Eta]$b[JJ__][-1]],eEe/.\[Eta]$[II__][1]\[Eta]$b[JJ__][-1]:>Block[{AAA=PeriodGen[\[Eta]$[II][1]]},
AAA(\[Eta]$b[JJ][-1]/.RR[n])+((MySimp[\[Eta]$[II][1]-AAA] \[Eta]$b[JJ][-1])/.RR[n])],
MatchQ[eEe,Plus[A_,B__]],eEe/.Plus[A_,B__]:>(Total[(#/.RR[n]&)/@{A,B}]),
(eEe/.subfromproduct)=!=eEe,eEe/.subfromproduct/.RR[n],
MatchQ[eEe,A_Times],eEe/.A_Times:>(Expand[A]/.RR[n]),
True,(ImportantMessage[PeriodGen::Pb,eEe];Pb[eEe])
];

PeriodGen[\[Eta]$[n_][1]]=\[Eta]$[n][1]+\[Eta]$b[n][-1];
PeriodGen[\[Eta]$[n_,p__][1]]:=(\[Eta]$[n,p][1]+PeriodGen[\[Eta]$[p][1]](\[Eta]$b[n][-1])+(MySimp[\[Eta]$[p][1]-PeriodGen[\[Eta]$[p][1]](*/.subshifttolist*)]/.RR[n]/.subshiftfromlist)/.(Hd:\[Eta]$|\[Eta]$b)[II___][u,v_]:>Hd[II][v])];


Module[{RidOfBara,RidOfBarb},


RidOfBara[\[Eta]$b[1][v___,-1]]:=RidOfBara[\[Eta]$b[1][v,-1]]=\[Eta]$b[1][v,-1];

RidOfBarb[\[Eta]$b[1][v___,-1]]:=RidOfBarb[\[Eta]$b[1][v,-1]]=\[Eta]$b[1][v,-1];

(*RidOfBara expresses everybody in the basis of (\[Eta]_ 1+/bar \[Eta]_ 1)^p   *)

RidOfBara[\[Eta]$b[III___][v___,-1]]/;{III}!={1}:=RidOfBara[\[Eta]$b[III][v,-1]]=FixedPoint[MySimp[#]/.RidOfBara &,(Last@First@First@Solve[PeriodGen[\[Eta]$[III][1]]==(PeriodGen[\[Eta]$[III][1]]//PeriodicSimp),\[Eta]$b[III][-1]]/.{
(Hd:\[Eta]$|\[Eta]$b)[JJ___][s_]:>Hd[JJ][v,s]})];

RidOfBara[eEe_]:=(eEe/.subshiftfromlist/.{
\[Eta]$b[III___][v___,-1]:>RidOfBara[\[Eta]$b[III][v,-1]],
\[Eta]$b[III___][v___,n_/;(Head@n)=!=List]:>Block[{XX},
XX=RidOfBara[\[Eta]$b[III][v,-1]];XX/.((Hd:\[Eta]$|\[Eta]$b)[II___][w___,z_]:>Hd[II][w,z+n+1])],
\[Eta]0$b[III__][n_]:>(RidOfBara[\[Eta]$b[III][n]]/.sub\[Eta]\[Eta]0)
});

RidOfBara/:eEe_/.RidOfBara:=RidOfBara[eEe];
RidOfBara/:eEe_//.RidOfBara:=FixedPoint[RidOfBara,eEe];

(*RidOfBarb expresses everybody in the basis of (\[Eta]_p+/bar \[Eta]_p)  *)


RidOfBarb[\[Eta]$b[III___][v___,-1]]/;{III}!={1}:=RidOfBarb[\[Eta]$b[III][v,-1]]=(RidOfBara[\[Eta]$b[III][v,-1]]//Subs\[Eta]1bp);

RidOfBarb[eEe_]:=((eEe/.subshiftfromlist//Subs\[Eta]1bp)/.{
\[Eta]$b[III___][v___,-1]:>RidOfBarb[\[Eta]$b[III][v,-1]],
\[Eta]$b[III___][v___,n_/;(Head@n)=!=List]:>Block[{XX},
XX=RidOfBarb[\[Eta]$b[III][v,-1]];XX/.((Hd:\[Eta]$|\[Eta]$b)[II___][w___,z_]:>Hd[II][w,z+n+1])],
\[Eta]0$b[III__][n_]:>(RidOfBarb[\[Eta]$b[III][n]]/.sub\[Eta]\[Eta]0)
});

RidOfBarb/:eEe_/.RidOfBarb:=RidOfBarb[eEe];
RidOfBarb/:eEe_//.RidOfBarb:=FixedPoint[RidOfBarb,eEe];


RidOfBar[eEe_]:=If[OptionValue[PeriodicSimp,PeriodPower]===False,RidOfBarb[eEe],RidOfBara[eEe]];
];

RidOfBar/:eEe_/.RidOfBar:=RidOfBar[eEe];
RidOfBar/:eEe_//.RidOfBar:=FixedPoint[RidOfBar,eEe];



(* ::Subsection::Closed:: *)
(*numeric evaluation for checks*)


(* ::Text:: *)
(*function necessary for numeric checks :*)


subtoNum={e_:>(e/.subshiftfromlist//.{
Sequence@@If[ValueQ@\[Section]\[Epsilon],{\[Epsilon]->\[Section]\[Epsilon]},{}],
A:((\[Eta]0$|\[Eta]0$b)[___][___]):>BoldCompute@A,
(Hd:\[Eta]$|\[Eta]$b)[II___][n_]:>Hd[II][If[ValueQ@\[Section]Var,\[Section]Var,u],n],
\[Eta]$[II__][v_,n_?NumericQ]:>EMFun[{II},Prec->\[Section]Prec,PolyGamma->True,Shift->Re@n][v+I/2 I Im@n],
\[Eta]$b[II__][v_,n_?NumericQ]:>Block[{klz},EMFun[{II},Prec->\[Section]Prec,PolyGamma->True,Shift->-Re@n][klz+I/2 I Im@n]/.{
a_?NumericQ:>Conjugate@a}/.klz->v],
(\[Eta]$|\[Eta]$b)[][___]->1,
\[Eta]$[II__][u,ll_List]:>(\[Eta]$[II][ll+(UU/(I/2))]/.BBold[50]/.UU->u)
})};


BBold[]=sub\[Zeta]\[Eta]~Join~{\[Eta]$b[a__][c_]:>Conjugate[\[Eta]$[a][-Conjugate@c]],
\[Eta]$[a__][c_List]:>N@Block[{xx,Indl,Ifty=\[Infinity],Expr},
xx[n_]:=xx[n]=Module[{Tmp},Tmp];
Indl=Table[{xx[n],Boole[n>1],Ifty},{n,Length@{a}-1}];
Expr=Product[1/((Plus[I/2])*c[[n]] + I*Total[xx /@ Range[n]])^{a}[[n]],{n,Length@{a}-1}]\[Eta]$[{a}[[-1]]][c[[-1]]+2Boole[Length@{a}=!=1]+ 2 Total@(xx/@Range[Length@{a}-1])]/.subtoPolyGammas/.u->0;
If[Indl=={},Expr,NSum@@{Expr,Sequence@@Indl}]],
\[Eta]$[a__][c_]:>\[Eta]$[a][ConstantArray[c,Length@{a}]]};
BBold[nnnn_]:=sub\[Zeta]\[Eta]~Join~{\[Eta]$b[a__][c_List]:>Conjugate[\[Eta]$[a][-Conjugate@c]],
\[Eta]$[a__][c_]:>If[nnnn===\[Infinity],Identity,N]@Block[{xx,Indl,Ifty=(nnnn)&,Expr},
If[Head@nnnn===List,Ifty=(nnnn[[#]]&)];
xx[n_]:=xx[n]=Module[{Tmp},Tmp];
Indl=Table[{xx[n],Boole[n>1],Ifty[n]},{n,Length@{a}-1}];
Expr=Product[1/((Plus[I/2])*c[[n]] + I*Total[xx /@ Range[n]])^{a}[[n]],{n,Length@{a}-1}]\[Eta]$[{a}[[-1]]][c[[-1]]+2Boole[Length@{a}=!=1]+2  Total@(xx/@Range[Length@{a}-1])]/.subtoPolyGammas/.u->0;
If[Indl=={},Expr,Sum@@{Expr,Sequence@@Indl}]],
\[Eta]$[a__][c_]:>\[Eta]$[a][ConstantArray[c,Length@{a}]]};


(* ::Subsection::Closed:: *)
(*defs added for energy integrals :*)


Taylorv0[order_]:=e_:>(e//.{u->Subscript[v, 0]/.weak,\[Eta]$[a__][b_]:>\[Eta]$[a][Subscript[v, 0]/.weak,b],
\[Eta]$b[a__][b_]:>\[Eta]$b[a][Subscript[v, 0]/.weak,b]}/.TaylorOptions[Variable->g,Order->order]//.{
\[Eta]$[a__][v00,b_]:>\[Eta]0$[a][b],\[Eta]$b[a__][v00,b_]:>\[Eta]0$b[a][b]});


IntoList[Plus[a_,b__]]:={a,b};
IntoList[a_]:={a};


fF0[EEE_]:=(ExpaCol[EEE,((\[Eta]$|\[Eta]0$|\[Eta]$b|\[Eta]0$b|\[Zeta]$)[___][___] | g),(MyTogether[#]//(ExpandAll@Numerator@#/ExpandAll@Denominator@# /. {a_?NumericQ:>FullSimplify@Re@a+I FullSimplify@Im@a}&))&])


fF1[EEE_]:=((#//DenFactorize[#,u]&//Apart[#,u]&//(((*Factor@*)(ExpaCol[#,(\[Eta]$[___][___]|\[Eta]$b[___][___])]&)@((Numerator[#]//.{a_?NumericQ b_?NumericQ c_. :> (ExpandAll[a b] c)})/(Denominator[#]//.{a_?NumericQ b_?NumericQ c_. :> (ExpandAll[a b] c)}))&)/@(IntoList@#))&//Total(*Apart[#,u]&*))&/@(IntoList@MySimp@EEE))//Total;


SumOverBlocks[Expr_,Fun_,fFfF_:fF0,firstF_:fF1]:=Block[{Terms,R},
If[\[Section]Verbose,Print["splitting and Apart-ing for integrals "]];
Timing[Terms=Expr//firstF;]//If[\[Section]Verbose,Print[First@#,"s"]]&;
(*If[Head@Terms =!= Plus, Message[SumOverBlocks::Pb]];*)
Terms=IntoList@Terms;
 If[\[Section]Verbose,Print["length =",Length@Terms]];
Blocks = Block[{barir}, 
   barir = Range[0, Length@Terms, 
     Ceiling[Sqrt@Length@Terms]];
   AppendTo[barir, Length@Terms]; barir = Union@barir;
   Table[barir[[n - 1]] + 1 ;; barir[[n]], {n, 2, Length@barir}]];
If[Join @@ ((Range @@ #) & /@ Blocks) != 
   Range[1, Length@Terms], ImportantMessage[SumOverBlocks::Pb]];
Quiet[ClearAll@AnlBlcks;];
  (span \[Function] (Timing[
         AnlBlcks["Tmp"][
           span] = Fun/@ ((*IntoList[*)Terms[[span]](*]*))] //
         First //  If[\[Section]Verbose, Print[span, "->", #1 , "s"]] &))/@ (Blocks);
R=fFfF@Sum[fFfF@Total@AnlBlcks["Tmp"][span], {span, Blocks}];R];


Quiet[{\[Section]RuleBeforeInt,\[Section]RuleforSimp}={{},{}};];


Module[{ldf},
ldf[llead_]:=Switch[llead,lead,1,sublead,2,
subsublead|sublead2,3,
subsubsublead|sublead3,4,
subsubsubsublead|sublead4,5,
_,ImportantMessage[Compute::defineld,llead]];

CCompute[EE_(*,OptionsPattern[]*)]:=EE/.{
\[DoubleStruckCapitalC][YY_]/;!FreeQ[YY,Q0$[_]]:>(If[\[Section]Verbose===True,Print[""];Print["spliting \[DoubleStruckCapitalC][",YY,"]"];];
Total[\[DoubleStruckCapitalC]/@(IntoList@Expand[ExpaCol[YY,(H$|W$|W$h)[___][___],(#/.subQ0//Apart[#,u]&)&]])]//CCompute),
\[DoubleStruckCapitalC][YY_]/;(Head@YY===Plus && FreeQ[YY,W$h[___][0]]):>Block[{AAA},AAA=IntoList[Expand[YY]];
Total[\[DoubleStruckCapitalC]/@AAA]//CCompute],
\[DoubleStruckCapitalC][YY_]:>1/(-2 I \[Pi]) Block[{ToIntegrate=YY,Pv=False},
If[\[Section]Verbose,Print["Now computing \[DoubleStruckCapitalC][",YY,"]"<>If[$KernelID==0,""," on kernel "<>ToString[$KernelID]]]];
ToIntegrate=(*Together*)Identity[ToIntegrate/.subQ0]/.{H$[llead_][sh_]:>Block[
{$\[Delta]QCorrectiontoH=True,ld=ldf@llead,apartQswise=Identity},
Coefficient[
H$[sh]/.leadweak[ld],g^(6+2*ld)]],
W$[nN___,llead_][sh_]:>Block[{ld=ldf@llead,n},If[Length@{nN}==1,n=nN,n=0];
Coefficient[W$[n][sh]/.leadweak[ld],g^(6+2 ld)]],
a_. W$h[nN___,llead_][0]:>Block[{ld=ldf@llead,n(*,
AA=Denominator@a*)},(*If[(AA/.u->0) === 0,Message[CCompute::PrincipalValue]];
Pv=True;*)If[Length@{nN}==1,n=nN,n=0];a Coefficient[W$[n][0]/.leadweak[ld],g^(6+2 ld)]]}/.subQ0(*//Together*);
ToIntegrate=ExpaCol[ToIntegrate,(Q0$[_]|u|_?((PolynomialQ[#,u] && (!FreeQ[#,u]))&))^(p_/;p<0)];
ToIntegrate=ToIntegrate/.subQ0;
ToIntegrate={ToIntegrate}(*/.{(Hd:\[Eta]$ |\[Eta]$b)[a___][b_]:> Hd[a][u,b]}/.u->u-I \[Epsilon];
If[Pv,ToIntegrate={(ToIntegrate/.u->u+2I \[Epsilon]),(ToIntegrate)}/2,ToIntegrate={ToIntegrate}]*);
(*Print[ToIntegrate];*)
If[! FreeQ[ToIntegrate,H_[___][___]/;!MemberQ[{\[Eta]$,\[Eta]$b,\[Eta]0$,\[Eta]0$b,\[Zeta]$},H]],
ImportantMessage[CCompute::UnSimplified,ToIntegrate],
 (*If[\[Section]Verbose,Print["Now computing \[DoubleStruckCapitalC][",YY,"]"]];*)
(*CC[YY]=*)Sum[SumOverBlocks[ToI,((*Print["here's ",#];*)UpIntegrate[#/.{(Hd:\[Eta]$ |\[Eta]$b)[a___][b_]:> Hd[a][u,b]}/.u->u-I \[Epsilon]/.\[Section]RuleBeforeInt(*//(Print[#];#)&*),u]/.\[Section]RuleforSimp(*/.\[Epsilon]t0*)/.EndSimplify) &],{ToI,ToIntegrate}](*;*)
(*If[\[Section]Save===True,Save["CC.data",CC]];*)
(*CC[YY]*)]],
W$[n_,v0___,llead_][sh_]:>Block[{ld=ldf@llead},
If[\[Section]Verbose,Print["Now computing ",W$[n,v0,llead][sh],""<>If[$KernelID==0,""," on kernel "<>ToString[$KernelID]]]];
(W$[n][sh]/.leadweak[ld]/.Taylorv0[6+2 ld]//Coefficient[#,g^(6+2 ld)]//.UpIntSimp&)]}/.fromConj/.EndSimplify;


NCompute[EE_]:=EE/.{
\[DoubleStruckCapitalC][YY_]:>1/(-2I \[Pi]) Block[{ToIntegrate=YY,Pv=False,oldprec},
ToIntegrate=Together[ToIntegrate/.subQ0]/.{H$[llead_][sh_]:>Block[
{$\[Delta]QCorrectiontoH=True,ld=ldf@llead},
Coefficient[
H$[sh]/.leadweak[ld],g^(6+2*ld)]],
W$[n_,llead_][sh_]:>Block[{ld=ldf@llead},Coefficient[W$[n][sh]/.leadweak[ld],g^(6+2ld)]],
a_. W$h[___,llead_][0]:>Block[{AA=Denominator@a,ld=ldf@llead},If[(AA/.u->0) === 0,Message[CCompute::PrincipalValue],
Pv=True;a Coefficient[W$[0][0]/.leadweak[ld],g^(6+2ld)]]]}/.subQ0//Together;
ToIntegrate=ToIntegrate/.{(Hd:\[Eta]$ |\[Eta]$b)[a___][b_]:> Hd[a][u,b]}/.u->u-I \[Epsilon];
If[Pv,ToIntegrate=((ToIntegrate/.u->u+2I \[Epsilon])+(ToIntegrate))/2];
If[! FreeQ[ToIntegrate,H_[___][___]/;!MemberQ[{\[Eta]$,\[Eta]$b,\[Eta]0$,\[Eta]0$b,\[Zeta]$},H]],
ImportantMessage[CCompute::UnSimplified,ToIntegrate],
 If[\[Section]Verbose,Print["Numerically computing \[DoubleStruckCapitalC][",YY,"]"]];
UpIntegrate=UpIntegrate/.\[Section]RuleBeforeInt;
oldprec=If[ValueQ[\[Section]Prec],\[Section]Prec,12];
Block[{\[Section]\[Epsilon]=1/4,\[Section]Prec=oldprec},
ToIntegrate=ToIntegrate/.g->1/.subtoNum/.{\[Zeta]$[II_][0]:>BoldCompute[\[Zeta]$[II][0],0,\[Section]Prec]};
Block[{X,Tmp},X=Normal[Series[ToIntegrate u,{u,\[Infinity],0}]];
Which[
!NumericQ@Abs[X],Block[{R=10^2},
NIntegrate[ToIntegrate//(#+(#/.u->-u))/2&, {u, -R, R},Evaluate@IntPrec@\[Section]Prec]+NIntegrate[(ToIntegrate/.u->R E^(I \[Theta]))I R E^(I \[Theta]), {\[Theta], 0, \[Pi]},Evaluate@IntPrec@\[Section]Prec]],
Tmp=NIntegrate[ToIntegrate//(#+(#/.u->-u))/2&,{u,-\[Infinity],\[Infinity]},Evaluate@IntPrec@\[Section]Prec];
X==0,Tmp,
True,I \[Pi] X + Tmp]]]]],
W$[n_,v0___,llead_][sh_]:>Block[{ld=ldf@llead},(W$[n][sh]/.leadweak[ld]/.subtoNum/.u->(Subscript[v, 0]/.weak)//Series[#,{g,0,6+2ld}]&//N[Coefficient[#1,g^(6+2 ld)]/. {A:\[Zeta]$[___][___]:>BoldCompute[A,0,\[Section]Prec]}]&)]}/.{A:\[Zeta]$[___][___]:>BoldCompute[A,0,\[Section]Prec]};
]


Ewrap[lp_]:=(Ewrap[lp]=2 I \[DoubleStruckCapitalC][Coefficient[Series[(\!\(
\*SubsuperscriptBox[\(\[Sum]\), \(n = 0\), \(lp - 4\)]\(\(H$[Block[{R = "\<lead\>", t = n}, While[t > 0, \nR = "\<sub\>" <> R; t = t - 1]; R // ToExpression]]\)[0]\ g^\((8 + 2\ n)\)\)\))/Sqrt[1-(4g^2)/u^2],{g,0,2 lp}],g^(2 lp)]]//If[\[Section]Parallel===True,ParallelCCompute,CCompute][#]/.EndSimplify&);


Options[ParallelCCompute]={Sum->True};


ParallelCCompute[EEE0E_,OptionsPattern[]]:=Block[{XX=DownValues@CCompute,Tmp},
SetSharedVariable[\[Section]Verbose,\[Section]Prerun,\[Section]RuleBeforeInt,\[Section]RuleforSimp];
Block[{CCompute},
With[{BB=XX[[1,2,1,1,2,{1,2}]]},CCompute[EE_]:=(EE/.BB);];(*

*)Tmp=EEE0E//CCompute;(*


*)Tmp=Tmp/.CCompute->Identity;];
Tmp=IntoList[Collect[Tmp/.g->1,\[DoubleStruckCapitalC][_]]];
If[OptionValue[Sum]===True,Total,Identity]@ParallelMap[
((If[\[Section]Verbose, Print["kernel "<>ToString[$KernelID]<>" woke up at "<>DateString[{"Hour",":","Minute"}]," to compute ",#]];
 If[!MemberQ[$Path,"~/Konishi7/"],
If[\[Section]Verbose,Print["kernel "<>ToString[$KernelID]<>" initializing"]];
Block[{Print},
PrependTo[$Path, "~/Dropbox/Konishi7/"];
Get["stylepackage.m"];
Get["FiNLIEKonishi6S.m"];
Get["zetafunctionsS.m"];
PrependTo[$Path, "~/Konishi7/"];
Get["UpWiseIntegrate.m"];]];
\[Section]Prerun;
CCompute@#)//((If[\[Section]Verbose,Print["kernel "<>ToString[$KernelID]<>" off at "<>DateString[{"Hour",":","Minute"}]]];#)&))&,
(*/@*)Tmp
,Method->"FinestGrained",DistributedContexts->None]];


CCompute/:eEe_/.CCompute:=CCompute[eEe];
CCompute/:eEe_//.CCompute:=FixedPoint[CCompute,eEe];


UpIntSimp/:eEe_/.UpIntSimp:=UpIntSimp[eEe];
UpIntSimp/:eEe_//.UpIntSimp:=FixedPoint[UpIntSimp,eEe];


BoldCompute/:eEe_/.BoldCompute:=BoldCompute[eEe];
BoldCompute/:eEe_//.BoldCompute:=FixedPoint[BoldCompute,eEe];


PrepareParallelComput[filename_,Expr_]:=Block[{XX=DownValues@CCompute(*,CurrentExpr*)},

CurrentExpr=Expr/.\[Section]Ewrap[n_]:>Block[{CCompute = Identity, EndSimplify={}}, Ewrap[n]];

Block[{CCompute},
With[{BB=XX[[1,2,1,1,2,{1,2}]]},CCompute[EE_]:=(EE/.BB);];

CurrentExpr=CurrentExpr//CCompute;


CurrentExpr=CurrentExpr/.CCompute->Identity;];

CurrentExpr=IntoList[Collect[CurrentExpr/.g->1,\[DoubleStruckCapitalC][_]]];
CurrentExpr=Total[ToCompute/@CurrentExpr];

Save[filename,CurrentExpr];
Quiet[DeleteFile[filename<>".tmp"]];];


PseudoParallelCompute[Null]=Null;
PseudoParallelCompute[A_]/;Head[A]=!=String:=Null;


PseudoMove[filename_,str_:""]:=Block[{SillyNumber},
SillyNumber=RandomInteger[10^20];
While[Quiet[If[Check[RenameFile[filename,filename<>".tmp"];False,True],
Pause[10+RandomInteger[10]];True,
Get["! echo "<>ToString[SillyNumber]<>" > "<>filename<>".lock"];
If[\[Section]Verbose,Print["locking the file "<>filename<>str]];
Pause[3];
If[SillyNumber===Get[filename<>".lock"],False,
If[\[Section]Verbose,Print["Conflicting locks"]];True
]]],
If[\[Section]Verbose,Print["Failed to rename "<>filename<>" to "<>filename<>".tmp
If this happens only once in a while, it is the normal behavior of interferences with other kernels"]]];];


PseudoParallelCompute[filename_]:=Block[{(*Res,*)(*CurrentExpr,*)Pos,ThisTerm,Res,Waiting=False,SillyNumber},
While[
PseudoMove[filename," in order to start a computation"];
(*CurrentExpr=*)Get[filename<>".tmp"];
If[!FreeQ[CurrentExpr,ToCompute],
CurrentExpr=IntoList@CurrentExpr;
Pos=First@First@Position[CurrentExpr,_ToCompute];
ThisTerm=(CurrentExpr)[[Pos]];

CurrentExpr[[Pos,0]]=Computing;
CurrentExpr=Total@CurrentExpr;
Save[filename,CurrentExpr];(*1/0;*)
(*Quiet[*)DeleteFile[filename<>".tmp"];(*];*)
If[\[Section]Verbose,Print["unlocked the file "<>filename]];
ThisTerm=ThisTerm[[1]];
If[\[Section]Verbose,Print["at "<>DateString[{"Hour",":","Minute"}]<>", start to compute ",ThisTerm]];
Res=CCompute[ThisTerm/.Hold->Identity];
If[\[Section]Verbose,Print["at "<>DateString[{"Hour",":","Minute"}]<>", finishes computing ",ThisTerm]];

PseudoMove[filename," to save a modification"];
Get[filename<>".tmp"];
CurrentExpr=CurrentExpr/. Computing[ThisTerm]:>(If[\[Section]Verbose,Print["saving a term"]];Computed[Res])(*/.Computed[aAa23_]+Computed[bBb23_]+c23_.:>ToCompute[aAa23+bBb23]+c23*);
];Save[filename,CurrentExpr];
DeleteFile[filename<>".tmp"];
If[\[Section]Verbose,Print["unlocked the file "<>filename]];

If[MatchQ[CurrentExpr,Plus[___,_Computed,_Computed,___]],
PseudoMove[filename," to ask an addition"];
Get[filename<>".tmp"];
CurrentExpr=CurrentExpr/.Plus[A___,B_Computed,C_Computed,D___]:>(ToCompute[(Hold@@B)+(Hold@@C)]+Plus[A,D]);
Save[filename,CurrentExpr];
DeleteFile[filename<>".tmp"];
If[\[Section]Verbose,Print["unlocked the file "<>filename]];];

(*Check whether it is necessary to reloop*)
Position[IntoList@CurrentExpr,_ToCompute]=!={},Null];

While[Position[IntoList@CurrentExpr,_Computing]=!={},
If[!Waiting && \[Section]Verbose,
Print["Since "<>DateString[{"Hour",":","Minute"}]<>", waiting for other kernels to finish"];Waiting=True];Pause[60];
Quiet[Get[filename]];];
If[Head[CurrentExpr=!=Computed],
CurrentExpr=Computed[CurrentExpr/.Computed->Identity/.EndSimplify];
Quiet[DeleteFile[filename<>".tmp"];];
DeleteFile[filename];
Save[filename,CurrentExpr];
If[\[Section]Verbose,Print["Saved final result"]];];
CurrentExpr/.Computed->Identity
];
