(* ::Package:: *)

If[!ValueQ[$Copyright], $Copyright = False]; 
If[$Copyright, Print["FiNLIEKonishi.m: This package should be considered as a part of the paper "<>"Multiple zeta functions and double wrapping in planar N = 4 SYM"<>
     " by S.Leurent and D.Volin
This package is an updated version of an original package by S.Leurent, D. Serban and D.Volin"]]; 


(* ::Subsection::Closed:: *)
(*Diverse*)


\[CapitalLambda]\[Rho]s = 5; 
sub\[Rho]Ansatz = {M[Subscript[\[Delta]\[Rho]2, e_]] :> Sum[Subscript[\[Alpha], e][i]*Mint[2*i], {i, 0, \[CapitalLambda]\[Rho]s}], 
    M[w^(a_.)*Subscript[\[Delta]\[Rho]2, e_]] :> Sum[Subscript[\[Alpha], e][i]*Mint[2*i + a], {i, 0, \[CapitalLambda]\[Rho]s}], 
    PV[Subscript[\[Delta]\[Rho]2, e_]] :> Sum[Subscript[\[Alpha], e][i]*PVint[2*i], {i, 0, \[CapitalLambda]\[Rho]s}], PV[w^(a_.)*Subscript[\[Delta]\[Rho]2, e_]] :> 
     Sum[Subscript[\[Alpha], e][i]*PVint[2*i + a], {i, 0, \[CapitalLambda]\[Rho]s}], M[Subscript[\[Delta]\[Rho], e_]] :> 
     Sum[Subscript[\[Beta], e][i]*Mint[2*i], {i, 0, \[CapitalLambda]\[Rho]s}], M[w^(a_.)*Subscript[\[Delta]\[Rho], e_]] :> 
     Sum[Subscript[\[Beta], e][i]*Mint[2*i + a], {i, 0, \[CapitalLambda]\[Rho]s}], PV[Subscript[\[Delta]\[Rho], e_]] :> Sum[Subscript[\[Beta], e][i]*PVint[2*i], 
      {i, 0, \[CapitalLambda]\[Rho]s}], PV[w^(a_.)*Subscript[\[Delta]\[Rho], e_]] :> Sum[Subscript[\[Beta], e][i]*PVint[2*i + a], {i, 0, \[CapitalLambda]\[Rho]s}], 
    Subscript[\[Delta]\[Rho], e_] :> Sum[Subscript[\[Beta], e][i]*z^(2*i)*Sqrt[1 - z^2], {i, 0, \[CapitalLambda]\[Rho]s}], 
    Subscript[\[Delta]\[Rho]2, e_] :> Sum[Subscript[\[Alpha], e][i]*z^(2*i)*Sqrt[1 - z^2], {i, 0, \[CapitalLambda]\[Rho]s}]}; 
sub\[DoubleStruckCapitalC]simplify = {(a_.)*\[DoubleStruckCapitalC][(b_.)*W$h[e_][0] + (c_.)] + (a2_.)*\[DoubleStruckCapitalC][(b2_.)*W$h[e2_][0] + (c2_.)] :> 
     \[DoubleStruckCapitalC][Collect[a*b*W$h[e][0] + a2*b2*W$h[e2][0] + a*c + a2*c2, W$h[_][0], Simplify]], 
    (a_.)*\[DoubleStruckCapitalC][(b_.)*W$[1, e_][1] + (c_.)] + (a2_.)*\[DoubleStruckCapitalC][(b2_.)*W$[1, e2_][1] + (c2_.)] :> 
     \[DoubleStruckCapitalC][Collect[a*b*W$[1, e][1] + a2*b2*W$[1, e2][1] + a*c + a2*c2, W$[1, _][1], Simplify]], 
    (a_.)*\[DoubleStruckCapitalC][(b_.)*H$[e_][0] + (c_.)] + (a2_.)*\[DoubleStruckCapitalC][(b2_.)*H$[e2_][0] + (c2_.)] :> 
     \[DoubleStruckCapitalC][Collect[a*b*H$[e][0] + a2*b2*H$[e2][0] + a*c + a2*c2, H$[_][0], Simplify]]}; 


v00 = 1/Sqrt[12]; 


suboppositesign = {u -> -u,\[ScriptU]$[a_][r_]:>-\[ScriptU]$[-a][-r],Q0$[a_] :> Q0$[-a], \[Eta]$[a__][r_:0] :> (-1)^Total[{a}]*\[Eta]$b[a][-r], 
    \[Eta]$b[a__][r_:0] :> (-1)^Total[{a}]*\[Eta]$[a][-r]}; 
symfun = (1/2)*(#1 + (#1 /. suboppositesign)) & ; 
asymfun = (1/2)*(#1 - (#1 /. suboppositesign)) & ; 


denz = {Sqrt[4-4z^2]->2Sqrt[1-z^2],((AA_) + (BB_.)*Sqrt[1 - z^2])^(a_ /; a < 0) :> Simplify[AA^2 - BB^2*(1 - z^2)]^a/(AA - BB*Sqrt[1 - z^2])^a}; 
zlist = {g, Sqrt[2], Sqrt[1 - z^2], z}; 


subAnsatz = {M[Subscript[\[Delta]\[Rho]2, e_]] :> Sum[Subscript[\[Alpha], e][i]*Mint[2*i], 
      {i, 0, \[CapitalLambda]\[Rho]s}], M[w^(a_.)*Subscript[\[Delta]\[Rho]2, e_]] :> 
     Sum[Subscript[\[Alpha], e][i]*Mint[2*i + a], {i, 0, \[CapitalLambda]\[Rho]s}], 
    PV[Subscript[\[Delta]\[Rho]2, e_]] :> Sum[Subscript[\[Alpha], e][i]*PVint[2*i], 
      {i, 0, \[CapitalLambda]\[Rho]s}], PV[w^(a_.)*Subscript[\[Delta]\[Rho]2, e_]] :> 
     Sum[Subscript[\[Alpha], e][i]*PVint[2*i + a], {i, 0, \[CapitalLambda]\[Rho]s}], 
    M[Subscript[\[Delta]\[Rho], e_]] :> Sum[Subscript[\[Beta], e][i]*Mint[2*i], {i, 0, \[CapitalLambda]\[Rho]s}], 
    M[w^(a_.)*Subscript[\[Delta]\[Rho], e_]] :> Sum[Subscript[\[Beta], e][i]*Mint[2*i + a], 
      {i, 0, \[CapitalLambda]\[Rho]s}], PV[Subscript[\[Delta]\[Rho], e_]] :> 
     Sum[Subscript[\[Beta], e][i]*PVint[2*i], {i, 0, \[CapitalLambda]\[Rho]s}], 
    PV[w^(a_.)*Subscript[\[Delta]\[Rho], e_]] :> Sum[Subscript[\[Beta], e][i]*PVint[2*i + a], 
      {i, 0, \[CapitalLambda]\[Rho]s}], Subscript[\[Delta]\[Rho], e_] :> 
     Sum[Subscript[\[Beta], e][i]*z^(2*i)*Sqrt[1 - z^2], {i, 0, \[CapitalLambda]\[Rho]s}], 
    Subscript[\[Delta]\[Rho]2, e_] :> Sum[Subscript[\[Alpha], e][i]*z^(2*i)*Sqrt[1 - z^2], 
      {i, 0, \[CapitalLambda]\[Rho]s}]}; 


(* ::Subsection::Closed:: *)
(*Y-, T- functions*)


subYT = {Y$[a_, s_][r_:0] :> (T$[a, -1 + s][r]*T$[a, 1 + s][r])/(T$[-1 + a, s][r]*T$[1 + a, s][r]), 
    Yt$[a_, s_][r_:0] :> (T$[a, s][r + 1]*T$[a, s][r - 1])/(T$[a + 1, s][r]*T$[a - 1, s][r]), 
    Yo$[a_, s_][r_:0] :> (T$[a, s][r + 1]*T$[a, s][r - 1])/(T$[a, s - 1][r]*T$[a, s + 1][r])}; 
magicratioright = Yt$[1, 1][]/Yo$[2, 2][]; magicratioup = Yt$[2, 2][]/Yo$[1, 1][]; 
subsym = {x:(_T$g | _T | _T$w)[a_, s_ /; s < 0][r_:0] :> x$[a, -s][r]}; 
subtosimplebasis = {T$g[1, 1][r_:0] :> T$w[1, 1][r]*\[ScriptCapitalF]$[r], T$g[0, 0][r_:0] :> \[ScriptCapitalF]$[r]^2, 
    T$gh[2, 0][r_:0] :> \[ScriptCapitalF]$h[2 + r]*\[ScriptCapitalF]$h[-2 + r] - T$w[1, 1][r]^2}; 
subYtYoY = {Yt$[a_, s_][r_:0] :> 1 + Y$[a, s][r], Yo$[a_, s_][r_:0] :> 1 + 1/Y$[a, s][r]}; 


subgaugeTuTg = {T$u[a_, s_][r_:0] :> (T$g[a, s][r]/(f$[a + s + r]*f$[a - s + r]*f$b[-a - s + r]*f$b[-a + s + r]))*
      (1/Which[s === 0, 1, s === 1, U$[a + r]*U$b[-a + r], s === 2, U$[a + r + 1]*U$b[-a + r + 1]*U$[a + r - 1]*U$b[-a + r - 1], True, 
        "err"])}; 
subgaugeTgTu = {T$g[a_, s_][r_:0] :> T$u[a, s][r]*f$[a + s + r]*f$[a - s + r]*f$b[-a - s + r]*f$b[-a + s + r]*
      Which[s === 0, 1, s === 1, U$[a + r]*U$b[-a + r], s === 2, U$[a + r + 1]*U$b[-a + r + 1]*U$[a + r - 1]*U$b[-a + r - 1], True, "err"]}; 
subgaugeTrTw = {T$r[a_, s_][r_:0] :> T$w[a, s][r]/Which[a === 0, 1, a === 1, h$h[s + r]*h$h[-s + r], a === 2, 
       h$h[s + 1 + r]*h$h[s - 1 + r]*h$h[-s + 1 + r]*h$h[-s - 1 + r]]}; 
subgaugeTwTr = {T$w[a_, s_][r_:0] :> T$r[a, s][r]*Which[a === 0, 1, a === 1, h$h[s + r]*h$h[-s + r], a === 2, 
       h$h[s + 1 + r]*h$h[s - 1 + r]*h$h[-s + 1 + r]*h$h[-s - 1 + r]]}; 
subgaugeTwTg = {T$w[a_, s_][r_:0] :> T$g[a, s][r]*\[ScriptCapitalF]$[a + s + r]^(a - 2)}; 
subgaugeTgTw = {T$g[a_, s_][r_:0] :> T$w[a, s][r]*\[ScriptCapitalF]$[a + s + r]^(2 - a)}; 


(* ::Subsubsection::Closed:: *)
(*T-functions in terms of q-functions, upper band (this code does not perform a check of a>|s| condition )*)


subTWedge = {(xx_ /; FindFun[xx] === "T")[a_, s_][r_:0] :> Symbol[StringJoin["q$", SortSpecs[Join[{"f"}, FindSpecs[xx]]]]][2 - s][r + a] \[Wedge] 
      Symbol[StringJoin["p$", SortSpecs[Join[{"f"}, FindSpecs[xx]]]]][2 + s][r - a]}; 
rankOfForm[xx_Wedge] := Total[(Head[#1][[1]] & ) /@ List @@ xx]; 
WedgeToComponents[xx_Wedge] := Block[{fmnmb = (Head[#1][[1]] & ) /@ List @@ xx, indexpos, tmphead, tmpvar}, 
    indexpos = Join[{0}, Table[Total[fmnmb[[1 ;; k]]], {k, Length[fmnmb]}]]; 
     tmpvar = Union[(tmphead @@ Table[Sort[#1[[indexpos[[k]] + 1 ;; indexpos[[k + 1]]]]], {k, Length[indexpos] - 1}] & ) /@ 
        Permutations[Range[$dim]]]; 
     tmpvar = (Signature[Flatten[List @@ #1]]*Times @@ Table[xx[[k]] /. (aaa_)[bbb_][rrr_:0] :> 
             (Symbol[StringJoin[FindFun[aaa], "$", DeleteCases[FindSpecs[aaa], "f"]]] @@ #1[[k]])[rrr], {k, Length[xx]}] & ) /@ tmpvar; 
     Factor[Total[tmpvar]]]; 
subWedgeComponents = {xx_Wedge /; rankOfForm[xx] === $dim :> WedgeToComponents[xx]}; 
subTQ = {(xx_ /; FindFun[xx] === "T")[a_, s_][r_:0] :> (xx[a, s][r] /. subTWedge /. subWedgeComponents)}; 
subqfdetqf = {(xx_ /; MatchQ[FindFun[xx], "q" | "p"] && hextFormQ[xx])[a_][r_:0] :> Wedge @@ Table[xx[1][k + r], {k, a - 1, 1 - a, -2}]/
      Product[(RemoveSpec[xx, "f"] @@ {0}) @@ {k + r}, {k, a - 2, 2 - a, -2}]}; 


(xx:q$)[a__][r_:0] := Signature[{a}]*Sort[xx[a]][r] /;  !OrderedQ[{a}]; 
(xx:p$)[a__][r_:0] := Signature[{a}]*Sort[xx[a]][r] /;  !OrderedQ[{a}]; 
(xx:q$b)[a__][r_:0] := Signature[{a}]*Sort[xx[a]][r] /;  !OrderedQ[{a}]; 
(xx:p$b)[a__][r_:0] := Signature[{a}]*Sort[xx[a]][r] /;  !OrderedQ[{a}]; 
(xx:\[Omega])[a__][r_:0] := Signature[{a}]*Sort[xx[a]][r] /;  !OrderedQ[{a}]; 
(xx:\[Chi])[a__][r_:0] := Signature[{a}]*Sort[xx[a]][r] /;  !OrderedQ[{a}]; 
qqrelation[base___, i_, j_] := (-q$[base, i, j][])*q$[base][] + q$[base, i][1]*q$[base, j][-1] - q$[base, i][-1]*q$[base, j][Plus[1]]
subpqb = {p$[1][r_:0] :> -q$b[1, 3, 4][r], p$[2][r_:0] :> q$b[2, 3, 4][r], p$[3][r_:0] :> -q$b[1, 2, 3][r], p$[4][r_:0] :> q$b[1, 2, 4][r], 
    p$[1, 2][r_:0] :> q$b[3, 4][r], p$[2, 4][r_:0] :> q$b[2, 4][r], p$[1, 4][r_:0] :> -q$b[2, 3][r], p$[2, 3][r_:0] :> -q$b[1, 4][r], 
    p$[1, 3][r_:0] :> q$b[1, 3][r], p$[3, 4][r_:0] :> q$b[1, 2][r], p$[1, 3, 4][r_:0] :> -q$b[1][r], p$[2, 3, 4][r_:0] :> q$b[2][r], 
    p$[1, 2, 3][r_:0] :> -q$b[3][r], p$[1, 2, 4][r_:0] :> q$b[4][r]}; 
subqUq = {q$[1, 2, 3][r_:0] :> U$[r]^2*q$[1][r], q$[1, 2, 4][r_:0] :> U$[r]^2*q$[2][r], q$[1, 3, 4][r_:0] :> U$[r]^2*q$[3][r], 
    q$[2, 3, 4][r_:0] :> U$[r]^2*q$[4][r], q$b[1, 2, 3][r_:0] :> U$b[r]^2*q$b[1][r], q$b[1, 2, 4][r_:0] :> U$b[r]^2*q$b[2][r], 
    q$b[1, 3, 4][r_:0] :> U$b[r]^2*q$b[3][r], q$b[2, 3, 4][r_:0] :> U$b[r]^2*q$b[4][r]}; 


(* ::Subsection::Closed:: *)
(*Jukowsky functions  (* version designed for Konishi state *)*)


subFunsBethe = {Subscript[\[Gamma], 0] -> 4*I*g*(1/y$h[Plus[1]] - 1/y$h[-1]), Q$[r_:0] :> (u + (I*r)/2)^2 - Subscript[v, 0]^2, 
    Bm$[r_:0] :> (g/(I*Sqrt[y$h[-1]]*Sqrt[y$h[Plus[1]]]))*(1/x$[r] - y$h[Plus[1]])*(1/x$[r] + y$h[-1]), 
    Bp$[r_:0] :> (g/((-I)*Sqrt[y$h[-1]]*Sqrt[y$h[Plus[1]]]))*(1/x$[r] - y$h[-1])*(1/x$[r] + y$h[Plus[1]]), 
    Rm$[r_:0] :> (g/(I*Sqrt[y$h[-1]]*Sqrt[y$h[Plus[1]]]))*(x$[r] - y$h[Plus[1]])*(x$[r] + y$h[-1]), 
    Rp$[r_:0] :> (g/((-I)*Sqrt[y$h[-1]]*Sqrt[y$h[Plus[1]]]))*(x$[r] - y$h[-1])*(x$[r] + y$h[Plus[1]])}; 
subJuk = {x$[r_:0] :> (1/(2*g))*((u + (I*r)/2) + I*Sqrt[4*g^2 - (u + (I*r)/2)^2]), 
    x$h[r_:0] :> (1/(2*g))*((u + (I*r)/2) + Sqrt[(u + (I*r)/2) - 2*g]*Sqrt[(u + (I*r)/2) + 2*g]), 
    y$h[r_:0] :> (1/(2*g))*((Subscript[v, 0] + (I*r)/2) + Sqrt[(Subscript[v, 0] + (I*r)/2) - 2*g]*Sqrt[(Subscript[v, 0] + (I*r)/2) + 2*g])}; 
subxxh = {x$[r_:0] :> x$h[r]^If[r >= 0, 1, -1] /; NumericQ[r]}; 


(* ::Subsection::Closed:: *)
(*Routines to operate with data files*)


If[!ValueQ[PathToFiles],PathToFiles = InputString[ "Please enter the
name of the folder where you downloaded the packages",
$UserDocumentsDirectory];];
If[!ValueQ[$KonishiFolder],$KonishiFolder=PathToFiles;];
$Path=Cases[DeleteDuplicates[Prepend[$Path,$KonishiFolder]],_String];
If[!ValueQ[$WeakCouplingData],$WeakCouplingData=FileNameJoin[{DirectoryName[FindFile["FiNLIEKonishi.m"]],"WeakCouplingData"}]];
CreateFileDialog[filename_String]:=
DialogInput[DialogNotebook[
{TextCell[filename<>" file is not found. 
Most probably this means an error."],
Row[{Button["I know what I am doing. Create a file",DialogReturn[True]],TextCell["  "],
Button["Abort evaluation",DialogReturn[False]]}]
}
]];
AskToRewrite[messag_String]:=
DialogInput[DialogNotebook[
{TextCell[messag],
Row[{Button["Rewrite with new one",DialogReturn[True]],TextCell["  "],
Button["Keep old one",DialogReturn[False]]}]
}
]];

UpdateDsReplacements[]:=Block[{dir=Directory[]},
SetDirectory[$WeakCouplingData];
dsweakexplicit=Get["dsweak.data"];
dsweakknowns=dsweakexplicit[[All,1]];
dsweakknownsbar=Select[dsweakknowns/.mconj,FreeQ[dsweakknowns,#]&];
SetDirectory[dir];
];

UpdateNsReplacements[]:=Block[{dir=Directory[]},
SetDirectory[$WeakCouplingData];
nsweakexplicit=Get["nsweak.data"];
nsweakknowns=nsweakexplicit[[All,1]];
nsweakknownsbar=Select[nsweakknowns/.mconj,FreeQ[nsweakknowns,#]&];
SetDirectory[dir];
];


AddDsDefinition[expr_List]:=CheckAndAddDefinition[expr,"dsweak.data"];
AddNsDefinition[expr_List]:=CheckAndAddDefinition[expr,"nsweak.data"];

CheckAndAddDefinition::AddingNew="Adding new replacement rule for `1` to `2`";
Off[CheckAndAddDefinition::AddingNew];

CheckAndAddDefinition[expr_List,DataFileName_String]:=Block[
{tmp,dataexpr,curDirectory=Directory[],Changed=False},
SetDirectory[$WeakCouplingData];

If[FindFile[DataFileName]===$Failed,

	If[CreateFileDialog[DataFileName]/.$Failed->False,
		Put[{expr},DataFileName];Changed=True,
		Abort[]]
,
	dataexpr=Cases[tmp=Get[DataFileName],{expr[[1]],_}];
	Which[
		dataexpr=={},
			Message[CheckAndAddDefinition::AddingNew,expr[[1]],DataFileName];Put[Append[tmp,expr],DataFileName];Changed=True;,
		Length[dataexpr]==1,
			Which[
				Length[dataexpr[[1,2]]]<Length[expr[[2]]],
					If[
						Union[dataexpr[[1,2]]-expr[[2]][[ 1;;Length[ dataexpr[[1,2]] ] ]] ]=={0},
							Put[ReplacePart[tmp,Position[tmp,dataexpr[[1]]][[1]]->expr],DataFileName];Changed=True,
							If[AskToRewrite["new expression for "<> ToString[expr[[1]]]<>" does not agree with old one"]/.$Failed->False,
								Put[ReplacePart[tmp,Position[tmp,dataexpr[[1]]][[1]]->expr],DataFileName];Changed=True
							]
					],
				Length[dataexpr[[1,2]]]==Length[expr[[2]]],
					If[
						Union[dataexpr[[1,2]]-expr[[2]][[ 1;;Length[dataexpr[[1,2]]] ]]]=={0}//Not,
							If[AskToRewrite["new expression for "<> ToString[expr[[1]]]<>"  is of the same length but different from old one"]/.$Failed->False,
								Put[ReplacePart[tmp,Position[tmp,dataexpr[[1]]][[1]]->expr],DataFileName];Changed=True
							]
					],
				True,
					If[Union[dataexpr[[1,2]][[ 1;;Length[expr[[2]]] ]]-expr[[2]]]=={0},
						If[AskToRewrite["new expression for "<> ToString[expr[[1]]]<>" agrees with old one, BUT SHORTER"]/.$Failed->False,
							Put[ReplacePart[tmp,Position[tmp,dataexpr[[1]]][[1]]->expr],DataFileName];Changed=True
						],
						If[AskToRewrite["new expression for "<> ToString[expr[[1]]]<>" is shorter and does not agree with old one"]/.$Failed->False,
							Put[ReplacePart[tmp,Position[tmp,dataexpr[[1]]][[1]]->expr],DataFileName];Changed=True
						]
					]  
			],
		Length[dataexpr]>1,
			Print["Problem with structure of" <> DataFileName]; Abort[];
	]
];
If[Changed,
	Which[
		DataFileName=="dsweak.data",
			UpdateDsReplacements[],
		DataFileName=="nsweak.data",
			UpdateNsReplacements[],
		True,
			Print["some unknown filename!"]
	]
];
SetDirectory[curDirectory];
];


PrepareList[expr_, offset_:0] := 
  Block[{expo = Mod[Exponent[expr /. g -> 1/g, g], 2]}, 
   Join[ConstantArray[0, Floor[offset]], 
    SortBy[List @@ Collect[Collect[expr*g^50, g, Hold] /. 
         g^(a_) :> AAA^Floor[a/2 + expo/2 + offset]*g^(a - 50), 
        AAA] /. AAA -> 1, Exponent[#1, g] & ]]];


(* ::Subsection::Closed:: *)
(*Large volume expansion (* version designed for Konishi state *)*)


largevolume = {Y11Y22 -> (Bm*Rp)/(Bp*Rm), T$u[a_, 0][r_:0] :> Q$[a + r]*Q$[-a + r], \[Rho] -> (2*I*Sqrt[1 - (u/(2*g))^2])/(y$h[1] - y$h[-1]), 
    \[Rho]2 -> (2*I*Sqrt[1 - (u/(2*g))^2])/(1/y$h[1] - 1/y$h[-1]), q$[2][r_:0] :> (-I)*(u + (I*r)/2 + ((4*g)/Subscript[\[Gamma], 0])*(1/x$[r])), 
    q$b[2][r_:0] :> (Plus[I])*(u + (I*r)/2 + ((4*g)/Subscript[\[Gamma], 0])*x$[r]), T$u[a_ /; a >= 1, 1][r_:0] :> 
     a - (1/x$[a + r] - x$[-a + r])/(1/y$h[1] - 1/y$h[-1]), T$r[1, s_ /; s >= 1][r_:0] :> s - (1/x$[s + r] - x$[-s + r])/(y$h[1] - y$h[-1]), 
    T$uh[a_, 1][r_:0] :> a - (1/x$h[a + r] - 1/x$h[-a + r])/(1/y$h[1] - 1/y$h[-1]), 
    T$rh[1, s_][r_:0] :> s - (1/x$h[s + r] - 1/x$h[-s + r])/(y$h[1] - y$h[-1])};
If[Not@NameQ["$InTermsOfEnergy"],$InTermsOfEnergy=False];
If[$InTermsOfEnergy,
Block[{ee,eed},
largevolume=largevolume/.{RuleDelayed->eed,Rule->ee}/.((xxx:ee|eed)[aa_,bb_]:>xxx[aa,(bb/.{1/y$h[1]-1/y$h[-1]->  (-(I/g)(Subscript[\[Gamma], 0]/4)),y$h[1]- y$h[-1]-> (I/g (1+Subscript[\[Gamma], 0]/4))})])/.{eed->RuleDelayed,ee->Rule}]
];
subyhtoE={1/y$h[1]-1/y$h[-1]->  (-(I/g)(Subscript[\[Gamma], 0]/4)),y$h[1]- y$h[-1]-> (I/g (1+Subscript[\[Gamma], 0]/4))};


(* ::Subsection::Closed:: *)
(*Weakcoupling expansion (* version designed for Konishi state *)*)


$Assumptions = $Assumptions && g > 0; 


mconj={Complex[a_,b_]:>Complex[a,-b],
\[Eta]$[a__][r_:0]:>\[Eta]$b[a][-r],\[Eta]$b[a__][r_:0]:>\[Eta]$[a][-r],
\[Eta]0$[a__][r_:0]:>\[Eta]0$b[a][-r],\[Eta]0$b[a__][r_:0]:>\[Eta]0$[a][-r],
H$[r_:0]:>H$b[-r],H$b[r_:0]:>H$[-r],
\[Zeta]$[a___][0]:>\[Zeta]$[a][0],
q$[a__][r_:0]:>q$b[a][-r],q$b[a__][r_:0]:>q$[a][-r],Q0$[r_:0]:>Q0$[-r],Q$[r_:0]:>Q$[-r],\[Delta]Q$[r_:0]:>\[Delta]Q$b[-r],\[Delta]Q$b[r_:0]:>\[Delta]Q$[-r],
U$[r_:0]:>U$b[-r],U$b[r_:0]:>U$[-r],
x$h[r_:0]:>x$h[-r],x$[r_:0]:>1/x$[-r],y$h[r_:0]:>y$h[-r],
W$[a__][r_:0]:>W$[a][-r],W$h[a__][r_:0]:>W$h[a][-r],
xxx_?NumericQ:>Conjugate[xxx]};


ClearAll[weak]; 
weak = {nfactor :> (SeriesData[g, 0, {1, 0, -6*EulerGamma, 0, 24*EulerGamma + 18*EulerGamma^2 + 18*Zeta[3], 0, -168*EulerGamma - 144*EulerGamma^2 - 
          36*EulerGamma^3 - 72*Zeta[3] - 108*EulerGamma*Zeta[3] - 120*Zeta[5]}, 0, 8, 1] /. EulerGamma -> \[Zeta]$[1][0] /. Zeta[r_] :> \[Zeta]$[r][0]), 
    V$[r_:0] :> (SeriesData[g, 0, {1, 0, -6*\[Zeta]$[1][0] + (6*I)*\[Eta]$[1][2], 0, 6*(3*\[Zeta]$[1][0]^2 + 3*\[Zeta]$[3][0] + \[Zeta]$[1][0]*(4 - (6*I)*\[Eta]$[1][2]) - 
           (4*I)*\[Eta]$[1][2] - 3*\[Eta]$[1][2]^2 + I*\[Eta]$[3][2]), 0, 
         (-12*(-\[Zeta]$[3][0] + u^2*(3*\[Zeta]$[1][0]^3 + 10*\[Zeta]$[5][0] + 3*\[Zeta]$[1][0]^2*(4 - (3*I)*\[Eta]$[1][2]) + \[Zeta]$[3][0]*(6 - (9*I)*\[Eta]$[1][2]) - 
              (14*I)*\[Eta]$[1][2] - 12*\[Eta]$[1][2]^2 + (3*I)*\[Eta]$[1][2]^3 + \[Zeta]$[1][0]*(14 + 9*\[Zeta]$[3][0] - (24*I)*\[Eta]$[1][2] - 9*\[Eta]$[1][2]^2 + 
                (3*I)*\[Eta]$[3][2]) + (2*I)*\[Eta]$[3][2] + 3*\[Eta]$[1][2]*\[Eta]$[3][2] - I*\[Eta]$[5][2])))/u^2}, 0, 7, 1] /. Shift[r] /. u -> u + (I*r)/2), 
    V$b[r_:0] :> (V$[-(r /. Conjugate)] /. weak /. mconj), Subscript[v, 0] :> 1/(2*Sqrt[3]) + (4*g^2)/Sqrt[3] - (10*g^4)/Sqrt[3] + 
      (8*g^6*(7 + 3*\[Zeta]$[3][0]))/Sqrt[3] + g^8*(-(Im1/9) - (461 + 144*\[Zeta]$[3][0] + 240*\[Zeta]$[5][0])/Sqrt[3]) + 
      g^10*(-((4*Im1)/9) - Im2/9 + (4*(1133 + 252*\[Zeta]$[3][0] + 378*\[Zeta]$[5][0] + 630*\[Zeta]$[7][0]))/Sqrt[3]) + 
      g^12*(-15890*Sqrt[3] + 2*Im1 - (4*Im2)/9 - Im3/9 - 3112*Sqrt[3]*\[Zeta]$[3][0] - 96*Sqrt[3]*\[Zeta]$[3][0]^2 - 3888*Sqrt[3]*\[Zeta]$[5][0] - 
        5544*Sqrt[3]*\[Zeta]$[7][0] - 9408*Sqrt[3]*\[Zeta]$[9][0]) + g^14*(172616*Sqrt[3] - 8*Im1 + 2*Im2 - (4*Im3)/9 - Im4/9 + 36576*Sqrt[3]*\[Zeta]$[3][0] + 
        192*Sqrt[3]*\[Zeta]$[3][0]^2 + 38272*Sqrt[3]*\[Zeta]$[5][0] + 1920*Sqrt[3]*\[Zeta]$[3][0]*\[Zeta]$[5][0] + 45648*Sqrt[3]*\[Zeta]$[7][0] + 64512*Sqrt[3]*\[Zeta]$[9][0] + 
        110880*Sqrt[3]*\[Zeta]$[11][0]), Subscript[C, \[GothicCapitalT]] -> 4/(Subscript[\[Gamma], 0]*(Subscript[\[Gamma], 0] + 2)), 
    Subscript[C, \[ScriptCapitalT]] -> Subscript[\[Gamma], 0]/(Subscript[\[Gamma], 0] + 2), Subscript[\[Gamma], 0] -> 12*g^2 - 48*g^4 + 336*g^6 + (-2820 - 288*\[Zeta]$[3][0])*g^8 + 
      (26508 + (4*Im1)/Sqrt[3] + 4320*\[Zeta]$[3][0] + 2880*\[Zeta]$[5][0])*g^10 + (-269148 - (20*Im1)/Sqrt[3] + (4*Im2)/Sqrt[3] - 55296*\[Zeta]$[3][0] - 
        44064*\[Zeta]$[5][0] - 30240*\[Zeta]$[7][0])*g^12 + (2877240 + 56*Sqrt[3]*Im1 - (20*Im2)/Sqrt[3] + (4*Im3)/Sqrt[3] + 697536*\[Zeta]$[3][0] + 
        3456*\[Zeta]$[3][0]^2 + 579744*\[Zeta]$[5][0] + 471744*\[Zeta]$[7][0] + 338688*\[Zeta]$[9][0])*g^14 + 
      (-31857132 - (1844*Im1)/Sqrt[3] + 56*Sqrt[3]*Im2 - (20*Im3)/Sqrt[3] + (4*Im4)/Sqrt[3] - 8912160*\[Zeta]$[3][0] - 79488*\[Zeta]$[3][0]^2 - 
        7486848*\[Zeta]$[5][0] - 69120*\[Zeta]$[3][0]*\[Zeta]$[5][0] - 6342624*\[Zeta]$[7][0] - 5370624*\[Zeta]$[9][0] - 3991680*\[Zeta]$[11][0])*g^16, 
    U$b[r_:0]^2 :> (U$[-(r /. Conjugate)]^2 /. weak /. mconj), U$b[r_:0] :> (U$[-(r /. Conjugate)] /. weak /. mconj), 
    U$[r_:0]^2 :> (SeriesData[g, 0, {-2/u^2, 0, -4/u^4 - (12*I)/u^3 - 18/u^2 + (24*\[Zeta]$[1][0])/u^2 - ((24*I)*\[Eta]$[1][2])/u^2, 0, 
         -10/u^6 - (36*I)/u^5 - 6/u^4 - (60*I)/u^3 + 36/u^2 + (48/u^4 + (144*I)/u^3 + 120/u^2)*\[Zeta]$[1][0] - (144*\[Zeta]$[1][0]^2)/u^2 - (72*\[Zeta]$[3][0])/u^2 + 
          ((-48*I)/u^4 + 144/u^3 - (120*I)/u^2)*\[Eta]$[1][2] + ((288*I)*\[Zeta]$[1][0]*\[Eta]$[1][2])/u^2 + (144*\[Eta]$[2][2])/u^2 - ((24*I)*\[Eta]$[3][2])/u^2 + 
          (288*\[Eta]$[1, 1][2])/u^2, 0, -28/u^8 - (108*I)/u^7 + 30/u^6 - (144*I)/u^5 + 114/u^4 + (312*I)/u^3 - 216/u^2 + (576*\[Zeta]$[1][0]^3)/u^2 + 
          (-192/u^4 - (432*I)/u^3 - 360/u^2)*\[Zeta]$[3][0] + \[Zeta]$[1][0]*(120/u^6 + (432*I)/u^5 - 120/u^4 + (144*I)/u^3 - 624/u^2 + (864*\[Zeta]$[3][0])/u^2) + 
          (480*\[Zeta]$[5][0])/u^2 + ((-120*I)/u^6 + 432/u^5 + (120*I)/u^4 + 144/u^3 + (624*I)/u^2)*\[Eta]$[1][2] + ((576*I)/u^4 - 1728/u^3 + (288*I)/u^2)*
           \[Zeta]$[1][0]*\[Eta]$[1][2] - ((864*I)*\[Zeta]$[3][0]*\[Eta]$[1][2])/u^2 + \[Zeta]$[1][0]^2*(-288/u^4 - (864*I)/u^3 - 144/u^2 - ((1728*I)*\[Eta]$[1][2])/u^2) + 
          (288/u^4 + (864*I)/u^3 + 144/u^2)*\[Eta]$[2][2] - (1728*\[Zeta]$[1][0]*\[Eta]$[2][2])/u^2 + ((-48*I)/u^4 + 144/u^3 + (456*I)/u^2)*\[Eta]$[3][2] + 
          ((288*I)*\[Zeta]$[1][0]*\[Eta]$[3][2])/u^2 + (288*\[Eta]$[4][2])/u^2 - ((48*I)*\[Eta]$[5][2])/u^2 + (576/u^4 + (1728*I)/u^3 + 288/u^2)*\[Eta]$[1, 1][2] - 
          (3456*\[Zeta]$[1][0]*\[Eta]$[1, 1][2])/u^2 + ((1728*I)*\[Eta]$[1, 2][2])/u^2 + (288*\[Eta]$[1, 3][2])/u^2 + ((1728*I)*\[Eta]$[2, 1][2])/u^2 + 
          (288*\[Eta]$[3, 1][2])/u^2 + ((3456*I)*\[Eta]$[1, 1, 1][2])/u^2}, 4, 11, 1] /. Shift[r] /. u -> u + (I*r)/2), 
    U$[r_:0] :> (SeriesData[g, 0, {(I*Sqrt[2])/u, 0, (2*I + 6*u + (9*I)*u^2)/(Sqrt[2]*u^3) - ((6*I)*Sqrt[2]*\[Zeta]$[1][0])/u - (6*Sqrt[2]*\[Eta]$[1][0])/u, 0, 
         (16*I + 48*u + (12*I)*u^2 + 12*u^3 - (153*I)*u^4)/(4*Sqrt[2]*u^5) + ((18*I)*Sqrt[2]*\[Zeta]$[1][0]^2)/u + ((18*I)*Sqrt[2]*\[Zeta]$[3][0])/u - 
          (3*Sqrt[2]*(2 - (6*I)*u + u^2)*\[Eta]$[1][0])/u^3 + \[Zeta]$[1][0]*(((-3*I)*Sqrt[2]*(2 - (6*I)*u + u^2))/u^3 + (36*Sqrt[2]*\[Eta]$[1][0])/u) - 
          ((18*I)*Sqrt[2]*\[Eta]$[2][0])/u - (6*Sqrt[2]*\[Eta]$[3][0])/u - ((36*I)*Sqrt[2]*\[Eta]$[1, 1][0])/u, 0, 
         (80*I + 240*u + 48*u^3 - (186*I)*u^4 - 438*u^5 - (3*I)*u^6*(-747 + 640*\[Zeta]$[5][0]))/(8*Sqrt[2]*u^7) - ((36*I)*Sqrt[2]*\[Zeta]$[1][0]^3)/u + 
          (3*(-16 + (48*I)*u + 20*u^2 - (84*I)*u^3 + 73*u^4)*\[Eta]$[1][0])/(2*Sqrt[2]*u^5) + \[Zeta]$[3][0]*((3*Sqrt[2]*(10*I + 18*u + (3*I)*u^2))/u^3 - 
            (108*Sqrt[2]*\[Eta]$[1][0])/u) + \[Zeta]$[1][0]^2*((9*Sqrt[2]*(2*I + 6*u - (7*I)*u^2))/u^3 - (108*Sqrt[2]*\[Eta]$[1][0])/u) + 
          ((9*I)*Sqrt[2]*(-2 + (6*I)*u + 7*u^2)*\[Eta]$[2][0])/u^3 + (3*Sqrt[2]*(-2 + (6*I)*u + 11*u^2)*\[Eta]$[3][0])/u^3 - ((36*I)*Sqrt[2]*\[Eta]$[4][0])/u - 
          (12*Sqrt[2]*\[Eta]$[5][0])/u + ((18*I)*Sqrt[2]*(-2 + (6*I)*u + 7*u^2)*\[Eta]$[1, 1][0])/u^3 + 
          \[Zeta]$[1][0]*((3*(-16*I - 48*u + (20*I)*u^2 + 84*u^3 + (73*I)*u^4))/(2*Sqrt[2]*u^5) - ((108*I)*Sqrt[2]*\[Zeta]$[3][0])/u - 
            (18*Sqrt[2]*(-2 + (6*I)*u + 7*u^2)*\[Eta]$[1][0])/u^3 + ((108*I)*Sqrt[2]*\[Eta]$[2][0])/u + (36*Sqrt[2]*\[Eta]$[3][0])/u + 
            ((216*I)*Sqrt[2]*\[Eta]$[1, 1][0])/u) + (108*Sqrt[2]*\[Eta]$[1, 2][0])/u - ((36*I)*Sqrt[2]*\[Eta]$[1, 3][0])/u + (108*Sqrt[2]*\[Eta]$[2, 1][0])/u - 
          ((36*I)*Sqrt[2]*\[Eta]$[3, 1][0])/u + (216*Sqrt[2]*\[Eta]$[1, 1, 1][0])/u}, 2, 9, 1] /. Shift[r] /. u -> u + (I*r)/2), 
    q$[2][r_:0] :> (SeriesData[g, 0, {(Complex[0, Rational[-1, 3]])/u + (Complex[0, -1])*u, 0, (Complex[0, Rational[-1, 3]])/u^3 + 
         (Complex[0, Rational[-4, 3]])/u, 0, (Complex[0, Rational[-2, 3]])/u^5 + (Complex[0, Rational[-4, 3]])/u^3 + (Complex[0, 4])/u, 0, 
        ((Complex[0, Rational[-1, 3]])*(5 + 8*u^2 - 12*u^4 + 75*u^6))/u^7 + ((Complex[0, -8])*\[Zeta]$[3][0])/u}, 0, 8, 1] /. u -> u + (I*r)/2), 
    q$b[2][r_:0] :> (SeriesData[g, 0, {(Complex[0, Rational[1, 3]])/u + Complex[0, 1]*u, 0, (Complex[0, Rational[1, 3]])/u^3 + 
         (Complex[0, Rational[4, 3]])/u, 0, (Complex[0, Rational[2, 3]])/u^5 + (Complex[0, Rational[4, 3]])/u^3 + (Complex[0, -4])/u, 0, 
        ((Complex[0, Rational[1, 3]])*(5 + 8*u^2 - 12*u^4 + 75*u^6))/u^7 + ((Complex[0, 8])*\[Zeta]$[3][0])/u}, 0, 8, 1] /. u -> u + (I*r)/2), 
    (\[ScriptCapitalF]$ | \[ScriptCapitalF]$h)[r_:0] :> (Q0 + g^2*(-(4/3) - 6*I*Q0*\[Eta]$[1][1] + 6*I*Q0*\[Eta]$b[1][-1]) + g^4*(-2 + (8*I + 24*I*Q0)*\[Eta]$[1][1] - 18*Q0*\[Eta]$[2][1] - 
          6*I*Q0*\[Eta]$[3][1] - 36*Q0*\[Eta]$[1, 1][1] + (-8*I - 24*I*Q0)*\[Eta]$b[1][-1] + 36*Q0*\[Eta]$[1][1]*\[Eta]$b[1][-1] - 18*Q0*\[Eta]$b[2][-1] + 
          6*I*Q0*\[Eta]$b[3][-1] - 36*Q0*\[Eta]$b[1, 1][-1]) + g^6*(8 - 8*\[Zeta]$[3][0] + (-20*I - 168*I*Q0)*\[Eta]$[1][1] + (24 + 144*Q0)*\[Eta]$[2][1] + 
          (8*I + 60*I*Q0)*\[Eta]$[3][1] - 36*Q0*\[Eta]$[4][1] - 12*I*Q0*\[Eta]$[5][1] + (48 + 288*Q0)*\[Eta]$[1, 1][1] + 108*I*Q0*\[Eta]$[1, 2][1] - 36*Q0*\[Eta]$[1, 3][1] + 
          108*I*Q0*\[Eta]$[2, 1][1] - 36*Q0*\[Eta]$[3, 1][1] + 216*I*Q0*\[Eta]$[1, 1, 1][1] + (-48 - 288*Q0)*\[Eta]$[1][1]*\[Eta]$b[1][-1] - 
          108*I*Q0*\[Eta]$[2][1]*\[Eta]$b[1][-1] + 36*Q0*\[Eta]$[3][1]*\[Eta]$b[1][-1] - 216*I*Q0*\[Eta]$[1, 1][1]*\[Eta]$b[1][-1] + (24 + 144*Q0)*\[Eta]$b[2][-1] + 
          108*I*Q0*\[Eta]$[1][1]*\[Eta]$b[2][-1] + (-8*I - 24*I*Q0)*\[Eta]$b[3][-1] + 36*Q0*\[Eta]$[1][1]*\[Eta]$b[3][-1] + 12*I*Q0*\[Eta]$b[5][-1] + 
          (48 + 288*Q0)*\[Eta]$b[1, 1][-1] + 216*I*Q0*\[Eta]$[1][1]*\[Eta]$b[1, 1][-1] + \[Eta]$b[1][-1]*(20*I + 168*I*Q0 - 36*I*Q0*\[Eta]$b[2][-1] - 36*Q0*\[Eta]$b[3][-1] - 
            72*I*Q0*\[Eta]$b[1, 1][-1])) /. u -> u + (I*r)/2 /. Shift[r]),
h$h[r_:0]:>(((Sqrt[2]*g^2)/u^2 + (g^4*(4 + u^2*(9 - 12*\[Zeta]$[1][0])))/
  (Sqrt[2]*u^4) + (g^6*(40 + u^2*(72 - 96*\[Zeta]$[1][0]) + 
    3*u^4*(-51 - 8*\[Zeta]$[1][0] + 48*\[Zeta]$[1][0]^2 + 48*\[Zeta]$[3][0])))/
  (4*Sqrt[2]*u^6) + (g^8*(224 - 120*u^2*(-3 + 4*\[Zeta]$[1][0]) + 
    12*u^4*(-51 - 8*\[Zeta]$[1][0] + 48*\[Zeta]$[1][0]^2 + 
      64*\[Zeta]$[3][0]) - 3*u^6*(-747 + 336*\[Zeta]$[1][0]^2 + 
      192*\[Zeta]$[1][0]^3 - 48*\[Zeta]$[3][0] + 4*\[Zeta]$[1][0]*
       (-73 + 144*\[Zeta]$[3][0]) + 640*\[Zeta]$[5][0])))/(8*Sqrt[2]*u^8))/.Shift[r]/.u->u+(I r)/2),
 OverBar[\[Alpha]] :> (\[Alpha] /. weak /. mconj), 
    \[Alpha] :> SeriesData[g, 0, {108*Sqrt[3] + (108*I)*\[Eta]0$b[2][-1] - (36*I)*Sqrt[3]*\[Eta]0$b[3][-1] + (18*I)*\[Eta]0$b[4][-1], 0, 
       -3456*Sqrt[3] - 2592*Sqrt[3]*\[Zeta]$[1][0] + (1296*I)*Sqrt[3]*\[Eta]0$[1][1] + (-1296*I - (2592*I)*\[Zeta]$[1][0])*\[Eta]0$b[2][-1] - 
        1296*\[Eta]0$[1][1]*\[Eta]0$b[2][-1] + ((72*I)*(9*I + Sqrt[3]) + (864*I)*Sqrt[3]*\[Zeta]$[1][0])*\[Eta]0$b[3][-1] + 432*Sqrt[3]*\[Eta]0$[1][1]*\[Eta]0$b[3][-1] + 
        (72*(7*I + 3*Sqrt[3]) - (432*I)*\[Zeta]$[1][0])*\[Eta]0$b[4][-1] - 216*\[Eta]0$[1][1]*\[Eta]0$b[4][-1] + 
        \[Eta]0$b[1][-1]*((-1296*I)*Sqrt[3] + 1296*\[Eta]0$b[2][-1] - 432*Sqrt[3]*\[Eta]0$b[3][-1] + 216*\[Eta]0$b[4][-1]) + (-108 - (204*I)*Sqrt[3])*\[Eta]0$b[5][-1] + 
        (72*I)*\[Eta]0$b[6][-1] - 1296*\[Eta]0$b[1, 2][-1] + 432*Sqrt[3]*\[Eta]0$b[1, 3][-1] - 216*\[Eta]0$b[1, 4][-1], 0, 
       76464*Sqrt[3] + 93312*Sqrt[3]*\[Zeta]$[1][0] + 31104*Sqrt[3]*\[Zeta]$[1][0]^2 + 7776*Sqrt[3]*\[Zeta]$[3][0] + 
        ((-46656*I)*Sqrt[3] - (31104*I)*Sqrt[3]*\[Zeta]$[1][0])*\[Eta]0$[1][1] - 7776*Sqrt[3]*\[Eta]0$[1][1]^2 - (5184*I)*\[Eta]0$[2][1] + 
        (1296*I)*Sqrt[3]*\[Eta]0$[3][1] + (20736 + 31104*\[Zeta]$[1][0])*\[Eta]0$[1][1]*\[Eta]0$b[2][-1] - (7776*I)*\[Eta]0$[1][1]^2*\[Eta]0$b[2][-1] + 
        1728*Sqrt[3]*\[Eta]0$[2][1]*\[Eta]0$b[2][-1] - 1296*\[Eta]0$[3][1]*\[Eta]0$b[2][-1] - 432*(9*I + 2*Sqrt[3])*\[Eta]0$b[2][-1]^2 + 
        (-2592*(3*I + Sqrt[3]) - 10368*Sqrt[3]*\[Zeta]$[1][0])*\[Eta]0$[1][1]*\[Eta]0$b[3][-1] + (2592*I)*Sqrt[3]*\[Eta]0$[1][1]^2*\[Eta]0$b[3][-1] - 
        1728*\[Eta]0$[2][1]*\[Eta]0$b[3][-1] + 432*Sqrt[3]*\[Eta]0$[3][1]*\[Eta]0$b[3][-1] - 216*Sqrt[3]*\[Eta]0$b[3][-1]^2 + 
        \[Eta]0$b[1][-1]^2*(-7776*Sqrt[3] - (7776*I)*\[Eta]0$b[2][-1] + (2592*I)*Sqrt[3]*\[Eta]0$b[3][-1] - (1296*I)*\[Eta]0$b[4][-1]) + 
        \[Eta]0$[1][1]*\[Eta]0$b[1][-1]*(15552*Sqrt[3] + (15552*I)*\[Eta]0$b[2][-1] - (5184*I)*Sqrt[3]*\[Eta]0$b[3][-1] + (2592*I)*\[Eta]0$b[4][-1]) + 
        (-432*(7*I + 3*Sqrt[3]) - 5184*(2*I + Sqrt[3])*\[Zeta]$[1][0] + (5184*I)*\[Zeta]$[1][0]^2 + (1296*I)*\[Zeta]$[3][0])*\[Eta]0$b[4][-1] + 
        ((2592*I)*(2*I + Sqrt[3]) + 5184*\[Zeta]$[1][0])*\[Eta]0$[1][1]*\[Eta]0$b[4][-1] - (1296*I)*\[Eta]0$[1][1]^2*\[Eta]0$b[4][-1] + 
        288*Sqrt[3]*\[Eta]0$[2][1]*\[Eta]0$b[4][-1] - 216*\[Eta]0$[3][1]*\[Eta]0$b[4][-1] + \[Eta]0$b[3][-1]*(144*(72 - (5*I)*Sqrt[3]) + 5184*(3 - I*Sqrt[3])*\[Zeta]$[1][0] - 
          (10368*I)*Sqrt[3]*\[Zeta]$[1][0]^2 - (2592*I)*Sqrt[3]*\[Zeta]$[3][0] + 216*\[Eta]0$b[4][-1]) + 
        \[Eta]0$b[2][-1]*(15552*I + (41472*I)*\[Zeta]$[1][0] + (31104*I)*\[Zeta]$[1][0]^2 + (7776*I)*\[Zeta]$[3][0] + 1728*\[Eta]0$b[3][-1] - 288*Sqrt[3]*\[Eta]0$b[4][-1]) + 
        (-2808 + (432*I)*Sqrt[3] + 288*(9 + (17*I)*Sqrt[3])*\[Zeta]$[1][0])*\[Eta]0$b[5][-1] + 144*(-9*I + 17*Sqrt[3])*\[Eta]0$[1][1]*\[Eta]0$b[5][-1] + 
        (24*(115*I + 57*Sqrt[3]) - (1728*I)*\[Zeta]$[1][0])*\[Eta]0$b[6][-1] - 864*\[Eta]0$[1][1]*\[Eta]0$b[6][-1] + (-540 - (900*I)*Sqrt[3])*\[Eta]0$b[7][-1] + 
        (252*I)*\[Eta]0$b[8][-1] + (20736 + 31104*\[Zeta]$[1][0])*\[Eta]0$b[1, 2][-1] - (15552*I)*\[Eta]0$[1][1]*\[Eta]0$b[1, 2][-1] + 
        (-2592*(3*I + Sqrt[3]) - 10368*Sqrt[3]*\[Zeta]$[1][0])*\[Eta]0$b[1, 3][-1] + (5184*I)*Sqrt[3]*\[Eta]0$[1][1]*\[Eta]0$b[1, 3][-1] + 
        \[Eta]0$b[1][-1]*((46656*I)*Sqrt[3] + (31104*I)*Sqrt[3]*\[Zeta]$[1][0] + (-20736 - 31104*\[Zeta]$[1][0])*\[Eta]0$b[2][-1] + 
          (2592*(3*I + Sqrt[3]) + 10368*Sqrt[3]*\[Zeta]$[1][0])*\[Eta]0$b[3][-1] + (2592*(2 - I*Sqrt[3]) - 5184*\[Zeta]$[1][0])*\[Eta]0$b[4][-1] + 
          144*(9*I - 17*Sqrt[3])*\[Eta]0$b[5][-1] + 864*\[Eta]0$b[6][-1] + (15552*I)*\[Eta]0$b[1, 2][-1] - (5184*I)*Sqrt[3]*\[Eta]0$b[1, 3][-1] + 
          (2592*I)*\[Eta]0$b[1, 4][-1]) + ((2592*I)*(2*I + Sqrt[3]) + 5184*\[Zeta]$[1][0])*\[Eta]0$b[1, 4][-1] - (2592*I)*\[Eta]0$[1][1]*\[Eta]0$b[1, 4][-1] + 
        144*(-9*I + 17*Sqrt[3])*\[Eta]0$b[1, 5][-1] - 864*\[Eta]0$b[1, 6][-1] + 432*(-1 + (6*I)*Sqrt[3])*\[Eta]0$b[2, 3][-1] + 
        144*(-9*I + 2*Sqrt[3])*\[Eta]0$b[2, 4][-1] - 216*\[Eta]0$b[3, 4][-1] - (15552*I)*\[Eta]0$b[1, 1, 2][-1] + (5184*I)*Sqrt[3]*\[Eta]0$b[1, 1, 3][-1] - 
        (2592*I)*\[Eta]0$b[1, 1, 4][-1], 0, -1435968*Sqrt[3] - 1244160*Sqrt[3]*\[Zeta]$[1][0]^2 - 248832*Sqrt[3]*\[Zeta]$[1][0]^3 - 300672*Sqrt[3]*\[Zeta]$[3][0] + 
        \[Zeta]$[1][0]*(-2239488*Sqrt[3] - 186624*Sqrt[3]*\[Zeta]$[3][0]) - 51840*Sqrt[3]*\[Zeta]$[5][0] + (311040*Sqrt[3] + 186624*Sqrt[3]*\[Zeta]$[1][0])*\[Eta]0$[1][1]^2 - 
        (31104*I)*Sqrt[3]*\[Eta]0$[1][1]^3 + (199584*I + (124416*I)*\[Zeta]$[1][0])*\[Eta]0$[2][1] + ((-39744*I)*Sqrt[3] - (31104*I)*Sqrt[3]*\[Zeta]$[1][0])*
         \[Eta]0$[3][1] + \[Eta]0$[1][1]*((1119744*I)*Sqrt[3] + (1244160*I)*Sqrt[3]*\[Zeta]$[1][0] + (373248*I)*Sqrt[3]*\[Zeta]$[1][0]^2 + (93312*I)*Sqrt[3]*\[Zeta]$[3][0] + 
          62208*\[Eta]0$[2][1] - 15552*Sqrt[3]*\[Eta]0$[3][1]) - (15552*I)*\[Eta]0$[4][1] + (2592*I)*Sqrt[3]*\[Eta]0$[5][1] + 
        (155520*I + (186624*I)*\[Zeta]$[1][0])*\[Eta]0$[1][1]^2*\[Eta]0$b[2][-1] + 31104*\[Eta]0$[1][1]^3*\[Eta]0$b[2][-1] + (-31968*Sqrt[3] - 41472*Sqrt[3]*\[Zeta]$[1][0])*
         \[Eta]0$[2][1]*\[Eta]0$b[2][-1] + (13824 + 31104*\[Zeta]$[1][0])*\[Eta]0$[3][1]*\[Eta]0$b[2][-1] + 5184*Sqrt[3]*\[Eta]0$[4][1]*\[Eta]0$b[2][-1] - 
        2592*\[Eta]0$[5][1]*\[Eta]0$b[2][-1] + (432*(180*I + 37*Sqrt[3]) + 10368*(9*I + 2*Sqrt[3])*\[Zeta]$[1][0])*\[Eta]0$b[2][-1]^2 + 
        5184*(9 - (2*I)*Sqrt[3])*\[Eta]0$[1][1]*\[Eta]0$b[2][-1]^2 + (5184*(9 - (5*I)*Sqrt[3]) - (62208*I)*Sqrt[3]*\[Zeta]$[1][0])*\[Eta]0$[1][1]^2*\[Eta]0$b[3][-1] - 
        10368*Sqrt[3]*\[Eta]0$[1][1]^3*\[Eta]0$b[3][-1] + (864*(17 + (12*I)*Sqrt[3]) + 41472*\[Zeta]$[1][0])*\[Eta]0$[2][1]*\[Eta]0$b[3][-1] + 
        (-288*(27*I + Sqrt[3]) - 10368*Sqrt[3]*\[Zeta]$[1][0])*\[Eta]0$[3][1]*\[Eta]0$b[3][-1] - 5184*\[Eta]0$[4][1]*\[Eta]0$b[3][-1] + 
        864*Sqrt[3]*\[Eta]0$[5][1]*\[Eta]0$b[3][-1] + (-720*(9*I + 7*Sqrt[3]) + 5184*Sqrt[3]*\[Zeta]$[1][0])*\[Eta]0$b[3][-1]^2 - 
        (2592*I)*Sqrt[3]*\[Eta]0$[1][1]*\[Eta]0$b[3][-1]^2 + \[Eta]0$[1][1]^2*\[Eta]0$b[1][-1]*((93312*I)*Sqrt[3] - 93312*\[Eta]0$b[2][-1] + 31104*Sqrt[3]*\[Eta]0$b[3][-1] - 
          15552*\[Eta]0$b[4][-1]) + \[Eta]0$b[1][-1]^3*((31104*I)*Sqrt[3] - 31104*\[Eta]0$b[2][-1] + 10368*Sqrt[3]*\[Eta]0$b[3][-1] - 5184*\[Eta]0$b[4][-1]) + 
        \[Eta]0$[1][1]*\[Eta]0$b[3][-1]*(3456*(45*I + 7*Sqrt[3]) + 20736*(9*I + 5*Sqrt[3])*\[Zeta]$[1][0] + 124416*Sqrt[3]*\[Zeta]$[1][0]^2 + 31104*Sqrt[3]*\[Zeta]$[3][0] - 
          (20736*I)*\[Eta]0$[2][1] + (5184*I)*Sqrt[3]*\[Eta]0$[3][1] + (2592*I)*\[Eta]0$b[4][-1]) + \[Eta]0$[3][1]*\[Eta]0$b[1][-1]*
         (15552*Sqrt[3] + (15552*I)*\[Eta]0$b[2][-1] - (5184*I)*Sqrt[3]*\[Eta]0$b[3][-1] + (2592*I)*\[Eta]0$b[4][-1]) + 
        (720*(23*I + 6*Sqrt[3]) + 20736*(5*I + 3*Sqrt[3])*\[Zeta]$[1][0]^2 - (41472*I)*\[Zeta]$[1][0]^3 + 
          \[Zeta]$[1][0]*(5184*(21*I + 10*Sqrt[3]) - (31104*I)*\[Zeta]$[3][0]) + 432*(79*I + 36*Sqrt[3])*\[Zeta]$[3][0] - (8640*I)*\[Zeta]$[5][0])*\[Eta]0$b[4][-1] + 
        (-5184*(5*I + 3*Sqrt[3]) + (31104*I)*\[Zeta]$[1][0])*\[Eta]0$[1][1]^2*\[Eta]0$b[4][-1] + 5184*\[Eta]0$[1][1]^3*\[Eta]0$b[4][-1] + 
        (144*(-72*I + 43*Sqrt[3]) - 6912*Sqrt[3]*\[Zeta]$[1][0])*\[Eta]0$[2][1]*\[Eta]0$b[4][-1] + 
        \[Eta]0$[1][1]*(2592*(21 - (10*I)*Sqrt[3]) + 20736*(5 - (3*I)*Sqrt[3])*\[Zeta]$[1][0] - 62208*\[Zeta]$[1][0]^2 - 15552*\[Zeta]$[3][0] + 
          (3456*I)*Sqrt[3]*\[Eta]0$[2][1] - (2592*I)*\[Eta]0$[3][1])*\[Eta]0$b[4][-1] + (288*(-22 + (9*I)*Sqrt[3]) + 5184*\[Zeta]$[1][0])*\[Eta]0$[3][1]*\[Eta]0$b[4][-1] + 
        864*Sqrt[3]*\[Eta]0$[4][1]*\[Eta]0$b[4][-1] - 432*\[Eta]0$[5][1]*\[Eta]0$b[4][-1] - 432*(3*I + Sqrt[3])*\[Eta]0$b[4][-1]^2 + 
        \[Eta]0$[1][1]*\[Eta]0$b[1][-1]^2*((-93312*I)*Sqrt[3] + 93312*\[Eta]0$b[2][-1] - 31104*Sqrt[3]*\[Eta]0$b[3][-1] + 15552*\[Eta]0$b[4][-1]) + 
        \[Eta]0$[1][1]*\[Eta]0$b[2][-1]*(-285120 - 622080*\[Zeta]$[1][0] - 373248*\[Zeta]$[1][0]^2 - 93312*\[Zeta]$[3][0] + (20736*I)*Sqrt[3]*\[Eta]0$[2][1] - 
          (15552*I)*\[Eta]0$[3][1] + (20736*I)*\[Eta]0$b[3][-1] - (3456*I)*Sqrt[3]*\[Eta]0$b[4][-1]) + \[Eta]0$[2][1]*\[Eta]0$b[1][-1]*
         (-62208 - (20736*I)*Sqrt[3]*\[Eta]0$b[2][-1] + (20736*I)*\[Eta]0$b[3][-1] - (3456*I)*Sqrt[3]*\[Eta]0$b[4][-1]) + 
        (6048*(2 + I*Sqrt[3]) + 576*(99 - (52*I)*Sqrt[3])*\[Zeta]$[1][0] + 3456*(-9 - (17*I)*Sqrt[3])*\[Zeta]$[1][0]^2 + 288*(-27 - (56*I)*Sqrt[3])*\[Zeta]$[3][0])*
         \[Eta]0$b[5][-1] + (-288*(99*I + 52*Sqrt[3]) - 3456*(-9*I + 17*Sqrt[3])*\[Zeta]$[1][0])*\[Eta]0$[1][1]*\[Eta]0$b[5][-1] + 
        864*(9 + (17*I)*Sqrt[3])*\[Eta]0$[1][1]^2*\[Eta]0$b[5][-1] + 576*(-17 + (3*I)*Sqrt[3])*\[Eta]0$[2][1]*\[Eta]0$b[5][-1] + 
        144*(-9*I + 17*Sqrt[3])*\[Eta]0$[3][1]*\[Eta]0$b[5][-1] + (24*(-953*I + 33*Sqrt[3]) - 576*(103*I + 57*Sqrt[3])*\[Zeta]$[1][0] + (20736*I)*\[Zeta]$[1][0]^2 + 
          (5616*I)*\[Zeta]$[3][0])*\[Eta]0$b[6][-1] + (288*(-103 + (57*I)*Sqrt[3]) + 20736*\[Zeta]$[1][0])*\[Eta]0$[1][1]*\[Eta]0$b[6][-1] - 
        (5184*I)*\[Eta]0$[1][1]^2*\[Eta]0$b[6][-1] + 1152*Sqrt[3]*\[Eta]0$[2][1]*\[Eta]0$b[6][-1] - 864*\[Eta]0$[3][1]*\[Eta]0$b[6][-1] + 
        (-20304 - (400*I)*Sqrt[3] + 4320*(3 + (5*I)*Sqrt[3])*\[Zeta]$[1][0])*\[Eta]0$b[7][-1] + 2160*(-3*I + 5*Sqrt[3])*\[Eta]0$[1][1]*\[Eta]0$b[7][-1] + 
        (144*(111*I + 47*Sqrt[3]) - (6048*I)*\[Zeta]$[1][0])*\[Eta]0$b[8][-1] - 3024*\[Eta]0$[1][1]*\[Eta]0$b[8][-1] + 48*(-36 - (77*I)*Sqrt[3])*\[Eta]0$b[9][-1] + 
        (864*I)*\[Eta]0$b[10][-1] + (-222912 - 622080*\[Zeta]$[1][0] - 373248*\[Zeta]$[1][0]^2 - 93312*\[Zeta]$[3][0])*\[Eta]0$b[1, 2][-1] + 
        (311040*I + (373248*I)*\[Zeta]$[1][0])*\[Eta]0$[1][1]*\[Eta]0$b[1, 2][-1] + 93312*\[Eta]0$[1][1]^2*\[Eta]0$b[1, 2][-1] + 
        (20736*I)*Sqrt[3]*\[Eta]0$[2][1]*\[Eta]0$b[1, 2][-1] - (15552*I)*\[Eta]0$[3][1]*\[Eta]0$b[1, 2][-1] + 
        (8640*(18*I + Sqrt[3]) + 20736*(9*I + 5*Sqrt[3])*\[Zeta]$[1][0] + 124416*Sqrt[3]*\[Zeta]$[1][0]^2 + 31104*Sqrt[3]*\[Zeta]$[3][0])*\[Eta]0$b[1, 3][-1] + 
        (10368*(9 - (5*I)*Sqrt[3]) - (124416*I)*Sqrt[3]*\[Zeta]$[1][0])*\[Eta]0$[1][1]*\[Eta]0$b[1, 3][-1] - 31104*Sqrt[3]*\[Eta]0$[1][1]^2*\[Eta]0$b[1, 3][-1] - 
        (20736*I)*\[Eta]0$[2][1]*\[Eta]0$b[1, 3][-1] + (5184*I)*Sqrt[3]*\[Eta]0$[3][1]*\[Eta]0$b[1, 3][-1] + \[Eta]0$[1][1]*\[Eta]0$b[1][-1]*
         (-622080*Sqrt[3] - 373248*Sqrt[3]*\[Zeta]$[1][0] + (-311040*I - (373248*I)*\[Zeta]$[1][0])*\[Eta]0$b[2][-1] + 
          ((10368*I)*(9*I + 5*Sqrt[3]) + (124416*I)*Sqrt[3]*\[Zeta]$[1][0])*\[Eta]0$b[3][-1] + (10368*(5*I + 3*Sqrt[3]) - (62208*I)*\[Zeta]$[1][0])*\[Eta]0$b[4][-1] + 
          1728*(-9 - (17*I)*Sqrt[3])*\[Eta]0$b[5][-1] + (10368*I)*\[Eta]0$b[6][-1] - 186624*\[Eta]0$b[1, 2][-1] + 62208*Sqrt[3]*\[Eta]0$b[1, 3][-1] - 
          31104*\[Eta]0$b[1, 4][-1]) + \[Eta]0$b[3][-1]*(288*(-387 + (118*I)*Sqrt[3]) + (20736*I)*(9*I + 5*Sqrt[3])*\[Zeta]$[1][0]^2 + 
          (82944*I)*Sqrt[3]*\[Zeta]$[1][0]^3 + 1728*(-27 + (10*I)*Sqrt[3])*\[Zeta]$[3][0] + \[Zeta]$[1][0]*((6912*I)*(45*I + 7*Sqrt[3]) + 
            (62208*I)*Sqrt[3]*\[Zeta]$[3][0]) + (17280*I)*Sqrt[3]*\[Zeta]$[5][0] + (288*(22 - (9*I)*Sqrt[3]) - 5184*\[Zeta]$[1][0])*\[Eta]0$b[4][-1] + 
          144*(9*I - 17*Sqrt[3])*\[Eta]0$b[5][-1] + 864*\[Eta]0$b[6][-1] + (2592*I)*\[Eta]0$b[1, 4][-1]) + 
        (2592*(39 - (14*I)*Sqrt[3]) + 20736*(5 - (3*I)*Sqrt[3])*\[Zeta]$[1][0] - 62208*\[Zeta]$[1][0]^2 - 15552*\[Zeta]$[3][0])*\[Eta]0$b[1, 4][-1] + 
        (-10368*(5*I + 3*Sqrt[3]) + (62208*I)*\[Zeta]$[1][0])*\[Eta]0$[1][1]*\[Eta]0$b[1, 4][-1] + 15552*\[Eta]0$[1][1]^2*\[Eta]0$b[1, 4][-1] + 
        (3456*I)*Sqrt[3]*\[Eta]0$[2][1]*\[Eta]0$b[1, 4][-1] - (2592*I)*\[Eta]0$[3][1]*\[Eta]0$b[1, 4][-1] + 
        \[Eta]0$b[1][-1]^2*(311040*Sqrt[3] + 186624*Sqrt[3]*\[Zeta]$[1][0] + (155520*I + (186624*I)*\[Zeta]$[1][0])*\[Eta]0$b[2][-1] + 
          (5184*(9 - (5*I)*Sqrt[3]) - (62208*I)*Sqrt[3]*\[Zeta]$[1][0])*\[Eta]0$b[3][-1] + (-5184*(5*I + 3*Sqrt[3]) + (31104*I)*\[Zeta]$[1][0])*\[Eta]0$b[4][-1] + 
          864*(9 + (17*I)*Sqrt[3])*\[Eta]0$b[5][-1] - (5184*I)*\[Eta]0$b[6][-1] + 93312*\[Eta]0$b[1, 2][-1] - 31104*Sqrt[3]*\[Eta]0$b[1, 3][-1] + 
          15552*\[Eta]0$b[1, 4][-1]) + \[Eta]0$b[2][-1]*(-222048*I - (622080*I)*\[Zeta]$[1][0]^2 - (248832*I)*\[Zeta]$[1][0]^3 + 
          \[Zeta]$[1][0]*(-570240*I - (186624*I)*\[Zeta]$[3][0]) - (139968*I)*\[Zeta]$[3][0] - (51840*I)*\[Zeta]$[5][0] + (864*(19 - (12*I)*Sqrt[3]) - 41472*\[Zeta]$[1][0])*
           \[Eta]0$b[3][-1] + (144*(72*I - 43*Sqrt[3]) + 6912*Sqrt[3]*\[Zeta]$[1][0])*\[Eta]0$b[4][-1] + 576*(17 - (3*I)*Sqrt[3])*\[Eta]0$b[5][-1] - 
          1152*Sqrt[3]*\[Eta]0$b[6][-1] + (20736*I)*\[Eta]0$b[1, 3][-1] - (3456*I)*Sqrt[3]*\[Eta]0$b[1, 4][-1]) + 
        (-288*(99*I + 52*Sqrt[3]) - 3456*(-9*I + 17*Sqrt[3])*\[Zeta]$[1][0])*\[Eta]0$b[1, 5][-1] + 1728*(9 + (17*I)*Sqrt[3])*\[Eta]0$[1][1]*\[Eta]0$b[1, 5][-1] + 
        (288*(-103 + (48*I)*Sqrt[3]) + 20736*\[Zeta]$[1][0])*\[Eta]0$b[1, 6][-1] - (10368*I)*\[Eta]0$[1][1]*\[Eta]0$b[1, 6][-1] + 
        2160*(-3*I + 5*Sqrt[3])*\[Eta]0$b[1, 7][-1] - 3024*\[Eta]0$b[1, 8][-1] + (864*(19 - (18*I)*Sqrt[3]) + 10368*(1 - (6*I)*Sqrt[3])*\[Zeta]$[1][0])*
         \[Eta]0$b[2, 3][-1] - 5184*(I + 6*Sqrt[3])*\[Eta]0$[1][1]*\[Eta]0$b[2, 3][-1] + (-144*(252*I + 101*Sqrt[3]) - 3456*(-9*I + 2*Sqrt[3])*\[Zeta]$[1][0])*
         \[Eta]0$b[2, 4][-1] + 1728*(9 + (2*I)*Sqrt[3])*\[Eta]0$[1][1]*\[Eta]0$b[2, 4][-1] + 288*(2 + (57*I)*Sqrt[3])*\[Eta]0$b[2, 5][-1] + 
        576*(-9*I + 2*Sqrt[3])*\[Eta]0$b[2, 6][-1] + (2016*(2 + (3*I)*Sqrt[3]) + 5184*\[Zeta]$[1][0])*\[Eta]0$b[3, 4][-1] - (2592*I)*\[Eta]0$[1][1]*\[Eta]0$b[3, 4][-1] + 
        144*(-9*I + 11*Sqrt[3])*\[Eta]0$b[3, 5][-1] - 864*\[Eta]0$b[3, 6][-1] + 432*\[Eta]0$b[4, 5][-1] + (311040*I + (373248*I)*\[Zeta]$[1][0])*\[Eta]0$b[1, 1, 2][-1] + 
        186624*\[Eta]0$[1][1]*\[Eta]0$b[1, 1, 2][-1] + (10368*(9 - (5*I)*Sqrt[3]) - (124416*I)*Sqrt[3]*\[Zeta]$[1][0])*\[Eta]0$b[1, 1, 3][-1] - 
        62208*Sqrt[3]*\[Eta]0$[1][1]*\[Eta]0$b[1, 1, 3][-1] + \[Eta]0$b[1][-1]*((-1119744*I)*Sqrt[3] - (1244160*I)*Sqrt[3]*\[Zeta]$[1][0] - 
          (373248*I)*Sqrt[3]*\[Zeta]$[1][0]^2 - (93312*I)*Sqrt[3]*\[Zeta]$[3][0] + (5184*I)*(9*I + 2*Sqrt[3])*\[Eta]0$b[2][-1]^2 + (2592*I)*Sqrt[3]*\[Eta]0$b[3][-1]^2 + 
          \[Eta]0$b[3][-1]*(-3456*(45*I + 7*Sqrt[3]) - 20736*(9*I + 5*Sqrt[3])*\[Zeta]$[1][0] - 124416*Sqrt[3]*\[Zeta]$[1][0]^2 - 31104*Sqrt[3]*\[Zeta]$[3][0] - 
            (2592*I)*\[Eta]0$b[4][-1]) + (2592*(-21 + (10*I)*Sqrt[3]) + (20736*I)*(5*I + 3*Sqrt[3])*\[Zeta]$[1][0] + 62208*\[Zeta]$[1][0]^2 + 15552*\[Zeta]$[3][0])*
           \[Eta]0$b[4][-1] + \[Eta]0$b[2][-1]*(285120 + 622080*\[Zeta]$[1][0] + 373248*\[Zeta]$[1][0]^2 + 93312*\[Zeta]$[3][0] - (20736*I)*\[Eta]0$b[3][-1] + 
            (3456*I)*Sqrt[3]*\[Eta]0$b[4][-1]) + (288*(99*I + 52*Sqrt[3]) + 3456*(-9*I + 17*Sqrt[3])*\[Zeta]$[1][0])*\[Eta]0$b[5][-1] + 
          (288*(103 - (57*I)*Sqrt[3]) - 20736*\[Zeta]$[1][0])*\[Eta]0$b[6][-1] - 2160*(-3*I + 5*Sqrt[3])*\[Eta]0$b[7][-1] + 3024*\[Eta]0$b[8][-1] + 
          (-311040*I - (373248*I)*\[Zeta]$[1][0])*\[Eta]0$b[1, 2][-1] + ((10368*I)*(9*I + 5*Sqrt[3]) + (124416*I)*Sqrt[3]*\[Zeta]$[1][0])*\[Eta]0$b[1, 3][-1] + 
          (10368*(5*I + 3*Sqrt[3]) - (62208*I)*\[Zeta]$[1][0])*\[Eta]0$b[1, 4][-1] + 1728*(-9 - (17*I)*Sqrt[3])*\[Eta]0$b[1, 5][-1] + (10368*I)*\[Eta]0$b[1, 6][-1] + 
          5184*(I + 6*Sqrt[3])*\[Eta]0$b[2, 3][-1] + 1728*(-9 - (2*I)*Sqrt[3])*\[Eta]0$b[2, 4][-1] + (2592*I)*\[Eta]0$b[3, 4][-1] - 186624*\[Eta]0$b[1, 1, 2][-1] + 
          62208*Sqrt[3]*\[Eta]0$b[1, 1, 3][-1] - 31104*\[Eta]0$b[1, 1, 4][-1]) + (-10368*(5*I + 3*Sqrt[3]) + (62208*I)*\[Zeta]$[1][0])*\[Eta]0$b[1, 1, 4][-1] + 
        31104*\[Eta]0$[1][1]*\[Eta]0$b[1, 1, 4][-1] + 1728*(9 + (17*I)*Sqrt[3])*\[Eta]0$b[1, 1, 5][-1] - (10368*I)*\[Eta]0$b[1, 1, 6][-1] + 
        10368*(9 - (2*I)*Sqrt[3])*\[Eta]0$b[1, 2, 2][-1] - 5184*(I + 6*Sqrt[3])*\[Eta]0$b[1, 2, 3][-1] + 1728*(9 + (2*I)*Sqrt[3])*\[Eta]0$b[1, 2, 4][-1] - 
        (5184*I)*Sqrt[3]*\[Eta]0$b[1, 3, 3][-1] - (2592*I)*\[Eta]0$b[1, 3, 4][-1] + 93312*\[Eta]0$b[2, 1, 2][-1] - 10368*(2*I + 3*Sqrt[3])*\[Eta]0$b[2, 1, 3][-1] + 
        1728*(9 + (2*I)*Sqrt[3])*\[Eta]0$b[2, 1, 4][-1] - (2592*I)*\[Eta]0$b[3, 1, 4][-1] + 186624*\[Eta]0$b[1, 1, 1, 2][-1] - 
        62208*Sqrt[3]*\[Eta]0$b[1, 1, 1, 3][-1] + 31104*\[Eta]0$b[1, 1, 1, 4][-1]}, 8, 15, 1], 
    Hr1 -> Uncompress["1:eJztvX+s5dd1F3p+3DP3zownntoxcWJIxsjF0waUgZeW5JHCDUkbV0obD4XX5D1IJw12OHqmGeoiGgHRpQUrEooItJVqfnVkVOGqoDFp9J5D89Srlz4lrYI6FS12aAnTgh\
3Xbuzx7x/zI8/nXM/53u/ea+39WWuvtb/fc+/hD0spc79nr7XXj8/6uW/+4Y//pTsPDAaDuw+9+p8fuONHp3fc/d6P/NhH7h6++j8/Nn31P4M712f/32uv/uf907t/7M7R1f91+11/++6d/zV59T9/efo37\
9j1P2//+N+540fvnH3k7vGr/zl54pbp7H9Mv/nq/2s+OPvE9K7ZbwTfGbf+xXcS/2L+P2cfes/H/+bpu+748flRp0/OPt8+xHS8+OuNV//zlz7yY9OP/8hH7to5zgj+8k+/+uU5U/72nKod0mYf/Kv/64n/\
5S/+2Vfpm/3d/KvkBxmO7Tpx+19EB/imhrQxQtotrTNjX06zYsyxon2vB2HuX3a71yez97qGEYML6XUKfhcI6cFdxPzwjpS2ZclSSoca2upJaZsXY44XWjEdK85YIKZtataSN8sY5dm/p4zyT2e50gd5v4u\
645pG2U/cf1dh8SobZT9pvy5LjLlR9kMOpJBWNcp+0MFESp2Nsh92IMWUMco7UHotcZ958HwlttOfyarAbTA5j7kx6rQTeH6sew04MZAbQRM7fQ3M/Utu9/qYFXjGhfRGBb8LhNTCTsNS6ocmTKRUZadxMV\
1zu1lSTK3AM2GUT2e50gd5/wx1xzWNsp+4n+sKPPdB2m/MEmNulP2QAymkVY2yH3QwkVJno+yHHUgxNc1ovKlF87FD0cl2/m/Nr69f/fXvfA1wD3I6gpH6ICprL5Zz+zWWIr924RWGs9G/PP/8q/8yxydI5\
m+/ArJCFbXljij1c6m73hV6eZDS5ub0gSH4YyqnKlMBXsSa8za+QxGx+wGDU2MH7hRBBoBxuE01yMjpLpc5z3r8fcd0zNy2mFgp2GDXtFIsamP+/XDx74msE+4MOCE47sqj4Mdmp/OIVR6OJJn/hgcy3GXX\
3SOVJCN+t+ZtHtenjZJEPIcScYQ4VNtW6W6zwdUKr/eUedA64bjYjgZugY/YjhssbfdtWWIOqEQiVnBHuT46aRMxiohY/KmYEubYMH0GmGoXeNdJKMMPncVqpLbCzT6MUdKYLQpm9FJGU56Ui8vnH597PwG\
Ze0GAU97WlFndSnfKH+fJTPka3BlAxLed617Ml8Bxvyr0wyMRLuXqYucMwlggYmjiozyZApnG80IqMrV5IVWwYp4X6kTh+5AZ4tL05Q4UjsP7Ga7mtRCraYRaWJRHM3Cq7nk0v+47uzwaTGBV79WUlVwQmY\
X3ymdI8nrDVs/yEA5JGM4CCVHABhsqCwaSYY5F3bgoY9ibGAa0sElOwClDi/skQxRQ3gk/EZ3xXxK/+e+sKhXJrnr6PG+37w2YQPwRZAOfs+IPlg1sU3NAJbOdhiCjmIrF34pJ2QtokGOIzh516qA5UlQtL\
I0jbrewzNMKwUGgVIMAOHcSoaHQGQch0b+EWn2WKiVj0MIC17lXqYo6vVyQAJ65VK/pAOx7/RtDDYtxq/JybEEdA+C5pO6pALhiI4k4LqyKySTlryVDY57Frd7iMEnpKu8ZM3MzOz/5qQ7Dwq8oWFa5R8Qv\
KnwwmxTT9YhUTUyRQaFRj0j3ySmTiNCqQ6RqgooMCK06RDqV0JSL5LIzTQRbViBeMvFNuVBbVnUq2yknmycz74a7jcHaR+h5MqIv8zQW/SFVO8rzgUAT9uTJFMi083CBNumiMp/mSZeyuSG/UU3nlItBd0j\
3owz28WdeA7HeEG16CtbUuv0Zdumpvsw5WfRnVJ1gyacd8rLr3J8hHuiq2oZOBhkG/RnMkat2mZtEERYdGlWbyMkgAZT4JBXwpgbqVBOD+yya6voWxQFqN3L4jXWRKTuLRo5OY4VRTMXibyt3lPUBuHHscG\
4rc5vrSrVx7CCXAwkCgiMRnR3zg6+3LnybuPC2Np+CReK8WwJ+M5sHmmsAK73clZ9Hr9wvwNscGJhpTeX8KMz9Czjxc0nF7/W8IL9nJKTHFPwuEFKLzl9YSg0wpKeUqiJoXEyP4me0EFMJwmSM8vwYhFHez\
HKlD/K+Td1xTaPsJ+7bFk3QvkbZT9qPZYkxN8p+yIEU0qpG2Q86mEips1H2ww6kmFoZ5StxD/T918QofusIkG0MfruVQptecxntwPnVqiXFG+GR861nrIb2ti97BmB4UhjzYUgq9F/GtxsM/OgC582RZ1ZR\
JtCvCVVg+seoGqvWDEPitLXmQHuRew9F4dsH4TUGacMUee3ST4k9QPoRf3UU/fX0vCJ9A3rty1Y25UxPCk0V+6A3X5ZCGddWjuDHZqfziBqODSNdqpvMbGyye8yQZMQ5V4knRMdjod4FlAivhXoNwlWUXjp\
bqEd0jZeHj0LbfSpLjK5ZOlZwR7nePjBA2oNVpoqLZ1D6DNIeu6B2QeXFql26kdoKNztjs1u7dKcymvKkXIQ8/7i042UvCHDK25oyq1vpTvnjPJnBtWszF+/S3Hf7yz3PXMDxuKo3D48yLJqhYTU26DMEoo\
Em9smTmZJXhoi/PooPVTVDowo9chKBKg+enMlQ0W75WaIsjkEDNHNwOKruZ/CZ1zusVhAqV1HO6+VyF1mY82qsY39zXqciFvfBG+maq2H0ZOGN8tmMvFY4N1fPQL8ouILNkAUDyZDEotpalN3rTbxh0VoNp\
/cs7pMMJ0B5RyzsOeI3P2PVC7CQFOpVTPo8F+xXHE4g/ggyd4KKutADncpTo+uZ7jSkGMVULP7WaspjqbAexxCdPerUQXOkqBo/5n9JNH588Nm4iA+lDoLfXo70yWMT1FxAzS9LlT7BypDJ8AZ+CeoGQrwP\
a8jrf+Kh7enaE80psVA97oslFS7WK/azNZG2PXhmiOrdK1WD4HcRLUx+QfBcevdUEFyx8UMcG1bFZZJy1ZIhMs9iVG+xmKTUlPegmYmTnZ881WFoeFRh8yr3dPhFhmeyc1q6no6qySkyMDTq6eg+QWUSFVp\
1dFRNUpFBoVVHR6cSmnKRXIZm/nGDou+SiW/KhdqyqlPZTjnZPJnBbS7HJEoXCYm+TKJY9HNU7e7Og/wmpMmTmZJXhohLxKH+nmnSdeknbpY2rWLQq9H9mIB9rJjXKDazr01BHdAIOeoBFMnUPxd/XzdYBl\
Fvl6Tqy3SSRadG1bmTfPIhrxXOnRriMayqzeNkqGHQqcEcuWpvuEksYdGrUbX1mwwVQIlPA0hUsalTTQzus2gWq7s1eH0YxiITdxYtHZ1GFaOYisXfVu4t6wMk5Njh3GDmNo1l1dAx+/c7f/SB1u1ufy/R0\
PE/r0gbOqZb90QMyH2CZMKZ32ObScbMb6evkFjsSLxjxlzrRQOJhpe/vxgfK2CRSB3Yy6CTqPkCUXi2u2LO1rUVDw+cmbNIm5LMae2f5CFuRPr/VJi4kHTCThPiwxxAM5ItjPF2pWAWB2zngM2T6OXG5zXZ\
IAIahTabPZYYAvrXgwe44t/TxPxyc8Si6+AA4oQ9Z+MhWEtRSxpzB2QsjrQppinspLbh4i9gvif+6elLFrDuAHiACXEAl4RPeMAnQKRXzTYFB2xeEqiXdOcQF2AoOdMwAuXgOg0VWD0LvekKYsf88tZDJdG\
EWsaY07QfPHcRqDTQrLqMXPLMGkVEFlQOr/75zs+3yw6n3izjDcMI2FgYcIz58iyQ89ht1bzv5p89Zb48fzhO+GWHFkfmdDUfZUiIn1KHsrKynhKOGOfs+j/lTn19ucDstF20D3AAPoCh52ZxThw+LHNcFn\
vO4ygtg/uswp2tT3iGO3OPIAx3YhvZdbgjsfA9W8Go6/r8zCC6grrJMc1citJmI4r5J1+K0yHvGiskLZsIYw5gthxRZjOQ1g4iO0GclqGLsLF1s4maoqKgHUMxJhDydyPm7w/C/P0XGvJIGSDOGP3alw/FU\
nr/K144bZ6zNolYfW22Ulp0cxg/i5JioXmfi0UT99Sa6lTaxK+rOEasMaqFKVNfvpQld4MjN2lOmkpPRkDshlPbzB2cJWq294hVueNM2LD1AXDuKHkxRM3pIuzGLN75JoIrZ9BnD0aa5IaHUITh8nGF8pcI\
Fgvmk4IVg3mGJ1QJX4WPLO5NYCoNjPCONRFaoGb/Qd8skDRBNVz8+0MAOdufFiUXhGmKpCzDlTiV99IWq13uF3GlJ2NBhljOiIGZ45oQ36BZZ9BUwIUH6O0ZpoxKXFdTqKrhujQ1OqVUOXstooFY1yOU7QH\
ql/Zj+gVLlarhJmD7XOWUUpKuSwoSlXjySbWDdpw7gEBMTTrasRRTkouna5aoZ6jJ5VWRGEL2IY7fftcA2c7Aul4bn6GiT9iQopNhhh+6ukXc39gLGZiJpmivRaEJfBbOG6hqCIEJhK2HhwlkWKmzg7Axt7\
CDM3wBUKIzhnDL5LXEySxaCQhNxJNJmqHkNCvn5hUDotPH4LWGDxoAiCLtacuVGaN0huiWmtrzcJaSsZqSUijt15q0+cU2dhpHVC8yOUpEASdQ/RAF0YAvEuoUUyxb1W6v2OmREEmU9EYVgltYlYs6q/E2O\
tr8g4O7/kFis9WqlrSqJRUn5GylblVo2ruFplTCTixFyRva3/FsKqXnzWdHuB4GuzGZB3zIXB4sv/gglxi0vf49APQZjhW4t70RBTB8cTLYzKGWdYgrnIBgOMSL+X4f/fJiIEPTsg6MlbDJJmJXrX7URtWq\
Po/ymM68RWY4yBnR0cDOiMI2Q8VeqRFlZTeRgRSzKWzrF+ZLVNzHyyWX40hEF3ME35iVS0qXoFsKHhwcGDirXeMXVm4pD3UaZlH8kDErnoCCotMd4icGDIQxqHENCXRmC16LnRlDBtya1WbuDr0GHYdl6U2\
VypS7wpAPcAhswbCa/YZ5Fz0eaJwE7IwNBmDtAbyp89YxEPayRM+OiZe9PfsGRx5gcKTvGGG189ZxtNOSu8btNmQK3G7ZrkYLhHJcwT6Zj1wwhoTm2mWNf3RUTnv/xquDAxYta1TZavZOyfPKloIoUB0FKy\
2cNhzcayCkENEwv7zHljUaVr6bA3ImZ23AuBybIq9VdUxdDO0o5YTdNFx+UelWwPaSuYw8mmblSMEWOJT2S3jtyuaaYmZLNsEl6n7u4smjbBWzcDhsID3AqsU86m/IpK5dXCZowQmrbYz9ykFnc0yiwGK5Q\
3rTIGspDLLYXKid2kKz2isb510bIhFbkrG0lJGWkLsHJtJShlzCiiUZRkulcaoJelkYLhZ0C98BS7qf7zCRdIsEXZGo+909KeogAsszKPlmQTMalpGO98TU7Fr5p0ftcBvIhDiAS+iszS5VS9EFB4Q72Fyy\
Nu0bQfKF8esEwTsE3lnyou3MLkMfkBVdvVfQukX4vQKLIJqsKRVa6Madr6fojKuRgm3r37AY+SnZtl5BXTrQZ41WoYYy1vvjKC2rbevdeb4MCEdrZBbGKny81Aw+F61bt/DcJh14oNlGVPO31mPuV923Tky\
cVdy33irATTeeZ8QpOnUThlmyyPmJZkFhqi1hk4WESWoEReOFVTeGWU3JppM9+VRow+eAR8k6cRPDLviMr62/ozwlgLRA3ohexd3x96fv1Mg6RL3dYnvY3rkE/JxANe+Ulymuo6vPL6nL643uOXZ4gb/Bws\
ZAP9tP+6bk6u9dMscL6ypuFS3v90s8ksv72/RucPQmrepquGv3VZcNd43iS1mczqpRA27z8SufhnPmWVOW54tAYplDrSY4VhMcOXlrYmkJTIA1zq8sV7rXQK2hbPYh6VNWHZ0yvSs19SMNFSEOgDs6OVmxb\
EeMy7/VvVy4A0OtQ+Jyw3DxB8jbGZs/imJsaMmdRM/htzNU2BGBa0ar/OCXHapGtSp4VPZ4hsHiOebLvsV5eyjki7NDKHS8oljpfHr1HWYmdyaw9waxu2oVHxy4VLU96T5yQSocfzxDVQ3RpsIpKdW88ZLJ\
ybCZ7iQbYV2zSEySi/Qs8o5L0r7JwTbW+yaJ3gM9nBxDdJXoJWnk5Ig2s4P7qCTI8VJnDDut0nCk6CwivK7iaeJWnN7QYIkwCeIyvBwNtHaFOSPM4cMG3CxSspHiAAg3dQbrlppKFs45EqSM1aQk7H0tApk\
vk09tELalAH3sgVR1kiuWpqKHKcYk7WltWBxtB7/PvnTyaopy/kcf2E3pdPP/itVy66ahNJFi1X2K9ZmW3zk8e2rhHmABo2JRTS+GaMfAaLDb1Bjw9qfRoNXA9risT6IHNIHtSc1YT45H11z2Mrtw2/IjFd\
r89/3+pJcJwGeRJ4aT6KpWLpntZ36ZyD4YziPMVS3nJwKm9Xl/kmBKOmuy2uAxWN0xW3hhYOR7sLpjBhU89gz0YHOHZlLPYc9AKXjyu/vZHSk3DWQZlBy+hvMK3xf/9PSoGz8GN8md82pKuk9T0hZguGiqs\
q0rVaekNUXvcvliTqPZmmQZsdZNwUk272KGtHG66ykqVzPS+31G+iE0WB58WN6uxvzmPZ4xyRxaC2OS5Z6R9h0CC36MnJF2A7lV92B6PlMSUJvs7XoOJfo9xP3crLnj0OZFEIo5wBUisTLRHEBmVwqnqG9X\
3LPpFLWms0nQOtYSwYlKBJsYaUHeP4DJ2xgUmxnT4d5PE1LqN9w778I2QeR9Ge5tyVPzjGtenqKDfi7+u2Aote6Y6z8cyxmXtvjrHHuSotzTKde1b+ZmLjYE0tDGEJBgWwy5djtMkDdrFkOuceJ5BF3MdOs\
ZZj5o6QcGfB+ADqNY39nJ+HpZjJ3UO7hDSlWVzFYd+6V3mAmExchgW4N06C8WC2mWaLj49z0fbfNdi4AYaaPRtm5XLjBigDqLI4h35dFPnWS33FXAbXomrsJ3tgzLxCR1Dc65qLyExfUIIKxKxEK4qhgj63\
bkXZqOSvM/TnUQeR+GvIsGKlN91jEd87AZlSQXq85NkENkWBgvVcU+xKlhKzeDjlg3l6S5ByNkpU3cDD9Uifq+TpCFzdtShCw1gfjJVAnxwARWX+ECsFJnB6sO05LzYzElOmMINyE9YTTUZzo+9krhdHXMy\
tFAbVOINgSiZ7ev+jVSHABgpc5UVd3uT46OxSGIihLm2D2YHAtH1scR1Yu8ihJz9GBwrHRsPcUUyw6BHsyNhcPrKdIbVQhuYVUwqVQwSaW/mn9wcNc/2L0CLHVrq2pK36spqRRZ2d2HDFuVWsSWvKelllQa\
TSwzaa+/r6PMVKLNls+dhqCpVJwpmcuDn+OoIYDOxmq2/OCa4ViBM9sbyJvhi5PBZg61rEOZYSM+wyFezNlmUpQhSz7K6cVAhqZlHQAtYZNNlKzJfUKBae39x6poS4l6h4OcER0N7IwoPHWqYoHUiLKym8j\
6idkUdo4LcxQq7uPPWBM1Pt2K2OAbs2EM1NLakt75o4xNvGfllPJAp2EVRaZMR4+jsvO8QY6jaH1TW/Bs9hMxfM27LUGaEHYEKnHMOYK8x1OHVipI0mEnXd75jQcaGwRDYwN7Yw+NTd2ijoFwEZ7yX6rVvs\
E3ZnYJDbWkpO8YPbVb1HG00wKyxqU1ZJa7tLtQcbLw/w8rviHzSgvWkLBXuzbvuZGXLYInHm/SsF8YhRWtzVPJB3ur5Hllmx8USGo9/r6J44ZRjQa2CVEN88t7bG2eITxsDsgZnbnF9iuYqlTfAsoKLtigz\
dX38Zp+JY5YiVF4cDgo9Usc7cqKmiJkFZvK0hz9XKuSR9Q6VsHQ10B2gJ1feYTfkBncZh4r2+xX/CWitdlxv+IjjgOX1RBbcEA40+3ixMXwkQNMl0EqnqwwJdNFFxR0xNWOxZbo3zIAb8zC3pKpBtCcsleQ\
rF221Mhq5XO/CmMcJ0ZJTu7NbGiN/FS/0K0YfakjhIVmtdeZzlvJRCK2JBOsKcwrIXcPDK+mcLGEFUsytxqTq5sDKxL0MiwsFnQL3wFLup/vMJF0A99RJup+d0+KemFA2whLyzGEHCEGTG+Dz23x1GPRnmv\
DyI+Nk+tvrWdBtUG1I468VnuuS/dcV8g/ZFxaZNb8wO9841hFYA+XPwzcl03jGWi4EeW8ZRzz/8cMljTDe6wpAZjYiTtnN5A6FFH3O8IpTkSXalKOFZbFAYgHdJkDOG+6bsvgZCGDkqR/0dSdxXqroqk7DY\
PT4UY+GG/4HPAoWeAtWin+kk/HfnjGx9D0yt3EVSzDSnH4XUrnAnFboJrn2yWKC49xWsCB/Ea1vN7oXql/P0omkSIwaddplrYrQKPGi2agxrqKjUUr1v1iYnLFepveDY7epLldDUPZmaxRfCmLL1j1rfhu2\
MDcTDCXnbVxeb6kJHY1B9H3OQjufpvAVwS0UaYYhLichBfO3as1gk0VrHoiJShsSXsiOamw7HuEH0P38x/hNga1toirAMPFHyDvGGx/GqUI2iom0Wj4HQMVKtO2vrlIPgIRyxe5gaXDAHhYP2Sgsm32sAPG\
kCaww3dLG5hqT2obnCFQ+c+AH/DG/460DbfhEBVtt1BlCZukWU+Q7cUfM1CVBLTZXiLJbrNjDUzmJtkIU2GReyNXqFmk1pakR4aDSay3s3ESfmGYyXsGkigryZAl6ZYRg2WpHcSPtvRVL46XOmPYaSGCI0V\
nEeHBnxuIozm9aYDDcJM3DYiIQmdXiJ4z/FGDzlVM0zqA8FJnrjqdzCNIGatJSVj7WgQyXyafNSAsSwH22AMp4CRXLDvCepjQS9K+0IadsG0jS/HitDuAfvbxk1dzhJfiUY/BMD52kNaBCdvCWTanCGfZgK\
rnlg9yEAeb0bDr0J3Nd7TvBeOlw3wH8XObg5Zv69PYR+o+ldMgal0YyO+vQBfAhK2rMvh5FxNlAFOf1bXBLdYVaYMkC8i4mDnrKReTrxz0Qa2GORvRjYtx1CqFu14WF1NVqQavYdTaLsYPblG60AcX44i3L\
JShry6mKuBitcHKxcwjsze1WLF9bZxvGFw3EHcZtMZqdtUes3mGcgbzxcU40f8yeq7Bk+LOHu5L6CaamjvQWI+crF8fi1SJIeWRWDpNipUDtHdK5cVkIo80QGxGDJteRzC9usk+4MAdKbJpW4wTRDaFPvxn\
8JAmYzEIWY/t0zj66+mWZhQQszqXraxOA3F6ZHVYIMf8+0UyD5raHLwozP5uVcxozk/nsVFlaxiZGPYbHiZml03WJbCNgqHpds2SzFb2lRBW1oUYdlsE84lRXN2rKJSRibF1fC6qdsec1X5UdMLxvB0obsJ\
HbP9Ly0BxK0tM8wxjmTnwtGkHB3FhMrbgKsPG8Q2lzyD7swu66ySU4YfOvjWyWMO+DSFKGiNH2YteymjK73IR9/zjc18pIHMvCHDKN5syq1vpTnnvPJkpX4PJxDGUeNe5qn5kS9AIv53Dc273H6lkGlZ1FS\
2hncvGF000lSdTINNa6e0gK6QKd3Iyg6pXTvLh+MVvY7VzXohL8hs4VTSS72fAm9dMtiKizaKdLs9hlWbRhgphw7yRXRZtAFqWqt6oKQC5ICwLb5TPj+Rlnq1z5SEZlC48KA2tUSNj4s6psMWgkFyWL+xNT\
GJQL8YdrolCUCGHpK4rrHoXZQwN3qEMRGwTHjTYvmjeTjDhGKtNC27j/LFIC7ap0Q3SdBqLjGIqFn9r1Z6+VBCQY4jOkDWC24Fn50hRdanM/5LoUtm8EPcTQDmHlMJjcnUMZW7d3Mz2AdSkQN08S5WbMehk\
OY/6fqKcZVFQ2yM5i01UOdpdL6Y5i1cc+MPIGtjL8sAI1c0LZt1vSBR+LO7K84zCx1Z2ZwuVspp2x7mXRRycVsV3gprasiE7x4pZfzEdFZy6dLNstY+coY06q2oQPXVoQWy6uQbzGpz7mHB87WFoSk3PWXS\
sVE2rUZGpUcdKD1JrFmGpVb9K3fQaFZWa9at0KaEp38qliOYfNyhXL5n4pnyvLas6le2Ud86TGdzmcsztdJLt6MncjkknStVO92x00MRCeTJTuCj85WOD0IIxZFJZHVXRQ5vVUZlL86xO2XySgcnnVM83p2\
PQh9KDsQvzQDWvlWAXCp7/at5gcvAiimzvW+LvT68pPyMn5nYZsp5Me1n0qdSd48lmPvJa4d2nIh5ri0yTp7OnwhWDPhVO0FHaehOPWHSqbA4q3igZbvh0qshWWFCHnZRfM/FPZ/wum22ruRhbmyrcxM9ok\
So06WLpMo4ZxVQs/rZyH14fACTHDudmPLfpNqselrmuzLfVfqB1u2duiauvm//8irSHZec9cOIAiU+QTDj2W2z/zJj57fQVEiu86+4Xhp9Xpp4yaLNIpA7sZdBp23xJKjxbvDi5sq0oeKAbY84iUUsy50CL\
9Ic5QByR/mWrRR2L3z4XN6Ixv33hEYdIK7iWrbVILsYcCTYIudzuvCYWROSTkneGhscJRT4Yn1Ms7/AbbU8RB9jQHEDmBJjTDG4yuSLm67evs+dsHEbAyHfEPsFZQnMHZAyQtJ2nqSy1jFMoCw+ggFX1MD1\
rpTM/9taYzukTHpmhEHI+AnKjmm0KDvjAS54HlIEtxFCeGETqdfEK6qHeqKEBSkfCD/1d8hc6zlT+egk0UEsYc5pTT5vxQYfdz9UMv84XLk/Kosnh1T/f+fl2daL9PLE6Ewm/nOn3HMLsxUOPlWLwU+0qK4\
gVNI6oA46swy6/+/PdP4UxEz+lDmVlZT0pHINQOKi9DsypVdA4i3KmPwgf4IjmAFKUc1N0wCWOymLV5OxnDAO+aBbY3OcZ2Jx/qzywmQdDVS/Z0t33bPOlssF0EF1B3ayYZnZGabMRxfzgc3Eu4n5FCZMnM\
3MAs+WTMpuBdIDcGMvKz8OyoqIhy0QqC80cQPWQYY6JjAhOIBGcPjZGuXf/9fDhuTKjYMbtwuuIeOMlLxQ2780wiUd9LbJSFnQDHcdQUgjsItarC4NIr3A/rCk6pQ34uopj7yghogwxJhO+wxy5Gxy5yTZd\
OL1P4Prpsz6N59Nj/5pYMfBhsXrjOU4/RV58ABxqalv2c19H3dKJ58oxFBEsOYM4e3ABvyKqSneGDPtOLyzAiA0LzpM6HgMuhidniQraPx4oaJTfG/G287fEX2LOrUplhPblEbl92brYV/siTTgNF//+EED\
O+c+KkgXCtIONv/oFQpZVGaeskax554DzPP8RQriRa2BEg3VVwnuiKp0M69oPyJtOs6C3Z5gWKnFn8NPfJu5MU4dTShXryZDsys+uxyL+0jMGSaSoh6dfug04TaIJhqHhJYt04k16CUjXFQWJRiLVxZBsMV\
YYH4D5MaJB3aYVHUsRJbm4WbPEPENJLssqjkSi0IdIfXBygCxyYN1qmuZnwItT0Ye5UEUzpd9DLKNeysBMNEUrMApN4LOw1bfIn8PWw8MEMqzU2cGYlZ52cA2iRGcMT6GUXEuc7HoLoYg1EU8eHTAXirl5t\
ewzOYMK/fMW0xMlGtaWPTNm6oxV3BXpqGGzdpQ0JWM1JZylRx2yX/vR4GwbX40jqhfZHS3qiJBWfdQRt9OLhDrFFEszse26qQYWSZT0RhWCW1gVjXpV/W30tvkHB3f9g8TyrFVFaVVRImWqMXtimVqVm0qh\
ypKWm1JpPLEUJW9oO5Ki/RTlphJ93nx2BOhhCByT2US/pmQuD3qPY5YAuNte/x6A9gzHCtzb3sD9DF+cDDZzqGUdzQrnGhgO8WLO2tt9MtDlxUCGpmUdAythUxKFn0bhCxWjmzTKoHH0WPNj5XGeeaPMcJA\
zrKOBnWGF7YiKvVLDyspzIg8pZlPY4i/MkKi4jxdWLsfRiS4OCb4xK6yUblY3FTyUIQYObNcohpWrysOfhlkUP2TMgteAtCVlh/iJAQNhXGpcSQId3ILXpIPTpi7PHTZwXyWpS5Xol7u08P7g7sE1A0mr2T\
2Yd7XjgcbYw07VYGTVHpybOmEdA08NQAYSXTom3nJm70qfbOFI3zGmaies42inBXSN+2zIFLjPsrWKFkjjvB5pgL5uwRgSYmv3KjZb3QrhfeNn4b2KR9/k4OZCBBj1ZAs6/FRmmr1O8ryyDR6K+PyPxN832\
avYvC+UOQBRGFvtVdzFi6K9ioZF7uaAnAVaGzAeyKaee5IQFFU9V1v37CiTFNJcNJZhUlwuGMvIQ2tWilJMKY2P/bJYu9K2pgDakk1wLbqfq3TykFvFLBwbG0gPsCkxHwI0ZFLXLq4HtPMjRssU+5VY5jgx\
SnJyb8b3phHXUhhksblQO7WFZrU3Ls7bM0QitiRTaSkjLSJ3+QfSUoZcwoolmUVL5XSqCXpZYC4WdAvfAUu6n+8wkXSLbF2RqPvdPSnqIALLM8jmcQHV/kA2V5n5MepxAdVyDWHSDu79qJagCw4IPy7gkp9\
p34jycYHJEFULg8cFppuvjw6wFpPiz0RO5DiLuXpaYPctwk8LWATMZDGp0Bo3rns9Red2rC74YnTVYpRAXYoWo6sm5KQWumQxeu/KKjES4HIhcbrjiwDzMOR5nwmVzNerL0av4PkygBtFORbGKnxg1Awqbw\
+iO2BDrf620IFmG1HN+w/H3K+6Gp0YI6u4Gr1Vapt+Cq61328hCrFXItr+LAOXHIs4CZssJEzUvhXrGj4zWHU5GPXqqf3MYD7t2fA5pcmCDfMf/EOYi1wrTOGG+WPrCjnFHLzdhnnUVrlUtDlhaN4BL1M6R\
zed3yWXl3ndc+fwJv0rBnaE2KRPjBcwBzDZpN9m2bqKZUWr9P2yhOQq/Ta9Gxy9yUaZ1chVbMXb1182cjWKL2pxOrOJcHQe2q/+GU6EZ21cni9J576aq8jJbSiye2SugpObJtCV4ABYcxzrY4WbBNSaxqYG\
Vo2VvAzK9W6JGis5STHtChx17qvCnRNqDRJXAoaLP0BerDj2faiYQCvjJFpetCxPhQoBIGa2LA99T6FqIMsCH+FFCZ6seKJC00e9UnWJkYb35ZmAI999eWABIClWj6FRoZmXN3Gs+Do8k4ckNOvw1vpoe9I\
t3oLMNf6shap4oc1cEwWDAISZZJzYxHSSjfCchEkuci1LhS7VuCSdlRyUY71vmujlb6/kGLKneyw5os3s4D6q4HG81BlDmBSPwgxHis4inkJJeZq4FafXLVgiokOZvG5BRDgqu8KcEebwYQNuwpJJKdlIcQ\
CEmzqD1ekIIkHKWE1Kwt7XIpDzy9QDF4RtKUEfy5+8TnLF0lT0MO2YpD2tDYuj7eD32ZdOXk1bzkv5H9hN6fTU78RquX3HUJpIsWoWxdpCy+8cHgs1cQ/ozjpj98BeBz0nmV+lg/EWbhswsD0ua47o2Ulgy\
9GXL6IQ6vglL7N7FOX+f67Qlb9Xlx3BNRBq2dGLBmIPLzsi6oldLjuKMxKGIwXzIbic7wgY2edlR4Kh5qwZawPKcNPGQyZAqg+bNo4PXNYC9GHRhuJBcIe1AKWAyu/uZ3ekXAyQZVByVvrUAKT9ffFPT49q\
+BEYMZj5f4w4gEs1SdvIWc3nBwfcV/PTXzcAIEXz020VrDo/ramvl8sXc5ozrzPjgyo4rpvtkyzjxexz48vXU1Rux8qymp5u2+c9Pj3N4ds4F/guebccY2k+7BnqHPsteaiz5NPTFQEmPT3thp3rbsN0fIE\
koDbZRnYBJfq7iPs5MVDccWjzxqBAXSFSKBPNAWR2pXC++oMWshL7LaJdijmApolK0KXWEsEJJ4LtPMdGPKrPHP7BIXy/BmO/R5+OJcxx7PegFZruy9hvSxaaF1fz5ig66IX476YnLpdrUtEArMbYpE32Os\
ejpAvu6fzrA9lFxhsCkVAk+d3GXzsdRiCtWfv2DcZf4yT1iLusti1/4ClUfZpmcOuU7LKNMsBznpcMwIPznGcsOCwkT2r5jw9AJVPVS7P10H5pdMicogFFkzkK2YBiLBTSlNJw8e97PoZXfzkD4BDMxvA6X\
fzAiAbrmIQogqrCMOSp3kDL5/ZY5FcnUy+3Q/AMnonj8p3Bw9JISZn6lGuPj4mbwMftTObYNeN2nS4LYOQh3eWB50appBVDnma9UlQNRAWSSB857Ilj00FJLm4PQi5aCkR4ZWs5Itg8RloUejprd5bo9BfE\
fmmaezBqV9jszvBDVWXo7aTdM5AMmJlA/GSqbH5gArcHoPXwMIEMK3V2sO7QMTVnF1OiM4an0Dt5gijxWDxsUTRm90rhFHrMytFAbVNiVgbjqb3Wr5HiAAArdaaq6qMF5IhdHIKoKOHsfA8m7ILR/nFE9SL\
Po8UcPRiwKxzvTzHFtL0hMoLV5SEc8k+R3qhCcAurYtHV73VQLEql45p/cHDXP9i9Ui24yVUlaVVJyibkxFK1KjPtgzJTKmUnlpg0wtjXEW0qqWfL507D3VTaz5TM5cHqiw9yqUFjNVt+IM9wrMCV7Q2Uz/\
DFyWAzh1rWodhwYoHhEC/mbJlln4zSejGQoWlZB3BL2GQTkf8CkfztfYMMGu2rOkiUSHg4yBnW0cDOsG6+DOI2FQukhpWV50TWUcymsHVfmA9RcX96RoePd/54vVyP5uuTUOtrS/r2INQy79apMJAfyr+BW\
uA8qygyZToKP+z+vEUTCopAjStEoCtb8JV0ZdqU5O2KcT5pS0OGnSpBz7mYvC8Nb3Av7ekXutXxQGXdUCBuYMnsgbipw9Ux8NQAZCDlGVXLnYNvzCweGthJSd8xp2qHq+Nop6VxjbNsyCx3lnDAYoEsmnDR\
y98tWEMCau3ixIfHXrYoHtFk/uGf0rBfGN8VLU5UyQd7q+R5ZQs5FEE5tTjxYHxOsdyfGoMHIBrYV4sTd/GiaHGiIWRsDsgZorkV9yvYqsyBHN7u7SeN+pWmYiVG4dXhENgvTbUrL2uKmlVsKkuq9HMDTh5\
l61gFw2ED2QHWs+VRf0NmcJt5/GyzYfPzRC6/6obN/0EcwKXLJkxIoA1k1cBhcEB4w6YLNpAjVWLD5sUraJRisGGT+XK8d5P5h6osl0zoOKy62rGZFiRHI07mNEAbzV5BsiTbTlwbbRLvV22P48Qoycm9mX\
atkQjrF2QWQzp12LHQrPY623mHnEjElmQIOAWkReQu//xvCmxLWLEko78xuaoBtDJBL0PCYkG38B2wpPv5DhNJN/AdZaLud/ekqBdGyY2wtBxDhCwGEUfwPeeq3HY2ShbsOVe13Emj5JI959Ui5/ZpVnvOc\
9FYcMlFe84rZB8yJh7NNFmEi4MXs8bKEthvD0DaDNyXTe8caLgR5Tw3JvhvsFoY3mNOCcDETtw5u4EUt26MBGP685ziRHRZPJNODNsRj3EyB3DedN6WwclCBiWVhKJhQosNYdvRDTM/RjVnahicDjfywXjD\
55SuC1bK34aXnbiuGUSV4HcVniIY/aMDhTnAYMJBMVrjQI5rdkirlgcGGrWEZ08tnH1+5VxeKxoyJZgGfpOWSADoqmeB9SHW7+OQUOMjM0BiXcXGov37fhEvuX+/Te8GR2+yBWc1wTVwNWOj+KIWXzAbMEc\
zVn65/HDAPGv38nxJQoLV8IYcteyR4Q1OcpogWgTa0dUEBuEyJ0eFqwnUusamHVZNmxLMt6RNm5xUWDZmbl/u3DOFCyvU2iKuKAwXf4A8c3H+s7CvvU/sHhz36qmeTtU21rloAwBIDfbqgaVJ4UUJ3rmwiP\
GK3rlQlb7tYRC8Vs8EBvmu1QPLCEmhgh+6UPnz0O+hD0J0pOkAuMC35qnKvaGVkW3Nk7QhCvLY+EsXqmKHNo9NlA9sluKBaeokG2EqTPKO1M47i7TiknT/cKCN9bNpope/BYhjyJ7uA+KINrOD+NGWvp7H8\
VJnDDstwnCk6CziKfRWbiCO5vTgBQ7CTR68IGIZnV2JeSl48aJzFbvixEuduep0kJEgZawmJWHtaxHIeWXqzQvCspRgj+VPSCe5Ytrr1r/0YpL2tDYsjraD3mdfOnk1PTn/o1/dTel06xeei4uk5y5YNIpO\
B2+/JP4OBQihgLyhaPR4TNGtl/PNqcHfbJ++JP6bre9gk/gT5m/SaZWHY/p+DZYqA90mplinh+ED9CRXF6dfmPO+n8gEfKsBE2cTitABqFTESHMAmInJ7RKjq1JEmrKk4BIDBn9QFZPFdWoBvlVpjr3gnkA\
9EyU36waC22h/ddkbJ2UvOV1DLDx6GpY9C7YRBY5rfGVP461t21NUhSENOAh4TXjIu315LcMEMvQCmNHfgKn7nnJRZr4M77ZQSYWMwa8Z0uRWGrg2TeQNpm8uZ+OuwfDMAS4SB6ihWpSRZSzCfUrFtdQLWA\
Cp92IPFfEzGcd9AhDfQDRgdPofCFJu0ZAiNGD0abZvZr/UhDqQMTkzqW9MmiMy8GMeZLOAcWGMz1yKOpx29Yo65BNE2+EWRPAinP1GO+eCDbfeIy1yPgFyrMwSvhaM3eOz24KIlJ0DDjbK1CXcEhhcxIi5T\
tS6zZnoKPdVEIghOuLxUfyTnzpcflfw4px/bxXZ5dyttpmOaOrQtW9YAZbMeW8/Gt/o6d8xy1NlUCphPnfJcrRvKrhq75wJURP8KHyAt/tLJedv0GIHVX5T1VI1shrmp+LI7hE4SfEOzaFzAsvYzzlUytrP\
6ebj6OGbMfhC+L347cH70d/eesohIx364e52ejmsLmnoikf/GRo+P47V7GaNxGbNE3OAj8UETr/kX4vg5P2s596Vo4/L967cP64toUrb0zyxGxwtWXuAB+s/PYzl5MiwXFDPHwUFlajiWka5nKC+pu0tJk4\
feAA1op9xYZFABFVYJ8ciRgTXVSJI7CT+BkyeQcc3Ul2Ck6L/lJDSt5Wfkfm1M2+wwoUXIjPH/EMXlWPkaUMgT9FBHyY86/0vlgN/Qlx/Fwaj36fgXjpkP8jxSCjP1XBXUp4v5TIUhzhyJyly4Qmkt8Zf1j\
UVhCmCI+ABVOkAab4CPUxHxRQKYE83770UGdbBT7wg3fc3HXz/KyYNW1s/dUWMJTe/6Ml4CDcuPtBOWs/+zwq1emtkRQ4Q3zC0ItlSYaBA1RtXwgM+Gx2QtdV96W6Ybr+r9qEd8oM3g3jmSRcxZH6M6j2qY\
vEfHXYiSfMab007xlZhkALGuf8Rm/nt3684bP+cR6wWXslDy+f8w0sh+hVvJe6cput1Gros/U6FpMUuiFeGcuaIRYhyYLBdHeWw5U0m2GisyeGUOMIFyj9K5NCudxFH5gCqZJCBH2j6oERJvnqdkfADqo95\
ZHRZadR0e6GPDJ2Kf1m3XpD1+R53LbRFMAw0PMyEuVek+ZKodP59+H2215ffHvPlpixTC+CWGx2OlC9c6cTCEA0LeA37hZ5bHebYW18AxcYgCOOuOwZC1kYmS7ybRZHWVZiT/rVYxD1qKIRtI95DZ854sPy\
MO62TwnDJt0EvdxgGl2INtwD/8S1DFi1Tp9Fas1XvUbqUMFFxEa4ElsXPDSxNE8FW/ZNEEEu2+lD+mUWO0Y4DQRjHummmS3t+staqyOngK+M4mP7qSNzekrTMRIIVTx8YsJ+31rEXO3MZbVXj58b5ZFQUK3\
TTXJO1uCNO5NL3jPbqW1jXZpKgXqjDiT8CB4gZAMLuMzSoYgoMMD6r+LJSqthsdUqqmHPDcb8qySy/XqXsF/R1QWyaa4nQShGS2k8rpcOF8NPNZuML2eSbwBLYv6KkwoXM6eC8op/Ez6TXA0PGIMYRCG/dN\
Yy3XwnaGBRXBzdrWDQytMcA5VLM8IN1MMmbhZ+tsLjZmRiVYP4sYDsiv3pYa48QBH27hilCaOLRRNb+95YZ1/uqiJM6NVsqBCcJIVAVmXNpR1byzRK28KoAqk9StSoAS6WiJSWXijKJfZF+ku0fRH304JMH\
dQqIfb2V06i6hSK+yv90AD01n3VhVYK5hz9u9aWtX2flpcnRQyINFyYNRVpXRoCztv+mTmBJRAvXEzTRZ2yvltIhFtW7eGgLWM0ygir9ML1tEPGfgEEMef+PBVaOZ0ZZiOvZnlqS/IKV6rb4+4HzVbYMKbb\
d101LwE/GX0uwiICGYhYRE/74M2caPa6XloDX+JrEthetMzS6hEWHs+a53hq3UB7OChtcNIeZjpRpAsMP1qgknRcx90ZsjWEoedmvS6X6Bhl7lwZ3wf4rggbVQpTQzqDb6q3aCzB/yMgva85tenr+XNw1aP\
IUBrw/xgXIyqWSaHq5F1b4c+VGf6c3u0RQdM7u9EYBSFbdXdjsEx0A+jG9SQN8xrqKlRuoYbNIh594DkIDksn45uNHH68I++CyIvVqj6aq52A9inIN1xloUbwNX6DGBzQHUJqq0VUFMEkonIV73tcNmFx/l\
5xKUgkmxoHdpwmT8iWDGK4EW7XtXAU5lMQGEQVHfy9GTqePlUsZgUQIB8AcSrORK+1G5oyyzCnE9EEqa9dGAq88s5JRgMG6pVwwyqc2dr/PgJW+bSsOsed6gW5ZvM42L5wqTdbca+pypEQ6A4cHFq4T7oan\
dO6w4gBpnZuzUmXU8Iy8BcoP9xwxlOhCvxhPOVIymyRIU7KWvJOkHSTawyfEN2jq6vbJD959Ee2Tny0gypmKsFoTr5FxTl1DtmwcXfbw6j0rO+bh7RQWHfPwHqyedMwTwWAvOuYfVSyXKZYvVazJUABHN5V\
655VasPPHBladu+gj8sYHQmb7brmkraaLv7zzRuDKtq8cQtl94lrx2Bnzpc9OQpEwbC+b9War2qtYNI8ukNEASLA9C51esXqFUvRWzcK38rfEpoAnIDj0Kwg31+vEnoVrINkzSbEHjmf+NHHvBm/I4W8IVt\
kVFhlvl0hCv1fId1JBZtOUi8uIFA5Dg2oJCIbg0PUuZnhD5taooUyNA9uZWcpdK2NVpLCgAaipjT8Mo+EE3CmCSoMtTraC4mKdUiDVzcGV2yzmNL7TZvaWbPNr9Vb7dLB+SpqfeZP/UimKMZqxQUuozlwD/\
EynX6w687TKt+5yoDv9oDYMSZxGqJynBKWKgR6mKwTpO8Vcbnen23cSC2lm42JSCGWTAzCP9hl2+/YZQkeYde55vPkJN0Y59mQ/ow7BpdY0me4n6pc/AN+PRf0yDrcFAuJiQEmTkJQnuPHCrfG6+puSOSYy\
QjrhhJSAurE5+N+JeFLznpDFDVPP9jHnfqeGwaHzOKvI/KNFFZcEAiMBZs3UxGt0DHmq9pKwzeJFFS/1AVDa2Ov6qF+qGBVMzx3OEaFqoeb8KbqgQOUyUIMRm6xfWZNUiGzyL66IH1L7xQfA5UDpjgQ0B27\
SkYAyr78dCUQKxo9hnAxq0jEloqVqRqAGUq8hvkHT2P41v1YEnfi7tyI8C9wYFgq51rhKhErXEgrDLqdtfsyvwUGvVYwADFGx4UCSwcS0iHNHCwZBHoIGx3QAmJiDIqa2mJNZjJ3Ci6moV6I1c1BAb78u+w\
MvlF+Pv9xX/RwpjgUwWGcAl3a3+VhPM7z72SK0mi363k1JqpdupCMn7vtmv2EDjFgcrhPoFEuUSWO0Ic3ihmfihJKjFFg0Zei1c5jw4ngvdenO4RQ/VaCk1Kj7AfUZvEZJ12ETGBoYdIuWteCXukmGd6OB2\
tASuA7vR1PN6IdqiJo1D1yX4qfOSsNtW07grsysXfExawVYDu4E9yuVNubFlCljtZAx5+xhz02KdJ08dLpzPiZnYXSV5pfQ1qdrbiPDB40oGKbhMcrPlfm15adK3ZbZ0iwESBuguK4cD35stup6NzlrETkN\
SNabGw6hu74bFQbWiuc4RZzRGQ44hjDxK58Q0tRIMIVYihtRLeKiose8RooDlMzLNf/q4K5/9cM7/2Iu5RI+X3ilc4zaXLUTAxtrqmNgsgy62snqtxdntZNV3BpoK9zbkXAzDPgUcQMmGav9tLBVsyYtAmP\
wwtZYipoMpq2P2d/bXGM+Nw2ItnzudNVrTOaGnsx049Fqr1JY56tVK4YMy+IDXAOjsTisli6JWhzxyMYgp8RJ+6NeS5cY4WsCa1PhY8hbbWTCbN7e2cjEiF2T+7D19Pu7AYFhdkEQlGI2Q0QPuxMYvnjB+v\
1dfo+ZPbp623WYzdC6J4tDDLOdzCtDRA8rRzFfgvK0sdvpsqzE1ONLYwuFICxVzSnFNi9j1WlBKkVwgWKk86RRZ0dvUxJbZy6jKYlbL8vheZyb6QM8H0Yy0ViM9g/mBYMMc9PSgeIUiwyFr3Gyz1AU1V4dM\
xSKHnqtLBJVfy9ZZKiFH9qslLBQaox3wmKuW0KLSMh3Py0i0WlUIoXp+0WDZ6/8BRG71stfxLxvUhfuvGdo8n0zBzNCr8+xiRix8BPRLpt1F3+a3QFRWUx8F32yUMY0T2jsbpNS5LvimRBZ3dvTbvR3Ggma\
ov6xjQIpc5alDfJWjqpAd6QMrOqSAOdToDYU6X75BOKM+zOfoGIEHOEmW06HV38/3XI6uioiPkbV4m3AXdPUUtLH5aRPj30+DgAGHwbCsKwHEB8sqbHw0xv/nYhovk0jqNn6DGQtd/54XXMAWFPgsJ+Iyob\
xlxi6DFITO90FSsnKJ9N1knVbJFnTN8BMeUu5ZHF2H+1x6UmeEVbQ2+Lv2yzrfaSLXI6t5zn3TfDS/xrBxDcaMJHor/463HPwimPextjDjwoMoQr2hLhrTf4NNHdjyyp4A57fAFPzwIdpnqIAqqQ4xtnz/q\
2sZ/hS4GiTkrQHNtszHJO4g+CmktDk4UFkpn4Nvm2LBAdRXDkMH8A3PISBye3o1Mbn4u9Pv1VDA5slUky5jTQHUMfYjNA65mWfd9N1OIq3YnvaPy/Cdhvu2zRETOLz+DVE9MMeeEiLARs5l+3RJsEKoCbFN\
r4qphbVL/QSTCD4cbWKSxmYTNSxDLTJh91MyKsqHyb3vES6iYJA9LlN0k0PyftJYJR6OSbFJ8/HiNdooQhlkjUdPIneya4CqIbTDCH5eEOnInAy5VZCdK7X3GS2CcYy5LNHykTy5xKsry8a6Ovc/iulKB+D\
qTzV9EJJztzCT8GWnkImmh0RpSk5HZ9Po9pqUY2erVkvTadZAp+abSx5255KdRR4nbTtQTnglxxqoibT5FCBe1NI0lIMUc0/KDHYwe8m3T7hxf4A9mIWAXEsygKP0ZNq3rlRgdOxqOZplNEq77WQO3neC17\
3ZoAMsr6ks9RVmoFqADdcKMh66g5gwPQbhOz+R4uRQnQ3nCrGFcazcPa5zCGEAkGeLZFIWEvdKGFR8QeGTF5NPxkdYAIfoEJ0R02xai5jp/+c/sMxJ2HwGnZDRjSHoa5gD1cgCbM4ik+8l+CjBBgm/cI7Ym\
BYd5868Zw4/qJj2RSzwCJgdQnUxZW1yGLHHhO8Jkrnd/vyWmioIAMviHEIMMNQZwBxmC/DdUeVVMgY/JoJOZBiI5xzWo+/P31zLKlyi3AWPACBNroCbJxFuE+puJZ6AQsgAR91QBHizXzKQoiq4LaVDxCk3\
KIhRYO0YhNwM/ulCUMq86VTaChtaEyaI3LQYx6lSktRHK9QONpGCW71Wrj8bm+NktpTeyuAKjejzj1pmi5YKUzeL1yPtJhrmplij3YJlQKWDXn8nl80iDYF+4okbCFgwPSgVXMEG0IZ8oERyNGC8WJZJLJZ\
EYtuX4+V5vSlYsVTFvrXYG2wKPTPcZrQpPtaL6WM5It7rIzkzGA6mQFrIpXk/p6BgSaiGQAVeBHKBpzkrpGOoLgF50jrRcbSjDu+e9Yg484FmVEe3huhynwo1a+rysPPFxRoArLi1LcKadRLfTMeWsAKzh2\
j8bYBOGa+TGa+jdzNjvtkPpsvveoCjgdRJ2URcMxKF6Wtaw2ZKYGat4+F/HWtnOQCKYYKSfm9wR3grwzbv0KgldgC/NQVUZEKX4dlkH2Yn87B3lDLZthv+Ew6fEItcVk7JGGEb6GYEB3xwiHVbTraNFIk/a\
q/MG29kUqwLpy8Ubj11OJGSbG0ihjzfDmYYgQxr3OKU4+IOUcMRKKozcalczI8YPwiGG7KO6rgl/mfCqVwJB7d/BroOq6zEEO0Kks1v040B5CK4ZuudCJJmoWhplEsYaGIMTzmtlQtPNCX88sN08iR/KAt9\
orDE0FBrMxypb48g4QeKK2IXBW60ZNb5v3zKYFFoObo/Z+1aI8r8f6qO6vp/cuEqiPvb8jVEu8/bypBHPKTLmLI/NiLseep4/0fVTzuaeH9FQGbqfffXz6M+TXlUHlBCV4PgSSZCrqZ1DbS3wuogPqiJFk7\
PzLSn9BWdyQz5tr9G/wYuYveIDNGdY45R8tsLbvjvNiZSxXvE7Af6RoUpQOa1roGLUMVjbuGQiXp8tkTaVwq80xL9XaJVVzd6QMkVtEyfHMmlpsSSgvLXT/P6SGTFpbbt9sIEcqynEZjlfJW+pAJI95KEGY\
yOHwEPECVwBE9TJmtMh0Fn27eeyl+oOInXsi3j4Z/8/2vmExIz3sYclFtwHjfNgbLEDtuSO9FiD2ryHh4b/hdTseB8CPyKy/BACRvjT0xkUrGpcgvR7FrJMXW38JipMoh1BMj7z6ERppsvPZvExnYql5b9a\
C0l9fuqrfdN3qQeTcSQmy/euIIDnzyoLy5+7MTC5izkzTQeG26H94ytC8z3X4VdtJ0rwAAzQpdEqAI+qkcmx76rZx23mkHvCAWYUTnefhy7E8/dbjcn55HZyt+IBYLn53aoY9Fh9koc64K3Q38LjwC+MeIQ\
7/bjqtFlf1oLClwIin1UaEvSDHj98GYf/hRgrVvryCwhLEmmhGZQ39LRwJLjB3fBB/6HR4Cy1nR2U9YbfmA11GaGT9IxONlZN4mT4a2dXPs3mqaVUPmAFSvkEoNc0xUx+asyCdvAB4rNZOi4AaIeIXgNXOo\
pxQORLnTJLg8C96fGIC8px4L/Xq576Ts+Rvjn2IOZf9Y6MhJxotegLCoKxa9AKF5YK10CFnHZ3ha2KKUPhv3RqPoPJmBKLRirenm46g9Glw2yp8sfnvwfvS3t452glprpRhKi5ITQC4/+KFYzh7TbPQJE6w\
jUP8/Rgj6OzVsk0E1TprjZ3s1F8B8/ejj7Aohtg57f0lyUyV/2gBk/vyMNACZbg9AQflxQlA0TwWZYHZKbJlzf8mgXyWodyoNF3PAmrun8pielaLUDTGU1ewGZb68q0fUFH6r2FT2hrxJu9nF+ghaxyo4U2\
nRjzaLCEsBbENmcJtI4/y5G+NDnXiq/L7PHwWNECGGlp1FmYxNy0NNb/8AqhKfGSpOCKW6jj2lEj/HVBcnd+s69doosEQqlQsD1BcrMxh9ryjP54BHSXgVJ1ym34D5/FK5aTPd0Prx+PvTt2lkHUMPbxBHi\
xzud8UhWsXdGGgUd6PizrnpucPletOQSd06R+ZjqEx+G3HsD2lkMrBPhOLeAovu9ykOkCnSH1SxMU4D9qJBg3xLtU3vIY5eIquyC++UtAG2z79qA0RvetUG2K82wEZv2yq14Iw8S9QM9i5YM4mP52dHeBgT\
pxDffRFNnc/GO6QqFe/z6CQdKM30iMUh6Va6WmjIalA2hWNL/9ZxVVht2osRZ8ptMzmmHGOIqDl0yHw5Px8bpH7yfBEBlrdG9uQAfHYD6VrtT3QBNqv9iVIxXO1PtBsQL0OI4wFj4NMIEX1OQ3VZ2sDGBXG\
h0DSn5zCKMJN5DFk8qtgV5otSWZFUcH1ZFlbbY11LLjYPc3SG3GbIxQTRqviCb3HxiwGa7VlWMQCIdRuOSbAuXGf4mWFs7yxar1fvT0mQx5K9P8UcDlbTW+Nfnb6uXOgSxksBl6oV5uu+SpU0Ns14ogCPcm\
4Lbcqq9HwuDAHNxABzrUcU/W4RKcudGWXFzgYVGD8MYo8WdfTv8Tfj7DnGELGMT8vl+UL9LiW0xEdmf79z+NYemOngK0SF7qsjcT96MrlBpPPwJKlK0lFXEkv/mcto+evWy3IjH9cBe2Pk20Iz4oQufdHoP\
mKLLFaT2lvmLFa8/Jj5h5WzWDF+9RM2Nh5WQFTYg1aCqPD91oWoc+URWi9iT3dPrVfaZa4mq68eINNENtGwkTlev4ZZOIrZKYS04HT5QCUHG1kPrri8ZUn6JxnCepnk3Xb6VCVHCmvf8h72GoCUrb8Qrdif\
nnlcQV62WcISHrb/vSpnO7jPU86FBxwTB4SforlRc8BcnpEVtgREZnERugvuDNFqbPHyaRyL+SOXhpVhw8vN9Q8zYe71NQNEbK/bZRWHEVL5yWEsITQNrze4PaLvigiQmAOomsfLzQsXan3BvzWGsiXEIjh\
8N9gL/kWrMvuy9Z6IuuuI36CpM5gV5i77iAPfsLzuF8x+mbMc0lk+5qT/xmA+0jfcME8OUQb1cTj0a1s+JfR8PUCXbbxN0HwFptki3oa3PFntkvOIt3EqLCIUYPRMF0MvyUOBo5jeICILjHHDJeHg53Dxxe\
taXBn8jZciWYRGcQS2mnMhKGQui9+kNZvBr6yBtzmfI5NlPbkvRW31zD90aTZhhGoU6wLgl+EmCoPlvzjfXGYj5H6ZaMvAU7J+25JV7fRKqWrK1CKpihfPXUN8w82em7YPXST8v2P70LPAZWGYHyWwppVa4\
+QpfVdoxzQBIR3rpHDNiCrfmkDIFm8nKt4SmQAce5XNiCWl96HcwtADOlFCGwcMVHzeJhIByBgKsq47TUncT8J+w6VWo2kTALjBupy0GKPdJxb3OhMigBLW2GngNyq3ZfnNpYDfrqs5tGmQuRKLm6aUTczO\
+FtlHargb+c8fx/wt0F7VBkAN3Dq0O3qpl6XCIC7TilpBUqXroUROOUuLWwXAVNxW9CbdG0R2PZLdJJg2yKxC6MWi/T0rHXdrTmqDG4b1BRV1UO/1igYb5u0vX0CI0XcGtWIwpEUsURv5rNwIvC/VKgnu8Y\
E5j0PH+7R9C7WaDU9C1/3M31vjiA6uYmNjgx1qtYPDC25ugoZg/kuqDgH+IMwsJztPtQoFfb11iyXQPbLRSu+yv90AD01P23GCj9zD3/c6ktbv87Ky2TxJUik4S1QhiLdHDEgNhkvwusl2m+bOa+S6Ed7Dn\
M4uBv3+vhXLeaPdvqV66YVbhuENAfduCmGvcdAdIi8hjMIt89qwS07D8bXM32rARMb/etvumEI8uhpgkcEDBTziHht5ikYJGmSUxWnseD3zVQJh1Bj18x5oUxFdPcYXhIBncV6zHRROjxoYXDVHJw6UiYAH\
ENYw6Iorq3ejK7Y28zQ8FGChj38ZjQn1o2hp0QEN27ekpJPz1eeXtbsKWK9ahIFw7MM/98wZrZKoizUTvDs4zmLZPxyPvvISYrl046wU/abhp9V1k00SIfF9vcLahwv11W87PRRK46UDY6UpGE9+ng9tIpr\
4Q0EH1xwgdjKMwcuykwZLKRP2BzF7e4c64DmWFqLP/s/7Qq4yi0+fCNmshYKO7qIyIr3pc4luAKJFSGSlGevoFD0ZQPnQmDhdoyYOkBPwjY4Ir5ECMwdBhJbFLaNNAcoshbsCGCSy7BdeNkIhpiGbVc6CNs\
CZuftQnTqC2+OBfb0sXJWFg00f6mQlRynVGljihRCABlSLAYFty+D2MxK+RFesqGOTbKAcv3vU5CiMPbn1wtE1yKsmDeTCZMFsO2smiyYQxaVM2BOvxTLjPN2O+CLxBoR7/DiyQILPAdjoYOEaD9vb9nnvN\
RZdrjPw0KrZxqKkKLLIcUw35GUmRZmSFlL3krSR6xeiL2aNO7nC7Hj+LYXFm9XC7GoYINu0zBpjA/GULMGHCRYJOOrN+7EI59owozyOwZs5BT7Ua837pJiZ5mP813/yBo1pzAZZJtAWzm2rV4AghRk77wAl\
BQtXc4LTkWbDA7dk9siIdEl8XjRcPEHNwIEbw6fR7HVuQvilV8JlNZmsuFQwmxduaopn81UoO/qacIu4MkDwtMyByhIjrLXQSSlZsLFXwhbaJ3U83/Ml5ub9OLPwvOR/Jmk+ANH/L8Rf3n6PeU8wzv/qry2\
ibrZaq9tklBhLXWj8SZ/KuHK0GUw9EbtrMZj/AqDMNR4seYy5s8YZG1+WDtxfWchdxjOgIjdfYO1k/vTifFSYs89w4Fny2WRgwKuDzTIbA53RNcFNhrhh47t+4KKDF8hxhJ+kMCgWQgXO7Msh9D9qfId5bK\
kegrHEmwz19DXglSh7V6g6TvXU6oBeypipH56yEJdUBOoqsNLVQM9TI+Q4XTz3kvRzQx+4gVpQG0VOmNBctgg4fromL8RgddJ+RmRmd/JGBE2d5qieM884wwa1GTVh6jdEyN0DBUWtfs4kBaIiIsJJS1UUq\
DOox73o/H3bUboUG2tO0JHSOlEJaWbaFfEjxMMPlyTwf3YiEE1CN4LR7Dv1DAs9L0nC4TEbGaJ/UZEs6rYNM4dABISfaCU8QjrKja+FImOn+efnnguu9dQNanEud3VjuZWDbQzi9YgK6IeN9Lc+GpRs4w5e\
3xRMydbqm6L1bbm1bbmpFTp+qb398pmjpdshJDk5ZLsbeaI1iFeok6F10w1Oz0iAUJ3DA/jYxVPrRK8nCMHXVIIfpK04qQfrowjxQEQXuoM2/K+FjnWE93pJvVkV9xIR8+yr1PXdd2mvUyXO9V1nY/pO97X\
W6mSDFXBEOagPdwnlKRdh0bgvmGD1s8EldARqFaFUh/KsXS0+I+ROO3vZSVJNuvM+v7e8pBkqM6vwF3gKrAHmYJGRm25MlaLGXPQHrbrJGnXSYRvP0QIa37qyjcz9IyuSp+pZYY7C64lTr1ergu4A6TYpkk\
CwmxeWWZjhqr0cKlt0LiM9m5HutdiehrAbW6Ilmp+Ns8anfHodJAxT1RaiBcn2SlKzI5z8sQtO+NS8z/61d2ETbf+t8OxCJ64NrwXVf+j0ctF081/Mha3LmZ+JzDNW5dvIFNlwl/FXhgKTposID4cn/XniG\
/Q4vm9g3IdJUYl1+EDqBwpdHOLX0YqnHFamTnv54gr/R2DjCRcgay28pDVytYIdRvsigS3aLfT190SPXCXv8q/2YvuuRF4XkpyLAKDJnNdXfoa2EZJX3KY48ZY+r4BS9+HDNhGdCfjlawNzQE0/hrrtXF91\
E0DDwJeEz6y/ZhWirr3aXjtiUVCUSY6cn8Rpu5HykWZ+bJvRUvGYP5Rz5Q/Ys5LoJvp71tUJc+qWkj1GRYDBM9ZhA9H7NDg+jK9gAXwCat5PYg382p+TnwD0YCzKP+BIOUWDSlCA0afZv4Iai7YgYzJqVfq\
G5PmiAz8mIfZLGbNtwM1J2xi9fiElEOD4xUNO3KrVmge8BqQ/UY7G0PNpyeyUL3M2AT9FYm4SUIEp2W6mmlpoKrLyCVAvOg+fVdAE8KTJoI1BZMUEXEQwhDxe8P4UO1wRXeb8At9dxNc+bkKU+ZwIzPxFrE\
uutVgouDQ8KZl6knJt2kOrULDhJ3NYnq0CklhZFWuL0w2jqJY51/BRbOv1BDYeJ4D77VVNU4bCCwRQd4EH/rLHuEbY2bnkExqZplzw8b3N0flcrsd/dj0l2G5/T+7kVs8HaUCFhq5Fdux6WOoLf78OPr+9G\
YNXVmLxRyAmKLWzUvDudVkBH/S5IqYr1+4AbABASPvjxCft4QqjdSB+AeBcsjmAJSTP0HIyXcZCCq8+YvQXqfCR4th09s/gN726SvF2Tjmy+ePgkyiqtQqAJRjHCOE6yohjF8smp4ivkGT/I805OXvnbvjP\
x8z+DOPFMd6zK+deozNZHEulfnSUXQazG/WNJaWDU5aiIMqfOvfIpTh3RppCUwWIa63cEREh/qlwha6mIsHVVwk6uC1kFdS4sc5cg9x5CZzHkVb9FSuh+0pE5VZ9ssWvRAV9GjbHLnSb/vOcWRbBp88KEUc\
O/tPygHvdOuuIYgcF4xpJ8JHKrUiBrbvJL5B390bLNTqvcPwAKwprNNLg/UurNYKV0gn7lQCkfM+WbOQTrVEuYD08ICa5TQGxrwZJLeOghlbxtZ2iE6MGCn/W8K6/hMD8dC1K+38sarzSpqLQ0dtugIF3e7\
sl1sf4gWIr8LZ12f8dlRVb/iRYqJ4/EKFiebeqsSOpDstqMMxDQbz0x1qScLg7cRO6Fsvix9ZSiZWYn/d22c+t35ohOaI+fkH3rbFuz86yeJmUyIsDE/eM6zSFmtM4L0wLnxDBSwLZdE2PTO0hhlnxY4Yra\
yxMCltU+IBUgKxMOS9VGd1INybZN/TmqJ+boWElouYc+qn5dK1JcINVWadNljjJ3ososuieJFgzNuJhrfMieG9cH6j0TPbmyaYLWam1f6LNbdZBTsZGAzJOvQkJQRww9NaJk5e8RQQwA1d1yW8fcWk6/KLx\
FI9QWyQdbaHk6SiLfcfGxTbPiJ5ailR7X+vivgH94FmuCxW0Y94wX7i9wmgcb3m0LI0BQancajHUPfvCOossvu+Wx9yrNR2qhgeZsLcKzJZRrRX/uQwlhCahj+0SIjHD5DiTamqEKvc5HBh2Xv9X+Sj7AsR\
bOEtsqphspr2Zes9EXXXEb9hqGXC4pybMWF+uWGIm+WQdmIxJ701/vL01wxshu+AjXlyiTKyj8PZkBct4Orra4fsROcQEZwzJFu8sAaPTPc4OMendSximlnM7xFw93Qverh6bfHBshButPj3R1JMIXpinoV\
Nwn/xK/uh7yOVPRVljrw+XEVPLEPA6VnfKm9NiEakn4kOSYa6F/z2Yru+TSBjMB+LRafZvB9l3fx5YI1SYV9vFZ+rLsqIr/LPvIzyhC+Ps8LP3MN/s/rS1ndY7ZqAe9Vcdk1IggQYf1Hr2j9vkViIllj1O0\
ggXMQ3YCP6nMXu1vv0QYKuSnxbJCPTn4SV6ht+fgN9H8Qwh1ciObCq3RZ/P1g2Vtq1aMgHaThKSFpcU7yWiI1fKLc1xOj/U7DuFuzBMQ02CSLYb/iUE9eso25dwNrhvHkS2Zwc+FVP4cd6/DKqzT4V3fUz/\
JAYjGT+6tOwRqu2z4TKEAuhcwKtRt6TOS+xJ2X69nJBwz25VRIQ82qMpLJm2yYb/38QTL52qKDRQhCC1oSUMJ8YFJ9xp/c1dzeh8KD7nZxf3o0FReXWmMPDWwPabFUm5V8EWUr4W1WxF/AP6xpmTl9CTZtF\
Zv7cYYgSdlI+aT/gfY1vJE72BwaeDoYe1PNBhu0xnQXvFnOFxFP37CMb0QFeqWjAZv8Xu3TBh2Aa32bAZKLR4jBBBH2AZUsWrBFw4Q4NDZaYTOWESiS1KN1w4uaYggfeUs5CAk5dgRVBs7cr7XzmjFLlHDh\
Mgva3GrypOt2+DP6YlTwCzNSt6bowADWLSrkfVlCiMD/n1wtEd1x+xp2RLmEk4DsNoTRPcx+qa84h7Acx4+QYB8B9LZTOaSQ1rXNzVuqSprA7tYgDwr1HDCW6rOeDNXuNZo8GpClZS95J0g4Sc7wT4huGMA\
21g3FO91fW0OzvbAeQ0G7FC2R6MRY4ji57ePUHtaPNaP+PRZkC7pHqCeInQkP8MVdVnxfWs6VZNFMsX6rIk6FAmSDcuZUNjXBYXD500Tt/bIC3uMt/FrjMfIqj79ZM2jy6+Ms7bwSubHP4PNoUde6CeGcI8\
6Xvf8Wx5Ww2LqtquWKRLroNyOslbaI1ksC0hlBb9ELOwtvyd8Rx9ugE5KxK8yAP0lyuE3sWzoJkzyTFHjgu+CuE4Bk8fKdtfytwTlJzjj4rW22TGOld11K3TCzvInIrDF2qybvwluPpSTzUUbl3mRehVtVo\
LmNna0POMwTM8d0IkDsMY1OkkKABrMk5XqIARcxbM/QbVPE4uPCFK46BWXk4zGZJbA6oEfwwPV19yYcMfyFmEh6KN9mwGplE5sc627D6qP+YOMUYzbYWSzDOXAP8fqjfqqGZo1C+oZcD1umXvmEPRS2cN8E\
PrvN+UsVAD9MjRDjdvJdY0Tmby5ICJZvAGguhwyDVdSWWvwnx7dSDjjBrMPR4SxTeruMXZjcNG+IwW2pNk0l+oiWbePqTIeIjFdiTuSGz5YQyywJV5VEf7NaojWpw3UbtWHQnKtE9FYkuQ953E+SpnljUNl\
31ZBiS6FAg3iBkaPiSxTDkSb2M6OrvcSO2wP1Y1DVPb4AyQlRdipuzYy7q+rI3KkYT0xPP5Zy+qiWbczToOoOy3RziFoZ3X0SrUDOIK4sJuC+5RgqQ2i8+AG5yTfcv3Aeqnkn/guuzQva+gKj74iU0VUIHk\
0FNGqdEtFStC2XDrLWaFNBSUOUmhSPiVlHOdLvWukqEStdACo/sOC1kpyYxcJugecoeGL9iQ4MkKwlKnLtaMLBxHKLZchIR3upoNgcWChX62gcxWTXnhK1QzaGELmsEs9JkgKJEF6+Y6+KcbTqztrSbCsd6\
muHt2RYB0+xVpt2UqDqBFabFd0U4W8bQibSqfTXtrtGXbkyevPgETo5OZOGceN3nYOBjWeUwUS6rgAlzdhj5+ZVaZmAaJV2XioOBgFfXaFHLfqlLZfg5WvzHAI5QGI4hx2DPG24APZBdip86ew7PIxrAOw9\
j19Z1W47qXArciGEAEDiOPuGitmO1mDHn7GG/Top0ZYKjy0fCYnIWZldpgIuSDBYxIjyGRAyDqzJ8KD9XBtiaoyqFW2ZbsxAhbQTuuqY8+LHZeuzd5KxF5DTgucDgECPY7Deci1w6Cc/yRdnOhUYWJn7lnm\
/K7rqRX8oEFWMnp2gpi6cUfeAFBrL9V+DkXfOvDu76Vz+88y/m+iC5kQuvdI5mG6FwYmBjdXUMlLYarra/7v7l1fZXn6ZCWzE+FYkxw4BfJm7gZzQMsJASwWpYzS6zCBEt52rYWIqaXKepN+EM/L7ZGxtzu\
mlNtPXbnS6Vjcnc0JOZbkla7WcKg5Ra9WbItCw+wLU22orDanlTSldKKkHLuLyJEb4m3DYVPoa81Wan1WYnVhSbLImt91+1NShaLWtA3R72PDB8cQoB9nkBP2b2HAoVuKQks/d7cYlht5PZZQjrYeUp5ktQ\
4LYVw07LUqmerpEXwctes0oxzctYdVrQShFcoBbJaJXYx9TX5MXWD41Q0P7VkRy0x+rSB9A+jGRixPxgXjBIj5nOZZytmMuALXQ/chkc1iip02pyu9IRY38JJXoJ3CSUaAUjkhgMU17ynCxXoP26qY25xRN\
aSWL/bz+tJNG7VCKDyfuFx9PqZjrgY3lkOuIbaZIc7jfC0On77g3sHcRvPLsJbqdtwYs/zW6ccKO//jJSFnSa5hONHXCSh75biQmB1b2R7SdDXUaMptHBWEo6AQYqq8/xMvUxha5i9tV0R4DjKVAainS/rI\
NKclDUvkxZBxUj4Dg42a46vCos6XbV0eKYLibVIDbaPd8tJX1cTvr0/PfER5qvz1LGPY39Fx8sqbHwAyC3Ejx+S/k9KV+tJupnzLmvsZClh+S9l8pqbEHwqJSsfMpdJ1m3RZIleAZbs/sIaE53hjGwDYZFH\
36B9Lb4+yYbrJr3eWrmdmz9zolIEhkmfolQxe8yYCLRPP5GWBJL2wJiPjcZG1M+M+ffHIHcJzCqXOcvlk2nx8zK96rohBLuizNgCwdsT5ZJ1uKfSRtwLcWrh0v1Gb4UONo0rF7+3fsMxyQOIbipJDR5eBBy\
bPpz8G3/3y59YoGzTh3A5Y0TOTSJt9Ax5/1c/P3pt5aLIm5Brbq/9DE2I7SOWVlCnLp/KLR05VMiaLfhvU3ThAmQQZsmehKoFMmF4wCIR3sEK2qaVNp4cYnVUvQm8vmQWpWl7Eum41j22WS9vkpEhKqslzY\
7RGSN+/IaD5GWw2XQJC13XJ9rGC0UoUyyppu/jea0dhU5DQnJRxU6FYGTJtSa6+8tv13lUP4aLIEHy8+4U9HIXVyg+r7lQaUU5SMtlZ/iNGEEylb7NnWmFk6hUmHCYcUBSpNvOkQAuzSLqvPM9JemzSwFqm\
azSt66p1IaBX4nbQqjJ979wB/HgdeX6QrDsQIHp5CkpRiomn9QYrKD3xViYwGsa5c1fDZ1LUdAfOJygduxqNxp1NEqw7WQPHmGC14KZ9BolhW1ztJUaQaqQdxwwbgNgMMnTsWSeez/NRggfKT22gohRIczy\
9Ve+A4Lyqi3r/ASNvXceB6dTJ+Ae0Fe8MsOohldswEemZ+hRm0xeQm+M+/LlF1r2krvgZojYR7n4JxtLVt6ICmBiOup279xEKnzN+BT/VuD+mnTlaRory2bDlQbbc4GRaQw/1Blb4THHhO8Jorlb4V5/Xl/\
/4PZVEEK8Rdh6v6Zm2eCR0sNvVDGwR9IsRHOPlF16TdraAgtwknwABPiADVUCzfbzaJBoeJa6gUsgDcQ/DxUxM+k07+HTbg34huIBtyo8gGClFs0pGiQVmwCvsaSOmFIZb50ZlLfmDRH5KDHPFqVlqWYg8N\
wlCqnqiJK0kSmITM6/WJvoZIaVXtbQP+nm1jJTN4vXNczuMv5DXi0U6iUsmzUQ7XBPkzYlIx6qEJUWSCP2AcYQj1oNTDEpuUM+cCI42jBeFtJhLsWniaYqOpa0Fb3K6SP9MuO4DcxiHYLk8aKuYdRyla+YM\
jKVs54ptMicKcBEWFOf8RA+ODEuhkMEgIHOLHeUUSmzGUTMRBDl0Eumwh1BUP2Lk1FAYeIpltV1nq+xkYY7MGVkQqJk0w8gMYsfoVOkxQ649cFrGBOB8ftfsERmUE3cjY7UIH5bL6UqwtSYqTuGKTMSiClz\
XANmRLdalqTm9M3H2mdfrSgdhyf3o1VudiNYQKv21ax73DBbwLqxAbkp67ILqbTzWRG5mr514ulzJiEEZ3uCEsZzbLbdDSJpEj6FaFhdeuNVILl6eSN+mJARCwlPixv/hc2eedwRHRC10lEhtm14BhqAbXu\
zk8L4My7iRYc74kWwGtiLW6UXENnlXTJ8+WgjBHTvxyTwDDnDywC9vcOK+MFWVqG+WX4DTrVEVnbV9pQ4+vzZBkAJJ+0fTOop9fFbPNrkzgYE6PbHyDMEA4eHRYYI31HrQa8WKaDmGtQGvGCohDsUUsiK9p\
Fm8YmcfZIUKNu/5ol52bY1COKKSK3zICLyS3DBfmMW5PD8MMFb9BIiCUuUImoDS6IngN20SJrXADH+YacLcEF8/4v5LxPWkBUdBLC7HUbKS7QvORrgQvucQeJKz+WNsr4uz8vu/kxIL6dIx42Sqc7vG0j/v\
2DAZrcAKviXAptfm6otnHXUCa6sIMxqW28erp6pVhf32lgcj2qG75DloTweNhTOBtiktelhNIgr1tWceuNTFrYeLjkZpLVpYSyzHI3VikfvR0y0c7fJhCrakAlRKRoGOSyr1V7mK4m1n2dY3n0Nd1+9cShm\
Aw+eVDe/PbZiY5hhC01DSSIHvk+BBKzjLSH94Y3LBq4Bw5BPmMNZNIYgOStsScm4jNcivzis13zMLb+FhYjxy5NCzHyrsU20mTjtYkR87peu0pSCz1MGZgzbYefbt57KcJTg594Ib8HM/yb73/FpEt83oOY\
c5RaNKJivMZrx7b7LF8Ra0B0NdPtV0skTfcKANCs0CUBiqCfX2KQhH4rp5132gEvJilexLt6mBO/5UocJ7e3+ug87nm0j/7uWHCmH9EcQOiF4ReEnrUavNV4veDQ8LTwDxBc/c2edD5FE1CCV3BU+CxgYry\
HevpR+ABfqZDWIQw3UYBlDqh6Q9FANImVSo/Ah/6yh2hyFnX2ExaPR0w/DdOnMmh5qTgCi63KYMmgPbLtAPYKhEJO327BRNTqUx0Pqp0VOSaqY29WjJM3ALcWmrm9ce4AgieDNDegXJgSXJ4F7+E1Fe8kpN\
/pRdKvwzbM/kXSkY+MM+ffRldzXzLorIKBGmVn7J+fyHdP6iQaHiy2KJbPGl3QODlPZiAzqWiKoekxdPHH2y6XC9R2xOnpL8Oq+zMKgTIArbWyDa6LP+BI+n2XYk2+WcP48OZRu/UxQmfeqTmADPcxpyGeG\
dZcEfP1CzcAAUDAyPtLMqEuY0OclTowYIxxMkI5hUrqdxOCojIRWnBtmF8viUYIOHQvbFNVmhUcIKjUGgcIrBQpwFPNsVIOvz0RP6RngeUt2QTbapOZ47X6gFzFLBwNW7SvzRbslKLhhszg2pMGeBMl878S\
x7aI7+ChUs2TzDoD3GLY9IEHUPN6+kq5gpw/WuDwVZlm3Ja35W1do1bMwY89BdoglRAELD69oQoAd/5Yw2L0xaU8pyWaHWdudqGt3IX83fLY13ST7Mfj70/fppF2DDk89k3pY6kc5nfFIFrV3RgoVHf6UgQ\
9HT3iiedyHjGvNw2Zeb2JiPjZQ/GhHnu53PoQavm7MID/JYVaZmr1BzkmCRW3F30a5GuvbXoPcfSmsmll3YDt86+6AdGbXnUD9qsbcLj4QFulFl+Q53+aZSaLe2oLsLMd4UFKnBz8lTU0jTgbrChWqW4Sfd\
Icjlgckm6lqxlAVp2zyRlb+uGt437tgEQO3DZDY8oxLp6suFeR+XJ+CWiQ0snzRQJYiJaFO+Gzr1bJOWmgBjZAx16tklutkhPLks8quaQxGy9kUIISm3cG/QcknC2ALNhAcmgxZhA0p6kmvjFDqlmD5ItJW\
eFL8neZNzrY41oVDxnmxO031VHabHbNBL3qZAvGqX54v1mnbYX3QVw7jukCcC38ctW3DWNf/mWNHIXuYfVylX1yLq8X01vjLzF0PWMRvaxeruKzkN2+XJU0Ks3koQBf2rqnAk1XgL+HQGtESK+nW33Wwm4t\
dwaUFcXkhXa1NcseKero3+NvzdlzjCFiGZ+kE/MFU9Ah89n5F6/bzaLp4GfXY0+LVHMChmi8zT2g4qtCdtSzxJb83RfB3oR5XVRm87kvoRkYF6CV1WHBXU8H99UzZ87rzmUq4J65UuVlMfHTZGOVUtVYQIl\
UFc0t9Q2ZXoxTAJ7I9IhVax9MYE0r1UwTUtxgy+7oFhpieN9kwJrYr4FbAs32CPSxVwkXCSJwrVSZZAxYHM+Re0BFbty6Yyn/oR/96qhFxCgiYvGnYko4vqH0qa6OLTrpZJjhB+te0uYAfWHRZD38JyBKWM\
OmgdrozaowBuoq+wG1XTs5cSfWDs/maiweeICxtonCoozrR5U44RsgKsw6I/qAwNvCxtah/CD4S3Wma+DbrZwctoPgrqUurUA16SqR00UxuNeSIwK++m5wywxqTFRsLALhfoMpJAhv08vO76Z1HMUyFvWCw\
a2XvxlhNSKzyvpvjYtC86K2GbQCGC7pdUibhC5fOudIYa1b3r8eThELr9m71+Keo+ZkS6jY/veqzkzfvLHwgGPigPByjTcTsna9hqv0KZu+AFYcExC6uApJPMNq8uAqbNZd+rlDZHBz/cNMmHt9zUQdSN0e\
sSPn78croxka/rDCZE2tYKvcEHGkvNe/YZ2yOgS6wxf2qh7lqGh1OAD0HlBsDEYluOtWwCKhkckS72ZR0nH+ObTflOhPnP5ZzY2Q9i7prQh790cIOulzv1ge88zXXEnbvXy3c9WN3YltCM5rrse5AwhcS29\
id7i32yLeAVZF6CLyJXnbeBTTm47vWPfNtFbtnK31xtZ08HZiB8Otl6U7GNImmxjYIRKcfhcgKPls/dAITZp+dSTvqI2XKzhLotbsjjihSxd8zlYcC/TNQ8nkHwEFcfKoH2OBikJ33dIOc3A4JUCoWK2eqz\
kOQ85I2EPHgs/cDgltFyG+PbVdOsi4b9+0MIWMzPH6tfnXFl52tSInCRpZ/502V0s8WZ1kh67c09Xojy4cyEO5IwliSxWXakT99nKJ4ECL6/K99r+3zNLeV8UMqtO5pUJwkhCC12lI6T7JC5d6nV6bTiE3N\
wmSsZ2v/MTcvB+tCcwXQGoUEPt6K90h0JNygYuv8s+8jPKET8iwKsHcw3+z+tLWd7AZ5iavD4k0XMw0FGld6QFOh94Qf3n6Ps3pSYVLYhYiirg+/hJz7ucsBgM+LC89DG6qLwJOyQriNbPpT8IXoOrDwBwH\
+qxOT7JlcAHltvj709+26Ei6qaKoKTtUS+xRG7DreEQ8gvwt8U8xh9LMqrhUuQgqKke9F805oexd7e75vVyfjmNTJ9rn7bjg4hmftAdrVpIebPVItYH/Wj1STTs/TlQb001pTHFbaMUZjcpJe80mJNZPJu0\
C/PL0zxMife2woki7hAlyG1D0NOQJDQ3BAfCnITlJMX3XUFewNS18PiR8xCjPFwHUYA61f95a47i5ruFmt89fcaRscKQkTevtKFp4I3E0i/EGWDevJQ7wjX6kDIpSX08a6BaxPgkPJF9xa5EgRHV0VS3kkI\
vgMiETDJEG+S28p4bg/dxu14ZcAbMldoFIJn4IRhC/acHsGN8ehm+7J6lEOG1/iRCYOwyYWBSKjTQHKLILTdZAYhdmLyZDRB7WEGQZdmk4amIDJOmY6NTnvhbLxgNvKWclEaQQ+Ic5lOb9+gyKmnNKlcjl4\
DUKEy0EM84lO6s6wk3dQ+QXBiApTxCkWPAStig9CffPrxdokkWMMu9Z0Zr+OUBRmX6GoqVYeJy33AFfBPaIMq3Ebk3m7BbBPlxEpayRRoUz1mjOS5Vtx0mxUKSZ5UFI0VXZHqw5VTfTwgwpa8lbSfqI1Wux\
VzOt/Xwtdhzf9sLi7WoMluB8eOzKQnrDLaNZAw4SLJHx1Vt3KWmIU154ILaMb90lBUyXUSOMKJ42tBU6p4AYZJpAKxlurF4I0jfZ7J0XgpLipstuwUlnC68XbmAu0y/xwNBw8Qc3AgRvXzmEStiJa6UuKIX\
Q2kw2HBKYzdipmuTZOBB9nm09/rLjUl94xIXw6CW5KvbiiNTVTAz5q+MYfnQCUubX0tfcuRd/Fn6T5M8kxR84mP5F4uZ/pFwgtQ3/BX5a6tlQJ11m7/X7KH1nU2XWT/mAKJE3Zmjwm6eDVwCagTGZA6Q2vW\
lc3c5od+5aOVMjhhANpk/thWRYDY+bOu365ETFdUVteb7JOWY0sFn11wvY27HNr4F212D5I75PiUJoKuAoFUNNnsVAkjR7IiwhPXMNfS15FVrzBRK/cz2lGjAkcRqZx5OnVVQDPUxXCNJ3b0255Z1uv3riC\
A598qAcQtlkC8zzAgy7lTlM01zg2awRYbO2KYr3zGPSoEFN1pWIMbu74Rv6OYt25XjMjhiTYg7wcj/qT3Bz10fj79uM2aHaWnfMjpDSiUpKz6DNCt9NMPhnNPRZCMH0Y7Amfcli58VZ+c4LXzOvFRJdR8v5\
o9EF4M5GFdiFjU4vglLqMdVEsHFdxcYNdArIosh07nCWCtUsE+d2V098tiqt3Wr+KL7sxRdW73xaIhROHaLKOfMPzTI7mGg+6vXOJydxqu6P1WOfBbHdXnrsk5MqXb/2/n7xk+MlGzckebkkz35yROtwMDE\
b+zR8f6op6jCnh7Z0tD3xzh+XzsYSvJzjCV2qCK4COs0T4oqnmdRA+KYzYsv72s1YT3Snj+4mu+9GGno447VML+8muaIzCZ0+v5ukRye1+3t7VZKhKtDBHLSHe4eStOuwB9yh7NRkWjYKUupDOYaOFv+xAH\
P7aNFJkqE6871/NkQkmafzFXBzhV/ltJFHW66M1SLFHLSHbThJ2pXZii7fHSLomQu3HvOWZQwsTAbc800xSMNkmKEre1vAPJV2LbVlGZfR3u2I91pMTwONC8zL0k/Z5hmj7MnqcrQxT9RChHfK0dde/f/4/\
wG2r3GS"]}; 
subQ0 = {Q0$[r_:0] :> (u + (I*r)/2)^2 - 1/12}; 


subIm = {Im1 -> 405*Sqrt[3] + 648*Sqrt[3]*\[Zeta]$[3][0] + 720*Sqrt[3]*\[Zeta]$[5][0] - (972*I)*\[Eta]0$[2][1] + (324*I)*Sqrt[3]*\[Eta]0$[3][1] - (162*I)*\[Eta]0$[4][1] + 
      (972*I)*\[Eta]0$b[2][-1] - (324*I)*Sqrt[3]*\[Eta]0$b[3][-1] + (162*I)*\[Eta]0$b[4][-1], 
    Im2 -> Sqrt[3]*(-17496 - 10368*\[Zeta]$[3][0] + 2592*\[Zeta]$[3][0]^2 - 6552*\[Zeta]$[5][0] - 13608*\[Zeta]$[7][0]) + 
      (15552*I - 3888*Sqrt[3]*\[Zeta]$[2][0] + (1944*I)*\[Zeta]$[3][0])*\[Eta]0$[2][1] + (5832 - (1944*I)*Sqrt[3] + 1944*\[Zeta]$[2][0])*\[Eta]0$[3][1] + 
      (-3888*I - 1944*Sqrt[3])*\[Eta]0$[4][1] + (972 + (1836*I)*Sqrt[3])*\[Eta]0$[5][1] - (648*I)*\[Eta]0$[6][1] + 
      ((-11664*I)*Sqrt[3] - 11664*\[Eta]0$[2][1] + 3888*Sqrt[3]*\[Eta]0$[3][1] - 1944*\[Eta]0$[4][1])*((-I)*\[Zeta]$[1][0] + \[Eta]0$b[1][-1]) + 
      (-15552*I - 3888*Sqrt[3]*\[Zeta]$[2][0] - (1944*I)*\[Zeta]$[3][0])*\[Eta]0$b[2][-1] + (5832 + (1944*I)*Sqrt[3] + 1944*\[Zeta]$[2][0])*\[Eta]0$b[3][-1] + 
      (I*\[Zeta]$[1][0] + \[Eta]0$[1][1])*((11664*I)*Sqrt[3] - 11664*\[Eta]0$b[2][-1] + 3888*Sqrt[3]*\[Eta]0$b[3][-1] - 1944*\[Eta]0$b[4][-1]) + 
      (3888*I - 1944*Sqrt[3])*\[Eta]0$b[4][-1] + (972 - (1836*I)*Sqrt[3])*\[Eta]0$b[5][-1] + (648*I)*\[Eta]0$b[6][-1], 
    Im3 -> Sqrt[3]*(472392 - 419904*\[Zeta]$[2][0] + 293544*\[Zeta]$[3][0] - 15552*\[Zeta]$[3][0]^2 + 26640*\[Zeta]$[5][0] - 49248*\[Zeta]$[3][0]*\[Zeta]$[5][0] + 96768*\[Zeta]$[7][0] + 
        205632*\[Zeta]$[9][0]) + (139968*I)*\[Eta]0$[2][1]^2 + (-116640 + 11664*\[Zeta]$[2][0] - (23328*\[Zeta]$[2][0]^2)/5 + 
        Sqrt[3]*(20088*I - (116640*I)*\[Zeta]$[2][0] + (6480*I)*\[Zeta]$[3][0]) - 34992*\[Zeta]$[3][0])*\[Eta]0$[3][1] + 
      \[Eta]0$[2][1]*(-219672*I + (419904*I)*\[Zeta]$[2][0] - (11664*I)*\[Zeta]$[2][0]^2 + Sqrt[3]*(-69984 + 69984*\[Zeta]$[2][0] + (69984*\[Zeta]$[2][0]^2)/5) - 
        (42768*I)*\[Zeta]$[3][0] - (27216*I)*\[Zeta]$[5][0] - (23328*I)*Sqrt[3]*\[Eta]0$[3][1] + (11664*I)*\[Eta]0$[4][1]) + 
      (4860*I + Sqrt[3]*(11664 - 19440*\[Zeta]$[2][0]) + (58320*I)*\[Zeta]$[2][0] - (1944*I)*\[Zeta]$[3][0])*\[Eta]0$[4][1] + 
      (33048 - (11232*I)*Sqrt[3] + 7776*\[Zeta]$[2][0])*\[Eta]0$[5][1] + (-22248*I - 14256*Sqrt[3])*\[Eta]0$[6][1] + (4860 + (8100*I)*Sqrt[3])*\[Eta]0$[7][1] - 
      (2268*I)*\[Eta]0$[8][1] - 46656*\[Zeta]$[3][0]*\[Eta]0$[1, 2][1] + (139968*I)*\[Eta]0$[1, 3][1] - (46656*I)*Sqrt[3]*\[Eta]0$[1, 4][1] + (23328*I)*\[Eta]0$[1, 5][1] - 
      (46656*I)*Sqrt[3]*\[Eta]0$[2, 3][1] + (23328*I)*\[Eta]0$[2, 4][1] + (279936*I)*\[Eta]0$[1, 1, 2][1] - (93312*I)*Sqrt[3]*\[Eta]0$[1, 1, 3][1] + 
      (46656*I)*\[Eta]0$[1, 1, 4][1] + ((466560*I)*Sqrt[3] + 233280*\[Eta]0$[2][1] + (69984*I - 38880*Sqrt[3])*\[Eta]0$[3][1] + (-38880 - (23328*I)*Sqrt[3])*\[Eta]0$[4][1] + 
        (11664*I + 22032*Sqrt[3])*\[Eta]0$[5][1] - 7776*\[Eta]0$[6][1] + (139968*I)*\[Eta]0$[1, 2][1] - (46656*I)*Sqrt[3]*\[Eta]0$[1, 3][1] + (23328*I)*\[Eta]0$[1, 4][1])*
       ((-I)*\[Zeta]$[1][0] + \[Eta]0$b[1][-1]) + (219672*I - (11664*I)*\[Zeta]$[2][0]^2 + Sqrt[3]*(-69984 + 69984*\[Zeta]$[2][0] + (69984*\[Zeta]$[2][0]^2)/5) + 
        (42768*I)*\[Zeta]$[3][0] + (27216*I)*\[Zeta]$[5][0])*\[Eta]0$b[2][-1] + (69984*I + 31104*Sqrt[3])*\[Eta]0$[2][1]*\[Eta]0$b[2][-1] + 
      (-27216 - (23328*I)*Sqrt[3])*\[Eta]0$[3][1]*\[Eta]0$b[2][-1] + (11664*I + 2592*Sqrt[3])*\[Eta]0$[4][1]*\[Eta]0$b[2][-1] + 
      (-116640 + 11664*\[Zeta]$[2][0] - (23328*\[Zeta]$[2][0]^2)/5 + Sqrt[3]*(-20088*I + (23328*I)*\[Zeta]$[2][0] - (6480*I)*\[Zeta]$[3][0]) - 11664*\[Zeta]$[3][0])*\[Eta]0$b[3][-1] - 
      27216*\[Eta]0$[2][1]*\[Eta]0$b[3][-1] + 7776*Sqrt[3]*\[Eta]0$[3][1]*\[Eta]0$b[3][-1] - 1944*\[Eta]0$[4][1]*\[Eta]0$b[3][-1] + 
      (I*\[Zeta]$[1][0] + \[Eta]0$[1][1])^2*((-69984*I)*\[Eta]0$[2][1] + (23328*I)*Sqrt[3]*\[Eta]0$[3][1] - (11664*I)*\[Eta]0$[4][1] - (69984*I)*\[Eta]0$b[2][-1] + 
        (23328*I)*Sqrt[3]*\[Eta]0$b[3][-1] - (11664*I)*\[Eta]0$b[4][-1]) + (-74844*I + Sqrt[3]*(11664 - 19440*\[Zeta]$[2][0]) - (11664*I)*\[Zeta]$[2][0] + (1944*I)*\[Zeta]$[3][0])*
       \[Eta]0$b[4][-1] + 2592*Sqrt[3]*\[Eta]0$[2][1]*\[Eta]0$b[4][-1] - 1944*\[Eta]0$[3][1]*\[Eta]0$b[4][-1] + (33048 + (11232*I)*Sqrt[3] + 7776*\[Zeta]$[2][0])*\[Eta]0$b[5][-1] + 
      (I*\[Zeta]$[1][0] + \[Eta]0$[1][1])*((-466560*I)*Sqrt[3] + ((-46656*I)*Sqrt[3]*\[Zeta]$[2][0] + 23328*\[Zeta]$[3][0])*\[Eta]0$[2][1] + (23328*I)*\[Zeta]$[2][0]*\[Eta]0$[3][1] - 
        (139968*I)*\[Eta]0$[1, 2][1] + (46656*I)*Sqrt[3]*\[Eta]0$[1, 3][1] - (23328*I)*\[Eta]0$[1, 4][1] + 
        (279936*Sqrt[3] - (279936*I)*\[Eta]0$[2][1] + (93312*I)*Sqrt[3]*\[Eta]0$[3][1] - (46656*I)*\[Eta]0$[4][1])*((-I)*\[Zeta]$[1][0] + \[Eta]0$b[1][-1]) + 
        (233280 - (46656*I)*Sqrt[3]*\[Zeta]$[2][0] + 23328*\[Zeta]$[3][0])*\[Eta]0$b[2][-1] + (69984*I - 38880*Sqrt[3] + (23328*I)*\[Zeta]$[2][0])*\[Eta]0$b[3][-1] + 
        (-38880 - (23328*I)*Sqrt[3])*\[Eta]0$b[4][-1] + (11664*I + 22032*Sqrt[3])*\[Eta]0$b[5][-1] - 7776*\[Eta]0$b[6][-1]) + (22248*I - 14256*Sqrt[3])*\[Eta]0$b[6][-1] + 
      (4860 - (8100*I)*Sqrt[3])*\[Eta]0$b[7][-1] + (2268*I)*\[Eta]0$b[8][-1]}; 


weakqij = {q$[1, 2][r_:0] :> (Q0 - (4*g^2)/3 - 2*g^4 + g^6*(8 - 8*\[Zeta]$[3][0]) /. Shift[r] /. u -> u + (I*r)/2), 
    q$[1, 3][r_:0] :> (g^4*(-18*I*u - 18*Q0*\[Eta]$[2][1]) + g^6*(306*I*u + 216*u*\[Eta]$[1][1] + 24*\[Eta]$[2][1] + \[Zeta]$[1][0]*(216*I*u + 216*Q0*\[Eta]$[2][1]) + 
          Q0*(90*\[Eta]$[2][1] - 108*I*\[Eta]$[3][1] - 36*\[Eta]$[4][1] - 216*I*\[Eta]$[2, 1][1])) + g^8*(-162*I*u*(27 + 4*\[Zeta]$[3][0]) - 4536*u*\[Eta]$[1][1] + 
          12*I*(7*I + 108*u)*\[Eta]$[2][1] + \[Zeta]$[1][0]^2*(-1296*I*u - 1296*Q0*\[Eta]$[2][1]) + 72*(2*I + 3*u)*\[Eta]$[3][1] + 48*\[Eta]$[4][1] + 2592*I*u*\[Eta]$[1, 1][1] + 
          \[Zeta]$[1][0]*(-4536*I*u - 2592*u*\[Eta]$[1][1] - 288*\[Eta]$[2][1] + Q0*(-1944*\[Eta]$[2][1] + 1296*I*\[Eta]$[3][1] + 432*\[Eta]$[4][1] + 2592*I*\[Eta]$[2, 1][1])) + 
          288*I*\[Eta]$[2, 1][1] + Q0*(-162*(-1 + 4*\[Zeta]$[3][0])*\[Eta]$[2][1] + 972*I*\[Eta]$[3][1] + 504*\[Eta]$[4][1] - 324*I*\[Eta]$[5][1] - 90*\[Eta]$[6][1] + 
            1944*I*\[Eta]$[2, 1][1] + 1296*\[Eta]$[2, 2][1] - 216*I*\[Eta]$[2, 3][1] + 1296*\[Eta]$[3, 1][1] - 432*I*\[Eta]$[4, 1][1] + 2592*\[Eta]$[2, 1, 1][1])) + 
        g^10*(18*I*u*(3241 + 876*\[Zeta]$[3][0] + 240*\[Zeta]$[5][0]) + 648*u*(113 + 12*\[Zeta]$[3][0])*\[Eta]$[1][1] + 36*(-15 - 900*I*u + 28*\[Zeta]$[3][0])*\[Eta]$[2][1] + 
          \[Zeta]$[1][0]^3*(5184*I*u + 5184*Q0*\[Eta]$[2][1]) - 1080*(I + 9*u)*\[Eta]$[3][1] + 24*I*(25*I + 108*u)*\[Eta]$[4][1] + 432*(I + u)*\[Eta]$[5][1] + 120*\[Eta]$[6][1] - 
          64800*I*u*\[Eta]$[1, 1][1] - 15552*u*\[Eta]$[1, 2][1] + 2592*I*u*\[Eta]$[1, 3][1] + \[Zeta]$[1][0]^2*(32400*I*u + 15552*u*\[Eta]$[1][1] + 1728*\[Eta]$[2][1] + 
            Q0*(16848*\[Eta]$[2][1] - 7776*I*\[Eta]$[3][1] - 2592*\[Eta]$[4][1] - 15552*I*\[Eta]$[2, 1][1])) - 432*(5*I + 36*u)*\[Eta]$[2, 1][1] - 1728*\[Eta]$[2, 2][1] + 
          288*I*\[Eta]$[2, 3][1] + 864*I*(2*I + 3*u)*\[Eta]$[3, 1][1] + 576*I*\[Eta]$[4, 1][1] - 31104*u*\[Eta]$[1, 1, 1][1] + 
          \[Zeta]$[1][0]*(648*I*u*(113 + 12*\[Zeta]$[3][0]) + 64800*u*\[Eta]$[1][1] + 432*(5 - 36*I*u)*\[Eta]$[2][1] - 864*(2*I + 3*u)*\[Eta]$[3][1] - 576*\[Eta]$[4][1] - 
            31104*I*u*\[Eta]$[1, 1][1] - 3456*I*\[Eta]$[2, 1][1] + Q0*(648*(13 + 12*\[Zeta]$[3][0])*\[Eta]$[2][1] - 16848*I*\[Eta]$[3][1] - 7776*\[Eta]$[4][1] + 3888*I*\[Eta]$[5][1] + 
              1080*\[Eta]$[6][1] - 33696*I*\[Eta]$[2, 1][1] - 15552*\[Eta]$[2, 2][1] + 2592*I*\[Eta]$[2, 3][1] - 15552*\[Eta]$[3, 1][1] + 5184*I*\[Eta]$[4, 1][1] - 
              31104*\[Eta]$[2, 1, 1][1])) - 3456*\[Eta]$[2, 1, 1][1] + Q0*(18*(-827 + 444*\[Zeta]$[3][0] + 240*\[Zeta]$[5][0])*\[Eta]$[2][1] - 
            324*I*(13 + 12*\[Zeta]$[3][0])*\[Eta]$[3][1] - 432*(9 + 4*\[Zeta]$[3][0])*\[Eta]$[4][1] + 3564*I*\[Eta]$[5][1] + 1746*\[Eta]$[6][1] - 972*I*\[Eta]$[7][1] - 252*\[Eta]$[8][1] - 
            648*I*(13 + 12*\[Zeta]$[3][0])*\[Eta]$[2, 1][1] - 16848*\[Eta]$[2, 2][1] + 7128*I*\[Eta]$[2, 3][1] + 2592*\[Eta]$[2, 4][1] - 432*I*\[Eta]$[2, 5][1] - 
            16848*\[Eta]$[3, 1][1] + 7776*I*\[Eta]$[3, 2][1] + 1296*\[Eta]$[3, 3][1] + 7776*I*\[Eta]$[4, 1][1] + 2592*\[Eta]$[4, 2][1] - 432*I*\[Eta]$[4, 3][1] + 
            3888*\[Eta]$[5, 1][1] - 1080*I*\[Eta]$[6, 1][1] - 33696*\[Eta]$[2, 1, 1][1] + 15552*I*\[Eta]$[2, 1, 2][1] + 2592*\[Eta]$[2, 1, 3][1] + 15552*I*\[Eta]$[2, 2, 1][1] + 
            2592*\[Eta]$[2, 3, 1][1] + 15552*I*\[Eta]$[3, 1, 1][1] + 5184*\[Eta]$[4, 1, 1][1] + 31104*I*\[Eta]$[2, 1, 1, 1][1])) /. Shift[r] /. u -> u + (I*r)/2), 
    q$[1, 4][r_:0] :> (g^4*(-3 + 6*I*Q0*\[Eta]$[3][1]) + g^6*(12 - 36*I*\[Eta]$[1][1] - 8*I*\[Eta]$[3][1] + \[Zeta]$[1][0]*(36 - 72*I*Q0*\[Eta]$[3][1]) + 
          Q0*(12*I*\[Eta]$[3][1] - 36*\[Eta]$[4][1] + 18*I*\[Eta]$[5][1] - 72*\[Eta]$[3, 1][1])) + g^8*(-12*(7 + 9*\[Zeta]$[3][0]) + 288*I*\[Eta]$[1][1] + 216*\[Eta]$[2][1] - 
          64*I*\[Eta]$[3][1] + \[Zeta]$[1][0]^2*(-216 + 432*I*Q0*\[Eta]$[3][1]) + 48*\[Eta]$[4][1] - 24*I*\[Eta]$[5][1] + 432*\[Eta]$[1, 1][1] + 96*\[Eta]$[3, 1][1] + 
          \[Zeta]$[1][0]*(-288 + 432*I*\[Eta]$[1][1] + 96*I*\[Eta]$[3][1] + Q0*(144*I*\[Eta]$[3][1] + 432*\[Eta]$[4][1] - 216*I*\[Eta]$[5][1] + 864*\[Eta]$[3, 1][1])) + 
          Q0*(24*I*(-5 + 9*\[Zeta]$[3][0])*\[Eta]$[3][1] + 72*\[Eta]$[4][1] - 72*I*\[Eta]$[5][1] - 144*\[Eta]$[6][1] + 54*I*\[Eta]$[7][1] + 144*\[Eta]$[3, 1][1] - 
            432*I*\[Eta]$[3, 2][1] - 72*\[Eta]$[3, 3][1] - 432*I*\[Eta]$[4, 1][1] - 216*\[Eta]$[5, 1][1] - 864*I*\[Eta]$[3, 1, 1][1])) + 
        g^10*(24*(26 + 39*\[Zeta]$[3][0] + 30*\[Zeta]$[5][0]) - 1296*I*(2 + \[Zeta]$[3][0])*\[Eta]$[1][1] - 2592*\[Eta]$[2][1] - 8*I*(-167 + 42*\[Zeta]$[3][0])*\[Eta]$[3][1] + 
          \[Zeta]$[1][0]^3*(864 - 1728*I*Q0*\[Eta]$[3][1]) + 408*\[Eta]$[4][1] - 12*I*\[Eta]$[5][1] + 192*\[Eta]$[6][1] - 72*I*\[Eta]$[7][1] - 5184*\[Eta]$[1, 1][1] + 
          2592*I*\[Eta]$[1, 2][1] + 432*\[Eta]$[1, 3][1] + 2592*I*\[Eta]$[2, 1][1] + \[Zeta]$[1][0]^2*(2592 - 2592*I*\[Eta]$[1][1] - 576*I*\[Eta]$[3][1] + 
            Q0*(-2592*I*\[Eta]$[3][1] - 2592*\[Eta]$[4][1] + 1296*I*\[Eta]$[5][1] - 5184*\[Eta]$[3, 1][1])) + 384*\[Eta]$[3, 1][1] + 576*I*\[Eta]$[3, 2][1] + 96*\[Eta]$[3, 3][1] + 
          576*I*\[Eta]$[4, 1][1] + 288*\[Eta]$[5, 1][1] + 5184*I*\[Eta]$[1, 1, 1][1] + \[Zeta]$[1][0]*(1296*(2 + \[Zeta]$[3][0]) - 5184*I*\[Eta]$[1][1] - 2592*\[Eta]$[2][1] + 
            384*I*\[Eta]$[3][1] - 576*\[Eta]$[4][1] + 288*I*\[Eta]$[5][1] - 5184*\[Eta]$[1, 1][1] - 1152*\[Eta]$[3, 1][1] + 
            Q0*(-2592*I*\[Zeta]$[3][0]*\[Eta]$[3][1] - 2592*\[Eta]$[4][1] + 1728*I*\[Eta]$[5][1] + 1728*\[Eta]$[6][1] - 648*I*\[Eta]$[7][1] - 5184*\[Eta]$[3, 1][1] + 
              5184*I*\[Eta]$[3, 2][1] + 864*\[Eta]$[3, 3][1] + 5184*I*\[Eta]$[4, 1][1] + 2592*\[Eta]$[5, 1][1] + 10368*I*\[Eta]$[3, 1, 1][1])) + 1152*I*\[Eta]$[3, 1, 1][1] + 
          Q0*(-96*I*(-14 + 6*\[Zeta]$[3][0] + 15*\[Zeta]$[5][0])*\[Eta]$[3][1] - 1296*\[Zeta]$[3][0]*\[Eta]$[4][1] + 72*I*(4 + 11*\[Zeta]$[3][0])*\[Eta]$[5][1] + 504*\[Eta]$[6][1] - 
            432*I*\[Eta]$[7][1] - 504*\[Eta]$[8][1] + 168*I*\[Eta]$[9][1] - 2592*\[Zeta]$[3][0]*\[Eta]$[3, 1][1] + 2592*I*\[Eta]$[3, 2][1] + 1872*\[Eta]$[3, 3][1] - 
            864*I*\[Eta]$[3, 4][1] - 144*\[Eta]$[3, 5][1] + 2592*I*\[Eta]$[4, 1][1] + 2592*\[Eta]$[4, 2][1] - 432*I*\[Eta]$[4, 3][1] + 1728*\[Eta]$[5, 1][1] - 
            1296*I*\[Eta]$[5, 2][1] - 216*\[Eta]$[5, 3][1] - 1728*I*\[Eta]$[6, 1][1] - 648*\[Eta]$[7, 1][1] + 5184*I*\[Eta]$[3, 1, 1][1] + 5184*\[Eta]$[3, 1, 2][1] - 
            864*I*\[Eta]$[3, 1, 3][1] + 5184*\[Eta]$[3, 2, 1][1] - 864*I*\[Eta]$[3, 3, 1][1] + 5184*\[Eta]$[4, 1, 1][1] - 2592*I*\[Eta]$[5, 1, 1][1] + 
            10368*\[Eta]$[3, 1, 1, 1][1])) /. Shift[r] /. u -> u + (I*r)/2), 
    q$[2, 4][r_:0] :> (g^4*(6*I*u + Q0*(6*\[Eta]$[2][1] + 2*\[Eta]$[4][1])) + g^6*(-42*I*u - 72*u*\[Eta]$[1][1] - 8*\[Eta]$[2][1] + 
          \[Zeta]$[1][0]*(-72*I*u + Q0*(-72*\[Eta]$[2][1] - 24*\[Eta]$[4][1])) - (8/3)*\[Eta]$[4][1] + Q0*(30*\[Eta]$[2][1] + 36*I*\[Eta]$[3][1] + 30*\[Eta]$[4][1] + 12*I*\[Eta]$[5][1] + 
            8*\[Eta]$[6][1] + 72*I*\[Eta]$[2, 1][1] + 24*I*\[Eta]$[4, 1][1])) + g^8*(12*I*u*(35 + 18*\[Zeta]$[3][0]) + 792*u*\[Eta]$[1][1] - 4*I*(-13*I + 108*u)*\[Eta]$[2][1] - 
          24*(2*I + 3*u)*\[Eta]$[3][1] - 44*\[Eta]$[4][1] + \[Zeta]$[1][0]^2*(432*I*u + Q0*(432*\[Eta]$[2][1] + 144*\[Eta]$[4][1])) - 16*I*\[Eta]$[5][1] - (32/3)*\[Eta]$[6][1] - 
          864*I*u*\[Eta]$[1, 1][1] - 96*I*\[Eta]$[2, 1][1] + \[Zeta]$[1][0]*(792*I*u + 864*u*\[Eta]$[1][1] + 96*\[Eta]$[2][1] + 32*\[Eta]$[4][1] + 
            Q0*(-72*\[Eta]$[2][1] - 432*I*\[Eta]$[3][1] - 264*\[Eta]$[4][1] - 144*I*\[Eta]$[5][1] - 96*\[Eta]$[6][1] - 864*I*\[Eta]$[2, 1][1] - 288*I*\[Eta]$[4, 1][1])) - 
          32*I*\[Eta]$[4, 1][1] + Q0*(12*(-31 + 18*\[Zeta]$[3][0])*\[Eta]$[2][1] + 36*I*\[Eta]$[3][1] + 12*(-7 + 6*\[Zeta]$[3][0])*\[Eta]$[4][1] + 168*I*\[Eta]$[5][1] + 66*\[Eta]$[6][1] + 
            60*I*\[Eta]$[7][1] + 28*\[Eta]$[8][1] + 72*I*\[Eta]$[2, 1][1] - 432*\[Eta]$[2, 2][1] + 72*I*\[Eta]$[2, 3][1] - 432*\[Eta]$[3, 1][1] + 264*I*\[Eta]$[4, 1][1] - 
            144*\[Eta]$[4, 2][1] + 24*I*\[Eta]$[4, 3][1] - 144*\[Eta]$[5, 1][1] + 96*I*\[Eta]$[6, 1][1] - 864*\[Eta]$[2, 1, 1][1] - 288*\[Eta]$[4, 1, 1][1])) + 
        g^10*(-24*I*u*(187 + 105*\[Zeta]$[3][0] + 60*\[Zeta]$[5][0]) - 1296*u*(7 + 2*\[Zeta]$[3][0])*\[Eta]$[1][1] + 4*(121 + 1620*I*u - 84*\[Zeta]$[3][0])*\[Eta]$[2][1] + 
          120*(-I + 21*u)*\[Eta]$[3][1] + \[Zeta]$[1][0]^3*(-1728*I*u + Q0*(-1728*\[Eta]$[2][1] - 576*\[Eta]$[4][1])) + 4*(17 - 216*I*u - 28*\[Zeta]$[3][0])*\[Eta]$[4][1] - 
          8*(31*I + 18*u)*\[Eta]$[5][1] - 104*\[Eta]$[6][1] - 80*I*\[Eta]$[7][1] - (112/3)*\[Eta]$[8][1] + 12960*I*u*\[Eta]$[1, 1][1] + 5184*u*\[Eta]$[1, 2][1] - 
          864*I*u*\[Eta]$[1, 3][1] + 48*(-5*I + 108*u)*\[Eta]$[2, 1][1] + 576*\[Eta]$[2, 2][1] - 96*I*\[Eta]$[2, 3][1] + 288*(2 - 3*I*u)*\[Eta]$[3, 1][1] + 
          \[Zeta]$[1][0]^2*(-6480*I*u - 5184*u*\[Eta]$[1][1] - 576*\[Eta]$[2][1] - 192*\[Eta]$[4][1] + Q0*(-1296*\[Eta]$[2][1] + 2592*I*\[Eta]$[3][1] + 1008*\[Eta]$[4][1] + 
              864*I*\[Eta]$[5][1] + 576*\[Eta]$[6][1] + 5184*I*\[Eta]$[2, 1][1] + 1728*I*\[Eta]$[4, 1][1])) - 400*I*\[Eta]$[4, 1][1] + 192*\[Eta]$[4, 2][1] - 32*I*\[Eta]$[4, 3][1] + 
          192*\[Eta]$[5, 1][1] - 128*I*\[Eta]$[6, 1][1] + 10368*u*\[Eta]$[1, 1, 1][1] + 1152*\[Eta]$[2, 1, 1][1] + 384*\[Eta]$[4, 1, 1][1] + 
          \[Zeta]$[1][0]*(-1296*I*u*(7 + 2*\[Zeta]$[3][0]) - 12960*u*\[Eta]$[1][1] + 48*(5 + 108*I*u)*\[Eta]$[2][1] + 288*(2*I + 3*u)*\[Eta]$[3][1] + 400*\[Eta]$[4][1] + 
            192*I*\[Eta]$[5][1] + 128*\[Eta]$[6][1] + 10368*I*u*\[Eta]$[1, 1][1] + 1152*I*\[Eta]$[2, 1][1] + 384*I*\[Eta]$[4, 1][1] + 
            Q0*(-1296*(-3 + 2*\[Zeta]$[3][0])*\[Eta]$[2][1] + 1296*I*\[Eta]$[3][1] - 48*(-37 + 18*\[Zeta]$[3][0])*\[Eta]$[4][1] - 1440*I*\[Eta]$[5][1] - 408*\[Eta]$[6][1] - 
              720*I*\[Eta]$[7][1] - 336*\[Eta]$[8][1] + 2592*I*\[Eta]$[2, 1][1] + 5184*\[Eta]$[2, 2][1] - 864*I*\[Eta]$[2, 3][1] + 5184*\[Eta]$[3, 1][1] - 2016*I*\[Eta]$[4, 1][1] + 
              1728*\[Eta]$[4, 2][1] - 288*I*\[Eta]$[4, 3][1] + 1728*\[Eta]$[5, 1][1] - 1152*I*\[Eta]$[6, 1][1] + 10368*\[Eta]$[2, 1, 1][1] + 3456*\[Eta]$[4, 1, 1][1])) + 
          Q0*(24*(191 + 3*\[Zeta]$[3][0] - 60*\[Zeta]$[5][0])*\[Eta]$[2][1] + 648*I*(-3 + 2*\[Zeta]$[3][0])*\[Eta]$[3][1] + 12*(-17 + 78*\[Zeta]$[3][0] - 40*\[Zeta]$[5][0])*\[Eta]$[4][1] + 
            12*I*(-35 + 36*\[Zeta]$[3][0])*\[Eta]$[5][1] + 42*(-11 + 8*\[Zeta]$[3][0])*\[Eta]$[6][1] + 552*I*\[Eta]$[7][1] + 120*\[Eta]$[8][1] + 240*I*\[Eta]$[9][1] + 96*\[Eta]$[10][1] + 
            1296*I*(-3 + 2*\[Zeta]$[3][0])*\[Eta]$[2, 1][1] + 1296*\[Eta]$[2, 2][1] - 1656*I*\[Eta]$[2, 3][1] - 864*\[Eta]$[2, 4][1] + 144*I*\[Eta]$[2, 5][1] + 1296*\[Eta]$[3, 1][1] - 
            2592*I*\[Eta]$[3, 2][1] - 432*\[Eta]$[3, 3][1] + 48*I*(-37 + 18*\[Zeta]$[3][0])*\[Eta]$[4, 1][1] - 1008*\[Eta]$[4, 2][1] - 312*I*\[Eta]$[4, 3][1] - 288*\[Eta]$[4, 4][1] + 
            48*I*\[Eta]$[4, 5][1] - 1440*\[Eta]$[5, 1][1] - 864*I*\[Eta]$[5, 2][1] - 144*\[Eta]$[5, 3][1] + 408*I*\[Eta]$[6, 1][1] - 576*\[Eta]$[6, 2][1] + 96*I*\[Eta]$[6, 3][1] - 
            720*\[Eta]$[7, 1][1] + 336*I*\[Eta]$[8, 1][1] + 2592*\[Eta]$[2, 1, 1][1] - 5184*I*\[Eta]$[2, 1, 2][1] - 864*\[Eta]$[2, 1, 3][1] - 5184*I*\[Eta]$[2, 2, 1][1] - 
            864*\[Eta]$[2, 3, 1][1] - 5184*I*\[Eta]$[3, 1, 1][1] - 2016*\[Eta]$[4, 1, 1][1] - 1728*I*\[Eta]$[4, 1, 2][1] - 288*\[Eta]$[4, 1, 3][1] - 1728*I*\[Eta]$[4, 2, 1][1] - 
            288*\[Eta]$[4, 3, 1][1] - 1728*I*\[Eta]$[5, 1, 1][1] - 1152*\[Eta]$[6, 1, 1][1] - 10368*I*\[Eta]$[2, 1, 1, 1][1] - 3456*I*\[Eta]$[4, 1, 1, 1][1])) /. Shift[r] /. 
      u -> u + (I*r)/2), q$[2, 3][r_:0] :> (q$[1, 4][r] /. weakqij), 
    q$[3, 4][r_:0] :> (g^8*(108 - (216*I)*u*\[Eta]$[2][1] + (36*I)*\[Eta]$[3][1] - (36*I)*u*\[Eta]$[4][1] + 
         Q0$[0]*(-108*\[Eta]$[4][1] - 216*\[Eta]$[2, 2][1] - 36*\[Eta]$[2, 4][1] + 72*\[Eta]$[3, 3][1] - 36*\[Eta]$[4, 2][1])) /. Shift[r] /. u -> u + (I*r)/2), 
    q$b[i_, j_][r_:0] :> (q$[i, j][-r] /. weakqij /. mconj), q$b[3][r_:0] :> (q$[3][-r] /. weakqij /. mconj), q$b[4][r_:0] :> (q$[4][-r] /. weakqij /. mconj), 
    q$[3][r_:0] :> (g^4*(-18 + (9*I)/u + ((6*I)/u + (18*I)*u)*\[Eta]$[2][2] - (6*I)*\[Eta]$[3][2]) + 
        g^6*(306 + (9*I)/u^3 - 9/u^2 - (153*I)/u + (-216*I - 108/u)*\[Eta]$[1][2] + ((6*I)/u^3 - (6*I)/u - (90*I)*u)*\[Eta]$[2][2] + 
          \[Zeta]$[1][0]*(216 - (108*I)/u + ((-72*I)/u - (216*I)*u)*\[Eta]$[2][2] + (72*I)*\[Eta]$[3][2]) + (-12*I - 36/u - 108*u)*\[Eta]$[3][2] + 
          (36 + (12*I)/u + (36*I)*u)*\[Eta]$[4][2] - (18*I)*\[Eta]$[5][2] + (-72/u - 216*u)*\[Eta]$[2, 1][2] + 72*\[Eta]$[3, 1][2]) + 
        g^8*((-9*(-2*I + 2*u + (17*I)*u^2 - 23*u^3 - (243*I)*u^4 + 486*u^5))/u^5 - (324*(-I + 2*u)*\[Zeta]$[3][0])/u + (4536*I - 108/u^3 - (108*I)/u^2 + 2268/u)*
           \[Eta]$[1][2] + ((6*(2*I - I*u^2 - (149*I)*u^4 + 216*u^5 - (27*I)*u^6))/u^5 + ((216*I)*(1 + 3*u^2)*\[Zeta]$[3][0])/u)*\[Eta]$[2][2] + 
          \[Zeta]$[1][0]^2*(-1296 + (648*I)/u + ((432*I)/u + (1296*I)*u)*\[Eta]$[2][2] - (432*I)*\[Eta]$[3][2]) + 
          ((12*(-3 + 6*u^2 - (8*I)*u^3 + 81*u^4))/u^3 - (216*I)*\[Zeta]$[3][0])*\[Eta]$[3][2] + (-72 + (12*I)/u^3 - (120*I)/u - (504*I)*u)*\[Eta]$[4][2] + 
          (72*I - 108/u - 324*u)*\[Eta]$[5][2] + (144 + (30*I)/u + (90*I)*u)*\[Eta]$[6][2] - (54*I)*\[Eta]$[7][2] + (2592 - (1296*I)/u)*\[Eta]$[1, 1][2] + 
          (-72/u^3 + 360/u + 1944*u)*\[Eta]$[2, 1][2] + ((-432*I)/u - (1296*I)*u)*\[Eta]$[2, 2][2] + (-72/u - 216*u)*\[Eta]$[2, 3][2] + 
          \[Zeta]$[1][0]*(-4536 - (108*I)/u^3 + 108/u^2 + (2268*I)/u + (2592*I + 1296/u)*\[Eta]$[1][2] + ((-72*I)/u^3 + (360*I)/u + (1944*I)*u)*\[Eta]$[2][2] + 
            (-144*I + 432/u + 1296*u)*\[Eta]$[3][2] + (-432 - (144*I)/u - (432*I)*u)*\[Eta]$[4][2] + (216*I)*\[Eta]$[5][2] + (864/u + 2592*u)*\[Eta]$[2, 1][2] - 
            864*\[Eta]$[3, 1][2]) + (-144 - (432*I)/u - (1296*I)*u)*\[Eta]$[3, 1][2] + (432*I)*\[Eta]$[3, 2][2] + 72*\[Eta]$[3, 3][2] + 
          (432*I - 144/u - 432*u)*\[Eta]$[4, 1][2] + 216*\[Eta]$[5, 1][2] + ((-864*I)/u - (2592*I)*u)*\[Eta]$[2, 1, 1][2] + (864*I)*\[Eta]$[3, 1, 1][2]) + 
        g^10*((9*(5*I - 5*u - (34*I)*u^2 + 43*u^3 + (252*I)*u^4 - 387*u^5 - (3241*I)*u^6 + 6482*u^7 + (36*I)*u^4*\[Zeta]$[3][0] - 36*u^5*\[Zeta]$[3][0] - 
             (876*I)*u^6*\[Zeta]$[3][0] + 1752*u^7*\[Zeta]$[3][0]))/u^7 + (2160*(-I + 2*u)*\[Zeta]$[5][0])/u + 
          ((108*(-2 - (2*I)*u + 21*u^2 + (27*I)*u^3 - 339*u^4 - (678*I)*u^5))/u^5 - ((3888*I)*(-I + 2*u)*\[Zeta]$[3][0])/u)*\[Eta]$[1][2] + 
          ((6*(5*I - (2*I)*u^2 - (149*I)*u^4 + 108*u^5 + (3626*I)*u^6 - 5400*u^7 + (2481*I)*u^8 + (36*I)*u^4*\[Zeta]$[3][0] - (276*I)*u^6*\[Zeta]$[3][0] - (1332*I)*u^8*
                \[Zeta]$[3][0]))/u^7 - ((1440*I)*(1 + 3*u^2)*\[Zeta]$[5][0])/u)*\[Eta]$[2][2] + \[Zeta]$[1][0]^3*(5184 - (2592*I)/u + ((-1728*I)/u - (5184*I)*u)*\[Eta]$[2][2] + 
            (1728*I)*\[Eta]$[3][2]) + ((-12*(6 - 6*u^2 + (9*I)*u^3 - 432*u^4 - (698*I)*u^5 + 351*u^6 + 108*u^4*\[Zeta]$[3][0] - (48*I)*u^5*\[Zeta]$[3][0] + 324*u^6*
                \[Zeta]$[3][0]))/u^5 + (1440*I)*\[Zeta]$[5][0])*\[Eta]$[3][2] + ((24*(I - (5*I)*u^2 - (34*I)*u^4 + 108*u^5 + (162*I)*u^6))/u^5 + 
            (144*(4*I + 9*u + (12*I)*u^2)*\[Zeta]$[3][0])/u)*\[Eta]$[4][2] + ((36*(-3 + 15*u^2 - (20*I)*u^3 + 99*u^4))/u^3 - (792*I)*\[Zeta]$[3][0])*\[Eta]$[5][2] + 
          (-504 + (30*I)/u^3 - (462*I)/u - (1746*I)*u)*\[Eta]$[6][2] + (432*I - 324/u - 972*u)*\[Eta]$[7][2] + (504 + (84*I)/u + (252*I)*u)*\[Eta]$[8][2] - 
          (168*I)*\[Eta]$[9][2] + (-64800 - (1296*I)/u^3 + 1296/u^2 + (32400*I)/u)*\[Eta]$[1, 1][2] + (15552*I + 7776/u)*\[Eta]$[1, 2][2] + 
          (2592 - (1296*I)/u)*\[Eta]$[1, 3][2] + ((-72*(2 - 5*u^2 - 117*u^4 - (216*I)*u^5 + 117*u^6))/u^5 - (2592*(1 + 3*u^2)*\[Zeta]$[3][0])/u)*\[Eta]$[2, 1][2] + 
          ((-432*I)/u^3 + (3888*I)/u + (16848*I)*u)*\[Eta]$[2, 2][2] + (-72/u^3 + 2088/u + 7128*u)*\[Eta]$[2, 3][2] + ((-864*I)/u - (2592*I)*u)*\[Eta]$[2, 4][2] + 
          (-144/u - 432*u)*\[Eta]$[2, 5][2] + ((432*(-I + (6*I)*u^2 + 6*u^3 + (39*I)*u^4))/u^3 + 2592*\[Zeta]$[3][0])*\[Eta]$[3, 1][2] + 
          \[Zeta]$[1][0]^2*(32400 + (648*I)/u^3 - 648/u^2 - (16200*I)/u + (-15552*I - 7776/u)*\[Eta]$[1][2] + ((432*I)/u^3 - (3888*I)/u - (16848*I)*u)*\[Eta]$[2][2] + 
            (2592*I - 2592/u - 7776*u)*\[Eta]$[3][2] + (2592 + (864*I)/u + (2592*I)*u)*\[Eta]$[4][2] - (1296*I)*\[Eta]$[5][2] + (-5184/u - 15552*u)*\[Eta]$[2, 1][2] + 
            5184*\[Eta]$[3, 1][2]) + (-2592*I + 2592/u + 7776*u)*\[Eta]$[3, 2][2] + (-1872 - (432*I)/u - (1296*I)*u)*\[Eta]$[3, 3][2] + (864*I)*\[Eta]$[3, 4][2] + 
          144*\[Eta]$[3, 5][2] + (-2592*I - 144/u^3 + 2016/u + 7776*u)*\[Eta]$[4, 1][2] + (-2592 - (864*I)/u - (2592*I)*u)*\[Eta]$[4, 2][2] + 
          (432*I - 144/u - 432*u)*\[Eta]$[4, 3][2] + (-1728 - (1296*I)/u - (3888*I)*u)*\[Eta]$[5, 1][2] + (1296*I)*\[Eta]$[5, 2][2] + 216*\[Eta]$[5, 3][2] + 
          (1728*I - 360/u - 1080*u)*\[Eta]$[6, 1][2] + 648*\[Eta]$[7, 1][2] + (31104*I + 15552/u)*\[Eta]$[1, 1, 1][2] + ((-864*I)/u^3 + (7776*I)/u + (33696*I)*u)*
           \[Eta]$[2, 1, 1][2] + (5184/u + 15552*u)*\[Eta]$[2, 1, 2][2] + ((-864*I)/u - (2592*I)*u)*\[Eta]$[2, 1, 3][2] + (5184/u + 15552*u)*\[Eta]$[2, 2, 1][2] + 
          ((-864*I)/u - (2592*I)*u)*\[Eta]$[2, 3, 1][2] + \[Zeta]$[1][0]*((108*(-2*I + 2*u + (21*I)*u^2 - 27*u^3 - (339*I)*u^4 + 678*u^5))/u^5 + 
            (3888*(-I + 2*u)*\[Zeta]$[3][0])/u + (-64800*I + 1296/u^3 + (1296*I)/u^2 - 32400/u)*\[Eta]$[1][2] + 
            (((-72*I)*(2 - 5*u^2 - 117*u^4 - (216*I)*u^5 + 117*u^6))/u^5 - ((2592*I)*(1 + 3*u^2)*\[Zeta]$[3][0])/u)*\[Eta]$[2][2] + 
            ((-432*(-1 + 6*u^2 - (6*I)*u^3 + 39*u^4))/u^3 + (2592*I)*\[Zeta]$[3][0])*\[Eta]$[3][2] + (2592 - (144*I)/u^3 + (2016*I)/u + (7776*I)*u)*\[Eta]$[4][2] + 
            (-1728*I + 1296/u + 3888*u)*\[Eta]$[5][2] + (-1728 - (360*I)/u - (1080*I)*u)*\[Eta]$[6][2] + (648*I)*\[Eta]$[7][2] + (-31104 + (15552*I)/u)*\[Eta]$[1, 1][2] + 
            (864/u^3 - 7776/u - 33696*u)*\[Eta]$[2, 1][2] + ((5184*I)/u + (15552*I)*u)*\[Eta]$[2, 2][2] + (864/u + 2592*u)*\[Eta]$[2, 3][2] + 
            (5184 + (5184*I)/u + (15552*I)*u)*\[Eta]$[3, 1][2] - (5184*I)*\[Eta]$[3, 2][2] - 864*\[Eta]$[3, 3][2] + (-5184*I + 1728/u + 5184*u)*\[Eta]$[4, 1][2] - 
            2592*\[Eta]$[5, 1][2] + ((10368*I)/u + (31104*I)*u)*\[Eta]$[2, 1, 1][2] - (10368*I)*\[Eta]$[3, 1, 1][2]) + (-5184*I + 5184/u + 15552*u)*\[Eta]$[3, 1, 1][2] - 
          5184*\[Eta]$[3, 1, 2][2] + (864*I)*\[Eta]$[3, 1, 3][2] - 5184*\[Eta]$[3, 2, 1][2] + (864*I)*\[Eta]$[3, 3, 1][2] + (-5184 - (1728*I)/u - (5184*I)*u)*
           \[Eta]$[4, 1, 1][2] + (2592*I)*\[Eta]$[5, 1, 1][2] + (10368/u + 31104*u)*\[Eta]$[2, 1, 1, 1][2] - 10368*\[Eta]$[3, 1, 1, 1][2]) /. Shift[r] /. u -> u + (I*r)/2), 
    q$[4][r_:0] :> (g^4*((-3*I)/u - 6*\[Eta]$[2][2] + (2/u + 6*u)*\[Eta]$[3][2] - 2*\[Eta]$[4][2]) + g^6*((-3*I)/u^3 + 9/u^2 + (30*I)/u + (36*\[Eta]$[1][2])/u - 
          30*\[Eta]$[2][2] + (-36*I + 2/u^3 + 12/u + 12*u)*\[Eta]$[3][2] + (-30 + (12*I)/u + (36*I)*u)*\[Eta]$[4][2] + 
          \[Zeta]$[1][0]*((36*I)/u + 72*\[Eta]$[2][2] + (-24/u - 72*u)*\[Eta]$[3][2] + 24*\[Eta]$[4][2]) + (-12*I + 6/u + 18*u)*\[Eta]$[5][2] - 8*\[Eta]$[6][2] - 
          (72*I)*\[Eta]$[2, 1][2] + ((24*I)/u + (72*I)*u)*\[Eta]$[3, 1][2] - (24*I)*\[Eta]$[4, 1][2]) + g^8*((6*(-I + 3*u + (8*I)*u^2 - 21*u^3 - (56*I)*u^4))/u^5 - 
          ((108*I)*\[Zeta]$[3][0])/u + (36/u^3 + (108*I)/u^2 - 504/u)*\[Eta]$[1][2] + ((12*(18*I + 31*u))/u - 216*\[Zeta]$[3][0])*\[Eta]$[2][2] + 
          ((-4*(-1 - 3*u^2 + 3*u^4 + (9*I)*u^5 + 30*u^6))/u^5 + (72*(1 + 3*u^2)*\[Zeta]$[3][0])/u)*\[Eta]$[3][2] + 
          \[Zeta]$[1][0]^2*((-216*I)/u - 432*\[Eta]$[2][2] + (144/u + 432*u)*\[Eta]$[3][2] - 144*\[Eta]$[4][2]) + ((12*(I + (2*I)*u^2 + 7*u^3 - (6*I)*u^4))/u^3 - 
            72*\[Zeta]$[3][0])*\[Eta]$[4][2] + (-168*I + 6/u^3 - 72*u)*\[Eta]$[5][2] + (-66 + (48*I)/u + (144*I)*u)*\[Eta]$[6][2] + (-60*I + 18/u + 54*u)*\[Eta]$[7][2] - 
          28*\[Eta]$[8][2] + ((432*I)*\[Eta]$[1, 1][2])/u - (72*I)*\[Eta]$[2, 1][2] + 432*\[Eta]$[2, 2][2] - (72*I)*\[Eta]$[2, 3][2] + 
          (432 + (24*I)/u^3 + (48*I)/u - (144*I)*u)*\[Eta]$[3, 1][2] + (-144/u - 432*u)*\[Eta]$[3, 2][2] + ((24*I)/u + (72*I)*u)*\[Eta]$[3, 3][2] + 
          \[Zeta]$[1][0]*((36*I)/u^3 - 108/u^2 - (504*I)/u - (432*\[Eta]$[1][2])/u + 72*\[Eta]$[2][2] + (432*I - 24/u^3 - 48/u + 144*u)*\[Eta]$[3][2] + 
            (264 - (144*I)/u - (432*I)*u)*\[Eta]$[4][2] + (144*I - 72/u - 216*u)*\[Eta]$[5][2] + 96*\[Eta]$[6][2] + (864*I)*\[Eta]$[2, 1][2] + 
            ((-288*I)/u - (864*I)*u)*\[Eta]$[3, 1][2] + (288*I)*\[Eta]$[4, 1][2]) + (-264*I - 144/u - 432*u)*\[Eta]$[4, 1][2] + 144*\[Eta]$[4, 2][2] - (24*I)*\[Eta]$[4, 3][2] + 
          (144 + (72*I)/u + (216*I)*u)*\[Eta]$[5, 1][2] - (96*I)*\[Eta]$[6, 1][2] + 864*\[Eta]$[2, 1, 1][2] + (-288/u - 864*u)*\[Eta]$[3, 1, 1][2] + 288*\[Eta]$[4, 1, 1][2]) + 
        g^10*((3*(-5*I + 15*u + (38*I)*u^2 - 93*u^3 - (223*I)*u^4 + 540*u^5 + (1288*I)*u^6 - (36*I)*u^4*\[Zeta]$[3][0] + 108*u^5*\[Zeta]$[3][0] + 
             (528*I)*u^6*\[Zeta]$[3][0]))/u^7 + ((720*I)*\[Zeta]$[5][0])/u + ((72*(1 + (3*I)*u - 10*u^2 - (27*I)*u^3 + 90*u^4))/u^5 + (1296*\[Zeta]$[3][0])/u)*\[Eta]$[1][2] + 
          ((-24*(-9*I + 27*u + (162*I)*u^2 + 191*u^3 + 3*u^3*\[Zeta]$[3][0]))/u^3 + 1440*\[Zeta]$[5][0])*\[Eta]$[2][2] + 
          ((-2*(-5 - 12*u^2 + 6*u^4 - (54*I)*u^5 + 489*u^6 - (972*I)*u^7 - 672*u^8 - 36*u^4*\[Zeta]$[3][0] - 72*u^6*\[Zeta]$[3][0] + (648*I)*u^7*\[Zeta]$[3][0] + 288*u^8*
                \[Zeta]$[3][0]))/u^7 - (480*(1 + 3*u^2)*\[Zeta]$[5][0])/u)*\[Eta]$[3][2] + 
          ((12*(2*I + (2*I)*u^2 + (16*I)*u^4 + 17*u^5 + (36*I)*u^4*\[Zeta]$[3][0] - 78*u^5*\[Zeta]$[3][0] + (108*I)*u^6*\[Zeta]$[3][0]))/u^5 + 480*\[Zeta]$[5][0])*\[Eta]$[4][2] + 
          \[Zeta]$[1][0]^3*((864*I)/u + 1728*\[Eta]$[2][2] + (-576/u - 1728*u)*\[Eta]$[3][2] + 576*\[Eta]$[4][2]) + 
          ((12*(1 + (35*I)*u^5 + 24*u^6))/u^5 + (24*(11 - (18*I)*u + 33*u^2)*\[Zeta]$[3][0])/u)*\[Eta]$[5][2] + 
          ((6*(8*I + (4*I)*u^2 + 77*u^3 - (84*I)*u^4))/u^3 - 336*\[Zeta]$[3][0])*\[Eta]$[6][2] + (-552*I + 18/u^3 - 72/u - 432*u)*\[Eta]$[7][2] + 
          (-120 + (168*I)/u + (504*I)*u)*\[Eta]$[8][2] + (-240*I + 56/u + 168*u)*\[Eta]$[9][2] - 96*\[Eta]$[10][2] + ((432*I)/u^3 - 1296/u^2 - (7776*I)/u)*\[Eta]$[1, 1][2] - 
          (2592*\[Eta]$[1, 2][2])/u + ((432*I)*\[Eta]$[1, 3][2])/u + (((1296*I)*(2*I + 3*u))/u - (2592*I)*\[Zeta]$[3][0])*\[Eta]$[2, 1][2] - 1296*\[Eta]$[2, 2][2] + 
          (1656*I)*\[Eta]$[2, 3][2] + 864*\[Eta]$[2, 4][2] - (144*I)*\[Eta]$[2, 5][2] + ((-48*(-I - I*u^2 + I*u^4 + 27*u^5))/u^5 + ((864*I)*(1 + 3*u^2)*\[Zeta]$[3][0])/u)*
           \[Eta]$[3, 1][2] + (2592*I - 144/u^3 + 288/u + 2592*u)*\[Eta]$[3, 2][2] + (432 + (24*I)/u^3 - (528*I)/u - (1872*I)*u)*\[Eta]$[3, 3][2] + 
          (-288/u - 864*u)*\[Eta]$[3, 4][2] + ((48*I)/u + (144*I)*u)*\[Eta]$[3, 5][2] + \[Zeta]$[1][0]^2*((-216*I)/u^3 + 648/u^2 + (3888*I)/u + (2592*\[Eta]$[1][2])/u + 
            1296*\[Eta]$[2][2] + (-2592*I + 144/u^3 - 288/u - 2592*u)*\[Eta]$[3][2] + (-1008 + (864*I)/u + (2592*I)*u)*\[Eta]$[4][2] + 
            (-864*I + 432/u + 1296*u)*\[Eta]$[5][2] - 576*\[Eta]$[6][2] - (5184*I)*\[Eta]$[2, 1][2] + ((1728*I)/u + (5184*I)*u)*\[Eta]$[3, 1][2] - (1728*I)*\[Eta]$[4, 1][2]) + 
          ((48*(-3 + 6*u^2 + (37*I)*u^3 + 54*u^4))/u^3 - (864*I)*\[Zeta]$[3][0])*\[Eta]$[4, 1][2] + (1008 - (864*I)/u - (2592*I)*u)*\[Eta]$[4, 2][2] + 
          (312*I - 144/u - 432*u)*\[Eta]$[4, 3][2] + 288*\[Eta]$[4, 4][2] - (48*I)*\[Eta]$[4, 5][2] + (1440 + (72*I)/u^3 - (288*I)/u - (1728*I)*u)*\[Eta]$[5, 1][2] + 
          (864*I - 432/u - 1296*u)*\[Eta]$[5, 2][2] + (144 + (72*I)/u + (216*I)*u)*\[Eta]$[5, 3][2] + (-408*I - 576/u - 1728*u)*\[Eta]$[6, 1][2] + 576*\[Eta]$[6, 2][2] - 
          (96*I)*\[Eta]$[6, 3][2] + (720 + (216*I)/u + (648*I)*u)*\[Eta]$[7, 1][2] - (336*I)*\[Eta]$[8, 1][2] - (5184*\[Eta]$[1, 1, 1][2])/u - 2592*\[Eta]$[2, 1, 1][2] + 
          (5184*I)*\[Eta]$[2, 1, 2][2] + 864*\[Eta]$[2, 1, 3][2] + (5184*I)*\[Eta]$[2, 2, 1][2] + 864*\[Eta]$[2, 3, 1][2] + (5184*I - 288/u^3 + 576/u + 5184*u)*
           \[Eta]$[3, 1, 1][2] + ((-1728*I)/u - (5184*I)*u)*\[Eta]$[3, 1, 2][2] + (-288/u - 864*u)*\[Eta]$[3, 1, 3][2] + ((-1728*I)/u - (5184*I)*u)*\[Eta]$[3, 2, 1][2] + 
          (-288/u - 864*u)*\[Eta]$[3, 3, 1][2] + \[Zeta]$[1][0]*((72*(I - 3*u - (10*I)*u^2 + 27*u^3 + (90*I)*u^4))/u^5 + ((1296*I)*\[Zeta]$[3][0])/u + 
            (-432/u^3 - (1296*I)/u^2 + 7776/u)*\[Eta]$[1][2] + ((-1296*(2*I + 3*u))/u + 2592*\[Zeta]$[3][0])*\[Eta]$[2][2] + 
            ((48*(-1 - u^2 + u^4 - (27*I)*u^5))/u^5 - (864*(1 + 3*u^2)*\[Zeta]$[3][0])/u)*\[Eta]$[3][2] + (((48*I)*(-3 + 6*u^2 + (37*I)*u^3 + 54*u^4))/u^3 + 
              864*\[Zeta]$[3][0])*\[Eta]$[4][2] + (1440*I - 72/u^3 + 288/u + 1728*u)*\[Eta]$[5][2] + (408 - (576*I)/u - (1728*I)*u)*\[Eta]$[6][2] + 
            (720*I - 216/u - 648*u)*\[Eta]$[7][2] + 336*\[Eta]$[8][2] - ((5184*I)*\[Eta]$[1, 1][2])/u - (2592*I)*\[Eta]$[2, 1][2] - 5184*\[Eta]$[2, 2][2] + 
            (864*I)*\[Eta]$[2, 3][2] + (-5184 - (288*I)/u^3 + (576*I)/u + (5184*I)*u)*\[Eta]$[3, 1][2] + (1728/u + 5184*u)*\[Eta]$[3, 2][2] + 
            ((-288*I)/u - (864*I)*u)*\[Eta]$[3, 3][2] + (2016*I + 1728/u + 5184*u)*\[Eta]$[4, 1][2] - 1728*\[Eta]$[4, 2][2] + (288*I)*\[Eta]$[4, 3][2] + 
            (-1728 - (864*I)/u - (2592*I)*u)*\[Eta]$[5, 1][2] + (1152*I)*\[Eta]$[6, 1][2] - 10368*\[Eta]$[2, 1, 1][2] + (3456/u + 10368*u)*\[Eta]$[3, 1, 1][2] - 
            3456*\[Eta]$[4, 1, 1][2]) + (2016 - (1728*I)/u - (5184*I)*u)*\[Eta]$[4, 1, 1][2] + (1728*I)*\[Eta]$[4, 1, 2][2] + 288*\[Eta]$[4, 1, 3][2] + 
          (1728*I)*\[Eta]$[4, 2, 1][2] + 288*\[Eta]$[4, 3, 1][2] + (1728*I - 864/u - 2592*u)*\[Eta]$[5, 1, 1][2] + 1152*\[Eta]$[6, 1, 1][2] + (10368*I)*\[Eta]$[2, 1, 1, 1][2] + 
          ((-3456*I)/u - (10368*I)*u)*\[Eta]$[3, 1, 1, 1][2] + (3456*I)*\[Eta]$[4, 1, 1, 1][2]) /. Shift[r] /. u -> u + (I*r)/2)}; 


cdres[r_, s_, n_] := 2*(-1)^n*Sin[(Pi/2)*(r - s)]*(((2*n + r + (s - 1))!*(2*n + r + s)!)/(n!*(n + r)!*(n + s)!*(n + r + s)!))*\[Zeta]$[2*n + r + s][0]; 


$\[Delta]QCorrectiontoH = False; 
$\[Delta]QCorrectiontoHLeadSuppress = 0; 
leadweak[order_ /; IntegerQ[order] && order > 0] := {q$[1][_:0] -> 1,q$b[1][_:0] -> 1, U$b[r_:0]^2 :> (U$[-r]^2 /. leadweak[order] /. mconj), 
    U$b[r_:0] :> (U$[-r] /. leadweak[order] /. mconj), U$[r_:0]^2 :> Normal[Series[Normal[U$[r]^2 /. weak], {g, 0, 2*order + 2}]], 
    U$[r_:0] :> Normal[Series[Normal[U$[r] /. weak], {g, 0, 2*order}]], V$[r_:0] :> Normal[Series[Normal[U$[r] /. weak], {g, 0, 2*order}]], 
    Q$[r_:0] :> Q0$[r] + 1/12 - Normal[Series[Subscript[v, 0]^2 /. weak, {g, 0, 2*order - 2}]], 
    xxx:q$[2][_:0] | q$b[2][_:0] :> Normal[Expand /@ Series[xxx /. weak, {g, 0, 2*order - 2}]], 
    Subscript[v, 0] :> Normal[Series[Normal[Subscript[v, 0] /. weak], {g, 0, 2*order - 2}]], xxx:q$[1, 2][_:0] | q$b[1, 2][_:0] :> 
     Normal[Series[Normal[xxx /. weakqij], {g, 0, -2 + 2*order}]], xxx:q$[3, 4][_:0] | q$b[3, 4][_:0] :> 
     If[order > 1, Print["Not precomputed yet"], Normal[Series[Normal[xxx /. weakqij], {g, 0, 6 + 2*order}]]], 
    xxx:q$[_, _][_:0] | q$b[_, _][_:0] :> Normal[Series[Normal[xxx /. weakqij], {g, 0, 2 + 2*order}]], 
    xxx:q$[3][_:0] | q$[4][_:0] | q$b[3][_:0] | q$b[4][_:0] :> Normal[Series[Normal[xxx /. weakqij], {g, 0, 2 + 2*order}]], 
    W$[s_][r_:0] :> Collect[Normal[Series[q$[3][s]*q$b[4][-s] + q$[4][s]*q$b[3][-s] /. leadweak[order], {g, 0, 8 + 2*(order - 1)}]] /. Shift[r] /. 
       u -> u + (I*r)/2, {g, \[Eta]$[__][_]*\[Eta]$b[__][_], \[Eta]$[__][_], \[Eta]$b[__][_]}, Simplify], 
    Hr2 :> Collect[Normal[Series[(U$b[0]^2*(q$[2, 4][1] + 2*q$[1, 4][1]*q$b[2][0] + q$[1, 3][1]*q$b[2][0]^2))/(Q$[-1]*Q$[1]^2) /. 
         xxx:U$b[0]^2 | q$[__][1] | q$b[_][0] | Q$[_] :> Collect[xxx /. leadweak[order], g, Hold], {g, 0, 2*order + 6}]], g, 
      Collect[ReleaseHold[#1], Flatten[{\[Eta]list}], apartQswise[Together[#1]] & ] & ], 
    Hr1 :> If[$\[Delta]QCorrectiontoH, g^Range[8, 2*(order - $\[Delta]QCorrectiontoHLeadSuppress) + 6, 2] . Take[(Hr1 /. weak)[[3]], 
        {1, 2*(order - $\[Delta]QCorrectiontoHLeadSuppress) - 1, 2}], 0], H$[r_:0] :> (Hr1 + Hr2 /. leadweak[order] /. Shift[r] /. u -> u + (I*r)/2), 
    H$b[r_:0] :> (Hr1 + Hr2 /. leadweak[order] /. mconj /. Shift[r] /. u -> u + (I*r)/2), OverBar[\[Alpha]] :> (\[Alpha] /. leadweak[order] /. mconj), 
    \[Alpha] :> Collect[Collect[\[Alpha] /. weak, g] /. g^(a_ /; a > 2*order + 6) -> 0, Flatten[{g, \[Eta]0list, Subscript[\[Zeta], __]}]], 
    f$[r_:0] :> (Normal[Series[1 - 6*I*g^2*\[Eta]$[1][1] + g^4*(24*I*\[Eta]$[1][1] - 18*\[Eta]$[1][1]^2 - 6*I*\[Eta]$[3][1]) + 
          g^6*(-168*I*\[Eta]$[1][1] + 144*\[Eta]$[1][1]^2 + 36*I*\[Eta]$[1][1]^3 + 24*I*\[Eta]$[3][1] - 36*\[Eta]$[1][1]*\[Eta]$[3][1] - 12*I*\[Eta]$[5][1]), 
         {g, 0, 2*order - 2}]] /. Shift[r] /. u -> u + (I*r)/2), f$b[r_:0] :> (f$[-r] /. leadweak[order] /. mconj), 
    \[ScriptCapitalF]$[r_:0] :> Normal[Series[\[ScriptCapitalF]$[r] /. weak, {g, 0, 2*order - 2}]],h$h[r_:0] :> Normal[Series[h$h[r] /. weak, {g, 0, 2*order}]], Subscript[\[Gamma], 0] :> 
     Normal[Series[Normal[Subscript[\[Gamma], 0] /. weak], {g, 0, 2*order}]], 
    drphase :> Normal[(Collect[Expand[#1], {x$h[0], \[Zeta]$[__][0]}, Simplify] & ) /@ 
       Series[-2*I*Sum[((cdres[r, s, n]*g^(r + s + 2*n))/x$h[0]^r)*((1/y$h[-1])^s - (1/y$h[1])^s), {r, 2, 2*order, 2}, {s, 1, order - r/2 + 1, 2}, 
           {n, 0, order - r/2 - s + 1}] /. y$h[r_:0] :> (y$h[r] /. subJuk /. leadweak[order]), {g, 0, 2*order + 2}]]}; 


(* leadweak with old version of H *)
$\[Delta]QCorrectiontoH = False; 
$\[Delta]QCorrectiontoHLeadSuppress = 0; 
oldHleadweak[order_ /; IntegerQ[order] && order > 0] := 
   {q$[1][_:0]->1,U$b[r_:0]^2 :> (U$[-r]^2 /. leadweak[order] /. mconj), 
    U$b[r_:0] :> (U$[-r] /. leadweak[order] /. mconj), 
    U$[r_:0]^2 :> Normal[Series[Normal[U$[r]^2 /. weak], 
       {g, 0, 2*order + 2}]], U$[r_:0] :> 
     Normal[Series[Normal[U$[r] /. weak], {g, 0, 2*order}]], 
    V$[r_:0] :> Normal[Series[Normal[U$[r] /. weak], 
       {g, 0, 2*order}]], Q$[r_:0] :> Q0$[r] + 1/12 - 
      Normal[Series[Subscript[v, 0]^2 /. weak, 
        {g, 0, 2*order - 2}]], xxx:q$[2][_:0] | q$b[2][_:0] :> 
     Normal[Expand /@ Series[xxx /. weak, {g, 0, 2*order - 2}]], 
    Subscript[v, 0] :> Normal[Series[Normal[Subscript[v, 0] /. 
         weak], {g, 0, 2*order - 2}]], 
    xxx:q$[1, 2][_:0] | q$b[1, 2][_:0] :> 
     Normal[Series[Normal[xxx /. weakqij], {g, 0, -2 + 2*order}]], 
    xxx:q$[3, 4][_:0] | q$b[3, 4][_:0] :> 
     If[order > 1, Print["Not precomputed yet"], 
      Normal[Series[Normal[xxx /. weakqij], 
        {g, 0, 6 + 2*order}]]], 
    xxx:q$[_, _][_:0] | q$b[_, _][_:0] :> 
     Normal[Series[Normal[xxx /. weakqij], {g, 0, 2 + 2*order}]], 
    xxx:q$[3][_:0] | q$[4][_:0] | q$b[3][_:0] | q$b[4][_:0] :> 
     Normal[Series[Normal[xxx /. weakqij], {g, 0, 2 + 2*order}]], 
    W$[s_][r_:0] :> Collect[
      Normal[Series[q$[3][s]*q$b[4][-s] + q$[4][s]*q$b[3][-s] /. 
           leadweak[order], {g, 0, 8 + 2*(order - 1)}]] /. 
        Shift[r] /. u -> u + (I*r)/2, 
      {g, \[Eta]$[__][_]*\[Eta]$b[__][_], \[Eta]$[__][_], \[Eta]$b[__][_]}, 
      Simplify], Hr2 :> Normal[
      (Collect[#1, {\[Eta]$[__][_]*\[Eta]$b[__][_], \[Eta]$[__][_], 
          \[Eta]$b[__][_], Q0$[1]^_*Q0$[-1]^_, Q0$[1], Q0$[-1]}, 
         Expand] & ) /@ Series[
        (U$b[0]^2*(q$[2, 4][1] + 2*q$[1, 4][1]*q$b[2][0] + 
            q$[1, 3][1]*q$b[2][0]^2))/(Q$[-1]*Q$[1]^2) /. 
         leadweak[order], {g, 0, 2*order + 6}]], 
    Hr1 :> If[$\[Delta]QCorrectiontoH, 
      g^Range[8, 2*(order - $\[Delta]QCorrectiontoHLeadSuppress) + 6, 
         2] . Take[(Hr1 /. weak)[[3]], 
        {1, 2*(order - $\[Delta]QCorrectiontoHLeadSuppress) - 1, 2}], 
      0], H$[r_:0] :> (Hr1 + Hr2 /. leadweak[order] /. Shift[r] /. 
      u -> u + (I*r)/2), H$b[r_:0] :> 
     (Hr1 + Hr2 /. leadweak[order] /. mconj /. Shift[r] /. 
      u -> u + (I*r)/2), OverBar[\[Alpha]] :> 
     (\[Alpha] /. leadweak[order] /. mconj), 
    \[Alpha] :> Collect[Collect[\[Alpha] /. weak, g] /. 
       g^(a_ /; a > 2*order + 6) -> 0, 
      Flatten[{g, \[Eta]0list, Subscript[\[Zeta], __]}]], 
    Subscript[\[Gamma], 0] :> Normal[
      Series[Normal[Subscript[\[Gamma], 0] /. weak], {g, 0, 2*order}]], 
    drphase :> Normal[(Collect[Expand[#1], {x$h[0], \[Zeta]$[__][0]}, 
         Simplify] & ) /@ Series[
        -2*I*Sum[((cdres[r, s, n]*g^(r + s + 2*n))/x$h[0]^r)*
            ((1/y$h[-1])^s - (1/y$h[1])^s), {r, 2, 2*order, 2}, 
           {s, 1, order - r/2 + 1, 2}, {n, 0, order - r/2 - s + 
             1}] /. y$h[r_:0] :> (y$h[r] /. subJuk /. 
           leadweak[order]), {g, 0, 2*order + 2}]]}; 


subsupl = {Kr1 -> (1/8)*(1 + 4*Subscript[v, 0]^2)*(I*Sqrt[1 - (4*g^2)/(-(I/2) + Subscript[v, 0])^2] + 
       2*Subscript[v, 0]*Sqrt[1 - (4*g^2)/(-(I/2) + Subscript[v, 0])^2] - I*Sqrt[1 - (4*g^2)/(I/2 + Subscript[v, 0])^2] + 
       2*Subscript[v, 0]*Sqrt[1 - (4*g^2)/(I/2 + Subscript[v, 0])^2]), 
    Kr2 -> (1/2)*(I*Sqrt[1 - (4*g^2)/(-(I/2) + Subscript[v, 0])^2] - 2*Subscript[v, 0]*Sqrt[1 - (4*g^2)/(-(I/2) + Subscript[v, 0])^2] - 
       I*Sqrt[1 - (4*g^2)/(I/2 + Subscript[v, 0])^2] - 2*Subscript[v, 0]*Sqrt[1 - (4*g^2)/(I/2 + Subscript[v, 0])^2])}; 


repABC = {AAA -> (1/18)*(-2*Subscript[CC, 0] + Subscript[CC, 1] - 2*Subscript[DD, 1] - Subscript[EE, 1] - 2*Subscript[II, 2] - 4*Subscript[\[ScriptCapitalI], W0, 1, lead] + 
       4*Subscript[W, 1, v0, lead]), BBB -> (-(2/9))*(-2*Subscript[CC, 0] + Subscript[CC, 1] - 2*Subscript[DD, 1] - Subscript[EE, 1] - 2*Subscript[II, 2] - 
       16*Subscript[\[ScriptCapitalI], W0, 1, lead] + 16*Subscript[W, 1, v0, lead]), 
    CCC -> (1/6)*(4*Subscript[CC, 0] + Subscript[CC, 1] + 4*Subscript[DD, 1] - Subscript[EE, 1] + 4*Subscript[II, 2] - 4*Subscript[\[ScriptCapitalI], W0, 1, lead] + 
       4*Subscript[W, 1, v0, lead])}; 


subqbasic = {q$[1][_:0] -> 1, q$b[1][_:0] -> 1, q$[1, 2][r_:0] :> Q$[r], q$b[1, 2][r_:0] :> Q$[r], q$[2, 3][r_:0] :> q$[1, 4][r], 
    q$b[2, 3][r_:0] :> q$b[1, 4][r]}; 


reprules2 = {q$[1, 3][r_:0] -> {-18*g^4*(I*((I*r)/2 + u) + Q0$[r]*\[Eta]$[2][1 + r]), g^6*(306*I*((I*r)/2 + u) + 216*((I*r)/2 + u)*\[Eta]$[1][1 + r] + 
        24*\[Eta]$[2][1 + r] + Q0$[r]*(90*\[Eta]$[2][1 + r] - 108*I*\[Eta]$[3][1 + r] - 36*\[Eta]$[4][1 + r] - 216*I*\[Eta]$[2, 1][1 + r])), 
      g^8*(-4374*I*((I*r)/2 + u) - 4536*((I*r)/2 + u)*\[Eta]$[1][1 + r] + (-84 + 1296*I*((I*r)/2 + u))*\[Eta]$[2][1 + r] + 72*(2*I + 3*((I*r)/2 + u))*\[Eta]$[3][1 + r] + 
        48*\[Eta]$[4][1 + r] + 2592*I*((I*r)/2 + u)*\[Eta]$[1, 1][1 + r] + 288*I*\[Eta]$[2, 1][1 + r] + Q0$[r]*(162*\[Eta]$[2][1 + r] + 972*I*\[Eta]$[3][1 + r] + 
          504*\[Eta]$[4][1 + r] - 324*I*\[Eta]$[5][1 + r] - 90*\[Eta]$[6][1 + r] + 1944*I*\[Eta]$[2, 1][1 + r] + 1296*\[Eta]$[2, 2][1 + r] - 216*I*\[Eta]$[2, 3][1 + r] + 
          1296*\[Eta]$[3, 1][1 + r] - 432*I*\[Eta]$[4, 1][1 + r] + 2592*\[Eta]$[2, 1, 1][1 + r]))}, 
    q$[1, 4][r_:0] -> {g^4*(-3 + 6*I*Q0$[r]*\[Eta]$[3][1 + r]), g^6*(12 - 36*I*\[Eta]$[1][1 + r] - 8*I*\[Eta]$[3][1 + r] + 
        Q0$[r]*(12*I*\[Eta]$[3][1 + r] - 36*\[Eta]$[4][1 + r] + 18*I*\[Eta]$[5][1 + r] - 72*\[Eta]$[3, 1][1 + r])), 
      g^8*(-14 + 48*I*\[Eta]$[1][1 + r] + 36*\[Eta]$[2][1 + r] - (32/3)*I*\[Eta]$[3][1 + r] + 8*\[Eta]$[4][1 + r] - 4*I*\[Eta]$[5][1 + r] + 72*\[Eta]$[1, 1][1 + r] + 
        16*\[Eta]$[3, 1][1 + r] + Q0$[r]*(-20*I*\[Eta]$[3][1 + r] + 12*\[Eta]$[4][1 + r] - 12*I*\[Eta]$[5][1 + r] - 24*\[Eta]$[6][1 + r] + 9*I*\[Eta]$[7][1 + r] + 
          24*\[Eta]$[3, 1][1 + r] - 72*I*\[Eta]$[3, 2][1 + r] - 12*\[Eta]$[3, 3][1 + r] - 72*I*\[Eta]$[4, 1][1 + r] - 36*\[Eta]$[5, 1][1 + r] - 144*I*\[Eta]$[3, 1, 1][1 + r]))}, 
    q$[2, 4][r_:0] -> {g^4*(6*I*((I*r)/2 + u) + Q0$[r]*(6*\[Eta]$[2][1 + r] + 2*\[Eta]$[4][1 + r])), 
      g^6*(-42*I*((I*r)/2 + u) - 72*((I*r)/2 + u)*\[Eta]$[1][1 + r] - 8*\[Eta]$[2][1 + r] - (8/3)*\[Eta]$[4][1 + r] + 
        Q0$[r]*(30*\[Eta]$[2][1 + r] + 36*I*\[Eta]$[3][1 + r] + 30*\[Eta]$[4][1 + r] + 12*I*\[Eta]$[5][1 + r] + 8*\[Eta]$[6][1 + r] + 72*I*\[Eta]$[2, 1][1 + r] + 
          24*I*\[Eta]$[4, 1][1 + r])), g^8*(70*I*((I*r)/2 + u) + 132*((I*r)/2 + u)*\[Eta]$[1][1 + r] + (-(26/3) - 72*I*((I*r)/2 + u))*\[Eta]$[2][1 + r] - 
        4*(2*I + 3*((I*r)/2 + u))*\[Eta]$[3][1 + r] - (22/3)*\[Eta]$[4][1 + r] - (8/3)*I*\[Eta]$[5][1 + r] - (16/9)*\[Eta]$[6][1 + r] - 
        144*I*((I*r)/2 + u)*\[Eta]$[1, 1][1 + r] - 16*I*\[Eta]$[2, 1][1 + r] - (16/3)*I*\[Eta]$[4, 1][1 + r] + 
        Q0$[r]*(-62*\[Eta]$[2][1 + r] + 6*I*\[Eta]$[3][1 + r] - 14*\[Eta]$[4][1 + r] + 28*I*\[Eta]$[5][1 + r] + 11*\[Eta]$[6][1 + r] + 10*I*\[Eta]$[7][1 + r] + 
          (14/3)*\[Eta]$[8][1 + r] + 12*I*\[Eta]$[2, 1][1 + r] - 72*\[Eta]$[2, 2][1 + r] + 12*I*\[Eta]$[2, 3][1 + r] - 72*\[Eta]$[3, 1][1 + r] + 44*I*\[Eta]$[4, 1][1 + r] - 
          24*\[Eta]$[4, 2][1 + r] + 4*I*\[Eta]$[4, 3][1 + r] - 24*\[Eta]$[5, 1][1 + r] + 16*I*\[Eta]$[6, 1][1 + r] - 144*\[Eta]$[2, 1, 1][1 + r] - 48*\[Eta]$[4, 1, 1][1 + r]))}}; 
conjreprules2 =reprules2 /. (a_ -> b_) :> ((a /. q$ -> q$b) -> (b /. mconj /. r -> -r)); 


(* ::Subsection::Closed:: *)
(*Double scaling*)


DialogTooHighOrder[xxx_]:=
DialogInput[DialogNotebook[
{TextCell["Asked order of "<>ToString[xxx]<>" is unknown.\n 
If the input of dsweak was integer, we will proceed with giving maximal known order.\n
If the input was list, we will drop any orders which are not known."],
Row[{Button["Proceed",DialogReturn[True]],TextCell["  "],
Button["Abort",DialogReturn[False]]}]
}
]];


UpdateDsReplacements[];
ClearAll[dsweak];
Default[dsweak,1]=-1;
Default[dsweak,2]=ReleaseHold;
Options[dsweak]={Only->Blank[],But->""};
$dsweakVerbose=True;
dsweak[order_.,action_.,OptionsPattern[]]/;((IntegerQ[order]||Head[order]==List)&&Head[action]=!=Rule):=
{xxx:(Alternatives@@Cases[dsweakknownsbar,Except[OptionValue[But],OptionValue[Only]]]):>(xxx/.mconj/.dsweak[order,action]/.Hold->mHold/.mconj/.mHold->Hold),
 xxx:(Alternatives@@Cases[dsweakknowns,Except[OptionValue[But],OptionValue[Only]]]):>
Block[{pos=Position[dsweakknowns,xxx][[-1,1]],len,patt},
len=Length[ dsweakexplicit[[ pos,2 ]] ];
If[(Max[order]<=len)||Not[$dsweakVerbose]||DialogTooHighOrder[xxx],
Collect[Total[dsweakexplicit[[ pos,2,If[Head[order]===List,Select[order,#<len&],1;;Min[order,len]] ]]],g,action],
Abort[];
]
]};


(* ::Subsection::Closed:: *)
(*Normal scaling*)


UpdateNsReplacements[];
ClearAll[nsweak];
Default[nsweak,1]=-1;
Default[nsweak,2]=ReleaseHold;
Options[nsweak]={Only->Blank[],But->""};
nsweak[order_.,action_.,OptionsPattern[]]/;(IntegerQ[order]&&Head[action]=!=Rule):=
Module[{mHold},
{xxx:(Alternatives@@Cases[nsweakknownsbar,Except[OptionValue[But],OptionValue[Only]]]/.Shift[_]):>(xxx/.mconj/.nsweak[order,action]/.Hold->mHold/.mconj/.mHold->Hold),
 xxx:(Alternatives@@(Cases[nsweakknowns,Except[OptionValue[But],OptionValue[Only]]]/.Shift[rrr_])):>Collect[Total[nsweakexplicit[[ Position[nsweakknowns,xxx/.Shift[-rrr]][[-1,1]],2,1;;order ]]]/.Hold->mHold/.Shift[rrr]/.u->u+(I rrr)/2/.mHold->Hold,g,action]}
];


(* ::Subsection::Closed:: *)
(*General knowledge about powers in g*)


subWq = {W$[a_][r_] :> (q$[3][a]*q$b[4][-a] + q$[4][a]*q$b[3][-a] /. Shift[r])}; 


substandardq = {q$[2, 3][r_] :> q$[1, 4][r], q$[1, 2][r_] :> (Q - \[Alpha]*(u + Subscript[v, 0]) + OverBar[\[Alpha]]*(u - Subscript[v, 0]) - \[Alpha]*OverBar[\[Alpha]] /. 
       Shift[r] /. u -> u + (I*r)/2), q$[1][r_] :> 1, xxx:q$b[__][_] :> (xxx /. mconj /. substandardq /. mconj)}; 
subq34 = {q$[3, 4][r_:0] :> ((q$[1, 3][0]*q$[2, 4][0] - q$[1, 4][0]*q$[2, 3][0])/q$[1, 2][0] /. Shift[r] /. substandardq), 
    q$[4][r_:0] :> ((q$[2][0]*q$[1, 4][1] - q$[1][0]*q$[2, 4][1])/q$[1, 2][1] /. Shift[r] /. substandardq), 
    q$[3][r_:0] :> ((q$[2][0]*q$[1, 3][1] - q$[1][0]*q$[2, 3][1])/q$[1, 2][1] /. Shift[r] /. substandardq), 
    xxx:q$b[3, 4][_] | q$b[3][_] | q$b[4][_] :> (xxx /. mconj /. subq34 /. mconj)}; 
AsymptoticApproximation[expr_] := expr /. (W$ | W$h)[_?IntegerQ][_] -> 0 /. subTQ /. subpqb /. (q$ | q$b)[3 | 4][_] -> 0 /. (q$ | q$b)[1, 2][r_:0] :> Q$[r] /. 
      (q$ | q$b)[_?IntegerQ, _?IntegerQ][_] -> 0 /. (q$ | q$b)[1][_] -> 1 /. (xxx:q$ | q$b)[2][r_:0] :> xxx[2, "as"][r]; 
subtoanalyticitystrips = {q$[1, 3][r_ /; Re[r] <= -1] :> ((1/q$[1, 2][1])*(U^2 + q$[1, 2][-1]*q$[1, 3][1]) /. Shift[r + 1] /. u -> u + (I*r)/2), 
    q$[1, 4][r_ /; Re[r] <= -1] :> ((1/q$[1, 2][1])*(q$[2][0]*U^2 + q$[1, 2][-1]*q$[1, 4][1]) /. Shift[r + 1] /. u -> u + (I*r)/2), 
    q$[2, 4][r_ /; Re[r] <= -1] :> ((1/q$[1, 2][1])*(q$[2][0]^2*U^2 + q$[1, 2][-1]*q$[2, 4][1]) /. Shift[r + 1] /. u -> u + (I*r)/2), 
    xxx:(q$b[a_, b_][r_ /; Re[r] >= 1] /; {a, b} =!= {1, 2}) :> (xxx /. mconj /. subtoanalyticitystrips /. mconj)}; 
  nspowers::asymcheck = "`1` assumed to be in the ordinary regime"; 
nspowers = {xxx:(q$[a_, b_][rp_] /; IntegerQ[a] && IntegerQ[b] && {a, b} =!= {1, 2} && {a, b} =!= {3, 4}) :> 
     (If[Re[rp] <= -1, Message[nspowers::asymcheck, q$[a, b][rp]]]; g^4*xxx), 
    xxx:(q$b[a_, b_][rm_] /; IntegerQ[a] && IntegerQ[b] && {a, b} =!= {1, 2} && {a, b} =!= {3, 4}) :> 
     (If[Re[rm] >= Plus[1], Message[nspowers::asymcheck, q$b[a, b][rm]]]; g^4*xxx), xxx:\[Alpha] | OverBar[\[Alpha]] :> g^8*xxx, 
    xxx:U$[r_] :> (If[Re[r] <= 0, Message[nspowers::asymcheck, xxx]]; g^2*xxx), xxx:h$h[r_] :> (If[r == 0, Message[nspowers::asymcheck, xxx]]; g^2*xxx), 
    U$b[r_] :> (If[Re[r] >= 0, Message[nspowers::asymcheck, U$b[r]]]; g^2*U$b[r]), xxx:(q$[2] | q$[2, "as"])[r_] :> 
     (If[Re[r] <= 0, Message[nspowers::asymcheck, xxx]]; xxx), xxx:(q$b[2] | q$b[2, "as"])[r_] :> (If[Re[r] <= 0, Message[nspowers::asymcheck, xxx]]; xxx), 
    xxx:q$[2, "corr"][r_] :> (If[Re[r] <= 0, Message[nspowers::asymcheck, xxx]]; g^8*xxx), 
    xxx:q$b[2, "corr"][r_] :> (If[Re[r] <= 0, Message[nspowers::asymcheck, xxx]]; g^8*xxx), 
    xxx:(y$h | x$h)[r_] :> (If[r == 0, Message[nspowers::asymcheck, xxx]]; xxx/g)}; 
nspowersstrict = {xxx:(q$[(a_)?IntegerQ, (b_)?IntegerQ][rp_ /; Re[rp] > -1] | q$b[(a_)?IntegerQ, (b_)?IntegerQ][rm_ /; Re[rm] < 1] /; 
       {a, b} =!= {1, 2} && {a, b} =!= {3, 4}) :> g^4*xxx, xxx:q$[3, 4][rp_ /; Re[rp] > -1] | q$b[3, 4][rm_ /; Re[rm] < 1] :> g^8*xxx, 
    xxx:\[Alpha] | OverBar[\[Alpha]] | q$[2, "corr"][rp_ /; rp > 0] | q$b[2, "corr"][rm_ /; rm < 0] :> g^8*xxx, U$[r_ /; Re[r] > 0] :> g^2*U$[r], 
    h$h[r_ /; r != 0] :> g^2*h$h[r], x$h[r_ /; r != 0] :> x$h[r]/g, y$h[r_ /; r != 0] :> y$h[r]/g, 
    xxx:Q$[1 | 2, "|", 0][r_ /; Re[r] > 0] | Q$[3 | 4, "|", 0][r_ /; Re[r] < 0] | Q$[0, "|", 3 | 4][r_ /; Re[r] > 0] :> g^2*xxx, 
    xxx:Q$[0, "|", 1][r_ /; Re[r] > 0] :> xxx, xxx:Q$[0, "|", 2][r_ /; Re[r] > 0] :> xxx/g^2}; 
dspowers = {xxx:q$[2][0] | q$[2, "as"][0] | q$b[2][0] | q$b[2, "as"][0] :> (1/g)*xxx, U$[0] :> g*U$[0], U$b[0] :> g*U$b[0], U$[-2] :> g^2*U$[-2], 
    xxx:q$[2, "corr"][0] | q$b[2, "corr"][0] :> g^6*xxx, xxx:q$[2, "corr"][-2] | q$b[2, "corr"][Plus[2]] :> g^4*xxx, 
    xxx:Q$[1 | 3, "|", 0][0] | Q$[0, "|", 1 | 3][0] :> g*xxx, xxx:Q$[2 | 4, "|", 0][0] | Q$[0, "|", 2 | 4][0] :> xxx}; 


ClearAll[Funasym, LogRatasym, Funds, LogRatds]; 
nsgenericweak[expr_, gorder_:8, toAnalyticityStrips_:True] := Block[{tmp = expr /. subTQ /. subpqb /. subWq //. subq34 //. substandardq}, 
    Series[If[toAnalyticityStrips, tmp //. subtoanalyticitystrips //. substandardq, tmp] /. nspowers, {g, 0, gorder}]]; 
nsLogRat[expr_, gorder_:8, toAnalyticityStrips_:True] := Block[{tmp, tmpas = AsymptoticApproximation[expr] /. nspowers}, 
    tmp = nsgenericweak[expr, gorder + Exponent[tmpas /. g -> 1/g, g], toAnalyticityStrips] /. If[FreeQ[tmpas, q$[2, "as"]], {}, 
        {(xxx:q$ | q$b)[2][r_] :> Expand[xxx[2, "as"][r]*(1 + xxx[2, "corr"][r]/xxx[2, "as"][r] /. nspowers)]}]; Series[Log[Normal[tmp]/tmpas], {g, 0, gorder}]]; 
dsgenericweak[expr_, gorder_:8] := Block[{}, Series[expr /. subTQ /. subpqb /. subWq //. subq34 //. substandardq //. subtoanalyticitystrips //. substandardq /. 
       dspowers /. nspowersstrict, {g, 0, gorder}]]; 
dsLogRat[expr_, gorder_:8] := Block[{tmp, tmpas = AsymptoticApproximation[expr] /. dspowers /. nspowersstrict}, 
    tmp = dsgenericweak[expr, gorder + Exponent[tmpas /. g -> 1/g, g]] /. If[FreeQ[tmpas, q$[2, "as"]], {}, 
        {(xxx:q$ | q$b)[2][r_] :> Expand[xxx[2, "as"][r]*(1 + xxx[2, "corr"][r]/xxx[2, "as"][r] /. dspowers /. nspowersstrict)]}]; 
     Series[Log[Normal[tmp]/tmpas], {g, 0, gorder}]]; 


(* ::Subsection::Closed:: *)
(*MInt and PVInt*)


Mint[k_] := ((1 + (-1)^k)*Gamma[(1 + k)/2])/(4*Sqrt[Pi]*Gamma[2 + k/2]); 
PVint[k_] := -Sum[z^(k - 2*r + 1)*((I*Gamma[r - 1/2])/(4*Sqrt[Pi]*Gamma[r + 1])), {r, -1, k/2 + 1/2}]; 


(* ::Subsection::Closed:: *)
(*Solution for \[Delta]\[Rho],\[Delta]\[Rho]2*)


solut\[Rho]sexplicit=Get[FileNameJoin[{$WeakCouplingData,"solutrhosexplicit.data"}]]; 
solut\[Rho]s = {Subscript[\[Alpha], lead][0] -> -162 + \[DoubleStruckCapitalC][(2*(I + u)*H$[lead][0])/(9*u^2)] - 
      (1/9)*\[DoubleStruckCapitalC][-((4*(I + u)*W$[1, lead][1])/Q0$[1])] + 
      \[DoubleStruckCapitalC][-((2*I*(-1 + 2*u^2 + 3*u^4 + 9*Q0$[-1]*Q0$[1])*W$h[lead][0])/
         (27*(1 + u^2)*Q0$[-1]*Q0$[1]))] - (2/9)*W$[1, v0, lead][0] + 60*\[Zeta]$[2][0] + 
      24*\[Zeta]$[2][0]^2 - (16*\[Zeta]$[2][0]^3)/5 + 156*\[Zeta]$[3][0] - 
      88*\[Zeta]$[2][0]*\[Zeta]$[3][0] + (16/5)*\[Zeta]$[2][0]^2*\[Zeta]$[3][0] - 8*\[Zeta]$[3][0]^2, 
    Subscript[\[Beta], lead][0] -> (1/30)*(-4860 + \[DoubleStruckCapitalC][((20*I - 40*u)*H$[lead][0])/u^2] + 
       20*\[DoubleStruckCapitalC][-((4*(I + u)*W$[1, lead][1])/Q0$[1])] + 
       \[DoubleStruckCapitalC][(20*I*(1 + 16*u^2 + 15*u^4 - 9*Q0$[-1]*Q0$[1])*W$h[lead][0])/
         (3*(1 + u^2)*Q0$[-1]*Q0$[1])] + 100*W$[1, v0, lead][0] + 11880*\[Zeta]$[2][0] - 
       5616*\[Zeta]$[2][0]^2 + 576*\[Zeta]$[2][0]^3 - 5400*\[Zeta]$[3][0] + 
       720*\[Zeta]$[2][0]*\[Zeta]$[3][0] + 288*\[Zeta]$[2][0]^2*\[Zeta]$[3][0] + 1440*\[Zeta]$[3][0]^2), 
    Subscript[\[Alpha], lead][1] -> 648 + \[DoubleStruckCapitalC][-((8*(I + u)*H$[lead][0])/(9*u^2))] + 
      (4/9)*\[DoubleStruckCapitalC][-((4*(I + u)*W$[1, lead][1])/Q0$[1])] + 
      \[DoubleStruckCapitalC][-((8*I*(4 + 10*u^2 + 6*u^4 - 9*Q0$[-1]*Q0$[1])*W$h[lead][0])/
         (27*(1 + u^2)*Q0$[-1]*Q0$[1]))] - (16/9)*W$[1, v0, lead][0] - 
      240*\[Zeta]$[2][0] - 96*\[Zeta]$[2][0]^2 + (64*\[Zeta]$[2][0]^3)/5 - 624*\[Zeta]$[3][0] + 
      352*\[Zeta]$[2][0]*\[Zeta]$[3][0] - (64/5)*\[Zeta]$[2][0]^2*\[Zeta]$[3][0] + 32*\[Zeta]$[3][0]^2, 
    Subscript[\[Beta], lead][1] -> 0, Subscript[\[Alpha], lead][2] -> 0, 
    Subscript[\[Beta], lead][2] -> 0, Subscript[\[Alpha], lead][3] -> 0, 
    Subscript[\[Beta], lead][3] -> 0, Subscript[\[Alpha], lead][4] -> 0, 
    Subscript[\[Beta], lead][4] -> 0, Subscript[\[Alpha], lead][5] -> 0, 
    Subscript[\[Beta], lead][5] -> 0, Subscript[\[Alpha], sublead][0] -> 
     2826 + \[DoubleStruckCapitalC][(4*I*(1 + 3*u^2)*H$[lead][0])/(9*u^4) + (2*(I + u)*H$[sublead][0])/
         (9*u^2)] - (1/9)*\[DoubleStruckCapitalC][-((4*(I + 2*u)^2*(1 + I*u + u^2)*W$[1, lead][1])/
           (3*u^2*(I + u)*Q0$[1]^2)) - (4*(I + u)*W$[1, sublead][1])/Q0$[1]] + 
      \[DoubleStruckCapitalC][(1/(243*(1 + u^2)^2*Q0$[-1]^2*Q0$[1]^2))*(4*I*(13 + 765*u^8 + 324*u^10 - 
           27*Q0$[-1]*Q0$[1] - 405*Q0$[-1]^2*Q0$[1]^2 + 
           u^4*(370 - 189*Q0$[-1]*Q0$[1]) + u^6*(615 - 81*Q0$[-1]*Q0$[1]) - 
           3*u^2*(-37 + 45*Q0$[-1]*Q0$[1] + 135*Q0$[-1]^2*Q0$[1]^2))*W$h[lead][0]) - 
        (2*I*(24*u^4 + 45*u^6 + 27*u^8 + u^2*(7 - 18*Q0$[-1]*Q0$[1]) + 
           (1 - 9*Q0$[-1]*Q0$[1])^2)*W$h[sublead][0])/(243*(1 + u^2)*Q0$[-1]^2*
          Q0$[1]^2)] - (4/3)*W$[1, v0, lead][0] - (2/9)*W$[1, v0, sublead][0] + 
      420*\[Zeta]$[2][0] - 720*\[Zeta]$[2][0]^2 + (1328*\[Zeta]$[2][0]^3)/5 - 
      (288*\[Zeta]$[2][0]^4)/175 - 2748*\[Zeta]$[3][0] - 1256*\[Zeta]$[2][0]*\[Zeta]$[3][0] + 
      (784/5)*\[Zeta]$[2][0]^2*\[Zeta]$[3][0] - (256/35)*\[Zeta]$[2][0]^3*\[Zeta]$[3][0] + 
      1552*\[Zeta]$[3][0]^2 + 96*\[Zeta]$[2][0]*\[Zeta]$[3][0]^2 - 468*\[Zeta]$[5][0] + 
      504*\[Zeta]$[2][0]*\[Zeta]$[5][0] - (48/5)*\[Zeta]$[2][0]^2*\[Zeta]$[5][0] - 
      192*\[Zeta]$[3][0]*\[Zeta]$[5][0], Subscript[\[Beta], sublead][0] -> 
     7992 + \[DoubleStruckCapitalC][(2*(2*I - I*u^2 + 8*u^3)*H$[lead][0])/(3*u^4) + 
        ((2*I - 4*u)*H$[sublead][0])/(3*u^2)] + 
      \[DoubleStruckCapitalC][(8*(1 - 3*I*u + u^2*(1 - 12*Q0$[1]) + 8*I*u^3*(-1 + 3*Q0$[1]) + 
           4*u^4*(-1 + 3*Q0$[1]))*W$[1, lead][1])/(9*u^2*(I + u)*Q0$[1]^2) - 
        (8*(I + u)*W$[1, sublead][1])/(3*Q0$[1])] + 
      \[DoubleStruckCapitalC][-((1/(81*(1 + u^2)^2*Q0$[-1]^2*Q0$[1]^2))*(2*I*(64 + 2736*u^8 + 1296*u^10 - 
            261*Q0$[-1]*Q0$[1] - 729*Q0$[-1]^2*Q0$[1]^2 + 
            u^4*(1096 - 963*Q0$[-1]*Q0$[1]) + u^6*(1776 - 351*Q0$[-1]*Q0$[1]) - 
            9*u^2*(-48 + 97*Q0$[-1]*Q0$[1] + 81*Q0$[-1]^2*Q0$[1]^2))*W$h[lead][0])) + 
        (2*I*(5 + 120*u^4 + 225*u^6 + 135*u^8 - 36*Q0$[-1]*Q0$[1] - 
           81*Q0$[-1]^2*Q0$[1]^2 + u^2*(35 - 36*Q0$[-1]*Q0$[1]))*W$h[sublead][0])/
         (81*(1 + u^2)*Q0$[-1]^2*Q0$[1]^2)] + (26/3)*W$[1, v0, lead][0] + 
      (10/3)*W$[1, v0, sublead][0] - 8208*\[Zeta]$[2][0] + (7416*\[Zeta]$[2][0]^2)/5 + 
      (8496*\[Zeta]$[2][0]^3)/35 - (16416*\[Zeta]$[2][0]^4)/175 - 5040*\[Zeta]$[3][0] + 
      3840*\[Zeta]$[2][0]*\[Zeta]$[3][0] - (576/5)*\[Zeta]$[2][0]^2*\[Zeta]$[3][0] - 
      (768/35)*\[Zeta]$[2][0]^3*\[Zeta]$[3][0] - 432*\[Zeta]$[3][0]^2 + 
      288*\[Zeta]$[2][0]*\[Zeta]$[3][0]^2 + 3780*\[Zeta]$[5][0] - 1512*\[Zeta]$[2][0]*\[Zeta]$[5][0] - 
      (144/5)*\[Zeta]$[2][0]^2*\[Zeta]$[5][0] - 1008*\[Zeta]$[3][0]*\[Zeta]$[5][0], 
    Subscript[\[Alpha], sublead][1] -> -6120 + \[DoubleStruckCapitalC][(16*(1 - 3*I*u)*H$[lead][0])/(9*u^3) - 
        (8*(I + u)*H$[sublead][0])/(9*u^2)] + 
      \[DoubleStruckCapitalC][-((16*(-1 + 8*I*u^3 + 4*u^4 + 6*Q0$[1] - 3*I*u*(-1 + 4*Q0$[1]) - 
            u^2*(1 + 6*Q0$[1]))*W$[1, lead][1])/(27*u^2*(I + u)*Q0$[1]^2)) - 
        (16*(I + u)*W$[1, sublead][1])/(9*Q0$[1])] + 
      \[DoubleStruckCapitalC][-((1/(243*u^2*(1 + u^2)^3*Q0$[-1]^2*Q0$[1]^2))*
          (16*I*(1251*u^12 + 324*u^14 - 243*Q0$[-1]^2*Q0$[1]^2 + 
            6*u^10*(314 + 81*Q0$[-1]*Q0$[1]) + u^8*(1519 + 1782*Q0$[-1]*Q0$[1]) + 
            u^4*(124 + 882*Q0$[-1]*Q0$[1] - 2106*Q0$[-1]^2*Q0$[1]^2) + 
            u^2*(7 + 162*Q0$[-1]*Q0$[1] - 1863*Q0$[-1]^2*Q0$[1]^2) + 
            u^6*(679 + 2016*Q0$[-1]*Q0$[1] - 810*Q0$[-1]^2*Q0$[1]^2))*W$h[lead][0])) - 
        (8*I*(2 + 48*u^4 + 90*u^6 + 54*u^8 + 18*Q0$[-1]*Q0$[1] - 
           81*Q0$[-1]^2*Q0$[1]^2 + 2*u^2*(7 + 9*Q0$[-1]*Q0$[1]))*W$h[sublead][0])/
         (243*(1 + u^2)*Q0$[-1]^2*Q0$[1]^2)] - (32/3)*W$[1, v0, lead][0] - 
      (16/9)*W$[1, v0, sublead][0] - 7728*\[Zeta]$[2][0] + (23808*\[Zeta]$[2][0]^2)/5 - 
      (7616*\[Zeta]$[2][0]^3)/5 + (640*\[Zeta]$[2][0]^4)/7 + 15312*\[Zeta]$[3][0] + 
      4832*\[Zeta]$[2][0]*\[Zeta]$[3][0] - (8512/5)*\[Zeta]$[2][0]^2*\[Zeta]$[3][0] - 
      (4096/35)*\[Zeta]$[2][0]^3*\[Zeta]$[3][0] - 5440*\[Zeta]$[3][0]^2 - 
      384*\[Zeta]$[2][0]*\[Zeta]$[3][0]^2 - 7152*\[Zeta]$[5][0] + 2720*\[Zeta]$[2][0]*\[Zeta]$[5][0] + 
      192*\[Zeta]$[2][0]^2*\[Zeta]$[5][0] + 1024*\[Zeta]$[3][0]*\[Zeta]$[5][0], 
    Subscript[\[Beta], sublead][1] -> \[DoubleStruckCapitalC][-((8*(-I + 2*u + 3*u^3)*H$[lead][0])/(3*u^4))] + 
      \[DoubleStruckCapitalC][-((16*(2*I + 2*u + 3*I*u^2 + 3*u^3)*W$[1, lead][1])/(3*u^2*Q0$[1]))] + 
      \[DoubleStruckCapitalC][(8*I*u^2*(-2 + 90*u^4 + 18*u^6 - 45*Q0$[-1]*Q0$[1] + 
          u^2*(70 - 9*Q0$[-1]*Q0$[1]))*W$h[lead][0])/(9*(1 + u^2)^3*Q0$[-1]*Q0$[1])] - 
      48*W$[1, v0, lead][0] + 432*\[Zeta]$[2][0] - (25632*\[Zeta]$[2][0]^2)/5 + 
      (86976*\[Zeta]$[2][0]^3)/35 - (44544*\[Zeta]$[2][0]^4)/175 + 2160*\[Zeta]$[3][0] + 
      2016*\[Zeta]$[2][0]*\[Zeta]$[3][0] + (2304/5)*\[Zeta]$[2][0]^2*\[Zeta]$[3][0] - 
      (1536/7)*\[Zeta]$[2][0]^3*\[Zeta]$[3][0] - 2016*\[Zeta]$[3][0]^2 + 3744*\[Zeta]$[5][0] - 
      2112*\[Zeta]$[2][0]*\[Zeta]$[5][0] + (1152/5)*\[Zeta]$[2][0]^2*\[Zeta]$[5][0] - 
      768*\[Zeta]$[3][0]*\[Zeta]$[5][0], Subscript[\[Alpha], sublead][2] -> 
     -10368 + \[DoubleStruckCapitalC][-((32*(I + u)*H$[lead][0])/(9*u^4))] + 
      (4/9)*\[DoubleStruckCapitalC][-((16*(I + u)*W$[1, lead][1])/(u^2*Q0$[1]))] + 
      \[DoubleStruckCapitalC][(32*I*(168*u^8 + 45*u^10 - 27*Q0$[-1]*Q0$[1] + 
          u^6*(188 - 45*Q0$[-1]*Q0$[1]) - 16*u^4*(-5 + 9*Q0$[-1]*Q0$[1]) - 
          3*u^2*(-5 + 54*Q0$[-1]*Q0$[1]))*W$h[lead][0])/(27*u^2*(1 + u^2)^3*Q0$[-1]*
         Q0$[1])] + (32/3)*W$[1, v0, lead][0] + 12096*\[Zeta]$[2][0] - 
      (18816*\[Zeta]$[2][0]^2)/5 + (4608*\[Zeta]$[2][0]^3)/5 - (29696*\[Zeta]$[2][0]^4)/175 - 
      8640*\[Zeta]$[3][0] + 384*\[Zeta]$[2][0]*\[Zeta]$[3][0] + (10752/5)*\[Zeta]$[2][0]^2*
       \[Zeta]$[3][0] + (2048/7)*\[Zeta]$[2][0]^3*\[Zeta]$[3][0] - 1536*\[Zeta]$[3][0]^2 + 
      18048*\[Zeta]$[5][0] - 9472*\[Zeta]$[2][0]*\[Zeta]$[5][0] - (1536/5)*\[Zeta]$[2][0]^2*
       \[Zeta]$[5][0] - 512*\[Zeta]$[3][0]*\[Zeta]$[5][0], Subscript[\[Beta], sublead][2] -> 0, 
    Subscript[\[Alpha], sublead][3] -> 0, Subscript[\[Beta], sublead][3] -> 0, 
    Subscript[\[Alpha], sublead][4] -> 0, Subscript[\[Beta], sublead][4] -> 0, 
    Subscript[\[Alpha], sublead][5] -> 0, Subscript[\[Beta], sublead][5] -> 0, 
    Subscript[\[Alpha], sublead2][0] -> -32166 + 
      \[DoubleStruckCapitalC][(2*(6*I + 14*I*u^2 + u^3 + 2*I*u^4 + 23*u^5)*H$[lead][0])/(9*u^6) + 
        (4*I*(1 + 3*u^2)*H$[sublead][0])/(9*u^4) + (2*(I + u)*H$[sublead2][0])/
         (9*u^2)] + \[DoubleStruckCapitalC][-((1/(81*u^4*(I + u)^3*Q0$[1]^3))*
          (4*(1 - 10*I*u + 180*I*u^9 + 36*u^10 + u^4*(61 - 153*Q0$[1]^2) - 
            9*u^2*(5 + Q0$[1]^2) + 4*I*u^3*(25 + 9*Q0$[1]^2) - 
            4*I*u^7*(154 + 207*Q0$[1]^2) - u^8*(424 + 207*Q0$[1]^2) + 
            2*I*u^5*(101 + 396*Q0$[1]^2) + 3*u^6*(178 + 411*Q0$[1]^2))*
           W$[1, lead][1])) + (4*(I + 2*u)^2*(1 + I*u + u^2)*W$[1, sublead][1])/
         (27*u^2*(I + u)*Q0$[1]^2) + (4*(I + u)*W$[1, sublead2][1])/(9*Q0$[1])] + 
      \[DoubleStruckCapitalC][-((1/(2187*u^2*(1 + u^2)^4*Q0$[-1]^3*Q0$[1]^3))*
          (2*I*(232092*u^16 + 130248*u^18 + 30618*u^20 - 3645*Q0$[-1]^3*Q0$[1]^3 + 
            162*u^14*(1445 + 36*Q0$[-1]*Q0$[1]) + u^10*(55520 + 37368*Q0$[-1]*Q0$[1] - 
              9639*Q0$[-1]^2*Q0$[1]^2) - 9*u^12*(-15380 - 2664*Q0$[-1]*Q0$[1] + 
              189*Q0$[-1]^2*Q0$[1]^2) + u^6*(7436 + 7128*Q0$[-1]*Q0$[1] - 
              32724*Q0$[-1]^2*Q0$[1]^2 - 102789*Q0$[-1]^3*Q0$[1]^3) + 
            u^8*(18866 + 26352*Q0$[-1]*Q0$[1] - 25272*Q0$[-1]^2*Q0$[1]^2 - 
              32076*Q0$[-1]^3*Q0$[1]^3) - u^2*(-226 + 216*Q0$[-1]*Q0$[1] + 
              4293*Q0$[-1]^2*Q0$[1]^2 + 51759*Q0$[-1]^3*Q0$[1]^3) - 
            u^4*(-2036 + 216*Q0$[-1]*Q0$[1] + 19683*Q0$[-1]^2*Q0$[1]^2 + 
              118827*Q0$[-1]^3*Q0$[1]^3))*W$h[lead][0])) + 
        (4*I*(10 + 277*u^4 + 408*u^6 + 549*u^8 + 243*u^10 - 405*Q0$[-1]^2*Q0$[1]^2 + 
           u^2*(87 - 405*Q0$[-1]^2*Q0$[1]^2))*W$h[sublead][0])/
         (243*(1 + u^2)^2*Q0$[-1]^2*Q0$[1]^2) - 
        (2*I*(24*u^4 + 45*u^6 + 27*u^8 + u^2*(7 - 18*Q0$[-1]*Q0$[1]) + 
           (1 - 9*Q0$[-1]*Q0$[1])^2)*W$h[sublead2][0])/(243*(1 + u^2)*Q0$[-1]^2*
          Q0$[1]^2)] + (38/9)*W$[1, v0, lead][0] - (4/3)*W$[1, v0, sublead][0] - 
      (2/9)*W$[1, v0, sublead2][0] - 14340*\[Zeta]$[2][0] + (65064*\[Zeta]$[2][0]^2)/5 + 
      (234112*\[Zeta]$[2][0]^3)/35 - (345088*\[Zeta]$[2][0]^4)/175 + (6016*\[Zeta]$[2][0]^5)/175 + 
      7740*\[Zeta]$[3][0] + 4696*\[Zeta]$[2][0]*\[Zeta]$[3][0] - (70624/5)*\[Zeta]$[2][0]^2*
       \[Zeta]$[3][0] - (12864/35)*\[Zeta]$[2][0]^3*\[Zeta]$[3][0] + (384/25)*\[Zeta]$[2][0]^4*
       \[Zeta]$[3][0] + 14312*\[Zeta]$[3][0]^2 + 5280*\[Zeta]$[2][0]*\[Zeta]$[3][0]^2 - 
      (192/5)*\[Zeta]$[2][0]^2*\[Zeta]$[3][0]^2 - 1056*\[Zeta]$[3][0]^3 + 27132*\[Zeta]$[5][0] + 
      3112*\[Zeta]$[2][0]*\[Zeta]$[5][0] + (6288/5)*\[Zeta]$[2][0]^2*\[Zeta]$[5][0] + 
      (768/35)*\[Zeta]$[2][0]^3*\[Zeta]$[5][0] - 24352*\[Zeta]$[3][0]*\[Zeta]$[5][0] - 
      1632*\[Zeta]$[2][0]*\[Zeta]$[3][0]*\[Zeta]$[5][0] + 648*\[Zeta]$[5][0]^2 + 1404*\[Zeta]$[7][0] - 
      3816*\[Zeta]$[2][0]*\[Zeta]$[7][0] + (144/5)*\[Zeta]$[2][0]^2*\[Zeta]$[7][0] + 
      2880*\[Zeta]$[3][0]*\[Zeta]$[7][0], Subscript[\[Beta], sublead2][0] -> 
     -210762 + \[DoubleStruckCapitalC][-((2*(-6*I + 6*I*u^2 + 5*u^3 + 3*I*u^4 + 93*u^5)*H$[lead][0])/
          (3*u^6)) + (2*(2*I - I*u^2 + 8*u^3)*H$[sublead][0])/(3*u^4) + 
        ((2*I - 4*u)*H$[sublead2][0])/(3*u^2)] + 
      \[DoubleStruckCapitalC][(1/(27*u^4*(I + u)^3*Q0$[1]^3))*(4*(2 - 20*I*u + 360*I*u^9 + 72*u^10 + 
           u^8*(-848 + 96*Q0$[1] - 837*Q0$[1]^2) + u^4*(122 - 144*Q0$[1] - 
             567*Q0$[1]^2) + 20*I*u^3*(10 - 6*Q0$[1] + 9*Q0$[1]^2) - 
           3*u^2*(30 - 8*Q0$[1] + 15*Q0$[1]^2) + 4*I*u^5*(101 - 42*Q0$[1] + 
             792*Q0$[1]^2) - 4*I*u^7*(308 - 96*Q0$[1] + 837*Q0$[1]^2) + 
           3*u^6*(356 - 168*Q0$[1] + 1659*Q0$[1]^2))*W$[1, lead][1]) + 
        (8*(1 - 3*I*u + u^2*(1 - 12*Q0$[1]) + 8*I*u^3*(-1 + 3*Q0$[1]) + 
           4*u^4*(-1 + 3*Q0$[1]))*W$[1, sublead][1])/(9*u^2*(I + u)*Q0$[1]^2) - 
        (8*(I + u)*W$[1, sublead2][1])/(3*Q0$[1])] + 
      \[DoubleStruckCapitalC][(1/(729*u^2*(1 + u^2)^4*Q0$[-1]^3*Q0$[1]^3))*
         (2*I*(264870*u^18 + 61236*u^20 - 9477*Q0$[-1]^3*Q0$[1]^3 + 
           216*u^16*(2269 + 216*Q0$[-1]*Q0$[1]) + 162*u^14*
            (3247 + 1382*Q0$[-1]*Q0$[1]) + u^10*(133048 + 471348*Q0$[-1]*Q0$[1] - 
             127818*Q0$[-1]^2*Q0$[1]^2) + u^12*(335592 + 439452*Q0$[-1]*Q0$[1] - 
             27702*Q0$[-1]^2*Q0$[1]^2) + u^8*(32668 + 303336*Q0$[-1]*Q0$[1] - 
             252882*Q0$[-1]^2*Q0$[1]^2 - 57591*Q0$[-1]^3*Q0$[1]^3) - 
           2*u^2*(-241 - 558*Q0$[-1]*Q0$[1] + 12150*Q0$[-1]^2*Q0$[1]^2 + 
             53946*Q0$[-1]^3*Q0$[1]^3) - 4*u^4*(-832 - 4743*Q0$[-1]*Q0$[1] + 
             32238*Q0$[-1]^2*Q0$[1]^2 + 58320*Q0$[-1]^3*Q0$[1]^3) - 
           2*u^6*(-4745 - 56034*Q0$[-1]*Q0$[1] + 128709*Q0$[-1]^2*Q0$[1]^2 + 
             96228*Q0$[-1]^3*Q0$[1]^3))*W$h[lead][0]) - 
        (1/(81*(1 + u^2)^2*Q0$[-1]^2*Q0$[1]^2))*(2*I*(51 + 879*u^6 + 1800*u^8 + 
           945*u^10 - 144*Q0$[-1]*Q0$[1] - 729*Q0$[-1]^2*Q0$[1]^2 - 
           9*u^4*(-77 + 16*Q0$[-1]*Q0$[1]) + u^2*(328 - 288*Q0$[-1]*Q0$[1] - 
             729*Q0$[-1]^2*Q0$[1]^2))*W$h[sublead][0]) + 
        (2*I*(5 + 120*u^4 + 225*u^6 + 135*u^8 - 36*Q0$[-1]*Q0$[1] - 
           81*Q0$[-1]^2*Q0$[1]^2 + u^2*(35 - 36*Q0$[-1]*Q0$[1]))*W$h[sublead2][0])/
         (81*(1 + u^2)*Q0$[-1]^2*Q0$[1]^2)] - 116*W$[1, v0, lead][0] + 
      (26/3)*W$[1, v0, sublead][0] + (10/3)*W$[1, v0, sublead2][0] + 
      114876*\[Zeta]$[2][0] + (155376*\[Zeta]$[2][0]^2)/5 - (241104*\[Zeta]$[2][0]^3)/7 + 
      (100608*\[Zeta]$[2][0]^4)/25 + (57216*\[Zeta]$[2][0]^5)/175 + 133884*\[Zeta]$[3][0] - 
      15240*\[Zeta]$[2][0]*\[Zeta]$[3][0] + 8256*\[Zeta]$[2][0]^2*\[Zeta]$[3][0] + 
      (19776/35)*\[Zeta]$[2][0]^3*\[Zeta]$[3][0] + (1152/25)*\[Zeta]$[2][0]^4*\[Zeta]$[3][0] - 
      40584*\[Zeta]$[3][0]^2 - 16416*\[Zeta]$[2][0]*\[Zeta]$[3][0]^2 - 
      (576/5)*\[Zeta]$[2][0]^2*\[Zeta]$[3][0]^2 - 1440*\[Zeta]$[3][0]^3 - 9648*\[Zeta]$[5][0] - 
      17088*\[Zeta]$[2][0]*\[Zeta]$[5][0] - (3456/5)*\[Zeta]$[2][0]^2*\[Zeta]$[5][0] + 
      (2304/35)*\[Zeta]$[2][0]^3*\[Zeta]$[5][0] + 36240*\[Zeta]$[3][0]*\[Zeta]$[5][0] - 
      4896*\[Zeta]$[2][0]*\[Zeta]$[3][0]*\[Zeta]$[5][0] + 2592*\[Zeta]$[5][0]^2 - 42444*\[Zeta]$[7][0] + 
      18360*\[Zeta]$[2][0]*\[Zeta]$[7][0] + (432/5)*\[Zeta]$[2][0]^2*\[Zeta]$[7][0] + 
      9936*\[Zeta]$[3][0]*\[Zeta]$[7][0], Subscript[\[Alpha], sublead2][1] -> 
     -47304 + \[DoubleStruckCapitalC][(8*(-I + u - 2*I*u^2 + u^3 + 5*I*u^4 - 10*u^5)*H$[lead][0])/
         (9*u^6) + (16*(1 - 3*I*u)*H$[sublead][0])/(9*u^3) - 
        (8*(I + u)*H$[sublead2][0])/(9*u^2)] + 
      \[DoubleStruckCapitalC][(1/(81*u^4*(I + u)^3*Q0$[1]^3))*(16*(180*I*u^9 + 36*u^10 + 
           (1 + 3*Q0$[1])^2 - 2*I*u^3*(-50 + 21*Q0$[1]) + 
           u^4*(61 - 126*Q0$[1] - 135*Q0$[1]^2) - 9*u^2*(5 + 4*Q0$[1] + 5*Q0$[1]^2) - 
           2*I*u*(5 + 15*Q0$[1] + 18*Q0$[1]^2) - 8*I*u^7*(77 + 45*Q0$[1]^2) - 
           2*u^8*(212 + 45*Q0$[1]^2) + 3*u^6*(178 + 8*Q0$[1] + 183*Q0$[1]^2) + 
           2*I*u^5*(101 + 48*Q0$[1] + 198*Q0$[1]^2))*W$[1, lead][1]) - 
        (16*(-1 + 8*I*u^3 + 4*u^4 + 6*Q0$[1] - 3*I*u*(-1 + 4*Q0$[1]) - 
           u^2*(1 + 6*Q0$[1]))*W$[1, sublead][1])/(27*u^2*(I + u)*Q0$[1]^2) - 
        (16*(I + u)*W$[1, sublead2][1])/(9*Q0$[1])] + 
      \[DoubleStruckCapitalC][(1/(2187*u^4*(1 + u^2)^5*Q0$[-1]^3*Q0$[1]^3))*
         (8*I*(156492*u^22 + 30618*u^24 + 2187*Q0$[-1]^3*Q0$[1]^3 + 
           20412*u^2*Q0$[-1]^3*Q0$[1]^3 + 54*u^20*(6149 + 54*Q0$[-1]*Q0$[1]) - 
           108*u^18*(-3541 + 144*Q0$[-1]*Q0$[1]) + 36*u^16*
            (7109 - 3645*Q0$[-1]*Q0$[1] + 756*Q0$[-1]^2*Q0$[1]^2) + 
           2*u^14*(56590 - 152118*Q0$[-1]*Q0$[1] + 71037*Q0$[-1]^2*Q0$[1]^2) + 
           u^8*(15598 - 25344*Q0$[-1]*Q0$[1] + 215946*Q0$[-1]^2*Q0$[1]^2 - 
             284310*Q0$[-1]^3*Q0$[1]^3) + u^10*(36748 - 142812*Q0$[-1]*Q0$[1] + 
             347814*Q0$[-1]^2*Q0$[1]^2 - 233280*Q0$[-1]^3*Q0$[1]^3) + 
           u^6*(2976 + 3672*Q0$[-1]*Q0$[1] + 64152*Q0$[-1]^2*Q0$[1]^2 - 
             88938*Q0$[-1]^3*Q0$[1]^3) + u^12*(57442 - 306504*Q0$[-1]*Q0$[1] + 
             303426*Q0$[-1]^2*Q0$[1]^2 - 58320*Q0$[-1]^3*Q0$[1]^3) + 
           u^4*(196 + 1224*Q0$[-1]*Q0$[1] + 7452*Q0$[-1]^2*Q0$[1]^2 + 
             26973*Q0$[-1]^3*Q0$[1]^3))*W$h[lead][0]) - 
        (1/(243*u^2*(1 + u^2)^3*Q0$[-1]^2*Q0$[1]^2))*(16*I*(1845*u^12 + 486*u^14 - 
           243*Q0$[-1]^2*Q0$[1]^2 + 6*u^10*(455 + 54*Q0$[-1]*Q0$[1]) + 
           u^8*(2119 + 1242*Q0$[-1]*Q0$[1]) + u^4*(178 + 558*Q0$[-1]*Q0$[1] - 
             2106*Q0$[-1]^2*Q0$[1]^2) + u^2*(13 + 108*Q0$[-1]*Q0$[1] - 
             1863*Q0$[-1]^2*Q0$[1]^2) + u^6*(913 + 1368*Q0$[-1]*Q0$[1] - 
             810*Q0$[-1]^2*Q0$[1]^2))*W$h[sublead][0]) - 
        (8*I*(2 + 48*u^4 + 90*u^6 + 54*u^8 + 18*Q0$[-1]*Q0$[1] - 
           81*Q0$[-1]^2*Q0$[1]^2 + 2*u^2*(7 + 9*Q0$[-1]*Q0$[1]))*W$h[sublead2][0])/
         (243*(1 + u^2)*Q0$[-1]^2*Q0$[1]^2)] + (848/9)*W$[1, v0, lead][0] - 
      (32/3)*W$[1, v0, sublead][0] - (16/9)*W$[1, v0, sublead2][0] + 
      135600*\[Zeta]$[2][0] - 113856*\[Zeta]$[2][0]^2 - (277184*\[Zeta]$[2][0]^3)/35 + 
      (1561472*\[Zeta]$[2][0]^4)/175 - (128256*\[Zeta]$[2][0]^5)/175 + 122544*\[Zeta]$[3][0] - 
      11520*\[Zeta]$[2][0]*\[Zeta]$[3][0] + (251456/5)*\[Zeta]$[2][0]^2*\[Zeta]$[3][0] + 
      (9216/7)*\[Zeta]$[2][0]^3*\[Zeta]$[3][0] + (20736/25)*\[Zeta]$[2][0]^4*\[Zeta]$[3][0] - 
      80512*\[Zeta]$[3][0]^2 - 22272*\[Zeta]$[2][0]*\[Zeta]$[3][0]^2 + 3456*\[Zeta]$[3][0]^3 - 
      119472*\[Zeta]$[5][0] + 17504*\[Zeta]$[2][0]*\[Zeta]$[5][0] + (704/5)*\[Zeta]$[2][0]^2*
       \[Zeta]$[5][0] - (1024/35)*\[Zeta]$[2][0]^3*\[Zeta]$[5][0] + 44160*\[Zeta]$[3][0]*\[Zeta]$[5][0] + 
      1920*\[Zeta]$[2][0]*\[Zeta]$[3][0]*\[Zeta]$[5][0] + 352*\[Zeta]$[5][0]^2 + 72960*\[Zeta]$[7][0] - 
      34112*\[Zeta]$[2][0]*\[Zeta]$[7][0] - (6912/5)*\[Zeta]$[2][0]^2*\[Zeta]$[7][0] - 
      5824*\[Zeta]$[3][0]*\[Zeta]$[7][0], Subscript[\[Beta], sublead2][1] -> 
     -3456 + \[DoubleStruckCapitalC][(8*(2*I + 2*I*u^2 + 15*u^3 + 2*I*u^4 + 50*u^5)*H$[lead][0])/(3*u^6) - 
        (8*(-I + 2*u + 3*u^3)*H$[sublead][0])/(3*u^4)] + 
      \[DoubleStruckCapitalC][(16*(2 - 6*I*u + u^2*(5 - 45*Q0$[1]) + 5*I*u^3*(-5 + 18*Q0$[1]) - 
           5*u^4*(1 + 21*Q0$[1]) + 12*I*u^5*(-2 + 25*Q0$[1]) + 6*u^6*(-2 + 25*Q0$[1]))*
          W$[1, lead][1])/(9*u^4*(I + u)*Q0$[1]^2) - 
        (16*(I + u)*(2 + 3*u^2)*W$[1, sublead][1])/(3*u^2*Q0$[1])] + 
      \[DoubleStruckCapitalC][-((1/(81*(1 + u^2)^4*Q0$[-1]^2*Q0$[1]^2))*(16*I*(41 + 4995*u^12 + 
            1134*u^14 - 387*Q0$[-1]*Q0$[1] - 405*Q0$[-1]^2*Q0$[1]^2 + 
            9*u^10*(941 + 21*Q0$[-1]*Q0$[1]) + 9*u^8*(875 + 176*Q0$[-1]*Q0$[1]) + 
            u^4*(2449 - 1701*Q0$[-1]*Q0$[1] - 2673*Q0$[-1]^2*Q0$[1]^2) + 
            u^2*(481 - 2034*Q0$[-1]*Q0$[1] - 2430*Q0$[-1]^2*Q0$[1]^2) + 
            u^6*(6060 + 1341*Q0$[-1]*Q0$[1] - 648*Q0$[-1]^2*Q0$[1]^2))*
           W$h[lead][0])) - (1/(9*(1 + u^2)^3*Q0$[-1]^2*Q0$[1]^2))*
         (8*I*(2 + 198*u^10 + 54*u^12 - 18*Q0$[-1]*Q0$[1] + 
           u^6*(200 - 270*Q0$[-1]*Q0$[1]) + u^8*(282 - 72*Q0$[-1]*Q0$[1]) + 
           u^4*(78 - 286*Q0$[-1]*Q0$[1] + 9*Q0$[-1]^2*Q0$[1]^2) + 
           u^2*(18 - 106*Q0$[-1]*Q0$[1] + 45*Q0$[-1]^2*Q0$[1]^2))*W$h[sublead][0])] + 
      (1328/3)*W$[1, v0, lead][0] - 48*W$[1, v0, sublead][0] - 13968*\[Zeta]$[2][0] + 
      (449856*\[Zeta]$[2][0]^2)/5 - (927168*\[Zeta]$[2][0]^3)/35 - 
      (1466496*\[Zeta]$[2][0]^4)/175 + (270336*\[Zeta]$[2][0]^5)/175 - 37584*\[Zeta]$[3][0] - 
      17760*\[Zeta]$[2][0]*\[Zeta]$[3][0] + (24576/5)*\[Zeta]$[2][0]^2*\[Zeta]$[3][0] + 
      (39936/35)*\[Zeta]$[2][0]^3*\[Zeta]$[3][0] + (27648/25)*\[Zeta]$[2][0]^4*\[Zeta]$[3][0] - 
      11424*\[Zeta]$[3][0]^2 + 5184*\[Zeta]$[2][0]*\[Zeta]$[3][0]^2 - (1152/5)*\[Zeta]$[2][0]^2*
       \[Zeta]$[3][0]^2 + 2304*\[Zeta]$[3][0]^3 + 9648*\[Zeta]$[5][0] - 
      17184*\[Zeta]$[2][0]*\[Zeta]$[5][0] - (27648/5)*\[Zeta]$[2][0]^2*\[Zeta]$[5][0] - 
      (4608/35)*\[Zeta]$[2][0]^3*\[Zeta]$[5][0] + 28608*\[Zeta]$[3][0]*\[Zeta]$[5][0] - 
      6912*\[Zeta]$[2][0]*\[Zeta]$[3][0]*\[Zeta]$[5][0] + 6528*\[Zeta]$[5][0]^2 - 83376*\[Zeta]$[7][0] + 
      37728*\[Zeta]$[2][0]*\[Zeta]$[7][0] - (5184/5)*\[Zeta]$[2][0]^2*\[Zeta]$[7][0] + 
      20160*\[Zeta]$[3][0]*\[Zeta]$[7][0], Subscript[\[Alpha], sublead2][2] -> 
     320832 + \[DoubleStruckCapitalC][-((32*(-2 + 6*I*u + u^2 - I*u^3 + 2*u^4)*H$[lead][0])/(9*u^5)) - 
        (32*(I + u)*H$[sublead][0])/(9*u^4)] + 
      \[DoubleStruckCapitalC][-((64*(-1 + u^4*(4 - 3*Q0$[1]) + 6*Q0$[1] + 12*I*u^5*Q0$[1] + 6*u^6*Q0$[1] + 
            2*I*u^3*(4 + 3*Q0$[1]) - 3*I*u*(-1 + 4*Q0$[1]) - u^2*(1 + 9*Q0$[1]))*
           W$[1, lead][1])/(27*u^4*(I + u)*Q0$[1]^2)) - (64*(I + u)*W$[1, sublead][1])/
         (9*u^2*Q0$[1])] + \[DoubleStruckCapitalC][-((1/(243*u^4*(1 + u^2)^5*Q0$[-1]^2*Q0$[1]^2))*
          (64*I*(-270*u^18 + 81*u^20 - 243*Q0$[-1]^2*Q0$[1]^2 - 243*u^2*Q0$[-1]^2*
             Q0$[1]^2 + 9*u^16*(-313 + 15*Q0$[-1]*Q0$[1]) + 
            u^14*(-6747 + 657*Q0$[-1]*Q0$[1]) + u^10*(-3037 + 1530*Q0$[-1]*Q0$[1] - 
              486*Q0$[-1]^2*Q0$[1]^2) - 3*u^12*(2248 - 579*Q0$[-1]*Q0$[1] + 
              81*Q0$[-1]^2*Q0$[1]^2) + 9*u^6*(10 + 69*Q0$[-1]*Q0$[1] + 
              603*Q0$[-1]^2*Q0$[1]^2) + u^8*(-512 + 873*Q0$[-1]*Q0$[1] + 
              2187*Q0$[-1]^2*Q0$[1]^2) + u^4*(28 + 63*Q0$[-1]*Q0$[1] + 
              4293*Q0$[-1]^2*Q0$[1]^2))*W$h[lead][0])) + 
        (1/(81*u^2*(1 + u^2)^3*Q0$[-1]^2*Q0$[1]^2))*(32*I*(99*u^12 + 27*u^14 - 
           81*Q0$[-1]^2*Q0$[1]^2 + 3*u^10*(47 + 36*Q0$[-1]*Q0$[1]) + 
           2*u^8*(50 + 207*Q0$[-1]*Q0$[1]) + u^2*(1 + 36*Q0$[-1]*Q0$[1] - 
             486*Q0$[-1]^2*Q0$[1]^2) + u^4*(9 + 186*Q0$[-1]*Q0$[1] - 
             432*Q0$[-1]^2*Q0$[1]^2) + u^6*(39 + 456*Q0$[-1]*Q0$[1] - 
             135*Q0$[-1]^2*Q0$[1]^2))*W$h[sublead][0])] - 
      (1856/9)*W$[1, v0, lead][0] + (32/3)*W$[1, v0, sublead][0] - 87360*\[Zeta]$[2][0] + 
      (828288*\[Zeta]$[2][0]^2)/5 - (2382592*\[Zeta]$[2][0]^3)/35 + (52736*\[Zeta]$[2][0]^4)/35 + 
      (67584*\[Zeta]$[2][0]^5)/175 - 438336*\[Zeta]$[3][0] - 20864*\[Zeta]$[2][0]*\[Zeta]$[3][0] + 
      (44032/5)*\[Zeta]$[2][0]^2*\[Zeta]$[3][0] + (663552/35)*\[Zeta]$[2][0]^3*\[Zeta]$[3][0] - 
      (6144/25)*\[Zeta]$[2][0]^4*\[Zeta]$[3][0] + 45952*\[Zeta]$[3][0]^2 + 
      2304*\[Zeta]$[2][0]*\[Zeta]$[3][0]^2 + (1536/5)*\[Zeta]$[2][0]^2*\[Zeta]$[3][0]^2 + 
      1536*\[Zeta]$[3][0]^3 + 24768*\[Zeta]$[5][0] - 38784*\[Zeta]$[2][0]*\[Zeta]$[5][0] - 
      (123392/5)*\[Zeta]$[2][0]^2*\[Zeta]$[5][0] + (47104/35)*\[Zeta]$[2][0]^3*\[Zeta]$[5][0] + 
      91136*\[Zeta]$[3][0]*\[Zeta]$[5][0] + 9216*\[Zeta]$[2][0]*\[Zeta]$[3][0]*\[Zeta]$[5][0] - 
      12288*\[Zeta]$[5][0]^2 - 25152*\[Zeta]$[7][0] + 33152*\[Zeta]$[2][0]*\[Zeta]$[7][0] - 
      (16128/5)*\[Zeta]$[2][0]^2*\[Zeta]$[7][0] - 8192*\[Zeta]$[3][0]*\[Zeta]$[7][0], 
    Subscript[\[Beta], sublead2][2] -> 
     \[DoubleStruckCapitalC][-((32*(-I + 2*u + 3*u^3)*H$[lead][0])/(3*u^6))] + 
      \[DoubleStruckCapitalC][-((64*(2*I + 2*u + 3*I*u^2 + 3*u^3)*W$[1, lead][1])/(3*u^4*Q0$[1]))] + 
      \[DoubleStruckCapitalC][(32*I*u^2*(-2 + 192*u^6 + 54*u^8 + 81*Q0$[-1]*Q0$[1] - 
          18*u^2*(8 + 5*Q0$[-1]*Q0$[1]) - u^4*(4 + 27*Q0$[-1]*Q0$[1]))*W$h[lead][0])/
        (9*(1 + u^2)^5*Q0$[-1]*Q0$[1])] - (31104*\[Zeta]$[2][0]^2)/5 + 
      (1234944*\[Zeta]$[2][0]^3)/35 - (3220992*\[Zeta]$[2][0]^4)/175 + 
      (67584*\[Zeta]$[2][0]^5)/35 + 3456*\[Zeta]$[2][0]*\[Zeta]$[3][0] + 
      (52992/5)*\[Zeta]$[2][0]^2*\[Zeta]$[3][0] - 9216*\[Zeta]$[2][0]^3*\[Zeta]$[3][0] + 
      (9216/5)*\[Zeta]$[2][0]^4*\[Zeta]$[3][0] - 13824*\[Zeta]$[3][0]^2 - 10368*\[Zeta]$[5][0] - 
      52992*\[Zeta]$[2][0]*\[Zeta]$[5][0] + (33792/5)*\[Zeta]$[2][0]^2*\[Zeta]$[5][0] + 
      (12288/7)*\[Zeta]$[2][0]^3*\[Zeta]$[5][0] + 32256*\[Zeta]$[3][0]*\[Zeta]$[5][0] + 
      15360*\[Zeta]$[5][0]^2 - 31680*\[Zeta]$[7][0] + 36480*\[Zeta]$[2][0]*\[Zeta]$[7][0] - 
      6912*\[Zeta]$[2][0]^2*\[Zeta]$[7][0] - 7680*\[Zeta]$[3][0]*\[Zeta]$[7][0], 
    Subscript[\[Alpha], sublead2][3] -> 31104 + \[DoubleStruckCapitalC][-((128*(I + u)*H$[lead][0])/(9*u^6))] + 
      (4/9)*\[DoubleStruckCapitalC][-((64*(I + u)*W$[1, lead][1])/(u^4*Q0$[1]))] + 
      \[DoubleStruckCapitalC][-((1/(27*u^4*(1 + u^2)^5*Q0$[-1]*Q0$[1]))*(128*I*(144*u^14 + 27*u^16 + 
           27*Q0$[-1]*Q0$[1] + 81*u^2*Q0$[-1]*Q0$[1] + u^6*(58 - 216*Q0$[-1]*Q0$[1]) + 
           u^4*(9 - 162*Q0$[-1]*Q0$[1]) + u^10*(398 - 135*Q0$[-1]*Q0$[1]) - 
           3*u^12*(-95 + 9*Q0$[-1]*Q0$[1]) - 9*u^8*(-31 + 28*Q0$[-1]*Q0$[1]))*
          W$h[lead][0]))] + 128*W$[1, v0, lead][0] - 103680*\[Zeta]$[2][0] - 
      64512*\[Zeta]$[2][0]^2 + (337920*\[Zeta]$[2][0]^3)/7 - (1001472*\[Zeta]$[2][0]^4)/175 + 
      (45056*\[Zeta]$[2][0]^5)/35 + 228096*\[Zeta]$[3][0] + 6144*\[Zeta]$[2][0]^2*\[Zeta]$[3][0] - 
      (208896/7)*\[Zeta]$[2][0]^3*\[Zeta]$[3][0] - (12288/5)*\[Zeta]$[2][0]^4*\[Zeta]$[3][0] - 
      4608*\[Zeta]$[5][0] - 33792*\[Zeta]$[2][0]*\[Zeta]$[5][0] + (114688/5)*\[Zeta]$[2][0]^2*
       \[Zeta]$[5][0] - (16384/7)*\[Zeta]$[2][0]^3*\[Zeta]$[5][0] + 24576*\[Zeta]$[3][0]*\[Zeta]$[5][0] + 
      10240*\[Zeta]$[5][0]^2 - 211200*\[Zeta]$[7][0] + 104960*\[Zeta]$[2][0]*\[Zeta]$[7][0] + 
      9216*\[Zeta]$[2][0]^2*\[Zeta]$[7][0] - 5120*\[Zeta]$[3][0]*\[Zeta]$[7][0], 
    Subscript[\[Beta], sublead2][3] -> 0, Subscript[\[Alpha], sublead2][4] -> 0, 
    Subscript[\[Beta], sublead2][4] -> 0, Subscript[\[Alpha], sublead2][5] -> 0, 
    Subscript[\[Beta], sublead2][5] -> 0}; 


(* ::Subsection::Closed:: *)
(*ApartQs*)


PolQ = PolynomialQuotient; PolR = PolynomialRemainder; 


ClearAll[ApartQs]; 
PolynomialDegree[poly_] := Block[{tmp = List @@ Collect[Expand[poly + AAA], {u, AAA}] /. AAA -> 0}, 
    Max[Join[{0}, {(tmp[[Sequence @@ #1]] & ) /@ Position[tmp, u^(_.)] /. u^(a_.) :> a}]]]; 
Options[ApartQs] = {PowerOfu -> Automatic, Numer -> 1}; 
ApartQs[shiftsandpowers_List, OptionsPattern[]] := 
  Block[{upow = If[OptionValue[PowerOfu] === Automatic, Min[2*Total[shiftsandpowers[[All,2]]] - 1 - PolynomialDegree[OptionValue[Numer]], 1], 
      If[0 <= OptionValue[PowerOfu] <= 2*Total[shiftsandpowers[[All,2]]] - 1, OptionValue[PowerOfu], 
       Print[StringJoin["Proposed negative power of u-perfactor in the forbidden range. Choosing maximal possible instead, which is ", 
          ToString[2*Total[shiftsandpowers[[All,2]]] - 1]]]; 2*Total[shiftsandpowers[[All,2]]] - 1]], tmp, tmp2, ptmp, k, i}, 
   tmp = ptmp = (Q0$[#1[[1]]]^(-#1[[2]]) & ) /@ Flatten[(Table[{#1[[1]], k}, {k, #1[[2]]}] & ) /@ shiftsandpowers, 1]; 
    tmp2 = Plus @@ Table[((aa[i]*u + bb[i])*tmp[[i]])/u^upow, {i, Length[tmp]}]; 
    tmp = Expand[tmp2*Times @@ (Q0$[#1[[1]]]^(Plus[#1[[2]]]) & ) /@ shiftsandpowers]; 
    tmp = List @@ Collect[Expand[(Sqrt[u]*tmp /. subQ0) - Sqrt[u]*OptionValue[Numer]], u, Expand]/Sqrt[u]; 
    Collect[tmp2 /. Solve[tmp == 0, Flatten[Table[{aa[i], bb[i]}, {i, Total[shiftsandpowers[[All,2]]]}]]][[1]], ptmp, Expand]]


apartQswise[inpp_] := Block[{inp = inpp /. Hold -> Identity}, If[FreeQ[Denominator[inp], Q0$[-1]] && FreeQ[Denominator[inp], Q0$[1]], inp, 
     Block[{num = Expand[Numerator[inp] /. subQ0], den = Denominator[inp], Qs, powQs}, 
      Which[FreeQ[den, Q0$[-1]], Qs = den //. (c_.)*Q0$[1]^(b_.) :> (powQs = {{1, b}}; Q0$[1]^b), FreeQ[den, Q0$[1]], 
        Qs = den //. (c_.)*Q0$[-1]^(a_.) :> (powQs = {{-1, a}}; Q0$[-1]^a), True, 
        Qs = den //. (c_.)*Q0$[-1]^(a_.)*Q0$[1]^(b_.) :> (powQs = {{-1, a}, {1, b}}; Q0$[-1]^a*Q0$[1]^b); ]; 
       Collect[(Qs*Block[{tmp = PolQ[num, Qs /. subQ0, u]}, ApartQs[powQs, Numer -> Expand[num - Qs*tmp /. subQ0]] + tmp])/den, 
        Flatten[{\[Eta]list, Q0list, \[Zeta]$[1][0]}]]]]]; 
