(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 8.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       157,          7]
NotebookDataLength[   4475459,     129643]
NotebookOptionsPosition[   4380515,     126961]
NotebookOutlinePosition[   4381403,     126990]
CellTagsIndexPosition[   4381360,     126987]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{

Cell[CellGroupData[{
Cell["Init cell (loading packages)", "Section",
 CellChangeTimes->{{3.569019875602483*^9, 3.569019885973515*^9}, {
  3.56907637573769*^9, 3.569076375975651*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Block", "[", 
   RowBox[{
    RowBox[{"{", "Init", "}"}], ",", 
    RowBox[{
     RowBox[{
      RowBox[{"Init", "[", "]"}], ":=", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"$Path", "=", 
         RowBox[{"Cases", "[", 
          RowBox[{
           RowBox[{"DeleteDuplicates", "[", 
            RowBox[{"Prepend", "[", 
             RowBox[{"$Path", ",", "PathToFiles"}], "]"}], "]"}], ",", 
           "_String"}], "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"$Copyright", "=", "True"}], ";", "\[IndentingNewLine]", 
        RowBox[{"Get", "/@", 
         RowBox[{"{", 
          RowBox[{
          "\"\<stylepackage.m\>\"", ",", "\"\<zetafunctions.m\>\"", ",", 
           "\"\<FiNLIEKonishi.m\>\"", ",", "\"\<UpWiseIntegrate.m\>\""}], 
          "}"}]}], ";"}], ")"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"Check", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"PathToFiles", "=", 
         RowBox[{"NotebookDirectory", "[", "]"}]}], ";", 
        RowBox[{"Init", "[", "]"}]}], ",", 
       RowBox[{
        RowBox[{"PathToFiles", "=", 
         RowBox[{"InputString", "[", 
          RowBox[{
          "\"\<Please enter the name of the folder where you saved the \
packages\>\"", ",", "$UserDocumentsDirectory"}], "]"}]}], ";", 
        RowBox[{"Init", "[", "]"}]}]}], "]"}]}]}], "]"}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.569076101040699*^9, 3.569076240705756*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{
   "run", " ", "this", " ", "if", " ", "you", " ", "are", " ", "going", " ", 
    "to", " ", "use", " ", "parallel", " ", "computation", " ", "of", " ", 
    "integrals"}], " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{"DistributeDefinitions", "[", "PathToFiles", "]"}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"ParallelEvaluate", "[", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"PrependTo", "[", 
       RowBox[{"$Path", ",", "PathToFiles"}], "]"}], ";", "\n", 
      RowBox[{"Get", "/@", 
       RowBox[{"{", 
        RowBox[{
        "\"\<stylepackage.m\>\"", ",", "\"\<zetafunctions.m\>\"", ",", 
         "\"\<FiNLIEKonishi.m\>\"", ",", "\"\<UpWiseIntegrate.m\>\""}], 
        "}"}]}], ";"}], "\[IndentingNewLine]", "]"}], ";"}]}]}]], "Input",
 CellChangeTimes->{{3.560667919052945*^9, 3.560667923331307*^9}, 
   3.560676406585203*^9, {3.560680880375461*^9, 3.560680909008256*^9}, {
   3.562235198263627*^9, 3.562235202718055*^9}, {3.562304810438517*^9, 
   3.562304814211882*^9}, {3.568534233275413*^9, 3.5685342819892483`*^9}, {
   3.568534363843895*^9, 3.568534365205044*^9}, {3.568735924987678*^9, 
   3.568736007209264*^9}, {3.5687360549693604`*^9, 3.56873605948116*^9}, {
   3.568736387857119*^9, 3.568736482497726*^9}, {3.569019810941427*^9, 
   3.569019833367794*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["\<\
Right band (parameterization and large volume expressions)\
\>", "Section",
 CellChangeTimes->{{3.5502222520072813`*^9, 3.550222256086728*^9}, {
  3.568736944130444*^9, 3.568736955450905*^9}}],

Cell[CellGroupData[{

Cell["\[Rho]-parameterization", "Subsection",
 CellChangeTimes->{{3.55022664718054*^9, 3.5502266485896187`*^9}, {
  3.550226686196568*^9, 3.5502266904975758`*^9}, {3.550226739477955*^9, 
  3.550226743391844*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   SubscriptBox[
    StyleBox["\[ScriptCapitalT]",
     FontColor->RGBColor[1, 0, 0]], 
    RowBox[{"1", ",", "s"}]], "==", 
   RowBox[{"s", "+", 
    RowBox[{
     SubscriptBox["\[ScriptCapitalC]", "s"], "*", "\[Rho]"}]}]}], ",", 
  RowBox[{
   SubscriptBox[
    StyleBox["\[ScriptCapitalT]",
     FontColor->RGBColor[1, 0, 0]], 
    RowBox[{"0", ",", "s"}]], "\[Equal]", "1"}], ",", 
  RowBox[{
   SubscriptBox[
    OverscriptBox[
     StyleBox["\[ScriptCapitalT]",
      FontColor->RGBColor[1, 0, 0]], 
     StyleBox["^",
      FontColor->RGBColor[1, 0, 0]]], 
    RowBox[{"2", ",", "s"}]], "\[Equal]", 
   RowBox[{
    SuperscriptBox[
     OverscriptBox[
      StyleBox["\[ScriptCapitalT]",
       FontColor->RGBColor[1, 0, 0]], 
      StyleBox["^",
       FontColor->RGBColor[1, 0, 0]]], 
     RowBox[{"[", 
      RowBox[{"-", "s"}], "]"}]], " ", 
    SuperscriptBox[
     OverscriptBox[
      StyleBox["\[ScriptCapitalT]",
       FontColor->RGBColor[1, 0, 0]], 
      StyleBox["^",
       FontColor->RGBColor[1, 0, 0]]], 
     RowBox[{"[", "s", "]"}]]}]}]}], "\[IndentingNewLine]", 
 RowBox[{"\[Rho]", "\[Equal]", 
  RowBox[{
   SqrtBox[
    RowBox[{"1", "-", 
     SuperscriptBox["z", "2"]}]], 
   RowBox[{"r", "[", 
    RowBox[{"g", ",", "z"}], "]"}]}]}], "\[IndentingNewLine]"}], "Input",
 CellChangeTimes->{{3.5502222579853277`*^9, 3.550222412427021*^9}, {
   3.550222506064603*^9, 3.550222518539875*^9}, 3.5502229328137283`*^9, {
   3.550222971323041*^9, 3.55022298212883*^9}, 3.550226700194763*^9}]
}, Closed]],

Cell[CellGroupData[{

Cell["\[Rho]", "Subsection",
 CellChangeTimes->{{3.55022664718054*^9, 3.5502266485896187`*^9}, {
  3.550226686196568*^9, 3.55022670344972*^9}}],

Cell[BoxData[
 RowBox[{
  SubscriptBox["\[Rho]", "asym"], "==", 
  RowBox[{
   FractionBox[
    RowBox[{"2", " ", "\[ImaginaryI]", " "}], 
    RowBox[{
     RowBox[{"-", 
      SuperscriptBox[
       OverscriptBox[
        StyleBox["y",
         FontColor->RGBColor[0, 0.6, 0]], 
        StyleBox["^",
         FontColor->RGBColor[0, 0.6, 0]]], "-"]}], "+", 
     SuperscriptBox[
      OverscriptBox[
       StyleBox["y",
        FontColor->RGBColor[0, 0.6, 0]], 
       StyleBox["^",
        FontColor->RGBColor[0, 0.6, 0]]], "+"]}]], 
   SqrtBox[
    RowBox[{"1", "-", 
     SuperscriptBox["z", "2"]}]]}], "\[Equal]", 
  RowBox[{"2", "g", 
   RowBox[{"(", 
    InterpretationBox[
     RowBox[{"1", "-", 
      RowBox[{"3", " ", 
       SuperscriptBox["g", "2"]}], "+", 
      RowBox[{"21", " ", 
       SuperscriptBox["g", "4"]}], "-", 
      RowBox[{"183", " ", 
       SuperscriptBox["g", "6"]}], "+", 
      InterpretationBox[
       SuperscriptBox[
        RowBox[{"O", "[", "g", "]"}], "7"],
       SeriesData[$CellContext`g, 0, {}, 0, 7, 1],
       Editable->False]}],
     SeriesData[$CellContext`g, 0, {1, 0, -3, 0, 21, 0, -183}, 0, 7, 1],
     Editable->False], ")"}], 
   SqrtBox[
    RowBox[{"1", "-", 
     SuperscriptBox["z", "2"]}]]}]}]], "Input"],

Cell[TextData[{
 "One can use largevolume to find this expression, and substitution subyhtoE \
to change it representation. ",
 Cell[BoxData[
  FormBox[
   RowBox[{
    SubscriptBox["\[Gamma]", "0"], "=", 
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{"12", 
        SuperscriptBox["g", "2"]}], "+"}], "..."}], "."}]}], TraditionalForm]],
  FormatType->"TraditionalForm"]
}], "Text",
 CellChangeTimes->{{3.5687365696910543`*^9, 3.5687365715671473`*^9}, {
  3.5687367702617826`*^9, 3.568736806704949*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"{", 
    RowBox[{"#", ",", 
     RowBox[{"#", "/.", 
      RowBox[{"u", "\[Rule]", 
       RowBox[{"2", "g", " ", "z"}]}]}], ",", 
     RowBox[{"#", "/.", "subyhtoE"}]}], "}"}], "&"}], "/@", 
  RowBox[{"(", 
   RowBox[{"\[Rho]", "/.", "largevolume"}], ")"}]}]], "Input",
 CellChangeTimes->{{3.568736572181735*^9, 3.568736605349018*^9}, 
   3.568736678625258*^9, {3.568736757209968*^9, 3.5687367681945467`*^9}, {
   3.568736812677025*^9, 3.5687368176530733`*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   FractionBox[
    RowBox[{"2", " ", "\[ImaginaryI]", " ", 
     SqrtBox[
      RowBox[{"1", "-", 
       FractionBox[
        SuperscriptBox["u", "2"], 
        RowBox[{"4", " ", 
         SuperscriptBox["g", "2"]}]]}]]}], 
    RowBox[{
     RowBox[{"-", 
      SuperscriptBox[
       OverscriptBox[
        StyleBox["y",
         FontColor->RGBColor[0, 0.6, 0]], 
        StyleBox["^",
         FontColor->RGBColor[0, 0.6, 0]]], "-"]}], "+", 
     SuperscriptBox[
      OverscriptBox[
       StyleBox["y",
        FontColor->RGBColor[0, 0.6, 0]], 
       StyleBox["^",
        FontColor->RGBColor[0, 0.6, 0]]], "+"]}]], ",", 
   FractionBox[
    RowBox[{"2", " ", "\[ImaginaryI]", " ", 
     SqrtBox[
      RowBox[{"1", "-", 
       SuperscriptBox["z", "2"]}]]}], 
    RowBox[{
     RowBox[{"-", 
      SuperscriptBox[
       OverscriptBox[
        StyleBox["y",
         FontColor->RGBColor[0, 0.6, 0]], 
        StyleBox["^",
         FontColor->RGBColor[0, 0.6, 0]]], "-"]}], "+", 
     SuperscriptBox[
      OverscriptBox[
       StyleBox["y",
        FontColor->RGBColor[0, 0.6, 0]], 
       StyleBox["^",
        FontColor->RGBColor[0, 0.6, 0]]], "+"]}]], ",", 
   FractionBox[
    RowBox[{"2", " ", "g", " ", 
     SqrtBox[
      RowBox[{"1", "-", 
       FractionBox[
        SuperscriptBox["u", "2"], 
        RowBox[{"4", " ", 
         SuperscriptBox["g", "2"]}]]}]]}], 
    RowBox[{"1", "+", 
     FractionBox[
      SubscriptBox["\[Gamma]", "0"], "4"]}]]}], "}"}]], "Output",
 CellChangeTimes->{{3.5687365756117563`*^9, 3.568736590744714*^9}, 
   3.56873675895092*^9, {3.568736809648161*^9, 3.56873681812676*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  SubscriptBox["\[Gamma]", "0"], "/.", 
  RowBox[{"leadweak", "[", "5", "]"}]}]], "Input",
 CellChangeTimes->{{3.5687368206773977`*^9, 3.5687368617151937`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"12", " ", 
   SuperscriptBox["g", "2"]}], "-", 
  RowBox[{"48", " ", 
   SuperscriptBox["g", "4"]}], "+", 
  RowBox[{"336", " ", 
   SuperscriptBox["g", "6"]}], "+", 
  RowBox[{
   SuperscriptBox["g", "8"], " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"-", "2820"}], "-", 
     RowBox[{"288", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3"]}]}], ")"}]}], "+", 
  RowBox[{
   SuperscriptBox["g", "10"], " ", 
   RowBox[{"(", 
    RowBox[{"26508", "+", 
     FractionBox[
      RowBox[{"4", " ", "Im1"}], 
      SqrtBox["3"]], "+", 
     RowBox[{"4320", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3"]}], "+", 
     RowBox[{"2880", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "5"]}]}], ")"}]}]}]], "Output",
 CellChangeTimes->{{3.5687368388900557`*^9, 3.5687368618590384`*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"Series", "[", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{
       FractionBox["1", 
        RowBox[{"2", "g"}]], 
       FractionBox[
        RowBox[{"2", " ", "\[ImaginaryI]", " "}], 
        RowBox[{
         RowBox[{"-", 
          SuperscriptBox[
           OverscriptBox[
            StyleBox["y",
             FontColor->RGBColor[0, 0.6, 0]], 
            StyleBox["^",
             FontColor->RGBColor[0, 0.6, 0]]], "-"]}], "+", 
         SuperscriptBox[
          OverscriptBox[
           StyleBox["y",
            FontColor->RGBColor[0, 0.6, 0]], 
           StyleBox["^",
            FontColor->RGBColor[0, 0.6, 0]]], "+"]}]]}], "/.", "subJuk"}], "/.",
      "weak"}], ",", 
    RowBox[{"{", 
     RowBox[{"g", ",", "0", ",", "6"}], "}"}]}], "]"}], "//", 
  "Simplify"}]], "Input",
 CellChangeTimes->{{3.550222415314476*^9, 3.5502224605150013`*^9}, {
  3.550222502355466*^9, 3.550222502508687*^9}}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"1", "-", 
   RowBox[{"3", " ", 
    SuperscriptBox["g", "2"]}], "+", 
   RowBox[{"21", " ", 
    SuperscriptBox["g", "4"]}], "-", 
   RowBox[{"183", " ", 
    SuperscriptBox["g", "6"]}], "+", 
   InterpretationBox[
    SuperscriptBox[
     RowBox[{"O", "[", "g", "]"}], "7"],
    SeriesData[$CellContext`g, 0, {}, 0, 7, 1],
    Editable->False]}],
  SeriesData[$CellContext`g, 0, {1, 0, -3, 0, 21, 0, -183}, 0, 7, 1],
  Editable->False]], "Output",
 CellChangeTimes->{{3.5502224270030317`*^9, 3.550222461872952*^9}, 
   3.550222502983602*^9}]
}, Open  ]],

Cell[TextData[{
 Cell[BoxData[
  FormBox["\[Rho]", TraditionalForm]],
  FormatType->"TraditionalForm"],
 " deviates from ",
 Cell[BoxData[
  FormBox[
   SubscriptBox["\[Rho]", "asym"], TraditionalForm]],
  FormatType->"TraditionalForm"],
 " at ",
 Cell[BoxData[
  FormBox[
   SuperscriptBox["g", "9"], TraditionalForm]],
  FormatType->"TraditionalForm"],
 " (5th nontrivial order). It deviates only by a constant at ",
 Cell[BoxData[
  FormBox[
   SuperscriptBox["g", "9"], TraditionalForm]],
  FormatType->"TraditionalForm"],
 ". At higher orders r[g,z] can be a polynomial in ",
 Cell[BoxData[
  FormBox[
   SuperscriptBox["z", "2"], TraditionalForm]],
  FormatType->"TraditionalForm"],
 "."
}], "Text",
 CellChangeTimes->{{3.5502225297254343`*^9, 3.5502225883777514`*^9}, {
  3.55022268108079*^9, 3.55022268554198*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{
    RowBox[{"r", "[", 
     RowBox[{"g", ",", "z"}], "]"}], "\[Equal]", 
    RowBox[{
     SubsuperscriptBox["\[Sum]", 
      RowBox[{"k", "=", "0"}], "\[Infinity]"], 
     RowBox[{
      SuperscriptBox["g", 
       RowBox[{
        RowBox[{"2", "k"}], "+", "1"}]], 
      RowBox[{
       SubscriptBox["r", 
        RowBox[{
         RowBox[{"2", "k"}], "+", "1"}]], "[", "z", "]"}]}]}]}], ",", 
   RowBox[{
    RowBox[{
     SubscriptBox["r", 
      RowBox[{
       RowBox[{"2", "k"}], "+", "1"}]], "[", "z", "]"}], "\[Equal]", 
    RowBox[{
     SubsuperscriptBox["\[Sum]", 
      RowBox[{"n", "=", "0"}], "\[Infinity]"], 
     RowBox[{
      SubscriptBox["r", 
       RowBox[{
        RowBox[{
         RowBox[{"2", "k"}], "+", "1"}], ";", 
        RowBox[{"2", "n"}]}]], 
      SuperscriptBox["z", 
       RowBox[{"2", "n"}]]}]}]}]}], "}"}]], "Input",
 CellChangeTimes->{{3.5502225898907213`*^9, 3.5502226587391*^9}, {
  3.550222714828178*^9, 3.5502227218019648`*^9}}],

Cell[TextData[{
 "So, what we know that ",
 Cell[BoxData[
  FormBox[
   RowBox[{
    SubscriptBox["r", 
     RowBox[{
      RowBox[{
       RowBox[{"2", "k"}], "+", "1"}], ",", 
      RowBox[{"2", "n"}]}]], "=", "0"}], TraditionalForm]],
  FormatType->"TraditionalForm"],
 " for n>0 and 2k+1<11."
}], "Text",
 CellChangeTimes->{{3.5502226918868103`*^9, 3.550222748922399*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 "Explicit expressions for asymptotic ",
 Cell[BoxData[
  FormBox[
   SubscriptBox["\[ScriptCapitalT]", 
    RowBox[{"1", ",", "s"}]], TraditionalForm]]]
}], "Subsection",
 CellChangeTimes->{{3.55022664718054*^9, 3.5502266485896187`*^9}, {
  3.550226686196568*^9, 3.550226732809936*^9}, {3.5502302260344467`*^9, 
  3.5502302277541447`*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{
    SubscriptBox[
     OverscriptBox["\[ScriptCapitalT]", "^"], 
     RowBox[{"1", ",", "s"}]], "==", 
    RowBox[{"(", 
     RowBox[{
      SubscriptBox[
       OverscriptBox["\[ScriptCapitalT]", "^"], 
       RowBox[{"1", ",", "s"}]], "/.", "largevolume"}], ")"}]}], ",", 
   RowBox[{
    SubscriptBox[
     OverscriptBox["\[ScriptCapitalT]", "^"], 
     RowBox[{"1", ",", "s"}]], "==", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       SubscriptBox[
        OverscriptBox["\[ScriptCapitalT]", "^"], 
        RowBox[{"1", ",", "s"}]], "/.", "largevolume"}], "/.", "subyhtoE"}], 
     ")"}]}]}], "}"}]], "Input",
 CellChangeTimes->{{3.5502228243560247`*^9, 3.5502228870640287`*^9}, {
  3.550222967273736*^9, 3.550222986427936*^9}, {3.568736905060021*^9, 
  3.568736911776379*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{
    SubscriptBox[
     OverscriptBox[
      StyleBox["\[ScriptCapitalT]",
       FontColor->RGBColor[1, 0, 0]], 
      StyleBox["^",
       FontColor->RGBColor[1, 0, 0]]], 
     RowBox[{"1", ",", "s"}]], "\[Equal]", 
    RowBox[{"s", "-", 
     FractionBox[
      RowBox[{
       RowBox[{"-", 
        FractionBox["1", 
         SuperscriptBox[
          OverscriptBox[
           StyleBox["x",
            FontColor->RGBColor[0, 0.6, 0]], 
           StyleBox["^",
            FontColor->RGBColor[0, 0.6, 0]]], 
          RowBox[{"[", 
           RowBox[{"-", "s"}], "]"}]]]}], "+", 
       FractionBox["1", 
        SuperscriptBox[
         OverscriptBox[
          StyleBox["x",
           FontColor->RGBColor[0, 0.6, 0]], 
          StyleBox["^",
           FontColor->RGBColor[0, 0.6, 0]]], 
         RowBox[{"[", "s", "]"}]]]}], 
      RowBox[{
       RowBox[{"-", 
        SuperscriptBox[
         OverscriptBox[
          StyleBox["y",
           FontColor->RGBColor[0, 0.6, 0]], 
          StyleBox["^",
           FontColor->RGBColor[0, 0.6, 0]]], "-"]}], "+", 
       SuperscriptBox[
        OverscriptBox[
         StyleBox["y",
          FontColor->RGBColor[0, 0.6, 0]], 
         StyleBox["^",
          FontColor->RGBColor[0, 0.6, 0]]], "+"]}]]}]}], ",", 
   RowBox[{
    SubscriptBox[
     OverscriptBox[
      StyleBox["\[ScriptCapitalT]",
       FontColor->RGBColor[1, 0, 0]], 
      StyleBox["^",
       FontColor->RGBColor[1, 0, 0]]], 
     RowBox[{"1", ",", "s"}]], "\[Equal]", 
    RowBox[{"s", "+", 
     FractionBox[
      RowBox[{"\[ImaginaryI]", " ", "g", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", 
          FractionBox["1", 
           SuperscriptBox[
            OverscriptBox[
             StyleBox["x",
              FontColor->RGBColor[0, 0.6, 0]], 
             StyleBox["^",
              FontColor->RGBColor[0, 0.6, 0]]], 
            RowBox[{"[", 
             RowBox[{"-", "s"}], "]"}]]]}], "+", 
         FractionBox["1", 
          SuperscriptBox[
           OverscriptBox[
            StyleBox["x",
             FontColor->RGBColor[0, 0.6, 0]], 
            StyleBox["^",
             FontColor->RGBColor[0, 0.6, 0]]], 
           RowBox[{"[", "s", "]"}]]]}], ")"}]}], 
      RowBox[{"1", "+", 
       FractionBox[
        SubscriptBox["\[Gamma]", "0"], "4"]}]]}]}]}], "}"}]], "Output",
 CellChangeTimes->{
  3.5502228495616913`*^9, 3.550222888059503*^9, 3.5502229867045*^9, {
   3.568736899599441*^9, 3.568736912202734*^9}}]
}, Open  ]],

Cell["\<\
There is another one representation\
\>", "Text",
 CellChangeTimes->{{3.5502230090580072`*^9, 3.550223027119039*^9}, 
   3.550229535822646*^9, {3.568736917713972*^9, 3.568736919128891*^9}}],

Cell[BoxData[
 RowBox[{
  SubscriptBox[
   StyleBox["\[GothicCapitalT]",
    FontColor->RGBColor[0.54, 0.35, 0.15]], 
   RowBox[{"a", ",", "1"}]], "\[Equal]", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox[
      RowBox[{
       RowBox[{"(", 
        RowBox[{"4", "+", 
         SubscriptBox["\[Gamma]", "0"]}], ")"}], " ", 
       RowBox[{"(", 
        RowBox[{"4", "+", 
         SubscriptBox["\[Gamma]", "0"], "+", 
         RowBox[{"2", " ", 
          SuperscriptBox[
           OverscriptBox[
            StyleBox["y",
             FontColor->RGBColor[0, 0.6, 0]], 
            StyleBox["^",
             FontColor->RGBColor[0, 0.6, 0]]], "-"], " ", 
          SuperscriptBox[
           OverscriptBox[
            StyleBox["y",
             FontColor->RGBColor[0, 0.6, 0]], 
            StyleBox["^",
             FontColor->RGBColor[0, 0.6, 0]]], "+"]}]}], ")"}]}], 
      RowBox[{"4", 
       SuperscriptBox[
        OverscriptBox[
         StyleBox["y",
          FontColor->RGBColor[0, 0.6, 0]], 
         StyleBox["^",
          FontColor->RGBColor[0, 0.6, 0]]], "-"], " ", 
       SuperscriptBox[
        OverscriptBox[
         StyleBox["y",
          FontColor->RGBColor[0, 0.6, 0]], 
         StyleBox["^",
          FontColor->RGBColor[0, 0.6, 0]]], "+"]}]], ")"}], 
    RowBox[{"-", "1"}]], 
   RowBox[{"(", 
    RowBox[{
     RowBox[{
      SubscriptBox[
       RowBox[{"[", 
        RowBox[{"a", "+", "1"}], "]"}], "D"], 
      RowBox[{"(", 
       RowBox[{
        StyleBox["Bm",
         FontColor->RGBColor[0, 0.6, 0]], " ", 
        StyleBox["Rp",
         FontColor->RGBColor[0, 0.6, 0]]}], ")"}]}], "+", 
     RowBox[{
      SubscriptBox[
       RowBox[{"[", 
        RowBox[{"a", "-", "1"}], "]"}], "D"], 
      RowBox[{"(", 
       RowBox[{
        StyleBox["Bp",
         FontColor->RGBColor[0, 0.6, 0]], " ", 
        StyleBox["Rm",
         FontColor->RGBColor[0, 0.6, 0]]}], ")"}]}], "+", 
     RowBox[{
      SubscriptBox[
       RowBox[{"2", "[", "a", "]"}], "D"], "Q"}]}], ")"}]}]}]], "Input",
 CellChangeTimes->{{3.550229574569846*^9, 3.550229589670246*^9}}],

Cell["In particular", "Text",
 CellChangeTimes->{{3.550229537621759*^9, 3.5502295395496902`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   SubscriptBox["\[ScriptCapitalT]", 
    RowBox[{"1", ",", "1"}]], "==", 
   RowBox[{
    SuperscriptBox[
     RowBox[{"(", 
      FractionBox[
       RowBox[{
        RowBox[{"(", 
         RowBox[{"4", "+", 
          SubscriptBox["\[Gamma]", "0"]}], ")"}], " ", 
        RowBox[{"(", 
         RowBox[{"4", "+", 
          SubscriptBox["\[Gamma]", "0"], "+", 
          RowBox[{"2", " ", 
           SuperscriptBox[
            OverscriptBox[
             StyleBox["y",
              FontColor->RGBColor[0, 0.6, 0]], 
             StyleBox["^",
              FontColor->RGBColor[0, 0.6, 0]]], "-"], " ", 
           SuperscriptBox[
            OverscriptBox[
             StyleBox["y",
              FontColor->RGBColor[0, 0.6, 0]], 
             StyleBox["^",
              FontColor->RGBColor[0, 0.6, 0]]], "+"]}]}], ")"}]}], 
       RowBox[{"4", " ", 
        SuperscriptBox[
         OverscriptBox[
          StyleBox["y",
           FontColor->RGBColor[0, 0.6, 0]], 
          StyleBox["^",
           FontColor->RGBColor[0, 0.6, 0]]], "-"], " ", 
        SuperscriptBox[
         OverscriptBox[
          StyleBox["y",
           FontColor->RGBColor[0, 0.6, 0]], 
          StyleBox["^",
           FontColor->RGBColor[0, 0.6, 0]]], "+"]}]], ")"}], 
     RowBox[{"-", "1"}]], 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"2", " ", 
       StyleBox["Q",
        FontColor->RGBColor[0.8, 0, 0]]}], "+", 
      RowBox[{
       SuperscriptBox[
        StyleBox["Bm",
         FontColor->RGBColor[0, 0.6, 0]], "-"], " ", 
       SuperscriptBox[
        StyleBox["Rp",
         FontColor->RGBColor[0, 0.6, 0]], "-"]}], "+", 
      RowBox[{
       SuperscriptBox[
        StyleBox["Bm",
         FontColor->RGBColor[0, 0.6, 0]], "+"], " ", 
       SuperscriptBox[
        StyleBox["Rp",
         FontColor->RGBColor[0, 0.6, 0]], "+"]}]}], ")"}]}]}], ";"}]], "Input",\

 CellChangeTimes->{{3.5502230310675793`*^9, 3.550223062875807*^9}, {
  3.55022497508043*^9, 3.550224982733987*^9}}],

Cell["Indeed:", "Text",
 CellChangeTimes->{{3.55022306952591*^9, 3.550223070573573*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"(", 
    FractionBox[
     RowBox[{
      RowBox[{
       RowBox[{
        SuperscriptBox[
         RowBox[{"(", 
          FractionBox[
           RowBox[{
            RowBox[{"(", 
             RowBox[{"4", "+", 
              SubscriptBox["\[Gamma]", "0"]}], ")"}], " ", 
            RowBox[{"(", 
             RowBox[{"4", "+", 
              SubscriptBox["\[Gamma]", "0"], "+", 
              RowBox[{"2", " ", 
               SuperscriptBox[
                OverscriptBox[
                 StyleBox["y",
                  FontColor->RGBColor[0, 0.6, 0]], 
                 StyleBox["^",
                  FontColor->RGBColor[0, 0.6, 0]]], "-"], " ", 
               SuperscriptBox[
                OverscriptBox[
                 StyleBox["y",
                  FontColor->RGBColor[0, 0.6, 0]], 
                 StyleBox["^",
                  FontColor->RGBColor[0, 0.6, 0]]], "+"]}]}], ")"}]}], 
           RowBox[{"4", " ", 
            SuperscriptBox[
             OverscriptBox[
              StyleBox["y",
               FontColor->RGBColor[0, 0.6, 0]], 
              StyleBox["^",
               FontColor->RGBColor[0, 0.6, 0]]], "-"], " ", 
            SuperscriptBox[
             OverscriptBox[
              StyleBox["y",
               FontColor->RGBColor[0, 0.6, 0]], 
              StyleBox["^",
               FontColor->RGBColor[0, 0.6, 0]]], "+"]}]], ")"}], 
         RowBox[{"-", "1"}]], 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"2", " ", 
           StyleBox["Q",
            FontColor->RGBColor[0.8, 0, 0]]}], "+", 
          RowBox[{
           SuperscriptBox[
            StyleBox["Bm",
             FontColor->RGBColor[0, 0.6, 0]], "-"], " ", 
           SuperscriptBox[
            StyleBox["Rp",
             FontColor->RGBColor[0, 0.6, 0]], "-"]}], "+", 
          RowBox[{
           SuperscriptBox[
            StyleBox["Bm",
             FontColor->RGBColor[0, 0.6, 0]], "+"], " ", 
           SuperscriptBox[
            StyleBox["Rp",
             FontColor->RGBColor[0, 0.6, 0]], "+"]}]}], ")"}]}], "/.", 
       "subFunsBethe"}], "/.", "subxxh"}], 
     RowBox[{
      SubscriptBox[
       OverscriptBox["\[ScriptCapitalT]", "^"], 
       RowBox[{"1", ",", "1"}]], "/.", "largevolume"}]], ")"}], "/.", 
   "subJuk"}], "/.", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"u", "\[Rule]", 
     RowBox[{"Random", "[", "]"}]}], ",", 
    RowBox[{
     SubscriptBox["v", "0"], "\[Rule]", 
     RowBox[{"Random", "[", "]"}]}], ",", 
    RowBox[{"g", "\[Rule]", 
     RowBox[{"Random", "[", "]"}]}]}], "}"}]}]], "Input",
 CellChangeTimes->{{3.5502248890269403`*^9, 3.5502249141055307`*^9}, {
  3.550224966712756*^9, 3.5502249953707542`*^9}}],

Cell[BoxData[
 RowBox[{"0.9999999999999997`", "\[VeryThinSpace]", "+", 
  RowBox[{"0.`", " ", "\[ImaginaryI]"}]}]], "Output",
 CellChangeTimes->{{3.5502249059804573`*^9, 3.550224915918417*^9}, {
  3.550224967375474*^9, 3.550224995948783*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"With", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"\[CapitalLambda]", "=", 
     RowBox[{"Random", "[", 
      RowBox[{"Integer", ",", 
       RowBox[{"{", 
        RowBox[{"1", ",", "10"}], "}"}]}], "]"}]}], "}"}], ",", 
   RowBox[{
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       FractionBox["1", 
        RowBox[{
         SubscriptBox[
          OverscriptBox["\[ScriptCapitalT]", "^"], 
          RowBox[{"1", ",", 
           RowBox[{"\[CapitalLambda]", "+", "1"}]}]], "/.", "largevolume"}]], 
       
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          RowBox[{
           SuperscriptBox[
            RowBox[{"(", 
             FractionBox[
              RowBox[{
               RowBox[{"(", 
                RowBox[{"4", "+", 
                 SubscriptBox["\[Gamma]", "0"]}], ")"}], " ", 
               RowBox[{"(", 
                RowBox[{"4", "+", 
                 SubscriptBox["\[Gamma]", "0"], "+", 
                 RowBox[{"2", " ", 
                  SuperscriptBox[
                   OverscriptBox[
                    StyleBox["y",
                    FontColor->RGBColor[0, 0.6, 0]], 
                    StyleBox["^",
                    FontColor->RGBColor[0, 0.6, 0]]], "-"], " ", 
                  SuperscriptBox[
                   OverscriptBox[
                    StyleBox["y",
                    FontColor->RGBColor[0, 0.6, 0]], 
                    StyleBox["^",
                    FontColor->RGBColor[0, 0.6, 0]]], "+"]}]}], ")"}]}], 
              RowBox[{"4", 
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox[
                  OverscriptBox[
                   StyleBox["y",
                    FontColor->RGBColor[0, 0.6, 0]], 
                   StyleBox["^",
                    FontColor->RGBColor[0, 0.6, 0]]], "-"], " ", 
                 SuperscriptBox[
                  OverscriptBox[
                   StyleBox["y",
                    FontColor->RGBColor[0, 0.6, 0]], 
                   StyleBox["^",
                    FontColor->RGBColor[0, 0.6, 0]]], "+"]}], ")"}]}]], ")"}], 
            RowBox[{"-", "1"}]], 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"2", " ", 
              RowBox[{"Sum", "[", 
               RowBox[{
                SuperscriptBox[
                 StyleBox["Q",
                  FontColor->RGBColor[0.8, 0, 0]], 
                 RowBox[{"[", "k", "]"}]], ",", 
                RowBox[{"{", 
                 RowBox[{"k", ",", 
                  RowBox[{"-", "\[CapitalLambda]"}], ",", "\[CapitalLambda]", 
                  ",", "2"}], "}"}]}], "]"}]}], "+", 
             RowBox[{"Sum", "[", 
              RowBox[{
               RowBox[{
                SuperscriptBox[
                 StyleBox["Bm",
                  FontColor->RGBColor[0, 0.6, 0]], 
                 RowBox[{"[", "k", "]"}]], " ", 
                SuperscriptBox[
                 StyleBox["Rp",
                  FontColor->RGBColor[0, 0.6, 0]], 
                 RowBox[{"[", "k", "]"}]]}], ",", 
               RowBox[{"{", 
                RowBox[{"k", ",", 
                 RowBox[{
                  RowBox[{"-", "\[CapitalLambda]"}], "-", "1"}], ",", 
                 RowBox[{"\[CapitalLambda]", "+", "1"}], ",", "2"}], "}"}]}], 
              "]"}], "+", 
             RowBox[{"Sum", "[", 
              RowBox[{
               RowBox[{
                SuperscriptBox[
                 StyleBox["Bp",
                  FontColor->RGBColor[0, 0.6, 0]], 
                 RowBox[{"[", "k", "]"}]], " ", 
                SuperscriptBox[
                 StyleBox["Rm",
                  FontColor->RGBColor[0, 0.6, 0]], 
                 RowBox[{"[", "k", "]"}]]}], ",", 
               RowBox[{"{", 
                RowBox[{"k", ",", 
                 RowBox[{
                  RowBox[{"-", "\[CapitalLambda]"}], "+", "1"}], ",", 
                 RowBox[{"\[CapitalLambda]", "-", "1"}], ",", "2"}], "}"}]}], 
              "]"}]}], ")"}]}], "/.", "subFunsBethe"}], "/.", "subxxh"}], 
        ")"}]}], ")"}], "/.", "subJuk"}], "/.", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{
       SubscriptBox["v", "0"], "\[Rule]", 
       RowBox[{"Random", "[", "]"}]}], ",", 
      RowBox[{"g", "\[Rule]", 
       RowBox[{"Random", "[", "]"}]}], ",", 
      RowBox[{"u", "\[Rule]", 
       RowBox[{"Random", "[", "]"}]}]}], "}"}]}]}], "]"}]], "Input",
 CellChangeTimes->{{3.550229504690487*^9, 3.550229523875839*^9}, 
   3.5502296610217657`*^9}],

Cell[BoxData[
 RowBox[{"1.000000000000003`", "\[VeryThinSpace]", "-", 
  RowBox[{"8.01506473240122`*^-18", " ", "\[ImaginaryI]"}]}]], "Output",
 CellChangeTimes->{{3.550229524568095*^9, 3.550229530319673*^9}, 
   3.550229594778673*^9, 3.550229661404792*^9}]
}, Open  ]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 "Upper band (large volume for U and ",
 Cell[BoxData[
  FormBox[
   SubscriptBox["\[Rho]", "2"], TraditionalForm]],
  FormatType->"TraditionalForm"],
 ", then Wronskian sol.)"
}], "Section",
 CellChangeTimes->{{3.5502222520072813`*^9, 3.550222256086728*^9}, {
  3.5502250477988443`*^9, 3.5502250486532497`*^9}, {3.56895749739602*^9, 
  3.568957545011071*^9}}],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  FormBox[
   RowBox[{
    SubscriptBox["\[Rho]", "2"], ",", "U"}], TraditionalForm]]],
 " - parameterization and QQ relations"
}], "Subsection",
 CellChangeTimes->{{3.55022664718054*^9, 3.5502266485896187`*^9}, {
  3.5502267556888638`*^9, 3.550226763015155*^9}, {3.5502271851340227`*^9, 
  3.550227186989476*^9}}],

Cell[BoxData[{
 RowBox[{"{", 
  RowBox[{
   RowBox[{
    SubscriptBox[
     StyleBox["\[GothicCapitalT]",
      FontColor->RGBColor[0.54, 0.35, 0.15]], 
     RowBox[{"a", ",", "1"}]], "==", 
    RowBox[{
     SubsuperscriptBox[
      StyleBox["\[GothicQ]",
       FontColor->RGBColor[0.54, 0.35, 0.15]], "2", 
      RowBox[{"[", "a", "]"}]], "+", 
     SubsuperscriptBox[
      OverscriptBox[
       StyleBox["\[GothicQ]",
        FontColor->RGBColor[0.54, 0.35, 0.15]], 
       StyleBox["_",
        FontColor->RGBColor[0.54, 0.35, 0.15]]], "2", 
      RowBox[{"[", 
       RowBox[{"-", "a"}], "]"}]], "+", 
     SubscriptBox[
      StyleBox["W",
       FontColor->RGBColor[0.54, 0.35, 0.15]], "a"]}]}], ",", 
   RowBox[{
    SubscriptBox[
     StyleBox["W",
      FontColor->RGBColor[0.54, 0.35, 0.15]], "a"], "\[Equal]", 
    RowBox[{
     RowBox[{
      SubsuperscriptBox[
       StyleBox["\[GothicQ]",
        FontColor->RGBColor[0.54, 0.35, 0.15]], "4", 
       RowBox[{"[", "a", "]"}]], " ", 
      SubsuperscriptBox[
       OverscriptBox[
        StyleBox["\[GothicQ]",
         FontColor->RGBColor[0.54, 0.35, 0.15]], 
        StyleBox["_",
         FontColor->RGBColor[0.54, 0.35, 0.15]]], "3", 
       RowBox[{"[", 
        RowBox[{"-", "a"}], "]"}]]}], "+", 
     RowBox[{
      SubsuperscriptBox[
       StyleBox["\[GothicQ]",
        FontColor->RGBColor[0.54, 0.35, 0.15]], "3", 
       RowBox[{"[", "a", "]"}]], " ", 
      SubsuperscriptBox[
       OverscriptBox[
        StyleBox["\[GothicQ]",
         FontColor->RGBColor[0.54, 0.35, 0.15]], 
        StyleBox["_",
         FontColor->RGBColor[0.54, 0.35, 0.15]]], "4", 
       RowBox[{"[", 
        RowBox[{"-", "a"}], "]"}]]}]}]}], ",", 
   RowBox[{
    StyleBox["W",
     FontColor->RGBColor[0.54, 0.35, 0.15]], "\[Equal]", 
    SubscriptBox[
     StyleBox["W",
      FontColor->RGBColor[0.54, 0.35, 0.15]], "0"]}]}], 
  "}"}], "\[IndentingNewLine]", 
 RowBox[{"{", 
  RowBox[{
   RowBox[{
    SubscriptBox[
     StyleBox["\[GothicQ]",
      FontColor->RGBColor[0.54, 0.35, 0.15]], "2"], "\[Equal]", 
    RowBox[{
     RowBox[{
      RowBox[{"-", "\[ImaginaryI]"}], " ", "u"}], "+", 
     RowBox[{"\[ScriptCapitalC]", 
      OverscriptBox["*", "^"], 
      SubscriptBox["\[Rho]", "2"]}], "-", 
     RowBox[{"\[ScriptCapitalC]", "*", 
      SubscriptBox[
       OverscriptBox[
        StyleBox["W",
         FontColor->RGBColor[0.54, 0.35, 0.15]], 
        StyleBox["^",
         FontColor->RGBColor[0.54, 0.35, 0.15]]], "pv"]}]}]}], ",", 
   RowBox[{
    SubscriptBox[
     OverscriptBox[
      StyleBox["W",
       FontColor->RGBColor[0.54, 0.35, 0.15]], 
      StyleBox["^",
       FontColor->RGBColor[0.54, 0.35, 0.15]]], "pv"], "\[Equal]", 
    RowBox[{
     FractionBox["1", "2"], 
     RowBox[{"(", 
      RowBox[{
       SuperscriptBox[
        OverscriptBox[
         StyleBox["W",
          FontColor->RGBColor[0.54, 0.35, 0.15]], 
         StyleBox["^",
          FontColor->RGBColor[0.54, 0.35, 0.15]]], 
        RowBox[{"[", 
         RowBox[{"+", "o"}], "]"}]], "+", 
       SuperscriptBox[
        OverscriptBox[
         StyleBox["W",
          FontColor->RGBColor[0.54, 0.35, 0.15]], 
         StyleBox["^",
          FontColor->RGBColor[0.54, 0.35, 0.15]]], 
        RowBox[{"[", 
         RowBox[{"-", "o"}], "]"}]]}], ")"}]}]}]}], 
  "}"}], "\[IndentingNewLine]", 
 RowBox[{"{", 
  RowBox[{
   SubscriptBox[
    StyleBox["\[GothicCapitalT]",
     FontColor->RGBColor[0.54, 0.35, 0.15]], 
    RowBox[{"a", ",", "0"}]], "==", 
   RowBox[{
    RowBox[{
     SubsuperscriptBox["\[GothicQ]", 
      RowBox[{"1", ",", "2"}], 
      RowBox[{"[", "a", "]"}]], " ", 
     SubsuperscriptBox[
      OverscriptBox[
       StyleBox["\[GothicQ]",
        FontColor->RGBColor[0.54, 0.35, 0.15]], 
       StyleBox["_",
        FontColor->RGBColor[0.54, 0.35, 0.15]]], 
      RowBox[{"1", ",", "2"}], 
      RowBox[{"[", 
       RowBox[{"-", "a"}], "]"}]]}], "-", 
    RowBox[{
     SubsuperscriptBox[
      StyleBox["\[GothicQ]",
       FontColor->RGBColor[0.54, 0.35, 0.15]], 
      RowBox[{"2", ",", "4"}], 
      RowBox[{"[", "a", "]"}]], " ", 
     SubsuperscriptBox[
      OverscriptBox[
       StyleBox["\[GothicQ]",
        FontColor->RGBColor[0.54, 0.35, 0.15]], 
       StyleBox["_",
        FontColor->RGBColor[0.54, 0.35, 0.15]]], 
      RowBox[{"1", ",", "3"}], 
      RowBox[{"[", 
       RowBox[{"-", "a"}], "]"}]]}], "-", 
    RowBox[{
     SubsuperscriptBox[
      StyleBox["\[GothicQ]",
       FontColor->RGBColor[0.54, 0.35, 0.15]], 
      RowBox[{"1", ",", "4"}], 
      RowBox[{"[", "a", "]"}]], " ", 
     SubsuperscriptBox[
      OverscriptBox[
       StyleBox["\[GothicQ]",
        FontColor->RGBColor[0.54, 0.35, 0.15]], 
       StyleBox["_",
        FontColor->RGBColor[0.54, 0.35, 0.15]]], 
      RowBox[{"1", ",", "4"}], 
      RowBox[{"[", 
       RowBox[{"-", "a"}], "]"}]]}], "-", 
    RowBox[{
     SubsuperscriptBox[
      StyleBox["\[GothicQ]",
       FontColor->RGBColor[0.54, 0.35, 0.15]], 
      RowBox[{"2", ",", "3"}], 
      RowBox[{"[", "a", "]"}]], " ", 
     SubsuperscriptBox[
      OverscriptBox[
       StyleBox["\[GothicQ]",
        FontColor->RGBColor[0.54, 0.35, 0.15]], 
       StyleBox["_",
        FontColor->RGBColor[0.54, 0.35, 0.15]]], 
      RowBox[{"2", ",", "3"}], 
      RowBox[{"[", 
       RowBox[{"-", "a"}], "]"}]]}], "-", 
    RowBox[{
     SubsuperscriptBox[
      StyleBox["\[GothicQ]",
       FontColor->RGBColor[0.54, 0.35, 0.15]], 
      RowBox[{"1", ",", "3"}], 
      RowBox[{"[", "a", "]"}]], " ", 
     SubsuperscriptBox[
      OverscriptBox[
       StyleBox["\[GothicQ]",
        FontColor->RGBColor[0.54, 0.35, 0.15]], 
       StyleBox["_",
        FontColor->RGBColor[0.54, 0.35, 0.15]]], 
      RowBox[{"2", ",", "4"}], 
      RowBox[{"[", 
       RowBox[{"-", "a"}], "]"}]]}], "+", 
    RowBox[{
     SubsuperscriptBox[
      StyleBox["\[GothicQ]",
       FontColor->RGBColor[0.54, 0.35, 0.15]], 
      RowBox[{"3", ",", "4"}], 
      RowBox[{"[", "a", "]"}]], " ", 
     SubsuperscriptBox[
      OverscriptBox[
       StyleBox["\[GothicQ]",
        FontColor->RGBColor[0.54, 0.35, 0.15]], 
       StyleBox["_",
        FontColor->RGBColor[0.54, 0.35, 0.15]]], 
      RowBox[{"3", ",", "4"}], 
      RowBox[{"[", 
       RowBox[{"-", "a"}], "]"}]]}]}]}], "}"}], "\[IndentingNewLine]", 
 RowBox[{"{", 
  RowBox[{
   SubscriptBox[
    StyleBox["\[GothicCapitalT]",
     FontColor->RGBColor[0.54, 0.35, 0.15]], 
    RowBox[{"a", ",", 
     RowBox[{"-", "1"}]}]], "\[Equal]", 
   RowBox[{
    SuperscriptBox[
     StyleBox["U",
      FontColor->RGBColor[0, 0.6, 0]], 
     RowBox[{"[", "a", "]"}]], " ", 
    SuperscriptBox[
     OverscriptBox[
      StyleBox["U",
       FontColor->RGBColor[0, 0.6, 0]], 
      StyleBox["_",
       FontColor->RGBColor[0, 0.6, 0]]], 
     RowBox[{"[", 
      RowBox[{"-", "a"}], "]"}]], 
    SubscriptBox[
     StyleBox["\[GothicCapitalT]",
      FontColor->RGBColor[0.54, 0.35, 0.15]], 
     RowBox[{"a", ",", "1"}]]}]}], "}"}]}], "Input",
 CellChangeTimes->{{3.5502250600740213`*^9, 3.550225116694672*^9}, {
  3.550225268845295*^9, 3.5502254442258873`*^9}, {3.550225477210285*^9, 
  3.550225484911695*^9}, {3.550226847512972*^9, 3.550226872697723*^9}}],

Cell["\<\
For internal computations we omit the fact that we are using the upper gauge, \
therefore the gothic font will be omitted.\
\>", "Text",
 CellChangeTimes->{{3.550225541963366*^9, 3.550225566335908*^9}, {
  3.568880554354978*^9, 3.568880561296093*^9}}],

Cell[TextData[{
 "Q-functions other than ",
 Cell[BoxData[
  FormBox[
   SubscriptBox["q", "2"], TraditionalForm]]],
 ", are found through a set of QQ-relations:"
}], "Text",
 CellChangeTimes->{{3.550227195030396*^9, 3.55022720826865*^9}, 
   3.568880566456009*^9}],

Cell[BoxData[{
 RowBox[{"{", 
  RowBox[{
   RowBox[{
    SubscriptBox[
     StyleBox["q",
      FontColor->RGBColor[0, 0, 0.8]], 
     RowBox[{"1", ",", "2"}]], "==", 
    OverscriptBox[
     StyleBox["Q",
      FontColor->RGBColor[0.8, 0, 0]], 
     StyleBox["~",
      FontColor->RGBColor[0.8, 0, 0]]]}], ",", 
   RowBox[{
    SubscriptBox[
     StyleBox["q",
      FontColor->RGBColor[0, 0, 0.8]], 
     RowBox[{"1", ",", "3"}]], "==", 
    RowBox[{
     OverscriptBox[
      StyleBox["Q",
       FontColor->RGBColor[0.8, 0, 0]], 
      StyleBox["~",
       FontColor->RGBColor[0.8, 0, 0]]], 
     FractionBox["D", 
      RowBox[{"1", "-", 
       SuperscriptBox["D", "2"]}]], 
     FractionBox[
      SuperscriptBox[
       StyleBox["U",
        FontColor->RGBColor[0, 0.6, 0]], "2"], 
      RowBox[{
       SuperscriptBox[
        OverscriptBox[
         StyleBox["Q",
          FontColor->RGBColor[0.8, 0, 0]], 
         StyleBox["~",
          FontColor->RGBColor[0.8, 0, 0]]], "-"], " ", 
       SuperscriptBox[
        OverscriptBox[
         StyleBox["Q",
          FontColor->RGBColor[0.8, 0, 0]], 
         StyleBox["~",
          FontColor->RGBColor[0.8, 0, 0]]], "+"]}]]}]}], ",", 
   RowBox[{
    SubscriptBox[
     StyleBox["q",
      FontColor->RGBColor[0, 0, 0.8]], 
     RowBox[{"1", ",", "4"}]], "==", 
    SubscriptBox[
     StyleBox["q",
      FontColor->RGBColor[0, 0, 0.8]], 
     RowBox[{"2", ",", "3"}]], "==", 
    RowBox[{
     OverscriptBox[
      StyleBox["Q",
       FontColor->RGBColor[0.8, 0, 0]], 
      StyleBox["~",
       FontColor->RGBColor[0.8, 0, 0]]], 
     FractionBox["D", 
      RowBox[{"1", "-", 
       SuperscriptBox["D", "2"]}]], 
     FractionBox[
      RowBox[{
       SuperscriptBox[
        StyleBox["U",
         FontColor->RGBColor[0, 0.6, 0]], "2"], 
       SubscriptBox[
        StyleBox["q",
         FontColor->RGBColor[0, 0, 0.8]], "2"]}], 
      RowBox[{
       SuperscriptBox[
        OverscriptBox[
         StyleBox["Q",
          FontColor->RGBColor[0.8, 0, 0]], 
         StyleBox["~",
          FontColor->RGBColor[0.8, 0, 0]]], "-"], " ", 
       SuperscriptBox[
        OverscriptBox[
         StyleBox["Q",
          FontColor->RGBColor[0.8, 0, 0]], 
         StyleBox["~",
          FontColor->RGBColor[0.8, 0, 0]]], "+"]}]]}]}], ",", 
   RowBox[{
    SubscriptBox[
     StyleBox["q",
      FontColor->RGBColor[0, 0, 0.8]], 
     RowBox[{"2", ",", "4"}]], "==", 
    RowBox[{
     OverscriptBox[
      StyleBox["Q",
       FontColor->RGBColor[0.8, 0, 0]], 
      StyleBox["~",
       FontColor->RGBColor[0.8, 0, 0]]], 
     FractionBox["D", 
      RowBox[{"1", "-", 
       SuperscriptBox["D", "2"]}]], 
     FractionBox[
      RowBox[{
       SuperscriptBox[
        StyleBox["U",
         FontColor->RGBColor[0, 0.6, 0]], "2"], 
       SubsuperscriptBox[
        StyleBox["q",
         FontColor->RGBColor[0, 0, 0.8]], "2", "2"]}], 
      RowBox[{
       SuperscriptBox[
        OverscriptBox[
         StyleBox["Q",
          FontColor->RGBColor[0.8, 0, 0]], 
         StyleBox["~",
          FontColor->RGBColor[0.8, 0, 0]]], "-"], " ", 
       SuperscriptBox[
        OverscriptBox[
         StyleBox["Q",
          FontColor->RGBColor[0.8, 0, 0]], 
         StyleBox["~",
          FontColor->RGBColor[0.8, 0, 0]]], "+"]}]]}]}]}], 
  "}"}], "\[IndentingNewLine]", 
 RowBox[{"{", 
  RowBox[{
   RowBox[{
    SubscriptBox[
     StyleBox["q",
      FontColor->RGBColor[0, 0, 0.8]], "4"], "==", 
    FractionBox[
     RowBox[{
      RowBox[{
       SubscriptBox[
        StyleBox["q",
         FontColor->RGBColor[0, 0, 0.8]], "2"], " ", 
       SubsuperscriptBox[
        StyleBox["q",
         FontColor->RGBColor[0, 0, 0.8]], 
        RowBox[{"1", ",", "4"}], "+"]}], "-", 
      SubsuperscriptBox[
       StyleBox["q",
        FontColor->RGBColor[0, 0, 0.8]], 
       RowBox[{"2", ",", "4"}], "+"]}], 
     SuperscriptBox[
      OverscriptBox[
       StyleBox["Q",
        FontColor->RGBColor[0.8, 0, 0]], 
       StyleBox["~",
        FontColor->RGBColor[0.8, 0, 0]]], "+"]]}], ",", " ", 
   RowBox[{
    SubscriptBox[
     StyleBox["q",
      FontColor->RGBColor[0, 0, 0.8]], "3"], "==", 
    FractionBox[
     RowBox[{
      RowBox[{
       SubscriptBox[
        StyleBox["q",
         FontColor->RGBColor[0, 0, 0.8]], "2"], " ", 
       SubsuperscriptBox[
        StyleBox["q",
         FontColor->RGBColor[0, 0, 0.8]], 
        RowBox[{"1", ",", "3"}], "+"]}], "-", 
      SubsuperscriptBox[
       StyleBox["q",
        FontColor->RGBColor[0, 0, 0.8]], 
       RowBox[{"1", ",", "4"}], "+"]}], 
     SuperscriptBox[
      OverscriptBox[
       StyleBox["Q",
        FontColor->RGBColor[0.8, 0, 0]], 
       StyleBox["~",
        FontColor->RGBColor[0.8, 0, 0]]], "+"]]}], ",", 
   RowBox[{
    SubscriptBox[
     StyleBox["q",
      FontColor->RGBColor[0, 0, 0.8]], 
     RowBox[{"3", ",", "4"}]], "==", 
    FractionBox[
     RowBox[{
      RowBox[{
       SubscriptBox[
        StyleBox["q",
         FontColor->RGBColor[0, 0, 0.8]], 
        RowBox[{"1", ",", "3"}]], " ", 
       SubscriptBox[
        StyleBox["q",
         FontColor->RGBColor[0, 0, 0.8]], 
        RowBox[{"2", ",", "4"}]]}], "-", 
      RowBox[{
       SubscriptBox[
        StyleBox["q",
         FontColor->RGBColor[0, 0, 0.8]], 
        RowBox[{"1", ",", "4"}]], " ", 
       SubscriptBox[
        StyleBox["q",
         FontColor->RGBColor[0, 0, 0.8]], 
        RowBox[{"2", ",", "3"}]]}]}], 
     OverscriptBox[
      StyleBox["Q",
       FontColor->RGBColor[0.8, 0, 0]], 
      StyleBox["~",
       FontColor->RGBColor[0.8, 0, 0]]]]}]}], "}"}]}], "Input",
 CellChangeTimes->{{3.550225570072864*^9, 3.5502256279249163`*^9}}],

Cell[BoxData[
 RowBox[{
  OverscriptBox[
   StyleBox["Q",
    FontColor->RGBColor[0.8, 0, 0]], 
   StyleBox["~",
    FontColor->RGBColor[0.8, 0, 0]]], "==", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{"u", "-", 
     SubscriptBox["v", "0"], "-", "\[Alpha]"}], ")"}], 
   RowBox[{"(", 
    RowBox[{"u", "+", 
     SubscriptBox["v", "0"], "+", 
     OverscriptBox["\[Alpha]", "_"]}], ")"}]}]}]], "Input",
 CellChangeTimes->{{3.55022563490388*^9, 3.550225697437819*^9}, {
  3.568961835085017*^9, 3.568961837569022*^9}}],

Cell[TextData[{
 Cell[BoxData[
  FormBox[
   SubscriptBox["v", "0"], TraditionalForm]],
  FormatType->"TraditionalForm"],
 " is the exact position of the Bethe root. \[Alpha] is a complex number. Its \
value is determined below by the condition that ",
 Cell[BoxData[
  SubsuperscriptBox["T", 
   RowBox[{"1", ",", "0"}], "+"]]],
 " is zero at ",
 Cell[BoxData[
  FormBox[
   SubscriptBox["v", "0"], TraditionalForm]],
  FormatType->"TraditionalForm"],
 "."
}], "Text",
 CellChangeTimes->{{3.550226122644902*^9, 3.550226364847374*^9}, {
  3.568881051705381*^9, 3.568881052110298*^9}, {3.5689618436798973`*^9, 
  3.568961868384769*^9}}],

Cell[TextData[{
 "The definitions above are not exactly explicit. Indeed ",
 Cell[BoxData[
  FormBox[
   SubscriptBox["q", "2"], TraditionalForm]]],
 " depends on ",
 Cell[BoxData[
  FormBox[
   SubscriptBox["q", "3"], TraditionalForm]]],
 " and ",
 Cell[BoxData[
  FormBox[
   SubscriptBox["q", "4"], TraditionalForm]]],
 ", through W. However ",
 Cell[BoxData[
  FormBox[
   SubscriptBox["q", 
    RowBox[{"i", ",", "j"}]], TraditionalForm]]],
 " is of order ",
 Cell[BoxData[
  FormBox[
   SuperscriptBox["g", "4"], TraditionalForm]]],
 " or smaller (except for ",
 Cell[BoxData[
  FormBox[
   SubscriptBox["q", 
    RowBox[{"1", ",", "2"}]], TraditionalForm]]],
 "), therefore perturbatively we get a well defined recursion."
}], "Text",
 CellChangeTimes->{{3.550227214884605*^9, 3.550227358544012*^9}, {
  3.568881064169327*^9, 3.568881071062354*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[Cell[BoxData[
 FormBox[
  SubscriptBox["\[Rho]", "2"], TraditionalForm]]]], "Subsection",
 CellChangeTimes->{{3.550226640038102*^9, 3.5502266413009567`*^9}, 
   3.550227602375041*^9}],

Cell[BoxData[{
 RowBox[{
  SubscriptBox["\[Rho]", "2"], "==", 
  RowBox[{
   SqrtBox[
    RowBox[{"1", "-", 
     SuperscriptBox["z", "2"]}]], 
   RowBox[{"r2", "[", 
    RowBox[{"g", ",", "z"}], "]"}]}]}], "\[IndentingNewLine]", 
 RowBox[{
  SubscriptBox["\[Rho]", 
   RowBox[{"2", ",", "asym"}]], "\[Equal]", 
  RowBox[{
   FractionBox[
    RowBox[{"2", " ", "\[ImaginaryI]"}], 
    RowBox[{
     RowBox[{"-", 
      FractionBox["1", 
       SuperscriptBox[
        OverscriptBox[
         StyleBox["y",
          FontColor->RGBColor[0, 0.6, 0]], 
         StyleBox["^",
          FontColor->RGBColor[0, 0.6, 0]]], "-"]]}], "+", 
     FractionBox["1", 
      SuperscriptBox[
       OverscriptBox[
        StyleBox["y",
         FontColor->RGBColor[0, 0.6, 0]], 
        StyleBox["^",
         FontColor->RGBColor[0, 0.6, 0]]], "+"]]}]], 
   SqrtBox[
    RowBox[{"1", "-", 
     SuperscriptBox["z", "2"]}]]}], "==", 
  RowBox[{
   RowBox[{"-", 
    FractionBox["2", 
     RowBox[{"3", "g"}]]}], 
   SqrtBox[
    RowBox[{"1", "-", 
     SuperscriptBox["z", "2"]}]], 
   RowBox[{"(", 
    RowBox[{"1", "+", 
     RowBox[{"4", " ", 
      SuperscriptBox["g", "2"]}], "-", 
     RowBox[{"12", " ", 
      SuperscriptBox["g", "4"]}], "+", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"75", "+", 
        RowBox[{"24", " ", 
         RowBox[{"Zeta", "[", "3", "]"}]}]}], ")"}], " ", 
      SuperscriptBox["g", "6"]}], "+", 
     RowBox[{"O", "[", 
      SuperscriptBox["g", "8"], "]"}]}], ")"}]}]}]}], "Input",
 CellChangeTimes->{{3.5502264185383987`*^9, 3.5502264258069344`*^9}, {
   3.550226461390375*^9, 3.5502264866244097`*^9}, {3.550226524830571*^9, 
   3.550226524971418*^9}, {3.5502265784777517`*^9, 3.550226581932967*^9}, 
   3.550227602377993*^9}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"Series", "[", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{
       FractionBox[
        FractionBox["\[Rho]2", 
         SqrtBox[
          RowBox[{"1", "-", 
           FractionBox[
            SuperscriptBox["u", "2"], 
            RowBox[{"4", " ", 
             SuperscriptBox["g", "2"]}]]}]]], 
        FractionBox[
         RowBox[{"-", "2"}], 
         RowBox[{"3", "g"}]]], "/.", "largevolume"}], "/.", "subJuk"}], "/.", 
     "weak"}], ",", 
    RowBox[{"{", 
     RowBox[{"g", ",", "0", ",", "7"}], "}"}]}], "]"}], "//", 
  "FullSimplify"}]], "Input",
 CellChangeTimes->{{3.550226428329471*^9, 3.550226453252976*^9}, {
   3.550226489771495*^9, 3.550226532045795*^9}, 3.5502276023791237`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"1", "+", 
   RowBox[{"4", " ", 
    SuperscriptBox["g", "2"]}], "-", 
   RowBox[{"12", " ", 
    SuperscriptBox["g", "4"]}], "+", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{"75", "+", 
      RowBox[{"24", " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "3"]}]}], ")"}], " ", 
    SuperscriptBox["g", "6"]}], "+", 
   InterpretationBox[
    SuperscriptBox[
     RowBox[{"O", "[", "g", "]"}], "8"],
    SeriesData[$CellContext`g, 0, {}, 0, 8, 1],
    Editable->False]}],
  SeriesData[$CellContext`g, 0, {
   1, 0, 4, 0, -12, 0, 75 + 24 $CellContext`\[Zeta]$[3][0]}, 0, 8, 1],
  Editable->False]], "Output",
 CellChangeTimes->{3.568957565251501*^9}]
}, Open  ]],

Cell[TextData[{
 Cell[BoxData[
  FormBox[
   SubscriptBox["\[Rho]", "2"], TraditionalForm]]],
 " is corrected at ",
 Cell[BoxData[
  FormBox[
   SuperscriptBox["g", "7"], TraditionalForm]]],
 " order,  r2[g,z] has ",
 Cell[BoxData[
  FormBox[
   RowBox[{
    SuperscriptBox["z", "2"], " ", "and", " ", 
    SuperscriptBox["z", "0"]}], TraditionalForm]]],
 " terms."
}], "Text",
 CellChangeTimes->{{3.550226593213941*^9, 3.5502266214127693`*^9}, 
   3.550227602383803*^9, {3.568957578457974*^9, 3.568957587688397*^9}}],

Cell[TextData[{
 Cell[BoxData[
  RowBox[{"{", 
   RowBox[{
    RowBox[{
     RowBox[{"r2", "[", 
      RowBox[{"g", ",", "z"}], "]"}], "\[Equal]", 
     RowBox[{
      SubsuperscriptBox["\[Sum]", 
       RowBox[{"k", "=", 
        RowBox[{"-", "1"}]}], "\[Infinity]"], 
      RowBox[{
       SuperscriptBox["g", 
        RowBox[{
         RowBox[{"2", "k"}], "+", "1"}]], 
       RowBox[{
        SubscriptBox["r2", 
         RowBox[{
          RowBox[{"2", "k"}], "+", "1"}]], "[", "z", "]"}]}]}]}], ",", 
    RowBox[{
     RowBox[{
      SubscriptBox["r", 
       RowBox[{
        RowBox[{"2", "k"}], "+", "1"}]], "[", "z", "]"}], "\[Equal]", 
     RowBox[{
      SubsuperscriptBox["\[Sum]", 
       RowBox[{"n", "=", "0"}], "\[Infinity]"], 
      RowBox[{
       SubscriptBox["r", 
        RowBox[{
         RowBox[{
          RowBox[{"2", "k"}], "+", "1"}], ";", 
         RowBox[{"2", "n"}]}]], 
       SuperscriptBox["z", 
        RowBox[{"2", "n"}]]}]}]}]}], "}"}]], "Input",
  CellChangeTimes->{{3.5502225898907213`*^9, 3.5502226587391*^9}, {
   3.550222714828178*^9, 3.5502227218019648`*^9}}],
 ". What we know that ",
 Cell[BoxData[
  FormBox[
   RowBox[{
    SubscriptBox["r", 
     RowBox[{
      RowBox[{
       RowBox[{"2", "k"}], "+", "1"}], ";", 
      RowBox[{"2", "n"}]}]], "=", "0"}], TraditionalForm]],
  FormatType->"TraditionalForm"],
 " for 2n>0 and 2k+1<7. Also we know that for 2k+1==7 ",
 Cell[BoxData[
  FormBox[
   RowBox[{
    SubscriptBox["r", 
     RowBox[{
      RowBox[{
       RowBox[{"2", "k"}], "+", "1"}], ";", 
      RowBox[{"2", "n"}]}]], "\[Equal]", "0"}], TraditionalForm]],
  FormatType->"TraditionalForm"],
 " for 2n>2."
}], "Text",
 CellChangeTimes->{{3.550226572511677*^9, 3.550226573709614*^9}, 
   3.5502266360509663`*^9, {3.550227507365159*^9, 3.55022760238453*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 "Explicit expressions for asymptotic ",
 Cell[BoxData[
  FormBox[
   SubscriptBox["\[GothicCapitalT]", 
    RowBox[{"a", ",", "1"}]], TraditionalForm]]]
}], "Subsection",
 CellChangeTimes->{{3.55022664718054*^9, 3.5502266485896187`*^9}, {
  3.550226686196568*^9, 3.550226732809936*^9}, {3.550227649621166*^9, 
  3.5502276545232563`*^9}, {3.550230222802596*^9, 3.550230224242679*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  SubscriptBox[
   OverscriptBox["\[GothicCapitalT]", "^"], 
   RowBox[{"a", ",", "1"}]], "==", 
  RowBox[{"(", 
   RowBox[{
    SubscriptBox[
     OverscriptBox["\[GothicCapitalT]", "^"], 
     RowBox[{"a", ",", "1"}]], "/.", "largevolume"}], ")"}]}]], "Input",
 CellChangeTimes->{{3.5502228243560247`*^9, 3.5502228870640287`*^9}, {
  3.550222967273736*^9, 3.550222986427936*^9}, {3.550227697654294*^9, 
  3.550227705844344*^9}}],

Cell[BoxData[
 RowBox[{
  SubscriptBox[
   OverscriptBox[
    StyleBox["\[GothicCapitalT]",
     FontColor->RGBColor[0.54, 0.35, 0.15]], 
    StyleBox["^",
     FontColor->RGBColor[0.54, 0.35, 0.15]]], 
   RowBox[{"a", ",", "1"}]], "\[Equal]", 
  RowBox[{"a", "-", 
   FractionBox[
    RowBox[{
     RowBox[{"-", 
      FractionBox["1", 
       SuperscriptBox[
        OverscriptBox[
         StyleBox["x",
          FontColor->RGBColor[0, 0.6, 0]], 
         StyleBox["^",
          FontColor->RGBColor[0, 0.6, 0]]], 
        RowBox[{"[", 
         RowBox[{"-", "a"}], "]"}]]]}], "+", 
     FractionBox["1", 
      SuperscriptBox[
       OverscriptBox[
        StyleBox["x",
         FontColor->RGBColor[0, 0.6, 0]], 
        StyleBox["^",
         FontColor->RGBColor[0, 0.6, 0]]], 
       RowBox[{"[", "a", "]"}]]]}], 
    RowBox[{
     RowBox[{"-", 
      FractionBox["1", 
       SuperscriptBox[
        OverscriptBox[
         StyleBox["y",
          FontColor->RGBColor[0, 0.6, 0]], 
         StyleBox["^",
          FontColor->RGBColor[0, 0.6, 0]]], "-"]]}], "+", 
     FractionBox["1", 
      SuperscriptBox[
       OverscriptBox[
        StyleBox["y",
         FontColor->RGBColor[0, 0.6, 0]], 
        StyleBox["^",
         FontColor->RGBColor[0, 0.6, 0]]], "+"]]}]]}]}]], "Output",
 CellChangeTimes->{3.5502228495616913`*^9, 3.550222888059503*^9, 
  3.5502229867045*^9, 3.550227733153002*^9}]
}, Open  ]],

Cell["\<\
There is also another one good for any states in Sl2 sector:\
\>", "Text",
 CellChangeTimes->{{3.5502230090580072`*^9, 3.550223027119039*^9}, {
  3.5502277450667*^9, 3.5502277464445133`*^9}, {3.550229368877149*^9, 
  3.550229376700375*^9}, {3.568957604887987*^9, 3.568957613279717*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{
    SubscriptBox[
     StyleBox["\[GothicCapitalT]",
      FontColor->RGBColor[0.54, 0.35, 0.15]], 
     RowBox[{"a", ",", "1"}]], "\[Equal]", 
    RowBox[{
     SuperscriptBox[
      RowBox[{"(", 
       FractionBox[
        RowBox[{
         RowBox[{"(", 
          RowBox[{"4", "+", 
           SubscriptBox["\[Gamma]", "0"]}], ")"}], " ", 
         RowBox[{"(", 
          RowBox[{"4", "+", 
           SubscriptBox["\[Gamma]", "0"], "+", 
           RowBox[{"2", " ", 
            SuperscriptBox[
             OverscriptBox[
              StyleBox["y",
               FontColor->RGBColor[0, 0.6, 0]], 
              StyleBox["^",
               FontColor->RGBColor[0, 0.6, 0]]], "-"], " ", 
            SuperscriptBox[
             OverscriptBox[
              StyleBox["y",
               FontColor->RGBColor[0, 0.6, 0]], 
              StyleBox["^",
               FontColor->RGBColor[0, 0.6, 0]]], "+"]}]}], ")"}]}], 
        RowBox[{"4", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{
            SuperscriptBox[
             OverscriptBox[
              StyleBox["y",
               FontColor->RGBColor[0, 0.6, 0]], 
              StyleBox["^",
               FontColor->RGBColor[0, 0.6, 0]]], "-"], " ", 
            SuperscriptBox[
             OverscriptBox[
              StyleBox["y",
               FontColor->RGBColor[0, 0.6, 0]], 
              StyleBox["^",
               FontColor->RGBColor[0, 0.6, 0]]], "+"]}], ")"}], "2"]}]], 
       ")"}], 
      RowBox[{"-", "1"}]], 
     RowBox[{"(", 
      RowBox[{
       RowBox[{
        SubscriptBox[
         RowBox[{"[", 
          RowBox[{"a", "+", "1"}], "]"}], "D"], 
        RowBox[{"(", 
         RowBox[{"Bp", " ", "Rm"}], ")"}]}], "+", 
       RowBox[{
        SubscriptBox[
         RowBox[{"[", 
          RowBox[{"a", "-", "1"}], "]"}], "D"], 
        RowBox[{"(", 
         RowBox[{"Bm", " ", "Rp"}], ")"}]}], "+", 
       RowBox[{
        SubscriptBox[
         RowBox[{"2", "[", "a", "]"}], "D"], "Q"}]}], ")"}]}]}], ",", 
   RowBox[{
    SubscriptBox["\[Gamma]", "0"], "\[Equal]", 
    RowBox[{"4", " ", "\[ImaginaryI]", " ", "g", " ", 
     RowBox[{"(", 
      RowBox[{
       FractionBox["1", 
        SuperscriptBox[
         OverscriptBox[
          StyleBox["y",
           FontColor->RGBColor[0, 0.6, 0]], 
          StyleBox["^",
           FontColor->RGBColor[0, 0.6, 0]]], "+"]], "-", 
       FractionBox["1", 
        SuperscriptBox[
         OverscriptBox[
          StyleBox["y",
           FontColor->RGBColor[0, 0.6, 0]], 
          StyleBox["^",
           FontColor->RGBColor[0, 0.6, 0]]], "-"]]}], ")"}]}]}]}], 
  "}"}]], "Input",
 CellChangeTimes->{{3.550229563585822*^9, 3.5502295663385077`*^9}, {
  3.55022960731488*^9, 3.550229643040419*^9}}],

Cell["In particular:", "Text",
 CellChangeTimes->{{3.550229389384624*^9, 3.550229391651894*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   StyleBox["\[GothicCapitalT]",
    FontColor->RGBColor[0.54, 0.35, 0.15]], "==", 
   RowBox[{
    SuperscriptBox[
     RowBox[{"(", 
      FractionBox[
       RowBox[{
        RowBox[{"(", 
         RowBox[{"4", "+", 
          SubscriptBox["\[Gamma]", "0"]}], ")"}], " ", 
        RowBox[{"(", 
         RowBox[{"4", "+", 
          SubscriptBox["\[Gamma]", "0"], "+", 
          RowBox[{"2", " ", 
           SuperscriptBox[
            OverscriptBox[
             StyleBox["y",
              FontColor->RGBColor[0, 0.6, 0]], 
             StyleBox["^",
              FontColor->RGBColor[0, 0.6, 0]]], "-"], " ", 
           SuperscriptBox[
            OverscriptBox[
             StyleBox["y",
              FontColor->RGBColor[0, 0.6, 0]], 
             StyleBox["^",
              FontColor->RGBColor[0, 0.6, 0]]], "+"]}]}], ")"}]}], 
       RowBox[{"4", 
        SuperscriptBox[
         RowBox[{"(", 
          RowBox[{
           SuperscriptBox[
            OverscriptBox[
             StyleBox["y",
              FontColor->RGBColor[0, 0.6, 0]], 
             StyleBox["^",
              FontColor->RGBColor[0, 0.6, 0]]], "-"], " ", 
           SuperscriptBox[
            OverscriptBox[
             StyleBox["y",
              FontColor->RGBColor[0, 0.6, 0]], 
             StyleBox["^",
              FontColor->RGBColor[0, 0.6, 0]]], "+"]}], ")"}], "2"]}]], ")"}], 
     RowBox[{"-", "1"}]], 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"2", " ", 
       StyleBox["Q",
        FontColor->RGBColor[0.8, 0, 0]]}], "+", 
      RowBox[{
       SuperscriptBox[
        StyleBox["Bp",
         FontColor->RGBColor[0, 0.6, 0]], "-"], " ", 
       SuperscriptBox[
        StyleBox["Rm",
         FontColor->RGBColor[0, 0.6, 0]], "-"]}], "+", 
      RowBox[{
       SuperscriptBox[
        StyleBox["Bp",
         FontColor->RGBColor[0, 0.6, 0]], "+"], " ", 
       SuperscriptBox[
        StyleBox["Rm",
         FontColor->RGBColor[0, 0.6, 0]], "+"]}]}], ")"}]}]}], ";"}]], "Input",\

 CellChangeTimes->{{3.5502230310675793`*^9, 3.550223062875807*^9}, {
   3.55022497508043*^9, 3.550224982733987*^9}, {3.550227751418581*^9, 
   3.550227782232565*^9}, 3.550229604939747*^9}],

Cell["Numericall check", "Text",
 CellChangeTimes->{{3.5502294083885107`*^9, 3.55022941034695*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"With", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"\[CapitalLambda]", "=", 
      RowBox[{"Random", "[", 
       RowBox[{"Integer", ",", 
        RowBox[{"{", 
         RowBox[{"1", ",", "10"}], "}"}]}], "]"}]}], "}"}], ",", 
    RowBox[{
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        FractionBox["1", 
         RowBox[{
          SubscriptBox[
           OverscriptBox["\[GothicCapitalT]", "^"], 
           RowBox[{
            RowBox[{"\[CapitalLambda]", "+", "1"}], ",", "1"}]], "/.", 
          "largevolume"}]], 
        RowBox[{"(", 
         RowBox[{
          RowBox[{
           RowBox[{
            SuperscriptBox[
             RowBox[{"(", 
              FractionBox[
               RowBox[{
                RowBox[{"(", 
                 RowBox[{"4", "+", 
                  SubscriptBox["\[Gamma]", "0"]}], ")"}], " ", 
                RowBox[{"(", 
                 RowBox[{"4", "+", 
                  SubscriptBox["\[Gamma]", "0"], "+", 
                  RowBox[{"2", " ", 
                   SuperscriptBox[
                    OverscriptBox[
                    StyleBox["y",
                    FontColor->RGBColor[0, 0.6, 0]], 
                    StyleBox["^",
                    FontColor->RGBColor[0, 0.6, 0]]], "-"], " ", 
                   SuperscriptBox[
                    OverscriptBox[
                    StyleBox["y",
                    FontColor->RGBColor[0, 0.6, 0]], 
                    StyleBox["^",
                    FontColor->RGBColor[0, 0.6, 0]]], "+"]}]}], ")"}]}], 
               RowBox[{"4", 
                SuperscriptBox[
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox[
                    OverscriptBox[
                    StyleBox["y",
                    FontColor->RGBColor[0, 0.6, 0]], 
                    StyleBox["^",
                    FontColor->RGBColor[0, 0.6, 0]]], "-"], " ", 
                   SuperscriptBox[
                    OverscriptBox[
                    StyleBox["y",
                    FontColor->RGBColor[0, 0.6, 0]], 
                    StyleBox["^",
                    FontColor->RGBColor[0, 0.6, 0]]], "+"]}], ")"}], "2"]}]], 
              ")"}], 
             RowBox[{"-", "1"}]], 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"2", " ", 
               RowBox[{"Sum", "[", 
                RowBox[{
                 SuperscriptBox[
                  StyleBox["Q",
                   FontColor->RGBColor[0.8, 0, 0]], 
                  RowBox[{"[", "k", "]"}]], ",", 
                 RowBox[{"{", 
                  RowBox[{"k", ",", 
                   RowBox[{"-", "\[CapitalLambda]"}], ",", "\[CapitalLambda]",
                    ",", "2"}], "}"}]}], "]"}]}], "+", 
              RowBox[{"Sum", "[", 
               RowBox[{
                RowBox[{
                 SuperscriptBox[
                  StyleBox["Bp",
                   FontColor->RGBColor[0, 0.6, 0]], 
                  RowBox[{"[", "k", "]"}]], " ", 
                 SuperscriptBox[
                  StyleBox["Rm",
                   FontColor->RGBColor[0, 0.6, 0]], 
                  RowBox[{"[", "k", "]"}]]}], ",", 
                RowBox[{"{", 
                 RowBox[{"k", ",", 
                  RowBox[{
                   RowBox[{"-", "\[CapitalLambda]"}], "-", "1"}], ",", 
                  RowBox[{"\[CapitalLambda]", "+", "1"}], ",", "2"}], "}"}]}],
                "]"}], "+", 
              RowBox[{"Sum", "[", 
               RowBox[{
                RowBox[{
                 SuperscriptBox[
                  StyleBox["Bm",
                   FontColor->RGBColor[0, 0.6, 0]], 
                  RowBox[{"[", "k", "]"}]], " ", 
                 SuperscriptBox[
                  StyleBox["Rp",
                   FontColor->RGBColor[0, 0.6, 0]], 
                  RowBox[{"[", "k", "]"}]]}], ",", 
                RowBox[{"{", 
                 RowBox[{"k", ",", 
                  RowBox[{
                   RowBox[{"-", "\[CapitalLambda]"}], "+", "1"}], ",", 
                  RowBox[{"\[CapitalLambda]", "-", "1"}], ",", "2"}], "}"}]}],
                "]"}]}], ")"}]}], "/.", "subFunsBethe"}], "/.", "subxxh"}], 
         ")"}]}], ")"}], "/.", "subJuk"}], "/.", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{
        SubscriptBox["v", "0"], "\[Rule]", 
        RowBox[{"Random", "[", "]"}]}], ",", 
       RowBox[{"g", "\[Rule]", 
        RowBox[{"Random", "[", "]"}]}], ",", 
       RowBox[{"u", "\[Rule]", 
        RowBox[{"Random", "[", "]"}]}]}], "}"}]}]}], "]"}], "//", 
  "Chop"}]], "Input",
 CellChangeTimes->{{3.5502292271463623`*^9, 3.5502293223709106`*^9}, {
  3.550229415343256*^9, 3.550229463213319*^9}, {3.550229652021163*^9, 
  3.550229652646041*^9}, {3.568957630652925*^9, 3.568957633274489*^9}}],

Cell[BoxData["1.0000000000000002`"], "Output",
 CellChangeTimes->{{3.550229174023877*^9, 3.550229195028756*^9}, {
  3.550229311592381*^9, 3.5502293226419077`*^9}, {3.550229422766581*^9, 
  3.5502294682251577`*^9}, {3.550229653584527*^9, 3.5502296563866777`*^9}, {
  3.568957626964314*^9, 3.568957633608344*^9}}]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell["Explicit expressions for weak coupling of U", "Subsection",
 CellChangeTimes->{{3.55022664718054*^9, 3.5502266485896187`*^9}, {
  3.550226686196568*^9, 3.550226732809936*^9}, {3.550227649621166*^9, 
  3.5502276545232563`*^9}, {3.550230216917904*^9, 3.550230237193983*^9}, {
  3.5502963228101254`*^9, 3.550296325047329*^9}}],

Cell["\<\
I implemented the answer in \[OpenCurlyDoubleQuote]weak\
\[CloseCurlyDoubleQuote]  and in \[OpenCurlyDoubleQuote]leadweak\
\[CloseCurlyDoubleQuote] substitutions (first four orders, enough to go to 7 \
loops because of the way how U eneters to expressions)\
\>", "Text",
 CellChangeTimes->{{3.550230240571403*^9, 3.5502302589684258`*^9}, {
  3.550294817150599*^9, 3.550294836978763*^9}, {3.568957760010998*^9, 
  3.568957763602305*^9}, {3.568957879741951*^9, 3.568957902524888*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"U", "/.", "weak"}], ";", 
   RowBox[{"U", "/.", 
    RowBox[{"leadweak", "[", "2", "]"}]}]}], "}"}]], "Input",
 CellChangeTimes->{{3.550295994457239*^9, 3.550295995318018*^9}, {
  3.568957903911244*^9, 3.568957911278707*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   FractionBox[
    RowBox[{"\[ImaginaryI]", " ", 
     SqrtBox["2"], " ", 
     SuperscriptBox["g", "2"]}], "u"], "+", 
   RowBox[{
    SuperscriptBox["g", "4"], " ", 
    RowBox[{"(", 
     RowBox[{
      FractionBox[
       RowBox[{"\[ImaginaryI]", " ", 
        SqrtBox["2"]}], 
       SuperscriptBox["u", "3"]], "+", 
      FractionBox[
       RowBox[{"3", " ", 
        SqrtBox["2"]}], 
       SuperscriptBox["u", "2"]], "+", 
      FractionBox[
       RowBox[{"9", " ", "\[ImaginaryI]"}], 
       RowBox[{
        SqrtBox["2"], " ", "u"}]], "-", 
      FractionBox[
       RowBox[{"6", " ", "\[ImaginaryI]", " ", 
        SqrtBox["2"], " ", 
        SubscriptBox[
         StyleBox["\[Zeta]",
          FontWeight->Bold,
          FontColor->GrayLevel[0.4]], "1"]}], "u"], "-", 
      FractionBox[
       RowBox[{"6", " ", 
        SqrtBox["2"], " ", 
        SubscriptBox[
         StyleBox["\[Eta]",
          FontWeight->Bold,
          FontColor->RGBColor[0.8, 0, 0]], "1"]}], "u"]}], ")"}]}]}], 
  "}"}]], "Output",
 CellChangeTimes->{3.568957912559937*^9}]
}, Open  ]],

Cell["\<\
5 orders (for 8-loop result) is in \[OpenCurlyDoubleQuote]nsweak\
\[CloseCurlyDoubleQuote] substitution which is an advanced version of \
\[OpenCurlyDoubleQuote]leadweak\[CloseCurlyDoubleQuote] (\
\[OpenCurlyDoubleQuote]leadweak\[CloseCurlyDoubleQuote] is still functional \
to make back compatibility with old computations). Computation of 5th order \
is outlined in section \[OpenCurlyDoubleQuote]Correction to U (leading \
wrapping effect)\[CloseCurlyDoubleQuote].\
\>", "Text",
 CellChangeTimes->{{3.568957733995096*^9, 3.5689578328386173`*^9}, {
  3.5689579297087917`*^9, 3.568957959122859*^9}, {3.5689581616511383`*^9, 
  3.568958165586829*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"U", "/.", 
  RowBox[{"nsweak", "[", "2", "]"}]}]], "Input",
 CellChangeTimes->{{3.5689579227931833`*^9, 3.568957924772601*^9}}],

Cell[BoxData[
 RowBox[{
  FractionBox[
   RowBox[{"\[ImaginaryI]", " ", 
    SqrtBox["2"], " ", 
    SuperscriptBox["g", "2"]}], 
   StyleBox["\[ScriptU]",
    FontColor->RGBColor[0, 0, 0.4]]], "+", 
  RowBox[{
   SuperscriptBox["g", "4"], " ", 
   RowBox[{"(", 
    RowBox[{
     FractionBox[
      RowBox[{"\[ImaginaryI]", " ", 
       SqrtBox["2"]}], 
      SuperscriptBox[
       StyleBox["\[ScriptU]",
        FontColor->RGBColor[0, 0, 0.4]], "3"]], "-", 
     FractionBox[
      RowBox[{"3", " ", 
       SqrtBox["2"]}], 
      SuperscriptBox[
       StyleBox["\[ScriptU]",
        FontColor->RGBColor[0, 0, 0.4]], "2"]], "+", 
     FractionBox[
      RowBox[{
       FractionBox[
        RowBox[{"9", " ", "\[ImaginaryI]"}], 
        SqrtBox["2"]], "-", 
       RowBox[{"6", " ", "\[ImaginaryI]", " ", 
        SqrtBox["2"], " ", 
        SubscriptBox[
         StyleBox["\[Zeta]",
          FontWeight->Bold,
          FontColor->GrayLevel[0.4]], "1"]}]}], 
      StyleBox["\[ScriptU]",
       FontColor->RGBColor[0, 0, 0.4]]], "-", 
     FractionBox[
      RowBox[{"6", " ", 
       SqrtBox["2"], " ", 
       SubsuperscriptBox[
        StyleBox["\[Eta]",
         FontWeight->Bold,
         FontColor->RGBColor[0.8, 0, 0]], "1", 
        RowBox[{"[", "2", "]"}]]}], 
      StyleBox["\[ScriptU]",
       FontColor->RGBColor[0, 0, 0.4]]]}], ")"}]}]}]], "Output",
 CellChangeTimes->{3.568957925194984*^9}]
}, Open  ]],

Cell[TextData[{
 Cell[BoxData[
  FormBox[
   SubscriptBox["\[Zeta]", "1"], TraditionalForm]]],
 " by definition is ",
 Cell[BoxData[
  FormBox[
   RowBox[{"\[ImaginaryI]", " ", 
    SubsuperscriptBox["\[Eta]", "1", 
     RowBox[{"[", "2", "]"}]]}], TraditionalForm]]],
 " at zero, i.e. this is a result of a particular regualization of marginally \
divergent sum. We can check that by shifting ",
 Cell[BoxData[
  FormBox[
   SubscriptBox["\[Eta]", "1"], TraditionalForm]]],
 " by ",
 Cell[BoxData[
  FormBox[
   RowBox[{
    RowBox[{"-", "\[ImaginaryI]"}], " ", 
    SubscriptBox["\[Zeta]", "1"]}], TraditionalForm]]],
 " that we cancell all ",
 Cell[BoxData[
  FormBox[
   SubscriptBox["\[Zeta]", "1"], TraditionalForm]]],
 " appearing. In the final answer ",
 Cell[BoxData[
  FormBox[
   SubscriptBox["\[Zeta]", "1"], TraditionalForm]]],
 " should never appear, however I don\[CloseCurlyQuote]t know whether it \
should cancell among different terms or at each term separately.   ",
 Cell[BoxData[
  FormBox[
   SubscriptBox["\[Zeta]", "3"], TraditionalForm]]],
 " and ",
 Cell[BoxData[
  FormBox[
   SubscriptBox["\[Zeta]", "5"], TraditionalForm]]],
 " are coming from the normalization ",
 Cell[BoxData[
  FormBox[
   RowBox[{"U", " ", 
    OverscriptBox["U", "_"]}], TraditionalForm]]],
 " on the short interval (see discussion below)."
}], "Text",
 CellChangeTimes->{{3.552377771806913*^9, 3.552377988700259*^9}, {
  3.568957730276771*^9, 3.5689577311405277`*^9}}],

Cell[TextData[{
 "For convenience ",
 Cell[BoxData[
  FormBox[
   SuperscriptBox["U", "2"], TraditionalForm]]],
 " is also calculated in the MHZ basis (basis linear in multiple Hurwitz zeta \
functions (MHZ))"
}], "Text",
 CellChangeTimes->{{3.550314514135209*^9, 3.550314573211434*^9}, {
  3.55237830345874*^9, 3.552378325528496*^9}, {3.5689578576551447`*^9, 
  3.5689578699656963`*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{
    SuperscriptBox["U", "2"], "/.", 
    RowBox[{"leadweak", "[", "2", "]"}]}], ",", 
   RowBox[{
    SuperscriptBox["U", "2"], "/.", 
    RowBox[{"nsweak", "[", "2", "]"}]}]}], "}"}]], "Input",
 CellChangeTimes->{{3.55031452570144*^9, 3.550314528766856*^9}, {
  3.568957873151991*^9, 3.5689578744557*^9}, {3.568957976540195*^9, 
  3.568957980915759*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{
    RowBox[{"-", 
     FractionBox[
      RowBox[{"2", " ", 
       SuperscriptBox["g", "4"]}], 
      SuperscriptBox["u", "2"]]}], "+", 
    FractionBox[
     RowBox[{"2", " ", 
      SuperscriptBox["g", "6"], " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "2"}], "-", 
        RowBox[{"6", " ", "\[ImaginaryI]", " ", "u"}], "-", 
        RowBox[{"9", " ", 
         SuperscriptBox["u", "2"]}], "+", 
        RowBox[{"12", " ", 
         SuperscriptBox["u", "2"], " ", 
         SubscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "1"]}], "-", 
        RowBox[{"12", " ", "\[ImaginaryI]", " ", 
         SuperscriptBox["u", "2"], " ", 
         SubsuperscriptBox[
          StyleBox["\[Eta]",
           FontWeight->Bold,
           FontColor->RGBColor[0.8, 0, 0]], "1", 
          RowBox[{"[", "2", "]"}]]}]}], ")"}]}], 
     SuperscriptBox["u", "4"]]}], ",", 
   RowBox[{
    RowBox[{"-", 
     FractionBox[
      RowBox[{"2", " ", 
       SuperscriptBox["g", "4"]}], 
      SuperscriptBox[
       StyleBox["\[ScriptU]",
        FontColor->RGBColor[0, 0, 0.4]], "2"]]}], "+", 
    RowBox[{
     SuperscriptBox["g", "6"], " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"-", 
        FractionBox["4", 
         SuperscriptBox[
          StyleBox["\[ScriptU]",
           FontColor->RGBColor[0, 0, 0.4]], "4"]]}], "-", 
       FractionBox[
        RowBox[{"12", " ", "\[ImaginaryI]"}], 
        SuperscriptBox[
         StyleBox["\[ScriptU]",
          FontColor->RGBColor[0, 0, 0.4]], "3"]], "+", 
       FractionBox[
        RowBox[{
         RowBox[{"-", "18"}], "+", 
         RowBox[{"24", " ", 
          SubscriptBox[
           StyleBox["\[Zeta]",
            FontWeight->Bold,
            FontColor->GrayLevel[0.4]], "1"]}]}], 
        SuperscriptBox[
         StyleBox["\[ScriptU]",
          FontColor->RGBColor[0, 0, 0.4]], "2"]], "-", 
       FractionBox[
        RowBox[{"24", " ", "\[ImaginaryI]", " ", 
         SubsuperscriptBox[
          StyleBox["\[Eta]",
           FontWeight->Bold,
           FontColor->RGBColor[0.8, 0, 0]], "1", 
          RowBox[{"[", "2", "]"}]]}], 
        SuperscriptBox[
         StyleBox["\[ScriptU]",
          FontColor->RGBColor[0, 0, 0.4]], "2"]]}], ")"}]}]}]}], 
  "}"}]], "Output",
 CellChangeTimes->{3.550314529150106*^9, 3.552379516264008*^9, 
  3.568957874956625*^9, 3.5689579813050537`*^9}]
}, Open  ]],

Cell[TextData[{
 "Let us for instance check that ",
 Cell[BoxData[
  FormBox[
   SubscriptBox["\[Zeta]", "1"], TraditionalForm]],
  FormatType->"TraditionalForm"],
 " is a pure regularization"
}], "Text",
 CellChangeTimes->{{3.552379521430511*^9, 3.552379533341805*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"FreeQ", "[", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{
       SuperscriptBox["U", "2"], "/.", "weak"}], "//.", "subtopowerbasis"}], "/.", 
     RowBox[{
      SubsuperscriptBox["\[Eta]", "1", 
       RowBox[{"[", 
        RowBox[{"r_:", "0"}], "]"}]], "\[RuleDelayed]", 
      RowBox[{
       SubsuperscriptBox["\[Eta]", "1", 
        RowBox[{"[", "r", "]"}]], "+", 
       RowBox[{"(", 
        RowBox[{
         SubsuperscriptBox["\[Eta]", "1", 
          RowBox[{"[", "2", "]"}]], "/.", "sub\[Eta]\[Zeta]"}], ")"}]}]}]}], "//",
     "Simplify"}], ",", 
   SubscriptBox["\[Zeta]", "1"]}], "]"}]], "Input",
 CellChangeTimes->{{3.5523795343523684`*^9, 3.5523796027697287`*^9}}],

Cell[BoxData["True"], "Output",
 CellChangeTimes->{{3.55237955776369*^9, 3.552379603242303*^9}, 
   3.568957990517027*^9}]
}, Open  ]],

Cell["\<\
Now we are going to explain how it is computed. We use:\
\>", "Text",
 CellChangeTimes->{{3.55023026704828*^9, 3.550230275415957*^9}, {
   3.5502306724664373`*^9, 3.550230677663625*^9}, {3.550230737533628*^9, 
   3.550230739196875*^9}, {3.5502946742332573`*^9, 3.550294683320799*^9}, {
   3.550294726255126*^9, 3.5502947362088623`*^9}, 3.550294891244149*^9, {
   3.5689579998651667`*^9, 3.568958000456751*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{
    FractionBox[
     SuperscriptBox["V", "+"], 
     SuperscriptBox["V", "-"]], "=", 
    RowBox[{
     FractionBox[
      SuperscriptBox["Bp", "+"], 
      SuperscriptBox["Bm", "+"]], 
     SubscriptBox["\[Sigma]", "BES"]}]}], ",", 
   RowBox[{"U", "\[Equal]", 
    RowBox[{
     FractionBox["1", 
      SqrtBox[
       SubscriptBox["C", "\[GothicCapitalT]"]]], "Bm", " ", 
     FractionBox["V", 
      SuperscriptBox["x", 
       RowBox[{"L", "/", "2"}]]]}]}]}], "}"}]], "Input",
 CellChangeTimes->{{3.5409777203347883`*^9, 3.54097774075317*^9}, {
  3.550230733426744*^9, 3.55023078107977*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{
    SubscriptBox["C", "\[GothicCapitalT]"], "\[Equal]", 
    RowBox[{"(", 
     RowBox[{
      SubscriptBox["C", "\[GothicCapitalT]"], "/.", "weak"}], ")"}]}], ",", 
   RowBox[{
    SubscriptBox["\[Gamma]", "0"], "\[Equal]", 
    RowBox[{"(", 
     RowBox[{
      SubscriptBox["\[Gamma]", "0"], "/.", 
      RowBox[{"leadweak", "[", "2", "]"}]}], ")"}]}]}], "}"}]], "Input",
 CellChangeTimes->{{3.5689581042005568`*^9, 3.568958141646332*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{
    SubscriptBox["C", 
     StyleBox["\[GothicCapitalT]",
      FontColor->RGBColor[0.54, 0.35, 0.15]]], "\[Equal]", 
    FractionBox["4", 
     RowBox[{
      SubscriptBox["\[Gamma]", "0"], " ", 
      RowBox[{"(", 
       RowBox[{"2", "+", 
        SubscriptBox["\[Gamma]", "0"]}], ")"}]}]]}], ",", 
   RowBox[{
    SubscriptBox["\[Gamma]", "0"], "\[Equal]", 
    RowBox[{
     RowBox[{"12", " ", 
      SuperscriptBox["g", "2"]}], "-", 
     RowBox[{"48", " ", 
      SuperscriptBox["g", "4"]}]}]}]}], "}"}]], "Output",
 CellChangeTimes->{{3.568958105528098*^9, 3.56895814204284*^9}}]
}, Open  ]],

Cell[TextData[{
 Cell[BoxData[
  FormBox[
   RowBox[{
    SubscriptBox["\[Sigma]", "BES"], "=", 
    RowBox[{"Exp", "[", 
     RowBox[{"\[ImaginaryI]", " ", "\[Theta]"}], "]"}]}], TraditionalForm]]],
 ", ",
 Cell[BoxData[
  FormBox[
   RowBox[{"\[Theta]", "=", 
    RowBox[{"\[ImaginaryI]", "(", 
     RowBox[{
      RowBox[{"\[Chi]", "[", 
       RowBox[{
        SuperscriptBox["x", "+"], ",", 
        SuperscriptBox["y", "-"]}], "]"}], "-", 
      RowBox[{"\[Chi]", "[", 
       RowBox[{
        SuperscriptBox["x", "-"], ",", 
        SuperscriptBox["y", "-"]}], "]"}], "-", 
      RowBox[{"\[Chi]", "[", 
       RowBox[{
        SuperscriptBox["x", "+"], ",", 
        SuperscriptBox["y", "+"]}], "]"}], "+", 
      RowBox[{"\[Chi]", "[", 
       RowBox[{
        SuperscriptBox["x", "-"], ",", 
        SuperscriptBox["y", "+"]}], "]"}]}], ")"}]}], TraditionalForm]]]
}], "Text",
 CellChangeTimes->{{3.537809602193746*^9, 3.537809723112981*^9}, {
  3.537847059985951*^9, 3.537847060639296*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Log", "[", "V", "]"}], "=", " ", 
  RowBox[{
   RowBox[{"\[ImaginaryI]", " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       SubscriptBox["\[Chi]", "BES"], "[", 
       RowBox[{"x", ",", 
        SuperscriptBox["y", "-"]}], "]"}], "-", 
      RowBox[{
       SubscriptBox["\[Chi]", "BES"], "[", 
       RowBox[{"x", ",", 
        SuperscriptBox["y", "+"]}], "]"}]}], ")"}]}], "-", 
   RowBox[{
    FractionBox[
     SuperscriptBox["D", "2"], 
     RowBox[{"1", "-", 
      SuperscriptBox["D", "2"]}]], 
    RowBox[{"Log", "[", 
     FractionBox["Bp", "Bm"], "]"}]}]}]}]], "Input",
 CellChangeTimes->{{3.540977746780923*^9, 3.540977844682632*^9}, 
   3.54097787778058*^9}],

Cell[TextData[{
 "This is a solution up to a constant. The constant is important and is fixed \
later, from the shown (asymptotically) condition that ",
 Cell[BoxData[
  FormBox[
   RowBox[{
    RowBox[{"V", 
     OverscriptBox["V", "_"]}], "=", "1"}], TraditionalForm]]],
 "."
}], "Text",
 CellChangeTimes->{{3.550233187570539*^9, 3.550233253815753*^9}, {
  3.550235932335383*^9, 3.550235934676094*^9}, {3.550294905505131*^9, 
  3.5502949114325037`*^9}, {3.5689580322323713`*^9, 3.568958032703602*^9}}],

Cell[TextData[{
 "Expansion for ",
 Cell[BoxData[
  FormBox[
   SubscriptBox["\[Chi]", "BES"], TraditionalForm]]],
 " is well known"
}], "Text",
 CellChangeTimes->{{3.5409778944144707`*^9, 3.540977904554523*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"\[ImaginaryI]", " ", 
   RowBox[{
    SubscriptBox["\[Chi]", "BES"], "[", 
    RowBox[{"x", ",", "y"}], "]"}]}], "=", 
  RowBox[{
   RowBox[{"-", "\[ImaginaryI]"}], " ", 
   RowBox[{
    SubsuperscriptBox["\[Sum]", 
     RowBox[{"r", ",", 
      RowBox[{"s", "=", "1"}]}], "\[Infinity]"], 
    FractionBox[
     RowBox[{
      SubscriptBox["c", 
       RowBox[{"r", ",", "s"}]], "[", "g", "]"}], 
     RowBox[{
      SuperscriptBox["x", "r"], 
      SuperscriptBox["y", "s"]}]]}]}]}], "\[IndentingNewLine]", 
 RowBox[{
  SubscriptBox["c", 
   RowBox[{"r", ",", "s"}]], "=", 
  RowBox[{"2", " ", 
   RowBox[{"Sin", "[", 
    RowBox[{
     FractionBox["\[Pi]", "2"], 
     RowBox[{"(", 
      RowBox[{"r", "-", "s"}], ")"}]}], "]"}], 
   RowBox[{
    SubsuperscriptBox["\[Integral]", "0", "\[Infinity]"], 
    RowBox[{"dt", " ", 
     FractionBox[
      RowBox[{
       RowBox[{
        SubscriptBox["J", "r"], "[", 
        RowBox[{"2", "g", " ", "t"}], "]"}], 
       RowBox[{
        SubscriptBox["J", "s"], "[", 
        RowBox[{"2", "g", " ", "t"}], "]"}]}], 
      RowBox[{"t", 
       RowBox[{"(", 
        RowBox[{
         SuperscriptBox["\[ExponentialE]", "t"], "-", "1"}], 
        ")"}]}]]}]}]}]}], "\[IndentingNewLine]", 
 RowBox[{
  SubscriptBox["c", 
   RowBox[{"r", ",", "s"}]], "=", 
  RowBox[{
   SubsuperscriptBox["\[Sum]", 
    RowBox[{"n", "=", "0"}], "\[Infinity]"], 
   RowBox[{
    SubsuperscriptBox["c", 
     RowBox[{"r", ",", "s"}], 
     RowBox[{"(", "n", ")"}]], 
    SuperscriptBox["g", 
     RowBox[{"r", "+", "s", "+", 
      RowBox[{"2", "n"}]}]]}]}]}], "\[IndentingNewLine]", 
 RowBox[{
  SubsuperscriptBox["c", 
   RowBox[{"r", ",", "s"}], 
   RowBox[{"(", "n", ")"}]], "=", 
  RowBox[{"2", 
   SuperscriptBox[
    RowBox[{"(", 
     RowBox[{"-", "1"}], ")"}], "n"], 
   RowBox[{"Sin", "[", 
    RowBox[{
     FractionBox["\[Pi]", "2"], 
     RowBox[{"(", 
      RowBox[{"r", "-", "s"}], ")"}]}], "]"}], 
   FractionBox[
    RowBox[{
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"2", "n"}], "+", "r", "+", 
        RowBox[{"s", "\[Minus]", "1"}]}], ")"}], "!"}], 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"2", "n"}], "+", "r", "+", "s"}], ")"}], "!"}]}], 
    RowBox[{
     RowBox[{"n", "!"}], 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"n", "+", "r"}], ")"}], "!"}], 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"n", "+", "s"}], ")"}], "!"}], 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"n", "+", "r", "+", "s"}], ")"}], "!"}]}]], 
   RowBox[{"\[Zeta]", "[", 
    RowBox[{
     RowBox[{"2", "n"}], "+", "r", "+", "s"}], "]"}]}]}]}], "Input",
 CellChangeTimes->{{3.53784778486556*^9, 3.537847964068527*^9}, {
  3.546150046166855*^9, 3.5461500469718*^9}, {3.5502949202680397`*^9, 
  3.550294930735963*^9}}],

Cell["\<\
This weak coupling expansion for Konishi state is implemented:\
\>", "Text",
 CellChangeTimes->{{3.555789920931452*^9, 3.555789937609384*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"c", "[", 
    RowBox[{"r_", ",", "s_", ",", "n_"}], "]"}], ":=", 
   RowBox[{"2", 
    SuperscriptBox[
     RowBox[{"(", 
      RowBox[{"-", "1"}], ")"}], "n"], 
    RowBox[{"Sin", "[", 
     RowBox[{
      FractionBox["\[Pi]", "2"], 
      RowBox[{"(", 
       RowBox[{"r", "-", "s"}], ")"}]}], "]"}], 
    FractionBox[
     RowBox[{
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{"2", "n"}], "+", "r", "+", 
         RowBox[{"s", "\[Minus]", "1"}]}], ")"}], "!"}], 
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{"2", "n"}], "+", "r", "+", "s"}], ")"}], "!"}]}], 
     RowBox[{
      RowBox[{"n", "!"}], 
      RowBox[{
       RowBox[{"(", 
        RowBox[{"n", "+", "r"}], ")"}], "!"}], 
      RowBox[{
       RowBox[{"(", 
        RowBox[{"n", "+", "s"}], ")"}], "!"}], 
      RowBox[{
       RowBox[{"(", 
        RowBox[{"n", "+", "r", "+", "s"}], ")"}], "!"}]}]], 
    RowBox[{
     RowBox[{"\[Zeta]$", "[", 
      RowBox[{
       RowBox[{"2", "n"}], "+", "r", "+", "s"}], "]"}], "[", "0", "]"}]}]}], 
  ";"}]], "Input",
 CellChangeTimes->{{3.550230951518669*^9, 3.5502309719728518`*^9}, {
  3.555789604505701*^9, 3.555789608696155*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"drphase", "/.", 
  RowBox[{"leadweak", "[", "5", "]"}]}]], "Input",
 CellChangeTimes->{{3.555790098210623*^9, 3.5557901122285643`*^9}, {
  3.560866848332412*^9, 3.560866848756761*^9}}],

Cell[BoxData[
 RowBox[{
  FractionBox[
   RowBox[{"12", " ", 
    SuperscriptBox["g", "4"], " ", 
    SubscriptBox[
     StyleBox["\[Zeta]",
      FontWeight->Bold,
      FontColor->GrayLevel[0.4]], "3"]}], 
   SuperscriptBox[
    OverscriptBox[
     StyleBox["x",
      FontColor->RGBColor[0, 0.6, 0]], 
     StyleBox["^",
      FontColor->RGBColor[0, 0.6, 0]]], "2"]], "+", 
  RowBox[{
   SuperscriptBox["g", "6"], " ", 
   RowBox[{"(", 
    RowBox[{
     FractionBox[
      RowBox[{
       RowBox[{
        RowBox[{"-", "48"}], " ", 
        SubscriptBox[
         StyleBox["\[Zeta]",
          FontWeight->Bold,
          FontColor->GrayLevel[0.4]], "3"]}], "-", 
       RowBox[{"120", " ", 
        SubscriptBox[
         StyleBox["\[Zeta]",
          FontWeight->Bold,
          FontColor->GrayLevel[0.4]], "5"]}]}], 
      SuperscriptBox[
       OverscriptBox[
        StyleBox["x",
         FontColor->RGBColor[0, 0.6, 0]], 
        StyleBox["^",
         FontColor->RGBColor[0, 0.6, 0]]], "2"]], "-", 
     FractionBox[
      RowBox[{"12", " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "5"]}], 
      SuperscriptBox[
       OverscriptBox[
        StyleBox["x",
         FontColor->RGBColor[0, 0.6, 0]], 
        StyleBox["^",
         FontColor->RGBColor[0, 0.6, 0]]], "4"]]}], ")"}]}], "+", 
  RowBox[{
   SuperscriptBox["g", "8"], " ", 
   RowBox[{"(", 
    RowBox[{
     FractionBox[
      RowBox[{"12", " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "7"]}], 
      SuperscriptBox[
       OverscriptBox[
        StyleBox["x",
         FontColor->RGBColor[0, 0.6, 0]], 
        StyleBox["^",
         FontColor->RGBColor[0, 0.6, 0]]], "6"]], "+", 
     FractionBox[
      RowBox[{
       RowBox[{"48", " ", 
        SubscriptBox[
         StyleBox["\[Zeta]",
          FontWeight->Bold,
          FontColor->GrayLevel[0.4]], "5"]}], "+", 
       RowBox[{"252", " ", 
        SubscriptBox[
         StyleBox["\[Zeta]",
          FontWeight->Bold,
          FontColor->GrayLevel[0.4]], "7"]}]}], 
      SuperscriptBox[
       OverscriptBox[
        StyleBox["x",
         FontColor->RGBColor[0, 0.6, 0]], 
        StyleBox["^",
         FontColor->RGBColor[0, 0.6, 0]]], "4"]], "+", 
     FractionBox[
      RowBox[{
       RowBox[{"336", " ", 
        SubscriptBox[
         StyleBox["\[Zeta]",
          FontWeight->Bold,
          FontColor->GrayLevel[0.4]], "3"]}], "+", 
       RowBox[{"480", " ", 
        SubscriptBox[
         StyleBox["\[Zeta]",
          FontWeight->Bold,
          FontColor->GrayLevel[0.4]], "5"]}], "+", 
       RowBox[{"1260", " ", 
        SubscriptBox[
         StyleBox["\[Zeta]",
          FontWeight->Bold,
          FontColor->GrayLevel[0.4]], "7"]}]}], 
      SuperscriptBox[
       OverscriptBox[
        StyleBox["x",
         FontColor->RGBColor[0, 0.6, 0]], 
        StyleBox["^",
         FontColor->RGBColor[0, 0.6, 0]]], "2"]]}], ")"}]}], "+", 
  RowBox[{
   SuperscriptBox["g", "10"], " ", 
   RowBox[{"(", 
    RowBox[{
     FractionBox[
      RowBox[{
       RowBox[{
        RowBox[{"-", "2820"}], " ", 
        SubscriptBox[
         StyleBox["\[Zeta]",
          FontWeight->Bold,
          FontColor->GrayLevel[0.4]], "3"]}], "-", 
       RowBox[{"288", " ", 
        SubsuperscriptBox[
         StyleBox["\[Zeta]",
          FontWeight->Bold,
          FontColor->GrayLevel[0.4]], "3", "2"]}], "-", 
       RowBox[{"3576", " ", 
        SubscriptBox[
         StyleBox["\[Zeta]",
          FontWeight->Bold,
          FontColor->GrayLevel[0.4]], "5"]}], "-", 
       RowBox[{"5040", " ", 
        SubscriptBox[
         StyleBox["\[Zeta]",
          FontWeight->Bold,
          FontColor->GrayLevel[0.4]], "7"]}], "-", 
       RowBox[{"14112", " ", 
        SubscriptBox[
         StyleBox["\[Zeta]",
          FontWeight->Bold,
          FontColor->GrayLevel[0.4]], "9"]}]}], 
      SuperscriptBox[
       OverscriptBox[
        StyleBox["x",
         FontColor->RGBColor[0, 0.6, 0]], 
        StyleBox["^",
         FontColor->RGBColor[0, 0.6, 0]]], "2"]], "+", 
     FractionBox[
      RowBox[{
       RowBox[{
        RowBox[{"-", "336"}], " ", 
        SubscriptBox[
         StyleBox["\[Zeta]",
          FontWeight->Bold,
          FontColor->GrayLevel[0.4]], "5"]}], "-", 
       RowBox[{"1008", " ", 
        SubscriptBox[
         StyleBox["\[Zeta]",
          FontWeight->Bold,
          FontColor->GrayLevel[0.4]], "7"]}], "-", 
       RowBox[{"4032", " ", 
        SubscriptBox[
         StyleBox["\[Zeta]",
          FontWeight->Bold,
          FontColor->GrayLevel[0.4]], "9"]}]}], 
      SuperscriptBox[
       OverscriptBox[
        StyleBox["x",
         FontColor->RGBColor[0, 0.6, 0]], 
        StyleBox["^",
         FontColor->RGBColor[0, 0.6, 0]]], "4"]], "+", 
     FractionBox[
      RowBox[{
       RowBox[{
        RowBox[{"-", "48"}], " ", 
        SubscriptBox[
         StyleBox["\[Zeta]",
          FontWeight->Bold,
          FontColor->GrayLevel[0.4]], "7"]}], "-", 
       RowBox[{"432", " ", 
        SubscriptBox[
         StyleBox["\[Zeta]",
          FontWeight->Bold,
          FontColor->GrayLevel[0.4]], "9"]}]}], 
      SuperscriptBox[
       OverscriptBox[
        StyleBox["x",
         FontColor->RGBColor[0, 0.6, 0]], 
        StyleBox["^",
         FontColor->RGBColor[0, 0.6, 0]]], "6"]], "-", 
     FractionBox[
      RowBox[{"12", " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "9"]}], 
      SuperscriptBox[
       OverscriptBox[
        StyleBox["x",
         FontColor->RGBColor[0, 0.6, 0]], 
        StyleBox["^",
         FontColor->RGBColor[0, 0.6, 0]]], "8"]]}], ")"}]}], "+", 
  RowBox[{
   SuperscriptBox["g", "12"], " ", 
   RowBox[{"(", 
    RowBox[{
     FractionBox[
      RowBox[{"12", " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "11"]}], 
      SuperscriptBox[
       OverscriptBox[
        StyleBox["x",
         FontColor->RGBColor[0, 0.6, 0]], 
        StyleBox["^",
         FontColor->RGBColor[0, 0.6, 0]]], "10"]], "+", 
     FractionBox[
      RowBox[{
       RowBox[{"48", " ", 
        SubscriptBox[
         StyleBox["\[Zeta]",
          FontWeight->Bold,
          FontColor->GrayLevel[0.4]], "9"]}], "+", 
       RowBox[{"660", " ", 
        SubscriptBox[
         StyleBox["\[Zeta]",
          FontWeight->Bold,
          FontColor->GrayLevel[0.4]], "11"]}]}], 
      SuperscriptBox[
       OverscriptBox[
        StyleBox["x",
         FontColor->RGBColor[0, 0.6, 0]], 
        StyleBox["^",
         FontColor->RGBColor[0, 0.6, 0]]], "8"]], "+", 
     FractionBox[
      RowBox[{
       RowBox[{"336", " ", 
        SubscriptBox[
         StyleBox["\[Zeta]",
          FontWeight->Bold,
          FontColor->GrayLevel[0.4]], "7"]}], "+", 
       RowBox[{"1728", " ", 
        SubscriptBox[
         StyleBox["\[Zeta]",
          FontWeight->Bold,
          FontColor->GrayLevel[0.4]], "9"]}], "+", 
       RowBox[{"9900", " ", 
        SubscriptBox[
         StyleBox["\[Zeta]",
          FontWeight->Bold,
          FontColor->GrayLevel[0.4]], "11"]}]}], 
      SuperscriptBox[
       OverscriptBox[
        StyleBox["x",
         FontColor->RGBColor[0, 0.6, 0]], 
        StyleBox["^",
         FontColor->RGBColor[0, 0.6, 0]]], "6"]], "+", 
     FractionBox[
      RowBox[{
       RowBox[{"2820", " ", 
        SubscriptBox[
         StyleBox["\[Zeta]",
          FontWeight->Bold,
          FontColor->GrayLevel[0.4]], "5"]}], "+", 
       RowBox[{"288", " ", 
        SubscriptBox[
         StyleBox["\[Zeta]",
          FontWeight->Bold,
          FontColor->GrayLevel[0.4]], "3"], " ", 
        SubscriptBox[
         StyleBox["\[Zeta]",
          FontWeight->Bold,
          FontColor->GrayLevel[0.4]], "5"]}], "+", 
       RowBox[{"7596", " ", 
        SubscriptBox[
         StyleBox["\[Zeta]",
          FontWeight->Bold,
          FontColor->GrayLevel[0.4]], "7"]}], "+", 
       RowBox[{"16128", " ", 
        SubscriptBox[
         StyleBox["\[Zeta]",
          FontWeight->Bold,
          FontColor->GrayLevel[0.4]], "9"]}], "+", 
       RowBox[{"59400", " ", 
        SubscriptBox[
         StyleBox["\[Zeta]",
          FontWeight->Bold,
          FontColor->GrayLevel[0.4]], "11"]}]}], 
      SuperscriptBox[
       OverscriptBox[
        StyleBox["x",
         FontColor->RGBColor[0, 0.6, 0]], 
        StyleBox["^",
         FontColor->RGBColor[0, 0.6, 0]]], "4"]], "+", 
     RowBox[{
      FractionBox["1", 
       SuperscriptBox[
        OverscriptBox[
         StyleBox["x",
          FontColor->RGBColor[0, 0.6, 0]], 
         StyleBox["^",
          FontColor->RGBColor[0, 0.6, 0]]], "2"]], 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"4320", " ", 
         SubsuperscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "3", "2"]}], "+", 
        RowBox[{"31440", " ", 
         SubscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "5"]}], "+", 
        RowBox[{
         SubscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "3"], " ", 
         RowBox[{"(", 
          RowBox[{"26508", "+", 
           FractionBox[
            RowBox[{"4", " ", "Im1"}], 
            SqrtBox["3"]], "+", 
           RowBox[{"5760", " ", 
            SubscriptBox[
             StyleBox["\[Zeta]",
              FontWeight->Bold,
              FontColor->GrayLevel[0.4]], "5"]}]}], ")"}]}], "+", 
        RowBox[{"38736", " ", 
         SubscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "7"]}], "+", 
        RowBox[{"56448", " ", 
         SubscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "9"]}], "+", 
        RowBox[{"166320", " ", 
         SubscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "11"]}]}], ")"}]}]}], 
    ")"}]}]}]], "Output",
 CellChangeTimes->{{3.555790105548099*^9, 3.555790112721631*^9}, 
   3.560866853661522*^9, 3.562312530409577*^9, 3.568958045482192*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  FractionBox["Bp", "Bm"], "/.", "subFunsBethe"}]], "Input",
 CellChangeTimes->{{3.554625074626748*^9, 3.5546251003213997`*^9}}],

Cell[BoxData[
 RowBox[{"-", 
  FractionBox[
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      FractionBox["1", 
       StyleBox["x",
        FontColor->RGBColor[0, 0.6, 0]]], "-", 
      SuperscriptBox[
       OverscriptBox[
        StyleBox["y",
         FontColor->RGBColor[0, 0.6, 0]], 
        StyleBox["^",
         FontColor->RGBColor[0, 0.6, 0]]], "-"]}], ")"}], " ", 
    RowBox[{"(", 
     RowBox[{
      FractionBox["1", 
       StyleBox["x",
        FontColor->RGBColor[0, 0.6, 0]]], "+", 
      SuperscriptBox[
       OverscriptBox[
        StyleBox["y",
         FontColor->RGBColor[0, 0.6, 0]], 
        StyleBox["^",
         FontColor->RGBColor[0, 0.6, 0]]], "+"]}], ")"}]}], 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      FractionBox["1", 
       StyleBox["x",
        FontColor->RGBColor[0, 0.6, 0]]], "+", 
      SuperscriptBox[
       OverscriptBox[
        StyleBox["y",
         FontColor->RGBColor[0, 0.6, 0]], 
        StyleBox["^",
         FontColor->RGBColor[0, 0.6, 0]]], "-"]}], ")"}], " ", 
    RowBox[{"(", 
     RowBox[{
      FractionBox["1", 
       StyleBox["x",
        FontColor->RGBColor[0, 0.6, 0]]], "-", 
      SuperscriptBox[
       OverscriptBox[
        StyleBox["y",
         FontColor->RGBColor[0, 0.6, 0]], 
        StyleBox["^",
         FontColor->RGBColor[0, 0.6, 0]]], "+"]}], ")"}]}]]}]], "Output",
 CellChangeTimes->{{3.554625080316965*^9, 3.554625101000661*^9}, 
   3.555790133043139*^9, 3.5689580514246807`*^9}]
}, Open  ]],

Cell[TextData[{
 "Let us see how expansion for ",
 Cell[BoxData[
  FormBox[
   FractionBox["Bp", "Bm"], TraditionalForm]]],
 " is organised. We will use condition that finally all total momentum is zero"
}], "Text",
 CellChangeTimes->{{3.540977929854803*^9, 3.5409779392530317`*^9}, {
  3.540978004098596*^9, 3.540978015944372*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"-", 
    FractionBox[
     SuperscriptBox["D", "2"], 
     RowBox[{"1", "-", 
      SuperscriptBox["D", "2"]}]]}], 
   RowBox[{"Log", "[", 
    FractionBox["Bp", "Bm"], "]"}]}], "=", 
  RowBox[{
   RowBox[{
    RowBox[{"-", 
     FractionBox[
      SuperscriptBox["D", "2"], 
      RowBox[{"1", "-", 
       SuperscriptBox["D", "2"]}]]}], 
    RowBox[{
     SubscriptBox["\[Sum]", "r"], 
     RowBox[{"Log", "[", 
      FractionBox[
       RowBox[{"(", 
        RowBox[{
         FractionBox["1", 
          StyleBox["x",
           FontColor->RGBColor[0, 0.6, 0]]], "-", 
         SubsuperscriptBox[
          OverscriptBox[
           StyleBox["y",
            FontColor->RGBColor[0, 0.6, 0]], 
           StyleBox["^",
            FontColor->RGBColor[0, 0.6, 0]]], "r", "-"]}], ")"}], 
       RowBox[{"(", 
        RowBox[{
         FractionBox["1", 
          StyleBox["x",
           FontColor->RGBColor[0, 0.6, 0]]], "-", 
         SubsuperscriptBox[
          OverscriptBox[
           StyleBox["y",
            FontColor->RGBColor[0, 0.6, 0]], 
           StyleBox["^",
            FontColor->RGBColor[0, 0.6, 0]]], "r", "+"]}], ")"}]], "]"}]}]}], 
   "==", 
   RowBox[{"(*", " ", 
    RowBox[{"for", " ", "two", " ", "symmetric", " ", "Bethe", " ", "roots"}],
     " ", "*)"}], "\[Equal]", 
   RowBox[{
    RowBox[{"-", "2"}], 
    RowBox[{
     SubsuperscriptBox["\[Sum]", 
      RowBox[{"k", "=", "0"}], "\[Infinity]"], 
     RowBox[{
      FractionBox["1", 
       RowBox[{
        RowBox[{"2", "k"}], "+", "1"}]], 
      RowBox[{"(", 
       RowBox[{
        FractionBox["1", 
         SuperscriptBox[
          RowBox[{"(", 
           SuperscriptBox[
            OverscriptBox[
             StyleBox["y",
              FontColor->RGBColor[0, 0.6, 0]], 
             StyleBox["^",
              FontColor->RGBColor[0, 0.6, 0]]], "+"], ")"}], 
          RowBox[{
           RowBox[{"2", "k"}], "+", "1"}]]], "-", 
        FractionBox["1", 
         SuperscriptBox[
          RowBox[{"(", 
           SuperscriptBox[
            OverscriptBox[
             StyleBox["y",
              FontColor->RGBColor[0, 0.6, 0]], 
             StyleBox["^",
              FontColor->RGBColor[0, 0.6, 0]]], "-"], ")"}], 
          RowBox[{
           RowBox[{"2", "k"}], "+", "1"}]]]}], ")"}], 
      FractionBox[
       SuperscriptBox["D", "2"], 
       RowBox[{"1", "-", 
        SuperscriptBox["D", "2"]}]], 
      FractionBox["1", 
       SuperscriptBox["x", 
        RowBox[{
         RowBox[{"2", "k"}], "+", "1"}]]]}]}]}]}]}]], "Input",
 CellChangeTimes->{{3.540977944609264*^9, 3.540978053289414*^9}, {
   3.540978086106246*^9, 3.540978157082213*^9}, {3.550233373935454*^9, 
   3.5502334824698687`*^9}, 3.550234797110827*^9}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"Series", "[", 
   RowBox[{
    RowBox[{"Log", "[", 
     RowBox[{
      FractionBox[
       RowBox[{"1", "-", 
        FractionBox["1", 
         RowBox[{
          SuperscriptBox["yh", "-"], "x"}]]}], 
       RowBox[{"1", "-", 
        FractionBox["1", 
         RowBox[{
          SuperscriptBox["yh", "+"], "x"}]]}]], 
      FractionBox[
       RowBox[{"1", "+", 
        FractionBox["1", 
         RowBox[{
          SuperscriptBox["yh", "+"], "x"}]]}], 
       RowBox[{"1", "+", 
        FractionBox["1", 
         RowBox[{
          SuperscriptBox["yh", "-"], "x"}]]}]]}], "]"}], ",", 
    RowBox[{"{", 
     RowBox[{"x", ",", "\[Infinity]", ",", "5"}], "}"}]}], "]"}], "//", 
  "Normal"}]], "Input"],

Cell[BoxData[
 RowBox[{
  FractionBox[
   RowBox[{
    RowBox[{"-", 
     FractionBox["2", 
      RowBox[{"5", " ", 
       SuperscriptBox[
        RowBox[{"(", 
         SuperscriptBox[
          OverscriptBox[
           StyleBox["y",
            FontColor->RGBColor[0, 0.6, 0]], 
           StyleBox["^",
            FontColor->RGBColor[0, 0.6, 0]]], "-"], ")"}], "5"]}]]}], "+", 
    FractionBox["2", 
     RowBox[{"5", " ", 
      SuperscriptBox[
       RowBox[{"(", 
        SuperscriptBox[
         OverscriptBox[
          StyleBox["y",
           FontColor->RGBColor[0, 0.6, 0]], 
          StyleBox["^",
           FontColor->RGBColor[0, 0.6, 0]]], "+"], ")"}], "5"]}]]}], 
   SuperscriptBox[
    StyleBox["x",
     FontColor->RGBColor[0, 0.6, 0]], "5"]], "+", 
  FractionBox[
   RowBox[{
    RowBox[{"-", 
     FractionBox["2", 
      RowBox[{"3", " ", 
       SuperscriptBox[
        RowBox[{"(", 
         SuperscriptBox[
          OverscriptBox[
           StyleBox["y",
            FontColor->RGBColor[0, 0.6, 0]], 
           StyleBox["^",
            FontColor->RGBColor[0, 0.6, 0]]], "-"], ")"}], "3"]}]]}], "+", 
    FractionBox["2", 
     RowBox[{"3", " ", 
      SuperscriptBox[
       RowBox[{"(", 
        SuperscriptBox[
         OverscriptBox[
          StyleBox["y",
           FontColor->RGBColor[0, 0.6, 0]], 
          StyleBox["^",
           FontColor->RGBColor[0, 0.6, 0]]], "+"], ")"}], "3"]}]]}], 
   SuperscriptBox[
    StyleBox["x",
     FontColor->RGBColor[0, 0.6, 0]], "3"]], "+", 
  FractionBox[
   RowBox[{
    RowBox[{"-", 
     FractionBox["2", 
      SuperscriptBox[
       OverscriptBox[
        StyleBox["y",
         FontColor->RGBColor[0, 0.6, 0]], 
        StyleBox["^",
         FontColor->RGBColor[0, 0.6, 0]]], "-"]]}], "+", 
    FractionBox["2", 
     SuperscriptBox[
      OverscriptBox[
       StyleBox["y",
        FontColor->RGBColor[0, 0.6, 0]], 
       StyleBox["^",
        FontColor->RGBColor[0, 0.6, 0]]], "+"]]}], 
   StyleBox["x",
    FontColor->RGBColor[0, 0.6, 0]]]}]], "Output",
 CellChangeTimes->{3.5502333683209143`*^9, 3.555790138138912*^9, 
  3.568958066446289*^9}]
}, Open  ]],

Cell["\<\
We now expand at first 4 orders (before wrapping orders come). \
\>", "Text",
 CellChangeTimes->{{3.5502359665474567`*^9, 3.5502359827293673`*^9}, {
  3.555790239974485*^9, 3.555790253966302*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"(", 
  RowBox[{
   RowBox[{"Collect", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"Series", "[", 
       RowBox[{
        RowBox[{
         RowBox[{
          RowBox[{"Sum", "[", 
           RowBox[{
            RowBox[{
             FractionBox[
              RowBox[{"-", "2"}], 
              RowBox[{
               RowBox[{"2", "k"}], "+", "1"}]], 
             RowBox[{"(", 
              RowBox[{
               FractionBox["1", 
                SuperscriptBox[
                 RowBox[{"(", 
                  SuperscriptBox[
                   OverscriptBox[
                    StyleBox["y",
                    FontColor->RGBColor[0, 0.6, 0]], 
                    StyleBox["^",
                    FontColor->RGBColor[0, 0.6, 0]]], "+"], ")"}], 
                 RowBox[{
                  RowBox[{"2", "k"}], "+", "1"}]]], "-", 
               FractionBox["1", 
                SuperscriptBox[
                 RowBox[{"(", 
                  SuperscriptBox[
                   OverscriptBox[
                    StyleBox["y",
                    FontColor->RGBColor[0, 0.6, 0]], 
                    StyleBox["^",
                    FontColor->RGBColor[0, 0.6, 0]]], "-"], ")"}], 
                 RowBox[{
                  RowBox[{"2", "k"}], "+", "1"}]]]}], ")"}], 
             FractionBox["1", 
              SuperscriptBox[
               OverscriptBox["x", "^"], 
               RowBox[{
                RowBox[{"2", "k"}], "+", "1"}]]]}], ",", 
            RowBox[{"{", 
             RowBox[{"k", ",", "0", ",", "3"}], "}"}]}], "]"}], "/.", 
          "subJuk"}], "/.", 
         RowBox[{"leadweak", "[", "4", "]"}]}], ",", 
        RowBox[{"{", 
         RowBox[{"g", ",", "0", ",", "6"}], "}"}]}], "]"}], "//", "Normal"}], 
     ",", "u", ",", "Simplify"}], "]"}], "/.", 
   RowBox[{
    SuperscriptBox["u", "a_."], "\[RuleDelayed]", 
    SubsuperscriptBox["\[Eta]", 
     RowBox[{"-", "a"}], 
     RowBox[{"[", "2", "]"}]]}]}], ")"}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{"6", " ", "\[ImaginaryI]", " ", 
   RowBox[{"(", 
    RowBox[{
     SuperscriptBox["g", "2"], "-", 
     RowBox[{"4", " ", 
      SuperscriptBox["g", "4"]}], "+", 
     RowBox[{"28", " ", 
      SuperscriptBox["g", "6"]}]}], ")"}], " ", 
   SubsuperscriptBox[
    StyleBox["\[Eta]",
     FontWeight->Bold,
     FontColor->RGBColor[0.8, 0, 0]], "1", 
    RowBox[{"[", "2", "]"}]]}], "-", 
  RowBox[{"6", " ", "\[ImaginaryI]", " ", 
   SuperscriptBox["g", "4"], " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"-", "1"}], "+", 
     RowBox[{"4", " ", 
      SuperscriptBox["g", "2"]}]}], ")"}], " ", 
   SubsuperscriptBox[
    StyleBox["\[Eta]",
     FontWeight->Bold,
     FontColor->RGBColor[0.8, 0, 0]], "3", 
    RowBox[{"[", "2", "]"}]]}], "+", 
  RowBox[{"12", " ", "\[ImaginaryI]", " ", 
   SuperscriptBox["g", "6"], " ", 
   SubsuperscriptBox[
    StyleBox["\[Eta]",
     FontWeight->Bold,
     FontColor->RGBColor[0.8, 0, 0]], "5", 
    RowBox[{"[", "2", "]"}]]}]}]], "Output",
 CellChangeTimes->{3.558852993969563*^9, 3.568958070387313*^9, 
  3.568958183921283*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"tmpV", "=", 
   RowBox[{"(*", " ", 
    RowBox[{
    "this", " ", "includes", " ", "the", " ", "fact", " ", "that", " ", 
     "there", " ", "are", " ", "two", " ", "symmetric", " ", "Bethe", " ", 
     "roots"}], " ", "*)"}], 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"Collect", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"Series", "[", 
          RowBox[{
           RowBox[{
            RowBox[{
             RowBox[{"Sum", "[", 
              RowBox[{
               RowBox[{
                FractionBox[
                 RowBox[{"-", "2"}], 
                 RowBox[{
                  RowBox[{"2", "k"}], "+", "1"}]], 
                RowBox[{"(", 
                 RowBox[{
                  FractionBox["1", 
                   SuperscriptBox[
                    RowBox[{"(", 
                    SuperscriptBox[
                    OverscriptBox[
                    StyleBox["y",
                    FontColor->RGBColor[0, 0.6, 0]], 
                    StyleBox["^",
                    FontColor->RGBColor[0, 0.6, 0]]], "+"], ")"}], 
                    RowBox[{
                    RowBox[{"2", "k"}], "+", "1"}]]], "-", 
                  FractionBox["1", 
                   SuperscriptBox[
                    RowBox[{"(", 
                    SuperscriptBox[
                    OverscriptBox[
                    StyleBox["y",
                    FontColor->RGBColor[0, 0.6, 0]], 
                    StyleBox["^",
                    FontColor->RGBColor[0, 0.6, 0]]], "-"], ")"}], 
                    RowBox[{
                    RowBox[{"2", "k"}], "+", "1"}]]]}], ")"}], 
                FractionBox["1", 
                 SuperscriptBox[
                  OverscriptBox["x", "^"], 
                  RowBox[{
                   RowBox[{"2", "k"}], "+", "1"}]]]}], ",", 
               RowBox[{"{", 
                RowBox[{"k", ",", "0", ",", "3"}], "}"}]}], "]"}], "/.", 
             "subJuk"}], "/.", 
            RowBox[{"leadweak", "[", "4", "]"}]}], ",", 
           RowBox[{"{", 
            RowBox[{"g", ",", "0", ",", "7"}], "}"}]}], "]"}], "//", 
         "Normal"}], ",", "u", ",", "Simplify"}], "]"}], "/.", 
      RowBox[{
       SuperscriptBox["u", "a_."], "\[RuleDelayed]", 
       SubsuperscriptBox["\[Eta]", 
        RowBox[{"-", "a"}], 
        RowBox[{"[", "2", "]"}]]}]}], ")"}], "+", 
    RowBox[{"(*", 
     RowBox[{
     "contribution", " ", "from", " ", "the", " ", "dressing", " ", "phase"}],
      " ", "*)"}], 
    RowBox[{"+", 
     RowBox[{"(", 
      RowBox[{"drphase", "/.", 
       RowBox[{"leadweak", "[", "4", "]"}]}], ")"}]}]}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"tmpV", "=", 
  RowBox[{
   RowBox[{
    RowBox[{"Collect", "[", 
     RowBox[{"#", ",", 
      SubsuperscriptBox["\[Eta]", "_", 
       RowBox[{"[", "2", "]"}]], ",", "Simplify"}], "]"}], "&"}], "/@", 
   RowBox[{"Series", "[", 
    RowBox[{
     RowBox[{"Exp", "[", "tmpV", "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"g", ",", "0", ",", "7"}], "}"}]}], "]"}]}]}]}], "Input",
 CellChangeTimes->{{3.5409785710731773`*^9, 3.5409787444513063`*^9}, {
   3.540979196617437*^9, 3.540979273874674*^9}, {3.54097930854606*^9, 
   3.5409793101780643`*^9}, {3.540979379598606*^9, 3.540979380136709*^9}, {
   3.5409797406288*^9, 3.540979748366774*^9}, {3.540979779310378*^9, 
   3.5409797820452538`*^9}, 3.541012741467863*^9, {3.541012787511044*^9, 
   3.54101279022946*^9}, {3.541063821092331*^9, 3.5410638994626617`*^9}, {
   3.541063945767376*^9, 3.541063960232997*^9}, {3.541064014229698*^9, 
   3.541064014372715*^9}, {3.5502336636109533`*^9, 3.55023367999765*^9}, {
   3.550234685333322*^9, 3.550234699729247*^9}, 3.550234822363819*^9, {
   3.5502348549628*^9, 3.550234859357175*^9}, 3.550234892966872*^9, {
   3.550235148403988*^9, 3.550235205535935*^9}, {3.5502933959335403`*^9, 
   3.55029341476394*^9}, {3.552379699704681*^9, 3.5523797298066473`*^9}, {
   3.554629010208406*^9, 3.554629015007023*^9}, {3.555790262422866*^9, 
   3.555790284097692*^9}, {3.562312552453835*^9, 3.562312558453012*^9}}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"1", "+", 
   RowBox[{"6", " ", "\[ImaginaryI]", " ", 
    SubsuperscriptBox[
     StyleBox["\[Eta]",
      FontWeight->Bold,
      FontColor->RGBColor[0.8, 0, 0]], "1", 
     RowBox[{"[", "2", "]"}]], " ", 
    SuperscriptBox["g", "2"]}], "+", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      FractionBox[
       RowBox[{"12", " ", 
        SubscriptBox[
         StyleBox["\[Zeta]",
          FontWeight->Bold,
          FontColor->GrayLevel[0.4]], "3"]}], 
       SuperscriptBox[
        OverscriptBox[
         StyleBox["x",
          FontColor->RGBColor[0, 0.6, 0]], 
         StyleBox["^",
          FontColor->RGBColor[0, 0.6, 0]]], "2"]], "-", 
      RowBox[{"24", " ", "\[ImaginaryI]", " ", 
       SubsuperscriptBox[
        StyleBox["\[Eta]",
         FontWeight->Bold,
         FontColor->RGBColor[0.8, 0, 0]], "1", 
        RowBox[{"[", "2", "]"}]]}], "-", 
      RowBox[{"18", " ", 
       SuperscriptBox[
        RowBox[{"(", 
         SubsuperscriptBox[
          StyleBox["\[Eta]",
           FontWeight->Bold,
           FontColor->RGBColor[0.8, 0, 0]], "1", 
          RowBox[{"[", "2", "]"}]], ")"}], "2"]}], "+", 
      RowBox[{"6", " ", "\[ImaginaryI]", " ", 
       SubsuperscriptBox[
        StyleBox["\[Eta]",
         FontWeight->Bold,
         FontColor->RGBColor[0.8, 0, 0]], "3", 
        RowBox[{"[", "2", "]"}]]}]}], ")"}], " ", 
    SuperscriptBox["g", "4"]}], "+", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"-", 
       FractionBox[
        RowBox[{"12", " ", 
         RowBox[{"(", 
          RowBox[{
           SubscriptBox[
            StyleBox["\[Zeta]",
             FontWeight->Bold,
             FontColor->GrayLevel[0.4]], "5"], "+", 
           RowBox[{"2", " ", 
            SuperscriptBox[
             OverscriptBox[
              StyleBox["x",
               FontColor->RGBColor[0, 0.6, 0]], 
              StyleBox["^",
               FontColor->RGBColor[0, 0.6, 0]]], "2"], " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"2", " ", 
               SubscriptBox[
                StyleBox["\[Zeta]",
                 FontWeight->Bold,
                 FontColor->GrayLevel[0.4]], "3"]}], "+", 
              RowBox[{"5", " ", 
               SubscriptBox[
                StyleBox["\[Zeta]",
                 FontWeight->Bold,
                 FontColor->GrayLevel[0.4]], "5"]}]}], ")"}]}]}], ")"}]}], 
        SuperscriptBox[
         OverscriptBox[
          StyleBox["x",
           FontColor->RGBColor[0, 0.6, 0]], 
          StyleBox["^",
           FontColor->RGBColor[0, 0.6, 0]]], "4"]]}], "+", 
      RowBox[{"144", " ", 
       SuperscriptBox[
        RowBox[{"(", 
         SubsuperscriptBox[
          StyleBox["\[Eta]",
           FontWeight->Bold,
           FontColor->RGBColor[0.8, 0, 0]], "1", 
          RowBox[{"[", "2", "]"}]], ")"}], "2"]}], "-", 
      RowBox[{"36", " ", "\[ImaginaryI]", " ", 
       SuperscriptBox[
        RowBox[{"(", 
         SubsuperscriptBox[
          StyleBox["\[Eta]",
           FontWeight->Bold,
           FontColor->RGBColor[0.8, 0, 0]], "1", 
          RowBox[{"[", "2", "]"}]], ")"}], "3"]}], "+", 
      RowBox[{
       SubsuperscriptBox[
        StyleBox["\[Eta]",
         FontWeight->Bold,
         FontColor->RGBColor[0.8, 0, 0]], "1", 
        RowBox[{"[", "2", "]"}]], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"72", " ", "\[ImaginaryI]", " ", 
          RowBox[{"(", 
           RowBox[{
            FractionBox["7", "3"], "+", 
            FractionBox[
             SubscriptBox[
              StyleBox["\[Zeta]",
               FontWeight->Bold,
               FontColor->GrayLevel[0.4]], "3"], 
             SuperscriptBox[
              OverscriptBox[
               StyleBox["x",
                FontColor->RGBColor[0, 0.6, 0]], 
               StyleBox["^",
                FontColor->RGBColor[0, 0.6, 0]]], "2"]]}], ")"}]}], "-", 
         RowBox[{"36", " ", 
          SubsuperscriptBox[
           StyleBox["\[Eta]",
            FontWeight->Bold,
            FontColor->RGBColor[0.8, 0, 0]], "3", 
           RowBox[{"[", "2", "]"}]]}]}], ")"}]}], "-", 
      RowBox[{"24", " ", "\[ImaginaryI]", " ", 
       SubsuperscriptBox[
        StyleBox["\[Eta]",
         FontWeight->Bold,
         FontColor->RGBColor[0.8, 0, 0]], "3", 
        RowBox[{"[", "2", "]"}]]}], "+", 
      RowBox[{"12", " ", "\[ImaginaryI]", " ", 
       SubsuperscriptBox[
        StyleBox["\[Eta]",
         FontWeight->Bold,
         FontColor->RGBColor[0.8, 0, 0]], "5", 
        RowBox[{"[", "2", "]"}]]}]}], ")"}], " ", 
    SuperscriptBox["g", "6"]}], "+", 
   InterpretationBox[
    SuperscriptBox[
     RowBox[{"O", "[", "g", "]"}], "8"],
    SeriesData[$CellContext`g, 0, {}, 0, 8, 1],
    Editable->False]}],
  SeriesData[$CellContext`g, 0, {
   1, 0, Complex[0, 6] $CellContext`\[Eta]$[1][2], 0, 
    12 $CellContext`x$h[0]^(-2) $CellContext`\[Zeta]$[3][0] + 
    Complex[0, -24] $CellContext`\[Eta]$[1][2] - 
    18 $CellContext`\[Eta]$[1][2]^2 + 
    Complex[0, 6] $CellContext`\[Eta]$[3][2], 
    0, (-12) $CellContext`x$h[0]^(-4) ($CellContext`\[Zeta]$[5][0] + 
      2 $CellContext`x$h[0]^2 (2 $CellContext`\[Zeta]$[3][0] + 
        5 $CellContext`\[Zeta]$[5][0])) + 144 $CellContext`\[Eta]$[1][2]^2 + 
    Complex[0, -36] $CellContext`\[Eta]$[1][2]^3 + $CellContext`\[Eta]$[1][
      2] (Complex[0, 72] (
        Rational[
         7, 3] + $CellContext`x$h[0]^(-2) $CellContext`\[Zeta]$[3][0]) - 
      36 $CellContext`\[Eta]$[3][2]) + 
    Complex[0, -24] $CellContext`\[Eta]$[3][2] + 
    Complex[0, 12] $CellContext`\[Eta]$[5][2]}, 0, 8, 1],
  Editable->False]], "Output",
 CellChangeTimes->{{3.5409785914274693`*^9, 3.5409786616262417`*^9}, {
   3.5409787008458*^9, 3.540978744895681*^9}, {3.540979200299284*^9, 
   3.540979217278819*^9}, {3.5409792554850616`*^9, 3.540979310620092*^9}, 
   3.5409793491287947`*^9, 3.5409793813401546`*^9, {3.5409797412205877`*^9, 
   3.540979749082055*^9}, 3.5409797825471687`*^9, {3.541012724608779*^9, 
   3.541012741872033*^9}, 3.541012791706691*^9, {3.541063844393668*^9, 
   3.541063899887404*^9}, {3.541063948055781*^9, 3.541063960908539*^9}, 
   3.5410640148447933`*^9, 3.541064066452116*^9, 3.5502337091920443`*^9, {
   3.550234685940991*^9, 3.550234700149808*^9}, 3.5502348229162807`*^9, 
   3.5502348934621277`*^9, {3.5502351494742193`*^9, 3.5502351682300663`*^9}, 
   3.550235208023053*^9, {3.5502933967099657`*^9, 3.55029341523289*^9}, 
   3.552379618145382*^9, {3.5523797057233467`*^9, 3.5523797318632708`*^9}, 
   3.5546284190809803`*^9, 3.554629026259324*^9, 3.5546314373834047`*^9, 
   3.5557902867924347`*^9, 3.555790321489452*^9, {3.562312542451679*^9, 
   3.562312558744882*^9}, 3.568958078755797*^9, 3.5689581881321774`*^9}]
}, Open  ]],

Cell["Now we compute weak coupling expansion of U:", "Text",
 CellChangeTimes->{{3.541064105847002*^9, 3.541064114388812*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Bm", "/.", "subFunsBethe"}]], "Input",
 CellChangeTimes->{{3.5546281328784437`*^9, 3.554628135652451*^9}}],

Cell[BoxData[
 RowBox[{"-", 
  FractionBox[
   RowBox[{"\[ImaginaryI]", " ", "g", " ", 
    RowBox[{"(", 
     RowBox[{
      FractionBox["1", 
       StyleBox["x",
        FontColor->RGBColor[0, 0.6, 0]]], "+", 
      SuperscriptBox[
       OverscriptBox[
        StyleBox["y",
         FontColor->RGBColor[0, 0.6, 0]], 
        StyleBox["^",
         FontColor->RGBColor[0, 0.6, 0]]], "-"]}], ")"}], " ", 
    RowBox[{"(", 
     RowBox[{
      FractionBox["1", 
       StyleBox["x",
        FontColor->RGBColor[0, 0.6, 0]]], "-", 
      SuperscriptBox[
       OverscriptBox[
        StyleBox["y",
         FontColor->RGBColor[0, 0.6, 0]], 
        StyleBox["^",
         FontColor->RGBColor[0, 0.6, 0]]], "+"]}], ")"}]}], 
   RowBox[{
    SqrtBox[
     SuperscriptBox[
      OverscriptBox[
       StyleBox["y",
        FontColor->RGBColor[0, 0.6, 0]], 
       StyleBox["^",
        FontColor->RGBColor[0, 0.6, 0]]], "-"]], " ", 
    SqrtBox[
     SuperscriptBox[
      OverscriptBox[
       StyleBox["y",
        FontColor->RGBColor[0, 0.6, 0]], 
       StyleBox["^",
        FontColor->RGBColor[0, 0.6, 0]]], "+"]]}]]}]], "Output",
 CellChangeTimes->{3.554628136166039*^9, 3.555790326432205*^9, 
  3.568958085505846*^9, 3.568958191605991*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"tmpU", "=", 
  RowBox[{
   RowBox[{
    RowBox[{"Collect", "[", 
     RowBox[{"#", ",", 
      SubscriptBox["\[Eta]", "_"], ",", "Simplify"}], "]"}], "&"}], "/@", 
   RowBox[{"(", 
    RowBox[{"Series", "[", 
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{"Series", "[", 
         RowBox[{
          RowBox[{
           RowBox[{
            RowBox[{
             RowBox[{
              RowBox[{
               RowBox[{
                RowBox[{
                 FractionBox["1", 
                  SqrtBox[
                   SubscriptBox["C", "\[GothicCapitalT]"]]], "Bm", " ", 
                 FractionBox[
                  RowBox[{"tmpV", "//", "Normal"}], 
                  SuperscriptBox["x", 
                   RowBox[{"L", "/", "2"}]]]}], "/.", "subFunsBethe"}], "/.", 
               
               RowBox[{"x$", "\[Rule]", "x$h"}]}], "/.", 
              RowBox[{"L", "\[Rule]", "2"}]}], "/.", "subJuk"}], "//.", 
            "weak"}], "/.", 
           RowBox[{
            SubsuperscriptBox["\[Eta]", "a_", 
             RowBox[{"[", "2", "]"}]], ":>", 
            RowBox[{
             SubscriptBox["\[Eta]", "a"], "-", 
             FractionBox["1", 
              SuperscriptBox["u", "a"]]}]}]}], ",", 
          RowBox[{"{", 
           RowBox[{"g", ",", "0", ",", "9"}], "}"}]}], "]"}], "//", 
        "FullSimplify"}], "//", "Normal"}], ",", 
      RowBox[{"{", 
       RowBox[{"g", ",", "0", ",", "9"}], "}"}]}], "]"}], ")"}]}]}]], "Input",\

 CellChangeTimes->{{3.541013251210978*^9, 3.54101340607852*^9}, {
   3.541013456953495*^9, 3.541013642193056*^9}, {3.541064121000519*^9, 
   3.5410642470922527`*^9}, {3.541064436168786*^9, 3.541064444551216*^9}, 
   3.550233785522223*^9, {3.550235265468643*^9, 3.550235267007942*^9}, {
   3.5502353546492653`*^9, 3.550235364869108*^9}, {3.550235526096923*^9, 
   3.5502355264146557`*^9}, {3.552379650932255*^9, 3.552379651818725*^9}, {
   3.552379742225943*^9, 3.552379767687807*^9}, {3.5623125724389668`*^9, 
   3.562312578110621*^9}}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
   FractionBox[
    RowBox[{"\[ImaginaryI]", " ", 
     SqrtBox["2"], " ", 
     SuperscriptBox["g", "2"]}], "u"], "+", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      FractionBox[
       RowBox[{
        RowBox[{"2", " ", "\[ImaginaryI]"}], "+", 
        RowBox[{"6", " ", "u"}], "+", 
        RowBox[{"9", " ", "\[ImaginaryI]", " ", 
         SuperscriptBox["u", "2"]}]}], 
       RowBox[{
        SqrtBox["2"], " ", 
        SuperscriptBox["u", "3"]}]], "-", 
      FractionBox[
       RowBox[{"6", " ", 
        SqrtBox["2"], " ", 
        SubscriptBox[
         StyleBox["\[Eta]",
          FontWeight->Bold,
          FontColor->RGBColor[0.8, 0, 0]], "1"]}], "u"]}], ")"}], " ", 
    SuperscriptBox["g", "4"]}], "+", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      FractionBox[
       RowBox[{
        RowBox[{"16", " ", "\[ImaginaryI]"}], "+", 
        RowBox[{"48", " ", "u"}], "+", 
        RowBox[{"12", " ", "\[ImaginaryI]", " ", 
         SuperscriptBox["u", "2"]}], "+", 
        RowBox[{"12", " ", 
         SuperscriptBox["u", "3"]}], "-", 
        RowBox[{"153", " ", "\[ImaginaryI]", " ", 
         SuperscriptBox["u", "4"]}]}], 
       RowBox[{"4", " ", 
        SqrtBox["2"], " ", 
        SuperscriptBox["u", "5"]}]], "-", 
      FractionBox[
       RowBox[{"3", " ", 
        SqrtBox["2"], " ", 
        RowBox[{"(", 
         RowBox[{"2", "-", 
          RowBox[{"6", " ", "\[ImaginaryI]", " ", "u"}], "+", 
          SuperscriptBox["u", "2"]}], ")"}], " ", 
        SubscriptBox[
         StyleBox["\[Eta]",
          FontWeight->Bold,
          FontColor->RGBColor[0.8, 0, 0]], "1"]}], 
       SuperscriptBox["u", "3"]], "-", 
      FractionBox[
       RowBox[{"18", " ", "\[ImaginaryI]", " ", 
        SqrtBox["2"], " ", 
        SubsuperscriptBox[
         StyleBox["\[Eta]",
          FontWeight->Bold,
          FontColor->RGBColor[0.8, 0, 0]], "1", "2"]}], "u"], "-", 
      FractionBox[
       RowBox[{"6", " ", 
        SqrtBox["2"], " ", 
        SubscriptBox[
         StyleBox["\[Eta]",
          FontWeight->Bold,
          FontColor->RGBColor[0.8, 0, 0]], "3"]}], "u"]}], ")"}], " ", 
    SuperscriptBox["g", "6"]}], "+", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      FractionBox[
       RowBox[{
        RowBox[{"80", " ", "\[ImaginaryI]"}], "+", 
        RowBox[{"240", " ", "u"}], "+", 
        RowBox[{"48", " ", 
         SuperscriptBox["u", "3"]}], "-", 
        RowBox[{"438", " ", 
         SuperscriptBox["u", "5"]}], "+", 
        RowBox[{"2241", " ", "\[ImaginaryI]", " ", 
         SuperscriptBox["u", "6"]}], "+", 
        RowBox[{"6", " ", "\[ImaginaryI]", " ", 
         SuperscriptBox["u", "4"], " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"-", "31"}], "+", 
           RowBox[{"32", " ", 
            SubscriptBox[
             StyleBox["\[Zeta]",
              FontWeight->Bold,
              FontColor->GrayLevel[0.4]], "3"]}]}], ")"}]}]}], 
       RowBox[{"8", " ", 
        SqrtBox["2"], " ", 
        SuperscriptBox["u", "7"]}]], "+", 
      FractionBox[
       RowBox[{"9", " ", "\[ImaginaryI]", " ", 
        SqrtBox["2"], " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"-", "2"}], "+", 
          RowBox[{"6", " ", "\[ImaginaryI]", " ", "u"}], "+", 
          RowBox[{"7", " ", 
           SuperscriptBox["u", "2"]}]}], ")"}], " ", 
        SubsuperscriptBox[
         StyleBox["\[Eta]",
          FontWeight->Bold,
          FontColor->RGBColor[0.8, 0, 0]], "1", "2"]}], 
       SuperscriptBox["u", "3"]], "+", 
      FractionBox[
       RowBox[{"36", " ", 
        SqrtBox["2"], " ", 
        SubsuperscriptBox[
         StyleBox["\[Eta]",
          FontWeight->Bold,
          FontColor->RGBColor[0.8, 0, 0]], "1", "3"]}], "u"], "-", 
      FractionBox[
       RowBox[{"3", " ", 
        SqrtBox["2"], " ", 
        RowBox[{"(", 
         RowBox[{"2", "-", 
          RowBox[{"6", " ", "\[ImaginaryI]", " ", "u"}], "+", 
          SuperscriptBox["u", "2"]}], ")"}], " ", 
        SubscriptBox[
         StyleBox["\[Eta]",
          FontWeight->Bold,
          FontColor->RGBColor[0.8, 0, 0]], "3"]}], 
       SuperscriptBox["u", "3"]], "+", 
      RowBox[{
       SubscriptBox[
        StyleBox["\[Eta]",
         FontWeight->Bold,
         FontColor->RGBColor[0.8, 0, 0]], "1"], " ", 
       RowBox[{"(", 
        RowBox[{
         FractionBox[
          RowBox[{"3", " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"-", "16"}], "+", 
             RowBox[{"48", " ", "\[ImaginaryI]", " ", "u"}], "+", 
             RowBox[{"20", " ", 
              SuperscriptBox["u", "2"]}], "-", 
             RowBox[{"84", " ", "\[ImaginaryI]", " ", 
              SuperscriptBox["u", "3"]}], "+", 
             RowBox[{"73", " ", 
              SuperscriptBox["u", "4"]}]}], ")"}]}], 
          RowBox[{"2", " ", 
           SqrtBox["2"], " ", 
           SuperscriptBox["u", "5"]}]], "-", 
         FractionBox[
          RowBox[{"36", " ", "\[ImaginaryI]", " ", 
           SqrtBox["2"], " ", 
           SubscriptBox[
            StyleBox["\[Eta]",
             FontWeight->Bold,
             FontColor->RGBColor[0.8, 0, 0]], "3"]}], "u"]}], ")"}]}], "-", 
      FractionBox[
       RowBox[{"12", " ", 
        SqrtBox["2"], " ", 
        SubscriptBox[
         StyleBox["\[Eta]",
          FontWeight->Bold,
          FontColor->RGBColor[0.8, 0, 0]], "5"]}], "u"]}], ")"}], " ", 
    SuperscriptBox["g", "8"]}], "+", 
   InterpretationBox[
    SuperscriptBox[
     RowBox[{"O", "[", "g", "]"}], "10"],
    SeriesData[$CellContext`g, 0, {}, 2, 10, 1],
    Editable->False]}],
  SeriesData[$CellContext`g, 0, {
   Complex[0, 1] 2^Rational[1, 2]/$CellContext`u, 0, 
    2^Rational[-1, 2] $CellContext`u^(-3) (Complex[0, 2] + 6 $CellContext`u + 
      Complex[0, 9] $CellContext`u^2) - 6 
    2^Rational[1, 2] $CellContext`u^(-1) $CellContext`\[Eta]$[1][0], 0, 
    Rational[1, 4] 
     2^Rational[-1, 2] $CellContext`u^(-5) (Complex[0, 16] + 
      48 $CellContext`u + Complex[0, 12] $CellContext`u^2 + 
      12 $CellContext`u^3 + Complex[0, -153] $CellContext`u^4) - 3 
    2^Rational[1, 2] $CellContext`u^(-3) (2 + 
     Complex[0, -6] $CellContext`u + $CellContext`u^2) $CellContext`\[Eta]$[
     1][0] + Complex[0, -18] 
     2^Rational[1, 2] $CellContext`u^(-1) $CellContext`\[Eta]$[1][0]^2 - 6 
    2^Rational[1, 2] $CellContext`u^(-1) $CellContext`\[Eta]$[3][0], 0, 
    Rational[1, 8] 
     2^Rational[-1, 2] $CellContext`u^(-7) (Complex[0, 80] + 
      240 $CellContext`u + 48 $CellContext`u^3 - 438 $CellContext`u^5 + 
      Complex[0, 2241] $CellContext`u^6 + 
      Complex[0, 6] $CellContext`u^4 (-31 + 32 $CellContext`\[Zeta]$[3][0])) + 
    Complex[0, 9] 
     2^Rational[1, 2] $CellContext`u^(-3) (-2 + Complex[0, 6] $CellContext`u + 
      7 $CellContext`u^2) $CellContext`\[Eta]$[1][0]^2 + 
    36 2^Rational[1, 2] $CellContext`u^(-1) $CellContext`\[Eta]$[1][0]^3 - 3 
    2^Rational[1, 2] $CellContext`u^(-3) (2 + 
     Complex[0, -6] $CellContext`u + $CellContext`u^2) $CellContext`\[Eta]$[
     3][0] + $CellContext`\[Eta]$[1][0] (
      Rational[3, 2] 
       2^Rational[-1, 2] $CellContext`u^(-5) (-16 + 
        Complex[0, 48] $CellContext`u + 20 $CellContext`u^2 + 
        Complex[0, -84] $CellContext`u^3 + 73 $CellContext`u^4) + 
      Complex[0, -36] 
       2^Rational[1, 2] $CellContext`u^(-1) $CellContext`\[Eta]$[3][0]) - 12 
    2^Rational[1, 2] $CellContext`u^(-1) $CellContext`\[Eta]$[5][0]}, 2, 10, 
   1],
  Editable->False]], "Output",
 CellChangeTimes->{{3.541013272723645*^9, 3.541013406702639*^9}, {
   3.541013461160734*^9, 3.541013551045024*^9}, 3.541013592746372*^9, {
   3.541013632827179*^9, 3.541013643435733*^9}, {3.541064139458004*^9, 
   3.541064247641694*^9}, 3.54106444525426*^9, 3.55023378880963*^9, 
   3.550235366794835*^9, {3.550235514317317*^9, 3.550235530059619*^9}, 
   3.550295059687756*^9, 3.552379655877864*^9, {3.552379746016097*^9, 
   3.552379768736043*^9}, 3.554628434665938*^9, 3.554629042049081*^9, 
   3.554631444939754*^9, 3.5557903488151712`*^9, 3.562312582175993*^9, 
   3.568958091000761*^9, 3.568958193985918*^9}]
}, Open  ]],

Cell["Checking that I get correct solution of the Bethe equations", "Text",
 CellChangeTimes->{{3.541062581384129*^9, 3.541062589351054*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"eqns", "=", 
   RowBox[{
    RowBox[{"DeleteCases", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"Series", "[", " ", 
        RowBox[{
         RowBox[{
          RowBox[{"(", " ", 
           RowBox[{
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{
                FractionBox[
                 SuperscriptBox[
                  RowBox[{"(", "tmpU", ")"}], "2"], "u"], "/.", 
                RowBox[{"Shift", "[", "1", "]"}]}], "/.", 
               RowBox[{"u", "\[Rule]", 
                RowBox[{"u", "+", 
                 FractionBox["\[ImaginaryI]", "2"]}]}]}], ")"}], "/.", 
             "subtoPolyGammas"}], "/.", 
            RowBox[{"u", "\[Rule]", 
             RowBox[{"(", 
              RowBox[{"Sum", "[", 
               RowBox[{
                RowBox[{
                 SubscriptBox["u", "i"], 
                 SuperscriptBox["g", 
                  RowBox[{"2", "i"}]]}], ",", 
                RowBox[{"{", 
                 RowBox[{"i", ",", "0", ",", "3"}], "}"}]}], "]"}], ")"}]}]}],
            ")"}], "/", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{
                FractionBox[
                 SuperscriptBox[
                  RowBox[{"(", "tmpU", ")"}], "2"], "u"], "/.", 
                RowBox[{"Shift", "[", 
                 RowBox[{"-", "1"}], "]"}]}], "/.", 
               RowBox[{"u", "\[Rule]", 
                RowBox[{"u", "-", 
                 FractionBox["\[ImaginaryI]", "2"]}]}]}], ")"}], "/.", 
             "subtoPolyGammas"}], "/.", 
            RowBox[{"u", "\[Rule]", 
             RowBox[{"(", 
              RowBox[{"Sum", "[", 
               RowBox[{
                RowBox[{
                 SubscriptBox["u", "i"], 
                 SuperscriptBox["g", 
                  RowBox[{"2", "i"}]]}], ",", 
                RowBox[{"{", 
                 RowBox[{"i", ",", "0", ",", "3"}], "}"}]}], "]"}], ")"}]}]}],
            ")"}]}], ",", 
         RowBox[{"{", 
          RowBox[{"g", ",", "0", ",", "6"}], "}"}]}], "]"}], "[", 
       RowBox[{"[", "3", "]"}], "]"}], ",", "0"}], "]"}], "//", 
    "FullSimplify"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.541062591027451*^9, 3.541062779696024*^9}, {
  3.541062811500423*^9, 3.541062817926208*^9}, {3.5410628536334467`*^9, 
  3.541062867404825*^9}, {3.541063186169627*^9, 3.5410632554037113`*^9}, {
  3.541065146485201*^9, 3.541065173267652*^9}, {3.541065223269785*^9, 
  3.541065229350732*^9}, {3.550233888077039*^9, 3.5502338976096077`*^9}, {
  3.550235571633238*^9, 3.55023557633495*^9}, {3.550235609478073*^9, 
  3.550235609628674*^9}, {3.55023564573167*^9, 3.550235648387114*^9}, {
  3.552379812388949*^9, 3.552379822251638*^9}, {3.552379878581954*^9, 
  3.552379958565339*^9}}],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"eqns", "[", 
    RowBox[{"[", "1", "]"}], "]"}], "/.", 
   RowBox[{
    SubscriptBox["u", "0"], "\[Rule]", 
    FractionBox["1", 
     RowBox[{"2", 
      SqrtBox["3"]}]]}]}], "//", "FullSimplify"}], "\[IndentingNewLine]", 
 RowBox[{"Solve", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       RowBox[{"eqns", "[", 
        RowBox[{"[", "2", "]"}], "]"}], "/.", 
       RowBox[{
        SubscriptBox["u", "0"], "\[Rule]", 
        FractionBox["1", 
         RowBox[{"2", 
          SqrtBox["3"]}]]}]}], "//", "Simplify"}], ")"}], "\[Equal]", "0"}], 
   ",", 
   SubscriptBox["u", "1"]}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"Solve", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{"eqns", "[", 
         RowBox[{"[", "3", "]"}], "]"}], "/.", 
        RowBox[{
         SubscriptBox["u", "0"], "\[Rule]", 
         FractionBox["1", 
          RowBox[{"2", 
           SqrtBox["3"]}]]}]}], "/.", 
       RowBox[{
        SubscriptBox["u", "1"], "\[Rule]", 
        FractionBox["4", 
         SqrtBox["3"]]}]}], "//", "Simplify"}], ")"}], "\[Equal]", "0"}], ",", 
   SubscriptBox["u", "2"]}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"Solve", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{"eqns", "[", 
          RowBox[{"[", "4", "]"}], "]"}], "/.", 
         RowBox[{
          SubscriptBox["u", "0"], "\[Rule]", 
          FractionBox["1", 
           RowBox[{"2", 
            SqrtBox["3"]}]]}]}], "/.", 
        RowBox[{
         SubscriptBox["u", "1"], "\[Rule]", 
         FractionBox["4", 
          SqrtBox["3"]]}]}], "/.", 
       RowBox[{
        SubscriptBox["u", "2"], "\[Rule]", 
        RowBox[{"-", 
         FractionBox["10", 
          SqrtBox["3"]]}]}]}], "//", "Simplify"}], ")"}], "\[Equal]", "0"}], 
   ",", 
   SubscriptBox["u", "3"]}], "]"}]}], "Input",
 CellChangeTimes->{{3.541063256979944*^9, 3.541063311117586*^9}, {
  3.541065185837879*^9, 3.541065215892086*^9}, {3.5502356253348827`*^9, 
  3.550235642975684*^9}}],

Cell[BoxData["1"], "Output",
 CellChangeTimes->{{3.541063265658567*^9, 3.541063311441181*^9}, {
   3.541065207548922*^9, 3.541065234758616*^9}, 3.5502339067237787`*^9, 
   3.550235591858642*^9, 3.550235831268689*^9, 3.55029509300992*^9, 
   3.552379847801465*^9, 3.552379979803052*^9, 3.554628463149336*^9, 
   3.554629050428319*^9, 3.555790384043108*^9, 3.568958216667244*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"{", 
   RowBox[{
    SubscriptBox["u", "1"], "\[Rule]", 
    FractionBox["4", 
     SqrtBox["3"]]}], "}"}], "}"}]], "Output",
 CellChangeTimes->{{3.541063265658567*^9, 3.541063311441181*^9}, {
   3.541065207548922*^9, 3.541065234758616*^9}, 3.5502339067237787`*^9, 
   3.550235591858642*^9, 3.550235831268689*^9, 3.55029509300992*^9, 
   3.552379847801465*^9, 3.552379979803052*^9, 3.554628463149336*^9, 
   3.554629050428319*^9, 3.555790384043108*^9, 3.56895821668856*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"{", 
   RowBox[{
    SubscriptBox["u", "2"], "\[Rule]", 
    RowBox[{"-", 
     FractionBox["10", 
      SqrtBox["3"]]}]}], "}"}], "}"}]], "Output",
 CellChangeTimes->{{3.541063265658567*^9, 3.541063311441181*^9}, {
   3.541065207548922*^9, 3.541065234758616*^9}, 3.5502339067237787`*^9, 
   3.550235591858642*^9, 3.550235831268689*^9, 3.55029509300992*^9, 
   3.552379847801465*^9, 3.552379979803052*^9, 3.554628463149336*^9, 
   3.554629050428319*^9, 3.555790384043108*^9, 3.568958216705761*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"{", 
   RowBox[{
    SubscriptBox["u", "3"], "\[Rule]", 
    FractionBox[
     RowBox[{"8", " ", 
      RowBox[{"(", 
       RowBox[{"7", "+", 
        RowBox[{"3", " ", 
         SubscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "3"]}]}], ")"}]}], 
     SqrtBox["3"]]}], "}"}], "}"}]], "Output",
 CellChangeTimes->{{3.541063265658567*^9, 3.541063311441181*^9}, {
   3.541065207548922*^9, 3.541065234758616*^9}, 3.5502339067237787`*^9, 
   3.550235591858642*^9, 3.550235831268689*^9, 3.55029509300992*^9, 
   3.552379847801465*^9, 3.552379979803052*^9, 3.554628463149336*^9, 
   3.554629050428319*^9, 3.555790384043108*^9, 3.568958216751535*^9}]
}, Open  ]],

Cell["This is indeed what we want from other sources", "Text",
 CellChangeTimes->{{3.5410652412258787`*^9, 3.541065249353441*^9}, {
  3.5557903825443153`*^9, 3.555790385287711*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  SubscriptBox["v", "0"], "/.", 
  RowBox[{"leadweak", "[", "4", "]"}]}]], "Input",
 CellChangeTimes->{{3.541063315334242*^9, 3.541063317222026*^9}, {
  3.5689582232441797`*^9, 3.568958237529066*^9}}],

Cell[BoxData[
 RowBox[{
  FractionBox["1", 
   RowBox[{"2", " ", 
    SqrtBox["3"]}]], "+", 
  FractionBox[
   RowBox[{"4", " ", 
    SuperscriptBox["g", "2"]}], 
   SqrtBox["3"]], "-", 
  FractionBox[
   RowBox[{"10", " ", 
    SuperscriptBox["g", "4"]}], 
   SqrtBox["3"]], "+", 
  RowBox[{
   SuperscriptBox["g", "6"], " ", 
   RowBox[{"(", 
    RowBox[{
     FractionBox["56", 
      SqrtBox["3"]], "+", 
     RowBox[{"8", " ", 
      SqrtBox["3"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3"]}]}], ")"}]}]}]], "Output",
 CellChangeTimes->{
  3.541063317657002*^9, 3.541065250650701*^9, 3.550295096214519*^9, 
   3.5523812605282373`*^9, 3.55462846991842*^9, 3.555790387141555*^9, {
   3.568958216868623*^9, 3.568958237866694*^9}}]
}, Open  ]],

Cell[TextData[{
 "We still have to write down a proper normalization factor. This task was \
not explicitly resolved in the FiNLIE paper. We should use the formula  \
\[Rho]2=",
 Cell[BoxData[
  RowBox[{
   SubscriptBox["C", 
    StyleBox["\[GothicCapitalT]",
     FontColor->RGBColor[0.54, 0.35, 0.15]]], 
   RowBox[{"(", 
    RowBox[{
     RowBox[{
      StyleBox["Bp",
       FontColor->RGBColor[0, 0.6, 0]], " ", 
      StyleBox["Rm",
       FontColor->RGBColor[0, 0.6, 0]]}], "-", 
     RowBox[{
      StyleBox["Bm",
       FontColor->RGBColor[0, 0.6, 0]], " ", 
      StyleBox["Rp",
       FontColor->RGBColor[0, 0.6, 0]]}]}], 
    StyleBox[")",
     FontColor->RGBColor[0, 0.6, 0]]}]}]],
  CellChangeTimes->{{3.555790526711363*^9, 3.555790606238603*^9}, {
   3.555790653905758*^9, 3.555790684220338*^9}, {3.55579072307016*^9, 
   3.555790749697968*^9}}],
 " which indeed we can check:"
}], "Text",
 CellChangeTimes->{{3.546148460599266*^9, 3.546148487138751*^9}, {
  3.55023606868195*^9, 3.55023606880621*^9}, {3.550295109175932*^9, 
  3.5502951139594707`*^9}, {3.555790417270368*^9, 3.5557904201663303`*^9}, {
  3.555790761649184*^9, 3.5557907809018908`*^9}, {3.568958266574893*^9, 
  3.568958285245555*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"Series", "[", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{
          RowBox[{"Series", "[", 
           RowBox[{
            RowBox[{
             SuperscriptBox[
              SubscriptBox["C", 
               StyleBox["\[GothicCapitalT]",
                FontColor->RGBColor[0.54, 0.35, 0.15]]], "2"], "//.", 
             "weak"}], ",", 
            RowBox[{"{", 
             RowBox[{"g", ",", "0", ",", "8"}], "}"}]}], "]"}], 
          SuperscriptBox[
           RowBox[{"(", 
            RowBox[{
             RowBox[{
              StyleBox["Bp",
               FontColor->RGBColor[0, 0.6, 0]], " ", 
              StyleBox["Rm",
               FontColor->RGBColor[0, 0.6, 0]]}], "-", 
             RowBox[{
              StyleBox["Bm",
               FontColor->RGBColor[0, 0.6, 0]], " ", 
              StyleBox["Rp",
               FontColor->RGBColor[0, 0.6, 0]]}]}], ")"}], "2"]}], "/.", 
         "subFunsBethe"}], "/.", 
        RowBox[{"x$", "\[Rule]", "x$h"}]}], "/.", "subJuk"}], "/.", 
      RowBox[{"u", "\[Rule]", 
       RowBox[{"2", "g", " ", "z"}]}]}], "/.", 
     RowBox[{"leadweak", "[", "4", "]"}]}], ",", 
    RowBox[{"{", 
     RowBox[{"g", ",", "0", ",", "4"}], "}"}]}], "]"}], "//", 
  "Simplify"}]], "Input",
 CellChangeTimes->{{3.555790526711363*^9, 3.555790606238603*^9}, {
  3.555790653905758*^9, 3.555790684220338*^9}, {3.55579072307016*^9, 
  3.555790749697968*^9}}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
   RowBox[{"-", 
    FractionBox[
     RowBox[{"4", " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "1"}], "+", 
        SuperscriptBox["z", "2"]}], ")"}]}], 
     RowBox[{"9", " ", 
      SuperscriptBox["g", "2"]}]]}], "-", 
   RowBox[{
    FractionBox["32", "9"], " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"-", "1"}], "+", 
      SuperscriptBox["z", "2"]}], ")"}]}], "+", 
   RowBox[{
    FractionBox["32", "9"], " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"-", "1"}], "+", 
      SuperscriptBox["z", "2"]}], ")"}], " ", 
    SuperscriptBox["g", "2"]}], "-", 
   RowBox[{
    FractionBox["8", "3"], " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "1"}], "+", 
        SuperscriptBox["z", "2"]}], ")"}], " ", 
      RowBox[{"(", 
       RowBox[{"9", "+", 
        RowBox[{"8", " ", 
         SubscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "3"]}]}], ")"}]}], ")"}], " ", 
    SuperscriptBox["g", "4"]}], "+", 
   InterpretationBox[
    SuperscriptBox[
     RowBox[{"O", "[", "g", "]"}], "5"],
    SeriesData[$CellContext`g, 0, {}, -2, 5, 1],
    Editable->False]}],
  SeriesData[$CellContext`g, 0, {
   Rational[-4, 9] (-1 + $CellContext`z^2), 0, 
    Rational[-32, 9] (-1 + $CellContext`z^2), 0, 
    Rational[32, 9] (-1 + $CellContext`z^2), 0, 
    Rational[-8, 3] (-1 + $CellContext`z^2) (9 + 
     8 $CellContext`\[Zeta]$[3][0])}, -2, 5, 1],
  Editable->False]], "Output",
 CellChangeTimes->{{3.555790522948762*^9, 3.5557905601134853`*^9}, 
   3.555790592728765*^9, 3.555790625409379*^9, {3.5557906606417027`*^9, 
   3.555790673381213*^9}, {3.555790719979464*^9, 3.555790750847307*^9}, 
   3.555790782949786*^9, 3.568958276830483*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"Series", "[", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{
        SuperscriptBox["\[Rho]2", "2"], "/.", "largevolume"}], "/.", 
       "subJuk"}], "/.", 
      RowBox[{"u", "\[Rule]", 
       RowBox[{"2", "g", " ", "z"}]}]}], "//.", "weak"}], ",", 
    RowBox[{"{", 
     RowBox[{"g", ",", "0", ",", "4"}], "}"}]}], "]"}], "//", 
  "Simplify"}]], "Input",
 CellChangeTimes->{{3.554631154098867*^9, 3.554631195147354*^9}, 
   3.555790743310237*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
   RowBox[{"-", 
    FractionBox[
     RowBox[{"4", " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "1"}], "+", 
        SuperscriptBox["z", "2"]}], ")"}]}], 
     RowBox[{"9", " ", 
      SuperscriptBox["g", "2"]}]]}], "-", 
   RowBox[{
    FractionBox["32", "9"], " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"-", "1"}], "+", 
      SuperscriptBox["z", "2"]}], ")"}]}], "+", 
   RowBox[{
    FractionBox["32", "9"], " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"-", "1"}], "+", 
      SuperscriptBox["z", "2"]}], ")"}], " ", 
    SuperscriptBox["g", "2"]}], "-", 
   RowBox[{
    FractionBox["8", "3"], " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "1"}], "+", 
        SuperscriptBox["z", "2"]}], ")"}], " ", 
      RowBox[{"(", 
       RowBox[{"9", "+", 
        RowBox[{"8", " ", 
         SubscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "3"]}]}], ")"}]}], ")"}], " ", 
    SuperscriptBox["g", "4"]}], "+", 
   InterpretationBox[
    SuperscriptBox[
     RowBox[{"O", "[", "g", "]"}], "5"],
    SeriesData[$CellContext`g, 0, {}, -2, 5, 1],
    Editable->False]}],
  SeriesData[$CellContext`g, 0, {
   Rational[-4, 9] (-1 + $CellContext`z^2), 0, 
    Rational[-32, 9] (-1 + $CellContext`z^2), 0, 
    Rational[32, 9] (-1 + $CellContext`z^2), 0, 
    Rational[-8, 3] (-1 + $CellContext`z^2) (9 + 
     8 $CellContext`\[Zeta]$[3][0])}, -2, 5, 1],
  Editable->False]], "Output",
 CellChangeTimes->{
  3.554631239536442*^9, {3.5557907368333387`*^9, 3.555790744027197*^9}, 
   3.55579078369604*^9, 3.568958290695643*^9}]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"U", " ", 
    OverscriptBox["U", "_"]}], "=", 
   RowBox[{
    SqrtBox[
     RowBox[{
      SubsuperscriptBox["\[ScriptCapitalT]", 
       RowBox[{"0", ",", "0"}], "+"], 
      SubsuperscriptBox["\[ScriptCapitalT]", 
       RowBox[{"0", ",", "0"}], "-"]}]], 
    FractionBox[
     RowBox[{"(", 
      RowBox[{"1", "-", 
       RowBox[{
        SubscriptBox["Y", 
         RowBox[{"1", ",", "1"}]], 
        SubscriptBox["Y", 
         RowBox[{"2", ",", "2"}]]}]}], ")"}], 
     SubsuperscriptBox["\[GothicCapitalT]", 
      RowBox[{"0", ",", "1"}], "c"]]}]}], ",", 
  RowBox[{"(*", " ", 
   RowBox[{
    RowBox[{"asymptotically", " ", 
     SubsuperscriptBox["\[GothicCapitalT]", 
      RowBox[{"0", ",", "1"}], "c"]}], "\[Equal]", 
    SubscriptBox["\[Rho]", "2"]}], "*)"}]}]], "Input",
 CellChangeTimes->{{3.5502951161978073`*^9, 3.550295139897316*^9}}],

Cell[TextData[{
 "For asymptotic expressions we replace: ",
 Cell[BoxData[
  FormBox[
   SubscriptBox["\[ScriptCapitalT]", 
    RowBox[{"0", ",", "0"}]], TraditionalForm]]],
 " by ",
 Cell[BoxData[
  FormBox[
   SuperscriptBox["Q", "2"], TraditionalForm]]],
 ", ",
 Cell[BoxData[
  FormBox[
   RowBox[{
    RowBox[{
     SubscriptBox["Y", 
      RowBox[{"1", ",", "1"}]], 
     SubscriptBox["Y", 
      RowBox[{"2", ",", "2"}]]}], "=", 
    FractionBox[
     RowBox[{
      StyleBox["Bm",
       FontColor->RGBColor[0, 0.6, 0]], " ", 
      StyleBox["Rp",
       FontColor->RGBColor[0, 0.6, 0]]}], 
     RowBox[{
      StyleBox["Bp",
       FontColor->RGBColor[0, 0.6, 0]], " ", 
      StyleBox["Rm",
       FontColor->RGBColor[0, 0.6, 0]]}]]}], TraditionalForm]]],
 ", and ",
 Cell[BoxData[
  FormBox[
   SubscriptBox["\[Rho]", "2"], TraditionalForm]]],
 " by expressions from above"
}], "Text",
 CellChangeTimes->{{3.546148506153634*^9, 3.5461485637194147`*^9}, {
  3.546149191503974*^9, 3.546149196521796*^9}, {3.5689583151588707`*^9, 
  3.568958354314753*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   SuperscriptBox["U", "2"], 
   SuperscriptBox[
    OverscriptBox["U", "_"], "2"]}], "=", 
  RowBox[{
   RowBox[{
    SuperscriptBox[
     RowBox[{"(", 
      SuperscriptBox[
       StyleBox["Q",
        FontColor->RGBColor[0.8, 0, 0]], "-"], ")"}], "2"], " ", 
    SuperscriptBox[
     RowBox[{"(", 
      SuperscriptBox[
       StyleBox["Q",
        FontColor->RGBColor[0.8, 0, 0]], "+"], ")"}], "2"], 
    FractionBox[
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{"1", "-", 
        FractionBox[
         RowBox[{
          StyleBox["Bm",
           FontColor->RGBColor[0, 0.6, 0]], " ", 
          StyleBox["Rp",
           FontColor->RGBColor[0, 0.6, 0]]}], 
         RowBox[{
          StyleBox["Bp",
           FontColor->RGBColor[0, 0.6, 0]], " ", 
          StyleBox["Rm",
           FontColor->RGBColor[0, 0.6, 0]]}]]}], ")"}], "2"], 
     RowBox[{
      SuperscriptBox[
       SubscriptBox["C", 
        StyleBox["\[GothicCapitalT]",
         FontColor->RGBColor[0.54, 0.35, 0.15]]], "2"], 
      SuperscriptBox[
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          StyleBox["Bp",
           FontColor->RGBColor[0, 0.6, 0]], " ", 
          StyleBox["Rm",
           FontColor->RGBColor[0, 0.6, 0]]}], "-", 
         RowBox[{
          StyleBox["Bm",
           FontColor->RGBColor[0, 0.6, 0]], " ", 
          StyleBox["Rp",
           FontColor->RGBColor[0, 0.6, 0]]}]}], ")"}], "2"]}]]}], "=", 
   RowBox[{
    SuperscriptBox[
     RowBox[{"(", 
      SuperscriptBox[
       StyleBox["Q",
        FontColor->RGBColor[0.8, 0, 0]], "-"], ")"}], "2"], " ", 
    SuperscriptBox[
     RowBox[{"(", 
      SuperscriptBox[
       StyleBox["Q",
        FontColor->RGBColor[0.8, 0, 0]], "+"], ")"}], "2"], 
    FractionBox["1", 
     RowBox[{
      SuperscriptBox[
       SubscriptBox["C", 
        StyleBox["\[GothicCapitalT]",
         FontColor->RGBColor[0.54, 0.35, 0.15]]], "2"], 
      SuperscriptBox[
       RowBox[{"(", 
        RowBox[{
         StyleBox["Bp",
          FontColor->RGBColor[0, 0.6, 0]], " ", 
         StyleBox["Rm",
          FontColor->RGBColor[0, 0.6, 0]]}], ")"}], "2"]}]]}]}]}]], "Input",
 CellChangeTimes->{{3.54614864072503*^9, 3.546148671439763*^9}, {
  3.546148876546522*^9, 3.5461488770169992`*^9}, {3.546148969264196*^9, 
  3.546149020143029*^9}, {3.54614922092354*^9, 3.5461492518027697`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   FractionBox["1", 
    SubscriptBox["C", "\[GothicCapitalT]"]], 
   SuperscriptBox["Bm", "2"], " ", 
   FractionBox[
    SuperscriptBox["V", "2"], 
    SuperscriptBox[
     OverscriptBox[
      StyleBox["x",
       FontColor->RGBColor[0, 0.6, 0]], 
      StyleBox["^",
       FontColor->RGBColor[0, 0.6, 0]]], "L"]], 
   FractionBox["1", 
    SubscriptBox["C", "\[GothicCapitalT]"]], 
   SuperscriptBox["Rp", "2"], " ", 
   FractionBox[
    SuperscriptBox[
     OverscriptBox["V", "_"], "2"], 
    RowBox[{"1", "/", 
     SuperscriptBox[
      OverscriptBox[
       StyleBox["x",
        FontColor->RGBColor[0, 0.6, 0]], 
       StyleBox["^",
        FontColor->RGBColor[0, 0.6, 0]]], "L"]}]]}], "=", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     SuperscriptBox[
      StyleBox["Q",
       FontColor->RGBColor[0.8, 0, 0]], "-"], ")"}], "2"], " ", 
   SuperscriptBox[
    RowBox[{"(", 
     SuperscriptBox[
      StyleBox["Q",
       FontColor->RGBColor[0.8, 0, 0]], "+"], ")"}], "2"], 
   FractionBox["1", 
    RowBox[{
     SuperscriptBox[
      SubscriptBox["C", 
       StyleBox["\[GothicCapitalT]",
        FontColor->RGBColor[0.54, 0.35, 0.15]]], "2"], 
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{
        StyleBox["Bp",
         FontColor->RGBColor[0, 0.6, 0]], " ", 
        StyleBox["Rm",
         FontColor->RGBColor[0, 0.6, 0]]}], ")"}], "2"]}]]}]}]], "Input",
 CellChangeTimes->{{3.5461490447847137`*^9, 3.546149082576561*^9}, 
   3.546149116865201*^9, 3.546149254730631*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   SuperscriptBox["V", "2"], 
   SuperscriptBox[
    OverscriptBox["V", "_"], "2"]}], "=", 
  RowBox[{
   RowBox[{
    SuperscriptBox[
     RowBox[{"(", 
      SuperscriptBox[
       StyleBox["Q",
        FontColor->RGBColor[0.8, 0, 0]], "-"], ")"}], "2"], " ", 
    SuperscriptBox[
     RowBox[{"(", 
      SuperscriptBox[
       StyleBox["Q",
        FontColor->RGBColor[0.8, 0, 0]], "+"], ")"}], "2"], 
    FractionBox["1", 
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{
        StyleBox["Bm",
         FontColor->RGBColor[0, 0.6, 0]], " ", 
        StyleBox["Bp",
         FontColor->RGBColor[0, 0.6, 0]], " ", 
        StyleBox["Rm",
         FontColor->RGBColor[0, 0.6, 0]], " ", 
        StyleBox["Rp",
         FontColor->RGBColor[0, 0.6, 0]]}], ")"}], "2"]]}], "=", 
   RowBox[{
    RowBox[{
     SuperscriptBox[
      RowBox[{"(", 
       SuperscriptBox[
        StyleBox["Q",
         FontColor->RGBColor[0.8, 0, 0]], "-"], ")"}], "2"], " ", 
     SuperscriptBox[
      RowBox[{"(", 
       SuperscriptBox[
        StyleBox["Q",
         FontColor->RGBColor[0.8, 0, 0]], "+"], ")"}], "2"], 
     FractionBox["1", 
      SuperscriptBox[
       RowBox[{"(", 
        RowBox[{
         StyleBox["Bm",
          FontColor->RGBColor[0, 0.6, 0]], " ", 
         StyleBox["Bp",
          FontColor->RGBColor[0, 0.6, 0]], " ", 
         StyleBox["Rm",
          FontColor->RGBColor[0, 0.6, 0]], " ", 
         StyleBox["Rp",
          FontColor->RGBColor[0, 0.6, 0]]}], ")"}], "2"]]}], "=", 
    "1"}]}]}]], "Input",
 CellChangeTimes->{{3.546149125680627*^9, 3.546149142774735*^9}, {
  3.54614917731209*^9, 3.5461491813073606`*^9}, {3.5461492570413322`*^9, 
  3.546149287348721*^9}}],

Cell["The final conclusion is that V should be a pure phase. ", "Text",
 CellChangeTimes->{{3.546149288924239*^9, 3.546149305995229*^9}, {
  3.546149591739255*^9, 3.546149593448759*^9}}],

Cell["Let us see what we get perturbatively", "Text",
 CellChangeTimes->{{3.5461510514265137`*^9, 3.546151057041098*^9}}],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"tmpV", " ", "/.", 
   RowBox[{"x$h", "\[Rule]", "x$"}]}], "//", 
  "Normal"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"Series", "[", 
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{
          RowBox[{"%", 
           RowBox[{"(", 
            RowBox[{"%", "/.", "mconj"}], ")"}]}], "/.", "subtoPolyGammas"}], 
         "/.", "subZetas"}], "/.", 
        RowBox[{"x$", "\[Rule]", "x$h"}]}], "/.", "subJuk"}], "/.", 
      RowBox[{"u", "\[Rule]", 
       RowBox[{"2", " ", "g", " ", "z"}]}]}], ",", 
     RowBox[{"{", 
      RowBox[{"g", ",", "0", ",", "6"}], "}"}]}], "]"}], "//", "Simplify"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"currentnorm", "=", 
  RowBox[{
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"%", "//", "FunctionExpand"}], "//", "Simplify"}], ")"}], "/.", 
    
    RowBox[{
     RowBox[{"Zeta", "[", "a_", "]"}], "\[RuleDelayed]", 
     RowBox[{
      RowBox[{"\[Zeta]$", "[", "a", "]"}], "[", "0", "]"}]}]}], "/.", 
   RowBox[{"EulerGamma", "\[Rule]", 
    SubscriptBox["\[Zeta]", "1"]}]}]}]}], "Input",
 CellChangeTimes->{{3.554629199886119*^9, 3.554629262579628*^9}, {
  3.554631495568448*^9, 3.554631520239231*^9}, {3.555790905238027*^9, 
  3.555790910385124*^9}, {3.555790956066811*^9, 3.555790959528268*^9}, {
  3.5557912352980423`*^9, 3.555791238505212*^9}, {3.568958372965704*^9, 
  3.56895839793742*^9}}],

Cell[BoxData[
 RowBox[{"1", "+", 
  RowBox[{"6", " ", "\[ImaginaryI]", " ", 
   SuperscriptBox["g", "2"], " ", 
   SubsuperscriptBox[
    StyleBox["\[Eta]",
     FontWeight->Bold,
     FontColor->RGBColor[0.8, 0, 0]], "1", 
    RowBox[{"[", "2", "]"}]]}], "+", 
  RowBox[{
   SuperscriptBox["g", "4"], " ", 
   RowBox[{"(", 
    RowBox[{
     FractionBox[
      RowBox[{"12", " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "3"]}], 
      SuperscriptBox[
       StyleBox["x",
        FontColor->RGBColor[0, 0.6, 0]], "2"]], "-", 
     RowBox[{"24", " ", "\[ImaginaryI]", " ", 
      SubsuperscriptBox[
       StyleBox["\[Eta]",
        FontWeight->Bold,
        FontColor->RGBColor[0.8, 0, 0]], "1", 
       RowBox[{"[", "2", "]"}]]}], "-", 
     RowBox[{"18", " ", 
      SuperscriptBox[
       RowBox[{"(", 
        SubsuperscriptBox[
         StyleBox["\[Eta]",
          FontWeight->Bold,
          FontColor->RGBColor[0.8, 0, 0]], "1", 
         RowBox[{"[", "2", "]"}]], ")"}], "2"]}], "+", 
     RowBox[{"6", " ", "\[ImaginaryI]", " ", 
      SubsuperscriptBox[
       StyleBox["\[Eta]",
        FontWeight->Bold,
        FontColor->RGBColor[0.8, 0, 0]], "3", 
       RowBox[{"[", "2", "]"}]]}]}], ")"}]}], "+", 
  RowBox[{
   SuperscriptBox["g", "6"], " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"-", 
      FractionBox[
       RowBox[{"12", " ", 
        RowBox[{"(", 
         RowBox[{
          SubscriptBox[
           StyleBox["\[Zeta]",
            FontWeight->Bold,
            FontColor->GrayLevel[0.4]], "5"], "+", 
          RowBox[{"2", " ", 
           SuperscriptBox[
            StyleBox["x",
             FontColor->RGBColor[0, 0.6, 0]], "2"], " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"2", " ", 
              SubscriptBox[
               StyleBox["\[Zeta]",
                FontWeight->Bold,
                FontColor->GrayLevel[0.4]], "3"]}], "+", 
             RowBox[{"5", " ", 
              SubscriptBox[
               StyleBox["\[Zeta]",
                FontWeight->Bold,
                FontColor->GrayLevel[0.4]], "5"]}]}], ")"}]}]}], ")"}]}], 
       SuperscriptBox[
        StyleBox["x",
         FontColor->RGBColor[0, 0.6, 0]], "4"]]}], "+", 
     RowBox[{"144", " ", 
      SuperscriptBox[
       RowBox[{"(", 
        SubsuperscriptBox[
         StyleBox["\[Eta]",
          FontWeight->Bold,
          FontColor->RGBColor[0.8, 0, 0]], "1", 
         RowBox[{"[", "2", "]"}]], ")"}], "2"]}], "-", 
     RowBox[{"36", " ", "\[ImaginaryI]", " ", 
      SuperscriptBox[
       RowBox[{"(", 
        SubsuperscriptBox[
         StyleBox["\[Eta]",
          FontWeight->Bold,
          FontColor->RGBColor[0.8, 0, 0]], "1", 
         RowBox[{"[", "2", "]"}]], ")"}], "3"]}], "+", 
     RowBox[{
      SubsuperscriptBox[
       StyleBox["\[Eta]",
        FontWeight->Bold,
        FontColor->RGBColor[0.8, 0, 0]], "1", 
       RowBox[{"[", "2", "]"}]], " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"72", " ", "\[ImaginaryI]", " ", 
         RowBox[{"(", 
          RowBox[{
           FractionBox["7", "3"], "+", 
           FractionBox[
            SubscriptBox[
             StyleBox["\[Zeta]",
              FontWeight->Bold,
              FontColor->GrayLevel[0.4]], "3"], 
            SuperscriptBox[
             StyleBox["x",
              FontColor->RGBColor[0, 0.6, 0]], "2"]]}], ")"}]}], "-", 
        RowBox[{"36", " ", 
         SubsuperscriptBox[
          StyleBox["\[Eta]",
           FontWeight->Bold,
           FontColor->RGBColor[0.8, 0, 0]], "3", 
          RowBox[{"[", "2", "]"}]]}]}], ")"}]}], "-", 
     RowBox[{"24", " ", "\[ImaginaryI]", " ", 
      SubsuperscriptBox[
       StyleBox["\[Eta]",
        FontWeight->Bold,
        FontColor->RGBColor[0.8, 0, 0]], "3", 
       RowBox[{"[", "2", "]"}]]}], "+", 
     RowBox[{"12", " ", "\[ImaginaryI]", " ", 
      SubsuperscriptBox[
       StyleBox["\[Eta]",
        FontWeight->Bold,
        FontColor->RGBColor[0.8, 0, 0]], "5", 
       RowBox[{"[", "2", "]"}]]}]}], ")"}]}]}]], "Output",
 CellChangeTimes->{
  3.554629201858534*^9, {3.554629234024536*^9, 3.554629263284306*^9}, 
   3.554631466029188*^9, {3.554631498282246*^9, 3.5546315206267*^9}, {
   3.555790942365301*^9, 3.5557909602153673`*^9}, 3.5557910511313553`*^9, 
   3.55579120944219*^9, 3.555791239616622*^9, {3.5689583633863773`*^9, 
   3.568958398498863*^9}}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"1", "+", 
   RowBox[{"12", " ", 
    SubscriptBox[
     StyleBox["\[Zeta]",
      FontWeight->Bold,
      FontColor->GrayLevel[0.4]], "1"], " ", 
    SuperscriptBox["g", "2"]}], "+", 
   RowBox[{"12", " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       RowBox[{"-", "4"}], " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "1"]}], "+", 
      RowBox[{"6", " ", 
       SubsuperscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "1", "2"]}], "-", 
      RowBox[{"3", " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "3"]}]}], ")"}], " ", 
    SuperscriptBox["g", "4"]}], "+", 
   RowBox[{"48", " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       RowBox[{"-", "12"}], " ", 
       SubsuperscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "1", "2"]}], "+", 
      RowBox[{"6", " ", 
       SubsuperscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "1", "3"]}], "+", 
      RowBox[{
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "1"], " ", 
       RowBox[{"(", 
        RowBox[{"7", "-", 
         RowBox[{"9", " ", 
          SubscriptBox[
           StyleBox["\[Zeta]",
            FontWeight->Bold,
            FontColor->GrayLevel[0.4]], "3"]}]}], ")"}]}], "+", 
      RowBox[{"3", " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "3"]}], "+", 
      RowBox[{"5", " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "5"]}]}], ")"}], " ", 
    SuperscriptBox["g", "6"]}], "+", 
   InterpretationBox[
    SuperscriptBox[
     RowBox[{"O", "[", "g", "]"}], "7"],
    SeriesData[$CellContext`g, 0, {}, 0, 14, 2],
    Editable->False]}],
  SeriesData[$CellContext`g, 0, {
   1, 0, 0, 0, 12 $CellContext`\[Zeta]$[1][0], 0, 0, 0, 
    12 ((-4) $CellContext`\[Zeta]$[1][0] + 6 $CellContext`\[Zeta]$[1][0]^2 - 
     3 $CellContext`\[Zeta]$[3][0]), 0, 0, 0, 
    48 ((-12) $CellContext`\[Zeta]$[1][0]^2 + 
     6 $CellContext`\[Zeta]$[1][0]^3 + $CellContext`\[Zeta]$[1][0] (7 - 
       9 $CellContext`\[Zeta]$[3][0]) + 3 $CellContext`\[Zeta]$[3][0] + 
     5 $CellContext`\[Zeta]$[5][0])}, 0, 14, 2],
  Editable->False]], "Output",
 CellChangeTimes->{
  3.554629201858534*^9, {3.554629234024536*^9, 3.554629263284306*^9}, 
   3.554631466029188*^9, {3.554631498282246*^9, 3.5546315206267*^9}, {
   3.555790942365301*^9, 3.5557909602153673`*^9}, 3.5557910511313553`*^9, 
   3.55579120944219*^9, 3.555791239616622*^9, {3.5689583633863773`*^9, 
   3.5689583987157803`*^9}}]
}, Open  ]],

Cell[TextData[{
 "Note that role playing by the dressing factor. Since we expanded in the \
double scaling regime, dressing factor appeared in one earlier order of \
perturbation. Also the dependence on ",
 Cell[BoxData[
  FormBox["z", TraditionalForm]],
  FormatType->"TraditionalForm"],
 " went away, as it should. This is another check about validity of the \
expression."
}], "Text",
 CellChangeTimes->{{3.550295225467098*^9, 3.550295260537622*^9}, {
  3.555791145475926*^9, 3.555791205137169*^9}, {3.568958411123254*^9, 
  3.568958421113483*^9}}],

Cell["\<\
Therefore, we got an additional normalization factor which should be taken \
into account\
\>", "Text",
 CellChangeTimes->{{3.546151133221838*^9, 3.546151146021626*^9}, {
  3.550295269617263*^9, 3.550295281712967*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"nfactor", "==", 
  RowBox[{"Series", "[", 
   RowBox[{
    FractionBox["1", 
     SqrtBox["currentnorm"]], ",", 
    RowBox[{"{", 
     RowBox[{"g", ",", "0", ",", "7"}], "}"}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.54615121069209*^9, 3.5461512420064096`*^9}, {
   3.5502938971383867`*^9, 3.550293904869433*^9}, 3.5523813908223333`*^9, {
   3.555791249134062*^9, 3.55579125573005*^9}}],

Cell[BoxData[
 RowBox[{"nfactor", "\[Equal]", 
  InterpretationBox[
   RowBox[{"1", "-", 
    RowBox[{"6", " ", 
     SubscriptBox[
      StyleBox["\[Zeta]",
       FontWeight->Bold,
       FontColor->GrayLevel[0.4]], "1"], " ", 
     SuperscriptBox["g", "2"]}], "+", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{"24", " ", 
        SubscriptBox[
         StyleBox["\[Zeta]",
          FontWeight->Bold,
          FontColor->GrayLevel[0.4]], "1"]}], "+", 
       RowBox[{"18", " ", 
        SubsuperscriptBox[
         StyleBox["\[Zeta]",
          FontWeight->Bold,
          FontColor->GrayLevel[0.4]], "1", "2"]}], "+", 
       RowBox[{"18", " ", 
        SubscriptBox[
         StyleBox["\[Zeta]",
          FontWeight->Bold,
          FontColor->GrayLevel[0.4]], "3"]}]}], ")"}], " ", 
     SuperscriptBox["g", "4"]}], "+", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{
        RowBox[{"-", "168"}], " ", 
        SubscriptBox[
         StyleBox["\[Zeta]",
          FontWeight->Bold,
          FontColor->GrayLevel[0.4]], "1"]}], "-", 
       RowBox[{"144", " ", 
        SubsuperscriptBox[
         StyleBox["\[Zeta]",
          FontWeight->Bold,
          FontColor->GrayLevel[0.4]], "1", "2"]}], "-", 
       RowBox[{"36", " ", 
        SubsuperscriptBox[
         StyleBox["\[Zeta]",
          FontWeight->Bold,
          FontColor->GrayLevel[0.4]], "1", "3"]}], "-", 
       RowBox[{"72", " ", 
        SubscriptBox[
         StyleBox["\[Zeta]",
          FontWeight->Bold,
          FontColor->GrayLevel[0.4]], "3"]}], "-", 
       RowBox[{"108", " ", 
        SubscriptBox[
         StyleBox["\[Zeta]",
          FontWeight->Bold,
          FontColor->GrayLevel[0.4]], "1"], " ", 
        SubscriptBox[
         StyleBox["\[Zeta]",
          FontWeight->Bold,
          FontColor->GrayLevel[0.4]], "3"]}], "-", 
       RowBox[{"120", " ", 
        SubscriptBox[
         StyleBox["\[Zeta]",
          FontWeight->Bold,
          FontColor->GrayLevel[0.4]], "5"]}]}], ")"}], " ", 
     SuperscriptBox["g", "6"]}], "+", 
    InterpretationBox[
     SuperscriptBox[
      RowBox[{"O", "[", "g", "]"}], "7"],
     SeriesData[$CellContext`g, 0, {}, 0, 14, 2],
     Editable->False]}],
   SeriesData[$CellContext`g, 0, {
    1, 0, 0, 0, (-6) $CellContext`\[Zeta]$[1][0], 0, 0, 0, 
     24 $CellContext`\[Zeta]$[1][0] + 18 $CellContext`\[Zeta]$[1][0]^2 + 
     18 $CellContext`\[Zeta]$[3][0], 0, 0, 
     0, (-168) $CellContext`\[Zeta]$[1][0] - 
     144 $CellContext`\[Zeta]$[1][0]^2 - 36 $CellContext`\[Zeta]$[1][0]^3 - 
     72 $CellContext`\[Zeta]$[3][0] - 
     108 $CellContext`\[Zeta]$[1][0] $CellContext`\[Zeta]$[3][0] - 
     120 $CellContext`\[Zeta]$[5][0]}, 0, 14, 2],
   Editable->False]}]], "Output",
 CellChangeTimes->{{3.546151232812026*^9, 3.546151242601131*^9}, 
   3.550293907631228*^9, 3.5502953002281113`*^9, 3.5523813913651667`*^9, 
   3.555791261848412*^9, 3.568958427255638*^9}]
}, Open  ]],

Cell["We added nfactor to definition of weak", "Text",
 CellChangeTimes->{{3.5461512576506367`*^9, 3.54615127353102*^9}, {
  3.550295306023754*^9, 3.5502953062719183`*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"nfactor", "/.", "weak"}]], "Input",
 CellChangeTimes->{{3.550231336122677*^9, 3.550231337894559*^9}}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"1", "-", 
   RowBox[{"6", " ", 
    SubscriptBox[
     StyleBox["\[Zeta]",
      FontWeight->Bold,
      FontColor->GrayLevel[0.4]], "1"], " ", 
    SuperscriptBox["g", "2"]}], "+", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"24", " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "1"]}], "+", 
      RowBox[{"18", " ", 
       SubsuperscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "1", "2"]}], "+", 
      RowBox[{"18", " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "3"]}]}], ")"}], " ", 
    SuperscriptBox["g", "4"]}], "+", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       RowBox[{"-", "168"}], " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "1"]}], "-", 
      RowBox[{"144", " ", 
       SubsuperscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "1", "2"]}], "-", 
      RowBox[{"36", " ", 
       SubsuperscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "1", "3"]}], "-", 
      RowBox[{"72", " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "3"]}], "-", 
      RowBox[{"108", " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "1"], " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "3"]}], "-", 
      RowBox[{"120", " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "5"]}]}], ")"}], " ", 
    SuperscriptBox["g", "6"]}], "+", 
   InterpretationBox[
    SuperscriptBox[
     RowBox[{"O", "[", "g", "]"}], "8"],
    SeriesData[$CellContext`g, 0, {}, 0, 8, 1],
    Editable->False]}],
  SeriesData[$CellContext`g, 0, {
   1, 0, (-6) $CellContext`\[Zeta]$[1][0], 0, 24 $CellContext`\[Zeta]$[1][0] + 
    18 $CellContext`\[Zeta]$[1][0]^2 + 18 $CellContext`\[Zeta]$[3][0], 
    0, (-168) $CellContext`\[Zeta]$[1][0] - 144 $CellContext`\[Zeta]$[1][0]^2 - 
    36 $CellContext`\[Zeta]$[1][0]^3 - 72 $CellContext`\[Zeta]$[3][0] - 
    108 $CellContext`\[Zeta]$[1][0] $CellContext`\[Zeta]$[3][0] - 
    120 $CellContext`\[Zeta]$[5][0]}, 0, 8, 1],
  Editable->False]], "Output",
 CellChangeTimes->{3.5502313383609962`*^9, 3.5502939249095182`*^9, 
  3.5502940374850607`*^9, 3.550295307043724*^9, 3.55238139539924*^9, 
  3.555791380688529*^9, 3.568958432957198*^9}]
}, Open  ]],

Cell["\<\
We define V and U as {V==tmpV nfactor, U==tmpU nfactor} and store them in the \
weak replacement\
\>", "Text",
 CellChangeTimes->{{3.568958454654814*^9, 3.5689585059727907`*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{"(", 
        RowBox[{"tmpU", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"nfactor", "/.", "weak"}], "//", "Normal"}], ")"}]}], 
        ")"}], "-", 
       RowBox[{"(", 
        RowBox[{"U", "/.", "weak"}], ")"}]}], "//", "FuntoMHZbasis"}], "//", 
     "Simplify"}], ";", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{
      RowBox[{"Expand", "/@", 
       RowBox[{"(", "%", ")"}]}], "//", "FuntoMHZbasis"}], "//", 
     "Simplify"}]}], ",", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{"(", 
        RowBox[{"tmpV", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"nfactor", "/.", "weak"}], "//", "Normal"}], ")"}]}], 
        ")"}], "-", 
       RowBox[{"(", 
        RowBox[{"V", "/.", "weak"}], ")"}]}], "//", "FuntoMHZbasis"}], "//", 
     "Simplify"}], ";", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{
      RowBox[{"Expand", "/@", 
       RowBox[{"(", "%", ")"}]}], "//", "FuntoMHZbasis"}], "//", 
     "Simplify"}]}]}], "}"}]], "Input",
 CellChangeTimes->{{3.555791428772264*^9, 3.555791440600952*^9}, {
   3.555791473089497*^9, 3.5557915641167088`*^9}, 3.555791739325089*^9, {
   3.568958508736796*^9, 3.568958519696066*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   InterpretationBox[
    SuperscriptBox[
     RowBox[{"O", "[", "g", "]"}], "11"],
    SeriesData[$CellContext`g, 0, {}, 11, 11, 1],
    Editable->False], ",", 
   InterpretationBox[
    SuperscriptBox[
     RowBox[{"O", "[", "g", "]"}], "11"],
    SeriesData[$CellContext`g, 0, {}, 11, 11, 1],
    Editable->False]}], "}"}]], "Output",
 CellChangeTimes->{{3.555791736178632*^9, 3.5557917398018093`*^9}, 
   3.568958452059248*^9, 3.5689584821376343`*^9, 3.568958520063487*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"Expand", "/@", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        SuperscriptBox["U", "2"], "/.", 
        RowBox[{"leadweak", "[", "4", "]"}]}], ")"}], "-", 
      SuperscriptBox[
       RowBox[{"(", 
        RowBox[{"U", "/.", "weak"}], ")"}], "2"]}], "//.", 
     RowBox[{"shiftm\[Eta]", "[", "2", "]"}]}], ")"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"Expand", "/@", 
  RowBox[{"(", 
   RowBox[{"%", "/.", "subtopowerbasis"}], ")"}]}]}], "Input",
 CellChangeTimes->{{3.5557915798351994`*^9, 3.5557916046495333`*^9}, {
  3.5557916417768183`*^9, 3.555791711406871*^9}}],

Cell[BoxData[
 InterpretationBox[
  SuperscriptBox[
   RowBox[{"O", "[", "g", "]"}], "11"],
  SeriesData[$CellContext`g, 0, {}, 11, 11, 1],
  Editable->False]], "Output",
 CellChangeTimes->{{3.555791584987998*^9, 3.555791741114197*^9}, 
   3.5689584849226627`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
Checking that all 4 orders of normalization equation are not affected by \
wrapping.\
\>", "Subsubsection",
 CellChangeTimes->{{3.550294091475062*^9, 3.550294097471651*^9}, {
  3.552381437318009*^9, 3.552381448449937*^9}, {3.55238401293089*^9, 
  3.552384029678625*^9}, {3.568958534349923*^9, 3.5689585756746883`*^9}}],

Cell["\<\
The point is that defining equation\
\>", "Text",
 CellChangeTimes->{{3.55029410620089*^9, 3.5502941117998867`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"U", " ", 
   OverscriptBox["U", "_"]}], "=", 
  RowBox[{
   SqrtBox[
    RowBox[{
     SubsuperscriptBox["\[ScriptCapitalT]", 
      RowBox[{"0", ",", "0"}], "+"], 
     SubsuperscriptBox["\[ScriptCapitalT]", 
      RowBox[{"0", ",", "0"}], "-"]}]], 
   FractionBox[
    RowBox[{"(", 
     RowBox[{"1", "-", 
      RowBox[{
       SubscriptBox["Y", 
        RowBox[{"1", ",", "1"}]], 
       SubscriptBox["Y", 
        RowBox[{"2", ",", "2"}]]}]}], ")"}], 
    SubscriptBox["\[Rho]", "2"]]}]}]], "Input",
 CellChangeTimes->{{3.550294117927196*^9, 3.550294118987721*^9}}],

Cell["\<\
might receive corrections earlier than fifth order, because of the double \
scaling regime.\
\>", "Text",
 CellChangeTimes->{{3.550294120982806*^9, 3.5502941494775457`*^9}}],

Cell[TextData[{
 "Indeed, on the r.h.s ",
 Cell[BoxData[
  SubsuperscriptBox["\[ScriptCapitalT]", 
   RowBox[{"0", ",", "0"}], "+"]],
  CellChangeTimes->{{3.550294117927196*^9, 3.550294118987721*^9}}],
 " is ",
 Cell[BoxData[
  FormBox[
   RowBox[{
    SuperscriptBox["Q", "+"], "(", 
    RowBox[{"1", "+", 
     RowBox[{"const", " ", 
      SuperscriptBox["g", "6"]}]}], ")"}], TraditionalForm]],
  FormatType->"TraditionalForm"],
 " in the double scaling and ",
 Cell[BoxData[
  FormBox[
   SubscriptBox["\[Rho]", "2"], TraditionalForm]],
  FormatType->"TraditionalForm"],
 " should be replaced by ",
 Cell[BoxData[
  FormBox[
   SubsuperscriptBox["\[GothicCapitalT]", 
    RowBox[{"0", ",", "1"}], "c"], TraditionalForm]],
  FormatType->"TraditionalForm"],
 ", and we know that ",
 Cell[BoxData[
  FormBox[
   RowBox[{
    RowBox[{"Log", "[", 
     RowBox[{
      SubsuperscriptBox["\[GothicCapitalT]", 
       RowBox[{"0", ",", "1"}], "c"], "/", 
      SubscriptBox["\[Rho]", "2"]}], "]"}], "~", 
    SuperscriptBox["g", "7"]}], TraditionalForm]],
  FormatType->"TraditionalForm"],
 ". This does not  affect normalization of V, but for self-consistency this \
correction should have chance to be cancelled out. Apart of these two \
corrections, all other corrections starts at fifth order only, and hence \
contribute only to the double wrapping. We don\[CloseCurlyQuote]t compute \
them now."
}], "Text",
 CellChangeTimes->{{3.550294158885707*^9, 3.550294306391626*^9}}],

Cell["Recall that", "Text",
 CellChangeTimes->{{3.550294335104843*^9, 3.550294336702223*^9}}],

Cell[BoxData[{
 RowBox[{
  StyleBox["U",
   FontColor->RGBColor[0, 0.6, 0]], "\[Equal]", 
  RowBox[{
   FractionBox[
    OverscriptBox[
     StyleBox["h",
      FontColor->RGBColor[0, 0.6, 0]], 
     StyleBox["^",
      FontColor->RGBColor[0, 0.6, 0]]], 
    SuperscriptBox[
     OverscriptBox[
      StyleBox["h",
       FontColor->RGBColor[0, 0.6, 0]], 
      StyleBox["^",
       FontColor->RGBColor[0, 0.6, 0]]], 
     RowBox[{"[", "2", "]"}]]], 
   RowBox[{"(", 
    FractionBox[
     SuperscriptBox[
      StyleBox["f",
       FontColor->RGBColor[0, 0.6, 0]], 
      RowBox[{"[", "3", "]"}]], 
     SuperscriptBox[
      StyleBox["f",
       FontColor->RGBColor[0, 0.6, 0]], "+"]], ")"}], 
   RowBox[{"(", 
    FractionBox[
     SuperscriptBox[
      StyleBox["f",
       FontColor->RGBColor[0, 0.6, 0]], "+"], 
     SuperscriptBox[
      StyleBox["f",
       FontColor->RGBColor[0, 0.6, 0]], "-"]], ")"}], 
   FractionBox[
    RowBox[{" ", 
     RowBox[{
      SubscriptBox[
       StyleBox["\[GothicCapitalT]",
        FontColor->RGBColor[0.54, 0.35, 0.15]], 
       RowBox[{"2", ",", "1"}]], " ", 
      RowBox[{"(", 
       SuperscriptBox[
        StyleBox["\[ScriptCapitalT]",
         FontColor->RGBColor[1, 0, 0]], "-"], ")"}], " ", "1"}]}], 
    RowBox[{
     SubscriptBox[
      StyleBox["\[ScriptCapitalT]",
       FontColor->RGBColor[1, 0, 0]], 
      RowBox[{"1", ",", "2"}]], "  ", 
     RowBox[{"(", 
      SuperscriptBox[
       StyleBox["\[GothicCapitalT]",
        FontColor->RGBColor[0.54, 0.35, 0.15]], "-"], ")"}], " ", 
     SubscriptBox[
      StyleBox["Y",
       FontColor->RGBColor[0, 0, 0.8]], 
      RowBox[{"2", ",", "2"}]]}]], 
   SuperscriptBox[
    StyleBox["U",
     FontColor->RGBColor[0, 0.6, 0]], 
    RowBox[{"[", "2", "]"}]]}]}], "\[IndentingNewLine]", 
 RowBox[{
  SuperscriptBox[
   RowBox[{"(", 
    FractionBox[
     SuperscriptBox[
      StyleBox["f",
       FontColor->RGBColor[0, 0.6, 0]], "-"], 
     SuperscriptBox[
      StyleBox["f",
       FontColor->RGBColor[0, 0.6, 0]], "+"]], ")"}], "2"], "==", 
  RowBox[{
   FractionBox[
    SubscriptBox[
     StyleBox["\[GothicCapitalT]",
      FontColor->RGBColor[0.54, 0.35, 0.15]], 
     RowBox[{"1", ",", "0"}]], 
    SubsuperscriptBox[
     StyleBox["\[GothicCapitalT]",
      FontColor->RGBColor[0.54, 0.35, 0.15]], 
     RowBox[{"0", ",", "0"}], "-"]], 
   FractionBox["1", 
    RowBox[{" ", 
     RowBox[{
      SubscriptBox[
       StyleBox["Y",
        FontColor->RGBColor[0, 0, 0.8]], 
       RowBox[{"1", ",", "1"}]], " ", 
      SubscriptBox[
       StyleBox["Y",
        FontColor->RGBColor[0, 0, 0.8]], 
       RowBox[{"2", ",", "2"}]]}]}]]}], "==", "B"}]}], "Input",
 CellChangeTimes->{
  3.547812151450988*^9, 3.5479564456899023`*^9, {3.550294339618321*^9, 
   3.550294340426923*^9}}],

Cell[BoxData[
 RowBox[{
  StyleBox["U",
   FontColor->RGBColor[0, 0.6, 0]], "\[Equal]", 
  RowBox[{
   FractionBox[
    OverscriptBox[
     StyleBox["h",
      FontColor->RGBColor[0, 0.6, 0]], 
     StyleBox["^",
      FontColor->RGBColor[0, 0.6, 0]]], 
    SuperscriptBox[
     OverscriptBox[
      StyleBox["h",
       FontColor->RGBColor[0, 0.6, 0]], 
      StyleBox["^",
       FontColor->RGBColor[0, 0.6, 0]]], 
     RowBox[{"[", "2", "]"}]]], 
   RowBox[{"(", 
    FractionBox[
     SuperscriptBox[
      StyleBox["f",
       FontColor->RGBColor[0, 0.6, 0]], 
      RowBox[{"[", "3", "]"}]], 
     SuperscriptBox[
      StyleBox["f",
       FontColor->RGBColor[0, 0.6, 0]], "+"]], ")"}], 
   SqrtBox[
    RowBox[{"(", 
     FractionBox[
      SubsuperscriptBox[
       StyleBox["\[GothicCapitalT]",
        FontColor->RGBColor[0.54, 0.35, 0.15]], 
       RowBox[{"0", ",", "0"}], "-"], 
      SubscriptBox[
       StyleBox["\[GothicCapitalT]",
        FontColor->RGBColor[0.54, 0.35, 0.15]], 
       RowBox[{"1", ",", "0"}]]], ")"}]], 
   FractionBox[
    RowBox[{" ", 
     RowBox[{
      SubscriptBox[
       StyleBox["\[GothicCapitalT]",
        FontColor->RGBColor[0.54, 0.35, 0.15]], 
       RowBox[{"2", ",", "1"}]], " ", 
      RowBox[{"(", 
       SuperscriptBox[
        StyleBox["\[ScriptCapitalT]",
         FontColor->RGBColor[1, 0, 0]], "-"], ")"}]}]}], 
    RowBox[{
     SubscriptBox[
      StyleBox["\[ScriptCapitalT]",
       FontColor->RGBColor[1, 0, 0]], 
      RowBox[{"1", ",", "2"}]], "  ", 
     RowBox[{"(", 
      SuperscriptBox[
       StyleBox["\[GothicCapitalT]",
        FontColor->RGBColor[0.54, 0.35, 0.15]], "-"], ")"}], " "}]], 
   SqrtBox[
    FractionBox[
     SubscriptBox["Y", 
      RowBox[{"1", ",", "1"}]], 
     SubscriptBox["Y", 
      RowBox[{"2", ",", "2"}]]]], 
   SuperscriptBox[
    StyleBox["U",
     FontColor->RGBColor[0, 0.6, 0]], 
    RowBox[{"[", "2", "]"}]]}]}]], "Input",
 CellChangeTimes->{{3.550291168690516*^9, 3.5502912198991013`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Log", "[", 
   FractionBox[
    SubscriptBox["Y", 
     RowBox[{"1", ",", "1"}]], 
    SubscriptBox["Y", 
     RowBox[{"2", ",", "2"}]]], "]"}], "=", 
  RowBox[{
   RowBox[{"-", 
    RowBox[{"Log", "[", 
     FractionBox[
      SubsuperscriptBox[
       StyleBox["\[GothicCapitalT]",
        FontColor->RGBColor[0.54, 0.35, 0.15]], 
       RowBox[{"2", ",", "1"}], "2"], 
      SubsuperscriptBox[
       StyleBox["\[ScriptCapitalT]",
        FontColor->RGBColor[1, 0, 0]], 
       RowBox[{"1", ",", "2"}], "2"]], "]"}]}], "+", 
   RowBox[{"2", " ", "Re", " ", 
    RowBox[{
     SubsuperscriptBox["\[Integral]", 
      RowBox[{"-", "\[Infinity]"}], 
      RowBox[{"+", "\[Infinity]"}]], 
     RowBox[{
      FractionBox["dv", 
       RowBox[{
        RowBox[{"-", "2"}], "\[Pi]", " ", "\[ImaginaryI]"}]], 
      FractionBox["1", 
       RowBox[{"u", "-", 
        RowBox[{"(", 
         RowBox[{"v", "+", 
          RowBox[{"\[ImaginaryI]", " ", "0"}]}], ")"}]}]], 
      RowBox[{
       RowBox[{"Log", "[", 
        FractionBox[
         RowBox[{
          SubsuperscriptBox[
           StyleBox["\[GothicCapitalT]",
            FontColor->RGBColor[0.54, 0.35, 0.15]], 
           RowBox[{"0", ",", "0"}], "-"], " ", 
          SuperscriptBox[
           RowBox[{"(", 
            SuperscriptBox[
             StyleBox["\[ScriptCapitalT]",
              FontColor->RGBColor[1, 0, 0]], "-"], ")"}], "2"], " "}], 
         RowBox[{" ", 
          RowBox[{
           SubscriptBox[
            StyleBox["\[GothicCapitalT]",
             FontColor->RGBColor[0.54, 0.35, 0.15]], 
            RowBox[{"1", ",", "0"}]], " ", 
           SuperscriptBox[
            RowBox[{"(", 
             SuperscriptBox[
              StyleBox["\[GothicCapitalT]",
               FontColor->RGBColor[0.54, 0.35, 0.15]], "-"], ")"}], "2"]}]}]],
         "]"}], "[", 
       RowBox[{"v", "+", 
        RowBox[{"\[ImaginaryI]", " ", "0"}]}], "]"}], " "}]}]}]}]}]], "Input"],

Cell[BoxData[
 RowBox[{
  StyleBox["U",
   FontColor->RGBColor[0, 0.6, 0]], "\[Equal]", 
  RowBox[{
   FractionBox[
    OverscriptBox[
     StyleBox["h",
      FontColor->RGBColor[0, 0.6, 0]], 
     StyleBox["^",
      FontColor->RGBColor[0, 0.6, 0]]], 
    SuperscriptBox[
     OverscriptBox[
      StyleBox["h",
       FontColor->RGBColor[0, 0.6, 0]], 
      StyleBox["^",
       FontColor->RGBColor[0, 0.6, 0]]], 
     RowBox[{"[", "2", "]"}]]], 
   RowBox[{"(", 
    FractionBox[
     SuperscriptBox[
      StyleBox["f",
       FontColor->RGBColor[0, 0.6, 0]], 
      RowBox[{"[", "3", "]"}]], 
     SuperscriptBox[
      StyleBox["f",
       FontColor->RGBColor[0, 0.6, 0]], "+"]], ")"}], 
   SqrtBox[
    RowBox[{"(", 
     FractionBox[
      SubsuperscriptBox[
       StyleBox["\[GothicCapitalT]",
        FontColor->RGBColor[0.54, 0.35, 0.15]], 
       RowBox[{"0", ",", "0"}], "-"], 
      SubscriptBox[
       StyleBox["\[GothicCapitalT]",
        FontColor->RGBColor[0.54, 0.35, 0.15]], 
       RowBox[{"1", ",", "0"}]]], ")"}]], 
   FractionBox[
    RowBox[{"(", 
     SuperscriptBox[
      StyleBox["\[ScriptCapitalT]",
       FontColor->RGBColor[1, 0, 0]], "-"], ")"}], 
    RowBox[{
     RowBox[{"(", 
      SuperscriptBox[
       StyleBox["\[GothicCapitalT]",
        FontColor->RGBColor[0.54, 0.35, 0.15]], "-"], ")"}], " "}]], 
   SuperscriptBox[
    StyleBox["U",
     FontColor->RGBColor[0, 0.6, 0]], 
    RowBox[{"[", "2", "]"}]], 
   RowBox[{"Exp", "[", " ", 
    RowBox[{"Re", " ", 
     RowBox[{
      SubsuperscriptBox["\[Integral]", 
       RowBox[{"-", "\[Infinity]"}], 
       RowBox[{"+", "\[Infinity]"}]], 
      RowBox[{
       FractionBox["dv", 
        RowBox[{
         RowBox[{"-", "2"}], "\[Pi]", " ", "\[ImaginaryI]"}]], 
       FractionBox["1", 
        RowBox[{"u", "-", 
         RowBox[{"(", 
          RowBox[{"v", "+", 
           RowBox[{"\[ImaginaryI]", " ", "0"}]}], ")"}]}]], 
       RowBox[{
        RowBox[{"Log", "[", 
         FractionBox[
          RowBox[{
           SubsuperscriptBox[
            StyleBox["\[GothicCapitalT]",
             FontColor->RGBColor[0.54, 0.35, 0.15]], 
            RowBox[{"0", ",", "0"}], "-"], " ", 
           SuperscriptBox[
            RowBox[{"(", 
             SuperscriptBox[
              StyleBox["\[ScriptCapitalT]",
               FontColor->RGBColor[1, 0, 0]], "-"], ")"}], "2"], " "}], 
          RowBox[{" ", 
           RowBox[{
            SubscriptBox[
             StyleBox["\[GothicCapitalT]",
              FontColor->RGBColor[0.54, 0.35, 0.15]], 
             RowBox[{"1", ",", "0"}]], " ", 
            SuperscriptBox[
             RowBox[{"(", 
              SuperscriptBox[
               StyleBox["\[GothicCapitalT]",
                FontColor->RGBColor[0.54, 0.35, 0.15]], "-"], ")"}], 
             "2"]}]}]], "]"}], "[", 
        RowBox[{"v", "+", 
         RowBox[{"\[ImaginaryI]", " ", "0"}]}], "]"}]}]}]}], 
    "]"}]}]}]], "Input",
 CellChangeTimes->{{3.550291264614574*^9, 3.550291286168325*^9}, {
  3.5502915324100523`*^9, 3.550291533997917*^9}}],

Cell["\<\
We are now leaving terms which are suspicious, in the double scaling regime, \
to deviate earlier from asymptotic expression.\
\>", "Text",
 CellChangeTimes->{{3.550291427891276*^9, 3.550291442353601*^9}, {
  3.550294368758254*^9, 3.5502944238030567`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Log", "[", 
   FractionBox[
    StyleBox["U",
     FontColor->RGBColor[0, 0.6, 0]], 
    SubscriptBox[
     StyleBox["U",
      FontColor->RGBColor[0, 0.6, 0]], "asym"]], "]"}], "\[Equal]", 
  RowBox[{
   RowBox[{"Log", "[", 
    FractionBox[
     RowBox[{
      OverscriptBox[
       StyleBox["h",
        FontColor->RGBColor[0, 0.6, 0]], 
       StyleBox["^",
        FontColor->RGBColor[0, 0.6, 0]]], 
      SqrtBox[
       SubsuperscriptBox[
        StyleBox["\[GothicCapitalT]",
         FontColor->RGBColor[0.54, 0.35, 0.15]], 
        RowBox[{"0", ",", "0"}], "-"]], 
      FractionBox["1", 
       RowBox[{
        RowBox[{"(", 
         SuperscriptBox[
          StyleBox["\[GothicCapitalT]",
           FontColor->RGBColor[0.54, 0.35, 0.15]], "-"], ")"}], " "}]]}], 
     SubscriptBox[
      RowBox[{"(", 
       RowBox[{
        OverscriptBox[
         StyleBox["h",
          FontColor->RGBColor[0, 0.6, 0]], 
         StyleBox["^",
          FontColor->RGBColor[0, 0.6, 0]]], 
        SqrtBox[
         SubsuperscriptBox[
          StyleBox["\[GothicCapitalT]",
           FontColor->RGBColor[0.54, 0.35, 0.15]], 
          RowBox[{"0", ",", "0"}], "-"]], 
        FractionBox["1", 
         RowBox[{
          RowBox[{"(", 
           SuperscriptBox[
            StyleBox["\[GothicCapitalT]",
             FontColor->RGBColor[0.54, 0.35, 0.15]], "-"], ")"}], " "}]]}], 
       ")"}], "asym"]], "]"}], "+", 
   RowBox[{"O", "[", 
    SuperscriptBox["g", "8"], "]"}]}]}]], "Input",
 CellChangeTimes->{{3.5502914503804913`*^9, 3.550291468918213*^9}, 
   3.550291536797999*^9, {3.550294426246264*^9, 3.5502944551502438`*^9}}],

Cell[TextData[{
 Cell[BoxData[
  SubsuperscriptBox[
   StyleBox["\[GothicCapitalT]",
    FontColor->RGBColor[0.54, 0.35, 0.15]], 
   RowBox[{"0", ",", "0"}], "-"]],
  CellChangeTimes->{{3.5502914503804913`*^9, 3.550291468918213*^9}, 
    3.550291536797999*^9, {3.550294426246264*^9, 3.5502944551502438`*^9}}],
 " indeed deviates at 4th order, but this precisely cancells r.h.s. of  ",
 Cell[BoxData[
  RowBox[{
   RowBox[{"U", " ", 
    OverscriptBox["U", "_"]}], "=", 
   RowBox[{
    SqrtBox[
     RowBox[{
      SubsuperscriptBox["\[ScriptCapitalT]", 
       RowBox[{"0", ",", "0"}], "+"], 
      SubsuperscriptBox["\[ScriptCapitalT]", 
       RowBox[{"0", ",", "0"}], "-"]}]], 
    FractionBox[
     RowBox[{"(", 
      RowBox[{"1", "-", 
       RowBox[{
        SubscriptBox["Y", 
         RowBox[{"1", ",", "1"}]], 
        SubscriptBox["Y", 
         RowBox[{"2", ",", "2"}]]}]}], ")"}], 
     SubscriptBox["\[Rho]", "2"]]}]}]],
  CellChangeTimes->{{3.550294117927196*^9, 3.550294118987721*^9}}],
 ". So this deviation alters nothing"
}], "Text",
 CellChangeTimes->{{3.55029446884144*^9, 3.550294514567071*^9}}],

Cell[TextData[{
 Cell[BoxData[
  SuperscriptBox[
   StyleBox["\[GothicCapitalT]",
    FontColor->RGBColor[0.54, 0.35, 0.15]], "-"]],
  CellChangeTimes->{{3.5502914503804913`*^9, 3.550291468918213*^9}, 
    3.550291536797999*^9, {3.550294426246264*^9, 3.5502944551502438`*^9}}],
 " deviates at 4.5th order because of the second term in"
}], "Text",
 CellChangeTimes->{{3.5502945284090853`*^9, 3.550294545574235*^9}}],

Cell[BoxData[
 RowBox[{"\[Delta]q2", "=", 
  RowBox[{
   RowBox[{
    SuperscriptBox["\[ScriptCapitalC]", 
     RowBox[{"[", 
      RowBox[{"+", "0"}], "]"}]], 
    OverscriptBox["*", "^"], 
    SubscriptBox["\[Delta]\[Rho]", "2"]}], "-", 
   RowBox[{
    SuperscriptBox["g", "6"], " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"-", "9"}], "+", 
      SuperscriptBox["\[Pi]", "2"]}], ")"}], " ", 
    SuperscriptBox[
     RowBox[{"(", 
      RowBox[{
       RowBox[{"\[ImaginaryI]", " ", "z"}], "+", 
       SqrtBox[
        RowBox[{"1", "-", 
         SuperscriptBox["z", "2"]}]]}], ")"}], "2"], " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"-", "3"}], "+", 
      RowBox[{"2", " ", 
       RowBox[{"Zeta", "[", "3", "]"}]}]}], ")"}]}]}]}]], "Input",
 CellChangeTimes->{{3.55029453998002*^9, 3.55029454002776*^9}}],

Cell[TextData[{
 "This preciesly cancels ",
 Cell[BoxData[
  FormBox[
   RowBox[{"Log", "[", 
    RowBox[{
     SubsuperscriptBox["\[GothicCapitalT]", 
      RowBox[{"0", ",", "1"}], "c"], "/", 
     SubscriptBox["\[Rho]", "2"]}], "]"}], TraditionalForm]]],
 " deviation. Finally, from explicit expression for ",
 Cell[BoxData[
  OverscriptBox[
   StyleBox["h",
    FontColor->RGBColor[0, 0.6, 0]], 
   StyleBox["^",
    FontColor->RGBColor[0, 0.6, 0]]]]],
 ":"
}], "Text",
 CellChangeTimes->{{3.550294547957898*^9, 3.550294577493979*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{
    RowBox[{"Log", "[", " ", 
     FractionBox[
      RowBox[{
       OverscriptBox[
        StyleBox["h",
         FontColor->RGBColor[0, 0.6, 0]], 
        StyleBox["^",
         FontColor->RGBColor[0, 0.6, 0]]], " ", 
       SuperscriptBox[
        OverscriptBox[
         StyleBox["x",
          FontColor->RGBColor[0, 0.6, 0]], 
         StyleBox["^",
          FontColor->RGBColor[0, 0.6, 0]]], 
        RowBox[{
         FractionBox["L", "2"], "+", "1"}]]}], 
      SubscriptBox["\[Sigma]", "1"]], "]"}], "==", 
    RowBox[{"\[ScriptCapitalZ]", "*", 
     RowBox[{"Log", "[", 
      FractionBox[
       FractionBox[
        RowBox[{
         SuperscriptBox[
          StyleBox["\[ScriptCapitalF]",
           FontColor->RGBColor[0, 0.6, 0]], "+"], 
         RowBox[{"(", 
          RowBox[{"1", "-", 
           RowBox[{
            SubscriptBox["Y", 
             RowBox[{"1", ",", "1"}]], 
            SubscriptBox["Y", 
             RowBox[{"2", ",", "2"}]]}]}], ")"}]}], "\[Rho]"], 
       SubscriptBox[
        RowBox[{"(", 
         FractionBox[
          RowBox[{
           SuperscriptBox[
            StyleBox["\[ScriptCapitalF]",
             FontColor->RGBColor[0, 0.6, 0]], "+"], 
           RowBox[{"(", 
            RowBox[{"1", "-", 
             RowBox[{
              SubscriptBox["Y", 
               RowBox[{"1", ",", "1"}]], 
              SubscriptBox["Y", 
               RowBox[{"2", ",", "2"}]]}]}], ")"}]}], "\[Rho]"], ")"}], 
        "asym"]], "]"}]}]}], ",", 
   RowBox[{"\[ScriptCapitalZ]", "\[Equal]", 
    RowBox[{
     SubsuperscriptBox["\[Integral]", 
      RowBox[{
       RowBox[{"-", "2"}], "g"}], 
      RowBox[{"2", "g"}]], 
     RowBox[{
      FractionBox["dv", 
       RowBox[{
        RowBox[{"-", "2"}], "\[Pi]", " ", "\[ImaginaryI]"}]], 
      FractionBox[
       SqrtBox[
        RowBox[{
         RowBox[{"4", 
          SuperscriptBox["g", "2"]}], "-", 
         SuperscriptBox["u", "2"]}]], 
       SqrtBox[
        RowBox[{
         RowBox[{"4", 
          SuperscriptBox["g", "2"]}], "-", 
         SuperscriptBox["v", "2"]}]]], 
      FractionBox["1", 
       RowBox[{"u", "-", "v"}]]}]}], "\[Equal]", 
    RowBox[{
     SubsuperscriptBox["\[Integral]", 
      RowBox[{"-", "1"}], "1"], 
     RowBox[{
      FractionBox["dw", 
       RowBox[{
        RowBox[{"-", "2"}], "\[Pi]", " ", "\[ImaginaryI]"}]], 
      FractionBox[
       SqrtBox[
        RowBox[{"1", "-", 
         SuperscriptBox["z", "2"]}]], 
       SqrtBox[
        RowBox[{"1", "-", 
         SuperscriptBox["w", "2"]}]]], 
      FractionBox["1", 
       RowBox[{"z", "-", "w"}]]}]}]}]}], "}"}]], "Input",
 CellChangeTimes->{{3.550294580152154*^9, 3.5502945872857*^9}}],

Cell["\<\
We conclude that it deviates only at 5th order.\
\>", "Text",
 CellChangeTimes->{{3.550294590021484*^9, 3.550294600035618*^9}}],

Cell["\<\
The conclusion is that equation is unaffected and our normalization from \
asymptotic expressions is correct.\
\>", "Text",
 CellChangeTimes->{{3.5502946014922523`*^9, 3.550294619771064*^9}, {
  3.568958641696525*^9, 3.568958645399783*^9}}]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 "Explicit expressions for weak  coupling of ",
 Cell[BoxData[
  FormBox[
   SubscriptBox["q", 
    RowBox[{"i", ",", "j"}]], TraditionalForm]]],
 " (except ",
 Cell[BoxData[
  FormBox[
   SubscriptBox["q", 
    RowBox[{"3", ",", "4"}]], TraditionalForm]]],
 ")"
}], "Subsection",
 CellChangeTimes->{{3.538194756789219*^9, 3.538194772019889*^9}, 
   3.538292860253667*^9, {3.5388267421635056`*^9, 3.5388267452626824`*^9}, {
   3.5503789422185593`*^9, 3.550378952305046*^9}, {3.5503858819874277`*^9, 
   3.550385885896311*^9}}],

Cell[CellGroupData[{

Cell["Usage", "Subsubsection",
 CellChangeTimes->{{3.541066491268599*^9, 3.541066492391665*^9}, {
  3.55038037363339*^9, 3.5503803744792337`*^9}}],

Cell[TextData[{
 "There is a substitution \[OpenCurlyDoubleQuote]weakqij\
\[CloseCurlyDoubleQuote] which produces four nontrivial orders for all ",
 Cell[BoxData[
  FormBox[
   SubscriptBox["q", 
    RowBox[{"i", ",", "j"}]], TraditionalForm]],
  FormatType->"TraditionalForm"],
 " except ",
 Cell[BoxData[
  FormBox[
   SubscriptBox["q", 
    RowBox[{"3", ",", "4"}]], TraditionalForm]],
  FormatType->"TraditionalForm"]
}], "Text",
 CellChangeTimes->{{3.550379899616356*^9, 3.5503799254925137`*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  SubscriptBox["q", 
   RowBox[{"2", ",", "3"}]], "/.", "weakqij"}]], "Input",
 CellChangeTimes->{{3.550379965487586*^9, 3.5503799713854847`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   SuperscriptBox["g", "4"], " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"-", "3"}], "+", 
     RowBox[{"6", " ", "\[ImaginaryI]", " ", 
      StyleBox["Q0",
       FontColor->RGBColor[{
          Rational[1, 2], 
          Rational[1, 2], 0}]], " ", 
      SubsuperscriptBox[
       StyleBox["\[Eta]",
        FontWeight->Bold,
        FontColor->RGBColor[0.8, 0, 0]], "3", "+"]}]}], ")"}]}], "+", 
  RowBox[{
   SuperscriptBox["g", "6"], " ", 
   RowBox[{"(", 
    RowBox[{"12", "-", 
     RowBox[{"36", " ", "\[ImaginaryI]", " ", 
      SubsuperscriptBox[
       StyleBox["\[Eta]",
        FontWeight->Bold,
        FontColor->RGBColor[0.8, 0, 0]], "1", "+"]}], "-", 
     RowBox[{"8", " ", "\[ImaginaryI]", " ", 
      SubsuperscriptBox[
       StyleBox["\[Eta]",
        FontWeight->Bold,
        FontColor->RGBColor[0.8, 0, 0]], "3", "+"]}], "+", 
     RowBox[{
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "1"], " ", 
      RowBox[{"(", 
       RowBox[{"36", "-", 
        RowBox[{"72", " ", "\[ImaginaryI]", " ", 
         StyleBox["Q0",
          FontColor->RGBColor[{
             Rational[1, 2], 
             Rational[1, 2], 0}]], " ", 
         SubsuperscriptBox[
          StyleBox["\[Eta]",
           FontWeight->Bold,
           FontColor->RGBColor[0.8, 0, 0]], "3", "+"]}]}], ")"}]}], "+", 
     RowBox[{
      StyleBox["Q0",
       FontColor->RGBColor[{
          Rational[1, 2], 
          Rational[1, 2], 0}]], " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"12", " ", "\[ImaginaryI]", " ", 
         SubsuperscriptBox[
          StyleBox["\[Eta]",
           FontWeight->Bold,
           FontColor->RGBColor[0.8, 0, 0]], "3", "+"]}], "-", 
        RowBox[{"36", " ", 
         SubsuperscriptBox[
          StyleBox["\[Eta]",
           FontWeight->Bold,
           FontColor->RGBColor[0.8, 0, 0]], "4", "+"]}], "+", 
        RowBox[{"18", " ", "\[ImaginaryI]", " ", 
         SubsuperscriptBox[
          StyleBox["\[Eta]",
           FontWeight->Bold,
           FontColor->RGBColor[0.8, 0, 0]], "5", "+"]}], "-", 
        RowBox[{"72", " ", 
         SubsuperscriptBox[
          StyleBox["\[Eta]",
           FontWeight->Bold,
           FontColor->RGBColor[0.8, 0, 0]], 
          RowBox[{"3", ",", "1"}], "+"]}]}], ")"}]}]}], ")"}]}], "+", 
  RowBox[{
   SuperscriptBox["g", "8"], " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{
      RowBox[{"-", "12"}], " ", 
      RowBox[{"(", 
       RowBox[{"7", "+", 
        RowBox[{"9", " ", 
         SubscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "3"]}]}], ")"}]}], "+", 
     RowBox[{"288", " ", "\[ImaginaryI]", " ", 
      SubsuperscriptBox[
       StyleBox["\[Eta]",
        FontWeight->Bold,
        FontColor->RGBColor[0.8, 0, 0]], "1", "+"]}], "+", 
     RowBox[{"216", " ", 
      SubsuperscriptBox[
       StyleBox["\[Eta]",
        FontWeight->Bold,
        FontColor->RGBColor[0.8, 0, 0]], "2", "+"]}], "-", 
     RowBox[{"64", " ", "\[ImaginaryI]", " ", 
      SubsuperscriptBox[
       StyleBox["\[Eta]",
        FontWeight->Bold,
        FontColor->RGBColor[0.8, 0, 0]], "3", "+"]}], "+", 
     RowBox[{
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "1", "2"], " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "216"}], "+", 
        RowBox[{"432", " ", "\[ImaginaryI]", " ", 
         StyleBox["Q0",
          FontColor->RGBColor[{
             Rational[1, 2], 
             Rational[1, 2], 0}]], " ", 
         SubsuperscriptBox[
          StyleBox["\[Eta]",
           FontWeight->Bold,
           FontColor->RGBColor[0.8, 0, 0]], "3", "+"]}]}], ")"}]}], "+", 
     RowBox[{"48", " ", 
      SubsuperscriptBox[
       StyleBox["\[Eta]",
        FontWeight->Bold,
        FontColor->RGBColor[0.8, 0, 0]], "4", "+"]}], "-", 
     RowBox[{"24", " ", "\[ImaginaryI]", " ", 
      SubsuperscriptBox[
       StyleBox["\[Eta]",
        FontWeight->Bold,
        FontColor->RGBColor[0.8, 0, 0]], "5", "+"]}], "+", 
     RowBox[{"432", " ", 
      SubsuperscriptBox[
       StyleBox["\[Eta]",
        FontWeight->Bold,
        FontColor->RGBColor[0.8, 0, 0]], 
       RowBox[{"1", ",", "1"}], "+"]}], "+", 
     RowBox[{"96", " ", 
      SubsuperscriptBox[
       StyleBox["\[Eta]",
        FontWeight->Bold,
        FontColor->RGBColor[0.8, 0, 0]], 
       RowBox[{"3", ",", "1"}], "+"]}], "+", 
     RowBox[{
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "1"], " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "288"}], "+", 
        RowBox[{"432", " ", "\[ImaginaryI]", " ", 
         SubsuperscriptBox[
          StyleBox["\[Eta]",
           FontWeight->Bold,
           FontColor->RGBColor[0.8, 0, 0]], "1", "+"]}], "+", 
        RowBox[{"96", " ", "\[ImaginaryI]", " ", 
         SubsuperscriptBox[
          StyleBox["\[Eta]",
           FontWeight->Bold,
           FontColor->RGBColor[0.8, 0, 0]], "3", "+"]}], "+", 
        RowBox[{
         StyleBox["Q0",
          FontColor->RGBColor[{
             Rational[1, 2], 
             Rational[1, 2], 0}]], " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"144", " ", "\[ImaginaryI]", " ", 
            SubsuperscriptBox[
             StyleBox["\[Eta]",
              FontWeight->Bold,
              FontColor->RGBColor[0.8, 0, 0]], "3", "+"]}], "+", 
           RowBox[{"432", " ", 
            SubsuperscriptBox[
             StyleBox["\[Eta]",
              FontWeight->Bold,
              FontColor->RGBColor[0.8, 0, 0]], "4", "+"]}], "-", 
           RowBox[{"216", " ", "\[ImaginaryI]", " ", 
            SubsuperscriptBox[
             StyleBox["\[Eta]",
              FontWeight->Bold,
              FontColor->RGBColor[0.8, 0, 0]], "5", "+"]}], "+", 
           RowBox[{"864", " ", 
            SubsuperscriptBox[
             StyleBox["\[Eta]",
              FontWeight->Bold,
              FontColor->RGBColor[0.8, 0, 0]], 
             RowBox[{"3", ",", "1"}], "+"]}]}], ")"}]}]}], ")"}]}], "+", 
     RowBox[{
      StyleBox["Q0",
       FontColor->RGBColor[{
          Rational[1, 2], 
          Rational[1, 2], 0}]], " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"24", " ", "\[ImaginaryI]", " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"-", "5"}], "+", 
           RowBox[{"9", " ", 
            SubscriptBox[
             StyleBox["\[Zeta]",
              FontWeight->Bold,
              FontColor->GrayLevel[0.4]], "3"]}]}], ")"}], " ", 
         SubsuperscriptBox[
          StyleBox["\[Eta]",
           FontWeight->Bold,
           FontColor->RGBColor[0.8, 0, 0]], "3", "+"]}], "+", 
        RowBox[{"72", " ", 
         SubsuperscriptBox[
          StyleBox["\[Eta]",
           FontWeight->Bold,
           FontColor->RGBColor[0.8, 0, 0]], "4", "+"]}], "-", 
        RowBox[{"72", " ", "\[ImaginaryI]", " ", 
         SubsuperscriptBox[
          StyleBox["\[Eta]",
           FontWeight->Bold,
           FontColor->RGBColor[0.8, 0, 0]], "5", "+"]}], "-", 
        RowBox[{"144", " ", 
         SubsuperscriptBox[
          StyleBox["\[Eta]",
           FontWeight->Bold,
           FontColor->RGBColor[0.8, 0, 0]], "6", "+"]}], "+", 
        RowBox[{"54", " ", "\[ImaginaryI]", " ", 
         SubsuperscriptBox[
          StyleBox["\[Eta]",
           FontWeight->Bold,
           FontColor->RGBColor[0.8, 0, 0]], "7", "+"]}], "+", 
        RowBox[{"144", " ", 
         SubsuperscriptBox[
          StyleBox["\[Eta]",
           FontWeight->Bold,
           FontColor->RGBColor[0.8, 0, 0]], 
          RowBox[{"3", ",", "1"}], "+"]}], "-", 
        RowBox[{"432", " ", "\[ImaginaryI]", " ", 
         SubsuperscriptBox[
          StyleBox["\[Eta]",
           FontWeight->Bold,
           FontColor->RGBColor[0.8, 0, 0]], 
          RowBox[{"3", ",", "2"}], "+"]}], "-", 
        RowBox[{"72", " ", 
         SubsuperscriptBox[
          StyleBox["\[Eta]",
           FontWeight->Bold,
           FontColor->RGBColor[0.8, 0, 0]], 
          RowBox[{"3", ",", "3"}], "+"]}], "-", 
        RowBox[{"432", " ", "\[ImaginaryI]", " ", 
         SubsuperscriptBox[
          StyleBox["\[Eta]",
           FontWeight->Bold,
           FontColor->RGBColor[0.8, 0, 0]], 
          RowBox[{"4", ",", "1"}], "+"]}], "-", 
        RowBox[{"216", " ", 
         SubsuperscriptBox[
          StyleBox["\[Eta]",
           FontWeight->Bold,
           FontColor->RGBColor[0.8, 0, 0]], 
          RowBox[{"5", ",", "1"}], "+"]}], "-", 
        RowBox[{"864", " ", "\[ImaginaryI]", " ", 
         SubsuperscriptBox[
          StyleBox["\[Eta]",
           FontWeight->Bold,
           FontColor->RGBColor[0.8, 0, 0]], 
          RowBox[{"3", ",", "1", ",", "1"}], "+"]}]}], ")"}]}]}], ")"}]}], 
  "+", 
  RowBox[{
   SuperscriptBox["g", "10"], " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"24", " ", 
      RowBox[{"(", 
       RowBox[{"26", "+", 
        RowBox[{"39", " ", 
         SubscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "3"]}], "+", 
        RowBox[{"30", " ", 
         SubscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "5"]}]}], ")"}]}], "-", 
     RowBox[{"1296", " ", "\[ImaginaryI]", " ", 
      RowBox[{"(", 
       RowBox[{"2", "+", 
        SubscriptBox[
         StyleBox["\[Zeta]",
          FontWeight->Bold,
          FontColor->GrayLevel[0.4]], "3"]}], ")"}], " ", 
      SubsuperscriptBox[
       StyleBox["\[Eta]",
        FontWeight->Bold,
        FontColor->RGBColor[0.8, 0, 0]], "1", "+"]}], "-", 
     RowBox[{"2592", " ", 
      SubsuperscriptBox[
       StyleBox["\[Eta]",
        FontWeight->Bold,
        FontColor->RGBColor[0.8, 0, 0]], "2", "+"]}], "-", 
     RowBox[{"8", " ", "\[ImaginaryI]", " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "167"}], "+", 
        RowBox[{"42", " ", 
         SubscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "3"]}]}], ")"}], " ", 
      SubsuperscriptBox[
       StyleBox["\[Eta]",
        FontWeight->Bold,
        FontColor->RGBColor[0.8, 0, 0]], "3", "+"]}], "+", 
     RowBox[{
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "1", "3"], " ", 
      RowBox[{"(", 
       RowBox[{"864", "-", 
        RowBox[{"1728", " ", "\[ImaginaryI]", " ", 
         StyleBox["Q0",
          FontColor->RGBColor[{
             Rational[1, 2], 
             Rational[1, 2], 0}]], " ", 
         SubsuperscriptBox[
          StyleBox["\[Eta]",
           FontWeight->Bold,
           FontColor->RGBColor[0.8, 0, 0]], "3", "+"]}]}], ")"}]}], "+", 
     RowBox[{"408", " ", 
      SubsuperscriptBox[
       StyleBox["\[Eta]",
        FontWeight->Bold,
        FontColor->RGBColor[0.8, 0, 0]], "4", "+"]}], "-", 
     RowBox[{"12", " ", "\[ImaginaryI]", " ", 
      SubsuperscriptBox[
       StyleBox["\[Eta]",
        FontWeight->Bold,
        FontColor->RGBColor[0.8, 0, 0]], "5", "+"]}], "+", 
     RowBox[{"192", " ", 
      SubsuperscriptBox[
       StyleBox["\[Eta]",
        FontWeight->Bold,
        FontColor->RGBColor[0.8, 0, 0]], "6", "+"]}], "-", 
     RowBox[{"72", " ", "\[ImaginaryI]", " ", 
      SubsuperscriptBox[
       StyleBox["\[Eta]",
        FontWeight->Bold,
        FontColor->RGBColor[0.8, 0, 0]], "7", "+"]}], "-", 
     RowBox[{"5184", " ", 
      SubsuperscriptBox[
       StyleBox["\[Eta]",
        FontWeight->Bold,
        FontColor->RGBColor[0.8, 0, 0]], 
       RowBox[{"1", ",", "1"}], "+"]}], "+", 
     RowBox[{"2592", " ", "\[ImaginaryI]", " ", 
      SubsuperscriptBox[
       StyleBox["\[Eta]",
        FontWeight->Bold,
        FontColor->RGBColor[0.8, 0, 0]], 
       RowBox[{"1", ",", "2"}], "+"]}], "+", 
     RowBox[{"432", " ", 
      SubsuperscriptBox[
       StyleBox["\[Eta]",
        FontWeight->Bold,
        FontColor->RGBColor[0.8, 0, 0]], 
       RowBox[{"1", ",", "3"}], "+"]}], "+", 
     RowBox[{"2592", " ", "\[ImaginaryI]", " ", 
      SubsuperscriptBox[
       StyleBox["\[Eta]",
        FontWeight->Bold,
        FontColor->RGBColor[0.8, 0, 0]], 
       RowBox[{"2", ",", "1"}], "+"]}], "+", 
     RowBox[{
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "1", "2"], " ", 
      RowBox[{"(", 
       RowBox[{"2592", "-", 
        RowBox[{"2592", " ", "\[ImaginaryI]", " ", 
         SubsuperscriptBox[
          StyleBox["\[Eta]",
           FontWeight->Bold,
           FontColor->RGBColor[0.8, 0, 0]], "1", "+"]}], "-", 
        RowBox[{"576", " ", "\[ImaginaryI]", " ", 
         SubsuperscriptBox[
          StyleBox["\[Eta]",
           FontWeight->Bold,
           FontColor->RGBColor[0.8, 0, 0]], "3", "+"]}], "+", 
        RowBox[{
         StyleBox["Q0",
          FontColor->RGBColor[{
             Rational[1, 2], 
             Rational[1, 2], 0}]], " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{
            RowBox[{"-", "2592"}], " ", "\[ImaginaryI]", " ", 
            SubsuperscriptBox[
             StyleBox["\[Eta]",
              FontWeight->Bold,
              FontColor->RGBColor[0.8, 0, 0]], "3", "+"]}], "-", 
           RowBox[{"2592", " ", 
            SubsuperscriptBox[
             StyleBox["\[Eta]",
              FontWeight->Bold,
              FontColor->RGBColor[0.8, 0, 0]], "4", "+"]}], "+", 
           RowBox[{"1296", " ", "\[ImaginaryI]", " ", 
            SubsuperscriptBox[
             StyleBox["\[Eta]",
              FontWeight->Bold,
              FontColor->RGBColor[0.8, 0, 0]], "5", "+"]}], "-", 
           RowBox[{"5184", " ", 
            SubsuperscriptBox[
             StyleBox["\[Eta]",
              FontWeight->Bold,
              FontColor->RGBColor[0.8, 0, 0]], 
             RowBox[{"3", ",", "1"}], "+"]}]}], ")"}]}]}], ")"}]}], "+", 
     RowBox[{"384", " ", 
      SubsuperscriptBox[
       StyleBox["\[Eta]",
        FontWeight->Bold,
        FontColor->RGBColor[0.8, 0, 0]], 
       RowBox[{"3", ",", "1"}], "+"]}], "+", 
     RowBox[{"576", " ", "\[ImaginaryI]", " ", 
      SubsuperscriptBox[
       StyleBox["\[Eta]",
        FontWeight->Bold,
        FontColor->RGBColor[0.8, 0, 0]], 
       RowBox[{"3", ",", "2"}], "+"]}], "+", 
     RowBox[{"96", " ", 
      SubsuperscriptBox[
       StyleBox["\[Eta]",
        FontWeight->Bold,
        FontColor->RGBColor[0.8, 0, 0]], 
       RowBox[{"3", ",", "3"}], "+"]}], "+", 
     RowBox[{"576", " ", "\[ImaginaryI]", " ", 
      SubsuperscriptBox[
       StyleBox["\[Eta]",
        FontWeight->Bold,
        FontColor->RGBColor[0.8, 0, 0]], 
       RowBox[{"4", ",", "1"}], "+"]}], "+", 
     RowBox[{"288", " ", 
      SubsuperscriptBox[
       StyleBox["\[Eta]",
        FontWeight->Bold,
        FontColor->RGBColor[0.8, 0, 0]], 
       RowBox[{"5", ",", "1"}], "+"]}], "+", 
     RowBox[{"5184", " ", "\[ImaginaryI]", " ", 
      SubsuperscriptBox[
       StyleBox["\[Eta]",
        FontWeight->Bold,
        FontColor->RGBColor[0.8, 0, 0]], 
       RowBox[{"1", ",", "1", ",", "1"}], "+"]}], "+", 
     RowBox[{
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "1"], " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"1296", " ", 
         RowBox[{"(", 
          RowBox[{"2", "+", 
           SubscriptBox[
            StyleBox["\[Zeta]",
             FontWeight->Bold,
             FontColor->GrayLevel[0.4]], "3"]}], ")"}]}], "-", 
        RowBox[{"5184", " ", "\[ImaginaryI]", " ", 
         SubsuperscriptBox[
          StyleBox["\[Eta]",
           FontWeight->Bold,
           FontColor->RGBColor[0.8, 0, 0]], "1", "+"]}], "-", 
        RowBox[{"2592", " ", 
         SubsuperscriptBox[
          StyleBox["\[Eta]",
           FontWeight->Bold,
           FontColor->RGBColor[0.8, 0, 0]], "2", "+"]}], "+", 
        RowBox[{"384", " ", "\[ImaginaryI]", " ", 
         SubsuperscriptBox[
          StyleBox["\[Eta]",
           FontWeight->Bold,
           FontColor->RGBColor[0.8, 0, 0]], "3", "+"]}], "-", 
        RowBox[{"576", " ", 
         SubsuperscriptBox[
          StyleBox["\[Eta]",
           FontWeight->Bold,
           FontColor->RGBColor[0.8, 0, 0]], "4", "+"]}], "+", 
        RowBox[{"288", " ", "\[ImaginaryI]", " ", 
         SubsuperscriptBox[
          StyleBox["\[Eta]",
           FontWeight->Bold,
           FontColor->RGBColor[0.8, 0, 0]], "5", "+"]}], "-", 
        RowBox[{"5184", " ", 
         SubsuperscriptBox[
          StyleBox["\[Eta]",
           FontWeight->Bold,
           FontColor->RGBColor[0.8, 0, 0]], 
          RowBox[{"1", ",", "1"}], "+"]}], "-", 
        RowBox[{"1152", " ", 
         SubsuperscriptBox[
          StyleBox["\[Eta]",
           FontWeight->Bold,
           FontColor->RGBColor[0.8, 0, 0]], 
          RowBox[{"3", ",", "1"}], "+"]}], "+", 
        RowBox[{
         StyleBox["Q0",
          FontColor->RGBColor[{
             Rational[1, 2], 
             Rational[1, 2], 0}]], " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{
            RowBox[{"-", "2592"}], " ", "\[ImaginaryI]", " ", 
            SubscriptBox[
             StyleBox["\[Zeta]",
              FontWeight->Bold,
              FontColor->GrayLevel[0.4]], "3"], " ", 
            SubsuperscriptBox[
             StyleBox["\[Eta]",
              FontWeight->Bold,
              FontColor->RGBColor[0.8, 0, 0]], "3", "+"]}], "-", 
           RowBox[{"2592", " ", 
            SubsuperscriptBox[
             StyleBox["\[Eta]",
              FontWeight->Bold,
              FontColor->RGBColor[0.8, 0, 0]], "4", "+"]}], "+", 
           RowBox[{"1728", " ", "\[ImaginaryI]", " ", 
            SubsuperscriptBox[
             StyleBox["\[Eta]",
              FontWeight->Bold,
              FontColor->RGBColor[0.8, 0, 0]], "5", "+"]}], "+", 
           RowBox[{"1728", " ", 
            SubsuperscriptBox[
             StyleBox["\[Eta]",
              FontWeight->Bold,
              FontColor->RGBColor[0.8, 0, 0]], "6", "+"]}], "-", 
           RowBox[{"648", " ", "\[ImaginaryI]", " ", 
            SubsuperscriptBox[
             StyleBox["\[Eta]",
              FontWeight->Bold,
              FontColor->RGBColor[0.8, 0, 0]], "7", "+"]}], "-", 
           RowBox[{"5184", " ", 
            SubsuperscriptBox[
             StyleBox["\[Eta]",
              FontWeight->Bold,
              FontColor->RGBColor[0.8, 0, 0]], 
             RowBox[{"3", ",", "1"}], "+"]}], "+", 
           RowBox[{"5184", " ", "\[ImaginaryI]", " ", 
            SubsuperscriptBox[
             StyleBox["\[Eta]",
              FontWeight->Bold,
              FontColor->RGBColor[0.8, 0, 0]], 
             RowBox[{"3", ",", "2"}], "+"]}], "+", 
           RowBox[{"864", " ", 
            SubsuperscriptBox[
             StyleBox["\[Eta]",
              FontWeight->Bold,
              FontColor->RGBColor[0.8, 0, 0]], 
             RowBox[{"3", ",", "3"}], "+"]}], "+", 
           RowBox[{"5184", " ", "\[ImaginaryI]", " ", 
            SubsuperscriptBox[
             StyleBox["\[Eta]",
              FontWeight->Bold,
              FontColor->RGBColor[0.8, 0, 0]], 
             RowBox[{"4", ",", "1"}], "+"]}], "+", 
           RowBox[{"2592", " ", 
            SubsuperscriptBox[
             StyleBox["\[Eta]",
              FontWeight->Bold,
              FontColor->RGBColor[0.8, 0, 0]], 
             RowBox[{"5", ",", "1"}], "+"]}], "+", 
           RowBox[{"10368", " ", "\[ImaginaryI]", " ", 
            SubsuperscriptBox[
             StyleBox["\[Eta]",
              FontWeight->Bold,
              FontColor->RGBColor[0.8, 0, 0]], 
             RowBox[{"3", ",", "1", ",", "1"}], "+"]}]}], ")"}]}]}], ")"}]}], 
     "+", 
     RowBox[{"1152", " ", "\[ImaginaryI]", " ", 
      SubsuperscriptBox[
       StyleBox["\[Eta]",
        FontWeight->Bold,
        FontColor->RGBColor[0.8, 0, 0]], 
       RowBox[{"3", ",", "1", ",", "1"}], "+"]}], "+", 
     RowBox[{
      StyleBox["Q0",
       FontColor->RGBColor[{
          Rational[1, 2], 
          Rational[1, 2], 0}]], " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         RowBox[{"-", "96"}], " ", "\[ImaginaryI]", " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"-", "14"}], "+", 
           RowBox[{"6", " ", 
            SubscriptBox[
             StyleBox["\[Zeta]",
              FontWeight->Bold,
              FontColor->GrayLevel[0.4]], "3"]}], "+", 
           RowBox[{"15", " ", 
            SubscriptBox[
             StyleBox["\[Zeta]",
              FontWeight->Bold,
              FontColor->GrayLevel[0.4]], "5"]}]}], ")"}], " ", 
         SubsuperscriptBox[
          StyleBox["\[Eta]",
           FontWeight->Bold,
           FontColor->RGBColor[0.8, 0, 0]], "3", "+"]}], "-", 
        RowBox[{"1296", " ", 
         SubscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "3"], " ", 
         SubsuperscriptBox[
          StyleBox["\[Eta]",
           FontWeight->Bold,
           FontColor->RGBColor[0.8, 0, 0]], "4", "+"]}], "+", 
        RowBox[{"72", " ", "\[ImaginaryI]", " ", 
         RowBox[{"(", 
          RowBox[{"4", "+", 
           RowBox[{"11", " ", 
            SubscriptBox[
             StyleBox["\[Zeta]",
              FontWeight->Bold,
              FontColor->GrayLevel[0.4]], "3"]}]}], ")"}], " ", 
         SubsuperscriptBox[
          StyleBox["\[Eta]",
           FontWeight->Bold,
           FontColor->RGBColor[0.8, 0, 0]], "5", "+"]}], "+", 
        RowBox[{"504", " ", 
         SubsuperscriptBox[
          StyleBox["\[Eta]",
           FontWeight->Bold,
           FontColor->RGBColor[0.8, 0, 0]], "6", "+"]}], "-", 
        RowBox[{"432", " ", "\[ImaginaryI]", " ", 
         SubsuperscriptBox[
          StyleBox["\[Eta]",
           FontWeight->Bold,
           FontColor->RGBColor[0.8, 0, 0]], "7", "+"]}], "-", 
        RowBox[{"504", " ", 
         SubsuperscriptBox[
          StyleBox["\[Eta]",
           FontWeight->Bold,
           FontColor->RGBColor[0.8, 0, 0]], "8", "+"]}], "+", 
        RowBox[{"168", " ", "\[ImaginaryI]", " ", 
         SubsuperscriptBox[
          StyleBox["\[Eta]",
           FontWeight->Bold,
           FontColor->RGBColor[0.8, 0, 0]], "9", "+"]}], "-", 
        RowBox[{"2592", " ", 
         SubscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "3"], " ", 
         SubsuperscriptBox[
          StyleBox["\[Eta]",
           FontWeight->Bold,
           FontColor->RGBColor[0.8, 0, 0]], 
          RowBox[{"3", ",", "1"}], "+"]}], "+", 
        RowBox[{"2592", " ", "\[ImaginaryI]", " ", 
         SubsuperscriptBox[
          StyleBox["\[Eta]",
           FontWeight->Bold,
           FontColor->RGBColor[0.8, 0, 0]], 
          RowBox[{"3", ",", "2"}], "+"]}], "+", 
        RowBox[{"1872", " ", 
         SubsuperscriptBox[
          StyleBox["\[Eta]",
           FontWeight->Bold,
           FontColor->RGBColor[0.8, 0, 0]], 
          RowBox[{"3", ",", "3"}], "+"]}], "-", 
        RowBox[{"864", " ", "\[ImaginaryI]", " ", 
         SubsuperscriptBox[
          StyleBox["\[Eta]",
           FontWeight->Bold,
           FontColor->RGBColor[0.8, 0, 0]], 
          RowBox[{"3", ",", "4"}], "+"]}], "-", 
        RowBox[{"144", " ", 
         SubsuperscriptBox[
          StyleBox["\[Eta]",
           FontWeight->Bold,
           FontColor->RGBColor[0.8, 0, 0]], 
          RowBox[{"3", ",", "5"}], "+"]}], "+", 
        RowBox[{"2592", " ", "\[ImaginaryI]", " ", 
         SubsuperscriptBox[
          StyleBox["\[Eta]",
           FontWeight->Bold,
           FontColor->RGBColor[0.8, 0, 0]], 
          RowBox[{"4", ",", "1"}], "+"]}], "+", 
        RowBox[{"2592", " ", 
         SubsuperscriptBox[
          StyleBox["\[Eta]",
           FontWeight->Bold,
           FontColor->RGBColor[0.8, 0, 0]], 
          RowBox[{"4", ",", "2"}], "+"]}], "-", 
        RowBox[{"432", " ", "\[ImaginaryI]", " ", 
         SubsuperscriptBox[
          StyleBox["\[Eta]",
           FontWeight->Bold,
           FontColor->RGBColor[0.8, 0, 0]], 
          RowBox[{"4", ",", "3"}], "+"]}], "+", 
        RowBox[{"1728", " ", 
         SubsuperscriptBox[
          StyleBox["\[Eta]",
           FontWeight->Bold,
           FontColor->RGBColor[0.8, 0, 0]], 
          RowBox[{"5", ",", "1"}], "+"]}], "-", 
        RowBox[{"1296", " ", "\[ImaginaryI]", " ", 
         SubsuperscriptBox[
          StyleBox["\[Eta]",
           FontWeight->Bold,
           FontColor->RGBColor[0.8, 0, 0]], 
          RowBox[{"5", ",", "2"}], "+"]}], "-", 
        RowBox[{"216", " ", 
         SubsuperscriptBox[
          StyleBox["\[Eta]",
           FontWeight->Bold,
           FontColor->RGBColor[0.8, 0, 0]], 
          RowBox[{"5", ",", "3"}], "+"]}], "-", 
        RowBox[{"1728", " ", "\[ImaginaryI]", " ", 
         SubsuperscriptBox[
          StyleBox["\[Eta]",
           FontWeight->Bold,
           FontColor->RGBColor[0.8, 0, 0]], 
          RowBox[{"6", ",", "1"}], "+"]}], "-", 
        RowBox[{"648", " ", 
         SubsuperscriptBox[
          StyleBox["\[Eta]",
           FontWeight->Bold,
           FontColor->RGBColor[0.8, 0, 0]], 
          RowBox[{"7", ",", "1"}], "+"]}], "+", 
        RowBox[{"5184", " ", "\[ImaginaryI]", " ", 
         SubsuperscriptBox[
          StyleBox["\[Eta]",
           FontWeight->Bold,
           FontColor->RGBColor[0.8, 0, 0]], 
          RowBox[{"3", ",", "1", ",", "1"}], "+"]}], "+", 
        RowBox[{"5184", " ", 
         SubsuperscriptBox[
          StyleBox["\[Eta]",
           FontWeight->Bold,
           FontColor->RGBColor[0.8, 0, 0]], 
          RowBox[{"3", ",", "1", ",", "2"}], "+"]}], "-", 
        RowBox[{"864", " ", "\[ImaginaryI]", " ", 
         SubsuperscriptBox[
          StyleBox["\[Eta]",
           FontWeight->Bold,
           FontColor->RGBColor[0.8, 0, 0]], 
          RowBox[{"3", ",", "1", ",", "3"}], "+"]}], "+", 
        RowBox[{"5184", " ", 
         SubsuperscriptBox[
          StyleBox["\[Eta]",
           FontWeight->Bold,
           FontColor->RGBColor[0.8, 0, 0]], 
          RowBox[{"3", ",", "2", ",", "1"}], "+"]}], "-", 
        RowBox[{"864", " ", "\[ImaginaryI]", " ", 
         SubsuperscriptBox[
          StyleBox["\[Eta]",
           FontWeight->Bold,
           FontColor->RGBColor[0.8, 0, 0]], 
          RowBox[{"3", ",", "3", ",", "1"}], "+"]}], "+", 
        RowBox[{"5184", " ", 
         SubsuperscriptBox[
          StyleBox["\[Eta]",
           FontWeight->Bold,
           FontColor->RGBColor[0.8, 0, 0]], 
          RowBox[{"4", ",", "1", ",", "1"}], "+"]}], "-", 
        RowBox[{"2592", " ", "\[ImaginaryI]", " ", 
         SubsuperscriptBox[
          StyleBox["\[Eta]",
           FontWeight->Bold,
           FontColor->RGBColor[0.8, 0, 0]], 
          RowBox[{"5", ",", "1", ",", "1"}], "+"]}], "+", 
        RowBox[{"10368", " ", 
         SubsuperscriptBox[
          StyleBox["\[Eta]",
           FontWeight->Bold,
           FontColor->RGBColor[0.8, 0, 0]], 
          RowBox[{"3", ",", "1", ",", "1", ",", "1"}], "+"]}]}], ")"}]}]}], 
    ")"}]}]}]], "Output",
 CellChangeTimes->{3.5503799719532633`*^9, 3.56895866509755*^9}]
}, Open  ]],

Cell["\<\
leadweak[n]  trancates the whole expansion to first n nontrivial orders\
\>", "Text",
 CellChangeTimes->{{3.550380017726048*^9, 3.550380036708661*^9}, {
  3.568958674670559*^9, 3.568958679446046*^9}}],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"{", 
   RowBox[{
    SubscriptBox["q", 
     RowBox[{"1", ",", "2"}]], ",", 
    SubscriptBox["q", 
     RowBox[{"1", ",", "3"}]], ",", 
    SubscriptBox["q", 
     RowBox[{"1", ",", "4"}]], ",", 
    SubscriptBox["q", 
     RowBox[{"2", ",", "4"}]]}], "}"}], "/.", 
  RowBox[{"leadweak", "[", "1", "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  SubscriptBox["q", 
   RowBox[{"1", ",", "3"}]], "/.", 
  RowBox[{"leadweak", "[", "2", "]"}]}]}], "Input",
 CellChangeTimes->{{3.550380039224218*^9, 3.550380044214138*^9}, {
  3.550380276870343*^9, 3.550380302613535*^9}, {3.5503803474380836`*^9, 
  3.550380352730055*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   StyleBox["Q0",
    FontColor->RGBColor[{
       Rational[1, 2], 
       Rational[1, 2], 0}]], ",", 
   RowBox[{
    SuperscriptBox["g", "4"], " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       RowBox[{"-", "18"}], " ", "\[ImaginaryI]", " ", "u"}], "-", 
      RowBox[{"18", " ", 
       StyleBox["Q0",
        FontColor->RGBColor[{
           Rational[1, 2], 
           Rational[1, 2], 0}]], " ", 
       SubsuperscriptBox[
        StyleBox["\[Eta]",
         FontWeight->Bold,
         FontColor->RGBColor[0.8, 0, 0]], "2", "+"]}]}], ")"}]}], ",", 
   RowBox[{
    SuperscriptBox["g", "4"], " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"-", "3"}], "+", 
      RowBox[{"6", " ", "\[ImaginaryI]", " ", 
       StyleBox["Q0",
        FontColor->RGBColor[{
           Rational[1, 2], 
           Rational[1, 2], 0}]], " ", 
       SubsuperscriptBox[
        StyleBox["\[Eta]",
         FontWeight->Bold,
         FontColor->RGBColor[0.8, 0, 0]], "3", "+"]}]}], ")"}]}], ",", 
   RowBox[{
    SuperscriptBox["g", "4"], " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"6", " ", "\[ImaginaryI]", " ", "u"}], "+", 
      RowBox[{"6", " ", 
       StyleBox["Q0",
        FontColor->RGBColor[{
           Rational[1, 2], 
           Rational[1, 2], 0}]], " ", 
       SubsuperscriptBox[
        StyleBox["\[Eta]",
         FontWeight->Bold,
         FontColor->RGBColor[0.8, 0, 0]], "2", "+"]}], "+", 
      RowBox[{"2", " ", 
       StyleBox["Q0",
        FontColor->RGBColor[{
           Rational[1, 2], 
           Rational[1, 2], 0}]], " ", 
       SubsuperscriptBox[
        StyleBox["\[Eta]",
         FontWeight->Bold,
         FontColor->RGBColor[0.8, 0, 0]], "4", "+"]}]}], ")"}]}]}], 
  "}"}]], "Output",
 CellChangeTimes->{{3.5503802739389*^9, 3.550380353129718*^9}, 
   3.5689586819185963`*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   SuperscriptBox["g", "4"], " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{
      RowBox[{"-", "18"}], " ", "\[ImaginaryI]", " ", "u"}], "-", 
     RowBox[{"18", " ", 
      StyleBox["Q0",
       FontColor->RGBColor[{
          Rational[1, 2], 
          Rational[1, 2], 0}]], " ", 
      SubsuperscriptBox[
       StyleBox["\[Eta]",
        FontWeight->Bold,
        FontColor->RGBColor[0.8, 0, 0]], "2", "+"]}]}], ")"}]}], "+", 
  RowBox[{
   SuperscriptBox["g", "6"], " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"306", " ", "\[ImaginaryI]", " ", "u"}], "+", 
     RowBox[{"216", " ", "\[ImaginaryI]", " ", "u", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "1"]}], "+", 
     RowBox[{"216", " ", "u", " ", 
      SubsuperscriptBox[
       StyleBox["\[Eta]",
        FontWeight->Bold,
        FontColor->RGBColor[0.8, 0, 0]], "1", "+"]}], "+", 
     RowBox[{"24", " ", 
      SubsuperscriptBox[
       StyleBox["\[Eta]",
        FontWeight->Bold,
        FontColor->RGBColor[0.8, 0, 0]], "2", "+"]}], "+", 
     RowBox[{"90", " ", 
      StyleBox["Q0",
       FontColor->RGBColor[{
          Rational[1, 2], 
          Rational[1, 2], 0}]], " ", 
      SubsuperscriptBox[
       StyleBox["\[Eta]",
        FontWeight->Bold,
        FontColor->RGBColor[0.8, 0, 0]], "2", "+"]}], "+", 
     RowBox[{"216", " ", 
      StyleBox["Q0",
       FontColor->RGBColor[{
          Rational[1, 2], 
          Rational[1, 2], 0}]], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "1"], " ", 
      SubsuperscriptBox[
       StyleBox["\[Eta]",
        FontWeight->Bold,
        FontColor->RGBColor[0.8, 0, 0]], "2", "+"]}], "-", 
     RowBox[{"108", " ", "\[ImaginaryI]", " ", 
      StyleBox["Q0",
       FontColor->RGBColor[{
          Rational[1, 2], 
          Rational[1, 2], 0}]], " ", 
      SubsuperscriptBox[
       StyleBox["\[Eta]",
        FontWeight->Bold,
        FontColor->RGBColor[0.8, 0, 0]], "3", "+"]}], "-", 
     RowBox[{"36", " ", 
      StyleBox["Q0",
       FontColor->RGBColor[{
          Rational[1, 2], 
          Rational[1, 2], 0}]], " ", 
      SubsuperscriptBox[
       StyleBox["\[Eta]",
        FontWeight->Bold,
        FontColor->RGBColor[0.8, 0, 0]], "4", "+"]}], "-", 
     RowBox[{"216", " ", "\[ImaginaryI]", " ", 
      StyleBox["Q0",
       FontColor->RGBColor[{
          Rational[1, 2], 
          Rational[1, 2], 0}]], " ", 
      SubsuperscriptBox[
       StyleBox["\[Eta]",
        FontWeight->Bold,
        FontColor->RGBColor[0.8, 0, 0]], 
       RowBox[{"2", ",", "1"}], "+"]}]}], ")"}]}]}]], "Output",
 CellChangeTimes->{{3.5503802739389*^9, 3.550380353129718*^9}, 
   3.568958681977759*^9}]
}, Open  ]],

Cell[TextData[{
 "E.g. ",
 Cell[BoxData[
  FormBox[
   RowBox[{
    SubscriptBox["q", 
     RowBox[{"1", ",", "3"}]], "/.", 
    RowBox[{"nsweak", "[", "5", "]"}]}], TraditionalForm]],
  FormatType->"TraditionalForm"],
 " produces first 5 orders (for 8loop computation). "
}], "Text",
 CellChangeTimes->{{3.568958719454382*^9, 3.568958757875651*^9}}],

Cell["\<\
Now I explain how these expressions are obtained (first four orders, 5th \
order is discussed separatelly and later)\
\>", "Text",
 CellChangeTimes->{{3.5689587619952803`*^9, 3.5689587886176662`*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["Basics", "Subsubsection",
 CellChangeTimes->{{3.541066491268599*^9, 3.541066492391665*^9}}],

Cell[BoxData[{
 RowBox[{"{", 
  RowBox[{
   RowBox[{
    SubscriptBox[
     StyleBox["q",
      FontColor->RGBColor[0, 0, 0.8]], "1"], "\[Equal]", "1"}], ",", 
   RowBox[{
    SubscriptBox[
     StyleBox["q",
      FontColor->RGBColor[0, 0, 0.8]], "2"], "\[Equal]", 
    RowBox[{
     RowBox[{
      RowBox[{"-", "\[ImaginaryI]"}], " ", "u"}], "+", 
     RowBox[{"\[ScriptCapitalC]", 
      OverscriptBox["\[SmallCircle]", "^"], 
      SubscriptBox["\[Rho]", "2"]}], "-", 
     RowBox[{"\[ScriptCapitalC]", "\[SmallCircle]", 
      SubscriptBox[
       OverscriptBox[
        StyleBox["W",
         FontColor->RGBColor[0.54, 0.35, 0.15]], 
        StyleBox["^",
         FontColor->RGBColor[0.54, 0.35, 0.15]]], "pv"]}]}]}]}], " ", 
  "}"}], "\[IndentingNewLine]", 
 RowBox[{"{", 
  RowBox[{
   RowBox[{
    SubscriptBox[
     StyleBox["q",
      FontColor->RGBColor[0, 0, 0.8]], 
     RowBox[{"1", ",", "3"}]], "=", 
    RowBox[{
     OverscriptBox[
      StyleBox["Q",
       FontColor->RGBColor[0.8, 0, 0]], 
      StyleBox["~",
       FontColor->RGBColor[0.8, 0, 0]]], 
     FractionBox["D", 
      RowBox[{"1", "-", 
       SuperscriptBox["D", "2"]}]], 
     FractionBox[
      SuperscriptBox["U", "2"], 
      RowBox[{
       SuperscriptBox[
        OverscriptBox[
         StyleBox["Q",
          FontColor->RGBColor[0.8, 0, 0]], 
         StyleBox["~",
          FontColor->RGBColor[0.8, 0, 0]]], "-"], " ", 
       SuperscriptBox[
        OverscriptBox[
         StyleBox["Q",
          FontColor->RGBColor[0.8, 0, 0]], 
         StyleBox["~",
          FontColor->RGBColor[0.8, 0, 0]]], "+"]}]]}]}], ",", 
   RowBox[{
    SubscriptBox[
     StyleBox["q",
      FontColor->RGBColor[0, 0, 0.8]], 
     RowBox[{"1", ",", "4"}]], "=", 
    RowBox[{
     SubscriptBox[
      StyleBox["q",
       FontColor->RGBColor[0, 0, 0.8]], 
      RowBox[{"2", ",", "3"}]], "=", 
     RowBox[{
      OverscriptBox[
       StyleBox["Q",
        FontColor->RGBColor[0.8, 0, 0]], 
       StyleBox["~",
        FontColor->RGBColor[0.8, 0, 0]]], 
      FractionBox["D", 
       RowBox[{"1", "-", 
        SuperscriptBox["D", "2"]}]], 
      FractionBox[
       RowBox[{
        SuperscriptBox["U", "2"], 
        SubscriptBox[
         StyleBox["q",
          FontColor->RGBColor[0, 0, 0.8]], "2"]}], 
       RowBox[{
        SuperscriptBox[
         OverscriptBox[
          StyleBox["Q",
           FontColor->RGBColor[0.8, 0, 0]], 
          StyleBox["~",
           FontColor->RGBColor[0.8, 0, 0]]], "-"], " ", 
        SuperscriptBox[
         OverscriptBox[
          StyleBox["Q",
           FontColor->RGBColor[0.8, 0, 0]], 
          StyleBox["~",
           FontColor->RGBColor[0.8, 0, 0]]], "+"]}]]}]}]}], ",", 
   RowBox[{
    SubscriptBox[
     StyleBox["q",
      FontColor->RGBColor[0, 0, 0.8]], 
     RowBox[{"2", ",", "4"}]], "=", 
    RowBox[{
     OverscriptBox[
      StyleBox["Q",
       FontColor->RGBColor[0.8, 0, 0]], 
      StyleBox["~",
       FontColor->RGBColor[0.8, 0, 0]]], 
     FractionBox["D", 
      RowBox[{"1", "-", 
       SuperscriptBox["D", "2"]}]], 
     FractionBox[
      RowBox[{
       SuperscriptBox["U", "2"], 
       SubsuperscriptBox[
        StyleBox["q",
         FontColor->RGBColor[0, 0, 0.8]], "2", "2"]}], 
      RowBox[{
       SuperscriptBox[
        OverscriptBox[
         StyleBox["Q",
          FontColor->RGBColor[0.8, 0, 0]], 
         StyleBox["~",
          FontColor->RGBColor[0.8, 0, 0]]], "-"], " ", 
       SuperscriptBox[
        OverscriptBox[
         StyleBox["Q",
          FontColor->RGBColor[0.8, 0, 0]], 
         StyleBox["~",
          FontColor->RGBColor[0.8, 0, 0]]], "+"]}]]}]}]}], 
  "}"}], "\[IndentingNewLine]", 
 RowBox[{"{", 
  RowBox[{
   RowBox[{
    SubscriptBox[
     StyleBox["q",
      FontColor->RGBColor[0, 0, 0.8]], "4"], "==", 
    FractionBox[
     RowBox[{
      RowBox[{
       SubscriptBox[
        StyleBox["q",
         FontColor->RGBColor[0, 0, 0.8]], "2"], " ", 
       SubsuperscriptBox[
        StyleBox["q",
         FontColor->RGBColor[0, 0, 0.8]], 
        RowBox[{"1", ",", "4"}], "+"]}], "-", 
      SubsuperscriptBox[
       StyleBox["q",
        FontColor->RGBColor[0, 0, 0.8]], 
       RowBox[{"2", ",", "4"}], "+"]}], 
     SuperscriptBox[
      OverscriptBox[
       StyleBox["Q",
        FontColor->RGBColor[0.8, 0, 0]], 
       StyleBox["~",
        FontColor->RGBColor[0.8, 0, 0]]], "+"]]}], ",", " ", 
   RowBox[{
    SubscriptBox[
     StyleBox["q",
      FontColor->RGBColor[0, 0, 0.8]], "3"], "=", 
    FractionBox[
     RowBox[{
      RowBox[{
       SubscriptBox[
        StyleBox["q",
         FontColor->RGBColor[0, 0, 0.8]], "2"], " ", 
       SubsuperscriptBox[
        StyleBox["q",
         FontColor->RGBColor[0, 0, 0.8]], 
        RowBox[{"1", ",", "3"}], "+"]}], "-", 
      SubsuperscriptBox[
       StyleBox["q",
        FontColor->RGBColor[0, 0, 0.8]], 
       RowBox[{"1", ",", "4"}], "+"]}], 
     SuperscriptBox[
      OverscriptBox[
       StyleBox["Q",
        FontColor->RGBColor[0.8, 0, 0]], 
       StyleBox["~",
        FontColor->RGBColor[0.8, 0, 0]]], "+"]]}], ",", 
   RowBox[{
    SubscriptBox[
     StyleBox["q",
      FontColor->RGBColor[0, 0, 0.8]], 
     RowBox[{"3", ",", "4"}]], "=", 
    FractionBox[
     RowBox[{
      RowBox[{
       SubscriptBox[
        StyleBox["q",
         FontColor->RGBColor[0, 0, 0.8]], 
        RowBox[{"1", ",", "3"}]], " ", 
       SubscriptBox[
        StyleBox["q",
         FontColor->RGBColor[0, 0, 0.8]], 
        RowBox[{"2", ",", "4"}]]}], "-", 
      RowBox[{
       SubscriptBox[
        StyleBox["q",
         FontColor->RGBColor[0, 0, 0.8]], 
        RowBox[{"1", ",", "4"}]], " ", 
       SubscriptBox[
        StyleBox["q",
         FontColor->RGBColor[0, 0, 0.8]], 
        RowBox[{"2", ",", "3"}]]}]}], 
     OverscriptBox[
      StyleBox["Q",
       FontColor->RGBColor[0.8, 0, 0]], 
      StyleBox["~",
       FontColor->RGBColor[0.8, 0, 0]]]]}]}], "}"}]}], "Input",
 CellChangeTimes->{{3.53829727416853*^9, 3.538297344431334*^9}, {
   3.538297532781226*^9, 3.538297534205553*^9}, {3.538305658212562*^9, 
   3.538305658668274*^9}, {3.538305973780385*^9, 3.538305989236308*^9}, {
   3.538306028362544*^9, 3.538306029008769*^9}, 3.538306169808702*^9, {
   3.538741693486505*^9, 3.5387417093838463`*^9}, {3.538808371690981*^9, 
   3.538808377494191*^9}, {3.5388084500576315`*^9, 3.5388084642068563`*^9}, {
   3.538808548649804*^9, 3.5388086334671535`*^9}, 3.5388087245089135`*^9, {
   3.5502965056598883`*^9, 3.550296534594597*^9}, {3.5502965689596367`*^9, 
   3.550296587603911*^9}}],

Cell[TextData[{
 "We are aimimng to compute ordinary weak coupling expansion of ",
 Cell[BoxData[
  FormBox[
   SubscriptBox["q", 
    RowBox[{"i", ",", "j"}]], TraditionalForm]]],
 " up to the order which is enough to go to 7 loops. This corresponds to \
computing 4 nontrivial orders of ",
 Cell[BoxData[
  FormBox[
   SubscriptBox["q", 
    RowBox[{"i", ",", "j"}]], TraditionalForm]]],
 " ",
 Cell[BoxData[
  FormBox[
   RowBox[{"(", 
    RowBox[{
     SuperscriptBox["g", "4"], ",", 
     SuperscriptBox["g", "6"], ",", 
     SuperscriptBox["g", "8"], ",", 
     SuperscriptBox["g", "10"]}], ")"}], TraditionalForm]]],
 ". Up to this order ",
 Cell[BoxData[
  RowBox[{"\[ScriptCapitalC]", "\[SmallCircle]", 
   SubscriptBox[
    OverscriptBox[
     StyleBox["W",
      FontColor->RGBColor[0.54, 0.35, 0.15]], 
     StyleBox["^",
      FontColor->RGBColor[0.54, 0.35, 0.15]]], "pv"]}]],
  CellChangeTimes->{{3.53829727416853*^9, 3.538297344431334*^9}, {
    3.538297532781226*^9, 3.538297534205553*^9}, {3.538305658212562*^9, 
    3.538305658668274*^9}, {3.538305973780385*^9, 3.538305989236308*^9}, {
    3.538306028362544*^9, 3.538306029008769*^9}, 3.538306169808702*^9, {
    3.538741693486505*^9, 3.5387417093838463`*^9}, {3.538808371690981*^9, 
    3.538808377494191*^9}, {3.5388084500576315`*^9, 3.5388084642068563`*^9}, {
    3.538808548649804*^9, 3.5388086334671535`*^9}, 3.5388087245089135`*^9, {
    3.5502965056598883`*^9, 3.550296534594597*^9}, {3.5502965689596367`*^9, 
    3.550296587603911*^9}}],
 " never contributes, we can use asymptotic expression for ",
 Cell[BoxData[
  FormBox[
   SubscriptBox["q", "2"], TraditionalForm]]],
 " which is"
}], "Text",
 CellChangeTimes->{{3.550296598710355*^9, 3.550296680691237*^9}, {
  3.550296741335092*^9, 3.550296786013475*^9}, {3.550298541573388*^9, 
  3.550298553869502*^9}}],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  SubscriptBox[
   StyleBox["q",
    FontColor->RGBColor[0, 0, 0.8]], "2"], "/.", 
  "largevolume"}], "\[IndentingNewLine]", 
 RowBox[{
  SubscriptBox[
   StyleBox["q",
    FontColor->RGBColor[0, 0, 0.8]], "2"], "/.", "weak"}]}], "Input",
 CellChangeTimes->{{3.550296786714663*^9, 3.5502967963735943`*^9}, {
  3.550296980407188*^9, 3.5502970575816317`*^9}, {3.5502972025750933`*^9, 
  3.5502972049426737`*^9}, {3.55029761137803*^9, 3.550297615095385*^9}, {
  3.550298364835354*^9, 3.550298365815152*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"-", "\[ImaginaryI]"}], " ", 
  RowBox[{"(", 
   RowBox[{"u", "+", 
    FractionBox[
     RowBox[{"4", " ", "g"}], 
     RowBox[{
      SubscriptBox["\[Gamma]", "0"], " ", 
      StyleBox["x",
       FontColor->RGBColor[0, 0.6, 0]]}]]}], ")"}]}]], "Output",
 CellChangeTimes->{{3.5502967903433104`*^9, 3.550296796686*^9}, 
   3.550296972535075*^9, {3.550297014446332*^9, 3.550297058162253*^9}, 
   3.550297205466036*^9, {3.5502976158960733`*^9, 3.550297642443687*^9}, 
   3.550298367469329*^9, 3.552385603860944*^9, 3.552385656668167*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     RowBox[{"-", 
      FractionBox["\[ImaginaryI]", 
       RowBox[{"3", " ", "u"}]]}], "-", 
     RowBox[{"\[ImaginaryI]", " ", "u"}]}], ")"}], "+", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"-", 
       FractionBox["\[ImaginaryI]", 
        RowBox[{"3", " ", 
         SuperscriptBox["u", "3"]}]]}], "-", 
      FractionBox[
       RowBox[{"4", " ", "\[ImaginaryI]"}], 
       RowBox[{"3", " ", "u"}]]}], ")"}], " ", 
    SuperscriptBox["g", "2"]}], "+", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"-", 
       FractionBox[
        RowBox[{"2", " ", "\[ImaginaryI]"}], 
        RowBox[{"3", " ", 
         SuperscriptBox["u", "5"]}]]}], "-", 
      FractionBox[
       RowBox[{"4", " ", "\[ImaginaryI]"}], 
       RowBox[{"3", " ", 
        SuperscriptBox["u", "3"]}]], "+", 
      FractionBox[
       RowBox[{"4", " ", "\[ImaginaryI]"}], "u"]}], ")"}], " ", 
    SuperscriptBox["g", "4"]}], "+", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"-", 
       FractionBox[
        RowBox[{"\[ImaginaryI]", " ", 
         RowBox[{"(", 
          RowBox[{"5", "+", 
           RowBox[{"8", " ", 
            SuperscriptBox["u", "2"]}], "-", 
           RowBox[{"12", " ", 
            SuperscriptBox["u", "4"]}], "+", 
           RowBox[{"75", " ", 
            SuperscriptBox["u", "6"]}]}], ")"}]}], 
        RowBox[{"3", " ", 
         SuperscriptBox["u", "7"]}]]}], "-", 
      FractionBox[
       RowBox[{"8", " ", "\[ImaginaryI]", " ", 
        SubscriptBox[
         StyleBox["\[Zeta]",
          FontWeight->Bold,
          FontColor->RGBColor[0.8, 0, 0]], "3"]}], "u"]}], ")"}], " ", 
    SuperscriptBox["g", "6"]}], "+", 
   InterpretationBox[
    SuperscriptBox[
     RowBox[{"O", "[", "g", "]"}], "8"],
    SeriesData[$CellContext`g, 0, {}, 0, 8, 1],
    Editable->False]}],
  SeriesData[$CellContext`g, 0, {Complex[0, 
       Rational[-1, 3]]/$CellContext`u + Complex[0, -1] $CellContext`u, 0, 
    Complex[0, 
       Rational[-1, 3]] $CellContext`u^(-3) + Complex[0, 
       Rational[-4, 3]]/$CellContext`u, 0, Complex[0, 
       Rational[-2, 3]] $CellContext`u^(-5) + Complex[0, 
       Rational[-4, 3]] $CellContext`u^(-3) + Complex[0, 4]/$CellContext`u, 0,
     Complex[0, 
       Rational[-1, 3]] $CellContext`u^(-7) (5 + 8 $CellContext`u^2 - 
      12 $CellContext`u^4 + 75 $CellContext`u^6) + 
    Complex[0, -8] $CellContext`u^(-1) $CellContext`\[Zeta]$[3][0]}, 0, 8, 1],
  
  Editable->False]], "Output",
 CellChangeTimes->{{3.5502967903433104`*^9, 3.550296796686*^9}, 
   3.550296972535075*^9, {3.550297014446332*^9, 3.550297058162253*^9}, 
   3.550297205466036*^9, {3.5502976158960733`*^9, 3.550297642443687*^9}, 
   3.550298367469329*^9, 3.552385603860944*^9, 3.552385656675959*^9}]
}, Open  ]],

Cell["\<\
Note that in the doulbe scaling regime situation is different, but we don\
\[CloseCurlyQuote]t discuss it here.\
\>", "Text",
 CellChangeTimes->{{3.55029722806213*^9, 3.550297242418807*^9}, {
  3.5502985716258802`*^9, 3.550298572294332*^9}}],

Cell[TextData[{
 "At first 4 orders ",
 Cell[BoxData[
  FormBox[
   OverscriptBox["Q", "~"], TraditionalForm]],
  FormatType->"TraditionalForm"],
 " can be replaced by ",
 Cell[BoxData[
  FormBox["Q", TraditionalForm]],
  FormatType->"TraditionalForm"],
 " (indeed, correction starts at ",
 Cell[BoxData[
  FormBox[
   SuperscriptBox["g", "8"], TraditionalForm]],
  FormatType->"TraditionalForm"],
 "). So we get approximate expressions:"
}], "Text",
 CellChangeTimes->{{3.550297369943007*^9, 3.550297498480789*^9}, {
   3.550297719078451*^9, 3.550297720083494*^9}, {3.550298389673358*^9, 
   3.550298394973468*^9}, 3.550298577361456*^9}],

Cell[BoxData[{
 RowBox[{"{", 
  RowBox[{
   RowBox[{
    SubscriptBox[
     StyleBox["q",
      FontColor->RGBColor[0, 0, 0.8]], "1"], "\[Equal]", "1"}], ",", 
   RowBox[{
    SubscriptBox[
     StyleBox["q",
      FontColor->RGBColor[0, 0, 0.8]], "2"], "\[Equal]", 
    RowBox[{
     RowBox[{"-", "\[ImaginaryI]"}], " ", 
     RowBox[{"(", 
      RowBox[{"u", "+", 
       FractionBox[
        RowBox[{"4", " ", "g"}], 
        RowBox[{
         SubscriptBox["\[Gamma]", "0"], " ", 
         StyleBox["x",
          FontColor->RGBColor[0, 0.6, 0]]}]]}], ")"}]}], " ", "\[Equal]", 
    RowBox[{"\[ScriptCapitalO]", "[", "1", "]"}]}]}], 
  "}"}], "\[IndentingNewLine]", 
 RowBox[{"{", 
  RowBox[{
   RowBox[{
    SubscriptBox[
     StyleBox["q",
      FontColor->RGBColor[0, 0, 0.8]], 
     RowBox[{"1", ",", "3"}]], "\[Equal]", 
    RowBox[{
     StyleBox["Q",
      FontColor->RGBColor[0.8, 0, 0]], 
     FractionBox["D", 
      RowBox[{"1", "-", 
       SuperscriptBox["D", "2"]}]], 
     RowBox[{"(", 
      FractionBox[
       SuperscriptBox[
        StyleBox["U",
         FontColor->RGBColor[0, 0.6, 0]], "2"], 
       RowBox[{
        SuperscriptBox[
         StyleBox["Q",
          FontColor->RGBColor[0.8, 0, 0]], "-"], " ", 
        SuperscriptBox[
         StyleBox["Q",
          FontColor->RGBColor[0.8, 0, 0]], "+"]}]], ")"}]}], "\[Equal]", 
    RowBox[{"\[ScriptCapitalO]", "[", 
     SuperscriptBox["g", "4"], "]"}]}], ",", 
   RowBox[{
    SubscriptBox[
     StyleBox["q",
      FontColor->RGBColor[0, 0, 0.8]], 
     RowBox[{"1", ",", "4"}]], "\[Equal]", 
    SubscriptBox[
     StyleBox["q",
      FontColor->RGBColor[0, 0, 0.8]], 
     RowBox[{"2", ",", "3"}]], "\[Equal]", 
    RowBox[{
     StyleBox["Q",
      FontColor->RGBColor[0.8, 0, 0]], 
     FractionBox["D", 
      RowBox[{"1", "-", 
       SuperscriptBox["D", "2"]}]], 
     RowBox[{"(", 
      FractionBox[
       RowBox[{
        SuperscriptBox[
         StyleBox["U",
          FontColor->RGBColor[0, 0.6, 0]], "2"], 
        SubscriptBox[
         StyleBox["q",
          FontColor->RGBColor[0, 0, 0.8]], "2"]}], 
       RowBox[{
        SuperscriptBox[
         StyleBox["Q",
          FontColor->RGBColor[0.8, 0, 0]], "-"], " ", 
        SuperscriptBox[
         StyleBox["Q",
          FontColor->RGBColor[0.8, 0, 0]], "+"]}]], ")"}]}], "\[Equal]", 
    RowBox[{"\[ScriptCapitalO]", "[", 
     SuperscriptBox["g", "4"], "]"}]}], ",", 
   RowBox[{
    SubscriptBox[
     StyleBox["q",
      FontColor->RGBColor[0, 0, 0.8]], 
     RowBox[{"2", ",", "4"}]], "\[Equal]", 
    RowBox[{
     StyleBox["Q",
      FontColor->RGBColor[0.8, 0, 0]], 
     FractionBox["D", 
      RowBox[{"1", "-", 
       SuperscriptBox["D", "2"]}]], 
     RowBox[{"(", 
      FractionBox[
       RowBox[{
        SuperscriptBox[
         StyleBox["U",
          FontColor->RGBColor[0, 0.6, 0]], "2"], 
        SubsuperscriptBox[
         StyleBox["q",
          FontColor->RGBColor[0, 0, 0.8]], "2", "2"]}], 
       RowBox[{
        SuperscriptBox[
         StyleBox["Q",
          FontColor->RGBColor[0.8, 0, 0]], "-"], " ", 
        SuperscriptBox[
         StyleBox["Q",
          FontColor->RGBColor[0.8, 0, 0]], "+"]}]], ")"}]}], "\[Equal]", 
    RowBox[{"\[ScriptCapitalO]", "[", 
     SuperscriptBox["g", "4"], "]"}]}]}], "}"}], "\[IndentingNewLine]", 
 RowBox[{"{", 
  RowBox[{
   RowBox[{
    SubscriptBox[
     StyleBox["q",
      FontColor->RGBColor[0, 0, 0.8]], "4"], "\[Equal]", 
    FractionBox[
     RowBox[{
      RowBox[{
       SubscriptBox[
        StyleBox["q",
         FontColor->RGBColor[0, 0, 0.8]], "2"], " ", 
       SubsuperscriptBox[
        StyleBox["q",
         FontColor->RGBColor[0, 0, 0.8]], 
        RowBox[{"1", ",", "4"}], "+"]}], "-", 
      SubsuperscriptBox[
       StyleBox["q",
        FontColor->RGBColor[0, 0, 0.8]], 
       RowBox[{"2", ",", "4"}], "+"]}], 
     SuperscriptBox[
      StyleBox["Q",
       FontColor->RGBColor[0.8, 0, 0]], "+"]], "\[Equal]", 
    RowBox[{"\[ScriptCapitalO]", "[", 
     SuperscriptBox["g", "4"], "]"}]}], ",", " ", 
   RowBox[{
    SubscriptBox[
     StyleBox["q",
      FontColor->RGBColor[0, 0, 0.8]], "3"], "\[Equal]", 
    FractionBox[
     RowBox[{
      RowBox[{
       SubscriptBox[
        StyleBox["q",
         FontColor->RGBColor[0, 0, 0.8]], "2"], " ", 
       SubsuperscriptBox[
        StyleBox["q",
         FontColor->RGBColor[0, 0, 0.8]], 
        RowBox[{"1", ",", "3"}], "+"]}], "-", 
      SubsuperscriptBox[
       StyleBox["q",
        FontColor->RGBColor[0, 0, 0.8]], 
       RowBox[{"1", ",", "4"}], "+"]}], 
     SuperscriptBox[
      StyleBox["Q",
       FontColor->RGBColor[0.8, 0, 0]], "+"]], "\[Equal]", 
    RowBox[{"\[ScriptCapitalO]", "[", 
     SuperscriptBox["g", "4"], "]"}]}], ",", 
   RowBox[{
    SubscriptBox[
     StyleBox["q",
      FontColor->RGBColor[0, 0, 0.8]], 
     RowBox[{"3", ",", "4"}]], "\[Equal]", 
    FractionBox[
     RowBox[{
      RowBox[{
       SubscriptBox[
        StyleBox["q",
         FontColor->RGBColor[0, 0, 0.8]], 
        RowBox[{"1", ",", "3"}]], " ", 
       SubscriptBox[
        StyleBox["q",
         FontColor->RGBColor[0, 0, 0.8]], 
        RowBox[{"2", ",", "4"}]]}], "-", 
      RowBox[{
       SubscriptBox[
        StyleBox["q",
         FontColor->RGBColor[0, 0, 0.8]], 
        RowBox[{"1", ",", "4"}]], " ", 
       SubscriptBox[
        StyleBox["q",
         FontColor->RGBColor[0, 0, 0.8]], 
        RowBox[{"2", ",", "3"}]]}]}], 
     StyleBox["Q",
      FontColor->RGBColor[0.8, 0, 0]]], "\[Equal]", 
    RowBox[{"\[ScriptCapitalO]", "[", 
     SuperscriptBox["g", "8"], "]"}]}]}], "}"}]}], "Input",
 CellChangeTimes->{{3.550297510119981*^9, 3.550297606724163*^9}, {
   3.550297649865954*^9, 3.5502977087125273`*^9}, 3.550298399022648*^9}],

Cell[TextData[{
 "Infinite sums ",
 Cell[BoxData[
  RowBox[{
   StyleBox["Q",
    FontColor->RGBColor[0.8, 0, 0]], 
   FractionBox["D", 
    RowBox[{"1", "-", 
     SuperscriptBox["D", "2"]}]], 
   RowBox[{"(", 
    FractionBox[
     RowBox[{
      SubsuperscriptBox[
       StyleBox["q",
        FontColor->RGBColor[0, 0, 0.8]], "2", "\[Alpha]"], 
      SuperscriptBox[
       StyleBox["U",
        FontColor->RGBColor[0, 0.6, 0]], "2"]}], 
     RowBox[{
      SuperscriptBox[
       StyleBox["Q",
        FontColor->RGBColor[0.8, 0, 0]], "-"], " ", 
      SuperscriptBox[
       StyleBox["Q",
        FontColor->RGBColor[0.8, 0, 0]], "+"]}]], ")"}]}]],
  CellChangeTimes->{{3.550297510119981*^9, 3.550297606724163*^9}, {
   3.550297649865954*^9, 3.5502977087125273`*^9}}],
 " look like producing infinitely many poles at Bethe roots. This is however \
not true. Indeed, there are Bethe equations which are in the game. Let us  \
compute the residue of ",
 Cell[BoxData[
  RowBox[{
   FractionBox["D", 
    RowBox[{"1", "-", 
     SuperscriptBox["D", "2"]}]], 
   RowBox[{"(", 
    FractionBox[
     RowBox[{
      SubsuperscriptBox[
       StyleBox["q",
        FontColor->RGBColor[0, 0, 0.8]], "2", "\[Alpha]"], 
      SuperscriptBox[
       StyleBox["U",
        FontColor->RGBColor[0, 0.6, 0]], "2"]}], 
     RowBox[{
      SuperscriptBox[
       StyleBox["Q",
        FontColor->RGBColor[0.8, 0, 0]], "-"], " ", 
      SuperscriptBox[
       StyleBox["Q",
        FontColor->RGBColor[0.8, 0, 0]], "+"]}]], ")"}]}]],
  CellChangeTimes->{{3.550297510119981*^9, 3.550297606724163*^9}, {
   3.550297649865954*^9, 3.5502977087125273`*^9}}],
 " at position ",
 Cell[BoxData[
  FormBox[
   RowBox[{"u", "=", 
    RowBox[{
     SubscriptBox["v", "0"], "+", 
     RowBox[{"\[ImaginaryI]", " ", "r"}]}]}], TraditionalForm]]],
 ", where ",
 Cell[BoxData[
  FormBox[
   SubscriptBox["v", "0"], TraditionalForm]]],
 " is the Bethe root and r is integer. It is equal to the residue of"
}], "Text",
 CellChangeTimes->{{3.5502977221655893`*^9, 3.550297767046259*^9}, {
  3.550297951580699*^9, 3.550298035115877*^9}, {3.550298067087604*^9, 
  3.55029807710117*^9}, {3.550298595532571*^9, 3.550298618662387*^9}, {
  3.5689588442436533`*^9, 3.5689588461213083`*^9}}],

Cell[BoxData[
 RowBox[{
  FractionBox["1", 
   StyleBox["Q",
    FontColor->RGBColor[0.8, 0, 0]]], 
  RowBox[{"(", 
   RowBox[{
    FractionBox[
     RowBox[{
      SuperscriptBox[
       RowBox[{"(", 
        SubsuperscriptBox[
         OverscriptBox[
          StyleBox["q",
           FontColor->RGBColor[0, 0, 0.8]], 
          StyleBox["^",
           FontColor->RGBColor[0, 0, 0.8]]], "2", "-"], ")"}], 
       StyleBox["\[Alpha]",
        FontColor->RGBColor[{
           Rational[53, 85], 
           Rational[8, 17], 
           Rational[71, 255]}]]], 
      SuperscriptBox[
       RowBox[{"(", 
        SuperscriptBox[
         StyleBox["U",
          FontColor->RGBColor[0, 0.6, 0]], "-"], ")"}], "2"]}], 
     SuperscriptBox[
      StyleBox["Q",
       FontColor->RGBColor[0.8, 0, 0]], 
      RowBox[{"[", 
       RowBox[{"-", "2"}], "]"}]]], "+", 
    FractionBox[
     RowBox[{
      SuperscriptBox[
       RowBox[{"(", 
        SubsuperscriptBox[
         OverscriptBox[
          StyleBox["q",
           FontColor->RGBColor[0, 0, 0.8]], 
          StyleBox["^",
           FontColor->RGBColor[0, 0, 0.8]]], "2", "+"], ")"}], 
       StyleBox["\[Alpha]",
        FontColor->RGBColor[{
           Rational[53, 85], 
           Rational[8, 17], 
           Rational[71, 255]}]]], 
      SuperscriptBox[
       RowBox[{"(", 
        SuperscriptBox[
         StyleBox["U",
          FontColor->RGBColor[0, 0.6, 0]], "+"], ")"}], "2"]}], 
     RowBox[{" ", 
      SuperscriptBox[
       StyleBox["Q",
        FontColor->RGBColor[0.8, 0, 0]], 
       RowBox[{"[", 
        RowBox[{"+", "2"}], "]"}]]}]]}], ")"}]}]], "Input",
 CellChangeTimes->{{3.55029807908879*^9, 3.550298103566688*^9}, {
  3.5502981653910303`*^9, 3.550298176175655*^9}}],

Cell["\<\
at Bethe root. But the expression in brackets is zero. Indeed. Asymptotic \
Bethe equations can be rewritten (see appendix of FiNLIE paper) as\
\>", "Text",
 CellChangeTimes->{{3.550298046228664*^9, 3.550298060362297*^9}, {
  3.550298106837369*^9, 3.550298119360271*^9}, {3.550298315898882*^9, 
  3.550298324144981*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox[
      SuperscriptBox[
       StyleBox["U",
        FontColor->RGBColor[0, 0.6, 0]], "+"], 
      SuperscriptBox[
       StyleBox["U",
        FontColor->RGBColor[0, 0.6, 0]], "-"]], ")"}], "2"], 
   FractionBox[
    SuperscriptBox[
     StyleBox["Q",
      FontColor->RGBColor[0.8, 0, 0]], 
     RowBox[{"[", 
      RowBox[{"-", "2"}], "]"}]], 
    SuperscriptBox[
     StyleBox["Q",
      FontColor->RGBColor[0.8, 0, 0]], 
     RowBox[{"[", 
      RowBox[{"+", "2"}], "]"}]]]}], "\[Equal]", 
  RowBox[{"-", "1"}]}]], "Input",
 CellChangeTimes->{{3.5502981213629427`*^9, 3.55029813976912*^9}, {
  3.550298265193879*^9, 3.550298290268298*^9}}],

Cell["Whereas", "Text",
 CellChangeTimes->{{3.550298144807362*^9, 3.5502981490636*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   SubsuperscriptBox[
    OverscriptBox[
     StyleBox["q",
      FontColor->RGBColor[0, 0, 0.8]], 
     StyleBox["^",
      FontColor->RGBColor[0, 0, 0.8]]], "2", "-"], "-", 
   SubsuperscriptBox[
    OverscriptBox[
     StyleBox["q",
      FontColor->RGBColor[0, 0, 0.8]], 
     StyleBox["^",
      FontColor->RGBColor[0, 0, 0.8]]], "2", "+"]}], "\[TildeEqual]", 
  RowBox[{"-", 
   OverscriptBox[
    StyleBox["\[GothicCapitalT]",
     FontColor->RGBColor[0.54, 0.35, 0.15]], 
    StyleBox["^",
     FontColor->RGBColor[0.54, 0.35, 0.15]]]}], "\[Equal]", "0", " ", 
  RowBox[{"(*", " ", 
   RowBox[{"at", " ", "Bethe", " ", "root"}], " ", "*)"}], 
  StyleBox[" ",
   FontColor->RGBColor[0.54, 0.35, 0.15]]}]], "Input",
 CellChangeTimes->{{3.5502981594670362`*^9, 3.550298212838455*^9}, {
  3.550298330607605*^9, 3.550298331751452*^9}}],

Cell["\<\
Therefore all poles at shifted Bethe roots will cancell, and this should mean \
that we can express sums through \[Eta]-functions. Only the leading residue \
at r=0 will remain, but it is cancelled by the Q in front of infinite sum\
\>", "Text",
 CellChangeTimes->{{3.550298217070002*^9, 3.550298231635747*^9}, {
  3.5502983406027107`*^9, 3.55029835331874*^9}, {3.550298644223274*^9, 
  3.550298682017807*^9}, {3.568958869311434*^9, 3.568958869831272*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["New way of computation", "Subsubsection",
 CellChangeTimes->{{3.538828297912489*^9, 3.538828299780596*^9}, {
  3.540095540697797*^9, 3.540095541080428*^9}, {3.550375941652423*^9, 
  3.550375945666698*^9}, {3.568961327569889*^9, 3.56896133052789*^9}}],

Cell["\<\
Originally these quantities were computed using old way of computation, which \
is presented in next subsection\
\>", "Text",
 CellChangeTimes->{{3.568961351769429*^9, 3.568961374670059*^9}}],

Cell["\<\
We stick so far at first 4 nontrivial orders. Then a good approximation is:\
\>", "Text",
 CellChangeTimes->{{3.538827998378357*^9, 3.5388280488792453`*^9}, {
  3.538828081273098*^9, 3.538828082268155*^9}, {3.550298743410252*^9, 
  3.550298745450045*^9}, {3.550306132486553*^9, 3.55030614610192*^9}, {
  3.568958883206521*^9, 3.568958886270245*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{
    SubscriptBox[
     StyleBox["q",
      FontColor->RGBColor[0, 0, 0.8]], 
     RowBox[{"1", ",", "3"}]], "\[Equal]", 
    RowBox[{
     StyleBox["Q",
      FontColor->RGBColor[0.8, 0, 0]], 
     FractionBox["D", 
      RowBox[{"1", "-", 
       SuperscriptBox["D", "2"]}]], 
     RowBox[{"(", 
      FractionBox[
       SuperscriptBox[
        StyleBox["U",
         FontColor->RGBColor[0, 0.6, 0]], "2"], 
       RowBox[{
        SuperscriptBox[
         StyleBox["Q",
          FontColor->RGBColor[0.8, 0, 0]], "-"], " ", 
        SuperscriptBox[
         StyleBox["Q",
          FontColor->RGBColor[0.8, 0, 0]], "+"]}]], ")"}]}]}], ",", 
   RowBox[{
    SubscriptBox[
     StyleBox["q",
      FontColor->RGBColor[0, 0, 0.8]], 
     RowBox[{"1", ",", "4"}]], "\[Equal]", 
    RowBox[{
     StyleBox["Q",
      FontColor->RGBColor[0.8, 0, 0]], 
     FractionBox["D", 
      RowBox[{"1", "-", 
       SuperscriptBox["D", "2"]}]], 
     RowBox[{"(", 
      FractionBox[
       RowBox[{
        SuperscriptBox[
         StyleBox["U",
          FontColor->RGBColor[0, 0.6, 0]], "2"], 
        SubscriptBox[
         StyleBox["q",
          FontColor->RGBColor[0, 0, 0.8]], "2"]}], 
       RowBox[{
        SuperscriptBox[
         StyleBox["Q",
          FontColor->RGBColor[0.8, 0, 0]], "-"], " ", 
        SuperscriptBox[
         StyleBox["Q",
          FontColor->RGBColor[0.8, 0, 0]], "+"]}]], ")"}]}]}], ",", 
   RowBox[{
    SubscriptBox[
     StyleBox["q",
      FontColor->RGBColor[0, 0, 0.8]], 
     RowBox[{"2", ",", "4"}]], "\[Equal]", 
    RowBox[{
     StyleBox["Q",
      FontColor->RGBColor[0.8, 0, 0]], 
     FractionBox["D", 
      RowBox[{"1", "-", 
       SuperscriptBox["D", "2"]}]], 
     RowBox[{"(", 
      FractionBox[
       RowBox[{
        SuperscriptBox[
         StyleBox["U",
          FontColor->RGBColor[0, 0.6, 0]], "2"], 
        SubsuperscriptBox[
         StyleBox["q",
          FontColor->RGBColor[0, 0, 0.8]], "2", "2"]}], 
       RowBox[{
        SuperscriptBox[
         StyleBox["Q",
          FontColor->RGBColor[0.8, 0, 0]], "-"], " ", 
        SuperscriptBox[
         StyleBox["Q",
          FontColor->RGBColor[0.8, 0, 0]], "+"]}]], ")"}]}]}]}], 
  "}"}]], "Input",
 CellChangeTimes->{{3.541065852701613*^9, 3.541065862926146*^9}, {
   3.5410664986695833`*^9, 3.541066501787533*^9}, 3.55029874116143*^9, {
   3.5503759624881897`*^9, 3.5503759738555393`*^9}}],

Cell[TextData[{
 "We consider example of ",
 Cell[BoxData[
  FormBox[
   SubscriptBox["q", 
    RowBox[{"1", ",", "4"}]], TraditionalForm]],
  FormatType->"TraditionalForm"],
 ". You can change power to 0 for ",
 Cell[BoxData[
  FormBox[
   SubscriptBox["q", 
    RowBox[{"1", ",", "3"}]], TraditionalForm]],
  FormatType->"TraditionalForm"],
 " or to 2 for ",
 Cell[BoxData[
  FormBox[
   SubscriptBox["q", 
    RowBox[{"2", ",", "4"}]], TraditionalForm]],
  FormatType->"TraditionalForm"],
 ". Computation goes as follows. We first write everything as a sum over \
poles:"
}], "Text",
 CellChangeTimes->{{3.55030626029764*^9, 3.550306276350978*^9}, 
   3.550306701198901*^9, {3.550307073743445*^9, 3.550307075711055*^9}, {
   3.550307263498802*^9, 3.550307265599962*^9}, {3.568959934004932*^9, 
   3.568959950012257*^9}, {3.5689615144890738`*^9, 3.5689615449928837`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"tmp", "=", " ", 
   RowBox[{"Collect", "[", 
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{"Normal", "@", 
         RowBox[{"Series", "[", 
          RowBox[{
           RowBox[{
            FractionBox[
             RowBox[{
              SubsuperscriptBox["q", "2", 
               RowBox[{"(", 
                RowBox[{"power", "=", "1"}], ")"}]], 
              SuperscriptBox["U", "2"]}], 
             RowBox[{
              SuperscriptBox["Q", "-"], 
              SuperscriptBox["Q", "+"]}]], "/.", 
            RowBox[{"leadweak", "[", "4", "]"}]}], ",", 
           RowBox[{"{", 
            RowBox[{"g", ",", "0", ",", "10"}], "}"}]}], "]"}]}], "/.", 
        "subtousu"}], "//", "funapartusu"}], "//", "funreduceusu"}], ",", 
     "canlist"}], "]"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.568961547046555*^9, 3.5689615551828117`*^9}}],

Cell["\<\
Let us see what kind of poles do we get:\
\>", "Text",
 CellChangeTimes->{{3.568960127549906*^9, 3.5689601449007263`*^9}}],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"Extract", "[", 
   RowBox[{"tmp", ",", 
    RowBox[{"Position", "[", 
     RowBox[{"tmp", ",", 
      SuperscriptBox[
       RowBox[{
        RowBox[{"\[ScriptU]$", "[", "__", "]"}], "[", "_", "]"}], "_"]}], 
     "]"}]}], "]"}], "//", "Union"}], "\[IndentingNewLine]", 
 RowBox[{"Union", "[", 
  RowBox[{"%", "[", 
   RowBox[{"[", 
    RowBox[{"All", ",", "1"}], "]"}], "]"}], "]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"Exponent", "[", 
    RowBox[{"tmp", ",", "#"}], "]"}], "&"}], "/@", 
  "%"}], "\[IndentingNewLine]", 
 RowBox[{"FreeQ", "[", 
  RowBox[{"tmp", ",", "u"}], "]"}], "\[IndentingNewLine]"}], "Input",
 CellChangeTimes->{{3.568959812602632*^9, 3.568959972062235*^9}, {
  3.568960016041511*^9, 3.56896016919842*^9}, {3.5689602208220863`*^9, 
  3.568960282126176*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   FractionBox["1", 
    SuperscriptBox[
     StyleBox["\[ScriptU]",
      FontColor->RGBColor[0, 0, 0.4]], "9"]], ",", 
   FractionBox["1", 
    SuperscriptBox[
     StyleBox["\[ScriptU]",
      FontColor->RGBColor[0, 0, 0.4]], "8"]], ",", 
   FractionBox["1", 
    SuperscriptBox[
     StyleBox["\[ScriptU]",
      FontColor->RGBColor[0, 0, 0.4]], "7"]], ",", 
   FractionBox["1", 
    SuperscriptBox[
     StyleBox["\[ScriptU]",
      FontColor->RGBColor[0, 0, 0.4]], "6"]], ",", 
   FractionBox["1", 
    SuperscriptBox[
     StyleBox["\[ScriptU]",
      FontColor->RGBColor[0, 0, 0.4]], "5"]], ",", 
   FractionBox["1", 
    SuperscriptBox[
     StyleBox["\[ScriptU]",
      FontColor->RGBColor[0, 0, 0.4]], "4"]], ",", 
   FractionBox["1", 
    SuperscriptBox[
     StyleBox["\[ScriptU]",
      FontColor->RGBColor[0, 0, 0.4]], "3"]], ",", 
   FractionBox["1", 
    SuperscriptBox[
     StyleBox["\[ScriptU]",
      FontColor->RGBColor[0, 0, 0.4]], "2"]], ",", 
   FractionBox["1", 
    StyleBox["\[ScriptU]",
     FontColor->RGBColor[0, 0, 0.4]]], ",", 
   FractionBox["1", 
    SuperscriptBox[
     RowBox[{"(", 
      SubsuperscriptBox[
       StyleBox["\[ScriptU]",
        FontColor->RGBColor[0, 0, 0.4]], 
       RowBox[{"-", "v0"}], "-"], ")"}], "4"]], ",", 
   FractionBox["1", 
    SuperscriptBox[
     RowBox[{"(", 
      SubsuperscriptBox[
       StyleBox["\[ScriptU]",
        FontColor->RGBColor[0, 0, 0.4]], 
       RowBox[{"-", "v0"}], "-"], ")"}], "3"]], ",", 
   FractionBox["1", 
    SuperscriptBox[
     RowBox[{"(", 
      SubsuperscriptBox[
       StyleBox["\[ScriptU]",
        FontColor->RGBColor[0, 0, 0.4]], 
       RowBox[{"-", "v0"}], "-"], ")"}], "2"]], ",", 
   FractionBox["1", 
    SubsuperscriptBox[
     StyleBox["\[ScriptU]",
      FontColor->RGBColor[0, 0, 0.4]], 
     RowBox[{"-", "v0"}], "-"]], ",", 
   FractionBox["1", 
    SuperscriptBox[
     RowBox[{"(", 
      SubsuperscriptBox[
       StyleBox["\[ScriptU]",
        FontColor->RGBColor[0, 0, 0.4]], 
       RowBox[{"-", "v0"}], "+"], ")"}], "4"]], ",", 
   FractionBox["1", 
    SuperscriptBox[
     RowBox[{"(", 
      SubsuperscriptBox[
       StyleBox["\[ScriptU]",
        FontColor->RGBColor[0, 0, 0.4]], 
       RowBox[{"-", "v0"}], "+"], ")"}], "3"]], ",", 
   FractionBox["1", 
    SuperscriptBox[
     RowBox[{"(", 
      SubsuperscriptBox[
       StyleBox["\[ScriptU]",
        FontColor->RGBColor[0, 0, 0.4]], 
       RowBox[{"-", "v0"}], "+"], ")"}], "2"]], ",", 
   FractionBox["1", 
    SubsuperscriptBox[
     StyleBox["\[ScriptU]",
      FontColor->RGBColor[0, 0, 0.4]], 
     RowBox[{"-", "v0"}], "+"]], ",", 
   FractionBox["1", 
    SuperscriptBox[
     RowBox[{"(", 
      SubsuperscriptBox[
       StyleBox["\[ScriptU]",
        FontColor->RGBColor[0, 0, 0.4]], "v0", "-"], ")"}], "4"]], ",", 
   FractionBox["1", 
    SuperscriptBox[
     RowBox[{"(", 
      SubsuperscriptBox[
       StyleBox["\[ScriptU]",
        FontColor->RGBColor[0, 0, 0.4]], "v0", "-"], ")"}], "3"]], ",", 
   FractionBox["1", 
    SuperscriptBox[
     RowBox[{"(", 
      SubsuperscriptBox[
       StyleBox["\[ScriptU]",
        FontColor->RGBColor[0, 0, 0.4]], "v0", "-"], ")"}], "2"]], ",", 
   FractionBox["1", 
    SubsuperscriptBox[
     StyleBox["\[ScriptU]",
      FontColor->RGBColor[0, 0, 0.4]], "v0", "-"]], ",", 
   FractionBox["1", 
    SuperscriptBox[
     RowBox[{"(", 
      SubsuperscriptBox[
       StyleBox["\[ScriptU]",
        FontColor->RGBColor[0, 0, 0.4]], "v0", "+"], ")"}], "4"]], ",", 
   FractionBox["1", 
    SuperscriptBox[
     RowBox[{"(", 
      SubsuperscriptBox[
       StyleBox["\[ScriptU]",
        FontColor->RGBColor[0, 0, 0.4]], "v0", "+"], ")"}], "3"]], ",", 
   FractionBox["1", 
    SuperscriptBox[
     RowBox[{"(", 
      SubsuperscriptBox[
       StyleBox["\[ScriptU]",
        FontColor->RGBColor[0, 0, 0.4]], "v0", "+"], ")"}], "2"]], ",", 
   FractionBox["1", 
    SubsuperscriptBox[
     StyleBox["\[ScriptU]",
      FontColor->RGBColor[0, 0, 0.4]], "v0", "+"]]}], "}"}]], "Output",
 CellChangeTimes->{{3.568960036680969*^9, 3.568960045699788*^9}, {
   3.568960084473291*^9, 3.568960109074233*^9}, {3.568960140628407*^9, 
   3.568960169763238*^9}, 3.568960221262167*^9, {3.5689602555713377`*^9, 
   3.5689602825433197`*^9}, 3.568961580832384*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   StyleBox["\[ScriptU]",
    FontColor->RGBColor[0, 0, 0.4]], ",", 
   SubsuperscriptBox[
    StyleBox["\[ScriptU]",
     FontColor->RGBColor[0, 0, 0.4]], 
    RowBox[{"-", "v0"}], "-"], ",", 
   SubsuperscriptBox[
    StyleBox["\[ScriptU]",
     FontColor->RGBColor[0, 0, 0.4]], 
    RowBox[{"-", "v0"}], "+"], ",", 
   SubsuperscriptBox[
    StyleBox["\[ScriptU]",
     FontColor->RGBColor[0, 0, 0.4]], "v0", "-"], ",", 
   SubsuperscriptBox[
    StyleBox["\[ScriptU]",
     FontColor->RGBColor[0, 0, 0.4]], "v0", "+"]}], "}"}]], "Output",
 CellChangeTimes->{{3.568960036680969*^9, 3.568960045699788*^9}, {
   3.568960084473291*^9, 3.568960109074233*^9}, {3.568960140628407*^9, 
   3.568960169763238*^9}, 3.568960221262167*^9, {3.5689602555713377`*^9, 
   3.5689602825433197`*^9}, 3.568961580856573*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"0", ",", "0", ",", "0", ",", "0", ",", "0"}], "}"}]], "Output",
 CellChangeTimes->{{3.568960036680969*^9, 3.568960045699788*^9}, {
   3.568960084473291*^9, 3.568960109074233*^9}, {3.568960140628407*^9, 
   3.568960169763238*^9}, 3.568960221262167*^9, {3.5689602555713377`*^9, 
   3.5689602825433197`*^9}, 3.5689615808716917`*^9}],

Cell[BoxData["True"], "Output",
 CellChangeTimes->{{3.568960036680969*^9, 3.568960045699788*^9}, {
   3.568960084473291*^9, 3.568960109074233*^9}, {3.568960140628407*^9, 
   3.568960169763238*^9}, 3.568960221262167*^9, {3.5689602555713377`*^9, 
   3.5689602825433197`*^9}, 3.5689615808860283`*^9}]
}, Open  ]],

Cell["\<\
So we see that there is no u in the numerator, which facilitates our task.\
\>", "Text",
 CellChangeTimes->{{3.568960284967176*^9, 3.568960305998373*^9}}],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"plusguys", "=", 
   RowBox[{"Select", "[", 
    RowBox[{
     RowBox[{"tmp", "//", "Expand"}], ",", 
     RowBox[{
      RowBox[{"Not", "[", 
       RowBox[{"FreeQ", "[", 
        RowBox[{"#", ",", 
         RowBox[{
          RowBox[{"\[ScriptU]$", "[", "__", "]"}], "[", "1", "]"}]}], "]"}], 
       "]"}], "&"}]}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"minsguys", "=", 
   RowBox[{"Select", "[", 
    RowBox[{
     RowBox[{"tmp", "//", "Expand"}], ",", 
     RowBox[{
      RowBox[{"Not", "[", 
       RowBox[{"FreeQ", "[", 
        RowBox[{"#", ",", 
         RowBox[{
          RowBox[{"\[ScriptU]$", "[", "__", "]"}], "[", 
          RowBox[{"-", "1"}], "]"}]}], "]"}], "]"}], "&"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"uguys", "=", 
   RowBox[{"Select", "[", 
    RowBox[{
     RowBox[{"tmp", "//", "Expand"}], ",", 
     RowBox[{
      RowBox[{"Not", "[", 
       RowBox[{"FreeQ", "[", 
        RowBox[{"#", ",", 
         RowBox[{
          RowBox[{"\[ScriptU]$", "[", "__", "]"}], "[", "0", "]"}]}], "]"}], 
       "]"}], "&"}]}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"Collect", "[", 
  RowBox[{
   RowBox[{"plusguys", "+", "minsguys", "+", "uguys", "-", "tmp"}], ",", 
   "canlist"}], "]"}]}], "Input",
 CellChangeTimes->{{3.568960322776545*^9, 3.568960384608219*^9}, {
  3.5689604194788303`*^9, 3.5689604751489983`*^9}}],

Cell[BoxData["0"], "Output",
 CellChangeTimes->{3.568960473641087*^9, 3.568961585678665*^9}]
}, Open  ]],

Cell["Now we write:", "Text",
 CellChangeTimes->{{3.5689601485806026`*^9, 3.568960150268506*^9}, {
  3.568960309119182*^9, 3.568960315797882*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   FractionBox["D", 
    RowBox[{"1", "-", 
     SuperscriptBox["D", "2"]}]], 
   RowBox[{"(", "tmp", ")"}]}], "==", 
  RowBox[{
   FractionBox["D", 
    RowBox[{"1", "-", 
     SuperscriptBox["D", "2"]}]], 
   RowBox[{"(", 
    RowBox[{"plusguys", "+", "minsguys", "+", "uguys"}], ")"}]}], "==", 
  RowBox[{
   RowBox[{
    FractionBox["D", 
     RowBox[{"1", "-", 
      SuperscriptBox["D", "2"]}]], 
    RowBox[{"(", "uguys", ")"}]}], "+", 
   RowBox[{
    FractionBox["D", 
     RowBox[{"1", "-", 
      SuperscriptBox["D", "2"]}]], 
    RowBox[{"(", 
     RowBox[{"plusguys", "+", 
      RowBox[{
       SuperscriptBox["D", "2"], "minsguys"}]}], ")"}]}], "+", 
   RowBox[{"D", " ", "minsguys"}]}]}]], "Input",
 CellChangeTimes->{{3.568960010883831*^9, 3.5689600144077682`*^9}, {
  3.568960489033958*^9, 3.568960544450817*^9}, {3.568961021808221*^9, 
  3.568961022088146*^9}}],

Cell["\<\
Summing up plusguys and minsguys (and checking that result actually does not \
contains poles):\
\>", "Text",
 CellChangeTimes->{{3.568960868060128*^9, 3.568960899736649*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"presum", "=", 
  RowBox[{"Collect", "[", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{"Collect", "[", 
         RowBox[{
          RowBox[{
           RowBox[{
            RowBox[{
             RowBox[{
              RowBox[{"plusguys", "+", 
               RowBox[{"(", 
                RowBox[{"minsguys", "/.", 
                 RowBox[{"Shift", "[", "2", "]"}]}], ")"}]}], "//.", 
              RowBox[{"shiftm\[Eta]", "[", "4", "]"}]}], "/.", "subtousu"}], "//",
             "funapartusu"}], "//", "funreduceusu"}], ",", "canlist"}], "]"}],
         "/.", 
        RowBox[{"shiftp\[Eta]", "[", "2", "]"}]}], "/.", "subtousu"}], "//", 
      "funapartusu"}], "//", "funreduceusu"}], ",", "canlit"}], 
   "]"}]}]], "Input",
 CellChangeTimes->{{3.568960724478797*^9, 3.56896077811719*^9}, {
  3.568960821086788*^9, 3.568960858757182*^9}, {3.568960902356316*^9, 
  3.5689609113720207`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"-", 
   FractionBox[
    RowBox[{"216", " ", "\[ImaginaryI]", " ", 
     SuperscriptBox["g", "10"]}], 
    SuperscriptBox[
     RowBox[{"(", 
      SuperscriptBox[
       StyleBox["\[ScriptU]",
        FontColor->RGBColor[0, 0, 0.4]], 
       RowBox[{"[", "2", "]"}]], ")"}], "5"]]}], "+", 
  FractionBox[
   RowBox[{"648", " ", 
    SuperscriptBox["g", "10"]}], 
   SuperscriptBox[
    RowBox[{"(", 
     SuperscriptBox[
      StyleBox["\[ScriptU]",
       FontColor->RGBColor[0, 0, 0.4]], 
      RowBox[{"[", "2", "]"}]], ")"}], "4"]], "-", 
  FractionBox[
   RowBox[{"108", " ", "\[ImaginaryI]", " ", 
    SuperscriptBox["g", "8"]}], 
   SuperscriptBox[
    RowBox[{"(", 
     SuperscriptBox[
      StyleBox["\[ScriptU]",
       FontColor->RGBColor[0, 0, 0.4]], 
      RowBox[{"[", "2", "]"}]], ")"}], "3"]], "+", 
  FractionBox[
   RowBox[{"1296", " ", "\[ImaginaryI]", " ", 
    SuperscriptBox["g", "10"]}], 
   SuperscriptBox[
    RowBox[{"(", 
     SuperscriptBox[
      StyleBox["\[ScriptU]",
       FontColor->RGBColor[0, 0, 0.4]], 
      RowBox[{"[", "2", "]"}]], ")"}], "3"]], "+", 
  FractionBox[
   RowBox[{"324", " ", 
    SuperscriptBox["g", "8"]}], 
   SuperscriptBox[
    RowBox[{"(", 
     SuperscriptBox[
      StyleBox["\[ScriptU]",
       FontColor->RGBColor[0, 0, 0.4]], 
      RowBox[{"[", "2", "]"}]], ")"}], "2"]], "-", 
  FractionBox[
   RowBox[{"3240", " ", 
    SuperscriptBox["g", "10"]}], 
   SuperscriptBox[
    RowBox[{"(", 
     SuperscriptBox[
      StyleBox["\[ScriptU]",
       FontColor->RGBColor[0, 0, 0.4]], 
      RowBox[{"[", "2", "]"}]], ")"}], "2"]], "-", 
  FractionBox[
   RowBox[{"108", " ", "\[ImaginaryI]", " ", 
    SuperscriptBox["g", "6"]}], 
   SuperscriptBox[
    StyleBox["\[ScriptU]",
     FontColor->RGBColor[0, 0, 0.4]], 
    RowBox[{"[", "2", "]"}]]], "+", 
  FractionBox[
   RowBox[{"6480", " ", "\[ImaginaryI]", " ", 
    SuperscriptBox["g", "10"]}], 
   SuperscriptBox[
    StyleBox["\[ScriptU]",
     FontColor->RGBColor[0, 0, 0.4]], 
    RowBox[{"[", "2", "]"}]]], "+", 
  FractionBox[
   RowBox[{"1296", " ", "\[ImaginaryI]", " ", 
    SuperscriptBox["g", "10"], " ", 
    SubscriptBox[
     StyleBox["\[Zeta]",
      FontWeight->Bold,
      FontColor->GrayLevel[0.4]], "1"]}], 
   SuperscriptBox[
    RowBox[{"(", 
     SuperscriptBox[
      StyleBox["\[ScriptU]",
       FontColor->RGBColor[0, 0, 0.4]], 
      RowBox[{"[", "2", "]"}]], ")"}], "3"]], "-", 
  FractionBox[
   RowBox[{"3888", " ", 
    SuperscriptBox["g", "10"], " ", 
    SubscriptBox[
     StyleBox["\[Zeta]",
      FontWeight->Bold,
      FontColor->GrayLevel[0.4]], "1"]}], 
   SuperscriptBox[
    RowBox[{"(", 
     SuperscriptBox[
      StyleBox["\[ScriptU]",
       FontColor->RGBColor[0, 0, 0.4]], 
      RowBox[{"[", "2", "]"}]], ")"}], "2"]], "+", 
  FractionBox[
   RowBox[{"1296", " ", "\[ImaginaryI]", " ", 
    SuperscriptBox["g", "8"], " ", 
    SubscriptBox[
     StyleBox["\[Zeta]",
      FontWeight->Bold,
      FontColor->GrayLevel[0.4]], "1"]}], 
   SuperscriptBox[
    StyleBox["\[ScriptU]",
     FontColor->RGBColor[0, 0, 0.4]], 
    RowBox[{"[", "2", "]"}]]], "-", 
  FractionBox[
   RowBox[{"5184", " ", "\[ImaginaryI]", " ", 
    SuperscriptBox["g", "10"], " ", 
    SubscriptBox[
     StyleBox["\[Zeta]",
      FontWeight->Bold,
      FontColor->GrayLevel[0.4]], "1"]}], 
   SuperscriptBox[
    StyleBox["\[ScriptU]",
     FontColor->RGBColor[0, 0, 0.4]], 
    RowBox[{"[", "2", "]"}]]], "-", 
  FractionBox[
   RowBox[{"7776", " ", "\[ImaginaryI]", " ", 
    SuperscriptBox["g", "10"], " ", 
    SubsuperscriptBox[
     StyleBox["\[Zeta]",
      FontWeight->Bold,
      FontColor->GrayLevel[0.4]], "1", "2"]}], 
   SuperscriptBox[
    StyleBox["\[ScriptU]",
     FontColor->RGBColor[0, 0, 0.4]], 
    RowBox[{"[", "2", "]"}]]], "-", 
  FractionBox[
   RowBox[{"3888", " ", "\[ImaginaryI]", " ", 
    SuperscriptBox["g", "10"], " ", 
    SubscriptBox[
     StyleBox["\[Zeta]",
      FontWeight->Bold,
      FontColor->GrayLevel[0.4]], "3"]}], 
   SuperscriptBox[
    StyleBox["\[ScriptU]",
     FontColor->RGBColor[0, 0, 0.4]], 
    RowBox[{"[", "2", "]"}]]], "+", 
  FractionBox[
   RowBox[{"1296", " ", 
    SuperscriptBox["g", "10"], " ", 
    SubsuperscriptBox[
     StyleBox["\[Eta]",
      FontWeight->Bold,
      FontColor->RGBColor[0.8, 0, 0]], "1", 
     RowBox[{"[", "4", "]"}]]}], 
   SuperscriptBox[
    RowBox[{"(", 
     SuperscriptBox[
      StyleBox["\[ScriptU]",
       FontColor->RGBColor[0, 0, 0.4]], 
      RowBox[{"[", "2", "]"}]], ")"}], "3"]], "+", 
  FractionBox[
   RowBox[{"3888", " ", "\[ImaginaryI]", " ", 
    SuperscriptBox["g", "10"], " ", 
    SubsuperscriptBox[
     StyleBox["\[Eta]",
      FontWeight->Bold,
      FontColor->RGBColor[0.8, 0, 0]], "1", 
     RowBox[{"[", "4", "]"}]]}], 
   SuperscriptBox[
    RowBox[{"(", 
     SuperscriptBox[
      StyleBox["\[ScriptU]",
       FontColor->RGBColor[0, 0, 0.4]], 
      RowBox[{"[", "2", "]"}]], ")"}], "2"]], "+", 
  FractionBox[
   RowBox[{"1296", " ", 
    SuperscriptBox["g", "8"], " ", 
    SubsuperscriptBox[
     StyleBox["\[Eta]",
      FontWeight->Bold,
      FontColor->RGBColor[0.8, 0, 0]], "1", 
     RowBox[{"[", "4", "]"}]]}], 
   SuperscriptBox[
    StyleBox["\[ScriptU]",
     FontColor->RGBColor[0, 0, 0.4]], 
    RowBox[{"[", "2", "]"}]]], "-", 
  FractionBox[
   RowBox[{"5184", " ", 
    SuperscriptBox["g", "10"], " ", 
    SubsuperscriptBox[
     StyleBox["\[Eta]",
      FontWeight->Bold,
      FontColor->RGBColor[0.8, 0, 0]], "1", 
     RowBox[{"[", "4", "]"}]]}], 
   SuperscriptBox[
    StyleBox["\[ScriptU]",
     FontColor->RGBColor[0, 0, 0.4]], 
    RowBox[{"[", "2", "]"}]]], "-", 
  FractionBox[
   RowBox[{"15552", " ", 
    SuperscriptBox["g", "10"], " ", 
    SubscriptBox[
     StyleBox["\[Zeta]",
      FontWeight->Bold,
      FontColor->GrayLevel[0.4]], "1"], " ", 
    SubsuperscriptBox[
     StyleBox["\[Eta]",
      FontWeight->Bold,
      FontColor->RGBColor[0.8, 0, 0]], "1", 
     RowBox[{"[", "4", "]"}]]}], 
   SuperscriptBox[
    StyleBox["\[ScriptU]",
     FontColor->RGBColor[0, 0, 0.4]], 
    RowBox[{"[", "2", "]"}]]], "+", 
  FractionBox[
   RowBox[{"7776", " ", "\[ImaginaryI]", " ", 
    SuperscriptBox["g", "10"], " ", 
    SubsuperscriptBox[
     StyleBox["\[Eta]",
      FontWeight->Bold,
      FontColor->RGBColor[0.8, 0, 0]], "2", 
     RowBox[{"[", "4", "]"}]]}], 
   SuperscriptBox[
    StyleBox["\[ScriptU]",
     FontColor->RGBColor[0, 0, 0.4]], 
    RowBox[{"[", "2", "]"}]]], "+", 
  FractionBox[
   RowBox[{"1296", " ", 
    SuperscriptBox["g", "10"], " ", 
    SubsuperscriptBox[
     StyleBox["\[Eta]",
      FontWeight->Bold,
      FontColor->RGBColor[0.8, 0, 0]], "3", 
     RowBox[{"[", "4", "]"}]]}], 
   SuperscriptBox[
    StyleBox["\[ScriptU]",
     FontColor->RGBColor[0, 0, 0.4]], 
    RowBox[{"[", "2", "]"}]]], "+", 
  FractionBox[
   RowBox[{"15552", " ", "\[ImaginaryI]", " ", 
    SuperscriptBox["g", "10"], " ", 
    SubsuperscriptBox[
     StyleBox["\[Eta]",
      FontWeight->Bold,
      FontColor->RGBColor[0.8, 0, 0]], 
     RowBox[{"1", ",", "1"}], 
     RowBox[{"[", "4", "]"}]]}], 
   SuperscriptBox[
    StyleBox["\[ScriptU]",
     FontColor->RGBColor[0, 0, 0.4]], 
    RowBox[{"[", "2", "]"}]]]}]], "Output",
 CellChangeTimes->{{3.5689607531898737`*^9, 3.568960778972451*^9}, {
   3.568960826367689*^9, 3.568960846906199*^9}, {3.5689609045115356`*^9, 
   3.5689609122733717`*^9}, 3.568961589718103*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"sumplminguys", "=", 
  RowBox[{"Collect", "[", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{
          RowBox[{
           RowBox[{"presum", "/.", 
            RowBox[{"Shift", "[", 
             RowBox[{"-", "2"}], "]"}]}], "/.", 
           RowBox[{
            RowBox[{
             SuperscriptBox["\[ScriptU]", 
              RowBox[{"pow_", "/;", 
               RowBox[{"pow", "<", "0"}]}]], 
             RowBox[{
              RowBox[{"\[Eta]$", "[", "a__", "]"}], "[", "2", "]"}]}], 
            "\[RuleDelayed]", 
            RowBox[{
             RowBox[{"\[Eta]$", "[", 
              RowBox[{
               RowBox[{"-", "pow"}], ",", "a"}], "]"}], "[", "1", "]"}]}]}], "/.", 
          RowBox[{
           SuperscriptBox["\[ScriptU]", 
            RowBox[{"pow_", "/;", 
             RowBox[{"pow", "<", "0"}]}]], "\[RuleDelayed]", 
           RowBox[{
            RowBox[{"\[Eta]$", "[", 
             RowBox[{"-", "pow"}], "]"}], "[", "1", "]"}]}]}], "/.", 
         RowBox[{"Shift", "[", "2", "]"}]}], "//.", 
        RowBox[{"shiftm\[Eta]", "[", "3", "]"}]}], "/.", "subtousu"}], "//", 
      "funapartusu"}], "//", "funreduceusu"}], ",", "canlist"}], 
   "]"}]}]], "Input",
 CellChangeTimes->{{3.568960914272663*^9, 3.568960978735894*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   SuperscriptBox["g", "6"], " ", 
   RowBox[{"(", 
    RowBox[{
     FractionBox[
      RowBox[{"108", " ", "\[ImaginaryI]"}], 
      SuperscriptBox[
       StyleBox["\[ScriptU]",
        FontColor->RGBColor[0, 0, 0.4]], "+"]], "-", 
     RowBox[{"108", " ", "\[ImaginaryI]", " ", 
      SubsuperscriptBox[
       StyleBox["\[Eta]",
        FontWeight->Bold,
        FontColor->RGBColor[0.8, 0, 0]], "1", "+"]}]}], ")"}]}], "+", 
  RowBox[{
   SuperscriptBox["g", "8"], " ", 
   RowBox[{"(", 
    RowBox[{
     FractionBox[
      RowBox[{"108", " ", "\[ImaginaryI]"}], 
      SuperscriptBox[
       RowBox[{"(", 
        SuperscriptBox[
         StyleBox["\[ScriptU]",
          FontColor->RGBColor[0, 0, 0.4]], "+"], ")"}], "3"]], "+", 
     FractionBox["972", 
      SuperscriptBox[
       RowBox[{"(", 
        SuperscriptBox[
         StyleBox["\[ScriptU]",
          FontColor->RGBColor[0, 0, 0.4]], "+"], ")"}], "2"]], "-", 
     FractionBox[
      RowBox[{"1296", " ", "\[ImaginaryI]", " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "1"]}], 
      SuperscriptBox[
       StyleBox["\[ScriptU]",
        FontColor->RGBColor[0, 0, 0.4]], "+"]], "+", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", 
         FractionBox["1296", 
          SuperscriptBox[
           StyleBox["\[ScriptU]",
            FontColor->RGBColor[0, 0, 0.4]], "+"]]}], "+", 
        RowBox[{"1296", " ", "\[ImaginaryI]", " ", 
         SubscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "1"]}]}], ")"}], " ", 
      SubsuperscriptBox[
       StyleBox["\[Eta]",
        FontWeight->Bold,
        FontColor->RGBColor[0.8, 0, 0]], "1", "+"]}], "+", 
     RowBox[{"324", " ", 
      SubsuperscriptBox[
       StyleBox["\[Eta]",
        FontWeight->Bold,
        FontColor->RGBColor[0.8, 0, 0]], "2", "+"]}], "-", 
     RowBox[{"108", " ", "\[ImaginaryI]", " ", 
      SubsuperscriptBox[
       StyleBox["\[Eta]",
        FontWeight->Bold,
        FontColor->RGBColor[0.8, 0, 0]], "3", "+"]}], "+", 
     RowBox[{"1296", " ", 
      SubsuperscriptBox[
       StyleBox["\[Eta]",
        FontWeight->Bold,
        FontColor->RGBColor[0.8, 0, 0]], 
       RowBox[{"1", ",", "1"}], "+"]}]}], ")"}]}], "+", 
  RowBox[{
   SuperscriptBox["g", "10"], " ", 
   RowBox[{"(", 
    RowBox[{
     FractionBox[
      RowBox[{"216", " ", "\[ImaginaryI]"}], 
      SuperscriptBox[
       RowBox[{"(", 
        SuperscriptBox[
         StyleBox["\[ScriptU]",
          FontColor->RGBColor[0, 0, 0.4]], "+"], ")"}], "5"]], "+", 
     FractionBox["1944", 
      SuperscriptBox[
       RowBox[{"(", 
        SuperscriptBox[
         StyleBox["\[ScriptU]",
          FontColor->RGBColor[0, 0, 0.4]], "+"], ")"}], "4"]], "+", 
     FractionBox[
      RowBox[{
       RowBox[{"-", "1944"}], "-", 
       RowBox[{"11664", " ", 
        SubscriptBox[
         StyleBox["\[Zeta]",
          FontWeight->Bold,
          FontColor->GrayLevel[0.4]], "1"]}]}], 
      SuperscriptBox[
       RowBox[{"(", 
        SuperscriptBox[
         StyleBox["\[ScriptU]",
          FontColor->RGBColor[0, 0, 0.4]], "+"], ")"}], "2"]], "+", 
     FractionBox[
      RowBox[{
       RowBox[{
        RowBox[{"-", "5184"}], " ", "\[ImaginaryI]"}], "-", 
       RowBox[{"1296", " ", "\[ImaginaryI]", " ", 
        SubscriptBox[
         StyleBox["\[Zeta]",
          FontWeight->Bold,
          FontColor->GrayLevel[0.4]], "1"]}]}], 
      SuperscriptBox[
       RowBox[{"(", 
        SuperscriptBox[
         StyleBox["\[ScriptU]",
          FontColor->RGBColor[0, 0, 0.4]], "+"], ")"}], "3"]], "+", 
     FractionBox[
      RowBox[{
       RowBox[{
        RowBox[{"-", "6480"}], " ", "\[ImaginaryI]"}], "+", 
       RowBox[{"5184", " ", "\[ImaginaryI]", " ", 
        SubscriptBox[
         StyleBox["\[Zeta]",
          FontWeight->Bold,
          FontColor->GrayLevel[0.4]], "1"]}], "+", 
       RowBox[{"7776", " ", "\[ImaginaryI]", " ", 
        SubsuperscriptBox[
         StyleBox["\[Zeta]",
          FontWeight->Bold,
          FontColor->GrayLevel[0.4]], "1", "2"]}], "+", 
       RowBox[{"3888", " ", "\[ImaginaryI]", " ", 
        SubscriptBox[
         StyleBox["\[Zeta]",
          FontWeight->Bold,
          FontColor->GrayLevel[0.4]], "3"]}]}], 
      SuperscriptBox[
       StyleBox["\[ScriptU]",
        FontColor->RGBColor[0, 0, 0.4]], "+"]], "+", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"6480", " ", "\[ImaginaryI]"}], "-", 
        FractionBox["1296", 
         SuperscriptBox[
          RowBox[{"(", 
           SuperscriptBox[
            StyleBox["\[ScriptU]",
             FontColor->RGBColor[0, 0, 0.4]], "+"], ")"}], "3"]], "+", 
        FractionBox[
         RowBox[{"11664", " ", "\[ImaginaryI]"}], 
         SuperscriptBox[
          RowBox[{"(", 
           SuperscriptBox[
            StyleBox["\[ScriptU]",
             FontColor->RGBColor[0, 0, 0.4]], "+"], ")"}], "2"]], "-", 
        RowBox[{"5184", " ", "\[ImaginaryI]", " ", 
         SubscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "1"]}], "-", 
        RowBox[{"7776", " ", "\[ImaginaryI]", " ", 
         SubsuperscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "1", "2"]}], "+", 
        FractionBox[
         RowBox[{"5184", "+", 
          RowBox[{"15552", " ", 
           SubscriptBox[
            StyleBox["\[Zeta]",
             FontWeight->Bold,
             FontColor->GrayLevel[0.4]], "1"]}]}], 
         SuperscriptBox[
          StyleBox["\[ScriptU]",
           FontColor->RGBColor[0, 0, 0.4]], "+"]], "-", 
        RowBox[{"3888", " ", "\[ImaginaryI]", " ", 
         SubscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "3"]}]}], ")"}], " ", 
      SubsuperscriptBox[
       StyleBox["\[Eta]",
        FontWeight->Bold,
        FontColor->RGBColor[0.8, 0, 0]], "1", "+"]}], "+", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "3240"}], "-", 
        FractionBox[
         RowBox[{"7776", " ", "\[ImaginaryI]"}], 
         SuperscriptBox[
          StyleBox["\[ScriptU]",
           FontColor->RGBColor[0, 0, 0.4]], "+"]], "-", 
        RowBox[{"3888", " ", 
         SubscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "1"]}]}], ")"}], " ", 
      SubsuperscriptBox[
       StyleBox["\[Eta]",
        FontWeight->Bold,
        FontColor->RGBColor[0.8, 0, 0]], "2", "+"]}], "+", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"1296", " ", "\[ImaginaryI]"}], "-", 
        FractionBox["1296", 
         SuperscriptBox[
          StyleBox["\[ScriptU]",
           FontColor->RGBColor[0, 0, 0.4]], "+"]], "+", 
        RowBox[{"1296", " ", "\[ImaginaryI]", " ", 
         SubscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "1"]}]}], ")"}], " ", 
      SubsuperscriptBox[
       StyleBox["\[Eta]",
        FontWeight->Bold,
        FontColor->RGBColor[0.8, 0, 0]], "3", "+"]}], "+", 
     RowBox[{"648", " ", 
      SubsuperscriptBox[
       StyleBox["\[Eta]",
        FontWeight->Bold,
        FontColor->RGBColor[0.8, 0, 0]], "4", "+"]}], "-", 
     RowBox[{"216", " ", "\[ImaginaryI]", " ", 
      SubsuperscriptBox[
       StyleBox["\[Eta]",
        FontWeight->Bold,
        FontColor->RGBColor[0.8, 0, 0]], "5", "+"]}], "+", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "5184"}], "-", 
        FractionBox[
         RowBox[{"15552", " ", "\[ImaginaryI]"}], 
         SuperscriptBox[
          StyleBox["\[ScriptU]",
           FontColor->RGBColor[0, 0, 0.4]], "+"]], "-", 
        RowBox[{"15552", " ", 
         SubscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "1"]}]}], ")"}], " ", 
      SubsuperscriptBox[
       StyleBox["\[Eta]",
        FontWeight->Bold,
        FontColor->RGBColor[0.8, 0, 0]], 
       RowBox[{"1", ",", "1"}], "+"]}], "+", 
     RowBox[{"7776", " ", "\[ImaginaryI]", " ", 
      SubsuperscriptBox[
       StyleBox["\[Eta]",
        FontWeight->Bold,
        FontColor->RGBColor[0.8, 0, 0]], 
       RowBox[{"1", ",", "2"}], "+"]}], "+", 
     RowBox[{"1296", " ", 
      SubsuperscriptBox[
       StyleBox["\[Eta]",
        FontWeight->Bold,
        FontColor->RGBColor[0.8, 0, 0]], 
       RowBox[{"1", ",", "3"}], "+"]}], "+", 
     RowBox[{"3888", " ", "\[ImaginaryI]", " ", 
      SubsuperscriptBox[
       StyleBox["\[Eta]",
        FontWeight->Bold,
        FontColor->RGBColor[0.8, 0, 0]], 
       RowBox[{"2", ",", "1"}], "+"]}], "+", 
     RowBox[{"1296", " ", 
      SubsuperscriptBox[
       StyleBox["\[Eta]",
        FontWeight->Bold,
        FontColor->RGBColor[0.8, 0, 0]], 
       RowBox[{"3", ",", "1"}], "+"]}], "+", 
     RowBox[{"15552", " ", "\[ImaginaryI]", " ", 
      SubsuperscriptBox[
       StyleBox["\[Eta]",
        FontWeight->Bold,
        FontColor->RGBColor[0.8, 0, 0]], 
       RowBox[{"1", ",", "1", ",", "1"}], "+"]}]}], ")"}]}]}]], "Output",
 CellChangeTimes->{{3.5689609416957827`*^9, 3.568960979328245*^9}, 
   3.568961592755102*^9}]
}, Open  ]],

Cell["Summing uguys:", "Text",
 CellChangeTimes->{{3.56896071077639*^9, 3.568960712895903*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"sumuguys", "=", 
  RowBox[{"Collect", "[", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"(", 
       RowBox[{"uguys", "//", "Expand"}], ")"}], "/.", 
      RowBox[{
       RowBox[{
        SuperscriptBox["\[ScriptU]", 
         RowBox[{"pow_", "/;", 
          RowBox[{"pow", "<", "0"}]}]], 
        RowBox[{
         RowBox[{"\[Eta]$", "[", "a__", "]"}], "[", "2", "]"}]}], 
       "\[RuleDelayed]", 
       RowBox[{
        RowBox[{"\[Eta]$", "[", 
         RowBox[{
          RowBox[{"-", "pow"}], ",", "a"}], "]"}], "[", "1", "]"}]}]}], "/.", 
     
     RowBox[{
      SuperscriptBox["\[ScriptU]", 
       RowBox[{"pow_", "/;", 
        RowBox[{"pow", "<", "0"}]}]], "\[RuleDelayed]", 
      RowBox[{
       RowBox[{"\[Eta]$", "[", 
        RowBox[{"-", "pow"}], "]"}], "[", "1", "]"}]}]}], ",", "canlist"}], 
   "]"}]}]], "Input",
 CellChangeTimes->{{3.5689605514413433`*^9, 3.5689606592956247`*^9}, {
   3.568960699512059*^9, 3.5689607025606422`*^9}, 3.568960984587729*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{"6", " ", "\[ImaginaryI]", " ", 
   SuperscriptBox["g", "4"], " ", 
   SubsuperscriptBox[
    StyleBox["\[Eta]",
     FontWeight->Bold,
     FontColor->RGBColor[0.8, 0, 0]], "3", "+"]}], "+", 
  RowBox[{
   SuperscriptBox["g", "6"], " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"108", " ", "\[ImaginaryI]", " ", 
      SubsuperscriptBox[
       StyleBox["\[Eta]",
        FontWeight->Bold,
        FontColor->RGBColor[0.8, 0, 0]], "1", "+"]}], "+", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"12", " ", "\[ImaginaryI]"}], "-", 
        RowBox[{"72", " ", "\[ImaginaryI]", " ", 
         SubscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "1"]}]}], ")"}], " ", 
      SubsuperscriptBox[
       StyleBox["\[Eta]",
        FontWeight->Bold,
        FontColor->RGBColor[0.8, 0, 0]], "3", "+"]}], "-", 
     RowBox[{"36", " ", 
      SubsuperscriptBox[
       StyleBox["\[Eta]",
        FontWeight->Bold,
        FontColor->RGBColor[0.8, 0, 0]], "4", "+"]}], "+", 
     RowBox[{"18", " ", "\[ImaginaryI]", " ", 
      SubsuperscriptBox[
       StyleBox["\[Eta]",
        FontWeight->Bold,
        FontColor->RGBColor[0.8, 0, 0]], "5", "+"]}], "-", 
     RowBox[{"72", " ", 
      SubsuperscriptBox[
       StyleBox["\[Eta]",
        FontWeight->Bold,
        FontColor->RGBColor[0.8, 0, 0]], 
       RowBox[{"3", ",", "1"}], "+"]}]}], ")"}]}], "+", 
  RowBox[{
   SuperscriptBox["g", "8"], " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{
      RowBox[{"-", "1296"}], " ", "\[ImaginaryI]", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "1"], " ", 
      SubsuperscriptBox[
       StyleBox["\[Eta]",
        FontWeight->Bold,
        FontColor->RGBColor[0.8, 0, 0]], "1", "+"]}], "-", 
     RowBox[{"324", " ", 
      SubsuperscriptBox[
       StyleBox["\[Eta]",
        FontWeight->Bold,
        FontColor->RGBColor[0.8, 0, 0]], "2", "+"]}], "+", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         RowBox[{"-", "12"}], " ", "\[ImaginaryI]"}], "+", 
        RowBox[{"144", " ", "\[ImaginaryI]", " ", 
         SubscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "1"]}], "+", 
        RowBox[{"432", " ", "\[ImaginaryI]", " ", 
         SubsuperscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "1", "2"]}], "+", 
        RowBox[{"216", " ", "\[ImaginaryI]", " ", 
         SubscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "3"]}]}], ")"}], " ", 
      SubsuperscriptBox[
       StyleBox["\[Eta]",
        FontWeight->Bold,
        FontColor->RGBColor[0.8, 0, 0]], "3", "+"]}], "+", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"72", "+", 
        RowBox[{"432", " ", 
         SubscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "1"]}]}], ")"}], " ", 
      SubsuperscriptBox[
       StyleBox["\[Eta]",
        FontWeight->Bold,
        FontColor->RGBColor[0.8, 0, 0]], "4", "+"]}], "+", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         RowBox[{"-", "72"}], " ", "\[ImaginaryI]"}], "-", 
        RowBox[{"216", " ", "\[ImaginaryI]", " ", 
         SubscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "1"]}]}], ")"}], " ", 
      SubsuperscriptBox[
       StyleBox["\[Eta]",
        FontWeight->Bold,
        FontColor->RGBColor[0.8, 0, 0]], "5", "+"]}], "-", 
     RowBox[{"144", " ", 
      SubsuperscriptBox[
       StyleBox["\[Eta]",
        FontWeight->Bold,
        FontColor->RGBColor[0.8, 0, 0]], "6", "+"]}], "+", 
     RowBox[{"54", " ", "\[ImaginaryI]", " ", 
      SubsuperscriptBox[
       StyleBox["\[Eta]",
        FontWeight->Bold,
        FontColor->RGBColor[0.8, 0, 0]], "7", "+"]}], "-", 
     RowBox[{"1296", " ", 
      SubsuperscriptBox[
       StyleBox["\[Eta]",
        FontWeight->Bold,
        FontColor->RGBColor[0.8, 0, 0]], 
       RowBox[{"1", ",", "1"}], "+"]}], "+", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"144", "+", 
        RowBox[{"864", " ", 
         SubscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "1"]}]}], ")"}], " ", 
      SubsuperscriptBox[
       StyleBox["\[Eta]",
        FontWeight->Bold,
        FontColor->RGBColor[0.8, 0, 0]], 
       RowBox[{"3", ",", "1"}], "+"]}], "-", 
     RowBox[{"432", " ", "\[ImaginaryI]", " ", 
      SubsuperscriptBox[
       StyleBox["\[Eta]",
        FontWeight->Bold,
        FontColor->RGBColor[0.8, 0, 0]], 
       RowBox[{"3", ",", "2"}], "+"]}], "-", 
     RowBox[{"72", " ", 
      SubsuperscriptBox[
       StyleBox["\[Eta]",
        FontWeight->Bold,
        FontColor->RGBColor[0.8, 0, 0]], 
       RowBox[{"3", ",", "3"}], "+"]}], "-", 
     RowBox[{"432", " ", "\[ImaginaryI]", " ", 
      SubsuperscriptBox[
       StyleBox["\[Eta]",
        FontWeight->Bold,
        FontColor->RGBColor[0.8, 0, 0]], 
       RowBox[{"4", ",", "1"}], "+"]}], "-", 
     RowBox[{"216", " ", 
      SubsuperscriptBox[
       StyleBox["\[Eta]",
        FontWeight->Bold,
        FontColor->RGBColor[0.8, 0, 0]], 
       RowBox[{"5", ",", "1"}], "+"]}], "-", 
     RowBox[{"864", " ", "\[ImaginaryI]", " ", 
      SubsuperscriptBox[
       StyleBox["\[Eta]",
        FontWeight->Bold,
        FontColor->RGBColor[0.8, 0, 0]], 
       RowBox[{"3", ",", "1", ",", "1"}], "+"]}]}], ")"}]}], "+", 
  RowBox[{
   SuperscriptBox["g", "10"], " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         RowBox[{"-", "6480"}], " ", "\[ImaginaryI]"}], "+", 
        RowBox[{"5184", " ", "\[ImaginaryI]", " ", 
         SubscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "1"]}], "+", 
        RowBox[{"7776", " ", "\[ImaginaryI]", " ", 
         SubsuperscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "1", "2"]}], "+", 
        RowBox[{"3888", " ", "\[ImaginaryI]", " ", 
         SubscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "3"]}]}], ")"}], " ", 
      SubsuperscriptBox[
       StyleBox["\[Eta]",
        FontWeight->Bold,
        FontColor->RGBColor[0.8, 0, 0]], "1", "+"]}], "+", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"3240", "+", 
        RowBox[{"3888", " ", 
         SubscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "1"]}]}], ")"}], " ", 
      SubsuperscriptBox[
       StyleBox["\[Eta]",
        FontWeight->Bold,
        FontColor->RGBColor[0.8, 0, 0]], "2", "+"]}], "+", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"48", " ", "\[ImaginaryI]"}], "-", 
        RowBox[{"1296", " ", "\[ImaginaryI]", " ", 
         SubscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "1"]}], "-", 
        RowBox[{"2592", " ", "\[ImaginaryI]", " ", 
         SubsuperscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "1", "2"]}], "-", 
        RowBox[{"1728", " ", "\[ImaginaryI]", " ", 
         SubsuperscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "1", "3"]}], "-", 
        RowBox[{"576", " ", "\[ImaginaryI]", " ", 
         SubscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "3"]}], "-", 
        RowBox[{"2592", " ", "\[ImaginaryI]", " ", 
         SubscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "1"], " ", 
         SubscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "3"]}], "-", 
        RowBox[{"1440", " ", "\[ImaginaryI]", " ", 
         SubscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "5"]}]}], ")"}], " ", 
      SubsuperscriptBox[
       StyleBox["\[Eta]",
        FontWeight->Bold,
        FontColor->RGBColor[0.8, 0, 0]], "3", "+"]}], "+", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "648"}], "-", 
        RowBox[{"2592", " ", 
         SubscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "1"]}], "-", 
        RowBox[{"2592", " ", 
         SubsuperscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "1", "2"]}], "-", 
        RowBox[{"1296", " ", 
         SubscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "3"]}]}], ")"}], " ", 
      SubsuperscriptBox[
       StyleBox["\[Eta]",
        FontWeight->Bold,
        FontColor->RGBColor[0.8, 0, 0]], "4", "+"]}], "+", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"504", " ", "\[ImaginaryI]"}], "+", 
        RowBox[{"1728", " ", "\[ImaginaryI]", " ", 
         SubscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "1"]}], "+", 
        RowBox[{"1296", " ", "\[ImaginaryI]", " ", 
         SubsuperscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "1", "2"]}], "+", 
        RowBox[{"792", " ", "\[ImaginaryI]", " ", 
         SubscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "3"]}]}], ")"}], " ", 
      SubsuperscriptBox[
       StyleBox["\[Eta]",
        FontWeight->Bold,
        FontColor->RGBColor[0.8, 0, 0]], "5", "+"]}], "+", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"504", "+", 
        RowBox[{"1728", " ", 
         SubscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "1"]}]}], ")"}], " ", 
      SubsuperscriptBox[
       StyleBox["\[Eta]",
        FontWeight->Bold,
        FontColor->RGBColor[0.8, 0, 0]], "6", "+"]}], "+", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         RowBox[{"-", "432"}], " ", "\[ImaginaryI]"}], "-", 
        RowBox[{"648", " ", "\[ImaginaryI]", " ", 
         SubscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "1"]}]}], ")"}], " ", 
      SubsuperscriptBox[
       StyleBox["\[Eta]",
        FontWeight->Bold,
        FontColor->RGBColor[0.8, 0, 0]], "7", "+"]}], "-", 
     RowBox[{"504", " ", 
      SubsuperscriptBox[
       StyleBox["\[Eta]",
        FontWeight->Bold,
        FontColor->RGBColor[0.8, 0, 0]], "8", "+"]}], "+", 
     RowBox[{"168", " ", "\[ImaginaryI]", " ", 
      SubsuperscriptBox[
       StyleBox["\[Eta]",
        FontWeight->Bold,
        FontColor->RGBColor[0.8, 0, 0]], "9", "+"]}], "+", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"5184", "+", 
        RowBox[{"15552", " ", 
         SubscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "1"]}]}], ")"}], " ", 
      SubsuperscriptBox[
       StyleBox["\[Eta]",
        FontWeight->Bold,
        FontColor->RGBColor[0.8, 0, 0]], 
       RowBox[{"1", ",", "1"}], "+"]}], "-", 
     RowBox[{"7776", " ", "\[ImaginaryI]", " ", 
      SubsuperscriptBox[
       StyleBox["\[Eta]",
        FontWeight->Bold,
        FontColor->RGBColor[0.8, 0, 0]], 
       RowBox[{"1", ",", "2"}], "+"]}], "-", 
     RowBox[{"1296", " ", 
      SubsuperscriptBox[
       StyleBox["\[Eta]",
        FontWeight->Bold,
        FontColor->RGBColor[0.8, 0, 0]], 
       RowBox[{"1", ",", "3"}], "+"]}], "-", 
     RowBox[{"3888", " ", "\[ImaginaryI]", " ", 
      SubsuperscriptBox[
       StyleBox["\[Eta]",
        FontWeight->Bold,
        FontColor->RGBColor[0.8, 0, 0]], 
       RowBox[{"2", ",", "1"}], "+"]}], "+", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "1296"}], "-", 
        RowBox[{"5184", " ", 
         SubscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "1"]}], "-", 
        RowBox[{"5184", " ", 
         SubsuperscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "1", "2"]}], "-", 
        RowBox[{"2592", " ", 
         SubscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "3"]}]}], ")"}], " ", 
      SubsuperscriptBox[
       StyleBox["\[Eta]",
        FontWeight->Bold,
        FontColor->RGBColor[0.8, 0, 0]], 
       RowBox[{"3", ",", "1"}], "+"]}], "+", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"2592", " ", "\[ImaginaryI]"}], "+", 
        RowBox[{"5184", " ", "\[ImaginaryI]", " ", 
         SubscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "1"]}]}], ")"}], " ", 
      SubsuperscriptBox[
       StyleBox["\[Eta]",
        FontWeight->Bold,
        FontColor->RGBColor[0.8, 0, 0]], 
       RowBox[{"3", ",", "2"}], "+"]}], "+", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"1872", "+", 
        RowBox[{"864", " ", 
         SubscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "1"]}]}], ")"}], " ", 
      SubsuperscriptBox[
       StyleBox["\[Eta]",
        FontWeight->Bold,
        FontColor->RGBColor[0.8, 0, 0]], 
       RowBox[{"3", ",", "3"}], "+"]}], "-", 
     RowBox[{"864", " ", "\[ImaginaryI]", " ", 
      SubsuperscriptBox[
       StyleBox["\[Eta]",
        FontWeight->Bold,
        FontColor->RGBColor[0.8, 0, 0]], 
       RowBox[{"3", ",", "4"}], "+"]}], "-", 
     RowBox[{"144", " ", 
      SubsuperscriptBox[
       StyleBox["\[Eta]",
        FontWeight->Bold,
        FontColor->RGBColor[0.8, 0, 0]], 
       RowBox[{"3", ",", "5"}], "+"]}], "+", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"2592", " ", "\[ImaginaryI]"}], "+", 
        RowBox[{"5184", " ", "\[ImaginaryI]", " ", 
         SubscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "1"]}]}], ")"}], " ", 
      SubsuperscriptBox[
       StyleBox["\[Eta]",
        FontWeight->Bold,
        FontColor->RGBColor[0.8, 0, 0]], 
       RowBox[{"4", ",", "1"}], "+"]}], "+", 
     RowBox[{"2592", " ", 
      SubsuperscriptBox[
       StyleBox["\[Eta]",
        FontWeight->Bold,
        FontColor->RGBColor[0.8, 0, 0]], 
       RowBox[{"4", ",", "2"}], "+"]}], "-", 
     RowBox[{"432", " ", "\[ImaginaryI]", " ", 
      SubsuperscriptBox[
       StyleBox["\[Eta]",
        FontWeight->Bold,
        FontColor->RGBColor[0.8, 0, 0]], 
       RowBox[{"4", ",", "3"}], "+"]}], "+", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"1728", "+", 
        RowBox[{"2592", " ", 
         SubscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "1"]}]}], ")"}], " ", 
      SubsuperscriptBox[
       StyleBox["\[Eta]",
        FontWeight->Bold,
        FontColor->RGBColor[0.8, 0, 0]], 
       RowBox[{"5", ",", "1"}], "+"]}], "-", 
     RowBox[{"1296", " ", "\[ImaginaryI]", " ", 
      SubsuperscriptBox[
       StyleBox["\[Eta]",
        FontWeight->Bold,
        FontColor->RGBColor[0.8, 0, 0]], 
       RowBox[{"5", ",", "2"}], "+"]}], "-", 
     RowBox[{"216", " ", 
      SubsuperscriptBox[
       StyleBox["\[Eta]",
        FontWeight->Bold,
        FontColor->RGBColor[0.8, 0, 0]], 
       RowBox[{"5", ",", "3"}], "+"]}], "-", 
     RowBox[{"1728", " ", "\[ImaginaryI]", " ", 
      SubsuperscriptBox[
       StyleBox["\[Eta]",
        FontWeight->Bold,
        FontColor->RGBColor[0.8, 0, 0]], 
       RowBox[{"6", ",", "1"}], "+"]}], "-", 
     RowBox[{"648", " ", 
      SubsuperscriptBox[
       StyleBox["\[Eta]",
        FontWeight->Bold,
        FontColor->RGBColor[0.8, 0, 0]], 
       RowBox[{"7", ",", "1"}], "+"]}], "-", 
     RowBox[{"15552", " ", "\[ImaginaryI]", " ", 
      SubsuperscriptBox[
       StyleBox["\[Eta]",
        FontWeight->Bold,
        FontColor->RGBColor[0.8, 0, 0]], 
       RowBox[{"1", ",", "1", ",", "1"}], "+"]}], "+", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"5184", " ", "\[ImaginaryI]"}], "+", 
        RowBox[{"10368", " ", "\[ImaginaryI]", " ", 
         SubscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "1"]}]}], ")"}], " ", 
      SubsuperscriptBox[
       StyleBox["\[Eta]",
        FontWeight->Bold,
        FontColor->RGBColor[0.8, 0, 0]], 
       RowBox[{"3", ",", "1", ",", "1"}], "+"]}], "+", 
     RowBox[{"5184", " ", 
      SubsuperscriptBox[
       StyleBox["\[Eta]",
        FontWeight->Bold,
        FontColor->RGBColor[0.8, 0, 0]], 
       RowBox[{"3", ",", "1", ",", "2"}], "+"]}], "-", 
     RowBox[{"864", " ", "\[ImaginaryI]", " ", 
      SubsuperscriptBox[
       StyleBox["\[Eta]",
        FontWeight->Bold,
        FontColor->RGBColor[0.8, 0, 0]], 
       RowBox[{"3", ",", "1", ",", "3"}], "+"]}], "+", 
     RowBox[{"5184", " ", 
      SubsuperscriptBox[
       StyleBox["\[Eta]",
        FontWeight->Bold,
        FontColor->RGBColor[0.8, 0, 0]], 
       RowBox[{"3", ",", "2", ",", "1"}], "+"]}], "-", 
     RowBox[{"864", " ", "\[ImaginaryI]", " ", 
      SubsuperscriptBox[
       StyleBox["\[Eta]",
        FontWeight->Bold,
        FontColor->RGBColor[0.8, 0, 0]], 
       RowBox[{"3", ",", "3", ",", "1"}], "+"]}], "+", 
     RowBox[{"5184", " ", 
      SubsuperscriptBox[
       StyleBox["\[Eta]",
        FontWeight->Bold,
        FontColor->RGBColor[0.8, 0, 0]], 
       RowBox[{"4", ",", "1", ",", "1"}], "+"]}], "-", 
     RowBox[{"2592", " ", "\[ImaginaryI]", " ", 
      SubsuperscriptBox[
       StyleBox["\[Eta]",
        FontWeight->Bold,
        FontColor->RGBColor[0.8, 0, 0]], 
       RowBox[{"5", ",", "1", ",", "1"}], "+"]}], "+", 
     RowBox[{"10368", " ", 
      SubsuperscriptBox[
       StyleBox["\[Eta]",
        FontWeight->Bold,
        FontColor->RGBColor[0.8, 0, 0]], 
       RowBox[{"3", ",", "1", ",", "1", ",", "1"}], "+"]}]}], 
    ")"}]}]}]], "Output",
 CellChangeTimes->{3.568960985068128*^9, 3.5689615976060343`*^9}]
}, Open  ]],

Cell["All together we have", "Text",
 CellChangeTimes->{{3.568960992813005*^9, 3.568960995804946*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"answerqij", "=", 
   RowBox[{"Collect", "[", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{
        RowBox[{"Normal", "@", 
         RowBox[{"Series", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"(", 
             RowBox[{"Q", "/.", 
              RowBox[{"leadweak", "[", "4", "]"}]}], ")"}], " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"(", 
               RowBox[{
                RowBox[{
                 RowBox[{
                  RowBox[{
                   RowBox[{"minsguys", "/.", 
                    RowBox[{"Shift", "[", "1", "]"}]}], "//.", 
                   RowBox[{"shiftm\[Eta]", "[", "3", "]"}]}], "/.", 
                  "subtousu"}], "//", "funapartusu"}], "//", "funreduceusu"}],
                ")"}], "+", "sumplminguys", "+", "sumuguys"}], ")"}]}], ",", 
           RowBox[{"{", 
            RowBox[{"g", ",", "0", ",", "10"}], "}"}]}], "]"}]}], "/.", 
        "subQ0"}], "//", "funreduceusu"}], ")"}], ",", "canlist"}], "]"}]}], 
  ";"}]], "Input",
 CellChangeTimes->{{3.5689610157163563`*^9, 3.568961272516873*^9}, {
  3.568961602782008*^9, 3.568961604148234*^9}}],

Cell["\<\
Checking that we got a correct result (we check again the answer which was \
obtained by an \[OpenCurlyDoubleQuote]Old way of computation\
\[CloseCurlyDoubleQuote], which passed a numerical check)\
\>", "Text",
 CellChangeTimes->{{3.56896161716494*^9, 3.568961667978713*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Collect", "[", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       SubscriptBox["q", 
        RowBox[{"1", ",", "4"}]], "/.", 
       RowBox[{"leadweak", "[", "4", "]"}]}], ")"}], "-", "answerqij"}], "/.",
     "subQ0"}], ",", "canlist", ",", "Expand"}], "]"}]], "Input",
 CellChangeTimes->{{3.568961273820323*^9, 3.568961315452642*^9}, {
  3.568961607553361*^9, 3.56896161070866*^9}}],

Cell[BoxData["0"], "Output",
 CellChangeTimes->{{3.568961284063376*^9, 3.56896131575662*^9}, 
   3.568961611592209*^9, 3.5689616701555347`*^9}]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell["Old way of computation", "Subsubsection",
 CellChangeTimes->{{3.568960714991844*^9, 3.568960720391596*^9}, {
  3.5689613837736893`*^9, 3.5689613892134867`*^9}}],

Cell[TextData[{
 "In the old way of computation we are reluctant to replace ",
 Cell[BoxData[
  FormBox[
   RowBox[{"Q0", "\[Congruent]", 
    RowBox[{
     SuperscriptBox["u", "2"], "-", 
     RowBox[{"1", "/", "12"}]}]}], TraditionalForm]],
  FormatType->"TraditionalForm"],
 " by its explicit expression. This leads to a more compact answer, though it \
is a bit harder to implement computation on computer"
}], "Text",
 CellChangeTimes->{{3.538827998378357*^9, 3.5388280488792453`*^9}, {
  3.538828081273098*^9, 3.538828082268155*^9}, {3.550298743410252*^9, 
  3.550298745450045*^9}, {3.550306132486553*^9, 3.55030614610192*^9}, {
  3.568958883206521*^9, 3.568958886270245*^9}, {3.568961403991366*^9, 
  3.568961446979357*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{
    SubscriptBox[
     StyleBox["q",
      FontColor->RGBColor[0, 0, 0.8]], 
     RowBox[{"1", ",", "3"}]], "\[Equal]", 
    RowBox[{
     StyleBox["Q",
      FontColor->RGBColor[0.8, 0, 0]], 
     FractionBox["D", 
      RowBox[{"1", "-", 
       SuperscriptBox["D", "2"]}]], 
     RowBox[{"(", 
      FractionBox[
       SuperscriptBox[
        StyleBox["U",
         FontColor->RGBColor[0, 0.6, 0]], "2"], 
       RowBox[{
        SuperscriptBox[
         StyleBox["Q",
          FontColor->RGBColor[0.8, 0, 0]], "-"], " ", 
        SuperscriptBox[
         StyleBox["Q",
          FontColor->RGBColor[0.8, 0, 0]], "+"]}]], ")"}]}]}], ",", 
   RowBox[{
    SubscriptBox[
     StyleBox["q",
      FontColor->RGBColor[0, 0, 0.8]], 
     RowBox[{"1", ",", "4"}]], "\[Equal]", 
    RowBox[{
     StyleBox["Q",
      FontColor->RGBColor[0.8, 0, 0]], 
     FractionBox["D", 
      RowBox[{"1", "-", 
       SuperscriptBox["D", "2"]}]], 
     RowBox[{"(", 
      FractionBox[
       RowBox[{
        SuperscriptBox[
         StyleBox["U",
          FontColor->RGBColor[0, 0.6, 0]], "2"], 
        SubscriptBox[
         StyleBox["q",
          FontColor->RGBColor[0, 0, 0.8]], "2"]}], 
       RowBox[{
        SuperscriptBox[
         StyleBox["Q",
          FontColor->RGBColor[0.8, 0, 0]], "-"], " ", 
        SuperscriptBox[
         StyleBox["Q",
          FontColor->RGBColor[0.8, 0, 0]], "+"]}]], ")"}]}]}], ",", 
   RowBox[{
    SubscriptBox[
     StyleBox["q",
      FontColor->RGBColor[0, 0, 0.8]], 
     RowBox[{"2", ",", "4"}]], "\[Equal]", 
    RowBox[{
     StyleBox["Q",
      FontColor->RGBColor[0.8, 0, 0]], 
     FractionBox["D", 
      RowBox[{"1", "-", 
       SuperscriptBox["D", "2"]}]], 
     RowBox[{"(", 
      FractionBox[
       RowBox[{
        SuperscriptBox[
         StyleBox["U",
          FontColor->RGBColor[0, 0.6, 0]], "2"], 
        SubsuperscriptBox[
         StyleBox["q",
          FontColor->RGBColor[0, 0, 0.8]], "2", "2"]}], 
       RowBox[{
        SuperscriptBox[
         StyleBox["Q",
          FontColor->RGBColor[0.8, 0, 0]], "-"], " ", 
        SuperscriptBox[
         StyleBox["Q",
          FontColor->RGBColor[0.8, 0, 0]], "+"]}]], ")"}]}]}]}], 
  "}"}]], "Input",
 CellChangeTimes->{{3.541065852701613*^9, 3.541065862926146*^9}, {
   3.5410664986695833`*^9, 3.541066501787533*^9}, 3.55029874116143*^9, {
   3.5503759624881897`*^9, 3.5503759738555393`*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     SuperscriptBox[
      StyleBox["Q",
       FontColor->RGBColor[0.8, 0, 0]], "+"], "-", 
     SuperscriptBox[
      StyleBox["Q",
       FontColor->RGBColor[0.8, 0, 0]], "-"]}], ")"}], "/.", "subFunsBethe"}],
   "//", "Simplify"}]], "Input",
 CellChangeTimes->{{3.55030706494776*^9, 3.550307091952629*^9}}],

Cell[BoxData[
 RowBox[{"2", " ", "\[ImaginaryI]", " ", "u"}]], "Output",
 CellChangeTimes->{{3.550307066984329*^9, 3.550307092516028*^9}, 
   3.550307130848068*^9, 3.568958916779356*^9}]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  FractionBox["1", 
   RowBox[{"(", 
    RowBox[{
     SuperscriptBox[
      StyleBox["Q",
       FontColor->RGBColor[0.8, 0, 0]], "-"], " ", 
     SuperscriptBox[
      StyleBox["Q",
       FontColor->RGBColor[0.8, 0, 0]], "+"]}], ")"}]], "\[Equal]", 
  RowBox[{
   FractionBox["1", 
    RowBox[{"2", "\[ImaginaryI]", " ", "u"}]], 
   FractionBox[
    RowBox[{"(", 
     RowBox[{
      SuperscriptBox[
       StyleBox["Q",
        FontColor->RGBColor[0.8, 0, 0]], "+"], "-", 
      SuperscriptBox[
       StyleBox["Q",
        FontColor->RGBColor[0.8, 0, 0]], "-"]}], ")"}], 
    RowBox[{"(", 
     RowBox[{
      SuperscriptBox[
       StyleBox["Q",
        FontColor->RGBColor[0.8, 0, 0]], "-"], " ", 
      SuperscriptBox[
       StyleBox["Q",
        FontColor->RGBColor[0.8, 0, 0]], "+"]}], ")"}]]}], "\[Equal]", 
  RowBox[{
   FractionBox["1", 
    RowBox[{"2", "\[ImaginaryI]", " ", "u"}]], 
   RowBox[{"(", 
    RowBox[{
     FractionBox["1", 
      SuperscriptBox[
       StyleBox["Q",
        FontColor->RGBColor[0.8, 0, 0]], "-"]], "-", 
     FractionBox["1", 
      SuperscriptBox[
       StyleBox["Q",
        FontColor->RGBColor[0.8, 0, 0]], "+"]]}], ")"}]}]}]], "Input",
 CellChangeTimes->{{3.550307076481473*^9, 3.55030711893191*^9}}],

Cell["Therefore, for arbitrary function f:", "Text",
 CellChangeTimes->{{3.550307135478507*^9, 3.550307143100503*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   StyleBox["Q",
    FontColor->RGBColor[0.8, 0, 0]], 
   FractionBox["D", 
    RowBox[{"1", "-", 
     SuperscriptBox["D", "2"]}]], 
   FractionBox[
    StyleBox["f",
     FontColor->RGBColor[0, 0.6, 0]], 
    RowBox[{
     SuperscriptBox[
      StyleBox["Q",
       FontColor->RGBColor[0.8, 0, 0]], "-"], " ", 
     SuperscriptBox[
      StyleBox["Q",
       FontColor->RGBColor[0.8, 0, 0]], "+"]}]]}], "\[Equal]", 
  RowBox[{
   StyleBox["Q",
    FontColor->RGBColor[0.8, 0, 0]], 
   FractionBox["D", 
    RowBox[{"1", "-", 
     SuperscriptBox["D", "2"]}]], 
   RowBox[{"(", 
    RowBox[{
     FractionBox["1", 
      RowBox[{"2", "\[ImaginaryI]", " ", "u"}]], 
     RowBox[{"(", 
      RowBox[{
       FractionBox[
        StyleBox["f",
         FontColor->RGBColor[0, 0.6, 0]], 
        SuperscriptBox[
         StyleBox["Q",
          FontColor->RGBColor[0.8, 0, 0]], "-"]], "-", 
       FractionBox[
        StyleBox["f",
         FontColor->RGBColor[0, 0.6, 0]], 
        SuperscriptBox[
         StyleBox["Q",
          FontColor->RGBColor[0.8, 0, 0]], "+"]]}], ")"}]}], ")"}]}], "==", 
  RowBox[{
   FractionBox[
    StyleBox["Q",
     FontColor->RGBColor[0.8, 0, 0]], 
    RowBox[{"2", "\[ImaginaryI]"}]], 
   FractionBox["D", 
    RowBox[{"1", "-", 
     SuperscriptBox["D", "2"]}]], 
   RowBox[{"(", 
    RowBox[{
     RowBox[{
      SuperscriptBox["D", 
       RowBox[{"-", "1"}]], 
      RowBox[{"(", 
       RowBox[{
        FractionBox["1", 
         RowBox[{" ", 
          SuperscriptBox["u", "+"]}]], 
        FractionBox[
         SuperscriptBox[
          StyleBox["f",
           FontColor->RGBColor[0, 0.6, 0]], "+"], 
         StyleBox["Q",
          FontColor->RGBColor[0.8, 0, 0]]]}], ")"}]}], "-", 
     RowBox[{
      SuperscriptBox["D", 
       RowBox[{"+", "1"}]], 
      RowBox[{"(", 
       RowBox[{
        FractionBox["1", 
         SuperscriptBox["u", "-"]], 
        FractionBox[
         SuperscriptBox[
          StyleBox["f",
           FontColor->RGBColor[0, 0.6, 0]], "-"], 
         StyleBox["Q",
          FontColor->RGBColor[0.8, 0, 0]]]}], ")"}]}]}], ")"}]}], "\[Equal]", 
  
  RowBox[{
   RowBox[{
    FractionBox["1", 
     RowBox[{"2", "\[ImaginaryI]"}]], 
    FractionBox[
     SuperscriptBox[
      StyleBox["f",
       FontColor->RGBColor[0, 0.6, 0]], "+"], 
     SuperscriptBox["u", "+"]]}], "+", 
   RowBox[{
    FractionBox["1", 
     RowBox[{"2", "\[ImaginaryI]"}]], 
    FractionBox[
     SuperscriptBox["D", "2"], 
     RowBox[{"1", "-", 
      SuperscriptBox["D", "2"]}]], 
    RowBox[{"(", 
     FractionBox["1", 
      StyleBox["Q",
       FontColor->RGBColor[0.8, 0, 0]]], ")"}], 
    RowBox[{"(", 
     RowBox[{
      FractionBox[
       SuperscriptBox[
        StyleBox["f",
         FontColor->RGBColor[0, 0.6, 0]], "+"], 
       SuperscriptBox["u", "+"]], "-", 
      FractionBox[
       SuperscriptBox[
        StyleBox["f",
         FontColor->RGBColor[0, 0.6, 0]], "-"], 
       SuperscriptBox["u", "-"]]}], ")"}]}]}]}]], "Input",
 CellChangeTimes->{{3.5503071449228354`*^9, 3.550307330548102*^9}}],

Cell[TextData[{
 "Because of the properties of ",
 Cell[BoxData[
  FormBox["U", TraditionalForm]]],
 " and ",
 Cell[BoxData[
  FormBox[
   SubscriptBox["q", "2"], TraditionalForm]]],
 " one should see an explicit cancellation of Bethe poles by ",
 Cell[BoxData[
  RowBox[{"(", 
   RowBox[{
    FractionBox[
     SuperscriptBox[
      StyleBox["f",
       FontColor->RGBColor[0, 0.6, 0]], "+"], 
     SuperscriptBox["u", "+"]], "-", 
    FractionBox[
     SuperscriptBox[
      StyleBox["f",
       FontColor->RGBColor[0, 0.6, 0]], "-"], 
     SuperscriptBox["u", "-"]]}], ")"}]],
  CellChangeTimes->{{3.5503071449228354`*^9, 3.550307330548102*^9}}],
 "."
}], "Text",
 CellChangeTimes->{{3.55030737242132*^9, 3.550307401860591*^9}}],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"tabletotreat", "=", 
   RowBox[{"Outer", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         RowBox[{"SeriesCoefficient", "[", 
          RowBox[{
           RowBox[{
            RowBox[{
             RowBox[{
              RowBox[{
               RowBox[{
                RowBox[{"(", 
                 RowBox[{
                  FractionBox["1", 
                   StyleBox["Q",
                    FontColor->RGBColor[0.8, 0, 0]]], "/.", "subFunsBethe"}], 
                 ")"}], 
                RowBox[{"(", 
                 RowBox[{
                  FractionBox[
                   SuperscriptBox[
                    StyleBox["f",
                    FontColor->RGBColor[0, 0.6, 0]], "+"], 
                   RowBox[{"u", "+", 
                    FractionBox["\[ImaginaryI]", "2"]}]], "-", 
                  FractionBox[
                   SuperscriptBox[
                    StyleBox["f",
                    FontColor->RGBColor[0, 0.6, 0]], "-"], 
                   RowBox[{"u", "-", 
                    FractionBox["\[ImaginaryI]", "2"]}]]}], ")"}]}], "/.", 
               RowBox[{
                RowBox[{"f", "[", 
                 RowBox[{"r_:", "0"}], "]"}], "\[RuleDelayed]", 
                RowBox[{"#1", "[", "r", "]"}]}]}], "/.", "weak"}], "/.", 
             RowBox[{
              SubsuperscriptBox["\[Eta]", "a_", 
               RowBox[{"[", 
                RowBox[{"r_:", "0"}], "]"}]], "\[RuleDelayed]", " ", 
              SubsuperscriptBox["\[Eta]", "a", 
               RowBox[{"[", "r", "]"}]]}]}], "//.", 
            RowBox[{"shiftm\[Eta]", "[", "3", "]"}]}], ",", 
           RowBox[{"{", 
            RowBox[{"g", ",", "0", ",", "#2"}], "}"}]}], "]"}], "//", 
         "Simplify"}], "//", "Together"}], ")"}], "&"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{
        SuperscriptBox[
         RowBox[{"U", "[", "#", "]"}], "2"], "&"}], ",", 
       RowBox[{
        RowBox[{
         SuperscriptBox[
          RowBox[{"U", "[", "#", "]"}], "2"], 
         RowBox[{
          RowBox[{"q$", "[", "2", "]"}], "[", "#", "]"}]}], "&"}], ",", 
       RowBox[{
        RowBox[{
         SuperscriptBox[
          RowBox[{"U", "[", "#", "]"}], "2"], 
         SuperscriptBox[
          RowBox[{
           RowBox[{"q$", "[", "2", "]"}], "[", "#", "]"}], "2"]}], "&"}]}], 
      "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"4", ",", "6", ",", "8", ",", "10"}], "}"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"(", 
    RowBox[{"Union", "[", 
     RowBox[{"Solve", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"Denominator", "[", "#", "]"}], "\[Equal]", "0"}], ",", "u"}],
       "]"}], "]"}], ")"}], "&"}], "/@", 
  RowBox[{"Flatten", "[", "tabletotreat", "]"}]}]}], "Input",
 CellChangeTimes->{{3.55030742919766*^9, 3.550307596127508*^9}, {
   3.550307685439869*^9, 3.550307934864231*^9}, {3.550308058763762*^9, 
   3.550308063781489*^9}, {3.55030847245899*^9, 3.550308504648348*^9}, {
   3.5503121145571623`*^9, 3.550312153907226*^9}, {3.550312370424494*^9, 
   3.550312444705388*^9}, {3.550312474750684*^9, 3.550312514473501*^9}, {
   3.550312569879507*^9, 3.550312686193735*^9}, {3.5503152664671307`*^9, 
   3.550315359023197*^9}, {3.550316496582418*^9, 3.5503165583490667`*^9}, {
   3.5503760043334217`*^9, 3.55037600672971*^9}, {3.5523097827328157`*^9, 
   3.552309787538781*^9}, {3.552309855988133*^9, 3.552309874500188*^9}, {
   3.552309928549618*^9, 3.55230992884313*^9}, {3.552310043063645*^9, 
   3.55231006295242*^9}, 3.5523857177459908`*^9, {3.552385759259763*^9, 
   3.55238579299575*^9}, {3.55238583836093*^9, 3.5523858522685738`*^9}, {
   3.552385993380123*^9, 3.5523860033568077`*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"u", "\[Rule]", 
       RowBox[{"-", 
        FractionBox["\[ImaginaryI]", "2"]}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"u", "\[Rule]", 
       FractionBox["\[ImaginaryI]", "2"]}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"u", "\[Rule]", 
       RowBox[{"-", 
        FractionBox["\[ImaginaryI]", "2"]}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"u", "\[Rule]", 
       FractionBox["\[ImaginaryI]", "2"]}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"u", "\[Rule]", 
       RowBox[{"-", 
        FractionBox["\[ImaginaryI]", "2"]}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"u", "\[Rule]", 
       FractionBox["\[ImaginaryI]", "2"]}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"u", "\[Rule]", 
       RowBox[{"-", 
        FractionBox["\[ImaginaryI]", "2"]}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"u", "\[Rule]", 
       FractionBox["\[ImaginaryI]", "2"]}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"u", "\[Rule]", 
       RowBox[{"-", 
        FractionBox["\[ImaginaryI]", "2"]}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"u", "\[Rule]", 
       FractionBox["\[ImaginaryI]", "2"]}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"u", "\[Rule]", 
       RowBox[{"-", 
        FractionBox["\[ImaginaryI]", "2"]}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"u", "\[Rule]", 
       FractionBox["\[ImaginaryI]", "2"]}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"u", "\[Rule]", 
       RowBox[{"-", 
        FractionBox["\[ImaginaryI]", "2"]}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"u", "\[Rule]", 
       FractionBox["\[ImaginaryI]", "2"]}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"u", "\[Rule]", 
       RowBox[{"-", 
        FractionBox["\[ImaginaryI]", "2"]}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"u", "\[Rule]", 
       FractionBox["\[ImaginaryI]", "2"]}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"u", "\[Rule]", 
       RowBox[{"-", 
        FractionBox["\[ImaginaryI]", "2"]}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"u", "\[Rule]", 
       FractionBox["\[ImaginaryI]", "2"]}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"u", "\[Rule]", 
       RowBox[{"-", 
        FractionBox["\[ImaginaryI]", "2"]}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"u", "\[Rule]", 
       FractionBox["\[ImaginaryI]", "2"]}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"u", "\[Rule]", 
       RowBox[{"-", 
        FractionBox["\[ImaginaryI]", "2"]}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"u", "\[Rule]", 
       FractionBox["\[ImaginaryI]", "2"]}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"u", "\[Rule]", 
       RowBox[{"-", 
        FractionBox["\[ImaginaryI]", "2"]}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"u", "\[Rule]", 
       FractionBox["\[ImaginaryI]", "2"]}], "}"}]}], "}"}]}], "}"}]], "Output",\

 CellChangeTimes->{{3.550307493417688*^9, 3.550307569384076*^9}, {
   3.550307719145339*^9, 3.550307800687111*^9}, {3.550307856507833*^9, 
   3.550307936150477*^9}, 3.550308066199572*^9, 3.550308101395371*^9, {
   3.550308482482085*^9, 3.550308505316502*^9}, {3.550312139456561*^9, 
   3.550312155115778*^9}, {3.550312374049284*^9, 3.5503123903764143`*^9}, {
   3.550312560093699*^9, 3.550312563303988*^9}, {3.550312622972575*^9, 
   3.550312629400259*^9}, {3.550312659952496*^9, 3.5503126909537277`*^9}, 
   3.550314597350628*^9, 3.550315280286056*^9, {3.5503153337259703`*^9, 
   3.550315363494643*^9}, {3.550316552605815*^9, 3.5503165599572287`*^9}, 
   3.550316860909903*^9, 3.550317245716626*^9, 3.5523097958725157`*^9, 
   3.552309876166119*^9, 3.552309929331518*^9, 3.5523100644837*^9, 
   3.552385726913845*^9, {3.552385767135297*^9, 3.552385786931122*^9}, {
   3.5523858172778*^9, 3.552385853875331*^9}, {3.552385986887998*^9, 
   3.5523860046350117`*^9}, 3.568958964084745*^9, 3.568959641810665*^9}]
}, Open  ]],

Cell["\<\
So we see that none denominator is zero at Bethe root, which confirms that \
Bethe poles are explicitly cancelled out.\
\>", "Text",
 CellChangeTimes->{{3.550307952556967*^9, 3.5503079905873203`*^9}, 
   3.550308509838958*^9}],

Cell["\<\
After cancellation of Bethe poles we have expressions of type\
\>", "Text",
 CellChangeTimes->{{3.550307998346661*^9, 3.5503080097060137`*^9}}],

Cell[BoxData[
 RowBox[{
  FractionBox["1", 
   RowBox[{"2", "\[ImaginaryI]"}]], 
  FractionBox[
   SuperscriptBox["D", "2"], 
   RowBox[{"1", "-", 
    SuperscriptBox["D", "2"]}]], 
  RowBox[{"(", 
   FractionBox[
    StyleBox["h",
     FontColor->RGBColor[0, 0.6, 0]], 
    SuperscriptBox[
     RowBox[{"(", 
      RowBox[{
       SuperscriptBox["u", "+"], 
       SuperscriptBox["u", "-"]}], ")"}], "\[Alpha]"]], ")"}]}]], "Input",
 CellChangeTimes->{{3.550308019704843*^9, 3.550308033230813*^9}, 
   3.550316055695421*^9}],

Cell[TextData[{
 "We have to reshift ",
 Cell[BoxData[
  RowBox[{
   SuperscriptBox["u", "+"], 
   SuperscriptBox["u", "-"]}]],
  CellChangeTimes->{{3.550308019704843*^9, 3.550308033230813*^9}, 
    3.550316055695421*^9}],
 " to u position to be able perform sum uniformely in terms of \
\[Eta]-functions."
}], "Text",
 CellChangeTimes->{{3.550308046114584*^9, 3.550308047152533*^9}, {
  3.550308123355019*^9, 3.550308127301259*^9}, {3.550376018200151*^9, 
  3.5503760423744173`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   FractionBox["1", 
    RowBox[{"2", "\[ImaginaryI]"}]], 
   FractionBox[
    SuperscriptBox["D", "2"], 
    RowBox[{"1", "-", 
     SuperscriptBox["D", "2"]}]], 
   RowBox[{"(", 
    FractionBox[
     StyleBox["h",
      FontColor->RGBColor[0, 0.6, 0]], 
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{
        SuperscriptBox["u", "+"], 
        SuperscriptBox["u", "-"]}], ")"}], "\[Alpha]"]], ")"}]}], "==", 
  RowBox[{
   FractionBox["1", 
    RowBox[{"2", "\[ImaginaryI]"}]], 
   FractionBox[
    SuperscriptBox["D", "2"], 
    RowBox[{"1", "-", 
     SuperscriptBox["D", "2"]}]], 
   RowBox[{"(", 
    RowBox[{
     RowBox[{
      SubscriptBox["\[Sum]", "k"], 
      FractionBox[
       StyleBox["h",
        FontColor->RGBColor[0, 0.6, 0]], 
       SuperscriptBox[
        RowBox[{"(", 
         SuperscriptBox["u", "+"], ")"}], "k"]]}], "+", 
     RowBox[{
      SubscriptBox["\[Sum]", "k"], 
      FractionBox[
       StyleBox["h",
        FontColor->RGBColor[0, 0.6, 0]], 
       SuperscriptBox[
        RowBox[{"(", 
         SuperscriptBox["u", "-"], ")"}], "k"]]}]}], ")"}]}], "==", 
  RowBox[{
   FractionBox["1", 
    RowBox[{"2", "\[ImaginaryI]"}]], 
   FractionBox[
    SuperscriptBox["D", "2"], 
    RowBox[{"1", "-", 
     SuperscriptBox["D", "2"]}]], 
   RowBox[{"(", 
    RowBox[{
     RowBox[{
      SuperscriptBox["D", 
       RowBox[{"+", "1"}]], 
      RowBox[{
       SubscriptBox["\[Sum]", "k"], 
       FractionBox[
        SuperscriptBox[
         StyleBox["h",
          FontColor->RGBColor[0, 0.6, 0]], "-"], 
        SuperscriptBox[
         RowBox[{"(", "u", ")"}], "k"]]}]}], "+", 
     RowBox[{
      SuperscriptBox["D", 
       RowBox[{"-", "1"}]], 
      RowBox[{
       SubscriptBox["\[Sum]", "k"], 
       FractionBox[
        SuperscriptBox[
         StyleBox["h",
          FontColor->RGBColor[0, 0.6, 0]], "+"], 
        SuperscriptBox[
         RowBox[{"(", "u", ")"}], "k"]]}]}]}], ")"}]}], "\[Equal]", 
  "\[IndentingNewLine]", "\[Equal]", 
  RowBox[{
   RowBox[{
    FractionBox["1", 
     RowBox[{"2", "\[ImaginaryI]"}]], 
    FractionBox["D", 
     RowBox[{"1", "-", 
      SuperscriptBox["D", "2"]}]], 
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       SubscriptBox["\[Sum]", "k"], 
       FractionBox[
        SuperscriptBox[
         StyleBox["h",
          FontColor->RGBColor[0, 0.6, 0]], "-"], 
        SuperscriptBox[
         RowBox[{"(", "u", ")"}], "k"]]}], "+", 
      RowBox[{
       SubscriptBox["\[Sum]", "k"], 
       FractionBox[
        SuperscriptBox[
         StyleBox["h",
          FontColor->RGBColor[0, 0.6, 0]], "+"], 
        SuperscriptBox[
         RowBox[{"(", "u", ")"}], "k"]]}]}], ")"}]}], "-", 
   RowBox[{
    FractionBox["1", 
     RowBox[{"2", "\[ImaginaryI]"}]], "D", 
    RowBox[{
     SubscriptBox["\[Sum]", "k"], 
     FractionBox[
      SuperscriptBox[
       StyleBox["h",
        FontColor->RGBColor[0, 0.6, 0]], "-"], 
      SuperscriptBox[
       RowBox[{"(", "u", ")"}], "k"]]}]}]}]}]], "Input",
 CellChangeTimes->{{3.5503082070545177`*^9, 3.550308221693385*^9}, {
  3.5503083470011797`*^9, 3.550308432954335*^9}, {3.550315977388772*^9, 
  3.550315978715809*^9}, {3.550316059619368*^9, 3.550316075137278*^9}}],

Cell[TextData[{
 "This decomposition will unveil divergent series. There will be terms with  \
\[Eta]  multiplied by nonegative powers of u. These cases are sumed back into \
original expression ",
 Cell[BoxData[
  RowBox[{
   FractionBox["1", 
    RowBox[{"2", "\[ImaginaryI]"}]], 
   FractionBox[
    SuperscriptBox["D", "2"], 
    RowBox[{"1", "-", 
     SuperscriptBox["D", "2"]}]], 
   RowBox[{"(", 
    FractionBox[
     StyleBox["f",
      FontColor->RGBColor[0, 0.6, 0]], 
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{
        SuperscriptBox["u", "+"], 
        SuperscriptBox["u", "-"]}], ")"}], "\[Alpha]"]], ")"}]}]],
  CellChangeTimes->{{3.5503082070545177`*^9, 3.550308221693385*^9}, {
   3.5503083470011797`*^9, 3.550308432954335*^9}}],
 ". They should completelly cancell out since original expression is totaly \
convergent."
}], "Text",
 CellChangeTimes->{{3.550314702239614*^9, 3.550314755580093*^9}, {
  3.5503157146957703`*^9, 3.550315757692371*^9}}],

Cell["We hence get", "Text",
 CellChangeTimes->{{3.5503158573858337`*^9, 3.5503158591039667`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   FractionBox["1", 
    RowBox[{"2", "\[ImaginaryI]"}]], 
   FractionBox["D", 
    RowBox[{"1", "-", 
     SuperscriptBox["D", "2"]}]], 
   RowBox[{"(", 
    RowBox[{
     RowBox[{
      SubscriptBox["\[Sum]", "k"], 
      FractionBox[
       SuperscriptBox[
        StyleBox["h",
         FontColor->RGBColor[0, 0.6, 0]], "-"], 
       SuperscriptBox[
        RowBox[{"(", "u", ")"}], "k"]]}], "+", 
     RowBox[{
      SubscriptBox["\[Sum]", "k"], 
      FractionBox[
       SuperscriptBox[
        StyleBox["h",
         FontColor->RGBColor[0, 0.6, 0]], "+"], 
       SuperscriptBox[
        RowBox[{"(", "u", ")"}], "k"]]}]}], ")"}]}], "\[Equal]", 
  RowBox[{
   RowBox[{
    FractionBox["1", 
     RowBox[{"2", "\[ImaginaryI]"}]], 
    FractionBox["D", 
     RowBox[{"1", "-", 
      SuperscriptBox["D", "2"]}]], 
    RowBox[{"(", 
     RowBox[{
      SubscriptBox[
       RowBox[{"(", 
        RowBox[{
         SubscriptBox["\[Sum]", "k"], 
         FractionBox[
          SuperscriptBox[
           StyleBox["h",
            FontColor->RGBColor[0, 0.6, 0]], "-"], 
          SuperscriptBox[
           RowBox[{"(", "u", ")"}], "k"]]}], ")"}], "reg"], "+", 
      SubscriptBox[
       RowBox[{"(", 
        RowBox[{
         SubscriptBox["\[Sum]", "k"], 
         FractionBox[
          SuperscriptBox[
           StyleBox["h",
            FontColor->RGBColor[0, 0.6, 0]], "+"], 
          SuperscriptBox[
           RowBox[{"(", "u", ")"}], "k"]]}], ")"}], "reg"]}], ")"}]}], "+", 
   RowBox[{
    FractionBox["1", 
     RowBox[{"2", "\[ImaginaryI]"}]], 
    FractionBox[
     SuperscriptBox["D", "2"], 
     RowBox[{"1", "-", 
      SuperscriptBox["D", "2"]}]], 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         SuperscriptBox["D", 
          RowBox[{"+", "1"}]], 
         SubscriptBox[
          RowBox[{"(", 
           RowBox[{
            SubscriptBox["\[Sum]", "k"], 
            FractionBox[
             SuperscriptBox[
              StyleBox["h",
               FontColor->RGBColor[0, 0.6, 0]], "-"], 
             SuperscriptBox[
              RowBox[{"(", "u", ")"}], "k"]]}], ")"}], "sing"]}], "+", 
        RowBox[{
         SuperscriptBox["D", 
          RowBox[{"-", "1"}]], 
         SubscriptBox[
          RowBox[{"(", 
           RowBox[{
            SubscriptBox["\[Sum]", "k"], 
            FractionBox[
             SuperscriptBox[
              StyleBox["h",
               FontColor->RGBColor[0, 0.6, 0]], "+"], 
             SuperscriptBox[
              RowBox[{"(", "u", ")"}], "k"]]}], ")"}], "sing"]}]}], ")"}], 
      "\[Equal]", "0"}], ")"}]}], "+", 
   RowBox[{
    FractionBox["1", 
     RowBox[{"2", "\[ImaginaryI]"}]], "D", 
    RowBox[{
     SubscriptBox["\[Sum]", "k"], 
     SubscriptBox[
      RowBox[{"(", 
       FractionBox[
        StyleBox["h",
         FontColor->RGBColor[0, 0.6, 0]], 
        SuperscriptBox[
         RowBox[{"(", 
          SuperscriptBox["u", "+"], ")"}], "k"]], ")"}], 
      "sing"]}]}]}]}]], "Input",
 CellChangeTimes->{{3.550315860732667*^9, 3.550315958442051*^9}, 
   3.550315995750918*^9, {3.5503160783731422`*^9, 3.550316093751183*^9}}],

Cell["Hence finally we will get", "Text",
 CellChangeTimes->{{3.550315999412133*^9, 3.550316003114616*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   StyleBox["Q",
    FontColor->RGBColor[0.8, 0, 0]], 
   FractionBox["D", 
    RowBox[{"1", "-", 
     SuperscriptBox["D", "2"]}]], 
   FractionBox[
    StyleBox["f",
     FontColor->RGBColor[0, 0.6, 0]], 
    RowBox[{
     SuperscriptBox[
      StyleBox["Q",
       FontColor->RGBColor[0.8, 0, 0]], "-"], " ", 
     SuperscriptBox[
      StyleBox["Q",
       FontColor->RGBColor[0.8, 0, 0]], "+"]}]]}], "\[Equal]", 
  RowBox[{
   RowBox[{
    FractionBox["1", 
     RowBox[{"2", "\[ImaginaryI]"}]], 
    FractionBox[
     SuperscriptBox[
      StyleBox["f",
       FontColor->RGBColor[0, 0.6, 0]], "+"], 
     SuperscriptBox["u", "+"]]}], "+", 
   RowBox[{
    FractionBox[
     StyleBox["Q",
      FontColor->RGBColor[0.8, 0, 0]], 
     RowBox[{"2", "\[ImaginaryI]"}]], 
    FractionBox["D", 
     RowBox[{"1", "-", 
      SuperscriptBox["D", "2"]}]], 
    RowBox[{"(", 
     RowBox[{
      SubscriptBox[
       RowBox[{"(", 
        RowBox[{
         SubscriptBox["\[Sum]", "k"], 
         FractionBox[
          SuperscriptBox[
           StyleBox["h",
            FontColor->RGBColor[0, 0.6, 0]], "-"], 
          SuperscriptBox[
           RowBox[{"(", "u", ")"}], "k"]]}], ")"}], "reg"], "+", 
      SubscriptBox[
       RowBox[{"(", 
        RowBox[{
         SubscriptBox["\[Sum]", "k"], 
         FractionBox[
          SuperscriptBox[
           StyleBox["h",
            FontColor->RGBColor[0, 0.6, 0]], "+"], 
          SuperscriptBox[
           RowBox[{"(", "u", ")"}], "k"]]}], ")"}], "reg"]}], ")"}]}], "-", 
   RowBox[{
    FractionBox[
     StyleBox["Q",
      FontColor->RGBColor[0.8, 0, 0]], 
     RowBox[{"2", "\[ImaginaryI]"}]], "D", 
    SubscriptBox[
     RowBox[{"(", 
      RowBox[{
       SubscriptBox["\[Sum]", "k"], 
       FractionBox[
        SuperscriptBox[
         StyleBox["h",
          FontColor->RGBColor[0, 0.6, 0]], "-"], 
        SuperscriptBox[
         RowBox[{"(", "u", ")"}], "k"]]}], ")"}], "reg"]}]}]}]], "Input",
 CellChangeTimes->{{3.550316007767362*^9, 3.550316018519801*^9}, {
  3.550316096565843*^9, 3.5503161457614117`*^9}, {3.550317021922608*^9, 
  3.5503170292986*^9}}],

Cell["Now we implement:", "Text",
 CellChangeTimes->{{3.550316157405182*^9, 3.550316161372053*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"computing", " ", 
    FractionBox[
     SuperscriptBox[
      StyleBox["f",
       FontColor->RGBColor[0, 0.6, 0]], "+"], 
     SuperscriptBox["u", "+"]]}], " ", "*)"}], " ", 
  RowBox[{
   RowBox[{"inhomopiece", "=", 
    RowBox[{"Outer", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          RowBox[{"SeriesCoefficient", "[", 
           RowBox[{
            RowBox[{
             RowBox[{
              RowBox[{
               RowBox[{"(", 
                FractionBox[
                 SuperscriptBox[
                  StyleBox["f",
                   FontColor->RGBColor[0, 0.6, 0]], "+"], 
                 RowBox[{"u", "+", 
                  FractionBox["\[ImaginaryI]", "2"]}]], ")"}], "/.", 
               RowBox[{
                RowBox[{"f", "[", 
                 RowBox[{"r_:", "0"}], "]"}], "\[RuleDelayed]", 
                RowBox[{"#1", "[", "r", "]"}]}]}], "/.", "weak"}], "//.", 
             RowBox[{
              SubsuperscriptBox["\[Eta]", "a__", 
               RowBox[{"[", "1", "]"}]], "\[RuleDelayed]", 
              RowBox[{
               RowBox[{"+", 
                RowBox[{"If", "[", 
                 RowBox[{
                  RowBox[{
                   RowBox[{"Length", "[", 
                    RowBox[{"{", "a", "}"}], "]"}], "\[NotEqual]", "1"}], ",", 
                  RowBox[{
                   FractionBox["1", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{"u", "+", 
                    FractionBox["\[ImaginaryI]", "2"]}], ")"}], 
                    RowBox[{
                    RowBox[{"{", "a", "}"}], "[", 
                    RowBox[{"[", "1", "]"}], "]"}]]], 
                   RowBox[{
                    RowBox[{
                    RowBox[{"\[Eta]$", "[", "a", "]"}], "[", 
                    RowBox[{"[", 
                    RowBox[{"2", ";;", 
                    RowBox[{"-", "1"}]}], "]"}], "]"}], "[", "3", "]"}]}], 
                  ",", 
                  FractionBox["1", 
                   SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{"u", "+", 
                    FractionBox["\[ImaginaryI]", "2"]}], ")"}], 
                    RowBox[{
                    RowBox[{"{", "a", "}"}], "[", 
                    RowBox[{"[", "1", "]"}], "]"}]]]}], "]"}]}], " ", "+", 
               " ", 
               SubsuperscriptBox["\[Eta]", "a", 
                RowBox[{"[", "3", "]"}]]}]}]}], ",", 
            RowBox[{"{", 
             RowBox[{"g", ",", "0", ",", "#2"}], "}"}]}], "]"}], "//", 
          "Simplify"}], "//", "Together"}], ")"}], "&"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{
         SuperscriptBox[
          RowBox[{"U", "[", "#", "]"}], "2"], "&"}], ",", 
        RowBox[{
         RowBox[{
          SuperscriptBox[
           RowBox[{"U", "[", "#", "]"}], "2"], 
          RowBox[{
           RowBox[{"q$", "[", "2", "]"}], "[", "#", "]"}]}], "&"}], ",", 
        RowBox[{
         RowBox[{
          SuperscriptBox[
           RowBox[{"U", "[", "#", "]"}], "2"], 
          SuperscriptBox[
           RowBox[{
            RowBox[{"q$", "[", "2", "]"}], "[", "#", "]"}], "2"]}], "&"}]}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"4", ",", "6", ",", "8", ",", "10"}], "}"}]}], "]"}]}], 
   ";"}]}]], "Input",
 CellChangeTimes->{{3.550316622768485*^9, 3.550316631302866*^9}, {
   3.550316795402804*^9, 3.550316800992051*^9}, 3.550316852869334*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{
    RowBox[{"computing", " ", "everything", " ", "else"}], ",", " ", 
    RowBox[{
    "except", " ", "exterior", " ", "multiplication", " ", "by", " ", "Q"}]}],
    " ", "*)"}], " ", "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{"preanswer", "=", 
    RowBox[{"Table", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"tmp", "=", 
        RowBox[{"tabletotreat", "[", 
         RowBox[{"[", 
          RowBox[{"i", ",", "j"}], "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"den", "=", 
        RowBox[{"Denominator", "[", "tmp", "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"num", "=", 
        RowBox[{"Numerator", "[", "tmp", "]"}]}], ";", "\[IndentingNewLine]", 
       
       RowBox[{"expr1", "=", 
        RowBox[{
         RowBox[{
          RowBox[{
           RowBox[{"num", 
            RowBox[{"(", 
             RowBox[{"Normal", "@", 
              RowBox[{"Series", "[", 
               RowBox[{
                FractionBox["1", "den"], ",", 
                RowBox[{"{", 
                 RowBox[{"u", ",", 
                  FractionBox[
                   RowBox[{"-", "\[ImaginaryI]"}], "2"], ",", 
                  RowBox[{"-", "1"}]}], "}"}]}], "]"}]}], ")"}]}], "/.", 
           RowBox[{"Shift", "[", 
            RowBox[{"-", "1"}], "]"}]}], "/.", 
          RowBox[{"u", "\[Rule]", 
           RowBox[{"u", "-", 
            FractionBox["\[ImaginaryI]", "2"]}]}]}], "//", "Expand"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"expr1sing", "=", 
        RowBox[{"Total", "@", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"Total", "@", 
            RowBox[{"Cases", "[", 
             RowBox[{"expr1", ",", 
              RowBox[{"Times", "[", 
               RowBox[{"_", ",", 
                RowBox[{
                 SuperscriptBox["u", 
                  RowBox[{"a_", "/;", 
                   RowBox[{"a", ">", "0"}]}]], "|", "u"}]}], "]"}]}], "]"}]}],
            ",", 
           RowBox[{"Total", "@", 
            RowBox[{"Cases", "[", 
             RowBox[{"expr1", ",", 
              RowBox[{"a_", "/;", 
               RowBox[{"FreeQ", "[", 
                RowBox[{"a", ",", "u"}], "]"}]}]}], "]"}]}]}], "}"}]}]}], ";",
        "\[IndentingNewLine]", 
       RowBox[{"expr1reg", "=", 
        RowBox[{
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{"expr1", "-", "expr1sing"}], "//", "Expand"}], ")"}], "/.", 
          RowBox[{
           SubscriptBox["\[Eta]", "a__"], "\[RuleDelayed]", 
           RowBox[{
            RowBox[{"If", "[", 
             RowBox[{
              RowBox[{
               RowBox[{"Length", "[", 
                RowBox[{"{", "a", "}"}], "]"}], "\[NotEqual]", "1"}], ",", 
              RowBox[{
               FractionBox["1", 
                SuperscriptBox[
                 RowBox[{"(", "u", ")"}], 
                 RowBox[{
                  RowBox[{"{", "a", "}"}], "[", 
                  RowBox[{"[", "1", "]"}], "]"}]]], 
               RowBox[{
                RowBox[{
                 RowBox[{"\[Eta]$", "[", "a", "]"}], "[", 
                 RowBox[{"[", 
                  RowBox[{"2", ";;", 
                   RowBox[{"-", "1"}]}], "]"}], "]"}], "[", "2", "]"}]}], ",", 
              FractionBox["1", 
               SuperscriptBox[
                RowBox[{"(", "u", ")"}], 
                RowBox[{
                 RowBox[{"{", "a", "}"}], "[", 
                 RowBox[{"[", "1", "]"}], "]"}]]]}], "]"}], " ", "+", " ", 
            SubsuperscriptBox["\[Eta]", "a", 
             RowBox[{"[", "2", "]"}]]}]}]}], "//", "Expand"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"expr2", "=", 
        RowBox[{
         RowBox[{
          RowBox[{
           RowBox[{"num", 
            RowBox[{"(", 
             RowBox[{"Normal", "@", 
              RowBox[{"Series", "[", 
               RowBox[{
                FractionBox["1", "den"], ",", 
                RowBox[{"{", 
                 RowBox[{"u", ",", 
                  FractionBox[
                   RowBox[{"+", "\[ImaginaryI]"}], "2"], ",", 
                  RowBox[{"-", "1"}]}], "}"}]}], "]"}]}], ")"}]}], "/.", 
           RowBox[{"Shift", "[", 
            RowBox[{"+", "1"}], "]"}]}], "/.", 
          RowBox[{"u", "\[Rule]", 
           RowBox[{"u", "+", 
            FractionBox["\[ImaginaryI]", "2"]}]}]}], "//", "Expand"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"expr2sing", "=", 
        RowBox[{"Total", "@", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"Total", "@", 
            RowBox[{"Cases", "[", 
             RowBox[{"expr2", ",", 
              RowBox[{"Times", "[", 
               RowBox[{"_", ",", 
                RowBox[{
                 SuperscriptBox["u", 
                  RowBox[{"a_", "/;", 
                   RowBox[{"a", ">", "0"}]}]], "|", "u"}]}], "]"}]}], "]"}]}],
            ",", 
           RowBox[{"Total", "@", 
            RowBox[{"Cases", "[", 
             RowBox[{"expr2", ",", 
              RowBox[{"a_", "/;", 
               RowBox[{"FreeQ", "[", 
                RowBox[{"a", ",", "u"}], "]"}]}]}], "]"}]}]}], "}"}]}]}], ";",
        "\[IndentingNewLine]", 
       RowBox[{"expr2reg", "=", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"expr2", "-", "expr2sing"}], "//", "Expand"}], ")"}]}], ";",
        "\[IndentingNewLine]", 
       RowBox[{"If", "[", 
        RowBox[{
         RowBox[{"Not", "[", 
          RowBox[{
           RowBox[{"(", 
            RowBox[{
             RowBox[{
              RowBox[{"(", 
               RowBox[{
                RowBox[{"expr1sing", "/.", 
                 RowBox[{"Shift", "[", "1", "]"}]}], "/.", 
                RowBox[{"u", "\[Rule]", 
                 RowBox[{"u", "+", 
                  FractionBox["\[ImaginaryI]", "2"]}]}]}], ")"}], "+", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"expr2sing", "/.", 
                 RowBox[{"Shift", "[", 
                  RowBox[{"-", "1"}], "]"}]}], "/.", 
                RowBox[{"u", "\[Rule]", 
                 RowBox[{"u", "-", 
                  FractionBox["\[ImaginaryI]", "2"]}]}]}], ")"}]}], "//", 
             "Expand"}], ")"}], "===", "0"}], "]"}], ",", 
         RowBox[{
         "Print", "[", "\"\<Probelm! Singular part does not vanish!\>\"", 
          "]"}]}], "]"}], ";", "\[IndentingNewLine]", 
       RowBox[{"Collect", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{"expr1reg", "+", "expr2reg"}], "//", "Expand"}], ")"}], 
            "/.", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{
               RowBox[{
                SuperscriptBox["u", "a_"], 
                SubsuperscriptBox["\[Eta]", "b__", 
                 RowBox[{"[", "2", "]"}]]}], "\[RuleDelayed]", 
               SubsuperscriptBox["\[Eta]", 
                RowBox[{
                 RowBox[{"-", "a"}], ",", "b"}], "+"]}], ",", 
              RowBox[{
               SuperscriptBox["u", "a_"], "\[RuleDelayed]", 
               SubsuperscriptBox["\[Eta]", 
                RowBox[{"-", "a"}], "+"]}]}], "}"}]}], ")"}], "-", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"expr1reg", "/.", 
             RowBox[{"Shift", "[", "1", "]"}]}], "/.", 
            RowBox[{"u", "\[Rule]", 
             RowBox[{"u", "+", 
              FractionBox["\[ImaginaryI]", "2"]}]}]}], ")"}]}], ",", 
         RowBox[{
          RowBox[{"\[Eta]$", "[", "__", "]"}], "[", "_", "]"}], ",", 
         RowBox[{
          RowBox[{"Simplify", "[", "#", "]"}], "&"}]}], "]"}]}], ",", 
      RowBox[{"{", 
       RowBox[{"i", ",", "3"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"j", ",", "1", ",", "4"}], "}"}]}], "]"}]}], ";"}]}]], "Input",\

 CellChangeTimes->{{3.5503147635051727`*^9, 3.550314854691408*^9}, {
   3.55031490207445*^9, 3.550315236841127*^9}, {3.550315429906447*^9, 
   3.55031558579065*^9}, {3.55031563002847*^9, 3.550315634566988*^9}, {
   3.5503156746906223`*^9, 3.550315682946775*^9}, {3.5503158064723186`*^9, 
   3.550315829972383*^9}, {3.550316173327334*^9, 3.550316356959309*^9}, {
   3.550316421870942*^9, 3.5503164578447447`*^9}, {3.550316571822603*^9, 
   3.5503165783956757`*^9}, 3.550316608687422*^9, {3.550316642213719*^9, 
   3.550316699145254*^9}, {3.550317079711865*^9, 3.550317098501306*^9}, {
   3.550317190246339*^9, 3.550317225382019*^9}, {3.550317273438613*^9, 
   3.550317384359538*^9}, {3.550317446980321*^9, 3.550317451213595*^9}, {
   3.550317489872477*^9, 3.550317494062963*^9}, {3.550317902483246*^9, 
   3.5503179513773937`*^9}, {3.550376131696291*^9, 3.5503761698878317`*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{
   "multiplication", " ", "by", " ", "Q", " ", "and", " ", "summing", " ", 
    "up", " ", "everything"}], " ", "*)"}], " ", "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{"answer", "=", 
    RowBox[{"Table", "[", 
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{"Collect", "[", 
         RowBox[{"#", ",", 
          RowBox[{
           RowBox[{"\[Eta]$", "[", "__", "]"}], "[", "_", "]"}], ",", 
          RowBox[{
           RowBox[{"Simplify", "[", "#", "]"}], "&"}]}], "]"}], "&"}], "/@", 
       RowBox[{"(", 
        RowBox[{
         FractionBox["1", 
          RowBox[{"2", "\[ImaginaryI]"}]], 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"DeleteCases", "[", 
            RowBox[{
             RowBox[{
              RowBox[{"Series", "[", 
               RowBox[{
                RowBox[{
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"Q", "/.", "subFunsBethe"}], "/.", "weak"}], ")"}], 
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["g", 
                    RowBox[{"Range", "[", 
                    RowBox[{"4", ",", "10", ",", "2"}], "]"}]], ".", 
                   RowBox[{"preanswer", "[", 
                    RowBox[{"[", "iii", "]"}], "]"}]}], ")"}]}], ",", 
                RowBox[{"{", 
                 RowBox[{"g", ",", "0", ",", "10"}], "}"}]}], "]"}], "[", 
              RowBox[{"[", "3", "]"}], "]"}], ",", "0"}], "]"}], "+", 
           RowBox[{"inhomopiece", "[", 
            RowBox[{"[", "iii", "]"}], "]"}]}], ")"}]}], ")"}]}], ",", 
      RowBox[{"{", 
       RowBox[{"iii", ",", "3"}], "}"}]}], "]"}]}], ";"}]}]], "Input",
 CellChangeTimes->{{3.550317964505731*^9, 3.550318088780765*^9}, {
  3.550318145419827*^9, 3.5503182151545486`*^9}, {3.550318249018214*^9, 
  3.550318254910981*^9}, {3.550376147476672*^9, 3.55037615937166*^9}}],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"PowerMod", "::", "ninv"}], "MessageName"], 
  RowBox[{
  ":", " "}], "\<\"\[NoBreak]\\!\\(0\\)\[NoBreak] is not invertible modulo \
\[NoBreak]\\!\\(16267\\)\[NoBreak]. \\!\\(\\*ButtonBox[\\\"\[RightSkeleton]\\\
\", ButtonStyle->\\\"Link\\\", ButtonFrame->None, \
ButtonData:>\\\"paclet:ref/message/PowerMod/ninv\\\", ButtonNote -> \
\\\"PowerMod::ninv\\\"]\\)\"\>"}]], "Message", "MSG",
 CellChangeTimes->{3.5689597467727013`*^9}],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"PowerMod", "::", "ninv"}], "MessageName"], 
  RowBox[{
  ":", " "}], "\<\"\[NoBreak]\\!\\(0\\)\[NoBreak] is not invertible modulo \
\[NoBreak]\\!\\(16267\\)\[NoBreak]. \\!\\(\\*ButtonBox[\\\"\[RightSkeleton]\\\
\", ButtonStyle->\\\"Link\\\", ButtonFrame->None, \
ButtonData:>\\\"paclet:ref/message/PowerMod/ninv\\\", ButtonNote -> \
\\\"PowerMod::ninv\\\"]\\)\"\>"}]], "Message", "MSG",
 CellChangeTimes->{3.568959746784368*^9}],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"PowerMod", "::", "ninv"}], "MessageName"], 
  RowBox[{
  ":", " "}], "\<\"\[NoBreak]\\!\\(0\\)\[NoBreak] is not invertible modulo \
\[NoBreak]\\!\\(16267\\)\[NoBreak]. \\!\\(\\*ButtonBox[\\\"\[RightSkeleton]\\\
\", ButtonStyle->\\\"Link\\\", ButtonFrame->None, \
ButtonData:>\\\"paclet:ref/message/PowerMod/ninv\\\", ButtonNote -> \
\\\"PowerMod::ninv\\\"]\\)\"\>"}]], "Message", "MSG",
 CellChangeTimes->{3.568959746835071*^9}],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"General", "::", "stop"}], "MessageName"], 
  RowBox[{
  ":", " "}], "\<\"Further output of \[NoBreak]\\!\\(\\*StyleBox[\\(PowerMod \
:: ninv\\), \\\"MessageName\\\"]\\)\[NoBreak] will be suppressed during this \
calculation. \\!\\(\\*ButtonBox[\\\"\[RightSkeleton]\\\", \
ButtonStyle->\\\"Link\\\", ButtonFrame->None, \
ButtonData:>\\\"paclet:ref/message/General/stop\\\", ButtonNote -> \
\\\"General::stop\\\"]\\)\"\>"}]], "Message", "MSG",
 CellChangeTimes->{3.568959746847433*^9}]
}, Open  ]],

Cell["\<\
Now we are performing all the sums numerically and check that we get a good \
result\
\>", "Text",
 CellChangeTimes->{{3.55037617446668*^9, 3.5503761909844427`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"fornumerics", "=", 
   RowBox[{"Outer", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         RowBox[{
          RowBox[{
           RowBox[{"SeriesCoefficient", "[", 
            RowBox[{
             RowBox[{
              RowBox[{
               RowBox[{
                RowBox[{
                 RowBox[{"(", 
                  RowBox[{
                   FractionBox["1", 
                    RowBox[{
                    SuperscriptBox[
                    StyleBox["Q",
                    FontColor->RGBColor[0.8, 0, 0]], "+"], 
                    SuperscriptBox[
                    StyleBox["Q",
                    FontColor->RGBColor[0.8, 0, 0]], "-"]}]], "/.", 
                   "subFunsBethe"}], ")"}], 
                 StyleBox["f",
                  FontColor->RGBColor[0, 0.6, 0]]}], "/.", 
                RowBox[{
                 RowBox[{"f", "[", 
                  RowBox[{"r_:", "0"}], "]"}], "\[RuleDelayed]", 
                 RowBox[{"#1", "[", "r", "]"}]}]}], "/.", "weak"}], "//.", 
              RowBox[{
               SubsuperscriptBox["\[Eta]", "a__", 
                RowBox[{"[", "3", "]"}]], "\[RuleDelayed]", 
               RowBox[{
                RowBox[{"-", 
                 RowBox[{"If", "[", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"Length", "[", 
                    RowBox[{"{", "a", "}"}], "]"}], "\[NotEqual]", "1"}], ",", 
                   RowBox[{
                    FractionBox["1", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{"u", "+", 
                    FractionBox["\[ImaginaryI]", "2"]}], ")"}], 
                    RowBox[{
                    RowBox[{"{", "a", "}"}], "[", 
                    RowBox[{"[", "1", "]"}], "]"}]]], 
                    RowBox[{
                    RowBox[{
                    RowBox[{"\[Eta]$", "[", "a", "]"}], "[", 
                    RowBox[{"[", 
                    RowBox[{"2", ";;", 
                    RowBox[{"-", "1"}]}], "]"}], "]"}], "[", "3", "]"}]}], 
                   ",", 
                   FractionBox["1", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{"u", "+", 
                    FractionBox["\[ImaginaryI]", "2"]}], ")"}], 
                    RowBox[{
                    RowBox[{"{", "a", "}"}], "[", 
                    RowBox[{"[", "1", "]"}], "]"}]]]}], "]"}]}], " ", "+", 
                " ", 
                SubsuperscriptBox["\[Eta]", "a", 
                 RowBox[{"[", "1", "]"}]]}]}]}], ",", 
             RowBox[{"{", 
              RowBox[{"g", ",", "0", ",", "#2"}], "}"}]}], "]"}], "/.", 
           RowBox[{
            SubscriptBox["\[Zeta]", "1"], "\[Rule]", "EulerGamma"}]}], "/.", 
          RowBox[{
           SubscriptBox["\[Zeta]", "a_"], "\[RuleDelayed]", 
           RowBox[{"Zeta", "[", "a", "]"}]}]}], "//", "Simplify"}], "//", 
        "Together"}], ")"}], "&"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{
        SuperscriptBox[
         RowBox[{"U", "[", "#", "]"}], "2"], "&"}], ",", 
       RowBox[{
        RowBox[{
         SuperscriptBox[
          RowBox[{"U", "[", "#", "]"}], "2"], 
         RowBox[{
          RowBox[{"q$", "[", "2", "]"}], "[", "#", "]"}]}], "&"}], ",", 
       RowBox[{
        RowBox[{
         SuperscriptBox[
          RowBox[{"U", "[", "#", "]"}], "2"], 
         SuperscriptBox[
          RowBox[{
           RowBox[{"q$", "[", "2", "]"}], "[", "#", "]"}], "2"]}], "&"}]}], 
      "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"4", ",", "6", ",", "8", ",", "10"}], "}"}]}], "]"}]}], 
  ";"}]], "Input",
 CellChangeTimes->{{3.5503169244768972`*^9, 3.5503169680179167`*^9}, {
  3.552386085945093*^9, 3.552386109503429*^9}, {3.552386231221724*^9, 
  3.552386254827568*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"uu", "=", 
   RowBox[{"SetPrecision", "[", 
    RowBox[{
     RowBox[{"Random", "[", "]"}], ",", "30"}], "]"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.5503182989595413`*^9, 3.550318310592598*^9}}],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{"warning", ":", " ", 
   RowBox[{"This", " ", "sum", " ", "is", " ", "timely", " ", "to", " ", 
    RowBox[{"compute", "."}]}]}]}]], "Input",
 CellChangeTimes->{{3.552387077382128*^9, 3.5523871040669127`*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"precheck", "=", 
  RowBox[{"Monitor", "[", 
   RowBox[{
    RowBox[{"Table", "[", 
     RowBox[{
      RowBox[{"NSum", "[", 
       RowBox[{
        RowBox[{
         RowBox[{
          RowBox[{
           RowBox[{"Collect", "[", 
            RowBox[{
             RowBox[{
              RowBox[{"fornumerics", "[", 
               RowBox[{"[", 
                RowBox[{"i", ",", "j"}], "]"}], "]"}], "//.", 
              "subtopowerbasis"}], ",", 
             RowBox[{
              RowBox[{"\[Eta]$", "[", "__", "]"}], "[", "_", "]"}], ",", 
             "Simplify"}], "]"}], "/.", "subtoPolyGammas"}], "/.", 
          RowBox[{"u", "\[Rule]", 
           RowBox[{"uu", "+", 
            RowBox[{"\[ImaginaryI]", " ", "n"}], "+", 
            FractionBox["\[ImaginaryI]", "2"]}]}]}], "//", "Evaluate"}], ",", 
        
        RowBox[{"{", 
         RowBox[{"n", ",", "0", ",", "\[Infinity]"}], "}"}]}], "]"}], ",", 
      RowBox[{"{", 
       RowBox[{"i", ",", "3"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"j", ",", "4"}], "}"}]}], "]"}], ",", 
    RowBox[{"{", 
     RowBox[{"i", ",", "j"}], "}"}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.550374633258739*^9, 3.550374935509199*^9}, {
   3.550374971730446*^9, 3.550374972090232*^9}, {3.550375275496819*^9, 
   3.550375275797605*^9}, {3.550375366772532*^9, 3.550375368608039*^9}, {
   3.550375799084361*^9, 3.550375799575695*^9}, 3.5523861724355717`*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"5.067826589057104`", "\[VeryThinSpace]", "-", 
      RowBox[{"0.7087824595913599`", " ", "\[ImaginaryI]"}]}], ",", 
     RowBox[{"48.61700434978402`", "\[VeryThinSpace]", "+", 
      RowBox[{"39.61147602669343`", " ", "\[ImaginaryI]"}]}], ",", 
     RowBox[{"64.39396398010618`", "\[VeryThinSpace]", "+", 
      RowBox[{"33.87739835793193`", " ", "\[ImaginaryI]"}]}], ",", 
     RowBox[{"2409.8905868534207`", "\[VeryThinSpace]", "+", 
      RowBox[{"532.7908431089768`", " ", "\[ImaginaryI]"}]}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"0.5133845372292742`", "\[VeryThinSpace]", "-", 
      RowBox[{"5.1534014449781695`", " ", "\[ImaginaryI]"}]}], ",", 
     RowBox[{"43.938944495194406`", "\[VeryThinSpace]", "-", 
      RowBox[{"43.06635849344868`", " ", "\[ImaginaryI]"}]}], ",", 
     RowBox[{"29.133932660663863`", "\[VeryThinSpace]", "-", 
      RowBox[{"126.81294164625383`", " ", "\[ImaginaryI]"}]}], ",", 
     RowBox[{"807.5121085790363`", "\[VeryThinSpace]", "-", 
      RowBox[{"2249.2560974151424`", " ", "\[ImaginaryI]"}]}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{
      RowBox[{"-", "5.077198927066737`"}], "-", 
      RowBox[{"1.6759250342979892`", " ", "\[ImaginaryI]"}]}], ",", 
     RowBox[{
      RowBox[{"-", "37.91688597427607`"}], "-", 
      RowBox[{"49.33248299437316`", " ", "\[ImaginaryI]"}]}], ",", 
     RowBox[{
      RowBox[{"-", "189.7927859642933`"}], "-", 
      RowBox[{"30.992241226569607`", " ", "\[ImaginaryI]"}]}], ",", 
     RowBox[{
      RowBox[{"-", "2142.3835813849223`"}], "-", 
      RowBox[{"1099.7557374830737`", " ", "\[ImaginaryI]"}]}]}], "}"}]}], 
  "}"}]], "Output",
 CellChangeTimes->{
  3.550375361552051*^9, 3.550375594773233*^9, 3.550376117634163*^9, {
   3.552386169479377*^9, 3.5523861956148567`*^9}, 3.552386515432502*^9, 
   3.55238710627422*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"check", "=", 
  RowBox[{"Table", "[", 
   RowBox[{
    RowBox[{"Series", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          RowBox[{
           RowBox[{"Q", "/.", "subFunsBethe"}], "/.", 
           RowBox[{"u", "\[Rule]", "uu"}]}], "/.", "weak"}], "/.", 
         "subZetas"}], ")"}], 
       RowBox[{"(", 
        RowBox[{
         SuperscriptBox["g", 
          RowBox[{"Range", "[", 
           RowBox[{"4", ",", "10", ",", "2"}], "]"}]], ".", 
         RowBox[{"precheck", "[", 
          RowBox[{"[", "iii", "]"}], "]"}]}], ")"}]}], ",", 
      RowBox[{"{", 
       RowBox[{"g", ",", "0", ",", "10"}], "}"}]}], "]"}], ",", 
    RowBox[{"{", 
     RowBox[{"iii", ",", "3"}], "}"}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.5503750037358303`*^9, 3.550375063162818*^9}, {
  3.550375244763556*^9, 3.5503752604184523`*^9}, {3.550375620981451*^9, 
  3.5503756696268263`*^9}, {3.5503761954616613`*^9, 3.550376197557095*^9}, {
  3.552387177438108*^9, 3.5523871792117*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   InterpretationBox[
    RowBox[{
     RowBox[{
      RowBox[{"(", 
       RowBox[{"1.8647230441981988`", "\[VeryThinSpace]", "-", 
        RowBox[{"0.2607987788251045`", " ", "\[ImaginaryI]"}]}], ")"}], " ", 
      SuperscriptBox["g", "4"]}], "+", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"11.131680529558821`", "\[VeryThinSpace]", "+", 
        RowBox[{"15.520212903683078`", " ", "\[ImaginaryI]"}]}], ")"}], " ", 
      SuperscriptBox["g", "6"]}], "-", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"51.264360109000165`", "\[VeryThinSpace]", "+", 
        RowBox[{"38.932439090924504`", " ", "\[ImaginaryI]"}]}], ")"}], " ", 
      SuperscriptBox["g", "8"]}], "+", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"695.4424270020237`", "\[VeryThinSpace]", "+", 
        RowBox[{"72.79499777636082`", " ", "\[ImaginaryI]"}]}], ")"}], " ", 
      SuperscriptBox["g", "10"]}], "+", 
     InterpretationBox[
      SuperscriptBox[
       RowBox[{"O", "[", "g", "]"}], "11"],
      SeriesData[$CellContext`g, 0, {}, 4, 11, 1],
      Editable->False]}],
    SeriesData[$CellContext`g, 0, {
      Complex[1.8647230441981988`, -0.2607987788251045], 0, 
      Complex[11.131680529558821`, 15.520212903683078`], 0, 
      Complex[-51.264360109000165`, -38.932439090924504`], 0, 
      Complex[695.4424270020237, 72.79499777636082]}, 4, 11, 1],
    Editable->False], ",", 
   InterpretationBox[
    RowBox[{
     RowBox[{
      RowBox[{"(", 
       RowBox[{"0.1889014867188994`", "\[VeryThinSpace]", "-", 
        RowBox[{"1.8962105868431103`", " ", "\[ImaginaryI]"}]}], ")"}], " ", 
      SuperscriptBox["g", "4"]}], "+", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"15.482962807591194`", "\[VeryThinSpace]", "-", 
        RowBox[{"8.975202779837627`", " ", "\[ImaginaryI]"}]}], ")"}], " ", 
      SuperscriptBox["g", "6"]}], "-", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"48.89210445651909`", "\[VeryThinSpace]", "-", 
        RowBox[{"21.06738569088332`", " ", "\[ImaginaryI]"}]}], ")"}], " ", 
      SuperscriptBox["g", "8"]}], "+", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"169.57367410599346`", "\[VeryThinSpace]", "-", 
        RowBox[{"564.0741117491552`", " ", "\[ImaginaryI]"}]}], ")"}], " ", 
      SuperscriptBox["g", "10"]}], "+", 
     InterpretationBox[
      SuperscriptBox[
       RowBox[{"O", "[", "g", "]"}], "11"],
      SeriesData[$CellContext`g, 0, {}, 4, 11, 1],
      Editable->False]}],
    SeriesData[$CellContext`g, 0, {
      Complex[0.1889014867188994, -1.8962105868431103`], 0, 
      Complex[15.482962807591194`, -8.975202779837627], 0, 
      Complex[-48.89210445651909, 21.06738569088332], 0, 
      Complex[169.57367410599346`, -564.0741117491552]}, 4, 11, 1],
    Editable->False], ",", 
   InterpretationBox[
    RowBox[{
     RowBox[{
      RowBox[{"-", 
       RowBox[{"(", 
        RowBox[{"1.8681716260226668`", "\[VeryThinSpace]", "+", 
         RowBox[{"0.6166619904777692`", " ", "\[ImaginaryI]"}]}], ")"}]}], 
      " ", 
      SuperscriptBox["g", "4"]}], "-", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"7.182041211058612`", "\[VeryThinSpace]", "+", 
        RowBox[{"15.917478597471677`", " ", "\[ImaginaryI]"}]}], ")"}], " ", 
      SuperscriptBox["g", "6"]}], "-", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"9.124618375082477`", "\[VeryThinSpace]", "-", 
        RowBox[{"57.72479952045489`", " ", "\[ImaginaryI]"}]}], ")"}], " ", 
      SuperscriptBox["g", "8"]}], "-", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"451.1990240121193`", "\[VeryThinSpace]", "+", 
        RowBox[{"261.96163807077613`", " ", "\[ImaginaryI]"}]}], ")"}], " ", 
      SuperscriptBox["g", "10"]}], "+", 
     InterpretationBox[
      SuperscriptBox[
       RowBox[{"O", "[", "g", "]"}], "11"],
      SeriesData[$CellContext`g, 0, {}, 4, 11, 1],
      Editable->False]}],
    SeriesData[$CellContext`g, 0, {
      Complex[-1.8681716260226668`, -0.6166619904777692], 0, 
      Complex[-7.182041211058612, -15.917478597471677`], 0, 
      Complex[-9.124618375082477, 57.72479952045489], 0, 
      Complex[-451.1990240121193, -261.96163807077613`]}, 4, 11, 1],
    Editable->False]}], "}"}]], "Output",
 CellChangeTimes->{{3.550375058620129*^9, 3.550375063959363*^9}, {
   3.55037524523211*^9, 3.550375260710397*^9}, {3.5503756510888643`*^9, 
   3.5503756701607847`*^9}, 3.5503762014776278`*^9, 3.552387117325015*^9, {
   3.552387153297349*^9, 3.552387192727912*^9}}]
}, Open  ]],

Cell["\<\
Compare to what we get from analytic results:\
\>", "Text",
 CellChangeTimes->{{3.550376211423934*^9, 3.5503762182239733`*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"checka", "=", 
  RowBox[{
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{"BoldCompute", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"Collect", "[", 
         RowBox[{
          RowBox[{
           RowBox[{
            RowBox[{"answer", "[", 
             RowBox[{"[", 
              RowBox[{"i", ",", "j"}], "]"}], "]"}], "//.", 
            "subtopowerbasis"}], "/.", 
           RowBox[{"u", "\[Rule]", "uu"}]}], ",", 
          RowBox[{
           RowBox[{"\[Eta]$", "[", "__", "]"}], "[", "_", "]"}], ",", 
          "Simplify"}], "]"}], "/.", "subZetas"}], ",", "uu", ",", "20"}], 
      "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"i", ",", "3"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"j", ",", "4"}], "}"}]}], "]"}], "//", "N"}]}]], "Input",
 CellChangeTimes->{{3.550375688802328*^9, 3.55037569772304*^9}, {
   3.5503762046777563`*^9, 3.5503762277076683`*^9}, 3.552386306678629*^9, {
   3.552386389051996*^9, 3.552386405623064*^9}, {3.5523866731760178`*^9, 
   3.5523866923003283`*^9}, {3.5523867321903276`*^9, 
   3.5523867322749557`*^9}, {3.5523872200127773`*^9, 
   3.5523872718171167`*^9}, {3.552387342583947*^9, 3.552387342766387*^9}, {
   3.552387378303144*^9, 3.552387403739972*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"1.8647230441921336`", "\[VeryThinSpace]", "-", 
      RowBox[{"0.26079877882759284`", " ", "\[ImaginaryI]"}]}], ",", 
     RowBox[{"11.131680529737782`", "\[VeryThinSpace]", "+", 
      RowBox[{"15.520212903752858`", " ", "\[ImaginaryI]"}]}], ",", 
     RowBox[{
      RowBox[{"-", "51.26436011229146`"}], "-", 
      RowBox[{"38.932439092153224`", " ", "\[ImaginaryI]"}]}], ",", 
     RowBox[{"695.4424270525426`", "\[VeryThinSpace]", "+", 
      RowBox[{"72.79499779459773`", " ", "\[ImaginaryI]"}]}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"0.18890148665916587`", "\[VeryThinSpace]", "-", 
      RowBox[{"1.8962105868646382`", " ", "\[ImaginaryI]"}]}], ",", 
     RowBox[{"15.48296280929909`", "\[VeryThinSpace]", "-", 
      RowBox[{"8.975202779256792`", " ", "\[ImaginaryI]"}]}], ",", 
     RowBox[{
      RowBox[{"-", "48.89210448702146`"}], "+", 
      RowBox[{"21.067385681015917`", " ", "\[ImaginaryI]"}]}], ",", 
     RowBox[{"169.57367456275935`", "\[VeryThinSpace]", "-", 
      RowBox[{"564.0741116070055`", " ", "\[ImaginaryI]"}]}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{
      RowBox[{"-", "1.8681716265587964`"}], "-", 
      RowBox[{"0.6166619906450151`", " ", "\[ImaginaryI]"}]}], ",", 
     RowBox[{
      RowBox[{"-", "7.1820411964255015`"}], "-", 
      RowBox[{"15.91747859320843`", " ", "\[ImaginaryI]"}]}], ",", 
     RowBox[{
      RowBox[{"-", "9.124618417290904`"}], "+", 
      RowBox[{"57.72479950842313`", " ", "\[ImaginaryI]"}]}], ",", 
     RowBox[{
      RowBox[{"-", "451.19902409309367`"}], "-", 
      RowBox[{"261.96163809494993`", " ", "\[ImaginaryI]"}]}]}], "}"}]}], 
  "}"}]], "Output",
 CellChangeTimes->{
  3.550375704148973*^9, {3.5503762170183077`*^9, 3.550376229494927*^9}, 
   3.552387204072686*^9, {3.5523872387694607`*^9, 3.5523872738968697`*^9}, 
   3.552387345878804*^9, {3.552387383945067*^9, 3.552387417880164*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     RowBox[{
      RowBox[{"DeleteCases", "[", 
       RowBox[{
        RowBox[{"#", "[", 
         RowBox[{"[", "3", "]"}], "]"}], ",", "0"}], "]"}], "&"}], "/@", 
     "check"}], ")"}], "-", "checka"}], "//", "Chop"}]], "Input",
 CellChangeTimes->{{3.552387278881296*^9, 3.552387336572391*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"0", ",", 
     RowBox[{"-", "1.7896084614221763`*^-10"}], ",", 
     RowBox[{"3.2912979008870025`*^-9", "+", 
      RowBox[{"1.2287202366678684`*^-9", " ", "\[ImaginaryI]"}]}], ",", 
     RowBox[{
      RowBox[{"-", "5.0518906391516794`*^-8"}], "-", 
      RowBox[{"1.8236917753711168`*^-8", " ", "\[ImaginaryI]"}]}]}], "}"}], 
   ",", 
   RowBox[{"{", 
    RowBox[{"0", ",", 
     RowBox[{
      RowBox[{"-", "1.7078960468097648`*^-9"}], "-", 
      RowBox[{"5.808349357039333`*^-10", " ", "\[ImaginaryI]"}]}], ",", 
     RowBox[{"3.0502370407248236`*^-8", "+", 
      RowBox[{"9.867402894769839`*^-9", " ", "\[ImaginaryI]"}]}], ",", 
     RowBox[{
      RowBox[{"-", "4.5676588911192084`*^-7"}], "-", 
      RowBox[{"1.4214970178727526`*^-7", " ", "\[ImaginaryI]"}]}]}], "}"}], 
   ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"5.361295851713521`*^-10", "+", 
      RowBox[{"1.672459948309779`*^-10", " ", "\[ImaginaryI]"}]}], ",", 
     RowBox[{
      RowBox[{"-", "1.4633110723138998`*^-8"}], "-", 
      RowBox[{"4.263245756419565`*^-9", " ", "\[ImaginaryI]"}]}], ",", 
     RowBox[{"4.220842697577609`*^-8", "+", 
      RowBox[{"1.2031755147745571`*^-8", " ", "\[ImaginaryI]"}]}], ",", 
     RowBox[{"8.097435966192279`*^-8", "+", 
      RowBox[{"2.4173800738935824`*^-8", " ", "\[ImaginaryI]"}]}]}], "}"}]}], 
  "}"}]], "Output",
 CellChangeTimes->{{3.552387291221739*^9, 3.5523873516244583`*^9}, {
  3.552387384899431*^9, 3.552387420030912*^9}}]
}, Open  ]],

Cell["\<\
Concerning the precision problems of NSum, this should be considered as a \
complete agreement. All shon explicitly numbers do agree.\
\>", "Text",
 CellChangeTimes->{{3.552387450301755*^9, 3.5523874849879503`*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["\<\
Results (need to run \[OpenCurlyDoubleQuote]old way of computation\
\[CloseCurlyDoubleQuote] to get this section working)\
\>", "Subsubsection",
 CellChangeTimes->{{3.538828297912489*^9, 3.538828299780596*^9}, {
  3.540095540697797*^9, 3.540095541080428*^9}, {3.550375941652423*^9, 
  3.550375945666698*^9}, {3.550379003081327*^9, 3.550379004318808*^9}, {
  3.5689614790614023`*^9, 3.5689614942494907`*^9}}],

Cell["\<\
I slightly rearrange expressions to make them nicer looking (and to attribute \
all poles to \[Eta]-functions).\
\>", "Text",
 CellChangeTimes->{{3.550380396593239*^9, 3.550380421445447*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"Map", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"Collect", "[", 
       RowBox[{"#", ",", 
        RowBox[{
         RowBox[{"\[Eta]$", "[", "__", "]"}], "[", "_", "]"}], ",", 
        "Simplify"}], "]"}], "&"}], ",", 
     RowBox[{"answer", "//.", 
      RowBox[{"shiftm\[Eta]", "[", "3", "]"}]}], ",", 
     RowBox[{"{", "2", "}"}]}], "]"}], "/.", 
   RowBox[{
    SuperscriptBox["u", "2"], "\[Rule]", 
    RowBox[{"Q0", "+", 
     FractionBox["1", "12"]}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"tmp", "=", 
   RowBox[{"Map", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"Collect", "[", 
       RowBox[{"#", ",", 
        RowBox[{"{", 
         RowBox[{
          SubscriptBox["\[Zeta]", "1"], ",", "Q0", ",", 
          RowBox[{
           RowBox[{"\[Eta]$", "[", "__", "]"}], "[", "_", "]"}]}], "}"}], ",",
         "Factor"}], "]"}], "&"}], ",", "%", ",", 
     RowBox[{"{", "2", "}"}]}], "]"}]}], ";"}]}], "Input",
 CellChangeTimes->{{3.55037900525991*^9, 3.5503791101539173`*^9}, {
  3.5503791434053307`*^9, 3.550379162566104*^9}, {3.5503792386284313`*^9, 
  3.550379241505748*^9}, {3.550380390398568*^9, 3.550380394252212*^9}, {
  3.552387629181731*^9, 3.552387632892913*^9}, {3.552387674422097*^9, 
  3.552387677147345*^9}, {3.5523877172086678`*^9, 3.552387718044383*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"weakqij", "=", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{
     SubscriptBox["q", 
      RowBox[{"1", ",", "3"}]], "\[Rule]", " ", 
     RowBox[{"(", 
      RowBox[{"(", 
       RowBox[{
        SuperscriptBox["g", 
         RowBox[{"Range", "[", 
          RowBox[{"4", ",", "10", ",", "2"}], "]"}]], ".", 
        RowBox[{"tmp", "[", 
         RowBox[{"[", "1", "]"}], "]"}]}], ")"}], ")"}]}], ",", 
    RowBox[{
     SubscriptBox["q", 
      RowBox[{"1", ",", "4"}]], "\[Rule]", " ", 
     RowBox[{"(", 
      RowBox[{"(", 
       RowBox[{
        SuperscriptBox["g", 
         RowBox[{"Range", "[", 
          RowBox[{"4", ",", "10", ",", "2"}], "]"}]], ".", 
        RowBox[{"tmp", "[", 
         RowBox[{"[", "2", "]"}], "]"}]}], ")"}], ")"}]}], ",", 
    RowBox[{
     SubscriptBox["q", 
      RowBox[{"2", ",", "4"}]], "\[Rule]", " ", 
     RowBox[{"(", 
      RowBox[{"(", 
       RowBox[{
        SuperscriptBox["g", 
         RowBox[{"Range", "[", 
          RowBox[{"4", ",", "10", ",", "2"}], "]"}]], ".", 
        RowBox[{"tmp", "[", 
         RowBox[{"[", "3", "]"}], "]"}]}], ")"}], ")"}]}]}], "}"}]}]], "Input",\

 CellChangeTimes->{{3.550379163423367*^9, 3.550379250195806*^9}, {
  3.550379287021862*^9, 3.550379337695402*^9}, {3.552387533201749*^9, 
  3.552387536818983*^9}, {3.552387585637618*^9, 3.552387604511681*^9}, {
  3.552387683175111*^9, 3.552387690013144*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{
    SubscriptBox[
     StyleBox["q",
      FontColor->RGBColor[0, 0, 0.8]], 
     RowBox[{"1", ",", "3"}]], "\[Rule]", 
    RowBox[{
     RowBox[{
      SuperscriptBox["g", "4"], " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         RowBox[{"-", "18"}], " ", "\[ImaginaryI]", " ", "u"}], "-", 
        RowBox[{"18", " ", 
         StyleBox["Q0",
          FontColor->RGBColor[{
             Rational[1, 2], 
             Rational[1, 2], 0}]], " ", 
         SubsuperscriptBox[
          StyleBox["\[Eta]",
           FontWeight->Bold,
           FontColor->RGBColor[0.8, 0, 0]], "2", "+"]}]}], ")"}]}], "+", 
     RowBox[{
      SuperscriptBox["g", "6"], " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"306", " ", "\[ImaginaryI]", " ", "u"}], "+", 
        RowBox[{"216", " ", "u", " ", 
         SubsuperscriptBox[
          StyleBox["\[Eta]",
           FontWeight->Bold,
           FontColor->RGBColor[0.8, 0, 0]], "1", "+"]}], "+", 
        RowBox[{"24", " ", 
         SubsuperscriptBox[
          StyleBox["\[Eta]",
           FontWeight->Bold,
           FontColor->RGBColor[0.8, 0, 0]], "2", "+"]}], "+", 
        RowBox[{
         SubscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->RGBColor[0.8, 0, 0]], "1"], " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"216", " ", "\[ImaginaryI]", " ", "u"}], "+", 
           RowBox[{"216", " ", 
            StyleBox["Q0",
             FontColor->RGBColor[{
                Rational[1, 2], 
                Rational[1, 2], 0}]], " ", 
            SubsuperscriptBox[
             StyleBox["\[Eta]",
              FontWeight->Bold,
              FontColor->RGBColor[0.8, 0, 0]], "2", "+"]}]}], ")"}]}], "+", 
        RowBox[{
         StyleBox["Q0",
          FontColor->RGBColor[{
             Rational[1, 2], 
             Rational[1, 2], 0}]], " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"90", " ", 
            SubsuperscriptBox[
             StyleBox["\[Eta]",
              FontWeight->Bold,
              FontColor->RGBColor[0.8, 0, 0]], "2", "+"]}], "-", 
           RowBox[{"108", " ", "\[ImaginaryI]", " ", 
            SubsuperscriptBox[
             StyleBox["\[Eta]",
              FontWeight->Bold,
              FontColor->RGBColor[0.8, 0, 0]], "3", "+"]}], "-", 
           RowBox[{"36", " ", 
            SubsuperscriptBox[
             StyleBox["\[Eta]",
              FontWeight->Bold,
              FontColor->RGBColor[0.8, 0, 0]], "4", "+"]}], "-", 
           RowBox[{"216", " ", "\[ImaginaryI]", " ", 
            SubsuperscriptBox[
             StyleBox["\[Eta]",
              FontWeight->Bold,
              FontColor->RGBColor[0.8, 0, 0]], 
             RowBox[{"2", ",", "1"}], "+"]}]}], ")"}]}]}], ")"}]}], "+", 
     RowBox[{
      SuperscriptBox["g", "8"], " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         RowBox[{"-", "162"}], " ", "\[ImaginaryI]", " ", "u", " ", 
         RowBox[{"(", 
          RowBox[{"27", "+", 
           RowBox[{"4", " ", 
            SubscriptBox[
             StyleBox["\[Zeta]",
              FontWeight->Bold,
              FontColor->RGBColor[0.8, 0, 0]], "3"]}]}], ")"}]}], "-", 
        RowBox[{"4536", " ", "u", " ", 
         SubsuperscriptBox[
          StyleBox["\[Eta]",
           FontWeight->Bold,
           FontColor->RGBColor[0.8, 0, 0]], "1", "+"]}], "+", 
        RowBox[{"12", " ", "\[ImaginaryI]", " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"7", " ", "\[ImaginaryI]"}], "+", 
           RowBox[{"108", " ", "u"}]}], ")"}], " ", 
         SubsuperscriptBox[
          StyleBox["\[Eta]",
           FontWeight->Bold,
           FontColor->RGBColor[0.8, 0, 0]], "2", "+"]}], "+", 
        RowBox[{
         SubsuperscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->RGBColor[0.8, 0, 0]], "1", "2"], " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{
            RowBox[{"-", "1296"}], " ", "\[ImaginaryI]", " ", "u"}], "-", 
           RowBox[{"1296", " ", 
            StyleBox["Q0",
             FontColor->RGBColor[{
                Rational[1, 2], 
                Rational[1, 2], 0}]], " ", 
            SubsuperscriptBox[
             StyleBox["\[Eta]",
              FontWeight->Bold,
              FontColor->RGBColor[0.8, 0, 0]], "2", "+"]}]}], ")"}]}], "+", 
        RowBox[{"72", " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"2", " ", "\[ImaginaryI]"}], "+", 
           RowBox[{"3", " ", "u"}]}], ")"}], " ", 
         SubsuperscriptBox[
          StyleBox["\[Eta]",
           FontWeight->Bold,
           FontColor->RGBColor[0.8, 0, 0]], "3", "+"]}], "+", 
        RowBox[{"48", " ", 
         SubsuperscriptBox[
          StyleBox["\[Eta]",
           FontWeight->Bold,
           FontColor->RGBColor[0.8, 0, 0]], "4", "+"]}], "+", 
        RowBox[{"2592", " ", "\[ImaginaryI]", " ", "u", " ", 
         SubsuperscriptBox[
          StyleBox["\[Eta]",
           FontWeight->Bold,
           FontColor->RGBColor[0.8, 0, 0]], 
          RowBox[{"1", ",", "1"}], "+"]}], "+", 
        RowBox[{
         SubscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->RGBColor[0.8, 0, 0]], "1"], " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{
            RowBox[{"-", "4536"}], " ", "\[ImaginaryI]", " ", "u"}], "-", 
           RowBox[{"2592", " ", "u", " ", 
            SubsuperscriptBox[
             StyleBox["\[Eta]",
              FontWeight->Bold,
              FontColor->RGBColor[0.8, 0, 0]], "1", "+"]}], "-", 
           RowBox[{"288", " ", 
            SubsuperscriptBox[
             StyleBox["\[Eta]",
              FontWeight->Bold,
              FontColor->RGBColor[0.8, 0, 0]], "2", "+"]}], "+", 
           RowBox[{
            StyleBox["Q0",
             FontColor->RGBColor[{
                Rational[1, 2], 
                Rational[1, 2], 0}]], " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{
               RowBox[{"-", "1944"}], " ", 
               SubsuperscriptBox[
                StyleBox["\[Eta]",
                 FontWeight->Bold,
                 FontColor->RGBColor[0.8, 0, 0]], "2", "+"]}], "+", 
              RowBox[{"1296", " ", "\[ImaginaryI]", " ", 
               SubsuperscriptBox[
                StyleBox["\[Eta]",
                 FontWeight->Bold,
                 FontColor->RGBColor[0.8, 0, 0]], "3", "+"]}], "+", 
              RowBox[{"432", " ", 
               SubsuperscriptBox[
                StyleBox["\[Eta]",
                 FontWeight->Bold,
                 FontColor->RGBColor[0.8, 0, 0]], "4", "+"]}], "+", 
              RowBox[{"2592", " ", "\[ImaginaryI]", " ", 
               SubsuperscriptBox[
                StyleBox["\[Eta]",
                 FontWeight->Bold,
                 FontColor->RGBColor[0.8, 0, 0]], 
                RowBox[{"2", ",", "1"}], "+"]}]}], ")"}]}]}], ")"}]}], "+", 
        RowBox[{"288", " ", "\[ImaginaryI]", " ", 
         SubsuperscriptBox[
          StyleBox["\[Eta]",
           FontWeight->Bold,
           FontColor->RGBColor[0.8, 0, 0]], 
          RowBox[{"2", ",", "1"}], "+"]}], "+", 
        RowBox[{
         StyleBox["Q0",
          FontColor->RGBColor[{
             Rational[1, 2], 
             Rational[1, 2], 0}]], " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{
            RowBox[{"-", "162"}], " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "1"}], "+", 
              RowBox[{"4", " ", 
               SubscriptBox[
                StyleBox["\[Zeta]",
                 FontWeight->Bold,
                 FontColor->RGBColor[0.8, 0, 0]], "3"]}]}], ")"}], " ", 
            SubsuperscriptBox[
             StyleBox["\[Eta]",
              FontWeight->Bold,
              FontColor->RGBColor[0.8, 0, 0]], "2", "+"]}], "+", 
           RowBox[{"972", " ", "\[ImaginaryI]", " ", 
            SubsuperscriptBox[
             StyleBox["\[Eta]",
              FontWeight->Bold,
              FontColor->RGBColor[0.8, 0, 0]], "3", "+"]}], "+", 
           RowBox[{"504", " ", 
            SubsuperscriptBox[
             StyleBox["\[Eta]",
              FontWeight->Bold,
              FontColor->RGBColor[0.8, 0, 0]], "4", "+"]}], "-", 
           RowBox[{"324", " ", "\[ImaginaryI]", " ", 
            SubsuperscriptBox[
             StyleBox["\[Eta]",
              FontWeight->Bold,
              FontColor->RGBColor[0.8, 0, 0]], "5", "+"]}], "-", 
           RowBox[{"90", " ", 
            SubsuperscriptBox[
             StyleBox["\[Eta]",
              FontWeight->Bold,
              FontColor->RGBColor[0.8, 0, 0]], "6", "+"]}], "+", 
           RowBox[{"1944", " ", "\[ImaginaryI]", " ", 
            SubsuperscriptBox[
             StyleBox["\[Eta]",
              FontWeight->Bold,
              FontColor->RGBColor[0.8, 0, 0]], 
             RowBox[{"2", ",", "1"}], "+"]}], "+", 
           RowBox[{"1296", " ", 
            SubsuperscriptBox[
             StyleBox["\[Eta]",
              FontWeight->Bold,
              FontColor->RGBColor[0.8, 0, 0]], 
             RowBox[{"2", ",", "2"}], "+"]}], "-", 
           RowBox[{"216", " ", "\[ImaginaryI]", " ", 
            SubsuperscriptBox[
             StyleBox["\[Eta]",
              FontWeight->Bold,
              FontColor->RGBColor[0.8, 0, 0]], 
             RowBox[{"2", ",", "3"}], "+"]}], "+", 
           RowBox[{"1296", " ", 
            SubsuperscriptBox[
             StyleBox["\[Eta]",
              FontWeight->Bold,
              FontColor->RGBColor[0.8, 0, 0]], 
             RowBox[{"3", ",", "1"}], "+"]}], "-", 
           RowBox[{"432", " ", "\[ImaginaryI]", " ", 
            SubsuperscriptBox[
             StyleBox["\[Eta]",
              FontWeight->Bold,
              FontColor->RGBColor[0.8, 0, 0]], 
             RowBox[{"4", ",", "1"}], "+"]}], "+", 
           RowBox[{"2592", " ", 
            SubsuperscriptBox[
             StyleBox["\[Eta]",
              FontWeight->Bold,
              FontColor->RGBColor[0.8, 0, 0]], 
             RowBox[{"2", ",", "1", ",", "1"}], "+"]}]}], ")"}]}]}], ")"}]}], 
     "+", 
     RowBox[{
      SuperscriptBox["g", "10"], " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"18", " ", "\[ImaginaryI]", " ", "u", " ", 
         RowBox[{"(", 
          RowBox[{"3241", "+", 
           RowBox[{"876", " ", 
            SubscriptBox[
             StyleBox["\[Zeta]",
              FontWeight->Bold,
              FontColor->RGBColor[0.8, 0, 0]], "3"]}], "+", 
           RowBox[{"240", " ", 
            SubscriptBox[
             StyleBox["\[Zeta]",
              FontWeight->Bold,
              FontColor->RGBColor[0.8, 0, 0]], "5"]}]}], ")"}]}], "+", 
        RowBox[{"648", " ", "u", " ", 
         RowBox[{"(", 
          RowBox[{"113", "+", 
           RowBox[{"12", " ", 
            SubscriptBox[
             StyleBox["\[Zeta]",
              FontWeight->Bold,
              FontColor->RGBColor[0.8, 0, 0]], "3"]}]}], ")"}], " ", 
         SubsuperscriptBox[
          StyleBox["\[Eta]",
           FontWeight->Bold,
           FontColor->RGBColor[0.8, 0, 0]], "1", "+"]}], "+", 
        RowBox[{"36", " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"-", "15"}], "-", 
           RowBox[{"900", " ", "\[ImaginaryI]", " ", "u"}], "+", 
           RowBox[{"28", " ", 
            SubscriptBox[
             StyleBox["\[Zeta]",
              FontWeight->Bold,
              FontColor->RGBColor[0.8, 0, 0]], "3"]}]}], ")"}], " ", 
         SubsuperscriptBox[
          StyleBox["\[Eta]",
           FontWeight->Bold,
           FontColor->RGBColor[0.8, 0, 0]], "2", "+"]}], "+", 
        RowBox[{
         SubsuperscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->RGBColor[0.8, 0, 0]], "1", "3"], " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"5184", " ", "\[ImaginaryI]", " ", "u"}], "+", 
           RowBox[{"5184", " ", 
            StyleBox["Q0",
             FontColor->RGBColor[{
                Rational[1, 2], 
                Rational[1, 2], 0}]], " ", 
            SubsuperscriptBox[
             StyleBox["\[Eta]",
              FontWeight->Bold,
              FontColor->RGBColor[0.8, 0, 0]], "2", "+"]}]}], ")"}]}], "-", 
        RowBox[{"1080", " ", 
         RowBox[{"(", 
          RowBox[{"\[ImaginaryI]", "+", 
           RowBox[{"9", " ", "u"}]}], ")"}], " ", 
         SubsuperscriptBox[
          StyleBox["\[Eta]",
           FontWeight->Bold,
           FontColor->RGBColor[0.8, 0, 0]], "3", "+"]}], "+", 
        RowBox[{"24", " ", "\[ImaginaryI]", " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"25", " ", "\[ImaginaryI]"}], "+", 
           RowBox[{"108", " ", "u"}]}], ")"}], " ", 
         SubsuperscriptBox[
          StyleBox["\[Eta]",
           FontWeight->Bold,
           FontColor->RGBColor[0.8, 0, 0]], "4", "+"]}], "+", 
        RowBox[{"432", " ", 
         RowBox[{"(", 
          RowBox[{"\[ImaginaryI]", "+", "u"}], ")"}], " ", 
         SubsuperscriptBox[
          StyleBox["\[Eta]",
           FontWeight->Bold,
           FontColor->RGBColor[0.8, 0, 0]], "5", "+"]}], "+", 
        RowBox[{"120", " ", 
         SubsuperscriptBox[
          StyleBox["\[Eta]",
           FontWeight->Bold,
           FontColor->RGBColor[0.8, 0, 0]], "6", "+"]}], "-", 
        RowBox[{"64800", " ", "\[ImaginaryI]", " ", "u", " ", 
         SubsuperscriptBox[
          StyleBox["\[Eta]",
           FontWeight->Bold,
           FontColor->RGBColor[0.8, 0, 0]], 
          RowBox[{"1", ",", "1"}], "+"]}], "-", 
        RowBox[{"15552", " ", "u", " ", 
         SubsuperscriptBox[
          StyleBox["\[Eta]",
           FontWeight->Bold,
           FontColor->RGBColor[0.8, 0, 0]], 
          RowBox[{"1", ",", "2"}], "+"]}], "+", 
        RowBox[{"2592", " ", "\[ImaginaryI]", " ", "u", " ", 
         SubsuperscriptBox[
          StyleBox["\[Eta]",
           FontWeight->Bold,
           FontColor->RGBColor[0.8, 0, 0]], 
          RowBox[{"1", ",", "3"}], "+"]}], "+", 
        RowBox[{
         SubsuperscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->RGBColor[0.8, 0, 0]], "1", "2"], " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"32400", " ", "\[ImaginaryI]", " ", "u"}], "+", 
           RowBox[{"15552", " ", "u", " ", 
            SubsuperscriptBox[
             StyleBox["\[Eta]",
              FontWeight->Bold,
              FontColor->RGBColor[0.8, 0, 0]], "1", "+"]}], "+", 
           RowBox[{"1728", " ", 
            SubsuperscriptBox[
             StyleBox["\[Eta]",
              FontWeight->Bold,
              FontColor->RGBColor[0.8, 0, 0]], "2", "+"]}], "+", 
           RowBox[{
            StyleBox["Q0",
             FontColor->RGBColor[{
                Rational[1, 2], 
                Rational[1, 2], 0}]], " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"16848", " ", 
               SubsuperscriptBox[
                StyleBox["\[Eta]",
                 FontWeight->Bold,
                 FontColor->RGBColor[0.8, 0, 0]], "2", "+"]}], "-", 
              RowBox[{"7776", " ", "\[ImaginaryI]", " ", 
               SubsuperscriptBox[
                StyleBox["\[Eta]",
                 FontWeight->Bold,
                 FontColor->RGBColor[0.8, 0, 0]], "3", "+"]}], "-", 
              RowBox[{"2592", " ", 
               SubsuperscriptBox[
                StyleBox["\[Eta]",
                 FontWeight->Bold,
                 FontColor->RGBColor[0.8, 0, 0]], "4", "+"]}], "-", 
              RowBox[{"15552", " ", "\[ImaginaryI]", " ", 
               SubsuperscriptBox[
                StyleBox["\[Eta]",
                 FontWeight->Bold,
                 FontColor->RGBColor[0.8, 0, 0]], 
                RowBox[{"2", ",", "1"}], "+"]}]}], ")"}]}]}], ")"}]}], "-", 
        RowBox[{"432", " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"5", " ", "\[ImaginaryI]"}], "+", 
           RowBox[{"36", " ", "u"}]}], ")"}], " ", 
         SubsuperscriptBox[
          StyleBox["\[Eta]",
           FontWeight->Bold,
           FontColor->RGBColor[0.8, 0, 0]], 
          RowBox[{"2", ",", "1"}], "+"]}], "-", 
        RowBox[{"1728", " ", 
         SubsuperscriptBox[
          StyleBox["\[Eta]",
           FontWeight->Bold,
           FontColor->RGBColor[0.8, 0, 0]], 
          RowBox[{"2", ",", "2"}], "+"]}], "+", 
        RowBox[{"288", " ", "\[ImaginaryI]", " ", 
         SubsuperscriptBox[
          StyleBox["\[Eta]",
           FontWeight->Bold,
           FontColor->RGBColor[0.8, 0, 0]], 
          RowBox[{"2", ",", "3"}], "+"]}], "+", 
        RowBox[{"864", " ", "\[ImaginaryI]", " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"2", " ", "\[ImaginaryI]"}], "+", 
           RowBox[{"3", " ", "u"}]}], ")"}], " ", 
         SubsuperscriptBox[
          StyleBox["\[Eta]",
           FontWeight->Bold,
           FontColor->RGBColor[0.8, 0, 0]], 
          RowBox[{"3", ",", "1"}], "+"]}], "+", 
        RowBox[{"576", " ", "\[ImaginaryI]", " ", 
         SubsuperscriptBox[
          StyleBox["\[Eta]",
           FontWeight->Bold,
           FontColor->RGBColor[0.8, 0, 0]], 
          RowBox[{"4", ",", "1"}], "+"]}], "-", 
        RowBox[{"31104", " ", "u", " ", 
         SubsuperscriptBox[
          StyleBox["\[Eta]",
           FontWeight->Bold,
           FontColor->RGBColor[0.8, 0, 0]], 
          RowBox[{"1", ",", "1", ",", "1"}], "+"]}], "+", 
        RowBox[{
         SubscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->RGBColor[0.8, 0, 0]], "1"], " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"648", " ", "\[ImaginaryI]", " ", "u", " ", 
            RowBox[{"(", 
             RowBox[{"113", "+", 
              RowBox[{"12", " ", 
               SubscriptBox[
                StyleBox["\[Zeta]",
                 FontWeight->Bold,
                 FontColor->RGBColor[0.8, 0, 0]], "3"]}]}], ")"}]}], "+", 
           RowBox[{"64800", " ", "u", " ", 
            SubsuperscriptBox[
             StyleBox["\[Eta]",
              FontWeight->Bold,
              FontColor->RGBColor[0.8, 0, 0]], "1", "+"]}], "+", 
           RowBox[{"432", " ", 
            RowBox[{"(", 
             RowBox[{"5", "-", 
              RowBox[{"36", " ", "\[ImaginaryI]", " ", "u"}]}], ")"}], " ", 
            SubsuperscriptBox[
             StyleBox["\[Eta]",
              FontWeight->Bold,
              FontColor->RGBColor[0.8, 0, 0]], "2", "+"]}], "-", 
           RowBox[{"864", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"2", " ", "\[ImaginaryI]"}], "+", 
              RowBox[{"3", " ", "u"}]}], ")"}], " ", 
            SubsuperscriptBox[
             StyleBox["\[Eta]",
              FontWeight->Bold,
              FontColor->RGBColor[0.8, 0, 0]], "3", "+"]}], "-", 
           RowBox[{"576", " ", 
            SubsuperscriptBox[
             StyleBox["\[Eta]",
              FontWeight->Bold,
              FontColor->RGBColor[0.8, 0, 0]], "4", "+"]}], "-", 
           RowBox[{"31104", " ", "\[ImaginaryI]", " ", "u", " ", 
            SubsuperscriptBox[
             StyleBox["\[Eta]",
              FontWeight->Bold,
              FontColor->RGBColor[0.8, 0, 0]], 
             RowBox[{"1", ",", "1"}], "+"]}], "-", 
           RowBox[{"3456", " ", "\[ImaginaryI]", " ", 
            SubsuperscriptBox[
             StyleBox["\[Eta]",
              FontWeight->Bold,
              FontColor->RGBColor[0.8, 0, 0]], 
             RowBox[{"2", ",", "1"}], "+"]}], "+", 
           RowBox[{
            StyleBox["Q0",
             FontColor->RGBColor[{
                Rational[1, 2], 
                Rational[1, 2], 0}]], " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"648", " ", 
               RowBox[{"(", 
                RowBox[{"13", "+", 
                 RowBox[{"12", " ", 
                  SubscriptBox[
                   StyleBox["\[Zeta]",
                    FontWeight->Bold,
                    FontColor->RGBColor[0.8, 0, 0]], "3"]}]}], ")"}], " ", 
               SubsuperscriptBox[
                StyleBox["\[Eta]",
                 FontWeight->Bold,
                 FontColor->RGBColor[0.8, 0, 0]], "2", "+"]}], "-", 
              RowBox[{"16848", " ", "\[ImaginaryI]", " ", 
               SubsuperscriptBox[
                StyleBox["\[Eta]",
                 FontWeight->Bold,
                 FontColor->RGBColor[0.8, 0, 0]], "3", "+"]}], "-", 
              RowBox[{"7776", " ", 
               SubsuperscriptBox[
                StyleBox["\[Eta]",
                 FontWeight->Bold,
                 FontColor->RGBColor[0.8, 0, 0]], "4", "+"]}], "+", 
              RowBox[{"3888", " ", "\[ImaginaryI]", " ", 
               SubsuperscriptBox[
                StyleBox["\[Eta]",
                 FontWeight->Bold,
                 FontColor->RGBColor[0.8, 0, 0]], "5", "+"]}], "+", 
              RowBox[{"1080", " ", 
               SubsuperscriptBox[
                StyleBox["\[Eta]",
                 FontWeight->Bold,
                 FontColor->RGBColor[0.8, 0, 0]], "6", "+"]}], "-", 
              RowBox[{"33696", " ", "\[ImaginaryI]", " ", 
               SubsuperscriptBox[
                StyleBox["\[Eta]",
                 FontWeight->Bold,
                 FontColor->RGBColor[0.8, 0, 0]], 
                RowBox[{"2", ",", "1"}], "+"]}], "-", 
              RowBox[{"15552", " ", 
               SubsuperscriptBox[
                StyleBox["\[Eta]",
                 FontWeight->Bold,
                 FontColor->RGBColor[0.8, 0, 0]], 
                RowBox[{"2", ",", "2"}], "+"]}], "+", 
              RowBox[{"2592", " ", "\[ImaginaryI]", " ", 
               SubsuperscriptBox[
                StyleBox["\[Eta]",
                 FontWeight->Bold,
                 FontColor->RGBColor[0.8, 0, 0]], 
                RowBox[{"2", ",", "3"}], "+"]}], "-", 
              RowBox[{"15552", " ", 
               SubsuperscriptBox[
                StyleBox["\[Eta]",
                 FontWeight->Bold,
                 FontColor->RGBColor[0.8, 0, 0]], 
                RowBox[{"3", ",", "1"}], "+"]}], "+", 
              RowBox[{"5184", " ", "\[ImaginaryI]", " ", 
               SubsuperscriptBox[
                StyleBox["\[Eta]",
                 FontWeight->Bold,
                 FontColor->RGBColor[0.8, 0, 0]], 
                RowBox[{"4", ",", "1"}], "+"]}], "-", 
              RowBox[{"31104", " ", 
               SubsuperscriptBox[
                StyleBox["\[Eta]",
                 FontWeight->Bold,
                 FontColor->RGBColor[0.8, 0, 0]], 
                RowBox[{"2", ",", "1", ",", "1"}], "+"]}]}], ")"}]}]}], 
          ")"}]}], "-", 
        RowBox[{"3456", " ", 
         SubsuperscriptBox[
          StyleBox["\[Eta]",
           FontWeight->Bold,
           FontColor->RGBColor[0.8, 0, 0]], 
          RowBox[{"2", ",", "1", ",", "1"}], "+"]}], "+", 
        RowBox[{
         StyleBox["Q0",
          FontColor->RGBColor[{
             Rational[1, 2], 
             Rational[1, 2], 0}]], " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"18", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "827"}], "+", 
              RowBox[{"444", " ", 
               SubscriptBox[
                StyleBox["\[Zeta]",
                 FontWeight->Bold,
                 FontColor->RGBColor[0.8, 0, 0]], "3"]}], "+", 
              RowBox[{"240", " ", 
               SubscriptBox[
                StyleBox["\[Zeta]",
                 FontWeight->Bold,
                 FontColor->RGBColor[0.8, 0, 0]], "5"]}]}], ")"}], " ", 
            SubsuperscriptBox[
             StyleBox["\[Eta]",
              FontWeight->Bold,
              FontColor->RGBColor[0.8, 0, 0]], "2", "+"]}], "-", 
           RowBox[{"324", " ", "\[ImaginaryI]", " ", 
            RowBox[{"(", 
             RowBox[{"13", "+", 
              RowBox[{"12", " ", 
               SubscriptBox[
                StyleBox["\[Zeta]",
                 FontWeight->Bold,
                 FontColor->RGBColor[0.8, 0, 0]], "3"]}]}], ")"}], " ", 
            SubsuperscriptBox[
             StyleBox["\[Eta]",
              FontWeight->Bold,
              FontColor->RGBColor[0.8, 0, 0]], "3", "+"]}], "-", 
           RowBox[{"432", " ", 
            RowBox[{"(", 
             RowBox[{"9", "+", 
              RowBox[{"4", " ", 
               SubscriptBox[
                StyleBox["\[Zeta]",
                 FontWeight->Bold,
                 FontColor->RGBColor[0.8, 0, 0]], "3"]}]}], ")"}], " ", 
            SubsuperscriptBox[
             StyleBox["\[Eta]",
              FontWeight->Bold,
              FontColor->RGBColor[0.8, 0, 0]], "4", "+"]}], "+", 
           RowBox[{"3564", " ", "\[ImaginaryI]", " ", 
            SubsuperscriptBox[
             StyleBox["\[Eta]",
              FontWeight->Bold,
              FontColor->RGBColor[0.8, 0, 0]], "5", "+"]}], "+", 
           RowBox[{"1746", " ", 
            SubsuperscriptBox[
             StyleBox["\[Eta]",
              FontWeight->Bold,
              FontColor->RGBColor[0.8, 0, 0]], "6", "+"]}], "-", 
           RowBox[{"972", " ", "\[ImaginaryI]", " ", 
            SubsuperscriptBox[
             StyleBox["\[Eta]",
              FontWeight->Bold,
              FontColor->RGBColor[0.8, 0, 0]], "7", "+"]}], "-", 
           RowBox[{"252", " ", 
            SubsuperscriptBox[
             StyleBox["\[Eta]",
              FontWeight->Bold,
              FontColor->RGBColor[0.8, 0, 0]], "8", "+"]}], "-", 
           RowBox[{"648", " ", "\[ImaginaryI]", " ", 
            RowBox[{"(", 
             RowBox[{"13", "+", 
              RowBox[{"12", " ", 
               SubscriptBox[
                StyleBox["\[Zeta]",
                 FontWeight->Bold,
                 FontColor->RGBColor[0.8, 0, 0]], "3"]}]}], ")"}], " ", 
            SubsuperscriptBox[
             StyleBox["\[Eta]",
              FontWeight->Bold,
              FontColor->RGBColor[0.8, 0, 0]], 
             RowBox[{"2", ",", "1"}], "+"]}], "-", 
           RowBox[{"16848", " ", 
            SubsuperscriptBox[
             StyleBox["\[Eta]",
              FontWeight->Bold,
              FontColor->RGBColor[0.8, 0, 0]], 
             RowBox[{"2", ",", "2"}], "+"]}], "+", 
           RowBox[{"7128", " ", "\[ImaginaryI]", " ", 
            SubsuperscriptBox[
             StyleBox["\[Eta]",
              FontWeight->Bold,
              FontColor->RGBColor[0.8, 0, 0]], 
             RowBox[{"2", ",", "3"}], "+"]}], "+", 
           RowBox[{"2592", " ", 
            SubsuperscriptBox[
             StyleBox["\[Eta]",
              FontWeight->Bold,
              FontColor->RGBColor[0.8, 0, 0]], 
             RowBox[{"2", ",", "4"}], "+"]}], "-", 
           RowBox[{"432", " ", "\[ImaginaryI]", " ", 
            SubsuperscriptBox[
             StyleBox["\[Eta]",
              FontWeight->Bold,
              FontColor->RGBColor[0.8, 0, 0]], 
             RowBox[{"2", ",", "5"}], "+"]}], "-", 
           RowBox[{"16848", " ", 
            SubsuperscriptBox[
             StyleBox["\[Eta]",
              FontWeight->Bold,
              FontColor->RGBColor[0.8, 0, 0]], 
             RowBox[{"3", ",", "1"}], "+"]}], "+", 
           RowBox[{"7776", " ", "\[ImaginaryI]", " ", 
            SubsuperscriptBox[
             StyleBox["\[Eta]",
              FontWeight->Bold,
              FontColor->RGBColor[0.8, 0, 0]], 
             RowBox[{"3", ",", "2"}], "+"]}], "+", 
           RowBox[{"1296", " ", 
            SubsuperscriptBox[
             StyleBox["\[Eta]",
              FontWeight->Bold,
              FontColor->RGBColor[0.8, 0, 0]], 
             RowBox[{"3", ",", "3"}], "+"]}], "+", 
           RowBox[{"7776", " ", "\[ImaginaryI]", " ", 
            SubsuperscriptBox[
             StyleBox["\[Eta]",
              FontWeight->Bold,
              FontColor->RGBColor[0.8, 0, 0]], 
             RowBox[{"4", ",", "1"}], "+"]}], "+", 
           RowBox[{"2592", " ", 
            SubsuperscriptBox[
             StyleBox["\[Eta]",
              FontWeight->Bold,
              FontColor->RGBColor[0.8, 0, 0]], 
             RowBox[{"4", ",", "2"}], "+"]}], "-", 
           RowBox[{"432", " ", "\[ImaginaryI]", " ", 
            SubsuperscriptBox[
             StyleBox["\[Eta]",
              FontWeight->Bold,
              FontColor->RGBColor[0.8, 0, 0]], 
             RowBox[{"4", ",", "3"}], "+"]}], "+", 
           RowBox[{"3888", " ", 
            SubsuperscriptBox[
             StyleBox["\[Eta]",
              FontWeight->Bold,
              FontColor->RGBColor[0.8, 0, 0]], 
             RowBox[{"5", ",", "1"}], "+"]}], "-", 
           RowBox[{"1080", " ", "\[ImaginaryI]", " ", 
            SubsuperscriptBox[
             StyleBox["\[Eta]",
              FontWeight->Bold,
              FontColor->RGBColor[0.8, 0, 0]], 
             RowBox[{"6", ",", "1"}], "+"]}], "-", 
           RowBox[{"33696", " ", 
            SubsuperscriptBox[
             StyleBox["\[Eta]",
              FontWeight->Bold,
              FontColor->RGBColor[0.8, 0, 0]], 
             RowBox[{"2", ",", "1", ",", "1"}], "+"]}], "+", 
           RowBox[{"15552", " ", "\[ImaginaryI]", " ", 
            SubsuperscriptBox[
             StyleBox["\[Eta]",
              FontWeight->Bold,
              FontColor->RGBColor[0.8, 0, 0]], 
             RowBox[{"2", ",", "1", ",", "2"}], "+"]}], "+", 
           RowBox[{"2592", " ", 
            SubsuperscriptBox[
             StyleBox["\[Eta]",
              FontWeight->Bold,
              FontColor->RGBColor[0.8, 0, 0]], 
             RowBox[{"2", ",", "1", ",", "3"}], "+"]}], "+", 
           RowBox[{"15552", " ", "\[ImaginaryI]", " ", 
            SubsuperscriptBox[
             StyleBox["\[Eta]",
              FontWeight->Bold,
              FontColor->RGBColor[0.8, 0, 0]], 
             RowBox[{"2", ",", "2", ",", "1"}], "+"]}], "+", 
           RowBox[{"2592", " ", 
            SubsuperscriptBox[
             StyleBox["\[Eta]",
              FontWeight->Bold,
              FontColor->RGBColor[0.8, 0, 0]], 
             RowBox[{"2", ",", "3", ",", "1"}], "+"]}], "+", 
           RowBox[{"15552", " ", "\[ImaginaryI]", " ", 
            SubsuperscriptBox[
             StyleBox["\[Eta]",
              FontWeight->Bold,
              FontColor->RGBColor[0.8, 0, 0]], 
             RowBox[{"3", ",", "1", ",", "1"}], "+"]}], "+", 
           RowBox[{"5184", " ", 
            SubsuperscriptBox[
             StyleBox["\[Eta]",
              FontWeight->Bold,
              FontColor->RGBColor[0.8, 0, 0]], 
             RowBox[{"4", ",", "1", ",", "1"}], "+"]}], "+", 
           RowBox[{"31104", " ", "\[ImaginaryI]", " ", 
            SubsuperscriptBox[
             StyleBox["\[Eta]",
              FontWeight->Bold,
              FontColor->RGBColor[0.8, 0, 0]], 
             RowBox[{"2", ",", "1", ",", "1", ",", "1"}], "+"]}]}], ")"}]}]}],
        ")"}]}]}]}], ",", 
   RowBox[{
    SubscriptBox[
     StyleBox["q",
      FontColor->RGBColor[0, 0, 0.8]], 
     RowBox[{"1", ",", "4"}]], "\[Rule]", 
    RowBox[{
     RowBox[{
      SuperscriptBox["g", "4"], " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "3"}], "+", 
        RowBox[{"6", " ", "\[ImaginaryI]", " ", 
         StyleBox["Q0",
          FontColor->RGBColor[{
             Rational[1, 2], 
             Rational[1, 2], 0}]], " ", 
         SubsuperscriptBox[
          StyleBox["\[Eta]",
           FontWeight->Bold,
           FontColor->RGBColor[0.8, 0, 0]], "3", "+"]}]}], ")"}]}], "+", 
     RowBox[{
      SuperscriptBox["g", "6"], " ", 
      RowBox[{"(", 
       RowBox[{"12", "-", 
        RowBox[{"36", " ", "\[ImaginaryI]", " ", 
         SubsuperscriptBox[
          StyleBox["\[Eta]",
           FontWeight->Bold,
           FontColor->RGBColor[0.8, 0, 0]], "1", "+"]}], "-", 
        RowBox[{"8", " ", "\[ImaginaryI]", " ", 
         SubsuperscriptBox[
          StyleBox["\[Eta]",
           FontWeight->Bold,
           FontColor->RGBColor[0.8, 0, 0]], "3", "+"]}], "+", 
        RowBox[{
         SubscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->RGBColor[0.8, 0, 0]], "1"], " ", 
         RowBox[{"(", 
          RowBox[{"36", "-", 
           RowBox[{"72", " ", "\[ImaginaryI]", " ", 
            StyleBox["Q0",
             FontColor->RGBColor[{
                Rational[1, 2], 
                Rational[1, 2], 0}]], " ", 
            SubsuperscriptBox[
             StyleBox["\[Eta]",
              FontWeight->Bold,
              FontColor->RGBColor[0.8, 0, 0]], "3", "+"]}]}], ")"}]}], "+", 
        RowBox[{
         StyleBox["Q0",
          FontColor->RGBColor[{
             Rational[1, 2], 
             Rational[1, 2], 0}]], " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"12", " ", "\[ImaginaryI]", " ", 
            SubsuperscriptBox[
             StyleBox["\[Eta]",
              FontWeight->Bold,
              FontColor->RGBColor[0.8, 0, 0]], "3", "+"]}], "-", 
           RowBox[{"36", " ", 
            SubsuperscriptBox[
             StyleBox["\[Eta]",
              FontWeight->Bold,
              FontColor->RGBColor[0.8, 0, 0]], "4", "+"]}], "+", 
           RowBox[{"18", " ", "\[ImaginaryI]", " ", 
            SubsuperscriptBox[
             StyleBox["\[Eta]",
              FontWeight->Bold,
              FontColor->RGBColor[0.8, 0, 0]], "5", "+"]}], "-", 
           RowBox[{"72", " ", 
            SubsuperscriptBox[
             StyleBox["\[Eta]",
              FontWeight->Bold,
              FontColor->RGBColor[0.8, 0, 0]], 
             RowBox[{"3", ",", "1"}], "+"]}]}], ")"}]}]}], ")"}]}], "+", 
     RowBox[{
      SuperscriptBox["g", "8"], " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         RowBox[{"-", "12"}], " ", 
         RowBox[{"(", 
          RowBox[{"7", "+", 
           RowBox[{"9", " ", 
            SubscriptBox[
             StyleBox["\[Zeta]",
              FontWeight->Bold,
              FontColor->RGBColor[0.8, 0, 0]], "3"]}]}], ")"}]}], "+", 
        RowBox[{"288", " ", "\[ImaginaryI]", " ", 
         SubsuperscriptBox[
          StyleBox["\[Eta]",
           FontWeight->Bold,
           FontColor->RGBColor[0.8, 0, 0]], "1", "+"]}], "+", 
        RowBox[{"216", " ", 
         SubsuperscriptBox[
          StyleBox["\[Eta]",
           FontWeight->Bold,
           FontColor->RGBColor[0.8, 0, 0]], "2", "+"]}], "-", 
        RowBox[{"64", " ", "\[ImaginaryI]", " ", 
         SubsuperscriptBox[
          StyleBox["\[Eta]",
           FontWeight->Bold,
           FontColor->RGBColor[0.8, 0, 0]], "3", "+"]}], "+", 
        RowBox[{
         SubsuperscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->RGBColor[0.8, 0, 0]], "1", "2"], " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"-", "216"}], "+", 
           RowBox[{"432", " ", "\[ImaginaryI]", " ", 
            StyleBox["Q0",
             FontColor->RGBColor[{
                Rational[1, 2], 
                Rational[1, 2], 0}]], " ", 
            SubsuperscriptBox[
             StyleBox["\[Eta]",
              FontWeight->Bold,
              FontColor->RGBColor[0.8, 0, 0]], "3", "+"]}]}], ")"}]}], "+", 
        RowBox[{"48", " ", 
         SubsuperscriptBox[
          StyleBox["\[Eta]",
           FontWeight->Bold,
           FontColor->RGBColor[0.8, 0, 0]], "4", "+"]}], "-", 
        RowBox[{"24", " ", "\[ImaginaryI]", " ", 
         SubsuperscriptBox[
          StyleBox["\[Eta]",
           FontWeight->Bold,
           FontColor->RGBColor[0.8, 0, 0]], "5", "+"]}], "+", 
        RowBox[{"432", " ", 
         SubsuperscriptBox[
          StyleBox["\[Eta]",
           FontWeight->Bold,
           FontColor->RGBColor[0.8, 0, 0]], 
          RowBox[{"1", ",", "1"}], "+"]}], "+", 
        RowBox[{"96", " ", 
         SubsuperscriptBox[
          StyleBox["\[Eta]",
           FontWeight->Bold,
           FontColor->RGBColor[0.8, 0, 0]], 
          RowBox[{"3", ",", "1"}], "+"]}], "+", 
        RowBox[{
         SubscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->RGBColor[0.8, 0, 0]], "1"], " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"-", "288"}], "+", 
           RowBox[{"432", " ", "\[ImaginaryI]", " ", 
            SubsuperscriptBox[
             StyleBox["\[Eta]",
              FontWeight->Bold,
              FontColor->RGBColor[0.8, 0, 0]], "1", "+"]}], "+", 
           RowBox[{"96", " ", "\[ImaginaryI]", " ", 
            SubsuperscriptBox[
             StyleBox["\[Eta]",
              FontWeight->Bold,
              FontColor->RGBColor[0.8, 0, 0]], "3", "+"]}], "+", 
           RowBox[{
            StyleBox["Q0",
             FontColor->RGBColor[{
                Rational[1, 2], 
                Rational[1, 2], 0}]], " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"144", " ", "\[ImaginaryI]", " ", 
               SubsuperscriptBox[
                StyleBox["\[Eta]",
                 FontWeight->Bold,
                 FontColor->RGBColor[0.8, 0, 0]], "3", "+"]}], "+", 
              RowBox[{"432", " ", 
               SubsuperscriptBox[
                StyleBox["\[Eta]",
                 FontWeight->Bold,
                 FontColor->RGBColor[0.8, 0, 0]], "4", "+"]}], "-", 
              RowBox[{"216", " ", "\[ImaginaryI]", " ", 
               SubsuperscriptBox[
                StyleBox["\[Eta]",
                 FontWeight->Bold,
                 FontColor->RGBColor[0.8, 0, 0]], "5", "+"]}], "+", 
              RowBox[{"864", " ", 
               SubsuperscriptBox[
                StyleBox["\[Eta]",
                 FontWeight->Bold,
                 FontColor->RGBColor[0.8, 0, 0]], 
                RowBox[{"3", ",", "1"}], "+"]}]}], ")"}]}]}], ")"}]}], "+", 
        RowBox[{
         StyleBox["Q0",
          FontColor->RGBColor[{
             Rational[1, 2], 
             Rational[1, 2], 0}]], " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"24", " ", "\[ImaginaryI]", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "5"}], "+", 
              RowBox[{"9", " ", 
               SubscriptBox[
                StyleBox["\[Zeta]",
                 FontWeight->Bold,
                 FontColor->RGBColor[0.8, 0, 0]], "3"]}]}], ")"}], " ", 
            SubsuperscriptBox[
             StyleBox["\[Eta]",
              FontWeight->Bold,
              FontColor->RGBColor[0.8, 0, 0]], "3", "+"]}], "+", 
           RowBox[{"72", " ", 
            SubsuperscriptBox[
             StyleBox["\[Eta]",
              FontWeight->Bold,
              FontColor->RGBColor[0.8, 0, 0]], "4", "+"]}], "-", 
           RowBox[{"72", " ", "\[ImaginaryI]", " ", 
            SubsuperscriptBox[
             StyleBox["\[Eta]",
              FontWeight->Bold,
              FontColor->RGBColor[0.8, 0, 0]], "5", "+"]}], "-", 
           RowBox[{"144", " ", 
            SubsuperscriptBox[
             StyleBox["\[Eta]",
              FontWeight->Bold,
              FontColor->RGBColor[0.8, 0, 0]], "6", "+"]}], "+", 
           RowBox[{"54", " ", "\[ImaginaryI]", " ", 
            SubsuperscriptBox[
             StyleBox["\[Eta]",
              FontWeight->Bold,
              FontColor->RGBColor[0.8, 0, 0]], "7", "+"]}], "+", 
           RowBox[{"144", " ", 
            SubsuperscriptBox[
             StyleBox["\[Eta]",
              FontWeight->Bold,
              FontColor->RGBColor[0.8, 0, 0]], 
             RowBox[{"3", ",", "1"}], "+"]}], "-", 
           RowBox[{"432", " ", "\[ImaginaryI]", " ", 
            SubsuperscriptBox[
             StyleBox["\[Eta]",
              FontWeight->Bold,
              FontColor->RGBColor[0.8, 0, 0]], 
             RowBox[{"3", ",", "2"}], "+"]}], "-", 
           RowBox[{"72", " ", 
            SubsuperscriptBox[
             StyleBox["\[Eta]",
              FontWeight->Bold,
              FontColor->RGBColor[0.8, 0, 0]], 
             RowBox[{"3", ",", "3"}], "+"]}], "-", 
           RowBox[{"432", " ", "\[ImaginaryI]", " ", 
            SubsuperscriptBox[
             StyleBox["\[Eta]",
              FontWeight->Bold,
              FontColor->RGBColor[0.8, 0, 0]], 
             RowBox[{"4", ",", "1"}], "+"]}], "-", 
           RowBox[{"216", " ", 
            SubsuperscriptBox[
             StyleBox["\[Eta]",
              FontWeight->Bold,
              FontColor->RGBColor[0.8, 0, 0]], 
             RowBox[{"5", ",", "1"}], "+"]}], "-", 
           RowBox[{"864", " ", "\[ImaginaryI]", " ", 
            SubsuperscriptBox[
             StyleBox["\[Eta]",
              FontWeight->Bold,
              FontColor->RGBColor[0.8, 0, 0]], 
             RowBox[{"3", ",", "1", ",", "1"}], "+"]}]}], ")"}]}]}], ")"}]}], 
     "+", 
     RowBox[{
      SuperscriptBox["g", "10"], " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"24", " ", 
         RowBox[{"(", 
          RowBox[{"26", "+", 
           RowBox[{"39", " ", 
            SubscriptBox[
             StyleBox["\[Zeta]",
              FontWeight->Bold,
              FontColor->RGBColor[0.8, 0, 0]], "3"]}], "+", 
           RowBox[{"30", " ", 
            SubscriptBox[
             StyleBox["\[Zeta]",
              FontWeight->Bold,
              FontColor->RGBColor[0.8, 0, 0]], "5"]}]}], ")"}]}], "-", 
        RowBox[{"1296", " ", "\[ImaginaryI]", " ", 
         RowBox[{"(", 
          RowBox[{"2", "+", 
           SubscriptBox[
            StyleBox["\[Zeta]",
             FontWeight->Bold,
             FontColor->RGBColor[0.8, 0, 0]], "3"]}], ")"}], " ", 
         SubsuperscriptBox[
          StyleBox["\[Eta]",
           FontWeight->Bold,
           FontColor->RGBColor[0.8, 0, 0]], "1", "+"]}], "-", 
        RowBox[{"2592", " ", 
         SubsuperscriptBox[
          StyleBox["\[Eta]",
           FontWeight->Bold,
           FontColor->RGBColor[0.8, 0, 0]], "2", "+"]}], "-", 
        RowBox[{"8", " ", "\[ImaginaryI]", " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"-", "167"}], "+", 
           RowBox[{"42", " ", 
            SubscriptBox[
             StyleBox["\[Zeta]",
              FontWeight->Bold,
              FontColor->RGBColor[0.8, 0, 0]], "3"]}]}], ")"}], " ", 
         SubsuperscriptBox[
          StyleBox["\[Eta]",
           FontWeight->Bold,
           FontColor->RGBColor[0.8, 0, 0]], "3", "+"]}], "+", 
        RowBox[{
         SubsuperscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->RGBColor[0.8, 0, 0]], "1", "3"], " ", 
         RowBox[{"(", 
          RowBox[{"864", "-", 
           RowBox[{"1728", " ", "\[ImaginaryI]", " ", 
            StyleBox["Q0",
             FontColor->RGBColor[{
                Rational[1, 2], 
                Rational[1, 2], 0}]], " ", 
            SubsuperscriptBox[
             StyleBox["\[Eta]",
              FontWeight->Bold,
              FontColor->RGBColor[0.8, 0, 0]], "3", "+"]}]}], ")"}]}], "+", 
        RowBox[{"408", " ", 
         SubsuperscriptBox[
          StyleBox["\[Eta]",
           FontWeight->Bold,
           FontColor->RGBColor[0.8, 0, 0]], "4", "+"]}], "-", 
        RowBox[{"12", " ", "\[ImaginaryI]", " ", 
         SubsuperscriptBox[
          StyleBox["\[Eta]",
           FontWeight->Bold,
           FontColor->RGBColor[0.8, 0, 0]], "5", "+"]}], "+", 
        RowBox[{"192", " ", 
         SubsuperscriptBox[
          StyleBox["\[Eta]",
           FontWeight->Bold,
           FontColor->RGBColor[0.8, 0, 0]], "6", "+"]}], "-", 
        RowBox[{"72", " ", "\[ImaginaryI]", " ", 
         SubsuperscriptBox[
          StyleBox["\[Eta]",
           FontWeight->Bold,
           FontColor->RGBColor[0.8, 0, 0]], "7", "+"]}], "-", 
        RowBox[{"5184", " ", 
         SubsuperscriptBox[
          StyleBox["\[Eta]",
           FontWeight->Bold,
           FontColor->RGBColor[0.8, 0, 0]], 
          RowBox[{"1", ",", "1"}], "+"]}], "+", 
        RowBox[{"2592", " ", "\[ImaginaryI]", " ", 
         SubsuperscriptBox[
          StyleBox["\[Eta]",
           FontWeight->Bold,
           FontColor->RGBColor[0.8, 0, 0]], 
          RowBox[{"1", ",", "2"}], "+"]}], "+", 
        RowBox[{"432", " ", 
         SubsuperscriptBox[
          StyleBox["\[Eta]",
           FontWeight->Bold,
           FontColor->RGBColor[0.8, 0, 0]], 
          RowBox[{"1", ",", "3"}], "+"]}], "+", 
        RowBox[{"2592", " ", "\[ImaginaryI]", " ", 
         SubsuperscriptBox[
          StyleBox["\[Eta]",
           FontWeight->Bold,
           FontColor->RGBColor[0.8, 0, 0]], 
          RowBox[{"2", ",", "1"}], "+"]}], "+", 
        RowBox[{
         SubsuperscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->RGBColor[0.8, 0, 0]], "1", "2"], " ", 
         RowBox[{"(", 
          RowBox[{"2592", "-", 
           RowBox[{"2592", " ", "\[ImaginaryI]", " ", 
            SubsuperscriptBox[
             StyleBox["\[Eta]",
              FontWeight->Bold,
              FontColor->RGBColor[0.8, 0, 0]], "1", "+"]}], "-", 
           RowBox[{"576", " ", "\[ImaginaryI]", " ", 
            SubsuperscriptBox[
             StyleBox["\[Eta]",
              FontWeight->Bold,
              FontColor->RGBColor[0.8, 0, 0]], "3", "+"]}], "+", 
           RowBox[{
            StyleBox["Q0",
             FontColor->RGBColor[{
                Rational[1, 2], 
                Rational[1, 2], 0}]], " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{
               RowBox[{"-", "2592"}], " ", "\[ImaginaryI]", " ", 
               SubsuperscriptBox[
                StyleBox["\[Eta]",
                 FontWeight->Bold,
                 FontColor->RGBColor[0.8, 0, 0]], "3", "+"]}], "-", 
              RowBox[{"2592", " ", 
               SubsuperscriptBox[
                StyleBox["\[Eta]",
                 FontWeight->Bold,
                 FontColor->RGBColor[0.8, 0, 0]], "4", "+"]}], "+", 
              RowBox[{"1296", " ", "\[ImaginaryI]", " ", 
               SubsuperscriptBox[
                StyleBox["\[Eta]",
                 FontWeight->Bold,
                 FontColor->RGBColor[0.8, 0, 0]], "5", "+"]}], "-", 
              RowBox[{"5184", " ", 
               SubsuperscriptBox[
                StyleBox["\[Eta]",
                 FontWeight->Bold,
                 FontColor->RGBColor[0.8, 0, 0]], 
                RowBox[{"3", ",", "1"}], "+"]}]}], ")"}]}]}], ")"}]}], "+", 
        RowBox[{"384", " ", 
         SubsuperscriptBox[
          StyleBox["\[Eta]",
           FontWeight->Bold,
           FontColor->RGBColor[0.8, 0, 0]], 
          RowBox[{"3", ",", "1"}], "+"]}], "+", 
        RowBox[{"576", " ", "\[ImaginaryI]", " ", 
         SubsuperscriptBox[
          StyleBox["\[Eta]",
           FontWeight->Bold,
           FontColor->RGBColor[0.8, 0, 0]], 
          RowBox[{"3", ",", "2"}], "+"]}], "+", 
        RowBox[{"96", " ", 
         SubsuperscriptBox[
          StyleBox["\[Eta]",
           FontWeight->Bold,
           FontColor->RGBColor[0.8, 0, 0]], 
          RowBox[{"3", ",", "3"}], "+"]}], "+", 
        RowBox[{"576", " ", "\[ImaginaryI]", " ", 
         SubsuperscriptBox[
          StyleBox["\[Eta]",
           FontWeight->Bold,
           FontColor->RGBColor[0.8, 0, 0]], 
          RowBox[{"4", ",", "1"}], "+"]}], "+", 
        RowBox[{"288", " ", 
         SubsuperscriptBox[
          StyleBox["\[Eta]",
           FontWeight->Bold,
           FontColor->RGBColor[0.8, 0, 0]], 
          RowBox[{"5", ",", "1"}], "+"]}], "+", 
        RowBox[{"5184", " ", "\[ImaginaryI]", " ", 
         SubsuperscriptBox[
          StyleBox["\[Eta]",
           FontWeight->Bold,
           FontColor->RGBColor[0.8, 0, 0]], 
          RowBox[{"1", ",", "1", ",", "1"}], "+"]}], "+", 
        RowBox[{
         SubscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->RGBColor[0.8, 0, 0]], "1"], " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"1296", " ", 
            RowBox[{"(", 
             RowBox[{"2", "+", 
              SubscriptBox[
               StyleBox["\[Zeta]",
                FontWeight->Bold,
                FontColor->RGBColor[0.8, 0, 0]], "3"]}], ")"}]}], "-", 
           RowBox[{"5184", " ", "\[ImaginaryI]", " ", 
            SubsuperscriptBox[
             StyleBox["\[Eta]",
              FontWeight->Bold,
              FontColor->RGBColor[0.8, 0, 0]], "1", "+"]}], "-", 
           RowBox[{"2592", " ", 
            SubsuperscriptBox[
             StyleBox["\[Eta]",
              FontWeight->Bold,
              FontColor->RGBColor[0.8, 0, 0]], "2", "+"]}], "+", 
           RowBox[{"384", " ", "\[ImaginaryI]", " ", 
            SubsuperscriptBox[
             StyleBox["\[Eta]",
              FontWeight->Bold,
              FontColor->RGBColor[0.8, 0, 0]], "3", "+"]}], "-", 
           RowBox[{"576", " ", 
            SubsuperscriptBox[
             StyleBox["\[Eta]",
              FontWeight->Bold,
              FontColor->RGBColor[0.8, 0, 0]], "4", "+"]}], "+", 
           RowBox[{"288", " ", "\[ImaginaryI]", " ", 
            SubsuperscriptBox[
             StyleBox["\[Eta]",
              FontWeight->Bold,
              FontColor->RGBColor[0.8, 0, 0]], "5", "+"]}], "-", 
           RowBox[{"5184", " ", 
            SubsuperscriptBox[
             StyleBox["\[Eta]",
              FontWeight->Bold,
              FontColor->RGBColor[0.8, 0, 0]], 
             RowBox[{"1", ",", "1"}], "+"]}], "-", 
           RowBox[{"1152", " ", 
            SubsuperscriptBox[
             StyleBox["\[Eta]",
              FontWeight->Bold,
              FontColor->RGBColor[0.8, 0, 0]], 
             RowBox[{"3", ",", "1"}], "+"]}], "+", 
           RowBox[{
            StyleBox["Q0",
             FontColor->RGBColor[{
                Rational[1, 2], 
                Rational[1, 2], 0}]], " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{
               RowBox[{"-", "2592"}], " ", "\[ImaginaryI]", " ", 
               SubscriptBox[
                StyleBox["\[Zeta]",
                 FontWeight->Bold,
                 FontColor->RGBColor[0.8, 0, 0]], "3"], " ", 
               SubsuperscriptBox[
                StyleBox["\[Eta]",
                 FontWeight->Bold,
                 FontColor->RGBColor[0.8, 0, 0]], "3", "+"]}], "-", 
              RowBox[{"2592", " ", 
               SubsuperscriptBox[
                StyleBox["\[Eta]",
                 FontWeight->Bold,
                 FontColor->RGBColor[0.8, 0, 0]], "4", "+"]}], "+", 
              RowBox[{"1728", " ", "\[ImaginaryI]", " ", 
               SubsuperscriptBox[
                StyleBox["\[Eta]",
                 FontWeight->Bold,
                 FontColor->RGBColor[0.8, 0, 0]], "5", "+"]}], "+", 
              RowBox[{"1728", " ", 
               SubsuperscriptBox[
                StyleBox["\[Eta]",
                 FontWeight->Bold,
                 FontColor->RGBColor[0.8, 0, 0]], "6", "+"]}], "-", 
              RowBox[{"648", " ", "\[ImaginaryI]", " ", 
               SubsuperscriptBox[
                StyleBox["\[Eta]",
                 FontWeight->Bold,
                 FontColor->RGBColor[0.8, 0, 0]], "7", "+"]}], "-", 
              RowBox[{"5184", " ", 
               SubsuperscriptBox[
                StyleBox["\[Eta]",
                 FontWeight->Bold,
                 FontColor->RGBColor[0.8, 0, 0]], 
                RowBox[{"3", ",", "1"}], "+"]}], "+", 
              RowBox[{"5184", " ", "\[ImaginaryI]", " ", 
               SubsuperscriptBox[
                StyleBox["\[Eta]",
                 FontWeight->Bold,
                 FontColor->RGBColor[0.8, 0, 0]], 
                RowBox[{"3", ",", "2"}], "+"]}], "+", 
              RowBox[{"864", " ", 
               SubsuperscriptBox[
                StyleBox["\[Eta]",
                 FontWeight->Bold,
                 FontColor->RGBColor[0.8, 0, 0]], 
                RowBox[{"3", ",", "3"}], "+"]}], "+", 
              RowBox[{"5184", " ", "\[ImaginaryI]", " ", 
               SubsuperscriptBox[
                StyleBox["\[Eta]",
                 FontWeight->Bold,
                 FontColor->RGBColor[0.8, 0, 0]], 
                RowBox[{"4", ",", "1"}], "+"]}], "+", 
              RowBox[{"2592", " ", 
               SubsuperscriptBox[
                StyleBox["\[Eta]",
                 FontWeight->Bold,
                 FontColor->RGBColor[0.8, 0, 0]], 
                RowBox[{"5", ",", "1"}], "+"]}], "+", 
              RowBox[{"10368", " ", "\[ImaginaryI]", " ", 
               SubsuperscriptBox[
                StyleBox["\[Eta]",
                 FontWeight->Bold,
                 FontColor->RGBColor[0.8, 0, 0]], 
                RowBox[{"3", ",", "1", ",", "1"}], "+"]}]}], ")"}]}]}], 
          ")"}]}], "+", 
        RowBox[{"1152", " ", "\[ImaginaryI]", " ", 
         SubsuperscriptBox[
          StyleBox["\[Eta]",
           FontWeight->Bold,
           FontColor->RGBColor[0.8, 0, 0]], 
          RowBox[{"3", ",", "1", ",", "1"}], "+"]}], "+", 
        RowBox[{
         StyleBox["Q0",
          FontColor->RGBColor[{
             Rational[1, 2], 
             Rational[1, 2], 0}]], " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{
            RowBox[{"-", "96"}], " ", "\[ImaginaryI]", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "14"}], "+", 
              RowBox[{"6", " ", 
               SubscriptBox[
                StyleBox["\[Zeta]",
                 FontWeight->Bold,
                 FontColor->RGBColor[0.8, 0, 0]], "3"]}], "+", 
              RowBox[{"15", " ", 
               SubscriptBox[
                StyleBox["\[Zeta]",
                 FontWeight->Bold,
                 FontColor->RGBColor[0.8, 0, 0]], "5"]}]}], ")"}], " ", 
            SubsuperscriptBox[
             StyleBox["\[Eta]",
              FontWeight->Bold,
              FontColor->RGBColor[0.8, 0, 0]], "3", "+"]}], "-", 
           RowBox[{"1296", " ", 
            SubscriptBox[
             StyleBox["\[Zeta]",
              FontWeight->Bold,
              FontColor->RGBColor[0.8, 0, 0]], "3"], " ", 
            SubsuperscriptBox[
             StyleBox["\[Eta]",
              FontWeight->Bold,
              FontColor->RGBColor[0.8, 0, 0]], "4", "+"]}], "+", 
           RowBox[{"72", " ", "\[ImaginaryI]", " ", 
            RowBox[{"(", 
             RowBox[{"4", "+", 
              RowBox[{"11", " ", 
               SubscriptBox[
                StyleBox["\[Zeta]",
                 FontWeight->Bold,
                 FontColor->RGBColor[0.8, 0, 0]], "3"]}]}], ")"}], " ", 
            SubsuperscriptBox[
             StyleBox["\[Eta]",
              FontWeight->Bold,
              FontColor->RGBColor[0.8, 0, 0]], "5", "+"]}], "+", 
           RowBox[{"504", " ", 
            SubsuperscriptBox[
             StyleBox["\[Eta]",
              FontWeight->Bold,
              FontColor->RGBColor[0.8, 0, 0]], "6", "+"]}], "-", 
           RowBox[{"432", " ", "\[ImaginaryI]", " ", 
            SubsuperscriptBox[
             StyleBox["\[Eta]",
              FontWeight->Bold,
              FontColor->RGBColor[0.8, 0, 0]], "7", "+"]}], "-", 
           RowBox[{"504", " ", 
            SubsuperscriptBox[
             StyleBox["\[Eta]",
              FontWeight->Bold,
              FontColor->RGBColor[0.8, 0, 0]], "8", "+"]}], "+", 
           RowBox[{"168", " ", "\[ImaginaryI]", " ", 
            SubsuperscriptBox[
             StyleBox["\[Eta]",
              FontWeight->Bold,
              FontColor->RGBColor[0.8, 0, 0]], "9", "+"]}], "-", 
           RowBox[{"2592", " ", 
            SubscriptBox[
             StyleBox["\[Zeta]",
              FontWeight->Bold,
              FontColor->RGBColor[0.8, 0, 0]], "3"], " ", 
            SubsuperscriptBox[
             StyleBox["\[Eta]",
              FontWeight->Bold,
              FontColor->RGBColor[0.8, 0, 0]], 
             RowBox[{"3", ",", "1"}], "+"]}], "+", 
           RowBox[{"2592", " ", "\[ImaginaryI]", " ", 
            SubsuperscriptBox[
             StyleBox["\[Eta]",
              FontWeight->Bold,
              FontColor->RGBColor[0.8, 0, 0]], 
             RowBox[{"3", ",", "2"}], "+"]}], "+", 
           RowBox[{"1872", " ", 
            SubsuperscriptBox[
             StyleBox["\[Eta]",
              FontWeight->Bold,
              FontColor->RGBColor[0.8, 0, 0]], 
             RowBox[{"3", ",", "3"}], "+"]}], "-", 
           RowBox[{"864", " ", "\[ImaginaryI]", " ", 
            SubsuperscriptBox[
             StyleBox["\[Eta]",
              FontWeight->Bold,
              FontColor->RGBColor[0.8, 0, 0]], 
             RowBox[{"3", ",", "4"}], "+"]}], "-", 
           RowBox[{"144", " ", 
            SubsuperscriptBox[
             StyleBox["\[Eta]",
              FontWeight->Bold,
              FontColor->RGBColor[0.8, 0, 0]], 
             RowBox[{"3", ",", "5"}], "+"]}], "+", 
           RowBox[{"2592", " ", "\[ImaginaryI]", " ", 
            SubsuperscriptBox[
             StyleBox["\[Eta]",
              FontWeight->Bold,
              FontColor->RGBColor[0.8, 0, 0]], 
             RowBox[{"4", ",", "1"}], "+"]}], "+", 
           RowBox[{"2592", " ", 
            SubsuperscriptBox[
             StyleBox["\[Eta]",
              FontWeight->Bold,
              FontColor->RGBColor[0.8, 0, 0]], 
             RowBox[{"4", ",", "2"}], "+"]}], "-", 
           RowBox[{"432", " ", "\[ImaginaryI]", " ", 
            SubsuperscriptBox[
             StyleBox["\[Eta]",
              FontWeight->Bold,
              FontColor->RGBColor[0.8, 0, 0]], 
             RowBox[{"4", ",", "3"}], "+"]}], "+", 
           RowBox[{"1728", " ", 
            SubsuperscriptBox[
             StyleBox["\[Eta]",
              FontWeight->Bold,
              FontColor->RGBColor[0.8, 0, 0]], 
             RowBox[{"5", ",", "1"}], "+"]}], "-", 
           RowBox[{"1296", " ", "\[ImaginaryI]", " ", 
            SubsuperscriptBox[
             StyleBox["\[Eta]",
              FontWeight->Bold,
              FontColor->RGBColor[0.8, 0, 0]], 
             RowBox[{"5", ",", "2"}], "+"]}], "-", 
           RowBox[{"216", " ", 
            SubsuperscriptBox[
             StyleBox["\[Eta]",
              FontWeight->Bold,
              FontColor->RGBColor[0.8, 0, 0]], 
             RowBox[{"5", ",", "3"}], "+"]}], "-", 
           RowBox[{"1728", " ", "\[ImaginaryI]", " ", 
            SubsuperscriptBox[
             StyleBox["\[Eta]",
              FontWeight->Bold,
              FontColor->RGBColor[0.8, 0, 0]], 
             RowBox[{"6", ",", "1"}], "+"]}], "-", 
           RowBox[{"648", " ", 
            SubsuperscriptBox[
             StyleBox["\[Eta]",
              FontWeight->Bold,
              FontColor->RGBColor[0.8, 0, 0]], 
             RowBox[{"7", ",", "1"}], "+"]}], "+", 
           RowBox[{"5184", " ", "\[ImaginaryI]", " ", 
            SubsuperscriptBox[
             StyleBox["\[Eta]",
              FontWeight->Bold,
              FontColor->RGBColor[0.8, 0, 0]], 
             RowBox[{"3", ",", "1", ",", "1"}], "+"]}], "+", 
           RowBox[{"5184", " ", 
            SubsuperscriptBox[
             StyleBox["\[Eta]",
              FontWeight->Bold,
              FontColor->RGBColor[0.8, 0, 0]], 
             RowBox[{"3", ",", "1", ",", "2"}], "+"]}], "-", 
           RowBox[{"864", " ", "\[ImaginaryI]", " ", 
            SubsuperscriptBox[
             StyleBox["\[Eta]",
              FontWeight->Bold,
              FontColor->RGBColor[0.8, 0, 0]], 
             RowBox[{"3", ",", "1", ",", "3"}], "+"]}], "+", 
           RowBox[{"5184", " ", 
            SubsuperscriptBox[
             StyleBox["\[Eta]",
              FontWeight->Bold,
              FontColor->RGBColor[0.8, 0, 0]], 
             RowBox[{"3", ",", "2", ",", "1"}], "+"]}], "-", 
           RowBox[{"864", " ", "\[ImaginaryI]", " ", 
            SubsuperscriptBox[
             StyleBox["\[Eta]",
              FontWeight->Bold,
              FontColor->RGBColor[0.8, 0, 0]], 
             RowBox[{"3", ",", "3", ",", "1"}], "+"]}], "+", 
           RowBox[{"5184", " ", 
            SubsuperscriptBox[
             StyleBox["\[Eta]",
              FontWeight->Bold,
              FontColor->RGBColor[0.8, 0, 0]], 
             RowBox[{"4", ",", "1", ",", "1"}], "+"]}], "-", 
           RowBox[{"2592", " ", "\[ImaginaryI]", " ", 
            SubsuperscriptBox[
             StyleBox["\[Eta]",
              FontWeight->Bold,
              FontColor->RGBColor[0.8, 0, 0]], 
             RowBox[{"5", ",", "1", ",", "1"}], "+"]}], "+", 
           RowBox[{"10368", " ", 
            SubsuperscriptBox[
             StyleBox["\[Eta]",
              FontWeight->Bold,
              FontColor->RGBColor[0.8, 0, 0]], 
             RowBox[{"3", ",", "1", ",", "1", ",", "1"}], "+"]}]}], ")"}]}]}],
        ")"}]}]}]}], ",", 
   RowBox[{
    SubscriptBox[
     StyleBox["q",
      FontColor->RGBColor[0, 0, 0.8]], 
     RowBox[{"2", ",", "4"}]], "\[Rule]", 
    RowBox[{
     RowBox[{
      SuperscriptBox["g", "4"], " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"6", " ", "\[ImaginaryI]", " ", "u"}], "+", 
        RowBox[{
         StyleBox["Q0",
          FontColor->RGBColor[{
             Rational[1, 2], 
             Rational[1, 2], 0}]], " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"6", " ", 
            SubsuperscriptBox[
             StyleBox["\[Eta]",
              FontWeight->Bold,
              FontColor->RGBColor[0.8, 0, 0]], "2", "+"]}], "+", 
           RowBox[{"2", " ", 
            SubsuperscriptBox[
             StyleBox["\[Eta]",
              FontWeight->Bold,
              FontColor->RGBColor[0.8, 0, 0]], "4", "+"]}]}], ")"}]}]}], 
       ")"}]}], "+", 
     RowBox[{
      SuperscriptBox["g", "6"], " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         RowBox[{"-", "42"}], " ", "\[ImaginaryI]", " ", "u"}], "-", 
        RowBox[{"72", " ", "u", " ", 
         SubsuperscriptBox[
          StyleBox["\[Eta]",
           FontWeight->Bold,
           FontColor->RGBColor[0.8, 0, 0]], "1", "+"]}], "-", 
        RowBox[{"8", " ", 
         SubsuperscriptBox[
          StyleBox["\[Eta]",
           FontWeight->Bold,
           FontColor->RGBColor[0.8, 0, 0]], "2", "+"]}], "+", 
        RowBox[{
         SubscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->RGBColor[0.8, 0, 0]], "1"], " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{
            RowBox[{"-", "72"}], " ", "\[ImaginaryI]", " ", "u"}], "+", 
           RowBox[{
            StyleBox["Q0",
             FontColor->RGBColor[{
                Rational[1, 2], 
                Rational[1, 2], 0}]], " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{
               RowBox[{"-", "72"}], " ", 
               SubsuperscriptBox[
                StyleBox["\[Eta]",
                 FontWeight->Bold,
                 FontColor->RGBColor[0.8, 0, 0]], "2", "+"]}], "-", 
              RowBox[{"24", " ", 
               SubsuperscriptBox[
                StyleBox["\[Eta]",
                 FontWeight->Bold,
                 FontColor->RGBColor[0.8, 0, 0]], "4", "+"]}]}], ")"}]}]}], 
          ")"}]}], "-", 
        FractionBox[
         RowBox[{"8", " ", 
          SubsuperscriptBox[
           StyleBox["\[Eta]",
            FontWeight->Bold,
            FontColor->RGBColor[0.8, 0, 0]], "4", "+"]}], "3"], "+", 
        RowBox[{
         StyleBox["Q0",
          FontColor->RGBColor[{
             Rational[1, 2], 
             Rational[1, 2], 0}]], " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"30", " ", 
            SubsuperscriptBox[
             StyleBox["\[Eta]",
              FontWeight->Bold,
              FontColor->RGBColor[0.8, 0, 0]], "2", "+"]}], "+", 
           RowBox[{"36", " ", "\[ImaginaryI]", " ", 
            SubsuperscriptBox[
             StyleBox["\[Eta]",
              FontWeight->Bold,
              FontColor->RGBColor[0.8, 0, 0]], "3", "+"]}], "+", 
           RowBox[{"30", " ", 
            SubsuperscriptBox[
             StyleBox["\[Eta]",
              FontWeight->Bold,
              FontColor->RGBColor[0.8, 0, 0]], "4", "+"]}], "+", 
           RowBox[{"12", " ", "\[ImaginaryI]", " ", 
            SubsuperscriptBox[
             StyleBox["\[Eta]",
              FontWeight->Bold,
              FontColor->RGBColor[0.8, 0, 0]], "5", "+"]}], "+", 
           RowBox[{"8", " ", 
            SubsuperscriptBox[
             StyleBox["\[Eta]",
              FontWeight->Bold,
              FontColor->RGBColor[0.8, 0, 0]], "6", "+"]}], "+", 
           RowBox[{"72", " ", "\[ImaginaryI]", " ", 
            SubsuperscriptBox[
             StyleBox["\[Eta]",
              FontWeight->Bold,
              FontColor->RGBColor[0.8, 0, 0]], 
             RowBox[{"2", ",", "1"}], "+"]}], "+", 
           RowBox[{"24", " ", "\[ImaginaryI]", " ", 
            SubsuperscriptBox[
             StyleBox["\[Eta]",
              FontWeight->Bold,
              FontColor->RGBColor[0.8, 0, 0]], 
             RowBox[{"4", ",", "1"}], "+"]}]}], ")"}]}]}], ")"}]}], "+", 
     RowBox[{
      SuperscriptBox["g", "8"], " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"12", " ", "\[ImaginaryI]", " ", "u", " ", 
         RowBox[{"(", 
          RowBox[{"35", "+", 
           RowBox[{"18", " ", 
            SubscriptBox[
             StyleBox["\[Zeta]",
              FontWeight->Bold,
              FontColor->RGBColor[0.8, 0, 0]], "3"]}]}], ")"}]}], "+", 
        RowBox[{"792", " ", "u", " ", 
         SubsuperscriptBox[
          StyleBox["\[Eta]",
           FontWeight->Bold,
           FontColor->RGBColor[0.8, 0, 0]], "1", "+"]}], "-", 
        RowBox[{"4", " ", "\[ImaginaryI]", " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{
            RowBox[{"-", "13"}], " ", "\[ImaginaryI]"}], "+", 
           RowBox[{"108", " ", "u"}]}], ")"}], " ", 
         SubsuperscriptBox[
          StyleBox["\[Eta]",
           FontWeight->Bold,
           FontColor->RGBColor[0.8, 0, 0]], "2", "+"]}], "-", 
        RowBox[{"24", " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"2", " ", "\[ImaginaryI]"}], "+", 
           RowBox[{"3", " ", "u"}]}], ")"}], " ", 
         SubsuperscriptBox[
          StyleBox["\[Eta]",
           FontWeight->Bold,
           FontColor->RGBColor[0.8, 0, 0]], "3", "+"]}], "-", 
        RowBox[{"44", " ", 
         SubsuperscriptBox[
          StyleBox["\[Eta]",
           FontWeight->Bold,
           FontColor->RGBColor[0.8, 0, 0]], "4", "+"]}], "+", 
        RowBox[{
         SubsuperscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->RGBColor[0.8, 0, 0]], "1", "2"], " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"432", " ", "\[ImaginaryI]", " ", "u"}], "+", 
           RowBox[{
            StyleBox["Q0",
             FontColor->RGBColor[{
                Rational[1, 2], 
                Rational[1, 2], 0}]], " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"432", " ", 
               SubsuperscriptBox[
                StyleBox["\[Eta]",
                 FontWeight->Bold,
                 FontColor->RGBColor[0.8, 0, 0]], "2", "+"]}], "+", 
              RowBox[{"144", " ", 
               SubsuperscriptBox[
                StyleBox["\[Eta]",
                 FontWeight->Bold,
                 FontColor->RGBColor[0.8, 0, 0]], "4", "+"]}]}], ")"}]}]}], 
          ")"}]}], "-", 
        RowBox[{"16", " ", "\[ImaginaryI]", " ", 
         SubsuperscriptBox[
          StyleBox["\[Eta]",
           FontWeight->Bold,
           FontColor->RGBColor[0.8, 0, 0]], "5", "+"]}], "-", 
        FractionBox[
         RowBox[{"32", " ", 
          SubsuperscriptBox[
           StyleBox["\[Eta]",
            FontWeight->Bold,
            FontColor->RGBColor[0.8, 0, 0]], "6", "+"]}], "3"], "-", 
        RowBox[{"864", " ", "\[ImaginaryI]", " ", "u", " ", 
         SubsuperscriptBox[
          StyleBox["\[Eta]",
           FontWeight->Bold,
           FontColor->RGBColor[0.8, 0, 0]], 
          RowBox[{"1", ",", "1"}], "+"]}], "-", 
        RowBox[{"96", " ", "\[ImaginaryI]", " ", 
         SubsuperscriptBox[
          StyleBox["\[Eta]",
           FontWeight->Bold,
           FontColor->RGBColor[0.8, 0, 0]], 
          RowBox[{"2", ",", "1"}], "+"]}], "+", 
        RowBox[{
         SubscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->RGBColor[0.8, 0, 0]], "1"], " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"792", " ", "\[ImaginaryI]", " ", "u"}], "+", 
           RowBox[{"864", " ", "u", " ", 
            SubsuperscriptBox[
             StyleBox["\[Eta]",
              FontWeight->Bold,
              FontColor->RGBColor[0.8, 0, 0]], "1", "+"]}], "+", 
           RowBox[{"96", " ", 
            SubsuperscriptBox[
             StyleBox["\[Eta]",
              FontWeight->Bold,
              FontColor->RGBColor[0.8, 0, 0]], "2", "+"]}], "+", 
           RowBox[{"32", " ", 
            SubsuperscriptBox[
             StyleBox["\[Eta]",
              FontWeight->Bold,
              FontColor->RGBColor[0.8, 0, 0]], "4", "+"]}], "+", 
           RowBox[{
            StyleBox["Q0",
             FontColor->RGBColor[{
                Rational[1, 2], 
                Rational[1, 2], 0}]], " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{
               RowBox[{"-", "72"}], " ", 
               SubsuperscriptBox[
                StyleBox["\[Eta]",
                 FontWeight->Bold,
                 FontColor->RGBColor[0.8, 0, 0]], "2", "+"]}], "-", 
              RowBox[{"432", " ", "\[ImaginaryI]", " ", 
               SubsuperscriptBox[
                StyleBox["\[Eta]",
                 FontWeight->Bold,
                 FontColor->RGBColor[0.8, 0, 0]], "3", "+"]}], "-", 
              RowBox[{"264", " ", 
               SubsuperscriptBox[
                StyleBox["\[Eta]",
                 FontWeight->Bold,
                 FontColor->RGBColor[0.8, 0, 0]], "4", "+"]}], "-", 
              RowBox[{"144", " ", "\[ImaginaryI]", " ", 
               SubsuperscriptBox[
                StyleBox["\[Eta]",
                 FontWeight->Bold,
                 FontColor->RGBColor[0.8, 0, 0]], "5", "+"]}], "-", 
              RowBox[{"96", " ", 
               SubsuperscriptBox[
                StyleBox["\[Eta]",
                 FontWeight->Bold,
                 FontColor->RGBColor[0.8, 0, 0]], "6", "+"]}], "-", 
              RowBox[{"864", " ", "\[ImaginaryI]", " ", 
               SubsuperscriptBox[
                StyleBox["\[Eta]",
                 FontWeight->Bold,
                 FontColor->RGBColor[0.8, 0, 0]], 
                RowBox[{"2", ",", "1"}], "+"]}], "-", 
              RowBox[{"288", " ", "\[ImaginaryI]", " ", 
               SubsuperscriptBox[
                StyleBox["\[Eta]",
                 FontWeight->Bold,
                 FontColor->RGBColor[0.8, 0, 0]], 
                RowBox[{"4", ",", "1"}], "+"]}]}], ")"}]}]}], ")"}]}], "-", 
        RowBox[{"32", " ", "\[ImaginaryI]", " ", 
         SubsuperscriptBox[
          StyleBox["\[Eta]",
           FontWeight->Bold,
           FontColor->RGBColor[0.8, 0, 0]], 
          RowBox[{"4", ",", "1"}], "+"]}], "+", 
        RowBox[{
         StyleBox["Q0",
          FontColor->RGBColor[{
             Rational[1, 2], 
             Rational[1, 2], 0}]], " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"12", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "31"}], "+", 
              RowBox[{"18", " ", 
               SubscriptBox[
                StyleBox["\[Zeta]",
                 FontWeight->Bold,
                 FontColor->RGBColor[0.8, 0, 0]], "3"]}]}], ")"}], " ", 
            SubsuperscriptBox[
             StyleBox["\[Eta]",
              FontWeight->Bold,
              FontColor->RGBColor[0.8, 0, 0]], "2", "+"]}], "+", 
           RowBox[{"36", " ", "\[ImaginaryI]", " ", 
            SubsuperscriptBox[
             StyleBox["\[Eta]",
              FontWeight->Bold,
              FontColor->RGBColor[0.8, 0, 0]], "3", "+"]}], "+", 
           RowBox[{"12", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "7"}], "+", 
              RowBox[{"6", " ", 
               SubscriptBox[
                StyleBox["\[Zeta]",
                 FontWeight->Bold,
                 FontColor->RGBColor[0.8, 0, 0]], "3"]}]}], ")"}], " ", 
            SubsuperscriptBox[
             StyleBox["\[Eta]",
              FontWeight->Bold,
              FontColor->RGBColor[0.8, 0, 0]], "4", "+"]}], "+", 
           RowBox[{"168", " ", "\[ImaginaryI]", " ", 
            SubsuperscriptBox[
             StyleBox["\[Eta]",
              FontWeight->Bold,
              FontColor->RGBColor[0.8, 0, 0]], "5", "+"]}], "+", 
           RowBox[{"66", " ", 
            SubsuperscriptBox[
             StyleBox["\[Eta]",
              FontWeight->Bold,
              FontColor->RGBColor[0.8, 0, 0]], "6", "+"]}], "+", 
           RowBox[{"60", " ", "\[ImaginaryI]", " ", 
            SubsuperscriptBox[
             StyleBox["\[Eta]",
              FontWeight->Bold,
              FontColor->RGBColor[0.8, 0, 0]], "7", "+"]}], "+", 
           RowBox[{"28", " ", 
            SubsuperscriptBox[
             StyleBox["\[Eta]",
              FontWeight->Bold,
              FontColor->RGBColor[0.8, 0, 0]], "8", "+"]}], "+", 
           RowBox[{"72", " ", "\[ImaginaryI]", " ", 
            SubsuperscriptBox[
             StyleBox["\[Eta]",
              FontWeight->Bold,
              FontColor->RGBColor[0.8, 0, 0]], 
             RowBox[{"2", ",", "1"}], "+"]}], "-", 
           RowBox[{"432", " ", 
            SubsuperscriptBox[
             StyleBox["\[Eta]",
              FontWeight->Bold,
              FontColor->RGBColor[0.8, 0, 0]], 
             RowBox[{"2", ",", "2"}], "+"]}], "+", 
           RowBox[{"72", " ", "\[ImaginaryI]", " ", 
            SubsuperscriptBox[
             StyleBox["\[Eta]",
              FontWeight->Bold,
              FontColor->RGBColor[0.8, 0, 0]], 
             RowBox[{"2", ",", "3"}], "+"]}], "-", 
           RowBox[{"432", " ", 
            SubsuperscriptBox[
             StyleBox["\[Eta]",
              FontWeight->Bold,
              FontColor->RGBColor[0.8, 0, 0]], 
             RowBox[{"3", ",", "1"}], "+"]}], "+", 
           RowBox[{"264", " ", "\[ImaginaryI]", " ", 
            SubsuperscriptBox[
             StyleBox["\[Eta]",
              FontWeight->Bold,
              FontColor->RGBColor[0.8, 0, 0]], 
             RowBox[{"4", ",", "1"}], "+"]}], "-", 
           RowBox[{"144", " ", 
            SubsuperscriptBox[
             StyleBox["\[Eta]",
              FontWeight->Bold,
              FontColor->RGBColor[0.8, 0, 0]], 
             RowBox[{"4", ",", "2"}], "+"]}], "+", 
           RowBox[{"24", " ", "\[ImaginaryI]", " ", 
            SubsuperscriptBox[
             StyleBox["\[Eta]",
              FontWeight->Bold,
              FontColor->RGBColor[0.8, 0, 0]], 
             RowBox[{"4", ",", "3"}], "+"]}], "-", 
           RowBox[{"144", " ", 
            SubsuperscriptBox[
             StyleBox["\[Eta]",
              FontWeight->Bold,
              FontColor->RGBColor[0.8, 0, 0]], 
             RowBox[{"5", ",", "1"}], "+"]}], "+", 
           RowBox[{"96", " ", "\[ImaginaryI]", " ", 
            SubsuperscriptBox[
             StyleBox["\[Eta]",
              FontWeight->Bold,
              FontColor->RGBColor[0.8, 0, 0]], 
             RowBox[{"6", ",", "1"}], "+"]}], "-", 
           RowBox[{"864", " ", 
            SubsuperscriptBox[
             StyleBox["\[Eta]",
              FontWeight->Bold,
              FontColor->RGBColor[0.8, 0, 0]], 
             RowBox[{"2", ",", "1", ",", "1"}], "+"]}], "-", 
           RowBox[{"288", " ", 
            SubsuperscriptBox[
             StyleBox["\[Eta]",
              FontWeight->Bold,
              FontColor->RGBColor[0.8, 0, 0]], 
             RowBox[{"4", ",", "1", ",", "1"}], "+"]}]}], ")"}]}]}], ")"}]}], 
     "+", 
     RowBox[{
      SuperscriptBox["g", "10"], " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         RowBox[{"-", "24"}], " ", "\[ImaginaryI]", " ", "u", " ", 
         RowBox[{"(", 
          RowBox[{"187", "+", 
           RowBox[{"105", " ", 
            SubscriptBox[
             StyleBox["\[Zeta]",
              FontWeight->Bold,
              FontColor->RGBColor[0.8, 0, 0]], "3"]}], "+", 
           RowBox[{"60", " ", 
            SubscriptBox[
             StyleBox["\[Zeta]",
              FontWeight->Bold,
              FontColor->RGBColor[0.8, 0, 0]], "5"]}]}], ")"}]}], "-", 
        RowBox[{"1296", " ", "u", " ", 
         RowBox[{"(", 
          RowBox[{"7", "+", 
           RowBox[{"2", " ", 
            SubscriptBox[
             StyleBox["\[Zeta]",
              FontWeight->Bold,
              FontColor->RGBColor[0.8, 0, 0]], "3"]}]}], ")"}], " ", 
         SubsuperscriptBox[
          StyleBox["\[Eta]",
           FontWeight->Bold,
           FontColor->RGBColor[0.8, 0, 0]], "1", "+"]}], "+", 
        RowBox[{"4", " ", 
         RowBox[{"(", 
          RowBox[{"121", "+", 
           RowBox[{"1620", " ", "\[ImaginaryI]", " ", "u"}], "-", 
           RowBox[{"84", " ", 
            SubscriptBox[
             StyleBox["\[Zeta]",
              FontWeight->Bold,
              FontColor->RGBColor[0.8, 0, 0]], "3"]}]}], ")"}], " ", 
         SubsuperscriptBox[
          StyleBox["\[Eta]",
           FontWeight->Bold,
           FontColor->RGBColor[0.8, 0, 0]], "2", "+"]}], "+", 
        RowBox[{"120", " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"-", "\[ImaginaryI]"}], "+", 
           RowBox[{"21", " ", "u"}]}], ")"}], " ", 
         SubsuperscriptBox[
          StyleBox["\[Eta]",
           FontWeight->Bold,
           FontColor->RGBColor[0.8, 0, 0]], "3", "+"]}], "+", 
        RowBox[{
         SubsuperscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->RGBColor[0.8, 0, 0]], "1", "3"], " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{
            RowBox[{"-", "1728"}], " ", "\[ImaginaryI]", " ", "u"}], "+", 
           RowBox[{
            StyleBox["Q0",
             FontColor->RGBColor[{
                Rational[1, 2], 
                Rational[1, 2], 0}]], " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{
               RowBox[{"-", "1728"}], " ", 
               SubsuperscriptBox[
                StyleBox["\[Eta]",
                 FontWeight->Bold,
                 FontColor->RGBColor[0.8, 0, 0]], "2", "+"]}], "-", 
              RowBox[{"576", " ", 
               SubsuperscriptBox[
                StyleBox["\[Eta]",
                 FontWeight->Bold,
                 FontColor->RGBColor[0.8, 0, 0]], "4", "+"]}]}], ")"}]}]}], 
          ")"}]}], "+", 
        RowBox[{"4", " ", 
         RowBox[{"(", 
          RowBox[{"17", "-", 
           RowBox[{"216", " ", "\[ImaginaryI]", " ", "u"}], "-", 
           RowBox[{"28", " ", 
            SubscriptBox[
             StyleBox["\[Zeta]",
              FontWeight->Bold,
              FontColor->RGBColor[0.8, 0, 0]], "3"]}]}], ")"}], " ", 
         SubsuperscriptBox[
          StyleBox["\[Eta]",
           FontWeight->Bold,
           FontColor->RGBColor[0.8, 0, 0]], "4", "+"]}], "-", 
        RowBox[{"8", " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"31", " ", "\[ImaginaryI]"}], "+", 
           RowBox[{"18", " ", "u"}]}], ")"}], " ", 
         SubsuperscriptBox[
          StyleBox["\[Eta]",
           FontWeight->Bold,
           FontColor->RGBColor[0.8, 0, 0]], "5", "+"]}], "-", 
        RowBox[{"104", " ", 
         SubsuperscriptBox[
          StyleBox["\[Eta]",
           FontWeight->Bold,
           FontColor->RGBColor[0.8, 0, 0]], "6", "+"]}], "-", 
        RowBox[{"80", " ", "\[ImaginaryI]", " ", 
         SubsuperscriptBox[
          StyleBox["\[Eta]",
           FontWeight->Bold,
           FontColor->RGBColor[0.8, 0, 0]], "7", "+"]}], "-", 
        FractionBox[
         RowBox[{"112", " ", 
          SubsuperscriptBox[
           StyleBox["\[Eta]",
            FontWeight->Bold,
            FontColor->RGBColor[0.8, 0, 0]], "8", "+"]}], "3"], "+", 
        RowBox[{"12960", " ", "\[ImaginaryI]", " ", "u", " ", 
         SubsuperscriptBox[
          StyleBox["\[Eta]",
           FontWeight->Bold,
           FontColor->RGBColor[0.8, 0, 0]], 
          RowBox[{"1", ",", "1"}], "+"]}], "+", 
        RowBox[{"5184", " ", "u", " ", 
         SubsuperscriptBox[
          StyleBox["\[Eta]",
           FontWeight->Bold,
           FontColor->RGBColor[0.8, 0, 0]], 
          RowBox[{"1", ",", "2"}], "+"]}], "-", 
        RowBox[{"864", " ", "\[ImaginaryI]", " ", "u", " ", 
         SubsuperscriptBox[
          StyleBox["\[Eta]",
           FontWeight->Bold,
           FontColor->RGBColor[0.8, 0, 0]], 
          RowBox[{"1", ",", "3"}], "+"]}], "+", 
        RowBox[{"48", " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{
            RowBox[{"-", "5"}], " ", "\[ImaginaryI]"}], "+", 
           RowBox[{"108", " ", "u"}]}], ")"}], " ", 
         SubsuperscriptBox[
          StyleBox["\[Eta]",
           FontWeight->Bold,
           FontColor->RGBColor[0.8, 0, 0]], 
          RowBox[{"2", ",", "1"}], "+"]}], "+", 
        RowBox[{"576", " ", 
         SubsuperscriptBox[
          StyleBox["\[Eta]",
           FontWeight->Bold,
           FontColor->RGBColor[0.8, 0, 0]], 
          RowBox[{"2", ",", "2"}], "+"]}], "-", 
        RowBox[{"96", " ", "\[ImaginaryI]", " ", 
         SubsuperscriptBox[
          StyleBox["\[Eta]",
           FontWeight->Bold,
           FontColor->RGBColor[0.8, 0, 0]], 
          RowBox[{"2", ",", "3"}], "+"]}], "+", 
        RowBox[{"288", " ", 
         RowBox[{"(", 
          RowBox[{"2", "-", 
           RowBox[{"3", " ", "\[ImaginaryI]", " ", "u"}]}], ")"}], " ", 
         SubsuperscriptBox[
          StyleBox["\[Eta]",
           FontWeight->Bold,
           FontColor->RGBColor[0.8, 0, 0]], 
          RowBox[{"3", ",", "1"}], "+"]}], "+", 
        RowBox[{
         SubsuperscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->RGBColor[0.8, 0, 0]], "1", "2"], " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{
            RowBox[{"-", "6480"}], " ", "\[ImaginaryI]", " ", "u"}], "-", 
           RowBox[{"5184", " ", "u", " ", 
            SubsuperscriptBox[
             StyleBox["\[Eta]",
              FontWeight->Bold,
              FontColor->RGBColor[0.8, 0, 0]], "1", "+"]}], "-", 
           RowBox[{"576", " ", 
            SubsuperscriptBox[
             StyleBox["\[Eta]",
              FontWeight->Bold,
              FontColor->RGBColor[0.8, 0, 0]], "2", "+"]}], "-", 
           RowBox[{"192", " ", 
            SubsuperscriptBox[
             StyleBox["\[Eta]",
              FontWeight->Bold,
              FontColor->RGBColor[0.8, 0, 0]], "4", "+"]}], "+", 
           RowBox[{
            StyleBox["Q0",
             FontColor->RGBColor[{
                Rational[1, 2], 
                Rational[1, 2], 0}]], " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{
               RowBox[{"-", "1296"}], " ", 
               SubsuperscriptBox[
                StyleBox["\[Eta]",
                 FontWeight->Bold,
                 FontColor->RGBColor[0.8, 0, 0]], "2", "+"]}], "+", 
              RowBox[{"2592", " ", "\[ImaginaryI]", " ", 
               SubsuperscriptBox[
                StyleBox["\[Eta]",
                 FontWeight->Bold,
                 FontColor->RGBColor[0.8, 0, 0]], "3", "+"]}], "+", 
              RowBox[{"1008", " ", 
               SubsuperscriptBox[
                StyleBox["\[Eta]",
                 FontWeight->Bold,
                 FontColor->RGBColor[0.8, 0, 0]], "4", "+"]}], "+", 
              RowBox[{"864", " ", "\[ImaginaryI]", " ", 
               SubsuperscriptBox[
                StyleBox["\[Eta]",
                 FontWeight->Bold,
                 FontColor->RGBColor[0.8, 0, 0]], "5", "+"]}], "+", 
              RowBox[{"576", " ", 
               SubsuperscriptBox[
                StyleBox["\[Eta]",
                 FontWeight->Bold,
                 FontColor->RGBColor[0.8, 0, 0]], "6", "+"]}], "+", 
              RowBox[{"5184", " ", "\[ImaginaryI]", " ", 
               SubsuperscriptBox[
                StyleBox["\[Eta]",
                 FontWeight->Bold,
                 FontColor->RGBColor[0.8, 0, 0]], 
                RowBox[{"2", ",", "1"}], "+"]}], "+", 
              RowBox[{"1728", " ", "\[ImaginaryI]", " ", 
               SubsuperscriptBox[
                StyleBox["\[Eta]",
                 FontWeight->Bold,
                 FontColor->RGBColor[0.8, 0, 0]], 
                RowBox[{"4", ",", "1"}], "+"]}]}], ")"}]}]}], ")"}]}], "-", 
        RowBox[{"400", " ", "\[ImaginaryI]", " ", 
         SubsuperscriptBox[
          StyleBox["\[Eta]",
           FontWeight->Bold,
           FontColor->RGBColor[0.8, 0, 0]], 
          RowBox[{"4", ",", "1"}], "+"]}], "+", 
        RowBox[{"192", " ", 
         SubsuperscriptBox[
          StyleBox["\[Eta]",
           FontWeight->Bold,
           FontColor->RGBColor[0.8, 0, 0]], 
          RowBox[{"4", ",", "2"}], "+"]}], "-", 
        RowBox[{"32", " ", "\[ImaginaryI]", " ", 
         SubsuperscriptBox[
          StyleBox["\[Eta]",
           FontWeight->Bold,
           FontColor->RGBColor[0.8, 0, 0]], 
          RowBox[{"4", ",", "3"}], "+"]}], "+", 
        RowBox[{"192", " ", 
         SubsuperscriptBox[
          StyleBox["\[Eta]",
           FontWeight->Bold,
           FontColor->RGBColor[0.8, 0, 0]], 
          RowBox[{"5", ",", "1"}], "+"]}], "-", 
        RowBox[{"128", " ", "\[ImaginaryI]", " ", 
         SubsuperscriptBox[
          StyleBox["\[Eta]",
           FontWeight->Bold,
           FontColor->RGBColor[0.8, 0, 0]], 
          RowBox[{"6", ",", "1"}], "+"]}], "+", 
        RowBox[{"10368", " ", "u", " ", 
         SubsuperscriptBox[
          StyleBox["\[Eta]",
           FontWeight->Bold,
           FontColor->RGBColor[0.8, 0, 0]], 
          RowBox[{"1", ",", "1", ",", "1"}], "+"]}], "+", 
        RowBox[{"1152", " ", 
         SubsuperscriptBox[
          StyleBox["\[Eta]",
           FontWeight->Bold,
           FontColor->RGBColor[0.8, 0, 0]], 
          RowBox[{"2", ",", "1", ",", "1"}], "+"]}], "+", 
        RowBox[{"384", " ", 
         SubsuperscriptBox[
          StyleBox["\[Eta]",
           FontWeight->Bold,
           FontColor->RGBColor[0.8, 0, 0]], 
          RowBox[{"4", ",", "1", ",", "1"}], "+"]}], "+", 
        RowBox[{
         SubscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->RGBColor[0.8, 0, 0]], "1"], " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{
            RowBox[{"-", "1296"}], " ", "\[ImaginaryI]", " ", "u", " ", 
            RowBox[{"(", 
             RowBox[{"7", "+", 
              RowBox[{"2", " ", 
               SubscriptBox[
                StyleBox["\[Zeta]",
                 FontWeight->Bold,
                 FontColor->RGBColor[0.8, 0, 0]], "3"]}]}], ")"}]}], "-", 
           RowBox[{"12960", " ", "u", " ", 
            SubsuperscriptBox[
             StyleBox["\[Eta]",
              FontWeight->Bold,
              FontColor->RGBColor[0.8, 0, 0]], "1", "+"]}], "+", 
           RowBox[{"48", " ", 
            RowBox[{"(", 
             RowBox[{"5", "+", 
              RowBox[{"108", " ", "\[ImaginaryI]", " ", "u"}]}], ")"}], " ", 
            SubsuperscriptBox[
             StyleBox["\[Eta]",
              FontWeight->Bold,
              FontColor->RGBColor[0.8, 0, 0]], "2", "+"]}], "+", 
           RowBox[{"288", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"2", " ", "\[ImaginaryI]"}], "+", 
              RowBox[{"3", " ", "u"}]}], ")"}], " ", 
            SubsuperscriptBox[
             StyleBox["\[Eta]",
              FontWeight->Bold,
              FontColor->RGBColor[0.8, 0, 0]], "3", "+"]}], "+", 
           RowBox[{"400", " ", 
            SubsuperscriptBox[
             StyleBox["\[Eta]",
              FontWeight->Bold,
              FontColor->RGBColor[0.8, 0, 0]], "4", "+"]}], "+", 
           RowBox[{"192", " ", "\[ImaginaryI]", " ", 
            SubsuperscriptBox[
             StyleBox["\[Eta]",
              FontWeight->Bold,
              FontColor->RGBColor[0.8, 0, 0]], "5", "+"]}], "+", 
           RowBox[{"128", " ", 
            SubsuperscriptBox[
             StyleBox["\[Eta]",
              FontWeight->Bold,
              FontColor->RGBColor[0.8, 0, 0]], "6", "+"]}], "+", 
           RowBox[{"10368", " ", "\[ImaginaryI]", " ", "u", " ", 
            SubsuperscriptBox[
             StyleBox["\[Eta]",
              FontWeight->Bold,
              FontColor->RGBColor[0.8, 0, 0]], 
             RowBox[{"1", ",", "1"}], "+"]}], "+", 
           RowBox[{"1152", " ", "\[ImaginaryI]", " ", 
            SubsuperscriptBox[
             StyleBox["\[Eta]",
              FontWeight->Bold,
              FontColor->RGBColor[0.8, 0, 0]], 
             RowBox[{"2", ",", "1"}], "+"]}], "+", 
           RowBox[{"384", " ", "\[ImaginaryI]", " ", 
            SubsuperscriptBox[
             StyleBox["\[Eta]",
              FontWeight->Bold,
              FontColor->RGBColor[0.8, 0, 0]], 
             RowBox[{"4", ",", "1"}], "+"]}], "+", 
           RowBox[{
            StyleBox["Q0",
             FontColor->RGBColor[{
                Rational[1, 2], 
                Rational[1, 2], 0}]], " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{
               RowBox[{"-", "1296"}], " ", 
               RowBox[{"(", 
                RowBox[{
                 RowBox[{"-", "3"}], "+", 
                 RowBox[{"2", " ", 
                  SubscriptBox[
                   StyleBox["\[Zeta]",
                    FontWeight->Bold,
                    FontColor->RGBColor[0.8, 0, 0]], "3"]}]}], ")"}], " ", 
               SubsuperscriptBox[
                StyleBox["\[Eta]",
                 FontWeight->Bold,
                 FontColor->RGBColor[0.8, 0, 0]], "2", "+"]}], "+", 
              RowBox[{"1296", " ", "\[ImaginaryI]", " ", 
               SubsuperscriptBox[
                StyleBox["\[Eta]",
                 FontWeight->Bold,
                 FontColor->RGBColor[0.8, 0, 0]], "3", "+"]}], "-", 
              RowBox[{"48", " ", 
               RowBox[{"(", 
                RowBox[{
                 RowBox[{"-", "37"}], "+", 
                 RowBox[{"18", " ", 
                  SubscriptBox[
                   StyleBox["\[Zeta]",
                    FontWeight->Bold,
                    FontColor->RGBColor[0.8, 0, 0]], "3"]}]}], ")"}], " ", 
               SubsuperscriptBox[
                StyleBox["\[Eta]",
                 FontWeight->Bold,
                 FontColor->RGBColor[0.8, 0, 0]], "4", "+"]}], "-", 
              RowBox[{"1440", " ", "\[ImaginaryI]", " ", 
               SubsuperscriptBox[
                StyleBox["\[Eta]",
                 FontWeight->Bold,
                 FontColor->RGBColor[0.8, 0, 0]], "5", "+"]}], "-", 
              RowBox[{"408", " ", 
               SubsuperscriptBox[
                StyleBox["\[Eta]",
                 FontWeight->Bold,
                 FontColor->RGBColor[0.8, 0, 0]], "6", "+"]}], "-", 
              RowBox[{"720", " ", "\[ImaginaryI]", " ", 
               SubsuperscriptBox[
                StyleBox["\[Eta]",
                 FontWeight->Bold,
                 FontColor->RGBColor[0.8, 0, 0]], "7", "+"]}], "-", 
              RowBox[{"336", " ", 
               SubsuperscriptBox[
                StyleBox["\[Eta]",
                 FontWeight->Bold,
                 FontColor->RGBColor[0.8, 0, 0]], "8", "+"]}], "+", 
              RowBox[{"2592", " ", "\[ImaginaryI]", " ", 
               SubsuperscriptBox[
                StyleBox["\[Eta]",
                 FontWeight->Bold,
                 FontColor->RGBColor[0.8, 0, 0]], 
                RowBox[{"2", ",", "1"}], "+"]}], "+", 
              RowBox[{"5184", " ", 
               SubsuperscriptBox[
                StyleBox["\[Eta]",
                 FontWeight->Bold,
                 FontColor->RGBColor[0.8, 0, 0]], 
                RowBox[{"2", ",", "2"}], "+"]}], "-", 
              RowBox[{"864", " ", "\[ImaginaryI]", " ", 
               SubsuperscriptBox[
                StyleBox["\[Eta]",
                 FontWeight->Bold,
                 FontColor->RGBColor[0.8, 0, 0]], 
                RowBox[{"2", ",", "3"}], "+"]}], "+", 
              RowBox[{"5184", " ", 
               SubsuperscriptBox[
                StyleBox["\[Eta]",
                 FontWeight->Bold,
                 FontColor->RGBColor[0.8, 0, 0]], 
                RowBox[{"3", ",", "1"}], "+"]}], "-", 
              RowBox[{"2016", " ", "\[ImaginaryI]", " ", 
               SubsuperscriptBox[
                StyleBox["\[Eta]",
                 FontWeight->Bold,
                 FontColor->RGBColor[0.8, 0, 0]], 
                RowBox[{"4", ",", "1"}], "+"]}], "+", 
              RowBox[{"1728", " ", 
               SubsuperscriptBox[
                StyleBox["\[Eta]",
                 FontWeight->Bold,
                 FontColor->RGBColor[0.8, 0, 0]], 
                RowBox[{"4", ",", "2"}], "+"]}], "-", 
              RowBox[{"288", " ", "\[ImaginaryI]", " ", 
               SubsuperscriptBox[
                StyleBox["\[Eta]",
                 FontWeight->Bold,
                 FontColor->RGBColor[0.8, 0, 0]], 
                RowBox[{"4", ",", "3"}], "+"]}], "+", 
              RowBox[{"1728", " ", 
               SubsuperscriptBox[
                StyleBox["\[Eta]",
                 FontWeight->Bold,
                 FontColor->RGBColor[0.8, 0, 0]], 
                RowBox[{"5", ",", "1"}], "+"]}], "-", 
              RowBox[{"1152", " ", "\[ImaginaryI]", " ", 
               SubsuperscriptBox[
                StyleBox["\[Eta]",
                 FontWeight->Bold,
                 FontColor->RGBColor[0.8, 0, 0]], 
                RowBox[{"6", ",", "1"}], "+"]}], "+", 
              RowBox[{"10368", " ", 
               SubsuperscriptBox[
                StyleBox["\[Eta]",
                 FontWeight->Bold,
                 FontColor->RGBColor[0.8, 0, 0]], 
                RowBox[{"2", ",", "1", ",", "1"}], "+"]}], "+", 
              RowBox[{"3456", " ", 
               SubsuperscriptBox[
                StyleBox["\[Eta]",
                 FontWeight->Bold,
                 FontColor->RGBColor[0.8, 0, 0]], 
                RowBox[{"4", ",", "1", ",", "1"}], "+"]}]}], ")"}]}]}], 
          ")"}]}], "+", 
        RowBox[{
         StyleBox["Q0",
          FontColor->RGBColor[{
             Rational[1, 2], 
             Rational[1, 2], 0}]], " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"24", " ", 
            RowBox[{"(", 
             RowBox[{"191", "+", 
              RowBox[{"3", " ", 
               SubscriptBox[
                StyleBox["\[Zeta]",
                 FontWeight->Bold,
                 FontColor->RGBColor[0.8, 0, 0]], "3"]}], "-", 
              RowBox[{"60", " ", 
               SubscriptBox[
                StyleBox["\[Zeta]",
                 FontWeight->Bold,
                 FontColor->RGBColor[0.8, 0, 0]], "5"]}]}], ")"}], " ", 
            SubsuperscriptBox[
             StyleBox["\[Eta]",
              FontWeight->Bold,
              FontColor->RGBColor[0.8, 0, 0]], "2", "+"]}], "+", 
           RowBox[{"648", " ", "\[ImaginaryI]", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "3"}], "+", 
              RowBox[{"2", " ", 
               SubscriptBox[
                StyleBox["\[Zeta]",
                 FontWeight->Bold,
                 FontColor->RGBColor[0.8, 0, 0]], "3"]}]}], ")"}], " ", 
            SubsuperscriptBox[
             StyleBox["\[Eta]",
              FontWeight->Bold,
              FontColor->RGBColor[0.8, 0, 0]], "3", "+"]}], "+", 
           RowBox[{"12", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "17"}], "+", 
              RowBox[{"78", " ", 
               SubscriptBox[
                StyleBox["\[Zeta]",
                 FontWeight->Bold,
                 FontColor->RGBColor[0.8, 0, 0]], "3"]}], "-", 
              RowBox[{"40", " ", 
               SubscriptBox[
                StyleBox["\[Zeta]",
                 FontWeight->Bold,
                 FontColor->RGBColor[0.8, 0, 0]], "5"]}]}], ")"}], " ", 
            SubsuperscriptBox[
             StyleBox["\[Eta]",
              FontWeight->Bold,
              FontColor->RGBColor[0.8, 0, 0]], "4", "+"]}], "+", 
           RowBox[{"12", " ", "\[ImaginaryI]", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "35"}], "+", 
              RowBox[{"36", " ", 
               SubscriptBox[
                StyleBox["\[Zeta]",
                 FontWeight->Bold,
                 FontColor->RGBColor[0.8, 0, 0]], "3"]}]}], ")"}], " ", 
            SubsuperscriptBox[
             StyleBox["\[Eta]",
              FontWeight->Bold,
              FontColor->RGBColor[0.8, 0, 0]], "5", "+"]}], "+", 
           RowBox[{"42", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "11"}], "+", 
              RowBox[{"8", " ", 
               SubscriptBox[
                StyleBox["\[Zeta]",
                 FontWeight->Bold,
                 FontColor->RGBColor[0.8, 0, 0]], "3"]}]}], ")"}], " ", 
            SubsuperscriptBox[
             StyleBox["\[Eta]",
              FontWeight->Bold,
              FontColor->RGBColor[0.8, 0, 0]], "6", "+"]}], "+", 
           RowBox[{"552", " ", "\[ImaginaryI]", " ", 
            SubsuperscriptBox[
             StyleBox["\[Eta]",
              FontWeight->Bold,
              FontColor->RGBColor[0.8, 0, 0]], "7", "+"]}], "+", 
           RowBox[{"120", " ", 
            SubsuperscriptBox[
             StyleBox["\[Eta]",
              FontWeight->Bold,
              FontColor->RGBColor[0.8, 0, 0]], "8", "+"]}], "+", 
           RowBox[{"240", " ", "\[ImaginaryI]", " ", 
            SubsuperscriptBox[
             StyleBox["\[Eta]",
              FontWeight->Bold,
              FontColor->RGBColor[0.8, 0, 0]], "9", "+"]}], "+", 
           RowBox[{"96", " ", 
            SubsuperscriptBox[
             StyleBox["\[Eta]",
              FontWeight->Bold,
              FontColor->RGBColor[0.8, 0, 0]], "10", "+"]}], "+", 
           RowBox[{"1296", " ", "\[ImaginaryI]", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "3"}], "+", 
              RowBox[{"2", " ", 
               SubscriptBox[
                StyleBox["\[Zeta]",
                 FontWeight->Bold,
                 FontColor->RGBColor[0.8, 0, 0]], "3"]}]}], ")"}], " ", 
            SubsuperscriptBox[
             StyleBox["\[Eta]",
              FontWeight->Bold,
              FontColor->RGBColor[0.8, 0, 0]], 
             RowBox[{"2", ",", "1"}], "+"]}], "+", 
           RowBox[{"1296", " ", 
            SubsuperscriptBox[
             StyleBox["\[Eta]",
              FontWeight->Bold,
              FontColor->RGBColor[0.8, 0, 0]], 
             RowBox[{"2", ",", "2"}], "+"]}], "-", 
           RowBox[{"1656", " ", "\[ImaginaryI]", " ", 
            SubsuperscriptBox[
             StyleBox["\[Eta]",
              FontWeight->Bold,
              FontColor->RGBColor[0.8, 0, 0]], 
             RowBox[{"2", ",", "3"}], "+"]}], "-", 
           RowBox[{"864", " ", 
            SubsuperscriptBox[
             StyleBox["\[Eta]",
              FontWeight->Bold,
              FontColor->RGBColor[0.8, 0, 0]], 
             RowBox[{"2", ",", "4"}], "+"]}], "+", 
           RowBox[{"144", " ", "\[ImaginaryI]", " ", 
            SubsuperscriptBox[
             StyleBox["\[Eta]",
              FontWeight->Bold,
              FontColor->RGBColor[0.8, 0, 0]], 
             RowBox[{"2", ",", "5"}], "+"]}], "+", 
           RowBox[{"1296", " ", 
            SubsuperscriptBox[
             StyleBox["\[Eta]",
              FontWeight->Bold,
              FontColor->RGBColor[0.8, 0, 0]], 
             RowBox[{"3", ",", "1"}], "+"]}], "-", 
           RowBox[{"2592", " ", "\[ImaginaryI]", " ", 
            SubsuperscriptBox[
             StyleBox["\[Eta]",
              FontWeight->Bold,
              FontColor->RGBColor[0.8, 0, 0]], 
             RowBox[{"3", ",", "2"}], "+"]}], "-", 
           RowBox[{"432", " ", 
            SubsuperscriptBox[
             StyleBox["\[Eta]",
              FontWeight->Bold,
              FontColor->RGBColor[0.8, 0, 0]], 
             RowBox[{"3", ",", "3"}], "+"]}], "+", 
           RowBox[{"48", " ", "\[ImaginaryI]", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "37"}], "+", 
              RowBox[{"18", " ", 
               SubscriptBox[
                StyleBox["\[Zeta]",
                 FontWeight->Bold,
                 FontColor->RGBColor[0.8, 0, 0]], "3"]}]}], ")"}], " ", 
            SubsuperscriptBox[
             StyleBox["\[Eta]",
              FontWeight->Bold,
              FontColor->RGBColor[0.8, 0, 0]], 
             RowBox[{"4", ",", "1"}], "+"]}], "-", 
           RowBox[{"1008", " ", 
            SubsuperscriptBox[
             StyleBox["\[Eta]",
              FontWeight->Bold,
              FontColor->RGBColor[0.8, 0, 0]], 
             RowBox[{"4", ",", "2"}], "+"]}], "-", 
           RowBox[{"312", " ", "\[ImaginaryI]", " ", 
            SubsuperscriptBox[
             StyleBox["\[Eta]",
              FontWeight->Bold,
              FontColor->RGBColor[0.8, 0, 0]], 
             RowBox[{"4", ",", "3"}], "+"]}], "-", 
           RowBox[{"288", " ", 
            SubsuperscriptBox[
             StyleBox["\[Eta]",
              FontWeight->Bold,
              FontColor->RGBColor[0.8, 0, 0]], 
             RowBox[{"4", ",", "4"}], "+"]}], "+", 
           RowBox[{"48", " ", "\[ImaginaryI]", " ", 
            SubsuperscriptBox[
             StyleBox["\[Eta]",
              FontWeight->Bold,
              FontColor->RGBColor[0.8, 0, 0]], 
             RowBox[{"4", ",", "5"}], "+"]}], "-", 
           RowBox[{"1440", " ", 
            SubsuperscriptBox[
             StyleBox["\[Eta]",
              FontWeight->Bold,
              FontColor->RGBColor[0.8, 0, 0]], 
             RowBox[{"5", ",", "1"}], "+"]}], "-", 
           RowBox[{"864", " ", "\[ImaginaryI]", " ", 
            SubsuperscriptBox[
             StyleBox["\[Eta]",
              FontWeight->Bold,
              FontColor->RGBColor[0.8, 0, 0]], 
             RowBox[{"5", ",", "2"}], "+"]}], "-", 
           RowBox[{"144", " ", 
            SubsuperscriptBox[
             StyleBox["\[Eta]",
              FontWeight->Bold,
              FontColor->RGBColor[0.8, 0, 0]], 
             RowBox[{"5", ",", "3"}], "+"]}], "+", 
           RowBox[{"408", " ", "\[ImaginaryI]", " ", 
            SubsuperscriptBox[
             StyleBox["\[Eta]",
              FontWeight->Bold,
              FontColor->RGBColor[0.8, 0, 0]], 
             RowBox[{"6", ",", "1"}], "+"]}], "-", 
           RowBox[{"576", " ", 
            SubsuperscriptBox[
             StyleBox["\[Eta]",
              FontWeight->Bold,
              FontColor->RGBColor[0.8, 0, 0]], 
             RowBox[{"6", ",", "2"}], "+"]}], "+", 
           RowBox[{"96", " ", "\[ImaginaryI]", " ", 
            SubsuperscriptBox[
             StyleBox["\[Eta]",
              FontWeight->Bold,
              FontColor->RGBColor[0.8, 0, 0]], 
             RowBox[{"6", ",", "3"}], "+"]}], "-", 
           RowBox[{"720", " ", 
            SubsuperscriptBox[
             StyleBox["\[Eta]",
              FontWeight->Bold,
              FontColor->RGBColor[0.8, 0, 0]], 
             RowBox[{"7", ",", "1"}], "+"]}], "+", 
           RowBox[{"336", " ", "\[ImaginaryI]", " ", 
            SubsuperscriptBox[
             StyleBox["\[Eta]",
              FontWeight->Bold,
              FontColor->RGBColor[0.8, 0, 0]], 
             RowBox[{"8", ",", "1"}], "+"]}], "+", 
           RowBox[{"2592", " ", 
            SubsuperscriptBox[
             StyleBox["\[Eta]",
              FontWeight->Bold,
              FontColor->RGBColor[0.8, 0, 0]], 
             RowBox[{"2", ",", "1", ",", "1"}], "+"]}], "-", 
           RowBox[{"5184", " ", "\[ImaginaryI]", " ", 
            SubsuperscriptBox[
             StyleBox["\[Eta]",
              FontWeight->Bold,
              FontColor->RGBColor[0.8, 0, 0]], 
             RowBox[{"2", ",", "1", ",", "2"}], "+"]}], "-", 
           RowBox[{"864", " ", 
            SubsuperscriptBox[
             StyleBox["\[Eta]",
              FontWeight->Bold,
              FontColor->RGBColor[0.8, 0, 0]], 
             RowBox[{"2", ",", "1", ",", "3"}], "+"]}], "-", 
           RowBox[{"5184", " ", "\[ImaginaryI]", " ", 
            SubsuperscriptBox[
             StyleBox["\[Eta]",
              FontWeight->Bold,
              FontColor->RGBColor[0.8, 0, 0]], 
             RowBox[{"2", ",", "2", ",", "1"}], "+"]}], "-", 
           RowBox[{"864", " ", 
            SubsuperscriptBox[
             StyleBox["\[Eta]",
              FontWeight->Bold,
              FontColor->RGBColor[0.8, 0, 0]], 
             RowBox[{"2", ",", "3", ",", "1"}], "+"]}], "-", 
           RowBox[{"5184", " ", "\[ImaginaryI]", " ", 
            SubsuperscriptBox[
             StyleBox["\[Eta]",
              FontWeight->Bold,
              FontColor->RGBColor[0.8, 0, 0]], 
             RowBox[{"3", ",", "1", ",", "1"}], "+"]}], "-", 
           RowBox[{"2016", " ", 
            SubsuperscriptBox[
             StyleBox["\[Eta]",
              FontWeight->Bold,
              FontColor->RGBColor[0.8, 0, 0]], 
             RowBox[{"4", ",", "1", ",", "1"}], "+"]}], "-", 
           RowBox[{"1728", " ", "\[ImaginaryI]", " ", 
            SubsuperscriptBox[
             StyleBox["\[Eta]",
              FontWeight->Bold,
              FontColor->RGBColor[0.8, 0, 0]], 
             RowBox[{"4", ",", "1", ",", "2"}], "+"]}], "-", 
           RowBox[{"288", " ", 
            SubsuperscriptBox[
             StyleBox["\[Eta]",
              FontWeight->Bold,
              FontColor->RGBColor[0.8, 0, 0]], 
             RowBox[{"4", ",", "1", ",", "3"}], "+"]}], "-", 
           RowBox[{"1728", " ", "\[ImaginaryI]", " ", 
            SubsuperscriptBox[
             StyleBox["\[Eta]",
              FontWeight->Bold,
              FontColor->RGBColor[0.8, 0, 0]], 
             RowBox[{"4", ",", "2", ",", "1"}], "+"]}], "-", 
           RowBox[{"288", " ", 
            SubsuperscriptBox[
             StyleBox["\[Eta]",
              FontWeight->Bold,
              FontColor->RGBColor[0.8, 0, 0]], 
             RowBox[{"4", ",", "3", ",", "1"}], "+"]}], "-", 
           RowBox[{"1728", " ", "\[ImaginaryI]", " ", 
            SubsuperscriptBox[
             StyleBox["\[Eta]",
              FontWeight->Bold,
              FontColor->RGBColor[0.8, 0, 0]], 
             RowBox[{"5", ",", "1", ",", "1"}], "+"]}], "-", 
           RowBox[{"1152", " ", 
            SubsuperscriptBox[
             StyleBox["\[Eta]",
              FontWeight->Bold,
              FontColor->RGBColor[0.8, 0, 0]], 
             RowBox[{"6", ",", "1", ",", "1"}], "+"]}], "-", 
           RowBox[{"10368", " ", "\[ImaginaryI]", " ", 
            SubsuperscriptBox[
             StyleBox["\[Eta]",
              FontWeight->Bold,
              FontColor->RGBColor[0.8, 0, 0]], 
             RowBox[{"2", ",", "1", ",", "1", ",", "1"}], "+"]}], "-", 
           RowBox[{"3456", " ", "\[ImaginaryI]", " ", 
            SubsuperscriptBox[
             StyleBox["\[Eta]",
              FontWeight->Bold,
              FontColor->RGBColor[0.8, 0, 0]], 
             RowBox[{"4", ",", "1", ",", "1", ",", "1"}], "+"]}]}], ")"}]}]}],
        ")"}]}]}]}]}], "}"}]], "Output",
 CellChangeTimes->{{3.552387690790118*^9, 3.552387719548441*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  SubscriptBox["q", 
   RowBox[{"1", ",", "3"}]], "/.", "reprules2"}]], "Input",
 CellChangeTimes->{{3.552388175576054*^9, 3.55238821211805*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{
    RowBox[{"-", "18"}], " ", 
    SuperscriptBox["g", "4"], " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"\[ImaginaryI]", " ", "u"}], "+", 
      RowBox[{
       StyleBox["Q0",
        FontColor->RGBColor[{
           Rational[1, 2], 
           Rational[1, 2], 0}]], " ", 
       SubsuperscriptBox[
        StyleBox["\[Eta]",
         FontWeight->Bold,
         FontColor->RGBColor[0.8, 0, 0]], "2", "+"]}]}], ")"}]}], ",", 
   RowBox[{
    SuperscriptBox["g", "6"], " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"306", " ", "\[ImaginaryI]", " ", "u"}], "+", 
      RowBox[{"216", " ", "u", " ", 
       SubsuperscriptBox[
        StyleBox["\[Eta]",
         FontWeight->Bold,
         FontColor->RGBColor[0.8, 0, 0]], "1", "+"]}], "+", 
      RowBox[{"24", " ", 
       SubsuperscriptBox[
        StyleBox["\[Eta]",
         FontWeight->Bold,
         FontColor->RGBColor[0.8, 0, 0]], "2", "+"]}], "+", 
      RowBox[{
       StyleBox["Q0",
        FontColor->RGBColor[{
           Rational[1, 2], 
           Rational[1, 2], 0}]], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"90", " ", 
          SubsuperscriptBox[
           StyleBox["\[Eta]",
            FontWeight->Bold,
            FontColor->RGBColor[0.8, 0, 0]], "2", "+"]}], "-", 
         RowBox[{"108", " ", "\[ImaginaryI]", " ", 
          SubsuperscriptBox[
           StyleBox["\[Eta]",
            FontWeight->Bold,
            FontColor->RGBColor[0.8, 0, 0]], "3", "+"]}], "-", 
         RowBox[{"36", " ", 
          SubsuperscriptBox[
           StyleBox["\[Eta]",
            FontWeight->Bold,
            FontColor->RGBColor[0.8, 0, 0]], "4", "+"]}], "-", 
         RowBox[{"216", " ", "\[ImaginaryI]", " ", 
          SubsuperscriptBox[
           StyleBox["\[Eta]",
            FontWeight->Bold,
            FontColor->RGBColor[0.8, 0, 0]], 
           RowBox[{"2", ",", "1"}], "+"]}]}], ")"}]}]}], ")"}]}], ",", 
   RowBox[{
    SuperscriptBox["g", "8"], " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       RowBox[{"-", "4374"}], " ", "\[ImaginaryI]", " ", "u"}], "-", 
      RowBox[{"4536", " ", "u", " ", 
       SubsuperscriptBox[
        StyleBox["\[Eta]",
         FontWeight->Bold,
         FontColor->RGBColor[0.8, 0, 0]], "1", "+"]}], "+", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", "84"}], "+", 
         RowBox[{"1296", " ", "\[ImaginaryI]", " ", "u"}]}], ")"}], " ", 
       SubsuperscriptBox[
        StyleBox["\[Eta]",
         FontWeight->Bold,
         FontColor->RGBColor[0.8, 0, 0]], "2", "+"]}], "+", 
      RowBox[{"72", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"2", " ", "\[ImaginaryI]"}], "+", 
         RowBox[{"3", " ", "u"}]}], ")"}], " ", 
       SubsuperscriptBox[
        StyleBox["\[Eta]",
         FontWeight->Bold,
         FontColor->RGBColor[0.8, 0, 0]], "3", "+"]}], "+", 
      RowBox[{"48", " ", 
       SubsuperscriptBox[
        StyleBox["\[Eta]",
         FontWeight->Bold,
         FontColor->RGBColor[0.8, 0, 0]], "4", "+"]}], "+", 
      RowBox[{"2592", " ", "\[ImaginaryI]", " ", "u", " ", 
       SubsuperscriptBox[
        StyleBox["\[Eta]",
         FontWeight->Bold,
         FontColor->RGBColor[0.8, 0, 0]], 
        RowBox[{"1", ",", "1"}], "+"]}], "+", 
      RowBox[{"288", " ", "\[ImaginaryI]", " ", 
       SubsuperscriptBox[
        StyleBox["\[Eta]",
         FontWeight->Bold,
         FontColor->RGBColor[0.8, 0, 0]], 
        RowBox[{"2", ",", "1"}], "+"]}], "+", 
      RowBox[{
       StyleBox["Q0",
        FontColor->RGBColor[{
           Rational[1, 2], 
           Rational[1, 2], 0}]], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"162", " ", 
          SubsuperscriptBox[
           StyleBox["\[Eta]",
            FontWeight->Bold,
            FontColor->RGBColor[0.8, 0, 0]], "2", "+"]}], "+", 
         RowBox[{"972", " ", "\[ImaginaryI]", " ", 
          SubsuperscriptBox[
           StyleBox["\[Eta]",
            FontWeight->Bold,
            FontColor->RGBColor[0.8, 0, 0]], "3", "+"]}], "+", 
         RowBox[{"504", " ", 
          SubsuperscriptBox[
           StyleBox["\[Eta]",
            FontWeight->Bold,
            FontColor->RGBColor[0.8, 0, 0]], "4", "+"]}], "-", 
         RowBox[{"324", " ", "\[ImaginaryI]", " ", 
          SubsuperscriptBox[
           StyleBox["\[Eta]",
            FontWeight->Bold,
            FontColor->RGBColor[0.8, 0, 0]], "5", "+"]}], "-", 
         RowBox[{"90", " ", 
          SubsuperscriptBox[
           StyleBox["\[Eta]",
            FontWeight->Bold,
            FontColor->RGBColor[0.8, 0, 0]], "6", "+"]}], "+", 
         RowBox[{"1944", " ", "\[ImaginaryI]", " ", 
          SubsuperscriptBox[
           StyleBox["\[Eta]",
            FontWeight->Bold,
            FontColor->RGBColor[0.8, 0, 0]], 
           RowBox[{"2", ",", "1"}], "+"]}], "+", 
         RowBox[{"1296", " ", 
          SubsuperscriptBox[
           StyleBox["\[Eta]",
            FontWeight->Bold,
            FontColor->RGBColor[0.8, 0, 0]], 
           RowBox[{"2", ",", "2"}], "+"]}], "-", 
         RowBox[{"216", " ", "\[ImaginaryI]", " ", 
          SubsuperscriptBox[
           StyleBox["\[Eta]",
            FontWeight->Bold,
            FontColor->RGBColor[0.8, 0, 0]], 
           RowBox[{"2", ",", "3"}], "+"]}], "+", 
         RowBox[{"1296", " ", 
          SubsuperscriptBox[
           StyleBox["\[Eta]",
            FontWeight->Bold,
            FontColor->RGBColor[0.8, 0, 0]], 
           RowBox[{"3", ",", "1"}], "+"]}], "-", 
         RowBox[{"432", " ", "\[ImaginaryI]", " ", 
          SubsuperscriptBox[
           StyleBox["\[Eta]",
            FontWeight->Bold,
            FontColor->RGBColor[0.8, 0, 0]], 
           RowBox[{"4", ",", "1"}], "+"]}], "+", 
         RowBox[{"2592", " ", 
          SubsuperscriptBox[
           StyleBox["\[Eta]",
            FontWeight->Bold,
            FontColor->RGBColor[0.8, 0, 0]], 
           RowBox[{"2", ",", "1", ",", "1"}], "+"]}]}], ")"}]}]}], ")"}]}]}], 
  "}"}]], "Output",
 CellChangeTimes->{{3.552388179303364*^9, 3.5523882126199617`*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Series", "[", 
  RowBox[{
   FractionBox[
    RowBox[{
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         SubscriptBox["q", 
          RowBox[{"2", ",", "4"}]], "/.", "weakqij"}], "/.", 
        RowBox[{
         SubscriptBox["\[Zeta]", "1"], "\[Rule]", "0"}]}], ")"}], "-", 
      RowBox[{"Total", "[", 
       RowBox[{
        SubscriptBox["q", 
         RowBox[{"2", ",", "4"}]], "/.", "reprules2"}], "]"}]}], "//", 
     "Simplify"}], 
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       SubscriptBox["q", 
        RowBox[{"2", ",", "4"}]], "/.", "reprules2"}], ")"}], "[", 
     RowBox[{"[", 
      RowBox[{"-", "1"}], "]"}], "]"}]], ",", 
   RowBox[{"{", 
    RowBox[{"g", ",", "0", ",", "1"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.5523882181242847`*^9, 3.55238834327913*^9}}],

Cell[BoxData["$Aborted"], "Output",
 CellChangeTimes->{{3.552388239836155*^9, 3.552388256502141*^9}, 
   3.552388288579072*^9, {3.552388319820518*^9, 3.552388346475428*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     RowBox[{
      SubscriptBox["q", 
       RowBox[{"2", ",", "4"}]], "/.", 
      RowBox[{"leadweak", "[", "3", "]"}]}], "/.", 
     RowBox[{
      SubscriptBox["\[Zeta]", "1"], "\[Rule]", "0"}]}], ")"}], "-", 
   RowBox[{"Total", "[", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       SubscriptBox["q", 
        RowBox[{"2", ",", "4"}]], "/.", "reprules2"}], ")"}], "[", 
     RowBox[{"[", 
      RowBox[{"1", ";;", "2"}], "]"}], "]"}], "]"}], "-", 
   FractionBox[
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       SubscriptBox["q", 
        RowBox[{"2", ",", "4"}]], "/.", "reprules2"}], ")"}], "[", 
     RowBox[{"[", 
      RowBox[{"-", "1"}], "]"}], "]"}], 
    RowBox[{"1", "/", "6"}]]}], "//", "Simplify"}]], "Input",
 CellChangeTimes->{{3.5523883580575333`*^9, 3.552388483798299*^9}}],

Cell[BoxData[
 RowBox[{"72", " ", 
  SuperscriptBox["g", "8"], " ", 
  SubscriptBox[
   StyleBox["\[Zeta]",
    FontWeight->Bold,
    FontColor->RGBColor[0.8, 0, 0]], "3"], " ", 
  RowBox[{"(", 
   RowBox[{
    RowBox[{"3", " ", "\[ImaginaryI]", " ", "u"}], "+", 
    RowBox[{
     StyleBox["Q0",
      FontColor->RGBColor[{
         Rational[1, 2], 
         Rational[1, 2], 0}]], " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"3", " ", 
        SubsuperscriptBox[
         StyleBox["\[Eta]",
          FontWeight->Bold,
          FontColor->RGBColor[0.8, 0, 0]], "2", "+"]}], "+", 
       SubsuperscriptBox[
        StyleBox["\[Eta]",
         FontWeight->Bold,
         FontColor->RGBColor[0.8, 0, 0]], "4", "+"]}], ")"}]}]}], 
   ")"}]}]], "Output",
 CellChangeTimes->{{3.552388365998645*^9, 3.552388379435013*^9}, {
  3.552388414432392*^9, 3.552388484254631*^9}}]
}, Open  ]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 "Explicit expressions for weak coupling of ",
 Cell[BoxData[
  FormBox[
   RowBox[{
    SubscriptBox["q", "3"], ",", 
    SubscriptBox["q", "4"]}], TraditionalForm]]],
 ", ",
 Cell[BoxData[
  FormBox[
   SubscriptBox["q", 
    RowBox[{"3", ",", "4"}]], TraditionalForm]]],
 ",",
 Cell[BoxData[
  FormBox[
   SubscriptBox["W", "s"], TraditionalForm]]],
 " and ",
 Cell[BoxData[
  FormBox[
   SubscriptBox[
    OverscriptBox["W", "^"], "pv"], TraditionalForm]]]
}], "Subsection",
 CellChangeTimes->{{3.55022664718054*^9, 3.5502266485896187`*^9}, {
  3.550226686196568*^9, 3.550226732809936*^9}, {3.550227649621166*^9, 
  3.5502276545232563`*^9}, {3.550230216917904*^9, 3.550230237193983*^9}, {
  3.550295673435166*^9, 3.550295719823838*^9}, {3.55029633028043*^9, 
  3.550296332055595*^9}, {3.550385854651433*^9, 3.5503858571059313`*^9}}],

Cell[CellGroupData[{

Cell["Usage", "Subsubsection",
 CellChangeTimes->{{3.541066491268599*^9, 3.541066492391665*^9}, {
  3.5503854746741056`*^9, 3.550385499279208*^9}}],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  SubscriptBox["q", "4"], "/.", 
  RowBox[{"leadweak", "[", "1", "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  SubscriptBox["q", "3"], "/.", "weakqij"}]}], "Input",
 CellChangeTimes->{{3.5503855207437353`*^9, 3.550385541887951*^9}}],

Cell[BoxData[
 RowBox[{
  SuperscriptBox["g", "4"], " ", 
  RowBox[{"(", 
   RowBox[{
    RowBox[{"-", 
     FractionBox[
      RowBox[{"3", " ", "\[ImaginaryI]"}], "u"]}], "-", 
    RowBox[{"6", " ", 
     SubsuperscriptBox[
      StyleBox["\[Eta]",
       FontWeight->Bold,
       FontColor->RGBColor[0.8, 0, 0]], "2", 
      RowBox[{"[", "2", "]"}]]}], "+", 
    FractionBox[
     RowBox[{"2", " ", 
      SubsuperscriptBox[
       StyleBox["\[Eta]",
        FontWeight->Bold,
        FontColor->RGBColor[0.8, 0, 0]], "3", 
       RowBox[{"[", "2", "]"}]]}], "u"], "+", 
    RowBox[{"6", " ", "u", " ", 
     SubsuperscriptBox[
      StyleBox["\[Eta]",
       FontWeight->Bold,
       FontColor->RGBColor[0.8, 0, 0]], "3", 
      RowBox[{"[", "2", "]"}]]}], "-", 
    RowBox[{"2", " ", 
     SubsuperscriptBox[
      StyleBox["\[Eta]",
       FontWeight->Bold,
       FontColor->RGBColor[0.8, 0, 0]], "4", 
      RowBox[{"[", "2", "]"}]]}]}], ")"}]}]], "Output",
 CellChangeTimes->{{3.550385526898115*^9, 3.5503855423853407`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   SuperscriptBox["g", "4"], " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"-", "18"}], "+", 
     FractionBox[
      RowBox[{"9", " ", "\[ImaginaryI]"}], "u"], "+", 
     FractionBox[
      RowBox[{"6", " ", "\[ImaginaryI]", " ", 
       RowBox[{"(", 
        RowBox[{"1", "+", 
         RowBox[{"3", " ", 
          SuperscriptBox["u", "2"]}]}], ")"}], " ", 
       SubsuperscriptBox[
        StyleBox["\[Eta]",
         FontWeight->Bold,
         FontColor->RGBColor[0.8, 0, 0]], "2", 
        RowBox[{"[", "2", "]"}]]}], "u"], "-", 
     RowBox[{"6", " ", "\[ImaginaryI]", " ", 
      SubsuperscriptBox[
       StyleBox["\[Eta]",
        FontWeight->Bold,
        FontColor->RGBColor[0.8, 0, 0]], "3", 
       RowBox[{"[", "2", "]"}]]}]}], ")"}]}], "+", 
  RowBox[{
   SuperscriptBox["g", "6"], " ", 
   RowBox[{"(", 
    RowBox[{
     FractionBox[
      RowBox[{"9", " ", 
       RowBox[{"(", 
        RowBox[{"\[ImaginaryI]", "-", "u", "-", 
         RowBox[{"17", " ", "\[ImaginaryI]", " ", 
          SuperscriptBox["u", "2"]}], "+", 
         RowBox[{"34", " ", 
          SuperscriptBox["u", "3"]}]}], ")"}]}], 
      SuperscriptBox["u", "3"]], "+", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         RowBox[{"-", "216"}], " ", "\[ImaginaryI]"}], "-", 
        FractionBox["108", "u"]}], ")"}], " ", 
      SubsuperscriptBox[
       StyleBox["\[Eta]",
        FontWeight->Bold,
        FontColor->RGBColor[0.8, 0, 0]], "1", 
       RowBox[{"[", "2", "]"}]]}], "-", 
     FractionBox[
      RowBox[{"6", " ", "\[ImaginaryI]", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", "1"}], "+", 
         SuperscriptBox["u", "2"], "+", 
         RowBox[{"15", " ", 
          SuperscriptBox["u", "4"]}]}], ")"}], " ", 
       SubsuperscriptBox[
        StyleBox["\[Eta]",
         FontWeight->Bold,
         FontColor->RGBColor[0.8, 0, 0]], "2", 
        RowBox[{"[", "2", "]"}]]}], 
      SuperscriptBox["u", "3"]], "-", 
     FractionBox[
      RowBox[{"12", " ", 
       RowBox[{"(", 
        RowBox[{"3", "+", 
         RowBox[{"\[ImaginaryI]", " ", "u"}], "+", 
         RowBox[{"9", " ", 
          SuperscriptBox["u", "2"]}]}], ")"}], " ", 
       SubsuperscriptBox[
        StyleBox["\[Eta]",
         FontWeight->Bold,
         FontColor->RGBColor[0.8, 0, 0]], "3", 
        RowBox[{"[", "2", "]"}]]}], "u"], "+", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"36", "+", 
        FractionBox[
         RowBox[{"12", " ", "\[ImaginaryI]"}], "u"], "+", 
        RowBox[{"36", " ", "\[ImaginaryI]", " ", "u"}]}], ")"}], " ", 
      SubsuperscriptBox[
       StyleBox["\[Eta]",
        FontWeight->Bold,
        FontColor->RGBColor[0.8, 0, 0]], "4", 
       RowBox[{"[", "2", "]"}]]}], "-", 
     RowBox[{"18", " ", "\[ImaginaryI]", " ", 
      SubsuperscriptBox[
       StyleBox["\[Eta]",
        FontWeight->Bold,
        FontColor->RGBColor[0.8, 0, 0]], "5", 
       RowBox[{"[", "2", "]"}]]}], "-", 
     FractionBox[
      RowBox[{"72", " ", 
       RowBox[{"(", 
        RowBox[{"1", "+", 
         RowBox[{"3", " ", 
          SuperscriptBox["u", "2"]}]}], ")"}], " ", 
       SubsuperscriptBox[
        StyleBox["\[Eta]",
         FontWeight->Bold,
         FontColor->RGBColor[0.8, 0, 0]], 
        RowBox[{"2", ",", "1"}], 
        RowBox[{"[", "2", "]"}]]}], "u"], "+", 
     RowBox[{"72", " ", 
      SubsuperscriptBox[
       StyleBox["\[Eta]",
        FontWeight->Bold,
        FontColor->RGBColor[0.8, 0, 0]], 
       RowBox[{"3", ",", "1"}], 
       RowBox[{"[", "2", "]"}]]}]}], ")"}]}], "+", 
  RowBox[{
   SuperscriptBox["g", "8"], " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"-", 
      FractionBox[
       RowBox[{"9", " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{
           RowBox[{"-", "2"}], " ", "\[ImaginaryI]"}], "+", 
          RowBox[{"2", " ", "u"}], "+", 
          RowBox[{"17", " ", "\[ImaginaryI]", " ", 
           SuperscriptBox["u", "2"]}], "-", 
          RowBox[{"23", " ", 
           SuperscriptBox["u", "3"]}], "-", 
          RowBox[{"243", " ", "\[ImaginaryI]", " ", 
           SuperscriptBox["u", "4"]}], "+", 
          RowBox[{"486", " ", 
           SuperscriptBox["u", "5"]}]}], ")"}]}], 
       SuperscriptBox["u", "5"]]}], "+", 
     FractionBox[
      RowBox[{"108", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", "1"}], "-", 
         RowBox[{"\[ImaginaryI]", " ", "u"}], "+", 
         RowBox[{"21", " ", 
          SuperscriptBox["u", "2"]}], "+", 
         RowBox[{"42", " ", "\[ImaginaryI]", " ", 
          SuperscriptBox["u", "3"]}]}], ")"}], " ", 
       SubsuperscriptBox[
        StyleBox["\[Eta]",
         FontWeight->Bold,
         FontColor->RGBColor[0.8, 0, 0]], "1", 
        RowBox[{"[", "2", "]"}]]}], 
      SuperscriptBox["u", "3"]], "-", 
     FractionBox[
      RowBox[{"6", " ", "\[ImaginaryI]", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", "2"}], "+", 
         SuperscriptBox["u", "2"], "+", 
         RowBox[{"149", " ", 
          SuperscriptBox["u", "4"]}], "+", 
         RowBox[{"216", " ", "\[ImaginaryI]", " ", 
          SuperscriptBox["u", "5"]}], "+", 
         RowBox[{"27", " ", 
          SuperscriptBox["u", "6"]}]}], ")"}], " ", 
       SubsuperscriptBox[
        StyleBox["\[Eta]",
         FontWeight->Bold,
         FontColor->RGBColor[0.8, 0, 0]], "2", 
        RowBox[{"[", "2", "]"}]]}], 
      SuperscriptBox["u", "5"]], "+", 
     RowBox[{"12", " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         RowBox[{"-", "8"}], " ", "\[ImaginaryI]"}], "-", 
        FractionBox["3", 
         SuperscriptBox["u", "3"]], "+", 
        FractionBox["6", "u"], "+", 
        RowBox[{"81", " ", "u"}]}], ")"}], " ", 
      SubsuperscriptBox[
       StyleBox["\[Eta]",
        FontWeight->Bold,
        FontColor->RGBColor[0.8, 0, 0]], "3", 
       RowBox[{"[", "2", "]"}]]}], "+", 
     RowBox[{"12", " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "6"}], "+", 
        FractionBox["\[ImaginaryI]", 
         SuperscriptBox["u", "3"]], "-", 
        FractionBox[
         RowBox[{"10", " ", "\[ImaginaryI]"}], "u"], "-", 
        RowBox[{"42", " ", "\[ImaginaryI]", " ", "u"}]}], ")"}], " ", 
      SubsuperscriptBox[
       StyleBox["\[Eta]",
        FontWeight->Bold,
        FontColor->RGBColor[0.8, 0, 0]], "4", 
       RowBox[{"[", "2", "]"}]]}], "+", 
     RowBox[{"36", " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"2", " ", "\[ImaginaryI]"}], "-", 
        FractionBox["3", "u"], "-", 
        RowBox[{"9", " ", "u"}]}], ")"}], " ", 
      SubsuperscriptBox[
       StyleBox["\[Eta]",
        FontWeight->Bold,
        FontColor->RGBColor[0.8, 0, 0]], "5", 
       RowBox[{"[", "2", "]"}]]}], "+", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"144", "+", 
        FractionBox[
         RowBox[{"30", " ", "\[ImaginaryI]"}], "u"], "+", 
        RowBox[{"90", " ", "\[ImaginaryI]", " ", "u"}]}], ")"}], " ", 
      SubsuperscriptBox[
       StyleBox["\[Eta]",
        FontWeight->Bold,
        FontColor->RGBColor[0.8, 0, 0]], "6", 
       RowBox[{"[", "2", "]"}]]}], "-", 
     RowBox[{"54", " ", "\[ImaginaryI]", " ", 
      SubsuperscriptBox[
       StyleBox["\[Eta]",
        FontWeight->Bold,
        FontColor->RGBColor[0.8, 0, 0]], "7", 
       RowBox[{"[", "2", "]"}]]}], "+", 
     FractionBox[
      RowBox[{"1296", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", "\[ImaginaryI]"}], "+", 
         RowBox[{"2", " ", "u"}]}], ")"}], " ", 
       SubsuperscriptBox[
        StyleBox["\[Eta]",
         FontWeight->Bold,
         FontColor->RGBColor[0.8, 0, 0]], 
        RowBox[{"1", ",", "1"}], 
        RowBox[{"[", "2", "]"}]]}], "u"], "+", 
     FractionBox[
      RowBox[{"72", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", "1"}], "+", 
         RowBox[{"5", " ", 
          SuperscriptBox["u", "2"]}], "+", 
         RowBox[{"27", " ", 
          SuperscriptBox["u", "4"]}]}], ")"}], " ", 
       SubsuperscriptBox[
        StyleBox["\[Eta]",
         FontWeight->Bold,
         FontColor->RGBColor[0.8, 0, 0]], 
        RowBox[{"2", ",", "1"}], 
        RowBox[{"[", "2", "]"}]]}], 
      SuperscriptBox["u", "3"]], "-", 
     FractionBox[
      RowBox[{"432", " ", "\[ImaginaryI]", " ", 
       RowBox[{"(", 
        RowBox[{"1", "+", 
         RowBox[{"3", " ", 
          SuperscriptBox["u", "2"]}]}], ")"}], " ", 
       SubsuperscriptBox[
        StyleBox["\[Eta]",
         FontWeight->Bold,
         FontColor->RGBColor[0.8, 0, 0]], 
        RowBox[{"2", ",", "2"}], 
        RowBox[{"[", "2", "]"}]]}], "u"], "-", 
     FractionBox[
      RowBox[{"72", " ", 
       RowBox[{"(", 
        RowBox[{"1", "+", 
         RowBox[{"3", " ", 
          SuperscriptBox["u", "2"]}]}], ")"}], " ", 
       SubsuperscriptBox[
        StyleBox["\[Eta]",
         FontWeight->Bold,
         FontColor->RGBColor[0.8, 0, 0]], 
        RowBox[{"2", ",", "3"}], 
        RowBox[{"[", "2", "]"}]]}], "u"], "-", 
     FractionBox[
      RowBox[{"144", " ", "\[ImaginaryI]", " ", 
       RowBox[{"(", 
        RowBox[{"3", "-", 
         RowBox[{"\[ImaginaryI]", " ", "u"}], "+", 
         RowBox[{"9", " ", 
          SuperscriptBox["u", "2"]}]}], ")"}], " ", 
       SubsuperscriptBox[
        StyleBox["\[Eta]",
         FontWeight->Bold,
         FontColor->RGBColor[0.8, 0, 0]], 
        RowBox[{"3", ",", "1"}], 
        RowBox[{"[", "2", "]"}]]}], "u"], "+", 
     RowBox[{"432", " ", "\[ImaginaryI]", " ", 
      SubsuperscriptBox[
       StyleBox["\[Eta]",
        FontWeight->Bold,
        FontColor->RGBColor[0.8, 0, 0]], 
       RowBox[{"3", ",", "2"}], 
       RowBox[{"[", "2", "]"}]]}], "+", 
     RowBox[{"72", " ", 
      SubsuperscriptBox[
       StyleBox["\[Eta]",
        FontWeight->Bold,
        FontColor->RGBColor[0.8, 0, 0]], 
       RowBox[{"3", ",", "3"}], 
       RowBox[{"[", "2", "]"}]]}], "+", 
     RowBox[{"144", " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"3", " ", "\[ImaginaryI]"}], "-", 
        FractionBox["1", "u"], "-", 
        RowBox[{"3", " ", "u"}]}], ")"}], " ", 
      SubsuperscriptBox[
       StyleBox["\[Eta]",
        FontWeight->Bold,
        FontColor->RGBColor[0.8, 0, 0]], 
       RowBox[{"4", ",", "1"}], 
       RowBox[{"[", "2", "]"}]]}], "+", 
     RowBox[{"216", " ", 
      SubsuperscriptBox[
       StyleBox["\[Eta]",
        FontWeight->Bold,
        FontColor->RGBColor[0.8, 0, 0]], 
       RowBox[{"5", ",", "1"}], 
       RowBox[{"[", "2", "]"}]]}], "-", 
     FractionBox[
      RowBox[{"864", " ", "\[ImaginaryI]", " ", 
       RowBox[{"(", 
        RowBox[{"1", "+", 
         RowBox[{"3", " ", 
          SuperscriptBox["u", "2"]}]}], ")"}], " ", 
       SubsuperscriptBox[
        StyleBox["\[Eta]",
         FontWeight->Bold,
         FontColor->RGBColor[0.8, 0, 0]], 
        RowBox[{"2", ",", "1", ",", "1"}], 
        RowBox[{"[", "2", "]"}]]}], "u"], "+", 
     RowBox[{"864", " ", "\[ImaginaryI]", " ", 
      SubsuperscriptBox[
       StyleBox["\[Eta]",
        FontWeight->Bold,
        FontColor->RGBColor[0.8, 0, 0]], 
       RowBox[{"3", ",", "1", ",", "1"}], 
       RowBox[{"[", "2", "]"}]]}]}], ")"}]}], "+", 
  RowBox[{
   SuperscriptBox["g", "10"], " ", 
   RowBox[{"(", 
    RowBox[{
     FractionBox[
      RowBox[{"9", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"5", " ", "\[ImaginaryI]"}], "-", 
         RowBox[{"5", " ", "u"}], "-", 
         RowBox[{"34", " ", "\[ImaginaryI]", " ", 
          SuperscriptBox["u", "2"]}], "+", 
         RowBox[{"43", " ", 
          SuperscriptBox["u", "3"]}], "+", 
         RowBox[{"252", " ", "\[ImaginaryI]", " ", 
          SuperscriptBox["u", "4"]}], "-", 
         RowBox[{"387", " ", 
          SuperscriptBox["u", "5"]}], "-", 
         RowBox[{"\[ImaginaryI]", " ", 
          SuperscriptBox["u", "6"], " ", 
          RowBox[{"(", 
           RowBox[{"3241", "+", 
            RowBox[{"120", " ", 
             RowBox[{"Zeta", "[", "3", "]"}]}]}], ")"}]}], "+", 
         RowBox[{
          SuperscriptBox["u", "7"], " ", 
          RowBox[{"(", 
           RowBox[{"6482", "+", 
            RowBox[{"240", " ", 
             RowBox[{"Zeta", "[", "3", "]"}]}]}], ")"}]}]}], ")"}]}], 
      SuperscriptBox["u", "7"]], "+", 
     FractionBox[
      RowBox[{"108", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", "2"}], "-", 
         RowBox[{"2", " ", "\[ImaginaryI]", " ", "u"}], "+", 
         RowBox[{"21", " ", 
          SuperscriptBox["u", "2"]}], "+", 
         RowBox[{"27", " ", "\[ImaginaryI]", " ", 
          SuperscriptBox["u", "3"]}], "-", 
         RowBox[{"339", " ", 
          SuperscriptBox["u", "4"]}], "-", 
         RowBox[{"678", " ", "\[ImaginaryI]", " ", 
          SuperscriptBox["u", "5"]}]}], ")"}], " ", 
       SubsuperscriptBox[
        StyleBox["\[Eta]",
         FontWeight->Bold,
         FontColor->RGBColor[0.8, 0, 0]], "1", 
        RowBox[{"[", "2", "]"}]]}], 
      SuperscriptBox["u", "5"]], "-", 
     FractionBox[
      RowBox[{"6", " ", "\[ImaginaryI]", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", "5"}], "+", 
         RowBox[{"2", " ", 
          SuperscriptBox["u", "2"]}], "+", 
         RowBox[{"149", " ", 
          SuperscriptBox["u", "4"]}], "+", 
         RowBox[{"108", " ", "\[ImaginaryI]", " ", 
          SuperscriptBox["u", "5"]}], "-", 
         RowBox[{"5400", " ", "\[ImaginaryI]", " ", 
          SuperscriptBox["u", "7"]}], "+", 
         RowBox[{
          SuperscriptBox["u", "6"], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"-", "3626"}], "+", 
            RowBox[{"96", " ", 
             RowBox[{"Zeta", "[", "3", "]"}]}]}], ")"}]}], "+", 
         RowBox[{"3", " ", 
          SuperscriptBox["u", "8"], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"-", "827"}], "+", 
            RowBox[{"120", " ", 
             RowBox[{"Zeta", "[", "3", "]"}]}]}], ")"}]}]}], ")"}], " ", 
       SubsuperscriptBox[
        StyleBox["\[Eta]",
         FontWeight->Bold,
         FontColor->RGBColor[0.8, 0, 0]], "2", 
        RowBox[{"[", "2", "]"}]]}], 
      SuperscriptBox["u", "7"]], "-", 
     FractionBox[
      RowBox[{"12", " ", 
       RowBox[{"(", 
        RowBox[{"6", "-", 
         RowBox[{"6", " ", 
          SuperscriptBox["u", "2"]}], "+", 
         RowBox[{"9", " ", "\[ImaginaryI]", " ", 
          SuperscriptBox["u", "3"]}], "-", 
         RowBox[{"432", " ", 
          SuperscriptBox["u", "4"]}], "+", 
         RowBox[{"351", " ", 
          SuperscriptBox["u", "6"]}], "-", 
         RowBox[{"2", " ", "\[ImaginaryI]", " ", 
          SuperscriptBox["u", "5"], " ", 
          RowBox[{"(", 
           RowBox[{"349", "+", 
            RowBox[{"6", " ", 
             RowBox[{"Zeta", "[", "3", "]"}]}]}], ")"}]}]}], ")"}], " ", 
       SubsuperscriptBox[
        StyleBox["\[Eta]",
         FontWeight->Bold,
         FontColor->RGBColor[0.8, 0, 0]], "3", 
        RowBox[{"[", "2", "]"}]]}], 
      SuperscriptBox["u", "5"]], "+", 
     FractionBox[
      RowBox[{"24", " ", "\[ImaginaryI]", " ", 
       RowBox[{"(", 
        RowBox[{"1", "-", 
         RowBox[{"5", " ", 
          SuperscriptBox["u", "2"]}], "-", 
         RowBox[{"108", " ", "\[ImaginaryI]", " ", 
          SuperscriptBox["u", "5"]}], "+", 
         RowBox[{"18", " ", 
          SuperscriptBox["u", "6"], " ", 
          RowBox[{"(", 
           RowBox[{"9", "+", 
            RowBox[{"Zeta", "[", "3", "]"}]}], ")"}]}], "+", 
         RowBox[{
          SuperscriptBox["u", "4"], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"-", "34"}], "+", 
            RowBox[{"6", " ", 
             RowBox[{"Zeta", "[", "3", "]"}]}]}], ")"}]}]}], ")"}], " ", 
       SubsuperscriptBox[
        StyleBox["\[Eta]",
         FontWeight->Bold,
         FontColor->RGBColor[0.8, 0, 0]], "4", 
        RowBox[{"[", "2", "]"}]]}], 
      SuperscriptBox["u", "5"]], "+", 
     FractionBox[
      RowBox[{"36", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", "3"}], "+", 
         RowBox[{"15", " ", 
          SuperscriptBox["u", "2"]}], "+", 
         RowBox[{"99", " ", 
          SuperscriptBox["u", "4"]}], "-", 
         RowBox[{"4", " ", "\[ImaginaryI]", " ", 
          SuperscriptBox["u", "3"], " ", 
          RowBox[{"(", 
           RowBox[{"5", "+", 
            RowBox[{"Zeta", "[", "3", "]"}]}], ")"}]}]}], ")"}], " ", 
       SubsuperscriptBox[
        StyleBox["\[Eta]",
         FontWeight->Bold,
         FontColor->RGBColor[0.8, 0, 0]], "5", 
        RowBox[{"[", "2", "]"}]]}], 
      SuperscriptBox["u", "3"]], "-", 
     FractionBox[
      RowBox[{"6", " ", "\[ImaginaryI]", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", "5"}], "+", 
         RowBox[{"77", " ", 
          SuperscriptBox["u", "2"]}], "-", 
         RowBox[{"84", " ", "\[ImaginaryI]", " ", 
          SuperscriptBox["u", "3"]}], "+", 
         RowBox[{"291", " ", 
          SuperscriptBox["u", "4"]}]}], ")"}], " ", 
       SubsuperscriptBox[
        StyleBox["\[Eta]",
         FontWeight->Bold,
         FontColor->RGBColor[0.8, 0, 0]], "6", 
        RowBox[{"[", "2", "]"}]]}], 
      SuperscriptBox["u", "3"]], "+", 
     RowBox[{"108", " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"4", " ", "\[ImaginaryI]"}], "-", 
        FractionBox["3", "u"], "-", 
        RowBox[{"9", " ", "u"}]}], ")"}], " ", 
      SubsuperscriptBox[
       StyleBox["\[Eta]",
        FontWeight->Bold,
        FontColor->RGBColor[0.8, 0, 0]], "7", 
       RowBox[{"[", "2", "]"}]]}], "+", 
     RowBox[{"84", " ", 
      RowBox[{"(", 
       RowBox[{"6", "+", 
        FractionBox["\[ImaginaryI]", "u"], "+", 
        RowBox[{"3", " ", "\[ImaginaryI]", " ", "u"}]}], ")"}], " ", 
      SubsuperscriptBox[
       StyleBox["\[Eta]",
        FontWeight->Bold,
        FontColor->RGBColor[0.8, 0, 0]], "8", 
       RowBox[{"[", "2", "]"}]]}], "-", 
     RowBox[{"168", " ", "\[ImaginaryI]", " ", 
      SubsuperscriptBox[
       StyleBox["\[Eta]",
        FontWeight->Bold,
        FontColor->RGBColor[0.8, 0, 0]], "9", 
       RowBox[{"[", "2", "]"}]]}], "-", 
     FractionBox[
      RowBox[{"1296", " ", 
       RowBox[{"(", 
        RowBox[{"\[ImaginaryI]", "-", "u", "-", 
         RowBox[{"25", " ", "\[ImaginaryI]", " ", 
          SuperscriptBox["u", "2"]}], "+", 
         RowBox[{"50", " ", 
          SuperscriptBox["u", "3"]}]}], ")"}], " ", 
       SubsuperscriptBox[
        StyleBox["\[Eta]",
         FontWeight->Bold,
         FontColor->RGBColor[0.8, 0, 0]], 
        RowBox[{"1", ",", "1"}], 
        RowBox[{"[", "2", "]"}]]}], 
      SuperscriptBox["u", "3"]], "+", 
     FractionBox[
      RowBox[{"7776", " ", 
       RowBox[{"(", 
        RowBox[{"1", "+", 
         RowBox[{"2", " ", "\[ImaginaryI]", " ", "u"}]}], ")"}], " ", 
       SubsuperscriptBox[
        StyleBox["\[Eta]",
         FontWeight->Bold,
         FontColor->RGBColor[0.8, 0, 0]], 
        RowBox[{"1", ",", "2"}], 
        RowBox[{"[", "2", "]"}]]}], "u"], "+", 
     FractionBox[
      RowBox[{"1296", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", "\[ImaginaryI]"}], "+", 
         RowBox[{"2", " ", "u"}]}], ")"}], " ", 
       SubsuperscriptBox[
        StyleBox["\[Eta]",
         FontWeight->Bold,
         FontColor->RGBColor[0.8, 0, 0]], 
        RowBox[{"1", ",", "3"}], 
        RowBox[{"[", "2", "]"}]]}], "u"], "-", 
     FractionBox[
      RowBox[{"72", " ", 
       RowBox[{"(", 
        RowBox[{"2", "-", 
         RowBox[{"5", " ", 
          SuperscriptBox["u", "2"]}], "-", 
         RowBox[{"117", " ", 
          SuperscriptBox["u", "4"]}], "-", 
         RowBox[{"216", " ", "\[ImaginaryI]", " ", 
          SuperscriptBox["u", "5"]}], "+", 
         RowBox[{"117", " ", 
          SuperscriptBox["u", "6"]}]}], ")"}], " ", 
       SubsuperscriptBox[
        StyleBox["\[Eta]",
         FontWeight->Bold,
         FontColor->RGBColor[0.8, 0, 0]], 
        RowBox[{"2", ",", "1"}], 
        RowBox[{"[", "2", "]"}]]}], 
      SuperscriptBox["u", "5"]], "+", 
     FractionBox[
      RowBox[{"432", " ", "\[ImaginaryI]", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", "1"}], "+", 
         RowBox[{"9", " ", 
          SuperscriptBox["u", "2"]}], "+", 
         RowBox[{"39", " ", 
          SuperscriptBox["u", "4"]}]}], ")"}], " ", 
       SubsuperscriptBox[
        StyleBox["\[Eta]",
         FontWeight->Bold,
         FontColor->RGBColor[0.8, 0, 0]], 
        RowBox[{"2", ",", "2"}], 
        RowBox[{"[", "2", "]"}]]}], 
      SuperscriptBox["u", "3"]], "+", 
     FractionBox[
      RowBox[{"72", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", "1"}], "+", 
         RowBox[{"29", " ", 
          SuperscriptBox["u", "2"]}], "+", 
         RowBox[{"99", " ", 
          SuperscriptBox["u", "4"]}]}], ")"}], " ", 
       SubsuperscriptBox[
        StyleBox["\[Eta]",
         FontWeight->Bold,
         FontColor->RGBColor[0.8, 0, 0]], 
        RowBox[{"2", ",", "3"}], 
        RowBox[{"[", "2", "]"}]]}], 
      SuperscriptBox["u", "3"]], "-", 
     FractionBox[
      RowBox[{"864", " ", "\[ImaginaryI]", " ", 
       RowBox[{"(", 
        RowBox[{"1", "+", 
         RowBox[{"3", " ", 
          SuperscriptBox["u", "2"]}]}], ")"}], " ", 
       SubsuperscriptBox[
        StyleBox["\[Eta]",
         FontWeight->Bold,
         FontColor->RGBColor[0.8, 0, 0]], 
        RowBox[{"2", ",", "4"}], 
        RowBox[{"[", "2", "]"}]]}], "u"], "-", 
     FractionBox[
      RowBox[{"144", " ", 
       RowBox[{"(", 
        RowBox[{"1", "+", 
         RowBox[{"3", " ", 
          SuperscriptBox["u", "2"]}]}], ")"}], " ", 
       SubsuperscriptBox[
        StyleBox["\[Eta]",
         FontWeight->Bold,
         FontColor->RGBColor[0.8, 0, 0]], 
        RowBox[{"2", ",", "5"}], 
        RowBox[{"[", "2", "]"}]]}], "u"], "+", 
     FractionBox[
      RowBox[{"432", " ", "\[ImaginaryI]", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", "1"}], "+", 
         RowBox[{"6", " ", 
          SuperscriptBox["u", "2"]}], "-", 
         RowBox[{"6", " ", "\[ImaginaryI]", " ", 
          SuperscriptBox["u", "3"]}], "+", 
         RowBox[{"39", " ", 
          SuperscriptBox["u", "4"]}]}], ")"}], " ", 
       SubsuperscriptBox[
        StyleBox["\[Eta]",
         FontWeight->Bold,
         FontColor->RGBColor[0.8, 0, 0]], 
        RowBox[{"3", ",", "1"}], 
        RowBox[{"[", "2", "]"}]]}], 
      SuperscriptBox["u", "3"]], "+", 
     FractionBox[
      RowBox[{"2592", " ", 
       RowBox[{"(", 
        RowBox[{"1", "-", 
         RowBox[{"\[ImaginaryI]", " ", "u"}], "+", 
         RowBox[{"3", " ", 
          SuperscriptBox["u", "2"]}]}], ")"}], " ", 
       SubsuperscriptBox[
        StyleBox["\[Eta]",
         FontWeight->Bold,
         FontColor->RGBColor[0.8, 0, 0]], 
        RowBox[{"3", ",", "2"}], 
        RowBox[{"[", "2", "]"}]]}], "u"], "-", 
     FractionBox[
      RowBox[{"144", " ", "\[ImaginaryI]", " ", 
       RowBox[{"(", 
        RowBox[{"3", "-", 
         RowBox[{"13", " ", "\[ImaginaryI]", " ", "u"}], "+", 
         RowBox[{"9", " ", 
          SuperscriptBox["u", "2"]}]}], ")"}], " ", 
       SubsuperscriptBox[
        StyleBox["\[Eta]",
         FontWeight->Bold,
         FontColor->RGBColor[0.8, 0, 0]], 
        RowBox[{"3", ",", "3"}], 
        RowBox[{"[", "2", "]"}]]}], "u"], "+", 
     RowBox[{"864", " ", "\[ImaginaryI]", " ", 
      SubsuperscriptBox[
       StyleBox["\[Eta]",
        FontWeight->Bold,
        FontColor->RGBColor[0.8, 0, 0]], 
       RowBox[{"3", ",", "4"}], 
       RowBox[{"[", "2", "]"}]]}], "+", 
     RowBox[{"144", " ", 
      SubsuperscriptBox[
       StyleBox["\[Eta]",
        FontWeight->Bold,
        FontColor->RGBColor[0.8, 0, 0]], 
       RowBox[{"3", ",", "5"}], 
       RowBox[{"[", "2", "]"}]]}], "+", 
     FractionBox[
      RowBox[{"144", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", "1"}], "+", 
         RowBox[{"14", " ", 
          SuperscriptBox["u", "2"]}], "-", 
         RowBox[{"18", " ", "\[ImaginaryI]", " ", 
          SuperscriptBox["u", "3"]}], "+", 
         RowBox[{"54", " ", 
          SuperscriptBox["u", "4"]}]}], ")"}], " ", 
       SubsuperscriptBox[
        StyleBox["\[Eta]",
         FontWeight->Bold,
         FontColor->RGBColor[0.8, 0, 0]], 
        RowBox[{"4", ",", "1"}], 
        RowBox[{"[", "2", "]"}]]}], 
      SuperscriptBox["u", "3"]], "-", 
     FractionBox[
      RowBox[{"864", " ", "\[ImaginaryI]", " ", 
       RowBox[{"(", 
        RowBox[{"1", "-", 
         RowBox[{"3", " ", "\[ImaginaryI]", " ", "u"}], "+", 
         RowBox[{"3", " ", 
          SuperscriptBox["u", "2"]}]}], ")"}], " ", 
       SubsuperscriptBox[
        StyleBox["\[Eta]",
         FontWeight->Bold,
         FontColor->RGBColor[0.8, 0, 0]], 
        RowBox[{"4", ",", "2"}], 
        RowBox[{"[", "2", "]"}]]}], "u"], "+", 
     RowBox[{"144", " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"3", " ", "\[ImaginaryI]"}], "-", 
        FractionBox["1", "u"], "-", 
        RowBox[{"3", " ", "u"}]}], ")"}], " ", 
      SubsuperscriptBox[
       StyleBox["\[Eta]",
        FontWeight->Bold,
        FontColor->RGBColor[0.8, 0, 0]], 
       RowBox[{"4", ",", "3"}], 
       RowBox[{"[", "2", "]"}]]}], "-", 
     FractionBox[
      RowBox[{"432", " ", "\[ImaginaryI]", " ", 
       RowBox[{"(", 
        RowBox[{"3", "-", 
         RowBox[{"4", " ", "\[ImaginaryI]", " ", "u"}], "+", 
         RowBox[{"9", " ", 
          SuperscriptBox["u", "2"]}]}], ")"}], " ", 
       SubsuperscriptBox[
        StyleBox["\[Eta]",
         FontWeight->Bold,
         FontColor->RGBColor[0.8, 0, 0]], 
        RowBox[{"5", ",", "1"}], 
        RowBox[{"[", "2", "]"}]]}], "u"], "+", 
     RowBox[{"1296", " ", "\[ImaginaryI]", " ", 
      SubsuperscriptBox[
       StyleBox["\[Eta]",
        FontWeight->Bold,
        FontColor->RGBColor[0.8, 0, 0]], 
       RowBox[{"5", ",", "2"}], 
       RowBox[{"[", "2", "]"}]]}], "+", 
     RowBox[{"216", " ", 
      SubsuperscriptBox[
       StyleBox["\[Eta]",
        FontWeight->Bold,
        FontColor->RGBColor[0.8, 0, 0]], 
       RowBox[{"5", ",", "3"}], 
       RowBox[{"[", "2", "]"}]]}], "-", 
     FractionBox[
      RowBox[{"72", " ", 
       RowBox[{"(", 
        RowBox[{"5", "-", 
         RowBox[{"24", " ", "\[ImaginaryI]", " ", "u"}], "+", 
         RowBox[{"15", " ", 
          SuperscriptBox["u", "2"]}]}], ")"}], " ", 
       SubsuperscriptBox[
        StyleBox["\[Eta]",
         FontWeight->Bold,
         FontColor->RGBColor[0.8, 0, 0]], 
        RowBox[{"6", ",", "1"}], 
        RowBox[{"[", "2", "]"}]]}], "u"], "+", 
     RowBox[{"648", " ", 
      SubsuperscriptBox[
       StyleBox["\[Eta]",
        FontWeight->Bold,
        FontColor->RGBColor[0.8, 0, 0]], 
       RowBox[{"7", ",", "1"}], 
       RowBox[{"[", "2", "]"}]]}], "+", 
     FractionBox[
      RowBox[{"15552", " ", 
       RowBox[{"(", 
        RowBox[{"1", "+", 
         RowBox[{"2", " ", "\[ImaginaryI]", " ", "u"}]}], ")"}], " ", 
       SubsuperscriptBox[
        StyleBox["\[Eta]",
         FontWeight->Bold,
         FontColor->RGBColor[0.8, 0, 0]], 
        RowBox[{"1", ",", "1", ",", "1"}], 
        RowBox[{"[", "2", "]"}]]}], "u"], "+", 
     FractionBox[
      RowBox[{"864", " ", "\[ImaginaryI]", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", "1"}], "+", 
         RowBox[{"9", " ", 
          SuperscriptBox["u", "2"]}], "+", 
         RowBox[{"39", " ", 
          SuperscriptBox["u", "4"]}]}], ")"}], " ", 
       SubsuperscriptBox[
        StyleBox["\[Eta]",
         FontWeight->Bold,
         FontColor->RGBColor[0.8, 0, 0]], 
        RowBox[{"2", ",", "1", ",", "1"}], 
        RowBox[{"[", "2", "]"}]]}], 
      SuperscriptBox["u", "3"]], "+", 
     FractionBox[
      RowBox[{"5184", " ", 
       RowBox[{"(", 
        RowBox[{"1", "+", 
         RowBox[{"3", " ", 
          SuperscriptBox["u", "2"]}]}], ")"}], " ", 
       SubsuperscriptBox[
        StyleBox["\[Eta]",
         FontWeight->Bold,
         FontColor->RGBColor[0.8, 0, 0]], 
        RowBox[{"2", ",", "1", ",", "2"}], 
        RowBox[{"[", "2", "]"}]]}], "u"], "-", 
     FractionBox[
      RowBox[{"864", " ", "\[ImaginaryI]", " ", 
       RowBox[{"(", 
        RowBox[{"1", "+", 
         RowBox[{"3", " ", 
          SuperscriptBox["u", "2"]}]}], ")"}], " ", 
       SubsuperscriptBox[
        StyleBox["\[Eta]",
         FontWeight->Bold,
         FontColor->RGBColor[0.8, 0, 0]], 
        RowBox[{"2", ",", "1", ",", "3"}], 
        RowBox[{"[", "2", "]"}]]}], "u"], "+", 
     FractionBox[
      RowBox[{"5184", " ", 
       RowBox[{"(", 
        RowBox[{"1", "+", 
         RowBox[{"3", " ", 
          SuperscriptBox["u", "2"]}]}], ")"}], " ", 
       SubsuperscriptBox[
        StyleBox["\[Eta]",
         FontWeight->Bold,
         FontColor->RGBColor[0.8, 0, 0]], 
        RowBox[{"2", ",", "2", ",", "1"}], 
        RowBox[{"[", "2", "]"}]]}], "u"], "-", 
     FractionBox[
      RowBox[{"864", " ", "\[ImaginaryI]", " ", 
       RowBox[{"(", 
        RowBox[{"1", "+", 
         RowBox[{"3", " ", 
          SuperscriptBox["u", "2"]}]}], ")"}], " ", 
       SubsuperscriptBox[
        StyleBox["\[Eta]",
         FontWeight->Bold,
         FontColor->RGBColor[0.8, 0, 0]], 
        RowBox[{"2", ",", "3", ",", "1"}], 
        RowBox[{"[", "2", "]"}]]}], "u"], "+", 
     FractionBox[
      RowBox[{"5184", " ", 
       RowBox[{"(", 
        RowBox[{"1", "-", 
         RowBox[{"\[ImaginaryI]", " ", "u"}], "+", 
         RowBox[{"3", " ", 
          SuperscriptBox["u", "2"]}]}], ")"}], " ", 
       SubsuperscriptBox[
        StyleBox["\[Eta]",
         FontWeight->Bold,
         FontColor->RGBColor[0.8, 0, 0]], 
        RowBox[{"3", ",", "1", ",", "1"}], 
        RowBox[{"[", "2", "]"}]]}], "u"], "-", 
     RowBox[{"5184", " ", 
      SubsuperscriptBox[
       StyleBox["\[Eta]",
        FontWeight->Bold,
        FontColor->RGBColor[0.8, 0, 0]], 
       RowBox[{"3", ",", "1", ",", "2"}], 
       RowBox[{"[", "2", "]"}]]}], "+", 
     RowBox[{"864", " ", "\[ImaginaryI]", " ", 
      SubsuperscriptBox[
       StyleBox["\[Eta]",
        FontWeight->Bold,
        FontColor->RGBColor[0.8, 0, 0]], 
       RowBox[{"3", ",", "1", ",", "3"}], 
       RowBox[{"[", "2", "]"}]]}], "-", 
     RowBox[{"5184", " ", 
      SubsuperscriptBox[
       StyleBox["\[Eta]",
        FontWeight->Bold,
        FontColor->RGBColor[0.8, 0, 0]], 
       RowBox[{"3", ",", "2", ",", "1"}], 
       RowBox[{"[", "2", "]"}]]}], "+", 
     RowBox[{"864", " ", "\[ImaginaryI]", " ", 
      SubsuperscriptBox[
       StyleBox["\[Eta]",
        FontWeight->Bold,
        FontColor->RGBColor[0.8, 0, 0]], 
       RowBox[{"3", ",", "3", ",", "1"}], 
       RowBox[{"[", "2", "]"}]]}], "-", 
     FractionBox[
      RowBox[{"1728", " ", "\[ImaginaryI]", " ", 
       RowBox[{"(", 
        RowBox[{"1", "-", 
         RowBox[{"3", " ", "\[ImaginaryI]", " ", "u"}], "+", 
         RowBox[{"3", " ", 
          SuperscriptBox["u", "2"]}]}], ")"}], " ", 
       SubsuperscriptBox[
        StyleBox["\[Eta]",
         FontWeight->Bold,
         FontColor->RGBColor[0.8, 0, 0]], 
        RowBox[{"4", ",", "1", ",", "1"}], 
        RowBox[{"[", "2", "]"}]]}], "u"], "+", 
     RowBox[{"2592", " ", "\[ImaginaryI]", " ", 
      SubsuperscriptBox[
       StyleBox["\[Eta]",
        FontWeight->Bold,
        FontColor->RGBColor[0.8, 0, 0]], 
       RowBox[{"5", ",", "1", ",", "1"}], 
       RowBox[{"[", "2", "]"}]]}], "+", 
     FractionBox[
      RowBox[{"10368", " ", 
       RowBox[{"(", 
        RowBox[{"1", "+", 
         RowBox[{"3", " ", 
          SuperscriptBox["u", "2"]}]}], ")"}], " ", 
       SubsuperscriptBox[
        StyleBox["\[Eta]",
         FontWeight->Bold,
         FontColor->RGBColor[0.8, 0, 0]], 
        RowBox[{"2", ",", "1", ",", "1", ",", "1"}], 
        RowBox[{"[", "2", "]"}]]}], "u"], "-", 
     RowBox[{"10368", " ", 
      SubsuperscriptBox[
       StyleBox["\[Eta]",
        FontWeight->Bold,
        FontColor->RGBColor[0.8, 0, 0]], 
       RowBox[{"3", ",", "1", ",", "1", ",", "1"}], 
       RowBox[{"[", "2", "]"}]]}]}], ")"}]}]}]], "Output",
 CellChangeTimes->{{3.550385526898115*^9, 3.550385542473895*^9}}]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 "Computation ",
 Cell[BoxData[
  FormBox[
   SubscriptBox["q", "3"], TraditionalForm]],
  FormatType->"TraditionalForm"],
 " and ",
 Cell[BoxData[
  FormBox[
   SubscriptBox["q", "4"], TraditionalForm]],
  FormatType->"TraditionalForm"]
}], "Subsubsection",
 CellChangeTimes->{{3.541066491268599*^9, 3.541066492391665*^9}, {
  3.5503854746741056`*^9, 3.550385483872486*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{
    SubscriptBox[
     StyleBox["q",
      FontColor->RGBColor[0, 0, 0.8]], "4"], "\[Equal]", 
    FractionBox[
     RowBox[{
      RowBox[{
       SubscriptBox[
        StyleBox["q",
         FontColor->RGBColor[0, 0, 0.8]], "2"], " ", 
       SubsuperscriptBox[
        StyleBox["q",
         FontColor->RGBColor[0, 0, 0.8]], 
        RowBox[{"1", ",", "4"}], "+"]}], "-", 
      SubsuperscriptBox[
       StyleBox["q",
        FontColor->RGBColor[0, 0, 0.8]], 
       RowBox[{"2", ",", "4"}], "+"]}], 
     SuperscriptBox[
      StyleBox["Q",
       FontColor->RGBColor[0.8, 0, 0]], "+"]], "\[Equal]", 
    RowBox[{"\[ScriptCapitalO]", "[", 
     SuperscriptBox["g", "4"], "]"}]}], ",", " ", 
   RowBox[{
    SubscriptBox[
     StyleBox["q",
      FontColor->RGBColor[0, 0, 0.8]], "3"], "\[Equal]", 
    FractionBox[
     RowBox[{
      RowBox[{
       SubscriptBox[
        StyleBox["q",
         FontColor->RGBColor[0, 0, 0.8]], "2"], " ", 
       SubsuperscriptBox[
        StyleBox["q",
         FontColor->RGBColor[0, 0, 0.8]], 
        RowBox[{"1", ",", "3"}], "+"]}], "-", 
      SubsuperscriptBox[
       StyleBox["q",
        FontColor->RGBColor[0, 0, 0.8]], 
       RowBox[{"1", ",", "4"}], "+"]}], 
     SuperscriptBox[
      StyleBox["Q",
       FontColor->RGBColor[0.8, 0, 0]], "+"]], "\[Equal]", 
    RowBox[{"\[ScriptCapitalO]", "[", 
     SuperscriptBox["g", "4"], "]"}]}]}], "}"}]], "Input",
 CellChangeTimes->{{3.550375441030224*^9, 3.550375463509831*^9}, 
   3.5503854900792923`*^9}],

Cell[TextData[{
 Cell[BoxData[
  FormBox[
   SuperscriptBox["Q", "+"], TraditionalForm]],
  FormatType->"TraditionalForm"],
 " pole should normally cancell out, let us try to see why it happens"
}], "Text",
 CellChangeTimes->{{3.5503821459675837`*^9, 3.550382164294489*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{
    SubsuperscriptBox[
     StyleBox["q",
      FontColor->RGBColor[0, 0, 0.8]], "3", "-"], "\[Equal]", 
    RowBox[{
     RowBox[{
      SubsuperscriptBox[
       StyleBox["q",
        FontColor->RGBColor[0, 0, 0.8]], "2", "-"], 
      FractionBox["D", 
       RowBox[{"1", "-", 
        SuperscriptBox["D", "2"]}]], " ", 
      RowBox[{"(", 
       FractionBox[
        SuperscriptBox[
         StyleBox["U",
          FontColor->RGBColor[0, 0.6, 0]], "2"], 
        RowBox[{
         SuperscriptBox[
          StyleBox["Q",
           FontColor->RGBColor[0.8, 0, 0]], "-"], " ", 
         SuperscriptBox[
          StyleBox["Q",
           FontColor->RGBColor[0.8, 0, 0]], "+"]}]], ")"}]}], "-", 
     RowBox[{
      FractionBox["D", 
       RowBox[{"1", "-", 
        SuperscriptBox["D", "2"]}]], " ", 
      RowBox[{"(", 
       FractionBox[
        RowBox[{
         SubscriptBox[
          StyleBox["q",
           FontColor->RGBColor[0, 0, 0.8]], "2"], 
         SuperscriptBox[
          StyleBox["U",
           FontColor->RGBColor[0, 0.6, 0]], "2"]}], 
        RowBox[{
         SuperscriptBox[
          StyleBox["Q",
           FontColor->RGBColor[0.8, 0, 0]], "-"], " ", 
         SuperscriptBox[
          StyleBox["Q",
           FontColor->RGBColor[0.8, 0, 0]], "+"]}]], ")"}]}]}]}], ",", 
   RowBox[{
    SubsuperscriptBox[
     StyleBox["q",
      FontColor->RGBColor[0, 0, 0.8]], "4", "-"], "\[Equal]", 
    RowBox[{
     RowBox[{
      SubsuperscriptBox[
       StyleBox["q",
        FontColor->RGBColor[0, 0, 0.8]], "2", "-"], 
      FractionBox["D", 
       RowBox[{"1", "-", 
        SuperscriptBox["D", "2"]}]], " ", 
      RowBox[{"(", 
       FractionBox[
        RowBox[{
         SubscriptBox[
          StyleBox["q",
           FontColor->RGBColor[0, 0, 0.8]], "2"], 
         SuperscriptBox[
          StyleBox["U",
           FontColor->RGBColor[0, 0.6, 0]], "2"]}], 
        RowBox[{
         SuperscriptBox[
          StyleBox["Q",
           FontColor->RGBColor[0.8, 0, 0]], "-"], " ", 
         SuperscriptBox[
          StyleBox["Q",
           FontColor->RGBColor[0.8, 0, 0]], "+"]}]], ")"}]}], "-", 
     RowBox[{
      FractionBox["D", 
       RowBox[{"1", "-", 
        SuperscriptBox["D", "2"]}]], " ", 
      RowBox[{"(", 
       FractionBox[
        RowBox[{
         SubsuperscriptBox[
          StyleBox["q",
           FontColor->RGBColor[0, 0, 0.8]], "2", "2"], 
         SuperscriptBox[
          StyleBox["U",
           FontColor->RGBColor[0, 0.6, 0]], "2"]}], 
        RowBox[{
         SuperscriptBox[
          StyleBox["Q",
           FontColor->RGBColor[0.8, 0, 0]], "-"], " ", 
         SuperscriptBox[
          StyleBox["Q",
           FontColor->RGBColor[0.8, 0, 0]], "+"]}]], ")"}]}]}]}]}], 
  "}"}]], "Input",
 CellChangeTimes->{{3.550383773825296*^9, 3.550383834106585*^9}}],

Cell["\<\
We remind that all the poles, except the first one are cancelled out in the \
sum:\
\>", "Text",
 CellChangeTimes->{{3.5503838418599977`*^9, 3.550383858193595*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   FractionBox["D", 
    RowBox[{"1", "-", 
     SuperscriptBox["D", "2"]}]], 
   FractionBox[
    StyleBox["f",
     FontColor->RGBColor[0, 0.6, 0]], 
    RowBox[{
     SuperscriptBox[
      StyleBox["Q",
       FontColor->RGBColor[0.8, 0, 0]], "-"], " ", 
     SuperscriptBox[
      StyleBox["Q",
       FontColor->RGBColor[0.8, 0, 0]], "+"]}]]}], "\[Equal]", 
  RowBox[{
   RowBox[{
    FractionBox["1", 
     StyleBox["Q",
      FontColor->RGBColor[0.8, 0, 0]]], 
    FractionBox["1", 
     RowBox[{"2", "\[ImaginaryI]"}]], 
    FractionBox[
     SuperscriptBox[
      StyleBox["f",
       FontColor->RGBColor[0, 0.6, 0]], "+"], 
     SuperscriptBox["u", "+"]]}], "+", 
   RowBox[{
    FractionBox["1", 
     RowBox[{"2", "\[ImaginaryI]"}]], 
    FractionBox["D", 
     RowBox[{"1", "-", 
      SuperscriptBox["D", "2"]}]], 
    RowBox[{"(", 
     RowBox[{
      SubscriptBox[
       RowBox[{"(", 
        RowBox[{
         SubscriptBox["\[Sum]", "k"], 
         FractionBox[
          SuperscriptBox[
           StyleBox["h",
            FontColor->RGBColor[0, 0.6, 0]], "-"], 
          SuperscriptBox[
           RowBox[{"(", "u", ")"}], "k"]]}], ")"}], "reg"], "+", 
      SubscriptBox[
       RowBox[{"(", 
        RowBox[{
         SubscriptBox["\[Sum]", "k"], 
         FractionBox[
          SuperscriptBox[
           StyleBox["h",
            FontColor->RGBColor[0, 0.6, 0]], "+"], 
          SuperscriptBox[
           RowBox[{"(", "u", ")"}], "k"]]}], ")"}], "reg"]}], ")"}]}], "-", 
   RowBox[{
    FractionBox["1", 
     RowBox[{"2", "\[ImaginaryI]"}]], "D", 
    SubscriptBox[
     RowBox[{"(", 
      RowBox[{
       SubscriptBox["\[Sum]", "k"], 
       FractionBox[
        SuperscriptBox[
         StyleBox["h",
          FontColor->RGBColor[0, 0.6, 0]], "-"], 
        SuperscriptBox[
         RowBox[{"(", "u", ")"}], "k"]]}], ")"}], "reg"]}]}]}]], "Input",
 CellChangeTimes->{{3.550382463652323*^9, 3.5503824789048023`*^9}}],

Cell[TextData[{
 "The only potentially singular part in ",
 Cell[BoxData[
  SubsuperscriptBox[
   StyleBox["q",
    FontColor->RGBColor[0, 0, 0.8]], "3", "-"]],
  CellChangeTimes->{{3.550383773825296*^9, 3.550383834106585*^9}}],
 " and ",
 Cell[BoxData[
  SubsuperscriptBox[
   StyleBox["q",
    FontColor->RGBColor[0, 0, 0.8]], "4", "-"]],
  CellChangeTimes->{{3.550383773825296*^9, 3.550383834106585*^9}}],
 " is:"
}], "Text",
 CellChangeTimes->{{3.550382488363312*^9, 3.550382502161047*^9}, {
  3.550383881802253*^9, 3.550383902265983*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   FractionBox["1", 
    StyleBox["Q",
     FontColor->RGBColor[0.8, 0, 0]]], 
   FractionBox["1", 
    RowBox[{"2", "\[ImaginaryI]"}]], 
   FractionBox[
    SuperscriptBox[
     StyleBox["f",
      FontColor->RGBColor[0, 0.6, 0]], "+"], 
    SuperscriptBox["u", "+"]], 
   RowBox[{"(", 
    RowBox[{
     SubsuperscriptBox[
      OverscriptBox["q", "^"], "2", "-"], "-", 
     SubsuperscriptBox[
      OverscriptBox["q", "^"], "2", "+"]}], ")"}]}], "\[Proportional]", 
  RowBox[{
   FractionBox["1", 
    RowBox[{"2", "\[ImaginaryI]"}]], 
   FractionBox[
    SuperscriptBox[
     StyleBox["f",
      FontColor->RGBColor[0, 0.6, 0]], "+"], 
    SuperscriptBox["u", "+"]], 
   RowBox[{"(", 
    FractionBox[
     OverscriptBox[
      StyleBox["\[GothicCapitalT]",
       FontColor->RGBColor[0.54, 0.35, 0.15]], 
      StyleBox["^",
       FontColor->RGBColor[0.54, 0.35, 0.15]]], 
     StyleBox["Q",
      FontColor->RGBColor[0.8, 0, 0]]], ")"}], " ", 
   RowBox[{"(*", " ", 
    RowBox[{
    "at", " ", "the", " ", "orders", " ", "under", " ", "consideration"}], 
    " ", "*)"}]}]}]], "Input",
 CellChangeTimes->{{3.5503825104931173`*^9, 3.5503825533116217`*^9}, {
  3.5503838723851547`*^9, 3.550383878938903*^9}, {3.550383909442355*^9, 
  3.5503839405385437`*^9}, {3.550383980634123*^9, 3.550383981740079*^9}}],

Cell["\<\
Therefore a potentiall pole is cancelled out.\
\>", "Text",
 CellChangeTimes->{{3.550383976021345*^9, 3.550383990788167*^9}}],

Cell[TextData[{
 "We will use presented decomposition to compute  ",
 Cell[BoxData[
  SubscriptBox[
   StyleBox["q",
    FontColor->RGBColor[0, 0, 0.8]], "3"]],
  CellChangeTimes->{{3.550383773825296*^9, 3.550383834106585*^9}}],
 " and ",
 Cell[BoxData[
  SubscriptBox[
   StyleBox["q",
    FontColor->RGBColor[0, 0, 0.8]], "4"]],
  CellChangeTimes->{{3.550383773825296*^9, 3.550383834106585*^9}}],
 " , because the result will be manifestly free from Bethe poles. \
(Expressions in section computing ",
 Cell[BoxData[
  FormBox[
   SubscriptBox["q", 
    RowBox[{"i", ",", "j"}]], TraditionalForm]],
  FormatType->"TraditionalForm"],
 " should be known to the ",
 StyleBox["Mathematica",
  FontSlant->"Italic"],
 " kernel)."
}], "Text",
 CellChangeTimes->{{3.550383992247489*^9, 3.550384090720752*^9}}],

Cell[BoxData[{
 RowBox[{
  SubsuperscriptBox["q", "3", "-"], "=", 
  RowBox[{
   FractionBox["1", 
    RowBox[{"2", "\[ImaginaryI]"}]], 
   RowBox[{"(", 
    RowBox[{
     RowBox[{
      FractionBox[
       SuperscriptBox[
        RowBox[{"(", 
         SuperscriptBox[
          StyleBox["U",
           FontColor->RGBColor[0, 0.6, 0]], "+"], ")"}], "2"], 
       SuperscriptBox["u", "+"]], 
      FractionBox[
       RowBox[{"(", 
        RowBox[{
         SubsuperscriptBox[
          OverscriptBox[
           StyleBox["q",
            FontColor->RGBColor[0, 0, 0.8]], 
           StyleBox["^",
            FontColor->RGBColor[0, 0, 0.8]]], "2", "-"], "-", 
         SubsuperscriptBox[
          OverscriptBox[
           StyleBox["q",
            FontColor->RGBColor[0, 0, 0.8]], 
           StyleBox["^",
            FontColor->RGBColor[0, 0, 0.8]]], "2", "+"]}], ")"}], 
       StyleBox["Q",
        FontColor->RGBColor[0.8, 0, 0]]]}], "+", 
     RowBox[{
      SubsuperscriptBox[
       OverscriptBox[
        StyleBox["q",
         FontColor->RGBColor[0, 0, 0.8]], 
        StyleBox["^",
         FontColor->RGBColor[0, 0, 0.8]]], "2", "-"], 
      SubscriptBox["qpreanswer", 
       RowBox[{"1", ",", "3"}]]}], "-", 
     SubscriptBox["qpreanswer", 
      RowBox[{"1", ",", "4"}]]}], ")"}]}]}], "\[IndentingNewLine]", 
 RowBox[{
  SubsuperscriptBox["q", "4", "-"], "=", 
  RowBox[{
   FractionBox["1", 
    RowBox[{"2", "\[ImaginaryI]"}]], 
   RowBox[{"(", 
    RowBox[{
     RowBox[{
      FractionBox[
       RowBox[{
        SubsuperscriptBox[
         OverscriptBox[
          StyleBox["q",
           FontColor->RGBColor[0, 0, 0.8]], 
          StyleBox["^",
           FontColor->RGBColor[0, 0, 0.8]]], "2", "+"], 
        SuperscriptBox[
         RowBox[{"(", 
          SuperscriptBox[
           StyleBox["U",
            FontColor->RGBColor[0, 0.6, 0]], "+"], ")"}], "2"]}], 
       SuperscriptBox["u", "+"]], 
      FractionBox[
       RowBox[{"(", 
        RowBox[{
         SubsuperscriptBox[
          OverscriptBox[
           StyleBox["q",
            FontColor->RGBColor[0, 0, 0.8]], 
           StyleBox["^",
            FontColor->RGBColor[0, 0, 0.8]]], "2", "-"], "-", 
         SubsuperscriptBox[
          OverscriptBox[
           StyleBox["q",
            FontColor->RGBColor[0, 0, 0.8]], 
           StyleBox["^",
            FontColor->RGBColor[0, 0, 0.8]]], "2", "+"]}], ")"}], 
       StyleBox["Q",
        FontColor->RGBColor[0.8, 0, 0]]]}], "+", 
     RowBox[{
      SubsuperscriptBox[
       OverscriptBox[
        StyleBox["q",
         FontColor->RGBColor[0, 0, 0.8]], 
        StyleBox["^",
         FontColor->RGBColor[0, 0, 0.8]]], "2", "-"], 
      SubscriptBox["qpreanswer", 
       RowBox[{"1", ",", "4"}]]}], "-", 
     SubscriptBox["preanswer", 
      RowBox[{"2", ",", "4"}]]}], ")"}]}]}]}], "Input",
 CellChangeTimes->{{3.550382867843707*^9, 3.550382967890541*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"uni", "=", 
  RowBox[{
   RowBox[{
    FractionBox[
     RowBox[{"(", 
      RowBox[{
       RowBox[{
        RowBox[{"q$", "[", "2", "]"}], "[", 
        RowBox[{"-", "1"}], "]"}], "-", 
       RowBox[{
        RowBox[{"q$", "[", "2", "]"}], "[", "1", "]"}]}], ")"}], 
     RowBox[{"Q", "/.", "subFunsBethe"}]], "/.", "weak"}], "//", 
   "Simplify"}]}]], "Input",
 CellChangeTimes->{{3.550382743172278*^9, 3.550382829045499*^9}, {
  3.550382983055704*^9, 3.550383023183913*^9}}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
   RowBox[{"-", 
    FractionBox["4", 
     RowBox[{"1", "+", 
      RowBox[{"4", " ", 
       SuperscriptBox["u", "2"]}]}]]}], "+", 
   FractionBox[
    RowBox[{"64", " ", 
     SuperscriptBox["g", "2"]}], 
    SuperscriptBox[
     RowBox[{"(", 
      RowBox[{"1", "+", 
       RowBox[{"4", " ", 
        SuperscriptBox["u", "2"]}]}], ")"}], "3"]], "-", 
   FractionBox[
    RowBox[{"32", " ", 
     RowBox[{"(", 
      RowBox[{"31", "-", 
       RowBox[{"124", " ", 
        SuperscriptBox["u", "2"]}], "+", 
       RowBox[{"80", " ", 
        SuperscriptBox["u", "4"]}], "+", 
       RowBox[{"192", " ", 
        SuperscriptBox["u", "6"]}]}], ")"}], " ", 
     SuperscriptBox["g", "4"]}], 
    SuperscriptBox[
     RowBox[{"(", 
      RowBox[{"1", "+", 
       RowBox[{"4", " ", 
        SuperscriptBox["u", "2"]}]}], ")"}], "5"]], "+", 
   FractionBox[
    RowBox[{"16", " ", 
     RowBox[{"(", 
      RowBox[{"941", "-", 
       RowBox[{"11628", " ", 
        SuperscriptBox["u", "2"]}], "+", 
       RowBox[{"26656", " ", 
        SuperscriptBox["u", "4"]}], "+", 
       RowBox[{"31360", " ", 
        SuperscriptBox["u", "6"]}], "+", 
       RowBox[{"33024", " ", 
        SuperscriptBox["u", "8"]}], "+", 
       RowBox[{"33792", " ", 
        SuperscriptBox["u", "10"]}]}], ")"}], " ", 
     SuperscriptBox["g", "6"]}], 
    SuperscriptBox[
     RowBox[{"(", 
      RowBox[{"1", "+", 
       RowBox[{"4", " ", 
        SuperscriptBox["u", "2"]}]}], ")"}], "7"]], "+", 
   InterpretationBox[
    SuperscriptBox[
     RowBox[{"O", "[", "g", "]"}], "8"],
    SeriesData[$CellContext`g, 0, {}, 0, 8, 1],
    Editable->False]}],
  SeriesData[$CellContext`g, 
   0, {(-4)/(1 + 4 $CellContext`u^2), 0, 64 (1 + 4 $CellContext`u^2)^(-3), 
    0, (-32) (1 + 4 $CellContext`u^2)^(-5) (31 - 124 $CellContext`u^2 + 
     80 $CellContext`u^4 + 192 $CellContext`u^6), 0, 
    16 (1 + 4 $CellContext`u^2)^(-7) (941 - 11628 $CellContext`u^2 + 
     26656 $CellContext`u^4 + 31360 $CellContext`u^6 + 33024 $CellContext`u^8 + 
     33792 $CellContext`u^10)}, 0, 8, 1],
  Editable->False]], "Output",
 CellChangeTimes->{{3.5503827470133123`*^9, 3.550382755549245*^9}, {
   3.550382804379727*^9, 3.55038282949955*^9}, 3.5503829892625237`*^9, 
   3.55238864341949*^9, 3.568961741321403*^9}]
}, Open  ]],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   FractionBox["1", 
    RowBox[{"2", "\[ImaginaryI]"}]], 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"Series", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          SuperscriptBox["g", 
           RowBox[{"Range", "[", 
            RowBox[{"4", ",", "10", ",", "2"}], "]"}]], ".", 
          RowBox[{"inhomopiece", "[", 
           RowBox[{"[", "1", "]"}], "]"}]}], ")"}], 
        RowBox[{"(", 
         RowBox[{"Normal", "[", "uni", "]"}], ")"}]}], ",", 
       RowBox[{"{", 
        RowBox[{"g", ",", "0", ",", "10"}], "}"}]}], "]"}], "+", 
     RowBox[{"Series", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"(", 
         RowBox[{"Normal", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"q$", "[", "2", "]"}], "[", 
            RowBox[{"-", "1"}], "]"}], "/.", "weak"}], "]"}], ")"}], 
        RowBox[{"(", 
         RowBox[{
          SuperscriptBox["g", 
           RowBox[{"Range", "[", 
            RowBox[{"4", ",", "10", ",", "2"}], "]"}]], ".", 
          RowBox[{"preanswer", "[", 
           RowBox[{"[", "1", "]"}], "]"}]}], ")"}]}], ",", 
       RowBox[{"{", 
        RowBox[{"g", ",", "0", ",", "10"}], "}"}]}], "]"}], "-", 
     "\[IndentingNewLine]", 
     RowBox[{"Series", "[", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         SuperscriptBox["g", 
          RowBox[{"Range", "[", 
           RowBox[{"4", ",", "10", ",", "2"}], "]"}]], ".", 
         RowBox[{"preanswer", "[", 
          RowBox[{"[", "2", "]"}], "]"}]}], ")"}], ",", 
       RowBox[{"{", 
        RowBox[{"g", ",", "0", ",", "10"}], "}"}]}], "]"}]}], ")"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"%", "//.", 
   RowBox[{"shiftm\[Eta]", "[", "3", "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"q3tmp", "=", 
   RowBox[{
    RowBox[{
     RowBox[{"Collect", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"#", "/.", 
         RowBox[{"Shift", "[", "1", "]"}]}], "/.", 
        RowBox[{"u", "\[Rule]", 
         RowBox[{"u", "\[ImplicitPlus]", 
          RowBox[{"+", 
           FractionBox["\[ImaginaryI]", "2"]}]}]}]}], ",", 
       RowBox[{
        RowBox[{"\[Eta]$", "[", "__", "]"}], "[", "_", "]"}], ",", 
       "Simplify"}], "]"}], "&"}], "/@", "%"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   FractionBox["1", 
    RowBox[{"2", "\[ImaginaryI]"}]], 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"Series", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          SuperscriptBox["g", 
           RowBox[{"Range", "[", 
            RowBox[{"4", ",", "10", ",", "2"}], "]"}]], ".", 
          RowBox[{"inhomopiece", "[", 
           RowBox[{"[", "2", "]"}], "]"}]}], ")"}], 
        RowBox[{"(", 
         RowBox[{"Normal", "[", "uni", "]"}], ")"}]}], ",", 
       RowBox[{"{", 
        RowBox[{"g", ",", "0", ",", "10"}], "}"}]}], "]"}], "+", 
     RowBox[{"Series", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"(", 
         RowBox[{"Normal", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"q$", "[", "2", "]"}], "[", 
            RowBox[{"-", "1"}], "]"}], "/.", "weak"}], "]"}], ")"}], 
        RowBox[{"(", 
         RowBox[{
          SuperscriptBox["g", 
           RowBox[{"Range", "[", 
            RowBox[{"4", ",", "10", ",", "2"}], "]"}]], ".", 
          RowBox[{"preanswer", "[", 
           RowBox[{"[", "2", "]"}], "]"}]}], ")"}]}], ",", 
       RowBox[{"{", 
        RowBox[{"g", ",", "0", ",", "10"}], "}"}]}], "]"}], "-", 
     "\[IndentingNewLine]", 
     RowBox[{"Series", "[", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         SuperscriptBox["g", 
          RowBox[{"Range", "[", 
           RowBox[{"4", ",", "10", ",", "2"}], "]"}]], ".", 
         RowBox[{"preanswer", "[", 
          RowBox[{"[", "3", "]"}], "]"}]}], ")"}], ",", 
       RowBox[{"{", 
        RowBox[{"g", ",", "0", ",", "10"}], "}"}]}], "]"}]}], ")"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"%", "//.", 
   RowBox[{"shiftm\[Eta]", "[", "3", "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"q4tmp", "=", 
   RowBox[{
    RowBox[{
     RowBox[{"Collect", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"#", "/.", 
         RowBox[{"Shift", "[", "1", "]"}]}], "/.", 
        RowBox[{"u", "\[Rule]", 
         RowBox[{"u", "\[ImplicitPlus]", 
          RowBox[{"+", 
           FractionBox["\[ImaginaryI]", "2"]}]}]}]}], ",", 
       RowBox[{
        RowBox[{"\[Eta]$", "[", "__", "]"}], "[", "_", "]"}], ",", 
       "Simplify"}], "]"}], "&"}], "/@", "%"}]}], ";"}]}], "Input",
 CellChangeTimes->{{3.550382991973721*^9, 3.5503830537895823`*^9}, {
  3.550383088660837*^9, 3.550383194440298*^9}, {3.550383302012691*^9, 
  3.5503833202933292`*^9}, {3.550383406824779*^9, 3.55038341076823*^9}, {
  3.550383524907065*^9, 3.550383528600753*^9}, {3.550384058567918*^9, 
  3.550384058800877*^9}}],

Cell["\<\
We check this result against direct computation\
\>", "Text",
 CellChangeTimes->{{3.5503841084335747`*^9, 3.550384121641844*^9}, 
   3.550387313813843*^9}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{
     FractionBox[
      RowBox[{
       RowBox[{
        SubscriptBox[
         StyleBox["q",
          FontColor->RGBColor[0, 0, 0.8]], "2"], " ", 
        SubsuperscriptBox[
         StyleBox["q",
          FontColor->RGBColor[0, 0, 0.8]], 
         RowBox[{"1", ",", "3"}], "+"]}], "-", 
       SubsuperscriptBox[
        StyleBox["q",
         FontColor->RGBColor[0, 0, 0.8]], 
        RowBox[{"1", ",", "4"}], "+"]}], 
      SuperscriptBox[
       StyleBox["Q",
        FontColor->RGBColor[0.8, 0, 0]], "+"]], "/.", 
     RowBox[{"Q$", "\[Rule]", 
      RowBox[{"q$", "[", 
       RowBox[{"1", ",", "2"}], "]"}]}]}], "/.", "weak"}], "//", "Normal"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Series", "[", 
   RowBox[{
    RowBox[{"%", "/.", "weakqij"}], ",", 
    RowBox[{"{", 
     RowBox[{"g", ",", "0", ",", "10"}], "}"}]}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"tmp3", "=", 
   RowBox[{
    RowBox[{
     RowBox[{"Collect", "[", 
      RowBox[{"#", ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"Q0", "[", "_", "]"}], ",", 
         RowBox[{
          RowBox[{"\[Eta]$", "[", "__", "]"}], "[", "_", "]"}]}], "}"}], ",", 
       "Simplify"}], "]"}], "&"}], "/@", "%"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{
     FractionBox[
      RowBox[{
       RowBox[{
        SubscriptBox[
         StyleBox["q",
          FontColor->RGBColor[0, 0, 0.8]], "2"], " ", 
        SubsuperscriptBox[
         StyleBox["q",
          FontColor->RGBColor[0, 0, 0.8]], 
         RowBox[{"1", ",", "4"}], "+"]}], "-", 
       SubsuperscriptBox[
        StyleBox["q",
         FontColor->RGBColor[0, 0, 0.8]], 
        RowBox[{"2", ",", "4"}], "+"]}], 
      SuperscriptBox[
       StyleBox["Q",
        FontColor->RGBColor[0.8, 0, 0]], "+"]], "/.", 
     RowBox[{"Q$", "\[Rule]", 
      RowBox[{"q$", "[", 
       RowBox[{"1", ",", "2"}], "]"}]}]}], "/.", "weak"}], "//", "Normal"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Series", "[", 
   RowBox[{
    RowBox[{"%", "/.", "weakqij"}], ",", 
    RowBox[{"{", 
     RowBox[{"g", ",", "0", ",", "10"}], "}"}]}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"tmp4", "=", 
   RowBox[{
    RowBox[{
     RowBox[{"Collect", "[", 
      RowBox[{"#", ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"Q0", "[", "_", "]"}], ",", 
         RowBox[{
          RowBox[{"\[Eta]$", "[", "__", "]"}], "[", "_", "]"}]}], "}"}], ",", 
       "Simplify"}], "]"}], "&"}], "/@", "%"}]}], ";"}]}], "Input",
 CellChangeTimes->{{3.5503806157467537`*^9, 3.55038070359437*^9}, {
   3.550380745845003*^9, 3.5503808230402403`*^9}, {3.550380914262536*^9, 
   3.550380934662533*^9}, 3.5503815058253*^9, {3.550382286615748*^9, 
   3.5503823021513577`*^9}, {3.5503834314152613`*^9, 3.550383437655849*^9}, {
   3.550383673970147*^9, 3.5503836966215067`*^9}}],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"Table", "[", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{"SeriesCoefficient", "[", 
          RowBox[{
           RowBox[{"tmp3", "-", "q3tmp"}], ",", 
           RowBox[{"{", 
            RowBox[{"g", ",", "0", ",", "k"}], "}"}]}], "]"}], "/.", 
         "subQ0"}], "/.", "subtopowerbasis"}], "/.", "subtoPolyGammas"}], "/.", 
      RowBox[{"u", "\[Rule]", "uu"}]}], "//", "Simplify"}], ",", 
    RowBox[{"{", 
     RowBox[{"k", ",", "4", ",", "10", ",", "2"}], "}"}]}], "]"}], "//", 
  "Chop"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Table", "[", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{"SeriesCoefficient", "[", 
          RowBox[{
           RowBox[{"tmp4", "-", "q4tmp"}], ",", 
           RowBox[{"{", 
            RowBox[{"g", ",", "0", ",", "k"}], "}"}]}], "]"}], "/.", 
         "subQ0"}], "/.", "subtopowerbasis"}], "/.", "subtoPolyGammas"}], "/.", 
      RowBox[{"u", "\[Rule]", "uu"}]}], "//", "Simplify"}], ",", 
    RowBox[{"{", 
     RowBox[{"k", ",", "4", ",", "10", ",", "2"}], "}"}]}], "]"}], "//", 
  "Chop"}]}], "Input",
 CellChangeTimes->{{3.550383475210424*^9, 3.5503834977795067`*^9}, {
   3.5503835435297213`*^9, 3.550383614063846*^9}, 3.550383664511714*^9, {
   3.55038371536191*^9, 3.550383718191564*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"0", ",", "0", ",", "0", ",", "0"}], "}"}]], "Output",
 CellChangeTimes->{{3.5503834878251457`*^9, 3.550383498224557*^9}, {
   3.550383537227584*^9, 3.550383614600746*^9}, {3.550383700787709*^9, 
   3.550383718547031*^9}, 3.550384144894299*^9, 3.552388720209691*^9, 
   3.568961773892301*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"0", ",", "0", ",", "0", ",", "0"}], "}"}]], "Output",
 CellChangeTimes->{{3.5503834878251457`*^9, 3.550383498224557*^9}, {
   3.550383537227584*^9, 3.550383614600746*^9}, {3.550383700787709*^9, 
   3.550383718547031*^9}, 3.550384144894299*^9, 3.552388720209691*^9, 
   3.568961774142652*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Series", "[", 
  RowBox[{
   RowBox[{"q3tmp", "//", "Normal"}], ",", 
   RowBox[{"{", 
    RowBox[{"g", ",", "0", ",", "6"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.550384162917316*^9, 3.550384203974078*^9}}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
   FractionBox[
    RowBox[{"3", " ", "\[ImaginaryI]", " ", 
     RowBox[{"(", 
      RowBox[{"3", "+", 
       RowBox[{"6", " ", "\[ImaginaryI]", " ", "u"}], "+", 
       RowBox[{"2", " ", 
        SubsuperscriptBox[
         StyleBox["\[Eta]",
          FontWeight->Bold,
          FontColor->RGBColor[0.8, 0, 0]], "2", 
         RowBox[{"[", "2", "]"}]]}], "+", 
       RowBox[{"6", " ", 
        SuperscriptBox["u", "2"], " ", 
        SubsuperscriptBox[
         StyleBox["\[Eta]",
          FontWeight->Bold,
          FontColor->RGBColor[0.8, 0, 0]], "2", 
         RowBox[{"[", "2", "]"}]]}], "-", 
       RowBox[{"2", " ", "u", " ", 
        SubsuperscriptBox[
         StyleBox["\[Eta]",
          FontWeight->Bold,
          FontColor->RGBColor[0.8, 0, 0]], "3", 
         RowBox[{"[", "2", "]"}]]}]}], ")"}], " ", 
     SuperscriptBox["g", "4"]}], "u"], "+", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{"306", "+", 
      FractionBox[
       RowBox[{"9", " ", "\[ImaginaryI]"}], 
       SuperscriptBox["u", "3"]], "-", 
      FractionBox["9", 
       SuperscriptBox["u", "2"]], "-", 
      FractionBox[
       RowBox[{"153", " ", "\[ImaginaryI]"}], "u"], "+", 
      RowBox[{"216", " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "1"]}], "-", 
      FractionBox[
       RowBox[{"108", " ", "\[ImaginaryI]", " ", 
        SubscriptBox[
         StyleBox["\[Zeta]",
          FontWeight->Bold,
          FontColor->GrayLevel[0.4]], "1"]}], "u"], "-", 
      RowBox[{"216", " ", "\[ImaginaryI]", " ", 
       SubsuperscriptBox[
        StyleBox["\[Eta]",
         FontWeight->Bold,
         FontColor->RGBColor[0.8, 0, 0]], "1", 
        RowBox[{"[", "2", "]"}]]}], "-", 
      FractionBox[
       RowBox[{"108", " ", 
        SubsuperscriptBox[
         StyleBox["\[Eta]",
          FontWeight->Bold,
          FontColor->RGBColor[0.8, 0, 0]], "1", 
         RowBox[{"[", "2", "]"}]]}], "u"], "+", 
      FractionBox[
       RowBox[{"6", " ", "\[ImaginaryI]", " ", 
        SubsuperscriptBox[
         StyleBox["\[Eta]",
          FontWeight->Bold,
          FontColor->RGBColor[0.8, 0, 0]], "2", 
         RowBox[{"[", "2", "]"}]]}], 
       SuperscriptBox["u", "3"]], "-", 
      FractionBox[
       RowBox[{"6", " ", "\[ImaginaryI]", " ", 
        SubsuperscriptBox[
         StyleBox["\[Eta]",
          FontWeight->Bold,
          FontColor->RGBColor[0.8, 0, 0]], "2", 
         RowBox[{"[", "2", "]"}]]}], "u"], "-", 
      RowBox[{"90", " ", "\[ImaginaryI]", " ", "u", " ", 
       SubsuperscriptBox[
        StyleBox["\[Eta]",
         FontWeight->Bold,
         FontColor->RGBColor[0.8, 0, 0]], "2", 
        RowBox[{"[", "2", "]"}]]}], "-", 
      FractionBox[
       RowBox[{"72", " ", "\[ImaginaryI]", " ", 
        SubscriptBox[
         StyleBox["\[Zeta]",
          FontWeight->Bold,
          FontColor->GrayLevel[0.4]], "1"], " ", 
        SubsuperscriptBox[
         StyleBox["\[Eta]",
          FontWeight->Bold,
          FontColor->RGBColor[0.8, 0, 0]], "2", 
         RowBox[{"[", "2", "]"}]]}], "u"], "-", 
      RowBox[{"216", " ", "\[ImaginaryI]", " ", "u", " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "1"], " ", 
       SubsuperscriptBox[
        StyleBox["\[Eta]",
         FontWeight->Bold,
         FontColor->RGBColor[0.8, 0, 0]], "2", 
        RowBox[{"[", "2", "]"}]]}], "-", 
      RowBox[{"12", " ", "\[ImaginaryI]", " ", 
       SubsuperscriptBox[
        StyleBox["\[Eta]",
         FontWeight->Bold,
         FontColor->RGBColor[0.8, 0, 0]], "3", 
        RowBox[{"[", "2", "]"}]]}], "-", 
      FractionBox[
       RowBox[{"36", " ", 
        SubsuperscriptBox[
         StyleBox["\[Eta]",
          FontWeight->Bold,
          FontColor->RGBColor[0.8, 0, 0]], "3", 
         RowBox[{"[", "2", "]"}]]}], "u"], "-", 
      RowBox[{"108", " ", "u", " ", 
       SubsuperscriptBox[
        StyleBox["\[Eta]",
         FontWeight->Bold,
         FontColor->RGBColor[0.8, 0, 0]], "3", 
        RowBox[{"[", "2", "]"}]]}], "+", 
      RowBox[{"72", " ", "\[ImaginaryI]", " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "1"], " ", 
       SubsuperscriptBox[
        StyleBox["\[Eta]",
         FontWeight->Bold,
         FontColor->RGBColor[0.8, 0, 0]], "3", 
        RowBox[{"[", "2", "]"}]]}], "+", 
      RowBox[{"36", " ", 
       SubsuperscriptBox[
        StyleBox["\[Eta]",
         FontWeight->Bold,
         FontColor->RGBColor[0.8, 0, 0]], "4", 
        RowBox[{"[", "2", "]"}]]}], "+", 
      FractionBox[
       RowBox[{"12", " ", "\[ImaginaryI]", " ", 
        SubsuperscriptBox[
         StyleBox["\[Eta]",
          FontWeight->Bold,
          FontColor->RGBColor[0.8, 0, 0]], "4", 
         RowBox[{"[", "2", "]"}]]}], "u"], "+", 
      RowBox[{"36", " ", "\[ImaginaryI]", " ", "u", " ", 
       SubsuperscriptBox[
        StyleBox["\[Eta]",
         FontWeight->Bold,
         FontColor->RGBColor[0.8, 0, 0]], "4", 
        RowBox[{"[", "2", "]"}]]}], "-", 
      RowBox[{"18", " ", "\[ImaginaryI]", " ", 
       SubsuperscriptBox[
        StyleBox["\[Eta]",
         FontWeight->Bold,
         FontColor->RGBColor[0.8, 0, 0]], "5", 
        RowBox[{"[", "2", "]"}]]}], "-", 
      FractionBox[
       RowBox[{"72", " ", 
        SubsuperscriptBox[
         StyleBox["\[Eta]",
          FontWeight->Bold,
          FontColor->RGBColor[0.8, 0, 0]], 
         RowBox[{"2", ",", "1"}], 
         RowBox[{"[", "2", "]"}]]}], "u"], "-", 
      RowBox[{"216", " ", "u", " ", 
       SubsuperscriptBox[
        StyleBox["\[Eta]",
         FontWeight->Bold,
         FontColor->RGBColor[0.8, 0, 0]], 
        RowBox[{"2", ",", "1"}], 
        RowBox[{"[", "2", "]"}]]}], "+", 
      RowBox[{"72", " ", 
       SubsuperscriptBox[
        StyleBox["\[Eta]",
         FontWeight->Bold,
         FontColor->RGBColor[0.8, 0, 0]], 
        RowBox[{"3", ",", "1"}], 
        RowBox[{"[", "2", "]"}]]}]}], ")"}], " ", 
    SuperscriptBox["g", "6"]}], "+", 
   InterpretationBox[
    SuperscriptBox[
     RowBox[{"O", "[", "g", "]"}], "7"],
    SeriesData[$CellContext`g, 0, {}, 4, 7, 1],
    Editable->False]}],
  SeriesData[$CellContext`g, 0, {
   Complex[0, 3] $CellContext`u^(-1) (3 + Complex[0, 6] $CellContext`u + 
     2 $CellContext`\[Eta]$[2][2] + 
     6 $CellContext`u^2 $CellContext`\[Eta]$[2][2] - 
     2 $CellContext`u $CellContext`\[Eta]$[3][2]), 0, 306 + 
    Complex[0, 9] $CellContext`u^(-3) - 9 $CellContext`u^(-2) + 
    Complex[0, -153]/$CellContext`u + 216 $CellContext`\[Zeta]$[1][0] + 
    Complex[0, -108] $CellContext`u^(-1) $CellContext`\[Zeta]$[1][0] + 
    Complex[0, -216] $CellContext`\[Eta]$[1][2] - 
    108 $CellContext`u^(-1) $CellContext`\[Eta]$[1][2] + 
    Complex[0, 6] $CellContext`u^(-3) $CellContext`\[Eta]$[2][2] + 
    Complex[0, -6] $CellContext`u^(-1) $CellContext`\[Eta]$[2][2] + 
    Complex[0, -90] $CellContext`u $CellContext`\[Eta]$[2][2] + 
    Complex[0, -72] $CellContext`u^(-1) $CellContext`\[Zeta]$[1][
      0] $CellContext`\[Eta]$[2][2] + 
    Complex[0, -216] $CellContext`u $CellContext`\[Zeta]$[1][
      0] $CellContext`\[Eta]$[2][2] + 
    Complex[0, -12] $CellContext`\[Eta]$[3][2] - 
    36 $CellContext`u^(-1) $CellContext`\[Eta]$[3][2] - 
    108 $CellContext`u $CellContext`\[Eta]$[3][2] + 
    Complex[0, 72] $CellContext`\[Zeta]$[1][0] $CellContext`\[Eta]$[3][2] + 
    36 $CellContext`\[Eta]$[4][2] + 
    Complex[0, 12] $CellContext`u^(-1) $CellContext`\[Eta]$[4][2] + 
    Complex[0, 36] $CellContext`u $CellContext`\[Eta]$[4][2] + 
    Complex[0, -18] $CellContext`\[Eta]$[5][2] - 
    72 $CellContext`u^(-1) $CellContext`\[Eta]$[2, 1][2] - 
    216 $CellContext`u $CellContext`\[Eta]$[2, 1][2] + 
    72 $CellContext`\[Eta]$[3, 1][2]}, 4, 7, 1],
  Editable->False]], "Output",
 CellChangeTimes->{{3.5503841975763273`*^9, 3.5503842046868477`*^9}, 
   3.5523887257018833`*^9, 3.552389086677977*^9, 3.568961774644822*^9}]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 "Computation  ",
 Cell[BoxData[
  FormBox[
   SubscriptBox["q", 
    RowBox[{"3", ",", "4"}]], TraditionalForm]],
  FormatType->"TraditionalForm"],
 ", leading term"
}], "Subsubsection",
 CellChangeTimes->{{3.541066491268599*^9, 3.541066492391665*^9}, {
  3.5503854746741056`*^9, 3.550385483872486*^9}, {3.550385575731894*^9, 
  3.550385623081932*^9}}],

Cell[TextData[{
 "For ",
 Cell[BoxData[
  FormBox[
   SubscriptBox["q", 
    RowBox[{"3", ",", "4"}]], TraditionalForm]],
  FormatType->"TraditionalForm"],
 " we need only the leading tern, and it only appears at double wrapping."
}], "Text",
 CellChangeTimes->{{3.550375485470044*^9, 3.5503755151638393`*^9}, {
  3.550385187125126*^9, 3.550385187676194*^9}, {3.5503856564682302`*^9, 
  3.550385656809401*^9}, {3.550385930338954*^9, 3.550385930694026*^9}}],

Cell[BoxData[
 RowBox[{
  SubscriptBox[
   StyleBox["q",
    FontColor->RGBColor[0, 0, 0.8]], 
   RowBox[{"3", ",", "4"}]], "\[Equal]", 
  FractionBox[
   RowBox[{
    RowBox[{
     SubscriptBox[
      StyleBox["q",
       FontColor->RGBColor[0, 0, 0.8]], 
      RowBox[{"1", ",", "3"}]], " ", 
     SubscriptBox[
      StyleBox["q",
       FontColor->RGBColor[0, 0, 0.8]], 
      RowBox[{"2", ",", "4"}]]}], "-", 
    RowBox[{
     SubscriptBox[
      StyleBox["q",
       FontColor->RGBColor[0, 0, 0.8]], 
      RowBox[{"1", ",", "4"}]], " ", 
     SubscriptBox[
      StyleBox["q",
       FontColor->RGBColor[0, 0, 0.8]], 
      RowBox[{"2", ",", "3"}]]}]}], 
   StyleBox["Q",
    FontColor->RGBColor[0.8, 0, 0]]], "\[Equal]", 
  RowBox[{"\[ScriptCapitalO]", "[", 
   SuperscriptBox["g", "8"], "]"}]}]], "Input"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"Collect", "[", 
     RowBox[{
      RowBox[{
       RowBox[{
        FractionBox[
         RowBox[{
          RowBox[{
           SubscriptBox[
            StyleBox["q",
             FontColor->RGBColor[0, 0, 0.8]], 
            RowBox[{"1", ",", "3"}]], " ", 
           SubscriptBox[
            StyleBox["q",
             FontColor->RGBColor[0, 0, 0.8]], 
            RowBox[{"2", ",", "4"}]]}], "-", 
          RowBox[{
           SubscriptBox[
            StyleBox["q",
             FontColor->RGBColor[0, 0, 0.8]], 
            RowBox[{"1", ",", "4"}]], " ", 
           SubscriptBox[
            StyleBox["q",
             FontColor->RGBColor[0, 0, 0.8]], 
            RowBox[{"2", ",", "3"}]]}]}], 
         StyleBox["Q",
          FontColor->RGBColor[0.8, 0, 0]]], "/.", 
        RowBox[{"leadweak", "[", "1", "]"}]}], "/.", 
       RowBox[{"Q", "\[Rule]", "Q0"}]}], ",", 
      RowBox[{"{", 
       RowBox[{"Q0", ",", 
        RowBox[{
         RowBox[{"\[Eta]$", "[", "__", "]"}], "[", "_", "]"}]}], "}"}], ",", 
      "Simplify"}], "]"}], "/.", 
    RowBox[{
     SuperscriptBox["u", "2"], "\[Rule]", 
     RowBox[{"Q0", "+", 
      FractionBox["1", "12"]}]}]}], "/.", "subtoMHZbasis"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"Collect", "[", 
  RowBox[{"%", ",", 
   RowBox[{"{", 
    RowBox[{"g", ",", "Q0", ",", 
     RowBox[{
      RowBox[{"\[Eta]$", "[", "__", "]"}], "[", "_", "]"}]}], "}"}], ",", 
   "Simplify"}], "]"}], "\[IndentingNewLine]"}], "Input",
 CellChangeTimes->{{3.5503856666978617`*^9, 3.5503857631396427`*^9}, {
  3.550386100891906*^9, 3.550386144422077*^9}}],

Cell[BoxData[
 RowBox[{
  SuperscriptBox["g", "8"], " ", 
  RowBox[{"(", 
   RowBox[{"108", "-", 
    RowBox[{"216", " ", "\[ImaginaryI]", " ", "u", " ", 
     SubsuperscriptBox[
      StyleBox["\[Eta]",
       FontWeight->Bold,
       FontColor->RGBColor[0.8, 0, 0]], "2", "+"]}], "+", 
    RowBox[{"36", " ", "\[ImaginaryI]", " ", 
     SubsuperscriptBox[
      StyleBox["\[Eta]",
       FontWeight->Bold,
       FontColor->RGBColor[0.8, 0, 0]], "3", "+"]}], "-", 
    RowBox[{"36", " ", "\[ImaginaryI]", " ", "u", " ", 
     SubsuperscriptBox[
      StyleBox["\[Eta]",
       FontWeight->Bold,
       FontColor->RGBColor[0.8, 0, 0]], "4", "+"]}], "+", 
    RowBox[{
     StyleBox["Q0",
      FontColor->RGBColor[{
         Rational[1, 2], 
         Rational[1, 2], 0}]], " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{
        RowBox[{"-", "108"}], " ", 
        SubsuperscriptBox[
         StyleBox["\[Eta]",
          FontWeight->Bold,
          FontColor->RGBColor[0.8, 0, 0]], "4", "+"]}], "-", 
       RowBox[{"216", " ", 
        SubsuperscriptBox[
         StyleBox["\[Eta]",
          FontWeight->Bold,
          FontColor->RGBColor[0.8, 0, 0]], 
         RowBox[{"2", ",", "2"}], "+"]}], "-", 
       RowBox[{"36", " ", 
        SubsuperscriptBox[
         StyleBox["\[Eta]",
          FontWeight->Bold,
          FontColor->RGBColor[0.8, 0, 0]], 
         RowBox[{"2", ",", "4"}], "+"]}], "+", 
       RowBox[{"72", " ", 
        SubsuperscriptBox[
         StyleBox["\[Eta]",
          FontWeight->Bold,
          FontColor->RGBColor[0.8, 0, 0]], 
         RowBox[{"3", ",", "3"}], "+"]}], "-", 
       RowBox[{"36", " ", 
        SubsuperscriptBox[
         StyleBox["\[Eta]",
          FontWeight->Bold,
          FontColor->RGBColor[0.8, 0, 0]], 
         RowBox[{"4", ",", "2"}], "+"]}]}], ")"}]}]}], ")"}]}]], "Output",
 CellChangeTimes->{{3.550386093305468*^9, 3.5503861449918547`*^9}, 
   3.5523890954717903`*^9, 3.552389266772066*^9, 3.568961788537003*^9}]
}, Open  ]],

Cell["\<\
This order is also written in weakqij and leadweak.\
\>", "Text",
 CellChangeTimes->{{3.550386148360981*^9, 3.550386156564602*^9}, {
  3.55038655178057*^9, 3.5503865536928587`*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[Cell[BoxData[
 FormBox[
  SubscriptBox["W", "s"], TraditionalForm]],
 FormatType->"TraditionalForm"]], "Subsubsection",
 CellChangeTimes->{{3.541066491268599*^9, 3.541066492391665*^9}, {
  3.5503854746741056`*^9, 3.550385483872486*^9}, {3.550385575731894*^9, 
  3.550385597755858*^9}, {3.550387121011858*^9, 3.550387126084937*^9}, {
  3.550388082582279*^9, 3.550388083190147*^9}}],

Cell[BoxData[
 RowBox[{
  SubscriptBox["W", "s"], "=", 
  RowBox[{
   RowBox[{
    SubsuperscriptBox["q", "3", 
     RowBox[{"[", "s", "]"}]], 
    SubsuperscriptBox[
     OverscriptBox["q", "_"], "4", 
     RowBox[{"[", 
      RowBox[{"-", "s"}], "]"}]]}], "+", 
   RowBox[{
    SubsuperscriptBox["q", "4", 
     RowBox[{"[", "s", "]"}]], 
    SubsuperscriptBox[
     OverscriptBox["q", "_"], "3", 
     RowBox[{"[", 
      RowBox[{"-", "s"}], "]"}]]}]}]}]], "Input",
 CellChangeTimes->{{3.550387126964056*^9, 3.550387142774701*^9}}],

Cell["\<\
Expressions are two large, I just incorporate precomputation procedure in \
leadweak:\
\>", "Text",
 CellChangeTimes->{{3.550386862464191*^9, 3.550386882623042*^9}, 
   3.550387149215693*^9}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  SubscriptBox["W", "0"], "/.", 
  RowBox[{"leadweak", "[", "1", "]"}]}]], "Input",
 CellChangeTimes->{{3.550387070619985*^9, 3.550387103599972*^9}, {
  3.5523893162003927`*^9, 3.552389333268858*^9}}],

Cell[BoxData[
 RowBox[{
  SuperscriptBox["g", "8"], " ", 
  RowBox[{"(", 
   RowBox[{
    RowBox[{"-", 
     FractionBox["54", 
      SuperscriptBox["u", "2"]]}], "+", 
    FractionBox[
     RowBox[{"18", " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "1"}], "+", 
        RowBox[{"3", " ", "\[ImaginaryI]", " ", "u"}], "+", 
        RowBox[{"3", " ", 
         SuperscriptBox["u", "2"]}]}], ")"}], " ", 
      SubsuperscriptBox[
       StyleBox["\[Eta]",
        FontWeight->Bold,
        FontColor->RGBColor[0.8, 0, 0]], "2", 
       RowBox[{"[", "2", "]"}]]}], 
     SuperscriptBox["u", "2"]], "-", 
    FractionBox[
     RowBox[{"18", " ", 
      RowBox[{"(", 
       RowBox[{"\[ImaginaryI]", "+", "u", "+", 
        RowBox[{"3", " ", "\[ImaginaryI]", " ", 
         SuperscriptBox["u", "2"]}], "+", 
        RowBox[{"6", " ", 
         SuperscriptBox["u", "3"]}]}], ")"}], " ", 
      SubsuperscriptBox[
       StyleBox["\[Eta]",
        FontWeight->Bold,
        FontColor->RGBColor[0.8, 0, 0]], "3", 
       RowBox[{"[", "2", "]"}]]}], 
     SuperscriptBox["u", "2"]], "+", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{"36", "+", 
       FractionBox[
        RowBox[{"18", " ", "\[ImaginaryI]"}], "u"]}], ")"}], " ", 
     SubsuperscriptBox[
      StyleBox["\[Eta]",
       FontWeight->Bold,
       FontColor->RGBColor[0.8, 0, 0]], "4", 
      RowBox[{"[", "2", "]"}]]}], "+", 
    FractionBox[
     RowBox[{"18", " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "1"}], "-", 
        RowBox[{"3", " ", "\[ImaginaryI]", " ", "u"}], "+", 
        RowBox[{"3", " ", 
         SuperscriptBox["u", "2"]}]}], ")"}], " ", 
      SubsuperscriptBox[
       OverscriptBox[
        StyleBox["\[Eta]",
         FontWeight->Bold,
         FontColor->RGBColor[0.8, 0, 0]], 
        StyleBox["_",
         FontWeight->Bold,
         FontColor->RGBColor[0.8, 0, 0]]], "2", 
       RowBox[{"[", 
        RowBox[{"-", "2"}], "]"}]]}], 
     SuperscriptBox["u", "2"]], "-", 
    FractionBox[
     RowBox[{"12", " ", "\[ImaginaryI]", " ", 
      RowBox[{"(", 
       RowBox[{"1", "+", 
        RowBox[{"3", " ", 
         SuperscriptBox["u", "2"]}], "+", 
        RowBox[{"9", " ", 
         SuperscriptBox["u", "4"]}]}], ")"}], " ", 
      SubsuperscriptBox[
       StyleBox["\[Eta]",
        FontWeight->Bold,
        FontColor->RGBColor[0.8, 0, 0]], "3", 
       RowBox[{"[", "2", "]"}]], " ", 
      SubsuperscriptBox[
       OverscriptBox[
        StyleBox["\[Eta]",
         FontWeight->Bold,
         FontColor->RGBColor[0.8, 0, 0]], 
        StyleBox["_",
         FontWeight->Bold,
         FontColor->RGBColor[0.8, 0, 0]]], "2", 
       RowBox[{"[", 
        RowBox[{"-", "2"}], "]"}]]}], 
     SuperscriptBox["u", "2"]], "+", 
    FractionBox[
     RowBox[{"12", " ", "\[ImaginaryI]", " ", 
      RowBox[{"(", 
       RowBox[{"1", "+", 
        RowBox[{"3", " ", 
         SuperscriptBox["u", "2"]}]}], ")"}], " ", 
      SubsuperscriptBox[
       StyleBox["\[Eta]",
        FontWeight->Bold,
        FontColor->RGBColor[0.8, 0, 0]], "4", 
       RowBox[{"[", "2", "]"}]], " ", 
      SubsuperscriptBox[
       OverscriptBox[
        StyleBox["\[Eta]",
         FontWeight->Bold,
         FontColor->RGBColor[0.8, 0, 0]], 
        StyleBox["_",
         FontWeight->Bold,
         FontColor->RGBColor[0.8, 0, 0]]], "2", 
       RowBox[{"[", 
        RowBox[{"-", "2"}], "]"}]]}], "u"], "-", 
    FractionBox[
     RowBox[{"18", " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "\[ImaginaryI]"}], "+", "u", "-", 
        RowBox[{"3", " ", "\[ImaginaryI]", " ", 
         SuperscriptBox["u", "2"]}], "+", 
        RowBox[{"6", " ", 
         SuperscriptBox["u", "3"]}]}], ")"}], " ", 
      SubsuperscriptBox[
       OverscriptBox[
        StyleBox["\[Eta]",
         FontWeight->Bold,
         FontColor->RGBColor[0.8, 0, 0]], 
        StyleBox["_",
         FontWeight->Bold,
         FontColor->RGBColor[0.8, 0, 0]]], "3", 
       RowBox[{"[", 
        RowBox[{"-", "2"}], "]"}]]}], 
     SuperscriptBox["u", "2"]], "+", 
    FractionBox[
     RowBox[{"12", " ", "\[ImaginaryI]", " ", 
      RowBox[{"(", 
       RowBox[{"1", "+", 
        RowBox[{"3", " ", 
         SuperscriptBox["u", "2"]}], "+", 
        RowBox[{"9", " ", 
         SuperscriptBox["u", "4"]}]}], ")"}], " ", 
      SubsuperscriptBox[
       StyleBox["\[Eta]",
        FontWeight->Bold,
        FontColor->RGBColor[0.8, 0, 0]], "2", 
       RowBox[{"[", "2", "]"}]], " ", 
      SubsuperscriptBox[
       OverscriptBox[
        StyleBox["\[Eta]",
         FontWeight->Bold,
         FontColor->RGBColor[0.8, 0, 0]], 
        StyleBox["_",
         FontWeight->Bold,
         FontColor->RGBColor[0.8, 0, 0]]], "3", 
       RowBox[{"[", 
        RowBox[{"-", "2"}], "]"}]]}], 
     SuperscriptBox["u", "2"]], "-", 
    RowBox[{"12", " ", "\[ImaginaryI]", " ", 
     SubsuperscriptBox[
      StyleBox["\[Eta]",
       FontWeight->Bold,
       FontColor->RGBColor[0.8, 0, 0]], "4", 
      RowBox[{"[", "2", "]"}]], " ", 
     SubsuperscriptBox[
      OverscriptBox[
       StyleBox["\[Eta]",
        FontWeight->Bold,
        FontColor->RGBColor[0.8, 0, 0]], 
       StyleBox["_",
        FontWeight->Bold,
        FontColor->RGBColor[0.8, 0, 0]]], "3", 
      RowBox[{"[", 
       RowBox[{"-", "2"}], "]"}]]}], "+", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{"36", "-", 
       FractionBox[
        RowBox[{"18", " ", "\[ImaginaryI]"}], "u"]}], ")"}], " ", 
     SubsuperscriptBox[
      OverscriptBox[
       StyleBox["\[Eta]",
        FontWeight->Bold,
        FontColor->RGBColor[0.8, 0, 0]], 
       StyleBox["_",
        FontWeight->Bold,
        FontColor->RGBColor[0.8, 0, 0]]], "4", 
      RowBox[{"[", 
       RowBox[{"-", "2"}], "]"}]]}], "-", 
    FractionBox[
     RowBox[{"12", " ", "\[ImaginaryI]", " ", 
      RowBox[{"(", 
       RowBox[{"1", "+", 
        RowBox[{"3", " ", 
         SuperscriptBox["u", "2"]}]}], ")"}], " ", 
      SubsuperscriptBox[
       StyleBox["\[Eta]",
        FontWeight->Bold,
        FontColor->RGBColor[0.8, 0, 0]], "2", 
       RowBox[{"[", "2", "]"}]], " ", 
      SubsuperscriptBox[
       OverscriptBox[
        StyleBox["\[Eta]",
         FontWeight->Bold,
         FontColor->RGBColor[0.8, 0, 0]], 
        StyleBox["_",
         FontWeight->Bold,
         FontColor->RGBColor[0.8, 0, 0]]], "4", 
       RowBox[{"[", 
        RowBox[{"-", "2"}], "]"}]]}], "u"], "+", 
    RowBox[{"12", " ", "\[ImaginaryI]", " ", 
     SubsuperscriptBox[
      StyleBox["\[Eta]",
       FontWeight->Bold,
       FontColor->RGBColor[0.8, 0, 0]], "3", 
      RowBox[{"[", "2", "]"}]], " ", 
     SubsuperscriptBox[
      OverscriptBox[
       StyleBox["\[Eta]",
        FontWeight->Bold,
        FontColor->RGBColor[0.8, 0, 0]], 
       StyleBox["_",
        FontWeight->Bold,
        FontColor->RGBColor[0.8, 0, 0]]], "4", 
      RowBox[{"[", 
       RowBox[{"-", "2"}], "]"}]]}]}], ")"}]}]], "Output",
 CellChangeTimes->{{3.550387075222788*^9, 3.550387104129919*^9}, {
   3.552389309970748*^9, 3.55238933357484*^9}, 3.568961799573367*^9}]
}, Open  ]],

Cell["So, for instance, we can compute residue at 0:", "Text",
 CellChangeTimes->{{3.550387155563931*^9, 3.550387164019232*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Series", "[", 
    RowBox[{
     RowBox[{
      RowBox[{
       SubscriptBox["W", "0"], "/.", 
       RowBox[{"leadweak", "[", "1", "]"}]}], "/.", "subtoPolyGammas"}], ",", 
     
     RowBox[{"{", 
      RowBox[{"u", ",", "0", ",", 
       RowBox[{"-", "1"}]}], "}"}]}], "]"}], "//", "FunctionExpand"}], "//", 
  "Simplify"}]], "Input",
 CellChangeTimes->{{3.5503871646582737`*^9, 3.5503872207078648`*^9}, {
  3.55238935526446*^9, 3.552389368100738*^9}}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
   RowBox[{"-", 
    FractionBox[
     RowBox[{"2", " ", 
      RowBox[{"(", 
       RowBox[{
        SuperscriptBox["g", "8"], " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"-", "9"}], "+", 
          SuperscriptBox["\[Pi]", "2"]}], ")"}], " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"-", "3"}], "+", 
          RowBox[{"2", " ", 
           RowBox[{"Zeta", "[", "3", "]"}]}]}], ")"}]}], ")"}]}], 
     SuperscriptBox["u", "2"]]}], "+", 
   InterpretationBox[
    SuperscriptBox[
     RowBox[{"O", "[", "u", "]"}], "0"],
    SeriesData[$CellContext`u, 0, {}, -2, 0, 1],
    Editable->False]}],
  SeriesData[$CellContext`u, 
   0, {(-2) $CellContext`g^8 (-9 + Pi^2) (-3 + 2 Zeta[3])}, -2, 0, 1],
  Editable->False]], "Output",
 CellChangeTimes->{{3.550387184052672*^9, 3.5503872211631193`*^9}, {
   3.5523893460637503`*^9, 3.552389368657889*^9}, 3.5689618040484047`*^9}]
}, Open  ]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  FormBox[
   SubscriptBox["q", 
    RowBox[{"1", ",", "2"}]], TraditionalForm]]],
 " (i.e. ",
 Cell[BoxData[
  FormBox[
   OverscriptBox["Q", "~"], TraditionalForm]]],
 ") at single wrapping orders"
}], "Subsection",
 CellChangeTimes->{{3.5521971839438*^9, 3.552197201849609*^9}, {
  3.553351346348865*^9, 3.5533513556581917`*^9}}],

Cell[CellGroupData[{

Cell["Theory", "Subsubsection",
 CellChangeTimes->{{3.552197431942743*^9, 3.552197448091651*^9}, {
  3.55358596895302*^9, 3.553585969535471*^9}}],

Cell["Equation", "Item",
 CellChangeTimes->{{3.552197803456256*^9, 3.55219780475543*^9}}],

Cell[TextData[{
 Cell[BoxData[
  FormBox[
   OverscriptBox["Q", "~"], TraditionalForm]]],
 " is generically defined as"
}], "Text",
 CellChangeTimes->{{3.5533556325229063`*^9, 3.553355639544115*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{
    OverscriptBox["Q", "~"], "=", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{"u", "-", 
       SubscriptBox["v", "0"], "-", "\[Alpha]"}], ")"}], 
     RowBox[{"(", 
      RowBox[{"u", "+", 
       SubscriptBox["v", "0"], "+", 
       OverscriptBox["\[Alpha]", "_"]}], ")"}]}]}], ",", 
   RowBox[{
    OverscriptBox[
     OverscriptBox["Q", "~"], "_"], "=", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{"u", "-", 
       SubscriptBox["v", "0"], "-", 
       OverscriptBox["\[Alpha]", "_"]}], ")"}], 
     RowBox[{"(", 
      RowBox[{"u", "+", 
       SubscriptBox["v", "0"], "+", "\[Alpha]"}], ")"}]}]}]}], "}"}]], "Input",\

 CellChangeTimes->{{3.553355643074214*^9, 3.553355673732299*^9}, {
  3.5533557441061296`*^9, 3.55335574444202*^9}, {3.553362102054981*^9, 
  3.5533621252804613`*^9}, {3.553362210733736*^9, 3.5533622306556597`*^9}}],

Cell["\<\
It will be useful to know the following combination containing \[Alpha] \
(expressions are evaluated at the Bethe root, leading approximation is \
considered only):\
\>", "Text",
 CellChangeTimes->{{3.553362138067143*^9, 3.553362146889206*^9}, {
  3.553409009535396*^9, 3.553409073026362*^9}}],

Cell[BoxData[
 RowBox[{
  FractionBox[
   RowBox[{
    OverscriptBox["Q", "~"], 
    OverscriptBox[
     OverscriptBox["Q", "~"], "_"]}], "Q"], "\[Equal]", 
  FractionBox[
   RowBox[{
    RowBox[{"(", 
     RowBox[{"Q", "+", "\[Delta]Q"}], ")"}], 
    RowBox[{"(", 
     RowBox[{"Q", "+", 
      OverscriptBox["\[Delta]Q", "_"]}], ")"}]}], "Q"], "\[Equal]", 
  RowBox[{"\[Delta]Q", "+", " ", 
   OverscriptBox["\[Delta]Q", "_"]}], "\[Equal]", 
  RowBox[{
   RowBox[{"-", "2"}], 
   SubscriptBox["v", "0"], 
   RowBox[{"(", 
    RowBox[{"\[Alpha]", "+", 
     OverscriptBox["\[Alpha]", "_"]}], ")"}], " ", 
   RowBox[{"(*", " ", 
    RowBox[{"this", " ", "expression", " ", "comes", " ", "from", " ", 
     SubscriptBox["T", 
      RowBox[{"0", ",", "0"}]]}], "*)"}]}]}]], "Input",
 CellChangeTimes->{{3.5533621278286467`*^9, 3.553362263794121*^9}, {
  3.553409091613206*^9, 3.553409117582953*^9}}],

Cell[BoxData[
 RowBox[{
  FractionBox[
   RowBox[{
    SuperscriptBox[
     OverscriptBox["Q", "~"], 
     RowBox[{"[", "2", "]"}]], 
    OverscriptBox[
     OverscriptBox["Q", "~"], "_"]}], 
   SuperscriptBox["Q", 
    RowBox[{"[", "2", "]"}]]], "==", 
  FractionBox[
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      SuperscriptBox["Q", 
       RowBox[{"[", "2", "]"}]], "+", 
      SuperscriptBox["\[Delta]Q", 
       RowBox[{"[", "2", "]"}]]}], ")"}], 
    RowBox[{"(", 
     RowBox[{"Q", "+", 
      OverscriptBox["\[Delta]Q", "_"]}], ")"}]}], 
   SuperscriptBox["Q", 
    RowBox[{"[", "2", "]"}]]], "==", 
  OverscriptBox["\[Delta]Q", "_"], "\[Equal]", 
  RowBox[{
   RowBox[{"-", "2"}], 
   SubscriptBox["v", "0"], 
   OverscriptBox["\[Alpha]", "_"], " ", 
   RowBox[{"(*", " ", 
    RowBox[{"this", " ", "expression", " ", "comes", " ", "from", " ", 
     SubsuperscriptBox["T", 
      RowBox[{"1", ",", "0"}], "+"]}], "*)"}]}]}]], "Input",
 CellChangeTimes->{{3.5533622761306267`*^9, 3.553362319344775*^9}, {
  3.553409078594935*^9, 3.553409089023431*^9}}],

Cell["So it is useful to consider combination", "Text",
 CellChangeTimes->{{3.55336232265107*^9, 3.55336233023918*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   FractionBox[
    SubsuperscriptBox["T", 
     RowBox[{"1", ",", "0"}], "+"], 
    SuperscriptBox["Q", 
     RowBox[{"[", "2", "]"}]]], "-", 
   FractionBox[
    SubscriptBox["T", 
     RowBox[{"0", ",", "0"}]], "Q"]}], "==", 
  RowBox[{
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      FractionBox[
       SubscriptBox[
        StyleBox["q",
         FontColor->RGBColor[0, 0, 0.8]], 
        RowBox[{"2", ",", "4"}]], 
       StyleBox["Q",
        FontColor->RGBColor[0.8, 0, 0]]], "-", 
      FractionBox[
       SubsuperscriptBox[
        StyleBox["q",
         FontColor->RGBColor[0, 0, 0.8]], 
        RowBox[{"2", ",", "4"}], 
        RowBox[{"[", "2", "]"}]], 
       SuperscriptBox[
        StyleBox["Q",
         FontColor->RGBColor[0.8, 0, 0]], 
        RowBox[{"[", "2", "]"}]]]}], ")"}], " ", 
    SubscriptBox[
     OverscriptBox[
      StyleBox["q",
       FontColor->RGBColor[0, 0, 0.8]], 
      StyleBox["_",
       FontColor->RGBColor[0, 0, 0.8]]], 
     RowBox[{"1", ",", "3"}]]}], "+", 
   RowBox[{"2", " ", 
    RowBox[{"(", 
     RowBox[{
      FractionBox[
       SubscriptBox[
        StyleBox["q",
         FontColor->RGBColor[0, 0, 0.8]], 
        RowBox[{"1", ",", "4"}]], 
       StyleBox["Q",
        FontColor->RGBColor[0.8, 0, 0]]], "-", 
      FractionBox[
       SubsuperscriptBox[
        StyleBox["q",
         FontColor->RGBColor[0, 0, 0.8]], 
        RowBox[{"1", ",", "4"}], 
        RowBox[{"[", "2", "]"}]], 
       SuperscriptBox[
        StyleBox["Q",
         FontColor->RGBColor[0.8, 0, 0]], 
        RowBox[{"[", "2", "]"}]]]}], ")"}], " ", 
    SubscriptBox[
     OverscriptBox[
      StyleBox["q",
       FontColor->RGBColor[0, 0, 0.8]], 
      StyleBox["_",
       FontColor->RGBColor[0, 0, 0.8]]], 
     RowBox[{"1", ",", "4"}]]}], "+", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      FractionBox[
       SubscriptBox[
        StyleBox["q",
         FontColor->RGBColor[0, 0, 0.8]], 
        RowBox[{"1", ",", "3"}]], 
       StyleBox["Q",
        FontColor->RGBColor[0.8, 0, 0]]], "-", 
      FractionBox[
       SubsuperscriptBox[
        StyleBox["q",
         FontColor->RGBColor[0, 0, 0.8]], 
        RowBox[{"1", ",", "3"}], 
        RowBox[{"[", "2", "]"}]], 
       SuperscriptBox[
        StyleBox["Q",
         FontColor->RGBColor[0.8, 0, 0]], 
        RowBox[{"[", "2", "]"}]]]}], ")"}], " ", 
    SubscriptBox[
     OverscriptBox[
      StyleBox["q",
       FontColor->RGBColor[0, 0, 0.8]], 
      StyleBox["_",
       FontColor->RGBColor[0, 0, 0.8]]], 
     RowBox[{"2", ",", "4"}]]}], "+", 
   RowBox[{"2", 
    SubscriptBox["v", "0"], "\[Alpha]"}]}], "\[Equal]", "\[IndentingNewLine]",
   "\[Equal]", 
  RowBox[{
   RowBox[{
    FractionBox[
     SuperscriptBox[
      RowBox[{"(", 
       SuperscriptBox[
        StyleBox["U",
         FontColor->RGBColor[0, 0.6, 0]], "+"], ")"}], "2"], 
     RowBox[{"Q", " ", 
      SuperscriptBox["Q", 
       RowBox[{"[", "2", "]"}]]}]], 
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       SuperscriptBox[
        RowBox[{"(", 
         SubsuperscriptBox[
          StyleBox["q",
           FontColor->RGBColor[0, 0, 0.8]], "2", "+"], ")"}], "2"], 
       SubscriptBox[
        OverscriptBox[
         StyleBox["q",
          FontColor->RGBColor[0, 0, 0.8]], 
         StyleBox["_",
          FontColor->RGBColor[0, 0, 0.8]]], 
        RowBox[{"1", ",", "3"}]]}], "+", 
      RowBox[{
       RowBox[{"(", 
        SubsuperscriptBox[
         StyleBox["q",
          FontColor->RGBColor[0, 0, 0.8]], "2", "+"], ")"}], 
       SubscriptBox[
        OverscriptBox[
         StyleBox["q",
          FontColor->RGBColor[0, 0, 0.8]], 
         StyleBox["_",
          FontColor->RGBColor[0, 0, 0.8]]], 
        RowBox[{"1", ",", "4"}]]}], "+", " ", 
      SubscriptBox[
       OverscriptBox[
        StyleBox["q",
         FontColor->RGBColor[0, 0, 0.8]], 
        StyleBox["_",
         FontColor->RGBColor[0, 0, 0.8]]], 
       RowBox[{"2", ",", "4"}]]}], ")"}]}], "+", 
   RowBox[{"2", 
    SubscriptBox["v", "0"], "\[Alpha]"}]}]}]], "Input",
 CellChangeTimes->{{3.553362331286655*^9, 3.553362358341874*^9}, {
  3.5533624204299383`*^9, 3.55336249360427*^9}, {3.553362524410613*^9, 
  3.553362525221056*^9}, {3.5533625552662086`*^9, 3.553362627888215*^9}}],

Cell["\<\
This should be zero at the Bethe root. So we have that \[Alpha] is given by \
the following expression at the Bethe root\
\>", "Text",
 CellChangeTimes->{{3.553362497732538*^9, 3.5533625034048853`*^9}, {
  3.5533626516884327`*^9, 3.553362662949546*^9}, {3.553409178672495*^9, 
  3.553409178791567*^9}}],

Cell[BoxData[
 RowBox[{"\[Alpha]", "\[Equal]", " ", 
  RowBox[{
   RowBox[{"-", 
    FractionBox[
     SuperscriptBox[
      RowBox[{"(", 
       SuperscriptBox[
        StyleBox["U",
         FontColor->RGBColor[0, 0.6, 0]], "+"], ")"}], "2"], 
     RowBox[{"2", 
      SubscriptBox["v", "0"], "Q", " ", 
      SuperscriptBox["Q", 
       RowBox[{"[", "2", "]"}]]}]]}], 
   RowBox[{"(", 
    RowBox[{
     RowBox[{
      SuperscriptBox[
       RowBox[{"(", 
        SubsuperscriptBox[
         StyleBox["q",
          FontColor->RGBColor[0, 0, 0.8]], "2", "+"], ")"}], "2"], 
      SubscriptBox[
       OverscriptBox[
        StyleBox["q",
         FontColor->RGBColor[0, 0, 0.8]], 
        StyleBox["_",
         FontColor->RGBColor[0, 0, 0.8]]], 
       RowBox[{"1", ",", "3"}]]}], "+", 
     RowBox[{"2", 
      RowBox[{"(", 
       SubsuperscriptBox[
        StyleBox["q",
         FontColor->RGBColor[0, 0, 0.8]], "2", "+"], ")"}], 
      SubscriptBox[
       OverscriptBox[
        StyleBox["q",
         FontColor->RGBColor[0, 0, 0.8]], 
        StyleBox["_",
         FontColor->RGBColor[0, 0, 0.8]]], 
       RowBox[{"1", ",", "4"}]]}], "+", " ", 
     SubscriptBox[
      OverscriptBox[
       StyleBox["q",
        FontColor->RGBColor[0, 0, 0.8]], 
       StyleBox["_",
        FontColor->RGBColor[0, 0, 0.8]]], 
      RowBox[{"2", ",", "4"}]]}], ")"}]}]}]], "Input"],

Cell[TextData[{
 "In this way we assure that a certain combination of ",
 Cell[BoxData[
  FormBox[
   SubscriptBox["T", 
    RowBox[{"1", ",", "0"}]], TraditionalForm]]],
 " and ",
 Cell[BoxData[
  FormBox[
   FractionBox[
    SubscriptBox["T", 
     RowBox[{"0", ",", "0"}]], "Q"], TraditionalForm]]],
 " is zero at the Bethe root. However, each of them is zero separately. The \
reason comes from Hirota equation ",
 Cell[BoxData[
  FormBox[
   RowBox[{
    RowBox[{
     SubsuperscriptBox["T", 
      RowBox[{"1", ",", "0"}], "+"], 
     SubsuperscriptBox["T", 
      RowBox[{"1", ",", "1"}], "-"]}], "\[Equal]", 
    RowBox[{
     RowBox[{
      SubscriptBox["T", 
       RowBox[{"2", ",", "0"}]], 
      SubscriptBox["T", 
       RowBox[{"0", ",", "0"}]]}], "+", 
     RowBox[{
      SuperscriptBox[
       RowBox[{"(", 
        RowBox[{
         SuperscriptBox["U", "+"], 
         SuperscriptBox[
          OverscriptBox["U", "_"], "-"]}], ")"}], "2"], 
      SubsuperscriptBox["T", 
       RowBox[{"1", ",", "1"}], "2"]}]}]}], TraditionalForm]]],
 ". The last term has suppression by one wrapping, hence the fact that \
asymptotic ",
 Cell[BoxData[
  FormBox[
   SubscriptBox["T", 
    RowBox[{"1", ",", "1"}]], TraditionalForm]]],
 " vanishes at Bethe root (exact ",
 Cell[BoxData[
  FormBox[
   SubscriptBox["T", 
    RowBox[{"1", ",", "1"}]], TraditionalForm]]],
 " also vanishes, but this is a constraint, defining mean value of ",
 Cell[BoxData[
  FormBox[
   SubscriptBox["\[Rho]", "2"], TraditionalForm]]],
 ", but not a property.  It is important that we use only asymptotic \
expression in our reasoning) tells us that a certain combination of  ",
 Cell[BoxData[
  FormBox[
   FractionBox[
    RowBox[{
     SubsuperscriptBox["T", 
      RowBox[{"1", ",", "0"}], "+"], 
     SubsuperscriptBox["T", 
      RowBox[{"1", ",", "0"}], "-"]}], "Q"], TraditionalForm]]],
 " and ",
 Cell[BoxData[
  FormBox[
   FractionBox[
    SubscriptBox["T", 
     RowBox[{"0", ",", "0"}]], "Q"], TraditionalForm]]],
 " should be zero at wrapping order. Indeed, one can check explicitly (from \
knowing qij at first 4 orders) that"
}], "Text",
 CellChangeTimes->{{3.553409194920314*^9, 3.553409409221051*^9}, {
  3.553409443748198*^9, 3.553409454236239*^9}, {3.553586037793535*^9, 
  3.5535861935288153`*^9}, {3.56901466086869*^9, 3.569014686338194*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   FractionBox[
    SubsuperscriptBox["\[Delta]T", 
     RowBox[{"1", ",", "0"}], "+"], 
    SuperscriptBox["Q", 
     RowBox[{"[", 
      RowBox[{"+", "2"}], "]"}]]], "+", 
   FractionBox[
    SubsuperscriptBox["\[Delta]T", 
     RowBox[{"1", ",", "0"}], "-"], 
    SuperscriptBox["Q", 
     RowBox[{"[", 
      RowBox[{"-", "2"}], "]"}]]], "-", 
   FractionBox[
    SubscriptBox["\[Delta]T", 
     RowBox[{"0", ",", "0"}]], "Q"]}], "\[Equal]", "0"}]], "Input",
 CellChangeTimes->{{3.553409410018724*^9, 3.553409442335806*^9}}],

Cell["\<\
Note that \[Alpha] just cancells out in this expression, therefore this \
statement is \[Alpha]-independent.\
\>", "Text",
 CellChangeTimes->{{3.55340954035235*^9, 3.553409548801*^9}, {
   3.553586196783411*^9, 3.553586224574114*^9}, 3.5690146667469797`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell["Computation of \[Alpha]", "Subsubsection",
 CellChangeTimes->{{3.552197431942743*^9, 3.552197448091651*^9}, {
  3.55358596895302*^9, 3.553585969535471*^9}, {3.5535862354563828`*^9, 
  3.5535862400259733`*^9}, {3.553629804370203*^9, 3.553629807573696*^9}}],

Cell[BoxData[
 RowBox[{"\[Alpha]", "\[Equal]", " ", 
  RowBox[{
   RowBox[{"-", 
    FractionBox[
     SuperscriptBox[
      RowBox[{"(", 
       SuperscriptBox[
        StyleBox["U",
         FontColor->RGBColor[0, 0.6, 0]], "+"], ")"}], "2"], 
     RowBox[{"2", 
      SubscriptBox["v", "0"], "Q", " ", 
      SuperscriptBox["Q", 
       RowBox[{"[", "2", "]"}]]}]]}], 
   RowBox[{"(", 
    RowBox[{
     RowBox[{
      SuperscriptBox[
       RowBox[{"(", 
        SubsuperscriptBox[
         StyleBox["q",
          FontColor->RGBColor[0, 0, 0.8]], "2", "+"], ")"}], "2"], 
      SubscriptBox[
       OverscriptBox[
        StyleBox["q",
         FontColor->RGBColor[0, 0, 0.8]], 
        StyleBox["_",
         FontColor->RGBColor[0, 0, 0.8]]], 
       RowBox[{"1", ",", "3"}]]}], "+", 
     RowBox[{"2", 
      RowBox[{"(", 
       SubsuperscriptBox[
        StyleBox["q",
         FontColor->RGBColor[0, 0, 0.8]], "2", "+"], ")"}], 
      SubscriptBox[
       OverscriptBox[
        StyleBox["q",
         FontColor->RGBColor[0, 0, 0.8]], 
        StyleBox["_",
         FontColor->RGBColor[0, 0, 0.8]]], 
       RowBox[{"1", ",", "4"}]]}], "+", " ", 
     SubscriptBox[
      OverscriptBox[
       StyleBox["q",
        FontColor->RGBColor[0, 0, 0.8]], 
       StyleBox["_",
        FontColor->RGBColor[0, 0, 0.8]]], 
      RowBox[{"2", ",", "4"}]]}], ")"}]}]}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{"order", "=", "4"}], ";"}]], "Input",
 CellChangeTimes->{{3.553629894952993*^9, 3.553629897261469*^9}, {
  3.5536302923505993`*^9, 3.55363029265383*^9}, {3.553630753506851*^9, 
  3.553630754706612*^9}, {3.5536947620556793`*^9, 3.5536947644595423`*^9}, {
  3.5537002551919613`*^9, 3.553700255320423*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"mv0sub", "=", 
   RowBox[{"{", 
    RowBox[{
     FractionBox["1", 
      SubscriptBox["v", "0"]], "\[RuleDelayed]", 
     RowBox[{"Normal", "[", 
      RowBox[{"Series", "[", 
       RowBox[{
        RowBox[{
         FractionBox["1", 
          SubscriptBox["v", "0"]], "/.", 
         RowBox[{"leadweak", "[", "order", "]"}]}], ",", 
        RowBox[{"{", 
         RowBox[{"g", ",", "0", ",", 
          RowBox[{
           RowBox[{"2", " ", "order"}], "-", "2"}]}], "}"}]}], "]"}], "]"}]}],
     "}"}]}], ";"}]], "Input",
 CellChangeTimes->{3.55363033094415*^9}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"(", 
    RowBox[{"precomp3", "=", 
     RowBox[{"Take", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"Series", "[", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{"Collect", "[", 
             RowBox[{
              RowBox[{
               RowBox[{"(", 
                RowBox[{
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{
                    SuperscriptBox[
                    RowBox[{"(", 
                    SubsuperscriptBox[
                    StyleBox["q",
                    FontColor->RGBColor[0, 0, 0.8]], "2", "+"], ")"}], "2"], 
                    SubscriptBox[
                    OverscriptBox[
                    StyleBox["q",
                    FontColor->RGBColor[0, 0, 0.8]], 
                    StyleBox["_",
                    FontColor->RGBColor[0, 0, 0.8]]], 
                    RowBox[{"1", ",", "3"}]]}], "+", 
                   RowBox[{"2", 
                    RowBox[{"(", 
                    SubsuperscriptBox[
                    StyleBox["q",
                    FontColor->RGBColor[0, 0, 0.8]], "2", "+"], ")"}], 
                    SubscriptBox[
                    OverscriptBox[
                    StyleBox["q",
                    FontColor->RGBColor[0, 0, 0.8]], 
                    StyleBox["_",
                    FontColor->RGBColor[0, 0, 0.8]]], 
                    RowBox[{"1", ",", "4"}]]}], "+", " ", 
                   SubscriptBox[
                    OverscriptBox[
                    StyleBox["q",
                    FontColor->RGBColor[0, 0, 0.8]], 
                    StyleBox["_",
                    FontColor->RGBColor[0, 0, 0.8]]], 
                    RowBox[{"2", ",", "4"}]]}], ")"}], "/.", 
                 RowBox[{"leadweak", "[", "order", "]"}]}], ")"}], 
               RowBox[{"(", 
                RowBox[{
                 FractionBox["1", 
                  RowBox[{"Q", " "}]], "/.", "mQsub"}], ")"}]}], ",", "g"}], 
             "]"}], "/.", 
            RowBox[{
             SuperscriptBox["g", 
              RowBox[{"a_", "/;", 
               RowBox[{"a", ">", 
                RowBox[{
                 RowBox[{"2", " ", "order"}], "+", "2"}]}]}]], "\[Rule]", 
             "0"}]}], ")"}], ",", 
          RowBox[{"{", 
           RowBox[{"g", ",", "0", ",", 
            RowBox[{
             RowBox[{"2", " ", "order"}], "+", "2"}]}], "}"}]}], "]"}], "[", 
        RowBox[{"[", "3", "]"}], "]"}], ",", 
       RowBox[{"{", 
        RowBox[{"1", ",", 
         RowBox[{"-", "1"}], ",", "2"}], "}"}]}], "]"}]}], ")"}], "//", 
   "Short"}], "//", "Timing"}]], "Input",
 CellChangeTimes->{{3.553596791204527*^9, 3.553596850479574*^9}, {
  3.553596891355885*^9, 3.553596893830748*^9}, {3.553596941479638*^9, 
  3.553597040399729*^9}, {3.5535991474863873`*^9, 3.553599151965609*^9}, {
  3.5535992689586697`*^9, 3.553599272884557*^9}, {3.553629995858026*^9, 
  3.553630073472494*^9}, {3.553630131427346*^9, 3.553630180818318*^9}, {
  3.553630306231454*^9, 3.553630337715312*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"1.0403689999998278`", ",", 
   TagBox[
    RowBox[{"{", 
     RowBox[{
      FractionBox[
       RowBox[{
        RowBox[{"\[LeftSkeleton]", "24", "\[RightSkeleton]"}], "+", 
        RowBox[{"16", " ", 
         SuperscriptBox["u", "2"], " ", 
         StyleBox["Q0",
          FontColor->RGBColor[{
             Rational[1, 2], 
             Rational[1, 2], 0}]], " ", 
         SubsuperscriptBox[
          RowBox[{"\[LeftSkeleton]", "1", "\[RightSkeleton]"}], "4", "-"]}]}], 
       RowBox[{"2", " ", 
        SuperscriptBox[
         RowBox[{"(", 
          RowBox[{"\[LeftSkeleton]", "1", "\[RightSkeleton]"}], ")"}], "2"], 
        " ", 
        StyleBox["Q0",
         FontColor->RGBColor[{
            Rational[1, 2], 
            Rational[1, 2], 0}]]}]], ",", 
      FractionBox[
       RowBox[{"\[LeftSkeleton]", "1", "\[RightSkeleton]"}], 
       RowBox[{"\[LeftSkeleton]", "1", "\[RightSkeleton]"}]], ",", 
      RowBox[{"\[LeftSkeleton]", "1", "\[RightSkeleton]"}], ",", 
      RowBox[{
       RowBox[{"\[LeftSkeleton]", "106", "\[RightSkeleton]"}], "+", 
       FractionBox[
        RowBox[{"\[LeftSkeleton]", "1", "\[RightSkeleton]"}], 
        StyleBox[
         RowBox[{"\[LeftSkeleton]", "2", "\[RightSkeleton]"}],
         FontColor->RGBColor[{
            Rational[1, 2], 
            Rational[1, 2], 0}]]]}]}], "}"}],
    Short]}], "}"}]], "Output",
 CellChangeTimes->{{3.55359684551265*^9, 3.553596854305287*^9}, {
   3.5535968945959997`*^9, 3.553596930293436*^9}, {3.553596960438664*^9, 
   3.553597005031842*^9}, 3.553597042089757*^9, {3.553599149143708*^9, 
   3.5535991530844393`*^9}, 3.5536022198694353`*^9, 3.553630075004957*^9, 
   3.5536301358476057`*^9, 3.553630182803741*^9, 3.553630340896386*^9, 
   3.553630756903879*^9, 3.5536360028932467`*^9, 3.553694382934642*^9, 
   3.5536947698756723`*^9, 3.5537002593080873`*^9, 3.5537086544341784`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"(", 
    RowBox[{"precomp32", "=", 
     RowBox[{"RemoveQ0poles", "/@", "precomp3"}]}], ")"}], "//", "Short"}], "//",
   "Timing"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Do", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"precomp32", "[", 
      RowBox[{"[", "k", "]"}], "]"}], "=", 
     RowBox[{
      RowBox[{"precomp32", "[", 
       RowBox[{"[", "k", "]"}], "]"}], "/.", 
      RowBox[{
       SuperscriptBox["Q0", 
        RowBox[{"a_", "/;", 
         RowBox[{"a", ">", 
          RowBox[{"(", 
           RowBox[{"order", "-", "k"}], ")"}]}]}]], "\[Rule]", "0"}]}]}], ",", 
    RowBox[{"{", 
     RowBox[{"k", ",", 
      RowBox[{"order", "-", "1"}]}], "}"}]}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"precomp32", "[", 
    RowBox[{"[", 
     RowBox[{"-", "1"}], "]"}], "]"}], "=", 
   RowBox[{
    RowBox[{"precomp32", "[", 
     RowBox[{"[", 
      RowBox[{"-", "1"}], "]"}], "]"}], "/.", 
    RowBox[{"Q0", "\[Rule]", "0"}]}]}], ";"}]}], "Input",
 CellChangeTimes->{{3.553597871158999*^9, 3.5535979157737627`*^9}, {
  3.553598003306875*^9, 3.5535980034346943`*^9}, {3.553598620675181*^9, 
  3.5535986252986507`*^9}, {3.5535987433909388`*^9, 3.5535987561018257`*^9}, {
  3.553599095324308*^9, 3.553599107175344*^9}, {3.553599291201531*^9, 
  3.553599326120508*^9}, {3.55359940572362*^9, 3.5535994109166937`*^9}, {
  3.553600036221346*^9, 3.553600219726565*^9}, {3.553630187927882*^9, 
  3.553630214470264*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{
   RowBox[{"\<\"Check:    \"\>", "\[InvisibleSpace]", "0.`"}], 
   "\[VeryThinSpace]", "+", 
   RowBox[{"0.`", " ", "\[ImaginaryI]"}]}],
  SequenceForm["Check:    ", 
   Complex[0., 0.]],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.5535993417967463`*^9, 3.553599413277272*^9, {3.553600130198668*^9, 
   3.5536001727452707`*^9}, 3.55360022067342*^9, 3.553602221291535*^9, {
   3.553630199544053*^9, 3.553630217497285*^9}, 3.553630343993145*^9, 
   3.553630758156035*^9, 3.55363600373315*^9, {3.553694369666741*^9, 
   3.5536943840795097`*^9}, 3.5536947716758127`*^9, 3.553700227947481*^9, 
   3.553700261717187*^9, 3.553708655794677*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
   RowBox[{"\<\"Check:    \"\>", "\[InvisibleSpace]", "0.`"}], 
   "\[VeryThinSpace]", "+", 
   RowBox[{"0.`", " ", "\[ImaginaryI]"}]}],
  SequenceForm["Check:    ", 
   Complex[0., 0.]],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.5535993417967463`*^9, 3.553599413277272*^9, {3.553600130198668*^9, 
   3.5536001727452707`*^9}, 3.55360022067342*^9, 3.553602221291535*^9, {
   3.553630199544053*^9, 3.553630217497285*^9}, 3.553630343993145*^9, 
   3.553630758156035*^9, 3.55363600373315*^9, {3.553694369666741*^9, 
   3.5536943840795097`*^9}, 3.5536947716758127`*^9, 3.553700227947481*^9, 
   3.553700261717187*^9, 3.553708655827401*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
   RowBox[{"\<\"Check:    \"\>", "\[InvisibleSpace]", "0.`"}], 
   "\[VeryThinSpace]", "+", 
   RowBox[{"0.`", " ", "\[ImaginaryI]"}]}],
  SequenceForm["Check:    ", 
   Complex[0., 0.]],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.5535993417967463`*^9, 3.553599413277272*^9, {3.553600130198668*^9, 
   3.5536001727452707`*^9}, 3.55360022067342*^9, 3.553602221291535*^9, {
   3.553630199544053*^9, 3.553630217497285*^9}, 3.553630343993145*^9, 
   3.553630758156035*^9, 3.55363600373315*^9, {3.553694369666741*^9, 
   3.5536943840795097`*^9}, 3.5536947716758127`*^9, 3.553700227947481*^9, 
   3.553700261717187*^9, 3.553708656043738*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
   RowBox[{"\<\"Check:    \"\>", "\[InvisibleSpace]", "0.`"}], 
   "\[VeryThinSpace]", "+", 
   RowBox[{"0.`", " ", "\[ImaginaryI]"}]}],
  SequenceForm["Check:    ", 
   Complex[0., 0.]],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.5535993417967463`*^9, 3.553599413277272*^9, {3.553600130198668*^9, 
   3.5536001727452707`*^9}, 3.55360022067342*^9, 3.553602221291535*^9, {
   3.553630199544053*^9, 3.553630217497285*^9}, 3.553630343993145*^9, 
   3.553630758156035*^9, 3.55363600373315*^9, {3.553694369666741*^9, 
   3.5536943840795097`*^9}, 3.5536947716758127`*^9, 3.553700227947481*^9, 
   3.553700261717187*^9, 3.553708665865967*^9}]
}, Open  ]],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"7.111085000000003`", ",", 
   TagBox[
    RowBox[{"\[LeftSkeleton]", "1", "\[RightSkeleton]"}],
    Short]}], "}"}]], "Output",
 CellChangeTimes->{{3.553600152017918*^9, 3.553600178081626*^9}, 
   3.553600226244978*^9, 3.553602226548243*^9, {3.553630199622485*^9, 
   3.55363021750469*^9}, 3.5536303536393967`*^9, 3.553630758240418*^9, 
   3.553636003740963*^9, {3.553694369674789*^9, 3.553694384264908*^9}, 
   3.5536947722473173`*^9, 3.553700228235886*^9, 3.553700270741418*^9, 
   3.553708666326725*^9}]
}, Open  ]],

Cell[TextData[{
 "After we reduced complexity with Q0, we proceed with weak coupling \
expansion  at ",
 Cell[BoxData[
  FormBox[
   RowBox[{"u", "=", 
    SubscriptBox["v", "0"]}], TraditionalForm]],
  FormatType->"TraditionalForm"]
}], "Text",
 CellChangeTimes->{{3.553602289236228*^9, 3.553602335610817*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"ClearAll", "[", 
   RowBox[{"\[Delta]uexpand", ",", "mrule"}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"mrule", "[", 
    RowBox[{"maction_", ",", "ee_"}], "]"}], ":=", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"xxx", ":", "#"}], ")"}], ":>", 
      RowBox[{"Normal", "@", 
       RowBox[{"Series", "[", 
        RowBox[{
         RowBox[{"maction", "[", "xxx", "]"}], ",", 
         RowBox[{"{", 
          RowBox[{"\[Delta]u", ",", "0", ",", "ee"}], "}"}]}], "]"}]}]}], 
     ")"}], "&"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"\[Delta]uexpand", "[", 
   RowBox[{
   "inp_List", ",", "mlist_", ",", "rlist_", ",", "maction_", ",", 
    "collectlist_"}], "]"}], ":=", "\[IndentingNewLine]", 
  RowBox[{"MapThread", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"Collect", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"Collect", "[", 
         RowBox[{"#1", ",", "mlist"}], "]"}], "/.", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"mrule", "[", 
           RowBox[{"maction", ",", 
            RowBox[{"order", "-", "#2"}]}], "]"}], "/@", "rlist"}], ")"}]}], 
       ",", "collectlist", ",", "FullSimplify"}], "]"}], "&"}], ",", 
    RowBox[{"{", 
     RowBox[{"inp", ",", 
      RowBox[{"Range", "[", "order", "]"}]}], "}"}]}], 
   "]"}]}], "\[IndentingNewLine]"}], "Input",
 CellChangeTimes->{{3.553632872534172*^9, 3.553632946807308*^9}, {
   3.55363550759615*^9, 3.5536355650182247`*^9}, {3.55363563167117*^9, 
   3.553635690073174*^9}, {3.5536357212029963`*^9, 3.553635764456521*^9}, {
   3.553635835495544*^9, 3.5536358357591248`*^9}, {3.5536358740223303`*^9, 
   3.553635988899088*^9}, {3.553636071151703*^9, 3.5536360833356123`*^9}, {
   3.553693637077136*^9, 3.553693884028782*^9}, {3.553693966448573*^9, 
   3.553693975767458*^9}, {3.553694016334031*^9, 3.553694017382753*^9}, 
   3.553701454233025*^9}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Dynamic", "[", "kkkk", "]"}]], "Input",
 CellChangeTimes->{{3.553700279797072*^9, 3.5537002841187887`*^9}}],

Cell[BoxData[
 DynamicBox[ToBoxes[$CellContext`kkkk, StandardForm],
  ImageSizeCache->{58., {0., 16.}}]], "Output",
 CellChangeTimes->{3.553700285531043*^9}]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"kkkk", "=", "0"}], ";"}]], "Input",
 CellChangeTimes->{{3.5537002891653137`*^9, 3.553700290773253*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"ntmp1", "=", 
   RowBox[{"\[Delta]uexpand", "[", 
    RowBox[{"precomp32", ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{
        RowBox[{"2", "u"}], "+", "\[ImaginaryI]"}], ",", 
       RowBox[{"u", "+", 
        FractionBox["\[ImaginaryI]", "2"]}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       SuperscriptBox[
        RowBox[{"(", 
         RowBox[{
          RowBox[{"2", "u"}], "+", "\[ImaginaryI]"}], ")"}], "_."], ",", 
       SuperscriptBox[
        RowBox[{"(", 
         RowBox[{"u", "+", 
          FractionBox["\[ImaginaryI]", "2"]}], ")"}], "_."]}], "}"}], ",", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"#", "/.", 
        RowBox[{"u", "\[Rule]", 
         RowBox[{"v00", "+", "\[Delta]u"}]}]}], ")"}], "&"}], ",", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"\[Delta]u", ",", "Q0", ",", "\[Eta]list", ",", "u", ",", 
        SubscriptBox["\[Zeta]", "__"]}], "}"}], "//", "Flatten"}]}], "]"}]}], 
  ";", 
  RowBox[{"kkkk", "++"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"ntmp2", "=", 
   RowBox[{"\[Delta]uexpand", "[", 
    RowBox[{"ntmp1", ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{
        SuperscriptBox["\[Delta]u", "_."], 
        SuperscriptBox["u", "_."]}], ",", "u"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{
        SuperscriptBox["\[Delta]u", "_."], 
        SuperscriptBox["u", "_."]}], ",", 
       SuperscriptBox["u", "_."]}], "}"}], ",", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"#", "/.", 
        RowBox[{"u", "\[Rule]", 
         RowBox[{"v00", "+", "\[Delta]u"}]}]}], ")"}], "&"}], ",", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"\[Delta]u", ",", "Q0", ",", "\[Eta]list", ",", 
        SubscriptBox["\[Zeta]", "__"]}], "}"}], "//", "Flatten"}]}], "]"}]}], 
  ";", 
  RowBox[{"kkkk", "++"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"ntmp3", "=", 
   RowBox[{"\[Delta]uexpand", "[", 
    RowBox[{"ntmp2", ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{
        SuperscriptBox["\[Delta]u", "_."], 
        SuperscriptBox["Q0", "_."]}], ",", "Q0"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{
        SuperscriptBox["\[Delta]u", "_."], 
        SuperscriptBox["Q0", "_."]}], ",", 
       SuperscriptBox["Q0", "_."]}], "}"}], ",", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"#", "/.", "subQ0"}], "/.", 
        RowBox[{"u", "\[Rule]", 
         RowBox[{"v00", "+", "\[Delta]u"}]}]}], ")"}], "&"}], ",", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"\[Delta]u", ",", "\[Eta]list", ",", 
        SubscriptBox["\[Zeta]", "__"]}], "}"}], "//", "Flatten"}]}], "]"}]}], 
  ";", 
  RowBox[{"kkkk", "++"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"ntmp4", "=", 
   RowBox[{"\[Delta]uexpand", "[", 
    RowBox[{"ntmp3", ",", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{
         SuperscriptBox["\[Delta]u", "_."], "\[Eta]list"}], ",", 
        "\[Eta]list"}], "}"}], "//", "Flatten"}], ",", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{
         SuperscriptBox["\[Delta]u", "_."], "\[Eta]list"}], ",", 
        "\[Eta]list"}], "}"}], "//", "Flatten"}], ",", 
     RowBox[{"Function", "[", 
      RowBox[{"eee", ",", 
       RowBox[{
        RowBox[{"Normal", "[", 
         RowBox[{"eee", "/.", 
          RowBox[{"TaylorOptions", "[", 
           RowBox[{
            RowBox[{"Order", "\[Rule]", "order"}], ",", 
            RowBox[{"Variable", "\[Rule]", "\[Delta]u"}]}], "]"}]}], "]"}], "/.",
         "sub\[Eta]\[Eta]0"}]}], "]"}], ",", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"\[Delta]u", ",", "\[Eta]0list", ",", 
        SubscriptBox["\[Zeta]", "__"]}], "}"}], "//", "Flatten"}]}], "]"}]}], 
  ";", 
  RowBox[{"kkkk", "++"}], ";"}]}], "Input",
 CellChangeTimes->{{3.553693564691695*^9, 3.553693596315262*^9}, {
  3.5536942435802803`*^9, 3.55369424576562*^9}, {3.5536943336726503`*^9, 
  3.5536943464193487`*^9}, {3.553694421536903*^9, 3.553694454392392*^9}, {
  3.553694486242118*^9, 3.55369450199828*^9}, {3.553694550128028*^9, 
  3.553694609568694*^9}, {3.5536946475108223`*^9, 3.553694725930792*^9}, {
  3.553700293037488*^9, 3.5537003067666407`*^9}, {3.55370113507642*^9, 
  3.553701179276478*^9}}],

Cell["\<\
Now reformulating in terms of g\
\>", "Text",
 CellChangeTimes->{{3.553700403051179*^9, 3.553700408431013*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(", 
   RowBox[{"ntmpf", "=", 
    RowBox[{"MapThread", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"Collect", "[", 
        RowBox[{
         RowBox[{"#1", "/.", 
          RowBox[{
           SuperscriptBox["\[Delta]u", "a_."], "\[RuleDelayed]", " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{
                SuperscriptBox[
                 RowBox[{"(", 
                  RowBox[{
                   SubscriptBox["v", "0"], "-", "v00"}], ")"}], "a"], "/.", 
                RowBox[{"leadweak", "[", 
                 RowBox[{"order", "-", "#2", "-", "a", "+", "2"}], "]"}]}], "//",
                "Expand"}], ")"}], "/.", 
             RowBox[{
              SuperscriptBox["g", 
               RowBox[{"b_", "/;", 
                RowBox[{"b", ">", 
                 RowBox[{"2", 
                  RowBox[{"(", 
                   RowBox[{"order", "-", "#2"}], ")"}]}]}]}]], "\[Rule]", 
              "0"}]}], ")"}]}]}], ",", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"g", ",", "\[Eta]0list", ",", 
            SubscriptBox["\[Zeta]", "__"]}], "}"}], "//", "Flatten"}], ",", 
         "Simplify"}], "]"}], "&"}], ",", 
      RowBox[{"{", 
       RowBox[{"ntmp4", ",", 
        RowBox[{"Range", "[", "order", "]"}]}], "}"}]}], "]"}]}], ")"}], "//", 
  RowBox[{
   RowBox[{"Short", "[", 
    RowBox[{"#", ",", "5"}], "]"}], "&"}]}]], "Input",
 CellChangeTimes->{{3.553700430172262*^9, 3.55370048180548*^9}, {
   3.553700537658804*^9, 3.5537005378850203`*^9}, {3.553700617431587*^9, 
   3.553700617486577*^9}, 3.5537007332662*^9, {3.553700763376189*^9, 
   3.5537008603429737`*^9}, {3.553701268221251*^9, 3.553701324045514*^9}, {
   3.553701355562593*^9, 3.5537014031933813`*^9}, {3.553702527529295*^9, 
   3.553702576638013*^9}}],

Cell[BoxData[
 TagBox[
  RowBox[{"{", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"-", "12"}], " ", "\[ImaginaryI]", " ", 
      SqrtBox["3"]}], "+", 
     RowBox[{"\[LeftSkeleton]", "6", "\[RightSkeleton]"}], "+", 
     RowBox[{
      SuperscriptBox["g", "6"], " ", 
      RowBox[{"(", 
       RowBox[{"828", "-", 
        RowBox[{"3828", " ", "\[ImaginaryI]", " ", 
         SqrtBox["3"]}], "+", 
        RowBox[{"252", " ", 
         RowBox[{"(", 
          RowBox[{"3", "-", 
           RowBox[{"\[ImaginaryI]", " ", 
            SqrtBox["3"]}]}], ")"}], " ", 
         SubscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "3"]}], "+", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           RowBox[{"96", " ", 
            RowBox[{"(", 
             RowBox[{"5", "-", 
              RowBox[{"12", " ", "\[ImaginaryI]", " ", 
               SqrtBox["3"]}]}], ")"}]}], "+", 
           RowBox[{"144", " ", 
            RowBox[{"(", 
             RowBox[{"3", "+", 
              RowBox[{"\[ImaginaryI]", " ", 
               SqrtBox["3"]}]}], ")"}], " ", 
            SubscriptBox[
             StyleBox["\[Zeta]",
              FontWeight->Bold,
              FontColor->GrayLevel[0.4]], "3"]}]}], ")"}], " ", 
         SubsuperscriptBox[
          OverscriptBox[
           StyleBox["\[Eta]0",
            FontWeight->Bold,
            FontColor->RGBColor[0, 0.5, 0]], 
           StyleBox["_",
            FontWeight->Bold,
            FontColor->RGBColor[0, 0.5, 0]]], "2", "-"]}], "+", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           RowBox[{
            RowBox[{"-", "144"}], " ", 
            RowBox[{"(", 
             RowBox[{"\[ImaginaryI]", "+", 
              SqrtBox["3"]}], ")"}]}], "-", 
           RowBox[{"48", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"3", " ", "\[ImaginaryI]"}], "+", 
              RowBox[{"7", " ", 
               SqrtBox["3"]}]}], ")"}], " ", 
            SubscriptBox[
             StyleBox["\[Zeta]",
              FontWeight->Bold,
              FontColor->GrayLevel[0.4]], "3"]}]}], ")"}], " ", 
         SubsuperscriptBox[
          OverscriptBox[
           StyleBox["\[Eta]0",
            FontWeight->Bold,
            FontColor->RGBColor[0, 0.5, 0]], 
           StyleBox["_",
            FontWeight->Bold,
            FontColor->RGBColor[0, 0.5, 0]]], "3", "-"]}], "+", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           RowBox[{
            RowBox[{"-", "96"}], " ", "\[ImaginaryI]", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{
               RowBox[{"-", "14"}], " ", "\[ImaginaryI]"}], "+", 
              SqrtBox["3"]}], ")"}]}], "+", 
           RowBox[{"288", " ", 
            SubscriptBox[
             StyleBox["\[Zeta]",
              FontWeight->Bold,
              FontColor->GrayLevel[0.4]], "3"]}]}], ")"}], " ", 
         SubsuperscriptBox[
          OverscriptBox[
           StyleBox["\[Eta]0",
            FontWeight->Bold,
            FontColor->RGBColor[0, 0.5, 0]], 
           StyleBox["_",
            FontWeight->Bold,
            FontColor->RGBColor[0, 0.5, 0]]], "4", "-"]}], "+", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           RowBox[{
            RowBox[{"-", 
             FractionBox["64", "3"]}], " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"36", " ", "\[ImaginaryI]"}], "+", 
              RowBox[{"29", " ", 
               SqrtBox["3"]}]}], ")"}]}], "-", 
           RowBox[{"64", " ", 
            SqrtBox["3"], " ", 
            SubscriptBox[
             StyleBox["\[Zeta]",
              FontWeight->Bold,
              FontColor->GrayLevel[0.4]], "3"]}]}], ")"}], " ", 
         SubsuperscriptBox[
          OverscriptBox[
           StyleBox["\[Eta]0",
            FontWeight->Bold,
            FontColor->RGBColor[0, 0.5, 0]], 
           StyleBox["_",
            FontWeight->Bold,
            FontColor->RGBColor[0, 0.5, 0]]], "5", "-"]}], "+", 
        RowBox[{"320", " ", 
         SubsuperscriptBox[
          OverscriptBox[
           StyleBox["\[Eta]0",
            FontWeight->Bold,
            FontColor->RGBColor[0, 0.5, 0]], 
           StyleBox["_",
            FontWeight->Bold,
            FontColor->RGBColor[0, 0.5, 0]]], "6", "-"]}], "-", 
        FractionBox[
         RowBox[{"2560", " ", 
          SubsuperscriptBox[
           OverscriptBox[
            StyleBox["\[Eta]0",
             FontWeight->Bold,
             FontColor->RGBColor[0, 0.5, 0]], 
            StyleBox["_",
             FontWeight->Bold,
             FontColor->RGBColor[0, 0.5, 0]]], "7", "-"]}], 
         RowBox[{"3", " ", 
          SqrtBox["3"]}]]}], ")"}]}]}], ",", 
    RowBox[{"\[LeftSkeleton]", "1", "\[RightSkeleton]"}], ",", 
    RowBox[{"\[LeftSkeleton]", "1", "\[RightSkeleton]"}], ",", 
    RowBox[{
     RowBox[{"-", "51381"}], "+", 
     RowBox[{"\[LeftSkeleton]", "1", "\[RightSkeleton]"}], "+", 
     RowBox[{"\[LeftSkeleton]", "77", "\[RightSkeleton]"}], "+", 
     RowBox[{"3456", " ", "\[ImaginaryI]", " ", 
      SubsuperscriptBox[
       OverscriptBox[
        RowBox[{"\[LeftSkeleton]", "1", "\[RightSkeleton]"}], 
        RowBox[{"\[LeftSkeleton]", "1", "\[RightSkeleton]"}]], 
       RowBox[{"4", ",", 
        RowBox[{"\[LeftSkeleton]", "3", "\[RightSkeleton]"}]}], "-"]}]}]}], 
   "}"}],
  Short[#, 5]& ]], "Output",
 CellChangeTimes->{{3.553701390129347*^9, 3.5537014039147*^9}, 
   3.553702577018255*^9, 3.553708696620368*^9}]
}, Open  ]],

Cell[BoxData[
 RowBox[{"\[Alpha]", "\[Equal]", " ", 
  RowBox[{
   RowBox[{"-", 
    FractionBox[
     SuperscriptBox[
      RowBox[{"(", 
       SuperscriptBox[
        StyleBox["U",
         FontColor->RGBColor[0, 0.6, 0]], "+"], ")"}], "2"], 
     RowBox[{"2", 
      SubscriptBox["v", "0"], "Q", " ", 
      SuperscriptBox["Q", 
       RowBox[{"[", "2", "]"}]]}]]}], 
   RowBox[{"(", 
    RowBox[{
     RowBox[{
      SuperscriptBox[
       RowBox[{"(", 
        SubsuperscriptBox[
         StyleBox["q",
          FontColor->RGBColor[0, 0, 0.8]], "2", "+"], ")"}], "2"], 
      SubscriptBox[
       OverscriptBox[
        StyleBox["q",
         FontColor->RGBColor[0, 0, 0.8]], 
        StyleBox["_",
         FontColor->RGBColor[0, 0, 0.8]]], 
       RowBox[{"1", ",", "3"}]]}], "+", 
     RowBox[{"2", 
      RowBox[{"(", 
       SubsuperscriptBox[
        StyleBox["q",
         FontColor->RGBColor[0, 0, 0.8]], "2", "+"], ")"}], 
      SubscriptBox[
       OverscriptBox[
        StyleBox["q",
         FontColor->RGBColor[0, 0, 0.8]], 
        StyleBox["_",
         FontColor->RGBColor[0, 0, 0.8]]], 
       RowBox[{"1", ",", "4"}]]}], "+", " ", 
     SubscriptBox[
      OverscriptBox[
       StyleBox["q",
        FontColor->RGBColor[0, 0, 0.8]], 
       StyleBox["_",
        FontColor->RGBColor[0, 0, 0.8]]], 
      RowBox[{"2", ",", "4"}]]}], ")"}]}]}]], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  FractionBox["1", 
   RowBox[{
    SubscriptBox["v", "0"], " "}]], "/.", "mv0sub"}]], "Input",
 CellChangeTimes->{{3.5537018598325787`*^9, 3.55370186272069*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"2", " ", 
   SqrtBox["3"]}], "-", 
  RowBox[{"16", " ", 
   SqrtBox["3"], " ", 
   SuperscriptBox["g", "2"]}], "+", 
  RowBox[{"168", " ", 
   SqrtBox["3"], " ", 
   SuperscriptBox["g", "4"]}], "+", 
  RowBox[{
   SuperscriptBox["g", "6"], " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{
      RowBox[{"-", "1888"}], " ", 
      SqrtBox["3"]}], "-", 
     RowBox[{"96", " ", 
      SqrtBox["3"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3"]}]}], ")"}]}]}]], "Output",
 CellChangeTimes->{{3.553701856004916*^9, 3.553701863163097*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"(", 
    RowBox[{"precomp4", "=", 
     RowBox[{"Take", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"Series", "[", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{"Collect", "[", 
             RowBox[{
              RowBox[{
               RowBox[{"-", 
                FractionBox["1", "2"]}], 
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox[
                  RowBox[{"(", 
                   SuperscriptBox[
                    StyleBox["U",
                    FontColor->RGBColor[0, 0.6, 0]], "+"], ")"}], "2"], "/.", 
                 
                 RowBox[{"leadweak", "[", "order", "]"}]}], ")"}], 
               RowBox[{"(", 
                RowBox[{
                 FractionBox["1", 
                  RowBox[{
                   SuperscriptBox["Q", 
                    RowBox[{"[", "2", "]"}]], " "}]], "/.", "mQsub"}], ")"}], 
               
               RowBox[{"(", 
                RowBox[{
                 FractionBox["1", 
                  RowBox[{
                   SubscriptBox["v", "0"], " "}]], "/.", "mv0sub"}], ")"}]}], 
              ",", "g"}], "]"}], "/.", 
            RowBox[{
             SuperscriptBox["g", 
              RowBox[{"a_", "/;", 
               RowBox[{"a", ">", 
                RowBox[{
                 RowBox[{"2", " ", "order"}], "+", "2"}]}]}]], "\[Rule]", 
             "0"}]}], ")"}], ",", 
          RowBox[{"{", 
           RowBox[{"g", ",", "0", ",", 
            RowBox[{
             RowBox[{"2", " ", "order"}], "+", "2"}]}], "}"}]}], "]"}], "[", 
        RowBox[{"[", "3", "]"}], "]"}], ",", 
       RowBox[{"{", 
        RowBox[{"1", ",", 
         RowBox[{"-", "1"}], ",", "2"}], "}"}]}], "]"}]}], ")"}], "//", 
   "Short"}], "//", "Timing"}]], "Input",
 CellChangeTimes->{{3.553596791204527*^9, 3.553596850479574*^9}, {
  3.553596891355885*^9, 3.553596893830748*^9}, {3.553596941479638*^9, 
  3.553597040399729*^9}, {3.5535991474863873`*^9, 3.553599151965609*^9}, {
  3.5535992689586697`*^9, 3.553599272884557*^9}, {3.553629995858026*^9, 
  3.553630073472494*^9}, {3.553630131427346*^9, 3.553630180818318*^9}, {
  3.553630306231454*^9, 3.553630337715312*^9}, {3.553701826586817*^9, 
  3.553701877699231*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"0.23214700000062294`", ",", 
   TagBox[
    RowBox[{"\[LeftSkeleton]", "1", "\[RightSkeleton]"}],
    Short]}], "}"}]], "Output",
 CellChangeTimes->{{3.55359684551265*^9, 3.553596854305287*^9}, {
   3.5535968945959997`*^9, 3.553596930293436*^9}, {3.553596960438664*^9, 
   3.553597005031842*^9}, 3.553597042089757*^9, {3.553599149143708*^9, 
   3.5535991530844393`*^9}, 3.5536022198694353`*^9, 3.553630075004957*^9, 
   3.5536301358476057`*^9, 3.553630182803741*^9, 3.553630340896386*^9, 
   3.553630756903879*^9, 3.5536360028932467`*^9, 3.553694382934642*^9, 
   3.5536947698756723`*^9, 3.5537002593080873`*^9, 3.553701906096678*^9, 
   3.553707669456695*^9, 3.553708591434267*^9, 3.55370870180033*^9, 
   3.553708777270903*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"(", 
    RowBox[{"precomp42", "=", 
     RowBox[{
      RowBox[{
       RowBox[{"ReduceQ0poles", "[", 
        RowBox[{"#", ",", "2"}], "]"}], "&"}], "/@", "precomp4"}]}], ")"}], "//",
    "Short"}], "//", "Timing"}]], "Input",
 CellChangeTimes->{{3.553597871158999*^9, 3.5535979157737627`*^9}, {
  3.553598003306875*^9, 3.5535980034346943`*^9}, {3.553598620675181*^9, 
  3.5535986252986507`*^9}, {3.5535987433909388`*^9, 3.5535987561018257`*^9}, {
  3.553599095324308*^9, 3.553599107175344*^9}, {3.553599291201531*^9, 
  3.553599326120508*^9}, {3.55359940572362*^9, 3.5535994109166937`*^9}, {
  3.553600036221346*^9, 3.553600219726565*^9}, {3.553630187927882*^9, 
  3.553630214470264*^9}, {3.5537019330934477`*^9, 3.5537019705242167`*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Check:    \"\>", "\[InvisibleSpace]", "0.`"}],
  SequenceForm["Check:    ", 0.],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.5535993417967463`*^9, 3.553599413277272*^9, {3.553600130198668*^9, 
   3.5536001727452707`*^9}, 3.55360022067342*^9, 3.553602221291535*^9, {
   3.553630199544053*^9, 3.553630217497285*^9}, 3.553630343993145*^9, 
   3.553630758156035*^9, 3.55363600373315*^9, {3.553694369666741*^9, 
   3.5536943840795097`*^9}, 3.5536947716758127`*^9, 3.553700227947481*^9, 
   3.553700261717187*^9, 3.553701971552738*^9, {3.553702284144987*^9, 
   3.553702313213121*^9}, 3.553707671620204*^9, 3.5537087073007927`*^9, 
   3.5537087980047626`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
   RowBox[{"\<\"Check:    \"\>", "\[InvisibleSpace]", "0.`"}], 
   "\[VeryThinSpace]", "+", 
   RowBox[{"0.`", " ", "\[ImaginaryI]"}]}],
  SequenceForm["Check:    ", 
   Complex[0., 0.]],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.5535993417967463`*^9, 3.553599413277272*^9, {3.553600130198668*^9, 
   3.5536001727452707`*^9}, 3.55360022067342*^9, 3.553602221291535*^9, {
   3.553630199544053*^9, 3.553630217497285*^9}, 3.553630343993145*^9, 
   3.553630758156035*^9, 3.55363600373315*^9, {3.553694369666741*^9, 
   3.5536943840795097`*^9}, 3.5536947716758127`*^9, 3.553700227947481*^9, 
   3.553700261717187*^9, 3.553701971552738*^9, {3.553702284144987*^9, 
   3.553702313213121*^9}, 3.553707671620204*^9, 3.5537087073007927`*^9, 
   3.553708798060342*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
   RowBox[{"\<\"Check:    \"\>", "\[InvisibleSpace]", "0.`"}], 
   "\[VeryThinSpace]", "+", 
   RowBox[{"0.`", " ", "\[ImaginaryI]"}]}],
  SequenceForm["Check:    ", 
   Complex[0., 0.]],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.5535993417967463`*^9, 3.553599413277272*^9, {3.553600130198668*^9, 
   3.5536001727452707`*^9}, 3.55360022067342*^9, 3.553602221291535*^9, {
   3.553630199544053*^9, 3.553630217497285*^9}, 3.553630343993145*^9, 
   3.553630758156035*^9, 3.55363600373315*^9, {3.553694369666741*^9, 
   3.5536943840795097`*^9}, 3.5536947716758127`*^9, 3.553700227947481*^9, 
   3.553700261717187*^9, 3.553701971552738*^9, {3.553702284144987*^9, 
   3.553702313213121*^9}, 3.553707671620204*^9, 3.5537087073007927`*^9, 
   3.5537087981361837`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
   RowBox[{"\<\"Check:    \"\>", "\[InvisibleSpace]", "0.`"}], 
   "\[VeryThinSpace]", "+", 
   RowBox[{"0.`", " ", "\[ImaginaryI]"}]}],
  SequenceForm["Check:    ", 
   Complex[0., 0.]],
  Editable->False]], "Print",
 CellChangeTimes->{
  3.5535993417967463`*^9, 3.553599413277272*^9, {3.553600130198668*^9, 
   3.5536001727452707`*^9}, 3.55360022067342*^9, 3.553602221291535*^9, {
   3.553630199544053*^9, 3.553630217497285*^9}, 3.553630343993145*^9, 
   3.553630758156035*^9, 3.55363600373315*^9, {3.553694369666741*^9, 
   3.5536943840795097`*^9}, 3.5536947716758127`*^9, 3.553700227947481*^9, 
   3.553700261717187*^9, 3.553701971552738*^9, {3.553702284144987*^9, 
   3.553702313213121*^9}, 3.553707671620204*^9, 3.5537087073007927`*^9, 
   3.553708798756665*^9}]
}, Open  ]],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"0.7811940000001414`", ",", 
   TagBox[
    RowBox[{"{", 
     RowBox[{
      FractionBox[
       RowBox[{"8", " ", 
        SqrtBox["3"]}], 
       RowBox[{
        SuperscriptBox[
         RowBox[{"(", 
          RowBox[{"\[ImaginaryI]", "+", 
           RowBox[{"2", " ", "u"}]}], ")"}], "2"], " ", 
        SuperscriptBox[
         StyleBox["Q0",
          FontColor->RGBColor[{
             Rational[1, 2], 
             Rational[1, 2], 0}]], 
         RowBox[{"[", "2", "]"}]]}]], ",", 
      RowBox[{
       FractionBox[
        RowBox[{"32", " ", 
         SqrtBox["3"]}], 
        SuperscriptBox[
         RowBox[{"\[LeftSkeleton]", "1", "\[RightSkeleton]"}], "4"]], "+", 
       RowBox[{"\[LeftSkeleton]", "4", "\[RightSkeleton]"}], "+", 
       FractionBox[
        RowBox[{"\[LeftSkeleton]", "1", "\[RightSkeleton]"}], 
        SuperscriptBox[
         RowBox[{"\[LeftSkeleton]", "1", "\[RightSkeleton]"}], 
         RowBox[{"\[LeftSkeleton]", "1", "\[RightSkeleton]"}]]]}], ",", 
      RowBox[{"\[LeftSkeleton]", "1", "\[RightSkeleton]"}], ",", 
      RowBox[{
       RowBox[{"\[LeftSkeleton]", "37", "\[RightSkeleton]"}], "+", 
       RowBox[{
        SuperscriptBox[
         StyleBox["Q0",
          FontColor->RGBColor[{
             Rational[1, 2], 
             Rational[1, 2], 0}]], 
         RowBox[{"[", "2", "]"}]], " ", 
        RowBox[{"(", 
         RowBox[{"\[LeftSkeleton]", "1", "\[RightSkeleton]"}], ")"}]}]}]}], 
     "}"}],
    Short]}], "}"}]], "Output",
 CellChangeTimes->{{3.553600152017918*^9, 3.553600178081626*^9}, 
   3.553600226244978*^9, 3.553602226548243*^9, {3.553630199622485*^9, 
   3.55363021750469*^9}, 3.5536303536393967`*^9, 3.553630758240418*^9, 
   3.553636003740963*^9, {3.553694369674789*^9, 3.553694384264908*^9}, 
   3.5536947722473173`*^9, 3.553700228235886*^9, 3.553700270741418*^9, 
   3.553701972962995*^9, {3.55370228498298*^9, 3.553702314085701*^9}, 
   3.55370767274063*^9, 3.553708708207077*^9, 3.5537087989131927`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Dynamic", "[", "kkkk", "]"}]], "Input",
 CellChangeTimes->{{3.553700279797072*^9, 3.5537002841187887`*^9}}],

Cell[BoxData[
 DynamicBox[ToBoxes[$CellContext`kkkk, StandardForm],
  ImageSizeCache->{58., {0., 16.}}]], "Output",
 CellChangeTimes->{3.553700285531043*^9}]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"kkkk", "=", "0"}], ";"}]], "Input",
 CellChangeTimes->{{3.5537002891653137`*^9, 3.553700290773253*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"btmp1", "=", 
   RowBox[{"\[Delta]uexpand", "[", 
    RowBox[{"precomp42", ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{
        RowBox[{"2", "u"}], "+", "\[ImaginaryI]"}], ",", 
       RowBox[{"u", "+", 
        FractionBox["\[ImaginaryI]", "2"]}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       SuperscriptBox[
        RowBox[{"(", 
         RowBox[{
          RowBox[{"2", "u"}], "+", "\[ImaginaryI]"}], ")"}], "_."], ",", 
       SuperscriptBox[
        RowBox[{"(", 
         RowBox[{"u", "+", 
          FractionBox["\[ImaginaryI]", "2"]}], ")"}], "_."]}], "}"}], ",", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"#", "/.", 
        RowBox[{"u", "\[Rule]", 
         RowBox[{"v00", "+", "\[Delta]u"}]}]}], ")"}], "&"}], ",", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"\[Delta]u", ",", 
        RowBox[{"Q0", "[", "2", "]"}], ",", "\[Eta]list", ",", "u", ",", 
        SubscriptBox["\[Zeta]", "__"]}], "}"}], "//", "Flatten"}]}], "]"}]}], 
  ";", 
  RowBox[{"kkkk", "++"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"btmp2", "=", 
   RowBox[{"\[Delta]uexpand", "[", 
    RowBox[{"btmp1", ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{
        SuperscriptBox["\[Delta]u", "_."], 
        SuperscriptBox["u", "_."]}], ",", "u"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{
        SuperscriptBox["\[Delta]u", "_."], 
        SuperscriptBox["u", "_."]}], ",", 
       SuperscriptBox["u", "_."]}], "}"}], ",", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"#", "/.", 
        RowBox[{"u", "\[Rule]", 
         RowBox[{"v00", "+", "\[Delta]u"}]}]}], ")"}], "&"}], ",", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"\[Delta]u", ",", 
        RowBox[{"Q0", "[", "2", "]"}], ",", "\[Eta]list", ",", 
        SubscriptBox["\[Zeta]", "__"]}], "}"}], "//", "Flatten"}]}], "]"}]}], 
  ";", 
  RowBox[{"kkkk", "++"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"btmp3", "=", 
   RowBox[{"\[Delta]uexpand", "[", 
    RowBox[{"btmp2", ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{
        SuperscriptBox["\[Delta]u", "_."], 
        SuperscriptBox[
         RowBox[{"Q0", "[", "2", "]"}], "_."]}], ",", 
       RowBox[{"Q0", "[", "2", "]"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{
        SuperscriptBox["\[Delta]u", "_."], 
        SuperscriptBox[
         RowBox[{"Q0", "[", "2", "]"}], "_."]}], ",", 
       SuperscriptBox[
        RowBox[{"Q0", "[", "2", "]"}], "_."]}], "}"}], ",", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"#", "/.", "subQ0"}], "/.", 
        RowBox[{"u", "\[Rule]", 
         RowBox[{"v00", "+", "\[Delta]u"}]}]}], ")"}], "&"}], ",", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"\[Delta]u", ",", "\[Eta]list", ",", 
        SubscriptBox["\[Zeta]", "__"]}], "}"}], "//", "Flatten"}]}], "]"}]}], 
  ";", 
  RowBox[{"kkkk", "++"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"btmp4", "=", 
   RowBox[{"\[Delta]uexpand", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"btmp3", "//.", 
       RowBox[{"shiftm\[Eta]", "[", "3", "]"}]}], "//.", 
      RowBox[{"shiftp\[Eta]b", "[", 
       RowBox[{"-", "3"}], "]"}]}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{
        SuperscriptBox["\[Delta]u", "_."], 
        SuperscriptBox[
         RowBox[{"(", 
          RowBox[{"u", "+", "_."}], ")"}], "_."]}], ",", 
       RowBox[{"(", 
        RowBox[{"u", "+", "_."}], ")"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{
        SuperscriptBox["\[Delta]u", "_."], 
        SuperscriptBox[
         RowBox[{"(", 
          RowBox[{"u", "+", "_."}], ")"}], "_."]}], ",", 
       SuperscriptBox[
        RowBox[{"(", 
         RowBox[{"u", "+", "_."}], ")"}], "_."]}], "}"}], ",", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"#", "/.", 
        RowBox[{"u", "\[Rule]", 
         RowBox[{"v00", "+", "\[Delta]u"}]}]}], ")"}], "&"}], ",", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"\[Delta]u", ",", "\[Eta]list", ",", 
        SubscriptBox["\[Zeta]", "__"]}], "}"}], "//", "Flatten"}]}], "]"}]}], 
  ";", 
  RowBox[{"kkkk", "++"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"btmp5", "=", 
   RowBox[{"\[Delta]uexpand", "[", 
    RowBox[{"btmp4", ",", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{
         SuperscriptBox["\[Delta]u", "_."], "\[Eta]list"}], ",", 
        "\[Eta]list"}], "}"}], "//", "Flatten"}], ",", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{
         SuperscriptBox["\[Delta]u", "_."], "\[Eta]list"}], ",", 
        "\[Eta]list"}], "}"}], "//", "Flatten"}], ",", 
     RowBox[{"Function", "[", 
      RowBox[{"eee", ",", 
       RowBox[{
        RowBox[{"Normal", "[", 
         RowBox[{"eee", "/.", 
          RowBox[{"TaylorOptions", "[", 
           RowBox[{
            RowBox[{"Order", "\[Rule]", "order"}], ",", 
            RowBox[{"Variable", "\[Rule]", "\[Delta]u"}]}], "]"}]}], "]"}], "/.",
         "sub\[Eta]\[Eta]0"}]}], "]"}], ",", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"\[Delta]u", ",", "\[Eta]0list", ",", 
        SubscriptBox["\[Zeta]", "__"]}], "}"}], "//", "Flatten"}]}], "]"}]}], 
  ";", 
  RowBox[{"kkkk", "++"}], ";"}]}], "Input",
 CellChangeTimes->{{3.553693564691695*^9, 3.553693596315262*^9}, {
  3.5536942435802803`*^9, 3.55369424576562*^9}, {3.5536943336726503`*^9, 
  3.5536943464193487`*^9}, {3.553694421536903*^9, 3.553694454392392*^9}, {
  3.553694486242118*^9, 3.55369450199828*^9}, {3.553694550128028*^9, 
  3.553694609568694*^9}, {3.5536946475108223`*^9, 3.553694725930792*^9}, {
  3.553700293037488*^9, 3.5537003067666407`*^9}, {3.55370113507642*^9, 
  3.553701179276478*^9}, {3.553702367557517*^9, 3.553702418321759*^9}, {
  3.553703798060885*^9, 3.553703885137371*^9}, {3.553708580504263*^9, 
  3.553708583386911*^9}, {3.553708877234662*^9, 3.553708880062706*^9}}],

Cell["\<\
Now reformulating in terms of g\
\>", "Text",
 CellChangeTimes->{{3.553700403051179*^9, 3.553700408431013*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(", 
   RowBox[{"btmpf", "=", 
    RowBox[{"MapThread", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"Collect", "[", 
        RowBox[{
         RowBox[{"#1", "/.", 
          RowBox[{
           SuperscriptBox["\[Delta]u", "a_."], "\[RuleDelayed]", " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{
                SuperscriptBox[
                 RowBox[{"(", 
                  RowBox[{
                   SubscriptBox["v", "0"], "-", "v00"}], ")"}], "a"], "/.", 
                RowBox[{"leadweak", "[", 
                 RowBox[{"order", "-", "#2", "-", "a", "+", "2"}], "]"}]}], "//",
                "Expand"}], ")"}], "/.", 
             RowBox[{
              SuperscriptBox["g", 
               RowBox[{"b_", "/;", 
                RowBox[{"b", ">", 
                 RowBox[{"2", 
                  RowBox[{"(", 
                   RowBox[{"order", "-", "#2"}], ")"}]}]}]}]], "\[Rule]", 
              "0"}]}], ")"}]}]}], ",", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"g", ",", "\[Eta]0list", ",", 
            SubscriptBox["\[Zeta]", "__"]}], "}"}], "//", "Flatten"}], ",", 
         "Simplify"}], "]"}], "&"}], ",", 
      RowBox[{"{", 
       RowBox[{"btmp5", ",", 
        RowBox[{"Range", "[", "order", "]"}]}], "}"}]}], "]"}]}], ")"}], "//", 
  RowBox[{
   RowBox[{"Short", "[", 
    RowBox[{"#", ",", "5"}], "]"}], "&"}]}]], "Input",
 CellChangeTimes->{{3.553700430172262*^9, 3.55370048180548*^9}, {
   3.553700537658804*^9, 3.5537005378850203`*^9}, {3.553700617431587*^9, 
   3.553700617486577*^9}, 3.5537007332662*^9, {3.553700763376189*^9, 
   3.5537008603429737`*^9}, {3.553701268221251*^9, 3.553701324045514*^9}, {
   3.553701355562593*^9, 3.5537014031933813`*^9}, {3.553702478726177*^9, 
   3.553702481439292*^9}, {3.553708848260264*^9, 3.55370885517443*^9}}],

Cell[BoxData[
 TagBox[
  RowBox[{"{", 
   RowBox[{
    RowBox[{
     RowBox[{"9", " ", "\[ImaginaryI]"}], "+", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         RowBox[{"-", "45"}], " ", "\[ImaginaryI]"}], "-", 
        RowBox[{"57", " ", 
         SqrtBox["3"]}]}], ")"}], " ", 
      SuperscriptBox["g", "2"]}], "+", 
     RowBox[{
      FractionBox["3", "2"], " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         RowBox[{"-", "281"}], " ", "\[ImaginaryI]"}], "+", 
        RowBox[{"339", " ", 
         SqrtBox["3"]}]}], ")"}], " ", 
      SuperscriptBox["g", "4"]}], "+", 
     RowBox[{
      SuperscriptBox["g", "6"], " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"7032", " ", "\[ImaginaryI]"}], "-", 
        RowBox[{"1916", " ", 
         SqrtBox["3"]}], "-", 
        RowBox[{"18", " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"15", " ", "\[ImaginaryI]"}], "+", 
           RowBox[{"19", " ", 
            SqrtBox["3"]}]}], ")"}], " ", 
         SubscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "3"]}]}], ")"}]}]}], ",", 
    RowBox[{"\[LeftSkeleton]", "2", "\[RightSkeleton]"}], ",", 
    RowBox[{
     RowBox[{
      FractionBox["1", "2"], " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"22197", " ", "\[ImaginaryI]"}], "+", 
        RowBox[{"17923", " ", 
         SqrtBox["3"]}]}], ")"}]}], "+", 
     RowBox[{"216", " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         RowBox[{"-", "60"}], " ", "\[ImaginaryI]"}], "+", 
        RowBox[{"19", " ", 
         SqrtBox["3"]}]}], ")"}], " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "1", "2"]}], "-", 
     RowBox[{"2592", " ", "\[ImaginaryI]", " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "1", "3"]}], "+", 
     RowBox[{
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "1"], " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"18", " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{
            RowBox[{"-", "589"}], " ", "\[ImaginaryI]"}], "+", 
           RowBox[{"841", " ", 
            SqrtBox["3"]}]}], ")"}]}], "-", 
        RowBox[{"3888", " ", "\[ImaginaryI]", " ", 
         SubscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "3"]}]}], ")"}]}], "+", 
     RowBox[{"\[LeftSkeleton]", "14", "\[RightSkeleton]"}], "+", 
     RowBox[{"7776", " ", 
      SubsuperscriptBox[
       StyleBox["\[Eta]0",
        FontWeight->Bold,
        FontColor->RGBColor[0, 0.5, 0]], 
       RowBox[{"2", ",", "1"}], "+"]}], "-", 
     RowBox[{"1296", " ", "\[ImaginaryI]", " ", 
      SubsuperscriptBox[
       StyleBox["\[Eta]0",
        FontWeight->Bold,
        FontColor->RGBColor[0, 0.5, 0]], 
       RowBox[{"3", ",", "1"}], "+"]}], "+", 
     RowBox[{"15552", " ", 
      SubsuperscriptBox[
       StyleBox["\[Eta]0",
        FontWeight->Bold,
        FontColor->RGBColor[0, 0.5, 0]], 
       RowBox[{"1", ",", "1", ",", "1"}], "+"]}]}]}], "}"}],
  Short[#, 5]& ]], "Output",
 CellChangeTimes->{{3.553701390129347*^9, 3.5537014039147*^9}, 
   3.553702485469921*^9, 3.55370772847755*^9, 3.553708621995604*^9, 
   3.553708726275997*^9, {3.5537088505431957`*^9, 3.5537088555011253`*^9}, 
   3.553708895156616*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"prefinal\[Alpha]", "=", 
   RowBox[{"Collect", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"Collect", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           SuperscriptBox["g", 
            RowBox[{"Range", "[", 
             RowBox[{"4", ",", 
              RowBox[{
               RowBox[{"2", "order"}], "+", "2"}], ",", "2"}], "]"}]], ".", 
           "ntmpf"}], ")"}], 
         RowBox[{"(", 
          RowBox[{
           SuperscriptBox["g", 
            RowBox[{"Range", "[", 
             RowBox[{"4", ",", 
              RowBox[{
               RowBox[{"2", "order"}], "+", "2"}], ",", "2"}], "]"}]], ".", 
           "btmpf"}], ")"}]}], ",", "g"}], "]"}], "/.", 
      RowBox[{
       SuperscriptBox["g", 
        RowBox[{"a_", "/;", 
         RowBox[{"a", ">", 
          RowBox[{
           RowBox[{"2", "order"}], "+", "6"}]}]}]], "\[Rule]", "0"}]}], ",", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"g", ",", "\[Eta]0list", ",", 
        SubscriptBox["\[Zeta]", "__"]}], "}"}], "//", "Flatten"}], ",", 
     "Simplify"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"(", 
   RowBox[{"final\[Alpha]", "=", 
    RowBox[{
     RowBox[{
      RowBox[{"Collect", "[", 
       RowBox[{"#", ",", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"\[Eta]0list", ",", 
           SubscriptBox["\[Zeta]", "__"]}], "}"}], "//", "Flatten"}], ",", 
        "FullSimplify"}], "]"}], "&"}], "/@", 
     RowBox[{"Series", "[", 
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{"prefinal\[Alpha]", "/.", "sub\[Eta]0\[Eta]"}], "//.", 
         "subtopowerbasis"}], "/.", "sub\[Eta]\[Eta]0"}], ",", 
       RowBox[{"{", 
        RowBox[{"g", ",", "0", ",", 
         RowBox[{
          RowBox[{"2", "order"}], "+", "6"}]}], "}"}]}], "]"}]}]}], ")"}], "//", 
  RowBox[{
   RowBox[{"Short", "[", 
    RowBox[{"#", ",", "5"}], "]"}], "&"}]}]}], "Input",
 CellChangeTimes->{{3.553702583882247*^9, 3.553702831291684*^9}, {
  3.55370286615235*^9, 3.5537028721561747`*^9}}],

Cell[BoxData[
 TagBox[
  InterpretationBox[
   RowBox[{
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{"108", " ", 
        SqrtBox["3"]}], "+", 
       RowBox[{"108", " ", "\[ImaginaryI]", " ", 
        SubsuperscriptBox[
         OverscriptBox[
          StyleBox["\[Eta]0",
           FontWeight->Bold,
           FontColor->RGBColor[0, 0.5, 0]], 
          StyleBox["_",
           FontWeight->Bold,
           FontColor->RGBColor[0, 0.5, 0]]], "2", "-"]}], "-", 
       RowBox[{"36", " ", "\[ImaginaryI]", " ", 
        SqrtBox["3"], " ", 
        SubsuperscriptBox[
         OverscriptBox[
          StyleBox["\[Eta]0",
           FontWeight->Bold,
           FontColor->RGBColor[0, 0.5, 0]], 
          StyleBox["_",
           FontWeight->Bold,
           FontColor->RGBColor[0, 0.5, 0]]], "3", "-"]}], "+", 
       RowBox[{"18", " ", "\[ImaginaryI]", " ", 
        SubsuperscriptBox[
         OverscriptBox[
          StyleBox["\[Eta]0",
           FontWeight->Bold,
           FontColor->RGBColor[0, 0.5, 0]], 
          StyleBox["_",
           FontWeight->Bold,
           FontColor->RGBColor[0, 0.5, 0]]], "4", "-"]}]}], ")"}], " ", 
     SuperscriptBox["g", "8"]}], "+", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{
        RowBox[{"-", "3456"}], " ", 
        SqrtBox["3"]}], "-", 
       RowBox[{"2592", " ", 
        SqrtBox["3"], " ", 
        SubscriptBox[
         StyleBox["\[Zeta]",
          FontWeight->Bold,
          FontColor->GrayLevel[0.4]], "1"]}], "+", 
       RowBox[{"1296", " ", "\[ImaginaryI]", " ", 
        SqrtBox["3"], " ", 
        SubsuperscriptBox[
         StyleBox["\[Eta]0",
          FontWeight->Bold,
          FontColor->RGBColor[0, 0.5, 0]], "1", "+"]}], "+", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          RowBox[{
           RowBox[{"-", "1296"}], " ", "\[ImaginaryI]"}], "-", 
          RowBox[{"2592", " ", "\[ImaginaryI]", " ", 
           SubscriptBox[
            StyleBox["\[Zeta]",
             FontWeight->Bold,
             FontColor->GrayLevel[0.4]], "1"]}]}], ")"}], " ", 
        SubsuperscriptBox[
         OverscriptBox[
          StyleBox["\[Eta]0",
           FontWeight->Bold,
           FontColor->RGBColor[0, 0.5, 0]], 
          StyleBox["_",
           FontWeight->Bold,
           FontColor->RGBColor[0, 0.5, 0]]], "2", "-"]}], "-", 
       RowBox[{"1296", " ", 
        SubsuperscriptBox[
         StyleBox["\[Eta]0",
          FontWeight->Bold,
          FontColor->RGBColor[0, 0.5, 0]], "1", "+"], " ", 
        SubsuperscriptBox[
         OverscriptBox[
          StyleBox["\[Eta]0",
           FontWeight->Bold,
           FontColor->RGBColor[0, 0.5, 0]], 
          StyleBox["_",
           FontWeight->Bold,
           FontColor->RGBColor[0, 0.5, 0]]], "2", "-"]}], "+", 
       RowBox[{"\[LeftSkeleton]", "6", "\[RightSkeleton]"}], "+", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          RowBox[{"-", "108"}], "-", 
          RowBox[{"204", " ", "\[ImaginaryI]", " ", 
           SqrtBox["3"]}]}], ")"}], " ", 
        SubsuperscriptBox[
         OverscriptBox[
          StyleBox["\[Eta]0",
           FontWeight->Bold,
           FontColor->RGBColor[0, 0.5, 0]], 
          StyleBox["_",
           FontWeight->Bold,
           FontColor->RGBColor[0, 0.5, 0]]], "5", "-"]}], "+", 
       RowBox[{"72", " ", "\[ImaginaryI]", " ", 
        SubsuperscriptBox[
         OverscriptBox[
          StyleBox["\[Eta]0",
           FontWeight->Bold,
           FontColor->RGBColor[0, 0.5, 0]], 
          StyleBox["_",
           FontWeight->Bold,
           FontColor->RGBColor[0, 0.5, 0]]], "6", "-"]}], "-", 
       RowBox[{"1296", " ", 
        SubsuperscriptBox[
         OverscriptBox[
          StyleBox["\[Eta]0",
           FontWeight->Bold,
           FontColor->RGBColor[0, 0.5, 0]], 
          StyleBox["_",
           FontWeight->Bold,
           FontColor->RGBColor[0, 0.5, 0]]], 
         RowBox[{"1", ",", "2"}], "-"]}], "+", 
       RowBox[{"432", " ", 
        SqrtBox["3"], " ", 
        SubsuperscriptBox[
         OverscriptBox[
          StyleBox["\[Eta]0",
           FontWeight->Bold,
           FontColor->RGBColor[0, 0.5, 0]], 
          StyleBox["_",
           FontWeight->Bold,
           FontColor->RGBColor[0, 0.5, 0]]], 
         RowBox[{"1", ",", "3"}], "-"]}], "-", 
       RowBox[{"216", " ", 
        SubsuperscriptBox[
         OverscriptBox[
          StyleBox["\[Eta]0",
           FontWeight->Bold,
           FontColor->RGBColor[0, 0.5, 0]], 
          StyleBox["_",
           FontWeight->Bold,
           FontColor->RGBColor[0, 0.5, 0]]], 
         RowBox[{"1", ",", "4"}], "-"]}]}], ")"}], " ", 
     SuperscriptBox["g", "10"]}], "+", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{"\[LeftSkeleton]", "1", "\[RightSkeleton]"}], ")"}], " ", 
     RowBox[{"\[LeftSkeleton]", "1", "\[RightSkeleton]"}]}], "+", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{"\[LeftSkeleton]", "149", "\[RightSkeleton]"}], "+", 
       RowBox[{"31104", " ", 
        SubsuperscriptBox[
         RowBox[{"\[LeftSkeleton]", "1", "\[RightSkeleton]"}], 
         RowBox[{"\[LeftSkeleton]", "1", "\[RightSkeleton]"}], 
         RowBox[{"\[LeftSkeleton]", "1", "\[RightSkeleton]"}]]}]}], ")"}], 
     " ", 
     SuperscriptBox["g", "14"]}], "+", 
    InterpretationBox[
     SuperscriptBox[
      RowBox[{"O", "[", "g", "]"}], "15"],
     SeriesData[$CellContext`g, 0, {}, 8, 15, 1],
     Editable->False]}],
   SeriesData[$CellContext`g, 0, {
    108 3^Rational[1, 2] + Complex[0, 108] $CellContext`\[Eta]0$b[2][-1] + 
     Complex[0, -36] 3^Rational[1, 2] $CellContext`\[Eta]0$b[3][-1] + 
     Complex[0, 18] $CellContext`\[Eta]0$b[4][-1], 
     0, (-3456) 3^Rational[1, 2] - 2592 
     3^Rational[1, 2] $CellContext`\[Zeta]$[1][0] + 
     Complex[0, 1296] 
      3^Rational[1, 2] $CellContext`\[Eta]0$[1][1] + (Complex[0, -1296] + 
       Complex[0, -2592] $CellContext`\[Zeta]$[1][0]) $CellContext`\[Eta]0$b[
       2][-1] - 1296 $CellContext`\[Eta]0$[1][1] $CellContext`\[Eta]0$b[
      2][-1] + (Complex[0, 72] (Complex[0, 9] + 3^Rational[1, 2]) + 
       Complex[0, 864] 
        3^Rational[1, 2] $CellContext`\[Zeta]$[1][0]) $CellContext`\[Eta]0$b[
       3][-1] + 432 
      3^Rational[1, 2] $CellContext`\[Eta]0$[1][1] $CellContext`\[Eta]0$b[
       3][-1] + (72 (Complex[0, 7] + 3 3^Rational[1, 2]) + 
       Complex[0, -432] $CellContext`\[Zeta]$[1][0]) $CellContext`\[Eta]0$b[
       4][-1] - 216 $CellContext`\[Eta]0$[1][1] $CellContext`\[Eta]0$b[
      4][-1] + $CellContext`\[Eta]0$b[1][-1] (
       Complex[0, -1296] 3^Rational[1, 2] + 
       1296 $CellContext`\[Eta]0$b[2][-1] - 432 
       3^Rational[1, 2] $CellContext`\[Eta]0$b[3][-1] + 
       216 $CellContext`\[Eta]0$b[4][-1]) + (-108 + 
       Complex[0, -204] 3^Rational[1, 2]) $CellContext`\[Eta]0$b[5][-1] + 
     Complex[0, 72] $CellContext`\[Eta]0$b[6][-1] - 
     1296 $CellContext`\[Eta]0$b[1, 2][-1] + 
     432 3^Rational[1, 2] $CellContext`\[Eta]0$b[1, 3][-1] - 
     216 $CellContext`\[Eta]0$b[1, 4][-1], 0, 76464 3^Rational[1, 2] + 
     93312 3^Rational[1, 2] $CellContext`\[Zeta]$[1][0] + 
     31104 3^Rational[1, 2] $CellContext`\[Zeta]$[1][0]^2 + 
     7776 3^Rational[1, 2] $CellContext`\[Zeta]$[3][0] + (
       Complex[0, -46656] 3^Rational[1, 2] + 
       Complex[0, -31104] 
        3^Rational[1, 2] $CellContext`\[Zeta]$[1][0]) $CellContext`\[Eta]0$[
       1][1] - 7776 3^Rational[1, 2] $CellContext`\[Eta]0$[1][1]^2 + 
     Complex[0, -5184] $CellContext`\[Eta]0$[2][1] + 
     Complex[0, 1296] 
      3^Rational[1, 2] $CellContext`\[Eta]0$[3][1] + (20736 + 
       31104 $CellContext`\[Zeta]$[1][0]) $CellContext`\[Eta]0$[1][
       1] $CellContext`\[Eta]0$b[2][-1] + 
     Complex[0, -7776] $CellContext`\[Eta]0$[1][1]^2 $CellContext`\[Eta]0$b[
       2][-1] + 
     1728 3^Rational[1, 2] $CellContext`\[Eta]0$[2][1] $CellContext`\[Eta]0$b[
       2][-1] - 1296 $CellContext`\[Eta]0$[3][1] $CellContext`\[Eta]0$b[
      2][-1] - 432 (Complex[0, 9] + 
      2 3^Rational[1, 2]) $CellContext`\[Eta]0$b[
       2][-1]^2 + ((-2592) (Complex[0, 3] + 3^Rational[1, 2]) - 10368 
       3^Rational[1, 2] $CellContext`\[Zeta]$[1][0]) $CellContext`\[Eta]0$[1][
       1] $CellContext`\[Eta]0$b[3][-1] + 
     Complex[0, 2592] 
      3^Rational[1, 2] $CellContext`\[Eta]0$[1][1]^2 $CellContext`\[Eta]0$b[
       3][-1] - 1728 $CellContext`\[Eta]0$[2][1] $CellContext`\[Eta]0$b[
      3][-1] + 432 
      3^Rational[1, 2] $CellContext`\[Eta]0$[3][1] $CellContext`\[Eta]0$b[
       3][-1] - 216 
     3^Rational[1, 2] $CellContext`\[Eta]0$b[
       3][-1]^2 + $CellContext`\[Eta]0$b[1][-1]^2 ((-7776) 3^Rational[1, 2] + 
       Complex[0, -7776] $CellContext`\[Eta]0$b[2][-1] + 
       Complex[0, 2592] 3^Rational[1, 2] $CellContext`\[Eta]0$b[3][-1] + 
       Complex[0, -1296] $CellContext`\[Eta]0$b[
         4][-1]) + $CellContext`\[Eta]0$[1][1] $CellContext`\[Eta]0$b[1][-1] (
       15552 3^Rational[1, 2] + 
       Complex[0, 15552] $CellContext`\[Eta]0$b[2][-1] + 
       Complex[0, -5184] 3^Rational[1, 2] $CellContext`\[Eta]0$b[3][-1] + 
       Complex[0, 2592] $CellContext`\[Eta]0$b[4][-1]) + ((-432) (
         Complex[0, 7] + 3 3^Rational[1, 2]) - 
       5184 (Complex[0, 2] + 3^Rational[1, 2]) $CellContext`\[Zeta]$[1][0] + 
       Complex[0, 5184] $CellContext`\[Zeta]$[1][0]^2 + 
       Complex[0, 1296] $CellContext`\[Zeta]$[3][0]) $CellContext`\[Eta]0$b[
       4][-1] + (Complex[0, 2592] (Complex[0, 2] + 3^Rational[1, 2]) + 
       5184 $CellContext`\[Zeta]$[1][0]) $CellContext`\[Eta]0$[1][
       1] $CellContext`\[Eta]0$b[4][-1] + 
     Complex[0, -1296] $CellContext`\[Eta]0$[1][1]^2 $CellContext`\[Eta]0$b[
       4][-1] + 288 
      3^Rational[1, 2] $CellContext`\[Eta]0$[2][1] $CellContext`\[Eta]0$b[
       4][-1] - 216 $CellContext`\[Eta]0$[3][1] $CellContext`\[Eta]0$b[
      4][-1] + $CellContext`\[Eta]0$b[3][-1] (
       144 (72 + Complex[0, -5] 3^Rational[1, 2]) + 
       5184 (3 + Complex[0, -1] 3^Rational[1, 2]) $CellContext`\[Zeta]$[1][0] + 
       Complex[0, -10368] 3^Rational[1, 2] $CellContext`\[Zeta]$[1][0]^2 + 
       Complex[0, -2592] 3^Rational[1, 2] $CellContext`\[Zeta]$[3][0] + 
       216 $CellContext`\[Eta]0$b[4][-1]) + $CellContext`\[Eta]0$b[2][-1] (
       Complex[0, 15552] + Complex[0, 41472] $CellContext`\[Zeta]$[1][0] + 
       Complex[0, 31104] $CellContext`\[Zeta]$[1][0]^2 + 
       Complex[0, 7776] $CellContext`\[Zeta]$[3][0] + 
       1728 $CellContext`\[Eta]0$b[3][-1] - 288 
       3^Rational[1, 2] $CellContext`\[Eta]0$b[4][-1]) + (-2808 + 
       Complex[0, 432] 3^Rational[1, 2] + 
       288 (9 + Complex[0, 17] 3^Rational[1, 2]) $CellContext`\[Zeta]$[1][
         0]) $CellContext`\[Eta]0$b[5][-1] + 
     144 (Complex[0, -9] + 17 3^Rational[1, 2]) $CellContext`\[Eta]0$[1][
       1] $CellContext`\[Eta]0$b[5][-1] + (
       24 (Complex[0, 115] + 57 3^Rational[1, 2]) + 
       Complex[0, -1728] $CellContext`\[Zeta]$[1][0]) $CellContext`\[Eta]0$b[
       6][-1] - 864 $CellContext`\[Eta]0$[1][1] $CellContext`\[Eta]0$b[
      6][-1] + (-540 + 
       Complex[0, -900] 3^Rational[1, 2]) $CellContext`\[Eta]0$b[7][-1] + 
     Complex[0, 252] $CellContext`\[Eta]0$b[8][-1] + (20736 + 
       31104 $CellContext`\[Zeta]$[1][0]) $CellContext`\[Eta]0$b[1, 2][-1] + 
     Complex[0, -15552] $CellContext`\[Eta]0$[1][1] $CellContext`\[Eta]0$b[
       1, 2][-1] + ((-2592) (Complex[0, 3] + 3^Rational[1, 2]) - 10368 
       3^Rational[1, 2] $CellContext`\[Zeta]$[1][0]) $CellContext`\[Eta]0$b[
       1, 3][-1] + 
     Complex[0, 5184] 
      3^Rational[1, 2] $CellContext`\[Eta]0$[1][1] $CellContext`\[Eta]0$b[
       1, 3][-1] + $CellContext`\[Eta]0$b[1][-1] (
       Complex[0, 46656] 3^Rational[1, 2] + 
       Complex[0, 31104] 
        3^Rational[1, 2] $CellContext`\[Zeta]$[1][0] + (-20736 - 
         31104 $CellContext`\[Zeta]$[1][0]) $CellContext`\[Eta]0$b[2][-1] + (
         2592 (Complex[0, 3] + 3^Rational[1, 2]) + 
         10368 3^Rational[1, 2] $CellContext`\[Zeta]$[1][
           0]) $CellContext`\[Eta]0$b[3][-1] + (
         2592 (2 + Complex[0, -1] 3^Rational[1, 2]) - 
         5184 $CellContext`\[Zeta]$[1][0]) $CellContext`\[Eta]0$b[4][-1] + 
       144 (Complex[0, 9] - 17 3^Rational[1, 2]) $CellContext`\[Eta]0$b[
         5][-1] + 864 $CellContext`\[Eta]0$b[6][-1] + 
       Complex[0, 15552] $CellContext`\[Eta]0$b[1, 2][-1] + 
       Complex[0, -5184] 3^Rational[1, 2] $CellContext`\[Eta]0$b[1, 3][-1] + 
       Complex[0, 2592] $CellContext`\[Eta]0$b[1, 4][-1]) + (
       Complex[0, 2592] (Complex[0, 2] + 3^Rational[1, 2]) + 
       5184 $CellContext`\[Zeta]$[1][0]) $CellContext`\[Eta]0$b[1, 4][-1] + 
     Complex[0, -2592] $CellContext`\[Eta]0$[1][1] $CellContext`\[Eta]0$b[
       1, 4][-1] + 
     144 (Complex[0, -9] + 17 3^Rational[1, 2]) $CellContext`\[Eta]0$b[
       1, 5][-1] - 864 $CellContext`\[Eta]0$b[1, 6][-1] + 
     432 (-1 + Complex[0, 6] 3^Rational[1, 2]) $CellContext`\[Eta]0$b[
       2, 3][-1] + 
     144 (Complex[0, -9] + 2 3^Rational[1, 2]) $CellContext`\[Eta]0$b[
       2, 4][-1] - 216 $CellContext`\[Eta]0$b[3, 4][-1] + 
     Complex[0, -15552] $CellContext`\[Eta]0$b[1, 1, 2][-1] + 
     Complex[0, 5184] 3^Rational[1, 2] $CellContext`\[Eta]0$b[1, 1, 3][-1] + 
     Complex[0, -2592] $CellContext`\[Eta]0$b[1, 1, 4][-1], 
     0, (-1435968) 3^Rational[1, 2] - 1244160 
     3^Rational[1, 2] $CellContext`\[Zeta]$[1][0]^2 - 248832 
     3^Rational[1, 2] $CellContext`\[Zeta]$[1][0]^3 - 300672 
     3^Rational[1, 2] $CellContext`\[Zeta]$[3][
      0] + $CellContext`\[Zeta]$[1][0] ((-2239488) 3^Rational[1, 2] - 186624 
       3^Rational[1, 2] $CellContext`\[Zeta]$[3][0]) - 51840 
     3^Rational[1, 2] $CellContext`\[Zeta]$[5][
      0] + (311040 3^Rational[1, 2] + 
       186624 3^Rational[1, 2] $CellContext`\[Zeta]$[1][
         0]) $CellContext`\[Eta]0$[1][1]^2 + 
     Complex[0, -31104] 
      3^Rational[1, 2] $CellContext`\[Eta]0$[1][1]^3 + (Complex[0, 199584] + 
       Complex[0, 124416] $CellContext`\[Zeta]$[1][0]) $CellContext`\[Eta]0$[
       2][1] + (Complex[0, -39744] 3^Rational[1, 2] + 
       Complex[0, -31104] 
        3^Rational[1, 2] $CellContext`\[Zeta]$[1][0]) $CellContext`\[Eta]0$[
       3][1] + $CellContext`\[Eta]0$[1][1] (
       Complex[0, 1119744] 3^Rational[1, 2] + 
       Complex[0, 1244160] 3^Rational[1, 2] $CellContext`\[Zeta]$[1][0] + 
       Complex[0, 373248] 3^Rational[1, 2] $CellContext`\[Zeta]$[1][0]^2 + 
       Complex[0, 93312] 3^Rational[1, 2] $CellContext`\[Zeta]$[3][0] + 
       62208 $CellContext`\[Eta]0$[2][1] - 15552 
       3^Rational[1, 2] $CellContext`\[Eta]0$[3][1]) + 
     Complex[0, -15552] $CellContext`\[Eta]0$[4][1] + 
     Complex[0, 2592] 
      3^Rational[1, 2] $CellContext`\[Eta]0$[5][1] + (Complex[0, 155520] + 
       Complex[0, 186624] $CellContext`\[Zeta]$[1][0]) $CellContext`\[Eta]0$[
        1][1]^2 $CellContext`\[Eta]0$b[2][-1] + 
     31104 $CellContext`\[Eta]0$[1][1]^3 $CellContext`\[Eta]0$b[
       2][-1] + ((-31968) 3^Rational[1, 2] - 41472 
       3^Rational[1, 2] $CellContext`\[Zeta]$[1][0]) $CellContext`\[Eta]0$[2][
       1] $CellContext`\[Eta]0$b[2][-1] + (13824 + 
       31104 $CellContext`\[Zeta]$[1][0]) $CellContext`\[Eta]0$[3][
       1] $CellContext`\[Eta]0$b[2][-1] + 
     5184 3^Rational[1, 2] $CellContext`\[Eta]0$[4][1] $CellContext`\[Eta]0$b[
       2][-1] - 2592 $CellContext`\[Eta]0$[5][1] $CellContext`\[Eta]0$b[
      2][-1] + (432 (Complex[0, 180] + 37 3^Rational[1, 2]) + 
       10368 (Complex[0, 9] + 2 3^Rational[1, 2]) $CellContext`\[Zeta]$[1][
         0]) $CellContext`\[Eta]0$b[2][-1]^2 + 
     5184 (9 + Complex[0, -2] 3^Rational[1, 2]) $CellContext`\[Eta]0$[1][
       1] $CellContext`\[Eta]0$b[2][-1]^2 + (
       5184 (9 + Complex[0, -5] 3^Rational[1, 2]) + 
       Complex[0, -62208] 
        3^Rational[1, 2] $CellContext`\[Zeta]$[1][0]) $CellContext`\[Eta]0$[
        1][1]^2 $CellContext`\[Eta]0$b[3][-1] - 10368 
     3^Rational[1, 2] $CellContext`\[Eta]0$[1][1]^3 $CellContext`\[Eta]0$b[
      3][-1] + (864 (17 + Complex[0, 12] 3^Rational[1, 2]) + 
       41472 $CellContext`\[Zeta]$[1][0]) $CellContext`\[Eta]0$[2][
       1] $CellContext`\[Eta]0$b[
       3][-1] + ((-288) (Complex[0, 27] + 3^Rational[1, 2]) - 10368 
       3^Rational[1, 2] $CellContext`\[Zeta]$[1][0]) $CellContext`\[Eta]0$[3][
       1] $CellContext`\[Eta]0$b[3][-1] - 
     5184 $CellContext`\[Eta]0$[4][1] $CellContext`\[Eta]0$b[3][-1] + 
     864 3^Rational[1, 2] $CellContext`\[Eta]0$[5][1] $CellContext`\[Eta]0$b[
       3][-1] + ((-720) (Complex[0, 9] + 7 3^Rational[1, 2]) + 
       5184 3^Rational[1, 2] $CellContext`\[Zeta]$[1][
         0]) $CellContext`\[Eta]0$b[3][-1]^2 + 
     Complex[0, -2592] 
      3^Rational[1, 2] $CellContext`\[Eta]0$[1][
       1] $CellContext`\[Eta]0$b[3][-1]^2 + $CellContext`\[Eta]0$[1][
        1]^2 $CellContext`\[Eta]0$b[1][-1] (
       Complex[0, 93312] 3^Rational[1, 2] - 
       93312 $CellContext`\[Eta]0$b[2][-1] + 
       31104 3^Rational[1, 2] $CellContext`\[Eta]0$b[3][-1] - 
       15552 $CellContext`\[Eta]0$b[4][-1]) + $CellContext`\[Eta]0$b[
        1][-1]^3 (Complex[0, 31104] 3^Rational[1, 2] - 
       31104 $CellContext`\[Eta]0$b[2][-1] + 
       10368 3^Rational[1, 2] $CellContext`\[Eta]0$b[3][-1] - 
       5184 $CellContext`\[Eta]0$b[4][-1]) + $CellContext`\[Eta]0$[1][
       1] $CellContext`\[Eta]0$b[3][-1] (
       3456 (Complex[0, 45] + 7 3^Rational[1, 2]) + 
       20736 (Complex[0, 9] + 5 3^Rational[1, 2]) $CellContext`\[Zeta]$[1][0] + 
       124416 3^Rational[1, 2] $CellContext`\[Zeta]$[1][0]^2 + 
       31104 3^Rational[1, 2] $CellContext`\[Zeta]$[3][0] + 
       Complex[0, -20736] $CellContext`\[Eta]0$[2][1] + 
       Complex[0, 5184] 3^Rational[1, 2] $CellContext`\[Eta]0$[3][1] + 
       Complex[0, 2592] $CellContext`\[Eta]0$b[
         4][-1]) + $CellContext`\[Eta]0$[3][1] $CellContext`\[Eta]0$b[1][-1] (
       15552 3^Rational[1, 2] + 
       Complex[0, 15552] $CellContext`\[Eta]0$b[2][-1] + 
       Complex[0, -5184] 3^Rational[1, 2] $CellContext`\[Eta]0$b[3][-1] + 
       Complex[0, 2592] $CellContext`\[Eta]0$b[4][-1]) + (
       720 (Complex[0, 23] + 6 3^Rational[1, 2]) + 
       20736 (Complex[0, 5] + 
         3 3^Rational[1, 2]) $CellContext`\[Zeta]$[1][0]^2 + 
       Complex[0, -41472] $CellContext`\[Zeta]$[1][
          0]^3 + $CellContext`\[Zeta]$[1][0] (
         5184 (Complex[0, 21] + 10 3^Rational[1, 2]) + 
         Complex[0, -31104] $CellContext`\[Zeta]$[3][0]) + 
       432 (Complex[0, 79] + 36 3^Rational[1, 2]) $CellContext`\[Zeta]$[3][0] + 
       Complex[0, -8640] $CellContext`\[Zeta]$[5][0]) $CellContext`\[Eta]0$b[
       4][-1] + ((-5184) (Complex[0, 5] + 3 3^Rational[1, 2]) + 
       Complex[0, 31104] $CellContext`\[Zeta]$[1][0]) $CellContext`\[Eta]0$[
        1][1]^2 $CellContext`\[Eta]0$b[4][-1] + 
     5184 $CellContext`\[Eta]0$[1][1]^3 $CellContext`\[Eta]0$b[4][-1] + (
       144 (Complex[0, -72] + 43 3^Rational[1, 2]) - 6912 
       3^Rational[1, 2] $CellContext`\[Zeta]$[1][0]) $CellContext`\[Eta]0$[2][
       1] $CellContext`\[Eta]0$b[4][-1] + $CellContext`\[Eta]0$[1][1] (
       2592 (21 + Complex[0, -10] 3^Rational[1, 2]) + 
       20736 (5 + Complex[0, -3] 3^Rational[1, 2]) $CellContext`\[Zeta]$[1][
         0] - 62208 $CellContext`\[Zeta]$[1][0]^2 - 
       15552 $CellContext`\[Zeta]$[3][0] + 
       Complex[0, 3456] 3^Rational[1, 2] $CellContext`\[Eta]0$[2][1] + 
       Complex[0, -2592] $CellContext`\[Eta]0$[3][1]) $CellContext`\[Eta]0$b[
       4][-1] + (288 (-22 + Complex[0, 9] 3^Rational[1, 2]) + 
       5184 $CellContext`\[Zeta]$[1][0]) $CellContext`\[Eta]0$[3][
       1] $CellContext`\[Eta]0$b[4][-1] + 
     864 3^Rational[1, 2] $CellContext`\[Eta]0$[4][1] $CellContext`\[Eta]0$b[
       4][-1] - 432 $CellContext`\[Eta]0$[5][1] $CellContext`\[Eta]0$b[4][-1] - 
     432 (Complex[0, 3] + 
      3^Rational[1, 2]) $CellContext`\[Eta]0$b[
       4][-1]^2 + $CellContext`\[Eta]0$[1][
       1] $CellContext`\[Eta]0$b[1][-1]^2 (
       Complex[0, -93312] 3^Rational[1, 2] + 
       93312 $CellContext`\[Eta]0$b[2][-1] - 31104 
       3^Rational[1, 2] $CellContext`\[Eta]0$b[3][-1] + 
       15552 $CellContext`\[Eta]0$b[4][-1]) + $CellContext`\[Eta]0$[1][
       1] $CellContext`\[Eta]0$b[2][-1] (-285120 - 
       622080 $CellContext`\[Zeta]$[1][0] - 
       373248 $CellContext`\[Zeta]$[1][0]^2 - 
       93312 $CellContext`\[Zeta]$[3][0] + 
       Complex[0, 20736] 3^Rational[1, 2] $CellContext`\[Eta]0$[2][1] + 
       Complex[0, -15552] $CellContext`\[Eta]0$[3][1] + 
       Complex[0, 20736] $CellContext`\[Eta]0$b[3][-1] + 
       Complex[0, -3456] 
        3^Rational[1, 2] $CellContext`\[Eta]0$b[
         4][-1]) + $CellContext`\[Eta]0$[2][1] $CellContext`\[Eta]0$b[
       1][-1] (-62208 + 
       Complex[0, -20736] 3^Rational[1, 2] $CellContext`\[Eta]0$b[2][-1] + 
       Complex[0, 20736] $CellContext`\[Eta]0$b[3][-1] + 
       Complex[0, -3456] 3^Rational[1, 2] $CellContext`\[Eta]0$b[4][-1]) + (
       6048 (2 + Complex[0, 1] 3^Rational[1, 2]) + 
       576 (99 + Complex[0, -52] 3^Rational[1, 2]) $CellContext`\[Zeta]$[1][
         0] + 3456 (-9 + 
         Complex[0, -17] 3^Rational[1, 2]) $CellContext`\[Zeta]$[1][0]^2 + 
       288 (-27 + Complex[0, -56] 3^Rational[1, 2]) $CellContext`\[Zeta]$[3][
         0]) $CellContext`\[Eta]0$b[
       5][-1] + ((-288) (Complex[0, 99] + 52 3^Rational[1, 2]) - 
       3456 (Complex[0, -9] + 17 3^Rational[1, 2]) $CellContext`\[Zeta]$[1][
        0]) $CellContext`\[Eta]0$[1][1] $CellContext`\[Eta]0$b[5][-1] + 
     864 (9 + Complex[0, 17] 3^Rational[1, 2]) $CellContext`\[Eta]0$[1][
        1]^2 $CellContext`\[Eta]0$b[5][-1] + 
     576 (-17 + Complex[0, 3] 3^Rational[1, 2]) $CellContext`\[Eta]0$[2][
       1] $CellContext`\[Eta]0$b[5][-1] + 
     144 (Complex[0, -9] + 17 3^Rational[1, 2]) $CellContext`\[Eta]0$[3][
       1] $CellContext`\[Eta]0$b[5][-1] + (
       24 (Complex[0, -953] + 33 3^Rational[1, 2]) - 
       576 (Complex[0, 103] + 57 3^Rational[1, 2]) $CellContext`\[Zeta]$[1][
        0] + Complex[0, 20736] $CellContext`\[Zeta]$[1][0]^2 + 
       Complex[0, 5616] $CellContext`\[Zeta]$[3][0]) $CellContext`\[Eta]0$b[
       6][-1] + (288 (-103 + Complex[0, 57] 3^Rational[1, 2]) + 
       20736 $CellContext`\[Zeta]$[1][0]) $CellContext`\[Eta]0$[1][
       1] $CellContext`\[Eta]0$b[6][-1] + 
     Complex[0, -5184] $CellContext`\[Eta]0$[1][1]^2 $CellContext`\[Eta]0$b[
       6][-1] + 1152 
      3^Rational[1, 2] $CellContext`\[Eta]0$[2][1] $CellContext`\[Eta]0$b[
       6][-1] - 864 $CellContext`\[Eta]0$[3][1] $CellContext`\[Eta]0$b[
      6][-1] + (-20304 + Complex[0, -400] 3^Rational[1, 2] + 
       4320 (3 + Complex[0, 5] 3^Rational[1, 2]) $CellContext`\[Zeta]$[1][
         0]) $CellContext`\[Eta]0$b[7][-1] + 
     2160 (Complex[0, -3] + 5 3^Rational[1, 2]) $CellContext`\[Eta]0$[1][
       1] $CellContext`\[Eta]0$b[7][-1] + (
       144 (Complex[0, 111] + 47 3^Rational[1, 2]) + 
       Complex[0, -6048] $CellContext`\[Zeta]$[1][0]) $CellContext`\[Eta]0$b[
       8][-1] - 3024 $CellContext`\[Eta]0$[1][1] $CellContext`\[Eta]0$b[
      8][-1] + 48 (-36 + 
       Complex[0, -77] 3^Rational[1, 2]) $CellContext`\[Eta]0$b[9][-1] + 
     Complex[0, 864] $CellContext`\[Eta]0$b[10][-1] + (-222912 - 
       622080 $CellContext`\[Zeta]$[1][0] - 
       373248 $CellContext`\[Zeta]$[1][0]^2 - 
       93312 $CellContext`\[Zeta]$[3][0]) $CellContext`\[Eta]0$b[1, 2][-1] + (
       Complex[0, 311040] + 
       Complex[0, 373248] $CellContext`\[Zeta]$[1][0]) $CellContext`\[Eta]0$[
       1][1] $CellContext`\[Eta]0$b[1, 2][-1] + 
     93312 $CellContext`\[Eta]0$[1][1]^2 $CellContext`\[Eta]0$b[1, 2][-1] + 
     Complex[0, 20736] 
      3^Rational[1, 2] $CellContext`\[Eta]0$[2][1] $CellContext`\[Eta]0$b[
       1, 2][-1] + 
     Complex[0, -15552] $CellContext`\[Eta]0$[3][1] $CellContext`\[Eta]0$b[
       1, 2][-1] + (8640 (Complex[0, 18] + 3^Rational[1, 2]) + 
       20736 (Complex[0, 9] + 5 3^Rational[1, 2]) $CellContext`\[Zeta]$[1][0] + 
       124416 3^Rational[1, 2] $CellContext`\[Zeta]$[1][0]^2 + 
       31104 3^Rational[1, 2] $CellContext`\[Zeta]$[3][
         0]) $CellContext`\[Eta]0$b[1, 3][-1] + (
       10368 (9 + Complex[0, -5] 3^Rational[1, 2]) + 
       Complex[0, -124416] 
        3^Rational[1, 2] $CellContext`\[Zeta]$[1][0]) $CellContext`\[Eta]0$[
       1][1] $CellContext`\[Eta]0$b[1, 3][-1] - 31104 
     3^Rational[1, 2] $CellContext`\[Eta]0$[1][1]^2 $CellContext`\[Eta]0$b[
      1, 3][-1] + 
     Complex[0, -20736] $CellContext`\[Eta]0$[2][1] $CellContext`\[Eta]0$b[
       1, 3][-1] + 
     Complex[0, 5184] 
      3^Rational[1, 2] $CellContext`\[Eta]0$[3][1] $CellContext`\[Eta]0$b[
       1, 3][-1] + $CellContext`\[Eta]0$[1][1] $CellContext`\[Eta]0$b[
       1][-1] ((-622080) 3^Rational[1, 2] - 373248 
       3^Rational[1, 2] $CellContext`\[Zeta]$[1][
        0] + (Complex[0, -311040] + 
         Complex[0, -373248] $CellContext`\[Zeta]$[1][
           0]) $CellContext`\[Eta]0$b[2][-1] + (
         Complex[0, 10368] (Complex[0, 9] + 5 3^Rational[1, 2]) + 
         Complex[0, 124416] 
          3^Rational[1, 2] $CellContext`\[Zeta]$[1][
           0]) $CellContext`\[Eta]0$b[3][-1] + (
         10368 (Complex[0, 5] + 3 3^Rational[1, 2]) + 
         Complex[0, -62208] $CellContext`\[Zeta]$[1][
           0]) $CellContext`\[Eta]0$b[4][-1] + 
       1728 (-9 + Complex[0, -17] 3^Rational[1, 2]) $CellContext`\[Eta]0$b[
         5][-1] + Complex[0, 10368] $CellContext`\[Eta]0$b[6][-1] - 
       186624 $CellContext`\[Eta]0$b[1, 2][-1] + 
       62208 3^Rational[1, 2] $CellContext`\[Eta]0$b[1, 3][-1] - 
       31104 $CellContext`\[Eta]0$b[1, 4][-1]) + $CellContext`\[Eta]0$b[
       3][-1] (288 (-387 + Complex[0, 118] 3^Rational[1, 2]) + 
       Complex[0, 20736] (Complex[0, 9] + 
         5 3^Rational[1, 2]) $CellContext`\[Zeta]$[1][0]^2 + 
       Complex[0, 82944] 3^Rational[1, 2] $CellContext`\[Zeta]$[1][0]^3 + 
       1728 (-27 + Complex[0, 10] 3^Rational[1, 2]) $CellContext`\[Zeta]$[3][
         0] + $CellContext`\[Zeta]$[1][0] (
         Complex[0, 6912] (Complex[0, 45] + 7 3^Rational[1, 2]) + 
         Complex[0, 62208] 3^Rational[1, 2] $CellContext`\[Zeta]$[3][0]) + 
       Complex[0, 17280] 
        3^Rational[1, 2] $CellContext`\[Zeta]$[5][0] + (
         288 (22 + Complex[0, -9] 3^Rational[1, 2]) - 
         5184 $CellContext`\[Zeta]$[1][0]) $CellContext`\[Eta]0$b[4][-1] + 
       144 (Complex[0, 9] - 17 3^Rational[1, 2]) $CellContext`\[Eta]0$b[
         5][-1] + 864 $CellContext`\[Eta]0$b[6][-1] + 
       Complex[0, 2592] $CellContext`\[Eta]0$b[1, 4][-1]) + (
       2592 (39 + Complex[0, -14] 3^Rational[1, 2]) + 
       20736 (5 + Complex[0, -3] 3^Rational[1, 2]) $CellContext`\[Zeta]$[1][
         0] - 62208 $CellContext`\[Zeta]$[1][0]^2 - 
       15552 $CellContext`\[Zeta]$[3][0]) $CellContext`\[Eta]0$b[
       1, 4][-1] + ((-10368) (Complex[0, 5] + 3 3^Rational[1, 2]) + 
       Complex[0, 62208] $CellContext`\[Zeta]$[1][0]) $CellContext`\[Eta]0$[
       1][1] $CellContext`\[Eta]0$b[1, 4][-1] + 
     15552 $CellContext`\[Eta]0$[1][1]^2 $CellContext`\[Eta]0$b[1, 4][-1] + 
     Complex[0, 3456] 
      3^Rational[1, 2] $CellContext`\[Eta]0$[2][1] $CellContext`\[Eta]0$b[
       1, 4][-1] + 
     Complex[0, -2592] $CellContext`\[Eta]0$[3][1] $CellContext`\[Eta]0$b[
       1, 4][-1] + $CellContext`\[Eta]0$b[1][-1]^2 (311040 3^Rational[1, 2] + 
       186624 3^Rational[1, 2] $CellContext`\[Zeta]$[1][0] + (
         Complex[0, 155520] + 
         Complex[0, 186624] $CellContext`\[Zeta]$[1][
           0]) $CellContext`\[Eta]0$b[2][-1] + (
         5184 (9 + Complex[0, -5] 3^Rational[1, 2]) + 
         Complex[0, -62208] 
          3^Rational[1, 2] $CellContext`\[Zeta]$[1][
           0]) $CellContext`\[Eta]0$b[
         3][-1] + ((-5184) (Complex[0, 5] + 3 3^Rational[1, 2]) + 
         Complex[0, 31104] $CellContext`\[Zeta]$[1][
           0]) $CellContext`\[Eta]0$b[4][-1] + 
       864 (9 + Complex[0, 17] 3^Rational[1, 2]) $CellContext`\[Eta]0$b[
         5][-1] + Complex[0, -5184] $CellContext`\[Eta]0$b[6][-1] + 
       93312 $CellContext`\[Eta]0$b[1, 2][-1] - 31104 
       3^Rational[1, 2] $CellContext`\[Eta]0$b[1, 3][-1] + 
       15552 $CellContext`\[Eta]0$b[1, 4][-1]) + $CellContext`\[Eta]0$b[
       2][-1] (Complex[0, -222048] + 
       Complex[0, -622080] $CellContext`\[Zeta]$[1][0]^2 + 
       Complex[0, -248832] $CellContext`\[Zeta]$[1][
          0]^3 + $CellContext`\[Zeta]$[1][0] (Complex[0, -570240] + 
         Complex[0, -186624] $CellContext`\[Zeta]$[3][0]) + 
       Complex[0, -139968] $CellContext`\[Zeta]$[3][0] + 
       Complex[0, -51840] $CellContext`\[Zeta]$[5][0] + (
         864 (19 + Complex[0, -12] 3^Rational[1, 2]) - 
         41472 $CellContext`\[Zeta]$[1][0]) $CellContext`\[Eta]0$b[3][-1] + (
         144 (Complex[0, 72] - 43 3^Rational[1, 2]) + 
         6912 3^Rational[1, 2] $CellContext`\[Zeta]$[1][
           0]) $CellContext`\[Eta]0$b[4][-1] + 
       576 (17 + Complex[0, -3] 3^Rational[1, 2]) $CellContext`\[Eta]0$b[
         5][-1] - 1152 3^Rational[1, 2] $CellContext`\[Eta]0$b[6][-1] + 
       Complex[0, 20736] $CellContext`\[Eta]0$b[1, 3][-1] + 
       Complex[0, -3456] 
        3^Rational[1, 2] $CellContext`\[Eta]0$b[1, 4][-1]) + ((-288) (
         Complex[0, 99] + 52 3^Rational[1, 2]) - 
       3456 (Complex[0, -9] + 17 3^Rational[1, 2]) $CellContext`\[Zeta]$[1][
        0]) $CellContext`\[Eta]0$b[1, 5][-1] + 
     1728 (9 + Complex[0, 17] 3^Rational[1, 2]) $CellContext`\[Eta]0$[1][
       1] $CellContext`\[Eta]0$b[1, 5][-1] + (
       288 (-103 + Complex[0, 48] 3^Rational[1, 2]) + 
       20736 $CellContext`\[Zeta]$[1][0]) $CellContext`\[Eta]0$b[1, 6][-1] + 
     Complex[0, -10368] $CellContext`\[Eta]0$[1][1] $CellContext`\[Eta]0$b[
       1, 6][-1] + 
     2160 (Complex[0, -3] + 5 3^Rational[1, 2]) $CellContext`\[Eta]0$b[
       1, 7][-1] - 
     3024 $CellContext`\[Eta]0$b[
      1, 8][-1] + (864 (19 + Complex[0, -18] 3^Rational[1, 2]) + 
       10368 (1 + Complex[0, -6] 3^Rational[1, 2]) $CellContext`\[Zeta]$[1][
         0]) $CellContext`\[Eta]0$b[2, 3][-1] - 
     5184 (Complex[0, 1] + 6 3^Rational[1, 2]) $CellContext`\[Eta]0$[1][
      1] $CellContext`\[Eta]0$b[
      2, 3][-1] + ((-144) (Complex[0, 252] + 101 3^Rational[1, 2]) - 
       3456 (Complex[0, -9] + 2 3^Rational[1, 2]) $CellContext`\[Zeta]$[1][
        0]) $CellContext`\[Eta]0$b[2, 4][-1] + 
     1728 (9 + Complex[0, 2] 3^Rational[1, 2]) $CellContext`\[Eta]0$[1][
       1] $CellContext`\[Eta]0$b[2, 4][-1] + 
     288 (2 + Complex[0, 57] 3^Rational[1, 2]) $CellContext`\[Eta]0$b[
       2, 5][-1] + 
     576 (Complex[0, -9] + 2 3^Rational[1, 2]) $CellContext`\[Eta]0$b[
       2, 6][-1] + (2016 (2 + Complex[0, 3] 3^Rational[1, 2]) + 
       5184 $CellContext`\[Zeta]$[1][0]) $CellContext`\[Eta]0$b[3, 4][-1] + 
     Complex[0, -2592] $CellContext`\[Eta]0$[1][1] $CellContext`\[Eta]0$b[
       3, 4][-1] + 
     144 (Complex[0, -9] + 11 3^Rational[1, 2]) $CellContext`\[Eta]0$b[
       3, 5][-1] - 864 $CellContext`\[Eta]0$b[3, 6][-1] + 
     432 $CellContext`\[Eta]0$b[4, 5][-1] + (Complex[0, 311040] + 
       Complex[0, 373248] $CellContext`\[Zeta]$[1][0]) $CellContext`\[Eta]0$b[
       1, 1, 2][-1] + 
     186624 $CellContext`\[Eta]0$[1][1] $CellContext`\[Eta]0$b[
       1, 1, 2][-1] + (10368 (9 + Complex[0, -5] 3^Rational[1, 2]) + 
       Complex[0, -124416] 
        3^Rational[1, 2] $CellContext`\[Zeta]$[1][0]) $CellContext`\[Eta]0$b[
       1, 1, 3][-1] - 62208 
     3^Rational[1, 2] $CellContext`\[Eta]0$[1][1] $CellContext`\[Eta]0$b[
      1, 1, 3][-1] + $CellContext`\[Eta]0$b[1][-1] (
       Complex[0, -1119744] 3^Rational[1, 2] + 
       Complex[0, -1244160] 3^Rational[1, 2] $CellContext`\[Zeta]$[1][0] + 
       Complex[0, -373248] 3^Rational[1, 2] $CellContext`\[Zeta]$[1][0]^2 + 
       Complex[0, -93312] 3^Rational[1, 2] $CellContext`\[Zeta]$[3][0] + 
       Complex[0, 5184] (Complex[0, 9] + 
         2 3^Rational[1, 2]) $CellContext`\[Eta]0$b[2][-1]^2 + 
       Complex[0, 2592] 
        3^Rational[1, 2] $CellContext`\[Eta]0$b[
          3][-1]^2 + $CellContext`\[Eta]0$b[
         3][-1] ((-3456) (Complex[0, 45] + 7 3^Rational[1, 2]) - 
         20736 (Complex[0, 9] + 5 3^Rational[1, 2]) $CellContext`\[Zeta]$[1][
          0] - 124416 3^Rational[1, 2] $CellContext`\[Zeta]$[1][0]^2 - 31104 
         3^Rational[1, 2] $CellContext`\[Zeta]$[3][0] + 
         Complex[0, -2592] $CellContext`\[Eta]0$b[4][-1]) + (
         2592 (-21 + Complex[0, 10] 3^Rational[1, 2]) + 
         Complex[0, 20736] (Complex[0, 5] + 
           3 3^Rational[1, 2]) $CellContext`\[Zeta]$[1][0] + 
         62208 $CellContext`\[Zeta]$[1][0]^2 + 
         15552 $CellContext`\[Zeta]$[3][0]) $CellContext`\[Eta]0$b[
         4][-1] + $CellContext`\[Eta]0$b[2][-1] (285120 + 
         622080 $CellContext`\[Zeta]$[1][0] + 
         373248 $CellContext`\[Zeta]$[1][0]^2 + 
         93312 $CellContext`\[Zeta]$[3][0] + 
         Complex[0, -20736] $CellContext`\[Eta]0$b[3][-1] + 
         Complex[0, 3456] 3^Rational[1, 2] $CellContext`\[Eta]0$b[4][-1]) + (
         288 (Complex[0, 99] + 52 3^Rational[1, 2]) + 
         3456 (Complex[0, -9] + 17 3^Rational[1, 2]) $CellContext`\[Zeta]$[1][
           0]) $CellContext`\[Eta]0$b[5][-1] + (
         288 (103 + Complex[0, -57] 3^Rational[1, 2]) - 
         20736 $CellContext`\[Zeta]$[1][0]) $CellContext`\[Eta]0$b[6][-1] - 
       2160 (Complex[0, -3] + 5 3^Rational[1, 2]) $CellContext`\[Eta]0$b[
        7][-1] + 3024 $CellContext`\[Eta]0$b[8][-1] + (Complex[0, -311040] + 
         Complex[0, -373248] $CellContext`\[Zeta]$[1][
           0]) $CellContext`\[Eta]0$b[1, 2][-1] + (
         Complex[0, 10368] (Complex[0, 9] + 5 3^Rational[1, 2]) + 
         Complex[0, 124416] 
          3^Rational[1, 2] $CellContext`\[Zeta]$[1][
           0]) $CellContext`\[Eta]0$b[1, 3][-1] + (
         10368 (Complex[0, 5] + 3 3^Rational[1, 2]) + 
         Complex[0, -62208] $CellContext`\[Zeta]$[1][
           0]) $CellContext`\[Eta]0$b[1, 4][-1] + 
       1728 (-9 + Complex[0, -17] 3^Rational[1, 2]) $CellContext`\[Eta]0$b[
         1, 5][-1] + Complex[0, 10368] $CellContext`\[Eta]0$b[1, 6][-1] + 
       5184 (Complex[0, 1] + 6 3^Rational[1, 2]) $CellContext`\[Eta]0$b[
         2, 3][-1] + 
       1728 (-9 + Complex[0, -2] 3^Rational[1, 2]) $CellContext`\[Eta]0$b[
         2, 4][-1] + Complex[0, 2592] $CellContext`\[Eta]0$b[3, 4][-1] - 
       186624 $CellContext`\[Eta]0$b[1, 1, 2][-1] + 
       62208 3^Rational[1, 2] $CellContext`\[Eta]0$b[1, 1, 3][-1] - 
       31104 $CellContext`\[Eta]0$b[
        1, 1, 4][-1]) + ((-10368) (Complex[0, 5] + 3 3^Rational[1, 2]) + 
       Complex[0, 62208] $CellContext`\[Zeta]$[1][0]) $CellContext`\[Eta]0$b[
       1, 1, 4][-1] + 
     31104 $CellContext`\[Eta]0$[1][1] $CellContext`\[Eta]0$b[1, 1, 4][-1] + 
     1728 (9 + Complex[0, 17] 3^Rational[1, 2]) $CellContext`\[Eta]0$b[
       1, 1, 5][-1] + Complex[0, -10368] $CellContext`\[Eta]0$b[1, 1, 6][-1] + 
     10368 (9 + Complex[0, -2] 3^Rational[1, 2]) $CellContext`\[Eta]0$b[
       1, 2, 2][-1] - 
     5184 (Complex[0, 1] + 6 3^Rational[1, 2]) $CellContext`\[Eta]0$b[
      1, 2, 3][-1] + 
     1728 (9 + Complex[0, 2] 3^Rational[1, 2]) $CellContext`\[Eta]0$b[
       1, 2, 4][-1] + 
     Complex[0, -5184] 3^Rational[1, 2] $CellContext`\[Eta]0$b[1, 3, 3][-1] + 
     Complex[0, -2592] $CellContext`\[Eta]0$b[1, 3, 4][-1] + 
     93312 $CellContext`\[Eta]0$b[2, 1, 2][-1] - 
     10368 (Complex[0, 2] + 3 3^Rational[1, 2]) $CellContext`\[Eta]0$b[
      2, 1, 3][-1] + 
     1728 (9 + Complex[0, 2] 3^Rational[1, 2]) $CellContext`\[Eta]0$b[
       2, 1, 4][-1] + Complex[0, -2592] $CellContext`\[Eta]0$b[3, 1, 4][-1] + 
     186624 $CellContext`\[Eta]0$b[1, 1, 1, 2][-1] - 62208 
     3^Rational[1, 2] $CellContext`\[Eta]0$b[1, 1, 1, 3][-1] + 
     31104 $CellContext`\[Eta]0$b[1, 1, 1, 4][-1]}, 8, 15, 1],
   Editable->False],
  Short[#, 5]& ]], "Output",
 CellChangeTimes->{{3.553702826981536*^9, 3.5537028382446203`*^9}, 
   3.55370287746793*^9, 3.553707741719014*^9, 3.5537086256326103`*^9, 
   3.553708730627954*^9, {3.553708861925376*^9, 3.5537089000773497`*^9}}]
}, Open  ]]
}, Closed]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  FormBox[
   SubscriptBox["Y", 
    RowBox[{"1", ",", "1"}]], TraditionalForm]]],
 " and ",
 Cell[BoxData[
  FormBox[
   SubscriptBox["Y", 
    RowBox[{"2", ",", "2"}]], TraditionalForm]]],
 ", their product and ratio, and ",
 Cell[BoxData["H"],
  CellChangeTimes->{{3.553326436247958*^9, 3.5533264377368183`*^9}, {
   3.553326481625613*^9, 3.553326483351549*^9}}],
 " "
}], "Section",
 CellChangeTimes->{{3.5502222520072813`*^9, 3.550222256086728*^9}, {
  3.5502250477988443`*^9, 3.5502250486532497`*^9}, {3.5502303010087852`*^9, 
  3.5502303473771152`*^9}, {3.5533177720528393`*^9, 3.5533177782156963`*^9}, {
  3.5537117380506144`*^9, 3.5537117816948433`*^9}}],

Cell[CellGroupData[{

Cell[TextData[{
 "reltaions between asymptotic ",
 Cell[BoxData[
  FormBox[
   SubscriptBox["\[GothicCapitalT]", 
    RowBox[{"a", ",", "1"}]], TraditionalForm]]],
 " and ",
 Cell[BoxData[
  FormBox[
   SubscriptBox["\[ScriptCapitalT]", 
    RowBox[{"1", ",", "s"}]], TraditionalForm]]]
}], "Subsection",
 CellChangeTimes->{{3.55022664718054*^9, 3.5502266485896187`*^9}, {
  3.550226686196568*^9, 3.550226732809936*^9}, {3.550227649621166*^9, 
  3.5502276545232563`*^9}, {3.55022970916214*^9, 3.5502297255415783`*^9}}],

Cell["\<\
First important property is that \
\>", "Text",
 CellChangeTimes->{{3.550229735447589*^9, 3.5502297804040527`*^9}}],

Cell[BoxData[
 RowBox[{
  SubscriptBox[
   StyleBox["\[GothicCapitalT]",
    FontColor->RGBColor[0.54, 0.35, 0.15]], 
   RowBox[{"a", ",", "1"}]], "==", 
  RowBox[{
   SuperscriptBox[
    OverscriptBox[
     StyleBox["y",
      FontColor->RGBColor[0, 0.6, 0]], 
     StyleBox["^",
      FontColor->RGBColor[0, 0.6, 0]]], "-"], " ", 
   SuperscriptBox[
    OverscriptBox[
     StyleBox["y",
      FontColor->RGBColor[0, 0.6, 0]], 
     StyleBox["^",
      FontColor->RGBColor[0, 0.6, 0]]], "+"], 
   SubsuperscriptBox[
    StyleBox["\[ScriptCapitalT]",
     FontColor->RGBColor[1, 0, 0]], 
    RowBox[{"1", ",", "a"}], 
    RowBox[{
     SubscriptBox["\[Gamma]", "+"], 
     SubscriptBox["\[Gamma]", "-"]}]]}]}]], "Input",
 CellChangeTimes->{{3.550229808510084*^9, 3.550229840508202*^9}, {
  3.550229899945557*^9, 3.550229900050095*^9}, {3.553233465660474*^9, 
  3.553233466113317*^9}}],

Cell[TextData[{
 "where ",
 Cell[BoxData[
  FormBox[
   SubscriptBox["\[Gamma]", "+"], TraditionalForm]]],
 " ",
 Cell[BoxData[
  FormBox[
   SubscriptBox["\[Gamma]", "-"], TraditionalForm]]],
 " means analytic continuation around both branch cuts of the T-function."
}], "Text",
 CellChangeTimes->{{3.550229844338069*^9, 3.5502298651845407`*^9}, {
   3.550295340085432*^9, 3.550295344482882*^9}, 3.553233468143029*^9}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", "check", " ", "*)"}], 
  RowBox[{
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{"With", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"a", "=", 
         RowBox[{"Random", "[", 
          RowBox[{"Integer", ",", 
           RowBox[{"{", 
            RowBox[{"1", ",", "20"}], "}"}]}], "]"}]}], "}"}], ",", 
       RowBox[{
        RowBox[{
         FractionBox[
          RowBox[{
           RowBox[{
            RowBox[{
             SuperscriptBox[
              OverscriptBox[
               StyleBox["y",
                FontColor->RGBColor[0, 0.6, 0]], 
               StyleBox["^",
                FontColor->RGBColor[0, 0.6, 0]]], "-"], " ", 
             SuperscriptBox[
              OverscriptBox[
               StyleBox["y",
                FontColor->RGBColor[0, 0.6, 0]], 
               StyleBox["^",
                FontColor->RGBColor[0, 0.6, 0]]], "+"], 
             SubscriptBox[
              OverscriptBox["\[ScriptCapitalT]", "^"], 
              RowBox[{"1", ",", "a"}]]}], "/.", "largevolume"}], "/.", 
           RowBox[{
            RowBox[{"xh", "[", 
             RowBox[{"r_:", "0"}], "]"}], "\[RuleDelayed]", 
            FractionBox["1", 
             RowBox[{"xh", "[", "r", "]"}]]}]}], 
          RowBox[{
           SubscriptBox[
            OverscriptBox[
             StyleBox["\[GothicCapitalT]",
              FontColor->RGBColor[0.54, 0.35, 0.15]], "^"], 
            RowBox[{"a", ",", "1"}]], "/.", "largevolume"}]], "/.", 
         "subJuk"}], "/.", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{
           SubscriptBox["v", "0"], "\[Rule]", 
           RowBox[{"Random", "[", "]"}]}], ",", 
          RowBox[{"g", "\[Rule]", 
           RowBox[{"Random", "[", "]"}]}], ",", 
          RowBox[{"u", "\[Rule]", 
           RowBox[{"Random", "[", "]"}]}]}], "}"}]}]}], "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"iii", ",", "5"}], "}"}]}], "]"}], "//", "Chop"}]}]], "Input",
 CellChangeTimes->{{3.5502298731952467`*^9, 3.5502299465679083`*^9}, {
  3.550295346537928*^9, 3.550295367351652*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "1.`", ",", "0.9999999999999996`", ",", "0.9999999999999987`", ",", 
   "0.9999999999999988`", ",", "0.9999999999999996`"}], "}"}]], "Output",
 CellChangeTimes->{{3.550229927282607*^9, 3.550229949478499*^9}, {
   3.550295349999531*^9, 3.550295367849962*^9}, 3.553233404705114*^9}]
}, Open  ]],

Cell[TextData[{
 "For ",
 Cell[BoxData[
  FormBox[
   SubscriptBox["\[GothicCapitalT]", 
    RowBox[{"a", ",", "1"}]], TraditionalForm]],
  FormatType->"TraditionalForm"],
 " the ratio is also simple:"
}], "Text",
 CellChangeTimes->{{3.5502299627665863`*^9, 3.550229992475593*^9}}],

Cell[BoxData[
 RowBox[{
  FractionBox[
   StyleBox["\[GothicCapitalT]",
    FontColor->RGBColor[0.54, 0.35, 0.15]], 
   RowBox[{
    SuperscriptBox[
     OverscriptBox[
      StyleBox["y",
       FontColor->RGBColor[0, 0.6, 0]], 
      StyleBox["^",
       FontColor->RGBColor[0, 0.6, 0]]], "-"], " ", 
    SuperscriptBox[
     OverscriptBox[
      StyleBox["y",
       FontColor->RGBColor[0, 0.6, 0]], 
      StyleBox["^",
       FontColor->RGBColor[0, 0.6, 0]]], "+"], 
    StyleBox["\[ScriptCapitalT]",
     FontColor->RGBColor[1, 0, 0]]}]], "\[Equal]", 
  FractionBox[
   RowBox[{
    SuperscriptBox["Bp", "-"], 
    SuperscriptBox["x", "-"]}], 
   RowBox[{
    SuperscriptBox["Bm", "+"], 
    SuperscriptBox["x", "+"]}]]}]], "Input",
 CellChangeTimes->{{3.5502299945616217`*^9, 3.5502300287404747`*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", "check", " ", "*)"}], 
  RowBox[{
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{
          FractionBox[
           StyleBox["\[GothicCapitalT]",
            FontColor->RGBColor[0.54, 0.35, 0.15]], 
           RowBox[{
            SuperscriptBox[
             OverscriptBox[
              StyleBox["y",
               FontColor->RGBColor[0, 0.6, 0]], 
              StyleBox["^",
               FontColor->RGBColor[0, 0.6, 0]]], "-"], " ", 
            SuperscriptBox[
             OverscriptBox[
              StyleBox["y",
               FontColor->RGBColor[0, 0.6, 0]], 
              StyleBox["^",
               FontColor->RGBColor[0, 0.6, 0]]], "+"], 
            StyleBox["\[ScriptCapitalT]",
             FontColor->RGBColor[1, 0, 0]]}]], "/", 
          RowBox[{"(", 
           FractionBox[
            RowBox[{
             SuperscriptBox["Bp", "-"], 
             SuperscriptBox["x", "-"]}], 
            RowBox[{
             SuperscriptBox["Bm", "+"], 
             SuperscriptBox["x", "+"]}]], ")"}]}], "/.", "largevolume"}], "/.",
         "subFunsBethe"}], "/.", "subJuk"}], "/.", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{
         SubscriptBox["v", "0"], "\[Rule]", 
         RowBox[{"Random", "[", "]"}]}], ",", 
        RowBox[{"g", "\[Rule]", 
         RowBox[{"Random", "[", "]"}]}], ",", 
        RowBox[{"u", "\[Rule]", 
         RowBox[{"Random", "[", "]"}]}]}], "}"}]}], ",", 
     RowBox[{"{", 
      RowBox[{"iii", ",", "5"}], "}"}]}], "]"}], "//", "Chop"}]}]], "Input",
 CellChangeTimes->{{3.550230039940205*^9, 3.5502300781158257`*^9}, 
   3.5502953757395983`*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "1.0000000000000073`", ",", "0.9999999999999992`", ",", 
   "0.9999999999999997`", ",", "0.9999999999999974`", ",", 
   "0.9999999999999999`"}], "}"}]], "Output",
 CellChangeTimes->{{3.550230054419264*^9, 3.550230078495579*^9}, 
   3.550295376856659*^9, 3.553233445517335*^9}]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[Cell[BoxData[
 FormBox[
  RowBox[{"Log", "[", 
   RowBox[{
    SubscriptBox["Y", 
     RowBox[{"1", ",", "1"}]], 
    SubscriptBox["Y", 
     RowBox[{"2", ",", "2"}]]}], "]"}], TraditionalForm]]]], "Subsection",
 CellChangeTimes->{{3.5382929421119957`*^9, 3.53829295739063*^9}, 
   3.550204257722814*^9, {3.553233673844035*^9, 3.553233680186263*^9}, {
   3.5532846334394293`*^9, 3.553284635054514*^9}, 3.5533137256200457`*^9}],

Cell[CellGroupData[{

Cell["Init", "Subsubsection",
 CellChangeTimes->{{3.5532776004264097`*^9, 3.553277600894671*^9}}],

Cell[TextData[{
 "We are using the fact that ",
 Cell[BoxData[
  RowBox[{
   FractionBox["1", 
    RowBox[{" ", 
     RowBox[{
      SubscriptBox[
       StyleBox["Y",
        FontColor->RGBColor[0, 0, 0.8]], 
       RowBox[{"1", ",", "1"}]], " ", 
      SubscriptBox[
       StyleBox["Y",
        FontColor->RGBColor[0, 0, 0.8]], 
       RowBox[{"2", ",", "2"}]]}]}]], 
   FractionBox[
    SubscriptBox[
     StyleBox["\[GothicCapitalT]",
      FontColor->RGBColor[0.54, 0.35, 0.15]], 
     RowBox[{"1", ",", "0"}]], 
    SubsuperscriptBox[
     StyleBox["\[GothicCapitalT]",
      FontColor->RGBColor[0.54, 0.35, 0.15]], 
     RowBox[{"0", ",", "0"}], "-"]]}]],
  CellChangeTimes->{{3.538205353239572*^9, 3.53820550460912*^9}, {
    3.5382055365606213`*^9, 3.538205559308566*^9}, 3.550204257761262*^9}],
 " is analytic in the UHP, with a branch point on the real axis. We hence can \
write:"
}], "Text",
 CellChangeTimes->{{3.553234691315648*^9, 3.553234717936392*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{
    FractionBox[
     RowBox[{"Log", "[", 
      RowBox[{
       FractionBox["1", 
        RowBox[{" ", 
         RowBox[{
          SubscriptBox[
           StyleBox["Y",
            FontColor->RGBColor[0, 0, 0.8]], 
           RowBox[{"1", ",", "1"}]], " ", 
          SubscriptBox[
           StyleBox["Y",
            FontColor->RGBColor[0, 0, 0.8]], 
           RowBox[{"2", ",", "2"}]]}]}]], 
       FractionBox[
        SubscriptBox[
         StyleBox["\[GothicCapitalT]",
          FontColor->RGBColor[0.54, 0.35, 0.15]], 
         RowBox[{"1", ",", "0"}]], 
        SubsuperscriptBox[
         StyleBox["\[GothicCapitalT]",
          FontColor->RGBColor[0.54, 0.35, 0.15]], 
         RowBox[{"0", ",", "0"}], "-"]]}], "]"}], 
     RowBox[{
      OverscriptBox[
       StyleBox["x",
        FontColor->RGBColor[0, 0.6, 0]], 
       StyleBox["^",
        FontColor->RGBColor[0, 0.6, 0]]], "-", 
      FractionBox["1", 
       OverscriptBox[
        StyleBox["x",
         FontColor->RGBColor[0, 0.6, 0]], 
        StyleBox["^",
         FontColor->RGBColor[0, 0.6, 0]]]]}]], "\[Equal]", 
    RowBox[{"\[ScriptCapitalC]", "*", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"mf", "[", 
        RowBox[{"v", "+", 
         RowBox[{"\[ImaginaryI]", " ", "0"}]}], "]"}], "+", 
       RowBox[{
        OverscriptBox["mf", "_"], "[", 
        RowBox[{"v", "-", 
         RowBox[{"\[ImaginaryI]", " ", "0"}]}], "]"}]}], ")"}]}]}], ",", 
   RowBox[{
    RowBox[{"mf", "[", "u", "]"}], "=", 
    FractionBox[
     RowBox[{"Log", "[", 
      FractionBox[
       SubscriptBox[
        StyleBox["\[GothicCapitalT]",
         FontColor->RGBColor[0.54, 0.35, 0.15]], 
        RowBox[{"1", ",", "0"}]], 
       SubsuperscriptBox[
        StyleBox["\[GothicCapitalT]",
         FontColor->RGBColor[0.54, 0.35, 0.15]], 
        RowBox[{"0", ",", "0"}], "-"]], "]"}], 
     RowBox[{
      OverscriptBox[
       StyleBox["x",
        FontColor->RGBColor[0, 0.6, 0]], 
       StyleBox["^",
        FontColor->RGBColor[0, 0.6, 0]]], "-", 
      FractionBox["1", 
       OverscriptBox[
        StyleBox["x",
         FontColor->RGBColor[0, 0.6, 0]], 
        StyleBox["^",
         FontColor->RGBColor[0, 0.6, 0]]]]}]]}], ",", 
   RowBox[{
    RowBox[{
     OverscriptBox["mf", "_"], "[", "u", "]"}], "=", 
    FractionBox[
     RowBox[{"Log", "[", 
      FractionBox[
       SubscriptBox[
        StyleBox["\[GothicCapitalT]",
         FontColor->RGBColor[0.54, 0.35, 0.15]], 
        RowBox[{"1", ",", "0"}]], 
       SubsuperscriptBox[
        StyleBox["\[GothicCapitalT]",
         FontColor->RGBColor[0.54, 0.35, 0.15]], 
        RowBox[{"0", ",", "0"}], "+"]], "]"}], 
     RowBox[{
      OverscriptBox[
       StyleBox["x",
        FontColor->RGBColor[0, 0.6, 0]], 
       StyleBox["^",
        FontColor->RGBColor[0, 0.6, 0]]], "-", 
      FractionBox["1", 
       OverscriptBox[
        StyleBox["x",
         FontColor->RGBColor[0, 0.6, 0]], 
        StyleBox["^",
         FontColor->RGBColor[0, 0.6, 0]]]]}]]}]}], "}"}]], "Input",
 CellChangeTimes->{{3.538205736029601*^9, 3.538205757190119*^9}, {
   3.538205994876793*^9, 3.538206046488097*^9}, 3.550204257763142*^9, {
   3.5532346780852633`*^9, 3.5532346806457443`*^9}, {3.553234720722478*^9, 
   3.55323473094702*^9}, {3.553237797209345*^9, 3.553237847348947*^9}, {
   3.553239497787908*^9, 3.553239507062079*^9}}],

Cell[TextData[{
 "Checking now whether this expression gives  a correct asympotic value of \
Y11Y22. We use that ",
 Cell[BoxData[
  RowBox[{
   RowBox[{"Log", "[", 
    FractionBox[
     SubscriptBox[
      StyleBox["\[GothicCapitalT]",
       FontColor->RGBColor[0.54, 0.35, 0.15]], 
      RowBox[{"1", ",", "0"}]], 
     SubsuperscriptBox[
      StyleBox["\[GothicCapitalT]",
       FontColor->RGBColor[0.54, 0.35, 0.15]], 
      RowBox[{"0", ",", "0"}], "-"]], "]"}], "=", 
   RowBox[{"Log", "[", 
    FractionBox[
     SuperscriptBox["Q", "-"], 
     SuperscriptBox["Q", "+"]], "]"}]}]],
  CellChangeTimes->{{3.538205736029601*^9, 3.538205757190119*^9}, {
    3.538205994876793*^9, 3.538206046488097*^9}, 3.550204257763142*^9, {
    3.5532346780852633`*^9, 3.5532346806457443`*^9}, {3.553234720722478*^9, 
    3.55323473094702*^9}, {3.553237797209345*^9, 3.553237847348947*^9}, {
    3.553239497787908*^9, 3.553239507062079*^9}}]
}], "Text",
 CellChangeTimes->{{3.5532394675538607`*^9, 3.553239525285199*^9}, {
  3.568963847089613*^9, 3.5689638483438272`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"\[Integral]", 
   RowBox[{
    FractionBox["dv", 
     RowBox[{
      RowBox[{"-", "2"}], "\[Pi]", " ", "\[ImaginaryI]"}]], 
    RowBox[{"(", 
     RowBox[{
      FractionBox["1", 
       RowBox[{"u", "-", "v"}]], 
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         FractionBox[
          RowBox[{"Log", "[", 
           FractionBox[
            SuperscriptBox["Q", "+"], 
            SuperscriptBox["Q", "-"]], "]"}], 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"-", 
             FractionBox["1", 
              OverscriptBox[
               StyleBox["y",
                FontColor->RGBColor[0, 0.6, 0]], 
               StyleBox["^",
                FontColor->RGBColor[0, 0.6, 0]]]]}], "+", 
            OverscriptBox[
             StyleBox["y",
              FontColor->RGBColor[0, 0.6, 0]], 
             StyleBox["^",
              FontColor->RGBColor[0, 0.6, 0]]]}], ")"}]], "[", 
         RowBox[{"v", "+", 
          RowBox[{"\[ImaginaryI]", " ", "0"}]}], "]"}], "+", 
        RowBox[{
         FractionBox[
          RowBox[{"Log", "[", 
           FractionBox[
            SuperscriptBox["Q", "-"], 
            SuperscriptBox["Q", "+"]], "]"}], 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"-", 
             FractionBox["1", 
              OverscriptBox[
               StyleBox["y",
                FontColor->RGBColor[0, 0.6, 0]], 
               StyleBox["^",
                FontColor->RGBColor[0, 0.6, 0]]]]}], "+", 
            OverscriptBox[
             StyleBox["y",
              FontColor->RGBColor[0, 0.6, 0]], 
             StyleBox["^",
              FontColor->RGBColor[0, 0.6, 0]]]}], ")"}]], "[", 
         RowBox[{"v", "-", 
          RowBox[{"\[ImaginaryI]", " ", "0"}]}], "]"}]}], ")"}]}], ")"}]}]}], 
  "\[Equal]", "\[IndentingNewLine]", "\[Equal]", 
  RowBox[{"\[ContourIntegral]", 
   RowBox[{
    FractionBox["dv", 
     RowBox[{
      RowBox[{"-", "2"}], "\[Pi]", " ", "\[ImaginaryI]"}]], 
    FractionBox["1", 
     RowBox[{"u", "-", "v"}]], 
    RowBox[{"(", 
     FractionBox[
      RowBox[{"Log", "[", 
       FractionBox[
        SuperscriptBox["Q", "+"], 
        SuperscriptBox["Q", "-"]], "]"}], 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", 
         FractionBox["1", 
          OverscriptBox[
           StyleBox["y",
            FontColor->RGBColor[0, 0.6, 0]], 
           StyleBox["^",
            FontColor->RGBColor[0, 0.6, 0]]]]}], "+", 
        OverscriptBox[
         StyleBox["y",
          FontColor->RGBColor[0, 0.6, 0]], 
         StyleBox["^",
          FontColor->RGBColor[0, 0.6, 0]]]}], ")"}]], ")"}]}]}]}]], "Input",
 CellChangeTimes->{{3.553235038842248*^9, 3.553235062882704*^9}, {
   3.5532383605652447`*^9, 3.5532384212689247`*^9}, {3.553238460034313*^9, 
   3.553238535373673*^9}, {3.5532389105889473`*^9, 3.553238920965518*^9}, 
   3.553239198234618*^9, {3.55323952703117*^9, 3.55323953683827*^9}}],

Cell["\<\
We should defourm the contour of integration to the places around logarithmic \
branch cut (they are from the Bethe root to infinity). When doing this, we  \
cross u=v. The residue at this point cancells free term in the equation. Now \
we are around logarithmic branch cuts . There \[CapitalDelta][Log]=2\[Pi]\
\[ImaginaryI], and we have integration over a line from Bethe root to \
infinity. Integral converges, each separately. We can make change of \
variables of integration to Zhukowsky variables. Then the integral will be an \
integral over a rational function, and it can be taken, producing naturally \
logarithms of shifted B-s and R-s. I see therefore that we can succeed with \
taking the integral. And now I will check the known answer numerically.\
\>", "Text",
 CellChangeTimes->{{3.553238925558085*^9, 3.553239061184133*^9}, {
  3.5532391125554333`*^9, 3.553239205538043*^9}, {3.55323954492187*^9, 
  3.553239644170102*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Log", "[", 
   SubscriptBox[
    RowBox[{"(", "Y11Y22", ")"}], "as"], "]"}], "==", 
  RowBox[{"Log", "[", 
   FractionBox[
    RowBox[{
     StyleBox["Bm",
      FontColor->RGBColor[0, 0.6, 0]], " ", 
     StyleBox["Rp",
      FontColor->RGBColor[0, 0.6, 0]]}], 
    RowBox[{
     StyleBox["Bp",
      FontColor->RGBColor[0, 0.6, 0]], " ", 
     StyleBox["Rm",
      FontColor->RGBColor[0, 0.6, 0]]}]], "]"}], "==", 
  RowBox[{
   RowBox[{"Log", "[", 
    FractionBox[
     SuperscriptBox["Q", "+"], 
     SuperscriptBox["Q", "-"]], "]"}], "-", 
   RowBox[{"\[ContourIntegral]", 
    RowBox[{
     FractionBox["dv", 
      RowBox[{
       RowBox[{"-", "2"}], "\[Pi]", " ", "\[ImaginaryI]"}]], 
     FractionBox["1", 
      RowBox[{"u", "-", "v"}]], 
     RowBox[{"(", 
      FractionBox[
       RowBox[{"Log", "[", 
        FractionBox[
         SuperscriptBox["Q", "+"], 
         SuperscriptBox["Q", "-"]], "]"}], 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", 
          FractionBox["1", 
           OverscriptBox[
            StyleBox["y",
             FontColor->RGBColor[0, 0.6, 0]], 
            StyleBox["^",
             FontColor->RGBColor[0, 0.6, 0]]]]}], "+", 
         OverscriptBox[
          StyleBox["y",
           FontColor->RGBColor[0, 0.6, 0]], 
          StyleBox["^",
           FontColor->RGBColor[0, 0.6, 0]]]}], ")"}]], ")"}]}]}]}]}]], "Input",
 CellChangeTimes->{{3.5532392176824303`*^9, 3.5532392396750174`*^9}, {
  3.5532394045844193`*^9, 3.5532394118240433`*^9}, {3.5532395402642727`*^9, 
  3.55323954776884*^9}, {3.553239720634388*^9, 3.553239721968911*^9}, {
  3.553276698223421*^9, 3.55327669842187*^9}}],

Cell["Equality is above real axis.", "Text",
 CellChangeTimes->{{3.5532394376025248`*^9, 3.5532394485211353`*^9}, 
   3.5532396565661173`*^9}],

Cell[TextData[{
 "It should be checked first that ",
 Cell[BoxData[
  RowBox[{"Log", "[", 
   FractionBox[
    SuperscriptBox["Q", "+"], 
    SuperscriptBox["Q", "-"]], "]"}]], "Input",
  CellChangeTimes->{{3.5532392176824303`*^9, 3.5532392396750174`*^9}, {
   3.5532394045844193`*^9, 3.5532394118240433`*^9}}],
 " propertly handles logarithmic branch points."
}], "Text",
 CellChangeTimes->{{3.5532393947005453`*^9, 3.553239435866625*^9}, {
  3.553239666008338*^9, 3.553239667457966*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Plot", "[", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{
          RowBox[{"Log", "[", 
           RowBox[{
            FractionBox[
             RowBox[{
              StyleBox["Bm",
               FontColor->RGBColor[0, 0.6, 0]], " ", 
              StyleBox["Rp",
               FontColor->RGBColor[0, 0.6, 0]]}], 
             RowBox[{
              StyleBox["Bp",
               FontColor->RGBColor[0, 0.6, 0]], " ", 
              StyleBox["Rm",
               FontColor->RGBColor[0, 0.6, 0]]}]], "/", 
            RowBox[{"(", 
             FractionBox[
              SuperscriptBox["Q", "+"], 
              SuperscriptBox["Q", "-"]], ")"}]}], "]"}], "/.", 
          "subFunsBethe"}], "/.", "subJuk"}], "/.", 
        RowBox[{
         SubscriptBox["v", "0"], "\[Rule]", 
         RowBox[{
          FractionBox["1", 
           SqrtBox["12"]], "+", 
          RowBox[{"Random", "[", "]"}]}]}]}], "/.", 
       RowBox[{"g", "\[Rule]", 
        RowBox[{"1", "/", "3"}]}]}], "/.", 
      RowBox[{"u", "\[Rule]", 
       RowBox[{"t", "+", 
        FractionBox["\[ImaginaryI]", "10"]}]}]}], "//", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"Re", "[", "#", "]"}], ",", 
        RowBox[{"Im", "[", "#", "]"}]}], "}"}], "&"}]}], "//", "Evaluate"}], 
   ",", 
   RowBox[{"{", 
    RowBox[{"t", ",", 
     RowBox[{"-", "5"}], ",", "5"}], "}"}], ",", 
   RowBox[{"PlotRange", "\[Rule]", "All"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.553239244722086*^9, 3.5532393903985023`*^9}, {
  3.553239671288046*^9, 3.5532396988283873`*^9}, {3.553240720963859*^9, 
  3.553240721408107*^9}}],

Cell[BoxData[
 GraphicsBox[{{}, {}, 
   {Hue[0.67, 0.6, 0.6], LineBox[CompressedData["
1:eJwtmnc411/Yx+09ihLKTwlFmaFE7k/JKkqorLIjisxkJiMZWSErq+yV7OR8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     "]]}, 
   {Hue[0.9060679774997897, 0.6, 0.6], LineBox[CompressedData["
1:eJwtmHk01V/UhxFKxtxUkqmBDJkivyL7KkNlSBIlUahMCUWmUKQSDUQTFUpE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     "]]}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->True,
  AxesOrigin->{0, 0},
  PlotRange->{All, All},
  PlotRangeClipping->True,
  PlotRangePadding->{Automatic, Automatic}]], "Output",
 CellChangeTimes->{{3.553239256081114*^9, 3.55323933805971*^9}, {
   3.553239378397801*^9, 3.553239391443239*^9}, 3.553239700568323*^9, 
   3.553240725429894*^9},
 ImageCache->GraphicsData["CompressedBitmap", "\<\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\
\>"]]
}, Open  ]],

Cell["So it does indeed. ", "Text",
 CellChangeTimes->{{3.553239708440275*^9, 3.553239714727139*^9}}],

Cell[TextData[{
 "Now we take Bethe roots suffiicently far from the [-2g,2g] strip, so ",
 StyleBox["Mathematica",
  FontSlant->"Italic"],
 " implementation of Log has no branching"
}], "Text",
 CellChangeTimes->{{3.5532401237587767`*^9, 3.55324016520402*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"With", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"uu", "=", 
      RowBox[{
       RowBox[{"Random", "[", "]"}], "+", "\[ImaginaryI]", " ", "+", 
       RowBox[{"\[ImaginaryI]", " ", 
        RowBox[{"Random", "[", "]"}]}]}]}], ",", 
     RowBox[{"gg", "=", 
      RowBox[{"1", "+", 
       FractionBox[
        RowBox[{"Random", "[", "]"}], "5"]}]}], ",", 
     RowBox[{"v0", "=", 
      RowBox[{"4", "+", 
       RowBox[{"Random", "[", "]"}]}]}]}], "}"}], ",", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{
          FractionBox[
           RowBox[{"Log", "[", 
            RowBox[{
             FractionBox[
              RowBox[{
               StyleBox["Bm",
                FontColor->RGBColor[0, 0.6, 0]], " ", 
               StyleBox["Rp",
                FontColor->RGBColor[0, 0.6, 0]]}], 
              RowBox[{
               StyleBox["Bp",
                FontColor->RGBColor[0, 0.6, 0]], " ", 
               StyleBox["Rm",
                FontColor->RGBColor[0, 0.6, 0]]}]], "/", 
             RowBox[{"(", 
              FractionBox[
               SuperscriptBox["Q", "+"], 
               SuperscriptBox["Q", "-"]], ")"}]}], "]"}], 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"-", 
              FractionBox["1", "xh"]}], "+", "xh"}], ")"}]], "/.", 
          "subFunsBethe"}], "/.", "subJuk"}], "/.", 
        RowBox[{"u", "\[Rule]", "uu"}]}], "/.", 
       RowBox[{
        SubscriptBox["v", "0"], "\[Rule]", "v0"}]}], "/.", 
      RowBox[{"g", "\[Rule]", "gg"}]}], ")"}], "+", 
    RowBox[{"NIntegrate", "[", 
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{
          RowBox[{
           RowBox[{"+", 
            FractionBox["1", 
             RowBox[{
              RowBox[{"-", "2"}], "\[Pi]", " ", "\[ImaginaryI]"}]]}], 
           FractionBox["1", 
            RowBox[{"u", "-", "v"}]], 
           RowBox[{"(", 
            RowBox[{
             RowBox[{
              RowBox[{
               RowBox[{"(", 
                FractionBox[
                 RowBox[{"Log", "[", 
                  FractionBox[
                   SuperscriptBox["Q", "+"], 
                   SuperscriptBox["Q", "-"]], "]"}], 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"-", 
                    FractionBox["1", "xh"]}], "+", "xh"}], ")"}]], ")"}], "/.",
                "subFunsBethe"}], "/.", "subJuk"}], "/.", 
             RowBox[{"u", "\[Rule]", "v"}]}], ")"}]}], "/.", 
          RowBox[{
           SubscriptBox["v", "0"], "\[Rule]", "v0"}]}], "/.", 
         RowBox[{"u", "\[Rule]", "uu"}]}], "/.", 
        RowBox[{"g", "\[Rule]", "gg"}]}], "//", "Evaluate"}], ",", 
      RowBox[{"{", 
       RowBox[{"v", ",", 
        RowBox[{
         RowBox[{"-", "25"}], "/", "10"}], ",", 
        FractionBox["\[ImaginaryI]", "3"], ",", 
        RowBox[{"25", "/", "10"}], ",", 
        FractionBox[
         RowBox[{"-", "\[ImaginaryI]"}], "3"], ",", 
        FractionBox[
         RowBox[{"-", "25"}], "10"]}], "}"}]}], "]"}]}]}], "]"}]], "Input",
 CellChangeTimes->{{3.5532401766391363`*^9, 3.553240345593059*^9}, {
  3.5532403955756407`*^9, 3.553240508042471*^9}, {3.553240538307201*^9, 
  3.553240592791574*^9}, {3.55324063318766*^9, 3.5532407134561853`*^9}, {
  3.553240758920465*^9, 3.553240802544826*^9}, {3.553276555054475*^9, 
  3.553276555340274*^9}, {3.553276714875437*^9, 3.5532767150834513`*^9}}],

Cell[BoxData[
 RowBox[{"3.545688048722795`*^-13", "+", 
  RowBox[{"1.3759826611448034`*^-14", " ", "\[ImaginaryI]"}]}]], "Output",
 CellChangeTimes->{{3.55324044122712*^9, 3.553240508495208*^9}, {
   3.553240540083309*^9, 3.55324066132021*^9}, {3.553240693731997*^9, 
   3.5532408034244967`*^9}, 3.553276466451873*^9, {3.553276556186144*^9, 
   3.553276559226898*^9}, 3.553276715447908*^9}]
}, Open  ]],

Cell["\<\
Now we divide by the asymptotic solution. Define for short\
\>", "Text",
 CellChangeTimes->{{3.553276751610145*^9, 3.553276787501055*^9}, {
  3.5689638969902477`*^9, 3.5689638971576366`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Log", "[", 
   RowBox[{
    FractionBox[
     SubscriptBox[
      StyleBox["\[GothicCapitalT]",
       FontColor->RGBColor[0.54, 0.35, 0.15]], 
      RowBox[{"1", ",", "0"}]], 
     SubsuperscriptBox[
      StyleBox["\[GothicCapitalT]",
       FontColor->RGBColor[0.54, 0.35, 0.15]], 
      RowBox[{"0", ",", "0"}], "+"]], "/", 
    SubscriptBox[
     RowBox[{"(", 
      FractionBox[
       SubscriptBox[
        StyleBox["\[GothicCapitalT]",
         FontColor->RGBColor[0.54, 0.35, 0.15]], 
        RowBox[{"1", ",", "0"}]], 
       SubsuperscriptBox[
        StyleBox["\[GothicCapitalT]",
         FontColor->RGBColor[0.54, 0.35, 0.15]], 
        RowBox[{"0", ",", "0"}], "+"]], ")"}], "asym"]}], "]"}], "=", 
  "H"}]], "Input",
 CellChangeTimes->{{3.553276788642643*^9, 3.553276820380064*^9}, {
  3.55327691041538*^9, 3.553276910616242*^9}}],

Cell["\<\
In the next section an explicit weak coupling expansion of this quantity will \
be given. So far we note its main parity property\
\>", "Text",
 CellChangeTimes->{{3.553276823187901*^9, 3.553276864450111*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   OverscriptBox["H", "_"], "[", "u", "]"}], "=", 
  RowBox[{"H", "[", 
   RowBox[{"-", "u"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.553276853731751*^9, 3.553276867308921*^9}, {
  3.553276899134571*^9, 3.553276900651854*^9}}],

Cell[TextData[{
 Cell[BoxData[
  FormBox[
   OverscriptBox["H", "_"], TraditionalForm]],
  FormatType->"TraditionalForm"],
 " is a function analytic for certain in the band from the real axis and up \
to ",
 Cell[BoxData[
  FormBox[
   RowBox[{"\[DoubleStruckCapitalR]", "+", "\[ImaginaryI]"}], 
   TraditionalForm]],
  FormatType->"TraditionalForm"],
 ". ",
 Cell[BoxData[
  FormBox["H", TraditionalForm]],
  FormatType->"TraditionalForm"],
 " is analytic from \[DoubleStruckCapitalR]-\[ImaginaryI] to \
\[DoubleStruckCapitalR]."
}], "Text",
 CellChangeTimes->{{3.553276920472293*^9, 3.5532769385849752`*^9}, {
  3.553276988008909*^9, 3.553277024022097*^9}}],

Cell["\<\
Since H is a ratio of expression over its asymptotic expression, we do not \
have problems with branches of the logarithms. In terms of H we have an \
equation:\
\>", "Text",
 CellChangeTimes->{{3.553276872570017*^9, 3.553276961470869*^9}, {
  3.553277028800522*^9, 3.553277029334053*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Log", "[", " ", 
   FractionBox[
    RowBox[{
     SubscriptBox[
      StyleBox["Y",
       FontColor->RGBColor[0, 0, 0.8]], 
      RowBox[{"1", ",", "1"}]], " ", 
     SubscriptBox[
      StyleBox["Y",
       FontColor->RGBColor[0, 0, 0.8]], 
      RowBox[{"2", ",", "2"}]]}], 
    SubscriptBox[
     RowBox[{"(", 
      RowBox[{
       SubscriptBox["Y", 
        RowBox[{"1", ",", "1"}]], 
       SubscriptBox["Y", 
        RowBox[{"2", ",", "2"}]]}], ")"}], "asym"]], "]"}], "\[Equal]", 
  RowBox[{
   OverscriptBox["H", "_"], "-", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      OverscriptBox[
       StyleBox["x",
        FontColor->RGBColor[0, 0.6, 0]], 
       StyleBox["^",
        FontColor->RGBColor[0, 0.6, 0]]], "-", 
      FractionBox["1", 
       OverscriptBox[
        StyleBox["x",
         FontColor->RGBColor[0, 0.6, 0]], 
        StyleBox["^",
         FontColor->RGBColor[0, 0.6, 0]]]]}], ")"}], 
    RowBox[{
     SubsuperscriptBox["\[Integral]", 
      RowBox[{"-", "\[Infinity]"}], 
      RowBox[{"+", "\[Infinity]"}]], 
     RowBox[{
      FractionBox["dv", 
       RowBox[{
        RowBox[{"-", "2"}], "\[Pi]", " ", "\[ImaginaryI]"}]], 
      FractionBox["1", 
       RowBox[{"u", "-", "v"}]], 
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         FractionBox["1", 
          RowBox[{
           RowBox[{
            OverscriptBox[
             StyleBox["x",
              FontColor->RGBColor[0, 0.6, 0]], 
             StyleBox["^",
              FontColor->RGBColor[0, 0.6, 0]]], "[", 
            RowBox[{"v", "+", 
             RowBox[{"\[ImaginaryI]", " ", "0"}]}], "]"}], "-", 
           FractionBox["1", 
            RowBox[{
             OverscriptBox[
              StyleBox["x",
               FontColor->RGBColor[0, 0.6, 0]], 
              StyleBox["^",
               FontColor->RGBColor[0, 0.6, 0]]], "[", 
             RowBox[{"v", "+", 
              RowBox[{"\[ImaginaryI]", " ", "0"}]}], "]"}]]}]], 
         RowBox[{
          OverscriptBox["H", "_"], "[", 
          RowBox[{"v", "+", 
           RowBox[{"\[ImaginaryI]", " ", "0"}]}], "]"}]}], "+", 
        RowBox[{
         FractionBox["1", 
          RowBox[{
           RowBox[{
            OverscriptBox[
             StyleBox["x",
              FontColor->RGBColor[0, 0.6, 0]], 
             StyleBox["^",
              FontColor->RGBColor[0, 0.6, 0]]], "[", 
            RowBox[{"v", "-", 
             RowBox[{"\[ImaginaryI]", " ", "0"}]}], "]"}], "-", 
           FractionBox["1", 
            RowBox[{
             OverscriptBox[
              StyleBox["x",
               FontColor->RGBColor[0, 0.6, 0]], 
              StyleBox["^",
               FontColor->RGBColor[0, 0.6, 0]]], "[", 
             RowBox[{"v", "-", 
              RowBox[{"\[ImaginaryI]", " ", "0"}]}], "]"}]]}]], 
         RowBox[{"H", "[", 
          RowBox[{"v", "-", 
           RowBox[{"\[ImaginaryI]", " ", "0"}]}], "]"}]}]}], 
       ")"}]}]}]}]}]}]], "Input",
 CellChangeTimes->{{3.55327677118294*^9, 3.5532767827944307`*^9}, {
  3.553276964695347*^9, 3.553276978010294*^9}, {3.553277069062745*^9, 
  3.5532771608290577`*^9}, {3.5532773407853813`*^9, 3.5532773410890007`*^9}}],

Cell["And it is useful to use", "Text",
 CellChangeTimes->{{3.553277434862742*^9, 3.553277439668838*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{
    RowBox[{
     FractionBox["u", "g"], 
     SqrtBox[
      RowBox[{"1", "-", 
       FractionBox[
        RowBox[{"4", 
         SuperscriptBox["g", "2"]}], 
        SuperscriptBox["u", "2"]]}]]}], "==", 
    RowBox[{"xh", "-", 
     FractionBox["1", "xh"]}]}], ",", 
   RowBox[{
    RowBox[{"2", "\[ImaginaryI]", 
     SqrtBox[
      RowBox[{"1", "-", 
       FractionBox[
        SuperscriptBox["u", "2"], 
        RowBox[{"4", 
         SuperscriptBox["g", "2"]}]]}]]}], "\[Equal]", 
    RowBox[{"x", "-", 
     FractionBox["1", "x"]}]}]}], "}"}]], "Input",
 CellChangeTimes->{{3.553277444586698*^9, 3.55327744784196*^9}, {
  3.5532816764752893`*^9, 3.553281732656057*^9}}],

Cell[TextData[{
 "Expression for ",
 Cell[BoxData[
  RowBox[{"Log", "[", 
   FractionBox[
    RowBox[{
     SubscriptBox["Y", 
      RowBox[{"1", ",", "1"}]], " ", 
     SubscriptBox["Y", 
      RowBox[{"2", ",", "2"}]]}], 
    SubscriptBox[
     RowBox[{
      SubscriptBox["Y", 
       RowBox[{"1", ",", "1"}]], " ", 
      SubscriptBox["Y", 
       RowBox[{"2", ",", "2"}]]}], "asym"]], "]"}]]],
 " is defined in the UHP. There are three entries in the  FiNLIE equations \
where we have to compute it: its asymptotic at infinity, which produces \
energy, its value for real u in the double scaling regime (this is to compute \
corrections to \[Rho] and ",
 Cell[BoxData[
  FormBox[
   SubscriptBox["\[Rho]", "2"], TraditionalForm]]],
 "). And finally ",
 Cell[BoxData[
  RowBox[{
   RowBox[{"(", 
    RowBox[{"D", "-", 
     SuperscriptBox["D", 
      RowBox[{"-", "1"}]]}], ")"}], 
   RowBox[{"Log", "[", 
    FractionBox[
     RowBox[{
      SubscriptBox["Y", 
       RowBox[{"1", ",", "1"}]], " ", 
      SubscriptBox["Y", 
       RowBox[{"2", ",", "2"}]]}], 
     SubscriptBox[
      RowBox[{
       SubscriptBox["Y", 
        RowBox[{"1", ",", "1"}]], " ", 
       SubscriptBox["Y", 
        RowBox[{"2", ",", "2"}]]}], "asym"]], "]"}]}]]],
 " at the Bethe roots (this appears in the correction to the Bethe equation"
}], "Text",
 CellChangeTimes->{{3.553277458359483*^9, 3.553277590920471*^9}, {
  3.5689639293522797`*^9, 3.568963952014236*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 " ",
 Cell[BoxData[
  FormBox[
   RowBox[{
    SubscriptBox["E", "wrap"], "==", 
    RowBox[{"2", "\[ImaginaryI]", 
     RowBox[{
      SubsuperscriptBox["\[Integral]", 
       RowBox[{
        RowBox[{"-", "\[Infinity]"}], "-", 
        RowBox[{"\[ImaginaryI]", " ", "0"}]}], 
       RowBox[{
        RowBox[{"+", "\[Infinity]"}], "-", 
        RowBox[{"\[ImaginaryI]", " ", "0"}]}]], 
      RowBox[{
       FractionBox["dv", 
        RowBox[{
         RowBox[{"-", "2"}], "\[Pi]", " ", "\[ImaginaryI]"}]], 
       FractionBox["1", 
        SqrtBox[
         RowBox[{"1", "-", 
          FractionBox[
           RowBox[{"4", 
            SuperscriptBox["g", "2"]}], 
           SuperscriptBox["v", "2"]]}]]], "H"}]}]}]}], TraditionalForm]]]
}], "Subsubsection",
 CellChangeTimes->{{3.5532776094240723`*^9, 3.553277622999505*^9}, {
   3.553281474352312*^9, 3.553281494736189*^9}, 3.553313656345078*^9}],

Cell["One benfits from the formula", "Text",
 CellChangeTimes->{{3.553277791111128*^9, 3.5532778042081757`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Log", "[", " ", 
   FractionBox[
    RowBox[{
     SubscriptBox[
      StyleBox["Y",
       FontColor->RGBColor[0, 0, 0.8]], 
      RowBox[{"1", ",", "1"}]], " ", 
     SubscriptBox[
      StyleBox["Y",
       FontColor->RGBColor[0, 0, 0.8]], 
      RowBox[{"2", ",", "2"}]]}], 
    SubscriptBox[
     RowBox[{"(", 
      RowBox[{
       SubscriptBox["Y", 
        RowBox[{"1", ",", "1"}]], 
       SubscriptBox["Y", 
        RowBox[{"2", ",", "2"}]]}], ")"}], "asym"]], "]"}], "\[Equal]", 
  RowBox[{
   FractionBox["\[ImaginaryI]", "u"], 
   RowBox[{"(", 
    RowBox[{"E", "-", 
     SubscriptBox["E", "as"]}], ")"}]}]}]], "Input",
 CellChangeTimes->{{3.553277812038664*^9, 3.553277820017641*^9}}],

Cell[TextData[{
 "We remind that ",
 Cell[BoxData[
  FormBox[
   RowBox[{
    SubscriptBox["E", "as"], "="}], TraditionalForm]],
  FormatType->"TraditionalForm"]
}], "Text",
 CellChangeTimes->{{3.553277821328298*^9, 3.5532778271839457`*^9}, {
  3.553277958427083*^9, 3.5532779595144653`*^9}}],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"Series", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"Log", "[", 
       RowBox[{"Y11Y22", "/.", "largevolume"}], "]"}], "/.", "subFunsBethe"}],
      ",", 
     RowBox[{"{", 
      RowBox[{"x", ",", "\[Infinity]", ",", "1"}], "}"}]}], "]"}], "//", 
   "Normal"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Collect", "[", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         RowBox[{
          FractionBox["%", "\[ImaginaryI]"], "/.", 
          RowBox[{"x", "\[Rule]", 
           FractionBox["u", "g"]}]}], "/.", 
         RowBox[{"(", 
          RowBox[{
           SuperscriptBox[
            RowBox[{"y$h", "[", 
             RowBox[{"r_:", "0"}], "]"}], "a_"], "\[RuleDelayed]", 
           RowBox[{
            FractionBox[
             RowBox[{"u", "+", 
              FractionBox[
               RowBox[{"\[ImaginaryI]", " ", "r"}], "2"]}], "g"], "-", 
            FractionBox["1", 
             SuperscriptBox[
              RowBox[{"y$h", "[", "r", "]"}], "a"]]}]}], ")"}]}], "//", 
        "Simplify"}], ")"}], "/.", 
      RowBox[{"(", 
       RowBox[{
        SuperscriptBox[
         RowBox[{"y$h", "[", 
          RowBox[{"r_:", "0"}], "]"}], "a_."], "\[RuleDelayed]", 
        RowBox[{
         FractionBox[
          RowBox[{"u", "+", 
           FractionBox[
            RowBox[{"\[ImaginaryI]", " ", "r"}], "2"]}], "g"], "-", 
         FractionBox["1", 
          SuperscriptBox[
           RowBox[{"y$h", "[", "r", "]"}], "a"]]}]}], ")"}]}], "//", 
     "Simplify"}], ",", 
    RowBox[{"{", 
     RowBox[{"u", ",", "g"}], "}"}]}], "]"}], "/.", 
  RowBox[{"u", "\[Rule]", "1"}]}]}], "Input",
 CellChangeTimes->{{3.5532778335601273`*^9, 3.553278040701251*^9}}],

Cell[BoxData[
 RowBox[{"2", "-", 
  RowBox[{"4", " ", "\[ImaginaryI]", " ", "g", " ", 
   RowBox[{"(", 
    RowBox[{
     FractionBox["1", 
      SuperscriptBox[
       OverscriptBox[
        StyleBox["y",
         FontColor->RGBColor[0, 0.6, 0]], 
        StyleBox["^",
         FontColor->RGBColor[0, 0.6, 0]]], "-"]], "-", 
     FractionBox["1", 
      SuperscriptBox[
       OverscriptBox[
        StyleBox["y",
         FontColor->RGBColor[0, 0.6, 0]], 
        StyleBox["^",
         FontColor->RGBColor[0, 0.6, 0]]], "+"]]}], ")"}]}]}]], "Output",
 CellChangeTimes->{{3.553277999991087*^9, 3.553278040990994*^9}}]
}, Open  ]],

Cell[TextData[{
 "So ",
 Cell[BoxData[
  FormBox[
   RowBox[{
    SubscriptBox["E", "as"], "==", 
    RowBox[{"2", "-", 
     RowBox[{"4", " ", "\[ImaginaryI]", " ", "g", " ", 
      RowBox[{"(", 
       RowBox[{
        FractionBox["1", 
         SuperscriptBox[
          OverscriptBox[
           StyleBox["y",
            FontColor->RGBColor[0, 0.6, 0]], 
           StyleBox["^",
            FontColor->RGBColor[0, 0.6, 0]]], "-"]], "-", 
        FractionBox["1", 
         SuperscriptBox[
          OverscriptBox[
           StyleBox["y",
            FontColor->RGBColor[0, 0.6, 0]], 
           StyleBox["^",
            FontColor->RGBColor[0, 0.6, 0]]], "+"]]}], ")"}]}]}]}], 
   TraditionalForm]],
  FormatType->"TraditionalForm"],
 ", so this is as expression for the energy in the asymptotic Bethe Ansatz, \
but position of the Bethe roots is exact."
}], "Text",
 CellChangeTimes->{{3.553278046407305*^9, 3.5532780986679363`*^9}}],

Cell[TextData[{
 "It follows from the arguments in the FiNLIE paper that ",
 Cell[BoxData[
  OverscriptBox["H", "_"]],
  CellChangeTimes->{{3.55327677118294*^9, 3.5532767827944307`*^9}, {
   3.553276964695347*^9, 3.553276978010294*^9}, {3.553277069062745*^9, 
   3.5532771608290577`*^9}, {3.5532773407853813`*^9, 3.5532773410890007`*^9}}],
 " decreases faster than 1/u. We however will check this explicitly"
}], "Text",
 CellChangeTimes->{{3.553277738107435*^9, 3.5532777890163097`*^9}, {
  3.5532781088489513`*^9, 3.553278114019987*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Series", "[", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{
         FractionBox[
          RowBox[{
           RowBox[{
            FractionBox[
             SubscriptBox["T", 
              RowBox[{"1", ",", "0"}]], 
             SubsuperscriptBox["T", 
              RowBox[{"0", ",", "0"}], "-"]], "/.", "subTQ"}], "/.", 
           "subpqb"}], 
          RowBox[{
           SuperscriptBox["Q", "+"], "/", 
           SuperscriptBox["Q", "-"]}]], "/.", "subFunsBethe"}], "/.", 
        RowBox[{"leadweak", "[", "1", "]"}]}], "/.", 
       RowBox[{"Q$", "\[Rule]", "Q0$"}]}], "/.", "subQ0"}], "/.", 
     "subtopowerbasis"}], "/.", "subtoPolyGammas"}], ",", 
   RowBox[{"{", 
    RowBox[{"u", ",", "\[Infinity]", ",", "9"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.553278117474041*^9, 3.5532783467640657`*^9}, {
  3.5532784788391647`*^9, 3.553278492742032*^9}}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"1", "-", 
   FractionBox[
    RowBox[{"2", " ", "\[ImaginaryI]", " ", 
     SuperscriptBox["g", "8"]}], 
    RowBox[{"15", " ", 
     SuperscriptBox["u", "9"]}]], "+", 
   InterpretationBox[
    SuperscriptBox[
     RowBox[{"O", "[", 
      FractionBox["1", "u"], "]"}], "10"],
    SeriesData[$CellContext`u, 
     DirectedInfinity[1], {}, 0, 10, 1],
    Editable->False]}],
  SeriesData[$CellContext`u, 
   DirectedInfinity[1], {1, 0, 0, 0, 0, 0, 0, 0, 0, Complex[0, 
      Rational[-2, 15]] $CellContext`g^8}, 0, 10, 1],
  Editable->False]], "Output",
 CellChangeTimes->{{3.553278174307727*^9, 3.55327834986705*^9}, {
  3.553278482567556*^9, 3.553278493459529*^9}}]
}, Open  ]],

Cell["\<\
Such high cancellation may be a bit due to leading order. But even in general:\
\>", "Text",
 CellChangeTimes->{{3.5532784597517223`*^9, 3.553278496748662*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      SubscriptBox["q", 
       RowBox[{"3", ",", "4"}]], ",", 
      SubscriptBox["q", 
       RowBox[{"1", ",", "3"}]], ",", 
      SubscriptBox["q", 
       RowBox[{"1", ",", "4"}]], ",", 
      SubscriptBox["q", 
       RowBox[{"2", ",", "4"}]]}], "}"}], "/.", 
    RowBox[{"leadweak", "[", "1", "]"}]}], "/.", 
   RowBox[{
    SubsuperscriptBox["\[Eta]", "a__", 
     RowBox[{"[", 
      RowBox[{"r_:", "0"}], "]"}]], "\[RuleDelayed]", 
    RowBox[{
     RowBox[{"Random", "[", "]"}], 
     SuperscriptBox["u", 
      RowBox[{"-", 
       RowBox[{"Plus", "[", "a", "]"}]}]]}]}]}], "/.", "subQ0"}]], "Input",
 CellChangeTimes->{{3.553278367861723*^9, 3.553278441179356*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{
    SuperscriptBox["g", "8"], " ", 
    RowBox[{"(", 
     RowBox[{"108", "-", 
      FractionBox[
       RowBox[{"0.`", "\[VeryThinSpace]", "+", 
        RowBox[{"5.560652327722657`", " ", "\[ImaginaryI]"}]}], 
       SuperscriptBox["u", "3"]], "-", 
      FractionBox[
       RowBox[{"0.`", "\[VeryThinSpace]", "+", 
        RowBox[{"39.15055887682957`", " ", "\[ImaginaryI]"}]}], "u"], "+", 
      FractionBox[
       RowBox[{"42.344090024479`", " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"-", 
           FractionBox["1", "12"]}], "+", 
          SuperscriptBox["u", "2"]}], ")"}]}], 
       SuperscriptBox["u", "6"]], "-", 
      FractionBox[
       RowBox[{"118.65488627849257`", " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"-", 
           FractionBox["1", "12"]}], "+", 
          SuperscriptBox["u", "2"]}], ")"}]}], 
       SuperscriptBox["u", "4"]]}], ")"}]}], ",", 
   RowBox[{
    SuperscriptBox["g", "4"], " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       RowBox[{"-", "18"}], " ", "\[ImaginaryI]", " ", "u"}], "-", 
      FractionBox[
       RowBox[{"11.784775334097871`", " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"-", 
           FractionBox["1", "12"]}], "+", 
          SuperscriptBox["u", "2"]}], ")"}]}], 
       SuperscriptBox["u", "2"]]}], ")"}]}], ",", 
   RowBox[{
    SuperscriptBox["g", "4"], " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"-", "3"}], "+", 
      FractionBox[
       RowBox[{
        RowBox[{"(", 
         RowBox[{"0.`", "\[VeryThinSpace]", "+", 
          RowBox[{"3.4403342875515954`", " ", "\[ImaginaryI]"}]}], ")"}], " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"-", 
           FractionBox["1", "12"]}], "+", 
          SuperscriptBox["u", "2"]}], ")"}]}], 
       SuperscriptBox["u", "3"]]}], ")"}]}], ",", 
   RowBox[{
    SuperscriptBox["g", "4"], " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"6", " ", "\[ImaginaryI]", " ", "u"}], "+", 
      FractionBox[
       RowBox[{"1.1384135129914879`", " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"-", 
           FractionBox["1", "12"]}], "+", 
          SuperscriptBox["u", "2"]}], ")"}]}], 
       SuperscriptBox["u", "4"]], "+", 
      FractionBox[
       RowBox[{"3.5717475276731854`", " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"-", 
           FractionBox["1", "12"]}], "+", 
          SuperscriptBox["u", "2"]}], ")"}]}], 
       SuperscriptBox["u", "2"]]}], ")"}]}]}], "}"}]], "Output",
 CellChangeTimes->{
  3.553278375053619*^9, {3.553278412488635*^9, 3.5532784420683537`*^9}}]
}, Open  ]],

Cell[TextData[{
 "We see that the best divergency one can get from subleading terms is ",
 Cell[BoxData[
  FormBox[
   SuperscriptBox["u", "2"], TraditionalForm]],
  FormatType->"TraditionalForm"],
 ", whereas leading  ",
 Cell[BoxData[
  FormBox[
   RowBox[{" ", 
    SuperscriptBox["u", "4"]}], TraditionalForm]],
  FormatType->"TraditionalForm"],
 ". Therefore dividing by leading produces at least ",
 Cell[BoxData[
  FormBox[
   RowBox[{"1", "/", 
    SuperscriptBox["u", "2"]}], TraditionalForm]],
  FormatType->"TraditionalForm"],
 " at infinity. Therefore only an integral will contribute to the energy."
}], "Text",
 CellChangeTimes->{{3.553278498972625*^9, 3.553278576715516*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{
      FractionBox["\[ImaginaryI]", "u"], 
      RowBox[{"(", 
       RowBox[{"E", "-", 
        SubscriptBox["E", "as"]}], ")"}]}], "+"}], "..."}], "."}], "==", 
  RowBox[{
   RowBox[{"-", 
    FractionBox["u", "g"]}], 
   SqrtBox[
    RowBox[{"1", "-", 
     FractionBox[
      RowBox[{"4", 
       SuperscriptBox["g", "2"]}], 
      SuperscriptBox["u", "2"]]}]], 
   RowBox[{
    SubsuperscriptBox["\[Integral]", 
     RowBox[{"-", "\[Infinity]"}], 
     RowBox[{"+", "\[Infinity]"}]], 
    RowBox[{
     FractionBox["dv", 
      RowBox[{
       RowBox[{"-", "2"}], "\[Pi]", " ", "\[ImaginaryI]"}]], 
     FractionBox["1", 
      RowBox[{"u", "-", "v"}]], 
     RowBox[{"(", 
      RowBox[{
       SuperscriptBox[
        RowBox[{"(", 
         RowBox[{
          FractionBox["1", 
           RowBox[{
            FractionBox["v", "g"], 
            SqrtBox[
             RowBox[{"1", "-", 
              FractionBox[
               RowBox[{"4", 
                SuperscriptBox["g", "2"]}], 
               SuperscriptBox["v", "2"]]}]]}]], 
          OverscriptBox["H", "_"]}], ")"}], 
        RowBox[{"[", 
         RowBox[{"+", "0"}], "]"}]], "+", 
       SuperscriptBox[
        RowBox[{"(", 
         RowBox[{
          FractionBox["1", 
           RowBox[{
            FractionBox["v", "g"], 
            SqrtBox[
             RowBox[{"1", "-", 
              FractionBox[
               RowBox[{"4", 
                SuperscriptBox["g", "2"]}], 
               SuperscriptBox["v", "2"]]}]]}]], "H"}], ")"}], 
        RowBox[{"[", 
         RowBox[{"-", "0"}], "]"}]]}], ")"}]}]}]}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   FractionBox["\[ImaginaryI]", "u"], 
   RowBox[{"(", 
    RowBox[{"E", "-", 
     SubscriptBox["E", "as"]}], ")"}]}], "==", 
  RowBox[{
   RowBox[{"-", 
    FractionBox["1", "u"]}], 
   RowBox[{
    SubsuperscriptBox["\[Integral]", 
     RowBox[{"-", "\[Infinity]"}], 
     RowBox[{"+", "\[Infinity]"}]], 
    RowBox[{
     FractionBox["dv", 
      RowBox[{
       RowBox[{"-", "2"}], "\[Pi]", " ", "\[ImaginaryI]"}]], 
     RowBox[{"(", 
      RowBox[{
       SuperscriptBox[
        RowBox[{"(", 
         RowBox[{
          FractionBox["1", 
           SqrtBox[
            RowBox[{"1", "-", 
             FractionBox[
              RowBox[{"4", 
               SuperscriptBox["g", "2"]}], 
              SuperscriptBox["v", "2"]]}]]], 
          OverscriptBox["H", "_"]}], ")"}], 
        RowBox[{"[", 
         RowBox[{"+", "0"}], "]"}]], "+", 
       SuperscriptBox[
        RowBox[{"(", 
         RowBox[{
          FractionBox["1", 
           SqrtBox[
            RowBox[{"1", "-", 
             FractionBox[
              RowBox[{"4", 
               SuperscriptBox["g", "2"]}], 
              SuperscriptBox["v", "2"]]}]]], "H"}], ")"}], 
        RowBox[{"[", 
         RowBox[{"-", "0"}], "]"}]]}], ")"}]}]}]}], "==", 
  RowBox[{
   RowBox[{"-", 
    FractionBox["2", "u"]}], 
   RowBox[{
    SubsuperscriptBox["\[Integral]", 
     RowBox[{
      RowBox[{"-", "\[Infinity]"}], "-", 
      RowBox[{"\[ImaginaryI]", " ", "0"}]}], 
     RowBox[{
      RowBox[{"+", "\[Infinity]"}], "-", 
      RowBox[{"\[ImaginaryI]", " ", "0"}]}]], 
    RowBox[{
     FractionBox["dv", 
      RowBox[{
       RowBox[{"-", "2"}], "\[Pi]", " ", "\[ImaginaryI]"}]], 
     FractionBox["1", 
      SqrtBox[
       RowBox[{"1", "-", 
        FractionBox[
         RowBox[{"4", 
          SuperscriptBox["g", "2"]}], 
         SuperscriptBox["v", "2"]]}]]], "H"}]}]}]}]}], "Input",
 CellChangeTimes->{{3.55327859071257*^9, 3.55327869617763*^9}, {
  3.553278801565753*^9, 3.553278902366559*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"E", "-", 
   SubscriptBox["E", "as"]}], "==", 
  RowBox[{"2", "\[ImaginaryI]", 
   RowBox[{
    SubsuperscriptBox["\[Integral]", 
     RowBox[{
      RowBox[{"-", "\[Infinity]"}], "-", 
      RowBox[{"\[ImaginaryI]", " ", "0"}]}], 
     RowBox[{
      RowBox[{"+", "\[Infinity]"}], "-", 
      RowBox[{"\[ImaginaryI]", " ", "0"}]}]], 
    RowBox[{
     FractionBox["dv", 
      RowBox[{
       RowBox[{"-", "2"}], "\[Pi]", " ", "\[ImaginaryI]"}]], 
     FractionBox["1", 
      SqrtBox[
       RowBox[{"1", "-", 
        FractionBox[
         RowBox[{"4", 
          SuperscriptBox["g", "2"]}], 
         SuperscriptBox["v", "2"]]}]]], "H"}]}]}]}]], "Input",
 CellChangeTimes->{{3.553278916728654*^9, 3.5532789479366817`*^9}, {
  3.553281421972426*^9, 3.5532814221648607`*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 "Y11Y22 in the double scaling ",
 Cell[BoxData[
  FormBox[
   RowBox[{
    RowBox[{"Log", "[", " ", 
     FractionBox[
      RowBox[{
       SubscriptBox[
        StyleBox["Y",
         FontColor->RGBColor[0, 0, 0.8]], 
        RowBox[{"1", ",", "1"}]], " ", 
       SubscriptBox[
        StyleBox["Y",
         FontColor->RGBColor[0, 0, 0.8]], 
        RowBox[{"2", ",", "2"}]]}], 
      SubscriptBox[
       RowBox[{"(", 
        RowBox[{
         SubscriptBox["Y", 
          RowBox[{"1", ",", "1"}]], 
         SubscriptBox["Y", 
          RowBox[{"2", ",", "2"}]]}], ")"}], "asym"]], "]"}], "==", 
    RowBox[{
     RowBox[{"-", "4"}], "\[ImaginaryI]", " ", "g", 
     SqrtBox[
      RowBox[{"1", "-", 
       SuperscriptBox["z", "2"]}]], 
     RowBox[{
      SubsuperscriptBox["\[Integral]", 
       RowBox[{
        RowBox[{"-", "\[Infinity]"}], "-", 
        RowBox[{"\[ImaginaryI]", " ", "0"}]}], 
       RowBox[{
        RowBox[{"+", "\[Infinity]"}], "-", 
        RowBox[{"\[ImaginaryI]", " ", "0"}]}]], 
      RowBox[{
       FractionBox["dv", 
        RowBox[{
         RowBox[{"-", "2"}], "\[Pi]", " ", "\[ImaginaryI]"}]], 
       FractionBox["1", 
        RowBox[{
         RowBox[{"4", 
          SuperscriptBox["g", "2"], 
          SuperscriptBox["z", "2"]}], "-", 
         SuperscriptBox["v", "2"]}]], 
       FractionBox["H", 
        SqrtBox[
         RowBox[{"1", "-", 
          FractionBox[
           RowBox[{"4", 
            SuperscriptBox["g", "2"]}], 
           SuperscriptBox["v", "2"]]}]]]}]}]}]}], TraditionalForm]]]
}], "Subsubsection",
 CellChangeTimes->{{3.5532776094240723`*^9, 3.553277622999505*^9}, {
  3.553281474352312*^9, 3.553281514556501*^9}, {3.553282198940617*^9, 
  3.553282210160598*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Log", "[", " ", 
   FractionBox[
    RowBox[{
     SubscriptBox[
      StyleBox["Y",
       FontColor->RGBColor[0, 0, 0.8]], 
      RowBox[{"1", ",", "1"}]], " ", 
     SubscriptBox[
      StyleBox["Y",
       FontColor->RGBColor[0, 0, 0.8]], 
      RowBox[{"2", ",", "2"}]]}], 
    SubscriptBox[
     RowBox[{"(", 
      RowBox[{
       SubscriptBox["Y", 
        RowBox[{"1", ",", "1"}]], 
       SubscriptBox["Y", 
        RowBox[{"2", ",", "2"}]]}], ")"}], "asym"]], "]"}], "\[Equal]", 
  RowBox[{
   OverscriptBox["H", "_"], "-", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      OverscriptBox[
       StyleBox["x",
        FontColor->RGBColor[0, 0.6, 0]], 
       StyleBox["^",
        FontColor->RGBColor[0, 0.6, 0]]], "-", 
      FractionBox["1", 
       OverscriptBox[
        StyleBox["x",
         FontColor->RGBColor[0, 0.6, 0]], 
        StyleBox["^",
         FontColor->RGBColor[0, 0.6, 0]]]]}], ")"}], 
    RowBox[{
     SubsuperscriptBox["\[Integral]", 
      RowBox[{"-", "\[Infinity]"}], 
      RowBox[{"+", "\[Infinity]"}]], 
     RowBox[{
      FractionBox["dv", 
       RowBox[{
        RowBox[{"-", "2"}], "\[Pi]", " ", "\[ImaginaryI]"}]], 
      FractionBox["1", 
       RowBox[{"u", "-", "v"}]], 
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         FractionBox["1", 
          RowBox[{
           RowBox[{
            OverscriptBox[
             StyleBox["x",
              FontColor->RGBColor[0, 0.6, 0]], 
             StyleBox["^",
              FontColor->RGBColor[0, 0.6, 0]]], "[", 
            RowBox[{"v", "+", 
             RowBox[{"\[ImaginaryI]", " ", "0"}]}], "]"}], "-", 
           FractionBox["1", 
            RowBox[{
             OverscriptBox[
              StyleBox["x",
               FontColor->RGBColor[0, 0.6, 0]], 
              StyleBox["^",
               FontColor->RGBColor[0, 0.6, 0]]], "[", 
             RowBox[{"v", "+", 
              RowBox[{"\[ImaginaryI]", " ", "0"}]}], "]"}]]}]], 
         RowBox[{
          OverscriptBox["H", "_"], "[", 
          RowBox[{"v", "+", 
           RowBox[{"\[ImaginaryI]", " ", "0"}]}], "]"}]}], "+", 
        RowBox[{
         FractionBox["1", 
          RowBox[{
           RowBox[{
            OverscriptBox[
             StyleBox["x",
              FontColor->RGBColor[0, 0.6, 0]], 
             StyleBox["^",
              FontColor->RGBColor[0, 0.6, 0]]], "[", 
            RowBox[{"v", "-", 
             RowBox[{"\[ImaginaryI]", " ", "0"}]}], "]"}], "-", 
           FractionBox["1", 
            RowBox[{
             OverscriptBox[
              StyleBox["x",
               FontColor->RGBColor[0, 0.6, 0]], 
              StyleBox["^",
               FontColor->RGBColor[0, 0.6, 0]]], "[", 
             RowBox[{"v", "-", 
              RowBox[{"\[ImaginaryI]", " ", "0"}]}], "]"}]]}]], 
         RowBox[{"H", "[", 
          RowBox[{"v", "-", 
           RowBox[{"\[ImaginaryI]", " ", "0"}]}], "]"}]}]}], 
       ")"}]}]}]}]}]}]], "Input"],

Cell[TextData[{
 "Now we move u to the real axis, to the region  |u|<2g. A variable z=",
 Cell[BoxData[
  FormBox[
   FractionBox["u", 
    RowBox[{"2", "g"}]], TraditionalForm]],
  FormatType->"TraditionalForm"],
 " is used. In the double scaling regime ",
 Cell[BoxData[
  FormBox[
   RowBox[{"g", ",", 
    RowBox[{"u", "\[Rule]", "0"}]}], TraditionalForm]],
  FormatType->"TraditionalForm"],
 "  such that z is finite."
}], "Text",
 CellChangeTimes->{{3.538213187768412*^9, 3.538213228828576*^9}, 
   3.550204257829074*^9, {3.553281550380039*^9, 3.553281595265422*^9}}],

Cell[TextData[{
 "When moving to the real axis, we cross the pole ",
 Cell[BoxData[
  FormBox[
   RowBox[{"u", "=", 
    RowBox[{"v", "+", 
     RowBox[{"\[ImaginaryI]", " ", "0"}]}]}], TraditionalForm]],
  FormatType->"TraditionalForm"],
 ". The residue precisely Cancells ",
 Cell[BoxData[
  FormBox[
   OverscriptBox["H", "_"], TraditionalForm]],
  FormatType->"TraditionalForm"],
 " free term, so we get"
}], "Text",
 CellChangeTimes->{{3.553281604553032*^9, 3.553281647279561*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Log", "[", " ", 
   FractionBox[
    RowBox[{
     SubscriptBox[
      StyleBox["Y",
       FontColor->RGBColor[0, 0, 0.8]], 
      RowBox[{"1", ",", "1"}]], " ", 
     SubscriptBox[
      StyleBox["Y",
       FontColor->RGBColor[0, 0, 0.8]], 
      RowBox[{"2", ",", "2"}]]}], 
    SubscriptBox[
     RowBox[{"(", 
      RowBox[{
       SubscriptBox["Y", 
        RowBox[{"1", ",", "1"}]], 
       SubscriptBox["Y", 
        RowBox[{"2", ",", "2"}]]}], ")"}], "asym"]], "]"}], "\[Equal]", 
  RowBox[{
   RowBox[{
    RowBox[{"-", "2"}], "\[ImaginaryI]", 
    SqrtBox[
     RowBox[{"1", "-", 
      SuperscriptBox["z", "2"]}]], 
    RowBox[{
     SubsuperscriptBox["\[Integral]", 
      RowBox[{"-", "\[Infinity]"}], 
      RowBox[{"+", "\[Infinity]"}]], 
     RowBox[{
      FractionBox["dv", 
       RowBox[{
        RowBox[{"-", "2"}], "\[Pi]", " ", "\[ImaginaryI]"}]], 
      SuperscriptBox[
       RowBox[{"(", 
        RowBox[{
         FractionBox["1", 
          RowBox[{"u", "-", "v"}]], 
         FractionBox["1", 
          RowBox[{
           OverscriptBox[
            StyleBox["x",
             FontColor->RGBColor[0, 0.6, 0]], 
            StyleBox["^",
             FontColor->RGBColor[0, 0.6, 0]]], "-", 
           FractionBox["1", 
            OverscriptBox[
             StyleBox["x",
              FontColor->RGBColor[0, 0.6, 0]], 
             StyleBox["^",
              FontColor->RGBColor[0, 0.6, 0]]]]}]], 
         OverscriptBox["H", "_"]}], ")"}], 
       RowBox[{"[", 
        RowBox[{"+", "0"}], "]"}]]}]}]}], "+", 
   SuperscriptBox[
    RowBox[{"(", 
     RowBox[{
      FractionBox["1", 
       RowBox[{"u", "-", "v"}]], 
      FractionBox["1", 
       RowBox[{
        OverscriptBox[
         StyleBox["x",
          FontColor->RGBColor[0, 0.6, 0]], 
         StyleBox["^",
          FontColor->RGBColor[0, 0.6, 0]]], "-", 
        FractionBox["1", 
         OverscriptBox[
          StyleBox["x",
           FontColor->RGBColor[0, 0.6, 0]], 
          StyleBox["^",
           FontColor->RGBColor[0, 0.6, 0]]]]}]], "H"}], ")"}], 
    RowBox[{"[", 
     RowBox[{"-", "0"}], "]"}]]}], "\[Equal]", "\[IndentingNewLine]", "==", 
  RowBox[{
   RowBox[{"-", "2"}], "\[ImaginaryI]", 
   SqrtBox[
    RowBox[{"1", "-", 
     SuperscriptBox["z", "2"]}]], 
   RowBox[{
    SubsuperscriptBox["\[Integral]", 
     RowBox[{
      RowBox[{"-", "\[Infinity]"}], "-", 
      RowBox[{"\[ImaginaryI]", " ", "0"}]}], 
     RowBox[{
      RowBox[{"+", "\[Infinity]"}], "-", 
      RowBox[{"\[ImaginaryI]", " ", "0"}]}]], 
    RowBox[{
     FractionBox["dv", 
      RowBox[{
       RowBox[{"-", "2"}], "\[Pi]", " ", "\[ImaginaryI]"}]], 
     RowBox[{"(", 
      RowBox[{
       RowBox[{
        FractionBox["1", 
         RowBox[{"u", "+", "v"}]], 
        FractionBox["g", 
         RowBox[{"-", "v"}]]}], "+", 
       RowBox[{
        FractionBox["g", "v"], 
        FractionBox["1", 
         RowBox[{"u", "-", "v"}]]}]}], ")"}], 
     FractionBox["H", 
      SqrtBox[
       RowBox[{"1", "-", 
        FractionBox[
         RowBox[{"4", 
          SuperscriptBox["g", "2"]}], 
         SuperscriptBox["v", "2"]]}]]]}]}]}], "==", 
  RowBox[{
   RowBox[{"-", "4"}], "\[ImaginaryI]", " ", "g", 
   SqrtBox[
    RowBox[{"1", "-", 
     SuperscriptBox["z", "2"]}]], 
   RowBox[{
    SubsuperscriptBox["\[Integral]", 
     RowBox[{
      RowBox[{"-", "\[Infinity]"}], "-", 
      RowBox[{"\[ImaginaryI]", " ", "0"}]}], 
     RowBox[{
      RowBox[{"+", "\[Infinity]"}], "-", 
      RowBox[{"\[ImaginaryI]", " ", "0"}]}]], 
    RowBox[{
     FractionBox["dv", 
      RowBox[{
       RowBox[{"-", "2"}], "\[Pi]", " ", "\[ImaginaryI]"}]], 
     FractionBox["1", 
      RowBox[{
       RowBox[{"4", 
        SuperscriptBox["g", "2"], 
        SuperscriptBox["z", "2"]}], "-", 
       SuperscriptBox["v", "2"]}]], 
     FractionBox["H", 
      SqrtBox[
       RowBox[{"1", "-", 
        FractionBox[
         RowBox[{"4", 
          SuperscriptBox["g", "2"]}], 
         SuperscriptBox["v", "2"]]}]]]}]}]}]}]], "Input",
 CellChangeTimes->{{3.553281655116235*^9, 3.553281663436832*^9}, {
  3.5532818316123457`*^9, 3.553281844536529*^9}, {3.553281900352871*^9, 
  3.553281967253985*^9}, {3.553282046583412*^9, 3.553282108045973*^9}, {
  3.553282144630299*^9, 3.55328218446461*^9}}],

Cell[TextData[{
 "This is of course expanded in ",
 Cell[BoxData[
  FormBox[
   RowBox[{
    SuperscriptBox["g", "2"], 
    SuperscriptBox["z", "2"]}], TraditionalForm]],
  FormatType->"TraditionalForm"],
 " to get a proper at each order of perturbation theory. But in general the \
integral is written like this:"
}], "Text",
 CellChangeTimes->{{3.5532822205145683`*^9, 3.5532822555194693`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Log", "[", " ", 
   FractionBox[
    RowBox[{
     SubscriptBox[
      StyleBox["Y",
       FontColor->RGBColor[0, 0, 0.8]], 
      RowBox[{"1", ",", "1"}]], " ", 
     SubscriptBox[
      StyleBox["Y",
       FontColor->RGBColor[0, 0, 0.8]], 
      RowBox[{"2", ",", "2"}]]}], 
    SubscriptBox[
     RowBox[{"(", 
      RowBox[{
       SubscriptBox["Y", 
        RowBox[{"1", ",", "1"}]], 
       SubscriptBox["Y", 
        RowBox[{"2", ",", "2"}]]}], ")"}], "asym"]], "]"}], "\[Equal]", 
  RowBox[{
   RowBox[{"-", "4"}], "\[ImaginaryI]", " ", "g", 
   SqrtBox[
    RowBox[{"1", "-", 
     SuperscriptBox["z", "2"]}]], 
   RowBox[{
    SubsuperscriptBox["\[Integral]", 
     RowBox[{
      RowBox[{"-", "\[Infinity]"}], "-", 
      RowBox[{"\[ImaginaryI]", " ", "0"}]}], 
     RowBox[{
      RowBox[{"+", "\[Infinity]"}], "-", 
      RowBox[{"\[ImaginaryI]", " ", "0"}]}]], 
    RowBox[{
     FractionBox["dv", 
      RowBox[{
       RowBox[{"-", "2"}], "\[Pi]", " ", "\[ImaginaryI]"}]], 
     FractionBox["1", 
      RowBox[{
       RowBox[{"4", 
        SuperscriptBox["g", "2"], 
        SuperscriptBox["z", "2"]}], "-", 
       SuperscriptBox["v", "2"]}]], 
     FractionBox["H", 
      SqrtBox[
       RowBox[{"1", "-", 
        FractionBox[
         RowBox[{"4", 
          SuperscriptBox["g", "2"]}], 
         SuperscriptBox["v", "2"]]}]]]}]}]}]}]], "Input",
 CellChangeTimes->{3.553282263387369*^9}]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 "Ratio entering Bethe equations: ",
 Cell[BoxData[
  FormBox[
   RowBox[{
    RowBox[{
     RowBox[{"(", 
      RowBox[{"D", "-", 
       SuperscriptBox["D", 
        RowBox[{"-", "1"}]]}], ")"}], 
     RowBox[{"Log", "[", " ", 
      RowBox[{"(", 
       FractionBox[
        RowBox[{
         SubscriptBox[
          StyleBox["Y",
           FontColor->RGBColor[0, 0, 0.8]], 
          RowBox[{"1", ",", "1"}]], " ", 
         SubscriptBox[
          StyleBox["Y",
           FontColor->RGBColor[0, 0, 0.8]], 
          RowBox[{"2", ",", "2"}]]}], 
        SubscriptBox[
         RowBox[{"(", 
          RowBox[{
           SubscriptBox["Y", 
            RowBox[{"1", ",", "1"}]], 
           SubscriptBox["Y", 
            RowBox[{"2", ",", "2"}]]}], ")"}], "asym"]], ")"}], "]"}]}], 
    "\[Equal]", 
    RowBox[{
     RowBox[{
      RowBox[{"(", 
       RowBox[{"D", "-", 
        SuperscriptBox["D", 
         RowBox[{"-", "1"}]]}], ")"}], 
      RowBox[{"Log", "[", 
       FractionBox[
        SubscriptBox[
         StyleBox["\[GothicCapitalT]",
          FontColor->RGBColor[0.54, 0.35, 0.15]], 
         RowBox[{"1", ",", "0"}]], 
        SubscriptBox[
         RowBox[{
          StyleBox["(",
           FontColor->RGBColor[0.54, 0.35, 0.15]], 
          SubscriptBox[
           StyleBox["\[GothicCapitalT]",
            FontColor->RGBColor[0.54, 0.35, 0.15]], 
           RowBox[{"1", ",", "0"}]], ")"}], "asym"]], "]"}]}], "-", 
     RowBox[{"2", 
      RowBox[{
       SubsuperscriptBox["\[Integral]", 
        RowBox[{
         RowBox[{"-", "\[Infinity]"}], "-", 
         RowBox[{"\[ImaginaryI]", " ", "0"}]}], 
        RowBox[{
         RowBox[{"+", "\[Infinity]"}], "-", 
         RowBox[{"\[ImaginaryI]", " ", "0"}]}]], 
       RowBox[{
        FractionBox["dv", 
         RowBox[{
          RowBox[{"-", "2"}], "\[Pi]", " ", "\[ImaginaryI]"}]], 
        FractionBox[
         RowBox[{"Kr1", "+", 
          RowBox[{
           SuperscriptBox["v", "2"], "Kr2"}]}], 
         RowBox[{
          SuperscriptBox[
           StyleBox["Q",
            FontColor->RGBColor[0.8, 0, 0]], "-"], " ", 
          SuperscriptBox[
           StyleBox["Q",
            FontColor->RGBColor[0.8, 0, 0]], "+"]}]], 
        FractionBox["H", 
         SqrtBox[
          RowBox[{"1", "-", 
           FractionBox[
            RowBox[{"4", 
             SuperscriptBox["g", "2"]}], 
            SuperscriptBox["v", "2"]]}]]]}]}]}]}]}], TraditionalForm]]]
}], "Subsubsection",
 CellChangeTimes->{{3.5532776094240723`*^9, 3.553277622999505*^9}, {
  3.553281474352312*^9, 3.553281514556501*^9}, {3.553282198940617*^9, 
  3.553282210160598*^9}, {3.5532824072100067`*^9, 3.55328241520518*^9}, {
  3.553284550750433*^9, 3.55328456447476*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Log", "[", " ", 
   FractionBox[
    RowBox[{
     SubscriptBox[
      StyleBox["Y",
       FontColor->RGBColor[0, 0, 0.8]], 
      RowBox[{"1", ",", "1"}]], " ", 
     SubscriptBox[
      StyleBox["Y",
       FontColor->RGBColor[0, 0, 0.8]], 
      RowBox[{"2", ",", "2"}]]}], 
    SubscriptBox[
     RowBox[{"(", 
      RowBox[{
       SubscriptBox["Y", 
        RowBox[{"1", ",", "1"}]], 
       SubscriptBox["Y", 
        RowBox[{"2", ",", "2"}]]}], ")"}], "asym"]], "]"}], "\[Equal]", 
  RowBox[{
   OverscriptBox["H", "_"], "-", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      OverscriptBox[
       StyleBox["x",
        FontColor->RGBColor[0, 0.6, 0]], 
       StyleBox["^",
        FontColor->RGBColor[0, 0.6, 0]]], "-", 
      FractionBox["1", 
       OverscriptBox[
        StyleBox["x",
         FontColor->RGBColor[0, 0.6, 0]], 
        StyleBox["^",
         FontColor->RGBColor[0, 0.6, 0]]]]}], ")"}], 
    RowBox[{
     SubsuperscriptBox["\[Integral]", 
      RowBox[{"-", "\[Infinity]"}], 
      RowBox[{"+", "\[Infinity]"}]], 
     RowBox[{
      FractionBox["dv", 
       RowBox[{
        RowBox[{"-", "2"}], "\[Pi]", " ", "\[ImaginaryI]"}]], 
      FractionBox["1", 
       RowBox[{"u", "-", "v"}]], 
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         FractionBox["1", 
          RowBox[{
           RowBox[{
            OverscriptBox[
             StyleBox["x",
              FontColor->RGBColor[0, 0.6, 0]], 
             StyleBox["^",
              FontColor->RGBColor[0, 0.6, 0]]], "[", 
            RowBox[{"v", "+", 
             RowBox[{"\[ImaginaryI]", " ", "0"}]}], "]"}], "-", 
           FractionBox["1", 
            RowBox[{
             OverscriptBox[
              StyleBox["x",
               FontColor->RGBColor[0, 0.6, 0]], 
              StyleBox["^",
               FontColor->RGBColor[0, 0.6, 0]]], "[", 
             RowBox[{"v", "+", 
              RowBox[{"\[ImaginaryI]", " ", "0"}]}], "]"}]]}]], 
         RowBox[{
          OverscriptBox["H", "_"], "[", 
          RowBox[{"v", "+", 
           RowBox[{"\[ImaginaryI]", " ", "0"}]}], "]"}]}], "+", 
        RowBox[{
         FractionBox["1", 
          RowBox[{
           RowBox[{
            OverscriptBox[
             StyleBox["x",
              FontColor->RGBColor[0, 0.6, 0]], 
             StyleBox["^",
              FontColor->RGBColor[0, 0.6, 0]]], "[", 
            RowBox[{"v", "-", 
             RowBox[{"\[ImaginaryI]", " ", "0"}]}], "]"}], "-", 
           FractionBox["1", 
            RowBox[{
             OverscriptBox[
              StyleBox["x",
               FontColor->RGBColor[0, 0.6, 0]], 
              StyleBox["^",
               FontColor->RGBColor[0, 0.6, 0]]], "[", 
             RowBox[{"v", "-", 
              RowBox[{"\[ImaginaryI]", " ", "0"}]}], "]"}]]}]], 
         RowBox[{"H", "[", 
          RowBox[{"v", "-", 
           RowBox[{"\[ImaginaryI]", " ", "0"}]}], "]"}]}]}], 
       ")"}]}]}]}]}]}]], "Input"],

Cell["We should now compute", "Text",
 CellChangeTimes->{{3.55328242602705*^9, 3.553282429786147*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"(", 
   RowBox[{"D", "-", 
    SuperscriptBox["D", 
     RowBox[{"-", "1"}]]}], ")"}], 
  RowBox[{"Log", "[", " ", 
   FractionBox[
    RowBox[{
     SubscriptBox[
      StyleBox["Y",
       FontColor->RGBColor[0, 0, 0.8]], 
      RowBox[{"1", ",", "1"}]], " ", 
     SubscriptBox[
      StyleBox["Y",
       FontColor->RGBColor[0, 0, 0.8]], 
      RowBox[{"2", ",", "2"}]]}], 
    SubscriptBox[
     RowBox[{"(", 
      RowBox[{
       SubscriptBox["Y", 
        RowBox[{"1", ",", "1"}]], 
       SubscriptBox["Y", 
        RowBox[{"2", ",", "2"}]]}], ")"}], "asym"]], "]"}]}]], "Input",
 CellChangeTimes->{{3.553282435278867*^9, 3.5532824376833277`*^9}}],

Cell["\<\
For the first term we are using formula as it is. For the second term we \
should cross real axis, and also propertly deal with the Branch points of the \
Bethe roots. We have\
\>", "Text",
 CellChangeTimes->{{3.553282439161907*^9, 3.5532825188239594`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Log", "[", " ", 
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox[
      RowBox[{
       SubscriptBox[
        StyleBox["Y",
         FontColor->RGBColor[0, 0, 0.8]], 
        RowBox[{"1", ",", "1"}]], " ", 
       SubscriptBox[
        StyleBox["Y",
         FontColor->RGBColor[0, 0, 0.8]], 
        RowBox[{"2", ",", "2"}]]}], 
      SubscriptBox[
       RowBox[{"(", 
        RowBox[{
         SubscriptBox["Y", 
          RowBox[{"1", ",", "1"}]], 
         SubscriptBox["Y", 
          RowBox[{"2", ",", "2"}]]}], ")"}], "asym"]], ")"}], "+"], "]"}], 
  "\[Equal]", 
  RowBox[{
   SuperscriptBox[
    OverscriptBox["H", "_"], "+"], "-", 
   RowBox[{
    SuperscriptBox[
     RowBox[{"(", 
      RowBox[{
       OverscriptBox[
        StyleBox["x",
         FontColor->RGBColor[0, 0.6, 0]], 
        StyleBox["^",
         FontColor->RGBColor[0, 0.6, 0]]], "-", 
       FractionBox["1", 
        OverscriptBox[
         StyleBox["x",
          FontColor->RGBColor[0, 0.6, 0]], 
         StyleBox["^",
          FontColor->RGBColor[0, 0.6, 0]]]]}], ")"}], "+"], 
    RowBox[{
     SubsuperscriptBox["\[Integral]", 
      RowBox[{"-", "\[Infinity]"}], 
      RowBox[{"+", "\[Infinity]"}]], 
     RowBox[{
      FractionBox["dv", 
       RowBox[{
        RowBox[{"-", "2"}], "\[Pi]", " ", "\[ImaginaryI]"}]], 
      RowBox[{"(", 
       RowBox[{
        FractionBox["1", 
         RowBox[{
          SuperscriptBox["u", "+"], "-", "v"}]], "-", 
        FractionBox["1", 
         RowBox[{
          SuperscriptBox["u", "+"], "+", "v"}]]}], ")"}], 
      FractionBox["1", 
       RowBox[{
        RowBox[{
         OverscriptBox[
          StyleBox["x",
           FontColor->RGBColor[0, 0.6, 0]], 
          StyleBox["^",
           FontColor->RGBColor[0, 0.6, 0]]], "[", 
         RowBox[{"v", "-", 
          RowBox[{"\[ImaginaryI]", " ", "0"}]}], "]"}], "-", 
        FractionBox["1", 
         RowBox[{
          OverscriptBox[
           StyleBox["x",
            FontColor->RGBColor[0, 0.6, 0]], 
           StyleBox["^",
            FontColor->RGBColor[0, 0.6, 0]]], "[", 
          RowBox[{"v", "-", 
           RowBox[{"\[ImaginaryI]", " ", "0"}]}], "]"}]]}]], 
      RowBox[{"H", "[", 
       RowBox[{"v", "-", 
        RowBox[{"\[ImaginaryI]", " ", "0"}]}], "]"}]}]}]}]}]}]], "Input",
 CellChangeTimes->{{3.553282561764586*^9, 3.553282629320259*^9}, {
  3.553282684194765*^9, 3.553282691954465*^9}, {3.5532827391427*^9, 
  3.553282752940012*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Log", "[", " ", 
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox[
      RowBox[{
       SubscriptBox[
        StyleBox["Y",
         FontColor->RGBColor[0, 0, 0.8]], 
        RowBox[{"1", ",", "1"}]], " ", 
       SubscriptBox[
        StyleBox["Y",
         FontColor->RGBColor[0, 0, 0.8]], 
        RowBox[{"2", ",", "2"}]]}], 
      SubscriptBox[
       RowBox[{"(", 
        RowBox[{
         SubscriptBox["Y", 
          RowBox[{"1", ",", "1"}]], 
         SubscriptBox["Y", 
          RowBox[{"2", ",", "2"}]]}], ")"}], "asym"]], ")"}], "-"], "]"}], 
  "=", 
  RowBox[{
   RowBox[{"+", 
    SuperscriptBox["H", "-"]}], "-", 
   RowBox[{
    SuperscriptBox[
     RowBox[{"(", 
      RowBox[{
       StyleBox["x",
        FontColor->RGBColor[0, 0.6, 0]], "-", 
       FractionBox["1", 
        StyleBox["x",
         FontColor->RGBColor[0, 0.6, 0]]]}], ")"}], "-"], 
    RowBox[{
     SubsuperscriptBox["\[Integral]", 
      RowBox[{"-", "\[Infinity]"}], 
      RowBox[{"+", "\[Infinity]"}]], 
     RowBox[{
      FractionBox["dv", 
       RowBox[{
        RowBox[{"-", "2"}], "\[Pi]", " ", "\[ImaginaryI]"}]], 
      RowBox[{"(", 
       RowBox[{
        FractionBox["1", 
         RowBox[{
          SuperscriptBox["u", "-"], "-", "v"}]], "-", 
        FractionBox["1", 
         RowBox[{
          SuperscriptBox["u", "-"], "+", "v"}]]}], ")"}], 
      FractionBox["1", 
       RowBox[{
        RowBox[{
         OverscriptBox[
          StyleBox["x",
           FontColor->RGBColor[0, 0.6, 0]], 
          StyleBox["^",
           FontColor->RGBColor[0, 0.6, 0]]], "[", 
         RowBox[{"v", "-", 
          RowBox[{"\[ImaginaryI]", " ", "0"}]}], "]"}], "-", 
        FractionBox["1", 
         RowBox[{
          OverscriptBox[
           StyleBox["x",
            FontColor->RGBColor[0, 0.6, 0]], 
           StyleBox["^",
            FontColor->RGBColor[0, 0.6, 0]]], "[", 
          RowBox[{"v", "-", 
           RowBox[{"\[ImaginaryI]", " ", "0"}]}], "]"}]]}]], 
      RowBox[{"H", "[", 
       RowBox[{"v", "-", 
        RowBox[{"\[ImaginaryI]", " ", "0"}]}], "]"}]}]}]}]}]}]], "Input",
 CellChangeTimes->{{3.553282527118483*^9, 3.5532825493677063`*^9}, {
  3.5532827151802177`*^9, 3.553282763689508*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"(", 
    RowBox[{"D", "-", 
     SuperscriptBox["D", 
      RowBox[{"-", "1"}]]}], ")"}], 
   RowBox[{"Log", "[", " ", 
    RowBox[{"(", 
     FractionBox[
      RowBox[{
       SubscriptBox[
        StyleBox["Y",
         FontColor->RGBColor[0, 0, 0.8]], 
        RowBox[{"1", ",", "1"}]], " ", 
       SubscriptBox[
        StyleBox["Y",
         FontColor->RGBColor[0, 0, 0.8]], 
        RowBox[{"2", ",", "2"}]]}], 
      SubscriptBox[
       RowBox[{"(", 
        RowBox[{
         SubscriptBox["Y", 
          RowBox[{"1", ",", "1"}]], 
         SubscriptBox["Y", 
          RowBox[{"2", ",", "2"}]]}], ")"}], "asym"]], ")"}], "]"}]}], 
  "\[Equal]", 
  RowBox[{
   RowBox[{"Log", "[", 
    RowBox[{
     FractionBox[
      SuperscriptBox[
       SubscriptBox[
        StyleBox["\[GothicCapitalT]",
         FontColor->RGBColor[0.54, 0.35, 0.15]], 
        RowBox[{"1", ",", "0"}]], "+"], 
      SuperscriptBox[
       SubscriptBox[
        StyleBox["\[GothicCapitalT]",
         FontColor->RGBColor[0.54, 0.35, 0.15]], 
        RowBox[{"1", ",", "0"}]], "-"]], "/", 
     SubscriptBox[
      RowBox[{"(", 
       FractionBox[
        SuperscriptBox[
         SubscriptBox[
          StyleBox["\[GothicCapitalT]",
           FontColor->RGBColor[0.54, 0.35, 0.15]], 
          RowBox[{"1", ",", "0"}]], "+"], 
        SuperscriptBox[
         SubscriptBox[
          StyleBox["\[GothicCapitalT]",
           FontColor->RGBColor[0.54, 0.35, 0.15]], 
          RowBox[{"1", ",", "0"}]], "-"]], ")"}], "asym"]}], "]"}], "-", 
   RowBox[{"2", 
    RowBox[{
     SubsuperscriptBox["\[Integral]", 
      RowBox[{"-", "\[Infinity]"}], 
      RowBox[{"+", "\[Infinity]"}]], 
     RowBox[{
      FractionBox["dv", 
       RowBox[{
        RowBox[{"-", "2"}], "\[Pi]", " ", "\[ImaginaryI]"}]], 
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         FractionBox["1", 
          RowBox[{
           RowBox[{"(", 
            RowBox[{"u", "-", 
             SuperscriptBox["v", "-"]}], ")"}], 
           RowBox[{"(", 
            RowBox[{"u", "+", 
             SuperscriptBox["v", "+"]}], ")"}]}]], 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"u", 
            SqrtBox[
             RowBox[{"1", "-", 
              FractionBox[
               RowBox[{"4", 
                SuperscriptBox["g", "2"]}], 
               SuperscriptBox["u", "2"]]}]]}], ")"}], "+"]}], "+", 
        RowBox[{
         FractionBox["1", 
          RowBox[{
           RowBox[{"(", 
            RowBox[{"u", "-", 
             SuperscriptBox["v", "+"]}], ")"}], 
           RowBox[{"(", 
            RowBox[{"u", "+", 
             SuperscriptBox["v", "-"]}], ")"}]}]], 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"u", 
            SqrtBox[
             RowBox[{"1", "-", 
              FractionBox[
               RowBox[{"4", 
                SuperscriptBox["g", "2"]}], 
               SuperscriptBox["u", "2"]]}]]}], ")"}], "-"]}]}], ")"}], 
      FractionBox[
       RowBox[{"H", "[", 
        RowBox[{"v", "-", 
         RowBox[{"\[ImaginaryI]", " ", "0"}]}], "]"}], 
       SqrtBox[
        RowBox[{"1", "-", 
         FractionBox[
          RowBox[{"4", 
           SuperscriptBox["g", "2"]}], 
          SuperscriptBox["v", "2"]]}]]]}]}]}]}], "\[Equal]", 
  "\[IndentingNewLine]", "\[Equal]", 
  RowBox[{
   RowBox[{"Log", "[", 
    RowBox[{
     FractionBox[
      SuperscriptBox[
       SubscriptBox[
        StyleBox["\[GothicCapitalT]",
         FontColor->RGBColor[0.54, 0.35, 0.15]], 
        RowBox[{"1", ",", "0"}]], "+"], 
      SuperscriptBox[
       SubscriptBox[
        StyleBox["\[GothicCapitalT]",
         FontColor->RGBColor[0.54, 0.35, 0.15]], 
        RowBox[{"1", ",", "0"}]], "-"]], "/", 
     SubscriptBox[
      RowBox[{"(", 
       FractionBox[
        SuperscriptBox[
         SubscriptBox[
          StyleBox["\[GothicCapitalT]",
           FontColor->RGBColor[0.54, 0.35, 0.15]], 
          RowBox[{"1", ",", "0"}]], "+"], 
        SuperscriptBox[
         SubscriptBox[
          StyleBox["\[GothicCapitalT]",
           FontColor->RGBColor[0.54, 0.35, 0.15]], 
          RowBox[{"1", ",", "0"}]], "-"]], ")"}], "asym"]}], "]"}], "-", 
   RowBox[{"2", 
    RowBox[{
     SubsuperscriptBox["\[Integral]", 
      RowBox[{"-", "\[Infinity]"}], 
      RowBox[{"+", "\[Infinity]"}]], 
     RowBox[{
      FractionBox["dv", 
       RowBox[{
        RowBox[{"-", "2"}], "\[Pi]", " ", "\[ImaginaryI]"}]], 
      FractionBox["1", 
       RowBox[{
        SuperscriptBox[
         StyleBox["Q",
          FontColor->RGBColor[0.8, 0, 0]], "-"], " ", 
        SuperscriptBox[
         StyleBox["Q",
          FontColor->RGBColor[0.8, 0, 0]], "+"]}]], 
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           SuperscriptBox[
            RowBox[{"(", 
             RowBox[{
              SubscriptBox["v", "0"], "-", 
              FractionBox["\[ImaginaryI]", "2"]}], ")"}], "2"], "-", 
           SuperscriptBox["v", "2"]}], ")"}], 
         RowBox[{"(", 
          RowBox[{
           SubscriptBox["v", "0"], "+", 
           FractionBox["\[ImaginaryI]", "2"]}], ")"}], 
         SqrtBox[
          RowBox[{"1", "-", 
           FractionBox[
            RowBox[{"4", 
             SuperscriptBox["g", "2"]}], 
            SuperscriptBox[
             RowBox[{"(", 
              RowBox[{
               SubscriptBox["v", "0"], "+", 
               FractionBox["\[ImaginaryI]", "2"]}], ")"}], "2"]]}]]}], "+", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           SuperscriptBox[
            RowBox[{"(", 
             RowBox[{
              SubscriptBox["v", "0"], "+", 
              FractionBox["\[ImaginaryI]", "2"]}], ")"}], "2"], "-", 
           SuperscriptBox["v", "2"]}], ")"}], 
         RowBox[{"(", 
          RowBox[{
           SubscriptBox["v", "0"], "-", 
           FractionBox["\[ImaginaryI]", "2"]}], ")"}], 
         SqrtBox[
          RowBox[{"1", "-", 
           FractionBox[
            RowBox[{"4", 
             SuperscriptBox["g", "2"]}], 
            SuperscriptBox[
             RowBox[{"(", 
              RowBox[{
               SubscriptBox["v", "0"], "-", 
               FractionBox["\[ImaginaryI]", "2"]}], ")"}], "2"]]}]]}]}], 
       ")"}], 
      FractionBox[
       RowBox[{"H", "[", 
        RowBox[{"v", "-", 
         RowBox[{"\[ImaginaryI]", " ", "0"}]}], "]"}], 
       SqrtBox[
        RowBox[{"1", "-", 
         FractionBox[
          RowBox[{"4", 
           SuperscriptBox["g", "2"]}], 
          SuperscriptBox["v", "2"]]}]]]}]}]}]}]}]], "Input",
 CellChangeTimes->{{3.553282810081544*^9, 3.553282953981098*^9}, {
   3.553283048251378*^9, 3.5532831243465*^9}, {3.553283181967135*^9, 
   3.553283186368239*^9}, {3.553283218267436*^9, 3.553283267725947*^9}, {
   3.553283307734701*^9, 3.55328331339054*^9}, {3.55328342560015*^9, 
   3.553283426408002*^9}, 3.553283465229755*^9, {3.553283630322719*^9, 
   3.553283750617322*^9}, {3.553283959527026*^9, 3.553283959692307*^9}}],

Cell["\<\
For our convenience, we will denote this expression as\
\>", "Text",
 CellChangeTimes->{{3.553284147672752*^9, 3.55328415724851*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"(", 
   RowBox[{
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       SuperscriptBox[
        RowBox[{"(", 
         RowBox[{
          SubscriptBox["v", "0"], "-", 
          FractionBox["\[ImaginaryI]", "2"]}], ")"}], "2"], "-", 
       SuperscriptBox["v", "2"]}], ")"}], 
     RowBox[{"(", 
      RowBox[{
       SubscriptBox["v", "0"], "+", 
       FractionBox["\[ImaginaryI]", "2"]}], ")"}], 
     SqrtBox[
      RowBox[{"1", "-", 
       FractionBox[
        RowBox[{"4", 
         SuperscriptBox["g", "2"]}], 
        SuperscriptBox[
         RowBox[{"(", 
          RowBox[{
           SubscriptBox["v", "0"], "+", 
           FractionBox["\[ImaginaryI]", "2"]}], ")"}], "2"]]}]]}], "+", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       SuperscriptBox[
        RowBox[{"(", 
         RowBox[{
          SubscriptBox["v", "0"], "+", 
          FractionBox["\[ImaginaryI]", "2"]}], ")"}], "2"], "-", 
       SuperscriptBox["v", "2"]}], ")"}], 
     RowBox[{"(", 
      RowBox[{
       SubscriptBox["v", "0"], "-", 
       FractionBox["\[ImaginaryI]", "2"]}], ")"}], 
     SqrtBox[
      RowBox[{"1", "-", 
       FractionBox[
        RowBox[{"4", 
         SuperscriptBox["g", "2"]}], 
        SuperscriptBox[
         RowBox[{"(", 
          RowBox[{
           SubscriptBox["v", "0"], "-", 
           FractionBox["\[ImaginaryI]", "2"]}], ")"}], "2"]]}]]}]}], ")"}], 
  "\[Equal]", 
  RowBox[{"Kr1", "+", 
   RowBox[{
    SuperscriptBox["v", "2"], "Kr2"}]}]}]], "Input",
 CellChangeTimes->{{3.5532841659730873`*^9, 3.553284187158415*^9}}],

Cell["So that", "Text",
 CellChangeTimes->{{3.553284192136005*^9, 3.5532841949098053`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"(", 
    RowBox[{"D", "-", 
     SuperscriptBox["D", 
      RowBox[{"-", "1"}]]}], ")"}], 
   RowBox[{"Log", "[", " ", 
    RowBox[{"(", 
     FractionBox[
      RowBox[{
       SubscriptBox[
        StyleBox["Y",
         FontColor->RGBColor[0, 0, 0.8]], 
        RowBox[{"1", ",", "1"}]], " ", 
       SubscriptBox[
        StyleBox["Y",
         FontColor->RGBColor[0, 0, 0.8]], 
        RowBox[{"2", ",", "2"}]]}], 
      SubscriptBox[
       RowBox[{"(", 
        RowBox[{
         SubscriptBox["Y", 
          RowBox[{"1", ",", "1"}]], 
         SubscriptBox["Y", 
          RowBox[{"2", ",", "2"}]]}], ")"}], "asym"]], ")"}], "]"}]}], 
  "\[Equal]", 
  RowBox[{
   RowBox[{
    RowBox[{"(", 
     RowBox[{"D", "-", 
      SuperscriptBox["D", 
       RowBox[{"-", "1"}]]}], ")"}], 
    RowBox[{"Log", "[", 
     FractionBox[
      SubscriptBox[
       StyleBox["\[GothicCapitalT]",
        FontColor->RGBColor[0.54, 0.35, 0.15]], 
       RowBox[{"1", ",", "0"}]], 
      SubscriptBox[
       RowBox[{
        StyleBox["(",
         FontColor->RGBColor[0.54, 0.35, 0.15]], 
        SubscriptBox[
         StyleBox["\[GothicCapitalT]",
          FontColor->RGBColor[0.54, 0.35, 0.15]], 
         RowBox[{"1", ",", "0"}]], ")"}], "asym"]], "]"}]}], "-", 
   RowBox[{"2", 
    RowBox[{
     SubsuperscriptBox["\[Integral]", 
      RowBox[{
       RowBox[{"-", "\[Infinity]"}], "-", 
       RowBox[{"\[ImaginaryI]", " ", "0"}]}], 
      RowBox[{
       RowBox[{"+", "\[Infinity]"}], "-", 
       RowBox[{"\[ImaginaryI]", " ", "0"}]}]], 
     RowBox[{
      FractionBox["dv", 
       RowBox[{
        RowBox[{"-", "2"}], "\[Pi]", " ", "\[ImaginaryI]"}]], 
      FractionBox[
       RowBox[{"Kr1", "+", 
        RowBox[{
         SuperscriptBox["v", "2"], "Kr2"}]}], 
       RowBox[{
        SuperscriptBox[
         StyleBox["Q",
          FontColor->RGBColor[0.8, 0, 0]], "-"], " ", 
        SuperscriptBox[
         StyleBox["Q",
          FontColor->RGBColor[0.8, 0, 0]], "+"]}]], 
      FractionBox[
       RowBox[{"H", "[", "v", "]"}], 
       SqrtBox[
        RowBox[{"1", "-", 
         FractionBox[
          RowBox[{"4", 
           SuperscriptBox["g", "2"]}], 
          SuperscriptBox["v", "2"]]}]]]}]}]}]}]}]], "Input",
 CellChangeTimes->{{3.553284318830558*^9, 3.553284331720311*^9}, {
  3.553284517557727*^9, 3.5532845379418087`*^9}, {3.553284570415821*^9, 
  3.5532845779027357`*^9}}],

Cell["\<\
At each perturbative order expression simplifies:\
\>", "Text",
 CellChangeTimes->{{3.5532837807754927`*^9, 3.5532837946402493`*^9}, {
  3.5532838502922897`*^9, 3.5532838522925034`*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"Series", "[", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"Kr1", "+", 
       RowBox[{
        SuperscriptBox["v", "2"], "Kr2"}]}], "/.", "subsupl"}], "/.", 
     "weak"}], ",", 
    RowBox[{"{", 
     RowBox[{"g", ",", "0", ",", "6"}], "}"}]}], "]"}], "//", 
  "FullSimplify"}]], "Input",
 CellChangeTimes->{{3.553284288824501*^9, 3.5532842977340717`*^9}}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
   FractionBox[
    RowBox[{"1", "-", 
     RowBox[{"3", " ", 
      SuperscriptBox["v", "2"]}]}], 
    RowBox[{"3", " ", 
     SqrtBox["3"]}]], "-", 
   FractionBox[
    RowBox[{"2", " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"-", "4"}], "+", 
       SuperscriptBox["v", "2"]}], ")"}], " ", 
     SuperscriptBox["g", "2"]}], 
    SqrtBox["3"]], "+", 
   FractionBox[
    RowBox[{"8", " ", 
     RowBox[{"(", 
      RowBox[{"1", "+", 
       SuperscriptBox["v", "2"]}], ")"}], " ", 
     SuperscriptBox["g", "4"]}], 
    SqrtBox["3"]], "-", 
   FractionBox[
    RowBox[{"8", " ", 
     RowBox[{"(", 
      RowBox[{"14", "-", 
       RowBox[{"9", " ", 
        SubscriptBox[
         StyleBox["\[Zeta]",
          FontWeight->Bold,
          FontColor->RGBColor[0.8, 0, 0]], "3"]}], "+", 
       RowBox[{"3", " ", 
        SuperscriptBox["v", "2"], " ", 
        RowBox[{"(", 
         RowBox[{"5", "+", 
          RowBox[{"6", " ", 
           SubscriptBox[
            StyleBox["\[Zeta]",
             FontWeight->Bold,
             FontColor->RGBColor[0.8, 0, 0]], "3"]}]}], ")"}]}]}], ")"}], " ", 
     SuperscriptBox["g", "6"]}], 
    RowBox[{"3", " ", 
     SqrtBox["3"]}]], "+", 
   InterpretationBox[
    SuperscriptBox[
     RowBox[{"O", "[", "g", "]"}], "7"],
    SeriesData[$CellContext`g, 0, {}, 0, 7, 1],
    Editable->False]}],
  SeriesData[$CellContext`g, 0, {
   Rational[1, 3] 3^Rational[-1, 2] (1 - 3 $CellContext`v^2), 0, (-2) 
    3^Rational[-1, 2] (-4 + $CellContext`v^2), 0, 8 
    3^Rational[-1, 2] (1 + $CellContext`v^2), 0, Rational[-8, 3] 
    3^Rational[-1, 2] (14 - 9 $CellContext`\[Zeta]$[3][0] + 
     3 $CellContext`v^2 (5 + 6 $CellContext`\[Zeta]$[3][0]))}, 0, 7, 1],
  Editable->False]], "Output",
 CellChangeTimes->{3.55328429838984*^9}]
}, Open  ]],

Cell["\<\
Together with other entries one has\
\>", "Text",
 CellChangeTimes->{{3.553284341978661*^9, 3.553284351464016*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Collect", "[", 
    RowBox[{"#", ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{
        SuperscriptBox[
         RowBox[{"(", 
          SuperscriptBox["Q0", "+"], ")"}], "_"], 
        SuperscriptBox[
         RowBox[{"(", 
          SuperscriptBox["Q0", "-"], ")"}], "_"]}], ",", 
       SuperscriptBox["Q0", "+"], ",", 
       SuperscriptBox["Q0", "-"]}], "}"}], ",", "Simplify"}], "]"}], "&"}], "/@", 
  RowBox[{"Series", "[", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{
       FractionBox[
        RowBox[{"Kr1", "+", 
         RowBox[{
          SuperscriptBox["v", "2"], "Kr2"}]}], 
        RowBox[{
         RowBox[{
          SuperscriptBox["Q", "+"], 
          SuperscriptBox["Q", "-"]}], "/.", 
         RowBox[{
          RowBox[{"Q$", "[", 
           RowBox[{"r_:", "0"}], "]"}], "\[RuleDelayed]", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"Q0$", "[", "r", "]"}], "-", 
            SubsuperscriptBox["v", "0", "2"], "+", 
            FractionBox["1", "12"]}], ")"}]}]}]], 
       FractionBox["1", 
        SqrtBox[
         RowBox[{"1", "-", 
          FractionBox[
           RowBox[{"4", 
            SuperscriptBox["g", "2"]}], 
           SuperscriptBox["v", "2"]]}]]]}], "/.", "subsupl"}], "/.", "weak"}],
     ",", 
    RowBox[{"{", 
     RowBox[{"g", ",", "0", ",", "2"}], "}"}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.5532843596701107`*^9, 3.553284482215612*^9}, {
  3.553284588390929*^9, 3.55328458967682*^9}, {3.5532859688207493`*^9, 
  3.553286003618444*^9}, {3.5533126389335623`*^9, 3.553312708194441*^9}}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
   FractionBox[
    RowBox[{"1", "-", 
     RowBox[{"3", " ", 
      SuperscriptBox["v", "2"]}]}], 
    RowBox[{"3", " ", 
     SqrtBox["3"], " ", 
     SuperscriptBox[
      StyleBox["Q0",
       FontColor->RGBColor[{
          Rational[1, 2], 
          Rational[1, 2], 0}]], "-"], " ", 
     SuperscriptBox[
      StyleBox["Q0",
       FontColor->RGBColor[{
          Rational[1, 2], 
          Rational[1, 2], 0}]], "+"]}]], "+", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"-", 
       FractionBox[
        RowBox[{"4", " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"-", "1"}], "+", 
           RowBox[{"3", " ", 
            SuperscriptBox["v", "2"]}]}], ")"}]}], 
        RowBox[{"9", " ", 
         SqrtBox["3"], " ", 
         SuperscriptBox[
          StyleBox["Q0",
           FontColor->RGBColor[{
              Rational[1, 2], 
              Rational[1, 2], 0}]], "-"], " ", 
         SuperscriptBox[
          RowBox[{"(", 
           SuperscriptBox[
            StyleBox["Q0",
             FontColor->RGBColor[{
                Rational[1, 2], 
                Rational[1, 2], 0}]], "+"], ")"}], "2"]}]]}], "-", 
      FractionBox[
       RowBox[{"4", " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"-", "1"}], "+", 
          RowBox[{"3", " ", 
           SuperscriptBox["v", "2"]}]}], ")"}]}], 
       RowBox[{"9", " ", 
        SqrtBox["3"], " ", 
        SuperscriptBox[
         RowBox[{"(", 
          SuperscriptBox[
           StyleBox["Q0",
            FontColor->RGBColor[{
               Rational[1, 2], 
               Rational[1, 2], 0}]], "-"], ")"}], "2"], " ", 
        SuperscriptBox[
         StyleBox["Q0",
          FontColor->RGBColor[{
             Rational[1, 2], 
             Rational[1, 2], 0}]], "+"]}]], "+", 
      FractionBox[
       RowBox[{"2", " ", 
        RowBox[{"(", 
         RowBox[{"1", "+", 
          RowBox[{"9", " ", 
           SuperscriptBox["v", "2"]}], "-", 
          RowBox[{"3", " ", 
           SuperscriptBox["v", "4"]}]}], ")"}]}], 
       RowBox[{"3", " ", 
        SqrtBox["3"], " ", 
        SuperscriptBox["v", "2"], " ", 
        SuperscriptBox[
         StyleBox["Q0",
          FontColor->RGBColor[{
             Rational[1, 2], 
             Rational[1, 2], 0}]], "-"], " ", 
        SuperscriptBox[
         StyleBox["Q0",
          FontColor->RGBColor[{
             Rational[1, 2], 
             Rational[1, 2], 0}]], "+"]}]]}], ")"}], " ", 
    SuperscriptBox["g", "2"]}], "+", 
   InterpretationBox[
    SuperscriptBox[
     RowBox[{"O", "[", "g", "]"}], "3"],
    SeriesData[$CellContext`g, 0, {}, 0, 3, 1],
    Editable->False]}],
  SeriesData[$CellContext`g, 0, {
   Rational[1, 3] 
    3^Rational[-1, 2] (1 - 
     3 $CellContext`v^2) $CellContext`Q0$[-1]^(-1)/$CellContext`Q0$[1], 0, 
    Rational[-4, 9] 
     3^Rational[-1, 2] (-1 + 
      3 $CellContext`v^2) $CellContext`Q0$[-1]^(-1) $CellContext`Q0$[1]^(-2) + 
    Rational[-4, 9] 
     3^Rational[-1, 2] (-1 + 
      3 $CellContext`v^2) $CellContext`Q0$[-1]^(-2)/$CellContext`Q0$[1] + 
    Rational[2, 3] 
     3^Rational[-1, 2] $CellContext`v^(-2) (1 + 9 $CellContext`v^2 - 
      3 $CellContext`v^4) $CellContext`Q0$[-1]^(-1)/$CellContext`Q0$[1]}, 0, 
   3, 1],
  Editable->False]], "Output",
 CellChangeTimes->{{3.55331265891053*^9, 3.553312708677896*^9}}]
}, Open  ]],

Cell["\<\
There an interesting identity which allow to simplify expressions above\
\>", "Text",
 CellChangeTimes->{{3.553312920073086*^9, 3.553312927974432*^9}, {
  3.5533129706052227`*^9, 3.553312981156928*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"-", 
     FractionBox["3", "2"]}], 
    RowBox[{"(", 
     RowBox[{
      SuperscriptBox["Q0", "+"], "+", 
      SuperscriptBox["Q0", "-"]}], ")"}]}], "/.", "subQ0"}], "//", 
  "Expand"}]], "Input",
 CellChangeTimes->{{3.553312928840866*^9, 3.553312967057336*^9}}],

Cell[BoxData[
 RowBox[{"1", "-", 
  RowBox[{"3", " ", 
   SuperscriptBox["u", "2"]}]}]], "Output",
 CellChangeTimes->{{3.553312941690031*^9, 3.553312967483252*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Collect", "[", 
    RowBox[{"#", ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{
        SuperscriptBox[
         RowBox[{"(", 
          SuperscriptBox["Q0", "+"], ")"}], "_"], 
        SuperscriptBox[
         RowBox[{"(", 
          SuperscriptBox["Q0", "-"], ")"}], "_"]}], ",", 
       SuperscriptBox["Q0", "+"], ",", 
       SuperscriptBox["Q0", "-"]}], "}"}], ",", "Simplify"}], "]"}], "&"}], "/@", 
  RowBox[{"(", 
   RowBox[{
    InterpretationBox[
     RowBox[{
      FractionBox[
       RowBox[{"1", "-", 
        RowBox[{"3", " ", 
         SuperscriptBox["v", "2"]}]}], 
       RowBox[{"3", " ", 
        SqrtBox["3"], " ", 
        SuperscriptBox[
         StyleBox["Q0",
          FontColor->RGBColor[{
             Rational[1, 2], 
             Rational[1, 2], 0}]], "-"], " ", 
        SuperscriptBox[
         StyleBox["Q0",
          FontColor->RGBColor[{
             Rational[1, 2], 
             Rational[1, 2], 0}]], "+"]}]], "+", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", 
          FractionBox[
           RowBox[{"4", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "1"}], "+", 
              RowBox[{"3", " ", 
               SuperscriptBox["v", "2"]}]}], ")"}]}], 
           RowBox[{"9", " ", 
            SqrtBox["3"], " ", 
            SuperscriptBox[
             StyleBox["Q0",
              FontColor->RGBColor[{
                 Rational[1, 2], 
                 Rational[1, 2], 0}]], "-"], " ", 
            SuperscriptBox[
             RowBox[{"(", 
              SuperscriptBox[
               StyleBox["Q0",
                FontColor->RGBColor[{
                   Rational[1, 2], 
                   Rational[1, 2], 0}]], "+"], ")"}], "2"]}]]}], "-", 
         FractionBox[
          RowBox[{"4", " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"-", "1"}], "+", 
             RowBox[{"3", " ", 
              SuperscriptBox["v", "2"]}]}], ")"}]}], 
          RowBox[{"9", " ", 
           SqrtBox["3"], " ", 
           SuperscriptBox[
            RowBox[{"(", 
             SuperscriptBox[
              StyleBox["Q0",
               FontColor->RGBColor[{
                  Rational[1, 2], 
                  Rational[1, 2], 0}]], "-"], ")"}], "2"], " ", 
           SuperscriptBox[
            StyleBox["Q0",
             FontColor->RGBColor[{
                Rational[1, 2], 
                Rational[1, 2], 0}]], "+"]}]], "+", 
         FractionBox[
          RowBox[{"2", " ", 
           RowBox[{"(", 
            RowBox[{"1", "+", 
             RowBox[{"9", " ", 
              SuperscriptBox["v", "2"]}], "-", 
             RowBox[{"3", " ", 
              SuperscriptBox["v", "4"]}]}], ")"}]}], 
          RowBox[{"3", " ", 
           SqrtBox["3"], " ", 
           SuperscriptBox["v", "2"], " ", 
           SuperscriptBox[
            StyleBox["Q0",
             FontColor->RGBColor[{
                Rational[1, 2], 
                Rational[1, 2], 0}]], "-"], " ", 
           SuperscriptBox[
            StyleBox["Q0",
             FontColor->RGBColor[{
                Rational[1, 2], 
                Rational[1, 2], 0}]], "+"]}]]}], ")"}], " ", 
       SuperscriptBox["g", "2"]}], "+", 
      InterpretationBox[
       SuperscriptBox[
        RowBox[{"O", "[", "g", "]"}], "3"],
       SeriesData[$CellContext`g, 0, {}, 0, 3, 1],
       Editable->False]}],
     SeriesData[$CellContext`g, 0, {
      Rational[1, 3] 
       3^Rational[-1, 2] (1 - 
        3 $CellContext`v^2) $CellContext`Q0$[-1]^(-1)/$CellContext`Q0$[1], 0, 
       Rational[-4, 9] 
        3^Rational[-1, 2] (-1 + 
         3 $CellContext`v^2) $CellContext`Q0$[-1]^(-1) $CellContext`Q0$[
          1]^(-2) + Rational[-4, 9] 
        3^Rational[-1, 2] (-1 + 
         3 $CellContext`v^2) $CellContext`Q0$[-1]^(-2)/$CellContext`Q0$[1] + 
       Rational[2, 3] 
        3^Rational[-1, 2] $CellContext`v^(-2) (1 + 9 $CellContext`v^2 - 
         3 $CellContext`v^4) $CellContext`Q0$[-1]^(-1)/$CellContext`Q0$[1]}, 
      0, 3, 1],
     Editable->False], "/.", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{
       RowBox[{"1", "-", 
        RowBox[{"3", " ", 
         SuperscriptBox["v", "2"]}]}], "->", 
       RowBox[{
        RowBox[{"-", 
         FractionBox["3", "2"]}], 
        RowBox[{"(", 
         RowBox[{
          SuperscriptBox["Q0", "+"], "+", 
          SuperscriptBox["Q0", "-"]}], ")"}]}]}], ",", 
      RowBox[{
       RowBox[{
        RowBox[{"-", "1"}], "+", 
        RowBox[{"3", 
         SuperscriptBox["v", "2"]}]}], "\[Rule]", " ", 
       RowBox[{
        RowBox[{"+", 
         FractionBox["3", "2"]}], 
        RowBox[{"(", 
         RowBox[{
          SuperscriptBox["Q0", "+"], "+", 
          SuperscriptBox["Q0", "-"]}], ")"}]}]}]}], "}"}]}], ")"}]}]], "Input",\

 CellChangeTimes->{{3.553312994364642*^9, 3.553313030605618*^9}, {
   3.5533131378443117`*^9, 3.553313226661797*^9}, 3.553313418674141*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     RowBox[{"-", 
      FractionBox["1", 
       RowBox[{"2", " ", 
        SqrtBox["3"], " ", 
        SuperscriptBox[
         StyleBox["Q0",
          FontColor->RGBColor[{
             Rational[1, 2], 
             Rational[1, 2], 0}]], "-"]}]]}], "-", 
     FractionBox["1", 
      RowBox[{"2", " ", 
       SqrtBox["3"], " ", 
       SuperscriptBox[
        StyleBox["Q0",
         FontColor->RGBColor[{
            Rational[1, 2], 
            Rational[1, 2], 0}]], "+"]}]]}], ")"}], "+", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"-", 
       FractionBox["2", 
        RowBox[{"3", " ", 
         SqrtBox["3"], " ", 
         SuperscriptBox[
          RowBox[{"(", 
           SuperscriptBox[
            StyleBox["Q0",
             FontColor->RGBColor[{
                Rational[1, 2], 
                Rational[1, 2], 0}]], "-"], ")"}], "2"]}]]}], "-", 
      FractionBox["2", 
       RowBox[{"3", " ", 
        SqrtBox["3"], " ", 
        SuperscriptBox[
         RowBox[{"(", 
          SuperscriptBox[
           StyleBox["Q0",
            FontColor->RGBColor[{
               Rational[1, 2], 
               Rational[1, 2], 0}]], "+"], ")"}], "2"]}]], "+", 
      FractionBox[
       RowBox[{"2", "+", 
        RowBox[{"14", " ", 
         SuperscriptBox["v", "2"]}], "-", 
        RowBox[{"6", " ", 
         SuperscriptBox["v", "4"]}]}], 
       RowBox[{"3", " ", 
        SqrtBox["3"], " ", 
        SuperscriptBox["v", "2"], " ", 
        SuperscriptBox[
         StyleBox["Q0",
          FontColor->RGBColor[{
             Rational[1, 2], 
             Rational[1, 2], 0}]], "-"], " ", 
        SuperscriptBox[
         StyleBox["Q0",
          FontColor->RGBColor[{
             Rational[1, 2], 
             Rational[1, 2], 0}]], "+"]}]]}], ")"}], " ", 
    SuperscriptBox["g", "2"]}], "+", 
   InterpretationBox[
    SuperscriptBox[
     RowBox[{"O", "[", "g", "]"}], "3"],
    SeriesData[$CellContext`g, 0, {}, 0, 3, 1],
    Editable->False]}],
  SeriesData[$CellContext`g, 0, {
   Rational[-1, 2] 3^Rational[-1, 2]/$CellContext`Q0$[-1] + 
    Rational[-1, 2] 3^Rational[-1, 2]/$CellContext`Q0$[1], 0, 
    Rational[-2, 3] 3^Rational[-1, 2] $CellContext`Q0$[-1]^(-2) + 
    Rational[-2, 3] 3^Rational[-1, 2] $CellContext`Q0$[1]^(-2) + 
    Rational[1, 3] 
     3^Rational[-1, 2] $CellContext`v^(-2) (2 + 14 $CellContext`v^2 - 
      6 $CellContext`v^4) $CellContext`Q0$[-1]^(-1)/$CellContext`Q0$[1]}, 0, 
   3, 1],
  Editable->False]], "Output",
 CellChangeTimes->{3.5533134247660503`*^9}]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"subsupl", "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"Kr1", "\[Rule]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"Coefficient", "[", 
         RowBox[{
          RowBox[{
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              SuperscriptBox[
               RowBox[{"(", 
                RowBox[{
                 SubscriptBox["v", "0"], "-", 
                 FractionBox["\[ImaginaryI]", "2"]}], ")"}], "2"], "-", 
              SuperscriptBox["v", "2"]}], ")"}], 
            RowBox[{"(", 
             RowBox[{
              SubscriptBox["v", "0"], "+", 
              FractionBox["\[ImaginaryI]", "2"]}], ")"}], 
            SqrtBox[
             RowBox[{"1", "-", 
              FractionBox[
               RowBox[{"4", 
                SuperscriptBox["g", "2"]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SubscriptBox["v", "0"], "+", 
                  FractionBox["\[ImaginaryI]", "2"]}], ")"}], "2"]]}]]}], "+", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              SuperscriptBox[
               RowBox[{"(", 
                RowBox[{
                 SubscriptBox["v", "0"], "+", 
                 FractionBox["\[ImaginaryI]", "2"]}], ")"}], "2"], "-", 
              SuperscriptBox["v", "2"]}], ")"}], 
            RowBox[{"(", 
             RowBox[{
              SubscriptBox["v", "0"], "-", 
              FractionBox["\[ImaginaryI]", "2"]}], ")"}], 
            SqrtBox[
             RowBox[{"1", "-", 
              FractionBox[
               RowBox[{"4", 
                SuperscriptBox["g", "2"]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SubscriptBox["v", "0"], "-", 
                  FractionBox["\[ImaginaryI]", "2"]}], ")"}], "2"]]}]]}]}], 
          ",", "v", ",", "0"}], "]"}], "//", "Simplify"}], ")"}]}], ",", 
     RowBox[{"Kr2", "\[Rule]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"Coefficient", "[", 
         RowBox[{
          RowBox[{
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              SuperscriptBox[
               RowBox[{"(", 
                RowBox[{
                 SubscriptBox["v", "0"], "-", 
                 FractionBox["\[ImaginaryI]", "2"]}], ")"}], "2"], "-", 
              SuperscriptBox["v", "2"]}], ")"}], 
            RowBox[{"(", 
             RowBox[{
              SubscriptBox["v", "0"], "+", 
              FractionBox["\[ImaginaryI]", "2"]}], ")"}], 
            SqrtBox[
             RowBox[{"1", "-", 
              FractionBox[
               RowBox[{"4", 
                SuperscriptBox["g", "2"]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SubscriptBox["v", "0"], "+", 
                  FractionBox["\[ImaginaryI]", "2"]}], ")"}], "2"]]}]]}], "+", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              SuperscriptBox[
               RowBox[{"(", 
                RowBox[{
                 SubscriptBox["v", "0"], "+", 
                 FractionBox["\[ImaginaryI]", "2"]}], ")"}], "2"], "-", 
              SuperscriptBox["v", "2"]}], ")"}], 
            RowBox[{"(", 
             RowBox[{
              SubscriptBox["v", "0"], "-", 
              FractionBox["\[ImaginaryI]", "2"]}], ")"}], 
            SqrtBox[
             RowBox[{"1", "-", 
              FractionBox[
               RowBox[{"4", 
                SuperscriptBox["g", "2"]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{
                  SubscriptBox["v", "0"], "-", 
                  FractionBox["\[ImaginaryI]", "2"]}], ")"}], "2"]]}]]}]}], 
          ",", "v", ",", "2"}], "]"}], "//", "Simplify"}], ")"}]}]}], "}"}]}],
   ";"}]], "Input",
 CellChangeTimes->{{3.553284243373266*^9, 3.553284273463305*^9}}],

Cell[CellGroupData[{

Cell[BoxData["subsupl"], "Input",
 CellChangeTimes->{{3.553834948284486*^9, 3.553834949522316*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"Kr1", "\[Rule]", 
    RowBox[{
     FractionBox["1", "8"], " ", 
     RowBox[{"(", 
      RowBox[{"1", "+", 
       RowBox[{"4", " ", 
        SubsuperscriptBox["v", "0", "2"]}]}], ")"}], " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"\[ImaginaryI]", " ", 
        SqrtBox[
         RowBox[{"1", "-", 
          FractionBox[
           RowBox[{"4", " ", 
            SuperscriptBox["g", "2"]}], 
           SuperscriptBox[
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", 
               FractionBox["\[ImaginaryI]", "2"]}], "+", 
              SubscriptBox["v", "0"]}], ")"}], "2"]]}]]}], "+", 
       RowBox[{"2", " ", 
        SubscriptBox["v", "0"], " ", 
        SqrtBox[
         RowBox[{"1", "-", 
          FractionBox[
           RowBox[{"4", " ", 
            SuperscriptBox["g", "2"]}], 
           SuperscriptBox[
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", 
               FractionBox["\[ImaginaryI]", "2"]}], "+", 
              SubscriptBox["v", "0"]}], ")"}], "2"]]}]]}], "-", 
       RowBox[{"\[ImaginaryI]", " ", 
        SqrtBox[
         RowBox[{"1", "-", 
          FractionBox[
           RowBox[{"4", " ", 
            SuperscriptBox["g", "2"]}], 
           SuperscriptBox[
            RowBox[{"(", 
             RowBox[{
              FractionBox["\[ImaginaryI]", "2"], "+", 
              SubscriptBox["v", "0"]}], ")"}], "2"]]}]]}], "+", 
       RowBox[{"2", " ", 
        SubscriptBox["v", "0"], " ", 
        SqrtBox[
         RowBox[{"1", "-", 
          FractionBox[
           RowBox[{"4", " ", 
            SuperscriptBox["g", "2"]}], 
           SuperscriptBox[
            RowBox[{"(", 
             RowBox[{
              FractionBox["\[ImaginaryI]", "2"], "+", 
              SubscriptBox["v", "0"]}], ")"}], "2"]]}]]}]}], ")"}]}]}], ",", 
   RowBox[{"Kr2", "\[Rule]", 
    RowBox[{
     FractionBox["1", "2"], " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"\[ImaginaryI]", " ", 
        SqrtBox[
         RowBox[{"1", "-", 
          FractionBox[
           RowBox[{"4", " ", 
            SuperscriptBox["g", "2"]}], 
           SuperscriptBox[
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", 
               FractionBox["\[ImaginaryI]", "2"]}], "+", 
              SubscriptBox["v", "0"]}], ")"}], "2"]]}]]}], "-", 
       RowBox[{"2", " ", 
        SubscriptBox["v", "0"], " ", 
        SqrtBox[
         RowBox[{"1", "-", 
          FractionBox[
           RowBox[{"4", " ", 
            SuperscriptBox["g", "2"]}], 
           SuperscriptBox[
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", 
               FractionBox["\[ImaginaryI]", "2"]}], "+", 
              SubscriptBox["v", "0"]}], ")"}], "2"]]}]]}], "-", 
       RowBox[{"\[ImaginaryI]", " ", 
        SqrtBox[
         RowBox[{"1", "-", 
          FractionBox[
           RowBox[{"4", " ", 
            SuperscriptBox["g", "2"]}], 
           SuperscriptBox[
            RowBox[{"(", 
             RowBox[{
              FractionBox["\[ImaginaryI]", "2"], "+", 
              SubscriptBox["v", "0"]}], ")"}], "2"]]}]]}], "-", 
       RowBox[{"2", " ", 
        SubscriptBox["v", "0"], " ", 
        SqrtBox[
         RowBox[{"1", "-", 
          FractionBox[
           RowBox[{"4", " ", 
            SuperscriptBox["g", "2"]}], 
           SuperscriptBox[
            RowBox[{"(", 
             RowBox[{
              FractionBox["\[ImaginaryI]", "2"], "+", 
              SubscriptBox["v", "0"]}], ")"}], "2"]]}]]}]}], ")"}]}]}]}], 
  "}"}]], "Output",
 CellChangeTimes->{3.5538349500557413`*^9}]
}, Open  ]]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[Cell[BoxData[
 FormBox[
  RowBox[{"Log", "[", 
   RowBox[{
    SubscriptBox["Y", 
     RowBox[{"1", ",", "1"}]], "/", 
    SubscriptBox["Y", 
     RowBox[{"2", ",", "2"}]]}], "]"}], TraditionalForm]]]], "Subsection",
 CellChangeTimes->{{3.5388041332985287`*^9, 3.538804147136546*^9}, 
   3.547313106575903*^9, {3.5477847253141813`*^9, 3.5477847279364634`*^9}, {
   3.55331404751853*^9, 3.553314080326559*^9}}],

Cell[CellGroupData[{

Cell["\<\
Derivation of an integral equation\
\>", "Subsubsection",
 CellChangeTimes->{{3.553314123028195*^9, 3.553314128473793*^9}}],

Cell["\<\
The derivation is based on the analyticity of C in the UHP and its good \
behaviour at infinity.\
\>", "Text",
 CellChangeTimes->{{3.546241212213862*^9, 3.546241229028224*^9}, {
  3.553314148853345*^9, 3.5533141640479794`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"C", "\[Equal]", 
   RowBox[{
    FractionBox[
     SubscriptBox["Y", 
      RowBox[{"1", ",", "1"}]], 
     SubscriptBox["Y", 
      RowBox[{"2", ",", "2"}]]], "r1", " ", "r2"}]}], ",", "  ", 
  RowBox[{"r1", "\[Equal]", 
   FractionBox[
    RowBox[{
     SubsuperscriptBox[
      StyleBox["\[GothicCapitalT]",
       FontColor->RGBColor[0.54, 0.35, 0.15]], 
      RowBox[{"0", ",", "0"}], "-"], " ", 
     SuperscriptBox[
      RowBox[{"(", 
       SuperscriptBox[
        StyleBox["\[ScriptCapitalT]",
         FontColor->RGBColor[1, 0, 0]], "-"], ")"}], "2"], " "}], 
    RowBox[{" ", 
     RowBox[{
      SubscriptBox[
       StyleBox["\[GothicCapitalT]",
        FontColor->RGBColor[0.54, 0.35, 0.15]], 
       RowBox[{"1", ",", "0"}]], " ", 
      SuperscriptBox[
       RowBox[{"(", 
        SuperscriptBox[
         StyleBox["\[GothicCapitalT]",
          FontColor->RGBColor[0.54, 0.35, 0.15]], "-"], ")"}], "2"]}]}]]}], 
  ",", " ", 
  RowBox[{"r2", "\[Equal]", 
   FractionBox[
    SubsuperscriptBox[
     StyleBox["\[GothicCapitalT]",
      FontColor->RGBColor[0.54, 0.35, 0.15]], 
     RowBox[{"2", ",", "1"}], "2"], 
    SubsuperscriptBox[
     StyleBox["\[ScriptCapitalT]",
      FontColor->RGBColor[1, 0, 0]], 
     RowBox[{"1", ",", "2"}], "2"]]}]}]], "Input",
 CellChangeTimes->{{3.546241229992443*^9, 3.546241267600005*^9}, {
  3.553314196681678*^9, 3.5533142041077633`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Log", "[", "C", "]"}], "\[Equal]", " ", 
  RowBox[{"\[ScriptCapitalC]", "*", 
   RowBox[{"Log", "[", 
    FractionBox[
     SuperscriptBox["r1", 
      RowBox[{"[", 
       RowBox[{"+", "o"}], "]"}]], 
     SuperscriptBox[
      OverscriptBox["r1", "_"], 
      RowBox[{"[", 
       RowBox[{"-", "o"}], "]"}]]], "]"}]}]}]], "Input",
 CellChangeTimes->{{3.546241271837496*^9, 3.5462413185964127`*^9}, {
  3.553314206284889*^9, 3.553314215889349*^9}, {3.553314276416897*^9, 
  3.553314284184787*^9}}],

Cell["In the UHP one gets", "Text",
 CellChangeTimes->{{3.546241376710052*^9, 3.5462413816455507`*^9}, {
  3.553314240777733*^9, 3.553314253228798*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Log", "[", 
   RowBox[{
    FractionBox[
     SubscriptBox["Y", 
      RowBox[{"1", ",", "1"}]], 
     SubscriptBox["Y", 
      RowBox[{"2", ",", "2"}]]], "r2"}], "]"}], "\[Equal]", 
  RowBox[{
   RowBox[{"-", 
    RowBox[{"Log", "[", "r1", "]"}]}], "+", 
   RowBox[{"\[ScriptCapitalC]", "*", 
    RowBox[{"Log", "[", 
     FractionBox[
      SuperscriptBox["r1", 
       RowBox[{"[", 
        RowBox[{"+", "o"}], "]"}]], 
      SuperscriptBox[
       OverscriptBox["r1", "_"], 
       RowBox[{"[", 
        RowBox[{"-", "o"}], "]"}]]], "]"}]}]}]}]], "Input",
 CellChangeTimes->{{3.546241321841227*^9, 3.546241388077382*^9}, {
  3.5533142565207872`*^9, 3.5533143010081987`*^9}, {3.5533143374767933`*^9, 
  3.553314338374919*^9}}],

Cell[TextData[{
 "In the following we will always use combination ",
 Cell[BoxData[
  RowBox[{
   FractionBox[
    SubscriptBox["Y", 
     RowBox[{"1", ",", "1"}]], 
    SubscriptBox["Y", 
     RowBox[{"2", ",", "2"}]]], "r2"}]]],
 ". Hence explicitly one has"
}], "Text",
 CellChangeTimes->{{3.553314302731011*^9, 3.553314332273674*^9}, {
  3.553314613909835*^9, 3.5533146164230328`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Log", "[", 
   RowBox[{
    FractionBox[
     SubscriptBox["Y", 
      RowBox[{"1", ",", "1"}]], 
     SubscriptBox["Y", 
      RowBox[{"2", ",", "2"}]]], 
    FractionBox[
     SubsuperscriptBox[
      StyleBox["\[GothicCapitalT]",
       FontColor->RGBColor[0.54, 0.35, 0.15]], 
      RowBox[{"2", ",", "1"}], "2"], 
     SubsuperscriptBox[
      StyleBox["\[ScriptCapitalT]",
       FontColor->RGBColor[1, 0, 0]], 
      RowBox[{"1", ",", "2"}], "2"]]}], "]"}], "\[Equal]", 
  RowBox[{
   RowBox[{"Log", "[", 
    FractionBox[
     SubscriptBox[
      StyleBox["\[GothicCapitalT]",
       FontColor->RGBColor[0.54, 0.35, 0.15]], 
      RowBox[{"1", ",", "0"}]], 
     SubsuperscriptBox[
      StyleBox["\[GothicCapitalT]",
       FontColor->RGBColor[0.54, 0.35, 0.15]], 
      RowBox[{"0", ",", "0"}], "-"]], "]"}], "-", 
   RowBox[{"Log", "[", 
    SuperscriptBox[
     RowBox[{"(", 
      FractionBox[
       RowBox[{" ", 
        SuperscriptBox[
         StyleBox["\[ScriptCapitalT]",
          FontColor->RGBColor[1, 0, 0]], "-"], " "}], 
       SuperscriptBox[
        StyleBox["\[GothicCapitalT]",
         FontColor->RGBColor[0.54, 0.35, 0.15]], "-"]], ")"}], "2"], "]"}], 
   "+", 
   RowBox[{"\[ScriptCapitalC]", "*", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"-", 
       RowBox[{"Log", "[", 
        FractionBox[
         SubscriptBox[
          StyleBox["\[GothicCapitalT]",
           FontColor->RGBColor[0.54, 0.35, 0.15]], 
          RowBox[{"1", ",", "0"}]], 
         SubsuperscriptBox[
          StyleBox["\[GothicCapitalT]",
           FontColor->RGBColor[0.54, 0.35, 0.15]], 
          RowBox[{"0", ",", "0"}], "-"]], "]"}]}], "+", 
      RowBox[{"Log", "[", 
       SuperscriptBox[
        RowBox[{"(", 
         FractionBox[
          RowBox[{" ", 
           SuperscriptBox[
            StyleBox["\[ScriptCapitalT]",
             FontColor->RGBColor[1, 0, 0]], "-"], " "}], 
          SuperscriptBox[
           StyleBox["\[GothicCapitalT]",
            FontColor->RGBColor[0.54, 0.35, 0.15]], "-"]], ")"}], "2"], "]"}],
       "+", 
      RowBox[{"Log", "[", 
       FractionBox[
        SubscriptBox[
         StyleBox["\[GothicCapitalT]",
          FontColor->RGBColor[0.54, 0.35, 0.15]], 
         RowBox[{"1", ",", "0"}]], 
        SubsuperscriptBox[
         StyleBox["\[GothicCapitalT]",
          FontColor->RGBColor[0.54, 0.35, 0.15]], 
         RowBox[{"0", ",", "0"}], "+"]], "]"}], "-", 
      RowBox[{"Log", "[", 
       SuperscriptBox[
        RowBox[{"(", 
         FractionBox[
          RowBox[{" ", 
           SuperscriptBox[
            StyleBox["\[ScriptCapitalT]",
             FontColor->RGBColor[1, 0, 0]], "+"], " "}], 
          SuperscriptBox[
           StyleBox["\[GothicCapitalT]",
            FontColor->RGBColor[0.54, 0.35, 0.15]], "+"]], ")"}], "2"], 
       "]"}]}], ")"}]}]}]}]], "Input",
 CellChangeTimes->{{3.553314346569764*^9, 3.553314443360942*^9}, {
  3.553314541671711*^9, 3.553314552324584*^9}}],

Cell["\<\
This equation is correct in the UHP.\
\>", "Text",
 CellChangeTimes->{{3.553314718395152*^9, 3.553314725914995*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 "Asymptotic expression ",
 Cell[BoxData[
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     FractionBox[
      SubscriptBox["Y", 
       RowBox[{"1", ",", "1"}]], 
      SubscriptBox["Y", 
       RowBox[{"2", ",", "2"}]]], 
     FractionBox[
      SubsuperscriptBox[
       StyleBox["\[GothicCapitalT]",
        FontColor->RGBColor[0.54, 0.35, 0.15]], 
       RowBox[{"2", ",", "1"}], "2"], 
      SubsuperscriptBox[
       StyleBox["\[ScriptCapitalT]",
        FontColor->RGBColor[1, 0, 0]], 
       RowBox[{"1", ",", "2"}], "2"]]}], ")"}], "==", 
   RowBox[{
    SuperscriptBox[
     RowBox[{"(", 
      FractionBox["1", 
       RowBox[{
        SuperscriptBox[
         OverscriptBox[
          StyleBox["y",
           FontColor->RGBColor[0, 0.6, 0]], 
          StyleBox["^",
           FontColor->RGBColor[0, 0.6, 0]]], "-"], " ", 
        SuperscriptBox[
         OverscriptBox[
          StyleBox["y",
           FontColor->RGBColor[0, 0.6, 0]], 
          StyleBox["^",
           FontColor->RGBColor[0, 0.6, 0]]], "+"]}]], ")"}], "2"], 
    RowBox[{"(", 
     FractionBox[
      RowBox[{
       SuperscriptBox[
        StyleBox["\[GothicCapitalT]",
         FontColor->RGBColor[0.54, 0.35, 0.15]], "-"], 
       SubsuperscriptBox[
        StyleBox["\[GothicCapitalT]",
         FontColor->RGBColor[0.54, 0.35, 0.15]], "*", "-"], 
       SuperscriptBox[
        StyleBox["\[GothicCapitalT]",
         FontColor->RGBColor[0.54, 0.35, 0.15]], "+"], 
       SubsuperscriptBox[
        StyleBox["\[GothicCapitalT]",
         FontColor->RGBColor[0.54, 0.35, 0.15]], "*", "+"], " "}], 
      RowBox[{
       SuperscriptBox[
        StyleBox["\[ScriptCapitalT]",
         FontColor->RGBColor[1, 0, 0]], "-"], 
       SubsuperscriptBox[
        StyleBox["\[ScriptCapitalT]",
         FontColor->RGBColor[1, 0, 0]], "*", "-"], " ", 
       SuperscriptBox[
        StyleBox["\[ScriptCapitalT]",
         FontColor->RGBColor[1, 0, 0]], "+"], 
       SubsuperscriptBox[
        StyleBox["\[ScriptCapitalT]",
         FontColor->RGBColor[1, 0, 0]], "*", "+"]}]], ")"}]}], "\[Equal]", 
   RowBox[{
    SuperscriptBox[
     RowBox[{"(", 
      RowBox[{
       SuperscriptBox[
        OverscriptBox[
         StyleBox["y",
          FontColor->RGBColor[0, 0.6, 0]], 
         StyleBox["^",
          FontColor->RGBColor[0, 0.6, 0]]], "-"], " ", 
       SuperscriptBox[
        OverscriptBox[
         StyleBox["y",
          FontColor->RGBColor[0, 0.6, 0]], 
         StyleBox["^",
          FontColor->RGBColor[0, 0.6, 0]]], "+"]}], ")"}], "2"], 
    SuperscriptBox[
     RowBox[{"(", 
      FractionBox[
       RowBox[{
        SuperscriptBox[
         StyleBox["Bp",
          FontColor->RGBColor[0, 0.6, 0]], 
         RowBox[{"[", 
          RowBox[{"-", "2"}], "]"}]], " ", 
        SuperscriptBox[
         StyleBox["x",
          FontColor->RGBColor[0, 0.6, 0]], 
         RowBox[{"[", 
          RowBox[{"-", "2"}], "]"}]]}], 
       RowBox[{
        SuperscriptBox[
         StyleBox["Bm",
          FontColor->RGBColor[0, 0.6, 0]], 
         RowBox[{"[", 
          RowBox[{"+", "2"}], "]"}]], " ", 
        SuperscriptBox[
         StyleBox["x",
          FontColor->RGBColor[0, 0.6, 0]], 
         RowBox[{"[", 
          RowBox[{"+", "2"}], "]"}]]}]], ")"}], "2"], 
    RowBox[{"(", 
     FractionBox[
      SuperscriptBox[
       StyleBox["Q",
        FontColor->RGBColor[0.8, 0, 0]], "+"], 
      SuperscriptBox[
       StyleBox["Q",
        FontColor->RGBColor[0.8, 0, 0]], "-"]], ")"}]}]}]],
  CellChangeTimes->{{3.553322671838937*^9, 3.553322696403372*^9}}]
}], "Subsubsection",
 CellChangeTimes->{{3.5533141322279243`*^9, 3.553314137441065*^9}, {
  3.553317058206061*^9, 3.553317061875897*^9}, {3.5533227381212606`*^9, 
  3.553322739110907*^9}, {3.5533260532433443`*^9, 3.553326054998723*^9}}],

Cell["\<\
The final answer derived below is (expression is valid for asymptotic \
solution only):\
\>", "Text",
 CellChangeTimes->{{3.546256366772513*^9, 3.546256403321827*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"(", 
   RowBox[{
    FractionBox[
     SubscriptBox["Y", 
      RowBox[{"1", ",", "1"}]], 
     SubscriptBox["Y", 
      RowBox[{"2", ",", "2"}]]], 
    FractionBox[
     SubsuperscriptBox[
      StyleBox["\[GothicCapitalT]",
       FontColor->RGBColor[0.54, 0.35, 0.15]], 
      RowBox[{"2", ",", "1"}], "2"], 
     SubsuperscriptBox[
      StyleBox["\[ScriptCapitalT]",
       FontColor->RGBColor[1, 0, 0]], 
      RowBox[{"1", ",", "2"}], "2"]]}], ")"}], "\[Equal]", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["1", 
      RowBox[{
       SuperscriptBox[
        OverscriptBox[
         StyleBox["y",
          FontColor->RGBColor[0, 0.6, 0]], 
         StyleBox["^",
          FontColor->RGBColor[0, 0.6, 0]]], "-"], " ", 
       SuperscriptBox[
        OverscriptBox[
         StyleBox["y",
          FontColor->RGBColor[0, 0.6, 0]], 
         StyleBox["^",
          FontColor->RGBColor[0, 0.6, 0]]], "+"]}]], ")"}], "2"], 
   RowBox[{"(", 
    FractionBox[
     RowBox[{
      SuperscriptBox[
       StyleBox["\[GothicCapitalT]",
        FontColor->RGBColor[0.54, 0.35, 0.15]], "-"], 
      SubsuperscriptBox[
       StyleBox["\[GothicCapitalT]",
        FontColor->RGBColor[0.54, 0.35, 0.15]], "*", "-"], 
      SuperscriptBox[
       StyleBox["\[GothicCapitalT]",
        FontColor->RGBColor[0.54, 0.35, 0.15]], "+"], 
      SubsuperscriptBox[
       StyleBox["\[GothicCapitalT]",
        FontColor->RGBColor[0.54, 0.35, 0.15]], "*", "+"], " "}], 
     RowBox[{
      SuperscriptBox[
       StyleBox["\[ScriptCapitalT]",
        FontColor->RGBColor[1, 0, 0]], "-"], 
      SubsuperscriptBox[
       StyleBox["\[ScriptCapitalT]",
        FontColor->RGBColor[1, 0, 0]], "*", "-"], " ", 
      SuperscriptBox[
       StyleBox["\[ScriptCapitalT]",
        FontColor->RGBColor[1, 0, 0]], "+"], 
      SubsuperscriptBox[
       StyleBox["\[ScriptCapitalT]",
        FontColor->RGBColor[1, 0, 0]], "*", "+"]}]], ")"}]}]}]], "Input",
 CellChangeTimes->{{3.546320445860468*^9, 3.546320446268859*^9}, {
   3.5533218577710657`*^9, 3.5533219961037807`*^9}, 3.553322564209901*^9}],

Cell["\<\
There is a nice explicit formula discussd in the first subsection of the \
current section:\
\>", "Text",
 CellChangeTimes->{{3.550204413929832*^9, 3.550204427947484*^9}, 
   3.553322005745345*^9, {3.553322538903615*^9, 3.5533225483411903`*^9}}],

Cell[BoxData[
 RowBox[{
  FractionBox[
   StyleBox["\[GothicCapitalT]",
    FontColor->RGBColor[0.54, 0.35, 0.15]], 
   StyleBox["\[ScriptCapitalT]",
    FontColor->RGBColor[1, 0, 0]]], "\[Equal]", 
  RowBox[{
   FractionBox[
    RowBox[{
     SuperscriptBox[
      StyleBox["Bp",
       FontColor->RGBColor[0, 0.6, 0]], "-"], " ", 
     SuperscriptBox[
      StyleBox["x",
       FontColor->RGBColor[0, 0.6, 0]], "-"]}], 
    RowBox[{
     SuperscriptBox[
      StyleBox["Bm",
       FontColor->RGBColor[0, 0.6, 0]], "+"], " ", 
     SuperscriptBox[
      StyleBox["x",
       FontColor->RGBColor[0, 0.6, 0]], "+"]}]], 
   SuperscriptBox[
    OverscriptBox[
     StyleBox["y",
      FontColor->RGBColor[0, 0.6, 0]], 
     StyleBox["^",
      FontColor->RGBColor[0, 0.6, 0]]], "-"], " ", 
   SuperscriptBox[
    OverscriptBox[
     StyleBox["y",
      FontColor->RGBColor[0, 0.6, 0]], 
     StyleBox["^",
      FontColor->RGBColor[0, 0.6, 0]]], "+"]}]}]], "Input",
 CellChangeTimes->{{3.550204430455282*^9, 3.550204464364326*^9}, 
   3.5502089798203773`*^9, 3.553322537357375*^9}],

Cell["It leads to:", "Text",
 CellChangeTimes->{{3.55020974767595*^9, 3.550209752106165*^9}}],

Cell[BoxData[
 RowBox[{
  SuperscriptBox[
   StyleBox[
    RowBox[{"(", 
     FractionBox[
      RowBox[{
       SuperscriptBox[
        StyleBox["Bp",
         FontColor->RGBColor[0, 0.6, 0]], 
        RowBox[{"[", 
         RowBox[{"-", "2"}], "]"}]], " ", 
       SuperscriptBox[
        StyleBox["x",
         FontColor->RGBColor[0, 0.6, 0]], 
        RowBox[{"[", 
         RowBox[{"-", "2"}], "]"}]]}], 
      RowBox[{
       SuperscriptBox[
        StyleBox["Bm",
         FontColor->RGBColor[0, 0.6, 0]], 
        RowBox[{"[", 
         RowBox[{"+", "2"}], "]"}]], " ", 
       SuperscriptBox[
        StyleBox["x",
         FontColor->RGBColor[0, 0.6, 0]], 
        RowBox[{"[", 
         RowBox[{"+", "2"}], "]"}]]}]], ")"}], "Subsubsection"], "2"], 
  RowBox[{"(", 
   FractionBox[
    SuperscriptBox[
     StyleBox["Q",
      FontColor->RGBColor[0.8, 0, 0]], "+"], 
    SuperscriptBox[
     StyleBox["Q",
      FontColor->RGBColor[0.8, 0, 0]], "-"]], ")"}]}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(", 
   RowBox[{
    FractionBox[
     SubscriptBox["Y", 
      RowBox[{"1", ",", "1"}]], 
     SubscriptBox["Y", 
      RowBox[{"2", ",", "2"}]]], 
    FractionBox[
     SubsuperscriptBox[
      StyleBox["\[GothicCapitalT]",
       FontColor->RGBColor[0.54, 0.35, 0.15]], 
      RowBox[{"2", ",", "1"}], "2"], 
     SubsuperscriptBox[
      StyleBox["\[ScriptCapitalT]",
       FontColor->RGBColor[1, 0, 0]], 
      RowBox[{"1", ",", "2"}], "2"]]}], ")"}], "==", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     RowBox[{
      SuperscriptBox[
       OverscriptBox[
        StyleBox["y",
         FontColor->RGBColor[0, 0.6, 0]], 
        StyleBox["^",
         FontColor->RGBColor[0, 0.6, 0]]], "-"], " ", 
      SuperscriptBox[
       OverscriptBox[
        StyleBox["y",
         FontColor->RGBColor[0, 0.6, 0]], 
        StyleBox["^",
         FontColor->RGBColor[0, 0.6, 0]]], "+"]}], ")"}], "2"], 
   RowBox[{"(", 
    RowBox[{
     FractionBox[
      RowBox[{
       SuperscriptBox[
        StyleBox["Bp",
         FontColor->RGBColor[0, 0.6, 0]], 
        RowBox[{"[", 
         RowBox[{"-", "2"}], "]"}]], " ", 
       SuperscriptBox[
        StyleBox["x",
         FontColor->RGBColor[0, 0.6, 0]], 
        RowBox[{"[", 
         RowBox[{"-", "2"}], "]"}]]}], 
      RowBox[{
       StyleBox["Bm",
        FontColor->RGBColor[0, 0.6, 0]], " ", 
       StyleBox["x",
        FontColor->RGBColor[0, 0.6, 0]]}]], 
     FractionBox[
      RowBox[{
       SuperscriptBox[
        StyleBox["Bp",
         FontColor->RGBColor[0, 0.6, 0]], 
        RowBox[{"[", 
         RowBox[{"-", "2"}], "]"}]], " ", 
       SuperscriptBox[
        StyleBox["x",
         FontColor->RGBColor[0, 0.6, 0]], 
        RowBox[{"[", 
         RowBox[{"-", "2"}], "]"}]]}], 
      FractionBox[
       StyleBox["Rm",
        FontColor->RGBColor[0, 0.6, 0]], 
       StyleBox["x",
        FontColor->RGBColor[0, 0.6, 0]]]], 
     FractionBox[
      RowBox[{
       StyleBox["Bp",
        FontColor->RGBColor[0, 0.6, 0]], " ", 
       StyleBox["x",
        FontColor->RGBColor[0, 0.6, 0]]}], 
      RowBox[{
       SuperscriptBox[
        StyleBox["Bm",
         FontColor->RGBColor[0, 0.6, 0]], 
        RowBox[{"[", 
         RowBox[{"+", "2"}], "]"}]], " ", 
       SuperscriptBox[
        StyleBox["x",
         FontColor->RGBColor[0, 0.6, 0]], 
        RowBox[{"[", 
         RowBox[{"+", "2"}], "]"}]]}]], 
     FractionBox[
      FractionBox[
       StyleBox["Rp",
        FontColor->RGBColor[0, 0.6, 0]], 
       StyleBox["x",
        FontColor->RGBColor[0, 0.6, 0]]], 
      RowBox[{
       SuperscriptBox[
        StyleBox["Bm",
         FontColor->RGBColor[0, 0.6, 0]], 
        RowBox[{"[", 
         RowBox[{"+", "2"}], "]"}]], " ", 
       SuperscriptBox[
        StyleBox["x",
         FontColor->RGBColor[0, 0.6, 0]], 
        RowBox[{"[", 
         RowBox[{"+", "2"}], "]"}]]}]]}], ")"}]}]}]], "Input",
 CellChangeTimes->{{3.5502045038331957`*^9, 3.550204677551512*^9}, {
  3.5502079139079113`*^9, 3.550207925244198*^9}, {3.550209708065301*^9, 
  3.550209717827134*^9}, {3.550209755163313*^9, 3.5502097552879972`*^9}, {
  3.553322013328314*^9, 3.5533220229327793`*^9}, {3.553322575529455*^9, 
  3.5533226635729322`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"(", 
   RowBox[{
    FractionBox[
     SubscriptBox["Y", 
      RowBox[{"1", ",", "1"}]], 
     SubscriptBox["Y", 
      RowBox[{"2", ",", "2"}]]], 
    FractionBox[
     SubsuperscriptBox[
      StyleBox["\[GothicCapitalT]",
       FontColor->RGBColor[0.54, 0.35, 0.15]], 
      RowBox[{"2", ",", "1"}], "2"], 
     SubsuperscriptBox[
      StyleBox["\[ScriptCapitalT]",
       FontColor->RGBColor[1, 0, 0]], 
      RowBox[{"1", ",", "2"}], "2"]]}], ")"}], "==", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     RowBox[{
      SuperscriptBox[
       OverscriptBox[
        StyleBox["y",
         FontColor->RGBColor[0, 0.6, 0]], 
        StyleBox["^",
         FontColor->RGBColor[0, 0.6, 0]]], "-"], " ", 
      SuperscriptBox[
       OverscriptBox[
        StyleBox["y",
         FontColor->RGBColor[0, 0.6, 0]], 
        StyleBox["^",
         FontColor->RGBColor[0, 0.6, 0]]], "+"]}], ")"}], "2"], 
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox[
      RowBox[{
       SuperscriptBox[
        StyleBox["Bp",
         FontColor->RGBColor[0, 0.6, 0]], 
        RowBox[{"[", 
         RowBox[{"-", "2"}], "]"}]], " ", 
       SuperscriptBox[
        StyleBox["x",
         FontColor->RGBColor[0, 0.6, 0]], 
        RowBox[{"[", 
         RowBox[{"-", "2"}], "]"}]]}], 
      RowBox[{
       SuperscriptBox[
        StyleBox["Bm",
         FontColor->RGBColor[0, 0.6, 0]], 
        RowBox[{"[", 
         RowBox[{"+", "2"}], "]"}]], " ", 
       SuperscriptBox[
        StyleBox["x",
         FontColor->RGBColor[0, 0.6, 0]], 
        RowBox[{"[", 
         RowBox[{"+", "2"}], "]"}]]}]], ")"}], "2"], 
   RowBox[{"(", 
    FractionBox[
     SuperscriptBox[
      StyleBox["Q",
       FontColor->RGBColor[0.8, 0, 0]], "+"], 
     SuperscriptBox[
      StyleBox["Q",
       FontColor->RGBColor[0.8, 0, 0]], "-"]], ")"}]}]}]], "Input",
 CellChangeTimes->{{3.553322671838937*^9, 3.553322696403372*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["\<\
Derivation of asymptotic expression and checking the consistency with magic \
ratios\
\>", "Subsubsection",
 CellChangeTimes->{{3.548390187697459*^9, 3.5483901920725603`*^9}, {
  3.553322707963181*^9, 3.5533227464743547`*^9}, {3.553322795569809*^9, 
  3.5533227984997272`*^9}, {3.553326067827899*^9, 3.553326071222414*^9}}],

Cell["\<\
The goal is to compute integral in expression for Y11/Y22 analytically. We \
use the one with integration over real axis:\
\>", "Text",
 CellChangeTimes->{{3.553322949704968*^9, 3.553322964181427*^9}, {
  3.5533231460257177`*^9, 3.553323154654283*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Log", "[", 
   RowBox[{
    FractionBox[
     SubscriptBox["Y", 
      RowBox[{"1", ",", "1"}]], 
     SubscriptBox["Y", 
      RowBox[{"2", ",", "2"}]]], 
    FractionBox[
     SubsuperscriptBox[
      StyleBox["\[GothicCapitalT]",
       FontColor->RGBColor[0.54, 0.35, 0.15]], 
      RowBox[{"2", ",", "1"}], "2"], 
     SubsuperscriptBox[
      StyleBox["\[ScriptCapitalT]",
       FontColor->RGBColor[1, 0, 0]], 
      RowBox[{"1", ",", "2"}], "2"]]}], "]"}], "\[Equal]", 
  RowBox[{
   RowBox[{
    SubsuperscriptBox["\[Integral]", 
     RowBox[{
      RowBox[{"-", "\[Infinity]"}], "+", 
      RowBox[{"\[ImaginaryI]", " ", "0"}]}], 
     RowBox[{
      RowBox[{"+", "\[Infinity]"}], "+", 
      RowBox[{"\[ImaginaryI]", " ", "0"}]}]], 
    RowBox[{
     FractionBox["dv", 
      RowBox[{"2", "\[Pi]", " ", "\[ImaginaryI]"}]], 
     FractionBox["1", 
      RowBox[{"u", "-", "v"}]], 
     RowBox[{"(", 
      RowBox[{"Log", "[", 
       RowBox[{
        FractionBox[
         SubsuperscriptBox[
          StyleBox["\[GothicCapitalT]",
           FontColor->RGBColor[0.54, 0.35, 0.15]], 
          RowBox[{"0", ",", "0"}], "-"], 
         SubscriptBox[
          StyleBox["\[GothicCapitalT]",
           FontColor->RGBColor[0.54, 0.35, 0.15]], 
          RowBox[{"1", ",", "0"}]]], 
        SuperscriptBox[
         RowBox[{"(", 
          FractionBox[
           RowBox[{" ", 
            SuperscriptBox[
             StyleBox["\[ScriptCapitalT]",
              FontColor->RGBColor[1, 0, 0]], "-"], " "}], 
           SuperscriptBox[
            StyleBox["\[GothicCapitalT]",
             FontColor->RGBColor[0.54, 0.35, 0.15]], "-"]], ")"}], "2"]}], 
       "]"}], ")"}]}]}], "+", 
   RowBox[{"c", ".", "c", "."}]}]}]], "Input",
 CellChangeTimes->{{3.5533231341314087`*^9, 3.553323222508029*^9}}],

Cell[TextData[{
 "This integral seems a  hard one at first, because the contour of \
integration is confined between two cuts of ratio ",
 Cell[BoxData[
  FractionBox[
   RowBox[{
    SuperscriptBox[
     RowBox[{"(", 
      SuperscriptBox[
       StyleBox["\[ScriptCapitalT]",
        FontColor->RGBColor[1, 0, 0]], "-"], ")"}], "2"], " "}], 
   SuperscriptBox[
    RowBox[{"(", 
     SuperscriptBox[
      StyleBox["\[GothicCapitalT]",
       FontColor->RGBColor[0.54, 0.35, 0.15]], "-"], ")"}], "2"]]],
  CellChangeTimes->{{3.538804375043168*^9, 3.538804457536518*^9}, {
   3.538804503216818*^9, 3.538804580953148*^9}, {3.538805052945331*^9, 
   3.538805093652042*^9}, {3.538805130547708*^9, 3.538805241408742*^9}, {
   3.538805319991477*^9, 3.538805320407432*^9}, {3.546240026684054*^9, 
   3.546240048300362*^9}, {3.54624077003244*^9, 3.546240776573571*^9}, {
   3.546241599161903*^9, 3.5462416044518633`*^9}}],
 ". However there is a remarkable property which will help:"
}], "Text",
 CellChangeTimes->{{3.5462507213030376`*^9, 3.546250853236312*^9}, {
  3.553322979082329*^9, 3.553322989661545*^9}, {3.5533230847722263`*^9, 
  3.553323089986238*^9}, {3.553323121935832*^9, 3.55332312524743*^9}, {
  3.5533231978102217`*^9, 3.553323245642905*^9}}],

Cell[BoxData[
 RowBox[{
  FractionBox[
   StyleBox["\[GothicCapitalT]",
    FontColor->RGBColor[0.54, 0.35, 0.15]], 
   SubscriptBox[
    StyleBox["\[ScriptCapitalT]",
     FontColor->RGBColor[1, 0, 0]], 
    RowBox[{
     SubscriptBox["\[Gamma]", "+"], ",", 
     SubscriptBox["\[Gamma]", "-"]}]]], "==", 
  RowBox[{
   SuperscriptBox[
    OverscriptBox[
     StyleBox["y",
      FontColor->RGBColor[0, 0.6, 0]], 
     StyleBox["^",
      FontColor->RGBColor[0, 0.6, 0]]], "-"], " ", 
   SuperscriptBox[
    OverscriptBox[
     StyleBox["y",
      FontColor->RGBColor[0, 0.6, 0]], 
     StyleBox["^",
      FontColor->RGBColor[0, 0.6, 0]]], "+"]}]}]], "Input",
 CellChangeTimes->{{3.550229808510084*^9, 3.550229840508202*^9}, {
  3.550229899945557*^9, 3.550229900050095*^9}, {3.553233465660474*^9, 
  3.553233466113317*^9}, {3.553323056472356*^9, 3.553323119542131*^9}}],

Cell[TextData[{
 "Let us represent the ratio ",
 Cell[BoxData[
  FractionBox[
   RowBox[{
    SuperscriptBox[
     RowBox[{"(", 
      SuperscriptBox[
       StyleBox["\[ScriptCapitalT]",
        FontColor->RGBColor[1, 0, 0]], "-"], ")"}], "2"], " "}], 
   SuperscriptBox[
    RowBox[{"(", 
     SuperscriptBox[
      StyleBox["\[GothicCapitalT]",
       FontColor->RGBColor[0.54, 0.35, 0.15]], "-"], ")"}], "2"]]],
  CellChangeTimes->{{3.538804375043168*^9, 3.538804457536518*^9}, {
   3.538804503216818*^9, 3.538804580953148*^9}, {3.538805052945331*^9, 
   3.538805093652042*^9}, {3.538805130547708*^9, 3.538805241408742*^9}, {
   3.538805319991477*^9, 3.538805320407432*^9}, {3.546240026684054*^9, 
   3.546240048300362*^9}, {3.54624077003244*^9, 3.546240776573571*^9}, {
   3.546241599161903*^9, 3.5462416044518633`*^9}}],
 " as"
}], "Text",
 CellChangeTimes->{{3.5462508554834433`*^9, 3.546250873378798*^9}, {
  3.553323269683675*^9, 3.553323269897892*^9}}],

Cell[BoxData[
 RowBox[{
  FractionBox[
   RowBox[{
    SuperscriptBox[
     RowBox[{"(", 
      SuperscriptBox[
       StyleBox["\[ScriptCapitalT]",
        FontColor->RGBColor[1, 0, 0]], "-"], ")"}], "2"], " "}], 
   SuperscriptBox[
    RowBox[{"(", 
     SuperscriptBox[
      StyleBox["\[GothicCapitalT]",
       FontColor->RGBColor[0.54, 0.35, 0.15]], "-"], ")"}], "2"]], "=", 
  RowBox[{
   RowBox[{
    RowBox[{"(", 
     RowBox[{"\[ScriptCapitalA]", 
      FractionBox[
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          SuperscriptBox[
           StyleBox["\[ScriptCapitalT]",
            FontColor->RGBColor[1, 0, 0]], "-"], 
          SubsuperscriptBox[
           StyleBox["\[ScriptCapitalT]",
            FontColor->RGBColor[1, 0, 0]], "*", "-"]}], ")"}], " "}], 
       RowBox[{"(", 
        RowBox[{
         SuperscriptBox[
          StyleBox["\[GothicCapitalT]",
           FontColor->RGBColor[0.54, 0.35, 0.15]], "-"], 
         SubsuperscriptBox[
          StyleBox["\[GothicCapitalT]",
           FontColor->RGBColor[0.54, 0.35, 0.15]], "*", "-"]}], ")"}]]}], 
     ")"}], 
    RowBox[{"(", 
     RowBox[{
      FractionBox["1", "\[ScriptCapitalA]"], 
      FractionBox[
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          SuperscriptBox[
           StyleBox["\[ScriptCapitalT]",
            FontColor->RGBColor[1, 0, 0]], "-"], 
          SubsuperscriptBox[
           StyleBox["\[GothicCapitalT]",
            FontColor->RGBColor[0.54, 0.35, 0.15]], "*", "-"]}], ")"}], " "}], 
       RowBox[{"(", 
        RowBox[{
         SuperscriptBox[
          StyleBox["\[GothicCapitalT]",
           FontColor->RGBColor[0.54, 0.35, 0.15]], "-"], 
         SubsuperscriptBox[
          StyleBox["\[ScriptCapitalT]",
           FontColor->RGBColor[1, 0, 0]], "*", "-"]}], ")"}]]}], ")"}]}], "=", 
   RowBox[{"f1", "\[Cross]", "f2"}]}]}]], "Input",
 CellChangeTimes->{{3.5462508749486094`*^9, 3.546250935019807*^9}, {
  3.5462509740368137`*^9, 3.546250984808712*^9}}],

Cell[TextData[{
 "where \[ScriptCapitalA] is a constant which insures that f1 and f2 approach \
1 at inifnity. f1 clearly does not have a branch cut on the real axis. What \
is highly nontrivial is that f2 has no ",
 Cell[BoxData[
  FormBox[
   SubscriptBox["Z", 
    RowBox[{"-", "2"}]], TraditionalForm]]],
 " branch cut! We checked that both numerically and analytically."
}], "Text",
 CellChangeTimes->{{3.5462509403057756`*^9, 3.5462510393480263`*^9}, {
   3.5462512637397623`*^9, 3.5462512780989513`*^9}, {3.5472666672000732`*^9, 
   3.547266677245755*^9}, 3.5533234294807253`*^9, {3.568964163924481*^9, 
   3.56896417892276*^9}}],

Cell[TextData[{
 "Therefore f1 has only ",
 Cell[BoxData[
  FormBox[
   SubscriptBox["Z", 
    RowBox[{"-", "2"}]], TraditionalForm]]],
 " cut and f2 has only ",
 Cell[BoxData[
  FormBox[
   SubscriptBox["Z", "0"], TraditionalForm]]],
 " cut therefore integration can be done explicitly. \nf1 should be closed \
below, there seems no poles, therefore the answer will be given by the \
residue coming from ",
 Cell[BoxData[
  FractionBox["1", 
   RowBox[{"u", "-", 
    RowBox[{"(", 
     RowBox[{"v", "+", 
      RowBox[{"\[ImaginaryI]", " ", "0"}]}], ")"}]}]]],
  CellChangeTimes->{{3.546241500752057*^9, 3.5462415203083067`*^9}}],
 ":"
}], "Text",
 CellChangeTimes->{{3.546251285523652*^9, 3.546251386250147*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"2", " ", "Re", " ", 
   RowBox[{
    SubsuperscriptBox["\[Integral]", 
     RowBox[{"-", "\[Infinity]"}], 
     RowBox[{"+", "\[Infinity]"}]], 
    RowBox[{
     FractionBox["dv", 
      RowBox[{
       RowBox[{"-", "2"}], "\[Pi]", " ", "\[ImaginaryI]"}]], 
     FractionBox["1", 
      RowBox[{"u", "-", 
       RowBox[{"(", 
        RowBox[{"v", "+", 
         RowBox[{"\[ImaginaryI]", " ", "0"}]}], ")"}]}]], 
     RowBox[{
      RowBox[{"Log", "[", 
       RowBox[{"(", 
        RowBox[{"\[ScriptCapitalA]", 
         FractionBox[
          RowBox[{
           RowBox[{"(", 
            RowBox[{
             SuperscriptBox[
              StyleBox["\[ScriptCapitalT]",
               FontColor->RGBColor[1, 0, 0]], "-"], 
             SubsuperscriptBox[
              StyleBox["\[ScriptCapitalT]",
               FontColor->RGBColor[1, 0, 0]], "*", "-"]}], ")"}], " "}], 
          RowBox[{"(", 
           RowBox[{
            SuperscriptBox[
             StyleBox["\[GothicCapitalT]",
              FontColor->RGBColor[0.54, 0.35, 0.15]], "-"], 
            SubsuperscriptBox[
             StyleBox["\[GothicCapitalT]",
              FontColor->RGBColor[0.54, 0.35, 0.15]], "*", "-"]}], ")"}]]}], 
        ")"}], "]"}], "[", 
      RowBox[{"v", "+", 
       RowBox[{"\[ImaginaryI]", " ", "0"}]}], "]"}]}]}]}], " ", "=", 
  RowBox[{
   RowBox[{"-", "2"}], "Re", " ", 
   RowBox[{"Log", "[", 
    RowBox[{"(", 
     RowBox[{"\[ScriptCapitalA]", 
      FractionBox[
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          SuperscriptBox[
           StyleBox["\[ScriptCapitalT]",
            FontColor->RGBColor[1, 0, 0]], "-"], 
          SubsuperscriptBox[
           StyleBox["\[ScriptCapitalT]",
            FontColor->RGBColor[1, 0, 0]], "*", "-"]}], ")"}], " "}], 
       RowBox[{"(", 
        RowBox[{
         SuperscriptBox[
          StyleBox["\[GothicCapitalT]",
           FontColor->RGBColor[0.54, 0.35, 0.15]], "-"], 
         SubsuperscriptBox[
          StyleBox["\[GothicCapitalT]",
           FontColor->RGBColor[0.54, 0.35, 0.15]], "*", "-"]}], ")"}]]}], 
     ")"}], "]"}]}]}]], "Input",
 CellChangeTimes->{{3.54625139542875*^9, 3.54625141913811*^9}}],

Cell["\<\
This was checked numerically, which assured that no poles where missed.\
\>", "Text",
 CellChangeTimes->{{3.5462514395099792`*^9, 3.546251453755743*^9}, {
  3.55332335825773*^9, 3.55332337445529*^9}}],

Cell[TextData[{
 "Now we integrage f2 term. For this we close the contour above. f1 seems to \
have poles at Bethe roots ",
 Cell[BoxData[
  FormBox[
   FractionBox[
    RowBox[{"+", "\[ImaginaryI]"}], "2"], TraditionalForm]]],
 ", but they will be compensated from ",
 Cell[BoxData[
  FractionBox[
   RowBox[{
    SubsuperscriptBox[
     StyleBox["\[GothicCapitalT]",
      FontColor->RGBColor[0.54, 0.35, 0.15]], 
     RowBox[{"0", ",", "0"}], "-"], "  "}], 
   RowBox[{" ", 
    SubscriptBox[
     StyleBox["\[GothicCapitalT]",
      FontColor->RGBColor[0.54, 0.35, 0.15]], 
     RowBox[{"1", ",", "0"}]], " "}]]],
  CellChangeTimes->{{3.546241500752057*^9, 3.5462415203083067`*^9}}],
 ". Our conclusion that this integration will give zero. This was checked \
numerically"
}], "Text",
 CellChangeTimes->{{3.546251830174457*^9, 3.5462519010904016`*^9}, {
  3.546252059221324*^9, 3.546252059301098*^9}, {3.553323475822192*^9, 
  3.5533234796865*^9}}],

Cell["So, we get the complete answer", "Text",
 CellChangeTimes->{{3.54625244899824*^9, 3.546252470771945*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Log", "[", 
   RowBox[{
    FractionBox[
     SubscriptBox["Y", 
      RowBox[{"1", ",", "1"}]], 
     SubscriptBox["Y", 
      RowBox[{"2", ",", "2"}]]], 
    FractionBox[
     SubsuperscriptBox[
      StyleBox["\[GothicCapitalT]",
       FontColor->RGBColor[0.54, 0.35, 0.15]], 
      RowBox[{"2", ",", "1"}], "2"], 
     SubsuperscriptBox[
      StyleBox["\[ScriptCapitalT]",
       FontColor->RGBColor[1, 0, 0]], 
      RowBox[{"1", ",", "2"}], "2"]]}], "]"}], "\[Equal]", 
  RowBox[{
   RowBox[{"-", "2"}], "Re", " ", 
   RowBox[{"Log", "[", 
    RowBox[{"(", 
     RowBox[{"\[ScriptCapitalA]", 
      FractionBox[
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          SuperscriptBox[
           StyleBox["\[ScriptCapitalT]",
            FontColor->RGBColor[1, 0, 0]], "-"], 
          SubsuperscriptBox[
           StyleBox["\[ScriptCapitalT]",
            FontColor->RGBColor[1, 0, 0]], "*", "-"]}], ")"}], " "}], 
       RowBox[{"(", 
        RowBox[{
         SuperscriptBox[
          StyleBox["\[GothicCapitalT]",
           FontColor->RGBColor[0.54, 0.35, 0.15]], "-"], 
         SubsuperscriptBox[
          StyleBox["\[GothicCapitalT]",
           FontColor->RGBColor[0.54, 0.35, 0.15]], "*", "-"]}], ")"}]]}], 
     ")"}], "]"}]}], "==", " ", 
  RowBox[{"Log", "[", 
   RowBox[{
    SuperscriptBox["\[ScriptCapitalA]", "2"], 
    FractionBox[
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        SuperscriptBox[
         StyleBox["\[ScriptCapitalT]",
          FontColor->RGBColor[1, 0, 0]], "-"], 
        SubsuperscriptBox[
         StyleBox["\[ScriptCapitalT]",
          FontColor->RGBColor[1, 0, 0]], "*", "-"]}], ")"}], " "}], 
     RowBox[{"(", 
      RowBox[{
       SuperscriptBox[
        StyleBox["\[GothicCapitalT]",
         FontColor->RGBColor[0.54, 0.35, 0.15]], "-"], 
       SubsuperscriptBox[
        StyleBox["\[GothicCapitalT]",
         FontColor->RGBColor[0.54, 0.35, 0.15]], "*", "-"]}], ")"}]], 
    FractionBox[
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        SuperscriptBox[
         StyleBox["\[ScriptCapitalT]",
          FontColor->RGBColor[1, 0, 0]], "+"], 
        SubsuperscriptBox[
         StyleBox["\[ScriptCapitalT]",
          FontColor->RGBColor[1, 0, 0]], "*", "+"]}], ")"}], " "}], 
     RowBox[{"(", 
      RowBox[{
       SuperscriptBox[
        StyleBox["\[GothicCapitalT]",
         FontColor->RGBColor[0.54, 0.35, 0.15]], "+"], 
       SubsuperscriptBox[
        StyleBox["\[GothicCapitalT]",
         FontColor->RGBColor[0.54, 0.35, 0.15]], "*", "+"]}], ")"}]]}], 
   "]"}]}]], "Input",
 CellChangeTimes->{{3.553323527162311*^9, 3.553323565713585*^9}}],

Cell[TextData[{
 "\[ScriptCapitalA] can be found from explicit relation ",
 Cell[BoxData[
  RowBox[{
   FractionBox[
    StyleBox["\[GothicCapitalT]",
     FontColor->RGBColor[0.54, 0.35, 0.15]], 
    StyleBox["\[ScriptCapitalT]",
     FontColor->RGBColor[1, 0, 0]]], "\[Equal]", 
   RowBox[{
    FractionBox[
     RowBox[{
      SuperscriptBox[
       StyleBox["Bp",
        FontColor->RGBColor[0, 0.6, 0]], "-"], " ", 
      SuperscriptBox[
       StyleBox["x",
        FontColor->RGBColor[0, 0.6, 0]], "-"]}], 
     RowBox[{
      SuperscriptBox[
       StyleBox["Bm",
        FontColor->RGBColor[0, 0.6, 0]], "+"], " ", 
      SuperscriptBox[
       StyleBox["x",
        FontColor->RGBColor[0, 0.6, 0]], "+"]}]], 
    SuperscriptBox[
     OverscriptBox[
      StyleBox["y",
       FontColor->RGBColor[0, 0.6, 0]], 
      StyleBox["^",
       FontColor->RGBColor[0, 0.6, 0]]], "-"], " ", 
    SuperscriptBox[
     OverscriptBox[
      StyleBox["y",
       FontColor->RGBColor[0, 0.6, 0]], 
      StyleBox["^",
       FontColor->RGBColor[0, 0.6, 0]]], "+"]}]}]],
  CellChangeTimes->{{3.550204430455282*^9, 3.550204464364326*^9}, 
    3.5502089798203773`*^9, 3.553322537357375*^9}],
 " which shows that ",
 Cell[BoxData[
  FormBox[
   RowBox[{"\[ScriptCapitalA]", "=", 
    FractionBox["1", 
     RowBox[{
      SuperscriptBox[
       OverscriptBox[
        StyleBox["y",
         FontColor->RGBColor[0, 0.6, 0]], 
        StyleBox["^",
         FontColor->RGBColor[0, 0.6, 0]]], "-"], " ", 
      SuperscriptBox[
       OverscriptBox[
        StyleBox["y",
         FontColor->RGBColor[0, 0.6, 0]], 
        StyleBox["^",
         FontColor->RGBColor[0, 0.6, 0]]], "+"]}]]}], TraditionalForm]],
  FormatType->"TraditionalForm"],
 "."
}], "Text",
 CellChangeTimes->{{3.55332368572861*^9, 3.553323738120117*^9}}],

Cell["\<\
The obtained formula is now to be checked against what follows from magic \
ratios.\
\>", "Text",
 CellChangeTimes->{{3.546253432431747*^9, 3.546253442910006*^9}, {
  3.553323597878199*^9, 3.553323600959244*^9}, {3.553323747447933*^9, 
  3.553323749798633*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{"#", "/.", "subYtYoY"}], ")"}], "==", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"#", "/.", "subYT"}], "/.", 
       RowBox[{"T$", "\[Rule]", "T$r"}]}], ")"}]}], "}"}], "&"}], "[", 
  "magicratioright", "]"}]], "Input",
 CellChangeTimes->{{3.546253445164933*^9, 3.546253474910439*^9}, {
   3.546253543135158*^9, 3.546253546315496*^9}, 3.5462536625030622`*^9, {
   3.546255723971923*^9, 3.5462557693572407`*^9}, {3.553323757653782*^9, 
   3.553323767273448*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   FractionBox[
    RowBox[{"1", "+", 
     SubscriptBox[
      StyleBox["Y",
       FontColor->RGBColor[0, 0, 0.8]], 
      RowBox[{"1", ",", "1"}]]}], 
    RowBox[{"1", "+", 
     FractionBox["1", 
      SubscriptBox[
       StyleBox["Y",
        FontColor->RGBColor[0, 0, 0.8]], 
       RowBox[{"2", ",", "2"}]]]}]], "\[Equal]", 
   FractionBox[
    RowBox[{
     SuperscriptBox[
      StyleBox["\[ScriptCapitalT]",
       FontColor->RGBColor[1, 0, 0]], "-"], " ", 
     SuperscriptBox[
      StyleBox["\[ScriptCapitalT]",
       FontColor->RGBColor[1, 0, 0]], "+"], " ", 
     SubscriptBox[
      StyleBox["\[ScriptCapitalT]",
       FontColor->RGBColor[1, 0, 0]], 
      RowBox[{"2", ",", "3"}]]}], 
    RowBox[{
     SubscriptBox[
      StyleBox["\[ScriptCapitalT]",
       FontColor->RGBColor[1, 0, 0]], 
      RowBox[{"0", ",", "1"}]], " ", 
     SubsuperscriptBox[
      StyleBox["\[ScriptCapitalT]",
       FontColor->RGBColor[1, 0, 0]], 
      RowBox[{"2", ",", "2"}], "-"], " ", 
     SubsuperscriptBox[
      StyleBox["\[ScriptCapitalT]",
       FontColor->RGBColor[1, 0, 0]], 
      RowBox[{"2", ",", "2"}], "+"]}]]}], "}"}]], "Output",
 CellChangeTimes->{
  3.5462557254275093`*^9, 3.546255770396208*^9, {3.553323762956068*^9, 
   3.553323767795874*^9}}]
}, Open  ]],

Cell["It is more transparent to write this relation as:", "Text",
 CellChangeTimes->{{3.546255773827737*^9, 3.546255792833666*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   FractionBox[
    RowBox[{"1", "+", 
     SubscriptBox[
      StyleBox["Y",
       FontColor->RGBColor[0, 0, 0.8]], 
      RowBox[{"1", ",", "1"}]]}], 
    RowBox[{"1", "+", 
     FractionBox["1", 
      SubscriptBox[
       StyleBox["Y",
        FontColor->RGBColor[0, 0, 0.8]], 
       RowBox[{"2", ",", "2"}]]]}]], "==", 
   RowBox[{
    FractionBox[
     SuperscriptBox[
      StyleBox["\[ScriptCapitalT]",
       FontColor->RGBColor[1, 0, 0]], 
      RowBox[{"[", 
       RowBox[{
        RowBox[{"-", "1"}], "-", "\[Epsilon]"}], "]"}]], 
     SuperscriptBox[
      OverscriptBox[
       StyleBox["\[ScriptCapitalT]",
        FontColor->RGBColor[1, 0, 0]], 
       StyleBox["^",
        FontColor->RGBColor[1, 0, 0]]], 
      RowBox[{"[", 
       RowBox[{
        RowBox[{"-", "1"}], "-", "\[Epsilon]"}], "]"}]]], " ", 
    FractionBox[
     SuperscriptBox[
      StyleBox["\[ScriptCapitalT]",
       FontColor->RGBColor[1, 0, 0]], 
      RowBox[{"[", 
       RowBox[{
        RowBox[{"+", "1"}], "+", "\[Epsilon]"}], "]"}]], 
     SuperscriptBox[
      OverscriptBox[
       StyleBox["\[ScriptCapitalT]",
        FontColor->RGBColor[1, 0, 0]], 
       StyleBox["^",
        FontColor->RGBColor[1, 0, 0]]], 
      RowBox[{"[", 
       RowBox[{
        RowBox[{"+", "1"}], "+", "\[Epsilon]"}], "]"}]]]}], "\[Equal]", 
   RowBox[{
    FractionBox[
     SuperscriptBox[
      StyleBox["\[ScriptCapitalT]",
       FontColor->RGBColor[1, 0, 0]], "-"], 
     SubsuperscriptBox[
      StyleBox["\[ScriptCapitalT]",
       FontColor->RGBColor[1, 0, 0]], "\[FivePointedStar]", "-"]], 
    FractionBox[
     SuperscriptBox[
      StyleBox["\[ScriptCapitalT]",
       FontColor->RGBColor[1, 0, 0]], "+"], 
     SubsuperscriptBox[
      StyleBox["\[ScriptCapitalT]",
       FontColor->RGBColor[1, 0, 0]], "\[FivePointedStar]", "+"]]}]}], 
  "}"}]], "Input",
 CellChangeTimes->{{3.546253837854125*^9, 3.546253873516046*^9}, {
  3.546254801592692*^9, 3.5462548029921*^9}, {3.54625579787215*^9, 
  3.546255803948415*^9}, {3.553323787156711*^9, 3.553323828927277*^9}}],

Cell[TextData[{
 "We use \[FivePointedStar] (Soviet star) instead of * because  ",
 StyleBox["Mathematica",
  FontSlant->"Italic"],
 " does interpret * as multiplication. The Soviet star means analytic \
continuation of the expression around u=2g point (this operation is applied \
only after all the shifts are made)."
}], "Text",
 CellChangeTimes->{{3.55332383568437*^9, 3.553323931741909*^9}, {
  3.568964217827361*^9, 3.568964300503295*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{"#", "/.", "subYtYoY"}], ")"}], "\[Equal]", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"#", "/.", "subYT"}], "/.", 
       RowBox[{"T$", "\[Rule]", "T$u"}]}], ")"}]}], "}"}], "&"}], "[", 
  "magicratioup", "]"}]], "Input",
 CellChangeTimes->{{3.546253904753076*^9, 3.546253907117062*^9}, {
  3.5462558117426443`*^9, 3.5462558168121233`*^9}, {3.553323936676034*^9, 
  3.553323941594404*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   FractionBox[
    RowBox[{"1", "+", 
     SubscriptBox[
      StyleBox["Y",
       FontColor->RGBColor[0, 0, 0.8]], 
      RowBox[{"2", ",", "2"}]]}], 
    RowBox[{"1", "+", 
     FractionBox["1", 
      SubscriptBox[
       StyleBox["Y",
        FontColor->RGBColor[0, 0, 0.8]], 
       RowBox[{"1", ",", "1"}]]]}]], "\[Equal]", 
   FractionBox[
    RowBox[{
     SubscriptBox[
      StyleBox["\[GothicCapitalT]",
       FontColor->RGBColor[0.54, 0.35, 0.15]], 
      RowBox[{"1", ",", "0"}]], " ", 
     SubsuperscriptBox[
      StyleBox["\[GothicCapitalT]",
       FontColor->RGBColor[0.54, 0.35, 0.15]], 
      RowBox[{"2", ",", "2"}], "-"], " ", 
     SubsuperscriptBox[
      StyleBox["\[GothicCapitalT]",
       FontColor->RGBColor[0.54, 0.35, 0.15]], 
      RowBox[{"2", ",", "2"}], "+"]}], 
    RowBox[{
     SuperscriptBox[
      StyleBox["\[GothicCapitalT]",
       FontColor->RGBColor[0.54, 0.35, 0.15]], "-"], " ", 
     SuperscriptBox[
      StyleBox["\[GothicCapitalT]",
       FontColor->RGBColor[0.54, 0.35, 0.15]], "+"], " ", 
     SubscriptBox[
      StyleBox["\[GothicCapitalT]",
       FontColor->RGBColor[0.54, 0.35, 0.15]], 
      RowBox[{"3", ",", "2"}]]}]]}], "}"}]], "Output",
 CellChangeTimes->{3.546255817885007*^9, 3.553323942011838*^9}]
}, Open  ]],

Cell["\<\
It can be also rewritten (only in the asymptotic approximation!) as \
\>", "Text",
 CellChangeTimes->{{3.546255773827737*^9, 3.546255792833666*^9}, {
  3.546255859881618*^9, 3.5462558724868793`*^9}, {3.5533239467103662`*^9, 
  3.553323968236248*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   FractionBox[
    RowBox[{"1", "+", 
     SubscriptBox[
      StyleBox["Y",
       FontColor->RGBColor[0, 0, 0.8]], 
      RowBox[{"2", ",", "2"}]]}], 
    RowBox[{"1", "+", 
     FractionBox["1", 
      SubscriptBox[
       StyleBox["Y",
        FontColor->RGBColor[0, 0, 0.8]], 
       RowBox[{"1", ",", "1"}]]]}]], "==", 
   FractionBox[
    RowBox[{
     SuperscriptBox[
      OverscriptBox[
       StyleBox["\[GothicCapitalT]",
        FontColor->RGBColor[0.54, 0.35, 0.15]], 
       StyleBox["^",
        FontColor->RGBColor[0.54, 0.35, 0.15]]], 
      RowBox[{"[", 
       RowBox[{
        RowBox[{"-", "1"}], "-", "\[Epsilon]"}], "]"}]], " ", 
     SuperscriptBox[
      OverscriptBox[
       StyleBox["\[GothicCapitalT]",
        FontColor->RGBColor[0.54, 0.35, 0.15]], 
       StyleBox["^",
        FontColor->RGBColor[0.54, 0.35, 0.15]]], 
      RowBox[{"[", 
       RowBox[{"1", "+", "\[Epsilon]"}], "]"}]]}], 
    RowBox[{
     SuperscriptBox[
      StyleBox["\[GothicCapitalT]",
       FontColor->RGBColor[0.54, 0.35, 0.15]], 
      RowBox[{"[", 
       RowBox[{
        RowBox[{"-", "1"}], "-", "\[Epsilon]"}], "]"}]], " ", 
     SuperscriptBox[
      StyleBox["\[GothicCapitalT]",
       FontColor->RGBColor[0.54, 0.35, 0.15]], 
      RowBox[{"[", 
       RowBox[{"1", "+", "\[Epsilon]"}], "]"}]]}]], "==", 
   FractionBox[
    RowBox[{
     SubsuperscriptBox[
      StyleBox["\[GothicCapitalT]",
       FontColor->RGBColor[0.54, 0.35, 0.15]], "\[FivePointedStar]", "-"], 
     " ", 
     SubsuperscriptBox[
      StyleBox["\[GothicCapitalT]",
       FontColor->RGBColor[0.54, 0.35, 0.15]], "\[FivePointedStar]", "+"]}], 
    RowBox[{
     SuperscriptBox[
      StyleBox["\[GothicCapitalT]",
       FontColor->RGBColor[0.54, 0.35, 0.15]], "-"], " ", 
     SuperscriptBox[
      StyleBox["\[GothicCapitalT]",
       FontColor->RGBColor[0.54, 0.35, 0.15]], "+"]}]]}], "}"}]], "Input",
 CellChangeTimes->{{3.546253837854125*^9, 3.546253873516046*^9}, {
  3.546254801592692*^9, 3.5462548029921*^9}, {3.54625579787215*^9, 
  3.5462558331815166`*^9}, {3.553323971242127*^9, 3.55332398805764*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"solut", "=", 
  RowBox[{
   RowBox[{
    RowBox[{"Solve", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{
          FractionBox[
           RowBox[{"1", "+", 
            SubscriptBox[
             StyleBox["Y",
              FontColor->RGBColor[0, 0, 0.8]], 
             RowBox[{"1", ",", "1"}]]}], 
           RowBox[{"1", "+", 
            FractionBox["1", 
             SubscriptBox[
              StyleBox["Y",
               FontColor->RGBColor[0, 0, 0.8]], 
              RowBox[{"2", ",", "2"}]]]}]], "==", 
          RowBox[{
           FractionBox[
            SuperscriptBox[
             StyleBox["\[ScriptCapitalT]",
              FontColor->RGBColor[1, 0, 0]], "-"], 
            SubsuperscriptBox[
             StyleBox["\[ScriptCapitalT]",
              FontColor->RGBColor[1, 0, 0]], "\[FivePointedStar]", "-"]], 
           FractionBox[
            SuperscriptBox[
             StyleBox["\[ScriptCapitalT]",
              FontColor->RGBColor[1, 0, 0]], "+"], 
            SubsuperscriptBox[
             StyleBox["\[ScriptCapitalT]",
              FontColor->RGBColor[1, 0, 0]], "\[FivePointedStar]", "+"]]}]}], 
         ",", 
         RowBox[{
          FractionBox[
           RowBox[{"1", "+", 
            SubscriptBox[
             StyleBox["Y",
              FontColor->RGBColor[0, 0, 0.8]], 
             RowBox[{"2", ",", "2"}]]}], 
           RowBox[{"1", "+", 
            FractionBox["1", 
             SubscriptBox[
              StyleBox["Y",
               FontColor->RGBColor[0, 0, 0.8]], 
              RowBox[{"1", ",", "1"}]]]}]], "==", 
          FractionBox[
           RowBox[{
            SubsuperscriptBox[
             StyleBox["\[GothicCapitalT]",
              FontColor->RGBColor[0.54, 0.35, 0.15]], "\[FivePointedStar]", 
             "-"], " ", 
            SubsuperscriptBox[
             StyleBox["\[GothicCapitalT]",
              FontColor->RGBColor[0.54, 0.35, 0.15]], "\[FivePointedStar]", 
             "+"]}], 
           RowBox[{
            SuperscriptBox[
             StyleBox["\[GothicCapitalT]",
              FontColor->RGBColor[0.54, 0.35, 0.15]], "-"], " ", 
            SuperscriptBox[
             StyleBox["\[GothicCapitalT]",
              FontColor->RGBColor[0.54, 0.35, 0.15]], "+"]}]]}]}], "}"}], "/.",
        "subYtYoY"}], ",", 
      RowBox[{"{", 
       RowBox[{
        SubscriptBox["Y", 
         RowBox[{"1", ",", "1"}]], ",", 
        SubscriptBox["Y", 
         RowBox[{"2", ",", "2"}]]}], "}"}]}], "]"}], "[", 
    RowBox[{"[", "1", "]"}], "]"}], "//", "Simplify"}]}]], "Input",
 CellChangeTimes->{{3.546254829094688*^9, 3.5462549044517813`*^9}, {
  3.5462558458316708`*^9, 3.546255854607267*^9}, {3.553324007951914*^9, 
  3.553324011692617*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{
    SubscriptBox[
     StyleBox["Y",
      FontColor->RGBColor[0, 0, 0.8]], 
     RowBox[{"1", ",", "1"}]], "\[Rule]", 
    RowBox[{"-", 
     FractionBox[
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          SubsuperscriptBox[
           StyleBox["\[ScriptCapitalT]",
            FontColor->RGBColor[1, 0, 0]], "\[FivePointedStar]", "-"], " ", 
          SubsuperscriptBox[
           StyleBox["\[ScriptCapitalT]",
            FontColor->RGBColor[1, 0, 0]], "\[FivePointedStar]", "+"]}], "-", 
         
         RowBox[{
          SuperscriptBox[
           StyleBox["\[ScriptCapitalT]",
            FontColor->RGBColor[1, 0, 0]], "-"], " ", 
          SuperscriptBox[
           StyleBox["\[ScriptCapitalT]",
            FontColor->RGBColor[1, 0, 0]], "+"]}]}], ")"}], " ", 
       SubsuperscriptBox[
        StyleBox["\[GothicCapitalT]",
         FontColor->RGBColor[0.54, 0.35, 0.15]], "\[FivePointedStar]", "-"], 
       " ", 
       SubsuperscriptBox[
        StyleBox["\[GothicCapitalT]",
         FontColor->RGBColor[0.54, 0.35, 0.15]], "\[FivePointedStar]", "+"]}], 
      RowBox[{
       SubsuperscriptBox[
        StyleBox["\[ScriptCapitalT]",
         FontColor->RGBColor[1, 0, 0]], "\[FivePointedStar]", "-"], " ", 
       SubsuperscriptBox[
        StyleBox["\[ScriptCapitalT]",
         FontColor->RGBColor[1, 0, 0]], "\[FivePointedStar]", "+"], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          SubsuperscriptBox[
           StyleBox["\[GothicCapitalT]",
            FontColor->RGBColor[0.54, 0.35, 0.15]], "\[FivePointedStar]", 
           "-"], " ", 
          SubsuperscriptBox[
           StyleBox["\[GothicCapitalT]",
            FontColor->RGBColor[0.54, 0.35, 0.15]], "\[FivePointedStar]", 
           "+"]}], "-", 
         RowBox[{
          SuperscriptBox[
           StyleBox["\[GothicCapitalT]",
            FontColor->RGBColor[0.54, 0.35, 0.15]], "-"], " ", 
          SuperscriptBox[
           StyleBox["\[GothicCapitalT]",
            FontColor->RGBColor[0.54, 0.35, 0.15]], "+"]}]}], ")"}]}]]}]}], 
   ",", 
   RowBox[{
    SubscriptBox[
     StyleBox["Y",
      FontColor->RGBColor[0, 0, 0.8]], 
     RowBox[{"2", ",", "2"}]], "\[Rule]", 
    FractionBox[
     RowBox[{
      SuperscriptBox[
       StyleBox["\[ScriptCapitalT]",
        FontColor->RGBColor[1, 0, 0]], "-"], " ", 
      SuperscriptBox[
       StyleBox["\[ScriptCapitalT]",
        FontColor->RGBColor[1, 0, 0]], "+"], " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         RowBox[{"-", 
          SubsuperscriptBox[
           StyleBox["\[GothicCapitalT]",
            FontColor->RGBColor[0.54, 0.35, 0.15]], "\[FivePointedStar]", 
           "-"]}], " ", 
         SubsuperscriptBox[
          StyleBox["\[GothicCapitalT]",
           FontColor->RGBColor[0.54, 0.35, 0.15]], "\[FivePointedStar]", 
          "+"]}], "+", 
        RowBox[{
         SuperscriptBox[
          StyleBox["\[GothicCapitalT]",
           FontColor->RGBColor[0.54, 0.35, 0.15]], "-"], " ", 
         SuperscriptBox[
          StyleBox["\[GothicCapitalT]",
           FontColor->RGBColor[0.54, 0.35, 0.15]], "+"]}]}], ")"}]}], 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         SubsuperscriptBox[
          StyleBox["\[ScriptCapitalT]",
           FontColor->RGBColor[1, 0, 0]], "\[FivePointedStar]", "-"], " ", 
         SubsuperscriptBox[
          StyleBox["\[ScriptCapitalT]",
           FontColor->RGBColor[1, 0, 0]], "\[FivePointedStar]", "+"]}], "-", 
        RowBox[{
         SuperscriptBox[
          StyleBox["\[ScriptCapitalT]",
           FontColor->RGBColor[1, 0, 0]], "-"], " ", 
         SuperscriptBox[
          StyleBox["\[ScriptCapitalT]",
           FontColor->RGBColor[1, 0, 0]], "+"]}]}], ")"}], " ", 
      SuperscriptBox[
       StyleBox["\[GothicCapitalT]",
        FontColor->RGBColor[0.54, 0.35, 0.15]], "-"], " ", 
      SuperscriptBox[
       StyleBox["\[GothicCapitalT]",
        FontColor->RGBColor[0.54, 0.35, 0.15]], "+"]}]]}]}], "}"}]], "Output",\

 CellChangeTimes->{{3.546254852143507*^9, 3.546254904854138*^9}, 
   3.546255888536563*^9, 3.5533240139979877`*^9}]
}, Open  ]],

Cell[TextData[{
 "First we check that ",
 Cell[BoxData[
  FormBox[
   RowBox[{
    SubscriptBox["Y", 
     RowBox[{"1", ",", "1"}]], 
    SubscriptBox["Y", 
     RowBox[{"2", ",", "2"}]]}], TraditionalForm]]],
 " is reproduced correctly"
}], "Text",
 CellChangeTimes->{{3.546255902157446*^9, 3.54625591296489*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    SubscriptBox["Y", 
     RowBox[{"1", ",", "1"}]], 
    SubscriptBox["Y", 
     RowBox[{"2", ",", "2"}]]}], "/.", "solut"}], "//", "Simplify"}]], "Input"],

Cell[BoxData[
 FractionBox[
  RowBox[{
   SuperscriptBox[
    StyleBox["\[ScriptCapitalT]",
     FontColor->RGBColor[1, 0, 0]], "-"], " ", 
   SuperscriptBox[
    StyleBox["\[ScriptCapitalT]",
     FontColor->RGBColor[1, 0, 0]], "+"], " ", 
   SubsuperscriptBox[
    StyleBox["\[GothicCapitalT]",
     FontColor->RGBColor[0.54, 0.35, 0.15]], "\[FivePointedStar]", "-"], " ", 
   
   SubsuperscriptBox[
    StyleBox["\[GothicCapitalT]",
     FontColor->RGBColor[0.54, 0.35, 0.15]], "\[FivePointedStar]", "+"]}], 
  RowBox[{
   SubsuperscriptBox[
    StyleBox["\[ScriptCapitalT]",
     FontColor->RGBColor[1, 0, 0]], "\[FivePointedStar]", "-"], " ", 
   SubsuperscriptBox[
    StyleBox["\[ScriptCapitalT]",
     FontColor->RGBColor[1, 0, 0]], "\[FivePointedStar]", "+"], " ", 
   SuperscriptBox[
    StyleBox["\[GothicCapitalT]",
     FontColor->RGBColor[0.54, 0.35, 0.15]], "-"], " ", 
   SuperscriptBox[
    StyleBox["\[GothicCapitalT]",
     FontColor->RGBColor[0.54, 0.35, 0.15]], "+"]}]]], "Output",
 CellChangeTimes->{3.553324106385891*^9}]
}, Open  ]],

Cell[TextData[{
 "Again, using ",
 Cell[BoxData[
  RowBox[{
   FractionBox[
    StyleBox["\[GothicCapitalT]",
     FontColor->RGBColor[0.54, 0.35, 0.15]], 
    StyleBox["\[ScriptCapitalT]",
     FontColor->RGBColor[1, 0, 0]]], "\[Equal]", 
   RowBox[{
    FractionBox[
     RowBox[{
      SuperscriptBox[
       StyleBox["Bp",
        FontColor->RGBColor[0, 0.6, 0]], "-"], " ", 
      SuperscriptBox[
       StyleBox["x",
        FontColor->RGBColor[0, 0.6, 0]], "-"]}], 
     RowBox[{
      SuperscriptBox[
       StyleBox["Bm",
        FontColor->RGBColor[0, 0.6, 0]], "+"], " ", 
      SuperscriptBox[
       StyleBox["x",
        FontColor->RGBColor[0, 0.6, 0]], "+"]}]], 
    SuperscriptBox[
     OverscriptBox[
      StyleBox["y",
       FontColor->RGBColor[0, 0.6, 0]], 
      StyleBox["^",
       FontColor->RGBColor[0, 0.6, 0]]], "-"], " ", 
    SuperscriptBox[
     OverscriptBox[
      StyleBox["y",
       FontColor->RGBColor[0, 0.6, 0]], 
      StyleBox["^",
       FontColor->RGBColor[0, 0.6, 0]]], "+"]}]}]],
  CellChangeTimes->{{3.550204430455282*^9, 3.550204464364326*^9}, 
    3.5502089798203773`*^9, 3.553322537357375*^9}],
 " it is simple"
}], "Text",
 CellChangeTimes->{{3.5533251777619677`*^9, 3.553325198695406*^9}}],

Cell[BoxData[
 RowBox[{
  FractionBox[
   RowBox[{
    SuperscriptBox[
     StyleBox["\[ScriptCapitalT]",
      FontColor->RGBColor[1, 0, 0]], "-"], " ", 
    SuperscriptBox[
     StyleBox["\[ScriptCapitalT]",
      FontColor->RGBColor[1, 0, 0]], "+"], " ", 
    SubsuperscriptBox[
     StyleBox["\[GothicCapitalT]",
      FontColor->RGBColor[0.54, 0.35, 0.15]], "\[FivePointedStar]", "-"], " ", 
    SubsuperscriptBox[
     StyleBox["\[GothicCapitalT]",
      FontColor->RGBColor[0.54, 0.35, 0.15]], "\[FivePointedStar]", "+"]}], 
   RowBox[{
    SubsuperscriptBox[
     StyleBox["\[ScriptCapitalT]",
      FontColor->RGBColor[1, 0, 0]], "\[FivePointedStar]", "-"], " ", 
    SubsuperscriptBox[
     StyleBox["\[ScriptCapitalT]",
      FontColor->RGBColor[1, 0, 0]], "\[FivePointedStar]", "+"], " ", 
    SuperscriptBox[
     StyleBox["\[GothicCapitalT]",
      FontColor->RGBColor[0.54, 0.35, 0.15]], "-"], " ", 
    SuperscriptBox[
     StyleBox["\[GothicCapitalT]",
      FontColor->RGBColor[0.54, 0.35, 0.15]], "+"]}]], "==", 
  FractionBox[
   RowBox[{
    FractionBox[
     RowBox[{
      SuperscriptBox[
       StyleBox["Bp",
        FontColor->RGBColor[0, 0.6, 0]], 
       RowBox[{"[", 
        RowBox[{"-", "2"}], "]"}]], " ", 
      SuperscriptBox[
       StyleBox["x",
        FontColor->RGBColor[0, 0.6, 0]], 
       RowBox[{"[", 
        RowBox[{"-", "2"}], "]"}]]}], 
     FractionBox[
      StyleBox["Rm",
       FontColor->RGBColor[0, 0.6, 0]], 
      StyleBox["x",
       FontColor->RGBColor[0, 0.6, 0]]]], 
    FractionBox[
     FractionBox[
      StyleBox["Rp",
       FontColor->RGBColor[0, 0.6, 0]], 
      StyleBox["x",
       FontColor->RGBColor[0, 0.6, 0]]], 
     RowBox[{
      SuperscriptBox[
       StyleBox["Bm",
        FontColor->RGBColor[0, 0.6, 0]], 
       RowBox[{"[", 
        RowBox[{"+", "2"}], "]"}]], " ", 
      SuperscriptBox[
       StyleBox["x",
        FontColor->RGBColor[0, 0.6, 0]], 
       RowBox[{"[", 
        RowBox[{"+", "2"}], "]"}]]}]]}], 
   RowBox[{
    FractionBox[
     RowBox[{
      SuperscriptBox[
       StyleBox["Bp",
        FontColor->RGBColor[0, 0.6, 0]], 
       RowBox[{"[", 
        RowBox[{"-", "2"}], "]"}]], " ", 
      SuperscriptBox[
       StyleBox["x",
        FontColor->RGBColor[0, 0.6, 0]], 
       RowBox[{"[", 
        RowBox[{"-", "2"}], "]"}]]}], 
     RowBox[{
      StyleBox["Bm",
       FontColor->RGBColor[0, 0.6, 0]], " ", 
      StyleBox["x",
       FontColor->RGBColor[0, 0.6, 0]]}]], 
    FractionBox[
     RowBox[{
      StyleBox["Bp",
       FontColor->RGBColor[0, 0.6, 0]], " ", 
      StyleBox["x",
       FontColor->RGBColor[0, 0.6, 0]]}], 
     RowBox[{
      SuperscriptBox[
       StyleBox["Bm",
        FontColor->RGBColor[0, 0.6, 0]], 
       RowBox[{"[", 
        RowBox[{"+", "2"}], "]"}]], " ", 
      SuperscriptBox[
       StyleBox["x",
        FontColor->RGBColor[0, 0.6, 0]], 
       RowBox[{"[", 
        RowBox[{"+", "2"}], "]"}]]}]]}]], "\[Equal]", 
  FractionBox[
   RowBox[{
    StyleBox["Bm",
     FontColor->RGBColor[0, 0.6, 0]], " ", 
    StyleBox["Rp",
     FontColor->RGBColor[0, 0.6, 0]]}], 
   RowBox[{
    StyleBox["Bp",
     FontColor->RGBColor[0, 0.6, 0]], " ", 
    StyleBox["Rm",
     FontColor->RGBColor[0, 0.6, 0]]}]]}]], "Input",
 CellChangeTimes->{{3.5533252019896603`*^9, 3.55332528177722*^9}}],

Cell[TextData[{
 "Now we check that ",
 Cell[BoxData[
  FormBox[
   RowBox[{
    SubscriptBox["Y", 
     RowBox[{"1", ",", "1"}]], "/", 
    SubscriptBox["Y", 
     RowBox[{"2", ",", "2"}]]}], TraditionalForm]],
  FormatType->"TraditionalForm"],
 " is reproduced correctly"
}], "Text",
 CellChangeTimes->{{3.5533252909334927`*^9, 3.553325303627471*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    SubscriptBox["Y", 
     RowBox[{"1", ",", "1"}]], "/", 
    SubscriptBox["Y", 
     RowBox[{"2", ",", "2"}]]}], "/.", "solut"}], "//", "Simplify"}]], "Input",\

 CellChangeTimes->{3.553325308727317*^9}],

Cell[BoxData[
 FractionBox[
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       SubsuperscriptBox[
        StyleBox["\[ScriptCapitalT]",
         FontColor->RGBColor[1, 0, 0]], "\[FivePointedStar]", "-"], " ", 
       SubsuperscriptBox[
        StyleBox["\[ScriptCapitalT]",
         FontColor->RGBColor[1, 0, 0]], "\[FivePointedStar]", "+"]}], "-", 
      RowBox[{
       SuperscriptBox[
        StyleBox["\[ScriptCapitalT]",
         FontColor->RGBColor[1, 0, 0]], "-"], " ", 
       SuperscriptBox[
        StyleBox["\[ScriptCapitalT]",
         FontColor->RGBColor[1, 0, 0]], "+"]}]}], ")"}], "2"], " ", 
   SubsuperscriptBox[
    StyleBox["\[GothicCapitalT]",
     FontColor->RGBColor[0.54, 0.35, 0.15]], "\[FivePointedStar]", "-"], " ", 
   
   SubsuperscriptBox[
    StyleBox["\[GothicCapitalT]",
     FontColor->RGBColor[0.54, 0.35, 0.15]], "\[FivePointedStar]", "+"], " ", 
   
   SuperscriptBox[
    StyleBox["\[GothicCapitalT]",
     FontColor->RGBColor[0.54, 0.35, 0.15]], "-"], " ", 
   SuperscriptBox[
    StyleBox["\[GothicCapitalT]",
     FontColor->RGBColor[0.54, 0.35, 0.15]], "+"]}], 
  RowBox[{
   SubsuperscriptBox[
    StyleBox["\[ScriptCapitalT]",
     FontColor->RGBColor[1, 0, 0]], "\[FivePointedStar]", "-"], " ", 
   SubsuperscriptBox[
    StyleBox["\[ScriptCapitalT]",
     FontColor->RGBColor[1, 0, 0]], "\[FivePointedStar]", "+"], " ", 
   SuperscriptBox[
    StyleBox["\[ScriptCapitalT]",
     FontColor->RGBColor[1, 0, 0]], "-"], " ", 
   SuperscriptBox[
    StyleBox["\[ScriptCapitalT]",
     FontColor->RGBColor[1, 0, 0]], "+"], " ", 
   SuperscriptBox[
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       SubsuperscriptBox[
        StyleBox["\[GothicCapitalT]",
         FontColor->RGBColor[0.54, 0.35, 0.15]], "\[FivePointedStar]", "-"], 
       " ", 
       SubsuperscriptBox[
        StyleBox["\[GothicCapitalT]",
         FontColor->RGBColor[0.54, 0.35, 0.15]], "\[FivePointedStar]", "+"]}],
       "-", 
      RowBox[{
       SuperscriptBox[
        StyleBox["\[GothicCapitalT]",
         FontColor->RGBColor[0.54, 0.35, 0.15]], "-"], " ", 
       SuperscriptBox[
        StyleBox["\[GothicCapitalT]",
         FontColor->RGBColor[0.54, 0.35, 0.15]], "+"]}]}], ")"}], "2"]}]]], \
"Input",
 CellChangeTimes->{{3.55332585313881*^9, 3.553325854159051*^9}}],

Cell[TextData[{
 "It remains to note that ",
 Cell[BoxData[
  FormBox[
   RowBox[{
    RowBox[{
     SubsuperscriptBox[
      StyleBox["\[ScriptCapitalT]",
       FontColor->RGBColor[1, 0, 0]], "\[FivePointedStar]", "-"], " ", 
     SubsuperscriptBox[
      StyleBox["\[ScriptCapitalT]",
       FontColor->RGBColor[1, 0, 0]], "\[FivePointedStar]", "+"]}], "==", 
    SubsuperscriptBox["\[ScriptCapitalT]", 
     RowBox[{"2", ",", "1"}], "c"]}], TraditionalForm]],
  FormatType->"TraditionalForm"],
 ", ",
 Cell[BoxData[
  FormBox[
   RowBox[{
    RowBox[{
     SubsuperscriptBox[
      StyleBox["\[GothicCapitalT]",
       FontColor->RGBColor[0.54, 0.35, 0.15]], "\[FivePointedStar]", "-"], 
     " ", 
     SubsuperscriptBox[
      StyleBox["\[GothicCapitalT]",
       FontColor->RGBColor[0.54, 0.35, 0.15]], "\[FivePointedStar]", "+"]}], 
    "\[Equal]", 
    RowBox[{
     SubsuperscriptBox["\[GothicCapitalT]", 
      RowBox[{"1", ",", "2"}], "c"], 
     SubscriptBox["\[GothicCapitalT]", 
      RowBox[{"1", ",", "0"}]]}]}], TraditionalForm]],
  FormatType->"TraditionalForm"],
 ", which leads to "
}], "Text",
 CellChangeTimes->{{3.553325857440727*^9, 3.553325908492448*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{
      SubsuperscriptBox[
       StyleBox["\[ScriptCapitalT]",
        FontColor->RGBColor[1, 0, 0]], "\[FivePointedStar]", "-"], " ", 
      SubsuperscriptBox[
       StyleBox["\[ScriptCapitalT]",
        FontColor->RGBColor[1, 0, 0]], "\[FivePointedStar]", "+"]}], "-", 
     RowBox[{
      SuperscriptBox[
       StyleBox["\[ScriptCapitalT]",
        FontColor->RGBColor[1, 0, 0]], "-"], " ", 
      SuperscriptBox[
       StyleBox["\[ScriptCapitalT]",
        FontColor->RGBColor[1, 0, 0]], "+"]}]}], "\[Equal]", 
    RowBox[{
     RowBox[{"-", "\[Rho]"}], " ", 
     SubscriptBox[
      StyleBox["\[ScriptCapitalT]",
       FontColor->RGBColor[1, 0, 0]], 
      RowBox[{"1", ",", "2"}]]}]}], ",", 
   RowBox[{
    RowBox[{
     RowBox[{
      SubsuperscriptBox[
       StyleBox["\[GothicCapitalT]",
        FontColor->RGBColor[0.54, 0.35, 0.15]], "\[FivePointedStar]", "-"], 
      " ", 
      SubsuperscriptBox[
       StyleBox["\[GothicCapitalT]",
        FontColor->RGBColor[0.54, 0.35, 0.15]], "\[FivePointedStar]", "+"]}], 
     "-", 
     RowBox[{
      SuperscriptBox[
       StyleBox["\[GothicCapitalT]",
        FontColor->RGBColor[0.54, 0.35, 0.15]], "-"], " ", 
      SuperscriptBox[
       StyleBox["\[GothicCapitalT]",
        FontColor->RGBColor[0.54, 0.35, 0.15]], "+"]}]}], "=", 
    RowBox[{
     RowBox[{"-", 
      SubscriptBox["\[Rho]", "2"]}], " ", 
     SubscriptBox[
      StyleBox["\[GothicCapitalT]",
       FontColor->RGBColor[0.54, 0.35, 0.15]], 
      RowBox[{"2", ",", "1"}]]}]}]}], "}"}]], "Input",
 CellChangeTimes->{{3.553325913065428*^9, 3.553325956290229*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   FractionBox["\[Rho]", "\[Rho]2"], "/.", "largevolume"}], "//", 
  "Simplify"}]], "Input",
 CellChangeTimes->{{3.553326013538271*^9, 3.553326022834401*^9}}],

Cell[BoxData[
 RowBox[{"-", 
  FractionBox["1", 
   RowBox[{
    SuperscriptBox[
     OverscriptBox[
      StyleBox["y",
       FontColor->RGBColor[0, 0.6, 0]], 
      StyleBox["^",
       FontColor->RGBColor[0, 0.6, 0]]], "-"], " ", 
    SuperscriptBox[
     OverscriptBox[
      StyleBox["y",
       FontColor->RGBColor[0, 0.6, 0]], 
      StyleBox["^",
       FontColor->RGBColor[0, 0.6, 0]]], "+"]}]]}]], "Output",
 CellChangeTimes->{{3.553326019096779*^9, 3.553326023230563*^9}}]
}, Open  ]],

Cell["\<\

So we conclude that\
\>", "Text",
 CellChangeTimes->{{3.553326155477282*^9, 3.55332616045125*^9}}],

Cell[BoxData[
 RowBox[{
  FractionBox[
   SubscriptBox["Y", 
    RowBox[{"1", ",", "1"}]], 
   SubscriptBox["Y", 
    RowBox[{"2", ",", "2"}]]], "\[Equal]", 
  FractionBox[
   RowBox[{
    SuperscriptBox[
     RowBox[{"(", 
      RowBox[{
       RowBox[{
        SubsuperscriptBox[
         StyleBox["\[ScriptCapitalT]",
          FontColor->RGBColor[1, 0, 0]], "\[FivePointedStar]", "-"], " ", 
        SubsuperscriptBox[
         StyleBox["\[ScriptCapitalT]",
          FontColor->RGBColor[1, 0, 0]], "\[FivePointedStar]", "+"]}], "-", 
       RowBox[{
        SuperscriptBox[
         StyleBox["\[ScriptCapitalT]",
          FontColor->RGBColor[1, 0, 0]], "-"], " ", 
        SuperscriptBox[
         StyleBox["\[ScriptCapitalT]",
          FontColor->RGBColor[1, 0, 0]], "+"]}]}], ")"}], "2"], " ", 
    SubsuperscriptBox[
     StyleBox["\[GothicCapitalT]",
      FontColor->RGBColor[0.54, 0.35, 0.15]], "\[FivePointedStar]", "-"], " ", 
    SubsuperscriptBox[
     StyleBox["\[GothicCapitalT]",
      FontColor->RGBColor[0.54, 0.35, 0.15]], "\[FivePointedStar]", "+"], " ", 
    SuperscriptBox[
     StyleBox["\[GothicCapitalT]",
      FontColor->RGBColor[0.54, 0.35, 0.15]], "-"], " ", 
    SuperscriptBox[
     StyleBox["\[GothicCapitalT]",
      FontColor->RGBColor[0.54, 0.35, 0.15]], "+"]}], 
   RowBox[{
    SubsuperscriptBox[
     StyleBox["\[ScriptCapitalT]",
      FontColor->RGBColor[1, 0, 0]], "\[FivePointedStar]", "-"], " ", 
    SubsuperscriptBox[
     StyleBox["\[ScriptCapitalT]",
      FontColor->RGBColor[1, 0, 0]], "\[FivePointedStar]", "+"], " ", 
    SuperscriptBox[
     StyleBox["\[ScriptCapitalT]",
      FontColor->RGBColor[1, 0, 0]], "-"], " ", 
    SuperscriptBox[
     StyleBox["\[ScriptCapitalT]",
      FontColor->RGBColor[1, 0, 0]], "+"], " ", 
    SuperscriptBox[
     RowBox[{"(", 
      RowBox[{
       RowBox[{
        SubsuperscriptBox[
         StyleBox["\[GothicCapitalT]",
          FontColor->RGBColor[0.54, 0.35, 0.15]], "\[FivePointedStar]", "-"], 
        " ", 
        SubsuperscriptBox[
         StyleBox["\[GothicCapitalT]",
          FontColor->RGBColor[0.54, 0.35, 0.15]], "\[FivePointedStar]", 
         "+"]}], "-", 
       RowBox[{
        SuperscriptBox[
         StyleBox["\[GothicCapitalT]",
          FontColor->RGBColor[0.54, 0.35, 0.15]], "-"], " ", 
        SuperscriptBox[
         StyleBox["\[GothicCapitalT]",
          FontColor->RGBColor[0.54, 0.35, 0.15]], "+"]}]}], ")"}], "2"]}]], 
  "\[Equal]", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["1", 
      RowBox[{
       SuperscriptBox[
        OverscriptBox[
         StyleBox["y",
          FontColor->RGBColor[0, 0.6, 0]], 
         StyleBox["^",
          FontColor->RGBColor[0, 0.6, 0]]], "-"], " ", 
       SuperscriptBox[
        OverscriptBox[
         StyleBox["y",
          FontColor->RGBColor[0, 0.6, 0]], 
         StyleBox["^",
          FontColor->RGBColor[0, 0.6, 0]]], "+"]}]], ")"}], "2"], 
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox[
      SubscriptBox[
       StyleBox["\[ScriptCapitalT]",
        FontColor->RGBColor[1, 0, 0]], 
       RowBox[{"1", ",", "2"}]], 
      SubscriptBox[
       StyleBox["\[GothicCapitalT]",
        FontColor->RGBColor[0.54, 0.35, 0.15]], 
       RowBox[{"2", ",", "1"}]]], ")"}], "2"], 
   FractionBox[
    RowBox[{
     SubsuperscriptBox[
      StyleBox["\[GothicCapitalT]",
       FontColor->RGBColor[0.54, 0.35, 0.15]], "\[FivePointedStar]", "-"], 
     " ", 
     SubsuperscriptBox[
      StyleBox["\[GothicCapitalT]",
       FontColor->RGBColor[0.54, 0.35, 0.15]], "\[FivePointedStar]", "+"], 
     " ", 
     SuperscriptBox[
      StyleBox["\[GothicCapitalT]",
       FontColor->RGBColor[0.54, 0.35, 0.15]], "-"], " ", 
     SuperscriptBox[
      StyleBox["\[GothicCapitalT]",
       FontColor->RGBColor[0.54, 0.35, 0.15]], "+"]}], 
    RowBox[{
     SubsuperscriptBox[
      StyleBox["\[ScriptCapitalT]",
       FontColor->RGBColor[1, 0, 0]], "\[FivePointedStar]", "-"], " ", 
     SubsuperscriptBox[
      StyleBox["\[ScriptCapitalT]",
       FontColor->RGBColor[1, 0, 0]], "\[FivePointedStar]", "+"], " ", 
     SuperscriptBox[
      StyleBox["\[ScriptCapitalT]",
       FontColor->RGBColor[1, 0, 0]], "-"], " ", 
     SuperscriptBox[
      StyleBox["\[ScriptCapitalT]",
       FontColor->RGBColor[1, 0, 0]], "+"]}]]}]}]], "Input",
 CellChangeTimes->{{3.553325975784705*^9, 3.5533260121648006`*^9}, {
  3.553326093288618*^9, 3.55332609491749*^9}}],

Cell["So, all the checks were done.", "Text",
 CellChangeTimes->{{3.553326162523012*^9, 3.553326166058669*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 "Double scaling regime ",
 Cell[BoxData[
  FormBox[
   RowBox[{
    RowBox[{"Log", "[", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        FractionBox[
         SubscriptBox["Y", 
          RowBox[{"1", ",", "1"}]], 
         SubscriptBox["Y", 
          RowBox[{"2", ",", "2"}]]], 
        FractionBox[
         SubsuperscriptBox[
          StyleBox["\[GothicCapitalT]",
           FontColor->RGBColor[0.54, 0.35, 0.15]], 
          RowBox[{"2", ",", "1"}], "2"], 
         SubsuperscriptBox[
          StyleBox["\[ScriptCapitalT]",
           FontColor->RGBColor[1, 0, 0]], 
          RowBox[{"1", ",", "2"}], "2"]]}], ")"}], "/", 
      SubscriptBox[
       RowBox[{"(", 
        RowBox[{
         FractionBox[
          SubscriptBox["Y", 
           RowBox[{"1", ",", "1"}]], 
          SubscriptBox["Y", 
           RowBox[{"2", ",", "2"}]]], 
         FractionBox[
          SubsuperscriptBox[
           StyleBox["\[GothicCapitalT]",
            FontColor->RGBColor[0.54, 0.35, 0.15]], 
           RowBox[{"2", ",", "1"}], "2"], 
          SubsuperscriptBox[
           StyleBox["\[ScriptCapitalT]",
            FontColor->RGBColor[1, 0, 0]], 
           RowBox[{"1", ",", "2"}], "2"]]}], ")"}], "asym"]}], "]"}], 
    "\[Equal]", 
    RowBox[{
     SubsuperscriptBox["\[Integral]", 
      RowBox[{
       RowBox[{"-", "\[Infinity]"}], "-", 
       RowBox[{"\[ImaginaryI]", " ", "0"}]}], 
      RowBox[{
       RowBox[{"+", "\[Infinity]"}], "-", 
       RowBox[{"\[ImaginaryI]", " ", "0"}]}]], 
     RowBox[{
      FractionBox["dv", 
       RowBox[{
        RowBox[{"-", "2"}], "\[Pi]", " ", "\[ImaginaryI]"}]], 
      RowBox[{"(", 
       FractionBox[
        RowBox[{"2", "v"}], 
        RowBox[{
         RowBox[{"4", 
          SuperscriptBox["g", "2"], 
          SuperscriptBox["z", "2"]}], "-", 
         SuperscriptBox["v", "2"]}]], ")"}], 
      RowBox[{"(", 
       RowBox[{"H", "-", 
        RowBox[{"2", 
         RowBox[{"Log", "[", 
          RowBox[{
           RowBox[{"(", 
            FractionBox[
             RowBox[{" ", 
              SuperscriptBox[
               StyleBox["\[ScriptCapitalT]",
                FontColor->RGBColor[1, 0, 0]], "+"], " "}], 
             SuperscriptBox[
              StyleBox["\[GothicCapitalT]",
               FontColor->RGBColor[0.54, 0.35, 0.15]], "+"]], ")"}], "/", 
           SubscriptBox[
            RowBox[{"(", 
             FractionBox[
              RowBox[{" ", 
               SuperscriptBox[
                StyleBox["\[ScriptCapitalT]",
                 FontColor->RGBColor[1, 0, 0]], "+"], " "}], 
              SuperscriptBox[
               StyleBox["\[GothicCapitalT]",
                FontColor->RGBColor[0.54, 0.35, 0.15]], "+"]], ")"}], 
            "asym"]}], "]"}]}]}], ")"}]}]}]}], TraditionalForm]]]
}], "Subsubsection",
 CellChangeTimes->{{3.553314123028195*^9, 3.553314128473793*^9}, {
  3.553314668967449*^9, 3.553314675964815*^9}, {3.553314938015957*^9, 
  3.553314940802788*^9}, {3.553315197685042*^9, 3.5533152017594013`*^9}}],

Cell[TextData[{
 "One should put u to the real axis first. When crossing ",
 Cell[BoxData[
  FormBox[
   RowBox[{"u", "=", 
    RowBox[{"v", "+", 
     RowBox[{"\[ImaginaryI]", " ", "0"}]}]}], TraditionalForm]],
  FormatType->"TraditionalForm"],
 " pole, the residue kills inhomogeneous piece and we get:"
}], "Text",
 CellChangeTimes->{{3.553314701437792*^9, 3.553314771777128*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Log", "[", 
   RowBox[{
    FractionBox[
     SubscriptBox["Y", 
      RowBox[{"1", ",", "1"}]], 
     SubscriptBox["Y", 
      RowBox[{"2", ",", "2"}]]], 
    FractionBox[
     SubsuperscriptBox[
      StyleBox["\[GothicCapitalT]",
       FontColor->RGBColor[0.54, 0.35, 0.15]], 
      RowBox[{"2", ",", "1"}], "2"], 
     SubsuperscriptBox[
      StyleBox["\[ScriptCapitalT]",
       FontColor->RGBColor[1, 0, 0]], 
      RowBox[{"1", ",", "2"}], "2"]]}], "]"}], "\[Equal]", 
  RowBox[{
   RowBox[{
    SubsuperscriptBox["\[Integral]", 
     RowBox[{"-", "\[Infinity]"}], 
     RowBox[{"+", "\[Infinity]"}]], 
    RowBox[{
     FractionBox["dv", 
      RowBox[{
       RowBox[{"-", "2"}], "\[Pi]", " ", "\[ImaginaryI]"}]], 
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{
        FractionBox["1", 
         RowBox[{"u", "-", "v"}]], 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"-", 
           RowBox[{"Log", "[", 
            FractionBox[
             SubscriptBox[
              StyleBox["\[GothicCapitalT]",
               FontColor->RGBColor[0.54, 0.35, 0.15]], 
              RowBox[{"1", ",", "0"}]], 
             SubsuperscriptBox[
              StyleBox["\[GothicCapitalT]",
               FontColor->RGBColor[0.54, 0.35, 0.15]], 
              RowBox[{"0", ",", "0"}], "-"]], "]"}]}], "+", 
          RowBox[{"Log", "[", 
           SuperscriptBox[
            RowBox[{"(", 
             FractionBox[
              RowBox[{" ", 
               SuperscriptBox[
                StyleBox["\[ScriptCapitalT]",
                 FontColor->RGBColor[1, 0, 0]], "-"], " "}], 
              SuperscriptBox[
               StyleBox["\[GothicCapitalT]",
                FontColor->RGBColor[0.54, 0.35, 0.15]], "-"]], ")"}], "2"], 
           "]"}]}], ")"}]}], ")"}], 
      RowBox[{"[", 
       RowBox[{"+", "o"}], "]"}]]}]}], "+", 
   SuperscriptBox[
    RowBox[{"(", 
     RowBox[{
      FractionBox["1", 
       RowBox[{"u", "-", "v"}]], 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"Log", "[", 
         FractionBox[
          SubscriptBox[
           StyleBox["\[GothicCapitalT]",
            FontColor->RGBColor[0.54, 0.35, 0.15]], 
           RowBox[{"1", ",", "0"}]], 
          SubsuperscriptBox[
           StyleBox["\[GothicCapitalT]",
            FontColor->RGBColor[0.54, 0.35, 0.15]], 
           RowBox[{"0", ",", "0"}], "+"]], "]"}], "-", 
        RowBox[{"Log", "[", 
         SuperscriptBox[
          RowBox[{"(", 
           FractionBox[
            RowBox[{" ", 
             SuperscriptBox[
              StyleBox["\[ScriptCapitalT]",
               FontColor->RGBColor[1, 0, 0]], "+"], " "}], 
            SuperscriptBox[
             StyleBox["\[GothicCapitalT]",
              FontColor->RGBColor[0.54, 0.35, 0.15]], "+"]], ")"}], "2"], 
         "]"}]}], ")"}]}], ")"}], 
    RowBox[{"[", 
     RowBox[{"-", "o"}], "]"}]]}], "\[Equal]", "\[IndentingNewLine]", 
  RowBox[{
   SubsuperscriptBox["\[Integral]", 
    RowBox[{
     RowBox[{"-", "\[Infinity]"}], "-", 
     RowBox[{"\[ImaginaryI]", " ", "0"}]}], 
    RowBox[{
     RowBox[{"+", "\[Infinity]"}], "-", 
     RowBox[{"\[ImaginaryI]", " ", "0"}]}]], 
   RowBox[{
    FractionBox["dv", 
     RowBox[{
      RowBox[{"-", "2"}], "\[Pi]", " ", "\[ImaginaryI]"}]], 
    RowBox[{"(", 
     RowBox[{
      FractionBox["1", 
       RowBox[{"u", "-", "v"}]], "-", 
      FractionBox["1", 
       RowBox[{"u", "+", "v"}]]}], ")"}], 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"Log", "[", 
       FractionBox[
        SubscriptBox[
         StyleBox["\[GothicCapitalT]",
          FontColor->RGBColor[0.54, 0.35, 0.15]], 
         RowBox[{"1", ",", "0"}]], 
        SubsuperscriptBox[
         StyleBox["\[GothicCapitalT]",
          FontColor->RGBColor[0.54, 0.35, 0.15]], 
         RowBox[{"0", ",", "0"}], "+"]], "]"}], "-", 
      RowBox[{"Log", "[", 
       SuperscriptBox[
        RowBox[{"(", 
         FractionBox[
          RowBox[{" ", 
           SuperscriptBox[
            StyleBox["\[ScriptCapitalT]",
             FontColor->RGBColor[1, 0, 0]], "+"], " "}], 
          SuperscriptBox[
           StyleBox["\[GothicCapitalT]",
            FontColor->RGBColor[0.54, 0.35, 0.15]], "+"]], ")"}], "2"], 
       "]"}]}], ")"}]}]}], "==", 
  RowBox[{
   SubsuperscriptBox["\[Integral]", 
    RowBox[{
     RowBox[{"-", "\[Infinity]"}], "-", 
     RowBox[{"\[ImaginaryI]", " ", "0"}]}], 
    RowBox[{
     RowBox[{"+", "\[Infinity]"}], "-", 
     RowBox[{"\[ImaginaryI]", " ", "0"}]}]], 
   RowBox[{
    FractionBox["dv", 
     RowBox[{
      RowBox[{"-", "2"}], "\[Pi]", " ", "\[ImaginaryI]"}]], 
    RowBox[{"(", 
     FractionBox[
      RowBox[{"2", "v"}], 
      RowBox[{
       RowBox[{"4", 
        SuperscriptBox["g", "2"], 
        SuperscriptBox["z", "2"]}], "-", 
       SuperscriptBox["v", "2"]}]], ")"}], 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"Log", "[", 
       FractionBox[
        SubscriptBox[
         StyleBox["\[GothicCapitalT]",
          FontColor->RGBColor[0.54, 0.35, 0.15]], 
         RowBox[{"1", ",", "0"}]], 
        SubsuperscriptBox[
         StyleBox["\[GothicCapitalT]",
          FontColor->RGBColor[0.54, 0.35, 0.15]], 
         RowBox[{"0", ",", "0"}], "+"]], "]"}], "-", 
      RowBox[{"Log", "[", 
       SuperscriptBox[
        RowBox[{"(", 
         FractionBox[
          RowBox[{" ", 
           SuperscriptBox[
            StyleBox["\[ScriptCapitalT]",
             FontColor->RGBColor[1, 0, 0]], "+"], " "}], 
          SuperscriptBox[
           StyleBox["\[GothicCapitalT]",
            FontColor->RGBColor[0.54, 0.35, 0.15]], "+"]], ")"}], "2"], 
       "]"}]}], ")"}]}]}]}]], "Input",
 CellChangeTimes->{{3.553314346569764*^9, 3.553314443360942*^9}, {
  3.553314541671711*^9, 3.553314552324584*^9}, {3.5533147755889177`*^9, 
  3.553314856270431*^9}, {3.553314903623063*^9, 3.5533149809137297`*^9}, {
  3.5533150136987753`*^9, 3.553315033129386*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Log", "[", 
   RowBox[{
    FractionBox[
     SubscriptBox["Y", 
      RowBox[{"1", ",", "1"}]], 
     SubscriptBox["Y", 
      RowBox[{"2", ",", "2"}]]], 
    FractionBox[
     SubsuperscriptBox[
      StyleBox["\[GothicCapitalT]",
       FontColor->RGBColor[0.54, 0.35, 0.15]], 
      RowBox[{"2", ",", "1"}], "2"], 
     SubsuperscriptBox[
      StyleBox["\[ScriptCapitalT]",
       FontColor->RGBColor[1, 0, 0]], 
      RowBox[{"1", ",", "2"}], "2"]]}], "]"}], "\[Equal]", 
  RowBox[{
   SubsuperscriptBox["\[Integral]", 
    RowBox[{
     RowBox[{"-", "\[Infinity]"}], "-", 
     RowBox[{"\[ImaginaryI]", " ", "0"}]}], 
    RowBox[{
     RowBox[{"+", "\[Infinity]"}], "-", 
     RowBox[{"\[ImaginaryI]", " ", "0"}]}]], 
   RowBox[{
    FractionBox["dv", 
     RowBox[{
      RowBox[{"-", "2"}], "\[Pi]", " ", "\[ImaginaryI]"}]], 
    RowBox[{"(", 
     FractionBox[
      RowBox[{"2", "v"}], 
      RowBox[{
       RowBox[{"4", 
        SuperscriptBox["g", "2"], 
        SuperscriptBox["z", "2"]}], "-", 
       SuperscriptBox["v", "2"]}]], ")"}], 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"Log", "[", 
       FractionBox[
        SubscriptBox[
         StyleBox["\[GothicCapitalT]",
          FontColor->RGBColor[0.54, 0.35, 0.15]], 
         RowBox[{"1", ",", "0"}]], 
        SubsuperscriptBox[
         StyleBox["\[GothicCapitalT]",
          FontColor->RGBColor[0.54, 0.35, 0.15]], 
         RowBox[{"0", ",", "0"}], "+"]], "]"}], "-", 
      RowBox[{"Log", "[", 
       SuperscriptBox[
        RowBox[{"(", 
         FractionBox[
          RowBox[{" ", 
           SuperscriptBox[
            StyleBox["\[ScriptCapitalT]",
             FontColor->RGBColor[1, 0, 0]], "+"], " "}], 
          SuperscriptBox[
           StyleBox["\[GothicCapitalT]",
            FontColor->RGBColor[0.54, 0.35, 0.15]], "+"]], ")"}], "2"], 
       "]"}]}], ")"}]}]}]}]], "Input",
 CellChangeTimes->{3.553315059706897*^9}],

Cell["\<\
Correspondingly, when dividing on the asymptotic expression, one gets\
\>", "Text",
 CellChangeTimes->{{3.553315098574479*^9, 3.553315114524335*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Log", "[", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      FractionBox[
       SubscriptBox["Y", 
        RowBox[{"1", ",", "1"}]], 
       SubscriptBox["Y", 
        RowBox[{"2", ",", "2"}]]], 
      FractionBox[
       SubsuperscriptBox[
        StyleBox["\[GothicCapitalT]",
         FontColor->RGBColor[0.54, 0.35, 0.15]], 
        RowBox[{"2", ",", "1"}], "2"], 
       SubsuperscriptBox[
        StyleBox["\[ScriptCapitalT]",
         FontColor->RGBColor[1, 0, 0]], 
        RowBox[{"1", ",", "2"}], "2"]]}], ")"}], "/", 
    SubscriptBox[
     RowBox[{"(", 
      RowBox[{
       FractionBox[
        SubscriptBox["Y", 
         RowBox[{"1", ",", "1"}]], 
        SubscriptBox["Y", 
         RowBox[{"2", ",", "2"}]]], 
       FractionBox[
        SubsuperscriptBox[
         StyleBox["\[GothicCapitalT]",
          FontColor->RGBColor[0.54, 0.35, 0.15]], 
         RowBox[{"2", ",", "1"}], "2"], 
        SubsuperscriptBox[
         StyleBox["\[ScriptCapitalT]",
          FontColor->RGBColor[1, 0, 0]], 
         RowBox[{"1", ",", "2"}], "2"]]}], ")"}], "asym"]}], "]"}], 
  "\[Equal]", 
  RowBox[{
   SubsuperscriptBox["\[Integral]", 
    RowBox[{
     RowBox[{"-", "\[Infinity]"}], "-", 
     RowBox[{"\[ImaginaryI]", " ", "0"}]}], 
    RowBox[{
     RowBox[{"+", "\[Infinity]"}], "-", 
     RowBox[{"\[ImaginaryI]", " ", "0"}]}]], 
   RowBox[{
    FractionBox["dv", 
     RowBox[{
      RowBox[{"-", "2"}], "\[Pi]", " ", "\[ImaginaryI]"}]], 
    RowBox[{"(", 
     FractionBox[
      RowBox[{"2", "v"}], 
      RowBox[{
       RowBox[{"4", 
        SuperscriptBox["g", "2"], 
        SuperscriptBox["z", "2"]}], "-", 
       SuperscriptBox["v", "2"]}]], ")"}], 
    RowBox[{"(", 
     RowBox[{"H", "-", 
      RowBox[{"2", 
       RowBox[{"Log", "[", 
        RowBox[{
         RowBox[{"(", 
          FractionBox[
           RowBox[{" ", 
            SuperscriptBox[
             StyleBox["\[ScriptCapitalT]",
              FontColor->RGBColor[1, 0, 0]], "+"], " "}], 
           SuperscriptBox[
            StyleBox["\[GothicCapitalT]",
             FontColor->RGBColor[0.54, 0.35, 0.15]], "+"]], ")"}], "/", 
         SubscriptBox[
          RowBox[{"(", 
           FractionBox[
            RowBox[{" ", 
             SuperscriptBox[
              StyleBox["\[ScriptCapitalT]",
               FontColor->RGBColor[1, 0, 0]], "+"], " "}], 
            SuperscriptBox[
             StyleBox["\[GothicCapitalT]",
              FontColor->RGBColor[0.54, 0.35, 0.15]], "+"]], ")"}], "asym"]}],
         "]"}]}]}], ")"}]}]}]}]], "Input",
 CellChangeTimes->{{3.5533151223069344`*^9, 3.553315148226733*^9}}],

Cell[TextData[{
 "This to be expanded in ",
 Cell[BoxData[
  FormBox[
   RowBox[{"2", "g", " ", "z"}], TraditionalForm]],
  FormatType->"TraditionalForm"],
 "."
}], "Text",
 CellChangeTimes->{{3.553315066959865*^9, 3.553315078095747*^9}, {
  3.553315127860299*^9, 3.553315128747952*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 "Expression entering Bethe equations \n",
 Cell[BoxData[
  FormBox[
   RowBox[{
    RowBox[{
     RowBox[{"(", 
      RowBox[{"D", "-", 
       SuperscriptBox["D", 
        RowBox[{"-", "1"}]]}], ")"}], 
     RowBox[{"Log", "[", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         FractionBox[
          SubscriptBox["Y", 
           RowBox[{"1", ",", "1"}]], 
          SubscriptBox["Y", 
           RowBox[{"2", ",", "2"}]]], 
         FractionBox[
          SubsuperscriptBox[
           StyleBox["\[GothicCapitalT]",
            FontColor->RGBColor[0.54, 0.35, 0.15]], 
           RowBox[{"2", ",", "1"}], "2"], 
          SubsuperscriptBox[
           StyleBox["\[ScriptCapitalT]",
            FontColor->RGBColor[1, 0, 0]], 
           RowBox[{"1", ",", "2"}], "2"]]}], ")"}], "/", 
       SubscriptBox[
        RowBox[{"(", 
         RowBox[{
          FractionBox[
           SubscriptBox["Y", 
            RowBox[{"1", ",", "1"}]], 
           SubscriptBox["Y", 
            RowBox[{"2", ",", "2"}]]], 
          FractionBox[
           SubsuperscriptBox[
            StyleBox["\[GothicCapitalT]",
             FontColor->RGBColor[0.54, 0.35, 0.15]], 
            RowBox[{"2", ",", "1"}], "2"], 
           SubsuperscriptBox[
            StyleBox["\[ScriptCapitalT]",
             FontColor->RGBColor[1, 0, 0]], 
            RowBox[{"1", ",", "2"}], "2"]]}], ")"}], "asym"]}], "]"}]}], 
    "\[Equal]", 
    RowBox[{
     RowBox[{
      RowBox[{"(", 
       RowBox[{"D", "-", 
        SuperscriptBox["D", 
         RowBox[{"-", "1"}]]}], ")"}], 
      RowBox[{"Log", "[", 
       FractionBox[
        SubscriptBox[
         StyleBox["\[GothicCapitalT]",
          FontColor->RGBColor[0.54, 0.35, 0.15]], 
         RowBox[{"1", ",", "0"}]], 
        SubscriptBox[
         RowBox[{"(", 
          SubscriptBox[
           StyleBox["\[GothicCapitalT]",
            FontColor->RGBColor[0.54, 0.35, 0.15]], 
           RowBox[{"1", ",", "0"}]], ")"}], "asym"]], "]"}]}], "-", 
     RowBox[{"4", "\[ImaginaryI]", " ", 
      SubscriptBox["v", "0"], 
      RowBox[{
       SubsuperscriptBox["\[Integral]", 
        RowBox[{
         RowBox[{"-", "\[Infinity]"}], "-", 
         RowBox[{"\[ImaginaryI]", " ", "0"}]}], 
        RowBox[{
         RowBox[{"+", "\[Infinity]"}], "-", 
         RowBox[{"\[ImaginaryI]", " ", "0"}]}]], 
       RowBox[{
        FractionBox["dv", 
         RowBox[{
          RowBox[{"-", "2"}], "\[Pi]", " ", "\[ImaginaryI]"}]], 
        FractionBox["v", 
         RowBox[{
          SuperscriptBox[
           StyleBox["Q",
            FontColor->RGBColor[0.8, 0, 0]], "+"], " ", 
          SuperscriptBox[
           StyleBox["Q",
            FontColor->RGBColor[0.8, 0, 0]], "-"]}]], 
        RowBox[{"(", 
         RowBox[{"H", "-", 
          RowBox[{"2", 
           RowBox[{"Log", "[", 
            RowBox[{
             RowBox[{"(", 
              FractionBox[
               RowBox[{" ", 
                SuperscriptBox[
                 StyleBox["\[ScriptCapitalT]",
                  FontColor->RGBColor[1, 0, 0]], "+"], " "}], 
               SuperscriptBox[
                StyleBox["\[GothicCapitalT]",
                 FontColor->RGBColor[0.54, 0.35, 0.15]], "+"]], ")"}], "/", 
             SubscriptBox[
              RowBox[{"(", 
               FractionBox[
                RowBox[{" ", 
                 SuperscriptBox[
                  StyleBox["\[ScriptCapitalT]",
                   FontColor->RGBColor[1, 0, 0]], "+"], " "}], 
                SuperscriptBox[
                 StyleBox["\[GothicCapitalT]",
                  FontColor->RGBColor[0.54, 0.35, 0.15]], "+"]], ")"}], 
              "asym"]}], "]"}]}]}], ")"}]}]}]}]}]}], TraditionalForm]]]
}], "Subsubsection",
 CellChangeTimes->{{3.553314123028195*^9, 3.553314128473793*^9}, {
  3.553314668967449*^9, 3.553314675964815*^9}, {3.553315218933228*^9, 
  3.553315226575946*^9}, {3.553316911988914*^9, 3.553316953872158*^9}, {
  3.553317092267118*^9, 3.553317092267302*^9}}],

Cell["\<\
To compute the guy shifted to -\[ImaginaryI]/2 we should cross the contour of \
integration\
\>", "Text",
 CellChangeTimes->{{3.5533166389484577`*^9, 3.5533166554529123`*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"Log", "[", 
   SuperscriptBox[
    RowBox[{"(", 
     RowBox[{
      FractionBox[
       SubscriptBox["Y", 
        RowBox[{"1", ",", "1"}]], 
       SubscriptBox["Y", 
        RowBox[{"2", ",", "2"}]]], 
      FractionBox[
       SubsuperscriptBox[
        StyleBox["\[GothicCapitalT]",
         FontColor->RGBColor[0.54, 0.35, 0.15]], 
        RowBox[{"2", ",", "1"}], "2"], 
       SubsuperscriptBox[
        StyleBox["\[ScriptCapitalT]",
         FontColor->RGBColor[1, 0, 0]], 
        RowBox[{"1", ",", "2"}], "2"]]}], ")"}], "+"], "]"}], "\[Equal]", 
  RowBox[{
   RowBox[{"Log", "[", 
    FractionBox[
     SubsuperscriptBox[
      StyleBox["\[GothicCapitalT]",
       FontColor->RGBColor[0.54, 0.35, 0.15]], 
      RowBox[{"1", ",", "0"}], "+"], 
     SubscriptBox[
      StyleBox["\[GothicCapitalT]",
       FontColor->RGBColor[0.54, 0.35, 0.15]], 
      RowBox[{"0", ",", "0"}]]], "]"}], "-", 
   RowBox[{"Log", "[", 
    RowBox[{"(", 
     FractionBox[
      RowBox[{" ", 
       StyleBox["\[ScriptCapitalT]",
        FontColor->RGBColor[1, 0, 0]], " "}], 
      StyleBox["\[GothicCapitalT]",
       FontColor->RGBColor[0.54, 0.35, 0.15]]], ")"}], "]"}], "+", 
   RowBox[{
    SuperscriptBox["\[ScriptCapitalC]", "+"], "*", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"-", 
       RowBox[{"Log", "[", 
        FractionBox[
         SubscriptBox[
          StyleBox["\[GothicCapitalT]",
           FontColor->RGBColor[0.54, 0.35, 0.15]], 
          RowBox[{"1", ",", "0"}]], 
         SubsuperscriptBox[
          StyleBox["\[GothicCapitalT]",
           FontColor->RGBColor[0.54, 0.35, 0.15]], 
          RowBox[{"0", ",", "0"}], "-"]], "]"}]}], "+", 
      RowBox[{"Log", "[", 
       SuperscriptBox[
        RowBox[{"(", 
         FractionBox[
          RowBox[{" ", 
           SuperscriptBox[
            StyleBox["\[ScriptCapitalT]",
             FontColor->RGBColor[1, 0, 0]], "-"], " "}], 
          SuperscriptBox[
           StyleBox["\[GothicCapitalT]",
            FontColor->RGBColor[0.54, 0.35, 0.15]], "-"]], ")"}], "2"], "]"}],
       "+", 
      RowBox[{"Log", "[", 
       FractionBox[
        SubscriptBox[
         StyleBox["\[GothicCapitalT]",
          FontColor->RGBColor[0.54, 0.35, 0.15]], 
         RowBox[{"1", ",", "0"}]], 
        SubsuperscriptBox[
         StyleBox["\[GothicCapitalT]",
          FontColor->RGBColor[0.54, 0.35, 0.15]], 
         RowBox[{"0", ",", "0"}], "+"]], "]"}], "-", 
      RowBox[{"Log", "[", 
       SuperscriptBox[
        RowBox[{"(", 
         FractionBox[
          RowBox[{" ", 
           SuperscriptBox[
            StyleBox["\[ScriptCapitalT]",
             FontColor->RGBColor[1, 0, 0]], "+"], " "}], 
          SuperscriptBox[
           StyleBox["\[GothicCapitalT]",
            FontColor->RGBColor[0.54, 0.35, 0.15]], "+"]], ")"}], "2"], 
       "]"}]}], ")"}]}]}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Log", "[", 
   SuperscriptBox[
    RowBox[{"(", 
     RowBox[{
      FractionBox[
       SubscriptBox["Y", 
        RowBox[{"1", ",", "1"}]], 
       SubscriptBox["Y", 
        RowBox[{"2", ",", "2"}]]], 
      FractionBox[
       SubsuperscriptBox[
        StyleBox["\[GothicCapitalT]",
         FontColor->RGBColor[0.54, 0.35, 0.15]], 
        RowBox[{"2", ",", "1"}], "2"], 
       SubsuperscriptBox[
        StyleBox["\[ScriptCapitalT]",
         FontColor->RGBColor[1, 0, 0]], 
        RowBox[{"1", ",", "2"}], "2"]]}], ")"}], "-"], "]"}], "\[Equal]", 
  RowBox[{
   RowBox[{"Log", "[", 
    FractionBox[
     SubsuperscriptBox[
      StyleBox["\[GothicCapitalT]",
       FontColor->RGBColor[0.54, 0.35, 0.15]], 
      RowBox[{"1", ",", "0"}], "-"], 
     SubscriptBox[
      StyleBox["\[GothicCapitalT]",
       FontColor->RGBColor[0.54, 0.35, 0.15]], 
      RowBox[{"0", ",", "0"}]]], "]"}], "-", 
   RowBox[{"Log", "[", 
    SuperscriptBox[
     RowBox[{"(", 
      FractionBox[
       RowBox[{" ", 
        StyleBox["\[ScriptCapitalT]",
         FontColor->RGBColor[1, 0, 0]], " "}], 
       StyleBox["\[GothicCapitalT]",
        FontColor->RGBColor[0.54, 0.35, 0.15]]], ")"}], "2"], "]"}], "+", 
   RowBox[{
    SuperscriptBox["\[ScriptCapitalC]", "-"], "*", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"-", 
       RowBox[{"Log", "[", 
        FractionBox[
         SubscriptBox[
          StyleBox["\[GothicCapitalT]",
           FontColor->RGBColor[0.54, 0.35, 0.15]], 
          RowBox[{"1", ",", "0"}]], 
         SubsuperscriptBox[
          StyleBox["\[GothicCapitalT]",
           FontColor->RGBColor[0.54, 0.35, 0.15]], 
          RowBox[{"0", ",", "0"}], "-"]], "]"}]}], "+", 
      RowBox[{"Log", "[", 
       SuperscriptBox[
        RowBox[{"(", 
         FractionBox[
          RowBox[{" ", 
           SuperscriptBox[
            StyleBox["\[ScriptCapitalT]",
             FontColor->RGBColor[1, 0, 0]], "-"], " "}], 
          SuperscriptBox[
           StyleBox["\[GothicCapitalT]",
            FontColor->RGBColor[0.54, 0.35, 0.15]], "-"]], ")"}], "2"], "]"}],
       "+", 
      RowBox[{"Log", "[", 
       FractionBox[
        SubscriptBox[
         StyleBox["\[GothicCapitalT]",
          FontColor->RGBColor[0.54, 0.35, 0.15]], 
         RowBox[{"1", ",", "0"}]], 
        SubsuperscriptBox[
         StyleBox["\[GothicCapitalT]",
          FontColor->RGBColor[0.54, 0.35, 0.15]], 
         RowBox[{"0", ",", "0"}], "+"]], "]"}], "-", 
      RowBox[{"Log", "[", 
       SuperscriptBox[
        RowBox[{"(", 
         FractionBox[
          RowBox[{" ", 
           SuperscriptBox[
            StyleBox["\[ScriptCapitalT]",
             FontColor->RGBColor[1, 0, 0]], "+"], " "}], 
          SuperscriptBox[
           StyleBox["\[GothicCapitalT]",
            FontColor->RGBColor[0.54, 0.35, 0.15]], "+"]], ")"}], "2"], 
       "]"}]}], ")"}]}]}]}]}], "Input",
 CellChangeTimes->{{3.553314346569764*^9, 3.553314443360942*^9}, {
  3.553314541671711*^9, 3.553314552324584*^9}, {3.553316582238097*^9, 
  3.553316697306641*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"(", 
    RowBox[{"D", "-", 
     SuperscriptBox["D", 
      RowBox[{"-", "1"}]]}], ")"}], 
   RowBox[{"Log", "[", 
    RowBox[{"(", 
     RowBox[{
      FractionBox[
       SubscriptBox["Y", 
        RowBox[{"1", ",", "1"}]], 
       SubscriptBox["Y", 
        RowBox[{"2", ",", "2"}]]], 
      FractionBox[
       SubsuperscriptBox[
        StyleBox["\[GothicCapitalT]",
         FontColor->RGBColor[0.54, 0.35, 0.15]], 
        RowBox[{"2", ",", "1"}], "2"], 
       SubsuperscriptBox[
        StyleBox["\[ScriptCapitalT]",
         FontColor->RGBColor[1, 0, 0]], 
        RowBox[{"1", ",", "2"}], "2"]]}], ")"}], "]"}]}], "\[Equal]", 
  RowBox[{
   RowBox[{
    RowBox[{"(", 
     RowBox[{"D", "-", 
      SuperscriptBox["D", 
       RowBox[{"-", "1"}]]}], ")"}], 
    RowBox[{"Log", "[", 
     SubscriptBox[
      StyleBox["\[GothicCapitalT]",
       FontColor->RGBColor[0.54, 0.35, 0.15]], 
      RowBox[{"1", ",", "0"}]], "]"}]}], "+", 
   RowBox[{
    SubsuperscriptBox["\[Integral]", 
     RowBox[{
      RowBox[{"-", "\[Infinity]"}], "-", 
      RowBox[{"\[ImaginaryI]", " ", "0"}]}], 
     RowBox[{
      RowBox[{"+", "\[Infinity]"}], "-", 
      RowBox[{"\[ImaginaryI]", " ", "0"}]}]], 
    RowBox[{
     FractionBox["dv", 
      RowBox[{
       RowBox[{"-", "2"}], "\[Pi]", " ", "\[ImaginaryI]"}]], 
     RowBox[{"(", 
      RowBox[{
       FractionBox["1", 
        RowBox[{"u", "-", "v", "+", 
         FractionBox["\[ImaginaryI]", "2"]}]], "-", 
       FractionBox["1", 
        RowBox[{"u", "+", "v", "+", 
         FractionBox["\[ImaginaryI]", "2"]}]], "-", 
       FractionBox["1", 
        RowBox[{"u", "-", "v", "-", 
         FractionBox["\[ImaginaryI]", "2"]}]], "+", 
       FractionBox["1", 
        RowBox[{"u", "+", "v", "-", 
         FractionBox["\[ImaginaryI]", "2"]}]]}], ")"}], 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"Log", "[", 
        FractionBox[
         SubscriptBox[
          StyleBox["\[GothicCapitalT]",
           FontColor->RGBColor[0.54, 0.35, 0.15]], 
          RowBox[{"1", ",", "0"}]], 
         SubsuperscriptBox[
          StyleBox["\[GothicCapitalT]",
           FontColor->RGBColor[0.54, 0.35, 0.15]], 
          RowBox[{"0", ",", "0"}], "+"]], "]"}], "-", 
       RowBox[{"Log", "[", 
        SuperscriptBox[
         RowBox[{"(", 
          FractionBox[
           RowBox[{" ", 
            SuperscriptBox[
             StyleBox["\[ScriptCapitalT]",
              FontColor->RGBColor[1, 0, 0]], "+"], " "}], 
           SuperscriptBox[
            StyleBox["\[GothicCapitalT]",
             FontColor->RGBColor[0.54, 0.35, 0.15]], "+"]], ")"}], "2"], 
        "]"}]}], ")"}]}]}]}]}]], "Input",
 CellChangeTimes->{{3.553316701877013*^9, 3.553316768943914*^9}, {
  3.5533169699199142`*^9, 3.553316974709832*^9}, {3.5533170172958384`*^9, 
  3.5533170288410053`*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  FractionBox[
   RowBox[{
    RowBox[{
     FractionBox["1", 
      RowBox[{"u", "-", "v", "+", 
       FractionBox["\[ImaginaryI]", "2"]}]], "-", 
     FractionBox["1", 
      RowBox[{"u", "+", "v", "+", 
       FractionBox["\[ImaginaryI]", "2"]}]], "-", 
     FractionBox["1", 
      RowBox[{"u", "-", "v", "-", 
       FractionBox["\[ImaginaryI]", "2"]}]], "+", 
     FractionBox["1", 
      RowBox[{"u", "+", "v", "-", 
       FractionBox["\[ImaginaryI]", "2"]}]]}], "/.", 
    RowBox[{"u", "\[Rule]", 
     SubscriptBox["v", "0"]}]}], 
   RowBox[{
    RowBox[{
     FractionBox["1", 
      RowBox[{
       SuperscriptBox["Q", "+"], 
       SuperscriptBox["Q", "-"]}]], "/.", "subFunsBethe"}], "/.", 
    RowBox[{"u", "\[Rule]", "v"}]}]], "//", "Simplify"}]], "Input",
 CellChangeTimes->{{3.553316775651485*^9, 3.553316819922929*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"-", "4"}], " ", "\[ImaginaryI]", " ", "v", " ", 
  SubscriptBox["v", "0"]}]], "Output",
 CellChangeTimes->{3.55331677733169*^9, 3.553316820532804*^9}]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"(", 
    RowBox[{"D", "-", 
     SuperscriptBox["D", 
      RowBox[{"-", "1"}]]}], ")"}], 
   RowBox[{"Log", "[", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       FractionBox[
        SubscriptBox["Y", 
         RowBox[{"1", ",", "1"}]], 
        SubscriptBox["Y", 
         RowBox[{"2", ",", "2"}]]], 
       FractionBox[
        SubsuperscriptBox[
         StyleBox["\[GothicCapitalT]",
          FontColor->RGBColor[0.54, 0.35, 0.15]], 
         RowBox[{"2", ",", "1"}], "2"], 
        SubsuperscriptBox[
         StyleBox["\[ScriptCapitalT]",
          FontColor->RGBColor[1, 0, 0]], 
         RowBox[{"1", ",", "2"}], "2"]]}], ")"}], "/", 
     SubscriptBox[
      RowBox[{"(", 
       RowBox[{
        FractionBox[
         SubscriptBox["Y", 
          RowBox[{"1", ",", "1"}]], 
         SubscriptBox["Y", 
          RowBox[{"2", ",", "2"}]]], 
        FractionBox[
         SubsuperscriptBox[
          StyleBox["\[GothicCapitalT]",
           FontColor->RGBColor[0.54, 0.35, 0.15]], 
          RowBox[{"2", ",", "1"}], "2"], 
         SubsuperscriptBox[
          StyleBox["\[ScriptCapitalT]",
           FontColor->RGBColor[1, 0, 0]], 
          RowBox[{"1", ",", "2"}], "2"]]}], ")"}], "asym"]}], "]"}]}], 
  "\[Equal]", 
  RowBox[{
   RowBox[{
    RowBox[{"(", 
     RowBox[{"D", "-", 
      SuperscriptBox["D", 
       RowBox[{"-", "1"}]]}], ")"}], 
    RowBox[{"Log", "[", 
     FractionBox[
      SubscriptBox[
       StyleBox["\[GothicCapitalT]",
        FontColor->RGBColor[0.54, 0.35, 0.15]], 
       RowBox[{"1", ",", "0"}]], 
      SubscriptBox[
       RowBox[{"(", 
        SubscriptBox[
         StyleBox["\[GothicCapitalT]",
          FontColor->RGBColor[0.54, 0.35, 0.15]], 
         RowBox[{"1", ",", "0"}]], ")"}], "asym"]], "]"}]}], "-", 
   RowBox[{"4", "\[ImaginaryI]", " ", 
    SubscriptBox["v", "0"], 
    RowBox[{
     SubsuperscriptBox["\[Integral]", 
      RowBox[{
       RowBox[{"-", "\[Infinity]"}], "-", 
       RowBox[{"\[ImaginaryI]", " ", "0"}]}], 
      RowBox[{
       RowBox[{"+", "\[Infinity]"}], "-", 
       RowBox[{"\[ImaginaryI]", " ", "0"}]}]], 
     RowBox[{
      FractionBox["dv", 
       RowBox[{
        RowBox[{"-", "2"}], "\[Pi]", " ", "\[ImaginaryI]"}]], 
      FractionBox["v", 
       RowBox[{
        SuperscriptBox[
         StyleBox["Q",
          FontColor->RGBColor[0.8, 0, 0]], "-"], " ", 
        SuperscriptBox[
         StyleBox["Q",
          FontColor->RGBColor[0.8, 0, 0]], "+"]}]], 
      RowBox[{"(", 
       RowBox[{"H", "-", 
        RowBox[{"2", 
         RowBox[{"Log", "[", 
          RowBox[{
           RowBox[{"(", 
            FractionBox[
             RowBox[{" ", 
              SuperscriptBox[
               StyleBox["\[ScriptCapitalT]",
                FontColor->RGBColor[1, 0, 0]], "+"], " "}], 
             SuperscriptBox[
              StyleBox["\[GothicCapitalT]",
               FontColor->RGBColor[0.54, 0.35, 0.15]], "+"]], ")"}], "/", 
           SubscriptBox[
            RowBox[{"(", 
             FractionBox[
              RowBox[{" ", 
               SuperscriptBox[
                StyleBox["\[ScriptCapitalT]",
                 FontColor->RGBColor[1, 0, 0]], "+"], " "}], 
              SuperscriptBox[
               StyleBox["\[GothicCapitalT]",
                FontColor->RGBColor[0.54, 0.35, 0.15]], "+"]], ")"}], 
            "asym"]}], "]"}]}]}], ")"}]}]}]}]}]}]], "Input",
 CellChangeTimes->{{3.553316837933794*^9, 3.553316896579144*^9}, {
  3.553317044202005*^9, 3.553317087506382*^9}, {3.5533175290526648`*^9, 
  3.5533175357948027`*^9}}]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  RowBox[{"H", "\[Congruent]", 
   RowBox[{"Log", "[", 
    RowBox[{
     FractionBox[
      SubscriptBox[
       StyleBox["\[GothicCapitalT]",
        FontColor->RGBColor[0.54, 0.35, 0.15]], 
       RowBox[{"1", ",", "0"}]], 
      SubsuperscriptBox[
       StyleBox["\[GothicCapitalT]",
        FontColor->RGBColor[0.54, 0.35, 0.15]], 
       RowBox[{"0", ",", "0"}], "+"]], "/", 
     SubscriptBox[
      RowBox[{"(", 
       FractionBox[
        SubscriptBox[
         StyleBox["\[GothicCapitalT]",
          FontColor->RGBColor[0.54, 0.35, 0.15]], 
         RowBox[{"1", ",", "0"}]], 
        SubsuperscriptBox[
         StyleBox["\[GothicCapitalT]",
          FontColor->RGBColor[0.54, 0.35, 0.15]], 
         RowBox[{"0", ",", "0"}], "+"]], ")"}], "asym"]}], "]"}]}]],
  CellChangeTimes->{{3.553326436247958*^9, 3.5533264377368183`*^9}, {
   3.553326481625613*^9, 3.553326483351549*^9}}],
 " "
}], "Subsection",
 CellChangeTimes->{{3.5388041332985287`*^9, 3.538804147136546*^9}, 
   3.547313106575903*^9, {3.5477847253141813`*^9, 3.5477847279364634`*^9}, {
   3.55331404751853*^9, 3.553314080326559*^9}, 3.553317763050969*^9, {
   3.553329986325514*^9, 3.553329999657916*^9}, {3.553330062986905*^9, 
   3.553330065863699*^9}, {3.55371139310256*^9, 3.553711393651021*^9}, {
   3.553711750785131*^9, 3.553711751086812*^9}}],

Cell["Definition of H is", "Text",
 CellChangeTimes->{{3.553326432034747*^9, 3.55332643452055*^9}}],

Cell[BoxData[
 RowBox[{"H", "\[Congruent]", 
  RowBox[{"Log", "[", 
   RowBox[{
    FractionBox[
     SubscriptBox[
      StyleBox["\[GothicCapitalT]",
       FontColor->RGBColor[0.54, 0.35, 0.15]], 
      RowBox[{"1", ",", "0"}]], 
     SubsuperscriptBox[
      StyleBox["\[GothicCapitalT]",
       FontColor->RGBColor[0.54, 0.35, 0.15]], 
      RowBox[{"0", ",", "0"}], "+"]], "/", 
    SubscriptBox[
     RowBox[{"(", 
      FractionBox[
       SubscriptBox[
        StyleBox["\[GothicCapitalT]",
         FontColor->RGBColor[0.54, 0.35, 0.15]], 
        RowBox[{"1", ",", "0"}]], 
       SubsuperscriptBox[
        StyleBox["\[GothicCapitalT]",
         FontColor->RGBColor[0.54, 0.35, 0.15]], 
        RowBox[{"0", ",", "0"}], "+"]], ")"}], "asym"]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.553326436247958*^9, 3.5533264377368183`*^9}, {
  3.553326481625613*^9, 3.553326483351549*^9}}],

Cell["\<\
Below we compute it at single wrapping orders.\
\>", "Text",
 CellChangeTimes->{{3.55332644407218*^9, 3.553326464542048*^9}}],

Cell[BoxData[
 RowBox[{
  FractionBox[
   SubsuperscriptBox["q", 
    RowBox[{"1", ",", "3"}], "-"], 
   SuperscriptBox["Q", "-"]], "\[Equal]", 
  RowBox[{
   FractionBox[
    SubsuperscriptBox["q", 
     RowBox[{"1", ",", "3"}], "+"], 
    SuperscriptBox["Q", "+"]], "+", 
   FractionBox[
    SuperscriptBox["U", "2"], 
    RowBox[{
     SuperscriptBox["Q", "+"], 
     SuperscriptBox["Q", "-"]}]]}]}]], "Input",
 CellChangeTimes->{{3.55332796141031*^9, 3.553328003080833*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   FractionBox[
    SubsuperscriptBox["q", 
     RowBox[{"1", ",", "3"}], "-"], 
    SuperscriptBox["Q", "-"]], "\[Equal]", 
   RowBox[{
    FractionBox[
     SubsuperscriptBox["q", 
      RowBox[{"1", ",", "3"}], "+"], 
     SuperscriptBox["Q", "+"]], "+", 
    FractionBox[
     SuperscriptBox["U", "2"], 
     RowBox[{
      SuperscriptBox["Q", "+"], 
      SuperscriptBox["Q", "-"]}]]}]}], "/.", "mconj"}]], "Input",
 CellChangeTimes->{{3.553328010702651*^9, 3.5533280117998962`*^9}}],

Cell[BoxData[
 RowBox[{
  FractionBox[
   SubsuperscriptBox[
    OverscriptBox[
     StyleBox["q",
      FontColor->RGBColor[0, 0, 0.8]], 
     StyleBox["_",
      FontColor->RGBColor[0, 0, 0.8]]], 
    RowBox[{"1", ",", "3"}], "+"], 
   SuperscriptBox[
    StyleBox["Q",
     FontColor->RGBColor[0.8, 0, 0]], "+"]], "\[Equal]", 
  RowBox[{
   FractionBox[
    SuperscriptBox[
     OverscriptBox[
      StyleBox["U",
       FontColor->RGBColor[0, 0.6, 0]], 
      StyleBox["_",
       FontColor->RGBColor[0, 0.6, 0]]], "2"], 
    RowBox[{
     SuperscriptBox[
      StyleBox["Q",
       FontColor->RGBColor[0.8, 0, 0]], "-"], " ", 
     SuperscriptBox[
      StyleBox["Q",
       FontColor->RGBColor[0.8, 0, 0]], "+"]}]], "+", 
   FractionBox[
    SubsuperscriptBox[
     OverscriptBox[
      StyleBox["q",
       FontColor->RGBColor[0, 0, 0.8]], 
      StyleBox["_",
       FontColor->RGBColor[0, 0, 0.8]]], 
     RowBox[{"1", ",", "3"}], "-"], 
    SuperscriptBox[
     StyleBox["Q",
      FontColor->RGBColor[0.8, 0, 0]], "-"]]}]}]], "Output",
 CellChangeTimes->{3.553328012132002*^9, 3.553328336258181*^9}]
}, Open  ]],

Cell[BoxData[{
 RowBox[{"{", 
  RowBox[{
   RowBox[{
    SubscriptBox[
     StyleBox["q",
      FontColor->RGBColor[0, 0, 0.8]], 
     RowBox[{"1", ",", "2"}]], "==", 
    OverscriptBox[
     StyleBox["Q",
      FontColor->RGBColor[0.8, 0, 0]], 
     StyleBox["~",
      FontColor->RGBColor[0.8, 0, 0]]]}], ",", 
   RowBox[{
    SubscriptBox[
     StyleBox["q",
      FontColor->RGBColor[0, 0, 0.8]], 
     RowBox[{"1", ",", "3"}]], "==", 
    RowBox[{
     OverscriptBox[
      StyleBox["Q",
       FontColor->RGBColor[0.8, 0, 0]], 
      StyleBox["~",
       FontColor->RGBColor[0.8, 0, 0]]], 
     FractionBox["D", 
      RowBox[{"1", "-", 
       SuperscriptBox["D", "2"]}]], 
     FractionBox[
      SuperscriptBox[
       StyleBox["U",
        FontColor->RGBColor[0, 0.6, 0]], "2"], 
      RowBox[{
       SuperscriptBox[
        OverscriptBox[
         StyleBox["Q",
          FontColor->RGBColor[0.8, 0, 0]], 
         StyleBox["~",
          FontColor->RGBColor[0.8, 0, 0]]], "-"], " ", 
       SuperscriptBox[
        OverscriptBox[
         StyleBox["Q",
          FontColor->RGBColor[0.8, 0, 0]], 
         StyleBox["~",
          FontColor->RGBColor[0.8, 0, 0]]], "+"]}]]}]}], ",", 
   RowBox[{
    SubscriptBox[
     StyleBox["q",
      FontColor->RGBColor[0, 0, 0.8]], 
     RowBox[{"1", ",", "4"}]], "==", 
    SubscriptBox[
     StyleBox["q",
      FontColor->RGBColor[0, 0, 0.8]], 
     RowBox[{"2", ",", "3"}]], "==", 
    RowBox[{
     OverscriptBox[
      StyleBox["Q",
       FontColor->RGBColor[0.8, 0, 0]], 
      StyleBox["~",
       FontColor->RGBColor[0.8, 0, 0]]], 
     FractionBox["D", 
      RowBox[{"1", "-", 
       SuperscriptBox["D", "2"]}]], 
     FractionBox[
      RowBox[{
       SuperscriptBox[
        StyleBox["U",
         FontColor->RGBColor[0, 0.6, 0]], "2"], 
       SubscriptBox[
        StyleBox["q",
         FontColor->RGBColor[0, 0, 0.8]], "2"]}], 
      RowBox[{
       SuperscriptBox[
        OverscriptBox[
         StyleBox["Q",
          FontColor->RGBColor[0.8, 0, 0]], 
         StyleBox["~",
          FontColor->RGBColor[0.8, 0, 0]]], "-"], " ", 
       SuperscriptBox[
        OverscriptBox[
         StyleBox["Q",
          FontColor->RGBColor[0.8, 0, 0]], 
         StyleBox["~",
          FontColor->RGBColor[0.8, 0, 0]]], "+"]}]]}]}], ",", 
   RowBox[{
    SubscriptBox[
     StyleBox["q",
      FontColor->RGBColor[0, 0, 0.8]], 
     RowBox[{"2", ",", "4"}]], "==", 
    RowBox[{
     OverscriptBox[
      StyleBox["Q",
       FontColor->RGBColor[0.8, 0, 0]], 
      StyleBox["~",
       FontColor->RGBColor[0.8, 0, 0]]], 
     FractionBox["D", 
      RowBox[{"1", "-", 
       SuperscriptBox["D", "2"]}]], 
     FractionBox[
      RowBox[{
       SuperscriptBox[
        StyleBox["U",
         FontColor->RGBColor[0, 0.6, 0]], "2"], 
       SubsuperscriptBox[
        StyleBox["q",
         FontColor->RGBColor[0, 0, 0.8]], "2", "2"]}], 
      RowBox[{
       SuperscriptBox[
        OverscriptBox[
         StyleBox["Q",
          FontColor->RGBColor[0.8, 0, 0]], 
         StyleBox["~",
          FontColor->RGBColor[0.8, 0, 0]]], "-"], " ", 
       SuperscriptBox[
        OverscriptBox[
         StyleBox["Q",
          FontColor->RGBColor[0.8, 0, 0]], 
         StyleBox["~",
          FontColor->RGBColor[0.8, 0, 0]]], "+"]}]]}]}]}], 
  "}"}], "\[IndentingNewLine]", 
 RowBox[{"{", 
  RowBox[{
   RowBox[{
    SubscriptBox[
     StyleBox["q",
      FontColor->RGBColor[0, 0, 0.8]], "4"], "==", 
    FractionBox[
     RowBox[{
      RowBox[{
       SubscriptBox[
        StyleBox["q",
         FontColor->RGBColor[0, 0, 0.8]], "2"], " ", 
       SubsuperscriptBox[
        StyleBox["q",
         FontColor->RGBColor[0, 0, 0.8]], 
        RowBox[{"1", ",", "4"}], "+"]}], "-", 
      SubsuperscriptBox[
       StyleBox["q",
        FontColor->RGBColor[0, 0, 0.8]], 
       RowBox[{"2", ",", "4"}], "+"]}], 
     SuperscriptBox[
      OverscriptBox[
       StyleBox["Q",
        FontColor->RGBColor[0.8, 0, 0]], 
       StyleBox["~",
        FontColor->RGBColor[0.8, 0, 0]]], "+"]]}], ",", " ", 
   RowBox[{
    SubscriptBox[
     StyleBox["q",
      FontColor->RGBColor[0, 0, 0.8]], "3"], "==", 
    FractionBox[
     RowBox[{
      RowBox[{
       SubscriptBox[
        StyleBox["q",
         FontColor->RGBColor[0, 0, 0.8]], "2"], " ", 
       SubsuperscriptBox[
        StyleBox["q",
         FontColor->RGBColor[0, 0, 0.8]], 
        RowBox[{"1", ",", "3"}], "+"]}], "-", 
      SubsuperscriptBox[
       StyleBox["q",
        FontColor->RGBColor[0, 0, 0.8]], 
       RowBox[{"1", ",", "4"}], "+"]}], 
     SuperscriptBox[
      OverscriptBox[
       StyleBox["Q",
        FontColor->RGBColor[0.8, 0, 0]], 
       StyleBox["~",
        FontColor->RGBColor[0.8, 0, 0]]], "+"]]}], ",", 
   RowBox[{
    SubscriptBox[
     StyleBox["q",
      FontColor->RGBColor[0, 0, 0.8]], 
     RowBox[{"3", ",", "4"}]], "==", 
    FractionBox[
     RowBox[{
      RowBox[{
       SubscriptBox[
        StyleBox["q",
         FontColor->RGBColor[0, 0, 0.8]], 
        RowBox[{"1", ",", "3"}]], " ", 
       SubscriptBox[
        StyleBox["q",
         FontColor->RGBColor[0, 0, 0.8]], 
        RowBox[{"2", ",", "4"}]]}], "-", 
      RowBox[{
       SubscriptBox[
        StyleBox["q",
         FontColor->RGBColor[0, 0, 0.8]], 
        RowBox[{"1", ",", "4"}]], " ", 
       SubscriptBox[
        StyleBox["q",
         FontColor->RGBColor[0, 0, 0.8]], 
        RowBox[{"2", ",", "3"}]]}]}], 
     OverscriptBox[
      StyleBox["Q",
       FontColor->RGBColor[0.8, 0, 0]], 
      StyleBox["~",
       FontColor->RGBColor[0.8, 0, 0]]]]}]}], "}"}]}], "Input"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"Series", "[", 
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{
          RowBox[{"Log", "[", 
           RowBox[{
            FractionBox[
             SubscriptBox["T", 
              RowBox[{"1", ",", "0"}]], 
             SubsuperscriptBox["T", 
              RowBox[{"0", ",", "0"}], "+"]], "/", 
            RowBox[{"(", 
             FractionBox[
              SuperscriptBox["Q", "-"], 
              SuperscriptBox["Q", "+"]], ")"}]}], "]"}], "/.", "subTQ"}], "/.",
          "subpqb"}], "/.", 
        RowBox[{
         SubsuperscriptBox["q", 
          RowBox[{"3", ",", "4"}], 
          RowBox[{"[", 
           RowBox[{"_", ":", "0"}], "]"}]], "\[Rule]", "0"}]}], "/.", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{
          RowBox[{
           RowBox[{"q$", "[", 
            RowBox[{"1", ",", "2"}], "]"}], "[", 
           RowBox[{"r_:", "0"}], "]"}], "\[RuleDelayed]", 
          RowBox[{
           RowBox[{
            FractionBox["1", "\[Epsilon]"], 
            RowBox[{"Q$", "[", "r", "]"}]}], "+", 
           RowBox[{"\[Epsilon]", " ", 
            RowBox[{"\[Delta]Q$", "[", "r", "]"}]}]}]}], ",", 
         RowBox[{
          RowBox[{
           RowBox[{"q$b", "[", 
            RowBox[{"1", ",", "2"}], "]"}], "[", 
           RowBox[{"r_:", "0"}], "]"}], "\[RuleDelayed]", 
          RowBox[{
           RowBox[{
            FractionBox["1", "\[Epsilon]"], 
            RowBox[{"Q$", "[", "r", "]"}]}], "+", 
           RowBox[{"\[Epsilon]", " ", 
            RowBox[{"\[Delta]Q$b", "[", "r", "]"}]}]}]}]}], "}"}]}], "/.", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"eee_", "[", 
         RowBox[{"2", ",", "3"}], "]"}], "\[RuleDelayed]", 
        RowBox[{"eee", "[", 
         RowBox[{"1", ",", "4"}], "]"}]}], "}"}]}], ",", 
     RowBox[{"{", 
      RowBox[{"\[Epsilon]", ",", "0", ",", "2"}], "}"}]}], "]"}], "//", 
   "Normal"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Collect", "[", 
   RowBox[{
    RowBox[{"%", "/.", 
     RowBox[{"\[Epsilon]", "\[Rule]", "1"}]}], ",", 
    RowBox[{"{", 
     SubsuperscriptBox["q", 
      RowBox[{"_", ",", "_"}], "+"], "}"}], ",", 
    RowBox[{
     RowBox[{"Simplify", "[", 
      RowBox[{"(", 
       RowBox[{"#", "/.", 
        RowBox[{"{", 
         RowBox[{
          SubsuperscriptBox[
           OverscriptBox[
            StyleBox["q",
             FontColor->RGBColor[0, 0, 0.8]], 
            StyleBox["_",
             FontColor->RGBColor[0, 0, 0.8]]], 
           RowBox[{"i_", ",", "j_"}], "+"], "\[RuleDelayed]", " ", 
          RowBox[{"(", "  ", 
           RowBox[{
            FractionBox[
             RowBox[{
              RowBox[{"If", "[", 
               RowBox[{
                RowBox[{"i", "\[Equal]", "2"}], ",", 
                SubscriptBox[
                 OverscriptBox["q", "_"], "2"], ",", "1"}], "]"}], 
              RowBox[{"If", "[", 
               RowBox[{
                RowBox[{"j", "\[Equal]", "4"}], ",", 
                SubscriptBox[
                 OverscriptBox["q", "_"], "2"], ",", "1"}], "]"}], 
              SuperscriptBox[
               OverscriptBox[
                StyleBox["U",
                 FontColor->RGBColor[0, 0.6, 0]], 
                StyleBox["_",
                 FontColor->RGBColor[0, 0.6, 0]]], "2"]}], 
             RowBox[{" ", 
              SuperscriptBox[
               StyleBox["Q",
                FontColor->RGBColor[0.8, 0, 0]], "-"]}]], "+", 
            RowBox[{
             SuperscriptBox[
              StyleBox["Q",
               FontColor->RGBColor[0.8, 0, 0]], "+"], 
             FractionBox[
              SubsuperscriptBox[
               OverscriptBox[
                StyleBox["q",
                 FontColor->RGBColor[0, 0, 0.8]], 
                StyleBox["_",
                 FontColor->RGBColor[0, 0, 0.8]]], 
               RowBox[{"i", ",", "j"}], "-"], 
              SuperscriptBox[
               StyleBox["Q",
                FontColor->RGBColor[0.8, 0, 0]], "-"]]}]}], ")"}]}], "}"}]}], 
       ")"}], "]"}], "&"}]}], "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"Collect", "[", 
  RowBox[{"%", ",", 
   RowBox[{"{", 
    RowBox[{"U$b", "[", "0", "]"}], "}"}], ",", "Simplify"}], "]"}]}], "Input",\

 CellChangeTimes->{{3.553327352389721*^9, 3.553327660568623*^9}, {
  3.553327703405796*^9, 3.553327800615629*^9}, {3.553327922321105*^9, 
  3.553327947584903*^9}, {3.553328030347815*^9, 3.553328180858482*^9}, {
  3.553328341182995*^9, 3.553328395603541*^9}}],

Cell[BoxData[
 RowBox[{
  FractionBox[
   SuperscriptBox[
    OverscriptBox[
     StyleBox["\[Delta]Q",
      FontColor->RGBColor[0.8, 0, 0]], 
     StyleBox["_",
      FontColor->RGBColor[0.8, 0, 0]]], "-"], 
   SuperscriptBox[
    StyleBox["Q",
     FontColor->RGBColor[0.8, 0, 0]], "-"]], "-", 
  FractionBox[
   SuperscriptBox[
    OverscriptBox[
     StyleBox["\[Delta]Q",
      FontColor->RGBColor[0.8, 0, 0]], 
     StyleBox["_",
      FontColor->RGBColor[0.8, 0, 0]]], "+"], 
   SuperscriptBox[
    StyleBox["Q",
     FontColor->RGBColor[0.8, 0, 0]], "+"]], "+", 
  FractionBox[
   RowBox[{
    SuperscriptBox[
     OverscriptBox[
      StyleBox["U",
       FontColor->RGBColor[0, 0.6, 0]], 
      StyleBox["_",
       FontColor->RGBColor[0, 0.6, 0]]], "2"], " ", 
    RowBox[{"(", 
     RowBox[{
      SubsuperscriptBox[
       StyleBox["q",
        FontColor->RGBColor[0, 0, 0.8]], 
       RowBox[{"2", ",", "4"}], "+"], "+", 
      RowBox[{"2", " ", 
       SubsuperscriptBox[
        StyleBox["q",
         FontColor->RGBColor[0, 0, 0.8]], 
        RowBox[{"1", ",", "4"}], "+"], " ", 
       SubscriptBox[
        OverscriptBox[
         StyleBox["q",
          FontColor->RGBColor[0, 0, 0.8]], 
         StyleBox["_",
          FontColor->RGBColor[0, 0, 0.8]]], "2"]}], "+", 
      RowBox[{
       SubsuperscriptBox[
        StyleBox["q",
         FontColor->RGBColor[0, 0, 0.8]], 
        RowBox[{"1", ",", "3"}], "+"], " ", 
       SubsuperscriptBox[
        OverscriptBox[
         StyleBox["q",
          FontColor->RGBColor[0, 0, 0.8]], 
         StyleBox["_",
          FontColor->RGBColor[0, 0, 0.8]]], "2", "2"]}]}], ")"}]}], 
   RowBox[{
    SuperscriptBox[
     StyleBox["Q",
      FontColor->RGBColor[0.8, 0, 0]], "-"], " ", 
    SuperscriptBox[
     RowBox[{"(", 
      SuperscriptBox[
       StyleBox["Q",
        FontColor->RGBColor[0.8, 0, 0]], "+"], ")"}], "2"]}]]}]], "Output",
 CellChangeTimes->{{3.553328160604347*^9, 3.553328181221238*^9}, {
  3.553328350669293*^9, 3.553328396231187*^9}}]
}, Open  ]],

Cell["\<\
We correspondingly decompose H=Hr1+Hr2\
\>", "Text",
 CellChangeTimes->{{3.5533293704841146`*^9, 3.553329379217265*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"Hr1", "==", 
    RowBox[{
     FractionBox[
      SuperscriptBox[
       OverscriptBox[
        StyleBox["\[Delta]Q",
         FontColor->RGBColor[0.8, 0, 0]], 
        StyleBox["_",
         FontColor->RGBColor[0.8, 0, 0]]], "-"], 
      SuperscriptBox[
       StyleBox["Q",
        FontColor->RGBColor[0.8, 0, 0]], "-"]], "-", 
     FractionBox[
      SuperscriptBox[
       OverscriptBox[
        StyleBox["\[Delta]Q",
         FontColor->RGBColor[0.8, 0, 0]], 
        StyleBox["_",
         FontColor->RGBColor[0.8, 0, 0]]], "+"], 
      SuperscriptBox[
       StyleBox["Q",
        FontColor->RGBColor[0.8, 0, 0]], "+"]]}]}], ",", 
   RowBox[{"Hr2", "==", 
    FractionBox[
     RowBox[{
      SuperscriptBox[
       OverscriptBox[
        StyleBox["U",
         FontColor->RGBColor[0, 0.6, 0]], 
        StyleBox["_",
         FontColor->RGBColor[0, 0.6, 0]]], "2"], " ", 
      RowBox[{"(", 
       RowBox[{
        SubsuperscriptBox[
         StyleBox["q",
          FontColor->RGBColor[0, 0, 0.8]], 
         RowBox[{"2", ",", "4"}], "+"], "+", 
        RowBox[{"2", " ", 
         SubsuperscriptBox[
          StyleBox["q",
           FontColor->RGBColor[0, 0, 0.8]], 
          RowBox[{"1", ",", "4"}], "+"], " ", 
         SubscriptBox[
          OverscriptBox[
           StyleBox["q",
            FontColor->RGBColor[0, 0, 0.8]], 
           StyleBox["_",
            FontColor->RGBColor[0, 0, 0.8]]], "2"]}], "+", 
        RowBox[{
         SubsuperscriptBox[
          StyleBox["q",
           FontColor->RGBColor[0, 0, 0.8]], 
          RowBox[{"1", ",", "3"}], "+"], " ", 
         SubsuperscriptBox[
          OverscriptBox[
           StyleBox["q",
            FontColor->RGBColor[0, 0, 0.8]], 
           StyleBox["_",
            FontColor->RGBColor[0, 0, 0.8]]], "2", "2"]}]}], ")"}]}], 
     RowBox[{
      SuperscriptBox[
       StyleBox["Q",
        FontColor->RGBColor[0.8, 0, 0]], "-"], " ", 
      SuperscriptBox[
       RowBox[{"(", 
        SuperscriptBox[
         StyleBox["Q",
          FontColor->RGBColor[0.8, 0, 0]], "+"], ")"}], "2"]}]]}]}], 
  "}"}]], "Input",
 CellChangeTimes->{{3.553329381501622*^9, 3.55332939791158*^9}}],

Cell["\<\
The following substitution is added to leadweak for Hr2:\
\>", "Text",
 CellChangeTimes->{{3.5533294050104303`*^9, 3.553329416559914*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"With", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"order", "=", "1"}], "}"}], ",", 
   RowBox[{"Normal", "@", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       RowBox[{"Collect", "[", 
        RowBox[{"#", ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{
            RowBox[{
             RowBox[{"\[Eta]$", "[", "__", "]"}], "[", "_", "]"}], 
            RowBox[{
             RowBox[{"\[Eta]$b", "[", "__", "]"}], "[", "_", "]"}]}], ",", 
           RowBox[{
            RowBox[{"\[Eta]$", "[", "__", "]"}], "[", "_", "]"}], ",", 
           RowBox[{
            RowBox[{"\[Eta]$b", "[", "__", "]"}], "[", "_", "]"}], ",", 
           RowBox[{
            SuperscriptBox[
             RowBox[{"(", 
              SuperscriptBox["Q0", "+"], ")"}], "_"], 
            SuperscriptBox[
             RowBox[{"(", 
              SuperscriptBox["Q0", "-"], ")"}], "_"]}], ",", 
           SuperscriptBox["Q0", "+"], ",", 
           SuperscriptBox["Q0", "-"]}], "}"}], ",", "Expand"}], "]"}], "&"}], 
      "/@", 
      RowBox[{"Series", "[", 
       RowBox[{
        RowBox[{
         FractionBox[
          RowBox[{
           SuperscriptBox[
            OverscriptBox[
             StyleBox["U",
              FontColor->RGBColor[0, 0.6, 0]], 
             StyleBox["_",
              FontColor->RGBColor[0, 0.6, 0]]], "2"], " ", 
           RowBox[{"(", 
            RowBox[{
             SubsuperscriptBox[
              StyleBox["q",
               FontColor->RGBColor[0, 0, 0.8]], 
              RowBox[{"2", ",", "4"}], "+"], "+", 
             RowBox[{"2", " ", 
              SubsuperscriptBox[
               StyleBox["q",
                FontColor->RGBColor[0, 0, 0.8]], 
               RowBox[{"1", ",", "4"}], "+"], " ", 
              SubscriptBox[
               OverscriptBox[
                StyleBox["q",
                 FontColor->RGBColor[0, 0, 0.8]], 
                StyleBox["_",
                 FontColor->RGBColor[0, 0, 0.8]]], "2"]}], "+", 
             RowBox[{
              SubsuperscriptBox[
               StyleBox["q",
                FontColor->RGBColor[0, 0, 0.8]], 
               RowBox[{"1", ",", "3"}], "+"], " ", 
              SubsuperscriptBox[
               OverscriptBox[
                StyleBox["q",
                 FontColor->RGBColor[0, 0, 0.8]], 
                StyleBox["_",
                 FontColor->RGBColor[0, 0, 0.8]]], "2", "2"]}]}], ")"}]}], 
          RowBox[{
           SuperscriptBox[
            StyleBox["Q",
             FontColor->RGBColor[0.8, 0, 0]], "-"], " ", 
           SuperscriptBox[
            RowBox[{"(", 
             SuperscriptBox[
              StyleBox["Q",
               FontColor->RGBColor[0.8, 0, 0]], "+"], ")"}], "2"]}]], "/.", 
         RowBox[{"leadweak", "[", "order", "]"}]}], ",", 
        RowBox[{"{", 
         RowBox[{"g", ",", "0", ",", 
          RowBox[{
           RowBox[{"2", "order"}], "+", "6"}]}], "}"}]}], "]"}]}], ")"}]}]}], 
  "]"}]], "Input",
 CellChangeTimes->{{3.5533286169150877`*^9, 3.553328619033298*^9}, {
  3.5533287613667097`*^9, 3.5533287763567953`*^9}, {3.553328971674559*^9, 
  3.553329060973032*^9}, {3.5533291467086153`*^9, 3.553329158456848*^9}, {
  3.553329258614246*^9, 3.553329329767577*^9}}],

Cell[BoxData[
 RowBox[{
  SuperscriptBox["g", "8"], " ", 
  RowBox[{"(", 
   RowBox[{
    FractionBox[
     RowBox[{"18", "+", 
      FractionBox["2", 
       SuperscriptBox["u", "4"]], "+", 
      FractionBox["18", 
       SuperscriptBox["u", "2"]], "-", 
      FractionBox[
       RowBox[{"24", " ", "\[ImaginaryI]"}], "u"], "-", 
      RowBox[{"36", " ", "\[ImaginaryI]", " ", "u"}]}], 
     RowBox[{
      SuperscriptBox[
       StyleBox["Q0",
        FontColor->RGBColor[{
           Rational[1, 2], 
           Rational[1, 2], 0}]], "-"], " ", 
      SuperscriptBox[
       RowBox[{"(", 
        SuperscriptBox[
         StyleBox["Q0",
          FontColor->RGBColor[{
             Rational[1, 2], 
             Rational[1, 2], 0}]], "+"], ")"}], "2"]}]], "+", 
    FractionBox[
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "36"}], "-", 
        FractionBox["4", 
         SuperscriptBox["u", "4"]], "-", 
        FractionBox["36", 
         SuperscriptBox["u", "2"]]}], ")"}], " ", 
      SubsuperscriptBox[
       StyleBox["\[Eta]",
        FontWeight->Bold,
        FontColor->RGBColor[0.8, 0, 0]], "2", 
       RowBox[{"[", "2", "]"}]]}], 
     RowBox[{
      SuperscriptBox[
       StyleBox["Q0",
        FontColor->RGBColor[{
           Rational[1, 2], 
           Rational[1, 2], 0}]], "-"], " ", 
      SuperscriptBox[
       StyleBox["Q0",
        FontColor->RGBColor[{
           Rational[1, 2], 
           Rational[1, 2], 0}]], "+"]}]], "+", 
    FractionBox[
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        FractionBox["8", 
         SuperscriptBox["u", "3"]], "+", 
        FractionBox["24", "u"]}], ")"}], " ", 
      SubsuperscriptBox[
       StyleBox["\[Eta]",
        FontWeight->Bold,
        FontColor->RGBColor[0.8, 0, 0]], "3", 
       RowBox[{"[", "2", "]"}]]}], 
     RowBox[{
      SuperscriptBox[
       StyleBox["Q0",
        FontColor->RGBColor[{
           Rational[1, 2], 
           Rational[1, 2], 0}]], "-"], " ", 
      SuperscriptBox[
       StyleBox["Q0",
        FontColor->RGBColor[{
           Rational[1, 2], 
           Rational[1, 2], 0}]], "+"]}]], "-", 
    FractionBox[
     RowBox[{"4", " ", 
      SubsuperscriptBox[
       StyleBox["\[Eta]",
        FontWeight->Bold,
        FontColor->RGBColor[0.8, 0, 0]], "4", 
       RowBox[{"[", "2", "]"}]]}], 
     RowBox[{
      SuperscriptBox["u", "2"], " ", 
      SuperscriptBox[
       StyleBox["Q0",
        FontColor->RGBColor[{
           Rational[1, 2], 
           Rational[1, 2], 0}]], "-"], " ", 
      SuperscriptBox[
       StyleBox["Q0",
        FontColor->RGBColor[{
           Rational[1, 2], 
           Rational[1, 2], 0}]], "+"]}]]}], ")"}]}]], "Output",
 CellChangeTimes->{
  3.55332861950231*^9, {3.55332875793578*^9, 3.553328777523758*^9}, 
   3.5533289626170073`*^9, {3.553329035157282*^9, 3.553329062474621*^9}, {
   3.553329148757448*^9, 3.553329160362392*^9}, {3.5533292992096853`*^9, 
   3.553329330196417*^9}}]
}, Open  ]],

Cell["\<\
So, the general usage is  possible:\
\>", "Text",
 CellChangeTimes->{{3.55332992122928*^9, 3.553329956983836*^9}}],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"$\[Delta]QCorrectiontoH", "=", "False"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  OverscriptBox["H", "_"], "/.", 
  RowBox[{"leadweak", "[", "1", "]"}]}]}], "Input",
 CellChangeTimes->{{3.55332989736458*^9, 3.553329919743339*^9}, {
  3.553329950897606*^9, 3.55332995211728*^9}, {3.5535858812232*^9, 
  3.553585909635571*^9}, {3.553706573546607*^9, 3.5537065768181963`*^9}, {
  3.55370696949934*^9, 3.553706972851643*^9}}],

Cell[BoxData[
 RowBox[{
  SuperscriptBox["g", "8"], " ", 
  RowBox[{"(", 
   RowBox[{
    FractionBox[
     RowBox[{"18", "+", 
      FractionBox["2", 
       SuperscriptBox["u", "4"]], "+", 
      FractionBox["18", 
       SuperscriptBox["u", "2"]], "+", 
      FractionBox[
       RowBox[{"24", " ", "\[ImaginaryI]"}], "u"], "+", 
      RowBox[{"36", " ", "\[ImaginaryI]", " ", "u"}]}], 
     RowBox[{
      SuperscriptBox[
       RowBox[{"(", 
        SuperscriptBox[
         StyleBox["Q0",
          FontColor->RGBColor[{
             Rational[1, 2], 
             Rational[1, 2], 0}]], "-"], ")"}], "2"], " ", 
      SuperscriptBox[
       StyleBox["Q0",
        FontColor->RGBColor[{
           Rational[1, 2], 
           Rational[1, 2], 0}]], "+"]}]], "+", 
    FractionBox[
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "36"}], "-", 
        FractionBox["4", 
         SuperscriptBox["u", "4"]], "-", 
        FractionBox["36", 
         SuperscriptBox["u", "2"]]}], ")"}], " ", 
      SubsuperscriptBox[
       OverscriptBox[
        StyleBox["\[Eta]",
         FontWeight->Bold,
         FontColor->RGBColor[0.8, 0, 0]], 
        StyleBox["_",
         FontWeight->Bold,
         FontColor->RGBColor[0.8, 0, 0]]], "2", 
       RowBox[{"[", 
        RowBox[{"-", "2"}], "]"}]]}], 
     RowBox[{
      SuperscriptBox[
       StyleBox["Q0",
        FontColor->RGBColor[{
           Rational[1, 2], 
           Rational[1, 2], 0}]], "-"], " ", 
      SuperscriptBox[
       StyleBox["Q0",
        FontColor->RGBColor[{
           Rational[1, 2], 
           Rational[1, 2], 0}]], "+"]}]], "+", 
    FractionBox[
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        FractionBox["8", 
         SuperscriptBox["u", "3"]], "+", 
        FractionBox["24", "u"]}], ")"}], " ", 
      SubsuperscriptBox[
       OverscriptBox[
        StyleBox["\[Eta]",
         FontWeight->Bold,
         FontColor->RGBColor[0.8, 0, 0]], 
        StyleBox["_",
         FontWeight->Bold,
         FontColor->RGBColor[0.8, 0, 0]]], "3", 
       RowBox[{"[", 
        RowBox[{"-", "2"}], "]"}]]}], 
     RowBox[{
      SuperscriptBox[
       StyleBox["Q0",
        FontColor->RGBColor[{
           Rational[1, 2], 
           Rational[1, 2], 0}]], "-"], " ", 
      SuperscriptBox[
       StyleBox["Q0",
        FontColor->RGBColor[{
           Rational[1, 2], 
           Rational[1, 2], 0}]], "+"]}]], "-", 
    FractionBox[
     RowBox[{"4", " ", 
      SubsuperscriptBox[
       OverscriptBox[
        StyleBox["\[Eta]",
         FontWeight->Bold,
         FontColor->RGBColor[0.8, 0, 0]], 
        StyleBox["_",
         FontWeight->Bold,
         FontColor->RGBColor[0.8, 0, 0]]], "4", 
       RowBox[{"[", 
        RowBox[{"-", "2"}], "]"}]]}], 
     RowBox[{
      SuperscriptBox["u", "2"], " ", 
      SuperscriptBox[
       StyleBox["Q0",
        FontColor->RGBColor[{
           Rational[1, 2], 
           Rational[1, 2], 0}]], "-"], " ", 
      SuperscriptBox[
       StyleBox["Q0",
        FontColor->RGBColor[{
           Rational[1, 2], 
           Rational[1, 2], 0}]], "+"]}]]}], ")"}]}]], "Output",
 CellChangeTimes->{3.553706973930298*^9, 3.553710018457357*^9}]
}, Open  ]],

Cell["\<\
If we want explicitly Hr1 then \
\>", "Text",
 CellChangeTimes->{{3.553706982371188*^9, 3.5537069910886593`*^9}}],

Cell[BoxData[{
 RowBox[{"{", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{
     OverscriptBox["Q", "~"], "=", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"u", "-", 
        SubscriptBox["v", "0"], "-", "\[Alpha]"}], ")"}], 
      RowBox[{"(", 
       RowBox[{"u", "+", 
        SubscriptBox["v", "0"], "+", 
        OverscriptBox["\[Alpha]", "_"]}], ")"}]}]}], ",", 
    RowBox[{
     OverscriptBox[
      OverscriptBox["Q", "~"], "_"], "=", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"u", "-", 
        SubscriptBox["v", "0"], "-", 
        OverscriptBox["\[Alpha]", "_"]}], ")"}], 
      RowBox[{"(", 
       RowBox[{"u", "+", 
        SubscriptBox["v", "0"], "+", "\[Alpha]"}], ")"}]}]}]}], "}"}], 
  "}"}], "\[IndentingNewLine]", 
 RowBox[{
  OverscriptBox["\[Delta]Q", "_"], "\[Equal]", 
  RowBox[{
   RowBox[{"u", 
    RowBox[{"(", 
     RowBox[{"\[Alpha]", "-", 
      OverscriptBox["\[Alpha]", "_"]}], ")"}]}], "-", 
   RowBox[{
    SubscriptBox["v", "0"], 
    RowBox[{"(", 
     RowBox[{"\[Alpha]", "+", 
      OverscriptBox["\[Alpha]", "_"]}], ")"}]}]}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   FractionBox[
    SuperscriptBox[
     OverscriptBox[
      StyleBox["\[Delta]Q",
       FontColor->RGBColor[0.8, 0, 0]], 
      StyleBox["_",
       FontColor->RGBColor[0.8, 0, 0]]], "-"], 
    SuperscriptBox[
     StyleBox["Q",
      FontColor->RGBColor[0.8, 0, 0]], "-"]], "-", 
   FractionBox[
    SuperscriptBox[
     OverscriptBox[
      StyleBox["\[Delta]Q",
       FontColor->RGBColor[0.8, 0, 0]], 
      StyleBox["_",
       FontColor->RGBColor[0.8, 0, 0]]], "+"], 
    SuperscriptBox[
     StyleBox["Q",
      FontColor->RGBColor[0.8, 0, 0]], "+"]]}], "==", 
  RowBox[{
   FractionBox[
    RowBox[{
     RowBox[{
      RowBox[{"(", 
       RowBox[{"u", "-", 
        FractionBox["\[ImaginaryI]", "2"]}], ")"}], 
      RowBox[{"(", 
       RowBox[{"\[Alpha]", "-", 
        OverscriptBox["\[Alpha]", "_"]}], ")"}]}], "-", 
     RowBox[{
      SubscriptBox["v", "0"], 
      RowBox[{"(", 
       RowBox[{"\[Alpha]", "+", 
        OverscriptBox["\[Alpha]", "_"]}], ")"}]}]}], 
    SuperscriptBox["Q", "-"]], "-", 
   FractionBox[
    RowBox[{
     RowBox[{
      RowBox[{"(", 
       RowBox[{"u", "+", 
        FractionBox["\[ImaginaryI]", "2"]}], ")"}], 
      RowBox[{"(", 
       RowBox[{"\[Alpha]", "-", 
        OverscriptBox["\[Alpha]", "_"]}], ")"}]}], "-", 
     RowBox[{
      SubscriptBox["v", "0"], 
      RowBox[{"(", 
       RowBox[{"\[Alpha]", "+", 
        OverscriptBox["\[Alpha]", "_"]}], ")"}]}]}], 
    SuperscriptBox["Q", "+"]]}]}]}], "Input",
 CellChangeTimes->{{3.5537070013889637`*^9, 3.553707068843534*^9}, {
  3.553707127337048*^9, 3.553707178935706*^9}}],

Cell["\<\
Result of computation below was stored in compressed form in stylepackage.m\
\>", "Text",
 CellChangeTimes->{{3.553709923174942*^9, 3.5537099462604856`*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"(", 
    RowBox[{"tmp", "=", 
     RowBox[{
      RowBox[{
       RowBox[{"Collect", "[", 
        RowBox[{"#", ",", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{
            SuperscriptBox["Q0", "+"], ",", 
            SuperscriptBox["Q0", "-"], ",", "\[Eta]0list", ",", "u", ",", 
            SubscriptBox["\[Zeta]", "__"]}], "}"}], "//", "Flatten"}], ",", 
         "FullSimplify"}], "]"}], "&"}], "/@", 
      RowBox[{"(", 
       RowBox[{"Series", "[", 
        RowBox[{
         RowBox[{
          RowBox[{
           FractionBox[
            RowBox[{
             RowBox[{
              RowBox[{"(", 
               RowBox[{"u", "-", 
                FractionBox["\[ImaginaryI]", "2"]}], ")"}], 
              RowBox[{"(", 
               RowBox[{"\[Alpha]", "-", 
                OverscriptBox["\[Alpha]", "_"]}], ")"}]}], "-", 
             RowBox[{
              SubscriptBox["v", "0"], 
              RowBox[{"(", 
               RowBox[{"\[Alpha]", "+", 
                OverscriptBox["\[Alpha]", "_"]}], ")"}]}]}], 
            SuperscriptBox["Q", "-"]], "-", 
           FractionBox[
            RowBox[{
             RowBox[{
              RowBox[{"(", 
               RowBox[{"u", "+", 
                FractionBox["\[ImaginaryI]", "2"]}], ")"}], 
              RowBox[{"(", 
               RowBox[{"\[Alpha]", "-", 
                OverscriptBox["\[Alpha]", "_"]}], ")"}]}], "-", 
             RowBox[{
              SubscriptBox["v", "0"], 
              RowBox[{"(", 
               RowBox[{"\[Alpha]", "+", 
                OverscriptBox["\[Alpha]", "_"]}], ")"}]}]}], 
            SuperscriptBox["Q", "+"]]}], "/.", 
          RowBox[{"leadweak", "[", "4", "]"}]}], ",", 
         RowBox[{"{", 
          RowBox[{"g", ",", "0", ",", 
           RowBox[{
            RowBox[{"2", " ", "4"}], "+", "6"}]}], "}"}]}], "]"}], ")"}]}]}], 
    ")"}], "//", "Short"}], "//", "Timing"}]], "Input",
 CellChangeTimes->{{3.553707212982997*^9, 3.5537072216832314`*^9}, {
  3.55370734817763*^9, 3.553707510666803*^9}, {3.5537092512026978`*^9, 
  3.553709251277132*^9}, {3.5537094795207987`*^9, 3.553709487956468*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"29.138156999999865`", ",", 
   TagBox[
    InterpretationBox[
     RowBox[{
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         FractionBox[
          RowBox[{"\[LeftSkeleton]", "1", "\[RightSkeleton]"}], 
          SuperscriptBox[
           StyleBox["Q0",
            FontColor->RGBColor[{
               Rational[1, 2], 
               Rational[1, 2], 0}]], "+"]], "+", 
         FractionBox[
          RowBox[{
           RowBox[{"-", "108"}], "+", 
           RowBox[{"\[LeftSkeleton]", "5", "\[RightSkeleton]"}], "+", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{"\[LeftSkeleton]", "1", "\[RightSkeleton]"}], ")"}], " ", 
            RowBox[{"\[LeftSkeleton]", "1", "\[RightSkeleton]"}]}]}], 
          SuperscriptBox[
           StyleBox["Q0",
            FontColor->RGBColor[{
               Rational[1, 2], 
               Rational[1, 2], 0}]], "-"]]}], ")"}], " ", 
       SuperscriptBox["g", "8"]}], "+", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{"\[LeftSkeleton]", "1", "\[RightSkeleton]"}], ")"}], " ", 
       SuperscriptBox["g", "10"]}], "+", 
      RowBox[{"\[LeftSkeleton]", "1", "\[RightSkeleton]"}], "+", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{"\[LeftSkeleton]", "1", "\[RightSkeleton]"}], ")"}], " ", 
       RowBox[{"\[LeftSkeleton]", "1", "\[RightSkeleton]"}]}], "+", 
      InterpretationBox[
       SuperscriptBox[
        RowBox[{"O", "[", "g", "]"}], "15"],
       SeriesData[$CellContext`g, 0, {}, 8, 15, 1],
       Editable->False]}],
     SeriesData[$CellContext`g, 
      0, {$CellContext`Q0$[1]^(-1) (
         108 + (54 + Complex[0, -18] 3^Rational[1, 2] + 
           Complex[0, -108] $CellContext`u) $CellContext`\[Eta]0$[2][
           1] + ((-18) (Complex[0, -1] + 3^Rational[1, 2]) + 
           Complex[0, 36] 
            3^Rational[1, 2] $CellContext`u) $CellContext`\[Eta]0$[3][1] + (9 + 
           Complex[0, -3] 3^Rational[1, 2] + 
           Complex[0, -18] $CellContext`u) $CellContext`\[Eta]0$[4][1] + (54 + 
           Complex[0, 18] 3^Rational[1, 2] + 
           Complex[0, -108] $CellContext`u) $CellContext`\[Eta]0$b[
           2][-1] + ((-18) (Complex[0, 1] + 3^Rational[1, 2]) + 
           Complex[0, 36] 
            3^Rational[1, 2] $CellContext`u) $CellContext`\[Eta]0$b[3][-1] + (
           9 + Complex[0, 3] 3^Rational[1, 2] + 
           Complex[0, -18] $CellContext`u) $CellContext`\[Eta]0$b[
           4][-1]) + $CellContext`Q0$[-1]^(-1) (-108 + (54 + 
           Complex[0, 18] 3^Rational[1, 2] + 
           Complex[0, 108] $CellContext`u) $CellContext`\[Eta]0$[2][
           1] + ((-18) (Complex[0, 1] + 3^Rational[1, 2]) + 
           Complex[0, -36] 
            3^Rational[1, 2] $CellContext`u) $CellContext`\[Eta]0$[3][1] + (9 + 
           Complex[0, 3] 3^Rational[1, 2] + 
           Complex[0, 18] $CellContext`u) $CellContext`\[Eta]0$[4][1] + (54 + 
           Complex[0, -18] 3^Rational[1, 2] + 
           Complex[0, 108] $CellContext`u) $CellContext`\[Eta]0$b[
           2][-1] + ((-18) (Complex[0, -1] + 3^Rational[1, 2]) + 
           Complex[0, -36] 
            3^Rational[1, 2] $CellContext`u) $CellContext`\[Eta]0$b[3][-1] + (
           9 + Complex[0, -3] 3^Rational[1, 2] + 
           Complex[0, 18] $CellContext`u) $CellContext`\[Eta]0$b[4][-1]), 
       0, $CellContext`Q0$[1]^(-2) (
         144 + (72 + Complex[0, -24] 3^Rational[1, 2] + 
           Complex[0, -144] $CellContext`u) $CellContext`\[Eta]0$[2][
           1] + ((-24) (Complex[0, -1] + 3^Rational[1, 2]) + 
           Complex[0, 48] 
            3^Rational[1, 2] $CellContext`u) $CellContext`\[Eta]0$[3][1] + (
           12 + Complex[0, -4] 3^Rational[1, 2] + 
           Complex[0, -24] $CellContext`u) $CellContext`\[Eta]0$[4][1] + (72 + 
           Complex[0, 24] 3^Rational[1, 2] + 
           Complex[0, -144] $CellContext`u) $CellContext`\[Eta]0$b[
           2][-1] + ((-24) (Complex[0, 1] + 3^Rational[1, 2]) + 
           Complex[0, 48] 
            3^Rational[1, 2] $CellContext`u) $CellContext`\[Eta]0$b[3][-1] + (
           12 + Complex[0, 4] 3^Rational[1, 2] + 
           Complex[0, -24] $CellContext`u) $CellContext`\[Eta]0$b[
           4][-1]) + $CellContext`Q0$[-1]^(-2) (-144 + (72 + 
           Complex[0, 24] 3^Rational[1, 2] + 
           Complex[0, 144] $CellContext`u) $CellContext`\[Eta]0$[2][
           1] + ((-24) (Complex[0, 1] + 3^Rational[1, 2]) + 
           Complex[0, -48] 
            3^Rational[1, 2] $CellContext`u) $CellContext`\[Eta]0$[3][1] + (
           12 + Complex[0, 4] 3^Rational[1, 2] + 
           Complex[0, 24] $CellContext`u) $CellContext`\[Eta]0$[4][1] + (72 + 
           Complex[0, -24] 3^Rational[1, 2] + 
           Complex[0, 144] $CellContext`u) $CellContext`\[Eta]0$b[
           2][-1] + ((-24) (Complex[0, -1] + 3^Rational[1, 2]) + 
           Complex[0, -48] 
            3^Rational[1, 2] $CellContext`u) $CellContext`\[Eta]0$b[3][-1] + (
           12 + Complex[0, -4] 3^Rational[1, 2] + 
           Complex[0, 24] $CellContext`u) $CellContext`\[Eta]0$b[
           4][-1]) + $CellContext`Q0$[-1]^(-1) (2592 + 
         2592 $CellContext`\[Zeta]$[1][0] + (
           Complex[0, -72] (Complex[0, -9] + 
             3^Rational[1, 2]) + $CellContext`u (Complex[0, -1296] + 
             Complex[0, -2592] $CellContext`\[Zeta]$[1][0]) + 
           Complex[0, -432] (Complex[0, -3] + 
             3^Rational[1, 2]) $CellContext`\[Zeta]$[1][
             0]) $CellContext`\[Eta]0$[2][1] + (
           144 (Complex[0, -3] + 3^Rational[1, 2]) + 
           432 (Complex[0, 1] + 3^Rational[1, 2]) $CellContext`\[Zeta]$[1][
             0] + $CellContext`u (72 (9 + Complex[0, 1] 3^Rational[1, 2]) + 
             Complex[0, 864] 
              3^Rational[1, 2] $CellContext`\[Zeta]$[1][
               0])) $CellContext`\[Eta]0$[3][1] + (
           72 (2 + Complex[0, 3] 3^Rational[1, 2]) + $CellContext`u (
             72 (Complex[0, 7] - 3 3^Rational[1, 2]) + 
             Complex[0, -432] $CellContext`\[Zeta]$[1][0]) + 
           Complex[0, -72] (Complex[0, -3] + 
             3^Rational[1, 2]) $CellContext`\[Zeta]$[1][
             0]) $CellContext`\[Eta]0$[4][1] + $CellContext`\[Eta]0$[1][1] (
           Complex[0, -1296] + ((-216) (Complex[0, -3] + 3^Rational[1, 2]) - 
             1296 $CellContext`u) $CellContext`\[Eta]0$[2][1] + (
             216 (1 + Complex[0, -1] 3^Rational[1, 2]) + 
             432 3^Rational[1, 2] $CellContext`u) $CellContext`\[Eta]0$[3][
             1] + ((-36) (Complex[0, -3] + 3^Rational[1, 2]) - 
             216 $CellContext`u) $CellContext`\[Eta]0$[4][1]) + ((-12) (
             Complex[0, 13] + 7 3^Rational[1, 2]) + 
           12 (9 + Complex[0, -17] 
              3^Rational[1, 2]) $CellContext`u) $CellContext`\[Eta]0$[5][
           1] + (36 + Complex[0, 12] 3^Rational[1, 2] + 
           Complex[0, 72] $CellContext`u) $CellContext`\[Eta]0$[6][1] + (
           216 (Complex[0, -3] + 3^Rational[1, 2]) + 
           1296 $CellContext`u) $CellContext`\[Eta]0$[1, 2][1] + (
           Complex[0, 216] (Complex[0, 1] + 3^Rational[1, 2]) - 432 
           3^Rational[1, 2] $CellContext`u) $CellContext`\[Eta]0$[1, 3][1] + (
           36 (Complex[0, -3] + 3^Rational[1, 2]) + 
           216 $CellContext`u) $CellContext`\[Eta]0$[1, 4][1] + (
           216 (Complex[0, -3] + 3^Rational[1, 2]) + 
           1296 $CellContext`u) $CellContext`\[Eta]0$[2][
           1] $CellContext`\[Eta]0$b[1][-1] + (
           Complex[0, 216] (Complex[0, 1] + 3^Rational[1, 2]) - 432 
           3^Rational[1, 2] $CellContext`u) $CellContext`\[Eta]0$[3][
           1] $CellContext`\[Eta]0$b[1][-1] + (
           36 (Complex[0, -3] + 3^Rational[1, 2]) + 
           216 $CellContext`u) $CellContext`\[Eta]0$[4][
           1] $CellContext`\[Eta]0$b[1][-1] + (
           Complex[0, 72] (Complex[0, 9] + 
             3^Rational[1, 2]) + $CellContext`u (Complex[0, -1296] + 
             Complex[0, -2592] $CellContext`\[Zeta]$[1][0]) + 
           Complex[0, 432] (Complex[0, 3] + 
             3^Rational[1, 2]) $CellContext`\[Zeta]$[1][
             0]) $CellContext`\[Eta]0$b[2][-1] + (
           216 (Complex[0, 3] + 3^Rational[1, 2]) - 
           1296 $CellContext`u) $CellContext`\[Eta]0$[1][
           1] $CellContext`\[Eta]0$b[2][-1] + (
           144 (Complex[0, 3] + 3^Rational[1, 2]) + 
           432 (Complex[0, -1] + 3^Rational[1, 2]) $CellContext`\[Zeta]$[1][
             0] + $CellContext`u (
             Complex[0, 72] (Complex[0, 9] + 3^Rational[1, 2]) + 
             Complex[0, 864] 
              3^Rational[1, 2] $CellContext`\[Zeta]$[1][
               0])) $CellContext`\[Eta]0$b[3][-1] + (
           Complex[0, -216] (Complex[0, -1] + 3^Rational[1, 2]) + 
           432 3^Rational[1, 2] $CellContext`u) $CellContext`\[Eta]0$[1][
           1] $CellContext`\[Eta]0$b[3][-1] + (
           72 (2 + Complex[0, -3] 3^Rational[1, 2]) + $CellContext`u (
             72 (Complex[0, 7] + 3 3^Rational[1, 2]) + 
             Complex[0, -432] $CellContext`\[Zeta]$[1][0]) + 
           Complex[0, 72] (Complex[0, 3] + 
             3^Rational[1, 2]) $CellContext`\[Zeta]$[1][
             0]) $CellContext`\[Eta]0$b[4][-1] + (
           36 (Complex[0, 3] + 3^Rational[1, 2]) - 
           216 $CellContext`u) $CellContext`\[Eta]0$[1][
           1] $CellContext`\[Eta]0$b[4][-1] + $CellContext`\[Eta]0$b[1][-1] (
           Complex[0, 1296] + ((-216) (Complex[0, 3] + 3^Rational[1, 2]) + 
             1296 $CellContext`u) $CellContext`\[Eta]0$b[2][-1] + (
             216 (1 + Complex[0, 1] 3^Rational[1, 2]) - 432 
             3^Rational[1, 2] $CellContext`u) $CellContext`\[Eta]0$b[
             3][-1] + ((-36) (Complex[0, 3] + 3^Rational[1, 2]) + 
             216 $CellContext`u) $CellContext`\[Eta]0$b[4][-1]) + (
           Complex[0, 156] - 84 
           3^Rational[1, 2] + (-108 + 
             Complex[0, -204] 
              3^Rational[1, 2]) $CellContext`u) $CellContext`\[Eta]0$b[
           5][-1] + (36 + Complex[0, -12] 3^Rational[1, 2] + 
           Complex[0, 72] $CellContext`u) $CellContext`\[Eta]0$b[6][-1] + (
           216 (Complex[0, 3] + 3^Rational[1, 2]) - 
           1296 $CellContext`u) $CellContext`\[Eta]0$b[1, 2][-1] + (
           Complex[0, -216] (Complex[0, -1] + 3^Rational[1, 2]) + 
           432 3^Rational[1, 2] $CellContext`u) $CellContext`\[Eta]0$b[
           1, 3][-1] + (36 (Complex[0, 3] + 3^Rational[1, 2]) - 
           216 $CellContext`u) $CellContext`\[Eta]0$b[
           1, 4][-1]) + $CellContext`Q0$[1]^(-1) (-2592 - 
         2592 $CellContext`\[Zeta]$[1][
          0] + (Complex[0, 72] (Complex[0, 9] + 
             3^Rational[1, 2]) + $CellContext`u (Complex[0, 1296] + 
             Complex[0, 2592] $CellContext`\[Zeta]$[1][0]) + 
           Complex[0, 432] (Complex[0, 3] + 
             3^Rational[1, 2]) $CellContext`\[Zeta]$[1][
             0]) $CellContext`\[Eta]0$[2][
           1] + ((-72) (Complex[0, 3] + 3^Rational[1, 2]) + 
           432 (Complex[0, -1] + 3^Rational[1, 2]) $CellContext`\[Zeta]$[1][
             0] + $CellContext`u (
             Complex[0, -72] (Complex[0, -9] + 3^Rational[1, 2]) + 
             Complex[0, -864] 
              3^Rational[1, 2] $CellContext`\[Zeta]$[1][
               0])) $CellContext`\[Eta]0$[3][1] + (
           360 + $CellContext`u (72 (Complex[0, -7] + 3 3^Rational[1, 2]) + 
             Complex[0, 432] $CellContext`\[Zeta]$[1][0]) + 
           Complex[0, 72] (Complex[0, 3] + 
             3^Rational[1, 2]) $CellContext`\[Zeta]$[1][
             0]) $CellContext`\[Eta]0$[4][1] + $CellContext`\[Eta]0$[1][1] (
           Complex[0, 1296] + (216 (Complex[0, 3] + 3^Rational[1, 2]) + 
             1296 $CellContext`u) $CellContext`\[Eta]0$[2][1] + (
             Complex[0, -216] (Complex[0, -1] + 3^Rational[1, 2]) - 432 
             3^Rational[1, 2] $CellContext`u) $CellContext`\[Eta]0$[3][1] + (
             36 (Complex[0, 3] + 3^Rational[1, 2]) + 
             216 $CellContext`u) $CellContext`\[Eta]0$[4][1]) + (
           Complex[0, 48] - 120 
           3^Rational[1, 2] + (-108 + 
             Complex[0, 204] 
              3^Rational[1, 2]) $CellContext`u) $CellContext`\[Eta]0$[5][
           1] + (36 + Complex[0, -12] 3^Rational[1, 2] + 
           Complex[0, -72] $CellContext`u) $CellContext`\[Eta]0$[6][
           1] + ((-216) (Complex[0, 3] + 3^Rational[1, 2]) - 
           1296 $CellContext`u) $CellContext`\[Eta]0$[1, 2][1] + (
           216 (1 + Complex[0, 1] 3^Rational[1, 2]) + 
           432 3^Rational[1, 2] $CellContext`u) $CellContext`\[Eta]0$[1, 3][
           1] + ((-36) (Complex[0, 3] + 3^Rational[1, 2]) - 
           216 $CellContext`u) $CellContext`\[Eta]0$[1, 4][
           1] + ((-216) (Complex[0, 3] + 3^Rational[1, 2]) - 
           1296 $CellContext`u) $CellContext`\[Eta]0$[2][
           1] $CellContext`\[Eta]0$b[1][-1] + (
           216 (1 + Complex[0, 1] 3^Rational[1, 2]) + 
           432 3^Rational[1, 2] $CellContext`u) $CellContext`\[Eta]0$[3][
           1] $CellContext`\[Eta]0$b[
           1][-1] + ((-36) (Complex[0, 3] + 3^Rational[1, 2]) - 
           216 $CellContext`u) $CellContext`\[Eta]0$[4][
           1] $CellContext`\[Eta]0$b[1][-1] + (
           Complex[0, -72] (Complex[0, -9] + 
             3^Rational[1, 2]) + $CellContext`u (Complex[0, 1296] + 
             Complex[0, 2592] $CellContext`\[Zeta]$[1][0]) + 
           Complex[0, -432] (Complex[0, -3] + 
             3^Rational[1, 2]) $CellContext`\[Zeta]$[1][
             0]) $CellContext`\[Eta]0$b[
           2][-1] + ((-216) (Complex[0, -3] + 3^Rational[1, 2]) + 
           1296 $CellContext`u) $CellContext`\[Eta]0$[1][
           1] $CellContext`\[Eta]0$b[
           2][-1] + ((-72) (Complex[0, -3] + 3^Rational[1, 2]) + 
           432 (Complex[0, 1] + 3^Rational[1, 2]) $CellContext`\[Zeta]$[1][
             0] + $CellContext`u (72 (9 + Complex[0, -1] 3^Rational[1, 2]) + 
             Complex[0, -864] 
              3^Rational[1, 2] $CellContext`\[Zeta]$[1][
               0])) $CellContext`\[Eta]0$b[3][-1] + (
           216 (1 + Complex[0, -1] 3^Rational[1, 2]) - 432 
           3^Rational[1, 2] $CellContext`u) $CellContext`\[Eta]0$[1][
           1] $CellContext`\[Eta]0$b[3][-1] + (
           360 + $CellContext`u ((-72) (Complex[0, 7] + 3 3^Rational[1, 2]) + 
             Complex[0, 432] $CellContext`\[Zeta]$[1][0]) + 
           Complex[0, -72] (Complex[0, -3] + 
             3^Rational[1, 2]) $CellContext`\[Zeta]$[1][
             0]) $CellContext`\[Eta]0$b[
           4][-1] + ((-36) (Complex[0, -3] + 3^Rational[1, 2]) + 
           216 $CellContext`u) $CellContext`\[Eta]0$[1][
           1] $CellContext`\[Eta]0$b[4][-1] + $CellContext`\[Eta]0$b[1][-1] (
           Complex[0, -1296] + (216 (Complex[0, -3] + 3^Rational[1, 2]) - 
             1296 $CellContext`u) $CellContext`\[Eta]0$b[2][-1] + (
             Complex[0, 216] (Complex[0, 1] + 3^Rational[1, 2]) + 
             432 3^Rational[1, 2] $CellContext`u) $CellContext`\[Eta]0$b[
             3][-1] + (36 (Complex[0, -3] + 3^Rational[1, 2]) - 
             216 $CellContext`u) $CellContext`\[Eta]0$b[4][-1]) + ((-24) (
             Complex[0, 2] + 5 3^Rational[1, 2]) + 
           12 (9 + Complex[0, 17] 
              3^Rational[1, 2]) $CellContext`u) $CellContext`\[Eta]0$b[
           5][-1] + (36 + Complex[0, 12] 3^Rational[1, 2] + 
           Complex[0, -72] $CellContext`u) $CellContext`\[Eta]0$b[
           6][-1] + ((-216) (Complex[0, -3] + 3^Rational[1, 2]) + 
           1296 $CellContext`u) $CellContext`\[Eta]0$b[1, 2][-1] + (
           216 (1 + Complex[0, -1] 3^Rational[1, 2]) - 432 
           3^Rational[1, 2] $CellContext`u) $CellContext`\[Eta]0$b[
           1, 3][-1] + ((-36) (Complex[0, -3] + 3^Rational[1, 2]) + 
           216 $CellContext`u) $CellContext`\[Eta]0$b[1, 4][-1]), 
       0, $CellContext`Q0$[1]^(-3) (
         192 + (96 + Complex[0, -32] 3^Rational[1, 2] + 
           Complex[0, -192] $CellContext`u) $CellContext`\[Eta]0$[2][
           1] + ((-32) (Complex[0, -1] + 3^Rational[1, 2]) + 
           Complex[0, 64] 
            3^Rational[1, 2] $CellContext`u) $CellContext`\[Eta]0$[3][1] + (
           16 + Complex[0, -16] 3^Rational[-1, 2] + 
           Complex[0, -32] $CellContext`u) $CellContext`\[Eta]0$[4][1] + (96 + 
           Complex[0, 32] 3^Rational[1, 2] + 
           Complex[0, -192] $CellContext`u) $CellContext`\[Eta]0$b[
           2][-1] + ((-32) (Complex[0, 1] + 3^Rational[1, 2]) + 
           Complex[0, 64] 
            3^Rational[1, 2] $CellContext`u) $CellContext`\[Eta]0$b[3][-1] + (
           16 + Complex[0, 16] 3^Rational[-1, 2] + 
           Complex[0, -32] $CellContext`u) $CellContext`\[Eta]0$b[
           4][-1]) + $CellContext`Q0$[-1]^(-3) (-192 + (96 + 
           Complex[0, 32] 3^Rational[1, 2] + 
           Complex[0, 192] $CellContext`u) $CellContext`\[Eta]0$[2][
           1] + ((-32) (Complex[0, 1] + 3^Rational[1, 2]) + 
           Complex[0, -64] 
            3^Rational[1, 2] $CellContext`u) $CellContext`\[Eta]0$[3][1] + (
           16 + Complex[0, 16] 3^Rational[-1, 2] + 
           Complex[0, 32] $CellContext`u) $CellContext`\[Eta]0$[4][1] + (96 + 
           Complex[0, -32] 3^Rational[1, 2] + 
           Complex[0, 192] $CellContext`u) $CellContext`\[Eta]0$b[
           2][-1] + ((-32) (Complex[0, -1] + 3^Rational[1, 2]) + 
           Complex[0, -64] 
            3^Rational[1, 2] $CellContext`u) $CellContext`\[Eta]0$b[3][-1] + (
           16 + Complex[0, -16] 3^Rational[-1, 2] + 
           Complex[0, 32] $CellContext`u) $CellContext`\[Eta]0$b[
           4][-1]) + $CellContext`Q0$[-1]^(-2) (3240 + 
         3456 $CellContext`\[Zeta]$[1][0] + (-756 + 
           Complex[0, -60] 
            3^Rational[1, 2] + $CellContext`u (Complex[0, -1512] + 
             Complex[0, -3456] $CellContext`\[Zeta]$[1][0]) + 
           Complex[0, -576] (Complex[0, -3] + 
             3^Rational[1, 2]) $CellContext`\[Zeta]$[1][
             0]) $CellContext`\[Eta]0$[2][1] + (Complex[0, -612] + 
           156 3^Rational[1, 2] + 
           576 (Complex[0, 1] + 3^Rational[1, 2]) $CellContext`\[Zeta]$[1][
             0] + $CellContext`u (864 + Complex[0, 24] 3^Rational[1, 2] + 
             Complex[0, 1152] 
              3^Rational[1, 2] $CellContext`\[Zeta]$[1][
               0])) $CellContext`\[Eta]0$[3][1] + (
           42 (5 + Complex[0, 7] 3^Rational[1, 2]) + $CellContext`u (
             Complex[0, 708] - 288 3^Rational[1, 2] + 
             Complex[0, -576] $CellContext`\[Zeta]$[1][0]) + 
           Complex[0, -96] (Complex[0, -3] + 
             3^Rational[1, 2]) $CellContext`\[Zeta]$[1][
             0]) $CellContext`\[Eta]0$[4][1] + $CellContext`\[Eta]0$[1][1] (
           Complex[0, -1728] + ((-288) (Complex[0, -3] + 3^Rational[1, 2]) - 
             1728 $CellContext`u) $CellContext`\[Eta]0$[2][1] + (
             288 (1 + Complex[0, -1] 3^Rational[1, 2]) + 
             576 3^Rational[1, 2] $CellContext`u) $CellContext`\[Eta]0$[3][
             1] + ((-48) (Complex[0, -3] + 3^Rational[1, 2]) - 
             288 $CellContext`u) $CellContext`\[Eta]0$[4][1]) + ((-16) (
             Complex[0, 13] + 7 3^Rational[1, 2]) + 
           16 (9 + Complex[0, -17] 
              3^Rational[1, 2]) $CellContext`u) $CellContext`\[Eta]0$[5][
           1] + (48 + Complex[0, 16] 3^Rational[1, 2] + 
           Complex[0, 96] $CellContext`u) $CellContext`\[Eta]0$[6][1] + (
           288 (Complex[0, -3] + 3^Rational[1, 2]) + 
           1728 $CellContext`u) $CellContext`\[Eta]0$[1, 2][1] + (
           Complex[0, 288] (Complex[0, 1] + 3^Rational[1, 2]) - 576 
           3^Rational[1, 2] $CellContext`u) $CellContext`\[Eta]0$[1, 3][1] + (
           48 (Complex[0, -3] + 3^Rational[1, 2]) + 
           288 $CellContext`u) $CellContext`\[Eta]0$[1, 4][1] + (
           288 (Complex[0, -3] + 3^Rational[1, 2]) + 
           1728 $CellContext`u) $CellContext`\[Eta]0$[2][
           1] $CellContext`\[Eta]0$b[1][-1] + (
           Complex[0, 288] (Complex[0, 1] + 3^Rational[1, 2]) - 576 
           3^Rational[1, 2] $CellContext`u) $CellContext`\[Eta]0$[3][
           1] $CellContext`\[Eta]0$b[1][-1] + (
           48 (Complex[0, -3] + 3^Rational[1, 2]) + 
           288 $CellContext`u) $CellContext`\[Eta]0$[4][
           1] $CellContext`\[Eta]0$b[1][-1] + (-756 + 
           Complex[0, 60] 
            3^Rational[1, 2] + $CellContext`u (Complex[0, -1512] + 
             Complex[0, -3456] $CellContext`\[Zeta]$[1][0]) + 
           Complex[0, 576] (Complex[0, 3] + 
             3^Rational[1, 2]) $CellContext`\[Zeta]$[1][
             0]) $CellContext`\[Eta]0$b[2][-1] + (
           288 (Complex[0, 3] + 3^Rational[1, 2]) - 
           1728 $CellContext`u) $CellContext`\[Eta]0$[1][
           1] $CellContext`\[Eta]0$b[2][-1] + (Complex[0, 612] + 
           156 3^Rational[1, 2] + 
           576 (Complex[0, -1] + 3^Rational[1, 2]) $CellContext`\[Zeta]$[1][
             0] + $CellContext`u (
             Complex[0, 24] (Complex[0, 36] + 3^Rational[1, 2]) + 
             Complex[0, 1152] 
              3^Rational[1, 2] $CellContext`\[Zeta]$[1][
               0])) $CellContext`\[Eta]0$b[3][-1] + (
           Complex[0, -288] (Complex[0, -1] + 3^Rational[1, 2]) + 
           576 3^Rational[1, 2] $CellContext`u) $CellContext`\[Eta]0$[1][
           1] $CellContext`\[Eta]0$b[3][-1] + (
           42 (5 + Complex[0, -7] 3^Rational[1, 2]) + $CellContext`u (
             Complex[0, 708] + 288 3^Rational[1, 2] + 
             Complex[0, -576] $CellContext`\[Zeta]$[1][0]) + 
           Complex[0, 96] (Complex[0, 3] + 
             3^Rational[1, 2]) $CellContext`\[Zeta]$[1][
             0]) $CellContext`\[Eta]0$b[4][-1] + (
           48 (Complex[0, 3] + 3^Rational[1, 2]) - 
           288 $CellContext`u) $CellContext`\[Eta]0$[1][
           1] $CellContext`\[Eta]0$b[4][-1] + $CellContext`\[Eta]0$b[1][-1] (
           Complex[0, 1728] + ((-288) (Complex[0, 3] + 3^Rational[1, 2]) + 
             1728 $CellContext`u) $CellContext`\[Eta]0$b[2][-1] + (
             288 (1 + Complex[0, 1] 3^Rational[1, 2]) - 576 
             3^Rational[1, 2] $CellContext`u) $CellContext`\[Eta]0$b[
             3][-1] + ((-48) (Complex[0, 3] + 3^Rational[1, 2]) + 
             288 $CellContext`u) $CellContext`\[Eta]0$b[4][-1]) + (
           Complex[0, 208] - 112 
           3^Rational[1, 2] + (-144 + 
             Complex[0, -272] 
              3^Rational[1, 2]) $CellContext`u) $CellContext`\[Eta]0$b[
           5][-1] + (48 + Complex[0, -16] 3^Rational[1, 2] + 
           Complex[0, 96] $CellContext`u) $CellContext`\[Eta]0$b[6][-1] + (
           288 (Complex[0, 3] + 3^Rational[1, 2]) - 
           1728 $CellContext`u) $CellContext`\[Eta]0$b[1, 2][-1] + (
           Complex[0, -288] (Complex[0, -1] + 3^Rational[1, 2]) + 
           576 3^Rational[1, 2] $CellContext`u) $CellContext`\[Eta]0$b[
           1, 3][-1] + (48 (Complex[0, 3] + 3^Rational[1, 2]) - 
           288 $CellContext`u) $CellContext`\[Eta]0$b[
           1, 4][-1]) + $CellContext`Q0$[1]^(-2) (-3240 - 
         3456 $CellContext`\[Zeta]$[1][
          0] + (-756 + 
           Complex[0, 60] 
            3^Rational[1, 2] + $CellContext`u (Complex[0, 1512] + 
             Complex[0, 3456] $CellContext`\[Zeta]$[1][0]) + 
           Complex[0, 576] (Complex[0, 3] + 
             3^Rational[1, 2]) $CellContext`\[Zeta]$[1][
             0]) $CellContext`\[Eta]0$[2][
           1] + ((-12) (Complex[0, 21] + 11 3^Rational[1, 2]) + 
           576 (Complex[0, -1] + 3^Rational[1, 2]) $CellContext`\[Zeta]$[1][
             0] + $CellContext`u (-864 + Complex[0, -24] 3^Rational[1, 2] + 
             Complex[0, -1152] 
              3^Rational[1, 2] $CellContext`\[Zeta]$[1][
               0])) $CellContext`\[Eta]0$[3][1] + (498 + 
           Complex[0, -6] 
            3^Rational[1, 2] + $CellContext`u (Complex[0, -708] + 
             288 3^Rational[1, 2] + 
             Complex[0, 576] $CellContext`\[Zeta]$[1][0]) + 
           Complex[0, 96] (Complex[0, 3] + 
             3^Rational[1, 2]) $CellContext`\[Zeta]$[1][
             0]) $CellContext`\[Eta]0$[4][1] + $CellContext`\[Eta]0$[1][1] (
           Complex[0, 1728] + (288 (Complex[0, 3] + 3^Rational[1, 2]) + 
             1728 $CellContext`u) $CellContext`\[Eta]0$[2][1] + (
             Complex[0, -288] (Complex[0, -1] + 3^Rational[1, 2]) - 576 
             3^Rational[1, 2] $CellContext`u) $CellContext`\[Eta]0$[3][1] + (
             48 (Complex[0, 3] + 3^Rational[1, 2]) + 
             288 $CellContext`u) $CellContext`\[Eta]0$[4][1]) + (
           Complex[0, 64] - 160 
           3^Rational[1, 2] + (-144 + 
             Complex[0, 272] 
              3^Rational[1, 2]) $CellContext`u) $CellContext`\[Eta]0$[5][
           1] + (48 + Complex[0, -16] 3^Rational[1, 2] + 
           Complex[0, -96] $CellContext`u) $CellContext`\[Eta]0$[6][
           1] + ((-288) (Complex[0, 3] + 3^Rational[1, 2]) - 
           1728 $CellContext`u) $CellContext`\[Eta]0$[1, 2][1] + (
           288 (1 + Complex[0, 1] 3^Rational[1, 2]) + 
           576 3^Rational[1, 2] $CellContext`u) $CellContext`\[Eta]0$[1, 3][
           1] + ((-48) (Complex[0, 3] + 3^Rational[1, 2]) - 
           288 $CellContext`u) $CellContext`\[Eta]0$[1, 4][
           1] + ((-288) (Complex[0, 3] + 3^Rational[1, 2]) - 
           1728 $CellContext`u) $CellContext`\[Eta]0$[2][
           1] $CellContext`\[Eta]0$b[1][-1] + (
           288 (1 + Complex[0, 1] 3^Rational[1, 2]) + 
           576 3^Rational[1, 2] $CellContext`u) $CellContext`\[Eta]0$[3][
           1] $CellContext`\[Eta]0$b[
           1][-1] + ((-48) (Complex[0, 3] + 3^Rational[1, 2]) - 
           288 $CellContext`u) $CellContext`\[Eta]0$[4][
           1] $CellContext`\[Eta]0$b[1][-1] + (-756 + 
           Complex[0, -60] 
            3^Rational[1, 2] + $CellContext`u (Complex[0, 1512] + 
             Complex[0, 3456] $CellContext`\[Zeta]$[1][0]) + 
           Complex[0, -576] (Complex[0, -3] + 
             3^Rational[1, 2]) $CellContext`\[Zeta]$[1][
             0]) $CellContext`\[Eta]0$b[
           2][-1] + ((-288) (Complex[0, -3] + 3^Rational[1, 2]) + 
           1728 $CellContext`u) $CellContext`\[Eta]0$[1][
           1] $CellContext`\[Eta]0$b[2][-1] + (Complex[0, 252] - 132 
           3^Rational[1, 2] + 
           576 (Complex[0, 1] + 3^Rational[1, 2]) $CellContext`\[Zeta]$[1][
             0] + $CellContext`u (864 + Complex[0, -24] 3^Rational[1, 2] + 
             Complex[0, -1152] 
              3^Rational[1, 2] $CellContext`\[Zeta]$[1][
               0])) $CellContext`\[Eta]0$b[3][-1] + (
           288 (1 + Complex[0, -1] 3^Rational[1, 2]) - 576 
           3^Rational[1, 2] $CellContext`u) $CellContext`\[Eta]0$[1][
           1] $CellContext`\[Eta]0$b[3][-1] + (498 + 
           Complex[0, 6] 
            3^Rational[
              1, 2] + $CellContext`u ((-12) (Complex[0, 59] + 
               24 3^Rational[1, 2]) + 
             Complex[0, 576] $CellContext`\[Zeta]$[1][0]) + 
           Complex[0, -96] (Complex[0, -3] + 
             3^Rational[1, 2]) $CellContext`\[Zeta]$[1][
             0]) $CellContext`\[Eta]0$b[
           4][-1] + ((-48) (Complex[0, -3] + 3^Rational[1, 2]) + 
           288 $CellContext`u) $CellContext`\[Eta]0$[1][
           1] $CellContext`\[Eta]0$b[4][-1] + $CellContext`\[Eta]0$b[1][-1] (
           Complex[0, -1728] + (288 (Complex[0, -3] + 3^Rational[1, 2]) - 
             1728 $CellContext`u) $CellContext`\[Eta]0$b[2][-1] + (
             Complex[0, 288] (Complex[0, 1] + 3^Rational[1, 2]) + 
             576 3^Rational[1, 2] $CellContext`u) $CellContext`\[Eta]0$b[
             3][-1] + (48 (Complex[0, -3] + 3^Rational[1, 2]) - 
             288 $CellContext`u) $CellContext`\[Eta]0$b[4][-1]) + ((-32) (
             Complex[0, 2] + 5 3^Rational[1, 2]) + 
           16 (9 + Complex[0, 17] 
              3^Rational[1, 2]) $CellContext`u) $CellContext`\[Eta]0$b[
           5][-1] + (48 + Complex[0, 16] 3^Rational[1, 2] + 
           Complex[0, -96] $CellContext`u) $CellContext`\[Eta]0$b[
           6][-1] + ((-288) (Complex[0, -3] + 3^Rational[1, 2]) + 
           1728 $CellContext`u) $CellContext`\[Eta]0$b[1, 2][-1] + (
           288 (1 + Complex[0, -1] 3^Rational[1, 2]) - 576 
           3^Rational[1, 2] $CellContext`u) $CellContext`\[Eta]0$b[
           1, 3][-1] + ((-48) (Complex[0, -3] + 3^Rational[1, 2]) + 
           288 $CellContext`u) $CellContext`\[Eta]0$b[
           1, 4][-1]) + $CellContext`Q0$[-1]^(-1) (-46656 - 
         72576 $CellContext`\[Zeta]$[1][0] - 
         31104 $CellContext`\[Zeta]$[1][0]^2 - 
         7776 $CellContext`\[Zeta]$[3][
          0] + (216 (-7 + Complex[0, -5] 3^Rational[1, 2]) + 
           432 (Complex[0, -9] + 
             2 3^Rational[1, 2]) $CellContext`u) $CellContext`\[Eta]0$[2][
            1]^2 + (108 (1 + Complex[0, -1] 3^Rational[1, 2]) + 
           216 3^Rational[1, 2] $CellContext`u) $CellContext`\[Eta]0$[3][
            1]^2 + (-1728 + Complex[0, -540] 3^Rational[1, 2] + 
           288 (-9 + Complex[0, -17] 3^Rational[1, 2]) $CellContext`\[Zeta]$[
             1][0] + 864 (3 + 
             Complex[0, 1] 3^Rational[1, 2]) $CellContext`\[Zeta]$[1][
              0]^2 + $CellContext`u (
             432 (Complex[0, -7] + 3 3^Rational[1, 2]) + 
             5184 (Complex[0, -2] + 3^Rational[1, 2]) $CellContext`\[Zeta]$[
               1][0] + Complex[0, 5184] $CellContext`\[Zeta]$[1][0]^2 + 
             Complex[0, 1296] $CellContext`\[Zeta]$[3][0]) + 
           216 (3 + Complex[0, 1] 3^Rational[1, 2]) $CellContext`\[Zeta]$[3][
             0]) $CellContext`\[Eta]0$[4][1] + $CellContext`\[Eta]0$[3][1] (
           72 (Complex[0, 67] - 8 3^Rational[1, 2]) + 
           1728 (Complex[0, 5] - 3 3^Rational[1, 2]) $CellContext`\[Zeta]$[1][
             0] - 5184 (Complex[0, 1] + 
            3^Rational[1, 2]) $CellContext`\[Zeta]$[1][0]^2 - 
           1296 (Complex[0, 1] + 3^Rational[1, 2]) $CellContext`\[Zeta]$[3][
            0] + $CellContext`u (
             Complex[0, 576] (Complex[0, 18] + 3^Rational[1, 2]) + 
             Complex[0, -5184] (Complex[0, -3] + 
               3^Rational[1, 2]) $CellContext`\[Zeta]$[1][0] + 
             Complex[0, -10368] 
              3^Rational[1, 2] $CellContext`\[Zeta]$[1][0]^2 + 
             Complex[0, -2592] 
              3^Rational[1, 2] $CellContext`\[Zeta]$[3][0]) + ((-36) (
               Complex[0, -3] + 3^Rational[1, 2]) - 
             216 $CellContext`u) $CellContext`\[Eta]0$[4][
             1]) + $CellContext`\[Eta]0$[1][1]^2 (
           7776 + (Complex[0, -1296] (Complex[0, -3] + 3^Rational[1, 2]) + 
             Complex[0, -7776] $CellContext`u) $CellContext`\[Eta]0$[2][1] + (
             1296 (Complex[0, 1] + 3^Rational[1, 2]) + 
             Complex[0, 2592] 
              3^Rational[1, 2] $CellContext`u) $CellContext`\[Eta]0$[3][1] + (
             Complex[0, -216] (Complex[0, -3] + 3^Rational[1, 2]) + 
             Complex[0, -1296] $CellContext`u) $CellContext`\[Eta]0$[4][
             1]) + $CellContext`\[Eta]0$[2][1] (
           72 (72 + Complex[0, 19] 3^Rational[1, 2]) + 
           3456 (6 + Complex[0, 1] 3^Rational[1, 2]) $CellContext`\[Zeta]$[1][
             0] + 5184 (3 + 
             Complex[0, 1] 3^Rational[1, 2]) $CellContext`\[Zeta]$[1][
              0]^2 + $CellContext`u (Complex[0, 10368] + 
             Complex[0, 41472] $CellContext`\[Zeta]$[1][0] + 
             Complex[0, 31104] $CellContext`\[Zeta]$[1][0]^2 + 
             Complex[0, 7776] $CellContext`\[Zeta]$[3][0]) + 
           1296 (3 + Complex[0, 1] 3^Rational[1, 2]) $CellContext`\[Zeta]$[3][
             0] + ((-288) (Complex[0, -3] + 3^Rational[1, 2]) - 
             1728 $CellContext`u) $CellContext`\[Eta]0$[3][1] + (
             144 (1 + Complex[0, -1] 3^Rational[1, 2]) + 
             288 3^Rational[1, 2] $CellContext`u) $CellContext`\[Eta]0$[4][
             1]) + (Complex[0, -2004] + 828 3^Rational[1, 2] + 
           288 (Complex[0, 13] + 7 3^Rational[1, 2]) $CellContext`\[Zeta]$[1][
             0] + $CellContext`u (216 (13 + Complex[0, 2] 3^Rational[1, 2]) + 
             288 (-9 + Complex[0, 17] 3^Rational[1, 2]) $CellContext`\[Zeta]$[
               1][0])) $CellContext`\[Eta]0$[5][1] + (
           8 (87 + Complex[0, 155] 3^Rational[1, 2]) + $CellContext`u (
             Complex[0, 2760] - 1368 3^Rational[1, 2] + 
             Complex[0, -1728] $CellContext`\[Zeta]$[1][0]) + 
           Complex[0, -288] (Complex[0, -3] + 
             3^Rational[1, 2]) $CellContext`\[Zeta]$[1][
             0]) $CellContext`\[Eta]0$[6][
           1] + ((-360) (Complex[0, 2] + 3^Rational[1, 2]) + 
           180 (3 + Complex[0, -5] 
              3^Rational[1, 2]) $CellContext`u) $CellContext`\[Eta]0$[7][
           1] + (42 (3 + Complex[0, 1] 3^Rational[1, 2]) + 
           Complex[0, 252] $CellContext`u) $CellContext`\[Eta]0$[8][
           1] + ((-1728) (Complex[0, -6] + 
             3^Rational[1, 2]) + $CellContext`u (-20736 - 
             31104 $CellContext`\[Zeta]$[1][0]) - 
           5184 (Complex[0, -3] + 3^Rational[1, 2]) $CellContext`\[Zeta]$[1][
            0]) $CellContext`\[Eta]0$[1, 2][1] + (
           864 (-5 + Complex[0, -3] 3^Rational[1, 2]) + 
           5184 (1 + Complex[0, -1] 3^Rational[1, 2]) $CellContext`\[Zeta]$[
             1][0] + $CellContext`u (2592 (Complex[0, -3] + 3^Rational[1, 2]) + 
             10368 3^Rational[1, 2] $CellContext`\[Zeta]$[1][
               0])) $CellContext`\[Eta]0$[1, 3][1] + (
           144 (Complex[0, -9] + 17 3^Rational[1, 2]) + $CellContext`u (
             2592 (2 + Complex[0, 1] 3^Rational[1, 2]) - 
             5184 $CellContext`\[Zeta]$[1][0]) - 
           864 (Complex[0, -3] + 3^Rational[1, 2]) $CellContext`\[Zeta]$[1][
            0]) $CellContext`\[Eta]0$[1, 4][1] + $CellContext`\[Eta]0$[1][1] (
           Complex[0, 36288] + 
           Complex[0, 31104] $CellContext`\[Zeta]$[1][0] + (
             1728 (Complex[0, -6] + 3^Rational[1, 2]) + 
             5184 (Complex[0, -3] + 3^Rational[1, 2]) $CellContext`\[Zeta]$[
               1][0] + $CellContext`u (20736 + 
               31104 $CellContext`\[Zeta]$[1][0])) $CellContext`\[Eta]0$[2][
             1] + (864 (5 + Complex[0, 3] 3^Rational[1, 2]) + 
             Complex[0, 5184] (Complex[0, 1] + 
               3^Rational[1, 2]) $CellContext`\[Zeta]$[1][
               0] + $CellContext`u ((-2592) (Complex[0, -3] + 
                 3^Rational[1, 2]) - 10368 
               3^Rational[1, 2] $CellContext`\[Zeta]$[1][
                0])) $CellContext`\[Eta]0$[3][1] + (
             144 (Complex[0, 9] - 17 3^Rational[1, 2]) + 
             864 (Complex[0, -3] + 3^Rational[1, 2]) $CellContext`\[Zeta]$[1][
               0] + $CellContext`u (
               Complex[0, -2592] (Complex[0, -2] + 3^Rational[1, 2]) + 
               5184 $CellContext`\[Zeta]$[1][0])) $CellContext`\[Eta]0$[4][
             1] + (144 (13 + Complex[0, -7] 3^Rational[1, 2]) + 
             144 (Complex[0, 9] + 
               17 3^Rational[1, 2]) $CellContext`u) $CellContext`\[Eta]0$[5][
             1] + ((-144) (Complex[0, -3] + 3^Rational[1, 2]) - 
             864 $CellContext`u) $CellContext`\[Eta]0$[6][1] + (
             2592 (3 + Complex[0, 1] 3^Rational[1, 2]) + 
             Complex[0, 15552] $CellContext`u) $CellContext`\[Eta]0$[1, 2][
             1] + ((-2592) (Complex[0, 1] + 3^Rational[1, 2]) + 
             Complex[0, -5184] 
              3^Rational[1, 2] $CellContext`u) $CellContext`\[Eta]0$[1, 3][
             1] + (432 (3 + Complex[0, 1] 3^Rational[1, 2]) + 
             Complex[0, 2592] $CellContext`u) $CellContext`\[Eta]0$[1, 4][
             1]) + (144 (-13 + Complex[0, 7] 3^Rational[1, 2]) - 
           144 (Complex[0, 9] + 
            17 3^Rational[1, 2]) $CellContext`u) $CellContext`\[Eta]0$[1, 5][
           1] + (144 (Complex[0, -3] + 3^Rational[1, 2]) + 
           864 $CellContext`u) $CellContext`\[Eta]0$[1, 6][1] + (
           72 (Complex[0, 15] + 19 3^Rational[1, 2]) + 
           432 (1 + Complex[0, 6] 
              3^Rational[1, 2]) $CellContext`u) $CellContext`\[Eta]0$[2, 3][
           1] + (-792 + Complex[0, -72] 3^Rational[1, 2] - 
           144 (Complex[0, 9] + 
            2 3^Rational[1, 2]) $CellContext`u) $CellContext`\[Eta]0$[2, 4][
           1] + (36 (Complex[0, -3] + 3^Rational[1, 2]) + 
           216 $CellContext`u) $CellContext`\[Eta]0$[3, 4][1] + (
           Complex[0, -2592] (Complex[0, -3] + 3^Rational[1, 2]) + 
           Complex[0, -15552] $CellContext`u) $CellContext`\[Eta]0$[1, 1, 2][
           1] + (2592 (Complex[0, 1] + 3^Rational[1, 2]) + 
           Complex[0, 5184] 
            3^Rational[1, 2] $CellContext`u) $CellContext`\[Eta]0$[1, 1, 3][
           1] + (Complex[0, -432] (Complex[0, -3] + 3^Rational[1, 2]) + 
           Complex[0, -2592] $CellContext`u) $CellContext`\[Eta]0$[1, 1, 4][
           1] + ((-1728) (Complex[0, -6] + 
             3^Rational[1, 2]) + $CellContext`u (-20736 - 
             31104 $CellContext`\[Zeta]$[1][0]) - 
           5184 (Complex[0, -3] + 3^Rational[1, 2]) $CellContext`\[Zeta]$[1][
            0]) $CellContext`\[Eta]0$[2][1] $CellContext`\[Eta]0$b[1][-1] + (
           864 (-5 + Complex[0, -3] 3^Rational[1, 2]) + 
           5184 (1 + Complex[0, -1] 3^Rational[1, 2]) $CellContext`\[Zeta]$[
             1][0] + $CellContext`u (2592 (Complex[0, -3] + 3^Rational[1, 2]) + 
             10368 3^Rational[1, 2] $CellContext`\[Zeta]$[1][
               0])) $CellContext`\[Eta]0$[3][1] $CellContext`\[Eta]0$b[
           1][-1] + (
           144 (Complex[0, -9] + 17 3^Rational[1, 2]) + $CellContext`u (
             2592 (2 + Complex[0, 1] 3^Rational[1, 2]) - 
             5184 $CellContext`\[Zeta]$[1][0]) - 
           864 (Complex[0, -3] + 3^Rational[1, 2]) $CellContext`\[Zeta]$[1][
            0]) $CellContext`\[Eta]0$[4][1] $CellContext`\[Eta]0$b[1][-1] + (
           144 (-13 + Complex[0, 7] 3^Rational[1, 2]) - 
           144 (Complex[0, 9] + 
            17 3^Rational[1, 2]) $CellContext`u) $CellContext`\[Eta]0$[5][
           1] $CellContext`\[Eta]0$b[1][-1] + (
           144 (Complex[0, -3] + 3^Rational[1, 2]) + 
           864 $CellContext`u) $CellContext`\[Eta]0$[6][
           1] $CellContext`\[Eta]0$b[1][-1] + (
           Complex[0, -2592] (Complex[0, -3] + 3^Rational[1, 2]) + 
           Complex[0, -15552] $CellContext`u) $CellContext`\[Eta]0$[1, 2][
           1] $CellContext`\[Eta]0$b[1][-1] + (
           2592 (Complex[0, 1] + 3^Rational[1, 2]) + 
           Complex[0, 5184] 
            3^Rational[1, 2] $CellContext`u) $CellContext`\[Eta]0$[1, 3][
           1] $CellContext`\[Eta]0$b[1][-1] + (
           Complex[0, -432] (Complex[0, -3] + 3^Rational[1, 2]) + 
           Complex[0, -2592] $CellContext`u) $CellContext`\[Eta]0$[1, 4][
           1] $CellContext`\[Eta]0$b[1][-1] + (
           Complex[0, -1296] (Complex[0, -3] + 3^Rational[1, 2]) + 
           Complex[0, -7776] $CellContext`u) $CellContext`\[Eta]0$[2][
           1] $CellContext`\[Eta]0$b[1][-1]^2 + (
           1296 (Complex[0, 1] + 3^Rational[1, 2]) + 
           Complex[0, 2592] 
            3^Rational[1, 2] $CellContext`u) $CellContext`\[Eta]0$[3][
           1] $CellContext`\[Eta]0$b[1][-1]^2 + (
           Complex[0, -216] (Complex[0, -3] + 3^Rational[1, 2]) + 
           Complex[0, -1296] $CellContext`u) $CellContext`\[Eta]0$[4][
           1] $CellContext`\[Eta]0$b[
            1][-1]^2 + ((-1728) (Complex[0, 6] + 3^Rational[1, 2]) - 
           5184 (Complex[0, 3] + 3^Rational[1, 2]) $CellContext`\[Zeta]$[1][
            0] + $CellContext`u (20736 + 
             31104 $CellContext`\[Zeta]$[1][0])) $CellContext`\[Eta]0$[1][
           1] $CellContext`\[Eta]0$b[2][-1] + (
           Complex[0, 1296] (Complex[0, 3] + 3^Rational[1, 2]) + 
           Complex[0, -7776] $CellContext`u) $CellContext`\[Eta]0$[1][
            1]^2 $CellContext`\[Eta]0$b[2][-1] - 
         1728 $CellContext`\[Eta]0$[2][1] $CellContext`\[Eta]0$b[
          2][-1] + (72 (Complex[0, -3] + 7 3^Rational[1, 2]) + 
           432 $CellContext`u) $CellContext`\[Eta]0$[3][
           1] $CellContext`\[Eta]0$b[2][-1] + (
           Complex[0, 144] (Complex[0, 1] + 3^Rational[1, 2]) - 288 
           3^Rational[1, 2] $CellContext`u) $CellContext`\[Eta]0$[4][
           1] $CellContext`\[Eta]0$b[2][-1] + (
           Complex[0, 216] (Complex[0, 7] + 5 3^Rational[1, 2]) - 
           432 (Complex[0, 9] + 
            2 3^Rational[1, 2]) $CellContext`u) $CellContext`\[Eta]0$b[
            2][-1]^2 + (Complex[0, 864] (Complex[0, 5] + 3 3^Rational[1, 2]) + 
           5184 (1 + Complex[0, 1] 3^Rational[1, 2]) $CellContext`\[Zeta]$[1][
             0] + $CellContext`u ((-2592) (Complex[0, 3] + 3^Rational[1, 2]) - 
             10368 3^Rational[1, 2] $CellContext`\[Zeta]$[1][
              0])) $CellContext`\[Eta]0$[1][1] $CellContext`\[Eta]0$b[
           3][-1] + (1296 (Complex[0, -1] + 3^Rational[1, 2]) + 
           Complex[0, 2592] 
            3^Rational[1, 2] $CellContext`u) $CellContext`\[Eta]0$[1][
            1]^2 $CellContext`\[Eta]0$b[3][-1] + (
           72 (Complex[0, 3] + 7 3^Rational[1, 2]) - 
           432 $CellContext`u) $CellContext`\[Eta]0$[2][
           1] $CellContext`\[Eta]0$b[3][-1] - 
         432 $CellContext`\[Eta]0$[3][1] $CellContext`\[Eta]0$b[
          3][-1] + (36 (Complex[0, -3] + 3^Rational[1, 2]) + 
           216 $CellContext`u) $CellContext`\[Eta]0$[4][
           1] $CellContext`\[Eta]0$b[3][-1] + (
           108 (1 + Complex[0, 1] 3^Rational[1, 2]) - 216 
           3^Rational[1, 2] $CellContext`u) $CellContext`\[Eta]0$b[
            3][-1]^2 + (-1728 + Complex[0, 540] 3^Rational[1, 2] + 
           288 (-9 + Complex[0, 17] 3^Rational[1, 2]) $CellContext`\[Zeta]$[
             1][0] + 864 (3 + 
             Complex[0, -1] 3^Rational[1, 2]) $CellContext`\[Zeta]$[1][
              0]^2 + $CellContext`u ((-432) (Complex[0, 7] + 
               3 3^Rational[1, 2]) - 
             5184 (Complex[0, 2] + 3^Rational[1, 2]) $CellContext`\[Zeta]$[1][
              0] + Complex[0, 5184] $CellContext`\[Zeta]$[1][0]^2 + 
             Complex[0, 1296] $CellContext`\[Zeta]$[3][0]) + 
           216 (3 + Complex[0, -1] 3^Rational[1, 2]) $CellContext`\[Zeta]$[3][
             0]) $CellContext`\[Eta]0$b[4][-1] + (
           144 (Complex[0, 9] + 17 3^Rational[1, 2]) - 
           864 (Complex[0, 3] + 3^Rational[1, 2]) $CellContext`\[Zeta]$[1][
            0] + $CellContext`u (
             Complex[0, 2592] (Complex[0, 2] + 3^Rational[1, 2]) + 
             5184 $CellContext`\[Zeta]$[1][0])) $CellContext`\[Eta]0$[1][
           1] $CellContext`\[Eta]0$b[4][-1] + (
           Complex[0, 216] (Complex[0, 3] + 3^Rational[1, 2]) + 
           Complex[0, -1296] $CellContext`u) $CellContext`\[Eta]0$[1][
            1]^2 $CellContext`\[Eta]0$b[4][-1] + (
           Complex[0, -144] (Complex[0, -1] + 3^Rational[1, 2]) + 
           288 3^Rational[1, 2] $CellContext`u) $CellContext`\[Eta]0$[2][
           1] $CellContext`\[Eta]0$b[4][-1] + (
           36 (Complex[0, 3] + 3^Rational[1, 2]) - 
           216 $CellContext`u) $CellContext`\[Eta]0$[3][
           1] $CellContext`\[Eta]0$b[
           4][-1] + $CellContext`\[Eta]0$b[1][-1]^2 (
           7776 + (Complex[0, 1296] (Complex[0, 3] + 3^Rational[1, 2]) + 
             Complex[0, -7776] $CellContext`u) $CellContext`\[Eta]0$b[
             2][-1] + (1296 (Complex[0, -1] + 3^Rational[1, 2]) + 
             Complex[0, 2592] 
              3^Rational[1, 2] $CellContext`u) $CellContext`\[Eta]0$b[
             3][-1] + (Complex[0, 216] (Complex[0, 3] + 3^Rational[1, 2]) + 
             Complex[0, -1296] $CellContext`u) $CellContext`\[Eta]0$b[
             4][-1]) + $CellContext`\[Eta]0$[1][1] $CellContext`\[Eta]0$b[
           1][-1] (-15552 + (2592 (3 + Complex[0, 1] 3^Rational[1, 2]) + 
             Complex[0, 15552] $CellContext`u) $CellContext`\[Eta]0$[2][
             1] + ((-2592) (Complex[0, 1] + 3^Rational[1, 2]) + 
             Complex[0, -5184] 
              3^Rational[1, 2] $CellContext`u) $CellContext`\[Eta]0$[3][1] + (
             432 (3 + Complex[0, 1] 3^Rational[1, 2]) + 
             Complex[0, 2592] $CellContext`u) $CellContext`\[Eta]0$[4][1] + (
             2592 (3 + Complex[0, -1] 3^Rational[1, 2]) + 
             Complex[0, 15552] $CellContext`u) $CellContext`\[Eta]0$b[
             2][-1] + ((-2592) (Complex[0, -1] + 3^Rational[1, 2]) + 
             Complex[0, -5184] 
              3^Rational[1, 2] $CellContext`u) $CellContext`\[Eta]0$b[
             3][-1] + (432 (3 + Complex[0, -1] 3^Rational[1, 2]) + 
             Complex[0, 2592] $CellContext`u) $CellContext`\[Eta]0$b[
             4][-1]) + $CellContext`\[Eta]0$b[
           3][-1] ((-72) (Complex[0, 67] + 8 3^Rational[1, 2]) - 
           1728 (Complex[0, 5] + 3 3^Rational[1, 2]) $CellContext`\[Zeta]$[1][
            0] - 5184 (Complex[0, -1] + 
            3^Rational[1, 2]) $CellContext`\[Zeta]$[1][0]^2 - 
           1296 (Complex[0, -1] + 3^Rational[1, 2]) $CellContext`\[Zeta]$[3][
            0] + $CellContext`u (576 (18 + Complex[0, 1] 3^Rational[1, 2]) + 
             5184 (3 + Complex[0, -1] 3^Rational[1, 2]) $CellContext`\[Zeta]$[
               1][0] + Complex[0, -10368] 
              3^Rational[1, 2] $CellContext`\[Zeta]$[1][0]^2 + 
             Complex[0, -2592] 
              3^Rational[1, 2] $CellContext`\[Zeta]$[3][0]) + ((-36) (
               Complex[0, 3] + 3^Rational[1, 2]) + 
             216 $CellContext`u) $CellContext`\[Eta]0$b[
             4][-1]) + $CellContext`\[Eta]0$b[2][-1] (
           72 (72 + Complex[0, -19] 3^Rational[1, 2]) + 
           3456 (6 + Complex[0, -1] 3^Rational[1, 2]) $CellContext`\[Zeta]$[
             1][0] + 5184 (3 + 
             Complex[0, -1] 3^Rational[1, 2]) $CellContext`\[Zeta]$[1][
              0]^2 + $CellContext`u (Complex[0, 10368] + 
             Complex[0, 41472] $CellContext`\[Zeta]$[1][0] + 
             Complex[0, 31104] $CellContext`\[Zeta]$[1][0]^2 + 
             Complex[0, 7776] $CellContext`\[Zeta]$[3][0]) + 
           1296 (3 + Complex[0, -1] 3^Rational[1, 2]) $CellContext`\[Zeta]$[
             3][0] + ((-288) (Complex[0, 3] + 3^Rational[1, 2]) + 
             1728 $CellContext`u) $CellContext`\[Eta]0$b[3][-1] + (
             144 (1 + Complex[0, 1] 3^Rational[1, 2]) - 288 
             3^Rational[1, 2] $CellContext`u) $CellContext`\[Eta]0$b[
             4][-1]) + (Complex[0, 2004] + 828 3^Rational[1, 2] + 
           288 (Complex[0, -13] + 7 3^Rational[1, 2]) $CellContext`\[Zeta]$[
             1][0] + $CellContext`u (-2808 + Complex[0, 432] 3^Rational[1, 2] + 
             288 (9 + Complex[0, 17] 3^Rational[1, 2]) $CellContext`\[Zeta]$[
               1][0])) $CellContext`\[Eta]0$b[5][-1] + (
           144 (-13 + Complex[0, -7] 3^Rational[1, 2]) + 
           144 (Complex[0, -9] + 
             17 3^Rational[1, 2]) $CellContext`u) $CellContext`\[Eta]0$[1][
           1] $CellContext`\[Eta]0$b[5][-1] + (
           8 (87 + Complex[0, -155] 3^Rational[1, 2]) + $CellContext`u (
             24 (Complex[0, 115] + 57 3^Rational[1, 2]) + 
             Complex[0, -1728] $CellContext`\[Zeta]$[1][0]) + 
           Complex[0, 288] (Complex[0, 3] + 
             3^Rational[1, 2]) $CellContext`\[Zeta]$[1][
             0]) $CellContext`\[Eta]0$b[6][-1] + (
           144 (Complex[0, 3] + 3^Rational[1, 2]) - 
           864 $CellContext`u) $CellContext`\[Eta]0$[1][
           1] $CellContext`\[Eta]0$b[
           6][-1] + ((-360) (Complex[0, -2] + 3^Rational[1, 2]) + (-540 + 
             Complex[0, -900] 
              3^Rational[1, 2]) $CellContext`u) $CellContext`\[Eta]0$b[
           7][-1] + (42 (3 + Complex[0, -1] 3^Rational[1, 2]) + 
           Complex[0, 252] $CellContext`u) $CellContext`\[Eta]0$b[
           8][-1] + ((-1728) (Complex[0, 6] + 3^Rational[1, 2]) - 
           5184 (Complex[0, 3] + 3^Rational[1, 2]) $CellContext`\[Zeta]$[1][
            0] + $CellContext`u (20736 + 
             31104 $CellContext`\[Zeta]$[1][0])) $CellContext`\[Eta]0$b[
           1, 2][-1] + (Complex[0, 2592] (Complex[0, 3] + 3^Rational[1, 2]) + 
           Complex[0, -15552] $CellContext`u) $CellContext`\[Eta]0$[1][
           1] $CellContext`\[Eta]0$b[1, 2][-1] + (
           Complex[0, 864] (Complex[0, 5] + 3 3^Rational[1, 2]) + 
           5184 (1 + Complex[0, 1] 3^Rational[1, 2]) $CellContext`\[Zeta]$[1][
             0] + $CellContext`u ((-2592) (Complex[0, 3] + 3^Rational[1, 2]) - 
             10368 3^Rational[1, 2] $CellContext`\[Zeta]$[1][
              0])) $CellContext`\[Eta]0$b[1, 3][-1] + (
           2592 (Complex[0, -1] + 3^Rational[1, 2]) + 
           Complex[0, 5184] 
            3^Rational[1, 2] $CellContext`u) $CellContext`\[Eta]0$[1][
           1] $CellContext`\[Eta]0$b[1, 3][-1] + (
           144 (Complex[0, 9] + 17 3^Rational[1, 2]) - 
           864 (Complex[0, 3] + 3^Rational[1, 2]) $CellContext`\[Zeta]$[1][
            0] + $CellContext`u (
             Complex[0, 2592] (Complex[0, 2] + 3^Rational[1, 2]) + 
             5184 $CellContext`\[Zeta]$[1][0])) $CellContext`\[Eta]0$b[
           1, 4][-1] + (Complex[0, 432] (Complex[0, 3] + 3^Rational[1, 2]) + 
           Complex[0, -2592] $CellContext`u) $CellContext`\[Eta]0$[1][
           1] $CellContext`\[Eta]0$b[1, 4][-1] + $CellContext`\[Eta]0$b[
           1][-1] (Complex[0, -36288] + 
           Complex[0, -31104] $CellContext`\[Zeta]$[1][0] + (
             1728 (Complex[0, 6] + 3^Rational[1, 2]) + $CellContext`u (-20736 - 
               31104 $CellContext`\[Zeta]$[1][0]) + 
             5184 (Complex[0, 3] + 3^Rational[1, 2]) $CellContext`\[Zeta]$[1][
               0]) $CellContext`\[Eta]0$b[2][-1] + (
             864 (5 + Complex[0, -3] 3^Rational[1, 2]) + 
             Complex[0, -5184] (Complex[0, -1] + 
               3^Rational[1, 2]) $CellContext`\[Zeta]$[1][
               0] + $CellContext`u (2592 (Complex[0, 3] + 3^Rational[1, 2]) + 
               10368 3^Rational[1, 2] $CellContext`\[Zeta]$[1][
                 0])) $CellContext`\[Eta]0$b[
             3][-1] + ((-144) (Complex[0, 9] + 
               17 3^Rational[1, 2]) + $CellContext`u (
               2592 (2 + Complex[0, -1] 3^Rational[1, 2]) - 
               5184 $CellContext`\[Zeta]$[1][0]) + 
             864 (Complex[0, 3] + 3^Rational[1, 2]) $CellContext`\[Zeta]$[1][
               0]) $CellContext`\[Eta]0$b[4][-1] + (
             144 (13 + Complex[0, 7] 3^Rational[1, 2]) + 
             144 (Complex[0, 9] - 17 
               3^Rational[1, 2]) $CellContext`u) $CellContext`\[Eta]0$b[
             5][-1] + ((-144) (Complex[0, 3] + 3^Rational[1, 2]) + 
             864 $CellContext`u) $CellContext`\[Eta]0$b[6][-1] + (
             2592 (3 + Complex[0, -1] 3^Rational[1, 2]) + 
             Complex[0, 15552] $CellContext`u) $CellContext`\[Eta]0$b[
             1, 2][-1] + ((-2592) (Complex[0, -1] + 3^Rational[1, 2]) + 
             Complex[0, -5184] 
              3^Rational[1, 2] $CellContext`u) $CellContext`\[Eta]0$b[
             1, 3][-1] + (432 (3 + Complex[0, -1] 3^Rational[1, 2]) + 
             Complex[0, 2592] $CellContext`u) $CellContext`\[Eta]0$b[
             1, 4][-1]) + (144 (-13 + Complex[0, -7] 3^Rational[1, 2]) + 
           144 (Complex[0, -9] + 
             17 3^Rational[1, 2]) $CellContext`u) $CellContext`\[Eta]0$b[
           1, 5][-1] + (144 (Complex[0, 3] + 3^Rational[1, 2]) - 
           864 $CellContext`u) $CellContext`\[Eta]0$b[1, 6][-1] + (
           72 (Complex[0, -15] + 19 3^Rational[1, 2]) + 
           432 (-1 + Complex[0, 6] 
              3^Rational[1, 2]) $CellContext`u) $CellContext`\[Eta]0$b[
           2, 3][-1] + (Complex[0, 72] (Complex[0, 11] + 3^Rational[1, 2]) + 
           144 (Complex[0, -9] + 
             2 3^Rational[1, 2]) $CellContext`u) $CellContext`\[Eta]0$b[
           2, 4][-1] + (36 (Complex[0, 3] + 3^Rational[1, 2]) - 
           216 $CellContext`u) $CellContext`\[Eta]0$b[3, 4][-1] + (
           Complex[0, 2592] (Complex[0, 3] + 3^Rational[1, 2]) + 
           Complex[0, -15552] $CellContext`u) $CellContext`\[Eta]0$b[
           1, 1, 2][-1] + (2592 (Complex[0, -1] + 3^Rational[1, 2]) + 
           Complex[0, 5184] 
            3^Rational[1, 2] $CellContext`u) $CellContext`\[Eta]0$b[
           1, 1, 3][-1] + (Complex[0, 432] (Complex[0, 3] + 3^Rational[1, 2]) + 
           Complex[0, -2592] $CellContext`u) $CellContext`\[Eta]0$b[
           1, 1, 4][-1]) + $CellContext`Q0$[1]^(-1) (46656 + 
         72576 $CellContext`\[Zeta]$[1][0] + 
         31104 $CellContext`\[Zeta]$[1][0]^2 + 
         7776 $CellContext`\[Zeta]$[3][0] + (
           Complex[0, 216] (Complex[0, 11] + 3^Rational[1, 2]) + 
           432 (Complex[0, 9] - 2 
             3^Rational[1, 2]) $CellContext`u) $CellContext`\[Eta]0$[2][
            1]^2 + (Complex[0, -108] (Complex[0, -1] + 3^Rational[1, 2]) - 
           216 3^Rational[1, 2] $CellContext`u) $CellContext`\[Eta]0$[3][
            1]^2 + (-1296 + Complex[0, -756] 3^Rational[1, 2] + 
           Complex[0, -288] (Complex[0, -27] + 
             3^Rational[1, 2]) $CellContext`\[Zeta]$[1][0] + 
           864 (3 + Complex[0, -1] 3^Rational[1, 2]) $CellContext`\[Zeta]$[1][
              0]^2 + $CellContext`u ((-432) (Complex[0, -7] + 
               3 3^Rational[1, 2]) - 
             5184 (Complex[0, -2] + 3^Rational[1, 2]) $CellContext`\[Zeta]$[
              1][0] + Complex[0, -5184] $CellContext`\[Zeta]$[1][0]^2 + 
             Complex[0, -1296] $CellContext`\[Zeta]$[3][0]) + 
           216 (3 + Complex[0, -1] 3^Rational[1, 2]) $CellContext`\[Zeta]$[3][
             0]) $CellContext`\[Eta]0$[4][
           1] + $CellContext`\[Eta]0$[1][
            1]^2 (-7776 + (
             Complex[0, 1296] (Complex[0, 3] + 3^Rational[1, 2]) + 
             Complex[0, 7776] $CellContext`u) $CellContext`\[Eta]0$[2][1] + (
             1296 (Complex[0, -1] + 3^Rational[1, 2]) + 
             Complex[0, -2592] 
              3^Rational[1, 2] $CellContext`u) $CellContext`\[Eta]0$[3][1] + (
             Complex[0, 216] (Complex[0, 3] + 3^Rational[1, 2]) + 
             Complex[0, 1296] $CellContext`u) $CellContext`\[Eta]0$[4][
             1]) + $CellContext`\[Eta]0$[3][1] (
           72 (Complex[0, 77] + 16 3^Rational[1, 2]) + 
           Complex[0, 6912] $CellContext`\[Zeta]$[1][0] - 
           5184 (Complex[0, -1] + 
            3^Rational[1, 2]) $CellContext`\[Zeta]$[1][0]^2 - 
           1296 (Complex[0, -1] + 3^Rational[1, 2]) $CellContext`\[Zeta]$[3][
            0] + $CellContext`u (576 (18 + Complex[0, -1] 3^Rational[1, 2]) + 
             5184 (3 + Complex[0, 1] 3^Rational[1, 2]) $CellContext`\[Zeta]$[
               1][0] + 
             Complex[0, 10368] 3^Rational[1, 2] $CellContext`\[Zeta]$[1][0]^2 + 
             Complex[0, 2592] 
              3^Rational[1, 2] $CellContext`\[Zeta]$[3][0]) + (
             36 (Complex[0, 3] + 3^Rational[1, 2]) + 
             216 $CellContext`u) $CellContext`\[Eta]0$[4][
             1]) + $CellContext`\[Eta]0$[2][1] (
           72 (72 + Complex[0, -19] 3^Rational[1, 2]) + 
           3456 (6 + Complex[0, -1] 3^Rational[1, 2]) $CellContext`\[Zeta]$[
             1][0] + 5184 (3 + 
             Complex[0, -1] 3^Rational[1, 2]) $CellContext`\[Zeta]$[1][
              0]^2 + $CellContext`u (Complex[0, -10368] + 
             Complex[0, -41472] $CellContext`\[Zeta]$[1][0] + 
             Complex[0, -31104] $CellContext`\[Zeta]$[1][0]^2 + 
             Complex[0, -7776] $CellContext`\[Zeta]$[3][0]) + 
           1296 (3 + Complex[0, -1] 3^Rational[1, 2]) $CellContext`\[Zeta]$[
             3][0] + (288 (Complex[0, 3] + 3^Rational[1, 2]) + 
             1728 $CellContext`u) $CellContext`\[Eta]0$[3][1] + (
             Complex[0, -144] (Complex[0, -1] + 3^Rational[1, 2]) - 288 
             3^Rational[1, 2] $CellContext`u) $CellContext`\[Eta]0$[4][
             1]) + ((-12) (Complex[0, 67] + 33 3^Rational[1, 2]) + 
           576 (Complex[0, -2] + 5 3^Rational[1, 2]) $CellContext`\[Zeta]$[1][
             0] + $CellContext`u (-2808 + Complex[0, -432] 3^Rational[1, 2] + 
             288 (9 + Complex[0, -17] 3^Rational[1, 2]) $CellContext`\[Zeta]$[
               1][0])) $CellContext`\[Eta]0$[5][1] + (
           16 (129 + Complex[0, 8] 3^Rational[1, 2]) + $CellContext`u (
             24 (Complex[0, -115] + 57 3^Rational[1, 2]) + 
             Complex[0, 1728] $CellContext`\[Zeta]$[1][0]) + 
           Complex[0, 288] (Complex[0, 3] + 
             3^Rational[1, 2]) $CellContext`\[Zeta]$[1][
             0]) $CellContext`\[Eta]0$[6][1] + (Complex[0, 180] - 540 
           3^Rational[1, 2] + (-540 + 
             Complex[0, 900] 
              3^Rational[1, 2]) $CellContext`u) $CellContext`\[Eta]0$[7][
           1] + (42 (3 + Complex[0, -1] 3^Rational[1, 2]) + 
           Complex[0, -252] $CellContext`u) $CellContext`\[Eta]0$[8][1] + (
           1728 (Complex[0, 6] + 3^Rational[1, 2]) + 
           5184 (Complex[0, 3] + 3^Rational[1, 2]) $CellContext`\[Zeta]$[1][
             0] + $CellContext`u (20736 + 
             31104 $CellContext`\[Zeta]$[1][0])) $CellContext`\[Eta]0$[1, 2][
           1] + (-3456 + 
           Complex[0, -5184] (Complex[0, -1] + 
             3^Rational[1, 2]) $CellContext`\[Zeta]$[1][
             0] + $CellContext`u ((-2592) (Complex[0, -3] + 3^Rational[1, 2]) - 
             10368 3^Rational[1, 2] $CellContext`\[Zeta]$[1][
              0])) $CellContext`\[Eta]0$[1, 3][1] + (
           144 (Complex[0, -27] + 3^Rational[1, 2]) + 
           864 (Complex[0, 3] + 3^Rational[1, 2]) $CellContext`\[Zeta]$[1][
             0] + $CellContext`u (
             Complex[0, -2592] (Complex[0, -2] + 3^Rational[1, 2]) + 
             5184 $CellContext`\[Zeta]$[1][0])) $CellContext`\[Eta]0$[1, 4][
           1] + $CellContext`\[Eta]0$[1][1] (Complex[0, -36288] + 
           Complex[0, -31104] $CellContext`\[Zeta]$[1][
             0] + ((-1728) (Complex[0, 6] + 
               3^Rational[1, 2]) + $CellContext`u (-20736 - 
               31104 $CellContext`\[Zeta]$[1][0]) - 
             5184 (Complex[0, 3] + 3^Rational[1, 2]) $CellContext`\[Zeta]$[1][
              0]) $CellContext`\[Eta]0$[2][1] + (3456 + 
             5184 (1 + Complex[0, 1] 3^Rational[1, 2]) $CellContext`\[Zeta]$[
               1][0] + $CellContext`u (
               2592 (Complex[0, -3] + 3^Rational[1, 2]) + 
               10368 3^Rational[1, 2] $CellContext`\[Zeta]$[1][
                 0])) $CellContext`\[Eta]0$[3][
             1] + ((-144) (Complex[0, -27] + 
               3^Rational[1, 2]) + $CellContext`u (
               2592 (2 + Complex[0, 1] 3^Rational[1, 2]) - 
               5184 $CellContext`\[Zeta]$[1][0]) - 
             864 (Complex[0, 3] + 3^Rational[1, 2]) $CellContext`\[Zeta]$[1][
              0]) $CellContext`\[Eta]0$[4][1] + (
             288 (-2 + Complex[0, -5] 3^Rational[1, 2]) - 
             144 (Complex[0, 9] + 
              17 3^Rational[1, 2]) $CellContext`u) $CellContext`\[Eta]0$[5][
             1] + (144 (Complex[0, 3] + 3^Rational[1, 2]) + 
             864 $CellContext`u) $CellContext`\[Eta]0$[6][1] + (
             2592 (3 + Complex[0, -1] 3^Rational[1, 2]) + 
             Complex[0, -15552] $CellContext`u) $CellContext`\[Eta]0$[1, 2][
             1] + ((-2592) (Complex[0, -1] + 3^Rational[1, 2]) + 
             Complex[0, 5184] 
              3^Rational[1, 2] $CellContext`u) $CellContext`\[Eta]0$[1, 3][
             1] + (432 (3 + Complex[0, -1] 3^Rational[1, 2]) + 
             Complex[0, -2592] $CellContext`u) $CellContext`\[Eta]0$[1, 4][1])
            + (288 (2 + Complex[0, 5] 3^Rational[1, 2]) + 
           144 (Complex[0, 9] + 
             17 3^Rational[1, 2]) $CellContext`u) $CellContext`\[Eta]0$[1, 5][
           1] + ((-144) (Complex[0, 3] + 3^Rational[1, 2]) - 
           864 $CellContext`u) $CellContext`\[Eta]0$[1, 6][1] + (
           72 (Complex[0, -21] + 17 3^Rational[1, 2]) + 
           432 (-1 + Complex[0, -6] 
              3^Rational[1, 2]) $CellContext`u) $CellContext`\[Eta]0$[2, 3][
           1] + (72 (-7 + Complex[0, 5] 3^Rational[1, 2]) + 
           144 (Complex[0, 9] + 
             2 3^Rational[1, 2]) $CellContext`u) $CellContext`\[Eta]0$[2, 4][
           1] + ((-36) (Complex[0, 3] + 3^Rational[1, 2]) - 
           216 $CellContext`u) $CellContext`\[Eta]0$[3, 4][1] + (
           Complex[0, 2592] (Complex[0, 3] + 3^Rational[1, 2]) + 
           Complex[0, 15552] $CellContext`u) $CellContext`\[Eta]0$[1, 1, 2][
           1] + (2592 (Complex[0, -1] + 3^Rational[1, 2]) + 
           Complex[0, -5184] 
            3^Rational[1, 2] $CellContext`u) $CellContext`\[Eta]0$[1, 1, 3][
           1] + (Complex[0, 432] (Complex[0, 3] + 3^Rational[1, 2]) + 
           Complex[0, 2592] $CellContext`u) $CellContext`\[Eta]0$[1, 1, 4][
           1] + (1728 (Complex[0, 6] + 3^Rational[1, 2]) + 
           5184 (Complex[0, 3] + 3^Rational[1, 2]) $CellContext`\[Zeta]$[1][
             0] + $CellContext`u (20736 + 
             31104 $CellContext`\[Zeta]$[1][0])) $CellContext`\[Eta]0$[2][
           1] $CellContext`\[Eta]0$b[1][-1] + (-3456 + 
           Complex[0, -5184] (Complex[0, -1] + 
             3^Rational[1, 2]) $CellContext`\[Zeta]$[1][
             0] + $CellContext`u ((-2592) (Complex[0, -3] + 3^Rational[1, 2]) - 
             10368 3^Rational[1, 2] $CellContext`\[Zeta]$[1][
              0])) $CellContext`\[Eta]0$[3][1] $CellContext`\[Eta]0$b[
           1][-1] + (144 (Complex[0, -27] + 3^Rational[1, 2]) + 
           864 (Complex[0, 3] + 3^Rational[1, 2]) $CellContext`\[Zeta]$[1][
             0] + $CellContext`u (
             Complex[0, -2592] (Complex[0, -2] + 3^Rational[1, 2]) + 
             5184 $CellContext`\[Zeta]$[1][0])) $CellContext`\[Eta]0$[4][
           1] $CellContext`\[Eta]0$b[1][-1] + (
           288 (2 + Complex[0, 5] 3^Rational[1, 2]) + 
           144 (Complex[0, 9] + 
             17 3^Rational[1, 2]) $CellContext`u) $CellContext`\[Eta]0$[5][
           1] $CellContext`\[Eta]0$b[
           1][-1] + ((-144) (Complex[0, 3] + 3^Rational[1, 2]) - 
           864 $CellContext`u) $CellContext`\[Eta]0$[6][
           1] $CellContext`\[Eta]0$b[1][-1] + (
           Complex[0, 2592] (Complex[0, 3] + 3^Rational[1, 2]) + 
           Complex[0, 15552] $CellContext`u) $CellContext`\[Eta]0$[1, 2][
           1] $CellContext`\[Eta]0$b[1][-1] + (
           2592 (Complex[0, -1] + 3^Rational[1, 2]) + 
           Complex[0, -5184] 
            3^Rational[1, 2] $CellContext`u) $CellContext`\[Eta]0$[1, 3][
           1] $CellContext`\[Eta]0$b[1][-1] + (
           Complex[0, 432] (Complex[0, 3] + 3^Rational[1, 2]) + 
           Complex[0, 2592] $CellContext`u) $CellContext`\[Eta]0$[1, 4][
           1] $CellContext`\[Eta]0$b[1][-1] + (
           Complex[0, 1296] (Complex[0, 3] + 3^Rational[1, 2]) + 
           Complex[0, 7776] $CellContext`u) $CellContext`\[Eta]0$[2][
           1] $CellContext`\[Eta]0$b[1][-1]^2 + (
           1296 (Complex[0, -1] + 3^Rational[1, 2]) + 
           Complex[0, -2592] 
            3^Rational[1, 2] $CellContext`u) $CellContext`\[Eta]0$[3][
           1] $CellContext`\[Eta]0$b[1][-1]^2 + (
           Complex[0, 216] (Complex[0, 3] + 3^Rational[1, 2]) + 
           Complex[0, 1296] $CellContext`u) $CellContext`\[Eta]0$[4][
           1] $CellContext`\[Eta]0$b[1][-1]^2 + (
           1728 (Complex[0, -6] + 3^Rational[1, 2]) + $CellContext`u (-20736 - 
             31104 $CellContext`\[Zeta]$[1][0]) + 
           5184 (Complex[0, -3] + 3^Rational[1, 2]) $CellContext`\[Zeta]$[1][
             0]) $CellContext`\[Eta]0$[1][1] $CellContext`\[Eta]0$b[2][-1] + (
           Complex[0, -1296] (Complex[0, -3] + 3^Rational[1, 2]) + 
           Complex[0, 7776] $CellContext`u) $CellContext`\[Eta]0$[1][
            1]^2 $CellContext`\[Eta]0$b[2][-1] + 
         1728 $CellContext`\[Eta]0$[2][1] $CellContext`\[Eta]0$b[
           2][-1] + ((-72) (Complex[0, 3] + 7 3^Rational[1, 2]) - 
           432 $CellContext`u) $CellContext`\[Eta]0$[3][
           1] $CellContext`\[Eta]0$b[2][-1] + (
           144 (1 + Complex[0, 1] 3^Rational[1, 2]) + 
           288 3^Rational[1, 2] $CellContext`u) $CellContext`\[Eta]0$[4][
           1] $CellContext`\[Eta]0$b[2][-1] + (
           Complex[0, -216] (Complex[0, -11] + 3^Rational[1, 2]) + 
           432 (Complex[0, 9] + 
             2 3^Rational[1, 2]) $CellContext`u) $CellContext`\[Eta]0$b[
            2][-1]^2 + (-3456 + 
           Complex[0, 5184] (Complex[0, 1] + 
             3^Rational[1, 2]) $CellContext`\[Zeta]$[1][0] + $CellContext`u (
             2592 (Complex[0, 3] + 3^Rational[1, 2]) + 
             10368 3^Rational[1, 2] $CellContext`\[Zeta]$[1][
               0])) $CellContext`\[Eta]0$[1][1] $CellContext`\[Eta]0$b[
           3][-1] + (1296 (Complex[0, 1] + 3^Rational[1, 2]) + 
           Complex[0, -2592] 
            3^Rational[1, 2] $CellContext`u) $CellContext`\[Eta]0$[1][
            1]^2 $CellContext`\[Eta]0$b[3][-1] + (
           72 (Complex[0, 3] - 7 3^Rational[1, 2]) + 
           432 $CellContext`u) $CellContext`\[Eta]0$[2][
           1] $CellContext`\[Eta]0$b[3][-1] + 
         432 $CellContext`\[Eta]0$[3][1] $CellContext`\[Eta]0$b[
           3][-1] + ((-36) (Complex[0, 3] + 3^Rational[1, 2]) - 
           216 $CellContext`u) $CellContext`\[Eta]0$[4][
           1] $CellContext`\[Eta]0$b[3][-1] + (
           Complex[0, 108] (Complex[0, 1] + 3^Rational[1, 2]) + 
           216 3^Rational[1, 2] $CellContext`u) $CellContext`\[Eta]0$b[
            3][-1]^2 + (-1296 + Complex[0, 756] 3^Rational[1, 2] + 
           Complex[0, 288] (Complex[0, 27] + 
             3^Rational[1, 2]) $CellContext`\[Zeta]$[1][0] + 
           864 (3 + Complex[0, 1] 3^Rational[1, 2]) $CellContext`\[Zeta]$[1][
              0]^2 + $CellContext`u (432 (Complex[0, 7] + 3 3^Rational[1, 2]) + 
             5184 (Complex[0, 2] + 3^Rational[1, 2]) $CellContext`\[Zeta]$[1][
               0] + Complex[0, -5184] $CellContext`\[Zeta]$[1][0]^2 + 
             Complex[0, -1296] $CellContext`\[Zeta]$[3][0]) + 
           216 (3 + Complex[0, 1] 3^Rational[1, 2]) $CellContext`\[Zeta]$[3][
             0]) $CellContext`\[Eta]0$b[4][-1] + (
           144 (Complex[0, 27] + 3^Rational[1, 2]) + $CellContext`u (
             2592 (2 + Complex[0, -1] 3^Rational[1, 2]) - 
             5184 $CellContext`\[Zeta]$[1][0]) + 
           864 (Complex[0, -3] + 3^Rational[1, 2]) $CellContext`\[Zeta]$[1][
             0]) $CellContext`\[Eta]0$[1][1] $CellContext`\[Eta]0$b[4][-1] + (
           Complex[0, -216] (Complex[0, -3] + 3^Rational[1, 2]) + 
           Complex[0, 1296] $CellContext`u) $CellContext`\[Eta]0$[1][
            1]^2 $CellContext`\[Eta]0$b[4][-1] + (
           144 (1 + Complex[0, -1] 3^Rational[1, 2]) - 288 
           3^Rational[1, 2] $CellContext`u) $CellContext`\[Eta]0$[2][
           1] $CellContext`\[Eta]0$b[
           4][-1] + ((-36) (Complex[0, -3] + 3^Rational[1, 2]) + 
           216 $CellContext`u) $CellContext`\[Eta]0$[3][
           1] $CellContext`\[Eta]0$b[4][-1] + $CellContext`\[Eta]0$b[3][-1] (
           72 (Complex[0, -77] + 16 3^Rational[1, 2]) + 
           Complex[0, -6912] $CellContext`\[Zeta]$[1][0] - 
           5184 (Complex[0, 1] + 
            3^Rational[1, 2]) $CellContext`\[Zeta]$[1][0]^2 - 
           1296 (Complex[0, 1] + 3^Rational[1, 2]) $CellContext`\[Zeta]$[3][
            0] + $CellContext`u (
             Complex[0, -576] (Complex[0, -18] + 3^Rational[1, 2]) + 
             Complex[0, 5184] (Complex[0, 3] + 
               3^Rational[1, 2]) $CellContext`\[Zeta]$[1][0] + 
             Complex[0, 10368] 3^Rational[1, 2] $CellContext`\[Zeta]$[1][0]^2 + 
             Complex[0, 2592] 
              3^Rational[1, 2] $CellContext`\[Zeta]$[3][0]) + (
             36 (Complex[0, -3] + 3^Rational[1, 2]) - 
             216 $CellContext`u) $CellContext`\[Eta]0$b[
             4][-1]) + $CellContext`\[Eta]0$b[
            1][-1]^2 (-7776 + (
             Complex[0, -1296] (Complex[0, -3] + 3^Rational[1, 2]) + 
             Complex[0, 7776] $CellContext`u) $CellContext`\[Eta]0$b[
             2][-1] + (1296 (Complex[0, 1] + 3^Rational[1, 2]) + 
             Complex[0, -2592] 
              3^Rational[1, 2] $CellContext`u) $CellContext`\[Eta]0$b[
             3][-1] + (Complex[0, -216] (Complex[0, -3] + 3^Rational[1, 2]) + 
             Complex[0, 1296] $CellContext`u) $CellContext`\[Eta]0$b[
             4][-1]) + $CellContext`\[Eta]0$[1][1] $CellContext`\[Eta]0$b[
           1][-1] (15552 + (2592 (3 + Complex[0, -1] 3^Rational[1, 2]) + 
             Complex[0, -15552] $CellContext`u) $CellContext`\[Eta]0$[2][
             1] + ((-2592) (Complex[0, -1] + 3^Rational[1, 2]) + 
             Complex[0, 5184] 
              3^Rational[1, 2] $CellContext`u) $CellContext`\[Eta]0$[3][1] + (
             432 (3 + Complex[0, -1] 3^Rational[1, 2]) + 
             Complex[0, -2592] $CellContext`u) $CellContext`\[Eta]0$[4][1] + (
             2592 (3 + Complex[0, 1] 3^Rational[1, 2]) + 
             Complex[0, -15552] $CellContext`u) $CellContext`\[Eta]0$b[
             2][-1] + ((-2592) (Complex[0, 1] + 3^Rational[1, 2]) + 
             Complex[0, 5184] 
              3^Rational[1, 2] $CellContext`u) $CellContext`\[Eta]0$b[
             3][-1] + (432 (3 + Complex[0, 1] 3^Rational[1, 2]) + 
             Complex[0, -2592] $CellContext`u) $CellContext`\[Eta]0$b[
             4][-1]) + $CellContext`\[Eta]0$b[2][-1] (
           72 (72 + Complex[0, 19] 3^Rational[1, 2]) + 
           3456 (6 + Complex[0, 1] 3^Rational[1, 2]) $CellContext`\[Zeta]$[1][
             0] + 5184 (3 + 
             Complex[0, 1] 3^Rational[1, 2]) $CellContext`\[Zeta]$[1][
              0]^2 + $CellContext`u (Complex[0, -10368] + 
             Complex[0, -41472] $CellContext`\[Zeta]$[1][0] + 
             Complex[0, -31104] $CellContext`\[Zeta]$[1][0]^2 + 
             Complex[0, -7776] $CellContext`\[Zeta]$[3][0]) + 
           1296 (3 + Complex[0, 1] 3^Rational[1, 2]) $CellContext`\[Zeta]$[3][
             0] + (288 (Complex[0, -3] + 3^Rational[1, 2]) - 
             1728 $CellContext`u) $CellContext`\[Eta]0$b[3][-1] + (
             Complex[0, 144] (Complex[0, 1] + 3^Rational[1, 2]) + 
             288 3^Rational[1, 2] $CellContext`u) $CellContext`\[Eta]0$b[
             4][-1]) + (Complex[0, 804] - 396 3^Rational[1, 2] + 
           576 (Complex[0, 2] + 5 3^Rational[1, 2]) $CellContext`\[Zeta]$[1][
             0] + $CellContext`u (216 (13 + Complex[0, -2] 3^Rational[1, 2]) + 
             288 (-9 + Complex[0, -17] 
                3^Rational[1, 2]) $CellContext`\[Zeta]$[1][
               0])) $CellContext`\[Eta]0$b[5][-1] + (
           288 (2 + Complex[0, -5] 3^Rational[1, 2]) + 
           144 (Complex[0, 9] - 17 
             3^Rational[1, 2]) $CellContext`u) $CellContext`\[Eta]0$[1][
           1] $CellContext`\[Eta]0$b[5][-1] + (
           16 (129 + Complex[0, -8] 
              3^Rational[1, 2]) + $CellContext`u ((-24) (Complex[0, 115] + 
               57 3^Rational[1, 2]) + 
             Complex[0, 1728] $CellContext`\[Zeta]$[1][0]) + 
           Complex[0, -288] (Complex[0, -3] + 
             3^Rational[1, 2]) $CellContext`\[Zeta]$[1][
             0]) $CellContext`\[Eta]0$b[
           6][-1] + ((-144) (Complex[0, -3] + 3^Rational[1, 2]) + 
           864 $CellContext`u) $CellContext`\[Eta]0$[1][
           1] $CellContext`\[Eta]0$b[
           6][-1] + ((-180) (Complex[0, 1] + 3 3^Rational[1, 2]) + 
           180 (3 + Complex[0, 5] 
              3^Rational[1, 2]) $CellContext`u) $CellContext`\[Eta]0$b[
           7][-1] + (42 (3 + Complex[0, 1] 3^Rational[1, 2]) + 
           Complex[0, -252] $CellContext`u) $CellContext`\[Eta]0$b[8][-1] + (
           1728 (Complex[0, -6] + 3^Rational[1, 2]) + $CellContext`u (-20736 - 
             31104 $CellContext`\[Zeta]$[1][0]) + 
           5184 (Complex[0, -3] + 3^Rational[1, 2]) $CellContext`\[Zeta]$[1][
             0]) $CellContext`\[Eta]0$b[1, 2][-1] + (
           Complex[0, -2592] (Complex[0, -3] + 3^Rational[1, 2]) + 
           Complex[0, 15552] $CellContext`u) $CellContext`\[Eta]0$[1][
           1] $CellContext`\[Eta]0$b[1, 2][-1] + (-3456 + 
           Complex[0, 5184] (Complex[0, 1] + 
             3^Rational[1, 2]) $CellContext`\[Zeta]$[1][0] + $CellContext`u (
             2592 (Complex[0, 3] + 3^Rational[1, 2]) + 
             10368 3^Rational[1, 2] $CellContext`\[Zeta]$[1][
               0])) $CellContext`\[Eta]0$b[1, 3][-1] + (
           2592 (Complex[0, 1] + 3^Rational[1, 2]) + 
           Complex[0, -5184] 
            3^Rational[1, 2] $CellContext`u) $CellContext`\[Eta]0$[1][
           1] $CellContext`\[Eta]0$b[1, 3][-1] + (
           144 (Complex[0, 27] + 3^Rational[1, 2]) + $CellContext`u (
             2592 (2 + Complex[0, -1] 3^Rational[1, 2]) - 
             5184 $CellContext`\[Zeta]$[1][0]) + 
           864 (Complex[0, -3] + 3^Rational[1, 2]) $CellContext`\[Zeta]$[1][
             0]) $CellContext`\[Eta]0$b[1, 4][-1] + (
           Complex[0, -432] (Complex[0, -3] + 3^Rational[1, 2]) + 
           Complex[0, 2592] $CellContext`u) $CellContext`\[Eta]0$[1][
           1] $CellContext`\[Eta]0$b[1, 4][-1] + $CellContext`\[Eta]0$b[
           1][-1] (Complex[0, 36288] + 
           Complex[0, 31104] $CellContext`\[Zeta]$[1][
             0] + ((-1728) (Complex[0, -6] + 3^Rational[1, 2]) - 
             5184 (Complex[0, -3] + 3^Rational[1, 2]) $CellContext`\[Zeta]$[
              1][0] + $CellContext`u (20736 + 
               31104 $CellContext`\[Zeta]$[1][0])) $CellContext`\[Eta]0$b[
             2][-1] + (3456 + 
             5184 (1 + Complex[0, -1] 3^Rational[1, 2]) $CellContext`\[Zeta]$[
               1][0] + $CellContext`u ((-2592) (Complex[0, 3] + 
                 3^Rational[1, 2]) - 10368 
               3^Rational[1, 2] $CellContext`\[Zeta]$[1][
                0])) $CellContext`\[Eta]0$b[
             3][-1] + ((-144) (Complex[0, 27] + 3^Rational[1, 2]) - 
             864 (Complex[0, -3] + 3^Rational[1, 2]) $CellContext`\[Zeta]$[1][
              0] + $CellContext`u (
               Complex[0, 2592] (Complex[0, 2] + 3^Rational[1, 2]) + 
               5184 $CellContext`\[Zeta]$[1][0])) $CellContext`\[Eta]0$b[
             4][-1] + (288 (-2 + Complex[0, 5] 3^Rational[1, 2]) + 
             144 (Complex[0, -9] + 
               17 3^Rational[1, 2]) $CellContext`u) $CellContext`\[Eta]0$b[
             5][-1] + (144 (Complex[0, -3] + 3^Rational[1, 2]) - 
             864 $CellContext`u) $CellContext`\[Eta]0$b[6][-1] + (
             2592 (3 + Complex[0, 1] 3^Rational[1, 2]) + 
             Complex[0, -15552] $CellContext`u) $CellContext`\[Eta]0$b[
             1, 2][-1] + ((-2592) (Complex[0, 1] + 3^Rational[1, 2]) + 
             Complex[0, 5184] 
              3^Rational[1, 2] $CellContext`u) $CellContext`\[Eta]0$b[
             1, 3][-1] + (432 (3 + Complex[0, 1] 3^Rational[1, 2]) + 
             Complex[0, -2592] $CellContext`u) $CellContext`\[Eta]0$b[
             1, 4][-1]) + (288 (2 + Complex[0, -5] 3^Rational[1, 2]) + 
           144 (Complex[0, 9] - 17 
             3^Rational[1, 2]) $CellContext`u) $CellContext`\[Eta]0$b[
           1, 5][-1] + ((-144) (Complex[0, -3] + 3^Rational[1, 2]) + 
           864 $CellContext`u) $CellContext`\[Eta]0$b[1, 6][-1] + (
           72 (Complex[0, 21] + 17 3^Rational[1, 2]) + 
           432 (1 + Complex[0, -6] 
              3^Rational[1, 2]) $CellContext`u) $CellContext`\[Eta]0$b[
           2, 3][-1] + (72 (-7 + Complex[0, -5] 3^Rational[1, 2]) + 
           144 (Complex[0, 9] - 2 
             3^Rational[1, 2]) $CellContext`u) $CellContext`\[Eta]0$b[
           2, 4][-1] + ((-36) (Complex[0, -3] + 3^Rational[1, 2]) + 
           216 $CellContext`u) $CellContext`\[Eta]0$b[3, 4][-1] + (
           Complex[0, -2592] (Complex[0, -3] + 3^Rational[1, 2]) + 
           Complex[0, 15552] $CellContext`u) $CellContext`\[Eta]0$b[
           1, 1, 2][-1] + (2592 (Complex[0, 1] + 3^Rational[1, 2]) + 
           Complex[0, -5184] 
            3^Rational[1, 2] $CellContext`u) $CellContext`\[Eta]0$b[
           1, 1, 3][-1] + (
           Complex[0, -432] (Complex[0, -3] + 3^Rational[1, 2]) + 
           Complex[0, 2592] $CellContext`u) $CellContext`\[Eta]0$b[
           1, 1, 4][-1]), 
       0, $CellContext`Q0$[1]^(-4) (
         256 + (128 + Complex[0, -128] 3^Rational[-1, 2] + 
           Complex[0, -256] $CellContext`u) $CellContext`\[Eta]0$[2][1] + (
           Rational[-128, 3] (Complex[0, -1] + 3^Rational[1, 2]) + 
           Complex[0, 256] 
            3^Rational[-1, 2] $CellContext`u) $CellContext`\[Eta]0$[3][1] + (
           Rational[64, 9] (3 + Complex[0, -1] 3^Rational[1, 2]) + 
           Complex[0, 
              Rational[-128, 3]] $CellContext`u) $CellContext`\[Eta]0$[4][
           1] + (128 + Complex[0, 128] 3^Rational[-1, 2] + 
           Complex[0, -256] $CellContext`u) $CellContext`\[Eta]0$b[2][-1] + (
           Rational[-128, 3] (Complex[0, 1] + 3^Rational[1, 2]) + 
           Complex[0, 256] 
            3^Rational[-1, 2] $CellContext`u) $CellContext`\[Eta]0$b[
           3][-1] + (Rational[64, 9] (3 + Complex[0, 1] 3^Rational[1, 2]) + 
           Complex[0, 
              Rational[-128, 3]] $CellContext`u) $CellContext`\[Eta]0$b[
           4][-1]) + $CellContext`Q0$[-1]^(-4) (-256 + (128 + 
           Complex[0, 128] 3^Rational[-1, 2] + 
           Complex[0, 256] $CellContext`u) $CellContext`\[Eta]0$[2][1] + (
           Rational[-128, 3] (Complex[0, 1] + 3^Rational[1, 2]) + 
           Complex[0, -256] 
            3^Rational[-1, 2] $CellContext`u) $CellContext`\[Eta]0$[3][1] + (
           Rational[64, 9] (3 + Complex[0, 1] 3^Rational[1, 2]) + Complex[0, 
              Rational[128, 3]] $CellContext`u) $CellContext`\[Eta]0$[4][
           1] + (128 + Complex[0, -128] 3^Rational[-1, 2] + 
           Complex[0, 256] $CellContext`u) $CellContext`\[Eta]0$b[2][-1] + (
           Rational[-128, 3] (Complex[0, -1] + 3^Rational[1, 2]) + 
           Complex[0, -256] 
            3^Rational[-1, 2] $CellContext`u) $CellContext`\[Eta]0$b[
           3][-1] + (Rational[64, 9] (3 + Complex[0, -1] 3^Rational[1, 2]) + 
           Complex[0, 
              Rational[128, 3]] $CellContext`u) $CellContext`\[Eta]0$b[
           4][-1]) + $CellContext`Q0$[-1]^(-3) (4032 + 
         4608 $CellContext`\[Zeta]$[1][0] + (-864 + 
           Complex[0, -32] 
            3^Rational[1, 2] + $CellContext`u (Complex[0, -1728] + 
             Complex[0, -4608] $CellContext`\[Zeta]$[1][0]) + 
           Complex[0, -768] (Complex[0, -3] + 
             3^Rational[1, 2]) $CellContext`\[Zeta]$[1][
             0]) $CellContext`\[Eta]0$[2][1] + (
           32 (Complex[0, -27] + 5 3^Rational[1, 2]) + 
           768 (Complex[0, 1] + 3^Rational[1, 2]) $CellContext`\[Zeta]$[1][
             0] + $CellContext`u (64 (18 + Complex[0, -1] 3^Rational[1, 2]) + 
             Complex[0, 1536] 
              3^Rational[1, 2] $CellContext`\[Zeta]$[1][
               0])) $CellContext`\[Eta]0$[3][1] + (304 + 
           Complex[0, 400] 
            3^Rational[1, 2] + $CellContext`u (Complex[0, 992] - 384 
             3^Rational[1, 2] + Complex[0, -768] $CellContext`\[Zeta]$[1][0]) + 
           Complex[0, -128] (Complex[0, -3] + 
             3^Rational[1, 2]) $CellContext`\[Zeta]$[1][
             0]) $CellContext`\[Eta]0$[4][1] + $CellContext`\[Eta]0$[1][1] (
           Complex[0, -2304] + ((-384) (Complex[0, -3] + 3^Rational[1, 2]) - 
             2304 $CellContext`u) $CellContext`\[Eta]0$[2][1] + (
             384 (1 + Complex[0, -1] 3^Rational[1, 2]) + 
             768 3^Rational[1, 2] $CellContext`u) $CellContext`\[Eta]0$[3][
             1] + ((-64) (Complex[0, -3] + 3^Rational[1, 2]) - 
             384 $CellContext`u) $CellContext`\[Eta]0$[4][1]) + (
           Rational[-64, 3] (Complex[0, 13] + 7 3^Rational[1, 2]) + 
           Rational[64, 3] (9 + 
             Complex[0, -17] 
              3^Rational[1, 2]) $CellContext`u) $CellContext`\[Eta]0$[5][
           1] + (64 + Complex[0, 64] 3^Rational[-1, 2] + 
           Complex[0, 128] $CellContext`u) $CellContext`\[Eta]0$[6][1] + (
           384 (Complex[0, -3] + 3^Rational[1, 2]) + 
           2304 $CellContext`u) $CellContext`\[Eta]0$[1, 2][1] + (
           Complex[0, 384] (Complex[0, 1] + 3^Rational[1, 2]) - 768 
           3^Rational[1, 2] $CellContext`u) $CellContext`\[Eta]0$[1, 3][1] + (
           64 (Complex[0, -3] + 3^Rational[1, 2]) + 
           384 $CellContext`u) $CellContext`\[Eta]0$[1, 4][1] + (
           384 (Complex[0, -3] + 3^Rational[1, 2]) + 
           2304 $CellContext`u) $CellContext`\[Eta]0$[2][
           1] $CellContext`\[Eta]0$b[1][-1] + (
           Complex[0, 384] (Complex[0, 1] + 3^Rational[1, 2]) - 768 
           3^Rational[1, 2] $CellContext`u) $CellContext`\[Eta]0$[3][
           1] $CellContext`\[Eta]0$b[1][-1] + (
           64 (Complex[0, -3] + 3^Rational[1, 2]) + 
           384 $CellContext`u) $CellContext`\[Eta]0$[4][
           1] $CellContext`\[Eta]0$b[1][-1] + (
           Complex[0, 32] (Complex[0, 27] + 
             3^Rational[1, 2]) + $CellContext`u (Complex[0, -1728] + 
             Complex[0, -4608] $CellContext`\[Zeta]$[1][0]) + 
           Complex[0, 768] (Complex[0, 3] + 
             3^Rational[1, 2]) $CellContext`\[Zeta]$[1][
             0]) $CellContext`\[Eta]0$b[2][-1] + (
           384 (Complex[0, 3] + 3^Rational[1, 2]) - 
           2304 $CellContext`u) $CellContext`\[Eta]0$[1][
           1] $CellContext`\[Eta]0$b[2][-1] + (
           32 (Complex[0, 27] + 5 3^Rational[1, 2]) + 
           768 (Complex[0, -1] + 3^Rational[1, 2]) $CellContext`\[Zeta]$[1][
             0] + $CellContext`u (
             Complex[0, -64] (Complex[0, -18] + 3^Rational[1, 2]) + 
             Complex[0, 1536] 
              3^Rational[1, 2] $CellContext`\[Zeta]$[1][
               0])) $CellContext`\[Eta]0$b[3][-1] + (
           Complex[0, -384] (Complex[0, -1] + 3^Rational[1, 2]) + 
           768 3^Rational[1, 2] $CellContext`u) $CellContext`\[Eta]0$[1][
           1] $CellContext`\[Eta]0$b[3][-1] + (304 + 
           Complex[0, -400] 
            3^Rational[1, 2] + $CellContext`u (Complex[0, 992] + 
             384 3^Rational[1, 2] + 
             Complex[0, -768] $CellContext`\[Zeta]$[1][0]) + 
           Complex[0, 128] (Complex[0, 3] + 
             3^Rational[1, 2]) $CellContext`\[Zeta]$[1][
             0]) $CellContext`\[Eta]0$b[4][-1] + (
           64 (Complex[0, 3] + 3^Rational[1, 2]) - 
           384 $CellContext`u) $CellContext`\[Eta]0$[1][
           1] $CellContext`\[Eta]0$b[4][-1] + $CellContext`\[Eta]0$b[1][-1] (
           Complex[0, 2304] + ((-384) (Complex[0, 3] + 3^Rational[1, 2]) + 
             2304 $CellContext`u) $CellContext`\[Eta]0$b[2][-1] + (
             384 (1 + Complex[0, 1] 3^Rational[1, 2]) - 768 
             3^Rational[1, 2] $CellContext`u) $CellContext`\[Eta]0$b[
             3][-1] + ((-64) (Complex[0, 3] + 3^Rational[1, 2]) + 
             384 $CellContext`u) $CellContext`\[Eta]0$b[4][-1]) + (
           Rational[64, 3] (Complex[0, 13] - 7 3^Rational[1, 2]) + (-192 + 
             Complex[0, -1088] 
              3^Rational[-1, 2]) $CellContext`u) $CellContext`\[Eta]0$b[
           5][-1] + (64 + Complex[0, -64] 3^Rational[-1, 2] + 
           Complex[0, 128] $CellContext`u) $CellContext`\[Eta]0$b[6][-1] + (
           384 (Complex[0, 3] + 3^Rational[1, 2]) - 
           2304 $CellContext`u) $CellContext`\[Eta]0$b[1, 2][-1] + (
           Complex[0, -384] (Complex[0, -1] + 3^Rational[1, 2]) + 
           768 3^Rational[1, 2] $CellContext`u) $CellContext`\[Eta]0$b[
           1, 3][-1] + (64 (Complex[0, 3] + 3^Rational[1, 2]) - 
           384 $CellContext`u) $CellContext`\[Eta]0$b[
           1, 4][-1]) + $CellContext`Q0$[1]^(-3) (-4032 - 
         4608 $CellContext`\[Zeta]$[1][
          0] + (Complex[0, 32] (Complex[0, 27] + 
             3^Rational[1, 2]) + $CellContext`u (Complex[0, 1728] + 
             Complex[0, 4608] $CellContext`\[Zeta]$[1][0]) + 
           Complex[0, 768] (Complex[0, 3] + 
             3^Rational[1, 2]) $CellContext`\[Zeta]$[1][
             0]) $CellContext`\[Eta]0$[2][
           1] + ((-32) (Complex[0, 9] + 7 3^Rational[1, 2]) + 
           768 (Complex[0, -1] + 3^Rational[1, 2]) $CellContext`\[Zeta]$[1][
             0] + $CellContext`u (
             Complex[0, 64] (Complex[0, 18] + 3^Rational[1, 2]) + 
             Complex[0, -1536] 
              3^Rational[1, 2] $CellContext`\[Zeta]$[1][
               0])) $CellContext`\[Eta]0$[3][1] + (688 + 
           Complex[0, -16] 
            3^Rational[1, 2] + $CellContext`u (Complex[0, -992] + 
             384 3^Rational[1, 2] + 
             Complex[0, 768] $CellContext`\[Zeta]$[1][0]) + 
           Complex[0, 128] (Complex[0, 3] + 
             3^Rational[1, 2]) $CellContext`\[Zeta]$[1][
             0]) $CellContext`\[Eta]0$[4][1] + $CellContext`\[Eta]0$[1][1] (
           Complex[0, 2304] + (384 (Complex[0, 3] + 3^Rational[1, 2]) + 
             2304 $CellContext`u) $CellContext`\[Eta]0$[2][1] + (
             Complex[0, -384] (Complex[0, -1] + 3^Rational[1, 2]) - 768 
             3^Rational[1, 2] $CellContext`u) $CellContext`\[Eta]0$[3][1] + (
             64 (Complex[0, 3] + 3^Rational[1, 2]) + 
             384 $CellContext`u) $CellContext`\[Eta]0$[4][1]) + (
           Rational[128, 3] (Complex[0, 2] - 5 3^Rational[1, 2]) + (-192 + 
             Complex[0, 1088] 
              3^Rational[-1, 2]) $CellContext`u) $CellContext`\[Eta]0$[5][
           1] + (64 + Complex[0, -64] 3^Rational[-1, 2] + 
           Complex[0, -128] $CellContext`u) $CellContext`\[Eta]0$[6][
           1] + ((-384) (Complex[0, 3] + 3^Rational[1, 2]) - 
           2304 $CellContext`u) $CellContext`\[Eta]0$[1, 2][1] + (
           384 (1 + Complex[0, 1] 3^Rational[1, 2]) + 
           768 3^Rational[1, 2] $CellContext`u) $CellContext`\[Eta]0$[1, 3][
           1] + ((-64) (Complex[0, 3] + 3^Rational[1, 2]) - 
           384 $CellContext`u) $CellContext`\[Eta]0$[1, 4][
           1] + ((-384) (Complex[0, 3] + 3^Rational[1, 2]) - 
           2304 $CellContext`u) $CellContext`\[Eta]0$[2][
           1] $CellContext`\[Eta]0$b[1][-1] + (
           384 (1 + Complex[0, 1] 3^Rational[1, 2]) + 
           768 3^Rational[1, 2] $CellContext`u) $CellContext`\[Eta]0$[3][
           1] $CellContext`\[Eta]0$b[
           1][-1] + ((-64) (Complex[0, 3] + 3^Rational[1, 2]) - 
           384 $CellContext`u) $CellContext`\[Eta]0$[4][
           1] $CellContext`\[Eta]0$b[1][-1] + (-864 + 
           Complex[0, -32] 
            3^Rational[1, 2] + $CellContext`u (Complex[0, 1728] + 
             Complex[0, 4608] $CellContext`\[Zeta]$[1][0]) + 
           Complex[0, -768] (Complex[0, -3] + 
             3^Rational[1, 2]) $CellContext`\[Zeta]$[1][
             0]) $CellContext`\[Eta]0$b[
           2][-1] + ((-384) (Complex[0, -3] + 3^Rational[1, 2]) + 
           2304 $CellContext`u) $CellContext`\[Eta]0$[1][
           1] $CellContext`\[Eta]0$b[2][-1] + (
           32 (Complex[0, 9] - 7 3^Rational[1, 2]) + 
           768 (Complex[0, 1] + 3^Rational[1, 2]) $CellContext`\[Zeta]$[1][
             0] + $CellContext`u (64 (18 + Complex[0, 1] 3^Rational[1, 2]) + 
             Complex[0, -1536] 
              3^Rational[1, 2] $CellContext`\[Zeta]$[1][
               0])) $CellContext`\[Eta]0$b[3][-1] + (
           384 (1 + Complex[0, -1] 3^Rational[1, 2]) - 768 
           3^Rational[1, 2] $CellContext`u) $CellContext`\[Eta]0$[1][
           1] $CellContext`\[Eta]0$b[3][-1] + (688 + 
           Complex[0, 16] 
            3^Rational[
              1, 2] + $CellContext`u ((-32) (Complex[0, 31] + 
               12 3^Rational[1, 2]) + 
             Complex[0, 768] $CellContext`\[Zeta]$[1][0]) + 
           Complex[0, -128] (Complex[0, -3] + 
             3^Rational[1, 2]) $CellContext`\[Zeta]$[1][
             0]) $CellContext`\[Eta]0$b[
           4][-1] + ((-64) (Complex[0, -3] + 3^Rational[1, 2]) + 
           384 $CellContext`u) $CellContext`\[Eta]0$[1][
           1] $CellContext`\[Eta]0$b[4][-1] + $CellContext`\[Eta]0$b[1][-1] (
           Complex[0, -2304] + (384 (Complex[0, -3] + 3^Rational[1, 2]) - 
             2304 $CellContext`u) $CellContext`\[Eta]0$b[2][-1] + (
             Complex[0, 384] (Complex[0, 1] + 3^Rational[1, 2]) + 
             768 3^Rational[1, 2] $CellContext`u) $CellContext`\[Eta]0$b[
             3][-1] + (64 (Complex[0, -3] + 3^Rational[1, 2]) - 
             384 $CellContext`u) $CellContext`\[Eta]0$b[4][-1]) + (
           Rational[-128, 3] (Complex[0, 2] + 5 3^Rational[1, 2]) + 
           Rational[64, 3] (9 + 
             Complex[0, 17] 
              3^Rational[1, 2]) $CellContext`u) $CellContext`\[Eta]0$b[
           5][-1] + (64 + Complex[0, 64] 3^Rational[-1, 2] + 
           Complex[0, -128] $CellContext`u) $CellContext`\[Eta]0$b[
           6][-1] + ((-384) (Complex[0, -3] + 3^Rational[1, 2]) + 
           2304 $CellContext`u) $CellContext`\[Eta]0$b[1, 2][-1] + (
           384 (1 + Complex[0, -1] 3^Rational[1, 2]) - 768 
           3^Rational[1, 2] $CellContext`u) $CellContext`\[Eta]0$b[
           1, 3][-1] + ((-64) (Complex[0, -3] + 3^Rational[1, 2]) + 
           384 $CellContext`u) $CellContext`\[Eta]0$b[
           1, 4][-1]) + $CellContext`Q0$[-1]^(-2) (-56160 - 
         91584 $CellContext`\[Zeta]$[1][0] - 
         41472 $CellContext`\[Zeta]$[1][0]^2 - 
         11232 $CellContext`\[Zeta]$[3][
          0] + (288 (-7 + Complex[0, -5] 3^Rational[1, 2]) + 
           576 (Complex[0, -9] + 
             2 3^Rational[1, 2]) $CellContext`u) $CellContext`\[Eta]0$[2][
            1]^2 + (144 (1 + Complex[0, -1] 3^Rational[1, 2]) + 
           288 3^Rational[1, 2] $CellContext`u) $CellContext`\[Eta]0$[3][
            1]^2 + (-2088 + 
           Complex[0, -312] 
            3^Rational[1, 2] + (-3888 + 
             Complex[0, -6672] 3^Rational[1, 2]) $CellContext`\[Zeta]$[1][0] + 
           1152 (3 + Complex[0, 1] 3^Rational[1, 2]) $CellContext`\[Zeta]$[1][
              0]^2 + $CellContext`u (
             144 (Complex[0, -22] + 9 3^Rational[1, 2]) + 
             864 (Complex[0, -17] + 8 3^Rational[1, 2]) $CellContext`\[Zeta]$[
               1][0] + Complex[0, 6912] $CellContext`\[Zeta]$[1][0]^2 + 
             Complex[0, 1872] $CellContext`\[Zeta]$[3][0]) + 
           312 (3 + Complex[0, 1] 3^Rational[1, 2]) $CellContext`\[Zeta]$[3][
             0]) $CellContext`\[Eta]0$[4][1] + $CellContext`\[Eta]0$[3][
           1] ((-336) (Complex[0, -17] + 3^Rational[1, 2]) + 
           288 (Complex[0, 43] - 21 3^Rational[1, 2]) $CellContext`\[Zeta]$[
             1][0] - 6912 (Complex[0, 1] + 
            3^Rational[1, 2]) $CellContext`\[Zeta]$[1][0]^2 - 
           1872 (Complex[0, 1] + 3^Rational[1, 2]) $CellContext`\[Zeta]$[3][
            0] + $CellContext`u (48 (-261 + Complex[0, 25] 3^Rational[1, 2]) + 
             Complex[0, -5184] (Complex[0, -4] + 
               3^Rational[1, 2]) $CellContext`\[Zeta]$[1][0] + 
             Complex[0, -13824] 
              3^Rational[1, 2] $CellContext`\[Zeta]$[1][0]^2 + 
             Complex[0, -3744] 
              3^Rational[1, 2] $CellContext`\[Zeta]$[3][0]) + ((-48) (
               Complex[0, -3] + 3^Rational[1, 2]) - 
             288 $CellContext`u) $CellContext`\[Eta]0$[4][
             1]) + $CellContext`\[Eta]0$[1][1]^2 (
           10368 + (Complex[0, -1728] (Complex[0, -3] + 3^Rational[1, 2]) + 
             Complex[0, -10368] $CellContext`u) $CellContext`\[Eta]0$[2][
             1] + (1728 (Complex[0, 1] + 3^Rational[1, 2]) + 
             Complex[0, 3456] 
              3^Rational[1, 2] $CellContext`u) $CellContext`\[Eta]0$[3][1] + (
             Complex[0, -288] (Complex[0, -3] + 3^Rational[1, 2]) + 
             Complex[0, -1728] $CellContext`u) $CellContext`\[Eta]0$[4][
             1]) + $CellContext`\[Eta]0$[2][1] (
           192 (27 + Complex[0, 8] 3^Rational[1, 2]) + 
           288 (87 + Complex[0, 13] 3^Rational[1, 2]) $CellContext`\[Zeta]$[
             1][0] + 6912 (3 + 
             Complex[0, 1] 3^Rational[1, 2]) $CellContext`\[Zeta]$[1][
              0]^2 + $CellContext`u (Complex[0, 10368] + 
             Complex[0, 50112] $CellContext`\[Zeta]$[1][0] + 
             Complex[0, 41472] $CellContext`\[Zeta]$[1][0]^2 + 
             Complex[0, 11232] $CellContext`\[Zeta]$[3][0]) + 
           1872 (3 + Complex[0, 1] 3^Rational[1, 2]) $CellContext`\[Zeta]$[3][
             0] + ((-384) (Complex[0, -3] + 3^Rational[1, 2]) - 
             2304 $CellContext`u) $CellContext`\[Eta]0$[3][1] + (
             192 (1 + Complex[0, -1] 3^Rational[1, 2]) + 
             384 3^Rational[1, 2] $CellContext`u) $CellContext`\[Eta]0$[4][
             1]) + (Complex[0, -2984] + 936 3^Rational[1, 2] + 
           384 (Complex[0, 13] + 7 3^Rational[1, 2]) $CellContext`\[Zeta]$[1][
             0] + $CellContext`u (24 (165 + Complex[0, 7] 3^Rational[1, 2]) + 
             384 (-9 + Complex[0, 17] 3^Rational[1, 2]) $CellContext`\[Zeta]$[
               1][0])) $CellContext`\[Eta]0$[5][1] + (1000 + 
           Complex[0, 5032] 
            3^Rational[-1, 2] + $CellContext`u (Complex[0, 3824] - 1824 
             3^Rational[1, 2] + 
             Complex[0, -2304] $CellContext`\[Zeta]$[1][0]) + 
           Complex[0, -384] (Complex[0, -3] + 
             3^Rational[1, 2]) $CellContext`\[Zeta]$[1][
             0]) $CellContext`\[Eta]0$[6][
           1] + ((-480) (Complex[0, 2] + 3^Rational[1, 2]) + 
           240 (3 + Complex[0, -5] 
              3^Rational[1, 2]) $CellContext`u) $CellContext`\[Eta]0$[7][
           1] + (56 (3 + Complex[0, 1] 3^Rational[1, 2]) + 
           Complex[0, 336] $CellContext`u) $CellContext`\[Eta]0$[8][1] + (
           144 (Complex[0, 87] - 13 
             3^Rational[1, 2]) + $CellContext`u (-25056 - 
             41472 $CellContext`\[Zeta]$[1][0]) - 
           6912 (Complex[0, -3] + 3^Rational[1, 2]) $CellContext`\[Zeta]$[1][
            0]) $CellContext`\[Eta]0$[1, 2][1] + (-6192 + 
           Complex[0, -3024] 3^Rational[1, 2] + 
           6912 (1 + Complex[0, -1] 3^Rational[1, 2]) $CellContext`\[Zeta]$[
             1][0] + $CellContext`u (2592 (Complex[0, -4] + 3^Rational[1, 2]) + 
             13824 3^Rational[1, 2] $CellContext`\[Zeta]$[1][
               0])) $CellContext`\[Eta]0$[1, 3][1] + (
           24 (Complex[0, -81] + 139 3^Rational[1, 2]) + $CellContext`u (
             432 (17 + Complex[0, 8] 3^Rational[1, 2]) - 
             6912 $CellContext`\[Zeta]$[1][0]) - 
           1152 (Complex[0, -3] + 3^Rational[1, 2]) $CellContext`\[Zeta]$[1][
            0]) $CellContext`\[Eta]0$[1, 4][1] + $CellContext`\[Eta]0$[1][1] (
           Complex[0, 45792] + 
           Complex[0, 41472] $CellContext`\[Zeta]$[1][0] + (
             144 (Complex[0, -87] + 13 3^Rational[1, 2]) + 
             6912 (Complex[0, -3] + 3^Rational[1, 2]) $CellContext`\[Zeta]$[
               1][0] + $CellContext`u (25056 + 
               41472 $CellContext`\[Zeta]$[1][0])) $CellContext`\[Eta]0$[2][
             1] + (144 (43 + Complex[0, 21] 3^Rational[1, 2]) + 
             Complex[0, 6912] (Complex[0, 1] + 
               3^Rational[1, 2]) $CellContext`\[Zeta]$[1][
               0] + $CellContext`u ((-2592) (Complex[0, -4] + 
                 3^Rational[1, 2]) - 13824 
               3^Rational[1, 2] $CellContext`\[Zeta]$[1][
                0])) $CellContext`\[Eta]0$[3][1] + (Complex[0, 1944] - 3336 
             3^Rational[1, 2] + 
             1152 (Complex[0, -3] + 3^Rational[1, 2]) $CellContext`\[Zeta]$[
               1][0] + $CellContext`u (
               432 (-17 + Complex[0, -8] 3^Rational[1, 2]) + 
               6912 $CellContext`\[Zeta]$[1][0])) $CellContext`\[Eta]0$[4][
             1] + (192 (13 + Complex[0, -7] 3^Rational[1, 2]) + 
             192 (Complex[0, 9] + 
               17 3^Rational[1, 2]) $CellContext`u) $CellContext`\[Eta]0$[5][
             1] + ((-192) (Complex[0, -3] + 3^Rational[1, 2]) - 
             1152 $CellContext`u) $CellContext`\[Eta]0$[6][1] + (
             3456 (3 + Complex[0, 1] 3^Rational[1, 2]) + 
             Complex[0, 20736] $CellContext`u) $CellContext`\[Eta]0$[1, 2][
             1] + ((-3456) (Complex[0, 1] + 3^Rational[1, 2]) + 
             Complex[0, -6912] 
              3^Rational[1, 2] $CellContext`u) $CellContext`\[Eta]0$[1, 3][
             1] + (576 (3 + Complex[0, 1] 3^Rational[1, 2]) + 
             Complex[0, 3456] $CellContext`u) $CellContext`\[Eta]0$[1, 4][
             1]) + (192 (-13 + Complex[0, 7] 3^Rational[1, 2]) - 
           192 (Complex[0, 9] + 
            17 3^Rational[1, 2]) $CellContext`u) $CellContext`\[Eta]0$[1, 5][
           1] + (192 (Complex[0, -3] + 3^Rational[1, 2]) + 
           1152 $CellContext`u) $CellContext`\[Eta]0$[1, 6][1] + (
           96 (Complex[0, 15] + 19 3^Rational[1, 2]) + 
           576 (1 + Complex[0, 6] 
              3^Rational[1, 2]) $CellContext`u) $CellContext`\[Eta]0$[2, 3][
           1] + (Complex[0, -96] (Complex[0, -11] + 3^Rational[1, 2]) - 
           192 (Complex[0, 9] + 
            2 3^Rational[1, 2]) $CellContext`u) $CellContext`\[Eta]0$[2, 4][
           1] + (48 (Complex[0, -3] + 3^Rational[1, 2]) + 
           288 $CellContext`u) $CellContext`\[Eta]0$[3, 4][1] + (
           Complex[0, -3456] (Complex[0, -3] + 3^Rational[1, 2]) + 
           Complex[0, -20736] $CellContext`u) $CellContext`\[Eta]0$[1, 1, 2][
           1] + (3456 (Complex[0, 1] + 3^Rational[1, 2]) + 
           Complex[0, 6912] 
            3^Rational[1, 2] $CellContext`u) $CellContext`\[Eta]0$[1, 1, 3][
           1] + (Complex[0, -576] (Complex[0, -3] + 3^Rational[1, 2]) + 
           Complex[0, -3456] $CellContext`u) $CellContext`\[Eta]0$[1, 1, 4][
           1] + (
           144 (Complex[0, 87] - 13 
             3^Rational[1, 2]) + $CellContext`u (-25056 - 
             41472 $CellContext`\[Zeta]$[1][0]) - 
           6912 (Complex[0, -3] + 3^Rational[1, 2]) $CellContext`\[Zeta]$[1][
            0]) $CellContext`\[Eta]0$[2][1] $CellContext`\[Eta]0$b[
           1][-1] + (-6192 + Complex[0, -3024] 3^Rational[1, 2] + 
           6912 (1 + Complex[0, -1] 3^Rational[1, 2]) $CellContext`\[Zeta]$[
             1][0] + $CellContext`u (2592 (Complex[0, -4] + 3^Rational[1, 2]) + 
             13824 3^Rational[1, 2] $CellContext`\[Zeta]$[1][
               0])) $CellContext`\[Eta]0$[3][1] $CellContext`\[Eta]0$b[
           1][-1] + (
           24 (Complex[0, -81] + 139 3^Rational[1, 2]) + $CellContext`u (
             432 (17 + Complex[0, 8] 3^Rational[1, 2]) - 
             6912 $CellContext`\[Zeta]$[1][0]) - 
           1152 (Complex[0, -3] + 3^Rational[1, 2]) $CellContext`\[Zeta]$[1][
            0]) $CellContext`\[Eta]0$[4][1] $CellContext`\[Eta]0$b[1][-1] + (
           192 (-13 + Complex[0, 7] 3^Rational[1, 2]) - 
           192 (Complex[0, 9] + 
            17 3^Rational[1, 2]) $CellContext`u) $CellContext`\[Eta]0$[5][
           1] $CellContext`\[Eta]0$b[1][-1] + (
           192 (Complex[0, -3] + 3^Rational[1, 2]) + 
           1152 $CellContext`u) $CellContext`\[Eta]0$[6][
           1] $CellContext`\[Eta]0$b[1][-1] + (
           Complex[0, -3456] (Complex[0, -3] + 3^Rational[1, 2]) + 
           Complex[0, -20736] $CellContext`u) $CellContext`\[Eta]0$[1, 2][
           1] $CellContext`\[Eta]0$b[1][-1] + (
           3456 (Complex[0, 1] + 3^Rational[1, 2]) + 
           Complex[0, 6912] 
            3^Rational[1, 2] $CellContext`u) $CellContext`\[Eta]0$[1, 3][
           1] $CellContext`\[Eta]0$b[1][-1] + (
           Complex[0, -576] (Complex[0, -3] + 3^Rational[1, 2]) + 
           Complex[0, -3456] $CellContext`u) $CellContext`\[Eta]0$[1, 4][
           1] $CellContext`\[Eta]0$b[1][-1] + (
           Complex[0, -1728] (Complex[0, -3] + 3^Rational[1, 2]) + 
           Complex[0, -10368] $CellContext`u) $CellContext`\[Eta]0$[2][
           1] $CellContext`\[Eta]0$b[1][-1]^2 + (
           1728 (Complex[0, 1] + 3^Rational[1, 2]) + 
           Complex[0, 3456] 
            3^Rational[1, 2] $CellContext`u) $CellContext`\[Eta]0$[3][
           1] $CellContext`\[Eta]0$b[1][-1]^2 + (
           Complex[0, -288] (Complex[0, -3] + 3^Rational[1, 2]) + 
           Complex[0, -1728] $CellContext`u) $CellContext`\[Eta]0$[4][
           1] $CellContext`\[Eta]0$b[
            1][-1]^2 + ((-144) (Complex[0, 87] + 13 3^Rational[1, 2]) - 
           6912 (Complex[0, 3] + 3^Rational[1, 2]) $CellContext`\[Zeta]$[1][
            0] + $CellContext`u (25056 + 
             41472 $CellContext`\[Zeta]$[1][0])) $CellContext`\[Eta]0$[1][
           1] $CellContext`\[Eta]0$b[2][-1] + (
           Complex[0, 1728] (Complex[0, 3] + 3^Rational[1, 2]) + 
           Complex[0, -10368] $CellContext`u) $CellContext`\[Eta]0$[1][
            1]^2 $CellContext`\[Eta]0$b[2][-1] - 
         2304 $CellContext`\[Eta]0$[2][1] $CellContext`\[Eta]0$b[
          2][-1] + (96 (Complex[0, -3] + 7 3^Rational[1, 2]) + 
           576 $CellContext`u) $CellContext`\[Eta]0$[3][
           1] $CellContext`\[Eta]0$b[2][-1] + (
           Complex[0, 192] (Complex[0, 1] + 3^Rational[1, 2]) - 384 
           3^Rational[1, 2] $CellContext`u) $CellContext`\[Eta]0$[4][
           1] $CellContext`\[Eta]0$b[2][-1] + (
           Complex[0, 288] (Complex[0, 7] + 5 3^Rational[1, 2]) - 
           576 (Complex[0, 9] + 
            2 3^Rational[1, 2]) $CellContext`u) $CellContext`\[Eta]0$b[
            2][-1]^2 + (-6192 + Complex[0, 3024] 3^Rational[1, 2] + 
           6912 (1 + Complex[0, 1] 3^Rational[1, 2]) $CellContext`\[Zeta]$[1][
             0] + $CellContext`u ((-2592) (Complex[0, 4] + 3^Rational[1, 2]) - 
             13824 3^Rational[1, 2] $CellContext`\[Zeta]$[1][
              0])) $CellContext`\[Eta]0$[1][1] $CellContext`\[Eta]0$b[
           3][-1] + (1728 (Complex[0, -1] + 3^Rational[1, 2]) + 
           Complex[0, 3456] 
            3^Rational[1, 2] $CellContext`u) $CellContext`\[Eta]0$[1][
            1]^2 $CellContext`\[Eta]0$b[3][-1] + (
           96 (Complex[0, 3] + 7 3^Rational[1, 2]) - 
           576 $CellContext`u) $CellContext`\[Eta]0$[2][
           1] $CellContext`\[Eta]0$b[3][-1] - 
         576 $CellContext`\[Eta]0$[3][1] $CellContext`\[Eta]0$b[
          3][-1] + (48 (Complex[0, -3] + 3^Rational[1, 2]) + 
           288 $CellContext`u) $CellContext`\[Eta]0$[4][
           1] $CellContext`\[Eta]0$b[3][-1] + (
           144 (1 + Complex[0, 1] 3^Rational[1, 2]) - 288 
           3^Rational[1, 2] $CellContext`u) $CellContext`\[Eta]0$b[
            3][-1]^2 + (-2088 + 
           Complex[0, 312] 
            3^Rational[1, 2] + (-3888 + 
             Complex[0, 6672] 3^Rational[1, 2]) $CellContext`\[Zeta]$[1][0] + 
           1152 (3 + Complex[0, -1] 3^Rational[1, 2]) $CellContext`\[Zeta]$[
              1][0]^2 + $CellContext`u ((-144) (Complex[0, 22] + 
               9 3^Rational[1, 2]) - 
             864 (Complex[0, 17] + 8 3^Rational[1, 2]) $CellContext`\[Zeta]$[
              1][0] + Complex[0, 6912] $CellContext`\[Zeta]$[1][0]^2 + 
             Complex[0, 1872] $CellContext`\[Zeta]$[3][0]) + 
           312 (3 + Complex[0, -1] 3^Rational[1, 2]) $CellContext`\[Zeta]$[3][
             0]) $CellContext`\[Eta]0$b[4][-1] + (
           24 (Complex[0, 81] + 139 3^Rational[1, 2]) - 
           1152 (Complex[0, 3] + 3^Rational[1, 2]) $CellContext`\[Zeta]$[1][
            0] + $CellContext`u (432 (-17 + Complex[0, 8] 3^Rational[1, 2]) + 
             6912 $CellContext`\[Zeta]$[1][0])) $CellContext`\[Eta]0$[1][
           1] $CellContext`\[Eta]0$b[4][-1] + (
           Complex[0, 288] (Complex[0, 3] + 3^Rational[1, 2]) + 
           Complex[0, -1728] $CellContext`u) $CellContext`\[Eta]0$[1][
            1]^2 $CellContext`\[Eta]0$b[4][-1] + (
           Complex[0, -192] (Complex[0, -1] + 3^Rational[1, 2]) + 
           384 3^Rational[1, 2] $CellContext`u) $CellContext`\[Eta]0$[2][
           1] $CellContext`\[Eta]0$b[4][-1] + (
           48 (Complex[0, 3] + 3^Rational[1, 2]) - 
           288 $CellContext`u) $CellContext`\[Eta]0$[3][
           1] $CellContext`\[Eta]0$b[
           4][-1] + $CellContext`\[Eta]0$b[1][-1]^2 (
           10368 + (Complex[0, 1728] (Complex[0, 3] + 3^Rational[1, 2]) + 
             Complex[0, -10368] $CellContext`u) $CellContext`\[Eta]0$b[
             2][-1] + (1728 (Complex[0, -1] + 3^Rational[1, 2]) + 
             Complex[0, 3456] 
              3^Rational[1, 2] $CellContext`u) $CellContext`\[Eta]0$b[
             3][-1] + (Complex[0, 288] (Complex[0, 3] + 3^Rational[1, 2]) + 
             Complex[0, -1728] $CellContext`u) $CellContext`\[Eta]0$b[
             4][-1]) + $CellContext`\[Eta]0$[1][1] $CellContext`\[Eta]0$b[
           1][-1] (-20736 + (3456 (3 + Complex[0, 1] 3^Rational[1, 2]) + 
             Complex[0, 20736] $CellContext`u) $CellContext`\[Eta]0$[2][
             1] + ((-3456) (Complex[0, 1] + 3^Rational[1, 2]) + 
             Complex[0, -6912] 
              3^Rational[1, 2] $CellContext`u) $CellContext`\[Eta]0$[3][1] + (
             576 (3 + Complex[0, 1] 3^Rational[1, 2]) + 
             Complex[0, 3456] $CellContext`u) $CellContext`\[Eta]0$[4][1] + (
             3456 (3 + Complex[0, -1] 3^Rational[1, 2]) + 
             Complex[0, 20736] $CellContext`u) $CellContext`\[Eta]0$b[
             2][-1] + ((-3456) (Complex[0, -1] + 3^Rational[1, 2]) + 
             Complex[0, -6912] 
              3^Rational[1, 2] $CellContext`u) $CellContext`\[Eta]0$b[
             3][-1] + (576 (3 + Complex[0, -1] 3^Rational[1, 2]) + 
             Complex[0, 3456] $CellContext`u) $CellContext`\[Eta]0$b[
             4][-1]) + $CellContext`\[Eta]0$b[
           3][-1] ((-336) (Complex[0, 17] + 3^Rational[1, 2]) - 
           288 (Complex[0, 43] + 21 3^Rational[1, 2]) $CellContext`\[Zeta]$[
            1][0] - 6912 (Complex[0, -1] + 
            3^Rational[1, 2]) $CellContext`\[Zeta]$[1][0]^2 - 
           1872 (Complex[0, -1] + 3^Rational[1, 2]) $CellContext`\[Zeta]$[3][
            0] + $CellContext`u (48 (261 + Complex[0, 25] 3^Rational[1, 2]) + 
             5184 (4 + Complex[0, -1] 3^Rational[1, 2]) $CellContext`\[Zeta]$[
               1][0] + Complex[0, -13824] 
              3^Rational[1, 2] $CellContext`\[Zeta]$[1][0]^2 + 
             Complex[0, -3744] 
              3^Rational[1, 2] $CellContext`\[Zeta]$[3][0]) + ((-48) (
               Complex[0, 3] + 3^Rational[1, 2]) + 
             288 $CellContext`u) $CellContext`\[Eta]0$b[
             4][-1]) + $CellContext`\[Eta]0$b[2][-1] (
           192 (27 + Complex[0, -8] 3^Rational[1, 2]) + 
           288 (87 + Complex[0, -13] 3^Rational[1, 2]) $CellContext`\[Zeta]$[
             1][0] + 6912 (3 + 
             Complex[0, -1] 3^Rational[1, 2]) $CellContext`\[Zeta]$[1][
              0]^2 + $CellContext`u (Complex[0, 10368] + 
             Complex[0, 50112] $CellContext`\[Zeta]$[1][0] + 
             Complex[0, 41472] $CellContext`\[Zeta]$[1][0]^2 + 
             Complex[0, 11232] $CellContext`\[Zeta]$[3][0]) + 
           1872 (3 + Complex[0, -1] 3^Rational[1, 2]) $CellContext`\[Zeta]$[
             3][0] + ((-384) (Complex[0, 3] + 3^Rational[1, 2]) + 
             2304 $CellContext`u) $CellContext`\[Eta]0$b[3][-1] + (
             192 (1 + Complex[0, 1] 3^Rational[1, 2]) - 384 
             3^Rational[1, 2] $CellContext`u) $CellContext`\[Eta]0$b[
             4][-1]) + (Complex[0, 2984] + 936 3^Rational[1, 2] + 
           384 (Complex[0, -13] + 7 3^Rational[1, 2]) $CellContext`\[Zeta]$[
             1][0] + $CellContext`u (-3960 + Complex[0, 168] 3^Rational[1, 2] + 
             384 (9 + Complex[0, 17] 3^Rational[1, 2]) $CellContext`\[Zeta]$[
               1][0])) $CellContext`\[Eta]0$b[5][-1] + (
           192 (-13 + Complex[0, -7] 3^Rational[1, 2]) + 
           192 (Complex[0, -9] + 
             17 3^Rational[1, 2]) $CellContext`u) $CellContext`\[Eta]0$[1][
           1] $CellContext`\[Eta]0$b[5][-1] + (1000 + 
           Complex[0, -5032] 
            3^Rational[-1, 2] + $CellContext`u (Complex[0, 3824] + 
             1824 3^Rational[1, 2] + 
             Complex[0, -2304] $CellContext`\[Zeta]$[1][0]) + 
           Complex[0, 384] (Complex[0, 3] + 
             3^Rational[1, 2]) $CellContext`\[Zeta]$[1][
             0]) $CellContext`\[Eta]0$b[6][-1] + (
           192 (Complex[0, 3] + 3^Rational[1, 2]) - 
           1152 $CellContext`u) $CellContext`\[Eta]0$[1][
           1] $CellContext`\[Eta]0$b[
           6][-1] + ((-480) (Complex[0, -2] + 3^Rational[1, 2]) + 
           240 (-3 + Complex[0, -5] 
              3^Rational[1, 2]) $CellContext`u) $CellContext`\[Eta]0$b[
           7][-1] + (56 (3 + Complex[0, -1] 3^Rational[1, 2]) + 
           Complex[0, 336] $CellContext`u) $CellContext`\[Eta]0$b[
           8][-1] + ((-144) (Complex[0, 87] + 13 3^Rational[1, 2]) - 
           6912 (Complex[0, 3] + 3^Rational[1, 2]) $CellContext`\[Zeta]$[1][
            0] + $CellContext`u (25056 + 
             41472 $CellContext`\[Zeta]$[1][0])) $CellContext`\[Eta]0$b[
           1, 2][-1] + (Complex[0, 3456] (Complex[0, 3] + 3^Rational[1, 2]) + 
           Complex[0, -20736] $CellContext`u) $CellContext`\[Eta]0$[1][
           1] $CellContext`\[Eta]0$b[1, 2][-1] + (-6192 + 
           Complex[0, 3024] 3^Rational[1, 2] + 
           6912 (1 + Complex[0, 1] 3^Rational[1, 2]) $CellContext`\[Zeta]$[1][
             0] + $CellContext`u ((-2592) (Complex[0, 4] + 3^Rational[1, 2]) - 
             13824 3^Rational[1, 2] $CellContext`\[Zeta]$[1][
              0])) $CellContext`\[Eta]0$b[1, 3][-1] + (
           3456 (Complex[0, -1] + 3^Rational[1, 2]) + 
           Complex[0, 6912] 
            3^Rational[1, 2] $CellContext`u) $CellContext`\[Eta]0$[1][
           1] $CellContext`\[Eta]0$b[1, 3][-1] + (
           24 (Complex[0, 81] + 139 3^Rational[1, 2]) - 
           1152 (Complex[0, 3] + 3^Rational[1, 2]) $CellContext`\[Zeta]$[1][
            0] + $CellContext`u (432 (-17 + Complex[0, 8] 3^Rational[1, 2]) + 
             6912 $CellContext`\[Zeta]$[1][0])) $CellContext`\[Eta]0$b[
           1, 4][-1] + (Complex[0, 576] (Complex[0, 3] + 3^Rational[1, 2]) + 
           Complex[0, -3456] $CellContext`u) $CellContext`\[Eta]0$[1][
           1] $CellContext`\[Eta]0$b[1, 4][-1] + $CellContext`\[Eta]0$b[
           1][-1] (Complex[0, -45792] + 
           Complex[0, -41472] $CellContext`\[Zeta]$[1][0] + (
             144 (Complex[0, 87] + 
               13 3^Rational[1, 2]) + $CellContext`u (-25056 - 
               41472 $CellContext`\[Zeta]$[1][0]) + 
             6912 (Complex[0, 3] + 3^Rational[1, 2]) $CellContext`\[Zeta]$[1][
               0]) $CellContext`\[Eta]0$b[2][-1] + (
             144 (43 + Complex[0, -21] 3^Rational[1, 2]) + 
             Complex[0, -6912] (Complex[0, -1] + 
               3^Rational[1, 2]) $CellContext`\[Zeta]$[1][
               0] + $CellContext`u (2592 (Complex[0, 4] + 3^Rational[1, 2]) + 
               13824 3^Rational[1, 2] $CellContext`\[Zeta]$[1][
                 0])) $CellContext`\[Eta]0$b[
             3][-1] + ((-24) (Complex[0, 81] + 
               139 3^Rational[1, 2]) + $CellContext`u (
               432 (17 + Complex[0, -8] 3^Rational[1, 2]) - 
               6912 $CellContext`\[Zeta]$[1][0]) + 
             1152 (Complex[0, 3] + 3^Rational[1, 2]) $CellContext`\[Zeta]$[1][
               0]) $CellContext`\[Eta]0$b[4][-1] + (
             192 (13 + Complex[0, 7] 3^Rational[1, 2]) + 
             192 (Complex[0, 9] - 17 
               3^Rational[1, 2]) $CellContext`u) $CellContext`\[Eta]0$b[
             5][-1] + ((-192) (Complex[0, 3] + 3^Rational[1, 2]) + 
             1152 $CellContext`u) $CellContext`\[Eta]0$b[6][-1] + (
             3456 (3 + Complex[0, -1] 3^Rational[1, 2]) + 
             Complex[0, 20736] $CellContext`u) $CellContext`\[Eta]0$b[
             1, 2][-1] + ((-3456) (Complex[0, -1] + 3^Rational[1, 2]) + 
             Complex[0, -6912] 
              3^Rational[1, 2] $CellContext`u) $CellContext`\[Eta]0$b[
             1, 3][-1] + (576 (3 + Complex[0, -1] 3^Rational[1, 2]) + 
             Complex[0, 3456] $CellContext`u) $CellContext`\[Eta]0$b[
             1, 4][-1]) + (192 (-13 + Complex[0, -7] 3^Rational[1, 2]) + 
           192 (Complex[0, -9] + 
             17 3^Rational[1, 2]) $CellContext`u) $CellContext`\[Eta]0$b[
           1, 5][-1] + (192 (Complex[0, 3] + 3^Rational[1, 2]) - 
           1152 $CellContext`u) $CellContext`\[Eta]0$b[1, 6][-1] + (
           96 (Complex[0, -15] + 19 3^Rational[1, 2]) + 
           576 (-1 + Complex[0, 6] 
              3^Rational[1, 2]) $CellContext`u) $CellContext`\[Eta]0$b[
           2, 3][-1] + (Complex[0, 96] (Complex[0, 11] + 3^Rational[1, 2]) + 
           192 (Complex[0, -9] + 
             2 3^Rational[1, 2]) $CellContext`u) $CellContext`\[Eta]0$b[
           2, 4][-1] + (48 (Complex[0, 3] + 3^Rational[1, 2]) - 
           288 $CellContext`u) $CellContext`\[Eta]0$b[3, 4][-1] + (
           Complex[0, 3456] (Complex[0, 3] + 3^Rational[1, 2]) + 
           Complex[0, -20736] $CellContext`u) $CellContext`\[Eta]0$b[
           1, 1, 2][-1] + (3456 (Complex[0, -1] + 3^Rational[1, 2]) + 
           Complex[0, 6912] 
            3^Rational[1, 2] $CellContext`u) $CellContext`\[Eta]0$b[
           1, 1, 3][-1] + (Complex[0, 576] (Complex[0, 3] + 3^Rational[1, 2]) + 
           Complex[0, -3456] $CellContext`u) $CellContext`\[Eta]0$b[
           1, 1, 4][-1]) + $CellContext`Q0$[1]^(-2) (56160 + 
         91584 $CellContext`\[Zeta]$[1][0] + 
         41472 $CellContext`\[Zeta]$[1][0]^2 + 
         11232 $CellContext`\[Zeta]$[3][0] + (
           Complex[0, 288] (Complex[0, 11] + 3^Rational[1, 2]) - 
           576 (Complex[0, -9] + 
            2 3^Rational[1, 2]) $CellContext`u) $CellContext`\[Eta]0$[2][
            1]^2 + (Complex[0, -144] (Complex[0, -1] + 3^Rational[1, 2]) - 
           288 3^Rational[1, 2] $CellContext`u) $CellContext`\[Eta]0$[3][
            1]^2 + (-1080 + Complex[0, -984] 3^Rational[1, 2] + 
           Complex[0, -240] (Complex[0, -45] + 
             3^Rational[1, 2]) $CellContext`\[Zeta]$[1][0] + 
           1152 (3 + Complex[0, -1] 3^Rational[1, 2]) $CellContext`\[Zeta]$[
              1][0]^2 + $CellContext`u (
             144 (Complex[0, 22] - 9 3^Rational[1, 2]) - 
             864 (Complex[0, -17] + 8 3^Rational[1, 2]) $CellContext`\[Zeta]$[
              1][0] + Complex[0, -6912] $CellContext`\[Zeta]$[1][0]^2 + 
             Complex[0, -1872] $CellContext`\[Zeta]$[3][0]) + 
           312 (3 + Complex[0, -1] 3^Rational[1, 2]) $CellContext`\[Zeta]$[3][
             0]) $CellContext`\[Eta]0$[4][
           1] + $CellContext`\[Eta]0$[1][
            1]^2 (-10368 + (
             Complex[0, 1728] (Complex[0, 3] + 3^Rational[1, 2]) + 
             Complex[0, 10368] $CellContext`u) $CellContext`\[Eta]0$[2][1] + (
             1728 (Complex[0, -1] + 3^Rational[1, 2]) + 
             Complex[0, -3456] 
              3^Rational[1, 2] $CellContext`u) $CellContext`\[Eta]0$[3][1] + (
             Complex[0, 288] (Complex[0, 3] + 3^Rational[1, 2]) + 
             Complex[0, 1728] $CellContext`u) $CellContext`\[Eta]0$[4][
             1]) + $CellContext`\[Eta]0$[3][1] (
           96 (Complex[0, 71] + 16 3^Rational[1, 2]) + 
           288 (Complex[0, 29] + 3 3^Rational[1, 2]) $CellContext`\[Zeta]$[1][
             0] - 6912 (Complex[0, -1] + 
            3^Rational[1, 2]) $CellContext`\[Zeta]$[1][0]^2 - 
           1872 (Complex[0, -1] + 3^Rational[1, 2]) $CellContext`\[Zeta]$[3][
            0] + $CellContext`u (48 (261 + Complex[0, -25] 3^Rational[1, 2]) + 
             5184 (4 + Complex[0, 1] 3^Rational[1, 2]) $CellContext`\[Zeta]$[
               1][0] + Complex[0, 13824] 
              3^Rational[1, 2] $CellContext`\[Zeta]$[1][0]^2 + 
             Complex[0, 3744] 
              3^Rational[1, 2] $CellContext`\[Zeta]$[3][0]) + (
             48 (Complex[0, 3] + 3^Rational[1, 2]) + 
             288 $CellContext`u) $CellContext`\[Eta]0$[4][
             1]) + $CellContext`\[Eta]0$[2][1] (
           192 (27 + Complex[0, -8] 3^Rational[1, 2]) + 
           288 (87 + Complex[0, -13] 3^Rational[1, 2]) $CellContext`\[Zeta]$[
             1][0] + 6912 (3 + 
             Complex[0, -1] 3^Rational[1, 2]) $CellContext`\[Zeta]$[1][
              0]^2 + $CellContext`u (Complex[0, -10368] + 
             Complex[0, -50112] $CellContext`\[Zeta]$[1][0] + 
             Complex[0, -41472] $CellContext`\[Zeta]$[1][0]^2 + 
             Complex[0, -11232] $CellContext`\[Zeta]$[3][0]) + 
           1872 (3 + Complex[0, -1] 3^Rational[1, 2]) $CellContext`\[Zeta]$[
             3][0] + (384 (Complex[0, 3] + 3^Rational[1, 2]) + 
             2304 $CellContext`u) $CellContext`\[Eta]0$[3][1] + (
             Complex[0, -192] (Complex[0, -1] + 3^Rational[1, 2]) - 384 
             3^Rational[1, 2] $CellContext`u) $CellContext`\[Eta]0$[4][
             1]) + ((-16) (Complex[0, 61] + 48 3^Rational[1, 2]) + 
           768 (Complex[0, -2] + 5 3^Rational[1, 2]) $CellContext`\[Zeta]$[1][
             0] + $CellContext`u (-3960 + Complex[0, -168] 3^Rational[1, 2] + 
             384 (9 + Complex[0, -17] 3^Rational[1, 2]) $CellContext`\[Zeta]$[
               1][0])) $CellContext`\[Eta]0$[5][1] + (2824 + 
           Complex[0, 440] 
            3^Rational[-1, 2] + $CellContext`u (Complex[0, -3824] + 
             1824 3^Rational[1, 2] + 
             Complex[0, 2304] $CellContext`\[Zeta]$[1][0]) + 
           Complex[0, 384] (Complex[0, 3] + 
             3^Rational[1, 2]) $CellContext`\[Zeta]$[1][
             0]) $CellContext`\[Eta]0$[6][1] + (Complex[0, 240] - 720 
           3^Rational[1, 2] + 
           240 (-3 + Complex[0, 5] 
              3^Rational[1, 2]) $CellContext`u) $CellContext`\[Eta]0$[7][
           1] + (56 (3 + Complex[0, -1] 3^Rational[1, 2]) + 
           Complex[0, -336] $CellContext`u) $CellContext`\[Eta]0$[8][1] + (
           144 (Complex[0, 87] + 13 3^Rational[1, 2]) + 
           6912 (Complex[0, 3] + 3^Rational[1, 2]) $CellContext`\[Zeta]$[1][
             0] + $CellContext`u (25056 + 
             41472 $CellContext`\[Zeta]$[1][0])) $CellContext`\[Eta]0$[1, 2][
           1] + (-4176 + Complex[0, 432] 3^Rational[1, 2] + 
           Complex[0, -6912] (Complex[0, -1] + 
             3^Rational[1, 2]) $CellContext`\[Zeta]$[1][
             0] + $CellContext`u ((-2592) (Complex[0, -4] + 3^Rational[1, 2]) - 
             13824 3^Rational[1, 2] $CellContext`\[Zeta]$[1][
              0])) $CellContext`\[Eta]0$[1, 3][1] + (
           120 (Complex[0, -45] + 3^Rational[1, 2]) + 
           1152 (Complex[0, 3] + 3^Rational[1, 2]) $CellContext`\[Zeta]$[1][
             0] + $CellContext`u (432 (-17 + Complex[0, -8] 3^Rational[1, 2]) + 
             6912 $CellContext`\[Zeta]$[1][0])) $CellContext`\[Eta]0$[1, 4][
           1] + $CellContext`\[Eta]0$[1][1] (Complex[0, -45792] + 
           Complex[0, -41472] $CellContext`\[Zeta]$[1][
             0] + ((-144) (Complex[0, 87] + 
               13 3^Rational[1, 2]) + $CellContext`u (-25056 - 
               41472 $CellContext`\[Zeta]$[1][0]) - 
             6912 (Complex[0, 3] + 3^Rational[1, 2]) $CellContext`\[Zeta]$[1][
              0]) $CellContext`\[Eta]0$[2][1] + (
             144 (29 + Complex[0, -3] 3^Rational[1, 2]) + 
             6912 (1 + Complex[0, 1] 3^Rational[1, 2]) $CellContext`\[Zeta]$[
               1][0] + $CellContext`u (
               2592 (Complex[0, -4] + 3^Rational[1, 2]) + 
               13824 
                3^Rational[1, 2] $CellContext`\[Zeta]$[1][
                 0])) $CellContext`\[Eta]0$[3][
             1] + ((-120) (Complex[0, -45] + 
               3^Rational[1, 2]) + $CellContext`u (
               432 (17 + Complex[0, 8] 3^Rational[1, 2]) - 
               6912 $CellContext`\[Zeta]$[1][0]) - 
             1152 (Complex[0, 3] + 3^Rational[1, 2]) $CellContext`\[Zeta]$[1][
              0]) $CellContext`\[Eta]0$[4][1] + (
             384 (-2 + Complex[0, -5] 3^Rational[1, 2]) - 
             192 (Complex[0, 9] + 
              17 3^Rational[1, 2]) $CellContext`u) $CellContext`\[Eta]0$[5][
             1] + (192 (Complex[0, 3] + 3^Rational[1, 2]) + 
             1152 $CellContext`u) $CellContext`\[Eta]0$[6][1] + (
             3456 (3 + Complex[0, -1] 3^Rational[1, 2]) + 
             Complex[0, -20736] $CellContext`u) $CellContext`\[Eta]0$[1, 2][
             1] + ((-3456) (Complex[0, -1] + 3^Rational[1, 2]) + 
             Complex[0, 6912] 
              3^Rational[1, 2] $CellContext`u) $CellContext`\[Eta]0$[1, 3][
             1] + (576 (3 + Complex[0, -1] 3^Rational[1, 2]) + 
             Complex[0, -3456] $CellContext`u) $CellContext`\[Eta]0$[1, 4][
             1]) + (384 (2 + Complex[0, 5] 3^Rational[1, 2]) + 
           192 (Complex[0, 9] + 
             17 3^Rational[1, 2]) $CellContext`u) $CellContext`\[Eta]0$[1, 5][
           1] + ((-192) (Complex[0, 3] + 3^Rational[1, 2]) - 
           1152 $CellContext`u) $CellContext`\[Eta]0$[1, 6][1] + (
           96 (Complex[0, -21] + 17 3^Rational[1, 2]) + 
           576 (-1 + Complex[0, -6] 
              3^Rational[1, 2]) $CellContext`u) $CellContext`\[Eta]0$[2, 3][
           1] + (96 (-7 + Complex[0, 5] 3^Rational[1, 2]) + 
           192 (Complex[0, 9] + 
             2 3^Rational[1, 2]) $CellContext`u) $CellContext`\[Eta]0$[2, 4][
           1] + ((-48) (Complex[0, 3] + 3^Rational[1, 2]) - 
           288 $CellContext`u) $CellContext`\[Eta]0$[3, 4][1] + (
           Complex[0, 3456] (Complex[0, 3] + 3^Rational[1, 2]) + 
           Complex[0, 20736] $CellContext`u) $CellContext`\[Eta]0$[1, 1, 2][
           1] + (3456 (Complex[0, -1] + 3^Rational[1, 2]) + 
           Complex[0, -6912] 
            3^Rational[1, 2] $CellContext`u) $CellContext`\[Eta]0$[1, 1, 3][
           1] + (Complex[0, 576] (Complex[0, 3] + 3^Rational[1, 2]) + 
           Complex[0, 3456] $CellContext`u) $CellContext`\[Eta]0$[1, 1, 4][
           1] + (144 (Complex[0, 87] + 13 3^Rational[1, 2]) + 
           6912 (Complex[0, 3] + 3^Rational[1, 2]) $CellContext`\[Zeta]$[1][
             0] + $CellContext`u (25056 + 
             41472 $CellContext`\[Zeta]$[1][0])) $CellContext`\[Eta]0$[2][
           1] $CellContext`\[Eta]0$b[1][-1] + (-4176 + 
           Complex[0, 432] 3^Rational[1, 2] + 
           Complex[0, -6912] (Complex[0, -1] + 
             3^Rational[1, 2]) $CellContext`\[Zeta]$[1][
             0] + $CellContext`u ((-2592) (Complex[0, -4] + 3^Rational[1, 2]) - 
             13824 3^Rational[1, 2] $CellContext`\[Zeta]$[1][
              0])) $CellContext`\[Eta]0$[3][1] $CellContext`\[Eta]0$b[
           1][-1] + (120 (Complex[0, -45] + 3^Rational[1, 2]) + 
           1152 (Complex[0, 3] + 3^Rational[1, 2]) $CellContext`\[Zeta]$[1][
             0] + $CellContext`u (432 (-17 + Complex[0, -8] 3^Rational[1, 2]) + 
             6912 $CellContext`\[Zeta]$[1][0])) $CellContext`\[Eta]0$[4][
           1] $CellContext`\[Eta]0$b[1][-1] + (
           384 (2 + Complex[0, 5] 3^Rational[1, 2]) + 
           192 (Complex[0, 9] + 
             17 3^Rational[1, 2]) $CellContext`u) $CellContext`\[Eta]0$[5][
           1] $CellContext`\[Eta]0$b[
           1][-1] + ((-192) (Complex[0, 3] + 3^Rational[1, 2]) - 
           1152 $CellContext`u) $CellContext`\[Eta]0$[6][
           1] $CellContext`\[Eta]0$b[1][-1] + (
           Complex[0, 3456] (Complex[0, 3] + 3^Rational[1, 2]) + 
           Complex[0, 20736] $CellContext`u) $CellContext`\[Eta]0$[1, 2][
           1] $CellContext`\[Eta]0$b[1][-1] + (
           3456 (Complex[0, -1] + 3^Rational[1, 2]) + 
           Complex[0, -6912] 
            3^Rational[1, 2] $CellContext`u) $CellContext`\[Eta]0$[1, 3][
           1] $CellContext`\[Eta]0$b[1][-1] + (
           Complex[0, 576] (Complex[0, 3] + 3^Rational[1, 2]) + 
           Complex[0, 3456] $CellContext`u) $CellContext`\[Eta]0$[1, 4][
           1] $CellContext`\[Eta]0$b[1][-1] + (
           Complex[0, 1728] (Complex[0, 3] + 3^Rational[1, 2]) + 
           Complex[0, 10368] $CellContext`u) $CellContext`\[Eta]0$[2][
           1] $CellContext`\[Eta]0$b[1][-1]^2 + (
           1728 (Complex[0, -1] + 3^Rational[1, 2]) + 
           Complex[0, -3456] 
            3^Rational[1, 2] $CellContext`u) $CellContext`\[Eta]0$[3][
           1] $CellContext`\[Eta]0$b[1][-1]^2 + (
           Complex[0, 288] (Complex[0, 3] + 3^Rational[1, 2]) + 
           Complex[0, 1728] $CellContext`u) $CellContext`\[Eta]0$[4][
           1] $CellContext`\[Eta]0$b[1][-1]^2 + (
           144 (Complex[0, -87] + 
             13 3^Rational[1, 2]) + $CellContext`u (-25056 - 
             41472 $CellContext`\[Zeta]$[1][0]) + 
           6912 (Complex[0, -3] + 3^Rational[1, 2]) $CellContext`\[Zeta]$[1][
             0]) $CellContext`\[Eta]0$[1][1] $CellContext`\[Eta]0$b[2][-1] + (
           Complex[0, -1728] (Complex[0, -3] + 3^Rational[1, 2]) + 
           Complex[0, 10368] $CellContext`u) $CellContext`\[Eta]0$[1][
            1]^2 $CellContext`\[Eta]0$b[2][-1] + 
         2304 $CellContext`\[Eta]0$[2][1] $CellContext`\[Eta]0$b[
           2][-1] + ((-96) (Complex[0, 3] + 7 3^Rational[1, 2]) - 
           576 $CellContext`u) $CellContext`\[Eta]0$[3][
           1] $CellContext`\[Eta]0$b[2][-1] + (
           192 (1 + Complex[0, 1] 3^Rational[1, 2]) + 
           384 3^Rational[1, 2] $CellContext`u) $CellContext`\[Eta]0$[4][
           1] $CellContext`\[Eta]0$b[2][-1] + (
           Complex[0, -288] (Complex[0, -11] + 3^Rational[1, 2]) + 
           576 (Complex[0, 9] + 
             2 3^Rational[1, 2]) $CellContext`u) $CellContext`\[Eta]0$b[
            2][-1]^2 + (-4176 + Complex[0, -432] 3^Rational[1, 2] + 
           Complex[0, 6912] (Complex[0, 1] + 
             3^Rational[1, 2]) $CellContext`\[Zeta]$[1][0] + $CellContext`u (
             2592 (Complex[0, 4] + 3^Rational[1, 2]) + 
             13824 3^Rational[1, 2] $CellContext`\[Zeta]$[1][
               0])) $CellContext`\[Eta]0$[1][1] $CellContext`\[Eta]0$b[
           3][-1] + (1728 (Complex[0, 1] + 3^Rational[1, 2]) + 
           Complex[0, -3456] 
            3^Rational[1, 2] $CellContext`u) $CellContext`\[Eta]0$[1][
            1]^2 $CellContext`\[Eta]0$b[3][-1] + (
           96 (Complex[0, 3] - 7 3^Rational[1, 2]) + 
           576 $CellContext`u) $CellContext`\[Eta]0$[2][
           1] $CellContext`\[Eta]0$b[3][-1] + 
         576 $CellContext`\[Eta]0$[3][1] $CellContext`\[Eta]0$b[
           3][-1] + ((-48) (Complex[0, 3] + 3^Rational[1, 2]) - 
           288 $CellContext`u) $CellContext`\[Eta]0$[4][
           1] $CellContext`\[Eta]0$b[3][-1] + (
           Complex[0, 144] (Complex[0, 1] + 3^Rational[1, 2]) + 
           288 3^Rational[1, 2] $CellContext`u) $CellContext`\[Eta]0$b[
            3][-1]^2 + (-1080 + Complex[0, 984] 3^Rational[1, 2] + 
           Complex[0, 240] (Complex[0, 45] + 
             3^Rational[1, 2]) $CellContext`\[Zeta]$[1][0] + 
           1152 (3 + Complex[0, 1] 3^Rational[1, 2]) $CellContext`\[Zeta]$[1][
              0]^2 + $CellContext`u (
             144 (Complex[0, 22] + 9 3^Rational[1, 2]) + 
             864 (Complex[0, 17] + 8 3^Rational[1, 2]) $CellContext`\[Zeta]$[
               1][0] + Complex[0, -6912] $CellContext`\[Zeta]$[1][0]^2 + 
             Complex[0, -1872] $CellContext`\[Zeta]$[3][0]) + 
           312 (3 + Complex[0, 1] 3^Rational[1, 2]) $CellContext`\[Zeta]$[3][
             0]) $CellContext`\[Eta]0$b[4][-1] + (
           120 (Complex[0, 45] + 3^Rational[1, 2]) + $CellContext`u (
             432 (17 + Complex[0, -8] 3^Rational[1, 2]) - 
             6912 $CellContext`\[Zeta]$[1][0]) + 
           1152 (Complex[0, -3] + 3^Rational[1, 2]) $CellContext`\[Zeta]$[1][
             0]) $CellContext`\[Eta]0$[1][1] $CellContext`\[Eta]0$b[4][-1] + (
           Complex[0, -288] (Complex[0, -3] + 3^Rational[1, 2]) + 
           Complex[0, 1728] $CellContext`u) $CellContext`\[Eta]0$[1][
            1]^2 $CellContext`\[Eta]0$b[4][-1] + (
           192 (1 + Complex[0, -1] 3^Rational[1, 2]) - 384 
           3^Rational[1, 2] $CellContext`u) $CellContext`\[Eta]0$[2][
           1] $CellContext`\[Eta]0$b[
           4][-1] + ((-48) (Complex[0, -3] + 3^Rational[1, 2]) + 
           288 $CellContext`u) $CellContext`\[Eta]0$[3][
           1] $CellContext`\[Eta]0$b[4][-1] + $CellContext`\[Eta]0$b[3][-1] (
           96 (Complex[0, -71] + 16 3^Rational[1, 2]) + 
           288 (Complex[0, -29] + 3 3^Rational[1, 2]) $CellContext`\[Zeta]$[
             1][0] - 6912 (Complex[0, 1] + 
            3^Rational[1, 2]) $CellContext`\[Zeta]$[1][0]^2 - 
           1872 (Complex[0, 1] + 3^Rational[1, 2]) $CellContext`\[Zeta]$[3][
            0] + $CellContext`u (48 (-261 + Complex[0, -25] 3^Rational[1, 2]) + 
             Complex[0, 5184] (Complex[0, 4] + 
               3^Rational[1, 2]) $CellContext`\[Zeta]$[1][0] + 
             Complex[0, 13824] 3^Rational[1, 2] $CellContext`\[Zeta]$[1][0]^2 + 
             Complex[0, 3744] 
              3^Rational[1, 2] $CellContext`\[Zeta]$[3][0]) + (
             48 (Complex[0, -3] + 3^Rational[1, 2]) - 
             288 $CellContext`u) $CellContext`\[Eta]0$b[
             4][-1]) + $CellContext`\[Eta]0$b[
            1][-1]^2 (-10368 + (
             Complex[0, -1728] (Complex[0, -3] + 3^Rational[1, 2]) + 
             Complex[0, 10368] $CellContext`u) $CellContext`\[Eta]0$b[
             2][-1] + (1728 (Complex[0, 1] + 3^Rational[1, 2]) + 
             Complex[0, -3456] 
              3^Rational[1, 2] $CellContext`u) $CellContext`\[Eta]0$b[
             3][-1] + (Complex[0, -288] (Complex[0, -3] + 3^Rational[1, 2]) + 
             Complex[0, 1728] $CellContext`u) $CellContext`\[Eta]0$b[
             4][-1]) + $CellContext`\[Eta]0$[1][1] $CellContext`\[Eta]0$b[
           1][-1] (20736 + (3456 (3 + Complex[0, -1] 3^Rational[1, 2]) + 
             Complex[0, -20736] $CellContext`u) $CellContext`\[Eta]0$[2][
             1] + ((-3456) (Complex[0, -1] + 3^Rational[1, 2]) + 
             Complex[0, 6912] 
              3^Rational[1, 2] $CellContext`u) $CellContext`\[Eta]0$[3][1] + (
             576 (3 + Complex[0, -1] 3^Rational[1, 2]) + 
             Complex[0, -3456] $CellContext`u) $CellContext`\[Eta]0$[4][1] + (
             3456 (3 + Complex[0, 1] 3^Rational[1, 2]) + 
             Complex[0, -20736] $CellContext`u) $CellContext`\[Eta]0$b[
             2][-1] + ((-3456) (Complex[0, 1] + 3^Rational[1, 2]) + 
             Complex[0, 6912] 
              3^Rational[1, 2] $CellContext`u) $CellContext`\[Eta]0$b[
             3][-1] + (576 (3 + Complex[0, 1] 3^Rational[1, 2]) + 
             Complex[0, -3456] $CellContext`u) $CellContext`\[Eta]0$b[
             4][-1]) + $CellContext`\[Eta]0$b[2][-1] (
           192 (27 + Complex[0, 8] 3^Rational[1, 2]) + 
           288 (87 + Complex[0, 13] 3^Rational[1, 2]) $CellContext`\[Zeta]$[
             1][0] + 6912 (3 + 
             Complex[0, 1] 3^Rational[1, 2]) $CellContext`\[Zeta]$[1][
              0]^2 + $CellContext`u (Complex[0, -10368] + 
             Complex[0, -50112] $CellContext`\[Zeta]$[1][0] + 
             Complex[0, -41472] $CellContext`\[Zeta]$[1][0]^2 + 
             Complex[0, -11232] $CellContext`\[Zeta]$[3][0]) + 
           1872 (3 + Complex[0, 1] 3^Rational[1, 2]) $CellContext`\[Zeta]$[3][
             0] + (384 (Complex[0, -3] + 3^Rational[1, 2]) - 
             2304 $CellContext`u) $CellContext`\[Eta]0$b[3][-1] + (
             Complex[0, 192] (Complex[0, 1] + 3^Rational[1, 2]) + 
             384 3^Rational[1, 2] $CellContext`u) $CellContext`\[Eta]0$b[
             4][-1]) + (Complex[0, 976] - 768 3^Rational[1, 2] + 
           768 (Complex[0, 2] + 5 3^Rational[1, 2]) $CellContext`\[Zeta]$[1][
             0] + $CellContext`u (24 (165 + Complex[0, -7] 3^Rational[1, 2]) + 
             384 (-9 + Complex[0, -17] 
                3^Rational[1, 2]) $CellContext`\[Zeta]$[1][
               0])) $CellContext`\[Eta]0$b[5][-1] + (
           384 (2 + Complex[0, -5] 3^Rational[1, 2]) + 
           192 (Complex[0, 9] - 17 
             3^Rational[1, 2]) $CellContext`u) $CellContext`\[Eta]0$[1][
           1] $CellContext`\[Eta]0$b[5][-1] + (2824 + 
           Complex[0, -440] 
            3^Rational[-1, 2] + $CellContext`u ((-16) (Complex[0, 239] + 
               114 3^Rational[1, 2]) + 
             Complex[0, 2304] $CellContext`\[Zeta]$[1][0]) + 
           Complex[0, -384] (Complex[0, -3] + 
             3^Rational[1, 2]) $CellContext`\[Zeta]$[1][
             0]) $CellContext`\[Eta]0$b[
           6][-1] + ((-192) (Complex[0, -3] + 3^Rational[1, 2]) + 
           1152 $CellContext`u) $CellContext`\[Eta]0$[1][
           1] $CellContext`\[Eta]0$b[
           6][-1] + ((-240) (Complex[0, 1] + 3 3^Rational[1, 2]) + 
           240 (3 + Complex[0, 5] 
              3^Rational[1, 2]) $CellContext`u) $CellContext`\[Eta]0$b[
           7][-1] + (56 (3 + Complex[0, 1] 3^Rational[1, 2]) + 
           Complex[0, -336] $CellContext`u) $CellContext`\[Eta]0$b[8][-1] + (
           144 (Complex[0, -87] + 
             13 3^Rational[1, 2]) + $CellContext`u (-25056 - 
             41472 $CellContext`\[Zeta]$[1][0]) + 
           6912 (Complex[0, -3] + 3^Rational[1, 2]) $CellContext`\[Zeta]$[1][
             0]) $CellContext`\[Eta]0$b[1, 2][-1] + (
           Complex[0, -3456] (Complex[0, -3] + 3^Rational[1, 2]) + 
           Complex[0, 20736] $CellContext`u) $CellContext`\[Eta]0$[1][
           1] $CellContext`\[Eta]0$b[1, 2][-1] + (-4176 + 
           Complex[0, -432] 3^Rational[1, 2] + 
           Complex[0, 6912] (Complex[0, 1] + 
             3^Rational[1, 2]) $CellContext`\[Zeta]$[1][0] + $CellContext`u (
             2592 (Complex[0, 4] + 3^Rational[1, 2]) + 
             13824 3^Rational[1, 2] $CellContext`\[Zeta]$[1][
               0])) $CellContext`\[Eta]0$b[1, 3][-1] + (
           3456 (Complex[0, 1] + 3^Rational[1, 2]) + 
           Complex[0, -6912] 
            3^Rational[1, 2] $CellContext`u) $CellContext`\[Eta]0$[1][
           1] $CellContext`\[Eta]0$b[1, 3][-1] + (
           120 (Complex[0, 45] + 3^Rational[1, 2]) + $CellContext`u (
             432 (17 + Complex[0, -8] 3^Rational[1, 2]) - 
             6912 $CellContext`\[Zeta]$[1][0]) + 
           1152 (Complex[0, -3] + 3^Rational[1, 2]) $CellContext`\[Zeta]$[1][
             0]) $CellContext`\[Eta]0$b[1, 4][-1] + (
           Complex[0, -576] (Complex[0, -3] + 3^Rational[1, 2]) + 
           Complex[0, 3456] $CellContext`u) $CellContext`\[Eta]0$[1][
           1] $CellContext`\[Eta]0$b[1, 4][-1] + $CellContext`\[Eta]0$b[
           1][-1] (Complex[0, 45792] + 
           Complex[0, 41472] $CellContext`\[Zeta]$[1][0] + (
             144 (Complex[0, 87] - 13 3^Rational[1, 2]) - 
             6912 (Complex[0, -3] + 3^Rational[1, 2]) $CellContext`\[Zeta]$[
              1][0] + $CellContext`u (25056 + 
               41472 $CellContext`\[Zeta]$[1][0])) $CellContext`\[Eta]0$b[
             2][-1] + (144 (29 + Complex[0, 3] 3^Rational[1, 2]) + 
             6912 (1 + Complex[0, -1] 3^Rational[1, 2]) $CellContext`\[Zeta]$[
               1][0] + $CellContext`u ((-2592) (Complex[0, 4] + 
                 3^Rational[1, 2]) - 13824 
               3^Rational[1, 2] $CellContext`\[Zeta]$[1][
                0])) $CellContext`\[Eta]0$b[
             3][-1] + ((-120) (Complex[0, 45] + 3^Rational[1, 2]) - 
             1152 (Complex[0, -3] + 3^Rational[1, 2]) $CellContext`\[Zeta]$[
              1][0] + $CellContext`u (
               432 (-17 + Complex[0, 8] 3^Rational[1, 2]) + 
               6912 $CellContext`\[Zeta]$[1][0])) $CellContext`\[Eta]0$b[
             4][-1] + (384 (-2 + Complex[0, 5] 3^Rational[1, 2]) + 
             192 (Complex[0, -9] + 
               17 3^Rational[1, 2]) $CellContext`u) $CellContext`\[Eta]0$b[
             5][-1] + (192 (Complex[0, -3] + 3^Rational[1, 2]) - 
             1152 $CellContext`u) $CellContext`\[Eta]0$b[6][-1] + (
             3456 (3 + Complex[0, 1] 3^Rational[1, 2]) + 
             Complex[0, -20736] $CellContext`u) $CellContext`\[Eta]0$b[
             1, 2][-1] + ((-3456) (Complex[0, 1] + 3^Rational[1, 2]) + 
             Complex[0, 6912] 
              3^Rational[1, 2] $CellContext`u) $CellContext`\[Eta]0$b[
             1, 3][-1] + (576 (3 + Complex[0, 1] 3^Rational[1, 2]) + 
             Complex[0, -3456] $CellContext`u) $CellContext`\[Eta]0$b[
             1, 4][-1]) + (384 (2 + Complex[0, -5] 3^Rational[1, 2]) + 
           192 (Complex[0, 9] - 17 
             3^Rational[1, 2]) $CellContext`u) $CellContext`\[Eta]0$b[
           1, 5][-1] + ((-192) (Complex[0, -3] + 3^Rational[1, 2]) + 
           1152 $CellContext`u) $CellContext`\[Eta]0$b[1, 6][-1] + (
           96 (Complex[0, 21] + 17 3^Rational[1, 2]) + 
           576 (1 + Complex[0, -6] 
              3^Rational[1, 2]) $CellContext`u) $CellContext`\[Eta]0$b[
           2, 3][-1] + (96 (-7 + Complex[0, -5] 3^Rational[1, 2]) + 
           192 (Complex[0, 9] - 2 
             3^Rational[1, 2]) $CellContext`u) $CellContext`\[Eta]0$b[
           2, 4][-1] + ((-48) (Complex[0, -3] + 3^Rational[1, 2]) + 
           288 $CellContext`u) $CellContext`\[Eta]0$b[3, 4][-1] + (
           Complex[0, -3456] (Complex[0, -3] + 3^Rational[1, 2]) + 
           Complex[0, 20736] $CellContext`u) $CellContext`\[Eta]0$b[
           1, 1, 2][-1] + (3456 (Complex[0, 1] + 3^Rational[1, 2]) + 
           Complex[0, -6912] 
            3^Rational[1, 2] $CellContext`u) $CellContext`\[Eta]0$b[
           1, 1, 3][-1] + (
           Complex[0, -576] (Complex[0, -3] + 3^Rational[1, 2]) + 
           Complex[0, 3456] $CellContext`u) $CellContext`\[Eta]0$b[
           1, 1, 4][-1]) + $CellContext`Q0$[1]^(-1) (-743040 - 
         995328 $CellContext`\[Zeta]$[1][0]^2 - 
         248832 $CellContext`\[Zeta]$[1][0]^3 + $CellContext`\[Zeta]$[1][
           0] (-1441152 - 186624 $CellContext`\[Zeta]$[3][0]) - 
         233280 $CellContext`\[Zeta]$[3][0] - 
         51840 $CellContext`\[Zeta]$[5][
          0] + (216 (201 + Complex[0, 1] 3^Rational[1, 2]) + 
           5184 (11 + Complex[0, -1] 3^Rational[1, 2]) $CellContext`\[Zeta]$[
             1][0] + $CellContext`u (
             432 (Complex[0, -180] + 37 3^Rational[1, 2]) + 
             10368 (Complex[0, -9] + 
               2 3^Rational[1, 2]) $CellContext`\[Zeta]$[1][
               0])) $CellContext`\[Eta]0$[2][1]^2 + (
           288 (-23 + Complex[0, -5] 3^Rational[1, 2]) + 
           2592 (1 + Complex[0, 1] 3^Rational[1, 2]) $CellContext`\[Zeta]$[1][
             0] + $CellContext`u ((-720) (Complex[0, -9] + 
               7 3^Rational[1, 2]) + 
             5184 3^Rational[1, 2] $CellContext`\[Zeta]$[1][
               0])) $CellContext`\[Eta]0$[3][1]^2 + (
           312 (-15 + Complex[0, 7] 3^Rational[1, 2]) + 
           6912 (12 + 
             Complex[0, 1] 3^Rational[1, 2]) $CellContext`\[Zeta]$[1][0]^2 + 
           Complex[0, 6912] (Complex[0, 3] + 
             3^Rational[1, 2]) $CellContext`\[Zeta]$[1][0]^3 + 
           216 (115 + Complex[0, 1] 3^Rational[1, 2]) $CellContext`\[Zeta]$[
             3][0] + $CellContext`\[Zeta]$[1][0] (
             288 (207 + Complex[0, 70] 3^Rational[1, 2]) + 
             Complex[0, 5184] (Complex[0, 3] + 
               3^Rational[1, 2]) $CellContext`\[Zeta]$[3][
               0]) + $CellContext`u (
             144 (Complex[0, -7] + 30 3^Rational[1, 2]) + 
             20736 (Complex[0, -5] + 
               3 3^Rational[1, 2]) $CellContext`\[Zeta]$[1][0]^2 + 
             Complex[0, 41472] $CellContext`\[Zeta]$[1][
                0]^3 + $CellContext`\[Zeta]$[1][0] (
               5184 (Complex[0, -21] + 10 3^Rational[1, 2]) + 
               Complex[0, 31104] $CellContext`\[Zeta]$[3][0]) + 
             432 (Complex[0, -79] + 
               36 3^Rational[1, 2]) $CellContext`\[Zeta]$[3][0] + 
             Complex[0, 8640] $CellContext`\[Zeta]$[5][0]) + 
           Complex[0, 1440] (Complex[0, 3] + 
             3^Rational[1, 2]) $CellContext`\[Zeta]$[5][
             0]) $CellContext`\[Eta]0$[4][1] + (-864 - 
           432 (Complex[0, -3] + 
            3^Rational[1, 2]) $CellContext`u) $CellContext`\[Eta]0$[4][
            1]^2 + $CellContext`\[Eta]0$[1][1]^3 (
           Complex[0, -31104] + ((-5184) (Complex[0, 3] + 3^Rational[1, 2]) - 
             31104 $CellContext`u) $CellContext`\[Eta]0$[2][1] + (
             5184 (1 + Complex[0, 1] 3^Rational[1, 2]) + 
             10368 3^Rational[1, 2] $CellContext`u) $CellContext`\[Eta]0$[3][
             1] + ((-864) (Complex[0, 3] + 3^Rational[1, 2]) - 
             5184 $CellContext`u) $CellContext`\[Eta]0$[4][1]) + (
           Complex[0, 552] + 2952 3^Rational[1, 2] - 
           288 (Complex[0, -83] + 7 3^Rational[1, 2]) $CellContext`\[Zeta]$[
            1][0] - 6912 (Complex[0, -2] + 
            5 3^Rational[1, 2]) $CellContext`\[Zeta]$[1][0]^2 + (
             Complex[0, 4176] - 9360 3^Rational[1, 2]) $CellContext`\[Zeta]$[
             3][0] + $CellContext`u (
             1728 (7 + Complex[0, -5] 3^Rational[1, 2]) + 
             576 (99 + Complex[0, 52] 3^Rational[1, 2]) $CellContext`\[Zeta]$[
               1][0] + Complex[0, 3456] (Complex[0, 9] + 
               17 3^Rational[1, 2]) $CellContext`\[Zeta]$[1][0]^2 + 
             288 (-27 + 
               Complex[0, 56] 3^Rational[1, 2]) $CellContext`\[Zeta]$[3][
               0])) $CellContext`\[Eta]0$[5][1] + (-5568 + 
           Complex[0, 768] 
            3^Rational[1, 2] + (-46080 + 
             Complex[0, -4224] 3^Rational[1, 2]) $CellContext`\[Zeta]$[1][0] + 
           3456 (3 + Complex[0, -1] 3^Rational[1, 2]) $CellContext`\[Zeta]$[
              1][0]^2 + $CellContext`u (
             24 (Complex[0, 953] + 33 3^Rational[1, 2]) + 
             576 (Complex[0, 103] - 57 
               3^Rational[1, 2]) $CellContext`\[Zeta]$[1][0] + 
             Complex[0, -20736] $CellContext`\[Zeta]$[1][0]^2 + 
             Complex[0, -5616] $CellContext`\[Zeta]$[3][0]) + 
           936 (3 + Complex[0, -1] 3^Rational[1, 2]) $CellContext`\[Zeta]$[3][
             0]) $CellContext`\[Eta]0$[6][
           1] + ((-16) (Complex[0, 397] + 269 3^Rational[1, 2]) + 
           4320 (Complex[0, -1] + 3 3^Rational[1, 2]) $CellContext`\[Zeta]$[
             1][0] + $CellContext`u (-20304 + 
             Complex[0, 400] 3^Rational[1, 2] + 
             4320 (3 + Complex[0, -5] 3^Rational[1, 2]) $CellContext`\[Zeta]$[
               1][0])) $CellContext`\[Eta]0$[7][1] + (
           48 (237 + Complex[0, 8] 3^Rational[1, 2]) + $CellContext`u (
             144 (Complex[0, -111] + 47 3^Rational[1, 2]) + 
             Complex[0, 6048] $CellContext`\[Zeta]$[1][0]) + 
           Complex[0, 1008] (Complex[0, 3] + 
             3^Rational[1, 2]) $CellContext`\[Zeta]$[1][
             0]) $CellContext`\[Eta]0$[8][1] + (Complex[0, 984] - 2136 
           3^Rational[1, 2] + 
           48 (-36 + Complex[0, 77] 
              3^Rational[1, 2]) $CellContext`u) $CellContext`\[Eta]0$[9][
           1] + (144 (3 + Complex[0, -1] 3^Rational[1, 2]) + 
           Complex[0, -864] $CellContext`u) $CellContext`\[Eta]0$[10][
           1] + ((-2592) (Complex[0, 43] + 2 3^Rational[1, 2]) - 
           62208 (Complex[0, 5] + 3^Rational[1, 2]) $CellContext`\[Zeta]$[1][
            0] - 62208 (Complex[0, 3] + 
            3^Rational[1, 2]) $CellContext`\[Zeta]$[1][
             0]^2 + $CellContext`u (-222912 - 
             622080 $CellContext`\[Zeta]$[1][0] - 
             373248 $CellContext`\[Zeta]$[1][0]^2 - 
             93312 $CellContext`\[Zeta]$[3][0]) - 
           15552 (Complex[0, 3] + 3^Rational[1, 2]) $CellContext`\[Zeta]$[3][
            0]) $CellContext`\[Eta]0$[1, 2][1] + (
           11232 (6 + Complex[0, -1] 3^Rational[1, 2]) + 
           20736 (5 + Complex[0, 1] 3^Rational[1, 2]) $CellContext`\[Zeta]$[
             1][0] + 
           62208 (1 + 
             Complex[0, 1] 3^Rational[1, 2]) $CellContext`\[Zeta]$[1][0]^2 + 
           15552 (1 + Complex[0, 1] 3^Rational[1, 2]) $CellContext`\[Zeta]$[
             3][0] + $CellContext`u (
             8640 (Complex[0, -18] + 3^Rational[1, 2]) + 
             20736 (Complex[0, -9] + 
               5 3^Rational[1, 2]) $CellContext`\[Zeta]$[1][0] + 
             124416 3^Rational[1, 2] $CellContext`\[Zeta]$[1][0]^2 + 
             31104 3^Rational[1, 2] $CellContext`\[Zeta]$[3][
               0])) $CellContext`\[Eta]0$[1, 3][1] + (Complex[0, 58320] - 
           7488 3^Rational[1, 2] - 
           6912 (Complex[0, -12] + 3^Rational[1, 2]) $CellContext`\[Zeta]$[1][
            0] - 10368 (Complex[0, 3] + 
            3^Rational[1, 2]) $CellContext`\[Zeta]$[1][0]^2 + $CellContext`u (
             2592 (39 + Complex[0, 14] 3^Rational[1, 2]) + 
             20736 (5 + Complex[0, 3] 3^Rational[1, 2]) $CellContext`\[Zeta]$[
               1][0] - 62208 $CellContext`\[Zeta]$[1][0]^2 - 
             15552 $CellContext`\[Zeta]$[3][0]) - 
           2592 (Complex[0, 3] + 3^Rational[1, 2]) $CellContext`\[Zeta]$[3][
            0]) $CellContext`\[Eta]0$[1, 4][1] + $CellContext`\[Eta]0$[3][
           1] ((-288) (Complex[0, 284] + 19 3^Rational[1, 2]) + 
           20736 (Complex[0, -5] + 
             3^Rational[1, 2]) $CellContext`\[Zeta]$[1][0]^2 + 
           41472 (Complex[0, -1] + 
             3^Rational[1, 2]) $CellContext`\[Zeta]$[1][0]^3 + 
           864 (Complex[0, -24] + 3^Rational[1, 2]) $CellContext`\[Zeta]$[3][
             0] + $CellContext`\[Zeta]$[1][
             0] ((-1728) (Complex[0, 96] + 13 3^Rational[1, 2]) + 
             31104 (Complex[0, -1] + 3^Rational[1, 2]) $CellContext`\[Zeta]$[
               3][0]) + 8640 (Complex[0, -1] + 
             3^Rational[1, 2]) $CellContext`\[Zeta]$[5][0] + $CellContext`u (
             288 (-387 + Complex[0, 20] 3^Rational[1, 2]) + 
             Complex[0, -20736] (Complex[0, -9] + 
               5 3^Rational[1, 2]) $CellContext`\[Zeta]$[1][0]^2 + 
             Complex[0, -82944] 
              3^Rational[1, 2] $CellContext`\[Zeta]$[1][0]^3 + 
             1728 (-27 + 
               Complex[0, -10] 3^Rational[1, 2]) $CellContext`\[Zeta]$[3][
               0] + $CellContext`\[Zeta]$[1][0] (
               Complex[0, -17280] (Complex[0, -18] + 3^Rational[1, 2]) + 
               Complex[0, -62208] 
                3^Rational[1, 2] $CellContext`\[Zeta]$[3][0]) + 
             Complex[0, -17280] 
              3^Rational[1, 2] $CellContext`\[Zeta]$[5][0]) + (
             48 (Complex[0, 93] + 3^Rational[1, 2]) + $CellContext`u (
               288 (22 + Complex[0, 9] 3^Rational[1, 2]) - 
               5184 $CellContext`\[Zeta]$[1][0]) - 
             864 (Complex[0, 3] + 3^Rational[1, 2]) $CellContext`\[Zeta]$[1][
              0]) $CellContext`\[Eta]0$[4][1] + (
             288 (-2 + Complex[0, -5] 3^Rational[1, 2]) - 
             144 (Complex[0, 9] + 
              17 3^Rational[1, 2]) $CellContext`u) $CellContext`\[Eta]0$[5][
             1] + (144 (Complex[0, 3] + 3^Rational[1, 2]) + 
             864 $CellContext`u) $CellContext`\[Eta]0$[6][1] + (
             432 (3 + Complex[0, -1] 3^Rational[1, 2]) + 
             Complex[0, -2592] $CellContext`u) $CellContext`\[Eta]0$[1, 4][
             1]) + $CellContext`\[Eta]0$[1][1]^2 (248832 + 
           186624 $CellContext`\[Zeta]$[1][0] + (
             15552 (5 + Complex[0, -1] 3^Rational[1, 2]) + $CellContext`u (
               Complex[0, -155520] + 
               Complex[0, -186624] $CellContext`\[Zeta]$[1][0]) + 
             31104 (3 + 
               Complex[0, -1] 3^Rational[1, 2]) $CellContext`\[Zeta]$[1][
               0]) $CellContext`\[Eta]0$[2][
             1] + ((-5184) (Complex[0, -5] + 3^Rational[1, 2]) - 
             31104 (Complex[0, -1] + 3^Rational[1, 2]) $CellContext`\[Zeta]$[
              1][0] + $CellContext`u (
               5184 (9 + Complex[0, 5] 3^Rational[1, 2]) + 
               Complex[0, 62208] 
                3^Rational[1, 2] $CellContext`\[Zeta]$[1][
                 0])) $CellContext`\[Eta]0$[3][1] + (
             Complex[0, -1728] (Complex[0, -12] + 
               3^Rational[1, 2]) + $CellContext`u ((-5184) (Complex[0, -5] + 
                 3 3^Rational[1, 2]) + 
               Complex[0, -31104] $CellContext`\[Zeta]$[1][0]) + 
             5184 (3 + Complex[0, -1] 3^Rational[1, 2]) $CellContext`\[Zeta]$[
               1][0]) $CellContext`\[Eta]0$[4][1] + (
             1728 (Complex[0, -2] + 5 3^Rational[1, 2]) + 
             864 (9 + Complex[0, -17] 
                3^Rational[1, 2]) $CellContext`u) $CellContext`\[Eta]0$[5][
             1] + (Complex[0, 864] (Complex[0, 3] + 3^Rational[1, 2]) + 
             Complex[0, 5184] $CellContext`u) $CellContext`\[Eta]0$[6][1] + (
             15552 (Complex[0, 3] + 3^Rational[1, 2]) + 
             93312 $CellContext`u) $CellContext`\[Eta]0$[1, 2][1] + (
             Complex[0, -15552] (Complex[0, -1] + 3^Rational[1, 2]) - 31104 
             3^Rational[1, 2] $CellContext`u) $CellContext`\[Eta]0$[1, 3][
             1] + (2592 (Complex[0, 3] + 3^Rational[1, 2]) + 
             15552 $CellContext`u) $CellContext`\[Eta]0$[1, 4][
             1]) + $CellContext`\[Eta]0$[2][1] (
           Complex[0, 864] (Complex[0, 13] + 42 3^Rational[1, 2]) + 
           Complex[0, 62208] (Complex[0, 5] + 
             3^Rational[1, 2]) $CellContext`\[Zeta]$[1][0]^2 + 
           Complex[0, 41472] (Complex[0, 3] + 
             3^Rational[1, 2]) $CellContext`\[Zeta]$[1][0]^3 + 
           Complex[0, 864] (Complex[0, 81] + 
             14 3^Rational[1, 2]) $CellContext`\[Zeta]$[3][
             0] + $CellContext`\[Zeta]$[1][0] (
             Complex[0, 5184] (Complex[0, 43] + 10 3^Rational[1, 2]) + 
             Complex[0, 31104] (Complex[0, 3] + 
               3^Rational[1, 2]) $CellContext`\[Zeta]$[3][
               0]) + $CellContext`u (Complex[0, 22464] + 
             Complex[0, 622080] $CellContext`\[Zeta]$[1][0]^2 + 
             Complex[0, 248832] $CellContext`\[Zeta]$[1][
                0]^3 + $CellContext`\[Zeta]$[1][0] (Complex[0, 445824] + 
               Complex[0, 186624] $CellContext`\[Zeta]$[3][0]) + 
             Complex[0, 139968] $CellContext`\[Zeta]$[3][0] + 
             Complex[0, 51840] $CellContext`\[Zeta]$[5][0]) + 
           Complex[0, 8640] (Complex[0, 3] + 
             3^Rational[1, 2]) $CellContext`\[Zeta]$[5][
             0] + ((-144) (Complex[0, -93] + 
               3^Rational[1, 2]) + $CellContext`u (
               864 (19 + Complex[0, 12] 3^Rational[1, 2]) - 
               41472 $CellContext`\[Zeta]$[1][0]) - 
             6912 (Complex[0, 3] + 3^Rational[1, 2]) $CellContext`\[Zeta]$[1][
              0]) $CellContext`\[Eta]0$[3][1] + (
             72 (13 + Complex[0, -67] 3^Rational[1, 2]) + 
             3456 (1 + Complex[0, 1] 3^Rational[1, 2]) $CellContext`\[Zeta]$[
               1][0] + $CellContext`u ((-144) (Complex[0, 72] + 
                 43 3^Rational[1, 2]) + 
               6912 3^Rational[1, 2] $CellContext`\[Zeta]$[1][
                 0])) $CellContext`\[Eta]0$[4][1] + (
             384 (Complex[0, 15] + 2 3^Rational[1, 2]) + 
             576 (17 + Complex[0, 3] 
                3^Rational[1, 2]) $CellContext`u) $CellContext`\[Eta]0$[5][
             1] + (Complex[0, -576] (Complex[0, -1] + 3^Rational[1, 2]) - 
             1152 3^Rational[1, 2] $CellContext`u) $CellContext`\[Eta]0$[6][
             1] + (3456 (3 + Complex[0, -1] 3^Rational[1, 2]) + 
             Complex[0, -20736] $CellContext`u) $CellContext`\[Eta]0$[1, 3][
             1] + ((-1728) (Complex[0, -1] + 3^Rational[1, 2]) + 
             Complex[0, 3456] 
              3^Rational[1, 2] $CellContext`u) $CellContext`\[Eta]0$[1, 4][
             1]) + (144 (-83 + Complex[0, -7] 3^Rational[1, 2]) + 
           Complex[0, -6912] (Complex[0, -2] + 
             5 3^Rational[1, 2]) $CellContext`\[Zeta]$[1][
             0] + $CellContext`u ((-288) (Complex[0, -99] + 
               52 3^Rational[1, 2]) - 
             3456 (Complex[0, 9] + 17 3^Rational[1, 2]) $CellContext`\[Zeta]$[
              1][0])) $CellContext`\[Eta]0$[1, 5][1] + (
           48 (Complex[0, -453] + 17 3^Rational[1, 2]) + 
           3456 (Complex[0, 3] + 3^Rational[1, 2]) $CellContext`\[Zeta]$[1][
             0] + $CellContext`u (
             288 (-103 + Complex[0, -48] 3^Rational[1, 2]) + 
             20736 $CellContext`\[Zeta]$[1][0])) $CellContext`\[Eta]0$[1, 6][
           1] + (2160 (1 + Complex[0, 3] 3^Rational[1, 2]) + 
           2160 (Complex[0, 3] + 
             5 3^Rational[1, 2]) $CellContext`u) $CellContext`\[Eta]0$[1, 7][
           1] + ((-504) (Complex[0, 3] + 3^Rational[1, 2]) - 
           3024 $CellContext`u) $CellContext`\[Eta]0$[1, 8][
           1] + ((-5616) (Complex[0, -1] + 3^Rational[1, 2]) + 
           1728 (Complex[0, 21] - 17 3^Rational[1, 2]) $CellContext`\[Zeta]$[
             1][0] + $CellContext`u (
             864 (19 + Complex[0, 18] 3^Rational[1, 2]) + 
             10368 (1 + Complex[0, 6] 3^Rational[1, 2]) $CellContext`\[Zeta]$[
               1][0])) $CellContext`\[Eta]0$[2, 3][1] + (
           72 (-337 + Complex[0, 7] 3^Rational[1, 2]) + 
           1728 (7 + Complex[0, -5] 3^Rational[1, 2]) $CellContext`\[Zeta]$[
             1][0] + $CellContext`u (Complex[0, 36288] - 14544 
             3^Rational[1, 2] - 
             3456 (Complex[0, 9] + 2 3^Rational[1, 2]) $CellContext`\[Zeta]$[
              1][0])) $CellContext`\[Eta]0$[2, 4][1] + (Complex[0, -7920] + 
           8304 3^Rational[1, 2] + 
           288 (2 + Complex[0, -57] 
              3^Rational[1, 2]) $CellContext`u) $CellContext`\[Eta]0$[2, 5][
           1] + (Complex[0, 288] (Complex[0, 7] + 5 3^Rational[1, 2]) + 
           576 (Complex[0, 9] + 
             2 3^Rational[1, 2]) $CellContext`u) $CellContext`\[Eta]0$[2, 6][
           1] + (48 (Complex[0, -21] + 71 3^Rational[1, 2]) + 
           864 (Complex[0, 3] + 3^Rational[1, 2]) $CellContext`\[Zeta]$[1][
             0] + $CellContext`u (2016 (2 + Complex[0, -3] 3^Rational[1, 2]) + 
             5184 $CellContext`\[Zeta]$[1][0])) $CellContext`\[Eta]0$[3, 4][
           1] + (144 (1 + Complex[0, 7] 3^Rational[1, 2]) + 
           144 (Complex[0, 9] + 
             11 3^Rational[1, 2]) $CellContext`u) $CellContext`\[Eta]0$[3, 5][
           1] + ((-144) (Complex[0, 3] + 3^Rational[1, 2]) - 
           864 $CellContext`u) $CellContext`\[Eta]0$[3, 6][1] + (
           72 (Complex[0, 3] + 3^Rational[1, 2]) + 
           432 $CellContext`u) $CellContext`\[Eta]0$[4, 5][1] + (
           31104 (5 + Complex[0, -1] 3^Rational[1, 2]) + $CellContext`u (
             Complex[0, -311040] + 
             Complex[0, -373248] $CellContext`\[Zeta]$[1][0]) + 
           62208 (3 + Complex[0, -1] 3^Rational[1, 2]) $CellContext`\[Zeta]$[
             1][0]) $CellContext`\[Eta]0$[1, 1, 2][
           1] + ((-10368) (Complex[0, -5] + 3^Rational[1, 2]) - 
           62208 (Complex[0, -1] + 3^Rational[1, 2]) $CellContext`\[Zeta]$[1][
            0] + $CellContext`u (10368 (9 + Complex[0, 5] 3^Rational[1, 2]) + 
             Complex[0, 124416] 
              3^Rational[1, 2] $CellContext`\[Zeta]$[1][
               0])) $CellContext`\[Eta]0$[1, 1, 3][1] + (
           Complex[0, -3456] (Complex[0, -12] + 
             3^Rational[1, 2]) + $CellContext`u ((-10368) (Complex[0, -5] + 
               3 3^Rational[1, 2]) + 
             Complex[0, -62208] $CellContext`\[Zeta]$[1][0]) + 
           10368 (3 + Complex[0, -1] 3^Rational[1, 2]) $CellContext`\[Zeta]$[
             1][0]) $CellContext`\[Eta]0$[1, 1, 4][1] + $CellContext`\[Eta]0$[
           1][1] (Complex[0, 720576] + 
           Complex[0, 995328] $CellContext`\[Zeta]$[1][0] + 
           Complex[0, 373248] $CellContext`\[Zeta]$[1][0]^2 + 
           Complex[0, 93312] $CellContext`\[Zeta]$[3][
             0] + ((-2592) (Complex[0, 11] + 3^Rational[1, 2]) + 
             Complex[0, -5184] (Complex[0, -9] + 
               2 3^Rational[1, 2]) $CellContext`u) $CellContext`\[Eta]0$[2][
              1]^2 + (1296 (Complex[0, -1] + 3^Rational[1, 2]) + 
             Complex[0, -2592] 
              3^Rational[1, 2] $CellContext`u) $CellContext`\[Eta]0$[3][
              1]^2 + (144 (Complex[0, -207] + 70 3^Rational[1, 2]) + 
             6912 (Complex[0, -12] + 3^Rational[1, 2]) $CellContext`\[Zeta]$[
               1][0] + 10368 (Complex[0, 3] + 
               3^Rational[1, 2]) $CellContext`\[Zeta]$[1][0]^2 + 
             2592 (Complex[0, 3] + 3^Rational[1, 2]) $CellContext`\[Zeta]$[3][
               0] + $CellContext`u (
               2592 (-21 + Complex[0, -10] 3^Rational[1, 2]) + 
               Complex[0, -20736] (Complex[0, -5] + 
                 3 3^Rational[1, 2]) $CellContext`\[Zeta]$[1][0] + 
               62208 $CellContext`\[Zeta]$[1][0]^2 + 
               15552 $CellContext`\[Zeta]$[3][0])) $CellContext`\[Eta]0$[4][
             1] + $CellContext`\[Eta]0$[3][1] (
             Complex[0, 864] (Complex[0, 96] + 13 3^Rational[1, 2]) + 
             Complex[0, -20736] (Complex[0, -5] + 
               3^Rational[1, 2]) $CellContext`\[Zeta]$[1][0] + 
             Complex[0, -62208] (Complex[0, -1] + 
               3^Rational[1, 2]) $CellContext`\[Zeta]$[1][0]^2 + 
             Complex[0, -15552] (Complex[0, -1] + 
               3^Rational[1, 2]) $CellContext`\[Zeta]$[3][
               0] + $CellContext`u ((-8640) (Complex[0, -18] + 
                 3^Rational[1, 2]) - 
               20736 (Complex[0, -9] + 
                5 3^Rational[1, 2]) $CellContext`\[Zeta]$[1][0] - 124416 
               3^Rational[1, 2] $CellContext`\[Zeta]$[1][0]^2 - 31104 
               3^Rational[1, 2] $CellContext`\[Zeta]$[3][0]) + (
               Complex[0, 432] (Complex[0, 3] + 3^Rational[1, 2]) + 
               Complex[0, 2592] $CellContext`u) $CellContext`\[Eta]0$[4][
               1]) + $CellContext`\[Eta]0$[2][1] (
             2592 (Complex[0, 43] + 10 3^Rational[1, 2]) + 
             62208 (Complex[0, 5] + 3^Rational[1, 2]) $CellContext`\[Zeta]$[
               1][0] + 62208 (Complex[0, 3] + 
               3^Rational[1, 2]) $CellContext`\[Zeta]$[1][0]^2 + 
             15552 (Complex[0, 3] + 3^Rational[1, 2]) $CellContext`\[Zeta]$[
               3][0] + $CellContext`u (222912 + 
               622080 $CellContext`\[Zeta]$[1][0] + 
               373248 $CellContext`\[Zeta]$[1][0]^2 + 
               93312 $CellContext`\[Zeta]$[3][0]) + (
               Complex[0, 3456] (Complex[0, 3] + 3^Rational[1, 2]) + 
               Complex[0, 20736] $CellContext`u) $CellContext`\[Eta]0$[3][
               1] + (1728 (Complex[0, -1] + 3^Rational[1, 2]) + 
               Complex[0, -3456] 
                3^Rational[1, 2] $CellContext`u) $CellContext`\[Eta]0$[4][
               1]) + (144 (83 + Complex[0, 7] 3^Rational[1, 2]) + 
             6912 (2 + Complex[0, 5] 3^Rational[1, 2]) $CellContext`\[Zeta]$[
               1][0] + $CellContext`u (
               288 (Complex[0, -99] + 52 3^Rational[1, 2]) + 
               3456 (Complex[0, 9] + 
                 17 3^Rational[1, 2]) $CellContext`\[Zeta]$[1][
                 0])) $CellContext`\[Eta]0$[5][1] + (Complex[0, 23040] - 2112 
             3^Rational[1, 2] + $CellContext`u (
               288 (103 + Complex[0, 57] 3^Rational[1, 2]) - 
               20736 $CellContext`\[Zeta]$[1][0]) - 
             3456 (Complex[0, 3] + 3^Rational[1, 2]) $CellContext`\[Zeta]$[1][
              0]) $CellContext`\[Eta]0$[6][1] + (
             2160 (-1 + Complex[0, -3] 3^Rational[1, 2]) - 
             2160 (Complex[0, 3] + 
              5 3^Rational[1, 2]) $CellContext`u) $CellContext`\[Eta]0$[7][
             1] + (504 (Complex[0, 3] + 3^Rational[1, 2]) + 
             3024 $CellContext`u) $CellContext`\[Eta]0$[8][1] + (
             Complex[0, 31104] (Complex[0, 5] + 
               3^Rational[1, 2]) + $CellContext`u (Complex[0, 311040] + 
               Complex[0, 373248] $CellContext`\[Zeta]$[1][0]) + 
             Complex[0, 62208] (Complex[0, 3] + 
               3^Rational[1, 2]) $CellContext`\[Zeta]$[1][
               0]) $CellContext`\[Eta]0$[1, 2][1] + (
             10368 (Complex[0, -5] + 3^Rational[1, 2]) + 
             62208 (Complex[0, -1] + 3^Rational[1, 2]) $CellContext`\[Zeta]$[
               1][0] + $CellContext`u (
               10368 (-9 + Complex[0, -5] 3^Rational[1, 2]) + 
               Complex[0, -124416] 
                3^Rational[1, 2] $CellContext`\[Zeta]$[1][
                 0])) $CellContext`\[Eta]0$[1, 3][1] + (
             3456 (12 + Complex[0, 1] 3^Rational[1, 2]) + $CellContext`u (
               10368 (Complex[0, -5] + 3 3^Rational[1, 2]) + 
               Complex[0, 62208] $CellContext`\[Zeta]$[1][0]) + 
             Complex[0, 10368] (Complex[0, 3] + 
               3^Rational[1, 2]) $CellContext`\[Zeta]$[1][
               0]) $CellContext`\[Eta]0$[1, 4][
             1] + ((-3456) (Complex[0, -2] + 5 3^Rational[1, 2]) + 
             Complex[0, 1728] (Complex[0, 9] + 
               17 3^Rational[1, 2]) $CellContext`u) $CellContext`\[Eta]0$[
             1, 5][1] + (1728 (3 + Complex[0, -1] 3^Rational[1, 2]) + 
             Complex[0, -10368] $CellContext`u) $CellContext`\[Eta]0$[1, 6][
             1] + (864 (21 + Complex[0, 17] 3^Rational[1, 2]) + 
             5184 (Complex[0, -1] + 
               6 3^Rational[1, 2]) $CellContext`u) $CellContext`\[Eta]0$[
             2, 3][1] + ((-864) (Complex[0, 7] + 5 3^Rational[1, 2]) + 
             Complex[0, 1728] (Complex[0, 9] + 
               2 3^Rational[1, 2]) $CellContext`u) $CellContext`\[Eta]0$[
             2, 4][1] + (432 (3 + Complex[0, -1] 3^Rational[1, 2]) + 
             Complex[0, -2592] $CellContext`u) $CellContext`\[Eta]0$[3, 4][
             1] + ((-31104) (Complex[0, 3] + 3^Rational[1, 2]) - 
             186624 $CellContext`u) $CellContext`\[Eta]0$[1, 1, 2][1] + (
             31104 (1 + Complex[0, 1] 3^Rational[1, 2]) + 
             62208 3^Rational[1, 2] $CellContext`u) $CellContext`\[Eta]0$[
             1, 1, 3][1] + ((-5184) (Complex[0, 3] + 3^Rational[1, 2]) - 
             31104 $CellContext`u) $CellContext`\[Eta]0$[1, 1, 4][1]) + (
           3456 (Complex[0, -2] + 5 3^Rational[1, 2]) + 
           1728 (9 + Complex[0, -17] 
              3^Rational[1, 2]) $CellContext`u) $CellContext`\[Eta]0$[
           1, 1, 5][1] + (Complex[0, 1728] (Complex[0, 3] + 3^Rational[1, 2]) + 
           Complex[0, 10368] $CellContext`u) $CellContext`\[Eta]0$[1, 1, 6][
           1] + (5184 (Complex[0, 11] + 3^Rational[1, 2]) + 
           10368 (9 + 
             Complex[0, 2] 
              3^Rational[1, 2]) $CellContext`u) $CellContext`\[Eta]0$[
           1, 2, 2][1] + (864 (-21 + Complex[0, -17] 3^Rational[1, 2]) - 
           5184 (Complex[0, -1] + 
            6 3^Rational[1, 2]) $CellContext`u) $CellContext`\[Eta]0$[
           1, 2, 3][1] + (864 (Complex[0, 7] + 5 3^Rational[1, 2]) + 
           1728 (9 + Complex[0, -2] 
              3^Rational[1, 2]) $CellContext`u) $CellContext`\[Eta]0$[
           1, 2, 4][1] + ((-2592) (Complex[0, -1] + 3^Rational[1, 2]) + 
           Complex[0, 5184] 
            3^Rational[1, 2] $CellContext`u) $CellContext`\[Eta]0$[1, 3, 3][
           1] + (Complex[0, 432] (Complex[0, 3] + 3^Rational[1, 2]) + 
           Complex[0, 2592] $CellContext`u) $CellContext`\[Eta]0$[1, 3, 4][
           1] + (15552 (Complex[0, 3] + 3^Rational[1, 2]) + 
           93312 $CellContext`u) $CellContext`\[Eta]0$[2, 1, 2][1] + (
           1728 (-15 + Complex[0, -7] 3^Rational[1, 2]) - 
           10368 (Complex[0, -2] + 
            3 3^Rational[1, 2]) $CellContext`u) $CellContext`\[Eta]0$[
           2, 1, 3][1] + (864 (Complex[0, 7] + 5 3^Rational[1, 2]) + 
           1728 (9 + Complex[0, -2] 
              3^Rational[1, 2]) $CellContext`u) $CellContext`\[Eta]0$[
           2, 1, 4][1] + (Complex[0, 432] (Complex[0, 3] + 3^Rational[1, 2]) + 
           Complex[0, 2592] $CellContext`u) $CellContext`\[Eta]0$[3, 1, 4][
           1] + (31104 (Complex[0, 3] + 3^Rational[1, 2]) + 
           186624 $CellContext`u) $CellContext`\[Eta]0$[1, 1, 1, 2][1] + (
           Complex[0, -31104] (Complex[0, -1] + 3^Rational[1, 2]) - 62208 
           3^Rational[1, 2] $CellContext`u) $CellContext`\[Eta]0$[1, 1, 1, 3][
           1] + (5184 (Complex[0, 3] + 3^Rational[1, 2]) + 
           31104 $CellContext`u) $CellContext`\[Eta]0$[1, 1, 1, 4][1] + (
           2592 (Complex[0, 11] + 3^Rational[1, 2]) + 
           5184 (9 + Complex[0, 2] 
              3^Rational[1, 2]) $CellContext`u) $CellContext`\[Eta]0$[2][
            1]^2 $CellContext`\[Eta]0$b[
           1][-1] + ((-1296) (Complex[0, -1] + 3^Rational[1, 2]) + 
           Complex[0, 2592] 
            3^Rational[1, 2] $CellContext`u) $CellContext`\[Eta]0$[3][
            1]^2 $CellContext`\[Eta]0$b[1][-1] + (
           144 (-83 + Complex[0, -7] 3^Rational[1, 2]) + 
           Complex[0, -6912] (Complex[0, -2] + 
             5 3^Rational[1, 2]) $CellContext`\[Zeta]$[1][
             0] + $CellContext`u ((-288) (Complex[0, -99] + 
               52 3^Rational[1, 2]) - 
             3456 (Complex[0, 9] + 17 3^Rational[1, 2]) $CellContext`\[Zeta]$[
              1][0])) $CellContext`\[Eta]0$[5][1] $CellContext`\[Eta]0$b[
           1][-1] + (192 (Complex[0, -120] + 11 3^Rational[1, 2]) + 
           3456 (Complex[0, 3] + 3^Rational[1, 2]) $CellContext`\[Zeta]$[1][
             0] + $CellContext`u (
             288 (-103 + Complex[0, -57] 3^Rational[1, 2]) + 
             20736 $CellContext`\[Zeta]$[1][0])) $CellContext`\[Eta]0$[6][
           1] $CellContext`\[Eta]0$b[1][-1] + (
           2160 (1 + Complex[0, 3] 3^Rational[1, 2]) + 
           2160 (Complex[0, 3] + 
             5 3^Rational[1, 2]) $CellContext`u) $CellContext`\[Eta]0$[7][
           1] $CellContext`\[Eta]0$b[
           1][-1] + ((-504) (Complex[0, 3] + 3^Rational[1, 2]) - 
           3024 $CellContext`u) $CellContext`\[Eta]0$[8][
           1] $CellContext`\[Eta]0$b[1][-1] + (
           31104 (5 + Complex[0, -1] 3^Rational[1, 2]) + $CellContext`u (
             Complex[0, -311040] + 
             Complex[0, -373248] $CellContext`\[Zeta]$[1][0]) + 
           62208 (3 + Complex[0, -1] 3^Rational[1, 2]) $CellContext`\[Zeta]$[
             1][0]) $CellContext`\[Eta]0$[1, 2][1] $CellContext`\[Eta]0$b[
           1][-1] + ((-10368) (Complex[0, -5] + 3^Rational[1, 2]) - 
           62208 (Complex[0, -1] + 3^Rational[1, 2]) $CellContext`\[Zeta]$[1][
            0] + $CellContext`u (10368 (9 + Complex[0, 5] 3^Rational[1, 2]) + 
             Complex[0, 124416] 
              3^Rational[1, 2] $CellContext`\[Zeta]$[1][
               0])) $CellContext`\[Eta]0$[1, 3][1] $CellContext`\[Eta]0$b[
           1][-1] + (
           Complex[0, -3456] (Complex[0, -12] + 
             3^Rational[1, 2]) + $CellContext`u ((-10368) (Complex[0, -5] + 
               3 3^Rational[1, 2]) + 
             Complex[0, -62208] $CellContext`\[Zeta]$[1][0]) + 
           10368 (3 + Complex[0, -1] 3^Rational[1, 2]) $CellContext`\[Zeta]$[
             1][0]) $CellContext`\[Eta]0$[1, 4][1] $CellContext`\[Eta]0$b[
           1][-1] + (3456 (Complex[0, -2] + 5 3^Rational[1, 2]) + 
           1728 (9 + Complex[0, -17] 
              3^Rational[1, 2]) $CellContext`u) $CellContext`\[Eta]0$[1, 5][
           1] $CellContext`\[Eta]0$b[1][-1] + (
           Complex[0, 1728] (Complex[0, 3] + 3^Rational[1, 2]) + 
           Complex[0, 10368] $CellContext`u) $CellContext`\[Eta]0$[1, 6][
           1] $CellContext`\[Eta]0$b[1][-1] + (
           864 (-21 + Complex[0, -17] 3^Rational[1, 2]) - 
           5184 (Complex[0, -1] + 
            6 3^Rational[1, 2]) $CellContext`u) $CellContext`\[Eta]0$[2, 3][
           1] $CellContext`\[Eta]0$b[1][-1] + (
           864 (Complex[0, 7] + 5 3^Rational[1, 2]) + 
           1728 (9 + Complex[0, -2] 
              3^Rational[1, 2]) $CellContext`u) $CellContext`\[Eta]0$[2, 4][
           1] $CellContext`\[Eta]0$b[1][-1] + (
           Complex[0, 432] (Complex[0, 3] + 3^Rational[1, 2]) + 
           Complex[0, 2592] $CellContext`u) $CellContext`\[Eta]0$[3, 4][
           1] $CellContext`\[Eta]0$b[1][-1] + (
           31104 (Complex[0, 3] + 3^Rational[1, 2]) + 
           186624 $CellContext`u) $CellContext`\[Eta]0$[1, 1, 2][
           1] $CellContext`\[Eta]0$b[1][-1] + (
           Complex[0, -31104] (Complex[0, -1] + 3^Rational[1, 2]) - 62208 
           3^Rational[1, 2] $CellContext`u) $CellContext`\[Eta]0$[1, 1, 3][
           1] $CellContext`\[Eta]0$b[1][-1] + (
           5184 (Complex[0, 3] + 3^Rational[1, 2]) + 
           31104 $CellContext`u) $CellContext`\[Eta]0$[1, 1, 4][
           1] $CellContext`\[Eta]0$b[1][-1] + (
           15552 (5 + Complex[0, -1] 3^Rational[1, 2]) + $CellContext`u (
             Complex[0, -155520] + 
             Complex[0, -186624] $CellContext`\[Zeta]$[1][0]) + 
           31104 (3 + Complex[0, -1] 3^Rational[1, 2]) $CellContext`\[Zeta]$[
             1][0]) $CellContext`\[Eta]0$[2][
           1] $CellContext`\[Eta]0$b[
            1][-1]^2 + ((-5184) (Complex[0, -5] + 3^Rational[1, 2]) - 
           31104 (Complex[0, -1] + 3^Rational[1, 2]) $CellContext`\[Zeta]$[1][
            0] + $CellContext`u (5184 (9 + Complex[0, 5] 3^Rational[1, 2]) + 
             Complex[0, 62208] 
              3^Rational[1, 2] $CellContext`\[Zeta]$[1][
               0])) $CellContext`\[Eta]0$[3][
           1] $CellContext`\[Eta]0$b[1][-1]^2 + (
           Complex[0, -1728] (Complex[0, -12] + 
             3^Rational[1, 2]) + $CellContext`u ((-5184) (Complex[0, -5] + 
               3 3^Rational[1, 2]) + 
             Complex[0, -31104] $CellContext`\[Zeta]$[1][0]) + 
           5184 (3 + Complex[0, -1] 3^Rational[1, 2]) $CellContext`\[Zeta]$[
             1][0]) $CellContext`\[Eta]0$[4][
           1] $CellContext`\[Eta]0$b[1][-1]^2 + (
           1728 (Complex[0, -2] + 5 3^Rational[1, 2]) + 
           864 (9 + Complex[0, -17] 
              3^Rational[1, 2]) $CellContext`u) $CellContext`\[Eta]0$[5][
           1] $CellContext`\[Eta]0$b[1][-1]^2 + (
           Complex[0, 864] (Complex[0, 3] + 3^Rational[1, 2]) + 
           Complex[0, 5184] $CellContext`u) $CellContext`\[Eta]0$[6][
           1] $CellContext`\[Eta]0$b[1][-1]^2 + (
           15552 (Complex[0, 3] + 3^Rational[1, 2]) + 
           93312 $CellContext`u) $CellContext`\[Eta]0$[1, 2][
           1] $CellContext`\[Eta]0$b[1][-1]^2 + (
           Complex[0, -15552] (Complex[0, -1] + 3^Rational[1, 2]) - 31104 
           3^Rational[1, 2] $CellContext`u) $CellContext`\[Eta]0$[1, 3][
           1] $CellContext`\[Eta]0$b[1][-1]^2 + (
           2592 (Complex[0, 3] + 3^Rational[1, 2]) + 
           15552 $CellContext`u) $CellContext`\[Eta]0$[1, 4][
           1] $CellContext`\[Eta]0$b[1][-1]^2 + (
           5184 (Complex[0, 3] + 3^Rational[1, 2]) + 
           31104 $CellContext`u) $CellContext`\[Eta]0$[2][
           1] $CellContext`\[Eta]0$b[1][-1]^3 + (
           Complex[0, -5184] (Complex[0, -1] + 3^Rational[1, 2]) - 10368 
           3^Rational[1, 2] $CellContext`u) $CellContext`\[Eta]0$[3][
           1] $CellContext`\[Eta]0$b[1][-1]^3 + (
           864 (Complex[0, 3] + 3^Rational[1, 2]) + 
           5184 $CellContext`u) $CellContext`\[Eta]0$[4][
           1] $CellContext`\[Eta]0$b[1][-1]^3 + (
           15552 (5 + Complex[0, 1] 3^Rational[1, 2]) + $CellContext`u (
             Complex[0, -155520] + 
             Complex[0, -186624] $CellContext`\[Zeta]$[1][0]) + 
           31104 (3 + Complex[0, 1] 3^Rational[1, 2]) $CellContext`\[Zeta]$[
             1][0]) $CellContext`\[Eta]0$[1][1]^2 $CellContext`\[Eta]0$b[
           2][-1] + (5184 (Complex[0, -3] + 3^Rational[1, 2]) - 
           31104 $CellContext`u) $CellContext`\[Eta]0$[1][
            1]^3 $CellContext`\[Eta]0$b[2][-1] + (-18144 - 
           41472 $CellContext`\[Zeta]$[1][0]) $CellContext`\[Eta]0$[2][
           1] $CellContext`\[Eta]0$b[2][-1] + (
           144 (Complex[0, -33] + 41 3^Rational[1, 2]) + 
           1728 (Complex[0, 3] + 7 3^Rational[1, 2]) $CellContext`\[Zeta]$[1][
             0] + $CellContext`u (864 (1 + Complex[0, -12] 3^Rational[1, 2]) + 
             10368 $CellContext`\[Zeta]$[1][0])) $CellContext`\[Eta]0$[3][
           1] $CellContext`\[Eta]0$b[2][-1] + (
           72 (23 + Complex[0, 31] 3^Rational[1, 2]) + 
           Complex[0, -3456] (Complex[0, -1] + 
             3^Rational[1, 2]) $CellContext`\[Zeta]$[1][0] + $CellContext`u (
             144 (Complex[0, 72] + 7 3^Rational[1, 2]) - 6912 
             3^Rational[1, 2] $CellContext`\[Zeta]$[1][
              0])) $CellContext`\[Eta]0$[4][1] $CellContext`\[Eta]0$b[
           2][-1] + ((-48) (Complex[0, 93] + 25 3^Rational[1, 2]) + 
           288 (-25 + 
             Complex[0, -6] 
              3^Rational[1, 2]) $CellContext`u) $CellContext`\[Eta]0$[5][
           1] $CellContext`\[Eta]0$b[2][-1] + (
           576 (1 + Complex[0, 1] 3^Rational[1, 2]) + 
           1152 3^Rational[1, 2] $CellContext`u) $CellContext`\[Eta]0$[6][
           1] $CellContext`\[Eta]0$b[2][-1] + (
           10368 (Complex[0, -1] + 3^Rational[1, 2]) + 
           Complex[0, -20736] 
            3^Rational[1, 2] $CellContext`u) $CellContext`\[Eta]0$[1, 2][
           1] $CellContext`\[Eta]0$b[2][-1] + (
           Complex[0, 3456] (Complex[0, 3] + 3^Rational[1, 2]) + 
           Complex[0, 20736] $CellContext`u) $CellContext`\[Eta]0$[1, 3][
           1] $CellContext`\[Eta]0$b[2][-1] + (
           1728 (Complex[0, -1] + 3^Rational[1, 2]) + 
           Complex[0, -3456] 
            3^Rational[1, 2] $CellContext`u) $CellContext`\[Eta]0$[1, 4][
           1] $CellContext`\[Eta]0$b[2][-1] + (
           216 (201 + Complex[0, -1] 3^Rational[1, 2]) + 
           5184 (11 + Complex[0, 1] 3^Rational[1, 2]) $CellContext`\[Zeta]$[
             1][0] + $CellContext`u ((-432) (Complex[0, 180] + 
               37 3^Rational[1, 2]) - 
             10368 (Complex[0, 9] + 2 3^Rational[1, 2]) $CellContext`\[Zeta]$[
              1][0])) $CellContext`\[Eta]0$b[2][-1]^2 + (
           2592 (Complex[0, -11] + 3^Rational[1, 2]) + 
           Complex[0, 5184] (Complex[0, 9] + 
             2 3^Rational[1, 2]) $CellContext`u) $CellContext`\[Eta]0$[1][
           1] $CellContext`\[Eta]0$b[
            2][-1]^2 + ((-5184) (Complex[0, 5] + 3^Rational[1, 2]) - 
           31104 (Complex[0, 1] + 3^Rational[1, 2]) $CellContext`\[Zeta]$[1][
            0] + $CellContext`u (
             Complex[0, 5184] (Complex[0, 9] + 5 3^Rational[1, 2]) + 
             Complex[0, 62208] 
              3^Rational[1, 2] $CellContext`\[Zeta]$[1][
               0])) $CellContext`\[Eta]0$[1][1]^2 $CellContext`\[Eta]0$b[
           3][-1] + (Complex[0, 5184] (Complex[0, 1] + 3^Rational[1, 2]) + 
           10368 3^Rational[1, 2] $CellContext`u) $CellContext`\[Eta]0$[1][
            1]^3 $CellContext`\[Eta]0$b[3][-1] + (
           144 (Complex[0, 33] + 41 3^Rational[1, 2]) + $CellContext`u (
             864 (-1 + Complex[0, -12] 3^Rational[1, 2]) - 
             10368 $CellContext`\[Zeta]$[1][0]) + 
           1728 (Complex[0, -3] + 7 3^Rational[1, 2]) $CellContext`\[Zeta]$[
             1][0]) $CellContext`\[Eta]0$[2][1] $CellContext`\[Eta]0$b[
           3][-1] + (-4608 + Complex[0, 15552] $CellContext`u - 
           10368 $CellContext`\[Zeta]$[1][0]) $CellContext`\[Eta]0$[3][
           1] $CellContext`\[Eta]0$b[
           3][-1] + ((-48) (Complex[0, 39] + 19 3^Rational[1, 2]) + 
           864 (Complex[0, 3] + 3^Rational[1, 2]) $CellContext`\[Zeta]$[1][
             0] + $CellContext`u (288 (-4 + Complex[0, -9] 3^Rational[1, 2]) + 
             5184 $CellContext`\[Zeta]$[1][0])) $CellContext`\[Eta]0$[4][
           1] $CellContext`\[Eta]0$b[3][-1] + (
           1008 (1 + Complex[0, 1] 3^Rational[1, 2]) + 
           144 (Complex[0, 9] + 
             11 3^Rational[1, 2]) $CellContext`u) $CellContext`\[Eta]0$[5][
           1] $CellContext`\[Eta]0$b[
           3][-1] + ((-144) (Complex[0, 3] + 3^Rational[1, 2]) - 
           864 $CellContext`u) $CellContext`\[Eta]0$[6][
           1] $CellContext`\[Eta]0$b[3][-1] + (
           Complex[0, 2592] (Complex[0, 3] + 3^Rational[1, 2]) + 
           Complex[0, 15552] $CellContext`u) $CellContext`\[Eta]0$[1, 2][
           1] $CellContext`\[Eta]0$b[3][-1] + (
           2592 (Complex[0, -1] + 3^Rational[1, 2]) + 
           Complex[0, -5184] 
            3^Rational[1, 2] $CellContext`u) $CellContext`\[Eta]0$[1, 3][
           1] $CellContext`\[Eta]0$b[3][-1] + (
           Complex[0, 432] (Complex[0, 3] + 3^Rational[1, 2]) + 
           Complex[0, 2592] $CellContext`u) $CellContext`\[Eta]0$[1, 4][
           1] $CellContext`\[Eta]0$b[3][-1] + (
           288 (-23 + Complex[0, 5] 3^Rational[1, 2]) + 
           2592 (1 + Complex[0, -1] 3^Rational[1, 2]) $CellContext`\[Zeta]$[
             1][0] + $CellContext`u (720 (Complex[0, 9] + 7 3^Rational[1, 2]) - 
             5184 3^Rational[1, 2] $CellContext`\[Zeta]$[1][
              0])) $CellContext`\[Eta]0$b[
            3][-1]^2 + ((-1296) (Complex[0, 1] + 3^Rational[1, 2]) + 
           Complex[0, 2592] 
            3^Rational[1, 2] $CellContext`u) $CellContext`\[Eta]0$[1][
           1] $CellContext`\[Eta]0$b[3][-1]^2 + $CellContext`\[Eta]0$[4][
           1] $CellContext`\[Eta]0$b[1][-1] (
           144 (Complex[0, 207] - 70 3^Rational[1, 2]) - 
           6912 (Complex[0, -12] + 3^Rational[1, 2]) $CellContext`\[Zeta]$[1][
            0] - 10368 (Complex[0, 3] + 
            3^Rational[1, 2]) $CellContext`\[Zeta]$[1][0]^2 + $CellContext`u (
             2592 (21 + Complex[0, 10] 3^Rational[1, 2]) + 
             20736 (5 + Complex[0, 3] 3^Rational[1, 2]) $CellContext`\[Zeta]$[
               1][0] - 62208 $CellContext`\[Zeta]$[1][0]^2 - 
             15552 $CellContext`\[Zeta]$[3][0]) - 
           2592 (Complex[0, 3] + 3^Rational[1, 2]) $CellContext`\[Zeta]$[3][
            0] + (1728 (Complex[0, -1] + 3^Rational[1, 2]) + 
             Complex[0, -3456] 
              3^Rational[1, 2] $CellContext`u) $CellContext`\[Eta]0$b[
             2][-1] + (Complex[0, 432] (Complex[0, 3] + 3^Rational[1, 2]) + 
             Complex[0, 2592] $CellContext`u) $CellContext`\[Eta]0$b[
             3][-1]) + (312 (-15 + Complex[0, -7] 3^Rational[1, 2]) + 
           6912 (12 + 
             Complex[0, -1] 3^Rational[1, 2]) $CellContext`\[Zeta]$[1][0]^2 + 
           Complex[0, -6912] (Complex[0, -3] + 
             3^Rational[1, 2]) $CellContext`\[Zeta]$[1][0]^3 + 
           216 (115 + Complex[0, -1] 3^Rational[1, 2]) $CellContext`\[Zeta]$[
             3][0] + $CellContext`\[Zeta]$[1][0] (
             288 (207 + Complex[0, -70] 3^Rational[1, 2]) + 
             Complex[0, -5184] (Complex[0, -3] + 
               3^Rational[1, 2]) $CellContext`\[Zeta]$[3][
               0]) + $CellContext`u ((-144) (Complex[0, 7] + 
               30 3^Rational[1, 2]) - 
             20736 (Complex[0, 5] + 
              3 3^Rational[1, 2]) $CellContext`\[Zeta]$[1][0]^2 + 
             Complex[0, 41472] $CellContext`\[Zeta]$[1][
                0]^3 + $CellContext`\[Zeta]$[1][
               0] ((-5184) (Complex[0, 21] + 10 3^Rational[1, 2]) + 
               Complex[0, 31104] $CellContext`\[Zeta]$[3][0]) - 
             432 (Complex[0, 79] + 36 3^Rational[1, 2]) $CellContext`\[Zeta]$[
              3][0] + Complex[0, 8640] $CellContext`\[Zeta]$[5][0]) + 
           Complex[0, -1440] (Complex[0, -3] + 
             3^Rational[1, 2]) $CellContext`\[Zeta]$[5][
             0]) $CellContext`\[Eta]0$b[4][-1] + (
           Complex[0, 1728] (Complex[0, 12] + 
             3^Rational[1, 2]) + $CellContext`u (
             5184 (Complex[0, 5] + 3 3^Rational[1, 2]) + 
             Complex[0, -31104] $CellContext`\[Zeta]$[1][0]) + 
           5184 (3 + Complex[0, 1] 3^Rational[1, 2]) $CellContext`\[Zeta]$[1][
             0]) $CellContext`\[Eta]0$[1][1]^2 $CellContext`\[Eta]0$b[
           4][-1] + (864 (Complex[0, -3] + 3^Rational[1, 2]) - 
           5184 $CellContext`u) $CellContext`\[Eta]0$[1][
            1]^3 $CellContext`\[Eta]0$b[4][-1] + (
           72 (23 + Complex[0, -31] 3^Rational[1, 2]) + 
           Complex[0, 3456] (Complex[0, 1] + 
             3^Rational[1, 2]) $CellContext`\[Zeta]$[1][
             0] + $CellContext`u ((-144) (Complex[0, -72] + 
               7 3^Rational[1, 2]) + 
             6912 3^Rational[1, 2] $CellContext`\[Zeta]$[1][
               0])) $CellContext`\[Eta]0$[2][1] $CellContext`\[Eta]0$b[
           4][-1] + (Complex[0, 1872] - 912 
           3^Rational[1, 2] + $CellContext`u (
             288 (4 + Complex[0, -9] 3^Rational[1, 2]) - 
             5184 $CellContext`\[Zeta]$[1][0]) + 
           864 (Complex[0, -3] + 3^Rational[1, 2]) $CellContext`\[Zeta]$[1][
             0]) $CellContext`\[Eta]0$[3][1] $CellContext`\[Eta]0$b[
           4][-1] + $CellContext`\[Eta]0$[1][
           1] ((-144) (Complex[0, 207] + 70 3^Rational[1, 2]) - 
           6912 (Complex[0, 12] + 3^Rational[1, 2]) $CellContext`\[Zeta]$[1][
            0] - 10368 (Complex[0, -3] + 
            3^Rational[1, 2]) $CellContext`\[Zeta]$[1][0]^2 - 
           2592 (Complex[0, -3] + 3^Rational[1, 2]) $CellContext`\[Zeta]$[3][
            0] + $CellContext`u (2592 (-21 + Complex[0, 10] 3^Rational[1, 2]) + 
             Complex[0, 20736] (Complex[0, 5] + 
               3 3^Rational[1, 2]) $CellContext`\[Zeta]$[1][0] + 
             62208 $CellContext`\[Zeta]$[1][0]^2 + 
             15552 $CellContext`\[Zeta]$[3][0]) + (
             1728 (Complex[0, 1] + 3^Rational[1, 2]) + 
             Complex[0, -3456] 
              3^Rational[1, 2] $CellContext`u) $CellContext`\[Eta]0$[2][1] + (
             Complex[0, -432] (Complex[0, -3] + 3^Rational[1, 2]) + 
             Complex[0, 2592] $CellContext`u) $CellContext`\[Eta]0$[3][
             1]) $CellContext`\[Eta]0$b[4][-1] + 
         864 $CellContext`\[Eta]0$[4][1] $CellContext`\[Eta]0$b[
           4][-1] + ((-72) (Complex[0, -3] + 3^Rational[1, 2]) + 
           432 $CellContext`u) $CellContext`\[Eta]0$[5][
           1] $CellContext`\[Eta]0$b[4][-1] + (-864 + 
           432 (Complex[0, 3] + 
             3^Rational[1, 2]) $CellContext`u) $CellContext`\[Eta]0$b[
            4][-1]^2 + $CellContext`\[Eta]0$[1][
           1] $CellContext`\[Eta]0$b[1][-1]^2 (
           Complex[0, -93312] + ((-15552) (Complex[0, 3] + 3^Rational[1, 2]) - 
             93312 $CellContext`u) $CellContext`\[Eta]0$[2][1] + (
             15552 (1 + Complex[0, 1] 3^Rational[1, 2]) + 
             31104 3^Rational[1, 2] $CellContext`u) $CellContext`\[Eta]0$[3][
             1] + ((-2592) (Complex[0, 3] + 3^Rational[1, 2]) - 
             15552 $CellContext`u) $CellContext`\[Eta]0$[4][1] + (
             15552 (Complex[0, -3] + 3^Rational[1, 2]) - 
             93312 $CellContext`u) $CellContext`\[Eta]0$b[2][-1] + (
             Complex[0, 15552] (Complex[0, 1] + 3^Rational[1, 2]) + 
             31104 3^Rational[1, 2] $CellContext`u) $CellContext`\[Eta]0$b[
             3][-1] + (2592 (Complex[0, -3] + 3^Rational[1, 2]) - 
             15552 $CellContext`u) $CellContext`\[Eta]0$b[
             4][-1]) + $CellContext`\[Eta]0$[1][1] $CellContext`\[Eta]0$b[
           3][-1] (864 (96 + Complex[0, 13] 3^Rational[1, 2]) + 
           20736 (5 + Complex[0, -1] 3^Rational[1, 2]) $CellContext`\[Zeta]$[
             1][0] + 62208 (1 + 
             Complex[0, -1] 3^Rational[1, 2]) $CellContext`\[Zeta]$[1][0]^2 + 
           15552 (1 + Complex[0, -1] 3^Rational[1, 2]) $CellContext`\[Zeta]$[
             3][0] + $CellContext`u ((-8640) (Complex[0, 18] + 
               3^Rational[1, 2]) - 
             20736 (Complex[0, 9] + 5 3^Rational[1, 2]) $CellContext`\[Zeta]$[
              1][0] - 124416 3^Rational[1, 2] $CellContext`\[Zeta]$[1][0]^2 - 
             31104 3^Rational[1, 2] $CellContext`\[Zeta]$[3][0]) + (
             864 (-3 + Complex[0, -7] 3^Rational[1, 2]) + 
             Complex[0, 5184] $CellContext`u) $CellContext`\[Eta]0$[2][1] + 
           Complex[0, 5184] $CellContext`\[Eta]0$[3][1] + (
             432 (3 + Complex[0, -1] 3^Rational[1, 2]) + 
             Complex[0, -2592] $CellContext`u) $CellContext`\[Eta]0$[4][1] + (
             432 (3 + Complex[0, 1] 3^Rational[1, 2]) + 
             Complex[0, -2592] $CellContext`u) $CellContext`\[Eta]0$b[
             4][-1]) + $CellContext`\[Eta]0$[3][1] $CellContext`\[Eta]0$b[
           1][-1] (864 (96 + Complex[0, -13] 3^Rational[1, 2]) + 
           20736 (5 + Complex[0, 1] 3^Rational[1, 2]) $CellContext`\[Zeta]$[
             1][0] + 62208 (1 + 
             Complex[0, 1] 3^Rational[1, 2]) $CellContext`\[Zeta]$[1][0]^2 + 
           15552 (1 + Complex[0, 1] 3^Rational[1, 2]) $CellContext`\[Zeta]$[
             3][0] + $CellContext`u (
             8640 (Complex[0, -18] + 3^Rational[1, 2]) + 
             20736 (Complex[0, -9] + 
               5 3^Rational[1, 2]) $CellContext`\[Zeta]$[1][0] + 
             124416 3^Rational[1, 2] $CellContext`\[Zeta]$[1][0]^2 + 
             31104 3^Rational[1, 2] $CellContext`\[Zeta]$[3][0]) + (
             432 (3 + Complex[0, -1] 3^Rational[1, 2]) + 
             Complex[0, -2592] $CellContext`u) $CellContext`\[Eta]0$[4][1] + (
             Complex[0, 864] (Complex[0, 3] + 7 3^Rational[1, 2]) + 
             Complex[0, 5184] $CellContext`u) $CellContext`\[Eta]0$b[2][-1] + 
           Complex[0, -5184] $CellContext`\[Eta]0$b[3][-1] + (
             432 (3 + Complex[0, 1] 3^Rational[1, 2]) + 
             Complex[0, -2592] $CellContext`u) $CellContext`\[Eta]0$b[
             4][-1]) + $CellContext`\[Eta]0$b[1][-1]^3 (
           Complex[0, 31104] + ((-5184) (Complex[0, -3] + 3^Rational[1, 2]) + 
             31104 $CellContext`u) $CellContext`\[Eta]0$b[2][-1] + (
             5184 (1 + Complex[0, -1] 3^Rational[1, 2]) - 10368 
             3^Rational[1, 2] $CellContext`u) $CellContext`\[Eta]0$b[
             3][-1] + ((-864) (Complex[0, -3] + 3^Rational[1, 2]) + 
             5184 $CellContext`u) $CellContext`\[Eta]0$b[
             4][-1]) + $CellContext`\[Eta]0$[1][1]^2 $CellContext`\[Eta]0$b[
           1][-1] (Complex[
            0, 93312] + (15552 (Complex[0, 3] + 3^Rational[1, 2]) + 
             93312 $CellContext`u) $CellContext`\[Eta]0$[2][1] + (
             Complex[0, -15552] (Complex[0, -1] + 3^Rational[1, 2]) - 31104 
             3^Rational[1, 2] $CellContext`u) $CellContext`\[Eta]0$[3][1] + (
             2592 (Complex[0, 3] + 3^Rational[1, 2]) + 
             15552 $CellContext`u) $CellContext`\[Eta]0$[4][
             1] + ((-15552) (Complex[0, -3] + 3^Rational[1, 2]) + 
             93312 $CellContext`u) $CellContext`\[Eta]0$b[2][-1] + (
             15552 (1 + Complex[0, -1] 3^Rational[1, 2]) - 31104 
             3^Rational[1, 2] $CellContext`u) $CellContext`\[Eta]0$b[
             3][-1] + ((-2592) (Complex[0, -3] + 3^Rational[1, 2]) + 
             15552 $CellContext`u) $CellContext`\[Eta]0$b[
             4][-1]) + $CellContext`\[Eta]0$[2][1] $CellContext`\[Eta]0$b[
           1][-1] ((-2592) (Complex[0, 43] + 10 3^Rational[1, 2]) - 
           62208 (Complex[0, 5] + 3^Rational[1, 2]) $CellContext`\[Zeta]$[1][
            0] - 62208 (Complex[0, 3] + 
            3^Rational[1, 2]) $CellContext`\[Zeta]$[1][
             0]^2 + $CellContext`u (-222912 - 
             622080 $CellContext`\[Zeta]$[1][0] - 
             373248 $CellContext`\[Zeta]$[1][0]^2 - 
             93312 $CellContext`\[Zeta]$[3][0]) - 
           15552 (Complex[0, 3] + 3^Rational[1, 2]) $CellContext`\[Zeta]$[3][
            0] + (3456 (3 + Complex[0, -1] 3^Rational[1, 2]) + 
             Complex[0, -20736] $CellContext`u) $CellContext`\[Eta]0$[3][
             1] + ((-1728) (Complex[0, -1] + 3^Rational[1, 2]) + 
             Complex[0, 3456] 
              3^Rational[1, 2] $CellContext`u) $CellContext`\[Eta]0$[4][1] + 
           Complex[0, -20736] $CellContext`\[Eta]0$b[2][-1] + (
             864 (3 + Complex[0, 7] 3^Rational[1, 2]) + 
             Complex[0, -5184] $CellContext`u) $CellContext`\[Eta]0$b[
             3][-1] + ((-1728) (Complex[0, 1] + 3^Rational[1, 2]) + 
             Complex[0, 3456] 
              3^Rational[1, 2] $CellContext`u) $CellContext`\[Eta]0$b[
             4][-1]) + $CellContext`\[Eta]0$[1][1] $CellContext`\[Eta]0$b[
           2][-1] ((-2592) (Complex[0, -43] + 10 3^Rational[1, 2]) - 
           62208 (Complex[0, -5] + 3^Rational[1, 2]) $CellContext`\[Zeta]$[1][
            0] - 62208 (Complex[0, -3] + 
            3^Rational[1, 2]) $CellContext`\[Zeta]$[1][0]^2 - 
           15552 (Complex[0, -3] + 3^Rational[1, 2]) $CellContext`\[Zeta]$[3][
            0] + $CellContext`u (222912 + 622080 $CellContext`\[Zeta]$[1][0] + 
             373248 $CellContext`\[Zeta]$[1][0]^2 + 
             93312 $CellContext`\[Zeta]$[3][0]) + 
           Complex[0, 20736] $CellContext`\[Eta]0$[2][1] + (
             864 (3 + Complex[0, -7] 3^Rational[1, 2]) + 
             Complex[0, -5184] $CellContext`u) $CellContext`\[Eta]0$[3][
             1] + ((-1728) (Complex[0, -1] + 3^Rational[1, 2]) + 
             Complex[0, 3456] 
              3^Rational[1, 2] $CellContext`u) $CellContext`\[Eta]0$[4][1] + (
             3456 (3 + Complex[0, 1] 3^Rational[1, 2]) + 
             Complex[0, -20736] $CellContext`u) $CellContext`\[Eta]0$b[
             3][-1] + ((-1728) (Complex[0, 1] + 3^Rational[1, 2]) + 
             Complex[0, 3456] 
              3^Rational[1, 2] $CellContext`u) $CellContext`\[Eta]0$b[
             4][-1]) + (Complex[0, -552] + 2952 3^Rational[1, 2] - 
           288 (Complex[0, 83] + 7 3^Rational[1, 2]) $CellContext`\[Zeta]$[1][
            0] - 6912 (Complex[0, 2] + 
            5 3^Rational[1, 2]) $CellContext`\[Zeta]$[1][0]^2 - 
           144 (Complex[0, 29] + 65 3^Rational[1, 2]) $CellContext`\[Zeta]$[
            3][0] + $CellContext`u (
             1728 (-7 + Complex[0, -5] 3^Rational[1, 2]) + 
             Complex[0, 576] (Complex[0, 99] + 
               52 3^Rational[1, 2]) $CellContext`\[Zeta]$[1][0] + 
             3456 (9 + Complex[0, 17] 3^Rational[1, 2]) $CellContext`\[Zeta]$[
                1][0]^2 + 
             288 (27 + Complex[0, 56] 3^Rational[1, 2]) $CellContext`\[Zeta]$[
               3][0])) $CellContext`\[Eta]0$b[5][-1] + (
           Complex[0, 144] (Complex[0, 83] + 7 3^Rational[1, 2]) + 
           Complex[0, 6912] (Complex[0, 2] + 
             5 3^Rational[1, 2]) $CellContext`\[Zeta]$[1][
             0] + $CellContext`u (288 (Complex[0, 99] + 52 3^Rational[1, 2]) + 
             3456 (Complex[0, -9] + 
               17 3^Rational[1, 2]) $CellContext`\[Zeta]$[1][
               0])) $CellContext`\[Eta]0$[1][1] $CellContext`\[Eta]0$b[
           5][-1] + (1728 (Complex[0, 2] + 5 3^Rational[1, 2]) + 
           864 (-9 + Complex[0, -17] 
              3^Rational[1, 2]) $CellContext`u) $CellContext`\[Eta]0$[1][
            1]^2 $CellContext`\[Eta]0$b[5][-1] + (
           48 (Complex[0, 93] - 25 3^Rational[1, 2]) + 
           288 (25 + Complex[0, -6] 
              3^Rational[1, 2]) $CellContext`u) $CellContext`\[Eta]0$[2][
           1] $CellContext`\[Eta]0$b[5][-1] + (
           1008 (1 + Complex[0, -1] 3^Rational[1, 2]) + 
           144 (Complex[0, 9] - 11 
             3^Rational[1, 2]) $CellContext`u) $CellContext`\[Eta]0$[3][
           1] $CellContext`\[Eta]0$b[
           5][-1] + ((-72) (Complex[0, 3] + 3^Rational[1, 2]) - 
           432 $CellContext`u) $CellContext`\[Eta]0$[4][
           1] $CellContext`\[Eta]0$b[5][-1] + (-5568 + 
           Complex[0, -768] 
            3^Rational[1, 2] + (-46080 + 
             Complex[0, 4224] 3^Rational[1, 2]) $CellContext`\[Zeta]$[1][0] + 
           3456 (3 + Complex[0, 1] 3^Rational[1, 2]) $CellContext`\[Zeta]$[1][
              0]^2 + $CellContext`u (Complex[0, 22872] - 792 3^Rational[1, 2] + 
             576 (Complex[0, 103] + 
               57 3^Rational[1, 2]) $CellContext`\[Zeta]$[1][0] + 
             Complex[0, -20736] $CellContext`\[Zeta]$[1][0]^2 + 
             Complex[0, -5616] $CellContext`\[Zeta]$[3][0]) + 
           936 (3 + Complex[0, 1] 3^Rational[1, 2]) $CellContext`\[Zeta]$[3][
             0]) $CellContext`\[Eta]0$b[6][-1] + (
           192 (Complex[0, 120] + 11 3^Rational[1, 2]) + $CellContext`u (
             288 (103 + Complex[0, -57] 3^Rational[1, 2]) - 
             20736 $CellContext`\[Zeta]$[1][0]) + 
           3456 (Complex[0, -3] + 3^Rational[1, 2]) $CellContext`\[Zeta]$[1][
             0]) $CellContext`\[Eta]0$[1][1] $CellContext`\[Eta]0$b[6][-1] + (
           Complex[0, -864] (Complex[0, -3] + 3^Rational[1, 2]) + 
           Complex[0, 5184] $CellContext`u) $CellContext`\[Eta]0$[1][
            1]^2 $CellContext`\[Eta]0$b[6][-1] + (
           576 (1 + Complex[0, -1] 3^Rational[1, 2]) - 1152 
           3^Rational[1, 2] $CellContext`u) $CellContext`\[Eta]0$[2][
           1] $CellContext`\[Eta]0$b[
           6][-1] + ((-144) (Complex[0, -3] + 3^Rational[1, 2]) + 
           864 $CellContext`u) $CellContext`\[Eta]0$[3][
           1] $CellContext`\[Eta]0$b[6][-1] + (Complex[0, 6352] - 4304 
           3^Rational[1, 2] + 
           4320 (Complex[0, 1] + 3 3^Rational[1, 2]) $CellContext`\[Zeta]$[1][
             0] + $CellContext`u (20304 + Complex[0, 400] 3^Rational[1, 2] + 
             Complex[0, -4320] (Complex[0, -3] + 
               5 3^Rational[1, 2]) $CellContext`\[Zeta]$[1][
               0])) $CellContext`\[Eta]0$b[7][-1] + (
           2160 (1 + Complex[0, -3] 3^Rational[1, 2]) - 
           2160 (Complex[0, -3] + 
            5 3^Rational[1, 2]) $CellContext`u) $CellContext`\[Eta]0$[1][
           1] $CellContext`\[Eta]0$b[7][-1] + (
           48 (237 + Complex[0, -8] 
              3^Rational[1, 2]) + $CellContext`u ((-144) (Complex[0, 111] + 
               47 3^Rational[1, 2]) + 
             Complex[0, 6048] $CellContext`\[Zeta]$[1][0]) + 
           Complex[0, -1008] (Complex[0, -3] + 
             3^Rational[1, 2]) $CellContext`\[Zeta]$[1][
             0]) $CellContext`\[Eta]0$b[
           8][-1] + ((-504) (Complex[0, -3] + 3^Rational[1, 2]) + 
           3024 $CellContext`u) $CellContext`\[Eta]0$[1][
           1] $CellContext`\[Eta]0$b[
           8][-1] + ((-24) (Complex[0, 41] + 89 3^Rational[1, 2]) + 
           48 (36 + Complex[0, 77] 
              3^Rational[1, 2]) $CellContext`u) $CellContext`\[Eta]0$b[
           9][-1] + (144 (3 + Complex[0, 1] 3^Rational[1, 2]) + 
           Complex[0, -864] $CellContext`u) $CellContext`\[Eta]0$b[
           10][-1] + ((-2592) (Complex[0, -43] + 2 3^Rational[1, 2]) - 
           62208 (Complex[0, -5] + 3^Rational[1, 2]) $CellContext`\[Zeta]$[1][
            0] - 62208 (Complex[0, -3] + 
            3^Rational[1, 2]) $CellContext`\[Zeta]$[1][0]^2 - 
           15552 (Complex[0, -3] + 3^Rational[1, 2]) $CellContext`\[Zeta]$[3][
            0] + $CellContext`u (222912 + 622080 $CellContext`\[Zeta]$[1][0] + 
             373248 $CellContext`\[Zeta]$[1][0]^2 + 
             93312 $CellContext`\[Zeta]$[3][0])) $CellContext`\[Eta]0$b[
           1, 2][-1] + (
           31104 (5 + Complex[0, 1] 3^Rational[1, 2]) + $CellContext`u (
             Complex[0, -311040] + 
             Complex[0, -373248] $CellContext`\[Zeta]$[1][0]) + 
           62208 (3 + Complex[0, 1] 3^Rational[1, 2]) $CellContext`\[Zeta]$[
             1][0]) $CellContext`\[Eta]0$[1][1] $CellContext`\[Eta]0$b[
           1, 2][-1] + (15552 (Complex[0, -3] + 3^Rational[1, 2]) - 
           93312 $CellContext`u) $CellContext`\[Eta]0$[1][
            1]^2 $CellContext`\[Eta]0$b[1, 2][-1] + (
           10368 (Complex[0, 1] + 3^Rational[1, 2]) + 
           Complex[0, -20736] 
            3^Rational[1, 2] $CellContext`u) $CellContext`\[Eta]0$[2][
           1] $CellContext`\[Eta]0$b[1, 2][-1] + (
           Complex[0, -2592] (Complex[0, -3] + 3^Rational[1, 2]) + 
           Complex[0, 15552] $CellContext`u) $CellContext`\[Eta]0$[3][
           1] $CellContext`\[Eta]0$b[1, 2][-1] + (
           11232 (6 + Complex[0, 1] 3^Rational[1, 2]) + 
           20736 (5 + Complex[0, -1] 3^Rational[1, 2]) $CellContext`\[Zeta]$[
             1][0] + 62208 (1 + 
             Complex[0, -1] 3^Rational[1, 2]) $CellContext`\[Zeta]$[1][0]^2 + 
           15552 (1 + Complex[0, -1] 3^Rational[1, 2]) $CellContext`\[Zeta]$[
             3][0] + $CellContext`u ((-8640) (Complex[0, 18] + 
               3^Rational[1, 2]) - 
             20736 (Complex[0, 9] + 5 3^Rational[1, 2]) $CellContext`\[Zeta]$[
              1][0] - 124416 3^Rational[1, 2] $CellContext`\[Zeta]$[1][0]^2 - 
             31104 3^Rational[1, 2] $CellContext`\[Zeta]$[3][
              0])) $CellContext`\[Eta]0$b[
           1, 3][-1] + ((-10368) (Complex[0, 5] + 3^Rational[1, 2]) - 
           62208 (Complex[0, 1] + 3^Rational[1, 2]) $CellContext`\[Zeta]$[1][
            0] + $CellContext`u (
             Complex[0, 10368] (Complex[0, 9] + 5 3^Rational[1, 2]) + 
             Complex[0, 124416] 
              3^Rational[1, 2] $CellContext`\[Zeta]$[1][
               0])) $CellContext`\[Eta]0$[1][1] $CellContext`\[Eta]0$b[
           1, 3][-1] + (Complex[0, 15552] (Complex[0, 1] + 3^Rational[1, 2]) + 
           31104 3^Rational[1, 2] $CellContext`u) $CellContext`\[Eta]0$[1][
            1]^2 $CellContext`\[Eta]0$b[1, 3][-1] + (
           Complex[0, -3456] (Complex[0, -3] + 3^Rational[1, 2]) + 
           Complex[0, 20736] $CellContext`u) $CellContext`\[Eta]0$[2][
           1] $CellContext`\[Eta]0$b[1, 3][-1] + (
           2592 (Complex[0, 1] + 3^Rational[1, 2]) + 
           Complex[0, -5184] 
            3^Rational[1, 2] $CellContext`u) $CellContext`\[Eta]0$[3][
           1] $CellContext`\[Eta]0$b[
           1, 3][-1] + ((-144) (Complex[0, 405] + 52 3^Rational[1, 2]) - 
           6912 (Complex[0, 12] + 3^Rational[1, 2]) $CellContext`\[Zeta]$[1][
            0] - 10368 (Complex[0, -3] + 
            3^Rational[1, 2]) $CellContext`\[Zeta]$[1][0]^2 - 
           2592 (Complex[0, -3] + 3^Rational[1, 2]) $CellContext`\[Zeta]$[3][
            0] + $CellContext`u (
             Complex[0, 2592] (Complex[0, 39] + 14 3^Rational[1, 2]) + 
             Complex[0, 20736] (Complex[0, 5] + 
               3 3^Rational[1, 2]) $CellContext`\[Zeta]$[1][0] + 
             62208 $CellContext`\[Zeta]$[1][0]^2 + 
             15552 $CellContext`\[Zeta]$[3][0])) $CellContext`\[Eta]0$b[
           1, 4][-1] + (
           Complex[0, 3456] (Complex[0, 12] + 
             3^Rational[1, 2]) + $CellContext`u (
             10368 (Complex[0, 5] + 3 3^Rational[1, 2]) + 
             Complex[0, -62208] $CellContext`\[Zeta]$[1][0]) + 
           10368 (3 + Complex[0, 1] 3^Rational[1, 2]) $CellContext`\[Zeta]$[
             1][0]) $CellContext`\[Eta]0$[1][1] $CellContext`\[Eta]0$b[
           1, 4][-1] + (2592 (Complex[0, -3] + 3^Rational[1, 2]) - 
           15552 $CellContext`u) $CellContext`\[Eta]0$[1][
            1]^2 $CellContext`\[Eta]0$b[1, 4][-1] + (
           1728 (Complex[0, 1] + 3^Rational[1, 2]) + 
           Complex[0, -3456] 
            3^Rational[1, 2] $CellContext`u) $CellContext`\[Eta]0$[2][
           1] $CellContext`\[Eta]0$b[1, 4][-1] + (
           Complex[0, -432] (Complex[0, -3] + 3^Rational[1, 2]) + 
           Complex[0, 2592] $CellContext`u) $CellContext`\[Eta]0$[3][
           1] $CellContext`\[Eta]0$b[
           1, 4][-1] + $CellContext`\[Eta]0$b[1][-1]^2 (248832 + 
           186624 $CellContext`\[Zeta]$[1][0] + (
             15552 (5 + Complex[0, 1] 3^Rational[1, 2]) + $CellContext`u (
               Complex[0, -155520] + 
               Complex[0, -186624] $CellContext`\[Zeta]$[1][0]) + 
             31104 (3 + Complex[0, 1] 3^Rational[1, 2]) $CellContext`\[Zeta]$[
               1][0]) $CellContext`\[Eta]0$b[
             2][-1] + ((-5184) (Complex[0, 5] + 3^Rational[1, 2]) - 
             31104 (Complex[0, 1] + 3^Rational[1, 2]) $CellContext`\[Zeta]$[
              1][0] + $CellContext`u (
               Complex[0, 5184] (Complex[0, 9] + 5 3^Rational[1, 2]) + 
               Complex[0, 62208] 
                3^Rational[1, 2] $CellContext`\[Zeta]$[1][
                 0])) $CellContext`\[Eta]0$b[3][-1] + (
             Complex[0, 1728] (Complex[0, 12] + 
               3^Rational[1, 2]) + $CellContext`u (
               5184 (Complex[0, 5] + 3 3^Rational[1, 2]) + 
               Complex[0, -31104] $CellContext`\[Zeta]$[1][0]) + 
             5184 (3 + Complex[0, 1] 3^Rational[1, 2]) $CellContext`\[Zeta]$[
               1][0]) $CellContext`\[Eta]0$b[4][-1] + (
             1728 (Complex[0, 2] + 5 3^Rational[1, 2]) + 
             864 (-9 + Complex[0, -17] 
                3^Rational[1, 2]) $CellContext`u) $CellContext`\[Eta]0$b[
             5][-1] + (Complex[0, -864] (Complex[0, -3] + 3^Rational[1, 2]) + 
             Complex[0, 5184] $CellContext`u) $CellContext`\[Eta]0$b[
             6][-1] + (15552 (Complex[0, -3] + 3^Rational[1, 2]) - 
             93312 $CellContext`u) $CellContext`\[Eta]0$b[1, 2][-1] + (
             Complex[0, 15552] (Complex[0, 1] + 3^Rational[1, 2]) + 
             31104 3^Rational[1, 2] $CellContext`u) $CellContext`\[Eta]0$b[
             1, 3][-1] + (2592 (Complex[0, -3] + 3^Rational[1, 2]) - 
             15552 $CellContext`u) $CellContext`\[Eta]0$b[
             1, 4][-1]) + $CellContext`\[Eta]0$b[3][-1] (Complex[0, 81792] - 
           5472 3^Rational[1, 2] + 
           20736 (Complex[0, 5] + 
             3^Rational[1, 2]) $CellContext`\[Zeta]$[1][0]^2 + 
           41472 (Complex[0, 1] + 
             3^Rational[1, 2]) $CellContext`\[Zeta]$[1][0]^3 + 
           864 (Complex[0, 24] + 3^Rational[1, 2]) $CellContext`\[Zeta]$[3][
             0] + $CellContext`\[Zeta]$[1][
             0] ((-1728) (Complex[0, -96] + 13 3^Rational[1, 2]) + 
             31104 (Complex[0, 1] + 3^Rational[1, 2]) $CellContext`\[Zeta]$[
               3][0]) + 
           8640 (Complex[0, 1] + 3^Rational[1, 2]) $CellContext`\[Zeta]$[5][
             0] + $CellContext`u (288 (387 + Complex[0, 20] 3^Rational[1, 2]) + 
             20736 (9 + 
               Complex[0, -5] 3^Rational[1, 2]) $CellContext`\[Zeta]$[1][0]^2 + 
             Complex[0, -82944] 
              3^Rational[1, 2] $CellContext`\[Zeta]$[1][0]^3 + 
             1728 (27 + 
               Complex[0, -10] 3^Rational[1, 2]) $CellContext`\[Zeta]$[3][
               0] + $CellContext`\[Zeta]$[1][0] (
               17280 (18 + Complex[0, -1] 3^Rational[1, 2]) + 
               Complex[0, -62208] 
                3^Rational[1, 2] $CellContext`\[Zeta]$[3][0]) + 
             Complex[0, -17280] 
              3^Rational[1, 2] $CellContext`\[Zeta]$[5][0]) + (
             48 (Complex[0, -93] + 3^Rational[1, 2]) - 
             864 (Complex[0, -3] + 3^Rational[1, 2]) $CellContext`\[Zeta]$[1][
              0] + $CellContext`u (288 (-22 + Complex[0, 9] 3^Rational[1, 2]) + 
               5184 $CellContext`\[Zeta]$[1][0])) $CellContext`\[Eta]0$b[
             4][-1] + (288 (-2 + Complex[0, 5] 3^Rational[1, 2]) + 
             144 (Complex[0, -9] + 
               17 3^Rational[1, 2]) $CellContext`u) $CellContext`\[Eta]0$b[
             5][-1] + (144 (Complex[0, -3] + 3^Rational[1, 2]) - 
             864 $CellContext`u) $CellContext`\[Eta]0$b[6][-1] + (
             432 (3 + Complex[0, 1] 3^Rational[1, 2]) + 
             Complex[0, -2592] $CellContext`u) $CellContext`\[Eta]0$b[
             1, 4][-1]) + $CellContext`\[Eta]0$[1][1] $CellContext`\[Eta]0$b[
           1][-1] (-497664 - 
           373248 $CellContext`\[Zeta]$[1][
            0] + (Complex[0, 31104] (Complex[0, 5] + 
               3^Rational[1, 2]) + $CellContext`u (Complex[0, 311040] + 
               Complex[0, 373248] $CellContext`\[Zeta]$[1][0]) + 
             Complex[0, 62208] (Complex[0, 3] + 
               3^Rational[1, 2]) $CellContext`\[Zeta]$[1][
               0]) $CellContext`\[Eta]0$[2][1] + (
             10368 (Complex[0, -5] + 3^Rational[1, 2]) + 
             62208 (Complex[0, -1] + 3^Rational[1, 2]) $CellContext`\[Zeta]$[
               1][0] + $CellContext`u (
               10368 (-9 + Complex[0, -5] 3^Rational[1, 2]) + 
               Complex[0, -124416] 
                3^Rational[1, 2] $CellContext`\[Zeta]$[1][
                 0])) $CellContext`\[Eta]0$[3][1] + (
             3456 (12 + Complex[0, 1] 3^Rational[1, 2]) + $CellContext`u (
               10368 (Complex[0, -5] + 3 3^Rational[1, 2]) + 
               Complex[0, 62208] $CellContext`\[Zeta]$[1][0]) + 
             Complex[0, 10368] (Complex[0, 3] + 
               3^Rational[1, 2]) $CellContext`\[Zeta]$[1][
               0]) $CellContext`\[Eta]0$[4][
             1] + ((-3456) (Complex[0, -2] + 5 3^Rational[1, 2]) + 
             Complex[0, 1728] (Complex[0, 9] + 
               17 3^Rational[1, 2]) $CellContext`u) $CellContext`\[Eta]0$[5][
             1] + (1728 (3 + Complex[0, -1] 3^Rational[1, 2]) + 
             Complex[0, -10368] $CellContext`u) $CellContext`\[Eta]0$[6][
             1] + ((-31104) (Complex[0, 3] + 3^Rational[1, 2]) - 
             186624 $CellContext`u) $CellContext`\[Eta]0$[1, 2][1] + (
             31104 (1 + Complex[0, 1] 3^Rational[1, 2]) + 
             62208 3^Rational[1, 2] $CellContext`u) $CellContext`\[Eta]0$[
             1, 3][1] + ((-5184) (Complex[0, 3] + 3^Rational[1, 2]) - 
             31104 $CellContext`u) $CellContext`\[Eta]0$[1, 4][1] + (
             Complex[0, -31104] (Complex[0, -5] + 
               3^Rational[1, 2]) + $CellContext`u (Complex[0, 311040] + 
               Complex[0, 373248] $CellContext`\[Zeta]$[1][0]) + 
             Complex[0, -62208] (Complex[0, -3] + 
               3^Rational[1, 2]) $CellContext`\[Zeta]$[1][
               0]) $CellContext`\[Eta]0$b[2][-1] + (
             10368 (Complex[0, 5] + 3^Rational[1, 2]) + 
             62208 (Complex[0, 1] + 3^Rational[1, 2]) $CellContext`\[Zeta]$[
               1][0] + $CellContext`u (
               10368 (9 + Complex[0, -5] 3^Rational[1, 2]) + 
               Complex[0, -124416] 
                3^Rational[1, 2] $CellContext`\[Zeta]$[1][
                 0])) $CellContext`\[Eta]0$b[3][-1] + (
             3456 (12 + 
               Complex[0, -1] 
                3^Rational[1, 2]) + $CellContext`u ((-10368) (Complex[0, 5] + 
                 3 3^Rational[1, 2]) + 
               Complex[0, 62208] $CellContext`\[Zeta]$[1][0]) + 
             Complex[0, -10368] (Complex[0, -3] + 
               3^Rational[1, 2]) $CellContext`\[Zeta]$[1][
               0]) $CellContext`\[Eta]0$b[
             4][-1] + ((-3456) (Complex[0, 2] + 5 3^Rational[1, 2]) + 
             1728 (9 + Complex[0, 17] 
                3^Rational[1, 2]) $CellContext`u) $CellContext`\[Eta]0$b[
             5][-1] + (1728 (3 + Complex[0, 1] 3^Rational[1, 2]) + 
             Complex[0, -10368] $CellContext`u) $CellContext`\[Eta]0$b[
             6][-1] + ((-31104) (Complex[0, -3] + 3^Rational[1, 2]) + 
             186624 $CellContext`u) $CellContext`\[Eta]0$b[1, 2][-1] + (
             31104 (1 + Complex[0, -1] 3^Rational[1, 2]) - 62208 
             3^Rational[1, 2] $CellContext`u) $CellContext`\[Eta]0$b[
             1, 3][-1] + ((-5184) (Complex[0, -3] + 3^Rational[1, 2]) + 
             31104 $CellContext`u) $CellContext`\[Eta]0$b[
             1, 4][-1]) + $CellContext`\[Eta]0$b[2][-1] (
           864 (-13 + Complex[0, -42] 3^Rational[1, 2]) + 
           Complex[0, -62208] (Complex[0, -5] + 
             3^Rational[1, 2]) $CellContext`\[Zeta]$[1][0]^2 + 
           Complex[0, -41472] (Complex[0, -3] + 
             3^Rational[1, 2]) $CellContext`\[Zeta]$[1][0]^3 + 
           864 (-81 + Complex[0, -14] 3^Rational[1, 2]) $CellContext`\[Zeta]$[
             3][0] + $CellContext`\[Zeta]$[1][0] (
             5184 (-43 + Complex[0, -10] 3^Rational[1, 2]) + 
             Complex[0, -31104] (Complex[0, -3] + 
               3^Rational[1, 2]) $CellContext`\[Zeta]$[3][
               0]) + $CellContext`u (Complex[0, 22464] + 
             Complex[0, 622080] $CellContext`\[Zeta]$[1][0]^2 + 
             Complex[0, 248832] $CellContext`\[Zeta]$[1][
                0]^3 + $CellContext`\[Zeta]$[1][0] (Complex[0, 445824] + 
               Complex[0, 186624] $CellContext`\[Zeta]$[3][0]) + 
             Complex[0, 139968] $CellContext`\[Zeta]$[3][0] + 
             Complex[0, 51840] $CellContext`\[Zeta]$[5][0]) + 
           Complex[0, -8640] (Complex[0, -3] + 
             3^Rational[1, 2]) $CellContext`\[Zeta]$[5][
             0] + ((-144) (Complex[0, 93] + 3^Rational[1, 2]) - 
             6912 (Complex[0, -3] + 3^Rational[1, 2]) $CellContext`\[Zeta]$[
              1][0] + $CellContext`u (
               Complex[0, 864] (Complex[0, 19] + 12 3^Rational[1, 2]) + 
               41472 $CellContext`\[Zeta]$[1][0])) $CellContext`\[Eta]0$b[
             3][-1] + (72 (13 + Complex[0, 67] 3^Rational[1, 2]) + 
             3456 (1 + Complex[0, -1] 3^Rational[1, 2]) $CellContext`\[Zeta]$[
               1][0] + $CellContext`u (
               144 (Complex[0, -72] + 43 3^Rational[1, 2]) - 6912 
               3^Rational[1, 2] $CellContext`\[Zeta]$[1][
                0])) $CellContext`\[Eta]0$b[4][-1] + (
             384 (Complex[0, -15] + 2 3^Rational[1, 2]) + 
             576 (-17 + 
               Complex[0, 3] 
                3^Rational[1, 2]) $CellContext`u) $CellContext`\[Eta]0$b[
             5][-1] + (Complex[0, 576] (Complex[0, 1] + 3^Rational[1, 2]) + 
             1152 3^Rational[1, 2] $CellContext`u) $CellContext`\[Eta]0$b[
             6][-1] + (3456 (3 + Complex[0, 1] 3^Rational[1, 2]) + 
             Complex[0, -20736] $CellContext`u) $CellContext`\[Eta]0$b[
             1, 3][-1] + ((-1728) (Complex[0, 1] + 3^Rational[1, 2]) + 
             Complex[0, 3456] 
              3^Rational[1, 2] $CellContext`u) $CellContext`\[Eta]0$b[
             1, 4][-1]) + (
           Complex[0, 144] (Complex[0, 83] + 7 3^Rational[1, 2]) + 
           Complex[0, 6912] (Complex[0, 2] + 
             5 3^Rational[1, 2]) $CellContext`\[Zeta]$[1][
             0] + $CellContext`u (288 (Complex[0, 99] + 52 3^Rational[1, 2]) + 
             3456 (Complex[0, -9] + 
               17 3^Rational[1, 2]) $CellContext`\[Zeta]$[1][
               0])) $CellContext`\[Eta]0$b[1, 5][-1] + (
           3456 (Complex[0, 2] + 5 3^Rational[1, 2]) + 
           1728 (-9 + 
             Complex[0, -17] 
              3^Rational[1, 2]) $CellContext`u) $CellContext`\[Eta]0$[1][
           1] $CellContext`\[Eta]0$b[1, 5][-1] + (
           48 (Complex[0, 453] + 17 3^Rational[1, 2]) + $CellContext`u (
             288 (103 + Complex[0, -48] 3^Rational[1, 2]) - 
             20736 $CellContext`\[Zeta]$[1][0]) + 
           3456 (Complex[0, -3] + 3^Rational[1, 2]) $CellContext`\[Zeta]$[1][
             0]) $CellContext`\[Eta]0$b[1, 6][-1] + (
           Complex[0, -1728] (Complex[0, -3] + 3^Rational[1, 2]) + 
           Complex[0, 10368] $CellContext`u) $CellContext`\[Eta]0$[1][
           1] $CellContext`\[Eta]0$b[1, 6][-1] + (
           2160 (1 + Complex[0, -3] 3^Rational[1, 2]) - 
           2160 (Complex[0, -3] + 
            5 3^Rational[1, 2]) $CellContext`u) $CellContext`\[Eta]0$b[
           1, 7][-1] + ((-504) (Complex[0, -3] + 3^Rational[1, 2]) + 
           3024 $CellContext`u) $CellContext`\[Eta]0$b[
           1, 8][-1] + ((-5616) (Complex[0, 1] + 3^Rational[1, 2]) - 
           1728 (Complex[0, 21] + 17 3^Rational[1, 2]) $CellContext`\[Zeta]$[
            1][0] + $CellContext`u (
             Complex[0, 864] (Complex[0, 19] + 18 3^Rational[1, 2]) + 
             Complex[0, 10368] (Complex[0, 1] + 
               6 3^Rational[1, 2]) $CellContext`\[Zeta]$[1][
               0])) $CellContext`\[Eta]0$b[2, 3][-1] + (
           Complex[0, 864] (Complex[0, 21] + 17 3^Rational[1, 2]) + 
           5184 (Complex[0, 1] + 
             6 3^Rational[1, 2]) $CellContext`u) $CellContext`\[Eta]0$[1][
           1] $CellContext`\[Eta]0$b[2, 3][-1] + (
           72 (-337 + Complex[0, -7] 3^Rational[1, 2]) + 
           1728 (7 + Complex[0, 5] 3^Rational[1, 2]) $CellContext`\[Zeta]$[1][
             0] + $CellContext`u (
             144 (Complex[0, 252] + 101 3^Rational[1, 2]) + 
             3456 (Complex[0, -9] + 2 3^Rational[1, 2]) $CellContext`\[Zeta]$[
               1][0])) $CellContext`\[Eta]0$b[2, 4][-1] + (
           864 (Complex[0, -7] + 5 3^Rational[1, 2]) + 
           1728 (-9 + 
             Complex[0, -2] 
              3^Rational[1, 2]) $CellContext`u) $CellContext`\[Eta]0$[1][
           1] $CellContext`\[Eta]0$b[2, 4][-1] + (Complex[0, 7920] + 
           8304 3^Rational[1, 2] + 
           288 (-2 + Complex[0, -57] 
              3^Rational[1, 2]) $CellContext`u) $CellContext`\[Eta]0$b[
           2, 5][-1] + (288 (-7 + Complex[0, -5] 3^Rational[1, 2]) - 
           576 (Complex[0, -9] + 
            2 3^Rational[1, 2]) $CellContext`u) $CellContext`\[Eta]0$b[
           2, 6][-1] + (
           48 (Complex[0, 21] + 71 3^Rational[1, 2]) + $CellContext`u (
             2016 (-2 + Complex[0, -3] 3^Rational[1, 2]) - 
             5184 $CellContext`\[Zeta]$[1][0]) + 
           864 (Complex[0, -3] + 3^Rational[1, 2]) $CellContext`\[Zeta]$[1][
             0]) $CellContext`\[Eta]0$b[3, 4][-1] + (
           Complex[0, -432] (Complex[0, -3] + 3^Rational[1, 2]) + 
           Complex[0, 2592] $CellContext`u) $CellContext`\[Eta]0$[1][
           1] $CellContext`\[Eta]0$b[3, 4][-1] + (
           144 (1 + Complex[0, -7] 3^Rational[1, 2]) + 
           144 (Complex[0, 9] - 11 
             3^Rational[1, 2]) $CellContext`u) $CellContext`\[Eta]0$b[
           3, 5][-1] + ((-144) (Complex[0, -3] + 3^Rational[1, 2]) + 
           864 $CellContext`u) $CellContext`\[Eta]0$b[3, 6][-1] + (
           72 (Complex[0, -3] + 3^Rational[1, 2]) - 
           432 $CellContext`u) $CellContext`\[Eta]0$b[4, 5][-1] + (
           31104 (5 + Complex[0, 1] 3^Rational[1, 2]) + $CellContext`u (
             Complex[0, -311040] + 
             Complex[0, -373248] $CellContext`\[Zeta]$[1][0]) + 
           62208 (3 + Complex[0, 1] 3^Rational[1, 2]) $CellContext`\[Zeta]$[
             1][0]) $CellContext`\[Eta]0$b[1, 1, 2][-1] + (
           31104 (Complex[0, -3] + 3^Rational[1, 2]) - 
           186624 $CellContext`u) $CellContext`\[Eta]0$[1][
           1] $CellContext`\[Eta]0$b[
           1, 1, 2][-1] + ((-10368) (Complex[0, 5] + 3^Rational[1, 2]) - 
           62208 (Complex[0, 1] + 3^Rational[1, 2]) $CellContext`\[Zeta]$[1][
            0] + $CellContext`u (
             Complex[0, 10368] (Complex[0, 9] + 5 3^Rational[1, 2]) + 
             Complex[0, 124416] 
              3^Rational[1, 2] $CellContext`\[Zeta]$[1][
               0])) $CellContext`\[Eta]0$b[1, 1, 3][-1] + (
           Complex[0, 31104] (Complex[0, 1] + 3^Rational[1, 2]) + 
           62208 3^Rational[1, 2] $CellContext`u) $CellContext`\[Eta]0$[1][
           1] $CellContext`\[Eta]0$b[1, 1, 3][-1] + (
           Complex[0, 3456] (Complex[0, 12] + 
             3^Rational[1, 2]) + $CellContext`u (
             10368 (Complex[0, 5] + 3 3^Rational[1, 2]) + 
             Complex[0, -62208] $CellContext`\[Zeta]$[1][0]) + 
           10368 (3 + Complex[0, 1] 3^Rational[1, 2]) $CellContext`\[Zeta]$[
             1][0]) $CellContext`\[Eta]0$b[1, 1, 4][-1] + (
           5184 (Complex[0, -3] + 3^Rational[1, 2]) - 
           31104 $CellContext`u) $CellContext`\[Eta]0$[1][
           1] $CellContext`\[Eta]0$b[1, 1, 4][-1] + $CellContext`\[Eta]0$b[
           1][-1] (Complex[0, -720576] + 
           Complex[0, -995328] $CellContext`\[Zeta]$[1][0] + 
           Complex[0, -373248] $CellContext`\[Zeta]$[1][0]^2 + 
           Complex[0, -93312] $CellContext`\[Zeta]$[3][
             0] + ((-2592) (Complex[0, -11] + 3^Rational[1, 2]) + 
             5184 (9 + Complex[0, -2] 
                3^Rational[1, 2]) $CellContext`u) $CellContext`\[Eta]0$b[
              2][-1]^2 + (1296 (Complex[0, 1] + 3^Rational[1, 2]) + 
             Complex[0, -2592] 
              3^Rational[1, 2] $CellContext`u) $CellContext`\[Eta]0$b[
              3][-1]^2 + (144 (Complex[0, 207] + 70 3^Rational[1, 2]) + 
             6912 (Complex[0, 12] + 3^Rational[1, 2]) $CellContext`\[Zeta]$[
               1][0] + 10368 (Complex[0, -3] + 
               3^Rational[1, 2]) $CellContext`\[Zeta]$[1][
                0]^2 + $CellContext`u (
               2592 (21 + Complex[0, -10] 3^Rational[1, 2]) + 
               20736 (5 + 
                 Complex[0, -3] 3^Rational[1, 2]) $CellContext`\[Zeta]$[1][0] - 
               62208 $CellContext`\[Zeta]$[1][0]^2 - 
               15552 $CellContext`\[Zeta]$[3][0]) + 
             2592 (Complex[0, -3] + 3^Rational[1, 2]) $CellContext`\[Zeta]$[
               3][0]) $CellContext`\[Eta]0$b[4][-1] + $CellContext`\[Eta]0$b[
             3][-1] (864 (-96 + Complex[0, -13] 3^Rational[1, 2]) + 
             Complex[0, 20736] (Complex[0, 5] + 
               3^Rational[1, 2]) $CellContext`\[Zeta]$[1][0] + 
             Complex[0, 62208] (Complex[0, 1] + 
               3^Rational[1, 2]) $CellContext`\[Zeta]$[1][0]^2 + 
             Complex[0, 15552] (Complex[0, 1] + 
               3^Rational[1, 2]) $CellContext`\[Zeta]$[3][
               0] + $CellContext`u (8640 (Complex[0, 18] + 3^Rational[1, 2]) + 
               20736 (Complex[0, 9] + 
                 5 3^Rational[1, 2]) $CellContext`\[Zeta]$[1][0] + 
               124416 3^Rational[1, 2] $CellContext`\[Zeta]$[1][0]^2 + 
               31104 3^Rational[1, 2] $CellContext`\[Zeta]$[3][0]) + (
               Complex[0, -432] (Complex[0, -3] + 3^Rational[1, 2]) + 
               Complex[0, 2592] $CellContext`u) $CellContext`\[Eta]0$b[
               4][-1]) + $CellContext`\[Eta]0$b[2][-1] (
             2592 (Complex[0, -43] + 10 3^Rational[1, 2]) + 
             62208 (Complex[0, -5] + 3^Rational[1, 2]) $CellContext`\[Zeta]$[
               1][0] + 62208 (Complex[0, -3] + 
               3^Rational[1, 2]) $CellContext`\[Zeta]$[1][
                0]^2 + $CellContext`u (-222912 - 
               622080 $CellContext`\[Zeta]$[1][0] - 
               373248 $CellContext`\[Zeta]$[1][0]^2 - 
               93312 $CellContext`\[Zeta]$[3][0]) + 
             15552 (Complex[0, -3] + 3^Rational[1, 2]) $CellContext`\[Zeta]$[
               3][0] + (Complex[0, -3456] (Complex[0, -3] + 3^Rational[1, 2]) + 
               Complex[0, 20736] $CellContext`u) $CellContext`\[Eta]0$b[
               3][-1] + (1728 (Complex[0, 1] + 3^Rational[1, 2]) + 
               Complex[0, -3456] 
                3^Rational[1, 2] $CellContext`u) $CellContext`\[Eta]0$b[
               4][-1]) + (144 (83 + Complex[0, -7] 3^Rational[1, 2]) + 
             6912 (2 + Complex[0, -5] 3^Rational[1, 2]) $CellContext`\[Zeta]$[
               1][0] + $CellContext`u ((-288) (Complex[0, 99] + 
                 52 3^Rational[1, 2]) - 
               3456 (Complex[0, -9] + 
                17 3^Rational[1, 2]) $CellContext`\[Zeta]$[1][
                0])) $CellContext`\[Eta]0$b[
             5][-1] + ((-192) (Complex[0, 120] + 11 3^Rational[1, 2]) - 
             3456 (Complex[0, -3] + 3^Rational[1, 2]) $CellContext`\[Zeta]$[
              1][0] + $CellContext`u (
               288 (-103 + Complex[0, 57] 3^Rational[1, 2]) + 
               20736 $CellContext`\[Zeta]$[1][0])) $CellContext`\[Eta]0$b[
             6][-1] + (2160 (-1 + Complex[0, 3] 3^Rational[1, 2]) + 
             2160 (Complex[0, -3] + 
               5 3^Rational[1, 2]) $CellContext`u) $CellContext`\[Eta]0$b[
             7][-1] + (504 (Complex[0, -3] + 3^Rational[1, 2]) - 
             3024 $CellContext`u) $CellContext`\[Eta]0$b[8][-1] + (
             Complex[0, -31104] (Complex[0, -5] + 
               3^Rational[1, 2]) + $CellContext`u (Complex[0, 311040] + 
               Complex[0, 373248] $CellContext`\[Zeta]$[1][0]) + 
             Complex[0, -62208] (Complex[0, -3] + 
               3^Rational[1, 2]) $CellContext`\[Zeta]$[1][
               0]) $CellContext`\[Eta]0$b[1, 2][-1] + (
             10368 (Complex[0, 5] + 3^Rational[1, 2]) + 
             62208 (Complex[0, 1] + 3^Rational[1, 2]) $CellContext`\[Zeta]$[
               1][0] + $CellContext`u (
               10368 (9 + Complex[0, -5] 3^Rational[1, 2]) + 
               Complex[0, -124416] 
                3^Rational[1, 2] $CellContext`\[Zeta]$[1][
                 0])) $CellContext`\[Eta]0$b[1, 3][-1] + (
             3456 (12 + 
               Complex[0, -1] 
                3^Rational[1, 2]) + $CellContext`u ((-10368) (Complex[0, 5] + 
                 3 3^Rational[1, 2]) + 
               Complex[0, 62208] $CellContext`\[Zeta]$[1][0]) + 
             Complex[0, -10368] (Complex[0, -3] + 
               3^Rational[1, 2]) $CellContext`\[Zeta]$[1][
               0]) $CellContext`\[Eta]0$b[
             1, 4][-1] + ((-3456) (Complex[0, 2] + 5 3^Rational[1, 2]) + 
             1728 (9 + Complex[0, 17] 
                3^Rational[1, 2]) $CellContext`u) $CellContext`\[Eta]0$b[
             1, 5][-1] + (1728 (3 + Complex[0, 1] 3^Rational[1, 2]) + 
             Complex[0, -10368] $CellContext`u) $CellContext`\[Eta]0$b[
             1, 6][-1] + (864 (21 + Complex[0, -17] 3^Rational[1, 2]) - 
             5184 (Complex[0, 1] + 
              6 3^Rational[1, 2]) $CellContext`u) $CellContext`\[Eta]0$b[
             2, 3][-1] + ((-864) (Complex[0, -7] + 5 3^Rational[1, 2]) + 
             1728 (9 + Complex[0, 2] 
                3^Rational[1, 2]) $CellContext`u) $CellContext`\[Eta]0$b[
             2, 4][-1] + (432 (3 + Complex[0, 1] 3^Rational[1, 2]) + 
             Complex[0, -2592] $CellContext`u) $CellContext`\[Eta]0$b[
             3, 4][-1] + ((-31104) (Complex[0, -3] + 3^Rational[1, 2]) + 
             186624 $CellContext`u) $CellContext`\[Eta]0$b[1, 1, 2][-1] + (
             31104 (1 + Complex[0, -1] 3^Rational[1, 2]) - 62208 
             3^Rational[1, 2] $CellContext`u) $CellContext`\[Eta]0$b[
             1, 1, 3][-1] + ((-5184) (Complex[0, -3] + 3^Rational[1, 2]) + 
             31104 $CellContext`u) $CellContext`\[Eta]0$b[1, 1, 4][-1]) + (
           3456 (Complex[0, 2] + 5 3^Rational[1, 2]) + 
           1728 (-9 + 
             Complex[0, -17] 
              3^Rational[1, 2]) $CellContext`u) $CellContext`\[Eta]0$b[
           1, 1, 5][-1] + (
           Complex[0, -1728] (Complex[0, -3] + 3^Rational[1, 2]) + 
           Complex[0, 10368] $CellContext`u) $CellContext`\[Eta]0$b[
           1, 1, 6][-1] + (5184 (Complex[0, -11] + 3^Rational[1, 2]) + 
           Complex[0, 10368] (Complex[0, 9] + 
             2 3^Rational[1, 2]) $CellContext`u) $CellContext`\[Eta]0$b[
           1, 2, 2][-1] + (
           Complex[0, 864] (Complex[0, 21] + 17 3^Rational[1, 2]) + 
           5184 (Complex[0, 1] + 
             6 3^Rational[1, 2]) $CellContext`u) $CellContext`\[Eta]0$b[
           1, 2, 3][-1] + (864 (Complex[0, -7] + 5 3^Rational[1, 2]) + 
           1728 (-9 + 
             Complex[0, -2] 
              3^Rational[1, 2]) $CellContext`u) $CellContext`\[Eta]0$b[
           1, 2, 4][-1] + ((-2592) (Complex[0, 1] + 3^Rational[1, 2]) + 
           Complex[0, 5184] 
            3^Rational[1, 2] $CellContext`u) $CellContext`\[Eta]0$b[
           1, 3, 3][-1] + (
           Complex[0, -432] (Complex[0, -3] + 3^Rational[1, 2]) + 
           Complex[0, 2592] $CellContext`u) $CellContext`\[Eta]0$b[
           1, 3, 4][-1] + (15552 (Complex[0, -3] + 3^Rational[1, 2]) - 
           93312 $CellContext`u) $CellContext`\[Eta]0$b[2, 1, 2][-1] + (
           Complex[0, 1728] (Complex[0, 15] + 7 3^Rational[1, 2]) + 
           10368 (Complex[0, 2] + 
             3 3^Rational[1, 2]) $CellContext`u) $CellContext`\[Eta]0$b[
           2, 1, 3][-1] + (864 (Complex[0, -7] + 5 3^Rational[1, 2]) + 
           1728 (-9 + 
             Complex[0, -2] 
              3^Rational[1, 2]) $CellContext`u) $CellContext`\[Eta]0$b[
           2, 1, 4][-1] + (
           Complex[0, -432] (Complex[0, -3] + 3^Rational[1, 2]) + 
           Complex[0, 2592] $CellContext`u) $CellContext`\[Eta]0$b[
           3, 1, 4][-1] + (31104 (Complex[0, -3] + 3^Rational[1, 2]) - 
           186624 $CellContext`u) $CellContext`\[Eta]0$b[1, 1, 1, 2][-1] + (
           Complex[0, 31104] (Complex[0, 1] + 3^Rational[1, 2]) + 
           62208 3^Rational[1, 2] $CellContext`u) $CellContext`\[Eta]0$b[
           1, 1, 1, 3][-1] + (5184 (Complex[0, -3] + 3^Rational[1, 2]) - 
           31104 $CellContext`u) $CellContext`\[Eta]0$b[
           1, 1, 1, 4][-1]) + $CellContext`Q0$[-1]^(-1) (743040 + 
         995328 $CellContext`\[Zeta]$[1][0]^2 + 
         248832 $CellContext`\[Zeta]$[1][0]^3 + 
         233280 $CellContext`\[Zeta]$[3][0] + $CellContext`\[Zeta]$[1][0] (
           1441152 + 186624 $CellContext`\[Zeta]$[3][0]) + 
         51840 $CellContext`\[Zeta]$[5][0] + (
           216 (159 + Complex[0, 73] 3^Rational[1, 2]) + 
           5184 (7 + Complex[0, 5] 3^Rational[1, 2]) $CellContext`\[Zeta]$[1][
             0] + $CellContext`u (432 (Complex[0, 180] - 37 3^Rational[1, 2]) - 
             10368 (Complex[0, -9] + 
              2 3^Rational[1, 2]) $CellContext`\[Zeta]$[1][
              0])) $CellContext`\[Eta]0$[2][1]^2 + (
           144 (1 + Complex[0, -25] 3^Rational[1, 2]) + 
           Complex[0, 2592] (Complex[0, 1] + 
             3^Rational[1, 2]) $CellContext`\[Zeta]$[1][0] + $CellContext`u (
             720 (Complex[0, -9] + 7 3^Rational[1, 2]) - 5184 
             3^Rational[1, 2] $CellContext`\[Zeta]$[1][
              0])) $CellContext`\[Eta]0$[3][1]^2 + (
           24 (237 + Complex[0, 89] 3^Rational[1, 2]) + 
           6912 (3 + Complex[0, 8] 3^Rational[1, 2]) $CellContext`\[Zeta]$[1][
              0]^2 + Complex[0, -6912] (Complex[0, -3] + 
             3^Rational[1, 2]) $CellContext`\[Zeta]$[1][0]^3 + 
           216 (43 + Complex[0, 71] 3^Rational[1, 2]) $CellContext`\[Zeta]$[
             3][0] + $CellContext`\[Zeta]$[1][0] (
             288 (171 + Complex[0, 110] 3^Rational[1, 2]) + 
             Complex[0, -5184] (Complex[0, -3] + 
               3^Rational[1, 2]) $CellContext`\[Zeta]$[3][
               0]) + $CellContext`u (
             144 (Complex[0, 7] - 30 3^Rational[1, 2]) - 
             20736 (Complex[0, -5] + 
              3 3^Rational[1, 2]) $CellContext`\[Zeta]$[1][0]^2 + 
             Complex[0, -41472] $CellContext`\[Zeta]$[1][
                0]^3 + $CellContext`\[Zeta]$[1][
               0] ((-5184) (Complex[0, -21] + 10 3^Rational[1, 2]) + 
               Complex[0, -31104] $CellContext`\[Zeta]$[3][0]) - 
             432 (Complex[0, -79] + 
              36 3^Rational[1, 2]) $CellContext`\[Zeta]$[3][0] + 
             Complex[0, -8640] $CellContext`\[Zeta]$[5][0]) + 
           Complex[0, -1440] (Complex[0, -3] + 
             3^Rational[1, 2]) $CellContext`\[Zeta]$[5][
             0]) $CellContext`\[Eta]0$[4][1] + ((-864) (-1)^Rational[1, 3] + 
           432 (Complex[0, -3] + 
             3^Rational[1, 2]) $CellContext`u) $CellContext`\[Eta]0$[4][
            1]^2 + $CellContext`\[Eta]0$[1][1]^3 (
           Complex[0, 31104] + (5184 (Complex[0, -3] + 3^Rational[1, 2]) + 
             31104 $CellContext`u) $CellContext`\[Eta]0$[2][1] + (
             Complex[0, 5184] (Complex[0, 1] + 3^Rational[1, 2]) - 10368 
             3^Rational[1, 2] $CellContext`u) $CellContext`\[Eta]0$[3][1] + (
             864 (Complex[0, -3] + 3^Rational[1, 2]) + 
             5184 $CellContext`u) $CellContext`\[Eta]0$[4][1]) + (
           24 (Complex[0, 481] + 237 3^Rational[1, 2]) + 
           288 (Complex[0, 115] - 97 3^Rational[1, 2]) $CellContext`\[Zeta]$[
             1][0] - 3456 (Complex[0, 13] + 
            7 3^Rational[1, 2]) $CellContext`\[Zeta]$[1][0]^2 - 
           144 (Complex[0, 83] + 47 3^Rational[1, 2]) $CellContext`\[Zeta]$[
            3][0] + $CellContext`u (
             Complex[0, 1728] (Complex[0, 7] + 5 3^Rational[1, 2]) + 
             576 (-99 + 
               Complex[0, -52] 3^Rational[1, 2]) $CellContext`\[Zeta]$[1][0] + 
             3456 (9 + Complex[0, -17] 
                3^Rational[1, 2]) $CellContext`\[Zeta]$[1][0]^2 + 
             288 (27 + Complex[0, -56] 
                3^Rational[1, 2]) $CellContext`\[Zeta]$[3][
               0])) $CellContext`\[Eta]0$[5][1] + (
           Complex[0, 24] (Complex[0, 721] + 3^Rational[1, 2]) + 
           192 (-69 + 
             Complex[0, -149] 3^Rational[1, 2]) $CellContext`\[Zeta]$[1][0] + 
           3456 (3 + Complex[0, 1] 3^Rational[1, 2]) $CellContext`\[Zeta]$[1][
              0]^2 + $CellContext`u ((-24) (Complex[0, 953] + 
               33 3^Rational[1, 2]) + 
             576 (Complex[0, -103] + 
               57 3^Rational[1, 2]) $CellContext`\[Zeta]$[1][0] + 
             Complex[0, 20736] $CellContext`\[Zeta]$[1][0]^2 + 
             Complex[0, 5616] $CellContext`\[Zeta]$[3][0]) + 
           936 (3 + Complex[0, 1] 3^Rational[1, 2]) $CellContext`\[Zeta]$[3][
             0]) $CellContext`\[Eta]0$[6][1] + (
           64 (Complex[0, -218] + 61 3^Rational[1, 2]) + 
           8640 (Complex[0, 2] + 3^Rational[1, 2]) $CellContext`\[Zeta]$[1][
             0] + $CellContext`u (20304 + Complex[0, -400] 3^Rational[1, 2] + 
             Complex[0, 4320] (Complex[0, 3] + 
               5 3^Rational[1, 2]) $CellContext`\[Zeta]$[1][
               0])) $CellContext`\[Eta]0$[7][1] + (
           48 (96 + Complex[0, 133] 3^Rational[1, 2]) + $CellContext`u (
             Complex[0, 15984] - 6768 3^Rational[1, 2] + 
             Complex[0, -6048] $CellContext`\[Zeta]$[1][0]) + 
           Complex[0, -1008] (Complex[0, -3] + 
             3^Rational[1, 2]) $CellContext`\[Zeta]$[1][
             0]) $CellContext`\[Eta]0$[8][
           1] + ((-24) (Complex[0, 113] + 65 3^Rational[1, 2]) + 
           48 (36 + Complex[0, -77] 
              3^Rational[1, 2]) $CellContext`u) $CellContext`\[Eta]0$[9][
           1] + (144 (3 + Complex[0, 1] 3^Rational[1, 2]) + 
           Complex[0, 864] $CellContext`u) $CellContext`\[Eta]0$[10][1] + (
           2592 (Complex[0, -43] + 2 3^Rational[1, 2]) + 
           62208 (Complex[0, -5] + 3^Rational[1, 2]) $CellContext`\[Zeta]$[1][
             0] + 62208 (Complex[0, -3] + 
             3^Rational[1, 2]) $CellContext`\[Zeta]$[1][0]^2 + 
           15552 (Complex[0, -3] + 3^Rational[1, 2]) $CellContext`\[Zeta]$[3][
             0] + $CellContext`u (222912 + 622080 $CellContext`\[Zeta]$[1][0] + 
             373248 $CellContext`\[Zeta]$[1][0]^2 + 
             93312 $CellContext`\[Zeta]$[3][0])) $CellContext`\[Eta]0$[1, 2][
           1] + (864 (102 + Complex[0, 23] 3^Rational[1, 2]) + 
           82944 (1 + Complex[0, 1] 3^Rational[1, 2]) $CellContext`\[Zeta]$[
             1][0] + Complex[0, 62208] (Complex[0, 1] + 
             3^Rational[1, 2]) $CellContext`\[Zeta]$[1][0]^2 + 
           Complex[0, 15552] (Complex[0, 1] + 
             3^Rational[1, 2]) $CellContext`\[Zeta]$[3][
             0] + $CellContext`u ((-8640) (Complex[0, -18] + 
               3^Rational[1, 2]) - 
             20736 (Complex[0, -9] + 
              5 3^Rational[1, 2]) $CellContext`\[Zeta]$[1][0] - 124416 
             3^Rational[1, 2] $CellContext`\[Zeta]$[1][0]^2 - 31104 
             3^Rational[1, 2] $CellContext`\[Zeta]$[3][
              0])) $CellContext`\[Eta]0$[1, 3][1] + (Complex[0, 42768] - 
           28800 3^Rational[1, 2] - 
           6912 (Complex[0, -3] + 8 3^Rational[1, 2]) $CellContext`\[Zeta]$[
            1][0] + 10368 (Complex[0, -3] + 
             3^Rational[1, 2]) $CellContext`\[Zeta]$[1][0]^2 + 
           2592 (Complex[0, -3] + 3^Rational[1, 2]) $CellContext`\[Zeta]$[3][
             0] + $CellContext`u (
             2592 (-39 + Complex[0, -14] 3^Rational[1, 2]) + 
             Complex[0, -20736] (Complex[0, -5] + 
               3 3^Rational[1, 2]) $CellContext`\[Zeta]$[1][0] + 
             62208 $CellContext`\[Zeta]$[1][0]^2 + 
             15552 $CellContext`\[Zeta]$[3][0])) $CellContext`\[Eta]0$[1, 4][
           1] + $CellContext`\[Eta]0$[1][1]^2 (-248832 - 
           186624 $CellContext`\[Zeta]$[1][
            0] + (15552 (5 + 
               Complex[0, 1] 3^Rational[1, 2]) + $CellContext`u (
               Complex[0, 155520] + 
               Complex[0, 186624] $CellContext`\[Zeta]$[1][0]) + 
             31104 (3 + Complex[0, 1] 3^Rational[1, 2]) $CellContext`\[Zeta]$[
               1][0]) $CellContext`\[Eta]0$[2][
             1] + ((-20736) (Complex[0, -1] + 3^Rational[1, 2]) - 
             31104 (Complex[0, 1] + 3^Rational[1, 2]) $CellContext`\[Zeta]$[
              1][0] + $CellContext`u (
               Complex[0, -5184] (Complex[0, -9] + 5 3^Rational[1, 2]) + 
               Complex[0, -62208] 
                3^Rational[1, 2] $CellContext`\[Zeta]$[1][
                 0])) $CellContext`\[Eta]0$[3][1] + (
             1728 (-3 + Complex[0, -8] 3^Rational[1, 2]) + $CellContext`u (
               5184 (Complex[0, -5] + 3 3^Rational[1, 2]) + 
               Complex[0, 31104] $CellContext`\[Zeta]$[1][0]) + 
             5184 (3 + Complex[0, 1] 3^Rational[1, 2]) $CellContext`\[Zeta]$[
               1][0]) $CellContext`\[Eta]0$[4][1] + (
             864 (Complex[0, 13] + 7 3^Rational[1, 2]) + 
             Complex[0, 864] (Complex[0, 9] + 
               17 3^Rational[1, 2]) $CellContext`u) $CellContext`\[Eta]0$[5][
             1] + (Complex[0, -864] (Complex[0, -3] + 3^Rational[1, 2]) + 
             Complex[0, -5184] $CellContext`u) $CellContext`\[Eta]0$[6][
             1] + ((-15552) (Complex[0, -3] + 3^Rational[1, 2]) - 
             93312 $CellContext`u) $CellContext`\[Eta]0$[1, 2][1] + (
             15552 (1 + Complex[0, -1] 3^Rational[1, 2]) + 
             31104 3^Rational[1, 2] $CellContext`u) $CellContext`\[Eta]0$[
             1, 3][1] + ((-2592) (Complex[0, -3] + 3^Rational[1, 2]) - 
             15552 $CellContext`u) $CellContext`\[Eta]0$[1, 4][
             1]) + $CellContext`\[Eta]0$[3][
           1] ((-288) (Complex[0, 103] + 3^Rational[1, 2]) + 
           82944 (Complex[0, -1] + 
             3^Rational[1, 2]) $CellContext`\[Zeta]$[1][0]^2 + 
           41472 (Complex[0, 1] + 
             3^Rational[1, 2]) $CellContext`\[Zeta]$[1][0]^3 + 
           864 (Complex[0, -30] + 19 3^Rational[1, 2]) $CellContext`\[Zeta]$[
             3][0] + $CellContext`\[Zeta]$[1][0] (
             1728 (Complex[0, -84] + 23 3^Rational[1, 2]) + 
             31104 (Complex[0, 1] + 3^Rational[1, 2]) $CellContext`\[Zeta]$[
               3][0]) + 8640 (Complex[0, 1] + 
             3^Rational[1, 2]) $CellContext`\[Zeta]$[5][0] + $CellContext`u (
             288 (387 + Complex[0, -20] 3^Rational[1, 2]) + 
             20736 (9 + 
               Complex[0, 5] 3^Rational[1, 2]) $CellContext`\[Zeta]$[1][0]^2 + 
             Complex[0, 82944] 3^Rational[1, 2] $CellContext`\[Zeta]$[1][0]^3 + 
             1728 (27 + 
               Complex[0, 10] 3^Rational[1, 2]) $CellContext`\[Zeta]$[3][
               0] + $CellContext`\[Zeta]$[1][0] (
               17280 (18 + Complex[0, 1] 3^Rational[1, 2]) + 
               Complex[0, 62208] 
                3^Rational[1, 2] $CellContext`\[Zeta]$[3][0]) + 
             Complex[0, 17280] 
              3^Rational[1, 2] $CellContext`\[Zeta]$[5][0]) + (
             48 (Complex[0, 39] - 55 3^Rational[1, 2]) + 
             864 (Complex[0, -3] + 3^Rational[1, 2]) $CellContext`\[Zeta]$[1][
               0] + $CellContext`u (
               288 (-22 + Complex[0, -9] 3^Rational[1, 2]) + 
               5184 $CellContext`\[Zeta]$[1][0])) $CellContext`\[Eta]0$[4][
             1] + (144 (13 + Complex[0, -7] 3^Rational[1, 2]) + 
             144 (Complex[0, 9] + 
               17 3^Rational[1, 2]) $CellContext`u) $CellContext`\[Eta]0$[5][
             1] + ((-144) (Complex[0, -3] + 3^Rational[1, 2]) - 
             864 $CellContext`u) $CellContext`\[Eta]0$[6][1] + (
             432 (3 + Complex[0, 1] 3^Rational[1, 2]) + 
             Complex[0, 2592] $CellContext`u) $CellContext`\[Eta]0$[1, 4][
             1]) + $CellContext`\[Eta]0$[2][1] (
           864 (-13 + Complex[0, -42] 3^Rational[1, 2]) + 
           Complex[0, -62208] (Complex[0, -5] + 
             3^Rational[1, 2]) $CellContext`\[Zeta]$[1][0]^2 + 
           Complex[0, -41472] (Complex[0, -3] + 
             3^Rational[1, 2]) $CellContext`\[Zeta]$[1][0]^3 + 
           864 (-81 + Complex[0, -14] 3^Rational[1, 2]) $CellContext`\[Zeta]$[
             3][0] + $CellContext`\[Zeta]$[1][0] (
             5184 (-43 + Complex[0, -10] 3^Rational[1, 2]) + 
             Complex[0, -31104] (Complex[0, -3] + 
               3^Rational[1, 2]) $CellContext`\[Zeta]$[3][
               0]) + $CellContext`u (Complex[0, -22464] + 
             Complex[0, -622080] $CellContext`\[Zeta]$[1][0]^2 + 
             Complex[0, -248832] $CellContext`\[Zeta]$[1][
                0]^3 + $CellContext`\[Zeta]$[1][0] (Complex[0, -445824] + 
               Complex[0, -186624] $CellContext`\[Zeta]$[3][0]) + 
             Complex[0, -139968] $CellContext`\[Zeta]$[3][0] + 
             Complex[0, -51840] $CellContext`\[Zeta]$[5][0]) + 
           Complex[0, -8640] (Complex[0, -3] + 
             3^Rational[1, 2]) $CellContext`\[Zeta]$[5][0] + (
             144 (Complex[0, 21] - 71 3^Rational[1, 2]) + 
             6912 (Complex[0, -3] + 3^Rational[1, 2]) $CellContext`\[Zeta]$[
               1][0] + $CellContext`u (
               864 (-19 + Complex[0, -12] 3^Rational[1, 2]) + 
               41472 $CellContext`\[Zeta]$[1][0])) $CellContext`\[Eta]0$[3][
             1] + (72 (131 + Complex[0, -19] 3^Rational[1, 2]) + 
             Complex[0, 3456] (Complex[0, 1] + 
               3^Rational[1, 2]) $CellContext`\[Zeta]$[1][
               0] + $CellContext`u (
               144 (Complex[0, 72] + 43 3^Rational[1, 2]) - 6912 
               3^Rational[1, 2] $CellContext`\[Zeta]$[1][
                0])) $CellContext`\[Eta]0$[4][1] + (Complex[0, 4032] - 2496 
             3^Rational[1, 2] + 
             576 (-17 + 
               Complex[0, -3] 
                3^Rational[1, 2]) $CellContext`u) $CellContext`\[Eta]0$[5][
             1] + (576 (1 + Complex[0, -1] 3^Rational[1, 2]) + 
             1152 3^Rational[1, 2] $CellContext`u) $CellContext`\[Eta]0$[6][
             1] + (3456 (3 + Complex[0, 1] 3^Rational[1, 2]) + 
             Complex[0, 20736] $CellContext`u) $CellContext`\[Eta]0$[1, 3][
             1] + ((-1728) (Complex[0, 1] + 3^Rational[1, 2]) + 
             Complex[0, -3456] 
              3^Rational[1, 2] $CellContext`u) $CellContext`\[Eta]0$[1, 4][
             1]) + (144 (-115 + Complex[0, -97] 3^Rational[1, 2]) + 
           3456 (13 + Complex[0, -7] 3^Rational[1, 2]) $CellContext`\[Zeta]$[
             1][0] + $CellContext`u (
             288 (Complex[0, -99] + 52 3^Rational[1, 2]) + 
             3456 (Complex[0, 9] + 17 3^Rational[1, 2]) $CellContext`\[Zeta]$[
               1][0])) $CellContext`\[Eta]0$[1, 5][1] + (
           48 (Complex[0, -165] + 271 3^Rational[1, 2]) + $CellContext`u (
             288 (103 + Complex[0, 48] 3^Rational[1, 2]) - 
             20736 $CellContext`\[Zeta]$[1][0]) - 
           3456 (Complex[0, -3] + 3^Rational[1, 2]) $CellContext`\[Zeta]$[1][
            0]) $CellContext`\[Eta]0$[1, 6][1] + (
           Complex[0, 4320] (Complex[0, 2] + 3^Rational[1, 2]) - 
           2160 (Complex[0, 3] + 
            5 3^Rational[1, 2]) $CellContext`u) $CellContext`\[Eta]0$[1, 7][
           1] + (504 (Complex[0, -3] + 3^Rational[1, 2]) + 
           3024 $CellContext`u) $CellContext`\[Eta]0$[1, 8][1] + (
           432 (Complex[0, 25] - 23 3^Rational[1, 2]) - 
           1728 (Complex[0, 15] + 19 3^Rational[1, 2]) $CellContext`\[Zeta]$[
            1][0] + $CellContext`u (
             864 (-19 + Complex[0, -18] 3^Rational[1, 2]) + 
             10368 (-1 + 
               Complex[0, -6] 3^Rational[1, 2]) $CellContext`\[Zeta]$[1][
               0])) $CellContext`\[Eta]0$[2, 3][1] + (
           72 (-167 + Complex[0, -209] 3^Rational[1, 2]) + 
           1728 (11 + Complex[0, 1] 3^Rational[1, 2]) $CellContext`\[Zeta]$[
             1][0] + $CellContext`u (
             144 (Complex[0, -252] + 101 3^Rational[1, 2]) + 
             3456 (Complex[0, 9] + 2 3^Rational[1, 2]) $CellContext`\[Zeta]$[
               1][0])) $CellContext`\[Eta]0$[2, 4][1] + (Complex[0, 8496] + 
           8112 3^Rational[1, 2] + 
           288 (-2 + Complex[0, 57] 
              3^Rational[1, 2]) $CellContext`u) $CellContext`\[Eta]0$[2, 5][
           1] + (Complex[0, -288] (Complex[0, -11] + 3^Rational[1, 2]) - 
           576 (Complex[0, 9] + 
            2 3^Rational[1, 2]) $CellContext`u) $CellContext`\[Eta]0$[2, 6][
           1] + (240 (Complex[0, 21] + 11 3^Rational[1, 2]) + $CellContext`u (
             2016 (-2 + Complex[0, 3] 3^Rational[1, 2]) - 
             5184 $CellContext`\[Zeta]$[1][0]) - 
           864 (Complex[0, -3] + 3^Rational[1, 2]) $CellContext`\[Zeta]$[1][
            0]) $CellContext`\[Eta]0$[3, 4][1] + (
           288 (-5 + Complex[0, 2] 3^Rational[1, 2]) - 
           144 (Complex[0, 9] + 
            11 3^Rational[1, 2]) $CellContext`u) $CellContext`\[Eta]0$[3, 5][
           1] + (144 (Complex[0, -3] + 3^Rational[1, 2]) + 
           864 $CellContext`u) $CellContext`\[Eta]0$[3, 6][
           1] + ((-72) (Complex[0, -3] + 3^Rational[1, 2]) - 
           432 $CellContext`u) $CellContext`\[Eta]0$[4, 5][1] + (
           31104 (5 + Complex[0, 1] 3^Rational[1, 2]) + $CellContext`u (
             Complex[0, 311040] + 
             Complex[0, 373248] $CellContext`\[Zeta]$[1][0]) + 
           62208 (3 + Complex[0, 1] 3^Rational[1, 2]) $CellContext`\[Zeta]$[
             1][0]) $CellContext`\[Eta]0$[1, 1, 2][
           1] + ((-41472) (Complex[0, -1] + 3^Rational[1, 2]) - 
           62208 (Complex[0, 1] + 3^Rational[1, 2]) $CellContext`\[Zeta]$[1][
            0] + $CellContext`u (10368 (-9 + Complex[0, -5] 3^Rational[1, 2]) + 
             Complex[0, -124416] 
              3^Rational[1, 2] $CellContext`\[Zeta]$[1][
               0])) $CellContext`\[Eta]0$[1, 1, 3][1] + (
           Complex[0, -3456] (Complex[0, -3] + 
             8 3^Rational[1, 2]) + $CellContext`u (
             10368 (Complex[0, -5] + 3 3^Rational[1, 2]) + 
             Complex[0, 62208] $CellContext`\[Zeta]$[1][0]) + 
           10368 (3 + Complex[0, 1] 3^Rational[1, 2]) $CellContext`\[Zeta]$[
             1][0]) $CellContext`\[Eta]0$[1, 1, 4][1] + $CellContext`\[Eta]0$[
           1][1] (Complex[0, -720576] + 
           Complex[0, -995328] $CellContext`\[Zeta]$[1][0] + 
           Complex[0, -373248] $CellContext`\[Zeta]$[1][0]^2 + 
           Complex[0, -93312] $CellContext`\[Zeta]$[3][0] + (
             2592 (Complex[0, -7] + 5 3^Rational[1, 2]) + 
             5184 (9 + Complex[0, 2] 
                3^Rational[1, 2]) $CellContext`u) $CellContext`\[Eta]0$[2][
              1]^2 + (1296 (Complex[0, 1] + 3^Rational[1, 2]) + 
             Complex[0, 2592] 
              3^Rational[1, 2] $CellContext`u) $CellContext`\[Eta]0$[3][
              1]^2 + (144 (Complex[0, -171] + 110 3^Rational[1, 2]) + 
             6912 (Complex[0, -3] + 8 3^Rational[1, 2]) $CellContext`\[Zeta]$[
               1][0] - 10368 (Complex[0, -3] + 
              3^Rational[1, 2]) $CellContext`\[Zeta]$[1][
               0]^2 + $CellContext`u (
               2592 (21 + Complex[0, 10] 3^Rational[1, 2]) + 
               20736 (5 + 
                 Complex[0, 3] 3^Rational[1, 2]) $CellContext`\[Zeta]$[1][0] - 
               62208 $CellContext`\[Zeta]$[1][0]^2 - 
               15552 $CellContext`\[Zeta]$[3][0]) - 
             2592 (Complex[0, -3] + 3^Rational[1, 2]) $CellContext`\[Zeta]$[
              3][0]) $CellContext`\[Eta]0$[4][1] + $CellContext`\[Eta]0$[3][
             1] (864 (-84 + Complex[0, -23] 3^Rational[1, 2]) + 
             Complex[0, -82944] (Complex[0, -1] + 
               3^Rational[1, 2]) $CellContext`\[Zeta]$[1][0] + 
             62208 (1 + 
               Complex[0, -1] 3^Rational[1, 2]) $CellContext`\[Zeta]$[1][0]^2 + 
             15552 (1 + 
               Complex[0, -1] 3^Rational[1, 2]) $CellContext`\[Zeta]$[3][
               0] + $CellContext`u (8640 (Complex[0, -18] + 3^Rational[1, 2]) + 
               20736 (Complex[0, -9] + 
                 5 3^Rational[1, 2]) $CellContext`\[Zeta]$[1][0] + 
               124416 3^Rational[1, 2] $CellContext`\[Zeta]$[1][0]^2 + 
               31104 3^Rational[1, 2] $CellContext`\[Zeta]$[3][0]) + (
               Complex[0, -432] (Complex[0, -3] + 3^Rational[1, 2]) + 
               Complex[0, -2592] $CellContext`u) $CellContext`\[Eta]0$[4][
               1]) + $CellContext`\[Eta]0$[2][
             1] ((-2592) (Complex[0, -43] + 10 3^Rational[1, 2]) - 
             62208 (Complex[0, -5] + 3^Rational[1, 2]) $CellContext`\[Zeta]$[
              1][0] - 62208 (Complex[0, -3] + 
              3^Rational[1, 2]) $CellContext`\[Zeta]$[1][
               0]^2 + $CellContext`u (-222912 - 
               622080 $CellContext`\[Zeta]$[1][0] - 
               373248 $CellContext`\[Zeta]$[1][0]^2 - 
               93312 $CellContext`\[Zeta]$[3][0]) - 
             15552 (Complex[0, -3] + 3^Rational[1, 2]) $CellContext`\[Zeta]$[
              3][0] + (Complex[0, -3456] (Complex[0, -3] + 3^Rational[1, 2]) + 
               Complex[0, -20736] $CellContext`u) $CellContext`\[Eta]0$[3][
               1] + (1728 (Complex[0, 1] + 3^Rational[1, 2]) + 
               Complex[0, 3456] 
                3^Rational[1, 2] $CellContext`u) $CellContext`\[Eta]0$[4][
               1]) + (144 (115 + Complex[0, 97] 3^Rational[1, 2]) + 
             Complex[0, 3456] (Complex[0, 13] + 
               7 3^Rational[1, 2]) $CellContext`\[Zeta]$[1][
               0] + $CellContext`u ((-288) (Complex[0, -99] + 
                 52 3^Rational[1, 2]) - 
               3456 (Complex[0, 9] + 
                17 3^Rational[1, 2]) $CellContext`\[Zeta]$[1][
                0])) $CellContext`\[Eta]0$[5][1] + (
             96 (Complex[0, 69] - 149 3^Rational[1, 2]) + 
             3456 (Complex[0, -3] + 3^Rational[1, 2]) $CellContext`\[Zeta]$[
               1][0] + $CellContext`u (
               288 (-103 + Complex[0, -57] 3^Rational[1, 2]) + 
               20736 $CellContext`\[Zeta]$[1][0])) $CellContext`\[Eta]0$[6][
             1] + (4320 (2 + Complex[0, -1] 3^Rational[1, 2]) + 
             2160 (Complex[0, 3] + 
               5 3^Rational[1, 2]) $CellContext`u) $CellContext`\[Eta]0$[7][
             1] + ((-504) (Complex[0, -3] + 3^Rational[1, 2]) - 
             3024 $CellContext`u) $CellContext`\[Eta]0$[8][1] + (
             Complex[0, -31104] (Complex[0, -5] + 
               3^Rational[1, 2]) + $CellContext`u (Complex[0, -311040] + 
               Complex[0, -373248] $CellContext`\[Zeta]$[1][0]) + 
             Complex[0, -62208] (Complex[0, -3] + 
               3^Rational[1, 2]) $CellContext`\[Zeta]$[1][
               0]) $CellContext`\[Eta]0$[1, 2][1] + (
             41472 (Complex[0, -1] + 3^Rational[1, 2]) + 
             62208 (Complex[0, 1] + 3^Rational[1, 2]) $CellContext`\[Zeta]$[
               1][0] + $CellContext`u (
               10368 (9 + Complex[0, 5] 3^Rational[1, 2]) + 
               Complex[0, 124416] 
                3^Rational[1, 2] $CellContext`\[Zeta]$[1][
                 0])) $CellContext`\[Eta]0$[1, 3][1] + (
             3456 (3 + Complex[0, 8] 
                3^Rational[1, 2]) + $CellContext`u ((-10368) (Complex[0, -5] + 
                 3 3^Rational[1, 2]) + 
               Complex[0, -62208] $CellContext`\[Zeta]$[1][0]) + 
             Complex[0, -10368] (Complex[0, -3] + 
               3^Rational[1, 2]) $CellContext`\[Zeta]$[1][
               0]) $CellContext`\[Eta]0$[1, 4][
             1] + ((-1728) (Complex[0, 13] + 7 3^Rational[1, 2]) + 
             1728 (9 + Complex[0, -17] 
                3^Rational[1, 2]) $CellContext`u) $CellContext`\[Eta]0$[1, 5][
             1] + (1728 (3 + Complex[0, 1] 3^Rational[1, 2]) + 
             Complex[0, 10368] $CellContext`u) $CellContext`\[Eta]0$[1, 6][
             1] + (Complex[0, 864] (Complex[0, 15] + 19 3^Rational[1, 2]) - 
             5184 (Complex[0, -1] + 
              6 3^Rational[1, 2]) $CellContext`u) $CellContext`\[Eta]0$[2, 3][
             1] + (864 (Complex[0, -11] + 3^Rational[1, 2]) + 
             1728 (9 + Complex[0, -2] 
                3^Rational[1, 2]) $CellContext`u) $CellContext`\[Eta]0$[2, 4][
             1] + (432 (3 + Complex[0, 1] 3^Rational[1, 2]) + 
             Complex[0, 2592] $CellContext`u) $CellContext`\[Eta]0$[3, 4][
             1] + (31104 (Complex[0, -3] + 3^Rational[1, 2]) + 
             186624 $CellContext`u) $CellContext`\[Eta]0$[1, 1, 2][1] + (
             Complex[0, 31104] (Complex[0, 1] + 3^Rational[1, 2]) - 62208 
             3^Rational[1, 2] $CellContext`u) $CellContext`\[Eta]0$[1, 1, 3][
             1] + (5184 (Complex[0, -3] + 3^Rational[1, 2]) + 
             31104 $CellContext`u) $CellContext`\[Eta]0$[1, 1, 4][1]) + (
           1728 (Complex[0, 13] + 7 3^Rational[1, 2]) + 
           Complex[0, 1728] (Complex[0, 9] + 
             17 3^Rational[1, 2]) $CellContext`u) $CellContext`\[Eta]0$[
           1, 1, 5][1] + (
           Complex[0, -1728] (Complex[0, -3] + 3^Rational[1, 2]) + 
           Complex[0, -10368] $CellContext`u) $CellContext`\[Eta]0$[1, 1, 6][
           1] + ((-5184) (Complex[0, -7] + 5 3^Rational[1, 2]) + 
           10368 (-9 + 
             Complex[0, -2] 
              3^Rational[1, 2]) $CellContext`u) $CellContext`\[Eta]0$[
           1, 2, 2][1] + (864 (15 + Complex[0, -19] 3^Rational[1, 2]) + 
           5184 (Complex[0, -1] + 
             6 3^Rational[1, 2]) $CellContext`u) $CellContext`\[Eta]0$[
           1, 2, 3][1] + ((-864) (Complex[0, -11] + 3^Rational[1, 2]) + 
           Complex[0, 1728] (Complex[0, 9] + 
             2 3^Rational[1, 2]) $CellContext`u) $CellContext`\[Eta]0$[
           1, 2, 4][1] + ((-2592) (Complex[0, 1] + 3^Rational[1, 2]) + 
           Complex[0, -5184] 
            3^Rational[1, 2] $CellContext`u) $CellContext`\[Eta]0$[1, 3, 3][
           1] + (Complex[0, -432] (Complex[0, -3] + 3^Rational[1, 2]) + 
           Complex[0, -2592] $CellContext`u) $CellContext`\[Eta]0$[1, 3, 4][
           1] + ((-15552) (Complex[0, -3] + 3^Rational[1, 2]) - 
           93312 $CellContext`u) $CellContext`\[Eta]0$[2, 1, 2][1] + (
           1728 (3 + Complex[0, -11] 3^Rational[1, 2]) + 
           10368 (Complex[0, -2] + 
             3 3^Rational[1, 2]) $CellContext`u) $CellContext`\[Eta]0$[
           2, 1, 3][1] + ((-864) (Complex[0, -11] + 3^Rational[1, 2]) + 
           Complex[0, 1728] (Complex[0, 9] + 
             2 3^Rational[1, 2]) $CellContext`u) $CellContext`\[Eta]0$[
           2, 1, 4][1] + (
           Complex[0, -432] (Complex[0, -3] + 3^Rational[1, 2]) + 
           Complex[0, -2592] $CellContext`u) $CellContext`\[Eta]0$[3, 1, 4][
           1] + ((-31104) (Complex[0, -3] + 3^Rational[1, 2]) - 
           186624 $CellContext`u) $CellContext`\[Eta]0$[1, 1, 1, 2][1] + (
           31104 (1 + Complex[0, -1] 3^Rational[1, 2]) + 
           62208 3^Rational[1, 2] $CellContext`u) $CellContext`\[Eta]0$[
           1, 1, 1, 3][1] + ((-5184) (Complex[0, -3] + 3^Rational[1, 2]) - 
           31104 $CellContext`u) $CellContext`\[Eta]0$[1, 1, 1, 4][
           1] + ((-2592) (Complex[0, -7] + 5 3^Rational[1, 2]) + 
           Complex[0, -5184] (Complex[0, -9] + 
             2 3^Rational[1, 2]) $CellContext`u) $CellContext`\[Eta]0$[2][
            1]^2 $CellContext`\[Eta]0$b[
           1][-1] + ((-1296) (Complex[0, 1] + 3^Rational[1, 2]) + 
           Complex[0, -2592] 
            3^Rational[1, 2] $CellContext`u) $CellContext`\[Eta]0$[3][
            1]^2 $CellContext`\[Eta]0$b[1][-1] + (
           144 (-115 + Complex[0, -97] 3^Rational[1, 2]) + 
           3456 (13 + Complex[0, -7] 3^Rational[1, 2]) $CellContext`\[Zeta]$[
             1][0] + $CellContext`u (
             288 (Complex[0, -99] + 52 3^Rational[1, 2]) + 
             3456 (Complex[0, 9] + 17 3^Rational[1, 2]) $CellContext`\[Zeta]$[
               1][0])) $CellContext`\[Eta]0$[5][1] $CellContext`\[Eta]0$b[
           1][-1] + (
           96 (Complex[0, -69] + 149 3^Rational[1, 2]) + $CellContext`u (
             288 (103 + Complex[0, 57] 3^Rational[1, 2]) - 
             20736 $CellContext`\[Zeta]$[1][0]) - 
           3456 (Complex[0, -3] + 3^Rational[1, 2]) $CellContext`\[Zeta]$[1][
            0]) $CellContext`\[Eta]0$[6][1] $CellContext`\[Eta]0$b[1][-1] + (
           Complex[0, 4320] (Complex[0, 2] + 3^Rational[1, 2]) - 
           2160 (Complex[0, 3] + 
            5 3^Rational[1, 2]) $CellContext`u) $CellContext`\[Eta]0$[7][
           1] $CellContext`\[Eta]0$b[1][-1] + (
           504 (Complex[0, -3] + 3^Rational[1, 2]) + 
           3024 $CellContext`u) $CellContext`\[Eta]0$[8][
           1] $CellContext`\[Eta]0$b[1][-1] + (
           31104 (5 + Complex[0, 1] 3^Rational[1, 2]) + $CellContext`u (
             Complex[0, 311040] + 
             Complex[0, 373248] $CellContext`\[Zeta]$[1][0]) + 
           62208 (3 + Complex[0, 1] 3^Rational[1, 2]) $CellContext`\[Zeta]$[
             1][0]) $CellContext`\[Eta]0$[1, 2][1] $CellContext`\[Eta]0$b[
           1][-1] + ((-41472) (Complex[0, -1] + 3^Rational[1, 2]) - 
           62208 (Complex[0, 1] + 3^Rational[1, 2]) $CellContext`\[Zeta]$[1][
            0] + $CellContext`u (10368 (-9 + Complex[0, -5] 3^Rational[1, 2]) + 
             Complex[0, -124416] 
              3^Rational[1, 2] $CellContext`\[Zeta]$[1][
               0])) $CellContext`\[Eta]0$[1, 3][1] $CellContext`\[Eta]0$b[
           1][-1] + (
           Complex[0, -3456] (Complex[0, -3] + 
             8 3^Rational[1, 2]) + $CellContext`u (
             10368 (Complex[0, -5] + 3 3^Rational[1, 2]) + 
             Complex[0, 62208] $CellContext`\[Zeta]$[1][0]) + 
           10368 (3 + Complex[0, 1] 3^Rational[1, 2]) $CellContext`\[Zeta]$[
             1][0]) $CellContext`\[Eta]0$[1, 4][1] $CellContext`\[Eta]0$b[
           1][-1] + (1728 (Complex[0, 13] + 7 3^Rational[1, 2]) + 
           Complex[0, 1728] (Complex[0, 9] + 
             17 3^Rational[1, 2]) $CellContext`u) $CellContext`\[Eta]0$[1, 5][
           1] $CellContext`\[Eta]0$b[1][-1] + (
           Complex[0, -1728] (Complex[0, -3] + 3^Rational[1, 2]) + 
           Complex[0, -10368] $CellContext`u) $CellContext`\[Eta]0$[1, 6][
           1] $CellContext`\[Eta]0$b[1][-1] + (
           864 (15 + Complex[0, -19] 3^Rational[1, 2]) + 
           5184 (Complex[0, -1] + 
             6 3^Rational[1, 2]) $CellContext`u) $CellContext`\[Eta]0$[2, 3][
           1] $CellContext`\[Eta]0$b[
           1][-1] + ((-864) (Complex[0, -11] + 3^Rational[1, 2]) + 
           Complex[0, 1728] (Complex[0, 9] + 
             2 3^Rational[1, 2]) $CellContext`u) $CellContext`\[Eta]0$[2, 4][
           1] $CellContext`\[Eta]0$b[1][-1] + (
           Complex[0, -432] (Complex[0, -3] + 3^Rational[1, 2]) + 
           Complex[0, -2592] $CellContext`u) $CellContext`\[Eta]0$[3, 4][
           1] $CellContext`\[Eta]0$b[
           1][-1] + ((-31104) (Complex[0, -3] + 3^Rational[1, 2]) - 
           186624 $CellContext`u) $CellContext`\[Eta]0$[1, 1, 2][
           1] $CellContext`\[Eta]0$b[1][-1] + (
           31104 (1 + Complex[0, -1] 3^Rational[1, 2]) + 
           62208 3^Rational[1, 2] $CellContext`u) $CellContext`\[Eta]0$[
           1, 1, 3][1] $CellContext`\[Eta]0$b[
           1][-1] + ((-5184) (Complex[0, -3] + 3^Rational[1, 2]) - 
           31104 $CellContext`u) $CellContext`\[Eta]0$[1, 1, 4][
           1] $CellContext`\[Eta]0$b[1][-1] + (
           15552 (5 + Complex[0, 1] 3^Rational[1, 2]) + $CellContext`u (
             Complex[0, 155520] + 
             Complex[0, 186624] $CellContext`\[Zeta]$[1][0]) + 
           31104 (3 + Complex[0, 1] 3^Rational[1, 2]) $CellContext`\[Zeta]$[
             1][0]) $CellContext`\[Eta]0$[2][
           1] $CellContext`\[Eta]0$b[
            1][-1]^2 + ((-20736) (Complex[0, -1] + 3^Rational[1, 2]) - 
           31104 (Complex[0, 1] + 3^Rational[1, 2]) $CellContext`\[Zeta]$[1][
            0] + $CellContext`u (
             Complex[0, -5184] (Complex[0, -9] + 5 3^Rational[1, 2]) + 
             Complex[0, -62208] 
              3^Rational[1, 2] $CellContext`\[Zeta]$[1][
               0])) $CellContext`\[Eta]0$[3][
           1] $CellContext`\[Eta]0$b[1][-1]^2 + (
           1728 (-3 + Complex[0, -8] 3^Rational[1, 2]) + $CellContext`u (
             5184 (Complex[0, -5] + 3 3^Rational[1, 2]) + 
             Complex[0, 31104] $CellContext`\[Zeta]$[1][0]) + 
           5184 (3 + Complex[0, 1] 3^Rational[1, 2]) $CellContext`\[Zeta]$[1][
             0]) $CellContext`\[Eta]0$[4][
           1] $CellContext`\[Eta]0$b[1][-1]^2 + (
           864 (Complex[0, 13] + 7 3^Rational[1, 2]) + 
           Complex[0, 864] (Complex[0, 9] + 
             17 3^Rational[1, 2]) $CellContext`u) $CellContext`\[Eta]0$[5][
           1] $CellContext`\[Eta]0$b[1][-1]^2 + (
           Complex[0, -864] (Complex[0, -3] + 3^Rational[1, 2]) + 
           Complex[0, -5184] $CellContext`u) $CellContext`\[Eta]0$[6][
           1] $CellContext`\[Eta]0$b[
            1][-1]^2 + ((-15552) (Complex[0, -3] + 3^Rational[1, 2]) - 
           93312 $CellContext`u) $CellContext`\[Eta]0$[1, 2][
           1] $CellContext`\[Eta]0$b[1][-1]^2 + (
           15552 (1 + Complex[0, -1] 3^Rational[1, 2]) + 
           31104 3^Rational[1, 2] $CellContext`u) $CellContext`\[Eta]0$[1, 3][
           1] $CellContext`\[Eta]0$b[
            1][-1]^2 + ((-2592) (Complex[0, -3] + 3^Rational[1, 2]) - 
           15552 $CellContext`u) $CellContext`\[Eta]0$[1, 4][
           1] $CellContext`\[Eta]0$b[
            1][-1]^2 + ((-5184) (Complex[0, -3] + 3^Rational[1, 2]) - 
           31104 $CellContext`u) $CellContext`\[Eta]0$[2][
           1] $CellContext`\[Eta]0$b[1][-1]^3 + (
           5184 (1 + Complex[0, -1] 3^Rational[1, 2]) + 
           10368 3^Rational[1, 2] $CellContext`u) $CellContext`\[Eta]0$[3][
           1] $CellContext`\[Eta]0$b[
            1][-1]^3 + ((-864) (Complex[0, -3] + 3^Rational[1, 2]) - 
           5184 $CellContext`u) $CellContext`\[Eta]0$[4][
           1] $CellContext`\[Eta]0$b[1][-1]^3 + (
           15552 (5 + Complex[0, -1] 3^Rational[1, 2]) + $CellContext`u (
             Complex[0, 155520] + 
             Complex[0, 186624] $CellContext`\[Zeta]$[1][0]) + 
           31104 (3 + Complex[0, -1] 3^Rational[1, 2]) $CellContext`\[Zeta]$[
             1][0]) $CellContext`\[Eta]0$[1][1]^2 $CellContext`\[Eta]0$b[
           2][-1] + ((-5184) (Complex[0, 3] + 3^Rational[1, 2]) + 
           31104 $CellContext`u) $CellContext`\[Eta]0$[1][
            1]^3 $CellContext`\[Eta]0$b[2][-1] + (18144 + 
           41472 $CellContext`\[Zeta]$[1][0]) $CellContext`\[Eta]0$[2][
           1] $CellContext`\[Eta]0$b[2][-1] + (
           144 (Complex[0, 39] + 31 3^Rational[1, 2]) + $CellContext`u (
             864 (-1 + Complex[0, 12] 3^Rational[1, 2]) - 
             10368 $CellContext`\[Zeta]$[1][0]) - 
           1728 (Complex[0, -3] + 7 3^Rational[1, 2]) $CellContext`\[Zeta]$[
            1][0]) $CellContext`\[Eta]0$[3][1] $CellContext`\[Eta]0$b[
           2][-1] + (72 (-167 + Complex[0, -17] 3^Rational[1, 2]) + 
           3456 (1 + Complex[0, -1] 3^Rational[1, 2]) $CellContext`\[Zeta]$[
             1][0] + $CellContext`u ((-144) (Complex[0, 72] + 
               7 3^Rational[1, 2]) + 
             6912 3^Rational[1, 2] $CellContext`\[Zeta]$[1][
               0])) $CellContext`\[Eta]0$[4][1] $CellContext`\[Eta]0$b[
           2][-1] + (48 (Complex[0, -57] + 61 3^Rational[1, 2]) + 
           288 (25 + Complex[0, 6] 
              3^Rational[1, 2]) $CellContext`u) $CellContext`\[Eta]0$[5][
           1] $CellContext`\[Eta]0$b[2][-1] + (
           Complex[0, 576] (Complex[0, 1] + 3^Rational[1, 2]) - 1152 
           3^Rational[1, 2] $CellContext`u) $CellContext`\[Eta]0$[6][
           1] $CellContext`\[Eta]0$b[2][-1] + (
           10368 (Complex[0, 1] + 3^Rational[1, 2]) + 
           Complex[0, 20736] 
            3^Rational[1, 2] $CellContext`u) $CellContext`\[Eta]0$[1, 2][
           1] $CellContext`\[Eta]0$b[2][-1] + (
           Complex[0, -3456] (Complex[0, -3] + 3^Rational[1, 2]) + 
           Complex[0, -20736] $CellContext`u) $CellContext`\[Eta]0$[1, 3][
           1] $CellContext`\[Eta]0$b[2][-1] + (
           1728 (Complex[0, 1] + 3^Rational[1, 2]) + 
           Complex[0, 3456] 
            3^Rational[1, 2] $CellContext`u) $CellContext`\[Eta]0$[1, 4][
           1] $CellContext`\[Eta]0$b[2][-1] + (
           216 (159 + Complex[0, -73] 3^Rational[1, 2]) + 
           5184 (7 + Complex[0, -5] 3^Rational[1, 2]) $CellContext`\[Zeta]$[
             1][0] + $CellContext`u (
             432 (Complex[0, 180] + 37 3^Rational[1, 2]) + 
             10368 (Complex[0, 9] + 2 3^Rational[1, 2]) $CellContext`\[Zeta]$[
               1][0])) $CellContext`\[Eta]0$b[
            2][-1]^2 + ((-2592) (Complex[0, 7] + 5 3^Rational[1, 2]) + 
           5184 (9 + Complex[0, -2] 
              3^Rational[1, 2]) $CellContext`u) $CellContext`\[Eta]0$[1][
           1] $CellContext`\[Eta]0$b[
            2][-1]^2 + ((-20736) (Complex[0, 1] + 3^Rational[1, 2]) - 
           31104 (Complex[0, -1] + 3^Rational[1, 2]) $CellContext`\[Zeta]$[1][
            0] + $CellContext`u (5184 (9 + Complex[0, -5] 3^Rational[1, 2]) + 
             Complex[0, -62208] 
              3^Rational[1, 2] $CellContext`\[Zeta]$[1][
               0])) $CellContext`\[Eta]0$[1][1]^2 $CellContext`\[Eta]0$b[
           3][-1] + (5184 (1 + Complex[0, 1] 3^Rational[1, 2]) - 10368 
           3^Rational[1, 2] $CellContext`u) $CellContext`\[Eta]0$[1][
            1]^3 $CellContext`\[Eta]0$b[3][-1] + (
           144 (Complex[0, -39] + 31 3^Rational[1, 2]) - 
           1728 (Complex[0, 3] + 7 3^Rational[1, 2]) $CellContext`\[Zeta]$[1][
            0] + $CellContext`u (864 (1 + Complex[0, 12] 3^Rational[1, 2]) + 
             10368 $CellContext`\[Zeta]$[1][0])) $CellContext`\[Eta]0$[2][
           1] $CellContext`\[Eta]0$b[3][-1] + (-10944 + 
           Complex[0, -15552] $CellContext`u + 
           10368 $CellContext`\[Zeta]$[1][0]) $CellContext`\[Eta]0$[3][
           1] $CellContext`\[Eta]0$b[3][-1] + (
           48 (Complex[0, 15] + 73 3^Rational[1, 2]) + $CellContext`u (
             288 (4 + Complex[0, 9] 3^Rational[1, 2]) - 
             5184 $CellContext`\[Zeta]$[1][0]) - 
           864 (Complex[0, -3] + 3^Rational[1, 2]) $CellContext`\[Zeta]$[1][
            0]) $CellContext`\[Eta]0$[4][1] $CellContext`\[Eta]0$b[3][-1] + (
           Complex[0, 576] (Complex[0, 4] + 3^Rational[1, 2]) - 
           144 (Complex[0, 9] + 
            11 3^Rational[1, 2]) $CellContext`u) $CellContext`\[Eta]0$[5][
           1] $CellContext`\[Eta]0$b[3][-1] + (
           144 (Complex[0, -3] + 3^Rational[1, 2]) + 
           864 $CellContext`u) $CellContext`\[Eta]0$[6][
           1] $CellContext`\[Eta]0$b[3][-1] + (
           Complex[0, -2592] (Complex[0, -3] + 3^Rational[1, 2]) + 
           Complex[0, -15552] $CellContext`u) $CellContext`\[Eta]0$[1, 2][
           1] $CellContext`\[Eta]0$b[3][-1] + (
           2592 (Complex[0, 1] + 3^Rational[1, 2]) + 
           Complex[0, 5184] 
            3^Rational[1, 2] $CellContext`u) $CellContext`\[Eta]0$[1, 3][
           1] $CellContext`\[Eta]0$b[3][-1] + (
           Complex[0, -432] (Complex[0, -3] + 3^Rational[1, 2]) + 
           Complex[0, -2592] $CellContext`u) $CellContext`\[Eta]0$[1, 4][
           1] $CellContext`\[Eta]0$b[3][-1] + (
           144 (1 + Complex[0, 25] 3^Rational[1, 2]) + 
           Complex[0, -2592] (Complex[0, -1] + 
             3^Rational[1, 2]) $CellContext`\[Zeta]$[1][
             0] + $CellContext`u ((-720) (Complex[0, 9] + 7 3^Rational[1, 2]) + 
             5184 3^Rational[1, 2] $CellContext`\[Zeta]$[1][
               0])) $CellContext`\[Eta]0$b[
            3][-1]^2 + ((-1296) (Complex[0, -1] + 3^Rational[1, 2]) + 
           Complex[0, -2592] 
            3^Rational[1, 2] $CellContext`u) $CellContext`\[Eta]0$[1][
           1] $CellContext`\[Eta]0$b[3][-1]^2 + $CellContext`\[Eta]0$[4][
           1] $CellContext`\[Eta]0$b[1][-1] (Complex[0, 24624] - 15840 
           3^Rational[1, 2] - 
           6912 (Complex[0, -3] + 8 3^Rational[1, 2]) $CellContext`\[Zeta]$[
            1][0] + 10368 (Complex[0, -3] + 
             3^Rational[1, 2]) $CellContext`\[Zeta]$[1][0]^2 + 
           2592 (Complex[0, -3] + 3^Rational[1, 2]) $CellContext`\[Zeta]$[3][
             0] + $CellContext`u (
             2592 (-21 + Complex[0, -10] 3^Rational[1, 2]) + 
             Complex[0, -20736] (Complex[0, -5] + 
               3 3^Rational[1, 2]) $CellContext`\[Zeta]$[1][0] + 
             62208 $CellContext`\[Zeta]$[1][0]^2 + 
             15552 $CellContext`\[Zeta]$[3][0]) + (
             1728 (Complex[0, 1] + 3^Rational[1, 2]) + 
             Complex[0, 3456] 
              3^Rational[1, 2] $CellContext`u) $CellContext`\[Eta]0$b[
             2][-1] + (Complex[0, -432] (Complex[0, -3] + 3^Rational[1, 2]) + 
             Complex[0, -2592] $CellContext`u) $CellContext`\[Eta]0$b[
             3][-1]) + (24 (237 + Complex[0, -89] 3^Rational[1, 2]) + 
           6912 (3 + Complex[0, -8] 3^Rational[1, 2]) $CellContext`\[Zeta]$[
              1][0]^2 + Complex[0, 6912] (Complex[0, 3] + 
             3^Rational[1, 2]) $CellContext`\[Zeta]$[1][0]^3 + 
           216 (43 + Complex[0, -71] 3^Rational[1, 2]) $CellContext`\[Zeta]$[
             3][0] + $CellContext`\[Zeta]$[1][0] (
             288 (171 + Complex[0, -110] 3^Rational[1, 2]) + 
             Complex[0, 5184] (Complex[0, 3] + 
               3^Rational[1, 2]) $CellContext`\[Zeta]$[3][
               0]) + $CellContext`u (
             144 (Complex[0, 7] + 30 3^Rational[1, 2]) + 
             20736 (Complex[0, 5] + 
               3 3^Rational[1, 2]) $CellContext`\[Zeta]$[1][0]^2 + 
             Complex[0, -41472] $CellContext`\[Zeta]$[1][
                0]^3 + $CellContext`\[Zeta]$[1][0] (
               5184 (Complex[0, 21] + 10 3^Rational[1, 2]) + 
               Complex[0, -31104] $CellContext`\[Zeta]$[3][0]) + 
             432 (Complex[0, 79] + 36 3^Rational[1, 2]) $CellContext`\[Zeta]$[
               3][0] + Complex[0, -8640] $CellContext`\[Zeta]$[5][0]) + 
           Complex[0, 1440] (Complex[0, 3] + 
             3^Rational[1, 2]) $CellContext`\[Zeta]$[5][
             0]) $CellContext`\[Eta]0$b[4][-1] + (
           Complex[0, 1728] (Complex[0, 3] + 
             8 3^Rational[1, 2]) + $CellContext`u ((-5184) (Complex[0, 5] + 
               3 3^Rational[1, 2]) + 
             Complex[0, 31104] $CellContext`\[Zeta]$[1][0]) + 
           5184 (3 + Complex[0, -1] 3^Rational[1, 2]) $CellContext`\[Zeta]$[
             1][0]) $CellContext`\[Eta]0$[1][1]^2 $CellContext`\[Eta]0$b[
           4][-1] + ((-864) (Complex[0, 3] + 3^Rational[1, 2]) + 
           5184 $CellContext`u) $CellContext`\[Eta]0$[1][
            1]^3 $CellContext`\[Eta]0$b[4][-1] + (
           72 (-167 + Complex[0, 17] 3^Rational[1, 2]) + 
           3456 (1 + Complex[0, 1] 3^Rational[1, 2]) $CellContext`\[Zeta]$[1][
             0] + $CellContext`u (144 (Complex[0, -72] + 7 3^Rational[1, 2]) - 
             6912 3^Rational[1, 2] $CellContext`\[Zeta]$[1][
              0])) $CellContext`\[Eta]0$[2][1] $CellContext`\[Eta]0$b[
           4][-1] + (48 (Complex[0, -15] + 73 3^Rational[1, 2]) - 
           864 (Complex[0, 3] + 3^Rational[1, 2]) $CellContext`\[Zeta]$[1][
            0] + $CellContext`u (
             Complex[0, 288] (Complex[0, 4] + 9 3^Rational[1, 2]) + 
             5184 $CellContext`\[Zeta]$[1][0])) $CellContext`\[Eta]0$[3][
           1] $CellContext`\[Eta]0$b[4][-1] + $CellContext`\[Eta]0$[1][
           1] ((-144) (Complex[0, 171] + 110 3^Rational[1, 2]) - 
           6912 (Complex[0, 3] + 8 3^Rational[1, 2]) $CellContext`\[Zeta]$[1][
            0] + 10368 (Complex[0, 3] + 
             3^Rational[1, 2]) $CellContext`\[Zeta]$[1][
              0]^2 + $CellContext`u (
             2592 (21 + Complex[0, -10] 3^Rational[1, 2]) + 
             20736 (5 + 
               Complex[0, -3] 3^Rational[1, 2]) $CellContext`\[Zeta]$[1][0] - 
             62208 $CellContext`\[Zeta]$[1][0]^2 - 
             15552 $CellContext`\[Zeta]$[3][0]) + 
           2592 (Complex[0, 3] + 3^Rational[1, 2]) $CellContext`\[Zeta]$[3][
             0] + (1728 (Complex[0, -1] + 3^Rational[1, 2]) + 
             Complex[0, 3456] 
              3^Rational[1, 2] $CellContext`u) $CellContext`\[Eta]0$[2][1] + (
             Complex[0, 432] (Complex[0, 3] + 3^Rational[1, 2]) + 
             Complex[0, -2592] $CellContext`u) $CellContext`\[Eta]0$[3][
             1]) $CellContext`\[Eta]0$b[4][-1] - 
         864 $CellContext`\[Eta]0$[4][1] $CellContext`\[Eta]0$b[
          4][-1] + (72 (Complex[0, 3] + 3^Rational[1, 2]) - 
           432 $CellContext`u) $CellContext`\[Eta]0$[5][
           1] $CellContext`\[Eta]0$b[4][-1] + (864 (-1)^Rational[2, 3] - 
           432 (Complex[0, 3] + 
            3^Rational[1, 2]) $CellContext`u) $CellContext`\[Eta]0$b[
            4][-1]^2 + $CellContext`\[Eta]0$[1][1]^2 $CellContext`\[Eta]0$b[
           1][-1] (Complex[
            0, -93312] + ((-15552) (Complex[0, -3] + 3^Rational[1, 2]) - 
             93312 $CellContext`u) $CellContext`\[Eta]0$[2][1] + (
             15552 (1 + Complex[0, -1] 3^Rational[1, 2]) + 
             31104 3^Rational[1, 2] $CellContext`u) $CellContext`\[Eta]0$[3][
             1] + ((-2592) (Complex[0, -3] + 3^Rational[1, 2]) - 
             15552 $CellContext`u) $CellContext`\[Eta]0$[4][1] + (
             15552 (Complex[0, 3] + 3^Rational[1, 2]) - 
             93312 $CellContext`u) $CellContext`\[Eta]0$b[2][-1] + (
             Complex[0, -15552] (Complex[0, -1] + 3^Rational[1, 2]) + 
             31104 3^Rational[1, 2] $CellContext`u) $CellContext`\[Eta]0$b[
             3][-1] + (2592 (Complex[0, 3] + 3^Rational[1, 2]) - 
             15552 $CellContext`u) $CellContext`\[Eta]0$b[
             4][-1]) + $CellContext`\[Eta]0$b[1][-1]^3 (
           Complex[0, -31104] + (5184 (Complex[0, 3] + 3^Rational[1, 2]) - 
             31104 $CellContext`u) $CellContext`\[Eta]0$b[2][-1] + (
             Complex[0, -5184] (Complex[0, -1] + 3^Rational[1, 2]) + 
             10368 3^Rational[1, 2] $CellContext`u) $CellContext`\[Eta]0$b[
             3][-1] + (864 (Complex[0, 3] + 3^Rational[1, 2]) - 
             5184 $CellContext`u) $CellContext`\[Eta]0$b[
             4][-1]) + $CellContext`\[Eta]0$[1][1] $CellContext`\[Eta]0$b[
           3][-1] (864 (84 + Complex[0, -23] 3^Rational[1, 2]) + 
           82944 (1 + Complex[0, -1] 3^Rational[1, 2]) $CellContext`\[Zeta]$[
             1][0] + Complex[0, -62208] (Complex[0, -1] + 
             3^Rational[1, 2]) $CellContext`\[Zeta]$[1][0]^2 + 
           Complex[0, -15552] (Complex[0, -1] + 
             3^Rational[1, 2]) $CellContext`\[Zeta]$[3][0] + $CellContext`u (
             8640 (Complex[0, 18] + 3^Rational[1, 2]) + 
             20736 (Complex[0, 9] + 5 3^Rational[1, 2]) $CellContext`\[Zeta]$[
               1][0] + 124416 3^Rational[1, 2] $CellContext`\[Zeta]$[1][0]^2 + 
             31104 3^Rational[1, 2] $CellContext`\[Zeta]$[3][0]) + (
             Complex[0, 864] (Complex[0, 3] + 7 3^Rational[1, 2]) + 
             Complex[0, -5184] $CellContext`u) $CellContext`\[Eta]0$[2][1] + 
           Complex[0, -5184] $CellContext`\[Eta]0$[3][1] + (
             432 (3 + Complex[0, 1] 3^Rational[1, 2]) + 
             Complex[0, 2592] $CellContext`u) $CellContext`\[Eta]0$[4][1] + (
             432 (3 + Complex[0, -1] 3^Rational[1, 2]) + 
             Complex[0, 2592] $CellContext`u) $CellContext`\[Eta]0$b[
             4][-1]) + $CellContext`\[Eta]0$[3][1] $CellContext`\[Eta]0$b[
           1][-1] (864 (84 + Complex[0, 23] 3^Rational[1, 2]) + 
           82944 (1 + Complex[0, 1] 3^Rational[1, 2]) $CellContext`\[Zeta]$[
             1][0] + Complex[0, 62208] (Complex[0, 1] + 
             3^Rational[1, 2]) $CellContext`\[Zeta]$[1][0]^2 + 
           Complex[0, 15552] (Complex[0, 1] + 
             3^Rational[1, 2]) $CellContext`\[Zeta]$[3][
             0] + $CellContext`u ((-8640) (Complex[0, -18] + 
               3^Rational[1, 2]) - 
             20736 (Complex[0, -9] + 
              5 3^Rational[1, 2]) $CellContext`\[Zeta]$[1][0] - 124416 
             3^Rational[1, 2] $CellContext`\[Zeta]$[1][0]^2 - 31104 
             3^Rational[1, 2] $CellContext`\[Zeta]$[3][0]) + (
             432 (3 + Complex[0, 1] 3^Rational[1, 2]) + 
             Complex[0, 2592] $CellContext`u) $CellContext`\[Eta]0$[4][1] + (
             864 (-3 + Complex[0, -7] 3^Rational[1, 2]) + 
             Complex[0, -5184] $CellContext`u) $CellContext`\[Eta]0$b[2][-1] + 
           Complex[0, 5184] $CellContext`\[Eta]0$b[3][-1] + (
             432 (3 + Complex[0, -1] 3^Rational[1, 2]) + 
             Complex[0, 2592] $CellContext`u) $CellContext`\[Eta]0$b[
             4][-1]) + $CellContext`\[Eta]0$[1][
           1] $CellContext`\[Eta]0$b[1][-1]^2 (
           Complex[0, 93312] + (15552 (Complex[0, -3] + 3^Rational[1, 2]) + 
             93312 $CellContext`u) $CellContext`\[Eta]0$[2][1] + (
             Complex[0, 15552] (Complex[0, 1] + 3^Rational[1, 2]) - 31104 
             3^Rational[1, 2] $CellContext`u) $CellContext`\[Eta]0$[3][1] + (
             2592 (Complex[0, -3] + 3^Rational[1, 2]) + 
             15552 $CellContext`u) $CellContext`\[Eta]0$[4][
             1] + ((-15552) (Complex[0, 3] + 3^Rational[1, 2]) + 
             93312 $CellContext`u) $CellContext`\[Eta]0$b[2][-1] + (
             15552 (1 + Complex[0, 1] 3^Rational[1, 2]) - 31104 
             3^Rational[1, 2] $CellContext`u) $CellContext`\[Eta]0$b[
             3][-1] + ((-2592) (Complex[0, 3] + 3^Rational[1, 2]) + 
             15552 $CellContext`u) $CellContext`\[Eta]0$b[
             4][-1]) + $CellContext`\[Eta]0$[2][1] $CellContext`\[Eta]0$b[
           1][-1] (2592 (Complex[0, -43] + 10 3^Rational[1, 2]) + 
           62208 (Complex[0, -5] + 3^Rational[1, 2]) $CellContext`\[Zeta]$[1][
             0] + 62208 (Complex[0, -3] + 
             3^Rational[1, 2]) $CellContext`\[Zeta]$[1][0]^2 + 
           15552 (Complex[0, -3] + 3^Rational[1, 2]) $CellContext`\[Zeta]$[3][
             0] + $CellContext`u (222912 + 622080 $CellContext`\[Zeta]$[1][0] + 
             373248 $CellContext`\[Zeta]$[1][0]^2 + 
             93312 $CellContext`\[Zeta]$[3][0]) + (
             3456 (3 + Complex[0, 1] 3^Rational[1, 2]) + 
             Complex[0, 20736] $CellContext`u) $CellContext`\[Eta]0$[3][
             1] + ((-1728) (Complex[0, 1] + 3^Rational[1, 2]) + 
             Complex[0, -3456] 
              3^Rational[1, 2] $CellContext`u) $CellContext`\[Eta]0$[4][1] + 
           Complex[0, 20736] $CellContext`\[Eta]0$b[2][-1] + (
             864 (3 + Complex[0, -7] 3^Rational[1, 2]) + 
             Complex[0, 5184] $CellContext`u) $CellContext`\[Eta]0$b[
             3][-1] + ((-1728) (Complex[0, -1] + 3^Rational[1, 2]) + 
             Complex[0, -3456] 
              3^Rational[1, 2] $CellContext`u) $CellContext`\[Eta]0$b[
             4][-1]) + $CellContext`\[Eta]0$[1][1] $CellContext`\[Eta]0$b[
           2][-1] (2592 (Complex[0, 43] + 10 3^Rational[1, 2]) + 
           62208 (Complex[0, 5] + 3^Rational[1, 2]) $CellContext`\[Zeta]$[1][
             0] + 62208 (Complex[0, 3] + 
             3^Rational[1, 2]) $CellContext`\[Zeta]$[1][
              0]^2 + $CellContext`u (-222912 - 
             622080 $CellContext`\[Zeta]$[1][0] - 
             373248 $CellContext`\[Zeta]$[1][0]^2 - 
             93312 $CellContext`\[Zeta]$[3][0]) + 
           15552 (Complex[0, 3] + 3^Rational[1, 2]) $CellContext`\[Zeta]$[3][
             0] + Complex[0, -20736] $CellContext`\[Eta]0$[2][1] + (
             864 (3 + Complex[0, 7] 3^Rational[1, 2]) + 
             Complex[0, 5184] $CellContext`u) $CellContext`\[Eta]0$[3][
             1] + ((-1728) (Complex[0, 1] + 3^Rational[1, 2]) + 
             Complex[0, -3456] 
              3^Rational[1, 2] $CellContext`u) $CellContext`\[Eta]0$[4][1] + (
             3456 (3 + Complex[0, -1] 3^Rational[1, 2]) + 
             Complex[0, 20736] $CellContext`u) $CellContext`\[Eta]0$b[
             3][-1] + ((-1728) (Complex[0, -1] + 3^Rational[1, 2]) + 
             Complex[0, -3456] 
              3^Rational[1, 2] $CellContext`u) $CellContext`\[Eta]0$b[
             4][-1]) + (24 (Complex[0, -481] + 237 3^Rational[1, 2]) - 
           288 (Complex[0, 115] + 97 3^Rational[1, 2]) $CellContext`\[Zeta]$[
            1][0] - 3456 (Complex[0, -13] + 
            7 3^Rational[1, 2]) $CellContext`\[Zeta]$[1][0]^2 + 
           144 (Complex[0, 83] - 47 3^Rational[1, 2]) $CellContext`\[Zeta]$[
             3][0] + $CellContext`u (
             1728 (7 + Complex[0, 5] 3^Rational[1, 2]) + 
             576 (99 + Complex[0, -52] 
                3^Rational[1, 2]) $CellContext`\[Zeta]$[1][0] + 
             3456 (-9 + 
               Complex[0, -17] 3^Rational[1, 2]) $CellContext`\[Zeta]$[1][
                0]^2 + 288 (-27 + 
               Complex[0, -56] 3^Rational[1, 2]) $CellContext`\[Zeta]$[3][
               0])) $CellContext`\[Eta]0$b[5][-1] + (
           144 (-115 + Complex[0, 97] 3^Rational[1, 2]) + 
           3456 (13 + Complex[0, 7] 3^Rational[1, 2]) $CellContext`\[Zeta]$[
             1][0] + $CellContext`u ((-288) (Complex[0, 99] + 
               52 3^Rational[1, 2]) - 
             3456 (Complex[0, -9] + 
              17 3^Rational[1, 2]) $CellContext`\[Zeta]$[1][
              0])) $CellContext`\[Eta]0$[1][1] $CellContext`\[Eta]0$b[
           5][-1] + (864 (Complex[0, -13] + 7 3^Rational[1, 2]) + 
           864 (9 + Complex[0, 17] 
              3^Rational[1, 2]) $CellContext`u) $CellContext`\[Eta]0$[1][
            1]^2 $CellContext`\[Eta]0$b[5][-1] + (
           48 (Complex[0, 57] + 61 3^Rational[1, 2]) + 
           288 (-25 + 
             Complex[0, 6] 
              3^Rational[1, 2]) $CellContext`u) $CellContext`\[Eta]0$[2][
           1] $CellContext`\[Eta]0$b[5][-1] + (
           Complex[0, -576] (Complex[0, -4] + 3^Rational[1, 2]) + 
           144 (Complex[0, -9] + 
             11 3^Rational[1, 2]) $CellContext`u) $CellContext`\[Eta]0$[3][
           1] $CellContext`\[Eta]0$b[5][-1] + (
           72 (Complex[0, -3] + 3^Rational[1, 2]) + 
           432 $CellContext`u) $CellContext`\[Eta]0$[4][
           1] $CellContext`\[Eta]0$b[5][-1] + (
           Complex[0, -24] (Complex[0, -721] + 3^Rational[1, 2]) + 
           192 (-69 + Complex[0, 149] 3^Rational[1, 2]) $CellContext`\[Zeta]$[
             1][0] + 3456 (3 + 
             Complex[0, -1] 3^Rational[1, 2]) $CellContext`\[Zeta]$[1][
              0]^2 + $CellContext`u (
             24 (Complex[0, -953] + 33 3^Rational[1, 2]) - 
             576 (Complex[0, 103] + 
              57 3^Rational[1, 2]) $CellContext`\[Zeta]$[1][0] + 
             Complex[0, 20736] $CellContext`\[Zeta]$[1][0]^2 + 
             Complex[0, 5616] $CellContext`\[Zeta]$[3][0]) + 
           936 (3 + Complex[0, -1] 3^Rational[1, 2]) $CellContext`\[Zeta]$[3][
             0]) $CellContext`\[Eta]0$b[6][-1] + (
           96 (Complex[0, 69] + 149 3^Rational[1, 2]) - 
           3456 (Complex[0, 3] + 3^Rational[1, 2]) $CellContext`\[Zeta]$[1][
            0] + $CellContext`u (288 (-103 + Complex[0, 57] 3^Rational[1, 2]) + 
             20736 $CellContext`\[Zeta]$[1][0])) $CellContext`\[Eta]0$[1][
           1] $CellContext`\[Eta]0$b[6][-1] + (
           Complex[0, 864] (Complex[0, 3] + 3^Rational[1, 2]) + 
           Complex[0, -5184] $CellContext`u) $CellContext`\[Eta]0$[1][
            1]^2 $CellContext`\[Eta]0$b[6][-1] + (
           Complex[0, -576] (Complex[0, -1] + 3^Rational[1, 2]) + 
           1152 3^Rational[1, 2] $CellContext`u) $CellContext`\[Eta]0$[2][
           1] $CellContext`\[Eta]0$b[6][-1] + (
           144 (Complex[0, 3] + 3^Rational[1, 2]) - 
           864 $CellContext`u) $CellContext`\[Eta]0$[3][
           1] $CellContext`\[Eta]0$b[6][-1] + (
           64 (Complex[0, 218] + 61 3^Rational[1, 2]) + 
           8640 (Complex[0, -2] + 3^Rational[1, 2]) $CellContext`\[Zeta]$[1][
             0] + $CellContext`u (-20304 + Complex[0, -400] 3^Rational[1, 2] + 
             4320 (3 + Complex[0, 5] 3^Rational[1, 2]) $CellContext`\[Zeta]$[
               1][0])) $CellContext`\[Eta]0$b[7][-1] + (
           Complex[0, -4320] (Complex[0, -2] + 3^Rational[1, 2]) + 
           2160 (Complex[0, -3] + 
             5 3^Rational[1, 2]) $CellContext`u) $CellContext`\[Eta]0$[1][
           1] $CellContext`\[Eta]0$b[7][-1] + (
           48 (96 + Complex[0, -133] 3^Rational[1, 2]) + $CellContext`u (
             144 (Complex[0, 111] + 47 3^Rational[1, 2]) + 
             Complex[0, -6048] $CellContext`\[Zeta]$[1][0]) + 
           Complex[0, 1008] (Complex[0, 3] + 
             3^Rational[1, 2]) $CellContext`\[Zeta]$[1][
             0]) $CellContext`\[Eta]0$b[8][-1] + (
           504 (Complex[0, 3] + 3^Rational[1, 2]) - 
           3024 $CellContext`u) $CellContext`\[Eta]0$[1][
           1] $CellContext`\[Eta]0$b[8][-1] + (Complex[0, 2712] - 1560 
           3^Rational[1, 2] + 
           48 (-36 + Complex[0, -77] 
              3^Rational[1, 2]) $CellContext`u) $CellContext`\[Eta]0$b[
           9][-1] + (144 (3 + Complex[0, -1] 3^Rational[1, 2]) + 
           Complex[0, 864] $CellContext`u) $CellContext`\[Eta]0$b[10][-1] + (
           2592 (Complex[0, 43] + 2 3^Rational[1, 2]) + 
           62208 (Complex[0, 5] + 3^Rational[1, 2]) $CellContext`\[Zeta]$[1][
             0] + 62208 (Complex[0, 3] + 
             3^Rational[1, 2]) $CellContext`\[Zeta]$[1][
              0]^2 + $CellContext`u (-222912 - 
             622080 $CellContext`\[Zeta]$[1][0] - 
             373248 $CellContext`\[Zeta]$[1][0]^2 - 
             93312 $CellContext`\[Zeta]$[3][0]) + 
           15552 (Complex[0, 3] + 3^Rational[1, 2]) $CellContext`\[Zeta]$[3][
             0]) $CellContext`\[Eta]0$b[1, 2][-1] + (
           31104 (5 + Complex[0, -1] 3^Rational[1, 2]) + $CellContext`u (
             Complex[0, 311040] + 
             Complex[0, 373248] $CellContext`\[Zeta]$[1][0]) + 
           62208 (3 + Complex[0, -1] 3^Rational[1, 2]) $CellContext`\[Zeta]$[
             1][0]) $CellContext`\[Eta]0$[1][1] $CellContext`\[Eta]0$b[
           1, 2][-1] + ((-15552) (Complex[0, 3] + 3^Rational[1, 2]) + 
           93312 $CellContext`u) $CellContext`\[Eta]0$[1][
            1]^2 $CellContext`\[Eta]0$b[1, 2][-1] + (
           10368 (Complex[0, -1] + 3^Rational[1, 2]) + 
           Complex[0, 20736] 
            3^Rational[1, 2] $CellContext`u) $CellContext`\[Eta]0$[2][
           1] $CellContext`\[Eta]0$b[1, 2][-1] + (
           Complex[0, 2592] (Complex[0, 3] + 3^Rational[1, 2]) + 
           Complex[0, -15552] $CellContext`u) $CellContext`\[Eta]0$[3][
           1] $CellContext`\[Eta]0$b[1, 2][-1] + (
           864 (102 + Complex[0, -23] 3^Rational[1, 2]) + 
           82944 (1 + Complex[0, -1] 3^Rational[1, 2]) $CellContext`\[Zeta]$[
             1][0] + Complex[0, -62208] (Complex[0, -1] + 
             3^Rational[1, 2]) $CellContext`\[Zeta]$[1][0]^2 + 
           Complex[0, -15552] (Complex[0, -1] + 
             3^Rational[1, 2]) $CellContext`\[Zeta]$[3][0] + $CellContext`u (
             8640 (Complex[0, 18] + 3^Rational[1, 2]) + 
             20736 (Complex[0, 9] + 5 3^Rational[1, 2]) $CellContext`\[Zeta]$[
               1][0] + 124416 3^Rational[1, 2] $CellContext`\[Zeta]$[1][0]^2 + 
             31104 3^Rational[1, 2] $CellContext`\[Zeta]$[3][
               0])) $CellContext`\[Eta]0$b[
           1, 3][-1] + ((-41472) (Complex[0, 1] + 3^Rational[1, 2]) - 
           62208 (Complex[0, -1] + 3^Rational[1, 2]) $CellContext`\[Zeta]$[1][
            0] + $CellContext`u (10368 (9 + Complex[0, -5] 3^Rational[1, 2]) + 
             Complex[0, -124416] 
              3^Rational[1, 2] $CellContext`\[Zeta]$[1][
               0])) $CellContext`\[Eta]0$[1][1] $CellContext`\[Eta]0$b[
           1, 3][-1] + (15552 (1 + Complex[0, 1] 3^Rational[1, 2]) - 31104 
           3^Rational[1, 2] $CellContext`u) $CellContext`\[Eta]0$[1][
            1]^2 $CellContext`\[Eta]0$b[1, 3][-1] + (
           Complex[0, 3456] (Complex[0, 3] + 3^Rational[1, 2]) + 
           Complex[0, -20736] $CellContext`u) $CellContext`\[Eta]0$[2][
           1] $CellContext`\[Eta]0$b[1, 3][-1] + (
           2592 (Complex[0, -1] + 3^Rational[1, 2]) + 
           Complex[0, 5184] 
            3^Rational[1, 2] $CellContext`u) $CellContext`\[Eta]0$[3][
           1] $CellContext`\[Eta]0$b[
           1, 3][-1] + ((-144) (Complex[0, 297] + 200 3^Rational[1, 2]) - 
           6912 (Complex[0, 3] + 8 3^Rational[1, 2]) $CellContext`\[Zeta]$[1][
            0] + 10368 (Complex[0, 3] + 
             3^Rational[1, 2]) $CellContext`\[Zeta]$[1][
              0]^2 + $CellContext`u (
             2592 (39 + Complex[0, -14] 3^Rational[1, 2]) + 
             20736 (5 + 
               Complex[0, -3] 3^Rational[1, 2]) $CellContext`\[Zeta]$[1][0] - 
             62208 $CellContext`\[Zeta]$[1][0]^2 - 
             15552 $CellContext`\[Zeta]$[3][0]) + 
           2592 (Complex[0, 3] + 3^Rational[1, 2]) $CellContext`\[Zeta]$[3][
             0]) $CellContext`\[Eta]0$b[1, 4][-1] + (
           Complex[0, 3456] (Complex[0, 3] + 
             8 3^Rational[1, 2]) + $CellContext`u ((-10368) (Complex[0, 5] + 
               3 3^Rational[1, 2]) + 
             Complex[0, 62208] $CellContext`\[Zeta]$[1][0]) + 
           10368 (3 + Complex[0, -1] 3^Rational[1, 2]) $CellContext`\[Zeta]$[
             1][0]) $CellContext`\[Eta]0$[1][1] $CellContext`\[Eta]0$b[
           1, 4][-1] + ((-2592) (Complex[0, 3] + 3^Rational[1, 2]) + 
           15552 $CellContext`u) $CellContext`\[Eta]0$[1][
            1]^2 $CellContext`\[Eta]0$b[1, 4][-1] + (
           1728 (Complex[0, -1] + 3^Rational[1, 2]) + 
           Complex[0, 3456] 
            3^Rational[1, 2] $CellContext`u) $CellContext`\[Eta]0$[2][
           1] $CellContext`\[Eta]0$b[1, 4][-1] + (
           Complex[0, 432] (Complex[0, 3] + 3^Rational[1, 2]) + 
           Complex[0, -2592] $CellContext`u) $CellContext`\[Eta]0$[3][
           1] $CellContext`\[Eta]0$b[1, 4][-1] + $CellContext`\[Eta]0$[1][
           1] $CellContext`\[Eta]0$b[1][-1] (497664 + 
           373248 $CellContext`\[Zeta]$[1][0] + (
             Complex[0, -31104] (Complex[0, -5] + 
               3^Rational[1, 2]) + $CellContext`u (Complex[0, -311040] + 
               Complex[0, -373248] $CellContext`\[Zeta]$[1][0]) + 
             Complex[0, -62208] (Complex[0, -3] + 
               3^Rational[1, 2]) $CellContext`\[Zeta]$[1][
               0]) $CellContext`\[Eta]0$[2][1] + (
             41472 (Complex[0, -1] + 3^Rational[1, 2]) + 
             62208 (Complex[0, 1] + 3^Rational[1, 2]) $CellContext`\[Zeta]$[
               1][0] + $CellContext`u (
               10368 (9 + Complex[0, 5] 3^Rational[1, 2]) + 
               Complex[0, 124416] 
                3^Rational[1, 2] $CellContext`\[Zeta]$[1][
                 0])) $CellContext`\[Eta]0$[3][1] + (
             3456 (3 + Complex[0, 8] 
                3^Rational[1, 2]) + $CellContext`u ((-10368) (Complex[0, -5] + 
                 3 3^Rational[1, 2]) + 
               Complex[0, -62208] $CellContext`\[Zeta]$[1][0]) + 
             Complex[0, -10368] (Complex[0, -3] + 
               3^Rational[1, 2]) $CellContext`\[Zeta]$[1][
               0]) $CellContext`\[Eta]0$[4][
             1] + ((-1728) (Complex[0, 13] + 7 3^Rational[1, 2]) + 
             1728 (9 + Complex[0, -17] 
                3^Rational[1, 2]) $CellContext`u) $CellContext`\[Eta]0$[5][
             1] + (1728 (3 + Complex[0, 1] 3^Rational[1, 2]) + 
             Complex[0, 10368] $CellContext`u) $CellContext`\[Eta]0$[6][1] + (
             31104 (Complex[0, -3] + 3^Rational[1, 2]) + 
             186624 $CellContext`u) $CellContext`\[Eta]0$[1, 2][1] + (
             Complex[0, 31104] (Complex[0, 1] + 3^Rational[1, 2]) - 62208 
             3^Rational[1, 2] $CellContext`u) $CellContext`\[Eta]0$[1, 3][
             1] + (5184 (Complex[0, -3] + 3^Rational[1, 2]) + 
             31104 $CellContext`u) $CellContext`\[Eta]0$[1, 4][1] + (
             Complex[0, 31104] (Complex[0, 5] + 
               3^Rational[1, 2]) + $CellContext`u (Complex[0, -311040] + 
               Complex[0, -373248] $CellContext`\[Zeta]$[1][0]) + 
             Complex[0, 62208] (Complex[0, 3] + 
               3^Rational[1, 2]) $CellContext`\[Zeta]$[1][
               0]) $CellContext`\[Eta]0$b[2][-1] + (
             41472 (Complex[0, 1] + 3^Rational[1, 2]) + 
             62208 (Complex[0, -1] + 3^Rational[1, 2]) $CellContext`\[Zeta]$[
               1][0] + $CellContext`u (
               Complex[0, 10368] (Complex[0, 9] + 5 3^Rational[1, 2]) + 
               Complex[0, 124416] 
                3^Rational[1, 2] $CellContext`\[Zeta]$[1][
                 0])) $CellContext`\[Eta]0$b[3][-1] + (
             3456 (3 + Complex[0, -8] 3^Rational[1, 2]) + $CellContext`u (
               10368 (Complex[0, 5] + 3 3^Rational[1, 2]) + 
               Complex[0, -62208] $CellContext`\[Zeta]$[1][0]) + 
             Complex[0, 10368] (Complex[0, 3] + 
               3^Rational[1, 2]) $CellContext`\[Zeta]$[1][
               0]) $CellContext`\[Eta]0$b[
             4][-1] + ((-1728) (Complex[0, -13] + 7 3^Rational[1, 2]) + 
             1728 (-9 + 
               Complex[0, -17] 
                3^Rational[1, 2]) $CellContext`u) $CellContext`\[Eta]0$b[
             5][-1] + (1728 (3 + Complex[0, -1] 3^Rational[1, 2]) + 
             Complex[0, 10368] $CellContext`u) $CellContext`\[Eta]0$b[
             6][-1] + (31104 (Complex[0, 3] + 3^Rational[1, 2]) - 
             186624 $CellContext`u) $CellContext`\[Eta]0$b[1, 2][-1] + (
             Complex[0, -31104] (Complex[0, -1] + 3^Rational[1, 2]) + 
             62208 3^Rational[1, 2] $CellContext`u) $CellContext`\[Eta]0$b[
             1, 3][-1] + (5184 (Complex[0, 3] + 3^Rational[1, 2]) - 
             31104 $CellContext`u) $CellContext`\[Eta]0$b[
             1, 4][-1]) + $CellContext`\[Eta]0$b[
           3][-1] ((-288) (Complex[0, -103] + 3^Rational[1, 2]) + 
           82944 (Complex[0, 1] + 
             3^Rational[1, 2]) $CellContext`\[Zeta]$[1][0]^2 + 
           41472 (Complex[0, -1] + 
             3^Rational[1, 2]) $CellContext`\[Zeta]$[1][0]^3 + 
           864 (Complex[0, 30] + 19 3^Rational[1, 2]) $CellContext`\[Zeta]$[
             3][0] + $CellContext`\[Zeta]$[1][0] (
             1728 (Complex[0, 84] + 23 3^Rational[1, 2]) + 
             31104 (Complex[0, -1] + 3^Rational[1, 2]) $CellContext`\[Zeta]$[
               3][0]) + 8640 (Complex[0, -1] + 
             3^Rational[1, 2]) $CellContext`\[Zeta]$[5][0] + $CellContext`u (
             288 (-387 + Complex[0, -20] 3^Rational[1, 2]) + 
             Complex[0, 20736] (Complex[0, 9] + 
               5 3^Rational[1, 2]) $CellContext`\[Zeta]$[1][0]^2 + 
             Complex[0, 82944] 3^Rational[1, 2] $CellContext`\[Zeta]$[1][0]^3 + 
             1728 (-27 + 
               Complex[0, 10] 3^Rational[1, 2]) $CellContext`\[Zeta]$[3][
               0] + $CellContext`\[Zeta]$[1][0] (
               Complex[0, 17280] (Complex[0, 18] + 3^Rational[1, 2]) + 
               Complex[0, 62208] 
                3^Rational[1, 2] $CellContext`\[Zeta]$[3][0]) + 
             Complex[0, 17280] 
              3^Rational[1, 2] $CellContext`\[Zeta]$[5][0]) + ((-48) (
               Complex[0, 39] + 55 3^Rational[1, 2]) + $CellContext`u (
               288 (22 + Complex[0, -9] 3^Rational[1, 2]) - 
               5184 $CellContext`\[Zeta]$[1][0]) + 
             864 (Complex[0, 3] + 3^Rational[1, 2]) $CellContext`\[Zeta]$[1][
               0]) $CellContext`\[Eta]0$b[4][-1] + (
             144 (13 + Complex[0, 7] 3^Rational[1, 2]) + 
             144 (Complex[0, 9] - 17 
               3^Rational[1, 2]) $CellContext`u) $CellContext`\[Eta]0$b[
             5][-1] + ((-144) (Complex[0, 3] + 3^Rational[1, 2]) + 
             864 $CellContext`u) $CellContext`\[Eta]0$b[6][-1] + (
             432 (3 + Complex[0, -1] 3^Rational[1, 2]) + 
             Complex[0, 2592] $CellContext`u) $CellContext`\[Eta]0$b[
             1, 4][-1]) + $CellContext`\[Eta]0$b[1][-1]^2 (-248832 - 
           186624 $CellContext`\[Zeta]$[1][
            0] + (15552 (5 + 
               Complex[0, -1] 3^Rational[1, 2]) + $CellContext`u (
               Complex[0, 155520] + 
               Complex[0, 186624] $CellContext`\[Zeta]$[1][0]) + 
             31104 (3 + 
               Complex[0, -1] 3^Rational[1, 2]) $CellContext`\[Zeta]$[1][
               0]) $CellContext`\[Eta]0$b[
             2][-1] + ((-20736) (Complex[0, 1] + 3^Rational[1, 2]) - 
             31104 (Complex[0, -1] + 3^Rational[1, 2]) $CellContext`\[Zeta]$[
              1][0] + $CellContext`u (
               5184 (9 + Complex[0, -5] 3^Rational[1, 2]) + 
               Complex[0, -62208] 
                3^Rational[1, 2] $CellContext`\[Zeta]$[1][
                 0])) $CellContext`\[Eta]0$b[3][-1] + (
             Complex[0, 1728] (Complex[0, 3] + 
               8 3^Rational[1, 2]) + $CellContext`u ((-5184) (Complex[0, 5] + 
                 3 3^Rational[1, 2]) + 
               Complex[0, 31104] $CellContext`\[Zeta]$[1][0]) + 
             5184 (3 + Complex[0, -1] 3^Rational[1, 2]) $CellContext`\[Zeta]$[
               1][0]) $CellContext`\[Eta]0$b[4][-1] + (
             864 (Complex[0, -13] + 7 3^Rational[1, 2]) + 
             864 (9 + Complex[0, 17] 
                3^Rational[1, 2]) $CellContext`u) $CellContext`\[Eta]0$b[
             5][-1] + (Complex[0, 864] (Complex[0, 3] + 3^Rational[1, 2]) + 
             Complex[0, -5184] $CellContext`u) $CellContext`\[Eta]0$b[
             6][-1] + ((-15552) (Complex[0, 3] + 3^Rational[1, 2]) + 
             93312 $CellContext`u) $CellContext`\[Eta]0$b[1, 2][-1] + (
             15552 (1 + Complex[0, 1] 3^Rational[1, 2]) - 31104 
             3^Rational[1, 2] $CellContext`u) $CellContext`\[Eta]0$b[
             1, 3][-1] + ((-2592) (Complex[0, 3] + 3^Rational[1, 2]) + 
             15552 $CellContext`u) $CellContext`\[Eta]0$b[
             1, 4][-1]) + $CellContext`\[Eta]0$b[2][-1] (
           Complex[0, 864] (Complex[0, 13] + 42 3^Rational[1, 2]) + 
           Complex[0, 62208] (Complex[0, 5] + 
             3^Rational[1, 2]) $CellContext`\[Zeta]$[1][0]^2 + 
           Complex[0, 41472] (Complex[0, 3] + 
             3^Rational[1, 2]) $CellContext`\[Zeta]$[1][0]^3 + 
           Complex[0, 864] (Complex[0, 81] + 
             14 3^Rational[1, 2]) $CellContext`\[Zeta]$[3][
             0] + $CellContext`\[Zeta]$[1][0] (
             Complex[0, 5184] (Complex[0, 43] + 10 3^Rational[1, 2]) + 
             Complex[0, 31104] (Complex[0, 3] + 
               3^Rational[1, 2]) $CellContext`\[Zeta]$[3][
               0]) + $CellContext`u (Complex[0, -22464] + 
             Complex[0, -622080] $CellContext`\[Zeta]$[1][0]^2 + 
             Complex[0, -248832] $CellContext`\[Zeta]$[1][
                0]^3 + $CellContext`\[Zeta]$[1][0] (Complex[0, -445824] + 
               Complex[0, -186624] $CellContext`\[Zeta]$[3][0]) + 
             Complex[0, -139968] $CellContext`\[Zeta]$[3][0] + 
             Complex[0, -51840] $CellContext`\[Zeta]$[5][0]) + 
           Complex[0, 8640] (Complex[0, 3] + 
             3^Rational[1, 2]) $CellContext`\[Zeta]$[5][
             0] + ((-144) (Complex[0, 21] + 
               71 3^Rational[1, 2]) + $CellContext`u (
               864 (19 + Complex[0, -12] 3^Rational[1, 2]) - 
               41472 $CellContext`\[Zeta]$[1][0]) + 
             6912 (Complex[0, 3] + 3^Rational[1, 2]) $CellContext`\[Zeta]$[1][
               0]) $CellContext`\[Eta]0$b[3][-1] + (
             72 (131 + Complex[0, 19] 3^Rational[1, 2]) + 
             Complex[0, -3456] (Complex[0, -1] + 
               3^Rational[1, 2]) $CellContext`\[Zeta]$[1][
               0] + $CellContext`u (
               144 (Complex[0, 72] - 43 3^Rational[1, 2]) + 
               6912 3^Rational[1, 2] $CellContext`\[Zeta]$[1][
                 0])) $CellContext`\[Eta]0$b[
             4][-1] + ((-192) (Complex[0, 21] + 13 3^Rational[1, 2]) + 
             576 (17 + Complex[0, -3] 
                3^Rational[1, 2]) $CellContext`u) $CellContext`\[Eta]0$b[
             5][-1] + (576 (1 + Complex[0, 1] 3^Rational[1, 2]) - 1152 
             3^Rational[1, 2] $CellContext`u) $CellContext`\[Eta]0$b[
             6][-1] + (3456 (3 + Complex[0, -1] 3^Rational[1, 2]) + 
             Complex[0, 20736] $CellContext`u) $CellContext`\[Eta]0$b[
             1, 3][-1] + ((-1728) (Complex[0, -1] + 3^Rational[1, 2]) + 
             Complex[0, -3456] 
              3^Rational[1, 2] $CellContext`u) $CellContext`\[Eta]0$b[
             1, 4][-1]) + (144 (-115 + Complex[0, 97] 3^Rational[1, 2]) + 
           3456 (13 + Complex[0, 7] 3^Rational[1, 2]) $CellContext`\[Zeta]$[
             1][0] + $CellContext`u ((-288) (Complex[0, 99] + 
               52 3^Rational[1, 2]) - 
             3456 (Complex[0, -9] + 
              17 3^Rational[1, 2]) $CellContext`\[Zeta]$[1][
              0])) $CellContext`\[Eta]0$b[1, 5][-1] + (
           1728 (Complex[0, -13] + 7 3^Rational[1, 2]) + 
           1728 (9 + Complex[0, 17] 
              3^Rational[1, 2]) $CellContext`u) $CellContext`\[Eta]0$[1][
           1] $CellContext`\[Eta]0$b[1, 5][-1] + (
           48 (Complex[0, 165] + 271 3^Rational[1, 2]) - 
           3456 (Complex[0, 3] + 3^Rational[1, 2]) $CellContext`\[Zeta]$[1][
            0] + $CellContext`u (288 (-103 + Complex[0, 48] 3^Rational[1, 2]) + 
             20736 $CellContext`\[Zeta]$[1][0])) $CellContext`\[Eta]0$b[
           1, 6][-1] + (Complex[0, 1728] (Complex[0, 3] + 3^Rational[1, 2]) + 
           Complex[0, -10368] $CellContext`u) $CellContext`\[Eta]0$[1][
           1] $CellContext`\[Eta]0$b[1, 6][-1] + (
           Complex[0, -4320] (Complex[0, -2] + 3^Rational[1, 2]) + 
           2160 (Complex[0, -3] + 
             5 3^Rational[1, 2]) $CellContext`u) $CellContext`\[Eta]0$b[
           1, 7][-1] + (504 (Complex[0, 3] + 3^Rational[1, 2]) - 
           3024 $CellContext`u) $CellContext`\[Eta]0$b[
           1, 8][-1] + ((-432) (Complex[0, 25] + 23 3^Rational[1, 2]) + 
           1728 (Complex[0, 15] - 19 3^Rational[1, 2]) $CellContext`\[Zeta]$[
             1][0] + $CellContext`u (
             864 (19 + Complex[0, -18] 3^Rational[1, 2]) + 
             10368 (1 + 
               Complex[0, -6] 3^Rational[1, 2]) $CellContext`\[Zeta]$[1][
               0])) $CellContext`\[Eta]0$b[2, 3][-1] + (
           864 (15 + Complex[0, 19] 3^Rational[1, 2]) - 
           5184 (Complex[0, 1] + 
            6 3^Rational[1, 2]) $CellContext`u) $CellContext`\[Eta]0$[1][
           1] $CellContext`\[Eta]0$b[2, 3][-1] + (
           72 (-167 + Complex[0, 209] 3^Rational[1, 2]) + 
           1728 (11 + Complex[0, -1] 3^Rational[1, 2]) $CellContext`\[Zeta]$[
             1][0] + $CellContext`u ((-144) (Complex[0, 252] + 
               101 3^Rational[1, 2]) - 
             3456 (Complex[0, -9] + 2 3^Rational[1, 2]) $CellContext`\[Zeta]$[
              1][0])) $CellContext`\[Eta]0$b[
           2, 4][-1] + ((-864) (Complex[0, 11] + 3^Rational[1, 2]) + 
           1728 (9 + Complex[0, 2] 
              3^Rational[1, 2]) $CellContext`u) $CellContext`\[Eta]0$[1][
           1] $CellContext`\[Eta]0$b[2, 4][-1] + (Complex[0, -8496] + 
           8112 3^Rational[1, 2] + 
           288 (2 + Complex[0, 57] 
              3^Rational[1, 2]) $CellContext`u) $CellContext`\[Eta]0$b[
           2, 5][-1] + (Complex[0, 288] (Complex[0, 11] + 3^Rational[1, 2]) + 
           576 (Complex[0, -9] + 
             2 3^Rational[1, 2]) $CellContext`u) $CellContext`\[Eta]0$b[
           2, 6][-1] + (240 (Complex[0, -21] + 11 3^Rational[1, 2]) - 
           864 (Complex[0, 3] + 3^Rational[1, 2]) $CellContext`\[Zeta]$[1][
            0] + $CellContext`u (2016 (2 + Complex[0, 3] 3^Rational[1, 2]) + 
             5184 $CellContext`\[Zeta]$[1][0])) $CellContext`\[Eta]0$b[
           3, 4][-1] + (Complex[0, 432] (Complex[0, 3] + 3^Rational[1, 2]) + 
           Complex[0, -2592] $CellContext`u) $CellContext`\[Eta]0$[1][
           1] $CellContext`\[Eta]0$b[3, 4][-1] + (
           288 (-5 + Complex[0, -2] 3^Rational[1, 2]) + 
           144 (Complex[0, -9] + 
             11 3^Rational[1, 2]) $CellContext`u) $CellContext`\[Eta]0$b[
           3, 5][-1] + (144 (Complex[0, 3] + 3^Rational[1, 2]) - 
           864 $CellContext`u) $CellContext`\[Eta]0$b[
           3, 6][-1] + ((-72) (Complex[0, 3] + 3^Rational[1, 2]) + 
           432 $CellContext`u) $CellContext`\[Eta]0$b[4, 5][-1] + (
           31104 (5 + Complex[0, -1] 3^Rational[1, 2]) + $CellContext`u (
             Complex[0, 311040] + 
             Complex[0, 373248] $CellContext`\[Zeta]$[1][0]) + 
           62208 (3 + Complex[0, -1] 3^Rational[1, 2]) $CellContext`\[Zeta]$[
             1][0]) $CellContext`\[Eta]0$b[
           1, 1, 2][-1] + ((-31104) (Complex[0, 3] + 3^Rational[1, 2]) + 
           186624 $CellContext`u) $CellContext`\[Eta]0$[1][
           1] $CellContext`\[Eta]0$b[
           1, 1, 2][-1] + ((-41472) (Complex[0, 1] + 3^Rational[1, 2]) - 
           62208 (Complex[0, -1] + 3^Rational[1, 2]) $CellContext`\[Zeta]$[1][
            0] + $CellContext`u (10368 (9 + Complex[0, -5] 3^Rational[1, 2]) + 
             Complex[0, -124416] 
              3^Rational[1, 2] $CellContext`\[Zeta]$[1][
               0])) $CellContext`\[Eta]0$b[1, 1, 3][-1] + (
           31104 (1 + Complex[0, 1] 3^Rational[1, 2]) - 62208 
           3^Rational[1, 2] $CellContext`u) $CellContext`\[Eta]0$[1][
           1] $CellContext`\[Eta]0$b[1, 1, 3][-1] + (
           Complex[0, 3456] (Complex[0, 3] + 
             8 3^Rational[1, 2]) + $CellContext`u ((-10368) (Complex[0, 5] + 
               3 3^Rational[1, 2]) + 
             Complex[0, 62208] $CellContext`\[Zeta]$[1][0]) + 
           10368 (3 + Complex[0, -1] 3^Rational[1, 2]) $CellContext`\[Zeta]$[
             1][0]) $CellContext`\[Eta]0$b[
           1, 1, 4][-1] + ((-5184) (Complex[0, 3] + 3^Rational[1, 2]) + 
           31104 $CellContext`u) $CellContext`\[Eta]0$[1][
           1] $CellContext`\[Eta]0$b[1, 1, 4][-1] + $CellContext`\[Eta]0$b[
           1][-1] (Complex[0, 720576] + 
           Complex[0, 995328] $CellContext`\[Zeta]$[1][0] + 
           Complex[0, 373248] $CellContext`\[Zeta]$[1][0]^2 + 
           Complex[0, 93312] $CellContext`\[Zeta]$[3][0] + (
             2592 (Complex[0, 7] + 5 3^Rational[1, 2]) + 
             Complex[0, 5184] (Complex[0, 9] + 
               2 3^Rational[1, 2]) $CellContext`u) $CellContext`\[Eta]0$b[
              2][-1]^2 + (1296 (Complex[0, -1] + 3^Rational[1, 2]) + 
             Complex[0, 2592] 
              3^Rational[1, 2] $CellContext`u) $CellContext`\[Eta]0$b[
              3][-1]^2 + (144 (Complex[0, 171] + 110 3^Rational[1, 2]) + 
             6912 (Complex[0, 3] + 8 3^Rational[1, 2]) $CellContext`\[Zeta]$[
               1][0] - 10368 (Complex[0, 3] + 
              3^Rational[1, 2]) $CellContext`\[Zeta]$[1][0]^2 - 
             2592 (Complex[0, 3] + 3^Rational[1, 2]) $CellContext`\[Zeta]$[3][
              0] + $CellContext`u (
               2592 (-21 + Complex[0, 10] 3^Rational[1, 2]) + 
               Complex[0, 20736] (Complex[0, 5] + 
                 3 3^Rational[1, 2]) $CellContext`\[Zeta]$[1][0] + 
               62208 $CellContext`\[Zeta]$[1][0]^2 + 
               15552 $CellContext`\[Zeta]$[3][0])) $CellContext`\[Eta]0$b[
             4][-1] + $CellContext`\[Eta]0$b[3][-1] (
             Complex[0, 864] (Complex[0, 84] + 23 3^Rational[1, 2]) + 
             Complex[0, 82944] (Complex[0, 1] + 
               3^Rational[1, 2]) $CellContext`\[Zeta]$[1][0] + 
             62208 (1 + 
               Complex[0, 1] 3^Rational[1, 2]) $CellContext`\[Zeta]$[1][0]^2 + 
             15552 (1 + Complex[0, 1] 3^Rational[1, 2]) $CellContext`\[Zeta]$[
               3][0] + $CellContext`u ((-8640) (Complex[0, 18] + 
                 3^Rational[1, 2]) - 
               20736 (Complex[0, 9] + 
                5 3^Rational[1, 2]) $CellContext`\[Zeta]$[1][0] - 124416 
               3^Rational[1, 2] $CellContext`\[Zeta]$[1][0]^2 - 31104 
               3^Rational[1, 2] $CellContext`\[Zeta]$[3][0]) + (
               Complex[0, 432] (Complex[0, 3] + 3^Rational[1, 2]) + 
               Complex[0, -2592] $CellContext`u) $CellContext`\[Eta]0$b[
               4][-1]) + $CellContext`\[Eta]0$b[
             2][-1] ((-2592) (Complex[0, 43] + 10 3^Rational[1, 2]) - 
             62208 (Complex[0, 5] + 3^Rational[1, 2]) $CellContext`\[Zeta]$[
              1][0] - 62208 (Complex[0, 3] + 
              3^Rational[1, 2]) $CellContext`\[Zeta]$[1][0]^2 - 
             15552 (Complex[0, 3] + 3^Rational[1, 2]) $CellContext`\[Zeta]$[
              3][0] + $CellContext`u (222912 + 
               622080 $CellContext`\[Zeta]$[1][0] + 
               373248 $CellContext`\[Zeta]$[1][0]^2 + 
               93312 $CellContext`\[Zeta]$[3][0]) + (
               Complex[0, 3456] (Complex[0, 3] + 3^Rational[1, 2]) + 
               Complex[0, -20736] $CellContext`u) $CellContext`\[Eta]0$b[
               3][-1] + (1728 (Complex[0, -1] + 3^Rational[1, 2]) + 
               Complex[0, 3456] 
                3^Rational[1, 2] $CellContext`u) $CellContext`\[Eta]0$b[
               4][-1]) + (144 (115 + Complex[0, -97] 3^Rational[1, 2]) + 
             3456 (-13 + 
               Complex[0, -7] 3^Rational[1, 2]) $CellContext`\[Zeta]$[1][
               0] + $CellContext`u (
               288 (Complex[0, 99] + 52 3^Rational[1, 2]) + 
               3456 (Complex[0, -9] + 
                 17 3^Rational[1, 2]) $CellContext`\[Zeta]$[1][
                 0])) $CellContext`\[Eta]0$b[
             5][-1] + ((-96) (Complex[0, 69] + 
               149 3^Rational[1, 2]) + $CellContext`u (
               288 (103 + Complex[0, -57] 3^Rational[1, 2]) - 
               20736 $CellContext`\[Zeta]$[1][0]) + 
             3456 (Complex[0, 3] + 3^Rational[1, 2]) $CellContext`\[Zeta]$[1][
               0]) $CellContext`\[Eta]0$b[6][-1] + (
             4320 (2 + Complex[0, 1] 3^Rational[1, 2]) - 
             2160 (Complex[0, -3] + 
              5 3^Rational[1, 2]) $CellContext`u) $CellContext`\[Eta]0$b[
             7][-1] + ((-504) (Complex[0, 3] + 3^Rational[1, 2]) + 
             3024 $CellContext`u) $CellContext`\[Eta]0$b[8][-1] + (
             Complex[0, 31104] (Complex[0, 5] + 
               3^Rational[1, 2]) + $CellContext`u (Complex[0, -311040] + 
               Complex[0, -373248] $CellContext`\[Zeta]$[1][0]) + 
             Complex[0, 62208] (Complex[0, 3] + 
               3^Rational[1, 2]) $CellContext`\[Zeta]$[1][
               0]) $CellContext`\[Eta]0$b[1, 2][-1] + (
             41472 (Complex[0, 1] + 3^Rational[1, 2]) + 
             62208 (Complex[0, -1] + 3^Rational[1, 2]) $CellContext`\[Zeta]$[
               1][0] + $CellContext`u (
               Complex[0, 10368] (Complex[0, 9] + 5 3^Rational[1, 2]) + 
               Complex[0, 124416] 
                3^Rational[1, 2] $CellContext`\[Zeta]$[1][
                 0])) $CellContext`\[Eta]0$b[1, 3][-1] + (
             3456 (3 + Complex[0, -8] 3^Rational[1, 2]) + $CellContext`u (
               10368 (Complex[0, 5] + 3 3^Rational[1, 2]) + 
               Complex[0, -62208] $CellContext`\[Zeta]$[1][0]) + 
             Complex[0, 10368] (Complex[0, 3] + 
               3^Rational[1, 2]) $CellContext`\[Zeta]$[1][
               0]) $CellContext`\[Eta]0$b[
             1, 4][-1] + ((-1728) (Complex[0, -13] + 7 3^Rational[1, 2]) + 
             1728 (-9 + 
               Complex[0, -17] 
                3^Rational[1, 2]) $CellContext`u) $CellContext`\[Eta]0$b[
             1, 5][-1] + (1728 (3 + Complex[0, -1] 3^Rational[1, 2]) + 
             Complex[0, 10368] $CellContext`u) $CellContext`\[Eta]0$b[
             1, 6][-1] + (864 (-15 + Complex[0, -19] 3^Rational[1, 2]) + 
             5184 (Complex[0, 1] + 
               6 3^Rational[1, 2]) $CellContext`u) $CellContext`\[Eta]0$b[
             2, 3][-1] + (864 (Complex[0, 11] + 3^Rational[1, 2]) + 
             1728 (-9 + 
               Complex[0, -2] 
                3^Rational[1, 2]) $CellContext`u) $CellContext`\[Eta]0$b[
             2, 4][-1] + (432 (3 + Complex[0, -1] 3^Rational[1, 2]) + 
             Complex[0, 2592] $CellContext`u) $CellContext`\[Eta]0$b[
             3, 4][-1] + (31104 (Complex[0, 3] + 3^Rational[1, 2]) - 
             186624 $CellContext`u) $CellContext`\[Eta]0$b[1, 1, 2][-1] + (
             Complex[0, -31104] (Complex[0, -1] + 3^Rational[1, 2]) + 
             62208 3^Rational[1, 2] $CellContext`u) $CellContext`\[Eta]0$b[
             1, 1, 3][-1] + (5184 (Complex[0, 3] + 3^Rational[1, 2]) - 
             31104 $CellContext`u) $CellContext`\[Eta]0$b[1, 1, 4][-1]) + (
           1728 (Complex[0, -13] + 7 3^Rational[1, 2]) + 
           1728 (9 + Complex[0, 17] 
              3^Rational[1, 2]) $CellContext`u) $CellContext`\[Eta]0$b[
           1, 1, 5][-1] + (
           Complex[0, 1728] (Complex[0, 3] + 3^Rational[1, 2]) + 
           Complex[0, -10368] $CellContext`u) $CellContext`\[Eta]0$b[
           1, 1, 6][-1] + ((-5184) (Complex[0, 7] + 5 3^Rational[1, 2]) + 
           10368 (9 + 
             Complex[0, -2] 
              3^Rational[1, 2]) $CellContext`u) $CellContext`\[Eta]0$b[
           1, 2, 2][-1] + (864 (15 + Complex[0, 19] 3^Rational[1, 2]) - 
           5184 (Complex[0, 1] + 
            6 3^Rational[1, 2]) $CellContext`u) $CellContext`\[Eta]0$b[
           1, 2, 3][-1] + ((-864) (Complex[0, 11] + 3^Rational[1, 2]) + 
           1728 (9 + Complex[0, 2] 
              3^Rational[1, 2]) $CellContext`u) $CellContext`\[Eta]0$b[
           1, 2, 4][-1] + ((-2592) (Complex[0, -1] + 3^Rational[1, 2]) + 
           Complex[0, -5184] 
            3^Rational[1, 2] $CellContext`u) $CellContext`\[Eta]0$b[
           1, 3, 3][-1] + (Complex[0, 432] (Complex[0, 3] + 3^Rational[1, 2]) + 
           Complex[0, -2592] $CellContext`u) $CellContext`\[Eta]0$b[
           1, 3, 4][-1] + ((-15552) (Complex[0, 3] + 3^Rational[1, 2]) + 
           93312 $CellContext`u) $CellContext`\[Eta]0$b[2, 1, 2][-1] + (
           1728 (3 + Complex[0, 11] 3^Rational[1, 2]) - 
           10368 (Complex[0, 2] + 
            3 3^Rational[1, 2]) $CellContext`u) $CellContext`\[Eta]0$b[
           2, 1, 3][-1] + ((-864) (Complex[0, 11] + 3^Rational[1, 2]) + 
           1728 (9 + Complex[0, 2] 
              3^Rational[1, 2]) $CellContext`u) $CellContext`\[Eta]0$b[
           2, 1, 4][-1] + (Complex[0, 432] (Complex[0, 3] + 3^Rational[1, 2]) + 
           Complex[0, -2592] $CellContext`u) $CellContext`\[Eta]0$b[
           3, 1, 4][-1] + ((-31104) (Complex[0, 3] + 3^Rational[1, 2]) + 
           186624 $CellContext`u) $CellContext`\[Eta]0$b[1, 1, 1, 2][-1] + (
           31104 (1 + Complex[0, 1] 3^Rational[1, 2]) - 62208 
           3^Rational[1, 2] $CellContext`u) $CellContext`\[Eta]0$b[
           1, 1, 1, 3][-1] + ((-5184) (Complex[0, 3] + 3^Rational[1, 2]) + 
           31104 $CellContext`u) $CellContext`\[Eta]0$b[1, 1, 1, 4][-1])}, 8, 
      15, 1],
     Editable->False],
    Short]}], "}"}]], "Output",
 CellChangeTimes->{
  3.553707222827484*^9, {3.553707334244945*^9, 3.5537073555686903`*^9}, {
   3.553707404411285*^9, 3.5537074496985197`*^9}, {3.55370750540131*^9, 
   3.553707515996984*^9}, 3.55370913442962*^9, 3.5537092895786047`*^9}]
}, Open  ]],

Cell["\<\
When calling weak or leadweak, expression is automatically decompresses\
\>", "Text",
 CellChangeTimes->{{3.553709958901772*^9, 3.553709973771233*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(", 
   RowBox[{"Hr1", "/.", 
    RowBox[{"leadweak", "[", "4", "]"}]}], ")"}], "-", 
  RowBox[{
   SuperscriptBox["g", "8"], 
   RowBox[{"tmp", "[", 
    RowBox[{"[", 
     RowBox[{"3", ",", "1"}], "]"}], "]"}]}], "-", 
  RowBox[{
   SuperscriptBox["g", "10"], 
   RowBox[{"tmp", "[", 
    RowBox[{"[", 
     RowBox[{"3", ",", "3"}], "]"}], "]"}]}], "-", 
  RowBox[{
   SuperscriptBox["g", "12"], 
   RowBox[{"tmp", "[", 
    RowBox[{"[", 
     RowBox[{"3", ",", "5"}], "]"}], "]"}]}], "-", 
  RowBox[{
   SuperscriptBox["g", "14"], 
   RowBox[{"tmp", "[", 
    RowBox[{"[", 
     RowBox[{"3", ",", "7"}], "]"}], "]"}]}]}]], "Input",
 CellChangeTimes->{{3.55370931298532*^9, 3.553709313878931*^9}, {
  3.553709848963615*^9, 3.553709912836195*^9}}],

Cell[BoxData["0"], "Output",
 CellChangeTimes->{{3.5537098536029253`*^9, 3.5537099131149397`*^9}}]
}, Open  ]],

Cell["\<\
By default $\[Delta]QCorrectiontoH is True hence we get\
\>", "Text",
 CellChangeTimes->{{3.553706901582828*^9, 3.553706946834467*^9}}],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"$\[Delta]QCorrectiontoH", "=", "True"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"H", "/.", 
  RowBox[{"leadweak", "[", "1", "]"}]}]}], "Input",
 CellChangeTimes->{{3.55370692289142*^9, 3.553706950556094*^9}, {
  3.553710014915823*^9, 3.553710030027828*^9}, {3.553710275530067*^9, 
  3.55371027574583*^9}, {3.5537113770338917`*^9, 3.553711377158576*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   SuperscriptBox["g", "8"], " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{
      FractionBox["1", 
       SuperscriptBox[
        StyleBox["Q0",
         FontColor->RGBColor[{
            Rational[1, 2], 
            Rational[1, 2], 0}]], "+"]], 
      RowBox[{"(", 
       RowBox[{"108", "+", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{"54", "-", 
           RowBox[{"18", " ", "\[ImaginaryI]", " ", 
            SqrtBox["3"]}], "-", 
           RowBox[{"108", " ", "\[ImaginaryI]", " ", "u"}]}], ")"}], " ", 
         SubsuperscriptBox[
          StyleBox["\[Eta]0",
           FontWeight->Bold,
           FontColor->RGBColor[0, 0.5, 0]], "2", "+"]}], "+", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           RowBox[{
            RowBox[{"-", "18"}], " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "\[ImaginaryI]"}], "+", 
              SqrtBox["3"]}], ")"}]}], "+", 
           RowBox[{"36", " ", "\[ImaginaryI]", " ", 
            SqrtBox["3"], " ", "u"}]}], ")"}], " ", 
         SubsuperscriptBox[
          StyleBox["\[Eta]0",
           FontWeight->Bold,
           FontColor->RGBColor[0, 0.5, 0]], "3", "+"]}], "+", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{"9", "-", 
           RowBox[{"3", " ", "\[ImaginaryI]", " ", 
            SqrtBox["3"]}], "-", 
           RowBox[{"18", " ", "\[ImaginaryI]", " ", "u"}]}], ")"}], " ", 
         SubsuperscriptBox[
          StyleBox["\[Eta]0",
           FontWeight->Bold,
           FontColor->RGBColor[0, 0.5, 0]], "4", "+"]}], "+", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{"54", "+", 
           RowBox[{"18", " ", "\[ImaginaryI]", " ", 
            SqrtBox["3"]}], "-", 
           RowBox[{"108", " ", "\[ImaginaryI]", " ", "u"}]}], ")"}], " ", 
         SubsuperscriptBox[
          OverscriptBox[
           StyleBox["\[Eta]0",
            FontWeight->Bold,
            FontColor->RGBColor[0, 0.5, 0]], 
           StyleBox["_",
            FontWeight->Bold,
            FontColor->RGBColor[0, 0.5, 0]]], "2", "-"]}], "+", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           RowBox[{
            RowBox[{"-", "18"}], " ", 
            RowBox[{"(", 
             RowBox[{"\[ImaginaryI]", "+", 
              SqrtBox["3"]}], ")"}]}], "+", 
           RowBox[{"36", " ", "\[ImaginaryI]", " ", 
            SqrtBox["3"], " ", "u"}]}], ")"}], " ", 
         SubsuperscriptBox[
          OverscriptBox[
           StyleBox["\[Eta]0",
            FontWeight->Bold,
            FontColor->RGBColor[0, 0.5, 0]], 
           StyleBox["_",
            FontWeight->Bold,
            FontColor->RGBColor[0, 0.5, 0]]], "3", "-"]}], "+", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{"9", "+", 
           RowBox[{"3", " ", "\[ImaginaryI]", " ", 
            SqrtBox["3"]}], "-", 
           RowBox[{"18", " ", "\[ImaginaryI]", " ", "u"}]}], ")"}], " ", 
         SubsuperscriptBox[
          OverscriptBox[
           StyleBox["\[Eta]0",
            FontWeight->Bold,
            FontColor->RGBColor[0, 0.5, 0]], 
           StyleBox["_",
            FontWeight->Bold,
            FontColor->RGBColor[0, 0.5, 0]]], "4", "-"]}]}], ")"}]}], "+", 
     RowBox[{
      FractionBox["1", 
       SuperscriptBox[
        StyleBox["Q0",
         FontColor->RGBColor[{
            Rational[1, 2], 
            Rational[1, 2], 0}]], "-"]], 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "108"}], "+", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{"54", "+", 
           RowBox[{"18", " ", "\[ImaginaryI]", " ", 
            SqrtBox["3"]}], "+", 
           RowBox[{"108", " ", "\[ImaginaryI]", " ", "u"}]}], ")"}], " ", 
         SubsuperscriptBox[
          StyleBox["\[Eta]0",
           FontWeight->Bold,
           FontColor->RGBColor[0, 0.5, 0]], "2", "+"]}], "+", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           RowBox[{
            RowBox[{"-", "18"}], " ", 
            RowBox[{"(", 
             RowBox[{"\[ImaginaryI]", "+", 
              SqrtBox["3"]}], ")"}]}], "-", 
           RowBox[{"36", " ", "\[ImaginaryI]", " ", 
            SqrtBox["3"], " ", "u"}]}], ")"}], " ", 
         SubsuperscriptBox[
          StyleBox["\[Eta]0",
           FontWeight->Bold,
           FontColor->RGBColor[0, 0.5, 0]], "3", "+"]}], "+", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{"9", "+", 
           RowBox[{"3", " ", "\[ImaginaryI]", " ", 
            SqrtBox["3"]}], "+", 
           RowBox[{"18", " ", "\[ImaginaryI]", " ", "u"}]}], ")"}], " ", 
         SubsuperscriptBox[
          StyleBox["\[Eta]0",
           FontWeight->Bold,
           FontColor->RGBColor[0, 0.5, 0]], "4", "+"]}], "+", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{"54", "-", 
           RowBox[{"18", " ", "\[ImaginaryI]", " ", 
            SqrtBox["3"]}], "+", 
           RowBox[{"108", " ", "\[ImaginaryI]", " ", "u"}]}], ")"}], " ", 
         SubsuperscriptBox[
          OverscriptBox[
           StyleBox["\[Eta]0",
            FontWeight->Bold,
            FontColor->RGBColor[0, 0.5, 0]], 
           StyleBox["_",
            FontWeight->Bold,
            FontColor->RGBColor[0, 0.5, 0]]], "2", "-"]}], "+", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           RowBox[{
            RowBox[{"-", "18"}], " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "\[ImaginaryI]"}], "+", 
              SqrtBox["3"]}], ")"}]}], "-", 
           RowBox[{"36", " ", "\[ImaginaryI]", " ", 
            SqrtBox["3"], " ", "u"}]}], ")"}], " ", 
         SubsuperscriptBox[
          OverscriptBox[
           StyleBox["\[Eta]0",
            FontWeight->Bold,
            FontColor->RGBColor[0, 0.5, 0]], 
           StyleBox["_",
            FontWeight->Bold,
            FontColor->RGBColor[0, 0.5, 0]]], "3", "-"]}], "+", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{"9", "-", 
           RowBox[{"3", " ", "\[ImaginaryI]", " ", 
            SqrtBox["3"]}], "+", 
           RowBox[{"18", " ", "\[ImaginaryI]", " ", "u"}]}], ")"}], " ", 
         SubsuperscriptBox[
          OverscriptBox[
           StyleBox["\[Eta]0",
            FontWeight->Bold,
            FontColor->RGBColor[0, 0.5, 0]], 
           StyleBox["_",
            FontWeight->Bold,
            FontColor->RGBColor[0, 0.5, 0]]], "4", "-"]}]}], ")"}]}]}], 
    ")"}]}], "+", 
  RowBox[{
   SuperscriptBox["g", "8"], " ", 
   RowBox[{"(", 
    RowBox[{
     FractionBox[
      RowBox[{"18", "+", 
       FractionBox["2", 
        SuperscriptBox["u", "4"]], "+", 
       FractionBox["18", 
        SuperscriptBox["u", "2"]], "-", 
       FractionBox[
        RowBox[{"24", " ", "\[ImaginaryI]"}], "u"], "-", 
       RowBox[{"36", " ", "\[ImaginaryI]", " ", "u"}]}], 
      RowBox[{
       SuperscriptBox[
        StyleBox["Q0",
         FontColor->RGBColor[{
            Rational[1, 2], 
            Rational[1, 2], 0}]], "-"], " ", 
       SuperscriptBox[
        RowBox[{"(", 
         SuperscriptBox[
          StyleBox["Q0",
           FontColor->RGBColor[{
              Rational[1, 2], 
              Rational[1, 2], 0}]], "+"], ")"}], "2"]}]], "+", 
     FractionBox[
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", "36"}], "-", 
         FractionBox["4", 
          SuperscriptBox["u", "4"]], "-", 
         FractionBox["36", 
          SuperscriptBox["u", "2"]]}], ")"}], " ", 
       SubsuperscriptBox[
        StyleBox["\[Eta]",
         FontWeight->Bold,
         FontColor->RGBColor[0.8, 0, 0]], "2", 
        RowBox[{"[", "2", "]"}]]}], 
      RowBox[{
       SuperscriptBox[
        StyleBox["Q0",
         FontColor->RGBColor[{
            Rational[1, 2], 
            Rational[1, 2], 0}]], "-"], " ", 
       SuperscriptBox[
        StyleBox["Q0",
         FontColor->RGBColor[{
            Rational[1, 2], 
            Rational[1, 2], 0}]], "+"]}]], "+", 
     FractionBox[
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         FractionBox["8", 
          SuperscriptBox["u", "3"]], "+", 
         FractionBox["24", "u"]}], ")"}], " ", 
       SubsuperscriptBox[
        StyleBox["\[Eta]",
         FontWeight->Bold,
         FontColor->RGBColor[0.8, 0, 0]], "3", 
        RowBox[{"[", "2", "]"}]]}], 
      RowBox[{
       SuperscriptBox[
        StyleBox["Q0",
         FontColor->RGBColor[{
            Rational[1, 2], 
            Rational[1, 2], 0}]], "-"], " ", 
       SuperscriptBox[
        StyleBox["Q0",
         FontColor->RGBColor[{
            Rational[1, 2], 
            Rational[1, 2], 0}]], "+"]}]], "-", 
     FractionBox[
      RowBox[{"4", " ", 
       SubsuperscriptBox[
        StyleBox["\[Eta]",
         FontWeight->Bold,
         FontColor->RGBColor[0.8, 0, 0]], "4", 
        RowBox[{"[", "2", "]"}]]}], 
      RowBox[{
       SuperscriptBox["u", "2"], " ", 
       SuperscriptBox[
        StyleBox["Q0",
         FontColor->RGBColor[{
            Rational[1, 2], 
            Rational[1, 2], 0}]], "-"], " ", 
       SuperscriptBox[
        StyleBox["Q0",
         FontColor->RGBColor[{
            Rational[1, 2], 
            Rational[1, 2], 0}]], "+"]}]]}], ")"}]}]}]], "Output",
 CellChangeTimes->{3.553710032032547*^9, 3.553710276517075*^9, 
  3.553711377695746*^9}]
}, Open  ]],

Cell["\<\
One can check for instance that the residue is zero at Bethe root\
\>", "Text",
 CellChangeTimes->{{3.553710042201454*^9, 3.5537100537760773`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"H", "/.", 
    RowBox[{"leadweak", "[", "2", "]"}]}], "//.", 
   RowBox[{"shiftm\[Eta]", "[", "3", "]"}]}], "//.", 
  RowBox[{"shiftp\[Eta]b", "[", 
   RowBox[{"-", "3"}], "]"}]}]], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Series", "[", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{
          RowBox[{
           RowBox[{"H", "/.", 
            RowBox[{"leadweak", "[", "2", "]"}]}], "//.", 
           RowBox[{"shiftm\[Eta]", "[", "2", "]"}]}], "/.", 
          RowBox[{"Shift", "[", "1", "]"}]}], "/.", 
         RowBox[{"u", "\[Rule]", 
          RowBox[{"u", "+", 
           FractionBox["\[ImaginaryI]", "2"]}]}]}], "//.", 
        "subtopowerbasis"}], "/.", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{"xxx", ":", 
          RowBox[{"Alternatives", "@@", "\[Eta]list"}]}], ")"}], 
        "\[RuleDelayed]", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"xxx", "/.", 
           RowBox[{"TaylorOptions", "[", 
            RowBox[{
             RowBox[{"Order", "\[Rule]", "1"}], ",", 
             RowBox[{"Variable", "\[Rule]", "\[Delta]u"}]}], "]"}]}], "//", 
          "Normal"}], ")"}]}]}], "/.", 
      RowBox[{"\[Delta]u", "\[Rule]", 
       RowBox[{"(", 
        RowBox[{"u", "-", "v00"}], ")"}]}]}], "/.", "sub\[Eta]\[Eta]0"}], "/.",
     "subQ0"}], ",", 
   RowBox[{"{", 
    RowBox[{"u", ",", "v00", ",", 
     RowBox[{"-", "1"}]}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.55371005749536*^9, 3.553710084739904*^9}, {
  3.553710116977654*^9, 3.5537103707633266`*^9}, {3.5537104093633947`*^9, 
  3.553710457890065*^9}, {3.553711023012731*^9, 3.553711027949843*^9}, {
  3.553711095621233*^9, 3.553711125864175*^9}}],

Cell[BoxData[
 InterpretationBox[
  SuperscriptBox[
   RowBox[{"O", "[", 
    RowBox[{"u", "-", 
     FractionBox["1", 
      RowBox[{"2", " ", 
       SqrtBox["3"]}]]}], "]"}], "0"],
  SeriesData[$CellContext`u, Rational[1, 2] 3^Rational[-1, 2], {}, 0, 0, 1],
  Editable->False]], "Output",
 CellChangeTimes->{{3.5537100706635113`*^9, 3.553710157994319*^9}, {
   3.553710206721675*^9, 3.5537102544347057`*^9}, 3.5537103754822187`*^9, {
   3.55371042980145*^9, 3.553710459689334*^9}, 3.553711041977799*^9, {
   3.553711103517644*^9, 3.5537111262935333`*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Series", "[", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{
          RowBox[{
           RowBox[{"H", "/.", 
            RowBox[{"leadweak", "[", "2", "]"}]}], "//.", 
           RowBox[{"shiftp\[Eta]b", "[", 
            RowBox[{"-", "2"}], "]"}]}], "/.", 
          RowBox[{"Shift", "[", 
           RowBox[{"-", "1"}], "]"}]}], "/.", 
         RowBox[{"u", "\[Rule]", 
          RowBox[{"u", "-", 
           FractionBox["\[ImaginaryI]", "2"]}]}]}], "//.", 
        "subtopowerbasis"}], "/.", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{"xxx", ":", 
          RowBox[{"Alternatives", "@@", "\[Eta]list"}]}], ")"}], 
        "\[RuleDelayed]", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"xxx", "/.", 
           RowBox[{"TaylorOptions", "[", 
            RowBox[{
             RowBox[{"Order", "\[Rule]", "1"}], ",", 
             RowBox[{"Variable", "\[Rule]", "\[Delta]u"}]}], "]"}]}], "//", 
          "Normal"}], ")"}]}]}], "/.", 
      RowBox[{"\[Delta]u", "\[Rule]", 
       RowBox[{"(", 
        RowBox[{"u", "-", "v00"}], ")"}]}]}], "/.", "sub\[Eta]\[Eta]0"}], "/.",
     "subQ0"}], ",", 
   RowBox[{"{", 
    RowBox[{"u", ",", "v00", ",", 
     RowBox[{"-", "1"}]}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.5537111443803167`*^9, 3.553711151252681*^9}}],

Cell[BoxData[
 InterpretationBox[
  SuperscriptBox[
   RowBox[{"O", "[", 
    RowBox[{"u", "-", 
     FractionBox["1", 
      RowBox[{"2", " ", 
       SqrtBox["3"]}]]}], "]"}], "0"],
  SeriesData[$CellContext`u, Rational[1, 2] 3^Rational[-1, 2], {}, 0, 0, 1],
  Editable->False]], "Output",
 CellChangeTimes->{{3.553711157683839*^9, 3.5537111621967497`*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"Series", "[", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{
          RowBox[{
           RowBox[{
            RowBox[{"H", "/.", 
             RowBox[{"leadweak", "[", "3", "]"}]}], "//.", 
            RowBox[{"shiftm\[Eta]", "[", "2", "]"}]}], "/.", 
           RowBox[{"Shift", "[", "1", "]"}]}], "/.", 
          RowBox[{"u", "\[Rule]", 
           RowBox[{"u", "+", 
            FractionBox["\[ImaginaryI]", "2"]}]}]}], "//.", 
         "subtopowerbasis"}], "/.", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{"xxx", ":", 
           RowBox[{"Alternatives", "@@", "\[Eta]list"}]}], ")"}], 
         "\[RuleDelayed]", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"xxx", "/.", 
            RowBox[{"TaylorOptions", "[", 
             RowBox[{
              RowBox[{"Order", "\[Rule]", "2"}], ",", 
              RowBox[{"Variable", "\[Rule]", "\[Delta]u"}]}], "]"}]}], "//", 
           "Normal"}], ")"}]}]}], "/.", 
       RowBox[{"\[Delta]u", "\[Rule]", 
        RowBox[{"(", 
         RowBox[{"u", "-", "v00"}], ")"}]}]}], "/.", "sub\[Eta]\[Eta]0"}], "/.",
      "subQ0"}], ",", 
    RowBox[{"{", 
     RowBox[{"u", ",", "v00", ",", 
      RowBox[{"-", "1"}]}], "}"}]}], "]"}], "//", "Simplify"}]], "Input",
 CellChangeTimes->{{3.553711168824937*^9, 3.5537111825898046`*^9}, {
  3.553711245730917*^9, 3.5537112471074142`*^9}}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
   FractionBox[
    RowBox[{"644972544", " ", "\[ImaginaryI]", " ", 
     RowBox[{"(", 
      RowBox[{"\[ImaginaryI]", "+", 
       SqrtBox["3"]}], ")"}], " ", 
     SuperscriptBox["g", "12"], " ", 
     RowBox[{"(", 
      RowBox[{
       SuperscriptBox[
        RowBox[{"(", 
         SubsuperscriptBox[
          StyleBox["\[Eta]0",
           FontWeight->Bold,
           FontColor->RGBColor[0, 0.5, 0]], "2", "+"], ")"}], "2"], "-", 
       SubsuperscriptBox[
        StyleBox["\[Eta]0",
         FontWeight->Bold,
         FontColor->RGBColor[0, 0.5, 0]], "4", "+"], "-", 
       RowBox[{"2", " ", 
        SubsuperscriptBox[
         StyleBox["\[Eta]0",
          FontWeight->Bold,
          FontColor->RGBColor[0, 0.5, 0]], 
         RowBox[{"2", ",", "2"}], "+"]}]}], ")"}]}], 
    RowBox[{
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{
        RowBox[{"3", " ", "\[ImaginaryI]"}], "+", 
        SqrtBox["3"]}], ")"}], "11"], " ", 
     RowBox[{"(", 
      RowBox[{"u", "-", 
       FractionBox["1", 
        RowBox[{"2", " ", 
         SqrtBox["3"]}]]}], ")"}]}]], "+", 
   InterpretationBox[
    SuperscriptBox[
     RowBox[{"O", "[", 
      RowBox[{"u", "-", 
       FractionBox["1", 
        RowBox[{"2", " ", 
         SqrtBox["3"]}]]}], "]"}], "0"],
    SeriesData[$CellContext`u, Rational[1, 2] 3^Rational[-1, 2], {}, -1, 0, 1],
    Editable->False]}],
  SeriesData[$CellContext`u, Rational[1, 2] 3^Rational[-1, 2], {
   Complex[0, 644972544] (Complex[0, 1] + 
     3^Rational[1, 2]) (Complex[0, 3] + 
      3^Rational[1, 2])^(-11) $CellContext`g^12 ($CellContext`\[Eta]0$[2][
       1]^2 - $CellContext`\[Eta]0$[4][1] - 
     2 $CellContext`\[Eta]0$[2, 2][1])}, -1, 0, 1],
  Editable->False]], "Output",
 CellChangeTimes->{{3.553711223530417*^9, 3.553711250341267*^9}}]
}, Open  ]],

Cell[TextData[{
 "The last expression is zero, we know that (it is an \[Eta]-function \
property). Although we run subtopowerbasis, this is TaylorOptions which \
generated ",
 Cell[BoxData[
  FormBox[
   SubscriptBox["\[Eta]0", 
    RowBox[{"2", ",", "2"}]], TraditionalForm]],
  FormatType->"TraditionalForm"],
 " from something else)"
}], "Text",
 CellChangeTimes->{{3.5537112704106083`*^9, 3.553711276463784*^9}, {
  3.553711311350409*^9, 3.5537113642691402`*^9}}]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 " \[Delta]\[Rho] and \[Delta]",
 Cell[BoxData[
  FormBox[
   SubscriptBox["\[Rho]", "2"], TraditionalForm]]],
 " - systematic expansion (first 3 orders, good for 8 loops!)"
}], "Section",
 CellChangeTimes->{{3.538194756789219*^9, 3.538194772019889*^9}, 
   3.538292860253667*^9, {3.5388267421635056`*^9, 3.5388267452626824`*^9}, {
   3.540095920756257*^9, 3.540095943781209*^9}, 3.546685693009663*^9, {
   3.546685744290317*^9, 3.546685777805489*^9}, {3.546929303915393*^9, 
   3.5469293063369627`*^9}, {3.547188724626713*^9, 3.547188725591942*^9}, 
   3.5537123799033203`*^9, {3.553758844389677*^9, 3.553758863538767*^9}, 
   3.553758906212435*^9, {3.555792098495717*^9, 3.555792104660487*^9}, {
   3.555869869755844*^9, 3.555869880665091*^9}, {3.568964414107851*^9, 
   3.568964416899137*^9}, {3.568964901611019*^9, 3.568964903599812*^9}}],

Cell["\<\
We will compute the first thre orders of \[Delta]\[Rho] and \[Delta]\[Rho]2. \
At 4th order we will need to know only M[\[Delta]\[Rho]2] which can be found \
by other means.\
\>", "Text",
 CellChangeTimes->{{3.568964532309494*^9, 3.568964587915256*^9}}],

Cell[CellGroupData[{

Cell["Usage of the answer", "Subsection",
 CellChangeTimes->{{3.5689648625607643`*^9, 3.568964867568521*^9}, {
  3.568965155295623*^9, 3.5689651667976522`*^9}}],

Cell["\<\
We give it on the example of \[Delta]\[Rho]. The same is done for \[Delta]\
\[Rho]2.\
\>", "Text",
 CellChangeTimes->{{3.568964887007826*^9, 3.5689648999113903`*^9}, 
   3.5689651714617043`*^9}],

Cell[TextData[{
 "We need not only \[Delta]\[Rho] but also ",
 Cell[BoxData[
  FormBox[
   RowBox[{
    RowBox[{"M", "[", 
     RowBox[{
      SuperscriptBox["w", "k"], "\[Delta]\[Rho]"}], "]"}], "=", 
    RowBox[{
     SubsuperscriptBox["\[Integral]", 
      RowBox[{"-", "1"}], "1"], 
     RowBox[{
      FractionBox["dw", "\[Pi]"], 
      SuperscriptBox["w", "k"], "\[Delta]\[Rho]"}]}]}], TraditionalForm]],
  FormatType->"TraditionalForm"],
 " and ",
 Cell[BoxData[
  FormBox[
   RowBox[{
    RowBox[{"PV", "[", 
     RowBox[{
      SuperscriptBox["w", "k"], "\[Delta]\[Rho]"}], "]"}], "=", 
    RowBox[{
     SubsuperscriptBox["\[Integral]", 
      RowBox[{"-", "1"}], "1"], 
     RowBox[{
      FractionBox["dw", 
       RowBox[{
        RowBox[{"-", "2"}], "\[Pi]", " ", "\[ImaginaryI]"}]], 
      FractionBox[
       RowBox[{
        SuperscriptBox["w", "k"], "\[Delta]\[Rho]"}], 
       RowBox[{"z", "-", "w"}]]}]}]}], TraditionalForm]]],
 " "
}], "Text",
 CellChangeTimes->{{3.5689651781269817`*^9, 3.5689652521121817`*^9}}],

Cell["\<\
Therefore, we apply subAnsatz first who is aware how to take M and PV \
integrals:\
\>", "Text",
 CellChangeTimes->{{3.568965005852931*^9, 3.568965011515497*^9}, {
  3.568965062033736*^9, 3.568965092272497*^9}, {3.5689652329958897`*^9, 
  3.568965249194294*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"{", 
   RowBox[{
    SubscriptBox["\[Delta]\[Rho]", "lead"], ",", 
    SubscriptBox["\[Delta]\[Rho]", "sublead"], ",", 
    SubscriptBox["\[Delta]\[Rho]", "sublead2"], ",", 
    RowBox[{"M", "[", 
     RowBox[{
      SuperscriptBox["w", "2"], 
      SubscriptBox["\[Delta]\[Rho]", "lead"]}], "]"}], ",", 
    RowBox[{"PV", "[", 
     RowBox[{
      SuperscriptBox["w", "3"], 
      SubscriptBox["\[Delta]\[Rho]", "lead"]}], "]"}]}], "}"}], "/.", 
  "subAnsatz"}]], "Input",
 CellChangeTimes->{{3.56896502117623*^9, 3.568965056743053*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{
    RowBox[{
     SqrtBox[
      RowBox[{"1", "-", 
       SuperscriptBox["z", "2"]}]], " ", 
     RowBox[{
      SubscriptBox["\[Beta]", "lead"], "[", "0", "]"}]}], "+", 
    RowBox[{
     SuperscriptBox["z", "2"], " ", 
     SqrtBox[
      RowBox[{"1", "-", 
       SuperscriptBox["z", "2"]}]], " ", 
     RowBox[{
      SubscriptBox["\[Beta]", "lead"], "[", "1", "]"}]}], "+", 
    RowBox[{
     SuperscriptBox["z", "4"], " ", 
     SqrtBox[
      RowBox[{"1", "-", 
       SuperscriptBox["z", "2"]}]], " ", 
     RowBox[{
      SubscriptBox["\[Beta]", "lead"], "[", "2", "]"}]}], "+", 
    RowBox[{
     SuperscriptBox["z", "6"], " ", 
     SqrtBox[
      RowBox[{"1", "-", 
       SuperscriptBox["z", "2"]}]], " ", 
     RowBox[{
      SubscriptBox["\[Beta]", "lead"], "[", "3", "]"}]}], "+", 
    RowBox[{
     SuperscriptBox["z", "8"], " ", 
     SqrtBox[
      RowBox[{"1", "-", 
       SuperscriptBox["z", "2"]}]], " ", 
     RowBox[{
      SubscriptBox["\[Beta]", "lead"], "[", "4", "]"}]}], "+", 
    RowBox[{
     SuperscriptBox["z", "10"], " ", 
     SqrtBox[
      RowBox[{"1", "-", 
       SuperscriptBox["z", "2"]}]], " ", 
     RowBox[{
      SubscriptBox["\[Beta]", "lead"], "[", "5", "]"}]}]}], ",", 
   RowBox[{
    RowBox[{
     SqrtBox[
      RowBox[{"1", "-", 
       SuperscriptBox["z", "2"]}]], " ", 
     RowBox[{
      SubscriptBox["\[Beta]", "sublead"], "[", "0", "]"}]}], "+", 
    RowBox[{
     SuperscriptBox["z", "2"], " ", 
     SqrtBox[
      RowBox[{"1", "-", 
       SuperscriptBox["z", "2"]}]], " ", 
     RowBox[{
      SubscriptBox["\[Beta]", "sublead"], "[", "1", "]"}]}], "+", 
    RowBox[{
     SuperscriptBox["z", "4"], " ", 
     SqrtBox[
      RowBox[{"1", "-", 
       SuperscriptBox["z", "2"]}]], " ", 
     RowBox[{
      SubscriptBox["\[Beta]", "sublead"], "[", "2", "]"}]}], "+", 
    RowBox[{
     SuperscriptBox["z", "6"], " ", 
     SqrtBox[
      RowBox[{"1", "-", 
       SuperscriptBox["z", "2"]}]], " ", 
     RowBox[{
      SubscriptBox["\[Beta]", "sublead"], "[", "3", "]"}]}], "+", 
    RowBox[{
     SuperscriptBox["z", "8"], " ", 
     SqrtBox[
      RowBox[{"1", "-", 
       SuperscriptBox["z", "2"]}]], " ", 
     RowBox[{
      SubscriptBox["\[Beta]", "sublead"], "[", "4", "]"}]}], "+", 
    RowBox[{
     SuperscriptBox["z", "10"], " ", 
     SqrtBox[
      RowBox[{"1", "-", 
       SuperscriptBox["z", "2"]}]], " ", 
     RowBox[{
      SubscriptBox["\[Beta]", "sublead"], "[", "5", "]"}]}]}], ",", 
   RowBox[{
    RowBox[{
     SqrtBox[
      RowBox[{"1", "-", 
       SuperscriptBox["z", "2"]}]], " ", 
     RowBox[{
      SubscriptBox["\[Beta]", "sublead2"], "[", "0", "]"}]}], "+", 
    RowBox[{
     SuperscriptBox["z", "2"], " ", 
     SqrtBox[
      RowBox[{"1", "-", 
       SuperscriptBox["z", "2"]}]], " ", 
     RowBox[{
      SubscriptBox["\[Beta]", "sublead2"], "[", "1", "]"}]}], "+", 
    RowBox[{
     SuperscriptBox["z", "4"], " ", 
     SqrtBox[
      RowBox[{"1", "-", 
       SuperscriptBox["z", "2"]}]], " ", 
     RowBox[{
      SubscriptBox["\[Beta]", "sublead2"], "[", "2", "]"}]}], "+", 
    RowBox[{
     SuperscriptBox["z", "6"], " ", 
     SqrtBox[
      RowBox[{"1", "-", 
       SuperscriptBox["z", "2"]}]], " ", 
     RowBox[{
      SubscriptBox["\[Beta]", "sublead2"], "[", "3", "]"}]}], "+", 
    RowBox[{
     SuperscriptBox["z", "8"], " ", 
     SqrtBox[
      RowBox[{"1", "-", 
       SuperscriptBox["z", "2"]}]], " ", 
     RowBox[{
      SubscriptBox["\[Beta]", "sublead2"], "[", "4", "]"}]}], "+", 
    RowBox[{
     SuperscriptBox["z", "10"], " ", 
     SqrtBox[
      RowBox[{"1", "-", 
       SuperscriptBox["z", "2"]}]], " ", 
     RowBox[{
      SubscriptBox["\[Beta]", "sublead2"], "[", "5", "]"}]}]}], ",", 
   RowBox[{
    FractionBox[
     RowBox[{
      SubscriptBox["\[Beta]", "lead"], "[", "0", "]"}], "8"], "+", 
    FractionBox[
     RowBox[{
      SubscriptBox["\[Beta]", "lead"], "[", "1", "]"}], "16"], "+", 
    FractionBox[
     RowBox[{"5", " ", 
      RowBox[{
       SubscriptBox["\[Beta]", "lead"], "[", "2", "]"}]}], "128"], "+", 
    FractionBox[
     RowBox[{"7", " ", 
      RowBox[{
       SubscriptBox["\[Beta]", "lead"], "[", "3", "]"}]}], "256"], "+", 
    FractionBox[
     RowBox[{"21", " ", 
      RowBox[{
       SubscriptBox["\[Beta]", "lead"], "[", "4", "]"}]}], "1024"], "+", 
    FractionBox[
     RowBox[{"33", " ", 
      RowBox[{
       SubscriptBox["\[Beta]", "lead"], "[", "5", "]"}]}], "2048"]}], ",", 
   RowBox[{
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{"-", 
        FractionBox["\[ImaginaryI]", "16"]}], "-", 
       FractionBox[
        RowBox[{"\[ImaginaryI]", " ", 
         SuperscriptBox["z", "2"]}], "4"], "+", 
       FractionBox[
        RowBox[{"\[ImaginaryI]", " ", 
         SuperscriptBox["z", "4"]}], "2"]}], ")"}], " ", 
     RowBox[{
      SubscriptBox["\[Beta]", "lead"], "[", "0", "]"}]}], "+", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{"-", 
        FractionBox["\[ImaginaryI]", "32"]}], "-", 
       FractionBox[
        RowBox[{"\[ImaginaryI]", " ", 
         SuperscriptBox["z", "2"]}], "16"], "-", 
       FractionBox[
        RowBox[{"\[ImaginaryI]", " ", 
         SuperscriptBox["z", "4"]}], "4"], "+", 
       FractionBox[
        RowBox[{"\[ImaginaryI]", " ", 
         SuperscriptBox["z", "6"]}], "2"]}], ")"}], " ", 
     RowBox[{
      SubscriptBox["\[Beta]", "lead"], "[", "1", "]"}]}], "+", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{"-", 
        FractionBox[
         RowBox[{"5", " ", "\[ImaginaryI]"}], "256"]}], "-", 
       FractionBox[
        RowBox[{"\[ImaginaryI]", " ", 
         SuperscriptBox["z", "2"]}], "32"], "-", 
       FractionBox[
        RowBox[{"\[ImaginaryI]", " ", 
         SuperscriptBox["z", "4"]}], "16"], "-", 
       FractionBox[
        RowBox[{"\[ImaginaryI]", " ", 
         SuperscriptBox["z", "6"]}], "4"], "+", 
       FractionBox[
        RowBox[{"\[ImaginaryI]", " ", 
         SuperscriptBox["z", "8"]}], "2"]}], ")"}], " ", 
     RowBox[{
      SubscriptBox["\[Beta]", "lead"], "[", "2", "]"}]}], "+", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{"-", 
        FractionBox[
         RowBox[{"7", " ", "\[ImaginaryI]"}], "512"]}], "-", 
       FractionBox[
        RowBox[{"5", " ", "\[ImaginaryI]", " ", 
         SuperscriptBox["z", "2"]}], "256"], "-", 
       FractionBox[
        RowBox[{"\[ImaginaryI]", " ", 
         SuperscriptBox["z", "4"]}], "32"], "-", 
       FractionBox[
        RowBox[{"\[ImaginaryI]", " ", 
         SuperscriptBox["z", "6"]}], "16"], "-", 
       FractionBox[
        RowBox[{"\[ImaginaryI]", " ", 
         SuperscriptBox["z", "8"]}], "4"], "+", 
       FractionBox[
        RowBox[{"\[ImaginaryI]", " ", 
         SuperscriptBox["z", "10"]}], "2"]}], ")"}], " ", 
     RowBox[{
      SubscriptBox["\[Beta]", "lead"], "[", "3", "]"}]}], "+", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{"-", 
        FractionBox[
         RowBox[{"21", " ", "\[ImaginaryI]"}], "2048"]}], "-", 
       FractionBox[
        RowBox[{"7", " ", "\[ImaginaryI]", " ", 
         SuperscriptBox["z", "2"]}], "512"], "-", 
       FractionBox[
        RowBox[{"5", " ", "\[ImaginaryI]", " ", 
         SuperscriptBox["z", "4"]}], "256"], "-", 
       FractionBox[
        RowBox[{"\[ImaginaryI]", " ", 
         SuperscriptBox["z", "6"]}], "32"], "-", 
       FractionBox[
        RowBox[{"\[ImaginaryI]", " ", 
         SuperscriptBox["z", "8"]}], "16"], "-", 
       FractionBox[
        RowBox[{"\[ImaginaryI]", " ", 
         SuperscriptBox["z", "10"]}], "4"], "+", 
       FractionBox[
        RowBox[{"\[ImaginaryI]", " ", 
         SuperscriptBox["z", "12"]}], "2"]}], ")"}], " ", 
     RowBox[{
      SubscriptBox["\[Beta]", "lead"], "[", "4", "]"}]}], "+", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{"-", 
        FractionBox[
         RowBox[{"33", " ", "\[ImaginaryI]"}], "4096"]}], "-", 
       FractionBox[
        RowBox[{"21", " ", "\[ImaginaryI]", " ", 
         SuperscriptBox["z", "2"]}], "2048"], "-", 
       FractionBox[
        RowBox[{"7", " ", "\[ImaginaryI]", " ", 
         SuperscriptBox["z", "4"]}], "512"], "-", 
       FractionBox[
        RowBox[{"5", " ", "\[ImaginaryI]", " ", 
         SuperscriptBox["z", "6"]}], "256"], "-", 
       FractionBox[
        RowBox[{"\[ImaginaryI]", " ", 
         SuperscriptBox["z", "8"]}], "32"], "-", 
       FractionBox[
        RowBox[{"\[ImaginaryI]", " ", 
         SuperscriptBox["z", "10"]}], "16"], "-", 
       FractionBox[
        RowBox[{"\[ImaginaryI]", " ", 
         SuperscriptBox["z", "12"]}], "4"], "+", 
       FractionBox[
        RowBox[{"\[ImaginaryI]", " ", 
         SuperscriptBox["z", "14"]}], "2"]}], ")"}], " ", 
     RowBox[{
      SubscriptBox["\[Beta]", "lead"], "[", "5", "]"}]}]}]}], "}"}]], "Output",\

 CellChangeTimes->{{3.5689650157874727`*^9, 3.56896505696027*^9}, 
   3.568965093404653*^9}]
}, Open  ]],

Cell["\<\
Next is to apply solut\[Rho]sexplicit for explicit substitution of the \
coefficients, or solut\[Rho]s for the answer in terms of integrals\
\>", "Text",
 CellChangeTimes->{{3.5689650975681477`*^9, 3.568965128007107*^9}}],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"{", 
    SubscriptBox["\[Delta]\[Rho]", "lead"], "}"}], "/.", "subAnsatz"}], "/.", 
  "solut\[Rho]sexplicit"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"{", 
    SubscriptBox["\[Delta]\[Rho]", "lead"], "}"}], "/.", "subAnsatz"}], "/.", 
  "solut\[Rho]s"}]}], "Input",
 CellChangeTimes->{{3.568964922246969*^9, 3.568964992118889*^9}, {
  3.568965133036759*^9, 3.568965140387188*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   SqrtBox[
    RowBox[{"1", "-", 
     SuperscriptBox["z", "2"]}]], " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"-", "162"}], "-", 
     RowBox[{"432", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3"]}], "+", 
     RowBox[{"432", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "5"]}], "+", 
     RowBox[{"504", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "7"]}]}], ")"}]}], "}"}]], "Output",
 CellChangeTimes->{{3.5689651348787737`*^9, 3.568965140680048*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   FractionBox["1", "30"], " ", 
   SqrtBox[
    RowBox[{"1", "-", 
     SuperscriptBox["z", "2"]}]], " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"-", "4860"}], "+", 
     RowBox[{"\[DoubleStruckCapitalC]", "[", 
      FractionBox[
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          RowBox[{"20", " ", "\[ImaginaryI]"}], "-", 
          RowBox[{"40", " ", "u"}]}], ")"}], " ", 
        SubscriptBox[
         StyleBox["H",
          FontColor->RGBColor[0.54, 0.35, 0.15]], "lead"]}], 
       SuperscriptBox["u", "2"]], "]"}], "+", 
     RowBox[{"20", " ", 
      RowBox[{"\[DoubleStruckCapitalC]", "[", 
       RowBox[{"-", 
        FractionBox[
         RowBox[{"4", " ", 
          RowBox[{"(", 
           RowBox[{"\[ImaginaryI]", "+", "u"}], ")"}], " ", 
          SubsuperscriptBox[
           StyleBox["W",
            FontColor->RGBColor[0.54, 0.35, 0.15]], 
           RowBox[{"1", ",", "lead"}], "+"]}], 
         SuperscriptBox[
          StyleBox["Q0",
           FontColor->RGBColor[{
              Rational[1, 2], 
              Rational[1, 2], 0}]], "+"]]}], "]"}]}], "+", 
     RowBox[{"\[DoubleStruckCapitalC]", "[", 
      FractionBox[
       RowBox[{"20", " ", "\[ImaginaryI]", " ", 
        RowBox[{"(", 
         RowBox[{"1", "+", 
          RowBox[{"16", " ", 
           SuperscriptBox["u", "2"]}], "+", 
          RowBox[{"15", " ", 
           SuperscriptBox["u", "4"]}], "-", 
          RowBox[{"9", " ", 
           SuperscriptBox[
            StyleBox["Q0",
             FontColor->RGBColor[{
                Rational[1, 2], 
                Rational[1, 2], 0}]], "-"], " ", 
           SuperscriptBox[
            StyleBox["Q0",
             FontColor->RGBColor[{
                Rational[1, 2], 
                Rational[1, 2], 0}]], "+"]}]}], ")"}], " ", 
        SubscriptBox[
         OverscriptBox[
          StyleBox["W",
           FontColor->RGBColor[0.54, 0.35, 0.15]], 
          StyleBox["^",
           FontColor->RGBColor[0.54, 0.35, 0.15]]], "lead"]}], 
       RowBox[{"3", " ", 
        RowBox[{"(", 
         RowBox[{"1", "+", 
          SuperscriptBox["u", "2"]}], ")"}], " ", 
        SuperscriptBox[
         StyleBox["Q0",
          FontColor->RGBColor[{
             Rational[1, 2], 
             Rational[1, 2], 0}]], "-"], " ", 
        SuperscriptBox[
         StyleBox["Q0",
          FontColor->RGBColor[{
             Rational[1, 2], 
             Rational[1, 2], 0}]], "+"]}]], "]"}], "+", 
     RowBox[{"100", " ", 
      SubscriptBox[
       StyleBox["W",
        FontColor->RGBColor[0.54, 0.35, 0.15]], 
       RowBox[{"1", ",", "v0", ",", "lead"}]]}], "+", 
     RowBox[{"11880", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2"]}], "-", 
     RowBox[{"5616", " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2", "2"]}], "+", 
     RowBox[{"576", " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2", "3"]}], "-", 
     RowBox[{"5400", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3"]}], "+", 
     RowBox[{"720", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3"]}], "+", 
     RowBox[{"288", " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2", "2"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3"]}], "+", 
     RowBox[{"1440", " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3", "2"]}]}], ")"}]}], "}"}]], "Output",
 CellChangeTimes->{{3.5689651348787737`*^9, 3.568965140692911*^9}}]
}, Open  ]],

Cell["\<\
Not evaluated form is useful because there are some cancellations in the \
final expression for the energy.\
\>", "Text",
 CellChangeTimes->{{3.568965330481299*^9, 3.5689653479180727`*^9}}],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"solut\[Rho]sexplicit", ";"}], "\[IndentingNewLine]", 
 RowBox[{"{", 
  RowBox[{
   RowBox[{
    RowBox[{"Head", "/@", "%"}], "//", "Union"}], ",", 
   RowBox[{"%", "[", 
    RowBox[{"[", 
     RowBox[{"All", ",", "1"}], "]"}], "]"}]}], "}"}]}], "Input",
 CellChangeTimes->{{3.568965267328315*^9, 3.5689652898826933`*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", "Rule", "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{
      SubscriptBox["\[Alpha]", "lead"], "[", "0", "]"}], ",", 
     RowBox[{
      SubscriptBox["\[Beta]", "lead"], "[", "0", "]"}], ",", 
     RowBox[{
      SubscriptBox["\[Alpha]", "lead"], "[", "1", "]"}], ",", 
     RowBox[{
      SubscriptBox["\[Beta]", "lead"], "[", "1", "]"}], ",", 
     RowBox[{
      SubscriptBox["\[Alpha]", "lead"], "[", "2", "]"}], ",", 
     RowBox[{
      SubscriptBox["\[Beta]", "lead"], "[", "2", "]"}], ",", 
     RowBox[{
      SubscriptBox["\[Alpha]", "lead"], "[", "3", "]"}], ",", 
     RowBox[{
      SubscriptBox["\[Beta]", "lead"], "[", "3", "]"}], ",", 
     RowBox[{
      SubscriptBox["\[Alpha]", "lead"], "[", "4", "]"}], ",", 
     RowBox[{
      SubscriptBox["\[Beta]", "lead"], "[", "4", "]"}], ",", 
     RowBox[{
      SubscriptBox["\[Alpha]", "lead"], "[", "5", "]"}], ",", 
     RowBox[{
      SubscriptBox["\[Beta]", "lead"], "[", "5", "]"}], ",", 
     RowBox[{
      SubscriptBox["\[Alpha]", "sublead"], "[", "0", "]"}], ",", 
     RowBox[{
      SubscriptBox["\[Beta]", "sublead"], "[", "0", "]"}], ",", 
     RowBox[{
      SubscriptBox["\[Alpha]", "sublead"], "[", "1", "]"}], ",", 
     RowBox[{
      SubscriptBox["\[Beta]", "sublead"], "[", "1", "]"}], ",", 
     RowBox[{
      SubscriptBox["\[Alpha]", "sublead"], "[", "2", "]"}], ",", 
     RowBox[{
      SubscriptBox["\[Beta]", "sublead"], "[", "2", "]"}], ",", 
     RowBox[{
      SubscriptBox["\[Alpha]", "sublead"], "[", "3", "]"}], ",", 
     RowBox[{
      SubscriptBox["\[Beta]", "sublead"], "[", "3", "]"}], ",", 
     RowBox[{
      SubscriptBox["\[Alpha]", "sublead"], "[", "4", "]"}], ",", 
     RowBox[{
      SubscriptBox["\[Beta]", "sublead"], "[", "4", "]"}], ",", 
     RowBox[{
      SubscriptBox["\[Alpha]", "sublead"], "[", "5", "]"}], ",", 
     RowBox[{
      SubscriptBox["\[Beta]", "sublead"], "[", "5", "]"}], ",", 
     RowBox[{
      SubscriptBox["\[Alpha]", "sublead2"], "[", "0", "]"}], ",", 
     RowBox[{
      SubscriptBox["\[Beta]", "sublead2"], "[", "0", "]"}], ",", 
     RowBox[{
      SubscriptBox["\[Alpha]", "sublead2"], "[", "1", "]"}], ",", 
     RowBox[{
      SubscriptBox["\[Beta]", "sublead2"], "[", "1", "]"}], ",", 
     RowBox[{
      SubscriptBox["\[Alpha]", "sublead2"], "[", "2", "]"}], ",", 
     RowBox[{
      SubscriptBox["\[Beta]", "sublead2"], "[", "2", "]"}], ",", 
     RowBox[{
      SubscriptBox["\[Alpha]", "sublead2"], "[", "3", "]"}], ",", 
     RowBox[{
      SubscriptBox["\[Beta]", "sublead2"], "[", "3", "]"}], ",", 
     RowBox[{
      SubscriptBox["\[Alpha]", "sublead2"], "[", "4", "]"}], ",", 
     RowBox[{
      SubscriptBox["\[Beta]", "sublead2"], "[", "4", "]"}], ",", 
     RowBox[{
      SubscriptBox["\[Alpha]", "sublead2"], "[", "5", "]"}], ",", 
     RowBox[{
      SubscriptBox["\[Beta]", "sublead2"], "[", "5", "]"}]}], "}"}]}], 
  "}"}]], "Output",
 CellChangeTimes->{{3.568965270491253*^9, 3.568965290301632*^9}}]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell["Init", "Subsection",
 CellChangeTimes->{{3.546929378774991*^9, 3.5469293792622004`*^9}}],

Cell["Magic ratios are given by", "Text",
 CellChangeTimes->{{3.553712416061351*^9, 3.55371242164242*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{
    FractionBox[
     RowBox[{"1", "+", 
      SubscriptBox[
       StyleBox["Y",
        FontColor->RGBColor[0, 0, 0.8]], 
       RowBox[{"1", ",", "1"}]]}], 
     RowBox[{"1", "+", 
      FractionBox["1", 
       SubscriptBox[
        StyleBox["Y",
         FontColor->RGBColor[0, 0, 0.8]], 
        RowBox[{"2", ",", "2"}]]]}]], "==", 
    FractionBox[
     RowBox[{
      SuperscriptBox[
       StyleBox["\[ScriptCapitalT]",
        FontColor->RGBColor[1, 0, 0]], "-"], " ", 
      SuperscriptBox[
       StyleBox["\[ScriptCapitalT]",
        FontColor->RGBColor[1, 0, 0]], "+"], " ", 
      SubscriptBox[
       StyleBox["\[ScriptCapitalT]",
        FontColor->RGBColor[1, 0, 0]], 
       RowBox[{"2", ",", "3"}]]}], 
     RowBox[{
      SubscriptBox[
       StyleBox["\[ScriptCapitalT]",
        FontColor->RGBColor[1, 0, 0]], 
       RowBox[{"0", ",", "1"}]], " ", 
      SubsuperscriptBox[
       StyleBox["\[ScriptCapitalT]",
        FontColor->RGBColor[1, 0, 0]], 
       RowBox[{"2", ",", "2"}], "-"], " ", 
      SubsuperscriptBox[
       StyleBox["\[ScriptCapitalT]",
        FontColor->RGBColor[1, 0, 0]], 
       RowBox[{"2", ",", "2"}], "+"]}]]}], ",", 
   RowBox[{
    FractionBox[
     RowBox[{"1", "+", 
      SubscriptBox[
       StyleBox["Y",
        FontColor->RGBColor[0, 0, 0.8]], 
       RowBox[{"2", ",", "2"}]]}], 
     RowBox[{"1", "+", 
      FractionBox["1", 
       SubscriptBox[
        StyleBox["Y",
         FontColor->RGBColor[0, 0, 0.8]], 
        RowBox[{"1", ",", "1"}]]]}]], "==", 
    FractionBox[
     RowBox[{
      SubscriptBox[
       StyleBox["\[GothicCapitalT]",
        FontColor->RGBColor[0.54, 0.35, 0.15]], 
       RowBox[{"1", ",", "0"}]], " ", 
      SubsuperscriptBox[
       StyleBox["\[GothicCapitalT]",
        FontColor->RGBColor[0.54, 0.35, 0.15]], 
       RowBox[{"2", ",", "2"}], "-"], " ", 
      SubsuperscriptBox[
       StyleBox["\[GothicCapitalT]",
        FontColor->RGBColor[0.54, 0.35, 0.15]], 
       RowBox[{"2", ",", "2"}], "+"]}], 
     RowBox[{
      SuperscriptBox[
       StyleBox["\[GothicCapitalT]",
        FontColor->RGBColor[0.54, 0.35, 0.15]], "-"], " ", 
      SuperscriptBox[
       StyleBox["\[GothicCapitalT]",
        FontColor->RGBColor[0.54, 0.35, 0.15]], "+"], " ", 
      SubscriptBox[
       StyleBox["\[GothicCapitalT]",
        FontColor->RGBColor[0.54, 0.35, 0.15]], 
       RowBox[{"3", ",", "2"}]]}]]}]}], "}"}]], "Input",
 CellChangeTimes->{{3.546685955076654*^9, 3.546685964136176*^9}}],

Cell[TextData[{
 "Expression for ",
 Cell[BoxData[
  FormBox[
   RowBox[{
    SubscriptBox["Y", 
     RowBox[{"1", ",", "1"}]], 
    SubscriptBox["Y", 
     RowBox[{"2", ",", "2"}]]}], TraditionalForm]]],
 " and ",
 Cell[BoxData[
  FormBox[
   RowBox[{
    SubscriptBox["Y", 
     RowBox[{"1", ",", "1"}]], "/", 
    SubscriptBox["Y", 
     RowBox[{"2", ",", "2"}]]}], TraditionalForm]]],
 " in the double scaling regime are (see previous sections for derivation):"
}], "Text",
 CellChangeTimes->{{3.546685847937811*^9, 3.546685855606657*^9}, {
  3.546686017444147*^9, 3.546686027682317*^9}, {3.546929452883662*^9, 
  3.54692947114675*^9}, {3.549689411850115*^9, 3.549689416670555*^9}, {
  3.553712462275362*^9, 3.553712512526783*^9}, {3.5537126602066517`*^9, 
  3.553712665817276*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"Log", "[", " ", 
   FractionBox[
    RowBox[{
     SubscriptBox[
      StyleBox["Y",
       FontColor->RGBColor[0, 0, 0.8]], 
      RowBox[{"1", ",", "1"}]], " ", 
     SubscriptBox[
      StyleBox["Y",
       FontColor->RGBColor[0, 0, 0.8]], 
      RowBox[{"2", ",", "2"}]]}], 
    SubscriptBox[
     RowBox[{"(", 
      RowBox[{
       SubscriptBox["Y", 
        RowBox[{"1", ",", "1"}]], 
       SubscriptBox["Y", 
        RowBox[{"2", ",", "2"}]]}], ")"}], "asym"]], "]"}], "==", 
  RowBox[{
   RowBox[{"-", "4"}], "\[ImaginaryI]", " ", "g", 
   SqrtBox[
    RowBox[{"1", "-", 
     SuperscriptBox["z", "2"]}]], 
   RowBox[{
    SubsuperscriptBox["\[Integral]", 
     RowBox[{
      RowBox[{"-", "\[Infinity]"}], "-", 
      RowBox[{"\[ImaginaryI]", " ", "0"}]}], 
     RowBox[{
      RowBox[{"+", "\[Infinity]"}], "-", 
      RowBox[{"\[ImaginaryI]", " ", "0"}]}]], 
    RowBox[{
     FractionBox["dv", 
      RowBox[{
       RowBox[{"-", "2"}], "\[Pi]", " ", "\[ImaginaryI]"}]], 
     FractionBox["1", 
      RowBox[{
       RowBox[{"4", 
        SuperscriptBox["g", "2"], 
        SuperscriptBox["z", "2"]}], "-", 
       SuperscriptBox["v", "2"]}]], 
     FractionBox["H", 
      SqrtBox[
       RowBox[{"1", "-", 
        FractionBox[
         RowBox[{"4", 
          SuperscriptBox["g", "2"]}], 
         SuperscriptBox["v", "2"]]}]]]}]}]}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Log", "[", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      FractionBox[
       SubscriptBox["Y", 
        RowBox[{"1", ",", "1"}]], 
       SubscriptBox["Y", 
        RowBox[{"2", ",", "2"}]]], 
      FractionBox[
       SubsuperscriptBox[
        StyleBox["\[GothicCapitalT]",
         FontColor->RGBColor[0.54, 0.35, 0.15]], 
        RowBox[{"2", ",", "1"}], "2"], 
       SubsuperscriptBox[
        StyleBox["\[ScriptCapitalT]",
         FontColor->RGBColor[1, 0, 0]], 
        RowBox[{"1", ",", "2"}], "2"]]}], ")"}], "/", 
    SubscriptBox[
     RowBox[{"(", 
      RowBox[{
       FractionBox[
        SubscriptBox["Y", 
         RowBox[{"1", ",", "1"}]], 
        SubscriptBox["Y", 
         RowBox[{"2", ",", "2"}]]], 
       FractionBox[
        SubsuperscriptBox[
         StyleBox["\[GothicCapitalT]",
          FontColor->RGBColor[0.54, 0.35, 0.15]], 
         RowBox[{"2", ",", "1"}], "2"], 
        SubsuperscriptBox[
         StyleBox["\[ScriptCapitalT]",
          FontColor->RGBColor[1, 0, 0]], 
         RowBox[{"1", ",", "2"}], "2"]]}], ")"}], "asym"]}], "]"}], 
  "\[Equal]", 
  RowBox[{
   SubsuperscriptBox["\[Integral]", 
    RowBox[{
     RowBox[{"-", "\[Infinity]"}], "-", 
     RowBox[{"\[ImaginaryI]", " ", "0"}]}], 
    RowBox[{
     RowBox[{"+", "\[Infinity]"}], "-", 
     RowBox[{"\[ImaginaryI]", " ", "0"}]}]], 
   RowBox[{
    FractionBox["dv", 
     RowBox[{
      RowBox[{"-", "2"}], "\[Pi]", " ", "\[ImaginaryI]"}]], 
    RowBox[{"(", 
     FractionBox[
      RowBox[{"2", "v"}], 
      RowBox[{
       RowBox[{"4", 
        SuperscriptBox["g", "2"], 
        SuperscriptBox["z", "2"]}], "-", 
       SuperscriptBox["v", "2"]}]], ")"}], 
    RowBox[{"(", 
     RowBox[{"H", "-", 
      RowBox[{"2", 
       RowBox[{"Log", "[", 
        RowBox[{
         RowBox[{"(", 
          FractionBox[
           RowBox[{" ", 
            SuperscriptBox[
             StyleBox["\[ScriptCapitalT]",
              FontColor->RGBColor[1, 0, 0]], "+"], " "}], 
           SuperscriptBox[
            StyleBox["\[GothicCapitalT]",
             FontColor->RGBColor[0.54, 0.35, 0.15]], "+"]], ")"}], "/", 
         SubscriptBox[
          RowBox[{"(", 
           FractionBox[
            RowBox[{" ", 
             SuperscriptBox[
              StyleBox["\[ScriptCapitalT]",
               FontColor->RGBColor[1, 0, 0]], "+"], " "}], 
            SuperscriptBox[
             StyleBox["\[GothicCapitalT]",
              FontColor->RGBColor[0.54, 0.35, 0.15]], "+"]], ")"}], "asym"]}],
         "]"}]}]}], ")"}]}]}]}]}], "Input",
 CellChangeTimes->{{3.546686010540494*^9, 3.546686010839571*^9}, 
   3.553712451907802*^9, 3.5537126489002457`*^9}],

Cell[TextData[{
 "Now we will construct from magic ratios expressions which give ",
 Cell[BoxData[
  FormBox[
   RowBox[{
    SubscriptBox["Y", 
     RowBox[{"1", ",", "1"}]], 
    SubscriptBox["Y", 
     RowBox[{"2", ",", "2"}]]}], TraditionalForm]]],
 " and ",
 Cell[BoxData[
  FormBox[
   RowBox[{
    SubscriptBox["Y", 
     RowBox[{"1", ",", "1"}]], "/", 
    SubscriptBox["Y", 
     RowBox[{"2", ",", "2"}]]}], TraditionalForm]]],
 " in terms of \[ScriptCapitalT] and \[GothicCapitalT]. First we rewrite \
magic ratios in a more attractible way:"
}], "Text",
 CellChangeTimes->{{3.546686121134562*^9, 3.5466861346699123`*^9}, {
  3.553712671460473*^9, 3.553712737101655*^9}, {3.568964434067265*^9, 
  3.568964434185945*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{
    FractionBox[
     RowBox[{
      SuperscriptBox[
       StyleBox["\[ScriptCapitalT]",
        FontColor->RGBColor[1, 0, 0]], "-"], " ", 
      SuperscriptBox[
       StyleBox["\[ScriptCapitalT]",
        FontColor->RGBColor[1, 0, 0]], "+"], " ", 
      SubscriptBox[
       StyleBox["\[ScriptCapitalT]",
        FontColor->RGBColor[1, 0, 0]], 
       RowBox[{"2", ",", "3"}]]}], 
     RowBox[{
      SubscriptBox[
       StyleBox["\[ScriptCapitalT]",
        FontColor->RGBColor[1, 0, 0]], 
       RowBox[{"0", ",", "1"}]], " ", 
      SubsuperscriptBox[
       StyleBox["\[ScriptCapitalT]",
        FontColor->RGBColor[1, 0, 0]], 
       RowBox[{"2", ",", "2"}], "-"], " ", 
      SubsuperscriptBox[
       StyleBox["\[ScriptCapitalT]",
        FontColor->RGBColor[1, 0, 0]], 
       RowBox[{"2", ",", "2"}], "+"]}]], "==", 
    FractionBox[
     RowBox[{
      SuperscriptBox[
       StyleBox["\[ScriptCapitalT]",
        FontColor->RGBColor[1, 0, 0]], "-"], " ", 
      SuperscriptBox[
       StyleBox["\[ScriptCapitalT]",
        FontColor->RGBColor[1, 0, 0]], "+"]}], 
     RowBox[{
      SubsuperscriptBox[
       StyleBox["\[ScriptCapitalT]",
        FontColor->RGBColor[1, 0, 0]], "\[FivePointedStar]", "-"], 
      SubsuperscriptBox[
       StyleBox["\[ScriptCapitalT]",
        FontColor->RGBColor[1, 0, 0]], "\[FivePointedStar]", "+"]}]]}], ",", 
   RowBox[{
    FractionBox[
     RowBox[{
      SubscriptBox[
       StyleBox["\[GothicCapitalT]",
        FontColor->RGBColor[0.54, 0.35, 0.15]], 
       RowBox[{"1", ",", "0"}]], " ", 
      SubsuperscriptBox[
       StyleBox["\[GothicCapitalT]",
        FontColor->RGBColor[0.54, 0.35, 0.15]], 
       RowBox[{"2", ",", "2"}], "-"], " ", 
      SubsuperscriptBox[
       StyleBox["\[GothicCapitalT]",
        FontColor->RGBColor[0.54, 0.35, 0.15]], 
       RowBox[{"2", ",", "2"}], "+"]}], 
     RowBox[{
      SuperscriptBox[
       StyleBox["\[GothicCapitalT]",
        FontColor->RGBColor[0.54, 0.35, 0.15]], "-"], " ", 
      SuperscriptBox[
       StyleBox["\[GothicCapitalT]",
        FontColor->RGBColor[0.54, 0.35, 0.15]], "+"], " ", 
      SubscriptBox[
       StyleBox["\[GothicCapitalT]",
        FontColor->RGBColor[0.54, 0.35, 0.15]], 
       RowBox[{"3", ",", "2"}]]}]], "==", 
    FractionBox[
     RowBox[{
      SubsuperscriptBox[
       StyleBox["\[GothicQ]",
        FontColor->RGBColor[0.54, 0.35, 0.15]], "0", "+"], 
      SubsuperscriptBox[
       OverscriptBox[
        StyleBox["\[GothicQ]",
         FontColor->RGBColor[0.54, 0.35, 0.15]], 
        StyleBox["_",
         FontColor->RGBColor[0.54, 0.35, 0.15]]], "0", "-"], 
      SubscriptBox[
       StyleBox["\[GothicCapitalT]",
        FontColor->RGBColor[0.54, 0.35, 0.15]], 
       RowBox[{"1", ",", "0"}]]}], 
     RowBox[{
      SuperscriptBox[
       StyleBox["\[GothicCapitalT]",
        FontColor->RGBColor[0.54, 0.35, 0.15]], "-"], " ", 
      SuperscriptBox[
       StyleBox["\[GothicCapitalT]",
        FontColor->RGBColor[0.54, 0.35, 0.15]], "+"]}]], "\[Equal]", 
    RowBox[{
     FractionBox[
      SubscriptBox[
       StyleBox["\[GothicCapitalT]",
        FontColor->RGBColor[0.54, 0.35, 0.15]], 
       RowBox[{"1", ",", "0"}]], 
      RowBox[{"(", 
       RowBox[{
        SubsuperscriptBox[
         StyleBox["\[GothicQ]",
          FontColor->RGBColor[0.54, 0.35, 0.15]], 
         RowBox[{"1", ",", "2"}], "+"], " ", 
        SubsuperscriptBox[
         OverscriptBox[
          StyleBox["\[GothicQ]",
           FontColor->RGBColor[0.54, 0.35, 0.15]], 
          StyleBox["_",
           FontColor->RGBColor[0.54, 0.35, 0.15]]], 
         RowBox[{"1", ",", "2"}], "-"]}], ")"}]], 
     FractionBox[
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         SubscriptBox[
          StyleBox["\[GothicQ]",
           FontColor->RGBColor[0.54, 0.35, 0.15]], "2"], "-", 
         SubsuperscriptBox[
          StyleBox["\[GothicQ]",
           FontColor->RGBColor[0.54, 0.35, 0.15]], "2", 
          RowBox[{"[", "2", "]"}]]}], ")"}], 
       RowBox[{"(", 
        RowBox[{
         SubscriptBox[
          OverscriptBox[
           StyleBox["\[GothicQ]",
            FontColor->RGBColor[0.54, 0.35, 0.15]], 
           StyleBox["_",
            FontColor->RGBColor[0.54, 0.35, 0.15]]], "2"], "-", 
         SubsuperscriptBox[
          OverscriptBox[
           StyleBox["\[GothicQ]",
            FontColor->RGBColor[0.54, 0.35, 0.15]], 
           StyleBox["_",
            FontColor->RGBColor[0.54, 0.35, 0.15]]], "2", 
          RowBox[{"[", 
           RowBox[{"-", "2"}], "]"}]]}], ")"}]}], 
      RowBox[{
       SuperscriptBox[
        StyleBox["\[GothicCapitalT]",
         FontColor->RGBColor[0.54, 0.35, 0.15]], "-"], " ", 
       SuperscriptBox[
        StyleBox["\[GothicCapitalT]",
         FontColor->RGBColor[0.54, 0.35, 0.15]], "+"]}]]}]}]}], 
  "}"}]], "Input",
 CellChangeTimes->{{3.5466861392423058`*^9, 3.5466861589189987`*^9}, {
  3.546929610721087*^9, 3.546929612565577*^9}, {3.553712564182016*^9, 
  3.553712579893372*^9}, {3.55371273815758*^9, 3.553712744936556*^9}, {
  3.553712806724766*^9, 3.5537128125087357`*^9}}],

Cell[TextData[{
 "Now we solve magic ratios in terms of ",
 " ",
 Cell[BoxData[
  FormBox[
   RowBox[{
    SubscriptBox["Y", 
     RowBox[{"1", ",", "1"}]], 
    SubscriptBox["Y", 
     RowBox[{"2", ",", "2"}]]}], TraditionalForm]]],
 " and ",
 Cell[BoxData[
  FormBox[
   RowBox[{
    SubscriptBox["Y", 
     RowBox[{"1", ",", "1"}]], "/", 
    SubscriptBox["Y", 
     RowBox[{"2", ",", "2"}]]}], TraditionalForm]]]
}], "Text",
 CellChangeTimes->{{3.54692973488694*^9, 3.5469297437281427`*^9}, {
  3.5537127519932003`*^9, 3.5537127756573467`*^9}}],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"Solve", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{
         FractionBox[
          RowBox[{"1", "+", 
           SubscriptBox[
            StyleBox["Y",
             FontColor->RGBColor[0, 0, 0.8]], 
            RowBox[{"1", ",", "1"}]]}], 
          RowBox[{"1", "+", 
           FractionBox["1", 
            SubscriptBox[
             StyleBox["Y",
              FontColor->RGBColor[0, 0, 0.8]], 
             RowBox[{"2", ",", "2"}]]]}]], "==", 
         FractionBox[
          RowBox[{
           SuperscriptBox[
            StyleBox["\[ScriptCapitalT]",
             FontColor->RGBColor[1, 0, 0]], "-"], " ", 
           SuperscriptBox[
            StyleBox["\[ScriptCapitalT]",
             FontColor->RGBColor[1, 0, 0]], "+"]}], 
          RowBox[{
           SubsuperscriptBox[
            StyleBox["\[ScriptCapitalT]",
             FontColor->RGBColor[1, 0, 0]], "\[FivePointedStar]", "-"], 
           SubsuperscriptBox[
            StyleBox["\[ScriptCapitalT]",
             FontColor->RGBColor[1, 0, 0]], "\[FivePointedStar]", "+"]}]]}], 
        ",", 
        RowBox[{
         FractionBox[
          RowBox[{"1", "+", 
           SubscriptBox[
            StyleBox["Y",
             FontColor->RGBColor[0, 0, 0.8]], 
            RowBox[{"2", ",", "2"}]]}], 
          RowBox[{"1", "+", 
           FractionBox["1", 
            SubscriptBox[
             StyleBox["Y",
              FontColor->RGBColor[0, 0, 0.8]], 
             RowBox[{"1", ",", "1"}]]]}]], "==", 
         FractionBox[
          RowBox[{
           SubsuperscriptBox[
            StyleBox["\[GothicQ]",
             FontColor->RGBColor[0.54, 0.35, 0.15]], "0", "+"], 
           SubsuperscriptBox[
            OverscriptBox[
             StyleBox["\[GothicQ]",
              FontColor->RGBColor[0.54, 0.35, 0.15]], 
             StyleBox["_",
              FontColor->RGBColor[0.54, 0.35, 0.15]]], "0", "-"], 
           SubscriptBox[
            StyleBox["\[GothicCapitalT]",
             FontColor->RGBColor[0.54, 0.35, 0.15]], 
            RowBox[{"1", ",", "0"}]]}], 
          RowBox[{
           SuperscriptBox[
            StyleBox["\[GothicCapitalT]",
             FontColor->RGBColor[0.54, 0.35, 0.15]], "-"], " ", 
           SuperscriptBox[
            StyleBox["\[GothicCapitalT]",
             FontColor->RGBColor[0.54, 0.35, 0.15]], "+"]}]]}]}], "}"}], ",", 
      
      RowBox[{"{", 
       RowBox[{
        SubscriptBox["Y", 
         RowBox[{"1", ",", "1"}]], ",", 
        SubscriptBox["Y", 
         RowBox[{"2", ",", "2"}]]}], "}"}]}], "]"}], "[", 
    RowBox[{"[", "1", "]"}], "]"}], "//", "Simplify"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"{", 
   RowBox[{
    RowBox[{
     RowBox[{
      SubscriptBox["Y", 
       RowBox[{"1", ",", "1"}]], 
      SubscriptBox["Y", 
       RowBox[{"2", ",", "2"}]]}], "\[Equal]", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{
        SubscriptBox["Y", 
         RowBox[{"1", ",", "1"}]], 
        SubscriptBox["Y", 
         RowBox[{"2", ",", "2"}]]}], "/.", "%"}], ")"}]}], ",", 
    RowBox[{
     RowBox[{
      SubscriptBox["Y", 
       RowBox[{"1", ",", "1"}]], "/", 
      SubscriptBox["Y", 
       RowBox[{"2", ",", "2"}]]}], "\[Equal]", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{
        SubscriptBox["Y", 
         RowBox[{"1", ",", "1"}]], "/", 
        SubscriptBox["Y", 
         RowBox[{"2", ",", "2"}]]}], "/.", "%"}], ")"}]}]}], "}"}], "//", 
  "Simplify"}]}], "Input",
 CellChangeTimes->{{3.54668701083609*^9, 3.546687065769067*^9}, 
   3.553712784689097*^9, 3.5537128424947367`*^9, {3.5537129115350943`*^9, 
   3.5537129127070227`*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{
    FractionBox[
     RowBox[{
      SubsuperscriptBox[
       StyleBox["\[GothicQ]",
        FontColor->RGBColor[0.54, 0.35, 0.15]], "0", "+"], " ", 
      SubsuperscriptBox[
       OverscriptBox[
        StyleBox["\[GothicQ]",
         FontColor->RGBColor[0.54, 0.35, 0.15]], 
        StyleBox["_",
         FontColor->RGBColor[0.54, 0.35, 0.15]]], "0", "-"], " ", 
      SuperscriptBox[
       StyleBox["\[ScriptCapitalT]",
        FontColor->RGBColor[1, 0, 0]], "-"], " ", 
      SuperscriptBox[
       StyleBox["\[ScriptCapitalT]",
        FontColor->RGBColor[1, 0, 0]], "+"], " ", 
      SubscriptBox[
       StyleBox["\[GothicCapitalT]",
        FontColor->RGBColor[0.54, 0.35, 0.15]], 
       RowBox[{"1", ",", "0"}]]}], 
     RowBox[{
      SubsuperscriptBox[
       StyleBox["\[ScriptCapitalT]",
        FontColor->RGBColor[1, 0, 0]], "\[FivePointedStar]", "-"], " ", 
      SubsuperscriptBox[
       StyleBox["\[ScriptCapitalT]",
        FontColor->RGBColor[1, 0, 0]], "\[FivePointedStar]", "+"], " ", 
      SuperscriptBox[
       StyleBox["\[GothicCapitalT]",
        FontColor->RGBColor[0.54, 0.35, 0.15]], "-"], " ", 
      SuperscriptBox[
       StyleBox["\[GothicCapitalT]",
        FontColor->RGBColor[0.54, 0.35, 0.15]], "+"]}]], "\[Equal]", 
    RowBox[{
     SubscriptBox[
      StyleBox["Y",
       FontColor->RGBColor[0, 0, 0.8]], 
      RowBox[{"1", ",", "1"}]], " ", 
     SubscriptBox[
      StyleBox["Y",
       FontColor->RGBColor[0, 0, 0.8]], 
      RowBox[{"2", ",", "2"}]]}]}], ",", 
   RowBox[{
    FractionBox[
     SubscriptBox[
      StyleBox["Y",
       FontColor->RGBColor[0, 0, 0.8]], 
      RowBox[{"1", ",", "1"}]], 
     SubscriptBox[
      StyleBox["Y",
       FontColor->RGBColor[0, 0, 0.8]], 
      RowBox[{"2", ",", "2"}]]], "\[Equal]", 
    FractionBox[
     RowBox[{
      SubsuperscriptBox[
       StyleBox["\[GothicQ]",
        FontColor->RGBColor[0.54, 0.35, 0.15]], "0", "+"], " ", 
      SubsuperscriptBox[
       OverscriptBox[
        StyleBox["\[GothicQ]",
         FontColor->RGBColor[0.54, 0.35, 0.15]], 
        StyleBox["_",
         FontColor->RGBColor[0.54, 0.35, 0.15]]], "0", "-"], " ", 
      SuperscriptBox[
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          SubsuperscriptBox[
           StyleBox["\[ScriptCapitalT]",
            FontColor->RGBColor[1, 0, 0]], "\[FivePointedStar]", "-"], " ", 
          SubsuperscriptBox[
           StyleBox["\[ScriptCapitalT]",
            FontColor->RGBColor[1, 0, 0]], "\[FivePointedStar]", "+"]}], "-", 
         
         RowBox[{
          SuperscriptBox[
           StyleBox["\[ScriptCapitalT]",
            FontColor->RGBColor[1, 0, 0]], "-"], " ", 
          SuperscriptBox[
           StyleBox["\[ScriptCapitalT]",
            FontColor->RGBColor[1, 0, 0]], "+"]}]}], ")"}], "2"], " ", 
      SubscriptBox[
       StyleBox["\[GothicCapitalT]",
        FontColor->RGBColor[0.54, 0.35, 0.15]], 
       RowBox[{"1", ",", "0"}]], " ", 
      SuperscriptBox[
       StyleBox["\[GothicCapitalT]",
        FontColor->RGBColor[0.54, 0.35, 0.15]], "-"], " ", 
      SuperscriptBox[
       StyleBox["\[GothicCapitalT]",
        FontColor->RGBColor[0.54, 0.35, 0.15]], "+"]}], 
     RowBox[{
      SubsuperscriptBox[
       StyleBox["\[ScriptCapitalT]",
        FontColor->RGBColor[1, 0, 0]], "\[FivePointedStar]", "-"], " ", 
      SubsuperscriptBox[
       StyleBox["\[ScriptCapitalT]",
        FontColor->RGBColor[1, 0, 0]], "\[FivePointedStar]", "+"], " ", 
      SuperscriptBox[
       StyleBox["\[ScriptCapitalT]",
        FontColor->RGBColor[1, 0, 0]], "-"], " ", 
      SuperscriptBox[
       StyleBox["\[ScriptCapitalT]",
        FontColor->RGBColor[1, 0, 0]], "+"], " ", 
      SuperscriptBox[
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          SubsuperscriptBox[
           StyleBox["\[GothicQ]",
            FontColor->RGBColor[0.54, 0.35, 0.15]], "0", "+"], " ", 
          SubsuperscriptBox[
           OverscriptBox[
            StyleBox["\[GothicQ]",
             FontColor->RGBColor[0.54, 0.35, 0.15]], 
            StyleBox["_",
             FontColor->RGBColor[0.54, 0.35, 0.15]]], "0", "-"], " ", 
          SubscriptBox[
           StyleBox["\[GothicCapitalT]",
            FontColor->RGBColor[0.54, 0.35, 0.15]], 
           RowBox[{"1", ",", "0"}]]}], "-", 
         RowBox[{
          SuperscriptBox[
           StyleBox["\[GothicCapitalT]",
            FontColor->RGBColor[0.54, 0.35, 0.15]], "-"], " ", 
          SuperscriptBox[
           StyleBox["\[GothicCapitalT]",
            FontColor->RGBColor[0.54, 0.35, 0.15]], "+"]}]}], ")"}], 
       "2"]}]]}]}], "}"}]], "Output",
 CellChangeTimes->{{3.5466870311153107`*^9, 3.546687066741515*^9}, 
   3.5469297601975307`*^9, 3.553712843463189*^9, 3.5537129135346107`*^9}]
}, Open  ]],

Cell[TextData[{
 "Recall that ",
 Cell[BoxData[
  FormBox[
   RowBox[{
    RowBox[{
     SubsuperscriptBox[
      StyleBox["\[ScriptCapitalT]",
       FontColor->RGBColor[1, 0, 0]], "\[FivePointedStar]", "-"], " ", 
     SubsuperscriptBox[
      StyleBox["\[ScriptCapitalT]",
       FontColor->RGBColor[1, 0, 0]], "\[FivePointedStar]", "+"]}], "==", 
    SubsuperscriptBox["\[ScriptCapitalT]", 
     RowBox[{"2", ",", "1"}], "c"]}], TraditionalForm]]],
 ", ",
 Cell[BoxData[
  FormBox[
   RowBox[{
    RowBox[{
     SubsuperscriptBox[
      StyleBox["\[GothicQ]",
       FontColor->RGBColor[0.54, 0.35, 0.15]], "0", "+"], " ", 
     SubsuperscriptBox[
      OverscriptBox[
       StyleBox["\[GothicQ]",
        FontColor->RGBColor[0.54, 0.35, 0.15]], 
       StyleBox["_",
        FontColor->RGBColor[0.54, 0.35, 0.15]]], "0", "-"]}], " ", "\[Equal]", 
    SubsuperscriptBox["\[GothicCapitalT]", 
     RowBox[{"1", ",", "2"}], "c"]}], TraditionalForm]]],
 ", which leads to \n",
 Cell[BoxData[
  RowBox[{"{", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{
       SubsuperscriptBox[
        StyleBox["\[ScriptCapitalT]",
         FontColor->RGBColor[1, 0, 0]], "\[FivePointedStar]", "-"], " ", 
       SubsuperscriptBox[
        StyleBox["\[ScriptCapitalT]",
         FontColor->RGBColor[1, 0, 0]], "\[FivePointedStar]", "+"]}], "-", 
      RowBox[{
       SuperscriptBox[
        StyleBox["\[ScriptCapitalT]",
         FontColor->RGBColor[1, 0, 0]], "-"], " ", 
       SuperscriptBox[
        StyleBox["\[ScriptCapitalT]",
         FontColor->RGBColor[1, 0, 0]], "+"]}]}], "\[Equal]", 
     RowBox[{
      RowBox[{"-", 
       SubsuperscriptBox[
        StyleBox["\[ScriptCapitalT]",
         FontColor->RGBColor[1, 0, 0]], 
        RowBox[{"1", ",", "0"}], "c"]}], " ", 
      SubscriptBox[
       StyleBox["\[ScriptCapitalT]",
        FontColor->RGBColor[1, 0, 0]], 
       RowBox[{"1", ",", "2"}]]}]}], ",", 
    RowBox[{
     RowBox[{
      RowBox[{
       SubsuperscriptBox[
        StyleBox["\[GothicQ]",
         FontColor->RGBColor[0.54, 0.35, 0.15]], "0", "+"], " ", 
       SubsuperscriptBox[
        OverscriptBox[
         StyleBox["\[GothicQ]",
          FontColor->RGBColor[0.54, 0.35, 0.15]], 
         StyleBox["_",
          FontColor->RGBColor[0.54, 0.35, 0.15]]], "0", "-"], " ", 
       SubscriptBox[
        StyleBox["\[GothicCapitalT]",
         FontColor->RGBColor[0.54, 0.35, 0.15]], 
        RowBox[{"1", ",", "0"}]]}], "-", 
      RowBox[{
       SuperscriptBox[
        StyleBox["\[GothicCapitalT]",
         FontColor->RGBColor[0.54, 0.35, 0.15]], "-"], " ", 
       SuperscriptBox[
        StyleBox["\[GothicCapitalT]",
         FontColor->RGBColor[0.54, 0.35, 0.15]], "+"]}]}], "==", 
     RowBox[{
      RowBox[{"-", 
       SubsuperscriptBox[
        StyleBox["\[GothicCapitalT]",
         FontColor->RGBColor[0.54, 0.35, 0.15]], 
        RowBox[{"0", ",", "1"}], "c"]}], " ", 
      SubscriptBox[
       StyleBox["\[GothicCapitalT]",
        FontColor->RGBColor[0.54, 0.35, 0.15]], 
       RowBox[{"2", ",", "1"}]]}]}]}], "}"}]], "Input",
  CellChangeTimes->{{3.553325913065428*^9, 3.553325956290229*^9}}]
}], "Text",
 CellChangeTimes->{{3.5537135055046062`*^9, 3.553713506879176*^9}, {
  3.553713575846478*^9, 3.553713580949408*^9}, {3.553713616564322*^9, 
  3.553713623882163*^9}, {3.553713666953023*^9, 3.5537136840682697`*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{
    RowBox[{
     SubscriptBox[
      StyleBox["Y",
       FontColor->RGBColor[0, 0, 0.8]], 
      RowBox[{"1", ",", "1"}]], " ", 
     SubscriptBox[
      StyleBox["Y",
       FontColor->RGBColor[0, 0, 0.8]], 
      RowBox[{"2", ",", "2"}]]}], "\[Equal]", 
    RowBox[{
     FractionBox[
      RowBox[{
       SuperscriptBox[
        StyleBox["\[ScriptCapitalT]",
         FontColor->RGBColor[1, 0, 0]], "-"], " ", 
       SuperscriptBox[
        StyleBox["\[ScriptCapitalT]",
         FontColor->RGBColor[1, 0, 0]], "+"]}], 
      RowBox[{
       SubsuperscriptBox[
        StyleBox["\[ScriptCapitalT]",
         FontColor->RGBColor[1, 0, 0]], "\[FivePointedStar]", "-"], 
       SubsuperscriptBox[
        StyleBox["\[ScriptCapitalT]",
         FontColor->RGBColor[1, 0, 0]], "\[FivePointedStar]", "+"]}]], 
     FractionBox[
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         SubscriptBox[
          StyleBox["\[GothicQ]",
           FontColor->RGBColor[0.54, 0.35, 0.15]], "2"], "-", 
         SubsuperscriptBox[
          StyleBox["\[GothicQ]",
           FontColor->RGBColor[0.54, 0.35, 0.15]], "2", 
          RowBox[{"[", "2", "]"}]]}], ")"}], 
       RowBox[{"(", 
        RowBox[{
         SubscriptBox[
          OverscriptBox[
           StyleBox["\[GothicQ]",
            FontColor->RGBColor[0.54, 0.35, 0.15]], 
           StyleBox["_",
            FontColor->RGBColor[0.54, 0.35, 0.15]]], "2"], "-", 
         SubsuperscriptBox[
          OverscriptBox[
           StyleBox["\[GothicQ]",
            FontColor->RGBColor[0.54, 0.35, 0.15]], 
           StyleBox["_",
            FontColor->RGBColor[0.54, 0.35, 0.15]]], "2", 
          RowBox[{"[", 
           RowBox[{"-", "2"}], "]"}]]}], ")"}]}], 
      RowBox[{
       SuperscriptBox[
        StyleBox["\[GothicCapitalT]",
         FontColor->RGBColor[0.54, 0.35, 0.15]], "-"], " ", 
       SuperscriptBox[
        StyleBox["\[GothicCapitalT]",
         FontColor->RGBColor[0.54, 0.35, 0.15]], "+"]}]], 
     FractionBox[
      SubscriptBox[
       StyleBox["\[GothicCapitalT]",
        FontColor->RGBColor[0.54, 0.35, 0.15]], 
       RowBox[{"1", ",", "0"}]], 
      RowBox[{"(", 
       RowBox[{
        SubsuperscriptBox[
         StyleBox["\[GothicQ]",
          FontColor->RGBColor[0.54, 0.35, 0.15]], 
         RowBox[{"1", ",", "2"}], "+"], " ", 
        SubsuperscriptBox[
         OverscriptBox[
          StyleBox["\[GothicQ]",
           FontColor->RGBColor[0.54, 0.35, 0.15]], 
          StyleBox["_",
           FontColor->RGBColor[0.54, 0.35, 0.15]]], 
         RowBox[{"1", ",", "2"}], "-"]}], ")"}]]}]}], ",", 
   RowBox[{
    FractionBox[
     SubscriptBox[
      StyleBox["Y",
       FontColor->RGBColor[0, 0, 0.8]], 
      RowBox[{"1", ",", "1"}]], 
     SubscriptBox[
      StyleBox["Y",
       FontColor->RGBColor[0, 0, 0.8]], 
      RowBox[{"2", ",", "2"}]]], "\[Equal]", 
    RowBox[{
     FractionBox[
      SubscriptBox[
       StyleBox["\[GothicCapitalT]",
        FontColor->RGBColor[0.54, 0.35, 0.15]], 
       RowBox[{"1", ",", "0"}]], 
      RowBox[{"(", 
       RowBox[{
        SubsuperscriptBox[
         StyleBox["\[GothicQ]",
          FontColor->RGBColor[0.54, 0.35, 0.15]], 
         RowBox[{"1", ",", "2"}], "+"], " ", 
        SubsuperscriptBox[
         OverscriptBox[
          StyleBox["\[GothicQ]",
           FontColor->RGBColor[0.54, 0.35, 0.15]], 
          StyleBox["_",
           FontColor->RGBColor[0.54, 0.35, 0.15]]], 
         RowBox[{"1", ",", "2"}], "-"]}], ")"}]], 
     FractionBox[
      SuperscriptBox[
       RowBox[{"(", 
        RowBox[{
         SubsuperscriptBox[
          StyleBox["\[ScriptCapitalT]",
           FontColor->RGBColor[1, 0, 0]], 
          RowBox[{"1", ",", "0"}], "c"], 
         SubscriptBox[
          StyleBox["\[ScriptCapitalT]",
           FontColor->RGBColor[1, 0, 0]], 
          RowBox[{"1", ",", "2"}]]}], ")"}], "2"], 
      SuperscriptBox[
       RowBox[{"(", 
        RowBox[{
         SubsuperscriptBox[
          StyleBox["\[GothicCapitalT]",
           FontColor->RGBColor[0.54, 0.35, 0.15]], 
          RowBox[{"0", ",", "1"}], "c"], " ", 
         SubscriptBox[
          StyleBox["\[GothicCapitalT]",
           FontColor->RGBColor[0.54, 0.35, 0.15]], 
          RowBox[{"2", ",", "1"}]]}], ")"}], "2"]], 
     FractionBox[
      RowBox[{" ", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          SubscriptBox[
           StyleBox["\[GothicQ]",
            FontColor->RGBColor[0.54, 0.35, 0.15]], "2"], "-", 
          SubsuperscriptBox[
           StyleBox["\[GothicQ]",
            FontColor->RGBColor[0.54, 0.35, 0.15]], "2", 
           RowBox[{"[", "2", "]"}]]}], ")"}], 
        RowBox[{"(", 
         RowBox[{
          SubscriptBox[
           OverscriptBox[
            StyleBox["\[GothicQ]",
             FontColor->RGBColor[0.54, 0.35, 0.15]], 
            StyleBox["_",
             FontColor->RGBColor[0.54, 0.35, 0.15]]], "2"], "-", 
          SubsuperscriptBox[
           OverscriptBox[
            StyleBox["\[GothicQ]",
             FontColor->RGBColor[0.54, 0.35, 0.15]], 
            StyleBox["_",
             FontColor->RGBColor[0.54, 0.35, 0.15]]], "2", 
           RowBox[{"[", 
            RowBox[{"-", "2"}], "]"}]]}], ")"}], 
        SuperscriptBox[
         StyleBox["\[GothicCapitalT]",
          FontColor->RGBColor[0.54, 0.35, 0.15]], "-"], " ", 
        SuperscriptBox[
         StyleBox["\[GothicCapitalT]",
          FontColor->RGBColor[0.54, 0.35, 0.15]], "+"]}]}], 
      RowBox[{
       SuperscriptBox[
        StyleBox["\[ScriptCapitalT]",
         FontColor->RGBColor[1, 0, 0]], "-"], " ", 
       SuperscriptBox[
        StyleBox["\[ScriptCapitalT]",
         FontColor->RGBColor[1, 0, 0]], "+"], " ", 
       SubsuperscriptBox[
        StyleBox["\[ScriptCapitalT]",
         FontColor->RGBColor[1, 0, 0]], "\[FivePointedStar]", "-"], " ", 
       SubsuperscriptBox[
        StyleBox["\[ScriptCapitalT]",
         FontColor->RGBColor[1, 0, 0]], "\[FivePointedStar]", "+"]}]]}]}]}], 
  "}"}]], "Input",
 CellChangeTimes->{{3.546687131980775*^9, 3.5466871474899406`*^9}, {
   3.546687242371037*^9, 3.546687243939645*^9}, {3.546929801258525*^9, 
   3.5469298061298847`*^9}, {3.546929853468628*^9, 3.546929929881419*^9}, 
   3.5537128859765472`*^9, 3.553712974849058*^9}],

Cell[TextData[{
 "Here ",
 Cell[BoxData[
  SubsuperscriptBox[
   StyleBox["\[ScriptCapitalT]",
    FontColor->RGBColor[1, 0, 0]], 
   RowBox[{"1", ",", "0"}], "c"]],
  CellChangeTimes->{{3.546687131980775*^9, 3.5466871474899406`*^9}, {
   3.546687242371037*^9, 3.546687243939645*^9}, {3.546929801258525*^9, 
   3.5469298061298847`*^9}, {3.546929853468628*^9, 3.546929929881419*^9}}],
 "=\[Rho], ",
 Cell[BoxData[
  FormBox[
   RowBox[{
    SubsuperscriptBox[
     StyleBox["\[GothicCapitalT]",
      FontColor->RGBColor[0.54, 0.35, 0.15]], 
     RowBox[{"0", ",", "1"}], "c"], "=", 
    SubscriptBox["\[Rho]", 
     RowBox[{"2", ",", 
      RowBox[{"FiNLIE", " ", "paper"}]}]]}], TraditionalForm]]],
 " (we altered definition of ",
 Cell[BoxData[
  FormBox[
   SubscriptBox["\[Rho]", "2"], TraditionalForm]]],
 " to always get square root cuts)."
}], "Text",
 CellChangeTimes->{{3.546929946945657*^9, 3.546929997126169*^9}, {
  3.5496895145238953`*^9, 3.549689523683353*^9}}],

Cell["\<\
We plug in this definitions to the integral equaitons for Y11Y22 and Y11/Y22, \
and divide by asymptotic expressions, to get the following equalities:\
\>", "Text",
 CellChangeTimes->{{3.546930001887417*^9, 3.5469300488843803`*^9}}],

Cell["Y11Y22 equation:", "Text",
 CellChangeTimes->{{3.546930139017488*^9, 3.546930142080735*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{
    RowBox[{"Log", "[", 
     FractionBox[
      FractionBox[
       RowBox[{
        SuperscriptBox[
         StyleBox["\[ScriptCapitalT]",
          FontColor->RGBColor[1, 0, 0]], "-"], " ", 
        SuperscriptBox[
         StyleBox["\[ScriptCapitalT]",
          FontColor->RGBColor[1, 0, 0]], "+"]}], 
       RowBox[{
        SubsuperscriptBox[
         StyleBox["\[ScriptCapitalT]",
          FontColor->RGBColor[1, 0, 0]], "\[FivePointedStar]", "-"], 
        SubsuperscriptBox[
         StyleBox["\[ScriptCapitalT]",
          FontColor->RGBColor[1, 0, 0]], "\[FivePointedStar]", "+"]}]], 
      SubscriptBox[
       RowBox[{"(", 
        FractionBox[
         RowBox[{
          SuperscriptBox[
           StyleBox["\[ScriptCapitalT]",
            FontColor->RGBColor[1, 0, 0]], "-"], " ", 
          SuperscriptBox[
           StyleBox["\[ScriptCapitalT]",
            FontColor->RGBColor[1, 0, 0]], "+"]}], 
         RowBox[{
          SubsuperscriptBox[
           StyleBox["\[ScriptCapitalT]",
            FontColor->RGBColor[1, 0, 0]], "\[FivePointedStar]", "-"], 
          SubsuperscriptBox[
           StyleBox["\[ScriptCapitalT]",
            FontColor->RGBColor[1, 0, 0]], "\[FivePointedStar]", "+"]}]], 
        ")"}], "asym"]], "]"}], "+", 
    RowBox[{"Log", "[", 
     FractionBox[
      FractionBox[
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          SubscriptBox[
           StyleBox["\[GothicQ]",
            FontColor->RGBColor[0.54, 0.35, 0.15]], "2"], "-", 
          SubsuperscriptBox[
           StyleBox["\[GothicQ]",
            FontColor->RGBColor[0.54, 0.35, 0.15]], "2", 
           RowBox[{"[", "2", "]"}]]}], ")"}], 
        RowBox[{"(", 
         RowBox[{
          SubscriptBox[
           OverscriptBox[
            StyleBox["\[GothicQ]",
             FontColor->RGBColor[0.54, 0.35, 0.15]], 
            StyleBox["_",
             FontColor->RGBColor[0.54, 0.35, 0.15]]], "2"], "-", 
          SubsuperscriptBox[
           OverscriptBox[
            StyleBox["\[GothicQ]",
             FontColor->RGBColor[0.54, 0.35, 0.15]], 
            StyleBox["_",
             FontColor->RGBColor[0.54, 0.35, 0.15]]], "2", 
           RowBox[{"[", 
            RowBox[{"-", "2"}], "]"}]]}], ")"}]}], 
       RowBox[{
        SuperscriptBox[
         StyleBox["\[GothicCapitalT]",
          FontColor->RGBColor[0.54, 0.35, 0.15]], "-"], " ", 
        SuperscriptBox[
         StyleBox["\[GothicCapitalT]",
          FontColor->RGBColor[0.54, 0.35, 0.15]], "+"]}]], 
      SubscriptBox[
       RowBox[{"(", 
        FractionBox[
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            SubscriptBox[
             StyleBox["\[GothicQ]",
              FontColor->RGBColor[0.54, 0.35, 0.15]], "2"], "-", 
            SubsuperscriptBox[
             StyleBox["\[GothicQ]",
              FontColor->RGBColor[0.54, 0.35, 0.15]], "2", 
             RowBox[{"[", "2", "]"}]]}], ")"}], 
          RowBox[{"(", 
           RowBox[{
            SubscriptBox[
             OverscriptBox[
              StyleBox["\[GothicQ]",
               FontColor->RGBColor[0.54, 0.35, 0.15]], 
              StyleBox["_",
               FontColor->RGBColor[0.54, 0.35, 0.15]]], "2"], "-", 
            SubsuperscriptBox[
             OverscriptBox[
              StyleBox["\[GothicQ]",
               FontColor->RGBColor[0.54, 0.35, 0.15]], 
              StyleBox["_",
               FontColor->RGBColor[0.54, 0.35, 0.15]]], "2", 
             RowBox[{"[", 
              RowBox[{"-", "2"}], "]"}]]}], ")"}]}], 
         RowBox[{
          SuperscriptBox[
           StyleBox["\[GothicCapitalT]",
            FontColor->RGBColor[0.54, 0.35, 0.15]], "-"], " ", 
          SuperscriptBox[
           StyleBox["\[GothicCapitalT]",
            FontColor->RGBColor[0.54, 0.35, 0.15]], "+"]}]], ")"}], "asym"]], 
     "]"}], "+", 
    RowBox[{"Log", "[", 
     FractionBox[
      SubscriptBox[
       StyleBox["\[GothicCapitalT]",
        FontColor->RGBColor[0.54, 0.35, 0.15]], 
       RowBox[{"1", ",", "0"}]], 
      RowBox[{"(", 
       RowBox[{
        SubsuperscriptBox[
         StyleBox["\[GothicQ]",
          FontColor->RGBColor[0.54, 0.35, 0.15]], 
         RowBox[{"1", ",", "2"}], "+"], " ", 
        SubsuperscriptBox[
         OverscriptBox[
          StyleBox["\[GothicQ]",
           FontColor->RGBColor[0.54, 0.35, 0.15]], 
          StyleBox["_",
           FontColor->RGBColor[0.54, 0.35, 0.15]]], 
         RowBox[{"1", ",", "2"}], "-"]}], ")"}]], "]"}]}], "==", 
   RowBox[{
    RowBox[{"-", "4"}], "\[ImaginaryI]", " ", "g", 
    SqrtBox[
     RowBox[{"1", "-", 
      SuperscriptBox["z", "2"]}]], 
    RowBox[{
     SubsuperscriptBox["\[Integral]", 
      RowBox[{
       RowBox[{"-", "\[Infinity]"}], "-", 
       RowBox[{"\[ImaginaryI]", " ", "0"}]}], 
      RowBox[{
       RowBox[{"+", "\[Infinity]"}], "-", 
       RowBox[{"\[ImaginaryI]", " ", "0"}]}]], 
     RowBox[{
      FractionBox["du", 
       RowBox[{
        RowBox[{"-", "2"}], "\[Pi]", " ", "\[ImaginaryI]"}]], 
      FractionBox["1", 
       RowBox[{
        RowBox[{"4", 
         SuperscriptBox["g", "2"], 
         SuperscriptBox["z", "2"]}], "-", 
        SuperscriptBox["u", "2"]}]], 
      FractionBox["H", 
       SqrtBox[
        RowBox[{"1", "-", 
         FractionBox[
          RowBox[{"4", 
           SuperscriptBox["g", "2"]}], 
          SuperscriptBox["u", "2"]]}]]]}]}]}]}], "}"}]], "Input",
 CellChangeTimes->{{3.546687667733313*^9, 3.546687694430181*^9}, {
  3.546930060725745*^9, 3.546930086044445*^9}, {3.546930226332904*^9, 
  3.546930243522461*^9}, {3.546931545956169*^9, 3.546931547536798*^9}, {
  3.553713007494966*^9, 3.553713008809545*^9}, {3.5537130408085737`*^9, 
  3.5537130471513863`*^9}, {3.555855342790471*^9, 3.555855347237547*^9}}],

Cell["Y11/Y22 equation:", "Text",
 CellChangeTimes->{{3.546931548677003*^9, 3.5469315599295673`*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{
    RowBox[{"Log", "[", 
     FractionBox[
      SubscriptBox[
       StyleBox["\[GothicCapitalT]",
        FontColor->RGBColor[0.54, 0.35, 0.15]], 
       RowBox[{"1", ",", "0"}]], 
      RowBox[{"(", 
       RowBox[{
        SubsuperscriptBox[
         StyleBox["\[GothicQ]",
          FontColor->RGBColor[0.54, 0.35, 0.15]], 
         RowBox[{"1", ",", "2"}], "+"], " ", 
        SubsuperscriptBox[
         OverscriptBox[
          StyleBox["\[GothicQ]",
           FontColor->RGBColor[0.54, 0.35, 0.15]], 
          StyleBox["_",
           FontColor->RGBColor[0.54, 0.35, 0.15]]], 
         RowBox[{"1", ",", "2"}], "-"]}], ")"}]], "]"}], "+", 
    RowBox[{"2", 
     RowBox[{"Log", "[", 
      RowBox[{
       FractionBox[
        SubsuperscriptBox[
         StyleBox["\[ScriptCapitalT]",
          FontColor->RGBColor[1, 0, 0]], 
         RowBox[{"1", ",", "0"}], "c"], 
        RowBox[{
         SubsuperscriptBox[
          StyleBox["\[GothicCapitalT]",
           FontColor->RGBColor[0.54, 0.35, 0.15]], 
          RowBox[{"0", ",", "1"}], "c"], " "}]], 
       FractionBox[
        SubscriptBox["\[Rho]", 
         RowBox[{"2", ",", "asym"}]], 
        SubscriptBox["\[Rho]", "asym"]]}], "]"}]}], "+", 
    RowBox[{"Log", "[", 
     FractionBox[
      RowBox[{" ", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          SubscriptBox[
           StyleBox["\[GothicQ]",
            FontColor->RGBColor[0.54, 0.35, 0.15]], "2"], "-", 
          SubsuperscriptBox[
           StyleBox["\[GothicQ]",
            FontColor->RGBColor[0.54, 0.35, 0.15]], "2", 
           RowBox[{"[", "2", "]"}]]}], ")"}], 
        RowBox[{"(", 
         RowBox[{
          SubscriptBox[
           OverscriptBox[
            StyleBox["\[GothicQ]",
             FontColor->RGBColor[0.54, 0.35, 0.15]], 
            StyleBox["_",
             FontColor->RGBColor[0.54, 0.35, 0.15]]], "2"], "-", 
          SubsuperscriptBox[
           OverscriptBox[
            StyleBox["\[GothicQ]",
             FontColor->RGBColor[0.54, 0.35, 0.15]], 
            StyleBox["_",
             FontColor->RGBColor[0.54, 0.35, 0.15]]], "2", 
           RowBox[{"[", 
            RowBox[{"-", "2"}], "]"}]]}], ")"}], 
        SuperscriptBox[
         StyleBox["\[GothicCapitalT]",
          FontColor->RGBColor[0.54, 0.35, 0.15]], "-"], " ", 
        SuperscriptBox[
         StyleBox["\[GothicCapitalT]",
          FontColor->RGBColor[0.54, 0.35, 0.15]], "+"]}]}], 
      RowBox[{
       SubscriptBox[
        RowBox[{"(", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            SubscriptBox[
             StyleBox["\[GothicQ]",
              FontColor->RGBColor[0.54, 0.35, 0.15]], "2"], "-", 
            SubsuperscriptBox[
             StyleBox["\[GothicQ]",
              FontColor->RGBColor[0.54, 0.35, 0.15]], "2", 
             RowBox[{"[", "2", "]"}]]}], ")"}], 
          RowBox[{"(", 
           RowBox[{
            SubscriptBox[
             OverscriptBox[
              StyleBox["\[GothicQ]",
               FontColor->RGBColor[0.54, 0.35, 0.15]], 
              StyleBox["_",
               FontColor->RGBColor[0.54, 0.35, 0.15]]], "2"], "-", 
            SubsuperscriptBox[
             OverscriptBox[
              StyleBox["\[GothicQ]",
               FontColor->RGBColor[0.54, 0.35, 0.15]], 
              StyleBox["_",
               FontColor->RGBColor[0.54, 0.35, 0.15]]], "2", 
             RowBox[{"[", 
              RowBox[{"-", "2"}], "]"}]]}], ")"}], 
          SuperscriptBox[
           StyleBox["\[GothicCapitalT]",
            FontColor->RGBColor[0.54, 0.35, 0.15]], "-"], " ", 
          SuperscriptBox[
           StyleBox["\[GothicCapitalT]",
            FontColor->RGBColor[0.54, 0.35, 0.15]], "+"]}], ")"}], "asym"], 
       " "}]], "]"}], "+", 
    RowBox[{"Log", "[", 
     FractionBox[
      SubscriptBox[
       RowBox[{"(", 
        RowBox[{
         SuperscriptBox[
          StyleBox["\[ScriptCapitalT]",
           FontColor->RGBColor[1, 0, 0]], "-"], " ", 
         SuperscriptBox[
          StyleBox["\[ScriptCapitalT]",
           FontColor->RGBColor[1, 0, 0]], "+"], " ", 
         SubsuperscriptBox[
          StyleBox["\[ScriptCapitalT]",
           FontColor->RGBColor[1, 0, 0]], "\[FivePointedStar]", "-"], " ", 
         SubsuperscriptBox[
          StyleBox["\[ScriptCapitalT]",
           FontColor->RGBColor[1, 0, 0]], "\[FivePointedStar]", "+"]}], ")"}],
        "asym"], 
      RowBox[{
       SuperscriptBox[
        StyleBox["\[ScriptCapitalT]",
         FontColor->RGBColor[1, 0, 0]], "-"], " ", 
       SuperscriptBox[
        StyleBox["\[ScriptCapitalT]",
         FontColor->RGBColor[1, 0, 0]], "+"], " ", 
       SubsuperscriptBox[
        StyleBox["\[ScriptCapitalT]",
         FontColor->RGBColor[1, 0, 0]], "\[FivePointedStar]", "-"], " ", 
       SubsuperscriptBox[
        StyleBox["\[ScriptCapitalT]",
         FontColor->RGBColor[1, 0, 0]], "\[FivePointedStar]", "+"]}]], 
     "]"}]}], "==", 
   RowBox[{
    RowBox[{
     SubsuperscriptBox["\[Integral]", 
      RowBox[{
       RowBox[{"-", "\[Infinity]"}], "-", 
       RowBox[{"\[ImaginaryI]", " ", "0"}]}], 
      RowBox[{
       RowBox[{"+", "\[Infinity]"}], "-", 
       RowBox[{"\[ImaginaryI]", " ", "0"}]}]], 
     RowBox[{
      FractionBox["du", 
       RowBox[{
        RowBox[{"-", "2"}], "\[Pi]", " ", "\[ImaginaryI]"}]], 
      RowBox[{"(", 
       FractionBox[
        RowBox[{"2", "u"}], 
        RowBox[{
         RowBox[{"4", 
          SuperscriptBox["g", "2"], 
          SuperscriptBox["z", "2"]}], "-", 
         SuperscriptBox["u", "2"]}]], ")"}], "H"}]}], "+", 
    RowBox[{
     SubsuperscriptBox["\[Integral]", 
      RowBox[{
       RowBox[{"-", "\[Infinity]"}], "-", 
       RowBox[{"\[ImaginaryI]", " ", "0"}]}], 
      RowBox[{
       RowBox[{"+", "\[Infinity]"}], "-", 
       RowBox[{"\[ImaginaryI]", " ", "0"}]}]], 
     RowBox[{
      FractionBox["du", 
       RowBox[{
        RowBox[{"-", "2"}], "\[Pi]", " ", "\[ImaginaryI]"}]], 
      RowBox[{"(", 
       FractionBox[
        RowBox[{"2", "u"}], 
        RowBox[{
         RowBox[{"4", 
          SuperscriptBox["g", "2"], 
          SuperscriptBox["z", "2"]}], "-", 
         SuperscriptBox["u", "2"]}]], ")"}], 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "2"}], 
        RowBox[{"Log", "[", 
         RowBox[{
          RowBox[{"(", 
           FractionBox[
            RowBox[{" ", 
             SuperscriptBox[
              StyleBox["\[ScriptCapitalT]",
               FontColor->RGBColor[1, 0, 0]], "+"], " "}], 
            SuperscriptBox[
             StyleBox["\[GothicCapitalT]",
              FontColor->RGBColor[0.54, 0.35, 0.15]], "+"]], ")"}], "/", 
          SubscriptBox[
           RowBox[{"(", 
            FractionBox[
             RowBox[{" ", 
              SuperscriptBox[
               StyleBox["\[ScriptCapitalT]",
                FontColor->RGBColor[1, 0, 0]], "+"], " "}], 
             SuperscriptBox[
              StyleBox["\[GothicCapitalT]",
               FontColor->RGBColor[0.54, 0.35, 0.15]], "+"]], ")"}], 
           "asym"]}], "]"}]}], ")"}]}]}]}]}], "}"}]], "Input",
 CellChangeTimes->{{3.546931310662352*^9, 3.5469313989313602`*^9}, {
  3.546931442809442*^9, 3.5469315410399837`*^9}, {3.553713091967557*^9, 
  3.553713161571763*^9}, {3.555855326912468*^9, 3.555855337580681*^9}}],

Cell["\<\
By asymptotic we mean large volume expressions, but with exact positions of \
the Bethe roots.\
\>", "Text",
 CellChangeTimes->{{3.5469374690116253`*^9, 3.5469374708179493`*^9}, {
  3.568964475617971*^9, 3.568964476031885*^9}}],

Cell[TextData[{
 "Note that Y11Y22 equation has ",
 Cell[BoxData[
  FormBox[
   SuperscriptBox["g", "9"], TraditionalForm]]],
 " at the r.h.s., whereas Y11/Y22 has ",
 Cell[BoxData[
  FormBox[
   SuperscriptBox["g", "8"], TraditionalForm]]],
 " at the r.h.s. This determines the leading orders at which equations are \
nontrivial.\nIt consistently follows from these equations that \[Rho] and ",
 Cell[BoxData[
  FormBox[
   SubscriptBox["\[Rho]", "2"], TraditionalForm]]],
 " are corrected at their fifth nontrivial order. Since \[Rho]~g, ",
 Cell[BoxData[
  FormBox[
   RowBox[{"\[Delta]\[Rho]", "~", 
    SuperscriptBox["g", "9"]}], TraditionalForm]]],
 ". Since ",
 Cell[BoxData[
  FormBox[
   RowBox[{
    SubscriptBox["\[Rho]", "2"], "~", 
    FractionBox["1", "g"]}], TraditionalForm]]],
 ", ",
 Cell[BoxData[
  FormBox[
   RowBox[{
    SubscriptBox["\[Delta]\[Rho]", "2"], "~", 
    SuperscriptBox["g", "7"]}], TraditionalForm]]],
 "."
}], "Text",
 CellChangeTimes->{{3.553713757782626*^9, 3.5537138014115877`*^9}, {
  3.553713845711213*^9, 3.553713937704694*^9}, {3.553714717714614*^9, 
  3.553714782309469*^9}, {3.568964480798012*^9, 3.5689645252777987`*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[Cell[BoxData[
 RowBox[{
  RowBox[{"Log", "[", 
   FractionBox[
    FractionBox[
     RowBox[{
      SuperscriptBox[
       StyleBox["\[ScriptCapitalT]",
        FontColor->RGBColor[1, 0, 0]], "-"], " ", 
      SuperscriptBox[
       StyleBox["\[ScriptCapitalT]",
        FontColor->RGBColor[1, 0, 0]], "+"]}], 
     RowBox[{
      SubsuperscriptBox[
       StyleBox["\[ScriptCapitalT]",
        FontColor->RGBColor[1, 0, 0]], "\[FivePointedStar]", "-"], 
      SubsuperscriptBox[
       StyleBox["\[ScriptCapitalT]",
        FontColor->RGBColor[1, 0, 0]], "\[FivePointedStar]", "+"]}]], 
    SubscriptBox[
     RowBox[{"(", 
      FractionBox[
       RowBox[{
        SuperscriptBox[
         StyleBox["\[ScriptCapitalT]",
          FontColor->RGBColor[1, 0, 0]], "-"], " ", 
        SuperscriptBox[
         StyleBox["\[ScriptCapitalT]",
          FontColor->RGBColor[1, 0, 0]], "+"]}], 
       RowBox[{
        SubsuperscriptBox[
         StyleBox["\[ScriptCapitalT]",
          FontColor->RGBColor[1, 0, 0]], "\[FivePointedStar]", "-"], 
        SubsuperscriptBox[
         StyleBox["\[ScriptCapitalT]",
          FontColor->RGBColor[1, 0, 0]], "\[FivePointedStar]", "+"]}]], ")"}],
      "asym"]], "]"}], "\[Equal]", "ratioTright"}]],
 CellChangeTimes->{{3.546687667733313*^9, 3.546687694430181*^9}, {
  3.546930060725745*^9, 3.546930086044445*^9}, {3.546930226332904*^9, 
  3.546930243522461*^9}, {3.546931545956169*^9, 
  3.546931547536798*^9}}]], "Subsection",
 CellChangeTimes->{
  3.546937572863883*^9, {3.5469381704542503`*^9, 3.546938184193096*^9}, {
   3.546939399028844*^9, 3.546939401121449*^9}, {3.553713948809174*^9, 
   3.553713948809338*^9}, {3.5537143203026648`*^9, 3.553714323049741*^9}, {
   3.5557966614846478`*^9, 3.55579666148482*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{
      SuperscriptBox[
       StyleBox["\[ScriptCapitalC]", "Dafault"], 
       RowBox[{"[", "o", "]"}]], "\[Rule]", " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         FractionBox["1", "2"], "\[Delta]\[Rho]"}], "+", 
        RowBox[{"PV", "[", "\[Delta]\[Rho]", "]"}]}], ")"}]}], ",", 
     RowBox[{
      SuperscriptBox[
       StyleBox["\[ScriptCapitalC]", "Dafault"], 
       RowBox[{"[", 
        RowBox[{"-", "o"}], "]"}]], "\[Rule]", " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         RowBox[{"-", 
          FractionBox["1", "2"]}], "\[Delta]\[Rho]"}], "+", 
        RowBox[{"PV", "[", "\[Delta]\[Rho]", "]"}]}], ")"}]}], ",", 
     RowBox[{
      SuperscriptBox["\[ScriptCapitalC]", 
       RowBox[{"[", 
        RowBox[{"+", "2"}], "]"}]], "\[Rule]", " ", 
      RowBox[{"Normal", "@", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          RowBox[{"Expand", "/@", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"Series", "[", 
              RowBox[{
               RowBox[{
                RowBox[{"-", 
                 FractionBox[
                  RowBox[{"2", "g"}], 
                  RowBox[{"2", " ", "\[ImaginaryI]"}]]}], 
                FractionBox["w", 
                 RowBox[{
                  RowBox[{"2", "g", " ", "z"}], "+", "\[ImaginaryI]"}]]}], 
               ",", 
               RowBox[{"{", 
                RowBox[{"g", ",", "0", ",", "14"}], "}"}]}], "]"}], "/.", 
             RowBox[{"z", "\[Rule]", 
              RowBox[{"(", 
               RowBox[{"z", "-", "w"}], ")"}]}]}], ")"}]}], "/.", 
          RowBox[{
           SuperscriptBox["w", "a_."], "\[RuleDelayed]", 
           RowBox[{"If", "[", 
            RowBox[{
             RowBox[{"EvenQ", "[", "a", "]"}], ",", "0", ",", 
             SuperscriptBox["w", "a"]}], "]"}]}]}], "/.", 
         RowBox[{
          SuperscriptBox["w", "a_."], "\[RuleDelayed]", 
          RowBox[{"M", "[", 
           RowBox[{
            SuperscriptBox["w", 
             RowBox[{"a", "-", "1"}]], "\[Delta]\[Rho]"}], "]"}]}]}], 
        ")"}]}]}], ",", 
     RowBox[{
      SuperscriptBox["\[ScriptCapitalC]", 
       RowBox[{"[", 
        RowBox[{"-", "2"}], "]"}]], "\[Rule]", " ", 
      RowBox[{"Normal", "@", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          RowBox[{"Expand", "/@", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"Series", "[", 
              RowBox[{
               RowBox[{
                RowBox[{"-", 
                 FractionBox[
                  RowBox[{"2", "g"}], 
                  RowBox[{"2", " ", "\[ImaginaryI]"}]]}], 
                FractionBox["w", 
                 RowBox[{
                  RowBox[{"2", "g", " ", "z"}], "-", "\[ImaginaryI]"}]]}], 
               ",", 
               RowBox[{"{", 
                RowBox[{"g", ",", "0", ",", "14"}], "}"}]}], "]"}], "/.", 
             RowBox[{"z", "\[Rule]", 
              RowBox[{"(", 
               RowBox[{"z", "-", "w"}], ")"}]}]}], ")"}]}], "/.", 
          RowBox[{
           SuperscriptBox["w", "a_."], "\[RuleDelayed]", 
           RowBox[{"If", "[", 
            RowBox[{
             RowBox[{"EvenQ", "[", "a", "]"}], ",", "0", ",", 
             SuperscriptBox["w", "a"]}], "]"}]}]}], "/.", 
         RowBox[{
          SuperscriptBox["w", "a_."], "\[RuleDelayed]", 
          RowBox[{"M", "[", 
           RowBox[{
            SuperscriptBox["w", 
             RowBox[{"a", "-", "1"}]], "\[Delta]\[Rho]"}], "]"}]}]}], 
        ")"}]}]}]}], "}"}], "/.", 
   RowBox[{"\[Delta]\[Rho]", "\[Rule]", 
    RowBox[{"Expand", "[", 
     RowBox[{
      SuperscriptBox["g", "9"], 
      RowBox[{"(", 
       RowBox[{
        SubscriptBox["\[Delta]\[Rho]", "lead"], "+", 
        RowBox[{
         SuperscriptBox["g", "2"], 
         SubscriptBox["\[Delta]\[Rho]", "sublead"]}], "+", 
        RowBox[{
         SuperscriptBox["g", "4"], 
         SubscriptBox["\[Delta]\[Rho]", "sublead2"]}]}], ")"}]}], "]"}]}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{"%", "/.", 
        RowBox[{
         RowBox[{"PV", "[", "a_", "]"}], "\[RuleDelayed]", 
         RowBox[{"PV", "[", 
          RowBox[{"Expand", "[", "a", "]"}], "]"}]}]}], "//.", 
       RowBox[{
        RowBox[{"PV", "[", 
         RowBox[{
          RowBox[{
           SuperscriptBox["g", "a_."], "b_."}], "+", "c_"}], "]"}], 
        "\[RuleDelayed]", 
        RowBox[{
         RowBox[{
          SuperscriptBox["g", "a"], 
          RowBox[{"PV", "[", "b", "]"}]}], "+", 
         RowBox[{"PV", "[", "c", "]"}]}]}]}], "/.", 
      RowBox[{
       RowBox[{"PV", "[", 
        RowBox[{
         SuperscriptBox["g", "a_."], "b_."}], "]"}], "\[RuleDelayed]", 
       RowBox[{
        SuperscriptBox["g", "a"], 
        RowBox[{"PV", "[", "b", "]"}]}]}]}], "/.", 
     RowBox[{
      RowBox[{"M", "[", "a_", "]"}], "\[RuleDelayed]", 
      RowBox[{"M", "[", 
       RowBox[{"Expand", "[", "a", "]"}], "]"}]}]}], "//.", 
    RowBox[{
     RowBox[{"M", "[", 
      RowBox[{
       RowBox[{
        SuperscriptBox["g", "a_."], "b_."}], "+", "c_"}], "]"}], 
     "\[RuleDelayed]", 
     RowBox[{
      RowBox[{
       SuperscriptBox["g", "a"], 
       RowBox[{"M", "[", "b", "]"}]}], "+", 
      RowBox[{"M", "[", "c", "]"}]}]}]}], "/.", 
   RowBox[{
    RowBox[{"M", "[", 
     RowBox[{
      SuperscriptBox["g", "a_."], "b_."}], "]"}], "\[RuleDelayed]", 
    RowBox[{
     SuperscriptBox["g", "a"], 
     RowBox[{"M", "[", "b", "]"}]}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"tmpsubs", "=", 
   RowBox[{"%", "/.", 
    RowBox[{
     RowBox[{"Rule", "[", 
      RowBox[{"a_", ",", "b_"}], "]"}], "\[RuleDelayed]", 
     RowBox[{"Rule", "[", 
      RowBox[{"a", ",", 
       RowBox[{"Normal", "@", 
        RowBox[{"Series", "[", 
         RowBox[{"b", ",", 
          RowBox[{"{", 
           RowBox[{"g", ",", "0", ",", "21"}], "}"}]}], "]"}]}]}], 
      "]"}]}]}]}], ";"}]}], "Input",
 CellChangeTimes->{{3.5557926931303463`*^9, 3.555792731138949*^9}, {
  3.555793093764945*^9, 3.555793135131957*^9}, {3.555793486990962*^9, 
  3.5557935493591757`*^9}, {3.555793593986315*^9, 3.555793701494273*^9}, {
  3.555793743616707*^9, 3.555793794397271*^9}, {3.5557938466776657`*^9, 
  3.555793864501933*^9}, {3.555793900844964*^9, 3.5557939344919853`*^9}, {
  3.555793995318914*^9, 3.555794001438005*^9}, {3.555794054940826*^9, 
  3.555794103980994*^9}, {3.555794180073298*^9, 3.555794183201223*^9}, {
  3.5557943495763617`*^9, 3.555794354961646*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Log", "[", 
   FractionBox[
    StyleBox["\[ScriptCapitalT]",
     FontColor->RGBColor[1, 0, 0]], 
    SubscriptBox[
     StyleBox["\[ScriptCapitalT]",
      FontColor->RGBColor[1, 0, 0]], "asym"]], "]"}], "==", 
  FractionBox[
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      SuperscriptBox[
       StyleBox["\[ScriptCapitalC]", "Dafault"], "+"], "-", 
      SuperscriptBox["\[ScriptCapitalC]", "-"]}], ")"}], 
    OverscriptBox["*", "^"], "\[Delta]\[Rho]"}], 
   SubscriptBox[
    StyleBox["\[ScriptCapitalT]",
     FontColor->RGBColor[1, 0, 0]], "asym"]]}]], "Input",
 CellChangeTimes->{{3.555792380653092*^9, 3.555792391934897*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Log", "[", 
   FractionBox[
    FractionBox[
     RowBox[{
      SuperscriptBox[
       StyleBox["\[ScriptCapitalT]",
        FontColor->RGBColor[1, 0, 0]], "-"], " ", 
      SuperscriptBox[
       StyleBox["\[ScriptCapitalT]",
        FontColor->RGBColor[1, 0, 0]], "+"]}], 
     RowBox[{
      SubsuperscriptBox[
       StyleBox["\[ScriptCapitalT]",
        FontColor->RGBColor[1, 0, 0]], "\[FivePointedStar]", "-"], 
      SubsuperscriptBox[
       StyleBox["\[ScriptCapitalT]",
        FontColor->RGBColor[1, 0, 0]], "\[FivePointedStar]", "+"]}]], 
    SubscriptBox[
     RowBox[{"(", 
      FractionBox[
       RowBox[{
        SuperscriptBox[
         StyleBox["\[ScriptCapitalT]",
          FontColor->RGBColor[1, 0, 0]], "-"], " ", 
        SuperscriptBox[
         StyleBox["\[ScriptCapitalT]",
          FontColor->RGBColor[1, 0, 0]], "+"]}], 
       RowBox[{
        SubsuperscriptBox[
         StyleBox["\[ScriptCapitalT]",
          FontColor->RGBColor[1, 0, 0]], "\[FivePointedStar]", "-"], 
        SubsuperscriptBox[
         StyleBox["\[ScriptCapitalT]",
          FontColor->RGBColor[1, 0, 0]], "\[FivePointedStar]", "+"]}]], ")"}],
      "asym"]], "]"}], "==", 
  RowBox[{
   FractionBox[
    RowBox[{"(", 
     RowBox[{
      SuperscriptBox[
       StyleBox["\[ScriptCapitalC]", "Dafault"], 
       RowBox[{"[", 
        RowBox[{"+", "2"}], "]"}]], "-", 
      SuperscriptBox["\[ScriptCapitalC]", 
       RowBox[{"[", 
        RowBox[{"-", "o"}], "]"}]]}], ")"}], 
    RowBox[{
     SuperscriptBox[
      StyleBox["\[ScriptCapitalT]",
       FontColor->RGBColor[1, 0, 0]], "+"], "/.", "largevolume"}]], "+", 
   FractionBox[
    RowBox[{"(", 
     RowBox[{
      SuperscriptBox[
       StyleBox["\[ScriptCapitalC]", "Dafault"], 
       RowBox[{"[", 
        RowBox[{"+", "o"}], "]"}]], "-", 
      SuperscriptBox["\[ScriptCapitalC]", 
       RowBox[{"[", 
        RowBox[{"-", "2"}], "]"}]]}], ")"}], 
    RowBox[{
     SuperscriptBox[
      StyleBox["\[ScriptCapitalT]",
       FontColor->RGBColor[1, 0, 0]], "-"], "/.", "largevolume"}]], "-", 
   FractionBox[
    RowBox[{"(", 
     RowBox[{
      SuperscriptBox[
       StyleBox["\[ScriptCapitalC]", "Dafault"], 
       RowBox[{"[", 
        RowBox[{"+", "2"}], "]"}]], "-", 
      SuperscriptBox["\[ScriptCapitalC]", 
       RowBox[{"[", 
        RowBox[{"+", "o"}], "]"}]]}], ")"}], 
    RowBox[{
     RowBox[{
      SuperscriptBox[
       StyleBox["\[ScriptCapitalT]",
        FontColor->RGBColor[1, 0, 0]], "+"], "/.", "largevolume"}], "/.", 
     RowBox[{"x", "\[Rule]", 
      FractionBox["1", "x"]}]}]], "-", 
   FractionBox[
    RowBox[{"(", 
     RowBox[{
      SuperscriptBox[
       StyleBox["\[ScriptCapitalC]", "Dafault"], 
       RowBox[{"[", 
        RowBox[{"-", "o"}], "]"}]], "-", 
      SuperscriptBox["\[ScriptCapitalC]", 
       RowBox[{"[", 
        RowBox[{"-", "2"}], "]"}]]}], ")"}], 
    RowBox[{
     RowBox[{
      SuperscriptBox[
       StyleBox["\[ScriptCapitalT]",
        FontColor->RGBColor[1, 0, 0]], "-"], "/.", "largevolume"}], "/.", 
     RowBox[{"x", "\[Rule]", 
      FractionBox["1", "x"]}]}]]}]}]], "Input",
 CellChangeTimes->{{3.5557923593885603`*^9, 3.5557923852974243`*^9}, {
  3.555793154050644*^9, 3.555793247831085*^9}, {3.555793339732451*^9, 
  3.555793365775256*^9}},
 EmphasizeSyntaxErrors->True],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"Series", "[", 
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{
         FractionBox[
          RowBox[{"(", 
           RowBox[{
            SuperscriptBox[
             StyleBox["\[ScriptCapitalC]", "Dafault"], 
             RowBox[{"[", 
              RowBox[{"+", "2"}], "]"}]], "-", 
            SuperscriptBox["\[ScriptCapitalC]", 
             RowBox[{"[", 
              RowBox[{"-", "o"}], "]"}]]}], ")"}], 
          RowBox[{
           SuperscriptBox[
            StyleBox["\[ScriptCapitalT]",
             FontColor->RGBColor[1, 0, 0]], "+"], "/.", "largevolume"}]], "+", 
         FractionBox[
          RowBox[{"(", 
           RowBox[{
            SuperscriptBox[
             StyleBox["\[ScriptCapitalC]", "Dafault"], 
             RowBox[{"[", 
              RowBox[{"+", "o"}], "]"}]], "-", 
            SuperscriptBox["\[ScriptCapitalC]", 
             RowBox[{"[", 
              RowBox[{"-", "2"}], "]"}]]}], ")"}], 
          RowBox[{
           SuperscriptBox[
            StyleBox["\[ScriptCapitalT]",
             FontColor->RGBColor[1, 0, 0]], "-"], "/.", "largevolume"}]], "-", 
         FractionBox[
          RowBox[{"(", 
           RowBox[{
            SuperscriptBox[
             StyleBox["\[ScriptCapitalC]", "Dafault"], 
             RowBox[{"[", 
              RowBox[{"+", "2"}], "]"}]], "-", 
            SuperscriptBox["\[ScriptCapitalC]", 
             RowBox[{"[", 
              RowBox[{"+", "o"}], "]"}]]}], ")"}], 
          RowBox[{
           RowBox[{
            SuperscriptBox[
             StyleBox["\[ScriptCapitalT]",
              FontColor->RGBColor[1, 0, 0]], "+"], "/.", "largevolume"}], "/.", 
           RowBox[{"x", "\[Rule]", 
            FractionBox["1", "x"]}]}]], "-", 
         FractionBox[
          RowBox[{"(", 
           RowBox[{
            SuperscriptBox[
             StyleBox["\[ScriptCapitalC]", "Dafault"], 
             RowBox[{"[", 
              RowBox[{"-", "o"}], "]"}]], "-", 
            SuperscriptBox["\[ScriptCapitalC]", 
             RowBox[{"[", 
              RowBox[{"-", "2"}], "]"}]]}], ")"}], 
          RowBox[{
           RowBox[{
            SuperscriptBox[
             StyleBox["\[ScriptCapitalT]",
              FontColor->RGBColor[1, 0, 0]], "-"], "/.", "largevolume"}], "/.", 
           RowBox[{"x", "\[Rule]", 
            FractionBox["1", "x"]}]}]]}], "/.", "subJuk"}], "/.", 
       RowBox[{"u", "\[Rule]", 
        RowBox[{"2", "g", " ", "z"}]}]}], "/.", 
      RowBox[{"leadweak", "[", "4", "]"}]}], ",", 
     RowBox[{"{", 
      RowBox[{"g", ",", "0", ",", "8"}], "}"}]}], "]"}], "//", "Simplify"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"%", "/.", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         RowBox[{"-", "\[ImaginaryI]"}], " ", "z"}], "+", 
        SqrtBox[
         RowBox[{"1", "-", 
          SuperscriptBox["z", "2"]}]]}], ")"}], "\[Rule]", 
      FractionBox["1", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          RowBox[{"+", "\[ImaginaryI]"}], " ", "z"}], "+", 
         SqrtBox[
          RowBox[{"1", "-", 
           SuperscriptBox["z", "2"]}]]}], ")"}]]}]}], "//", "Simplify"}], "//",
    "Normal"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"ratioTright", "=", 
  RowBox[{
   RowBox[{
    RowBox[{"Collect", "[", 
     RowBox[{"#", ",", 
      SqrtBox[
       RowBox[{"1", "-", 
        SuperscriptBox["z", "2"]}]]}], "]"}], "&"}], "/@", 
   RowBox[{"Series", "[", 
    RowBox[{
     RowBox[{"%", "/.", "tmpsubs"}], ",", 
     RowBox[{"{", 
      RowBox[{"g", ",", "0", ",", "14"}], "}"}]}], "]"}]}]}]}], "Input",
 CellChangeTimes->{{3.555793382372897*^9, 3.555793424351448*^9}, {
   3.555793457462407*^9, 3.555793469337389*^9}, {3.5557940170303707`*^9, 
   3.555794045516943*^9}, {3.5557941132338533`*^9, 3.5557941133217087`*^9}, {
   3.555794149944571*^9, 3.5557942095686007`*^9}, 3.555794364601985*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
   RowBox[{"2", " ", 
    SubscriptBox["\[Delta]\[Rho]", "lead"], " ", 
    SuperscriptBox["g", "9"]}], "+", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       SqrtBox[
        RowBox[{"1", "-", 
         SuperscriptBox["z", "2"]}]], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          RowBox[{"-", "4"}], " ", 
          RowBox[{"M", "[", 
           SubscriptBox["\[Delta]\[Rho]", "lead"], "]"}]}], "+", 
         RowBox[{"8", " ", "\[ImaginaryI]", " ", "z", " ", 
          RowBox[{"PV", "[", 
           SubscriptBox["\[Delta]\[Rho]", "lead"], "]"}]}]}], ")"}]}], "-", 
      RowBox[{"4", " ", 
       SuperscriptBox["z", "2"], " ", 
       SubscriptBox["\[Delta]\[Rho]", "lead"]}], "+", 
      RowBox[{"2", " ", 
       SubscriptBox["\[Delta]\[Rho]", "sublead"]}]}], ")"}], " ", 
    SuperscriptBox["g", "11"]}], "+", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       SqrtBox[
        RowBox[{"1", "-", 
         SuperscriptBox["z", "2"]}]], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"16", " ", 
          RowBox[{"M", "[", 
           SubscriptBox["\[Delta]\[Rho]", "lead"], "]"}]}], "+", 
         RowBox[{"48", " ", 
          SuperscriptBox["z", "2"], " ", 
          RowBox[{"M", "[", 
           SubscriptBox["\[Delta]\[Rho]", "lead"], "]"}]}], "+", 
         RowBox[{"16", " ", 
          RowBox[{"M", "[", 
           RowBox[{
            SuperscriptBox["w", "2"], " ", 
            SubscriptBox["\[Delta]\[Rho]", "lead"]}], "]"}]}], "-", 
         RowBox[{"4", " ", 
          RowBox[{"M", "[", 
           SubscriptBox["\[Delta]\[Rho]", "sublead"], "]"}]}], "-", 
         RowBox[{"72", " ", "\[ImaginaryI]", " ", "z", " ", 
          RowBox[{"PV", "[", 
           SubscriptBox["\[Delta]\[Rho]", "lead"], "]"}]}], "-", 
         RowBox[{"32", " ", "\[ImaginaryI]", " ", 
          SuperscriptBox["z", "3"], " ", 
          RowBox[{"PV", "[", 
           SubscriptBox["\[Delta]\[Rho]", "lead"], "]"}]}], "+", 
         RowBox[{"8", " ", "\[ImaginaryI]", " ", "z", " ", 
          RowBox[{"PV", "[", 
           SubscriptBox["\[Delta]\[Rho]", "sublead"], "]"}]}]}], ")"}]}], "-", 
      RowBox[{"6", " ", 
       SubscriptBox["\[Delta]\[Rho]", "lead"]}], "+", 
      RowBox[{"36", " ", 
       SuperscriptBox["z", "2"], " ", 
       SubscriptBox["\[Delta]\[Rho]", "lead"]}], "+", 
      RowBox[{"16", " ", 
       SuperscriptBox["z", "4"], " ", 
       SubscriptBox["\[Delta]\[Rho]", "lead"]}], "-", 
      RowBox[{"4", " ", 
       SuperscriptBox["z", "2"], " ", 
       SubscriptBox["\[Delta]\[Rho]", "sublead"]}], "+", 
      RowBox[{"2", " ", 
       SubscriptBox["\[Delta]\[Rho]", "sublead2"]}]}], ")"}], " ", 
    SuperscriptBox["g", "13"]}], "+", 
   InterpretationBox[
    SuperscriptBox[
     RowBox[{"O", "[", "g", "]"}], "15"],
    SeriesData[$CellContext`g, 0, {}, 9, 15, 1],
    Editable->False]}],
  SeriesData[$CellContext`g, 0, {
   2 Subscript[$CellContext`\[Delta]\[Rho], $CellContext`lead], 
    0, (1 - $CellContext`z^2)^Rational[1, 2] ((-4) $CellContext`M[
         Subscript[$CellContext`\[Delta]\[Rho], $CellContext`lead]] + 
      Complex[0, 8] $CellContext`z $CellContext`PV[
         Subscript[$CellContext`\[Delta]\[Rho], $CellContext`lead]]) - 
    4 $CellContext`z^2 
    Subscript[$CellContext`\[Delta]\[Rho], $CellContext`lead] + 
    2 Subscript[$CellContext`\[Delta]\[Rho], $CellContext`sublead], 
    0, (1 - $CellContext`z^2)^Rational[1, 2] (16 $CellContext`M[
         Subscript[$CellContext`\[Delta]\[Rho], $CellContext`lead]] + 
      48 $CellContext`z^2 $CellContext`M[
         Subscript[$CellContext`\[Delta]\[Rho], $CellContext`lead]] + 
      16 $CellContext`M[$CellContext`w^2 
         Subscript[$CellContext`\[Delta]\[Rho], $CellContext`lead]] - 
      4 $CellContext`M[
        Subscript[$CellContext`\[Delta]\[Rho], $CellContext`sublead]] + 
      Complex[0, -72] $CellContext`z $CellContext`PV[
         Subscript[$CellContext`\[Delta]\[Rho], $CellContext`lead]] + 
      Complex[0, -32] $CellContext`z^3 $CellContext`PV[
         Subscript[$CellContext`\[Delta]\[Rho], $CellContext`lead]] + 
      Complex[0, 8] $CellContext`z $CellContext`PV[
         Subscript[$CellContext`\[Delta]\[Rho], $CellContext`sublead]]) - 6 
    Subscript[$CellContext`\[Delta]\[Rho], $CellContext`lead] + 
    36 $CellContext`z^2 
     Subscript[$CellContext`\[Delta]\[Rho], $CellContext`lead] + 
    16 $CellContext`z^4 
     Subscript[$CellContext`\[Delta]\[Rho], $CellContext`lead] - 
    4 $CellContext`z^2 
    Subscript[$CellContext`\[Delta]\[Rho], $CellContext`sublead] + 
    2 Subscript[$CellContext`\[Delta]\[Rho], $CellContext`sublead2]}, 9, 15, 
   1],
  Editable->False]], "Output",
 CellChangeTimes->{{3.55579337482847*^9, 3.5557934261584167`*^9}, 
   3.555793470047677*^9, 3.555794008112857*^9, {3.555794046057785*^9, 
   3.555794074157858*^9}, {3.5557941104297733`*^9, 3.55579411366818*^9}, {
   3.555794150674142*^9, 3.555794210340721*^9}, 3.5557943668668327`*^9, 
   3.5558459157034187`*^9, 3.5648552088272133`*^9}]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  RowBox[{"Log", "[", 
   FractionBox[
    SubscriptBox[
     RowBox[{"(", 
      RowBox[{
       SuperscriptBox[
        StyleBox["\[ScriptCapitalT]",
         FontColor->RGBColor[1, 0, 0]], "-"], " ", 
       SuperscriptBox[
        StyleBox["\[ScriptCapitalT]",
         FontColor->RGBColor[1, 0, 0]], "+"], " ", 
       SuperscriptBox[
        OverscriptBox[
         StyleBox["\[ScriptCapitalT]",
          FontColor->RGBColor[1, 0, 0]], 
         StyleBox["^",
          FontColor->RGBColor[1, 0, 0]]], 
        RowBox[{"[", 
         RowBox[{
          RowBox[{"-", "1"}], "-", "o"}], "]"}]], " ", 
       SuperscriptBox[
        OverscriptBox[
         StyleBox["\[ScriptCapitalT]",
          FontColor->RGBColor[1, 0, 0]], 
         StyleBox["^",
          FontColor->RGBColor[1, 0, 0]]], 
        RowBox[{"[", 
         RowBox[{"1", "+", "o"}], "]"}]]}], ")"}], "asym"], 
    RowBox[{
     SuperscriptBox[
      StyleBox["\[ScriptCapitalT]",
       FontColor->RGBColor[1, 0, 0]], "-"], " ", 
     SuperscriptBox[
      StyleBox["\[ScriptCapitalT]",
       FontColor->RGBColor[1, 0, 0]], "+"], " ", 
     SuperscriptBox[
      OverscriptBox[
       StyleBox["\[ScriptCapitalT]",
        FontColor->RGBColor[1, 0, 0]], 
       StyleBox["^",
        FontColor->RGBColor[1, 0, 0]]], 
      RowBox[{"[", 
       RowBox[{
        RowBox[{"-", "1"}], "-", "o"}], "]"}]], " ", 
     SuperscriptBox[
      OverscriptBox[
       StyleBox["\[ScriptCapitalT]",
        FontColor->RGBColor[1, 0, 0]], 
       StyleBox["^",
        FontColor->RGBColor[1, 0, 0]]], 
      RowBox[{"[", 
       RowBox[{"1", "+", "o"}], "]"}]]}]], "]"}]],
  CellChangeTimes->{{3.546931310662352*^9, 3.5469313989313602`*^9}, {
   3.546931442809442*^9, 3.5469315410399837`*^9}}],
 Cell[BoxData[
  RowBox[{"\[Equal]", 
   RowBox[{"-", "productTright"}]}]],
  CellChangeTimes->{{3.546919596170136*^9, 3.54691964093874*^9}, {
   3.5469393060739107`*^9, 3.546939359116583*^9}}]
}], "Subsection",
 CellChangeTimes->{
  3.546938210601287*^9, 3.5469388822189693`*^9, {3.546939396776827*^9, 
   3.546939396910386*^9}, {3.5496897518505507`*^9, 3.54968975217618*^9}, {
   3.553714643107349*^9, 3.5537146431075163`*^9}, {3.555796672949273*^9, 
   3.5557966729494143`*^9}, {3.555846000744589*^9, 3.555846000744753*^9}}],

Cell[BoxData[
 RowBox[{
  StyleBox["\[ScriptCapitalT]",
   FontColor->RGBColor[1, 0, 0]], "=", 
  RowBox[{"1", "+", 
   RowBox[{
    SuperscriptBox["\[ScriptCapitalC]", "+"], 
    OverscriptBox["*", "^"], "\[Rho]"}], "-", 
   RowBox[{
    SuperscriptBox["\[ScriptCapitalC]", "-"], 
    OverscriptBox["*", "^"], "\[Rho]"}]}]}]], "Input",
 CellChangeTimes->{{3.546918441244444*^9, 3.546918462533304*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Log", "[", 
   FractionBox[
    RowBox[{
     SuperscriptBox[
      StyleBox["\[ScriptCapitalT]",
       FontColor->RGBColor[1, 0, 0]], "-"], " ", 
     SuperscriptBox[
      StyleBox["\[ScriptCapitalT]",
       FontColor->RGBColor[1, 0, 0]], "+"], 
     SubsuperscriptBox[
      StyleBox["\[ScriptCapitalT]",
       FontColor->RGBColor[1, 0, 0]], "\[FivePointedStar]", "-"], 
     SubsuperscriptBox[
      StyleBox["\[ScriptCapitalT]",
       FontColor->RGBColor[1, 0, 0]], "\[FivePointedStar]", "+"]}], 
    SubscriptBox[
     RowBox[{"(", 
      RowBox[{
       SuperscriptBox[
        StyleBox["\[ScriptCapitalT]",
         FontColor->RGBColor[1, 0, 0]], "-"], " ", 
       SuperscriptBox[
        StyleBox["\[ScriptCapitalT]",
         FontColor->RGBColor[1, 0, 0]], "+"], 
       SubsuperscriptBox[
        StyleBox["\[ScriptCapitalT]",
         FontColor->RGBColor[1, 0, 0]], "\[FivePointedStar]", "-"], 
       SubsuperscriptBox[
        StyleBox["\[ScriptCapitalT]",
         FontColor->RGBColor[1, 0, 0]], "\[FivePointedStar]", "+"]}], ")"}], 
     "asym"]], "]"}], "\[Equal]", 
  FractionBox[
   RowBox[{"\[Delta]", 
    RowBox[{"(", 
     RowBox[{
      SuperscriptBox[
       StyleBox["\[ScriptCapitalT]",
        FontColor->RGBColor[1, 0, 0]], "-"], " ", 
      SuperscriptBox[
       StyleBox["\[ScriptCapitalT]",
        FontColor->RGBColor[1, 0, 0]], "+"], 
      SubsuperscriptBox[
       StyleBox["\[ScriptCapitalT]",
        FontColor->RGBColor[1, 0, 0]], "\[FivePointedStar]", "-"], 
      SubsuperscriptBox[
       StyleBox["\[ScriptCapitalT]",
        FontColor->RGBColor[1, 0, 0]], "\[FivePointedStar]", "+"]}], ")"}]}], 
   
   SubscriptBox[
    RowBox[{"(", 
     RowBox[{
      SuperscriptBox[
       StyleBox["\[ScriptCapitalT]",
        FontColor->RGBColor[1, 0, 0]], "-"], " ", 
      SuperscriptBox[
       StyleBox["\[ScriptCapitalT]",
        FontColor->RGBColor[1, 0, 0]], "+"], 
      SubsuperscriptBox[
       StyleBox["\[ScriptCapitalT]",
        FontColor->RGBColor[1, 0, 0]], "\[FivePointedStar]", "-"], 
      SubsuperscriptBox[
       StyleBox["\[ScriptCapitalT]",
        FontColor->RGBColor[1, 0, 0]], "\[FivePointedStar]", "+"]}], ")"}], 
    "asym"]], "==", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       SuperscriptBox["\[ScriptCapitalC]", 
        RowBox[{"[", 
         RowBox[{"+", "o"}], "]"}]], "-", 
       SuperscriptBox["\[ScriptCapitalC]", 
        RowBox[{"[", 
         RowBox[{"-", "2"}], "]"}]]}], ")"}], "+", 
     RowBox[{"(", 
      RowBox[{
       SuperscriptBox[
        StyleBox["\[ScriptCapitalC]", "Dafault"], 
        RowBox[{"[", 
         RowBox[{"+", "2"}], "]"}]], "-", 
       SuperscriptBox["\[ScriptCapitalC]", 
        RowBox[{"[", 
         RowBox[{"-", "o"}], "]"}]]}], ")"}], "+", 
     RowBox[{"(", 
      RowBox[{
       SuperscriptBox[
        StyleBox["\[ScriptCapitalC]", "Dafault"], 
        RowBox[{"[", 
         RowBox[{"-", "o"}], "]"}]], "-", 
       SuperscriptBox["\[ScriptCapitalC]", 
        RowBox[{"[", 
         RowBox[{"-", "2"}], "]"}]]}], ")"}], "+", 
     RowBox[{"(", 
      RowBox[{
       SuperscriptBox[
        StyleBox["\[ScriptCapitalC]", "Dafault"], 
        RowBox[{"[", 
         RowBox[{"+", "2"}], "]"}]], "-", 
       SuperscriptBox["\[ScriptCapitalC]", 
        RowBox[{"[", 
         RowBox[{"+", "o"}], "]"}]]}], ")"}]}], ")"}], 
   OverscriptBox["*", "^"], "\[Delta]\[Rho]"}], "\[Equal]", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     RowBox[{
      RowBox[{"-", "2"}], " ", 
      SuperscriptBox[
       StyleBox["\[ScriptCapitalC]",
        FontColor->RGBColor[0, 0, 0.8]], 
       RowBox[{"[", 
        RowBox[{"-", "2"}], "]"}]]}], "+", 
     RowBox[{"2", " ", 
      SuperscriptBox[
       StyleBox["\[ScriptCapitalC]",
        FontColor->RGBColor[0, 0, 0.8]], 
       RowBox[{"[", "2", "]"}]]}]}], ")"}], 
   OverscriptBox["*", "^"], 
   RowBox[{"\[Delta]\[Rho]", "~", 
    SuperscriptBox["g", "10"]}]}]}]], "Input",
 CellChangeTimes->{{3.553714436592785*^9, 3.553714452149851*^9}, {
  3.553714512956922*^9, 3.553714568890388*^9}, {3.553714632694984*^9, 
  3.553714637335125*^9}}],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"Series", "[", 
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{
         FractionBox[
          RowBox[{"(", 
           RowBox[{
            SuperscriptBox[
             StyleBox["\[ScriptCapitalC]", "Dafault"], 
             RowBox[{"[", 
              RowBox[{"+", "2"}], "]"}]], "-", 
            SuperscriptBox["\[ScriptCapitalC]", 
             RowBox[{"[", 
              RowBox[{"-", "o"}], "]"}]]}], ")"}], 
          RowBox[{
           SuperscriptBox[
            StyleBox["\[ScriptCapitalT]",
             FontColor->RGBColor[1, 0, 0]], "+"], "/.", "largevolume"}]], "+", 
         FractionBox[
          RowBox[{"(", 
           RowBox[{
            SuperscriptBox[
             StyleBox["\[ScriptCapitalC]", "Dafault"], 
             RowBox[{"[", 
              RowBox[{"+", "o"}], "]"}]], "-", 
            SuperscriptBox["\[ScriptCapitalC]", 
             RowBox[{"[", 
              RowBox[{"-", "2"}], "]"}]]}], ")"}], 
          RowBox[{
           SuperscriptBox[
            StyleBox["\[ScriptCapitalT]",
             FontColor->RGBColor[1, 0, 0]], "-"], "/.", "largevolume"}]], "+", 
         FractionBox[
          RowBox[{"(", 
           RowBox[{
            SuperscriptBox[
             StyleBox["\[ScriptCapitalC]", "Dafault"], 
             RowBox[{"[", 
              RowBox[{"+", "2"}], "]"}]], "-", 
            SuperscriptBox["\[ScriptCapitalC]", 
             RowBox[{"[", 
              RowBox[{"+", "o"}], "]"}]]}], ")"}], 
          RowBox[{
           RowBox[{
            SuperscriptBox[
             StyleBox["\[ScriptCapitalT]",
              FontColor->RGBColor[1, 0, 0]], "+"], "/.", "largevolume"}], "/.", 
           RowBox[{"x", "\[Rule]", 
            FractionBox["1", "x"]}]}]], "+", 
         FractionBox[
          RowBox[{"(", 
           RowBox[{
            SuperscriptBox[
             StyleBox["\[ScriptCapitalC]", "Dafault"], 
             RowBox[{"[", 
              RowBox[{"-", "o"}], "]"}]], "-", 
            SuperscriptBox["\[ScriptCapitalC]", 
             RowBox[{"[", 
              RowBox[{"-", "2"}], "]"}]]}], ")"}], 
          RowBox[{
           RowBox[{
            SuperscriptBox[
             StyleBox["\[ScriptCapitalT]",
              FontColor->RGBColor[1, 0, 0]], "-"], "/.", "largevolume"}], "/.", 
           RowBox[{"x", "\[Rule]", 
            FractionBox["1", "x"]}]}]]}], "/.", "subJuk"}], "/.", 
       RowBox[{"u", "\[Rule]", 
        RowBox[{"2", "g", " ", "z"}]}]}], "/.", 
      RowBox[{"leadweak", "[", "4", "]"}]}], ",", 
     RowBox[{"{", 
      RowBox[{"g", ",", "0", ",", "8"}], "}"}]}], "]"}], "//", "Simplify"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"%", "/.", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         RowBox[{"-", "\[ImaginaryI]"}], " ", "z"}], "+", 
        SqrtBox[
         RowBox[{"1", "-", 
          SuperscriptBox["z", "2"]}]]}], ")"}], "\[Rule]", 
      FractionBox["1", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          RowBox[{"+", "\[ImaginaryI]"}], " ", "z"}], "+", 
         SqrtBox[
          RowBox[{"1", "-", 
           SuperscriptBox["z", "2"]}]]}], ")"}]]}]}], "//", "Simplify"}], "//",
    "Normal"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"productTright", "=", 
  RowBox[{
   RowBox[{
    RowBox[{"Collect", "[", 
     RowBox[{"#", ",", 
      SqrtBox[
       RowBox[{"1", "-", 
        SuperscriptBox["z", "2"]}]]}], "]"}], "&"}], "/@", 
   RowBox[{"Series", "[", 
    RowBox[{
     RowBox[{"%", "/.", "tmpsubs"}], ",", 
     RowBox[{"{", 
      RowBox[{"g", ",", "0", ",", "13"}], "}"}]}], "]"}]}]}]}], "Input",
 CellChangeTimes->{{3.555793382372897*^9, 3.555793424351448*^9}, {
  3.555793457462407*^9, 3.555793469337389*^9}, {3.5557940170303707`*^9, 
  3.555794045516943*^9}, {3.5557941132338533`*^9, 3.5557941133217087`*^9}, {
  3.555794149944571*^9, 3.5557942095686007`*^9}, {3.5557943148853617`*^9, 
  3.5557943372922773`*^9}, {3.5558460273088627`*^9, 3.555846027642274*^9}}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"4", " ", 
       RowBox[{"M", "[", 
        SubscriptBox["\[Delta]\[Rho]", "lead"], "]"}]}], "-", 
      RowBox[{"4", " ", "\[ImaginaryI]", " ", "z", " ", 
       RowBox[{"PV", "[", 
        SubscriptBox["\[Delta]\[Rho]", "lead"], "]"}]}], "-", 
      RowBox[{"2", " ", 
       SqrtBox[
        RowBox[{"1", "-", 
         SuperscriptBox["z", "2"]}]], " ", 
       SubscriptBox["\[Delta]\[Rho]", "lead"]}]}], ")"}], " ", 
    SuperscriptBox["g", "10"]}], "+", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       RowBox[{"-", "32"}], " ", 
       SuperscriptBox["z", "2"], " ", 
       RowBox[{"M", "[", 
        SubscriptBox["\[Delta]\[Rho]", "lead"], "]"}]}], "-", 
      RowBox[{"16", " ", 
       RowBox[{"M", "[", 
        RowBox[{
         SuperscriptBox["w", "2"], " ", 
         SubscriptBox["\[Delta]\[Rho]", "lead"]}], "]"}]}], "+", 
      RowBox[{"4", " ", 
       RowBox[{"M", "[", 
        SubscriptBox["\[Delta]\[Rho]", "sublead"], "]"}]}], "+", 
      RowBox[{"16", " ", "\[ImaginaryI]", " ", "z", " ", 
       RowBox[{"PV", "[", 
        SubscriptBox["\[Delta]\[Rho]", "lead"], "]"}]}], "+", 
      RowBox[{"16", " ", "\[ImaginaryI]", " ", 
       SuperscriptBox["z", "3"], " ", 
       RowBox[{"PV", "[", 
        SubscriptBox["\[Delta]\[Rho]", "lead"], "]"}]}], "-", 
      RowBox[{"4", " ", "\[ImaginaryI]", " ", "z", " ", 
       RowBox[{"PV", "[", 
        SubscriptBox["\[Delta]\[Rho]", "sublead"], "]"}]}], "+", 
      RowBox[{
       SqrtBox[
        RowBox[{"1", "-", 
         SuperscriptBox["z", "2"]}]], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"8", " ", 
          SubscriptBox["\[Delta]\[Rho]", "lead"]}], "+", 
         RowBox[{"8", " ", 
          SuperscriptBox["z", "2"], " ", 
          SubscriptBox["\[Delta]\[Rho]", "lead"]}], "-", 
         RowBox[{"2", " ", 
          SubscriptBox["\[Delta]\[Rho]", "sublead"]}]}], ")"}]}]}], ")"}], 
    " ", 
    SuperscriptBox["g", "12"]}], "+", 
   InterpretationBox[
    SuperscriptBox[
     RowBox[{"O", "[", "g", "]"}], "14"],
    SeriesData[$CellContext`g, 0, {}, 10, 14, 1],
    Editable->False]}],
  SeriesData[$CellContext`g, 0, {4 $CellContext`M[
       Subscript[$CellContext`\[Delta]\[Rho], $CellContext`lead]] + 
    Complex[0, -4] $CellContext`z $CellContext`PV[
       Subscript[$CellContext`\[Delta]\[Rho], $CellContext`lead]] - 
    2 (1 - $CellContext`z^2)^Rational[1, 2] 
    Subscript[$CellContext`\[Delta]\[Rho], $CellContext`lead], 
    0, (-32) $CellContext`z^2 $CellContext`M[
       Subscript[$CellContext`\[Delta]\[Rho], $CellContext`lead]] - 
    16 $CellContext`M[$CellContext`w^2 
      Subscript[$CellContext`\[Delta]\[Rho], $CellContext`lead]] + 
    4 $CellContext`M[
       Subscript[$CellContext`\[Delta]\[Rho], $CellContext`sublead]] + 
    Complex[0, 16] $CellContext`z $CellContext`PV[
       Subscript[$CellContext`\[Delta]\[Rho], $CellContext`lead]] + 
    Complex[0, 16] $CellContext`z^3 $CellContext`PV[
       Subscript[$CellContext`\[Delta]\[Rho], $CellContext`lead]] + 
    Complex[0, -4] $CellContext`z $CellContext`PV[
       Subscript[$CellContext`\[Delta]\[Rho], $CellContext`sublead]] + (
       1 - $CellContext`z^2)^Rational[1, 2] (
      8 Subscript[$CellContext`\[Delta]\[Rho], $CellContext`lead] + 
      8 $CellContext`z^2 
       Subscript[$CellContext`\[Delta]\[Rho], $CellContext`lead] - 2 
      Subscript[$CellContext`\[Delta]\[Rho], $CellContext`sublead])}, 10, 14, 
   1],
  Editable->False]], "Output",
 CellChangeTimes->{{3.55579337482847*^9, 3.5557934261584167`*^9}, 
   3.555793470047677*^9, 3.555794008112857*^9, {3.555794046057785*^9, 
   3.555794074157858*^9}, {3.5557941104297733`*^9, 3.55579411366818*^9}, {
   3.555794150674142*^9, 3.555794210340721*^9}, {3.55579432889889*^9, 
   3.555794340412781*^9}, 3.555794371332498*^9, 3.555846031518465*^9, 
   3.56485522085614*^9}]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  RowBox[{"2", 
   RowBox[{"Log", "[", 
    RowBox[{
     FractionBox[
      SubsuperscriptBox[
       StyleBox["\[ScriptCapitalT]",
        FontColor->RGBColor[1, 0, 0]], 
       RowBox[{"1", ",", "0"}], "c"], 
      RowBox[{
       SubsuperscriptBox[
        StyleBox["\[GothicCapitalT]",
         FontColor->RGBColor[0.54, 0.35, 0.15]], 
        RowBox[{"0", ",", "1"}], "c"], " "}]], 
     FractionBox[
      SubscriptBox["\[Rho]", 
       RowBox[{"2", ",", "asym"}]], 
      SubscriptBox["\[Rho]", "asym"]]}], "]"}]}]],
  CellChangeTimes->{{3.546931310662352*^9, 3.5469313989313602`*^9}, {
   3.546931442809442*^9, 3.5469315410399837`*^9}}],
 "==",
 Cell[BoxData[
  RowBox[{"Tc\[Rho]2\[Delta]\[Rho]contr", "+", "Tc\[Rho]2Wcontr"}]],
  CellChangeTimes->{{3.546943726296591*^9, 3.5469437849562283`*^9}}]
}], "Subsection",
 CellChangeTimes->{{3.546860158703958*^9, 3.546860185529262*^9}, {
   3.546941201745359*^9, 3.54694121121525*^9}, {3.546942156630391*^9, 
   3.54694220195328*^9}, {3.546942439767205*^9, 3.546942458261949*^9}, 
   3.546943916010236*^9, 3.553714688798966*^9, {3.553718739365039*^9, 
   3.553718739365212*^9}, {3.553718832356677*^9, 3.553718835749504*^9}, {
   3.555796614741125*^9, 3.555796642521941*^9}, {3.555846358885466*^9, 
   3.555846358885632*^9}}],

Cell[TextData[{
 "Original parameterization (from the FiNLIE paper) of ",
 Cell[BoxData[
  FormBox[
   SubscriptBox["q", "2"], TraditionalForm]]],
 " is the following:"
}], "Text",
 CellChangeTimes->{{3.546834634966998*^9, 3.546834643565124*^9}, {
  3.5468601889263153`*^9, 3.546860191509297*^9}, {3.549692129313098*^9, 
  3.549692134413393*^9}}],

Cell[BoxData[
 RowBox[{
  SubscriptBox[
   StyleBox["\[GothicQ]",
    FontColor->RGBColor[0.54, 0.35, 0.15]], "2"], "\[Equal]", 
  RowBox[{
   RowBox[{
    RowBox[{"-", "\[ImaginaryI]"}], " ", "u"}], "+", 
   RowBox[{"\[ScriptCapitalC]", 
    OverscriptBox["*", "^"], 
    SubscriptBox["\[Rho]", 
     RowBox[{"2", ",", "FiNLIE"}]]}], "-", 
   RowBox[{"\[ScriptCapitalC]", "*", 
    SubscriptBox["W", "0"]}]}]}]], "Input",
 CellChangeTimes->{{3.546941351021723*^9, 3.5469413579888144`*^9}, {
  3.5496921555624104`*^9, 3.549692157017799*^9}, {3.553714862256588*^9, 
  3.553714868267756*^9}}],

Cell[TextData[{
 "We remind that ",
 Cell[BoxData[
  FormBox[
   RowBox[{
    SubscriptBox["W", "s"], "=", 
    RowBox[{
     RowBox[{
      SubsuperscriptBox["q", "3", 
       RowBox[{"[", 
        RowBox[{"+", "s"}], "]"}]], 
      SubsuperscriptBox[
       OverscriptBox["q", "_"], "4", 
       RowBox[{"[", 
        RowBox[{"-", "s"}], "]"}]]}], "+", 
     RowBox[{
      SubsuperscriptBox["q", "4", 
       RowBox[{"[", 
        RowBox[{"+", "s"}], "]"}]], 
      SubsuperscriptBox[
       OverscriptBox["q", "_"], "3", 
       RowBox[{"[", 
        RowBox[{"-", "s"}], "]"}]]}]}]}], TraditionalForm]]],
 ". "
}], "Text",
 CellChangeTimes->{{3.553715081019219*^9, 3.553715120183597*^9}, 
   3.553717000672086*^9, {3.568964614586919*^9, 3.568964615642939*^9}}],

Cell[TextData[{
 Cell[BoxData[
  FormBox[
   SubscriptBox["\[Rho]", 
    RowBox[{"2", ",", "FiNLIE"}]], TraditionalForm]]],
 " has finite support. And",
 Cell[BoxData[
  FormBox[
   RowBox[{" ", 
    RowBox[{
     RowBox[{
      SubscriptBox["q", "2"], "+", 
      SubscriptBox[
       OverscriptBox["q", "_"], "2"]}], "=", 
     RowBox[{
      SubscriptBox["\[Rho]", 
       RowBox[{"2", ",", "FiNLIE"}]], "-", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         SubsuperscriptBox[
          StyleBox["\[GothicQ]",
           FontColor->RGBColor[0.54, 0.35, 0.15]], "3", 
          RowBox[{"[", "o", "]"}]], 
         SubsuperscriptBox[
          OverscriptBox[
           StyleBox["\[GothicQ]",
            FontColor->RGBColor[0.54, 0.35, 0.15]], 
           StyleBox["_",
            FontColor->RGBColor[0.54, 0.35, 0.15]]], "4", 
          RowBox[{"[", 
           RowBox[{"-", "o"}], "]"}]]}], "+", 
        RowBox[{
         SubsuperscriptBox[
          StyleBox["\[GothicQ]",
           FontColor->RGBColor[0.54, 0.35, 0.15]], "4", 
          RowBox[{"[", 
           RowBox[{"+", "o"}], "]"}]], 
         SubsuperscriptBox[
          OverscriptBox[
           StyleBox["\[GothicQ]",
            FontColor->RGBColor[0.54, 0.35, 0.15]], 
           StyleBox["_",
            FontColor->RGBColor[0.54, 0.35, 0.15]]], "3", 
          RowBox[{"[", 
           RowBox[{"-", "o"}], "]"}]]}]}], ")"}]}]}]}], TraditionalForm]]],
 ", and hence ",
 Cell[BoxData[
  FormBox[
   RowBox[{
    SubscriptBox["\[Rho]", 
     RowBox[{"2", ",", "FiNLIE"}]], "=", 
    SubsuperscriptBox["\[GothicCapitalT]", 
     RowBox[{"0", ",", "1"}], "c"]}], TraditionalForm]]],
 "."
}], "Text",
 CellChangeTimes->{{3.546941216703065*^9, 3.546941271517844*^9}, {
  3.546941363653595*^9, 3.5469413661866827`*^9}, {3.546941443340613*^9, 
  3.546941444223806*^9}, {3.546942506675089*^9, 3.546942510087409*^9}, {
  3.5469425428884697`*^9, 3.546942579282406*^9}, {3.549692158762162*^9, 
  3.549692177443866*^9}, {3.553715149602942*^9, 3.553715151167919*^9}}],

Cell[TextData[{
 "However, this definition of ",
 Cell[BoxData[
  FormBox[
   SubscriptBox["\[Rho]", "2"], TraditionalForm]]],
 " introduces logarithmic cuts in the story, for instance ",
 Cell[BoxData[
  RowBox[{"\[ScriptCapitalC]", "*", 
   SubscriptBox["W", "0"]}]],
  CellChangeTimes->{{3.546941351021723*^9, 3.5469413579888144`*^9}, {
   3.5496921555624104`*^9, 3.549692157017799*^9}, {3.553714862256588*^9, 
   3.553714868267756*^9}}],
 " produces  logarithmic cuts. Since ",
 Cell[BoxData[
  FormBox[
   SubscriptBox["q", "2"], TraditionalForm]]],
 " should not have such cuts, it is reasonable to make definitions which do \
not produce them on intermediate stages. Therefore we will redefine ",
 Cell[BoxData[
  FormBox[
   SubscriptBox["\[Rho]", "2"], TraditionalForm]]],
 ".  In the new definition ",
 Cell[BoxData[
  FormBox[
   SubscriptBox["\[Rho]", "2"], TraditionalForm]]],
 " is defined through:"
}], "Text",
 CellChangeTimes->{{3.546834664957556*^9, 3.546834744552759*^9}, {
  3.5468602168316402`*^9, 3.546860264922926*^9}, {3.54686074162199*^9, 
  3.546860746823388*^9}, {3.546941279277816*^9, 3.546941292451693*^9}, {
  3.546941332894023*^9, 3.546941342556118*^9}, {3.549692286198925*^9, 
  3.549692362372456*^9}, {3.553714891276376*^9, 3.553714980490287*^9}, {
  3.553715168478956*^9, 3.553715240771578*^9}, {3.568964630890443*^9, 
  3.5689646314583673`*^9}}],

Cell[BoxData[
 RowBox[{
  SubscriptBox[
   StyleBox["\[GothicQ]",
    FontColor->RGBColor[0.54, 0.35, 0.15]], "2"], "\[Equal]", 
  RowBox[{
   RowBox[{
    RowBox[{"-", "\[ImaginaryI]"}], " ", "u"}], "+", 
   RowBox[{"\[ScriptCapitalC]", 
    OverscriptBox["*", "^"], 
    SubscriptBox["\[Rho]", "2"]}], "-", 
   RowBox[{"\[ScriptCapitalC]", "*", 
    SubscriptBox[
     OverscriptBox["W", "^"], 
     RowBox[{"0", ",", "pv"}]]}]}]}]], "Input",
 CellChangeTimes->{{3.5468347543733053`*^9, 3.546834776156386*^9}, {
   3.546860753997827*^9, 3.546860759535069*^9}, 3.5496925429899673`*^9, {
   3.553714959983172*^9, 3.553714968873337*^9}}],

Cell[TextData[Cell[BoxData[
 FormBox[
  RowBox[{
   SubscriptBox[
    OverscriptBox["W", "^"], 
    RowBox[{"0", ",", "pv"}]], "\[Congruent]", 
   RowBox[{
    FractionBox["1", "2"], 
    RowBox[{"(", 
     RowBox[{
      SubsuperscriptBox[
       OverscriptBox["W", "^"], "0", 
       RowBox[{"[", 
        RowBox[{"+", "o"}], "]"}]], "+", 
      SubsuperscriptBox[
       OverscriptBox["W", "^"], "0", 
       RowBox[{"[", 
        RowBox[{"-", "o"}], "]"}]]}], ")"}]}]}], TraditionalForm]]]], "Text",
 CellChangeTimes->{{3.553715054529717*^9, 3.553715078635487*^9}, {
  3.553715255943285*^9, 3.5537152806568737`*^9}}],

Cell[TextData[{
 "Making a standard assumption that ",
 Cell[BoxData[
  FormBox[
   SubscriptBox["\[GothicQ]", "2"], TraditionalForm]]],
 " has branch points of the second order, it is straightforward to see that \
",
 Cell[BoxData[
  FormBox[
   RowBox[{
    SubsuperscriptBox["\[Rho]", "2", "\[FivePointedStar]"], "=", 
    RowBox[{"-", 
     SubscriptBox["\[Rho]", "2"]}]}], TraditionalForm]]],
 ", which means that  ",
 Cell[BoxData[
  FormBox[
   RowBox[{
    SubscriptBox["\[Rho]", "2"], "\[TildeEqual]", 
    RowBox[{
     SqrtBox[
      RowBox[{
       RowBox[{"4", 
        SuperscriptBox["g", "2"]}], "-", 
       SuperscriptBox["u", "2"]}]], "\[Cross]", "f"}]}], TraditionalForm]]],
 ", where ",
 Cell[BoxData[
  FormBox["f", TraditionalForm]]],
 " is a function analytic on the real axis. "
}], "Text",
 CellChangeTimes->{{3.55371498721102*^9, 3.553715049218422*^9}, {
  3.5689646406499653`*^9, 3.5689646409778633`*^9}}],

Cell[TextData[{
 "Let us relate ",
 Cell[BoxData[
  FormBox[
   SubscriptBox["\[Rho]", "2"], TraditionalForm]]],
 " and ",
 Cell[BoxData[
  FormBox[
   SubsuperscriptBox["\[GothicCapitalT]", 
    RowBox[{"0", ",", "1"}], "c"], TraditionalForm]]]
}], "Text",
 CellChangeTimes->{{3.546942470751197*^9, 3.546942493380829*^9}, {
  3.5469426091128483`*^9, 3.546942611281774*^9}, {3.549692687619523*^9, 
  3.5496926968087187`*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   SubscriptBox["q", "2"], "+", 
   SubscriptBox[
    OverscriptBox["q", "_"], "2"]}], "=", 
  RowBox[{
   RowBox[{
    SubsuperscriptBox[
     StyleBox["\[GothicCapitalT]",
      FontColor->RGBColor[0.54, 0.35, 0.15]], 
     RowBox[{"0", ",", "1"}], "c"], "-", 
    SubscriptBox["W", "0"]}], "==", 
   RowBox[{
    SubscriptBox["\[Rho]", "2"], "-", 
    SubscriptBox[
     OverscriptBox["W", "^"], 
     RowBox[{"0", ",", "pv"}]]}]}]}], "\[IndentingNewLine]", 
 RowBox[{
  SubsuperscriptBox[
   StyleBox["\[GothicCapitalT]",
    FontColor->RGBColor[0.54, 0.35, 0.15]], 
   RowBox[{"0", ",", "1"}], "c"], "=", 
  RowBox[{
   SubscriptBox["\[Rho]", "2"], "+", 
   SubscriptBox["W", "0"], "-", 
   SubscriptBox[
    OverscriptBox["W", "^"], 
    RowBox[{"0", ",", "pv"}]]}]}]}], "Input",
 CellChangeTimes->{{3.546942613048223*^9, 3.5469426411049356`*^9}, {
  3.5496927013679333`*^9, 3.549692722298811*^9}, {3.549692889903329*^9, 
  3.549692899020965*^9}, {3.553715306701334*^9, 3.5537153395483303`*^9}}],

Cell["Now we are ready to compute things.", "Text",
 CellChangeTimes->{{3.55371537188587*^9, 3.553715376701136*^9}, {
  3.553715416206732*^9, 3.553715417019703*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"2", 
   RowBox[{"Log", "[", " ", 
    FractionBox[
     SubscriptBox["\[Rho]", 
      RowBox[{"2", ",", "asym"}]], 
     SubsuperscriptBox[
      StyleBox["\[GothicCapitalT]",
       FontColor->RGBColor[0.54, 0.35, 0.15]], 
      RowBox[{"0", ",", "1"}], "c"]], "]"}]}], "\[Equal]", 
  RowBox[{"2", 
   RowBox[{"Log", "[", 
    FractionBox[
     SubscriptBox["\[Rho]", 
      RowBox[{"2", ",", "asym"}]], 
     RowBox[{
      SubscriptBox["\[Rho]", 
       RowBox[{"2", ",", "asym"}]], "+", 
      SubscriptBox["\[Delta]\[Rho]", "2"], "+", 
      SubscriptBox["W", "0"], "-", 
      SubscriptBox[
       OverscriptBox["W", "^"], 
       RowBox[{"0", ",", "pv"}]]}]], "]"}]}], "\[Equal]", 
  RowBox[{
   FractionBox[
    RowBox[{"-", "2"}], 
    SubscriptBox["\[Rho]", 
     RowBox[{"2", ",", "asym"}]]], 
   RowBox[{"(", 
    RowBox[{
     SubscriptBox["\[Delta]\[Rho]", "2"], "+", 
     SubscriptBox["W", "0"], "-", 
     SubscriptBox[
      OverscriptBox["W", "^"], 
      RowBox[{"0", ",", "pv"}]]}], ")"}]}], "==", 
  RowBox[{
   RowBox[{"-", 
    FractionBox[
     RowBox[{"3", " ", "g", " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "1"}], "+", 
        RowBox[{"4", " ", 
         SuperscriptBox["g", "2"]}], "-", 
        RowBox[{"28", " ", 
         SuperscriptBox["g", "4"]}], "+", 
        RowBox[{
         SuperscriptBox["g", "6"], " ", 
         RowBox[{"(", 
          RowBox[{"235", "+", 
           RowBox[{"24", " ", 
            SubscriptBox[
             StyleBox["\[Zeta]",
              FontWeight->Bold,
              FontColor->GrayLevel[0.4]], "3"]}]}], ")"}]}]}], ")"}]}], 
     SqrtBox[
      RowBox[{"1", "-", 
       SuperscriptBox["z", "2"]}]]]}], 
   RowBox[{"(", 
    RowBox[{
     SubscriptBox["\[Delta]\[Rho]", "2"], "+", 
     SubscriptBox["W", "0"], "-", 
     SubscriptBox[
      OverscriptBox["W", "^"], 
      RowBox[{"0", ",", "pv"}]]}], ")"}]}]}]], "Input",
 CellChangeTimes->{{3.553715431610722*^9, 3.553715490143063*^9}, {
   3.553715721402481*^9, 3.553715762621471*^9}, {3.5557952438044662`*^9, 
   3.555795258495632*^9}, 3.5557953312702007`*^9, 3.555865356255865*^9}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"-", "2"}], "/", 
   SubscriptBox["\[Rho]", 
    RowBox[{"2", ",", "asym"}]]}], "\[Equal]", 
  RowBox[{"(", 
   RowBox[{
    RowBox[{"Normal", "@", 
     RowBox[{"Series", "[", 
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{
          RowBox[{
           RowBox[{
            RowBox[{"-", "2"}], "/", "\[Rho]2"}], "/.", "largevolume"}], "/.", 
          RowBox[{"u", "\[Rule]", 
           RowBox[{"2", "g", " ", "z"}]}]}], "/.", "subJuk"}], "/.", 
        RowBox[{"leadweak", "[", "4", "]"}]}], ",", 
       RowBox[{"{", 
        RowBox[{"g", ",", "0", ",", "7"}], "}"}]}], "]"}]}], "//", 
    "Simplify"}], ")"}]}]], "Input",
 CellChangeTimes->{{3.553715491257474*^9, 3.5537155568257504`*^9}, {
  3.553715625660116*^9, 3.5537156257346907`*^9}, {3.5557952702794657`*^9, 
  3.5557953231661386`*^9}, {3.55586531973694*^9, 3.555865320745143*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"-", 
   FractionBox["2", 
    SubscriptBox["\[Rho]", 
     RowBox[{"2", ",", "asym"}]]]}], "\[Equal]", 
  RowBox[{"-", 
   FractionBox[
    RowBox[{"3", " ", "g", " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"-", "1"}], "+", 
       RowBox[{"4", " ", 
        SuperscriptBox["g", "2"]}], "-", 
       RowBox[{"28", " ", 
        SuperscriptBox["g", "4"]}], "+", 
       RowBox[{
        SuperscriptBox["g", "6"], " ", 
        RowBox[{"(", 
         RowBox[{"235", "+", 
          RowBox[{"24", " ", 
           SubscriptBox[
            StyleBox["\[Zeta]",
             FontWeight->Bold,
             FontColor->GrayLevel[0.4]], "3"]}]}], ")"}]}]}], ")"}]}], 
    SqrtBox[
     RowBox[{"1", "-", 
      SuperscriptBox["z", "2"]}]]]}]}]], "Output",
 CellChangeTimes->{{3.553715494790169*^9, 3.553715557263238*^9}, 
   3.553715626162472*^9, {3.5557952722226343`*^9, 3.5557953242410603`*^9}, 
   3.555846240681036*^9, 3.555865321538479*^9}]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"2", 
   RowBox[{"Log", "[", 
    FractionBox[
     SubsuperscriptBox[
      StyleBox["\[ScriptCapitalT]",
       FontColor->RGBColor[1, 0, 0]], 
      RowBox[{"1", ",", "0"}], "c"], 
     RowBox[{
      SubscriptBox["\[Rho]", "asym"], " "}]], "]"}]}], "\[Equal]", 
  RowBox[{"2", 
   FractionBox["\[Delta]\[Rho]", 
    SubscriptBox["\[Rho]", "asym"]]}], "\[Equal]", 
  RowBox[{
   FractionBox[
    RowBox[{"1", "+", 
     RowBox[{"3", " ", 
      SuperscriptBox["g", "2"]}], "-", 
     RowBox[{"54", " ", 
      SuperscriptBox["g", "6"]}]}], 
    RowBox[{"g", " ", 
     SqrtBox[
      RowBox[{"1", "-", 
       SuperscriptBox["z", "2"]}]]}]], "\[Delta]\[Rho]"}]}]], "Input",
 CellChangeTimes->{{3.553715667059308*^9, 3.553715681692539*^9}, {
  3.553715746778713*^9, 3.553715771202059*^9}, {3.5557953741313543`*^9, 
  3.5557953787184877`*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"2", "/", 
   SubscriptBox["\[Rho]", "asym"]}], "\[Equal]", 
  RowBox[{"(", 
   RowBox[{
    RowBox[{"Normal", "@", 
     RowBox[{"Series", "[", 
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{
          RowBox[{
           RowBox[{"2", "/", "\[Rho]"}], "/.", "largevolume"}], "/.", 
          RowBox[{"u", "\[Rule]", 
           RowBox[{"2", "g", " ", "z"}]}]}], "/.", "subJuk"}], "/.", 
        RowBox[{"leadweak", "[", "4", "]"}]}], ",", 
       RowBox[{"{", 
        RowBox[{"g", ",", "0", ",", "5"}], "}"}]}], "]"}]}], "//", 
    "Simplify"}], ")"}]}]], "Input",
 CellChangeTimes->{{3.553715687629487*^9, 3.553715694942985*^9}, {
   3.555795354651745*^9, 3.555795363704862*^9}, 3.555865333772791*^9}],

Cell[BoxData[
 RowBox[{
  FractionBox["2", 
   SubscriptBox["\[Rho]", "asym"]], "\[Equal]", 
  FractionBox[
   RowBox[{"1", "+", 
    RowBox[{"3", " ", 
     SuperscriptBox["g", "2"]}], "-", 
    RowBox[{"12", " ", 
     SuperscriptBox["g", "4"]}], "+", 
    RowBox[{"84", " ", 
     SuperscriptBox["g", "6"]}]}], 
   RowBox[{"g", " ", 
    SqrtBox[
     RowBox[{"1", "-", 
      SuperscriptBox["z", "2"]}]]}]]}]], "Output",
 CellChangeTimes->{{3.553715690204485*^9, 3.553715695158346*^9}, 
   3.555795366880434*^9, 3.55584625624885*^9, {3.5558653347854557`*^9, 
   3.5558653644583397`*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Tc\[Rho]2\[Delta]\[Rho]contr", "=", 
  RowBox[{"Normal", "@", 
   RowBox[{"Series", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         FractionBox[
          RowBox[{"1", "+", 
           RowBox[{"3", " ", 
            SuperscriptBox["g", "2"]}], "-", 
           RowBox[{"12", " ", 
            SuperscriptBox["g", "4"]}], "+", 
           RowBox[{"84", " ", 
            SuperscriptBox["g", "6"]}]}], 
          RowBox[{"g", " ", 
           SqrtBox[
            RowBox[{"1", "-", 
             SuperscriptBox["z", "2"]}]]}]], "\[Delta]\[Rho]"}], "+", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{"-", 
           FractionBox[
            RowBox[{"3", " ", "g", " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"-", "1"}], "+", 
               RowBox[{"4", " ", 
                SuperscriptBox["g", "2"]}], "-", 
               RowBox[{"28", " ", 
                SuperscriptBox["g", "4"]}], "+", 
               RowBox[{
                SuperscriptBox["g", "6"], " ", 
                RowBox[{"(", 
                 RowBox[{"235", "+", 
                  RowBox[{"24", " ", 
                   SubscriptBox[
                    StyleBox["\[Zeta]",
                    FontWeight->Bold,
                    FontColor->GrayLevel[0.4]], "3"]}]}], ")"}]}]}], ")"}]}], 
            
            SqrtBox[
             RowBox[{"1", "-", 
              SuperscriptBox["z", "2"]}]]]}], ")"}], "\[Delta]\[Rho]2"}]}], 
       ")"}], "/.", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"\[Delta]\[Rho]", "\[Rule]", 
         RowBox[{
          SuperscriptBox["g", "9"], 
          RowBox[{"(", 
           RowBox[{
            SubscriptBox["\[Delta]\[Rho]", "lead"], "+", 
            RowBox[{
             SuperscriptBox["g", "2"], 
             SubscriptBox["\[Delta]\[Rho]", "sublead"]}], "+", 
            RowBox[{
             SuperscriptBox["g", "4"], 
             SubscriptBox["\[Delta]\[Rho]", "sublead2"]}]}], ")"}]}]}], ",", 
        RowBox[{"\[Delta]\[Rho]2", "\[Rule]", 
         RowBox[{
          SuperscriptBox["g", "7"], 
          RowBox[{"(", 
           RowBox[{
            SubscriptBox["\[Delta]\[Rho]2", "lead"], "+", 
            RowBox[{
             SuperscriptBox["g", "2"], 
             SubscriptBox["\[Delta]\[Rho]2", "sublead"]}], "+", 
            RowBox[{
             SuperscriptBox["g", "4"], 
             SubscriptBox["\[Delta]\[Rho]2", "sublead2"]}]}], ")"}]}]}]}], 
       "}"}]}], ",", 
     RowBox[{"{", 
      RowBox[{"g", ",", "0", ",", "13"}], "}"}]}], "]"}]}]}]], "Input",
 CellChangeTimes->{{3.555846297963016*^9, 3.555846322289288*^9}, {
  3.555865375227495*^9, 3.5558653837295647`*^9}}],

Cell[BoxData[
 RowBox[{
  FractionBox[
   RowBox[{
    SuperscriptBox["g", "8"], " ", 
    RowBox[{"(", 
     RowBox[{
      SubscriptBox["\[Delta]\[Rho]", "lead"], "+", 
      RowBox[{"3", " ", 
       SubscriptBox["\[Delta]\[Rho]2", "lead"]}]}], ")"}]}], 
   SqrtBox[
    RowBox[{"1", "-", 
     SuperscriptBox["z", "2"]}]]], "+", 
  FractionBox[
   RowBox[{
    SuperscriptBox["g", "10"], " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"3", " ", 
       SubscriptBox["\[Delta]\[Rho]", "lead"]}], "+", 
      SubscriptBox["\[Delta]\[Rho]", "sublead"], "-", 
      RowBox[{"12", " ", 
       SubscriptBox["\[Delta]\[Rho]2", "lead"]}], "+", 
      RowBox[{"3", " ", 
       SubscriptBox["\[Delta]\[Rho]2", "sublead"]}]}], ")"}]}], 
   SqrtBox[
    RowBox[{"1", "-", 
     SuperscriptBox["z", "2"]}]]], "+", 
  FractionBox[
   RowBox[{
    SuperscriptBox["g", "12"], " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       RowBox[{"-", "12"}], " ", 
       SubscriptBox["\[Delta]\[Rho]", "lead"]}], "+", 
      RowBox[{"3", " ", 
       SubscriptBox["\[Delta]\[Rho]", "sublead"]}], "+", 
      SubscriptBox["\[Delta]\[Rho]", "sublead2"], "+", 
      RowBox[{"84", " ", 
       SubscriptBox["\[Delta]\[Rho]2", "lead"]}], "-", 
      RowBox[{"12", " ", 
       SubscriptBox["\[Delta]\[Rho]2", "sublead"]}], "+", 
      RowBox[{"3", " ", 
       SubscriptBox["\[Delta]\[Rho]2", "sublead2"]}]}], ")"}]}], 
   SqrtBox[
    RowBox[{"1", "-", 
     SuperscriptBox["z", "2"]}]]]}]], "Output",
 CellChangeTimes->{
  3.555846322547052*^9, {3.555865386261015*^9, 3.555865389485917*^9}, 
   3.555865735821784*^9, 3.564855241533695*^9}]
}, Open  ]],

Cell[TextData[{
 "Now we compute ",
 Cell[BoxData[
  RowBox[{
   SubscriptBox["W", "0"], "-", 
   SubscriptBox[
    OverscriptBox["W", "^"], 
    RowBox[{"0", ",", "pv"}]]}]],
  CellChangeTimes->{{3.553715431610722*^9, 3.553715490143063*^9}, {
   3.553715721402481*^9, 3.553715762621471*^9}}]
}], "Text",
 CellChangeTimes->{{3.55371852596235*^9, 3.55371853334342*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     FractionBox[
      RowBox[{
       RowBox[{
        SubscriptBox[
         StyleBox["q",
          FontColor->RGBColor[0, 0, 0.8]], "2"], " ", 
        SubsuperscriptBox[
         StyleBox["q",
          FontColor->RGBColor[0, 0, 0.8]], 
         RowBox[{"1", ",", "3"}], "+"]}], "-", 
       SubsuperscriptBox[
        StyleBox["q",
         FontColor->RGBColor[0, 0, 0.8]], 
        RowBox[{"1", ",", "4"}], "+"]}], 
      SuperscriptBox[
       StyleBox["Q",
        FontColor->RGBColor[{
           Rational[1, 2], 
           Rational[1, 2], 0}]], "+"]], ",", 
     FractionBox[
      RowBox[{
       RowBox[{
        SubscriptBox[
         StyleBox["q",
          FontColor->RGBColor[0, 0, 0.8]], "2"], " ", 
        SubsuperscriptBox[
         StyleBox["q",
          FontColor->RGBColor[0, 0, 0.8]], 
         RowBox[{"1", ",", "4"}], "+"]}], "-", 
       SubsuperscriptBox[
        StyleBox["q",
         FontColor->RGBColor[0, 0, 0.8]], 
        RowBox[{"2", ",", "4"}], "+"]}], 
      SuperscriptBox[
       StyleBox["Q",
        FontColor->RGBColor[{
           Rational[1, 2], 
           Rational[1, 2], 0}]], "+"]]}], "}"}], "/.", 
   RowBox[{
    SubscriptBox["q", "2"], "\[Rule]", 
    RowBox[{"(", 
     RowBox[{
      SubscriptBox["q", "2"], "/.", "largevolume"}], ")"}]}]}], "/.", 
  RowBox[{"x", "\[Rule]", "xh"}]}]], "Input"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   FractionBox[
    RowBox[{
     RowBox[{
      RowBox[{"-", "\[ImaginaryI]"}], " ", 
      RowBox[{"(", 
       RowBox[{"u", "+", 
        FractionBox[
         RowBox[{"4", " ", "g"}], 
         RowBox[{
          SubscriptBox["\[Gamma]", "0"], " ", 
          OverscriptBox[
           StyleBox["x",
            FontColor->RGBColor[0, 0.6, 0]], 
           StyleBox["^",
            FontColor->RGBColor[0, 0.6, 0]]]}]]}], ")"}], " ", 
      SubsuperscriptBox[
       StyleBox["q",
        FontColor->RGBColor[0, 0, 0.8]], 
       RowBox[{"1", ",", "3"}], "+"]}], "-", 
     SubsuperscriptBox[
      StyleBox["q",
       FontColor->RGBColor[0, 0, 0.8]], 
      RowBox[{"1", ",", "4"}], "+"]}], 
    SuperscriptBox[
     StyleBox["Q",
      FontColor->RGBColor[0.8, 0, 0]], "+"]], ",", 
   FractionBox[
    RowBox[{
     RowBox[{
      RowBox[{"-", "\[ImaginaryI]"}], " ", 
      RowBox[{"(", 
       RowBox[{"u", "+", 
        FractionBox[
         RowBox[{"4", " ", "g"}], 
         RowBox[{
          SubscriptBox["\[Gamma]", "0"], " ", 
          OverscriptBox[
           StyleBox["x",
            FontColor->RGBColor[0, 0.6, 0]], 
           StyleBox["^",
            FontColor->RGBColor[0, 0.6, 0]]]}]]}], ")"}], " ", 
      SubsuperscriptBox[
       StyleBox["q",
        FontColor->RGBColor[0, 0, 0.8]], 
       RowBox[{"1", ",", "4"}], "+"]}], "-", 
     SubsuperscriptBox[
      StyleBox["q",
       FontColor->RGBColor[0, 0, 0.8]], 
      RowBox[{"2", ",", "4"}], "+"]}], 
    SuperscriptBox[
     StyleBox["Q",
      FontColor->RGBColor[0.8, 0, 0]], "+"]]}], "}"}]], "Output",
 CellChangeTimes->{3.555795424955553*^9, 3.555846379026019*^9, 
  3.555865404488797*^9}]
}, Open  ]],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      FractionBox[
       RowBox[{
        RowBox[{
         SubscriptBox[
          StyleBox["q",
           FontColor->RGBColor[0, 0, 0.8]], "2"], " ", 
         SubsuperscriptBox[
          StyleBox["q",
           FontColor->RGBColor[0, 0, 0.8]], 
          RowBox[{"1", ",", "3"}], "+"]}], "-", 
        SubsuperscriptBox[
         StyleBox["q",
          FontColor->RGBColor[0, 0, 0.8]], 
         RowBox[{"1", ",", "4"}], "+"]}], 
       SuperscriptBox[
        StyleBox["Q",
         FontColor->RGBColor[{
            Rational[1, 2], 
            Rational[1, 2], 0}]], "+"]], ",", 
      FractionBox[
       RowBox[{
        RowBox[{
         SubscriptBox[
          StyleBox["q",
           FontColor->RGBColor[0, 0, 0.8]], "2"], " ", 
         SubsuperscriptBox[
          StyleBox["q",
           FontColor->RGBColor[0, 0, 0.8]], 
          RowBox[{"1", ",", "4"}], "+"]}], "-", 
        SubsuperscriptBox[
         StyleBox["q",
          FontColor->RGBColor[0, 0, 0.8]], 
         RowBox[{"2", ",", "4"}], "+"]}], 
       SuperscriptBox[
        StyleBox["Q",
         FontColor->RGBColor[{
            Rational[1, 2], 
            Rational[1, 2], 0}]], "+"]]}], "}"}], "/.", 
    RowBox[{
     SubscriptBox["q", "2"], "\[Rule]", 
     RowBox[{"(", 
      RowBox[{
       SubscriptBox["q", "2"], "/.", "largevolume"}], ")"}]}]}], "/.", 
   RowBox[{"x", "\[Rule]", "xh"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"tmp1", "=", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       RowBox[{
        FractionBox["1", "2"], 
        RowBox[{"(", 
         RowBox[{"#", "+", 
          RowBox[{"(", 
           RowBox[{"#", "/.", 
            RowBox[{"xh", "\[Rule]", 
             FractionBox["1", "xh"]}]}], ")"}]}], ")"}]}], "&"}], "[", 
      RowBox[{"Collect", "[", 
       RowBox[{
        RowBox[{"%", ".", 
         RowBox[{"Reverse", "[", 
          RowBox[{"%", "/.", "mconj"}], "]"}]}], ",", 
        RowBox[{"x$h", "[", "0", "]"}], ",", "Simplify"}], "]"}], "]"}], 
     ")"}], "/.", 
    RowBox[{"xh", "\[Rule]", "x"}]}]}], ";"}]}], "Input",
 CellChangeTimes->{{3.5537176604989758`*^9, 3.553717744590509*^9}, {
   3.555846443060206*^9, 3.555846449085281*^9}, 3.555846489707363*^9, 
   3.555846542585376*^9}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     FractionBox[
      RowBox[{
       RowBox[{
        SubscriptBox[
         StyleBox["q",
          FontColor->RGBColor[0, 0, 0.8]], "2"], " ", 
        SubsuperscriptBox[
         StyleBox["q",
          FontColor->RGBColor[0, 0, 0.8]], 
         RowBox[{"1", ",", "3"}], "+"]}], "-", 
       SubsuperscriptBox[
        StyleBox["q",
         FontColor->RGBColor[0, 0, 0.8]], 
        RowBox[{"1", ",", "4"}], "+"]}], 
      SuperscriptBox[
       StyleBox["Q",
        FontColor->RGBColor[{
           Rational[1, 2], 
           Rational[1, 2], 0}]], "+"]], ",", 
     FractionBox[
      RowBox[{
       RowBox[{
        SubscriptBox[
         StyleBox["q",
          FontColor->RGBColor[0, 0, 0.8]], "2"], " ", 
        SubsuperscriptBox[
         StyleBox["q",
          FontColor->RGBColor[0, 0, 0.8]], 
         RowBox[{"1", ",", "4"}], "+"]}], "-", 
       SubsuperscriptBox[
        StyleBox["q",
         FontColor->RGBColor[0, 0, 0.8]], 
        RowBox[{"2", ",", "4"}], "+"]}], 
      SuperscriptBox[
       StyleBox["Q",
        FontColor->RGBColor[{
           Rational[1, 2], 
           Rational[1, 2], 0}]], "+"]]}], "}"}], "/.", 
   RowBox[{
    SubscriptBox["q", "2"], "\[Rule]", 
    RowBox[{"(", 
     RowBox[{
      SubscriptBox["q", "2"], "/.", "largevolume"}], ")"}]}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"tmp2", "=", 
   RowBox[{"Collect", "[", 
    RowBox[{
     RowBox[{"%", ".", 
      RowBox[{"Reverse", "[", 
       RowBox[{"%", "/.", "mconj"}], "]"}]}], ",", 
     RowBox[{"x$", "[", "0", "]"}], ",", "Simplify"}], "]"}]}], 
  ";"}]}], "Input",
 CellChangeTimes->{{3.5537175653662157`*^9, 3.5537176379900637`*^9}, {
   3.553717736592239*^9, 3.5537177477637243`*^9}, 3.555846459854767*^9, {
   3.5558465197515078`*^9, 3.555846545611847*^9}}],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"tmpn", "=", 
  RowBox[{
   RowBox[{
    RowBox[{"Series", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"Collect", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"tmp2", "-", "tmp1"}], "/.", 
          RowBox[{"u", "\[Rule]", 
           RowBox[{"2", "g", " ", "z"}]}]}], ",", "x", ",", "Simplify"}], 
        "]"}], "//.", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"xxx", ":", 
          RowBox[{"(", 
           RowBox[{"Alternatives", "@@", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"Q0", "[", 
               RowBox[{"_", ":", "0"}], "]"}], ",", 
              RowBox[{"Q", "[", 
               RowBox[{"_", ":", "0"}], "]"}], ",", 
              SubscriptBox["\[Gamma]", "0"], ",", "x"}], "}"}]}], ")"}]}], 
         "\[RuleDelayed]", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{
            RowBox[{
             RowBox[{"xxx", "/.", "subQ0"}], "/.", "subJuk"}], "/.", 
            RowBox[{"leadweak", "[", "4", "]"}]}], "/.", 
           RowBox[{"u", "\[Rule]", 
            RowBox[{"2", "g", " ", "z"}]}]}], ")"}]}], ")"}]}], ",", 
      RowBox[{"{", 
       RowBox[{"g", ",", "0", ",", "5"}], "}"}]}], "]"}], "/.", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{
        RowBox[{"-", "\[ImaginaryI]"}], " ", "z"}], "+", 
       SqrtBox[
        RowBox[{"1", "-", 
         SuperscriptBox["z", "2"]}]]}], ")"}], "\[Rule]", 
     FractionBox["1", 
      RowBox[{
       RowBox[{
        RowBox[{"+", "\[ImaginaryI]"}], " ", "z"}], "+", 
       SqrtBox[
        RowBox[{"1", "-", 
         SuperscriptBox["z", "2"]}]]}]]}]}], "//", 
   "FullSimplify"}]}], "\[IndentingNewLine]", 
 RowBox[{"FreeQ", "[", 
  RowBox[{"%", ",", 
   SubscriptBox["\[Zeta]", "5"]}], "]"}]}], "Input",
 CellChangeTimes->{{3.555795530563179*^9, 3.555795563689238*^9}, 
   3.555795601710372*^9, {3.555795657885633*^9, 3.55579565808496*^9}, {
   3.5557956945773087`*^9, 3.5557957123028803`*^9}, {3.555846597396964*^9, 
   3.5558466069407263`*^9}}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
   RowBox[{"-", 
    FractionBox[
     RowBox[{"2", " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          RowBox[{"-", "1"}], "+", 
          SuperscriptBox["z", "2"]}], ")"}], " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{
           SubsuperscriptBox[
            StyleBox["q",
             FontColor->RGBColor[0, 0, 0.8]], 
            RowBox[{"1", ",", "4"}], "+"], " ", 
           SubsuperscriptBox[
            OverscriptBox[
             StyleBox["q",
              FontColor->RGBColor[0, 0, 0.8]], 
             StyleBox["_",
              FontColor->RGBColor[0, 0, 0.8]]], 
            RowBox[{"1", ",", "3"}], "-"]}], "+", 
          RowBox[{
           SubsuperscriptBox[
            StyleBox["q",
             FontColor->RGBColor[0, 0, 0.8]], 
            RowBox[{"1", ",", "3"}], "+"], " ", 
           SubsuperscriptBox[
            OverscriptBox[
             StyleBox["q",
              FontColor->RGBColor[0, 0, 0.8]], 
             StyleBox["_",
              FontColor->RGBColor[0, 0, 0.8]]], 
            RowBox[{"1", ",", "4"}], "-"]}]}], ")"}]}], ")"}]}], 
     SuperscriptBox["g", "2"]]}], "+", 
   FractionBox[
    RowBox[{"3", " ", 
     SqrtBox[
      RowBox[{"1", "-", 
       SuperscriptBox["z", "2"]}]], " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{
        SubsuperscriptBox[
         StyleBox["q",
          FontColor->RGBColor[0, 0, 0.8]], 
         RowBox[{"2", ",", "4"}], "+"], " ", 
        SubsuperscriptBox[
         OverscriptBox[
          StyleBox["q",
           FontColor->RGBColor[0, 0, 0.8]], 
          StyleBox["_",
           FontColor->RGBColor[0, 0, 0.8]]], 
         RowBox[{"1", ",", "3"}], "-"]}], "+", 
       RowBox[{"2", " ", 
        SubsuperscriptBox[
         StyleBox["q",
          FontColor->RGBColor[0, 0, 0.8]], 
         RowBox[{"1", ",", "4"}], "+"], " ", 
        SubsuperscriptBox[
         OverscriptBox[
          StyleBox["q",
           FontColor->RGBColor[0, 0, 0.8]], 
          StyleBox["_",
           FontColor->RGBColor[0, 0, 0.8]]], 
         RowBox[{"1", ",", "4"}], "-"]}], "+", 
       RowBox[{
        SubsuperscriptBox[
         StyleBox["q",
          FontColor->RGBColor[0, 0, 0.8]], 
         RowBox[{"1", ",", "3"}], "+"], " ", 
        SubsuperscriptBox[
         OverscriptBox[
          StyleBox["q",
           FontColor->RGBColor[0, 0, 0.8]], 
          StyleBox["_",
           FontColor->RGBColor[0, 0, 0.8]]], 
         RowBox[{"2", ",", "4"}], "-"]}]}], ")"}]}], "g"], "+", 
   RowBox[{"24", " ", 
    SuperscriptBox["z", "2"], " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"-", "1"}], "+", 
      SuperscriptBox["z", "2"]}], ")"}], " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       SubsuperscriptBox[
        StyleBox["q",
         FontColor->RGBColor[0, 0, 0.8]], 
        RowBox[{"1", ",", "4"}], "+"], " ", 
       SubsuperscriptBox[
        OverscriptBox[
         StyleBox["q",
          FontColor->RGBColor[0, 0, 0.8]], 
         StyleBox["_",
          FontColor->RGBColor[0, 0, 0.8]]], 
        RowBox[{"1", ",", "3"}], "-"]}], "+", 
      RowBox[{
       SubsuperscriptBox[
        StyleBox["q",
         FontColor->RGBColor[0, 0, 0.8]], 
        RowBox[{"1", ",", "3"}], "+"], " ", 
       SubsuperscriptBox[
        OverscriptBox[
         StyleBox["q",
          FontColor->RGBColor[0, 0, 0.8]], 
         StyleBox["_",
          FontColor->RGBColor[0, 0, 0.8]]], 
        RowBox[{"1", ",", "4"}], "-"]}]}], ")"}]}], "-", 
   RowBox[{"12", " ", 
    RowBox[{"(", 
     RowBox[{
      SqrtBox[
       RowBox[{"1", "-", 
        SuperscriptBox["z", "2"]}]], " ", 
      RowBox[{"(", 
       RowBox[{"1", "+", 
        RowBox[{"3", " ", 
         SuperscriptBox["z", "2"]}]}], ")"}], " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         SubsuperscriptBox[
          StyleBox["q",
           FontColor->RGBColor[0, 0, 0.8]], 
          RowBox[{"2", ",", "4"}], "+"], " ", 
         SubsuperscriptBox[
          OverscriptBox[
           StyleBox["q",
            FontColor->RGBColor[0, 0, 0.8]], 
           StyleBox["_",
            FontColor->RGBColor[0, 0, 0.8]]], 
          RowBox[{"1", ",", "3"}], "-"]}], "+", 
        RowBox[{"2", " ", 
         SubsuperscriptBox[
          StyleBox["q",
           FontColor->RGBColor[0, 0, 0.8]], 
          RowBox[{"1", ",", "4"}], "+"], " ", 
         SubsuperscriptBox[
          OverscriptBox[
           StyleBox["q",
            FontColor->RGBColor[0, 0, 0.8]], 
           StyleBox["_",
            FontColor->RGBColor[0, 0, 0.8]]], 
          RowBox[{"1", ",", "4"}], "-"]}], "+", 
        RowBox[{
         SubsuperscriptBox[
          StyleBox["q",
           FontColor->RGBColor[0, 0, 0.8]], 
          RowBox[{"1", ",", "3"}], "+"], " ", 
         SubsuperscriptBox[
          OverscriptBox[
           StyleBox["q",
            FontColor->RGBColor[0, 0, 0.8]], 
           StyleBox["_",
            FontColor->RGBColor[0, 0, 0.8]]], 
          RowBox[{"2", ",", "4"}], "-"]}]}], ")"}]}], ")"}], " ", "g"}], "-", 
   
   RowBox[{"24", " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"3", "-", 
        RowBox[{"19", " ", 
         SuperscriptBox["z", "2"]}], "+", 
        RowBox[{"16", " ", 
         SuperscriptBox["z", "4"]}]}], ")"}], " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         SubsuperscriptBox[
          StyleBox["q",
           FontColor->RGBColor[0, 0, 0.8]], 
          RowBox[{"1", ",", "4"}], "+"], " ", 
         SubsuperscriptBox[
          OverscriptBox[
           StyleBox["q",
            FontColor->RGBColor[0, 0, 0.8]], 
           StyleBox["_",
            FontColor->RGBColor[0, 0, 0.8]]], 
          RowBox[{"1", ",", "3"}], "-"]}], "+", 
        RowBox[{
         SubsuperscriptBox[
          StyleBox["q",
           FontColor->RGBColor[0, 0, 0.8]], 
          RowBox[{"1", ",", "3"}], "+"], " ", 
         SubsuperscriptBox[
          OverscriptBox[
           StyleBox["q",
            FontColor->RGBColor[0, 0, 0.8]], 
           StyleBox["_",
            FontColor->RGBColor[0, 0, 0.8]]], 
          RowBox[{"1", ",", "4"}], "-"]}]}], ")"}]}], ")"}], " ", 
    SuperscriptBox["g", "2"]}], "+", 
   RowBox[{"24", " ", 
    SqrtBox[
     RowBox[{"1", "-", 
      SuperscriptBox["z", "2"]}]], " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"-", "1"}], "+", 
      RowBox[{"30", " ", 
       SuperscriptBox["z", "2"]}]}], ")"}], " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       SubsuperscriptBox[
        StyleBox["q",
         FontColor->RGBColor[0, 0, 0.8]], 
        RowBox[{"2", ",", "4"}], "+"], " ", 
       SubsuperscriptBox[
        OverscriptBox[
         StyleBox["q",
          FontColor->RGBColor[0, 0, 0.8]], 
         StyleBox["_",
          FontColor->RGBColor[0, 0, 0.8]]], 
        RowBox[{"1", ",", "3"}], "-"]}], "+", 
      RowBox[{"2", " ", 
       SubsuperscriptBox[
        StyleBox["q",
         FontColor->RGBColor[0, 0, 0.8]], 
        RowBox[{"1", ",", "4"}], "+"], " ", 
       SubsuperscriptBox[
        OverscriptBox[
         StyleBox["q",
          FontColor->RGBColor[0, 0, 0.8]], 
         StyleBox["_",
          FontColor->RGBColor[0, 0, 0.8]]], 
        RowBox[{"1", ",", "4"}], "-"]}], "+", 
      RowBox[{
       SubsuperscriptBox[
        StyleBox["q",
         FontColor->RGBColor[0, 0, 0.8]], 
        RowBox[{"1", ",", "3"}], "+"], " ", 
       SubsuperscriptBox[
        OverscriptBox[
         StyleBox["q",
          FontColor->RGBColor[0, 0, 0.8]], 
         StyleBox["_",
          FontColor->RGBColor[0, 0, 0.8]]], 
        RowBox[{"2", ",", "4"}], "-"]}]}], ")"}], " ", 
    SuperscriptBox["g", "3"]}], "-", 
   RowBox[{"12", " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "57"}], "+", 
        RowBox[{
         SuperscriptBox["z", "2"], " ", 
         RowBox[{"(", 
          RowBox[{"161", "+", 
           RowBox[{"8", " ", 
            SuperscriptBox["z", "2"], " ", 
            RowBox[{"(", 
             RowBox[{"59", "+", 
              RowBox[{"36", " ", 
               SuperscriptBox["z", "2"], " ", 
               RowBox[{"(", 
                RowBox[{
                 RowBox[{"-", "3"}], "+", 
                 SuperscriptBox["z", "2"]}], ")"}]}]}], ")"}]}]}], ")"}]}]}], 
       ")"}], " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         SubsuperscriptBox[
          StyleBox["q",
           FontColor->RGBColor[0, 0, 0.8]], 
          RowBox[{"1", ",", "4"}], "+"], " ", 
         SubsuperscriptBox[
          OverscriptBox[
           StyleBox["q",
            FontColor->RGBColor[0, 0, 0.8]], 
           StyleBox["_",
            FontColor->RGBColor[0, 0, 0.8]]], 
          RowBox[{"1", ",", "3"}], "-"]}], "+", 
        RowBox[{
         SubsuperscriptBox[
          StyleBox["q",
           FontColor->RGBColor[0, 0, 0.8]], 
          RowBox[{"1", ",", "3"}], "+"], " ", 
         SubsuperscriptBox[
          OverscriptBox[
           StyleBox["q",
            FontColor->RGBColor[0, 0, 0.8]], 
           StyleBox["_",
            FontColor->RGBColor[0, 0, 0.8]]], 
          RowBox[{"1", ",", "4"}], "-"]}]}], ")"}]}], ")"}], " ", 
    SuperscriptBox["g", "4"]}], "+", 
   RowBox[{"3", " ", 
    SqrtBox[
     RowBox[{"1", "-", 
      SuperscriptBox["z", "2"]}]], " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       SubsuperscriptBox[
        StyleBox["q",
         FontColor->RGBColor[0, 0, 0.8]], 
        RowBox[{"2", ",", "4"}], "+"], " ", 
       SubsuperscriptBox[
        OverscriptBox[
         StyleBox["q",
          FontColor->RGBColor[0, 0, 0.8]], 
         StyleBox["_",
          FontColor->RGBColor[0, 0, 0.8]]], 
        RowBox[{"1", ",", "3"}], "-"]}], "+", 
      RowBox[{"2", " ", 
       SubsuperscriptBox[
        StyleBox["q",
         FontColor->RGBColor[0, 0, 0.8]], 
        RowBox[{"1", ",", "4"}], "+"], " ", 
       SubsuperscriptBox[
        OverscriptBox[
         StyleBox["q",
          FontColor->RGBColor[0, 0, 0.8]], 
         StyleBox["_",
          FontColor->RGBColor[0, 0, 0.8]]], 
        RowBox[{"1", ",", "4"}], "-"]}], "+", 
      RowBox[{
       SubsuperscriptBox[
        StyleBox["q",
         FontColor->RGBColor[0, 0, 0.8]], 
        RowBox[{"1", ",", "3"}], "+"], " ", 
       SubsuperscriptBox[
        OverscriptBox[
         StyleBox["q",
          FontColor->RGBColor[0, 0, 0.8]], 
         StyleBox["_",
          FontColor->RGBColor[0, 0, 0.8]]], 
        RowBox[{"2", ",", "4"}], "-"]}]}], ")"}], " ", 
    RowBox[{"(", 
     RowBox[{"251", "+", 
      RowBox[{"1728", " ", 
       SuperscriptBox["z", "2"], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", "1"}], "-", 
         RowBox[{"2", " ", 
          SuperscriptBox["z", "2"]}], "+", 
         SuperscriptBox["z", "4"]}], ")"}]}], "-", 
      RowBox[{"24", " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "3"]}]}], ")"}], " ", 
    SuperscriptBox["g", "5"]}], "+", 
   InterpretationBox[
    SuperscriptBox[
     RowBox[{"O", "[", "g", "]"}], "6"],
    SeriesData[$CellContext`g, 0, {}, -2, 6, 1],
    Editable->False]}],
  SeriesData[$CellContext`g, 
   0, {(-2) (-1 + $CellContext`z^2) ($CellContext`q$[1, 4][
       1] $CellContext`q$b[1, 3][-1] + $CellContext`q$[1, 3][
       1] $CellContext`q$b[1, 4][-1]), 
    3 (1 - $CellContext`z^2)^
     Rational[1, 2] ($CellContext`q$[2, 4][1] $CellContext`q$b[1, 3][-1] + 
     2 $CellContext`q$[1, 4][1] $CellContext`q$b[1, 4][-1] + $CellContext`q$[
       1, 3][1] $CellContext`q$b[2, 4][-1]), 
    24 $CellContext`z^2 (-1 + $CellContext`z^2) ($CellContext`q$[1, 4][
       1] $CellContext`q$b[1, 3][-1] + $CellContext`q$[1, 3][
       1] $CellContext`q$b[1, 4][-1]), (-12) (1 - $CellContext`z^2)^
     Rational[1, 2] (1 + 
     3 $CellContext`z^2) ($CellContext`q$[2, 4][1] $CellContext`q$b[1, 3][-1] + 
     2 $CellContext`q$[1, 4][1] $CellContext`q$b[1, 4][-1] + $CellContext`q$[
       1, 3][1] $CellContext`q$b[2, 4][-1]), (-24) (3 - 19 $CellContext`z^2 + 
     16 $CellContext`z^4) ($CellContext`q$[1, 4][1] $CellContext`q$b[
       1, 3][-1] + $CellContext`q$[1, 3][1] $CellContext`q$b[1, 4][-1]), 
    24 (1 - $CellContext`z^2)^Rational[1, 2] (-1 + 
     30 $CellContext`z^2) ($CellContext`q$[2, 4][1] $CellContext`q$b[
       1, 3][-1] + 
     2 $CellContext`q$[1, 4][1] $CellContext`q$b[1, 4][-1] + $CellContext`q$[
       1, 3][1] $CellContext`q$b[2, 4][-1]), (-12) (-57 + $CellContext`z^2 (
       161 + 8 $CellContext`z^2 (59 + 
         36 $CellContext`z^2 (-3 + $CellContext`z^2)))) ($CellContext`q$[
       1, 4][1] $CellContext`q$b[1, 3][-1] + $CellContext`q$[1, 3][
       1] $CellContext`q$b[1, 4][-1]), 
    3 (1 - $CellContext`z^2)^
     Rational[1, 2] ($CellContext`q$[2, 4][1] $CellContext`q$b[1, 3][-1] + 
     2 $CellContext`q$[1, 4][1] $CellContext`q$b[1, 4][-1] + $CellContext`q$[
       1, 3][1] $CellContext`q$b[2, 4][-1]) (251 + 
     1728 $CellContext`z^2 (-1 - 2 $CellContext`z^2 + $CellContext`z^4) - 
     24 $CellContext`\[Zeta]$[3][0])}, -2, 6, 1],
  Editable->False]], "Output",
 CellChangeTimes->{{3.555795534904286*^9, 3.555795564581017*^9}, 
   3.555795602667741*^9, 3.5557956589276114`*^9, {3.555795703668861*^9, 
   3.555795714206608*^9}, 3.555798321123605*^9, {3.555846589721546*^9, 
   3.5558466109013844`*^9}, {3.5558649473557043`*^9, 3.5558649579350243`*^9}, 
   3.555865415784535*^9, 3.555865741313086*^9, 3.56485525545081*^9}],

Cell[BoxData["True"], "Output",
 CellChangeTimes->{{3.555795534904286*^9, 3.555795564581017*^9}, 
   3.555795602667741*^9, 3.5557956589276114`*^9, {3.555795703668861*^9, 
   3.555795714206608*^9}, 3.555798321123605*^9, {3.555846589721546*^9, 
   3.5558466109013844`*^9}, {3.5558649473557043`*^9, 3.5558649579350243`*^9}, 
   3.555865415784535*^9, 3.555865741313086*^9, 3.564855255482885*^9}]
}, Open  ]],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"Series", "[", 
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{"Normal", "[", "tmpn", "]"}], "/.", 
         RowBox[{"leadweak", "[", "4", "]"}]}], "/.", "subQ0"}], "/.", 
       RowBox[{"u", "\[Rule]", 
        RowBox[{"2", " ", "g", " ", "z"}]}]}], ",", 
      RowBox[{"{", 
       RowBox[{"g", ",", "0", ",", "13"}], "}"}]}], "]"}], "//", "Simplify"}],
    "//", "Normal"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Wtmprlt", "=", 
   RowBox[{
    RowBox[{
     RowBox[{"Collect", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"#", "//.", "subZetaReduce"}], "//", "Expand"}], ",", 
       RowBox[{"{", 
        RowBox[{
         SqrtBox[
          RowBox[{"1", "-", 
           SuperscriptBox["z", "2"]}]], ",", "z", ",", "\[Zeta]list"}], "}"}],
        ",", "Simplify"}], "]"}], "&"}], "/@", 
    RowBox[{"(", 
     RowBox[{"%", "/.", 
      RowBox[{"TaylorOptions", "[", 
       RowBox[{
        RowBox[{"Variable", "\[Rule]", "g"}], ",", 
        RowBox[{"\[Eta]Factor", "\[Rule]", 
         RowBox[{"2", "z"}]}], ",", 
        RowBox[{"Order", "\[Rule]", "13"}]}], "]"}]}], ")"}]}]}], 
  ";"}]}], "Input",
 CellChangeTimes->{{3.555795944097809*^9, 3.555795971026029*^9}, {
   3.555796052923943*^9, 3.5557960606596622`*^9}, {3.5557961001069202`*^9, 
   3.555796155570109*^9}, {3.555796187716881*^9, 3.555796232307411*^9}, {
   3.555796333638373*^9, 3.555796363578953*^9}, {3.555798344011282*^9, 
   3.5557983498166037`*^9}, {3.555846682542*^9, 3.5558466837012043`*^9}, {
   3.5558467140046043`*^9, 3.555846720491535*^9}, 3.555865843413024*^9}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Tc\[Rho]2Wcontr", "=", 
  RowBox[{"Collect", "[", 
   RowBox[{
    RowBox[{"Normal", "@", 
     RowBox[{"Series", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"(", 
         RowBox[{"-", 
          FractionBox[
           RowBox[{"3", " ", "g", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "1"}], "+", 
              RowBox[{"4", " ", 
               SuperscriptBox["g", "2"]}], "-", 
              RowBox[{"28", " ", 
               SuperscriptBox["g", "4"]}], "+", 
              RowBox[{
               SuperscriptBox["g", "6"], " ", 
               RowBox[{"(", 
                RowBox[{"235", "+", 
                 RowBox[{"24", " ", 
                  SubscriptBox[
                   StyleBox["\[Zeta]",
                    FontWeight->Bold,
                    FontColor->GrayLevel[0.4]], "3"]}]}], ")"}]}]}], ")"}]}], 
           
           SqrtBox[
            RowBox[{"1", "-", 
             SuperscriptBox["z", "2"]}]]]}], ")"}], "Wtmprlt"}], ",", 
       RowBox[{"{", 
        RowBox[{"g", ",", "0", ",", "13"}], "}"}]}], "]"}]}], ",", 
    RowBox[{"{", 
     RowBox[{"g", ",", 
      SqrtBox[
       RowBox[{"1", "-", 
        SuperscriptBox["z", "2"]}]], ",", "z", ",", "\[Zeta]list"}], "}"}], 
    ",", "Simplify"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.553718702053146*^9, 3.553718718510997*^9}, {
   3.555796390907897*^9, 3.5557964444559193`*^9}, {3.5557965968486557`*^9, 
   3.5557966014006968`*^9}, 3.555846810321102*^9, 3.555865445498835*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   FractionBox["36", "5"], " ", 
   SuperscriptBox["g", "8"], " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"-", "45"}], "+", 
     RowBox[{"90", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2"]}], "-", 
     RowBox[{"36", " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2", "2"]}], "+", 
     RowBox[{"4", " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2", "3"]}], "-", 
     RowBox[{"30", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3"]}], "+", 
     RowBox[{"10", " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3", "2"]}]}], ")"}]}], "+", 
  FractionBox[
   RowBox[{"3", " ", 
    SuperscriptBox["g", "7"], " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       RowBox[{"-", "12"}], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", "3"}], "+", 
         RowBox[{"2", " ", 
          SubscriptBox[
           StyleBox["\[Zeta]",
            FontWeight->Bold,
            FontColor->GrayLevel[0.4]], "2"]}]}], ")"}], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", "3"}], "+", 
         RowBox[{"2", " ", 
          SubscriptBox[
           StyleBox["\[Zeta]",
            FontWeight->Bold,
            FontColor->GrayLevel[0.4]], "3"]}]}], ")"}]}], "+", 
      RowBox[{"12", " ", 
       SuperscriptBox["z", "2"], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", "3"}], "+", 
         RowBox[{"2", " ", 
          SubscriptBox[
           StyleBox["\[Zeta]",
            FontWeight->Bold,
            FontColor->GrayLevel[0.4]], "2"]}]}], ")"}], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", "3"}], "+", 
         RowBox[{"2", " ", 
          SubscriptBox[
           StyleBox["\[Zeta]",
            FontWeight->Bold,
            FontColor->GrayLevel[0.4]], "3"]}]}], ")"}]}]}], ")"}]}], 
   SqrtBox[
    RowBox[{"1", "-", 
     SuperscriptBox["z", "2"]}]]], "+", 
  RowBox[{
   FractionBox["1", 
    RowBox[{"5", " ", 
     SqrtBox[
      RowBox[{"1", "-", 
       SuperscriptBox["z", "2"]}]]}]], 
   RowBox[{"36", " ", 
    SuperscriptBox["g", "9"], " ", 
    RowBox[{"(", 
     RowBox[{"1125", "-", 
      RowBox[{"585", " ", 
       SuperscriptBox["z", "2"]}], "-", 
      RowBox[{"540", " ", 
       SuperscriptBox["z", "4"]}], "-", 
      RowBox[{"270", " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "2"]}], "-", 
      RowBox[{"450", " ", 
       SuperscriptBox["z", "2"], " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "2"]}], "+", 
      RowBox[{"720", " ", 
       SuperscriptBox["z", "4"], " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "2"]}], "-", 
      RowBox[{"132", " ", 
       SubsuperscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "2", "2"]}], "+", 
      RowBox[{"132", " ", 
       SuperscriptBox["z", "2"], " ", 
       SubsuperscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "2", "2"]}], "+", 
      RowBox[{"72", " ", 
       SubsuperscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "2", "3"]}], "-", 
      RowBox[{"72", " ", 
       SuperscriptBox["z", "2"], " ", 
       SubsuperscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "2", "3"]}], "-", 
      RowBox[{"990", " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "3"]}], "+", 
      RowBox[{"1710", " ", 
       SuperscriptBox["z", "2"], " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "3"]}], "-", 
      RowBox[{"720", " ", 
       SuperscriptBox["z", "4"], " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "3"]}], "-", 
      RowBox[{"20", " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "2"], " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "3"]}], "+", 
      RowBox[{"20", " ", 
       SuperscriptBox["z", "2"], " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "2"], " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "3"]}], "+", 
      RowBox[{"16", " ", 
       SubsuperscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "2", "2"], " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "3"]}], "-", 
      RowBox[{"112", " ", 
       SuperscriptBox["z", "2"], " ", 
       SubsuperscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "2", "2"], " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "3"]}], "+", 
      RowBox[{"96", " ", 
       SuperscriptBox["z", "4"], " ", 
       SubsuperscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "2", "2"], " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "3"]}], "+", 
      RowBox[{"360", " ", 
       SubsuperscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "3", "2"]}], "-", 
      RowBox[{"360", " ", 
       SuperscriptBox["z", "2"], " ", 
       SubsuperscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "3", "2"]}], "-", 
      RowBox[{"90", " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "5"]}], "-", 
      RowBox[{"630", " ", 
       SuperscriptBox["z", "2"], " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "5"]}], "+", 
      RowBox[{"720", " ", 
       SuperscriptBox["z", "4"], " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "5"]}], "+", 
      RowBox[{"60", " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "2"], " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "5"]}], "+", 
      RowBox[{"420", " ", 
       SuperscriptBox["z", "2"], " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "2"], " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "5"]}], "-", 
      RowBox[{"480", " ", 
       SuperscriptBox["z", "4"], " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "2"], " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "5"]}]}], ")"}]}]}], "-", 
  RowBox[{
   FractionBox["144", "175"], " ", 
   SuperscriptBox["g", "10"], " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"-", "15750"}], "+", 
     RowBox[{"4725", " ", 
      SuperscriptBox["z", "2"]}], "+", 
     RowBox[{"12600", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2"]}], "-", 
     RowBox[{"945", " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2", "2"]}], "+", 
     RowBox[{"7560", " ", 
      SuperscriptBox["z", "2"], " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2", "2"]}], "-", 
     RowBox[{"680", " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2", "3"]}], "-", 
     RowBox[{"3720", " ", 
      SuperscriptBox["z", "2"], " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2", "3"]}], "+", 
     RowBox[{"108", " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2", "4"]}], "+", 
     RowBox[{"464", " ", 
      SuperscriptBox["z", "2"], " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2", "4"]}], "+", 
     RowBox[{"12600", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3"]}], "-", 
     RowBox[{"12600", " ", 
      SuperscriptBox["z", "2"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3"]}], "-", 
     RowBox[{"7875", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3"]}], "+", 
     RowBox[{"210", " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2", "2"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3"]}], "-", 
     RowBox[{"350", " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3", "2"]}], "+", 
     RowBox[{"4200", " ", 
      SuperscriptBox["z", "2"], " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3", "2"]}], "-", 
     RowBox[{"4725", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "5"]}], "-", 
     RowBox[{"4200", " ", 
      SuperscriptBox["z", "2"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "5"]}], "+", 
     RowBox[{"2625", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "5"]}], "+", 
     RowBox[{"525", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "5"]}], "+", 
     RowBox[{"1400", " ", 
      SuperscriptBox["z", "2"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "5"]}]}], ")"}]}], "-", 
  RowBox[{
   FractionBox["1", 
    RowBox[{"175", " ", 
     SqrtBox[
      RowBox[{"1", "-", 
       SuperscriptBox["z", "2"]}]]}]], 
   RowBox[{"36", " ", 
    SuperscriptBox["g", "11"], " ", 
    RowBox[{"(", 
     RowBox[{"653625", "+", 
      RowBox[{"121275", " ", 
       SuperscriptBox["z", "2"]}], "-", 
      RowBox[{"774900", " ", 
       SuperscriptBox["z", "4"]}], "-", 
      RowBox[{"22050", " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "2"]}], "-", 
      RowBox[{"456750", " ", 
       SuperscriptBox["z", "2"], " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "2"]}], "+", 
      RowBox[{"327600", " ", 
       SuperscriptBox["z", "4"], " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "2"]}], "+", 
      RowBox[{"151200", " ", 
       SuperscriptBox["z", "6"], " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "2"]}], "-", 
      RowBox[{"177660", " ", 
       SubsuperscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "2", "2"]}], "+", 
      RowBox[{"414540", " ", 
       SuperscriptBox["z", "2"], " ", 
       SubsuperscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "2", "2"]}], "-", 
      RowBox[{"418320", " ", 
       SuperscriptBox["z", "4"], " ", 
       SubsuperscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "2", "2"]}], "+", 
      RowBox[{"181440", " ", 
       SuperscriptBox["z", "6"], " ", 
       SubsuperscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "2", "2"]}], "-", 
      RowBox[{"4440", " ", 
       SubsuperscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "2", "3"]}], "-", 
      RowBox[{"57960", " ", 
       SuperscriptBox["z", "2"], " ", 
       SubsuperscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "2", "3"]}], "+", 
      RowBox[{"81600", " ", 
       SuperscriptBox["z", "4"], " ", 
       SubsuperscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "2", "3"]}], "-", 
      RowBox[{"19200", " ", 
       SuperscriptBox["z", "6"], " ", 
       SubsuperscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "2", "3"]}], "+", 
      RowBox[{"9216", " ", 
       SubsuperscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "2", "4"]}], "-", 
      RowBox[{"3072", " ", 
       SuperscriptBox["z", "2"], " ", 
       SubsuperscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "2", "4"]}], "-", 
      RowBox[{"6144", " ", 
       SuperscriptBox["z", "4"], " ", 
       SubsuperscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "2", "4"]}], "-", 
      RowBox[{"349650", " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "3"]}], "-", 
      RowBox[{"78750", " ", 
       SuperscriptBox["z", "2"], " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "3"]}], "+", 
      RowBox[{"882000", " ", 
       SuperscriptBox["z", "4"], " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "3"]}], "-", 
      RowBox[{"453600", " ", 
       SuperscriptBox["z", "6"], " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "3"]}], "-", 
      RowBox[{"44100", " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "2"], " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "3"]}], "+", 
      RowBox[{"94500", " ", 
       SuperscriptBox["z", "2"], " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "2"], " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "3"]}], "-", 
      RowBox[{"50400", " ", 
       SuperscriptBox["z", "4"], " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "2"], " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "3"]}], "+", 
      RowBox[{"110320", " ", 
       SubsuperscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "2", "2"], " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "3"]}], "-", 
      RowBox[{"106960", " ", 
       SuperscriptBox["z", "2"], " ", 
       SubsuperscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "2", "2"], " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "3"]}], "-", 
      RowBox[{"3360", " ", 
       SuperscriptBox["z", "4"], " ", 
       SubsuperscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "2", "2"], " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "3"]}], "+", 
      RowBox[{"800", " ", 
       SubsuperscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "2", "3"], " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "3"]}], "-", 
      RowBox[{"7200", " ", 
       SuperscriptBox["z", "2"], " ", 
       SubsuperscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "2", "3"], " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "3"]}], "-", 
      RowBox[{"32000", " ", 
       SuperscriptBox["z", "4"], " ", 
       SubsuperscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "2", "3"], " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "3"]}], "+", 
      RowBox[{"38400", " ", 
       SuperscriptBox["z", "6"], " ", 
       SubsuperscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "2", "3"], " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "3"]}], "+", 
      RowBox[{"75600", " ", 
       SuperscriptBox["z", "2"], " ", 
       SubsuperscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "3", "2"]}], "-", 
      RowBox[{"75600", " ", 
       SuperscriptBox["z", "4"], " ", 
       SubsuperscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "3", "2"]}], "-", 
      RowBox[{"8400", " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "2"], " ", 
       SubsuperscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "3", "2"]}], "-", 
      RowBox[{"8400", " ", 
       SuperscriptBox["z", "2"], " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "2"], " ", 
       SubsuperscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "3", "2"]}], "+", 
      RowBox[{"16800", " ", 
       SuperscriptBox["z", "4"], " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "2"], " ", 
       SubsuperscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "3", "2"]}], "-", 
      RowBox[{"229950", " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "5"]}], "-", 
      RowBox[{"47250", " ", 
       SuperscriptBox["z", "2"], " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "5"]}], "+", 
      RowBox[{"478800", " ", 
       SuperscriptBox["z", "4"], " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "5"]}], "-", 
      RowBox[{"201600", " ", 
       SuperscriptBox["z", "6"], " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "5"]}], "+", 
      RowBox[{"35700", " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "2"], " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "5"]}], "-", 
      RowBox[{"52500", " ", 
       SuperscriptBox["z", "2"], " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "2"], " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "5"]}], "+", 
      RowBox[{"16800", " ", 
       SuperscriptBox["z", "4"], " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "2"], " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "5"]}], "+", 
      RowBox[{"1680", " ", 
       SubsuperscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "2", "2"], " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "5"]}], "-", 
      RowBox[{"5040", " ", 
       SuperscriptBox["z", "2"], " ", 
       SubsuperscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "2", "2"], " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "5"]}], "+", 
      RowBox[{"30240", " ", 
       SuperscriptBox["z", "4"], " ", 
       SubsuperscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "2", "2"], " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "5"]}], "-", 
      RowBox[{"26880", " ", 
       SuperscriptBox["z", "6"], " ", 
       SubsuperscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "2", "2"], " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "5"]}], "+", 
      RowBox[{"121800", " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "3"], " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "5"]}], "+", 
      RowBox[{"96600", " ", 
       SuperscriptBox["z", "2"], " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "3"], " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "5"]}], "-", 
      RowBox[{"218400", " ", 
       SuperscriptBox["z", "4"], " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "3"], " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "5"]}], "-", 
      RowBox[{"9450", " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "7"]}], "-", 
      RowBox[{"179550", " ", 
       SuperscriptBox["z", "2"], " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "7"]}], "-", 
      RowBox[{"63000", " ", 
       SuperscriptBox["z", "4"], " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "7"]}], "+", 
      RowBox[{"252000", " ", 
       SuperscriptBox["z", "6"], " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "7"]}], "+", 
      RowBox[{"6300", " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "2"], " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "7"]}], "+", 
      RowBox[{"119700", " ", 
       SuperscriptBox["z", "2"], " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "2"], " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "7"]}], "+", 
      RowBox[{"42000", " ", 
       SuperscriptBox["z", "4"], " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "2"], " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "7"]}], "-", 
      RowBox[{"168000", " ", 
       SuperscriptBox["z", "6"], " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "2"], " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "7"]}]}], ")"}]}]}], "+", 
  RowBox[{
   FractionBox["72", "175"], " ", 
   SuperscriptBox["g", "12"], " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"-", "711900"}], "+", 
     RowBox[{"75600", " ", 
      SuperscriptBox["z", "2"]}], "+", 
     RowBox[{"226800", " ", 
      SuperscriptBox["z", "4"]}], "+", 
     RowBox[{"242550", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2"]}], "+", 
     RowBox[{"226800", " ", 
      SuperscriptBox["z", "2"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2"]}], "-", 
     RowBox[{"226800", " ", 
      SuperscriptBox["z", "4"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2"]}], "+", 
     RowBox[{"187110", " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2", "2"]}], "+", 
     RowBox[{"52920", " ", 
      SuperscriptBox["z", "2"], " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2", "2"]}], "+", 
     RowBox[{"105840", " ", 
      SuperscriptBox["z", "4"], " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2", "2"]}], "-", 
     RowBox[{"120780", " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2", "3"]}], "+", 
     RowBox[{"4800", " ", 
      SuperscriptBox["z", "2"], " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2", "3"]}], "+", 
     RowBox[{"86400", " ", 
      SuperscriptBox["z", "4"], " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2", "3"]}], "+", 
     RowBox[{"13236", " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2", "4"]}], "-", 
     RowBox[{"39040", " ", 
      SuperscriptBox["z", "2"], " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2", "4"]}], "-", 
     RowBox[{"51456", " ", 
      SuperscriptBox["z", "4"], " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2", "4"]}], "+", 
     RowBox[{"544", " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2", "5"]}], "+", 
     RowBox[{"5632", " ", 
      SuperscriptBox["z", "2"], " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2", "5"]}], "+", 
     RowBox[{"7040", " ", 
      SuperscriptBox["z", "4"], " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2", "5"]}], "+", 
     RowBox[{"519750", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3"]}], "-", 
     RowBox[{"478800", " ", 
      SuperscriptBox["z", "2"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3"]}], "+", 
     RowBox[{"75600", " ", 
      SuperscriptBox["z", "4"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3"]}], "-", 
     RowBox[{"25200", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3"]}], "-", 
     RowBox[{"75600", " ", 
      SuperscriptBox["z", "2"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3"]}], "+", 
     RowBox[{"10080", " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2", "2"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3"]}], "+", 
     RowBox[{"40320", " ", 
      SuperscriptBox["z", "2"], " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2", "2"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3"]}], "+", 
     RowBox[{"1440", " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2", "3"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3"]}], "+", 
     RowBox[{"11840", " ", 
      SuperscriptBox["z", "2"], " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2", "3"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3"]}], "-", 
     RowBox[{"166950", " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3", "2"]}], "+", 
     RowBox[{"25200", " ", 
      SuperscriptBox["z", "2"], " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3", "2"]}], "-", 
     RowBox[{"56700", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2"], " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3", "2"]}], "+", 
     RowBox[{"4200", " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3", "3"]}], "+", 
     RowBox[{"8400", " ", 
      SuperscriptBox["z", "2"], " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3", "3"]}], "+", 
     RowBox[{"25200", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "5"]}], "+", 
     RowBox[{"315000", " ", 
      SuperscriptBox["z", "2"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "5"]}], "-", 
     RowBox[{"453600", " ", 
      SuperscriptBox["z", "4"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "5"]}], "-", 
     RowBox[{"81900", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "5"]}], "-", 
     RowBox[{"126000", " ", 
      SuperscriptBox["z", "2"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "5"]}], "-", 
     RowBox[{"13020", " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2", "2"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "5"]}], "-", 
     RowBox[{"23520", " ", 
      SuperscriptBox["z", "2"], " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2", "2"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "5"]}], "+", 
     RowBox[{"109200", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "5"]}], "+", 
     RowBox[{"56000", " ", 
      SuperscriptBox["z", "2"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "5"]}], "+", 
     RowBox[{"134400", " ", 
      SuperscriptBox["z", "4"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "5"]}], "+", 
     RowBox[{"1575", " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "5", "2"]}], "+", 
     RowBox[{"2800", " ", 
      SuperscriptBox["z", "2"], " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "5", "2"]}], "+", 
     RowBox[{"56000", " ", 
      SuperscriptBox["z", "4"], " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "5", "2"]}], "-", 
     RowBox[{"103950", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "7"]}], "-", 
     RowBox[{"201600", " ", 
      SuperscriptBox["z", "2"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "7"]}], "-", 
     RowBox[{"42000", " ", 
      SuperscriptBox["z", "4"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "7"]}], "+", 
     RowBox[{"66150", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "7"]}], "+", 
     RowBox[{"88200", " ", 
      SuperscriptBox["z", "2"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "7"]}], "+", 
     RowBox[{"3150", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "7"]}], "+", 
     RowBox[{"29400", " ", 
      SuperscriptBox["z", "2"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "7"]}], "-", 
     RowBox[{"28000", " ", 
      SuperscriptBox["z", "4"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "7"]}]}], ")"}]}], "+", 
  RowBox[{
   FractionBox["1", 
    RowBox[{"175", " ", 
     SqrtBox[
      RowBox[{"1", "-", 
       SuperscriptBox["z", "2"]}]]}]], 
   RowBox[{"72", " ", 
    SuperscriptBox["g", "13"], " ", 
    RowBox[{"(", 
     RowBox[{"4594275", "+", 
      RowBox[{"3939075", " ", 
       SuperscriptBox["z", "2"]}], "-", 
      RowBox[{"5811750", " ", 
       SuperscriptBox["z", "4"]}], "-", 
      RowBox[{"4082400", " ", 
       SuperscriptBox["z", "6"]}], "+", 
      RowBox[{"1360800", " ", 
       SuperscriptBox["z", "8"]}], "+", 
      RowBox[{"445200", " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "2"]}], "-", 
      RowBox[{"2461200", " ", 
       SuperscriptBox["z", "2"], " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "2"]}], "-", 
      RowBox[{"1990800", " ", 
       SuperscriptBox["z", "4"], " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "2"]}], "+", 
      RowBox[{"4914000", " ", 
       SuperscriptBox["z", "6"], " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "2"]}], "-", 
      RowBox[{"907200", " ", 
       SuperscriptBox["z", "8"], " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "2"]}], "-", 
      RowBox[{"1333710", " ", 
       SubsuperscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "2", "2"]}], "+", 
      RowBox[{"2011590", " ", 
       SuperscriptBox["z", "2"], " ", 
       SubsuperscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "2", "2"]}], "-", 
      RowBox[{"466200", " ", 
       SuperscriptBox["z", "4"], " ", 
       SubsuperscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "2", "2"]}], "-", 
      RowBox[{"1300320", " ", 
       SuperscriptBox["z", "6"], " ", 
       SubsuperscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "2", "2"]}], "+", 
      RowBox[{"1088640", " ", 
       SuperscriptBox["z", "8"], " ", 
       SubsuperscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "2", "2"]}], "-", 
      RowBox[{"300060", " ", 
       SubsuperscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "2", "3"]}], "-", 
      RowBox[{"12420", " ", 
       SuperscriptBox["z", "2"], " ", 
       SubsuperscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "2", "3"]}], "+", 
      RowBox[{"779040", " ", 
       SuperscriptBox["z", "4"], " ", 
       SubsuperscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "2", "3"]}], "-", 
      RowBox[{"927360", " ", 
       SuperscriptBox["z", "6"], " ", 
       SubsuperscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "2", "3"]}], "+", 
      RowBox[{"460800", " ", 
       SuperscriptBox["z", "8"], " ", 
       SubsuperscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "2", "3"]}], "+", 
      RowBox[{"143604", " ", 
       SubsuperscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "2", "4"]}], "-", 
      RowBox[{"404388", " ", 
       SuperscriptBox["z", "2"], " ", 
       SubsuperscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "2", "4"]}], "+", 
      RowBox[{"233712", " ", 
       SuperscriptBox["z", "4"], " ", 
       SubsuperscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "2", "4"]}], "+", 
      RowBox[{"91584", " ", 
       SuperscriptBox["z", "6"], " ", 
       SubsuperscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "2", "4"]}], "-", 
      RowBox[{"64512", " ", 
       SuperscriptBox["z", "8"], " ", 
       SubsuperscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "2", "4"]}], "+", 
      RowBox[{"10152", " ", 
       SubsuperscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "2", "5"]}], "+", 
      RowBox[{"79992", " ", 
       SuperscriptBox["z", "2"], " ", 
       SubsuperscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "2", "5"]}], "-", 
      RowBox[{"192672", " ", 
       SuperscriptBox["z", "4"], " ", 
       SubsuperscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "2", "5"]}], "+", 
      RowBox[{"102528", " ", 
       SuperscriptBox["z", "6"], " ", 
       SubsuperscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "2", "5"]}], "-", 
      RowBox[{"493500", " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "3"]}], "-", 
      RowBox[{"7242900", " ", 
       SuperscriptBox["z", "2"], " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "3"]}], "+", 
      RowBox[{"10684800", " ", 
       SuperscriptBox["z", "4"], " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "3"]}], "-", 
      RowBox[{"2041200", " ", 
       SuperscriptBox["z", "6"], " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "3"]}], "-", 
      RowBox[{"907200", " ", 
       SuperscriptBox["z", "8"], " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "3"]}], "-", 
      RowBox[{"721000", " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "2"], " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "3"]}], "+", 
      RowBox[{"1048600", " ", 
       SuperscriptBox["z", "2"], " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "2"], " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "3"]}], "+", 
      RowBox[{"277200", " ", 
       SuperscriptBox["z", "4"], " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "2"], " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "3"]}], "-", 
      RowBox[{"604800", " ", 
       SuperscriptBox["z", "6"], " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "2"], " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "3"]}], "+", 
      RowBox[{"322560", " ", 
       SubsuperscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "2", "2"], " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "3"]}], "-", 
      RowBox[{"45360", " ", 
       SuperscriptBox["z", "2"], " ", 
       SubsuperscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "2", "2"], " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "3"]}], "-", 
      RowBox[{"277200", " ", 
       SuperscriptBox["z", "4"], " ", 
       SubsuperscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "2", "2"], " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "3"]}], "+", 
      RowBox[{"107840", " ", 
       SubsuperscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "2", "3"], " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "3"]}], "+", 
      RowBox[{"274560", " ", 
       SuperscriptBox["z", "2"], " ", 
       SubsuperscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "2", "3"], " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "3"]}], "-", 
      RowBox[{"363200", " ", 
       SuperscriptBox["z", "4"], " ", 
       SubsuperscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "2", "3"], " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "3"]}], "-", 
      RowBox[{"19200", " ", 
       SuperscriptBox["z", "6"], " ", 
       SubsuperscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "2", "3"], " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "3"]}], "+", 
      RowBox[{"672", " ", 
       SubsuperscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "2", "4"], " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "3"]}], "-", 
      RowBox[{"4704", " ", 
       SuperscriptBox["z", "2"], " ", 
       SubsuperscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "2", "4"], " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "3"]}], "-", 
      RowBox[{"103488", " ", 
       SuperscriptBox["z", "4"], " ", 
       SubsuperscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "2", "4"], " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "3"]}], "+", 
      RowBox[{"107520", " ", 
       SuperscriptBox["z", "8"], " ", 
       SubsuperscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "2", "4"], " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "3"]}], "-", 
      RowBox[{"926100", " ", 
       SubsuperscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "3", "2"]}], "+", 
      RowBox[{"2627100", " ", 
       SuperscriptBox["z", "2"], " ", 
       SubsuperscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "3", "2"]}], "-", 
      RowBox[{"2608200", " ", 
       SuperscriptBox["z", "4"], " ", 
       SubsuperscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "3", "2"]}], "+", 
      RowBox[{"907200", " ", 
       SuperscriptBox["z", "6"], " ", 
       SubsuperscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "3", "2"]}], "+", 
      RowBox[{"218400", " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "2"], " ", 
       SubsuperscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "3", "2"]}], "-", 
      RowBox[{"243600", " ", 
       SuperscriptBox["z", "2"], " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "2"], " ", 
       SubsuperscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "3", "2"]}], "+", 
      RowBox[{"25200", " ", 
       SuperscriptBox["z", "4"], " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "2"], " ", 
       SubsuperscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "3", "2"]}], "-", 
      RowBox[{"1680", " ", 
       SubsuperscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "2", "2"], " ", 
       SubsuperscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "3", "2"]}], "-", 
      RowBox[{"25200", " ", 
       SuperscriptBox["z", "2"], " ", 
       SubsuperscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "2", "2"], " ", 
       SubsuperscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "3", "2"]}], "+", 
      RowBox[{"67200", " ", 
       SuperscriptBox["z", "4"], " ", 
       SubsuperscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "2", "2"], " ", 
       SubsuperscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "3", "2"]}], "-", 
      RowBox[{"40320", " ", 
       SuperscriptBox["z", "6"], " ", 
       SubsuperscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "2", "2"], " ", 
       SubsuperscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "3", "2"]}], "+", 
      RowBox[{"75600", " ", 
       SubsuperscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "3", "3"]}], "-", 
      RowBox[{"378000", " ", 
       SuperscriptBox["z", "2"], " ", 
       SubsuperscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "3", "3"]}], "+", 
      RowBox[{"302400", " ", 
       SuperscriptBox["z", "4"], " ", 
       SubsuperscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "3", "3"]}], "-", 
      RowBox[{"2439675", " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "5"]}], "+", 
      RowBox[{"2376675", " ", 
       SuperscriptBox["z", "2"], " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "5"]}], "-", 
      RowBox[{"2179800", " ", 
       SuperscriptBox["z", "4"], " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "5"]}], "+", 
      RowBox[{"5266800", " ", 
       SuperscriptBox["z", "6"], " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "5"]}], "-", 
      RowBox[{"3024000", " ", 
       SuperscriptBox["z", "8"], " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "5"]}], "+", 
      RowBox[{"47250", " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "2"], " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "5"]}], "-", 
      RowBox[{"425250", " ", 
       SuperscriptBox["z", "2"], " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "2"], " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "5"]}], "+", 
      RowBox[{"478800", " ", 
       SuperscriptBox["z", "4"], " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "2"], " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "5"]}], "-", 
      RowBox[{"100800", " ", 
       SuperscriptBox["z", "6"], " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "2"], " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "5"]}], "+", 
      RowBox[{"263760", " ", 
       SubsuperscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "2", "2"], " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "5"]}], "-", 
      RowBox[{"453600", " ", 
       SuperscriptBox["z", "2"], " ", 
       SubsuperscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "2", "2"], " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "5"]}], "+", 
      RowBox[{"176400", " ", 
       SuperscriptBox["z", "4"], " ", 
       SubsuperscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "2", "2"], " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "5"]}], "+", 
      RowBox[{"13440", " ", 
       SuperscriptBox["z", "6"], " ", 
       SubsuperscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "2", "2"], " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "5"]}], "+", 
      RowBox[{"1200", " ", 
       SubsuperscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "2", "3"], " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "5"]}], "-", 
      RowBox[{"10800", " ", 
       SuperscriptBox["z", "2"], " ", 
       SubsuperscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "2", "3"], " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "5"]}], "+", 
      RowBox[{"3200", " ", 
       SuperscriptBox["z", "4"], " ", 
       SubsuperscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "2", "3"], " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "5"]}], "-", 
      RowBox[{"44800", " ", 
       SuperscriptBox["z", "6"], " ", 
       SubsuperscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "2", "3"], " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "5"]}], "+", 
      RowBox[{"51200", " ", 
       SuperscriptBox["z", "8"], " ", 
       SubsuperscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "2", "3"], " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "5"]}], "+", 
      RowBox[{"913500", " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "3"], " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "5"]}], "-", 
      RowBox[{"132300", " ", 
       SuperscriptBox["z", "2"], " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "3"], " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "5"]}], "-", 
      RowBox[{"478800", " ", 
       SuperscriptBox["z", "4"], " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "3"], " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "5"]}], "-", 
      RowBox[{"302400", " ", 
       SuperscriptBox["z", "6"], " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "3"], " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "5"]}], "+", 
      RowBox[{"12600", " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "2"], " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "3"], " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "5"]}], "-", 
      RowBox[{"567000", " ", 
       SuperscriptBox["z", "2"], " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "2"], " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "3"], " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "5"]}], "+", 
      RowBox[{"823200", " ", 
       SuperscriptBox["z", "4"], " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "2"], " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "3"], " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "5"]}], "-", 
      RowBox[{"268800", " ", 
       SuperscriptBox["z", "6"], " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "2"], " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "3"], " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "5"]}], "+", 
      RowBox[{"126000", " ", 
       SubsuperscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "5", "2"]}], "+", 
      RowBox[{"672000", " ", 
       SuperscriptBox["z", "2"], " ", 
       SubsuperscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "5", "2"]}], "-", 
      RowBox[{"462000", " ", 
       SuperscriptBox["z", "4"], " ", 
       SubsuperscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "5", "2"]}], "-", 
      RowBox[{"336000", " ", 
       SuperscriptBox["z", "6"], " ", 
       SubsuperscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "5", "2"]}], "-", 
      RowBox[{"760725", " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "7"]}], "-", 
      RowBox[{"1337175", " ", 
       SuperscriptBox["z", "2"], " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "7"]}], "+", 
      RowBox[{"1568700", " ", 
       SuperscriptBox["z", "4"], " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "7"]}], "+", 
      RowBox[{"1134000", " ", 
       SuperscriptBox["z", "6"], " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "7"]}], "-", 
      RowBox[{"604800", " ", 
       SuperscriptBox["z", "8"], " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "7"]}], "+", 
      RowBox[{"148050", " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "2"], " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "7"]}], "+", 
      RowBox[{"192150", " ", 
       SuperscriptBox["z", "2"], " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "2"], " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "7"]}], "-", 
      RowBox[{"424200", " ", 
       SuperscriptBox["z", "4"], " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "2"], " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "7"]}], "+", 
      RowBox[{"84000", " ", 
       SuperscriptBox["z", "6"], " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "2"], " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "7"]}], "+", 
      RowBox[{"2520", " ", 
       SubsuperscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "2", "2"], " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "7"]}], "+", 
      RowBox[{"12600", " ", 
       SuperscriptBox["z", "2"], " ", 
       SubsuperscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "2", "2"], " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "7"]}], "+", 
      RowBox[{"85680", " ", 
       SuperscriptBox["z", "4"], " ", 
       SubsuperscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "2", "2"], " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "7"]}], "+", 
      RowBox[{"141120", " ", 
       SuperscriptBox["z", "6"], " ", 
       SubsuperscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "2", "2"], " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "7"]}], "-", 
      RowBox[{"241920", " ", 
       SuperscriptBox["z", "8"], " ", 
       SubsuperscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "2", "2"], " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "7"]}], "+", 
      RowBox[{"365400", " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "3"], " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "7"]}], "+", 
      RowBox[{"592200", " ", 
       SuperscriptBox["z", "2"], " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "3"], " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "7"]}], "-", 
      RowBox[{"151200", " ", 
       SuperscriptBox["z", "4"], " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "3"], " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "7"]}], "-", 
      RowBox[{"806400", " ", 
       SuperscriptBox["z", "6"], " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "3"], " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "7"]}], "-", 
      RowBox[{"14700", " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "9"]}], "-", 
      RowBox[{"514500", " ", 
       SuperscriptBox["z", "2"], " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "9"]}], "-", 
      RowBox[{"1234800", " ", 
       SuperscriptBox["z", "4"], " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "9"]}], "+", 
      RowBox[{"823200", " ", 
       SuperscriptBox["z", "6"], " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "9"]}], "+", 
      RowBox[{"940800", " ", 
       SuperscriptBox["z", "8"], " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "9"]}], "+", 
      RowBox[{"9800", " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "2"], " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "9"]}], "+", 
      RowBox[{"343000", " ", 
       SuperscriptBox["z", "2"], " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "2"], " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "9"]}], "+", 
      RowBox[{"823200", " ", 
       SuperscriptBox["z", "4"], " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "2"], " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "9"]}], "-", 
      RowBox[{"548800", " ", 
       SuperscriptBox["z", "6"], " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "2"], " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "9"]}], "-", 
      RowBox[{"627200", " ", 
       SuperscriptBox["z", "8"], " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "2"], " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "9"]}], "+", 
      RowBox[{"15750", " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], 
        RowBox[{"2", ",", "6"}]]}], "-", 
      RowBox[{"204750", " ", 
       SuperscriptBox["z", "2"], " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], 
        RowBox[{"2", ",", "6"}]]}], "+", 
      RowBox[{"441000", " ", 
       SuperscriptBox["z", "4"], " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], 
        RowBox[{"2", ",", "6"}]]}], "-", 
      RowBox[{"252000", " ", 
       SuperscriptBox["z", "6"], " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], 
        RowBox[{"2", ",", "6"}]]}], "-", 
      RowBox[{"10500", " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "2"], " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], 
        RowBox[{"2", ",", "6"}]]}], "+", 
      RowBox[{"136500", " ", 
       SuperscriptBox["z", "2"], " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "2"], " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], 
        RowBox[{"2", ",", "6"}]]}], "-", 
      RowBox[{"294000", " ", 
       SuperscriptBox["z", "4"], " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "2"], " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], 
        RowBox[{"2", ",", "6"}]]}], "+", 
      RowBox[{"168000", " ", 
       SuperscriptBox["z", "6"], " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "2"], " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], 
        RowBox[{"2", ",", "6"}]]}]}], ")"}]}]}]}]], "Output",
 CellChangeTimes->{3.555847021529922*^9, 3.555865807551052*^9, 
  3.555865854976933*^9, 3.564855570431978*^9}]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[Cell[BoxData[
 FormBox[
  RowBox[{
   RowBox[{"Log", "[", 
    FormBox[
     FractionBox[
      SubscriptBox[
       StyleBox["\[GothicCapitalT]",
        FontColor->RGBColor[0.54, 0.35, 0.15]], 
       RowBox[{"1", ",", "0"}]], 
      RowBox[{
       SuperscriptBox[
        RowBox[{"(", 
         SubscriptBox[
          StyleBox["\[GothicQ]",
           FontColor->RGBColor[0.54, 0.35, 0.15]], 
          RowBox[{"1", ",", "2"}]], ")"}], "+"], " ", 
       SuperscriptBox[
        RowBox[{"(", 
         SubscriptBox[
          OverscriptBox[
           StyleBox["\[GothicQ]",
            FontColor->RGBColor[0.54, 0.35, 0.15]], "_"], 
          RowBox[{"1", ",", "2"}]], ")"}], "-"]}]],
     TraditionalForm], "]"}], "\[Equal]", "T10contr"}], 
  TraditionalForm]]]], "Subsection",
 CellChangeTimes->{{3.546834634966998*^9, 3.546834643565124*^9}, {
  3.5468601889263153`*^9, 3.546860191509297*^9}, {3.546868207176361*^9, 
  3.5468682174960833`*^9}, {3.546871524691566*^9, 3.546871562789534*^9}, {
  3.54694787754251*^9, 3.546947899586294*^9}, {3.549702177631687*^9, 
  3.549702191256879*^9}, {3.54970222365797*^9, 3.5497022395593224`*^9}, {
  3.549702366523322*^9, 3.5497023681071167`*^9}, {3.553719313998662*^9, 
  3.5537193149168253`*^9}, {3.5537193522329283`*^9, 3.553719352233096*^9}, {
  3.5537194149056387`*^9, 3.553719426396679*^9}, {3.555797377532257*^9, 
  3.555797379967043*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Log", "[", 
   FractionBox[
    SubscriptBox["\[GothicCapitalT]", 
     RowBox[{"1", ",", "0"}]], 
    RowBox[{
     SubsuperscriptBox["\[GothicQ]", 
      RowBox[{"1", ",", "2"}], 
      RowBox[{"[", 
       RowBox[{"1", "+", "o"}], "]"}]], 
     SubsuperscriptBox[
      OverscriptBox[
       StyleBox["\[GothicQ]",
        FontColor->RGBColor[0.54, 0.35, 0.15]], 
       StyleBox["_",
        FontColor->RGBColor[0.54, 0.35, 0.15]]], 
      RowBox[{"1", ",", "2"}], 
      RowBox[{"[", 
       RowBox[{
        RowBox[{"-", "1"}], "-", "o"}], "]"}]]}]], "]"}], "\[TildeEqual]", 
  FractionBox[
   RowBox[{
    SubscriptBox["\[GothicCapitalT]", 
     RowBox[{"1", ",", "0"}]], "-", 
    RowBox[{
     SubsuperscriptBox["\[GothicQ]", 
      RowBox[{"1", ",", "2"}], 
      RowBox[{"[", 
       RowBox[{"1", "+", "o"}], "]"}]], 
     SubsuperscriptBox[
      OverscriptBox[
       StyleBox["\[GothicQ]",
        FontColor->RGBColor[0.54, 0.35, 0.15]], 
       StyleBox["_",
        FontColor->RGBColor[0.54, 0.35, 0.15]]], 
      RowBox[{"1", ",", "2"}], 
      RowBox[{"[", 
       RowBox[{
        RowBox[{"-", "1"}], "-", "o"}], "]"}]]}]}], 
   RowBox[{
    SubsuperscriptBox["\[GothicQ]", 
     RowBox[{"1", ",", "2"}], 
     RowBox[{"[", 
      RowBox[{"1", "+", "o"}], "]"}]], 
    SubsuperscriptBox[
     OverscriptBox[
      StyleBox["\[GothicQ]",
       FontColor->RGBColor[0.54, 0.35, 0.15]], 
      StyleBox["_",
       FontColor->RGBColor[0.54, 0.35, 0.15]]], 
     RowBox[{"1", ",", "2"}], 
     RowBox[{"[", 
      RowBox[{
       RowBox[{"-", "1"}], "-", "o"}], "]"}]]}]], "\[TildeEqual]", 
  FractionBox[
   RowBox[{
    SubscriptBox["\[GothicCapitalT]", 
     RowBox[{"1", ",", "0"}]], "-", 
    RowBox[{
     SuperscriptBox["Q", "+"], 
     SuperscriptBox["Q", "-"]}]}], 
   RowBox[{
    SuperscriptBox["Q", "+"], 
    SuperscriptBox["Q", "-"]}]]}]], "Input",
 CellChangeTimes->{{3.553719045772708*^9, 3.5537191318670683`*^9}, {
  3.5557970683650723`*^9, 3.5557970696045227`*^9}, {3.555852163499136*^9, 
  3.555852166594421*^9}, {3.563020481962097*^9, 3.563020489353673*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"tmp", "=", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{
         SubscriptBox["T", 
          RowBox[{"1", ",", "0"}]], "/.", "subTQ"}], "/.", "subpqb"}], "/.", 
       RowBox[{
        RowBox[{
         RowBox[{"q$", "[", 
          RowBox[{"3", ",", "4"}], "]"}], "[", "1", "]"}], "\[Rule]", "0"}]}],
       "/.", 
      RowBox[{
       RowBox[{
        RowBox[{"xx_", "[", 
         RowBox[{"2", ",", "3"}], "]"}], "[", "r_", "]"}], "\[RuleDelayed]", 
       RowBox[{
        RowBox[{"xx", "[", 
         RowBox[{"1", ",", "4"}], "]"}], "[", "r", "]"}]}]}], ")"}], "-", 
    RowBox[{
     SubsuperscriptBox["q", 
      RowBox[{"1", ",", "2"}], "+"], " ", 
     SubsuperscriptBox[
      OverscriptBox[
       StyleBox["q",
        FontColor->RGBColor[0, 0, 0.8]], 
       StyleBox["_",
        FontColor->RGBColor[0, 0, 0.8]]], 
      RowBox[{"1", ",", "2"}], "-"]}]}]}], ";"}]], "Input",
 CellChangeTimes->{{3.555847569334715*^9, 3.55584757446985*^9}, {
  3.555852051023571*^9, 3.555852153591462*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"Series", "[", 
    RowBox[{
     FractionBox[
      RowBox[{"tmp", "/.", 
       RowBox[{"leadweak", "[", "4", "]"}]}], 
      RowBox[{
       RowBox[{
        SuperscriptBox["Q", "+"], 
        SuperscriptBox["Q", "-"]}], "/.", 
       RowBox[{"leadweak", "[", "4", "]"}]}]], ",", 
     RowBox[{"{", 
      RowBox[{"g", ",", "0", ",", "14"}], "}"}]}], "]"}], "//", "Normal"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"(", 
   RowBox[{
    RowBox[{
     RowBox[{"%", "/.", "subQ0"}], "/.", 
     RowBox[{"u", "\[Rule]", 
      RowBox[{"2", "g", " ", "z"}]}]}], "/.", 
    RowBox[{"TaylorOptions", "[", 
     RowBox[{
      RowBox[{"Variable", "\[Rule]", "g"}], ",", 
      RowBox[{"\[Eta]Factor", "\[Rule]", 
       RowBox[{"2", "z"}]}], ",", 
      RowBox[{"Order", "\[Rule]", "14"}]}], "]"}]}], ")"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"T10contr", "=", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"Collect", "[", 
       RowBox[{"#", ",", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"z", ",", "\[Zeta]list"}], "}"}], "//", "Flatten"}], ",", 
        "Simplify"}], "]"}], "&"}], "/@", 
     RowBox[{"(", 
      RowBox[{"%", "//.", "subZetaReduce"}], ")"}]}], "//", "Normal"}]}], 
  ";"}]}], "Input",
 CellChangeTimes->{{3.5537191278458977`*^9, 3.553719280381703*^9}, {
  3.553719375436386*^9, 3.553719382475395*^9}, {3.555797084387602*^9, 
  3.555797165561664*^9}, {3.555797206365491*^9, 3.555797245837755*^9}, {
  3.55579728275659*^9, 3.55579729113267*^9}, {3.555852182683591*^9, 
  3.555852185438595*^9}, {3.555852220239648*^9, 3.555852261631579*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 "Log[ ",
 Cell[BoxData[
  RowBox[{
   FractionBox[
    RowBox[{
     SuperscriptBox[
      StyleBox["\[GothicCapitalT]",
       FontColor->RGBColor[0.54, 0.35, 0.15]], "-"], " ", 
     SuperscriptBox[
      StyleBox["\[GothicCapitalT]",
       FontColor->RGBColor[0.54, 0.35, 0.15]], "+"]}], 
    SubscriptBox[
     RowBox[{"(", 
      RowBox[{
       SuperscriptBox[
        StyleBox["\[GothicCapitalT]",
         FontColor->RGBColor[0.54, 0.35, 0.15]], "-"], " ", 
       SuperscriptBox[
        StyleBox["\[GothicCapitalT]",
         FontColor->RGBColor[0.54, 0.35, 0.15]], "+"]}], ")"}], "asym"]], 
   "]"}]],
  CellChangeTimes->{{3.5467742886388063`*^9, 3.546774377540269*^9}}],
 "==ToTW1 \n(Coorections from  ",
 Cell[BoxData[
  FormBox[
   SubscriptBox["W", "1"], TraditionalForm]]],
 " piece of ",
 Cell[BoxData[
  FormBox["\[GothicCapitalT]", TraditionalForm]]],
 ")"
}], "Subsection",
 CellChangeTimes->{{3.546834634966998*^9, 3.546834643565124*^9}, {
   3.5468601889263153`*^9, 3.546860191509297*^9}, {3.546868207176361*^9, 
   3.5468682174960833`*^9}, {3.546871524691566*^9, 3.546871562789534*^9}, {
   3.54687186150214*^9, 3.5468719098230352`*^9}, {3.546871940645009*^9, 
   3.5468719406452*^9}, {3.546947906735064*^9, 3.546947952514098*^9}, 
   3.546947993171628*^9, {3.54970239032008*^9, 3.5497024197312727`*^9}, {
   3.549702466452436*^9, 3.549702473036686*^9}, {3.549702793519092*^9, 
   3.5497027972289553`*^9}, {3.553718936946206*^9, 3.553718938221333*^9}, {
   3.553719501846691*^9, 3.553719502548704*^9}, {3.553719606620242*^9, 
   3.553719610809867*^9}, {3.5537207631436863`*^9, 3.55372077748569*^9}, {
   3.55582251395887*^9, 3.555822529037299*^9}}],

Cell[BoxData[
 RowBox[{"\[GothicCapitalT]", "=", 
  RowBox[{"1", "+", 
   RowBox[{
    SubscriptBox["\[ScriptCapitalC]", "1"], 
    OverscriptBox["*", "^"], 
    SubscriptBox["\[Rho]", "2"]}], "-", 
   RowBox[{
    SubscriptBox["\[ScriptCapitalC]", "1"], 
    OverscriptBox["*", "^"], 
    SubscriptBox["\[Delta]\[Rho]", "2"]}], "+", 
   SubscriptBox["W", "1"]}]}]], "Input",
 CellChangeTimes->{{3.5537196267091084`*^9, 3.553719664167872*^9}}],

Cell[TextData[{
 "Here we compute only correction coming from ",
 Cell[BoxData[
  FormBox[
   SubscriptBox["W", "1"], TraditionalForm]]],
 ". We are again in the doulbe scaling, hence we cannot use leadweak for \
computation of ",
 Cell[BoxData[
  FormBox[
   SubscriptBox["W", "1"], TraditionalForm]]]
}], "Text",
 CellChangeTimes->{{3.553719666019918*^9, 3.553719702947844*^9}, {
  3.5689646903847847`*^9, 3.568964690951652*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Log", "[", " ", 
   FractionBox[
    RowBox[{
     SuperscriptBox[
      StyleBox["\[GothicCapitalT]",
       FontColor->RGBColor[0.54, 0.35, 0.15]], "-"], " ", 
     SuperscriptBox[
      StyleBox["\[GothicCapitalT]",
       FontColor->RGBColor[0.54, 0.35, 0.15]], "+"]}], 
    SubscriptBox[
     RowBox[{"(", 
      RowBox[{
       SuperscriptBox[
        StyleBox["\[GothicCapitalT]",
         FontColor->RGBColor[0.54, 0.35, 0.15]], "-"], " ", 
       SuperscriptBox[
        StyleBox["\[GothicCapitalT]",
         FontColor->RGBColor[0.54, 0.35, 0.15]], "+"]}], ")"}], "asym"]], 
   "]"}], "\[Equal]", 
  RowBox[{"(*", " ", 
   RowBox[{"relevant", " ", "for", " ", "us", " ", "expressions"}], " ", 
   "*)"}], "\[Equal]", 
  RowBox[{
   FractionBox[
    SubsuperscriptBox["W", "1", "-"], 
    RowBox[{
     SubscriptBox[
      RowBox[{
       StyleBox["(",
        FontColor->RGBColor[0.54, 0.35, 0.15]], 
       SuperscriptBox[
        StyleBox["\[GothicCapitalT]",
         FontColor->RGBColor[0.54, 0.35, 0.15]], "-"], ")"}], "asym"], " "}]],
    "+", 
   FractionBox[
    SubsuperscriptBox["W", "1", "+"], 
    RowBox[{
     SubscriptBox[
      RowBox[{
       StyleBox["(",
        FontColor->RGBColor[0.54, 0.35, 0.15]], 
       SuperscriptBox[
        StyleBox["\[GothicCapitalT]",
         FontColor->RGBColor[0.54, 0.35, 0.15]], "+"], ")"}], "asym"], 
     " "}]]}]}]], "Input",
 CellChangeTimes->{{3.553719683059626*^9, 3.553719769027698*^9}, {
  3.553720551823493*^9, 3.553720552934512*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Series", "[", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{"1", "/", 
        SuperscriptBox["\[GothicCapitalT]", "-"]}], "/.", "largevolume"}], "/.",
       "subJuk"}], "/.", 
     RowBox[{"leadweak", "[", "2", "]"}]}], "/.", 
    RowBox[{"u", "\[Rule]", 
     RowBox[{"2", "g", " ", "z"}]}]}], ",", 
   RowBox[{"{", 
    RowBox[{"g", ",", "0", ",", "1"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.5537200971622057`*^9, 3.553720126038385*^9}, {
  3.553720431861027*^9, 3.55372043743416*^9}, {3.555797910088663*^9, 
  3.5557979141229486`*^9}}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"3", " ", "\[ImaginaryI]", " ", "z"}], "-", 
      RowBox[{"3", " ", 
       SqrtBox[
        RowBox[{"1", "-", 
         SuperscriptBox["z", "2"]}]]}]}], ")"}], " ", "g"}], "+", 
   InterpretationBox[
    SuperscriptBox[
     RowBox[{"O", "[", "g", "]"}], "2"],
    SeriesData[$CellContext`g, 0, {}, 1, 2, 1],
    Editable->False]}],
  SeriesData[$CellContext`g, 0, {
   Complex[0, 3] $CellContext`z - 3 (1 - $CellContext`z^2)^Rational[1, 2]}, 1,
    2, 1],
  Editable->False]], "Output",
 CellChangeTimes->{{3.553720101217147*^9, 3.553720126327859*^9}, {
   3.553720433743129*^9, 3.553720438238109*^9}, 3.55579791486626*^9, 
   3.555856133276537*^9}]
}, Open  ]],

Cell[TextData[{
 "This shows that we have to compute ",
 Cell[BoxData[
  FormBox[
   SubscriptBox["W", "1"], TraditionalForm]]],
 " up to ",
 Cell[BoxData[
  FormBox[
   SuperscriptBox["g", "12"], TraditionalForm]]],
 " ( ",
 Cell[BoxData[
  RowBox[{"Log", "[", " ", 
   FractionBox[
    RowBox[{
     SuperscriptBox[
      StyleBox["\[GothicCapitalT]",
       FontColor->RGBColor[0.54, 0.35, 0.15]], "-"], " ", 
     SuperscriptBox[
      StyleBox["\[GothicCapitalT]",
       FontColor->RGBColor[0.54, 0.35, 0.15]], "+"]}], 
    SubscriptBox[
     RowBox[{"(", 
      RowBox[{
       SuperscriptBox[
        StyleBox["\[GothicCapitalT]",
         FontColor->RGBColor[0.54, 0.35, 0.15]], "-"], " ", 
       SuperscriptBox[
        StyleBox["\[GothicCapitalT]",
         FontColor->RGBColor[0.54, 0.35, 0.15]], "+"]}], ")"}], "asym"]], 
   "]"}]],
  CellChangeTimes->{{3.553719683059626*^9, 3.553719769027698*^9}}],
 " appears in both equations, hence it should be computed up to ",
 Cell[BoxData[
  FormBox[
   SuperscriptBox["g", "13"], TraditionalForm]]],
 ")"
}], "Text",
 CellChangeTimes->{{3.553720134177512*^9, 3.553720177640538*^9}, {
  3.5557979256613483`*^9, 3.555797932411689*^9}, {3.555820482259966*^9, 
  3.555820482700883*^9}}],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      FractionBox[
       RowBox[{
        RowBox[{
         SubscriptBox[
          StyleBox["q",
           FontColor->RGBColor[0, 0, 0.8]], "2"], " ", 
         SubsuperscriptBox[
          StyleBox["q",
           FontColor->RGBColor[0, 0, 0.8]], 
          RowBox[{"1", ",", "4"}], "+"]}], "-", 
        SubsuperscriptBox[
         StyleBox["q",
          FontColor->RGBColor[0, 0, 0.8]], 
         RowBox[{"2", ",", "4"}], "+"]}], 
       SuperscriptBox[
        StyleBox["Q",
         FontColor->RGBColor[0.8, 0, 0]], "+"]], ",", 
      FractionBox[
       RowBox[{
        RowBox[{
         SubscriptBox[
          StyleBox["q",
           FontColor->RGBColor[0, 0, 0.8]], "2"], " ", 
         SubsuperscriptBox[
          StyleBox["q",
           FontColor->RGBColor[0, 0, 0.8]], 
          RowBox[{"1", ",", "3"}], "+"]}], "-", 
        SubsuperscriptBox[
         StyleBox["q",
          FontColor->RGBColor[0, 0, 0.8]], 
         RowBox[{"1", ",", "4"}], "+"]}], 
       SuperscriptBox[
        StyleBox["Q",
         FontColor->RGBColor[0.8, 0, 0]], "+"]]}], "}"}], "/.", 
    RowBox[{"Shift", "[", "1", "]"}]}], "/.", "largevolume"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"tmp", "=", 
  RowBox[{
   RowBox[{
    RowBox[{"(", 
     RowBox[{"%", ".", 
      RowBox[{"Reverse", "[", 
       RowBox[{"%", "/.", "mconj"}], "]"}]}], ")"}], "/.", 
    RowBox[{"Shift", "[", 
     RowBox[{"-", "1"}], "]"}]}], "/.", 
   RowBox[{"u", "\[Rule]", 
    RowBox[{"u", "-", 
     FractionBox["\[ImaginaryI]", "2"]}]}]}]}]}], "Input",
 CellChangeTimes->{{3.5537198004411383`*^9, 3.553719820096191*^9}, {
   3.5537198569550247`*^9, 3.553719862734717*^9}, {3.55371992306411*^9, 
   3.553719931029523*^9}, {3.553720002450375*^9, 3.553720013674209*^9}, {
   3.553720043994502*^9, 3.5537200704557056`*^9}, {3.5558524034453382`*^9, 
   3.555852406217102*^9}, {3.5558562460115023`*^9, 3.5558562556303873`*^9}, 
   3.555856302998884*^9}],

Cell[BoxData[
 RowBox[{
  FractionBox[
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       RowBox[{"-", "\[ImaginaryI]"}], " ", 
       RowBox[{"(", 
        RowBox[{"u", "+", 
         FractionBox[
          RowBox[{"4", " ", "g"}], 
          RowBox[{
           SubscriptBox["\[Gamma]", "0"], " ", 
           StyleBox["x",
            FontColor->RGBColor[0, 0.6, 0]]}]]}], ")"}], " ", 
       SubsuperscriptBox[
        StyleBox["q",
         FontColor->RGBColor[0, 0, 0.8]], 
        RowBox[{"1", ",", "4"}], "+"]}], "-", 
      SubsuperscriptBox[
       StyleBox["q",
        FontColor->RGBColor[0, 0, 0.8]], 
       RowBox[{"2", ",", "4"}], "+"]}], ")"}], " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"\[ImaginaryI]", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", "\[ImaginaryI]"}], "+", "u", "+", 
         FractionBox[
          RowBox[{"4", " ", "g", " ", 
           SuperscriptBox[
            StyleBox["x",
             FontColor->RGBColor[0, 0.6, 0]], 
            RowBox[{"[", 
             RowBox[{"-", "2"}], "]"}]]}], 
          SubscriptBox["\[Gamma]", "0"]]}], ")"}], " ", 
       SubsuperscriptBox[
        OverscriptBox[
         StyleBox["q",
          FontColor->RGBColor[0, 0, 0.8]], 
         StyleBox["_",
          FontColor->RGBColor[0, 0, 0.8]]], 
        RowBox[{"1", ",", "3"}], 
        RowBox[{"[", 
         RowBox[{"-", "3"}], "]"}]]}], "-", 
      SubsuperscriptBox[
       OverscriptBox[
        StyleBox["q",
         FontColor->RGBColor[0, 0, 0.8]], 
        StyleBox["_",
         FontColor->RGBColor[0, 0, 0.8]]], 
       RowBox[{"1", ",", "4"}], 
       RowBox[{"[", 
        RowBox[{"-", "3"}], "]"}]]}], ")"}]}], 
   RowBox[{
    SuperscriptBox[
     StyleBox["Q",
      FontColor->RGBColor[0.8, 0, 0]], 
     RowBox[{"[", 
      RowBox[{"-", "3"}], "]"}]], " ", 
    SuperscriptBox[
     StyleBox["Q",
      FontColor->RGBColor[0.8, 0, 0]], "+"]}]], "+", 
  FractionBox[
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       RowBox[{"-", "\[ImaginaryI]"}], " ", 
       RowBox[{"(", 
        RowBox[{"u", "+", 
         FractionBox[
          RowBox[{"4", " ", "g"}], 
          RowBox[{
           SubscriptBox["\[Gamma]", "0"], " ", 
           StyleBox["x",
            FontColor->RGBColor[0, 0.6, 0]]}]]}], ")"}], " ", 
       SubsuperscriptBox[
        StyleBox["q",
         FontColor->RGBColor[0, 0, 0.8]], 
        RowBox[{"1", ",", "3"}], "+"]}], "-", 
      SubsuperscriptBox[
       StyleBox["q",
        FontColor->RGBColor[0, 0, 0.8]], 
       RowBox[{"1", ",", "4"}], "+"]}], ")"}], " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"\[ImaginaryI]", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", "\[ImaginaryI]"}], "+", "u", "+", 
         FractionBox[
          RowBox[{"4", " ", "g", " ", 
           SuperscriptBox[
            StyleBox["x",
             FontColor->RGBColor[0, 0.6, 0]], 
            RowBox[{"[", 
             RowBox[{"-", "2"}], "]"}]]}], 
          SubscriptBox["\[Gamma]", "0"]]}], ")"}], " ", 
       SubsuperscriptBox[
        OverscriptBox[
         StyleBox["q",
          FontColor->RGBColor[0, 0, 0.8]], 
         StyleBox["_",
          FontColor->RGBColor[0, 0, 0.8]]], 
        RowBox[{"1", ",", "4"}], 
        RowBox[{"[", 
         RowBox[{"-", "3"}], "]"}]]}], "-", 
      SubsuperscriptBox[
       OverscriptBox[
        StyleBox["q",
         FontColor->RGBColor[0, 0, 0.8]], 
        StyleBox["_",
         FontColor->RGBColor[0, 0, 0.8]]], 
       RowBox[{"2", ",", "4"}], 
       RowBox[{"[", 
        RowBox[{"-", "3"}], "]"}]]}], ")"}]}], 
   RowBox[{
    SuperscriptBox[
     StyleBox["Q",
      FontColor->RGBColor[0.8, 0, 0]], 
     RowBox[{"[", 
      RowBox[{"-", "3"}], "]"}]], " ", 
    SuperscriptBox[
     StyleBox["Q",
      FontColor->RGBColor[0.8, 0, 0]], "+"]}]]}]], "Output",
 CellChangeTimes->{
  3.555798530038742*^9, 3.555852357806851*^9, 3.555852407124572*^9, 
   3.555852541346098*^9, 3.555856165505526*^9, {3.55585624690482*^9, 
   3.555856256354785*^9}, 3.555856303921297*^9, 3.564855660364846*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"tmpn", "=", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"Series", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"Collect", "[", 
            RowBox[{
             RowBox[{"tmp", "/.", 
              RowBox[{"u", "\[Rule]", 
               RowBox[{"2", "g", " ", "z"}]}]}], ",", "x", ",", "Simplify"}], 
            "]"}], "//.", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"xxx", ":", 
              RowBox[{"(", 
               RowBox[{"Alternatives", "@@", 
                RowBox[{"{", 
                 RowBox[{
                  RowBox[{"Q0", "[", 
                   RowBox[{"_", ":", "0"}], "]"}], ",", 
                  RowBox[{"Q", "[", 
                   RowBox[{"_", ":", "0"}], "]"}], ",", 
                  SubscriptBox["\[Gamma]", "0"], ",", 
                  RowBox[{"x$", "[", 
                   RowBox[{"_", ":", "0"}], "]"}]}], "}"}]}], ")"}]}], 
             "\[RuleDelayed]", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{
                RowBox[{
                 RowBox[{"xxx", "/.", "subQ0"}], "/.", "subJuk"}], "/.", 
                RowBox[{"leadweak", "[", "4", "]"}]}], "/.", 
               RowBox[{"u", "\[Rule]", 
                RowBox[{"2", "g", " ", "z"}]}]}], ")"}]}], ")"}]}], ",", 
          RowBox[{"{", 
           RowBox[{"g", ",", "0", ",", "6"}], "}"}]}], "]"}], "//", 
        "Simplify"}], ")"}], "/.", 
      RowBox[{
       RowBox[{"b_.", 
        SuperscriptBox[
         RowBox[{"(", 
          RowBox[{
           RowBox[{
            RowBox[{"-", "\[ImaginaryI]"}], " ", "z"}], "+", 
           SqrtBox[
            RowBox[{"1", "-", 
             SuperscriptBox["z", "2"]}]]}], ")"}], 
         RowBox[{"a_", "/;", 
          RowBox[{"a", "<", "0"}]}]]}], "\[RuleDelayed]", 
       RowBox[{"b", " ", 
        SuperscriptBox[
         RowBox[{"(", 
          FractionBox["1", 
           RowBox[{
            RowBox[{"\[ImaginaryI]", " ", "z"}], "+", 
            SqrtBox[
             RowBox[{"1", "-", 
              SuperscriptBox["z", "2"]}]]}]], ")"}], "a"]}]}]}], "/.", 
     RowBox[{
      RowBox[{"b_.", 
       SuperscriptBox[
        RowBox[{"(", 
         RowBox[{
          RowBox[{"\[ImaginaryI]", " ", "z"}], "+", 
          SqrtBox[
           RowBox[{"1", "-", 
            SuperscriptBox["z", "2"]}]]}], ")"}], 
        RowBox[{"a_", "/;", 
         RowBox[{"a", "<", "0"}]}]]}], "\[RuleDelayed]", " ", 
      RowBox[{"b", 
       SuperscriptBox[
        RowBox[{"(", 
         FractionBox["1", 
          RowBox[{
           RowBox[{
            RowBox[{"-", "\[ImaginaryI]"}], " ", "z"}], "+", 
           SqrtBox[
            RowBox[{"1", "-", 
             SuperscriptBox["z", "2"]}]]}]], ")"}], "a"]}]}]}], "/.", 
    RowBox[{
     RowBox[{"b_.", 
      SuperscriptBox[
       RowBox[{"(", 
        RowBox[{"z", "+", 
         RowBox[{"\[ImaginaryI]", " ", 
          SqrtBox[
           RowBox[{"1", "-", 
            SuperscriptBox["z", "2"]}]]}]}], ")"}], 
       RowBox[{"a_", "/;", 
        RowBox[{"a", "<", "0"}]}]]}], "\[RuleDelayed]", " ", 
     RowBox[{"b", 
      SuperscriptBox[
       RowBox[{"(", 
        FractionBox["1", 
         RowBox[{"z", "-", 
          RowBox[{"\[ImaginaryI]", 
           SqrtBox[
            RowBox[{"1", "-", 
             SuperscriptBox["z", "2"]}]]}]}]], ")"}], "a"]}]}]}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"tmpn", "=", 
   RowBox[{
    RowBox[{
     RowBox[{"Collect", "[", 
      RowBox[{
       RowBox[{"#", "//", "Expand"}], ",", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{
           RowBox[{
            RowBox[{"q$", "[", 
             RowBox[{"_", ",", "_"}], "]"}], "[", "_", "]"}], 
           RowBox[{
            RowBox[{"q$b", "[", 
             RowBox[{"_", ",", "_"}], "]"}], "[", "_", "]"}]}], ",", 
          SqrtBox[
           RowBox[{"1", "-", 
            SuperscriptBox["z", "2"]}]], ",", "z", ",", "\[Zeta]list"}], 
         "}"}], "//", "Flatten"}], ",", "Simplify"}], "]"}], "&"}], "/@", 
    "%"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"FreeQ", "[", 
  RowBox[{"%", ",", 
   SubscriptBox["\[Zeta]", "5"]}], "]"}]}], "Input",
 CellChangeTimes->{
  3.5557984910314007`*^9, {3.555820514176888*^9, 3.555820553549423*^9}, {
   3.555820589037825*^9, 3.5558206962533407`*^9}, {3.555820727362359*^9, 
   3.555820748151065*^9}, {3.555820798555138*^9, 3.555820899603109*^9}, 
   3.55585260296597*^9, 3.555852711319322*^9}],

Cell[BoxData["True"], "Output",
 CellChangeTimes->{3.55585273629742*^9, 3.555852823998995*^9, 
  3.555856314222312*^9, 3.55585634452527*^9, 3.56485566672159*^9}]
}, Open  ]],

Cell[BoxData[{
 RowBox[{
  RowBox[{"List", "@@", 
   RowBox[{"Collect", "[", 
    RowBox[{
     RowBox[{"Normal", "[", "tmpn", "]"}], ",", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{
         RowBox[{
          RowBox[{"q$", "[", 
           RowBox[{"_", ",", "_"}], "]"}], "[", "_", "]"}], 
         RowBox[{
          RowBox[{"q$b", "[", 
           RowBox[{"_", ",", "_"}], "]"}], "[", "_", "]"}]}], ",", "g", ",", 
        SqrtBox[
         RowBox[{"1", "-", 
          SuperscriptBox["z", "2"]}]], ",", "z", ",", "\[Zeta]list"}], "}"}], 
      "//", "Flatten"}]}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"tmp3", "=", 
   RowBox[{"Collect", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"Total", "[", 
       RowBox[{"Normal", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"Series", "[", 
           RowBox[{
            RowBox[{
             RowBox[{
              RowBox[{
               RowBox[{"#", "/.", 
                RowBox[{"leadweak", "[", "4", "]"}]}], "/.", "subQ0"}], "//.", 
              RowBox[{"shiftp\[Eta]b", "[", 
               RowBox[{"-", "4"}], "]"}]}], "/.", 
             RowBox[{"u", "\[Rule]", 
              RowBox[{"2", "g", " ", "z"}]}]}], ",", 
            RowBox[{"{", 
             RowBox[{"g", ",", "0", ",", "13"}], "}"}]}], "]"}], "&"}], "/@", 
         "%"}], "]"}], "]"}], "//", "Expand"}], ",", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"\[Eta]list", ",", "g", ",", 
        SqrtBox[
         RowBox[{"1", "-", 
          SuperscriptBox["z", "2"]}]], ",", "z", ",", "\[Zeta]list"}], "}"}], 
      "//", "Flatten"}]}], "]"}]}], ";"}]}], "Input",
 CellChangeTimes->{{3.555821561058899*^9, 3.555821730937216*^9}, {
  3.555821762016913*^9, 3.555821766749757*^9}, {3.555821955226857*^9, 
  3.555821959689242*^9}, {3.5558528314570847`*^9, 3.555852859839695*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"tmp4", "=", 
   RowBox[{"Collect", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"(", 
       RowBox[{"tmp3", "/.", 
        RowBox[{"TaylorOptions", "[", 
         RowBox[{
          RowBox[{"Variable", "\[Rule]", "g"}], ",", 
          RowBox[{"\[Eta]Factor", "\[Rule]", 
           RowBox[{"2", "z"}]}], ",", 
          RowBox[{"Order", "\[Rule]", "13"}], ",", 
          RowBox[{"Series", "\[Rule]", "False"}]}], "]"}]}], ")"}], "//.", 
      "subZetaReduce"}], ",", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"g", ",", 
        SqrtBox[
         RowBox[{"1", "-", 
          SuperscriptBox["z", "2"]}]], ",", "z", ",", "\[Zeta]list"}], "}"}], 
      "//", "Flatten"}]}], "]"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.5558218207860317`*^9, 3.555821892822016*^9}, {
  3.555852864034422*^9, 3.555852864490012*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Collect", "[", 
  RowBox[{"tmp4", ",", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"g", ",", 
      SqrtBox[
       RowBox[{"1", "-", 
        SuperscriptBox["z", "2"]}]], ",", "z"}], "}"}], "//", "Flatten"}], 
   ",", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       RowBox[{"#", "/.", "subZetas"}], "/.", "Nnnreducibles"}], "//", "N"}], 
     ")"}], "&"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.555821900047181*^9, 3.5558219009531717`*^9}, {
  3.555822016861388*^9, 3.5558220787831507`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   SuperscriptBox["g", "7"], " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{
      RowBox[{"(", 
       RowBox[{"0.`", "\[VeryThinSpace]", "+", 
        RowBox[{"0.11867432164428493`", " ", "\[ImaginaryI]"}]}], ")"}], " ", 
      "z"}], "+", 
     RowBox[{"0.11867432164428493`", " ", 
      SqrtBox[
       RowBox[{"1", "-", 
        SuperscriptBox["z", "2"]}]]}]}], ")"}]}], "+", 
  RowBox[{
   SuperscriptBox["g", "8"], " ", 
   RowBox[{"(", 
    RowBox[{"0.24735542950759282`", "\[VeryThinSpace]", "-", 
     RowBox[{"0.7666059470368509`", " ", 
      SuperscriptBox["z", "2"]}], "+", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"0.`", "\[VeryThinSpace]", "+", 
        RowBox[{"0.7666059470368509`", " ", "\[ImaginaryI]"}]}], ")"}], " ", 
      "z", " ", 
      SqrtBox[
       RowBox[{"1", "-", 
        SuperscriptBox["z", "2"]}]]}]}], ")"}]}], "+", 
  RowBox[{
   SuperscriptBox["g", "9"], " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{
      RowBox[{"(", 
       RowBox[{"0.`", "\[VeryThinSpace]", "+", 
        RowBox[{"0.22880106316483761`", " ", "\[ImaginaryI]"}]}], ")"}], " ", 
      "z"}], "-", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"0.`", "\[VeryThinSpace]", "+", 
        RowBox[{"4.342114490548283`", " ", "\[ImaginaryI]"}]}], ")"}], " ", 
      SuperscriptBox["z", "3"]}], "+", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "1.0670621876198538`"}], "-", 
        RowBox[{"4.342114490548283`", " ", 
         SuperscriptBox["z", "2"]}]}], ")"}], " ", 
      SqrtBox[
       RowBox[{"1", "-", 
        SuperscriptBox["z", "2"]}]]}]}], ")"}]}], "+", 
  RowBox[{
   SuperscriptBox["g", "10"], " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"-", "3.612838352237759`"}], "+", 
     RowBox[{"2.3504542293740087`", " ", 
      SuperscriptBox["z", "2"]}], "+", 
     RowBox[{"17.573679816516233`", " ", 
      SuperscriptBox["z", "4"]}], "+", 
     RowBox[{
      SqrtBox[
       RowBox[{"1", "-", 
        SuperscriptBox["z", "2"]}]], " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         RowBox[{"(", 
          RowBox[{"0.`", "\[VeryThinSpace]", "-", 
           RowBox[{"9.112947687448468`", " ", "\[ImaginaryI]"}]}], ")"}], " ",
          "z"}], "-", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{"0.`", "\[VeryThinSpace]", "+", 
           RowBox[{"17.573679816516233`", " ", "\[ImaginaryI]"}]}], ")"}], 
         " ", 
         SuperscriptBox["z", "3"]}]}], ")"}]}]}], ")"}]}], "+", 
  RowBox[{
   SuperscriptBox["g", "11"], " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{
      RowBox[{"(", 
       RowBox[{"0.`", "\[VeryThinSpace]", "-", 
        RowBox[{"14.384070850646822`", " ", "\[ImaginaryI]"}]}], ")"}], " ", 
      "z"}], "+", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"0.`", "\[VeryThinSpace]", "+", 
        RowBox[{"41.70813261148942`", " ", "\[ImaginaryI]"}]}], ")"}], " ", 
      SuperscriptBox["z", "3"]}], "+", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"0.`", "\[VeryThinSpace]", "+", 
        RowBox[{"60.57131250930615`", " ", "\[ImaginaryI]"}]}], ")"}], " ", 
      SuperscriptBox["z", "5"]}], "+", 
     RowBox[{
      SqrtBox[
       RowBox[{"1", "-", 
        SuperscriptBox["z", "2"]}]], " ", 
      RowBox[{"(", 
       RowBox[{"9.428319636554079`", "\[VeryThinSpace]", "+", 
        RowBox[{"64.15544490212778`", " ", 
         SuperscriptBox["z", "2"]}], "+", 
        RowBox[{"60.57131250930615`", " ", 
         SuperscriptBox["z", "4"]}]}], ")"}]}]}], ")"}]}], "+", 
  RowBox[{
   SuperscriptBox["g", "12"], " ", 
   RowBox[{"(", 
    RowBox[{"42.87827038624164`", "\[VeryThinSpace]", "+", 
     RowBox[{"66.65293402904514`", " ", 
      SuperscriptBox["z", "2"]}], "-", 
     RowBox[{"281.3298066362804`", " ", 
      SuperscriptBox["z", "4"]}], "-", 
     RowBox[{"157.9091043738299`", " ", 
      SuperscriptBox["z", "6"]}], "+", 
     RowBox[{
      SqrtBox[
       RowBox[{"1", "-", 
        SuperscriptBox["z", "2"]}]], " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         RowBox[{"(", 
          RowBox[{"0.`", "\[VeryThinSpace]", "+", 
           RowBox[{"80.98256607429379`", " ", "\[ImaginaryI]"}]}], ")"}], " ",
          "z"}], "+", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{"0.`", "\[VeryThinSpace]", "+", 
           RowBox[{"342.3956214599166`", " ", "\[ImaginaryI]"}]}], ")"}], " ", 
         SuperscriptBox["z", "3"]}], "+", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{"0.`", "\[VeryThinSpace]", "+", 
           RowBox[{"157.9091043738299`", " ", "\[ImaginaryI]"}]}], ")"}], " ", 
         SuperscriptBox["z", "5"]}]}], ")"}]}]}], ")"}]}], "+", 
  RowBox[{
   SuperscriptBox["g", "13"], " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{
      RowBox[{"(", 
       RowBox[{"0.`", "\[VeryThinSpace]", "+", 
        RowBox[{"202.91404555857912`", " ", "\[ImaginaryI]"}]}], ")"}], " ", 
      "z"}], "+", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"0.`", "\[VeryThinSpace]", "+", 
        RowBox[{"23.980640349021304`", " ", "\[ImaginaryI]"}]}], ")"}], " ", 
      SuperscriptBox["z", "3"]}], "-", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"0.`", "\[VeryThinSpace]", "+", 
        RowBox[{"1490.6121309102207`", " ", "\[ImaginaryI]"}]}], ")"}], " ", 
      SuperscriptBox["z", "5"]}], "-", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"0.`", "\[VeryThinSpace]", "+", 
        RowBox[{"257.29753312902176`", " ", "\[ImaginaryI]"}]}], ")"}], " ", 
      SuperscriptBox["z", "7"]}], "+", 
     RowBox[{
      SqrtBox[
       RowBox[{"1", "-", 
        SuperscriptBox["z", "2"]}]], " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "94.5226999772459`"}], "-", 
        RowBox[{"626.8767270937459`", " ", 
         SuperscriptBox["z", "2"]}], "-", 
        RowBox[{"1564.1928060035866`", " ", 
         SuperscriptBox["z", "4"]}], "-", 
        RowBox[{"257.29753312902176`", " ", 
         SuperscriptBox["z", "6"]}]}], ")"}]}]}], ")"}]}]}]], "Output",
 CellChangeTimes->{
  3.555821902439095*^9, 3.555821979599986*^9, {3.5558220523198977`*^9, 
   3.555822079218824*^9}, 3.555852909349536*^9, 3.55585645929808*^9, 
   3.5648557067346153`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"tmp5", "=", 
  RowBox[{
   RowBox[{
    RowBox[{"Collect", "[", 
     RowBox[{
      RowBox[{"Expand", "[", "#", "]"}], ",", "z"}], "]"}], "&"}], "/@", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"Series", "[", 
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{
          RowBox[{
           RowBox[{"1", "/", 
            SuperscriptBox["\[GothicCapitalT]", "-"]}], "/.", "largevolume"}],
           "/.", "subJuk"}], "/.", 
         RowBox[{"leadweak", "[", "4", "]"}]}], "/.", 
        RowBox[{"u", "\[Rule]", 
         RowBox[{"2", "g", " ", "z"}]}]}], ",", 
       RowBox[{"{", 
        RowBox[{"g", ",", "0", ",", "7"}], "}"}]}], "]"}], "//", "Simplify"}],
     ")"}]}]}]], "Input",
 CellChangeTimes->{{3.55582212382786*^9, 3.555822206003076*^9}, {
  3.555852922117372*^9, 3.555852924710801*^9}}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"3", " ", "\[ImaginaryI]", " ", "z"}], "-", 
      RowBox[{"3", " ", 
       SqrtBox[
        RowBox[{"1", "-", 
         SuperscriptBox["z", "2"]}]]}]}], ")"}], " ", "g"}], "+", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"-", "6"}], "+", 
      RowBox[{"12", " ", 
       SuperscriptBox["z", "2"]}], "+", 
      RowBox[{"12", " ", "\[ImaginaryI]", " ", "z", " ", 
       SqrtBox[
        RowBox[{"1", "-", 
         SuperscriptBox["z", "2"]}]]}]}], ")"}], " ", 
    SuperscriptBox["g", "2"]}], "+", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"18", " ", "\[ImaginaryI]", " ", "z"}], "-", 
      RowBox[{"36", " ", "\[ImaginaryI]", " ", 
       SuperscriptBox["z", "3"]}], "+", 
      RowBox[{"36", " ", 
       SuperscriptBox["z", "2"], " ", 
       SqrtBox[
        RowBox[{"1", "-", 
         SuperscriptBox["z", "2"]}]]}]}], ")"}], " ", 
    SuperscriptBox["g", "3"]}], "+", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{"33", "-", 
      RowBox[{"6", " ", 
       SuperscriptBox["z", "2"]}], "-", 
      RowBox[{"72", " ", 
       SuperscriptBox["z", "4"]}], "-", 
      RowBox[{"42", " ", "\[ImaginaryI]", " ", "z", " ", 
       SqrtBox[
        RowBox[{"1", "-", 
         SuperscriptBox["z", "2"]}]]}], "-", 
      RowBox[{"72", " ", "\[ImaginaryI]", " ", 
       SuperscriptBox["z", "3"], " ", 
       SqrtBox[
        RowBox[{"1", "-", 
         SuperscriptBox["z", "2"]}]]}]}], ")"}], " ", 
    SuperscriptBox["g", "4"]}], "+", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       RowBox[{"-", "246"}], " ", "\[ImaginaryI]", " ", "z"}], "+", 
      RowBox[{"384", " ", "\[ImaginaryI]", " ", 
       SuperscriptBox["z", "3"]}], "+", 
      RowBox[{"48", " ", 
       SqrtBox[
        RowBox[{"1", "-", 
         SuperscriptBox["z", "2"]}]]}], "-", 
      RowBox[{"384", " ", 
       SuperscriptBox["z", "2"], " ", 
       SqrtBox[
        RowBox[{"1", "-", 
         SuperscriptBox["z", "2"]}]]}]}], ")"}], " ", 
    SuperscriptBox["g", "5"]}], "+", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"-", "150"}], "-", 
      RowBox[{"1128", " ", 
       SuperscriptBox["z", "2"]}], "+", 
      RowBox[{"2496", " ", 
       SuperscriptBox["z", "4"]}], "-", 
      RowBox[{"864", " ", 
       SuperscriptBox["z", "6"]}], "-", 
      RowBox[{"192", " ", "\[ImaginaryI]", " ", "z", " ", 
       SqrtBox[
        RowBox[{"1", "-", 
         SuperscriptBox["z", "2"]}]]}], "+", 
      RowBox[{"2064", " ", "\[ImaginaryI]", " ", 
       SuperscriptBox["z", "3"], " ", 
       SqrtBox[
        RowBox[{"1", "-", 
         SuperscriptBox["z", "2"]}]]}], "-", 
      RowBox[{"864", " ", "\[ImaginaryI]", " ", 
       SuperscriptBox["z", "5"], " ", 
       SqrtBox[
        RowBox[{"1", "-", 
         SuperscriptBox["z", "2"]}]]}]}], ")"}], " ", 
    SuperscriptBox["g", "6"]}], "+", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"2532", " ", "\[ImaginaryI]", " ", 
       SuperscriptBox["z", "3"]}], "-", 
      RowBox[{"10320", " ", "\[ImaginaryI]", " ", 
       SuperscriptBox["z", "5"]}], "+", 
      RowBox[{"5184", " ", "\[ImaginaryI]", " ", 
       SuperscriptBox["z", "7"]}], "-", 
      RowBox[{"450", " ", 
       SqrtBox[
        RowBox[{"1", "-", 
         SuperscriptBox["z", "2"]}]]}], "+", 
      RowBox[{"708", " ", 
       SuperscriptBox["z", "2"], " ", 
       SqrtBox[
        RowBox[{"1", "-", 
         SuperscriptBox["z", "2"]}]]}], "+", 
      RowBox[{"7728", " ", 
       SuperscriptBox["z", "4"], " ", 
       SqrtBox[
        RowBox[{"1", "-", 
         SuperscriptBox["z", "2"]}]]}], "-", 
      RowBox[{"5184", " ", 
       SuperscriptBox["z", "6"], " ", 
       SqrtBox[
        RowBox[{"1", "-", 
         SuperscriptBox["z", "2"]}]]}], "+", 
      RowBox[{"z", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"1548", " ", "\[ImaginaryI]"}], "-", 
         RowBox[{"72", " ", "\[ImaginaryI]", " ", 
          SubscriptBox[
           StyleBox["\[Zeta]",
            FontWeight->Bold,
            FontColor->GrayLevel[0.4]], "3"]}]}], ")"}]}], "+", 
      RowBox[{"72", " ", 
       SqrtBox[
        RowBox[{"1", "-", 
         SuperscriptBox["z", "2"]}]], " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "3"]}]}], ")"}], " ", 
    SuperscriptBox["g", "7"]}], "+", 
   InterpretationBox[
    SuperscriptBox[
     RowBox[{"O", "[", "g", "]"}], "8"],
    SeriesData[$CellContext`g, 0, {}, 1, 8, 1],
    Editable->False]}],
  SeriesData[$CellContext`g, 0, {
   Complex[0, 3] $CellContext`z - 3 (1 - $CellContext`z^2)^Rational[1, 2], -6 + 
    12 $CellContext`z^2 + 
    Complex[0, 12] $CellContext`z (1 - $CellContext`z^2)^Rational[1, 2], 
    Complex[0, 18] $CellContext`z + Complex[0, -36] $CellContext`z^3 + 
    36 $CellContext`z^2 (1 - $CellContext`z^2)^Rational[1, 2], 33 - 
    6 $CellContext`z^2 - 72 $CellContext`z^4 + 
    Complex[0, -42] $CellContext`z (1 - $CellContext`z^2)^Rational[1, 2] + 
    Complex[0, -72] $CellContext`z^3 (1 - $CellContext`z^2)^Rational[1, 2], 
    Complex[0, -246] $CellContext`z + Complex[0, 384] $CellContext`z^3 + 
    48 (1 - $CellContext`z^2)^Rational[1, 2] - 
    384 $CellContext`z^2 (1 - $CellContext`z^2)^Rational[1, 2], -150 - 
    1128 $CellContext`z^2 + 2496 $CellContext`z^4 - 864 $CellContext`z^6 + 
    Complex[0, -192] $CellContext`z (1 - $CellContext`z^2)^Rational[1, 2] + 
    Complex[0, 2064] $CellContext`z^3 (1 - $CellContext`z^2)^Rational[1, 2] + 
    Complex[0, -864] $CellContext`z^5 (1 - $CellContext`z^2)^Rational[1, 2], 
    Complex[0, 2532] $CellContext`z^3 + Complex[0, -10320] $CellContext`z^5 + 
    Complex[0, 5184] $CellContext`z^7 - 
    450 (1 - $CellContext`z^2)^Rational[1, 2] + 
    708 $CellContext`z^2 (1 - $CellContext`z^2)^Rational[1, 2] + 
    7728 $CellContext`z^4 (1 - $CellContext`z^2)^Rational[1, 2] - 
    5184 $CellContext`z^6 (1 - $CellContext`z^2)^
     Rational[1, 2] + $CellContext`z (Complex[0, 1548] + 
      Complex[0, -72] $CellContext`\[Zeta]$[3][0]) + 
    72 (1 - $CellContext`z^2)^Rational[1, 2] $CellContext`\[Zeta]$[3][0]}, 1, 
   8, 1],
  Editable->False]], "Output",
 CellChangeTimes->{{3.55582211811417*^9, 3.555822137465643*^9}, 
   3.555822172547764*^9, 3.5558222066875563`*^9, 3.555852929293746*^9, 
   3.555856478547058*^9, 3.564855708970155*^9}]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"prerlt", "=", 
   RowBox[{"Collect", "[", 
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{"Series", "[", 
        RowBox[{
         RowBox[{"tmp4", " ", "tmp5"}], ",", 
         RowBox[{"{", 
          RowBox[{"g", ",", "0", ",", "14"}], "}"}]}], "]"}], "//", 
       "Normal"}], "//", "Expand"}], ",", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"g", ",", 
        SqrtBox[
         RowBox[{"1", "-", 
          SuperscriptBox["z", "2"]}]], ",", "z", ",", "\[Zeta]list"}], "}"}], 
      "//", "Flatten"}]}], "]"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.555822223534616*^9, 3.555822280582272*^9}, 
   3.555852990867407*^9}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Collect", "[", 
  RowBox[{"prerlt", ",", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"g", ",", 
      SqrtBox[
       RowBox[{"1", "-", 
        SuperscriptBox["z", "2"]}]], ",", "z"}], "}"}], "//", "Flatten"}], 
   ",", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       RowBox[{"#", "/.", "subZetas"}], "/.", "Nnnreducibles"}], "//", "N"}], 
     ")"}], "&"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.5558223174723263`*^9, 3.555822318629341*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"-", "0.3560229649328761`"}], " ", 
   SuperscriptBox["g", "8"]}], "+", 
  RowBox[{
   SuperscriptBox["g", "9"], " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{
      RowBox[{"(", 
       RowBox[{"0.`", "\[VeryThinSpace]", "-", 
        RowBox[{"0.8457056227219368`", " ", "\[ImaginaryI]"}]}], ")"}], " ", 
      "z"}], "-", 
     RowBox[{"1.4541122183883886`", " ", 
      SqrtBox[
       RowBox[{"1", "-", 
        SuperscriptBox["z", "2"]}]]}]}], ")"}]}], "+", 
  RowBox[{
   SuperscriptBox["g", "10"], " ", 
   RowBox[{"(", 
    RowBox[{"1.7170539858161646`", "\[VeryThinSpace]", "+", 
     RowBox[{"9.64352098075824`", " ", 
      SuperscriptBox["z", "2"]}], "-", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"0.`", "\[VeryThinSpace]", "+", 
        RowBox[{"3.3828224908877473`", " ", "\[ImaginaryI]"}]}], ")"}], " ", 
      "z", " ", 
      SqrtBox[
       RowBox[{"1", "-", 
        SuperscriptBox["z", "2"]}]]}]}], ")"}]}], "+", 
  RowBox[{
   SuperscriptBox["g", "11"], " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{
      RowBox[{"(", 
       RowBox[{"0.`", "\[VeryThinSpace]", "+", 
        RowBox[{"5.707104211534215`", " ", "\[ImaginaryI]"}]}], ")"}], " ", 
      "z"}], "+", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"0.`", "\[VeryThinSpace]", "+", 
        RowBox[{"22.55306714665676`", " ", "\[ImaginaryI]"}]}], ")"}], " ", 
      SuperscriptBox["z", "3"]}], "+", 
     RowBox[{
      SqrtBox[
       RowBox[{"1", "-", 
        SuperscriptBox["z", "2"]}]], " ", 
      RowBox[{"(", 
       RowBox[{"21.157140796696694`", "\[VeryThinSpace]", "+", 
        RowBox[{"30.167972302897397`", " ", 
         SuperscriptBox["z", "2"]}]}], ")"}]}]}], ")"}]}], "+", 
  RowBox[{
   SuperscriptBox["g", "12"], " ", 
   RowBox[{"(", 
    RowBox[{"7.2511678164228215`", "\[VeryThinSpace]", "-", 
     RowBox[{"128.3213373694016`", " ", 
      SuperscriptBox["z", "2"]}], "-", 
     RowBox[{"111.79860388660745`", " ", 
      SuperscriptBox["z", "4"]}], "+", 
     RowBox[{
      SqrtBox[
       RowBox[{"1", "-", 
        SuperscriptBox["z", "2"]}]], " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         RowBox[{"(", 
          RowBox[{"0.`", "\[VeryThinSpace]", "+", 
           RowBox[{"54.96523050957239`", " ", "\[ImaginaryI]"}]}], ")"}], " ",
          "z"}], "+", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{"0.`", "\[VeryThinSpace]", "+", 
           RowBox[{"69.91533364130737`", " ", "\[ImaginaryI]"}]}], ")"}], " ", 
         SuperscriptBox["z", "3"]}]}], ")"}]}]}], ")"}]}], "+", 
  RowBox[{
   SuperscriptBox["g", "13"], " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{
      RowBox[{"(", 
       RowBox[{"0.`", "\[VeryThinSpace]", "+", 
        RowBox[{"7.82836209914158`", " ", "\[ImaginaryI]"}]}], ")"}], " ", 
      "z"}], "-", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"0.`", "\[VeryThinSpace]", "+", 
        RowBox[{"350.1297634369439`", " ", "\[ImaginaryI]"}]}], ")"}], " ", 
      SuperscriptBox["z", "3"]}], "-", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"0.`", "\[VeryThinSpace]", "+", 
        RowBox[{"257.5995526360639`", " ", "\[ImaginaryI]"}]}], ")"}], " ", 
      SuperscriptBox["z", "5"]}], "+", 
     RowBox[{
      SqrtBox[
       RowBox[{"1", "-", 
        SuperscriptBox["z", "2"]}]], " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "226.34586879977724`"}], "-", 
        RowBox[{"689.6730390690354`", " ", 
         SuperscriptBox["z", "2"]}], "-", 
        RowBox[{"216.12776048533124`", " ", 
         SuperscriptBox["z", "4"]}]}], ")"}]}]}], ")"}]}], "+", 
  RowBox[{
   SuperscriptBox["g", "14"], " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"-", "224.37989547718175`"}], "+", 
     RowBox[{"691.695546285414`", " ", 
      SuperscriptBox["z", "2"]}], "+", 
     RowBox[{"3202.237164438013`", " ", 
      SuperscriptBox["z", "4"]}], "+", 
     RowBox[{"282.76800036244094`", " ", 
      SuperscriptBox["z", "6"]}], "+", 
     RowBox[{
      SqrtBox[
       RowBox[{"1", "-", 
        SuperscriptBox["z", "2"]}]], " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         RowBox[{"(", 
          RowBox[{"0.`", "\[VeryThinSpace]", "-", 
           RowBox[{"601.6436780210232`", " ", "\[ImaginaryI]"}]}], ")"}], " ",
          "z"}], "-", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{"0.`", "\[VeryThinSpace]", "+", 
           RowBox[{"1761.9859202097432`", " ", "\[ImaginaryI]"}]}], ")"}], 
         " ", 
         SuperscriptBox["z", "3"]}], "-", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{"0.`", "\[VeryThinSpace]", "+", 
           RowBox[{"489.1245990244788`", " ", "\[ImaginaryI]"}]}], ")"}], " ", 
         SuperscriptBox["z", "5"]}]}], ")"}]}]}], ")"}]}]}]], "Output",
 CellChangeTimes->{3.555822320007263*^9, 3.555852995041119*^9, 
  3.555856532505911*^9, 3.56485571106291*^9}]
}, Open  ]],

Cell["\<\
Now we need to just add complex conjugation of this expression\
\>", "Text",
 CellChangeTimes->{{3.553720525010129*^9, 3.5537205446971197`*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"(", 
  RowBox[{
   FractionBox[
    SubsuperscriptBox["W", "1", "-"], 
    RowBox[{
     SubscriptBox[
      RowBox[{
       StyleBox["(",
        FontColor->RGBColor[0.54, 0.35, 0.15]], 
       SuperscriptBox[
        StyleBox["\[GothicCapitalT]",
         FontColor->RGBColor[0.54, 0.35, 0.15]], "-"], ")"}], "asym"], " "}]],
    "+", 
   FractionBox[
    SubsuperscriptBox["W", "1", "+"], 
    RowBox[{
     SubscriptBox[
      RowBox[{
       StyleBox["(",
        FontColor->RGBColor[0.54, 0.35, 0.15]], 
       SuperscriptBox[
        StyleBox["\[GothicCapitalT]",
         FontColor->RGBColor[0.54, 0.35, 0.15]], "+"], ")"}], "asym"], 
     " "}]]}], ")"}]], "Input",
 CellChangeTimes->{{3.5537205604268503`*^9, 3.553720568243717*^9}, {
  3.553720611024707*^9, 3.553720706863286*^9}, {3.553720805813386*^9, 
  3.553720843414201*^9}, {3.555822366134955*^9, 3.555822385616127*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   FractionBox[
    SubsuperscriptBox[
     StyleBox["W",
      FontColor->RGBColor[0.54, 0.35, 0.15]], "1", "-"], 
    SubscriptBox[
     SuperscriptBox[
      StyleBox["\[GothicCapitalT]",
       FontColor->RGBColor[0.54, 0.35, 0.15]], "-"], "asym"]], "+", 
   FractionBox[
    SubsuperscriptBox[
     StyleBox["W",
      FontColor->RGBColor[0.54, 0.35, 0.15]], "1", "+"], 
    SubscriptBox[
     SuperscriptBox[
      StyleBox["\[GothicCapitalT]",
       FontColor->RGBColor[0.54, 0.35, 0.15]], "+"], "asym"]]}], "\[Equal]", 
  InterpretationBox[
   RowBox[{
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       FractionBox[
        RowBox[{"36", " ", 
         SuperscriptBox["\[Pi]", "4"]}], "5"], "-", 
       FractionBox[
        RowBox[{"2", " ", 
         SuperscriptBox["\[Pi]", "6"]}], "15"], "-", 
       RowBox[{"12", " ", 
        SuperscriptBox["\[Pi]", "2"], " ", 
        RowBox[{"(", 
         RowBox[{"3", "+", 
          RowBox[{"4", " ", 
           SubscriptBox[
            StyleBox["\[Zeta]",
             FontWeight->Bold,
             FontColor->GrayLevel[0.4]], "3"]}]}], ")"}]}], "-", 
       RowBox[{"36", " ", 
        RowBox[{"(", 
         RowBox[{"9", "+", 
          RowBox[{"2", " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"-", "9"}], "+", 
             SubscriptBox[
              StyleBox["\[Zeta]",
               FontWeight->Bold,
               FontColor->GrayLevel[0.4]], "3"]}], ")"}], " ", 
           SubscriptBox[
            StyleBox["\[Zeta]",
             FontWeight->Bold,
             FontColor->GrayLevel[0.4]], "3"]}]}], ")"}]}]}], ")"}], " ", 
     SuperscriptBox["g", "8"]}], "+", 
    RowBox[{
     FractionBox["4", "5"], " ", 
     RowBox[{"(", 
      RowBox[{"945", "-", 
       RowBox[{"105", " ", 
        SuperscriptBox["\[Pi]", "2"]}], "+", 
       SuperscriptBox["\[Pi]", "4"]}], ")"}], " ", 
     SqrtBox[
      RowBox[{"1", "-", 
       SuperscriptBox["z", "2"]}]], " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"-", "3"}], "+", 
       RowBox[{"2", " ", 
        SubscriptBox[
         StyleBox["\[Zeta]",
          FontWeight->Bold,
          FontColor->GrayLevel[0.4]], "3"]}]}], ")"}], " ", 
     SuperscriptBox["g", "9"]}], "+", 
    InterpretationBox[
     SuperscriptBox[
      RowBox[{"O", "[", "g", "]"}], "10"],
     SeriesData[$CellContext`g, 0, {}, 8, 10, 1],
     Editable->False]}],
   SeriesData[$CellContext`g, 0, {
    Rational[36, 5] Pi^4 + 
     Rational[-2, 15] Pi^6 - (12 Pi^2) (3 + 4 $CellContext`\[Zeta]$[3][0]) - 
     36 (9 + (2 (-9 + $CellContext`\[Zeta]$[3][0])) $CellContext`\[Zeta]$[3][
        0]), ((Rational[4, 5] (945 - 105 Pi^2 + Pi^4)) (1 - $CellContext`z^2)^
       Rational[1, 2]) (-3 + 2 $CellContext`\[Zeta]$[3][0])}, 8, 10, 1],
   Editable->False]}]], "Output",
 CellChangeTimes->{
  3.5537206194630632`*^9, {3.5537206601916924`*^9, 3.553720707343266*^9}, {
   3.5537208093436403`*^9, 3.553720844079793*^9}}]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"ToTW1", "=", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{
      RowBox[{"Collect", "[", 
       RowBox[{"#", ",", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"g", ",", 
           SqrtBox[
            RowBox[{"1", "-", 
             SuperscriptBox["z", "2"]}]], ",", "z", ",", "\[Zeta]list"}], 
          "}"}], "//", "Flatten"}]}], "]"}], "&"}], "@", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"prerlt", "+", 
        RowBox[{"(", 
         RowBox[{"prerlt", "/.", "mconj"}], ")"}]}], "//", "Expand"}], 
      ")"}]}], ")"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.555822389930532*^9, 3.5558224371690817`*^9}, 
   3.5558225361197453`*^9}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Collect", "[", 
  RowBox[{"ToTW1", ",", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"g", ",", 
      SqrtBox[
       RowBox[{"1", "-", 
        SuperscriptBox["z", "2"]}]], ",", "z"}], "}"}], "//", "Flatten"}], 
   ",", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       RowBox[{"#", "/.", "subZetas"}], "/.", "Nnnreducibles"}], "//", "N"}], 
     ")"}], "&"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.555822444129328*^9, 3.555822453865044*^9}, 
   3.5558225385273523`*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"-", "0.7120459298657522`"}], " ", 
   SuperscriptBox["g", "8"]}], "-", 
  RowBox[{"2.908224436776777`", " ", 
   SuperscriptBox["g", "9"], " ", 
   SqrtBox[
    RowBox[{"1", "-", 
     SuperscriptBox["z", "2"]}]]}], "+", 
  RowBox[{
   SuperscriptBox["g", "10"], " ", 
   RowBox[{"(", 
    RowBox[{"3.4341079716323293`", "\[VeryThinSpace]", "+", 
     RowBox[{"19.28704196151648`", " ", 
      SuperscriptBox["z", "2"]}]}], ")"}]}], "+", 
  RowBox[{
   SuperscriptBox["g", "11"], " ", 
   SqrtBox[
    RowBox[{"1", "-", 
     SuperscriptBox["z", "2"]}]], " ", 
   RowBox[{"(", 
    RowBox[{"42.31428159339339`", "\[VeryThinSpace]", "+", 
     RowBox[{"60.33594460579479`", " ", 
      SuperscriptBox["z", "2"]}]}], ")"}]}], "+", 
  RowBox[{
   SuperscriptBox["g", "13"], " ", 
   SqrtBox[
    RowBox[{"1", "-", 
     SuperscriptBox["z", "2"]}]], " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"-", "452.6917375995545`"}], "-", 
     RowBox[{"1379.3460781380709`", " ", 
      SuperscriptBox["z", "2"]}], "-", 
     RowBox[{"432.2555209706625`", " ", 
      SuperscriptBox["z", "4"]}]}], ")"}]}], "+", 
  RowBox[{
   SuperscriptBox["g", "12"], " ", 
   RowBox[{"(", 
    RowBox[{"14.502335632845643`", "\[VeryThinSpace]", "-", 
     RowBox[{"256.6426747388032`", " ", 
      SuperscriptBox["z", "2"]}], "-", 
     RowBox[{"223.5972077732149`", " ", 
      SuperscriptBox["z", "4"]}]}], ")"}]}], "+", 
  RowBox[{
   SuperscriptBox["g", "14"], " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"-", "448.7597909543635`"}], "+", 
     RowBox[{"1383.391092570828`", " ", 
      SuperscriptBox["z", "2"]}], "+", 
     RowBox[{"6404.474328876026`", " ", 
      SuperscriptBox["z", "4"]}], "+", 
     RowBox[{"565.5360007248819`", " ", 
      SuperscriptBox["z", "6"]}]}], ")"}]}]}]], "Output",
 CellChangeTimes->{3.555822454406145*^9, 3.5558225389192867`*^9, 
  3.5558530187810383`*^9, 3.5558566016005697`*^9, 3.564855711552012*^9}]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  FormBox[
   RowBox[{
    RowBox[{
     RowBox[{"Log", "[", 
      RowBox[{"(", 
       FractionBox[
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           SubscriptBox[
            StyleBox["\[GothicQ]",
             FontColor->RGBColor[0.54, 0.35, 0.15]], "2"], "-", 
           SubsuperscriptBox[
            StyleBox["\[GothicQ]",
             FontColor->RGBColor[0.54, 0.35, 0.15]], "2", 
            RowBox[{"[", "2", "]"}]]}], ")"}], 
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            SubscriptBox[
             OverscriptBox[
              StyleBox["\[GothicQ]",
               FontColor->RGBColor[0.54, 0.35, 0.15]], 
              StyleBox["_",
               FontColor->RGBColor[0.54, 0.35, 0.15]]], "2"], "-", 
            SubsuperscriptBox[
             OverscriptBox[
              StyleBox["\[GothicQ]",
               FontColor->RGBColor[0.54, 0.35, 0.15]], 
              StyleBox["_",
               FontColor->RGBColor[0.54, 0.35, 0.15]]], "2", 
             RowBox[{"[", 
              RowBox[{"-", "2"}], "]"}]]}], ")"}], "/", "  ", 
          SuperscriptBox[
           StyleBox["\[GothicCapitalT]",
            FontColor->RGBColor[0.54, 0.35, 0.15]], "-"]}], " ", 
         SuperscriptBox[
          StyleBox["\[GothicCapitalT]",
           FontColor->RGBColor[0.54, 0.35, 0.15]], "+"]}], 
        SubscriptBox[
         RowBox[{"(", 
          RowBox[{
           RowBox[{"(", 
            RowBox[{
             SubscriptBox[
              StyleBox["\[GothicQ]",
               FontColor->RGBColor[0.54, 0.35, 0.15]], "2"], "-", 
             SubsuperscriptBox[
              StyleBox["\[GothicQ]",
               FontColor->RGBColor[0.54, 0.35, 0.15]], "2", 
              RowBox[{"[", "2", "]"}]]}], ")"}], 
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              SubscriptBox[
               OverscriptBox[
                StyleBox["\[GothicQ]",
                 FontColor->RGBColor[0.54, 0.35, 0.15]], 
                StyleBox["_",
                 FontColor->RGBColor[0.54, 0.35, 0.15]]], "2"], "-", 
              SubsuperscriptBox[
               OverscriptBox[
                StyleBox["\[GothicQ]",
                 FontColor->RGBColor[0.54, 0.35, 0.15]], 
                StyleBox["_",
                 FontColor->RGBColor[0.54, 0.35, 0.15]]], "2", 
               RowBox[{"[", 
                RowBox[{"-", "2"}], "]"}]]}], ")"}], " ", "/", " ", 
            SuperscriptBox[
             StyleBox["\[GothicCapitalT]",
              FontColor->RGBColor[0.54, 0.35, 0.15]], "-"]}], " ", 
           SuperscriptBox[
            StyleBox["\[GothicCapitalT]",
             FontColor->RGBColor[0.54, 0.35, 0.15]], "+"]}], ")"}], "asym"]], 
       ")"}], "]"}], "\[Rule]", 
     RowBox[{"Log", "[", 
      FractionBox[
       RowBox[{" ", 
        FractionBox[
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            SubscriptBox[
             StyleBox["\[GothicQ]",
              FontColor->RGBColor[0.54, 0.35, 0.15]], "2"], "-", 
            SubsuperscriptBox[
             StyleBox["\[GothicQ]",
              FontColor->RGBColor[0.54, 0.35, 0.15]], "2", 
             RowBox[{"[", "2", "]"}]]}], ")"}], 
          RowBox[{"(", 
           RowBox[{
            SubscriptBox[
             OverscriptBox[
              StyleBox["\[GothicQ]",
               FontColor->RGBColor[0.54, 0.35, 0.15]], 
              StyleBox["_",
               FontColor->RGBColor[0.54, 0.35, 0.15]]], "2"], "-", 
            SubsuperscriptBox[
             OverscriptBox[
              StyleBox["\[GothicQ]",
               FontColor->RGBColor[0.54, 0.35, 0.15]], 
              StyleBox["_",
               FontColor->RGBColor[0.54, 0.35, 0.15]]], "2", 
             RowBox[{"[", 
              RowBox[{"-", "2"}], "]"}]]}], ")"}]}], 
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            SubscriptBox[
             StyleBox["\[GothicQ]",
              FontColor->RGBColor[0.54, 0.35, 0.15]], "2"], "+", 
            SubsuperscriptBox[
             OverscriptBox[
              StyleBox["\[GothicQ]",
               FontColor->RGBColor[0.54, 0.35, 0.15]], "_"], "2", 
             RowBox[{"[", 
              RowBox[{"-", "2"}], "]"}]]}], ")"}], 
          RowBox[{"(", 
           RowBox[{
            SubscriptBox[
             OverscriptBox[
              StyleBox["\[GothicQ]",
               FontColor->RGBColor[0.54, 0.35, 0.15]], "_"], "2"], "+", 
            SubsuperscriptBox[
             StyleBox["\[GothicQ]",
              FontColor->RGBColor[0.54, 0.35, 0.15]], "2", 
             RowBox[{"[", 
              RowBox[{"+", "2"}], "]"}]]}], ")"}]}]]}], 
       RowBox[{
        SubscriptBox[
         RowBox[{"(", 
          FractionBox[
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              SubscriptBox[
               StyleBox["\[GothicQ]",
                FontColor->RGBColor[0.54, 0.35, 0.15]], "2"], "-", 
              SubsuperscriptBox[
               StyleBox["\[GothicQ]",
                FontColor->RGBColor[0.54, 0.35, 0.15]], "2", 
               RowBox[{"[", "2", "]"}]]}], ")"}], 
            RowBox[{"(", 
             RowBox[{
              SubscriptBox[
               OverscriptBox[
                StyleBox["\[GothicQ]",
                 FontColor->RGBColor[0.54, 0.35, 0.15]], 
                StyleBox["_",
                 FontColor->RGBColor[0.54, 0.35, 0.15]]], "2"], "-", 
              SubsuperscriptBox[
               OverscriptBox[
                StyleBox["\[GothicQ]",
                 FontColor->RGBColor[0.54, 0.35, 0.15]], 
                StyleBox["_",
                 FontColor->RGBColor[0.54, 0.35, 0.15]]], "2", 
               RowBox[{"[", 
                RowBox[{"-", "2"}], "]"}]]}], ")"}]}], 
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              SubscriptBox[
               StyleBox["\[GothicQ]",
                FontColor->RGBColor[0.54, 0.35, 0.15]], "2"], "+", 
              SubsuperscriptBox[
               OverscriptBox[
                StyleBox["\[GothicQ]",
                 FontColor->RGBColor[0.54, 0.35, 0.15]], "_"], "2", 
               RowBox[{"[", 
                RowBox[{"-", "2"}], "]"}]]}], ")"}], 
            RowBox[{"(", 
             RowBox[{
              SubscriptBox[
               OverscriptBox[
                StyleBox["\[GothicQ]",
                 FontColor->RGBColor[0.54, 0.35, 0.15]], "_"], "2"], "+", 
              SubsuperscriptBox[
               StyleBox["\[GothicQ]",
                FontColor->RGBColor[0.54, 0.35, 0.15]], "2", 
               RowBox[{"[", 
                RowBox[{"+", "2"}], "]"}]]}], ")"}]}]], ")"}], "asym"], 
        " "}]], "]"}]}], "=", 
    RowBox[{
    "ratioq2Wint", "+", "ratioq2\[Delta]\[Rho]2", "+", "ratioq2Wmp0"}]}], 
   TraditionalForm]]],
 "\n(*Corrections  from changing  ",
 Cell[BoxData[
  FormBox[
   SubscriptBox["q", "2"], TraditionalForm]]],
 ", including change of q2 by ",
 Cell[BoxData[
  FormBox[
   SubscriptBox["W", "0"], TraditionalForm]]],
 "*)"
}], "Subsection",
 CellChangeTimes->{{3.546834634966998*^9, 3.546834643565124*^9}, {
  3.5468601889263153`*^9, 3.546860191509297*^9}, {3.546868207176361*^9, 
  3.5468682174960833`*^9}, {3.546945196188978*^9, 3.546945216345038*^9}, {
  3.546946209451289*^9, 3.5469462142553062`*^9}, {3.5469779315773697`*^9, 
  3.546977931577567*^9}, {3.547190665613242*^9, 3.547190666759266*^9}, {
  3.5496961235066147`*^9, 3.5496961281269217`*^9}, {3.549702438884674*^9, 
  3.549702445751395*^9}, {3.549735848431609*^9, 3.549735853019761*^9}, {
  3.5537189517928143`*^9, 3.553718967791031*^9}, {3.553721079353677*^9, 
  3.55372111792717*^9}, {3.553728517752797*^9, 3.553728578445665*^9}, {
  3.555828771705508*^9, 3.555828880540886*^9}, {3.555828922539254*^9, 
  3.555828926282259*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Log", "[", 
   FractionBox[
    RowBox[{" ", 
     FractionBox[
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         SubscriptBox[
          StyleBox["\[GothicQ]",
           FontColor->RGBColor[0.54, 0.35, 0.15]], "2"], "-", 
         SubsuperscriptBox[
          StyleBox["\[GothicQ]",
           FontColor->RGBColor[0.54, 0.35, 0.15]], "2", 
          RowBox[{"[", "2", "]"}]]}], ")"}], 
       RowBox[{"(", 
        RowBox[{
         SubscriptBox[
          OverscriptBox[
           StyleBox["\[GothicQ]",
            FontColor->RGBColor[0.54, 0.35, 0.15]], 
           StyleBox["_",
            FontColor->RGBColor[0.54, 0.35, 0.15]]], "2"], "-", 
         SubsuperscriptBox[
          OverscriptBox[
           StyleBox["\[GothicQ]",
            FontColor->RGBColor[0.54, 0.35, 0.15]], 
           StyleBox["_",
            FontColor->RGBColor[0.54, 0.35, 0.15]]], "2", 
          RowBox[{"[", 
           RowBox[{"-", "2"}], "]"}]]}], ")"}]}], 
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         SubscriptBox[
          StyleBox["\[GothicQ]",
           FontColor->RGBColor[0.54, 0.35, 0.15]], "2"], "+", 
         SubsuperscriptBox[
          OverscriptBox[
           StyleBox["\[GothicQ]",
            FontColor->RGBColor[0.54, 0.35, 0.15]], "_"], "2", 
          RowBox[{"[", 
           RowBox[{"-", "2"}], "]"}]]}], ")"}], 
       RowBox[{"(", 
        RowBox[{
         SubscriptBox[
          OverscriptBox[
           StyleBox["\[GothicQ]",
            FontColor->RGBColor[0.54, 0.35, 0.15]], "_"], "2"], "+", 
         SubsuperscriptBox[
          StyleBox["\[GothicQ]",
           FontColor->RGBColor[0.54, 0.35, 0.15]], "2", 
          RowBox[{"[", 
           RowBox[{"+", "2"}], "]"}]]}], ")"}]}]]}], 
    RowBox[{
     SubscriptBox[
      RowBox[{"(", 
       FractionBox[
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           SubscriptBox[
            StyleBox["\[GothicQ]",
             FontColor->RGBColor[0.54, 0.35, 0.15]], "2"], "-", 
           SubsuperscriptBox[
            StyleBox["\[GothicQ]",
             FontColor->RGBColor[0.54, 0.35, 0.15]], "2", 
            RowBox[{"[", "2", "]"}]]}], ")"}], 
         RowBox[{"(", 
          RowBox[{
           SubscriptBox[
            OverscriptBox[
             StyleBox["\[GothicQ]",
              FontColor->RGBColor[0.54, 0.35, 0.15]], 
             StyleBox["_",
              FontColor->RGBColor[0.54, 0.35, 0.15]]], "2"], "-", 
           SubsuperscriptBox[
            OverscriptBox[
             StyleBox["\[GothicQ]",
              FontColor->RGBColor[0.54, 0.35, 0.15]], 
             StyleBox["_",
              FontColor->RGBColor[0.54, 0.35, 0.15]]], "2", 
            RowBox[{"[", 
             RowBox[{"-", "2"}], "]"}]]}], ")"}]}], 
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           SubscriptBox[
            StyleBox["\[GothicQ]",
             FontColor->RGBColor[0.54, 0.35, 0.15]], "2"], "+", 
           SubsuperscriptBox[
            OverscriptBox[
             StyleBox["\[GothicQ]",
              FontColor->RGBColor[0.54, 0.35, 0.15]], "_"], "2", 
            RowBox[{"[", 
             RowBox[{"-", "2"}], "]"}]]}], ")"}], 
         RowBox[{"(", 
          RowBox[{
           SubscriptBox[
            OverscriptBox[
             StyleBox["\[GothicQ]",
              FontColor->RGBColor[0.54, 0.35, 0.15]], "_"], "2"], "+", 
           SubsuperscriptBox[
            StyleBox["\[GothicQ]",
             FontColor->RGBColor[0.54, 0.35, 0.15]], "2", 
            RowBox[{"[", 
             RowBox[{"+", "2"}], "]"}]]}], ")"}]}]], ")"}], "asym"], " "}]], 
   "]"}], "\[Equal]", 
  RowBox[{
   FractionBox[
    RowBox[{"\[Delta]", 
     RowBox[{"(", 
      RowBox[{"(", 
       RowBox[{
        SubscriptBox[
         StyleBox["\[GothicQ]",
          FontColor->RGBColor[0.54, 0.35, 0.15]], "2"], "-", 
        SubsuperscriptBox[
         StyleBox["\[GothicQ]",
          FontColor->RGBColor[0.54, 0.35, 0.15]], "2", 
         RowBox[{"[", "2", "]"}]]}], ")"}], ")"}]}], 
    RowBox[{"(", 
     RowBox[{
      SubscriptBox[
       StyleBox["\[GothicQ]",
        FontColor->RGBColor[0.54, 0.35, 0.15]], "2"], "-", 
      SubsuperscriptBox[
       StyleBox["\[GothicQ]",
        FontColor->RGBColor[0.54, 0.35, 0.15]], "2", 
       RowBox[{"[", "2", "]"}]]}], ")"}]], "+", 
   FractionBox[
    RowBox[{"\[Delta]", 
     RowBox[{"(", 
      RowBox[{
       SubscriptBox[
        OverscriptBox[
         StyleBox["\[GothicQ]",
          FontColor->RGBColor[0.54, 0.35, 0.15]], 
         StyleBox["_",
          FontColor->RGBColor[0.54, 0.35, 0.15]]], "2"], "-", 
       SubsuperscriptBox[
        OverscriptBox[
         StyleBox["\[GothicQ]",
          FontColor->RGBColor[0.54, 0.35, 0.15]], 
         StyleBox["_",
          FontColor->RGBColor[0.54, 0.35, 0.15]]], "2", 
        RowBox[{"[", 
         RowBox[{"-", "2"}], "]"}]]}], ")"}]}], 
    RowBox[{"(", 
     RowBox[{
      SubscriptBox[
       OverscriptBox[
        StyleBox["\[GothicQ]",
         FontColor->RGBColor[0.54, 0.35, 0.15]], 
        StyleBox["_",
         FontColor->RGBColor[0.54, 0.35, 0.15]]], "2"], "-", 
      SubsuperscriptBox[
       OverscriptBox[
        StyleBox["\[GothicQ]",
         FontColor->RGBColor[0.54, 0.35, 0.15]], 
        StyleBox["_",
         FontColor->RGBColor[0.54, 0.35, 0.15]]], "2", 
       RowBox[{"[", 
        RowBox[{"-", "2"}], "]"}]]}], ")"}]], "-", 
   FractionBox[
    RowBox[{"\[Delta]", 
     RowBox[{"(", 
      RowBox[{
       SubscriptBox[
        StyleBox["\[GothicQ]",
         FontColor->RGBColor[0.54, 0.35, 0.15]], "2"], "+", 
       SubsuperscriptBox[
        OverscriptBox[
         StyleBox["\[GothicQ]",
          FontColor->RGBColor[0.54, 0.35, 0.15]], "_"], "2", 
        RowBox[{"[", 
         RowBox[{"-", "2"}], "]"}]]}], ")"}]}], 
    RowBox[{"(", 
     RowBox[{
      SubscriptBox[
       StyleBox["\[GothicQ]",
        FontColor->RGBColor[0.54, 0.35, 0.15]], "2"], "+", 
      SubsuperscriptBox[
       OverscriptBox[
        StyleBox["\[GothicQ]",
         FontColor->RGBColor[0.54, 0.35, 0.15]], "_"], "2", 
       RowBox[{"[", 
        RowBox[{"-", "2"}], "]"}]]}], ")"}]], "-", 
   FractionBox[
    RowBox[{"\[Delta]", 
     RowBox[{"(", 
      RowBox[{
       SubscriptBox[
        OverscriptBox[
         StyleBox["\[GothicQ]",
          FontColor->RGBColor[0.54, 0.35, 0.15]], "_"], "2"], "+", 
       SubsuperscriptBox[
        StyleBox["\[GothicQ]",
         FontColor->RGBColor[0.54, 0.35, 0.15]], "2", 
        RowBox[{"[", 
         RowBox[{"+", "2"}], "]"}]]}], ")"}]}], 
    RowBox[{"(", 
     RowBox[{
      SubscriptBox[
       OverscriptBox[
        StyleBox["\[GothicQ]",
         FontColor->RGBColor[0.54, 0.35, 0.15]], "_"], "2"], "+", 
      SubsuperscriptBox[
       StyleBox["\[GothicQ]",
        FontColor->RGBColor[0.54, 0.35, 0.15]], "2", 
       RowBox[{"[", 
        RowBox[{"+", "2"}], "]"}]]}], ")"}]]}]}]], "Input",
 CellChangeTimes->{{3.553721590400281*^9, 3.5537216652513742`*^9}}],

Cell[CellGroupData[{

Cell[TextData[{
 "Correction from ",
 Cell[BoxData[
  FormBox[
   SubscriptBox["\[Delta]\[Rho]", "2"], TraditionalForm]]]
}], "Subsubsection",
 CellChangeTimes->{{3.553721690765481*^9, 3.553721709405624*^9}}],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{
     FractionBox[
      RowBox[{"(", 
       RowBox[{
        SuperscriptBox["\[ScriptCapitalC]", 
         RowBox[{"[", 
          RowBox[{"+", "o"}], "]"}]], "-", 
        SuperscriptBox["\[ScriptCapitalC]", 
         RowBox[{"[", 
          RowBox[{"+", "2"}], "]"}]]}], ")"}], 
      RowBox[{"(", 
       RowBox[{
        SubscriptBox[
         StyleBox["\[GothicQ]",
          FontColor->RGBColor[0.54, 0.35, 0.15]], "2"], "-", 
        SubsuperscriptBox[
         StyleBox["\[GothicQ]",
          FontColor->RGBColor[0.54, 0.35, 0.15]], "2", 
         RowBox[{"[", "2", "]"}]]}], ")"}]], "+", 
     FractionBox[
      RowBox[{"-", 
       RowBox[{"(", 
        RowBox[{
         SuperscriptBox["\[ScriptCapitalC]", 
          RowBox[{"[", 
           RowBox[{"-", "o"}], "]"}]], "-", 
         SuperscriptBox["\[ScriptCapitalC]", 
          RowBox[{"[", 
           RowBox[{"-", "2"}], "]"}]]}], ")"}]}], 
      RowBox[{"(", 
       RowBox[{
        SubscriptBox[
         OverscriptBox[
          StyleBox["\[GothicQ]",
           FontColor->RGBColor[0.54, 0.35, 0.15]], 
          StyleBox["_",
           FontColor->RGBColor[0.54, 0.35, 0.15]]], "2"], "-", 
        SubsuperscriptBox[
         OverscriptBox[
          StyleBox["\[GothicQ]",
           FontColor->RGBColor[0.54, 0.35, 0.15]], 
          StyleBox["_",
           FontColor->RGBColor[0.54, 0.35, 0.15]]], "2", 
         RowBox[{"[", 
          RowBox[{"-", "2"}], "]"}]]}], ")"}]], "-", 
     FractionBox[
      RowBox[{"(", 
       RowBox[{
        SuperscriptBox["\[ScriptCapitalC]", 
         RowBox[{"[", 
          RowBox[{"+", "o"}], "]"}]], "-", 
        SuperscriptBox["\[ScriptCapitalC]", 
         RowBox[{"[", 
          RowBox[{"-", "2"}], "]"}]]}], ")"}], 
      RowBox[{"(", 
       RowBox[{
        SubscriptBox[
         StyleBox["\[GothicQ]",
          FontColor->RGBColor[0.54, 0.35, 0.15]], "2"], "+", 
        SubsuperscriptBox[
         OverscriptBox[
          StyleBox["\[GothicQ]",
           FontColor->RGBColor[0.54, 0.35, 0.15]], "_"], "2", 
         RowBox[{"[", 
          RowBox[{"-", "2"}], "]"}]]}], ")"}]], "-", 
     FractionBox[
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", 
         SuperscriptBox["\[ScriptCapitalC]", 
          RowBox[{"[", 
           RowBox[{"-", "o"}], "]"}]]}], "+", 
        SuperscriptBox["\[ScriptCapitalC]", 
         RowBox[{"[", 
          RowBox[{"+", "2"}], "]"}]]}], ")"}], 
      RowBox[{"(", 
       RowBox[{
        SubscriptBox[
         OverscriptBox[
          StyleBox["\[GothicQ]",
           FontColor->RGBColor[0.54, 0.35, 0.15]], "_"], "2"], "+", 
        SubsuperscriptBox[
         StyleBox["\[GothicQ]",
          FontColor->RGBColor[0.54, 0.35, 0.15]], "2", 
         RowBox[{"[", 
          RowBox[{"+", "2"}], "]"}]]}], ")"}]]}], "/.", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"q$u", "\[Rule]", "q$"}], ",", 
      RowBox[{"q$ub", "\[Rule]", "q$b"}]}], "}"}]}], "/.", "largevolume"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"tmp", "=", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"Series", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"%", "/.", 
         RowBox[{"u", "\[Rule]", 
          RowBox[{"2", "g", " ", "z"}]}]}], "//.", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"xxx", ":", 
           RowBox[{"(", 
            RowBox[{"Alternatives", "@@", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{"Q0", "[", 
                RowBox[{"_", ":", "0"}], "]"}], ",", 
               RowBox[{"Q", "[", 
                RowBox[{"_", ":", "0"}], "]"}], ",", 
               SubscriptBox["\[Gamma]", "0"], ",", 
               RowBox[{"x", "[", 
                RowBox[{"_", ":", "0"}], "]"}]}], "}"}]}], ")"}]}], 
          "\[RuleDelayed]", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{
             RowBox[{
              RowBox[{"xxx", "/.", "subQ0"}], "/.", "subJuk"}], "/.", 
             RowBox[{"leadweak", "[", "4", "]"}]}], "/.", 
            RowBox[{"u", "\[Rule]", 
             RowBox[{"2", "g", " ", "z"}]}]}], ")"}]}], ")"}]}], ",", 
       RowBox[{"{", 
        RowBox[{"g", ",", "0", ",", "8"}], "}"}]}], "]"}], "/.", 
     RowBox[{
      SuperscriptBox[
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          RowBox[{"-", "\[ImaginaryI]"}], " ", "z"}], "+", 
         SqrtBox[
          RowBox[{"1", "-", 
           SuperscriptBox["z", "2"]}]]}], ")"}], 
       RowBox[{"a_", "/;", 
        RowBox[{"a", "<", "0"}]}]], "\[RuleDelayed]", 
      SuperscriptBox[
       RowBox[{"(", 
        FractionBox["1", 
         RowBox[{
          RowBox[{"\[ImaginaryI]", " ", "z"}], "+", 
          SqrtBox[
           RowBox[{"1", "-", 
            SuperscriptBox["z", "2"]}]]}]], ")"}], "a"]}]}], "//", 
    "Simplify"}], "//", "Normal"}]}]}], "Input",
 CellChangeTimes->{{3.5537217283244762`*^9, 3.553721954008107*^9}, {
   3.555823475656831*^9, 3.555823528850947*^9}, {3.5558236419898367`*^9, 
   3.5558236435491953`*^9}, {3.555823700204507*^9, 3.555823701245968*^9}, 
   3.555853152213056*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{"72", " ", 
   SuperscriptBox["g", "3"], " ", 
   SuperscriptBox["z", "2"], " ", 
   SqrtBox[
    RowBox[{"1", "-", 
     SuperscriptBox["z", "2"]}]], " ", 
   RowBox[{"(", 
    RowBox[{
     SuperscriptBox[
      StyleBox["\[ScriptCapitalC]",
       FontColor->RGBColor[0, 0, 0.8]], 
      RowBox[{"[", 
       RowBox[{"-", "2"}], "]"}]], "-", 
     SuperscriptBox[
      StyleBox["\[ScriptCapitalC]",
       FontColor->RGBColor[0, 0, 0.8]], 
      RowBox[{"[", "2", "]"}]]}], ")"}]}], "-", 
  RowBox[{"96", " ", 
   SuperscriptBox["g", "5"], " ", 
   SqrtBox[
    RowBox[{"1", "-", 
     SuperscriptBox["z", "2"]}]], " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"-", "1"}], "+", 
     RowBox[{"8", " ", 
      SuperscriptBox["z", "2"]}]}], ")"}], " ", 
   RowBox[{"(", 
    RowBox[{
     SuperscriptBox[
      StyleBox["\[ScriptCapitalC]",
       FontColor->RGBColor[0, 0, 0.8]], 
      RowBox[{"[", 
       RowBox[{"-", "2"}], "]"}]], "-", 
     SuperscriptBox[
      StyleBox["\[ScriptCapitalC]",
       FontColor->RGBColor[0, 0, 0.8]], 
      RowBox[{"[", "2", "]"}]]}], ")"}]}], "+", 
  RowBox[{"6", " ", "g", " ", 
   SqrtBox[
    RowBox[{"1", "-", 
     SuperscriptBox["z", "2"]}]], " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"-", 
      SuperscriptBox[
       StyleBox["\[ScriptCapitalC]",
        FontColor->RGBColor[0, 0, 0.8]], 
       RowBox[{"[", 
        RowBox[{"-", "2"}], "]"}]]}], "+", 
     SuperscriptBox[
      StyleBox["\[ScriptCapitalC]",
       FontColor->RGBColor[0, 0, 0.8]], 
      RowBox[{"[", "2", "]"}]]}], ")"}]}], "+", 
  RowBox[{"12", " ", 
   SuperscriptBox["g", "2"], " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"2", " ", "\[ImaginaryI]", " ", "z", " ", 
      SqrtBox[
       RowBox[{"1", "-", 
        SuperscriptBox["z", "2"]}]], " ", 
      RowBox[{"(", 
       RowBox[{
        SuperscriptBox[
         StyleBox["\[ScriptCapitalC]",
          FontColor->RGBColor[0, 0, 0.8]], 
         RowBox[{"[", 
          RowBox[{"-", "2"}], "]"}]], "+", 
        SuperscriptBox[
         StyleBox["\[ScriptCapitalC]",
          FontColor->RGBColor[0, 0, 0.8]], 
         RowBox[{"[", "2", "]"}]]}], ")"}]}], "+", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "1"}], "+", 
        RowBox[{"2", " ", 
         SuperscriptBox["z", "2"]}], "-", 
        RowBox[{"2", " ", "\[ImaginaryI]", " ", "z", " ", 
         SqrtBox[
          RowBox[{"1", "-", 
           SuperscriptBox["z", "2"]}]]}]}], ")"}], " ", 
      SuperscriptBox[
       StyleBox["\[ScriptCapitalC]",
        FontColor->RGBColor[0, 0, 0.8]], 
       RowBox[{"[", 
        RowBox[{"-", "o"}], "]"}]]}], "+", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"1", "-", 
        RowBox[{"2", " ", 
         SuperscriptBox["z", "2"]}], "-", 
        RowBox[{"2", " ", "\[ImaginaryI]", " ", "z", " ", 
         SqrtBox[
          RowBox[{"1", "-", 
           SuperscriptBox["z", "2"]}]]}]}], ")"}], " ", 
      SuperscriptBox[
       StyleBox["\[ScriptCapitalC]",
        FontColor->RGBColor[0, 0, 0.8]], 
       RowBox[{"[", "o", "]"}]]}]}], ")"}]}], "+", 
  RowBox[{"6", " ", 
   SuperscriptBox["g", "4"], " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{
      RowBox[{"-", "2"}], " ", "\[ImaginaryI]", " ", "z", " ", 
      SqrtBox[
       RowBox[{"1", "-", 
        SuperscriptBox["z", "2"]}]], " ", 
      RowBox[{"(", 
       RowBox[{"7", "+", 
        RowBox[{"12", " ", 
         SuperscriptBox["z", "2"]}]}], ")"}], " ", 
      RowBox[{"(", 
       RowBox[{
        SuperscriptBox[
         StyleBox["\[ScriptCapitalC]",
          FontColor->RGBColor[0, 0, 0.8]], 
         RowBox[{"[", 
          RowBox[{"-", "2"}], "]"}]], "+", 
        SuperscriptBox[
         StyleBox["\[ScriptCapitalC]",
          FontColor->RGBColor[0, 0, 0.8]], 
         RowBox[{"[", "2", "]"}]]}], ")"}]}], "+", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"11", "-", 
        RowBox[{"2", " ", 
         SuperscriptBox["z", "2"]}], "-", 
        RowBox[{"24", " ", 
         SuperscriptBox["z", "4"]}], "+", 
        RowBox[{"14", " ", "\[ImaginaryI]", " ", "z", " ", 
         SqrtBox[
          RowBox[{"1", "-", 
           SuperscriptBox["z", "2"]}]]}], "+", 
        RowBox[{"24", " ", "\[ImaginaryI]", " ", 
         SuperscriptBox["z", "3"], " ", 
         SqrtBox[
          RowBox[{"1", "-", 
           SuperscriptBox["z", "2"]}]]}]}], ")"}], " ", 
      SuperscriptBox[
       StyleBox["\[ScriptCapitalC]",
        FontColor->RGBColor[0, 0, 0.8]], 
       RowBox[{"[", 
        RowBox[{"-", "o"}], "]"}]]}], "+", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "11"}], "+", 
        RowBox[{"2", " ", 
         SuperscriptBox["z", "2"]}], "+", 
        RowBox[{"24", " ", 
         SuperscriptBox["z", "4"]}], "+", 
        RowBox[{"14", " ", "\[ImaginaryI]", " ", "z", " ", 
         SqrtBox[
          RowBox[{"1", "-", 
           SuperscriptBox["z", "2"]}]]}], "+", 
        RowBox[{"24", " ", "\[ImaginaryI]", " ", 
         SuperscriptBox["z", "3"], " ", 
         SqrtBox[
          RowBox[{"1", "-", 
           SuperscriptBox["z", "2"]}]]}]}], ")"}], " ", 
      SuperscriptBox[
       StyleBox["\[ScriptCapitalC]",
        FontColor->RGBColor[0, 0, 0.8]], 
       RowBox[{"[", "o", "]"}]]}]}], ")"}]}], "+", 
  RowBox[{"12", " ", 
   SuperscriptBox["g", "6"], " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{
      RowBox[{"-", "8"}], " ", "\[ImaginaryI]", " ", "z", " ", 
      SqrtBox[
       RowBox[{"1", "-", 
        SuperscriptBox["z", "2"]}]], " ", 
      RowBox[{"(", 
       RowBox[{"4", "-", 
        RowBox[{"43", " ", 
         SuperscriptBox["z", "2"]}], "+", 
        RowBox[{"18", " ", 
         SuperscriptBox["z", "4"]}]}], ")"}], " ", 
      RowBox[{"(", 
       RowBox[{
        SuperscriptBox[
         StyleBox["\[ScriptCapitalC]",
          FontColor->RGBColor[0, 0, 0.8]], 
         RowBox[{"[", 
          RowBox[{"-", "2"}], "]"}]], "+", 
        SuperscriptBox[
         StyleBox["\[ScriptCapitalC]",
          FontColor->RGBColor[0, 0, 0.8]], 
         RowBox[{"[", "2", "]"}]]}], ")"}]}], "+", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "25"}], "-", 
        RowBox[{"188", " ", 
         SuperscriptBox["z", "2"]}], "+", 
        RowBox[{"416", " ", 
         SuperscriptBox["z", "4"]}], "-", 
        RowBox[{"144", " ", 
         SuperscriptBox["z", "6"]}], "+", 
        RowBox[{"32", " ", "\[ImaginaryI]", " ", "z", " ", 
         SqrtBox[
          RowBox[{"1", "-", 
           SuperscriptBox["z", "2"]}]]}], "-", 
        RowBox[{"344", " ", "\[ImaginaryI]", " ", 
         SuperscriptBox["z", "3"], " ", 
         SqrtBox[
          RowBox[{"1", "-", 
           SuperscriptBox["z", "2"]}]]}], "+", 
        RowBox[{"144", " ", "\[ImaginaryI]", " ", 
         SuperscriptBox["z", "5"], " ", 
         SqrtBox[
          RowBox[{"1", "-", 
           SuperscriptBox["z", "2"]}]]}]}], ")"}], " ", 
      SuperscriptBox[
       StyleBox["\[ScriptCapitalC]",
        FontColor->RGBColor[0, 0, 0.8]], 
       RowBox[{"[", 
        RowBox[{"-", "o"}], "]"}]]}], "+", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"25", "+", 
        RowBox[{"188", " ", 
         SuperscriptBox["z", "2"]}], "-", 
        RowBox[{"416", " ", 
         SuperscriptBox["z", "4"]}], "+", 
        RowBox[{"144", " ", 
         SuperscriptBox["z", "6"]}], "+", 
        RowBox[{"32", " ", "\[ImaginaryI]", " ", "z", " ", 
         SqrtBox[
          RowBox[{"1", "-", 
           SuperscriptBox["z", "2"]}]]}], "-", 
        RowBox[{"344", " ", "\[ImaginaryI]", " ", 
         SuperscriptBox["z", "3"], " ", 
         SqrtBox[
          RowBox[{"1", "-", 
           SuperscriptBox["z", "2"]}]]}], "+", 
        RowBox[{"144", " ", "\[ImaginaryI]", " ", 
         SuperscriptBox["z", "5"], " ", 
         SqrtBox[
          RowBox[{"1", "-", 
           SuperscriptBox["z", "2"]}]]}]}], ")"}], " ", 
      SuperscriptBox[
       StyleBox["\[ScriptCapitalC]",
        FontColor->RGBColor[0, 0, 0.8]], 
       RowBox[{"[", "o", "]"}]]}]}], ")"}]}], "-", 
  RowBox[{"12", " ", 
   SuperscriptBox["g", "7"], " ", 
   SqrtBox[
    RowBox[{"1", "-", 
     SuperscriptBox["z", "2"]}]], " ", 
   RowBox[{"(", 
    RowBox[{
     SuperscriptBox[
      StyleBox["\[ScriptCapitalC]",
       FontColor->RGBColor[0, 0, 0.8]], 
      RowBox[{"[", 
       RowBox[{"-", "2"}], "]"}]], "-", 
     SuperscriptBox[
      StyleBox["\[ScriptCapitalC]",
       FontColor->RGBColor[0, 0, 0.8]], 
      RowBox[{"[", "2", "]"}]]}], ")"}], " ", 
   RowBox[{"(", 
    RowBox[{"75", "-", 
     RowBox[{"118", " ", 
      SuperscriptBox["z", "2"]}], "-", 
     RowBox[{"1288", " ", 
      SuperscriptBox["z", "4"]}], "+", 
     RowBox[{"864", " ", 
      SuperscriptBox["z", "6"]}], "-", 
     RowBox[{"12", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3"]}]}], ")"}]}], "+", 
  RowBox[{"24", " ", 
   SuperscriptBox["g", "8"], " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"4", " ", "\[ImaginaryI]", " ", "z", " ", 
      SqrtBox[
       RowBox[{"1", "-", 
        SuperscriptBox["z", "2"]}]], " ", 
      RowBox[{"(", 
       RowBox[{
        SuperscriptBox[
         StyleBox["\[ScriptCapitalC]",
          FontColor->RGBColor[0, 0, 0.8]], 
         RowBox[{"[", 
          RowBox[{"-", "2"}], "]"}]], "+", 
        SuperscriptBox[
         StyleBox["\[ScriptCapitalC]",
          FontColor->RGBColor[0, 0, 0.8]], 
         RowBox[{"[", "2", "]"}]]}], ")"}], " ", 
      RowBox[{"(", 
       RowBox[{"81", "-", 
        RowBox[{"296", " ", 
         SuperscriptBox["z", "2"]}], "-", 
        RowBox[{"376", " ", 
         SuperscriptBox["z", "4"]}], "+", 
        RowBox[{"432", " ", 
         SuperscriptBox["z", "6"]}], "-", 
        RowBox[{"15", " ", 
         SubscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "3"]}]}], ")"}]}], "+", 
     RowBox[{
      SuperscriptBox[
       StyleBox["\[ScriptCapitalC]",
        FontColor->RGBColor[0, 0, 0.8]], 
       RowBox[{"[", 
        RowBox[{"-", "o"}], "]"}]], " ", 
      RowBox[{"(", 
       RowBox[{"56", "-", 
        RowBox[{"644", " ", 
         SuperscriptBox["z", "4"]}], "-", 
        RowBox[{"2368", " ", 
         SuperscriptBox["z", "6"]}], "+", 
        RowBox[{"1728", " ", 
         SuperscriptBox["z", "8"]}], "+", 
        RowBox[{"1184", " ", "\[ImaginaryI]", " ", 
         SuperscriptBox["z", "3"], " ", 
         SqrtBox[
          RowBox[{"1", "-", 
           SuperscriptBox["z", "2"]}]]}], "+", 
        RowBox[{"1504", " ", "\[ImaginaryI]", " ", 
         SuperscriptBox["z", "5"], " ", 
         SqrtBox[
          RowBox[{"1", "-", 
           SuperscriptBox["z", "2"]}]]}], "-", 
        RowBox[{"1728", " ", "\[ImaginaryI]", " ", 
         SuperscriptBox["z", "7"], " ", 
         SqrtBox[
          RowBox[{"1", "-", 
           SuperscriptBox["z", "2"]}]]}], "+", 
        RowBox[{
         SuperscriptBox["z", "2"], " ", 
         RowBox[{"(", 
          RowBox[{"1017", "-", 
           RowBox[{"60", " ", 
            SubscriptBox[
             StyleBox["\[Zeta]",
              FontWeight->Bold,
              FontColor->GrayLevel[0.4]], "3"]}]}], ")"}]}], "+", 
        RowBox[{"30", " ", 
         SubscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "3"]}], "+", 
        RowBox[{"12", " ", "\[ImaginaryI]", " ", "z", " ", 
         SqrtBox[
          RowBox[{"1", "-", 
           SuperscriptBox["z", "2"]}]], " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"-", "27"}], "+", 
           RowBox[{"5", " ", 
            SubscriptBox[
             StyleBox["\[Zeta]",
              FontWeight->Bold,
              FontColor->GrayLevel[0.4]], "3"]}]}], ")"}]}]}], ")"}]}], "+", 
     RowBox[{
      SuperscriptBox[
       StyleBox["\[ScriptCapitalC]",
        FontColor->RGBColor[0, 0, 0.8]], 
       RowBox[{"[", "o", "]"}]], " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "56"}], "+", 
        RowBox[{"644", " ", 
         SuperscriptBox["z", "4"]}], "+", 
        RowBox[{"2368", " ", 
         SuperscriptBox["z", "6"]}], "-", 
        RowBox[{"1728", " ", 
         SuperscriptBox["z", "8"]}], "+", 
        RowBox[{"1184", " ", "\[ImaginaryI]", " ", 
         SuperscriptBox["z", "3"], " ", 
         SqrtBox[
          RowBox[{"1", "-", 
           SuperscriptBox["z", "2"]}]]}], "+", 
        RowBox[{"1504", " ", "\[ImaginaryI]", " ", 
         SuperscriptBox["z", "5"], " ", 
         SqrtBox[
          RowBox[{"1", "-", 
           SuperscriptBox["z", "2"]}]]}], "-", 
        RowBox[{"1728", " ", "\[ImaginaryI]", " ", 
         SuperscriptBox["z", "7"], " ", 
         SqrtBox[
          RowBox[{"1", "-", 
           SuperscriptBox["z", "2"]}]]}], "-", 
        RowBox[{"30", " ", 
         SubscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "3"]}], "+", 
        RowBox[{"12", " ", "\[ImaginaryI]", " ", "z", " ", 
         SqrtBox[
          RowBox[{"1", "-", 
           SuperscriptBox["z", "2"]}]], " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"-", "27"}], "+", 
           RowBox[{"5", " ", 
            SubscriptBox[
             StyleBox["\[Zeta]",
              FontWeight->Bold,
              FontColor->GrayLevel[0.4]], "3"]}]}], ")"}]}], "+", 
        RowBox[{"3", " ", 
         SuperscriptBox["z", "2"], " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"-", "339"}], "+", 
           RowBox[{"20", " ", 
            SubscriptBox[
             StyleBox["\[Zeta]",
              FontWeight->Bold,
              FontColor->GrayLevel[0.4]], "3"]}]}], ")"}]}]}], ")"}]}]}], 
    ")"}]}]}]], "Output",
 CellChangeTimes->{{3.553721882164321*^9, 3.5537218999003267`*^9}, 
   3.5537219582111397`*^9, {3.5558234943490057`*^9, 3.555823529826674*^9}, 
   3.555823644274384*^9, 3.5558237020066757`*^9, 3.555853158542428*^9, 
   3.564855735955724*^9}]
}, Open  ]],

Cell["\<\
For \[ScriptCapitalC] we make the same thing as we did for \[Delta]\[Rho] \
case:\
\>", "Text",
 CellChangeTimes->{{3.555823551589016*^9, 3.555823564106531*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{
      SuperscriptBox[
       StyleBox["\[ScriptCapitalC]", "Dafault"], 
       RowBox[{"[", "o", "]"}]], "\[Rule]", " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         FractionBox["1", "2"], "\[Delta]\[Rho]2"}], "+", 
        RowBox[{"PV", "[", "\[Delta]\[Rho]2", "]"}]}], ")"}]}], ",", 
     RowBox[{
      SuperscriptBox[
       StyleBox["\[ScriptCapitalC]", "Dafault"], 
       RowBox[{"[", 
        RowBox[{"-", "o"}], "]"}]], "\[Rule]", " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         RowBox[{"-", 
          FractionBox["1", "2"]}], "\[Delta]\[Rho]2"}], "+", 
        RowBox[{"PV", "[", "\[Delta]\[Rho]2", "]"}]}], ")"}]}], ",", 
     RowBox[{
      SuperscriptBox["\[ScriptCapitalC]", 
       RowBox[{"[", 
        RowBox[{"+", "2"}], "]"}]], "\[Rule]", " ", 
      RowBox[{"Normal", "@", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          RowBox[{"Expand", "/@", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"Series", "[", 
              RowBox[{
               RowBox[{
                RowBox[{"-", 
                 FractionBox[
                  RowBox[{"2", "g"}], 
                  RowBox[{"2", " ", "\[ImaginaryI]"}]]}], 
                FractionBox["w", 
                 RowBox[{
                  RowBox[{"2", "g", " ", "z"}], "+", "\[ImaginaryI]"}]]}], 
               ",", 
               RowBox[{"{", 
                RowBox[{"g", ",", "0", ",", "16"}], "}"}]}], "]"}], "/.", 
             RowBox[{"z", "\[Rule]", 
              RowBox[{"(", 
               RowBox[{"z", "-", "w"}], ")"}]}]}], ")"}]}], "/.", 
          RowBox[{
           SuperscriptBox["w", "a_."], "\[RuleDelayed]", 
           RowBox[{"If", "[", 
            RowBox[{
             RowBox[{"EvenQ", "[", "a", "]"}], ",", "0", ",", 
             SuperscriptBox["w", "a"]}], "]"}]}]}], "/.", 
         RowBox[{
          SuperscriptBox["w", "a_."], "\[RuleDelayed]", 
          RowBox[{"M", "[", 
           RowBox[{
            SuperscriptBox["w", 
             RowBox[{"a", "-", "1"}]], "\[Delta]\[Rho]2"}], "]"}]}]}], 
        ")"}]}]}], ",", 
     RowBox[{
      SuperscriptBox["\[ScriptCapitalC]", 
       RowBox[{"[", 
        RowBox[{"-", "2"}], "]"}]], "\[Rule]", " ", 
      RowBox[{"Normal", "@", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          RowBox[{"Expand", "/@", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"Series", "[", 
              RowBox[{
               RowBox[{
                RowBox[{"-", 
                 FractionBox[
                  RowBox[{"2", "g"}], 
                  RowBox[{"2", " ", "\[ImaginaryI]"}]]}], 
                FractionBox["w", 
                 RowBox[{
                  RowBox[{"2", "g", " ", "z"}], "-", "\[ImaginaryI]"}]]}], 
               ",", 
               RowBox[{"{", 
                RowBox[{"g", ",", "0", ",", "16"}], "}"}]}], "]"}], "/.", 
             RowBox[{"z", "\[Rule]", 
              RowBox[{"(", 
               RowBox[{"z", "-", "w"}], ")"}]}]}], ")"}]}], "/.", 
          RowBox[{
           SuperscriptBox["w", "a_."], "\[RuleDelayed]", 
           RowBox[{"If", "[", 
            RowBox[{
             RowBox[{"EvenQ", "[", "a", "]"}], ",", "0", ",", 
             SuperscriptBox["w", "a"]}], "]"}]}]}], "/.", 
         RowBox[{
          SuperscriptBox["w", "a_."], "\[RuleDelayed]", 
          RowBox[{"M", "[", 
           RowBox[{
            SuperscriptBox["w", 
             RowBox[{"a", "-", "1"}]], "\[Delta]\[Rho]2"}], "]"}]}]}], 
        ")"}]}]}]}], "}"}], "/.", 
   RowBox[{"\[Delta]\[Rho]2", "\[Rule]", 
    RowBox[{"Expand", "[", 
     RowBox[{
      SuperscriptBox["g", "7"], 
      RowBox[{"(", 
       RowBox[{
        SubscriptBox["\[Delta]\[Rho]2", "lead"], "+", 
        RowBox[{
         SuperscriptBox["g", "2"], 
         SubscriptBox["\[Delta]\[Rho]2", "sublead"]}], "+", 
        RowBox[{
         SuperscriptBox["g", "4"], 
         SubscriptBox["\[Delta]\[Rho]2", "sublead2"]}]}], ")"}]}], "]"}]}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{"%", "/.", 
        RowBox[{
         RowBox[{"PV", "[", "a_", "]"}], "\[RuleDelayed]", 
         RowBox[{"PV", "[", 
          RowBox[{"Expand", "[", "a", "]"}], "]"}]}]}], "//.", 
       RowBox[{
        RowBox[{"PV", "[", 
         RowBox[{
          RowBox[{
           SuperscriptBox["g", "a_."], "b_."}], "+", "c_"}], "]"}], 
        "\[RuleDelayed]", 
        RowBox[{
         RowBox[{
          SuperscriptBox["g", "a"], 
          RowBox[{"PV", "[", "b", "]"}]}], "+", 
         RowBox[{"PV", "[", "c", "]"}]}]}]}], "/.", 
      RowBox[{
       RowBox[{"PV", "[", 
        RowBox[{
         SuperscriptBox["g", "a_."], "b_."}], "]"}], "\[RuleDelayed]", 
       RowBox[{
        SuperscriptBox["g", "a"], 
        RowBox[{"PV", "[", "b", "]"}]}]}]}], "/.", 
     RowBox[{
      RowBox[{"M", "[", "a_", "]"}], "\[RuleDelayed]", 
      RowBox[{"M", "[", 
       RowBox[{"Expand", "[", "a", "]"}], "]"}]}]}], "//.", 
    RowBox[{
     RowBox[{"M", "[", 
      RowBox[{
       RowBox[{
        SuperscriptBox["g", "a_."], "b_."}], "+", "c_"}], "]"}], 
     "\[RuleDelayed]", 
     RowBox[{
      RowBox[{
       SuperscriptBox["g", "a"], 
       RowBox[{"M", "[", "b", "]"}]}], "+", 
      RowBox[{"M", "[", "c", "]"}]}]}]}], "/.", 
   RowBox[{
    RowBox[{"M", "[", 
     RowBox[{
      SuperscriptBox["g", "a_."], "b_."}], "]"}], "\[RuleDelayed]", 
    RowBox[{
     SuperscriptBox["g", "a"], 
     RowBox[{"M", "[", "b", "]"}]}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"tmpsubs", "=", 
   RowBox[{"%", "/.", 
    RowBox[{
     RowBox[{"Rule", "[", 
      RowBox[{"a_", ",", "b_"}], "]"}], "\[RuleDelayed]", 
     RowBox[{"Rule", "[", 
      RowBox[{"a", ",", 
       RowBox[{"Normal", "@", 
        RowBox[{"Series", "[", 
         RowBox[{"b", ",", 
          RowBox[{"{", 
           RowBox[{"g", ",", "0", ",", "21"}], "}"}]}], "]"}]}]}], 
      "]"}]}]}]}], ";"}]}], "Input",
 CellChangeTimes->{{3.555823600656617*^9, 3.555823633343945*^9}, {
  3.55585322671714*^9, 3.5558532300766373`*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ratioq2\[Delta]\[Rho]2", "=", 
  RowBox[{"Collect", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"Series", "[", 
      RowBox[{
       RowBox[{"tmp", "/.", "tmpsubs"}], ",", 
       RowBox[{"{", 
        RowBox[{"g", ",", "0", ",", "14"}], "}"}]}], "]"}], "//", "Normal"}], 
    ",", 
    RowBox[{"{", 
     RowBox[{"g", ",", 
      SqrtBox[
       RowBox[{"1", "-", 
        SuperscriptBox["z", "2"]}]]}], "}"}], ",", "Simplify"}], 
   "]"}]}]], "Input",
 CellChangeTimes->{{3.555823664344098*^9, 3.555823705633832*^9}, {
  3.5558237870777807`*^9, 3.555823787645262*^9}, {3.555823819211955*^9, 
  3.5558238424438667`*^9}, {3.555823895446691*^9, 3.5558239108836927`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   SuperscriptBox["g", "9"], " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"12", " ", 
      SqrtBox[
       RowBox[{"1", "-", 
        SuperscriptBox["z", "2"]}]], " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"M", "[", 
         SubscriptBox["\[Delta]\[Rho]2", "lead"], "]"}], "-", 
        RowBox[{"4", " ", "\[ImaginaryI]", " ", "z", " ", 
         RowBox[{"PV", "[", 
          SubscriptBox["\[Delta]\[Rho]2", "lead"], "]"}]}]}], ")"}]}], "+", 
     RowBox[{"12", " ", 
      RowBox[{"(", 
       RowBox[{"1", "-", 
        RowBox[{"2", " ", 
         SuperscriptBox["z", "2"]}]}], ")"}], " ", 
      SubscriptBox["\[Delta]\[Rho]2", "lead"]}]}], ")"}]}], "+", 
  RowBox[{
   SuperscriptBox["g", "11"], " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"12", " ", "\[ImaginaryI]", " ", 
      SqrtBox[
       RowBox[{"1", "-", 
        SuperscriptBox["z", "2"]}]], " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"24", " ", "\[ImaginaryI]", " ", 
         SuperscriptBox["z", "2"], " ", 
         RowBox[{"M", "[", 
          SubscriptBox["\[Delta]\[Rho]2", "lead"], "]"}]}], "+", 
        RowBox[{"4", " ", "\[ImaginaryI]", " ", 
         RowBox[{"M", "[", 
          RowBox[{
           SuperscriptBox["w", "2"], " ", 
           SubscriptBox["\[Delta]\[Rho]2", "lead"]}], "]"}]}], "-", 
        RowBox[{"\[ImaginaryI]", " ", 
         RowBox[{"M", "[", 
          SubscriptBox["\[Delta]\[Rho]2", "sublead"], "]"}]}], "+", 
        RowBox[{"14", " ", "z", " ", 
         RowBox[{"PV", "[", 
          SubscriptBox["\[Delta]\[Rho]2", "lead"], "]"}]}], "+", 
        RowBox[{"24", " ", 
         SuperscriptBox["z", "3"], " ", 
         RowBox[{"PV", "[", 
          SubscriptBox["\[Delta]\[Rho]2", "lead"], "]"}]}], "-", 
        RowBox[{"4", " ", "z", " ", 
         RowBox[{"PV", "[", 
          SubscriptBox["\[Delta]\[Rho]2", "sublead"], "]"}]}]}], ")"}]}], "+", 
     RowBox[{"6", " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           RowBox[{"-", "11"}], "+", 
           RowBox[{"2", " ", 
            SuperscriptBox["z", "2"]}], "+", 
           RowBox[{"24", " ", 
            SuperscriptBox["z", "4"]}]}], ")"}], " ", 
         SubscriptBox["\[Delta]\[Rho]2", "lead"]}], "+", 
        RowBox[{"2", " ", 
         RowBox[{"(", 
          RowBox[{"1", "-", 
           RowBox[{"2", " ", 
            SuperscriptBox["z", "2"]}]}], ")"}], " ", 
         SubscriptBox["\[Delta]\[Rho]2", "sublead"]}]}], ")"}]}]}], ")"}]}], 
  "+", 
  RowBox[{
   SuperscriptBox["g", "13"], " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"12", " ", 
      SqrtBox[
       RowBox[{"1", "-", 
        SuperscriptBox["z", "2"]}]], " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"4", " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"-", "4"}], "+", 
           RowBox[{"39", " ", 
            SuperscriptBox["z", "2"]}], "+", 
           RowBox[{"36", " ", 
            SuperscriptBox["z", "4"]}]}], ")"}], " ", 
         RowBox[{"M", "[", 
          SubscriptBox["\[Delta]\[Rho]2", "lead"], "]"}]}], "+", 
        RowBox[{"240", " ", 
         SuperscriptBox["z", "2"], " ", 
         RowBox[{"M", "[", 
          RowBox[{
           SuperscriptBox["w", "2"], " ", 
           SubscriptBox["\[Delta]\[Rho]2", "lead"]}], "]"}]}], "+", 
        RowBox[{"16", " ", 
         RowBox[{"M", "[", 
          RowBox[{
           SuperscriptBox["w", "4"], " ", 
           SubscriptBox["\[Delta]\[Rho]2", "lead"]}], "]"}]}], "-", 
        RowBox[{"24", " ", 
         SuperscriptBox["z", "2"], " ", 
         RowBox[{"M", "[", 
          SubscriptBox["\[Delta]\[Rho]2", "sublead"], "]"}]}], "-", 
        RowBox[{"4", " ", 
         RowBox[{"M", "[", 
          RowBox[{
           SuperscriptBox["w", "2"], " ", 
           SubscriptBox["\[Delta]\[Rho]2", "sublead"]}], "]"}]}], "+", 
        RowBox[{"M", "[", 
         SubscriptBox["\[Delta]\[Rho]2", "sublead2"], "]"}], "+", 
        RowBox[{"64", " ", "\[ImaginaryI]", " ", "z", " ", 
         RowBox[{"PV", "[", 
          SubscriptBox["\[Delta]\[Rho]2", "lead"], "]"}]}], "-", 
        RowBox[{"688", " ", "\[ImaginaryI]", " ", 
         SuperscriptBox["z", "3"], " ", 
         RowBox[{"PV", "[", 
          SubscriptBox["\[Delta]\[Rho]2", "lead"], "]"}]}], "+", 
        RowBox[{"288", " ", "\[ImaginaryI]", " ", 
         SuperscriptBox["z", "5"], " ", 
         RowBox[{"PV", "[", 
          SubscriptBox["\[Delta]\[Rho]2", "lead"], "]"}]}], "+", 
        RowBox[{"14", " ", "\[ImaginaryI]", " ", "z", " ", 
         RowBox[{"PV", "[", 
          SubscriptBox["\[Delta]\[Rho]2", "sublead"], "]"}]}], "+", 
        RowBox[{"24", " ", "\[ImaginaryI]", " ", 
         SuperscriptBox["z", "3"], " ", 
         RowBox[{"PV", "[", 
          SubscriptBox["\[Delta]\[Rho]2", "sublead"], "]"}]}], "-", 
        RowBox[{"4", " ", "\[ImaginaryI]", " ", "z", " ", 
         RowBox[{"PV", "[", 
          SubscriptBox["\[Delta]\[Rho]2", "sublead2"], "]"}]}]}], ")"}]}], 
     "+", 
     RowBox[{"6", " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         RowBox[{"(", 
          RowBox[{"50", "+", 
           RowBox[{"376", " ", 
            SuperscriptBox["z", "2"]}], "-", 
           RowBox[{"832", " ", 
            SuperscriptBox["z", "4"]}], "+", 
           RowBox[{"288", " ", 
            SuperscriptBox["z", "6"]}]}], ")"}], " ", 
         SubscriptBox["\[Delta]\[Rho]2", "lead"]}], "+", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           RowBox[{"-", "11"}], "+", 
           RowBox[{"2", " ", 
            SuperscriptBox["z", "2"]}], "+", 
           RowBox[{"24", " ", 
            SuperscriptBox["z", "4"]}]}], ")"}], " ", 
         SubscriptBox["\[Delta]\[Rho]2", "sublead"]}], "+", 
        RowBox[{"2", " ", 
         RowBox[{"(", 
          RowBox[{"1", "-", 
           RowBox[{"2", " ", 
            SuperscriptBox["z", "2"]}]}], ")"}], " ", 
         SubscriptBox["\[Delta]\[Rho]2", "sublead2"]}]}], ")"}]}]}], 
    ")"}]}]}]], "Output",
 CellChangeTimes->{{3.555823674301133*^9, 3.55582370632253*^9}, 
   3.555823788411509*^9, 3.555823843172443*^9, 3.555823911445879*^9, 
   3.5558533887323027`*^9, 3.5648557438527184`*^9}]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 "Correction from ",
 Cell[BoxData[
  FormBox[
   SubscriptBox[
    OverscriptBox["W", "^"], 
    RowBox[{"0", ",", "pv"}]], TraditionalForm]]]
}], "Subsubsection",
 CellChangeTimes->{{3.553721690765481*^9, 3.553721709405624*^9}, {
  3.5537230332410517`*^9, 3.553723038227042*^9}}],

Cell[TextData[{
 "Here we have to go one order more, because ",
 Cell[BoxData[
  FormBox[
   RowBox[{
    SuperscriptBox["C", 
     RowBox[{"[", 
      RowBox[{"+", "0"}], "]"}]], "*", 
    SubscriptBox[
     OverscriptBox["W", "^"], 
     RowBox[{"0", ",", "pv"}]]}], TraditionalForm]]],
 " is of order ",
 Cell[BoxData[
  FormBox[
   SuperscriptBox["g", "6"], TraditionalForm]]],
 " (+ corrections )"
}], "Text",
 CellChangeTimes->{{3.5537230490703907`*^9, 3.553723084172709*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"-", 
     RowBox[{"(", 
      RowBox[{
       FractionBox[
        RowBox[{"(", 
         RowBox[{
          SuperscriptBox["\[ScriptCapitalC]", 
           RowBox[{"[", 
            RowBox[{"+", "o"}], "]"}]], "-", 
          SuperscriptBox["\[ScriptCapitalC]", 
           RowBox[{"[", 
            RowBox[{"+", "2"}], "]"}]]}], ")"}], 
        RowBox[{"(", 
         RowBox[{
          SubscriptBox[
           StyleBox["\[GothicQ]",
            FontColor->RGBColor[0.54, 0.35, 0.15]], "2"], "-", 
          SubsuperscriptBox[
           StyleBox["\[GothicQ]",
            FontColor->RGBColor[0.54, 0.35, 0.15]], "2", 
           RowBox[{"[", "2", "]"}]]}], ")"}]], "+", 
       FractionBox[
        RowBox[{"-", 
         RowBox[{"(", 
          RowBox[{
           SuperscriptBox["\[ScriptCapitalC]", 
            RowBox[{"[", 
             RowBox[{"-", "o"}], "]"}]], "-", 
           SuperscriptBox["\[ScriptCapitalC]", 
            RowBox[{"[", 
             RowBox[{"-", "2"}], "]"}]]}], ")"}]}], 
        RowBox[{"(", 
         RowBox[{
          SubscriptBox[
           OverscriptBox[
            StyleBox["\[GothicQ]",
             FontColor->RGBColor[0.54, 0.35, 0.15]], 
            StyleBox["_",
             FontColor->RGBColor[0.54, 0.35, 0.15]]], "2"], "-", 
          SubsuperscriptBox[
           OverscriptBox[
            StyleBox["\[GothicQ]",
             FontColor->RGBColor[0.54, 0.35, 0.15]], 
            StyleBox["_",
             FontColor->RGBColor[0.54, 0.35, 0.15]]], "2", 
           RowBox[{"[", 
            RowBox[{"-", "2"}], "]"}]]}], ")"}]], "-", 
       FractionBox[
        RowBox[{"(", 
         RowBox[{
          SuperscriptBox["\[ScriptCapitalC]", 
           RowBox[{"[", 
            RowBox[{"+", "o"}], "]"}]], "-", 
          SuperscriptBox["\[ScriptCapitalC]", 
           RowBox[{"[", 
            RowBox[{"-", "2"}], "]"}]]}], ")"}], 
        RowBox[{"(", 
         RowBox[{
          SubscriptBox[
           StyleBox["\[GothicQ]",
            FontColor->RGBColor[0.54, 0.35, 0.15]], "2"], "+", 
          SubsuperscriptBox[
           OverscriptBox[
            StyleBox["\[GothicQ]",
             FontColor->RGBColor[0.54, 0.35, 0.15]], "_"], "2", 
           RowBox[{"[", 
            RowBox[{"-", "2"}], "]"}]]}], ")"}]], "-", 
       FractionBox[
        RowBox[{"(", 
         RowBox[{
          RowBox[{"-", 
           SuperscriptBox["\[ScriptCapitalC]", 
            RowBox[{"[", 
             RowBox[{"-", "o"}], "]"}]]}], "+", 
          SuperscriptBox["\[ScriptCapitalC]", 
           RowBox[{"[", 
            RowBox[{"+", "2"}], "]"}]]}], ")"}], 
        RowBox[{"(", 
         RowBox[{
          SubscriptBox[
           OverscriptBox[
            StyleBox["\[GothicQ]",
             FontColor->RGBColor[0.54, 0.35, 0.15]], "_"], "2"], "+", 
          SubsuperscriptBox[
           StyleBox["\[GothicQ]",
            FontColor->RGBColor[0.54, 0.35, 0.15]], "2", 
           RowBox[{"[", 
            RowBox[{"+", "2"}], "]"}]]}], ")"}]]}], ")"}]}], "/.", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"q$u", "\[Rule]", "q$"}], ",", 
      RowBox[{"q$ub", "\[Rule]", "q$b"}]}], "}"}]}], "/.", "largevolume"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"tmp", "=", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"Series", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"%", "/.", 
          RowBox[{"u", "\[Rule]", 
           RowBox[{"2", "g", " ", "z"}]}]}], "//.", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"xxx", ":", 
            RowBox[{"(", 
             RowBox[{"Alternatives", "@@", 
              RowBox[{"{", 
               RowBox[{
                RowBox[{"Q0", "[", 
                 RowBox[{"_", ":", "0"}], "]"}], ",", 
                RowBox[{"Q", "[", 
                 RowBox[{"_", ":", "0"}], "]"}], ",", 
                SubscriptBox["\[Gamma]", "0"], ",", 
                RowBox[{"x", "[", 
                 RowBox[{"_", ":", "0"}], "]"}]}], "}"}]}], ")"}]}], 
           "\[RuleDelayed]", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{
              RowBox[{
               RowBox[{"xxx", "/.", "subQ0"}], "/.", "subJuk"}], "/.", 
              RowBox[{"leadweak", "[", "4", "]"}]}], "/.", 
             RowBox[{"u", "\[Rule]", 
              RowBox[{"2", "g", " ", "z"}]}]}], ")"}]}], ")"}]}], ",", 
        RowBox[{"{", 
         RowBox[{"g", ",", "0", ",", "8"}], "}"}]}], "]"}], "/.", 
      RowBox[{
       SuperscriptBox[
        RowBox[{"(", 
         RowBox[{
          RowBox[{
           RowBox[{"-", "\[ImaginaryI]"}], " ", "z"}], "+", 
          SqrtBox[
           RowBox[{"1", "-", 
            SuperscriptBox["z", "2"]}]]}], ")"}], 
        RowBox[{"a_", "/;", 
         RowBox[{"a", "<", "0"}]}]], "\[RuleDelayed]", 
       SuperscriptBox[
        RowBox[{"(", 
         FractionBox["1", 
          RowBox[{
           RowBox[{"\[ImaginaryI]", " ", "z"}], "+", 
           SqrtBox[
            RowBox[{"1", "-", 
             SuperscriptBox["z", "2"]}]]}]], ")"}], "a"]}]}], "//", 
     "Simplify"}], "//", "Normal"}]}], ";"}]}], "Input",
 CellChangeTimes->{{3.5558243087635307`*^9, 3.55582432847305*^9}, {
  3.5558272547174053`*^9, 3.555827257505205*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   SuperscriptBox["\[ScriptCapitalC]", 
    RowBox[{"[", 
     RowBox[{"\[PlusMinus]", "o"}], "]"}]], "*", "W"}], "\[Equal]", 
  RowBox[{"\[Integral]", 
   RowBox[{
    FractionBox["du", 
     RowBox[{
      RowBox[{"-", "2"}], "\[Pi]", " ", "\[ImaginaryI]"}]], 
    FractionBox["1", 
     RowBox[{
      RowBox[{"2", "g", " ", "z"}], "-", 
      RowBox[{"(", 
       RowBox[{"u", "-", 
        RowBox[{"\[ImaginaryI]", " ", "o"}]}], ")"}]}]], 
    FractionBox["1", "2"], 
    RowBox[{"(", 
     RowBox[{
      SuperscriptBox[
       OverscriptBox["W", "^"], 
       RowBox[{"[", 
        RowBox[{"+", "o"}], "]"}]], "+", 
      SuperscriptBox[
       OverscriptBox["W", "^"], 
       RowBox[{"[", 
        RowBox[{"-", "o"}], "]"}]]}], ")"}]}]}], "\[Equal]", 
  RowBox[{
   RowBox[{
    RowBox[{"\[PlusMinus]", 
     FractionBox["1", "2"]}], 
    SuperscriptBox[
     OverscriptBox["W", "^"], 
     RowBox[{"[", 
      RowBox[{"\[PlusMinus]", "o"}], "]"}]]}], "+", 
   RowBox[{"\[Integral]", 
    RowBox[{
     FractionBox["du", 
      RowBox[{
       RowBox[{"-", "2"}], "\[Pi]", " ", "\[ImaginaryI]"}]], 
     FractionBox["1", "2"], 
     RowBox[{"(", 
      RowBox[{
       FractionBox[
        SuperscriptBox[
         OverscriptBox["W", "^"], 
         RowBox[{"[", 
          RowBox[{"+", "o"}], "]"}]], 
        RowBox[{
         RowBox[{"2", "g", " ", "z"}], "-", 
         RowBox[{"(", 
          RowBox[{"u", "+", 
           RowBox[{"\[ImaginaryI]", " ", "o"}]}], ")"}]}]], "+", 
       FractionBox[
        SuperscriptBox[
         OverscriptBox["W", "^"], 
         RowBox[{"[", 
          RowBox[{"-", "o"}], "]"}]], 
        RowBox[{
         RowBox[{"2", "g", " ", "z"}], "-", 
         RowBox[{"(", 
          RowBox[{"u", "-", 
           RowBox[{"\[ImaginaryI]", " ", "o"}]}], ")"}]}]]}], 
      ")"}]}]}]}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   SuperscriptBox["\[ScriptCapitalC]", 
    RowBox[{"[", 
     RowBox[{"\[PlusMinus]", "2"}], "]"}]], "*", "W"}], "\[Equal]", 
  RowBox[{"\[Integral]", 
   RowBox[{
    FractionBox["du", 
     RowBox[{
      RowBox[{"-", "2"}], "\[Pi]", " ", "\[ImaginaryI]"}]], 
    FractionBox["1", 
     RowBox[{
      RowBox[{
       RowBox[{"2", "g", " ", "z"}], "\[PlusMinus]", "\[ImaginaryI]"}], "-", 
      "u"}]], 
    SubscriptBox[
     OverscriptBox["W", "^"], 
     RowBox[{"0", ",", "pv"}]]}]}]}]}], "Input",
 CellChangeTimes->{{3.5537256528025227`*^9, 3.553725697991482*^9}, {
   3.5537257310731688`*^9, 3.5537258035428667`*^9}, 3.553726111627782*^9, {
   3.55582463480515*^9, 3.55582463515359*^9}, {3.555824666097083*^9, 
   3.555824714627948*^9}, {3.5558247606434402`*^9, 3.555824846435422*^9}}],

Cell["\<\
Since W is symmetric, we can symmetrize integrands. After this there will be \
no residue at zero. As a consequence \[PlusMinus]o prescriptions would be \
irrelevant\
\>", "Text",
 CellChangeTimes->{{3.555825661181712*^9, 3.555825702123271*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{
      FractionBox["1", "2"], 
      RowBox[{"(", 
       RowBox[{
        FractionBox["1", 
         RowBox[{
          RowBox[{"2", "g", " ", "z"}], "-", "u"}]], "+", 
        FractionBox["1", 
         RowBox[{
          RowBox[{"2", "g", " ", "z"}], "+", "u"}]]}], ")"}]}], ",", 
     RowBox[{
      FractionBox["1", "2"], 
      RowBox[{"(", 
       RowBox[{
        FractionBox["1", 
         RowBox[{
          RowBox[{"2", "g", " ", "z"}], "+", "\[ImaginaryI]", "-", "u"}]], 
        "+", 
        FractionBox["1", 
         RowBox[{
          RowBox[{"2", "g", " ", "z"}], "+", "\[ImaginaryI]", "+", "u"}]]}], 
       ")"}]}], ",", 
     RowBox[{
      FractionBox["1", "2"], 
      RowBox[{"(", 
       RowBox[{
        FractionBox["1", 
         RowBox[{
          RowBox[{"2", "g", " ", "z"}], "-", "\[ImaginaryI]", "-", "u"}]], 
        "+", 
        FractionBox["1", 
         RowBox[{
          RowBox[{"2", "g", " ", "z"}], "-", "\[ImaginaryI]", "+", "u"}]]}], 
       ")"}]}]}], "}"}], "//", "Together"}], "//", "Simplify"}]], "Input",
 CellChangeTimes->{{3.555825474496325*^9, 3.555825478504106*^9}, {
  3.555825533302165*^9, 3.5558255597130117`*^9}, {3.5558256249964647`*^9, 
  3.555825626881064*^9}, {3.5558257044791327`*^9, 3.555825731865939*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"-", 
    FractionBox[
     RowBox[{"2", " ", "g", " ", "z"}], 
     RowBox[{
      SuperscriptBox["u", "2"], "-", 
      RowBox[{"4", " ", 
       SuperscriptBox["g", "2"], " ", 
       SuperscriptBox["z", "2"]}]}]]}], ",", 
   FractionBox[
    RowBox[{"\[ImaginaryI]", "+", 
     RowBox[{"2", " ", "g", " ", "z"}]}], 
    RowBox[{
     RowBox[{"-", 
      SuperscriptBox["u", "2"]}], "+", 
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{"\[ImaginaryI]", "+", 
        RowBox[{"2", " ", "g", " ", "z"}]}], ")"}], "2"]}]], ",", 
   FractionBox[
    RowBox[{"\[ImaginaryI]", "-", 
     RowBox[{"2", " ", "g", " ", "z"}]}], 
    RowBox[{
     SuperscriptBox["u", "2"], "-", 
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{"\[ImaginaryI]", "-", 
        RowBox[{"2", " ", "g", " ", "z"}]}], ")"}], "2"]}]]}], 
  "}"}]], "Output",
 CellChangeTimes->{
  3.5558254791025057`*^9, {3.555825554436635*^9, 3.5558255601575603`*^9}, 
   3.555825632244066*^9, 3.555825732284964*^9, 3.555853500372596*^9, 
   3.5648557530191917`*^9}]
}, Open  ]],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   SuperscriptBox["\[ScriptCapitalC]", 
    RowBox[{"[", 
     RowBox[{"\[PlusMinus]", "o"}], "]"}]], "*", "W"}], "\[Equal]", 
  RowBox[{"\[Integral]", 
   RowBox[{
    FractionBox["du", 
     RowBox[{
      RowBox[{"-", "2"}], "\[Pi]", " ", "\[ImaginaryI]"}]], 
    FractionBox["1", 
     RowBox[{
      RowBox[{"2", "g", " ", "z"}], "-", 
      RowBox[{"(", 
       RowBox[{"u", "-", 
        RowBox[{"\[ImaginaryI]", " ", "o"}]}], ")"}]}]], 
    FractionBox["1", "2"], 
    RowBox[{"(", 
     RowBox[{
      SuperscriptBox[
       OverscriptBox["W", "^"], 
       RowBox[{"[", 
        RowBox[{"+", "o"}], "]"}]], "+", 
      SuperscriptBox[
       OverscriptBox["W", "^"], 
       RowBox[{"[", 
        RowBox[{"-", "o"}], "]"}]]}], ")"}]}]}], "\[Equal]", 
  RowBox[{
   RowBox[{
    RowBox[{"\[PlusMinus]", 
     FractionBox["1", "2"]}], 
    SuperscriptBox[
     OverscriptBox["W", "^"], 
     RowBox[{"[", 
      RowBox[{"\[PlusMinus]", "o"}], "]"}]]}], "+", 
   RowBox[{"\[DoubleStruckCapitalC]", "[", 
    RowBox[{
     RowBox[{"-", 
      FractionBox[
       RowBox[{"2", " ", "g", " ", "z", " "}], 
       RowBox[{
        SuperscriptBox["u", "2"], "-", 
        RowBox[{"4", " ", 
         SuperscriptBox["g", "2"], " ", 
         SuperscriptBox["z", "2"]}]}]]}], 
     OverscriptBox[
      StyleBox["W",
       FontColor->RGBColor[0.54, 0.35, 0.15]], 
      StyleBox["^",
       FontColor->RGBColor[0.54, 0.35, 0.15]]]}], 
    "]"}]}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   SuperscriptBox["\[ScriptCapitalC]", 
    RowBox[{"[", "2", "]"}]], "*", "W"}], "\[Equal]", 
  RowBox[{"\[Integral]", 
   RowBox[{
    FractionBox["du", 
     RowBox[{
      RowBox[{"-", "2"}], "\[Pi]", " ", "\[ImaginaryI]"}]], 
    FractionBox["1", 
     RowBox[{
      RowBox[{"2", "g", " ", "z"}], "+", "\[ImaginaryI]", "-", "u"}]], 
    SubscriptBox[
     OverscriptBox["W", "^"], 
     RowBox[{"0", ",", "pv"}]]}]}], "==", 
  RowBox[{"\[DoubleStruckCapitalC]", "[", 
   RowBox[{
    FractionBox[
     RowBox[{"\[ImaginaryI]", "+", 
      RowBox[{"2", " ", "g", " ", "z"}]}], 
     RowBox[{
      RowBox[{"-", 
       SuperscriptBox["u", "2"]}], "+", 
      SuperscriptBox[
       RowBox[{"(", 
        RowBox[{"\[ImaginaryI]", "+", 
         RowBox[{"2", " ", "g", " ", "z"}]}], ")"}], "2"]}]], " ", 
    OverscriptBox[
     StyleBox["W",
      FontColor->RGBColor[0.54, 0.35, 0.15]], 
     StyleBox["^",
      FontColor->RGBColor[0.54, 0.35, 0.15]]]}], 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   SuperscriptBox["\[ScriptCapitalC]", 
    RowBox[{"[", 
     RowBox[{"-", "2"}], "]"}]], "*", "W"}], "\[Equal]", 
  RowBox[{"\[Integral]", 
   RowBox[{
    FractionBox["du", 
     RowBox[{
      RowBox[{"-", "2"}], "\[Pi]", " ", "\[ImaginaryI]"}]], 
    FractionBox["1", 
     RowBox[{
      RowBox[{"2", "g", " ", "z"}], "-", "\[ImaginaryI]", "-", "u"}]], 
    SubscriptBox[
     OverscriptBox["W", "^"], 
     RowBox[{"0", ",", "pv"}]]}]}], "==", 
  RowBox[{"\[DoubleStruckCapitalC]", "[", 
   RowBox[{
    FractionBox[
     RowBox[{"\[ImaginaryI]", "-", 
      RowBox[{"2", " ", "g", " ", "z"}]}], 
     RowBox[{
      SuperscriptBox["u", "2"], "-", 
      SuperscriptBox[
       RowBox[{"(", 
        RowBox[{"\[ImaginaryI]", "-", 
         RowBox[{"2", " ", "g", " ", "z"}]}], ")"}], "2"]}]], " ", 
    OverscriptBox[
     StyleBox["W",
      FontColor->RGBColor[0.54, 0.35, 0.15]], 
     StyleBox["^",
      FontColor->RGBColor[0.54, 0.35, 0.15]]]}], "]"}]}]}], "Input",
 CellChangeTimes->{{3.5537256528025227`*^9, 3.553725697991482*^9}, {
   3.5537257310731688`*^9, 3.5537258035428667`*^9}, 3.553726111627782*^9, {
   3.55582463480515*^9, 3.55582463515359*^9}, {3.555824666097083*^9, 
   3.555824714627948*^9}, {3.5558247606434402`*^9, 3.555824846435422*^9}, {
   3.555825464598485*^9, 3.555825514081964*^9}, {3.555825572996896*^9, 
   3.555825603383564*^9}, 3.5558256406682177`*^9, {3.555825736162112*^9, 
   3.555825738904806*^9}, {3.560081719255518*^9, 3.560081723326009*^9}}],

Cell["\<\
Let us compute contribution which is coming from the integrals:\
\>", "Text",
 CellChangeTimes->{{3.555825822160657*^9, 3.555825831990363*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ratioq2Wint", "=", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     RowBox[{
      RowBox[{"Expand", "/@", 
       RowBox[{"Series", "[", 
        RowBox[{
         RowBox[{
          RowBox[{
           RowBox[{"Collect", "[", 
            RowBox[{
             RowBox[{
              RowBox[{"tmp", "/.", 
               RowBox[{"o", "\[Rule]", "0"}]}], "/.", 
              RowBox[{"{", 
               RowBox[{
                RowBox[{
                 StyleBox["\[ScriptCapitalC]",
                  FontColor->RGBColor[0, 0, 0.8]], "\[Rule]", " ", 
                 RowBox[{"\[DoubleStruckCapitalC]", "[", 
                  RowBox[{
                   RowBox[{"-", 
                    FractionBox[
                    RowBox[{"2", " ", "g", " ", "z", " "}], 
                    RowBox[{
                    SuperscriptBox["u", "2"], "-", 
                    RowBox[{"4", " ", 
                    SuperscriptBox["g", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}]]}], 
                   StyleBox["W",
                    FontColor->RGBColor[0.54, 0.35, 0.15]]}], "]"}]}], ",", 
                RowBox[{
                 SuperscriptBox[
                  StyleBox["\[ScriptCapitalC]",
                   FontColor->RGBColor[0, 0, 0.8]], 
                  RowBox[{"[", "2", "]"}]], "\[Rule]", " ", 
                 RowBox[{"\[DoubleStruckCapitalC]", "[", 
                  RowBox[{
                   FractionBox[
                    RowBox[{"\[ImaginaryI]", "+", 
                    RowBox[{"2", " ", "g", " ", "z"}]}], 
                    RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["u", "2"]}], "+", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{"\[ImaginaryI]", "+", 
                    RowBox[{"2", " ", "g", " ", "z"}]}], ")"}], "2"]}]], " ", 
                   
                   StyleBox["W",
                    FontColor->RGBColor[0.54, 0.35, 0.15]]}], "]"}]}], ",", 
                RowBox[{
                 SuperscriptBox[
                  StyleBox["\[ScriptCapitalC]",
                   FontColor->RGBColor[0, 0, 0.8]], 
                  RowBox[{"[", 
                   RowBox[{"-", "2"}], "]"}]], "\[Rule]", " ", 
                 RowBox[{"\[DoubleStruckCapitalC]", "[", 
                  RowBox[{
                   FractionBox[
                    RowBox[{"\[ImaginaryI]", "-", 
                    RowBox[{"2", " ", "g", " ", "z"}]}], 
                    RowBox[{
                    SuperscriptBox["u", "2"], "-", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{"\[ImaginaryI]", "-", 
                    RowBox[{"2", " ", "g", " ", "z"}]}], ")"}], "2"]}]], " ", 
                   
                   StyleBox["W",
                    FontColor->RGBColor[0.54, 0.35, 0.15]]}], "]"}]}]}], 
               "}"}]}], ",", 
             RowBox[{"\[ScriptCapitalC]$", "[", 
              RowBox[{"_", ":", "0"}], "]"}]}], "]"}], "/.", 
           RowBox[{"W", "\[Rule]", 
            RowBox[{
             SuperscriptBox["g", "8"], 
             RowBox[{"(", 
              RowBox[{
               SubscriptBox["W", "lead"], "+", 
               RowBox[{
                SuperscriptBox["g", "2"], 
                SubscriptBox["W", "sublead"]}], "+", 
               RowBox[{
                SuperscriptBox["g", "4"], 
                SubscriptBox["W", "sublead2"]}]}], ")"}]}]}]}], "/.", 
          RowBox[{
           RowBox[{"\[DoubleStruckCapitalC]", "[", "a_", "]"}], 
           "\[RuleDelayed]", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{
              RowBox[{
               RowBox[{
                RowBox[{"\[DoubleStruckCapitalC]", "[", 
                 RowBox[{
                  RowBox[{"Normal", "@", 
                   RowBox[{"Series", "[", 
                    RowBox[{"a", ",", 
                    RowBox[{"{", 
                    RowBox[{"g", ",", "0", ",", "13"}], "}"}]}], "]"}]}], "//",
                   "Expand"}], "]"}], "//.", 
                RowBox[{
                 RowBox[{"\[DoubleStruckCapitalC]", "[", 
                  RowBox[{
                   RowBox[{
                    SuperscriptBox["g", "aa_."], "b_."}], "+", "c_"}], "]"}], 
                 "\[RuleDelayed]", 
                 RowBox[{
                  RowBox[{
                   SuperscriptBox["g", "aa"], 
                   RowBox[{"\[DoubleStruckCapitalC]", "[", "b", "]"}]}], "+", 
                  
                  RowBox[{"\[DoubleStruckCapitalC]", "[", "c", "]"}]}]}]}], "/.", 
               RowBox[{
                RowBox[{"\[DoubleStruckCapitalC]", "[", 
                 RowBox[{
                  SuperscriptBox["g", "aa_."], "b_."}], "]"}], 
                "\[RuleDelayed]", " ", 
                RowBox[{
                 SuperscriptBox["g", "aa"], 
                 RowBox[{"\[DoubleStruckCapitalC]", "[", "b", "]"}]}]}]}], "/.", 
              RowBox[{
               RowBox[{"\[DoubleStruckCapitalC]", "[", 
                RowBox[{
                 SuperscriptBox["z", "aa_."], "bb_"}], "]"}], 
               "\[RuleDelayed]", 
               RowBox[{
                SuperscriptBox["z", "aa"], " ", 
                RowBox[{"\[DoubleStruckCapitalC]", "[", "bb", "]"}]}]}]}], "//.", 
             RowBox[{
              RowBox[{"(", 
               RowBox[{
                RowBox[{
                 RowBox[{"a1_.", " ", "e1_.", 
                  RowBox[{"\[DoubleStruckCapitalC]", "[", 
                   RowBox[{"b1_.", 
                    SubscriptBox["W", "c1_"]}], "]"}]}], "+", 
                 RowBox[{"a2_.", "e1_.", 
                  RowBox[{"\[DoubleStruckCapitalC]", "[", 
                   RowBox[{"b2_.", 
                    SubscriptBox["W", "c1_"]}], "]"}]}]}], "/;", 
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{"FreeQ", "[", 
                   RowBox[{"a1", ",", 
                    RowBox[{"z", "|", "g"}]}], "]"}], "&&", 
                  RowBox[{"FreeQ", "[", 
                   RowBox[{"a2", ",", 
                    RowBox[{"z", "|", "g"}]}], "]"}]}], ")"}]}], ")"}], 
              "\[RuleDelayed]", 
              RowBox[{"e1", " ", 
               RowBox[{"\[DoubleStruckCapitalC]", "[", 
                RowBox[{
                 RowBox[{"Simplify", "@", 
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{"a1", " ", "b1"}], "+", 
                    RowBox[{"a2", " ", "b2"}]}], ")"}]}], 
                 SubscriptBox["W", "c1"]}], "]"}]}]}]}], ")"}]}]}], ",", 
         RowBox[{"{", 
          RowBox[{"g", ",", "0", ",", "13"}], "}"}]}], "]"}]}], "//.", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          RowBox[{"a1_.", " ", "e1_.", 
           RowBox[{"\[DoubleStruckCapitalC]", "[", 
            RowBox[{"b1_.", 
             SubscriptBox["W", "c1_"]}], "]"}]}], "+", 
          RowBox[{"a2_.", "e1_.", 
           RowBox[{"\[DoubleStruckCapitalC]", "[", 
            RowBox[{"b2_.", 
             SubscriptBox["W", "c1_"]}], "]"}]}]}], "/;", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"FreeQ", "[", 
            RowBox[{"a1", ",", "z"}], "]"}], "&&", 
           RowBox[{"FreeQ", "[", 
            RowBox[{"a2", ",", "z"}], "]"}]}], ")"}]}], ")"}], 
       "\[RuleDelayed]", 
       RowBox[{"e1", " ", 
        RowBox[{"\[DoubleStruckCapitalC]", "[", 
         RowBox[{
          RowBox[{"Simplify", "@", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"a1", " ", "b1"}], "+", 
             RowBox[{"a2", " ", "b2"}]}], ")"}]}], 
          SubscriptBox["W", "c1"]}], "]"}]}]}]}], "/.", 
     RowBox[{
      RowBox[{"\[DoubleStruckCapitalC]", "[", "0", "]"}], "\[Rule]", "0"}]}], 
    ")"}], "//", "Normal"}]}]], "Input",
 CellChangeTimes->{{3.55582583676724*^9, 3.5558260887127*^9}, {
   3.555826146337365*^9, 3.555826151434085*^9}, {3.555826247464765*^9, 
   3.555826349961907*^9}, {3.555826406464158*^9, 3.555826424577861*^9}, {
   3.5558264622019587`*^9, 3.555826575517362*^9}, {3.55582684467315*^9, 
   3.555826846058529*^9}, {3.555826886212303*^9, 3.555826927578436*^9}, {
   3.555827127117009*^9, 3.5558271307313538`*^9}, {3.555827190001021*^9, 
   3.555827197038712*^9}, 3.55582723702668*^9, 3.555827271116486*^9, {
   3.555828564816039*^9, 3.555828593219985*^9}, {3.555853646171742*^9, 
   3.5558536469523153`*^9}, {3.555853689681079*^9, 3.5558536904089327`*^9}, {
   3.555868243790351*^9, 3.555868285673134*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   SuperscriptBox["g", "9"], " ", 
   SqrtBox[
    RowBox[{"1", "-", 
     SuperscriptBox["z", "2"]}]], " ", 
   RowBox[{"\[DoubleStruckCapitalC]", "[", 
    FractionBox[
     RowBox[{"12", " ", "\[ImaginaryI]", " ", 
      SubscriptBox[
       StyleBox["W",
        FontColor->RGBColor[0.54, 0.35, 0.15]], "lead"]}], 
     RowBox[{"1", "+", 
      SuperscriptBox["u", "2"]}]], "]"}]}], "+", 
  RowBox[{
   SuperscriptBox["g", "11"], " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{
      SuperscriptBox["z", "2"], " ", 
      SqrtBox[
       RowBox[{"1", "-", 
        SuperscriptBox["z", "2"]}]], " ", 
      RowBox[{"\[DoubleStruckCapitalC]", "[", 
       RowBox[{"-", 
        FractionBox[
         RowBox[{"48", " ", "\[ImaginaryI]", " ", 
          RowBox[{"(", 
           RowBox[{"2", "+", 
            RowBox[{"12", " ", 
             SuperscriptBox["u", "2"]}], "+", 
            RowBox[{"9", " ", 
             SuperscriptBox["u", "4"]}], "+", 
            RowBox[{"3", " ", 
             SuperscriptBox["u", "6"]}]}], ")"}], " ", 
          SubscriptBox[
           StyleBox["W",
            FontColor->RGBColor[0.54, 0.35, 0.15]], "lead"]}], 
         RowBox[{
          SuperscriptBox["u", "2"], " ", 
          SuperscriptBox[
           RowBox[{"(", 
            RowBox[{"1", "+", 
             SuperscriptBox["u", "2"]}], ")"}], "3"]}]]}], "]"}]}], "+", 
     RowBox[{
      SqrtBox[
       RowBox[{"1", "-", 
        SuperscriptBox["z", "2"]}]], " ", 
      RowBox[{"\[DoubleStruckCapitalC]", "[", 
       FractionBox[
        RowBox[{"12", " ", "\[ImaginaryI]", " ", 
         SubscriptBox[
          StyleBox["W",
           FontColor->RGBColor[0.54, 0.35, 0.15]], "sublead"]}], 
        RowBox[{"1", "+", 
         SuperscriptBox["u", "2"]}]], "]"}]}]}], ")"}]}], "+", 
  RowBox[{
   SuperscriptBox["g", "13"], " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{
      SqrtBox[
       RowBox[{"1", "-", 
        SuperscriptBox["z", "2"]}]], " ", 
      RowBox[{"\[DoubleStruckCapitalC]", "[", 
       RowBox[{"-", 
        FractionBox[
         RowBox[{"192", " ", "\[ImaginaryI]", " ", 
          SubscriptBox[
           StyleBox["W",
            FontColor->RGBColor[0.54, 0.35, 0.15]], "lead"]}], 
         RowBox[{"1", "+", 
          SuperscriptBox["u", "2"]}]]}], "]"}]}], "+", 
     RowBox[{
      SuperscriptBox["z", "2"], " ", 
      SqrtBox[
       RowBox[{"1", "-", 
        SuperscriptBox["z", "2"]}]], " ", 
      RowBox[{"\[DoubleStruckCapitalC]", "[", 
       FractionBox[
        RowBox[{"48", " ", "\[ImaginaryI]", " ", 
         RowBox[{"(", 
          RowBox[{"7", "+", 
           RowBox[{"53", " ", 
            SuperscriptBox["u", "2"]}], "+", 
           RowBox[{"32", " ", 
            SuperscriptBox["u", "4"]}]}], ")"}], " ", 
         SubscriptBox[
          StyleBox["W",
           FontColor->RGBColor[0.54, 0.35, 0.15]], "lead"]}], 
        SuperscriptBox[
         RowBox[{"(", 
          RowBox[{"u", "+", 
           SuperscriptBox["u", "3"]}], ")"}], "2"]], "]"}]}], "+", 
     RowBox[{
      SuperscriptBox["z", "4"], " ", 
      SqrtBox[
       RowBox[{"1", "-", 
        SuperscriptBox["z", "2"]}]], " ", 
      RowBox[{"\[DoubleStruckCapitalC]", "[", 
       RowBox[{"-", 
        FractionBox[
         RowBox[{"192", " ", "\[ImaginaryI]", " ", 
          RowBox[{"(", 
           RowBox[{"2", "+", 
            RowBox[{"7", " ", 
             SuperscriptBox["u", "2"]}], "-", 
            RowBox[{"4", " ", 
             SuperscriptBox["u", "4"]}], "+", 
            RowBox[{"7", " ", 
             SuperscriptBox["u", "6"]}]}], ")"}], " ", 
          SubscriptBox[
           StyleBox["W",
            FontColor->RGBColor[0.54, 0.35, 0.15]], "lead"]}], 
         RowBox[{
          SuperscriptBox["u", "4"], " ", 
          SuperscriptBox[
           RowBox[{"(", 
            RowBox[{"1", "+", 
             SuperscriptBox["u", "2"]}], ")"}], "5"]}]]}], "]"}]}], "+", 
     RowBox[{
      SuperscriptBox["z", "2"], " ", 
      SqrtBox[
       RowBox[{"1", "-", 
        SuperscriptBox["z", "2"]}]], " ", 
      RowBox[{"\[DoubleStruckCapitalC]", "[", 
       RowBox[{"-", 
        FractionBox[
         RowBox[{"48", " ", "\[ImaginaryI]", " ", 
          RowBox[{"(", 
           RowBox[{"2", "+", 
            RowBox[{"12", " ", 
             SuperscriptBox["u", "2"]}], "+", 
            RowBox[{"9", " ", 
             SuperscriptBox["u", "4"]}], "+", 
            RowBox[{"3", " ", 
             SuperscriptBox["u", "6"]}]}], ")"}], " ", 
          SubscriptBox[
           StyleBox["W",
            FontColor->RGBColor[0.54, 0.35, 0.15]], "sublead"]}], 
         RowBox[{
          SuperscriptBox["u", "2"], " ", 
          SuperscriptBox[
           RowBox[{"(", 
            RowBox[{"1", "+", 
             SuperscriptBox["u", "2"]}], ")"}], "3"]}]]}], "]"}]}], "+", 
     RowBox[{
      SqrtBox[
       RowBox[{"1", "-", 
        SuperscriptBox["z", "2"]}]], " ", 
      RowBox[{"\[DoubleStruckCapitalC]", "[", 
       FractionBox[
        RowBox[{"12", " ", "\[ImaginaryI]", " ", 
         SubscriptBox[
          StyleBox["W",
           FontColor->RGBColor[0.54, 0.35, 0.15]], "sublead2"]}], 
        RowBox[{"1", "+", 
         SuperscriptBox["u", "2"]}]], "]"}]}]}], ")"}]}]}]], "Output",
 CellChangeTimes->{
  3.555825838030005*^9, 3.5558259597021303`*^9, 3.555826152246524*^9, 
   3.555826309143602*^9, 3.5558263506314096`*^9, 3.5558264256696167`*^9, {
   3.5558265117136383`*^9, 3.5558265164289427`*^9}, 3.555826858674934*^9, {
   3.555826896893277*^9, 3.555826913561716*^9}, 3.5558270920569973`*^9, 
   3.55582714235541*^9, 3.55582720670391*^9, 3.555827250080751*^9, 
   3.555827281077129*^9, {3.555828591951417*^9, 3.555828602904426*^9}, 
   3.555853703538625*^9, 3.555868304283208*^9, 3.564855760920219*^9}]
}, Open  ]],

Cell["Contribution from Wh", "Item",
 CellChangeTimes->{{3.553726696286642*^9, 3.553726699301937*^9}}],

Cell[TextData[{
 "I will compute ",
 Cell[BoxData[
  FormBox[
   SuperscriptBox[
    OverscriptBox["W", "^"], 
    RowBox[{"[", 
     RowBox[{"+", "o"}], "]"}]], TraditionalForm]],
  FormatType->"TraditionalForm"],
 ", ",
 Cell[BoxData[
  FormBox[
   SuperscriptBox[
    OverscriptBox["W", "^"], 
    RowBox[{"[", 
     RowBox[{"-", "o"}], "]"}]], TraditionalForm]],
  FormatType->"TraditionalForm"],
 " is a complex conjugate:"
}], "Text",
 CellChangeTimes->{{3.555827912087694*^9, 3.555827926807559*^9}, {
  3.555828232255294*^9, 3.5558282463958397`*^9}}],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      FractionBox[
       RowBox[{
        RowBox[{
         SubscriptBox[
          StyleBox["q",
           FontColor->RGBColor[0, 0, 0.8]], "2"], " ", 
         SubsuperscriptBox[
          StyleBox["q",
           FontColor->RGBColor[0, 0, 0.8]], 
          RowBox[{"1", ",", "3"}], "+"]}], "-", 
        SubsuperscriptBox[
         StyleBox["q",
          FontColor->RGBColor[0, 0, 0.8]], 
         RowBox[{"1", ",", "4"}], "+"]}], 
       SuperscriptBox[
        StyleBox["Q",
         FontColor->RGBColor[{
            Rational[1, 2], 
            Rational[1, 2], 0}]], "+"]], ",", 
      FractionBox[
       RowBox[{
        RowBox[{
         SubscriptBox[
          StyleBox["q",
           FontColor->RGBColor[0, 0, 0.8]], "2"], " ", 
         SubsuperscriptBox[
          StyleBox["q",
           FontColor->RGBColor[0, 0, 0.8]], 
          RowBox[{"1", ",", "4"}], "+"]}], "-", 
        SubsuperscriptBox[
         StyleBox["q",
          FontColor->RGBColor[0, 0, 0.8]], 
         RowBox[{"2", ",", "4"}], "+"]}], 
       SuperscriptBox[
        StyleBox["Q",
         FontColor->RGBColor[{
            Rational[1, 2], 
            Rational[1, 2], 0}]], "+"]]}], "}"}], "/.", 
    RowBox[{
     SubscriptBox["q", "2"], "\[Rule]", 
     RowBox[{"(", 
      RowBox[{
       SubscriptBox["q", "2"], "/.", "largevolume"}], ")"}]}]}], "/.", 
   RowBox[{"x", "\[Rule]", "xh"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"tmp", "=", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{"Collect", "[", 
     RowBox[{
      RowBox[{"%", ".", 
       RowBox[{"Reverse", "[", 
        RowBox[{"%", "/.", "mconj"}], "]"}]}], ",", 
      RowBox[{"x$h", "[", "0", "]"}], ",", "Simplify"}], "]"}], ")"}], "/.", 
   RowBox[{"xh", "\[Rule]", "x"}]}]}]}], "Input",
 CellChangeTimes->{{3.5537176604989758`*^9, 3.553717744590509*^9}, {
  3.553726829041334*^9, 3.553726835494506*^9}, {3.553727655779147*^9, 
  3.553727658420474*^9}, {3.553727748775133*^9, 3.5537277488646383`*^9}, {
  3.553727838978693*^9, 3.553727853971786*^9}, {3.5558277733858023`*^9, 
  3.555827775416168*^9}, {3.555827876358048*^9, 3.5558278783166733`*^9}}],

Cell[BoxData[
 RowBox[{
  FractionBox[
   RowBox[{"16", " ", 
    SuperscriptBox["g", "2"], " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       SubsuperscriptBox[
        StyleBox["q",
         FontColor->RGBColor[0, 0, 0.8]], 
        RowBox[{"1", ",", "4"}], "+"], " ", 
       SubsuperscriptBox[
        OverscriptBox[
         StyleBox["q",
          FontColor->RGBColor[0, 0, 0.8]], 
         StyleBox["_",
          FontColor->RGBColor[0, 0, 0.8]]], 
        RowBox[{"1", ",", "3"}], "-"]}], "+", 
      RowBox[{
       SubsuperscriptBox[
        StyleBox["q",
         FontColor->RGBColor[0, 0, 0.8]], 
        RowBox[{"1", ",", "3"}], "+"], " ", 
       SubsuperscriptBox[
        OverscriptBox[
         StyleBox["q",
          FontColor->RGBColor[0, 0, 0.8]], 
         StyleBox["_",
          FontColor->RGBColor[0, 0, 0.8]]], 
        RowBox[{"1", ",", "4"}], "-"]}]}], ")"}]}], 
   RowBox[{
    SuperscriptBox[
     StyleBox["Q",
      FontColor->RGBColor[0.8, 0, 0]], "-"], " ", 
    SuperscriptBox[
     StyleBox["Q",
      FontColor->RGBColor[0.8, 0, 0]], "+"], " ", 
    SubsuperscriptBox["\[Gamma]", "0", "2"], " ", 
    SuperscriptBox[
     StyleBox["x",
      FontColor->RGBColor[0, 0.6, 0]], "2"]}]], "+", 
  FractionBox[
   RowBox[{
    RowBox[{
     SubsuperscriptBox[
      StyleBox["q",
       FontColor->RGBColor[0, 0, 0.8]], 
      RowBox[{"2", ",", "4"}], "+"], " ", 
     SubsuperscriptBox[
      OverscriptBox[
       StyleBox["q",
        FontColor->RGBColor[0, 0, 0.8]], 
       StyleBox["_",
        FontColor->RGBColor[0, 0, 0.8]]], 
      RowBox[{"1", ",", "4"}], "-"]}], "+", 
    RowBox[{
     SuperscriptBox["u", "2"], " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{
        SubsuperscriptBox[
         StyleBox["q",
          FontColor->RGBColor[0, 0, 0.8]], 
         RowBox[{"1", ",", "4"}], "+"], " ", 
        SubsuperscriptBox[
         OverscriptBox[
          StyleBox["q",
           FontColor->RGBColor[0, 0, 0.8]], 
          StyleBox["_",
           FontColor->RGBColor[0, 0, 0.8]]], 
         RowBox[{"1", ",", "3"}], "-"]}], "+", 
       RowBox[{
        SubsuperscriptBox[
         StyleBox["q",
          FontColor->RGBColor[0, 0, 0.8]], 
         RowBox[{"1", ",", "3"}], "+"], " ", 
        SubsuperscriptBox[
         OverscriptBox[
          StyleBox["q",
           FontColor->RGBColor[0, 0, 0.8]], 
          StyleBox["_",
           FontColor->RGBColor[0, 0, 0.8]]], 
         RowBox[{"1", ",", "4"}], "-"]}]}], ")"}]}], "+", 
    RowBox[{
     SubsuperscriptBox[
      StyleBox["q",
       FontColor->RGBColor[0, 0, 0.8]], 
      RowBox[{"1", ",", "4"}], "+"], " ", 
     SubsuperscriptBox[
      OverscriptBox[
       StyleBox["q",
        FontColor->RGBColor[0, 0, 0.8]], 
       StyleBox["_",
        FontColor->RGBColor[0, 0, 0.8]]], 
      RowBox[{"2", ",", "4"}], "-"]}], "-", 
    RowBox[{"\[ImaginaryI]", " ", "u", " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{
        SubsuperscriptBox[
         StyleBox["q",
          FontColor->RGBColor[0, 0, 0.8]], 
         RowBox[{"2", ",", "4"}], "+"], " ", 
        SubsuperscriptBox[
         OverscriptBox[
          StyleBox["q",
           FontColor->RGBColor[0, 0, 0.8]], 
          StyleBox["_",
           FontColor->RGBColor[0, 0, 0.8]]], 
         RowBox[{"1", ",", "3"}], "-"]}], "-", 
       RowBox[{
        SubsuperscriptBox[
         StyleBox["q",
          FontColor->RGBColor[0, 0, 0.8]], 
         RowBox[{"1", ",", "3"}], "+"], " ", 
        SubsuperscriptBox[
         OverscriptBox[
          StyleBox["q",
           FontColor->RGBColor[0, 0, 0.8]], 
          StyleBox["_",
           FontColor->RGBColor[0, 0, 0.8]]], 
         RowBox[{"2", ",", "4"}], "-"]}]}], ")"}]}]}], 
   RowBox[{
    SuperscriptBox[
     StyleBox["Q",
      FontColor->RGBColor[0.8, 0, 0]], "-"], " ", 
    SuperscriptBox[
     StyleBox["Q",
      FontColor->RGBColor[0.8, 0, 0]], "+"]}]], "+", 
  FractionBox[
   RowBox[{"4", " ", "g", " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"2", " ", "u", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          SubsuperscriptBox[
           StyleBox["q",
            FontColor->RGBColor[0, 0, 0.8]], 
           RowBox[{"1", ",", "4"}], "+"], " ", 
          SubsuperscriptBox[
           OverscriptBox[
            StyleBox["q",
             FontColor->RGBColor[0, 0, 0.8]], 
            StyleBox["_",
             FontColor->RGBColor[0, 0, 0.8]]], 
           RowBox[{"1", ",", "3"}], "-"]}], "+", 
         RowBox[{
          SubsuperscriptBox[
           StyleBox["q",
            FontColor->RGBColor[0, 0, 0.8]], 
           RowBox[{"1", ",", "3"}], "+"], " ", 
          SubsuperscriptBox[
           OverscriptBox[
            StyleBox["q",
             FontColor->RGBColor[0, 0, 0.8]], 
            StyleBox["_",
             FontColor->RGBColor[0, 0, 0.8]]], 
           RowBox[{"1", ",", "4"}], "-"]}]}], ")"}]}], "+", 
      RowBox[{"\[ImaginaryI]", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          RowBox[{"-", 
           SubsuperscriptBox[
            StyleBox["q",
             FontColor->RGBColor[0, 0, 0.8]], 
            RowBox[{"2", ",", "4"}], "+"]}], " ", 
          SubsuperscriptBox[
           OverscriptBox[
            StyleBox["q",
             FontColor->RGBColor[0, 0, 0.8]], 
            StyleBox["_",
             FontColor->RGBColor[0, 0, 0.8]]], 
           RowBox[{"1", ",", "3"}], "-"]}], "+", 
         RowBox[{
          SubsuperscriptBox[
           StyleBox["q",
            FontColor->RGBColor[0, 0, 0.8]], 
           RowBox[{"1", ",", "3"}], "+"], " ", 
          SubsuperscriptBox[
           OverscriptBox[
            StyleBox["q",
             FontColor->RGBColor[0, 0, 0.8]], 
            StyleBox["_",
             FontColor->RGBColor[0, 0, 0.8]]], 
           RowBox[{"2", ",", "4"}], "-"]}]}], ")"}]}]}], ")"}]}], 
   RowBox[{
    SuperscriptBox[
     StyleBox["Q",
      FontColor->RGBColor[0.8, 0, 0]], "-"], " ", 
    SuperscriptBox[
     StyleBox["Q",
      FontColor->RGBColor[0.8, 0, 0]], "+"], " ", 
    SubscriptBox["\[Gamma]", "0"], " ", 
    StyleBox["x",
     FontColor->RGBColor[0, 0.6, 0]]}]]}]], "Output",
 CellChangeTimes->{3.5558277793961773`*^9, 3.555827882784383*^9, 
  3.555827928038422*^9, 3.555853739192354*^9, 3.5558541534508944`*^9, 
  3.5600822898741293`*^9, 3.564855767050251*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"tmpn", "=", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"Series", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"Collect", "[", 
            RowBox[{
             RowBox[{"tmp", "/.", 
              RowBox[{"u", "\[Rule]", 
               RowBox[{"2", "g", " ", "z"}]}]}], ",", "x", ",", "Simplify"}], 
            "]"}], "//.", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"xxx", ":", 
              RowBox[{"(", 
               RowBox[{"Alternatives", "@@", 
                RowBox[{"{", 
                 RowBox[{
                  RowBox[{"Q0", "[", 
                   RowBox[{"_", ":", "0"}], "]"}], ",", 
                  RowBox[{"Q", "[", 
                   RowBox[{"_", ":", "0"}], "]"}], ",", 
                  SubscriptBox["\[Gamma]", "0"], ",", 
                  RowBox[{"x$", "[", "_", "]"}]}], "}"}]}], ")"}]}], 
             "\[RuleDelayed]", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{
                RowBox[{
                 RowBox[{"xxx", "/.", "subQ0"}], "/.", "subJuk"}], "/.", 
                RowBox[{"leadweak", "[", "4", "]"}]}], "/.", 
               RowBox[{"u", "\[Rule]", 
                RowBox[{"2", "g", " ", "z"}]}]}], ")"}]}], ")"}]}], ",", 
          RowBox[{"{", 
           RowBox[{"g", ",", "0", ",", "5"}], "}"}]}], "]"}], "//", 
        "Simplify"}], ")"}], "/.", 
      RowBox[{
       RowBox[{"b_.", 
        SuperscriptBox[
         RowBox[{"(", 
          RowBox[{
           RowBox[{
            RowBox[{"-", "\[ImaginaryI]"}], " ", "z"}], "+", 
           SqrtBox[
            RowBox[{"1", "-", 
             SuperscriptBox["z", "2"]}]]}], ")"}], 
         RowBox[{"a_", "/;", 
          RowBox[{"a", "<", "0"}]}]]}], "\[RuleDelayed]", 
       RowBox[{"b", " ", 
        SuperscriptBox[
         RowBox[{"(", 
          FractionBox["1", 
           RowBox[{
            RowBox[{"\[ImaginaryI]", " ", "z"}], "+", 
            SqrtBox[
             RowBox[{"1", "-", 
              SuperscriptBox["z", "2"]}]]}]], ")"}], "a"]}]}]}], "/.", 
     RowBox[{
      RowBox[{"b_.", 
       SuperscriptBox[
        RowBox[{"(", 
         RowBox[{
          RowBox[{"\[ImaginaryI]", " ", "z"}], "+", 
          SqrtBox[
           RowBox[{"1", "-", 
            SuperscriptBox["z", "2"]}]]}], ")"}], 
        RowBox[{"a_", "/;", 
         RowBox[{"a", "<", "0"}]}]]}], "\[RuleDelayed]", " ", 
      RowBox[{"b", 
       SuperscriptBox[
        RowBox[{"(", 
         FractionBox["1", 
          RowBox[{
           RowBox[{
            RowBox[{"-", "\[ImaginaryI]"}], " ", "z"}], "+", 
           SqrtBox[
            RowBox[{"1", "-", 
             SuperscriptBox["z", "2"]}]]}]], ")"}], "a"]}]}]}], "/.", 
    RowBox[{
     RowBox[{"b_.", 
      SuperscriptBox[
       RowBox[{"(", 
        RowBox[{"z", "+", 
         RowBox[{"\[ImaginaryI]", " ", 
          SqrtBox[
           RowBox[{"1", "-", 
            SuperscriptBox["z", "2"]}]]}]}], ")"}], 
       RowBox[{"a_", "/;", 
        RowBox[{"a", "<", "0"}]}]]}], "\[RuleDelayed]", " ", 
     RowBox[{"b", 
      SuperscriptBox[
       RowBox[{"(", 
        FractionBox["1", 
         RowBox[{"z", "-", 
          RowBox[{"\[ImaginaryI]", 
           SqrtBox[
            RowBox[{"1", "-", 
             SuperscriptBox["z", "2"]}]]}]}]], ")"}], "a"]}]}]}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"tmpn", "=", 
   RowBox[{
    RowBox[{
     RowBox[{"Collect", "[", 
      RowBox[{
       RowBox[{"#", "//", "Expand"}], ",", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{
           RowBox[{
            RowBox[{"q$", "[", 
             RowBox[{"_", ",", "_"}], "]"}], "[", "_", "]"}], 
           RowBox[{
            RowBox[{"q$b", "[", 
             RowBox[{"_", ",", "_"}], "]"}], "[", "_", "]"}]}], ",", 
          SqrtBox[
           RowBox[{"1", "-", 
            SuperscriptBox["z", "2"]}]], ",", "z", ",", "\[Zeta]list"}], 
         "}"}], "//", "Flatten"}], ",", "Simplify"}], "]"}], "&"}], "/@", 
    "%"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"FreeQ", "[", 
  RowBox[{"%", ",", 
   SubscriptBox["\[Zeta]", "5"]}], "]"}]}], "Input",
 CellChangeTimes->{
  3.5557984910314007`*^9, {3.555820514176888*^9, 3.555820553549423*^9}, {
   3.555820589037825*^9, 3.5558206962533407`*^9}, {3.555820727362359*^9, 
   3.555820748151065*^9}, {3.555820798555138*^9, 3.555820899603109*^9}, 
   3.555827810441613*^9, {3.5558278456075363`*^9, 3.555827846872373*^9}, 
   3.555827965611432*^9, 3.5558537525007677`*^9}],

Cell[BoxData["True"], "Output",
 CellChangeTimes->{
  3.555798526017378*^9, 3.555798624210374*^9, 3.555820525345909*^9, 
   3.555820557627701*^9, 3.555820589823442*^9, {3.555820626270465*^9, 
   3.5558206969485397`*^9}, 3.555820783916935*^9, {3.555820836558887*^9, 
   3.555820900521743*^9}, 3.555827811418427*^9, 3.555827848531954*^9, 
   3.5558279328189163`*^9, 3.555827968306572*^9, 3.5558537610931396`*^9, 
   3.555854146048373*^9, 3.560082292828536*^9, 3.564855770235847*^9}]
}, Open  ]],

Cell[BoxData[{
 RowBox[{
  RowBox[{"List", "@@", 
   RowBox[{"Collect", "[", 
    RowBox[{
     RowBox[{"Normal", "[", "tmpn", "]"}], ",", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{
         RowBox[{
          RowBox[{"q$", "[", 
           RowBox[{"_", ",", "_"}], "]"}], "[", "_", "]"}], 
         RowBox[{
          RowBox[{"q$b", "[", 
           RowBox[{"_", ",", "_"}], "]"}], "[", "_", "]"}]}], ",", "g", ",", 
        SqrtBox[
         RowBox[{"1", "-", 
          SuperscriptBox["z", "2"]}]], ",", "z", ",", "\[Zeta]list"}], "}"}], 
      "//", "Flatten"}]}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"tmp3", "=", 
   RowBox[{"Collect", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"Total", "[", 
       RowBox[{"Normal", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"Series", "[", 
           RowBox[{
            RowBox[{
             RowBox[{
              RowBox[{
               RowBox[{"#", "/.", 
                RowBox[{"leadweak", "[", "4", "]"}]}], "/.", "subQ0"}], "//.", 
              RowBox[{"shiftp\[Eta]b", "[", 
               RowBox[{"-", "4"}], "]"}]}], "/.", 
             RowBox[{"u", "\[Rule]", 
              RowBox[{"2", "g", " ", "z"}]}]}], ",", 
            RowBox[{"{", 
             RowBox[{"g", ",", "0", ",", "13"}], "}"}]}], "]"}], "&"}], "/@", 
         "%"}], "]"}], "]"}], "//", "Expand"}], ",", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"\[Eta]list", ",", "g", ",", 
        SqrtBox[
         RowBox[{"1", "-", 
          SuperscriptBox["z", "2"]}]], ",", "z", ",", "\[Zeta]list"}], "}"}], 
      "//", "Flatten"}]}], "]"}]}], ";"}]}], "Input",
 CellChangeTimes->{{3.555821561058899*^9, 3.555821730937216*^9}, {
   3.555821762016913*^9, 3.555821766749757*^9}, {3.555821955226857*^9, 
   3.555821959689242*^9}, 3.555827995777967*^9, {3.5558280311667347`*^9, 
   3.5558280433959837`*^9}, 3.555854177522726*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{"tmpWp", "=", 
   RowBox[{"Collect", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"(", 
       RowBox[{"tmp3", "/.", 
        RowBox[{"TaylorOptions", "[", 
         RowBox[{
          RowBox[{"Variable", "\[Rule]", "g"}], ",", 
          RowBox[{"\[Eta]Factor", "\[Rule]", 
           RowBox[{"2", "z"}]}], ",", 
          RowBox[{"Order", "\[Rule]", "13"}], ",", 
          RowBox[{"Series", "\[Rule]", "False"}]}], "]"}]}], ")"}], "//.", 
      "subZetaReduce"}], ",", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"g", ",", 
        SqrtBox[
         RowBox[{"1", "-", 
          SuperscriptBox["z", "2"]}]], ",", "z", ",", "\[Zeta]list"}], "}"}], 
      "//", "Flatten"}]}], "]"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.5558218207860317`*^9, 3.555821892822016*^9}, {
  3.555828006682323*^9, 3.555828050920504*^9}, {3.555828147998576*^9, 
  3.555828148511265*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Collect", "[", 
  RowBox[{"tmpWp", ",", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"g", ",", 
      SqrtBox[
       RowBox[{"1", "-", 
        SuperscriptBox["z", "2"]}]], ",", "z"}], "}"}], "//", "Flatten"}], 
   ",", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       RowBox[{"#", "/.", "subZetas"}], "/.", "Nnnreducibles"}], "//", "N"}], 
     ")"}], "&"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.555821900047181*^9, 3.5558219009531717`*^9}, {
  3.555822016861388*^9, 3.5558220787831507`*^9}, {3.555828135264492*^9, 
  3.5558281542602463`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   SuperscriptBox["g", "6"], " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"-", "1.0363705131464371`"}], "+", 
     RowBox[{"2.0727410262928743`", " ", 
      SuperscriptBox["z", "2"]}], "-", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"0.`", "\[VeryThinSpace]", "+", 
        RowBox[{"2.0727410262928743`", " ", "\[ImaginaryI]"}]}], ")"}], " ", 
      "z", " ", 
      SqrtBox[
       RowBox[{"1", "-", 
        SuperscriptBox["z", "2"]}]]}]}], ")"}]}], "+", 
  RowBox[{
   SuperscriptBox["g", "8"], " ", 
   RowBox[{"(", 
    RowBox[{"5.502864517141575`", "\[VeryThinSpace]", "+", 
     RowBox[{"15.349057491655458`", " ", 
      SuperscriptBox["z", "2"]}], "-", 
     RowBox[{"45.54621644366807`", " ", 
      SuperscriptBox["z", "4"]}], "+", 
     RowBox[{
      SqrtBox[
       RowBox[{"1", "-", 
        SuperscriptBox["z", "2"]}]], " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         RowBox[{"(", 
          RowBox[{"0.`", "\[VeryThinSpace]", "+", 
           RowBox[{"7.424050730178692`", " ", "\[ImaginaryI]"}]}], ")"}], " ",
          "z"}], "+", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{"0.`", "\[VeryThinSpace]", "+", 
           RowBox[{"45.54621644366807`", " ", "\[ImaginaryI]"}]}], ")"}], " ", 
         SuperscriptBox["z", "3"]}]}], ")"}]}]}], ")"}]}], "+", 
  RowBox[{
   SuperscriptBox["g", "10"], " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"-", "27.36356182472082`"}], "-", 
     RowBox[{"313.9476643279486`", " ", 
      SuperscriptBox["z", "2"]}], "+", 
     RowBox[{"371.8689902899241`", " ", 
      SuperscriptBox["z", "4"]}], "+", 
     RowBox[{"368.8543183697948`", " ", 
      SuperscriptBox["z", "6"]}], "+", 
     RowBox[{
      SqrtBox[
       RowBox[{"1", "-", 
        SuperscriptBox["z", "2"]}]], " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         RowBox[{"(", 
          RowBox[{"0.`", "\[VeryThinSpace]", "+", 
           RowBox[{"23.40661407295738`", " ", "\[ImaginaryI]"}]}], ")"}], " ",
          "z"}], "-", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{"0.`", "\[VeryThinSpace]", "+", 
           RowBox[{"556.296149474827`", " ", "\[ImaginaryI]"}]}], ")"}], " ", 
         
         SuperscriptBox["z", "3"]}], "-", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{"0.`", "\[VeryThinSpace]", "+", 
           RowBox[{"368.8543183697948`", " ", "\[ImaginaryI]"}]}], ")"}], " ", 
         SuperscriptBox["z", "5"]}]}], ")"}]}]}], ")"}]}], "+", 
  RowBox[{
   SuperscriptBox["g", "12"], " ", 
   RowBox[{"(", 
    RowBox[{"233.97109895710616`", "\[VeryThinSpace]", "+", 
     RowBox[{"2508.0198307091923`", " ", 
      SuperscriptBox["z", "2"]}], "+", 
     RowBox[{"3403.2372088569437`", " ", 
      SuperscriptBox["z", "4"]}], "-", 
     RowBox[{"13352.83220072707`", " ", 
      SuperscriptBox["z", "6"]}], "+", 
     RowBox[{"1617.903356310213`", " ", 
      SuperscriptBox["z", "8"]}], "+", 
     RowBox[{
      SqrtBox[
       RowBox[{"1", "-", 
        SuperscriptBox["z", "2"]}]], " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         RowBox[{"(", 
          RowBox[{"0.`", "\[VeryThinSpace]", "-", 
           RowBox[{"376.9105658413116`", " ", "\[ImaginaryI]"}]}], ")"}], " ",
          "z"}], "+", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{"0.`", "\[VeryThinSpace]", "+", 
           RowBox[{"2447.5887242657395`", " ", "\[ImaginaryI]"}]}], ")"}], 
         " ", 
         SuperscriptBox["z", "3"]}], "+", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{"0.`", "\[VeryThinSpace]", "+", 
           RowBox[{"12543.880522572039`", " ", "\[ImaginaryI]"}]}], ")"}], 
         " ", 
         SuperscriptBox["z", "5"]}], "-", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{"0.`", "\[VeryThinSpace]", "+", 
           RowBox[{"1617.903356310213`", " ", "\[ImaginaryI]"}]}], ")"}], " ", 
         SuperscriptBox["z", "7"]}]}], ")"}]}]}], ")"}]}]}]], "Output",
 CellChangeTimes->{
  3.555821902439095*^9, 3.555821979599986*^9, {3.5558220523198977`*^9, 
   3.555822079218824*^9}, {3.555828015898288*^9, 3.555828038588513*^9}, 
   3.555828082403591*^9, {3.5558281403917933`*^9, 3.555828166485169*^9}, 
   3.555854490725977*^9, 3.564855819535308*^9}]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"tmpWm", "=", 
   RowBox[{"tmpWp", "/.", "mconj"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.555828142714836*^9, 3.5558281717771606`*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"-", 
       RowBox[{"(", 
        RowBox[{
         FractionBox[
          RowBox[{"(", 
           RowBox[{
            SuperscriptBox["\[ScriptCapitalC]", 
             RowBox[{"[", 
              RowBox[{"+", "o"}], "]"}]], "-", 
            SuperscriptBox["\[ScriptCapitalC]", 
             RowBox[{"[", 
              RowBox[{"+", "2"}], "]"}]]}], ")"}], 
          RowBox[{"(", 
           RowBox[{
            SubscriptBox[
             StyleBox["\[GothicQ]",
              FontColor->RGBColor[0.54, 0.35, 0.15]], "2"], "-", 
            SubsuperscriptBox[
             StyleBox["\[GothicQ]",
              FontColor->RGBColor[0.54, 0.35, 0.15]], "2", 
             RowBox[{"[", "2", "]"}]]}], ")"}]], "+", 
         FractionBox[
          RowBox[{"-", 
           RowBox[{"(", 
            RowBox[{
             SuperscriptBox["\[ScriptCapitalC]", 
              RowBox[{"[", 
               RowBox[{"-", "o"}], "]"}]], "-", 
             SuperscriptBox["\[ScriptCapitalC]", 
              RowBox[{"[", 
               RowBox[{"-", "2"}], "]"}]]}], ")"}]}], 
          RowBox[{"(", 
           RowBox[{
            SubscriptBox[
             OverscriptBox[
              StyleBox["\[GothicQ]",
               FontColor->RGBColor[0.54, 0.35, 0.15]], 
              StyleBox["_",
               FontColor->RGBColor[0.54, 0.35, 0.15]]], "2"], "-", 
            SubsuperscriptBox[
             OverscriptBox[
              StyleBox["\[GothicQ]",
               FontColor->RGBColor[0.54, 0.35, 0.15]], 
              StyleBox["_",
               FontColor->RGBColor[0.54, 0.35, 0.15]]], "2", 
             RowBox[{"[", 
              RowBox[{"-", "2"}], "]"}]]}], ")"}]], "-", 
         FractionBox[
          RowBox[{"(", 
           RowBox[{
            SuperscriptBox["\[ScriptCapitalC]", 
             RowBox[{"[", 
              RowBox[{"+", "o"}], "]"}]], "-", 
            SuperscriptBox["\[ScriptCapitalC]", 
             RowBox[{"[", 
              RowBox[{"-", "2"}], "]"}]]}], ")"}], 
          RowBox[{"(", 
           RowBox[{
            SubscriptBox[
             StyleBox["\[GothicQ]",
              FontColor->RGBColor[0.54, 0.35, 0.15]], "2"], "+", 
            SubsuperscriptBox[
             OverscriptBox[
              StyleBox["\[GothicQ]",
               FontColor->RGBColor[0.54, 0.35, 0.15]], "_"], "2", 
             RowBox[{"[", 
              RowBox[{"-", "2"}], "]"}]]}], ")"}]], "-", 
         FractionBox[
          RowBox[{"(", 
           RowBox[{
            RowBox[{"-", 
             SuperscriptBox["\[ScriptCapitalC]", 
              RowBox[{"[", 
               RowBox[{"-", "o"}], "]"}]]}], "+", 
            SuperscriptBox["\[ScriptCapitalC]", 
             RowBox[{"[", 
              RowBox[{"+", "2"}], "]"}]]}], ")"}], 
          RowBox[{"(", 
           RowBox[{
            SubscriptBox[
             OverscriptBox[
              StyleBox["\[GothicQ]",
               FontColor->RGBColor[0.54, 0.35, 0.15]], "_"], "2"], "+", 
            SubsuperscriptBox[
             StyleBox["\[GothicQ]",
              FontColor->RGBColor[0.54, 0.35, 0.15]], "2", 
             RowBox[{"[", 
              RowBox[{"+", "2"}], "]"}]]}], ")"}]]}], ")"}]}], "/.", 
      RowBox[{
       SuperscriptBox["\[ScriptCapitalC]", 
        RowBox[{"[", 
         RowBox[{"+", "2"}], "]"}]], "\[Rule]", "0"}]}], "/.", 
     RowBox[{
      SuperscriptBox["\[ScriptCapitalC]", 
       RowBox[{"[", 
        RowBox[{"-", "2"}], "]"}]], "\[Rule]", "0"}]}], "/.", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"q$u", "\[Rule]", "q$"}], ",", 
      RowBox[{"q$ub", "\[Rule]", "q$b"}]}], "}"}]}], "/.", "largevolume"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"tmp", "=", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"Series", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"%", "/.", 
          RowBox[{"u", "\[Rule]", 
           RowBox[{"2", "g", " ", "z"}]}]}], "//.", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"xxx", ":", 
            RowBox[{"(", 
             RowBox[{"Alternatives", "@@", 
              RowBox[{"{", 
               RowBox[{
                RowBox[{"Q0", "[", 
                 RowBox[{"_", ":", "0"}], "]"}], ",", 
                RowBox[{"Q", "[", 
                 RowBox[{"_", ":", "0"}], "]"}], ",", 
                SubscriptBox["\[Gamma]", "0"], ",", 
                RowBox[{"x", "[", 
                 RowBox[{"_", ":", "0"}], "]"}]}], "}"}]}], ")"}]}], 
           "\[RuleDelayed]", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{
              RowBox[{
               RowBox[{"xxx", "/.", "subQ0"}], "/.", "subJuk"}], "/.", 
              RowBox[{"leadweak", "[", "4", "]"}]}], "/.", 
             RowBox[{"u", "\[Rule]", 
              RowBox[{"2", "g", " ", "z"}]}]}], ")"}]}], ")"}]}], ",", 
        RowBox[{"{", 
         RowBox[{"g", ",", "0", ",", "10"}], "}"}]}], "]"}], "/.", 
      RowBox[{
       SuperscriptBox[
        RowBox[{"(", 
         RowBox[{
          RowBox[{
           RowBox[{"-", "\[ImaginaryI]"}], " ", "z"}], "+", 
          SqrtBox[
           RowBox[{"1", "-", 
            SuperscriptBox["z", "2"]}]]}], ")"}], 
        RowBox[{"a_", "/;", 
         RowBox[{"a", "<", "0"}]}]], "\[RuleDelayed]", 
       SuperscriptBox[
        RowBox[{"(", 
         FractionBox["1", 
          RowBox[{
           RowBox[{"\[ImaginaryI]", " ", "z"}], "+", 
           SqrtBox[
            RowBox[{"1", "-", 
             SuperscriptBox["z", "2"]}]]}]], ")"}], "a"]}]}], "//", 
     "Simplify"}], "//", "Normal"}]}], ";"}]}], "Input",
 CellChangeTimes->{{3.555828314448575*^9, 3.555828327609612*^9}, {
  3.555854631219133*^9, 3.555854631722158*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ratioq2Wmp0", "=", 
  RowBox[{"Collect", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"Normal", "@", 
      RowBox[{"Series", "[", 
       RowBox[{
        RowBox[{"tmp", "/.", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{
            SuperscriptBox[
             StyleBox["\[ScriptCapitalC]",
              FontColor->RGBColor[0, 0, 0.8]], 
             RowBox[{"[", "o", "]"}]], "\[Rule]", 
            FractionBox["tmpWp", "2"]}], ",", 
           RowBox[{
            SuperscriptBox[
             StyleBox["\[ScriptCapitalC]",
              FontColor->RGBColor[0, 0, 0.8]], 
             RowBox[{"[", 
              RowBox[{"-", "o"}], "]"}]], "\[Rule]", 
            RowBox[{"-", 
             FractionBox["tmpWm", "2"]}]}]}], "}"}]}], ",", 
        RowBox[{"{", 
         RowBox[{"g", ",", "0", ",", "14"}], "}"}]}], "]"}]}], "//", 
     "Expand"}], ",", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"g", ",", 
       SqrtBox[
        RowBox[{"1", "-", 
         SuperscriptBox["z", "2"]}]], ",", "z", ",", "\[Zeta]list"}], "}"}], "//",
      "Flatten"}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.555828329479436*^9, 3.5558284028782597`*^9}, {
   3.5558284517495337`*^9, 3.555828454716977*^9}, 3.555828639766397*^9, {
   3.555854642292612*^9, 3.555854642659883*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   SuperscriptBox["g", "8"], " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"-", "648"}], "+", 
     RowBox[{"432", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2"]}], "+", 
     RowBox[{"432", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3"]}], "-", 
     RowBox[{"288", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3"]}]}], ")"}]}], "+", 
  RowBox[{
   SuperscriptBox["g", "10"], " ", 
   RowBox[{"(", 
    RowBox[{"15228", "-", 
     RowBox[{"3240", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2"]}], "-", 
     FractionBox[
      RowBox[{"10368", " ", 
       SubsuperscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "2", "2"]}], "5"], "+", 
     FractionBox[
      RowBox[{"5184", " ", 
       SubsuperscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "2", "3"]}], "5"], "-", 
     RowBox[{"13608", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3"]}], "-", 
     RowBox[{"720", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3"]}], "+", 
     RowBox[{
      FractionBox["1728", "5"], " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2", "2"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3"]}], "+", 
     RowBox[{"5184", " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3", "2"]}], "-", 
     RowBox[{"1296", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "5"]}], "+", 
     RowBox[{"864", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "5"]}], "+", 
     RowBox[{
      SuperscriptBox["z", "2"], " ", 
      RowBox[{"(", 
       RowBox[{"5184", "-", 
        RowBox[{"8640", " ", 
         SubscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "2"]}], "+", 
        FractionBox[
         RowBox[{"3456", " ", 
          SubsuperscriptBox[
           StyleBox["\[Zeta]",
            FontWeight->Bold,
            FontColor->GrayLevel[0.4]], "2", "2"]}], "5"], "+", 
        RowBox[{"12096", " ", 
         SubscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "3"]}], "-", 
        RowBox[{"1152", " ", 
         SubscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "2"], " ", 
         SubscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "3"]}], "-", 
        RowBox[{
         FractionBox["10368", "5"], " ", 
         SubsuperscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "2", "2"], " ", 
         SubscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "3"]}], "-", 
        RowBox[{"13824", " ", 
         SubscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "5"]}], "+", 
        RowBox[{"9216", " ", 
         SubscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "2"], " ", 
         SubscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "5"]}]}], ")"}]}]}], ")"}]}], "+", 
  RowBox[{
   SuperscriptBox["g", "12"], " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"-", "239760"}], "+", 
     FractionBox[
      RowBox[{"355104", " ", 
       SubsuperscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "2", "2"]}], "5"], "+", 
     FractionBox[
      RowBox[{"132192", " ", 
       SubsuperscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "2", "3"]}], "35"], "-", 
     FractionBox[
      RowBox[{"736128", " ", 
       SubsuperscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "2", "4"]}], "175"], "+", 
     RowBox[{"119232", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3"]}], "+", 
     RowBox[{"14688", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3"]}], "-", 
     RowBox[{
      FractionBox["222048", "5"], " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2", "2"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3"]}], "-", 
     RowBox[{
      FractionBox["20736", "35"], " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2", "3"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3"]}], "+", 
     RowBox[{"7776", " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3", "2"]}], "+", 
     RowBox[{"6912", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2"], " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3", "2"]}], "+", 
     RowBox[{"105624", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "5"]}], "-", 
     RowBox[{"13392", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "5"]}], "-", 
     RowBox[{
      FractionBox["5184", "5"], " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2", "2"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "5"]}], "-", 
     RowBox[{"58752", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "5"]}], "+", 
     RowBox[{"3888", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "7"]}], "-", 
     RowBox[{"2592", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "7"]}], "+", 
     RowBox[{
      SuperscriptBox["z", "4"], " ", 
      RowBox[{"(", 
       RowBox[{"33696", "+", 
        RowBox[{"19008", " ", 
         SubscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "2"]}], "+", 
        FractionBox[
         RowBox[{"352512", " ", 
          SubsuperscriptBox[
           StyleBox["\[Zeta]",
            FontWeight->Bold,
            FontColor->GrayLevel[0.4]], "2", "2"]}], "5"], "-", 
        FractionBox[
         RowBox[{"165888", " ", 
          SubsuperscriptBox[
           StyleBox["\[Zeta]",
            FontWeight->Bold,
            FontColor->GrayLevel[0.4]], "2", "3"]}], "7"], "-", 
        RowBox[{"146880", " ", 
         SubscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "3"]}], "+", 
        RowBox[{"1152", " ", 
         SubscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "2"], " ", 
         SubscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "3"]}], "-", 
        RowBox[{"6912", " ", 
         SubsuperscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "2", "2"], " ", 
         SubscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "3"]}], "+", 
        RowBox[{
         FractionBox["221184", "7"], " ", 
         SubsuperscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "2", "3"], " ", 
         SubscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "3"]}], "-", 
        RowBox[{"103680", " ", 
         SubscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "5"]}], "+", 
        RowBox[{"41472", " ", 
         SubscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "2"], " ", 
         SubscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "5"]}], "-", 
        RowBox[{
         FractionBox["119808", "5"], " ", 
         SubsuperscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "2", "2"], " ", 
         SubscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "5"]}], "+", 
        RowBox[{"172800", " ", 
         SubscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "7"]}], "-", 
        RowBox[{"115200", " ", 
         SubscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "2"], " ", 
         SubscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "7"]}]}], ")"}]}], "+", 
     RowBox[{
      SuperscriptBox["z", "2"], " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "228744"}], "+", 
        RowBox[{"156816", " ", 
         SubscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "2"]}], "-", 
        FractionBox[
         RowBox[{"551232", " ", 
          SubsuperscriptBox[
           StyleBox["\[Zeta]",
            FontWeight->Bold,
            FontColor->GrayLevel[0.4]], "2", "2"]}], "5"], "+", 
        FractionBox[
         RowBox[{"1472256", " ", 
          SubsuperscriptBox[
           StyleBox["\[Zeta]",
            FontWeight->Bold,
            FontColor->GrayLevel[0.4]], "2", "3"]}], "35"], "-", 
        FractionBox[
         RowBox[{"916992", " ", 
          SubsuperscriptBox[
           StyleBox["\[Zeta]",
            FontWeight->Bold,
            FontColor->GrayLevel[0.4]], "2", "4"]}], "175"], "+", 
        RowBox[{"125712", " ", 
         SubscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "3"]}], "+", 
        RowBox[{"4896", " ", 
         SubscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "2"], " ", 
         SubscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "3"]}], "-", 
        RowBox[{"5184", " ", 
         SubsuperscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "2", "2"], " ", 
         SubscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "3"]}], "+", 
        RowBox[{
         FractionBox["55296", "35"], " ", 
         SubsuperscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "2", "3"], " ", 
         SubscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "3"]}], "-", 
        RowBox[{"20736", " ", 
         SubsuperscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "3", "2"]}], "-", 
        RowBox[{"6912", " ", 
         SubscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "2"], " ", 
         SubsuperscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "3", "2"]}], "+", 
        RowBox[{"74304", " ", 
         SubscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "5"]}], "+", 
        RowBox[{"21888", " ", 
         SubscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "2"], " ", 
         SubscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "5"]}], "+", 
        RowBox[{
         FractionBox["24192", "5"], " ", 
         SubsuperscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "2", "2"], " ", 
         SubscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "5"]}], "-", 
        RowBox[{"79488", " ", 
         SubscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "3"], " ", 
         SubscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "5"]}], "+", 
        RowBox[{"98496", " ", 
         SubscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "7"]}], "-", 
        RowBox[{"65664", " ", 
         SubscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "2"], " ", 
         SubscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "7"]}]}], ")"}]}]}], ")"}]}], "+", 
  RowBox[{
   SuperscriptBox["g", "14"], " ", 
   RowBox[{"(", 
    RowBox[{"3216672", "+", 
     RowBox[{"435024", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2"]}], "-", 
     RowBox[{"970704", " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2", "2"]}], "-", 
     FractionBox[
      RowBox[{"1902528", " ", 
       SubsuperscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "2", "3"]}], "7"], "+", 
     FractionBox[
      RowBox[{"19429632", " ", 
       SubsuperscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "2", "4"]}], "175"], "+", 
     FractionBox[
      RowBox[{"1835136", " ", 
       SubsuperscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "2", "5"]}], "175"], "-", 
     RowBox[{"34128", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3"]}], "-", 
     RowBox[{"552672", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3"]}], "+", 
     RowBox[{"189216", " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2", "2"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3"]}], "+", 
     RowBox[{"86400", " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2", "3"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3"]}], "+", 
     RowBox[{
      FractionBox["27648", "25"], " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2", "4"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3"]}], "-", 
     RowBox[{"769824", " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3", "2"]}], "+", 
     RowBox[{"200448", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2"], " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3", "2"]}], "-", 
     RowBox[{
      FractionBox["13824", "5"], " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2", "2"], " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3", "2"]}], "+", 
     RowBox[{"31104", " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3", "3"]}], "-", 
     RowBox[{"1966032", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "5"]}], "+", 
     RowBox[{"82944", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "5"]}], "+", 
     RowBox[{"251424", " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2", "2"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "5"]}], "+", 
     RowBox[{
      FractionBox["62208", "35"], " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2", "3"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "5"]}], "+", 
     RowBox[{"663552", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "5"]}], "-", 
     RowBox[{"48384", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "5"]}], "+", 
     RowBox[{"129600", " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "5", "2"]}], "-", 
     RowBox[{"783432", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "7"]}], "+", 
     RowBox[{"117936", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "7"]}], "+", 
     RowBox[{
      FractionBox["15552", "5"], " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2", "2"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "7"]}], "+", 
     RowBox[{"409536", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "7"]}], "-", 
     RowBox[{"12096", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "9"]}], "+", 
     RowBox[{"8064", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "9"]}], "+", 
     RowBox[{
      SuperscriptBox["z", "6"], " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "1161216"}], "+", 
        RowBox[{"1043712", " ", 
         SubscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "2"]}], "-", 
        FractionBox[
         RowBox[{"3234816", " ", 
          SubsuperscriptBox[
           StyleBox["\[Zeta]",
            FontWeight->Bold,
            FontColor->GrayLevel[0.4]], "2", "2"]}], "5"], "-", 
        FractionBox[
         RowBox[{"2211840", " ", 
          SubsuperscriptBox[
           StyleBox["\[Zeta]",
            FontWeight->Bold,
            FontColor->GrayLevel[0.4]], "2", "3"]}], "7"], "+", 
        FractionBox[
         RowBox[{"4644864", " ", 
          SubsuperscriptBox[
           StyleBox["\[Zeta]",
            FontWeight->Bold,
            FontColor->GrayLevel[0.4]], "2", "4"]}], "25"], "-", 
        RowBox[{"34560", " ", 
         SubscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "3"]}], "-", 
        RowBox[{"4608", " ", 
         SubscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "2"], " ", 
         SubscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "3"]}], "+", 
        RowBox[{
         FractionBox["442368", "5"], " ", 
         SubsuperscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "2", "2"], " ", 
         SubscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "3"]}], "+", 
        RowBox[{
         FractionBox["663552", "7"], " ", 
         SubsuperscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "2", "3"], " ", 
         SubscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "3"]}], "-", 
        RowBox[{"221184", " ", 
         SubsuperscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "2", "4"], " ", 
         SubscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "3"]}], "+", 
        RowBox[{"2446848", " ", 
         SubscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "5"]}], "-", 
        RowBox[{"359424", " ", 
         SubscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "2"], " ", 
         SubscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "5"]}], "-", 
        RowBox[{"55296", " ", 
         SubsuperscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "2", "2"], " ", 
         SubscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "5"]}], "-", 
        RowBox[{
         FractionBox["884736", "7"], " ", 
         SubsuperscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "2", "3"], " ", 
         SubscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "5"]}], "+", 
        RowBox[{"497664", " ", 
         SubscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "7"]}], "-", 
        RowBox[{"552960", " ", 
         SubscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "2"], " ", 
         SubscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "7"]}], "+", 
        RowBox[{
         FractionBox["2820096", "5"], " ", 
         SubsuperscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "2", "2"], " ", 
         SubscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "7"]}], "-", 
        RowBox[{"1548288", " ", 
         SubscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "9"]}], "+", 
        RowBox[{"1032192", " ", 
         SubscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "2"], " ", 
         SubscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "9"]}]}], ")"}]}], "+", 
     RowBox[{"12960", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], 
       RowBox[{"2", ",", "6"}]]}], "-", 
     RowBox[{"8640", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], 
       RowBox[{"2", ",", "6"}]]}], "+", 
     RowBox[{
      SuperscriptBox["z", "4"], " ", 
      RowBox[{"(", 
       RowBox[{"694656", "-", 
        RowBox[{"2154816", " ", 
         SubscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "2"]}], "+", 
        FractionBox[
         RowBox[{"255744", " ", 
          SubsuperscriptBox[
           StyleBox["\[Zeta]",
            FontWeight->Bold,
            FontColor->GrayLevel[0.4]], "2", "2"]}], "5"], "+", 
        FractionBox[
         RowBox[{"18876672", " ", 
          SubsuperscriptBox[
           StyleBox["\[Zeta]",
            FontWeight->Bold,
            FontColor->GrayLevel[0.4]], "2", "3"]}], "35"], "-", 
        FractionBox[
         RowBox[{"2875392", " ", 
          SubsuperscriptBox[
           StyleBox["\[Zeta]",
            FontWeight->Bold,
            FontColor->GrayLevel[0.4]], "2", "4"]}], "25"], "-", 
        FractionBox[
         RowBox[{"11649024", " ", 
          SubsuperscriptBox[
           StyleBox["\[Zeta]",
            FontWeight->Bold,
            FontColor->GrayLevel[0.4]], "2", "5"]}], "175"], "+", 
        RowBox[{"2718144", " ", 
         SubscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "3"]}], "+", 
        RowBox[{"273024", " ", 
         SubscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "2"], " ", 
         SubscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "3"]}], "-", 
        RowBox[{
         FractionBox["1133568", "5"], " ", 
         SubsuperscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "2", "2"], " ", 
         SubscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "3"]}], "+", 
        RowBox[{
         FractionBox["3981312", "35"], " ", 
         SubsuperscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "2", "3"], " ", 
         SubscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "3"]}], "-", 
        RowBox[{
         FractionBox["3649536", "25"], " ", 
         SubsuperscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "2", "4"], " ", 
         SubscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "3"]}], "-", 
        RowBox[{"829440", " ", 
         SubsuperscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "3", "2"]}], "+", 
        RowBox[{"27648", " ", 
         SubscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "2"], " ", 
         SubsuperscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "3", "2"]}], "+", 
        RowBox[{"82944", " ", 
         SubsuperscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "2", "2"], " ", 
         SubsuperscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "3", "2"]}], "-", 
        RowBox[{"1670976", " ", 
         SubscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "5"]}], "+", 
        RowBox[{"381312", " ", 
         SubscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "2"], " ", 
         SubscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "5"]}], "-", 
        RowBox[{
         FractionBox["440064", "5"], " ", 
         SubsuperscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "2", "2"], " ", 
         SubscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "5"]}], "+", 
        RowBox[{
         FractionBox["73728", "7"], " ", 
         SubsuperscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "2", "3"], " ", 
         SubscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "5"]}], "+", 
        RowBox[{"76032", " ", 
         SubscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "3"], " ", 
         SubscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "5"]}], "+", 
        RowBox[{"387072", " ", 
         SubscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "2"], " ", 
         SubscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "3"], " ", 
         SubscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "5"]}], "+", 
        RowBox[{"138240", " ", 
         SubsuperscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "5", "2"]}], "+", 
        RowBox[{"120960", " ", 
         SubscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "7"]}], "-", 
        RowBox[{"486144", " ", 
         SubscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "2"], " ", 
         SubscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "7"]}], "+", 
        RowBox[{
         FractionBox["456192", "5"], " ", 
         SubsuperscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "2", "2"], " ", 
         SubscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "7"]}], "+", 
        RowBox[{"622080", " ", 
         SubscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "3"], " ", 
         SubscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "7"]}], "-", 
        RowBox[{"2225664", " ", 
         SubscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "9"]}], "+", 
        RowBox[{"1483776", " ", 
         SubscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "2"], " ", 
         SubscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "9"]}], "+", 
        RowBox[{"207360", " ", 
         SubscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], 
          RowBox[{"2", ",", "6"}]]}], "-", 
        RowBox[{"138240", " ", 
         SubscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "2"], " ", 
         SubscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], 
          RowBox[{"2", ",", "6"}]]}]}], ")"}]}], "+", 
     RowBox[{
      SuperscriptBox["z", "2"], " ", 
      RowBox[{"(", 
       RowBox[{"4981176", "-", 
        RowBox[{"1108944", " ", 
         SubscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "2"]}], "+", 
        FractionBox[
         RowBox[{"3763584", " ", 
          SubsuperscriptBox[
           StyleBox["\[Zeta]",
            FontWeight->Bold,
            FontColor->GrayLevel[0.4]], "2", "2"]}], "5"], "-", 
        FractionBox[
         RowBox[{"10501056", " ", 
          SubsuperscriptBox[
           StyleBox["\[Zeta]",
            FontWeight->Bold,
            FontColor->GrayLevel[0.4]], "2", "3"]}], "35"], "-", 
        FractionBox[
         RowBox[{"46446336", " ", 
          SubsuperscriptBox[
           StyleBox["\[Zeta]",
            FontWeight->Bold,
            FontColor->GrayLevel[0.4]], "2", "4"]}], "175"], "+", 
        FractionBox[
         RowBox[{"14017536", " ", 
          SubsuperscriptBox[
           StyleBox["\[Zeta]",
            FontWeight->Bold,
            FontColor->GrayLevel[0.4]], "2", "5"]}], "175"], "-", 
        RowBox[{"5245776", " ", 
         SubscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "3"]}], "+", 
        RowBox[{"39456", " ", 
         SubscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "2"], " ", 
         SubscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "3"]}], "+", 
        RowBox[{
         FractionBox["1532736", "5"], " ", 
         SubsuperscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "2", "2"], " ", 
         SubscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "3"]}], "+", 
        RowBox[{
         FractionBox["13298688", "35"], " ", 
         SubsuperscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "2", "3"], " ", 
         SubscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "3"]}], "+", 
        RowBox[{
         FractionBox["165888", "25"], " ", 
         SubsuperscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "2", "4"], " ", 
         SubscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "3"]}], "+", 
        RowBox[{"1197504", " ", 
         SubsuperscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "3", "2"]}], "-", 
        RowBox[{"17280", " ", 
         SubscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "2"], " ", 
         SubsuperscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "3", "2"]}], "-", 
        RowBox[{
         FractionBox["82944", "5"], " ", 
         SubsuperscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "2", "2"], " ", 
         SubsuperscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "3", "2"]}], "-", 
        RowBox[{"186624", " ", 
         SubsuperscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "3", "3"]}], "+", 
        RowBox[{"981072", " ", 
         SubscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "5"]}], "-", 
        RowBox[{"1014624", " ", 
         SubscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "2"], " ", 
         SubscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "5"]}], "-", 
        RowBox[{"312768", " ", 
         SubsuperscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "2", "2"], " ", 
         SubscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "5"]}], "-", 
        RowBox[{
         FractionBox["442368", "35"], " ", 
         SubsuperscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "2", "3"], " ", 
         SubscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "5"]}], "+", 
        RowBox[{"319680", " ", 
         SubscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "3"], " ", 
         SubscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "5"]}], "-", 
        RowBox[{"200448", " ", 
         SubscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "2"], " ", 
         SubscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "3"], " ", 
         SubscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "5"]}], "+", 
        RowBox[{"812160", " ", 
         SubsuperscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "5", "2"]}], "-", 
        RowBox[{"1923264", " ", 
         SubscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "7"]}], "+", 
        RowBox[{"563328", " ", 
         SubscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "2"], " ", 
         SubscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "7"]}], "+", 
        RowBox[{
         FractionBox["10368", "5"], " ", 
         SubsuperscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "2", "2"], " ", 
         SubscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "7"]}], "+", 
        RowBox[{"528768", " ", 
         SubscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "3"], " ", 
         SubscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "7"]}], "-", 
        RowBox[{"532224", " ", 
         SubscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "9"]}], "+", 
        RowBox[{"354816", " ", 
         SubscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "2"], " ", 
         SubscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "9"]}], "-", 
        RowBox[{"93312", " ", 
         SubscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], 
          RowBox[{"2", ",", "6"}]]}], "+", 
        RowBox[{"62208", " ", 
         SubscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "2"], " ", 
         SubscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], 
          RowBox[{"2", ",", "6"}]]}]}], ")"}]}]}], ")"}]}]}]], "Output",
 CellChangeTimes->{
  3.555828329998637*^9, 3.555828405629641*^9, 3.5558284557487183`*^9, {
   3.555828641047724*^9, 3.555828662552433*^9}, 3.555854607193573*^9, 
   3.5558546486811*^9, 3.564855824928358*^9}]
}, Open  ]]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  FormBox[
   RowBox[{
    RowBox[{
     RowBox[{"Log", "[", 
      RowBox[{"(", 
       FractionBox[
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           SubscriptBox[
            StyleBox["\[GothicQ]",
             FontColor->RGBColor[0.54, 0.35, 0.15]], "2"], "-", 
           SubsuperscriptBox[
            StyleBox["\[GothicQ]",
             FontColor->RGBColor[0.54, 0.35, 0.15]], "2", 
            RowBox[{"[", "2", "]"}]]}], ")"}], 
         RowBox[{"(", 
          RowBox[{
           SubscriptBox[
            OverscriptBox[
             StyleBox["\[GothicQ]",
              FontColor->RGBColor[0.54, 0.35, 0.15]], 
             StyleBox["_",
              FontColor->RGBColor[0.54, 0.35, 0.15]]], "2"], "-", 
           SubsuperscriptBox[
            OverscriptBox[
             StyleBox["\[GothicQ]",
              FontColor->RGBColor[0.54, 0.35, 0.15]], 
             StyleBox["_",
              FontColor->RGBColor[0.54, 0.35, 0.15]]], "2", 
            RowBox[{"[", 
             RowBox[{"-", "2"}], "]"}]]}], ")"}], " ", 
         SuperscriptBox[
          StyleBox["\[GothicCapitalT]",
           FontColor->RGBColor[0.54, 0.35, 0.15]], "-"], " ", 
         SuperscriptBox[
          StyleBox["\[GothicCapitalT]",
           FontColor->RGBColor[0.54, 0.35, 0.15]], "+"]}], 
        SubscriptBox[
         RowBox[{"(", 
          RowBox[{
           RowBox[{"(", 
            RowBox[{
             SubscriptBox[
              StyleBox["\[GothicQ]",
               FontColor->RGBColor[0.54, 0.35, 0.15]], "2"], "-", 
             SubsuperscriptBox[
              StyleBox["\[GothicQ]",
               FontColor->RGBColor[0.54, 0.35, 0.15]], "2", 
              RowBox[{"[", "2", "]"}]]}], ")"}], 
           RowBox[{"(", 
            RowBox[{
             SubscriptBox[
              OverscriptBox[
               StyleBox["\[GothicQ]",
                FontColor->RGBColor[0.54, 0.35, 0.15]], 
               StyleBox["_",
                FontColor->RGBColor[0.54, 0.35, 0.15]]], "2"], "-", 
             SubsuperscriptBox[
              OverscriptBox[
               StyleBox["\[GothicQ]",
                FontColor->RGBColor[0.54, 0.35, 0.15]], 
               StyleBox["_",
                FontColor->RGBColor[0.54, 0.35, 0.15]]], "2", 
              RowBox[{"[", 
               RowBox[{"-", "2"}], "]"}]]}], ")"}], "  ", 
           SuperscriptBox[
            StyleBox["\[GothicCapitalT]",
             FontColor->RGBColor[0.54, 0.35, 0.15]], "-"], " ", 
           SuperscriptBox[
            StyleBox["\[GothicCapitalT]",
             FontColor->RGBColor[0.54, 0.35, 0.15]], "+"]}], ")"}], "asym"]], 
       ")"}], "]"}], "\[Rule]", 
     RowBox[{"Log", "[", 
      FractionBox[
       RowBox[{" ", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           SubscriptBox[
            StyleBox["\[GothicQ]",
             FontColor->RGBColor[0.54, 0.35, 0.15]], "2"], "-", 
           SubsuperscriptBox[
            StyleBox["\[GothicQ]",
             FontColor->RGBColor[0.54, 0.35, 0.15]], "2", 
            RowBox[{"[", "2", "]"}]]}], ")"}], 
         RowBox[{"(", 
          RowBox[{
           SubscriptBox[
            OverscriptBox[
             StyleBox["\[GothicQ]",
              FontColor->RGBColor[0.54, 0.35, 0.15]], 
             StyleBox["_",
              FontColor->RGBColor[0.54, 0.35, 0.15]]], "2"], "-", 
           SubsuperscriptBox[
            OverscriptBox[
             StyleBox["\[GothicQ]",
              FontColor->RGBColor[0.54, 0.35, 0.15]], 
             StyleBox["_",
              FontColor->RGBColor[0.54, 0.35, 0.15]]], "2", 
            RowBox[{"[", 
             RowBox[{"-", "2"}], "]"}]]}], ")"}], 
         RowBox[{"(", 
          RowBox[{
           SubscriptBox[
            StyleBox["\[GothicQ]",
             FontColor->RGBColor[0.54, 0.35, 0.15]], "2"], "+", 
           SubsuperscriptBox[
            OverscriptBox[
             StyleBox["\[GothicQ]",
              FontColor->RGBColor[0.54, 0.35, 0.15]], "_"], "2", 
            RowBox[{"[", 
             RowBox[{"-", "2"}], "]"}]]}], ")"}], 
         RowBox[{"(", 
          RowBox[{
           SubscriptBox[
            OverscriptBox[
             StyleBox["\[GothicQ]",
              FontColor->RGBColor[0.54, 0.35, 0.15]], "_"], "2"], "+", 
           SubsuperscriptBox[
            StyleBox["\[GothicQ]",
             FontColor->RGBColor[0.54, 0.35, 0.15]], "2", 
            RowBox[{"[", 
             RowBox[{"+", "2"}], "]"}]]}], ")"}]}]}], 
       RowBox[{
        SubscriptBox[
         RowBox[{"(", 
          RowBox[{
           RowBox[{"(", 
            RowBox[{
             SubscriptBox[
              StyleBox["\[GothicQ]",
               FontColor->RGBColor[0.54, 0.35, 0.15]], "2"], "-", 
             SubsuperscriptBox[
              StyleBox["\[GothicQ]",
               FontColor->RGBColor[0.54, 0.35, 0.15]], "2", 
              RowBox[{"[", "2", "]"}]]}], ")"}], 
           RowBox[{"(", 
            RowBox[{
             SubscriptBox[
              OverscriptBox[
               StyleBox["\[GothicQ]",
                FontColor->RGBColor[0.54, 0.35, 0.15]], 
               StyleBox["_",
                FontColor->RGBColor[0.54, 0.35, 0.15]]], "2"], "-", 
             SubsuperscriptBox[
              OverscriptBox[
               StyleBox["\[GothicQ]",
                FontColor->RGBColor[0.54, 0.35, 0.15]], 
               StyleBox["_",
                FontColor->RGBColor[0.54, 0.35, 0.15]]], "2", 
              RowBox[{"[", 
               RowBox[{"-", "2"}], "]"}]]}], ")"}], 
           RowBox[{"(", 
            RowBox[{
             SubscriptBox[
              StyleBox["\[GothicQ]",
               FontColor->RGBColor[0.54, 0.35, 0.15]], "2"], "+", 
             SubsuperscriptBox[
              OverscriptBox[
               StyleBox["\[GothicQ]",
                FontColor->RGBColor[0.54, 0.35, 0.15]], "_"], "2", 
              RowBox[{"[", 
               RowBox[{"-", "2"}], "]"}]]}], ")"}], 
           RowBox[{"(", 
            RowBox[{
             SubscriptBox[
              OverscriptBox[
               StyleBox["\[GothicQ]",
                FontColor->RGBColor[0.54, 0.35, 0.15]], "_"], "2"], "+", 
             SubsuperscriptBox[
              StyleBox["\[GothicQ]",
               FontColor->RGBColor[0.54, 0.35, 0.15]], "2", 
              RowBox[{"[", 
               RowBox[{"+", "2"}], "]"}]]}], ")"}]}], ")"}], "asym"], " "}]], 
      "]"}]}], "=", 
    RowBox[{
    "productq2Wint", "+", "productq2\[Delta]\[Rho]2", "+", 
     "productq2Wmp0"}]}], TraditionalForm]],
  FormatType->"TraditionalForm"],
 "\n(*Corrections  from changing  ",
 Cell[BoxData[
  FormBox[
   SubscriptBox["q", "2"], TraditionalForm]]],
 ", including change of q2 by ",
 Cell[BoxData[
  FormBox[
   SubscriptBox["W", "0"], TraditionalForm]]],
 "*)"
}], "Subsection",
 CellChangeTimes->{{3.546834634966998*^9, 3.546834643565124*^9}, {
  3.5468601889263153`*^9, 3.546860191509297*^9}, {3.546868207176361*^9, 
  3.5468682174960833`*^9}, {3.546945196188978*^9, 3.546945216345038*^9}, {
  3.546946209451289*^9, 3.5469462142553062`*^9}, {3.5469779315773697`*^9, 
  3.546977931577567*^9}, {3.547190665613242*^9, 3.547190666759266*^9}, {
  3.5496961235066147`*^9, 3.5496961281269217`*^9}, {3.549702438884674*^9, 
  3.549702445751395*^9}, {3.549735848431609*^9, 3.549735853019761*^9}, {
  3.5537189517928143`*^9, 3.553718967791031*^9}, {3.553721079353677*^9, 
  3.55372111792717*^9}, {3.553728517752797*^9, 3.553728578445665*^9}, {
  3.555828771705508*^9, 3.555828880540886*^9}, {3.5558289295622997`*^9, 
  3.5558289653369427`*^9}}],

Cell["\<\
The same game, just change some signs...\
\>", "Text",
 CellChangeTimes->{{3.555829065228085*^9, 3.555829072251614*^9}}],

Cell[CellGroupData[{

Cell[TextData[{
 "Correction from ",
 Cell[BoxData[
  FormBox[
   SubscriptBox["\[Delta]\[Rho]", "2"], TraditionalForm]]]
}], "Subsubsection",
 CellChangeTimes->{{3.553721690765481*^9, 3.553721709405624*^9}}],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{
     FractionBox[
      RowBox[{"(", 
       RowBox[{
        SuperscriptBox["\[ScriptCapitalC]", 
         RowBox[{"[", 
          RowBox[{"+", "o"}], "]"}]], "-", 
        SuperscriptBox["\[ScriptCapitalC]", 
         RowBox[{"[", 
          RowBox[{"+", "2"}], "]"}]]}], ")"}], 
      RowBox[{"(", 
       RowBox[{
        SubscriptBox[
         StyleBox["\[GothicQ]",
          FontColor->RGBColor[0.54, 0.35, 0.15]], "2"], "-", 
        SubsuperscriptBox[
         StyleBox["\[GothicQ]",
          FontColor->RGBColor[0.54, 0.35, 0.15]], "2", 
         RowBox[{"[", "2", "]"}]]}], ")"}]], "+", 
     FractionBox[
      RowBox[{"-", 
       RowBox[{"(", 
        RowBox[{
         SuperscriptBox["\[ScriptCapitalC]", 
          RowBox[{"[", 
           RowBox[{"-", "o"}], "]"}]], "-", 
         SuperscriptBox["\[ScriptCapitalC]", 
          RowBox[{"[", 
           RowBox[{"-", "2"}], "]"}]]}], ")"}]}], 
      RowBox[{"(", 
       RowBox[{
        SubscriptBox[
         OverscriptBox[
          StyleBox["\[GothicQ]",
           FontColor->RGBColor[0.54, 0.35, 0.15]], 
          StyleBox["_",
           FontColor->RGBColor[0.54, 0.35, 0.15]]], "2"], "-", 
        SubsuperscriptBox[
         OverscriptBox[
          StyleBox["\[GothicQ]",
           FontColor->RGBColor[0.54, 0.35, 0.15]], 
          StyleBox["_",
           FontColor->RGBColor[0.54, 0.35, 0.15]]], "2", 
         RowBox[{"[", 
          RowBox[{"-", "2"}], "]"}]]}], ")"}]], "+", 
     FractionBox[
      RowBox[{"(", 
       RowBox[{
        SuperscriptBox["\[ScriptCapitalC]", 
         RowBox[{"[", 
          RowBox[{"+", "o"}], "]"}]], "-", 
        SuperscriptBox["\[ScriptCapitalC]", 
         RowBox[{"[", 
          RowBox[{"-", "2"}], "]"}]]}], ")"}], 
      RowBox[{"(", 
       RowBox[{
        SubscriptBox[
         StyleBox["\[GothicQ]",
          FontColor->RGBColor[0.54, 0.35, 0.15]], "2"], "+", 
        SubsuperscriptBox[
         OverscriptBox[
          StyleBox["\[GothicQ]",
           FontColor->RGBColor[0.54, 0.35, 0.15]], "_"], "2", 
         RowBox[{"[", 
          RowBox[{"-", "2"}], "]"}]]}], ")"}]], "+", 
     FractionBox[
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", 
         SuperscriptBox["\[ScriptCapitalC]", 
          RowBox[{"[", 
           RowBox[{"-", "o"}], "]"}]]}], "+", 
        SuperscriptBox["\[ScriptCapitalC]", 
         RowBox[{"[", 
          RowBox[{"+", "2"}], "]"}]]}], ")"}], 
      RowBox[{"(", 
       RowBox[{
        SubscriptBox[
         OverscriptBox[
          StyleBox["\[GothicQ]",
           FontColor->RGBColor[0.54, 0.35, 0.15]], "_"], "2"], "+", 
        SubsuperscriptBox[
         StyleBox["\[GothicQ]",
          FontColor->RGBColor[0.54, 0.35, 0.15]], "2", 
         RowBox[{"[", 
          RowBox[{"+", "2"}], "]"}]]}], ")"}]]}], "/.", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"q$u", "\[Rule]", "q$"}], ",", 
      RowBox[{"q$ub", "\[Rule]", "q$b"}]}], "}"}]}], "/.", "largevolume"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"tmp", "=", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"Series", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"%", "/.", 
         RowBox[{"u", "\[Rule]", 
          RowBox[{"2", "g", " ", "z"}]}]}], "//.", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"xxx", ":", 
           RowBox[{"(", 
            RowBox[{"Alternatives", "@@", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{"Q0", "[", 
                RowBox[{"_", ":", "0"}], "]"}], ",", 
               RowBox[{"Q", "[", 
                RowBox[{"_", ":", "0"}], "]"}], ",", 
               SubscriptBox["\[Gamma]", "0"], ",", 
               RowBox[{"x", "[", 
                RowBox[{"_", ":", "0"}], "]"}]}], "}"}]}], ")"}]}], 
          "\[RuleDelayed]", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{
             RowBox[{
              RowBox[{"xxx", "/.", "subQ0"}], "/.", "subJuk"}], "/.", 
             RowBox[{"leadweak", "[", "4", "]"}]}], "/.", 
            RowBox[{"u", "\[Rule]", 
             RowBox[{"2", "g", " ", "z"}]}]}], ")"}]}], ")"}]}], ",", 
       RowBox[{"{", 
        RowBox[{"g", ",", "0", ",", "8"}], "}"}]}], "]"}], "/.", 
     RowBox[{
      SuperscriptBox[
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          RowBox[{"-", "\[ImaginaryI]"}], " ", "z"}], "+", 
         SqrtBox[
          RowBox[{"1", "-", 
           SuperscriptBox["z", "2"]}]]}], ")"}], 
       RowBox[{"a_", "/;", 
        RowBox[{"a", "<", "0"}]}]], "\[RuleDelayed]", 
      SuperscriptBox[
       RowBox[{"(", 
        FractionBox["1", 
         RowBox[{
          RowBox[{"\[ImaginaryI]", " ", "z"}], "+", 
          SqrtBox[
           RowBox[{"1", "-", 
            SuperscriptBox["z", "2"]}]]}]], ")"}], "a"]}]}], "//", 
    "Simplify"}], "//", "Normal"}]}]}], "Input",
 CellChangeTimes->{{3.5537217283244762`*^9, 3.553721954008107*^9}, {
   3.555823475656831*^9, 3.555823528850947*^9}, {3.5558236419898367`*^9, 
   3.5558236435491953`*^9}, {3.555823700204507*^9, 3.555823701245968*^9}, {
   3.555828976326468*^9, 3.555828978414919*^9}, 3.5558547737155247`*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"-", "12"}], " ", 
   SuperscriptBox["g", "2"], " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"-", "1"}], "+", 
     RowBox[{"2", " ", 
      SuperscriptBox["z", "2"]}]}], ")"}], " ", 
   RowBox[{"(", 
    RowBox[{
     SuperscriptBox[
      StyleBox["\[ScriptCapitalC]",
       FontColor->RGBColor[0, 0, 0.8]], 
      RowBox[{"[", 
       RowBox[{"-", "2"}], "]"}]], "-", 
     SuperscriptBox[
      StyleBox["\[ScriptCapitalC]",
       FontColor->RGBColor[0, 0, 0.8]], 
      RowBox[{"[", "2", "]"}]]}], ")"}]}], "+", 
  RowBox[{"6", " ", 
   SuperscriptBox["g", "4"], " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"-", "11"}], "+", 
     RowBox[{"2", " ", 
      SuperscriptBox["z", "2"]}], "+", 
     RowBox[{"24", " ", 
      SuperscriptBox["z", "4"]}]}], ")"}], " ", 
   RowBox[{"(", 
    RowBox[{
     SuperscriptBox[
      StyleBox["\[ScriptCapitalC]",
       FontColor->RGBColor[0, 0, 0.8]], 
      RowBox[{"[", 
       RowBox[{"-", "2"}], "]"}]], "-", 
     SuperscriptBox[
      StyleBox["\[ScriptCapitalC]",
       FontColor->RGBColor[0, 0, 0.8]], 
      RowBox[{"[", "2", "]"}]]}], ")"}]}], "+", 
  RowBox[{"12", " ", 
   SuperscriptBox["g", "6"], " ", 
   RowBox[{"(", 
    RowBox[{"25", "+", 
     RowBox[{"188", " ", 
      SuperscriptBox["z", "2"]}], "-", 
     RowBox[{"416", " ", 
      SuperscriptBox["z", "4"]}], "+", 
     RowBox[{"144", " ", 
      SuperscriptBox["z", "6"]}]}], ")"}], " ", 
   RowBox[{"(", 
    RowBox[{
     SuperscriptBox[
      StyleBox["\[ScriptCapitalC]",
       FontColor->RGBColor[0, 0, 0.8]], 
      RowBox[{"[", 
       RowBox[{"-", "2"}], "]"}]], "-", 
     SuperscriptBox[
      StyleBox["\[ScriptCapitalC]",
       FontColor->RGBColor[0, 0, 0.8]], 
      RowBox[{"[", "2", "]"}]]}], ")"}]}], "+", 
  RowBox[{"36", " ", 
   SuperscriptBox["g", "3"], " ", "z", " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"\[ImaginaryI]", " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "1"}], "+", 
        RowBox[{"2", " ", 
         SuperscriptBox["z", "2"]}]}], ")"}], " ", 
      RowBox[{"(", 
       RowBox[{
        SuperscriptBox[
         StyleBox["\[ScriptCapitalC]",
          FontColor->RGBColor[0, 0, 0.8]], 
         RowBox[{"[", 
          RowBox[{"-", "2"}], "]"}]], "+", 
        SuperscriptBox[
         StyleBox["\[ScriptCapitalC]",
          FontColor->RGBColor[0, 0, 0.8]], 
         RowBox[{"[", "2", "]"}]]}], ")"}]}], "+", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"\[ImaginaryI]", "-", 
        RowBox[{"2", " ", "\[ImaginaryI]", " ", 
         SuperscriptBox["z", "2"]}], "-", 
        RowBox[{"2", " ", "z", " ", 
         SqrtBox[
          RowBox[{"1", "-", 
           SuperscriptBox["z", "2"]}]]}]}], ")"}], " ", 
      SuperscriptBox[
       StyleBox["\[ScriptCapitalC]",
        FontColor->RGBColor[0, 0, 0.8]], 
       RowBox[{"[", 
        RowBox[{"-", "o"}], "]"}]]}], "+", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"\[ImaginaryI]", "-", 
        RowBox[{"2", " ", "\[ImaginaryI]", " ", 
         SuperscriptBox["z", "2"]}], "+", 
        RowBox[{"2", " ", "z", " ", 
         SqrtBox[
          RowBox[{"1", "-", 
           SuperscriptBox["z", "2"]}]]}]}], ")"}], " ", 
      SuperscriptBox[
       StyleBox["\[ScriptCapitalC]",
        FontColor->RGBColor[0, 0, 0.8]], 
       RowBox[{"[", "o", "]"}]]}]}], ")"}]}], "+", 
  RowBox[{"12", " ", 
   SuperscriptBox["g", "5"], " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{
      RowBox[{"-", "\[ImaginaryI]"}], " ", "z", " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "41"}], "+", 
        RowBox[{"64", " ", 
         SuperscriptBox["z", "2"]}]}], ")"}], " ", 
      RowBox[{"(", 
       RowBox[{
        SuperscriptBox[
         StyleBox["\[ScriptCapitalC]",
          FontColor->RGBColor[0, 0, 0.8]], 
         RowBox[{"[", 
          RowBox[{"-", "2"}], "]"}]], "+", 
        SuperscriptBox[
         StyleBox["\[ScriptCapitalC]",
          FontColor->RGBColor[0, 0, 0.8]], 
         RowBox[{"[", "2", "]"}]]}], ")"}]}], "+", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         RowBox[{"-", "41"}], " ", "\[ImaginaryI]", " ", "z"}], "+", 
        RowBox[{"64", " ", "\[ImaginaryI]", " ", 
         SuperscriptBox["z", "3"]}], "-", 
        RowBox[{"8", " ", 
         SqrtBox[
          RowBox[{"1", "-", 
           SuperscriptBox["z", "2"]}]]}], "+", 
        RowBox[{"64", " ", 
         SuperscriptBox["z", "2"], " ", 
         SqrtBox[
          RowBox[{"1", "-", 
           SuperscriptBox["z", "2"]}]]}]}], ")"}], " ", 
      SuperscriptBox[
       StyleBox["\[ScriptCapitalC]",
        FontColor->RGBColor[0, 0, 0.8]], 
       RowBox[{"[", 
        RowBox[{"-", "o"}], "]"}]]}], "+", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         RowBox[{"-", "41"}], " ", "\[ImaginaryI]", " ", "z"}], "+", 
        RowBox[{"64", " ", "\[ImaginaryI]", " ", 
         SuperscriptBox["z", "3"]}], "+", 
        RowBox[{"8", " ", 
         SqrtBox[
          RowBox[{"1", "-", 
           SuperscriptBox["z", "2"]}]]}], "-", 
        RowBox[{"64", " ", 
         SuperscriptBox["z", "2"], " ", 
         SqrtBox[
          RowBox[{"1", "-", 
           SuperscriptBox["z", "2"]}]]}]}], ")"}], " ", 
      SuperscriptBox[
       StyleBox["\[ScriptCapitalC]",
        FontColor->RGBColor[0, 0, 0.8]], 
       RowBox[{"[", "o", "]"}]]}]}], ")"}]}], "+", 
  RowBox[{"g", " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"6", " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"\[ImaginaryI]", " ", "z"}], "+", 
        SqrtBox[
         RowBox[{"1", "-", 
          SuperscriptBox["z", "2"]}]]}], ")"}], " ", 
      SuperscriptBox[
       StyleBox["\[ScriptCapitalC]",
        FontColor->RGBColor[0, 0, 0.8]], 
       RowBox[{"[", 
        RowBox[{"-", "o"}], "]"}]]}], "-", 
     RowBox[{"6", " ", "\[ImaginaryI]", " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"z", " ", 
         RowBox[{"(", 
          RowBox[{
           SuperscriptBox[
            StyleBox["\[ScriptCapitalC]",
             FontColor->RGBColor[0, 0, 0.8]], 
            RowBox[{"[", 
             RowBox[{"-", "2"}], "]"}]], "+", 
           SuperscriptBox[
            StyleBox["\[ScriptCapitalC]",
             FontColor->RGBColor[0, 0, 0.8]], 
            RowBox[{"[", "2", "]"}]]}], ")"}]}], "+", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           RowBox[{"-", "z"}], "-", 
           RowBox[{"\[ImaginaryI]", " ", 
            SqrtBox[
             RowBox[{"1", "-", 
              SuperscriptBox["z", "2"]}]]}]}], ")"}], " ", 
         SuperscriptBox[
          StyleBox["\[ScriptCapitalC]",
           FontColor->RGBColor[0, 0, 0.8]], 
          RowBox[{"[", "o", "]"}]]}]}], ")"}]}]}], ")"}]}], "-", 
  RowBox[{"24", " ", 
   SuperscriptBox["g", "8"], " ", 
   RowBox[{"(", 
    RowBox[{
     SuperscriptBox[
      StyleBox["\[ScriptCapitalC]",
       FontColor->RGBColor[0, 0, 0.8]], 
      RowBox[{"[", 
       RowBox[{"-", "2"}], "]"}]], "-", 
     SuperscriptBox[
      StyleBox["\[ScriptCapitalC]",
       FontColor->RGBColor[0, 0, 0.8]], 
      RowBox[{"[", "2", "]"}]]}], ")"}], " ", 
   RowBox[{"(", 
    RowBox[{"56", "-", 
     RowBox[{"644", " ", 
      SuperscriptBox["z", "4"]}], "-", 
     RowBox[{"2368", " ", 
      SuperscriptBox["z", "6"]}], "+", 
     RowBox[{"1728", " ", 
      SuperscriptBox["z", "8"]}], "+", 
     RowBox[{
      SuperscriptBox["z", "2"], " ", 
      RowBox[{"(", 
       RowBox[{"1017", "-", 
        RowBox[{"60", " ", 
         SubscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "3"]}]}], ")"}]}], "+", 
     RowBox[{"30", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3"]}]}], ")"}]}], "+", 
  RowBox[{"12", " ", 
   SuperscriptBox["g", "7"], " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{
      RowBox[{"-", "2"}], " ", "\[ImaginaryI]", " ", "z", " ", 
      RowBox[{"(", 
       RowBox[{
        SuperscriptBox[
         StyleBox["\[ScriptCapitalC]",
          FontColor->RGBColor[0, 0, 0.8]], 
         RowBox[{"[", 
          RowBox[{"-", "2"}], "]"}]], "+", 
        SuperscriptBox[
         StyleBox["\[ScriptCapitalC]",
          FontColor->RGBColor[0, 0, 0.8]], 
         RowBox[{"[", "2", "]"}]]}], ")"}], " ", 
      RowBox[{"(", 
       RowBox[{"129", "+", 
        RowBox[{"211", " ", 
         SuperscriptBox["z", "2"]}], "-", 
        RowBox[{"860", " ", 
         SuperscriptBox["z", "4"]}], "+", 
        RowBox[{"432", " ", 
         SuperscriptBox["z", "6"]}], "-", 
        RowBox[{"6", " ", 
         SubscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "3"]}]}], ")"}]}], "+", 
     RowBox[{
      SuperscriptBox[
       StyleBox["\[ScriptCapitalC]",
        FontColor->RGBColor[0, 0, 0.8]], 
       RowBox[{"[", 
        RowBox[{"-", "o"}], "]"}]], " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"422", " ", "\[ImaginaryI]", " ", 
         SuperscriptBox["z", "3"]}], "-", 
        RowBox[{"1720", " ", "\[ImaginaryI]", " ", 
         SuperscriptBox["z", "5"]}], "+", 
        RowBox[{"864", " ", "\[ImaginaryI]", " ", 
         SuperscriptBox["z", "7"]}], "-", 
        RowBox[{"118", " ", 
         SuperscriptBox["z", "2"], " ", 
         SqrtBox[
          RowBox[{"1", "-", 
           SuperscriptBox["z", "2"]}]]}], "-", 
        RowBox[{"1288", " ", 
         SuperscriptBox["z", "4"], " ", 
         SqrtBox[
          RowBox[{"1", "-", 
           SuperscriptBox["z", "2"]}]]}], "+", 
        RowBox[{"864", " ", 
         SuperscriptBox["z", "6"], " ", 
         SqrtBox[
          RowBox[{"1", "-", 
           SuperscriptBox["z", "2"]}]]}], "+", 
        RowBox[{"3", " ", 
         SqrtBox[
          RowBox[{"1", "-", 
           SuperscriptBox["z", "2"]}]], " ", 
         RowBox[{"(", 
          RowBox[{"25", "-", 
           RowBox[{"4", " ", 
            SubscriptBox[
             StyleBox["\[Zeta]",
              FontWeight->Bold,
              FontColor->GrayLevel[0.4]], "3"]}]}], ")"}]}], "-", 
        RowBox[{"6", " ", "\[ImaginaryI]", " ", "z", " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"-", "43"}], "+", 
           RowBox[{"2", " ", 
            SubscriptBox[
             StyleBox["\[Zeta]",
              FontWeight->Bold,
              FontColor->GrayLevel[0.4]], "3"]}]}], ")"}]}]}], ")"}]}], "+", 
     RowBox[{
      SuperscriptBox[
       StyleBox["\[ScriptCapitalC]",
        FontColor->RGBColor[0, 0, 0.8]], 
       RowBox[{"[", "o", "]"}]], " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"422", " ", "\[ImaginaryI]", " ", 
         SuperscriptBox["z", "3"]}], "-", 
        RowBox[{"1720", " ", "\[ImaginaryI]", " ", 
         SuperscriptBox["z", "5"]}], "+", 
        RowBox[{"864", " ", "\[ImaginaryI]", " ", 
         SuperscriptBox["z", "7"]}], "+", 
        RowBox[{"118", " ", 
         SuperscriptBox["z", "2"], " ", 
         SqrtBox[
          RowBox[{"1", "-", 
           SuperscriptBox["z", "2"]}]]}], "+", 
        RowBox[{"1288", " ", 
         SuperscriptBox["z", "4"], " ", 
         SqrtBox[
          RowBox[{"1", "-", 
           SuperscriptBox["z", "2"]}]]}], "-", 
        RowBox[{"864", " ", 
         SuperscriptBox["z", "6"], " ", 
         SqrtBox[
          RowBox[{"1", "-", 
           SuperscriptBox["z", "2"]}]]}], "-", 
        RowBox[{"6", " ", "\[ImaginaryI]", " ", "z", " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"-", "43"}], "+", 
           RowBox[{"2", " ", 
            SubscriptBox[
             StyleBox["\[Zeta]",
              FontWeight->Bold,
              FontColor->GrayLevel[0.4]], "3"]}]}], ")"}]}], "+", 
        RowBox[{"3", " ", 
         SqrtBox[
          RowBox[{"1", "-", 
           SuperscriptBox["z", "2"]}]], " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"-", "25"}], "+", 
           RowBox[{"4", " ", 
            SubscriptBox[
             StyleBox["\[Zeta]",
              FontWeight->Bold,
              FontColor->GrayLevel[0.4]], "3"]}]}], ")"}]}]}], ")"}]}]}], 
    ")"}]}]}]], "Output",
 CellChangeTimes->{{3.553721882164321*^9, 3.5537218999003267`*^9}, 
   3.5537219582111397`*^9, {3.5558234943490057`*^9, 3.555823529826674*^9}, 
   3.555823644274384*^9, 3.5558237020066757`*^9, 3.555828983225792*^9, 
   3.5558547753985567`*^9, 3.564855848922971*^9}]
}, Open  ]],

Cell["\<\
For \[ScriptCapitalC] we make the same thing as we did for \[Delta]\[Rho] \
case:\
\>", "Text",
 CellChangeTimes->{{3.555823551589016*^9, 3.555823564106531*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{
      SuperscriptBox[
       StyleBox["\[ScriptCapitalC]", "Dafault"], 
       RowBox[{"[", "o", "]"}]], "\[Rule]", " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         FractionBox["1", "2"], "\[Delta]\[Rho]2"}], "+", 
        RowBox[{"PV", "[", "\[Delta]\[Rho]2", "]"}]}], ")"}]}], ",", 
     RowBox[{
      SuperscriptBox[
       StyleBox["\[ScriptCapitalC]", "Dafault"], 
       RowBox[{"[", 
        RowBox[{"-", "o"}], "]"}]], "\[Rule]", " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         RowBox[{"-", 
          FractionBox["1", "2"]}], "\[Delta]\[Rho]2"}], "+", 
        RowBox[{"PV", "[", "\[Delta]\[Rho]2", "]"}]}], ")"}]}], ",", 
     RowBox[{
      SuperscriptBox["\[ScriptCapitalC]", 
       RowBox[{"[", 
        RowBox[{"+", "2"}], "]"}]], "\[Rule]", " ", 
      RowBox[{"Normal", "@", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          RowBox[{"Expand", "/@", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"Series", "[", 
              RowBox[{
               RowBox[{
                RowBox[{"-", 
                 FractionBox[
                  RowBox[{"2", "g"}], 
                  RowBox[{"2", " ", "\[ImaginaryI]"}]]}], 
                FractionBox["w", 
                 RowBox[{
                  RowBox[{"2", "g", " ", "z"}], "+", "\[ImaginaryI]"}]]}], 
               ",", 
               RowBox[{"{", 
                RowBox[{"g", ",", "0", ",", "16"}], "}"}]}], "]"}], "/.", 
             RowBox[{"z", "\[Rule]", 
              RowBox[{"(", 
               RowBox[{"z", "-", "w"}], ")"}]}]}], ")"}]}], "/.", 
          RowBox[{
           SuperscriptBox["w", "a_."], "\[RuleDelayed]", 
           RowBox[{"If", "[", 
            RowBox[{
             RowBox[{"EvenQ", "[", "a", "]"}], ",", "0", ",", 
             SuperscriptBox["w", "a"]}], "]"}]}]}], "/.", 
         RowBox[{
          SuperscriptBox["w", "a_."], "\[RuleDelayed]", 
          RowBox[{"M", "[", 
           RowBox[{
            SuperscriptBox["w", 
             RowBox[{"a", "-", "1"}]], "\[Delta]\[Rho]2"}], "]"}]}]}], 
        ")"}]}]}], ",", 
     RowBox[{
      SuperscriptBox["\[ScriptCapitalC]", 
       RowBox[{"[", 
        RowBox[{"-", "2"}], "]"}]], "\[Rule]", " ", 
      RowBox[{"Normal", "@", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          RowBox[{"Expand", "/@", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"Series", "[", 
              RowBox[{
               RowBox[{
                RowBox[{"-", 
                 FractionBox[
                  RowBox[{"2", "g"}], 
                  RowBox[{"2", " ", "\[ImaginaryI]"}]]}], 
                FractionBox["w", 
                 RowBox[{
                  RowBox[{"2", "g", " ", "z"}], "-", "\[ImaginaryI]"}]]}], 
               ",", 
               RowBox[{"{", 
                RowBox[{"g", ",", "0", ",", "16"}], "}"}]}], "]"}], "/.", 
             RowBox[{"z", "\[Rule]", 
              RowBox[{"(", 
               RowBox[{"z", "-", "w"}], ")"}]}]}], ")"}]}], "/.", 
          RowBox[{
           SuperscriptBox["w", "a_."], "\[RuleDelayed]", 
           RowBox[{"If", "[", 
            RowBox[{
             RowBox[{"EvenQ", "[", "a", "]"}], ",", "0", ",", 
             SuperscriptBox["w", "a"]}], "]"}]}]}], "/.", 
         RowBox[{
          SuperscriptBox["w", "a_."], "\[RuleDelayed]", 
          RowBox[{"M", "[", 
           RowBox[{
            SuperscriptBox["w", 
             RowBox[{"a", "-", "1"}]], "\[Delta]\[Rho]2"}], "]"}]}]}], 
        ")"}]}]}]}], "}"}], "/.", 
   RowBox[{"\[Delta]\[Rho]2", "\[Rule]", 
    RowBox[{"Expand", "[", 
     RowBox[{
      SuperscriptBox["g", "7"], 
      RowBox[{"(", 
       RowBox[{
        SubscriptBox["\[Delta]\[Rho]2", "lead"], "+", 
        RowBox[{
         SuperscriptBox["g", "2"], 
         SubscriptBox["\[Delta]\[Rho]2", "sublead"]}], "+", 
        RowBox[{
         SuperscriptBox["g", "4"], 
         SubscriptBox["\[Delta]\[Rho]2", "sublead2"]}]}], ")"}]}], "]"}]}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{"%", "/.", 
        RowBox[{
         RowBox[{"PV", "[", "a_", "]"}], "\[RuleDelayed]", 
         RowBox[{"PV", "[", 
          RowBox[{"Expand", "[", "a", "]"}], "]"}]}]}], "//.", 
       RowBox[{
        RowBox[{"PV", "[", 
         RowBox[{
          RowBox[{
           SuperscriptBox["g", "a_."], "b_."}], "+", "c_"}], "]"}], 
        "\[RuleDelayed]", 
        RowBox[{
         RowBox[{
          SuperscriptBox["g", "a"], 
          RowBox[{"PV", "[", "b", "]"}]}], "+", 
         RowBox[{"PV", "[", "c", "]"}]}]}]}], "/.", 
      RowBox[{
       RowBox[{"PV", "[", 
        RowBox[{
         SuperscriptBox["g", "a_."], "b_."}], "]"}], "\[RuleDelayed]", 
       RowBox[{
        SuperscriptBox["g", "a"], 
        RowBox[{"PV", "[", "b", "]"}]}]}]}], "/.", 
     RowBox[{
      RowBox[{"M", "[", "a_", "]"}], "\[RuleDelayed]", 
      RowBox[{"M", "[", 
       RowBox[{"Expand", "[", "a", "]"}], "]"}]}]}], "//.", 
    RowBox[{
     RowBox[{"M", "[", 
      RowBox[{
       RowBox[{
        SuperscriptBox["g", "a_."], "b_."}], "+", "c_"}], "]"}], 
     "\[RuleDelayed]", 
     RowBox[{
      RowBox[{
       SuperscriptBox["g", "a"], 
       RowBox[{"M", "[", "b", "]"}]}], "+", 
      RowBox[{"M", "[", "c", "]"}]}]}]}], "/.", 
   RowBox[{
    RowBox[{"M", "[", 
     RowBox[{
      SuperscriptBox["g", "a_."], "b_."}], "]"}], "\[RuleDelayed]", 
    RowBox[{
     SuperscriptBox["g", "a"], 
     RowBox[{"M", "[", "b", "]"}]}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"tmpsubs", "=", 
   RowBox[{"%", "/.", 
    RowBox[{
     RowBox[{"Rule", "[", 
      RowBox[{"a_", ",", "b_"}], "]"}], "\[RuleDelayed]", 
     RowBox[{"Rule", "[", 
      RowBox[{"a", ",", 
       RowBox[{"Normal", "@", 
        RowBox[{"Series", "[", 
         RowBox[{"b", ",", 
          RowBox[{"{", 
           RowBox[{"g", ",", "0", ",", "21"}], "}"}]}], "]"}]}]}], 
      "]"}]}]}]}], ";"}]}], "Input",
 CellChangeTimes->{{3.555823600656617*^9, 3.555823633343945*^9}, {
  3.55585478424504*^9, 3.555854789694264*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"productq2\[Delta]\[Rho]2", "=", 
  RowBox[{"Collect", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"Series", "[", 
      RowBox[{
       RowBox[{"tmp", "/.", "tmpsubs"}], ",", 
       RowBox[{"{", 
        RowBox[{"g", ",", "0", ",", "14"}], "}"}]}], "]"}], "//", "Normal"}], 
    ",", 
    RowBox[{"{", 
     RowBox[{"g", ",", 
      SqrtBox[
       RowBox[{"1", "-", 
        SuperscriptBox["z", "2"]}]]}], "}"}], ",", "Simplify"}], 
   "]"}]}]], "Input",
 CellChangeTimes->{{3.555823664344098*^9, 3.555823705633832*^9}, {
  3.5558237870777807`*^9, 3.555823787645262*^9}, {3.555823819211955*^9, 
  3.5558238424438667`*^9}, {3.555823895446691*^9, 3.5558239108836927`*^9}, {
  3.555829010812738*^9, 3.55582902949137*^9}, {3.555854803850313*^9, 
  3.555854803951736*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   SuperscriptBox["g", "8"], " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"12", " ", "\[ImaginaryI]", " ", "z", " ", 
      RowBox[{"PV", "[", 
       SubscriptBox["\[Delta]\[Rho]2", "lead"], "]"}]}], "-", 
     RowBox[{"6", " ", 
      SqrtBox[
       RowBox[{"1", "-", 
        SuperscriptBox["z", "2"]}]], " ", 
      SubscriptBox["\[Delta]\[Rho]2", "lead"]}]}], ")"}]}], "+", 
  RowBox[{
   SuperscriptBox["g", "10"], " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"12", " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           RowBox[{"-", "2"}], "+", 
           RowBox[{"6", " ", 
            SuperscriptBox["z", "2"]}]}], ")"}], " ", 
         RowBox[{"M", "[", 
          SubscriptBox["\[Delta]\[Rho]2", "lead"], "]"}]}], "+", 
        RowBox[{"\[ImaginaryI]", " ", "z", " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{
            RowBox[{"(", 
             RowBox[{"6", "-", 
              RowBox[{"12", " ", 
               SuperscriptBox["z", "2"]}]}], ")"}], " ", 
            RowBox[{"PV", "[", 
             SubscriptBox["\[Delta]\[Rho]2", "lead"], "]"}]}], "+", 
           RowBox[{"PV", "[", 
            SubscriptBox["\[Delta]\[Rho]2", "sublead"], "]"}]}], ")"}]}]}], 
       ")"}]}], "+", 
     RowBox[{
      SqrtBox[
       RowBox[{"1", "-", 
        SuperscriptBox["z", "2"]}]], " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"72", " ", 
         SuperscriptBox["z", "2"], " ", 
         SubscriptBox["\[Delta]\[Rho]2", "lead"]}], "-", 
        RowBox[{"6", " ", 
         SubscriptBox["\[Delta]\[Rho]2", "sublead"]}]}], ")"}]}]}], ")"}]}], 
  "+", 
  RowBox[{
   SuperscriptBox["g", "12"], " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{
      RowBox[{"-", "12"}], " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           RowBox[{"-", "11"}], "-", 
           RowBox[{"18", " ", 
            SuperscriptBox["z", "2"]}], "+", 
           RowBox[{"72", " ", 
            SuperscriptBox["z", "4"]}]}], ")"}], " ", 
         RowBox[{"M", "[", 
          SubscriptBox["\[Delta]\[Rho]2", "lead"], "]"}]}], "+", 
        RowBox[{"8", " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"-", "1"}], "+", 
           RowBox[{"5", " ", 
            SuperscriptBox["z", "2"]}]}], ")"}], " ", 
         RowBox[{"M", "[", 
          RowBox[{
           SuperscriptBox["w", "2"], " ", 
           SubscriptBox["\[Delta]\[Rho]2", "lead"]}], "]"}]}], "-", 
        RowBox[{"\[ImaginaryI]", " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{
            RowBox[{"-", "2"}], " ", "\[ImaginaryI]", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "1"}], "+", 
              RowBox[{"3", " ", 
               SuperscriptBox["z", "2"]}]}], ")"}], " ", 
            RowBox[{"M", "[", 
             SubscriptBox["\[Delta]\[Rho]2", "sublead"], "]"}]}], "+", 
           RowBox[{"z", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"2", " ", 
               RowBox[{"(", 
                RowBox[{
                 RowBox[{"-", "41"}], "+", 
                 RowBox[{"64", " ", 
                  SuperscriptBox["z", "2"]}]}], ")"}], " ", 
               RowBox[{"PV", "[", 
                SubscriptBox["\[Delta]\[Rho]2", "lead"], "]"}]}], "+", 
              RowBox[{
               RowBox[{"(", 
                RowBox[{"6", "-", 
                 RowBox[{"12", " ", 
                  SuperscriptBox["z", "2"]}]}], ")"}], " ", 
               RowBox[{"PV", "[", 
                SubscriptBox["\[Delta]\[Rho]2", "sublead"], "]"}]}], "+", 
              RowBox[{"PV", "[", 
               SubscriptBox["\[Delta]\[Rho]2", "sublead2"], "]"}]}], 
             ")"}]}]}], ")"}]}]}], ")"}]}], "+", 
     RowBox[{
      SqrtBox[
       RowBox[{"1", "-", 
        SuperscriptBox["z", "2"]}]], " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         RowBox[{"-", "96"}], " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"-", "1"}], "+", 
           RowBox[{"8", " ", 
            SuperscriptBox["z", "2"]}]}], ")"}], " ", 
         SubscriptBox["\[Delta]\[Rho]2", "lead"]}], "+", 
        RowBox[{"72", " ", 
         SuperscriptBox["z", "2"], " ", 
         SubscriptBox["\[Delta]\[Rho]2", "sublead"]}], "-", 
        RowBox[{"6", " ", 
         SubscriptBox["\[Delta]\[Rho]2", "sublead2"]}]}], ")"}]}]}], ")"}]}], 
  "+", 
  RowBox[{
   SuperscriptBox["g", "14"], " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{
      RowBox[{"-", "12"}], " ", 
      SqrtBox[
       RowBox[{"1", "-", 
        SuperscriptBox["z", "2"]}]], " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"8", " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"-", "1"}], "+", 
           RowBox[{"8", " ", 
            SuperscriptBox["z", "2"]}]}], ")"}], " ", 
         SubscriptBox["\[Delta]\[Rho]2", "sublead"]}], "-", 
        RowBox[{"6", " ", 
         SuperscriptBox["z", "2"], " ", 
         SubscriptBox["\[Delta]\[Rho]2", "sublead2"]}], "+", 
        RowBox[{
         SubscriptBox["\[Delta]\[Rho]2", "lead"], " ", 
         RowBox[{"(", 
          RowBox[{"75", "-", 
           RowBox[{"118", " ", 
            SuperscriptBox["z", "2"]}], "-", 
           RowBox[{"1288", " ", 
            SuperscriptBox["z", "4"]}], "+", 
           RowBox[{"864", " ", 
            SuperscriptBox["z", "6"]}], "-", 
           RowBox[{"12", " ", 
            SubscriptBox[
             StyleBox["\[Zeta]",
              FontWeight->Bold,
              FontColor->GrayLevel[0.4]], "3"]}]}], ")"}]}]}], ")"}]}], "+", 
     RowBox[{"12", " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"2", " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"-", "25"}], "-", 
           RowBox[{"292", " ", 
            SuperscriptBox["z", "2"]}], "+", 
           RowBox[{"508", " ", 
            SuperscriptBox["z", "4"]}]}], ")"}], " ", 
         RowBox[{"M", "[", 
          SubscriptBox["\[Delta]\[Rho]2", "lead"], "]"}]}], "+", 
        RowBox[{"4", " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"-", "11"}], "-", 
           RowBox[{"82", " ", 
            SuperscriptBox["z", "2"]}], "+", 
           RowBox[{"272", " ", 
            SuperscriptBox["z", "4"]}]}], ")"}], " ", 
         RowBox[{"M", "[", 
          RowBox[{
           SuperscriptBox["w", "2"], " ", 
           SubscriptBox["\[Delta]\[Rho]2", "lead"]}], "]"}]}], "-", 
        RowBox[{"32", " ", 
         RowBox[{"M", "[", 
          RowBox[{
           SuperscriptBox["w", "4"], " ", 
           SubscriptBox["\[Delta]\[Rho]2", "lead"]}], "]"}]}], "+", 
        RowBox[{"224", " ", 
         SuperscriptBox["z", "2"], " ", 
         RowBox[{"M", "[", 
          RowBox[{
           SuperscriptBox["w", "4"], " ", 
           SubscriptBox["\[Delta]\[Rho]2", "lead"]}], "]"}]}], "+", 
        RowBox[{"11", " ", 
         RowBox[{"M", "[", 
          SubscriptBox["\[Delta]\[Rho]2", "sublead"], "]"}]}], "+", 
        RowBox[{"18", " ", 
         SuperscriptBox["z", "2"], " ", 
         RowBox[{"M", "[", 
          SubscriptBox["\[Delta]\[Rho]2", "sublead"], "]"}]}], "-", 
        RowBox[{"72", " ", 
         SuperscriptBox["z", "4"], " ", 
         RowBox[{"M", "[", 
          SubscriptBox["\[Delta]\[Rho]2", "sublead"], "]"}]}], "+", 
        RowBox[{"8", " ", 
         RowBox[{"M", "[", 
          RowBox[{
           SuperscriptBox["w", "2"], " ", 
           SubscriptBox["\[Delta]\[Rho]2", "sublead"]}], "]"}]}], "-", 
        RowBox[{"40", " ", 
         SuperscriptBox["z", "2"], " ", 
         RowBox[{"M", "[", 
          RowBox[{
           SuperscriptBox["w", "2"], " ", 
           SubscriptBox["\[Delta]\[Rho]2", "sublead"]}], "]"}]}], "-", 
        RowBox[{"2", " ", 
         RowBox[{"M", "[", 
          SubscriptBox["\[Delta]\[Rho]2", "sublead2"], "]"}]}], "+", 
        RowBox[{"6", " ", 
         SuperscriptBox["z", "2"], " ", 
         RowBox[{"M", "[", 
          SubscriptBox["\[Delta]\[Rho]2", "sublead2"], "]"}]}], "+", 
        RowBox[{"516", " ", "\[ImaginaryI]", " ", "z", " ", 
         RowBox[{"PV", "[", 
          SubscriptBox["\[Delta]\[Rho]2", "lead"], "]"}]}], "+", 
        RowBox[{"844", " ", "\[ImaginaryI]", " ", 
         SuperscriptBox["z", "3"], " ", 
         RowBox[{"PV", "[", 
          SubscriptBox["\[Delta]\[Rho]2", "lead"], "]"}]}], "-", 
        RowBox[{"3440", " ", "\[ImaginaryI]", " ", 
         SuperscriptBox["z", "5"], " ", 
         RowBox[{"PV", "[", 
          SubscriptBox["\[Delta]\[Rho]2", "lead"], "]"}]}], "+", 
        RowBox[{"1728", " ", "\[ImaginaryI]", " ", 
         SuperscriptBox["z", "7"], " ", 
         RowBox[{"PV", "[", 
          SubscriptBox["\[Delta]\[Rho]2", "lead"], "]"}]}], "-", 
        RowBox[{"82", " ", "\[ImaginaryI]", " ", "z", " ", 
         RowBox[{"PV", "[", 
          SubscriptBox["\[Delta]\[Rho]2", "sublead"], "]"}]}], "+", 
        RowBox[{"128", " ", "\[ImaginaryI]", " ", 
         SuperscriptBox["z", "3"], " ", 
         RowBox[{"PV", "[", 
          SubscriptBox["\[Delta]\[Rho]2", "sublead"], "]"}]}], "+", 
        RowBox[{"6", " ", "\[ImaginaryI]", " ", "z", " ", 
         RowBox[{"PV", "[", 
          SubscriptBox["\[Delta]\[Rho]2", "sublead2"], "]"}]}], "-", 
        RowBox[{"12", " ", "\[ImaginaryI]", " ", 
         SuperscriptBox["z", "3"], " ", 
         RowBox[{"PV", "[", 
          SubscriptBox["\[Delta]\[Rho]2", "sublead2"], "]"}]}], "-", 
        RowBox[{"24", " ", "\[ImaginaryI]", " ", "z", " ", 
         RowBox[{"PV", "[", 
          SubscriptBox["\[Delta]\[Rho]2", "lead"], "]"}], " ", 
         SubscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "3"]}]}], ")"}]}]}], 
    ")"}]}]}]], "Output",
 CellChangeTimes->{{3.555823674301133*^9, 3.55582370632253*^9}, 
   3.555823788411509*^9, 3.555823843172443*^9, 3.555823911445879*^9, {
   3.555829016686079*^9, 3.5558290304264803`*^9}, 3.5558548062474413`*^9, 
   3.564855858023994*^9}]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 "Correction from ",
 Cell[BoxData[
  FormBox[
   SubscriptBox[
    OverscriptBox["W", "^"], 
    RowBox[{"0", ",", "pv"}]], TraditionalForm]]]
}], "Subsubsection",
 CellChangeTimes->{{3.553721690765481*^9, 3.553721709405624*^9}, {
  3.5537230332410517`*^9, 3.553723038227042*^9}}],

Cell[TextData[{
 "Here we have to go one order more, because ",
 Cell[BoxData[
  FormBox[
   RowBox[{
    SuperscriptBox["C", 
     RowBox[{"[", 
      RowBox[{"+", "0"}], "]"}]], "*", 
    SubscriptBox[
     OverscriptBox["W", "^"], 
     RowBox[{"0", ",", "pv"}]]}], TraditionalForm]]],
 " is of order ",
 Cell[BoxData[
  FormBox[
   SuperscriptBox["g", "6"], TraditionalForm]]],
 " (+ corrections )"
}], "Text",
 CellChangeTimes->{{3.5537230490703907`*^9, 3.553723084172709*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"-", 
     RowBox[{"(", 
      RowBox[{
       FractionBox[
        RowBox[{"(", 
         RowBox[{
          SuperscriptBox["\[ScriptCapitalC]", 
           RowBox[{"[", 
            RowBox[{"+", "o"}], "]"}]], "-", 
          SuperscriptBox["\[ScriptCapitalC]", 
           RowBox[{"[", 
            RowBox[{"+", "2"}], "]"}]]}], ")"}], 
        RowBox[{"(", 
         RowBox[{
          SubscriptBox[
           StyleBox["\[GothicQ]",
            FontColor->RGBColor[0.54, 0.35, 0.15]], "2"], "-", 
          SubsuperscriptBox[
           StyleBox["\[GothicQ]",
            FontColor->RGBColor[0.54, 0.35, 0.15]], "2", 
           RowBox[{"[", "2", "]"}]]}], ")"}]], "+", 
       FractionBox[
        RowBox[{"-", 
         RowBox[{"(", 
          RowBox[{
           SuperscriptBox["\[ScriptCapitalC]", 
            RowBox[{"[", 
             RowBox[{"-", "o"}], "]"}]], "-", 
           SuperscriptBox["\[ScriptCapitalC]", 
            RowBox[{"[", 
             RowBox[{"-", "2"}], "]"}]]}], ")"}]}], 
        RowBox[{"(", 
         RowBox[{
          SubscriptBox[
           OverscriptBox[
            StyleBox["\[GothicQ]",
             FontColor->RGBColor[0.54, 0.35, 0.15]], 
            StyleBox["_",
             FontColor->RGBColor[0.54, 0.35, 0.15]]], "2"], "-", 
          SubsuperscriptBox[
           OverscriptBox[
            StyleBox["\[GothicQ]",
             FontColor->RGBColor[0.54, 0.35, 0.15]], 
            StyleBox["_",
             FontColor->RGBColor[0.54, 0.35, 0.15]]], "2", 
           RowBox[{"[", 
            RowBox[{"-", "2"}], "]"}]]}], ")"}]], "+", 
       FractionBox[
        RowBox[{"(", 
         RowBox[{
          SuperscriptBox["\[ScriptCapitalC]", 
           RowBox[{"[", 
            RowBox[{"+", "o"}], "]"}]], "-", 
          SuperscriptBox["\[ScriptCapitalC]", 
           RowBox[{"[", 
            RowBox[{"-", "2"}], "]"}]]}], ")"}], 
        RowBox[{"(", 
         RowBox[{
          SubscriptBox[
           StyleBox["\[GothicQ]",
            FontColor->RGBColor[0.54, 0.35, 0.15]], "2"], "+", 
          SubsuperscriptBox[
           OverscriptBox[
            StyleBox["\[GothicQ]",
             FontColor->RGBColor[0.54, 0.35, 0.15]], "_"], "2", 
           RowBox[{"[", 
            RowBox[{"-", "2"}], "]"}]]}], ")"}]], "+", 
       FractionBox[
        RowBox[{"(", 
         RowBox[{
          RowBox[{"-", 
           SuperscriptBox["\[ScriptCapitalC]", 
            RowBox[{"[", 
             RowBox[{"-", "o"}], "]"}]]}], "+", 
          SuperscriptBox["\[ScriptCapitalC]", 
           RowBox[{"[", 
            RowBox[{"+", "2"}], "]"}]]}], ")"}], 
        RowBox[{"(", 
         RowBox[{
          SubscriptBox[
           OverscriptBox[
            StyleBox["\[GothicQ]",
             FontColor->RGBColor[0.54, 0.35, 0.15]], "_"], "2"], "+", 
          SubsuperscriptBox[
           StyleBox["\[GothicQ]",
            FontColor->RGBColor[0.54, 0.35, 0.15]], "2", 
           RowBox[{"[", 
            RowBox[{"+", "2"}], "]"}]]}], ")"}]]}], ")"}]}], "/.", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"q$u", "\[Rule]", "q$"}], ",", 
      RowBox[{"q$ub", "\[Rule]", "q$b"}]}], "}"}]}], "/.", "largevolume"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"tmp", "=", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"Series", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"%", "/.", 
          RowBox[{"u", "\[Rule]", 
           RowBox[{"2", "g", " ", "z"}]}]}], "//.", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"xxx", ":", 
            RowBox[{"(", 
             RowBox[{"Alternatives", "@@", 
              RowBox[{"{", 
               RowBox[{
                RowBox[{"Q0", "[", 
                 RowBox[{"_", ":", "0"}], "]"}], ",", 
                RowBox[{"Q", "[", 
                 RowBox[{"_", ":", "0"}], "]"}], ",", 
                SubscriptBox["\[Gamma]", "0"], ",", 
                RowBox[{"x", "[", 
                 RowBox[{"_", ":", "0"}], "]"}]}], "}"}]}], ")"}]}], 
           "\[RuleDelayed]", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{
              RowBox[{
               RowBox[{"xxx", "/.", "subQ0"}], "/.", "subJuk"}], "/.", 
              RowBox[{"leadweak", "[", "4", "]"}]}], "/.", 
             RowBox[{"u", "\[Rule]", 
              RowBox[{"2", "g", " ", "z"}]}]}], ")"}]}], ")"}]}], ",", 
        RowBox[{"{", 
         RowBox[{"g", ",", "0", ",", "8"}], "}"}]}], "]"}], "/.", 
      RowBox[{
       SuperscriptBox[
        RowBox[{"(", 
         RowBox[{
          RowBox[{
           RowBox[{"-", "\[ImaginaryI]"}], " ", "z"}], "+", 
          SqrtBox[
           RowBox[{"1", "-", 
            SuperscriptBox["z", "2"]}]]}], ")"}], 
        RowBox[{"a_", "/;", 
         RowBox[{"a", "<", "0"}]}]], "\[RuleDelayed]", 
       SuperscriptBox[
        RowBox[{"(", 
         FractionBox["1", 
          RowBox[{
           RowBox[{"\[ImaginaryI]", " ", "z"}], "+", 
           SqrtBox[
            RowBox[{"1", "-", 
             SuperscriptBox["z", "2"]}]]}]], ")"}], "a"]}]}], "//", 
     "Simplify"}], "//", "Normal"}]}], ";"}]}], "Input",
 CellChangeTimes->{{3.5558243087635307`*^9, 3.55582432847305*^9}, {
  3.5558272547174053`*^9, 3.555827257505205*^9}, {3.555829084723634*^9, 
  3.555829087250733*^9}}],

Cell["\<\
Let us compute contribution which is coming from the integrals:\
\>", "Text",
 CellChangeTimes->{{3.555825822160657*^9, 3.555825831990363*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"productq2Wint", "=", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     RowBox[{
      RowBox[{"Expand", "/@", 
       RowBox[{"Series", "[", 
        RowBox[{
         RowBox[{
          RowBox[{
           RowBox[{"Collect", "[", 
            RowBox[{
             RowBox[{
              RowBox[{"tmp", "/.", 
               RowBox[{"o", "\[Rule]", "0"}]}], "/.", 
              RowBox[{"{", 
               RowBox[{
                RowBox[{
                 StyleBox["\[ScriptCapitalC]",
                  FontColor->RGBColor[0, 0, 0.8]], "\[Rule]", " ", 
                 RowBox[{"\[DoubleStruckCapitalC]", "[", 
                  RowBox[{
                   RowBox[{"-", 
                    FractionBox[
                    RowBox[{"2", " ", "g", " ", "z", " "}], 
                    RowBox[{
                    SuperscriptBox["u", "2"], "-", 
                    RowBox[{"4", " ", 
                    SuperscriptBox["g", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}]]}], 
                   OverscriptBox[
                    StyleBox["W",
                    FontColor->RGBColor[0.54, 0.35, 0.15]], 
                    StyleBox["^",
                    FontColor->RGBColor[0.54, 0.35, 0.15]]]}], "]"}]}], ",", 
                RowBox[{
                 SuperscriptBox[
                  StyleBox["\[ScriptCapitalC]",
                   FontColor->RGBColor[0, 0, 0.8]], 
                  RowBox[{"[", "2", "]"}]], "\[Rule]", " ", 
                 RowBox[{"\[DoubleStruckCapitalC]", "[", 
                  RowBox[{
                   FractionBox[
                    RowBox[{"\[ImaginaryI]", "+", 
                    RowBox[{"2", " ", "g", " ", "z"}]}], 
                    RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["u", "2"]}], "+", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{"\[ImaginaryI]", "+", 
                    RowBox[{"2", " ", "g", " ", "z"}]}], ")"}], "2"]}]], " ", 
                   
                   OverscriptBox[
                    StyleBox["W",
                    FontColor->RGBColor[0.54, 0.35, 0.15]], 
                    StyleBox["^",
                    FontColor->RGBColor[0.54, 0.35, 0.15]]]}], "]"}]}], ",", 
                RowBox[{
                 SuperscriptBox[
                  StyleBox["\[ScriptCapitalC]",
                   FontColor->RGBColor[0, 0, 0.8]], 
                  RowBox[{"[", 
                   RowBox[{"-", "2"}], "]"}]], "\[Rule]", " ", 
                 RowBox[{"\[DoubleStruckCapitalC]", "[", 
                  RowBox[{
                   FractionBox[
                    RowBox[{"\[ImaginaryI]", "-", 
                    RowBox[{"2", " ", "g", " ", "z"}]}], 
                    RowBox[{
                    SuperscriptBox["u", "2"], "-", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{"\[ImaginaryI]", "-", 
                    RowBox[{"2", " ", "g", " ", "z"}]}], ")"}], "2"]}]], " ", 
                   
                   OverscriptBox[
                    StyleBox["W",
                    FontColor->RGBColor[0.54, 0.35, 0.15]], 
                    StyleBox["^",
                    FontColor->RGBColor[0.54, 0.35, 0.15]]]}], "]"}]}]}], 
               "}"}]}], ",", 
             RowBox[{"\[ScriptCapitalC]$", "[", 
              RowBox[{"_", ":", "0"}], "]"}]}], "]"}], "/.", 
           RowBox[{
            OverscriptBox["W", "^"], "\[Rule]", 
            RowBox[{
             SuperscriptBox["g", "8"], 
             RowBox[{"(", 
              RowBox[{
               SubscriptBox[
                OverscriptBox["W", "^"], "lead"], "+", 
               RowBox[{
                SuperscriptBox["g", "2"], 
                SubscriptBox[
                 OverscriptBox["W", "^"], "sublead"]}], "+", 
               RowBox[{
                SuperscriptBox["g", "4"], 
                SubscriptBox[
                 OverscriptBox["W", "^"], "sublead2"]}]}], ")"}]}]}]}], "/.", 
          
          RowBox[{
           RowBox[{"\[DoubleStruckCapitalC]", "[", "a_", "]"}], 
           "\[RuleDelayed]", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{
              RowBox[{
               RowBox[{
                RowBox[{"\[DoubleStruckCapitalC]", "[", 
                 RowBox[{
                  RowBox[{"Normal", "@", 
                   RowBox[{"Series", "[", 
                    RowBox[{"a", ",", 
                    RowBox[{"{", 
                    RowBox[{"g", ",", "0", ",", "14"}], "}"}]}], "]"}]}], "//",
                   "Expand"}], "]"}], "//.", 
                RowBox[{
                 RowBox[{"\[DoubleStruckCapitalC]", "[", 
                  RowBox[{
                   RowBox[{
                    SuperscriptBox["g", "aa_."], "b_."}], "+", "c_"}], "]"}], 
                 "\[RuleDelayed]", 
                 RowBox[{
                  RowBox[{
                   SuperscriptBox["g", "aa"], 
                   RowBox[{"\[DoubleStruckCapitalC]", "[", "b", "]"}]}], "+", 
                  
                  RowBox[{"\[DoubleStruckCapitalC]", "[", "c", "]"}]}]}]}], "/.", 
               RowBox[{
                RowBox[{"\[DoubleStruckCapitalC]", "[", 
                 RowBox[{
                  SuperscriptBox["g", "aa_."], "b_."}], "]"}], 
                "\[RuleDelayed]", " ", 
                RowBox[{
                 SuperscriptBox["g", "aa"], 
                 RowBox[{"\[DoubleStruckCapitalC]", "[", "b", "]"}]}]}]}], "/.", 
              RowBox[{
               RowBox[{"\[DoubleStruckCapitalC]", "[", 
                RowBox[{
                 SuperscriptBox["z", "aa_."], "bb_"}], "]"}], 
               "\[RuleDelayed]", 
               RowBox[{
                SuperscriptBox["z", "aa"], " ", 
                RowBox[{"\[DoubleStruckCapitalC]", "[", "bb", "]"}]}]}]}], "//.", 
             RowBox[{
              RowBox[{"(", 
               RowBox[{
                RowBox[{
                 RowBox[{"a1_.", " ", "e1_.", 
                  RowBox[{"\[DoubleStruckCapitalC]", "[", 
                   RowBox[{"b1_.", 
                    SubscriptBox[
                    OverscriptBox["W", "^"], "c1_"]}], "]"}]}], "+", 
                 RowBox[{"a2_.", "e1_.", 
                  RowBox[{"\[DoubleStruckCapitalC]", "[", 
                   RowBox[{"b2_.", 
                    SubscriptBox[
                    OverscriptBox["W", "^"], "c1_"]}], "]"}]}]}], "/;", 
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{"FreeQ", "[", 
                   RowBox[{"a1", ",", 
                    RowBox[{"z", "|", "g"}]}], "]"}], "&&", 
                  RowBox[{"FreeQ", "[", 
                   RowBox[{"a2", ",", 
                    RowBox[{"z", "|", "g"}]}], "]"}]}], ")"}]}], ")"}], 
              "\[RuleDelayed]", 
              RowBox[{"e1", " ", 
               RowBox[{"\[DoubleStruckCapitalC]", "[", 
                RowBox[{
                 RowBox[{"Simplify", "@", 
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{"a1", " ", "b1"}], "+", 
                    RowBox[{"a2", " ", "b2"}]}], ")"}]}], 
                 SubscriptBox[
                  OverscriptBox["W", "^"], "c1"]}], "]"}]}]}]}], ")"}]}]}], 
         ",", 
         RowBox[{"{", 
          RowBox[{"g", ",", "0", ",", "14"}], "}"}]}], "]"}]}], "//.", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          RowBox[{"a1_.", " ", "e1_.", 
           RowBox[{"\[DoubleStruckCapitalC]", "[", 
            RowBox[{"b1_.", 
             SubscriptBox[
              OverscriptBox["W", "^"], "c1_"]}], "]"}]}], "+", 
          RowBox[{"a2_.", "e1_.", 
           RowBox[{"\[DoubleStruckCapitalC]", "[", 
            RowBox[{"b2_.", 
             SubscriptBox[
              OverscriptBox["W", "^"], "c1_"]}], "]"}]}]}], "/;", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"FreeQ", "[", 
            RowBox[{"a1", ",", "z"}], "]"}], "&&", 
           RowBox[{"FreeQ", "[", 
            RowBox[{"a2", ",", "z"}], "]"}]}], ")"}]}], ")"}], 
       "\[RuleDelayed]", 
       RowBox[{"e1", " ", 
        RowBox[{"\[DoubleStruckCapitalC]", "[", 
         RowBox[{
          RowBox[{"Simplify", "@", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"a1", " ", "b1"}], "+", 
             RowBox[{"a2", " ", "b2"}]}], ")"}]}], 
          SubscriptBox[
           OverscriptBox["W", "^"], "c1"]}], "]"}]}]}]}], "/.", 
     RowBox[{
      RowBox[{"\[DoubleStruckCapitalC]", "[", "0", "]"}], "\[Rule]", "0"}]}], 
    ")"}], "//", "Normal"}]}]], "Input",
 CellChangeTimes->{{3.55582583676724*^9, 3.5558260887127*^9}, {
   3.555826146337365*^9, 3.555826151434085*^9}, {3.555826247464765*^9, 
   3.555826349961907*^9}, {3.555826406464158*^9, 3.555826424577861*^9}, {
   3.5558264622019587`*^9, 3.555826575517362*^9}, {3.55582684467315*^9, 
   3.555826846058529*^9}, {3.555826886212303*^9, 3.555826927578436*^9}, {
   3.555827127117009*^9, 3.5558271307313538`*^9}, {3.555827190001021*^9, 
   3.555827197038712*^9}, 3.55582723702668*^9, 3.555827271116486*^9, {
   3.555828564816039*^9, 3.555828593219985*^9}, {3.5558291061937532`*^9, 
   3.555829108338867*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   SuperscriptBox["g", "10"], " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"\[DoubleStruckCapitalC]", "[", 
      RowBox[{"-", 
       FractionBox[
        RowBox[{"24", " ", "\[ImaginaryI]", " ", 
         SubscriptBox[
          OverscriptBox[
           StyleBox["W",
            FontColor->RGBColor[0.54, 0.35, 0.15]], 
           StyleBox["^",
            FontColor->RGBColor[0.54, 0.35, 0.15]]], "lead"]}], 
        RowBox[{"1", "+", 
         SuperscriptBox["u", "2"]}]]}], "]"}], "+", 
     RowBox[{
      SuperscriptBox["z", "2"], " ", 
      RowBox[{"\[DoubleStruckCapitalC]", "[", 
       FractionBox[
        RowBox[{"24", " ", "\[ImaginaryI]", " ", 
         RowBox[{"(", 
          RowBox[{"1", "+", 
           RowBox[{"5", " ", 
            SuperscriptBox["u", "2"]}], "+", 
           RowBox[{"2", " ", 
            SuperscriptBox["u", "4"]}]}], ")"}], " ", 
         SubscriptBox[
          OverscriptBox[
           StyleBox["W",
            FontColor->RGBColor[0.54, 0.35, 0.15]], 
           StyleBox["^",
            FontColor->RGBColor[0.54, 0.35, 0.15]]], "lead"]}], 
        SuperscriptBox[
         RowBox[{"(", 
          RowBox[{"u", "+", 
           SuperscriptBox["u", "3"]}], ")"}], "2"]], "]"}]}]}], ")"}]}], "+", 
  
  RowBox[{
   SuperscriptBox["g", "12"], " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"\[DoubleStruckCapitalC]", "[", 
      FractionBox[
       RowBox[{"132", " ", "\[ImaginaryI]", " ", 
        SubscriptBox[
         OverscriptBox[
          StyleBox["W",
           FontColor->RGBColor[0.54, 0.35, 0.15]], 
          StyleBox["^",
           FontColor->RGBColor[0.54, 0.35, 0.15]]], "lead"]}], 
       RowBox[{"1", "+", 
        SuperscriptBox["u", "2"]}]], "]"}], "+", 
     RowBox[{
      SuperscriptBox["z", "2"], " ", 
      RowBox[{"\[DoubleStruckCapitalC]", "[", 
       RowBox[{"-", 
        FractionBox[
         RowBox[{"24", " ", "\[ImaginaryI]", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"-", "6"}], "-", 
            RowBox[{"27", " ", 
             SuperscriptBox["u", "2"]}], "-", 
            RowBox[{"4", " ", 
             SuperscriptBox["u", "4"]}], "+", 
            SuperscriptBox["u", "6"]}], ")"}], " ", 
          SubscriptBox[
           OverscriptBox[
            StyleBox["W",
             FontColor->RGBColor[0.54, 0.35, 0.15]], 
            StyleBox["^",
             FontColor->RGBColor[0.54, 0.35, 0.15]]], "lead"]}], 
         RowBox[{
          SuperscriptBox["u", "2"], " ", 
          SuperscriptBox[
           RowBox[{"(", 
            RowBox[{"1", "+", 
             SuperscriptBox["u", "2"]}], ")"}], "3"]}]]}], "]"}]}], "+", 
     RowBox[{
      SuperscriptBox["z", "4"], " ", 
      RowBox[{"\[DoubleStruckCapitalC]", "[", 
       RowBox[{"-", 
        FractionBox[
         RowBox[{"96", " ", "\[ImaginaryI]", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"-", "1"}], "-", 
            SuperscriptBox["u", "2"], "+", 
            RowBox[{"15", " ", 
             SuperscriptBox["u", "4"]}], "+", 
            RowBox[{"16", " ", 
             SuperscriptBox["u", "6"]}], "+", 
            RowBox[{"12", " ", 
             SuperscriptBox["u", "8"]}], "+", 
            RowBox[{"3", " ", 
             SuperscriptBox["u", "10"]}]}], ")"}], " ", 
          SubscriptBox[
           OverscriptBox[
            StyleBox["W",
             FontColor->RGBColor[0.54, 0.35, 0.15]], 
            StyleBox["^",
             FontColor->RGBColor[0.54, 0.35, 0.15]]], "lead"]}], 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"u", "+", 
            SuperscriptBox["u", "3"]}], ")"}], "4"]]}], "]"}]}], "+", 
     RowBox[{"\[DoubleStruckCapitalC]", "[", 
      RowBox[{"-", 
       FractionBox[
        RowBox[{"24", " ", "\[ImaginaryI]", " ", 
         SubscriptBox[
          OverscriptBox[
           StyleBox["W",
            FontColor->RGBColor[0.54, 0.35, 0.15]], 
           StyleBox["^",
            FontColor->RGBColor[0.54, 0.35, 0.15]]], "sublead"]}], 
        RowBox[{"1", "+", 
         SuperscriptBox["u", "2"]}]]}], "]"}], "+", 
     RowBox[{
      SuperscriptBox["z", "2"], " ", 
      RowBox[{"\[DoubleStruckCapitalC]", "[", 
       FractionBox[
        RowBox[{"24", " ", "\[ImaginaryI]", " ", 
         RowBox[{"(", 
          RowBox[{"1", "+", 
           RowBox[{"5", " ", 
            SuperscriptBox["u", "2"]}], "+", 
           RowBox[{"2", " ", 
            SuperscriptBox["u", "4"]}]}], ")"}], " ", 
         SubscriptBox[
          OverscriptBox[
           StyleBox["W",
            FontColor->RGBColor[0.54, 0.35, 0.15]], 
           StyleBox["^",
            FontColor->RGBColor[0.54, 0.35, 0.15]]], "sublead"]}], 
        SuperscriptBox[
         RowBox[{"(", 
          RowBox[{"u", "+", 
           SuperscriptBox["u", "3"]}], ")"}], "2"]], "]"}]}]}], ")"}]}], "+", 
  
  RowBox[{
   SuperscriptBox["g", "14"], " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"\[DoubleStruckCapitalC]", "[", 
      RowBox[{"-", 
       FractionBox[
        RowBox[{"600", " ", "\[ImaginaryI]", " ", 
         SubscriptBox[
          OverscriptBox[
           StyleBox["W",
            FontColor->RGBColor[0.54, 0.35, 0.15]], 
           StyleBox["^",
            FontColor->RGBColor[0.54, 0.35, 0.15]]], "lead"]}], 
        RowBox[{"1", "+", 
         SuperscriptBox["u", "2"]}]]}], "]"}], "+", 
     RowBox[{
      SuperscriptBox["z", "2"], " ", 
      RowBox[{"\[DoubleStruckCapitalC]", "[", 
       RowBox[{"-", 
        FractionBox[
         RowBox[{"48", " ", "\[ImaginaryI]", " ", 
          RowBox[{"(", 
           RowBox[{"41", "+", 
            RowBox[{"269", " ", 
             SuperscriptBox["u", "2"]}], "+", 
            RowBox[{"278", " ", 
             SuperscriptBox["u", "4"]}], "+", 
            RowBox[{"94", " ", 
             SuperscriptBox["u", "6"]}]}], ")"}], " ", 
          SubscriptBox[
           OverscriptBox[
            StyleBox["W",
             FontColor->RGBColor[0.54, 0.35, 0.15]], 
            StyleBox["^",
             FontColor->RGBColor[0.54, 0.35, 0.15]]], "lead"]}], 
         RowBox[{
          SuperscriptBox["u", "2"], " ", 
          SuperscriptBox[
           RowBox[{"(", 
            RowBox[{"1", "+", 
             SuperscriptBox["u", "2"]}], ")"}], "3"]}]]}], "]"}]}], "+", 
     RowBox[{
      SuperscriptBox["z", "4"], " ", 
      RowBox[{"\[DoubleStruckCapitalC]", "[", 
       FractionBox[
        RowBox[{"96", " ", "\[ImaginaryI]", " ", 
         RowBox[{"(", 
          RowBox[{"6", "+", 
           RowBox[{"62", " ", 
            SuperscriptBox["u", "2"]}], "+", 
           RowBox[{"347", " ", 
            SuperscriptBox["u", "4"]}], "+", 
           RowBox[{"929", " ", 
            SuperscriptBox["u", "6"]}], "+", 
           RowBox[{"979", " ", 
            SuperscriptBox["u", "8"]}], "+", 
           RowBox[{"509", " ", 
            SuperscriptBox["u", "10"]}], "+", 
           RowBox[{"104", " ", 
            SuperscriptBox["u", "12"]}]}], ")"}], " ", 
         SubscriptBox[
          OverscriptBox[
           StyleBox["W",
            FontColor->RGBColor[0.54, 0.35, 0.15]], 
           StyleBox["^",
            FontColor->RGBColor[0.54, 0.35, 0.15]]], "lead"]}], 
        RowBox[{
         SuperscriptBox["u", "4"], " ", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"1", "+", 
            SuperscriptBox["u", "2"]}], ")"}], "5"]}]], "]"}]}], "+", 
     RowBox[{
      SuperscriptBox["z", "6"], " ", 
      RowBox[{"\[DoubleStruckCapitalC]", "[", 
       RowBox[{"-", 
        FractionBox[
         RowBox[{"384", " ", "\[ImaginaryI]", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"-", "1"}], "-", 
            RowBox[{"3", " ", 
             SuperscriptBox["u", "2"]}], "+", 
            RowBox[{"3", " ", 
             SuperscriptBox["u", "4"]}], "+", 
            RowBox[{"25", " ", 
             SuperscriptBox["u", "6"]}], "+", 
            RowBox[{"135", " ", 
             SuperscriptBox["u", "8"]}], "+", 
            RowBox[{"172", " ", 
             SuperscriptBox["u", "10"]}], "+", 
            RowBox[{"134", " ", 
             SuperscriptBox["u", "12"]}], "+", 
            RowBox[{"54", " ", 
             SuperscriptBox["u", "14"]}], "+", 
            RowBox[{"9", " ", 
             SuperscriptBox["u", "16"]}]}], ")"}], " ", 
          SubscriptBox[
           OverscriptBox[
            StyleBox["W",
             FontColor->RGBColor[0.54, 0.35, 0.15]], 
            StyleBox["^",
             FontColor->RGBColor[0.54, 0.35, 0.15]]], "lead"]}], 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"u", "+", 
            SuperscriptBox["u", "3"]}], ")"}], "6"]]}], "]"}]}], "+", 
     RowBox[{"\[DoubleStruckCapitalC]", "[", 
      FractionBox[
       RowBox[{"132", " ", "\[ImaginaryI]", " ", 
        SubscriptBox[
         OverscriptBox[
          StyleBox["W",
           FontColor->RGBColor[0.54, 0.35, 0.15]], 
          StyleBox["^",
           FontColor->RGBColor[0.54, 0.35, 0.15]]], "sublead"]}], 
       RowBox[{"1", "+", 
        SuperscriptBox["u", "2"]}]], "]"}], "+", 
     RowBox[{
      SuperscriptBox["z", "2"], " ", 
      RowBox[{"\[DoubleStruckCapitalC]", "[", 
       RowBox[{"-", 
        FractionBox[
         RowBox[{"24", " ", "\[ImaginaryI]", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"-", "6"}], "-", 
            RowBox[{"27", " ", 
             SuperscriptBox["u", "2"]}], "-", 
            RowBox[{"4", " ", 
             SuperscriptBox["u", "4"]}], "+", 
            SuperscriptBox["u", "6"]}], ")"}], " ", 
          SubscriptBox[
           OverscriptBox[
            StyleBox["W",
             FontColor->RGBColor[0.54, 0.35, 0.15]], 
            StyleBox["^",
             FontColor->RGBColor[0.54, 0.35, 0.15]]], "sublead"]}], 
         RowBox[{
          SuperscriptBox["u", "2"], " ", 
          SuperscriptBox[
           RowBox[{"(", 
            RowBox[{"1", "+", 
             SuperscriptBox["u", "2"]}], ")"}], "3"]}]]}], "]"}]}], "+", 
     RowBox[{
      SuperscriptBox["z", "4"], " ", 
      RowBox[{"\[DoubleStruckCapitalC]", "[", 
       RowBox[{"-", 
        FractionBox[
         RowBox[{"96", " ", "\[ImaginaryI]", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"-", "1"}], "-", 
            SuperscriptBox["u", "2"], "+", 
            RowBox[{"15", " ", 
             SuperscriptBox["u", "4"]}], "+", 
            RowBox[{"16", " ", 
             SuperscriptBox["u", "6"]}], "+", 
            RowBox[{"12", " ", 
             SuperscriptBox["u", "8"]}], "+", 
            RowBox[{"3", " ", 
             SuperscriptBox["u", "10"]}]}], ")"}], " ", 
          SubscriptBox[
           OverscriptBox[
            StyleBox["W",
             FontColor->RGBColor[0.54, 0.35, 0.15]], 
            StyleBox["^",
             FontColor->RGBColor[0.54, 0.35, 0.15]]], "sublead"]}], 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"u", "+", 
            SuperscriptBox["u", "3"]}], ")"}], "4"]]}], "]"}]}], "+", 
     RowBox[{"\[DoubleStruckCapitalC]", "[", 
      RowBox[{"-", 
       FractionBox[
        RowBox[{"24", " ", "\[ImaginaryI]", " ", 
         SubscriptBox[
          OverscriptBox[
           StyleBox["W",
            FontColor->RGBColor[0.54, 0.35, 0.15]], 
           StyleBox["^",
            FontColor->RGBColor[0.54, 0.35, 0.15]]], "sublead2"]}], 
        RowBox[{"1", "+", 
         SuperscriptBox["u", "2"]}]]}], "]"}], "+", 
     RowBox[{
      SuperscriptBox["z", "2"], " ", 
      RowBox[{"\[DoubleStruckCapitalC]", "[", 
       FractionBox[
        RowBox[{"24", " ", "\[ImaginaryI]", " ", 
         RowBox[{"(", 
          RowBox[{"1", "+", 
           RowBox[{"5", " ", 
            SuperscriptBox["u", "2"]}], "+", 
           RowBox[{"2", " ", 
            SuperscriptBox["u", "4"]}]}], ")"}], " ", 
         SubscriptBox[
          OverscriptBox[
           StyleBox["W",
            FontColor->RGBColor[0.54, 0.35, 0.15]], 
           StyleBox["^",
            FontColor->RGBColor[0.54, 0.35, 0.15]]], "sublead2"]}], 
        SuperscriptBox[
         RowBox[{"(", 
          RowBox[{"u", "+", 
           SuperscriptBox["u", "3"]}], ")"}], "2"]], "]"}]}]}], 
    ")"}]}]}]], "Output",
 CellChangeTimes->{
  3.555825838030005*^9, 3.5558259597021303`*^9, 3.555826152246524*^9, 
   3.555826309143602*^9, 3.5558263506314096`*^9, 3.5558264256696167`*^9, {
   3.5558265117136383`*^9, 3.5558265164289427`*^9}, 3.555826858674934*^9, {
   3.555826896893277*^9, 3.555826913561716*^9}, 3.5558270920569973`*^9, 
   3.55582714235541*^9, 3.55582720670391*^9, 3.555827250080751*^9, 
   3.555827281077129*^9, {3.555828591951417*^9, 3.555828602904426*^9}, 
   3.5558291220024652`*^9, 3.555854858116342*^9, 3.564855885516576*^9}]
}, Open  ]],

Cell["Contribution from Wh", "Item",
 CellChangeTimes->{{3.553726696286642*^9, 3.553726699301937*^9}}],

Cell[TextData[{
 "I will compute ",
 Cell[BoxData[
  FormBox[
   SuperscriptBox[
    OverscriptBox["W", "^"], 
    RowBox[{"[", 
     RowBox[{"+", "o"}], "]"}]], TraditionalForm]],
  FormatType->"TraditionalForm"],
 ", ",
 Cell[BoxData[
  FormBox[
   SuperscriptBox[
    OverscriptBox["W", "^"], 
    RowBox[{"[", 
     RowBox[{"-", "o"}], "]"}]], TraditionalForm]],
  FormatType->"TraditionalForm"],
 " is a complex conjugate:"
}], "Text",
 CellChangeTimes->{{3.555827912087694*^9, 3.555827926807559*^9}, {
  3.555828232255294*^9, 3.5558282463958397`*^9}}],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      FractionBox[
       RowBox[{
        RowBox[{
         SubscriptBox[
          StyleBox["q",
           FontColor->RGBColor[0, 0, 0.8]], "2"], " ", 
         SubsuperscriptBox[
          StyleBox["q",
           FontColor->RGBColor[0, 0, 0.8]], 
          RowBox[{"1", ",", "3"}], "+"]}], "-", 
        SubsuperscriptBox[
         StyleBox["q",
          FontColor->RGBColor[0, 0, 0.8]], 
         RowBox[{"1", ",", "4"}], "+"]}], 
       SuperscriptBox[
        StyleBox["Q",
         FontColor->RGBColor[{
            Rational[1, 2], 
            Rational[1, 2], 0}]], "+"]], ",", 
      FractionBox[
       RowBox[{
        RowBox[{
         SubscriptBox[
          StyleBox["q",
           FontColor->RGBColor[0, 0, 0.8]], "2"], " ", 
         SubsuperscriptBox[
          StyleBox["q",
           FontColor->RGBColor[0, 0, 0.8]], 
          RowBox[{"1", ",", "4"}], "+"]}], "-", 
        SubsuperscriptBox[
         StyleBox["q",
          FontColor->RGBColor[0, 0, 0.8]], 
         RowBox[{"2", ",", "4"}], "+"]}], 
       SuperscriptBox[
        StyleBox["Q",
         FontColor->RGBColor[{
            Rational[1, 2], 
            Rational[1, 2], 0}]], "+"]]}], "}"}], "/.", 
    RowBox[{
     SubscriptBox["q", "2"], "\[Rule]", 
     RowBox[{"(", 
      RowBox[{
       SubscriptBox["q", "2"], "/.", "largevolume"}], ")"}]}]}], "/.", 
   RowBox[{"x", "\[Rule]", "xh"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"tmp", "=", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{"Collect", "[", 
     RowBox[{
      RowBox[{"%", ".", 
       RowBox[{"Reverse", "[", 
        RowBox[{"%", "/.", "mconj"}], "]"}]}], ",", 
      RowBox[{"x$h", "[", "0", "]"}], ",", "Simplify"}], "]"}], ")"}], "/.", 
   RowBox[{"xh", "\[Rule]", "x"}]}]}]}], "Input",
 CellChangeTimes->{{3.5537176604989758`*^9, 3.553717744590509*^9}, {
  3.553726829041334*^9, 3.553726835494506*^9}, {3.553727655779147*^9, 
  3.553727658420474*^9}, {3.553727748775133*^9, 3.5537277488646383`*^9}, {
  3.553727838978693*^9, 3.553727853971786*^9}, {3.5558277733858023`*^9, 
  3.555827775416168*^9}, {3.555827876358048*^9, 3.5558278783166733`*^9}}],

Cell[BoxData[
 RowBox[{
  FractionBox[
   RowBox[{"16", " ", 
    SuperscriptBox["g", "2"], " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       SubsuperscriptBox[
        StyleBox["q",
         FontColor->RGBColor[0, 0, 0.8]], 
        RowBox[{"1", ",", "4"}], "+"], " ", 
       SubsuperscriptBox[
        OverscriptBox[
         StyleBox["q",
          FontColor->RGBColor[0, 0, 0.8]], 
         StyleBox["_",
          FontColor->RGBColor[0, 0, 0.8]]], 
        RowBox[{"1", ",", "3"}], "-"]}], "+", 
      RowBox[{
       SubsuperscriptBox[
        StyleBox["q",
         FontColor->RGBColor[0, 0, 0.8]], 
        RowBox[{"1", ",", "3"}], "+"], " ", 
       SubsuperscriptBox[
        OverscriptBox[
         StyleBox["q",
          FontColor->RGBColor[0, 0, 0.8]], 
         StyleBox["_",
          FontColor->RGBColor[0, 0, 0.8]]], 
        RowBox[{"1", ",", "4"}], "-"]}]}], ")"}]}], 
   RowBox[{
    SuperscriptBox[
     StyleBox["Q",
      FontColor->RGBColor[0.8, 0, 0]], "-"], " ", 
    SuperscriptBox[
     StyleBox["Q",
      FontColor->RGBColor[0.8, 0, 0]], "+"], " ", 
    SubsuperscriptBox["\[Gamma]", "0", "2"], " ", 
    SuperscriptBox[
     StyleBox["x",
      FontColor->RGBColor[0, 0.6, 0]], "2"]}]], "+", 
  FractionBox[
   RowBox[{
    RowBox[{
     SubsuperscriptBox[
      StyleBox["q",
       FontColor->RGBColor[0, 0, 0.8]], 
      RowBox[{"2", ",", "4"}], "+"], " ", 
     SubsuperscriptBox[
      OverscriptBox[
       StyleBox["q",
        FontColor->RGBColor[0, 0, 0.8]], 
       StyleBox["_",
        FontColor->RGBColor[0, 0, 0.8]]], 
      RowBox[{"1", ",", "4"}], "-"]}], "+", 
    RowBox[{
     SuperscriptBox["u", "2"], " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{
        SubsuperscriptBox[
         StyleBox["q",
          FontColor->RGBColor[0, 0, 0.8]], 
         RowBox[{"1", ",", "4"}], "+"], " ", 
        SubsuperscriptBox[
         OverscriptBox[
          StyleBox["q",
           FontColor->RGBColor[0, 0, 0.8]], 
          StyleBox["_",
           FontColor->RGBColor[0, 0, 0.8]]], 
         RowBox[{"1", ",", "3"}], "-"]}], "+", 
       RowBox[{
        SubsuperscriptBox[
         StyleBox["q",
          FontColor->RGBColor[0, 0, 0.8]], 
         RowBox[{"1", ",", "3"}], "+"], " ", 
        SubsuperscriptBox[
         OverscriptBox[
          StyleBox["q",
           FontColor->RGBColor[0, 0, 0.8]], 
          StyleBox["_",
           FontColor->RGBColor[0, 0, 0.8]]], 
         RowBox[{"1", ",", "4"}], "-"]}]}], ")"}]}], "+", 
    RowBox[{
     SubsuperscriptBox[
      StyleBox["q",
       FontColor->RGBColor[0, 0, 0.8]], 
      RowBox[{"1", ",", "4"}], "+"], " ", 
     SubsuperscriptBox[
      OverscriptBox[
       StyleBox["q",
        FontColor->RGBColor[0, 0, 0.8]], 
       StyleBox["_",
        FontColor->RGBColor[0, 0, 0.8]]], 
      RowBox[{"2", ",", "4"}], "-"]}], "-", 
    RowBox[{"\[ImaginaryI]", " ", "u", " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{
        SubsuperscriptBox[
         StyleBox["q",
          FontColor->RGBColor[0, 0, 0.8]], 
         RowBox[{"2", ",", "4"}], "+"], " ", 
        SubsuperscriptBox[
         OverscriptBox[
          StyleBox["q",
           FontColor->RGBColor[0, 0, 0.8]], 
          StyleBox["_",
           FontColor->RGBColor[0, 0, 0.8]]], 
         RowBox[{"1", ",", "3"}], "-"]}], "-", 
       RowBox[{
        SubsuperscriptBox[
         StyleBox["q",
          FontColor->RGBColor[0, 0, 0.8]], 
         RowBox[{"1", ",", "3"}], "+"], " ", 
        SubsuperscriptBox[
         OverscriptBox[
          StyleBox["q",
           FontColor->RGBColor[0, 0, 0.8]], 
          StyleBox["_",
           FontColor->RGBColor[0, 0, 0.8]]], 
         RowBox[{"2", ",", "4"}], "-"]}]}], ")"}]}]}], 
   RowBox[{
    SuperscriptBox[
     StyleBox["Q",
      FontColor->RGBColor[0.8, 0, 0]], "-"], " ", 
    SuperscriptBox[
     StyleBox["Q",
      FontColor->RGBColor[0.8, 0, 0]], "+"]}]], "+", 
  FractionBox[
   RowBox[{"4", " ", "g", " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"2", " ", "u", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          SubsuperscriptBox[
           StyleBox["q",
            FontColor->RGBColor[0, 0, 0.8]], 
           RowBox[{"1", ",", "4"}], "+"], " ", 
          SubsuperscriptBox[
           OverscriptBox[
            StyleBox["q",
             FontColor->RGBColor[0, 0, 0.8]], 
            StyleBox["_",
             FontColor->RGBColor[0, 0, 0.8]]], 
           RowBox[{"1", ",", "3"}], "-"]}], "+", 
         RowBox[{
          SubsuperscriptBox[
           StyleBox["q",
            FontColor->RGBColor[0, 0, 0.8]], 
           RowBox[{"1", ",", "3"}], "+"], " ", 
          SubsuperscriptBox[
           OverscriptBox[
            StyleBox["q",
             FontColor->RGBColor[0, 0, 0.8]], 
            StyleBox["_",
             FontColor->RGBColor[0, 0, 0.8]]], 
           RowBox[{"1", ",", "4"}], "-"]}]}], ")"}]}], "+", 
      RowBox[{"\[ImaginaryI]", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          RowBox[{"-", 
           SubsuperscriptBox[
            StyleBox["q",
             FontColor->RGBColor[0, 0, 0.8]], 
            RowBox[{"2", ",", "4"}], "+"]}], " ", 
          SubsuperscriptBox[
           OverscriptBox[
            StyleBox["q",
             FontColor->RGBColor[0, 0, 0.8]], 
            StyleBox["_",
             FontColor->RGBColor[0, 0, 0.8]]], 
           RowBox[{"1", ",", "3"}], "-"]}], "+", 
         RowBox[{
          SubsuperscriptBox[
           StyleBox["q",
            FontColor->RGBColor[0, 0, 0.8]], 
           RowBox[{"1", ",", "3"}], "+"], " ", 
          SubsuperscriptBox[
           OverscriptBox[
            StyleBox["q",
             FontColor->RGBColor[0, 0, 0.8]], 
            StyleBox["_",
             FontColor->RGBColor[0, 0, 0.8]]], 
           RowBox[{"2", ",", "4"}], "-"]}]}], ")"}]}]}], ")"}]}], 
   RowBox[{
    SuperscriptBox[
     StyleBox["Q",
      FontColor->RGBColor[0.8, 0, 0]], "-"], " ", 
    SuperscriptBox[
     StyleBox["Q",
      FontColor->RGBColor[0.8, 0, 0]], "+"], " ", 
    SubscriptBox["\[Gamma]", "0"], " ", 
    StyleBox["x",
     FontColor->RGBColor[0, 0.6, 0]]}]]}]], "Output",
 CellChangeTimes->{3.5558277793961773`*^9, 3.555827882784383*^9, 
  3.555827928038422*^9, 3.555829148754624*^9, 3.555829327183412*^9, 
  3.555854865433683*^9, 3.564855885793663*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"tmpn", "=", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"Series", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"Collect", "[", 
            RowBox[{
             RowBox[{"tmp", "/.", 
              RowBox[{"u", "\[Rule]", 
               RowBox[{"2", "g", " ", "z"}]}]}], ",", "x", ",", "Simplify"}], 
            "]"}], "//.", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"xxx", ":", 
              RowBox[{"(", 
               RowBox[{"Alternatives", "@@", 
                RowBox[{"{", 
                 RowBox[{
                  RowBox[{"Q0", "[", 
                   RowBox[{"_", ":", "0"}], "]"}], ",", 
                  RowBox[{"Q", "[", 
                   RowBox[{"_", ":", "0"}], "]"}], ",", 
                  SubscriptBox["\[Gamma]", "0"], ",", 
                  RowBox[{"x$", "[", "_", "]"}]}], "}"}]}], ")"}]}], 
             "\[RuleDelayed]", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{
                RowBox[{
                 RowBox[{"xxx", "/.", "subQ0"}], "/.", "subJuk"}], "/.", 
                RowBox[{"leadweak", "[", "5", "]"}]}], "/.", 
               RowBox[{"u", "\[Rule]", 
                RowBox[{"2", "g", " ", "z"}]}]}], ")"}]}], ")"}]}], ",", 
          RowBox[{"{", 
           RowBox[{"g", ",", "0", ",", "7"}], "}"}]}], "]"}], "//", 
        "Simplify"}], ")"}], "/.", 
      RowBox[{
       RowBox[{"b_.", 
        SuperscriptBox[
         RowBox[{"(", 
          RowBox[{
           RowBox[{
            RowBox[{"-", "\[ImaginaryI]"}], " ", "z"}], "+", 
           SqrtBox[
            RowBox[{"1", "-", 
             SuperscriptBox["z", "2"]}]]}], ")"}], 
         RowBox[{"a_", "/;", 
          RowBox[{"a", "<", "0"}]}]]}], "\[RuleDelayed]", 
       RowBox[{"b", " ", 
        SuperscriptBox[
         RowBox[{"(", 
          FractionBox["1", 
           RowBox[{
            RowBox[{"\[ImaginaryI]", " ", "z"}], "+", 
            SqrtBox[
             RowBox[{"1", "-", 
              SuperscriptBox["z", "2"]}]]}]], ")"}], "a"]}]}]}], "/.", 
     RowBox[{
      RowBox[{"b_.", 
       SuperscriptBox[
        RowBox[{"(", 
         RowBox[{
          RowBox[{"\[ImaginaryI]", " ", "z"}], "+", 
          SqrtBox[
           RowBox[{"1", "-", 
            SuperscriptBox["z", "2"]}]]}], ")"}], 
        RowBox[{"a_", "/;", 
         RowBox[{"a", "<", "0"}]}]]}], "\[RuleDelayed]", " ", 
      RowBox[{"b", 
       SuperscriptBox[
        RowBox[{"(", 
         FractionBox["1", 
          RowBox[{
           RowBox[{
            RowBox[{"-", "\[ImaginaryI]"}], " ", "z"}], "+", 
           SqrtBox[
            RowBox[{"1", "-", 
             SuperscriptBox["z", "2"]}]]}]], ")"}], "a"]}]}]}], "/.", 
    RowBox[{
     RowBox[{"b_.", 
      SuperscriptBox[
       RowBox[{"(", 
        RowBox[{"z", "+", 
         RowBox[{"\[ImaginaryI]", " ", 
          SqrtBox[
           RowBox[{"1", "-", 
            SuperscriptBox["z", "2"]}]]}]}], ")"}], 
       RowBox[{"a_", "/;", 
        RowBox[{"a", "<", "0"}]}]]}], "\[RuleDelayed]", " ", 
     RowBox[{"b", 
      SuperscriptBox[
       RowBox[{"(", 
        FractionBox["1", 
         RowBox[{"z", "-", 
          RowBox[{"\[ImaginaryI]", 
           SqrtBox[
            RowBox[{"1", "-", 
             SuperscriptBox["z", "2"]}]]}]}]], ")"}], "a"]}]}]}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"tmpn", "=", 
   RowBox[{
    RowBox[{
     RowBox[{"Collect", "[", 
      RowBox[{
       RowBox[{"#", "//", "Expand"}], ",", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{
           RowBox[{
            RowBox[{"q$", "[", 
             RowBox[{"_", ",", "_"}], "]"}], "[", "_", "]"}], 
           RowBox[{
            RowBox[{"q$b", "[", 
             RowBox[{"_", ",", "_"}], "]"}], "[", "_", "]"}]}], ",", 
          SqrtBox[
           RowBox[{"1", "-", 
            SuperscriptBox["z", "2"]}]], ",", "z", ",", "\[Zeta]list"}], 
         "}"}], "//", "Flatten"}], ",", "Simplify"}], "]"}], "&"}], "/@", 
    "%"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"FreeQ", "[", 
  RowBox[{"%", ",", 
   SubscriptBox["\[Zeta]", "5"]}], "]"}]}], "Input",
 CellChangeTimes->{
  3.5557984910314007`*^9, {3.555820514176888*^9, 3.555820553549423*^9}, {
   3.555820589037825*^9, 3.5558206962533407`*^9}, {3.555820727362359*^9, 
   3.555820748151065*^9}, {3.555820798555138*^9, 3.555820899603109*^9}, 
   3.555827810441613*^9, {3.5558278456075363`*^9, 3.555827846872373*^9}, 
   3.555827965611432*^9, {3.55585487196592*^9, 3.555854872455062*^9}}],

Cell[BoxData["False"], "Output",
 CellChangeTimes->{
  3.555798526017378*^9, 3.555798624210374*^9, 3.555820525345909*^9, 
   3.555820557627701*^9, 3.555820589823442*^9, {3.555820626270465*^9, 
   3.5558206969485397`*^9}, 3.555820783916935*^9, {3.555820836558887*^9, 
   3.555820900521743*^9}, 3.555827811418427*^9, 3.555827848531954*^9, 
   3.5558279328189163`*^9, 3.555827968306572*^9, 3.555829151037243*^9, 
   3.55582933004672*^9, 3.555854875689288*^9, 3.564855889280781*^9}]
}, Open  ]],

Cell[BoxData[{
 RowBox[{
  RowBox[{"List", "@@", 
   RowBox[{"Collect", "[", 
    RowBox[{
     RowBox[{"Normal", "[", "tmpn", "]"}], ",", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{
         RowBox[{
          RowBox[{"q$", "[", 
           RowBox[{"_", ",", "_"}], "]"}], "[", "_", "]"}], 
         RowBox[{
          RowBox[{"q$b", "[", 
           RowBox[{"_", ",", "_"}], "]"}], "[", "_", "]"}]}], ",", "g", ",", 
        SqrtBox[
         RowBox[{"1", "-", 
          SuperscriptBox["z", "2"]}]], ",", "z", ",", "\[Zeta]list"}], "}"}], 
      "//", "Flatten"}]}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"tmp3", "=", 
   RowBox[{"Collect", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"Total", "[", 
       RowBox[{"Normal", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"Series", "[", 
           RowBox[{
            RowBox[{
             RowBox[{
              RowBox[{
               RowBox[{"#", "/.", 
                RowBox[{"leadweak", "[", "4", "]"}]}], "/.", "subQ0"}], "//.", 
              RowBox[{"shiftp\[Eta]b", "[", 
               RowBox[{"-", "4"}], "]"}]}], "/.", 
             RowBox[{"u", "\[Rule]", 
              RowBox[{"2", "g", " ", "z"}]}]}], ",", 
            RowBox[{"{", 
             RowBox[{"g", ",", "0", ",", "13"}], "}"}]}], "]"}], "&"}], "/@", 
         "%"}], "]"}], "]"}], "//", "Expand"}], ",", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"\[Eta]list", ",", "g", ",", 
        SqrtBox[
         RowBox[{"1", "-", 
          SuperscriptBox["z", "2"]}]], ",", "z", ",", "\[Zeta]list"}], "}"}], 
      "//", "Flatten"}]}], "]"}]}], ";"}]}], "Input",
 CellChangeTimes->{{3.555821561058899*^9, 3.555821730937216*^9}, {
   3.555821762016913*^9, 3.555821766749757*^9}, {3.555821955226857*^9, 
   3.555821959689242*^9}, 3.555827995777967*^9, {3.5558280311667347`*^9, 
   3.5558280433959837`*^9}, 3.55582936462339*^9, {3.555854890021947*^9, 
   3.555854919132168*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"tmpWp", "=", 
   RowBox[{"Collect", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"(", 
       RowBox[{"tmp3", "/.", 
        RowBox[{"TaylorOptions", "[", 
         RowBox[{
          RowBox[{"Variable", "\[Rule]", "g"}], ",", 
          RowBox[{"\[Eta]Factor", "\[Rule]", 
           RowBox[{"2", "z"}]}], ",", 
          RowBox[{"Order", "\[Rule]", "13"}], ",", 
          RowBox[{"Series", "\[Rule]", "False"}]}], "]"}]}], ")"}], "//.", 
      "subZetaReduce"}], ",", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"g", ",", 
        SqrtBox[
         RowBox[{"1", "-", 
          SuperscriptBox["z", "2"]}]], ",", "z", ",", "\[Zeta]list"}], "}"}], 
      "//", "Flatten"}]}], "]"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.5558218207860317`*^9, 3.555821892822016*^9}, {
  3.555828006682323*^9, 3.555828050920504*^9}, {3.555828147998576*^9, 
  3.555828148511265*^9}, {3.555829373901649*^9, 3.555829394376055*^9}, {
  3.555854895982409*^9, 3.555854922813065*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Collect", "[", 
  RowBox[{"tmpWp", ",", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"g", ",", 
      SqrtBox[
       RowBox[{"1", "-", 
        SuperscriptBox["z", "2"]}]], ",", "z"}], "}"}], "//", "Flatten"}], 
   ",", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       RowBox[{"#", "/.", "subZetas"}], "/.", "Nnnreducibles"}], "//", "N"}], 
     ")"}], "&"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.555821900047181*^9, 3.5558219009531717`*^9}, {
  3.555822016861388*^9, 3.5558220787831507`*^9}, {3.555828135264492*^9, 
  3.5558281542602463`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   SuperscriptBox["g", "6"], " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"-", "1.0363705131464371`"}], "+", 
     RowBox[{"2.0727410262928743`", " ", 
      SuperscriptBox["z", "2"]}], "-", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"0.`", "\[VeryThinSpace]", "+", 
        RowBox[{"2.0727410262928743`", " ", "\[ImaginaryI]"}]}], ")"}], " ", 
      "z", " ", 
      SqrtBox[
       RowBox[{"1", "-", 
        SuperscriptBox["z", "2"]}]]}]}], ")"}]}], "+", 
  RowBox[{
   SuperscriptBox["g", "8"], " ", 
   RowBox[{"(", 
    RowBox[{"5.502864517141575`", "\[VeryThinSpace]", "+", 
     RowBox[{"15.349057491655458`", " ", 
      SuperscriptBox["z", "2"]}], "-", 
     RowBox[{"45.54621644366807`", " ", 
      SuperscriptBox["z", "4"]}], "+", 
     RowBox[{
      SqrtBox[
       RowBox[{"1", "-", 
        SuperscriptBox["z", "2"]}]], " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         RowBox[{"(", 
          RowBox[{"0.`", "\[VeryThinSpace]", "+", 
           RowBox[{"7.424050730178692`", " ", "\[ImaginaryI]"}]}], ")"}], " ",
          "z"}], "+", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{"0.`", "\[VeryThinSpace]", "+", 
           RowBox[{"45.54621644366807`", " ", "\[ImaginaryI]"}]}], ")"}], " ", 
         SuperscriptBox["z", "3"]}]}], ")"}]}]}], ")"}]}], "+", 
  RowBox[{
   SuperscriptBox["g", "10"], " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"-", "27.36356182472082`"}], "-", 
     RowBox[{"313.9476643279486`", " ", 
      SuperscriptBox["z", "2"]}], "+", 
     RowBox[{"371.8689902899241`", " ", 
      SuperscriptBox["z", "4"]}], "+", 
     RowBox[{"368.8543183697948`", " ", 
      SuperscriptBox["z", "6"]}], "+", 
     RowBox[{
      SqrtBox[
       RowBox[{"1", "-", 
        SuperscriptBox["z", "2"]}]], " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         RowBox[{"(", 
          RowBox[{"0.`", "\[VeryThinSpace]", "+", 
           RowBox[{"23.40661407295738`", " ", "\[ImaginaryI]"}]}], ")"}], " ",
          "z"}], "-", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{"0.`", "\[VeryThinSpace]", "+", 
           RowBox[{"556.296149474827`", " ", "\[ImaginaryI]"}]}], ")"}], " ", 
         
         SuperscriptBox["z", "3"]}], "-", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{"0.`", "\[VeryThinSpace]", "+", 
           RowBox[{"368.8543183697948`", " ", "\[ImaginaryI]"}]}], ")"}], " ", 
         SuperscriptBox["z", "5"]}]}], ")"}]}]}], ")"}]}], "+", 
  RowBox[{
   SuperscriptBox["g", "12"], " ", 
   RowBox[{"(", 
    RowBox[{"233.97109895710616`", "\[VeryThinSpace]", "+", 
     RowBox[{"2508.0198307091923`", " ", 
      SuperscriptBox["z", "2"]}], "+", 
     RowBox[{"3403.2372088569437`", " ", 
      SuperscriptBox["z", "4"]}], "-", 
     RowBox[{"13352.83220072707`", " ", 
      SuperscriptBox["z", "6"]}], "+", 
     RowBox[{"1617.903356310213`", " ", 
      SuperscriptBox["z", "8"]}], "+", 
     RowBox[{
      SqrtBox[
       RowBox[{"1", "-", 
        SuperscriptBox["z", "2"]}]], " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         RowBox[{"(", 
          RowBox[{"0.`", "\[VeryThinSpace]", "-", 
           RowBox[{"376.9105658413116`", " ", "\[ImaginaryI]"}]}], ")"}], " ",
          "z"}], "+", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{"0.`", "\[VeryThinSpace]", "+", 
           RowBox[{"2447.5887242657395`", " ", "\[ImaginaryI]"}]}], ")"}], 
         " ", 
         SuperscriptBox["z", "3"]}], "+", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{"0.`", "\[VeryThinSpace]", "+", 
           RowBox[{"12543.880522572039`", " ", "\[ImaginaryI]"}]}], ")"}], 
         " ", 
         SuperscriptBox["z", "5"]}], "-", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{"0.`", "\[VeryThinSpace]", "+", 
           RowBox[{"1617.903356310213`", " ", "\[ImaginaryI]"}]}], ")"}], " ", 
         SuperscriptBox["z", "7"]}]}], ")"}]}]}], ")"}]}]}]], "Output",
 CellChangeTimes->{
  3.555821902439095*^9, 3.555821979599986*^9, {3.5558220523198977`*^9, 
   3.555822079218824*^9}, {3.555828015898288*^9, 3.555828038588513*^9}, 
   3.555828082403591*^9, {3.5558281403917933`*^9, 3.555828166485169*^9}, 
   3.555829188975876*^9, 3.5558294907351437`*^9, 3.5558549594614067`*^9, 
   3.564855932151802*^9}]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"tmpWm", "=", 
   RowBox[{"tmpWp", "/.", "mconj"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.555828142714836*^9, 3.5558281717771606`*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"-", 
       RowBox[{"(", 
        RowBox[{
         FractionBox[
          RowBox[{"(", 
           RowBox[{
            SuperscriptBox["\[ScriptCapitalC]", 
             RowBox[{"[", 
              RowBox[{"+", "o"}], "]"}]], "-", 
            SuperscriptBox["\[ScriptCapitalC]", 
             RowBox[{"[", 
              RowBox[{"+", "2"}], "]"}]]}], ")"}], 
          RowBox[{"(", 
           RowBox[{
            SubscriptBox[
             StyleBox["\[GothicQ]",
              FontColor->RGBColor[0.54, 0.35, 0.15]], "2"], "-", 
            SubsuperscriptBox[
             StyleBox["\[GothicQ]",
              FontColor->RGBColor[0.54, 0.35, 0.15]], "2", 
             RowBox[{"[", "2", "]"}]]}], ")"}]], "+", 
         FractionBox[
          RowBox[{"-", 
           RowBox[{"(", 
            RowBox[{
             SuperscriptBox["\[ScriptCapitalC]", 
              RowBox[{"[", 
               RowBox[{"-", "o"}], "]"}]], "-", 
             SuperscriptBox["\[ScriptCapitalC]", 
              RowBox[{"[", 
               RowBox[{"-", "2"}], "]"}]]}], ")"}]}], 
          RowBox[{"(", 
           RowBox[{
            SubscriptBox[
             OverscriptBox[
              StyleBox["\[GothicQ]",
               FontColor->RGBColor[0.54, 0.35, 0.15]], 
              StyleBox["_",
               FontColor->RGBColor[0.54, 0.35, 0.15]]], "2"], "-", 
            SubsuperscriptBox[
             OverscriptBox[
              StyleBox["\[GothicQ]",
               FontColor->RGBColor[0.54, 0.35, 0.15]], 
              StyleBox["_",
               FontColor->RGBColor[0.54, 0.35, 0.15]]], "2", 
             RowBox[{"[", 
              RowBox[{"-", "2"}], "]"}]]}], ")"}]], "+", 
         FractionBox[
          RowBox[{"(", 
           RowBox[{
            SuperscriptBox["\[ScriptCapitalC]", 
             RowBox[{"[", 
              RowBox[{"+", "o"}], "]"}]], "-", 
            SuperscriptBox["\[ScriptCapitalC]", 
             RowBox[{"[", 
              RowBox[{"-", "2"}], "]"}]]}], ")"}], 
          RowBox[{"(", 
           RowBox[{
            SubscriptBox[
             StyleBox["\[GothicQ]",
              FontColor->RGBColor[0.54, 0.35, 0.15]], "2"], "+", 
            SubsuperscriptBox[
             OverscriptBox[
              StyleBox["\[GothicQ]",
               FontColor->RGBColor[0.54, 0.35, 0.15]], "_"], "2", 
             RowBox[{"[", 
              RowBox[{"-", "2"}], "]"}]]}], ")"}]], "+", 
         FractionBox[
          RowBox[{"(", 
           RowBox[{
            RowBox[{"-", 
             SuperscriptBox["\[ScriptCapitalC]", 
              RowBox[{"[", 
               RowBox[{"-", "o"}], "]"}]]}], "+", 
            SuperscriptBox["\[ScriptCapitalC]", 
             RowBox[{"[", 
              RowBox[{"+", "2"}], "]"}]]}], ")"}], 
          RowBox[{"(", 
           RowBox[{
            SubscriptBox[
             OverscriptBox[
              StyleBox["\[GothicQ]",
               FontColor->RGBColor[0.54, 0.35, 0.15]], "_"], "2"], "+", 
            SubsuperscriptBox[
             StyleBox["\[GothicQ]",
              FontColor->RGBColor[0.54, 0.35, 0.15]], "2", 
             RowBox[{"[", 
              RowBox[{"+", "2"}], "]"}]]}], ")"}]]}], ")"}]}], "/.", 
      RowBox[{
       SuperscriptBox["\[ScriptCapitalC]", 
        RowBox[{"[", 
         RowBox[{"+", "2"}], "]"}]], "\[Rule]", "0"}]}], "/.", 
     RowBox[{
      SuperscriptBox["\[ScriptCapitalC]", 
       RowBox[{"[", 
        RowBox[{"-", "2"}], "]"}]], "\[Rule]", "0"}]}], "/.", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"q$u", "\[Rule]", "q$"}], ",", 
      RowBox[{"q$ub", "\[Rule]", "q$b"}]}], "}"}]}], "/.", "largevolume"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"tmp", "=", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"Series", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"%", "/.", 
          RowBox[{"u", "\[Rule]", 
           RowBox[{"2", "g", " ", "z"}]}]}], "//.", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"xxx", ":", 
            RowBox[{"(", 
             RowBox[{"Alternatives", "@@", 
              RowBox[{"{", 
               RowBox[{
                RowBox[{"Q0", "[", 
                 RowBox[{"_", ":", "0"}], "]"}], ",", 
                RowBox[{"Q", "[", 
                 RowBox[{"_", ":", "0"}], "]"}], ",", 
                SubscriptBox["\[Gamma]", "0"], ",", 
                RowBox[{"x", "[", 
                 RowBox[{"_", ":", "0"}], "]"}]}], "}"}]}], ")"}]}], 
           "\[RuleDelayed]", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{
              RowBox[{
               RowBox[{"xxx", "/.", "subQ0"}], "/.", "subJuk"}], "/.", 
              RowBox[{"leadweak", "[", "4", "]"}]}], "/.", 
             RowBox[{"u", "\[Rule]", 
              RowBox[{"2", "g", " ", "z"}]}]}], ")"}]}], ")"}]}], ",", 
        RowBox[{"{", 
         RowBox[{"g", ",", "0", ",", "8"}], "}"}]}], "]"}], "/.", 
      RowBox[{
       SuperscriptBox[
        RowBox[{"(", 
         RowBox[{
          RowBox[{
           RowBox[{"-", "\[ImaginaryI]"}], " ", "z"}], "+", 
          SqrtBox[
           RowBox[{"1", "-", 
            SuperscriptBox["z", "2"]}]]}], ")"}], 
        RowBox[{"a_", "/;", 
         RowBox[{"a", "<", "0"}]}]], "\[RuleDelayed]", 
       SuperscriptBox[
        RowBox[{"(", 
         FractionBox["1", 
          RowBox[{
           RowBox[{"\[ImaginaryI]", " ", "z"}], "+", 
           SqrtBox[
            RowBox[{"1", "-", 
             SuperscriptBox["z", "2"]}]]}]], ")"}], "a"]}]}], "//", 
     "Simplify"}], "//", "Normal"}]}], ";"}]}], "Input",
 CellChangeTimes->{{3.555828314448575*^9, 3.555828327609612*^9}, {
  3.555829172245613*^9, 3.5558291744609337`*^9}, {3.555829539744618*^9, 
  3.55582955729702*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"productq2Wmp0", "=", 
  RowBox[{"Collect", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"Normal", "@", 
      RowBox[{"Series", "[", 
       RowBox[{
        RowBox[{"tmp", "/.", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{
            SuperscriptBox[
             StyleBox["\[ScriptCapitalC]",
              FontColor->RGBColor[0, 0, 0.8]], 
             RowBox[{"[", "o", "]"}]], "\[Rule]", 
            FractionBox["tmpWp", "2"]}], ",", 
           RowBox[{
            SuperscriptBox[
             StyleBox["\[ScriptCapitalC]",
              FontColor->RGBColor[0, 0, 0.8]], 
             RowBox[{"[", 
              RowBox[{"-", "o"}], "]"}]], "\[Rule]", 
            RowBox[{"-", 
             FractionBox["tmpWm", "2"]}]}]}], "}"}]}], ",", 
        RowBox[{"{", 
         RowBox[{"g", ",", "0", ",", "13"}], "}"}]}], "]"}]}], "//", 
     "Expand"}], ",", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"g", ",", 
       SqrtBox[
        RowBox[{"1", "-", 
         SuperscriptBox["z", "2"]}]], ",", "z", ",", "\[Zeta]list"}], "}"}], "//",
      "Flatten"}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.555828329479436*^9, 3.5558284028782597`*^9}, {
   3.5558284517495337`*^9, 3.555828454716977*^9}, 3.555828639766397*^9, {
   3.555829184767495*^9, 3.555829185622944*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   SuperscriptBox["g", "7"], " ", 
   SqrtBox[
    RowBox[{"1", "-", 
     SuperscriptBox["z", "2"]}]], " ", 
   RowBox[{"(", 
    RowBox[{"324", "-", 
     RowBox[{"216", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2"]}], "-", 
     RowBox[{"216", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3"]}], "+", 
     RowBox[{"144", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3"]}]}], ")"}]}], "+", 
  RowBox[{
   SuperscriptBox["g", "9"], " ", 
   SqrtBox[
    RowBox[{"1", "-", 
     SuperscriptBox["z", "2"]}]], " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"-", "5832"}], "+", 
     RowBox[{"432", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2"]}], "+", 
     FractionBox[
      RowBox[{"5184", " ", 
       SubsuperscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "2", "2"]}], "5"], "-", 
     FractionBox[
      RowBox[{"2592", " ", 
       SubsuperscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "2", "3"]}], "5"], "+", 
     RowBox[{"5616", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3"]}], "+", 
     RowBox[{"1152", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3"]}], "-", 
     RowBox[{
      FractionBox["864", "5"], " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2", "2"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3"]}], "-", 
     RowBox[{"2592", " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3", "2"]}], "+", 
     RowBox[{"648", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "5"]}], "-", 
     RowBox[{"432", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "5"]}], "+", 
     RowBox[{
      SuperscriptBox["z", "2"], " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "3888"}], "+", 
        RowBox[{"5184", " ", 
         SubscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "2"]}], "-", 
        RowBox[{"5184", " ", 
         SubscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "3"]}], "+", 
        RowBox[{
         FractionBox["3456", "5"], " ", 
         SubsuperscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "2", "2"], " ", 
         SubscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "3"]}], "+", 
        RowBox[{"5184", " ", 
         SubscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "5"]}], "-", 
        RowBox[{"3456", " ", 
         SubscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "2"], " ", 
         SubscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "5"]}]}], ")"}]}]}], ")"}]}], "+", 
  RowBox[{
   SuperscriptBox["g", "11"], " ", 
   SqrtBox[
    RowBox[{"1", "-", 
     SuperscriptBox["z", "2"]}]], " ", 
   RowBox[{"(", 
    RowBox[{"74520", "+", 
     RowBox[{"11232", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2"]}], "-", 
     RowBox[{"29808", " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2", "2"]}], "-", 
     FractionBox[
      RowBox[{"165888", " ", 
       SubsuperscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "2", "3"]}], "35"], "+", 
     FractionBox[
      RowBox[{"368064", " ", 
       SubsuperscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "2", "4"]}], "175"], "-", 
     RowBox[{"19872", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3"]}], "-", 
     RowBox[{"6912", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3"]}], "+", 
     RowBox[{
      FractionBox["106272", "5"], " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2", "2"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3"]}], "+", 
     RowBox[{
      FractionBox["10368", "35"], " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2", "3"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3"]}], "-", 
     RowBox[{"18144", " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3", "2"]}], "-", 
     RowBox[{"3456", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2"], " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3", "2"]}], "-", 
     RowBox[{"49248", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "5"]}], "+", 
     RowBox[{"4320", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "5"]}], "+", 
     RowBox[{
      FractionBox["2592", "5"], " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2", "2"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "5"]}], "+", 
     RowBox[{"29376", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "5"]}], "-", 
     RowBox[{"1944", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "7"]}], "+", 
     RowBox[{"1296", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "7"]}], "+", 
     RowBox[{
      SuperscriptBox["z", "2"], " ", 
      RowBox[{"(", 
       RowBox[{"130896", "-", 
        RowBox[{"61344", " ", 
         SubscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "2"]}], "+", 
        FractionBox[
         RowBox[{"228096", " ", 
          SubsuperscriptBox[
           StyleBox["\[Zeta]",
            FontWeight->Bold,
            FontColor->GrayLevel[0.4]], "2", "2"]}], "5"], "-", 
        FractionBox[
         RowBox[{"103680", " ", 
          SubsuperscriptBox[
           StyleBox["\[Zeta]",
            FontWeight->Bold,
            FontColor->GrayLevel[0.4]], "2", "3"]}], "7"], "+", 
        FractionBox[
         RowBox[{"221184", " ", 
          SubsuperscriptBox[
           StyleBox["\[Zeta]",
            FontWeight->Bold,
            FontColor->GrayLevel[0.4]], "2", "4"]}], "175"], "-", 
        RowBox[{"123552", " ", 
         SubscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "3"]}], "+", 
        RowBox[{"9792", " ", 
         SubscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "2"], " ", 
         SubscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "3"]}], "+", 
        RowBox[{
         FractionBox["31104", "5"], " ", 
         SubsuperscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "2", "2"], " ", 
         SubscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "3"]}], "+", 
        RowBox[{"15552", " ", 
         SubsuperscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "3", "2"]}], "-", 
        RowBox[{"3456", " ", 
         SubscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "2"], " ", 
         SubsuperscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "3", "2"]}], "-", 
        RowBox[{"10368", " ", 
         SubscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "5"]}], "-", 
        RowBox[{"27648", " ", 
         SubscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "2"], " ", 
         SubscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "5"]}], "-", 
        RowBox[{
         FractionBox["10368", "5"], " ", 
         SubsuperscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "2", "2"], " ", 
         SubscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "5"]}], "+", 
        RowBox[{"44928", " ", 
         SubscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "3"], " ", 
         SubscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "5"]}], "-", 
        RowBox[{"38880", " ", 
         SubscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "7"]}], "+", 
        RowBox[{"25920", " ", 
         SubscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "2"], " ", 
         SubscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "7"]}]}], ")"}]}], "+", 
     RowBox[{
      SuperscriptBox["z", "4"], " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         RowBox[{"-", "31104"}], " ", 
         SubscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "2"]}], "-", 
        FractionBox[
         RowBox[{"186624", " ", 
          SubsuperscriptBox[
           StyleBox["\[Zeta]",
            FontWeight->Bold,
            FontColor->GrayLevel[0.4]], "2", "2"]}], "5"], "+", 
        FractionBox[
         RowBox[{"27648", " ", 
          SubsuperscriptBox[
           StyleBox["\[Zeta]",
            FontWeight->Bold,
            FontColor->GrayLevel[0.4]], "2", "3"]}], "7"], "+", 
        RowBox[{"93312", " ", 
         SubscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "3"]}], "-", 
        RowBox[{
         FractionBox["55296", "7"], " ", 
         SubsuperscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "2", "3"], " ", 
         SubscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "3"]}], "+", 
        RowBox[{"41472", " ", 
         SubscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "5"]}], "+", 
        RowBox[{
         FractionBox["27648", "5"], " ", 
         SubsuperscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "2", "2"], " ", 
         SubscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "5"]}], "-", 
        RowBox[{"51840", " ", 
         SubscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "7"]}], "+", 
        RowBox[{"34560", " ", 
         SubscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "2"], " ", 
         SubscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "7"]}]}], ")"}]}]}], ")"}]}], "+", 
  RowBox[{
   SuperscriptBox["g", "13"], " ", 
   SqrtBox[
    RowBox[{"1", "-", 
     SuperscriptBox["z", "2"]}]], " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"-", "845964"}], "-", 
     RowBox[{"249048", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2"]}], "+", 
     FractionBox[
      RowBox[{"1394496", " ", 
       SubsuperscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "2", "2"]}], "5"], "+", 
     FractionBox[
      RowBox[{"917568", " ", 
       SubsuperscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "2", "3"]}], "7"], "-", 
     FractionBox[
      RowBox[{"7690464", " ", 
       SubsuperscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "2", "4"]}], "175"], "-", 
     FractionBox[
      RowBox[{"917568", " ", 
       SubsuperscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "2", "5"]}], "175"], "-", 
     RowBox[{"386424", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3"]}], "+", 
     RowBox[{"233712", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3"]}], "+", 
     RowBox[{"29376", " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2", "2"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3"]}], "-", 
     RowBox[{
      FractionBox["1454976", "35"], " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2", "3"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3"]}], "-", 
     RowBox[{
      FractionBox["13824", "25"], " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2", "4"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3"]}], "+", 
     RowBox[{"383616", " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3", "2"]}], "-", 
     RowBox[{"114048", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2"], " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3", "2"]}], "+", 
     RowBox[{
      FractionBox["6912", "5"], " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2", "2"], " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3", "2"]}], "-", 
     RowBox[{"15552", " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3", "3"]}], "+", 
     RowBox[{"685584", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "5"]}], "-", 
     RowBox[{
      FractionBox["614304", "5"], " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2", "2"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "5"]}], "-", 
     RowBox[{
      FractionBox["31104", "35"], " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2", "3"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "5"]}], "-", 
     RowBox[{"170208", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "5"]}], "+", 
     RowBox[{"24192", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "5"]}], "-", 
     RowBox[{"64800", " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "5", "2"]}], "+", 
     RowBox[{"381024", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "7"]}], "-", 
     RowBox[{"51840", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "7"]}], "-", 
     RowBox[{
      FractionBox["7776", "5"], " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2", "2"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "7"]}], "-", 
     RowBox[{"204768", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "7"]}], "+", 
     RowBox[{"6048", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "9"]}], "-", 
     RowBox[{"4032", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "9"]}], "+", 
     RowBox[{
      SuperscriptBox["z", "6"], " ", 
      RowBox[{"(", 
       RowBox[{"559872", "-", 
        RowBox[{"373248", " ", 
         SubscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "2"]}], "+", 
        FractionBox[
         RowBox[{"2239488", " ", 
          SubsuperscriptBox[
           StyleBox["\[Zeta]",
            FontWeight->Bold,
            FontColor->GrayLevel[0.4]], "2", "2"]}], "5"], "+", 
        FractionBox[
         RowBox[{"1327104", " ", 
          SubsuperscriptBox[
           StyleBox["\[Zeta]",
            FontWeight->Bold,
            FontColor->GrayLevel[0.4]], "2", "3"]}], "7"], "-", 
        FractionBox[
         RowBox[{"663552", " ", 
          SubsuperscriptBox[
           StyleBox["\[Zeta]",
            FontWeight->Bold,
            FontColor->GrayLevel[0.4]], "2", "4"]}], "25"], "-", 
        RowBox[{"373248", " ", 
         SubscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "3"]}], "+", 
        RowBox[{
         FractionBox["221184", "5"], " ", 
         SubsuperscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "2", "4"], " ", 
         SubscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "3"]}], "-", 
        RowBox[{"1244160", " ", 
         SubscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "5"]}], "+", 
        RowBox[{
         FractionBox["147456", "7"], " ", 
         SubsuperscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "2", "3"], " ", 
         SubscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "5"]}], "-", 
        RowBox[{"248832", " ", 
         SubscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "7"]}], "-", 
        RowBox[{
         FractionBox["497664", "5"], " ", 
         SubsuperscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "2", "2"], " ", 
         SubscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "7"]}], "+", 
        RowBox[{"387072", " ", 
         SubscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "9"]}], "-", 
        RowBox[{"258048", " ", 
         SubscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "2"], " ", 
         SubscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "9"]}]}], ")"}]}], "-", 
     RowBox[{"6480", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], 
       RowBox[{"2", ",", "6"}]]}], "+", 
     RowBox[{"4320", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], 
       RowBox[{"2", ",", "6"}]]}], "+", 
     RowBox[{
      SuperscriptBox["z", "2"], " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "2323728"}], "+", 
        RowBox[{"80352", " ", 
         SubscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "2"]}], "+", 
        FractionBox[
         RowBox[{"471744", " ", 
          SubsuperscriptBox[
           StyleBox["\[Zeta]",
            FontWeight->Bold,
            FontColor->GrayLevel[0.4]], "2", "2"]}], "5"], "+", 
        FractionBox[
         RowBox[{"114048", " ", 
          SubsuperscriptBox[
           StyleBox["\[Zeta]",
            FontWeight->Bold,
            FontColor->GrayLevel[0.4]], "2", "3"]}], "7"], "+", 
        FractionBox[
         RowBox[{"21631104", " ", 
          SubsuperscriptBox[
           StyleBox["\[Zeta]",
            FontWeight->Bold,
            FontColor->GrayLevel[0.4]], "2", "4"]}], "175"], "-", 
        FractionBox[
         RowBox[{"6490368", " ", 
          SubsuperscriptBox[
           StyleBox["\[Zeta]",
            FontWeight->Bold,
            FontColor->GrayLevel[0.4]], "2", "5"]}], "175"], "+", 
        RowBox[{"2589408", " ", 
         SubscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "3"]}], "-", 
        RowBox[{"156096", " ", 
         SubscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "2"], " ", 
         SubscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "3"]}], "-", 
        RowBox[{"141696", " ", 
         SubsuperscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "2", "2"], " ", 
         SubscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "3"]}], "-", 
        RowBox[{
         FractionBox["5377536", "35"], " ", 
         SubsuperscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "2", "3"], " ", 
         SubscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "3"]}], "-", 
        RowBox[{
         FractionBox["124416", "25"], " ", 
         SubsuperscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "2", "4"], " ", 
         SubscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "3"]}], "-", 
        RowBox[{"549504", " ", 
         SubsuperscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "3", "2"]}], "+", 
        RowBox[{"6912", " ", 
         SubscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "2"], " ", 
         SubsuperscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "3", "2"]}], "+", 
        RowBox[{
         FractionBox["62208", "5"], " ", 
         SubsuperscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "2", "2"], " ", 
         SubsuperscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "3", "2"]}], "+", 
        RowBox[{"124416", " ", 
         SubsuperscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "3", "3"]}], "-", 
        RowBox[{"298080", " ", 
         SubscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "5"]}], "+", 
        RowBox[{"216000", " ", 
         SubscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "2"], " ", 
         SubscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "5"]}], "+", 
        RowBox[{
         FractionBox["279936", "5"], " ", 
         SubsuperscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "2", "2"], " ", 
         SubscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "5"]}], "+", 
        RowBox[{
         FractionBox["165888", "35"], " ", 
         SubsuperscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "2", "3"], " ", 
         SubscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "5"]}], "-", 
        RowBox[{"58752", " ", 
         SubscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "3"], " ", 
         SubscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "5"]}], "+", 
        RowBox[{"269568", " ", 
         SubscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "2"], " ", 
         SubscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "3"], " ", 
         SubscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "5"]}], "-", 
        RowBox[{"362880", " ", 
         SubsuperscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "5", "2"]}], "+", 
        RowBox[{"637632", " ", 
         SubscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "7"]}], "+", 
        RowBox[{"41472", " ", 
         SubscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "2"], " ", 
         SubscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "7"]}], "-", 
        RowBox[{"466560", " ", 
         SubscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "3"], " ", 
         SubscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "7"]}], "+", 
        RowBox[{"217728", " ", 
         SubscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "9"]}], "-", 
        RowBox[{"145152", " ", 
         SubscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "2"], " ", 
         SubscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "9"]}], "+", 
        RowBox[{"77760", " ", 
         SubscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], 
          RowBox[{"2", ",", "6"}]]}], "-", 
        RowBox[{"51840", " ", 
         SubscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "2"], " ", 
         SubscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], 
          RowBox[{"2", ",", "6"}]]}]}], ")"}]}], "+", 
     RowBox[{
      SuperscriptBox["z", "4"], " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "1099008"}], "+", 
        RowBox[{"1406592", " ", 
         SubscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "2"]}], "-", 
        FractionBox[
         RowBox[{"1617408", " ", 
          SubsuperscriptBox[
           StyleBox["\[Zeta]",
            FontWeight->Bold,
            FontColor->GrayLevel[0.4]], "2", "2"]}], "5"], "-", 
        FractionBox[
         RowBox[{"3262464", " ", 
          SubsuperscriptBox[
           StyleBox["\[Zeta]",
            FontWeight->Bold,
            FontColor->GrayLevel[0.4]], "2", "3"]}], "35"], "+", 
        FractionBox[
         RowBox[{"4852224", " ", 
          SubsuperscriptBox[
           StyleBox["\[Zeta]",
            FontWeight->Bold,
            FontColor->GrayLevel[0.4]], "2", "4"]}], "175"], "+", 
        FractionBox[
         RowBox[{"7382016", " ", 
          SubsuperscriptBox[
           StyleBox["\[Zeta]",
            FontWeight->Bold,
            FontColor->GrayLevel[0.4]], "2", "5"]}], "175"], "-", 
        RowBox[{"542592", " ", 
         SubscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "3"]}], "-", 
        RowBox[{"246528", " ", 
         SubscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "2"], " ", 
         SubscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "3"]}], "+", 
        RowBox[{"13824", " ", 
         SubsuperscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "2", "2"], " ", 
         SubscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "3"]}], "-", 
        RowBox[{
         FractionBox["552960", "7"], " ", 
         SubsuperscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "2", "3"], " ", 
         SubscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "3"]}], "+", 
        RowBox[{
         FractionBox["165888", "5"], " ", 
         SubsuperscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "2", "4"], " ", 
         SubscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "3"]}], "+", 
        RowBox[{"373248", " ", 
         SubsuperscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "3", "2"]}], "-", 
        RowBox[{
         FractionBox["82944", "5"], " ", 
         SubsuperscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "2", "2"], " ", 
         SubsuperscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "3", "2"]}], "+", 
        RowBox[{"1067904", " ", 
         SubscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "5"]}], "-", 
        RowBox[{"110592", " ", 
         SubscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "2"], " ", 
         SubscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "5"]}], "+", 
        RowBox[{
         FractionBox["304128", "5"], " ", 
         SubsuperscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "2", "2"], " ", 
         SubscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "5"]}], "-", 
        RowBox[{
         FractionBox["55296", "7"], " ", 
         SubsuperscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "2", "3"], " ", 
         SubscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "5"]}], "-", 
        RowBox[{"124416", " ", 
         SubscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "3"], " ", 
         SubscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "5"]}], "-", 
        RowBox[{"110592", " ", 
         SubscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "2"], " ", 
         SubscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "3"], " ", 
         SubscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "5"]}], "-", 
        RowBox[{"138240", " ", 
         SubsuperscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "5", "2"]}], "-", 
        RowBox[{"352512", " ", 
         SubscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "7"]}], "+", 
        RowBox[{"276480", " ", 
         SubscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "2"], " ", 
         SubscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "7"]}], "-", 
        RowBox[{"331776", " ", 
         SubscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "3"], " ", 
         SubscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "7"]}], "+", 
        RowBox[{"725760", " ", 
         SubscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "9"]}], "-", 
        RowBox[{"483840", " ", 
         SubscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "2"], " ", 
         SubscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "9"]}], "-", 
        RowBox[{"103680", " ", 
         SubscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], 
          RowBox[{"2", ",", "6"}]]}], "+", 
        RowBox[{"69120", " ", 
         SubscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "2"], " ", 
         SubscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], 
          RowBox[{"2", ",", "6"}]]}]}], ")"}]}]}], ")"}]}]}]], "Output",
 CellChangeTimes->{
  3.555828329998637*^9, 3.555828405629641*^9, 3.5558284557487183`*^9, {
   3.555828641047724*^9, 3.555828662552433*^9}, {3.555829195586906*^9, 
   3.555829205300832*^9}, {3.555829573991558*^9, 3.5558295836765957`*^9}, 
   3.555854989060677*^9, 3.564855933480289*^9}]
}, Open  ]]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 "RHS: ",
 Cell[BoxData[
  RowBox[{
   RowBox[{
    RowBox[{"-", "4"}], "\[ImaginaryI]", " ", "g", 
    SqrtBox[
     RowBox[{"1", "-", 
      SuperscriptBox["z", "2"]}]], 
    RowBox[{
     SubsuperscriptBox["\[Integral]", 
      RowBox[{
       RowBox[{"-", "\[Infinity]"}], "-", 
       RowBox[{"\[ImaginaryI]", " ", "0"}]}], 
      RowBox[{
       RowBox[{"+", "\[Infinity]"}], "-", 
       RowBox[{"\[ImaginaryI]", " ", "0"}]}]], 
     RowBox[{
      FractionBox["dv", 
       RowBox[{
        RowBox[{"-", "2"}], "\[Pi]", " ", "\[ImaginaryI]"}]], 
      FractionBox["1", 
       RowBox[{
        RowBox[{"4", 
         SuperscriptBox["g", "2"], 
         SuperscriptBox["z", "2"]}], "-", 
        SuperscriptBox["u", "2"]}]], 
      FractionBox["H", 
       SqrtBox[
        RowBox[{"1", "-", 
         FractionBox[
          RowBox[{"4", 
           SuperscriptBox["g", "2"]}], 
          SuperscriptBox["u", "2"]]}]]]}]}]}], "=", "RHSHp"}]],
  CellChangeTimes->{{3.546686010540494*^9, 3.546686010839571*^9}}]
}], "Subsection",
 CellChangeTimes->{{3.546971808165141*^9, 3.5469718300391407`*^9}, 
   3.54973622547484*^9, {3.55235419129112*^9, 3.5523541932365437`*^9}, {
   3.553729352611065*^9, 3.553729353928093*^9}, {3.553729453907784*^9, 
   3.553729522407083*^9}, {3.553729566626319*^9, 3.553729575047632*^9}, {
   3.5537300898581877`*^9, 3.553730094733838*^9}, {3.555830025007077*^9, 
   3.5558300278016157`*^9}, {3.555830298866482*^9, 3.555830313727335*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"RHSHp", "=", 
  RowBox[{
   SqrtBox[
    RowBox[{"1", "-", 
     SuperscriptBox["z", "2"]}]], 
   RowBox[{"Collect", "[", 
    RowBox[{
     RowBox[{"Normal", "@", 
      RowBox[{"Series", "[", 
       RowBox[{
        RowBox[{
         RowBox[{
          RowBox[{"-", "4"}], "\[ImaginaryI]", " ", "g", 
          FractionBox["1", 
           RowBox[{
            RowBox[{"4", 
             SuperscriptBox["g", "2"], 
             SuperscriptBox["z", "2"]}], "-", 
            SuperscriptBox["u", "2"]}]], 
          FractionBox["H", 
           SqrtBox[
            RowBox[{"1", "-", 
             FractionBox[
              RowBox[{"4", 
               SuperscriptBox["g", "2"]}], 
              SuperscriptBox["u", "2"]]}]]]}], "/.", 
         RowBox[{"H", "\[Rule]", 
          RowBox[{
           SuperscriptBox["g", "8"], 
           RowBox[{"(", 
            RowBox[{
             SubscriptBox["H", "lead"], "+", 
             RowBox[{
              SuperscriptBox["g", "2"], 
              SubscriptBox["H", "sublead"]}], "+", 
             RowBox[{
              SuperscriptBox["g", "4"], 
              SubscriptBox["H", "sublead2"]}]}], ")"}]}]}]}], ",", 
        RowBox[{"{", 
         RowBox[{"g", ",", "0", ",", "13"}], "}"}]}], "]"}]}], ",", "g", ",", 
     
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         RowBox[{"\[DoubleStruckCapitalC]", "[", 
          RowBox[{"Collect", "[", 
           RowBox[{
            RowBox[{"Expand", "[", "#", "]"}], ",", "z"}], "]"}], "]"}], "//.", 
         RowBox[{
          RowBox[{"\[DoubleStruckCapitalC]", "[", 
           RowBox[{
            RowBox[{
             SuperscriptBox["z", "a_."], "b_."}], "+", "c_."}], "]"}], 
          "\[RuleDelayed]", 
          RowBox[{
           RowBox[{
            SuperscriptBox["z", "a"], 
            RowBox[{"\[DoubleStruckCapitalC]", "[", "b", "]"}]}], "+", 
           RowBox[{"\[DoubleStruckCapitalC]", "[", "c", "]"}]}]}]}], "/.", 
        RowBox[{
         RowBox[{"\[DoubleStruckCapitalC]", "[", "0", "]"}], "\[Rule]", 
         "0"}]}], ")"}], "&"}]}], "]"}]}]}]], "Input",
 CellChangeTimes->{{3.55582999159136*^9, 3.555830181536829*^9}, {
  3.555830213512594*^9, 3.55583024300826*^9}, {3.555830288361685*^9, 
  3.555830303882792*^9}}],

Cell[BoxData[
 RowBox[{
  SqrtBox[
   RowBox[{"1", "-", 
    SuperscriptBox["z", "2"]}]], " ", 
  RowBox[{"(", 
   RowBox[{
    RowBox[{
     SuperscriptBox["g", "9"], " ", 
     RowBox[{"\[DoubleStruckCapitalC]", "[", 
      FractionBox[
       RowBox[{"4", " ", "\[ImaginaryI]", " ", 
        SubscriptBox[
         StyleBox["H",
          FontColor->RGBColor[0.54, 0.35, 0.15]], "lead"]}], 
       SuperscriptBox["u", "2"]], "]"}]}], "+", 
    RowBox[{
     SuperscriptBox["g", "11"], " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{
        SuperscriptBox["z", "2"], " ", 
        RowBox[{"\[DoubleStruckCapitalC]", "[", 
         FractionBox[
          RowBox[{"16", " ", "\[ImaginaryI]", " ", 
           SubscriptBox[
            StyleBox["H",
             FontColor->RGBColor[0.54, 0.35, 0.15]], "lead"]}], 
          SuperscriptBox["u", "4"]], "]"}]}], "+", 
       RowBox[{"\[DoubleStruckCapitalC]", "[", 
        RowBox[{
         FractionBox[
          RowBox[{"8", " ", "\[ImaginaryI]", " ", 
           SubscriptBox[
            StyleBox["H",
             FontColor->RGBColor[0.54, 0.35, 0.15]], "lead"]}], 
          SuperscriptBox["u", "4"]], "+", 
         FractionBox[
          RowBox[{"4", " ", "\[ImaginaryI]", " ", 
           SubscriptBox[
            StyleBox["H",
             FontColor->RGBColor[0.54, 0.35, 0.15]], "sublead"]}], 
          SuperscriptBox["u", "2"]]}], "]"}]}], ")"}]}], "+", 
    RowBox[{
     SuperscriptBox["g", "13"], " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{
        SuperscriptBox["z", "4"], " ", 
        RowBox[{"\[DoubleStruckCapitalC]", "[", 
         FractionBox[
          RowBox[{"64", " ", "\[ImaginaryI]", " ", 
           SubscriptBox[
            StyleBox["H",
             FontColor->RGBColor[0.54, 0.35, 0.15]], "lead"]}], 
          SuperscriptBox["u", "6"]], "]"}]}], "+", 
       RowBox[{
        SuperscriptBox["z", "2"], " ", 
        RowBox[{"\[DoubleStruckCapitalC]", "[", 
         RowBox[{
          FractionBox[
           RowBox[{"32", " ", "\[ImaginaryI]", " ", 
            SubscriptBox[
             StyleBox["H",
              FontColor->RGBColor[0.54, 0.35, 0.15]], "lead"]}], 
           SuperscriptBox["u", "6"]], "+", 
          FractionBox[
           RowBox[{"16", " ", "\[ImaginaryI]", " ", 
            SubscriptBox[
             StyleBox["H",
              FontColor->RGBColor[0.54, 0.35, 0.15]], "sublead"]}], 
           SuperscriptBox["u", "4"]]}], "]"}]}], "+", 
       RowBox[{"\[DoubleStruckCapitalC]", "[", 
        RowBox[{
         FractionBox[
          RowBox[{"24", " ", "\[ImaginaryI]", " ", 
           SubscriptBox[
            StyleBox["H",
             FontColor->RGBColor[0.54, 0.35, 0.15]], "lead"]}], 
          SuperscriptBox["u", "6"]], "+", 
         FractionBox[
          RowBox[{"8", " ", "\[ImaginaryI]", " ", 
           SubscriptBox[
            StyleBox["H",
             FontColor->RGBColor[0.54, 0.35, 0.15]], "sublead"]}], 
          SuperscriptBox["u", "4"]], "+", 
         FractionBox[
          RowBox[{"4", " ", "\[ImaginaryI]", " ", 
           SubscriptBox[
            StyleBox["H",
             FontColor->RGBColor[0.54, 0.35, 0.15]], "sublead2"]}], 
          SuperscriptBox["u", "2"]]}], "]"}]}], ")"}]}]}], ")"}]}]], "Output",\

 CellChangeTimes->{
  3.5558300369553013`*^9, 3.555830094188402*^9, 3.555830151785042*^9, 
   3.5558301829149*^9, {3.555830214088901*^9, 3.555830243899747*^9}, {
   3.55583029354173*^9, 3.555830321084546*^9}, {3.555855255936572*^9, 
   3.555855258614468*^9}, 3.564855946218302*^9}]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 "RHS: ",
 Cell[BoxData[
  RowBox[{
   RowBox[{
    SubsuperscriptBox["\[Integral]", 
     RowBox[{
      RowBox[{"-", "\[Infinity]"}], "-", 
      RowBox[{"\[ImaginaryI]", " ", "0"}]}], 
     RowBox[{
      RowBox[{"+", "\[Infinity]"}], "-", 
      RowBox[{"\[ImaginaryI]", " ", "0"}]}]], 
    RowBox[{
     FractionBox["dv", 
      RowBox[{
       RowBox[{"-", "2"}], "\[Pi]", " ", "\[ImaginaryI]"}]], 
     RowBox[{"(", 
      FractionBox[
       RowBox[{"2", "u"}], 
       RowBox[{
        RowBox[{"4", 
         SuperscriptBox["g", "2"], 
         SuperscriptBox["z", "2"]}], "-", 
        SuperscriptBox["u", "2"]}]], ")"}], "H"}]}], "==", "RHSHo"}]],
  CellChangeTimes->{{3.546931310662352*^9, 3.5469313989313602`*^9}, {
   3.546931442809442*^9, 3.5469315410399837`*^9}}]
}], "Subsection",
 CellChangeTimes->{
  3.546920783970316*^9, {3.546922333319865*^9, 3.5469223384533052`*^9}, {
   3.5469719436208487`*^9, 3.546971948218935*^9}, 3.549877610590971*^9, {
   3.553730735112656*^9, 3.5537307553428593`*^9}, {3.553730822488984*^9, 
   3.553730832126541*^9}, {3.553731181912916*^9, 3.553731200239025*^9}, {
   3.5558304664294*^9, 3.5558304698761053`*^9}, {3.5558305131306047`*^9, 
   3.555830519365007*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"RHSHo", "=", 
  RowBox[{"Collect", "[", 
   RowBox[{
    RowBox[{"Normal", "@", 
     RowBox[{"Series", "[", 
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{"(", 
          FractionBox[
           RowBox[{"2", "u"}], 
           RowBox[{
            RowBox[{"4", 
             SuperscriptBox["g", "2"], 
             SuperscriptBox["z", "2"]}], "-", 
            SuperscriptBox["u", "2"]}]], ")"}], "H"}], "/.", 
        RowBox[{"H", "\[Rule]", 
         RowBox[{
          SuperscriptBox["g", "8"], 
          RowBox[{"(", 
           RowBox[{
            SubscriptBox["H", "lead"], "+", 
            RowBox[{
             SuperscriptBox["g", "2"], 
             SubscriptBox["H", "sublead"]}], "+", 
            RowBox[{
             SuperscriptBox["g", "4"], 
             SubscriptBox["H", "sublead2"]}]}], ")"}]}]}]}], ",", 
       RowBox[{"{", 
        RowBox[{"g", ",", "0", ",", "12"}], "}"}]}], "]"}]}], ",", "g", ",", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{
        RowBox[{"\[DoubleStruckCapitalC]", "[", 
         RowBox[{"Collect", "[", 
          RowBox[{
           RowBox[{"Expand", "[", "#", "]"}], ",", "z"}], "]"}], "]"}], "//.", 
        RowBox[{
         RowBox[{"\[DoubleStruckCapitalC]", "[", 
          RowBox[{
           RowBox[{
            SuperscriptBox["z", "a_."], "b_."}], "+", "c_."}], "]"}], 
         "\[RuleDelayed]", 
         RowBox[{
          RowBox[{
           SuperscriptBox["z", "a"], 
           RowBox[{"\[DoubleStruckCapitalC]", "[", "b", "]"}]}], "+", 
          RowBox[{"\[DoubleStruckCapitalC]", "[", "c", "]"}]}]}]}], "/.", 
       RowBox[{
        RowBox[{"\[DoubleStruckCapitalC]", "[", "0", "]"}], "\[Rule]", 
        "0"}]}], ")"}], "&"}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.555830458701126*^9, 3.555830497573657*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   SuperscriptBox["g", "8"], " ", 
   RowBox[{"\[DoubleStruckCapitalC]", "[", 
    RowBox[{"-", 
     FractionBox[
      RowBox[{"2", " ", 
       SubscriptBox[
        StyleBox["H",
         FontColor->RGBColor[0.54, 0.35, 0.15]], "lead"]}], "u"]}], "]"}]}], 
  "+", 
  RowBox[{
   SuperscriptBox["g", "10"], " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{
      SuperscriptBox["z", "2"], " ", 
      RowBox[{"\[DoubleStruckCapitalC]", "[", 
       RowBox[{"-", 
        FractionBox[
         RowBox[{"8", " ", 
          SubscriptBox[
           StyleBox["H",
            FontColor->RGBColor[0.54, 0.35, 0.15]], "lead"]}], 
         SuperscriptBox["u", "3"]]}], "]"}]}], "+", 
     RowBox[{"\[DoubleStruckCapitalC]", "[", 
      RowBox[{"-", 
       FractionBox[
        RowBox[{"2", " ", 
         SubscriptBox[
          StyleBox["H",
           FontColor->RGBColor[0.54, 0.35, 0.15]], "sublead"]}], "u"]}], 
      "]"}]}], ")"}]}], "+", 
  RowBox[{
   SuperscriptBox["g", "12"], " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{
      SuperscriptBox["z", "4"], " ", 
      RowBox[{"\[DoubleStruckCapitalC]", "[", 
       RowBox[{"-", 
        FractionBox[
         RowBox[{"32", " ", 
          SubscriptBox[
           StyleBox["H",
            FontColor->RGBColor[0.54, 0.35, 0.15]], "lead"]}], 
         SuperscriptBox["u", "5"]]}], "]"}]}], "+", 
     RowBox[{
      SuperscriptBox["z", "2"], " ", 
      RowBox[{"\[DoubleStruckCapitalC]", "[", 
       RowBox[{"-", 
        FractionBox[
         RowBox[{"8", " ", 
          SubscriptBox[
           StyleBox["H",
            FontColor->RGBColor[0.54, 0.35, 0.15]], "sublead"]}], 
         SuperscriptBox["u", "3"]]}], "]"}]}], "+", 
     RowBox[{"\[DoubleStruckCapitalC]", "[", 
      RowBox[{"-", 
       FractionBox[
        RowBox[{"2", " ", 
         SubscriptBox[
          StyleBox["H",
           FontColor->RGBColor[0.54, 0.35, 0.15]], "sublead2"]}], "u"]}], 
      "]"}]}], ")"}]}]}]], "Output",
 CellChangeTimes->{{3.555830490853858*^9, 3.555830498243071*^9}, 
   3.555855275757971*^9, 3.5648559547726793`*^9}]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 "RHS:",
 Cell[BoxData[
  RowBox[{
   RowBox[{
    SubsuperscriptBox["\[Integral]", 
     RowBox[{
      RowBox[{"-", "\[Infinity]"}], "-", 
      RowBox[{"\[ImaginaryI]", " ", "0"}]}], 
     RowBox[{
      RowBox[{"+", "\[Infinity]"}], "-", 
      RowBox[{"\[ImaginaryI]", " ", "0"}]}]], 
    RowBox[{
     FractionBox["dv", 
      RowBox[{
       RowBox[{"-", "2"}], "\[Pi]", " ", "\[ImaginaryI]"}]], 
     RowBox[{"(", 
      FractionBox[
       RowBox[{"2", "u"}], 
       RowBox[{
        RowBox[{"4", 
         SuperscriptBox["g", "2"], 
         SuperscriptBox["z", "2"]}], "-", 
        SuperscriptBox["u", "2"]}]], ")"}], 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"-", "2"}], 
       RowBox[{"Log", "[", 
        RowBox[{
         RowBox[{"(", 
          FractionBox[
           RowBox[{" ", 
            SuperscriptBox[
             StyleBox["\[ScriptCapitalT]",
              FontColor->RGBColor[1, 0, 0]], "+"], " "}], 
           SuperscriptBox[
            StyleBox["\[GothicCapitalT]",
             FontColor->RGBColor[0.54, 0.35, 0.15]], "+"]], ")"}], "/", 
         SubscriptBox[
          RowBox[{"(", 
           FractionBox[
            RowBox[{" ", 
             SuperscriptBox[
              StyleBox["\[ScriptCapitalT]",
               FontColor->RGBColor[1, 0, 0]], "+"], " "}], 
            SuperscriptBox[
             StyleBox["\[GothicCapitalT]",
              FontColor->RGBColor[0.54, 0.35, 0.15]], "+"]], ")"}], "asym"]}],
         "]"}]}], ")"}]}]}], "=", 
   RowBox[{
   "RHS\[Delta]\[Rho]", "+", "RHS\[Delta]\[Rho]2", "+", "RHSCW", "+", 
    "RHSW1"}]}]],
  CellChangeTimes->{{3.546931310662352*^9, 3.5469313989313602`*^9}, {
   3.546931442809442*^9, 3.5469315410399837`*^9}, {3.553713091967557*^9, 
   3.553713161571763*^9}}]
}], "Subsection",
 CellChangeTimes->{
  3.546920783970316*^9, {3.546922333319865*^9, 3.5469223384533052`*^9}, {
   3.5469719436208487`*^9, 3.546971948218935*^9}, {3.546972012603903*^9, 
   3.546972012604336*^9}, {3.546972199870935*^9, 3.54697226112455*^9}, {
   3.548428281283731*^9, 3.54842828128389*^9}, {3.549874149991908*^9, 
   3.549874152468955*^9}, {3.5498774927538357`*^9, 3.5498774980236053`*^9}, {
   3.5498775921627274`*^9, 3.549877593901733*^9}, {3.553731300136894*^9, 
   3.553731351848385*^9}, {3.5537326748761597`*^9, 3.55373267566474*^9}, {
   3.5537328733166847`*^9, 3.553732881823558*^9}, {3.5537333063369093`*^9, 
   3.553733319007102*^9}, {3.553733366144402*^9, 3.5537333703321*^9}, {
   3.553733489478483*^9, 3.553733490124563*^9}, {3.553735279590702*^9, 
   3.553735291239007*^9}, {3.553737264471204*^9, 3.5537372716344547`*^9}, {
   3.553775744457981*^9, 3.55377574445815*^9}, {3.555840754994789*^9, 
   3.555840755371622*^9}, {3.555855311597653*^9, 3.5558553173111877`*^9}}],

Cell[CellGroupData[{

Cell["\<\
Some remarkable facts (a little bit old now story, probably can be further \
developed)\
\>", "Subsubsection",
 CellChangeTimes->{{3.553736174008065*^9, 3.553736198164898*^9}, {
  3.553737189438835*^9, 3.553737213108431*^9}, {3.555837043112764*^9, 
  3.555837056565687*^9}}],

Cell["\<\
Derivation is given below, now we note that previously we found that (and \
numerically I checked that it gives the same result)\
\>", "Text",
 CellChangeTimes->{{3.553735780070093*^9, 3.553735793868807*^9}, {
  3.553736021603538*^9, 3.55373603639522*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   SuperscriptBox["g", "8"], "I2"}], "=", 
  RowBox[{"4", 
   RowBox[{"\[DoubleStruckCapitalC]", "[", 
    RowBox[{
     FractionBox["u", 
      SuperscriptBox[
       StyleBox["Q0",
        FontColor->RGBColor[{
           Rational[1, 2], 
           Rational[1, 2], 0}]], "+"]], 
     RowBox[{"(", 
      RowBox[{
       SubsuperscriptBox["W", "1", "+"], "-", 
       SubscriptBox[
        OverscriptBox["W", "^"], "pv"]}], ")"}]}], "]"}]}]}]], "Input",
 CellChangeTimes->{{3.553735807478779*^9, 3.553735837285006*^9}}],

Cell["\<\
The sign is corred (i.e. a little bit less trivial for cancellation). Hence \
we get a relation\
\>", "Text",
 CellChangeTimes->{{3.553736038611259*^9, 3.553736056602214*^9}, {
  3.5537361203837547`*^9, 3.553736126511416*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"g", " ", 
   RowBox[{"M", "[", 
    SubscriptBox["\[Delta]\[Rho]", "2"], "]"}]}], "\[Equal]", 
  RowBox[{
   FractionBox["2", "3"], 
   RowBox[{"\[DoubleStruckCapitalC]", "[", 
    RowBox[{
     FractionBox[
      RowBox[{"u", "+", 
       FractionBox["\[ImaginaryI]", "2"]}], 
      SuperscriptBox[
       StyleBox["Q0",
        FontColor->RGBColor[{
           Rational[1, 2], 
           Rational[1, 2], 0}]], "+"]], 
     RowBox[{"(", 
      RowBox[{
       SubscriptBox[
        OverscriptBox["W", "^"], "pv"], "-", 
       SubsuperscriptBox["W", "1", "+"]}], ")"}]}], "]"}]}]}]], "Input",
 CellChangeTimes->{{3.553736135435493*^9, 3.553736170444406*^9}}],

Cell["From the other side we have also:", "Text",
 CellChangeTimes->{{3.55373627720947*^9, 3.5537362825928373`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"M", "[", 
   SubscriptBox["\[Delta]\[Rho]", "2"], "]"}], "\[Equal]", 
  RowBox[{
   FractionBox["1", "3"], 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"-", 
      SubscriptBox["W", "1"]}], "+", 
     RowBox[{
      SubscriptBox["\[ScriptCapitalC]", "1"], "*", 
      SubscriptBox[
       OverscriptBox["W", "^"], "pv"]}]}], ")"}]}], "\[Equal]", 
  RowBox[{
   RowBox[{"-", 
    FractionBox[
     SubscriptBox["W", "1"], "3"]}], "-", 
   RowBox[{
    FractionBox["1", "9"], 
    RowBox[{"\[DoubleStruckCapitalC]", "[", 
     RowBox[{
      FractionBox[
       RowBox[{" ", 
        RowBox[{"\[ImaginaryI]", " ", 
         RowBox[{"(", 
          RowBox[{"1", "+", 
           RowBox[{"3", " ", 
            SuperscriptBox["u", "2"]}]}], ")"}]}]}], 
       RowBox[{" ", 
        RowBox[{
         SuperscriptBox[
          StyleBox["Q0",
           FontColor->RGBColor[{
              Rational[1, 2], 
              Rational[1, 2], 0}]], "-"], " ", 
         SuperscriptBox[
          StyleBox["Q0",
           FontColor->RGBColor[{
              Rational[1, 2], 
              Rational[1, 2], 0}]], "+"]}]}]], 
      SubscriptBox[
       OverscriptBox["W", "^"], "pv"]}], "]"}]}]}]}]], "Input",
 CellChangeTimes->{{3.5537363482407103`*^9, 3.55373638259251*^9}, {
  3.5537365511308107`*^9, 3.5537366118628607`*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     RowBox[{
      RowBox[{
       FractionBox["1", "2"], 
       RowBox[{"(", 
        RowBox[{
         FractionBox["1", 
          RowBox[{"u", "-", "v", "+", 
           FractionBox["\[ImaginaryI]", "2"]}]], "-", 
         FractionBox["1", 
          RowBox[{"u", "-", "v", "-", 
           FractionBox["\[ImaginaryI]", "2"]}]], "+", 
         FractionBox["1", 
          RowBox[{"u", "+", "v", "+", 
           FractionBox["\[ImaginaryI]", "2"]}]], "-", 
         FractionBox["1", 
          RowBox[{"u", "+", "v", "-", 
           FractionBox["\[ImaginaryI]", "2"]}]]}], ")"}]}], "/.", 
      RowBox[{"u", "\[Rule]", "v00"}]}], "//", "Simplify"}], ")"}], "/.", " ", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{"1", "+", 
      RowBox[{"3", " ", 
       SuperscriptBox["v", "2"]}], "+", 
      RowBox[{"9", " ", 
       SuperscriptBox["v", "4"]}]}], ")"}], "\[Rule]", 
    RowBox[{"9", 
     SuperscriptBox["Q0", "+"], 
     SuperscriptBox["Q0", "-"]}]}]}], "/.", 
  RowBox[{"v", "\[Rule]", "u"}]}]], "Input",
 CellChangeTimes->{{3.553736383770186*^9, 3.55373643573491*^9}, {
  3.553736477197501*^9, 3.553736533043331*^9}, {3.5537366161862392`*^9, 
  3.553736642776783*^9}, {3.553736785814183*^9, 3.553736786396119*^9}}],

Cell[BoxData[
 RowBox[{"-", 
  FractionBox[
   RowBox[{"\[ImaginaryI]", " ", 
    RowBox[{"(", 
     RowBox[{"1", "+", 
      RowBox[{"3", " ", 
       SuperscriptBox["u", "2"]}]}], ")"}]}], 
   RowBox[{"3", " ", 
    SuperscriptBox[
     StyleBox["Q0",
      FontColor->RGBColor[{
         Rational[1, 2], 
         Rational[1, 2], 0}]], "-"], " ", 
    SuperscriptBox[
     StyleBox["Q0",
      FontColor->RGBColor[{
         Rational[1, 2], 
         Rational[1, 2], 0}]], "+"]}]]}]], "Output",
 CellChangeTimes->{3.553737076318322*^9}]
}, Open  ]],

Cell["In particular, it is easy to see that ", "Text",
 CellChangeTimes->{{3.553736992966549*^9, 3.55373702653132*^9}, {
  3.553737063975047*^9, 3.553737084857601*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"\[DoubleStruckCapitalC]", "[", 
   RowBox[{
    FractionBox[
     RowBox[{"u", "+", 
      FractionBox["\[ImaginaryI]", "2"]}], 
     SuperscriptBox[
      StyleBox["Q0",
       FontColor->RGBColor[{
          Rational[1, 2], 
          Rational[1, 2], 0}]], "+"]], 
    SubscriptBox[
     OverscriptBox["W", "^"], "pv"]}], "]"}], "==", 
  RowBox[{
   RowBox[{"-", 
    FractionBox["1", "6"]}], 
   RowBox[{"\[DoubleStruckCapitalC]", "[", 
    RowBox[{
     FractionBox[
      RowBox[{" ", 
       RowBox[{"\[ImaginaryI]", " ", 
        RowBox[{"(", 
         RowBox[{"1", "+", 
          RowBox[{"3", " ", 
           SuperscriptBox["u", "2"]}]}], ")"}]}]}], 
      RowBox[{" ", 
       RowBox[{
        SuperscriptBox[
         StyleBox["Q0",
          FontColor->RGBColor[{
             Rational[1, 2], 
             Rational[1, 2], 0}]], "-"], " ", 
        SuperscriptBox[
         StyleBox["Q0",
          FontColor->RGBColor[{
             Rational[1, 2], 
             Rational[1, 2], 0}]], "+"]}]}]], 
     SubscriptBox[
      OverscriptBox["W", "^"], "pv"]}], "]"}]}]}]], "Input"],

Cell["and hence", "Text",
 CellChangeTimes->{{3.55373708797723*^9, 3.553737089537166*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"2", 
   RowBox[{"\[DoubleStruckCapitalC]", "[", 
    RowBox[{
     FractionBox[
      RowBox[{"u", "+", 
       FractionBox["\[ImaginaryI]", "2"]}], 
      SuperscriptBox[
       StyleBox["Q0",
        FontColor->RGBColor[{
           Rational[1, 2], 
           Rational[1, 2], 0}]], "+"]], 
     SubsuperscriptBox["W", "1", "+"]}], "]"}]}], "==", 
  SubscriptBox["W", "1"], " ", 
  RowBox[{"(*", " ", 
   RowBox[{"at", " ", "Bethe", " ", "root"}], " ", "*)"}]}]], "Input",
 CellChangeTimes->{{3.553737096949698*^9, 3.553737116499874*^9}, {
  3.553740760213468*^9, 3.55374076727497*^9}}],

Cell["All this was checked only at the leading order. ", "Text",
 CellChangeTimes->{{3.55373713703946*^9, 3.55373714707136*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["Numerical check:", "Subsubsection",
 CellChangeTimes->{{3.553736174008065*^9, 3.553736198164898*^9}}],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"tmp1", "=", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{"-", 
         FractionBox["1", 
          RowBox[{"2", "\[Pi]", " ", "\[ImaginaryI]"}]]}], 
        FractionBox["2", "3"], 
        FractionBox[
         RowBox[{"u", "+", 
          FractionBox["\[ImaginaryI]", "2"]}], 
         SuperscriptBox[
          StyleBox["Q0",
           FontColor->RGBColor[{
              Rational[1, 2], 
              Rational[1, 2], 0}]], "+"]], "W"}], "/.", 
       RowBox[{"leadweak", "[", "1", "]"}]}], "/.", "subQ0"}], "/.", 
     RowBox[{"g", "\[Rule]", "1"}]}], "/.", "subtoPolyGammas"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"int1", "=", 
  RowBox[{
   RowBox[{
    FractionBox["1", "2"], 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"NIntegrate", "[", 
       RowBox[{
        RowBox[{"tmp1", "/.", 
         RowBox[{"u", "\[Rule]", 
          RowBox[{"t", "+", 
           FractionBox["\[ImaginaryI]", "4"]}]}]}], ",", 
        RowBox[{"{", 
         RowBox[{"t", ",", 
          RowBox[{"-", "\[Infinity]"}], ",", 
          RowBox[{"+", "\[Infinity]"}]}], "}"}]}], "]"}], "+", 
      RowBox[{"NIntegrate", "[", 
       RowBox[{
        RowBox[{"tmp1", "/.", 
         RowBox[{"u", "\[Rule]", 
          RowBox[{"t", "-", 
           FractionBox["\[ImaginaryI]", "4"]}]}]}], ",", 
        RowBox[{"{", 
         RowBox[{"t", ",", 
          RowBox[{"-", "\[Infinity]"}], ",", 
          RowBox[{"+", "\[Infinity]"}]}], "}"}]}], "]"}]}], ")"}]}], "//", 
   "Chop"}]}]}], "Input",
 CellChangeTimes->{{3.5537362013834743`*^9, 3.553736268367291*^9}, 
   3.5537364060815277`*^9, {3.553736821400281*^9, 3.553736823476405*^9}}],

Cell[BoxData[
 RowBox[{"-", "1.1929762349556183`"}]], "Output",
 CellChangeTimes->{3.553736825294846*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"tmp2", "=", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{"-", 
         FractionBox["1", 
          RowBox[{"2", "\[Pi]", " ", "\[ImaginaryI]"}]]}], 
        FractionBox["2", "3"], 
        FractionBox[
         RowBox[{"u", "+", 
          FractionBox["\[ImaginaryI]", "2"]}], 
         SuperscriptBox[
          StyleBox["Q0",
           FontColor->RGBColor[{
              Rational[1, 2], 
              Rational[1, 2], 0}]], "+"]], 
        RowBox[{"(", 
         RowBox[{"-", 
          SubsuperscriptBox["W", "1", "+"]}], ")"}]}], "/.", 
       RowBox[{"leadweak", "[", "1", "]"}]}], "/.", "subQ0"}], "/.", 
     RowBox[{"g", "\[Rule]", "1"}]}], "/.", "subtoPolyGammas"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"int2", "=", 
  RowBox[{
   RowBox[{"NIntegrate", "[", 
    RowBox[{
     RowBox[{"tmp2", "/.", 
      RowBox[{"u", "\[Rule]", 
       RowBox[{"t", "-", 
        FractionBox["\[ImaginaryI]", "4"]}]}]}], ",", 
     RowBox[{"{", 
      RowBox[{"t", ",", 
       RowBox[{"-", "\[Infinity]"}], ",", 
       RowBox[{"+", "\[Infinity]"}]}], "}"}]}], "]"}], "//", 
   "Chop"}]}]}], "Input",
 CellChangeTimes->{{3.553736812029935*^9, 3.553736843921022*^9}, {
  3.5537368739884233`*^9, 3.553736874164377*^9}}],

Cell[BoxData[
 RowBox[{"-", "0.06037678328642483`"}]], "Output",
 CellChangeTimes->{{3.55373639335303*^9, 3.553736407995446*^9}, {
  3.553736845433095*^9, 3.553736875336076*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"tmp3", "=", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{"-", 
         FractionBox["1", 
          RowBox[{"2", "\[Pi]", " ", "\[ImaginaryI]"}]]}], 
        RowBox[{"(", 
         RowBox[{"-", 
          FractionBox["1", "9"]}], ")"}], 
        FractionBox[
         RowBox[{" ", 
          RowBox[{"\[ImaginaryI]", " ", 
           RowBox[{"(", 
            RowBox[{"1", "+", 
             RowBox[{"3", " ", 
              SuperscriptBox["u", "2"]}]}], ")"}]}]}], 
         RowBox[{" ", 
          RowBox[{
           SuperscriptBox[
            StyleBox["Q0",
             FontColor->RGBColor[{
                Rational[1, 2], 
                Rational[1, 2], 0}]], "-"], " ", 
           SuperscriptBox[
            StyleBox["Q0",
             FontColor->RGBColor[{
                Rational[1, 2], 
                Rational[1, 2], 0}]], "+"]}]}]], "W"}], "/.", 
       RowBox[{"leadweak", "[", "1", "]"}]}], "/.", "subQ0"}], "/.", 
     RowBox[{"g", "\[Rule]", "1"}]}], "/.", "subtoPolyGammas"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"int3", "=", 
  RowBox[{
   RowBox[{
    FractionBox["1", "2"], 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"NIntegrate", "[", 
       RowBox[{
        RowBox[{"tmp3", "/.", 
         RowBox[{"u", "\[Rule]", 
          RowBox[{"t", "+", 
           FractionBox["\[ImaginaryI]", "4"]}]}]}], ",", 
        RowBox[{"{", 
         RowBox[{"t", ",", 
          RowBox[{"-", "\[Infinity]"}], ",", 
          RowBox[{"+", "\[Infinity]"}]}], "}"}]}], "]"}], "+", 
      RowBox[{"NIntegrate", "[", 
       RowBox[{
        RowBox[{"tmp3", "/.", 
         RowBox[{"u", "\[Rule]", 
          RowBox[{"t", "-", 
           FractionBox["\[ImaginaryI]", "4"]}]}]}], ",", 
        RowBox[{"{", 
         RowBox[{"t", ",", 
          RowBox[{"-", "\[Infinity]"}], ",", 
          RowBox[{"+", "\[Infinity]"}]}], "}"}]}], "]"}]}], ")"}]}], "//", 
   "Chop"}]}]}], "Input",
 CellChangeTimes->{{3.553736866392997*^9, 3.5537368930344887`*^9}}],

Cell[BoxData[
 RowBox[{"-", "1.1929762349539663`"}]], "Output",
 CellChangeTimes->{3.5537369053660393`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{"-", 
        FractionBox[
         SubscriptBox["W", "1"], "3"]}], "/.", 
       RowBox[{"leadweak", "[", "1", "]"}]}], "/.", "subQ0"}], "/.", 
     RowBox[{"g", "\[Rule]", "1"}]}], "/.", "subtoPolyGammas"}], "/.", 
   RowBox[{"u", "\[Rule]", "v00"}]}], "//", "N"}]], "Input",
 CellChangeTimes->{{3.553737168715065*^9, 3.553737171841695*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"-", "0.060376783286426`"}], "+", 
  RowBox[{"0.`", " ", "\[ImaginaryI]"}]}]], "Output",
 CellChangeTimes->{3.5537371722385197`*^9}]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell["Continue with analytical derivation", "Subsubsection",
 CellChangeTimes->{{3.553736174008065*^9, 3.553736198164898*^9}, {
  3.553737189438835*^9, 3.553737195149122*^9}}],

Cell[TextData[{
 "Now we are performing computations. Integral can be shifted far enough to \
not get singularities from ",
 Cell[BoxData[
  FormBox[
   SuperscriptBox["\[ScriptCapitalC]", 
    RowBox[{"[", 
     RowBox[{"\[PlusMinus]", "0"}], "]"}]], TraditionalForm]]],
 "."
}], "Text",
 CellChangeTimes->{{3.55373137363869*^9, 3.5537314175000467`*^9}, {
  3.553736094265439*^9, 3.5537361038413363`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Log", "[", 
   RowBox[{
    RowBox[{"(", 
     FractionBox[
      RowBox[{" ", 
       StyleBox["\[ScriptCapitalT]",
        FontColor->RGBColor[1, 0, 0]], " "}], 
      StyleBox["\[GothicCapitalT]",
       FontColor->RGBColor[0.54, 0.35, 0.15]]], ")"}], "/", 
    SubscriptBox[
     RowBox[{"(", 
      FractionBox[
       RowBox[{" ", 
        StyleBox["\[ScriptCapitalT]",
         FontColor->RGBColor[1, 0, 0]], " "}], 
       StyleBox["\[GothicCapitalT]",
        FontColor->RGBColor[0.54, 0.35, 0.15]]], ")"}], "asym"]}], "]"}], "=", 
  RowBox[{
   FractionBox[
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       SuperscriptBox["\[ScriptCapitalC]", 
        RowBox[{"[", 
         RowBox[{"+", "1"}], "]"}]], "-", 
       SuperscriptBox["\[ScriptCapitalC]", 
        RowBox[{"[", 
         RowBox[{"-", "1"}], "]"}]]}], ")"}], 
     OverscriptBox["*", "^"], "\[Delta]\[Rho]"}], 
    RowBox[{
     StyleBox["\[ScriptCapitalT]",
      FontColor->RGBColor[1, 0, 0]], " "}]], "-", 
   FractionBox[
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       SuperscriptBox["\[ScriptCapitalC]", 
        RowBox[{"[", 
         RowBox[{"+", "1"}], "]"}]], "-", 
       SuperscriptBox["\[ScriptCapitalC]", 
        RowBox[{"[", 
         RowBox[{"-", "1"}], "]"}]]}], ")"}], 
     OverscriptBox["*", "^"], "\[Delta]\[Rho]2"}], "\[GothicCapitalT]"], "-", 
   
   FractionBox[
    RowBox[{
     SubscriptBox["W", "1"], "-", " ", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        SuperscriptBox["\[ScriptCapitalC]", 
         RowBox[{"[", 
          RowBox[{"+", "1"}], "]"}]], "-", 
        SuperscriptBox["\[ScriptCapitalC]", 
         RowBox[{"[", 
          RowBox[{"-", "1"}], "]"}]]}], ")"}], "*", "W"}]}], 
    "\[GothicCapitalT]"]}]}]], "Input",
 CellChangeTimes->{{3.555837085900972*^9, 3.5558371899449387`*^9}, {
  3.55583894732381*^9, 3.555838955621048*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Series", "[", 
  RowBox[{
   RowBox[{
   "RHS\[Delta]\[Rho]", "+", "RHS\[Delta]\[Rho]2", "+", "RHSCW", "+", 
    "RHSW1"}], ",", 
   RowBox[{"{", 
    RowBox[{"g", ",", "0", ",", "8"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.5558400276905727`*^9, 3.555840048056575*^9}, {
  3.555840095982913*^9, 3.555840098373447*^9}, {3.555840680544981*^9, 
  3.5558407011905107`*^9}}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       RowBox[{"-", "12"}], " ", 
       RowBox[{"M", "[", 
        SubscriptBox["\[Delta]\[Rho]2", "lead"], "]"}]}], "+", 
      RowBox[{"\[DoubleStruckCapitalC]", "[", 
       RowBox[{"-", 
        FractionBox[
         RowBox[{"4", " ", "\[ImaginaryI]", " ", 
          SubscriptBox[
           StyleBox["W",
            FontColor->RGBColor[0.54, 0.35, 0.15]], "lead"]}], 
         RowBox[{"3", " ", 
          SuperscriptBox[
           StyleBox["Q0",
            FontColor->RGBColor[{
               Rational[1, 2], 
               Rational[1, 2], 0}]], "-"], " ", 
          SuperscriptBox[
           StyleBox["Q0",
            FontColor->RGBColor[{
               Rational[1, 2], 
               Rational[1, 2], 0}]], "+"]}]]}], "]"}], "+", 
      RowBox[{"\[DoubleStruckCapitalC]", "[", 
       RowBox[{"-", 
        FractionBox[
         RowBox[{"4", " ", 
          RowBox[{"(", 
           RowBox[{"\[ImaginaryI]", "+", "u"}], ")"}], " ", 
          SubsuperscriptBox[
           StyleBox["W",
            FontColor->RGBColor[0.54, 0.35, 0.15]], 
           RowBox[{"1", ",", "lead"}], "+"]}], 
         SuperscriptBox[
          StyleBox["Q0",
           FontColor->RGBColor[{
              Rational[1, 2], 
              Rational[1, 2], 0}]], "+"]]}], "]"}]}], ")"}], " ", 
    SuperscriptBox["g", "8"]}], "+", 
   InterpretationBox[
    SuperscriptBox[
     RowBox[{"O", "[", "g", "]"}], "9"],
    SeriesData[$CellContext`g, 0, {}, 8, 9, 1],
    Editable->False]}],
  SeriesData[$CellContext`g, 0, {(-12) $CellContext`M[
       Subscript[$CellContext`\[Delta]\[Rho]2, $CellContext`lead]] + \
$CellContext`\[DoubleStruckCapitalC][Complex[0, 
        Rational[-4, 3]] $CellContext`Q0$[-1]^(-1) $CellContext`Q0$[
        1]^(-1) $CellContext`W$[$CellContext`lead][
       0]] + $CellContext`\[DoubleStruckCapitalC][(-4) (
       Complex[0, 1] + $CellContext`u) $CellContext`Q0$[
        1]^(-1) $CellContext`W$[1, $CellContext`lead][1]]}, 8, 9, 1],
  Editable->False]], "Output",
 CellChangeTimes->{3.564840723155863*^9}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Corrections from \[Delta]\[Rho]", "Subsubsection",
 CellChangeTimes->{{3.555837206729759*^9, 3.555837216895596*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     SuperscriptBox["\[ScriptCapitalC]", 
      RowBox[{"[", 
       RowBox[{"+", "1"}], "]"}]], "-", 
     SuperscriptBox["\[ScriptCapitalC]", 
      RowBox[{"[", 
       RowBox[{"-", "1"}], "]"}]]}], ")"}], 
   OverscriptBox["*", "^"], "\[Delta]\[Rho]"}], "\[Equal]", 
  RowBox[{
   SubsuperscriptBox["\[Integral]", 
    RowBox[{"-", "1"}], "1"], 
   RowBox[{
    FractionBox[
     RowBox[{"\[DifferentialD]", "w"}], "\[Pi]"], 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"-", 
       FractionBox[
        RowBox[{"2", "g"}], 
        RowBox[{"2", "\[ImaginaryI]"}]]}], 
      RowBox[{"(", 
       RowBox[{
        FractionBox["1", 
         RowBox[{"u", "+", 
          FractionBox["\[ImaginaryI]", "2"], "-", 
          RowBox[{"2", " ", "g", " ", "w"}]}]], "-", 
        FractionBox["1", 
         RowBox[{"u", "-", 
          FractionBox["\[ImaginaryI]", "2"], "-", 
          RowBox[{"2", " ", "g", " ", "w"}]}]]}], ")"}]}], ")"}], 
    OverscriptBox["*", "^"], "\[Delta]\[Rho]"}]}]}]], "Input",
 CellChangeTimes->{{3.5558372193280573`*^9, 3.555837294814817*^9}, {
  3.5558375054542017`*^9, 3.5558375096606627`*^9}, {3.5558376367610826`*^9, 
  3.555837639713213*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"Normal", "@", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       RowBox[{"Expand", "/@", 
        RowBox[{"(", 
         RowBox[{"Series", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"-", 
             FractionBox[
              RowBox[{"2", "g", " ", "w"}], 
              RowBox[{"2", "\[ImaginaryI]"}]]}], 
            RowBox[{"(", 
             RowBox[{
              FractionBox["1", 
               RowBox[{"u", "+", 
                FractionBox["\[ImaginaryI]", "2"], "-", 
                RowBox[{"2", " ", "g", " ", "w"}]}]], "-", 
              FractionBox["1", 
               RowBox[{"u", "-", 
                FractionBox["\[ImaginaryI]", "2"], "-", 
                RowBox[{"2", " ", "g", " ", "w"}]}]]}], ")"}]}], ",", 
           RowBox[{"{", 
            RowBox[{"g", ",", "0", ",", "5"}], "}"}]}], "]"}], ")"}]}], "/.", 
       
       RowBox[{
        SuperscriptBox["w", "a_."], "\[RuleDelayed]", 
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{"EvenQ", "[", "a", "]"}], ",", "0", ",", 
          SuperscriptBox["w", "a"]}], "]"}]}]}], "/.", 
      RowBox[{
       SuperscriptBox["w", "a_."], "\[RuleDelayed]", 
       RowBox[{"M", "[", 
        RowBox[{
         SuperscriptBox["w", 
          RowBox[{"a", "-", "1"}]], "\[Delta]\[Rho]"}], "]"}]}]}], ")"}]}], "/.", 
   RowBox[{"\[Delta]\[Rho]", "\[Rule]", 
    RowBox[{"Expand", "[", 
     RowBox[{
      SuperscriptBox["g", "9"], 
      RowBox[{"(", 
       RowBox[{
        SubscriptBox["\[Delta]\[Rho]", "lead"], "+", 
        RowBox[{
         SuperscriptBox["g", "2"], 
         SubscriptBox["\[Delta]\[Rho]", "sublead"]}], "+", 
        RowBox[{
         SuperscriptBox["g", "4"], 
         SubscriptBox["\[Delta]\[Rho]", "sublead2"]}]}], ")"}]}], "]"}]}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"%", "/.", 
     RowBox[{
      RowBox[{"M", "[", "a_", "]"}], "\[RuleDelayed]", 
      RowBox[{"M", "[", 
       RowBox[{"Expand", "[", "a", "]"}], "]"}]}]}], "//.", 
    RowBox[{
     RowBox[{"M", "[", 
      RowBox[{
       RowBox[{
        SuperscriptBox["g", "a_."], "b_."}], "+", "c_."}], "]"}], 
     "\[RuleDelayed]", 
     RowBox[{
      RowBox[{
       SuperscriptBox["g", "a"], 
       RowBox[{"M", "[", "b", "]"}]}], "+", 
      RowBox[{"M", "[", "c", "]"}]}]}]}], "/.", 
   RowBox[{
    RowBox[{"M", "[", "0", "]"}], "\[RuleDelayed]", "0"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"tmp1", "=", 
   RowBox[{
    RowBox[{
     RowBox[{"Series", "[", 
      RowBox[{"%", ",", 
       RowBox[{"{", 
        RowBox[{"g", ",", "0", ",", "14"}], "}"}]}], "]"}], "//", 
     "Simplify"}], "//", "Normal"}]}], ";"}]}], "Input",
 CellChangeTimes->{{3.555837382927916*^9, 3.555837461728405*^9}, {
  3.55583751361889*^9, 3.5558375904900503`*^9}, {3.555837641448226*^9, 
  3.555837705282494*^9}, {3.555837837876952*^9, 3.5558378384927893`*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"tmp2", "=", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"Series", "[", 
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{
          RowBox[{
           FractionBox["1", "\[ScriptCapitalT]"], "/.", "largevolume"}], "/.", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{
             RowBox[{"x$", "[", "1", "]"}], "\[Rule]", 
             RowBox[{"x$h", "[", "1", "]"}]}], ",", 
            RowBox[{
             RowBox[{"x$", "[", 
              RowBox[{"-", "1"}], "]"}], "\[Rule]", 
             RowBox[{"1", "/", 
              RowBox[{"x$h", "[", 
               RowBox[{"-", "1"}], "]"}]}]}]}], "}"}]}], "/.", "subJuk"}], "/.", 
        RowBox[{"leadweak", "[", "4", "]"}]}], ",", 
       RowBox[{"{", 
        RowBox[{"g", ",", "0", ",", "6"}], "}"}]}], "]"}], "//", "Together"}],
     "//", "Simplify"}], "//", "Normal"}]}]], "Input",
 CellChangeTimes->{{3.55583771466037*^9, 3.555837841278035*^9}, {
  3.555838384881381*^9, 3.555838385008992*^9}}],

Cell[BoxData[
 RowBox[{"1", "-", 
  FractionBox[
   RowBox[{"4", " ", 
    SuperscriptBox["g", "2"]}], 
   RowBox[{"1", "+", 
    RowBox[{"4", " ", 
     SuperscriptBox["u", "2"]}]}]], "+", 
  FractionBox[
   RowBox[{"4", " ", 
    SuperscriptBox["g", "4"], " ", 
    RowBox[{"(", 
     RowBox[{"11", "-", 
      RowBox[{"8", " ", 
       SuperscriptBox["u", "2"]}], "+", 
      RowBox[{"48", " ", 
       SuperscriptBox["u", "4"]}]}], ")"}]}], 
   SuperscriptBox[
    RowBox[{"(", 
     RowBox[{"1", "+", 
      RowBox[{"4", " ", 
       SuperscriptBox["u", "2"]}]}], ")"}], "3"]], "-", 
  FractionBox[
   RowBox[{"4", " ", 
    SuperscriptBox["g", "6"], " ", 
    RowBox[{"(", 
     RowBox[{"137", "-", 
      RowBox[{"832", " ", 
       SuperscriptBox["u", "2"]}], "+", 
      RowBox[{"3488", " ", 
       SuperscriptBox["u", "4"]}], "+", 
      RowBox[{"4608", " ", 
       SuperscriptBox["u", "6"]}], "+", 
      RowBox[{"5376", " ", 
       SuperscriptBox["u", "8"]}]}], ")"}]}], 
   SuperscriptBox[
    RowBox[{"(", 
     RowBox[{"1", "+", 
      RowBox[{"4", " ", 
       SuperscriptBox["u", "2"]}]}], ")"}], "5"]]}]], "Output",
 CellChangeTimes->{{3.5558377375278587`*^9, 3.5558377575297832`*^9}, {
   3.555837809905575*^9, 3.5558378417192287`*^9}, {3.5558383903705673`*^9, 
   3.555838419820189*^9}, 3.555839942956214*^9, {3.5558554210437317`*^9, 
   3.555855444953557*^9}, 3.564840663091367*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"Series", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"(", 
       FractionBox[
        RowBox[{"2", "u"}], 
        RowBox[{
         RowBox[{"4", 
          SuperscriptBox["g", "2"], 
          SuperscriptBox["z", "2"]}], "-", 
         SuperscriptBox["u", "2"]}]], ")"}], 
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         RowBox[{
          RowBox[{"-", "2"}], " ", "tmp1", " ", "tmp2"}], "/.", 
         RowBox[{"Shift", "[", "1", "]"}]}], "/.", 
        RowBox[{"u", "\[Rule]", 
         RowBox[{"u", "+", 
          FractionBox["\[ImaginaryI]", "2"]}]}]}], ")"}]}], ",", 
     RowBox[{"{", 
      RowBox[{"g", ",", "0", ",", "13"}], "}"}]}], "]"}], "//", "Simplify"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"RHS\[Delta]\[Rho]", "=", 
  RowBox[{"Collect", "[", 
   RowBox[{
    RowBox[{"Normal", "[", "%", "]"}], ",", "g", ",", 
    RowBox[{
     RowBox[{"Integrate", "[", 
      RowBox[{
       FractionBox[
        RowBox[{"#", "/.", 
         RowBox[{"u", "\[Rule]", 
          RowBox[{"t", "-", 
           FractionBox["\[ImaginaryI]", "4"]}]}]}], 
        RowBox[{
         RowBox[{"-", "2"}], "\[Pi]", " ", "\[ImaginaryI]"}]], ",", 
       RowBox[{"{", 
        RowBox[{"t", ",", 
         RowBox[{"-", "\[Infinity]"}], ",", 
         RowBox[{"+", "\[Infinity]"}]}], "}"}]}], "]"}], "&"}]}], 
   "]"}]}]}], "Input",
 CellChangeTimes->{{3.5558378762908573`*^9, 3.555837921054811*^9}, {
  3.5558379528026333`*^9, 3.555838088924897*^9}, {3.555839930855537*^9, 
  3.555839938763672*^9}, {3.555855452094685*^9, 3.555855470697173*^9}, {
  3.555855515980336*^9, 3.555855516539888*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"-", "4"}], " ", 
   SuperscriptBox["g", "10"], " ", 
   RowBox[{"M", "[", 
    SubscriptBox["\[Delta]\[Rho]", "lead"], "]"}]}], "-", 
  RowBox[{"4", " ", 
   SuperscriptBox["g", "12"], " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{
      RowBox[{"-", 
       RowBox[{"(", 
        RowBox[{"3", "+", 
         RowBox[{"4", " ", 
          SuperscriptBox["z", "2"]}]}], ")"}]}], " ", 
      RowBox[{"M", "[", 
       SubscriptBox["\[Delta]\[Rho]", "lead"], "]"}]}], "-", 
     RowBox[{"4", " ", 
      RowBox[{"M", "[", 
       RowBox[{
        SuperscriptBox["w", "2"], " ", 
        SubscriptBox["\[Delta]\[Rho]", "lead"]}], "]"}]}], "+", 
     RowBox[{"M", "[", 
      SubscriptBox["\[Delta]\[Rho]", "sublead"], "]"}]}], ")"}]}]}]], "Output",\

 CellChangeTimes->{{3.5558379162169037`*^9, 3.555837921558806*^9}, {
   3.5558379835940123`*^9, 3.555838089666821*^9}, {3.555838401405355*^9, 
   3.555838421519259*^9}, 3.555839944911174*^9, {3.5558555024651117`*^9, 
   3.5558555174339523`*^9}, 3.564840665929504*^9}]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell["Corrections from \[Delta]\[Rho]2", "Subsubsection",
 CellChangeTimes->{{3.555837206729759*^9, 3.555837216895596*^9}, 
   3.55583818624183*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     SuperscriptBox["\[ScriptCapitalC]", 
      RowBox[{"[", 
       RowBox[{"+", "1"}], "]"}]], "-", 
     SuperscriptBox["\[ScriptCapitalC]", 
      RowBox[{"[", 
       RowBox[{"-", "1"}], "]"}]]}], ")"}], 
   OverscriptBox["*", "^"], "\[Delta]\[Rho]2"}], "\[Equal]", 
  RowBox[{
   SubsuperscriptBox["\[Integral]", 
    RowBox[{"-", "1"}], "1"], 
   RowBox[{
    FractionBox[
     RowBox[{"\[DifferentialD]", "w"}], "\[Pi]"], 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"-", 
       FractionBox[
        RowBox[{"2", "g"}], 
        RowBox[{"2", "\[ImaginaryI]"}]]}], 
      RowBox[{"(", 
       RowBox[{
        FractionBox["1", 
         RowBox[{"u", "+", 
          FractionBox["\[ImaginaryI]", "2"], "-", 
          RowBox[{"2", " ", "g", " ", "w"}]}]], "-", 
        FractionBox["1", 
         RowBox[{"u", "-", 
          FractionBox["\[ImaginaryI]", "2"], "-", 
          RowBox[{"2", " ", "g", " ", "w"}]}]]}], ")"}]}], ")"}], 
    OverscriptBox["*", "^"], "\[Delta]\[Rho]2"}]}]}]], "Input",
 CellChangeTimes->{{3.5558372193280573`*^9, 3.555837294814817*^9}, {
  3.5558375054542017`*^9, 3.5558375096606627`*^9}, {3.5558376367610826`*^9, 
  3.555837639713213*^9}, {3.555838194840076*^9, 3.5558381960557632`*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"Normal", "@", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       RowBox[{"Expand", "/@", 
        RowBox[{"(", 
         RowBox[{"Series", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"-", 
             FractionBox[
              RowBox[{"2", "g", " ", "w"}], 
              RowBox[{"2", "\[ImaginaryI]"}]]}], 
            RowBox[{"(", 
             RowBox[{
              FractionBox["1", 
               RowBox[{"u", "+", 
                FractionBox["\[ImaginaryI]", "2"], "-", 
                RowBox[{"2", " ", "g", " ", "w"}]}]], "-", 
              FractionBox["1", 
               RowBox[{"u", "-", 
                FractionBox["\[ImaginaryI]", "2"], "-", 
                RowBox[{"2", " ", "g", " ", "w"}]}]]}], ")"}]}], ",", 
           RowBox[{"{", 
            RowBox[{"g", ",", "0", ",", "5"}], "}"}]}], "]"}], ")"}]}], "/.", 
       
       RowBox[{
        SuperscriptBox["w", "a_."], "\[RuleDelayed]", 
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{"EvenQ", "[", "a", "]"}], ",", "0", ",", 
          SuperscriptBox["w", "a"]}], "]"}]}]}], "/.", 
      RowBox[{
       SuperscriptBox["w", "a_."], "\[RuleDelayed]", 
       RowBox[{"M", "[", 
        RowBox[{
         SuperscriptBox["w", 
          RowBox[{"a", "-", "1"}]], "\[Delta]\[Rho]2"}], "]"}]}]}], ")"}]}], "/.", 
   RowBox[{"\[Delta]\[Rho]2", "\[Rule]", 
    RowBox[{"Expand", "[", 
     RowBox[{
      SuperscriptBox["g", "7"], 
      RowBox[{"(", 
       RowBox[{
        SubscriptBox["\[Delta]\[Rho]2", "lead"], "+", 
        RowBox[{
         SuperscriptBox["g", "2"], 
         SubscriptBox["\[Delta]\[Rho]2", "sublead"]}], "+", 
        RowBox[{
         SuperscriptBox["g", "4"], 
         SubscriptBox["\[Delta]\[Rho]2", "sublead2"]}]}], ")"}]}], "]"}]}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"%", "/.", 
     RowBox[{
      RowBox[{"M", "[", "a_", "]"}], "\[RuleDelayed]", 
      RowBox[{"M", "[", 
       RowBox[{"Expand", "[", "a", "]"}], "]"}]}]}], "//.", 
    RowBox[{
     RowBox[{"M", "[", 
      RowBox[{
       RowBox[{
        SuperscriptBox["g", "a_."], "b_."}], "+", "c_."}], "]"}], 
     "\[RuleDelayed]", 
     RowBox[{
      RowBox[{
       SuperscriptBox["g", "a"], 
       RowBox[{"M", "[", "b", "]"}]}], "+", 
      RowBox[{"M", "[", "c", "]"}]}]}]}], "/.", 
   RowBox[{
    RowBox[{"M", "[", "0", "]"}], "\[RuleDelayed]", "0"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"tmp1", "=", 
   RowBox[{
    RowBox[{
     RowBox[{"Series", "[", 
      RowBox[{"%", ",", 
       RowBox[{"{", 
        RowBox[{"g", ",", "0", ",", "12"}], "}"}]}], "]"}], "//", 
     "Simplify"}], "//", "Normal"}]}], ";"}]}], "Input",
 CellChangeTimes->{{3.555837382927916*^9, 3.555837461728405*^9}, {
  3.55583751361889*^9, 3.5558375904900503`*^9}, {3.555837641448226*^9, 
  3.555837705282494*^9}, {3.555837837876952*^9, 3.5558378384927893`*^9}, {
  3.555838212472659*^9, 3.5558382596250877`*^9}}],

Cell[CellGroupData[{

Cell[BoxData["tmp1"], "Input",
 CellChangeTimes->{{3.555838556200193*^9, 3.555838556548091*^9}}],

Cell[BoxData[
 RowBox[{
  FractionBox[
   RowBox[{"4", " ", 
    SuperscriptBox["g", "8"], " ", 
    RowBox[{"M", "[", 
     SubscriptBox["\[Delta]\[Rho]2", "lead"], "]"}]}], 
   RowBox[{"1", "+", 
    RowBox[{"4", " ", 
     SuperscriptBox["u", "2"]}]}]], "+", 
  FractionBox[
   RowBox[{"4", " ", 
    SuperscriptBox["g", "10"], " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"16", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", "1"}], "+", 
         RowBox[{"12", " ", 
          SuperscriptBox["u", "2"]}]}], ")"}], " ", 
       RowBox[{"M", "[", 
        RowBox[{
         SuperscriptBox["w", "2"], " ", 
         SubscriptBox["\[Delta]\[Rho]2", "lead"]}], "]"}]}], "+", 
      RowBox[{
       SuperscriptBox[
        RowBox[{"(", 
         RowBox[{"1", "+", 
          RowBox[{"4", " ", 
           SuperscriptBox["u", "2"]}]}], ")"}], "2"], " ", 
       RowBox[{"M", "[", 
        SubscriptBox["\[Delta]\[Rho]2", "sublead"], "]"}]}]}], ")"}]}], 
   SuperscriptBox[
    RowBox[{"(", 
     RowBox[{"1", "+", 
      RowBox[{"4", " ", 
       SuperscriptBox["u", "2"]}]}], ")"}], "3"]], "+", 
  RowBox[{
   FractionBox["1", 
    SuperscriptBox[
     RowBox[{"(", 
      RowBox[{"1", "+", 
       RowBox[{"4", " ", 
        SuperscriptBox["u", "2"]}]}], ")"}], "5"]], 
   RowBox[{"4", " ", 
    SuperscriptBox["g", "12"], " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"256", " ", 
       RowBox[{"(", 
        RowBox[{"1", "-", 
         RowBox[{"40", " ", 
          SuperscriptBox["u", "2"]}], "+", 
         RowBox[{"80", " ", 
          SuperscriptBox["u", "4"]}]}], ")"}], " ", 
       RowBox[{"M", "[", 
        RowBox[{
         SuperscriptBox["w", "4"], " ", 
         SubscriptBox["\[Delta]\[Rho]2", "lead"]}], "]"}]}], "+", 
      RowBox[{
       SuperscriptBox[
        RowBox[{"(", 
         RowBox[{"1", "+", 
          RowBox[{"4", " ", 
           SuperscriptBox["u", "2"]}]}], ")"}], "2"], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"16", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"-", "1"}], "+", 
            RowBox[{"12", " ", 
             SuperscriptBox["u", "2"]}]}], ")"}], " ", 
          RowBox[{"M", "[", 
           RowBox[{
            SuperscriptBox["w", "2"], " ", 
            SubscriptBox["\[Delta]\[Rho]2", "sublead"]}], "]"}]}], "+", 
         RowBox[{
          SuperscriptBox[
           RowBox[{"(", 
            RowBox[{"1", "+", 
             RowBox[{"4", " ", 
              SuperscriptBox["u", "2"]}]}], ")"}], "2"], " ", 
          RowBox[{"M", "[", 
           SubscriptBox["\[Delta]\[Rho]2", "sublead2"], "]"}]}]}], ")"}]}]}], 
     ")"}]}]}]}]], "Output",
 CellChangeTimes->{3.5558385568295717`*^9, 3.555839957741901*^9, 
  3.564840681931017*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"tmp2", "=", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"Series", "[", 
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{
          RowBox[{
           RowBox[{"1", "/", "\[GothicCapitalT]"}], "/.", "largevolume"}], "/.", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{
             RowBox[{"x$", "[", "1", "]"}], "\[Rule]", 
             RowBox[{"x$h", "[", "1", "]"}]}], ",", 
            RowBox[{
             RowBox[{"x$", "[", 
              RowBox[{"-", "1"}], "]"}], "\[Rule]", 
             RowBox[{"1", "/", 
              RowBox[{"x$h", "[", 
               RowBox[{"-", "1"}], "]"}]}]}]}], "}"}]}], "/.", "subJuk"}], "/.", 
        RowBox[{"leadweak", "[", "4", "]"}]}], ",", 
       RowBox[{"{", 
        RowBox[{"g", ",", "0", ",", "6"}], "}"}]}], "]"}], "//", "Together"}],
     "//", "Simplify"}], "//", "Normal"}]}]], "Input",
 CellChangeTimes->{{3.55583771466037*^9, 3.555837841278035*^9}, {
  3.555838275626243*^9, 3.555838276557899*^9}, {3.555838309204073*^9, 
  3.5558383093468437`*^9}, {3.555838367127324*^9, 3.5558383732244864`*^9}}],

Cell[BoxData[
 RowBox[{
  FractionBox[
   RowBox[{"192", " ", 
    SuperscriptBox["g", "2"], " ", 
    SuperscriptBox["u", "2"], " ", 
    RowBox[{"(", 
     RowBox[{"5", "+", 
      RowBox[{"4", " ", 
       SuperscriptBox["u", "2"]}]}], ")"}]}], 
   RowBox[{
    SuperscriptBox[
     RowBox[{"(", 
      RowBox[{"1", "-", 
       RowBox[{"12", " ", 
        SuperscriptBox["u", "2"]}]}], ")"}], "2"], " ", 
    RowBox[{"(", 
     RowBox[{"1", "+", 
      RowBox[{"4", " ", 
       SuperscriptBox["u", "2"]}]}], ")"}]}]], "+", 
  FractionBox[
   RowBox[{"3", " ", 
    RowBox[{"(", 
     RowBox[{"1", "+", 
      RowBox[{"4", " ", 
       SuperscriptBox["u", "2"]}]}], ")"}]}], 
   RowBox[{
    RowBox[{"-", "1"}], "+", 
    RowBox[{"12", " ", 
     SuperscriptBox["u", "2"]}]}]], "-", 
  FractionBox[
   RowBox[{"48", " ", 
    SuperscriptBox["g", "4"], " ", 
    RowBox[{"(", 
     RowBox[{"1", "-", 
      RowBox[{"364", " ", 
       SuperscriptBox["u", "2"]}], "-", 
      RowBox[{"1504", " ", 
       SuperscriptBox["u", "4"]}], "-", 
      RowBox[{"18304", " ", 
       SuperscriptBox["u", "6"]}], "-", 
      RowBox[{"4864", " ", 
       SuperscriptBox["u", "8"]}], "+", 
      RowBox[{"9216", " ", 
       SuperscriptBox["u", "10"]}]}], ")"}]}], 
   SuperscriptBox[
    RowBox[{"(", 
     RowBox[{
      RowBox[{"-", "1"}], "+", 
      RowBox[{"8", " ", 
       SuperscriptBox["u", "2"]}], "+", 
      RowBox[{"48", " ", 
       SuperscriptBox["u", "4"]}]}], ")"}], "3"]], "+", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{"12", " ", 
     SuperscriptBox["g", "6"], " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"-", "69"}], "+", 
       RowBox[{"23872", " ", 
        SuperscriptBox["u", "2"]}], "+", 
       RowBox[{"24", " ", 
        SubscriptBox[
         StyleBox["\[Zeta]",
          FontWeight->Bold,
          FontColor->GrayLevel[0.4]], "3"]}], "+", 
       RowBox[{"18874368", " ", 
        SuperscriptBox["u", "14"], " ", 
        RowBox[{"(", 
         RowBox[{"1", "+", 
          SubscriptBox[
           StyleBox["\[Zeta]",
            FontWeight->Bold,
            FontColor->GrayLevel[0.4]], "3"]}], ")"}]}], "-", 
       RowBox[{"6144", " ", 
        SuperscriptBox["u", "6"], " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"-", "787"}], "+", 
          RowBox[{"4", " ", 
           SubscriptBox[
            StyleBox["\[Zeta]",
             FontWeight->Bold,
             FontColor->GrayLevel[0.4]], "3"]}]}], ")"}]}], "-", 
       RowBox[{"576", " ", 
        SuperscriptBox["u", "4"], " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"-", "227"}], "+", 
          RowBox[{"8", " ", 
           SubscriptBox[
            StyleBox["\[Zeta]",
             FontWeight->Bold,
             FontColor->GrayLevel[0.4]], "3"]}]}], ")"}]}], "+", 
       RowBox[{"1769472", " ", 
        SuperscriptBox["u", "16"], " ", 
        RowBox[{"(", 
         RowBox[{"25", "+", 
          RowBox[{"8", " ", 
           SubscriptBox[
            StyleBox["\[Zeta]",
             FontWeight->Bold,
             FontColor->GrayLevel[0.4]], "3"]}]}], ")"}]}], "+", 
       RowBox[{"49152", " ", 
        SuperscriptBox["u", "10"], " ", 
        RowBox[{"(", 
         RowBox[{"1123", "+", 
          RowBox[{"48", " ", 
           SubscriptBox[
            StyleBox["\[Zeta]",
             FontWeight->Bold,
             FontColor->GrayLevel[0.4]], "3"]}]}], ")"}]}], "+", 
       RowBox[{"81920", " ", 
        SuperscriptBox["u", "12"], " ", 
        RowBox[{"(", 
         RowBox[{"251", "+", 
          RowBox[{"120", " ", 
           SubscriptBox[
            StyleBox["\[Zeta]",
             FontWeight->Bold,
             FontColor->GrayLevel[0.4]], "3"]}]}], ")"}]}], "+", 
       RowBox[{"512", " ", 
        SuperscriptBox["u", "8"], " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"-", "4147"}], "+", 
          RowBox[{"360", " ", 
           SubscriptBox[
            StyleBox["\[Zeta]",
             FontWeight->Bold,
             FontColor->GrayLevel[0.4]], "3"]}]}], ")"}]}]}], ")"}]}], ")"}], 
   "/", 
   RowBox[{"(", 
    RowBox[{
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{"1", "-", 
        RowBox[{"12", " ", 
         SuperscriptBox["u", "2"]}]}], ")"}], "4"], " ", 
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{"1", "+", 
        RowBox[{"4", " ", 
         SuperscriptBox["u", "2"]}]}], ")"}], "5"]}], ")"}]}]}]], "Output",
 CellChangeTimes->{{3.555838344656487*^9, 3.5558383737123737`*^9}, {
   3.5558384339508944`*^9, 3.555838454938746*^9}, 3.5558385347465773`*^9, 
   3.5558399606130047`*^9, 3.564840685488192*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"Series", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"(", 
       FractionBox[
        RowBox[{"2", "u"}], 
        RowBox[{
         RowBox[{"4", 
          SuperscriptBox["g", "2"], 
          SuperscriptBox["z", "2"]}], "-", 
         SuperscriptBox["u", "2"]}]], ")"}], 
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         RowBox[{"+", "2"}], " ", "tmp1", " ", "tmp2"}], "/.", 
        RowBox[{"u", "\[Rule]", 
         RowBox[{"u", "+", 
          FractionBox["\[ImaginaryI]", "2"]}]}]}], ")"}]}], ",", 
     RowBox[{"{", 
      RowBox[{"g", ",", "0", ",", "12"}], "}"}]}], "]"}], "//", "Simplify"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"RHS\[Delta]\[Rho]2", "=", 
  RowBox[{"Collect", "[", 
   RowBox[{
    RowBox[{"Normal", "[", "%", "]"}], ",", "g", ",", 
    RowBox[{
     RowBox[{"Simplify", "[", 
      RowBox[{"Integrate", "[", 
       RowBox[{
        FractionBox[
         RowBox[{"#", "/.", 
          RowBox[{"u", "\[Rule]", 
           RowBox[{"t", "-", 
            FractionBox["\[ImaginaryI]", "4"]}]}]}], 
         RowBox[{
          RowBox[{"-", "2"}], "\[Pi]", " ", "\[ImaginaryI]"}]], ",", 
        RowBox[{"{", 
         RowBox[{"t", ",", 
          RowBox[{"-", "\[Infinity]"}], ",", 
          RowBox[{"+", "\[Infinity]"}]}], "}"}]}], "]"}], "]"}], "&"}]}], 
   "]"}]}]}], "Input",
 CellChangeTimes->{{3.5558378762908573`*^9, 3.555837921054811*^9}, {
  3.5558379528026333`*^9, 3.555838088924897*^9}, {3.555838444018227*^9, 
  3.555838450362361*^9}, {3.555838696267303*^9, 3.5558386990641813`*^9}, {
  3.555839966988792*^9, 3.5558399777631063`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"-", "12"}], " ", 
   SuperscriptBox["g", "8"], " ", 
   RowBox[{"M", "[", 
    SubscriptBox["\[Delta]\[Rho]2", "lead"], "]"}]}], "+", 
  RowBox[{"12", " ", 
   SuperscriptBox["g", "10"], " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "11"}], "+", 
        RowBox[{"24", " ", 
         SuperscriptBox["z", "2"]}]}], ")"}], " ", 
      RowBox[{"M", "[", 
       SubscriptBox["\[Delta]\[Rho]2", "lead"], "]"}]}], "+", 
     RowBox[{"12", " ", 
      RowBox[{"M", "[", 
       RowBox[{
        SuperscriptBox["w", "2"], " ", 
        SubscriptBox["\[Delta]\[Rho]2", "lead"]}], "]"}]}], "-", 
     RowBox[{"M", "[", 
      SubscriptBox["\[Delta]\[Rho]2", "sublead"], "]"}]}], ")"}]}], "-", 
  RowBox[{"12", " ", 
   SuperscriptBox["g", "12"], " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"4", " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "27"}], "+", 
        RowBox[{"22", " ", 
         SuperscriptBox["z", "2"]}], "+", 
        RowBox[{"36", " ", 
         SuperscriptBox["z", "4"]}]}], ")"}], " ", 
      RowBox[{"M", "[", 
       SubscriptBox["\[Delta]\[Rho]2", "lead"], "]"}]}], "+", 
     RowBox[{"20", " ", 
      RowBox[{"(", 
       RowBox[{"5", "+", 
        RowBox[{"4", " ", 
         SuperscriptBox["z", "2"]}]}], ")"}], " ", 
      RowBox[{"M", "[", 
       RowBox[{
        SuperscriptBox["w", "2"], " ", 
        SubscriptBox["\[Delta]\[Rho]2", "lead"]}], "]"}]}], "+", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"11", "-", 
        RowBox[{"24", " ", 
         SuperscriptBox["z", "2"]}]}], ")"}], " ", 
      RowBox[{"M", "[", 
       SubscriptBox["\[Delta]\[Rho]2", "sublead"], "]"}]}], "-", 
     RowBox[{"12", " ", 
      RowBox[{"M", "[", 
       RowBox[{
        SuperscriptBox["w", "2"], " ", 
        SubscriptBox["\[Delta]\[Rho]2", "sublead"]}], "]"}]}], "+", 
     RowBox[{"M", "[", 
      SubscriptBox["\[Delta]\[Rho]2", "sublead2"], "]"}]}], 
    ")"}]}]}]], "Output",
 CellChangeTimes->{{3.5558379162169037`*^9, 3.555837921558806*^9}, {
   3.5558379835940123`*^9, 3.555838089666821*^9}, 3.555838463603054*^9, 
   3.55583854714893*^9, 3.555838700602582*^9, 3.555839982781868*^9, 
   3.564840691398312*^9}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[{
 "Correction from ",
 Cell[BoxData[
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     SuperscriptBox["\[ScriptCapitalC]", 
      RowBox[{"[", 
       RowBox[{"+", "1"}], "]"}]], "-", 
     SuperscriptBox["\[ScriptCapitalC]", 
      RowBox[{"[", 
       RowBox[{"-", "1"}], "]"}]]}], ")"}], "*", "W"}]],
  CellChangeTimes->{{3.555837085900972*^9, 3.5558371899449387`*^9}}]
}], "Subsubsection",
 CellChangeTimes->{{3.555838758322815*^9, 3.5558387651001787`*^9}}],

Cell["\<\
We will keep integral integration, while external integration can be done \
explicitly\
\>", "Text",
 CellChangeTimes->{{3.555838778019924*^9, 3.5558387922328787`*^9}}],

Cell[TextData[{
 "Integrand of ",
 Cell[BoxData[
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     SuperscriptBox["\[ScriptCapitalC]", 
      RowBox[{"[", 
       RowBox[{"+", "1"}], "]"}]], "-", 
     SuperscriptBox["\[ScriptCapitalC]", 
      RowBox[{"[", 
       RowBox[{"-", "1"}], "]"}]]}], ")"}], "*", "W"}]],
  CellChangeTimes->{{3.555837085900972*^9, 3.5558371899449387`*^9}}],
 " is"
}], "Text",
 CellChangeTimes->{{3.5558387987534103`*^9, 3.555838801928687*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"tmp1", "=", 
   RowBox[{
    RowBox[{
     FractionBox["1", "2"], 
     RowBox[{"(", 
      RowBox[{
       FractionBox["1", 
        RowBox[{"u", "-", "v", "+", 
         FractionBox["\[ImaginaryI]", "2"]}]], "-", 
       FractionBox["1", 
        RowBox[{"u", "-", "v", "-", 
         FractionBox["\[ImaginaryI]", "2"]}]], "+", 
       FractionBox["1", 
        RowBox[{"u", "+", "v", "+", 
         FractionBox["\[ImaginaryI]", "2"]}]], "-", 
       FractionBox["1", 
        RowBox[{"u", "+", "v", "-", 
         FractionBox["\[ImaginaryI]", "2"]}]]}], ")"}]}], "//", 
    "Simplify"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"tmp2", "=", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"Series", "[", 
       RowBox[{
        RowBox[{
         RowBox[{
          RowBox[{
           RowBox[{
            RowBox[{"1", "/", "\[GothicCapitalT]"}], "/.", "largevolume"}], "/.", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{
              RowBox[{"x$", "[", "1", "]"}], "\[Rule]", 
              RowBox[{"x$h", "[", "1", "]"}]}], ",", 
             RowBox[{
              RowBox[{"x$", "[", 
               RowBox[{"-", "1"}], "]"}], "\[Rule]", 
              RowBox[{"1", "/", 
               RowBox[{"x$h", "[", 
                RowBox[{"-", "1"}], "]"}]}]}]}], "}"}]}], "/.", "subJuk"}], "/.", 
         RowBox[{"leadweak", "[", "4", "]"}]}], ",", 
        RowBox[{"{", 
         RowBox[{"g", ",", "0", ",", "6"}], "}"}]}], "]"}], "//", 
      "Together"}], "//", "Simplify"}], "//", "Normal"}]}], ";"}]}], "Input",
 CellChangeTimes->{{3.555838804724347*^9, 3.555838898122136*^9}}],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"toint", "=", 
   RowBox[{"Series", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"(", 
       FractionBox[
        RowBox[{"2", "u"}], 
        RowBox[{
         RowBox[{"4", 
          SuperscriptBox["g", "2"], 
          SuperscriptBox["z", "2"]}], "-", 
         SuperscriptBox["u", "2"]}]], ")"}], 
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         RowBox[{"-", "2"}], " ", "tmp1", " ", "tmp2"}], "/.", 
        RowBox[{"u", "\[Rule]", 
         RowBox[{"u", "+", 
          FractionBox["\[ImaginaryI]", "2"]}]}]}], ")"}]}], ",", 
     RowBox[{"{", 
      RowBox[{"g", ",", "0", ",", "4"}], "}"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"preanswer", "=", 
  RowBox[{
   RowBox[{"Collect", "[", 
    RowBox[{
     RowBox[{"Normal", "[", "%", "]"}], ",", "g", ",", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         RowBox[{"Integrate", "[", 
          RowBox[{
           RowBox[{
            FractionBox["#", 
             RowBox[{
              RowBox[{"-", "2"}], "\[Pi]", " ", "\[ImaginaryI]"}]], "/.", 
            RowBox[{"u", "\[Rule]", 
             RowBox[{"t", "-", 
              FractionBox["\[ImaginaryI]", "4"]}]}]}], ",", 
           RowBox[{"{", 
            RowBox[{"t", ",", 
             RowBox[{"-", "\[Infinity]"}], ",", 
             RowBox[{"+", "\[Infinity]"}]}], "}"}], ",", 
           RowBox[{"Assumptions", "\[Rule]", 
            RowBox[{"v", "\[Element]", "Reals"}]}]}], "]"}], "/.", 
         RowBox[{"v", "\[Rule]", "u"}]}], "//", "Simplify"}], ")"}], "&"}]}], 
    "]"}], "/.", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{
      RowBox[{"1", "+", 
       RowBox[{"3", " ", 
        SuperscriptBox["u", "2"]}], "+", 
       RowBox[{"9", " ", 
        SuperscriptBox["u", "4"]}]}], "->", 
      RowBox[{"9", 
       SuperscriptBox["Q0", "+"], 
       SuperscriptBox["Q0", "-"]}]}], ",", 
     RowBox[{
      RowBox[{"1", "+", 
       RowBox[{"4", " ", 
        SuperscriptBox["u", "2"]}], "+", 
       RowBox[{"12", " ", 
        SuperscriptBox["u", "4"]}], "+", 
       RowBox[{"9", " ", 
        SuperscriptBox["u", "6"]}]}], "\[Rule]", 
      RowBox[{"9", 
       RowBox[{"(", 
        RowBox[{"1", "+", 
         SuperscriptBox["u", "2"]}], ")"}], 
       SuperscriptBox["Q0", "+"], 
       SuperscriptBox["Q0", "-"]}]}]}], "}"}]}]}]}], "Input",
 CellChangeTimes->{{3.5558389185087137`*^9, 3.555839057490868*^9}, {
  3.555839120634943*^9, 3.555839150922764*^9}, {3.5558392568268957`*^9, 
  3.555839268381015*^9}, {3.555839304309492*^9, 3.5558393056873703`*^9}, {
  3.555839486204103*^9, 3.555839487662043*^9}, {3.5558395785926313`*^9, 
  3.555839590938753*^9}, {3.555839800958441*^9, 3.5558398149756947`*^9}, {
  3.555840191382918*^9, 3.555840200837332*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"-", 
   FractionBox[
    RowBox[{"4", " ", "\[ImaginaryI]"}], 
    RowBox[{"3", " ", 
     SuperscriptBox[
      StyleBox["Q0",
       FontColor->RGBColor[{
          Rational[1, 2], 
          Rational[1, 2], 0}]], "-"], " ", 
     SuperscriptBox[
      StyleBox["Q0",
       FontColor->RGBColor[{
          Rational[1, 2], 
          Rational[1, 2], 0}]], "+"]}]]}], "-", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{"4", " ", "\[ImaginaryI]", " ", 
     SuperscriptBox["g", "2"], " ", 
     RowBox[{"(", 
      RowBox[{"11", "+", 
       RowBox[{"113", " ", 
        SuperscriptBox["u", "2"]}], "+", 
       RowBox[{"434", " ", 
        SuperscriptBox["u", "4"]}], "+", 
       RowBox[{"729", " ", 
        SuperscriptBox["u", "6"]}], "+", 
       RowBox[{"819", " ", 
        SuperscriptBox["u", "8"]}], "+", 
       RowBox[{"324", " ", 
        SuperscriptBox["u", "10"]}], "-", 
       RowBox[{"36", " ", 
        RowBox[{"(", 
         RowBox[{"6", "+", 
          RowBox[{"25", " ", 
           SuperscriptBox["u", "2"]}], "+", 
          RowBox[{"51", " ", 
           SuperscriptBox["u", "4"]}], "+", 
          RowBox[{"18", " ", 
           SuperscriptBox["u", "6"]}]}], ")"}], " ", 
        SuperscriptBox["z", "2"], " ", 
        SuperscriptBox[
         StyleBox["Q0",
          FontColor->RGBColor[{
             Rational[1, 2], 
             Rational[1, 2], 0}]], "-"], " ", 
        SuperscriptBox[
         StyleBox["Q0",
          FontColor->RGBColor[{
             Rational[1, 2], 
             Rational[1, 2], 0}]], "+"]}]}], ")"}]}], ")"}], "/", 
   RowBox[{"(", 
    RowBox[{"27", " ", 
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{"1", "+", 
        SuperscriptBox["u", "2"]}], ")"}], "2"], " ", 
     SuperscriptBox[
      RowBox[{"(", 
       SuperscriptBox[
        StyleBox["Q0",
         FontColor->RGBColor[{
            Rational[1, 2], 
            Rational[1, 2], 0}]], "-"], ")"}], "2"], " ", 
     SuperscriptBox[
      RowBox[{"(", 
       SuperscriptBox[
        StyleBox["Q0",
         FontColor->RGBColor[{
            Rational[1, 2], 
            Rational[1, 2], 0}]], "+"], ")"}], "2"]}], ")"}]}], "+", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{"4", " ", "\[ImaginaryI]", " ", 
     SuperscriptBox["g", "4"], " ", 
     RowBox[{"(", 
      RowBox[{"108", "+", 
       RowBox[{"1142", " ", 
        SuperscriptBox["u", "2"]}], "+", 
       RowBox[{"4615", " ", 
        SuperscriptBox["u", "4"]}], "+", 
       RowBox[{"10277", " ", 
        SuperscriptBox["u", "6"]}], "+", 
       RowBox[{"24092", " ", 
        SuperscriptBox["u", "8"]}], "+", 
       RowBox[{"59418", " ", 
        SuperscriptBox["u", "10"]}], "+", 
       RowBox[{"107406", " ", 
        SuperscriptBox["u", "12"]}], "+", 
       RowBox[{"111726", " ", 
        SuperscriptBox["u", "14"]}], "+", 
       RowBox[{"64395", " ", 
        SuperscriptBox["u", "16"]}], "+", 
       RowBox[{"15309", " ", 
        SuperscriptBox["u", "18"]}], "-", 
       RowBox[{"36", " ", 
        RowBox[{"(", 
         RowBox[{"22", "+", 
          RowBox[{
           SuperscriptBox["u", "2"], " ", 
           RowBox[{"(", 
            RowBox[{"56", "+", 
             RowBox[{
              SuperscriptBox["u", "2"], " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"-", "376"}], "+", 
                RowBox[{"3", " ", 
                 SuperscriptBox["u", "2"], " ", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"-", "577"}], "-", 
                   RowBox[{"1081", " ", 
                    SuperscriptBox["u", "2"]}], "-", 
                   RowBox[{"600", " ", 
                    SuperscriptBox["u", "4"]}], "-", 
                   RowBox[{"63", " ", 
                    SuperscriptBox["u", "6"]}], "+", 
                   RowBox[{"27", " ", 
                    SuperscriptBox["u", "8"]}]}], ")"}]}]}], ")"}]}]}], 
            ")"}]}]}], ")"}], " ", 
        SuperscriptBox["z", "2"], " ", 
        SuperscriptBox[
         StyleBox["Q0",
          FontColor->RGBColor[{
             Rational[1, 2], 
             Rational[1, 2], 0}]], "-"], " ", 
        SuperscriptBox[
         StyleBox["Q0",
          FontColor->RGBColor[{
             Rational[1, 2], 
             Rational[1, 2], 0}]], "+"]}], "-", 
       RowBox[{"1296", " ", 
        RowBox[{"(", 
         RowBox[{"9", "+", 
          RowBox[{"56", " ", 
           SuperscriptBox["u", "2"]}], "+", 
          RowBox[{"196", " ", 
           SuperscriptBox["u", "4"]}], "+", 
          RowBox[{"183", " ", 
           SuperscriptBox["u", "6"]}], "+", 
          RowBox[{"117", " ", 
           SuperscriptBox["u", "8"]}], "+", 
          RowBox[{"27", " ", 
           SuperscriptBox["u", "10"]}]}], ")"}], " ", 
        SuperscriptBox["z", "4"], " ", 
        SuperscriptBox[
         RowBox[{"(", 
          SuperscriptBox[
           StyleBox["Q0",
            FontColor->RGBColor[{
               Rational[1, 2], 
               Rational[1, 2], 0}]], "-"], ")"}], "2"], " ", 
        SuperscriptBox[
         RowBox[{"(", 
          SuperscriptBox[
           StyleBox["Q0",
            FontColor->RGBColor[{
               Rational[1, 2], 
               Rational[1, 2], 0}]], "+"], ")"}], "2"]}]}], ")"}]}], ")"}], 
   "/", 
   RowBox[{"(", 
    RowBox[{"243", " ", 
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{"1", "+", 
        SuperscriptBox["u", "2"]}], ")"}], "4"], " ", 
     SuperscriptBox[
      RowBox[{"(", 
       SuperscriptBox[
        StyleBox["Q0",
         FontColor->RGBColor[{
            Rational[1, 2], 
            Rational[1, 2], 0}]], "-"], ")"}], "3"], " ", 
     SuperscriptBox[
      RowBox[{"(", 
       SuperscriptBox[
        StyleBox["Q0",
         FontColor->RGBColor[{
            Rational[1, 2], 
            Rational[1, 2], 0}]], "+"], ")"}], "3"]}], ")"}]}]}]], "Output",
 CellChangeTimes->{{3.5558389677980127`*^9, 3.555838980267571*^9}, {
   3.555839037405555*^9, 3.555839058959167*^9}, {3.555839136036277*^9, 
   3.555839152434594*^9}, {3.555839280719705*^9, 3.555839307068534*^9}, 
   3.555839503975836*^9, 3.5558395934185658`*^9, 3.555839826918263*^9, {
   3.555840201422497*^9, 3.555840212884617*^9}, 3.564840702685684*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"RHSCW", "=", 
  RowBox[{"Collect", "[", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"Series", "[", 
       RowBox[{
        RowBox[{"preanswer", " ", 
         RowBox[{"(", 
          RowBox[{
           SuperscriptBox["g", "8"], 
           RowBox[{"(", 
            RowBox[{
             SubscriptBox["W", "lead"], "+", 
             RowBox[{
              SuperscriptBox["g", "2"], 
              SubscriptBox["W", "sublead"]}], "+", 
             RowBox[{
              SuperscriptBox["g", "4"], 
              SubscriptBox["W", "sublead2"]}]}], ")"}]}], ")"}]}], ",", 
        RowBox[{"{", 
         RowBox[{"g", ",", "0", ",", "12"}], "}"}]}], "]"}], "//", "Normal"}],
      "//", "Expand"}], ",", 
    RowBox[{"{", 
     RowBox[{"g", ",", "z"}], "}"}], ",", 
    RowBox[{
     RowBox[{"\[DoubleStruckCapitalC]", "[", 
      RowBox[{"Collect", "[", 
       RowBox[{"#", ",", 
        SubscriptBox["W", "_"], ",", 
        RowBox[{
         RowBox[{"Simplify", "[", 
          RowBox[{"Together", "[", "#", "]"}], "]"}], "&"}]}], "]"}], "]"}], 
     "&"}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.5558393228415737`*^9, 3.5558394471665173`*^9}, {
  3.555839610089334*^9, 3.555839621184819*^9}, {3.555840010888736*^9, 
  3.55584001710035*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   SuperscriptBox["g", "8"], " ", 
   RowBox[{"\[DoubleStruckCapitalC]", "[", 
    RowBox[{"-", 
     FractionBox[
      RowBox[{"4", " ", "\[ImaginaryI]", " ", 
       SubscriptBox[
        StyleBox["W",
         FontColor->RGBColor[0.54, 0.35, 0.15]], "lead"]}], 
      RowBox[{"3", " ", 
       SuperscriptBox[
        StyleBox["Q0",
         FontColor->RGBColor[{
            Rational[1, 2], 
            Rational[1, 2], 0}]], "-"], " ", 
       SuperscriptBox[
        StyleBox["Q0",
         FontColor->RGBColor[{
            Rational[1, 2], 
            Rational[1, 2], 0}]], "+"]}]]}], "]"}]}], "+", 
  RowBox[{
   SuperscriptBox["g", "10"], " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{
      SuperscriptBox["z", "2"], " ", 
      RowBox[{"\[DoubleStruckCapitalC]", "[", 
       FractionBox[
        RowBox[{"16", " ", "\[ImaginaryI]", " ", 
         RowBox[{"(", 
          RowBox[{"6", "+", 
           RowBox[{"25", " ", 
            SuperscriptBox["u", "2"]}], "+", 
           RowBox[{"51", " ", 
            SuperscriptBox["u", "4"]}], "+", 
           RowBox[{"18", " ", 
            SuperscriptBox["u", "6"]}]}], ")"}], " ", 
         SubscriptBox[
          StyleBox["W",
           FontColor->RGBColor[0.54, 0.35, 0.15]], "lead"]}], 
        RowBox[{"3", " ", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"1", "+", 
            SuperscriptBox["u", "2"]}], ")"}], "2"], " ", 
         SuperscriptBox[
          StyleBox["Q0",
           FontColor->RGBColor[{
              Rational[1, 2], 
              Rational[1, 2], 0}]], "-"], " ", 
         SuperscriptBox[
          StyleBox["Q0",
           FontColor->RGBColor[{
              Rational[1, 2], 
              Rational[1, 2], 0}]], "+"]}]], "]"}]}], "+", 
     RowBox[{"\[DoubleStruckCapitalC]", "[", 
      RowBox[{
       RowBox[{"-", 
        FractionBox[
         RowBox[{"4", " ", "\[ImaginaryI]", " ", 
          RowBox[{"(", 
           RowBox[{"11", "+", 
            RowBox[{"113", " ", 
             SuperscriptBox["u", "2"]}], "+", 
            RowBox[{"434", " ", 
             SuperscriptBox["u", "4"]}], "+", 
            RowBox[{"729", " ", 
             SuperscriptBox["u", "6"]}], "+", 
            RowBox[{"819", " ", 
             SuperscriptBox["u", "8"]}], "+", 
            RowBox[{"324", " ", 
             SuperscriptBox["u", "10"]}]}], ")"}], " ", 
          SubscriptBox[
           StyleBox["W",
            FontColor->RGBColor[0.54, 0.35, 0.15]], "lead"]}], 
         RowBox[{"27", " ", 
          SuperscriptBox[
           RowBox[{"(", 
            RowBox[{"1", "+", 
             SuperscriptBox["u", "2"]}], ")"}], "2"], " ", 
          SuperscriptBox[
           RowBox[{"(", 
            SuperscriptBox[
             StyleBox["Q0",
              FontColor->RGBColor[{
                 Rational[1, 2], 
                 Rational[1, 2], 0}]], "-"], ")"}], "2"], " ", 
          SuperscriptBox[
           RowBox[{"(", 
            SuperscriptBox[
             StyleBox["Q0",
              FontColor->RGBColor[{
                 Rational[1, 2], 
                 Rational[1, 2], 0}]], "+"], ")"}], "2"]}]]}], "-", 
       FractionBox[
        RowBox[{"4", " ", "\[ImaginaryI]", " ", 
         SubscriptBox[
          StyleBox["W",
           FontColor->RGBColor[0.54, 0.35, 0.15]], "sublead"]}], 
        RowBox[{"3", " ", 
         SuperscriptBox[
          StyleBox["Q0",
           FontColor->RGBColor[{
              Rational[1, 2], 
              Rational[1, 2], 0}]], "-"], " ", 
         SuperscriptBox[
          StyleBox["Q0",
           FontColor->RGBColor[{
              Rational[1, 2], 
              Rational[1, 2], 0}]], "+"]}]]}], "]"}]}], ")"}]}], "+", 
  RowBox[{
   SuperscriptBox["g", "12"], " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{
      SuperscriptBox["z", "4"], " ", 
      RowBox[{"\[DoubleStruckCapitalC]", "[", 
       RowBox[{"-", 
        FractionBox[
         RowBox[{"64", " ", "\[ImaginaryI]", " ", 
          RowBox[{"(", 
           RowBox[{"9", "+", 
            RowBox[{"56", " ", 
             SuperscriptBox["u", "2"]}], "+", 
            RowBox[{"196", " ", 
             SuperscriptBox["u", "4"]}], "+", 
            RowBox[{"183", " ", 
             SuperscriptBox["u", "6"]}], "+", 
            RowBox[{"117", " ", 
             SuperscriptBox["u", "8"]}], "+", 
            RowBox[{"27", " ", 
             SuperscriptBox["u", "10"]}]}], ")"}], " ", 
          SubscriptBox[
           StyleBox["W",
            FontColor->RGBColor[0.54, 0.35, 0.15]], "lead"]}], 
         RowBox[{"3", " ", 
          SuperscriptBox[
           RowBox[{"(", 
            RowBox[{"1", "+", 
             SuperscriptBox["u", "2"]}], ")"}], "4"], " ", 
          SuperscriptBox[
           StyleBox["Q0",
            FontColor->RGBColor[{
               Rational[1, 2], 
               Rational[1, 2], 0}]], "-"], " ", 
          SuperscriptBox[
           StyleBox["Q0",
            FontColor->RGBColor[{
               Rational[1, 2], 
               Rational[1, 2], 0}]], "+"]}]]}], "]"}]}], "+", 
     RowBox[{
      SuperscriptBox["z", "2"], " ", 
      RowBox[{"\[DoubleStruckCapitalC]", "[", 
       RowBox[{
        RowBox[{"-", 
         FractionBox[
          RowBox[{"16", " ", "\[ImaginaryI]", " ", 
           RowBox[{"(", 
            RowBox[{"22", "+", 
             RowBox[{"56", " ", 
              SuperscriptBox["u", "2"]}], "-", 
             RowBox[{"376", " ", 
              SuperscriptBox["u", "4"]}], "-", 
             RowBox[{"1731", " ", 
              SuperscriptBox["u", "6"]}], "-", 
             RowBox[{"3243", " ", 
              SuperscriptBox["u", "8"]}], "-", 
             RowBox[{"1800", " ", 
              SuperscriptBox["u", "10"]}], "-", 
             RowBox[{"189", " ", 
              SuperscriptBox["u", "12"]}], "+", 
             RowBox[{"81", " ", 
              SuperscriptBox["u", "14"]}]}], ")"}], " ", 
           SubscriptBox[
            StyleBox["W",
             FontColor->RGBColor[0.54, 0.35, 0.15]], "lead"]}], 
          RowBox[{"27", " ", 
           SuperscriptBox[
            RowBox[{"(", 
             RowBox[{"1", "+", 
              SuperscriptBox["u", "2"]}], ")"}], "4"], " ", 
           SuperscriptBox[
            RowBox[{"(", 
             SuperscriptBox[
              StyleBox["Q0",
               FontColor->RGBColor[{
                  Rational[1, 2], 
                  Rational[1, 2], 0}]], "-"], ")"}], "2"], " ", 
           SuperscriptBox[
            RowBox[{"(", 
             SuperscriptBox[
              StyleBox["Q0",
               FontColor->RGBColor[{
                  Rational[1, 2], 
                  Rational[1, 2], 0}]], "+"], ")"}], "2"]}]]}], "+", 
        FractionBox[
         RowBox[{"16", " ", "\[ImaginaryI]", " ", 
          RowBox[{"(", 
           RowBox[{"6", "+", 
            RowBox[{"25", " ", 
             SuperscriptBox["u", "2"]}], "+", 
            RowBox[{"51", " ", 
             SuperscriptBox["u", "4"]}], "+", 
            RowBox[{"18", " ", 
             SuperscriptBox["u", "6"]}]}], ")"}], " ", 
          SubscriptBox[
           StyleBox["W",
            FontColor->RGBColor[0.54, 0.35, 0.15]], "sublead"]}], 
         RowBox[{"3", " ", 
          SuperscriptBox[
           RowBox[{"(", 
            RowBox[{"1", "+", 
             SuperscriptBox["u", "2"]}], ")"}], "2"], " ", 
          SuperscriptBox[
           StyleBox["Q0",
            FontColor->RGBColor[{
               Rational[1, 2], 
               Rational[1, 2], 0}]], "-"], " ", 
          SuperscriptBox[
           StyleBox["Q0",
            FontColor->RGBColor[{
               Rational[1, 2], 
               Rational[1, 2], 0}]], "+"]}]]}], "]"}]}], "+", 
     RowBox[{"\[DoubleStruckCapitalC]", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"(", 
         RowBox[{"4", " ", "\[ImaginaryI]", " ", 
          RowBox[{"(", 
           RowBox[{"108", "+", 
            RowBox[{"1142", " ", 
             SuperscriptBox["u", "2"]}], "+", 
            RowBox[{"4615", " ", 
             SuperscriptBox["u", "4"]}], "+", 
            RowBox[{"10277", " ", 
             SuperscriptBox["u", "6"]}], "+", 
            RowBox[{"24092", " ", 
             SuperscriptBox["u", "8"]}], "+", 
            RowBox[{"59418", " ", 
             SuperscriptBox["u", "10"]}], "+", 
            RowBox[{"107406", " ", 
             SuperscriptBox["u", "12"]}], "+", 
            RowBox[{"111726", " ", 
             SuperscriptBox["u", "14"]}], "+", 
            RowBox[{"64395", " ", 
             SuperscriptBox["u", "16"]}], "+", 
            RowBox[{"15309", " ", 
             SuperscriptBox["u", "18"]}]}], ")"}], " ", 
          SubscriptBox[
           StyleBox["W",
            FontColor->RGBColor[0.54, 0.35, 0.15]], "lead"]}], ")"}], "/", 
        RowBox[{"(", 
         RowBox[{"243", " ", 
          SuperscriptBox[
           RowBox[{"(", 
            RowBox[{"1", "+", 
             SuperscriptBox["u", "2"]}], ")"}], "4"], " ", 
          SuperscriptBox[
           RowBox[{"(", 
            SuperscriptBox[
             StyleBox["Q0",
              FontColor->RGBColor[{
                 Rational[1, 2], 
                 Rational[1, 2], 0}]], "-"], ")"}], "3"], " ", 
          SuperscriptBox[
           RowBox[{"(", 
            SuperscriptBox[
             StyleBox["Q0",
              FontColor->RGBColor[{
                 Rational[1, 2], 
                 Rational[1, 2], 0}]], "+"], ")"}], "3"]}], ")"}]}], "-", 
       FractionBox[
        RowBox[{"4", " ", "\[ImaginaryI]", " ", 
         RowBox[{"(", 
          RowBox[{"11", "+", 
           RowBox[{"113", " ", 
            SuperscriptBox["u", "2"]}], "+", 
           RowBox[{"434", " ", 
            SuperscriptBox["u", "4"]}], "+", 
           RowBox[{"729", " ", 
            SuperscriptBox["u", "6"]}], "+", 
           RowBox[{"819", " ", 
            SuperscriptBox["u", "8"]}], "+", 
           RowBox[{"324", " ", 
            SuperscriptBox["u", "10"]}]}], ")"}], " ", 
         SubscriptBox[
          StyleBox["W",
           FontColor->RGBColor[0.54, 0.35, 0.15]], "sublead"]}], 
        RowBox[{"27", " ", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"1", "+", 
            SuperscriptBox["u", "2"]}], ")"}], "2"], " ", 
         SuperscriptBox[
          RowBox[{"(", 
           SuperscriptBox[
            StyleBox["Q0",
             FontColor->RGBColor[{
                Rational[1, 2], 
                Rational[1, 2], 0}]], "-"], ")"}], "2"], " ", 
         SuperscriptBox[
          RowBox[{"(", 
           SuperscriptBox[
            StyleBox["Q0",
             FontColor->RGBColor[{
                Rational[1, 2], 
                Rational[1, 2], 0}]], "+"], ")"}], "2"]}]], "-", 
       FractionBox[
        RowBox[{"4", " ", "\[ImaginaryI]", " ", 
         SubscriptBox[
          StyleBox["W",
           FontColor->RGBColor[0.54, 0.35, 0.15]], "sublead2"]}], 
        RowBox[{"3", " ", 
         SuperscriptBox[
          StyleBox["Q0",
           FontColor->RGBColor[{
              Rational[1, 2], 
              Rational[1, 2], 0}]], "-"], " ", 
         SuperscriptBox[
          StyleBox["Q0",
           FontColor->RGBColor[{
              Rational[1, 2], 
              Rational[1, 2], 0}]], "+"]}]]}], "]"}]}], ")"}]}]}]], "Output",
 CellChangeTimes->{
  3.555839409477634*^9, {3.555839440093554*^9, 3.555839447470441*^9}, {
   3.555839602388381*^9, 3.555839621869473*^9}, 3.555839832399612*^9, 
   3.555840019616262*^9, 3.555840217186384*^9, 3.564840702971754*^9}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[{
 "Correction from ",
 Cell[BoxData[
  SubscriptBox["W", "1"]],
  CellChangeTimes->{{3.555837085900972*^9, 3.5558371899449387`*^9}}]
}], "Subsubsection",
 CellChangeTimes->{{3.555838758322815*^9, 3.5558387651001787`*^9}, {
  3.555840310897921*^9, 3.5558403122217283`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"tmp2", "=", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"Series", "[", 
       RowBox[{
        RowBox[{
         RowBox[{
          RowBox[{
           RowBox[{
            RowBox[{"1", "/", "\[GothicCapitalT]"}], "/.", "largevolume"}], "/.", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{
              RowBox[{"x$", "[", "1", "]"}], "\[Rule]", 
              RowBox[{"x$h", "[", "1", "]"}]}], ",", 
             RowBox[{
              RowBox[{"x$", "[", 
               RowBox[{"-", "1"}], "]"}], "\[Rule]", 
              RowBox[{"1", "/", 
               RowBox[{"x$h", "[", 
                RowBox[{"-", "1"}], "]"}]}]}]}], "}"}]}], "/.", "subJuk"}], "/.", 
         RowBox[{"leadweak", "[", "4", "]"}]}], ",", 
        RowBox[{"{", 
         RowBox[{"g", ",", "0", ",", "6"}], "}"}]}], "]"}], "//", 
      "Together"}], "//", "Simplify"}], "//", "Normal"}]}], ";"}]], "Input"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"Series", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"(", 
       FractionBox[
        RowBox[{"2", "u"}], 
        RowBox[{
         RowBox[{"4", 
          SuperscriptBox["g", "2"], 
          SuperscriptBox["z", "2"]}], "-", 
         SuperscriptBox["u", "2"]}]], ")"}], 
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         RowBox[{"+", "2"}], " ", "tmp2"}], "/.", 
        RowBox[{"u", "\[Rule]", 
         RowBox[{"u", "+", 
          FractionBox["\[ImaginaryI]", "2"]}]}]}], ")"}], 
      RowBox[{"(", 
       RowBox[{
        SuperscriptBox["g", "8"], 
        RowBox[{"(", 
         RowBox[{
          SubsuperscriptBox["W", 
           RowBox[{"1", ",", "lead"}], "+"], "+", 
          RowBox[{
           SuperscriptBox["g", "2"], 
           SubsuperscriptBox["W", 
            RowBox[{"1", ",", "sublead"}], "+"]}], "+", 
          RowBox[{
           SuperscriptBox["g", "4"], 
           SubsuperscriptBox["W", 
            RowBox[{"1", ",", "sublead2"}], "+"]}]}], ")"}]}], ")"}]}], ",", 
     RowBox[{"{", 
      RowBox[{"g", ",", "0", ",", "12"}], "}"}]}], "]"}], "//", "Normal"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"RHSW1", "=", 
  RowBox[{
   RowBox[{"Collect", "[", 
    RowBox[{"%", ",", 
     RowBox[{"{", 
      RowBox[{"g", ",", "z"}], "}"}], ",", 
     RowBox[{
      RowBox[{"\[DoubleStruckCapitalC]", "[", 
       RowBox[{"Collect", "[", 
        RowBox[{"#", ",", 
         SubsuperscriptBox["W", "__", "+"], ",", "Simplify"}], "]"}], "]"}], 
      "&"}]}], "]"}], "/.", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{"-", "1"}], "+", 
       RowBox[{"3", " ", "\[ImaginaryI]", " ", "u"}], "+", 
       RowBox[{"3", " ", 
        SuperscriptBox["u", "2"]}]}], "\[Rule]", 
      RowBox[{"3", 
       SuperscriptBox["Q0", "+"]}]}], ",", 
     RowBox[{
      RowBox[{
       RowBox[{"-", "\[ImaginaryI]"}], "-", 
       RowBox[{"4", " ", "u"}], "+", 
       RowBox[{"6", " ", "\[ImaginaryI]", " ", 
        SuperscriptBox["u", "2"]}], "+", 
       RowBox[{"3", " ", 
        SuperscriptBox["u", "3"]}]}], "\[Rule]", 
      RowBox[{"3", 
       SuperscriptBox["Q0", "+"], 
       RowBox[{"(", 
        RowBox[{"u", "+", "\[ImaginaryI]"}], ")"}]}]}]}], "}"}]}]}]}], "Input",\

 CellChangeTimes->{{3.555840416253265*^9, 3.555840520999799*^9}, {
  3.555840566794216*^9, 3.555840605293166*^9}, {3.5558406523763247`*^9, 
  3.555840655807144*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   SuperscriptBox["g", "8"], " ", 
   RowBox[{"\[DoubleStruckCapitalC]", "[", 
    RowBox[{"-", 
     FractionBox[
      RowBox[{"4", " ", 
       RowBox[{"(", 
        RowBox[{"\[ImaginaryI]", "+", "u"}], ")"}], " ", 
       SubsuperscriptBox[
        StyleBox["W",
         FontColor->RGBColor[0.54, 0.35, 0.15]], 
        RowBox[{"1", ",", "lead"}], "+"]}], 
      SuperscriptBox[
       StyleBox["Q0",
        FontColor->RGBColor[{
           Rational[1, 2], 
           Rational[1, 2], 0}]], "+"]]}], "]"}]}], "+", 
  RowBox[{
   SuperscriptBox["g", "10"], " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{
      SuperscriptBox["z", "2"], " ", 
      RowBox[{"\[DoubleStruckCapitalC]", "[", 
       RowBox[{"-", 
        FractionBox[
         RowBox[{"16", " ", 
          RowBox[{"(", 
           RowBox[{"\[ImaginaryI]", "+", "u"}], ")"}], " ", 
          SubsuperscriptBox[
           StyleBox["W",
            FontColor->RGBColor[0.54, 0.35, 0.15]], 
           RowBox[{"1", ",", "lead"}], "+"]}], 
         RowBox[{
          SuperscriptBox["u", "2"], " ", 
          SuperscriptBox[
           StyleBox["Q0",
            FontColor->RGBColor[{
               Rational[1, 2], 
               Rational[1, 2], 0}]], "+"]}]]}], "]"}]}], "+", 
     RowBox[{"\[DoubleStruckCapitalC]", "[", 
      RowBox[{
       RowBox[{"-", 
        FractionBox[
         RowBox[{"4", " ", 
          SuperscriptBox[
           RowBox[{"(", 
            RowBox[{"\[ImaginaryI]", "+", 
             RowBox[{"2", " ", "u"}]}], ")"}], "2"], " ", 
          RowBox[{"(", 
           RowBox[{"1", "+", 
            RowBox[{"\[ImaginaryI]", " ", "u"}], "+", 
            SuperscriptBox["u", "2"]}], ")"}], " ", 
          SubsuperscriptBox[
           StyleBox["W",
            FontColor->RGBColor[0.54, 0.35, 0.15]], 
           RowBox[{"1", ",", "lead"}], "+"]}], 
         RowBox[{"3", " ", 
          SuperscriptBox["u", "2"], " ", 
          RowBox[{"(", 
           RowBox[{"\[ImaginaryI]", "+", "u"}], ")"}], " ", 
          SuperscriptBox[
           RowBox[{"(", 
            SuperscriptBox[
             StyleBox["Q0",
              FontColor->RGBColor[{
                 Rational[1, 2], 
                 Rational[1, 2], 0}]], "+"], ")"}], "2"]}]]}], "-", 
       FractionBox[
        RowBox[{"4", " ", 
         RowBox[{"(", 
          RowBox[{"\[ImaginaryI]", "+", "u"}], ")"}], " ", 
         SubsuperscriptBox[
          StyleBox["W",
           FontColor->RGBColor[0.54, 0.35, 0.15]], 
          RowBox[{"1", ",", "sublead"}], "+"]}], 
        SuperscriptBox[
         StyleBox["Q0",
          FontColor->RGBColor[{
             Rational[1, 2], 
             Rational[1, 2], 0}]], "+"]]}], "]"}]}], ")"}]}], "+", 
  RowBox[{
   SuperscriptBox["g", "12"], " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{
      SuperscriptBox["z", "4"], " ", 
      RowBox[{"\[DoubleStruckCapitalC]", "[", 
       RowBox[{"-", 
        FractionBox[
         RowBox[{"64", " ", 
          RowBox[{"(", 
           RowBox[{"\[ImaginaryI]", "+", "u"}], ")"}], " ", 
          SubsuperscriptBox[
           StyleBox["W",
            FontColor->RGBColor[0.54, 0.35, 0.15]], 
           RowBox[{"1", ",", "lead"}], "+"]}], 
         RowBox[{
          SuperscriptBox["u", "4"], " ", 
          SuperscriptBox[
           StyleBox["Q0",
            FontColor->RGBColor[{
               Rational[1, 2], 
               Rational[1, 2], 0}]], "+"]}]]}], "]"}]}], "+", 
     RowBox[{
      SuperscriptBox["z", "2"], " ", 
      RowBox[{"\[DoubleStruckCapitalC]", "[", 
       RowBox[{
        RowBox[{"-", 
         FractionBox[
          RowBox[{"16", " ", 
           SuperscriptBox[
            RowBox[{"(", 
             RowBox[{"\[ImaginaryI]", "+", 
              RowBox[{"2", " ", "u"}]}], ")"}], "2"], " ", 
           RowBox[{"(", 
            RowBox[{"1", "+", 
             RowBox[{"\[ImaginaryI]", " ", "u"}], "+", 
             SuperscriptBox["u", "2"]}], ")"}], " ", 
           SubsuperscriptBox[
            StyleBox["W",
             FontColor->RGBColor[0.54, 0.35, 0.15]], 
            RowBox[{"1", ",", "lead"}], "+"]}], 
          RowBox[{"3", " ", 
           SuperscriptBox["u", "4"], " ", 
           RowBox[{"(", 
            RowBox[{"\[ImaginaryI]", "+", "u"}], ")"}], " ", 
           SuperscriptBox[
            RowBox[{"(", 
             SuperscriptBox[
              StyleBox["Q0",
               FontColor->RGBColor[{
                  Rational[1, 2], 
                  Rational[1, 2], 0}]], "+"], ")"}], "2"]}]]}], "-", 
        FractionBox[
         RowBox[{"16", " ", 
          RowBox[{"(", 
           RowBox[{"\[ImaginaryI]", "+", "u"}], ")"}], " ", 
          SubsuperscriptBox[
           StyleBox["W",
            FontColor->RGBColor[0.54, 0.35, 0.15]], 
           RowBox[{"1", ",", "sublead"}], "+"]}], 
         RowBox[{
          SuperscriptBox["u", "2"], " ", 
          SuperscriptBox[
           StyleBox["Q0",
            FontColor->RGBColor[{
               Rational[1, 2], 
               Rational[1, 2], 0}]], "+"]}]]}], "]"}]}], "+", 
     RowBox[{"\[DoubleStruckCapitalC]", "[", 
      RowBox[{
       RowBox[{
        FractionBox["1", 
         RowBox[{"9", " ", 
          SuperscriptBox["u", "4"], " ", 
          SuperscriptBox[
           RowBox[{"(", 
            RowBox[{"\[ImaginaryI]", "+", "u"}], ")"}], "3"], " ", 
          SuperscriptBox[
           RowBox[{"(", 
            SuperscriptBox[
             StyleBox["Q0",
              FontColor->RGBColor[{
                 Rational[1, 2], 
                 Rational[1, 2], 0}]], "+"], ")"}], "3"]}]], 
        RowBox[{"4", " ", 
         RowBox[{"(", 
          RowBox[{"1", "-", 
           RowBox[{"10", " ", "\[ImaginaryI]", " ", "u"}], "-", 
           RowBox[{"45", " ", 
            SuperscriptBox["u", "2"]}], "+", 
           RowBox[{"100", " ", "\[ImaginaryI]", " ", 
            SuperscriptBox["u", "3"]}], "+", 
           RowBox[{"61", " ", 
            SuperscriptBox["u", "4"]}], "+", 
           RowBox[{"202", " ", "\[ImaginaryI]", " ", 
            SuperscriptBox["u", "5"]}], "+", 
           RowBox[{"534", " ", 
            SuperscriptBox["u", "6"]}], "-", 
           RowBox[{"616", " ", "\[ImaginaryI]", " ", 
            SuperscriptBox["u", "7"]}], "-", 
           RowBox[{"424", " ", 
            SuperscriptBox["u", "8"]}], "+", 
           RowBox[{"180", " ", "\[ImaginaryI]", " ", 
            SuperscriptBox["u", "9"]}], "+", 
           RowBox[{"36", " ", 
            SuperscriptBox["u", "10"]}]}], ")"}], " ", 
         SubsuperscriptBox[
          StyleBox["W",
           FontColor->RGBColor[0.54, 0.35, 0.15]], 
          RowBox[{"1", ",", "lead"}], "+"]}]}], "-", 
       FractionBox[
        RowBox[{"4", " ", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"\[ImaginaryI]", "+", 
            RowBox[{"2", " ", "u"}]}], ")"}], "2"], " ", 
         RowBox[{"(", 
          RowBox[{"1", "+", 
           RowBox[{"\[ImaginaryI]", " ", "u"}], "+", 
           SuperscriptBox["u", "2"]}], ")"}], " ", 
         SubsuperscriptBox[
          StyleBox["W",
           FontColor->RGBColor[0.54, 0.35, 0.15]], 
          RowBox[{"1", ",", "sublead"}], "+"]}], 
        RowBox[{"3", " ", 
         SuperscriptBox["u", "2"], " ", 
         RowBox[{"(", 
          RowBox[{"\[ImaginaryI]", "+", "u"}], ")"}], " ", 
         SuperscriptBox[
          RowBox[{"(", 
           SuperscriptBox[
            StyleBox["Q0",
             FontColor->RGBColor[{
                Rational[1, 2], 
                Rational[1, 2], 0}]], "+"], ")"}], "2"]}]], "-", 
       FractionBox[
        RowBox[{"4", " ", 
         RowBox[{"(", 
          RowBox[{"\[ImaginaryI]", "+", "u"}], ")"}], " ", 
         SubsuperscriptBox[
          StyleBox["W",
           FontColor->RGBColor[0.54, 0.35, 0.15]], 
          RowBox[{"1", ",", "sublead2"}], "+"]}], 
        SuperscriptBox[
         StyleBox["Q0",
          FontColor->RGBColor[{
             Rational[1, 2], 
             Rational[1, 2], 0}]], "+"]]}], "]"}]}], ")"}]}]}]], "Output",
 CellChangeTimes->{3.555840523694784*^9, 3.555840572598069*^9, 
  3.555840618221472*^9, 3.555840656949057*^9, 3.564840712198132*^9}]
}, Open  ]]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 "Fixing one-parametric ambiguity by demanding that ",
 Cell[BoxData[
  FormBox["\[GothicCapitalT]", TraditionalForm]]],
 " has a zero at Bethe root."
}], "Subsection",
 CellChangeTimes->{{3.547188747435412*^9, 3.547188749621891*^9}, {
  3.547188802438261*^9, 3.547188803147543*^9}, {3.547188852625847*^9, 
  3.547188864504485*^9}, {3.548413856998253*^9, 3.5484138865950613`*^9}}],

Cell["\<\
We\[CloseCurlyQuote]ve got two equaitons on three constants: AAA,BBB,CCC. The \
third equaiton comes from requirement that at Bethe root \[GothicCapitalT]=0. \
This demand produces equation:\
\>", "Text",
 CellChangeTimes->{{3.5537403445375433`*^9, 3.553740378294457*^9}, {
  3.553740497401762*^9, 3.553740504385742*^9}}],

Cell[BoxData[
 RowBox[{"\[Delta]\[GothicCapitalT]", "\[Equal]", 
  RowBox[{
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      SuperscriptBox["\[ScriptCapitalC]", 
       RowBox[{"[", 
        RowBox[{"+", "1"}], "]"}]], "-", 
      SuperscriptBox["\[ScriptCapitalC]", 
       RowBox[{"[", 
        RowBox[{"-", "1"}], "]"}]]}], ")"}], 
    OverscriptBox["*", "^"], 
    SubscriptBox["\[Delta]\[Rho]", "2"]}], "+", 
   SubscriptBox["W", "1"], "-", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      SuperscriptBox["\[ScriptCapitalC]", 
       RowBox[{"[", 
        RowBox[{"+", "1"}], "]"}]], "-", 
      SuperscriptBox["\[ScriptCapitalC]", 
       RowBox[{"[", 
        RowBox[{"-", "1"}], "]"}]]}], ")"}], "*", "W"}]}]}]], "Input",
 CellChangeTimes->{{3.555843619476699*^9, 3.5558436797977877`*^9}}],

Cell["\<\
It should be zero at Bethe root. It is now simple to expand this expression.\
\>", "Text",
 CellChangeTimes->{{3.5558436647228327`*^9, 3.555843686393982*^9}}],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"Series", "[", 
     RowBox[{
      RowBox[{
       RowBox[{
        FractionBox[
         RowBox[{"2", "g"}], 
         RowBox[{
          RowBox[{"-", "2"}], "\[ImaginaryI]"}]], 
        RowBox[{"(", 
         RowBox[{
          FractionBox["w", 
           RowBox[{
            SubscriptBox["v", "0"], "+", 
            FractionBox["\[ImaginaryI]", "2"], "-", 
            RowBox[{"2", "g", " ", "w"}]}]], "-", 
          FractionBox["w", 
           RowBox[{
            SubscriptBox["v", "0"], "-", 
            FractionBox["\[ImaginaryI]", "2"], "-", 
            RowBox[{"2", "g", " ", "w"}]}]]}], ")"}], 
        SuperscriptBox["g", "7"], 
        RowBox[{"(", 
         RowBox[{
          SubscriptBox["\[Delta]\[Rho]2", "lead"], "+", 
          RowBox[{
           SuperscriptBox["g", "2"], 
           SubscriptBox["\[Delta]\[Rho]2", "sublead"]}], "+", 
          RowBox[{
           SuperscriptBox["g", "4"], 
           SubscriptBox["\[Delta]\[Rho]2", "sublead2"]}], "+", 
          RowBox[{
           SuperscriptBox["g", "6"], 
           SubscriptBox["\[Delta]\[Rho]2", "sublead3"]}]}], ")"}]}], "/.", 
       RowBox[{"leadweak", "[", "4", "]"}]}], ",", 
      RowBox[{"{", 
       RowBox[{"g", ",", "0", ",", "14"}], "}"}]}], "]"}], "//", "Simplify"}],
    "//", "Normal"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"tmp1", "=", 
  RowBox[{
   RowBox[{
    RowBox[{"Collect", "[", 
     RowBox[{
      RowBox[{"%", "//", "Expand"}], ",", 
      RowBox[{"{", "g", "}"}]}], "]"}], "/.", 
    RowBox[{
     SuperscriptBox["w", 
      RowBox[{"a_", "/;", 
       RowBox[{"EvenQ", "[", "a", "]"}]}]], "\[Rule]", "0"}]}], "/.", 
   RowBox[{
    RowBox[{
     SuperscriptBox["w", "a_."], 
     SubscriptBox["\[Delta]\[Rho]2", "b_"]}], "\[RuleDelayed]", 
    RowBox[{"M", "[", 
     RowBox[{
      SuperscriptBox["w", 
       RowBox[{"a", "-", "1"}]], 
      SubscriptBox["\[Delta]\[Rho]2", "b"]}], "]"}]}]}]}]}], "Input",
 CellChangeTimes->{{3.5558436936210957`*^9, 3.555843737350903*^9}, {
  3.5558437898386087`*^9, 3.555843956469735*^9}, {3.555959929874806*^9, 
  3.555959943065651*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"3", " ", 
   SuperscriptBox["g", "8"], " ", 
   RowBox[{"M", "[", 
    SubscriptBox["\[Delta]\[Rho]2", "lead"], "]"}]}], "+", 
  RowBox[{
   SuperscriptBox["g", "10"], " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{
      RowBox[{"-", "12"}], " ", 
      RowBox[{"M", "[", 
       SubscriptBox["\[Delta]\[Rho]2", "lead"], "]"}]}], "+", 
     RowBox[{"3", " ", 
      RowBox[{"M", "[", 
       SubscriptBox["\[Delta]\[Rho]2", "sublead"], "]"}]}]}], ")"}]}], "+", 
  RowBox[{
   SuperscriptBox["g", "12"], " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"30", " ", 
      RowBox[{"M", "[", 
       SubscriptBox["\[Delta]\[Rho]2", "lead"], "]"}]}], "+", 
     RowBox[{"432", " ", 
      RowBox[{"M", "[", 
       RowBox[{
        SuperscriptBox["w", "2"], " ", 
        SubscriptBox["\[Delta]\[Rho]2", "lead"]}], "]"}]}], "-", 
     RowBox[{"432", " ", 
      RowBox[{"M", "[", 
       RowBox[{
        SuperscriptBox["w", "4"], " ", 
        SubscriptBox["\[Delta]\[Rho]2", "lead"]}], "]"}]}], "-", 
     RowBox[{"12", " ", 
      RowBox[{"M", "[", 
       SubscriptBox["\[Delta]\[Rho]2", "sublead"], "]"}]}], "+", 
     RowBox[{"3", " ", 
      RowBox[{"M", "[", 
       SubscriptBox["\[Delta]\[Rho]2", "sublead2"], "]"}]}]}], ")"}]}], "+", 
  RowBox[{
   SuperscriptBox["g", "14"], " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"24", " ", 
      RowBox[{"M", "[", 
       SubscriptBox["\[Delta]\[Rho]2", "lead"], "]"}]}], "-", 
     RowBox[{"4536", " ", 
      RowBox[{"M", "[", 
       RowBox[{
        SuperscriptBox["w", "2"], " ", 
        SubscriptBox["\[Delta]\[Rho]2", "lead"]}], "]"}]}], "+", 
     RowBox[{"5184", " ", 
      RowBox[{"M", "[", 
       RowBox[{
        SuperscriptBox["w", "6"], " ", 
        SubscriptBox["\[Delta]\[Rho]2", "lead"]}], "]"}]}], "+", 
     RowBox[{"30", " ", 
      RowBox[{"M", "[", 
       SubscriptBox["\[Delta]\[Rho]2", "sublead"], "]"}]}], "+", 
     RowBox[{"432", " ", 
      RowBox[{"M", "[", 
       RowBox[{
        SuperscriptBox["w", "2"], " ", 
        SubscriptBox["\[Delta]\[Rho]2", "sublead"]}], "]"}]}], "-", 
     RowBox[{"432", " ", 
      RowBox[{"M", "[", 
       RowBox[{
        SuperscriptBox["w", "4"], " ", 
        SubscriptBox["\[Delta]\[Rho]2", "sublead"]}], "]"}]}], "-", 
     RowBox[{"12", " ", 
      RowBox[{"M", "[", 
       SubscriptBox["\[Delta]\[Rho]2", "sublead2"], "]"}]}], "+", 
     RowBox[{"3", " ", 
      RowBox[{"M", "[", 
       SubscriptBox["\[Delta]\[Rho]2", "sublead3"], "]"}]}], "-", 
     RowBox[{"72", " ", 
      RowBox[{"M", "[", 
       SubscriptBox["\[Delta]\[Rho]2", "lead"], "]"}], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3"]}]}], ")"}]}]}]], "Output",
 CellChangeTimes->{3.555844254847727*^9, 3.5558665661745863`*^9, 
  3.5559599498605013`*^9, 3.560337071805748*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"tmp2", "=", 
  RowBox[{"Collect", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{
        RowBox[{"Series", "[", 
         RowBox[{
          RowBox[{
           FractionBox["1", "2"], 
           RowBox[{"(", 
            RowBox[{
             RowBox[{
              FractionBox["1", 
               RowBox[{
                SubscriptBox["v", "0"], "+", 
                FractionBox["\[ImaginaryI]", "2"], "-", "u"}]], "-", 
              FractionBox["1", 
               RowBox[{
                SubscriptBox["v", "0"], "-", 
                FractionBox["\[ImaginaryI]", "2"], "-", "u"}]], "+", 
              FractionBox["1", 
               RowBox[{
                SubscriptBox["v", "0"], "+", 
                FractionBox["\[ImaginaryI]", "2"], "+", "u"}]], "-", 
              FractionBox["1", 
               RowBox[{
                SubscriptBox["v", "0"], "-", 
                FractionBox["\[ImaginaryI]", "2"], "+", "u"}]]}], "/.", 
             RowBox[{"leadweak", "[", "4", "]"}]}], ")"}], 
           SuperscriptBox["g", "8"], 
           RowBox[{"(", 
            RowBox[{
             SubscriptBox["W", "lead"], "+", 
             RowBox[{
              SuperscriptBox["g", "2"], 
              SubscriptBox["W", "sublead"]}], "+", 
             RowBox[{
              SuperscriptBox["g", "4"], 
              SubscriptBox["W", "sublead2"]}], "+", 
             RowBox[{
              SuperscriptBox["g", "6"], 
              SubscriptBox["W", "sublead3"]}]}], ")"}]}], ",", 
          RowBox[{"{", 
           RowBox[{"g", ",", "0", ",", "14"}], "}"}]}], "]"}], "//", 
        "Simplify"}], "//", "Normal"}], ")"}], "/.", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"1", "+", 
        RowBox[{"3", " ", 
         SuperscriptBox["u", "2"]}], "+", 
        RowBox[{"9", " ", 
         SuperscriptBox["u", "4"]}]}], "\[Rule]", 
       RowBox[{"9", 
        SuperscriptBox["Q0", "+"], 
        SuperscriptBox["Q0", "-"]}]}], "}"}]}], ",", "g", ",", 
    "\[DoubleStruckCapitalC]"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.555844020425021*^9, 3.555844186553638*^9}, {
  3.5559599776794653`*^9, 3.5559599889051113`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   SuperscriptBox["g", "8"], " ", 
   RowBox[{"\[DoubleStruckCapitalC]", "[", 
    RowBox[{"-", 
     FractionBox[
      RowBox[{"\[ImaginaryI]", " ", 
       RowBox[{"(", 
        RowBox[{"1", "+", 
         RowBox[{"3", " ", 
          SuperscriptBox["u", "2"]}]}], ")"}], " ", 
       SubscriptBox[
        StyleBox["W",
         FontColor->RGBColor[0.54, 0.35, 0.15]], "lead"]}], 
      RowBox[{"3", " ", 
       SuperscriptBox[
        StyleBox["Q0",
         FontColor->RGBColor[{
            Rational[1, 2], 
            Rational[1, 2], 0}]], "-"], " ", 
       SuperscriptBox[
        StyleBox["Q0",
         FontColor->RGBColor[{
            Rational[1, 2], 
            Rational[1, 2], 0}]], "+"]}]]}], "]"}]}], "+", 
  RowBox[{
   SuperscriptBox["g", "10"], " ", 
   RowBox[{"\[DoubleStruckCapitalC]", "[", 
    RowBox[{"-", 
     FractionBox[
      RowBox[{"\[ImaginaryI]", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"4", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"-", "1"}], "+", 
            RowBox[{"3", " ", 
             SuperscriptBox["u", "2"]}], "+", 
            RowBox[{"27", " ", 
             SuperscriptBox["u", "4"]}]}], ")"}], " ", 
          SubscriptBox[
           StyleBox["W",
            FontColor->RGBColor[0.54, 0.35, 0.15]], "lead"]}], "+", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{"1", "+", 
            RowBox[{"6", " ", 
             SuperscriptBox["u", "2"]}], "+", 
            RowBox[{"18", " ", 
             SuperscriptBox["u", "4"]}], "+", 
            RowBox[{"27", " ", 
             SuperscriptBox["u", "6"]}]}], ")"}], " ", 
          SubscriptBox[
           StyleBox["W",
            FontColor->RGBColor[0.54, 0.35, 0.15]], "sublead"]}]}], ")"}]}], 
      RowBox[{"27", " ", 
       SuperscriptBox[
        RowBox[{"(", 
         SuperscriptBox[
          StyleBox["Q0",
           FontColor->RGBColor[{
              Rational[1, 2], 
              Rational[1, 2], 0}]], "-"], ")"}], "2"], " ", 
       SuperscriptBox[
        RowBox[{"(", 
         SuperscriptBox[
          StyleBox["Q0",
           FontColor->RGBColor[{
              Rational[1, 2], 
              Rational[1, 2], 0}]], "+"], ")"}], "2"]}]]}], "]"}]}], "+", 
  RowBox[{
   SuperscriptBox["g", "12"], " ", 
   RowBox[{"\[DoubleStruckCapitalC]", "[", 
    RowBox[{"-", 
     RowBox[{
      FractionBox["1", 
       RowBox[{"243", " ", 
        SuperscriptBox[
         RowBox[{"(", 
          SuperscriptBox[
           StyleBox["Q0",
            FontColor->RGBColor[{
               Rational[1, 2], 
               Rational[1, 2], 0}]], "-"], ")"}], "3"], " ", 
        SuperscriptBox[
         RowBox[{"(", 
          SuperscriptBox[
           StyleBox["Q0",
            FontColor->RGBColor[{
               Rational[1, 2], 
               Rational[1, 2], 0}]], "+"], ")"}], "3"]}]], 
      RowBox[{"\[ImaginaryI]", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"2", " ", 
          RowBox[{"(", 
           RowBox[{"5", "-", 
            RowBox[{"144", " ", 
             SuperscriptBox["u", "2"]}], "-", 
            RowBox[{"351", " ", 
             SuperscriptBox["u", "4"]}], "+", 
            RowBox[{"1404", " ", 
             SuperscriptBox["u", "6"]}], "+", 
            RowBox[{"729", " ", 
             SuperscriptBox["u", "8"]}]}], ")"}], " ", 
          SubscriptBox[
           StyleBox["W",
            FontColor->RGBColor[0.54, 0.35, 0.15]], "lead"]}], "+", 
         RowBox[{"9", " ", 
          SuperscriptBox[
           StyleBox["Q0",
            FontColor->RGBColor[{
               Rational[1, 2], 
               Rational[1, 2], 0}]], "-"], " ", 
          SuperscriptBox[
           StyleBox["Q0",
            FontColor->RGBColor[{
               Rational[1, 2], 
               Rational[1, 2], 0}]], "+"], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"4", " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"-", "1"}], "+", 
               RowBox[{"3", " ", 
                SuperscriptBox["u", "2"]}], "+", 
               RowBox[{"27", " ", 
                SuperscriptBox["u", "4"]}]}], ")"}], " ", 
             SubscriptBox[
              StyleBox["W",
               FontColor->RGBColor[0.54, 0.35, 0.15]], "sublead"]}], "+", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{"1", "+", 
               RowBox[{"6", " ", 
                SuperscriptBox["u", "2"]}], "+", 
               RowBox[{"18", " ", 
                SuperscriptBox["u", "4"]}], "+", 
               RowBox[{"27", " ", 
                SuperscriptBox["u", "6"]}]}], ")"}], " ", 
             SubscriptBox[
              StyleBox["W",
               FontColor->RGBColor[0.54, 0.35, 0.15]], "sublead2"]}]}], 
           ")"}]}]}], ")"}]}]}]}], "]"}]}], "+", 
  RowBox[{
   SuperscriptBox["g", "14"], " ", 
   RowBox[{"\[DoubleStruckCapitalC]", "[", 
    RowBox[{"-", 
     RowBox[{
      FractionBox["1", 
       RowBox[{"2187", " ", 
        SuperscriptBox[
         RowBox[{"(", 
          SuperscriptBox[
           StyleBox["Q0",
            FontColor->RGBColor[{
               Rational[1, 2], 
               Rational[1, 2], 0}]], "-"], ")"}], "4"], " ", 
        SuperscriptBox[
         RowBox[{"(", 
          SuperscriptBox[
           StyleBox["Q0",
            FontColor->RGBColor[{
               Rational[1, 2], 
               Rational[1, 2], 0}]], "+"], ")"}], "4"]}]], 
      RowBox[{"\[ImaginaryI]", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"9", " ", 
          SuperscriptBox[
           StyleBox["Q0",
            FontColor->RGBColor[{
               Rational[1, 2], 
               Rational[1, 2], 0}]], "-"], " ", 
          SuperscriptBox[
           StyleBox["Q0",
            FontColor->RGBColor[{
               Rational[1, 2], 
               Rational[1, 2], 0}]], "+"], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"2", " ", 
             RowBox[{"(", 
              RowBox[{"5", "-", 
               RowBox[{"144", " ", 
                SuperscriptBox["u", "2"]}], "-", 
               RowBox[{"351", " ", 
                SuperscriptBox["u", "4"]}], "+", 
               RowBox[{"1404", " ", 
                SuperscriptBox["u", "6"]}], "+", 
               RowBox[{"729", " ", 
                SuperscriptBox["u", "8"]}]}], ")"}], " ", 
             SubscriptBox[
              StyleBox["W",
               FontColor->RGBColor[0.54, 0.35, 0.15]], "sublead"]}], "+", 
            RowBox[{"9", " ", 
             SuperscriptBox[
              StyleBox["Q0",
               FontColor->RGBColor[{
                  Rational[1, 2], 
                  Rational[1, 2], 0}]], "-"], " ", 
             SuperscriptBox[
              StyleBox["Q0",
               FontColor->RGBColor[{
                  Rational[1, 2], 
                  Rational[1, 2], 0}]], "+"], " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"4", " ", 
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{"-", "1"}], "+", 
                  RowBox[{"3", " ", 
                   SuperscriptBox["u", "2"]}], "+", 
                  RowBox[{"27", " ", 
                   SuperscriptBox["u", "4"]}]}], ")"}], " ", 
                SubscriptBox[
                 StyleBox["W",
                  FontColor->RGBColor[0.54, 0.35, 0.15]], "sublead2"]}], "+", 
               
               RowBox[{
                RowBox[{"(", 
                 RowBox[{"1", "+", 
                  RowBox[{"6", " ", 
                   SuperscriptBox["u", "2"]}], "+", 
                  RowBox[{"18", " ", 
                   SuperscriptBox["u", "4"]}], "+", 
                  RowBox[{"27", " ", 
                   SuperscriptBox["u", "6"]}]}], ")"}], " ", 
                SubscriptBox[
                 StyleBox["W",
                  FontColor->RGBColor[0.54, 0.35, 0.15]], "sublead3"]}]}], 
              ")"}]}]}], ")"}]}], "+", 
         RowBox[{"8", " ", 
          SubscriptBox[
           StyleBox["W",
            FontColor->RGBColor[0.54, 0.35, 0.15]], "lead"], " ", 
          RowBox[{"(", 
           RowBox[{"1", "+", 
            RowBox[{
             SuperscriptBox["u", "2"], " ", 
             RowBox[{"(", 
              RowBox[{"255", "-", 
               RowBox[{"9", " ", 
                SubscriptBox[
                 StyleBox["\[Zeta]",
                  FontWeight->Bold,
                  FontColor->GrayLevel[0.4]], "3"]}]}], ")"}]}], "+", 
            RowBox[{"54", " ", 
             SuperscriptBox["u", "4"], " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"-", "16"}], "+", 
               SubscriptBox[
                StyleBox["\[Zeta]",
                 FontWeight->Bold,
                 FontColor->GrayLevel[0.4]], "3"]}], ")"}]}], "+", 
            RowBox[{"6561", " ", 
             SuperscriptBox["u", "12"], " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"-", "1"}], "+", 
               SubscriptBox[
                StyleBox["\[Zeta]",
                 FontWeight->Bold,
                 FontColor->GrayLevel[0.4]], "3"]}], ")"}]}], "-", 
            RowBox[{"3", " ", 
             SubscriptBox[
              StyleBox["\[Zeta]",
               FontWeight->Bold,
               FontColor->GrayLevel[0.4]], "3"]}], "+", 
            RowBox[{"810", " ", 
             SuperscriptBox["u", "8"], " ", 
             RowBox[{"(", 
              RowBox[{"2", "+", 
               RowBox[{"3", " ", 
                SubscriptBox[
                 StyleBox["\[Zeta]",
                  FontWeight->Bold,
                  FontColor->GrayLevel[0.4]], "3"]}]}], ")"}]}], "+", 
            RowBox[{"729", " ", 
             SuperscriptBox["u", "10"], " ", 
             RowBox[{"(", 
              RowBox[{"3", "+", 
               RowBox[{"7", " ", 
                SubscriptBox[
                 StyleBox["\[Zeta]",
                  FontWeight->Bold,
                  FontColor->GrayLevel[0.4]], "3"]}]}], ")"}]}], "+", 
            RowBox[{"27", " ", 
             SuperscriptBox["u", "6"], " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"-", "271"}], "+", 
               RowBox[{"21", " ", 
                SubscriptBox[
                 StyleBox["\[Zeta]",
                  FontWeight->Bold,
                  FontColor->GrayLevel[0.4]], "3"]}]}], ")"}]}]}], ")"}]}]}], 
        ")"}]}]}]}], "]"}]}]}]], "Output",
 CellChangeTimes->{{3.555843819715083*^9, 3.555843866090838*^9}, {
   3.555843931459271*^9, 3.555843956989833*^9}, {3.555844078570904*^9, 
   3.555844134418425*^9}, {3.555844173723168*^9, 3.555844187199965*^9}, 
   3.555844256427011*^9, 3.555866572929612*^9, 3.5559599924269876`*^9, 
   3.5603370733973017`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"eqnT11ZeroAtBetheroot", "=", 
  RowBox[{"List", "@@", 
   RowBox[{"Collect", "[", 
    RowBox[{
     RowBox[{"tmp1", "-", "tmp2", "+", 
      RowBox[{
       SuperscriptBox["g", "8"], 
       RowBox[{"(", 
        RowBox[{
         SubscriptBox["W", 
          RowBox[{"1", ",", "v0", ",", "lead"}]], "+", 
         RowBox[{
          SuperscriptBox["g", "2"], 
          SubscriptBox["W", 
           RowBox[{"1", ",", "v0", ",", "sublead"}]]}], "+", 
         RowBox[{
          SuperscriptBox["g", "4"], 
          SubscriptBox["W", 
           RowBox[{"1", ",", "v0", ",", "sublead2"}]]}], "+", 
         RowBox[{
          SuperscriptBox["g", "6"], 
          SubscriptBox["W", 
           RowBox[{"1", ",", "v0", ",", "sublead3"}]]}]}], ")"}]}]}], ",", 
     "g"}], "]"}]}]}]], "Input",
 CellChangeTimes->{{3.555844188463277*^9, 3.5558442620339813`*^9}, {
  3.555866580019491*^9, 3.555866580747793*^9}, {3.555960009181939*^9, 
  3.55596001480512*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{
    SuperscriptBox["g", "8"], " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"3", " ", 
       RowBox[{"M", "[", 
        SubscriptBox["\[Delta]\[Rho]2", "lead"], "]"}]}], "-", 
      RowBox[{"\[DoubleStruckCapitalC]", "[", 
       RowBox[{"-", 
        FractionBox[
         RowBox[{"\[ImaginaryI]", " ", 
          RowBox[{"(", 
           RowBox[{"1", "+", 
            RowBox[{"3", " ", 
             SuperscriptBox["u", "2"]}]}], ")"}], " ", 
          SubscriptBox[
           StyleBox["W",
            FontColor->RGBColor[0.54, 0.35, 0.15]], "lead"]}], 
         RowBox[{"3", " ", 
          SuperscriptBox[
           StyleBox["Q0",
            FontColor->RGBColor[{
               Rational[1, 2], 
               Rational[1, 2], 0}]], "-"], " ", 
          SuperscriptBox[
           StyleBox["Q0",
            FontColor->RGBColor[{
               Rational[1, 2], 
               Rational[1, 2], 0}]], "+"]}]]}], "]"}], "+", 
      SubscriptBox[
       StyleBox["W",
        FontColor->RGBColor[0.54, 0.35, 0.15]], 
       RowBox[{"1", ",", "v0", ",", "lead"}]]}], ")"}]}], ",", 
   RowBox[{
    SuperscriptBox["g", "10"], " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       RowBox[{"-", "12"}], " ", 
       RowBox[{"M", "[", 
        SubscriptBox["\[Delta]\[Rho]2", "lead"], "]"}]}], "+", 
      RowBox[{"3", " ", 
       RowBox[{"M", "[", 
        SubscriptBox["\[Delta]\[Rho]2", "sublead"], "]"}]}], "-", 
      RowBox[{"\[DoubleStruckCapitalC]", "[", 
       RowBox[{"-", 
        FractionBox[
         RowBox[{"\[ImaginaryI]", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"4", " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"-", "1"}], "+", 
               RowBox[{"3", " ", 
                SuperscriptBox["u", "2"]}], "+", 
               RowBox[{"27", " ", 
                SuperscriptBox["u", "4"]}]}], ")"}], " ", 
             SubscriptBox[
              StyleBox["W",
               FontColor->RGBColor[0.54, 0.35, 0.15]], "lead"]}], "+", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{"1", "+", 
               RowBox[{"6", " ", 
                SuperscriptBox["u", "2"]}], "+", 
               RowBox[{"18", " ", 
                SuperscriptBox["u", "4"]}], "+", 
               RowBox[{"27", " ", 
                SuperscriptBox["u", "6"]}]}], ")"}], " ", 
             SubscriptBox[
              StyleBox["W",
               FontColor->RGBColor[0.54, 0.35, 0.15]], "sublead"]}]}], 
           ")"}]}], 
         RowBox[{"27", " ", 
          SuperscriptBox[
           RowBox[{"(", 
            SuperscriptBox[
             StyleBox["Q0",
              FontColor->RGBColor[{
                 Rational[1, 2], 
                 Rational[1, 2], 0}]], "-"], ")"}], "2"], " ", 
          SuperscriptBox[
           RowBox[{"(", 
            SuperscriptBox[
             StyleBox["Q0",
              FontColor->RGBColor[{
                 Rational[1, 2], 
                 Rational[1, 2], 0}]], "+"], ")"}], "2"]}]]}], "]"}], "+", 
      SubscriptBox[
       StyleBox["W",
        FontColor->RGBColor[0.54, 0.35, 0.15]], 
       RowBox[{"1", ",", "v0", ",", "sublead"}]]}], ")"}]}], ",", 
   RowBox[{
    SuperscriptBox["g", "12"], " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"30", " ", 
       RowBox[{"M", "[", 
        SubscriptBox["\[Delta]\[Rho]2", "lead"], "]"}]}], "+", 
      RowBox[{"432", " ", 
       RowBox[{"M", "[", 
        RowBox[{
         SuperscriptBox["w", "2"], " ", 
         SubscriptBox["\[Delta]\[Rho]2", "lead"]}], "]"}]}], "-", 
      RowBox[{"432", " ", 
       RowBox[{"M", "[", 
        RowBox[{
         SuperscriptBox["w", "4"], " ", 
         SubscriptBox["\[Delta]\[Rho]2", "lead"]}], "]"}]}], "-", 
      RowBox[{"12", " ", 
       RowBox[{"M", "[", 
        SubscriptBox["\[Delta]\[Rho]2", "sublead"], "]"}]}], "+", 
      RowBox[{"3", " ", 
       RowBox[{"M", "[", 
        SubscriptBox["\[Delta]\[Rho]2", "sublead2"], "]"}]}], "-", 
      RowBox[{"\[DoubleStruckCapitalC]", "[", 
       RowBox[{"-", 
        RowBox[{
         FractionBox["1", 
          RowBox[{"243", " ", 
           SuperscriptBox[
            RowBox[{"(", 
             SuperscriptBox[
              StyleBox["Q0",
               FontColor->RGBColor[{
                  Rational[1, 2], 
                  Rational[1, 2], 0}]], "-"], ")"}], "3"], " ", 
           SuperscriptBox[
            RowBox[{"(", 
             SuperscriptBox[
              StyleBox["Q0",
               FontColor->RGBColor[{
                  Rational[1, 2], 
                  Rational[1, 2], 0}]], "+"], ")"}], "3"]}]], 
         RowBox[{"\[ImaginaryI]", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"2", " ", 
             RowBox[{"(", 
              RowBox[{"5", "-", 
               RowBox[{"144", " ", 
                SuperscriptBox["u", "2"]}], "-", 
               RowBox[{"351", " ", 
                SuperscriptBox["u", "4"]}], "+", 
               RowBox[{"1404", " ", 
                SuperscriptBox["u", "6"]}], "+", 
               RowBox[{"729", " ", 
                SuperscriptBox["u", "8"]}]}], ")"}], " ", 
             SubscriptBox[
              StyleBox["W",
               FontColor->RGBColor[0.54, 0.35, 0.15]], "lead"]}], "+", 
            RowBox[{"9", " ", 
             SuperscriptBox[
              StyleBox["Q0",
               FontColor->RGBColor[{
                  Rational[1, 2], 
                  Rational[1, 2], 0}]], "-"], " ", 
             SuperscriptBox[
              StyleBox["Q0",
               FontColor->RGBColor[{
                  Rational[1, 2], 
                  Rational[1, 2], 0}]], "+"], " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"4", " ", 
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{"-", "1"}], "+", 
                  RowBox[{"3", " ", 
                   SuperscriptBox["u", "2"]}], "+", 
                  RowBox[{"27", " ", 
                   SuperscriptBox["u", "4"]}]}], ")"}], " ", 
                SubscriptBox[
                 StyleBox["W",
                  FontColor->RGBColor[0.54, 0.35, 0.15]], "sublead"]}], "+", 
               RowBox[{
                RowBox[{"(", 
                 RowBox[{"1", "+", 
                  RowBox[{"6", " ", 
                   SuperscriptBox["u", "2"]}], "+", 
                  RowBox[{"18", " ", 
                   SuperscriptBox["u", "4"]}], "+", 
                  RowBox[{"27", " ", 
                   SuperscriptBox["u", "6"]}]}], ")"}], " ", 
                SubscriptBox[
                 StyleBox["W",
                  FontColor->RGBColor[0.54, 0.35, 0.15]], "sublead2"]}]}], 
              ")"}]}]}], ")"}]}]}]}], "]"}], "+", 
      SubscriptBox[
       StyleBox["W",
        FontColor->RGBColor[0.54, 0.35, 0.15]], 
       RowBox[{"1", ",", "v0", ",", "sublead2"}]]}], ")"}]}], ",", 
   RowBox[{
    SuperscriptBox["g", "14"], " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"24", " ", 
       RowBox[{"M", "[", 
        SubscriptBox["\[Delta]\[Rho]2", "lead"], "]"}]}], "-", 
      RowBox[{"4536", " ", 
       RowBox[{"M", "[", 
        RowBox[{
         SuperscriptBox["w", "2"], " ", 
         SubscriptBox["\[Delta]\[Rho]2", "lead"]}], "]"}]}], "+", 
      RowBox[{"5184", " ", 
       RowBox[{"M", "[", 
        RowBox[{
         SuperscriptBox["w", "6"], " ", 
         SubscriptBox["\[Delta]\[Rho]2", "lead"]}], "]"}]}], "+", 
      RowBox[{"30", " ", 
       RowBox[{"M", "[", 
        SubscriptBox["\[Delta]\[Rho]2", "sublead"], "]"}]}], "+", 
      RowBox[{"432", " ", 
       RowBox[{"M", "[", 
        RowBox[{
         SuperscriptBox["w", "2"], " ", 
         SubscriptBox["\[Delta]\[Rho]2", "sublead"]}], "]"}]}], "-", 
      RowBox[{"432", " ", 
       RowBox[{"M", "[", 
        RowBox[{
         SuperscriptBox["w", "4"], " ", 
         SubscriptBox["\[Delta]\[Rho]2", "sublead"]}], "]"}]}], "-", 
      RowBox[{"12", " ", 
       RowBox[{"M", "[", 
        SubscriptBox["\[Delta]\[Rho]2", "sublead2"], "]"}]}], "+", 
      RowBox[{"3", " ", 
       RowBox[{"M", "[", 
        SubscriptBox["\[Delta]\[Rho]2", "sublead3"], "]"}]}], "-", 
      RowBox[{"\[DoubleStruckCapitalC]", "[", 
       RowBox[{"-", 
        RowBox[{
         FractionBox["1", 
          RowBox[{"2187", " ", 
           SuperscriptBox[
            RowBox[{"(", 
             SuperscriptBox[
              StyleBox["Q0",
               FontColor->RGBColor[{
                  Rational[1, 2], 
                  Rational[1, 2], 0}]], "-"], ")"}], "4"], " ", 
           SuperscriptBox[
            RowBox[{"(", 
             SuperscriptBox[
              StyleBox["Q0",
               FontColor->RGBColor[{
                  Rational[1, 2], 
                  Rational[1, 2], 0}]], "+"], ")"}], "4"]}]], 
         RowBox[{"\[ImaginaryI]", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"9", " ", 
             SuperscriptBox[
              StyleBox["Q0",
               FontColor->RGBColor[{
                  Rational[1, 2], 
                  Rational[1, 2], 0}]], "-"], " ", 
             SuperscriptBox[
              StyleBox["Q0",
               FontColor->RGBColor[{
                  Rational[1, 2], 
                  Rational[1, 2], 0}]], "+"], " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"2", " ", 
                RowBox[{"(", 
                 RowBox[{"5", "-", 
                  RowBox[{"144", " ", 
                   SuperscriptBox["u", "2"]}], "-", 
                  RowBox[{"351", " ", 
                   SuperscriptBox["u", "4"]}], "+", 
                  RowBox[{"1404", " ", 
                   SuperscriptBox["u", "6"]}], "+", 
                  RowBox[{"729", " ", 
                   SuperscriptBox["u", "8"]}]}], ")"}], " ", 
                SubscriptBox[
                 StyleBox["W",
                  FontColor->RGBColor[0.54, 0.35, 0.15]], "sublead"]}], "+", 
               RowBox[{"9", " ", 
                SuperscriptBox[
                 StyleBox["Q0",
                  FontColor->RGBColor[{
                    Rational[1, 2], 
                    Rational[1, 2], 0}]], "-"], " ", 
                SuperscriptBox[
                 StyleBox["Q0",
                  FontColor->RGBColor[{
                    Rational[1, 2], 
                    Rational[1, 2], 0}]], "+"], " ", 
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{"4", " ", 
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", "1"}], "+", 
                    RowBox[{"3", " ", 
                    SuperscriptBox["u", "2"]}], "+", 
                    RowBox[{"27", " ", 
                    SuperscriptBox["u", "4"]}]}], ")"}], " ", 
                   SubscriptBox[
                    StyleBox["W",
                    FontColor->RGBColor[0.54, 0.35, 0.15]], "sublead2"]}], 
                  "+", 
                  RowBox[{
                   RowBox[{"(", 
                    RowBox[{"1", "+", 
                    RowBox[{"6", " ", 
                    SuperscriptBox["u", "2"]}], "+", 
                    RowBox[{"18", " ", 
                    SuperscriptBox["u", "4"]}], "+", 
                    RowBox[{"27", " ", 
                    SuperscriptBox["u", "6"]}]}], ")"}], " ", 
                   SubscriptBox[
                    StyleBox["W",
                    FontColor->RGBColor[0.54, 0.35, 0.15]], "sublead3"]}]}], 
                 ")"}]}]}], ")"}]}], "+", 
            RowBox[{"8", " ", 
             SubscriptBox[
              StyleBox["W",
               FontColor->RGBColor[0.54, 0.35, 0.15]], "lead"], " ", 
             RowBox[{"(", 
              RowBox[{"1", "+", 
               RowBox[{
                SuperscriptBox["u", "2"], " ", 
                RowBox[{"(", 
                 RowBox[{"255", "-", 
                  RowBox[{"9", " ", 
                   SubscriptBox[
                    StyleBox["\[Zeta]",
                    FontWeight->Bold,
                    FontColor->GrayLevel[0.4]], "3"]}]}], ")"}]}], "+", 
               RowBox[{"54", " ", 
                SuperscriptBox["u", "4"], " ", 
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{"-", "16"}], "+", 
                  SubscriptBox[
                   StyleBox["\[Zeta]",
                    FontWeight->Bold,
                    FontColor->GrayLevel[0.4]], "3"]}], ")"}]}], "+", 
               RowBox[{"6561", " ", 
                SuperscriptBox["u", "12"], " ", 
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{"-", "1"}], "+", 
                  SubscriptBox[
                   StyleBox["\[Zeta]",
                    FontWeight->Bold,
                    FontColor->GrayLevel[0.4]], "3"]}], ")"}]}], "-", 
               RowBox[{"3", " ", 
                SubscriptBox[
                 StyleBox["\[Zeta]",
                  FontWeight->Bold,
                  FontColor->GrayLevel[0.4]], "3"]}], "+", 
               RowBox[{"810", " ", 
                SuperscriptBox["u", "8"], " ", 
                RowBox[{"(", 
                 RowBox[{"2", "+", 
                  RowBox[{"3", " ", 
                   SubscriptBox[
                    StyleBox["\[Zeta]",
                    FontWeight->Bold,
                    FontColor->GrayLevel[0.4]], "3"]}]}], ")"}]}], "+", 
               RowBox[{"729", " ", 
                SuperscriptBox["u", "10"], " ", 
                RowBox[{"(", 
                 RowBox[{"3", "+", 
                  RowBox[{"7", " ", 
                   SubscriptBox[
                    StyleBox["\[Zeta]",
                    FontWeight->Bold,
                    FontColor->GrayLevel[0.4]], "3"]}]}], ")"}]}], "+", 
               RowBox[{"27", " ", 
                SuperscriptBox["u", "6"], " ", 
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{"-", "271"}], "+", 
                  RowBox[{"21", " ", 
                   SubscriptBox[
                    StyleBox["\[Zeta]",
                    FontWeight->Bold,
                    FontColor->GrayLevel[0.4]], "3"]}]}], ")"}]}]}], 
              ")"}]}]}], ")"}]}]}]}], "]"}], "+", 
      SubscriptBox[
       StyleBox["W",
        FontColor->RGBColor[0.54, 0.35, 0.15]], 
       RowBox[{"1", ",", "v0", ",", "sublead3"}]], "-", 
      RowBox[{"72", " ", 
       RowBox[{"M", "[", 
        SubscriptBox["\[Delta]\[Rho]2", "lead"], "]"}], " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "3"]}]}], ")"}]}]}], "}"}]], "Output",
 CellChangeTimes->{3.555844262447709*^9, 3.555866581075091*^9, 
  3.555960015586829*^9, 3.560337075743939*^9}]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell["Final equations", "Subsection",
 CellChangeTimes->{{3.555844987646489*^9, 3.555844991397812*^9}, 
   3.5558665996040087`*^9}],

Cell["Equation coming from Y11Y22", "Text",
 CellChangeTimes->{{3.555844999063806*^9, 3.5558450101651487`*^9}}],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"{", 
   RowBox[{"ratioTright", ",", 
    RowBox[{"-", "ToTW1"}], ",", 
    RowBox[{"+", 
     RowBox[{"(", 
      RowBox[{
      "ratioq2Wint", "+", "ratioq2\[Delta]\[Rho]2", "+", "ratioq2Wmp0"}], 
      ")"}]}], ",", 
    RowBox[{"+", "T10contr"}], ",", 
    RowBox[{"-", "RHSHp"}]}], "}"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"tmp", "=", 
   RowBox[{"List", "@@", 
    RowBox[{"Collect", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"Series", "[", 
        RowBox[{
         RowBox[{"Total", "[", 
          RowBox[{"Normal", "/@", "%"}], "]"}], ",", 
         RowBox[{"{", 
          RowBox[{"g", ",", "0", ",", "14"}], "}"}]}], "]"}], "//", 
       "Normal"}], ",", "g"}], "]"}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"SortBy", "[", 
   RowBox[{"tmp", ",", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{"#", "//.", 
       RowBox[{
        RowBox[{"a_.", 
         SuperscriptBox["g", "b_."]}], "\[RuleDelayed]", 
        SuperscriptBox["g", "b"]}]}], ")"}], "&"}]}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"eqFromY11Y22", "=", 
  RowBox[{
   RowBox[{
    RowBox[{"Collect", "[", 
     RowBox[{
      RowBox[{"#", "//", "Expand"}], ",", 
      RowBox[{"{", 
       RowBox[{"g", ",", 
        SqrtBox[
         RowBox[{"1", "-", 
          SuperscriptBox["z", "2"]}]]}], "}"}], ",", "Simplify"}], "]"}], 
    "&"}], "/@", "%"}]}]}], "Input",
 CellChangeTimes->{{3.555844448462405*^9, 3.555844753426512*^9}, {
   3.555844795717238*^9, 3.555844841724825*^9}, {3.555844886719757*^9, 
   3.55584488681039*^9}, {3.5558450123693523`*^9, 3.555845017985017*^9}, 
   3.555845058832286*^9, 3.55585510125264*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{
    SuperscriptBox["g", "9"], " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"2", " ", 
       RowBox[{"(", 
        RowBox[{
         SubscriptBox["\[Delta]\[Rho]", "lead"], "+", 
         RowBox[{"6", " ", 
          RowBox[{"(", 
           RowBox[{"1", "-", 
            RowBox[{"2", " ", 
             SuperscriptBox["z", "2"]}]}], ")"}], " ", 
          SubscriptBox["\[Delta]\[Rho]2", "lead"]}]}], ")"}]}], "+", 
      RowBox[{
       SqrtBox[
        RowBox[{"1", "-", 
         SuperscriptBox["z", "2"]}]], " ", 
       RowBox[{"(", 
        RowBox[{"2268", "+", 
         RowBox[{"12", " ", 
          RowBox[{"M", "[", 
           SubscriptBox["\[Delta]\[Rho]2", "lead"], "]"}]}], "-", 
         RowBox[{"48", " ", "\[ImaginaryI]", " ", "z", " ", 
          RowBox[{"PV", "[", 
           SubscriptBox["\[Delta]\[Rho]2", "lead"], "]"}]}], "-", 
         RowBox[{"\[DoubleStruckCapitalC]", "[", 
          FractionBox[
           RowBox[{"4", " ", "\[ImaginaryI]", " ", 
            SubscriptBox[
             StyleBox["H",
              FontColor->RGBColor[0.54, 0.35, 0.15]], "lead"]}], 
           SuperscriptBox["u", "2"]], "]"}], "+", 
         RowBox[{"\[DoubleStruckCapitalC]", "[", 
          FractionBox[
           RowBox[{"12", " ", "\[ImaginaryI]", " ", 
            SubscriptBox[
             StyleBox["W",
              FontColor->RGBColor[0.54, 0.35, 0.15]], "lead"]}], 
           RowBox[{"1", "+", 
            SuperscriptBox["u", "2"]}]], "]"}], "-", 
         RowBox[{"1512", " ", 
          SubscriptBox[
           StyleBox["\[Zeta]",
            FontWeight->Bold,
            FontColor->GrayLevel[0.4]], "2"]}], "+", 
         FractionBox[
          RowBox[{"432", " ", 
           SubsuperscriptBox[
            StyleBox["\[Zeta]",
             FontWeight->Bold,
             FontColor->GrayLevel[0.4]], "2", "2"]}], "5"], "-", 
         RowBox[{"1512", " ", 
          SubscriptBox[
           StyleBox["\[Zeta]",
            FontWeight->Bold,
            FontColor->GrayLevel[0.4]], "3"]}], "+", 
         RowBox[{"1008", " ", 
          SubscriptBox[
           StyleBox["\[Zeta]",
            FontWeight->Bold,
            FontColor->GrayLevel[0.4]], "2"], " ", 
          SubscriptBox[
           StyleBox["\[Zeta]",
            FontWeight->Bold,
            FontColor->GrayLevel[0.4]], "3"]}], "-", 
         RowBox[{
          FractionBox["288", "5"], " ", 
          SubsuperscriptBox[
           StyleBox["\[Zeta]",
            FontWeight->Bold,
            FontColor->GrayLevel[0.4]], "2", "2"], " ", 
          SubscriptBox[
           StyleBox["\[Zeta]",
            FontWeight->Bold,
            FontColor->GrayLevel[0.4]], "3"]}]}], ")"}]}]}], ")"}]}], ",", 
   RowBox[{
    SuperscriptBox["g", "11"], " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"2", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          RowBox[{"-", "2"}], " ", 
          SuperscriptBox["z", "2"], " ", 
          SubscriptBox["\[Delta]\[Rho]", "lead"]}], "+", 
         SubscriptBox["\[Delta]\[Rho]", "sublead"], "-", 
         RowBox[{"33", " ", 
          SubscriptBox["\[Delta]\[Rho]2", "lead"]}], "+", 
         RowBox[{"6", " ", 
          SuperscriptBox["z", "2"], " ", 
          SubscriptBox["\[Delta]\[Rho]2", "lead"]}], "+", 
         RowBox[{"72", " ", 
          SuperscriptBox["z", "4"], " ", 
          SubscriptBox["\[Delta]\[Rho]2", "lead"]}], "+", 
         RowBox[{"6", " ", 
          SubscriptBox["\[Delta]\[Rho]2", "sublead"]}], "-", 
         RowBox[{"12", " ", 
          SuperscriptBox["z", "2"], " ", 
          SubscriptBox["\[Delta]\[Rho]2", "sublead"]}]}], ")"}]}], "+", 
      RowBox[{
       SqrtBox[
        RowBox[{"1", "-", 
         SuperscriptBox["z", "2"]}]], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", "59940"}], "-", 
         RowBox[{"28512", " ", 
          SuperscriptBox["z", "2"]}], "-", 
         RowBox[{"4", " ", 
          RowBox[{"M", "[", 
           SubscriptBox["\[Delta]\[Rho]", "lead"], "]"}]}], "-", 
         RowBox[{"288", " ", 
          SuperscriptBox["z", "2"], " ", 
          RowBox[{"M", "[", 
           SubscriptBox["\[Delta]\[Rho]2", "lead"], "]"}]}], "-", 
         RowBox[{"48", " ", 
          RowBox[{"M", "[", 
           RowBox[{
            SuperscriptBox["w", "2"], " ", 
            SubscriptBox["\[Delta]\[Rho]2", "lead"]}], "]"}]}], "+", 
         RowBox[{"12", " ", 
          RowBox[{"M", "[", 
           SubscriptBox["\[Delta]\[Rho]2", "sublead"], "]"}]}], "+", 
         RowBox[{"8", " ", "\[ImaginaryI]", " ", "z", " ", 
          RowBox[{"PV", "[", 
           SubscriptBox["\[Delta]\[Rho]", "lead"], "]"}]}], "+", 
         RowBox[{"168", " ", "\[ImaginaryI]", " ", "z", " ", 
          RowBox[{"PV", "[", 
           SubscriptBox["\[Delta]\[Rho]2", "lead"], "]"}]}], "+", 
         RowBox[{"288", " ", "\[ImaginaryI]", " ", 
          SuperscriptBox["z", "3"], " ", 
          RowBox[{"PV", "[", 
           SubscriptBox["\[Delta]\[Rho]2", "lead"], "]"}]}], "-", 
         RowBox[{"48", " ", "\[ImaginaryI]", " ", "z", " ", 
          RowBox[{"PV", "[", 
           SubscriptBox["\[Delta]\[Rho]2", "sublead"], "]"}]}], "-", 
         RowBox[{
          SuperscriptBox["z", "2"], " ", 
          RowBox[{"\[DoubleStruckCapitalC]", "[", 
           FractionBox[
            RowBox[{"16", " ", "\[ImaginaryI]", " ", 
             SubscriptBox[
              StyleBox["H",
               FontColor->RGBColor[0.54, 0.35, 0.15]], "lead"]}], 
            SuperscriptBox["u", "4"]], "]"}]}], "-", 
         RowBox[{"\[DoubleStruckCapitalC]", "[", 
          FractionBox[
           RowBox[{"4", " ", "\[ImaginaryI]", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"2", " ", 
               SubscriptBox[
                StyleBox["H",
                 FontColor->RGBColor[0.54, 0.35, 0.15]], "lead"]}], "+", 
              RowBox[{
               SuperscriptBox["u", "2"], " ", 
               SubscriptBox[
                StyleBox["H",
                 FontColor->RGBColor[0.54, 0.35, 0.15]], "sublead"]}]}], 
             ")"}]}], 
           SuperscriptBox["u", "4"]], "]"}], "+", 
         RowBox[{
          SuperscriptBox["z", "2"], " ", 
          RowBox[{"\[DoubleStruckCapitalC]", "[", 
           RowBox[{"-", 
            FractionBox[
             RowBox[{"48", " ", "\[ImaginaryI]", " ", 
              RowBox[{"(", 
               RowBox[{"2", "+", 
                RowBox[{"12", " ", 
                 SuperscriptBox["u", "2"]}], "+", 
                RowBox[{"9", " ", 
                 SuperscriptBox["u", "4"]}], "+", 
                RowBox[{"3", " ", 
                 SuperscriptBox["u", "6"]}]}], ")"}], " ", 
              SubscriptBox[
               StyleBox["W",
                FontColor->RGBColor[0.54, 0.35, 0.15]], "lead"]}], 
             RowBox[{
              SuperscriptBox["u", "2"], " ", 
              SuperscriptBox[
               RowBox[{"(", 
                RowBox[{"1", "+", 
                 SuperscriptBox["u", "2"]}], ")"}], "3"]}]]}], "]"}]}], "+", 
         RowBox[{"\[DoubleStruckCapitalC]", "[", 
          FractionBox[
           RowBox[{"12", " ", "\[ImaginaryI]", " ", 
            SubscriptBox[
             StyleBox["W",
              FontColor->RGBColor[0.54, 0.35, 0.15]], "sublead"]}], 
           RowBox[{"1", "+", 
            SuperscriptBox["u", "2"]}]], "]"}], "+", 
         RowBox[{"15768", " ", 
          SubscriptBox[
           StyleBox["\[Zeta]",
            FontWeight->Bold,
            FontColor->GrayLevel[0.4]], "2"]}], "+", 
         RowBox[{"37152", " ", 
          SuperscriptBox["z", "2"], " ", 
          SubscriptBox[
           StyleBox["\[Zeta]",
            FontWeight->Bold,
            FontColor->GrayLevel[0.4]], "2"]}], "+", 
         FractionBox[
          RowBox[{"33696", " ", 
           SubsuperscriptBox[
            StyleBox["\[Zeta]",
             FontWeight->Bold,
             FontColor->GrayLevel[0.4]], "2", "2"]}], "5"], "-", 
         RowBox[{
          FractionBox["15552", "5"], " ", 
          SuperscriptBox["z", "2"], " ", 
          SubsuperscriptBox[
           StyleBox["\[Zeta]",
            FontWeight->Bold,
            FontColor->GrayLevel[0.4]], "2", "2"]}], "-", 
         FractionBox[
          RowBox[{"26784", " ", 
           SubsuperscriptBox[
            StyleBox["\[Zeta]",
             FontWeight->Bold,
             FontColor->GrayLevel[0.4]], "2", "3"]}], "7"], "-", 
         RowBox[{
          FractionBox["13824", "7"], " ", 
          SuperscriptBox["z", "2"], " ", 
          SubsuperscriptBox[
           StyleBox["\[Zeta]",
            FontWeight->Bold,
            FontColor->GrayLevel[0.4]], "2", "3"]}], "+", 
         FractionBox[
          RowBox[{"5184", " ", 
           SubsuperscriptBox[
            StyleBox["\[Zeta]",
             FontWeight->Bold,
             FontColor->GrayLevel[0.4]], "2", "4"]}], "25"], "+", 
         RowBox[{"52056", " ", 
          SubscriptBox[
           StyleBox["\[Zeta]",
            FontWeight->Bold,
            FontColor->GrayLevel[0.4]], "3"]}], "-", 
         RowBox[{"35424", " ", 
          SuperscriptBox["z", "2"], " ", 
          SubscriptBox[
           StyleBox["\[Zeta]",
            FontWeight->Bold,
            FontColor->GrayLevel[0.4]], "3"]}], "+", 
         RowBox[{"2160", " ", 
          SubscriptBox[
           StyleBox["\[Zeta]",
            FontWeight->Bold,
            FontColor->GrayLevel[0.4]], "2"], " ", 
          SubscriptBox[
           StyleBox["\[Zeta]",
            FontWeight->Bold,
            FontColor->GrayLevel[0.4]], "3"]}], "-", 
         RowBox[{"576", " ", 
          SuperscriptBox["z", "2"], " ", 
          SubscriptBox[
           StyleBox["\[Zeta]",
            FontWeight->Bold,
            FontColor->GrayLevel[0.4]], "2"], " ", 
          SubscriptBox[
           StyleBox["\[Zeta]",
            FontWeight->Bold,
            FontColor->GrayLevel[0.4]], "3"]}], "-", 
         RowBox[{"1440", " ", 
          SubsuperscriptBox[
           StyleBox["\[Zeta]",
            FontWeight->Bold,
            FontColor->GrayLevel[0.4]], "2", "2"], " ", 
          SubscriptBox[
           StyleBox["\[Zeta]",
            FontWeight->Bold,
            FontColor->GrayLevel[0.4]], "3"]}], "+", 
         RowBox[{
          FractionBox["27648", "5"], " ", 
          SuperscriptBox["z", "2"], " ", 
          SubsuperscriptBox[
           StyleBox["\[Zeta]",
            FontWeight->Bold,
            FontColor->GrayLevel[0.4]], "2", "2"], " ", 
          SubscriptBox[
           StyleBox["\[Zeta]",
            FontWeight->Bold,
            FontColor->GrayLevel[0.4]], "3"]}], "+", 
         RowBox[{
          FractionBox["4608", "35"], " ", 
          SubsuperscriptBox[
           StyleBox["\[Zeta]",
            FontWeight->Bold,
            FontColor->GrayLevel[0.4]], "2", "3"], " ", 
          SubscriptBox[
           StyleBox["\[Zeta]",
            FontWeight->Bold,
            FontColor->GrayLevel[0.4]], "3"]}], "+", 
         RowBox[{
          FractionBox["9216", "7"], " ", 
          SuperscriptBox["z", "2"], " ", 
          SubsuperscriptBox[
           StyleBox["\[Zeta]",
            FontWeight->Bold,
            FontColor->GrayLevel[0.4]], "2", "3"], " ", 
          SubscriptBox[
           StyleBox["\[Zeta]",
            FontWeight->Bold,
            FontColor->GrayLevel[0.4]], "3"]}], "-", 
         RowBox[{"18144", " ", 
          SubsuperscriptBox[
           StyleBox["\[Zeta]",
            FontWeight->Bold,
            FontColor->GrayLevel[0.4]], "3", "2"]}], "-", 
         RowBox[{"1728", " ", 
          SubscriptBox[
           StyleBox["\[Zeta]",
            FontWeight->Bold,
            FontColor->GrayLevel[0.4]], "2"], " ", 
          SubsuperscriptBox[
           StyleBox["\[Zeta]",
            FontWeight->Bold,
            FontColor->GrayLevel[0.4]], "3", "2"]}], "-", 
         RowBox[{"1944", " ", 
          SubscriptBox[
           StyleBox["\[Zeta]",
            FontWeight->Bold,
            FontColor->GrayLevel[0.4]], "5"]}], "+", 
         RowBox[{"46656", " ", 
          SuperscriptBox["z", "2"], " ", 
          SubscriptBox[
           StyleBox["\[Zeta]",
            FontWeight->Bold,
            FontColor->GrayLevel[0.4]], "5"]}], "-", 
         RowBox[{"3024", " ", 
          SubscriptBox[
           StyleBox["\[Zeta]",
            FontWeight->Bold,
            FontColor->GrayLevel[0.4]], "2"], " ", 
          SubscriptBox[
           StyleBox["\[Zeta]",
            FontWeight->Bold,
            FontColor->GrayLevel[0.4]], "5"]}], "-", 
         RowBox[{"24192", " ", 
          SuperscriptBox["z", "2"], " ", 
          SubscriptBox[
           StyleBox["\[Zeta]",
            FontWeight->Bold,
            FontColor->GrayLevel[0.4]], "2"], " ", 
          SubscriptBox[
           StyleBox["\[Zeta]",
            FontWeight->Bold,
            FontColor->GrayLevel[0.4]], "5"]}], "+", 
         RowBox[{
          FractionBox["864", "5"], " ", 
          SubsuperscriptBox[
           StyleBox["\[Zeta]",
            FontWeight->Bold,
            FontColor->GrayLevel[0.4]], "2", "2"], " ", 
          SubscriptBox[
           StyleBox["\[Zeta]",
            FontWeight->Bold,
            FontColor->GrayLevel[0.4]], "5"]}], "-", 
         RowBox[{
          FractionBox["6912", "5"], " ", 
          SuperscriptBox["z", "2"], " ", 
          SubsuperscriptBox[
           StyleBox["\[Zeta]",
            FontWeight->Bold,
            FontColor->GrayLevel[0.4]], "2", "2"], " ", 
          SubscriptBox[
           StyleBox["\[Zeta]",
            FontWeight->Bold,
            FontColor->GrayLevel[0.4]], "5"]}], "+", 
         RowBox[{"4320", " ", 
          SubscriptBox[
           StyleBox["\[Zeta]",
            FontWeight->Bold,
            FontColor->GrayLevel[0.4]], "3"], " ", 
          SubscriptBox[
           StyleBox["\[Zeta]",
            FontWeight->Bold,
            FontColor->GrayLevel[0.4]], "5"]}]}], ")"}]}]}], ")"}]}], ",", 
   RowBox[{
    SuperscriptBox["g", "13"], " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"2", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{"-", "3"}], "+", 
            RowBox[{"18", " ", 
             SuperscriptBox["z", "2"]}], "+", 
            RowBox[{"8", " ", 
             SuperscriptBox["z", "4"]}]}], ")"}], " ", 
          SubscriptBox["\[Delta]\[Rho]", "lead"]}], "-", 
         RowBox[{"2", " ", 
          SuperscriptBox["z", "2"], " ", 
          SubscriptBox["\[Delta]\[Rho]", "sublead"]}], "+", 
         SubscriptBox["\[Delta]\[Rho]", "sublead2"], "+", 
         RowBox[{"150", " ", 
          SubscriptBox["\[Delta]\[Rho]2", "lead"]}], "+", 
         RowBox[{"1128", " ", 
          SuperscriptBox["z", "2"], " ", 
          SubscriptBox["\[Delta]\[Rho]2", "lead"]}], "-", 
         RowBox[{"2496", " ", 
          SuperscriptBox["z", "4"], " ", 
          SubscriptBox["\[Delta]\[Rho]2", "lead"]}], "+", 
         RowBox[{"864", " ", 
          SuperscriptBox["z", "6"], " ", 
          SubscriptBox["\[Delta]\[Rho]2", "lead"]}], "-", 
         RowBox[{"33", " ", 
          SubscriptBox["\[Delta]\[Rho]2", "sublead"]}], "+", 
         RowBox[{"6", " ", 
          SuperscriptBox["z", "2"], " ", 
          SubscriptBox["\[Delta]\[Rho]2", "sublead"]}], "+", 
         RowBox[{"72", " ", 
          SuperscriptBox["z", "4"], " ", 
          SubscriptBox["\[Delta]\[Rho]2", "sublead"]}], "+", 
         RowBox[{"6", " ", 
          SubscriptBox["\[Delta]\[Rho]2", "sublead2"]}], "-", 
         RowBox[{"12", " ", 
          SuperscriptBox["z", "2"], " ", 
          SubscriptBox["\[Delta]\[Rho]2", "sublead2"]}]}], ")"}]}], "+", 
      RowBox[{
       SqrtBox[
        RowBox[{"1", "-", 
         SuperscriptBox["z", "2"]}]], " ", 
       RowBox[{"(", 
        RowBox[{"1044252", "+", 
         RowBox[{"1187136", " ", 
          SuperscriptBox["z", "2"]}], "+", 
         RowBox[{"20736", " ", 
          SuperscriptBox["z", "4"]}], "+", 
         RowBox[{"16", " ", 
          RowBox[{"(", 
           RowBox[{"1", "+", 
            RowBox[{"3", " ", 
             SuperscriptBox["z", "2"]}]}], ")"}], " ", 
          RowBox[{"M", "[", 
           SubscriptBox["\[Delta]\[Rho]", "lead"], "]"}]}], "+", 
         RowBox[{"16", " ", 
          RowBox[{"M", "[", 
           RowBox[{
            SuperscriptBox["w", "2"], " ", 
            SubscriptBox["\[Delta]\[Rho]", "lead"]}], "]"}]}], "-", 
         RowBox[{"4", " ", 
          RowBox[{"M", "[", 
           SubscriptBox["\[Delta]\[Rho]", "sublead"], "]"}]}], "-", 
         RowBox[{"192", " ", 
          RowBox[{"M", "[", 
           SubscriptBox["\[Delta]\[Rho]2", "lead"], "]"}]}], "+", 
         RowBox[{"1872", " ", 
          SuperscriptBox["z", "2"], " ", 
          RowBox[{"M", "[", 
           SubscriptBox["\[Delta]\[Rho]2", "lead"], "]"}]}], "+", 
         RowBox[{"1728", " ", 
          SuperscriptBox["z", "4"], " ", 
          RowBox[{"M", "[", 
           SubscriptBox["\[Delta]\[Rho]2", "lead"], "]"}]}], "+", 
         RowBox[{"2880", " ", 
          SuperscriptBox["z", "2"], " ", 
          RowBox[{"M", "[", 
           RowBox[{
            SuperscriptBox["w", "2"], " ", 
            SubscriptBox["\[Delta]\[Rho]2", "lead"]}], "]"}]}], "+", 
         RowBox[{"192", " ", 
          RowBox[{"M", "[", 
           RowBox[{
            SuperscriptBox["w", "4"], " ", 
            SubscriptBox["\[Delta]\[Rho]2", "lead"]}], "]"}]}], "-", 
         RowBox[{"288", " ", 
          SuperscriptBox["z", "2"], " ", 
          RowBox[{"M", "[", 
           SubscriptBox["\[Delta]\[Rho]2", "sublead"], "]"}]}], "-", 
         RowBox[{"48", " ", 
          RowBox[{"M", "[", 
           RowBox[{
            SuperscriptBox["w", "2"], " ", 
            SubscriptBox["\[Delta]\[Rho]2", "sublead"]}], "]"}]}], "+", 
         RowBox[{"12", " ", 
          RowBox[{"M", "[", 
           SubscriptBox["\[Delta]\[Rho]2", "sublead2"], "]"}]}], "-", 
         RowBox[{"72", " ", "\[ImaginaryI]", " ", "z", " ", 
          RowBox[{"PV", "[", 
           SubscriptBox["\[Delta]\[Rho]", "lead"], "]"}]}], "-", 
         RowBox[{"32", " ", "\[ImaginaryI]", " ", 
          SuperscriptBox["z", "3"], " ", 
          RowBox[{"PV", "[", 
           SubscriptBox["\[Delta]\[Rho]", "lead"], "]"}]}], "+", 
         RowBox[{"8", " ", "\[ImaginaryI]", " ", "z", " ", 
          RowBox[{"PV", "[", 
           SubscriptBox["\[Delta]\[Rho]", "sublead"], "]"}]}], "+", 
         RowBox[{"768", " ", "\[ImaginaryI]", " ", "z", " ", 
          RowBox[{"PV", "[", 
           SubscriptBox["\[Delta]\[Rho]2", "lead"], "]"}]}], "-", 
         RowBox[{"8256", " ", "\[ImaginaryI]", " ", 
          SuperscriptBox["z", "3"], " ", 
          RowBox[{"PV", "[", 
           SubscriptBox["\[Delta]\[Rho]2", "lead"], "]"}]}], "+", 
         RowBox[{"3456", " ", "\[ImaginaryI]", " ", 
          SuperscriptBox["z", "5"], " ", 
          RowBox[{"PV", "[", 
           SubscriptBox["\[Delta]\[Rho]2", "lead"], "]"}]}], "+", 
         RowBox[{"168", " ", "\[ImaginaryI]", " ", "z", " ", 
          RowBox[{"PV", "[", 
           SubscriptBox["\[Delta]\[Rho]2", "sublead"], "]"}]}], "+", 
         RowBox[{"288", " ", "\[ImaginaryI]", " ", 
          SuperscriptBox["z", "3"], " ", 
          RowBox[{"PV", "[", 
           SubscriptBox["\[Delta]\[Rho]2", "sublead"], "]"}]}], "-", 
         RowBox[{"48", " ", "\[ImaginaryI]", " ", "z", " ", 
          RowBox[{"PV", "[", 
           SubscriptBox["\[Delta]\[Rho]2", "sublead2"], "]"}]}], "-", 
         RowBox[{
          SuperscriptBox["z", "4"], " ", 
          RowBox[{"\[DoubleStruckCapitalC]", "[", 
           FractionBox[
            RowBox[{"64", " ", "\[ImaginaryI]", " ", 
             SubscriptBox[
              StyleBox["H",
               FontColor->RGBColor[0.54, 0.35, 0.15]], "lead"]}], 
            SuperscriptBox["u", "6"]], "]"}]}], "-", 
         RowBox[{
          SuperscriptBox["z", "2"], " ", 
          RowBox[{"\[DoubleStruckCapitalC]", "[", 
           FractionBox[
            RowBox[{"16", " ", "\[ImaginaryI]", " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"2", " ", 
                SubscriptBox[
                 StyleBox["H",
                  FontColor->RGBColor[0.54, 0.35, 0.15]], "lead"]}], "+", 
               RowBox[{
                SuperscriptBox["u", "2"], " ", 
                SubscriptBox[
                 StyleBox["H",
                  FontColor->RGBColor[0.54, 0.35, 0.15]], "sublead"]}]}], 
              ")"}]}], 
            SuperscriptBox["u", "6"]], "]"}]}], "-", 
         RowBox[{"\[DoubleStruckCapitalC]", "[", 
          FractionBox[
           RowBox[{"4", " ", "\[ImaginaryI]", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"6", " ", 
               SubscriptBox[
                StyleBox["H",
                 FontColor->RGBColor[0.54, 0.35, 0.15]], "lead"]}], "+", 
              RowBox[{"2", " ", 
               SuperscriptBox["u", "2"], " ", 
               SubscriptBox[
                StyleBox["H",
                 FontColor->RGBColor[0.54, 0.35, 0.15]], "sublead"]}], "+", 
              RowBox[{
               SuperscriptBox["u", "4"], " ", 
               SubscriptBox[
                StyleBox["H",
                 FontColor->RGBColor[0.54, 0.35, 0.15]], "sublead2"]}]}], 
             ")"}]}], 
           SuperscriptBox["u", "6"]], "]"}], "+", 
         RowBox[{"\[DoubleStruckCapitalC]", "[", 
          RowBox[{"-", 
           FractionBox[
            RowBox[{"192", " ", "\[ImaginaryI]", " ", 
             SubscriptBox[
              StyleBox["W",
               FontColor->RGBColor[0.54, 0.35, 0.15]], "lead"]}], 
            RowBox[{"1", "+", 
             SuperscriptBox["u", "2"]}]]}], "]"}], "+", 
         RowBox[{
          SuperscriptBox["z", "2"], " ", 
          RowBox[{"\[DoubleStruckCapitalC]", "[", 
           FractionBox[
            RowBox[{"48", " ", "\[ImaginaryI]", " ", 
             RowBox[{"(", 
              RowBox[{"7", "+", 
               RowBox[{"53", " ", 
                SuperscriptBox["u", "2"]}], "+", 
               RowBox[{"32", " ", 
                SuperscriptBox["u", "4"]}]}], ")"}], " ", 
             SubscriptBox[
              StyleBox["W",
               FontColor->RGBColor[0.54, 0.35, 0.15]], "lead"]}], 
            SuperscriptBox[
             RowBox[{"(", 
              RowBox[{"u", "+", 
               SuperscriptBox["u", "3"]}], ")"}], "2"]], "]"}]}], "+", 
         RowBox[{
          SuperscriptBox["z", "4"], " ", 
          RowBox[{"\[DoubleStruckCapitalC]", "[", 
           RowBox[{"-", 
            FractionBox[
             RowBox[{"192", " ", "\[ImaginaryI]", " ", 
              RowBox[{"(", 
               RowBox[{"2", "+", 
                RowBox[{"7", " ", 
                 SuperscriptBox["u", "2"]}], "-", 
                RowBox[{"4", " ", 
                 SuperscriptBox["u", "4"]}], "+", 
                RowBox[{"7", " ", 
                 SuperscriptBox["u", "6"]}]}], ")"}], " ", 
              SubscriptBox[
               StyleBox["W",
                FontColor->RGBColor[0.54, 0.35, 0.15]], "lead"]}], 
             RowBox[{
              SuperscriptBox["u", "4"], " ", 
              SuperscriptBox[
               RowBox[{"(", 
                RowBox[{"1", "+", 
                 SuperscriptBox["u", "2"]}], ")"}], "5"]}]]}], "]"}]}], "+", 
         RowBox[{
          SuperscriptBox["z", "2"], " ", 
          RowBox[{"\[DoubleStruckCapitalC]", "[", 
           RowBox[{"-", 
            FractionBox[
             RowBox[{"48", " ", "\[ImaginaryI]", " ", 
              RowBox[{"(", 
               RowBox[{"2", "+", 
                RowBox[{"12", " ", 
                 SuperscriptBox["u", "2"]}], "+", 
                RowBox[{"9", " ", 
                 SuperscriptBox["u", "4"]}], "+", 
                RowBox[{"3", " ", 
                 SuperscriptBox["u", "6"]}]}], ")"}], " ", 
              SubscriptBox[
               StyleBox["W",
                FontColor->RGBColor[0.54, 0.35, 0.15]], "sublead"]}], 
             RowBox[{
              SuperscriptBox["u", "2"], " ", 
              SuperscriptBox[
               RowBox[{"(", 
                RowBox[{"1", "+", 
                 SuperscriptBox["u", "2"]}], ")"}], "3"]}]]}], "]"}]}], "+", 
         RowBox[{"\[DoubleStruckCapitalC]", "[", 
          FractionBox[
           RowBox[{"12", " ", "\[ImaginaryI]", " ", 
            SubscriptBox[
             StyleBox["W",
              FontColor->RGBColor[0.54, 0.35, 0.15]], "sublead2"]}], 
           RowBox[{"1", "+", 
            SuperscriptBox["u", "2"]}]], "]"}], "-", 
         RowBox[{"65880", " ", 
          SubscriptBox[
           StyleBox["\[Zeta]",
            FontWeight->Bold,
            FontColor->GrayLevel[0.4]], "2"]}], "-", 
         RowBox[{"749088", " ", 
          SuperscriptBox["z", "2"], " ", 
          SubscriptBox[
           StyleBox["\[Zeta]",
            FontWeight->Bold,
            FontColor->GrayLevel[0.4]], "2"]}], "-", 
         RowBox[{"241920", " ", 
          SuperscriptBox["z", "4"], " ", 
          SubscriptBox[
           StyleBox["\[Zeta]",
            FontWeight->Bold,
            FontColor->GrayLevel[0.4]], "2"]}], "-", 
         FractionBox[
          RowBox[{"1349136", " ", 
           SubsuperscriptBox[
            StyleBox["\[Zeta]",
             FontWeight->Bold,
             FontColor->GrayLevel[0.4]], "2", "2"]}], "5"], "+", 
         RowBox[{"373248", " ", 
          SuperscriptBox["z", "2"], " ", 
          SubsuperscriptBox[
           StyleBox["\[Zeta]",
            FontWeight->Bold,
            FontColor->GrayLevel[0.4]], "2", "2"]}], "-", 
         RowBox[{
          FractionBox["1181952", "5"], " ", 
          SuperscriptBox["z", "4"], " ", 
          SubsuperscriptBox[
           StyleBox["\[Zeta]",
            FontWeight->Bold,
            FontColor->GrayLevel[0.4]], "2", "2"]}], "+", 
         FractionBox[
          RowBox[{"266976", " ", 
           SubsuperscriptBox[
            StyleBox["\[Zeta]",
             FontWeight->Bold,
             FontColor->GrayLevel[0.4]], "2", "3"]}], "35"], "-", 
         RowBox[{
          FractionBox["3929472", "35"], " ", 
          SuperscriptBox["z", "2"], " ", 
          SubsuperscriptBox[
           StyleBox["\[Zeta]",
            FontWeight->Bold,
            FontColor->GrayLevel[0.4]], "2", "3"]}], "+", 
         RowBox[{
          FractionBox["691200", "7"], " ", 
          SuperscriptBox["z", "4"], " ", 
          SubsuperscriptBox[
           StyleBox["\[Zeta]",
            FontWeight->Bold,
            FontColor->GrayLevel[0.4]], "2", "3"]}], "+", 
         FractionBox[
          RowBox[{"378432", " ", 
           SubsuperscriptBox[
            StyleBox["\[Zeta]",
             FontWeight->Bold,
             FontColor->GrayLevel[0.4]], "2", "4"]}], "25"], "+", 
         RowBox[{
          FractionBox["407808", "25"], " ", 
          SuperscriptBox["z", "2"], " ", 
          SubsuperscriptBox[
           StyleBox["\[Zeta]",
            FontWeight->Bold,
            FontColor->GrayLevel[0.4]], "2", "4"]}], "+", 
         RowBox[{
          FractionBox["82944", "5"], " ", 
          SuperscriptBox["z", "4"], " ", 
          SubsuperscriptBox[
           StyleBox["\[Zeta]",
            FontWeight->Bold,
            FontColor->GrayLevel[0.4]], "2", "4"]}], "-", 
         FractionBox[
          RowBox[{"186624", " ", 
           SubsuperscriptBox[
            StyleBox["\[Zeta]",
             FontWeight->Bold,
             FontColor->GrayLevel[0.4]], "2", "5"]}], "175"], "-", 
         RowBox[{"589464", " ", 
          SubscriptBox[
           StyleBox["\[Zeta]",
            FontWeight->Bold,
            FontColor->GrayLevel[0.4]], "3"]}], "-", 
         RowBox[{"593568", " ", 
          SuperscriptBox["z", "2"], " ", 
          SubscriptBox[
           StyleBox["\[Zeta]",
            FontWeight->Bold,
            FontColor->GrayLevel[0.4]], "3"]}], "+", 
         RowBox[{"670464", " ", 
          SuperscriptBox["z", "4"], " ", 
          SubscriptBox[
           StyleBox["\[Zeta]",
            FontWeight->Bold,
            FontColor->GrayLevel[0.4]], "3"]}], "-", 
         RowBox[{"62928", " ", 
          SubscriptBox[
           StyleBox["\[Zeta]",
            FontWeight->Bold,
            FontColor->GrayLevel[0.4]], "2"], " ", 
          SubscriptBox[
           StyleBox["\[Zeta]",
            FontWeight->Bold,
            FontColor->GrayLevel[0.4]], "3"]}], "-", 
         RowBox[{"21312", " ", 
          SuperscriptBox["z", "2"], " ", 
          SubscriptBox[
           StyleBox["\[Zeta]",
            FontWeight->Bold,
            FontColor->GrayLevel[0.4]], "2"], " ", 
          SubscriptBox[
           StyleBox["\[Zeta]",
            FontWeight->Bold,
            FontColor->GrayLevel[0.4]], "3"]}], "+", 
         RowBox[{"2304", " ", 
          SuperscriptBox["z", "4"], " ", 
          SubscriptBox[
           StyleBox["\[Zeta]",
            FontWeight->Bold,
            FontColor->GrayLevel[0.4]], "2"], " ", 
          SubscriptBox[
           StyleBox["\[Zeta]",
            FontWeight->Bold,
            FontColor->GrayLevel[0.4]], "3"]}], "+", 
         RowBox[{
          FractionBox["810432", "5"], " ", 
          SubsuperscriptBox[
           StyleBox["\[Zeta]",
            FontWeight->Bold,
            FontColor->GrayLevel[0.4]], "2", "2"], " ", 
          SubscriptBox[
           StyleBox["\[Zeta]",
            FontWeight->Bold,
            FontColor->GrayLevel[0.4]], "3"]}], "-", 
         RowBox[{"27648", " ", 
          SuperscriptBox["z", "2"], " ", 
          SubsuperscriptBox[
           StyleBox["\[Zeta]",
            FontWeight->Bold,
            FontColor->GrayLevel[0.4]], "2", "2"], " ", 
          SubscriptBox[
           StyleBox["\[Zeta]",
            FontWeight->Bold,
            FontColor->GrayLevel[0.4]], "3"]}], "+", 
         RowBox[{"13824", " ", 
          SuperscriptBox["z", "4"], " ", 
          SubsuperscriptBox[
           StyleBox["\[Zeta]",
            FontWeight->Bold,
            FontColor->GrayLevel[0.4]], "2", "2"], " ", 
          SubscriptBox[
           StyleBox["\[Zeta]",
            FontWeight->Bold,
            FontColor->GrayLevel[0.4]], "3"]}], "+", 
         RowBox[{
          FractionBox["19584", "7"], " ", 
          SubsuperscriptBox[
           StyleBox["\[Zeta]",
            FontWeight->Bold,
            FontColor->GrayLevel[0.4]], "2", "3"], " ", 
          SubscriptBox[
           StyleBox["\[Zeta]",
            FontWeight->Bold,
            FontColor->GrayLevel[0.4]], "3"]}], "+", 
         RowBox[{
          FractionBox["18432", "5"], " ", 
          SuperscriptBox["z", "2"], " ", 
          SubsuperscriptBox[
           StyleBox["\[Zeta]",
            FontWeight->Bold,
            FontColor->GrayLevel[0.4]], "2", "3"], " ", 
          SubscriptBox[
           StyleBox["\[Zeta]",
            FontWeight->Bold,
            FontColor->GrayLevel[0.4]], "3"]}], "-", 
         RowBox[{
          FractionBox["497664", "7"], " ", 
          SuperscriptBox["z", "4"], " ", 
          SubsuperscriptBox[
           StyleBox["\[Zeta]",
            FontWeight->Bold,
            FontColor->GrayLevel[0.4]], "2", "3"], " ", 
          SubscriptBox[
           StyleBox["\[Zeta]",
            FontWeight->Bold,
            FontColor->GrayLevel[0.4]], "3"]}], "-", 
         RowBox[{
          FractionBox["6912", "25"], " ", 
          SubsuperscriptBox[
           StyleBox["\[Zeta]",
            FontWeight->Bold,
            FontColor->GrayLevel[0.4]], "2", "4"], " ", 
          SubscriptBox[
           StyleBox["\[Zeta]",
            FontWeight->Bold,
            FontColor->GrayLevel[0.4]], "3"]}], "-", 
         RowBox[{
          FractionBox["165888", "25"], " ", 
          SuperscriptBox["z", "2"], " ", 
          SubsuperscriptBox[
           StyleBox["\[Zeta]",
            FontWeight->Bold,
            FontColor->GrayLevel[0.4]], "2", "4"], " ", 
          SubscriptBox[
           StyleBox["\[Zeta]",
            FontWeight->Bold,
            FontColor->GrayLevel[0.4]], "3"]}], "-", 
         RowBox[{
          FractionBox["55296", "5"], " ", 
          SuperscriptBox["z", "4"], " ", 
          SubsuperscriptBox[
           StyleBox["\[Zeta]",
            FontWeight->Bold,
            FontColor->GrayLevel[0.4]], "2", "4"], " ", 
          SubscriptBox[
           StyleBox["\[Zeta]",
            FontWeight->Bold,
            FontColor->GrayLevel[0.4]], "3"]}], "+", 
         RowBox[{"2592", " ", 
          SubsuperscriptBox[
           StyleBox["\[Zeta]",
            FontWeight->Bold,
            FontColor->GrayLevel[0.4]], "3", "2"]}], "+", 
         RowBox[{"150336", " ", 
          SuperscriptBox["z", "2"], " ", 
          SubsuperscriptBox[
           StyleBox["\[Zeta]",
            FontWeight->Bold,
            FontColor->GrayLevel[0.4]], "3", "2"]}], "-", 
         RowBox[{"24192", " ", 
          SubscriptBox[
           StyleBox["\[Zeta]",
            FontWeight->Bold,
            FontColor->GrayLevel[0.4]], "2"], " ", 
          SubsuperscriptBox[
           StyleBox["\[Zeta]",
            FontWeight->Bold,
            FontColor->GrayLevel[0.4]], "3", "2"]}], "-", 
         RowBox[{"3456", " ", 
          SuperscriptBox["z", "2"], " ", 
          SubscriptBox[
           StyleBox["\[Zeta]",
            FontWeight->Bold,
            FontColor->GrayLevel[0.4]], "2"], " ", 
          SubsuperscriptBox[
           StyleBox["\[Zeta]",
            FontWeight->Bold,
            FontColor->GrayLevel[0.4]], "3", "2"]}], "+", 
         RowBox[{
          FractionBox["3456", "5"], " ", 
          SubsuperscriptBox[
           StyleBox["\[Zeta]",
            FontWeight->Bold,
            FontColor->GrayLevel[0.4]], "2", "2"], " ", 
          SubsuperscriptBox[
           StyleBox["\[Zeta]",
            FontWeight->Bold,
            FontColor->GrayLevel[0.4]], "3", "2"]}], "+", 
         RowBox[{
          FractionBox["6912", "5"], " ", 
          SuperscriptBox["z", "2"], " ", 
          SubsuperscriptBox[
           StyleBox["\[Zeta]",
            FontWeight->Bold,
            FontColor->GrayLevel[0.4]], "2", "2"], " ", 
          SubsuperscriptBox[
           StyleBox["\[Zeta]",
            FontWeight->Bold,
            FontColor->GrayLevel[0.4]], "3", "2"]}], "+", 
         RowBox[{"15552", " ", 
          SubsuperscriptBox[
           StyleBox["\[Zeta]",
            FontWeight->Bold,
            FontColor->GrayLevel[0.4]], "3", "3"]}], "-", 
         RowBox[{"318168", " ", 
          SubscriptBox[
           StyleBox["\[Zeta]",
            FontWeight->Bold,
            FontColor->GrayLevel[0.4]], "5"]}], "-", 
         RowBox[{"324000", " ", 
          SuperscriptBox["z", "2"], " ", 
          SubscriptBox[
           StyleBox["\[Zeta]",
            FontWeight->Bold,
            FontColor->GrayLevel[0.4]], "5"]}], "+", 
         RowBox[{"145152", " ", 
          SuperscriptBox["z", "4"], " ", 
          SubscriptBox[
           StyleBox["\[Zeta]",
            FontWeight->Bold,
            FontColor->GrayLevel[0.4]], "5"]}], "+", 
         RowBox[{"19440", " ", 
          SubscriptBox[
           StyleBox["\[Zeta]",
            FontWeight->Bold,
            FontColor->GrayLevel[0.4]], "2"], " ", 
          SubscriptBox[
           StyleBox["\[Zeta]",
            FontWeight->Bold,
            FontColor->GrayLevel[0.4]], "5"]}], "+", 
         RowBox[{"60480", " ", 
          SuperscriptBox["z", "2"], " ", 
          SubscriptBox[
           StyleBox["\[Zeta]",
            FontWeight->Bold,
            FontColor->GrayLevel[0.4]], "2"], " ", 
          SubscriptBox[
           StyleBox["\[Zeta]",
            FontWeight->Bold,
            FontColor->GrayLevel[0.4]], "5"]}], "-", 
         RowBox[{"69120", " ", 
          SuperscriptBox["z", "4"], " ", 
          SubscriptBox[
           StyleBox["\[Zeta]",
            FontWeight->Bold,
            FontColor->GrayLevel[0.4]], "2"], " ", 
          SubscriptBox[
           StyleBox["\[Zeta]",
            FontWeight->Bold,
            FontColor->GrayLevel[0.4]], "5"]}], "-", 
         RowBox[{
          FractionBox["71712", "5"], " ", 
          SubsuperscriptBox[
           StyleBox["\[Zeta]",
            FontWeight->Bold,
            FontColor->GrayLevel[0.4]], "2", "2"], " ", 
          SubscriptBox[
           StyleBox["\[Zeta]",
            FontWeight->Bold,
            FontColor->GrayLevel[0.4]], "5"]}], "-", 
         RowBox[{
          FractionBox["110592", "5"], " ", 
          SuperscriptBox["z", "2"], " ", 
          SubsuperscriptBox[
           StyleBox["\[Zeta]",
            FontWeight->Bold,
            FontColor->GrayLevel[0.4]], "2", "2"], " ", 
          SubscriptBox[
           StyleBox["\[Zeta]",
            FontWeight->Bold,
            FontColor->GrayLevel[0.4]], "5"]}], "+", 
         RowBox[{"55296", " ", 
          SuperscriptBox["z", "4"], " ", 
          SubsuperscriptBox[
           StyleBox["\[Zeta]",
            FontWeight->Bold,
            FontColor->GrayLevel[0.4]], "2", "2"], " ", 
          SubscriptBox[
           StyleBox["\[Zeta]",
            FontWeight->Bold,
            FontColor->GrayLevel[0.4]], "5"]}], "-", 
         RowBox[{
          FractionBox["13824", "35"], " ", 
          SubsuperscriptBox[
           StyleBox["\[Zeta]",
            FontWeight->Bold,
            FontColor->GrayLevel[0.4]], "2", "3"], " ", 
          SubscriptBox[
           StyleBox["\[Zeta]",
            FontWeight->Bold,
            FontColor->GrayLevel[0.4]], "5"]}], "+", 
         RowBox[{
          FractionBox["27648", "35"], " ", 
          SuperscriptBox["z", "2"], " ", 
          SubsuperscriptBox[
           StyleBox["\[Zeta]",
            FontWeight->Bold,
            FontColor->GrayLevel[0.4]], "2", "3"], " ", 
          SubscriptBox[
           StyleBox["\[Zeta]",
            FontWeight->Bold,
            FontColor->GrayLevel[0.4]], "5"]}], "-", 
         RowBox[{
          FractionBox["73728", "7"], " ", 
          SuperscriptBox["z", "4"], " ", 
          SubsuperscriptBox[
           StyleBox["\[Zeta]",
            FontWeight->Bold,
            FontColor->GrayLevel[0.4]], "2", "3"], " ", 
          SubscriptBox[
           StyleBox["\[Zeta]",
            FontWeight->Bold,
            FontColor->GrayLevel[0.4]], "5"]}], "+", 
         RowBox[{"205632", " ", 
          SubscriptBox[
           StyleBox["\[Zeta]",
            FontWeight->Bold,
            FontColor->GrayLevel[0.4]], "3"], " ", 
          SubscriptBox[
           StyleBox["\[Zeta]",
            FontWeight->Bold,
            FontColor->GrayLevel[0.4]], "5"]}], "+", 
         RowBox[{"262656", " ", 
          SuperscriptBox["z", "2"], " ", 
          SubscriptBox[
           StyleBox["\[Zeta]",
            FontWeight->Bold,
            FontColor->GrayLevel[0.4]], "3"], " ", 
          SubscriptBox[
           StyleBox["\[Zeta]",
            FontWeight->Bold,
            FontColor->GrayLevel[0.4]], "5"]}], "+", 
         RowBox[{"29376", " ", 
          SubscriptBox[
           StyleBox["\[Zeta]",
            FontWeight->Bold,
            FontColor->GrayLevel[0.4]], "2"], " ", 
          SubscriptBox[
           StyleBox["\[Zeta]",
            FontWeight->Bold,
            FontColor->GrayLevel[0.4]], "3"], " ", 
          SubscriptBox[
           StyleBox["\[Zeta]",
            FontWeight->Bold,
            FontColor->GrayLevel[0.4]], "5"]}], "+", 
         RowBox[{"41472", " ", 
          SuperscriptBox["z", "2"], " ", 
          SubscriptBox[
           StyleBox["\[Zeta]",
            FontWeight->Bold,
            FontColor->GrayLevel[0.4]], "2"], " ", 
          SubscriptBox[
           StyleBox["\[Zeta]",
            FontWeight->Bold,
            FontColor->GrayLevel[0.4]], "3"], " ", 
          SubscriptBox[
           StyleBox["\[Zeta]",
            FontWeight->Bold,
            FontColor->GrayLevel[0.4]], "5"]}], "-", 
         RowBox[{"12960", " ", 
          SubsuperscriptBox[
           StyleBox["\[Zeta]",
            FontWeight->Bold,
            FontColor->GrayLevel[0.4]], "5", "2"]}], "-", 
         RowBox[{"34560", " ", 
          SuperscriptBox["z", "2"], " ", 
          SubsuperscriptBox[
           StyleBox["\[Zeta]",
            FontWeight->Bold,
            FontColor->GrayLevel[0.4]], "5", "2"]}], "+", 
         RowBox[{"68040", " ", 
          SubscriptBox[
           StyleBox["\[Zeta]",
            FontWeight->Bold,
            FontColor->GrayLevel[0.4]], "7"]}], "-", 
         RowBox[{"225504", " ", 
          SuperscriptBox["z", "2"], " ", 
          SubscriptBox[
           StyleBox["\[Zeta]",
            FontWeight->Bold,
            FontColor->GrayLevel[0.4]], "7"]}], "-", 
         RowBox[{"570240", " ", 
          SuperscriptBox["z", "4"], " ", 
          SubscriptBox[
           StyleBox["\[Zeta]",
            FontWeight->Bold,
            FontColor->GrayLevel[0.4]], "7"]}], "+", 
         RowBox[{"9072", " ", 
          SubscriptBox[
           StyleBox["\[Zeta]",
            FontWeight->Bold,
            FontColor->GrayLevel[0.4]], "2"], " ", 
          SubscriptBox[
           StyleBox["\[Zeta]",
            FontWeight->Bold,
            FontColor->GrayLevel[0.4]], "7"]}], "+", 
         RowBox[{"181440", " ", 
          SuperscriptBox["z", "2"], " ", 
          SubscriptBox[
           StyleBox["\[Zeta]",
            FontWeight->Bold,
            FontColor->GrayLevel[0.4]], "2"], " ", 
          SubscriptBox[
           StyleBox["\[Zeta]",
            FontWeight->Bold,
            FontColor->GrayLevel[0.4]], "7"]}], "+", 
         RowBox[{"241920", " ", 
          SuperscriptBox["z", "4"], " ", 
          SubscriptBox[
           StyleBox["\[Zeta]",
            FontWeight->Bold,
            FontColor->GrayLevel[0.4]], "2"], " ", 
          SubscriptBox[
           StyleBox["\[Zeta]",
            FontWeight->Bold,
            FontColor->GrayLevel[0.4]], "7"]}], "-", 
         RowBox[{
          FractionBox["2592", "5"], " ", 
          SubsuperscriptBox[
           StyleBox["\[Zeta]",
            FontWeight->Bold,
            FontColor->GrayLevel[0.4]], "2", "2"], " ", 
          SubscriptBox[
           StyleBox["\[Zeta]",
            FontWeight->Bold,
            FontColor->GrayLevel[0.4]], "7"]}], "+", 
         RowBox[{
          FractionBox["31104", "5"], " ", 
          SuperscriptBox["z", "2"], " ", 
          SubsuperscriptBox[
           StyleBox["\[Zeta]",
            FontWeight->Bold,
            FontColor->GrayLevel[0.4]], "2", "2"], " ", 
          SubscriptBox[
           StyleBox["\[Zeta]",
            FontWeight->Bold,
            FontColor->GrayLevel[0.4]], "7"]}], "+", 
         RowBox[{"41472", " ", 
          SuperscriptBox["z", "4"], " ", 
          SubsuperscriptBox[
           StyleBox["\[Zeta]",
            FontWeight->Bold,
            FontColor->GrayLevel[0.4]], "2", "2"], " ", 
          SubscriptBox[
           StyleBox["\[Zeta]",
            FontWeight->Bold,
            FontColor->GrayLevel[0.4]], "7"]}], "-", 
         RowBox[{"54432", " ", 
          SubscriptBox[
           StyleBox["\[Zeta]",
            FontWeight->Bold,
            FontColor->GrayLevel[0.4]], "3"], " ", 
          SubscriptBox[
           StyleBox["\[Zeta]",
            FontWeight->Bold,
            FontColor->GrayLevel[0.4]], "7"]}], "-", 
         RowBox[{"72576", " ", 
          SuperscriptBox["z", "2"], " ", 
          SubscriptBox[
           StyleBox["\[Zeta]",
            FontWeight->Bold,
            FontColor->GrayLevel[0.4]], "3"], " ", 
          SubscriptBox[
           StyleBox["\[Zeta]",
            FontWeight->Bold,
            FontColor->GrayLevel[0.4]], "7"]}]}], ")"}]}]}], ")"}]}]}], 
  "}"}]], "Output",
 CellChangeTimes->{3.5558551030128117`*^9, 3.555865874085984*^9, 
  3.555866406091527*^9, 3.5558683553561153`*^9, 3.564856022252356*^9}]
}, Open  ]],

Cell["Equation coming from Y11oY22", "Text",
 CellChangeTimes->{{3.555844999063806*^9, 3.5558450101651487`*^9}, 
   3.555845053059496*^9}],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"{", 
   RowBox[{"T10contr", ",", 
    RowBox[{"Tc\[Rho]2\[Delta]\[Rho]contr", "+", "Tc\[Rho]2Wcontr"}], ",", 
    "ToTW1", ",", 
    RowBox[{
    "productq2Wint", "+", "productq2\[Delta]\[Rho]2", "+", "productq2Wmp0"}], 
    ",", 
    RowBox[{"-", "productTright"}], ",", 
    RowBox[{"-", "RHSHo"}], ",", 
    RowBox[{"-", 
     RowBox[{"(", 
      RowBox[{
      "RHS\[Delta]\[Rho]", "+", "RHS\[Delta]\[Rho]2", "+", "RHSCW", "+", 
       "RHSW1"}], ")"}]}]}], "}"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"tmp", "=", 
   RowBox[{"List", "@@", 
    RowBox[{"Collect", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"Series", "[", 
        RowBox[{
         RowBox[{"Total", "[", 
          RowBox[{"Normal", "/@", "%"}], "]"}], ",", 
         RowBox[{"{", 
          RowBox[{"g", ",", "0", ",", "13"}], "}"}]}], "]"}], "//", 
       "Normal"}], ",", "g"}], "]"}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"SortBy", "[", 
   RowBox[{"tmp", ",", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{"#", "//.", 
       RowBox[{
        RowBox[{"a_.", 
         SuperscriptBox["g", "b_."]}], "\[RuleDelayed]", 
        SuperscriptBox["g", "b"]}]}], ")"}], "&"}]}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"eqFromY11oY22", "=", 
  RowBox[{
   RowBox[{
    RowBox[{"Collect", "[", 
     RowBox[{
      RowBox[{"#", "//", "Expand"}], ",", 
      RowBox[{"{", 
       RowBox[{"g", ",", 
        SqrtBox[
         RowBox[{"1", "-", 
          SuperscriptBox["z", "2"]}]]}], "}"}], ",", "Simplify"}], "]"}], 
    "&"}], "/@", "%"}]}]}], "Input",
 CellChangeTimes->{{3.555844448462405*^9, 3.555844753426512*^9}, {
   3.555844795717238*^9, 3.555844841724825*^9}, {3.555844886719757*^9, 
   3.55584488681039*^9}, {3.5558450123693523`*^9, 3.555845017985017*^9}, {
   3.555845343232707*^9, 3.5558453627581787`*^9}, 3.5558659327955837`*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{
    SuperscriptBox["g", "8"], " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"-", "324"}], "+", 
      RowBox[{"12", " ", 
       RowBox[{"M", "[", 
        SubscriptBox["\[Delta]\[Rho]2", "lead"], "]"}]}], "+", 
      RowBox[{"12", " ", "\[ImaginaryI]", " ", "z", " ", 
       RowBox[{"PV", "[", 
        SubscriptBox["\[Delta]\[Rho]2", "lead"], "]"}]}], "+", 
      FractionBox[
       RowBox[{
        SubscriptBox["\[Delta]\[Rho]", "lead"], "+", 
        RowBox[{"3", " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"-", "1"}], "+", 
           RowBox[{"2", " ", 
            SuperscriptBox["z", "2"]}]}], ")"}], " ", 
         SubscriptBox["\[Delta]\[Rho]2", "lead"]}]}], 
       SqrtBox[
        RowBox[{"1", "-", 
         SuperscriptBox["z", "2"]}]]], "-", 
      RowBox[{"\[DoubleStruckCapitalC]", "[", 
       RowBox[{"-", 
        FractionBox[
         RowBox[{"2", " ", 
          SubscriptBox[
           StyleBox["H",
            FontColor->RGBColor[0.54, 0.35, 0.15]], "lead"]}], "u"]}], "]"}], 
      "-", 
      RowBox[{"\[DoubleStruckCapitalC]", "[", 
       RowBox[{"-", 
        FractionBox[
         RowBox[{"4", " ", "\[ImaginaryI]", " ", 
          SubscriptBox[
           StyleBox["W",
            FontColor->RGBColor[0.54, 0.35, 0.15]], "lead"]}], 
         RowBox[{"3", " ", 
          SuperscriptBox[
           StyleBox["Q0",
            FontColor->RGBColor[{
               Rational[1, 2], 
               Rational[1, 2], 0}]], "-"], " ", 
          SuperscriptBox[
           StyleBox["Q0",
            FontColor->RGBColor[{
               Rational[1, 2], 
               Rational[1, 2], 0}]], "+"]}]]}], "]"}], "-", 
      RowBox[{"\[DoubleStruckCapitalC]", "[", 
       RowBox[{"-", 
        FractionBox[
         RowBox[{"4", " ", 
          RowBox[{"(", 
           RowBox[{"\[ImaginaryI]", "+", "u"}], ")"}], " ", 
          SubsuperscriptBox[
           StyleBox["W",
            FontColor->RGBColor[0.54, 0.35, 0.15]], 
           RowBox[{"1", ",", "lead"}], "+"]}], 
         SuperscriptBox[
          StyleBox["Q0",
           FontColor->RGBColor[{
              Rational[1, 2], 
              Rational[1, 2], 0}]], "+"]]}], "]"}], "-", 
      RowBox[{"216", " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "2"]}], "+", 
      FractionBox[
       RowBox[{"1296", " ", 
        SubsuperscriptBox[
         StyleBox["\[Zeta]",
          FontWeight->Bold,
          FontColor->GrayLevel[0.4]], "2", "2"]}], "5"], "-", 
      FractionBox[
       RowBox[{"144", " ", 
        SubsuperscriptBox[
         StyleBox["\[Zeta]",
          FontWeight->Bold,
          FontColor->GrayLevel[0.4]], "2", "3"]}], "5"], "+", 
      RowBox[{"648", " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "3"]}], "-", 
      RowBox[{"288", " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "2"], " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "3"]}], "-", 
      RowBox[{"72", " ", 
       SubsuperscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "3", "2"]}]}], ")"}]}], ",", 
   RowBox[{
    SuperscriptBox["g", "10"], " ", 
    RowBox[{"(", 
     RowBox[{"2268", "+", 
      RowBox[{"9072", " ", 
       SuperscriptBox["z", "2"]}], "-", 
      RowBox[{"108", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", "1"}], "+", 
         RowBox[{"2", " ", 
          SuperscriptBox["z", "2"]}]}], ")"}], " ", 
       RowBox[{"M", "[", 
        SubscriptBox["\[Delta]\[Rho]2", "lead"], "]"}]}], "-", 
      RowBox[{"144", " ", 
       RowBox[{"M", "[", 
        RowBox[{
         SuperscriptBox["w", "2"], " ", 
         SubscriptBox["\[Delta]\[Rho]2", "lead"]}], "]"}]}], "+", 
      RowBox[{"12", " ", 
       RowBox[{"M", "[", 
        SubscriptBox["\[Delta]\[Rho]2", "sublead"], "]"}]}], "+", 
      RowBox[{"4", " ", "\[ImaginaryI]", " ", "z", " ", 
       RowBox[{"PV", "[", 
        SubscriptBox["\[Delta]\[Rho]", "lead"], "]"}]}], "+", 
      RowBox[{"72", " ", "\[ImaginaryI]", " ", "z", " ", 
       RowBox[{"PV", "[", 
        SubscriptBox["\[Delta]\[Rho]2", "lead"], "]"}]}], "-", 
      RowBox[{"144", " ", "\[ImaginaryI]", " ", 
       SuperscriptBox["z", "3"], " ", 
       RowBox[{"PV", "[", 
        SubscriptBox["\[Delta]\[Rho]2", "lead"], "]"}]}], "+", 
      RowBox[{"12", " ", "\[ImaginaryI]", " ", "z", " ", 
       RowBox[{"PV", "[", 
        SubscriptBox["\[Delta]\[Rho]2", "sublead"], "]"}]}], "+", 
      RowBox[{
       FractionBox["1", 
        RowBox[{
         RowBox[{"-", "1"}], "+", 
         SuperscriptBox["z", "2"]}]], 
       RowBox[{
        SqrtBox[
         RowBox[{"1", "-", 
          SuperscriptBox["z", "2"]}]], " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{
           RowBox[{"(", 
            RowBox[{
             RowBox[{"-", "5"}], "+", 
             RowBox[{"2", " ", 
              SuperscriptBox["z", "2"]}]}], ")"}], " ", 
           SubscriptBox["\[Delta]\[Rho]", "lead"]}], "-", 
          SubscriptBox["\[Delta]\[Rho]", "sublead"], "+", 
          RowBox[{"3", " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"4", " ", 
              RowBox[{"(", 
               RowBox[{"1", "-", 
                RowBox[{"6", " ", 
                 SuperscriptBox["z", "2"]}], "+", 
                RowBox[{"6", " ", 
                 SuperscriptBox["z", "4"]}]}], ")"}], " ", 
              SubscriptBox["\[Delta]\[Rho]2", "lead"]}], "+", 
             RowBox[{
              RowBox[{"(", 
               RowBox[{"1", "-", 
                RowBox[{"2", " ", 
                 SuperscriptBox["z", "2"]}]}], ")"}], " ", 
              SubscriptBox["\[Delta]\[Rho]2", "sublead"]}]}], ")"}]}]}], 
         ")"}]}]}], "-", 
      RowBox[{
       SuperscriptBox["z", "2"], " ", 
       RowBox[{"\[DoubleStruckCapitalC]", "[", 
        RowBox[{"-", 
         FractionBox[
          RowBox[{"8", " ", 
           SubscriptBox[
            StyleBox["H",
             FontColor->RGBColor[0.54, 0.35, 0.15]], "lead"]}], 
          SuperscriptBox["u", "3"]]}], "]"}]}], "-", 
      RowBox[{"\[DoubleStruckCapitalC]", "[", 
       RowBox[{"-", 
        FractionBox[
         RowBox[{"2", " ", 
          SubscriptBox[
           StyleBox["H",
            FontColor->RGBColor[0.54, 0.35, 0.15]], "sublead"]}], "u"]}], 
       "]"}], "-", 
      RowBox[{
       SuperscriptBox["z", "2"], " ", 
       RowBox[{"\[DoubleStruckCapitalC]", "[", 
        FractionBox[
         RowBox[{"16", " ", "\[ImaginaryI]", " ", 
          RowBox[{"(", 
           RowBox[{"6", "+", 
            RowBox[{"25", " ", 
             SuperscriptBox["u", "2"]}], "+", 
            RowBox[{"51", " ", 
             SuperscriptBox["u", "4"]}], "+", 
            RowBox[{"18", " ", 
             SuperscriptBox["u", "6"]}]}], ")"}], " ", 
          SubscriptBox[
           StyleBox["W",
            FontColor->RGBColor[0.54, 0.35, 0.15]], "lead"]}], 
         RowBox[{"3", " ", 
          SuperscriptBox[
           RowBox[{"(", 
            RowBox[{"1", "+", 
             SuperscriptBox["u", "2"]}], ")"}], "2"], " ", 
          SuperscriptBox[
           StyleBox["Q0",
            FontColor->RGBColor[{
               Rational[1, 2], 
               Rational[1, 2], 0}]], "-"], " ", 
          SuperscriptBox[
           StyleBox["Q0",
            FontColor->RGBColor[{
               Rational[1, 2], 
               Rational[1, 2], 0}]], "+"]}]], "]"}]}], "-", 
      RowBox[{"\[DoubleStruckCapitalC]", "[", 
       RowBox[{"-", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{"4", " ", "\[ImaginaryI]", " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{
              RowBox[{"(", 
               RowBox[{"11", "+", 
                RowBox[{"113", " ", 
                 SuperscriptBox["u", "2"]}], "+", 
                RowBox[{"434", " ", 
                 SuperscriptBox["u", "4"]}], "+", 
                RowBox[{"729", " ", 
                 SuperscriptBox["u", "6"]}], "+", 
                RowBox[{"819", " ", 
                 SuperscriptBox["u", "8"]}], "+", 
                RowBox[{"324", " ", 
                 SuperscriptBox["u", "10"]}]}], ")"}], " ", 
              SubscriptBox[
               StyleBox["W",
                FontColor->RGBColor[0.54, 0.35, 0.15]], "lead"]}], "+", 
             RowBox[{"9", " ", 
              SuperscriptBox[
               RowBox[{"(", 
                RowBox[{"1", "+", 
                 SuperscriptBox["u", "2"]}], ")"}], "2"], " ", 
              SuperscriptBox[
               StyleBox["Q0",
                FontColor->RGBColor[{
                   Rational[1, 2], 
                   Rational[1, 2], 0}]], "-"], " ", 
              SuperscriptBox[
               StyleBox["Q0",
                FontColor->RGBColor[{
                   Rational[1, 2], 
                   Rational[1, 2], 0}]], "+"], " ", 
              SubscriptBox[
               StyleBox["W",
                FontColor->RGBColor[0.54, 0.35, 0.15]], "sublead"]}]}], 
            ")"}]}], ")"}], "/", 
         RowBox[{"(", 
          RowBox[{"27", " ", 
           SuperscriptBox[
            RowBox[{"(", 
             RowBox[{"1", "+", 
              SuperscriptBox["u", "2"]}], ")"}], "2"], " ", 
           SuperscriptBox[
            RowBox[{"(", 
             SuperscriptBox[
              StyleBox["Q0",
               FontColor->RGBColor[{
                  Rational[1, 2], 
                  Rational[1, 2], 0}]], "-"], ")"}], "2"], " ", 
           SuperscriptBox[
            RowBox[{"(", 
             SuperscriptBox[
              StyleBox["Q0",
               FontColor->RGBColor[{
                  Rational[1, 2], 
                  Rational[1, 2], 0}]], "+"], ")"}], "2"]}], ")"}]}]}], "]"}],
       "-", 
      RowBox[{
       SuperscriptBox["z", "2"], " ", 
       RowBox[{"\[DoubleStruckCapitalC]", "[", 
        RowBox[{"-", 
         FractionBox[
          RowBox[{"16", " ", 
           RowBox[{"(", 
            RowBox[{"\[ImaginaryI]", "+", "u"}], ")"}], " ", 
           SubsuperscriptBox[
            StyleBox["W",
             FontColor->RGBColor[0.54, 0.35, 0.15]], 
            RowBox[{"1", ",", "lead"}], "+"]}], 
          RowBox[{
           SuperscriptBox["u", "2"], " ", 
           SuperscriptBox[
            StyleBox["Q0",
             FontColor->RGBColor[{
                Rational[1, 2], 
                Rational[1, 2], 0}]], "+"]}]]}], "]"}]}], "-", 
      RowBox[{"\[DoubleStruckCapitalC]", "[", 
       RowBox[{
        RowBox[{"-", 
         FractionBox[
          RowBox[{"4", " ", 
           SuperscriptBox[
            RowBox[{"(", 
             RowBox[{"\[ImaginaryI]", "+", 
              RowBox[{"2", " ", "u"}]}], ")"}], "2"], " ", 
           RowBox[{"(", 
            RowBox[{"1", "+", 
             RowBox[{"\[ImaginaryI]", " ", "u"}], "+", 
             SuperscriptBox["u", "2"]}], ")"}], " ", 
           SubsuperscriptBox[
            StyleBox["W",
             FontColor->RGBColor[0.54, 0.35, 0.15]], 
            RowBox[{"1", ",", "lead"}], "+"]}], 
          RowBox[{"3", " ", 
           SuperscriptBox["u", "2"], " ", 
           RowBox[{"(", 
            RowBox[{"\[ImaginaryI]", "+", "u"}], ")"}], " ", 
           SuperscriptBox[
            RowBox[{"(", 
             SuperscriptBox[
              StyleBox["Q0",
               FontColor->RGBColor[{
                  Rational[1, 2], 
                  Rational[1, 2], 0}]], "+"], ")"}], "2"]}]]}], "-", 
        FractionBox[
         RowBox[{"4", " ", 
          RowBox[{"(", 
           RowBox[{"\[ImaginaryI]", "+", "u"}], ")"}], " ", 
          SubsuperscriptBox[
           StyleBox["W",
            FontColor->RGBColor[0.54, 0.35, 0.15]], 
           RowBox[{"1", ",", "sublead"}], "+"]}], 
         SuperscriptBox[
          StyleBox["Q0",
           FontColor->RGBColor[{
              Rational[1, 2], 
              Rational[1, 2], 0}]], "+"]]}], "]"}], "+", 
      RowBox[{"\[DoubleStruckCapitalC]", "[", 
       RowBox[{"-", 
        FractionBox[
         RowBox[{"24", " ", "\[ImaginaryI]", " ", 
          SubscriptBox[
           OverscriptBox[
            StyleBox["W",
             FontColor->RGBColor[0.54, 0.35, 0.15]], 
            StyleBox["^",
             FontColor->RGBColor[0.54, 0.35, 0.15]]], "lead"]}], 
         RowBox[{"1", "+", 
          SuperscriptBox["u", "2"]}]]}], "]"}], "+", 
      RowBox[{
       SuperscriptBox["z", "2"], " ", 
       RowBox[{"\[DoubleStruckCapitalC]", "[", 
        FractionBox[
         RowBox[{"24", " ", "\[ImaginaryI]", " ", 
          RowBox[{"(", 
           RowBox[{"1", "+", 
            RowBox[{"5", " ", 
             SuperscriptBox["u", "2"]}], "+", 
            RowBox[{"2", " ", 
             SuperscriptBox["u", "4"]}]}], ")"}], " ", 
          SubscriptBox[
           OverscriptBox[
            StyleBox["W",
             FontColor->RGBColor[0.54, 0.35, 0.15]], 
            StyleBox["^",
             FontColor->RGBColor[0.54, 0.35, 0.15]]], "lead"]}], 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"u", "+", 
            SuperscriptBox["u", "3"]}], ")"}], "2"]], "]"}]}], "+", 
      RowBox[{"7128", " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "2"]}], "-", 
      RowBox[{"8640", " ", 
       SuperscriptBox["z", "2"], " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "2"]}], "-", 
      FractionBox[
       RowBox[{"14256", " ", 
        SubsuperscriptBox[
         StyleBox["\[Zeta]",
          FontWeight->Bold,
          FontColor->GrayLevel[0.4]], "2", "2"]}], "5"], "+", 
      RowBox[{"6912", " ", 
       SuperscriptBox["z", "2"], " ", 
       SubsuperscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "2", "2"]}], "+", 
      FractionBox[
       RowBox[{"16704", " ", 
        SubsuperscriptBox[
         StyleBox["\[Zeta]",
          FontWeight->Bold,
          FontColor->GrayLevel[0.4]], "2", "3"]}], "35"], "-", 
      RowBox[{
       FractionBox["107136", "35"], " ", 
       SuperscriptBox["z", "2"], " ", 
       SubsuperscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "2", "3"]}], "+", 
      FractionBox[
       RowBox[{"15552", " ", 
        SubsuperscriptBox[
         StyleBox["\[Zeta]",
          FontWeight->Bold,
          FontColor->GrayLevel[0.4]], "2", "4"]}], "175"], "+", 
      RowBox[{
       FractionBox["66816", "175"], " ", 
       SuperscriptBox["z", "2"], " ", 
       SubsuperscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "2", "4"]}], "-", 
      RowBox[{"3240", " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "3"]}], "+", 
      RowBox[{"1728", " ", 
       SuperscriptBox["z", "2"], " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "3"]}], "-", 
      RowBox[{"7200", " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "2"], " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "3"]}], "-", 
      RowBox[{"1152", " ", 
       SuperscriptBox["z", "2"], " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "2"], " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "3"]}], "+", 
      RowBox[{
       FractionBox["2592", "5"], " ", 
       SubsuperscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "2", "2"], " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "3"]}], "-", 
      RowBox[{
       FractionBox["10368", "5"], " ", 
       SuperscriptBox["z", "2"], " ", 
       SubsuperscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "2", "2"], " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "3"]}], "+", 
      RowBox[{"4896", " ", 
       SubsuperscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "3", "2"]}], "+", 
      RowBox[{"3456", " ", 
       SuperscriptBox["z", "2"], " ", 
       SubsuperscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "3", "2"]}], "-", 
      RowBox[{"5184", " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "5"]}], "-", 
      RowBox[{"17280", " ", 
       SuperscriptBox["z", "2"], " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "5"]}], "+", 
      RowBox[{"3024", " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "2"], " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "5"]}], "+", 
      RowBox[{"9216", " ", 
       SuperscriptBox["z", "2"], " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "2"], " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "5"]}], "+", 
      RowBox[{"432", " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "3"], " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "5"]}], "+", 
      RowBox[{"1152", " ", 
       SuperscriptBox["z", "2"], " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "3"], " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "5"]}]}], ")"}]}], ",", 
   RowBox[{
    SuperscriptBox["g", "12"], " ", 
    RowBox[{"(", 
     RowBox[{"53136", "-", 
      RowBox[{"259848", " ", 
       SuperscriptBox["z", "2"]}], "-", 
      RowBox[{"59616", " ", 
       SuperscriptBox["z", "4"]}], "+", 
      RowBox[{"4", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", "3"}], "+", 
         RowBox[{"4", " ", 
          SuperscriptBox["z", "2"]}]}], ")"}], " ", 
       RowBox[{"M", "[", 
        SubscriptBox["\[Delta]\[Rho]", "lead"], "]"}]}], "+", 
      RowBox[{"12", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", "97"}], "+", 
         RowBox[{"106", " ", 
          SuperscriptBox["z", "2"]}], "+", 
         RowBox[{"72", " ", 
          SuperscriptBox["z", "4"]}]}], ")"}], " ", 
       RowBox[{"M", "[", 
        SubscriptBox["\[Delta]\[Rho]2", "lead"], "]"}]}], "+", 
      RowBox[{"1296", " ", 
       RowBox[{"M", "[", 
        RowBox[{
         SuperscriptBox["w", "2"], " ", 
         SubscriptBox["\[Delta]\[Rho]2", "lead"]}], "]"}]}], "+", 
      RowBox[{"480", " ", 
       SuperscriptBox["z", "2"], " ", 
       RowBox[{"M", "[", 
        RowBox[{
         SuperscriptBox["w", "2"], " ", 
         SubscriptBox["\[Delta]\[Rho]2", "lead"]}], "]"}]}], "+", 
      RowBox[{"108", " ", 
       RowBox[{"M", "[", 
        SubscriptBox["\[Delta]\[Rho]2", "sublead"], "]"}]}], "-", 
      RowBox[{"216", " ", 
       SuperscriptBox["z", "2"], " ", 
       RowBox[{"M", "[", 
        SubscriptBox["\[Delta]\[Rho]2", "sublead"], "]"}]}], "-", 
      RowBox[{"144", " ", 
       RowBox[{"M", "[", 
        RowBox[{
         SuperscriptBox["w", "2"], " ", 
         SubscriptBox["\[Delta]\[Rho]2", "sublead"]}], "]"}]}], "+", 
      RowBox[{"12", " ", 
       RowBox[{"M", "[", 
        SubscriptBox["\[Delta]\[Rho]2", "sublead2"], "]"}]}], "-", 
      RowBox[{"16", " ", "\[ImaginaryI]", " ", "z", " ", 
       RowBox[{"PV", "[", 
        SubscriptBox["\[Delta]\[Rho]", "lead"], "]"}]}], "-", 
      RowBox[{"16", " ", "\[ImaginaryI]", " ", 
       SuperscriptBox["z", "3"], " ", 
       RowBox[{"PV", "[", 
        SubscriptBox["\[Delta]\[Rho]", "lead"], "]"}]}], "+", 
      RowBox[{"4", " ", "\[ImaginaryI]", " ", "z", " ", 
       RowBox[{"PV", "[", 
        SubscriptBox["\[Delta]\[Rho]", "sublead"], "]"}]}], "-", 
      RowBox[{"984", " ", "\[ImaginaryI]", " ", "z", " ", 
       RowBox[{"PV", "[", 
        SubscriptBox["\[Delta]\[Rho]2", "lead"], "]"}]}], "+", 
      RowBox[{"1536", " ", "\[ImaginaryI]", " ", 
       SuperscriptBox["z", "3"], " ", 
       RowBox[{"PV", "[", 
        SubscriptBox["\[Delta]\[Rho]2", "lead"], "]"}]}], "+", 
      RowBox[{"72", " ", "\[ImaginaryI]", " ", "z", " ", 
       RowBox[{"PV", "[", 
        SubscriptBox["\[Delta]\[Rho]2", "sublead"], "]"}]}], "-", 
      RowBox[{"144", " ", "\[ImaginaryI]", " ", 
       SuperscriptBox["z", "3"], " ", 
       RowBox[{"PV", "[", 
        SubscriptBox["\[Delta]\[Rho]2", "sublead"], "]"}]}], "+", 
      RowBox[{"12", " ", "\[ImaginaryI]", " ", "z", " ", 
       RowBox[{"PV", "[", 
        SubscriptBox["\[Delta]\[Rho]2", "sublead2"], "]"}]}], "+", 
      RowBox[{
       FractionBox["1", 
        RowBox[{
         RowBox[{"-", "1"}], "+", 
         SuperscriptBox["z", "2"]}]], 
       RowBox[{
        SqrtBox[
         RowBox[{"1", "-", 
          SuperscriptBox["z", "2"]}]], " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{
           RowBox[{"(", 
            RowBox[{"20", "-", 
             RowBox[{"8", " ", 
              SuperscriptBox["z", "4"]}]}], ")"}], " ", 
           SubscriptBox["\[Delta]\[Rho]", "lead"]}], "+", 
          RowBox[{
           RowBox[{"(", 
            RowBox[{
             RowBox[{"-", "5"}], "+", 
             RowBox[{"2", " ", 
              SuperscriptBox["z", "2"]}]}], ")"}], " ", 
           SubscriptBox["\[Delta]\[Rho]", "sublead"]}], "-", 
          SubscriptBox["\[Delta]\[Rho]", "sublead2"], "-", 
          RowBox[{"180", " ", 
           SubscriptBox["\[Delta]\[Rho]2", "lead"]}], "+", 
          RowBox[{"864", " ", 
           SuperscriptBox["z", "2"], " ", 
           SubscriptBox["\[Delta]\[Rho]2", "lead"]}], "-", 
          RowBox[{"768", " ", 
           SuperscriptBox["z", "4"], " ", 
           SubscriptBox["\[Delta]\[Rho]2", "lead"]}], "+", 
          RowBox[{"12", " ", 
           SubscriptBox["\[Delta]\[Rho]2", "sublead"]}], "-", 
          RowBox[{"72", " ", 
           SuperscriptBox["z", "2"], " ", 
           SubscriptBox["\[Delta]\[Rho]2", "sublead"]}], "+", 
          RowBox[{"72", " ", 
           SuperscriptBox["z", "4"], " ", 
           SubscriptBox["\[Delta]\[Rho]2", "sublead"]}], "+", 
          RowBox[{"3", " ", 
           SubscriptBox["\[Delta]\[Rho]2", "sublead2"]}], "-", 
          RowBox[{"6", " ", 
           SuperscriptBox["z", "2"], " ", 
           SubscriptBox["\[Delta]\[Rho]2", "sublead2"]}]}], ")"}]}]}], "-", 
      RowBox[{
       SuperscriptBox["z", "4"], " ", 
       RowBox[{"\[DoubleStruckCapitalC]", "[", 
        RowBox[{"-", 
         FractionBox[
          RowBox[{"32", " ", 
           SubscriptBox[
            StyleBox["H",
             FontColor->RGBColor[0.54, 0.35, 0.15]], "lead"]}], 
          SuperscriptBox["u", "5"]]}], "]"}]}], "-", 
      RowBox[{
       SuperscriptBox["z", "2"], " ", 
       RowBox[{"\[DoubleStruckCapitalC]", "[", 
        RowBox[{"-", 
         FractionBox[
          RowBox[{"8", " ", 
           SubscriptBox[
            StyleBox["H",
             FontColor->RGBColor[0.54, 0.35, 0.15]], "sublead"]}], 
          SuperscriptBox["u", "3"]]}], "]"}]}], "-", 
      RowBox[{"\[DoubleStruckCapitalC]", "[", 
       RowBox[{"-", 
        FractionBox[
         RowBox[{"2", " ", 
          SubscriptBox[
           StyleBox["H",
            FontColor->RGBColor[0.54, 0.35, 0.15]], "sublead2"]}], "u"]}], 
       "]"}], "-", 
      RowBox[{
       SuperscriptBox["z", "4"], " ", 
       RowBox[{"\[DoubleStruckCapitalC]", "[", 
        RowBox[{"-", 
         FractionBox[
          RowBox[{"64", " ", "\[ImaginaryI]", " ", 
           RowBox[{"(", 
            RowBox[{"9", "+", 
             RowBox[{"56", " ", 
              SuperscriptBox["u", "2"]}], "+", 
             RowBox[{"196", " ", 
              SuperscriptBox["u", "4"]}], "+", 
             RowBox[{"183", " ", 
              SuperscriptBox["u", "6"]}], "+", 
             RowBox[{"117", " ", 
              SuperscriptBox["u", "8"]}], "+", 
             RowBox[{"27", " ", 
              SuperscriptBox["u", "10"]}]}], ")"}], " ", 
           SubscriptBox[
            StyleBox["W",
             FontColor->RGBColor[0.54, 0.35, 0.15]], "lead"]}], 
          RowBox[{"3", " ", 
           SuperscriptBox[
            RowBox[{"(", 
             RowBox[{"1", "+", 
              SuperscriptBox["u", "2"]}], ")"}], "4"], " ", 
           SuperscriptBox[
            StyleBox["Q0",
             FontColor->RGBColor[{
                Rational[1, 2], 
                Rational[1, 2], 0}]], "-"], " ", 
           SuperscriptBox[
            StyleBox["Q0",
             FontColor->RGBColor[{
                Rational[1, 2], 
                Rational[1, 2], 0}]], "+"]}]]}], "]"}]}], "-", 
      RowBox[{
       SuperscriptBox["z", "2"], " ", 
       RowBox[{"\[DoubleStruckCapitalC]", "[", 
        RowBox[{"-", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{"16", " ", "\[ImaginaryI]", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{
               RowBox[{"(", 
                RowBox[{"22", "+", 
                 RowBox[{"56", " ", 
                  SuperscriptBox["u", "2"]}], "-", 
                 RowBox[{"376", " ", 
                  SuperscriptBox["u", "4"]}], "-", 
                 RowBox[{"1731", " ", 
                  SuperscriptBox["u", "6"]}], "-", 
                 RowBox[{"3243", " ", 
                  SuperscriptBox["u", "8"]}], "-", 
                 RowBox[{"1800", " ", 
                  SuperscriptBox["u", "10"]}], "-", 
                 RowBox[{"189", " ", 
                  SuperscriptBox["u", "12"]}], "+", 
                 RowBox[{"81", " ", 
                  SuperscriptBox["u", "14"]}]}], ")"}], " ", 
               SubscriptBox[
                StyleBox["W",
                 FontColor->RGBColor[0.54, 0.35, 0.15]], "lead"]}], "-", 
              RowBox[{"9", " ", 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{"1", "+", 
                  SuperscriptBox["u", "2"]}], ")"}], "2"], " ", 
               RowBox[{"(", 
                RowBox[{"6", "+", 
                 RowBox[{"25", " ", 
                  SuperscriptBox["u", "2"]}], "+", 
                 RowBox[{"51", " ", 
                  SuperscriptBox["u", "4"]}], "+", 
                 RowBox[{"18", " ", 
                  SuperscriptBox["u", "6"]}]}], ")"}], " ", 
               SuperscriptBox[
                StyleBox["Q0",
                 FontColor->RGBColor[{
                    Rational[1, 2], 
                    Rational[1, 2], 0}]], "-"], " ", 
               SuperscriptBox[
                StyleBox["Q0",
                 FontColor->RGBColor[{
                    Rational[1, 2], 
                    Rational[1, 2], 0}]], "+"], " ", 
               SubscriptBox[
                StyleBox["W",
                 FontColor->RGBColor[0.54, 0.35, 0.15]], "sublead"]}]}], 
             ")"}]}], ")"}], "/", 
          RowBox[{"(", 
           RowBox[{"27", " ", 
            SuperscriptBox[
             RowBox[{"(", 
              RowBox[{"1", "+", 
               SuperscriptBox["u", "2"]}], ")"}], "4"], " ", 
            SuperscriptBox[
             RowBox[{"(", 
              SuperscriptBox[
               StyleBox["Q0",
                FontColor->RGBColor[{
                   Rational[1, 2], 
                   Rational[1, 2], 0}]], "-"], ")"}], "2"], " ", 
            SuperscriptBox[
             RowBox[{"(", 
              SuperscriptBox[
               StyleBox["Q0",
                FontColor->RGBColor[{
                   Rational[1, 2], 
                   Rational[1, 2], 0}]], "+"], ")"}], "2"]}], ")"}]}]}], 
        "]"}]}], "-", 
      RowBox[{"\[DoubleStruckCapitalC]", "[", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{"4", " ", "\[ImaginaryI]", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{
             RowBox[{"(", 
              RowBox[{"108", "+", 
               RowBox[{"1142", " ", 
                SuperscriptBox["u", "2"]}], "+", 
               RowBox[{"4615", " ", 
                SuperscriptBox["u", "4"]}], "+", 
               RowBox[{"10277", " ", 
                SuperscriptBox["u", "6"]}], "+", 
               RowBox[{"24092", " ", 
                SuperscriptBox["u", "8"]}], "+", 
               RowBox[{"59418", " ", 
                SuperscriptBox["u", "10"]}], "+", 
               RowBox[{"107406", " ", 
                SuperscriptBox["u", "12"]}], "+", 
               RowBox[{"111726", " ", 
                SuperscriptBox["u", "14"]}], "+", 
               RowBox[{"64395", " ", 
                SuperscriptBox["u", "16"]}], "+", 
               RowBox[{"15309", " ", 
                SuperscriptBox["u", "18"]}]}], ")"}], " ", 
             SubscriptBox[
              StyleBox["W",
               FontColor->RGBColor[0.54, 0.35, 0.15]], "lead"]}], "-", 
            RowBox[{"9", " ", 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{"1", "+", 
                SuperscriptBox["u", "2"]}], ")"}], "2"], " ", 
             SuperscriptBox[
              StyleBox["Q0",
               FontColor->RGBColor[{
                  Rational[1, 2], 
                  Rational[1, 2], 0}]], "-"], " ", 
             SuperscriptBox[
              StyleBox["Q0",
               FontColor->RGBColor[{
                  Rational[1, 2], 
                  Rational[1, 2], 0}]], "+"], " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{
                RowBox[{"(", 
                 RowBox[{"11", "+", 
                  RowBox[{"113", " ", 
                   SuperscriptBox["u", "2"]}], "+", 
                  RowBox[{"434", " ", 
                   SuperscriptBox["u", "4"]}], "+", 
                  RowBox[{"729", " ", 
                   SuperscriptBox["u", "6"]}], "+", 
                  RowBox[{"819", " ", 
                   SuperscriptBox["u", "8"]}], "+", 
                  RowBox[{"324", " ", 
                   SuperscriptBox["u", "10"]}]}], ")"}], " ", 
                SubscriptBox[
                 StyleBox["W",
                  FontColor->RGBColor[0.54, 0.35, 0.15]], "sublead"]}], "+", 
               RowBox[{"9", " ", 
                SuperscriptBox[
                 RowBox[{"(", 
                  RowBox[{"1", "+", 
                   SuperscriptBox["u", "2"]}], ")"}], "2"], " ", 
                SuperscriptBox[
                 StyleBox["Q0",
                  FontColor->RGBColor[{
                    Rational[1, 2], 
                    Rational[1, 2], 0}]], "-"], " ", 
                SuperscriptBox[
                 StyleBox["Q0",
                  FontColor->RGBColor[{
                    Rational[1, 2], 
                    Rational[1, 2], 0}]], "+"], " ", 
                SubscriptBox[
                 StyleBox["W",
                  FontColor->RGBColor[0.54, 0.35, 0.15]], "sublead2"]}]}], 
              ")"}]}]}], ")"}]}], ")"}], "/", 
        RowBox[{"(", 
         RowBox[{"243", " ", 
          SuperscriptBox[
           RowBox[{"(", 
            RowBox[{"1", "+", 
             SuperscriptBox["u", "2"]}], ")"}], "4"], " ", 
          SuperscriptBox[
           RowBox[{"(", 
            SuperscriptBox[
             StyleBox["Q0",
              FontColor->RGBColor[{
                 Rational[1, 2], 
                 Rational[1, 2], 0}]], "-"], ")"}], "3"], " ", 
          SuperscriptBox[
           RowBox[{"(", 
            SuperscriptBox[
             StyleBox["Q0",
              FontColor->RGBColor[{
                 Rational[1, 2], 
                 Rational[1, 2], 0}]], "+"], ")"}], "3"]}], ")"}]}], "]"}], 
      "-", 
      RowBox[{
       SuperscriptBox["z", "4"], " ", 
       RowBox[{"\[DoubleStruckCapitalC]", "[", 
        RowBox[{"-", 
         FractionBox[
          RowBox[{"64", " ", 
           RowBox[{"(", 
            RowBox[{"\[ImaginaryI]", "+", "u"}], ")"}], " ", 
           SubsuperscriptBox[
            StyleBox["W",
             FontColor->RGBColor[0.54, 0.35, 0.15]], 
            RowBox[{"1", ",", "lead"}], "+"]}], 
          RowBox[{
           SuperscriptBox["u", "4"], " ", 
           SuperscriptBox[
            StyleBox["Q0",
             FontColor->RGBColor[{
                Rational[1, 2], 
                Rational[1, 2], 0}]], "+"]}]]}], "]"}]}], "-", 
      RowBox[{
       SuperscriptBox["z", "2"], " ", 
       RowBox[{"\[DoubleStruckCapitalC]", "[", 
        RowBox[{"-", 
         FractionBox[
          RowBox[{"16", " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{
              SuperscriptBox[
               RowBox[{"(", 
                RowBox[{"\[ImaginaryI]", "+", 
                 RowBox[{"2", " ", "u"}]}], ")"}], "2"], " ", 
              RowBox[{"(", 
               RowBox[{"1", "+", 
                RowBox[{"\[ImaginaryI]", " ", "u"}], "+", 
                SuperscriptBox["u", "2"]}], ")"}], " ", 
              SubsuperscriptBox[
               StyleBox["W",
                FontColor->RGBColor[0.54, 0.35, 0.15]], 
               RowBox[{"1", ",", "lead"}], "+"]}], "+", 
             RowBox[{"3", " ", 
              SuperscriptBox["u", "2"], " ", 
              SuperscriptBox[
               RowBox[{"(", 
                RowBox[{"\[ImaginaryI]", "+", "u"}], ")"}], "2"], " ", 
              SuperscriptBox[
               StyleBox["Q0",
                FontColor->RGBColor[{
                   Rational[1, 2], 
                   Rational[1, 2], 0}]], "+"], " ", 
              SubsuperscriptBox[
               StyleBox["W",
                FontColor->RGBColor[0.54, 0.35, 0.15]], 
               RowBox[{"1", ",", "sublead"}], "+"]}]}], ")"}]}], 
          RowBox[{"3", " ", 
           SuperscriptBox["u", "4"], " ", 
           RowBox[{"(", 
            RowBox[{"\[ImaginaryI]", "+", "u"}], ")"}], " ", 
           SuperscriptBox[
            RowBox[{"(", 
             SuperscriptBox[
              StyleBox["Q0",
               FontColor->RGBColor[{
                  Rational[1, 2], 
                  Rational[1, 2], 0}]], "+"], ")"}], "2"]}]]}], "]"}]}], "-", 
      
      RowBox[{"\[DoubleStruckCapitalC]", "[", 
       RowBox[{
        FractionBox["1", 
         RowBox[{"9", " ", 
          SuperscriptBox["u", "4"], " ", 
          SuperscriptBox[
           RowBox[{"(", 
            RowBox[{"\[ImaginaryI]", "+", "u"}], ")"}], "3"], " ", 
          SuperscriptBox[
           RowBox[{"(", 
            SuperscriptBox[
             StyleBox["Q0",
              FontColor->RGBColor[{
                 Rational[1, 2], 
                 Rational[1, 2], 0}]], "+"], ")"}], "3"]}]], 
        RowBox[{"4", " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{
            RowBox[{"(", 
             RowBox[{"1", "-", 
              RowBox[{"10", " ", "\[ImaginaryI]", " ", "u"}], "-", 
              RowBox[{"45", " ", 
               SuperscriptBox["u", "2"]}], "+", 
              RowBox[{"100", " ", "\[ImaginaryI]", " ", 
               SuperscriptBox["u", "3"]}], "+", 
              RowBox[{"61", " ", 
               SuperscriptBox["u", "4"]}], "+", 
              RowBox[{"202", " ", "\[ImaginaryI]", " ", 
               SuperscriptBox["u", "5"]}], "+", 
              RowBox[{"534", " ", 
               SuperscriptBox["u", "6"]}], "-", 
              RowBox[{"616", " ", "\[ImaginaryI]", " ", 
               SuperscriptBox["u", "7"]}], "-", 
              RowBox[{"424", " ", 
               SuperscriptBox["u", "8"]}], "+", 
              RowBox[{"180", " ", "\[ImaginaryI]", " ", 
               SuperscriptBox["u", "9"]}], "+", 
              RowBox[{"36", " ", 
               SuperscriptBox["u", "10"]}]}], ")"}], " ", 
            SubsuperscriptBox[
             StyleBox["W",
              FontColor->RGBColor[0.54, 0.35, 0.15]], 
             RowBox[{"1", ",", "lead"}], "+"]}], "-", 
           RowBox[{"3", " ", 
            SuperscriptBox["u", "2"], " ", 
            SuperscriptBox[
             RowBox[{"(", 
              RowBox[{"\[ImaginaryI]", "+", "u"}], ")"}], "2"], " ", 
            SuperscriptBox[
             StyleBox["Q0",
              FontColor->RGBColor[{
                 Rational[1, 2], 
                 Rational[1, 2], 0}]], "+"], " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{"\[ImaginaryI]", "+", 
                  RowBox[{"2", " ", "u"}]}], ")"}], "2"], " ", 
               RowBox[{"(", 
                RowBox[{"1", "+", 
                 RowBox[{"\[ImaginaryI]", " ", "u"}], "+", 
                 SuperscriptBox["u", "2"]}], ")"}], " ", 
               SubsuperscriptBox[
                StyleBox["W",
                 FontColor->RGBColor[0.54, 0.35, 0.15]], 
                RowBox[{"1", ",", "sublead"}], "+"]}], "+", 
              RowBox[{"3", " ", 
               SuperscriptBox["u", "2"], " ", 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{"\[ImaginaryI]", "+", "u"}], ")"}], "2"], " ", 
               SuperscriptBox[
                StyleBox["Q0",
                 FontColor->RGBColor[{
                    Rational[1, 2], 
                    Rational[1, 2], 0}]], "+"], " ", 
               SubsuperscriptBox[
                StyleBox["W",
                 FontColor->RGBColor[0.54, 0.35, 0.15]], 
                RowBox[{"1", ",", "sublead2"}], "+"]}]}], ")"}]}]}], 
          ")"}]}]}], "]"}], "+", 
      RowBox[{"\[DoubleStruckCapitalC]", "[", 
       FractionBox[
        RowBox[{"132", " ", "\[ImaginaryI]", " ", 
         SubscriptBox[
          OverscriptBox[
           StyleBox["W",
            FontColor->RGBColor[0.54, 0.35, 0.15]], 
           StyleBox["^",
            FontColor->RGBColor[0.54, 0.35, 0.15]]], "lead"]}], 
        RowBox[{"1", "+", 
         SuperscriptBox["u", "2"]}]], "]"}], "+", 
      RowBox[{
       SuperscriptBox["z", "2"], " ", 
       RowBox[{"\[DoubleStruckCapitalC]", "[", 
        RowBox[{"-", 
         FractionBox[
          RowBox[{"24", " ", "\[ImaginaryI]", " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"-", "6"}], "-", 
             RowBox[{"27", " ", 
              SuperscriptBox["u", "2"]}], "-", 
             RowBox[{"4", " ", 
              SuperscriptBox["u", "4"]}], "+", 
             SuperscriptBox["u", "6"]}], ")"}], " ", 
           SubscriptBox[
            OverscriptBox[
             StyleBox["W",
              FontColor->RGBColor[0.54, 0.35, 0.15]], 
             StyleBox["^",
              FontColor->RGBColor[0.54, 0.35, 0.15]]], "lead"]}], 
          RowBox[{
           SuperscriptBox["u", "2"], " ", 
           SuperscriptBox[
            RowBox[{"(", 
             RowBox[{"1", "+", 
              SuperscriptBox["u", "2"]}], ")"}], "3"]}]]}], "]"}]}], "+", 
      RowBox[{
       SuperscriptBox["z", "4"], " ", 
       RowBox[{"\[DoubleStruckCapitalC]", "[", 
        RowBox[{"-", 
         FractionBox[
          RowBox[{"96", " ", "\[ImaginaryI]", " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"-", "1"}], "-", 
             SuperscriptBox["u", "2"], "+", 
             RowBox[{"15", " ", 
              SuperscriptBox["u", "4"]}], "+", 
             RowBox[{"16", " ", 
              SuperscriptBox["u", "6"]}], "+", 
             RowBox[{"12", " ", 
              SuperscriptBox["u", "8"]}], "+", 
             RowBox[{"3", " ", 
              SuperscriptBox["u", "10"]}]}], ")"}], " ", 
           SubscriptBox[
            OverscriptBox[
             StyleBox["W",
              FontColor->RGBColor[0.54, 0.35, 0.15]], 
             StyleBox["^",
              FontColor->RGBColor[0.54, 0.35, 0.15]]], "lead"]}], 
          SuperscriptBox[
           RowBox[{"(", 
            RowBox[{"u", "+", 
             SuperscriptBox["u", "3"]}], ")"}], "4"]]}], "]"}]}], "+", 
      RowBox[{"\[DoubleStruckCapitalC]", "[", 
       RowBox[{"-", 
        FractionBox[
         RowBox[{"24", " ", "\[ImaginaryI]", " ", 
          SubscriptBox[
           OverscriptBox[
            StyleBox["W",
             FontColor->RGBColor[0.54, 0.35, 0.15]], 
            StyleBox["^",
             FontColor->RGBColor[0.54, 0.35, 0.15]]], "sublead"]}], 
         RowBox[{"1", "+", 
          SuperscriptBox["u", "2"]}]]}], "]"}], "+", 
      RowBox[{
       SuperscriptBox["z", "2"], " ", 
       RowBox[{"\[DoubleStruckCapitalC]", "[", 
        FractionBox[
         RowBox[{"24", " ", "\[ImaginaryI]", " ", 
          RowBox[{"(", 
           RowBox[{"1", "+", 
            RowBox[{"5", " ", 
             SuperscriptBox["u", "2"]}], "+", 
            RowBox[{"2", " ", 
             SuperscriptBox["u", "4"]}]}], ")"}], " ", 
          SubscriptBox[
           OverscriptBox[
            StyleBox["W",
             FontColor->RGBColor[0.54, 0.35, 0.15]], 
            StyleBox["^",
             FontColor->RGBColor[0.54, 0.35, 0.15]]], "sublead"]}], 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"u", "+", 
            SuperscriptBox["u", "3"]}], ")"}], "2"]], "]"}]}], "-", 
      RowBox[{"99792", " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "2"]}], "+", 
      RowBox[{"63504", " ", 
       SuperscriptBox["z", "2"], " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "2"]}], "+", 
      RowBox[{"112320", " ", 
       SuperscriptBox["z", "4"], " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "2"]}], "-", 
      FractionBox[
       RowBox[{"29808", " ", 
        SubsuperscriptBox[
         StyleBox["\[Zeta]",
          FontWeight->Bold,
          FontColor->GrayLevel[0.4]], "2", "2"]}], "5"], "-", 
      RowBox[{
       FractionBox["660096", "5"], " ", 
       SuperscriptBox["z", "2"], " ", 
       SubsuperscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "2", "2"]}], "+", 
      RowBox[{
       FractionBox["134784", "5"], " ", 
       SuperscriptBox["z", "4"], " ", 
       SubsuperscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "2", "2"]}], "+", 
      FractionBox[
       RowBox[{"1871424", " ", 
        SubsuperscriptBox[
         StyleBox["\[Zeta]",
          FontWeight->Bold,
          FontColor->GrayLevel[0.4]], "2", "3"]}], "35"], "+", 
      RowBox[{
       FractionBox["200448", "5"], " ", 
       SuperscriptBox["z", "2"], " ", 
       SubsuperscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "2", "3"]}], "-", 
      RowBox[{
       FractionBox["414720", "7"], " ", 
       SuperscriptBox["z", "4"], " ", 
       SubsuperscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "2", "3"]}], "-", 
      FractionBox[
       RowBox[{"337824", " ", 
        SubsuperscriptBox[
         StyleBox["\[Zeta]",
          FontWeight->Bold,
          FontColor->GrayLevel[0.4]], "2", "4"]}], "35"], "+", 
      RowBox[{
       FractionBox["1893888", "175"], " ", 
       SuperscriptBox["z", "2"], " ", 
       SubsuperscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "2", "4"]}], "+", 
      RowBox[{
       FractionBox["3704832", "175"], " ", 
       SuperscriptBox["z", "4"], " ", 
       SubsuperscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "2", "4"]}], "-", 
      FractionBox[
       RowBox[{"39168", " ", 
        SubsuperscriptBox[
         StyleBox["\[Zeta]",
          FontWeight->Bold,
          FontColor->GrayLevel[0.4]], "2", "5"]}], "175"], "-", 
      RowBox[{
       FractionBox["405504", "175"], " ", 
       SuperscriptBox["z", "2"], " ", 
       SubsuperscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "2", "5"]}], "-", 
      RowBox[{
       FractionBox["101376", "35"], " ", 
       SuperscriptBox["z", "4"], " ", 
       SubsuperscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "2", "5"]}], "-", 
      RowBox[{"94608", " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "3"]}], "+", 
      RowBox[{"322704", " ", 
       SuperscriptBox["z", "2"], " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "3"]}], "-", 
      RowBox[{"177984", " ", 
       SuperscriptBox["z", "4"], " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "3"]}], "+", 
      RowBox[{"25056", " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "2"], " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "3"]}], "+", 
      RowBox[{"36000", " ", 
       SuperscriptBox["z", "2"], " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "2"], " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "3"]}], "+", 
      RowBox[{"1152", " ", 
       SuperscriptBox["z", "4"], " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "2"], " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "3"]}], "-", 
      RowBox[{
       FractionBox["242784", "5"], " ", 
       SubsuperscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "2", "2"], " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "3"]}], "-", 
      RowBox[{
       FractionBox["108864", "5"], " ", 
       SuperscriptBox["z", "2"], " ", 
       SubsuperscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "2", "2"], " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "3"]}], "-", 
      RowBox[{"6912", " ", 
       SuperscriptBox["z", "4"], " ", 
       SubsuperscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "2", "2"], " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "3"]}], "-", 
      RowBox[{
       FractionBox["41472", "35"], " ", 
       SubsuperscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "2", "3"], " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "3"]}], "-", 
      RowBox[{
       FractionBox["23040", "7"], " ", 
       SuperscriptBox["z", "2"], " ", 
       SubsuperscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "2", "3"], " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "3"]}], "+", 
      RowBox[{
       FractionBox["221184", "7"], " ", 
       SuperscriptBox["z", "4"], " ", 
       SubsuperscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "2", "3"], " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "3"]}], "+", 
      RowBox[{"76464", " ", 
       SubsuperscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "3", "2"]}], "-", 
      RowBox[{"31104", " ", 
       SuperscriptBox["z", "2"], " ", 
       SubsuperscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "3", "2"]}], "+", 
      RowBox[{"30240", " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "2"], " ", 
       SubsuperscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "3", "2"]}], "-", 
      RowBox[{"6912", " ", 
       SuperscriptBox["z", "2"], " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "2"], " ", 
       SubsuperscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "3", "2"]}], "-", 
      RowBox[{"1728", " ", 
       SubsuperscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "3", "3"]}], "-", 
      RowBox[{"3456", " ", 
       SuperscriptBox["z", "2"], " ", 
       SubsuperscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "3", "3"]}], "+", 
      RowBox[{"95256", " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "5"]}], "-", 
      RowBox[{"55296", " ", 
       SuperscriptBox["z", "2"], " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "5"]}], "+", 
      RowBox[{"82944", " ", 
       SuperscriptBox["z", "4"], " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "5"]}], "+", 
      RowBox[{"20304", " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "2"], " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "5"]}], "+", 
      RowBox[{"73728", " ", 
       SuperscriptBox["z", "2"], " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "2"], " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "5"]}], "+", 
      RowBox[{"41472", " ", 
       SuperscriptBox["z", "4"], " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "2"], " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "5"]}], "+", 
      RowBox[{"4320", " ", 
       SubsuperscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "2", "2"], " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "5"]}], "+", 
      RowBox[{
       FractionBox["72576", "5"], " ", 
       SuperscriptBox["z", "2"], " ", 
       SubsuperscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "2", "2"], " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "5"]}], "-", 
      RowBox[{
       FractionBox["119808", "5"], " ", 
       SuperscriptBox["z", "4"], " ", 
       SubsuperscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "2", "2"], " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "5"]}], "-", 
      RowBox[{"103680", " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "3"], " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "5"]}], "-", 
      RowBox[{"102528", " ", 
       SuperscriptBox["z", "2"], " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "3"], " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "5"]}], "-", 
      RowBox[{"55296", " ", 
       SuperscriptBox["z", "4"], " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "3"], " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "5"]}], "-", 
      RowBox[{"648", " ", 
       SubsuperscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "5", "2"]}], "-", 
      RowBox[{"1152", " ", 
       SuperscriptBox["z", "2"], " ", 
       SubsuperscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "5", "2"]}], "-", 
      RowBox[{"23040", " ", 
       SuperscriptBox["z", "4"], " ", 
       SubsuperscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "5", "2"]}], "+", 
      RowBox[{"46656", " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "7"]}], "+", 
      RowBox[{"181440", " ", 
       SuperscriptBox["z", "2"], " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "7"]}], "+", 
      RowBox[{"190080", " ", 
       SuperscriptBox["z", "4"], " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "7"]}], "-", 
      RowBox[{"29808", " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "2"], " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "7"]}], "-", 
      RowBox[{"101952", " ", 
       SuperscriptBox["z", "2"], " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "2"], " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "7"]}], "-", 
      RowBox[{"115200", " ", 
       SuperscriptBox["z", "4"], " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "2"], " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "7"]}], "-", 
      RowBox[{"1296", " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "3"], " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "7"]}], "-", 
      RowBox[{"12096", " ", 
       SuperscriptBox["z", "2"], " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "3"], " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "7"]}], "+", 
      RowBox[{"11520", " ", 
       SuperscriptBox["z", "4"], " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "3"], " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "7"]}]}], ")"}]}]}], "}"}]], "Output",
 CellChangeTimes->{{3.555845358521976*^9, 3.5558453637306223`*^9}, 
   3.5558551589743233`*^9, 3.555865881530974*^9, 3.5558659347628193`*^9, 
   3.564856031307089*^9}]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell["\<\
Solution, for first three orders\
\>", "Subsection",
 CellChangeTimes->{{3.546927772148695*^9, 3.546927775524055*^9}, {
  3.5469777926766243`*^9, 3.546977803571855*^9}, {3.546978341522544*^9, 
  3.5469783506149893`*^9}, {3.553740607349867*^9, 3.5537406082352257`*^9}, {
  3.555866527246801*^9, 3.555866541102318*^9}, {3.568964848613001*^9, 
  3.568964852457046*^9}}],

Cell[CellGroupData[{

Cell["Leading order", "Subsubsection",
 CellChangeTimes->{{3.555866616963666*^9, 3.5558666197227697`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"firstset", "=", 
   RowBox[{
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"eqnT11ZeroAtBetheroot", "[", 
        RowBox[{"[", "1", "]"}], "]"}], ",", 
       RowBox[{"eqFromY11Y22", "[", 
        RowBox[{"[", "1", "]"}], "]"}], ",", 
       RowBox[{"eqFromY11oY22", "[", 
        RowBox[{"[", "1", "]"}], "]"}]}], "}"}], "/.", 
     RowBox[{
      SubscriptBox["W", "a_"], "\[RuleDelayed]", 
      SubscriptBox[
       OverscriptBox["W", "^"], "a"]}]}], "/.", 
    RowBox[{"g", "\[Rule]", "1"}]}]}], ";"}]], "Input",
 CellChangeTimes->{{3.555866604526623*^9, 3.555866676631379*^9}, {
   3.55586839092831*^9, 3.555868405201024*^9}, 3.555868444216206*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{"\[CapitalLambda]\[Rho]s", "=", "5"}], ";"}]], "Input",
 CellChangeTimes->{{3.555866707997067*^9, 3.555866711458231*^9}, {
  3.555867435759068*^9, 3.5558674360605497`*^9}, {3.555867756344376*^9, 
  3.555867772671063*^9}, {3.555868685701922*^9, 3.555868692605308*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"subAnsatz", "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{
      RowBox[{"M", "[", 
       SubscriptBox["\[Delta]\[Rho]2", "e_"], "]"}], "\[RuleDelayed]", " ", 
      RowBox[{"Sum", "[", 
       RowBox[{
        RowBox[{
         RowBox[{
          SubscriptBox["\[Alpha]", "e"], "[", "i", "]"}], 
         RowBox[{"Mint", "[", 
          RowBox[{"2", "i"}], "]"}]}], ",", 
        RowBox[{"{", 
         RowBox[{"i", ",", "0", ",", "\[CapitalLambda]\[Rho]s"}], "}"}]}], 
       "]"}]}], ",", 
     RowBox[{
      RowBox[{"M", "[", 
       RowBox[{
        SuperscriptBox["w", "a_."], 
        SubscriptBox["\[Delta]\[Rho]2", "e_"]}], "]"}], "\[RuleDelayed]", " ", 
      RowBox[{"Sum", "[", 
       RowBox[{
        RowBox[{
         RowBox[{
          SubscriptBox["\[Alpha]", "e"], "[", "i", "]"}], 
         RowBox[{"Mint", "[", 
          RowBox[{
           RowBox[{"2", "i"}], "+", "a"}], "]"}]}], ",", 
        RowBox[{"{", 
         RowBox[{"i", ",", "0", ",", "\[CapitalLambda]\[Rho]s"}], "}"}]}], 
       "]"}]}], ",", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"PV", "[", 
       SubscriptBox["\[Delta]\[Rho]2", "e_"], "]"}], "\[RuleDelayed]", " ", 
      RowBox[{"Sum", "[", 
       RowBox[{
        RowBox[{
         RowBox[{
          SubscriptBox["\[Alpha]", "e"], "[", "i", "]"}], 
         RowBox[{"PVint", "[", 
          RowBox[{"2", "i"}], "]"}]}], ",", 
        RowBox[{"{", 
         RowBox[{"i", ",", "0", ",", "\[CapitalLambda]\[Rho]s"}], "}"}]}], 
       "]"}]}], ",", 
     RowBox[{
      RowBox[{"PV", "[", 
       RowBox[{
        SuperscriptBox["w", "a_."], 
        SubscriptBox["\[Delta]\[Rho]2", "e_"]}], "]"}], "\[RuleDelayed]", " ", 
      RowBox[{"Sum", "[", 
       RowBox[{
        RowBox[{
         RowBox[{
          SubscriptBox["\[Alpha]", "e"], "[", "i", "]"}], 
         RowBox[{"PVint", "[", 
          RowBox[{
           RowBox[{"2", "i"}], "+", "a"}], "]"}]}], ",", 
        RowBox[{"{", 
         RowBox[{"i", ",", "0", ",", "\[CapitalLambda]\[Rho]s"}], "}"}]}], 
       "]"}]}], " ", ",", 
     RowBox[{
      RowBox[{"M", "[", 
       SubscriptBox["\[Delta]\[Rho]", "e_"], "]"}], "\[RuleDelayed]", " ", 
      RowBox[{"Sum", "[", 
       RowBox[{
        RowBox[{
         RowBox[{
          SubscriptBox["\[Beta]", "e"], "[", "i", "]"}], 
         RowBox[{"Mint", "[", 
          RowBox[{"2", "i"}], "]"}]}], ",", 
        RowBox[{"{", 
         RowBox[{"i", ",", "0", ",", "\[CapitalLambda]\[Rho]s"}], "}"}]}], 
       "]"}]}], ",", 
     RowBox[{
      RowBox[{"M", "[", 
       RowBox[{
        SuperscriptBox["w", "a_."], 
        SubscriptBox["\[Delta]\[Rho]", "e_"]}], "]"}], "\[RuleDelayed]", " ", 
      
      RowBox[{"Sum", "[", 
       RowBox[{
        RowBox[{
         RowBox[{
          SubscriptBox["\[Beta]", "e"], "[", "i", "]"}], 
         RowBox[{"Mint", "[", 
          RowBox[{
           RowBox[{"2", "i"}], "+", "a"}], "]"}]}], ",", 
        RowBox[{"{", 
         RowBox[{"i", ",", "0", ",", "\[CapitalLambda]\[Rho]s"}], "}"}]}], 
       "]"}]}], ",", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"PV", "[", 
       SubscriptBox["\[Delta]\[Rho]", "e_"], "]"}], "\[RuleDelayed]", " ", 
      RowBox[{"Sum", "[", 
       RowBox[{
        RowBox[{
         RowBox[{
          SubscriptBox["\[Beta]", "e"], "[", "i", "]"}], 
         RowBox[{"PVint", "[", 
          RowBox[{"2", "i"}], "]"}]}], ",", 
        RowBox[{"{", 
         RowBox[{"i", ",", "0", ",", "\[CapitalLambda]\[Rho]s"}], "}"}]}], 
       "]"}]}], ",", 
     RowBox[{
      RowBox[{"PV", "[", 
       RowBox[{
        SuperscriptBox["w", "a_."], 
        SubscriptBox["\[Delta]\[Rho]", "e_"]}], "]"}], "\[RuleDelayed]", " ", 
      
      RowBox[{"Sum", "[", 
       RowBox[{
        RowBox[{
         RowBox[{
          SubscriptBox["\[Beta]", "e"], "[", "i", "]"}], 
         RowBox[{"PVint", "[", 
          RowBox[{
           RowBox[{"2", "i"}], "+", "a"}], "]"}]}], ",", 
        RowBox[{"{", 
         RowBox[{"i", ",", "0", ",", "\[CapitalLambda]\[Rho]s"}], "}"}]}], 
       "]"}]}], " ", ",", 
     RowBox[{
      SubscriptBox["\[Delta]\[Rho]", "e_"], "\[RuleDelayed]", " ", 
      RowBox[{"Sum", "[", 
       RowBox[{
        RowBox[{
         RowBox[{
          SubscriptBox["\[Beta]", "e"], "[", "i", "]"}], 
         SuperscriptBox["z", 
          RowBox[{"2", "i"}]], 
         SqrtBox[
          RowBox[{"1", "-", 
           SuperscriptBox["z", "2"]}]]}], ",", 
        RowBox[{"{", 
         RowBox[{"i", ",", "0", ",", "\[CapitalLambda]\[Rho]s"}], "}"}]}], 
       "]"}]}], ",", 
     RowBox[{
      SubscriptBox["\[Delta]\[Rho]2", "e_"], "\[RuleDelayed]", " ", 
      RowBox[{"Sum", "[", 
       RowBox[{
        RowBox[{
         RowBox[{
          SubscriptBox["\[Alpha]", "e"], "[", "i", "]"}], 
         SuperscriptBox["z", 
          RowBox[{"2", "i"}]], 
         SqrtBox[
          RowBox[{"1", "-", 
           SuperscriptBox["z", "2"]}]]}], ",", 
        RowBox[{"{", 
         RowBox[{"i", ",", "0", ",", "\[CapitalLambda]\[Rho]s"}], "}"}]}], 
       "]"}]}]}], "}"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.5558676928243732`*^9, 3.555867695153057*^9}, {
   3.555867728968429*^9, 3.555867741904189*^9}, {3.5558686975806093`*^9, 
   3.555868743227689*^9}, 3.560081018650111*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"firsteqns", "=", 
    RowBox[{"firstset", "//.", "subAnsatz"}]}], ";"}], 
  "\[IndentingNewLine]"}]], "Input",
 CellChangeTimes->{{3.555866679652109*^9, 3.55586680066827*^9}, {
   3.555866842702819*^9, 3.5558670893216047`*^9}, {3.555867700853509*^9, 
   3.555867706202673*^9}, 3.5558677464093857`*^9}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"solut1", "=", 
  RowBox[{
   RowBox[{
    RowBox[{"Solve", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"DeleteCases", "[", 
        RowBox[{
         RowBox[{
          RowBox[{
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{
               RowBox[{"List", "@@", 
                RowBox[{"Collect", "[", 
                 RowBox[{
                  RowBox[{
                   RowBox[{
                    RowBox[{"AAA", " ", "#"}], "+", "BBB"}], "//", "Expand"}],
                   ",", 
                  RowBox[{"{", 
                   RowBox[{
                    RowBox[{
                    SuperscriptBox["z", "_."], 
                    SqrtBox[
                    RowBox[{"1", "-", 
                    SuperscriptBox["z", "2"]}]]}], ",", 
                    SqrtBox[
                    RowBox[{"1", "-", 
                    SuperscriptBox["z", "2"]}]], ",", "z", ",", "AAA"}], 
                   "}"}]}], "]"}]}], "/.", 
               RowBox[{"AAA", "\[Rule]", "1"}]}], "/.", 
              RowBox[{"BBB", "\[Rule]", "0"}]}], ")"}], "&"}], "/@", 
           "firsteqns"}], "//", "Flatten"}], ",", "0"}], "]"}], "\[Equal]", 
       "0"}], ",", 
      RowBox[{
       RowBox[{"Table", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
           RowBox[{
            SubscriptBox["\[Alpha]", "lead"], "[", "i", "]"}], ",", 
           RowBox[{
            SubscriptBox["\[Beta]", "lead"], "[", "i", "]"}]}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"i", ",", "0", ",", "\[CapitalLambda]\[Rho]s"}], "}"}]}], 
        "]"}], "//", "Flatten"}]}], "]"}], "[", 
    RowBox[{"[", "1", "]"}], "]"}], "//", "Simplify"}]}]], "Input",
 CellChangeTimes->{{3.5558670909006863`*^9, 3.5558671799232283`*^9}, {
   3.555867222449935*^9, 3.555867411149969*^9}, 3.555868708948947*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{
    RowBox[{
     SubscriptBox["\[Alpha]", "lead"], "[", "0", "]"}], "\[Rule]", 
    RowBox[{
     RowBox[{"-", "162"}], "+", 
     RowBox[{
      FractionBox["1", "18"], " ", 
      RowBox[{"\[DoubleStruckCapitalC]", "[", 
       FractionBox[
        RowBox[{"4", " ", "\[ImaginaryI]", " ", 
         SubscriptBox[
          StyleBox["H",
           FontColor->RGBColor[0.54, 0.35, 0.15]], "lead"]}], 
        SuperscriptBox["u", "2"]], "]"}]}], "-", 
     RowBox[{
      FractionBox["1", "9"], " ", 
      RowBox[{"\[DoubleStruckCapitalC]", "[", 
       RowBox[{"-", 
        FractionBox[
         RowBox[{"2", " ", 
          SubscriptBox[
           StyleBox["H",
            FontColor->RGBColor[0.54, 0.35, 0.15]], "lead"]}], "u"]}], 
       "]"}]}], "-", 
     RowBox[{
      FractionBox["1", "9"], " ", 
      RowBox[{"\[DoubleStruckCapitalC]", "[", 
       RowBox[{"-", 
        FractionBox[
         RowBox[{"4", " ", 
          RowBox[{"(", 
           RowBox[{"\[ImaginaryI]", "+", "u"}], ")"}], " ", 
          SubsuperscriptBox[
           StyleBox["W",
            FontColor->RGBColor[0.54, 0.35, 0.15]], 
           RowBox[{"1", ",", "lead"}], "+"]}], 
         SuperscriptBox[
          StyleBox["Q0",
           FontColor->RGBColor[{
              Rational[1, 2], 
              Rational[1, 2], 0}]], "+"]]}], "]"}]}], "-", 
     RowBox[{
      FractionBox["1", "18"], " ", 
      RowBox[{"\[DoubleStruckCapitalC]", "[", 
       FractionBox[
        RowBox[{"12", " ", "\[ImaginaryI]", " ", 
         SubscriptBox[
          OverscriptBox[
           StyleBox["W",
            FontColor->RGBColor[0.54, 0.35, 0.15]], 
           StyleBox["^",
            FontColor->RGBColor[0.54, 0.35, 0.15]]], "lead"]}], 
        RowBox[{"1", "+", 
         SuperscriptBox["u", "2"]}]], "]"}]}], "-", 
     RowBox[{
      FractionBox["1", "9"], " ", 
      RowBox[{"\[DoubleStruckCapitalC]", "[", 
       RowBox[{"-", 
        FractionBox[
         RowBox[{"4", " ", "\[ImaginaryI]", " ", 
          SubscriptBox[
           OverscriptBox[
            StyleBox["W",
             FontColor->RGBColor[0.54, 0.35, 0.15]], 
            StyleBox["^",
             FontColor->RGBColor[0.54, 0.35, 0.15]]], "lead"]}], 
         RowBox[{"3", " ", 
          SuperscriptBox[
           StyleBox["Q0",
            FontColor->RGBColor[{
               Rational[1, 2], 
               Rational[1, 2], 0}]], "-"], " ", 
          SuperscriptBox[
           StyleBox["Q0",
            FontColor->RGBColor[{
               Rational[1, 2], 
               Rational[1, 2], 0}]], "+"]}]]}], "]"}]}], "+", 
     RowBox[{
      FractionBox["2", "9"], " ", 
      RowBox[{"\[DoubleStruckCapitalC]", "[", 
       RowBox[{"-", 
        FractionBox[
         RowBox[{"\[ImaginaryI]", " ", 
          RowBox[{"(", 
           RowBox[{"1", "+", 
            RowBox[{"3", " ", 
             SuperscriptBox["u", "2"]}]}], ")"}], " ", 
          SubscriptBox[
           OverscriptBox[
            StyleBox["W",
             FontColor->RGBColor[0.54, 0.35, 0.15]], 
            StyleBox["^",
             FontColor->RGBColor[0.54, 0.35, 0.15]]], "lead"]}], 
         RowBox[{"3", " ", 
          SuperscriptBox[
           StyleBox["Q0",
            FontColor->RGBColor[{
               Rational[1, 2], 
               Rational[1, 2], 0}]], "-"], " ", 
          SuperscriptBox[
           StyleBox["Q0",
            FontColor->RGBColor[{
               Rational[1, 2], 
               Rational[1, 2], 0}]], "+"]}]]}], "]"}]}], "-", 
     RowBox[{
      FractionBox["2", "9"], " ", 
      SubscriptBox[
       StyleBox["W",
        FontColor->RGBColor[0.54, 0.35, 0.15]], 
       RowBox[{"1", ",", "v0", ",", "lead"}]]}], "+", 
     RowBox[{"60", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2"]}], "+", 
     RowBox[{"24", " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2", "2"]}], "-", 
     FractionBox[
      RowBox[{"16", " ", 
       SubsuperscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "2", "3"]}], "5"], "+", 
     RowBox[{"156", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3"]}], "-", 
     RowBox[{"88", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3"]}], "+", 
     RowBox[{
      FractionBox["16", "5"], " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2", "2"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3"]}], "-", 
     RowBox[{"8", " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3", "2"]}]}]}], ",", 
   RowBox[{
    RowBox[{
     SubscriptBox["\[Beta]", "lead"], "[", "0", "]"}], "\[Rule]", 
    RowBox[{
     FractionBox["1", "30"], " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"-", "4860"}], "+", 
       RowBox[{"5", " ", 
        RowBox[{"\[DoubleStruckCapitalC]", "[", 
         FractionBox[
          RowBox[{"4", " ", "\[ImaginaryI]", " ", 
           SubscriptBox[
            StyleBox["H",
             FontColor->RGBColor[0.54, 0.35, 0.15]], "lead"]}], 
          SuperscriptBox["u", "2"]], "]"}]}], "+", 
       RowBox[{"20", " ", 
        RowBox[{"\[DoubleStruckCapitalC]", "[", 
         RowBox[{"-", 
          FractionBox[
           RowBox[{"2", " ", 
            SubscriptBox[
             StyleBox["H",
              FontColor->RGBColor[0.54, 0.35, 0.15]], "lead"]}], "u"]}], 
         "]"}]}], "+", 
       RowBox[{"20", " ", 
        RowBox[{"\[DoubleStruckCapitalC]", "[", 
         RowBox[{"-", 
          FractionBox[
           RowBox[{"4", " ", 
            RowBox[{"(", 
             RowBox[{"\[ImaginaryI]", "+", "u"}], ")"}], " ", 
            SubsuperscriptBox[
             StyleBox["W",
              FontColor->RGBColor[0.54, 0.35, 0.15]], 
             RowBox[{"1", ",", "lead"}], "+"]}], 
           SuperscriptBox[
            StyleBox["Q0",
             FontColor->RGBColor[{
                Rational[1, 2], 
                Rational[1, 2], 0}]], "+"]]}], "]"}]}], "-", 
       RowBox[{"5", " ", 
        RowBox[{"\[DoubleStruckCapitalC]", "[", 
         FractionBox[
          RowBox[{"12", " ", "\[ImaginaryI]", " ", 
           SubscriptBox[
            OverscriptBox[
             StyleBox["W",
              FontColor->RGBColor[0.54, 0.35, 0.15]], 
             StyleBox["^",
              FontColor->RGBColor[0.54, 0.35, 0.15]]], "lead"]}], 
          RowBox[{"1", "+", 
           SuperscriptBox["u", "2"]}]], "]"}]}], "+", 
       RowBox[{"20", " ", 
        RowBox[{"\[DoubleStruckCapitalC]", "[", 
         RowBox[{"-", 
          FractionBox[
           RowBox[{"4", " ", "\[ImaginaryI]", " ", 
            SubscriptBox[
             OverscriptBox[
              StyleBox["W",
               FontColor->RGBColor[0.54, 0.35, 0.15]], 
              StyleBox["^",
               FontColor->RGBColor[0.54, 0.35, 0.15]]], "lead"]}], 
           RowBox[{"3", " ", 
            SuperscriptBox[
             StyleBox["Q0",
              FontColor->RGBColor[{
                 Rational[1, 2], 
                 Rational[1, 2], 0}]], "-"], " ", 
            SuperscriptBox[
             StyleBox["Q0",
              FontColor->RGBColor[{
                 Rational[1, 2], 
                 Rational[1, 2], 0}]], "+"]}]]}], "]"}]}], "-", 
       RowBox[{"100", " ", 
        RowBox[{"\[DoubleStruckCapitalC]", "[", 
         RowBox[{"-", 
          FractionBox[
           RowBox[{"\[ImaginaryI]", " ", 
            RowBox[{"(", 
             RowBox[{"1", "+", 
              RowBox[{"3", " ", 
               SuperscriptBox["u", "2"]}]}], ")"}], " ", 
            SubscriptBox[
             OverscriptBox[
              StyleBox["W",
               FontColor->RGBColor[0.54, 0.35, 0.15]], 
              StyleBox["^",
               FontColor->RGBColor[0.54, 0.35, 0.15]]], "lead"]}], 
           RowBox[{"3", " ", 
            SuperscriptBox[
             StyleBox["Q0",
              FontColor->RGBColor[{
                 Rational[1, 2], 
                 Rational[1, 2], 0}]], "-"], " ", 
            SuperscriptBox[
             StyleBox["Q0",
              FontColor->RGBColor[{
                 Rational[1, 2], 
                 Rational[1, 2], 0}]], "+"]}]]}], "]"}]}], "+", 
       RowBox[{"100", " ", 
        SubscriptBox[
         StyleBox["W",
          FontColor->RGBColor[0.54, 0.35, 0.15]], 
         RowBox[{"1", ",", "v0", ",", "lead"}]]}], "+", 
       RowBox[{"11880", " ", 
        SubscriptBox[
         StyleBox["\[Zeta]",
          FontWeight->Bold,
          FontColor->GrayLevel[0.4]], "2"]}], "-", 
       RowBox[{"5616", " ", 
        SubsuperscriptBox[
         StyleBox["\[Zeta]",
          FontWeight->Bold,
          FontColor->GrayLevel[0.4]], "2", "2"]}], "+", 
       RowBox[{"576", " ", 
        SubsuperscriptBox[
         StyleBox["\[Zeta]",
          FontWeight->Bold,
          FontColor->GrayLevel[0.4]], "2", "3"]}], "-", 
       RowBox[{"5400", " ", 
        SubscriptBox[
         StyleBox["\[Zeta]",
          FontWeight->Bold,
          FontColor->GrayLevel[0.4]], "3"]}], "+", 
       RowBox[{"720", " ", 
        SubscriptBox[
         StyleBox["\[Zeta]",
          FontWeight->Bold,
          FontColor->GrayLevel[0.4]], "2"], " ", 
        SubscriptBox[
         StyleBox["\[Zeta]",
          FontWeight->Bold,
          FontColor->GrayLevel[0.4]], "3"]}], "+", 
       RowBox[{"288", " ", 
        SubsuperscriptBox[
         StyleBox["\[Zeta]",
          FontWeight->Bold,
          FontColor->GrayLevel[0.4]], "2", "2"], " ", 
        SubscriptBox[
         StyleBox["\[Zeta]",
          FontWeight->Bold,
          FontColor->GrayLevel[0.4]], "3"]}], "+", 
       RowBox[{"1440", " ", 
        SubsuperscriptBox[
         StyleBox["\[Zeta]",
          FontWeight->Bold,
          FontColor->GrayLevel[0.4]], "3", "2"]}]}], ")"}]}]}], ",", 
   RowBox[{
    RowBox[{
     SubscriptBox["\[Alpha]", "lead"], "[", "1", "]"}], "\[Rule]", 
    RowBox[{"648", "-", 
     RowBox[{
      FractionBox["2", "9"], " ", 
      RowBox[{"\[DoubleStruckCapitalC]", "[", 
       FractionBox[
        RowBox[{"4", " ", "\[ImaginaryI]", " ", 
         SubscriptBox[
          StyleBox["H",
           FontColor->RGBColor[0.54, 0.35, 0.15]], "lead"]}], 
        SuperscriptBox["u", "2"]], "]"}]}], "+", 
     RowBox[{
      FractionBox["4", "9"], " ", 
      RowBox[{"\[DoubleStruckCapitalC]", "[", 
       RowBox[{"-", 
        FractionBox[
         RowBox[{"2", " ", 
          SubscriptBox[
           StyleBox["H",
            FontColor->RGBColor[0.54, 0.35, 0.15]], "lead"]}], "u"]}], 
       "]"}]}], "+", 
     RowBox[{
      FractionBox["4", "9"], " ", 
      RowBox[{"\[DoubleStruckCapitalC]", "[", 
       RowBox[{"-", 
        FractionBox[
         RowBox[{"4", " ", 
          RowBox[{"(", 
           RowBox[{"\[ImaginaryI]", "+", "u"}], ")"}], " ", 
          SubsuperscriptBox[
           StyleBox["W",
            FontColor->RGBColor[0.54, 0.35, 0.15]], 
           RowBox[{"1", ",", "lead"}], "+"]}], 
         SuperscriptBox[
          StyleBox["Q0",
           FontColor->RGBColor[{
              Rational[1, 2], 
              Rational[1, 2], 0}]], "+"]]}], "]"}]}], "+", 
     RowBox[{
      FractionBox["2", "9"], " ", 
      RowBox[{"\[DoubleStruckCapitalC]", "[", 
       FractionBox[
        RowBox[{"12", " ", "\[ImaginaryI]", " ", 
         SubscriptBox[
          OverscriptBox[
           StyleBox["W",
            FontColor->RGBColor[0.54, 0.35, 0.15]], 
           StyleBox["^",
            FontColor->RGBColor[0.54, 0.35, 0.15]]], "lead"]}], 
        RowBox[{"1", "+", 
         SuperscriptBox["u", "2"]}]], "]"}]}], "+", 
     RowBox[{
      FractionBox["4", "9"], " ", 
      RowBox[{"\[DoubleStruckCapitalC]", "[", 
       RowBox[{"-", 
        FractionBox[
         RowBox[{"4", " ", "\[ImaginaryI]", " ", 
          SubscriptBox[
           OverscriptBox[
            StyleBox["W",
             FontColor->RGBColor[0.54, 0.35, 0.15]], 
            StyleBox["^",
             FontColor->RGBColor[0.54, 0.35, 0.15]]], "lead"]}], 
         RowBox[{"3", " ", 
          SuperscriptBox[
           StyleBox["Q0",
            FontColor->RGBColor[{
               Rational[1, 2], 
               Rational[1, 2], 0}]], "-"], " ", 
          SuperscriptBox[
           StyleBox["Q0",
            FontColor->RGBColor[{
               Rational[1, 2], 
               Rational[1, 2], 0}]], "+"]}]]}], "]"}]}], "+", 
     RowBox[{
      FractionBox["16", "9"], " ", 
      RowBox[{"\[DoubleStruckCapitalC]", "[", 
       RowBox[{"-", 
        FractionBox[
         RowBox[{"\[ImaginaryI]", " ", 
          RowBox[{"(", 
           RowBox[{"1", "+", 
            RowBox[{"3", " ", 
             SuperscriptBox["u", "2"]}]}], ")"}], " ", 
          SubscriptBox[
           OverscriptBox[
            StyleBox["W",
             FontColor->RGBColor[0.54, 0.35, 0.15]], 
            StyleBox["^",
             FontColor->RGBColor[0.54, 0.35, 0.15]]], "lead"]}], 
         RowBox[{"3", " ", 
          SuperscriptBox[
           StyleBox["Q0",
            FontColor->RGBColor[{
               Rational[1, 2], 
               Rational[1, 2], 0}]], "-"], " ", 
          SuperscriptBox[
           StyleBox["Q0",
            FontColor->RGBColor[{
               Rational[1, 2], 
               Rational[1, 2], 0}]], "+"]}]]}], "]"}]}], "-", 
     RowBox[{
      FractionBox["16", "9"], " ", 
      SubscriptBox[
       StyleBox["W",
        FontColor->RGBColor[0.54, 0.35, 0.15]], 
       RowBox[{"1", ",", "v0", ",", "lead"}]]}], "-", 
     RowBox[{"240", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2"]}], "-", 
     RowBox[{"96", " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2", "2"]}], "+", 
     FractionBox[
      RowBox[{"64", " ", 
       SubsuperscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "2", "3"]}], "5"], "-", 
     RowBox[{"624", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3"]}], "+", 
     RowBox[{"352", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3"]}], "-", 
     RowBox[{
      FractionBox["64", "5"], " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2", "2"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3"]}], "+", 
     RowBox[{"32", " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3", "2"]}]}]}], ",", 
   RowBox[{
    RowBox[{
     SubscriptBox["\[Beta]", "lead"], "[", "1", "]"}], "\[Rule]", "0"}], ",", 
   
   RowBox[{
    RowBox[{
     SubscriptBox["\[Alpha]", "lead"], "[", "2", "]"}], "\[Rule]", "0"}], ",", 
   RowBox[{
    RowBox[{
     SubscriptBox["\[Beta]", "lead"], "[", "2", "]"}], "\[Rule]", "0"}], ",", 
   
   RowBox[{
    RowBox[{
     SubscriptBox["\[Alpha]", "lead"], "[", "3", "]"}], "\[Rule]", "0"}], ",", 
   RowBox[{
    RowBox[{
     SubscriptBox["\[Beta]", "lead"], "[", "3", "]"}], "\[Rule]", "0"}], ",", 
   
   RowBox[{
    RowBox[{
     SubscriptBox["\[Alpha]", "lead"], "[", "4", "]"}], "\[Rule]", "0"}], ",", 
   RowBox[{
    RowBox[{
     SubscriptBox["\[Beta]", "lead"], "[", "4", "]"}], "\[Rule]", "0"}], ",", 
   
   RowBox[{
    RowBox[{
     SubscriptBox["\[Alpha]", "lead"], "[", "5", "]"}], "\[Rule]", "0"}], ",", 
   RowBox[{
    RowBox[{
     SubscriptBox["\[Beta]", "lead"], "[", "5", "]"}], "\[Rule]", "0"}]}], 
  "}"}]], "Output",
 CellChangeTimes->{
  3.5558670943389473`*^9, {3.555867159117064*^9, 3.5558671806020403`*^9}, {
   3.555867224193522*^9, 3.555867326610877*^9}, {3.555867381236259*^9, 
   3.5558674404405193`*^9}, 3.5558677099093733`*^9, {3.55586775121577*^9, 
   3.555867774601324*^9}, 3.555868414580984*^9, 3.5558684480964193`*^9, {
   3.555868711053043*^9, 3.555868748441492*^9}}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Second order", "Subsubsection",
 CellChangeTimes->{{3.555866616963666*^9, 3.5558666197227697`*^9}, {
  3.555869227213325*^9, 3.555869230258786*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"secondset", "=", 
   RowBox[{
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"eqnT11ZeroAtBetheroot", "[", 
        RowBox[{"[", "2", "]"}], "]"}], ",", 
       RowBox[{"eqFromY11Y22", "[", 
        RowBox[{"[", "2", "]"}], "]"}], ",", 
       RowBox[{"eqFromY11oY22", "[", 
        RowBox[{"[", "2", "]"}], "]"}]}], "}"}], "/.", 
     RowBox[{
      SubscriptBox["W", "a_"], "\[RuleDelayed]", 
      SubscriptBox[
       OverscriptBox["W", "^"], "a"]}]}], "/.", 
    RowBox[{"g", "\[Rule]", "1"}]}]}], ";"}]], "Input",
 CellChangeTimes->{{3.555866604526623*^9, 3.555866676631379*^9}, {
   3.555867795264862*^9, 3.555867840222376*^9}, {3.5558678748195047`*^9, 
   3.5558678759470453`*^9}, 3.555868486603088*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"secondeqns", "=", 
    RowBox[{
     RowBox[{
      RowBox[{"secondset", "//.", "subAnsatz"}], "/.", "solut1"}], "//", 
     "Simplify"}]}], ";"}], "\[IndentingNewLine]"}]], "Input",
 CellChangeTimes->{{3.555866679652109*^9, 3.55586680066827*^9}, {
   3.555866842702819*^9, 3.5558670893216047`*^9}, {3.555867700853509*^9, 
   3.555867706202673*^9}, 3.5558677464093857`*^9, {3.55586784340543*^9, 
   3.5558678626276197`*^9}, {3.555868051348563*^9, 3.5558680527005653`*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"solut2", "=", 
  RowBox[{
   RowBox[{
    RowBox[{"Solve", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"DeleteCases", "[", 
        RowBox[{
         RowBox[{
          RowBox[{
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{
               RowBox[{"List", "@@", 
                RowBox[{"Collect", "[", 
                 RowBox[{
                  RowBox[{
                   RowBox[{
                    RowBox[{"AAA", " ", "#"}], "+", "BBB"}], "//", "Expand"}],
                   ",", 
                  RowBox[{"{", 
                   RowBox[{
                    RowBox[{
                    SuperscriptBox["z", "_."], 
                    SqrtBox[
                    RowBox[{"1", "-", 
                    SuperscriptBox["z", "2"]}]]}], ",", 
                    SqrtBox[
                    RowBox[{"1", "-", 
                    SuperscriptBox["z", "2"]}]], ",", "z", ",", "AAA"}], 
                   "}"}]}], "]"}]}], "/.", 
               RowBox[{"AAA", "\[Rule]", "1"}]}], "/.", 
              RowBox[{"BBB", "\[Rule]", "0"}]}], ")"}], "&"}], "/@", 
           "secondeqns"}], "//", "Flatten"}], ",", "0"}], "]"}], "\[Equal]", 
       "0"}], ",", 
      RowBox[{
       RowBox[{"Table", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
           RowBox[{
            SubscriptBox["\[Alpha]", "sublead"], "[", "i", "]"}], ",", 
           RowBox[{
            SubscriptBox["\[Beta]", "sublead"], "[", "i", "]"}]}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"i", ",", "0", ",", "\[CapitalLambda]\[Rho]s"}], "}"}]}], 
        "]"}], "//", "Flatten"}]}], "]"}], "[", 
    RowBox[{"[", "1", "]"}], "]"}], "//", "Simplify"}]}]], "Input",
 CellChangeTimes->{{3.5558670909006863`*^9, 3.5558671799232283`*^9}, {
   3.555867222449935*^9, 3.555867411149969*^9}, {3.5558679005094976`*^9, 
   3.555867916081595*^9}, 3.555868759825069*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{
    RowBox[{
     SubscriptBox["\[Alpha]", "sublead"], "[", "0", "]"}], "\[Rule]", 
    RowBox[{"2826", "+", 
     RowBox[{
      FractionBox["1", "3"], " ", 
      RowBox[{"\[DoubleStruckCapitalC]", "[", 
       FractionBox[
        RowBox[{"4", " ", "\[ImaginaryI]", " ", 
         SubscriptBox[
          StyleBox["H",
           FontColor->RGBColor[0.54, 0.35, 0.15]], "lead"]}], 
        SuperscriptBox["u", "2"]], "]"}]}], "-", 
     RowBox[{
      FractionBox["1", "9"], " ", 
      RowBox[{"\[DoubleStruckCapitalC]", "[", 
       RowBox[{"-", 
        FractionBox[
         RowBox[{"2", " ", 
          SubscriptBox[
           StyleBox["H",
            FontColor->RGBColor[0.54, 0.35, 0.15]], "sublead"]}], "u"]}], 
       "]"}]}], "+", 
     RowBox[{
      FractionBox["1", "18"], " ", 
      RowBox[{"\[DoubleStruckCapitalC]", "[", 
       FractionBox[
        RowBox[{"4", " ", "\[ImaginaryI]", " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"2", " ", 
            SubscriptBox[
             StyleBox["H",
              FontColor->RGBColor[0.54, 0.35, 0.15]], "lead"]}], "+", 
           RowBox[{
            SuperscriptBox["u", "2"], " ", 
            SubscriptBox[
             StyleBox["H",
              FontColor->RGBColor[0.54, 0.35, 0.15]], "sublead"]}]}], ")"}]}], 
        SuperscriptBox["u", "4"]], "]"}]}], "-", 
     RowBox[{
      FractionBox["1", "9"], " ", 
      RowBox[{"\[DoubleStruckCapitalC]", "[", 
       RowBox[{
        RowBox[{"-", 
         FractionBox[
          RowBox[{"4", " ", 
           SuperscriptBox[
            RowBox[{"(", 
             RowBox[{"\[ImaginaryI]", "+", 
              RowBox[{"2", " ", "u"}]}], ")"}], "2"], " ", 
           RowBox[{"(", 
            RowBox[{"1", "+", 
             RowBox[{"\[ImaginaryI]", " ", "u"}], "+", 
             SuperscriptBox["u", "2"]}], ")"}], " ", 
           SubsuperscriptBox[
            StyleBox["W",
             FontColor->RGBColor[0.54, 0.35, 0.15]], 
            RowBox[{"1", ",", "lead"}], "+"]}], 
          RowBox[{"3", " ", 
           SuperscriptBox["u", "2"], " ", 
           RowBox[{"(", 
            RowBox[{"\[ImaginaryI]", "+", "u"}], ")"}], " ", 
           SuperscriptBox[
            RowBox[{"(", 
             SuperscriptBox[
              StyleBox["Q0",
               FontColor->RGBColor[{
                  Rational[1, 2], 
                  Rational[1, 2], 0}]], "+"], ")"}], "2"]}]]}], "-", 
        FractionBox[
         RowBox[{"4", " ", 
          RowBox[{"(", 
           RowBox[{"\[ImaginaryI]", "+", "u"}], ")"}], " ", 
          SubsuperscriptBox[
           StyleBox["W",
            FontColor->RGBColor[0.54, 0.35, 0.15]], 
           RowBox[{"1", ",", "sublead"}], "+"]}], 
         SuperscriptBox[
          StyleBox["Q0",
           FontColor->RGBColor[{
              Rational[1, 2], 
              Rational[1, 2], 0}]], "+"]]}], "]"}]}], "-", 
     RowBox[{
      FractionBox["1", "3"], " ", 
      RowBox[{"\[DoubleStruckCapitalC]", "[", 
       FractionBox[
        RowBox[{"12", " ", "\[ImaginaryI]", " ", 
         SubscriptBox[
          OverscriptBox[
           StyleBox["W",
            FontColor->RGBColor[0.54, 0.35, 0.15]], 
           StyleBox["^",
            FontColor->RGBColor[0.54, 0.35, 0.15]]], "lead"]}], 
        RowBox[{"1", "+", 
         SuperscriptBox["u", "2"]}]], "]"}]}], "+", 
     RowBox[{
      FractionBox["1", "9"], " ", 
      RowBox[{"\[DoubleStruckCapitalC]", "[", 
       RowBox[{"-", 
        FractionBox[
         RowBox[{"24", " ", "\[ImaginaryI]", " ", 
          SubscriptBox[
           OverscriptBox[
            StyleBox["W",
             FontColor->RGBColor[0.54, 0.35, 0.15]], 
            StyleBox["^",
             FontColor->RGBColor[0.54, 0.35, 0.15]]], "lead"]}], 
         RowBox[{"1", "+", 
          SuperscriptBox["u", "2"]}]]}], "]"}]}], "+", 
     RowBox[{
      FractionBox["4", "3"], " ", 
      RowBox[{"\[DoubleStruckCapitalC]", "[", 
       RowBox[{"-", 
        FractionBox[
         RowBox[{"\[ImaginaryI]", " ", 
          RowBox[{"(", 
           RowBox[{"1", "+", 
            RowBox[{"3", " ", 
             SuperscriptBox["u", "2"]}]}], ")"}], " ", 
          SubscriptBox[
           OverscriptBox[
            StyleBox["W",
             FontColor->RGBColor[0.54, 0.35, 0.15]], 
            StyleBox["^",
             FontColor->RGBColor[0.54, 0.35, 0.15]]], "lead"]}], 
         RowBox[{"3", " ", 
          SuperscriptBox[
           StyleBox["Q0",
            FontColor->RGBColor[{
               Rational[1, 2], 
               Rational[1, 2], 0}]], "-"], " ", 
          SuperscriptBox[
           StyleBox["Q0",
            FontColor->RGBColor[{
               Rational[1, 2], 
               Rational[1, 2], 0}]], "+"]}]]}], "]"}]}], "-", 
     RowBox[{
      FractionBox["1", "18"], " ", 
      RowBox[{"\[DoubleStruckCapitalC]", "[", 
       FractionBox[
        RowBox[{"12", " ", "\[ImaginaryI]", " ", 
         SubscriptBox[
          OverscriptBox[
           StyleBox["W",
            FontColor->RGBColor[0.54, 0.35, 0.15]], 
           StyleBox["^",
            FontColor->RGBColor[0.54, 0.35, 0.15]]], "sublead"]}], 
        RowBox[{"1", "+", 
         SuperscriptBox["u", "2"]}]], "]"}]}], "+", 
     RowBox[{
      FractionBox["2", "9"], " ", 
      RowBox[{"\[DoubleStruckCapitalC]", "[", 
       RowBox[{"-", 
        FractionBox[
         RowBox[{"\[ImaginaryI]", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"4", " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"-", "1"}], "+", 
               RowBox[{"3", " ", 
                SuperscriptBox["u", "2"]}], "+", 
               RowBox[{"27", " ", 
                SuperscriptBox["u", "4"]}]}], ")"}], " ", 
             SubscriptBox[
              OverscriptBox[
               StyleBox["W",
                FontColor->RGBColor[0.54, 0.35, 0.15]], 
               StyleBox["^",
                FontColor->RGBColor[0.54, 0.35, 0.15]]], "lead"]}], "+", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{"1", "+", 
               RowBox[{"6", " ", 
                SuperscriptBox["u", "2"]}], "+", 
               RowBox[{"18", " ", 
                SuperscriptBox["u", "4"]}], "+", 
               RowBox[{"27", " ", 
                SuperscriptBox["u", "6"]}]}], ")"}], " ", 
             SubscriptBox[
              OverscriptBox[
               StyleBox["W",
                FontColor->RGBColor[0.54, 0.35, 0.15]], 
               StyleBox["^",
                FontColor->RGBColor[0.54, 0.35, 0.15]]], "sublead"]}]}], 
           ")"}]}], 
         RowBox[{"27", " ", 
          SuperscriptBox[
           RowBox[{"(", 
            SuperscriptBox[
             StyleBox["Q0",
              FontColor->RGBColor[{
                 Rational[1, 2], 
                 Rational[1, 2], 0}]], "-"], ")"}], "2"], " ", 
          SuperscriptBox[
           RowBox[{"(", 
            SuperscriptBox[
             StyleBox["Q0",
              FontColor->RGBColor[{
                 Rational[1, 2], 
                 Rational[1, 2], 0}]], "+"], ")"}], "2"]}]]}], "]"}]}], "-", 
     RowBox[{
      FractionBox["1", "9"], " ", 
      RowBox[{"\[DoubleStruckCapitalC]", "[", 
       RowBox[{"-", 
        FractionBox[
         RowBox[{"4", " ", "\[ImaginaryI]", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{
             RowBox[{"(", 
              RowBox[{"11", "+", 
               RowBox[{"113", " ", 
                SuperscriptBox["u", "2"]}], "+", 
               RowBox[{"434", " ", 
                SuperscriptBox["u", "4"]}], "+", 
               RowBox[{"729", " ", 
                SuperscriptBox["u", "6"]}], "+", 
               RowBox[{"819", " ", 
                SuperscriptBox["u", "8"]}], "+", 
               RowBox[{"324", " ", 
                SuperscriptBox["u", "10"]}]}], ")"}], " ", 
             SubscriptBox[
              OverscriptBox[
               StyleBox["W",
                FontColor->RGBColor[0.54, 0.35, 0.15]], 
               StyleBox["^",
                FontColor->RGBColor[0.54, 0.35, 0.15]]], "lead"]}], "+", 
            RowBox[{"9", " ", 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{"1", "+", 
                SuperscriptBox["u", "2"]}], ")"}], "2"], " ", 
             SuperscriptBox[
              StyleBox["Q0",
               FontColor->RGBColor[{
                  Rational[1, 2], 
                  Rational[1, 2], 0}]], "-"], " ", 
             SuperscriptBox[
              StyleBox["Q0",
               FontColor->RGBColor[{
                  Rational[1, 2], 
                  Rational[1, 2], 0}]], "+"], " ", 
             SubscriptBox[
              OverscriptBox[
               StyleBox["W",
                FontColor->RGBColor[0.54, 0.35, 0.15]], 
               StyleBox["^",
                FontColor->RGBColor[0.54, 0.35, 0.15]]], "sublead"]}]}], 
           ")"}]}], 
         RowBox[{"27", " ", 
          SuperscriptBox[
           RowBox[{"(", 
            RowBox[{"1", "+", 
             SuperscriptBox["u", "2"]}], ")"}], "2"], " ", 
          SuperscriptBox[
           RowBox[{"(", 
            SuperscriptBox[
             StyleBox["Q0",
              FontColor->RGBColor[{
                 Rational[1, 2], 
                 Rational[1, 2], 0}]], "-"], ")"}], "2"], " ", 
          SuperscriptBox[
           RowBox[{"(", 
            SuperscriptBox[
             StyleBox["Q0",
              FontColor->RGBColor[{
                 Rational[1, 2], 
                 Rational[1, 2], 0}]], "+"], ")"}], "2"]}]]}], "]"}]}], "-", 
     RowBox[{
      FractionBox["4", "3"], " ", 
      SubscriptBox[
       StyleBox["W",
        FontColor->RGBColor[0.54, 0.35, 0.15]], 
       RowBox[{"1", ",", "v0", ",", "lead"}]]}], "-", 
     RowBox[{
      FractionBox["2", "9"], " ", 
      SubscriptBox[
       StyleBox["W",
        FontColor->RGBColor[0.54, 0.35, 0.15]], 
       RowBox[{"1", ",", "v0", ",", "sublead"}]]}], "+", 
     RowBox[{"420", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2"]}], "-", 
     RowBox[{"720", " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2", "2"]}], "+", 
     FractionBox[
      RowBox[{"1328", " ", 
       SubsuperscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "2", "3"]}], "5"], "-", 
     FractionBox[
      RowBox[{"288", " ", 
       SubsuperscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "2", "4"]}], "175"], "-", 
     RowBox[{"2748", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3"]}], "-", 
     RowBox[{"1256", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3"]}], "+", 
     RowBox[{
      FractionBox["784", "5"], " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2", "2"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3"]}], "-", 
     RowBox[{
      FractionBox["256", "35"], " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2", "3"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3"]}], "+", 
     RowBox[{"1552", " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3", "2"]}], "+", 
     RowBox[{"96", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2"], " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3", "2"]}], "-", 
     RowBox[{"468", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "5"]}], "+", 
     RowBox[{"504", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "5"]}], "-", 
     RowBox[{
      FractionBox["48", "5"], " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2", "2"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "5"]}], "-", 
     RowBox[{"192", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "5"]}]}]}], ",", 
   RowBox[{
    RowBox[{
     SubscriptBox["\[Beta]", "sublead"], "[", "0", "]"}], "\[Rule]", 
    RowBox[{"7992", "-", 
     RowBox[{
      FractionBox["1", "6"], " ", 
      RowBox[{"\[DoubleStruckCapitalC]", "[", 
       FractionBox[
        RowBox[{"4", " ", "\[ImaginaryI]", " ", 
         SubscriptBox[
          StyleBox["H",
           FontColor->RGBColor[0.54, 0.35, 0.15]], "lead"]}], 
        SuperscriptBox["u", "2"]], "]"}]}], "-", 
     RowBox[{
      FractionBox["8", "3"], " ", 
      RowBox[{"\[DoubleStruckCapitalC]", "[", 
       RowBox[{"-", 
        FractionBox[
         RowBox[{"2", " ", 
          SubscriptBox[
           StyleBox["H",
            FontColor->RGBColor[0.54, 0.35, 0.15]], "lead"]}], "u"]}], 
       "]"}]}], "+", 
     RowBox[{
      FractionBox["2", "3"], " ", 
      RowBox[{"\[DoubleStruckCapitalC]", "[", 
       RowBox[{"-", 
        FractionBox[
         RowBox[{"2", " ", 
          SubscriptBox[
           StyleBox["H",
            FontColor->RGBColor[0.54, 0.35, 0.15]], "sublead"]}], "u"]}], 
       "]"}]}], "+", 
     RowBox[{
      FractionBox["1", "6"], " ", 
      RowBox[{"\[DoubleStruckCapitalC]", "[", 
       FractionBox[
        RowBox[{"4", " ", "\[ImaginaryI]", " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"2", " ", 
            SubscriptBox[
             StyleBox["H",
              FontColor->RGBColor[0.54, 0.35, 0.15]], "lead"]}], "+", 
           RowBox[{
            SuperscriptBox["u", "2"], " ", 
            SubscriptBox[
             StyleBox["H",
              FontColor->RGBColor[0.54, 0.35, 0.15]], "sublead"]}]}], ")"}]}], 
        SuperscriptBox["u", "4"]], "]"}]}], "-", 
     RowBox[{
      FractionBox["8", "3"], " ", 
      RowBox[{"\[DoubleStruckCapitalC]", "[", 
       RowBox[{"-", 
        FractionBox[
         RowBox[{"4", " ", 
          RowBox[{"(", 
           RowBox[{"\[ImaginaryI]", "+", "u"}], ")"}], " ", 
          SubsuperscriptBox[
           StyleBox["W",
            FontColor->RGBColor[0.54, 0.35, 0.15]], 
           RowBox[{"1", ",", "lead"}], "+"]}], 
         SuperscriptBox[
          StyleBox["Q0",
           FontColor->RGBColor[{
              Rational[1, 2], 
              Rational[1, 2], 0}]], "+"]]}], "]"}]}], "+", 
     RowBox[{
      FractionBox["2", "3"], " ", 
      RowBox[{"\[DoubleStruckCapitalC]", "[", 
       RowBox[{
        RowBox[{"-", 
         FractionBox[
          RowBox[{"4", " ", 
           SuperscriptBox[
            RowBox[{"(", 
             RowBox[{"\[ImaginaryI]", "+", 
              RowBox[{"2", " ", "u"}]}], ")"}], "2"], " ", 
           RowBox[{"(", 
            RowBox[{"1", "+", 
             RowBox[{"\[ImaginaryI]", " ", "u"}], "+", 
             SuperscriptBox["u", "2"]}], ")"}], " ", 
           SubsuperscriptBox[
            StyleBox["W",
             FontColor->RGBColor[0.54, 0.35, 0.15]], 
            RowBox[{"1", ",", "lead"}], "+"]}], 
          RowBox[{"3", " ", 
           SuperscriptBox["u", "2"], " ", 
           RowBox[{"(", 
            RowBox[{"\[ImaginaryI]", "+", "u"}], ")"}], " ", 
           SuperscriptBox[
            RowBox[{"(", 
             SuperscriptBox[
              StyleBox["Q0",
               FontColor->RGBColor[{
                  Rational[1, 2], 
                  Rational[1, 2], 0}]], "+"], ")"}], "2"]}]]}], "-", 
        FractionBox[
         RowBox[{"4", " ", 
          RowBox[{"(", 
           RowBox[{"\[ImaginaryI]", "+", "u"}], ")"}], " ", 
          SubsuperscriptBox[
           StyleBox["W",
            FontColor->RGBColor[0.54, 0.35, 0.15]], 
           RowBox[{"1", ",", "sublead"}], "+"]}], 
         SuperscriptBox[
          StyleBox["Q0",
           FontColor->RGBColor[{
              Rational[1, 2], 
              Rational[1, 2], 0}]], "+"]]}], "]"}]}], "+", 
     RowBox[{
      FractionBox["1", "6"], " ", 
      RowBox[{"\[DoubleStruckCapitalC]", "[", 
       FractionBox[
        RowBox[{"12", " ", "\[ImaginaryI]", " ", 
         SubscriptBox[
          OverscriptBox[
           StyleBox["W",
            FontColor->RGBColor[0.54, 0.35, 0.15]], 
           StyleBox["^",
            FontColor->RGBColor[0.54, 0.35, 0.15]]], "lead"]}], 
        RowBox[{"1", "+", 
         SuperscriptBox["u", "2"]}]], "]"}]}], "-", 
     RowBox[{
      FractionBox["2", "3"], " ", 
      RowBox[{"\[DoubleStruckCapitalC]", "[", 
       RowBox[{"-", 
        FractionBox[
         RowBox[{"24", " ", "\[ImaginaryI]", " ", 
          SubscriptBox[
           OverscriptBox[
            StyleBox["W",
             FontColor->RGBColor[0.54, 0.35, 0.15]], 
            StyleBox["^",
             FontColor->RGBColor[0.54, 0.35, 0.15]]], "lead"]}], 
         RowBox[{"1", "+", 
          SuperscriptBox["u", "2"]}]]}], "]"}]}], "-", 
     RowBox[{
      FractionBox["8", "3"], " ", 
      RowBox[{"\[DoubleStruckCapitalC]", "[", 
       RowBox[{"-", 
        FractionBox[
         RowBox[{"4", " ", "\[ImaginaryI]", " ", 
          SubscriptBox[
           OverscriptBox[
            StyleBox["W",
             FontColor->RGBColor[0.54, 0.35, 0.15]], 
            StyleBox["^",
             FontColor->RGBColor[0.54, 0.35, 0.15]]], "lead"]}], 
         RowBox[{"3", " ", 
          SuperscriptBox[
           StyleBox["Q0",
            FontColor->RGBColor[{
               Rational[1, 2], 
               Rational[1, 2], 0}]], "-"], " ", 
          SuperscriptBox[
           StyleBox["Q0",
            FontColor->RGBColor[{
               Rational[1, 2], 
               Rational[1, 2], 0}]], "+"]}]]}], "]"}]}], "-", 
     RowBox[{
      FractionBox["26", "3"], " ", 
      RowBox[{"\[DoubleStruckCapitalC]", "[", 
       RowBox[{"-", 
        FractionBox[
         RowBox[{"\[ImaginaryI]", " ", 
          RowBox[{"(", 
           RowBox[{"1", "+", 
            RowBox[{"3", " ", 
             SuperscriptBox["u", "2"]}]}], ")"}], " ", 
          SubscriptBox[
           OverscriptBox[
            StyleBox["W",
             FontColor->RGBColor[0.54, 0.35, 0.15]], 
            StyleBox["^",
             FontColor->RGBColor[0.54, 0.35, 0.15]]], "lead"]}], 
         RowBox[{"3", " ", 
          SuperscriptBox[
           StyleBox["Q0",
            FontColor->RGBColor[{
               Rational[1, 2], 
               Rational[1, 2], 0}]], "-"], " ", 
          SuperscriptBox[
           StyleBox["Q0",
            FontColor->RGBColor[{
               Rational[1, 2], 
               Rational[1, 2], 0}]], "+"]}]]}], "]"}]}], "-", 
     RowBox[{
      FractionBox["1", "6"], " ", 
      RowBox[{"\[DoubleStruckCapitalC]", "[", 
       FractionBox[
        RowBox[{"12", " ", "\[ImaginaryI]", " ", 
         SubscriptBox[
          OverscriptBox[
           StyleBox["W",
            FontColor->RGBColor[0.54, 0.35, 0.15]], 
           StyleBox["^",
            FontColor->RGBColor[0.54, 0.35, 0.15]]], "sublead"]}], 
        RowBox[{"1", "+", 
         SuperscriptBox["u", "2"]}]], "]"}]}], "-", 
     RowBox[{
      FractionBox["10", "3"], " ", 
      RowBox[{"\[DoubleStruckCapitalC]", "[", 
       RowBox[{"-", 
        FractionBox[
         RowBox[{"\[ImaginaryI]", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"4", " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"-", "1"}], "+", 
               RowBox[{"3", " ", 
                SuperscriptBox["u", "2"]}], "+", 
               RowBox[{"27", " ", 
                SuperscriptBox["u", "4"]}]}], ")"}], " ", 
             SubscriptBox[
              OverscriptBox[
               StyleBox["W",
                FontColor->RGBColor[0.54, 0.35, 0.15]], 
               StyleBox["^",
                FontColor->RGBColor[0.54, 0.35, 0.15]]], "lead"]}], "+", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{"1", "+", 
               RowBox[{"6", " ", 
                SuperscriptBox["u", "2"]}], "+", 
               RowBox[{"18", " ", 
                SuperscriptBox["u", "4"]}], "+", 
               RowBox[{"27", " ", 
                SuperscriptBox["u", "6"]}]}], ")"}], " ", 
             SubscriptBox[
              OverscriptBox[
               StyleBox["W",
                FontColor->RGBColor[0.54, 0.35, 0.15]], 
               StyleBox["^",
                FontColor->RGBColor[0.54, 0.35, 0.15]]], "sublead"]}]}], 
           ")"}]}], 
         RowBox[{"27", " ", 
          SuperscriptBox[
           RowBox[{"(", 
            SuperscriptBox[
             StyleBox["Q0",
              FontColor->RGBColor[{
                 Rational[1, 2], 
                 Rational[1, 2], 0}]], "-"], ")"}], "2"], " ", 
          SuperscriptBox[
           RowBox[{"(", 
            SuperscriptBox[
             StyleBox["Q0",
              FontColor->RGBColor[{
                 Rational[1, 2], 
                 Rational[1, 2], 0}]], "+"], ")"}], "2"]}]]}], "]"}]}], "+", 
     RowBox[{
      FractionBox["2", "3"], " ", 
      RowBox[{"\[DoubleStruckCapitalC]", "[", 
       RowBox[{"-", 
        FractionBox[
         RowBox[{"4", " ", "\[ImaginaryI]", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{
             RowBox[{"(", 
              RowBox[{"11", "+", 
               RowBox[{"113", " ", 
                SuperscriptBox["u", "2"]}], "+", 
               RowBox[{"434", " ", 
                SuperscriptBox["u", "4"]}], "+", 
               RowBox[{"729", " ", 
                SuperscriptBox["u", "6"]}], "+", 
               RowBox[{"819", " ", 
                SuperscriptBox["u", "8"]}], "+", 
               RowBox[{"324", " ", 
                SuperscriptBox["u", "10"]}]}], ")"}], " ", 
             SubscriptBox[
              OverscriptBox[
               StyleBox["W",
                FontColor->RGBColor[0.54, 0.35, 0.15]], 
               StyleBox["^",
                FontColor->RGBColor[0.54, 0.35, 0.15]]], "lead"]}], "+", 
            RowBox[{"9", " ", 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{"1", "+", 
                SuperscriptBox["u", "2"]}], ")"}], "2"], " ", 
             SuperscriptBox[
              StyleBox["Q0",
               FontColor->RGBColor[{
                  Rational[1, 2], 
                  Rational[1, 2], 0}]], "-"], " ", 
             SuperscriptBox[
              StyleBox["Q0",
               FontColor->RGBColor[{
                  Rational[1, 2], 
                  Rational[1, 2], 0}]], "+"], " ", 
             SubscriptBox[
              OverscriptBox[
               StyleBox["W",
                FontColor->RGBColor[0.54, 0.35, 0.15]], 
               StyleBox["^",
                FontColor->RGBColor[0.54, 0.35, 0.15]]], "sublead"]}]}], 
           ")"}]}], 
         RowBox[{"27", " ", 
          SuperscriptBox[
           RowBox[{"(", 
            RowBox[{"1", "+", 
             SuperscriptBox["u", "2"]}], ")"}], "2"], " ", 
          SuperscriptBox[
           RowBox[{"(", 
            SuperscriptBox[
             StyleBox["Q0",
              FontColor->RGBColor[{
                 Rational[1, 2], 
                 Rational[1, 2], 0}]], "-"], ")"}], "2"], " ", 
          SuperscriptBox[
           RowBox[{"(", 
            SuperscriptBox[
             StyleBox["Q0",
              FontColor->RGBColor[{
                 Rational[1, 2], 
                 Rational[1, 2], 0}]], "+"], ")"}], "2"]}]]}], "]"}]}], "+", 
     RowBox[{
      FractionBox["26", "3"], " ", 
      SubscriptBox[
       StyleBox["W",
        FontColor->RGBColor[0.54, 0.35, 0.15]], 
       RowBox[{"1", ",", "v0", ",", "lead"}]]}], "+", 
     RowBox[{
      FractionBox["10", "3"], " ", 
      SubscriptBox[
       StyleBox["W",
        FontColor->RGBColor[0.54, 0.35, 0.15]], 
       RowBox[{"1", ",", "v0", ",", "sublead"}]]}], "-", 
     RowBox[{"8208", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2"]}], "+", 
     FractionBox[
      RowBox[{"7416", " ", 
       SubsuperscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "2", "2"]}], "5"], "+", 
     FractionBox[
      RowBox[{"8496", " ", 
       SubsuperscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "2", "3"]}], "35"], "-", 
     FractionBox[
      RowBox[{"16416", " ", 
       SubsuperscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "2", "4"]}], "175"], "-", 
     RowBox[{"5040", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3"]}], "+", 
     RowBox[{"3840", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3"]}], "-", 
     RowBox[{
      FractionBox["576", "5"], " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2", "2"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3"]}], "-", 
     RowBox[{
      FractionBox["768", "35"], " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2", "3"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3"]}], "-", 
     RowBox[{"432", " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3", "2"]}], "+", 
     RowBox[{"288", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2"], " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3", "2"]}], "+", 
     RowBox[{"3780", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "5"]}], "-", 
     RowBox[{"1512", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "5"]}], "-", 
     RowBox[{
      FractionBox["144", "5"], " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2", "2"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "5"]}], "-", 
     RowBox[{"1008", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "5"]}]}]}], ",", 
   RowBox[{
    RowBox[{
     SubscriptBox["\[Alpha]", "sublead"], "[", "1", "]"}], "\[Rule]", 
    RowBox[{
     RowBox[{"-", "6120"}], "+", 
     RowBox[{
      FractionBox["1", "9"], " ", 
      RowBox[{"\[DoubleStruckCapitalC]", "[", 
       FractionBox[
        RowBox[{"16", " ", "\[ImaginaryI]", " ", 
         SubscriptBox[
          StyleBox["H",
           FontColor->RGBColor[0.54, 0.35, 0.15]], "lead"]}], 
        SuperscriptBox["u", "4"]], "]"}]}], "-", 
     RowBox[{
      FractionBox["2", "9"], " ", 
      RowBox[{"\[DoubleStruckCapitalC]", "[", 
       RowBox[{"-", 
        FractionBox[
         RowBox[{"8", " ", 
          SubscriptBox[
           StyleBox["H",
            FontColor->RGBColor[0.54, 0.35, 0.15]], "lead"]}], 
         SuperscriptBox["u", "3"]]}], "]"}]}], "-", 
     RowBox[{
      FractionBox["4", "3"], " ", 
      RowBox[{"\[DoubleStruckCapitalC]", "[", 
       FractionBox[
        RowBox[{"4", " ", "\[ImaginaryI]", " ", 
         SubscriptBox[
          StyleBox["H",
           FontColor->RGBColor[0.54, 0.35, 0.15]], "lead"]}], 
        SuperscriptBox["u", "2"]], "]"}]}], "+", 
     RowBox[{
      FractionBox["4", "9"], " ", 
      RowBox[{"\[DoubleStruckCapitalC]", "[", 
       RowBox[{"-", 
        FractionBox[
         RowBox[{"2", " ", 
          SubscriptBox[
           StyleBox["H",
            FontColor->RGBColor[0.54, 0.35, 0.15]], "sublead"]}], "u"]}], 
       "]"}]}], "-", 
     RowBox[{
      FractionBox["2", "9"], " ", 
      RowBox[{"\[DoubleStruckCapitalC]", "[", 
       FractionBox[
        RowBox[{"4", " ", "\[ImaginaryI]", " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"2", " ", 
            SubscriptBox[
             StyleBox["H",
              FontColor->RGBColor[0.54, 0.35, 0.15]], "lead"]}], "+", 
           RowBox[{
            SuperscriptBox["u", "2"], " ", 
            SubscriptBox[
             StyleBox["H",
              FontColor->RGBColor[0.54, 0.35, 0.15]], "sublead"]}]}], ")"}]}], 
        SuperscriptBox["u", "4"]], "]"}]}], "-", 
     RowBox[{
      FractionBox["2", "9"], " ", 
      RowBox[{"\[DoubleStruckCapitalC]", "[", 
       RowBox[{"-", 
        FractionBox[
         RowBox[{"16", " ", 
          RowBox[{"(", 
           RowBox[{"\[ImaginaryI]", "+", "u"}], ")"}], " ", 
          SubsuperscriptBox[
           StyleBox["W",
            FontColor->RGBColor[0.54, 0.35, 0.15]], 
           RowBox[{"1", ",", "lead"}], "+"]}], 
         RowBox[{
          SuperscriptBox["u", "2"], " ", 
          SuperscriptBox[
           StyleBox["Q0",
            FontColor->RGBColor[{
               Rational[1, 2], 
               Rational[1, 2], 0}]], "+"]}]]}], "]"}]}], "+", 
     RowBox[{
      FractionBox["4", "9"], " ", 
      RowBox[{"\[DoubleStruckCapitalC]", "[", 
       RowBox[{
        RowBox[{"-", 
         FractionBox[
          RowBox[{"4", " ", 
           SuperscriptBox[
            RowBox[{"(", 
             RowBox[{"\[ImaginaryI]", "+", 
              RowBox[{"2", " ", "u"}]}], ")"}], "2"], " ", 
           RowBox[{"(", 
            RowBox[{"1", "+", 
             RowBox[{"\[ImaginaryI]", " ", "u"}], "+", 
             SuperscriptBox["u", "2"]}], ")"}], " ", 
           SubsuperscriptBox[
            StyleBox["W",
             FontColor->RGBColor[0.54, 0.35, 0.15]], 
            RowBox[{"1", ",", "lead"}], "+"]}], 
          RowBox[{"3", " ", 
           SuperscriptBox["u", "2"], " ", 
           RowBox[{"(", 
            RowBox[{"\[ImaginaryI]", "+", "u"}], ")"}], " ", 
           SuperscriptBox[
            RowBox[{"(", 
             SuperscriptBox[
              StyleBox["Q0",
               FontColor->RGBColor[{
                  Rational[1, 2], 
                  Rational[1, 2], 0}]], "+"], ")"}], "2"]}]]}], "-", 
        FractionBox[
         RowBox[{"4", " ", 
          RowBox[{"(", 
           RowBox[{"\[ImaginaryI]", "+", "u"}], ")"}], " ", 
          SubsuperscriptBox[
           StyleBox["W",
            FontColor->RGBColor[0.54, 0.35, 0.15]], 
           RowBox[{"1", ",", "sublead"}], "+"]}], 
         SuperscriptBox[
          StyleBox["Q0",
           FontColor->RGBColor[{
              Rational[1, 2], 
              Rational[1, 2], 0}]], "+"]]}], "]"}]}], "+", 
     RowBox[{
      FractionBox["4", "3"], " ", 
      RowBox[{"\[DoubleStruckCapitalC]", "[", 
       FractionBox[
        RowBox[{"12", " ", "\[ImaginaryI]", " ", 
         SubscriptBox[
          OverscriptBox[
           StyleBox["W",
            FontColor->RGBColor[0.54, 0.35, 0.15]], 
           StyleBox["^",
            FontColor->RGBColor[0.54, 0.35, 0.15]]], "lead"]}], 
        RowBox[{"1", "+", 
         SuperscriptBox["u", "2"]}]], "]"}]}], "-", 
     RowBox[{
      FractionBox["4", "9"], " ", 
      RowBox[{"\[DoubleStruckCapitalC]", "[", 
       RowBox[{"-", 
        FractionBox[
         RowBox[{"24", " ", "\[ImaginaryI]", " ", 
          SubscriptBox[
           OverscriptBox[
            StyleBox["W",
             FontColor->RGBColor[0.54, 0.35, 0.15]], 
            StyleBox["^",
             FontColor->RGBColor[0.54, 0.35, 0.15]]], "lead"]}], 
         RowBox[{"1", "+", 
          SuperscriptBox["u", "2"]}]]}], "]"}]}], "+", 
     RowBox[{
      FractionBox["2", "9"], " ", 
      RowBox[{"\[DoubleStruckCapitalC]", "[", 
       FractionBox[
        RowBox[{"24", " ", "\[ImaginaryI]", " ", 
         RowBox[{"(", 
          RowBox[{"1", "+", 
           RowBox[{"5", " ", 
            SuperscriptBox["u", "2"]}], "+", 
           RowBox[{"2", " ", 
            SuperscriptBox["u", "4"]}]}], ")"}], " ", 
         SubscriptBox[
          OverscriptBox[
           StyleBox["W",
            FontColor->RGBColor[0.54, 0.35, 0.15]], 
           StyleBox["^",
            FontColor->RGBColor[0.54, 0.35, 0.15]]], "lead"]}], 
        SuperscriptBox[
         RowBox[{"(", 
          RowBox[{"u", "+", 
           SuperscriptBox["u", "3"]}], ")"}], "2"]], "]"}]}], "-", 
     RowBox[{
      FractionBox["1", "9"], " ", 
      RowBox[{"\[DoubleStruckCapitalC]", "[", 
       RowBox[{"-", 
        FractionBox[
         RowBox[{"48", " ", "\[ImaginaryI]", " ", 
          RowBox[{"(", 
           RowBox[{"2", "+", 
            RowBox[{"12", " ", 
             SuperscriptBox["u", "2"]}], "+", 
            RowBox[{"9", " ", 
             SuperscriptBox["u", "4"]}], "+", 
            RowBox[{"3", " ", 
             SuperscriptBox["u", "6"]}]}], ")"}], " ", 
          SubscriptBox[
           OverscriptBox[
            StyleBox["W",
             FontColor->RGBColor[0.54, 0.35, 0.15]], 
            StyleBox["^",
             FontColor->RGBColor[0.54, 0.35, 0.15]]], "lead"]}], 
         RowBox[{
          SuperscriptBox["u", "2"], " ", 
          SuperscriptBox[
           RowBox[{"(", 
            RowBox[{"1", "+", 
             SuperscriptBox["u", "2"]}], ")"}], "3"]}]]}], "]"}]}], "+", 
     RowBox[{
      FractionBox["32", "3"], " ", 
      RowBox[{"\[DoubleStruckCapitalC]", "[", 
       RowBox[{"-", 
        FractionBox[
         RowBox[{"\[ImaginaryI]", " ", 
          RowBox[{"(", 
           RowBox[{"1", "+", 
            RowBox[{"3", " ", 
             SuperscriptBox["u", "2"]}]}], ")"}], " ", 
          SubscriptBox[
           OverscriptBox[
            StyleBox["W",
             FontColor->RGBColor[0.54, 0.35, 0.15]], 
            StyleBox["^",
             FontColor->RGBColor[0.54, 0.35, 0.15]]], "lead"]}], 
         RowBox[{"3", " ", 
          SuperscriptBox[
           StyleBox["Q0",
            FontColor->RGBColor[{
               Rational[1, 2], 
               Rational[1, 2], 0}]], "-"], " ", 
          SuperscriptBox[
           StyleBox["Q0",
            FontColor->RGBColor[{
               Rational[1, 2], 
               Rational[1, 2], 0}]], "+"]}]]}], "]"}]}], "-", 
     RowBox[{
      FractionBox["2", "9"], " ", 
      RowBox[{"\[DoubleStruckCapitalC]", "[", 
       FractionBox[
        RowBox[{"16", " ", "\[ImaginaryI]", " ", 
         RowBox[{"(", 
          RowBox[{"6", "+", 
           RowBox[{"25", " ", 
            SuperscriptBox["u", "2"]}], "+", 
           RowBox[{"51", " ", 
            SuperscriptBox["u", "4"]}], "+", 
           RowBox[{"18", " ", 
            SuperscriptBox["u", "6"]}]}], ")"}], " ", 
         SubscriptBox[
          OverscriptBox[
           StyleBox["W",
            FontColor->RGBColor[0.54, 0.35, 0.15]], 
           StyleBox["^",
            FontColor->RGBColor[0.54, 0.35, 0.15]]], "lead"]}], 
        RowBox[{"3", " ", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"1", "+", 
            SuperscriptBox["u", "2"]}], ")"}], "2"], " ", 
         SuperscriptBox[
          StyleBox["Q0",
           FontColor->RGBColor[{
              Rational[1, 2], 
              Rational[1, 2], 0}]], "-"], " ", 
         SuperscriptBox[
          StyleBox["Q0",
           FontColor->RGBColor[{
              Rational[1, 2], 
              Rational[1, 2], 0}]], "+"]}]], "]"}]}], "+", 
     RowBox[{
      FractionBox["2", "9"], " ", 
      RowBox[{"\[DoubleStruckCapitalC]", "[", 
       FractionBox[
        RowBox[{"12", " ", "\[ImaginaryI]", " ", 
         SubscriptBox[
          OverscriptBox[
           StyleBox["W",
            FontColor->RGBColor[0.54, 0.35, 0.15]], 
           StyleBox["^",
            FontColor->RGBColor[0.54, 0.35, 0.15]]], "sublead"]}], 
        RowBox[{"1", "+", 
         SuperscriptBox["u", "2"]}]], "]"}]}], "+", 
     RowBox[{
      FractionBox["16", "9"], " ", 
      RowBox[{"\[DoubleStruckCapitalC]", "[", 
       RowBox[{"-", 
        FractionBox[
         RowBox[{"\[ImaginaryI]", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"4", " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"-", "1"}], "+", 
               RowBox[{"3", " ", 
                SuperscriptBox["u", "2"]}], "+", 
               RowBox[{"27", " ", 
                SuperscriptBox["u", "4"]}]}], ")"}], " ", 
             SubscriptBox[
              OverscriptBox[
               StyleBox["W",
                FontColor->RGBColor[0.54, 0.35, 0.15]], 
               StyleBox["^",
                FontColor->RGBColor[0.54, 0.35, 0.15]]], "lead"]}], "+", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{"1", "+", 
               RowBox[{"6", " ", 
                SuperscriptBox["u", "2"]}], "+", 
               RowBox[{"18", " ", 
                SuperscriptBox["u", "4"]}], "+", 
               RowBox[{"27", " ", 
                SuperscriptBox["u", "6"]}]}], ")"}], " ", 
             SubscriptBox[
              OverscriptBox[
               StyleBox["W",
                FontColor->RGBColor[0.54, 0.35, 0.15]], 
               StyleBox["^",
                FontColor->RGBColor[0.54, 0.35, 0.15]]], "sublead"]}]}], 
           ")"}]}], 
         RowBox[{"27", " ", 
          SuperscriptBox[
           RowBox[{"(", 
            SuperscriptBox[
             StyleBox["Q0",
              FontColor->RGBColor[{
                 Rational[1, 2], 
                 Rational[1, 2], 0}]], "-"], ")"}], "2"], " ", 
          SuperscriptBox[
           RowBox[{"(", 
            SuperscriptBox[
             StyleBox["Q0",
              FontColor->RGBColor[{
                 Rational[1, 2], 
                 Rational[1, 2], 0}]], "+"], ")"}], "2"]}]]}], "]"}]}], "+", 
     RowBox[{
      FractionBox["4", "9"], " ", 
      RowBox[{"\[DoubleStruckCapitalC]", "[", 
       RowBox[{"-", 
        FractionBox[
         RowBox[{"4", " ", "\[ImaginaryI]", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{
             RowBox[{"(", 
              RowBox[{"11", "+", 
               RowBox[{"113", " ", 
                SuperscriptBox["u", "2"]}], "+", 
               RowBox[{"434", " ", 
                SuperscriptBox["u", "4"]}], "+", 
               RowBox[{"729", " ", 
                SuperscriptBox["u", "6"]}], "+", 
               RowBox[{"819", " ", 
                SuperscriptBox["u", "8"]}], "+", 
               RowBox[{"324", " ", 
                SuperscriptBox["u", "10"]}]}], ")"}], " ", 
             SubscriptBox[
              OverscriptBox[
               StyleBox["W",
                FontColor->RGBColor[0.54, 0.35, 0.15]], 
               StyleBox["^",
                FontColor->RGBColor[0.54, 0.35, 0.15]]], "lead"]}], "+", 
            RowBox[{"9", " ", 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{"1", "+", 
                SuperscriptBox["u", "2"]}], ")"}], "2"], " ", 
             SuperscriptBox[
              StyleBox["Q0",
               FontColor->RGBColor[{
                  Rational[1, 2], 
                  Rational[1, 2], 0}]], "-"], " ", 
             SuperscriptBox[
              StyleBox["Q0",
               FontColor->RGBColor[{
                  Rational[1, 2], 
                  Rational[1, 2], 0}]], "+"], " ", 
             SubscriptBox[
              OverscriptBox[
               StyleBox["W",
                FontColor->RGBColor[0.54, 0.35, 0.15]], 
               StyleBox["^",
                FontColor->RGBColor[0.54, 0.35, 0.15]]], "sublead"]}]}], 
           ")"}]}], 
         RowBox[{"27", " ", 
          SuperscriptBox[
           RowBox[{"(", 
            RowBox[{"1", "+", 
             SuperscriptBox["u", "2"]}], ")"}], "2"], " ", 
          SuperscriptBox[
           RowBox[{"(", 
            SuperscriptBox[
             StyleBox["Q0",
              FontColor->RGBColor[{
                 Rational[1, 2], 
                 Rational[1, 2], 0}]], "-"], ")"}], "2"], " ", 
          SuperscriptBox[
           RowBox[{"(", 
            SuperscriptBox[
             StyleBox["Q0",
              FontColor->RGBColor[{
                 Rational[1, 2], 
                 Rational[1, 2], 0}]], "+"], ")"}], "2"]}]]}], "]"}]}], "-", 
     RowBox[{
      FractionBox["32", "3"], " ", 
      SubscriptBox[
       StyleBox["W",
        FontColor->RGBColor[0.54, 0.35, 0.15]], 
       RowBox[{"1", ",", "v0", ",", "lead"}]]}], "-", 
     RowBox[{
      FractionBox["16", "9"], " ", 
      SubscriptBox[
       StyleBox["W",
        FontColor->RGBColor[0.54, 0.35, 0.15]], 
       RowBox[{"1", ",", "v0", ",", "sublead"}]]}], "-", 
     RowBox[{"7728", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2"]}], "+", 
     FractionBox[
      RowBox[{"23808", " ", 
       SubsuperscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "2", "2"]}], "5"], "-", 
     FractionBox[
      RowBox[{"7616", " ", 
       SubsuperscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "2", "3"]}], "5"], "+", 
     FractionBox[
      RowBox[{"640", " ", 
       SubsuperscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "2", "4"]}], "7"], "+", 
     RowBox[{"15312", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3"]}], "+", 
     RowBox[{"4832", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3"]}], "-", 
     RowBox[{
      FractionBox["8512", "5"], " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2", "2"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3"]}], "-", 
     RowBox[{
      FractionBox["4096", "35"], " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2", "3"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3"]}], "-", 
     RowBox[{"5440", " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3", "2"]}], "-", 
     RowBox[{"384", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2"], " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3", "2"]}], "-", 
     RowBox[{"7152", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "5"]}], "+", 
     RowBox[{"2720", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "5"]}], "+", 
     RowBox[{"192", " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2", "2"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "5"]}], "+", 
     RowBox[{"1024", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "5"]}]}]}], ",", 
   RowBox[{
    RowBox[{
     SubscriptBox["\[Beta]", "sublead"], "[", "1", "]"}], "\[Rule]", 
    RowBox[{
     RowBox[{
      FractionBox["1", "6"], " ", 
      RowBox[{"\[DoubleStruckCapitalC]", "[", 
       FractionBox[
        RowBox[{"16", " ", "\[ImaginaryI]", " ", 
         SubscriptBox[
          StyleBox["H",
           FontColor->RGBColor[0.54, 0.35, 0.15]], "lead"]}], 
        SuperscriptBox["u", "4"]], "]"}]}], "+", 
     RowBox[{
      FractionBox["2", "3"], " ", 
      RowBox[{"\[DoubleStruckCapitalC]", "[", 
       RowBox[{"-", 
        FractionBox[
         RowBox[{"8", " ", 
          SubscriptBox[
           StyleBox["H",
            FontColor->RGBColor[0.54, 0.35, 0.15]], "lead"]}], 
         SuperscriptBox["u", "3"]]}], "]"}]}], "+", 
     RowBox[{"4", " ", 
      RowBox[{"\[DoubleStruckCapitalC]", "[", 
       RowBox[{"-", 
        FractionBox[
         RowBox[{"2", " ", 
          SubscriptBox[
           StyleBox["H",
            FontColor->RGBColor[0.54, 0.35, 0.15]], "lead"]}], "u"]}], 
       "]"}]}], "+", 
     RowBox[{"4", " ", 
      RowBox[{"\[DoubleStruckCapitalC]", "[", 
       RowBox[{"-", 
        FractionBox[
         RowBox[{"4", " ", 
          RowBox[{"(", 
           RowBox[{"\[ImaginaryI]", "+", "u"}], ")"}], " ", 
          SubsuperscriptBox[
           StyleBox["W",
            FontColor->RGBColor[0.54, 0.35, 0.15]], 
           RowBox[{"1", ",", "lead"}], "+"]}], 
         SuperscriptBox[
          StyleBox["Q0",
           FontColor->RGBColor[{
              Rational[1, 2], 
              Rational[1, 2], 0}]], "+"]]}], "]"}]}], "+", 
     RowBox[{
      FractionBox["2", "3"], " ", 
      RowBox[{"\[DoubleStruckCapitalC]", "[", 
       RowBox[{"-", 
        FractionBox[
         RowBox[{"16", " ", 
          RowBox[{"(", 
           RowBox[{"\[ImaginaryI]", "+", "u"}], ")"}], " ", 
          SubsuperscriptBox[
           StyleBox["W",
            FontColor->RGBColor[0.54, 0.35, 0.15]], 
           RowBox[{"1", ",", "lead"}], "+"]}], 
         RowBox[{
          SuperscriptBox["u", "2"], " ", 
          SuperscriptBox[
           StyleBox["Q0",
            FontColor->RGBColor[{
               Rational[1, 2], 
               Rational[1, 2], 0}]], "+"]}]]}], "]"}]}], "-", 
     RowBox[{
      FractionBox["2", "3"], " ", 
      RowBox[{"\[DoubleStruckCapitalC]", "[", 
       FractionBox[
        RowBox[{"24", " ", "\[ImaginaryI]", " ", 
         RowBox[{"(", 
          RowBox[{"1", "+", 
           RowBox[{"5", " ", 
            SuperscriptBox["u", "2"]}], "+", 
           RowBox[{"2", " ", 
            SuperscriptBox["u", "4"]}]}], ")"}], " ", 
         SubscriptBox[
          OverscriptBox[
           StyleBox["W",
            FontColor->RGBColor[0.54, 0.35, 0.15]], 
           StyleBox["^",
            FontColor->RGBColor[0.54, 0.35, 0.15]]], "lead"]}], 
        SuperscriptBox[
         RowBox[{"(", 
          RowBox[{"u", "+", 
           SuperscriptBox["u", "3"]}], ")"}], "2"]], "]"}]}], "-", 
     RowBox[{
      FractionBox["1", "6"], " ", 
      RowBox[{"\[DoubleStruckCapitalC]", "[", 
       RowBox[{"-", 
        FractionBox[
         RowBox[{"48", " ", "\[ImaginaryI]", " ", 
          RowBox[{"(", 
           RowBox[{"2", "+", 
            RowBox[{"12", " ", 
             SuperscriptBox["u", "2"]}], "+", 
            RowBox[{"9", " ", 
             SuperscriptBox["u", "4"]}], "+", 
            RowBox[{"3", " ", 
             SuperscriptBox["u", "6"]}]}], ")"}], " ", 
          SubscriptBox[
           OverscriptBox[
            StyleBox["W",
             FontColor->RGBColor[0.54, 0.35, 0.15]], 
            StyleBox["^",
             FontColor->RGBColor[0.54, 0.35, 0.15]]], "lead"]}], 
         RowBox[{
          SuperscriptBox["u", "2"], " ", 
          SuperscriptBox[
           RowBox[{"(", 
            RowBox[{"1", "+", 
             SuperscriptBox["u", "2"]}], ")"}], "3"]}]]}], "]"}]}], "+", 
     RowBox[{"4", " ", 
      RowBox[{"\[DoubleStruckCapitalC]", "[", 
       RowBox[{"-", 
        FractionBox[
         RowBox[{"4", " ", "\[ImaginaryI]", " ", 
          SubscriptBox[
           OverscriptBox[
            StyleBox["W",
             FontColor->RGBColor[0.54, 0.35, 0.15]], 
            StyleBox["^",
             FontColor->RGBColor[0.54, 0.35, 0.15]]], "lead"]}], 
         RowBox[{"3", " ", 
          SuperscriptBox[
           StyleBox["Q0",
            FontColor->RGBColor[{
               Rational[1, 2], 
               Rational[1, 2], 0}]], "-"], " ", 
          SuperscriptBox[
           StyleBox["Q0",
            FontColor->RGBColor[{
               Rational[1, 2], 
               Rational[1, 2], 0}]], "+"]}]]}], "]"}]}], "+", 
     RowBox[{"48", " ", 
      RowBox[{"\[DoubleStruckCapitalC]", "[", 
       RowBox[{"-", 
        FractionBox[
         RowBox[{"\[ImaginaryI]", " ", 
          RowBox[{"(", 
           RowBox[{"1", "+", 
            RowBox[{"3", " ", 
             SuperscriptBox["u", "2"]}]}], ")"}], " ", 
          SubscriptBox[
           OverscriptBox[
            StyleBox["W",
             FontColor->RGBColor[0.54, 0.35, 0.15]], 
            StyleBox["^",
             FontColor->RGBColor[0.54, 0.35, 0.15]]], "lead"]}], 
         RowBox[{"3", " ", 
          SuperscriptBox[
           StyleBox["Q0",
            FontColor->RGBColor[{
               Rational[1, 2], 
               Rational[1, 2], 0}]], "-"], " ", 
          SuperscriptBox[
           StyleBox["Q0",
            FontColor->RGBColor[{
               Rational[1, 2], 
               Rational[1, 2], 0}]], "+"]}]]}], "]"}]}], "+", 
     RowBox[{
      FractionBox["2", "3"], " ", 
      RowBox[{"\[DoubleStruckCapitalC]", "[", 
       FractionBox[
        RowBox[{"16", " ", "\[ImaginaryI]", " ", 
         RowBox[{"(", 
          RowBox[{"6", "+", 
           RowBox[{"25", " ", 
            SuperscriptBox["u", "2"]}], "+", 
           RowBox[{"51", " ", 
            SuperscriptBox["u", "4"]}], "+", 
           RowBox[{"18", " ", 
            SuperscriptBox["u", "6"]}]}], ")"}], " ", 
         SubscriptBox[
          OverscriptBox[
           StyleBox["W",
            FontColor->RGBColor[0.54, 0.35, 0.15]], 
           StyleBox["^",
            FontColor->RGBColor[0.54, 0.35, 0.15]]], "lead"]}], 
        RowBox[{"3", " ", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"1", "+", 
            SuperscriptBox["u", "2"]}], ")"}], "2"], " ", 
         SuperscriptBox[
          StyleBox["Q0",
           FontColor->RGBColor[{
              Rational[1, 2], 
              Rational[1, 2], 0}]], "-"], " ", 
         SuperscriptBox[
          StyleBox["Q0",
           FontColor->RGBColor[{
              Rational[1, 2], 
              Rational[1, 2], 0}]], "+"]}]], "]"}]}], "-", 
     RowBox[{"48", " ", 
      SubscriptBox[
       StyleBox["W",
        FontColor->RGBColor[0.54, 0.35, 0.15]], 
       RowBox[{"1", ",", "v0", ",", "lead"}]]}], "+", 
     RowBox[{"432", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2"]}], "-", 
     FractionBox[
      RowBox[{"25632", " ", 
       SubsuperscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "2", "2"]}], "5"], "+", 
     FractionBox[
      RowBox[{"86976", " ", 
       SubsuperscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "2", "3"]}], "35"], "-", 
     FractionBox[
      RowBox[{"44544", " ", 
       SubsuperscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "2", "4"]}], "175"], "+", 
     RowBox[{"2160", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3"]}], "+", 
     RowBox[{"2016", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3"]}], "+", 
     RowBox[{
      FractionBox["2304", "5"], " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2", "2"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3"]}], "-", 
     RowBox[{
      FractionBox["1536", "7"], " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2", "3"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3"]}], "-", 
     RowBox[{"2016", " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3", "2"]}], "+", 
     RowBox[{"3744", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "5"]}], "-", 
     RowBox[{"2112", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "5"]}], "+", 
     RowBox[{
      FractionBox["1152", "5"], " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2", "2"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "5"]}], "-", 
     RowBox[{"768", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "5"]}]}]}], ",", 
   RowBox[{
    RowBox[{
     SubscriptBox["\[Alpha]", "sublead"], "[", "2", "]"}], "\[Rule]", 
    RowBox[{
     RowBox[{"-", "10368"}], "-", 
     RowBox[{
      FractionBox["2", "9"], " ", 
      RowBox[{"\[DoubleStruckCapitalC]", "[", 
       FractionBox[
        RowBox[{"16", " ", "\[ImaginaryI]", " ", 
         SubscriptBox[
          StyleBox["H",
           FontColor->RGBColor[0.54, 0.35, 0.15]], "lead"]}], 
        SuperscriptBox["u", "4"]], "]"}]}], "+", 
     RowBox[{
      FractionBox["4", "9"], " ", 
      RowBox[{"\[DoubleStruckCapitalC]", "[", 
       RowBox[{"-", 
        FractionBox[
         RowBox[{"8", " ", 
          SubscriptBox[
           StyleBox["H",
            FontColor->RGBColor[0.54, 0.35, 0.15]], "lead"]}], 
         SuperscriptBox["u", "3"]]}], "]"}]}], "+", 
     RowBox[{
      FractionBox["4", "9"], " ", 
      RowBox[{"\[DoubleStruckCapitalC]", "[", 
       RowBox[{"-", 
        FractionBox[
         RowBox[{"16", " ", 
          RowBox[{"(", 
           RowBox[{"\[ImaginaryI]", "+", "u"}], ")"}], " ", 
          SubsuperscriptBox[
           StyleBox["W",
            FontColor->RGBColor[0.54, 0.35, 0.15]], 
           RowBox[{"1", ",", "lead"}], "+"]}], 
         RowBox[{
          SuperscriptBox["u", "2"], " ", 
          SuperscriptBox[
           StyleBox["Q0",
            FontColor->RGBColor[{
               Rational[1, 2], 
               Rational[1, 2], 0}]], "+"]}]]}], "]"}]}], "-", 
     RowBox[{
      FractionBox["4", "9"], " ", 
      RowBox[{"\[DoubleStruckCapitalC]", "[", 
       FractionBox[
        RowBox[{"24", " ", "\[ImaginaryI]", " ", 
         RowBox[{"(", 
          RowBox[{"1", "+", 
           RowBox[{"5", " ", 
            SuperscriptBox["u", "2"]}], "+", 
           RowBox[{"2", " ", 
            SuperscriptBox["u", "4"]}]}], ")"}], " ", 
         SubscriptBox[
          OverscriptBox[
           StyleBox["W",
            FontColor->RGBColor[0.54, 0.35, 0.15]], 
           StyleBox["^",
            FontColor->RGBColor[0.54, 0.35, 0.15]]], "lead"]}], 
        SuperscriptBox[
         RowBox[{"(", 
          RowBox[{"u", "+", 
           SuperscriptBox["u", "3"]}], ")"}], "2"]], "]"}]}], "+", 
     RowBox[{
      FractionBox["2", "9"], " ", 
      RowBox[{"\[DoubleStruckCapitalC]", "[", 
       RowBox[{"-", 
        FractionBox[
         RowBox[{"48", " ", "\[ImaginaryI]", " ", 
          RowBox[{"(", 
           RowBox[{"2", "+", 
            RowBox[{"12", " ", 
             SuperscriptBox["u", "2"]}], "+", 
            RowBox[{"9", " ", 
             SuperscriptBox["u", "4"]}], "+", 
            RowBox[{"3", " ", 
             SuperscriptBox["u", "6"]}]}], ")"}], " ", 
          SubscriptBox[
           OverscriptBox[
            StyleBox["W",
             FontColor->RGBColor[0.54, 0.35, 0.15]], 
            StyleBox["^",
             FontColor->RGBColor[0.54, 0.35, 0.15]]], "lead"]}], 
         RowBox[{
          SuperscriptBox["u", "2"], " ", 
          SuperscriptBox[
           RowBox[{"(", 
            RowBox[{"1", "+", 
             SuperscriptBox["u", "2"]}], ")"}], "3"]}]]}], "]"}]}], "-", 
     RowBox[{
      FractionBox["32", "3"], " ", 
      RowBox[{"\[DoubleStruckCapitalC]", "[", 
       RowBox[{"-", 
        FractionBox[
         RowBox[{"\[ImaginaryI]", " ", 
          RowBox[{"(", 
           RowBox[{"1", "+", 
            RowBox[{"3", " ", 
             SuperscriptBox["u", "2"]}]}], ")"}], " ", 
          SubscriptBox[
           OverscriptBox[
            StyleBox["W",
             FontColor->RGBColor[0.54, 0.35, 0.15]], 
            StyleBox["^",
             FontColor->RGBColor[0.54, 0.35, 0.15]]], "lead"]}], 
         RowBox[{"3", " ", 
          SuperscriptBox[
           StyleBox["Q0",
            FontColor->RGBColor[{
               Rational[1, 2], 
               Rational[1, 2], 0}]], "-"], " ", 
          SuperscriptBox[
           StyleBox["Q0",
            FontColor->RGBColor[{
               Rational[1, 2], 
               Rational[1, 2], 0}]], "+"]}]]}], "]"}]}], "+", 
     RowBox[{
      FractionBox["4", "9"], " ", 
      RowBox[{"\[DoubleStruckCapitalC]", "[", 
       FractionBox[
        RowBox[{"16", " ", "\[ImaginaryI]", " ", 
         RowBox[{"(", 
          RowBox[{"6", "+", 
           RowBox[{"25", " ", 
            SuperscriptBox["u", "2"]}], "+", 
           RowBox[{"51", " ", 
            SuperscriptBox["u", "4"]}], "+", 
           RowBox[{"18", " ", 
            SuperscriptBox["u", "6"]}]}], ")"}], " ", 
         SubscriptBox[
          OverscriptBox[
           StyleBox["W",
            FontColor->RGBColor[0.54, 0.35, 0.15]], 
           StyleBox["^",
            FontColor->RGBColor[0.54, 0.35, 0.15]]], "lead"]}], 
        RowBox[{"3", " ", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"1", "+", 
            SuperscriptBox["u", "2"]}], ")"}], "2"], " ", 
         SuperscriptBox[
          StyleBox["Q0",
           FontColor->RGBColor[{
              Rational[1, 2], 
              Rational[1, 2], 0}]], "-"], " ", 
         SuperscriptBox[
          StyleBox["Q0",
           FontColor->RGBColor[{
              Rational[1, 2], 
              Rational[1, 2], 0}]], "+"]}]], "]"}]}], "+", 
     RowBox[{
      FractionBox["32", "3"], " ", 
      SubscriptBox[
       StyleBox["W",
        FontColor->RGBColor[0.54, 0.35, 0.15]], 
       RowBox[{"1", ",", "v0", ",", "lead"}]]}], "+", 
     RowBox[{"12096", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2"]}], "-", 
     FractionBox[
      RowBox[{"18816", " ", 
       SubsuperscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "2", "2"]}], "5"], "+", 
     FractionBox[
      RowBox[{"4608", " ", 
       SubsuperscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "2", "3"]}], "5"], "-", 
     FractionBox[
      RowBox[{"29696", " ", 
       SubsuperscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "2", "4"]}], "175"], "-", 
     RowBox[{"8640", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3"]}], "+", 
     RowBox[{"384", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3"]}], "+", 
     RowBox[{
      FractionBox["10752", "5"], " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2", "2"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3"]}], "+", 
     RowBox[{
      FractionBox["2048", "7"], " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2", "3"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3"]}], "-", 
     RowBox[{"1536", " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3", "2"]}], "+", 
     RowBox[{"18048", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "5"]}], "-", 
     RowBox[{"9472", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "5"]}], "-", 
     RowBox[{
      FractionBox["1536", "5"], " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2", "2"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "5"]}], "-", 
     RowBox[{"512", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "5"]}]}]}], ",", 
   RowBox[{
    RowBox[{
     SubscriptBox["\[Beta]", "sublead"], "[", "2", "]"}], "\[Rule]", "0"}], 
   ",", 
   RowBox[{
    RowBox[{
     SubscriptBox["\[Alpha]", "sublead"], "[", "3", "]"}], "\[Rule]", "0"}], 
   ",", 
   RowBox[{
    RowBox[{
     SubscriptBox["\[Beta]", "sublead"], "[", "3", "]"}], "\[Rule]", "0"}], 
   ",", 
   RowBox[{
    RowBox[{
     SubscriptBox["\[Alpha]", "sublead"], "[", "4", "]"}], "\[Rule]", "0"}], 
   ",", 
   RowBox[{
    RowBox[{
     SubscriptBox["\[Beta]", "sublead"], "[", "4", "]"}], "\[Rule]", "0"}], 
   ",", 
   RowBox[{
    RowBox[{
     SubscriptBox["\[Alpha]", "sublead"], "[", "5", "]"}], "\[Rule]", "0"}], 
   ",", 
   RowBox[{
    RowBox[{
     SubscriptBox["\[Beta]", "sublead"], "[", "5", "]"}], "\[Rule]", "0"}]}], 
  "}"}]], "Output",
 CellChangeTimes->{
  3.5558670943389473`*^9, {3.555867159117064*^9, 3.5558671806020403`*^9}, {
   3.555867224193522*^9, 3.555867326610877*^9}, {3.555867381236259*^9, 
   3.5558674404405193`*^9}, 3.5558677099093733`*^9, {3.55586775121577*^9, 
   3.555867774601324*^9}, 3.555867918100762*^9, 3.55586809019375*^9, 
   3.555868492479928*^9, 3.555868760550604*^9}]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell["Third order", "Subsubsection",
 CellChangeTimes->{{3.555866616963666*^9, 3.5558666197227697`*^9}, {
  3.555869227213325*^9, 3.555869230258786*^9}, {3.555869281787188*^9, 
  3.555869283176793*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"thirdset", "=", 
   RowBox[{
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"eqnT11ZeroAtBetheroot", "[", 
        RowBox[{"[", "3", "]"}], "]"}], ",", 
       RowBox[{"eqFromY11Y22", "[", 
        RowBox[{"[", "3", "]"}], "]"}], ",", 
       RowBox[{"eqFromY11oY22", "[", 
        RowBox[{"[", "3", "]"}], "]"}]}], "}"}], "/.", 
     RowBox[{
      SubscriptBox["W", "a_"], "\[RuleDelayed]", 
      SubscriptBox[
       OverscriptBox["W", "^"], "a"]}]}], "/.", 
    RowBox[{"g", "\[Rule]", "1"}]}]}], ";"}]], "Input",
 CellChangeTimes->{{3.555866604526623*^9, 3.555866676631379*^9}, {
   3.555867795264862*^9, 3.555867840222376*^9}, {3.5558678748195047`*^9, 
   3.5558678759470453`*^9}, 3.555868486603088*^9, {3.555868557990645*^9, 
   3.555868565140028*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"thirdeqns", "=", 
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{"thirdset", "//.", "subAnsatz"}], "/.", "solut1"}], "/.", 
      "solut2"}], "//", "Simplify"}]}], ";"}], 
  "\[IndentingNewLine]"}]], "Input",
 CellChangeTimes->{{3.555866679652109*^9, 3.55586680066827*^9}, {
   3.555866842702819*^9, 3.5558670893216047`*^9}, {3.555867700853509*^9, 
   3.555867706202673*^9}, 3.5558677464093857`*^9, {3.55586784340543*^9, 
   3.5558678626276197`*^9}, {3.555868051348563*^9, 3.5558680527005653`*^9}, {
   3.555868567513433*^9, 3.5558685764882317`*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"solut3", "=", 
  RowBox[{
   RowBox[{
    RowBox[{"Solve", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"DeleteCases", "[", 
        RowBox[{
         RowBox[{
          RowBox[{
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{
               RowBox[{"List", "@@", 
                RowBox[{"Collect", "[", 
                 RowBox[{
                  RowBox[{
                   RowBox[{
                    RowBox[{"AAA", " ", "#"}], "+", "BBB"}], "//", "Expand"}],
                   ",", 
                  RowBox[{"{", 
                   RowBox[{
                    RowBox[{
                    SuperscriptBox["z", "_."], 
                    SqrtBox[
                    RowBox[{"1", "-", 
                    SuperscriptBox["z", "2"]}]]}], ",", 
                    SqrtBox[
                    RowBox[{"1", "-", 
                    SuperscriptBox["z", "2"]}]], ",", "z", ",", "AAA"}], 
                   "}"}]}], "]"}]}], "/.", 
               RowBox[{"AAA", "\[Rule]", "1"}]}], "/.", 
              RowBox[{"BBB", "\[Rule]", "0"}]}], ")"}], "&"}], "/@", 
           "thirdeqns"}], "//", "Flatten"}], ",", "0"}], "]"}], "\[Equal]", 
       "0"}], ",", 
      RowBox[{
       RowBox[{"Table", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
           RowBox[{
            SubscriptBox["\[Alpha]", "sublead2"], "[", "i", "]"}], ",", 
           RowBox[{
            SubscriptBox["\[Beta]", "sublead2"], "[", "i", "]"}]}], "}"}], 
         ",", 
         RowBox[{"{", 
          RowBox[{"i", ",", "0", ",", "\[CapitalLambda]\[Rho]s"}], "}"}]}], 
        "]"}], "//", "Flatten"}]}], "]"}], "[", 
    RowBox[{"[", "1", "]"}], "]"}], "//", "Simplify"}]}]], "Input",
 CellChangeTimes->{{3.5558670909006863`*^9, 3.5558671799232283`*^9}, {
   3.555867222449935*^9, 3.555867411149969*^9}, {3.5558679005094976`*^9, 
   3.555867916081595*^9}, {3.555868608432683*^9, 3.555868619471197*^9}, 
   3.555868770947527*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{
    RowBox[{
     SubscriptBox["\[Alpha]", "sublead2"], "[", "0", "]"}], "\[Rule]", 
    RowBox[{
     RowBox[{"-", "32166"}], "+", 
     RowBox[{
      FractionBox["1", "36"], " ", 
      RowBox[{"\[DoubleStruckCapitalC]", "[", 
       FractionBox[
        RowBox[{"16", " ", "\[ImaginaryI]", " ", 
         SubscriptBox[
          StyleBox["H",
           FontColor->RGBColor[0.54, 0.35, 0.15]], "lead"]}], 
        SuperscriptBox["u", "4"]], "]"}]}], "-", 
     RowBox[{
      FractionBox["1", "36"], " ", 
      RowBox[{"\[DoubleStruckCapitalC]", "[", 
       RowBox[{"-", 
        FractionBox[
         RowBox[{"8", " ", 
          SubscriptBox[
           StyleBox["H",
            FontColor->RGBColor[0.54, 0.35, 0.15]], "lead"]}], 
         SuperscriptBox["u", "3"]]}], "]"}]}], "+", 
     RowBox[{
      FractionBox["1", "9"], " ", 
      RowBox[{"\[DoubleStruckCapitalC]", "[", 
       FractionBox[
        RowBox[{"4", " ", "\[ImaginaryI]", " ", 
         SubscriptBox[
          StyleBox["H",
           FontColor->RGBColor[0.54, 0.35, 0.15]], "lead"]}], 
        SuperscriptBox["u", "2"]], "]"}]}], "-", 
     RowBox[{
      FractionBox["23", "9"], " ", 
      RowBox[{"\[DoubleStruckCapitalC]", "[", 
       RowBox[{"-", 
        FractionBox[
         RowBox[{"2", " ", 
          SubscriptBox[
           StyleBox["H",
            FontColor->RGBColor[0.54, 0.35, 0.15]], "lead"]}], "u"]}], 
       "]"}]}], "+", 
     RowBox[{
      FractionBox["1", "3"], " ", 
      RowBox[{"\[DoubleStruckCapitalC]", "[", 
       FractionBox[
        RowBox[{"4", " ", "\[ImaginaryI]", " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"2", " ", 
            SubscriptBox[
             StyleBox["H",
              FontColor->RGBColor[0.54, 0.35, 0.15]], "lead"]}], "+", 
           RowBox[{
            SuperscriptBox["u", "2"], " ", 
            SubscriptBox[
             StyleBox["H",
              FontColor->RGBColor[0.54, 0.35, 0.15]], "sublead"]}]}], ")"}]}], 
        SuperscriptBox["u", "4"]], "]"}]}], "-", 
     RowBox[{
      FractionBox["1", "9"], " ", 
      RowBox[{"\[DoubleStruckCapitalC]", "[", 
       RowBox[{"-", 
        FractionBox[
         RowBox[{"2", " ", 
          SubscriptBox[
           StyleBox["H",
            FontColor->RGBColor[0.54, 0.35, 0.15]], "sublead2"]}], "u"]}], 
       "]"}]}], "+", 
     RowBox[{
      FractionBox["1", "18"], " ", 
      RowBox[{"\[DoubleStruckCapitalC]", "[", 
       FractionBox[
        RowBox[{"4", " ", "\[ImaginaryI]", " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"6", " ", 
            SubscriptBox[
             StyleBox["H",
              FontColor->RGBColor[0.54, 0.35, 0.15]], "lead"]}], "+", 
           RowBox[{"2", " ", 
            SuperscriptBox["u", "2"], " ", 
            SubscriptBox[
             StyleBox["H",
              FontColor->RGBColor[0.54, 0.35, 0.15]], "sublead"]}], "+", 
           RowBox[{
            SuperscriptBox["u", "4"], " ", 
            SubscriptBox[
             StyleBox["H",
              FontColor->RGBColor[0.54, 0.35, 0.15]], "sublead2"]}]}], 
          ")"}]}], 
        SuperscriptBox["u", "6"]], "]"}]}], "-", 
     RowBox[{
      FractionBox["23", "9"], " ", 
      RowBox[{"\[DoubleStruckCapitalC]", "[", 
       RowBox[{"-", 
        FractionBox[
         RowBox[{"4", " ", 
          RowBox[{"(", 
           RowBox[{"\[ImaginaryI]", "+", "u"}], ")"}], " ", 
          SubsuperscriptBox[
           StyleBox["W",
            FontColor->RGBColor[0.54, 0.35, 0.15]], 
           RowBox[{"1", ",", "lead"}], "+"]}], 
         SuperscriptBox[
          StyleBox["Q0",
           FontColor->RGBColor[{
              Rational[1, 2], 
              Rational[1, 2], 0}]], "+"]]}], "]"}]}], "-", 
     RowBox[{
      FractionBox["1", "36"], " ", 
      RowBox[{"\[DoubleStruckCapitalC]", "[", 
       RowBox[{"-", 
        FractionBox[
         RowBox[{"16", " ", 
          RowBox[{"(", 
           RowBox[{"\[ImaginaryI]", "+", "u"}], ")"}], " ", 
          SubsuperscriptBox[
           StyleBox["W",
            FontColor->RGBColor[0.54, 0.35, 0.15]], 
           RowBox[{"1", ",", "lead"}], "+"]}], 
         RowBox[{
          SuperscriptBox["u", "2"], " ", 
          SuperscriptBox[
           StyleBox["Q0",
            FontColor->RGBColor[{
               Rational[1, 2], 
               Rational[1, 2], 0}]], "+"]}]]}], "]"}]}], "-", 
     RowBox[{
      FractionBox["1", "9"], " ", 
      RowBox[{"\[DoubleStruckCapitalC]", "[", 
       RowBox[{
        FractionBox["1", 
         RowBox[{"9", " ", 
          SuperscriptBox["u", "4"], " ", 
          SuperscriptBox[
           RowBox[{"(", 
            RowBox[{"\[ImaginaryI]", "+", "u"}], ")"}], "3"], " ", 
          SuperscriptBox[
           RowBox[{"(", 
            SuperscriptBox[
             StyleBox["Q0",
              FontColor->RGBColor[{
                 Rational[1, 2], 
                 Rational[1, 2], 0}]], "+"], ")"}], "3"]}]], 
        RowBox[{"4", " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{
            RowBox[{"(", 
             RowBox[{"1", "-", 
              RowBox[{"10", " ", "\[ImaginaryI]", " ", "u"}], "-", 
              RowBox[{"45", " ", 
               SuperscriptBox["u", "2"]}], "+", 
              RowBox[{"100", " ", "\[ImaginaryI]", " ", 
               SuperscriptBox["u", "3"]}], "+", 
              RowBox[{"61", " ", 
               SuperscriptBox["u", "4"]}], "+", 
              RowBox[{"202", " ", "\[ImaginaryI]", " ", 
               SuperscriptBox["u", "5"]}], "+", 
              RowBox[{"534", " ", 
               SuperscriptBox["u", "6"]}], "-", 
              RowBox[{"616", " ", "\[ImaginaryI]", " ", 
               SuperscriptBox["u", "7"]}], "-", 
              RowBox[{"424", " ", 
               SuperscriptBox["u", "8"]}], "+", 
              RowBox[{"180", " ", "\[ImaginaryI]", " ", 
               SuperscriptBox["u", "9"]}], "+", 
              RowBox[{"36", " ", 
               SuperscriptBox["u", "10"]}]}], ")"}], " ", 
            SubsuperscriptBox[
             StyleBox["W",
              FontColor->RGBColor[0.54, 0.35, 0.15]], 
             RowBox[{"1", ",", "lead"}], "+"]}], "-", 
           RowBox[{"3", " ", 
            SuperscriptBox["u", "2"], " ", 
            SuperscriptBox[
             RowBox[{"(", 
              RowBox[{"\[ImaginaryI]", "+", "u"}], ")"}], "2"], " ", 
            SuperscriptBox[
             StyleBox["Q0",
              FontColor->RGBColor[{
                 Rational[1, 2], 
                 Rational[1, 2], 0}]], "+"], " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{"\[ImaginaryI]", "+", 
                  RowBox[{"2", " ", "u"}]}], ")"}], "2"], " ", 
               RowBox[{"(", 
                RowBox[{"1", "+", 
                 RowBox[{"\[ImaginaryI]", " ", "u"}], "+", 
                 SuperscriptBox["u", "2"]}], ")"}], " ", 
               SubsuperscriptBox[
                StyleBox["W",
                 FontColor->RGBColor[0.54, 0.35, 0.15]], 
                RowBox[{"1", ",", "sublead"}], "+"]}], "+", 
              RowBox[{"3", " ", 
               SuperscriptBox["u", "2"], " ", 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{"\[ImaginaryI]", "+", "u"}], ")"}], "2"], " ", 
               SuperscriptBox[
                StyleBox["Q0",
                 FontColor->RGBColor[{
                    Rational[1, 2], 
                    Rational[1, 2], 0}]], "+"], " ", 
               SubsuperscriptBox[
                StyleBox["W",
                 FontColor->RGBColor[0.54, 0.35, 0.15]], 
                RowBox[{"1", ",", "sublead2"}], "+"]}]}], ")"}]}]}], 
          ")"}]}]}], "]"}]}], "-", 
     RowBox[{
      FractionBox["1", "9"], " ", 
      RowBox[{"\[DoubleStruckCapitalC]", "[", 
       FractionBox[
        RowBox[{"12", " ", "\[ImaginaryI]", " ", 
         SubscriptBox[
          OverscriptBox[
           StyleBox["W",
            FontColor->RGBColor[0.54, 0.35, 0.15]], 
           StyleBox["^",
            FontColor->RGBColor[0.54, 0.35, 0.15]]], "lead"]}], 
        RowBox[{"1", "+", 
         SuperscriptBox["u", "2"]}]], "]"}]}], "+", 
     RowBox[{
      FractionBox["1", "9"], " ", 
      RowBox[{"\[DoubleStruckCapitalC]", "[", 
       FractionBox[
        RowBox[{"132", " ", "\[ImaginaryI]", " ", 
         SubscriptBox[
          OverscriptBox[
           StyleBox["W",
            FontColor->RGBColor[0.54, 0.35, 0.15]], 
           StyleBox["^",
            FontColor->RGBColor[0.54, 0.35, 0.15]]], "lead"]}], 
        RowBox[{"1", "+", 
         SuperscriptBox["u", "2"]}]], "]"}]}], "-", 
     RowBox[{
      FractionBox["1", "18"], " ", 
      RowBox[{"\[DoubleStruckCapitalC]", "[", 
       RowBox[{"-", 
        FractionBox[
         RowBox[{"192", " ", "\[ImaginaryI]", " ", 
          SubscriptBox[
           OverscriptBox[
            StyleBox["W",
             FontColor->RGBColor[0.54, 0.35, 0.15]], 
            StyleBox["^",
             FontColor->RGBColor[0.54, 0.35, 0.15]]], "lead"]}], 
         RowBox[{"1", "+", 
          SuperscriptBox["u", "2"]}]]}], "]"}]}], "+", 
     RowBox[{
      FractionBox["1", "36"], " ", 
      RowBox[{"\[DoubleStruckCapitalC]", "[", 
       FractionBox[
        RowBox[{"24", " ", "\[ImaginaryI]", " ", 
         RowBox[{"(", 
          RowBox[{"1", "+", 
           RowBox[{"5", " ", 
            SuperscriptBox["u", "2"]}], "+", 
           RowBox[{"2", " ", 
            SuperscriptBox["u", "4"]}]}], ")"}], " ", 
         SubscriptBox[
          OverscriptBox[
           StyleBox["W",
            FontColor->RGBColor[0.54, 0.35, 0.15]], 
           StyleBox["^",
            FontColor->RGBColor[0.54, 0.35, 0.15]]], "lead"]}], 
        SuperscriptBox[
         RowBox[{"(", 
          RowBox[{"u", "+", 
           SuperscriptBox["u", "3"]}], ")"}], "2"]], "]"}]}], "-", 
     RowBox[{
      FractionBox["1", "36"], " ", 
      RowBox[{"\[DoubleStruckCapitalC]", "[", 
       RowBox[{"-", 
        FractionBox[
         RowBox[{"48", " ", "\[ImaginaryI]", " ", 
          RowBox[{"(", 
           RowBox[{"2", "+", 
            RowBox[{"12", " ", 
             SuperscriptBox["u", "2"]}], "+", 
            RowBox[{"9", " ", 
             SuperscriptBox["u", "4"]}], "+", 
            RowBox[{"3", " ", 
             SuperscriptBox["u", "6"]}]}], ")"}], " ", 
          SubscriptBox[
           OverscriptBox[
            StyleBox["W",
             FontColor->RGBColor[0.54, 0.35, 0.15]], 
            StyleBox["^",
             FontColor->RGBColor[0.54, 0.35, 0.15]]], "lead"]}], 
         RowBox[{
          SuperscriptBox["u", "2"], " ", 
          SuperscriptBox[
           RowBox[{"(", 
            RowBox[{"1", "+", 
             SuperscriptBox["u", "2"]}], ")"}], "3"]}]]}], "]"}]}], "-", 
     RowBox[{
      FractionBox["23", "9"], " ", 
      RowBox[{"\[DoubleStruckCapitalC]", "[", 
       RowBox[{"-", 
        FractionBox[
         RowBox[{"4", " ", "\[ImaginaryI]", " ", 
          SubscriptBox[
           OverscriptBox[
            StyleBox["W",
             FontColor->RGBColor[0.54, 0.35, 0.15]], 
            StyleBox["^",
             FontColor->RGBColor[0.54, 0.35, 0.15]]], "lead"]}], 
         RowBox[{"3", " ", 
          SuperscriptBox[
           StyleBox["Q0",
            FontColor->RGBColor[{
               Rational[1, 2], 
               Rational[1, 2], 0}]], "-"], " ", 
          SuperscriptBox[
           StyleBox["Q0",
            FontColor->RGBColor[{
               Rational[1, 2], 
               Rational[1, 2], 0}]], "+"]}]]}], "]"}]}], "-", 
     RowBox[{
      FractionBox["38", "9"], " ", 
      RowBox[{"\[DoubleStruckCapitalC]", "[", 
       RowBox[{"-", 
        FractionBox[
         RowBox[{"\[ImaginaryI]", " ", 
          RowBox[{"(", 
           RowBox[{"1", "+", 
            RowBox[{"3", " ", 
             SuperscriptBox["u", "2"]}]}], ")"}], " ", 
          SubscriptBox[
           OverscriptBox[
            StyleBox["W",
             FontColor->RGBColor[0.54, 0.35, 0.15]], 
            StyleBox["^",
             FontColor->RGBColor[0.54, 0.35, 0.15]]], "lead"]}], 
         RowBox[{"3", " ", 
          SuperscriptBox[
           StyleBox["Q0",
            FontColor->RGBColor[{
               Rational[1, 2], 
               Rational[1, 2], 0}]], "-"], " ", 
          SuperscriptBox[
           StyleBox["Q0",
            FontColor->RGBColor[{
               Rational[1, 2], 
               Rational[1, 2], 0}]], "+"]}]]}], "]"}]}], "-", 
     RowBox[{
      FractionBox["1", "36"], " ", 
      RowBox[{"\[DoubleStruckCapitalC]", "[", 
       FractionBox[
        RowBox[{"16", " ", "\[ImaginaryI]", " ", 
         RowBox[{"(", 
          RowBox[{"6", "+", 
           RowBox[{"25", " ", 
            SuperscriptBox["u", "2"]}], "+", 
           RowBox[{"51", " ", 
            SuperscriptBox["u", "4"]}], "+", 
           RowBox[{"18", " ", 
            SuperscriptBox["u", "6"]}]}], ")"}], " ", 
         SubscriptBox[
          OverscriptBox[
           StyleBox["W",
            FontColor->RGBColor[0.54, 0.35, 0.15]], 
           StyleBox["^",
            FontColor->RGBColor[0.54, 0.35, 0.15]]], "lead"]}], 
        RowBox[{"3", " ", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"1", "+", 
            SuperscriptBox["u", "2"]}], ")"}], "2"], " ", 
         SuperscriptBox[
          StyleBox["Q0",
           FontColor->RGBColor[{
              Rational[1, 2], 
              Rational[1, 2], 0}]], "-"], " ", 
         SuperscriptBox[
          StyleBox["Q0",
           FontColor->RGBColor[{
              Rational[1, 2], 
              Rational[1, 2], 0}]], "+"]}]], "]"}]}], "-", 
     RowBox[{
      FractionBox["1", "3"], " ", 
      RowBox[{"\[DoubleStruckCapitalC]", "[", 
       FractionBox[
        RowBox[{"12", " ", "\[ImaginaryI]", " ", 
         SubscriptBox[
          OverscriptBox[
           StyleBox["W",
            FontColor->RGBColor[0.54, 0.35, 0.15]], 
           StyleBox["^",
            FontColor->RGBColor[0.54, 0.35, 0.15]]], "sublead"]}], 
        RowBox[{"1", "+", 
         SuperscriptBox["u", "2"]}]], "]"}]}], "+", 
     RowBox[{
      FractionBox["1", "9"], " ", 
      RowBox[{"\[DoubleStruckCapitalC]", "[", 
       RowBox[{"-", 
        FractionBox[
         RowBox[{"24", " ", "\[ImaginaryI]", " ", 
          SubscriptBox[
           OverscriptBox[
            StyleBox["W",
             FontColor->RGBColor[0.54, 0.35, 0.15]], 
            StyleBox["^",
             FontColor->RGBColor[0.54, 0.35, 0.15]]], "sublead"]}], 
         RowBox[{"1", "+", 
          SuperscriptBox["u", "2"]}]]}], "]"}]}], "+", 
     RowBox[{
      FractionBox["4", "3"], " ", 
      RowBox[{"\[DoubleStruckCapitalC]", "[", 
       RowBox[{"-", 
        FractionBox[
         RowBox[{"\[ImaginaryI]", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"4", " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"-", "1"}], "+", 
               RowBox[{"3", " ", 
                SuperscriptBox["u", "2"]}], "+", 
               RowBox[{"27", " ", 
                SuperscriptBox["u", "4"]}]}], ")"}], " ", 
             SubscriptBox[
              OverscriptBox[
               StyleBox["W",
                FontColor->RGBColor[0.54, 0.35, 0.15]], 
               StyleBox["^",
                FontColor->RGBColor[0.54, 0.35, 0.15]]], "lead"]}], "+", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{"1", "+", 
               RowBox[{"6", " ", 
                SuperscriptBox["u", "2"]}], "+", 
               RowBox[{"18", " ", 
                SuperscriptBox["u", "4"]}], "+", 
               RowBox[{"27", " ", 
                SuperscriptBox["u", "6"]}]}], ")"}], " ", 
             SubscriptBox[
              OverscriptBox[
               StyleBox["W",
                FontColor->RGBColor[0.54, 0.35, 0.15]], 
               StyleBox["^",
                FontColor->RGBColor[0.54, 0.35, 0.15]]], "sublead"]}]}], 
           ")"}]}], 
         RowBox[{"27", " ", 
          SuperscriptBox[
           RowBox[{"(", 
            SuperscriptBox[
             StyleBox["Q0",
              FontColor->RGBColor[{
                 Rational[1, 2], 
                 Rational[1, 2], 0}]], "-"], ")"}], "2"], " ", 
          SuperscriptBox[
           RowBox[{"(", 
            SuperscriptBox[
             StyleBox["Q0",
              FontColor->RGBColor[{
                 Rational[1, 2], 
                 Rational[1, 2], 0}]], "+"], ")"}], "2"]}]]}], "]"}]}], "-", 
     RowBox[{
      FractionBox["1", "18"], " ", 
      RowBox[{"\[DoubleStruckCapitalC]", "[", 
       FractionBox[
        RowBox[{"12", " ", "\[ImaginaryI]", " ", 
         SubscriptBox[
          OverscriptBox[
           StyleBox["W",
            FontColor->RGBColor[0.54, 0.35, 0.15]], 
           StyleBox["^",
            FontColor->RGBColor[0.54, 0.35, 0.15]]], "sublead2"]}], 
        RowBox[{"1", "+", 
         SuperscriptBox["u", "2"]}]], "]"}]}], "+", 
     RowBox[{
      FractionBox["2", "9"], " ", 
      RowBox[{"\[DoubleStruckCapitalC]", "[", 
       RowBox[{"-", 
        RowBox[{
         FractionBox["1", 
          RowBox[{"243", " ", 
           SuperscriptBox[
            RowBox[{"(", 
             SuperscriptBox[
              StyleBox["Q0",
               FontColor->RGBColor[{
                  Rational[1, 2], 
                  Rational[1, 2], 0}]], "-"], ")"}], "3"], " ", 
           SuperscriptBox[
            RowBox[{"(", 
             SuperscriptBox[
              StyleBox["Q0",
               FontColor->RGBColor[{
                  Rational[1, 2], 
                  Rational[1, 2], 0}]], "+"], ")"}], "3"]}]], 
         RowBox[{"\[ImaginaryI]", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"2", " ", 
             RowBox[{"(", 
              RowBox[{"5", "-", 
               RowBox[{"144", " ", 
                SuperscriptBox["u", "2"]}], "-", 
               RowBox[{"351", " ", 
                SuperscriptBox["u", "4"]}], "+", 
               RowBox[{"1404", " ", 
                SuperscriptBox["u", "6"]}], "+", 
               RowBox[{"729", " ", 
                SuperscriptBox["u", "8"]}]}], ")"}], " ", 
             SubscriptBox[
              OverscriptBox[
               StyleBox["W",
                FontColor->RGBColor[0.54, 0.35, 0.15]], 
               StyleBox["^",
                FontColor->RGBColor[0.54, 0.35, 0.15]]], "lead"]}], "+", 
            RowBox[{"9", " ", 
             SuperscriptBox[
              StyleBox["Q0",
               FontColor->RGBColor[{
                  Rational[1, 2], 
                  Rational[1, 2], 0}]], "-"], " ", 
             SuperscriptBox[
              StyleBox["Q0",
               FontColor->RGBColor[{
                  Rational[1, 2], 
                  Rational[1, 2], 0}]], "+"], " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"4", " ", 
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{"-", "1"}], "+", 
                  RowBox[{"3", " ", 
                   SuperscriptBox["u", "2"]}], "+", 
                  RowBox[{"27", " ", 
                   SuperscriptBox["u", "4"]}]}], ")"}], " ", 
                SubscriptBox[
                 OverscriptBox[
                  StyleBox["W",
                   FontColor->RGBColor[0.54, 0.35, 0.15]], 
                  StyleBox["^",
                   FontColor->RGBColor[0.54, 0.35, 0.15]]], "sublead"]}], "+", 
               RowBox[{
                RowBox[{"(", 
                 RowBox[{"1", "+", 
                  RowBox[{"6", " ", 
                   SuperscriptBox["u", "2"]}], "+", 
                  RowBox[{"18", " ", 
                   SuperscriptBox["u", "4"]}], "+", 
                  RowBox[{"27", " ", 
                   SuperscriptBox["u", "6"]}]}], ")"}], " ", 
                SubscriptBox[
                 OverscriptBox[
                  StyleBox["W",
                   FontColor->RGBColor[0.54, 0.35, 0.15]], 
                  StyleBox["^",
                   FontColor->RGBColor[0.54, 0.35, 0.15]]], "sublead2"]}]}], 
              ")"}]}]}], ")"}]}]}]}], "]"}]}], "-", 
     RowBox[{
      FractionBox["1", "9"], " ", 
      RowBox[{"\[DoubleStruckCapitalC]", "[", 
       RowBox[{
        FractionBox["1", 
         RowBox[{"243", " ", 
          SuperscriptBox[
           RowBox[{"(", 
            RowBox[{"1", "+", 
             SuperscriptBox["u", "2"]}], ")"}], "4"], " ", 
          SuperscriptBox[
           RowBox[{"(", 
            SuperscriptBox[
             StyleBox["Q0",
              FontColor->RGBColor[{
                 Rational[1, 2], 
                 Rational[1, 2], 0}]], "-"], ")"}], "3"], " ", 
          SuperscriptBox[
           RowBox[{"(", 
            SuperscriptBox[
             StyleBox["Q0",
              FontColor->RGBColor[{
                 Rational[1, 2], 
                 Rational[1, 2], 0}]], "+"], ")"}], "3"]}]], 
        RowBox[{"4", " ", "\[ImaginaryI]", " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{
            RowBox[{"(", 
             RowBox[{"108", "+", 
              RowBox[{"1142", " ", 
               SuperscriptBox["u", "2"]}], "+", 
              RowBox[{"4615", " ", 
               SuperscriptBox["u", "4"]}], "+", 
              RowBox[{"10277", " ", 
               SuperscriptBox["u", "6"]}], "+", 
              RowBox[{"24092", " ", 
               SuperscriptBox["u", "8"]}], "+", 
              RowBox[{"59418", " ", 
               SuperscriptBox["u", "10"]}], "+", 
              RowBox[{"107406", " ", 
               SuperscriptBox["u", "12"]}], "+", 
              RowBox[{"111726", " ", 
               SuperscriptBox["u", "14"]}], "+", 
              RowBox[{"64395", " ", 
               SuperscriptBox["u", "16"]}], "+", 
              RowBox[{"15309", " ", 
               SuperscriptBox["u", "18"]}]}], ")"}], " ", 
            SubscriptBox[
             OverscriptBox[
              StyleBox["W",
               FontColor->RGBColor[0.54, 0.35, 0.15]], 
              StyleBox["^",
               FontColor->RGBColor[0.54, 0.35, 0.15]]], "lead"]}], "-", 
           RowBox[{"9", " ", 
            SuperscriptBox[
             RowBox[{"(", 
              RowBox[{"1", "+", 
               SuperscriptBox["u", "2"]}], ")"}], "2"], " ", 
            SuperscriptBox[
             StyleBox["Q0",
              FontColor->RGBColor[{
                 Rational[1, 2], 
                 Rational[1, 2], 0}]], "-"], " ", 
            SuperscriptBox[
             StyleBox["Q0",
              FontColor->RGBColor[{
                 Rational[1, 2], 
                 Rational[1, 2], 0}]], "+"], " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{
               RowBox[{"(", 
                RowBox[{"11", "+", 
                 RowBox[{"113", " ", 
                  SuperscriptBox["u", "2"]}], "+", 
                 RowBox[{"434", " ", 
                  SuperscriptBox["u", "4"]}], "+", 
                 RowBox[{"729", " ", 
                  SuperscriptBox["u", "6"]}], "+", 
                 RowBox[{"819", " ", 
                  SuperscriptBox["u", "8"]}], "+", 
                 RowBox[{"324", " ", 
                  SuperscriptBox["u", "10"]}]}], ")"}], " ", 
               SubscriptBox[
                OverscriptBox[
                 StyleBox["W",
                  FontColor->RGBColor[0.54, 0.35, 0.15]], 
                 StyleBox["^",
                  FontColor->RGBColor[0.54, 0.35, 0.15]]], "sublead"]}], "+", 
              
              RowBox[{"9", " ", 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{"1", "+", 
                  SuperscriptBox["u", "2"]}], ")"}], "2"], " ", 
               SuperscriptBox[
                StyleBox["Q0",
                 FontColor->RGBColor[{
                    Rational[1, 2], 
                    Rational[1, 2], 0}]], "-"], " ", 
               SuperscriptBox[
                StyleBox["Q0",
                 FontColor->RGBColor[{
                    Rational[1, 2], 
                    Rational[1, 2], 0}]], "+"], " ", 
               SubscriptBox[
                OverscriptBox[
                 StyleBox["W",
                  FontColor->RGBColor[0.54, 0.35, 0.15]], 
                 StyleBox["^",
                  FontColor->RGBColor[0.54, 0.35, 0.15]]], "sublead2"]}]}], 
             ")"}]}]}], ")"}]}]}], "]"}]}], "+", 
     RowBox[{
      FractionBox["38", "9"], " ", 
      SubscriptBox[
       StyleBox["W",
        FontColor->RGBColor[0.54, 0.35, 0.15]], 
       RowBox[{"1", ",", "v0", ",", "lead"}]]}], "-", 
     RowBox[{
      FractionBox["4", "3"], " ", 
      SubscriptBox[
       StyleBox["W",
        FontColor->RGBColor[0.54, 0.35, 0.15]], 
       RowBox[{"1", ",", "v0", ",", "sublead"}]]}], "-", 
     RowBox[{
      FractionBox["2", "9"], " ", 
      SubscriptBox[
       StyleBox["W",
        FontColor->RGBColor[0.54, 0.35, 0.15]], 
       RowBox[{"1", ",", "v0", ",", "sublead2"}]]}], "-", 
     RowBox[{"14340", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2"]}], "+", 
     FractionBox[
      RowBox[{"65064", " ", 
       SubsuperscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "2", "2"]}], "5"], "+", 
     FractionBox[
      RowBox[{"234112", " ", 
       SubsuperscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "2", "3"]}], "35"], "-", 
     FractionBox[
      RowBox[{"345088", " ", 
       SubsuperscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "2", "4"]}], "175"], "+", 
     FractionBox[
      RowBox[{"6016", " ", 
       SubsuperscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "2", "5"]}], "175"], "+", 
     RowBox[{"7740", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3"]}], "+", 
     RowBox[{"4696", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3"]}], "-", 
     RowBox[{
      FractionBox["70624", "5"], " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2", "2"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3"]}], "-", 
     RowBox[{
      FractionBox["12864", "35"], " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2", "3"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3"]}], "+", 
     RowBox[{
      FractionBox["384", "25"], " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2", "4"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3"]}], "+", 
     RowBox[{"14312", " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3", "2"]}], "+", 
     RowBox[{"5280", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2"], " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3", "2"]}], "-", 
     RowBox[{
      FractionBox["192", "5"], " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2", "2"], " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3", "2"]}], "-", 
     RowBox[{"1056", " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3", "3"]}], "+", 
     RowBox[{"27132", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "5"]}], "+", 
     RowBox[{"3112", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "5"]}], "+", 
     RowBox[{
      FractionBox["6288", "5"], " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2", "2"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "5"]}], "+", 
     RowBox[{
      FractionBox["768", "35"], " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2", "3"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "5"]}], "-", 
     RowBox[{"24352", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "5"]}], "-", 
     RowBox[{"1632", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "5"]}], "+", 
     RowBox[{"648", " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "5", "2"]}], "+", 
     RowBox[{"1404", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "7"]}], "-", 
     RowBox[{"3816", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "7"]}], "+", 
     RowBox[{
      FractionBox["144", "5"], " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2", "2"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "7"]}], "+", 
     RowBox[{"2880", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "7"]}]}]}], ",", 
   RowBox[{
    RowBox[{
     SubscriptBox["\[Beta]", "sublead2"], "[", "0", "]"}], "\[Rule]", 
    RowBox[{
     RowBox[{"-", "210762"}], "-", 
     RowBox[{
      FractionBox["1", "6"], " ", 
      RowBox[{"\[DoubleStruckCapitalC]", "[", 
       FractionBox[
        RowBox[{"16", " ", "\[ImaginaryI]", " ", 
         SubscriptBox[
          StyleBox["H",
           FontColor->RGBColor[0.54, 0.35, 0.15]], "lead"]}], 
        SuperscriptBox["u", "4"]], "]"}]}], "+", 
     RowBox[{
      FractionBox["5", "12"], " ", 
      RowBox[{"\[DoubleStruckCapitalC]", "[", 
       RowBox[{"-", 
        FractionBox[
         RowBox[{"8", " ", 
          SubscriptBox[
           StyleBox["H",
            FontColor->RGBColor[0.54, 0.35, 0.15]], "lead"]}], 
         SuperscriptBox["u", "3"]]}], "]"}]}], "-", 
     RowBox[{
      FractionBox["1", "2"], " ", 
      RowBox[{"\[DoubleStruckCapitalC]", "[", 
       FractionBox[
        RowBox[{"4", " ", "\[ImaginaryI]", " ", 
         SubscriptBox[
          StyleBox["H",
           FontColor->RGBColor[0.54, 0.35, 0.15]], "lead"]}], 
        SuperscriptBox["u", "2"]], "]"}]}], "+", 
     RowBox[{"31", " ", 
      RowBox[{"\[DoubleStruckCapitalC]", "[", 
       RowBox[{"-", 
        FractionBox[
         RowBox[{"2", " ", 
          SubscriptBox[
           StyleBox["H",
            FontColor->RGBColor[0.54, 0.35, 0.15]], "lead"]}], "u"]}], 
       "]"}]}], "-", 
     RowBox[{
      FractionBox["8", "3"], " ", 
      RowBox[{"\[DoubleStruckCapitalC]", "[", 
       RowBox[{"-", 
        FractionBox[
         RowBox[{"2", " ", 
          SubscriptBox[
           StyleBox["H",
            FontColor->RGBColor[0.54, 0.35, 0.15]], "sublead"]}], "u"]}], 
       "]"}]}], "-", 
     RowBox[{
      FractionBox["1", "6"], " ", 
      RowBox[{"\[DoubleStruckCapitalC]", "[", 
       FractionBox[
        RowBox[{"4", " ", "\[ImaginaryI]", " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"2", " ", 
            SubscriptBox[
             StyleBox["H",
              FontColor->RGBColor[0.54, 0.35, 0.15]], "lead"]}], "+", 
           RowBox[{
            SuperscriptBox["u", "2"], " ", 
            SubscriptBox[
             StyleBox["H",
              FontColor->RGBColor[0.54, 0.35, 0.15]], "sublead"]}]}], ")"}]}], 
        SuperscriptBox["u", "4"]], "]"}]}], "+", 
     RowBox[{
      FractionBox["2", "3"], " ", 
      RowBox[{"\[DoubleStruckCapitalC]", "[", 
       RowBox[{"-", 
        FractionBox[
         RowBox[{"2", " ", 
          SubscriptBox[
           StyleBox["H",
            FontColor->RGBColor[0.54, 0.35, 0.15]], "sublead2"]}], "u"]}], 
       "]"}]}], "+", 
     RowBox[{
      FractionBox["1", "6"], " ", 
      RowBox[{"\[DoubleStruckCapitalC]", "[", 
       FractionBox[
        RowBox[{"4", " ", "\[ImaginaryI]", " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"6", " ", 
            SubscriptBox[
             StyleBox["H",
              FontColor->RGBColor[0.54, 0.35, 0.15]], "lead"]}], "+", 
           RowBox[{"2", " ", 
            SuperscriptBox["u", "2"], " ", 
            SubscriptBox[
             StyleBox["H",
              FontColor->RGBColor[0.54, 0.35, 0.15]], "sublead"]}], "+", 
           RowBox[{
            SuperscriptBox["u", "4"], " ", 
            SubscriptBox[
             StyleBox["H",
              FontColor->RGBColor[0.54, 0.35, 0.15]], "sublead2"]}]}], 
          ")"}]}], 
        SuperscriptBox["u", "6"]], "]"}]}], "+", 
     RowBox[{"31", " ", 
      RowBox[{"\[DoubleStruckCapitalC]", "[", 
       RowBox[{"-", 
        FractionBox[
         RowBox[{"4", " ", 
          RowBox[{"(", 
           RowBox[{"\[ImaginaryI]", "+", "u"}], ")"}], " ", 
          SubsuperscriptBox[
           StyleBox["W",
            FontColor->RGBColor[0.54, 0.35, 0.15]], 
           RowBox[{"1", ",", "lead"}], "+"]}], 
         SuperscriptBox[
          StyleBox["Q0",
           FontColor->RGBColor[{
              Rational[1, 2], 
              Rational[1, 2], 0}]], "+"]]}], "]"}]}], "+", 
     RowBox[{
      FractionBox["5", "12"], " ", 
      RowBox[{"\[DoubleStruckCapitalC]", "[", 
       RowBox[{"-", 
        FractionBox[
         RowBox[{"16", " ", 
          RowBox[{"(", 
           RowBox[{"\[ImaginaryI]", "+", "u"}], ")"}], " ", 
          SubsuperscriptBox[
           StyleBox["W",
            FontColor->RGBColor[0.54, 0.35, 0.15]], 
           RowBox[{"1", ",", "lead"}], "+"]}], 
         RowBox[{
          SuperscriptBox["u", "2"], " ", 
          SuperscriptBox[
           StyleBox["Q0",
            FontColor->RGBColor[{
               Rational[1, 2], 
               Rational[1, 2], 0}]], "+"]}]]}], "]"}]}], "-", 
     RowBox[{
      FractionBox["8", "3"], " ", 
      RowBox[{"\[DoubleStruckCapitalC]", "[", 
       RowBox[{
        RowBox[{"-", 
         FractionBox[
          RowBox[{"4", " ", 
           SuperscriptBox[
            RowBox[{"(", 
             RowBox[{"\[ImaginaryI]", "+", 
              RowBox[{"2", " ", "u"}]}], ")"}], "2"], " ", 
           RowBox[{"(", 
            RowBox[{"1", "+", 
             RowBox[{"\[ImaginaryI]", " ", "u"}], "+", 
             SuperscriptBox["u", "2"]}], ")"}], " ", 
           SubsuperscriptBox[
            StyleBox["W",
             FontColor->RGBColor[0.54, 0.35, 0.15]], 
            RowBox[{"1", ",", "lead"}], "+"]}], 
          RowBox[{"3", " ", 
           SuperscriptBox["u", "2"], " ", 
           RowBox[{"(", 
            RowBox[{"\[ImaginaryI]", "+", "u"}], ")"}], " ", 
           SuperscriptBox[
            RowBox[{"(", 
             SuperscriptBox[
              StyleBox["Q0",
               FontColor->RGBColor[{
                  Rational[1, 2], 
                  Rational[1, 2], 0}]], "+"], ")"}], "2"]}]]}], "-", 
        FractionBox[
         RowBox[{"4", " ", 
          RowBox[{"(", 
           RowBox[{"\[ImaginaryI]", "+", "u"}], ")"}], " ", 
          SubsuperscriptBox[
           StyleBox["W",
            FontColor->RGBColor[0.54, 0.35, 0.15]], 
           RowBox[{"1", ",", "sublead"}], "+"]}], 
         SuperscriptBox[
          StyleBox["Q0",
           FontColor->RGBColor[{
              Rational[1, 2], 
              Rational[1, 2], 0}]], "+"]]}], "]"}]}], "+", 
     RowBox[{
      FractionBox["2", "3"], " ", 
      RowBox[{"\[DoubleStruckCapitalC]", "[", 
       RowBox[{
        FractionBox["1", 
         RowBox[{"9", " ", 
          SuperscriptBox["u", "4"], " ", 
          SuperscriptBox[
           RowBox[{"(", 
            RowBox[{"\[ImaginaryI]", "+", "u"}], ")"}], "3"], " ", 
          SuperscriptBox[
           RowBox[{"(", 
            SuperscriptBox[
             StyleBox["Q0",
              FontColor->RGBColor[{
                 Rational[1, 2], 
                 Rational[1, 2], 0}]], "+"], ")"}], "3"]}]], 
        RowBox[{"4", " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{
            RowBox[{"(", 
             RowBox[{"1", "-", 
              RowBox[{"10", " ", "\[ImaginaryI]", " ", "u"}], "-", 
              RowBox[{"45", " ", 
               SuperscriptBox["u", "2"]}], "+", 
              RowBox[{"100", " ", "\[ImaginaryI]", " ", 
               SuperscriptBox["u", "3"]}], "+", 
              RowBox[{"61", " ", 
               SuperscriptBox["u", "4"]}], "+", 
              RowBox[{"202", " ", "\[ImaginaryI]", " ", 
               SuperscriptBox["u", "5"]}], "+", 
              RowBox[{"534", " ", 
               SuperscriptBox["u", "6"]}], "-", 
              RowBox[{"616", " ", "\[ImaginaryI]", " ", 
               SuperscriptBox["u", "7"]}], "-", 
              RowBox[{"424", " ", 
               SuperscriptBox["u", "8"]}], "+", 
              RowBox[{"180", " ", "\[ImaginaryI]", " ", 
               SuperscriptBox["u", "9"]}], "+", 
              RowBox[{"36", " ", 
               SuperscriptBox["u", "10"]}]}], ")"}], " ", 
            SubsuperscriptBox[
             StyleBox["W",
              FontColor->RGBColor[0.54, 0.35, 0.15]], 
             RowBox[{"1", ",", "lead"}], "+"]}], "-", 
           RowBox[{"3", " ", 
            SuperscriptBox["u", "2"], " ", 
            SuperscriptBox[
             RowBox[{"(", 
              RowBox[{"\[ImaginaryI]", "+", "u"}], ")"}], "2"], " ", 
            SuperscriptBox[
             StyleBox["Q0",
              FontColor->RGBColor[{
                 Rational[1, 2], 
                 Rational[1, 2], 0}]], "+"], " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{"\[ImaginaryI]", "+", 
                  RowBox[{"2", " ", "u"}]}], ")"}], "2"], " ", 
               RowBox[{"(", 
                RowBox[{"1", "+", 
                 RowBox[{"\[ImaginaryI]", " ", "u"}], "+", 
                 SuperscriptBox["u", "2"]}], ")"}], " ", 
               SubsuperscriptBox[
                StyleBox["W",
                 FontColor->RGBColor[0.54, 0.35, 0.15]], 
                RowBox[{"1", ",", "sublead"}], "+"]}], "+", 
              RowBox[{"3", " ", 
               SuperscriptBox["u", "2"], " ", 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{"\[ImaginaryI]", "+", "u"}], ")"}], "2"], " ", 
               SuperscriptBox[
                StyleBox["Q0",
                 FontColor->RGBColor[{
                    Rational[1, 2], 
                    Rational[1, 2], 0}]], "+"], " ", 
               SubsuperscriptBox[
                StyleBox["W",
                 FontColor->RGBColor[0.54, 0.35, 0.15]], 
                RowBox[{"1", ",", "sublead2"}], "+"]}]}], ")"}]}]}], 
          ")"}]}]}], "]"}]}], "+", 
     RowBox[{
      FractionBox["1", "2"], " ", 
      RowBox[{"\[DoubleStruckCapitalC]", "[", 
       FractionBox[
        RowBox[{"12", " ", "\[ImaginaryI]", " ", 
         SubscriptBox[
          OverscriptBox[
           StyleBox["W",
            FontColor->RGBColor[0.54, 0.35, 0.15]], 
           StyleBox["^",
            FontColor->RGBColor[0.54, 0.35, 0.15]]], "lead"]}], 
        RowBox[{"1", "+", 
         SuperscriptBox["u", "2"]}]], "]"}]}], "+", 
     RowBox[{
      FractionBox["8", "3"], " ", 
      RowBox[{"\[DoubleStruckCapitalC]", "[", 
       RowBox[{"-", 
        FractionBox[
         RowBox[{"24", " ", "\[ImaginaryI]", " ", 
          SubscriptBox[
           OverscriptBox[
            StyleBox["W",
             FontColor->RGBColor[0.54, 0.35, 0.15]], 
            StyleBox["^",
             FontColor->RGBColor[0.54, 0.35, 0.15]]], "lead"]}], 
         RowBox[{"1", "+", 
          SuperscriptBox["u", "2"]}]]}], "]"}]}], "-", 
     RowBox[{
      FractionBox["2", "3"], " ", 
      RowBox[{"\[DoubleStruckCapitalC]", "[", 
       FractionBox[
        RowBox[{"132", " ", "\[ImaginaryI]", " ", 
         SubscriptBox[
          OverscriptBox[
           StyleBox["W",
            FontColor->RGBColor[0.54, 0.35, 0.15]], 
           StyleBox["^",
            FontColor->RGBColor[0.54, 0.35, 0.15]]], "lead"]}], 
        RowBox[{"1", "+", 
         SuperscriptBox["u", "2"]}]], "]"}]}], "-", 
     RowBox[{
      FractionBox["1", "6"], " ", 
      RowBox[{"\[DoubleStruckCapitalC]", "[", 
       RowBox[{"-", 
        FractionBox[
         RowBox[{"192", " ", "\[ImaginaryI]", " ", 
          SubscriptBox[
           OverscriptBox[
            StyleBox["W",
             FontColor->RGBColor[0.54, 0.35, 0.15]], 
            StyleBox["^",
             FontColor->RGBColor[0.54, 0.35, 0.15]]], "lead"]}], 
         RowBox[{"1", "+", 
          SuperscriptBox["u", "2"]}]]}], "]"}]}], "-", 
     RowBox[{
      FractionBox["5", "12"], " ", 
      RowBox[{"\[DoubleStruckCapitalC]", "[", 
       FractionBox[
        RowBox[{"24", " ", "\[ImaginaryI]", " ", 
         RowBox[{"(", 
          RowBox[{"1", "+", 
           RowBox[{"5", " ", 
            SuperscriptBox["u", "2"]}], "+", 
           RowBox[{"2", " ", 
            SuperscriptBox["u", "4"]}]}], ")"}], " ", 
         SubscriptBox[
          OverscriptBox[
           StyleBox["W",
            FontColor->RGBColor[0.54, 0.35, 0.15]], 
           StyleBox["^",
            FontColor->RGBColor[0.54, 0.35, 0.15]]], "lead"]}], 
        SuperscriptBox[
         RowBox[{"(", 
          RowBox[{"u", "+", 
           SuperscriptBox["u", "3"]}], ")"}], "2"]], "]"}]}], "+", 
     RowBox[{
      FractionBox["1", "6"], " ", 
      RowBox[{"\[DoubleStruckCapitalC]", "[", 
       RowBox[{"-", 
        FractionBox[
         RowBox[{"48", " ", "\[ImaginaryI]", " ", 
          RowBox[{"(", 
           RowBox[{"2", "+", 
            RowBox[{"12", " ", 
             SuperscriptBox["u", "2"]}], "+", 
            RowBox[{"9", " ", 
             SuperscriptBox["u", "4"]}], "+", 
            RowBox[{"3", " ", 
             SuperscriptBox["u", "6"]}]}], ")"}], " ", 
          SubscriptBox[
           OverscriptBox[
            StyleBox["W",
             FontColor->RGBColor[0.54, 0.35, 0.15]], 
            StyleBox["^",
             FontColor->RGBColor[0.54, 0.35, 0.15]]], "lead"]}], 
         RowBox[{
          SuperscriptBox["u", "2"], " ", 
          SuperscriptBox[
           RowBox[{"(", 
            RowBox[{"1", "+", 
             SuperscriptBox["u", "2"]}], ")"}], "3"]}]]}], "]"}]}], "+", 
     RowBox[{"31", " ", 
      RowBox[{"\[DoubleStruckCapitalC]", "[", 
       RowBox[{"-", 
        FractionBox[
         RowBox[{"4", " ", "\[ImaginaryI]", " ", 
          SubscriptBox[
           OverscriptBox[
            StyleBox["W",
             FontColor->RGBColor[0.54, 0.35, 0.15]], 
            StyleBox["^",
             FontColor->RGBColor[0.54, 0.35, 0.15]]], "lead"]}], 
         RowBox[{"3", " ", 
          SuperscriptBox[
           StyleBox["Q0",
            FontColor->RGBColor[{
               Rational[1, 2], 
               Rational[1, 2], 0}]], "-"], " ", 
          SuperscriptBox[
           StyleBox["Q0",
            FontColor->RGBColor[{
               Rational[1, 2], 
               Rational[1, 2], 0}]], "+"]}]]}], "]"}]}], "+", 
     RowBox[{"116", " ", 
      RowBox[{"\[DoubleStruckCapitalC]", "[", 
       RowBox[{"-", 
        FractionBox[
         RowBox[{"\[ImaginaryI]", " ", 
          RowBox[{"(", 
           RowBox[{"1", "+", 
            RowBox[{"3", " ", 
             SuperscriptBox["u", "2"]}]}], ")"}], " ", 
          SubscriptBox[
           OverscriptBox[
            StyleBox["W",
             FontColor->RGBColor[0.54, 0.35, 0.15]], 
            StyleBox["^",
             FontColor->RGBColor[0.54, 0.35, 0.15]]], "lead"]}], 
         RowBox[{"3", " ", 
          SuperscriptBox[
           StyleBox["Q0",
            FontColor->RGBColor[{
               Rational[1, 2], 
               Rational[1, 2], 0}]], "-"], " ", 
          SuperscriptBox[
           StyleBox["Q0",
            FontColor->RGBColor[{
               Rational[1, 2], 
               Rational[1, 2], 0}]], "+"]}]]}], "]"}]}], "+", 
     RowBox[{
      FractionBox["5", "12"], " ", 
      RowBox[{"\[DoubleStruckCapitalC]", "[", 
       FractionBox[
        RowBox[{"16", " ", "\[ImaginaryI]", " ", 
         RowBox[{"(", 
          RowBox[{"6", "+", 
           RowBox[{"25", " ", 
            SuperscriptBox["u", "2"]}], "+", 
           RowBox[{"51", " ", 
            SuperscriptBox["u", "4"]}], "+", 
           RowBox[{"18", " ", 
            SuperscriptBox["u", "6"]}]}], ")"}], " ", 
         SubscriptBox[
          OverscriptBox[
           StyleBox["W",
            FontColor->RGBColor[0.54, 0.35, 0.15]], 
           StyleBox["^",
            FontColor->RGBColor[0.54, 0.35, 0.15]]], "lead"]}], 
        RowBox[{"3", " ", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"1", "+", 
            SuperscriptBox["u", "2"]}], ")"}], "2"], " ", 
         SuperscriptBox[
          StyleBox["Q0",
           FontColor->RGBColor[{
              Rational[1, 2], 
              Rational[1, 2], 0}]], "-"], " ", 
         SuperscriptBox[
          StyleBox["Q0",
           FontColor->RGBColor[{
              Rational[1, 2], 
              Rational[1, 2], 0}]], "+"]}]], "]"}]}], "+", 
     RowBox[{
      FractionBox["1", "6"], " ", 
      RowBox[{"\[DoubleStruckCapitalC]", "[", 
       FractionBox[
        RowBox[{"12", " ", "\[ImaginaryI]", " ", 
         SubscriptBox[
          OverscriptBox[
           StyleBox["W",
            FontColor->RGBColor[0.54, 0.35, 0.15]], 
           StyleBox["^",
            FontColor->RGBColor[0.54, 0.35, 0.15]]], "sublead"]}], 
        RowBox[{"1", "+", 
         SuperscriptBox["u", "2"]}]], "]"}]}], "-", 
     RowBox[{
      FractionBox["2", "3"], " ", 
      RowBox[{"\[DoubleStruckCapitalC]", "[", 
       RowBox[{"-", 
        FractionBox[
         RowBox[{"24", " ", "\[ImaginaryI]", " ", 
          SubscriptBox[
           OverscriptBox[
            StyleBox["W",
             FontColor->RGBColor[0.54, 0.35, 0.15]], 
            StyleBox["^",
             FontColor->RGBColor[0.54, 0.35, 0.15]]], "sublead"]}], 
         RowBox[{"1", "+", 
          SuperscriptBox["u", "2"]}]]}], "]"}]}], "-", 
     RowBox[{
      FractionBox["26", "3"], " ", 
      RowBox[{"\[DoubleStruckCapitalC]", "[", 
       RowBox[{"-", 
        FractionBox[
         RowBox[{"\[ImaginaryI]", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"4", " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"-", "1"}], "+", 
               RowBox[{"3", " ", 
                SuperscriptBox["u", "2"]}], "+", 
               RowBox[{"27", " ", 
                SuperscriptBox["u", "4"]}]}], ")"}], " ", 
             SubscriptBox[
              OverscriptBox[
               StyleBox["W",
                FontColor->RGBColor[0.54, 0.35, 0.15]], 
               StyleBox["^",
                FontColor->RGBColor[0.54, 0.35, 0.15]]], "lead"]}], "+", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{"1", "+", 
               RowBox[{"6", " ", 
                SuperscriptBox["u", "2"]}], "+", 
               RowBox[{"18", " ", 
                SuperscriptBox["u", "4"]}], "+", 
               RowBox[{"27", " ", 
                SuperscriptBox["u", "6"]}]}], ")"}], " ", 
             SubscriptBox[
              OverscriptBox[
               StyleBox["W",
                FontColor->RGBColor[0.54, 0.35, 0.15]], 
               StyleBox["^",
                FontColor->RGBColor[0.54, 0.35, 0.15]]], "sublead"]}]}], 
           ")"}]}], 
         RowBox[{"27", " ", 
          SuperscriptBox[
           RowBox[{"(", 
            SuperscriptBox[
             StyleBox["Q0",
              FontColor->RGBColor[{
                 Rational[1, 2], 
                 Rational[1, 2], 0}]], "-"], ")"}], "2"], " ", 
          SuperscriptBox[
           RowBox[{"(", 
            SuperscriptBox[
             StyleBox["Q0",
              FontColor->RGBColor[{
                 Rational[1, 2], 
                 Rational[1, 2], 0}]], "+"], ")"}], "2"]}]]}], "]"}]}], "-", 
     RowBox[{
      FractionBox["8", "3"], " ", 
      RowBox[{"\[DoubleStruckCapitalC]", "[", 
       RowBox[{"-", 
        FractionBox[
         RowBox[{"4", " ", "\[ImaginaryI]", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{
             RowBox[{"(", 
              RowBox[{"11", "+", 
               RowBox[{"113", " ", 
                SuperscriptBox["u", "2"]}], "+", 
               RowBox[{"434", " ", 
                SuperscriptBox["u", "4"]}], "+", 
               RowBox[{"729", " ", 
                SuperscriptBox["u", "6"]}], "+", 
               RowBox[{"819", " ", 
                SuperscriptBox["u", "8"]}], "+", 
               RowBox[{"324", " ", 
                SuperscriptBox["u", "10"]}]}], ")"}], " ", 
             SubscriptBox[
              OverscriptBox[
               StyleBox["W",
                FontColor->RGBColor[0.54, 0.35, 0.15]], 
               StyleBox["^",
                FontColor->RGBColor[0.54, 0.35, 0.15]]], "lead"]}], "+", 
            RowBox[{"9", " ", 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{"1", "+", 
                SuperscriptBox["u", "2"]}], ")"}], "2"], " ", 
             SuperscriptBox[
              StyleBox["Q0",
               FontColor->RGBColor[{
                  Rational[1, 2], 
                  Rational[1, 2], 0}]], "-"], " ", 
             SuperscriptBox[
              StyleBox["Q0",
               FontColor->RGBColor[{
                  Rational[1, 2], 
                  Rational[1, 2], 0}]], "+"], " ", 
             SubscriptBox[
              OverscriptBox[
               StyleBox["W",
                FontColor->RGBColor[0.54, 0.35, 0.15]], 
               StyleBox["^",
                FontColor->RGBColor[0.54, 0.35, 0.15]]], "sublead"]}]}], 
           ")"}]}], 
         RowBox[{"27", " ", 
          SuperscriptBox[
           RowBox[{"(", 
            RowBox[{"1", "+", 
             SuperscriptBox["u", "2"]}], ")"}], "2"], " ", 
          SuperscriptBox[
           RowBox[{"(", 
            SuperscriptBox[
             StyleBox["Q0",
              FontColor->RGBColor[{
                 Rational[1, 2], 
                 Rational[1, 2], 0}]], "-"], ")"}], "2"], " ", 
          SuperscriptBox[
           RowBox[{"(", 
            SuperscriptBox[
             StyleBox["Q0",
              FontColor->RGBColor[{
                 Rational[1, 2], 
                 Rational[1, 2], 0}]], "+"], ")"}], "2"]}]]}], "]"}]}], "-", 
     RowBox[{
      FractionBox["1", "6"], " ", 
      RowBox[{"\[DoubleStruckCapitalC]", "[", 
       FractionBox[
        RowBox[{"12", " ", "\[ImaginaryI]", " ", 
         SubscriptBox[
          OverscriptBox[
           StyleBox["W",
            FontColor->RGBColor[0.54, 0.35, 0.15]], 
           StyleBox["^",
            FontColor->RGBColor[0.54, 0.35, 0.15]]], "sublead2"]}], 
        RowBox[{"1", "+", 
         SuperscriptBox["u", "2"]}]], "]"}]}], "-", 
     RowBox[{
      FractionBox["10", "3"], " ", 
      RowBox[{"\[DoubleStruckCapitalC]", "[", 
       RowBox[{"-", 
        RowBox[{
         FractionBox["1", 
          RowBox[{"243", " ", 
           SuperscriptBox[
            RowBox[{"(", 
             SuperscriptBox[
              StyleBox["Q0",
               FontColor->RGBColor[{
                  Rational[1, 2], 
                  Rational[1, 2], 0}]], "-"], ")"}], "3"], " ", 
           SuperscriptBox[
            RowBox[{"(", 
             SuperscriptBox[
              StyleBox["Q0",
               FontColor->RGBColor[{
                  Rational[1, 2], 
                  Rational[1, 2], 0}]], "+"], ")"}], "3"]}]], 
         RowBox[{"\[ImaginaryI]", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"2", " ", 
             RowBox[{"(", 
              RowBox[{"5", "-", 
               RowBox[{"144", " ", 
                SuperscriptBox["u", "2"]}], "-", 
               RowBox[{"351", " ", 
                SuperscriptBox["u", "4"]}], "+", 
               RowBox[{"1404", " ", 
                SuperscriptBox["u", "6"]}], "+", 
               RowBox[{"729", " ", 
                SuperscriptBox["u", "8"]}]}], ")"}], " ", 
             SubscriptBox[
              OverscriptBox[
               StyleBox["W",
                FontColor->RGBColor[0.54, 0.35, 0.15]], 
               StyleBox["^",
                FontColor->RGBColor[0.54, 0.35, 0.15]]], "lead"]}], "+", 
            RowBox[{"9", " ", 
             SuperscriptBox[
              StyleBox["Q0",
               FontColor->RGBColor[{
                  Rational[1, 2], 
                  Rational[1, 2], 0}]], "-"], " ", 
             SuperscriptBox[
              StyleBox["Q0",
               FontColor->RGBColor[{
                  Rational[1, 2], 
                  Rational[1, 2], 0}]], "+"], " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"4", " ", 
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{"-", "1"}], "+", 
                  RowBox[{"3", " ", 
                   SuperscriptBox["u", "2"]}], "+", 
                  RowBox[{"27", " ", 
                   SuperscriptBox["u", "4"]}]}], ")"}], " ", 
                SubscriptBox[
                 OverscriptBox[
                  StyleBox["W",
                   FontColor->RGBColor[0.54, 0.35, 0.15]], 
                  StyleBox["^",
                   FontColor->RGBColor[0.54, 0.35, 0.15]]], "sublead"]}], "+", 
               RowBox[{
                RowBox[{"(", 
                 RowBox[{"1", "+", 
                  RowBox[{"6", " ", 
                   SuperscriptBox["u", "2"]}], "+", 
                  RowBox[{"18", " ", 
                   SuperscriptBox["u", "4"]}], "+", 
                  RowBox[{"27", " ", 
                   SuperscriptBox["u", "6"]}]}], ")"}], " ", 
                SubscriptBox[
                 OverscriptBox[
                  StyleBox["W",
                   FontColor->RGBColor[0.54, 0.35, 0.15]], 
                  StyleBox["^",
                   FontColor->RGBColor[0.54, 0.35, 0.15]]], "sublead2"]}]}], 
              ")"}]}]}], ")"}]}]}]}], "]"}]}], "+", 
     RowBox[{
      FractionBox["2", "3"], " ", 
      RowBox[{"\[DoubleStruckCapitalC]", "[", 
       RowBox[{
        FractionBox["1", 
         RowBox[{"243", " ", 
          SuperscriptBox[
           RowBox[{"(", 
            RowBox[{"1", "+", 
             SuperscriptBox["u", "2"]}], ")"}], "4"], " ", 
          SuperscriptBox[
           RowBox[{"(", 
            SuperscriptBox[
             StyleBox["Q0",
              FontColor->RGBColor[{
                 Rational[1, 2], 
                 Rational[1, 2], 0}]], "-"], ")"}], "3"], " ", 
          SuperscriptBox[
           RowBox[{"(", 
            SuperscriptBox[
             StyleBox["Q0",
              FontColor->RGBColor[{
                 Rational[1, 2], 
                 Rational[1, 2], 0}]], "+"], ")"}], "3"]}]], 
        RowBox[{"4", " ", "\[ImaginaryI]", " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{
            RowBox[{"(", 
             RowBox[{"108", "+", 
              RowBox[{"1142", " ", 
               SuperscriptBox["u", "2"]}], "+", 
              RowBox[{"4615", " ", 
               SuperscriptBox["u", "4"]}], "+", 
              RowBox[{"10277", " ", 
               SuperscriptBox["u", "6"]}], "+", 
              RowBox[{"24092", " ", 
               SuperscriptBox["u", "8"]}], "+", 
              RowBox[{"59418", " ", 
               SuperscriptBox["u", "10"]}], "+", 
              RowBox[{"107406", " ", 
               SuperscriptBox["u", "12"]}], "+", 
              RowBox[{"111726", " ", 
               SuperscriptBox["u", "14"]}], "+", 
              RowBox[{"64395", " ", 
               SuperscriptBox["u", "16"]}], "+", 
              RowBox[{"15309", " ", 
               SuperscriptBox["u", "18"]}]}], ")"}], " ", 
            SubscriptBox[
             OverscriptBox[
              StyleBox["W",
               FontColor->RGBColor[0.54, 0.35, 0.15]], 
              StyleBox["^",
               FontColor->RGBColor[0.54, 0.35, 0.15]]], "lead"]}], "-", 
           RowBox[{"9", " ", 
            SuperscriptBox[
             RowBox[{"(", 
              RowBox[{"1", "+", 
               SuperscriptBox["u", "2"]}], ")"}], "2"], " ", 
            SuperscriptBox[
             StyleBox["Q0",
              FontColor->RGBColor[{
                 Rational[1, 2], 
                 Rational[1, 2], 0}]], "-"], " ", 
            SuperscriptBox[
             StyleBox["Q0",
              FontColor->RGBColor[{
                 Rational[1, 2], 
                 Rational[1, 2], 0}]], "+"], " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{
               RowBox[{"(", 
                RowBox[{"11", "+", 
                 RowBox[{"113", " ", 
                  SuperscriptBox["u", "2"]}], "+", 
                 RowBox[{"434", " ", 
                  SuperscriptBox["u", "4"]}], "+", 
                 RowBox[{"729", " ", 
                  SuperscriptBox["u", "6"]}], "+", 
                 RowBox[{"819", " ", 
                  SuperscriptBox["u", "8"]}], "+", 
                 RowBox[{"324", " ", 
                  SuperscriptBox["u", "10"]}]}], ")"}], " ", 
               SubscriptBox[
                OverscriptBox[
                 StyleBox["W",
                  FontColor->RGBColor[0.54, 0.35, 0.15]], 
                 StyleBox["^",
                  FontColor->RGBColor[0.54, 0.35, 0.15]]], "sublead"]}], "+", 
              
              RowBox[{"9", " ", 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{"1", "+", 
                  SuperscriptBox["u", "2"]}], ")"}], "2"], " ", 
               SuperscriptBox[
                StyleBox["Q0",
                 FontColor->RGBColor[{
                    Rational[1, 2], 
                    Rational[1, 2], 0}]], "-"], " ", 
               SuperscriptBox[
                StyleBox["Q0",
                 FontColor->RGBColor[{
                    Rational[1, 2], 
                    Rational[1, 2], 0}]], "+"], " ", 
               SubscriptBox[
                OverscriptBox[
                 StyleBox["W",
                  FontColor->RGBColor[0.54, 0.35, 0.15]], 
                 StyleBox["^",
                  FontColor->RGBColor[0.54, 0.35, 0.15]]], "sublead2"]}]}], 
             ")"}]}]}], ")"}]}]}], "]"}]}], "-", 
     RowBox[{"116", " ", 
      SubscriptBox[
       StyleBox["W",
        FontColor->RGBColor[0.54, 0.35, 0.15]], 
       RowBox[{"1", ",", "v0", ",", "lead"}]]}], "+", 
     RowBox[{
      FractionBox["26", "3"], " ", 
      SubscriptBox[
       StyleBox["W",
        FontColor->RGBColor[0.54, 0.35, 0.15]], 
       RowBox[{"1", ",", "v0", ",", "sublead"}]]}], "+", 
     RowBox[{
      FractionBox["10", "3"], " ", 
      SubscriptBox[
       StyleBox["W",
        FontColor->RGBColor[0.54, 0.35, 0.15]], 
       RowBox[{"1", ",", "v0", ",", "sublead2"}]]}], "+", 
     RowBox[{"114876", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2"]}], "+", 
     FractionBox[
      RowBox[{"155376", " ", 
       SubsuperscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "2", "2"]}], "5"], "-", 
     FractionBox[
      RowBox[{"241104", " ", 
       SubsuperscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "2", "3"]}], "7"], "+", 
     FractionBox[
      RowBox[{"100608", " ", 
       SubsuperscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "2", "4"]}], "25"], "+", 
     FractionBox[
      RowBox[{"57216", " ", 
       SubsuperscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "2", "5"]}], "175"], "+", 
     RowBox[{"133884", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3"]}], "-", 
     RowBox[{"15240", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3"]}], "+", 
     RowBox[{"8256", " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2", "2"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3"]}], "+", 
     RowBox[{
      FractionBox["19776", "35"], " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2", "3"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3"]}], "+", 
     RowBox[{
      FractionBox["1152", "25"], " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2", "4"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3"]}], "-", 
     RowBox[{"40584", " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3", "2"]}], "-", 
     RowBox[{"16416", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2"], " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3", "2"]}], "-", 
     RowBox[{
      FractionBox["576", "5"], " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2", "2"], " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3", "2"]}], "-", 
     RowBox[{"1440", " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3", "3"]}], "-", 
     RowBox[{"9648", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "5"]}], "-", 
     RowBox[{"17088", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "5"]}], "-", 
     RowBox[{
      FractionBox["3456", "5"], " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2", "2"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "5"]}], "+", 
     RowBox[{
      FractionBox["2304", "35"], " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2", "3"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "5"]}], "+", 
     RowBox[{"36240", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "5"]}], "-", 
     RowBox[{"4896", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "5"]}], "+", 
     RowBox[{"2592", " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "5", "2"]}], "-", 
     RowBox[{"42444", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "7"]}], "+", 
     RowBox[{"18360", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "7"]}], "+", 
     RowBox[{
      FractionBox["432", "5"], " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2", "2"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "7"]}], "+", 
     RowBox[{"9936", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "7"]}]}]}], ",", 
   RowBox[{
    RowBox[{
     SubscriptBox["\[Alpha]", "sublead2"], "[", "1", "]"}], "\[Rule]", 
    RowBox[{
     RowBox[{"-", "47304"}], "+", 
     RowBox[{
      FractionBox["1", "72"], " ", 
      RowBox[{"\[DoubleStruckCapitalC]", "[", 
       FractionBox[
        RowBox[{"64", " ", "\[ImaginaryI]", " ", 
         SubscriptBox[
          StyleBox["H",
           FontColor->RGBColor[0.54, 0.35, 0.15]], "lead"]}], 
        SuperscriptBox["u", "6"]], "]"}]}], "-", 
     RowBox[{
      FractionBox["1", "36"], " ", 
      RowBox[{"\[DoubleStruckCapitalC]", "[", 
       RowBox[{"-", 
        FractionBox[
         RowBox[{"32", " ", 
          SubscriptBox[
           StyleBox["H",
            FontColor->RGBColor[0.54, 0.35, 0.15]], "lead"]}], 
         SuperscriptBox["u", "5"]]}], "]"}]}], "+", 
     RowBox[{
      FractionBox["5", "9"], " ", 
      RowBox[{"\[DoubleStruckCapitalC]", "[", 
       FractionBox[
        RowBox[{"16", " ", "\[ImaginaryI]", " ", 
         SubscriptBox[
          StyleBox["H",
           FontColor->RGBColor[0.54, 0.35, 0.15]], "lead"]}], 
        SuperscriptBox["u", "4"]], "]"}]}], "-", 
     RowBox[{
      FractionBox["1", "9"], " ", 
      RowBox[{"\[DoubleStruckCapitalC]", "[", 
       RowBox[{"-", 
        FractionBox[
         RowBox[{"8", " ", 
          SubscriptBox[
           StyleBox["H",
            FontColor->RGBColor[0.54, 0.35, 0.15]], "lead"]}], 
         SuperscriptBox["u", "3"]]}], "]"}]}], "+", 
     RowBox[{
      FractionBox["10", "9"], " ", 
      RowBox[{"\[DoubleStruckCapitalC]", "[", 
       FractionBox[
        RowBox[{"4", " ", "\[ImaginaryI]", " ", 
         SubscriptBox[
          StyleBox["H",
           FontColor->RGBColor[0.54, 0.35, 0.15]], "lead"]}], 
        SuperscriptBox["u", "2"]], "]"}]}], "+", 
     RowBox[{
      FractionBox["40", "9"], " ", 
      RowBox[{"\[DoubleStruckCapitalC]", "[", 
       RowBox[{"-", 
        FractionBox[
         RowBox[{"2", " ", 
          SubscriptBox[
           StyleBox["H",
            FontColor->RGBColor[0.54, 0.35, 0.15]], "lead"]}], "u"]}], 
       "]"}]}], "-", 
     RowBox[{
      FractionBox["2", "9"], " ", 
      RowBox[{"\[DoubleStruckCapitalC]", "[", 
       RowBox[{"-", 
        FractionBox[
         RowBox[{"8", " ", 
          SubscriptBox[
           StyleBox["H",
            FontColor->RGBColor[0.54, 0.35, 0.15]], "sublead"]}], 
         SuperscriptBox["u", "3"]]}], "]"}]}], "+", 
     RowBox[{
      FractionBox["1", "9"], " ", 
      RowBox[{"\[DoubleStruckCapitalC]", "[", 
       FractionBox[
        RowBox[{"16", " ", "\[ImaginaryI]", " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"2", " ", 
            SubscriptBox[
             StyleBox["H",
              FontColor->RGBColor[0.54, 0.35, 0.15]], "lead"]}], "+", 
           RowBox[{
            SuperscriptBox["u", "2"], " ", 
            SubscriptBox[
             StyleBox["H",
              FontColor->RGBColor[0.54, 0.35, 0.15]], "sublead"]}]}], ")"}]}], 
        SuperscriptBox["u", "6"]], "]"}]}], "-", 
     RowBox[{
      FractionBox["4", "3"], " ", 
      RowBox[{"\[DoubleStruckCapitalC]", "[", 
       FractionBox[
        RowBox[{"4", " ", "\[ImaginaryI]", " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"2", " ", 
            SubscriptBox[
             StyleBox["H",
              FontColor->RGBColor[0.54, 0.35, 0.15]], "lead"]}], "+", 
           RowBox[{
            SuperscriptBox["u", "2"], " ", 
            SubscriptBox[
             StyleBox["H",
              FontColor->RGBColor[0.54, 0.35, 0.15]], "sublead"]}]}], ")"}]}], 
        SuperscriptBox["u", "4"]], "]"}]}], "+", 
     RowBox[{
      FractionBox["4", "9"], " ", 
      RowBox[{"\[DoubleStruckCapitalC]", "[", 
       RowBox[{"-", 
        FractionBox[
         RowBox[{"2", " ", 
          SubscriptBox[
           StyleBox["H",
            FontColor->RGBColor[0.54, 0.35, 0.15]], "sublead2"]}], "u"]}], 
       "]"}]}], "-", 
     RowBox[{
      FractionBox["2", "9"], " ", 
      RowBox[{"\[DoubleStruckCapitalC]", "[", 
       FractionBox[
        RowBox[{"4", " ", "\[ImaginaryI]", " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"6", " ", 
            SubscriptBox[
             StyleBox["H",
              FontColor->RGBColor[0.54, 0.35, 0.15]], "lead"]}], "+", 
           RowBox[{"2", " ", 
            SuperscriptBox["u", "2"], " ", 
            SubscriptBox[
             StyleBox["H",
              FontColor->RGBColor[0.54, 0.35, 0.15]], "sublead"]}], "+", 
           RowBox[{
            SuperscriptBox["u", "4"], " ", 
            SubscriptBox[
             StyleBox["H",
              FontColor->RGBColor[0.54, 0.35, 0.15]], "sublead2"]}]}], 
          ")"}]}], 
        SuperscriptBox["u", "6"]], "]"}]}], "+", 
     RowBox[{
      FractionBox["40", "9"], " ", 
      RowBox[{"\[DoubleStruckCapitalC]", "[", 
       RowBox[{"-", 
        FractionBox[
         RowBox[{"4", " ", 
          RowBox[{"(", 
           RowBox[{"\[ImaginaryI]", "+", "u"}], ")"}], " ", 
          SubsuperscriptBox[
           StyleBox["W",
            FontColor->RGBColor[0.54, 0.35, 0.15]], 
           RowBox[{"1", ",", "lead"}], "+"]}], 
         SuperscriptBox[
          StyleBox["Q0",
           FontColor->RGBColor[{
              Rational[1, 2], 
              Rational[1, 2], 0}]], "+"]]}], "]"}]}], "-", 
     RowBox[{
      FractionBox["1", "36"], " ", 
      RowBox[{"\[DoubleStruckCapitalC]", "[", 
       RowBox[{"-", 
        FractionBox[
         RowBox[{"64", " ", 
          RowBox[{"(", 
           RowBox[{"\[ImaginaryI]", "+", "u"}], ")"}], " ", 
          SubsuperscriptBox[
           StyleBox["W",
            FontColor->RGBColor[0.54, 0.35, 0.15]], 
           RowBox[{"1", ",", "lead"}], "+"]}], 
         RowBox[{
          SuperscriptBox["u", "4"], " ", 
          SuperscriptBox[
           StyleBox["Q0",
            FontColor->RGBColor[{
               Rational[1, 2], 
               Rational[1, 2], 0}]], "+"]}]]}], "]"}]}], "-", 
     RowBox[{
      FractionBox["1", "9"], " ", 
      RowBox[{"\[DoubleStruckCapitalC]", "[", 
       RowBox[{"-", 
        FractionBox[
         RowBox[{"16", " ", 
          RowBox[{"(", 
           RowBox[{"\[ImaginaryI]", "+", "u"}], ")"}], " ", 
          SubsuperscriptBox[
           StyleBox["W",
            FontColor->RGBColor[0.54, 0.35, 0.15]], 
           RowBox[{"1", ",", "lead"}], "+"]}], 
         RowBox[{
          SuperscriptBox["u", "2"], " ", 
          SuperscriptBox[
           StyleBox["Q0",
            FontColor->RGBColor[{
               Rational[1, 2], 
               Rational[1, 2], 0}]], "+"]}]]}], "]"}]}], "-", 
     RowBox[{
      FractionBox["2", "9"], " ", 
      RowBox[{"\[DoubleStruckCapitalC]", "[", 
       RowBox[{"-", 
        FractionBox[
         RowBox[{"16", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{"\[ImaginaryI]", "+", 
                RowBox[{"2", " ", "u"}]}], ")"}], "2"], " ", 
             RowBox[{"(", 
              RowBox[{"1", "+", 
               RowBox[{"\[ImaginaryI]", " ", "u"}], "+", 
               SuperscriptBox["u", "2"]}], ")"}], " ", 
             SubsuperscriptBox[
              StyleBox["W",
               FontColor->RGBColor[0.54, 0.35, 0.15]], 
              RowBox[{"1", ",", "lead"}], "+"]}], "+", 
            RowBox[{"3", " ", 
             SuperscriptBox["u", "2"], " ", 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{"\[ImaginaryI]", "+", "u"}], ")"}], "2"], " ", 
             SuperscriptBox[
              StyleBox["Q0",
               FontColor->RGBColor[{
                  Rational[1, 2], 
                  Rational[1, 2], 0}]], "+"], " ", 
             SubsuperscriptBox[
              StyleBox["W",
               FontColor->RGBColor[0.54, 0.35, 0.15]], 
              RowBox[{"1", ",", "sublead"}], "+"]}]}], ")"}]}], 
         RowBox[{"3", " ", 
          SuperscriptBox["u", "4"], " ", 
          RowBox[{"(", 
           RowBox[{"\[ImaginaryI]", "+", "u"}], ")"}], " ", 
          SuperscriptBox[
           RowBox[{"(", 
            SuperscriptBox[
             StyleBox["Q0",
              FontColor->RGBColor[{
                 Rational[1, 2], 
                 Rational[1, 2], 0}]], "+"], ")"}], "2"]}]]}], "]"}]}], "+", 
     RowBox[{
      FractionBox["4", "9"], " ", 
      RowBox[{"\[DoubleStruckCapitalC]", "[", 
       RowBox[{
        FractionBox["1", 
         RowBox[{"9", " ", 
          SuperscriptBox["u", "4"], " ", 
          SuperscriptBox[
           RowBox[{"(", 
            RowBox[{"\[ImaginaryI]", "+", "u"}], ")"}], "3"], " ", 
          SuperscriptBox[
           RowBox[{"(", 
            SuperscriptBox[
             StyleBox["Q0",
              FontColor->RGBColor[{
                 Rational[1, 2], 
                 Rational[1, 2], 0}]], "+"], ")"}], "3"]}]], 
        RowBox[{"4", " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{
            RowBox[{"(", 
             RowBox[{"1", "-", 
              RowBox[{"10", " ", "\[ImaginaryI]", " ", "u"}], "-", 
              RowBox[{"45", " ", 
               SuperscriptBox["u", "2"]}], "+", 
              RowBox[{"100", " ", "\[ImaginaryI]", " ", 
               SuperscriptBox["u", "3"]}], "+", 
              RowBox[{"61", " ", 
               SuperscriptBox["u", "4"]}], "+", 
              RowBox[{"202", " ", "\[ImaginaryI]", " ", 
               SuperscriptBox["u", "5"]}], "+", 
              RowBox[{"534", " ", 
               SuperscriptBox["u", "6"]}], "-", 
              RowBox[{"616", " ", "\[ImaginaryI]", " ", 
               SuperscriptBox["u", "7"]}], "-", 
              RowBox[{"424", " ", 
               SuperscriptBox["u", "8"]}], "+", 
              RowBox[{"180", " ", "\[ImaginaryI]", " ", 
               SuperscriptBox["u", "9"]}], "+", 
              RowBox[{"36", " ", 
               SuperscriptBox["u", "10"]}]}], ")"}], " ", 
            SubsuperscriptBox[
             StyleBox["W",
              FontColor->RGBColor[0.54, 0.35, 0.15]], 
             RowBox[{"1", ",", "lead"}], "+"]}], "-", 
           RowBox[{"3", " ", 
            SuperscriptBox["u", "2"], " ", 
            SuperscriptBox[
             RowBox[{"(", 
              RowBox[{"\[ImaginaryI]", "+", "u"}], ")"}], "2"], " ", 
            SuperscriptBox[
             StyleBox["Q0",
              FontColor->RGBColor[{
                 Rational[1, 2], 
                 Rational[1, 2], 0}]], "+"], " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{"\[ImaginaryI]", "+", 
                  RowBox[{"2", " ", "u"}]}], ")"}], "2"], " ", 
               RowBox[{"(", 
                RowBox[{"1", "+", 
                 RowBox[{"\[ImaginaryI]", " ", "u"}], "+", 
                 SuperscriptBox["u", "2"]}], ")"}], " ", 
               SubsuperscriptBox[
                StyleBox["W",
                 FontColor->RGBColor[0.54, 0.35, 0.15]], 
                RowBox[{"1", ",", "sublead"}], "+"]}], "+", 
              RowBox[{"3", " ", 
               SuperscriptBox["u", "2"], " ", 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{"\[ImaginaryI]", "+", "u"}], ")"}], "2"], " ", 
               SuperscriptBox[
                StyleBox["Q0",
                 FontColor->RGBColor[{
                    Rational[1, 2], 
                    Rational[1, 2], 0}]], "+"], " ", 
               SubsuperscriptBox[
                StyleBox["W",
                 FontColor->RGBColor[0.54, 0.35, 0.15]], 
                RowBox[{"1", ",", "sublead2"}], "+"]}]}], ")"}]}]}], 
          ")"}]}]}], "]"}]}], "-", 
     RowBox[{
      FractionBox["10", "9"], " ", 
      RowBox[{"\[DoubleStruckCapitalC]", "[", 
       FractionBox[
        RowBox[{"12", " ", "\[ImaginaryI]", " ", 
         SubscriptBox[
          OverscriptBox[
           StyleBox["W",
            FontColor->RGBColor[0.54, 0.35, 0.15]], 
           StyleBox["^",
            FontColor->RGBColor[0.54, 0.35, 0.15]]], "lead"]}], 
        RowBox[{"1", "+", 
         SuperscriptBox["u", "2"]}]], "]"}]}], "-", 
     RowBox[{
      FractionBox["4", "9"], " ", 
      RowBox[{"\[DoubleStruckCapitalC]", "[", 
       FractionBox[
        RowBox[{"132", " ", "\[ImaginaryI]", " ", 
         SubscriptBox[
          OverscriptBox[
           StyleBox["W",
            FontColor->RGBColor[0.54, 0.35, 0.15]], 
           StyleBox["^",
            FontColor->RGBColor[0.54, 0.35, 0.15]]], "lead"]}], 
        RowBox[{"1", "+", 
         SuperscriptBox["u", "2"]}]], "]"}]}], "+", 
     RowBox[{
      FractionBox["2", "9"], " ", 
      RowBox[{"\[DoubleStruckCapitalC]", "[", 
       RowBox[{"-", 
        FractionBox[
         RowBox[{"192", " ", "\[ImaginaryI]", " ", 
          SubscriptBox[
           OverscriptBox[
            StyleBox["W",
             FontColor->RGBColor[0.54, 0.35, 0.15]], 
            StyleBox["^",
             FontColor->RGBColor[0.54, 0.35, 0.15]]], "lead"]}], 
         RowBox[{"1", "+", 
          SuperscriptBox["u", "2"]}]]}], "]"}]}], "+", 
     RowBox[{
      FractionBox["1", "9"], " ", 
      RowBox[{"\[DoubleStruckCapitalC]", "[", 
       FractionBox[
        RowBox[{"24", " ", "\[ImaginaryI]", " ", 
         RowBox[{"(", 
          RowBox[{"1", "+", 
           RowBox[{"5", " ", 
            SuperscriptBox["u", "2"]}], "+", 
           RowBox[{"2", " ", 
            SuperscriptBox["u", "4"]}]}], ")"}], " ", 
         SubscriptBox[
          OverscriptBox[
           StyleBox["W",
            FontColor->RGBColor[0.54, 0.35, 0.15]], 
           StyleBox["^",
            FontColor->RGBColor[0.54, 0.35, 0.15]]], "lead"]}], 
        SuperscriptBox[
         RowBox[{"(", 
          RowBox[{"u", "+", 
           SuperscriptBox["u", "3"]}], ")"}], "2"]], "]"}]}], "-", 
     RowBox[{
      FractionBox["1", "9"], " ", 
      RowBox[{"\[DoubleStruckCapitalC]", "[", 
       FractionBox[
        RowBox[{"48", " ", "\[ImaginaryI]", " ", 
         RowBox[{"(", 
          RowBox[{"7", "+", 
           RowBox[{"53", " ", 
            SuperscriptBox["u", "2"]}], "+", 
           RowBox[{"32", " ", 
            SuperscriptBox["u", "4"]}]}], ")"}], " ", 
         SubscriptBox[
          OverscriptBox[
           StyleBox["W",
            FontColor->RGBColor[0.54, 0.35, 0.15]], 
           StyleBox["^",
            FontColor->RGBColor[0.54, 0.35, 0.15]]], "lead"]}], 
        SuperscriptBox[
         RowBox[{"(", 
          RowBox[{"u", "+", 
           SuperscriptBox["u", "3"]}], ")"}], "2"]], "]"}]}], "+", 
     RowBox[{
      FractionBox["2", "9"], " ", 
      RowBox[{"\[DoubleStruckCapitalC]", "[", 
       RowBox[{"-", 
        FractionBox[
         RowBox[{"24", " ", "\[ImaginaryI]", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"-", "6"}], "-", 
            RowBox[{"27", " ", 
             SuperscriptBox["u", "2"]}], "-", 
            RowBox[{"4", " ", 
             SuperscriptBox["u", "4"]}], "+", 
            SuperscriptBox["u", "6"]}], ")"}], " ", 
          SubscriptBox[
           OverscriptBox[
            StyleBox["W",
             FontColor->RGBColor[0.54, 0.35, 0.15]], 
            StyleBox["^",
             FontColor->RGBColor[0.54, 0.35, 0.15]]], "lead"]}], 
         RowBox[{
          SuperscriptBox["u", "2"], " ", 
          SuperscriptBox[
           RowBox[{"(", 
            RowBox[{"1", "+", 
             SuperscriptBox["u", "2"]}], ")"}], "3"]}]]}], "]"}]}], "-", 
     RowBox[{
      FractionBox["5", "9"], " ", 
      RowBox[{"\[DoubleStruckCapitalC]", "[", 
       RowBox[{"-", 
        FractionBox[
         RowBox[{"48", " ", "\[ImaginaryI]", " ", 
          RowBox[{"(", 
           RowBox[{"2", "+", 
            RowBox[{"12", " ", 
             SuperscriptBox["u", "2"]}], "+", 
            RowBox[{"9", " ", 
             SuperscriptBox["u", "4"]}], "+", 
            RowBox[{"3", " ", 
             SuperscriptBox["u", "6"]}]}], ")"}], " ", 
          SubscriptBox[
           OverscriptBox[
            StyleBox["W",
             FontColor->RGBColor[0.54, 0.35, 0.15]], 
            StyleBox["^",
             FontColor->RGBColor[0.54, 0.35, 0.15]]], "lead"]}], 
         RowBox[{
          SuperscriptBox["u", "2"], " ", 
          SuperscriptBox[
           RowBox[{"(", 
            RowBox[{"1", "+", 
             SuperscriptBox["u", "2"]}], ")"}], "3"]}]]}], "]"}]}], "-", 
     RowBox[{
      FractionBox["1", "72"], " ", 
      RowBox[{"\[DoubleStruckCapitalC]", "[", 
       RowBox[{"-", 
        FractionBox[
         RowBox[{"192", " ", "\[ImaginaryI]", " ", 
          RowBox[{"(", 
           RowBox[{"2", "+", 
            RowBox[{"7", " ", 
             SuperscriptBox["u", "2"]}], "-", 
            RowBox[{"4", " ", 
             SuperscriptBox["u", "4"]}], "+", 
            RowBox[{"7", " ", 
             SuperscriptBox["u", "6"]}]}], ")"}], " ", 
          SubscriptBox[
           OverscriptBox[
            StyleBox["W",
             FontColor->RGBColor[0.54, 0.35, 0.15]], 
            StyleBox["^",
             FontColor->RGBColor[0.54, 0.35, 0.15]]], "lead"]}], 
         RowBox[{
          SuperscriptBox["u", "4"], " ", 
          SuperscriptBox[
           RowBox[{"(", 
            RowBox[{"1", "+", 
             SuperscriptBox["u", "2"]}], ")"}], "5"]}]]}], "]"}]}], "+", 
     RowBox[{
      FractionBox["1", "36"], " ", 
      RowBox[{"\[DoubleStruckCapitalC]", "[", 
       RowBox[{"-", 
        FractionBox[
         RowBox[{"96", " ", "\[ImaginaryI]", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"-", "1"}], "-", 
            SuperscriptBox["u", "2"], "+", 
            RowBox[{"15", " ", 
             SuperscriptBox["u", "4"]}], "+", 
            RowBox[{"16", " ", 
             SuperscriptBox["u", "6"]}], "+", 
            RowBox[{"12", " ", 
             SuperscriptBox["u", "8"]}], "+", 
            RowBox[{"3", " ", 
             SuperscriptBox["u", "10"]}]}], ")"}], " ", 
          SubscriptBox[
           OverscriptBox[
            StyleBox["W",
             FontColor->RGBColor[0.54, 0.35, 0.15]], 
            StyleBox["^",
             FontColor->RGBColor[0.54, 0.35, 0.15]]], "lead"]}], 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"u", "+", 
            SuperscriptBox["u", "3"]}], ")"}], "4"]]}], "]"}]}], "+", 
     RowBox[{
      FractionBox["40", "9"], " ", 
      RowBox[{"\[DoubleStruckCapitalC]", "[", 
       RowBox[{"-", 
        FractionBox[
         RowBox[{"4", " ", "\[ImaginaryI]", " ", 
          SubscriptBox[
           OverscriptBox[
            StyleBox["W",
             FontColor->RGBColor[0.54, 0.35, 0.15]], 
            StyleBox["^",
             FontColor->RGBColor[0.54, 0.35, 0.15]]], "lead"]}], 
         RowBox[{"3", " ", 
          SuperscriptBox[
           StyleBox["Q0",
            FontColor->RGBColor[{
               Rational[1, 2], 
               Rational[1, 2], 0}]], "-"], " ", 
          SuperscriptBox[
           StyleBox["Q0",
            FontColor->RGBColor[{
               Rational[1, 2], 
               Rational[1, 2], 0}]], "+"]}]]}], "]"}]}], "-", 
     RowBox[{
      FractionBox["848", "9"], " ", 
      RowBox[{"\[DoubleStruckCapitalC]", "[", 
       RowBox[{"-", 
        FractionBox[
         RowBox[{"\[ImaginaryI]", " ", 
          RowBox[{"(", 
           RowBox[{"1", "+", 
            RowBox[{"3", " ", 
             SuperscriptBox["u", "2"]}]}], ")"}], " ", 
          SubscriptBox[
           OverscriptBox[
            StyleBox["W",
             FontColor->RGBColor[0.54, 0.35, 0.15]], 
            StyleBox["^",
             FontColor->RGBColor[0.54, 0.35, 0.15]]], "lead"]}], 
         RowBox[{"3", " ", 
          SuperscriptBox[
           StyleBox["Q0",
            FontColor->RGBColor[{
               Rational[1, 2], 
               Rational[1, 2], 0}]], "-"], " ", 
          SuperscriptBox[
           StyleBox["Q0",
            FontColor->RGBColor[{
               Rational[1, 2], 
               Rational[1, 2], 0}]], "+"]}]]}], "]"}]}], "-", 
     RowBox[{
      FractionBox["1", "9"], " ", 
      RowBox[{"\[DoubleStruckCapitalC]", "[", 
       FractionBox[
        RowBox[{"16", " ", "\[ImaginaryI]", " ", 
         RowBox[{"(", 
          RowBox[{"6", "+", 
           RowBox[{"25", " ", 
            SuperscriptBox["u", "2"]}], "+", 
           RowBox[{"51", " ", 
            SuperscriptBox["u", "4"]}], "+", 
           RowBox[{"18", " ", 
            SuperscriptBox["u", "6"]}]}], ")"}], " ", 
         SubscriptBox[
          OverscriptBox[
           StyleBox["W",
            FontColor->RGBColor[0.54, 0.35, 0.15]], 
           StyleBox["^",
            FontColor->RGBColor[0.54, 0.35, 0.15]]], "lead"]}], 
        RowBox[{"3", " ", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"1", "+", 
            SuperscriptBox["u", "2"]}], ")"}], "2"], " ", 
         SuperscriptBox[
          StyleBox["Q0",
           FontColor->RGBColor[{
              Rational[1, 2], 
              Rational[1, 2], 0}]], "-"], " ", 
         SuperscriptBox[
          StyleBox["Q0",
           FontColor->RGBColor[{
              Rational[1, 2], 
              Rational[1, 2], 0}]], "+"]}]], "]"}]}], "-", 
     RowBox[{
      FractionBox["1", "36"], " ", 
      RowBox[{"\[DoubleStruckCapitalC]", "[", 
       RowBox[{"-", 
        FractionBox[
         RowBox[{"64", " ", "\[ImaginaryI]", " ", 
          RowBox[{"(", 
           RowBox[{"9", "+", 
            RowBox[{"56", " ", 
             SuperscriptBox["u", "2"]}], "+", 
            RowBox[{"196", " ", 
             SuperscriptBox["u", "4"]}], "+", 
            RowBox[{"183", " ", 
             SuperscriptBox["u", "6"]}], "+", 
            RowBox[{"117", " ", 
             SuperscriptBox["u", "8"]}], "+", 
            RowBox[{"27", " ", 
             SuperscriptBox["u", "10"]}]}], ")"}], " ", 
          SubscriptBox[
           OverscriptBox[
            StyleBox["W",
             FontColor->RGBColor[0.54, 0.35, 0.15]], 
            StyleBox["^",
             FontColor->RGBColor[0.54, 0.35, 0.15]]], "lead"]}], 
         RowBox[{"3", " ", 
          SuperscriptBox[
           RowBox[{"(", 
            RowBox[{"1", "+", 
             SuperscriptBox["u", "2"]}], ")"}], "4"], " ", 
          SuperscriptBox[
           StyleBox["Q0",
            FontColor->RGBColor[{
               Rational[1, 2], 
               Rational[1, 2], 0}]], "-"], " ", 
          SuperscriptBox[
           StyleBox["Q0",
            FontColor->RGBColor[{
               Rational[1, 2], 
               Rational[1, 2], 0}]], "+"]}]]}], "]"}]}], "+", 
     RowBox[{
      FractionBox["4", "3"], " ", 
      RowBox[{"\[DoubleStruckCapitalC]", "[", 
       FractionBox[
        RowBox[{"12", " ", "\[ImaginaryI]", " ", 
         SubscriptBox[
          OverscriptBox[
           StyleBox["W",
            FontColor->RGBColor[0.54, 0.35, 0.15]], 
           StyleBox["^",
            FontColor->RGBColor[0.54, 0.35, 0.15]]], "sublead"]}], 
        RowBox[{"1", "+", 
         SuperscriptBox["u", "2"]}]], "]"}]}], "-", 
     RowBox[{
      FractionBox["4", "9"], " ", 
      RowBox[{"\[DoubleStruckCapitalC]", "[", 
       RowBox[{"-", 
        FractionBox[
         RowBox[{"24", " ", "\[ImaginaryI]", " ", 
          SubscriptBox[
           OverscriptBox[
            StyleBox["W",
             FontColor->RGBColor[0.54, 0.35, 0.15]], 
            StyleBox["^",
             FontColor->RGBColor[0.54, 0.35, 0.15]]], "sublead"]}], 
         RowBox[{"1", "+", 
          SuperscriptBox["u", "2"]}]]}], "]"}]}], "+", 
     RowBox[{
      FractionBox["2", "9"], " ", 
      RowBox[{"\[DoubleStruckCapitalC]", "[", 
       FractionBox[
        RowBox[{"24", " ", "\[ImaginaryI]", " ", 
         RowBox[{"(", 
          RowBox[{"1", "+", 
           RowBox[{"5", " ", 
            SuperscriptBox["u", "2"]}], "+", 
           RowBox[{"2", " ", 
            SuperscriptBox["u", "4"]}]}], ")"}], " ", 
         SubscriptBox[
          OverscriptBox[
           StyleBox["W",
            FontColor->RGBColor[0.54, 0.35, 0.15]], 
           StyleBox["^",
            FontColor->RGBColor[0.54, 0.35, 0.15]]], "sublead"]}], 
        SuperscriptBox[
         RowBox[{"(", 
          RowBox[{"u", "+", 
           SuperscriptBox["u", "3"]}], ")"}], "2"]], "]"}]}], "-", 
     RowBox[{
      FractionBox["1", "9"], " ", 
      RowBox[{"\[DoubleStruckCapitalC]", "[", 
       RowBox[{"-", 
        FractionBox[
         RowBox[{"48", " ", "\[ImaginaryI]", " ", 
          RowBox[{"(", 
           RowBox[{"2", "+", 
            RowBox[{"12", " ", 
             SuperscriptBox["u", "2"]}], "+", 
            RowBox[{"9", " ", 
             SuperscriptBox["u", "4"]}], "+", 
            RowBox[{"3", " ", 
             SuperscriptBox["u", "6"]}]}], ")"}], " ", 
          SubscriptBox[
           OverscriptBox[
            StyleBox["W",
             FontColor->RGBColor[0.54, 0.35, 0.15]], 
            StyleBox["^",
             FontColor->RGBColor[0.54, 0.35, 0.15]]], "sublead"]}], 
         RowBox[{
          SuperscriptBox["u", "2"], " ", 
          SuperscriptBox[
           RowBox[{"(", 
            RowBox[{"1", "+", 
             SuperscriptBox["u", "2"]}], ")"}], "3"]}]]}], "]"}]}], "+", 
     RowBox[{
      FractionBox["32", "3"], " ", 
      RowBox[{"\[DoubleStruckCapitalC]", "[", 
       RowBox[{"-", 
        FractionBox[
         RowBox[{"\[ImaginaryI]", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"4", " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"-", "1"}], "+", 
               RowBox[{"3", " ", 
                SuperscriptBox["u", "2"]}], "+", 
               RowBox[{"27", " ", 
                SuperscriptBox["u", "4"]}]}], ")"}], " ", 
             SubscriptBox[
              OverscriptBox[
               StyleBox["W",
                FontColor->RGBColor[0.54, 0.35, 0.15]], 
               StyleBox["^",
                FontColor->RGBColor[0.54, 0.35, 0.15]]], "lead"]}], "+", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{"1", "+", 
               RowBox[{"6", " ", 
                SuperscriptBox["u", "2"]}], "+", 
               RowBox[{"18", " ", 
                SuperscriptBox["u", "4"]}], "+", 
               RowBox[{"27", " ", 
                SuperscriptBox["u", "6"]}]}], ")"}], " ", 
             SubscriptBox[
              OverscriptBox[
               StyleBox["W",
                FontColor->RGBColor[0.54, 0.35, 0.15]], 
               StyleBox["^",
                FontColor->RGBColor[0.54, 0.35, 0.15]]], "sublead"]}]}], 
           ")"}]}], 
         RowBox[{"27", " ", 
          SuperscriptBox[
           RowBox[{"(", 
            SuperscriptBox[
             StyleBox["Q0",
              FontColor->RGBColor[{
                 Rational[1, 2], 
                 Rational[1, 2], 0}]], "-"], ")"}], "2"], " ", 
          SuperscriptBox[
           RowBox[{"(", 
            SuperscriptBox[
             StyleBox["Q0",
              FontColor->RGBColor[{
                 Rational[1, 2], 
                 Rational[1, 2], 0}]], "+"], ")"}], "2"]}]]}], "]"}]}], "-", 
     RowBox[{
      FractionBox["2", "9"], " ", 
      RowBox[{"\[DoubleStruckCapitalC]", "[", 
       RowBox[{"-", 
        RowBox[{
         FractionBox["1", 
          RowBox[{"27", " ", 
           SuperscriptBox[
            RowBox[{"(", 
             RowBox[{"1", "+", 
              SuperscriptBox["u", "2"]}], ")"}], "4"], " ", 
           SuperscriptBox[
            RowBox[{"(", 
             SuperscriptBox[
              StyleBox["Q0",
               FontColor->RGBColor[{
                  Rational[1, 2], 
                  Rational[1, 2], 0}]], "-"], ")"}], "2"], " ", 
           SuperscriptBox[
            RowBox[{"(", 
             SuperscriptBox[
              StyleBox["Q0",
               FontColor->RGBColor[{
                  Rational[1, 2], 
                  Rational[1, 2], 0}]], "+"], ")"}], "2"]}]], 
         RowBox[{"16", " ", "\[ImaginaryI]", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{
             RowBox[{"(", 
              RowBox[{"22", "+", 
               RowBox[{"56", " ", 
                SuperscriptBox["u", "2"]}], "-", 
               RowBox[{"376", " ", 
                SuperscriptBox["u", "4"]}], "-", 
               RowBox[{"1731", " ", 
                SuperscriptBox["u", "6"]}], "-", 
               RowBox[{"3243", " ", 
                SuperscriptBox["u", "8"]}], "-", 
               RowBox[{"1800", " ", 
                SuperscriptBox["u", "10"]}], "-", 
               RowBox[{"189", " ", 
                SuperscriptBox["u", "12"]}], "+", 
               RowBox[{"81", " ", 
                SuperscriptBox["u", "14"]}]}], ")"}], " ", 
             SubscriptBox[
              OverscriptBox[
               StyleBox["W",
                FontColor->RGBColor[0.54, 0.35, 0.15]], 
               StyleBox["^",
                FontColor->RGBColor[0.54, 0.35, 0.15]]], "lead"]}], "-", 
            RowBox[{"9", " ", 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{"1", "+", 
                SuperscriptBox["u", "2"]}], ")"}], "2"], " ", 
             RowBox[{"(", 
              RowBox[{"6", "+", 
               RowBox[{"25", " ", 
                SuperscriptBox["u", "2"]}], "+", 
               RowBox[{"51", " ", 
                SuperscriptBox["u", "4"]}], "+", 
               RowBox[{"18", " ", 
                SuperscriptBox["u", "6"]}]}], ")"}], " ", 
             SuperscriptBox[
              StyleBox["Q0",
               FontColor->RGBColor[{
                  Rational[1, 2], 
                  Rational[1, 2], 0}]], "-"], " ", 
             SuperscriptBox[
              StyleBox["Q0",
               FontColor->RGBColor[{
                  Rational[1, 2], 
                  Rational[1, 2], 0}]], "+"], " ", 
             SubscriptBox[
              OverscriptBox[
               StyleBox["W",
                FontColor->RGBColor[0.54, 0.35, 0.15]], 
               StyleBox["^",
                FontColor->RGBColor[0.54, 0.35, 0.15]]], "sublead"]}]}], 
           ")"}]}]}]}], "]"}]}], "+", 
     RowBox[{
      FractionBox["2", "9"], " ", 
      RowBox[{"\[DoubleStruckCapitalC]", "[", 
       FractionBox[
        RowBox[{"12", " ", "\[ImaginaryI]", " ", 
         SubscriptBox[
          OverscriptBox[
           StyleBox["W",
            FontColor->RGBColor[0.54, 0.35, 0.15]], 
           StyleBox["^",
            FontColor->RGBColor[0.54, 0.35, 0.15]]], "sublead2"]}], 
        RowBox[{"1", "+", 
         SuperscriptBox["u", "2"]}]], "]"}]}], "+", 
     RowBox[{
      FractionBox["16", "9"], " ", 
      RowBox[{"\[DoubleStruckCapitalC]", "[", 
       RowBox[{"-", 
        RowBox[{
         FractionBox["1", 
          RowBox[{"243", " ", 
           SuperscriptBox[
            RowBox[{"(", 
             SuperscriptBox[
              StyleBox["Q0",
               FontColor->RGBColor[{
                  Rational[1, 2], 
                  Rational[1, 2], 0}]], "-"], ")"}], "3"], " ", 
           SuperscriptBox[
            RowBox[{"(", 
             SuperscriptBox[
              StyleBox["Q0",
               FontColor->RGBColor[{
                  Rational[1, 2], 
                  Rational[1, 2], 0}]], "+"], ")"}], "3"]}]], 
         RowBox[{"\[ImaginaryI]", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"2", " ", 
             RowBox[{"(", 
              RowBox[{"5", "-", 
               RowBox[{"144", " ", 
                SuperscriptBox["u", "2"]}], "-", 
               RowBox[{"351", " ", 
                SuperscriptBox["u", "4"]}], "+", 
               RowBox[{"1404", " ", 
                SuperscriptBox["u", "6"]}], "+", 
               RowBox[{"729", " ", 
                SuperscriptBox["u", "8"]}]}], ")"}], " ", 
             SubscriptBox[
              OverscriptBox[
               StyleBox["W",
                FontColor->RGBColor[0.54, 0.35, 0.15]], 
               StyleBox["^",
                FontColor->RGBColor[0.54, 0.35, 0.15]]], "lead"]}], "+", 
            RowBox[{"9", " ", 
             SuperscriptBox[
              StyleBox["Q0",
               FontColor->RGBColor[{
                  Rational[1, 2], 
                  Rational[1, 2], 0}]], "-"], " ", 
             SuperscriptBox[
              StyleBox["Q0",
               FontColor->RGBColor[{
                  Rational[1, 2], 
                  Rational[1, 2], 0}]], "+"], " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"4", " ", 
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{"-", "1"}], "+", 
                  RowBox[{"3", " ", 
                   SuperscriptBox["u", "2"]}], "+", 
                  RowBox[{"27", " ", 
                   SuperscriptBox["u", "4"]}]}], ")"}], " ", 
                SubscriptBox[
                 OverscriptBox[
                  StyleBox["W",
                   FontColor->RGBColor[0.54, 0.35, 0.15]], 
                  StyleBox["^",
                   FontColor->RGBColor[0.54, 0.35, 0.15]]], "sublead"]}], "+", 
               RowBox[{
                RowBox[{"(", 
                 RowBox[{"1", "+", 
                  RowBox[{"6", " ", 
                   SuperscriptBox["u", "2"]}], "+", 
                  RowBox[{"18", " ", 
                   SuperscriptBox["u", "4"]}], "+", 
                  RowBox[{"27", " ", 
                   SuperscriptBox["u", "6"]}]}], ")"}], " ", 
                SubscriptBox[
                 OverscriptBox[
                  StyleBox["W",
                   FontColor->RGBColor[0.54, 0.35, 0.15]], 
                  StyleBox["^",
                   FontColor->RGBColor[0.54, 0.35, 0.15]]], "sublead2"]}]}], 
              ")"}]}]}], ")"}]}]}]}], "]"}]}], "+", 
     RowBox[{
      FractionBox["4", "9"], " ", 
      RowBox[{"\[DoubleStruckCapitalC]", "[", 
       RowBox[{
        FractionBox["1", 
         RowBox[{"243", " ", 
          SuperscriptBox[
           RowBox[{"(", 
            RowBox[{"1", "+", 
             SuperscriptBox["u", "2"]}], ")"}], "4"], " ", 
          SuperscriptBox[
           RowBox[{"(", 
            SuperscriptBox[
             StyleBox["Q0",
              FontColor->RGBColor[{
                 Rational[1, 2], 
                 Rational[1, 2], 0}]], "-"], ")"}], "3"], " ", 
          SuperscriptBox[
           RowBox[{"(", 
            SuperscriptBox[
             StyleBox["Q0",
              FontColor->RGBColor[{
                 Rational[1, 2], 
                 Rational[1, 2], 0}]], "+"], ")"}], "3"]}]], 
        RowBox[{"4", " ", "\[ImaginaryI]", " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{
            RowBox[{"(", 
             RowBox[{"108", "+", 
              RowBox[{"1142", " ", 
               SuperscriptBox["u", "2"]}], "+", 
              RowBox[{"4615", " ", 
               SuperscriptBox["u", "4"]}], "+", 
              RowBox[{"10277", " ", 
               SuperscriptBox["u", "6"]}], "+", 
              RowBox[{"24092", " ", 
               SuperscriptBox["u", "8"]}], "+", 
              RowBox[{"59418", " ", 
               SuperscriptBox["u", "10"]}], "+", 
              RowBox[{"107406", " ", 
               SuperscriptBox["u", "12"]}], "+", 
              RowBox[{"111726", " ", 
               SuperscriptBox["u", "14"]}], "+", 
              RowBox[{"64395", " ", 
               SuperscriptBox["u", "16"]}], "+", 
              RowBox[{"15309", " ", 
               SuperscriptBox["u", "18"]}]}], ")"}], " ", 
            SubscriptBox[
             OverscriptBox[
              StyleBox["W",
               FontColor->RGBColor[0.54, 0.35, 0.15]], 
              StyleBox["^",
               FontColor->RGBColor[0.54, 0.35, 0.15]]], "lead"]}], "-", 
           RowBox[{"9", " ", 
            SuperscriptBox[
             RowBox[{"(", 
              RowBox[{"1", "+", 
               SuperscriptBox["u", "2"]}], ")"}], "2"], " ", 
            SuperscriptBox[
             StyleBox["Q0",
              FontColor->RGBColor[{
                 Rational[1, 2], 
                 Rational[1, 2], 0}]], "-"], " ", 
            SuperscriptBox[
             StyleBox["Q0",
              FontColor->RGBColor[{
                 Rational[1, 2], 
                 Rational[1, 2], 0}]], "+"], " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{
               RowBox[{"(", 
                RowBox[{"11", "+", 
                 RowBox[{"113", " ", 
                  SuperscriptBox["u", "2"]}], "+", 
                 RowBox[{"434", " ", 
                  SuperscriptBox["u", "4"]}], "+", 
                 RowBox[{"729", " ", 
                  SuperscriptBox["u", "6"]}], "+", 
                 RowBox[{"819", " ", 
                  SuperscriptBox["u", "8"]}], "+", 
                 RowBox[{"324", " ", 
                  SuperscriptBox["u", "10"]}]}], ")"}], " ", 
               SubscriptBox[
                OverscriptBox[
                 StyleBox["W",
                  FontColor->RGBColor[0.54, 0.35, 0.15]], 
                 StyleBox["^",
                  FontColor->RGBColor[0.54, 0.35, 0.15]]], "sublead"]}], "+", 
              
              RowBox[{"9", " ", 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{"1", "+", 
                  SuperscriptBox["u", "2"]}], ")"}], "2"], " ", 
               SuperscriptBox[
                StyleBox["Q0",
                 FontColor->RGBColor[{
                    Rational[1, 2], 
                    Rational[1, 2], 0}]], "-"], " ", 
               SuperscriptBox[
                StyleBox["Q0",
                 FontColor->RGBColor[{
                    Rational[1, 2], 
                    Rational[1, 2], 0}]], "+"], " ", 
               SubscriptBox[
                OverscriptBox[
                 StyleBox["W",
                  FontColor->RGBColor[0.54, 0.35, 0.15]], 
                 StyleBox["^",
                  FontColor->RGBColor[0.54, 0.35, 0.15]]], "sublead2"]}]}], 
             ")"}]}]}], ")"}]}]}], "]"}]}], "+", 
     RowBox[{
      FractionBox["848", "9"], " ", 
      SubscriptBox[
       StyleBox["W",
        FontColor->RGBColor[0.54, 0.35, 0.15]], 
       RowBox[{"1", ",", "v0", ",", "lead"}]]}], "-", 
     RowBox[{
      FractionBox["32", "3"], " ", 
      SubscriptBox[
       StyleBox["W",
        FontColor->RGBColor[0.54, 0.35, 0.15]], 
       RowBox[{"1", ",", "v0", ",", "sublead"}]]}], "-", 
     RowBox[{
      FractionBox["16", "9"], " ", 
      SubscriptBox[
       StyleBox["W",
        FontColor->RGBColor[0.54, 0.35, 0.15]], 
       RowBox[{"1", ",", "v0", ",", "sublead2"}]]}], "+", 
     RowBox[{"135600", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2"]}], "-", 
     RowBox[{"113856", " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2", "2"]}], "-", 
     FractionBox[
      RowBox[{"277184", " ", 
       SubsuperscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "2", "3"]}], "35"], "+", 
     FractionBox[
      RowBox[{"1561472", " ", 
       SubsuperscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "2", "4"]}], "175"], "-", 
     FractionBox[
      RowBox[{"128256", " ", 
       SubsuperscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "2", "5"]}], "175"], "+", 
     RowBox[{"122544", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3"]}], "-", 
     RowBox[{"11520", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3"]}], "+", 
     RowBox[{
      FractionBox["251456", "5"], " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2", "2"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3"]}], "+", 
     RowBox[{
      FractionBox["9216", "7"], " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2", "3"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3"]}], "+", 
     RowBox[{
      FractionBox["20736", "25"], " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2", "4"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3"]}], "-", 
     RowBox[{"80512", " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3", "2"]}], "-", 
     RowBox[{"22272", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2"], " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3", "2"]}], "+", 
     RowBox[{"3456", " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3", "3"]}], "-", 
     RowBox[{"119472", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "5"]}], "+", 
     RowBox[{"17504", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "5"]}], "+", 
     RowBox[{
      FractionBox["704", "5"], " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2", "2"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "5"]}], "-", 
     RowBox[{
      FractionBox["1024", "35"], " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2", "3"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "5"]}], "+", 
     RowBox[{"44160", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "5"]}], "+", 
     RowBox[{"1920", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "5"]}], "+", 
     RowBox[{"352", " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "5", "2"]}], "+", 
     RowBox[{"72960", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "7"]}], "-", 
     RowBox[{"34112", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "7"]}], "-", 
     RowBox[{
      FractionBox["6912", "5"], " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2", "2"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "7"]}], "-", 
     RowBox[{"5824", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "7"]}]}]}], ",", 
   RowBox[{
    RowBox[{
     SubscriptBox["\[Beta]", "sublead2"], "[", "1", "]"}], "\[Rule]", 
    RowBox[{
     RowBox[{"-", "3456"}], "+", 
     RowBox[{
      FractionBox["1", "3"], " ", 
      RowBox[{"\[DoubleStruckCapitalC]", "[", 
       FractionBox[
        RowBox[{"16", " ", "\[ImaginaryI]", " ", 
         SubscriptBox[
          StyleBox["H",
           FontColor->RGBColor[0.54, 0.35, 0.15]], "lead"]}], 
        SuperscriptBox["u", "4"]], "]"}]}], "-", 
     RowBox[{"5", " ", 
      RowBox[{"\[DoubleStruckCapitalC]", "[", 
       RowBox[{"-", 
        FractionBox[
         RowBox[{"8", " ", 
          SubscriptBox[
           StyleBox["H",
            FontColor->RGBColor[0.54, 0.35, 0.15]], "lead"]}], 
         SuperscriptBox["u", "3"]]}], "]"}]}], "+", 
     RowBox[{
      FractionBox["4", "3"], " ", 
      RowBox[{"\[DoubleStruckCapitalC]", "[", 
       FractionBox[
        RowBox[{"4", " ", "\[ImaginaryI]", " ", 
         SubscriptBox[
          StyleBox["H",
           FontColor->RGBColor[0.54, 0.35, 0.15]], "lead"]}], 
        SuperscriptBox["u", "2"]], "]"}]}], "-", 
     RowBox[{
      FractionBox["200", "3"], " ", 
      RowBox[{"\[DoubleStruckCapitalC]", "[", 
       RowBox[{"-", 
        FractionBox[
         RowBox[{"2", " ", 
          SubscriptBox[
           StyleBox["H",
            FontColor->RGBColor[0.54, 0.35, 0.15]], "lead"]}], "u"]}], 
       "]"}]}], "+", 
     RowBox[{
      FractionBox["2", "3"], " ", 
      RowBox[{"\[DoubleStruckCapitalC]", "[", 
       RowBox[{"-", 
        FractionBox[
         RowBox[{"8", " ", 
          SubscriptBox[
           StyleBox["H",
            FontColor->RGBColor[0.54, 0.35, 0.15]], "sublead"]}], 
         SuperscriptBox["u", "3"]]}], "]"}]}], "+", 
     RowBox[{"4", " ", 
      RowBox[{"\[DoubleStruckCapitalC]", "[", 
       RowBox[{"-", 
        FractionBox[
         RowBox[{"2", " ", 
          SubscriptBox[
           StyleBox["H",
            FontColor->RGBColor[0.54, 0.35, 0.15]], "sublead"]}], "u"]}], 
       "]"}]}], "+", 
     RowBox[{
      FractionBox["1", "6"], " ", 
      RowBox[{"\[DoubleStruckCapitalC]", "[", 
       FractionBox[
        RowBox[{"16", " ", "\[ImaginaryI]", " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"2", " ", 
            SubscriptBox[
             StyleBox["H",
              FontColor->RGBColor[0.54, 0.35, 0.15]], "lead"]}], "+", 
           RowBox[{
            SuperscriptBox["u", "2"], " ", 
            SubscriptBox[
             StyleBox["H",
              FontColor->RGBColor[0.54, 0.35, 0.15]], "sublead"]}]}], ")"}]}], 
        SuperscriptBox["u", "6"]], "]"}]}], "-", 
     RowBox[{
      FractionBox["200", "3"], " ", 
      RowBox[{"\[DoubleStruckCapitalC]", "[", 
       RowBox[{"-", 
        FractionBox[
         RowBox[{"4", " ", 
          RowBox[{"(", 
           RowBox[{"\[ImaginaryI]", "+", "u"}], ")"}], " ", 
          SubsuperscriptBox[
           StyleBox["W",
            FontColor->RGBColor[0.54, 0.35, 0.15]], 
           RowBox[{"1", ",", "lead"}], "+"]}], 
         SuperscriptBox[
          StyleBox["Q0",
           FontColor->RGBColor[{
              Rational[1, 2], 
              Rational[1, 2], 0}]], "+"]]}], "]"}]}], "-", 
     RowBox[{"5", " ", 
      RowBox[{"\[DoubleStruckCapitalC]", "[", 
       RowBox[{"-", 
        FractionBox[
         RowBox[{"16", " ", 
          RowBox[{"(", 
           RowBox[{"\[ImaginaryI]", "+", "u"}], ")"}], " ", 
          SubsuperscriptBox[
           StyleBox["W",
            FontColor->RGBColor[0.54, 0.35, 0.15]], 
           RowBox[{"1", ",", "lead"}], "+"]}], 
         RowBox[{
          SuperscriptBox["u", "2"], " ", 
          SuperscriptBox[
           StyleBox["Q0",
            FontColor->RGBColor[{
               Rational[1, 2], 
               Rational[1, 2], 0}]], "+"]}]]}], "]"}]}], "+", 
     RowBox[{"4", " ", 
      RowBox[{"\[DoubleStruckCapitalC]", "[", 
       RowBox[{
        RowBox[{"-", 
         FractionBox[
          RowBox[{"4", " ", 
           SuperscriptBox[
            RowBox[{"(", 
             RowBox[{"\[ImaginaryI]", "+", 
              RowBox[{"2", " ", "u"}]}], ")"}], "2"], " ", 
           RowBox[{"(", 
            RowBox[{"1", "+", 
             RowBox[{"\[ImaginaryI]", " ", "u"}], "+", 
             SuperscriptBox["u", "2"]}], ")"}], " ", 
           SubsuperscriptBox[
            StyleBox["W",
             FontColor->RGBColor[0.54, 0.35, 0.15]], 
            RowBox[{"1", ",", "lead"}], "+"]}], 
          RowBox[{"3", " ", 
           SuperscriptBox["u", "2"], " ", 
           RowBox[{"(", 
            RowBox[{"\[ImaginaryI]", "+", "u"}], ")"}], " ", 
           SuperscriptBox[
            RowBox[{"(", 
             SuperscriptBox[
              StyleBox["Q0",
               FontColor->RGBColor[{
                  Rational[1, 2], 
                  Rational[1, 2], 0}]], "+"], ")"}], "2"]}]]}], "-", 
        FractionBox[
         RowBox[{"4", " ", 
          RowBox[{"(", 
           RowBox[{"\[ImaginaryI]", "+", "u"}], ")"}], " ", 
          SubsuperscriptBox[
           StyleBox["W",
            FontColor->RGBColor[0.54, 0.35, 0.15]], 
           RowBox[{"1", ",", "sublead"}], "+"]}], 
         SuperscriptBox[
          StyleBox["Q0",
           FontColor->RGBColor[{
              Rational[1, 2], 
              Rational[1, 2], 0}]], "+"]]}], "]"}]}], "+", 
     RowBox[{
      FractionBox["2", "3"], " ", 
      RowBox[{"\[DoubleStruckCapitalC]", "[", 
       RowBox[{"-", 
        FractionBox[
         RowBox[{"16", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{"\[ImaginaryI]", "+", 
                RowBox[{"2", " ", "u"}]}], ")"}], "2"], " ", 
             RowBox[{"(", 
              RowBox[{"1", "+", 
               RowBox[{"\[ImaginaryI]", " ", "u"}], "+", 
               SuperscriptBox["u", "2"]}], ")"}], " ", 
             SubsuperscriptBox[
              StyleBox["W",
               FontColor->RGBColor[0.54, 0.35, 0.15]], 
              RowBox[{"1", ",", "lead"}], "+"]}], "+", 
            RowBox[{"3", " ", 
             SuperscriptBox["u", "2"], " ", 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{"\[ImaginaryI]", "+", "u"}], ")"}], "2"], " ", 
             SuperscriptBox[
              StyleBox["Q0",
               FontColor->RGBColor[{
                  Rational[1, 2], 
                  Rational[1, 2], 0}]], "+"], " ", 
             SubsuperscriptBox[
              StyleBox["W",
               FontColor->RGBColor[0.54, 0.35, 0.15]], 
              RowBox[{"1", ",", "sublead"}], "+"]}]}], ")"}]}], 
         RowBox[{"3", " ", 
          SuperscriptBox["u", "4"], " ", 
          RowBox[{"(", 
           RowBox[{"\[ImaginaryI]", "+", "u"}], ")"}], " ", 
          SuperscriptBox[
           RowBox[{"(", 
            SuperscriptBox[
             StyleBox["Q0",
              FontColor->RGBColor[{
                 Rational[1, 2], 
                 Rational[1, 2], 0}]], "+"], ")"}], "2"]}]]}], "]"}]}], "-", 
     RowBox[{
      FractionBox["4", "3"], " ", 
      RowBox[{"\[DoubleStruckCapitalC]", "[", 
       FractionBox[
        RowBox[{"12", " ", "\[ImaginaryI]", " ", 
         SubscriptBox[
          OverscriptBox[
           StyleBox["W",
            FontColor->RGBColor[0.54, 0.35, 0.15]], 
           StyleBox["^",
            FontColor->RGBColor[0.54, 0.35, 0.15]]], "lead"]}], 
        RowBox[{"1", "+", 
         SuperscriptBox["u", "2"]}]], "]"}]}], "-", 
     RowBox[{"4", " ", 
      RowBox[{"\[DoubleStruckCapitalC]", "[", 
       RowBox[{"-", 
        FractionBox[
         RowBox[{"24", " ", "\[ImaginaryI]", " ", 
          SubscriptBox[
           OverscriptBox[
            StyleBox["W",
             FontColor->RGBColor[0.54, 0.35, 0.15]], 
            StyleBox["^",
             FontColor->RGBColor[0.54, 0.35, 0.15]]], "lead"]}], 
         RowBox[{"1", "+", 
          SuperscriptBox["u", "2"]}]]}], "]"}]}], "+", 
     RowBox[{"5", " ", 
      RowBox[{"\[DoubleStruckCapitalC]", "[", 
       FractionBox[
        RowBox[{"24", " ", "\[ImaginaryI]", " ", 
         RowBox[{"(", 
          RowBox[{"1", "+", 
           RowBox[{"5", " ", 
            SuperscriptBox["u", "2"]}], "+", 
           RowBox[{"2", " ", 
            SuperscriptBox["u", "4"]}]}], ")"}], " ", 
         SubscriptBox[
          OverscriptBox[
           StyleBox["W",
            FontColor->RGBColor[0.54, 0.35, 0.15]], 
           StyleBox["^",
            FontColor->RGBColor[0.54, 0.35, 0.15]]], "lead"]}], 
        SuperscriptBox[
         RowBox[{"(", 
          RowBox[{"u", "+", 
           SuperscriptBox["u", "3"]}], ")"}], "2"]], "]"}]}], "-", 
     RowBox[{
      FractionBox["1", "6"], " ", 
      RowBox[{"\[DoubleStruckCapitalC]", "[", 
       FractionBox[
        RowBox[{"48", " ", "\[ImaginaryI]", " ", 
         RowBox[{"(", 
          RowBox[{"7", "+", 
           RowBox[{"53", " ", 
            SuperscriptBox["u", "2"]}], "+", 
           RowBox[{"32", " ", 
            SuperscriptBox["u", "4"]}]}], ")"}], " ", 
         SubscriptBox[
          OverscriptBox[
           StyleBox["W",
            FontColor->RGBColor[0.54, 0.35, 0.15]], 
           StyleBox["^",
            FontColor->RGBColor[0.54, 0.35, 0.15]]], "lead"]}], 
        SuperscriptBox[
         RowBox[{"(", 
          RowBox[{"u", "+", 
           SuperscriptBox["u", "3"]}], ")"}], "2"]], "]"}]}], "-", 
     RowBox[{
      FractionBox["2", "3"], " ", 
      RowBox[{"\[DoubleStruckCapitalC]", "[", 
       RowBox[{"-", 
        FractionBox[
         RowBox[{"24", " ", "\[ImaginaryI]", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"-", "6"}], "-", 
            RowBox[{"27", " ", 
             SuperscriptBox["u", "2"]}], "-", 
            RowBox[{"4", " ", 
             SuperscriptBox["u", "4"]}], "+", 
            SuperscriptBox["u", "6"]}], ")"}], " ", 
          SubscriptBox[
           OverscriptBox[
            StyleBox["W",
             FontColor->RGBColor[0.54, 0.35, 0.15]], 
            StyleBox["^",
             FontColor->RGBColor[0.54, 0.35, 0.15]]], "lead"]}], 
         RowBox[{
          SuperscriptBox["u", "2"], " ", 
          SuperscriptBox[
           RowBox[{"(", 
            RowBox[{"1", "+", 
             SuperscriptBox["u", "2"]}], ")"}], "3"]}]]}], "]"}]}], "-", 
     RowBox[{
      FractionBox["1", "3"], " ", 
      RowBox[{"\[DoubleStruckCapitalC]", "[", 
       RowBox[{"-", 
        FractionBox[
         RowBox[{"48", " ", "\[ImaginaryI]", " ", 
          RowBox[{"(", 
           RowBox[{"2", "+", 
            RowBox[{"12", " ", 
             SuperscriptBox["u", "2"]}], "+", 
            RowBox[{"9", " ", 
             SuperscriptBox["u", "4"]}], "+", 
            RowBox[{"3", " ", 
             SuperscriptBox["u", "6"]}]}], ")"}], " ", 
          SubscriptBox[
           OverscriptBox[
            StyleBox["W",
             FontColor->RGBColor[0.54, 0.35, 0.15]], 
            StyleBox["^",
             FontColor->RGBColor[0.54, 0.35, 0.15]]], "lead"]}], 
         RowBox[{
          SuperscriptBox["u", "2"], " ", 
          SuperscriptBox[
           RowBox[{"(", 
            RowBox[{"1", "+", 
             SuperscriptBox["u", "2"]}], ")"}], "3"]}]]}], "]"}]}], "-", 
     RowBox[{
      FractionBox["200", "3"], " ", 
      RowBox[{"\[DoubleStruckCapitalC]", "[", 
       RowBox[{"-", 
        FractionBox[
         RowBox[{"4", " ", "\[ImaginaryI]", " ", 
          SubscriptBox[
           OverscriptBox[
            StyleBox["W",
             FontColor->RGBColor[0.54, 0.35, 0.15]], 
            StyleBox["^",
             FontColor->RGBColor[0.54, 0.35, 0.15]]], "lead"]}], 
         RowBox[{"3", " ", 
          SuperscriptBox[
           StyleBox["Q0",
            FontColor->RGBColor[{
               Rational[1, 2], 
               Rational[1, 2], 0}]], "-"], " ", 
          SuperscriptBox[
           StyleBox["Q0",
            FontColor->RGBColor[{
               Rational[1, 2], 
               Rational[1, 2], 0}]], "+"]}]]}], "]"}]}], "-", 
     RowBox[{
      FractionBox["1328", "3"], " ", 
      RowBox[{"\[DoubleStruckCapitalC]", "[", 
       RowBox[{"-", 
        FractionBox[
         RowBox[{"\[ImaginaryI]", " ", 
          RowBox[{"(", 
           RowBox[{"1", "+", 
            RowBox[{"3", " ", 
             SuperscriptBox["u", "2"]}]}], ")"}], " ", 
          SubscriptBox[
           OverscriptBox[
            StyleBox["W",
             FontColor->RGBColor[0.54, 0.35, 0.15]], 
            StyleBox["^",
             FontColor->RGBColor[0.54, 0.35, 0.15]]], "lead"]}], 
         RowBox[{"3", " ", 
          SuperscriptBox[
           StyleBox["Q0",
            FontColor->RGBColor[{
               Rational[1, 2], 
               Rational[1, 2], 0}]], "-"], " ", 
          SuperscriptBox[
           StyleBox["Q0",
            FontColor->RGBColor[{
               Rational[1, 2], 
               Rational[1, 2], 0}]], "+"]}]]}], "]"}]}], "-", 
     RowBox[{"5", " ", 
      RowBox[{"\[DoubleStruckCapitalC]", "[", 
       FractionBox[
        RowBox[{"16", " ", "\[ImaginaryI]", " ", 
         RowBox[{"(", 
          RowBox[{"6", "+", 
           RowBox[{"25", " ", 
            SuperscriptBox["u", "2"]}], "+", 
           RowBox[{"51", " ", 
            SuperscriptBox["u", "4"]}], "+", 
           RowBox[{"18", " ", 
            SuperscriptBox["u", "6"]}]}], ")"}], " ", 
         SubscriptBox[
          OverscriptBox[
           StyleBox["W",
            FontColor->RGBColor[0.54, 0.35, 0.15]], 
           StyleBox["^",
            FontColor->RGBColor[0.54, 0.35, 0.15]]], "lead"]}], 
        RowBox[{"3", " ", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"1", "+", 
            SuperscriptBox["u", "2"]}], ")"}], "2"], " ", 
         SuperscriptBox[
          StyleBox["Q0",
           FontColor->RGBColor[{
              Rational[1, 2], 
              Rational[1, 2], 0}]], "-"], " ", 
         SuperscriptBox[
          StyleBox["Q0",
           FontColor->RGBColor[{
              Rational[1, 2], 
              Rational[1, 2], 0}]], "+"]}]], "]"}]}], "-", 
     RowBox[{
      FractionBox["2", "3"], " ", 
      RowBox[{"\[DoubleStruckCapitalC]", "[", 
       FractionBox[
        RowBox[{"24", " ", "\[ImaginaryI]", " ", 
         RowBox[{"(", 
          RowBox[{"1", "+", 
           RowBox[{"5", " ", 
            SuperscriptBox["u", "2"]}], "+", 
           RowBox[{"2", " ", 
            SuperscriptBox["u", "4"]}]}], ")"}], " ", 
         SubscriptBox[
          OverscriptBox[
           StyleBox["W",
            FontColor->RGBColor[0.54, 0.35, 0.15]], 
           StyleBox["^",
            FontColor->RGBColor[0.54, 0.35, 0.15]]], "sublead"]}], 
        SuperscriptBox[
         RowBox[{"(", 
          RowBox[{"u", "+", 
           SuperscriptBox["u", "3"]}], ")"}], "2"]], "]"}]}], "-", 
     RowBox[{
      FractionBox["1", "6"], " ", 
      RowBox[{"\[DoubleStruckCapitalC]", "[", 
       RowBox[{"-", 
        FractionBox[
         RowBox[{"48", " ", "\[ImaginaryI]", " ", 
          RowBox[{"(", 
           RowBox[{"2", "+", 
            RowBox[{"12", " ", 
             SuperscriptBox["u", "2"]}], "+", 
            RowBox[{"9", " ", 
             SuperscriptBox["u", "4"]}], "+", 
            RowBox[{"3", " ", 
             SuperscriptBox["u", "6"]}]}], ")"}], " ", 
          SubscriptBox[
           OverscriptBox[
            StyleBox["W",
             FontColor->RGBColor[0.54, 0.35, 0.15]], 
            StyleBox["^",
             FontColor->RGBColor[0.54, 0.35, 0.15]]], "sublead"]}], 
         RowBox[{
          SuperscriptBox["u", "2"], " ", 
          SuperscriptBox[
           RowBox[{"(", 
            RowBox[{"1", "+", 
             SuperscriptBox["u", "2"]}], ")"}], "3"]}]]}], "]"}]}], "+", 
     RowBox[{"48", " ", 
      RowBox[{"\[DoubleStruckCapitalC]", "[", 
       RowBox[{"-", 
        FractionBox[
         RowBox[{"\[ImaginaryI]", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"4", " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"-", "1"}], "+", 
               RowBox[{"3", " ", 
                SuperscriptBox["u", "2"]}], "+", 
               RowBox[{"27", " ", 
                SuperscriptBox["u", "4"]}]}], ")"}], " ", 
             SubscriptBox[
              OverscriptBox[
               StyleBox["W",
                FontColor->RGBColor[0.54, 0.35, 0.15]], 
               StyleBox["^",
                FontColor->RGBColor[0.54, 0.35, 0.15]]], "lead"]}], "+", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{"1", "+", 
               RowBox[{"6", " ", 
                SuperscriptBox["u", "2"]}], "+", 
               RowBox[{"18", " ", 
                SuperscriptBox["u", "4"]}], "+", 
               RowBox[{"27", " ", 
                SuperscriptBox["u", "6"]}]}], ")"}], " ", 
             SubscriptBox[
              OverscriptBox[
               StyleBox["W",
                FontColor->RGBColor[0.54, 0.35, 0.15]], 
               StyleBox["^",
                FontColor->RGBColor[0.54, 0.35, 0.15]]], "sublead"]}]}], 
           ")"}]}], 
         RowBox[{"27", " ", 
          SuperscriptBox[
           RowBox[{"(", 
            SuperscriptBox[
             StyleBox["Q0",
              FontColor->RGBColor[{
                 Rational[1, 2], 
                 Rational[1, 2], 0}]], "-"], ")"}], "2"], " ", 
          SuperscriptBox[
           RowBox[{"(", 
            SuperscriptBox[
             StyleBox["Q0",
              FontColor->RGBColor[{
                 Rational[1, 2], 
                 Rational[1, 2], 0}]], "+"], ")"}], "2"]}]]}], "]"}]}], "+", 
     RowBox[{"4", " ", 
      RowBox[{"\[DoubleStruckCapitalC]", "[", 
       RowBox[{"-", 
        FractionBox[
         RowBox[{"4", " ", "\[ImaginaryI]", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{
             RowBox[{"(", 
              RowBox[{"11", "+", 
               RowBox[{"113", " ", 
                SuperscriptBox["u", "2"]}], "+", 
               RowBox[{"434", " ", 
                SuperscriptBox["u", "4"]}], "+", 
               RowBox[{"729", " ", 
                SuperscriptBox["u", "6"]}], "+", 
               RowBox[{"819", " ", 
                SuperscriptBox["u", "8"]}], "+", 
               RowBox[{"324", " ", 
                SuperscriptBox["u", "10"]}]}], ")"}], " ", 
             SubscriptBox[
              OverscriptBox[
               StyleBox["W",
                FontColor->RGBColor[0.54, 0.35, 0.15]], 
               StyleBox["^",
                FontColor->RGBColor[0.54, 0.35, 0.15]]], "lead"]}], "+", 
            RowBox[{"9", " ", 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{"1", "+", 
                SuperscriptBox["u", "2"]}], ")"}], "2"], " ", 
             SuperscriptBox[
              StyleBox["Q0",
               FontColor->RGBColor[{
                  Rational[1, 2], 
                  Rational[1, 2], 0}]], "-"], " ", 
             SuperscriptBox[
              StyleBox["Q0",
               FontColor->RGBColor[{
                  Rational[1, 2], 
                  Rational[1, 2], 0}]], "+"], " ", 
             SubscriptBox[
              OverscriptBox[
               StyleBox["W",
                FontColor->RGBColor[0.54, 0.35, 0.15]], 
               StyleBox["^",
                FontColor->RGBColor[0.54, 0.35, 0.15]]], "sublead"]}]}], 
           ")"}]}], 
         RowBox[{"27", " ", 
          SuperscriptBox[
           RowBox[{"(", 
            RowBox[{"1", "+", 
             SuperscriptBox["u", "2"]}], ")"}], "2"], " ", 
          SuperscriptBox[
           RowBox[{"(", 
            SuperscriptBox[
             StyleBox["Q0",
              FontColor->RGBColor[{
                 Rational[1, 2], 
                 Rational[1, 2], 0}]], "-"], ")"}], "2"], " ", 
          SuperscriptBox[
           RowBox[{"(", 
            SuperscriptBox[
             StyleBox["Q0",
              FontColor->RGBColor[{
                 Rational[1, 2], 
                 Rational[1, 2], 0}]], "+"], ")"}], "2"]}]]}], "]"}]}], "+", 
     RowBox[{
      FractionBox["2", "3"], " ", 
      RowBox[{"\[DoubleStruckCapitalC]", "[", 
       RowBox[{"-", 
        RowBox[{
         FractionBox["1", 
          RowBox[{"27", " ", 
           SuperscriptBox[
            RowBox[{"(", 
             RowBox[{"1", "+", 
              SuperscriptBox["u", "2"]}], ")"}], "4"], " ", 
           SuperscriptBox[
            RowBox[{"(", 
             SuperscriptBox[
              StyleBox["Q0",
               FontColor->RGBColor[{
                  Rational[1, 2], 
                  Rational[1, 2], 0}]], "-"], ")"}], "2"], " ", 
           SuperscriptBox[
            RowBox[{"(", 
             SuperscriptBox[
              StyleBox["Q0",
               FontColor->RGBColor[{
                  Rational[1, 2], 
                  Rational[1, 2], 0}]], "+"], ")"}], "2"]}]], 
         RowBox[{"16", " ", "\[ImaginaryI]", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{
             RowBox[{"(", 
              RowBox[{"22", "+", 
               RowBox[{"56", " ", 
                SuperscriptBox["u", "2"]}], "-", 
               RowBox[{"376", " ", 
                SuperscriptBox["u", "4"]}], "-", 
               RowBox[{"1731", " ", 
                SuperscriptBox["u", "6"]}], "-", 
               RowBox[{"3243", " ", 
                SuperscriptBox["u", "8"]}], "-", 
               RowBox[{"1800", " ", 
                SuperscriptBox["u", "10"]}], "-", 
               RowBox[{"189", " ", 
                SuperscriptBox["u", "12"]}], "+", 
               RowBox[{"81", " ", 
                SuperscriptBox["u", "14"]}]}], ")"}], " ", 
             SubscriptBox[
              OverscriptBox[
               StyleBox["W",
                FontColor->RGBColor[0.54, 0.35, 0.15]], 
               StyleBox["^",
                FontColor->RGBColor[0.54, 0.35, 0.15]]], "lead"]}], "-", 
            RowBox[{"9", " ", 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{"1", "+", 
                SuperscriptBox["u", "2"]}], ")"}], "2"], " ", 
             RowBox[{"(", 
              RowBox[{"6", "+", 
               RowBox[{"25", " ", 
                SuperscriptBox["u", "2"]}], "+", 
               RowBox[{"51", " ", 
                SuperscriptBox["u", "4"]}], "+", 
               RowBox[{"18", " ", 
                SuperscriptBox["u", "6"]}]}], ")"}], " ", 
             SuperscriptBox[
              StyleBox["Q0",
               FontColor->RGBColor[{
                  Rational[1, 2], 
                  Rational[1, 2], 0}]], "-"], " ", 
             SuperscriptBox[
              StyleBox["Q0",
               FontColor->RGBColor[{
                  Rational[1, 2], 
                  Rational[1, 2], 0}]], "+"], " ", 
             SubscriptBox[
              OverscriptBox[
               StyleBox["W",
                FontColor->RGBColor[0.54, 0.35, 0.15]], 
               StyleBox["^",
                FontColor->RGBColor[0.54, 0.35, 0.15]]], "sublead"]}]}], 
           ")"}]}]}]}], "]"}]}], "+", 
     RowBox[{
      FractionBox["1328", "3"], " ", 
      SubscriptBox[
       StyleBox["W",
        FontColor->RGBColor[0.54, 0.35, 0.15]], 
       RowBox[{"1", ",", "v0", ",", "lead"}]]}], "-", 
     RowBox[{"48", " ", 
      SubscriptBox[
       StyleBox["W",
        FontColor->RGBColor[0.54, 0.35, 0.15]], 
       RowBox[{"1", ",", "v0", ",", "sublead"}]]}], "-", 
     RowBox[{"13968", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2"]}], "+", 
     FractionBox[
      RowBox[{"449856", " ", 
       SubsuperscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "2", "2"]}], "5"], "-", 
     FractionBox[
      RowBox[{"927168", " ", 
       SubsuperscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "2", "3"]}], "35"], "-", 
     FractionBox[
      RowBox[{"1466496", " ", 
       SubsuperscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "2", "4"]}], "175"], "+", 
     FractionBox[
      RowBox[{"270336", " ", 
       SubsuperscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "2", "5"]}], "175"], "-", 
     RowBox[{"37584", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3"]}], "-", 
     RowBox[{"17760", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3"]}], "+", 
     RowBox[{
      FractionBox["24576", "5"], " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2", "2"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3"]}], "+", 
     RowBox[{
      FractionBox["39936", "35"], " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2", "3"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3"]}], "+", 
     RowBox[{
      FractionBox["27648", "25"], " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2", "4"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3"]}], "-", 
     RowBox[{"11424", " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3", "2"]}], "+", 
     RowBox[{"5184", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2"], " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3", "2"]}], "-", 
     RowBox[{
      FractionBox["1152", "5"], " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2", "2"], " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3", "2"]}], "+", 
     RowBox[{"2304", " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3", "3"]}], "+", 
     RowBox[{"9648", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "5"]}], "-", 
     RowBox[{"17184", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "5"]}], "-", 
     RowBox[{
      FractionBox["27648", "5"], " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2", "2"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "5"]}], "-", 
     RowBox[{
      FractionBox["4608", "35"], " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2", "3"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "5"]}], "+", 
     RowBox[{"28608", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "5"]}], "-", 
     RowBox[{"6912", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "5"]}], "+", 
     RowBox[{"6528", " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "5", "2"]}], "-", 
     RowBox[{"83376", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "7"]}], "+", 
     RowBox[{"37728", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "7"]}], "-", 
     RowBox[{
      FractionBox["5184", "5"], " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2", "2"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "7"]}], "+", 
     RowBox[{"20160", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "7"]}]}]}], ",", 
   RowBox[{
    RowBox[{
     SubscriptBox["\[Alpha]", "sublead2"], "[", "2", "]"}], "\[Rule]", 
    RowBox[{"320832", "+", 
     RowBox[{
      FractionBox["1", "9"], " ", 
      RowBox[{"\[DoubleStruckCapitalC]", "[", 
       FractionBox[
        RowBox[{"64", " ", "\[ImaginaryI]", " ", 
         SubscriptBox[
          StyleBox["H",
           FontColor->RGBColor[0.54, 0.35, 0.15]], "lead"]}], 
        SuperscriptBox["u", "6"]], "]"}]}], "-", 
     RowBox[{
      FractionBox["2", "9"], " ", 
      RowBox[{"\[DoubleStruckCapitalC]", "[", 
       RowBox[{"-", 
        FractionBox[
         RowBox[{"32", " ", 
          SubscriptBox[
           StyleBox["H",
            FontColor->RGBColor[0.54, 0.35, 0.15]], "lead"]}], 
         SuperscriptBox["u", "5"]]}], "]"}]}], "-", 
     RowBox[{
      FractionBox["4", "3"], " ", 
      RowBox[{"\[DoubleStruckCapitalC]", "[", 
       FractionBox[
        RowBox[{"16", " ", "\[ImaginaryI]", " ", 
         SubscriptBox[
          StyleBox["H",
           FontColor->RGBColor[0.54, 0.35, 0.15]], "lead"]}], 
        SuperscriptBox["u", "4"]], "]"}]}], "+", 
     RowBox[{
      FractionBox["4", "9"], " ", 
      RowBox[{"\[DoubleStruckCapitalC]", "[", 
       RowBox[{"-", 
        FractionBox[
         RowBox[{"8", " ", 
          SubscriptBox[
           StyleBox["H",
            FontColor->RGBColor[0.54, 0.35, 0.15]], "lead"]}], 
         SuperscriptBox["u", "3"]]}], "]"}]}], "+", 
     RowBox[{
      FractionBox["8", "9"], " ", 
      RowBox[{"\[DoubleStruckCapitalC]", "[", 
       FractionBox[
        RowBox[{"4", " ", "\[ImaginaryI]", " ", 
         SubscriptBox[
          StyleBox["H",
           FontColor->RGBColor[0.54, 0.35, 0.15]], "lead"]}], 
        SuperscriptBox["u", "2"]], "]"}]}], "+", 
     RowBox[{
      FractionBox["32", "9"], " ", 
      RowBox[{"\[DoubleStruckCapitalC]", "[", 
       RowBox[{"-", 
        FractionBox[
         RowBox[{"2", " ", 
          SubscriptBox[
           StyleBox["H",
            FontColor->RGBColor[0.54, 0.35, 0.15]], "lead"]}], "u"]}], 
       "]"}]}], "+", 
     RowBox[{
      FractionBox["4", "9"], " ", 
      RowBox[{"\[DoubleStruckCapitalC]", "[", 
       RowBox[{"-", 
        FractionBox[
         RowBox[{"8", " ", 
          SubscriptBox[
           StyleBox["H",
            FontColor->RGBColor[0.54, 0.35, 0.15]], "sublead"]}], 
         SuperscriptBox["u", "3"]]}], "]"}]}], "-", 
     RowBox[{
      FractionBox["2", "9"], " ", 
      RowBox[{"\[DoubleStruckCapitalC]", "[", 
       FractionBox[
        RowBox[{"16", " ", "\[ImaginaryI]", " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"2", " ", 
            SubscriptBox[
             StyleBox["H",
              FontColor->RGBColor[0.54, 0.35, 0.15]], "lead"]}], "+", 
           RowBox[{
            SuperscriptBox["u", "2"], " ", 
            SubscriptBox[
             StyleBox["H",
              FontColor->RGBColor[0.54, 0.35, 0.15]], "sublead"]}]}], ")"}]}], 
        SuperscriptBox["u", "6"]], "]"}]}], "+", 
     RowBox[{
      FractionBox["32", "9"], " ", 
      RowBox[{"\[DoubleStruckCapitalC]", "[", 
       RowBox[{"-", 
        FractionBox[
         RowBox[{"4", " ", 
          RowBox[{"(", 
           RowBox[{"\[ImaginaryI]", "+", "u"}], ")"}], " ", 
          SubsuperscriptBox[
           StyleBox["W",
            FontColor->RGBColor[0.54, 0.35, 0.15]], 
           RowBox[{"1", ",", "lead"}], "+"]}], 
         SuperscriptBox[
          StyleBox["Q0",
           FontColor->RGBColor[{
              Rational[1, 2], 
              Rational[1, 2], 0}]], "+"]]}], "]"}]}], "-", 
     RowBox[{
      FractionBox["2", "9"], " ", 
      RowBox[{"\[DoubleStruckCapitalC]", "[", 
       RowBox[{"-", 
        FractionBox[
         RowBox[{"64", " ", 
          RowBox[{"(", 
           RowBox[{"\[ImaginaryI]", "+", "u"}], ")"}], " ", 
          SubsuperscriptBox[
           StyleBox["W",
            FontColor->RGBColor[0.54, 0.35, 0.15]], 
           RowBox[{"1", ",", "lead"}], "+"]}], 
         RowBox[{
          SuperscriptBox["u", "4"], " ", 
          SuperscriptBox[
           StyleBox["Q0",
            FontColor->RGBColor[{
               Rational[1, 2], 
               Rational[1, 2], 0}]], "+"]}]]}], "]"}]}], "+", 
     RowBox[{
      FractionBox["4", "9"], " ", 
      RowBox[{"\[DoubleStruckCapitalC]", "[", 
       RowBox[{"-", 
        FractionBox[
         RowBox[{"16", " ", 
          RowBox[{"(", 
           RowBox[{"\[ImaginaryI]", "+", "u"}], ")"}], " ", 
          SubsuperscriptBox[
           StyleBox["W",
            FontColor->RGBColor[0.54, 0.35, 0.15]], 
           RowBox[{"1", ",", "lead"}], "+"]}], 
         RowBox[{
          SuperscriptBox["u", "2"], " ", 
          SuperscriptBox[
           StyleBox["Q0",
            FontColor->RGBColor[{
               Rational[1, 2], 
               Rational[1, 2], 0}]], "+"]}]]}], "]"}]}], "+", 
     RowBox[{
      FractionBox["4", "9"], " ", 
      RowBox[{"\[DoubleStruckCapitalC]", "[", 
       RowBox[{"-", 
        FractionBox[
         RowBox[{"16", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{"\[ImaginaryI]", "+", 
                RowBox[{"2", " ", "u"}]}], ")"}], "2"], " ", 
             RowBox[{"(", 
              RowBox[{"1", "+", 
               RowBox[{"\[ImaginaryI]", " ", "u"}], "+", 
               SuperscriptBox["u", "2"]}], ")"}], " ", 
             SubsuperscriptBox[
              StyleBox["W",
               FontColor->RGBColor[0.54, 0.35, 0.15]], 
              RowBox[{"1", ",", "lead"}], "+"]}], "+", 
            RowBox[{"3", " ", 
             SuperscriptBox["u", "2"], " ", 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{"\[ImaginaryI]", "+", "u"}], ")"}], "2"], " ", 
             SuperscriptBox[
              StyleBox["Q0",
               FontColor->RGBColor[{
                  Rational[1, 2], 
                  Rational[1, 2], 0}]], "+"], " ", 
             SubsuperscriptBox[
              StyleBox["W",
               FontColor->RGBColor[0.54, 0.35, 0.15]], 
              RowBox[{"1", ",", "sublead"}], "+"]}]}], ")"}]}], 
         RowBox[{"3", " ", 
          SuperscriptBox["u", "4"], " ", 
          RowBox[{"(", 
           RowBox[{"\[ImaginaryI]", "+", "u"}], ")"}], " ", 
          SuperscriptBox[
           RowBox[{"(", 
            SuperscriptBox[
             StyleBox["Q0",
              FontColor->RGBColor[{
                 Rational[1, 2], 
                 Rational[1, 2], 0}]], "+"], ")"}], "2"]}]]}], "]"}]}], "-", 
     RowBox[{
      FractionBox["8", "9"], " ", 
      RowBox[{"\[DoubleStruckCapitalC]", "[", 
       FractionBox[
        RowBox[{"12", " ", "\[ImaginaryI]", " ", 
         SubscriptBox[
          OverscriptBox[
           StyleBox["W",
            FontColor->RGBColor[0.54, 0.35, 0.15]], 
           StyleBox["^",
            FontColor->RGBColor[0.54, 0.35, 0.15]]], "lead"]}], 
        RowBox[{"1", "+", 
         SuperscriptBox["u", "2"]}]], "]"}]}], "-", 
     RowBox[{
      FractionBox["4", "9"], " ", 
      RowBox[{"\[DoubleStruckCapitalC]", "[", 
       FractionBox[
        RowBox[{"24", " ", "\[ImaginaryI]", " ", 
         RowBox[{"(", 
          RowBox[{"1", "+", 
           RowBox[{"5", " ", 
            SuperscriptBox["u", "2"]}], "+", 
           RowBox[{"2", " ", 
            SuperscriptBox["u", "4"]}]}], ")"}], " ", 
         SubscriptBox[
          OverscriptBox[
           StyleBox["W",
            FontColor->RGBColor[0.54, 0.35, 0.15]], 
           StyleBox["^",
            FontColor->RGBColor[0.54, 0.35, 0.15]]], "lead"]}], 
        SuperscriptBox[
         RowBox[{"(", 
          RowBox[{"u", "+", 
           SuperscriptBox["u", "3"]}], ")"}], "2"]], "]"}]}], "+", 
     RowBox[{
      FractionBox["2", "9"], " ", 
      RowBox[{"\[DoubleStruckCapitalC]", "[", 
       FractionBox[
        RowBox[{"48", " ", "\[ImaginaryI]", " ", 
         RowBox[{"(", 
          RowBox[{"7", "+", 
           RowBox[{"53", " ", 
            SuperscriptBox["u", "2"]}], "+", 
           RowBox[{"32", " ", 
            SuperscriptBox["u", "4"]}]}], ")"}], " ", 
         SubscriptBox[
          OverscriptBox[
           StyleBox["W",
            FontColor->RGBColor[0.54, 0.35, 0.15]], 
           StyleBox["^",
            FontColor->RGBColor[0.54, 0.35, 0.15]]], "lead"]}], 
        SuperscriptBox[
         RowBox[{"(", 
          RowBox[{"u", "+", 
           SuperscriptBox["u", "3"]}], ")"}], "2"]], "]"}]}], "-", 
     RowBox[{
      FractionBox["4", "9"], " ", 
      RowBox[{"\[DoubleStruckCapitalC]", "[", 
       RowBox[{"-", 
        FractionBox[
         RowBox[{"24", " ", "\[ImaginaryI]", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"-", "6"}], "-", 
            RowBox[{"27", " ", 
             SuperscriptBox["u", "2"]}], "-", 
            RowBox[{"4", " ", 
             SuperscriptBox["u", "4"]}], "+", 
            SuperscriptBox["u", "6"]}], ")"}], " ", 
          SubscriptBox[
           OverscriptBox[
            StyleBox["W",
             FontColor->RGBColor[0.54, 0.35, 0.15]], 
            StyleBox["^",
             FontColor->RGBColor[0.54, 0.35, 0.15]]], "lead"]}], 
         RowBox[{
          SuperscriptBox["u", "2"], " ", 
          SuperscriptBox[
           RowBox[{"(", 
            RowBox[{"1", "+", 
             SuperscriptBox["u", "2"]}], ")"}], "3"]}]]}], "]"}]}], "+", 
     RowBox[{
      FractionBox["4", "3"], " ", 
      RowBox[{"\[DoubleStruckCapitalC]", "[", 
       RowBox[{"-", 
        FractionBox[
         RowBox[{"48", " ", "\[ImaginaryI]", " ", 
          RowBox[{"(", 
           RowBox[{"2", "+", 
            RowBox[{"12", " ", 
             SuperscriptBox["u", "2"]}], "+", 
            RowBox[{"9", " ", 
             SuperscriptBox["u", "4"]}], "+", 
            RowBox[{"3", " ", 
             SuperscriptBox["u", "6"]}]}], ")"}], " ", 
          SubscriptBox[
           OverscriptBox[
            StyleBox["W",
             FontColor->RGBColor[0.54, 0.35, 0.15]], 
            StyleBox["^",
             FontColor->RGBColor[0.54, 0.35, 0.15]]], "lead"]}], 
         RowBox[{
          SuperscriptBox["u", "2"], " ", 
          SuperscriptBox[
           RowBox[{"(", 
            RowBox[{"1", "+", 
             SuperscriptBox["u", "2"]}], ")"}], "3"]}]]}], "]"}]}], "-", 
     RowBox[{
      FractionBox["1", "9"], " ", 
      RowBox[{"\[DoubleStruckCapitalC]", "[", 
       RowBox[{"-", 
        FractionBox[
         RowBox[{"192", " ", "\[ImaginaryI]", " ", 
          RowBox[{"(", 
           RowBox[{"2", "+", 
            RowBox[{"7", " ", 
             SuperscriptBox["u", "2"]}], "-", 
            RowBox[{"4", " ", 
             SuperscriptBox["u", "4"]}], "+", 
            RowBox[{"7", " ", 
             SuperscriptBox["u", "6"]}]}], ")"}], " ", 
          SubscriptBox[
           OverscriptBox[
            StyleBox["W",
             FontColor->RGBColor[0.54, 0.35, 0.15]], 
            StyleBox["^",
             FontColor->RGBColor[0.54, 0.35, 0.15]]], "lead"]}], 
         RowBox[{
          SuperscriptBox["u", "4"], " ", 
          SuperscriptBox[
           RowBox[{"(", 
            RowBox[{"1", "+", 
             SuperscriptBox["u", "2"]}], ")"}], "5"]}]]}], "]"}]}], "+", 
     RowBox[{
      FractionBox["2", "9"], " ", 
      RowBox[{"\[DoubleStruckCapitalC]", "[", 
       RowBox[{"-", 
        FractionBox[
         RowBox[{"96", " ", "\[ImaginaryI]", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"-", "1"}], "-", 
            SuperscriptBox["u", "2"], "+", 
            RowBox[{"15", " ", 
             SuperscriptBox["u", "4"]}], "+", 
            RowBox[{"16", " ", 
             SuperscriptBox["u", "6"]}], "+", 
            RowBox[{"12", " ", 
             SuperscriptBox["u", "8"]}], "+", 
            RowBox[{"3", " ", 
             SuperscriptBox["u", "10"]}]}], ")"}], " ", 
          SubscriptBox[
           OverscriptBox[
            StyleBox["W",
             FontColor->RGBColor[0.54, 0.35, 0.15]], 
            StyleBox["^",
             FontColor->RGBColor[0.54, 0.35, 0.15]]], "lead"]}], 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"u", "+", 
            SuperscriptBox["u", "3"]}], ")"}], "4"]]}], "]"}]}], "+", 
     RowBox[{
      FractionBox["32", "9"], " ", 
      RowBox[{"\[DoubleStruckCapitalC]", "[", 
       RowBox[{"-", 
        FractionBox[
         RowBox[{"4", " ", "\[ImaginaryI]", " ", 
          SubscriptBox[
           OverscriptBox[
            StyleBox["W",
             FontColor->RGBColor[0.54, 0.35, 0.15]], 
            StyleBox["^",
             FontColor->RGBColor[0.54, 0.35, 0.15]]], "lead"]}], 
         RowBox[{"3", " ", 
          SuperscriptBox[
           StyleBox["Q0",
            FontColor->RGBColor[{
               Rational[1, 2], 
               Rational[1, 2], 0}]], "-"], " ", 
          SuperscriptBox[
           StyleBox["Q0",
            FontColor->RGBColor[{
               Rational[1, 2], 
               Rational[1, 2], 0}]], "+"]}]]}], "]"}]}], "+", 
     RowBox[{
      FractionBox["1856", "9"], " ", 
      RowBox[{"\[DoubleStruckCapitalC]", "[", 
       RowBox[{"-", 
        FractionBox[
         RowBox[{"\[ImaginaryI]", " ", 
          RowBox[{"(", 
           RowBox[{"1", "+", 
            RowBox[{"3", " ", 
             SuperscriptBox["u", "2"]}]}], ")"}], " ", 
          SubscriptBox[
           OverscriptBox[
            StyleBox["W",
             FontColor->RGBColor[0.54, 0.35, 0.15]], 
            StyleBox["^",
             FontColor->RGBColor[0.54, 0.35, 0.15]]], "lead"]}], 
         RowBox[{"3", " ", 
          SuperscriptBox[
           StyleBox["Q0",
            FontColor->RGBColor[{
               Rational[1, 2], 
               Rational[1, 2], 0}]], "-"], " ", 
          SuperscriptBox[
           StyleBox["Q0",
            FontColor->RGBColor[{
               Rational[1, 2], 
               Rational[1, 2], 0}]], "+"]}]]}], "]"}]}], "+", 
     RowBox[{
      FractionBox["4", "9"], " ", 
      RowBox[{"\[DoubleStruckCapitalC]", "[", 
       FractionBox[
        RowBox[{"16", " ", "\[ImaginaryI]", " ", 
         RowBox[{"(", 
          RowBox[{"6", "+", 
           RowBox[{"25", " ", 
            SuperscriptBox["u", "2"]}], "+", 
           RowBox[{"51", " ", 
            SuperscriptBox["u", "4"]}], "+", 
           RowBox[{"18", " ", 
            SuperscriptBox["u", "6"]}]}], ")"}], " ", 
         SubscriptBox[
          OverscriptBox[
           StyleBox["W",
            FontColor->RGBColor[0.54, 0.35, 0.15]], 
           StyleBox["^",
            FontColor->RGBColor[0.54, 0.35, 0.15]]], "lead"]}], 
        RowBox[{"3", " ", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"1", "+", 
            SuperscriptBox["u", "2"]}], ")"}], "2"], " ", 
         SuperscriptBox[
          StyleBox["Q0",
           FontColor->RGBColor[{
              Rational[1, 2], 
              Rational[1, 2], 0}]], "-"], " ", 
         SuperscriptBox[
          StyleBox["Q0",
           FontColor->RGBColor[{
              Rational[1, 2], 
              Rational[1, 2], 0}]], "+"]}]], "]"}]}], "-", 
     RowBox[{
      FractionBox["2", "9"], " ", 
      RowBox[{"\[DoubleStruckCapitalC]", "[", 
       RowBox[{"-", 
        FractionBox[
         RowBox[{"64", " ", "\[ImaginaryI]", " ", 
          RowBox[{"(", 
           RowBox[{"9", "+", 
            RowBox[{"56", " ", 
             SuperscriptBox["u", "2"]}], "+", 
            RowBox[{"196", " ", 
             SuperscriptBox["u", "4"]}], "+", 
            RowBox[{"183", " ", 
             SuperscriptBox["u", "6"]}], "+", 
            RowBox[{"117", " ", 
             SuperscriptBox["u", "8"]}], "+", 
            RowBox[{"27", " ", 
             SuperscriptBox["u", "10"]}]}], ")"}], " ", 
          SubscriptBox[
           OverscriptBox[
            StyleBox["W",
             FontColor->RGBColor[0.54, 0.35, 0.15]], 
            StyleBox["^",
             FontColor->RGBColor[0.54, 0.35, 0.15]]], "lead"]}], 
         RowBox[{"3", " ", 
          SuperscriptBox[
           RowBox[{"(", 
            RowBox[{"1", "+", 
             SuperscriptBox["u", "2"]}], ")"}], "4"], " ", 
          SuperscriptBox[
           StyleBox["Q0",
            FontColor->RGBColor[{
               Rational[1, 2], 
               Rational[1, 2], 0}]], "-"], " ", 
          SuperscriptBox[
           StyleBox["Q0",
            FontColor->RGBColor[{
               Rational[1, 2], 
               Rational[1, 2], 0}]], "+"]}]]}], "]"}]}], "-", 
     RowBox[{
      FractionBox["4", "9"], " ", 
      RowBox[{"\[DoubleStruckCapitalC]", "[", 
       FractionBox[
        RowBox[{"24", " ", "\[ImaginaryI]", " ", 
         RowBox[{"(", 
          RowBox[{"1", "+", 
           RowBox[{"5", " ", 
            SuperscriptBox["u", "2"]}], "+", 
           RowBox[{"2", " ", 
            SuperscriptBox["u", "4"]}]}], ")"}], " ", 
         SubscriptBox[
          OverscriptBox[
           StyleBox["W",
            FontColor->RGBColor[0.54, 0.35, 0.15]], 
           StyleBox["^",
            FontColor->RGBColor[0.54, 0.35, 0.15]]], "sublead"]}], 
        SuperscriptBox[
         RowBox[{"(", 
          RowBox[{"u", "+", 
           SuperscriptBox["u", "3"]}], ")"}], "2"]], "]"}]}], "+", 
     RowBox[{
      FractionBox["2", "9"], " ", 
      RowBox[{"\[DoubleStruckCapitalC]", "[", 
       RowBox[{"-", 
        FractionBox[
         RowBox[{"48", " ", "\[ImaginaryI]", " ", 
          RowBox[{"(", 
           RowBox[{"2", "+", 
            RowBox[{"12", " ", 
             SuperscriptBox["u", "2"]}], "+", 
            RowBox[{"9", " ", 
             SuperscriptBox["u", "4"]}], "+", 
            RowBox[{"3", " ", 
             SuperscriptBox["u", "6"]}]}], ")"}], " ", 
          SubscriptBox[
           OverscriptBox[
            StyleBox["W",
             FontColor->RGBColor[0.54, 0.35, 0.15]], 
            StyleBox["^",
             FontColor->RGBColor[0.54, 0.35, 0.15]]], "sublead"]}], 
         RowBox[{
          SuperscriptBox["u", "2"], " ", 
          SuperscriptBox[
           RowBox[{"(", 
            RowBox[{"1", "+", 
             SuperscriptBox["u", "2"]}], ")"}], "3"]}]]}], "]"}]}], "-", 
     RowBox[{
      FractionBox["32", "3"], " ", 
      RowBox[{"\[DoubleStruckCapitalC]", "[", 
       RowBox[{"-", 
        FractionBox[
         RowBox[{"\[ImaginaryI]", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"4", " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"-", "1"}], "+", 
               RowBox[{"3", " ", 
                SuperscriptBox["u", "2"]}], "+", 
               RowBox[{"27", " ", 
                SuperscriptBox["u", "4"]}]}], ")"}], " ", 
             SubscriptBox[
              OverscriptBox[
               StyleBox["W",
                FontColor->RGBColor[0.54, 0.35, 0.15]], 
               StyleBox["^",
                FontColor->RGBColor[0.54, 0.35, 0.15]]], "lead"]}], "+", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{"1", "+", 
               RowBox[{"6", " ", 
                SuperscriptBox["u", "2"]}], "+", 
               RowBox[{"18", " ", 
                SuperscriptBox["u", "4"]}], "+", 
               RowBox[{"27", " ", 
                SuperscriptBox["u", "6"]}]}], ")"}], " ", 
             SubscriptBox[
              OverscriptBox[
               StyleBox["W",
                FontColor->RGBColor[0.54, 0.35, 0.15]], 
               StyleBox["^",
                FontColor->RGBColor[0.54, 0.35, 0.15]]], "sublead"]}]}], 
           ")"}]}], 
         RowBox[{"27", " ", 
          SuperscriptBox[
           RowBox[{"(", 
            SuperscriptBox[
             StyleBox["Q0",
              FontColor->RGBColor[{
                 Rational[1, 2], 
                 Rational[1, 2], 0}]], "-"], ")"}], "2"], " ", 
          SuperscriptBox[
           RowBox[{"(", 
            SuperscriptBox[
             StyleBox["Q0",
              FontColor->RGBColor[{
                 Rational[1, 2], 
                 Rational[1, 2], 0}]], "+"], ")"}], "2"]}]]}], "]"}]}], "+", 
     RowBox[{
      FractionBox["4", "9"], " ", 
      RowBox[{"\[DoubleStruckCapitalC]", "[", 
       RowBox[{"-", 
        RowBox[{
         FractionBox["1", 
          RowBox[{"27", " ", 
           SuperscriptBox[
            RowBox[{"(", 
             RowBox[{"1", "+", 
              SuperscriptBox["u", "2"]}], ")"}], "4"], " ", 
           SuperscriptBox[
            RowBox[{"(", 
             SuperscriptBox[
              StyleBox["Q0",
               FontColor->RGBColor[{
                  Rational[1, 2], 
                  Rational[1, 2], 0}]], "-"], ")"}], "2"], " ", 
           SuperscriptBox[
            RowBox[{"(", 
             SuperscriptBox[
              StyleBox["Q0",
               FontColor->RGBColor[{
                  Rational[1, 2], 
                  Rational[1, 2], 0}]], "+"], ")"}], "2"]}]], 
         RowBox[{"16", " ", "\[ImaginaryI]", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{
             RowBox[{"(", 
              RowBox[{"22", "+", 
               RowBox[{"56", " ", 
                SuperscriptBox["u", "2"]}], "-", 
               RowBox[{"376", " ", 
                SuperscriptBox["u", "4"]}], "-", 
               RowBox[{"1731", " ", 
                SuperscriptBox["u", "6"]}], "-", 
               RowBox[{"3243", " ", 
                SuperscriptBox["u", "8"]}], "-", 
               RowBox[{"1800", " ", 
                SuperscriptBox["u", "10"]}], "-", 
               RowBox[{"189", " ", 
                SuperscriptBox["u", "12"]}], "+", 
               RowBox[{"81", " ", 
                SuperscriptBox["u", "14"]}]}], ")"}], " ", 
             SubscriptBox[
              OverscriptBox[
               StyleBox["W",
                FontColor->RGBColor[0.54, 0.35, 0.15]], 
               StyleBox["^",
                FontColor->RGBColor[0.54, 0.35, 0.15]]], "lead"]}], "-", 
            RowBox[{"9", " ", 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{"1", "+", 
                SuperscriptBox["u", "2"]}], ")"}], "2"], " ", 
             RowBox[{"(", 
              RowBox[{"6", "+", 
               RowBox[{"25", " ", 
                SuperscriptBox["u", "2"]}], "+", 
               RowBox[{"51", " ", 
                SuperscriptBox["u", "4"]}], "+", 
               RowBox[{"18", " ", 
                SuperscriptBox["u", "6"]}]}], ")"}], " ", 
             SuperscriptBox[
              StyleBox["Q0",
               FontColor->RGBColor[{
                  Rational[1, 2], 
                  Rational[1, 2], 0}]], "-"], " ", 
             SuperscriptBox[
              StyleBox["Q0",
               FontColor->RGBColor[{
                  Rational[1, 2], 
                  Rational[1, 2], 0}]], "+"], " ", 
             SubscriptBox[
              OverscriptBox[
               StyleBox["W",
                FontColor->RGBColor[0.54, 0.35, 0.15]], 
               StyleBox["^",
                FontColor->RGBColor[0.54, 0.35, 0.15]]], "sublead"]}]}], 
           ")"}]}]}]}], "]"}]}], "-", 
     RowBox[{
      FractionBox["1856", "9"], " ", 
      SubscriptBox[
       StyleBox["W",
        FontColor->RGBColor[0.54, 0.35, 0.15]], 
       RowBox[{"1", ",", "v0", ",", "lead"}]]}], "+", 
     RowBox[{
      FractionBox["32", "3"], " ", 
      SubscriptBox[
       StyleBox["W",
        FontColor->RGBColor[0.54, 0.35, 0.15]], 
       RowBox[{"1", ",", "v0", ",", "sublead"}]]}], "-", 
     RowBox[{"87360", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2"]}], "+", 
     FractionBox[
      RowBox[{"828288", " ", 
       SubsuperscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "2", "2"]}], "5"], "-", 
     FractionBox[
      RowBox[{"2382592", " ", 
       SubsuperscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "2", "3"]}], "35"], "+", 
     FractionBox[
      RowBox[{"52736", " ", 
       SubsuperscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "2", "4"]}], "35"], "+", 
     FractionBox[
      RowBox[{"67584", " ", 
       SubsuperscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "2", "5"]}], "175"], "-", 
     RowBox[{"438336", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3"]}], "-", 
     RowBox[{"20864", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3"]}], "+", 
     RowBox[{
      FractionBox["44032", "5"], " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2", "2"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3"]}], "+", 
     RowBox[{
      FractionBox["663552", "35"], " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2", "3"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3"]}], "-", 
     RowBox[{
      FractionBox["6144", "25"], " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2", "4"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3"]}], "+", 
     RowBox[{"45952", " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3", "2"]}], "+", 
     RowBox[{"2304", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2"], " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3", "2"]}], "+", 
     RowBox[{
      FractionBox["1536", "5"], " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2", "2"], " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3", "2"]}], "+", 
     RowBox[{"1536", " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3", "3"]}], "+", 
     RowBox[{"24768", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "5"]}], "-", 
     RowBox[{"38784", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "5"]}], "-", 
     RowBox[{
      FractionBox["123392", "5"], " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2", "2"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "5"]}], "+", 
     RowBox[{
      FractionBox["47104", "35"], " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2", "3"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "5"]}], "+", 
     RowBox[{"91136", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "5"]}], "+", 
     RowBox[{"9216", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "5"]}], "-", 
     RowBox[{"12288", " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "5", "2"]}], "-", 
     RowBox[{"25152", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "7"]}], "+", 
     RowBox[{"33152", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "7"]}], "-", 
     RowBox[{
      FractionBox["16128", "5"], " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2", "2"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "7"]}], "-", 
     RowBox[{"8192", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "7"]}]}]}], ",", 
   RowBox[{
    RowBox[{
     SubscriptBox["\[Beta]", "sublead2"], "[", "2", "]"}], "\[Rule]", 
    RowBox[{
     RowBox[{
      FractionBox["1", "6"], " ", 
      RowBox[{"\[DoubleStruckCapitalC]", "[", 
       FractionBox[
        RowBox[{"64", " ", "\[ImaginaryI]", " ", 
         SubscriptBox[
          StyleBox["H",
           FontColor->RGBColor[0.54, 0.35, 0.15]], "lead"]}], 
        SuperscriptBox["u", "6"]], "]"}]}], "+", 
     RowBox[{
      FractionBox["2", "3"], " ", 
      RowBox[{"\[DoubleStruckCapitalC]", "[", 
       RowBox[{"-", 
        FractionBox[
         RowBox[{"32", " ", 
          SubscriptBox[
           StyleBox["H",
            FontColor->RGBColor[0.54, 0.35, 0.15]], "lead"]}], 
         SuperscriptBox["u", "5"]]}], "]"}]}], "+", 
     RowBox[{"4", " ", 
      RowBox[{"\[DoubleStruckCapitalC]", "[", 
       RowBox[{"-", 
        FractionBox[
         RowBox[{"8", " ", 
          SubscriptBox[
           StyleBox["H",
            FontColor->RGBColor[0.54, 0.35, 0.15]], "lead"]}], 
         SuperscriptBox["u", "3"]]}], "]"}]}], "+", 
     RowBox[{
      FractionBox["2", "3"], " ", 
      RowBox[{"\[DoubleStruckCapitalC]", "[", 
       RowBox[{"-", 
        FractionBox[
         RowBox[{"64", " ", 
          RowBox[{"(", 
           RowBox[{"\[ImaginaryI]", "+", "u"}], ")"}], " ", 
          SubsuperscriptBox[
           StyleBox["W",
            FontColor->RGBColor[0.54, 0.35, 0.15]], 
           RowBox[{"1", ",", "lead"}], "+"]}], 
         RowBox[{
          SuperscriptBox["u", "4"], " ", 
          SuperscriptBox[
           StyleBox["Q0",
            FontColor->RGBColor[{
               Rational[1, 2], 
               Rational[1, 2], 0}]], "+"]}]]}], "]"}]}], "+", 
     RowBox[{"4", " ", 
      RowBox[{"\[DoubleStruckCapitalC]", "[", 
       RowBox[{"-", 
        FractionBox[
         RowBox[{"16", " ", 
          RowBox[{"(", 
           RowBox[{"\[ImaginaryI]", "+", "u"}], ")"}], " ", 
          SubsuperscriptBox[
           StyleBox["W",
            FontColor->RGBColor[0.54, 0.35, 0.15]], 
           RowBox[{"1", ",", "lead"}], "+"]}], 
         RowBox[{
          SuperscriptBox["u", "2"], " ", 
          SuperscriptBox[
           StyleBox["Q0",
            FontColor->RGBColor[{
               Rational[1, 2], 
               Rational[1, 2], 0}]], "+"]}]]}], "]"}]}], "-", 
     RowBox[{"4", " ", 
      RowBox[{"\[DoubleStruckCapitalC]", "[", 
       FractionBox[
        RowBox[{"24", " ", "\[ImaginaryI]", " ", 
         RowBox[{"(", 
          RowBox[{"1", "+", 
           RowBox[{"5", " ", 
            SuperscriptBox["u", "2"]}], "+", 
           RowBox[{"2", " ", 
            SuperscriptBox["u", "4"]}]}], ")"}], " ", 
         SubscriptBox[
          OverscriptBox[
           StyleBox["W",
            FontColor->RGBColor[0.54, 0.35, 0.15]], 
           StyleBox["^",
            FontColor->RGBColor[0.54, 0.35, 0.15]]], "lead"]}], 
        SuperscriptBox[
         RowBox[{"(", 
          RowBox[{"u", "+", 
           SuperscriptBox["u", "3"]}], ")"}], "2"]], "]"}]}], "-", 
     RowBox[{
      FractionBox["1", "6"], " ", 
      RowBox[{"\[DoubleStruckCapitalC]", "[", 
       RowBox[{"-", 
        FractionBox[
         RowBox[{"192", " ", "\[ImaginaryI]", " ", 
          RowBox[{"(", 
           RowBox[{"2", "+", 
            RowBox[{"7", " ", 
             SuperscriptBox["u", "2"]}], "-", 
            RowBox[{"4", " ", 
             SuperscriptBox["u", "4"]}], "+", 
            RowBox[{"7", " ", 
             SuperscriptBox["u", "6"]}]}], ")"}], " ", 
          SubscriptBox[
           OverscriptBox[
            StyleBox["W",
             FontColor->RGBColor[0.54, 0.35, 0.15]], 
            StyleBox["^",
             FontColor->RGBColor[0.54, 0.35, 0.15]]], "lead"]}], 
         RowBox[{
          SuperscriptBox["u", "4"], " ", 
          SuperscriptBox[
           RowBox[{"(", 
            RowBox[{"1", "+", 
             SuperscriptBox["u", "2"]}], ")"}], "5"]}]]}], "]"}]}], "-", 
     RowBox[{
      FractionBox["2", "3"], " ", 
      RowBox[{"\[DoubleStruckCapitalC]", "[", 
       RowBox[{"-", 
        FractionBox[
         RowBox[{"96", " ", "\[ImaginaryI]", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"-", "1"}], "-", 
            SuperscriptBox["u", "2"], "+", 
            RowBox[{"15", " ", 
             SuperscriptBox["u", "4"]}], "+", 
            RowBox[{"16", " ", 
             SuperscriptBox["u", "6"]}], "+", 
            RowBox[{"12", " ", 
             SuperscriptBox["u", "8"]}], "+", 
            RowBox[{"3", " ", 
             SuperscriptBox["u", "10"]}]}], ")"}], " ", 
          SubscriptBox[
           OverscriptBox[
            StyleBox["W",
             FontColor->RGBColor[0.54, 0.35, 0.15]], 
            StyleBox["^",
             FontColor->RGBColor[0.54, 0.35, 0.15]]], "lead"]}], 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"u", "+", 
            SuperscriptBox["u", "3"]}], ")"}], "4"]]}], "]"}]}], "+", 
     RowBox[{"4", " ", 
      RowBox[{"\[DoubleStruckCapitalC]", "[", 
       FractionBox[
        RowBox[{"16", " ", "\[ImaginaryI]", " ", 
         RowBox[{"(", 
          RowBox[{"6", "+", 
           RowBox[{"25", " ", 
            SuperscriptBox["u", "2"]}], "+", 
           RowBox[{"51", " ", 
            SuperscriptBox["u", "4"]}], "+", 
           RowBox[{"18", " ", 
            SuperscriptBox["u", "6"]}]}], ")"}], " ", 
         SubscriptBox[
          OverscriptBox[
           StyleBox["W",
            FontColor->RGBColor[0.54, 0.35, 0.15]], 
           StyleBox["^",
            FontColor->RGBColor[0.54, 0.35, 0.15]]], "lead"]}], 
        RowBox[{"3", " ", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"1", "+", 
            SuperscriptBox["u", "2"]}], ")"}], "2"], " ", 
         SuperscriptBox[
          StyleBox["Q0",
           FontColor->RGBColor[{
              Rational[1, 2], 
              Rational[1, 2], 0}]], "-"], " ", 
         SuperscriptBox[
          StyleBox["Q0",
           FontColor->RGBColor[{
              Rational[1, 2], 
              Rational[1, 2], 0}]], "+"]}]], "]"}]}], "+", 
     RowBox[{
      FractionBox["2", "3"], " ", 
      RowBox[{"\[DoubleStruckCapitalC]", "[", 
       RowBox[{"-", 
        FractionBox[
         RowBox[{"64", " ", "\[ImaginaryI]", " ", 
          RowBox[{"(", 
           RowBox[{"9", "+", 
            RowBox[{"56", " ", 
             SuperscriptBox["u", "2"]}], "+", 
            RowBox[{"196", " ", 
             SuperscriptBox["u", "4"]}], "+", 
            RowBox[{"183", " ", 
             SuperscriptBox["u", "6"]}], "+", 
            RowBox[{"117", " ", 
             SuperscriptBox["u", "8"]}], "+", 
            RowBox[{"27", " ", 
             SuperscriptBox["u", "10"]}]}], ")"}], " ", 
          SubscriptBox[
           OverscriptBox[
            StyleBox["W",
             FontColor->RGBColor[0.54, 0.35, 0.15]], 
            StyleBox["^",
             FontColor->RGBColor[0.54, 0.35, 0.15]]], "lead"]}], 
         RowBox[{"3", " ", 
          SuperscriptBox[
           RowBox[{"(", 
            RowBox[{"1", "+", 
             SuperscriptBox["u", "2"]}], ")"}], "4"], " ", 
          SuperscriptBox[
           StyleBox["Q0",
            FontColor->RGBColor[{
               Rational[1, 2], 
               Rational[1, 2], 0}]], "-"], " ", 
          SuperscriptBox[
           StyleBox["Q0",
            FontColor->RGBColor[{
               Rational[1, 2], 
               Rational[1, 2], 0}]], "+"]}]]}], "]"}]}], "-", 
     FractionBox[
      RowBox[{"31104", " ", 
       SubsuperscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "2", "2"]}], "5"], "+", 
     FractionBox[
      RowBox[{"1234944", " ", 
       SubsuperscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "2", "3"]}], "35"], "-", 
     FractionBox[
      RowBox[{"3220992", " ", 
       SubsuperscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "2", "4"]}], "175"], "+", 
     FractionBox[
      RowBox[{"67584", " ", 
       SubsuperscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "2", "5"]}], "35"], "+", 
     RowBox[{"3456", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3"]}], "+", 
     RowBox[{
      FractionBox["52992", "5"], " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2", "2"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3"]}], "-", 
     RowBox[{"9216", " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2", "3"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3"]}], "+", 
     RowBox[{
      FractionBox["9216", "5"], " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2", "4"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3"]}], "-", 
     RowBox[{"13824", " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3", "2"]}], "-", 
     RowBox[{"10368", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "5"]}], "-", 
     RowBox[{"52992", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "5"]}], "+", 
     RowBox[{
      FractionBox["33792", "5"], " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2", "2"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "5"]}], "+", 
     RowBox[{
      FractionBox["12288", "7"], " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2", "3"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "5"]}], "+", 
     RowBox[{"32256", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "5"]}], "+", 
     RowBox[{"15360", " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "5", "2"]}], "-", 
     RowBox[{"31680", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "7"]}], "+", 
     RowBox[{"36480", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "7"]}], "-", 
     RowBox[{"6912", " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2", "2"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "7"]}], "-", 
     RowBox[{"7680", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "7"]}]}]}], ",", 
   RowBox[{
    RowBox[{
     SubscriptBox["\[Alpha]", "sublead2"], "[", "3", "]"}], "\[Rule]", 
    RowBox[{"31104", "-", 
     RowBox[{
      FractionBox["2", "9"], " ", 
      RowBox[{"\[DoubleStruckCapitalC]", "[", 
       FractionBox[
        RowBox[{"64", " ", "\[ImaginaryI]", " ", 
         SubscriptBox[
          StyleBox["H",
           FontColor->RGBColor[0.54, 0.35, 0.15]], "lead"]}], 
        SuperscriptBox["u", "6"]], "]"}]}], "+", 
     RowBox[{
      FractionBox["4", "9"], " ", 
      RowBox[{"\[DoubleStruckCapitalC]", "[", 
       RowBox[{"-", 
        FractionBox[
         RowBox[{"32", " ", 
          SubscriptBox[
           StyleBox["H",
            FontColor->RGBColor[0.54, 0.35, 0.15]], "lead"]}], 
         SuperscriptBox["u", "5"]]}], "]"}]}], "+", 
     RowBox[{
      FractionBox["4", "9"], " ", 
      RowBox[{"\[DoubleStruckCapitalC]", "[", 
       RowBox[{"-", 
        FractionBox[
         RowBox[{"64", " ", 
          RowBox[{"(", 
           RowBox[{"\[ImaginaryI]", "+", "u"}], ")"}], " ", 
          SubsuperscriptBox[
           StyleBox["W",
            FontColor->RGBColor[0.54, 0.35, 0.15]], 
           RowBox[{"1", ",", "lead"}], "+"]}], 
         RowBox[{
          SuperscriptBox["u", "4"], " ", 
          SuperscriptBox[
           StyleBox["Q0",
            FontColor->RGBColor[{
               Rational[1, 2], 
               Rational[1, 2], 0}]], "+"]}]]}], "]"}]}], "+", 
     RowBox[{
      FractionBox["2", "9"], " ", 
      RowBox[{"\[DoubleStruckCapitalC]", "[", 
       RowBox[{"-", 
        FractionBox[
         RowBox[{"192", " ", "\[ImaginaryI]", " ", 
          RowBox[{"(", 
           RowBox[{"2", "+", 
            RowBox[{"7", " ", 
             SuperscriptBox["u", "2"]}], "-", 
            RowBox[{"4", " ", 
             SuperscriptBox["u", "4"]}], "+", 
            RowBox[{"7", " ", 
             SuperscriptBox["u", "6"]}]}], ")"}], " ", 
          SubscriptBox[
           OverscriptBox[
            StyleBox["W",
             FontColor->RGBColor[0.54, 0.35, 0.15]], 
            StyleBox["^",
             FontColor->RGBColor[0.54, 0.35, 0.15]]], "lead"]}], 
         RowBox[{
          SuperscriptBox["u", "4"], " ", 
          SuperscriptBox[
           RowBox[{"(", 
            RowBox[{"1", "+", 
             SuperscriptBox["u", "2"]}], ")"}], "5"]}]]}], "]"}]}], "-", 
     RowBox[{
      FractionBox["4", "9"], " ", 
      RowBox[{"\[DoubleStruckCapitalC]", "[", 
       RowBox[{"-", 
        FractionBox[
         RowBox[{"96", " ", "\[ImaginaryI]", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"-", "1"}], "-", 
            SuperscriptBox["u", "2"], "+", 
            RowBox[{"15", " ", 
             SuperscriptBox["u", "4"]}], "+", 
            RowBox[{"16", " ", 
             SuperscriptBox["u", "6"]}], "+", 
            RowBox[{"12", " ", 
             SuperscriptBox["u", "8"]}], "+", 
            RowBox[{"3", " ", 
             SuperscriptBox["u", "10"]}]}], ")"}], " ", 
          SubscriptBox[
           OverscriptBox[
            StyleBox["W",
             FontColor->RGBColor[0.54, 0.35, 0.15]], 
            StyleBox["^",
             FontColor->RGBColor[0.54, 0.35, 0.15]]], "lead"]}], 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"u", "+", 
            SuperscriptBox["u", "3"]}], ")"}], "4"]]}], "]"}]}], "-", 
     RowBox[{"128", " ", 
      RowBox[{"\[DoubleStruckCapitalC]", "[", 
       RowBox[{"-", 
        FractionBox[
         RowBox[{"\[ImaginaryI]", " ", 
          RowBox[{"(", 
           RowBox[{"1", "+", 
            RowBox[{"3", " ", 
             SuperscriptBox["u", "2"]}]}], ")"}], " ", 
          SubscriptBox[
           OverscriptBox[
            StyleBox["W",
             FontColor->RGBColor[0.54, 0.35, 0.15]], 
            StyleBox["^",
             FontColor->RGBColor[0.54, 0.35, 0.15]]], "lead"]}], 
         RowBox[{"3", " ", 
          SuperscriptBox[
           StyleBox["Q0",
            FontColor->RGBColor[{
               Rational[1, 2], 
               Rational[1, 2], 0}]], "-"], " ", 
          SuperscriptBox[
           StyleBox["Q0",
            FontColor->RGBColor[{
               Rational[1, 2], 
               Rational[1, 2], 0}]], "+"]}]]}], "]"}]}], "+", 
     RowBox[{
      FractionBox["4", "9"], " ", 
      RowBox[{"\[DoubleStruckCapitalC]", "[", 
       RowBox[{"-", 
        FractionBox[
         RowBox[{"64", " ", "\[ImaginaryI]", " ", 
          RowBox[{"(", 
           RowBox[{"9", "+", 
            RowBox[{"56", " ", 
             SuperscriptBox["u", "2"]}], "+", 
            RowBox[{"196", " ", 
             SuperscriptBox["u", "4"]}], "+", 
            RowBox[{"183", " ", 
             SuperscriptBox["u", "6"]}], "+", 
            RowBox[{"117", " ", 
             SuperscriptBox["u", "8"]}], "+", 
            RowBox[{"27", " ", 
             SuperscriptBox["u", "10"]}]}], ")"}], " ", 
          SubscriptBox[
           OverscriptBox[
            StyleBox["W",
             FontColor->RGBColor[0.54, 0.35, 0.15]], 
            StyleBox["^",
             FontColor->RGBColor[0.54, 0.35, 0.15]]], "lead"]}], 
         RowBox[{"3", " ", 
          SuperscriptBox[
           RowBox[{"(", 
            RowBox[{"1", "+", 
             SuperscriptBox["u", "2"]}], ")"}], "4"], " ", 
          SuperscriptBox[
           StyleBox["Q0",
            FontColor->RGBColor[{
               Rational[1, 2], 
               Rational[1, 2], 0}]], "-"], " ", 
          SuperscriptBox[
           StyleBox["Q0",
            FontColor->RGBColor[{
               Rational[1, 2], 
               Rational[1, 2], 0}]], "+"]}]]}], "]"}]}], "+", 
     RowBox[{"128", " ", 
      SubscriptBox[
       StyleBox["W",
        FontColor->RGBColor[0.54, 0.35, 0.15]], 
       RowBox[{"1", ",", "v0", ",", "lead"}]]}], "-", 
     RowBox[{"103680", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2"]}], "-", 
     RowBox[{"64512", " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2", "2"]}], "+", 
     FractionBox[
      RowBox[{"337920", " ", 
       SubsuperscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "2", "3"]}], "7"], "-", 
     FractionBox[
      RowBox[{"1001472", " ", 
       SubsuperscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "2", "4"]}], "175"], "+", 
     FractionBox[
      RowBox[{"45056", " ", 
       SubsuperscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "2", "5"]}], "35"], "+", 
     RowBox[{"228096", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3"]}], "+", 
     RowBox[{"6144", " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2", "2"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3"]}], "-", 
     RowBox[{
      FractionBox["208896", "7"], " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2", "3"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3"]}], "-", 
     RowBox[{
      FractionBox["12288", "5"], " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2", "4"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3"]}], "-", 
     RowBox[{"4608", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "5"]}], "-", 
     RowBox[{"33792", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "5"]}], "+", 
     RowBox[{
      FractionBox["114688", "5"], " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2", "2"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "5"]}], "-", 
     RowBox[{
      FractionBox["16384", "7"], " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2", "3"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "5"]}], "+", 
     RowBox[{"24576", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "5"]}], "+", 
     RowBox[{"10240", " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "5", "2"]}], "-", 
     RowBox[{"211200", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "7"]}], "+", 
     RowBox[{"104960", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "7"]}], "+", 
     RowBox[{"9216", " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2", "2"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "7"]}], "-", 
     RowBox[{"5120", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "7"]}]}]}], ",", 
   RowBox[{
    RowBox[{
     SubscriptBox["\[Beta]", "sublead2"], "[", "3", "]"}], "\[Rule]", "0"}], 
   ",", 
   RowBox[{
    RowBox[{
     SubscriptBox["\[Alpha]", "sublead2"], "[", "4", "]"}], "\[Rule]", "0"}], 
   ",", 
   RowBox[{
    RowBox[{
     SubscriptBox["\[Beta]", "sublead2"], "[", "4", "]"}], "\[Rule]", "0"}], 
   ",", 
   RowBox[{
    RowBox[{
     SubscriptBox["\[Alpha]", "sublead2"], "[", "5", "]"}], "\[Rule]", "0"}], 
   ",", 
   RowBox[{
    RowBox[{
     SubscriptBox["\[Beta]", "sublead2"], "[", "5", "]"}], "\[Rule]", "0"}]}],
   "}"}]], "Output",
 CellChangeTimes->{3.555868624547008*^9, 3.555868772421707*^9}]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell["Simplifications", "Subsubsection",
 CellChangeTimes->{{3.555866616963666*^9, 3.5558666197227697`*^9}, {
  3.555869227213325*^9, 3.555869230258786*^9}, {3.555869281787188*^9, 
  3.5558693040481863`*^9}}],

Cell["\<\
Now we will simplify \[DoubleStruckCapitalC] entries by combining things \
together\
\>", "Text",
 CellChangeTimes->{{3.555868793141548*^9, 3.555868815483492*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"sub\[DoubleStruckCapitalC]simplify", "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"a_.", " ", 
         RowBox[{"\[DoubleStruckCapitalC]", "[", 
          RowBox[{
           RowBox[{"b_.", " ", 
            SubscriptBox[
             OverscriptBox["W", "^"], "e_"]}], "+", "c_."}], "]"}]}], "+", 
        RowBox[{"a2_.", " ", 
         RowBox[{"\[DoubleStruckCapitalC]", "[", 
          RowBox[{
           RowBox[{"b2_.", " ", 
            SubscriptBox[
             OverscriptBox["W", "^"], "e2_"]}], "+", "c2_."}], "]"}]}]}], 
       ")"}], "\[RuleDelayed]", 
      RowBox[{"\[DoubleStruckCapitalC]", "[", " ", 
       RowBox[{"Collect", "[", 
        RowBox[{
         RowBox[{
          RowBox[{
           RowBox[{"a", " ", "b", " ", 
            SubscriptBox[
             OverscriptBox["W", "^"], "e"]}], "+", 
           RowBox[{"a2", " ", "b2", " ", 
            SubscriptBox[
             OverscriptBox["W", "^"], "e2"]}], "+", 
           RowBox[{"a", " ", "c"}], "+", 
           RowBox[{"a2", " ", "c2"}]}], "//", "Expand"}], ",", 
         SubscriptBox[
          OverscriptBox["W", "^"], "_"], ",", "Simplify"}], "]"}], "]"}]}], 
     ",", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"a_.", " ", 
         RowBox[{"\[DoubleStruckCapitalC]", "[", 
          RowBox[{
           RowBox[{"b_.", " ", 
            SubsuperscriptBox["W", 
             RowBox[{"1", ",", "e_"}], "+"]}], "+", "c_."}], "]"}]}], "+", 
        RowBox[{"a2_.", " ", 
         RowBox[{"\[DoubleStruckCapitalC]", "[", 
          RowBox[{
           RowBox[{"b2_.", " ", 
            SubsuperscriptBox["W", 
             RowBox[{"1", ",", "e2_"}], "+"]}], "+", "c2_."}], "]"}]}]}], 
       ")"}], "\[RuleDelayed]", 
      RowBox[{"\[DoubleStruckCapitalC]", "[", " ", 
       RowBox[{"Collect", "[", 
        RowBox[{
         RowBox[{
          RowBox[{
           RowBox[{"a", " ", "b", " ", 
            SubsuperscriptBox["W", 
             RowBox[{"1", ",", "e"}], "+"]}], "+", 
           RowBox[{"a2", " ", "b2", " ", 
            SubsuperscriptBox["W", 
             RowBox[{"1", ",", "e2"}], "+"]}], "+", 
           RowBox[{"a", " ", "c"}], "+", 
           RowBox[{"a2", " ", "c2"}]}], "//", "Expand"}], ",", 
         SubsuperscriptBox["W", 
          RowBox[{"1", ",", "_"}], "+"], ",", "Simplify"}], "]"}], "]"}]}], 
     ",", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"a_.", " ", 
         RowBox[{"\[DoubleStruckCapitalC]", "[", 
          RowBox[{
           RowBox[{"b_.", " ", 
            SubscriptBox["H", "e_"]}], "+", "c_."}], "]"}]}], "+", 
        RowBox[{"a2_.", " ", 
         RowBox[{"\[DoubleStruckCapitalC]", "[", 
          RowBox[{
           RowBox[{"b2_.", " ", 
            SubscriptBox["H", "e2_"]}], "+", "c2_."}], "]"}]}]}], ")"}], 
      "\[RuleDelayed]", 
      RowBox[{"\[DoubleStruckCapitalC]", "[", " ", 
       RowBox[{"Collect", "[", 
        RowBox[{
         RowBox[{
          RowBox[{
           RowBox[{"a", " ", "b", " ", 
            SubscriptBox["H", "e"]}], "+", 
           RowBox[{"a2", " ", "b2", " ", 
            SubscriptBox["H", "e2"]}], "+", 
           RowBox[{"a", " ", "c"}], "+", 
           RowBox[{"a2", " ", "c2"}]}], "//", "Expand"}], ",", 
         SubscriptBox["H", "_"], ",", "Simplify"}], "]"}], "]"}]}]}], 
    "\[IndentingNewLine]", "}"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.555868816822505*^9, 3.555869121057111*^9}, 
   3.555869343152938*^9, {3.555869501602269*^9, 3.55586951399855*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"soluttmp1", "=", 
   RowBox[{
    RowBox[{
     RowBox[{"solut1", "//.", 
      RowBox[{
       RowBox[{"\[DoubleStruckCapitalC]", "[", "a_", "]"}], "\[RuleDelayed]", 
       
       RowBox[{"\[DoubleStruckCapitalC]", "[", 
        RowBox[{"a", "//", "Expand"}], "]"}]}]}], "//.", 
     "sub\[DoubleStruckCapitalC]simplify"}], "/.", 
    RowBox[{
     RowBox[{"\[DoubleStruckCapitalC]", "[", "a_", "]"}], "\[RuleDelayed]", 
     RowBox[{"\[DoubleStruckCapitalC]", "[", 
      RowBox[{"Collect", "[", 
       RowBox[{"a", ",", 
        RowBox[{"{", 
         RowBox[{
          SubscriptBox[
           OverscriptBox["W", "^"], "_"], ",", 
          SubsuperscriptBox["W", 
           RowBox[{"1", ",", "_"}], "+"], ",", 
          SubscriptBox["H", "_"]}], "}"}], ",", "Simplify"}], "]"}], 
      "]"}]}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"soluttmp2", "=", 
   RowBox[{
    RowBox[{
     RowBox[{"solut2", "//.", 
      RowBox[{
       RowBox[{"\[DoubleStruckCapitalC]", "[", "a_", "]"}], "\[RuleDelayed]", 
       
       RowBox[{"\[DoubleStruckCapitalC]", "[", 
        RowBox[{"a", "//", "Expand"}], "]"}]}]}], "//.", 
     "sub\[DoubleStruckCapitalC]simplify"}], "/.", 
    RowBox[{
     RowBox[{"\[DoubleStruckCapitalC]", "[", "a_", "]"}], "\[RuleDelayed]", 
     RowBox[{"\[DoubleStruckCapitalC]", "[", 
      RowBox[{"Collect", "[", 
       RowBox[{"a", ",", 
        RowBox[{"{", 
         RowBox[{
          SubscriptBox[
           OverscriptBox["W", "^"], "_"], ",", 
          SubsuperscriptBox["W", 
           RowBox[{"1", ",", "_"}], "+"], ",", 
          SubscriptBox["H", "_"]}], "}"}], ",", "Simplify"}], "]"}], 
      "]"}]}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"soluttmp3", "=", 
   RowBox[{
    RowBox[{
     RowBox[{"solut3", "//.", 
      RowBox[{
       RowBox[{"\[DoubleStruckCapitalC]", "[", "a_", "]"}], "\[RuleDelayed]", 
       
       RowBox[{"\[DoubleStruckCapitalC]", "[", 
        RowBox[{"a", "//", "Expand"}], "]"}]}]}], "//.", 
     "sub\[DoubleStruckCapitalC]simplify"}], "/.", 
    RowBox[{
     RowBox[{"\[DoubleStruckCapitalC]", "[", "a_", "]"}], "\[RuleDelayed]", 
     RowBox[{"\[DoubleStruckCapitalC]", "[", 
      RowBox[{"Collect", "[", 
       RowBox[{"a", ",", 
        RowBox[{"{", 
         RowBox[{
          SubscriptBox[
           OverscriptBox["W", "^"], "_"], ",", 
          SubsuperscriptBox["W", 
           RowBox[{"1", ",", "_"}], "+"], ",", 
          SubscriptBox["H", "_"]}], "}"}], ",", "Simplify"}], "]"}], 
      "]"}]}]}]}], ";"}]}], "Input",
 CellChangeTimes->{{3.555869143284666*^9, 3.55586916185602*^9}, {
  3.555869351096064*^9, 3.55586946215184*^9}, {3.5558695551566677`*^9, 
  3.555869595121279*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"solut\[Rho]s", "=", 
   RowBox[{"Join", "[", 
    RowBox[{"soluttmp1", ",", "soluttmp2", ",", "soluttmp3"}], "]"}]}], 
  ";"}]], "Input",
 CellChangeTimes->{{3.555869693648628*^9, 3.555869706890761*^9}}],

Cell[CellGroupData[{

Cell[BoxData["solut\[Rho]s"], "Input"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{
    RowBox[{
     SubscriptBox["\[Alpha]", "lead"], "[", "0", "]"}], "\[Rule]", 
    RowBox[{
     RowBox[{"-", "162"}], "+", 
     RowBox[{"\[DoubleStruckCapitalC]", "[", 
      FractionBox[
       RowBox[{"2", " ", 
        RowBox[{"(", 
         RowBox[{"\[ImaginaryI]", "+", "u"}], ")"}], " ", 
        SubscriptBox[
         StyleBox["H",
          FontColor->RGBColor[0.54, 0.35, 0.15]], "lead"]}], 
       RowBox[{"9", " ", 
        SuperscriptBox["u", "2"]}]], "]"}], "-", 
     RowBox[{
      FractionBox["1", "9"], " ", 
      RowBox[{"\[DoubleStruckCapitalC]", "[", 
       RowBox[{"-", 
        FractionBox[
         RowBox[{"4", " ", 
          RowBox[{"(", 
           RowBox[{"\[ImaginaryI]", "+", "u"}], ")"}], " ", 
          SubsuperscriptBox[
           StyleBox["W",
            FontColor->RGBColor[0.54, 0.35, 0.15]], 
           RowBox[{"1", ",", "lead"}], "+"]}], 
         SuperscriptBox[
          StyleBox["Q0",
           FontColor->RGBColor[{
              Rational[1, 2], 
              Rational[1, 2], 0}]], "+"]]}], "]"}]}], "+", 
     RowBox[{"\[DoubleStruckCapitalC]", "[", 
      RowBox[{"-", 
       FractionBox[
        RowBox[{"2", " ", "\[ImaginaryI]", " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"-", "1"}], "+", 
           RowBox[{"2", " ", 
            SuperscriptBox["u", "2"]}], "+", 
           RowBox[{"3", " ", 
            SuperscriptBox["u", "4"]}], "+", 
           RowBox[{"9", " ", 
            SuperscriptBox[
             StyleBox["Q0",
              FontColor->RGBColor[{
                 Rational[1, 2], 
                 Rational[1, 2], 0}]], "-"], " ", 
            SuperscriptBox[
             StyleBox["Q0",
              FontColor->RGBColor[{
                 Rational[1, 2], 
                 Rational[1, 2], 0}]], "+"]}]}], ")"}], " ", 
         SubscriptBox[
          OverscriptBox[
           StyleBox["W",
            FontColor->RGBColor[0.54, 0.35, 0.15]], 
           StyleBox["^",
            FontColor->RGBColor[0.54, 0.35, 0.15]]], "lead"]}], 
        RowBox[{"27", " ", 
         RowBox[{"(", 
          RowBox[{"1", "+", 
           SuperscriptBox["u", "2"]}], ")"}], " ", 
         SuperscriptBox[
          StyleBox["Q0",
           FontColor->RGBColor[{
              Rational[1, 2], 
              Rational[1, 2], 0}]], "-"], " ", 
         SuperscriptBox[
          StyleBox["Q0",
           FontColor->RGBColor[{
              Rational[1, 2], 
              Rational[1, 2], 0}]], "+"]}]]}], "]"}], "-", 
     RowBox[{
      FractionBox["2", "9"], " ", 
      SubscriptBox[
       StyleBox["W",
        FontColor->RGBColor[0.54, 0.35, 0.15]], 
       RowBox[{"1", ",", "v0", ",", "lead"}]]}], "+", 
     RowBox[{"60", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2"]}], "+", 
     RowBox[{"24", " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2", "2"]}], "-", 
     FractionBox[
      RowBox[{"16", " ", 
       SubsuperscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "2", "3"]}], "5"], "+", 
     RowBox[{"156", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3"]}], "-", 
     RowBox[{"88", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3"]}], "+", 
     RowBox[{
      FractionBox["16", "5"], " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2", "2"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3"]}], "-", 
     RowBox[{"8", " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3", "2"]}]}]}], ",", 
   RowBox[{
    RowBox[{
     SubscriptBox["\[Beta]", "lead"], "[", "0", "]"}], "\[Rule]", 
    RowBox[{
     FractionBox["1", "30"], " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"-", "4860"}], "+", 
       RowBox[{"\[DoubleStruckCapitalC]", "[", 
        FractionBox[
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{"20", " ", "\[ImaginaryI]"}], "-", 
            RowBox[{"40", " ", "u"}]}], ")"}], " ", 
          SubscriptBox[
           StyleBox["H",
            FontColor->RGBColor[0.54, 0.35, 0.15]], "lead"]}], 
         SuperscriptBox["u", "2"]], "]"}], "+", 
       RowBox[{"20", " ", 
        RowBox[{"\[DoubleStruckCapitalC]", "[", 
         RowBox[{"-", 
          FractionBox[
           RowBox[{"4", " ", 
            RowBox[{"(", 
             RowBox[{"\[ImaginaryI]", "+", "u"}], ")"}], " ", 
            SubsuperscriptBox[
             StyleBox["W",
              FontColor->RGBColor[0.54, 0.35, 0.15]], 
             RowBox[{"1", ",", "lead"}], "+"]}], 
           SuperscriptBox[
            StyleBox["Q0",
             FontColor->RGBColor[{
                Rational[1, 2], 
                Rational[1, 2], 0}]], "+"]]}], "]"}]}], "+", 
       RowBox[{"\[DoubleStruckCapitalC]", "[", 
        FractionBox[
         RowBox[{"20", " ", "\[ImaginaryI]", " ", 
          RowBox[{"(", 
           RowBox[{"1", "+", 
            RowBox[{"16", " ", 
             SuperscriptBox["u", "2"]}], "+", 
            RowBox[{"15", " ", 
             SuperscriptBox["u", "4"]}], "-", 
            RowBox[{"9", " ", 
             SuperscriptBox[
              StyleBox["Q0",
               FontColor->RGBColor[{
                  Rational[1, 2], 
                  Rational[1, 2], 0}]], "-"], " ", 
             SuperscriptBox[
              StyleBox["Q0",
               FontColor->RGBColor[{
                  Rational[1, 2], 
                  Rational[1, 2], 0}]], "+"]}]}], ")"}], " ", 
          SubscriptBox[
           OverscriptBox[
            StyleBox["W",
             FontColor->RGBColor[0.54, 0.35, 0.15]], 
            StyleBox["^",
             FontColor->RGBColor[0.54, 0.35, 0.15]]], "lead"]}], 
         RowBox[{"3", " ", 
          RowBox[{"(", 
           RowBox[{"1", "+", 
            SuperscriptBox["u", "2"]}], ")"}], " ", 
          SuperscriptBox[
           StyleBox["Q0",
            FontColor->RGBColor[{
               Rational[1, 2], 
               Rational[1, 2], 0}]], "-"], " ", 
          SuperscriptBox[
           StyleBox["Q0",
            FontColor->RGBColor[{
               Rational[1, 2], 
               Rational[1, 2], 0}]], "+"]}]], "]"}], "+", 
       RowBox[{"100", " ", 
        SubscriptBox[
         StyleBox["W",
          FontColor->RGBColor[0.54, 0.35, 0.15]], 
         RowBox[{"1", ",", "v0", ",", "lead"}]]}], "+", 
       RowBox[{"11880", " ", 
        SubscriptBox[
         StyleBox["\[Zeta]",
          FontWeight->Bold,
          FontColor->GrayLevel[0.4]], "2"]}], "-", 
       RowBox[{"5616", " ", 
        SubsuperscriptBox[
         StyleBox["\[Zeta]",
          FontWeight->Bold,
          FontColor->GrayLevel[0.4]], "2", "2"]}], "+", 
       RowBox[{"576", " ", 
        SubsuperscriptBox[
         StyleBox["\[Zeta]",
          FontWeight->Bold,
          FontColor->GrayLevel[0.4]], "2", "3"]}], "-", 
       RowBox[{"5400", " ", 
        SubscriptBox[
         StyleBox["\[Zeta]",
          FontWeight->Bold,
          FontColor->GrayLevel[0.4]], "3"]}], "+", 
       RowBox[{"720", " ", 
        SubscriptBox[
         StyleBox["\[Zeta]",
          FontWeight->Bold,
          FontColor->GrayLevel[0.4]], "2"], " ", 
        SubscriptBox[
         StyleBox["\[Zeta]",
          FontWeight->Bold,
          FontColor->GrayLevel[0.4]], "3"]}], "+", 
       RowBox[{"288", " ", 
        SubsuperscriptBox[
         StyleBox["\[Zeta]",
          FontWeight->Bold,
          FontColor->GrayLevel[0.4]], "2", "2"], " ", 
        SubscriptBox[
         StyleBox["\[Zeta]",
          FontWeight->Bold,
          FontColor->GrayLevel[0.4]], "3"]}], "+", 
       RowBox[{"1440", " ", 
        SubsuperscriptBox[
         StyleBox["\[Zeta]",
          FontWeight->Bold,
          FontColor->GrayLevel[0.4]], "3", "2"]}]}], ")"}]}]}], ",", 
   RowBox[{
    RowBox[{
     SubscriptBox["\[Alpha]", "lead"], "[", "1", "]"}], "\[Rule]", 
    RowBox[{"648", "+", 
     RowBox[{"\[DoubleStruckCapitalC]", "[", 
      RowBox[{"-", 
       FractionBox[
        RowBox[{"8", " ", 
         RowBox[{"(", 
          RowBox[{"\[ImaginaryI]", "+", "u"}], ")"}], " ", 
         SubscriptBox[
          StyleBox["H",
           FontColor->RGBColor[0.54, 0.35, 0.15]], "lead"]}], 
        RowBox[{"9", " ", 
         SuperscriptBox["u", "2"]}]]}], "]"}], "+", 
     RowBox[{
      FractionBox["4", "9"], " ", 
      RowBox[{"\[DoubleStruckCapitalC]", "[", 
       RowBox[{"-", 
        FractionBox[
         RowBox[{"4", " ", 
          RowBox[{"(", 
           RowBox[{"\[ImaginaryI]", "+", "u"}], ")"}], " ", 
          SubsuperscriptBox[
           StyleBox["W",
            FontColor->RGBColor[0.54, 0.35, 0.15]], 
           RowBox[{"1", ",", "lead"}], "+"]}], 
         SuperscriptBox[
          StyleBox["Q0",
           FontColor->RGBColor[{
              Rational[1, 2], 
              Rational[1, 2], 0}]], "+"]]}], "]"}]}], "+", 
     RowBox[{"\[DoubleStruckCapitalC]", "[", 
      RowBox[{"-", 
       FractionBox[
        RowBox[{"8", " ", "\[ImaginaryI]", " ", 
         RowBox[{"(", 
          RowBox[{"4", "+", 
           RowBox[{"10", " ", 
            SuperscriptBox["u", "2"]}], "+", 
           RowBox[{"6", " ", 
            SuperscriptBox["u", "4"]}], "-", 
           RowBox[{"9", " ", 
            SuperscriptBox[
             StyleBox["Q0",
              FontColor->RGBColor[{
                 Rational[1, 2], 
                 Rational[1, 2], 0}]], "-"], " ", 
            SuperscriptBox[
             StyleBox["Q0",
              FontColor->RGBColor[{
                 Rational[1, 2], 
                 Rational[1, 2], 0}]], "+"]}]}], ")"}], " ", 
         SubscriptBox[
          OverscriptBox[
           StyleBox["W",
            FontColor->RGBColor[0.54, 0.35, 0.15]], 
           StyleBox["^",
            FontColor->RGBColor[0.54, 0.35, 0.15]]], "lead"]}], 
        RowBox[{"27", " ", 
         RowBox[{"(", 
          RowBox[{"1", "+", 
           SuperscriptBox["u", "2"]}], ")"}], " ", 
         SuperscriptBox[
          StyleBox["Q0",
           FontColor->RGBColor[{
              Rational[1, 2], 
              Rational[1, 2], 0}]], "-"], " ", 
         SuperscriptBox[
          StyleBox["Q0",
           FontColor->RGBColor[{
              Rational[1, 2], 
              Rational[1, 2], 0}]], "+"]}]]}], "]"}], "-", 
     RowBox[{
      FractionBox["16", "9"], " ", 
      SubscriptBox[
       StyleBox["W",
        FontColor->RGBColor[0.54, 0.35, 0.15]], 
       RowBox[{"1", ",", "v0", ",", "lead"}]]}], "-", 
     RowBox[{"240", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2"]}], "-", 
     RowBox[{"96", " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2", "2"]}], "+", 
     FractionBox[
      RowBox[{"64", " ", 
       SubsuperscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "2", "3"]}], "5"], "-", 
     RowBox[{"624", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3"]}], "+", 
     RowBox[{"352", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3"]}], "-", 
     RowBox[{
      FractionBox["64", "5"], " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2", "2"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3"]}], "+", 
     RowBox[{"32", " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3", "2"]}]}]}], ",", 
   RowBox[{
    RowBox[{
     SubscriptBox["\[Beta]", "lead"], "[", "1", "]"}], "\[Rule]", "0"}], ",", 
   
   RowBox[{
    RowBox[{
     SubscriptBox["\[Alpha]", "lead"], "[", "2", "]"}], "\[Rule]", "0"}], ",", 
   RowBox[{
    RowBox[{
     SubscriptBox["\[Beta]", "lead"], "[", "2", "]"}], "\[Rule]", "0"}], ",", 
   
   RowBox[{
    RowBox[{
     SubscriptBox["\[Alpha]", "lead"], "[", "3", "]"}], "\[Rule]", "0"}], ",", 
   RowBox[{
    RowBox[{
     SubscriptBox["\[Beta]", "lead"], "[", "3", "]"}], "\[Rule]", "0"}], ",", 
   
   RowBox[{
    RowBox[{
     SubscriptBox["\[Alpha]", "lead"], "[", "4", "]"}], "\[Rule]", "0"}], ",", 
   RowBox[{
    RowBox[{
     SubscriptBox["\[Beta]", "lead"], "[", "4", "]"}], "\[Rule]", "0"}], ",", 
   
   RowBox[{
    RowBox[{
     SubscriptBox["\[Alpha]", "lead"], "[", "5", "]"}], "\[Rule]", "0"}], ",", 
   RowBox[{
    RowBox[{
     SubscriptBox["\[Beta]", "lead"], "[", "5", "]"}], "\[Rule]", "0"}], ",", 
   
   RowBox[{
    RowBox[{
     SubscriptBox["\[Alpha]", "sublead"], "[", "0", "]"}], "\[Rule]", 
    RowBox[{"2826", "+", 
     RowBox[{"\[DoubleStruckCapitalC]", "[", 
      RowBox[{
       FractionBox[
        RowBox[{"4", " ", "\[ImaginaryI]", " ", 
         RowBox[{"(", 
          RowBox[{"1", "+", 
           RowBox[{"3", " ", 
            SuperscriptBox["u", "2"]}]}], ")"}], " ", 
         SubscriptBox[
          StyleBox["H",
           FontColor->RGBColor[0.54, 0.35, 0.15]], "lead"]}], 
        RowBox[{"9", " ", 
         SuperscriptBox["u", "4"]}]], "+", 
       FractionBox[
        RowBox[{"2", " ", 
         RowBox[{"(", 
          RowBox[{"\[ImaginaryI]", "+", "u"}], ")"}], " ", 
         SubscriptBox[
          StyleBox["H",
           FontColor->RGBColor[0.54, 0.35, 0.15]], "sublead"]}], 
        RowBox[{"9", " ", 
         SuperscriptBox["u", "2"]}]]}], "]"}], "-", 
     RowBox[{
      FractionBox["1", "9"], " ", 
      RowBox[{"\[DoubleStruckCapitalC]", "[", 
       RowBox[{
        RowBox[{"-", 
         FractionBox[
          RowBox[{"4", " ", 
           SuperscriptBox[
            RowBox[{"(", 
             RowBox[{"\[ImaginaryI]", "+", 
              RowBox[{"2", " ", "u"}]}], ")"}], "2"], " ", 
           RowBox[{"(", 
            RowBox[{"1", "+", 
             RowBox[{"\[ImaginaryI]", " ", "u"}], "+", 
             SuperscriptBox["u", "2"]}], ")"}], " ", 
           SubsuperscriptBox[
            StyleBox["W",
             FontColor->RGBColor[0.54, 0.35, 0.15]], 
            RowBox[{"1", ",", "lead"}], "+"]}], 
          RowBox[{"3", " ", 
           SuperscriptBox["u", "2"], " ", 
           RowBox[{"(", 
            RowBox[{"\[ImaginaryI]", "+", "u"}], ")"}], " ", 
           SuperscriptBox[
            RowBox[{"(", 
             SuperscriptBox[
              StyleBox["Q0",
               FontColor->RGBColor[{
                  Rational[1, 2], 
                  Rational[1, 2], 0}]], "+"], ")"}], "2"]}]]}], "-", 
        FractionBox[
         RowBox[{"4", " ", 
          RowBox[{"(", 
           RowBox[{"\[ImaginaryI]", "+", "u"}], ")"}], " ", 
          SubsuperscriptBox[
           StyleBox["W",
            FontColor->RGBColor[0.54, 0.35, 0.15]], 
           RowBox[{"1", ",", "sublead"}], "+"]}], 
         SuperscriptBox[
          StyleBox["Q0",
           FontColor->RGBColor[{
              Rational[1, 2], 
              Rational[1, 2], 0}]], "+"]]}], "]"}]}], "+", 
     RowBox[{"\[DoubleStruckCapitalC]", "[", 
      RowBox[{
       RowBox[{
        FractionBox["1", 
         RowBox[{"243", " ", 
          SuperscriptBox[
           RowBox[{"(", 
            RowBox[{"1", "+", 
             SuperscriptBox["u", "2"]}], ")"}], "2"], " ", 
          SuperscriptBox[
           RowBox[{"(", 
            SuperscriptBox[
             StyleBox["Q0",
              FontColor->RGBColor[{
                 Rational[1, 2], 
                 Rational[1, 2], 0}]], "-"], ")"}], "2"], " ", 
          SuperscriptBox[
           RowBox[{"(", 
            SuperscriptBox[
             StyleBox["Q0",
              FontColor->RGBColor[{
                 Rational[1, 2], 
                 Rational[1, 2], 0}]], "+"], ")"}], "2"]}]], 
        RowBox[{"4", " ", "\[ImaginaryI]", " ", 
         RowBox[{"(", 
          RowBox[{"13", "+", 
           RowBox[{"765", " ", 
            SuperscriptBox["u", "8"]}], "+", 
           RowBox[{"324", " ", 
            SuperscriptBox["u", "10"]}], "-", 
           RowBox[{"27", " ", 
            SuperscriptBox[
             StyleBox["Q0",
              FontColor->RGBColor[{
                 Rational[1, 2], 
                 Rational[1, 2], 0}]], "-"], " ", 
            SuperscriptBox[
             StyleBox["Q0",
              FontColor->RGBColor[{
                 Rational[1, 2], 
                 Rational[1, 2], 0}]], "+"]}], "-", 
           RowBox[{"405", " ", 
            SuperscriptBox[
             RowBox[{"(", 
              SuperscriptBox[
               StyleBox["Q0",
                FontColor->RGBColor[{
                   Rational[1, 2], 
                   Rational[1, 2], 0}]], "-"], ")"}], "2"], " ", 
            SuperscriptBox[
             RowBox[{"(", 
              SuperscriptBox[
               StyleBox["Q0",
                FontColor->RGBColor[{
                   Rational[1, 2], 
                   Rational[1, 2], 0}]], "+"], ")"}], "2"]}], "+", 
           RowBox[{
            SuperscriptBox["u", "4"], " ", 
            RowBox[{"(", 
             RowBox[{"370", "-", 
              RowBox[{"189", " ", 
               SuperscriptBox[
                StyleBox["Q0",
                 FontColor->RGBColor[{
                    Rational[1, 2], 
                    Rational[1, 2], 0}]], "-"], " ", 
               SuperscriptBox[
                StyleBox["Q0",
                 FontColor->RGBColor[{
                    Rational[1, 2], 
                    Rational[1, 2], 0}]], "+"]}]}], ")"}]}], "+", 
           RowBox[{
            SuperscriptBox["u", "6"], " ", 
            RowBox[{"(", 
             RowBox[{"615", "-", 
              RowBox[{"81", " ", 
               SuperscriptBox[
                StyleBox["Q0",
                 FontColor->RGBColor[{
                    Rational[1, 2], 
                    Rational[1, 2], 0}]], "-"], " ", 
               SuperscriptBox[
                StyleBox["Q0",
                 FontColor->RGBColor[{
                    Rational[1, 2], 
                    Rational[1, 2], 0}]], "+"]}]}], ")"}]}], "-", 
           RowBox[{"3", " ", 
            SuperscriptBox["u", "2"], " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "37"}], "+", 
              RowBox[{"45", " ", 
               SuperscriptBox[
                StyleBox["Q0",
                 FontColor->RGBColor[{
                    Rational[1, 2], 
                    Rational[1, 2], 0}]], "-"], " ", 
               SuperscriptBox[
                StyleBox["Q0",
                 FontColor->RGBColor[{
                    Rational[1, 2], 
                    Rational[1, 2], 0}]], "+"]}], "+", 
              RowBox[{"135", " ", 
               SuperscriptBox[
                RowBox[{"(", 
                 SuperscriptBox[
                  StyleBox["Q0",
                   FontColor->RGBColor[{
                    Rational[1, 2], 
                    Rational[1, 2], 0}]], "-"], ")"}], "2"], " ", 
               SuperscriptBox[
                RowBox[{"(", 
                 SuperscriptBox[
                  StyleBox["Q0",
                   FontColor->RGBColor[{
                    Rational[1, 2], 
                    Rational[1, 2], 0}]], "+"], ")"}], "2"]}]}], ")"}]}]}], 
          ")"}], " ", 
         SubscriptBox[
          OverscriptBox[
           StyleBox["W",
            FontColor->RGBColor[0.54, 0.35, 0.15]], 
           StyleBox["^",
            FontColor->RGBColor[0.54, 0.35, 0.15]]], "lead"]}]}], "-", 
       FractionBox[
        RowBox[{"2", " ", "\[ImaginaryI]", " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"24", " ", 
            SuperscriptBox["u", "4"]}], "+", 
           RowBox[{"45", " ", 
            SuperscriptBox["u", "6"]}], "+", 
           RowBox[{"27", " ", 
            SuperscriptBox["u", "8"]}], "+", 
           RowBox[{
            SuperscriptBox["u", "2"], " ", 
            RowBox[{"(", 
             RowBox[{"7", "-", 
              RowBox[{"18", " ", 
               SuperscriptBox[
                StyleBox["Q0",
                 FontColor->RGBColor[{
                    Rational[1, 2], 
                    Rational[1, 2], 0}]], "-"], " ", 
               SuperscriptBox[
                StyleBox["Q0",
                 FontColor->RGBColor[{
                    Rational[1, 2], 
                    Rational[1, 2], 0}]], "+"]}]}], ")"}]}], "+", 
           SuperscriptBox[
            RowBox[{"(", 
             RowBox[{"1", "-", 
              RowBox[{"9", " ", 
               SuperscriptBox[
                StyleBox["Q0",
                 FontColor->RGBColor[{
                    Rational[1, 2], 
                    Rational[1, 2], 0}]], "-"], " ", 
               SuperscriptBox[
                StyleBox["Q0",
                 FontColor->RGBColor[{
                    Rational[1, 2], 
                    Rational[1, 2], 0}]], "+"]}]}], ")"}], "2"]}], ")"}], " ", 
         SubscriptBox[
          OverscriptBox[
           StyleBox["W",
            FontColor->RGBColor[0.54, 0.35, 0.15]], 
           StyleBox["^",
            FontColor->RGBColor[0.54, 0.35, 0.15]]], "sublead"]}], 
        RowBox[{"243", " ", 
         RowBox[{"(", 
          RowBox[{"1", "+", 
           SuperscriptBox["u", "2"]}], ")"}], " ", 
         SuperscriptBox[
          RowBox[{"(", 
           SuperscriptBox[
            StyleBox["Q0",
             FontColor->RGBColor[{
                Rational[1, 2], 
                Rational[1, 2], 0}]], "-"], ")"}], "2"], " ", 
         SuperscriptBox[
          RowBox[{"(", 
           SuperscriptBox[
            StyleBox["Q0",
             FontColor->RGBColor[{
                Rational[1, 2], 
                Rational[1, 2], 0}]], "+"], ")"}], "2"]}]]}], "]"}], "-", 
     RowBox[{
      FractionBox["4", "3"], " ", 
      SubscriptBox[
       StyleBox["W",
        FontColor->RGBColor[0.54, 0.35, 0.15]], 
       RowBox[{"1", ",", "v0", ",", "lead"}]]}], "-", 
     RowBox[{
      FractionBox["2", "9"], " ", 
      SubscriptBox[
       StyleBox["W",
        FontColor->RGBColor[0.54, 0.35, 0.15]], 
       RowBox[{"1", ",", "v0", ",", "sublead"}]]}], "+", 
     RowBox[{"420", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2"]}], "-", 
     RowBox[{"720", " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2", "2"]}], "+", 
     FractionBox[
      RowBox[{"1328", " ", 
       SubsuperscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "2", "3"]}], "5"], "-", 
     FractionBox[
      RowBox[{"288", " ", 
       SubsuperscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "2", "4"]}], "175"], "-", 
     RowBox[{"2748", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3"]}], "-", 
     RowBox[{"1256", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3"]}], "+", 
     RowBox[{
      FractionBox["784", "5"], " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2", "2"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3"]}], "-", 
     RowBox[{
      FractionBox["256", "35"], " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2", "3"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3"]}], "+", 
     RowBox[{"1552", " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3", "2"]}], "+", 
     RowBox[{"96", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2"], " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3", "2"]}], "-", 
     RowBox[{"468", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "5"]}], "+", 
     RowBox[{"504", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "5"]}], "-", 
     RowBox[{
      FractionBox["48", "5"], " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2", "2"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "5"]}], "-", 
     RowBox[{"192", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "5"]}]}]}], ",", 
   RowBox[{
    RowBox[{
     SubscriptBox["\[Beta]", "sublead"], "[", "0", "]"}], "\[Rule]", 
    RowBox[{"7992", "+", 
     RowBox[{"\[DoubleStruckCapitalC]", "[", 
      RowBox[{
       FractionBox[
        RowBox[{"2", " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"2", " ", "\[ImaginaryI]"}], "-", 
           RowBox[{"\[ImaginaryI]", " ", 
            SuperscriptBox["u", "2"]}], "+", 
           RowBox[{"8", " ", 
            SuperscriptBox["u", "3"]}]}], ")"}], " ", 
         SubscriptBox[
          StyleBox["H",
           FontColor->RGBColor[0.54, 0.35, 0.15]], "lead"]}], 
        RowBox[{"3", " ", 
         SuperscriptBox["u", "4"]}]], "+", 
       FractionBox[
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           RowBox[{"2", " ", "\[ImaginaryI]"}], "-", 
           RowBox[{"4", " ", "u"}]}], ")"}], " ", 
         SubscriptBox[
          StyleBox["H",
           FontColor->RGBColor[0.54, 0.35, 0.15]], "sublead"]}], 
        RowBox[{"3", " ", 
         SuperscriptBox["u", "2"]}]]}], "]"}], "+", 
     RowBox[{"\[DoubleStruckCapitalC]", "[", 
      RowBox[{
       FractionBox[
        RowBox[{"8", " ", 
         RowBox[{"(", 
          RowBox[{"1", "-", 
           RowBox[{"3", " ", "\[ImaginaryI]", " ", "u"}], "+", 
           RowBox[{
            SuperscriptBox["u", "2"], " ", 
            RowBox[{"(", 
             RowBox[{"1", "-", 
              RowBox[{"12", " ", 
               SuperscriptBox[
                StyleBox["Q0",
                 FontColor->RGBColor[{
                    Rational[1, 2], 
                    Rational[1, 2], 0}]], "+"]}]}], ")"}]}], "+", 
           RowBox[{"8", " ", "\[ImaginaryI]", " ", 
            SuperscriptBox["u", "3"], " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "1"}], "+", 
              RowBox[{"3", " ", 
               SuperscriptBox[
                StyleBox["Q0",
                 FontColor->RGBColor[{
                    Rational[1, 2], 
                    Rational[1, 2], 0}]], "+"]}]}], ")"}]}], "+", 
           RowBox[{"4", " ", 
            SuperscriptBox["u", "4"], " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "1"}], "+", 
              RowBox[{"3", " ", 
               SuperscriptBox[
                StyleBox["Q0",
                 FontColor->RGBColor[{
                    Rational[1, 2], 
                    Rational[1, 2], 0}]], "+"]}]}], ")"}]}]}], ")"}], " ", 
         SubsuperscriptBox[
          StyleBox["W",
           FontColor->RGBColor[0.54, 0.35, 0.15]], 
          RowBox[{"1", ",", "lead"}], "+"]}], 
        RowBox[{"9", " ", 
         SuperscriptBox["u", "2"], " ", 
         RowBox[{"(", 
          RowBox[{"\[ImaginaryI]", "+", "u"}], ")"}], " ", 
         SuperscriptBox[
          RowBox[{"(", 
           SuperscriptBox[
            StyleBox["Q0",
             FontColor->RGBColor[{
                Rational[1, 2], 
                Rational[1, 2], 0}]], "+"], ")"}], "2"]}]], "-", 
       FractionBox[
        RowBox[{"8", " ", 
         RowBox[{"(", 
          RowBox[{"\[ImaginaryI]", "+", "u"}], ")"}], " ", 
         SubsuperscriptBox[
          StyleBox["W",
           FontColor->RGBColor[0.54, 0.35, 0.15]], 
          RowBox[{"1", ",", "sublead"}], "+"]}], 
        RowBox[{"3", " ", 
         SuperscriptBox[
          StyleBox["Q0",
           FontColor->RGBColor[{
              Rational[1, 2], 
              Rational[1, 2], 0}]], "+"]}]]}], "]"}], "+", 
     RowBox[{"\[DoubleStruckCapitalC]", "[", 
      RowBox[{
       RowBox[{"-", 
        RowBox[{
         FractionBox["1", 
          RowBox[{"81", " ", 
           SuperscriptBox[
            RowBox[{"(", 
             RowBox[{"1", "+", 
              SuperscriptBox["u", "2"]}], ")"}], "2"], " ", 
           SuperscriptBox[
            RowBox[{"(", 
             SuperscriptBox[
              StyleBox["Q0",
               FontColor->RGBColor[{
                  Rational[1, 2], 
                  Rational[1, 2], 0}]], "-"], ")"}], "2"], " ", 
           SuperscriptBox[
            RowBox[{"(", 
             SuperscriptBox[
              StyleBox["Q0",
               FontColor->RGBColor[{
                  Rational[1, 2], 
                  Rational[1, 2], 0}]], "+"], ")"}], "2"]}]], 
         RowBox[{"2", " ", "\[ImaginaryI]", " ", 
          RowBox[{"(", 
           RowBox[{"64", "+", 
            RowBox[{"2736", " ", 
             SuperscriptBox["u", "8"]}], "+", 
            RowBox[{"1296", " ", 
             SuperscriptBox["u", "10"]}], "-", 
            RowBox[{"261", " ", 
             SuperscriptBox[
              StyleBox["Q0",
               FontColor->RGBColor[{
                  Rational[1, 2], 
                  Rational[1, 2], 0}]], "-"], " ", 
             SuperscriptBox[
              StyleBox["Q0",
               FontColor->RGBColor[{
                  Rational[1, 2], 
                  Rational[1, 2], 0}]], "+"]}], "-", 
            RowBox[{"729", " ", 
             SuperscriptBox[
              RowBox[{"(", 
               SuperscriptBox[
                StyleBox["Q0",
                 FontColor->RGBColor[{
                    Rational[1, 2], 
                    Rational[1, 2], 0}]], "-"], ")"}], "2"], " ", 
             SuperscriptBox[
              RowBox[{"(", 
               SuperscriptBox[
                StyleBox["Q0",
                 FontColor->RGBColor[{
                    Rational[1, 2], 
                    Rational[1, 2], 0}]], "+"], ")"}], "2"]}], "+", 
            RowBox[{
             SuperscriptBox["u", "4"], " ", 
             RowBox[{"(", 
              RowBox[{"1096", "-", 
               RowBox[{"963", " ", 
                SuperscriptBox[
                 StyleBox["Q0",
                  FontColor->RGBColor[{
                    Rational[1, 2], 
                    Rational[1, 2], 0}]], "-"], " ", 
                SuperscriptBox[
                 StyleBox["Q0",
                  FontColor->RGBColor[{
                    Rational[1, 2], 
                    Rational[1, 2], 0}]], "+"]}]}], ")"}]}], "+", 
            RowBox[{
             SuperscriptBox["u", "6"], " ", 
             RowBox[{"(", 
              RowBox[{"1776", "-", 
               RowBox[{"351", " ", 
                SuperscriptBox[
                 StyleBox["Q0",
                  FontColor->RGBColor[{
                    Rational[1, 2], 
                    Rational[1, 2], 0}]], "-"], " ", 
                SuperscriptBox[
                 StyleBox["Q0",
                  FontColor->RGBColor[{
                    Rational[1, 2], 
                    Rational[1, 2], 0}]], "+"]}]}], ")"}]}], "-", 
            RowBox[{"9", " ", 
             SuperscriptBox["u", "2"], " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"-", "48"}], "+", 
               RowBox[{"97", " ", 
                SuperscriptBox[
                 StyleBox["Q0",
                  FontColor->RGBColor[{
                    Rational[1, 2], 
                    Rational[1, 2], 0}]], "-"], " ", 
                SuperscriptBox[
                 StyleBox["Q0",
                  FontColor->RGBColor[{
                    Rational[1, 2], 
                    Rational[1, 2], 0}]], "+"]}], "+", 
               RowBox[{"81", " ", 
                SuperscriptBox[
                 RowBox[{"(", 
                  SuperscriptBox[
                   StyleBox["Q0",
                    FontColor->RGBColor[{
                    Rational[1, 2], 
                    Rational[1, 2], 0}]], "-"], ")"}], "2"], " ", 
                SuperscriptBox[
                 RowBox[{"(", 
                  SuperscriptBox[
                   StyleBox["Q0",
                    FontColor->RGBColor[{
                    Rational[1, 2], 
                    Rational[1, 2], 0}]], "+"], ")"}], "2"]}]}], ")"}]}]}], 
           ")"}], " ", 
          SubscriptBox[
           OverscriptBox[
            StyleBox["W",
             FontColor->RGBColor[0.54, 0.35, 0.15]], 
            StyleBox["^",
             FontColor->RGBColor[0.54, 0.35, 0.15]]], "lead"]}]}]}], "+", 
       FractionBox[
        RowBox[{"2", " ", "\[ImaginaryI]", " ", 
         RowBox[{"(", 
          RowBox[{"5", "+", 
           RowBox[{"120", " ", 
            SuperscriptBox["u", "4"]}], "+", 
           RowBox[{"225", " ", 
            SuperscriptBox["u", "6"]}], "+", 
           RowBox[{"135", " ", 
            SuperscriptBox["u", "8"]}], "-", 
           RowBox[{"36", " ", 
            SuperscriptBox[
             StyleBox["Q0",
              FontColor->RGBColor[{
                 Rational[1, 2], 
                 Rational[1, 2], 0}]], "-"], " ", 
            SuperscriptBox[
             StyleBox["Q0",
              FontColor->RGBColor[{
                 Rational[1, 2], 
                 Rational[1, 2], 0}]], "+"]}], "-", 
           RowBox[{"81", " ", 
            SuperscriptBox[
             RowBox[{"(", 
              SuperscriptBox[
               StyleBox["Q0",
                FontColor->RGBColor[{
                   Rational[1, 2], 
                   Rational[1, 2], 0}]], "-"], ")"}], "2"], " ", 
            SuperscriptBox[
             RowBox[{"(", 
              SuperscriptBox[
               StyleBox["Q0",
                FontColor->RGBColor[{
                   Rational[1, 2], 
                   Rational[1, 2], 0}]], "+"], ")"}], "2"]}], "+", 
           RowBox[{
            SuperscriptBox["u", "2"], " ", 
            RowBox[{"(", 
             RowBox[{"35", "-", 
              RowBox[{"36", " ", 
               SuperscriptBox[
                StyleBox["Q0",
                 FontColor->RGBColor[{
                    Rational[1, 2], 
                    Rational[1, 2], 0}]], "-"], " ", 
               SuperscriptBox[
                StyleBox["Q0",
                 FontColor->RGBColor[{
                    Rational[1, 2], 
                    Rational[1, 2], 0}]], "+"]}]}], ")"}]}]}], ")"}], " ", 
         SubscriptBox[
          OverscriptBox[
           StyleBox["W",
            FontColor->RGBColor[0.54, 0.35, 0.15]], 
           StyleBox["^",
            FontColor->RGBColor[0.54, 0.35, 0.15]]], "sublead"]}], 
        RowBox[{"81", " ", 
         RowBox[{"(", 
          RowBox[{"1", "+", 
           SuperscriptBox["u", "2"]}], ")"}], " ", 
         SuperscriptBox[
          RowBox[{"(", 
           SuperscriptBox[
            StyleBox["Q0",
             FontColor->RGBColor[{
                Rational[1, 2], 
                Rational[1, 2], 0}]], "-"], ")"}], "2"], " ", 
         SuperscriptBox[
          RowBox[{"(", 
           SuperscriptBox[
            StyleBox["Q0",
             FontColor->RGBColor[{
                Rational[1, 2], 
                Rational[1, 2], 0}]], "+"], ")"}], "2"]}]]}], "]"}], "+", 
     RowBox[{
      FractionBox["26", "3"], " ", 
      SubscriptBox[
       StyleBox["W",
        FontColor->RGBColor[0.54, 0.35, 0.15]], 
       RowBox[{"1", ",", "v0", ",", "lead"}]]}], "+", 
     RowBox[{
      FractionBox["10", "3"], " ", 
      SubscriptBox[
       StyleBox["W",
        FontColor->RGBColor[0.54, 0.35, 0.15]], 
       RowBox[{"1", ",", "v0", ",", "sublead"}]]}], "-", 
     RowBox[{"8208", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2"]}], "+", 
     FractionBox[
      RowBox[{"7416", " ", 
       SubsuperscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "2", "2"]}], "5"], "+", 
     FractionBox[
      RowBox[{"8496", " ", 
       SubsuperscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "2", "3"]}], "35"], "-", 
     FractionBox[
      RowBox[{"16416", " ", 
       SubsuperscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "2", "4"]}], "175"], "-", 
     RowBox[{"5040", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3"]}], "+", 
     RowBox[{"3840", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3"]}], "-", 
     RowBox[{
      FractionBox["576", "5"], " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2", "2"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3"]}], "-", 
     RowBox[{
      FractionBox["768", "35"], " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2", "3"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3"]}], "-", 
     RowBox[{"432", " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3", "2"]}], "+", 
     RowBox[{"288", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2"], " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3", "2"]}], "+", 
     RowBox[{"3780", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "5"]}], "-", 
     RowBox[{"1512", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "5"]}], "-", 
     RowBox[{
      FractionBox["144", "5"], " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2", "2"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "5"]}], "-", 
     RowBox[{"1008", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "5"]}]}]}], ",", 
   RowBox[{
    RowBox[{
     SubscriptBox["\[Alpha]", "sublead"], "[", "1", "]"}], "\[Rule]", 
    RowBox[{
     RowBox[{"-", "6120"}], "+", 
     RowBox[{"\[DoubleStruckCapitalC]", "[", 
      RowBox[{
       FractionBox[
        RowBox[{"16", " ", 
         RowBox[{"(", 
          RowBox[{"1", "-", 
           RowBox[{"3", " ", "\[ImaginaryI]", " ", "u"}]}], ")"}], " ", 
         SubscriptBox[
          StyleBox["H",
           FontColor->RGBColor[0.54, 0.35, 0.15]], "lead"]}], 
        RowBox[{"9", " ", 
         SuperscriptBox["u", "3"]}]], "-", 
       FractionBox[
        RowBox[{"8", " ", 
         RowBox[{"(", 
          RowBox[{"\[ImaginaryI]", "+", "u"}], ")"}], " ", 
         SubscriptBox[
          StyleBox["H",
           FontColor->RGBColor[0.54, 0.35, 0.15]], "sublead"]}], 
        RowBox[{"9", " ", 
         SuperscriptBox["u", "2"]}]]}], "]"}], "+", 
     RowBox[{"\[DoubleStruckCapitalC]", "[", 
      RowBox[{
       RowBox[{"-", 
        FractionBox[
         RowBox[{"16", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"-", "1"}], "+", 
            RowBox[{"8", " ", "\[ImaginaryI]", " ", 
             SuperscriptBox["u", "3"]}], "+", 
            RowBox[{"4", " ", 
             SuperscriptBox["u", "4"]}], "+", 
            RowBox[{"6", " ", 
             SuperscriptBox[
              StyleBox["Q0",
               FontColor->RGBColor[{
                  Rational[1, 2], 
                  Rational[1, 2], 0}]], "+"]}], "-", 
            RowBox[{"3", " ", "\[ImaginaryI]", " ", "u", " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"-", "1"}], "+", 
               RowBox[{"4", " ", 
                SuperscriptBox[
                 StyleBox["Q0",
                  FontColor->RGBColor[{
                    Rational[1, 2], 
                    Rational[1, 2], 0}]], "+"]}]}], ")"}]}], "-", 
            RowBox[{
             SuperscriptBox["u", "2"], " ", 
             RowBox[{"(", 
              RowBox[{"1", "+", 
               RowBox[{"6", " ", 
                SuperscriptBox[
                 StyleBox["Q0",
                  FontColor->RGBColor[{
                    Rational[1, 2], 
                    Rational[1, 2], 0}]], "+"]}]}], ")"}]}]}], ")"}], " ", 
          SubsuperscriptBox[
           StyleBox["W",
            FontColor->RGBColor[0.54, 0.35, 0.15]], 
           RowBox[{"1", ",", "lead"}], "+"]}], 
         RowBox[{"27", " ", 
          SuperscriptBox["u", "2"], " ", 
          RowBox[{"(", 
           RowBox[{"\[ImaginaryI]", "+", "u"}], ")"}], " ", 
          SuperscriptBox[
           RowBox[{"(", 
            SuperscriptBox[
             StyleBox["Q0",
              FontColor->RGBColor[{
                 Rational[1, 2], 
                 Rational[1, 2], 0}]], "+"], ")"}], "2"]}]]}], "-", 
       FractionBox[
        RowBox[{"16", " ", 
         RowBox[{"(", 
          RowBox[{"\[ImaginaryI]", "+", "u"}], ")"}], " ", 
         SubsuperscriptBox[
          StyleBox["W",
           FontColor->RGBColor[0.54, 0.35, 0.15]], 
          RowBox[{"1", ",", "sublead"}], "+"]}], 
        RowBox[{"9", " ", 
         SuperscriptBox[
          StyleBox["Q0",
           FontColor->RGBColor[{
              Rational[1, 2], 
              Rational[1, 2], 0}]], "+"]}]]}], "]"}], "+", 
     RowBox[{"\[DoubleStruckCapitalC]", "[", 
      RowBox[{
       RowBox[{"-", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{"16", " ", "\[ImaginaryI]", " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"1251", " ", 
              SuperscriptBox["u", "12"]}], "+", 
             RowBox[{"324", " ", 
              SuperscriptBox["u", "14"]}], "-", 
             RowBox[{"243", " ", 
              SuperscriptBox[
               RowBox[{"(", 
                SuperscriptBox[
                 StyleBox["Q0",
                  FontColor->RGBColor[{
                    Rational[1, 2], 
                    Rational[1, 2], 0}]], "-"], ")"}], "2"], " ", 
              SuperscriptBox[
               RowBox[{"(", 
                SuperscriptBox[
                 StyleBox["Q0",
                  FontColor->RGBColor[{
                    Rational[1, 2], 
                    Rational[1, 2], 0}]], "+"], ")"}], "2"]}], "+", 
             RowBox[{"6", " ", 
              SuperscriptBox["u", "10"], " ", 
              RowBox[{"(", 
               RowBox[{"314", "+", 
                RowBox[{"81", " ", 
                 SuperscriptBox[
                  StyleBox["Q0",
                   FontColor->RGBColor[{
                    Rational[1, 2], 
                    Rational[1, 2], 0}]], "-"], " ", 
                 SuperscriptBox[
                  StyleBox["Q0",
                   FontColor->RGBColor[{
                    Rational[1, 2], 
                    Rational[1, 2], 0}]], "+"]}]}], ")"}]}], "+", 
             RowBox[{
              SuperscriptBox["u", "8"], " ", 
              RowBox[{"(", 
               RowBox[{"1519", "+", 
                RowBox[{"1782", " ", 
                 SuperscriptBox[
                  StyleBox["Q0",
                   FontColor->RGBColor[{
                    Rational[1, 2], 
                    Rational[1, 2], 0}]], "-"], " ", 
                 SuperscriptBox[
                  StyleBox["Q0",
                   FontColor->RGBColor[{
                    Rational[1, 2], 
                    Rational[1, 2], 0}]], "+"]}]}], ")"}]}], "+", 
             RowBox[{
              SuperscriptBox["u", "4"], " ", 
              RowBox[{"(", 
               RowBox[{"124", "+", 
                RowBox[{"882", " ", 
                 SuperscriptBox[
                  StyleBox["Q0",
                   FontColor->RGBColor[{
                    Rational[1, 2], 
                    Rational[1, 2], 0}]], "-"], " ", 
                 SuperscriptBox[
                  StyleBox["Q0",
                   FontColor->RGBColor[{
                    Rational[1, 2], 
                    Rational[1, 2], 0}]], "+"]}], "-", 
                RowBox[{"2106", " ", 
                 SuperscriptBox[
                  RowBox[{"(", 
                   SuperscriptBox[
                    StyleBox["Q0",
                    FontColor->RGBColor[{
                    Rational[1, 2], 
                    Rational[1, 2], 0}]], "-"], ")"}], "2"], " ", 
                 SuperscriptBox[
                  RowBox[{"(", 
                   SuperscriptBox[
                    StyleBox["Q0",
                    FontColor->RGBColor[{
                    Rational[1, 2], 
                    Rational[1, 2], 0}]], "+"], ")"}], "2"]}]}], ")"}]}], "+", 
             RowBox[{
              SuperscriptBox["u", "2"], " ", 
              RowBox[{"(", 
               RowBox[{"7", "+", 
                RowBox[{"162", " ", 
                 SuperscriptBox[
                  StyleBox["Q0",
                   FontColor->RGBColor[{
                    Rational[1, 2], 
                    Rational[1, 2], 0}]], "-"], " ", 
                 SuperscriptBox[
                  StyleBox["Q0",
                   FontColor->RGBColor[{
                    Rational[1, 2], 
                    Rational[1, 2], 0}]], "+"]}], "-", 
                RowBox[{"1863", " ", 
                 SuperscriptBox[
                  RowBox[{"(", 
                   SuperscriptBox[
                    StyleBox["Q0",
                    FontColor->RGBColor[{
                    Rational[1, 2], 
                    Rational[1, 2], 0}]], "-"], ")"}], "2"], " ", 
                 SuperscriptBox[
                  RowBox[{"(", 
                   SuperscriptBox[
                    StyleBox["Q0",
                    FontColor->RGBColor[{
                    Rational[1, 2], 
                    Rational[1, 2], 0}]], "+"], ")"}], "2"]}]}], ")"}]}], "+", 
             RowBox[{
              SuperscriptBox["u", "6"], " ", 
              RowBox[{"(", 
               RowBox[{"679", "+", 
                RowBox[{"2016", " ", 
                 SuperscriptBox[
                  StyleBox["Q0",
                   FontColor->RGBColor[{
                    Rational[1, 2], 
                    Rational[1, 2], 0}]], "-"], " ", 
                 SuperscriptBox[
                  StyleBox["Q0",
                   FontColor->RGBColor[{
                    Rational[1, 2], 
                    Rational[1, 2], 0}]], "+"]}], "-", 
                RowBox[{"810", " ", 
                 SuperscriptBox[
                  RowBox[{"(", 
                   SuperscriptBox[
                    StyleBox["Q0",
                    FontColor->RGBColor[{
                    Rational[1, 2], 
                    Rational[1, 2], 0}]], "-"], ")"}], "2"], " ", 
                 SuperscriptBox[
                  RowBox[{"(", 
                   SuperscriptBox[
                    StyleBox["Q0",
                    FontColor->RGBColor[{
                    Rational[1, 2], 
                    Rational[1, 2], 0}]], "+"], ")"}], "2"]}]}], ")"}]}]}], 
            ")"}], " ", 
           SubscriptBox[
            OverscriptBox[
             StyleBox["W",
              FontColor->RGBColor[0.54, 0.35, 0.15]], 
             StyleBox["^",
              FontColor->RGBColor[0.54, 0.35, 0.15]]], "lead"]}], ")"}], "/", 
         
         RowBox[{"(", 
          RowBox[{"243", " ", 
           SuperscriptBox["u", "2"], " ", 
           SuperscriptBox[
            RowBox[{"(", 
             RowBox[{"1", "+", 
              SuperscriptBox["u", "2"]}], ")"}], "3"], " ", 
           SuperscriptBox[
            RowBox[{"(", 
             SuperscriptBox[
              StyleBox["Q0",
               FontColor->RGBColor[{
                  Rational[1, 2], 
                  Rational[1, 2], 0}]], "-"], ")"}], "2"], " ", 
           SuperscriptBox[
            RowBox[{"(", 
             SuperscriptBox[
              StyleBox["Q0",
               FontColor->RGBColor[{
                  Rational[1, 2], 
                  Rational[1, 2], 0}]], "+"], ")"}], "2"]}], ")"}]}]}], "-", 
       FractionBox[
        RowBox[{"8", " ", "\[ImaginaryI]", " ", 
         RowBox[{"(", 
          RowBox[{"2", "+", 
           RowBox[{"48", " ", 
            SuperscriptBox["u", "4"]}], "+", 
           RowBox[{"90", " ", 
            SuperscriptBox["u", "6"]}], "+", 
           RowBox[{"54", " ", 
            SuperscriptBox["u", "8"]}], "+", 
           RowBox[{"18", " ", 
            SuperscriptBox[
             StyleBox["Q0",
              FontColor->RGBColor[{
                 Rational[1, 2], 
                 Rational[1, 2], 0}]], "-"], " ", 
            SuperscriptBox[
             StyleBox["Q0",
              FontColor->RGBColor[{
                 Rational[1, 2], 
                 Rational[1, 2], 0}]], "+"]}], "-", 
           RowBox[{"81", " ", 
            SuperscriptBox[
             RowBox[{"(", 
              SuperscriptBox[
               StyleBox["Q0",
                FontColor->RGBColor[{
                   Rational[1, 2], 
                   Rational[1, 2], 0}]], "-"], ")"}], "2"], " ", 
            SuperscriptBox[
             RowBox[{"(", 
              SuperscriptBox[
               StyleBox["Q0",
                FontColor->RGBColor[{
                   Rational[1, 2], 
                   Rational[1, 2], 0}]], "+"], ")"}], "2"]}], "+", 
           RowBox[{"2", " ", 
            SuperscriptBox["u", "2"], " ", 
            RowBox[{"(", 
             RowBox[{"7", "+", 
              RowBox[{"9", " ", 
               SuperscriptBox[
                StyleBox["Q0",
                 FontColor->RGBColor[{
                    Rational[1, 2], 
                    Rational[1, 2], 0}]], "-"], " ", 
               SuperscriptBox[
                StyleBox["Q0",
                 FontColor->RGBColor[{
                    Rational[1, 2], 
                    Rational[1, 2], 0}]], "+"]}]}], ")"}]}]}], ")"}], " ", 
         SubscriptBox[
          OverscriptBox[
           StyleBox["W",
            FontColor->RGBColor[0.54, 0.35, 0.15]], 
           StyleBox["^",
            FontColor->RGBColor[0.54, 0.35, 0.15]]], "sublead"]}], 
        RowBox[{"243", " ", 
         RowBox[{"(", 
          RowBox[{"1", "+", 
           SuperscriptBox["u", "2"]}], ")"}], " ", 
         SuperscriptBox[
          RowBox[{"(", 
           SuperscriptBox[
            StyleBox["Q0",
             FontColor->RGBColor[{
                Rational[1, 2], 
                Rational[1, 2], 0}]], "-"], ")"}], "2"], " ", 
         SuperscriptBox[
          RowBox[{"(", 
           SuperscriptBox[
            StyleBox["Q0",
             FontColor->RGBColor[{
                Rational[1, 2], 
                Rational[1, 2], 0}]], "+"], ")"}], "2"]}]]}], "]"}], "-", 
     RowBox[{
      FractionBox["32", "3"], " ", 
      SubscriptBox[
       StyleBox["W",
        FontColor->RGBColor[0.54, 0.35, 0.15]], 
       RowBox[{"1", ",", "v0", ",", "lead"}]]}], "-", 
     RowBox[{
      FractionBox["16", "9"], " ", 
      SubscriptBox[
       StyleBox["W",
        FontColor->RGBColor[0.54, 0.35, 0.15]], 
       RowBox[{"1", ",", "v0", ",", "sublead"}]]}], "-", 
     RowBox[{"7728", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2"]}], "+", 
     FractionBox[
      RowBox[{"23808", " ", 
       SubsuperscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "2", "2"]}], "5"], "-", 
     FractionBox[
      RowBox[{"7616", " ", 
       SubsuperscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "2", "3"]}], "5"], "+", 
     FractionBox[
      RowBox[{"640", " ", 
       SubsuperscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "2", "4"]}], "7"], "+", 
     RowBox[{"15312", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3"]}], "+", 
     RowBox[{"4832", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3"]}], "-", 
     RowBox[{
      FractionBox["8512", "5"], " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2", "2"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3"]}], "-", 
     RowBox[{
      FractionBox["4096", "35"], " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2", "3"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3"]}], "-", 
     RowBox[{"5440", " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3", "2"]}], "-", 
     RowBox[{"384", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2"], " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3", "2"]}], "-", 
     RowBox[{"7152", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "5"]}], "+", 
     RowBox[{"2720", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "5"]}], "+", 
     RowBox[{"192", " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2", "2"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "5"]}], "+", 
     RowBox[{"1024", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "5"]}]}]}], ",", 
   RowBox[{
    RowBox[{
     SubscriptBox["\[Beta]", "sublead"], "[", "1", "]"}], "\[Rule]", 
    RowBox[{
     RowBox[{"\[DoubleStruckCapitalC]", "[", 
      RowBox[{"-", 
       FractionBox[
        RowBox[{"8", " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"-", "\[ImaginaryI]"}], "+", 
           RowBox[{"2", " ", "u"}], "+", 
           RowBox[{"3", " ", 
            SuperscriptBox["u", "3"]}]}], ")"}], " ", 
         SubscriptBox[
          StyleBox["H",
           FontColor->RGBColor[0.54, 0.35, 0.15]], "lead"]}], 
        RowBox[{"3", " ", 
         SuperscriptBox["u", "4"]}]]}], "]"}], "+", 
     RowBox[{"\[DoubleStruckCapitalC]", "[", 
      RowBox[{"-", 
       FractionBox[
        RowBox[{"16", " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"2", " ", "\[ImaginaryI]"}], "+", 
           RowBox[{"2", " ", "u"}], "+", 
           RowBox[{"3", " ", "\[ImaginaryI]", " ", 
            SuperscriptBox["u", "2"]}], "+", 
           RowBox[{"3", " ", 
            SuperscriptBox["u", "3"]}]}], ")"}], " ", 
         SubsuperscriptBox[
          StyleBox["W",
           FontColor->RGBColor[0.54, 0.35, 0.15]], 
          RowBox[{"1", ",", "lead"}], "+"]}], 
        RowBox[{"3", " ", 
         SuperscriptBox["u", "2"], " ", 
         SuperscriptBox[
          StyleBox["Q0",
           FontColor->RGBColor[{
              Rational[1, 2], 
              Rational[1, 2], 0}]], "+"]}]]}], "]"}], "+", 
     RowBox[{"\[DoubleStruckCapitalC]", "[", 
      FractionBox[
       RowBox[{"8", " ", "\[ImaginaryI]", " ", 
        SuperscriptBox["u", "2"], " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"-", "2"}], "+", 
          RowBox[{"90", " ", 
           SuperscriptBox["u", "4"]}], "+", 
          RowBox[{"18", " ", 
           SuperscriptBox["u", "6"]}], "-", 
          RowBox[{"45", " ", 
           SuperscriptBox[
            StyleBox["Q0",
             FontColor->RGBColor[{
                Rational[1, 2], 
                Rational[1, 2], 0}]], "-"], " ", 
           SuperscriptBox[
            StyleBox["Q0",
             FontColor->RGBColor[{
                Rational[1, 2], 
                Rational[1, 2], 0}]], "+"]}], "+", 
          RowBox[{
           SuperscriptBox["u", "2"], " ", 
           RowBox[{"(", 
            RowBox[{"70", "-", 
             RowBox[{"9", " ", 
              SuperscriptBox[
               StyleBox["Q0",
                FontColor->RGBColor[{
                   Rational[1, 2], 
                   Rational[1, 2], 0}]], "-"], " ", 
              SuperscriptBox[
               StyleBox["Q0",
                FontColor->RGBColor[{
                   Rational[1, 2], 
                   Rational[1, 2], 0}]], "+"]}]}], ")"}]}]}], ")"}], " ", 
        SubscriptBox[
         OverscriptBox[
          StyleBox["W",
           FontColor->RGBColor[0.54, 0.35, 0.15]], 
          StyleBox["^",
           FontColor->RGBColor[0.54, 0.35, 0.15]]], "lead"]}], 
       RowBox[{"9", " ", 
        SuperscriptBox[
         RowBox[{"(", 
          RowBox[{"1", "+", 
           SuperscriptBox["u", "2"]}], ")"}], "3"], " ", 
        SuperscriptBox[
         StyleBox["Q0",
          FontColor->RGBColor[{
             Rational[1, 2], 
             Rational[1, 2], 0}]], "-"], " ", 
        SuperscriptBox[
         StyleBox["Q0",
          FontColor->RGBColor[{
             Rational[1, 2], 
             Rational[1, 2], 0}]], "+"]}]], "]"}], "-", 
     RowBox[{"48", " ", 
      SubscriptBox[
       StyleBox["W",
        FontColor->RGBColor[0.54, 0.35, 0.15]], 
       RowBox[{"1", ",", "v0", ",", "lead"}]]}], "+", 
     RowBox[{"432", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2"]}], "-", 
     FractionBox[
      RowBox[{"25632", " ", 
       SubsuperscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "2", "2"]}], "5"], "+", 
     FractionBox[
      RowBox[{"86976", " ", 
       SubsuperscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "2", "3"]}], "35"], "-", 
     FractionBox[
      RowBox[{"44544", " ", 
       SubsuperscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "2", "4"]}], "175"], "+", 
     RowBox[{"2160", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3"]}], "+", 
     RowBox[{"2016", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3"]}], "+", 
     RowBox[{
      FractionBox["2304", "5"], " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2", "2"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3"]}], "-", 
     RowBox[{
      FractionBox["1536", "7"], " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2", "3"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3"]}], "-", 
     RowBox[{"2016", " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3", "2"]}], "+", 
     RowBox[{"3744", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "5"]}], "-", 
     RowBox[{"2112", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "5"]}], "+", 
     RowBox[{
      FractionBox["1152", "5"], " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2", "2"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "5"]}], "-", 
     RowBox[{"768", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "5"]}]}]}], ",", 
   RowBox[{
    RowBox[{
     SubscriptBox["\[Alpha]", "sublead"], "[", "2", "]"}], "\[Rule]", 
    RowBox[{
     RowBox[{"-", "10368"}], "+", 
     RowBox[{"\[DoubleStruckCapitalC]", "[", 
      RowBox[{"-", 
       FractionBox[
        RowBox[{"32", " ", 
         RowBox[{"(", 
          RowBox[{"\[ImaginaryI]", "+", "u"}], ")"}], " ", 
         SubscriptBox[
          StyleBox["H",
           FontColor->RGBColor[0.54, 0.35, 0.15]], "lead"]}], 
        RowBox[{"9", " ", 
         SuperscriptBox["u", "4"]}]]}], "]"}], "+", 
     RowBox[{
      FractionBox["4", "9"], " ", 
      RowBox[{"\[DoubleStruckCapitalC]", "[", 
       RowBox[{"-", 
        FractionBox[
         RowBox[{"16", " ", 
          RowBox[{"(", 
           RowBox[{"\[ImaginaryI]", "+", "u"}], ")"}], " ", 
          SubsuperscriptBox[
           StyleBox["W",
            FontColor->RGBColor[0.54, 0.35, 0.15]], 
           RowBox[{"1", ",", "lead"}], "+"]}], 
         RowBox[{
          SuperscriptBox["u", "2"], " ", 
          SuperscriptBox[
           StyleBox["Q0",
            FontColor->RGBColor[{
               Rational[1, 2], 
               Rational[1, 2], 0}]], "+"]}]]}], "]"}]}], "+", 
     RowBox[{"\[DoubleStruckCapitalC]", "[", 
      FractionBox[
       RowBox[{"32", " ", "\[ImaginaryI]", " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"168", " ", 
           SuperscriptBox["u", "8"]}], "+", 
          RowBox[{"45", " ", 
           SuperscriptBox["u", "10"]}], "-", 
          RowBox[{"27", " ", 
           SuperscriptBox[
            StyleBox["Q0",
             FontColor->RGBColor[{
                Rational[1, 2], 
                Rational[1, 2], 0}]], "-"], " ", 
           SuperscriptBox[
            StyleBox["Q0",
             FontColor->RGBColor[{
                Rational[1, 2], 
                Rational[1, 2], 0}]], "+"]}], "+", 
          RowBox[{
           SuperscriptBox["u", "6"], " ", 
           RowBox[{"(", 
            RowBox[{"188", "-", 
             RowBox[{"45", " ", 
              SuperscriptBox[
               StyleBox["Q0",
                FontColor->RGBColor[{
                   Rational[1, 2], 
                   Rational[1, 2], 0}]], "-"], " ", 
              SuperscriptBox[
               StyleBox["Q0",
                FontColor->RGBColor[{
                   Rational[1, 2], 
                   Rational[1, 2], 0}]], "+"]}]}], ")"}]}], "-", 
          RowBox[{"16", " ", 
           SuperscriptBox["u", "4"], " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"-", "5"}], "+", 
             RowBox[{"9", " ", 
              SuperscriptBox[
               StyleBox["Q0",
                FontColor->RGBColor[{
                   Rational[1, 2], 
                   Rational[1, 2], 0}]], "-"], " ", 
              SuperscriptBox[
               StyleBox["Q0",
                FontColor->RGBColor[{
                   Rational[1, 2], 
                   Rational[1, 2], 0}]], "+"]}]}], ")"}]}], "-", 
          RowBox[{"3", " ", 
           SuperscriptBox["u", "2"], " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"-", "5"}], "+", 
             RowBox[{"54", " ", 
              SuperscriptBox[
               StyleBox["Q0",
                FontColor->RGBColor[{
                   Rational[1, 2], 
                   Rational[1, 2], 0}]], "-"], " ", 
              SuperscriptBox[
               StyleBox["Q0",
                FontColor->RGBColor[{
                   Rational[1, 2], 
                   Rational[1, 2], 0}]], "+"]}]}], ")"}]}]}], ")"}], " ", 
        SubscriptBox[
         OverscriptBox[
          StyleBox["W",
           FontColor->RGBColor[0.54, 0.35, 0.15]], 
          StyleBox["^",
           FontColor->RGBColor[0.54, 0.35, 0.15]]], "lead"]}], 
       RowBox[{"27", " ", 
        SuperscriptBox["u", "2"], " ", 
        SuperscriptBox[
         RowBox[{"(", 
          RowBox[{"1", "+", 
           SuperscriptBox["u", "2"]}], ")"}], "3"], " ", 
        SuperscriptBox[
         StyleBox["Q0",
          FontColor->RGBColor[{
             Rational[1, 2], 
             Rational[1, 2], 0}]], "-"], " ", 
        SuperscriptBox[
         StyleBox["Q0",
          FontColor->RGBColor[{
             Rational[1, 2], 
             Rational[1, 2], 0}]], "+"]}]], "]"}], "+", 
     RowBox[{
      FractionBox["32", "3"], " ", 
      SubscriptBox[
       StyleBox["W",
        FontColor->RGBColor[0.54, 0.35, 0.15]], 
       RowBox[{"1", ",", "v0", ",", "lead"}]]}], "+", 
     RowBox[{"12096", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2"]}], "-", 
     FractionBox[
      RowBox[{"18816", " ", 
       SubsuperscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "2", "2"]}], "5"], "+", 
     FractionBox[
      RowBox[{"4608", " ", 
       SubsuperscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "2", "3"]}], "5"], "-", 
     FractionBox[
      RowBox[{"29696", " ", 
       SubsuperscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "2", "4"]}], "175"], "-", 
     RowBox[{"8640", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3"]}], "+", 
     RowBox[{"384", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3"]}], "+", 
     RowBox[{
      FractionBox["10752", "5"], " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2", "2"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3"]}], "+", 
     RowBox[{
      FractionBox["2048", "7"], " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2", "3"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3"]}], "-", 
     RowBox[{"1536", " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3", "2"]}], "+", 
     RowBox[{"18048", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "5"]}], "-", 
     RowBox[{"9472", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "5"]}], "-", 
     RowBox[{
      FractionBox["1536", "5"], " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2", "2"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "5"]}], "-", 
     RowBox[{"512", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "5"]}]}]}], ",", 
   RowBox[{
    RowBox[{
     SubscriptBox["\[Beta]", "sublead"], "[", "2", "]"}], "\[Rule]", "0"}], 
   ",", 
   RowBox[{
    RowBox[{
     SubscriptBox["\[Alpha]", "sublead"], "[", "3", "]"}], "\[Rule]", "0"}], 
   ",", 
   RowBox[{
    RowBox[{
     SubscriptBox["\[Beta]", "sublead"], "[", "3", "]"}], "\[Rule]", "0"}], 
   ",", 
   RowBox[{
    RowBox[{
     SubscriptBox["\[Alpha]", "sublead"], "[", "4", "]"}], "\[Rule]", "0"}], 
   ",", 
   RowBox[{
    RowBox[{
     SubscriptBox["\[Beta]", "sublead"], "[", "4", "]"}], "\[Rule]", "0"}], 
   ",", 
   RowBox[{
    RowBox[{
     SubscriptBox["\[Alpha]", "sublead"], "[", "5", "]"}], "\[Rule]", "0"}], 
   ",", 
   RowBox[{
    RowBox[{
     SubscriptBox["\[Beta]", "sublead"], "[", "5", "]"}], "\[Rule]", "0"}], 
   ",", 
   RowBox[{
    RowBox[{
     SubscriptBox["\[Alpha]", "sublead2"], "[", "0", "]"}], "\[Rule]", 
    RowBox[{
     RowBox[{"-", "32166"}], "+", 
     RowBox[{"\[DoubleStruckCapitalC]", "[", 
      RowBox[{
       FractionBox[
        RowBox[{"2", " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"6", " ", "\[ImaginaryI]"}], "+", 
           RowBox[{"14", " ", "\[ImaginaryI]", " ", 
            SuperscriptBox["u", "2"]}], "+", 
           SuperscriptBox["u", "3"], "+", 
           RowBox[{"2", " ", "\[ImaginaryI]", " ", 
            SuperscriptBox["u", "4"]}], "+", 
           RowBox[{"23", " ", 
            SuperscriptBox["u", "5"]}]}], ")"}], " ", 
         SubscriptBox[
          StyleBox["H",
           FontColor->RGBColor[0.54, 0.35, 0.15]], "lead"]}], 
        RowBox[{"9", " ", 
         SuperscriptBox["u", "6"]}]], "+", 
       FractionBox[
        RowBox[{"4", " ", "\[ImaginaryI]", " ", 
         RowBox[{"(", 
          RowBox[{"1", "+", 
           RowBox[{"3", " ", 
            SuperscriptBox["u", "2"]}]}], ")"}], " ", 
         SubscriptBox[
          StyleBox["H",
           FontColor->RGBColor[0.54, 0.35, 0.15]], "sublead"]}], 
        RowBox[{"9", " ", 
         SuperscriptBox["u", "4"]}]], "+", 
       FractionBox[
        RowBox[{"2", " ", 
         RowBox[{"(", 
          RowBox[{"\[ImaginaryI]", "+", "u"}], ")"}], " ", 
         SubscriptBox[
          StyleBox["H",
           FontColor->RGBColor[0.54, 0.35, 0.15]], "sublead2"]}], 
        RowBox[{"9", " ", 
         SuperscriptBox["u", "2"]}]]}], "]"}], "+", 
     RowBox[{"\[DoubleStruckCapitalC]", "[", 
      RowBox[{
       RowBox[{"-", 
        RowBox[{
         FractionBox["1", 
          RowBox[{"81", " ", 
           SuperscriptBox["u", "4"], " ", 
           SuperscriptBox[
            RowBox[{"(", 
             RowBox[{"\[ImaginaryI]", "+", "u"}], ")"}], "3"], " ", 
           SuperscriptBox[
            RowBox[{"(", 
             SuperscriptBox[
              StyleBox["Q0",
               FontColor->RGBColor[{
                  Rational[1, 2], 
                  Rational[1, 2], 0}]], "+"], ")"}], "3"]}]], 
         RowBox[{"4", " ", 
          RowBox[{"(", 
           RowBox[{"1", "-", 
            RowBox[{"10", " ", "\[ImaginaryI]", " ", "u"}], "+", 
            RowBox[{"180", " ", "\[ImaginaryI]", " ", 
             SuperscriptBox["u", "9"]}], "+", 
            RowBox[{"36", " ", 
             SuperscriptBox["u", "10"]}], "+", 
            RowBox[{
             SuperscriptBox["u", "4"], " ", 
             RowBox[{"(", 
              RowBox[{"61", "-", 
               RowBox[{"153", " ", 
                SuperscriptBox[
                 RowBox[{"(", 
                  SuperscriptBox[
                   StyleBox["Q0",
                    FontColor->RGBColor[{
                    Rational[1, 2], 
                    Rational[1, 2], 0}]], "+"], ")"}], "2"]}]}], ")"}]}], "-", 
            RowBox[{"9", " ", 
             SuperscriptBox["u", "2"], " ", 
             RowBox[{"(", 
              RowBox[{"5", "+", 
               SuperscriptBox[
                RowBox[{"(", 
                 SuperscriptBox[
                  StyleBox["Q0",
                   FontColor->RGBColor[{
                    Rational[1, 2], 
                    Rational[1, 2], 0}]], "+"], ")"}], "2"]}], ")"}]}], "+", 
            RowBox[{"4", " ", "\[ImaginaryI]", " ", 
             SuperscriptBox["u", "3"], " ", 
             RowBox[{"(", 
              RowBox[{"25", "+", 
               RowBox[{"9", " ", 
                SuperscriptBox[
                 RowBox[{"(", 
                  SuperscriptBox[
                   StyleBox["Q0",
                    FontColor->RGBColor[{
                    Rational[1, 2], 
                    Rational[1, 2], 0}]], "+"], ")"}], "2"]}]}], ")"}]}], "-", 
            RowBox[{"4", " ", "\[ImaginaryI]", " ", 
             SuperscriptBox["u", "7"], " ", 
             RowBox[{"(", 
              RowBox[{"154", "+", 
               RowBox[{"207", " ", 
                SuperscriptBox[
                 RowBox[{"(", 
                  SuperscriptBox[
                   StyleBox["Q0",
                    FontColor->RGBColor[{
                    Rational[1, 2], 
                    Rational[1, 2], 0}]], "+"], ")"}], "2"]}]}], ")"}]}], "-", 
            RowBox[{
             SuperscriptBox["u", "8"], " ", 
             RowBox[{"(", 
              RowBox[{"424", "+", 
               RowBox[{"207", " ", 
                SuperscriptBox[
                 RowBox[{"(", 
                  SuperscriptBox[
                   StyleBox["Q0",
                    FontColor->RGBColor[{
                    Rational[1, 2], 
                    Rational[1, 2], 0}]], "+"], ")"}], "2"]}]}], ")"}]}], "+", 
            RowBox[{"2", " ", "\[ImaginaryI]", " ", 
             SuperscriptBox["u", "5"], " ", 
             RowBox[{"(", 
              RowBox[{"101", "+", 
               RowBox[{"396", " ", 
                SuperscriptBox[
                 RowBox[{"(", 
                  SuperscriptBox[
                   StyleBox["Q0",
                    FontColor->RGBColor[{
                    Rational[1, 2], 
                    Rational[1, 2], 0}]], "+"], ")"}], "2"]}]}], ")"}]}], "+", 
            RowBox[{"3", " ", 
             SuperscriptBox["u", "6"], " ", 
             RowBox[{"(", 
              RowBox[{"178", "+", 
               RowBox[{"411", " ", 
                SuperscriptBox[
                 RowBox[{"(", 
                  SuperscriptBox[
                   StyleBox["Q0",
                    FontColor->RGBColor[{
                    Rational[1, 2], 
                    Rational[1, 2], 0}]], "+"], ")"}], "2"]}]}], ")"}]}]}], 
           ")"}], " ", 
          SubsuperscriptBox[
           StyleBox["W",
            FontColor->RGBColor[0.54, 0.35, 0.15]], 
           RowBox[{"1", ",", "lead"}], "+"]}]}]}], "+", 
       FractionBox[
        RowBox[{"4", " ", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"\[ImaginaryI]", "+", 
            RowBox[{"2", " ", "u"}]}], ")"}], "2"], " ", 
         RowBox[{"(", 
          RowBox[{"1", "+", 
           RowBox[{"\[ImaginaryI]", " ", "u"}], "+", 
           SuperscriptBox["u", "2"]}], ")"}], " ", 
         SubsuperscriptBox[
          StyleBox["W",
           FontColor->RGBColor[0.54, 0.35, 0.15]], 
          RowBox[{"1", ",", "sublead"}], "+"]}], 
        RowBox[{"27", " ", 
         SuperscriptBox["u", "2"], " ", 
         RowBox[{"(", 
          RowBox[{"\[ImaginaryI]", "+", "u"}], ")"}], " ", 
         SuperscriptBox[
          RowBox[{"(", 
           SuperscriptBox[
            StyleBox["Q0",
             FontColor->RGBColor[{
                Rational[1, 2], 
                Rational[1, 2], 0}]], "+"], ")"}], "2"]}]], "+", 
       FractionBox[
        RowBox[{"4", " ", 
         RowBox[{"(", 
          RowBox[{"\[ImaginaryI]", "+", "u"}], ")"}], " ", 
         SubsuperscriptBox[
          StyleBox["W",
           FontColor->RGBColor[0.54, 0.35, 0.15]], 
          RowBox[{"1", ",", "sublead2"}], "+"]}], 
        RowBox[{"9", " ", 
         SuperscriptBox[
          StyleBox["Q0",
           FontColor->RGBColor[{
              Rational[1, 2], 
              Rational[1, 2], 0}]], "+"]}]]}], "]"}], "+", 
     RowBox[{"\[DoubleStruckCapitalC]", "[", 
      RowBox[{
       RowBox[{"-", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{"2", " ", "\[ImaginaryI]", " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"232092", " ", 
              SuperscriptBox["u", "16"]}], "+", 
             RowBox[{"130248", " ", 
              SuperscriptBox["u", "18"]}], "+", 
             RowBox[{"30618", " ", 
              SuperscriptBox["u", "20"]}], "-", 
             RowBox[{"3645", " ", 
              SuperscriptBox[
               RowBox[{"(", 
                SuperscriptBox[
                 StyleBox["Q0",
                  FontColor->RGBColor[{
                    Rational[1, 2], 
                    Rational[1, 2], 0}]], "-"], ")"}], "3"], " ", 
              SuperscriptBox[
               RowBox[{"(", 
                SuperscriptBox[
                 StyleBox["Q0",
                  FontColor->RGBColor[{
                    Rational[1, 2], 
                    Rational[1, 2], 0}]], "+"], ")"}], "3"]}], "+", 
             RowBox[{"162", " ", 
              SuperscriptBox["u", "14"], " ", 
              RowBox[{"(", 
               RowBox[{"1445", "+", 
                RowBox[{"36", " ", 
                 SuperscriptBox[
                  StyleBox["Q0",
                   FontColor->RGBColor[{
                    Rational[1, 2], 
                    Rational[1, 2], 0}]], "-"], " ", 
                 SuperscriptBox[
                  StyleBox["Q0",
                   FontColor->RGBColor[{
                    Rational[1, 2], 
                    Rational[1, 2], 0}]], "+"]}]}], ")"}]}], "+", 
             RowBox[{
              SuperscriptBox["u", "10"], " ", 
              RowBox[{"(", 
               RowBox[{"55520", "+", 
                RowBox[{"37368", " ", 
                 SuperscriptBox[
                  StyleBox["Q0",
                   FontColor->RGBColor[{
                    Rational[1, 2], 
                    Rational[1, 2], 0}]], "-"], " ", 
                 SuperscriptBox[
                  StyleBox["Q0",
                   FontColor->RGBColor[{
                    Rational[1, 2], 
                    Rational[1, 2], 0}]], "+"]}], "-", 
                RowBox[{"9639", " ", 
                 SuperscriptBox[
                  RowBox[{"(", 
                   SuperscriptBox[
                    StyleBox["Q0",
                    FontColor->RGBColor[{
                    Rational[1, 2], 
                    Rational[1, 2], 0}]], "-"], ")"}], "2"], " ", 
                 SuperscriptBox[
                  RowBox[{"(", 
                   SuperscriptBox[
                    StyleBox["Q0",
                    FontColor->RGBColor[{
                    Rational[1, 2], 
                    Rational[1, 2], 0}]], "+"], ")"}], "2"]}]}], ")"}]}], "-", 
             RowBox[{"9", " ", 
              SuperscriptBox["u", "12"], " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"-", "15380"}], "-", 
                RowBox[{"2664", " ", 
                 SuperscriptBox[
                  StyleBox["Q0",
                   FontColor->RGBColor[{
                    Rational[1, 2], 
                    Rational[1, 2], 0}]], "-"], " ", 
                 SuperscriptBox[
                  StyleBox["Q0",
                   FontColor->RGBColor[{
                    Rational[1, 2], 
                    Rational[1, 2], 0}]], "+"]}], "+", 
                RowBox[{"189", " ", 
                 SuperscriptBox[
                  RowBox[{"(", 
                   SuperscriptBox[
                    StyleBox["Q0",
                    FontColor->RGBColor[{
                    Rational[1, 2], 
                    Rational[1, 2], 0}]], "-"], ")"}], "2"], " ", 
                 SuperscriptBox[
                  RowBox[{"(", 
                   SuperscriptBox[
                    StyleBox["Q0",
                    FontColor->RGBColor[{
                    Rational[1, 2], 
                    Rational[1, 2], 0}]], "+"], ")"}], "2"]}]}], ")"}]}], "+", 
             RowBox[{
              SuperscriptBox["u", "6"], " ", 
              RowBox[{"(", 
               RowBox[{"7436", "+", 
                RowBox[{"7128", " ", 
                 SuperscriptBox[
                  StyleBox["Q0",
                   FontColor->RGBColor[{
                    Rational[1, 2], 
                    Rational[1, 2], 0}]], "-"], " ", 
                 SuperscriptBox[
                  StyleBox["Q0",
                   FontColor->RGBColor[{
                    Rational[1, 2], 
                    Rational[1, 2], 0}]], "+"]}], "-", 
                RowBox[{"32724", " ", 
                 SuperscriptBox[
                  RowBox[{"(", 
                   SuperscriptBox[
                    StyleBox["Q0",
                    FontColor->RGBColor[{
                    Rational[1, 2], 
                    Rational[1, 2], 0}]], "-"], ")"}], "2"], " ", 
                 SuperscriptBox[
                  RowBox[{"(", 
                   SuperscriptBox[
                    StyleBox["Q0",
                    FontColor->RGBColor[{
                    Rational[1, 2], 
                    Rational[1, 2], 0}]], "+"], ")"}], "2"]}], "-", 
                RowBox[{"102789", " ", 
                 SuperscriptBox[
                  RowBox[{"(", 
                   SuperscriptBox[
                    StyleBox["Q0",
                    FontColor->RGBColor[{
                    Rational[1, 2], 
                    Rational[1, 2], 0}]], "-"], ")"}], "3"], " ", 
                 SuperscriptBox[
                  RowBox[{"(", 
                   SuperscriptBox[
                    StyleBox["Q0",
                    FontColor->RGBColor[{
                    Rational[1, 2], 
                    Rational[1, 2], 0}]], "+"], ")"}], "3"]}]}], ")"}]}], "+", 
             RowBox[{
              SuperscriptBox["u", "8"], " ", 
              RowBox[{"(", 
               RowBox[{"18866", "+", 
                RowBox[{"26352", " ", 
                 SuperscriptBox[
                  StyleBox["Q0",
                   FontColor->RGBColor[{
                    Rational[1, 2], 
                    Rational[1, 2], 0}]], "-"], " ", 
                 SuperscriptBox[
                  StyleBox["Q0",
                   FontColor->RGBColor[{
                    Rational[1, 2], 
                    Rational[1, 2], 0}]], "+"]}], "-", 
                RowBox[{"25272", " ", 
                 SuperscriptBox[
                  RowBox[{"(", 
                   SuperscriptBox[
                    StyleBox["Q0",
                    FontColor->RGBColor[{
                    Rational[1, 2], 
                    Rational[1, 2], 0}]], "-"], ")"}], "2"], " ", 
                 SuperscriptBox[
                  RowBox[{"(", 
                   SuperscriptBox[
                    StyleBox["Q0",
                    FontColor->RGBColor[{
                    Rational[1, 2], 
                    Rational[1, 2], 0}]], "+"], ")"}], "2"]}], "-", 
                RowBox[{"32076", " ", 
                 SuperscriptBox[
                  RowBox[{"(", 
                   SuperscriptBox[
                    StyleBox["Q0",
                    FontColor->RGBColor[{
                    Rational[1, 2], 
                    Rational[1, 2], 0}]], "-"], ")"}], "3"], " ", 
                 SuperscriptBox[
                  RowBox[{"(", 
                   SuperscriptBox[
                    StyleBox["Q0",
                    FontColor->RGBColor[{
                    Rational[1, 2], 
                    Rational[1, 2], 0}]], "+"], ")"}], "3"]}]}], ")"}]}], "-", 
             RowBox[{
              SuperscriptBox["u", "2"], " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"-", "226"}], "+", 
                RowBox[{"216", " ", 
                 SuperscriptBox[
                  StyleBox["Q0",
                   FontColor->RGBColor[{
                    Rational[1, 2], 
                    Rational[1, 2], 0}]], "-"], " ", 
                 SuperscriptBox[
                  StyleBox["Q0",
                   FontColor->RGBColor[{
                    Rational[1, 2], 
                    Rational[1, 2], 0}]], "+"]}], "+", 
                RowBox[{"4293", " ", 
                 SuperscriptBox[
                  RowBox[{"(", 
                   SuperscriptBox[
                    StyleBox["Q0",
                    FontColor->RGBColor[{
                    Rational[1, 2], 
                    Rational[1, 2], 0}]], "-"], ")"}], "2"], " ", 
                 SuperscriptBox[
                  RowBox[{"(", 
                   SuperscriptBox[
                    StyleBox["Q0",
                    FontColor->RGBColor[{
                    Rational[1, 2], 
                    Rational[1, 2], 0}]], "+"], ")"}], "2"]}], "+", 
                RowBox[{"51759", " ", 
                 SuperscriptBox[
                  RowBox[{"(", 
                   SuperscriptBox[
                    StyleBox["Q0",
                    FontColor->RGBColor[{
                    Rational[1, 2], 
                    Rational[1, 2], 0}]], "-"], ")"}], "3"], " ", 
                 SuperscriptBox[
                  RowBox[{"(", 
                   SuperscriptBox[
                    StyleBox["Q0",
                    FontColor->RGBColor[{
                    Rational[1, 2], 
                    Rational[1, 2], 0}]], "+"], ")"}], "3"]}]}], ")"}]}], "-", 
             RowBox[{
              SuperscriptBox["u", "4"], " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"-", "2036"}], "+", 
                RowBox[{"216", " ", 
                 SuperscriptBox[
                  StyleBox["Q0",
                   FontColor->RGBColor[{
                    Rational[1, 2], 
                    Rational[1, 2], 0}]], "-"], " ", 
                 SuperscriptBox[
                  StyleBox["Q0",
                   FontColor->RGBColor[{
                    Rational[1, 2], 
                    Rational[1, 2], 0}]], "+"]}], "+", 
                RowBox[{"19683", " ", 
                 SuperscriptBox[
                  RowBox[{"(", 
                   SuperscriptBox[
                    StyleBox["Q0",
                    FontColor->RGBColor[{
                    Rational[1, 2], 
                    Rational[1, 2], 0}]], "-"], ")"}], "2"], " ", 
                 SuperscriptBox[
                  RowBox[{"(", 
                   SuperscriptBox[
                    StyleBox["Q0",
                    FontColor->RGBColor[{
                    Rational[1, 2], 
                    Rational[1, 2], 0}]], "+"], ")"}], "2"]}], "+", 
                RowBox[{"118827", " ", 
                 SuperscriptBox[
                  RowBox[{"(", 
                   SuperscriptBox[
                    StyleBox["Q0",
                    FontColor->RGBColor[{
                    Rational[1, 2], 
                    Rational[1, 2], 0}]], "-"], ")"}], "3"], " ", 
                 SuperscriptBox[
                  RowBox[{"(", 
                   SuperscriptBox[
                    StyleBox["Q0",
                    FontColor->RGBColor[{
                    Rational[1, 2], 
                    Rational[1, 2], 0}]], "+"], ")"}], "3"]}]}], ")"}]}]}], 
            ")"}], " ", 
           SubscriptBox[
            OverscriptBox[
             StyleBox["W",
              FontColor->RGBColor[0.54, 0.35, 0.15]], 
             StyleBox["^",
              FontColor->RGBColor[0.54, 0.35, 0.15]]], "lead"]}], ")"}], "/", 
         
         RowBox[{"(", 
          RowBox[{"2187", " ", 
           SuperscriptBox["u", "2"], " ", 
           SuperscriptBox[
            RowBox[{"(", 
             RowBox[{"1", "+", 
              SuperscriptBox["u", "2"]}], ")"}], "4"], " ", 
           SuperscriptBox[
            RowBox[{"(", 
             SuperscriptBox[
              StyleBox["Q0",
               FontColor->RGBColor[{
                  Rational[1, 2], 
                  Rational[1, 2], 0}]], "-"], ")"}], "3"], " ", 
           SuperscriptBox[
            RowBox[{"(", 
             SuperscriptBox[
              StyleBox["Q0",
               FontColor->RGBColor[{
                  Rational[1, 2], 
                  Rational[1, 2], 0}]], "+"], ")"}], "3"]}], ")"}]}]}], "+", 
       FractionBox[
        RowBox[{"4", " ", "\[ImaginaryI]", " ", 
         RowBox[{"(", 
          RowBox[{"10", "+", 
           RowBox[{"277", " ", 
            SuperscriptBox["u", "4"]}], "+", 
           RowBox[{"408", " ", 
            SuperscriptBox["u", "6"]}], "+", 
           RowBox[{"549", " ", 
            SuperscriptBox["u", "8"]}], "+", 
           RowBox[{"243", " ", 
            SuperscriptBox["u", "10"]}], "-", 
           RowBox[{"405", " ", 
            SuperscriptBox[
             RowBox[{"(", 
              SuperscriptBox[
               StyleBox["Q0",
                FontColor->RGBColor[{
                   Rational[1, 2], 
                   Rational[1, 2], 0}]], "-"], ")"}], "2"], " ", 
            SuperscriptBox[
             RowBox[{"(", 
              SuperscriptBox[
               StyleBox["Q0",
                FontColor->RGBColor[{
                   Rational[1, 2], 
                   Rational[1, 2], 0}]], "+"], ")"}], "2"]}], "+", 
           RowBox[{
            SuperscriptBox["u", "2"], " ", 
            RowBox[{"(", 
             RowBox[{"87", "-", 
              RowBox[{"405", " ", 
               SuperscriptBox[
                RowBox[{"(", 
                 SuperscriptBox[
                  StyleBox["Q0",
                   FontColor->RGBColor[{
                    Rational[1, 2], 
                    Rational[1, 2], 0}]], "-"], ")"}], "2"], " ", 
               SuperscriptBox[
                RowBox[{"(", 
                 SuperscriptBox[
                  StyleBox["Q0",
                   FontColor->RGBColor[{
                    Rational[1, 2], 
                    Rational[1, 2], 0}]], "+"], ")"}], "2"]}]}], ")"}]}]}], 
          ")"}], " ", 
         SubscriptBox[
          OverscriptBox[
           StyleBox["W",
            FontColor->RGBColor[0.54, 0.35, 0.15]], 
           StyleBox["^",
            FontColor->RGBColor[0.54, 0.35, 0.15]]], "sublead"]}], 
        RowBox[{"243", " ", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{"1", "+", 
            SuperscriptBox["u", "2"]}], ")"}], "2"], " ", 
         SuperscriptBox[
          RowBox[{"(", 
           SuperscriptBox[
            StyleBox["Q0",
             FontColor->RGBColor[{
                Rational[1, 2], 
                Rational[1, 2], 0}]], "-"], ")"}], "2"], " ", 
         SuperscriptBox[
          RowBox[{"(", 
           SuperscriptBox[
            StyleBox["Q0",
             FontColor->RGBColor[{
                Rational[1, 2], 
                Rational[1, 2], 0}]], "+"], ")"}], "2"]}]], "-", 
       FractionBox[
        RowBox[{"2", " ", "\[ImaginaryI]", " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"24", " ", 
            SuperscriptBox["u", "4"]}], "+", 
           RowBox[{"45", " ", 
            SuperscriptBox["u", "6"]}], "+", 
           RowBox[{"27", " ", 
            SuperscriptBox["u", "8"]}], "+", 
           RowBox[{
            SuperscriptBox["u", "2"], " ", 
            RowBox[{"(", 
             RowBox[{"7", "-", 
              RowBox[{"18", " ", 
               SuperscriptBox[
                StyleBox["Q0",
                 FontColor->RGBColor[{
                    Rational[1, 2], 
                    Rational[1, 2], 0}]], "-"], " ", 
               SuperscriptBox[
                StyleBox["Q0",
                 FontColor->RGBColor[{
                    Rational[1, 2], 
                    Rational[1, 2], 0}]], "+"]}]}], ")"}]}], "+", 
           SuperscriptBox[
            RowBox[{"(", 
             RowBox[{"1", "-", 
              RowBox[{"9", " ", 
               SuperscriptBox[
                StyleBox["Q0",
                 FontColor->RGBColor[{
                    Rational[1, 2], 
                    Rational[1, 2], 0}]], "-"], " ", 
               SuperscriptBox[
                StyleBox["Q0",
                 FontColor->RGBColor[{
                    Rational[1, 2], 
                    Rational[1, 2], 0}]], "+"]}]}], ")"}], "2"]}], ")"}], " ", 
         SubscriptBox[
          OverscriptBox[
           StyleBox["W",
            FontColor->RGBColor[0.54, 0.35, 0.15]], 
           StyleBox["^",
            FontColor->RGBColor[0.54, 0.35, 0.15]]], "sublead2"]}], 
        RowBox[{"243", " ", 
         RowBox[{"(", 
          RowBox[{"1", "+", 
           SuperscriptBox["u", "2"]}], ")"}], " ", 
         SuperscriptBox[
          RowBox[{"(", 
           SuperscriptBox[
            StyleBox["Q0",
             FontColor->RGBColor[{
                Rational[1, 2], 
                Rational[1, 2], 0}]], "-"], ")"}], "2"], " ", 
         SuperscriptBox[
          RowBox[{"(", 
           SuperscriptBox[
            StyleBox["Q0",
             FontColor->RGBColor[{
                Rational[1, 2], 
                Rational[1, 2], 0}]], "+"], ")"}], "2"]}]]}], "]"}], "+", 
     RowBox[{
      FractionBox["38", "9"], " ", 
      SubscriptBox[
       StyleBox["W",
        FontColor->RGBColor[0.54, 0.35, 0.15]], 
       RowBox[{"1", ",", "v0", ",", "lead"}]]}], "-", 
     RowBox[{
      FractionBox["4", "3"], " ", 
      SubscriptBox[
       StyleBox["W",
        FontColor->RGBColor[0.54, 0.35, 0.15]], 
       RowBox[{"1", ",", "v0", ",", "sublead"}]]}], "-", 
     RowBox[{
      FractionBox["2", "9"], " ", 
      SubscriptBox[
       StyleBox["W",
        FontColor->RGBColor[0.54, 0.35, 0.15]], 
       RowBox[{"1", ",", "v0", ",", "sublead2"}]]}], "-", 
     RowBox[{"14340", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2"]}], "+", 
     FractionBox[
      RowBox[{"65064", " ", 
       SubsuperscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "2", "2"]}], "5"], "+", 
     FractionBox[
      RowBox[{"234112", " ", 
       SubsuperscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "2", "3"]}], "35"], "-", 
     FractionBox[
      RowBox[{"345088", " ", 
       SubsuperscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "2", "4"]}], "175"], "+", 
     FractionBox[
      RowBox[{"6016", " ", 
       SubsuperscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "2", "5"]}], "175"], "+", 
     RowBox[{"7740", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3"]}], "+", 
     RowBox[{"4696", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3"]}], "-", 
     RowBox[{
      FractionBox["70624", "5"], " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2", "2"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3"]}], "-", 
     RowBox[{
      FractionBox["12864", "35"], " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2", "3"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3"]}], "+", 
     RowBox[{
      FractionBox["384", "25"], " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2", "4"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3"]}], "+", 
     RowBox[{"14312", " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3", "2"]}], "+", 
     RowBox[{"5280", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2"], " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3", "2"]}], "-", 
     RowBox[{
      FractionBox["192", "5"], " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2", "2"], " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3", "2"]}], "-", 
     RowBox[{"1056", " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3", "3"]}], "+", 
     RowBox[{"27132", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "5"]}], "+", 
     RowBox[{"3112", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "5"]}], "+", 
     RowBox[{
      FractionBox["6288", "5"], " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2", "2"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "5"]}], "+", 
     RowBox[{
      FractionBox["768", "35"], " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2", "3"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "5"]}], "-", 
     RowBox[{"24352", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "5"]}], "-", 
     RowBox[{"1632", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "5"]}], "+", 
     RowBox[{"648", " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "5", "2"]}], "+", 
     RowBox[{"1404", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "7"]}], "-", 
     RowBox[{"3816", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "7"]}], "+", 
     RowBox[{
      FractionBox["144", "5"], " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2", "2"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "7"]}], "+", 
     RowBox[{"2880", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "7"]}]}]}], ",", 
   RowBox[{
    RowBox[{
     SubscriptBox["\[Beta]", "sublead2"], "[", "0", "]"}], "\[Rule]", 
    RowBox[{
     RowBox[{"-", "210762"}], "+", 
     RowBox[{"\[DoubleStruckCapitalC]", "[", 
      RowBox[{
       RowBox[{"-", 
        FractionBox[
         RowBox[{"2", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{
             RowBox[{"-", "6"}], " ", "\[ImaginaryI]"}], "+", 
            RowBox[{"6", " ", "\[ImaginaryI]", " ", 
             SuperscriptBox["u", "2"]}], "+", 
            RowBox[{"5", " ", 
             SuperscriptBox["u", "3"]}], "+", 
            RowBox[{"3", " ", "\[ImaginaryI]", " ", 
             SuperscriptBox["u", "4"]}], "+", 
            RowBox[{"93", " ", 
             SuperscriptBox["u", "5"]}]}], ")"}], " ", 
          SubscriptBox[
           StyleBox["H",
            FontColor->RGBColor[0.54, 0.35, 0.15]], "lead"]}], 
         RowBox[{"3", " ", 
          SuperscriptBox["u", "6"]}]]}], "+", 
       FractionBox[
        RowBox[{"2", " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"2", " ", "\[ImaginaryI]"}], "-", 
           RowBox[{"\[ImaginaryI]", " ", 
            SuperscriptBox["u", "2"]}], "+", 
           RowBox[{"8", " ", 
            SuperscriptBox["u", "3"]}]}], ")"}], " ", 
         SubscriptBox[
          StyleBox["H",
           FontColor->RGBColor[0.54, 0.35, 0.15]], "sublead"]}], 
        RowBox[{"3", " ", 
         SuperscriptBox["u", "4"]}]], "+", 
       FractionBox[
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           RowBox[{"2", " ", "\[ImaginaryI]"}], "-", 
           RowBox[{"4", " ", "u"}]}], ")"}], " ", 
         SubscriptBox[
          StyleBox["H",
           FontColor->RGBColor[0.54, 0.35, 0.15]], "sublead2"]}], 
        RowBox[{"3", " ", 
         SuperscriptBox["u", "2"]}]]}], "]"}], "+", 
     RowBox[{"\[DoubleStruckCapitalC]", "[", 
      RowBox[{
       RowBox[{
        FractionBox["1", 
         RowBox[{"27", " ", 
          SuperscriptBox["u", "4"], " ", 
          SuperscriptBox[
           RowBox[{"(", 
            RowBox[{"\[ImaginaryI]", "+", "u"}], ")"}], "3"], " ", 
          SuperscriptBox[
           RowBox[{"(", 
            SuperscriptBox[
             StyleBox["Q0",
              FontColor->RGBColor[{
                 Rational[1, 2], 
                 Rational[1, 2], 0}]], "+"], ")"}], "3"]}]], 
        RowBox[{"4", " ", 
         RowBox[{"(", 
          RowBox[{"2", "-", 
           RowBox[{"20", " ", "\[ImaginaryI]", " ", "u"}], "+", 
           RowBox[{"360", " ", "\[ImaginaryI]", " ", 
            SuperscriptBox["u", "9"]}], "+", 
           RowBox[{"72", " ", 
            SuperscriptBox["u", "10"]}], "+", 
           RowBox[{
            SuperscriptBox["u", "8"], " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "848"}], "+", 
              RowBox[{"96", " ", 
               SuperscriptBox[
                StyleBox["Q0",
                 FontColor->RGBColor[{
                    Rational[1, 2], 
                    Rational[1, 2], 0}]], "+"]}], "-", 
              RowBox[{"837", " ", 
               SuperscriptBox[
                RowBox[{"(", 
                 SuperscriptBox[
                  StyleBox["Q0",
                   FontColor->RGBColor[{
                    Rational[1, 2], 
                    Rational[1, 2], 0}]], "+"], ")"}], "2"]}]}], ")"}]}], "+", 
           RowBox[{
            SuperscriptBox["u", "4"], " ", 
            RowBox[{"(", 
             RowBox[{"122", "-", 
              RowBox[{"144", " ", 
               SuperscriptBox[
                StyleBox["Q0",
                 FontColor->RGBColor[{
                    Rational[1, 2], 
                    Rational[1, 2], 0}]], "+"]}], "-", 
              RowBox[{"567", " ", 
               SuperscriptBox[
                RowBox[{"(", 
                 SuperscriptBox[
                  StyleBox["Q0",
                   FontColor->RGBColor[{
                    Rational[1, 2], 
                    Rational[1, 2], 0}]], "+"], ")"}], "2"]}]}], ")"}]}], "+", 
           RowBox[{"20", " ", "\[ImaginaryI]", " ", 
            SuperscriptBox["u", "3"], " ", 
            RowBox[{"(", 
             RowBox[{"10", "-", 
              RowBox[{"6", " ", 
               SuperscriptBox[
                StyleBox["Q0",
                 FontColor->RGBColor[{
                    Rational[1, 2], 
                    Rational[1, 2], 0}]], "+"]}], "+", 
              RowBox[{"9", " ", 
               SuperscriptBox[
                RowBox[{"(", 
                 SuperscriptBox[
                  StyleBox["Q0",
                   FontColor->RGBColor[{
                    Rational[1, 2], 
                    Rational[1, 2], 0}]], "+"], ")"}], "2"]}]}], ")"}]}], "-", 
           RowBox[{"3", " ", 
            SuperscriptBox["u", "2"], " ", 
            RowBox[{"(", 
             RowBox[{"30", "-", 
              RowBox[{"8", " ", 
               SuperscriptBox[
                StyleBox["Q0",
                 FontColor->RGBColor[{
                    Rational[1, 2], 
                    Rational[1, 2], 0}]], "+"]}], "+", 
              RowBox[{"15", " ", 
               SuperscriptBox[
                RowBox[{"(", 
                 SuperscriptBox[
                  StyleBox["Q0",
                   FontColor->RGBColor[{
                    Rational[1, 2], 
                    Rational[1, 2], 0}]], "+"], ")"}], "2"]}]}], ")"}]}], "+", 
           RowBox[{"4", " ", "\[ImaginaryI]", " ", 
            SuperscriptBox["u", "5"], " ", 
            RowBox[{"(", 
             RowBox[{"101", "-", 
              RowBox[{"42", " ", 
               SuperscriptBox[
                StyleBox["Q0",
                 FontColor->RGBColor[{
                    Rational[1, 2], 
                    Rational[1, 2], 0}]], "+"]}], "+", 
              RowBox[{"792", " ", 
               SuperscriptBox[
                RowBox[{"(", 
                 SuperscriptBox[
                  StyleBox["Q0",
                   FontColor->RGBColor[{
                    Rational[1, 2], 
                    Rational[1, 2], 0}]], "+"], ")"}], "2"]}]}], ")"}]}], "-", 
           RowBox[{"4", " ", "\[ImaginaryI]", " ", 
            SuperscriptBox["u", "7"], " ", 
            RowBox[{"(", 
             RowBox[{"308", "-", 
              RowBox[{"96", " ", 
               SuperscriptBox[
                StyleBox["Q0",
                 FontColor->RGBColor[{
                    Rational[1, 2], 
                    Rational[1, 2], 0}]], "+"]}], "+", 
              RowBox[{"837", " ", 
               SuperscriptBox[
                RowBox[{"(", 
                 SuperscriptBox[
                  StyleBox["Q0",
                   FontColor->RGBColor[{
                    Rational[1, 2], 
                    Rational[1, 2], 0}]], "+"], ")"}], "2"]}]}], ")"}]}], "+", 
           RowBox[{"3", " ", 
            SuperscriptBox["u", "6"], " ", 
            RowBox[{"(", 
             RowBox[{"356", "-", 
              RowBox[{"168", " ", 
               SuperscriptBox[
                StyleBox["Q0",
                 FontColor->RGBColor[{
                    Rational[1, 2], 
                    Rational[1, 2], 0}]], "+"]}], "+", 
              RowBox[{"1659", " ", 
               SuperscriptBox[
                RowBox[{"(", 
                 SuperscriptBox[
                  StyleBox["Q0",
                   FontColor->RGBColor[{
                    Rational[1, 2], 
                    Rational[1, 2], 0}]], "+"], ")"}], "2"]}]}], ")"}]}]}], 
          ")"}], " ", 
         SubsuperscriptBox[
          StyleBox["W",
           FontColor->RGBColor[0.54, 0.35, 0.15]], 
          RowBox[{"1", ",", "lead"}], "+"]}]}], "+", 
       FractionBox[
        RowBox[{"8", " ", 
         RowBox[{"(", 
          RowBox[{"1", "-", 
           RowBox[{"3", " ", "\[ImaginaryI]", " ", "u"}], "+", 
           RowBox[{
            SuperscriptBox["u", "2"], " ", 
            RowBox[{"(", 
             RowBox[{"1", "-", 
              RowBox[{"12", " ", 
               SuperscriptBox[
                StyleBox["Q0",
                 FontColor->RGBColor[{
                    Rational[1, 2], 
                    Rational[1, 2], 0}]], "+"]}]}], ")"}]}], "+", 
           RowBox[{"8", " ", "\[ImaginaryI]", " ", 
            SuperscriptBox["u", "3"], " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "1"}], "+", 
              RowBox[{"3", " ", 
               SuperscriptBox[
                StyleBox["Q0",
                 FontColor->RGBColor[{
                    Rational[1, 2], 
                    Rational[1, 2], 0}]], "+"]}]}], ")"}]}], "+", 
           RowBox[{"4", " ", 
            SuperscriptBox["u", "4"], " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "1"}], "+", 
              RowBox[{"3", " ", 
               SuperscriptBox[
                StyleBox["Q0",
                 FontColor->RGBColor[{
                    Rational[1, 2], 
                    Rational[1, 2], 0}]], "+"]}]}], ")"}]}]}], ")"}], " ", 
         SubsuperscriptBox[
          StyleBox["W",
           FontColor->RGBColor[0.54, 0.35, 0.15]], 
          RowBox[{"1", ",", "sublead"}], "+"]}], 
        RowBox[{"9", " ", 
         SuperscriptBox["u", "2"], " ", 
         RowBox[{"(", 
          RowBox[{"\[ImaginaryI]", "+", "u"}], ")"}], " ", 
         SuperscriptBox[
          RowBox[{"(", 
           SuperscriptBox[
            StyleBox["Q0",
             FontColor->RGBColor[{
                Rational[1, 2], 
                Rational[1, 2], 0}]], "+"], ")"}], "2"]}]], "-", 
       FractionBox[
        RowBox[{"8", " ", 
         RowBox[{"(", 
          RowBox[{"\[ImaginaryI]", "+", "u"}], ")"}], " ", 
         SubsuperscriptBox[
          StyleBox["W",
           FontColor->RGBColor[0.54, 0.35, 0.15]], 
          RowBox[{"1", ",", "sublead2"}], "+"]}], 
        RowBox[{"3", " ", 
         SuperscriptBox[
          StyleBox["Q0",
           FontColor->RGBColor[{
              Rational[1, 2], 
              Rational[1, 2], 0}]], "+"]}]]}], "]"}], "+", 
     RowBox[{"\[DoubleStruckCapitalC]", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"(", 
         RowBox[{"2", " ", "\[ImaginaryI]", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"264870", " ", 
             SuperscriptBox["u", "18"]}], "+", 
            RowBox[{"61236", " ", 
             SuperscriptBox["u", "20"]}], "-", 
            RowBox[{"9477", " ", 
             SuperscriptBox[
              RowBox[{"(", 
               SuperscriptBox[
                StyleBox["Q0",
                 FontColor->RGBColor[{
                    Rational[1, 2], 
                    Rational[1, 2], 0}]], "-"], ")"}], "3"], " ", 
             SuperscriptBox[
              RowBox[{"(", 
               SuperscriptBox[
                StyleBox["Q0",
                 FontColor->RGBColor[{
                    Rational[1, 2], 
                    Rational[1, 2], 0}]], "+"], ")"}], "3"]}], "+", 
            RowBox[{"216", " ", 
             SuperscriptBox["u", "16"], " ", 
             RowBox[{"(", 
              RowBox[{"2269", "+", 
               RowBox[{"216", " ", 
                SuperscriptBox[
                 StyleBox["Q0",
                  FontColor->RGBColor[{
                    Rational[1, 2], 
                    Rational[1, 2], 0}]], "-"], " ", 
                SuperscriptBox[
                 StyleBox["Q0",
                  FontColor->RGBColor[{
                    Rational[1, 2], 
                    Rational[1, 2], 0}]], "+"]}]}], ")"}]}], "+", 
            RowBox[{"162", " ", 
             SuperscriptBox["u", "14"], " ", 
             RowBox[{"(", 
              RowBox[{"3247", "+", 
               RowBox[{"1382", " ", 
                SuperscriptBox[
                 StyleBox["Q0",
                  FontColor->RGBColor[{
                    Rational[1, 2], 
                    Rational[1, 2], 0}]], "-"], " ", 
                SuperscriptBox[
                 StyleBox["Q0",
                  FontColor->RGBColor[{
                    Rational[1, 2], 
                    Rational[1, 2], 0}]], "+"]}]}], ")"}]}], "+", 
            RowBox[{
             SuperscriptBox["u", "10"], " ", 
             RowBox[{"(", 
              RowBox[{"133048", "+", 
               RowBox[{"471348", " ", 
                SuperscriptBox[
                 StyleBox["Q0",
                  FontColor->RGBColor[{
                    Rational[1, 2], 
                    Rational[1, 2], 0}]], "-"], " ", 
                SuperscriptBox[
                 StyleBox["Q0",
                  FontColor->RGBColor[{
                    Rational[1, 2], 
                    Rational[1, 2], 0}]], "+"]}], "-", 
               RowBox[{"127818", " ", 
                SuperscriptBox[
                 RowBox[{"(", 
                  SuperscriptBox[
                   StyleBox["Q0",
                    FontColor->RGBColor[{
                    Rational[1, 2], 
                    Rational[1, 2], 0}]], "-"], ")"}], "2"], " ", 
                SuperscriptBox[
                 RowBox[{"(", 
                  SuperscriptBox[
                   StyleBox["Q0",
                    FontColor->RGBColor[{
                    Rational[1, 2], 
                    Rational[1, 2], 0}]], "+"], ")"}], "2"]}]}], ")"}]}], "+", 
            RowBox[{
             SuperscriptBox["u", "12"], " ", 
             RowBox[{"(", 
              RowBox[{"335592", "+", 
               RowBox[{"439452", " ", 
                SuperscriptBox[
                 StyleBox["Q0",
                  FontColor->RGBColor[{
                    Rational[1, 2], 
                    Rational[1, 2], 0}]], "-"], " ", 
                SuperscriptBox[
                 StyleBox["Q0",
                  FontColor->RGBColor[{
                    Rational[1, 2], 
                    Rational[1, 2], 0}]], "+"]}], "-", 
               RowBox[{"27702", " ", 
                SuperscriptBox[
                 RowBox[{"(", 
                  SuperscriptBox[
                   StyleBox["Q0",
                    FontColor->RGBColor[{
                    Rational[1, 2], 
                    Rational[1, 2], 0}]], "-"], ")"}], "2"], " ", 
                SuperscriptBox[
                 RowBox[{"(", 
                  SuperscriptBox[
                   StyleBox["Q0",
                    FontColor->RGBColor[{
                    Rational[1, 2], 
                    Rational[1, 2], 0}]], "+"], ")"}], "2"]}]}], ")"}]}], "+", 
            RowBox[{
             SuperscriptBox["u", "8"], " ", 
             RowBox[{"(", 
              RowBox[{"32668", "+", 
               RowBox[{"303336", " ", 
                SuperscriptBox[
                 StyleBox["Q0",
                  FontColor->RGBColor[{
                    Rational[1, 2], 
                    Rational[1, 2], 0}]], "-"], " ", 
                SuperscriptBox[
                 StyleBox["Q0",
                  FontColor->RGBColor[{
                    Rational[1, 2], 
                    Rational[1, 2], 0}]], "+"]}], "-", 
               RowBox[{"252882", " ", 
                SuperscriptBox[
                 RowBox[{"(", 
                  SuperscriptBox[
                   StyleBox["Q0",
                    FontColor->RGBColor[{
                    Rational[1, 2], 
                    Rational[1, 2], 0}]], "-"], ")"}], "2"], " ", 
                SuperscriptBox[
                 RowBox[{"(", 
                  SuperscriptBox[
                   StyleBox["Q0",
                    FontColor->RGBColor[{
                    Rational[1, 2], 
                    Rational[1, 2], 0}]], "+"], ")"}], "2"]}], "-", 
               RowBox[{"57591", " ", 
                SuperscriptBox[
                 RowBox[{"(", 
                  SuperscriptBox[
                   StyleBox["Q0",
                    FontColor->RGBColor[{
                    Rational[1, 2], 
                    Rational[1, 2], 0}]], "-"], ")"}], "3"], " ", 
                SuperscriptBox[
                 RowBox[{"(", 
                  SuperscriptBox[
                   StyleBox["Q0",
                    FontColor->RGBColor[{
                    Rational[1, 2], 
                    Rational[1, 2], 0}]], "+"], ")"}], "3"]}]}], ")"}]}], "-", 
            RowBox[{"2", " ", 
             SuperscriptBox["u", "2"], " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"-", "241"}], "-", 
               RowBox[{"558", " ", 
                SuperscriptBox[
                 StyleBox["Q0",
                  FontColor->RGBColor[{
                    Rational[1, 2], 
                    Rational[1, 2], 0}]], "-"], " ", 
                SuperscriptBox[
                 StyleBox["Q0",
                  FontColor->RGBColor[{
                    Rational[1, 2], 
                    Rational[1, 2], 0}]], "+"]}], "+", 
               RowBox[{"12150", " ", 
                SuperscriptBox[
                 RowBox[{"(", 
                  SuperscriptBox[
                   StyleBox["Q0",
                    FontColor->RGBColor[{
                    Rational[1, 2], 
                    Rational[1, 2], 0}]], "-"], ")"}], "2"], " ", 
                SuperscriptBox[
                 RowBox[{"(", 
                  SuperscriptBox[
                   StyleBox["Q0",
                    FontColor->RGBColor[{
                    Rational[1, 2], 
                    Rational[1, 2], 0}]], "+"], ")"}], "2"]}], "+", 
               RowBox[{"53946", " ", 
                SuperscriptBox[
                 RowBox[{"(", 
                  SuperscriptBox[
                   StyleBox["Q0",
                    FontColor->RGBColor[{
                    Rational[1, 2], 
                    Rational[1, 2], 0}]], "-"], ")"}], "3"], " ", 
                SuperscriptBox[
                 RowBox[{"(", 
                  SuperscriptBox[
                   StyleBox["Q0",
                    FontColor->RGBColor[{
                    Rational[1, 2], 
                    Rational[1, 2], 0}]], "+"], ")"}], "3"]}]}], ")"}]}], "-", 
            RowBox[{"4", " ", 
             SuperscriptBox["u", "4"], " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"-", "832"}], "-", 
               RowBox[{"4743", " ", 
                SuperscriptBox[
                 StyleBox["Q0",
                  FontColor->RGBColor[{
                    Rational[1, 2], 
                    Rational[1, 2], 0}]], "-"], " ", 
                SuperscriptBox[
                 StyleBox["Q0",
                  FontColor->RGBColor[{
                    Rational[1, 2], 
                    Rational[1, 2], 0}]], "+"]}], "+", 
               RowBox[{"32238", " ", 
                SuperscriptBox[
                 RowBox[{"(", 
                  SuperscriptBox[
                   StyleBox["Q0",
                    FontColor->RGBColor[{
                    Rational[1, 2], 
                    Rational[1, 2], 0}]], "-"], ")"}], "2"], " ", 
                SuperscriptBox[
                 RowBox[{"(", 
                  SuperscriptBox[
                   StyleBox["Q0",
                    FontColor->RGBColor[{
                    Rational[1, 2], 
                    Rational[1, 2], 0}]], "+"], ")"}], "2"]}], "+", 
               RowBox[{"58320", " ", 
                SuperscriptBox[
                 RowBox[{"(", 
                  SuperscriptBox[
                   StyleBox["Q0",
                    FontColor->RGBColor[{
                    Rational[1, 2], 
                    Rational[1, 2], 0}]], "-"], ")"}], "3"], " ", 
                SuperscriptBox[
                 RowBox[{"(", 
                  SuperscriptBox[
                   StyleBox["Q0",
                    FontColor->RGBColor[{
                    Rational[1, 2], 
                    Rational[1, 2], 0}]], "+"], ")"}], "3"]}]}], ")"}]}], "-", 
            RowBox[{"2", " ", 
             SuperscriptBox["u", "6"], " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"-", "4745"}], "-", 
               RowBox[{"56034", " ", 
                SuperscriptBox[
                 StyleBox["Q0",
                  FontColor->RGBColor[{
                    Rational[1, 2], 
                    Rational[1, 2], 0}]], "-"], " ", 
                SuperscriptBox[
                 StyleBox["Q0",
                  FontColor->RGBColor[{
                    Rational[1, 2], 
                    Rational[1, 2], 0}]], "+"]}], "+", 
               RowBox[{"128709", " ", 
                SuperscriptBox[
                 RowBox[{"(", 
                  SuperscriptBox[
                   StyleBox["Q0",
                    FontColor->RGBColor[{
                    Rational[1, 2], 
                    Rational[1, 2], 0}]], "-"], ")"}], "2"], " ", 
                SuperscriptBox[
                 RowBox[{"(", 
                  SuperscriptBox[
                   StyleBox["Q0",
                    FontColor->RGBColor[{
                    Rational[1, 2], 
                    Rational[1, 2], 0}]], "+"], ")"}], "2"]}], "+", 
               RowBox[{"96228", " ", 
                SuperscriptBox[
                 RowBox[{"(", 
                  SuperscriptBox[
                   StyleBox["Q0",
                    FontColor->RGBColor[{
                    Rational[1, 2], 
                    Rational[1, 2], 0}]], "-"], ")"}], "3"], " ", 
                SuperscriptBox[
                 RowBox[{"(", 
                  SuperscriptBox[
                   StyleBox["Q0",
                    FontColor->RGBColor[{
                    Rational[1, 2], 
                    Rational[1, 2], 0}]], "+"], ")"}], "3"]}]}], ")"}]}]}], 
           ")"}], " ", 
          SubscriptBox[
           OverscriptBox[
            StyleBox["W",
             FontColor->RGBColor[0.54, 0.35, 0.15]], 
            StyleBox["^",
             FontColor->RGBColor[0.54, 0.35, 0.15]]], "lead"]}], ")"}], "/", 
        RowBox[{"(", 
         RowBox[{"729", " ", 
          SuperscriptBox["u", "2"], " ", 
          SuperscriptBox[
           RowBox[{"(", 
            RowBox[{"1", "+", 
             SuperscriptBox["u", "2"]}], ")"}], "4"], " ", 
          SuperscriptBox[
           RowBox[{"(", 
            SuperscriptBox[
             StyleBox["Q0",
              FontColor->RGBColor[{
                 Rational[1, 2], 
                 Rational[1, 2], 0}]], "-"], ")"}], "3"], " ", 
          SuperscriptBox[
           RowBox[{"(", 
            SuperscriptBox[
             StyleBox["Q0",
              FontColor->RGBColor[{
                 Rational[1, 2], 
                 Rational[1, 2], 0}]], "+"], ")"}], "3"]}], ")"}]}], "-", 
       RowBox[{
        FractionBox["1", 
         RowBox[{"81", " ", 
          SuperscriptBox[
           RowBox[{"(", 
            RowBox[{"1", "+", 
             SuperscriptBox["u", "2"]}], ")"}], "2"], " ", 
          SuperscriptBox[
           RowBox[{"(", 
            SuperscriptBox[
             StyleBox["Q0",
              FontColor->RGBColor[{
                 Rational[1, 2], 
                 Rational[1, 2], 0}]], "-"], ")"}], "2"], " ", 
          SuperscriptBox[
           RowBox[{"(", 
            SuperscriptBox[
             StyleBox["Q0",
              FontColor->RGBColor[{
                 Rational[1, 2], 
                 Rational[1, 2], 0}]], "+"], ")"}], "2"]}]], 
        RowBox[{"2", " ", "\[ImaginaryI]", " ", 
         RowBox[{"(", 
          RowBox[{"51", "+", 
           RowBox[{"879", " ", 
            SuperscriptBox["u", "6"]}], "+", 
           RowBox[{"1800", " ", 
            SuperscriptBox["u", "8"]}], "+", 
           RowBox[{"945", " ", 
            SuperscriptBox["u", "10"]}], "-", 
           RowBox[{"144", " ", 
            SuperscriptBox[
             StyleBox["Q0",
              FontColor->RGBColor[{
                 Rational[1, 2], 
                 Rational[1, 2], 0}]], "-"], " ", 
            SuperscriptBox[
             StyleBox["Q0",
              FontColor->RGBColor[{
                 Rational[1, 2], 
                 Rational[1, 2], 0}]], "+"]}], "-", 
           RowBox[{"729", " ", 
            SuperscriptBox[
             RowBox[{"(", 
              SuperscriptBox[
               StyleBox["Q0",
                FontColor->RGBColor[{
                   Rational[1, 2], 
                   Rational[1, 2], 0}]], "-"], ")"}], "2"], " ", 
            SuperscriptBox[
             RowBox[{"(", 
              SuperscriptBox[
               StyleBox["Q0",
                FontColor->RGBColor[{
                   Rational[1, 2], 
                   Rational[1, 2], 0}]], "+"], ")"}], "2"]}], "-", 
           RowBox[{"9", " ", 
            SuperscriptBox["u", "4"], " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "77"}], "+", 
              RowBox[{"16", " ", 
               SuperscriptBox[
                StyleBox["Q0",
                 FontColor->RGBColor[{
                    Rational[1, 2], 
                    Rational[1, 2], 0}]], "-"], " ", 
               SuperscriptBox[
                StyleBox["Q0",
                 FontColor->RGBColor[{
                    Rational[1, 2], 
                    Rational[1, 2], 0}]], "+"]}]}], ")"}]}], "+", 
           RowBox[{
            SuperscriptBox["u", "2"], " ", 
            RowBox[{"(", 
             RowBox[{"328", "-", 
              RowBox[{"288", " ", 
               SuperscriptBox[
                StyleBox["Q0",
                 FontColor->RGBColor[{
                    Rational[1, 2], 
                    Rational[1, 2], 0}]], "-"], " ", 
               SuperscriptBox[
                StyleBox["Q0",
                 FontColor->RGBColor[{
                    Rational[1, 2], 
                    Rational[1, 2], 0}]], "+"]}], "-", 
              RowBox[{"729", " ", 
               SuperscriptBox[
                RowBox[{"(", 
                 SuperscriptBox[
                  StyleBox["Q0",
                   FontColor->RGBColor[{
                    Rational[1, 2], 
                    Rational[1, 2], 0}]], "-"], ")"}], "2"], " ", 
               SuperscriptBox[
                RowBox[{"(", 
                 SuperscriptBox[
                  StyleBox["Q0",
                   FontColor->RGBColor[{
                    Rational[1, 2], 
                    Rational[1, 2], 0}]], "+"], ")"}], "2"]}]}], ")"}]}]}], 
          ")"}], " ", 
         SubscriptBox[
          OverscriptBox[
           StyleBox["W",
            FontColor->RGBColor[0.54, 0.35, 0.15]], 
           StyleBox["^",
            FontColor->RGBColor[0.54, 0.35, 0.15]]], "sublead"]}]}], "+", 
       FractionBox[
        RowBox[{"2", " ", "\[ImaginaryI]", " ", 
         RowBox[{"(", 
          RowBox[{"5", "+", 
           RowBox[{"120", " ", 
            SuperscriptBox["u", "4"]}], "+", 
           RowBox[{"225", " ", 
            SuperscriptBox["u", "6"]}], "+", 
           RowBox[{"135", " ", 
            SuperscriptBox["u", "8"]}], "-", 
           RowBox[{"36", " ", 
            SuperscriptBox[
             StyleBox["Q0",
              FontColor->RGBColor[{
                 Rational[1, 2], 
                 Rational[1, 2], 0}]], "-"], " ", 
            SuperscriptBox[
             StyleBox["Q0",
              FontColor->RGBColor[{
                 Rational[1, 2], 
                 Rational[1, 2], 0}]], "+"]}], "-", 
           RowBox[{"81", " ", 
            SuperscriptBox[
             RowBox[{"(", 
              SuperscriptBox[
               StyleBox["Q0",
                FontColor->RGBColor[{
                   Rational[1, 2], 
                   Rational[1, 2], 0}]], "-"], ")"}], "2"], " ", 
            SuperscriptBox[
             RowBox[{"(", 
              SuperscriptBox[
               StyleBox["Q0",
                FontColor->RGBColor[{
                   Rational[1, 2], 
                   Rational[1, 2], 0}]], "+"], ")"}], "2"]}], "+", 
           RowBox[{
            SuperscriptBox["u", "2"], " ", 
            RowBox[{"(", 
             RowBox[{"35", "-", 
              RowBox[{"36", " ", 
               SuperscriptBox[
                StyleBox["Q0",
                 FontColor->RGBColor[{
                    Rational[1, 2], 
                    Rational[1, 2], 0}]], "-"], " ", 
               SuperscriptBox[
                StyleBox["Q0",
                 FontColor->RGBColor[{
                    Rational[1, 2], 
                    Rational[1, 2], 0}]], "+"]}]}], ")"}]}]}], ")"}], " ", 
         SubscriptBox[
          OverscriptBox[
           StyleBox["W",
            FontColor->RGBColor[0.54, 0.35, 0.15]], 
           StyleBox["^",
            FontColor->RGBColor[0.54, 0.35, 0.15]]], "sublead2"]}], 
        RowBox[{"81", " ", 
         RowBox[{"(", 
          RowBox[{"1", "+", 
           SuperscriptBox["u", "2"]}], ")"}], " ", 
         SuperscriptBox[
          RowBox[{"(", 
           SuperscriptBox[
            StyleBox["Q0",
             FontColor->RGBColor[{
                Rational[1, 2], 
                Rational[1, 2], 0}]], "-"], ")"}], "2"], " ", 
         SuperscriptBox[
          RowBox[{"(", 
           SuperscriptBox[
            StyleBox["Q0",
             FontColor->RGBColor[{
                Rational[1, 2], 
                Rational[1, 2], 0}]], "+"], ")"}], "2"]}]]}], "]"}], "-", 
     RowBox[{"116", " ", 
      SubscriptBox[
       StyleBox["W",
        FontColor->RGBColor[0.54, 0.35, 0.15]], 
       RowBox[{"1", ",", "v0", ",", "lead"}]]}], "+", 
     RowBox[{
      FractionBox["26", "3"], " ", 
      SubscriptBox[
       StyleBox["W",
        FontColor->RGBColor[0.54, 0.35, 0.15]], 
       RowBox[{"1", ",", "v0", ",", "sublead"}]]}], "+", 
     RowBox[{
      FractionBox["10", "3"], " ", 
      SubscriptBox[
       StyleBox["W",
        FontColor->RGBColor[0.54, 0.35, 0.15]], 
       RowBox[{"1", ",", "v0", ",", "sublead2"}]]}], "+", 
     RowBox[{"114876", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2"]}], "+", 
     FractionBox[
      RowBox[{"155376", " ", 
       SubsuperscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "2", "2"]}], "5"], "-", 
     FractionBox[
      RowBox[{"241104", " ", 
       SubsuperscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "2", "3"]}], "7"], "+", 
     FractionBox[
      RowBox[{"100608", " ", 
       SubsuperscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "2", "4"]}], "25"], "+", 
     FractionBox[
      RowBox[{"57216", " ", 
       SubsuperscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "2", "5"]}], "175"], "+", 
     RowBox[{"133884", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3"]}], "-", 
     RowBox[{"15240", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3"]}], "+", 
     RowBox[{"8256", " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2", "2"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3"]}], "+", 
     RowBox[{
      FractionBox["19776", "35"], " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2", "3"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3"]}], "+", 
     RowBox[{
      FractionBox["1152", "25"], " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2", "4"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3"]}], "-", 
     RowBox[{"40584", " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3", "2"]}], "-", 
     RowBox[{"16416", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2"], " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3", "2"]}], "-", 
     RowBox[{
      FractionBox["576", "5"], " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2", "2"], " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3", "2"]}], "-", 
     RowBox[{"1440", " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3", "3"]}], "-", 
     RowBox[{"9648", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "5"]}], "-", 
     RowBox[{"17088", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "5"]}], "-", 
     RowBox[{
      FractionBox["3456", "5"], " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2", "2"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "5"]}], "+", 
     RowBox[{
      FractionBox["2304", "35"], " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2", "3"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "5"]}], "+", 
     RowBox[{"36240", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "5"]}], "-", 
     RowBox[{"4896", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "5"]}], "+", 
     RowBox[{"2592", " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "5", "2"]}], "-", 
     RowBox[{"42444", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "7"]}], "+", 
     RowBox[{"18360", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "7"]}], "+", 
     RowBox[{
      FractionBox["432", "5"], " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2", "2"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "7"]}], "+", 
     RowBox[{"9936", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "7"]}]}]}], ",", 
   RowBox[{
    RowBox[{
     SubscriptBox["\[Alpha]", "sublead2"], "[", "1", "]"}], "\[Rule]", 
    RowBox[{
     RowBox[{"-", "47304"}], "+", 
     RowBox[{"\[DoubleStruckCapitalC]", "[", 
      RowBox[{
       FractionBox[
        RowBox[{"8", " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"-", "\[ImaginaryI]"}], "+", "u", "-", 
           RowBox[{"2", " ", "\[ImaginaryI]", " ", 
            SuperscriptBox["u", "2"]}], "+", 
           SuperscriptBox["u", "3"], "+", 
           RowBox[{"5", " ", "\[ImaginaryI]", " ", 
            SuperscriptBox["u", "4"]}], "-", 
           RowBox[{"10", " ", 
            SuperscriptBox["u", "5"]}]}], ")"}], " ", 
         SubscriptBox[
          StyleBox["H",
           FontColor->RGBColor[0.54, 0.35, 0.15]], "lead"]}], 
        RowBox[{"9", " ", 
         SuperscriptBox["u", "6"]}]], "+", 
       FractionBox[
        RowBox[{"16", " ", 
         RowBox[{"(", 
          RowBox[{"1", "-", 
           RowBox[{"3", " ", "\[ImaginaryI]", " ", "u"}]}], ")"}], " ", 
         SubscriptBox[
          StyleBox["H",
           FontColor->RGBColor[0.54, 0.35, 0.15]], "sublead"]}], 
        RowBox[{"9", " ", 
         SuperscriptBox["u", "3"]}]], "-", 
       FractionBox[
        RowBox[{"8", " ", 
         RowBox[{"(", 
          RowBox[{"\[ImaginaryI]", "+", "u"}], ")"}], " ", 
         SubscriptBox[
          StyleBox["H",
           FontColor->RGBColor[0.54, 0.35, 0.15]], "sublead2"]}], 
        RowBox[{"9", " ", 
         SuperscriptBox["u", "2"]}]]}], "]"}], "+", 
     RowBox[{"\[DoubleStruckCapitalC]", "[", 
      RowBox[{
       RowBox[{
        FractionBox["1", 
         RowBox[{"81", " ", 
          SuperscriptBox["u", "4"], " ", 
          SuperscriptBox[
           RowBox[{"(", 
            RowBox[{"\[ImaginaryI]", "+", "u"}], ")"}], "3"], " ", 
          SuperscriptBox[
           RowBox[{"(", 
            SuperscriptBox[
             StyleBox["Q0",
              FontColor->RGBColor[{
                 Rational[1, 2], 
                 Rational[1, 2], 0}]], "+"], ")"}], "3"]}]], 
        RowBox[{"16", " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"180", " ", "\[ImaginaryI]", " ", 
            SuperscriptBox["u", "9"]}], "+", 
           RowBox[{"36", " ", 
            SuperscriptBox["u", "10"]}], "+", 
           SuperscriptBox[
            RowBox[{"(", 
             RowBox[{"1", "+", 
              RowBox[{"3", " ", 
               SuperscriptBox[
                StyleBox["Q0",
                 FontColor->RGBColor[{
                    Rational[1, 2], 
                    Rational[1, 2], 0}]], "+"]}]}], ")"}], "2"], "-", 
           RowBox[{"2", " ", "\[ImaginaryI]", " ", 
            SuperscriptBox["u", "3"], " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "50"}], "+", 
              RowBox[{"21", " ", 
               SuperscriptBox[
                StyleBox["Q0",
                 FontColor->RGBColor[{
                    Rational[1, 2], 
                    Rational[1, 2], 0}]], "+"]}]}], ")"}]}], "+", 
           RowBox[{
            SuperscriptBox["u", "4"], " ", 
            RowBox[{"(", 
             RowBox[{"61", "-", 
              RowBox[{"126", " ", 
               SuperscriptBox[
                StyleBox["Q0",
                 FontColor->RGBColor[{
                    Rational[1, 2], 
                    Rational[1, 2], 0}]], "+"]}], "-", 
              RowBox[{"135", " ", 
               SuperscriptBox[
                RowBox[{"(", 
                 SuperscriptBox[
                  StyleBox["Q0",
                   FontColor->RGBColor[{
                    Rational[1, 2], 
                    Rational[1, 2], 0}]], "+"], ")"}], "2"]}]}], ")"}]}], "-", 
           RowBox[{"9", " ", 
            SuperscriptBox["u", "2"], " ", 
            RowBox[{"(", 
             RowBox[{"5", "+", 
              RowBox[{"4", " ", 
               SuperscriptBox[
                StyleBox["Q0",
                 FontColor->RGBColor[{
                    Rational[1, 2], 
                    Rational[1, 2], 0}]], "+"]}], "+", 
              RowBox[{"5", " ", 
               SuperscriptBox[
                RowBox[{"(", 
                 SuperscriptBox[
                  StyleBox["Q0",
                   FontColor->RGBColor[{
                    Rational[1, 2], 
                    Rational[1, 2], 0}]], "+"], ")"}], "2"]}]}], ")"}]}], "-", 
           RowBox[{"2", " ", "\[ImaginaryI]", " ", "u", " ", 
            RowBox[{"(", 
             RowBox[{"5", "+", 
              RowBox[{"15", " ", 
               SuperscriptBox[
                StyleBox["Q0",
                 FontColor->RGBColor[{
                    Rational[1, 2], 
                    Rational[1, 2], 0}]], "+"]}], "+", 
              RowBox[{"18", " ", 
               SuperscriptBox[
                RowBox[{"(", 
                 SuperscriptBox[
                  StyleBox["Q0",
                   FontColor->RGBColor[{
                    Rational[1, 2], 
                    Rational[1, 2], 0}]], "+"], ")"}], "2"]}]}], ")"}]}], "-", 
           RowBox[{"8", " ", "\[ImaginaryI]", " ", 
            SuperscriptBox["u", "7"], " ", 
            RowBox[{"(", 
             RowBox[{"77", "+", 
              RowBox[{"45", " ", 
               SuperscriptBox[
                RowBox[{"(", 
                 SuperscriptBox[
                  StyleBox["Q0",
                   FontColor->RGBColor[{
                    Rational[1, 2], 
                    Rational[1, 2], 0}]], "+"], ")"}], "2"]}]}], ")"}]}], "-", 
           RowBox[{"2", " ", 
            SuperscriptBox["u", "8"], " ", 
            RowBox[{"(", 
             RowBox[{"212", "+", 
              RowBox[{"45", " ", 
               SuperscriptBox[
                RowBox[{"(", 
                 SuperscriptBox[
                  StyleBox["Q0",
                   FontColor->RGBColor[{
                    Rational[1, 2], 
                    Rational[1, 2], 0}]], "+"], ")"}], "2"]}]}], ")"}]}], "+", 
           RowBox[{"3", " ", 
            SuperscriptBox["u", "6"], " ", 
            RowBox[{"(", 
             RowBox[{"178", "+", 
              RowBox[{"8", " ", 
               SuperscriptBox[
                StyleBox["Q0",
                 FontColor->RGBColor[{
                    Rational[1, 2], 
                    Rational[1, 2], 0}]], "+"]}], "+", 
              RowBox[{"183", " ", 
               SuperscriptBox[
                RowBox[{"(", 
                 SuperscriptBox[
                  StyleBox["Q0",
                   FontColor->RGBColor[{
                    Rational[1, 2], 
                    Rational[1, 2], 0}]], "+"], ")"}], "2"]}]}], ")"}]}], "+", 
           RowBox[{"2", " ", "\[ImaginaryI]", " ", 
            SuperscriptBox["u", "5"], " ", 
            RowBox[{"(", 
             RowBox[{"101", "+", 
              RowBox[{"48", " ", 
               SuperscriptBox[
                StyleBox["Q0",
                 FontColor->RGBColor[{
                    Rational[1, 2], 
                    Rational[1, 2], 0}]], "+"]}], "+", 
              RowBox[{"198", " ", 
               SuperscriptBox[
                RowBox[{"(", 
                 SuperscriptBox[
                  StyleBox["Q0",
                   FontColor->RGBColor[{
                    Rational[1, 2], 
                    Rational[1, 2], 0}]], "+"], ")"}], "2"]}]}], ")"}]}]}], 
          ")"}], " ", 
         SubsuperscriptBox[
          StyleBox["W",
           FontColor->RGBColor[0.54, 0.35, 0.15]], 
          RowBox[{"1", ",", "lead"}], "+"]}]}], "-", 
       FractionBox[
        RowBox[{"16", " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"-", "1"}], "+", 
           RowBox[{"8", " ", "\[ImaginaryI]", " ", 
            SuperscriptBox["u", "3"]}], "+", 
           RowBox[{"4", " ", 
            SuperscriptBox["u", "4"]}], "+", 
           RowBox[{"6", " ", 
            SuperscriptBox[
             StyleBox["Q0",
              FontColor->RGBColor[{
                 Rational[1, 2], 
                 Rational[1, 2], 0}]], "+"]}], "-", 
           RowBox[{"3", " ", "\[ImaginaryI]", " ", "u", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "1"}], "+", 
              RowBox[{"4", " ", 
               SuperscriptBox[
                StyleBox["Q0",
                 FontColor->RGBColor[{
                    Rational[1, 2], 
                    Rational[1, 2], 0}]], "+"]}]}], ")"}]}], "-", 
           RowBox[{
            SuperscriptBox["u", "2"], " ", 
            RowBox[{"(", 
             RowBox[{"1", "+", 
              RowBox[{"6", " ", 
               SuperscriptBox[
                StyleBox["Q0",
                 FontColor->RGBColor[{
                    Rational[1, 2], 
                    Rational[1, 2], 0}]], "+"]}]}], ")"}]}]}], ")"}], " ", 
         SubsuperscriptBox[
          StyleBox["W",
           FontColor->RGBColor[0.54, 0.35, 0.15]], 
          RowBox[{"1", ",", "sublead"}], "+"]}], 
        RowBox[{"27", " ", 
         SuperscriptBox["u", "2"], " ", 
         RowBox[{"(", 
          RowBox[{"\[ImaginaryI]", "+", "u"}], ")"}], " ", 
         SuperscriptBox[
          RowBox[{"(", 
           SuperscriptBox[
            StyleBox["Q0",
             FontColor->RGBColor[{
                Rational[1, 2], 
                Rational[1, 2], 0}]], "+"], ")"}], "2"]}]], "-", 
       FractionBox[
        RowBox[{"16", " ", 
         RowBox[{"(", 
          RowBox[{"\[ImaginaryI]", "+", "u"}], ")"}], " ", 
         SubsuperscriptBox[
          StyleBox["W",
           FontColor->RGBColor[0.54, 0.35, 0.15]], 
          RowBox[{"1", ",", "sublead2"}], "+"]}], 
        RowBox[{"9", " ", 
         SuperscriptBox[
          StyleBox["Q0",
           FontColor->RGBColor[{
              Rational[1, 2], 
              Rational[1, 2], 0}]], "+"]}]]}], "]"}], "+", 
     RowBox[{"\[DoubleStruckCapitalC]", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"(", 
         RowBox[{"8", " ", "\[ImaginaryI]", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"156492", " ", 
             SuperscriptBox["u", "22"]}], "+", 
            RowBox[{"30618", " ", 
             SuperscriptBox["u", "24"]}], "+", 
            RowBox[{"2187", " ", 
             SuperscriptBox[
              RowBox[{"(", 
               SuperscriptBox[
                StyleBox["Q0",
                 FontColor->RGBColor[{
                    Rational[1, 2], 
                    Rational[1, 2], 0}]], "-"], ")"}], "3"], " ", 
             SuperscriptBox[
              RowBox[{"(", 
               SuperscriptBox[
                StyleBox["Q0",
                 FontColor->RGBColor[{
                    Rational[1, 2], 
                    Rational[1, 2], 0}]], "+"], ")"}], "3"]}], "+", 
            RowBox[{"20412", " ", 
             SuperscriptBox["u", "2"], " ", 
             SuperscriptBox[
              RowBox[{"(", 
               SuperscriptBox[
                StyleBox["Q0",
                 FontColor->RGBColor[{
                    Rational[1, 2], 
                    Rational[1, 2], 0}]], "-"], ")"}], "3"], " ", 
             SuperscriptBox[
              RowBox[{"(", 
               SuperscriptBox[
                StyleBox["Q0",
                 FontColor->RGBColor[{
                    Rational[1, 2], 
                    Rational[1, 2], 0}]], "+"], ")"}], "3"]}], "+", 
            RowBox[{"54", " ", 
             SuperscriptBox["u", "20"], " ", 
             RowBox[{"(", 
              RowBox[{"6149", "+", 
               RowBox[{"54", " ", 
                SuperscriptBox[
                 StyleBox["Q0",
                  FontColor->RGBColor[{
                    Rational[1, 2], 
                    Rational[1, 2], 0}]], "-"], " ", 
                SuperscriptBox[
                 StyleBox["Q0",
                  FontColor->RGBColor[{
                    Rational[1, 2], 
                    Rational[1, 2], 0}]], "+"]}]}], ")"}]}], "-", 
            RowBox[{"108", " ", 
             SuperscriptBox["u", "18"], " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"-", "3541"}], "+", 
               RowBox[{"144", " ", 
                SuperscriptBox[
                 StyleBox["Q0",
                  FontColor->RGBColor[{
                    Rational[1, 2], 
                    Rational[1, 2], 0}]], "-"], " ", 
                SuperscriptBox[
                 StyleBox["Q0",
                  FontColor->RGBColor[{
                    Rational[1, 2], 
                    Rational[1, 2], 0}]], "+"]}]}], ")"}]}], "+", 
            RowBox[{"36", " ", 
             SuperscriptBox["u", "16"], " ", 
             RowBox[{"(", 
              RowBox[{"7109", "-", 
               RowBox[{"3645", " ", 
                SuperscriptBox[
                 StyleBox["Q0",
                  FontColor->RGBColor[{
                    Rational[1, 2], 
                    Rational[1, 2], 0}]], "-"], " ", 
                SuperscriptBox[
                 StyleBox["Q0",
                  FontColor->RGBColor[{
                    Rational[1, 2], 
                    Rational[1, 2], 0}]], "+"]}], "+", 
               RowBox[{"756", " ", 
                SuperscriptBox[
                 RowBox[{"(", 
                  SuperscriptBox[
                   StyleBox["Q0",
                    FontColor->RGBColor[{
                    Rational[1, 2], 
                    Rational[1, 2], 0}]], "-"], ")"}], "2"], " ", 
                SuperscriptBox[
                 RowBox[{"(", 
                  SuperscriptBox[
                   StyleBox["Q0",
                    FontColor->RGBColor[{
                    Rational[1, 2], 
                    Rational[1, 2], 0}]], "+"], ")"}], "2"]}]}], ")"}]}], "+", 
            RowBox[{"2", " ", 
             SuperscriptBox["u", "14"], " ", 
             RowBox[{"(", 
              RowBox[{"56590", "-", 
               RowBox[{"152118", " ", 
                SuperscriptBox[
                 StyleBox["Q0",
                  FontColor->RGBColor[{
                    Rational[1, 2], 
                    Rational[1, 2], 0}]], "-"], " ", 
                SuperscriptBox[
                 StyleBox["Q0",
                  FontColor->RGBColor[{
                    Rational[1, 2], 
                    Rational[1, 2], 0}]], "+"]}], "+", 
               RowBox[{"71037", " ", 
                SuperscriptBox[
                 RowBox[{"(", 
                  SuperscriptBox[
                   StyleBox["Q0",
                    FontColor->RGBColor[{
                    Rational[1, 2], 
                    Rational[1, 2], 0}]], "-"], ")"}], "2"], " ", 
                SuperscriptBox[
                 RowBox[{"(", 
                  SuperscriptBox[
                   StyleBox["Q0",
                    FontColor->RGBColor[{
                    Rational[1, 2], 
                    Rational[1, 2], 0}]], "+"], ")"}], "2"]}]}], ")"}]}], "+", 
            RowBox[{
             SuperscriptBox["u", "8"], " ", 
             RowBox[{"(", 
              RowBox[{"15598", "-", 
               RowBox[{"25344", " ", 
                SuperscriptBox[
                 StyleBox["Q0",
                  FontColor->RGBColor[{
                    Rational[1, 2], 
                    Rational[1, 2], 0}]], "-"], " ", 
                SuperscriptBox[
                 StyleBox["Q0",
                  FontColor->RGBColor[{
                    Rational[1, 2], 
                    Rational[1, 2], 0}]], "+"]}], "+", 
               RowBox[{"215946", " ", 
                SuperscriptBox[
                 RowBox[{"(", 
                  SuperscriptBox[
                   StyleBox["Q0",
                    FontColor->RGBColor[{
                    Rational[1, 2], 
                    Rational[1, 2], 0}]], "-"], ")"}], "2"], " ", 
                SuperscriptBox[
                 RowBox[{"(", 
                  SuperscriptBox[
                   StyleBox["Q0",
                    FontColor->RGBColor[{
                    Rational[1, 2], 
                    Rational[1, 2], 0}]], "+"], ")"}], "2"]}], "-", 
               RowBox[{"284310", " ", 
                SuperscriptBox[
                 RowBox[{"(", 
                  SuperscriptBox[
                   StyleBox["Q0",
                    FontColor->RGBColor[{
                    Rational[1, 2], 
                    Rational[1, 2], 0}]], "-"], ")"}], "3"], " ", 
                SuperscriptBox[
                 RowBox[{"(", 
                  SuperscriptBox[
                   StyleBox["Q0",
                    FontColor->RGBColor[{
                    Rational[1, 2], 
                    Rational[1, 2], 0}]], "+"], ")"}], "3"]}]}], ")"}]}], "+", 
            RowBox[{
             SuperscriptBox["u", "10"], " ", 
             RowBox[{"(", 
              RowBox[{"36748", "-", 
               RowBox[{"142812", " ", 
                SuperscriptBox[
                 StyleBox["Q0",
                  FontColor->RGBColor[{
                    Rational[1, 2], 
                    Rational[1, 2], 0}]], "-"], " ", 
                SuperscriptBox[
                 StyleBox["Q0",
                  FontColor->RGBColor[{
                    Rational[1, 2], 
                    Rational[1, 2], 0}]], "+"]}], "+", 
               RowBox[{"347814", " ", 
                SuperscriptBox[
                 RowBox[{"(", 
                  SuperscriptBox[
                   StyleBox["Q0",
                    FontColor->RGBColor[{
                    Rational[1, 2], 
                    Rational[1, 2], 0}]], "-"], ")"}], "2"], " ", 
                SuperscriptBox[
                 RowBox[{"(", 
                  SuperscriptBox[
                   StyleBox["Q0",
                    FontColor->RGBColor[{
                    Rational[1, 2], 
                    Rational[1, 2], 0}]], "+"], ")"}], "2"]}], "-", 
               RowBox[{"233280", " ", 
                SuperscriptBox[
                 RowBox[{"(", 
                  SuperscriptBox[
                   StyleBox["Q0",
                    FontColor->RGBColor[{
                    Rational[1, 2], 
                    Rational[1, 2], 0}]], "-"], ")"}], "3"], " ", 
                SuperscriptBox[
                 RowBox[{"(", 
                  SuperscriptBox[
                   StyleBox["Q0",
                    FontColor->RGBColor[{
                    Rational[1, 2], 
                    Rational[1, 2], 0}]], "+"], ")"}], "3"]}]}], ")"}]}], "+", 
            RowBox[{
             SuperscriptBox["u", "6"], " ", 
             RowBox[{"(", 
              RowBox[{"2976", "+", 
               RowBox[{"3672", " ", 
                SuperscriptBox[
                 StyleBox["Q0",
                  FontColor->RGBColor[{
                    Rational[1, 2], 
                    Rational[1, 2], 0}]], "-"], " ", 
                SuperscriptBox[
                 StyleBox["Q0",
                  FontColor->RGBColor[{
                    Rational[1, 2], 
                    Rational[1, 2], 0}]], "+"]}], "+", 
               RowBox[{"64152", " ", 
                SuperscriptBox[
                 RowBox[{"(", 
                  SuperscriptBox[
                   StyleBox["Q0",
                    FontColor->RGBColor[{
                    Rational[1, 2], 
                    Rational[1, 2], 0}]], "-"], ")"}], "2"], " ", 
                SuperscriptBox[
                 RowBox[{"(", 
                  SuperscriptBox[
                   StyleBox["Q0",
                    FontColor->RGBColor[{
                    Rational[1, 2], 
                    Rational[1, 2], 0}]], "+"], ")"}], "2"]}], "-", 
               RowBox[{"88938", " ", 
                SuperscriptBox[
                 RowBox[{"(", 
                  SuperscriptBox[
                   StyleBox["Q0",
                    FontColor->RGBColor[{
                    Rational[1, 2], 
                    Rational[1, 2], 0}]], "-"], ")"}], "3"], " ", 
                SuperscriptBox[
                 RowBox[{"(", 
                  SuperscriptBox[
                   StyleBox["Q0",
                    FontColor->RGBColor[{
                    Rational[1, 2], 
                    Rational[1, 2], 0}]], "+"], ")"}], "3"]}]}], ")"}]}], "+", 
            RowBox[{
             SuperscriptBox["u", "12"], " ", 
             RowBox[{"(", 
              RowBox[{"57442", "-", 
               RowBox[{"306504", " ", 
                SuperscriptBox[
                 StyleBox["Q0",
                  FontColor->RGBColor[{
                    Rational[1, 2], 
                    Rational[1, 2], 0}]], "-"], " ", 
                SuperscriptBox[
                 StyleBox["Q0",
                  FontColor->RGBColor[{
                    Rational[1, 2], 
                    Rational[1, 2], 0}]], "+"]}], "+", 
               RowBox[{"303426", " ", 
                SuperscriptBox[
                 RowBox[{"(", 
                  SuperscriptBox[
                   StyleBox["Q0",
                    FontColor->RGBColor[{
                    Rational[1, 2], 
                    Rational[1, 2], 0}]], "-"], ")"}], "2"], " ", 
                SuperscriptBox[
                 RowBox[{"(", 
                  SuperscriptBox[
                   StyleBox["Q0",
                    FontColor->RGBColor[{
                    Rational[1, 2], 
                    Rational[1, 2], 0}]], "+"], ")"}], "2"]}], "-", 
               RowBox[{"58320", " ", 
                SuperscriptBox[
                 RowBox[{"(", 
                  SuperscriptBox[
                   StyleBox["Q0",
                    FontColor->RGBColor[{
                    Rational[1, 2], 
                    Rational[1, 2], 0}]], "-"], ")"}], "3"], " ", 
                SuperscriptBox[
                 RowBox[{"(", 
                  SuperscriptBox[
                   StyleBox["Q0",
                    FontColor->RGBColor[{
                    Rational[1, 2], 
                    Rational[1, 2], 0}]], "+"], ")"}], "3"]}]}], ")"}]}], "+", 
            RowBox[{
             SuperscriptBox["u", "4"], " ", 
             RowBox[{"(", 
              RowBox[{"196", "+", 
               RowBox[{"1224", " ", 
                SuperscriptBox[
                 StyleBox["Q0",
                  FontColor->RGBColor[{
                    Rational[1, 2], 
                    Rational[1, 2], 0}]], "-"], " ", 
                SuperscriptBox[
                 StyleBox["Q0",
                  FontColor->RGBColor[{
                    Rational[1, 2], 
                    Rational[1, 2], 0}]], "+"]}], "+", 
               RowBox[{"7452", " ", 
                SuperscriptBox[
                 RowBox[{"(", 
                  SuperscriptBox[
                   StyleBox["Q0",
                    FontColor->RGBColor[{
                    Rational[1, 2], 
                    Rational[1, 2], 0}]], "-"], ")"}], "2"], " ", 
                SuperscriptBox[
                 RowBox[{"(", 
                  SuperscriptBox[
                   StyleBox["Q0",
                    FontColor->RGBColor[{
                    Rational[1, 2], 
                    Rational[1, 2], 0}]], "+"], ")"}], "2"]}], "+", 
               RowBox[{"26973", " ", 
                SuperscriptBox[
                 RowBox[{"(", 
                  SuperscriptBox[
                   StyleBox["Q0",
                    FontColor->RGBColor[{
                    Rational[1, 2], 
                    Rational[1, 2], 0}]], "-"], ")"}], "3"], " ", 
                SuperscriptBox[
                 RowBox[{"(", 
                  SuperscriptBox[
                   StyleBox["Q0",
                    FontColor->RGBColor[{
                    Rational[1, 2], 
                    Rational[1, 2], 0}]], "+"], ")"}], "3"]}]}], ")"}]}]}], 
           ")"}], " ", 
          SubscriptBox[
           OverscriptBox[
            StyleBox["W",
             FontColor->RGBColor[0.54, 0.35, 0.15]], 
            StyleBox["^",
             FontColor->RGBColor[0.54, 0.35, 0.15]]], "lead"]}], ")"}], "/", 
        RowBox[{"(", 
         RowBox[{"2187", " ", 
          SuperscriptBox["u", "4"], " ", 
          SuperscriptBox[
           RowBox[{"(", 
            RowBox[{"1", "+", 
             SuperscriptBox["u", "2"]}], ")"}], "5"], " ", 
          SuperscriptBox[
           RowBox[{"(", 
            SuperscriptBox[
             StyleBox["Q0",
              FontColor->RGBColor[{
                 Rational[1, 2], 
                 Rational[1, 2], 0}]], "-"], ")"}], "3"], " ", 
          SuperscriptBox[
           RowBox[{"(", 
            SuperscriptBox[
             StyleBox["Q0",
              FontColor->RGBColor[{
                 Rational[1, 2], 
                 Rational[1, 2], 0}]], "+"], ")"}], "3"]}], ")"}]}], "-", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{"16", " ", "\[ImaginaryI]", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"1845", " ", 
             SuperscriptBox["u", "12"]}], "+", 
            RowBox[{"486", " ", 
             SuperscriptBox["u", "14"]}], "-", 
            RowBox[{"243", " ", 
             SuperscriptBox[
              RowBox[{"(", 
               SuperscriptBox[
                StyleBox["Q0",
                 FontColor->RGBColor[{
                    Rational[1, 2], 
                    Rational[1, 2], 0}]], "-"], ")"}], "2"], " ", 
             SuperscriptBox[
              RowBox[{"(", 
               SuperscriptBox[
                StyleBox["Q0",
                 FontColor->RGBColor[{
                    Rational[1, 2], 
                    Rational[1, 2], 0}]], "+"], ")"}], "2"]}], "+", 
            RowBox[{"6", " ", 
             SuperscriptBox["u", "10"], " ", 
             RowBox[{"(", 
              RowBox[{"455", "+", 
               RowBox[{"54", " ", 
                SuperscriptBox[
                 StyleBox["Q0",
                  FontColor->RGBColor[{
                    Rational[1, 2], 
                    Rational[1, 2], 0}]], "-"], " ", 
                SuperscriptBox[
                 StyleBox["Q0",
                  FontColor->RGBColor[{
                    Rational[1, 2], 
                    Rational[1, 2], 0}]], "+"]}]}], ")"}]}], "+", 
            RowBox[{
             SuperscriptBox["u", "8"], " ", 
             RowBox[{"(", 
              RowBox[{"2119", "+", 
               RowBox[{"1242", " ", 
                SuperscriptBox[
                 StyleBox["Q0",
                  FontColor->RGBColor[{
                    Rational[1, 2], 
                    Rational[1, 2], 0}]], "-"], " ", 
                SuperscriptBox[
                 StyleBox["Q0",
                  FontColor->RGBColor[{
                    Rational[1, 2], 
                    Rational[1, 2], 0}]], "+"]}]}], ")"}]}], "+", 
            RowBox[{
             SuperscriptBox["u", "4"], " ", 
             RowBox[{"(", 
              RowBox[{"178", "+", 
               RowBox[{"558", " ", 
                SuperscriptBox[
                 StyleBox["Q0",
                  FontColor->RGBColor[{
                    Rational[1, 2], 
                    Rational[1, 2], 0}]], "-"], " ", 
                SuperscriptBox[
                 StyleBox["Q0",
                  FontColor->RGBColor[{
                    Rational[1, 2], 
                    Rational[1, 2], 0}]], "+"]}], "-", 
               RowBox[{"2106", " ", 
                SuperscriptBox[
                 RowBox[{"(", 
                  SuperscriptBox[
                   StyleBox["Q0",
                    FontColor->RGBColor[{
                    Rational[1, 2], 
                    Rational[1, 2], 0}]], "-"], ")"}], "2"], " ", 
                SuperscriptBox[
                 RowBox[{"(", 
                  SuperscriptBox[
                   StyleBox["Q0",
                    FontColor->RGBColor[{
                    Rational[1, 2], 
                    Rational[1, 2], 0}]], "+"], ")"}], "2"]}]}], ")"}]}], "+", 
            RowBox[{
             SuperscriptBox["u", "2"], " ", 
             RowBox[{"(", 
              RowBox[{"13", "+", 
               RowBox[{"108", " ", 
                SuperscriptBox[
                 StyleBox["Q0",
                  FontColor->RGBColor[{
                    Rational[1, 2], 
                    Rational[1, 2], 0}]], "-"], " ", 
                SuperscriptBox[
                 StyleBox["Q0",
                  FontColor->RGBColor[{
                    Rational[1, 2], 
                    Rational[1, 2], 0}]], "+"]}], "-", 
               RowBox[{"1863", " ", 
                SuperscriptBox[
                 RowBox[{"(", 
                  SuperscriptBox[
                   StyleBox["Q0",
                    FontColor->RGBColor[{
                    Rational[1, 2], 
                    Rational[1, 2], 0}]], "-"], ")"}], "2"], " ", 
                SuperscriptBox[
                 RowBox[{"(", 
                  SuperscriptBox[
                   StyleBox["Q0",
                    FontColor->RGBColor[{
                    Rational[1, 2], 
                    Rational[1, 2], 0}]], "+"], ")"}], "2"]}]}], ")"}]}], "+", 
            RowBox[{
             SuperscriptBox["u", "6"], " ", 
             RowBox[{"(", 
              RowBox[{"913", "+", 
               RowBox[{"1368", " ", 
                SuperscriptBox[
                 StyleBox["Q0",
                  FontColor->RGBColor[{
                    Rational[1, 2], 
                    Rational[1, 2], 0}]], "-"], " ", 
                SuperscriptBox[
                 StyleBox["Q0",
                  FontColor->RGBColor[{
                    Rational[1, 2], 
                    Rational[1, 2], 0}]], "+"]}], "-", 
               RowBox[{"810", " ", 
                SuperscriptBox[
                 RowBox[{"(", 
                  SuperscriptBox[
                   StyleBox["Q0",
                    FontColor->RGBColor[{
                    Rational[1, 2], 
                    Rational[1, 2], 0}]], "-"], ")"}], "2"], " ", 
                SuperscriptBox[
                 RowBox[{"(", 
                  SuperscriptBox[
                   StyleBox["Q0",
                    FontColor->RGBColor[{
                    Rational[1, 2], 
                    Rational[1, 2], 0}]], "+"], ")"}], "2"]}]}], ")"}]}]}], 
           ")"}], " ", 
          SubscriptBox[
           OverscriptBox[
            StyleBox["W",
             FontColor->RGBColor[0.54, 0.35, 0.15]], 
            StyleBox["^",
             FontColor->RGBColor[0.54, 0.35, 0.15]]], "sublead"]}], ")"}], 
        "/", 
        RowBox[{"(", 
         RowBox[{"243", " ", 
          SuperscriptBox["u", "2"], " ", 
          SuperscriptBox[
           RowBox[{"(", 
            RowBox[{"1", "+", 
             SuperscriptBox["u", "2"]}], ")"}], "3"], " ", 
          SuperscriptBox[
           RowBox[{"(", 
            SuperscriptBox[
             StyleBox["Q0",
              FontColor->RGBColor[{
                 Rational[1, 2], 
                 Rational[1, 2], 0}]], "-"], ")"}], "2"], " ", 
          SuperscriptBox[
           RowBox[{"(", 
            SuperscriptBox[
             StyleBox["Q0",
              FontColor->RGBColor[{
                 Rational[1, 2], 
                 Rational[1, 2], 0}]], "+"], ")"}], "2"]}], ")"}]}], "-", 
       FractionBox[
        RowBox[{"8", " ", "\[ImaginaryI]", " ", 
         RowBox[{"(", 
          RowBox[{"2", "+", 
           RowBox[{"48", " ", 
            SuperscriptBox["u", "4"]}], "+", 
           RowBox[{"90", " ", 
            SuperscriptBox["u", "6"]}], "+", 
           RowBox[{"54", " ", 
            SuperscriptBox["u", "8"]}], "+", 
           RowBox[{"18", " ", 
            SuperscriptBox[
             StyleBox["Q0",
              FontColor->RGBColor[{
                 Rational[1, 2], 
                 Rational[1, 2], 0}]], "-"], " ", 
            SuperscriptBox[
             StyleBox["Q0",
              FontColor->RGBColor[{
                 Rational[1, 2], 
                 Rational[1, 2], 0}]], "+"]}], "-", 
           RowBox[{"81", " ", 
            SuperscriptBox[
             RowBox[{"(", 
              SuperscriptBox[
               StyleBox["Q0",
                FontColor->RGBColor[{
                   Rational[1, 2], 
                   Rational[1, 2], 0}]], "-"], ")"}], "2"], " ", 
            SuperscriptBox[
             RowBox[{"(", 
              SuperscriptBox[
               StyleBox["Q0",
                FontColor->RGBColor[{
                   Rational[1, 2], 
                   Rational[1, 2], 0}]], "+"], ")"}], "2"]}], "+", 
           RowBox[{"2", " ", 
            SuperscriptBox["u", "2"], " ", 
            RowBox[{"(", 
             RowBox[{"7", "+", 
              RowBox[{"9", " ", 
               SuperscriptBox[
                StyleBox["Q0",
                 FontColor->RGBColor[{
                    Rational[1, 2], 
                    Rational[1, 2], 0}]], "-"], " ", 
               SuperscriptBox[
                StyleBox["Q0",
                 FontColor->RGBColor[{
                    Rational[1, 2], 
                    Rational[1, 2], 0}]], "+"]}]}], ")"}]}]}], ")"}], " ", 
         SubscriptBox[
          OverscriptBox[
           StyleBox["W",
            FontColor->RGBColor[0.54, 0.35, 0.15]], 
           StyleBox["^",
            FontColor->RGBColor[0.54, 0.35, 0.15]]], "sublead2"]}], 
        RowBox[{"243", " ", 
         RowBox[{"(", 
          RowBox[{"1", "+", 
           SuperscriptBox["u", "2"]}], ")"}], " ", 
         SuperscriptBox[
          RowBox[{"(", 
           SuperscriptBox[
            StyleBox["Q0",
             FontColor->RGBColor[{
                Rational[1, 2], 
                Rational[1, 2], 0}]], "-"], ")"}], "2"], " ", 
         SuperscriptBox[
          RowBox[{"(", 
           SuperscriptBox[
            StyleBox["Q0",
             FontColor->RGBColor[{
                Rational[1, 2], 
                Rational[1, 2], 0}]], "+"], ")"}], "2"]}]]}], "]"}], "+", 
     RowBox[{
      FractionBox["848", "9"], " ", 
      SubscriptBox[
       StyleBox["W",
        FontColor->RGBColor[0.54, 0.35, 0.15]], 
       RowBox[{"1", ",", "v0", ",", "lead"}]]}], "-", 
     RowBox[{
      FractionBox["32", "3"], " ", 
      SubscriptBox[
       StyleBox["W",
        FontColor->RGBColor[0.54, 0.35, 0.15]], 
       RowBox[{"1", ",", "v0", ",", "sublead"}]]}], "-", 
     RowBox[{
      FractionBox["16", "9"], " ", 
      SubscriptBox[
       StyleBox["W",
        FontColor->RGBColor[0.54, 0.35, 0.15]], 
       RowBox[{"1", ",", "v0", ",", "sublead2"}]]}], "+", 
     RowBox[{"135600", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2"]}], "-", 
     RowBox[{"113856", " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2", "2"]}], "-", 
     FractionBox[
      RowBox[{"277184", " ", 
       SubsuperscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "2", "3"]}], "35"], "+", 
     FractionBox[
      RowBox[{"1561472", " ", 
       SubsuperscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "2", "4"]}], "175"], "-", 
     FractionBox[
      RowBox[{"128256", " ", 
       SubsuperscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "2", "5"]}], "175"], "+", 
     RowBox[{"122544", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3"]}], "-", 
     RowBox[{"11520", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3"]}], "+", 
     RowBox[{
      FractionBox["251456", "5"], " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2", "2"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3"]}], "+", 
     RowBox[{
      FractionBox["9216", "7"], " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2", "3"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3"]}], "+", 
     RowBox[{
      FractionBox["20736", "25"], " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2", "4"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3"]}], "-", 
     RowBox[{"80512", " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3", "2"]}], "-", 
     RowBox[{"22272", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2"], " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3", "2"]}], "+", 
     RowBox[{"3456", " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3", "3"]}], "-", 
     RowBox[{"119472", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "5"]}], "+", 
     RowBox[{"17504", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "5"]}], "+", 
     RowBox[{
      FractionBox["704", "5"], " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2", "2"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "5"]}], "-", 
     RowBox[{
      FractionBox["1024", "35"], " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2", "3"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "5"]}], "+", 
     RowBox[{"44160", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "5"]}], "+", 
     RowBox[{"1920", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "5"]}], "+", 
     RowBox[{"352", " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "5", "2"]}], "+", 
     RowBox[{"72960", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "7"]}], "-", 
     RowBox[{"34112", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "7"]}], "-", 
     RowBox[{
      FractionBox["6912", "5"], " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2", "2"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "7"]}], "-", 
     RowBox[{"5824", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "7"]}]}]}], ",", 
   RowBox[{
    RowBox[{
     SubscriptBox["\[Beta]", "sublead2"], "[", "1", "]"}], "\[Rule]", 
    RowBox[{
     RowBox[{"-", "3456"}], "+", 
     RowBox[{"\[DoubleStruckCapitalC]", "[", 
      RowBox[{
       FractionBox[
        RowBox[{"8", " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"2", " ", "\[ImaginaryI]"}], "+", 
           RowBox[{"2", " ", "\[ImaginaryI]", " ", 
            SuperscriptBox["u", "2"]}], "+", 
           RowBox[{"15", " ", 
            SuperscriptBox["u", "3"]}], "+", 
           RowBox[{"2", " ", "\[ImaginaryI]", " ", 
            SuperscriptBox["u", "4"]}], "+", 
           RowBox[{"50", " ", 
            SuperscriptBox["u", "5"]}]}], ")"}], " ", 
         SubscriptBox[
          StyleBox["H",
           FontColor->RGBColor[0.54, 0.35, 0.15]], "lead"]}], 
        RowBox[{"3", " ", 
         SuperscriptBox["u", "6"]}]], "-", 
       FractionBox[
        RowBox[{"8", " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"-", "\[ImaginaryI]"}], "+", 
           RowBox[{"2", " ", "u"}], "+", 
           RowBox[{"3", " ", 
            SuperscriptBox["u", "3"]}]}], ")"}], " ", 
         SubscriptBox[
          StyleBox["H",
           FontColor->RGBColor[0.54, 0.35, 0.15]], "sublead"]}], 
        RowBox[{"3", " ", 
         SuperscriptBox["u", "4"]}]]}], "]"}], "+", 
     RowBox[{"\[DoubleStruckCapitalC]", "[", 
      RowBox[{
       RowBox[{
        FractionBox["1", 
         RowBox[{"9", " ", 
          SuperscriptBox["u", "4"], " ", 
          RowBox[{"(", 
           RowBox[{"\[ImaginaryI]", "+", "u"}], ")"}], " ", 
          SuperscriptBox[
           RowBox[{"(", 
            SuperscriptBox[
             StyleBox["Q0",
              FontColor->RGBColor[{
                 Rational[1, 2], 
                 Rational[1, 2], 0}]], "+"], ")"}], "2"]}]], 
        RowBox[{"16", " ", 
         RowBox[{"(", 
          RowBox[{"2", "-", 
           RowBox[{"6", " ", "\[ImaginaryI]", " ", "u"}], "+", 
           RowBox[{
            SuperscriptBox["u", "2"], " ", 
            RowBox[{"(", 
             RowBox[{"5", "-", 
              RowBox[{"45", " ", 
               SuperscriptBox[
                StyleBox["Q0",
                 FontColor->RGBColor[{
                    Rational[1, 2], 
                    Rational[1, 2], 0}]], "+"]}]}], ")"}]}], "+", 
           RowBox[{"5", " ", "\[ImaginaryI]", " ", 
            SuperscriptBox["u", "3"], " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "5"}], "+", 
              RowBox[{"18", " ", 
               SuperscriptBox[
                StyleBox["Q0",
                 FontColor->RGBColor[{
                    Rational[1, 2], 
                    Rational[1, 2], 0}]], "+"]}]}], ")"}]}], "-", 
           RowBox[{"5", " ", 
            SuperscriptBox["u", "4"], " ", 
            RowBox[{"(", 
             RowBox[{"1", "+", 
              RowBox[{"21", " ", 
               SuperscriptBox[
                StyleBox["Q0",
                 FontColor->RGBColor[{
                    Rational[1, 2], 
                    Rational[1, 2], 0}]], "+"]}]}], ")"}]}], "+", 
           RowBox[{"12", " ", "\[ImaginaryI]", " ", 
            SuperscriptBox["u", "5"], " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "2"}], "+", 
              RowBox[{"25", " ", 
               SuperscriptBox[
                StyleBox["Q0",
                 FontColor->RGBColor[{
                    Rational[1, 2], 
                    Rational[1, 2], 0}]], "+"]}]}], ")"}]}], "+", 
           RowBox[{"6", " ", 
            SuperscriptBox["u", "6"], " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "2"}], "+", 
              RowBox[{"25", " ", 
               SuperscriptBox[
                StyleBox["Q0",
                 FontColor->RGBColor[{
                    Rational[1, 2], 
                    Rational[1, 2], 0}]], "+"]}]}], ")"}]}]}], ")"}], " ", 
         SubsuperscriptBox[
          StyleBox["W",
           FontColor->RGBColor[0.54, 0.35, 0.15]], 
          RowBox[{"1", ",", "lead"}], "+"]}]}], "-", 
       FractionBox[
        RowBox[{"16", " ", 
         RowBox[{"(", 
          RowBox[{"\[ImaginaryI]", "+", "u"}], ")"}], " ", 
         RowBox[{"(", 
          RowBox[{"2", "+", 
           RowBox[{"3", " ", 
            SuperscriptBox["u", "2"]}]}], ")"}], " ", 
         SubsuperscriptBox[
          StyleBox["W",
           FontColor->RGBColor[0.54, 0.35, 0.15]], 
          RowBox[{"1", ",", "sublead"}], "+"]}], 
        RowBox[{"3", " ", 
         SuperscriptBox["u", "2"], " ", 
         SuperscriptBox[
          StyleBox["Q0",
           FontColor->RGBColor[{
              Rational[1, 2], 
              Rational[1, 2], 0}]], "+"]}]]}], "]"}], "+", 
     RowBox[{"\[DoubleStruckCapitalC]", "[", 
      RowBox[{
       RowBox[{"-", 
        RowBox[{
         FractionBox["1", 
          RowBox[{"81", " ", 
           SuperscriptBox[
            RowBox[{"(", 
             RowBox[{"1", "+", 
              SuperscriptBox["u", "2"]}], ")"}], "4"], " ", 
           SuperscriptBox[
            RowBox[{"(", 
             SuperscriptBox[
              StyleBox["Q0",
               FontColor->RGBColor[{
                  Rational[1, 2], 
                  Rational[1, 2], 0}]], "-"], ")"}], "2"], " ", 
           SuperscriptBox[
            RowBox[{"(", 
             SuperscriptBox[
              StyleBox["Q0",
               FontColor->RGBColor[{
                  Rational[1, 2], 
                  Rational[1, 2], 0}]], "+"], ")"}], "2"]}]], 
         RowBox[{"16", " ", "\[ImaginaryI]", " ", 
          RowBox[{"(", 
           RowBox[{"41", "+", 
            RowBox[{"4995", " ", 
             SuperscriptBox["u", "12"]}], "+", 
            RowBox[{"1134", " ", 
             SuperscriptBox["u", "14"]}], "-", 
            RowBox[{"387", " ", 
             SuperscriptBox[
              StyleBox["Q0",
               FontColor->RGBColor[{
                  Rational[1, 2], 
                  Rational[1, 2], 0}]], "-"], " ", 
             SuperscriptBox[
              StyleBox["Q0",
               FontColor->RGBColor[{
                  Rational[1, 2], 
                  Rational[1, 2], 0}]], "+"]}], "-", 
            RowBox[{"405", " ", 
             SuperscriptBox[
              RowBox[{"(", 
               SuperscriptBox[
                StyleBox["Q0",
                 FontColor->RGBColor[{
                    Rational[1, 2], 
                    Rational[1, 2], 0}]], "-"], ")"}], "2"], " ", 
             SuperscriptBox[
              RowBox[{"(", 
               SuperscriptBox[
                StyleBox["Q0",
                 FontColor->RGBColor[{
                    Rational[1, 2], 
                    Rational[1, 2], 0}]], "+"], ")"}], "2"]}], "+", 
            RowBox[{"9", " ", 
             SuperscriptBox["u", "10"], " ", 
             RowBox[{"(", 
              RowBox[{"941", "+", 
               RowBox[{"21", " ", 
                SuperscriptBox[
                 StyleBox["Q0",
                  FontColor->RGBColor[{
                    Rational[1, 2], 
                    Rational[1, 2], 0}]], "-"], " ", 
                SuperscriptBox[
                 StyleBox["Q0",
                  FontColor->RGBColor[{
                    Rational[1, 2], 
                    Rational[1, 2], 0}]], "+"]}]}], ")"}]}], "+", 
            RowBox[{"9", " ", 
             SuperscriptBox["u", "8"], " ", 
             RowBox[{"(", 
              RowBox[{"875", "+", 
               RowBox[{"176", " ", 
                SuperscriptBox[
                 StyleBox["Q0",
                  FontColor->RGBColor[{
                    Rational[1, 2], 
                    Rational[1, 2], 0}]], "-"], " ", 
                SuperscriptBox[
                 StyleBox["Q0",
                  FontColor->RGBColor[{
                    Rational[1, 2], 
                    Rational[1, 2], 0}]], "+"]}]}], ")"}]}], "+", 
            RowBox[{
             SuperscriptBox["u", "4"], " ", 
             RowBox[{"(", 
              RowBox[{"2449", "-", 
               RowBox[{"1701", " ", 
                SuperscriptBox[
                 StyleBox["Q0",
                  FontColor->RGBColor[{
                    Rational[1, 2], 
                    Rational[1, 2], 0}]], "-"], " ", 
                SuperscriptBox[
                 StyleBox["Q0",
                  FontColor->RGBColor[{
                    Rational[1, 2], 
                    Rational[1, 2], 0}]], "+"]}], "-", 
               RowBox[{"2673", " ", 
                SuperscriptBox[
                 RowBox[{"(", 
                  SuperscriptBox[
                   StyleBox["Q0",
                    FontColor->RGBColor[{
                    Rational[1, 2], 
                    Rational[1, 2], 0}]], "-"], ")"}], "2"], " ", 
                SuperscriptBox[
                 RowBox[{"(", 
                  SuperscriptBox[
                   StyleBox["Q0",
                    FontColor->RGBColor[{
                    Rational[1, 2], 
                    Rational[1, 2], 0}]], "+"], ")"}], "2"]}]}], ")"}]}], "+", 
            RowBox[{
             SuperscriptBox["u", "2"], " ", 
             RowBox[{"(", 
              RowBox[{"481", "-", 
               RowBox[{"2034", " ", 
                SuperscriptBox[
                 StyleBox["Q0",
                  FontColor->RGBColor[{
                    Rational[1, 2], 
                    Rational[1, 2], 0}]], "-"], " ", 
                SuperscriptBox[
                 StyleBox["Q0",
                  FontColor->RGBColor[{
                    Rational[1, 2], 
                    Rational[1, 2], 0}]], "+"]}], "-", 
               RowBox[{"2430", " ", 
                SuperscriptBox[
                 RowBox[{"(", 
                  SuperscriptBox[
                   StyleBox["Q0",
                    FontColor->RGBColor[{
                    Rational[1, 2], 
                    Rational[1, 2], 0}]], "-"], ")"}], "2"], " ", 
                SuperscriptBox[
                 RowBox[{"(", 
                  SuperscriptBox[
                   StyleBox["Q0",
                    FontColor->RGBColor[{
                    Rational[1, 2], 
                    Rational[1, 2], 0}]], "+"], ")"}], "2"]}]}], ")"}]}], "+", 
            RowBox[{
             SuperscriptBox["u", "6"], " ", 
             RowBox[{"(", 
              RowBox[{"6060", "+", 
               RowBox[{"1341", " ", 
                SuperscriptBox[
                 StyleBox["Q0",
                  FontColor->RGBColor[{
                    Rational[1, 2], 
                    Rational[1, 2], 0}]], "-"], " ", 
                SuperscriptBox[
                 StyleBox["Q0",
                  FontColor->RGBColor[{
                    Rational[1, 2], 
                    Rational[1, 2], 0}]], "+"]}], "-", 
               RowBox[{"648", " ", 
                SuperscriptBox[
                 RowBox[{"(", 
                  SuperscriptBox[
                   StyleBox["Q0",
                    FontColor->RGBColor[{
                    Rational[1, 2], 
                    Rational[1, 2], 0}]], "-"], ")"}], "2"], " ", 
                SuperscriptBox[
                 RowBox[{"(", 
                  SuperscriptBox[
                   StyleBox["Q0",
                    FontColor->RGBColor[{
                    Rational[1, 2], 
                    Rational[1, 2], 0}]], "+"], ")"}], "2"]}]}], ")"}]}]}], 
           ")"}], " ", 
          SubscriptBox[
           OverscriptBox[
            StyleBox["W",
             FontColor->RGBColor[0.54, 0.35, 0.15]], 
            StyleBox["^",
             FontColor->RGBColor[0.54, 0.35, 0.15]]], "lead"]}]}]}], "-", 
       RowBox[{
        FractionBox["1", 
         RowBox[{"9", " ", 
          SuperscriptBox[
           RowBox[{"(", 
            RowBox[{"1", "+", 
             SuperscriptBox["u", "2"]}], ")"}], "3"], " ", 
          SuperscriptBox[
           RowBox[{"(", 
            SuperscriptBox[
             StyleBox["Q0",
              FontColor->RGBColor[{
                 Rational[1, 2], 
                 Rational[1, 2], 0}]], "-"], ")"}], "2"], " ", 
          SuperscriptBox[
           RowBox[{"(", 
            SuperscriptBox[
             StyleBox["Q0",
              FontColor->RGBColor[{
                 Rational[1, 2], 
                 Rational[1, 2], 0}]], "+"], ")"}], "2"]}]], 
        RowBox[{"8", " ", "\[ImaginaryI]", " ", 
         RowBox[{"(", 
          RowBox[{"2", "+", 
           RowBox[{"198", " ", 
            SuperscriptBox["u", "10"]}], "+", 
           RowBox[{"54", " ", 
            SuperscriptBox["u", "12"]}], "-", 
           RowBox[{"18", " ", 
            SuperscriptBox[
             StyleBox["Q0",
              FontColor->RGBColor[{
                 Rational[1, 2], 
                 Rational[1, 2], 0}]], "-"], " ", 
            SuperscriptBox[
             StyleBox["Q0",
              FontColor->RGBColor[{
                 Rational[1, 2], 
                 Rational[1, 2], 0}]], "+"]}], "+", 
           RowBox[{
            SuperscriptBox["u", "6"], " ", 
            RowBox[{"(", 
             RowBox[{"200", "-", 
              RowBox[{"270", " ", 
               SuperscriptBox[
                StyleBox["Q0",
                 FontColor->RGBColor[{
                    Rational[1, 2], 
                    Rational[1, 2], 0}]], "-"], " ", 
               SuperscriptBox[
                StyleBox["Q0",
                 FontColor->RGBColor[{
                    Rational[1, 2], 
                    Rational[1, 2], 0}]], "+"]}]}], ")"}]}], "+", 
           RowBox[{
            SuperscriptBox["u", "8"], " ", 
            RowBox[{"(", 
             RowBox[{"282", "-", 
              RowBox[{"72", " ", 
               SuperscriptBox[
                StyleBox["Q0",
                 FontColor->RGBColor[{
                    Rational[1, 2], 
                    Rational[1, 2], 0}]], "-"], " ", 
               SuperscriptBox[
                StyleBox["Q0",
                 FontColor->RGBColor[{
                    Rational[1, 2], 
                    Rational[1, 2], 0}]], "+"]}]}], ")"}]}], "+", 
           RowBox[{
            SuperscriptBox["u", "4"], " ", 
            RowBox[{"(", 
             RowBox[{"78", "-", 
              RowBox[{"286", " ", 
               SuperscriptBox[
                StyleBox["Q0",
                 FontColor->RGBColor[{
                    Rational[1, 2], 
                    Rational[1, 2], 0}]], "-"], " ", 
               SuperscriptBox[
                StyleBox["Q0",
                 FontColor->RGBColor[{
                    Rational[1, 2], 
                    Rational[1, 2], 0}]], "+"]}], "+", 
              RowBox[{"9", " ", 
               SuperscriptBox[
                RowBox[{"(", 
                 SuperscriptBox[
                  StyleBox["Q0",
                   FontColor->RGBColor[{
                    Rational[1, 2], 
                    Rational[1, 2], 0}]], "-"], ")"}], "2"], " ", 
               SuperscriptBox[
                RowBox[{"(", 
                 SuperscriptBox[
                  StyleBox["Q0",
                   FontColor->RGBColor[{
                    Rational[1, 2], 
                    Rational[1, 2], 0}]], "+"], ")"}], "2"]}]}], ")"}]}], "+", 
           RowBox[{
            SuperscriptBox["u", "2"], " ", 
            RowBox[{"(", 
             RowBox[{"18", "-", 
              RowBox[{"106", " ", 
               SuperscriptBox[
                StyleBox["Q0",
                 FontColor->RGBColor[{
                    Rational[1, 2], 
                    Rational[1, 2], 0}]], "-"], " ", 
               SuperscriptBox[
                StyleBox["Q0",
                 FontColor->RGBColor[{
                    Rational[1, 2], 
                    Rational[1, 2], 0}]], "+"]}], "+", 
              RowBox[{"45", " ", 
               SuperscriptBox[
                RowBox[{"(", 
                 SuperscriptBox[
                  StyleBox["Q0",
                   FontColor->RGBColor[{
                    Rational[1, 2], 
                    Rational[1, 2], 0}]], "-"], ")"}], "2"], " ", 
               SuperscriptBox[
                RowBox[{"(", 
                 SuperscriptBox[
                  StyleBox["Q0",
                   FontColor->RGBColor[{
                    Rational[1, 2], 
                    Rational[1, 2], 0}]], "+"], ")"}], "2"]}]}], ")"}]}]}], 
          ")"}], " ", 
         SubscriptBox[
          OverscriptBox[
           StyleBox["W",
            FontColor->RGBColor[0.54, 0.35, 0.15]], 
           StyleBox["^",
            FontColor->RGBColor[0.54, 0.35, 0.15]]], "sublead"]}]}]}], "]"}], 
     "+", 
     RowBox[{
      FractionBox["1328", "3"], " ", 
      SubscriptBox[
       StyleBox["W",
        FontColor->RGBColor[0.54, 0.35, 0.15]], 
       RowBox[{"1", ",", "v0", ",", "lead"}]]}], "-", 
     RowBox[{"48", " ", 
      SubscriptBox[
       StyleBox["W",
        FontColor->RGBColor[0.54, 0.35, 0.15]], 
       RowBox[{"1", ",", "v0", ",", "sublead"}]]}], "-", 
     RowBox[{"13968", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2"]}], "+", 
     FractionBox[
      RowBox[{"449856", " ", 
       SubsuperscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "2", "2"]}], "5"], "-", 
     FractionBox[
      RowBox[{"927168", " ", 
       SubsuperscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "2", "3"]}], "35"], "-", 
     FractionBox[
      RowBox[{"1466496", " ", 
       SubsuperscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "2", "4"]}], "175"], "+", 
     FractionBox[
      RowBox[{"270336", " ", 
       SubsuperscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "2", "5"]}], "175"], "-", 
     RowBox[{"37584", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3"]}], "-", 
     RowBox[{"17760", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3"]}], "+", 
     RowBox[{
      FractionBox["24576", "5"], " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2", "2"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3"]}], "+", 
     RowBox[{
      FractionBox["39936", "35"], " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2", "3"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3"]}], "+", 
     RowBox[{
      FractionBox["27648", "25"], " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2", "4"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3"]}], "-", 
     RowBox[{"11424", " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3", "2"]}], "+", 
     RowBox[{"5184", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2"], " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3", "2"]}], "-", 
     RowBox[{
      FractionBox["1152", "5"], " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2", "2"], " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3", "2"]}], "+", 
     RowBox[{"2304", " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3", "3"]}], "+", 
     RowBox[{"9648", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "5"]}], "-", 
     RowBox[{"17184", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "5"]}], "-", 
     RowBox[{
      FractionBox["27648", "5"], " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2", "2"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "5"]}], "-", 
     RowBox[{
      FractionBox["4608", "35"], " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2", "3"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "5"]}], "+", 
     RowBox[{"28608", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "5"]}], "-", 
     RowBox[{"6912", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "5"]}], "+", 
     RowBox[{"6528", " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "5", "2"]}], "-", 
     RowBox[{"83376", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "7"]}], "+", 
     RowBox[{"37728", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "7"]}], "-", 
     RowBox[{
      FractionBox["5184", "5"], " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2", "2"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "7"]}], "+", 
     RowBox[{"20160", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "7"]}]}]}], ",", 
   RowBox[{
    RowBox[{
     SubscriptBox["\[Alpha]", "sublead2"], "[", "2", "]"}], "\[Rule]", 
    RowBox[{"320832", "+", 
     RowBox[{"\[DoubleStruckCapitalC]", "[", 
      RowBox[{
       RowBox[{"-", 
        FractionBox[
         RowBox[{"32", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"-", "2"}], "+", 
            RowBox[{"6", " ", "\[ImaginaryI]", " ", "u"}], "+", 
            SuperscriptBox["u", "2"], "-", 
            RowBox[{"\[ImaginaryI]", " ", 
             SuperscriptBox["u", "3"]}], "+", 
            RowBox[{"2", " ", 
             SuperscriptBox["u", "4"]}]}], ")"}], " ", 
          SubscriptBox[
           StyleBox["H",
            FontColor->RGBColor[0.54, 0.35, 0.15]], "lead"]}], 
         RowBox[{"9", " ", 
          SuperscriptBox["u", "5"]}]]}], "-", 
       FractionBox[
        RowBox[{"32", " ", 
         RowBox[{"(", 
          RowBox[{"\[ImaginaryI]", "+", "u"}], ")"}], " ", 
         SubscriptBox[
          StyleBox["H",
           FontColor->RGBColor[0.54, 0.35, 0.15]], "sublead"]}], 
        RowBox[{"9", " ", 
         SuperscriptBox["u", "4"]}]]}], "]"}], "+", 
     RowBox[{"\[DoubleStruckCapitalC]", "[", 
      RowBox[{
       RowBox[{"-", 
        RowBox[{
         FractionBox["1", 
          RowBox[{"27", " ", 
           SuperscriptBox["u", "4"], " ", 
           RowBox[{"(", 
            RowBox[{"\[ImaginaryI]", "+", "u"}], ")"}], " ", 
           SuperscriptBox[
            RowBox[{"(", 
             SuperscriptBox[
              StyleBox["Q0",
               FontColor->RGBColor[{
                  Rational[1, 2], 
                  Rational[1, 2], 0}]], "+"], ")"}], "2"]}]], 
         RowBox[{"64", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"-", "1"}], "+", 
            RowBox[{
             SuperscriptBox["u", "4"], " ", 
             RowBox[{"(", 
              RowBox[{"4", "-", 
               RowBox[{"3", " ", 
                SuperscriptBox[
                 StyleBox["Q0",
                  FontColor->RGBColor[{
                    Rational[1, 2], 
                    Rational[1, 2], 0}]], "+"]}]}], ")"}]}], "+", 
            RowBox[{"6", " ", 
             SuperscriptBox[
              StyleBox["Q0",
               FontColor->RGBColor[{
                  Rational[1, 2], 
                  Rational[1, 2], 0}]], "+"]}], "+", 
            RowBox[{"12", " ", "\[ImaginaryI]", " ", 
             SuperscriptBox["u", "5"], " ", 
             SuperscriptBox[
              StyleBox["Q0",
               FontColor->RGBColor[{
                  Rational[1, 2], 
                  Rational[1, 2], 0}]], "+"]}], "+", 
            RowBox[{"6", " ", 
             SuperscriptBox["u", "6"], " ", 
             SuperscriptBox[
              StyleBox["Q0",
               FontColor->RGBColor[{
                  Rational[1, 2], 
                  Rational[1, 2], 0}]], "+"]}], "+", 
            RowBox[{"2", " ", "\[ImaginaryI]", " ", 
             SuperscriptBox["u", "3"], " ", 
             RowBox[{"(", 
              RowBox[{"4", "+", 
               RowBox[{"3", " ", 
                SuperscriptBox[
                 StyleBox["Q0",
                  FontColor->RGBColor[{
                    Rational[1, 2], 
                    Rational[1, 2], 0}]], "+"]}]}], ")"}]}], "-", 
            RowBox[{"3", " ", "\[ImaginaryI]", " ", "u", " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"-", "1"}], "+", 
               RowBox[{"4", " ", 
                SuperscriptBox[
                 StyleBox["Q0",
                  FontColor->RGBColor[{
                    Rational[1, 2], 
                    Rational[1, 2], 0}]], "+"]}]}], ")"}]}], "-", 
            RowBox[{
             SuperscriptBox["u", "2"], " ", 
             RowBox[{"(", 
              RowBox[{"1", "+", 
               RowBox[{"9", " ", 
                SuperscriptBox[
                 StyleBox["Q0",
                  FontColor->RGBColor[{
                    Rational[1, 2], 
                    Rational[1, 2], 0}]], "+"]}]}], ")"}]}]}], ")"}], " ", 
          SubsuperscriptBox[
           StyleBox["W",
            FontColor->RGBColor[0.54, 0.35, 0.15]], 
           RowBox[{"1", ",", "lead"}], "+"]}]}]}], "-", 
       FractionBox[
        RowBox[{"64", " ", 
         RowBox[{"(", 
          RowBox[{"\[ImaginaryI]", "+", "u"}], ")"}], " ", 
         SubsuperscriptBox[
          StyleBox["W",
           FontColor->RGBColor[0.54, 0.35, 0.15]], 
          RowBox[{"1", ",", "sublead"}], "+"]}], 
        RowBox[{"9", " ", 
         SuperscriptBox["u", "2"], " ", 
         SuperscriptBox[
          StyleBox["Q0",
           FontColor->RGBColor[{
              Rational[1, 2], 
              Rational[1, 2], 0}]], "+"]}]]}], "]"}], "+", 
     RowBox[{"\[DoubleStruckCapitalC]", "[", 
      RowBox[{
       RowBox[{"-", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{"64", " ", "\[ImaginaryI]", " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{
              RowBox[{"-", "270"}], " ", 
              SuperscriptBox["u", "18"]}], "+", 
             RowBox[{"81", " ", 
              SuperscriptBox["u", "20"]}], "-", 
             RowBox[{"243", " ", 
              SuperscriptBox[
               RowBox[{"(", 
                SuperscriptBox[
                 StyleBox["Q0",
                  FontColor->RGBColor[{
                    Rational[1, 2], 
                    Rational[1, 2], 0}]], "-"], ")"}], "2"], " ", 
              SuperscriptBox[
               RowBox[{"(", 
                SuperscriptBox[
                 StyleBox["Q0",
                  FontColor->RGBColor[{
                    Rational[1, 2], 
                    Rational[1, 2], 0}]], "+"], ")"}], "2"]}], "-", 
             RowBox[{"243", " ", 
              SuperscriptBox["u", "2"], " ", 
              SuperscriptBox[
               RowBox[{"(", 
                SuperscriptBox[
                 StyleBox["Q0",
                  FontColor->RGBColor[{
                    Rational[1, 2], 
                    Rational[1, 2], 0}]], "-"], ")"}], "2"], " ", 
              SuperscriptBox[
               RowBox[{"(", 
                SuperscriptBox[
                 StyleBox["Q0",
                  FontColor->RGBColor[{
                    Rational[1, 2], 
                    Rational[1, 2], 0}]], "+"], ")"}], "2"]}], "+", 
             RowBox[{"9", " ", 
              SuperscriptBox["u", "16"], " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"-", "313"}], "+", 
                RowBox[{"15", " ", 
                 SuperscriptBox[
                  StyleBox["Q0",
                   FontColor->RGBColor[{
                    Rational[1, 2], 
                    Rational[1, 2], 0}]], "-"], " ", 
                 SuperscriptBox[
                  StyleBox["Q0",
                   FontColor->RGBColor[{
                    Rational[1, 2], 
                    Rational[1, 2], 0}]], "+"]}]}], ")"}]}], "+", 
             RowBox[{
              SuperscriptBox["u", "14"], " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"-", "6747"}], "+", 
                RowBox[{"657", " ", 
                 SuperscriptBox[
                  StyleBox["Q0",
                   FontColor->RGBColor[{
                    Rational[1, 2], 
                    Rational[1, 2], 0}]], "-"], " ", 
                 SuperscriptBox[
                  StyleBox["Q0",
                   FontColor->RGBColor[{
                    Rational[1, 2], 
                    Rational[1, 2], 0}]], "+"]}]}], ")"}]}], "+", 
             RowBox[{
              SuperscriptBox["u", "10"], " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"-", "3037"}], "+", 
                RowBox[{"1530", " ", 
                 SuperscriptBox[
                  StyleBox["Q0",
                   FontColor->RGBColor[{
                    Rational[1, 2], 
                    Rational[1, 2], 0}]], "-"], " ", 
                 SuperscriptBox[
                  StyleBox["Q0",
                   FontColor->RGBColor[{
                    Rational[1, 2], 
                    Rational[1, 2], 0}]], "+"]}], "-", 
                RowBox[{"486", " ", 
                 SuperscriptBox[
                  RowBox[{"(", 
                   SuperscriptBox[
                    StyleBox["Q0",
                    FontColor->RGBColor[{
                    Rational[1, 2], 
                    Rational[1, 2], 0}]], "-"], ")"}], "2"], " ", 
                 SuperscriptBox[
                  RowBox[{"(", 
                   SuperscriptBox[
                    StyleBox["Q0",
                    FontColor->RGBColor[{
                    Rational[1, 2], 
                    Rational[1, 2], 0}]], "+"], ")"}], "2"]}]}], ")"}]}], "-", 
             RowBox[{"3", " ", 
              SuperscriptBox["u", "12"], " ", 
              RowBox[{"(", 
               RowBox[{"2248", "-", 
                RowBox[{"579", " ", 
                 SuperscriptBox[
                  StyleBox["Q0",
                   FontColor->RGBColor[{
                    Rational[1, 2], 
                    Rational[1, 2], 0}]], "-"], " ", 
                 SuperscriptBox[
                  StyleBox["Q0",
                   FontColor->RGBColor[{
                    Rational[1, 2], 
                    Rational[1, 2], 0}]], "+"]}], "+", 
                RowBox[{"81", " ", 
                 SuperscriptBox[
                  RowBox[{"(", 
                   SuperscriptBox[
                    StyleBox["Q0",
                    FontColor->RGBColor[{
                    Rational[1, 2], 
                    Rational[1, 2], 0}]], "-"], ")"}], "2"], " ", 
                 SuperscriptBox[
                  RowBox[{"(", 
                   SuperscriptBox[
                    StyleBox["Q0",
                    FontColor->RGBColor[{
                    Rational[1, 2], 
                    Rational[1, 2], 0}]], "+"], ")"}], "2"]}]}], ")"}]}], "+", 
             RowBox[{"9", " ", 
              SuperscriptBox["u", "6"], " ", 
              RowBox[{"(", 
               RowBox[{"10", "+", 
                RowBox[{"69", " ", 
                 SuperscriptBox[
                  StyleBox["Q0",
                   FontColor->RGBColor[{
                    Rational[1, 2], 
                    Rational[1, 2], 0}]], "-"], " ", 
                 SuperscriptBox[
                  StyleBox["Q0",
                   FontColor->RGBColor[{
                    Rational[1, 2], 
                    Rational[1, 2], 0}]], "+"]}], "+", 
                RowBox[{"603", " ", 
                 SuperscriptBox[
                  RowBox[{"(", 
                   SuperscriptBox[
                    StyleBox["Q0",
                    FontColor->RGBColor[{
                    Rational[1, 2], 
                    Rational[1, 2], 0}]], "-"], ")"}], "2"], " ", 
                 SuperscriptBox[
                  RowBox[{"(", 
                   SuperscriptBox[
                    StyleBox["Q0",
                    FontColor->RGBColor[{
                    Rational[1, 2], 
                    Rational[1, 2], 0}]], "+"], ")"}], "2"]}]}], ")"}]}], "+", 
             RowBox[{
              SuperscriptBox["u", "8"], " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"-", "512"}], "+", 
                RowBox[{"873", " ", 
                 SuperscriptBox[
                  StyleBox["Q0",
                   FontColor->RGBColor[{
                    Rational[1, 2], 
                    Rational[1, 2], 0}]], "-"], " ", 
                 SuperscriptBox[
                  StyleBox["Q0",
                   FontColor->RGBColor[{
                    Rational[1, 2], 
                    Rational[1, 2], 0}]], "+"]}], "+", 
                RowBox[{"2187", " ", 
                 SuperscriptBox[
                  RowBox[{"(", 
                   SuperscriptBox[
                    StyleBox["Q0",
                    FontColor->RGBColor[{
                    Rational[1, 2], 
                    Rational[1, 2], 0}]], "-"], ")"}], "2"], " ", 
                 SuperscriptBox[
                  RowBox[{"(", 
                   SuperscriptBox[
                    StyleBox["Q0",
                    FontColor->RGBColor[{
                    Rational[1, 2], 
                    Rational[1, 2], 0}]], "+"], ")"}], "2"]}]}], ")"}]}], "+", 
             RowBox[{
              SuperscriptBox["u", "4"], " ", 
              RowBox[{"(", 
               RowBox[{"28", "+", 
                RowBox[{"63", " ", 
                 SuperscriptBox[
                  StyleBox["Q0",
                   FontColor->RGBColor[{
                    Rational[1, 2], 
                    Rational[1, 2], 0}]], "-"], " ", 
                 SuperscriptBox[
                  StyleBox["Q0",
                   FontColor->RGBColor[{
                    Rational[1, 2], 
                    Rational[1, 2], 0}]], "+"]}], "+", 
                RowBox[{"4293", " ", 
                 SuperscriptBox[
                  RowBox[{"(", 
                   SuperscriptBox[
                    StyleBox["Q0",
                    FontColor->RGBColor[{
                    Rational[1, 2], 
                    Rational[1, 2], 0}]], "-"], ")"}], "2"], " ", 
                 SuperscriptBox[
                  RowBox[{"(", 
                   SuperscriptBox[
                    StyleBox["Q0",
                    FontColor->RGBColor[{
                    Rational[1, 2], 
                    Rational[1, 2], 0}]], "+"], ")"}], "2"]}]}], ")"}]}]}], 
            ")"}], " ", 
           SubscriptBox[
            OverscriptBox[
             StyleBox["W",
              FontColor->RGBColor[0.54, 0.35, 0.15]], 
             StyleBox["^",
              FontColor->RGBColor[0.54, 0.35, 0.15]]], "lead"]}], ")"}], "/", 
         
         RowBox[{"(", 
          RowBox[{"243", " ", 
           SuperscriptBox["u", "4"], " ", 
           SuperscriptBox[
            RowBox[{"(", 
             RowBox[{"1", "+", 
              SuperscriptBox["u", "2"]}], ")"}], "5"], " ", 
           SuperscriptBox[
            RowBox[{"(", 
             SuperscriptBox[
              StyleBox["Q0",
               FontColor->RGBColor[{
                  Rational[1, 2], 
                  Rational[1, 2], 0}]], "-"], ")"}], "2"], " ", 
           SuperscriptBox[
            RowBox[{"(", 
             SuperscriptBox[
              StyleBox["Q0",
               FontColor->RGBColor[{
                  Rational[1, 2], 
                  Rational[1, 2], 0}]], "+"], ")"}], "2"]}], ")"}]}]}], "+", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{"32", " ", "\[ImaginaryI]", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"99", " ", 
             SuperscriptBox["u", "12"]}], "+", 
            RowBox[{"27", " ", 
             SuperscriptBox["u", "14"]}], "-", 
            RowBox[{"81", " ", 
             SuperscriptBox[
              RowBox[{"(", 
               SuperscriptBox[
                StyleBox["Q0",
                 FontColor->RGBColor[{
                    Rational[1, 2], 
                    Rational[1, 2], 0}]], "-"], ")"}], "2"], " ", 
             SuperscriptBox[
              RowBox[{"(", 
               SuperscriptBox[
                StyleBox["Q0",
                 FontColor->RGBColor[{
                    Rational[1, 2], 
                    Rational[1, 2], 0}]], "+"], ")"}], "2"]}], "+", 
            RowBox[{"3", " ", 
             SuperscriptBox["u", "10"], " ", 
             RowBox[{"(", 
              RowBox[{"47", "+", 
               RowBox[{"36", " ", 
                SuperscriptBox[
                 StyleBox["Q0",
                  FontColor->RGBColor[{
                    Rational[1, 2], 
                    Rational[1, 2], 0}]], "-"], " ", 
                SuperscriptBox[
                 StyleBox["Q0",
                  FontColor->RGBColor[{
                    Rational[1, 2], 
                    Rational[1, 2], 0}]], "+"]}]}], ")"}]}], "+", 
            RowBox[{"2", " ", 
             SuperscriptBox["u", "8"], " ", 
             RowBox[{"(", 
              RowBox[{"50", "+", 
               RowBox[{"207", " ", 
                SuperscriptBox[
                 StyleBox["Q0",
                  FontColor->RGBColor[{
                    Rational[1, 2], 
                    Rational[1, 2], 0}]], "-"], " ", 
                SuperscriptBox[
                 StyleBox["Q0",
                  FontColor->RGBColor[{
                    Rational[1, 2], 
                    Rational[1, 2], 0}]], "+"]}]}], ")"}]}], "+", 
            RowBox[{
             SuperscriptBox["u", "2"], " ", 
             RowBox[{"(", 
              RowBox[{"1", "+", 
               RowBox[{"36", " ", 
                SuperscriptBox[
                 StyleBox["Q0",
                  FontColor->RGBColor[{
                    Rational[1, 2], 
                    Rational[1, 2], 0}]], "-"], " ", 
                SuperscriptBox[
                 StyleBox["Q0",
                  FontColor->RGBColor[{
                    Rational[1, 2], 
                    Rational[1, 2], 0}]], "+"]}], "-", 
               RowBox[{"486", " ", 
                SuperscriptBox[
                 RowBox[{"(", 
                  SuperscriptBox[
                   StyleBox["Q0",
                    FontColor->RGBColor[{
                    Rational[1, 2], 
                    Rational[1, 2], 0}]], "-"], ")"}], "2"], " ", 
                SuperscriptBox[
                 RowBox[{"(", 
                  SuperscriptBox[
                   StyleBox["Q0",
                    FontColor->RGBColor[{
                    Rational[1, 2], 
                    Rational[1, 2], 0}]], "+"], ")"}], "2"]}]}], ")"}]}], "+", 
            RowBox[{
             SuperscriptBox["u", "4"], " ", 
             RowBox[{"(", 
              RowBox[{"9", "+", 
               RowBox[{"186", " ", 
                SuperscriptBox[
                 StyleBox["Q0",
                  FontColor->RGBColor[{
                    Rational[1, 2], 
                    Rational[1, 2], 0}]], "-"], " ", 
                SuperscriptBox[
                 StyleBox["Q0",
                  FontColor->RGBColor[{
                    Rational[1, 2], 
                    Rational[1, 2], 0}]], "+"]}], "-", 
               RowBox[{"432", " ", 
                SuperscriptBox[
                 RowBox[{"(", 
                  SuperscriptBox[
                   StyleBox["Q0",
                    FontColor->RGBColor[{
                    Rational[1, 2], 
                    Rational[1, 2], 0}]], "-"], ")"}], "2"], " ", 
                SuperscriptBox[
                 RowBox[{"(", 
                  SuperscriptBox[
                   StyleBox["Q0",
                    FontColor->RGBColor[{
                    Rational[1, 2], 
                    Rational[1, 2], 0}]], "+"], ")"}], "2"]}]}], ")"}]}], "+", 
            RowBox[{
             SuperscriptBox["u", "6"], " ", 
             RowBox[{"(", 
              RowBox[{"39", "+", 
               RowBox[{"456", " ", 
                SuperscriptBox[
                 StyleBox["Q0",
                  FontColor->RGBColor[{
                    Rational[1, 2], 
                    Rational[1, 2], 0}]], "-"], " ", 
                SuperscriptBox[
                 StyleBox["Q0",
                  FontColor->RGBColor[{
                    Rational[1, 2], 
                    Rational[1, 2], 0}]], "+"]}], "-", 
               RowBox[{"135", " ", 
                SuperscriptBox[
                 RowBox[{"(", 
                  SuperscriptBox[
                   StyleBox["Q0",
                    FontColor->RGBColor[{
                    Rational[1, 2], 
                    Rational[1, 2], 0}]], "-"], ")"}], "2"], " ", 
                SuperscriptBox[
                 RowBox[{"(", 
                  SuperscriptBox[
                   StyleBox["Q0",
                    FontColor->RGBColor[{
                    Rational[1, 2], 
                    Rational[1, 2], 0}]], "+"], ")"}], "2"]}]}], ")"}]}]}], 
           ")"}], " ", 
          SubscriptBox[
           OverscriptBox[
            StyleBox["W",
             FontColor->RGBColor[0.54, 0.35, 0.15]], 
            StyleBox["^",
             FontColor->RGBColor[0.54, 0.35, 0.15]]], "sublead"]}], ")"}], 
        "/", 
        RowBox[{"(", 
         RowBox[{"81", " ", 
          SuperscriptBox["u", "2"], " ", 
          SuperscriptBox[
           RowBox[{"(", 
            RowBox[{"1", "+", 
             SuperscriptBox["u", "2"]}], ")"}], "3"], " ", 
          SuperscriptBox[
           RowBox[{"(", 
            SuperscriptBox[
             StyleBox["Q0",
              FontColor->RGBColor[{
                 Rational[1, 2], 
                 Rational[1, 2], 0}]], "-"], ")"}], "2"], " ", 
          SuperscriptBox[
           RowBox[{"(", 
            SuperscriptBox[
             StyleBox["Q0",
              FontColor->RGBColor[{
                 Rational[1, 2], 
                 Rational[1, 2], 0}]], "+"], ")"}], "2"]}], ")"}]}]}], "]"}], 
     "-", 
     RowBox[{
      FractionBox["1856", "9"], " ", 
      SubscriptBox[
       StyleBox["W",
        FontColor->RGBColor[0.54, 0.35, 0.15]], 
       RowBox[{"1", ",", "v0", ",", "lead"}]]}], "+", 
     RowBox[{
      FractionBox["32", "3"], " ", 
      SubscriptBox[
       StyleBox["W",
        FontColor->RGBColor[0.54, 0.35, 0.15]], 
       RowBox[{"1", ",", "v0", ",", "sublead"}]]}], "-", 
     RowBox[{"87360", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2"]}], "+", 
     FractionBox[
      RowBox[{"828288", " ", 
       SubsuperscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "2", "2"]}], "5"], "-", 
     FractionBox[
      RowBox[{"2382592", " ", 
       SubsuperscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "2", "3"]}], "35"], "+", 
     FractionBox[
      RowBox[{"52736", " ", 
       SubsuperscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "2", "4"]}], "35"], "+", 
     FractionBox[
      RowBox[{"67584", " ", 
       SubsuperscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "2", "5"]}], "175"], "-", 
     RowBox[{"438336", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3"]}], "-", 
     RowBox[{"20864", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3"]}], "+", 
     RowBox[{
      FractionBox["44032", "5"], " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2", "2"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3"]}], "+", 
     RowBox[{
      FractionBox["663552", "35"], " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2", "3"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3"]}], "-", 
     RowBox[{
      FractionBox["6144", "25"], " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2", "4"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3"]}], "+", 
     RowBox[{"45952", " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3", "2"]}], "+", 
     RowBox[{"2304", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2"], " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3", "2"]}], "+", 
     RowBox[{
      FractionBox["1536", "5"], " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2", "2"], " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3", "2"]}], "+", 
     RowBox[{"1536", " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3", "3"]}], "+", 
     RowBox[{"24768", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "5"]}], "-", 
     RowBox[{"38784", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "5"]}], "-", 
     RowBox[{
      FractionBox["123392", "5"], " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2", "2"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "5"]}], "+", 
     RowBox[{
      FractionBox["47104", "35"], " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2", "3"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "5"]}], "+", 
     RowBox[{"91136", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "5"]}], "+", 
     RowBox[{"9216", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "5"]}], "-", 
     RowBox[{"12288", " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "5", "2"]}], "-", 
     RowBox[{"25152", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "7"]}], "+", 
     RowBox[{"33152", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "7"]}], "-", 
     RowBox[{
      FractionBox["16128", "5"], " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2", "2"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "7"]}], "-", 
     RowBox[{"8192", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "7"]}]}]}], ",", 
   RowBox[{
    RowBox[{
     SubscriptBox["\[Beta]", "sublead2"], "[", "2", "]"}], "\[Rule]", 
    RowBox[{
     RowBox[{"\[DoubleStruckCapitalC]", "[", 
      RowBox[{"-", 
       FractionBox[
        RowBox[{"32", " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"-", "\[ImaginaryI]"}], "+", 
           RowBox[{"2", " ", "u"}], "+", 
           RowBox[{"3", " ", 
            SuperscriptBox["u", "3"]}]}], ")"}], " ", 
         SubscriptBox[
          StyleBox["H",
           FontColor->RGBColor[0.54, 0.35, 0.15]], "lead"]}], 
        RowBox[{"3", " ", 
         SuperscriptBox["u", "6"]}]]}], "]"}], "+", 
     RowBox[{"\[DoubleStruckCapitalC]", "[", 
      RowBox[{"-", 
       FractionBox[
        RowBox[{"64", " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"2", " ", "\[ImaginaryI]"}], "+", 
           RowBox[{"2", " ", "u"}], "+", 
           RowBox[{"3", " ", "\[ImaginaryI]", " ", 
            SuperscriptBox["u", "2"]}], "+", 
           RowBox[{"3", " ", 
            SuperscriptBox["u", "3"]}]}], ")"}], " ", 
         SubsuperscriptBox[
          StyleBox["W",
           FontColor->RGBColor[0.54, 0.35, 0.15]], 
          RowBox[{"1", ",", "lead"}], "+"]}], 
        RowBox[{"3", " ", 
         SuperscriptBox["u", "4"], " ", 
         SuperscriptBox[
          StyleBox["Q0",
           FontColor->RGBColor[{
              Rational[1, 2], 
              Rational[1, 2], 0}]], "+"]}]]}], "]"}], "+", 
     RowBox[{"\[DoubleStruckCapitalC]", "[", 
      FractionBox[
       RowBox[{"32", " ", "\[ImaginaryI]", " ", 
        SuperscriptBox["u", "2"], " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"-", "2"}], "+", 
          RowBox[{"192", " ", 
           SuperscriptBox["u", "6"]}], "+", 
          RowBox[{"54", " ", 
           SuperscriptBox["u", "8"]}], "+", 
          RowBox[{"81", " ", 
           SuperscriptBox[
            StyleBox["Q0",
             FontColor->RGBColor[{
                Rational[1, 2], 
                Rational[1, 2], 0}]], "-"], " ", 
           SuperscriptBox[
            StyleBox["Q0",
             FontColor->RGBColor[{
                Rational[1, 2], 
                Rational[1, 2], 0}]], "+"]}], "-", 
          RowBox[{"18", " ", 
           SuperscriptBox["u", "2"], " ", 
           RowBox[{"(", 
            RowBox[{"8", "+", 
             RowBox[{"5", " ", 
              SuperscriptBox[
               StyleBox["Q0",
                FontColor->RGBColor[{
                   Rational[1, 2], 
                   Rational[1, 2], 0}]], "-"], " ", 
              SuperscriptBox[
               StyleBox["Q0",
                FontColor->RGBColor[{
                   Rational[1, 2], 
                   Rational[1, 2], 0}]], "+"]}]}], ")"}]}], "-", 
          RowBox[{
           SuperscriptBox["u", "4"], " ", 
           RowBox[{"(", 
            RowBox[{"4", "+", 
             RowBox[{"27", " ", 
              SuperscriptBox[
               StyleBox["Q0",
                FontColor->RGBColor[{
                   Rational[1, 2], 
                   Rational[1, 2], 0}]], "-"], " ", 
              SuperscriptBox[
               StyleBox["Q0",
                FontColor->RGBColor[{
                   Rational[1, 2], 
                   Rational[1, 2], 0}]], "+"]}]}], ")"}]}]}], ")"}], " ", 
        SubscriptBox[
         OverscriptBox[
          StyleBox["W",
           FontColor->RGBColor[0.54, 0.35, 0.15]], 
          StyleBox["^",
           FontColor->RGBColor[0.54, 0.35, 0.15]]], "lead"]}], 
       RowBox[{"9", " ", 
        SuperscriptBox[
         RowBox[{"(", 
          RowBox[{"1", "+", 
           SuperscriptBox["u", "2"]}], ")"}], "5"], " ", 
        SuperscriptBox[
         StyleBox["Q0",
          FontColor->RGBColor[{
             Rational[1, 2], 
             Rational[1, 2], 0}]], "-"], " ", 
        SuperscriptBox[
         StyleBox["Q0",
          FontColor->RGBColor[{
             Rational[1, 2], 
             Rational[1, 2], 0}]], "+"]}]], "]"}], "-", 
     FractionBox[
      RowBox[{"31104", " ", 
       SubsuperscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "2", "2"]}], "5"], "+", 
     FractionBox[
      RowBox[{"1234944", " ", 
       SubsuperscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "2", "3"]}], "35"], "-", 
     FractionBox[
      RowBox[{"3220992", " ", 
       SubsuperscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "2", "4"]}], "175"], "+", 
     FractionBox[
      RowBox[{"67584", " ", 
       SubsuperscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "2", "5"]}], "35"], "+", 
     RowBox[{"3456", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3"]}], "+", 
     RowBox[{
      FractionBox["52992", "5"], " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2", "2"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3"]}], "-", 
     RowBox[{"9216", " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2", "3"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3"]}], "+", 
     RowBox[{
      FractionBox["9216", "5"], " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2", "4"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3"]}], "-", 
     RowBox[{"13824", " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3", "2"]}], "-", 
     RowBox[{"10368", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "5"]}], "-", 
     RowBox[{"52992", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "5"]}], "+", 
     RowBox[{
      FractionBox["33792", "5"], " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2", "2"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "5"]}], "+", 
     RowBox[{
      FractionBox["12288", "7"], " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2", "3"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "5"]}], "+", 
     RowBox[{"32256", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "5"]}], "+", 
     RowBox[{"15360", " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "5", "2"]}], "-", 
     RowBox[{"31680", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "7"]}], "+", 
     RowBox[{"36480", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "7"]}], "-", 
     RowBox[{"6912", " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2", "2"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "7"]}], "-", 
     RowBox[{"7680", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "7"]}]}]}], ",", 
   RowBox[{
    RowBox[{
     SubscriptBox["\[Alpha]", "sublead2"], "[", "3", "]"}], "\[Rule]", 
    RowBox[{"31104", "+", 
     RowBox[{"\[DoubleStruckCapitalC]", "[", 
      RowBox[{"-", 
       FractionBox[
        RowBox[{"128", " ", 
         RowBox[{"(", 
          RowBox[{"\[ImaginaryI]", "+", "u"}], ")"}], " ", 
         SubscriptBox[
          StyleBox["H",
           FontColor->RGBColor[0.54, 0.35, 0.15]], "lead"]}], 
        RowBox[{"9", " ", 
         SuperscriptBox["u", "6"]}]]}], "]"}], "+", 
     RowBox[{
      FractionBox["4", "9"], " ", 
      RowBox[{"\[DoubleStruckCapitalC]", "[", 
       RowBox[{"-", 
        FractionBox[
         RowBox[{"64", " ", 
          RowBox[{"(", 
           RowBox[{"\[ImaginaryI]", "+", "u"}], ")"}], " ", 
          SubsuperscriptBox[
           StyleBox["W",
            FontColor->RGBColor[0.54, 0.35, 0.15]], 
           RowBox[{"1", ",", "lead"}], "+"]}], 
         RowBox[{
          SuperscriptBox["u", "4"], " ", 
          SuperscriptBox[
           StyleBox["Q0",
            FontColor->RGBColor[{
               Rational[1, 2], 
               Rational[1, 2], 0}]], "+"]}]]}], "]"}]}], "+", 
     RowBox[{"\[DoubleStruckCapitalC]", "[", 
      RowBox[{"-", 
       RowBox[{
        FractionBox["1", 
         RowBox[{"27", " ", 
          SuperscriptBox["u", "4"], " ", 
          SuperscriptBox[
           RowBox[{"(", 
            RowBox[{"1", "+", 
             SuperscriptBox["u", "2"]}], ")"}], "5"], " ", 
          SuperscriptBox[
           StyleBox["Q0",
            FontColor->RGBColor[{
               Rational[1, 2], 
               Rational[1, 2], 0}]], "-"], " ", 
          SuperscriptBox[
           StyleBox["Q0",
            FontColor->RGBColor[{
               Rational[1, 2], 
               Rational[1, 2], 0}]], "+"]}]], 
        RowBox[{"128", " ", "\[ImaginaryI]", " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"144", " ", 
            SuperscriptBox["u", "14"]}], "+", 
           RowBox[{"27", " ", 
            SuperscriptBox["u", "16"]}], "+", 
           RowBox[{"27", " ", 
            SuperscriptBox[
             StyleBox["Q0",
              FontColor->RGBColor[{
                 Rational[1, 2], 
                 Rational[1, 2], 0}]], "-"], " ", 
            SuperscriptBox[
             StyleBox["Q0",
              FontColor->RGBColor[{
                 Rational[1, 2], 
                 Rational[1, 2], 0}]], "+"]}], "+", 
           RowBox[{"81", " ", 
            SuperscriptBox["u", "2"], " ", 
            SuperscriptBox[
             StyleBox["Q0",
              FontColor->RGBColor[{
                 Rational[1, 2], 
                 Rational[1, 2], 0}]], "-"], " ", 
            SuperscriptBox[
             StyleBox["Q0",
              FontColor->RGBColor[{
                 Rational[1, 2], 
                 Rational[1, 2], 0}]], "+"]}], "+", 
           RowBox[{
            SuperscriptBox["u", "6"], " ", 
            RowBox[{"(", 
             RowBox[{"58", "-", 
              RowBox[{"216", " ", 
               SuperscriptBox[
                StyleBox["Q0",
                 FontColor->RGBColor[{
                    Rational[1, 2], 
                    Rational[1, 2], 0}]], "-"], " ", 
               SuperscriptBox[
                StyleBox["Q0",
                 FontColor->RGBColor[{
                    Rational[1, 2], 
                    Rational[1, 2], 0}]], "+"]}]}], ")"}]}], "+", 
           RowBox[{
            SuperscriptBox["u", "4"], " ", 
            RowBox[{"(", 
             RowBox[{"9", "-", 
              RowBox[{"162", " ", 
               SuperscriptBox[
                StyleBox["Q0",
                 FontColor->RGBColor[{
                    Rational[1, 2], 
                    Rational[1, 2], 0}]], "-"], " ", 
               SuperscriptBox[
                StyleBox["Q0",
                 FontColor->RGBColor[{
                    Rational[1, 2], 
                    Rational[1, 2], 0}]], "+"]}]}], ")"}]}], "+", 
           RowBox[{
            SuperscriptBox["u", "10"], " ", 
            RowBox[{"(", 
             RowBox[{"398", "-", 
              RowBox[{"135", " ", 
               SuperscriptBox[
                StyleBox["Q0",
                 FontColor->RGBColor[{
                    Rational[1, 2], 
                    Rational[1, 2], 0}]], "-"], " ", 
               SuperscriptBox[
                StyleBox["Q0",
                 FontColor->RGBColor[{
                    Rational[1, 2], 
                    Rational[1, 2], 0}]], "+"]}]}], ")"}]}], "-", 
           RowBox[{"3", " ", 
            SuperscriptBox["u", "12"], " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "95"}], "+", 
              RowBox[{"9", " ", 
               SuperscriptBox[
                StyleBox["Q0",
                 FontColor->RGBColor[{
                    Rational[1, 2], 
                    Rational[1, 2], 0}]], "-"], " ", 
               SuperscriptBox[
                StyleBox["Q0",
                 FontColor->RGBColor[{
                    Rational[1, 2], 
                    Rational[1, 2], 0}]], "+"]}]}], ")"}]}], "-", 
           RowBox[{"9", " ", 
            SuperscriptBox["u", "8"], " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "31"}], "+", 
              RowBox[{"28", " ", 
               SuperscriptBox[
                StyleBox["Q0",
                 FontColor->RGBColor[{
                    Rational[1, 2], 
                    Rational[1, 2], 0}]], "-"], " ", 
               SuperscriptBox[
                StyleBox["Q0",
                 FontColor->RGBColor[{
                    Rational[1, 2], 
                    Rational[1, 2], 0}]], "+"]}]}], ")"}]}]}], ")"}], " ", 
         SubscriptBox[
          OverscriptBox[
           StyleBox["W",
            FontColor->RGBColor[0.54, 0.35, 0.15]], 
           StyleBox["^",
            FontColor->RGBColor[0.54, 0.35, 0.15]]], "lead"]}]}]}], "]"}], 
     "+", 
     RowBox[{"128", " ", 
      SubscriptBox[
       StyleBox["W",
        FontColor->RGBColor[0.54, 0.35, 0.15]], 
       RowBox[{"1", ",", "v0", ",", "lead"}]]}], "-", 
     RowBox[{"103680", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2"]}], "-", 
     RowBox[{"64512", " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2", "2"]}], "+", 
     FractionBox[
      RowBox[{"337920", " ", 
       SubsuperscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "2", "3"]}], "7"], "-", 
     FractionBox[
      RowBox[{"1001472", " ", 
       SubsuperscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "2", "4"]}], "175"], "+", 
     FractionBox[
      RowBox[{"45056", " ", 
       SubsuperscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "2", "5"]}], "35"], "+", 
     RowBox[{"228096", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3"]}], "+", 
     RowBox[{"6144", " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2", "2"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3"]}], "-", 
     RowBox[{
      FractionBox["208896", "7"], " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2", "3"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3"]}], "-", 
     RowBox[{
      FractionBox["12288", "5"], " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2", "4"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3"]}], "-", 
     RowBox[{"4608", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "5"]}], "-", 
     RowBox[{"33792", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "5"]}], "+", 
     RowBox[{
      FractionBox["114688", "5"], " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2", "2"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "5"]}], "-", 
     RowBox[{
      FractionBox["16384", "7"], " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2", "3"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "5"]}], "+", 
     RowBox[{"24576", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "5"]}], "+", 
     RowBox[{"10240", " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "5", "2"]}], "-", 
     RowBox[{"211200", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "7"]}], "+", 
     RowBox[{"104960", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "7"]}], "+", 
     RowBox[{"9216", " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2", "2"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "7"]}], "-", 
     RowBox[{"5120", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "7"]}]}]}], ",", 
   RowBox[{
    RowBox[{
     SubscriptBox["\[Beta]", "sublead2"], "[", "3", "]"}], "\[Rule]", "0"}], 
   ",", 
   RowBox[{
    RowBox[{
     SubscriptBox["\[Alpha]", "sublead2"], "[", "4", "]"}], "\[Rule]", "0"}], 
   ",", 
   RowBox[{
    RowBox[{
     SubscriptBox["\[Beta]", "sublead2"], "[", "4", "]"}], "\[Rule]", "0"}], 
   ",", 
   RowBox[{
    RowBox[{
     SubscriptBox["\[Alpha]", "sublead2"], "[", "5", "]"}], "\[Rule]", "0"}], 
   ",", 
   RowBox[{
    RowBox[{
     SubscriptBox["\[Beta]", "sublead2"], "[", "5", "]"}], "\[Rule]", "0"}]}],
   "}"}]], "Output",
 CellChangeTimes->{3.560077192197361*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 FractionBox["11880", "10368"]], "Input",
 CellChangeTimes->{{3.560077183700173*^9, 3.560077185859726*^9}}],

Cell[BoxData[
 FractionBox["55", "48"]], "Output",
 CellChangeTimes->{3.5600771423245564`*^9, 3.560077186329557*^9}]
}, Open  ]]
}, Open  ]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["\<\
Correction to Bethe equation (m1,m2,m3,m4)\
\>", "Section",
 CellChangeTimes->{{3.5413970581295958`*^9, 3.541397061343525*^9}, {
   3.54988220878127*^9, 3.549882221850399*^9}, {3.552193238013246*^9, 
   3.5521932539051723`*^9}, 3.5537720339020433`*^9, {3.558946735832645*^9, 
   3.558946737791807*^9}}],

Cell[CellGroupData[{

Cell["Init", "Subsection",
 CellChangeTimes->{{3.5502176613251038`*^9, 3.550217661754586*^9}}],

Cell["We consider the phase coming from", "Text",
 CellChangeTimes->{{3.54988224265903*^9, 3.549882248160984*^9}, {
  3.55219327600231*^9, 3.5521932820547743`*^9}}],

Cell[BoxData[
 RowBox[{
  SuperscriptBox[
   RowBox[{"(", 
    FractionBox[
     SuperscriptBox[
      OverscriptBox[
       StyleBox["h",
        FontColor->RGBColor[0, 0.6, 0]], 
       StyleBox["^",
        FontColor->RGBColor[0, 0.6, 0]]], "+"], 
     SuperscriptBox[
      OverscriptBox[
       StyleBox["h",
        FontColor->RGBColor[0, 0.6, 0]], 
       StyleBox["^",
        FontColor->RGBColor[0, 0.6, 0]]], "-"]], ")"}], "2"], "\[Equal]", 
  RowBox[{
   RowBox[{"-", 
    FractionBox[
     SubsuperscriptBox[
      StyleBox["Y",
       FontColor->RGBColor[0, 0, 0.8]], 
      RowBox[{"2", ",", "2"}], "+"], 
     SubsuperscriptBox[
      StyleBox["Y",
       FontColor->RGBColor[0, 0, 0.8]], 
      RowBox[{"2", ",", "2"}], "-"]]}], 
   FractionBox[
    RowBox[{
     SubsuperscriptBox[
      StyleBox["\[ScriptCapitalT]",
       FontColor->RGBColor[1, 0, 0]], 
      RowBox[{"1", ",", "2"}], "+"], " "}], 
    RowBox[{
     SubsuperscriptBox[
      StyleBox["\[ScriptCapitalT]",
       FontColor->RGBColor[1, 0, 0]], 
      RowBox[{"1", ",", "2"}], "-"], " "}]], 
   FractionBox[
    RowBox[{
     SuperscriptBox[
      OverscriptBox[
       StyleBox["\[ScriptCapitalT]",
        FontColor->RGBColor[1, 0, 0]], 
       StyleBox["^",
        FontColor->RGBColor[1, 0, 0]]], 
      RowBox[{"[", 
       RowBox[{"-", "2"}], "]"}]], " "}], 
    SuperscriptBox[
     OverscriptBox[
      StyleBox["\[ScriptCapitalT]",
       FontColor->RGBColor[1, 0, 0]], 
      StyleBox["^",
       FontColor->RGBColor[1, 0, 0]]], 
     RowBox[{"[", 
      RowBox[{"+", "2"}], "]"}]]]}]}]], "Input",
 CellChangeTimes->{{3.550212444414013*^9, 3.550212452015951*^9}}],

Cell["\<\
The form which is really used  in the computation\
\>", "Text",
 CellChangeTimes->{{3.552205162855936*^9, 3.5522051733980722`*^9}, {
  3.568967911092264*^9, 3.568967915811652*^9}}],

Cell[BoxData[
 RowBox[{
  SuperscriptBox[
   RowBox[{"(", 
    FractionBox[
     SuperscriptBox[
      OverscriptBox[
       StyleBox["h",
        FontColor->RGBColor[0, 0.6, 0]], 
       StyleBox["^",
        FontColor->RGBColor[0, 0.6, 0]]], "+"], 
     SuperscriptBox[
      OverscriptBox[
       StyleBox["h",
        FontColor->RGBColor[0, 0.6, 0]], 
       StyleBox["^",
        FontColor->RGBColor[0, 0.6, 0]]], "-"]], ")"}], "2"], "\[Equal]", 
  RowBox[{
   RowBox[{"-", 
    FractionBox[
     SqrtBox[
      FractionBox[
       SuperscriptBox[
        RowBox[{"(", 
         RowBox[{
          SubscriptBox[
           StyleBox["Y",
            FontColor->RGBColor[0, 0, 0.8]], 
           RowBox[{"1", ",", "1"}]], 
          SubscriptBox[
           StyleBox["Y",
            FontColor->RGBColor[0, 0, 0.8]], 
           RowBox[{"2", ",", "2"}]]}], ")"}], "+"], 
       SuperscriptBox[
        RowBox[{"(", 
         RowBox[{
          SubscriptBox[
           StyleBox["Y",
            FontColor->RGBColor[0, 0, 0.8]], 
           RowBox[{"1", ",", "1"}]], 
          SubscriptBox[
           StyleBox["Y",
            FontColor->RGBColor[0, 0, 0.8]], 
           RowBox[{"2", ",", "2"}]]}], ")"}], "-"]]], 
     SqrtBox[
      FractionBox[
       SuperscriptBox[
        RowBox[{"(", 
         RowBox[{
          FractionBox[
           SubscriptBox[
            StyleBox["Y",
             FontColor->RGBColor[0, 0, 0.8]], 
            RowBox[{"1", ",", "1"}]], 
           SubscriptBox["Y", 
            RowBox[{"2", ",", "2"}]]], 
          FractionBox[
           SubsuperscriptBox[
            StyleBox["\[GothicCapitalT]",
             FontColor->RGBColor[0.54, 0.35, 0.15]], 
            RowBox[{"2", ",", "1"}], "2"], 
           SubsuperscriptBox[
            StyleBox["\[ScriptCapitalT]",
             FontColor->RGBColor[1, 0, 0]], 
            RowBox[{"1", ",", "2"}], "2"]]}], ")"}], "+"], 
       SuperscriptBox[
        RowBox[{"(", 
         RowBox[{
          FractionBox[
           SubscriptBox[
            StyleBox["Y",
             FontColor->RGBColor[0, 0, 0.8]], 
            RowBox[{"1", ",", "1"}]], 
           SubscriptBox["Y", 
            RowBox[{"2", ",", "2"}]]], 
          FractionBox[
           SubsuperscriptBox[
            StyleBox["\[GothicCapitalT]",
             FontColor->RGBColor[0.54, 0.35, 0.15]], 
            RowBox[{"2", ",", "1"}], "2"], 
           SubsuperscriptBox[
            StyleBox["\[ScriptCapitalT]",
             FontColor->RGBColor[1, 0, 0]], 
            RowBox[{"1", ",", "2"}], "2"]]}], ")"}], "-"]]]]}], 
   FractionBox[
    SuperscriptBox[
     RowBox[{"(", 
      SubscriptBox[
       StyleBox["\[GothicCapitalT]",
        FontColor->RGBColor[0.54, 0.35, 0.15]], 
       RowBox[{"2", ",", "1"}]], ")"}], "+"], 
    SuperscriptBox[
     RowBox[{"(", 
      SubscriptBox[
       StyleBox["\[GothicCapitalT]",
        FontColor->RGBColor[0.54, 0.35, 0.15]], 
       RowBox[{"2", ",", "1"}]], ")"}], "-"]], 
   FractionBox[
    RowBox[{
     SuperscriptBox[
      OverscriptBox[
       StyleBox["\[ScriptCapitalT]",
        FontColor->RGBColor[1, 0, 0]], 
       StyleBox["^",
        FontColor->RGBColor[1, 0, 0]]], 
      RowBox[{"[", 
       RowBox[{"-", "2"}], "]"}]], " "}], 
    SuperscriptBox[
     OverscriptBox[
      StyleBox["\[ScriptCapitalT]",
       FontColor->RGBColor[1, 0, 0]], 
      StyleBox["^",
       FontColor->RGBColor[1, 0, 0]]], 
     RowBox[{"[", 
      RowBox[{"+", "2"}], "]"}]]]}]}]], "Input",
 CellChangeTimes->{{3.552205181043242*^9, 3.552205217682931*^9}, {
  3.5522052656677628`*^9, 3.5522053298096657`*^9}}],

Cell[TextData[{
 "Integrals for ",
 Cell[BoxData[
  FormBox[
   SubscriptBox["Y", 
    RowBox[{"1", ",", "1"}]], TraditionalForm]],
  FormatType->"TraditionalForm"],
 " and ",
 Cell[BoxData[
  FormBox[
   SubscriptBox["Y", 
    RowBox[{"2", ",", "2"}]], TraditionalForm]],
  FormatType->"TraditionalForm"],
 " can be conveniently combined:"
}], "Text",
 CellChangeTimes->{{3.5537752944149017`*^9, 3.5537753083407087`*^9}}],

Cell[BoxData[{
 FormBox[
  RowBox[{
   RowBox[{
    RowBox[{"(", 
     RowBox[{"D", "-", 
      SuperscriptBox["D", 
       RowBox[{"-", "1"}]]}], ")"}], 
    RowBox[{"Log", "[", " ", 
     RowBox[{"(", 
      FractionBox[
       RowBox[{
        SubscriptBox[
         StyleBox["Y",
          FontColor->RGBColor[0, 0, 0.8]], 
         RowBox[{"1", ",", "1"}]], " ", 
        SubscriptBox[
         StyleBox["Y",
          FontColor->RGBColor[0, 0, 0.8]], 
         RowBox[{"2", ",", "2"}]]}], 
       SubscriptBox[
        RowBox[{"(", 
         RowBox[{
          SubscriptBox["Y", 
           RowBox[{"1", ",", "1"}]], 
          SubscriptBox["Y", 
           RowBox[{"2", ",", "2"}]]}], ")"}], "asym"]], ")"}], "]"}]}], 
   "\[Equal]", 
   RowBox[{
    RowBox[{
     RowBox[{"(", 
      RowBox[{"D", "-", 
       SuperscriptBox["D", 
        RowBox[{"-", "1"}]]}], ")"}], 
     RowBox[{"Log", "[", 
      FractionBox[
       SubscriptBox[
        StyleBox["\[GothicCapitalT]",
         FontColor->RGBColor[0.54, 0.35, 0.15]], 
        RowBox[{"1", ",", "0"}]], 
       SubscriptBox[
        RowBox[{
         StyleBox["(",
          FontColor->RGBColor[0.54, 0.35, 0.15]], 
         SubscriptBox[
          StyleBox["\[GothicCapitalT]",
           FontColor->RGBColor[0.54, 0.35, 0.15]], 
          RowBox[{"1", ",", "0"}]], ")"}], "asym"]], "]"}]}], "-", 
    RowBox[{"2", 
     RowBox[{
      SubsuperscriptBox["\[Integral]", 
       RowBox[{
        RowBox[{"-", "\[Infinity]"}], "-", 
        RowBox[{"\[ImaginaryI]", " ", "0"}]}], 
       RowBox[{
        RowBox[{"+", "\[Infinity]"}], "-", 
        RowBox[{"\[ImaginaryI]", " ", "0"}]}]], 
      RowBox[{
       FractionBox["dv", 
        RowBox[{
         RowBox[{"-", "2"}], "\[Pi]", " ", "\[ImaginaryI]"}]], 
       FractionBox[
        RowBox[{"Kr1", "+", 
         RowBox[{
          SuperscriptBox["v", "2"], "Kr2"}]}], 
        RowBox[{
         SuperscriptBox[
          StyleBox["Q",
           FontColor->RGBColor[0.8, 0, 0]], "-"], " ", 
         SuperscriptBox[
          StyleBox["Q",
           FontColor->RGBColor[0.8, 0, 0]], "+"]}]], 
       FractionBox["H", 
        SqrtBox[
         RowBox[{"1", "-", 
          FractionBox[
           RowBox[{"4", 
            SuperscriptBox["g", "2"]}], 
           SuperscriptBox["v", "2"]]}]]]}]}]}]}]}], 
  TraditionalForm], "\[IndentingNewLine]", 
 FormBox[
  RowBox[{
   RowBox[{
    RowBox[{"-", 
     RowBox[{"(", 
      RowBox[{"D", "-", 
       SuperscriptBox["D", 
        RowBox[{"-", "1"}]]}], ")"}]}], 
    RowBox[{"Log", "[", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        FractionBox[
         SubscriptBox["Y", 
          RowBox[{"1", ",", "1"}]], 
         SubscriptBox["Y", 
          RowBox[{"2", ",", "2"}]]], 
        FractionBox[
         SubsuperscriptBox[
          StyleBox["\[GothicCapitalT]",
           FontColor->RGBColor[0.54, 0.35, 0.15]], 
          RowBox[{"2", ",", "1"}], "2"], 
         SubsuperscriptBox[
          StyleBox["\[ScriptCapitalT]",
           FontColor->RGBColor[1, 0, 0]], 
          RowBox[{"1", ",", "2"}], "2"]]}], ")"}], "/", 
      SubscriptBox[
       RowBox[{"(", 
        RowBox[{
         FractionBox[
          SubscriptBox["Y", 
           RowBox[{"1", ",", "1"}]], 
          SubscriptBox["Y", 
           RowBox[{"2", ",", "2"}]]], 
         FractionBox[
          SubsuperscriptBox[
           StyleBox["\[GothicCapitalT]",
            FontColor->RGBColor[0.54, 0.35, 0.15]], 
           RowBox[{"2", ",", "1"}], "2"], 
          SubsuperscriptBox[
           StyleBox["\[ScriptCapitalT]",
            FontColor->RGBColor[1, 0, 0]], 
           RowBox[{"1", ",", "2"}], "2"]]}], ")"}], "asym"]}], "]"}]}], 
   "\[Equal]", 
   RowBox[{
    RowBox[{
     RowBox[{"-", 
      RowBox[{"(", 
       RowBox[{"D", "-", 
        SuperscriptBox["D", 
         RowBox[{"-", "1"}]]}], ")"}]}], 
     RowBox[{"Log", "[", 
      FractionBox[
       SubscriptBox[
        StyleBox["\[GothicCapitalT]",
         FontColor->RGBColor[0.54, 0.35, 0.15]], 
        RowBox[{"1", ",", "0"}]], 
       SubscriptBox[
        RowBox[{"(", 
         SubscriptBox[
          StyleBox["\[GothicCapitalT]",
           FontColor->RGBColor[0.54, 0.35, 0.15]], 
          RowBox[{"1", ",", "0"}]], ")"}], "asym"]], "]"}]}], "+", 
    RowBox[{"4", "\[ImaginaryI]", " ", 
     SubscriptBox["v", "0"], 
     RowBox[{
      SubsuperscriptBox["\[Integral]", 
       RowBox[{
        RowBox[{"-", "\[Infinity]"}], "-", 
        RowBox[{"\[ImaginaryI]", " ", "0"}]}], 
       RowBox[{
        RowBox[{"+", "\[Infinity]"}], "-", 
        RowBox[{"\[ImaginaryI]", " ", "0"}]}]], 
      RowBox[{
       FractionBox["dv", 
        RowBox[{
         RowBox[{"-", "2"}], "\[Pi]", " ", "\[ImaginaryI]"}]], 
       FractionBox["v", 
        RowBox[{
         SuperscriptBox[
          StyleBox["Q",
           FontColor->RGBColor[0.8, 0, 0]], "+"], " ", 
         SuperscriptBox[
          StyleBox["Q",
           FontColor->RGBColor[0.8, 0, 0]], "-"]}]], 
       RowBox[{"(", 
        RowBox[{"H", "-", 
         RowBox[{"2", 
          RowBox[{"Log", "[", 
           RowBox[{
            RowBox[{"(", 
             FractionBox[
              RowBox[{" ", 
               SuperscriptBox[
                StyleBox["\[ScriptCapitalT]",
                 FontColor->RGBColor[1, 0, 0]], "+"], " "}], 
              SuperscriptBox[
               StyleBox["\[GothicCapitalT]",
                FontColor->RGBColor[0.54, 0.35, 0.15]], "+"]], ")"}], "/", 
            SubscriptBox[
             RowBox[{"(", 
              FractionBox[
               RowBox[{" ", 
                SuperscriptBox[
                 StyleBox["\[ScriptCapitalT]",
                  FontColor->RGBColor[1, 0, 0]], "+"], " "}], 
               SuperscriptBox[
                StyleBox["\[GothicCapitalT]",
                 FontColor->RGBColor[0.54, 0.35, 0.15]], "+"]], ")"}], 
             "asym"]}], "]"}]}]}], ")"}]}]}]}]}]}], 
  TraditionalForm]}], "Input",
 CellChangeTimes->{{3.553775351468223*^9, 3.553775361403623*^9}}],

Cell[BoxData[
 FormBox[
  RowBox[{
   RowBox[{
    FractionBox["1", "2"], 
    RowBox[{"(", 
     RowBox[{"D", "-", 
      SuperscriptBox["D", 
       RowBox[{"-", "1"}]]}], ")"}], 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"Log", "[", " ", 
       RowBox[{"(", 
        FractionBox[
         RowBox[{
          SubscriptBox[
           StyleBox["Y",
            FontColor->RGBColor[0, 0, 0.8]], 
           RowBox[{"1", ",", "1"}]], " ", 
          SubscriptBox[
           StyleBox["Y",
            FontColor->RGBColor[0, 0, 0.8]], 
           RowBox[{"2", ",", "2"}]]}], 
         SubscriptBox[
          RowBox[{"(", 
           RowBox[{
            SubscriptBox["Y", 
             RowBox[{"1", ",", "1"}]], 
            SubscriptBox["Y", 
             RowBox[{"2", ",", "2"}]]}], ")"}], "asym"]], ")"}], "]"}], "-", 
      RowBox[{"Log", "[", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          FractionBox[
           SubscriptBox["Y", 
            RowBox[{"1", ",", "1"}]], 
           SubscriptBox["Y", 
            RowBox[{"2", ",", "2"}]]], 
          FractionBox[
           SubsuperscriptBox[
            StyleBox["\[GothicCapitalT]",
             FontColor->RGBColor[0.54, 0.35, 0.15]], 
            RowBox[{"2", ",", "1"}], "2"], 
           SubsuperscriptBox[
            StyleBox["\[ScriptCapitalT]",
             FontColor->RGBColor[1, 0, 0]], 
            RowBox[{"1", ",", "2"}], "2"]]}], ")"}], "/", 
        SubscriptBox[
         RowBox[{"(", 
          RowBox[{
           FractionBox[
            SubscriptBox["Y", 
             RowBox[{"1", ",", "1"}]], 
            SubscriptBox["Y", 
             RowBox[{"2", ",", "2"}]]], 
           FractionBox[
            SubsuperscriptBox[
             StyleBox["\[GothicCapitalT]",
              FontColor->RGBColor[0.54, 0.35, 0.15]], 
             RowBox[{"2", ",", "1"}], "2"], 
            SubsuperscriptBox[
             StyleBox["\[ScriptCapitalT]",
              FontColor->RGBColor[1, 0, 0]], 
             RowBox[{"1", ",", "2"}], "2"]]}], ")"}], "asym"]}], "]"}]}], 
     ")"}]}], "\[Equal]", 
   RowBox[{
    RowBox[{"+", 
     RowBox[{
      SubsuperscriptBox["\[Integral]", 
       RowBox[{
        RowBox[{"-", "\[Infinity]"}], "-", 
        RowBox[{"\[ImaginaryI]", " ", "0"}]}], 
       RowBox[{
        RowBox[{"+", "\[Infinity]"}], "-", 
        RowBox[{"\[ImaginaryI]", " ", "0"}]}]], 
      RowBox[{
       FractionBox["dv", 
        RowBox[{
         RowBox[{"-", "2"}], "\[Pi]", " ", "\[ImaginaryI]"}]], 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", 
          FractionBox[
           RowBox[{"(", 
            RowBox[{"Kr1", "+", 
             RowBox[{
              SuperscriptBox["v", "2"], "Kr2"}]}], ")"}], 
           SqrtBox[
            RowBox[{"1", "-", 
             FractionBox[
              RowBox[{"4", 
               SuperscriptBox["g", "2"]}], 
              SuperscriptBox["v", "2"]]}]]]}], "+", 
         RowBox[{"2", "\[ImaginaryI]", " ", 
          SubscriptBox["v", "0"], " ", "v"}]}], ")"}], 
       FractionBox["H", 
        RowBox[{
         SuperscriptBox[
          StyleBox["Q",
           FontColor->RGBColor[0.8, 0, 0]], "-"], " ", 
         SuperscriptBox[
          StyleBox["Q",
           FontColor->RGBColor[0.8, 0, 0]], "+"]}]]}]}]}], "-", 
    RowBox[{"4", "\[ImaginaryI]", " ", 
     SubscriptBox["v", "0"], 
     RowBox[{
      SubsuperscriptBox["\[Integral]", 
       RowBox[{
        RowBox[{"-", "\[Infinity]"}], "-", 
        RowBox[{"\[ImaginaryI]", " ", "0"}]}], 
       RowBox[{
        RowBox[{"+", "\[Infinity]"}], "-", 
        RowBox[{"\[ImaginaryI]", " ", "0"}]}]], 
      RowBox[{
       FractionBox["dv", 
        RowBox[{
         RowBox[{"-", "2"}], "\[Pi]", " ", "\[ImaginaryI]"}]], 
       FractionBox["v", 
        RowBox[{
         SuperscriptBox[
          StyleBox["Q",
           FontColor->RGBColor[0.8, 0, 0]], "+"], " ", 
         SuperscriptBox[
          StyleBox["Q",
           FontColor->RGBColor[0.8, 0, 0]], "-"]}]], " ", 
       RowBox[{"Log", "[", 
        RowBox[{
         RowBox[{"(", 
          FractionBox[
           RowBox[{" ", 
            SuperscriptBox[
             StyleBox["\[ScriptCapitalT]",
              FontColor->RGBColor[1, 0, 0]], "+"], " "}], 
           SuperscriptBox[
            StyleBox["\[GothicCapitalT]",
             FontColor->RGBColor[0.54, 0.35, 0.15]], "+"]], ")"}], "/", 
         SubscriptBox[
          RowBox[{"(", 
           FractionBox[
            RowBox[{" ", 
             SuperscriptBox[
              StyleBox["\[ScriptCapitalT]",
               FontColor->RGBColor[1, 0, 0]], "+"], " "}], 
            SuperscriptBox[
             StyleBox["\[GothicCapitalT]",
              FontColor->RGBColor[0.54, 0.35, 0.15]], "+"]], ")"}], "asym"]}],
         "]"}]}]}]}]}]}], TraditionalForm]], "Input",
 CellChangeTimes->{{3.553775383172915*^9, 3.553775509975719*^9}, 
   3.553828570979607*^9, {3.553835450106105*^9, 3.553835464422566*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{
     SuperscriptBox["g", "8"], "m"}], "+", 
    RowBox[{
     SuperscriptBox["g", "10"], "m2"}], "+"}], "..."}], "\[Equal]", 
  RowBox[{
   RowBox[{"-", 
    RowBox[{"Log", "[", 
     RowBox[{
      SuperscriptBox[
       RowBox[{"(", 
        FractionBox[
         SuperscriptBox[
          OverscriptBox[
           StyleBox["h",
            FontColor->RGBColor[0, 0.6, 0]], 
           StyleBox["^",
            FontColor->RGBColor[0, 0.6, 0]]], "+"], 
         SuperscriptBox[
          OverscriptBox[
           StyleBox["h",
            FontColor->RGBColor[0, 0.6, 0]], 
           StyleBox["^",
            FontColor->RGBColor[0, 0.6, 0]]], "-"]], ")"}], "2"], "/", 
      SuperscriptBox[
       SubscriptBox[
        RowBox[{"(", 
         FractionBox[
          SuperscriptBox[
           OverscriptBox[
            StyleBox["h",
             FontColor->RGBColor[0, 0.6, 0]], 
            StyleBox["^",
             FontColor->RGBColor[0, 0.6, 0]]], "+"], 
          SuperscriptBox[
           OverscriptBox[
            StyleBox["h",
             FontColor->RGBColor[0, 0.6, 0]], 
            StyleBox["^",
             FontColor->RGBColor[0, 0.6, 0]]], "-"]], ")"}], "asym"], "2"]}], 
     "]"}]}], "+", 
   RowBox[{"Log", "[", 
    FractionBox[
     FractionBox[
      RowBox[{
       SuperscriptBox[
        OverscriptBox[
         StyleBox["\[ScriptCapitalT]",
          FontColor->RGBColor[1, 0, 0]], 
         StyleBox["^",
          FontColor->RGBColor[1, 0, 0]]], 
        RowBox[{"[", 
         RowBox[{"-", "2"}], "]"}]], " "}], 
      SuperscriptBox[
       OverscriptBox[
        StyleBox["\[ScriptCapitalT]",
         FontColor->RGBColor[1, 0, 0]], 
        StyleBox["^",
         FontColor->RGBColor[1, 0, 0]]], 
       RowBox[{"[", 
        RowBox[{"+", "2"}], "]"}]]], 
     SubscriptBox[
      RowBox[{"(", 
       FractionBox[
        RowBox[{
         SuperscriptBox[
          OverscriptBox[
           StyleBox["\[ScriptCapitalT]",
            FontColor->RGBColor[1, 0, 0]], 
           StyleBox["^",
            FontColor->RGBColor[1, 0, 0]]], 
          RowBox[{"[", 
           RowBox[{"-", "2"}], "]"}]], " "}], 
        SuperscriptBox[
         OverscriptBox[
          StyleBox["\[ScriptCapitalT]",
           FontColor->RGBColor[1, 0, 0]], 
          StyleBox["^",
           FontColor->RGBColor[1, 0, 0]]], 
         RowBox[{"[", 
          RowBox[{"+", "2"}], "]"}]]], ")"}], "asym"]], "]"}], "+", 
   RowBox[{"Log", "[", 
    FractionBox[
     FractionBox[
      SuperscriptBox[
       RowBox[{"(", 
        SubscriptBox[
         StyleBox["\[GothicCapitalT]",
          FontColor->RGBColor[0.54, 0.35, 0.15]], 
         RowBox[{"2", ",", "1"}]], ")"}], "+"], 
      SuperscriptBox[
       RowBox[{"(", 
        SubscriptBox[
         StyleBox["\[GothicCapitalT]",
          FontColor->RGBColor[0.54, 0.35, 0.15]], 
         RowBox[{"2", ",", "1"}]], ")"}], "-"]], 
     SubscriptBox[
      RowBox[{"(", 
       FractionBox[
        SuperscriptBox[
         RowBox[{"(", 
          SubscriptBox[
           StyleBox["\[GothicCapitalT]",
            FontColor->RGBColor[0.54, 0.35, 0.15]], 
           RowBox[{"2", ",", "1"}]], ")"}], "+"], 
        SuperscriptBox[
         RowBox[{"(", 
          SubscriptBox[
           StyleBox["\[GothicCapitalT]",
            FontColor->RGBColor[0.54, 0.35, 0.15]], 
           RowBox[{"2", ",", "1"}]], ")"}], "-"]], ")"}], "asym"]], "]"}], 
   "+", 
   RowBox[{"\[DoubleStruckCapitalC]", "[", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{"-", 
        FractionBox[
         RowBox[{"(", 
          RowBox[{"Kr1", "+", 
           RowBox[{
            SuperscriptBox["v", "2"], "Kr2"}]}], ")"}], 
         SqrtBox[
          RowBox[{"1", "-", 
           FractionBox[
            RowBox[{"4", 
             SuperscriptBox["g", "2"]}], 
            SuperscriptBox["v", "2"]]}]]]}], "+", 
       RowBox[{"2", "\[ImaginaryI]", " ", 
        SubscriptBox["v", "0"], " ", "v"}]}], ")"}], 
     FractionBox["H", 
      RowBox[{
       SuperscriptBox[
        StyleBox["Q",
         FontColor->RGBColor[0.8, 0, 0]], "-"], " ", 
       SuperscriptBox[
        StyleBox["Q",
         FontColor->RGBColor[0.8, 0, 0]], "+"]}]]}], "]"}], "+", 
   RowBox[{"\[DoubleStruckCapitalC]", "[", 
    RowBox[{
     FractionBox[
      RowBox[{
       RowBox[{"-", "4"}], "\[ImaginaryI]", " ", 
       SubscriptBox["v", "0"], "v"}], 
      RowBox[{
       SuperscriptBox[
        StyleBox["Q",
         FontColor->RGBColor[0.8, 0, 0]], "+"], " ", 
       SuperscriptBox[
        StyleBox["Q",
         FontColor->RGBColor[0.8, 0, 0]], "-"]}]], 
     RowBox[{"Log", "[", 
      RowBox[{
       RowBox[{"(", 
        FractionBox[
         RowBox[{" ", 
          SuperscriptBox[
           StyleBox["\[ScriptCapitalT]",
            FontColor->RGBColor[1, 0, 0]], "+"], " "}], 
         SuperscriptBox[
          StyleBox["\[GothicCapitalT]",
           FontColor->RGBColor[0.54, 0.35, 0.15]], "+"]], ")"}], "/", 
       SubscriptBox[
        RowBox[{"(", 
         FractionBox[
          RowBox[{" ", 
           SuperscriptBox[
            StyleBox["\[ScriptCapitalT]",
             FontColor->RGBColor[1, 0, 0]], "+"], " "}], 
          SuperscriptBox[
           StyleBox["\[GothicCapitalT]",
            FontColor->RGBColor[0.54, 0.35, 0.15]], "+"]], ")"}], "asym"]}], 
      "]"}]}], "]"}]}]}]], "Input",
 CellChangeTimes->{{3.553775524449216*^9, 3.553775575150013*^9}, {
   3.553775653575102*^9, 3.553775669355048*^9}, 3.553828617589128*^9, {
   3.553835479511333*^9, 3.553835512876645*^9}, {3.568967956547711*^9, 
   3.568967959406912*^9}}],

Cell[BoxData[
 RowBox[{"(*", 
  RowBox[{"subKr", "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"Kr1", "\[Rule]", " ", 
      RowBox[{"g", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          SuperscriptBox[
           RowBox[{"(", 
            RowBox[{
             SubscriptBox["v", "0"], "+", 
             FractionBox["\[ImaginaryI]", "2"]}], ")"}], "2"], 
          RowBox[{"(", 
           RowBox[{
            SuperscriptBox[
             OverscriptBox["y", "^"], "-"], "-", 
            FractionBox["1", 
             SuperscriptBox[
              OverscriptBox["y", "^"], "-"]]}], ")"}]}], "+", 
         RowBox[{
          SuperscriptBox[
           RowBox[{"(", 
            RowBox[{
             SubscriptBox["v", "0"], "-", 
             FractionBox["\[ImaginaryI]", "2"]}], ")"}], "2"], 
          RowBox[{"(", 
           RowBox[{
            SuperscriptBox[
             OverscriptBox["y", "^"], "+"], "-", 
            FractionBox["1", 
             SuperscriptBox[
              OverscriptBox["y", "^"], "+"]]}], ")"}]}]}], ")"}]}]}], ",", 
     RowBox[{"Kr2", "\[Rule]", " ", 
      RowBox[{
       RowBox[{"-", "g"}], 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"+", 
          SuperscriptBox[
           OverscriptBox["y", "^"], "+"]}], "-", 
         FractionBox["1", 
          SuperscriptBox[
           OverscriptBox["y", "^"], "+"]], "+", 
         SuperscriptBox[
          OverscriptBox["y", "^"], "-"], "-", 
         FractionBox["1", 
          SuperscriptBox[
           OverscriptBox["y", "^"], "-"]]}], ")"}]}]}]}], "}"}]}], 
  "*)"}]], "Input",
 CellChangeTimes->{{3.554045670770096*^9, 3.554045707386589*^9}, {
  3.5540457769470987`*^9, 3.554045778058028*^9}}],

Cell["\<\
Kr1 and Kr2 are written into stylepackage.m inside subsupl substition.\
\>", "Text",
 CellChangeTimes->{{3.554045782284917*^9, 3.554045801884191*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"{", 
   RowBox[{"Kr1", ",", "Kr2"}], "}"}], "/.", "subsupl"}]], "Input",
 CellChangeTimes->{{3.554045804535224*^9, 3.5540458128621264`*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{
    FractionBox["1", "8"], " ", 
    RowBox[{"(", 
     RowBox[{"1", "+", 
      RowBox[{"4", " ", 
       SubsuperscriptBox["v", "0", "2"]}]}], ")"}], " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"\[ImaginaryI]", " ", 
       SqrtBox[
        RowBox[{"1", "-", 
         FractionBox[
          RowBox[{"4", " ", 
           SuperscriptBox["g", "2"]}], 
          SuperscriptBox[
           RowBox[{"(", 
            RowBox[{
             RowBox[{"-", 
              FractionBox["\[ImaginaryI]", "2"]}], "+", 
             SubscriptBox["v", "0"]}], ")"}], "2"]]}]]}], "+", 
      RowBox[{"2", " ", 
       SubscriptBox["v", "0"], " ", 
       SqrtBox[
        RowBox[{"1", "-", 
         FractionBox[
          RowBox[{"4", " ", 
           SuperscriptBox["g", "2"]}], 
          SuperscriptBox[
           RowBox[{"(", 
            RowBox[{
             RowBox[{"-", 
              FractionBox["\[ImaginaryI]", "2"]}], "+", 
             SubscriptBox["v", "0"]}], ")"}], "2"]]}]]}], "-", 
      RowBox[{"\[ImaginaryI]", " ", 
       SqrtBox[
        RowBox[{"1", "-", 
         FractionBox[
          RowBox[{"4", " ", 
           SuperscriptBox["g", "2"]}], 
          SuperscriptBox[
           RowBox[{"(", 
            RowBox[{
             FractionBox["\[ImaginaryI]", "2"], "+", 
             SubscriptBox["v", "0"]}], ")"}], "2"]]}]]}], "+", 
      RowBox[{"2", " ", 
       SubscriptBox["v", "0"], " ", 
       SqrtBox[
        RowBox[{"1", "-", 
         FractionBox[
          RowBox[{"4", " ", 
           SuperscriptBox["g", "2"]}], 
          SuperscriptBox[
           RowBox[{"(", 
            RowBox[{
             FractionBox["\[ImaginaryI]", "2"], "+", 
             SubscriptBox["v", "0"]}], ")"}], "2"]]}]]}]}], ")"}]}], ",", 
   RowBox[{
    FractionBox["1", "2"], " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"\[ImaginaryI]", " ", 
       SqrtBox[
        RowBox[{"1", "-", 
         FractionBox[
          RowBox[{"4", " ", 
           SuperscriptBox["g", "2"]}], 
          SuperscriptBox[
           RowBox[{"(", 
            RowBox[{
             RowBox[{"-", 
              FractionBox["\[ImaginaryI]", "2"]}], "+", 
             SubscriptBox["v", "0"]}], ")"}], "2"]]}]]}], "-", 
      RowBox[{"2", " ", 
       SubscriptBox["v", "0"], " ", 
       SqrtBox[
        RowBox[{"1", "-", 
         FractionBox[
          RowBox[{"4", " ", 
           SuperscriptBox["g", "2"]}], 
          SuperscriptBox[
           RowBox[{"(", 
            RowBox[{
             RowBox[{"-", 
              FractionBox["\[ImaginaryI]", "2"]}], "+", 
             SubscriptBox["v", "0"]}], ")"}], "2"]]}]]}], "-", 
      RowBox[{"\[ImaginaryI]", " ", 
       SqrtBox[
        RowBox[{"1", "-", 
         FractionBox[
          RowBox[{"4", " ", 
           SuperscriptBox["g", "2"]}], 
          SuperscriptBox[
           RowBox[{"(", 
            RowBox[{
             FractionBox["\[ImaginaryI]", "2"], "+", 
             SubscriptBox["v", "0"]}], ")"}], "2"]]}]]}], "-", 
      RowBox[{"2", " ", 
       SubscriptBox["v", "0"], " ", 
       SqrtBox[
        RowBox[{"1", "-", 
         FractionBox[
          RowBox[{"4", " ", 
           SuperscriptBox["g", "2"]}], 
          SuperscriptBox[
           RowBox[{"(", 
            RowBox[{
             FractionBox["\[ImaginaryI]", "2"], "+", 
             SubscriptBox["v", "0"]}], ")"}], "2"]]}]]}]}], ")"}]}]}], 
  "}"}]], "Output",
 CellChangeTimes->{{3.554045809166357*^9, 3.554045813281777*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"yh", "-", 
    FractionBox["1", "yh"]}], "/.", "subJuk"}], "//", 
  "FullSimplify"}]], "Input",
 CellChangeTimes->{{3.554046806870677*^9, 3.554046820942216*^9}}],

Cell[BoxData[
 FractionBox[
  RowBox[{
   SqrtBox[
    RowBox[{
     RowBox[{
      RowBox[{"-", "2"}], " ", "g"}], "+", 
     SubscriptBox["v", "0"]}]], " ", 
   SqrtBox[
    RowBox[{
     RowBox[{"2", " ", "g"}], "+", 
     SubscriptBox["v", "0"]}]]}], "g"]], "Output",
 CellChangeTimes->{{3.554046818176601*^9, 3.5540468214934273`*^9}}]
}, Open  ]],

Cell[BoxData[
 SqrtBox[
  RowBox[{
   SubsuperscriptBox["v", "0", "2"], "-", 
   RowBox[{"4", 
    SuperscriptBox["g", "2"]}]}]]], "Input",
 CellChangeTimes->{{3.554046832403882*^9, 3.5540468431746607`*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"-", 
   RowBox[{"Log", "[", 
    RowBox[{
     SuperscriptBox[
      RowBox[{"(", 
       FractionBox[
        SuperscriptBox[
         OverscriptBox[
          StyleBox["h",
           FontColor->RGBColor[0, 0.6, 0]], 
          StyleBox["^",
           FontColor->RGBColor[0, 0.6, 0]]], "+"], 
        SuperscriptBox[
         OverscriptBox[
          StyleBox["h",
           FontColor->RGBColor[0, 0.6, 0]], 
          StyleBox["^",
           FontColor->RGBColor[0, 0.6, 0]]], "-"]], ")"}], "2"], "/", 
     SuperscriptBox[
      SubscriptBox[
       RowBox[{"(", 
        FractionBox[
         SuperscriptBox[
          OverscriptBox[
           StyleBox["h",
            FontColor->RGBColor[0, 0.6, 0]], 
           StyleBox["^",
            FontColor->RGBColor[0, 0.6, 0]]], "+"], 
         SuperscriptBox[
          OverscriptBox[
           StyleBox["h",
            FontColor->RGBColor[0, 0.6, 0]], 
           StyleBox["^",
            FontColor->RGBColor[0, 0.6, 0]]], "-"]], ")"}], "asym"], "2"]}], 
    "]"}]}], "\[Equal]", 
  RowBox[{"-", 
   RowBox[{"(", 
    RowBox[{
    "conth\[Rho]", "+", "conthY11Y22", "+", "conth\[ScriptCapitalF]"}], 
    ")"}]}]}]], "Subsection",
 CellChangeTimes->{{3.552193297070553*^9, 3.5521933034819736`*^9}, {
   3.552205941187338*^9, 3.5522059414016953`*^9}, {3.5523672032119102`*^9, 
   3.552367210500926*^9}, {3.553772156125369*^9, 3.553772174865464*^9}, {
   3.553775562934312*^9, 3.553775563607533*^9}, {3.555874071749701*^9, 
   3.5558741029420433`*^9}, {3.555957685930942*^9, 3.5559577071023817`*^9}, {
   3.5635134813285503`*^9, 3.563513486019833*^9}, 3.568968280387236*^9}],

Cell[TextData[{
 "Asymptotically one found (up to an overall constant ",
 Cell[BoxData[
  FormBox[
   RowBox[{
    SubscriptBox["hh", "as"], "=", 
    RowBox[{
     SubscriptBox["\[Sigma]", "1"], 
     SuperscriptBox["xh", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{
         RowBox[{"-", "L"}], "/", "2"}], "-", "1"}], "}"}]]}]}], 
   TraditionalForm]]],
 "."
}], "Text",
 CellChangeTimes->{{3.552193343869741*^9, 3.552193372875533*^9}}],

Cell["We hence have to compute", "Text",
 CellChangeTimes->{{3.552193376010419*^9, 3.5521933786827497`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Log", "[", 
   SubscriptBox[
    RowBox[{"(", 
     OverscriptBox[
      StyleBox["h",
       FontColor->RGBColor[0, 0.6, 0]], 
      StyleBox["^",
       FontColor->RGBColor[0, 0.6, 0]]], ")"}], "r"], "]"}], "==", 
  RowBox[{"Log", "[", " ", 
   FractionBox[
    RowBox[{
     OverscriptBox[
      StyleBox["h",
       FontColor->RGBColor[0, 0.6, 0]], 
      StyleBox["^",
       FontColor->RGBColor[0, 0.6, 0]]], " ", 
     SuperscriptBox[
      OverscriptBox[
       StyleBox["x",
        FontColor->RGBColor[0, 0.6, 0]], 
       StyleBox["^",
        FontColor->RGBColor[0, 0.6, 0]]], 
      RowBox[{
       FractionBox["L", "2"], "+", "1"}]]}], 
    SubscriptBox["\[Sigma]", "1"]], "]"}], "==", 
  RowBox[{"\[ScriptCapitalZ]", "*", 
   RowBox[{"Log", "[", 
    SubscriptBox[
     RowBox[{"(", 
      FractionBox[
       RowBox[{
        SuperscriptBox[
         StyleBox["\[ScriptCapitalF]",
          FontColor->RGBColor[0, 0.6, 0]], "+"], 
        RowBox[{"(", 
         RowBox[{"1", "-", 
          RowBox[{
           SubscriptBox["Y", 
            RowBox[{"1", ",", "1"}]], 
           SubscriptBox["Y", 
            RowBox[{"2", ",", "2"}]]}]}], ")"}]}], "\[Rho]"], ")"}], "r"], 
    "]"}]}]}]], "Input",
 CellChangeTimes->{{3.5479657623344088`*^9, 3.5479658621787853`*^9}, {
   3.547965923675784*^9, 3.5479659385131187`*^9}, 3.5521933809999647`*^9, {
   3.5635135939626617`*^9, 3.563513626760295*^9}}],

Cell[BoxData[
 RowBox[{"\[ScriptCapitalZ]", "==", 
  RowBox[{
   RowBox[{"-", 
    FractionBox["1", 
     RowBox[{"2", "\[Pi]", " ", "\[ImaginaryI]"}]]}], 
   FractionBox[
    SqrtBox[
     RowBox[{
      RowBox[{"4", 
       SuperscriptBox["g", "2"]}], "-", 
      SuperscriptBox["u", "2"]}]], 
    SqrtBox[
     RowBox[{
      RowBox[{"4", 
       SuperscriptBox["g", "2"]}], "-", 
      SuperscriptBox["v", "2"]}]]], 
   FractionBox["1", 
    RowBox[{"u", "-", "v"}]], 
   RowBox[{"\[DifferentialD]", "v"}]}], "==", 
  RowBox[{
   RowBox[{"-", 
    FractionBox["1", 
     RowBox[{"2", "\[Pi]", " ", "\[ImaginaryI]"}]]}], 
   FractionBox[
    SqrtBox[
     RowBox[{"1", "-", 
      SuperscriptBox[
       RowBox[{"(", 
        FractionBox["u", 
         RowBox[{"2", "g"}]], ")"}], "2"]}]], 
    SqrtBox[
     RowBox[{"1", "-", 
      SuperscriptBox["z", "2"]}]]], 
   FractionBox["1", 
    RowBox[{
     FractionBox["u", 
      RowBox[{"2", "g"}]], "-", "v"}]], 
   RowBox[{"\[DifferentialD]", "z"}]}]}]], "Input",
 CellChangeTimes->{{3.552193605054901*^9, 3.5521936258780107`*^9}, {
  3.563513513410804*^9, 3.5635135687427053`*^9}}],

Cell["\<\
Note that both in double scaling and ordinary scaling integrand is of double \
scaling form. This facilitates the consideration. Now, the overall \
normalization of h is not fixed by this equation (more precisely, it can be \
fixed but we won\[CloseCurlyQuote]t bother doing this). It should be fixed \
from original equation\
\>", "Text",
 CellChangeTimes->{{3.563513570587419*^9, 3.5635137010230017`*^9}, {
  3.568968081122245*^9, 3.5689680817012*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   SuperscriptBox["h", 
    RowBox[{"[", 
     RowBox[{"+", "o"}], "]"}]], 
   SuperscriptBox["h", 
    RowBox[{"[", 
     RowBox[{"-", "o"}], "]"}]]}], "==", 
  RowBox[{
   FractionBox[
    RowBox[{
     SuperscriptBox[
      StyleBox["\[ScriptCapitalF]",
       FontColor->RGBColor[0, 0.6, 0]], "+"], 
     RowBox[{"(", 
      RowBox[{"1", "-", 
       RowBox[{
        SubscriptBox["Y", 
         RowBox[{"1", ",", "1"}]], 
        SubscriptBox["Y", 
         RowBox[{"2", ",", "2"}]]}]}], ")"}]}], "\[Rho]"], 
   RowBox[{"(", "1", ")"}]}]}]], "Input",
 CellChangeTimes->{{3.563513705856812*^9, 3.563513715573667*^9}, {
  3.563514028309464*^9, 3.563514028789278*^9}}],

Cell["\<\
Here normalization of \[ScriptCapitalF] is also unknown. It comes in turn \
from the relation\
\>", "Text",
 CellChangeTimes->{{3.563513728534391*^9, 3.563513742841166*^9}}],

Cell[BoxData[
 RowBox[{
  StyleBox["\[ScriptCapitalF]",
   FontColor->RGBColor[0, 0.6, 0]], "\[Equal]", 
  RowBox[{
   StyleBox["f",
    FontColor->RGBColor[0, 0.6, 0]], 
   OverscriptBox[
    StyleBox["f",
     FontColor->RGBColor[0, 0.6, 0]], 
    StyleBox["_",
     FontColor->RGBColor[0, 0.6, 0]]], " ", 
   SqrtBox[
    SubscriptBox[
     StyleBox["\[GothicCapitalT]",
      FontColor->RGBColor[0.54, 0.35, 0.15]], 
     RowBox[{"0", ",", "0"}]]], " ", 
   RowBox[{"(", "2", ")"}]}]}]], "Input",
 CellChangeTimes->{{3.563513778517478*^9, 3.5635138455506268`*^9}, {
  3.563514026301703*^9, 3.5635140269008627`*^9}}],

Cell["\<\
So, the program is the following \
\>", "Text",
 CellChangeTimes->{{3.563513855738439*^9, 3.563513860488463*^9}}],

Cell[TextData[{
 "1. Compute ",
 Cell[BoxData[
  FormBox[
   SubscriptBox[
    RowBox[{"(", "\[ScriptCapitalF]", ")"}], "r"], TraditionalForm]]],
 " in the double scaling from integral represenation with Y11Y22. Separate \
odd-g pieces and even-g pieces (odd-g pieces are cancelled out after wards). \
Compare the answer with the double scaling of \[ScriptCapitalF] coming from \
eqn (2).\n2. Compute ",
 Cell[BoxData[
  FormBox[
   SubscriptBox[
    RowBox[{"(", 
     RowBox[{"1", "-", 
      RowBox[{
       SubscriptBox["Y", 
        RowBox[{"1", ",", "1"}]], 
       SubscriptBox["Y", 
        RowBox[{"2", ",", "2"}]]}]}], ")"}], "r"], TraditionalForm]]],
 "\n3. Compute \[Rho]. \n4. Compute density of ",
 Cell[BoxData[
  FormBox[
   SubscriptBox["h", "r"], TraditionalForm]]],
 ". Separate constant term. \n5. Restore h in normal and double scaling, \
including proper normalization"
}], "Text",
 CellChangeTimes->{{3.563513985892613*^9, 3.563514048946334*^9}, {
  3.5635140793056803`*^9, 3.563514220196373*^9}}],

Cell[CellGroupData[{

Cell[TextData[{
 "Contribution from ",
 Cell[BoxData[
  FormBox[
   RowBox[{
    RowBox[{"Log", "[", 
     FractionBox[
      SuperscriptBox[
       StyleBox["\[ScriptCapitalF]",
        FontColor->RGBColor[0, 0.6, 0]], "+"], 
      SubscriptBox[
       RowBox[{"(", 
        SuperscriptBox[
         StyleBox["\[ScriptCapitalF]",
          FontColor->RGBColor[0, 0.6, 0]], "+"], ")"}], "asym"]], "]"}], "=", 
    "conth\[ScriptCapitalF]"}], TraditionalForm]]]
}], "Subsubsection",
 CellChangeTimes->{{3.552194573693015*^9, 3.552194586631557*^9}, {
  3.552195423782762*^9, 3.552195451528096*^9}, {3.5521965050485697`*^9, 
  3.552196518074411*^9}, {3.552196569144054*^9, 3.552196575356393*^9}, {
  3.552205045118082*^9, 3.55220504515469*^9}, {3.555874436885995*^9, 
  3.555874443483198*^9}, {3.555928460336525*^9, 3.555928464641596*^9}}],

Cell["\<\
The point is to use integral equaiton:\
\>", "Text",
 CellChangeTimes->{{3.563514330356749*^9, 3.5635143372160177`*^9}}],

Cell[BoxData[
 RowBox[{
  SuperscriptBox["\[ScriptCapitalF]", "+"], "=", 
  RowBox[{
   SubscriptBox["\[CapitalLambda]", "F"], 
   RowBox[{
    SubscriptBox["\[Product]", "j"], 
    RowBox[{
     RowBox[{"(", 
      RowBox[{"\[ImaginaryI]", " ", 
       RowBox[{"Cosh", "[", 
        RowBox[{"\[Pi]", " ", 
         RowBox[{"(", 
          RowBox[{"u", "-", 
           SubscriptBox["u", "j"]}], ")"}]}], "]"}]}], ")"}], 
     RowBox[{"Exp", "[", 
      RowBox[{
       SubscriptBox["\[Integral]", 
        OverscriptBox["Z", "\[Vee]"]], 
       RowBox[{
        FractionBox["dv", 
         RowBox[{"2", "\[ImaginaryI]"}]], 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"Coth", "[", 
           RowBox[{"\[Pi]", 
            RowBox[{"(", 
             RowBox[{"u", "-", "v"}], ")"}]}], "]"}], "+", 
          RowBox[{"Sign", "[", "v", "]"}]}], ")"}], 
        RowBox[{"Log", "[", 
         RowBox[{
          SubscriptBox["Y", 
           RowBox[{"1", ",", "1"}]], 
          SubscriptBox["Y", 
           RowBox[{"2", ",", "2"}]]}], "]"}]}]}], "]"}]}]}]}]}]], "Input",
 CellChangeTimes->{{3.547966072743767*^9, 3.54796607412173*^9}, {
  3.547966236317339*^9, 3.547966294388851*^9}, {3.547966826922048*^9, 
  3.5479668505432377`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Log", "[", 
   SubsuperscriptBox[
    RowBox[{"(", "\[ScriptCapitalF]", ")"}], "r", "+"], "]"}], "=", 
  RowBox[{
   SubscriptBox["\[Integral]", 
    OverscriptBox["Z", "\[Vee]"]], 
   RowBox[{
    FractionBox["dv", 
     RowBox[{"2", "\[ImaginaryI]"}]], 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"Coth", "[", 
       RowBox[{"\[Pi]", 
        RowBox[{"(", 
         RowBox[{"u", "-", "v"}], ")"}]}], "]"}], "+", 
      SubscriptBox[
       RowBox[{"Coth", "[", 
        RowBox[{"\[Pi]", " ", "v"}], "]"}], "pv"]}], ")"}], 
    RowBox[{"Log", "[", 
     SubscriptBox[
      RowBox[{"(", 
       RowBox[{
        SubscriptBox["Y", 
         RowBox[{"1", ",", "1"}]], 
        SubscriptBox["Y", 
         RowBox[{"2", ",", "2"}]]}], ")"}], "r"], "]"}]}]}]}]], "Input",
 CellChangeTimes->{{3.547966491674753*^9, 3.547966543809491*^9}, {
   3.547966856640164*^9, 3.5479668725649157`*^9}, {3.5479669237629766`*^9, 
   3.547966932264473*^9}, 3.55219692680199*^9, {3.5521975315545397`*^9, 
   3.552197558495037*^9}, {3.563514296948494*^9, 3.563514349007523*^9}, 
   3.563515437671116*^9}],

Cell[TextData[{
 "We have to compute the answer up to a constant. To do that we \n1)Note that \
",
 Cell[BoxData[
  RowBox[{"Log", "[", 
   SubscriptBox[
    RowBox[{"(", 
     RowBox[{
      SubscriptBox["Y", 
       RowBox[{"1", ",", "1"}]], 
      SubscriptBox["Y", 
       RowBox[{"2", ",", "2"}]]}], ")"}], "r"], "]"}]],
  CellChangeTimes->{{3.547966491674753*^9, 3.547966543809491*^9}, {
    3.547966856640164*^9, 3.5479668725649157`*^9}, {3.5479669237629766`*^9, 
    3.547966932264473*^9}, 3.55219692680199*^9, {3.5521975315545397`*^9, 
    3.552197558495037*^9}, {3.563514296948494*^9, 3.563514349007523*^9}, 
    3.563515437671116*^9}],
 " is antysymmetric on ",
 Cell[BoxData[
  FormBox[
   RowBox[{"v", "\[Element]", 
    OverscriptBox["Z", "\[Vee]"]}], TraditionalForm]],
  FormatType->"TraditionalForm"],
 ". We will use this symmetry explicit"
}], "Text",
 CellChangeTimes->{{3.563515441013834*^9, 3.563515517475074*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Log", "[", 
   SubsuperscriptBox[
    RowBox[{"(", "\[ScriptCapitalF]", ")"}], "r", "+"], "]"}], "=", 
  RowBox[{
   SubscriptBox["\[Integral]", 
    OverscriptBox["Z", "\[Vee]"]], 
   RowBox[{
    FractionBox["dv", 
     RowBox[{"2", "\[ImaginaryI]"}]], 
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       FractionBox["1", "2"], 
       RowBox[{"Coth", "[", 
        RowBox[{"\[Pi]", 
         RowBox[{"(", 
          RowBox[{"u", "-", "v"}], ")"}]}], "]"}]}], "-", 
      RowBox[{
       FractionBox["1", "2"], 
       RowBox[{"Coth", "[", 
        RowBox[{"\[Pi]", 
         RowBox[{"(", 
          RowBox[{"u", "+", "v"}], ")"}]}], "]"}]}], "+", 
      SubscriptBox[
       RowBox[{"Coth", "[", 
        RowBox[{"\[Pi]", " ", "v"}], "]"}], "pv"]}], ")"}], 
    RowBox[{"Log", "[", 
     SubscriptBox[
      RowBox[{"(", 
       RowBox[{
        SubscriptBox["Y", 
         RowBox[{"1", ",", "1"}]], 
        SubscriptBox["Y", 
         RowBox[{"2", ",", "2"}]]}], ")"}], "r"], "]"}]}]}]}]], "Input",
 CellChangeTimes->{{3.563515519546277*^9, 3.563515534163651*^9}, {
  3.5635155642519617`*^9, 3.563515567086184*^9}, {3.563515636984901*^9, 
  3.5635156403122463`*^9}}],

Cell[TextData[{
 "2) Because ",
 Cell[BoxData[
  RowBox[{"Log", "[", 
   SubscriptBox[
    RowBox[{"(", 
     RowBox[{
      SubscriptBox["Y", 
       RowBox[{"1", ",", "1"}]], 
      SubscriptBox["Y", 
       RowBox[{"2", ",", "2"}]]}], ")"}], "r"], "]"}]],
  CellChangeTimes->{{3.563515519546277*^9, 3.563515534163651*^9}}],
 " is  a pure square root cut, we can replace this integration with pv \
integration. So in the ordinary regime, with u somewhere in the UHP or LHP, \
one can use the integral "
}], "Text",
 CellChangeTimes->{{3.563515556530954*^9, 3.5635155896167917`*^9}, {
  3.5635156637514563`*^9, 3.5635157284288588`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Log", "[", 
   SubsuperscriptBox[
    RowBox[{"(", "\[ScriptCapitalF]", ")"}], "r", "+"], "]"}], "=", 
  RowBox[{"\[Integral]", 
   RowBox[{
    FractionBox["dv", 
     RowBox[{"2", "\[ImaginaryI]"}]], 
    SubscriptBox[
     RowBox[{"(", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          FractionBox["1", "2"], 
          RowBox[{"Coth", "[", 
           RowBox[{"\[Pi]", 
            RowBox[{"(", 
             RowBox[{"u", "-", "v"}], ")"}]}], "]"}]}], "-", 
         RowBox[{
          FractionBox["1", "2"], 
          RowBox[{"Coth", "[", 
           RowBox[{"\[Pi]", 
            RowBox[{"(", 
             RowBox[{"u", "+", "v"}], ")"}]}], "]"}]}], "+", 
         RowBox[{"Coth", "[", 
          RowBox[{"\[Pi]", " ", "v"}], "]"}]}], ")"}], 
       RowBox[{"Log", "[", 
        SubscriptBox[
         RowBox[{"(", 
          RowBox[{
           SubscriptBox["Y", 
            RowBox[{"1", ",", "1"}]], 
           SubscriptBox["Y", 
            RowBox[{"2", ",", "2"}]]}], ")"}], "r"], "]"}]}], ")"}], 
     "pv"]}]}]}]], "Input",
 CellChangeTimes->{{3.563515600303791*^9, 3.563515609167882*^9}, {
  3.563515642248496*^9, 3.563515657287135*^9}}],

Cell["\<\
3) In the double scaling regime we have to put u on the real axis, hence we \
pick additional pole.\
\>", "Text",
 CellChangeTimes->{{3.563515731436265*^9, 3.563515754443574*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Series", "[", 
  RowBox[{
   RowBox[{"Coth", "[", 
    RowBox[{"\[Pi]", " ", "u"}], "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"u", ",", "0", ",", 
     RowBox[{"-", "1"}]}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.5635157627833138`*^9, 3.563515770251514*^9}}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
   FractionBox["1", 
    RowBox[{"\[Pi]", " ", "u"}]], "+", 
   InterpretationBox[
    SuperscriptBox[
     RowBox[{"O", "[", "u", "]"}], "0"],
    SeriesData[$CellContext`u, 0, {}, -1, 0, 1],
    Editable->False]}],
  SeriesData[$CellContext`u, 0, {Pi^(-1)}, -1, 0, 1],
  Editable->False]], "Output",
 CellChangeTimes->{3.56351577070453*^9}]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    FractionBox["1", "2"], 
    RowBox[{"\[Integral]", 
     RowBox[{
      FractionBox["dv", 
       RowBox[{"2", "\[ImaginaryI]", " ", "\[Pi]"}]], 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          RowBox[{
           FractionBox["1", "2"], 
           FractionBox["1", 
            RowBox[{"u", "-", "v", "-", 
             RowBox[{"\[ImaginaryI]", " ", "\[Epsilon]"}]}]]}], "-", 
          RowBox[{
           FractionBox["1", "2"], 
           FractionBox["1", 
            RowBox[{"u", "+", "v", "+", 
             RowBox[{"\[ImaginaryI]", " ", "\[Epsilon]"}]}]]}]}], ")"}], 
        RowBox[{"Log", "[", 
         SubsuperscriptBox[
          RowBox[{"(", 
           RowBox[{
            SubscriptBox["Y", 
             RowBox[{"1", ",", "1"}]], 
            SubscriptBox["Y", 
             RowBox[{"2", ",", "2"}]]}], ")"}], "r", 
          RowBox[{"[", 
           FractionBox[
            RowBox[{"+", "\[Epsilon]"}], "2"], "]"}]], "]"}]}], ")"}]}]}]}], 
   "+", 
   RowBox[{
    FractionBox["1", "2"], 
    RowBox[{"\[Integral]", 
     RowBox[{
      FractionBox["dv", 
       RowBox[{"2", "\[ImaginaryI]", " ", "\[Pi]"}]], 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          RowBox[{
           FractionBox["1", "2"], 
           FractionBox["1", 
            RowBox[{"u", "-", "v", "+", 
             RowBox[{"\[ImaginaryI]", " ", "\[Epsilon]"}]}]]}], "-", 
          RowBox[{
           FractionBox["1", "2"], 
           FractionBox["1", 
            RowBox[{"u", "+", "v", "-", 
             RowBox[{"\[ImaginaryI]", " ", "\[Epsilon]"}]}]]}]}], ")"}], 
        RowBox[{"Log", "[", 
         SubsuperscriptBox[
          RowBox[{"(", 
           RowBox[{
            SubscriptBox["Y", 
             RowBox[{"1", ",", "1"}]], 
            SubscriptBox["Y", 
             RowBox[{"2", ",", "2"}]]}], ")"}], "r", 
          RowBox[{"[", 
           FractionBox[
            RowBox[{"-", "\[Epsilon]"}], "2"], "]"}]], "]"}]}], ")"}]}]}]}]}],
   "\[Equal]", "\[IndentingNewLine]", "\[Equal]", 
  RowBox[{
   RowBox[{
    FractionBox[
     RowBox[{"-", "1"}], "4"], 
    RowBox[{
     RowBox[{"Log", "[", 
      SubsuperscriptBox[
       RowBox[{"(", 
        RowBox[{
         SubscriptBox["Y", 
          RowBox[{"1", ",", "1"}]], 
         SubscriptBox["Y", 
          RowBox[{"2", ",", "2"}]]}], ")"}], "r", 
       RowBox[{"[", 
        RowBox[{"+", "o"}], "]"}]], "]"}], "[", "u", "]"}]}], "+", 
   RowBox[{
    FractionBox["1", "4"], 
    RowBox[{"Log", "[", 
     RowBox[{
      SubsuperscriptBox[
       RowBox[{"(", 
        RowBox[{
         SubscriptBox["Y", 
          RowBox[{"1", ",", "1"}]], 
         SubscriptBox["Y", 
          RowBox[{"2", ",", "2"}]]}], ")"}], "r", 
       RowBox[{"[", 
        RowBox[{"-", "o"}], "]"}]], "[", 
      RowBox[{"-", "u"}], "]"}], "]"}]}]}], "\[Equal]", 
  RowBox[{
   RowBox[{"-", 
    FractionBox["1", "2"]}], 
   RowBox[{"Log", "[", 
    SubsuperscriptBox[
     RowBox[{"(", 
      RowBox[{
       SubscriptBox["Y", 
        RowBox[{"1", ",", "1"}]], 
       SubscriptBox["Y", 
        RowBox[{"2", ",", "2"}]]}], ")"}], "r", 
     RowBox[{"[", 
      RowBox[{"+", "o"}], "]"}]], "]"}]}]}]], "Input",
 CellChangeTimes->{{3.56351578179565*^9, 3.563515853969208*^9}, {
  3.5635159463995457`*^9, 3.563516007776195*^9}, {3.563516067304841*^9, 
  3.563516083499857*^9}}],

Cell["\<\
So, in the double scaling one should compute the following integral\
\>", "Text",
 CellChangeTimes->{{3.563516659615119*^9, 3.563516670317069*^9}}],

Cell[BoxData[
 RowBox[{
  SubscriptBox[
   RowBox[{"Log", "[", 
    SubsuperscriptBox[
     RowBox[{"(", "\[ScriptCapitalF]", ")"}], "r", "+"], "]"}], "ds"], "=", 
  RowBox[{
   RowBox[{"\[Integral]", 
    RowBox[{
     FractionBox["dv", 
      RowBox[{"2", "\[ImaginaryI]"}]], 
     SubscriptBox[
      RowBox[{"(", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          RowBox[{
           FractionBox["1", "2"], 
           RowBox[{"Coth", "[", 
            RowBox[{"\[Pi]", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"2", "g", " ", "z"}], "-", "v"}], ")"}]}], "]"}]}], 
          "-", 
          RowBox[{
           FractionBox["1", "2"], 
           RowBox[{"Coth", "[", 
            RowBox[{"\[Pi]", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"2", "g", " ", "z"}], "+", "v"}], ")"}]}], "]"}]}], 
          "+", 
          RowBox[{"Coth", "[", 
           RowBox[{"\[Pi]", " ", "v"}], "]"}]}], ")"}], 
        RowBox[{"Log", "[", 
         SubscriptBox[
          RowBox[{"(", 
           RowBox[{
            SubscriptBox["Y", 
             RowBox[{"1", ",", "1"}]], 
            SubscriptBox["Y", 
             RowBox[{"2", ",", "2"}]]}], ")"}], "r"], "]"}]}], ")"}], 
      "pv"]}]}], "-", 
   RowBox[{
    FractionBox["1", "2"], 
    RowBox[{"Log", "[", 
     SubscriptBox[
      RowBox[{"(", 
       RowBox[{
        SubscriptBox["Y", 
         RowBox[{"1", ",", "1"}]], 
        SubscriptBox["Y", 
         RowBox[{"2", ",", "2"}]]}], ")"}], "ds"], "]"}]}]}]}]], "Input",
 CellChangeTimes->{{3.563516674904834*^9, 3.563516698293339*^9}}],

Cell[BoxData[
 RowBox[{"o", "\[Equal]", 
  RowBox[{"Log", "[", 
   SubscriptBox[
    RowBox[{"(", 
     RowBox[{
      SubscriptBox["Y", 
       RowBox[{"1", ",", "1"}]], 
      SubscriptBox["Y", 
       RowBox[{"2", ",", "2"}]]}], ")"}], "r"], "]"}]}]], "Input",
 CellChangeTimes->{{3.563516762563198*^9, 3.5635167913232403`*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"Series", "[", 
   RowBox[{
    RowBox[{
     SuperscriptBox["g", 
      RowBox[{"-", "9"}]], 
     RowBox[{"Log", "[", 
      FractionBox[
       RowBox[{"(", 
        RowBox[{"1", "-", 
         RowBox[{"Y11Y22", " ", 
          RowBox[{"Exp", "[", 
           RowBox[{"o", " ", 
            SuperscriptBox["g", "9"]}], "]"}]}]}], ")"}], 
       RowBox[{"(", 
        RowBox[{"1", "-", "Y11Y22"}], ")"}]], "]"}]}], ",", 
    RowBox[{"{", 
     RowBox[{"g", ",", "0", ",", "0"}], "}"}]}], "]"}], "//", 
  "Normal"}], "\[IndentingNewLine]", 
 RowBox[{
  SuperscriptBox["g", "9"], 
  RowBox[{"Collect", "[", 
   RowBox[{"%", ",", "o", " ", ",", 
    RowBox[{
     RowBox[{"Collect", "[", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          RowBox[{
           RowBox[{
            RowBox[{
             RowBox[{
              RowBox[{
               RowBox[{"(", 
                RowBox[{
                 RowBox[{"#", "/.", "largevolume"}], "//", "Simplify"}], 
                ")"}], "/.", "subFunsBethe"}], "/.", "subJuk"}], "/.", 
             RowBox[{"u", "\[Rule]", 
              RowBox[{"2", "g", " ", "z"}]}]}], "/.", 
            RowBox[{"leadweak", "[", "4", "]"}]}], "/.", 
           RowBox[{"TaylorOptions", "[", 
            RowBox[{
             RowBox[{"Variable", "\[Rule]", "g"}], ",", 
             RowBox[{"\[Eta]Factor", "\[Rule]", 
              RowBox[{"2", " ", "z"}]}], ",", 
             RowBox[{"Order", "\[Rule]", "3"}]}], "]"}]}], "//.", "denz"}], "//.",
          "densqrt3"}], ")"}], ",", "g", ",", "Simplify"}], "]"}], "&"}]}], 
   "]"}]}]}], "Input",
 CellChangeTimes->{{3.5635167169349127`*^9, 3.5635167592735023`*^9}, {
   3.563516793854328*^9, 3.563516795278283*^9}, {3.563517127003928*^9, 
   3.563517321602813*^9}, 3.5635173840317*^9}],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{
     FractionBox[
      RowBox[{"-", "1"}], "2"], 
     RowBox[{"(", 
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{
          RowBox[{"\[Eta]$", "[", "1", "]"}], "[", "2", "]"}], "+", 
         FractionBox["1", "u"], "+", 
         RowBox[{
          RowBox[{"\[Eta]$b", "[", "1", "]"}], "[", 
          RowBox[{"-", "2"}], "]"}]}], "/.", 
        RowBox[{"Shift", "[", 
         RowBox[{"2", "\[ImaginaryI]", " ", 
          RowBox[{"(", 
           RowBox[{"2", "g", " ", "z"}], ")"}]}], "]"}]}], "/.", 
       RowBox[{"u", "\[Rule]", 
        RowBox[{"u", "-", 
         RowBox[{"2", "g", " ", "z"}]}]}]}], ")"}]}], "+", 
    RowBox[{
     FractionBox[
      RowBox[{"-", "1"}], "2"], 
     RowBox[{"(", 
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{
          RowBox[{"\[Eta]$", "[", "1", "]"}], "[", "2", "]"}], "+", 
         FractionBox["1", "u"], "+", 
         RowBox[{
          RowBox[{"\[Eta]$b", "[", "1", "]"}], "[", 
          RowBox[{"-", "2"}], "]"}]}], "/.", 
        RowBox[{"Shift", "[", 
         RowBox[{
          RowBox[{"-", "2"}], "\[ImaginaryI]", " ", 
          RowBox[{"(", 
           RowBox[{"2", "g", " ", "z"}], ")"}]}], "]"}]}], "/.", 
       RowBox[{"u", "\[Rule]", 
        RowBox[{"u", "+", 
         RowBox[{"2", "g", " ", "z"}]}]}]}], ")"}]}], "+", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       RowBox[{"\[Eta]$", "[", "1", "]"}], "[", "2", "]"}], "+", 
      FractionBox["1", "u"], "+", 
      RowBox[{
       RowBox[{"\[Eta]$b", "[", "1", "]"}], "[", 
       RowBox[{"-", "2"}], "]"}]}], ")"}]}], "/.", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"(", 
       RowBox[{"xxx", ":", 
        RowBox[{"\[Eta]$", "|", "\[Eta]$b"}]}], ")"}], "[", "a_", "]"}], "[", 
     "sh_", "]"}], "\[RuleDelayed]", 
    RowBox[{
     RowBox[{"xxx", "[", "a", "]"}], "[", 
     RowBox[{
      RowBox[{"u", "+", 
       RowBox[{
        RowBox[{"\[ImaginaryI]", "/", "2"}], "sh"}]}], ",", "0"}], "]"}]}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Series", "[", 
   RowBox[{"%", ",", 
    RowBox[{"{", 
     RowBox[{"g", ",", "0", ",", "4"}], "}"}]}], "]"}], "/.", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"Derivative", "[", 
      RowBox[{"der_", ",", "0"}], "]"}], "[", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"xxx", ":", 
        RowBox[{"\[Eta]$", "|", "\[Eta]$b"}]}], ")"}], "[", "a_", "]"}], 
     "]"}], "[", "arg__", "]"}], "\[RuleDelayed]", 
   RowBox[{
    SuperscriptBox[
     RowBox[{"(", 
      RowBox[{"-", "1"}], ")"}], "der"], 
    RowBox[{"Pochhammer", "[", 
     RowBox[{"a", ",", "der"}], "]"}], 
    RowBox[{
     RowBox[{"xxx", "[", 
      RowBox[{"a", "+", "der"}], "]"}], "[", 
     RowBox[{
      FractionBox[
       RowBox[{
        RowBox[{"{", "arg", "}"}], "[", 
        RowBox[{"[", "1", "]"}], "]"}], 
       RowBox[{"\[ImaginaryI]", "/", "2"}]], "/.", 
      RowBox[{"u", "\[Rule]", "0"}]}], "]"}]}]}]}]}], "Input",
 CellChangeTimes->{{3.563522547550331*^9, 3.563522684668605*^9}, {
  3.563522719302595*^9, 3.563522848430112*^9}, {3.563522880468212*^9, 
  3.563523009022294*^9}, {3.563523758634535*^9, 3.563523758749139*^9}}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"-", 
       FractionBox[
        RowBox[{"4", " ", 
         SuperscriptBox["z", "2"]}], 
        SuperscriptBox["u", "3"]]}], "-", 
      RowBox[{"4", " ", 
       SuperscriptBox["z", "2"], " ", 
       SubsuperscriptBox[
        StyleBox["\[Eta]",
         FontWeight->Bold,
         FontColor->RGBColor[0.8, 0, 0]], "3", 
        RowBox[{"[", "2", "]"}]]}], "-", 
      RowBox[{"4", " ", 
       SuperscriptBox["z", "2"], " ", 
       SubsuperscriptBox[
        OverscriptBox[
         StyleBox["\[Eta]",
          FontWeight->Bold,
          FontColor->RGBColor[0.8, 0, 0]], 
         StyleBox["_",
          FontWeight->Bold,
          FontColor->RGBColor[0.8, 0, 0]]], "3", 
        RowBox[{"[", 
         RowBox[{"-", "2"}], "]"}]]}]}], ")"}], " ", 
    SuperscriptBox["g", "2"]}], "+", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"-", 
       FractionBox[
        RowBox[{"16", " ", 
         SuperscriptBox["z", "4"]}], 
        SuperscriptBox["u", "5"]]}], "-", 
      RowBox[{"16", " ", 
       SuperscriptBox["z", "4"], " ", 
       SubsuperscriptBox[
        StyleBox["\[Eta]",
         FontWeight->Bold,
         FontColor->RGBColor[0.8, 0, 0]], "5", 
        RowBox[{"[", "2", "]"}]]}], "-", 
      RowBox[{"16", " ", 
       SuperscriptBox["z", "4"], " ", 
       SubsuperscriptBox[
        OverscriptBox[
         StyleBox["\[Eta]",
          FontWeight->Bold,
          FontColor->RGBColor[0.8, 0, 0]], 
         StyleBox["_",
          FontWeight->Bold,
          FontColor->RGBColor[0.8, 0, 0]]], "5", 
        RowBox[{"[", 
         RowBox[{"-", "2"}], "]"}]]}]}], ")"}], " ", 
    SuperscriptBox["g", "4"]}], "+", 
   InterpretationBox[
    SuperscriptBox[
     RowBox[{"O", "[", "g", "]"}], "5"],
    SeriesData[$CellContext`g, 0, {}, 2, 5, 1],
    Editable->False]}],
  SeriesData[$CellContext`g, 
   0, {(-4) $CellContext`u^(-3) $CellContext`z^2 - 
    4 $CellContext`z^2 $CellContext`\[Eta]$[3][2] - 
    4 $CellContext`z^2 $CellContext`\[Eta]$b[3][-2], 
    0, (-16) $CellContext`u^(-5) $CellContext`z^4 - 
    16 $CellContext`z^4 $CellContext`\[Eta]$[5][2] - 
    16 $CellContext`z^4 $CellContext`\[Eta]$b[5][-2]}, 2, 5, 1],
  Editable->False]], "Output",
 CellChangeTimes->{{3.5635167382230253`*^9, 3.56351674547972*^9}, 
   3.563516795729772*^9, {3.5635171313279552`*^9, 3.563517166569665*^9}, 
   3.563517197303941*^9, {3.563517233591975*^9, 3.5635173218604717`*^9}, 
   3.563517384188077*^9, 3.563522630858532*^9, 3.563522756566102*^9, 
   3.563522799862773*^9, {3.5635228320318813`*^9, 3.563522842933405*^9}, {
   3.5635229882475853`*^9, 3.5635230094975853`*^9}, {3.563523739806357*^9, 
   3.5635237591601753`*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Series", "[", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"\[Pi]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         FractionBox["1", "2"], 
         RowBox[{"Coth", "[", 
          RowBox[{"\[Pi]", 
           RowBox[{"(", 
            RowBox[{"u", "-", "v"}], ")"}]}], "]"}]}], "-", 
        RowBox[{
         FractionBox["1", "2"], 
         RowBox[{"Coth", "[", 
          RowBox[{"\[Pi]", 
           RowBox[{"(", 
            RowBox[{"u", "+", "v"}], ")"}]}], "]"}]}], "+", 
        RowBox[{"Coth", "[", 
         RowBox[{"\[Pi]", " ", "v"}], "]"}]}], ")"}]}], "/.", 
     RowBox[{"u", "\[Rule]", 
      RowBox[{"2", "g", " ", "z"}]}]}], "/.", 
    RowBox[{"v", "\[Rule]", "u"}]}], ",", 
   RowBox[{"{", 
    RowBox[{"g", ",", "0", ",", "4"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.563523786277433*^9, 3.563523793953465*^9}, {
  3.563523856106928*^9, 3.563523856524543*^9}}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"4", " ", 
       SuperscriptBox["\[Pi]", "3"], " ", 
       SuperscriptBox["z", "2"], " ", 
       RowBox[{"Coth", "[", 
        RowBox[{"\[Pi]", " ", "u"}], "]"}]}], "-", 
      RowBox[{"4", " ", 
       SuperscriptBox["\[Pi]", "3"], " ", 
       SuperscriptBox["z", "2"], " ", 
       SuperscriptBox[
        RowBox[{"Coth", "[", 
         RowBox[{"\[Pi]", " ", "u"}], "]"}], "3"]}]}], ")"}], " ", 
    SuperscriptBox["g", "2"]}], "+", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       RowBox[{"-", 
        FractionBox["32", "3"]}], " ", 
       SuperscriptBox["\[Pi]", "5"], " ", 
       SuperscriptBox["z", "4"], " ", 
       RowBox[{"Coth", "[", 
        RowBox[{"\[Pi]", " ", "u"}], "]"}]}], "+", 
      RowBox[{
       FractionBox["80", "3"], " ", 
       SuperscriptBox["\[Pi]", "5"], " ", 
       SuperscriptBox["z", "4"], " ", 
       SuperscriptBox[
        RowBox[{"Coth", "[", 
         RowBox[{"\[Pi]", " ", "u"}], "]"}], "3"]}], "-", 
      RowBox[{"16", " ", 
       SuperscriptBox["\[Pi]", "5"], " ", 
       SuperscriptBox["z", "4"], " ", 
       SuperscriptBox[
        RowBox[{"Coth", "[", 
         RowBox[{"\[Pi]", " ", "u"}], "]"}], "5"]}]}], ")"}], " ", 
    SuperscriptBox["g", "4"]}], "+", 
   InterpretationBox[
    SuperscriptBox[
     RowBox[{"O", "[", "g", "]"}], "5"],
    SeriesData[$CellContext`g, 0, {}, 2, 5, 1],
    Editable->False]}],
  SeriesData[$CellContext`g, 0, {
   4 Pi^3 $CellContext`z^2 Coth[Pi $CellContext`u] - 4 Pi^3 $CellContext`z^2 
    Coth[Pi $CellContext`u]^3, 0, 
    Rational[-32, 3] Pi^5 $CellContext`z^4 Coth[Pi $CellContext`u] + 
    Rational[80, 3] Pi^5 $CellContext`z^4 Coth[Pi $CellContext`u]^3 - 16 
    Pi^5 $CellContext`z^4 Coth[Pi $CellContext`u]^5}, 2, 5, 1],
  Editable->False]], "Output",
 CellChangeTimes->{
  3.563523795020282*^9, {3.563523858070636*^9, 3.56352386073402*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  SubsuperscriptBox[
   StyleBox["\[Eta]",
    FontWeight->Bold,
    FontColor->RGBColor[0.8, 0, 0]], "1", 
   RowBox[{"[", "2", "]"}]], "/.", 
  RowBox[{"TaylorOptions", "[", 
   RowBox[{
    RowBox[{"Variable", "\[Rule]", "z"}], ",", 
    RowBox[{"\[Eta]Factor", "\[Rule]", "1"}], ",", 
    RowBox[{"Order", "\[Rule]", "3"}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.563522691875033*^9, 3.56352270017924*^9}}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
   RowBox[{"-", 
    RowBox[{"\[ImaginaryI]", " ", 
     SubscriptBox[
      StyleBox["\[Zeta]",
       FontWeight->Bold,
       FontColor->GrayLevel[0.4]], "1"]}]}], "+", 
   RowBox[{
    SubscriptBox[
     StyleBox["\[Zeta]",
      FontWeight->Bold,
      FontColor->GrayLevel[0.4]], "2"], " ", "z"}], "+", 
   RowBox[{"\[ImaginaryI]", " ", 
    SubscriptBox[
     StyleBox["\[Zeta]",
      FontWeight->Bold,
      FontColor->GrayLevel[0.4]], "3"], " ", 
    SuperscriptBox["z", "2"]}], "-", 
   RowBox[{
    SubscriptBox[
     StyleBox["\[Zeta]",
      FontWeight->Bold,
      FontColor->GrayLevel[0.4]], "4"], " ", 
    SuperscriptBox["z", "3"]}], "+", 
   InterpretationBox[
    SuperscriptBox[
     RowBox[{"O", "[", "z", "]"}], "4"],
    SeriesData[$CellContext`z, 0, {}, 0, 4, 1],
    Editable->False]}],
  SeriesData[$CellContext`z, 0, {Complex[0, -1] $CellContext`\[Zeta]$[1][0], 
    $CellContext`\[Zeta]$[2][0], 
    Complex[0, 1] $CellContext`\[Zeta]$[3][0], -$CellContext`\[Zeta]$[4][0]}, 
   0, 4, 1],
  Editable->False]], "Output",
 CellChangeTimes->{{3.563522697632655*^9, 3.563522704708228*^9}}]
}, Open  ]],

Cell["\<\
Ok Let us compute first even-g part of \[ScriptCapitalF] in the double scaling\
\>", "Text",
 CellChangeTimes->{{3.563517472721345*^9, 3.563517514776099*^9}}],

Cell[BoxData[
 RowBox[{
  SubscriptBox[
   RowBox[{"Log", "[", 
    SubsuperscriptBox[
     RowBox[{"(", "\[ScriptCapitalF]", ")"}], "r", "+"], "]"}], "ds"], "=", 
  RowBox[{"\[Integral]", 
   RowBox[{
    FractionBox["dv", 
     RowBox[{"2", "\[ImaginaryI]"}]], 
    SubscriptBox[
     RowBox[{"(", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          FractionBox["1", "2"], 
          RowBox[{"Coth", "[", 
           RowBox[{"\[Pi]", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"2", "g", " ", "z"}], "-", "v"}], ")"}]}], "]"}]}], "-", 
         RowBox[{
          FractionBox["1", "2"], 
          RowBox[{"Coth", "[", 
           RowBox[{"\[Pi]", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"2", "g", " ", "z"}], "+", "v"}], ")"}]}], "]"}]}], "+", 
         RowBox[{"Coth", "[", 
          RowBox[{"\[Pi]", " ", "v"}], "]"}]}], ")"}], 
       RowBox[{"Log", "[", 
        SubscriptBox[
         RowBox[{"(", 
          RowBox[{
           SubscriptBox["Y", 
            RowBox[{"1", ",", "1"}]], 
           SubscriptBox["Y", 
            RowBox[{"2", ",", "2"}]]}], ")"}], "r"], "]"}]}], ")"}], 
     "pv"]}]}]}]], "Input",
 CellChangeTimes->{{3.563517522335216*^9, 3.563517522616291*^9}}],

Cell[TextData[{
 "I can compute it probably in any regime. For this I have to recall that in \
the rhs we have ",
 Cell[BoxData[
  RowBox[{"Log", "[", 
   SubscriptBox[
    RowBox[{"(", 
     RowBox[{
      SubscriptBox["Y", 
       RowBox[{"1", ",", "1"}]], 
      SubscriptBox["Y", 
       RowBox[{"2", ",", "2"}]]}], ")"}], "r"], "]"}]],
  CellChangeTimes->{{3.563517522335216*^9, 3.563517522616291*^9}}],
 ". How should I compute this quantity? In principle from the integral \
equation I have got for it."
}], "Text",
 CellChangeTimes->{{3.563517524111567*^9, 3.5635175752777977`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Log", "[", " ", 
   FractionBox[
    RowBox[{
     SubscriptBox[
      StyleBox["Y",
       FontColor->RGBColor[0, 0, 0.8]], 
      RowBox[{"1", ",", "1"}]], " ", 
     SubscriptBox[
      StyleBox["Y",
       FontColor->RGBColor[0, 0, 0.8]], 
      RowBox[{"2", ",", "2"}]]}], 
    SubscriptBox[
     RowBox[{"(", 
      RowBox[{
       SubscriptBox["Y", 
        RowBox[{"1", ",", "1"}]], 
       SubscriptBox["Y", 
        RowBox[{"2", ",", "2"}]]}], ")"}], "asym"]], "]"}], "\[Equal]", 
  RowBox[{
   OverscriptBox["H", "_"], "-", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      OverscriptBox[
       StyleBox["x",
        FontColor->RGBColor[0, 0.6, 0]], 
       StyleBox["^",
        FontColor->RGBColor[0, 0.6, 0]]], "-", 
      FractionBox["1", 
       OverscriptBox[
        StyleBox["x",
         FontColor->RGBColor[0, 0.6, 0]], 
        StyleBox["^",
         FontColor->RGBColor[0, 0.6, 0]]]]}], ")"}], 
    RowBox[{
     SubsuperscriptBox["\[Integral]", 
      RowBox[{"-", "\[Infinity]"}], 
      RowBox[{"+", "\[Infinity]"}]], 
     RowBox[{
      FractionBox["dv", 
       RowBox[{
        RowBox[{"-", "2"}], "\[Pi]", " ", "\[ImaginaryI]"}]], 
      FractionBox["1", 
       RowBox[{"u", "-", "v"}]], 
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         FractionBox["1", 
          RowBox[{
           RowBox[{
            OverscriptBox[
             StyleBox["x",
              FontColor->RGBColor[0, 0.6, 0]], 
             StyleBox["^",
              FontColor->RGBColor[0, 0.6, 0]]], "[", 
            RowBox[{"v", "+", 
             RowBox[{"\[ImaginaryI]", " ", "0"}]}], "]"}], "-", 
           FractionBox["1", 
            RowBox[{
             OverscriptBox[
              StyleBox["x",
               FontColor->RGBColor[0, 0.6, 0]], 
              StyleBox["^",
               FontColor->RGBColor[0, 0.6, 0]]], "[", 
             RowBox[{"v", "+", 
              RowBox[{"\[ImaginaryI]", " ", "0"}]}], "]"}]]}]], 
         RowBox[{
          OverscriptBox["H", "_"], "[", 
          RowBox[{"v", "+", 
           RowBox[{"\[ImaginaryI]", " ", "0"}]}], "]"}]}], "+", 
        RowBox[{
         FractionBox["1", 
          RowBox[{
           RowBox[{
            OverscriptBox[
             StyleBox["x",
              FontColor->RGBColor[0, 0.6, 0]], 
             StyleBox["^",
              FontColor->RGBColor[0, 0.6, 0]]], "[", 
            RowBox[{"v", "-", 
             RowBox[{"\[ImaginaryI]", " ", "0"}]}], "]"}], "-", 
           FractionBox["1", 
            RowBox[{
             OverscriptBox[
              StyleBox["x",
               FontColor->RGBColor[0, 0.6, 0]], 
              StyleBox["^",
               FontColor->RGBColor[0, 0.6, 0]]], "[", 
             RowBox[{"v", "-", 
              RowBox[{"\[ImaginaryI]", " ", "0"}]}], "]"}]]}]], 
         RowBox[{"H", "[", 
          RowBox[{"v", "-", 
           RowBox[{"\[ImaginaryI]", " ", "0"}]}], "]"}]}]}], 
       ")"}]}]}]}]}]}]], "Input"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{
    RowBox[{
     FractionBox["u", "g"], 
     SqrtBox[
      RowBox[{"1", "-", 
       FractionBox[
        RowBox[{"4", 
         SuperscriptBox["g", "2"]}], 
        SuperscriptBox["u", "2"]]}]]}], "==", 
    RowBox[{"xh", "-", 
     FractionBox["1", "xh"]}]}], ",", 
   RowBox[{
    RowBox[{"2", "\[ImaginaryI]", 
     SqrtBox[
      RowBox[{"1", "-", 
       FractionBox[
        SuperscriptBox["u", "2"], 
        RowBox[{"4", 
         SuperscriptBox["g", "2"]}]]}]]}], "\[Equal]", 
    RowBox[{"x", "-", 
     FractionBox["1", "x"]}]}]}], "}"}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{"Log", "[", 
   SubscriptBox[
    RowBox[{"(", 
     RowBox[{
      SubscriptBox["Y", 
       RowBox[{"1", ",", "1"}]], 
      SubscriptBox["Y", 
       RowBox[{"2", ",", "2"}]]}], ")"}], "r"], "]"}], "\[Equal]", 
  RowBox[{
   RowBox[{
    OverscriptBox["H", "_"], "[", "v", "]"}], "+", 
   RowBox[{"\[DoubleStruckCapitalC]", "[", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       FractionBox["1", 
        RowBox[{"v", "-", "u"}]], "-", 
       FractionBox["1", 
        RowBox[{"v", "+", "u"}]]}], ")"}], 
     FractionBox[
      RowBox[{
       FractionBox["v", "g"], 
       SqrtBox[
        RowBox[{"1", "-", 
         FractionBox[
          RowBox[{"4", 
           SuperscriptBox["g", "2"]}], 
          SuperscriptBox["v", "2"]]}]]}], 
      RowBox[{
       FractionBox["u", "g"], 
       SqrtBox[
        RowBox[{"1", "-", 
         FractionBox[
          RowBox[{"4", 
           SuperscriptBox["g", "2"]}], 
          SuperscriptBox["u", "2"]]}]]}]], "H"}], "]"}]}]}]], "Input",
 CellChangeTimes->{{3.56351772823709*^9, 3.563517794220087*^9}, 
   3.5635189178910217`*^9, {3.5635189892639637`*^9, 3.563519000429031*^9}, {
   3.563519053248931*^9, 3.56351905577201*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Apart", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"Series", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         FractionBox["1", 
          RowBox[{"v", "-", "u"}]], "-", 
         FractionBox["1", 
          RowBox[{"v", "+", "u"}]]}], ")"}], 
       FractionBox[
        RowBox[{
         FractionBox["v", "g"], 
         SqrtBox[
          RowBox[{"1", "-", 
           FractionBox[
            RowBox[{"4", 
             SuperscriptBox["g", "2"]}], 
            SuperscriptBox["v", "2"]]}]]}], 
        RowBox[{
         FractionBox["u", "g"], 
         SqrtBox[
          RowBox[{"1", "-", 
           FractionBox[
            RowBox[{"4", 
             SuperscriptBox["g", "2"]}], 
            SuperscriptBox["u", "2"]]}]]}]]}], ",", 
      RowBox[{"{", 
       RowBox[{"g", ",", "0", ",", "0"}], "}"}]}], "]"}], "//", "Normal"}], 
   ",", "u"}], "]"}]], "Input",
 CellChangeTimes->{{3.563522060684713*^9, 3.563522081769582*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"-", 
   FractionBox["1", 
    RowBox[{"u", "-", "v"}]]}], "+", 
  FractionBox["1", 
   RowBox[{"u", "+", "v"}]]}]], "Output",
 CellChangeTimes->{{3.563522069732291*^9, 3.563522082122191*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"H", "/.", 
  RowBox[{"leadweak", "[", "1", "]"}]}]], "Input",
 CellChangeTimes->{{3.563522040649516*^9, 3.56352204264927*^9}}],

Cell[BoxData[
 RowBox[{
  SuperscriptBox["g", "8"], " ", 
  RowBox[{"(", 
   RowBox[{
    RowBox[{"-", 
     FractionBox["6", 
      RowBox[{
       SuperscriptBox["u", "4"], " ", 
       SuperscriptBox[
        StyleBox["Q0",
         FontColor->RGBColor[{
            Rational[1, 2], 
            Rational[1, 2], 0}]], "-"]}]]}], "+", 
    FractionBox[
     RowBox[{"24", "-", 
      RowBox[{"36", " ", "\[ImaginaryI]", " ", "u"}]}], 
     RowBox[{
      SuperscriptBox["u", "4"], " ", 
      SuperscriptBox[
       StyleBox["Q0",
        FontColor->RGBColor[{
           Rational[1, 2], 
           Rational[1, 2], 0}]], "+"]}]], "+", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{"-", 
        FractionBox["36", 
         SuperscriptBox["u", "4"]]}], "+", 
       FractionBox[
        RowBox[{
         RowBox[{"-", "12"}], "+", 
         FractionBox[
          RowBox[{"4", " ", "\[ImaginaryI]"}], "u"]}], 
        RowBox[{
         SuperscriptBox["u", "4"], " ", 
         SuperscriptBox[
          StyleBox["Q0",
           FontColor->RGBColor[{
              Rational[1, 2], 
              Rational[1, 2], 0}]], "-"]}]], "+", 
       FractionBox[
        RowBox[{
         RowBox[{"-", "12"}], "-", 
         FractionBox[
          RowBox[{"4", " ", "\[ImaginaryI]"}], "u"]}], 
        RowBox[{
         SuperscriptBox["u", "4"], " ", 
         SuperscriptBox[
          StyleBox["Q0",
           FontColor->RGBColor[{
              Rational[1, 2], 
              Rational[1, 2], 0}]], "+"]}]]}], ")"}], " ", 
     SubsuperscriptBox[
      StyleBox["\[Eta]",
       FontWeight->Bold,
       FontColor->RGBColor[0.8, 0, 0]], "2", 
      RowBox[{"[", "2", "]"}]]}], "+", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       FractionBox[
        RowBox[{"12", "-", 
         FractionBox[
          RowBox[{"8", " ", "\[ImaginaryI]"}], "u"]}], 
        RowBox[{
         SuperscriptBox["u", "3"], " ", 
         SuperscriptBox[
          StyleBox["Q0",
           FontColor->RGBColor[{
              Rational[1, 2], 
              Rational[1, 2], 0}]], "-"]}]], "+", 
       FractionBox[
        RowBox[{"12", "+", 
         FractionBox[
          RowBox[{"8", " ", "\[ImaginaryI]"}], "u"]}], 
        RowBox[{
         SuperscriptBox["u", "3"], " ", 
         SuperscriptBox[
          StyleBox["Q0",
           FontColor->RGBColor[{
              Rational[1, 2], 
              Rational[1, 2], 0}]], "+"]}]]}], ")"}], " ", 
     SubsuperscriptBox[
      StyleBox["\[Eta]",
       FontWeight->Bold,
       FontColor->RGBColor[0.8, 0, 0]], "3", 
      RowBox[{"[", "2", "]"}]]}], "+", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       FractionBox[
        RowBox[{"2", " ", "\[ImaginaryI]"}], 
        RowBox[{
         SuperscriptBox["u", "3"], " ", 
         SuperscriptBox[
          StyleBox["Q0",
           FontColor->RGBColor[{
              Rational[1, 2], 
              Rational[1, 2], 0}]], "-"]}]], "-", 
       FractionBox[
        RowBox[{"2", " ", "\[ImaginaryI]"}], 
        RowBox[{
         SuperscriptBox["u", "3"], " ", 
         SuperscriptBox[
          StyleBox["Q0",
           FontColor->RGBColor[{
              Rational[1, 2], 
              Rational[1, 2], 0}]], "+"]}]]}], ")"}], " ", 
     SubsuperscriptBox[
      StyleBox["\[Eta]",
       FontWeight->Bold,
       FontColor->RGBColor[0.8, 0, 0]], "4", 
      RowBox[{"[", "2", "]"}]]}]}], ")"}]}]], "Output",
 CellChangeTimes->{3.563522043126255*^9}]
}, Open  ]],

Cell["\<\
The first thing to do is to make principle value integration of the \
quantities that appear. I won\[CloseCurlyQuote]t go to double scaling. Just \
integrals with coth should be computed\
\>", "Text",
 CellChangeTimes->{{3.563519075186565*^9, 3.563519109295701*^9}}],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"Series", "[", 
    RowBox[{
     RowBox[{
      FractionBox["v", "g"], 
      SqrtBox[
       RowBox[{"1", "-", 
        FractionBox[
         RowBox[{"4", 
          SuperscriptBox["g", "2"]}], 
         SuperscriptBox["v", "2"]]}]]}], ",", 
     RowBox[{"{", 
      RowBox[{"g", ",", "0", ",", "6"}], "}"}]}], "]"}], "//", "Normal"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"%", 
  RowBox[{"(", 
   RowBox[{
    FractionBox["1", 
     RowBox[{"v", "-", "u"}]], "-", 
    FractionBox["1", 
     RowBox[{"v", "+", "u"}]]}], ")"}]}]}], "Input",
 CellChangeTimes->{{3.56351912267169*^9, 3.563519147429246*^9}, {
  3.5635191854444637`*^9, 3.563519209129488*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"(", 
   RowBox[{
    RowBox[{"-", 
     FractionBox[
      RowBox[{"4", " ", 
       SuperscriptBox["g", "5"]}], 
      SuperscriptBox["v", "5"]]}], "-", 
    FractionBox[
     RowBox[{"2", " ", 
      SuperscriptBox["g", "3"]}], 
     SuperscriptBox["v", "3"]], "-", 
    FractionBox[
     RowBox[{"2", " ", "g"}], "v"], "+", 
    FractionBox["v", "g"]}], ")"}], " ", 
  RowBox[{"(", 
   RowBox[{
    FractionBox["1", 
     RowBox[{
      RowBox[{"-", "u"}], "+", "v"}]], "-", 
    FractionBox["1", 
     RowBox[{"u", "+", "v"}]]}], ")"}]}]], "Output",
 CellChangeTimes->{
  3.563519147847455*^9, {3.5635191873708277`*^9, 3.5635192094533*^9}}]
}, Open  ]],

Cell["\<\
The point is not consider residue at zero. Otherwise, performe integration as \
it is. (u is real in our treatment. We also skip residues from it.\
\>", "Text",
 CellChangeTimes->{{3.56351915543876*^9, 3.5635192369312887`*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Collect", "[", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", 
          FractionBox[
           RowBox[{"4", " ", 
            SuperscriptBox["g", "5"]}], 
           SuperscriptBox["v", "5"]]}], "-", 
         FractionBox[
          RowBox[{"2", " ", 
           SuperscriptBox["g", "3"]}], 
          SuperscriptBox["v", "3"]], "-", 
         FractionBox[
          RowBox[{"2", " ", "g"}], "v"], "+", 
         FractionBox["v", "g"]}], ")"}], " ", 
       RowBox[{"(", 
        RowBox[{
         FractionBox["1", 
          RowBox[{
           RowBox[{"-", "u"}], "+", "v"}]], "-", 
         FractionBox["1", 
          RowBox[{"u", "+", "v"}]]}], ")"}]}], "/.", 
      RowBox[{"u", "\[Rule]", 
       RowBox[{"Re", "[", "u0", "]"}]}]}], "/.", 
     RowBox[{"v", "\[Rule]", "u"}]}], "/.", "subtousu"}], ",", "g", ",", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"#", "//", "funapartusu"}], "//", "funreduceusu"}], ")"}], 
    "&"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.5635192506067*^9, 3.5635192621169777`*^9}, {
  3.563519298824376*^9, 3.563519341465509*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   SuperscriptBox["g", "5"], " ", 
   RowBox[{"(", 
    RowBox[{
     FractionBox["8", 
      RowBox[{
       RowBox[{"Re", "[", "u0", "]"}], " ", 
       SuperscriptBox[
        StyleBox["\[ScriptU]",
         FontColor->RGBColor[0, 0, 0.4]], "5"]}]], "+", 
     FractionBox["8", 
      RowBox[{
       SuperscriptBox[
        RowBox[{"Re", "[", "u0", "]"}], "3"], " ", 
       SuperscriptBox[
        StyleBox["\[ScriptU]",
         FontColor->RGBColor[0, 0, 0.4]], "3"]}]], "+", 
     FractionBox["8", 
      RowBox[{
       SuperscriptBox[
        RowBox[{"Re", "[", "u0", "]"}], "5"], " ", 
       StyleBox["\[ScriptU]",
        FontColor->RGBColor[0, 0, 0.4]]}]], "-", 
     FractionBox["4", 
      RowBox[{
       SuperscriptBox[
        RowBox[{"Re", "[", "u0", "]"}], "5"], " ", 
       SubscriptBox[
        StyleBox["\[ScriptU]",
         FontColor->RGBColor[0, 0, 0.4]], 
        RowBox[{"-", 
         RowBox[{"Re", "[", "u0", "]"}]}]]}]], "-", 
     FractionBox["4", 
      RowBox[{
       SuperscriptBox[
        RowBox[{"Re", "[", "u0", "]"}], "5"], " ", 
       SubscriptBox[
        StyleBox["\[ScriptU]",
         FontColor->RGBColor[0, 0, 0.4]], 
        RowBox[{"Re", "[", "u0", "]"}]]}]]}], ")"}]}], "+", 
  RowBox[{
   SuperscriptBox["g", "3"], " ", 
   RowBox[{"(", 
    RowBox[{
     FractionBox["4", 
      RowBox[{
       RowBox[{"Re", "[", "u0", "]"}], " ", 
       SuperscriptBox[
        StyleBox["\[ScriptU]",
         FontColor->RGBColor[0, 0, 0.4]], "3"]}]], "+", 
     FractionBox["4", 
      RowBox[{
       SuperscriptBox[
        RowBox[{"Re", "[", "u0", "]"}], "3"], " ", 
       StyleBox["\[ScriptU]",
        FontColor->RGBColor[0, 0, 0.4]]}]], "-", 
     FractionBox["2", 
      RowBox[{
       SuperscriptBox[
        RowBox[{"Re", "[", "u0", "]"}], "3"], " ", 
       SubscriptBox[
        StyleBox["\[ScriptU]",
         FontColor->RGBColor[0, 0, 0.4]], 
        RowBox[{"-", 
         RowBox[{"Re", "[", "u0", "]"}]}]]}]], "-", 
     FractionBox["2", 
      RowBox[{
       SuperscriptBox[
        RowBox[{"Re", "[", "u0", "]"}], "3"], " ", 
       SubscriptBox[
        StyleBox["\[ScriptU]",
         FontColor->RGBColor[0, 0, 0.4]], 
        RowBox[{"Re", "[", "u0", "]"}]]}]]}], ")"}]}], "+", 
  RowBox[{"g", " ", 
   RowBox[{"(", 
    RowBox[{
     FractionBox["4", 
      RowBox[{
       RowBox[{"Re", "[", "u0", "]"}], " ", 
       StyleBox["\[ScriptU]",
        FontColor->RGBColor[0, 0, 0.4]]}]], "-", 
     FractionBox["2", 
      RowBox[{
       RowBox[{"Re", "[", "u0", "]"}], " ", 
       SubscriptBox[
        StyleBox["\[ScriptU]",
         FontColor->RGBColor[0, 0, 0.4]], 
        RowBox[{"-", 
         RowBox[{"Re", "[", "u0", "]"}]}]]}]], "-", 
     FractionBox["2", 
      RowBox[{
       RowBox[{"Re", "[", "u0", "]"}], " ", 
       SubscriptBox[
        StyleBox["\[ScriptU]",
         FontColor->RGBColor[0, 0, 0.4]], 
        RowBox[{"Re", "[", "u0", "]"}]]}]]}], ")"}]}], "+", 
  FractionBox[
   RowBox[{
    FractionBox[
     RowBox[{"Re", "[", "u0", "]"}], 
     SubscriptBox[
      StyleBox["\[ScriptU]",
       FontColor->RGBColor[0, 0, 0.4]], 
      RowBox[{"-", 
       RowBox[{"Re", "[", "u0", "]"}]}]]], "+", 
    FractionBox[
     RowBox[{"Re", "[", "u0", "]"}], 
     SubscriptBox[
      StyleBox["\[ScriptU]",
       FontColor->RGBColor[0, 0, 0.4]], 
      RowBox[{"Re", "[", "u0", "]"}]]]}], "g"]}]], "Output",
 CellChangeTimes->{{3.5635193040312767`*^9, 3.56351934192677*^9}}]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"(", 
   RowBox[{
    RowBox[{
     FractionBox["1", "2"], 
     RowBox[{"Coth", "[", 
      RowBox[{"\[Pi]", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"2", "g", " ", "z"}], "-", "v"}], ")"}]}], "]"}]}], "-", 
    RowBox[{
     FractionBox["1", "2"], 
     RowBox[{"Coth", "[", 
      RowBox[{"\[Pi]", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"2", "g", " ", "z"}], "+", "v"}], ")"}]}], "]"}]}], "+", 
    RowBox[{"Coth", "[", 
     RowBox[{"\[Pi]", " ", "v"}], "]"}]}], ")"}], "\[Equal]", 
  "\[IndentingNewLine]", "==", 
  RowBox[{"(", 
   RowBox[{
    RowBox[{
     RowBox[{"-", 
      FractionBox["1", "2"]}], 
     RowBox[{"Coth", "[", 
      RowBox[{"\[Pi]", 
       RowBox[{"(", 
        RowBox[{"v", "-", "w"}], ")"}]}], "]"}]}], "-", 
    RowBox[{
     FractionBox["1", "2"], 
     RowBox[{"Coth", "[", 
      RowBox[{"\[Pi]", 
       RowBox[{"(", 
        RowBox[{"v", "+", "w"}], ")"}]}], "]"}]}], "+", 
    RowBox[{"Coth", "[", 
     RowBox[{"\[Pi]", " ", "v"}], "]"}]}], ")"}], "\[Equal]", 
  "\[IndentingNewLine]"}]], "Input",
 CellChangeTimes->{{3.563519416290516*^9, 3.5635195510028877`*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"\[Integral]", 
   RowBox[{
    FractionBox["du", 
     RowBox[{"2", "\[ImaginaryI]"}]], 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"Coth", "[", 
       RowBox[{"\[Pi]", 
        RowBox[{"(", 
         RowBox[{"u", "-", 
          RowBox[{"Re", "[", "w0", "]"}]}], ")"}]}], "]"}], 
      FractionBox["1", 
       SuperscriptBox[
        RowBox[{"(", 
         RowBox[{"u", "-", 
          RowBox[{"Re", "[", "u0", "]"}]}], ")"}], "a"]]}], ")"}]}]}], "==", 
  RowBox[{"\[Integral]", 
   RowBox[{
    FractionBox["du", 
     RowBox[{"2", "\[ImaginaryI]"}]], 
    SubscriptBox[
     RowBox[{"(", 
      RowBox[{
       RowBox[{"Coth", "[", 
        RowBox[{"\[Pi]", 
         RowBox[{"(", 
          RowBox[{"u", "-", 
           RowBox[{"Re", "[", "w0", "]"}]}], ")"}]}], "]"}], 
       FractionBox["1", 
        SuperscriptBox[
         RowBox[{"(", 
          RowBox[{"u", "-", 
           RowBox[{"Re", "[", "u0", "]"}]}], ")"}], "a"]]}], ")"}], "pv"]}]}],
   "\[Equal]", "\[IndentingNewLine]", "\[Equal]", 
  RowBox[{"\[Integral]", 
   RowBox[{
    FractionBox["du", 
     RowBox[{"2", "\[ImaginaryI]"}]], 
    FractionBox["1", "2"], 
    RowBox[{"(", 
     RowBox[{
      SuperscriptBox[
       RowBox[{"(", 
        RowBox[{
         RowBox[{"Coth", "[", 
          RowBox[{"\[Pi]", 
           RowBox[{"(", 
            RowBox[{"u", "-", 
             RowBox[{"Re", "[", "w0", "]"}]}], ")"}]}], "]"}], 
         FractionBox["1", 
          SuperscriptBox[
           RowBox[{"(", 
            RowBox[{"u", "-", 
             RowBox[{"Re", "[", "u0", "]"}]}], ")"}], "a"]]}], ")"}], 
       RowBox[{"[", 
        RowBox[{"+", "o"}], "]"}]], "+", 
      SuperscriptBox[
       RowBox[{"(", 
        RowBox[{
         RowBox[{"Coth", "[", 
          RowBox[{"\[Pi]", 
           RowBox[{"(", 
            RowBox[{"u", "-", 
             RowBox[{"Re", "[", "w0", "]"}]}], ")"}]}], "]"}], 
         FractionBox["1", 
          SuperscriptBox[
           RowBox[{"(", 
            RowBox[{"u", "-", 
             RowBox[{"Re", "[", "u0", "]"}]}], ")"}], "a"]]}], ")"}], 
       RowBox[{"[", 
        RowBox[{"-", "o"}], "]"}]]}], ")"}]}]}], "\[Equal]", 
  "\[IndentingNewLine]", 
  RowBox[{"\[Integral]", 
   RowBox[{
    FractionBox["du", 
     RowBox[{"2", "\[ImaginaryI]"}]], 
    FractionBox["1", "2"], 
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       RowBox[{"Coth", "[", 
        RowBox[{"\[Pi]", 
         RowBox[{"(", 
          RowBox[{"u", "-", 
           RowBox[{"Re", "[", "w0", "]"}], "+", 
           FractionBox[
            RowBox[{"\[ImaginaryI]", " ", "o"}], "2"]}], ")"}]}], "]"}], 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", 
          RowBox[{
           SubsuperscriptBox["\[Eta]", "a", 
            RowBox[{"[", "2", "]"}]], "[", 
           RowBox[{"u", "-", 
            RowBox[{"Re", "[", "u0", "]"}]}], "]"}]}], "+", 
         RowBox[{
          SubsuperscriptBox[
           StyleBox["\[Eta]",
            FontWeight->Bold,
            FontColor->RGBColor[0.8, 0, 0]], "a", 
           RowBox[{"[", "o", "]"}]], "[", 
          RowBox[{"u", "-", 
           RowBox[{"Re", "[", "u0", "]"}]}], "]"}]}], ")"}]}], "+", 
      SuperscriptBox[
       RowBox[{"(", 
        RowBox[{
         RowBox[{"Coth", "[", 
          RowBox[{"\[Pi]", 
           RowBox[{"(", 
            RowBox[{"u", "-", 
             RowBox[{"Re", "[", "w0", "]"}], "-", 
             FractionBox[
              RowBox[{"\[ImaginaryI]", " ", "o"}], "2"]}], ")"}]}], "]"}], 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"-", 
            RowBox[{
             SubsuperscriptBox["\[Eta]", "a", 
              RowBox[{"[", "2", "]"}]], "[", 
             RowBox[{"u", "-", 
              RowBox[{"Re", "[", "u0", "]"}]}], "]"}]}], "+", 
           RowBox[{
            SubsuperscriptBox[
             StyleBox["\[Eta]",
              FontWeight->Bold,
              FontColor->RGBColor[0.8, 0, 0]], "a", 
             RowBox[{"[", 
              RowBox[{"-", "o"}], "]"}]], "[", 
            RowBox[{"u", "-", 
             RowBox[{"Re", "[", "u0", "]"}]}], "]"}]}], ")"}]}], ")"}], 
       RowBox[{"[", 
        RowBox[{"-", "o"}], "]"}]]}], ")"}]}]}], "\[Equal]", 
  "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{"\[Integral]", 
    RowBox[{
     FractionBox["du", 
      RowBox[{"2", "\[ImaginaryI]"}]], 
     FractionBox["1", "2"], 
     RowBox[{"(", 
      RowBox[{
       RowBox[{
        RowBox[{"Coth", "[", 
         RowBox[{"\[Pi]", 
          RowBox[{"(", 
           RowBox[{"u", "-", 
            RowBox[{"Re", "[", "w0", "]"}], "+", 
            FractionBox[
             RowBox[{"\[ImaginaryI]", " ", "o"}], "2"]}], ")"}]}], "]"}], 
        RowBox[{"(", 
         RowBox[{
          SubsuperscriptBox[
           StyleBox["\[Eta]",
            FontWeight->Bold,
            FontColor->RGBColor[0.8, 0, 0]], "a", 
           RowBox[{"[", "o", "]"}]], "[", 
          RowBox[{"u", "-", 
           RowBox[{"Re", "[", "u0", "]"}]}], "]"}], ")"}]}], "+", 
       SuperscriptBox[
        RowBox[{"(", 
         RowBox[{
          RowBox[{"Coth", "[", 
           RowBox[{"\[Pi]", 
            RowBox[{"(", 
             RowBox[{"u", "-", 
              RowBox[{"Re", "[", "w0", "]"}], "-", 
              FractionBox[
               RowBox[{"\[ImaginaryI]", " ", "o"}], "2"]}], ")"}]}], "]"}], 
          RowBox[{"(", 
           RowBox[{
            SubsuperscriptBox[
             StyleBox["\[Eta]",
              FontWeight->Bold,
              FontColor->RGBColor[0.8, 0, 0]], "a", 
             RowBox[{"[", 
              RowBox[{"-", "o"}], "]"}]], "[", 
            RowBox[{"u", "-", 
             RowBox[{"Re", "[", "u0", "]"}]}], "]"}], ")"}]}], ")"}], 
        RowBox[{"[", 
         RowBox[{"-", "o"}], "]"}]]}], ")"}]}]}], "-", "\[IndentingNewLine]", 
   
   RowBox[{"-", 
    RowBox[{"\[Integral]", 
     RowBox[{
      FractionBox["du", 
       RowBox[{"2", "\[ImaginaryI]"}]], 
      FractionBox["1", "2"], 
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         RowBox[{"Coth", "[", 
          RowBox[{"\[Pi]", 
           RowBox[{"(", 
            RowBox[{"u", "-", 
             RowBox[{"Re", "[", "w0", "]"}], "+", 
             FractionBox[
              RowBox[{"\[ImaginaryI]", " ", "o"}], "2"]}], ")"}]}], "]"}], 
         RowBox[{"(", 
          RowBox[{
           SubsuperscriptBox[
            StyleBox["\[Eta]",
             FontWeight->Bold,
             FontColor->RGBColor[0.8, 0, 0]], "a", 
            RowBox[{"[", "2", "]"}]], "[", 
           RowBox[{"u", "-", 
            RowBox[{"Re", "[", "u0", "]"}]}], "]"}], ")"}]}], "+", 
        SuperscriptBox[
         RowBox[{"(", 
          RowBox[{
           RowBox[{"Coth", "[", 
            RowBox[{"\[Pi]", 
             RowBox[{"(", 
              RowBox[{"u", "-", 
               RowBox[{"Re", "[", "w0", "]"}], "-", 
               FractionBox[
                RowBox[{"\[ImaginaryI]", " ", "o"}], "2"]}], ")"}]}], "]"}], 
           RowBox[{"(", 
            RowBox[{
             SubsuperscriptBox[
              StyleBox["\[Eta]",
               FontWeight->Bold,
               FontColor->RGBColor[0.8, 0, 0]], "a", 
              RowBox[{"[", "2", "]"}]], "[", 
             RowBox[{"u", "-", 
              RowBox[{"Re", "[", "u0", "]"}]}], "]"}], ")"}]}], ")"}], 
         RowBox[{"[", 
          RowBox[{"-", "o"}], "]"}]]}], ")"}]}]}]}]}], "\[Equal]", 
  "\[IndentingNewLine]", "==", 
  RowBox[{"\[Integral]", 
   RowBox[{
    FractionBox["du", 
     RowBox[{"2", "\[ImaginaryI]"}]], 
    FractionBox["1", "2"], 
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       RowBox[{"Coth", "[", 
        RowBox[{"\[Pi]", 
         RowBox[{"(", 
          RowBox[{"u", "-", 
           RowBox[{"Re", "[", "w0", "]"}], "+", 
           FractionBox[
            RowBox[{"\[ImaginaryI]", " ", "o"}], "2"]}], ")"}]}], "]"}], 
       RowBox[{"(", 
        RowBox[{
         SubsuperscriptBox[
          StyleBox["\[Eta]",
           FontWeight->Bold,
           FontColor->RGBColor[0.8, 0, 0]], "a", 
          RowBox[{"[", "o", "]"}]], "[", 
         RowBox[{"u", "-", 
          RowBox[{"Re", "[", "u0", "]"}]}], "]"}], ")"}]}], "+", 
      SuperscriptBox[
       RowBox[{"(", 
        RowBox[{
         RowBox[{"Coth", "[", 
          RowBox[{"\[Pi]", 
           RowBox[{"(", 
            RowBox[{"u", "-", 
             RowBox[{"Re", "[", "w0", "]"}], "-", 
             FractionBox[
              RowBox[{"\[ImaginaryI]", " ", "o"}], "2"]}], ")"}]}], "]"}], 
         RowBox[{"(", 
          RowBox[{
           SubsuperscriptBox[
            StyleBox["\[Eta]",
             FontWeight->Bold,
             FontColor->RGBColor[0.8, 0, 0]], "a", 
            RowBox[{"[", 
             RowBox[{"-", "o"}], "]"}]], "[", 
           RowBox[{"u", "-", 
            RowBox[{"Re", "[", "u0", "]"}]}], "]"}], ")"}]}], ")"}], 
       RowBox[{"[", 
        RowBox[{"-", "o"}], "]"}]]}], ")"}]}]}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    FractionBox["1", "2"], 
    RowBox[{
     SubsuperscriptBox[
      StyleBox["\[Eta]",
       FontWeight->Bold,
       FontColor->RGBColor[0.8, 0, 0]], "a", 
      RowBox[{"[", "2", "]"}]], "[", 
     RowBox[{
      RowBox[{"Re", "[", "w0", "]"}], "-", 
      RowBox[{"Re", "[", "u0", "]"}]}], "]"}]}], "-", 
   RowBox[{"\[Integral]", 
    RowBox[{
     FractionBox["du", 
      RowBox[{"2", "\[ImaginaryI]"}]], 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"Coth", "[", 
        RowBox[{"\[Pi]", 
         RowBox[{"(", 
          RowBox[{"u", "-", 
           RowBox[{"Re", "[", "w0", "]"}], "-", 
           FractionBox[
            RowBox[{"\[ImaginaryI]", " ", "o"}], "2"]}], ")"}]}], "]"}], 
       RowBox[{"(", 
        RowBox[{
         SubsuperscriptBox[
          StyleBox["\[Eta]",
           FontWeight->Bold,
           FontColor->RGBColor[0.8, 0, 0]], "a", 
          RowBox[{"[", "2", "]"}]], "[", 
         RowBox[{"u", "-", 
          RowBox[{"Re", "[", "u0", "]"}]}], "]"}], ")"}]}], ")"}]}]}]}], 
  "\[Equal]", "\[IndentingNewLine]", "==", 
  RowBox[{"\[Integral]", 
   RowBox[{
    FractionBox["du", 
     RowBox[{"2", "\[ImaginaryI]"}]], 
    FractionBox["1", "2"], 
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       RowBox[{"Coth", "[", 
        RowBox[{"\[Pi]", 
         RowBox[{"(", 
          RowBox[{"u", "-", 
           RowBox[{"Re", "[", "w0", "]"}], "+", 
           FractionBox[
            RowBox[{"\[ImaginaryI]", " ", "o"}], "2"]}], ")"}]}], "]"}], 
       RowBox[{"(", 
        RowBox[{
         SubsuperscriptBox[
          StyleBox["\[Eta]",
           FontWeight->Bold,
           FontColor->RGBColor[0.8, 0, 0]], "a", 
          RowBox[{"[", "o", "]"}]], "[", 
         RowBox[{"u", "-", 
          RowBox[{"Re", "[", "u0", "]"}]}], "]"}], ")"}]}], "+", 
      SuperscriptBox[
       RowBox[{"(", 
        RowBox[{
         RowBox[{"Coth", "[", 
          RowBox[{"\[Pi]", 
           RowBox[{"(", 
            RowBox[{"u", "-", 
             RowBox[{"Re", "[", "w0", "]"}], "-", 
             FractionBox[
              RowBox[{"\[ImaginaryI]", " ", "o"}], "2"]}], ")"}]}], "]"}], 
         RowBox[{"(", 
          RowBox[{
           SubsuperscriptBox[
            StyleBox["\[Eta]",
             FontWeight->Bold,
             FontColor->RGBColor[0.8, 0, 0]], "a", 
            RowBox[{"[", 
             RowBox[{"-", "o"}], "]"}]], "[", 
           RowBox[{"u", "-", 
            RowBox[{"Re", "[", "u0", "]"}]}], "]"}], ")"}]}], ")"}], 
       RowBox[{"[", 
        RowBox[{"-", "o"}], "]"}]]}], ")"}]}]}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    FractionBox["1", "2"], 
    RowBox[{
     SubsuperscriptBox[
      StyleBox["\[Eta]",
       FontWeight->Bold,
       FontColor->RGBColor[0.8, 0, 0]], "a", 
      RowBox[{"[", "2", "]"}]], "[", 
     RowBox[{
      RowBox[{"Re", "[", "w0", "]"}], "-", 
      RowBox[{"Re", "[", "u0", "]"}]}], "]"}]}], "-", 
   RowBox[{"\[Integral]", 
    RowBox[{
     FractionBox["du", 
      RowBox[{"2", "\[ImaginaryI]"}]], 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"Coth", "[", 
        RowBox[{"\[Pi]", 
         RowBox[{"(", 
          RowBox[{"u", "-", 
           RowBox[{"Re", "[", "w0", "]"}], "+", 
           FractionBox[
            RowBox[{"\[ImaginaryI]", " ", "o"}], "2"]}], ")"}]}], "]"}], 
       RowBox[{"(", 
        RowBox[{
         SubsuperscriptBox[
          StyleBox["\[Eta]",
           FontWeight->Bold,
           FontColor->RGBColor[0.8, 0, 0]], "a", 
          RowBox[{"[", 
           RowBox[{"+", "o"}], "]"}]], "[", 
         RowBox[{"u", "-", 
          RowBox[{"Re", "[", "u0", "]"}]}], "]"}], ")"}]}], ")"}]}]}]}], 
  "\[Equal]", "\[IndentingNewLine]", "==", 
  RowBox[{
   RowBox[{
    FractionBox["1", "2"], 
    RowBox[{
     SubsuperscriptBox[
      StyleBox["\[Eta]",
       FontWeight->Bold,
       FontColor->RGBColor[0.8, 0, 0]], "a", 
      RowBox[{"[", "2", "]"}]], "[", 
     RowBox[{
      RowBox[{"Re", "[", "w0", "]"}], "-", 
      RowBox[{"Re", "[", "u0", "]"}]}], "]"}]}], "+", 
   RowBox[{"\[Integral]", 
    RowBox[{
     FractionBox["du", 
      RowBox[{"2", "\[ImaginaryI]"}]], 
     FractionBox["1", "2"], 
     RowBox[{"(", 
      RowBox[{
       RowBox[{
        RowBox[{"-", 
         RowBox[{"Coth", "[", 
          RowBox[{"\[Pi]", 
           RowBox[{"(", 
            RowBox[{"u", "-", 
             RowBox[{"Re", "[", "w0", "]"}], "+", 
             FractionBox[
              RowBox[{"\[ImaginaryI]", " ", "o"}], "2"]}], ")"}]}], "]"}]}], 
        RowBox[{"(", 
         RowBox[{
          SubsuperscriptBox[
           StyleBox["\[Eta]",
            FontWeight->Bold,
            FontColor->RGBColor[0.8, 0, 0]], "a", 
           RowBox[{"[", "o", "]"}]], "[", 
          RowBox[{"u", "-", 
           RowBox[{"Re", "[", "u0", "]"}]}], "]"}], ")"}]}], "+", 
       SuperscriptBox[
        RowBox[{"(", 
         RowBox[{
          RowBox[{"Coth", "[", 
           RowBox[{"\[Pi]", 
            RowBox[{"(", 
             RowBox[{"u", "-", 
              RowBox[{"Re", "[", "w0", "]"}], "-", 
              FractionBox[
               RowBox[{"\[ImaginaryI]", " ", "o"}], "2"]}], ")"}]}], "]"}], 
          RowBox[{"(", 
           RowBox[{
            SubsuperscriptBox[
             StyleBox["\[Eta]",
              FontWeight->Bold,
              FontColor->RGBColor[0.8, 0, 0]], "a", 
             RowBox[{"[", 
              RowBox[{"-", "o"}], "]"}]], "[", 
            RowBox[{"u", "-", 
             RowBox[{"Re", "[", "u0", "]"}]}], "]"}], ")"}]}], ")"}], 
        RowBox[{"[", 
         RowBox[{"-", "o"}], "]"}]]}], ")"}]}]}]}], "\[Equal]", 
  "\[IndentingNewLine]", "==", 
  RowBox[{
   RowBox[{
    FractionBox["1", "2"], 
    RowBox[{
     SubsuperscriptBox[
      StyleBox["\[Eta]",
       FontWeight->Bold,
       FontColor->RGBColor[0.8, 0, 0]], "a", 
      RowBox[{"[", "2", "]"}]], "[", 
     RowBox[{
      RowBox[{"Re", "[", "w0", "]"}], "-", 
      RowBox[{"Re", "[", "u0", "]"}]}], "]"}]}], "+", 
   RowBox[{
    FractionBox["1", "2"], 
    RowBox[{"(", 
     RowBox[{
      SubsuperscriptBox["\[Eta]", "a", 
       RowBox[{"[", 
        RowBox[{"-", "o"}], "]"}]], "[", 
      RowBox[{
       RowBox[{"Re", "[", "w0", "]"}], "-", 
       RowBox[{"Re", "[", "u0", "]"}]}], "]"}], ")"}]}], "+", 
   RowBox[{
    FractionBox["1", "2"], 
    FractionBox["\[Pi]", 
     RowBox[{"Gamma", "[", "a", "]"}]], 
    RowBox[{
     SubsuperscriptBox["\[PartialD]", "u0", 
      RowBox[{"a", "-", "1"}]], 
     RowBox[{"Coth", "[", 
      RowBox[{"\[Pi]", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"Re", "[", "u0", "]"}], "-", 
         RowBox[{"Re", "[", "w0", "]"}]}], ")"}]}], "]"}]}]}]}]}]}], "Input",
 CellChangeTimes->{{3.56351955889954*^9, 3.563519641191572*^9}, {
  3.5635197241310863`*^9, 3.563519980907192*^9}, {3.563520139309733*^9, 
  3.56352020453301*^9}, {3.5635202672815866`*^9, 3.563520307881925*^9}, {
  3.563520378179941*^9, 3.5635204168741083`*^9}, {3.5635204527381487`*^9, 
  3.563520503916407*^9}, {3.563520885918481*^9, 3.563520886143852*^9}}],

Cell[BoxData[
 RowBox[{"\[Integral]", 
  RowBox[{
   FractionBox["du", 
    RowBox[{"2", "\[ImaginaryI]"}]], 
   FractionBox["1", "2"], 
   RowBox[{"(", 
    RowBox[{
     RowBox[{
      RowBox[{"Coth", "[", 
       RowBox[{"\[Pi]", 
        RowBox[{"(", 
         RowBox[{"u", "-", 
          RowBox[{"Re", "[", "w0", "]"}], "+", 
          FractionBox[
           RowBox[{"\[ImaginaryI]", " ", "o"}], "2"]}], ")"}]}], "]"}], 
      RowBox[{"(", 
       RowBox[{
        SubsuperscriptBox[
         StyleBox["\[Eta]",
          FontWeight->Bold,
          FontColor->RGBColor[0.8, 0, 0]], "a", 
         RowBox[{"[", "o", "]"}]], "[", 
        RowBox[{"u", "-", 
         RowBox[{"Re", "[", "u0", "]"}]}], "]"}], ")"}]}], "+", 
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{
        RowBox[{"Coth", "[", 
         RowBox[{"\[Pi]", 
          RowBox[{"(", 
           RowBox[{"u", "-", 
            RowBox[{"Re", "[", "w0", "]"}], "-", 
            FractionBox[
             RowBox[{"\[ImaginaryI]", " ", "o"}], "2"]}], ")"}]}], "]"}], 
        RowBox[{"(", 
         RowBox[{
          SubsuperscriptBox[
           StyleBox["\[Eta]",
            FontWeight->Bold,
            FontColor->RGBColor[0.8, 0, 0]], "a", 
           RowBox[{"[", 
            RowBox[{"-", "o"}], "]"}]], "[", 
          RowBox[{"u", "-", 
           RowBox[{"Re", "[", "u0", "]"}]}], "]"}], ")"}]}], ")"}], 
      RowBox[{"[", 
       RowBox[{"-", "o"}], "]"}]]}], ")"}]}]}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{"myanswer", "[", 
   RowBox[{"w0_", ",", "u0_", ",", "a_"}], "]"}], ":=", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     RowBox[{
      RowBox[{
       FractionBox["1", "2"], 
       RowBox[{
        RowBox[{"\[Eta]$", "[", "a", "]"}], "[", "2", "]"}]}], "+", 
      RowBox[{
       FractionBox["1", "2"], 
       RowBox[{
        RowBox[{"\[Eta]$", "[", "a", "]"}], "[", "0", "]"}]}]}], "/.", 
     "subtoPolyGammas"}], ")"}], "/.", 
   RowBox[{"u", "\[Rule]", 
    RowBox[{
     RowBox[{"Re", "[", "w0", "]"}], "-", 
     RowBox[{"Re", "[", "u0", "]"}], "+", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{
        FractionBox["1", "2"], 
        FractionBox["\[Pi]", 
         RowBox[{"Gamma", "[", "a", "]"}]], 
        RowBox[{"D", "[", 
         RowBox[{
          RowBox[{"Coth", "[", 
           RowBox[{"\[Pi]", " ", "u"}], "]"}], ",", 
          RowBox[{"{", 
           RowBox[{"u", ",", "a"}], "}"}]}], "]"}]}], "/.", 
       RowBox[{"u", "\[Rule]", 
        RowBox[{
         RowBox[{"Re", "[", "u0", "]"}], "-", 
         RowBox[{"Re", "[", "w0", "]"}]}]}]}], ")"}]}]}]}]}]], "Input",
 CellChangeTimes->{{3.563520691201981*^9, 3.5635206932734222`*^9}, {
  3.56352073198353*^9, 3.563520817806018*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"With", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"u0", "=", 
      RowBox[{"Random", "[", "]"}]}], ",", 
     RowBox[{"w0", "=", 
      RowBox[{"Random", "[", "]"}]}], ",", 
     RowBox[{"a", "=", "3"}]}], "}"}], ",", 
   RowBox[{
    FractionBox["1", "2"], 
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{"NIntegrate", "[", 
        RowBox[{
         RowBox[{
          RowBox[{
           FractionBox["1", 
            RowBox[{"2", "\[ImaginaryI]"}]], 
           FractionBox["1", "2"], 
           RowBox[{"Coth", "[", 
            RowBox[{"\[Pi]", 
             RowBox[{"(", 
              RowBox[{"u", "-", 
               RowBox[{"Re", "[", "w0", "]"}]}], ")"}]}], "]"}], 
           RowBox[{"(", 
            FractionBox["1", 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{"u", "-", 
                RowBox[{"Re", "[", "u0", "]"}]}], ")"}], "a"]], ")"}]}], "/.", 
          RowBox[{"u", "\[Rule]", 
           RowBox[{"t", "+", 
            RowBox[{"\[ImaginaryI]", "/", "4"}]}]}]}], ",", 
         RowBox[{"{", 
          RowBox[{"t", ",", 
           RowBox[{"-", "\[Infinity]"}], ",", 
           RowBox[{"+", "\[Infinity]"}]}], "}"}]}], "]"}], "+", 
       RowBox[{"NIntegrate", "[", 
        RowBox[{
         RowBox[{
          RowBox[{
           FractionBox["1", 
            RowBox[{"2", "\[ImaginaryI]"}]], 
           FractionBox["1", "2"], 
           RowBox[{"Coth", "[", 
            RowBox[{"\[Pi]", 
             RowBox[{"(", 
              RowBox[{"u", "-", 
               RowBox[{"Re", "[", "w0", "]"}]}], ")"}]}], "]"}], 
           RowBox[{"(", 
            FractionBox["1", 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{"u", "-", 
                RowBox[{"Re", "[", "u0", "]"}]}], ")"}], "a"]], ")"}]}], "/.", 
          RowBox[{"u", "\[Rule]", 
           RowBox[{"t", "-", 
            RowBox[{"\[ImaginaryI]", "/", "4"}]}]}]}], ",", 
         RowBox[{"{", 
          RowBox[{"t", ",", 
           RowBox[{"-", "\[Infinity]"}], ",", "0", ",", 
           RowBox[{"+", "\[Infinity]"}]}], "}"}]}], "]"}]}], ")"}], "/", 
     RowBox[{"myanswer", "[", 
      RowBox[{"w0", ",", "u0", ",", "a"}], "]"}]}]}]}], "]"}]], "Input",
 CellChangeTimes->{{3.563520534245034*^9, 3.5635206878143883`*^9}, {
  3.563520821243986*^9, 3.563520827066514*^9}, {3.563520868553896*^9, 
  3.563520868812154*^9}, {3.563521073291664*^9, 3.563521091974237*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"-", "668.6121693039929`"}], "+", 
  RowBox[{"0.`", " ", "\[ImaginaryI]"}]}]], "Output",
 CellChangeTimes->{{3.5635206441049433`*^9, 3.563520679778164*^9}, {
  3.5635208278172693`*^9, 3.563520831247528*^9}, {3.563520869511469*^9, 
  3.563520874438751*^9}, {3.5635210927627907`*^9, 3.5635210960105047`*^9}}]
}, Open  ]],

Cell[BoxData[
 RowBox[{"\[Integral]", 
  RowBox[{
   FractionBox["du", 
    RowBox[{"2", "\[ImaginaryI]"}]], 
   RowBox[{"Coth", "[", 
    RowBox[{"\[Pi]", 
     RowBox[{"(", 
      RowBox[{"u", "-", 
       RowBox[{"Re", "[", "w0", "]"}], "+", 
       FractionBox[
        RowBox[{"\[ImaginaryI]", " ", "o"}], "2"]}], ")"}]}], "]"}], 
   RowBox[{"(", 
    RowBox[{
     SubsuperscriptBox[
      StyleBox["\[Eta]",
       FontWeight->Bold,
       FontColor->RGBColor[0.8, 0, 0]], "a", 
      RowBox[{"[", "o", "]"}]], "[", 
     RowBox[{"u", "-", 
      RowBox[{"Re", "[", "u0", "]"}]}], "]"}], ")"}]}]}]], "Input",
 CellChangeTimes->{{3.563520895032405*^9, 3.5635209044785137`*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"With", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"a", "=", "0"}], "}"}], ",", 
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{"UpIntegrate", "[", 
        RowBox[{
         RowBox[{
          RowBox[{
           RowBox[{
            RowBox[{
             RowBox[{
              FractionBox["1", 
               RowBox[{"2", "\[Pi]", " ", "\[ImaginaryI]"}]], 
              FractionBox["1", "2"], 
              RowBox[{"(", 
               RowBox[{
                SubsuperscriptBox[
                 OverscriptBox["\[Eta]", "_"], "1", 
                 RowBox[{"[", 
                  RowBox[{
                   RowBox[{"-", "2"}], "+", 
                   RowBox[{"2", "\[ImaginaryI]", " ", 
                    RowBox[{"Re", "[", "w0", "]"}]}]}], "]"}]], "+", 
                SubsuperscriptBox["\[Eta]", "1", 
                 RowBox[{"[", 
                  RowBox[{"2", "\[ImaginaryI]", " ", 
                   RowBox[{"Re", "[", "w0", "]"}]}], "]"}]]}], ")"}], 
              RowBox[{"(", 
               FractionBox["1", 
                SuperscriptBox[
                 RowBox[{"(", 
                  RowBox[{"u", "-", 
                   RowBox[{"Re", "[", "u0", "]"}]}], ")"}], "a"]], ")"}]}], "/.", 
             RowBox[{"Shift", "[", 
              RowBox[{"+", "\[Epsilon]"}], "]"}]}], "/.", 
            RowBox[{"u", "\[Rule]", 
             RowBox[{"u", "+", 
              FractionBox[
               RowBox[{"\[ImaginaryI]", " ", "\[Epsilon]"}], "2"]}]}]}], "/.", 
           RowBox[{"w0", "\[Rule]", 
            RowBox[{"Zeta", "[", "137", "]"}]}]}], "/.", 
          RowBox[{"u0", "\[Rule]", 
           RowBox[{"Zeta", "[", "139", "]"}]}]}], ",", "u"}], "]"}], "+", 
       RowBox[{"UpIntegrate", "[", 
        RowBox[{
         RowBox[{
          RowBox[{
           RowBox[{
            RowBox[{
             RowBox[{
              FractionBox["1", 
               RowBox[{"2", "\[Pi]", " ", "\[ImaginaryI]"}]], 
              FractionBox["1", "2"], 
              RowBox[{"(", 
               RowBox[{
                SubsuperscriptBox[
                 OverscriptBox["\[Eta]", "_"], "1", 
                 RowBox[{"[", 
                  RowBox[{
                   RowBox[{"-", "2"}], "+", 
                   RowBox[{"2", "\[ImaginaryI]", " ", 
                    RowBox[{"Re", "[", "w0", "]"}]}]}], "]"}]], "+", 
                SubsuperscriptBox["\[Eta]", "1", 
                 RowBox[{"[", 
                  RowBox[{"2", "\[ImaginaryI]", " ", 
                   RowBox[{"Re", "[", "w0", "]"}]}], "]"}]]}], ")"}], 
              RowBox[{"(", 
               FractionBox["1", 
                SuperscriptBox[
                 RowBox[{"(", 
                  RowBox[{"u", "-", 
                   RowBox[{"Re", "[", "u0", "]"}]}], ")"}], "a"]], ")"}]}], "/.", 
             RowBox[{"Shift", "[", 
              RowBox[{"+", "\[Epsilon]"}], "]"}]}], "/.", 
            RowBox[{"u", "\[Rule]", 
             RowBox[{"u", "+", 
              FractionBox[
               RowBox[{"\[ImaginaryI]", " ", "\[Epsilon]"}], "2"]}]}]}], "/.", 
           RowBox[{"w0", "\[Rule]", 
            RowBox[{"Zeta", "[", "137", "]"}]}]}], "/.", 
          RowBox[{"u0", "\[Rule]", 
           RowBox[{"Zeta", "[", "139", "]"}]}]}], ",", "u"}], "]"}], "-", 
       RowBox[{
        RowBox[{"\[Eta]$", "[", "a", "]"}], "[", 
        RowBox[{"2", "+", 
         RowBox[{"2", "\[ImaginaryI]", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"Zeta", "[", "139", "]"}], "-", 
            RowBox[{"Zeta", "[", "137", "]"}]}], ")"}]}]}], "]"}]}], "/.", 
      "subtoPolyGammas"}], "/.", 
     RowBox[{"u", "\[Rule]", "0"}]}]}], "]"}], "//", 
  "FullSimplify"}]], "Input",
 CellChangeTimes->{{3.563520897086087*^9, 3.563521067459646*^9}, {
  3.563521102438792*^9, 3.563521299081814*^9}, {3.56352153708461*^9, 
  3.563521546345553*^9}}],

Cell[BoxData["0"], "Output",
 CellChangeTimes->{{3.563520983823964*^9, 3.563521041839679*^9}, {
  3.563521121554172*^9, 3.5635211495638437`*^9}, {3.563521182255789*^9, 
  3.5635212993257*^9}, {3.563521537605953*^9, 3.563521546822351*^9}}]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"\[Eta]$", "[", "2", "]"}], "["}]], "Input",
 CellChangeTimes->{{3.5635211525768127`*^9, 3.563521154851033*^9}}],

Cell[BoxData[
 FractionBox["1", 
  RowBox[{"u", "-", 
   RowBox[{"Re", "[", "w0", "]"}], "+", 
   RowBox[{"\[ImaginaryI]", " ", "0"}], "-", "\[ImaginaryI]"}]]], "Input",
 CellChangeTimes->{{3.563520000574276*^9, 3.56352001245015*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   FractionBox[
    RowBox[{
     SubsuperscriptBox[
      OverscriptBox["\[Eta]", "_"], "1", 
      RowBox[{"[", "0", "]"}]], "+", 
     SubsuperscriptBox["\[Eta]", "1", 
      RowBox[{"[", "2", "]"}]]}], "\[Pi]"], "/.", "subtoPolyGammas"}], "//", 
  "FullSimplify"}]], "Input",
 CellChangeTimes->{{3.563519362026678*^9, 3.5635194132836733`*^9}}],

Cell[BoxData[
 RowBox[{"Coth", "[", 
  RowBox[{"\[Pi]", " ", "u"}], "]"}]], "Output",
 CellChangeTimes->{{3.563519405247023*^9, 3.563519414364002*^9}}]
}, Open  ]],

Cell["\<\
Now we can expand Coth in the double scaling and be happy.\
\>", "Text",
 CellChangeTimes->{{3.563515626463663*^9, 3.56351564679103*^9}}],

Cell[TextData[{
 "Now we should compute ",
 Cell[BoxData[
  RowBox[{"Log", "[", 
   FractionBox[
    RowBox[{
     SubscriptBox["Y", 
      RowBox[{"1", ",", "1"}]], 
     SubscriptBox["Y", 
      RowBox[{"2", ",", "2"}]]}], 
    SubscriptBox[
     RowBox[{"(", 
      RowBox[{
       SubscriptBox["Y", 
        RowBox[{"1", ",", "1"}]], 
       SubscriptBox["Y", 
        RowBox[{"2", ",", "2"}]]}], ")"}], "asym"]], "]"}]],
  CellChangeTimes->{{3.547966491674753*^9, 3.547966543809491*^9}, {
    3.547966856640164*^9, 3.5479668725649157`*^9}, {3.5479669237629766`*^9, 
    3.547966932264473*^9}, 3.55219692680199*^9}],
 " in the ordinary regime. This expression decreases at infinity and it is \
odd (as a function slightly above real axis). Sign[v] is still needed to make \
integral convergent (PV does not help), but it evenuatlly produces a constant \
which is irrelevant due to subsequent integration with \[ScriptCapitalZ]. \
Hence we have to symbolically compute"
}], "Text",
 CellChangeTimes->{{3.5521974405406218`*^9, 3.552197528901947*^9}, {
  3.552197560692713*^9, 3.5521975641335907`*^9}, {3.555938369452853*^9, 
  3.5559384729127283`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   SubscriptBox["\[Integral]", 
    OverscriptBox["Z", "\[Vee]"]], 
   RowBox[{
    FractionBox["dv", 
     RowBox[{"2", "\[ImaginaryI]"}]], 
    RowBox[{"(", 
     RowBox[{"Coth", "[", 
      RowBox[{"\[Pi]", 
       RowBox[{"(", 
        RowBox[{"u", "-", "v"}], ")"}]}], "]"}], ")"}], "Yf"}]}], ",", " ", 
  RowBox[{"Yf", "=", 
   RowBox[{"Log", "[", 
    FractionBox[
     RowBox[{
      SubscriptBox["Y", 
       RowBox[{"1", ",", "1"}]], 
      SubscriptBox["Y", 
       RowBox[{"2", ",", "2"}]]}], 
     SubscriptBox[
      RowBox[{"(", 
       RowBox[{
        SubscriptBox["Y", 
         RowBox[{"1", ",", "1"}]], 
        SubscriptBox["Y", 
         RowBox[{"2", ",", "2"}]]}], ")"}], "asym"]], "]"}]}]}]], "Input",
 CellChangeTimes->{
  3.552199536107751*^9, {3.555928500588642*^9, 3.555928518580277*^9}}],

Cell["\<\
up to a regularization constant which can be chosen arbitrarily.\
\>", "Text",
 CellChangeTimes->{{3.555938475055812*^9, 3.5559384897913837`*^9}}],

Cell["We will use the fact that", "Text",
 CellChangeTimes->{{3.5559285595490227`*^9, 3.5559285660448017`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"\[Pi]", " ", 
   RowBox[{"Coth", "[", 
    RowBox[{"\[Pi]", " ", "u"}], "]"}]}], "==", 
  RowBox[{
   FractionBox["1", "u"], "+", 
   RowBox[{"(*", " ", 
    RowBox[{
    "expression", " ", "which", " ", "is", " ", "regular", " ", "on", " ", 
     "the", " ", "real", " ", "axis"}], " ", "*)"}]}]}]], "Input",
 CellChangeTimes->{{3.5559285738655577`*^9, 3.5559285790731163`*^9}, {
  3.5559287282768908`*^9, 3.555928752624527*^9}}],

Cell["Hence we are dealing sith integral", "Text",
 CellChangeTimes->{{3.555928581774694*^9, 3.555928586124208*^9}}],

Cell[BoxData[
 RowBox[{
  SubscriptBox["\[Integral]", 
   OverscriptBox["Z", "\[Vee]"]], 
  RowBox[{
   FractionBox["dv", 
    RowBox[{"2", "\[Pi]", " ", "\[ImaginaryI]"}]], 
   RowBox[{"(", 
    RowBox[{
     FractionBox["1", 
      RowBox[{"u", "-", "v"}]], "+", "reg"}], ")"}], "Yf"}]}]], "Input",
 CellChangeTimes->{{3.555928588566545*^9, 3.555928603166411*^9}, {
  3.5559287640835*^9, 3.555928775097156*^9}}],

Cell[TextData[{
 "For the regular piece we can extend integration to the whole real line by \
using ",
 Cell[BoxData[
  FormBox[
   SubscriptBox[
    OverscriptBox["Yf", "^"], "pv"], TraditionalForm]]],
 ". Now we will treat the pole appropriately, for u being on ",
 Cell[BoxData[
  FormBox[
   OverscriptBox["Z", "^"], TraditionalForm]]],
 ":"
}], "Text",
 CellChangeTimes->{{3.5559287726935863`*^9, 3.5559288227638483`*^9}, {
  3.555928911922014*^9, 3.5559289670950317`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   SubscriptBox["\[Integral]", 
    OverscriptBox["Z", "\[Vee]"]], 
   RowBox[{
    FractionBox["dv", 
     RowBox[{"2", "\[Pi]", " ", "\[ImaginaryI]"}]], 
    FractionBox["1", 
     RowBox[{"u", "-", "v"}]], "Yf"}]}], "=", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{"-", 
     RowBox[{"\[Integral]", 
      RowBox[{
       FractionBox["dv", 
        RowBox[{
         RowBox[{"-", "2"}], "\[Pi]", " ", "\[ImaginaryI]"}]], 
       FractionBox["1", "2"], 
       RowBox[{"(", 
        RowBox[{
         FractionBox[
          SuperscriptBox["Yf", 
           RowBox[{"[", 
            RowBox[{"-", "o"}], "]"}]], 
          RowBox[{"u", "-", 
           RowBox[{"(", 
            RowBox[{"v", "-", 
             RowBox[{"\[ImaginaryI]", " ", "o"}]}], ")"}]}]], "+", 
         FractionBox[
          SuperscriptBox["Yf", 
           RowBox[{"[", 
            RowBox[{"+", "o"}], "]"}]], 
          RowBox[{"u", "-", 
           RowBox[{"(", 
            RowBox[{"v", "+", 
             RowBox[{"\[ImaginaryI]", " ", "o"}]}], ")"}]}]]}], ")"}]}]}]}], 
    ")"}], "-", 
   RowBox[{
    FractionBox["1", "2"], 
    SuperscriptBox["Yf", 
     RowBox[{"[", 
      RowBox[{"+", "o"}], "]"}]]}]}]}]], "Input",
 CellChangeTimes->{{3.555928929165043*^9, 3.555928931209879*^9}, {
  3.555928970777697*^9, 3.5559290435509653`*^9}, {3.555929109640674*^9, 
  3.5559291600332413`*^9}}],

Cell["\<\
The second term precisely cancels 1/2 term from Y11Y22 piece above. Hence \
genuine contribution from \[ScriptCapitalF] will come from the integral\
\>", "Text",
 CellChangeTimes->{{3.555929174968452*^9, 3.555929239891765*^9}}],

Cell[BoxData[
 RowBox[{"\[Integral]", 
  RowBox[{
   FractionBox["dv", 
    RowBox[{"2", "\[ImaginaryI]"}]], 
   SubscriptBox[
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"Coth", "[", 
        RowBox[{"\[Pi]", 
         RowBox[{"(", 
          RowBox[{"u", "-", "v"}], ")"}]}], "]"}], ")"}], 
      OverscriptBox["Yf", "^"]}], ")"}], "pv"]}]}]], "Input",
 CellChangeTimes->{{3.555929255920342*^9, 3.5559293013670597`*^9}}],

Cell["\<\
This is still a double integral, but we are able to take one integral \
explicitly. Indeed, recall explicit expression for Im[u]>0:\
\>", "Text",
 CellChangeTimes->{{3.55592930562554*^9, 3.555929333248526*^9}, {
  3.5559294491797667`*^9, 3.5559294548036337`*^9}, {3.55592958102558*^9, 
  3.555929584111412*^9}, {3.5559385248066883`*^9, 3.555938528982328*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   OverscriptBox["H", "_"], "[", "u", "]"}], "=", 
  RowBox[{"H", "[", 
   RowBox[{"-", "u"}], "]"}], " ", 
  RowBox[{"(*", " ", 
   RowBox[{
    RowBox[{"it", " ", "is", " ", "a", " ", "property"}], ",", " ", 
    RowBox[{"not", " ", "a", " ", "definition"}]}], " ", "*)"}]}]], "Input",
 CellChangeTimes->{{3.553276853731751*^9, 3.553276867308921*^9}, {
  3.553276899134571*^9, 3.553276900651854*^9}, {3.555929634394063*^9, 
  3.555929641992764*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   OverscriptBox["Yf", "^"], "\[Equal]", 
   RowBox[{
    OverscriptBox["H", "_"], "+", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{"-", 
        FractionBox["u", "g"]}], 
       SqrtBox[
        RowBox[{"1", "-", 
         FractionBox[
          RowBox[{"4", 
           SuperscriptBox["g", "2"]}], 
          SuperscriptBox["u", "2"]]}]]}], ")"}], 
     RowBox[{
      SubsuperscriptBox["\[Integral]", 
       RowBox[{"-", "\[Infinity]"}], 
       RowBox[{"+", "\[Infinity]"}]], 
      RowBox[{
       FractionBox["dv", 
        RowBox[{
         RowBox[{"-", "2"}], "\[Pi]", " ", "\[ImaginaryI]"}]], 
       FractionBox["1", 
        RowBox[{"u", "-", "v"}]], 
       RowBox[{"(", 
        RowBox[{
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{
            FractionBox["1", 
             RowBox[{
              FractionBox["v", "g"], 
              SqrtBox[
               RowBox[{"1", "-", 
                FractionBox[
                 RowBox[{"4", 
                  SuperscriptBox["g", "2"]}], 
                 SuperscriptBox["v", "2"]]}]]}]], 
            OverscriptBox["H", "_"]}], ")"}], 
          RowBox[{"[", 
           RowBox[{"+", "o"}], "]"}]], "+", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{
            FractionBox["1", 
             RowBox[{
              FractionBox["v", "g"], 
              SqrtBox[
               RowBox[{"1", "-", 
                FractionBox[
                 RowBox[{"4", 
                  SuperscriptBox["g", "2"]}], 
                 SuperscriptBox["v", "2"]]}]]}]], "H"}], ")"}], 
          RowBox[{"[", 
           RowBox[{"-", "o"}], "]"}]]}], ")"}]}]}]}]}]}], ",", " ", 
  RowBox[{
   RowBox[{"Im", "[", "u", "]"}], ">", "0"}]}]], "Input",
 CellChangeTimes->{{3.55327677118294*^9, 3.5532767827944307`*^9}, {
  3.553276964695347*^9, 3.553276978010294*^9}, {3.553277069062745*^9, 
  3.5532771608290577`*^9}, {3.5532773407853813`*^9, 3.5532773410890007`*^9}, {
  3.555930087125458*^9, 3.555930171066276*^9}, {3.555930251576469*^9, 
  3.555930251966673*^9}, {3.5559386882018967`*^9, 3.55593868960981*^9}}],

Cell["Use this expression to cross the real line to get:", "Text",
 CellChangeTimes->{{3.555930187648075*^9, 3.55593022307022*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   OverscriptBox["Yf", "^"], "\[Equal]", 
   RowBox[{
    RowBox[{"-", "H"}], "+", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{"-", 
        FractionBox["u", "g"]}], 
       SqrtBox[
        RowBox[{"1", "-", 
         FractionBox[
          RowBox[{"4", 
           SuperscriptBox["g", "2"]}], 
          SuperscriptBox["u", "2"]]}]]}], ")"}], 
     RowBox[{
      SubsuperscriptBox["\[Integral]", 
       RowBox[{"-", "\[Infinity]"}], 
       RowBox[{"+", "\[Infinity]"}]], 
      RowBox[{
       FractionBox["dv", 
        RowBox[{
         RowBox[{"-", "2"}], "\[Pi]", " ", "\[ImaginaryI]"}]], 
       FractionBox["1", 
        RowBox[{"u", "-", "v"}]], 
       RowBox[{"(", 
        RowBox[{
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{
            FractionBox["1", 
             RowBox[{
              FractionBox["v", "g"], 
              SqrtBox[
               RowBox[{"1", "-", 
                FractionBox[
                 RowBox[{"4", 
                  SuperscriptBox["g", "2"]}], 
                 SuperscriptBox["v", "2"]]}]]}]], 
            OverscriptBox["H", "_"]}], ")"}], 
          RowBox[{"[", 
           RowBox[{"+", "o"}], "]"}]], "+", 
         SuperscriptBox[
          RowBox[{"(", 
           RowBox[{
            FractionBox["1", 
             RowBox[{
              FractionBox["v", "g"], 
              SqrtBox[
               RowBox[{"1", "-", 
                FractionBox[
                 RowBox[{"4", 
                  SuperscriptBox["g", "2"]}], 
                 SuperscriptBox["v", "2"]]}]]}]], "H"}], ")"}], 
          RowBox[{"[", 
           RowBox[{"-", "o"}], "]"}]]}], ")"}]}]}]}]}]}], ",", " ", 
  RowBox[{
   RowBox[{"Im", "[", "u", "]"}], "<", "0"}]}]], "Input",
 CellChangeTimes->{{3.5559302340736637`*^9, 3.555930254167122*^9}, {
  3.555938692217519*^9, 3.55593869457777*^9}}],

Cell[TextData[{
 "Note that ",
 Cell[BoxData[
  FormBox[
   RowBox[{
    RowBox[{
     OverscriptBox["Yf", "^"], "[", "u", "]"}], "=", 
    RowBox[{"-", 
     RowBox[{
      OverscriptBox["Yf", "^"], "[", 
      RowBox[{"-", "u"}], "]"}]}]}], TraditionalForm]]],
 " (true for both free term and integral). We will use this fact:"
}], "Text",
 CellChangeTimes->{{3.5559385564389057`*^9, 3.555938627642311*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"\[Integral]", 
   RowBox[{
    FractionBox["du", 
     RowBox[{"2", "\[ImaginaryI]"}]], 
    SubscriptBox[
     RowBox[{"(", 
      RowBox[{
       RowBox[{"Coth", "[", 
        RowBox[{"\[Pi]", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"2", "g", " ", "z"}], "-", "u"}], ")"}]}], "]"}], 
       OverscriptBox["Yf", "^"]}], ")"}], "pv"]}]}], "\[Rule]", 
  RowBox[{
   RowBox[{"\[Integral]", 
    RowBox[{
     FractionBox["du", 
      RowBox[{
       RowBox[{"-", "2"}], "\[Pi]", " ", "\[ImaginaryI]"}]], 
     SubscriptBox[
      RowBox[{"(", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{"\[Pi]", " ", 
          RowBox[{"Coth", "[", 
           RowBox[{"\[Pi]", 
            RowBox[{"(", 
             RowBox[{"u", "-", 
              RowBox[{"2", "g", " ", "z"}]}], ")"}]}], "]"}]}], ")"}], 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"-", 
           FractionBox["u", "g"]}], 
          SqrtBox[
           RowBox[{"1", "-", 
            FractionBox[
             RowBox[{"4", 
              SuperscriptBox["g", "2"]}], 
             SuperscriptBox["u", "2"]]}]]}], ")"}], 
        FractionBox["1", "2"], 
        RowBox[{"(", 
         RowBox[{
          FractionBox["1", 
           RowBox[{"u", "-", "v"}]], "-", 
          FractionBox["1", 
           RowBox[{"u", "+", "v"}]]}], ")"}]}], ")"}], "pv"]}]}], "\[Equal]", 
   "\[IndentingNewLine]", 
   RowBox[{"\[Integral]", 
    RowBox[{
     FractionBox["du", 
      RowBox[{
       RowBox[{"-", "2"}], "\[Pi]", " ", "\[ImaginaryI]"}]], 
     SubscriptBox[
      RowBox[{"(", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          RowBox[{
           SubsuperscriptBox["\[Eta]", "1", 
            RowBox[{"[", "2", "]"}]], "[", 
           RowBox[{"u", "-", 
            RowBox[{"2", "g", " ", "z"}]}], "]"}], "+", 
          FractionBox["1", 
           RowBox[{"u", "-", 
            RowBox[{"2", "g", " ", "z"}]}]], "+", 
          RowBox[{
           SubsuperscriptBox[
            OverscriptBox["\[Eta]", "_"], "1", 
            RowBox[{"[", 
             RowBox[{"-", "2"}], "]"}]], "[", 
           RowBox[{"u", "-", 
            RowBox[{"2", "g", " ", "z"}]}], "]"}]}], ")"}], 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"-", 
           FractionBox["u", "g"]}], 
          SqrtBox[
           RowBox[{"1", "-", 
            FractionBox[
             RowBox[{"4", 
              SuperscriptBox["g", "2"]}], 
             SuperscriptBox["u", "2"]]}]]}], ")"}], 
        FractionBox["1", "2"], 
        RowBox[{"(", 
         RowBox[{
          FractionBox["1", 
           RowBox[{"u", "-", "v"}]], "-", 
          FractionBox["1", 
           RowBox[{"u", "+", "v"}]]}], ")"}]}], ")"}], "pv"]}]}]}]}]], "Input",\

 CellChangeTimes->{{3.555930336793887*^9, 3.555930390914983*^9}, {
  3.555930568756378*^9, 3.555930578462007*^9}, {3.5559307564605618`*^9, 
  3.5559307572857637`*^9}, {3.555931710139903*^9, 3.55593182000343*^9}, {
  3.5559318788654346`*^9, 3.555931885146661*^9}, {3.555931969412405*^9, 
  3.555931994235361*^9}, {3.5559387191614313`*^9, 3.555938737622476*^9}, {
  3.5559387823007936`*^9, 3.555938825239627*^9}}],

Cell[TextData[{
 "Consider first integration of a rational piece ",
 Cell[BoxData[
  FormBox[
   RowBox[{"(", 
    FractionBox["1", 
     RowBox[{"u", "-", 
      RowBox[{"2", "g", " ", "z"}]}]], ")"}], TraditionalForm]]],
 ". It is zero. Because: what is above real axis, is closed above and gives \
zero. And what is below real axis is closed below and also gives zero."
}], "Text",
 CellChangeTimes->{{3.5559319465018806`*^9, 3.555931959701037*^9}, {
  3.555932036844569*^9, 3.555932074304956*^9}, {3.555932126451665*^9, 
  3.555932155317975*^9}, {3.555938807564386*^9, 3.555938836371804*^9}}],

Cell[TextData[{
 "To make things more clear, we change u->-u for ",
 Cell[BoxData[
  RowBox[{
   SubsuperscriptBox[
    OverscriptBox["\[Eta]", "_"], "1", 
    RowBox[{"[", 
     RowBox[{"-", "2"}], "]"}]], "[", 
   RowBox[{"u", "-", 
    RowBox[{"2", "g", " ", "z"}]}], "]"}]],
  CellChangeTimes->{{3.555930336793887*^9, 3.555930390914983*^9}, {
   3.555930568756378*^9, 3.555930578462007*^9}, {3.5559307564605618`*^9, 
   3.5559307572857637`*^9}, {3.555931710139903*^9, 3.55593182000343*^9}, {
   3.5559318788654346`*^9, 3.555931885146661*^9}, {3.555931969412405*^9, 
   3.555931994235361*^9}}],
 " term"
}], "Text",
 CellChangeTimes->{{3.5559328710613117`*^9, 3.555932889186302*^9}}],

Cell[TextData[{
 "Now consider integraton of ",
 Cell[BoxData[
  FormBox[
   SubsuperscriptBox["\[Eta]", "1", 
    RowBox[{"[", "2", "]"}]], TraditionalForm]]],
 " remaining term. This should be closed above, hence we have a nontrivial \
contribution from"
}], "Text",
 CellChangeTimes->{{3.555932159973701*^9, 3.555932198036379*^9}, {
  3.55593289775483*^9, 3.555932899402767*^9}}],

Cell[BoxData[
 RowBox[{"\[Integral]", 
  RowBox[{
   FractionBox["du", 
    RowBox[{
     RowBox[{"-", "2"}], "\[Pi]", " ", "\[ImaginaryI]"}]], 
   FractionBox["1", "2"], 
   SuperscriptBox[
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            SubsuperscriptBox["\[Eta]", "1", 
             RowBox[{"[", "2", "]"}]], "[", 
            RowBox[{"u", "-", 
             RowBox[{"2", "g", " ", "z"}]}], "]"}], ")"}], 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"-", 
             FractionBox["u", "g"]}], 
            SqrtBox[
             RowBox[{"1", "-", 
              FractionBox[
               RowBox[{"4", 
                SuperscriptBox["g", "2"]}], 
               SuperscriptBox["u", "2"]]}]]}], ")"}]}], ")"}], "+", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{"-", 
            RowBox[{
             SubsuperscriptBox["\[Eta]", "1", 
              RowBox[{"[", "2", "]"}]], "[", 
             RowBox[{"u", "+", 
              RowBox[{"2", "g", " ", "z"}]}], "]"}]}], ")"}], 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"+", 
             FractionBox["u", "g"]}], 
            SqrtBox[
             RowBox[{"1", "-", 
              FractionBox[
               RowBox[{"4", 
                SuperscriptBox["g", "2"]}], 
               SuperscriptBox["u", "2"]]}]]}], ")"}]}], ")"}]}], ")"}], 
      FractionBox["1", "2"], 
      RowBox[{"(", 
       RowBox[{
        FractionBox["1", 
         RowBox[{"u", "-", "v"}]], "-", 
        FractionBox["1", 
         RowBox[{"u", "+", "v"}]]}], ")"}]}], ")"}], 
    RowBox[{"[", 
     RowBox[{"-", "o"}], "]"}]]}]}]], "Input",
 CellChangeTimes->{{3.555932195969533*^9, 3.555932214828957*^9}, {
  3.555932904451857*^9, 3.555932930086976*^9}, {3.5559361328975353`*^9, 
  3.555936137342299*^9}, {3.5559365229192467`*^9, 3.555936546971422*^9}, {
  3.5559388727699413`*^9, 3.555938926992208*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"integral1", "=", 
  RowBox[{
   RowBox[{"Collect", "[", 
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{"Collect", "[", 
         RowBox[{
          RowBox[{"Series", "[", 
           RowBox[{
            RowBox[{
             FractionBox["1", "2"], 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"(", 
                RowBox[{
                 RowBox[{"(", 
                  RowBox[{
                   SubsuperscriptBox["\[Eta]", "1", 
                    RowBox[{"[", "2", "]"}]], "[", 
                   RowBox[{"u", "-", 
                    RowBox[{"2", "g", " ", "z"}]}], "]"}], ")"}], 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"-", 
                    FractionBox["u", "g"]}], 
                   SqrtBox[
                    RowBox[{"1", "-", 
                    FractionBox[
                    RowBox[{"4", 
                    SuperscriptBox["g", "2"]}], 
                    SuperscriptBox["u", "2"]]}]]}], ")"}]}], ")"}], "+", 
               RowBox[{"(", 
                RowBox[{
                 RowBox[{"(", 
                  RowBox[{"-", 
                   RowBox[{
                    SubsuperscriptBox["\[Eta]", "1", 
                    RowBox[{"[", "2", "]"}]], "[", 
                    RowBox[{"u", "+", 
                    RowBox[{"2", "g", " ", "z"}]}], "]"}]}], ")"}], 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"+", 
                    FractionBox["u", "g"]}], 
                   SqrtBox[
                    RowBox[{"1", "-", 
                    FractionBox[
                    RowBox[{"4", 
                    SuperscriptBox["g", "2"]}], 
                    SuperscriptBox["u", "2"]]}]]}], ")"}]}], ")"}]}], ")"}], 
             FractionBox["1", "2"], 
             RowBox[{"(", 
              RowBox[{
               FractionBox["1", 
                RowBox[{"u", "-", "v"}]], "-", 
               FractionBox["1", 
                RowBox[{"u", "+", "v"}]]}], ")"}]}], ",", 
            RowBox[{"{", 
             RowBox[{"g", ",", "0", ",", "7"}], "}"}]}], "]"}], ",", "g", ",", 
          RowBox[{
           RowBox[{"-", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"Residue", "[", 
               RowBox[{"#", ",", 
                RowBox[{"{", 
                 RowBox[{"u", ",", "0"}], "}"}]}], "]"}], "+", 
              RowBox[{"Residue", "[", 
               RowBox[{"#", ",", 
                RowBox[{"{", 
                 RowBox[{"u", ",", "v"}], "}"}]}], "]"}], "+", 
              RowBox[{"Residue", "[", 
               RowBox[{"#", ",", 
                RowBox[{"{", 
                 RowBox[{"u", ",", 
                  RowBox[{"-", "v"}]}], "}"}]}], "]"}]}], ")"}]}], "&"}]}], 
         "]"}], "/.", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{
           RowBox[{
            RowBox[{
             RowBox[{"Derivative", "[", "a_", "]"}], "[", 
             RowBox[{
              RowBox[{"\[Eta]$", "[", "b__", "]"}], "[", "2", "]"}], "]"}], 
            "[", "0", "]"}], "\[RuleDelayed]", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{
              RowBox[{"\[Eta]D", "[", 
               RowBox[{
                RowBox[{
                 RowBox[{"\[Eta]$", "[", "b", "]"}], "[", "0", "]"}], ",", 
                "a"}], "]"}], "/.", 
              RowBox[{"Shift", "[", "2", "]"}]}], "/.", "sub\[Eta]\[Zeta]"}], 
            ")"}]}], ",", 
          RowBox[{
           RowBox[{
            RowBox[{
             RowBox[{"\[Eta]$", "[", "a__", "]"}], "[", "2", "]"}], "[", "0", 
            "]"}], "\[RuleDelayed]", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{
              RowBox[{"\[Eta]$", "[", "a", "]"}], "[", "2", "]"}], "/.", 
             "sub\[Eta]\[Zeta]"}], ")"}]}]}], "}"}]}], "/.", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{
          RowBox[{
           RowBox[{
            RowBox[{"Derivative", "[", "a_", "]"}], "[", 
            RowBox[{
             RowBox[{"\[Eta]$", "[", "b__", "]"}], "[", "2", "]"}], "]"}], 
           "[", "v", "]"}], "\[RuleDelayed]", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"\[Eta]D", "[", 
             RowBox[{
              RowBox[{
               RowBox[{"\[Eta]$", "[", "b", "]"}], "[", "0", "]"}], ",", 
              "a"}], "]"}], "/.", 
            RowBox[{"Shift", "[", "2", "]"}]}], ")"}]}], ",", 
         RowBox[{
          RowBox[{
           RowBox[{
            RowBox[{"\[Eta]$", "[", "a__", "]"}], "[", "2", "]"}], "[", "v", 
           "]"}], "\[RuleDelayed]", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"\[Eta]$", "[", "a", "]"}], "[", "2", "]"}], ")"}]}]}], 
        "}"}]}], "/.", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{
         RowBox[{
          RowBox[{
           RowBox[{"Derivative", "[", "a_", "]"}], "[", 
           RowBox[{
            RowBox[{"\[Eta]$", "[", "b__", "]"}], "[", "2", "]"}], "]"}], "[", 
          RowBox[{"-", "v"}], "]"}], "\[RuleDelayed]", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{
            RowBox[{"\[Eta]D", "[", 
             RowBox[{
              RowBox[{
               RowBox[{"\[Eta]$", "[", "b", "]"}], "[", "0", "]"}], ",", 
              "a"}], "]"}], "/.", 
            RowBox[{"Shift", "[", "2", "]"}]}], "/.", "suboppositesign"}], 
          ")"}]}], ",", 
        RowBox[{
         RowBox[{
          RowBox[{
           RowBox[{"\[Eta]$", "[", "a__", "]"}], "[", "2", "]"}], "[", 
          RowBox[{"-", "v"}], "]"}], "\[RuleDelayed]", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{
            RowBox[{"\[Eta]$", "[", "a", "]"}], "[", "2", "]"}], "/.", 
           "suboppositesign"}], ")"}]}]}], "}"}]}], ",", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"g", ",", "z", ",", "v", ",", "\[Eta]list"}], "}"}], "//", 
      "Flatten"}], ",", "Simplify"}], "]"}], "/.", 
   RowBox[{"v", "\[Rule]", "u"}]}]}]], "Input",
 CellChangeTimes->{{3.555933936908436*^9, 3.555933995555579*^9}, {
   3.555934063872415*^9, 3.5559342142152987`*^9}, 3.555934261314521*^9, {
   3.5559343119990673`*^9, 3.555934323257826*^9}, {3.5559343694266644`*^9, 
   3.555934397531311*^9}, {3.5559344331651793`*^9, 3.555934509854397*^9}, 
   3.555934587588389*^9, 3.555935086137792*^9, {3.555936144613831*^9, 
   3.5559361626134663`*^9}, {3.5559365293910646`*^9, 3.555936536524839*^9}, {
   3.555936568112789*^9, 3.555936583172969*^9}, 3.555936690003104*^9, {
   3.555936721788412*^9, 3.5559367262735577`*^9}, {3.555938943455508*^9, 
   3.5559389469963713`*^9}, 3.5559389984969263`*^9, {3.555939504675879*^9, 
   3.555939505635779*^9}, 3.555939675896607*^9, {3.555940772496133*^9, 
   3.555940773801612*^9}, {3.555941048546423*^9, 3.555941050586434*^9}, 
   3.5559412395870867`*^9, {3.555941429993063*^9, 3.555941431696143*^9}}],

Cell[BoxData[
 RowBox[{
  FractionBox[
   RowBox[{"u", " ", 
    RowBox[{"(", 
     RowBox[{
      FractionBox[
       SubsuperscriptBox[
        StyleBox["\[Eta]",
         FontWeight->Bold,
         FontColor->RGBColor[0.8, 0, 0]], "1", 
        RowBox[{"[", "2", "]"}]], "2"], "-", 
      RowBox[{
       FractionBox["1", "2"], " ", 
       SubsuperscriptBox[
        OverscriptBox[
         StyleBox["\[Eta]",
          FontWeight->Bold,
          FontColor->RGBColor[0.8, 0, 0]], 
         StyleBox["_",
          FontWeight->Bold,
          FontColor->RGBColor[0.8, 0, 0]]], "1", 
        RowBox[{"[", 
         RowBox[{"-", "2"}], "]"}]]}]}], ")"}]}], "g"], "+", 
  RowBox[{"g", " ", 
   RowBox[{"(", 
    RowBox[{
     FractionBox[
      RowBox[{
       RowBox[{
        RowBox[{"-", "2"}], " ", "\[ImaginaryI]", " ", 
        SubscriptBox[
         StyleBox["\[Zeta]",
          FontWeight->Bold,
          FontColor->GrayLevel[0.4]], "1"]}], "-", 
       SubsuperscriptBox[
        StyleBox["\[Eta]",
         FontWeight->Bold,
         FontColor->RGBColor[0.8, 0, 0]], "1", 
        RowBox[{"[", "2", "]"}]], "+", 
       SubsuperscriptBox[
        OverscriptBox[
         StyleBox["\[Eta]",
          FontWeight->Bold,
          FontColor->RGBColor[0.8, 0, 0]], 
         StyleBox["_",
          FontWeight->Bold,
          FontColor->RGBColor[0.8, 0, 0]]], "1", 
        RowBox[{"[", 
         RowBox[{"-", "2"}], "]"}]]}], "u"], "+", 
     RowBox[{"u", " ", 
      SuperscriptBox["z", "2"], " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"2", " ", 
         SubsuperscriptBox[
          StyleBox["\[Eta]",
           FontWeight->Bold,
           FontColor->RGBColor[0.8, 0, 0]], "3", 
          RowBox[{"[", "2", "]"}]]}], "-", 
        RowBox[{"2", " ", 
         SubsuperscriptBox[
          OverscriptBox[
           StyleBox["\[Eta]",
            FontWeight->Bold,
            FontColor->RGBColor[0.8, 0, 0]], 
           StyleBox["_",
            FontWeight->Bold,
            FontColor->RGBColor[0.8, 0, 0]]], "3", 
          RowBox[{"[", 
           RowBox[{"-", "2"}], "]"}]]}]}], ")"}]}]}], ")"}]}], "+", 
  RowBox[{
   SuperscriptBox["g", "3"], " ", 
   RowBox[{"(", 
    RowBox[{
     FractionBox[
      RowBox[{"2", " ", "\[ImaginaryI]", " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "3"]}], "u"], "+", 
     FractionBox[
      RowBox[{
       RowBox[{
        RowBox[{"-", "2"}], " ", "\[ImaginaryI]", " ", 
        SubscriptBox[
         StyleBox["\[Zeta]",
          FontWeight->Bold,
          FontColor->GrayLevel[0.4]], "1"]}], "-", 
       SubsuperscriptBox[
        StyleBox["\[Eta]",
         FontWeight->Bold,
         FontColor->RGBColor[0.8, 0, 0]], "1", 
        RowBox[{"[", "2", "]"}]], "+", 
       SubsuperscriptBox[
        OverscriptBox[
         StyleBox["\[Eta]",
          FontWeight->Bold,
          FontColor->RGBColor[0.8, 0, 0]], 
         StyleBox["_",
          FontWeight->Bold,
          FontColor->RGBColor[0.8, 0, 0]]], "1", 
        RowBox[{"[", 
         RowBox[{"-", "2"}], "]"}]]}], 
      SuperscriptBox["u", "3"]], "+", 
     FractionBox[
      RowBox[{
       SuperscriptBox["z", "2"], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"8", " ", "\[ImaginaryI]", " ", 
          SubscriptBox[
           StyleBox["\[Zeta]",
            FontWeight->Bold,
            FontColor->GrayLevel[0.4]], "3"]}], "-", 
         RowBox[{"4", " ", 
          SubsuperscriptBox[
           StyleBox["\[Eta]",
            FontWeight->Bold,
            FontColor->RGBColor[0.8, 0, 0]], "3", 
           RowBox[{"[", "2", "]"}]]}], "+", 
         RowBox[{"4", " ", 
          SubsuperscriptBox[
           OverscriptBox[
            StyleBox["\[Eta]",
             FontWeight->Bold,
             FontColor->RGBColor[0.8, 0, 0]], 
            StyleBox["_",
             FontWeight->Bold,
             FontColor->RGBColor[0.8, 0, 0]]], "3", 
           RowBox[{"[", 
            RowBox[{"-", "2"}], "]"}]]}]}], ")"}]}], "u"], "+", 
     RowBox[{"u", " ", 
      SuperscriptBox["z", "4"], " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"8", " ", 
         SubsuperscriptBox[
          StyleBox["\[Eta]",
           FontWeight->Bold,
           FontColor->RGBColor[0.8, 0, 0]], "5", 
          RowBox[{"[", "2", "]"}]]}], "-", 
        RowBox[{"8", " ", 
         SubsuperscriptBox[
          OverscriptBox[
           StyleBox["\[Eta]",
            FontWeight->Bold,
            FontColor->RGBColor[0.8, 0, 0]], 
           StyleBox["_",
            FontWeight->Bold,
            FontColor->RGBColor[0.8, 0, 0]]], "5", 
          RowBox[{"[", 
           RowBox[{"-", "2"}], "]"}]]}]}], ")"}]}]}], ")"}]}], "+", 
  RowBox[{
   SuperscriptBox["g", "5"], " ", 
   RowBox[{"(", 
    RowBox[{
     FractionBox[
      RowBox[{"4", " ", "\[ImaginaryI]", " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "3"]}], 
      SuperscriptBox["u", "3"]], "-", 
     FractionBox[
      RowBox[{"4", " ", "\[ImaginaryI]", " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "5"]}], "u"], "+", 
     FractionBox[
      RowBox[{
       RowBox[{
        RowBox[{"-", "4"}], " ", "\[ImaginaryI]", " ", 
        SubscriptBox[
         StyleBox["\[Zeta]",
          FontWeight->Bold,
          FontColor->GrayLevel[0.4]], "1"]}], "-", 
       RowBox[{"2", " ", 
        SubsuperscriptBox[
         StyleBox["\[Eta]",
          FontWeight->Bold,
          FontColor->RGBColor[0.8, 0, 0]], "1", 
         RowBox[{"[", "2", "]"}]]}], "+", 
       RowBox[{"2", " ", 
        SubsuperscriptBox[
         OverscriptBox[
          StyleBox["\[Eta]",
           FontWeight->Bold,
           FontColor->RGBColor[0.8, 0, 0]], 
          StyleBox["_",
           FontWeight->Bold,
           FontColor->RGBColor[0.8, 0, 0]]], "1", 
         RowBox[{"[", 
          RowBox[{"-", "2"}], "]"}]]}]}], 
      SuperscriptBox["u", "5"]], "+", 
     RowBox[{
      SuperscriptBox["z", "2"], " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", 
         FractionBox[
          RowBox[{"48", " ", "\[ImaginaryI]", " ", 
           SubscriptBox[
            StyleBox["\[Zeta]",
             FontWeight->Bold,
             FontColor->GrayLevel[0.4]], "5"]}], "u"]}], "+", 
        FractionBox[
         RowBox[{
          RowBox[{"8", " ", "\[ImaginaryI]", " ", 
           SubscriptBox[
            StyleBox["\[Zeta]",
             FontWeight->Bold,
             FontColor->GrayLevel[0.4]], "3"]}], "-", 
          RowBox[{"4", " ", 
           SubsuperscriptBox[
            StyleBox["\[Eta]",
             FontWeight->Bold,
             FontColor->RGBColor[0.8, 0, 0]], "3", 
            RowBox[{"[", "2", "]"}]]}], "+", 
          RowBox[{"4", " ", 
           SubsuperscriptBox[
            OverscriptBox[
             StyleBox["\[Eta]",
              FontWeight->Bold,
              FontColor->RGBColor[0.8, 0, 0]], 
             StyleBox["_",
              FontWeight->Bold,
              FontColor->RGBColor[0.8, 0, 0]]], "3", 
            RowBox[{"[", 
             RowBox[{"-", "2"}], "]"}]]}]}], 
         SuperscriptBox["u", "3"]]}], ")"}]}], "+", 
     FractionBox[
      RowBox[{
       SuperscriptBox["z", "4"], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          RowBox[{"-", "32"}], " ", "\[ImaginaryI]", " ", 
          SubscriptBox[
           StyleBox["\[Zeta]",
            FontWeight->Bold,
            FontColor->GrayLevel[0.4]], "5"]}], "-", 
         RowBox[{"16", " ", 
          SubsuperscriptBox[
           StyleBox["\[Eta]",
            FontWeight->Bold,
            FontColor->RGBColor[0.8, 0, 0]], "5", 
           RowBox[{"[", "2", "]"}]]}], "+", 
         RowBox[{"16", " ", 
          SubsuperscriptBox[
           OverscriptBox[
            StyleBox["\[Eta]",
             FontWeight->Bold,
             FontColor->RGBColor[0.8, 0, 0]], 
            StyleBox["_",
             FontWeight->Bold,
             FontColor->RGBColor[0.8, 0, 0]]], "5", 
           RowBox[{"[", 
            RowBox[{"-", "2"}], "]"}]]}]}], ")"}]}], "u"], "+", 
     RowBox[{"u", " ", 
      SuperscriptBox["z", "6"], " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"32", " ", 
         SubsuperscriptBox[
          StyleBox["\[Eta]",
           FontWeight->Bold,
           FontColor->RGBColor[0.8, 0, 0]], "7", 
          RowBox[{"[", "2", "]"}]]}], "-", 
        RowBox[{"32", " ", 
         SubsuperscriptBox[
          OverscriptBox[
           StyleBox["\[Eta]",
            FontWeight->Bold,
            FontColor->RGBColor[0.8, 0, 0]], 
           StyleBox["_",
            FontWeight->Bold,
            FontColor->RGBColor[0.8, 0, 0]]], "7", 
          RowBox[{"[", 
           RowBox[{"-", "2"}], "]"}]]}]}], ")"}]}]}], ")"}]}], "+", 
  RowBox[{
   SuperscriptBox["g", "7"], " ", 
   RowBox[{"(", 
    RowBox[{
     FractionBox[
      RowBox[{"10", " ", "\[ImaginaryI]", " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "3"]}], 
      SuperscriptBox["u", "5"]], "-", 
     FractionBox[
      RowBox[{"10", " ", "\[ImaginaryI]", " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "5"]}], 
      SuperscriptBox["u", "3"]], "+", 
     FractionBox[
      RowBox[{"10", " ", "\[ImaginaryI]", " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "7"]}], "u"], "+", 
     FractionBox[
      RowBox[{
       RowBox[{
        RowBox[{"-", "10"}], " ", "\[ImaginaryI]", " ", 
        SubscriptBox[
         StyleBox["\[Zeta]",
          FontWeight->Bold,
          FontColor->GrayLevel[0.4]], "1"]}], "-", 
       RowBox[{"5", " ", 
        SubsuperscriptBox[
         StyleBox["\[Eta]",
          FontWeight->Bold,
          FontColor->RGBColor[0.8, 0, 0]], "1", 
         RowBox[{"[", "2", "]"}]]}], "+", 
       RowBox[{"5", " ", 
        SubsuperscriptBox[
         OverscriptBox[
          StyleBox["\[Eta]",
           FontWeight->Bold,
           FontColor->RGBColor[0.8, 0, 0]], 
          StyleBox["_",
           FontWeight->Bold,
           FontColor->RGBColor[0.8, 0, 0]]], "1", 
         RowBox[{"[", 
          RowBox[{"-", "2"}], "]"}]]}]}], 
      SuperscriptBox["u", "7"]], "+", 
     RowBox[{
      SuperscriptBox["z", "2"], " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", 
         FractionBox[
          RowBox[{"96", " ", "\[ImaginaryI]", " ", 
           SubscriptBox[
            StyleBox["\[Zeta]",
             FontWeight->Bold,
             FontColor->GrayLevel[0.4]], "5"]}], 
          SuperscriptBox["u", "3"]]}], "+", 
        FractionBox[
         RowBox[{"240", " ", "\[ImaginaryI]", " ", 
          SubscriptBox[
           StyleBox["\[Zeta]",
            FontWeight->Bold,
            FontColor->GrayLevel[0.4]], "7"]}], "u"], "+", 
        FractionBox[
         RowBox[{
          RowBox[{"16", " ", "\[ImaginaryI]", " ", 
           SubscriptBox[
            StyleBox["\[Zeta]",
             FontWeight->Bold,
             FontColor->GrayLevel[0.4]], "3"]}], "-", 
          RowBox[{"8", " ", 
           SubsuperscriptBox[
            StyleBox["\[Eta]",
             FontWeight->Bold,
             FontColor->RGBColor[0.8, 0, 0]], "3", 
            RowBox[{"[", "2", "]"}]]}], "+", 
          RowBox[{"8", " ", 
           SubsuperscriptBox[
            OverscriptBox[
             StyleBox["\[Eta]",
              FontWeight->Bold,
              FontColor->RGBColor[0.8, 0, 0]], 
             StyleBox["_",
              FontWeight->Bold,
              FontColor->RGBColor[0.8, 0, 0]]], "3", 
            RowBox[{"[", 
             RowBox[{"-", "2"}], "]"}]]}]}], 
         SuperscriptBox["u", "5"]]}], ")"}]}], "+", 
     RowBox[{
      SuperscriptBox["z", "4"], " ", 
      RowBox[{"(", 
       RowBox[{
        FractionBox[
         RowBox[{"480", " ", "\[ImaginaryI]", " ", 
          SubscriptBox[
           StyleBox["\[Zeta]",
            FontWeight->Bold,
            FontColor->GrayLevel[0.4]], "7"]}], "u"], "+", 
        FractionBox[
         RowBox[{
          RowBox[{
           RowBox[{"-", "32"}], " ", "\[ImaginaryI]", " ", 
           SubscriptBox[
            StyleBox["\[Zeta]",
             FontWeight->Bold,
             FontColor->GrayLevel[0.4]], "5"]}], "-", 
          RowBox[{"16", " ", 
           SubsuperscriptBox[
            StyleBox["\[Eta]",
             FontWeight->Bold,
             FontColor->RGBColor[0.8, 0, 0]], "5", 
            RowBox[{"[", "2", "]"}]]}], "+", 
          RowBox[{"16", " ", 
           SubsuperscriptBox[
            OverscriptBox[
             StyleBox["\[Eta]",
              FontWeight->Bold,
              FontColor->RGBColor[0.8, 0, 0]], 
             StyleBox["_",
              FontWeight->Bold,
              FontColor->RGBColor[0.8, 0, 0]]], "5", 
            RowBox[{"[", 
             RowBox[{"-", "2"}], "]"}]]}]}], 
         SuperscriptBox["u", "3"]]}], ")"}]}], "+", 
     FractionBox[
      RowBox[{
       SuperscriptBox["z", "6"], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"128", " ", "\[ImaginaryI]", " ", 
          SubscriptBox[
           StyleBox["\[Zeta]",
            FontWeight->Bold,
            FontColor->GrayLevel[0.4]], "7"]}], "-", 
         RowBox[{"64", " ", 
          SubsuperscriptBox[
           StyleBox["\[Eta]",
            FontWeight->Bold,
            FontColor->RGBColor[0.8, 0, 0]], "7", 
           RowBox[{"[", "2", "]"}]]}], "+", 
         RowBox[{"64", " ", 
          SubsuperscriptBox[
           OverscriptBox[
            StyleBox["\[Eta]",
             FontWeight->Bold,
             FontColor->RGBColor[0.8, 0, 0]], 
            StyleBox["_",
             FontWeight->Bold,
             FontColor->RGBColor[0.8, 0, 0]]], "7", 
           RowBox[{"[", 
            RowBox[{"-", "2"}], "]"}]]}]}], ")"}]}], "u"], "+", 
     RowBox[{"u", " ", 
      SuperscriptBox["z", "8"], " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"128", " ", 
         SubsuperscriptBox[
          StyleBox["\[Eta]",
           FontWeight->Bold,
           FontColor->RGBColor[0.8, 0, 0]], "9", 
          RowBox[{"[", "2", "]"}]]}], "-", 
        RowBox[{"128", " ", 
         SubsuperscriptBox[
          OverscriptBox[
           StyleBox["\[Eta]",
            FontWeight->Bold,
            FontColor->RGBColor[0.8, 0, 0]], 
           StyleBox["_",
            FontWeight->Bold,
            FontColor->RGBColor[0.8, 0, 0]]], "9", 
          RowBox[{"[", 
           RowBox[{"-", "2"}], "]"}]]}]}], ")"}]}]}], ")"}]}]}]], "Output",
 CellChangeTimes->{
  3.5559339007185717`*^9, 3.555933940807191*^9, 3.5559339969024563`*^9, 
   3.555934029841415*^9, 3.555934091878933*^9, 3.555934218861103*^9, 
   3.5559342617811947`*^9, {3.555934318212739*^9, 3.555934327893515*^9}, {
   3.5559343723062353`*^9, 3.555934398517611*^9}, {3.5559344690591917`*^9, 
   3.555934510733144*^9}, 3.5559345884233027`*^9, 3.555935086775312*^9, 
   3.555935141253664*^9, {3.555936151960938*^9, 3.555936163001268*^9}, 
   3.5559365861281652`*^9, {3.555936698469026*^9, 3.555936748472803*^9}, 
   3.555938953231657*^9, {3.555938995701253*^9, 3.555938999249078*^9}, 
   3.555939126674233*^9, 3.5559395061193447`*^9, {3.555939676351983*^9, 
   3.555939684277103*^9}, 3.5559407771483173`*^9, 3.555940831059285*^9, 
   3.555940916254918*^9, 3.5559410510516787`*^9, 3.555941240412972*^9, 
   3.555941432571602*^9, 3.555942547222211*^9, 3.560336902105336*^9}]
}, Open  ]],

Cell["Now we check our expression against numerical computation", "Text",
 CellChangeTimes->{{3.555939069963457*^9, 3.555939086336836*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"Block", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"v", "=", 
       RowBox[{"SetPrecision", "[", 
        RowBox[{
         RowBox[{"Random", "[", "]"}], ",", "100"}], "]"}]}], ",", 
      RowBox[{"zz", "=", 
       RowBox[{"SetPrecision", "[", 
        RowBox[{
         RowBox[{"Random", "[", "]"}], ",", "100"}], "]"}]}], ",", "tmp"}], 
     "}"}], ",", 
    RowBox[{
     RowBox[{"{", "\[IndentingNewLine]", 
      RowBox[{"Collect", "[", 
       RowBox[{
        RowBox[{"Simplify", "@", 
         RowBox[{"Series", "[", 
          RowBox[{
           RowBox[{"symfun", "[", 
            FractionBox[
             RowBox[{"(", 
              RowBox[{
               RowBox[{"(", 
                RowBox[{"\[Pi]", 
                 RowBox[{"(", " ", 
                  RowBox[{
                   RowBox[{"Coth", "[", 
                    RowBox[{"\[Pi]", 
                    RowBox[{"(", 
                    RowBox[{"u", "-", 
                    RowBox[{"2", "g", " ", "zz"}]}], ")"}]}], "]"}], "-", 
                   RowBox[{"Coth", "[", 
                    RowBox[{"\[Pi]", 
                    RowBox[{"(", "u", ")"}]}], "]"}]}], ")"}]}], ")"}], 
               RowBox[{"(", 
                RowBox[{
                 RowBox[{"-", 
                  FractionBox["u", "g"]}], 
                 SqrtBox[
                  RowBox[{"1", "-", 
                   FractionBox[
                    RowBox[{"4", 
                    SuperscriptBox["g", "2"]}], 
                    SuperscriptBox["u", "2"]]}]]}], ")"}], 
               FractionBox["1", "2"], 
               RowBox[{"(", 
                RowBox[{
                 FractionBox["1", 
                  RowBox[{"u", "-", "v"}]], "-", 
                 FractionBox["1", 
                  RowBox[{"u", "+", "v"}]]}], ")"}]}], ")"}], 
             RowBox[{
              RowBox[{"-", "2"}], "\[Pi]", " ", "\[ImaginaryI]"}]], "]"}], 
           ",", 
           RowBox[{"{", 
            RowBox[{"g", ",", "0", ",", "7"}], "}"}]}], "]"}]}], ",", "g", 
        ",", 
        RowBox[{
         RowBox[{"NIntegrate", "[", 
          RowBox[{
           RowBox[{
            FractionBox["1", "2"], 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"(", 
               RowBox[{"#", "/.", 
                RowBox[{"u", "\[Rule]", 
                 RowBox[{"t", "+", 
                  FractionBox["\[ImaginaryI]", "4"]}]}]}], ")"}], "+", 
              RowBox[{"(", 
               RowBox[{"#", "/.", 
                RowBox[{"u", "\[Rule]", 
                 RowBox[{"t", "-", 
                  FractionBox["\[ImaginaryI]", "4"]}]}]}], ")"}]}], ")"}]}], 
           ",", 
           RowBox[{"{", 
            RowBox[{"t", ",", 
             RowBox[{"-", "\[Infinity]"}], ",", "0", ",", 
             RowBox[{"+", "\[Infinity]"}]}], "}"}]}], "]"}], "&"}]}], "]"}], 
      "}"}], "-", 
     RowBox[{"{", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         RowBox[{
          RowBox[{
           RowBox[{"integral1", "-", 
            RowBox[{"(", 
             RowBox[{"integral1", "/.", 
              RowBox[{"z", "\[Rule]", "0"}]}], ")"}]}], "/.", 
           "subtoPolyGammas"}], "/.", "subZetas"}], "/.", 
         RowBox[{"u", "\[Rule]", "v"}]}], "/.", 
        RowBox[{"z", "\[Rule]", "zz"}]}], ")"}], "}"}]}]}], "]"}], "//", 
  "N"}]], "Input",
 CellChangeTimes->{{3.5559332756366167`*^9, 3.55593360782675*^9}, {
   3.555933736278026*^9, 3.555933739592188*^9}, 3.5559337709076967`*^9, {
   3.555933823745948*^9, 3.555933844427206*^9}, {3.555934381839847*^9, 
   3.555934388517679*^9}, {3.555934594678316*^9, 3.555934595234523*^9}, {
   3.555934820925727*^9, 3.5559350076731567`*^9}, {3.55593504499559*^9, 
   3.555935083125184*^9}, {3.555935199343886*^9, 3.555935211477454*^9}, {
   3.555936168803022*^9, 3.555936207875231*^9}, {3.55593904927046*^9, 
   3.5559391496044827`*^9}, {3.555939180203239*^9, 3.555939194594617*^9}, {
   3.555939264176448*^9, 3.55593927352744*^9}, {3.555939321870212*^9, 
   3.555939362971057*^9}, {3.555939435218417*^9, 3.555939460121317*^9}, {
   3.55593953647044*^9, 3.555939594627988*^9}, {3.555939653052565*^9, 
   3.5559396891208353`*^9}, {3.555940252003303*^9, 3.555940307577703*^9}, {
   3.555940596152945*^9, 3.555940641473558*^9}, {3.555940671936058*^9, 
   3.555940675173053*^9}, {3.5559407081528997`*^9, 3.5559407458625937`*^9}, {
   3.555941138714293*^9, 3.555941147372444*^9}, {3.555941209009645*^9, 
   3.555941254735073*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{
    RowBox[{"(", 
     RowBox[{"0.`", "\[VeryThinSpace]", "-", 
      RowBox[{"6.869504964868156`*^-16", " ", "\[ImaginaryI]"}]}], ")"}], " ",
     "g"}], "-", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{"0.`", "\[VeryThinSpace]", "+", 
      RowBox[{"4.440892098500626`*^-16", " ", "\[ImaginaryI]"}]}], ")"}], " ", 
    SuperscriptBox["g", "3"]}], "-", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{"0.`", "\[VeryThinSpace]", "+", 
      RowBox[{"1.0236256287043943`*^-13", " ", "\[ImaginaryI]"}]}], ")"}], 
    " ", 
    SuperscriptBox["g", "5"]}], "+", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{"0.`", "\[VeryThinSpace]", "+", 
      RowBox[{"8.277822871605167`*^-13", " ", "\[ImaginaryI]"}]}], ")"}], " ", 
    SuperscriptBox["g", "7"]}]}], "}"}]], "Output",
 CellChangeTimes->{{3.555935206969879*^9, 3.5559352205539227`*^9}, {
   3.555936180485079*^9, 3.5559362085495033`*^9}, {3.555939130272954*^9, 
   3.5559391956455383`*^9}, {3.555939256158616*^9, 3.55593927401054*^9}, {
   3.555939325555442*^9, 3.555939377249193*^9}, {3.5559394302255697`*^9, 
   3.555939492263281*^9}, {3.555939537617312*^9, 3.555939595250095*^9}, {
   3.55593965614935*^9, 3.5559396969920473`*^9}, {3.555940284991729*^9, 
   3.555940320641089*^9}, {3.5559405987516747`*^9, 3.5559406049451313`*^9}, {
   3.5559406427077436`*^9, 3.555940646789515*^9}, {3.55594067692083*^9, 
   3.555940757849362*^9}, 3.555941108128314*^9, 3.555941151309*^9, {
   3.555941211013476*^9, 3.555941222262995*^9}, 3.555941263100526*^9, 
   3.555941437176063*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"integral1", "/.", 
  RowBox[{
   SuperscriptBox["g", 
    RowBox[{"a_", "/;", 
     RowBox[{"a", ">", "1"}]}]], "\[Rule]", "0"}]}]], "Input",
 CellChangeTimes->{{3.5559414092641153`*^9, 3.555941411330803*^9}, {
  3.5559414415939817`*^9, 3.555941462994375*^9}}],

Cell[BoxData[
 RowBox[{
  FractionBox[
   RowBox[{"u", " ", 
    RowBox[{"(", 
     RowBox[{
      FractionBox[
       SubsuperscriptBox[
        StyleBox["\[Eta]",
         FontWeight->Bold,
         FontColor->RGBColor[0.8, 0, 0]], "1", 
        RowBox[{"[", "2", "]"}]], "2"], "-", 
      RowBox[{
       FractionBox["1", "2"], " ", 
       SubsuperscriptBox[
        OverscriptBox[
         StyleBox["\[Eta]",
          FontWeight->Bold,
          FontColor->RGBColor[0.8, 0, 0]], 
         StyleBox["_",
          FontWeight->Bold,
          FontColor->RGBColor[0.8, 0, 0]]], "1", 
        RowBox[{"[", 
         RowBox[{"-", "2"}], "]"}]]}]}], ")"}]}], "g"], "+", 
  RowBox[{"g", " ", 
   RowBox[{"(", 
    RowBox[{
     FractionBox[
      RowBox[{
       RowBox[{
        RowBox[{"-", "2"}], " ", "\[ImaginaryI]", " ", 
        SubscriptBox[
         StyleBox["\[Zeta]",
          FontWeight->Bold,
          FontColor->GrayLevel[0.4]], "1"]}], "-", 
       SubsuperscriptBox[
        StyleBox["\[Eta]",
         FontWeight->Bold,
         FontColor->RGBColor[0.8, 0, 0]], "1", 
        RowBox[{"[", "2", "]"}]], "+", 
       SubsuperscriptBox[
        OverscriptBox[
         StyleBox["\[Eta]",
          FontWeight->Bold,
          FontColor->RGBColor[0.8, 0, 0]], 
         StyleBox["_",
          FontWeight->Bold,
          FontColor->RGBColor[0.8, 0, 0]]], "1", 
        RowBox[{"[", 
         RowBox[{"-", "2"}], "]"}]]}], "u"], "+", 
     RowBox[{"u", " ", 
      SuperscriptBox["z", "2"], " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"2", " ", 
         SubsuperscriptBox[
          StyleBox["\[Eta]",
           FontWeight->Bold,
           FontColor->RGBColor[0.8, 0, 0]], "3", 
          RowBox[{"[", "2", "]"}]]}], "-", 
        RowBox[{"2", " ", 
         SubsuperscriptBox[
          OverscriptBox[
           StyleBox["\[Eta]",
            FontWeight->Bold,
            FontColor->RGBColor[0.8, 0, 0]], 
           StyleBox["_",
            FontWeight->Bold,
            FontColor->RGBColor[0.8, 0, 0]]], "3", 
          RowBox[{"[", 
           RowBox[{"-", "2"}], "]"}]]}]}], ")"}]}]}], ")"}]}]}]], "Output",
 CellChangeTimes->{
  3.5559414131883373`*^9, {3.5559414450976477`*^9, 3.555941463162365*^9}}]
}, Open  ]],

Cell["\<\
The terms which do not depend on z will cancell anyway, so we can write\
\>", "Text",
 CellChangeTimes->{{3.5559414687349367`*^9, 3.555941493149857*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"tmp1", "=", 
  RowBox[{"Collect", "[", 
   RowBox[{
    RowBox[{"integral1", "-", 
     RowBox[{"(", 
      RowBox[{"integral1", "/.", 
       RowBox[{"z", "\[Rule]", "0"}]}], ")"}]}], ",", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"g", ",", "z", ",", "v", ",", "\[Eta]list"}], "}"}], "//", 
     "Flatten"}], ",", "Simplify"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.5559414946074457`*^9, 3.5559415222329283`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"g", " ", 
   SuperscriptBox["z", "2"], " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"2", " ", "u", " ", 
      SubsuperscriptBox[
       StyleBox["\[Eta]",
        FontWeight->Bold,
        FontColor->RGBColor[0.8, 0, 0]], "3", 
       RowBox[{"[", "2", "]"}]]}], "-", 
     RowBox[{"2", " ", "u", " ", 
      SubsuperscriptBox[
       OverscriptBox[
        StyleBox["\[Eta]",
         FontWeight->Bold,
         FontColor->RGBColor[0.8, 0, 0]], 
        StyleBox["_",
         FontWeight->Bold,
         FontColor->RGBColor[0.8, 0, 0]]], "3", 
       RowBox[{"[", 
        RowBox[{"-", "2"}], "]"}]]}]}], ")"}]}], "+", 
  RowBox[{
   SuperscriptBox["g", "3"], " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{
      SuperscriptBox["z", "2"], " ", 
      RowBox[{"(", 
       RowBox[{
        FractionBox[
         RowBox[{"8", " ", "\[ImaginaryI]", " ", 
          SubscriptBox[
           StyleBox["\[Zeta]",
            FontWeight->Bold,
            FontColor->GrayLevel[0.4]], "3"]}], "u"], "-", 
        FractionBox[
         RowBox[{"4", " ", 
          SubsuperscriptBox[
           StyleBox["\[Eta]",
            FontWeight->Bold,
            FontColor->RGBColor[0.8, 0, 0]], "3", 
           RowBox[{"[", "2", "]"}]]}], "u"], "+", 
        FractionBox[
         RowBox[{"4", " ", 
          SubsuperscriptBox[
           OverscriptBox[
            StyleBox["\[Eta]",
             FontWeight->Bold,
             FontColor->RGBColor[0.8, 0, 0]], 
            StyleBox["_",
             FontWeight->Bold,
             FontColor->RGBColor[0.8, 0, 0]]], "3", 
           RowBox[{"[", 
            RowBox[{"-", "2"}], "]"}]]}], "u"]}], ")"}]}], "+", 
     RowBox[{
      SuperscriptBox["z", "4"], " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"8", " ", "u", " ", 
         SubsuperscriptBox[
          StyleBox["\[Eta]",
           FontWeight->Bold,
           FontColor->RGBColor[0.8, 0, 0]], "5", 
          RowBox[{"[", "2", "]"}]]}], "-", 
        RowBox[{"8", " ", "u", " ", 
         SubsuperscriptBox[
          OverscriptBox[
           StyleBox["\[Eta]",
            FontWeight->Bold,
            FontColor->RGBColor[0.8, 0, 0]], 
           StyleBox["_",
            FontWeight->Bold,
            FontColor->RGBColor[0.8, 0, 0]]], "5", 
          RowBox[{"[", 
           RowBox[{"-", "2"}], "]"}]]}]}], ")"}]}]}], ")"}]}], "+", 
  RowBox[{
   SuperscriptBox["g", "5"], " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{
      SuperscriptBox["z", "2"], " ", 
      RowBox[{"(", 
       RowBox[{
        FractionBox[
         RowBox[{"8", " ", "\[ImaginaryI]", " ", 
          RowBox[{"(", 
           RowBox[{
            SubscriptBox[
             StyleBox["\[Zeta]",
              FontWeight->Bold,
              FontColor->GrayLevel[0.4]], "3"], "-", 
            RowBox[{"6", " ", 
             SuperscriptBox["u", "2"], " ", 
             SubscriptBox[
              StyleBox["\[Zeta]",
               FontWeight->Bold,
               FontColor->GrayLevel[0.4]], "5"]}]}], ")"}]}], 
         SuperscriptBox["u", "3"]], "-", 
        FractionBox[
         RowBox[{"4", " ", 
          SubsuperscriptBox[
           StyleBox["\[Eta]",
            FontWeight->Bold,
            FontColor->RGBColor[0.8, 0, 0]], "3", 
           RowBox[{"[", "2", "]"}]]}], 
         SuperscriptBox["u", "3"]], "+", 
        FractionBox[
         RowBox[{"4", " ", 
          SubsuperscriptBox[
           OverscriptBox[
            StyleBox["\[Eta]",
             FontWeight->Bold,
             FontColor->RGBColor[0.8, 0, 0]], 
            StyleBox["_",
             FontWeight->Bold,
             FontColor->RGBColor[0.8, 0, 0]]], "3", 
           RowBox[{"[", 
            RowBox[{"-", "2"}], "]"}]]}], 
         SuperscriptBox["u", "3"]]}], ")"}]}], "+", 
     RowBox[{
      SuperscriptBox["z", "4"], " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", 
         FractionBox[
          RowBox[{"32", " ", "\[ImaginaryI]", " ", 
           SubscriptBox[
            StyleBox["\[Zeta]",
             FontWeight->Bold,
             FontColor->GrayLevel[0.4]], "5"]}], "u"]}], "-", 
        FractionBox[
         RowBox[{"16", " ", 
          SubsuperscriptBox[
           StyleBox["\[Eta]",
            FontWeight->Bold,
            FontColor->RGBColor[0.8, 0, 0]], "5", 
           RowBox[{"[", "2", "]"}]]}], "u"], "+", 
        FractionBox[
         RowBox[{"16", " ", 
          SubsuperscriptBox[
           OverscriptBox[
            StyleBox["\[Eta]",
             FontWeight->Bold,
             FontColor->RGBColor[0.8, 0, 0]], 
            StyleBox["_",
             FontWeight->Bold,
             FontColor->RGBColor[0.8, 0, 0]]], "5", 
           RowBox[{"[", 
            RowBox[{"-", "2"}], "]"}]]}], "u"]}], ")"}]}], "+", 
     RowBox[{
      SuperscriptBox["z", "6"], " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"32", " ", "u", " ", 
         SubsuperscriptBox[
          StyleBox["\[Eta]",
           FontWeight->Bold,
           FontColor->RGBColor[0.8, 0, 0]], "7", 
          RowBox[{"[", "2", "]"}]]}], "-", 
        RowBox[{"32", " ", "u", " ", 
         SubsuperscriptBox[
          OverscriptBox[
           StyleBox["\[Eta]",
            FontWeight->Bold,
            FontColor->RGBColor[0.8, 0, 0]], 
           StyleBox["_",
            FontWeight->Bold,
            FontColor->RGBColor[0.8, 0, 0]]], "7", 
          RowBox[{"[", 
           RowBox[{"-", "2"}], "]"}]]}]}], ")"}]}]}], ")"}]}], "+", 
  RowBox[{
   SuperscriptBox["g", "7"], " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{
      SuperscriptBox["z", "2"], " ", 
      RowBox[{"(", 
       RowBox[{
        FractionBox[
         RowBox[{"16", " ", "\[ImaginaryI]", " ", 
          RowBox[{"(", 
           RowBox[{
            SubscriptBox[
             StyleBox["\[Zeta]",
              FontWeight->Bold,
              FontColor->GrayLevel[0.4]], "3"], "-", 
            RowBox[{"6", " ", 
             SuperscriptBox["u", "2"], " ", 
             SubscriptBox[
              StyleBox["\[Zeta]",
               FontWeight->Bold,
               FontColor->GrayLevel[0.4]], "5"]}], "+", 
            RowBox[{"15", " ", 
             SuperscriptBox["u", "4"], " ", 
             SubscriptBox[
              StyleBox["\[Zeta]",
               FontWeight->Bold,
               FontColor->GrayLevel[0.4]], "7"]}]}], ")"}]}], 
         SuperscriptBox["u", "5"]], "-", 
        FractionBox[
         RowBox[{"8", " ", 
          SubsuperscriptBox[
           StyleBox["\[Eta]",
            FontWeight->Bold,
            FontColor->RGBColor[0.8, 0, 0]], "3", 
           RowBox[{"[", "2", "]"}]]}], 
         SuperscriptBox["u", "5"]], "+", 
        FractionBox[
         RowBox[{"8", " ", 
          SubsuperscriptBox[
           OverscriptBox[
            StyleBox["\[Eta]",
             FontWeight->Bold,
             FontColor->RGBColor[0.8, 0, 0]], 
            StyleBox["_",
             FontWeight->Bold,
             FontColor->RGBColor[0.8, 0, 0]]], "3", 
           RowBox[{"[", 
            RowBox[{"-", "2"}], "]"}]]}], 
         SuperscriptBox["u", "5"]]}], ")"}]}], "+", 
     RowBox[{
      SuperscriptBox["z", "4"], " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", 
         FractionBox[
          RowBox[{"32", " ", "\[ImaginaryI]", " ", 
           RowBox[{"(", 
            RowBox[{
             SubscriptBox[
              StyleBox["\[Zeta]",
               FontWeight->Bold,
               FontColor->GrayLevel[0.4]], "5"], "-", 
             RowBox[{"15", " ", 
              SuperscriptBox["u", "2"], " ", 
              SubscriptBox[
               StyleBox["\[Zeta]",
                FontWeight->Bold,
                FontColor->GrayLevel[0.4]], "7"]}]}], ")"}]}], 
          SuperscriptBox["u", "3"]]}], "-", 
        FractionBox[
         RowBox[{"16", " ", 
          SubsuperscriptBox[
           StyleBox["\[Eta]",
            FontWeight->Bold,
            FontColor->RGBColor[0.8, 0, 0]], "5", 
           RowBox[{"[", "2", "]"}]]}], 
         SuperscriptBox["u", "3"]], "+", 
        FractionBox[
         RowBox[{"16", " ", 
          SubsuperscriptBox[
           OverscriptBox[
            StyleBox["\[Eta]",
             FontWeight->Bold,
             FontColor->RGBColor[0.8, 0, 0]], 
            StyleBox["_",
             FontWeight->Bold,
             FontColor->RGBColor[0.8, 0, 0]]], "5", 
           RowBox[{"[", 
            RowBox[{"-", "2"}], "]"}]]}], 
         SuperscriptBox["u", "3"]]}], ")"}]}], "+", 
     RowBox[{
      SuperscriptBox["z", "6"], " ", 
      RowBox[{"(", 
       RowBox[{
        FractionBox[
         RowBox[{"128", " ", "\[ImaginaryI]", " ", 
          SubscriptBox[
           StyleBox["\[Zeta]",
            FontWeight->Bold,
            FontColor->GrayLevel[0.4]], "7"]}], "u"], "-", 
        FractionBox[
         RowBox[{"64", " ", 
          SubsuperscriptBox[
           StyleBox["\[Eta]",
            FontWeight->Bold,
            FontColor->RGBColor[0.8, 0, 0]], "7", 
           RowBox[{"[", "2", "]"}]]}], "u"], "+", 
        FractionBox[
         RowBox[{"64", " ", 
          SubsuperscriptBox[
           OverscriptBox[
            StyleBox["\[Eta]",
             FontWeight->Bold,
             FontColor->RGBColor[0.8, 0, 0]], 
            StyleBox["_",
             FontWeight->Bold,
             FontColor->RGBColor[0.8, 0, 0]]], "7", 
           RowBox[{"[", 
            RowBox[{"-", "2"}], "]"}]]}], "u"]}], ")"}]}], "+", 
     RowBox[{
      SuperscriptBox["z", "8"], " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"128", " ", "u", " ", 
         SubsuperscriptBox[
          StyleBox["\[Eta]",
           FontWeight->Bold,
           FontColor->RGBColor[0.8, 0, 0]], "9", 
          RowBox[{"[", "2", "]"}]]}], "-", 
        RowBox[{"128", " ", "u", " ", 
         SubsuperscriptBox[
          OverscriptBox[
           StyleBox["\[Eta]",
            FontWeight->Bold,
            FontColor->RGBColor[0.8, 0, 0]], 
           StyleBox["_",
            FontWeight->Bold,
            FontColor->RGBColor[0.8, 0, 0]]], "9", 
          RowBox[{"[", 
           RowBox[{"-", "2"}], "]"}]]}]}], ")"}]}]}], ")"}]}]}]], "Output",
 CellChangeTimes->{{3.5559415058667994`*^9, 3.555941522860466*^9}, 
   3.555942550413362*^9, 3.555942612149439*^9, 3.5603369174679728`*^9}]
}, Open  ]],

Cell[TextData[{
 "Note that immediately improves convergency: no ",
 Cell[BoxData[
  FormBox[
   SubscriptBox["\[Eta]", "1"], TraditionalForm]]],
 " and ",
 Cell[BoxData[
  FormBox[
   SubscriptBox["\[Zeta]", "1"], TraditionalForm]]],
 " terms. We now use that answer is odd in u to reduce integral to a  \
standard form"
}], "Text",
 CellChangeTimes->{{3.55594154423801*^9, 3.5559415614033537`*^9}, {
  3.555941615129541*^9, 3.555941674888364*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   SubsuperscriptBox["\[Integral]", 
    RowBox[{"-", "\[Infinity]"}], 
    RowBox[{"+", "\[Infinity]"}]], 
   RowBox[{
    FractionBox["du", 
     RowBox[{
      RowBox[{"-", "2"}], "\[Pi]", " ", "\[ImaginaryI]"}]], 
    FractionBox["1", 
     SuperscriptBox["u", "a"]], 
    RowBox[{"(", 
     RowBox[{
      SuperscriptBox[
       RowBox[{"(", 
        RowBox[{
         FractionBox["1", 
          RowBox[{
           FractionBox["u", "g"], 
           SqrtBox[
            RowBox[{"1", "-", 
             FractionBox[
              RowBox[{"4", 
               SuperscriptBox["g", "2"]}], 
              SuperscriptBox["u", "2"]]}]]}]], 
         OverscriptBox["H", "_"]}], ")"}], 
       RowBox[{"[", 
        RowBox[{"+", "o"}], "]"}]], "+", 
      SuperscriptBox[
       RowBox[{"(", 
        RowBox[{
         FractionBox["1", 
          RowBox[{
           FractionBox["u", "g"], 
           SqrtBox[
            RowBox[{"1", "-", 
             FractionBox[
              RowBox[{"4", 
               SuperscriptBox["g", "2"]}], 
              SuperscriptBox["u", "2"]]}]]}]], "H"}], ")"}], 
       RowBox[{"[", 
        RowBox[{"-", "o"}], "]"}]]}], ")"}]}]}], "\[Equal]", 
  RowBox[{"2", 
   RowBox[{"\[DoubleStruckCapitalC]", "[", 
    RowBox[{
     FractionBox["1", 
      SuperscriptBox["u", "a"]], 
     FractionBox["1", 
      RowBox[{
       FractionBox["u", "g"], 
       SqrtBox[
        RowBox[{"1", "-", 
         FractionBox[
          RowBox[{"4", 
           SuperscriptBox["g", "2"]}], 
          SuperscriptBox["u", "2"]]}]]}]], "H"}], "]"}]}]}]], "Input",
 CellChangeTimes->{{3.555941638438579*^9, 3.5559417055054617`*^9}}],

Cell["so we can reexpand things", "Text",
 CellChangeTimes->{{3.555942600212631*^9, 3.5559426172996597`*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"tmp11", "=", 
  RowBox[{"Normal", "@", 
   RowBox[{"Series", "[", 
    RowBox[{
     RowBox[{"tmp1", " ", 
      RowBox[{"(", 
       RowBox[{"2", 
        FractionBox["1", 
         RowBox[{
          FractionBox["u", "g"], 
          SqrtBox[
           RowBox[{"1", "-", 
            FractionBox[
             RowBox[{"4", 
              SuperscriptBox["g", "2"]}], 
             SuperscriptBox["u", "2"]]}]]}]]}], ")"}]}], ",", 
     RowBox[{"{", 
      RowBox[{"g", ",", "0", ",", "8"}], "}"}]}], "]"}]}]}]], "Input",
 CellChangeTimes->{{3.555942749990095*^9, 3.555942750955948*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"4", " ", 
   SuperscriptBox["g", "2"], " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{
      SuperscriptBox["z", "2"], " ", 
      SubsuperscriptBox[
       StyleBox["\[Eta]",
        FontWeight->Bold,
        FontColor->RGBColor[0.8, 0, 0]], "3", 
       RowBox[{"[", "2", "]"}]]}], "-", 
     RowBox[{
      SuperscriptBox["z", "2"], " ", 
      SubsuperscriptBox[
       OverscriptBox[
        StyleBox["\[Eta]",
         FontWeight->Bold,
         FontColor->RGBColor[0.8, 0, 0]], 
        StyleBox["_",
         FontWeight->Bold,
         FontColor->RGBColor[0.8, 0, 0]]], "3", 
       RowBox[{"[", 
        RowBox[{"-", "2"}], "]"}]]}]}], ")"}]}], "+", 
  FractionBox[
   RowBox[{"16", " ", 
    SuperscriptBox["g", "4"], " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"\[ImaginaryI]", " ", 
       SuperscriptBox["z", "2"], " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "3"]}], "+", 
      RowBox[{
       SuperscriptBox["u", "2"], " ", 
       SuperscriptBox["z", "4"], " ", 
       SubsuperscriptBox[
        StyleBox["\[Eta]",
         FontWeight->Bold,
         FontColor->RGBColor[0.8, 0, 0]], "5", 
        RowBox[{"[", "2", "]"}]]}], "-", 
      RowBox[{
       SuperscriptBox["u", "2"], " ", 
       SuperscriptBox["z", "4"], " ", 
       SubsuperscriptBox[
        OverscriptBox[
         StyleBox["\[Eta]",
          FontWeight->Bold,
          FontColor->RGBColor[0.8, 0, 0]], 
         StyleBox["_",
          FontWeight->Bold,
          FontColor->RGBColor[0.8, 0, 0]]], "5", 
        RowBox[{"[", 
         RowBox[{"-", "2"}], "]"}]]}]}], ")"}]}], 
   SuperscriptBox["u", "2"]], "+", 
  FractionBox[
   RowBox[{"16", " ", 
    SuperscriptBox["g", "6"], " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"3", " ", "\[ImaginaryI]", " ", 
       SuperscriptBox["z", "2"], " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "3"]}], "-", 
      RowBox[{"6", " ", "\[ImaginaryI]", " ", 
       SuperscriptBox["u", "2"], " ", 
       SuperscriptBox["z", "2"], " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "5"]}], "-", 
      RowBox[{"4", " ", "\[ImaginaryI]", " ", 
       SuperscriptBox["u", "2"], " ", 
       SuperscriptBox["z", "4"], " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "5"]}], "+", 
      RowBox[{"4", " ", 
       SuperscriptBox["u", "4"], " ", 
       SuperscriptBox["z", "6"], " ", 
       SubsuperscriptBox[
        StyleBox["\[Eta]",
         FontWeight->Bold,
         FontColor->RGBColor[0.8, 0, 0]], "7", 
        RowBox[{"[", "2", "]"}]]}], "-", 
      RowBox[{"4", " ", 
       SuperscriptBox["u", "4"], " ", 
       SuperscriptBox["z", "6"], " ", 
       SubsuperscriptBox[
        OverscriptBox[
         StyleBox["\[Eta]",
          FontWeight->Bold,
          FontColor->RGBColor[0.8, 0, 0]], 
         StyleBox["_",
          FontWeight->Bold,
          FontColor->RGBColor[0.8, 0, 0]]], "7", 
        RowBox[{"[", 
         RowBox[{"-", "2"}], "]"}]]}]}], ")"}]}], 
   SuperscriptBox["u", "4"]], "+", 
  FractionBox[
   RowBox[{"32", " ", 
    SuperscriptBox["g", "8"], " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"5", " ", "\[ImaginaryI]", " ", 
       SuperscriptBox["z", "2"], " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "3"]}], "-", 
      RowBox[{"12", " ", "\[ImaginaryI]", " ", 
       SuperscriptBox["u", "2"], " ", 
       SuperscriptBox["z", "2"], " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "5"]}], "-", 
      RowBox[{"6", " ", "\[ImaginaryI]", " ", 
       SuperscriptBox["u", "2"], " ", 
       SuperscriptBox["z", "4"], " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "5"]}], "+", 
      RowBox[{"15", " ", "\[ImaginaryI]", " ", 
       SuperscriptBox["u", "4"], " ", 
       SuperscriptBox["z", "2"], " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "7"]}], "+", 
      RowBox[{"30", " ", "\[ImaginaryI]", " ", 
       SuperscriptBox["u", "4"], " ", 
       SuperscriptBox["z", "4"], " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "7"]}], "+", 
      RowBox[{"8", " ", "\[ImaginaryI]", " ", 
       SuperscriptBox["u", "4"], " ", 
       SuperscriptBox["z", "6"], " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "7"]}], "+", 
      RowBox[{"8", " ", 
       SuperscriptBox["u", "6"], " ", 
       SuperscriptBox["z", "8"], " ", 
       SubsuperscriptBox[
        StyleBox["\[Eta]",
         FontWeight->Bold,
         FontColor->RGBColor[0.8, 0, 0]], "9", 
        RowBox[{"[", "2", "]"}]]}], "-", 
      RowBox[{"8", " ", 
       SuperscriptBox["u", "6"], " ", 
       SuperscriptBox["z", "8"], " ", 
       SubsuperscriptBox[
        OverscriptBox[
         StyleBox["\[Eta]",
          FontWeight->Bold,
          FontColor->RGBColor[0.8, 0, 0]], 
         StyleBox["_",
          FontWeight->Bold,
          FontColor->RGBColor[0.8, 0, 0]]], "9", 
        RowBox[{"[", 
         RowBox[{"-", "2"}], "]"}]]}]}], ")"}]}], 
   SuperscriptBox["u", "6"]]}]], "Output",
 CellChangeTimes->{3.555942751478271*^9, 3.560336922464818*^9}]
}, Open  ]],

Cell["\<\
There is also a homogeneous piece which should be considered.\
\>", "Text",
 CellChangeTimes->{{3.555941884495112*^9, 3.5559419046067467`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"\[Integral]", 
    RowBox[{
     FractionBox["du", 
      RowBox[{"2", "\[ImaginaryI]"}]], 
     SubscriptBox[
      RowBox[{"(", 
       RowBox[{
        RowBox[{"Coth", "[", 
         RowBox[{"\[Pi]", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"2", "g", " ", "z"}], "-", "u"}], ")"}]}], "]"}], 
        OverscriptBox["Yf", "^"]}], ")"}], "pv"]}]}], "==", 
   RowBox[{"\[Integral]", 
    RowBox[{
     FractionBox["du", 
      RowBox[{
       RowBox[{"-", "2"}], "\[Pi]", " ", "\[ImaginaryI]"}]], 
     FractionBox["1", "2"], 
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          RowBox[{"\[Pi]", " ", 
           RowBox[{"Coth", "[", 
            RowBox[{"\[Pi]", 
             RowBox[{"(", 
              RowBox[{"u", "-", 
               RowBox[{"2", "g", " ", "z"}]}], ")"}]}], "]"}]}], "+", 
          RowBox[{"\[Pi]", " ", 
           RowBox[{"Coth", "[", 
            RowBox[{"\[Pi]", 
             RowBox[{"(", 
              RowBox[{"u", "+", 
               RowBox[{"2", "g", " ", "z"}]}], ")"}]}], "]"}]}]}], ")"}], 
        OverscriptBox["Yf", "^"]}], ")"}], 
      RowBox[{"[", 
       RowBox[{"-", "o"}], "]"}]]}]}]}], "\[Rule]", " ", 
  RowBox[{"\[DoubleStruckCapitalC]", "[", 
   RowBox[{
    RowBox[{"-", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"\[Pi]", " ", 
        RowBox[{"Coth", "[", 
         RowBox[{"\[Pi]", 
          RowBox[{"(", 
           RowBox[{"u", "-", 
            RowBox[{"2", "g", " ", "z"}]}], ")"}]}], "]"}]}], "+", 
       RowBox[{"\[Pi]", " ", 
        RowBox[{"Coth", "[", 
         RowBox[{"\[Pi]", 
          RowBox[{"(", 
           RowBox[{"u", "+", 
            RowBox[{"2", "g", " ", "z"}]}], ")"}]}], "]"}]}]}], ")"}]}], 
    "H"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.555941971545079*^9, 3.555942082165902*^9}, {
  3.555942246550453*^9, 3.555942247157467*^9}}],

Cell["\<\
This is also to be exapnded in powers of g. We also will substract answer at \
z=0.\
\>", "Text",
 CellChangeTimes->{{3.555942092751739*^9, 3.555942114070722*^9}}],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"integral2", "=", 
   RowBox[{
    RowBox[{"Series", "[", 
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{
         FractionBox["1", "2"], 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"(", 
            RowBox[{"#", "/.", 
             RowBox[{"u", "\[Rule]", 
              RowBox[{"u", "-", 
               RowBox[{"2", "g", " ", "z"}]}]}]}], ")"}], "+", 
           RowBox[{"(", 
            RowBox[{"#", "/.", 
             RowBox[{"u", "\[Rule]", 
              RowBox[{"u", "+", 
               RowBox[{"2", "g", " ", "z"}]}]}]}], ")"}]}], ")"}]}], "&"}], "/@", 
       RowBox[{"(", 
        RowBox[{"-", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{
            SubsuperscriptBox["\[Eta]", "1", 
             RowBox[{"[", "2", "]"}]], "[", "u", "]"}], "+", 
           FractionBox["1", "u"], "+", 
           RowBox[{
            SubsuperscriptBox[
             OverscriptBox["\[Eta]", "_"], "1", 
             RowBox[{"[", 
              RowBox[{"-", "2"}], "]"}]], "[", "u", "]"}]}], ")"}]}], ")"}]}],
       ",", 
      RowBox[{"{", 
       RowBox[{"g", ",", "0", ",", "8"}], "}"}]}], "]"}], "/.", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{"Derivative", "[", "a_", "]"}], "[", 
         RowBox[{
          RowBox[{"\[Eta]$", "[", "b__", "]"}], "[", "2", "]"}], "]"}], "[", 
        "u", "]"}], "\[RuleDelayed]", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"\[Eta]D", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"\[Eta]$", "[", "b", "]"}], "[", "0", "]"}], ",", "a"}], 
          "]"}], "/.", 
         RowBox[{"Shift", "[", "2", "]"}]}], ")"}]}], ",", 
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{"\[Eta]$", "[", "a__", "]"}], "[", "2", "]"}], "[", "u", 
        "]"}], "\[RuleDelayed]", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"\[Eta]$", "[", "a", "]"}], "[", "2", "]"}], ")"}]}], ",", 
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{"Derivative", "[", "a_", "]"}], "[", 
         RowBox[{
          RowBox[{"\[Eta]$b", "[", "b__", "]"}], "[", 
          RowBox[{"-", "2"}], "]"}], "]"}], "[", "u", "]"}], "\[RuleDelayed]", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          RowBox[{"\[Eta]D", "[", 
           RowBox[{
            RowBox[{
             RowBox[{"\[Eta]$", "[", "b", "]"}], "[", "0", "]"}], ",", "a"}], 
           "]"}], "/.", 
          RowBox[{"Shift", "[", "2", "]"}]}], "/.", "mconj"}], ")"}]}], ",", 
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{"\[Eta]$b", "[", "a__", "]"}], "[", 
         RowBox[{"-", "2"}], "]"}], "[", "u", "]"}], "\[RuleDelayed]", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"\[Eta]$b", "[", "a", "]"}], "[", 
         RowBox[{"-", "2"}], "]"}], ")"}]}]}], "}"}]}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"tmp2", "=", 
  RowBox[{
   RowBox[{"integral2", "-", 
    RowBox[{"(", 
     RowBox[{"integral2", "/.", 
      RowBox[{"z", "\[Rule]", "0"}]}], ")"}]}], "//", "Normal"}]}]}], "Input",\

 CellChangeTimes->{{3.555942148239159*^9, 3.5559421522286367`*^9}, {
   3.5559422028010406`*^9, 3.555942346970387*^9}, {3.5559424079157457`*^9, 
   3.555942484868475*^9}, 3.555942569340311*^9, {3.555942770371768*^9, 
   3.5559427718640747`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   SuperscriptBox["g", "2"], " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"-", 
      FractionBox[
       RowBox[{"4", " ", 
        SuperscriptBox["z", "2"]}], 
       SuperscriptBox["u", "3"]]}], "-", 
     RowBox[{"4", " ", 
      SuperscriptBox["z", "2"], " ", 
      SubsuperscriptBox[
       StyleBox["\[Eta]",
        FontWeight->Bold,
        FontColor->RGBColor[0.8, 0, 0]], "3", 
       RowBox[{"[", "2", "]"}]]}], "-", 
     RowBox[{"4", " ", 
      SuperscriptBox["z", "2"], " ", 
      SubsuperscriptBox[
       OverscriptBox[
        StyleBox["\[Eta]",
         FontWeight->Bold,
         FontColor->RGBColor[0.8, 0, 0]], 
        StyleBox["_",
         FontWeight->Bold,
         FontColor->RGBColor[0.8, 0, 0]]], "3", 
       RowBox[{"[", 
        RowBox[{"-", "2"}], "]"}]]}]}], ")"}]}], "+", 
  RowBox[{
   SuperscriptBox["g", "4"], " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"-", 
      FractionBox[
       RowBox[{"16", " ", 
        SuperscriptBox["z", "4"]}], 
       SuperscriptBox["u", "5"]]}], "-", 
     RowBox[{"16", " ", 
      SuperscriptBox["z", "4"], " ", 
      SubsuperscriptBox[
       StyleBox["\[Eta]",
        FontWeight->Bold,
        FontColor->RGBColor[0.8, 0, 0]], "5", 
       RowBox[{"[", "2", "]"}]]}], "-", 
     RowBox[{"16", " ", 
      SuperscriptBox["z", "4"], " ", 
      SubsuperscriptBox[
       OverscriptBox[
        StyleBox["\[Eta]",
         FontWeight->Bold,
         FontColor->RGBColor[0.8, 0, 0]], 
        StyleBox["_",
         FontWeight->Bold,
         FontColor->RGBColor[0.8, 0, 0]]], "5", 
       RowBox[{"[", 
        RowBox[{"-", "2"}], "]"}]]}]}], ")"}]}], "+", 
  RowBox[{
   SuperscriptBox["g", "6"], " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"-", 
      FractionBox[
       RowBox[{"64", " ", 
        SuperscriptBox["z", "6"]}], 
       SuperscriptBox["u", "7"]]}], "-", 
     RowBox[{"64", " ", 
      SuperscriptBox["z", "6"], " ", 
      SubsuperscriptBox[
       StyleBox["\[Eta]",
        FontWeight->Bold,
        FontColor->RGBColor[0.8, 0, 0]], "7", 
       RowBox[{"[", "2", "]"}]]}], "-", 
     RowBox[{"64", " ", 
      SuperscriptBox["z", "6"], " ", 
      SubsuperscriptBox[
       OverscriptBox[
        StyleBox["\[Eta]",
         FontWeight->Bold,
         FontColor->RGBColor[0.8, 0, 0]], 
        StyleBox["_",
         FontWeight->Bold,
         FontColor->RGBColor[0.8, 0, 0]]], "7", 
       RowBox[{"[", 
        RowBox[{"-", "2"}], "]"}]]}]}], ")"}]}], "+", 
  RowBox[{
   SuperscriptBox["g", "8"], " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"-", 
      FractionBox[
       RowBox[{"256", " ", 
        SuperscriptBox["z", "8"]}], 
       SuperscriptBox["u", "9"]]}], "-", 
     RowBox[{"256", " ", 
      SuperscriptBox["z", "8"], " ", 
      SubsuperscriptBox[
       StyleBox["\[Eta]",
        FontWeight->Bold,
        FontColor->RGBColor[0.8, 0, 0]], "9", 
       RowBox[{"[", "2", "]"}]]}], "-", 
     RowBox[{"256", " ", 
      SuperscriptBox["z", "8"], " ", 
      SubsuperscriptBox[
       OverscriptBox[
        StyleBox["\[Eta]",
         FontWeight->Bold,
         FontColor->RGBColor[0.8, 0, 0]], 
        StyleBox["_",
         FontWeight->Bold,
         FontColor->RGBColor[0.8, 0, 0]]], "9", 
       RowBox[{"[", 
        RowBox[{"-", "2"}], "]"}]]}]}], ")"}]}]}]], "Output",
 CellChangeTimes->{{3.555942329792302*^9, 3.555942347510675*^9}, {
   3.555942445816257*^9, 3.5559424490228167`*^9}, 3.555942485293386*^9, 
   3.555942569900468*^9, {3.555942768442346*^9, 3.555942772218566*^9}, 
   3.5603369264228992`*^9}]
}, Closed]],

Cell["\<\
So finally we end up with \[DoubleStruckCapitalC] integral:\
\>", "Text",
 CellChangeTimes->{{3.555942780501954*^9, 3.555942789757052*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"preanswer", "=", 
  RowBox[{"Collect", "[", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"Series", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"(", 
          RowBox[{"tmp11", "+", "tmp2"}], ")"}], 
         RowBox[{"(", 
          RowBox[{
           SuperscriptBox["g", "8"], 
           RowBox[{"(", 
            RowBox[{
             SubscriptBox["H", "lead"], "+", 
             RowBox[{
              SuperscriptBox["g", "2"], 
              SubscriptBox["H", "sublead"]}], "+", 
             RowBox[{
              SuperscriptBox["g", "4"], 
              SubscriptBox["H", "sublead2"]}]}], ")"}]}], ")"}]}], ",", 
        RowBox[{"{", 
         RowBox[{"g", ",", "0", ",", "14"}], "}"}]}], "]"}], "//", "Normal"}],
      "//", "Expand"}], ",", 
    RowBox[{
     SuperscriptBox["g", "_."], 
     SuperscriptBox["z", "_."]}], ",", "\[DoubleStruckCapitalC]"}], 
   "]"}]}]], "Input",
 CellChangeTimes->{{3.5559426182976837`*^9, 3.555942760906838*^9}, {
  3.555942800263503*^9, 3.555942964801708*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   SuperscriptBox["g", "10"], " ", 
   SuperscriptBox["z", "2"], " ", 
   RowBox[{"\[DoubleStruckCapitalC]", "[", 
    RowBox[{
     RowBox[{"-", 
      FractionBox[
       RowBox[{"4", " ", 
        SubscriptBox[
         StyleBox["H",
          FontColor->RGBColor[0.54, 0.35, 0.15]], "lead"]}], 
       SuperscriptBox["u", "3"]]}], "-", 
     RowBox[{"8", " ", 
      SubscriptBox[
       StyleBox["H",
        FontColor->RGBColor[0.54, 0.35, 0.15]], "lead"], " ", 
      SubsuperscriptBox[
       OverscriptBox[
        StyleBox["\[Eta]",
         FontWeight->Bold,
         FontColor->RGBColor[0.8, 0, 0]], 
        StyleBox["_",
         FontWeight->Bold,
         FontColor->RGBColor[0.8, 0, 0]]], "3", 
       RowBox[{"[", 
        RowBox[{"-", "2"}], "]"}]]}]}], "]"}]}], "+", 
  RowBox[{
   SuperscriptBox["g", "12"], " ", 
   SuperscriptBox["z", "2"], " ", 
   RowBox[{"\[DoubleStruckCapitalC]", "[", 
    RowBox[{
     RowBox[{"-", 
      FractionBox[
       RowBox[{"4", " ", 
        SubscriptBox[
         StyleBox["H",
          FontColor->RGBColor[0.54, 0.35, 0.15]], "sublead"]}], 
       SuperscriptBox["u", "3"]]}], "+", 
     FractionBox[
      RowBox[{"16", " ", "\[ImaginaryI]", " ", 
       SubscriptBox[
        StyleBox["H",
         FontColor->RGBColor[0.54, 0.35, 0.15]], "lead"], " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "3"]}], 
      SuperscriptBox["u", "2"]], "-", 
     RowBox[{"8", " ", 
      SubscriptBox[
       StyleBox["H",
        FontColor->RGBColor[0.54, 0.35, 0.15]], "sublead"], " ", 
      SubsuperscriptBox[
       OverscriptBox[
        StyleBox["\[Eta]",
         FontWeight->Bold,
         FontColor->RGBColor[0.8, 0, 0]], 
        StyleBox["_",
         FontWeight->Bold,
         FontColor->RGBColor[0.8, 0, 0]]], "3", 
       RowBox[{"[", 
        RowBox[{"-", "2"}], "]"}]]}]}], "]"}]}], "+", 
  RowBox[{
   SuperscriptBox["g", "14"], " ", 
   SuperscriptBox["z", "2"], " ", 
   RowBox[{"\[DoubleStruckCapitalC]", "[", 
    RowBox[{
     RowBox[{"-", 
      FractionBox[
       RowBox[{"4", " ", 
        SubscriptBox[
         StyleBox["H",
          FontColor->RGBColor[0.54, 0.35, 0.15]], "sublead2"]}], 
       SuperscriptBox["u", "3"]]}], "+", 
     FractionBox[
      RowBox[{"48", " ", "\[ImaginaryI]", " ", 
       SubscriptBox[
        StyleBox["H",
         FontColor->RGBColor[0.54, 0.35, 0.15]], "lead"], " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "3"]}], 
      SuperscriptBox["u", "4"]], "+", 
     FractionBox[
      RowBox[{"16", " ", "\[ImaginaryI]", " ", 
       SubscriptBox[
        StyleBox["H",
         FontColor->RGBColor[0.54, 0.35, 0.15]], "sublead"], " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "3"]}], 
      SuperscriptBox["u", "2"]], "-", 
     FractionBox[
      RowBox[{"96", " ", "\[ImaginaryI]", " ", 
       SubscriptBox[
        StyleBox["H",
         FontColor->RGBColor[0.54, 0.35, 0.15]], "lead"], " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "5"]}], 
      SuperscriptBox["u", "2"]], "-", 
     RowBox[{"8", " ", 
      SubscriptBox[
       StyleBox["H",
        FontColor->RGBColor[0.54, 0.35, 0.15]], "sublead2"], " ", 
      SubsuperscriptBox[
       OverscriptBox[
        StyleBox["\[Eta]",
         FontWeight->Bold,
         FontColor->RGBColor[0.8, 0, 0]], 
        StyleBox["_",
         FontWeight->Bold,
         FontColor->RGBColor[0.8, 0, 0]]], "3", 
       RowBox[{"[", 
        RowBox[{"-", "2"}], "]"}]]}]}], "]"}]}], "+", 
  RowBox[{
   SuperscriptBox["g", "12"], " ", 
   SuperscriptBox["z", "4"], " ", 
   RowBox[{"\[DoubleStruckCapitalC]", "[", 
    RowBox[{
     RowBox[{"-", 
      FractionBox[
       RowBox[{"16", " ", 
        SubscriptBox[
         StyleBox["H",
          FontColor->RGBColor[0.54, 0.35, 0.15]], "lead"]}], 
       SuperscriptBox["u", "5"]]}], "-", 
     RowBox[{"32", " ", 
      SubscriptBox[
       StyleBox["H",
        FontColor->RGBColor[0.54, 0.35, 0.15]], "lead"], " ", 
      SubsuperscriptBox[
       OverscriptBox[
        StyleBox["\[Eta]",
         FontWeight->Bold,
         FontColor->RGBColor[0.8, 0, 0]], 
        StyleBox["_",
         FontWeight->Bold,
         FontColor->RGBColor[0.8, 0, 0]]], "5", 
       RowBox[{"[", 
        RowBox[{"-", "2"}], "]"}]]}]}], "]"}]}], "+", 
  RowBox[{
   SuperscriptBox["g", "14"], " ", 
   SuperscriptBox["z", "4"], " ", 
   RowBox[{"\[DoubleStruckCapitalC]", "[", 
    RowBox[{
     RowBox[{"-", 
      FractionBox[
       RowBox[{"16", " ", 
        SubscriptBox[
         StyleBox["H",
          FontColor->RGBColor[0.54, 0.35, 0.15]], "sublead"]}], 
       SuperscriptBox["u", "5"]]}], "-", 
     FractionBox[
      RowBox[{"64", " ", "\[ImaginaryI]", " ", 
       SubscriptBox[
        StyleBox["H",
         FontColor->RGBColor[0.54, 0.35, 0.15]], "lead"], " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "5"]}], 
      SuperscriptBox["u", "2"]], "-", 
     RowBox[{"32", " ", 
      SubscriptBox[
       StyleBox["H",
        FontColor->RGBColor[0.54, 0.35, 0.15]], "sublead"], " ", 
      SubsuperscriptBox[
       OverscriptBox[
        StyleBox["\[Eta]",
         FontWeight->Bold,
         FontColor->RGBColor[0.8, 0, 0]], 
        StyleBox["_",
         FontWeight->Bold,
         FontColor->RGBColor[0.8, 0, 0]]], "5", 
       RowBox[{"[", 
        RowBox[{"-", "2"}], "]"}]]}]}], "]"}]}], "+", 
  RowBox[{
   SuperscriptBox["g", "14"], " ", 
   SuperscriptBox["z", "6"], " ", 
   RowBox[{"\[DoubleStruckCapitalC]", "[", 
    RowBox[{
     RowBox[{"-", 
      FractionBox[
       RowBox[{"64", " ", 
        SubscriptBox[
         StyleBox["H",
          FontColor->RGBColor[0.54, 0.35, 0.15]], "lead"]}], 
       SuperscriptBox["u", "7"]]}], "-", 
     RowBox[{"128", " ", 
      SubscriptBox[
       StyleBox["H",
        FontColor->RGBColor[0.54, 0.35, 0.15]], "lead"], " ", 
      SubsuperscriptBox[
       OverscriptBox[
        StyleBox["\[Eta]",
         FontWeight->Bold,
         FontColor->RGBColor[0.8, 0, 0]], 
        StyleBox["_",
         FontWeight->Bold,
         FontColor->RGBColor[0.8, 0, 0]]], "7", 
       RowBox[{"[", 
        RowBox[{"-", "2"}], "]"}]]}]}], "]"}]}]}]], "Output",
 CellChangeTimes->{{3.555942832945705*^9, 3.555942847100298*^9}, {
   3.5559429477819*^9, 3.5559429655286903`*^9}, 3.5603369346086483`*^9}]
}, Closed]],

Cell[TextData[{
 "Note that integrands contain only ",
 Cell[BoxData[
  FormBox[
   OverscriptBox["\[Eta]", "_"], TraditionalForm]]],
 " functions, there is some analyticity gained. in our game."
}], "Text",
 CellChangeTimes->{{3.5559429602390623`*^9, 3.555942992285515*^9}}],

Cell["\<\
Finally we can evaluate \[ScriptCapitalZ] integral:\
\>", "Text",
 CellChangeTimes->{{3.55594299846117*^9, 3.5559430214360523`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Log", "[", 
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox[
      SuperscriptBox[
       OverscriptBox[
        StyleBox["h",
         FontColor->RGBColor[0, 0.6, 0]], 
        StyleBox["^",
         FontColor->RGBColor[0, 0.6, 0]]], "+"], 
      SuperscriptBox[
       OverscriptBox[
        StyleBox["h",
         FontColor->RGBColor[0, 0.6, 0]], 
        StyleBox["^",
         FontColor->RGBColor[0, 0.6, 0]]], "-"]], ")"}], "2"], "]"}], 
  "\[Equal]", 
  RowBox[{
   SubsuperscriptBox["\[Integral]", 
    RowBox[{"-", "1"}], "1"], 
   RowBox[{
    FractionBox["dz", 
     RowBox[{"\[Pi]", 
      SqrtBox[
       RowBox[{"1", "-", 
        SuperscriptBox["z", "2"]}]]}]], "kern", " ", 
    RowBox[{"Log", "[", 
     FractionBox[
      FractionBox[
       RowBox[{
        SuperscriptBox[
         StyleBox["\[ScriptCapitalF]",
          FontColor->RGBColor[0, 0.6, 0]], "+"], 
        RowBox[{"(", 
         RowBox[{"1", "-", 
          RowBox[{
           SubscriptBox["Y", 
            RowBox[{"1", ",", "1"}]], 
           SubscriptBox["Y", 
            RowBox[{"2", ",", "2"}]]}]}], ")"}]}], "\[Rho]"], 
      SubscriptBox[
       RowBox[{"(", 
        FractionBox[
         RowBox[{
          SuperscriptBox[
           StyleBox["\[ScriptCapitalF]",
            FontColor->RGBColor[0, 0.6, 0]], "+"], 
          RowBox[{"(", 
           RowBox[{"1", "-", 
            RowBox[{
             SubscriptBox["Y", 
              RowBox[{"1", ",", "1"}]], 
             SubscriptBox["Y", 
              RowBox[{"2", ",", "2"}]]}]}], ")"}]}], "\[Rho]"], ")"}], 
       "asym"]], "]"}]}]}]}]], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"conth\[ScriptCapitalF]", "=", 
  RowBox[{"Collect", "[", 
   RowBox[{
    RowBox[{"Series", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"Normal", "[", "kern", "]"}], " ", "preanswer"}], ",", 
      RowBox[{"{", 
       RowBox[{"g", ",", "0", ",", "14"}], "}"}]}], "]"}], ",", "g", ",", 
    RowBox[{
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           RowBox[{
            RowBox[{"Integrate", "[", 
             RowBox[{
              FractionBox["#", 
               RowBox[{"\[Pi]", 
                SqrtBox[
                 RowBox[{"1", "-", 
                  SuperscriptBox["z", "2"]}]]}]], ",", 
              RowBox[{"{", 
               RowBox[{"z", ",", 
                RowBox[{"-", "1"}], ",", "1"}], "}"}]}], "]"}], "+", 
            RowBox[{"\[DoubleStruckCapitalC]", "[", 
             RowBox[{"AAA", " ", 
              SubscriptBox["H", "me"]}], "]"}]}], "//", "Expand"}], ")"}], "/.", 
         RowBox[{
          RowBox[{"\[DoubleStruckCapitalC]", "[", "a_", "]"}], 
          "\[RuleDelayed]", 
          RowBox[{"\[DoubleStruckCapitalC]", "[", 
           RowBox[{"a", "//", "Expand"}], "]"}]}]}], "//.", 
        "sub\[DoubleStruckCapitalC]simplify"}], ")"}], "/.", 
      RowBox[{"AAA", "\[Rule]", "0"}]}], "&"}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.555943227267811*^9, 3.5559433094631557`*^9}, {
  3.5559433755014353`*^9, 3.555943379605863*^9}, {3.555943411032206*^9, 
  3.5559434354701567`*^9}, {3.5559434681858873`*^9, 3.5559435358362617`*^9}, {
  3.5559435684757442`*^9, 3.555943598553523*^9}, {3.555943644667883*^9, 
  3.555943645165422*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   SuperscriptBox["g", "12"], " ", 
   RowBox[{"\[DoubleStruckCapitalC]", "[", 
    FractionBox[
     RowBox[{"6", " ", "\[ImaginaryI]", " ", 
      SqrtBox["3"], " ", 
      SubscriptBox[
       StyleBox["H",
        FontColor->RGBColor[0.54, 0.35, 0.15]], "lead"], " ", 
      RowBox[{"(", 
       RowBox[{"1", "+", 
        RowBox[{"2", " ", 
         SuperscriptBox["u", "3"], " ", 
         SubsuperscriptBox[
          OverscriptBox[
           StyleBox["\[Eta]",
            FontWeight->Bold,
            FontColor->RGBColor[0.8, 0, 0]], 
           StyleBox["_",
            FontWeight->Bold,
            FontColor->RGBColor[0.8, 0, 0]]], "3", 
          RowBox[{"[", 
           RowBox[{"-", "2"}], "]"}]]}]}], ")"}]}], 
     SuperscriptBox["u", "3"]], "]"}]}], "+", 
  RowBox[{
   SuperscriptBox["g", "14"], " ", 
   RowBox[{"\[DoubleStruckCapitalC]", "[", 
    RowBox[{
     FractionBox[
      RowBox[{"6", " ", "\[ImaginaryI]", " ", 
       SqrtBox["3"], " ", 
       SubscriptBox[
        StyleBox["H",
         FontColor->RGBColor[0.54, 0.35, 0.15]], "sublead"], " ", 
       RowBox[{"(", 
        RowBox[{"1", "+", 
         RowBox[{"2", " ", 
          SuperscriptBox["u", "3"], " ", 
          SubsuperscriptBox[
           OverscriptBox[
            StyleBox["\[Eta]",
             FontWeight->Bold,
             FontColor->RGBColor[0.8, 0, 0]], 
            StyleBox["_",
             FontWeight->Bold,
             FontColor->RGBColor[0.8, 0, 0]]], "3", 
           RowBox[{"[", 
            RowBox[{"-", "2"}], "]"}]]}]}], ")"}]}], 
      SuperscriptBox["u", "3"]], "-", 
     FractionBox[
      RowBox[{"12", " ", "\[ImaginaryI]", " ", 
       SqrtBox["3"], " ", 
       SubscriptBox[
        StyleBox["H",
         FontColor->RGBColor[0.54, 0.35, 0.15]], "lead"], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", "2"}], "+", 
         RowBox[{"3", " ", 
          SuperscriptBox["u", "2"]}], "+", 
         RowBox[{"2", " ", "\[ImaginaryI]", " ", 
          SuperscriptBox["u", "3"], " ", 
          SubscriptBox[
           StyleBox["\[Zeta]",
            FontWeight->Bold,
            FontColor->GrayLevel[0.4]], "3"]}], "+", 
         RowBox[{
          SuperscriptBox["u", "5"], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"6", " ", 
             SubsuperscriptBox[
              OverscriptBox[
               StyleBox["\[Eta]",
                FontWeight->Bold,
                FontColor->RGBColor[0.8, 0, 0]], 
               StyleBox["_",
                FontWeight->Bold,
                FontColor->RGBColor[0.8, 0, 0]]], "3", 
              RowBox[{"[", 
               RowBox[{"-", "2"}], "]"}]]}], "-", 
            RowBox[{"4", " ", 
             SubsuperscriptBox[
              OverscriptBox[
               StyleBox["\[Eta]",
                FontWeight->Bold,
                FontColor->RGBColor[0.8, 0, 0]], 
               StyleBox["_",
                FontWeight->Bold,
                FontColor->RGBColor[0.8, 0, 0]]], "5", 
              RowBox[{"[", 
               RowBox[{"-", "2"}], "]"}]]}]}], ")"}]}]}], ")"}]}], 
      SuperscriptBox["u", "5"]]}], "]"}]}]}]], "Output",
 CellChangeTimes->{{3.5559432278751183`*^9, 3.5559432749296503`*^9}, 
   3.5559433828433037`*^9, {3.555943417010789*^9, 3.555943437109277*^9}, {
   3.5559434702423353`*^9, 3.555943537464334*^9}, {3.555943574803227*^9, 
   3.5559436002441063`*^9}, 3.555943646884388*^9, 3.5603369478556356`*^9}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[{
 "Contribution from ",
 Cell[BoxData[
  FormBox[
   RowBox[{
    RowBox[{"Log", "[", 
     RowBox[{
      FractionBox["1", "\[Rho]"], "/", 
      FractionBox["1", 
       SubscriptBox["\[Rho]", "asym"]]}], "]"}], "=", "conth\[Rho]"}], 
   TraditionalForm]]]
}], "Subsubsection",
 CellChangeTimes->{{3.552194573693015*^9, 3.552194586631557*^9}, {
  3.552195423782762*^9, 3.552195423851169*^9}, {3.5558723898227663`*^9, 
  3.555872393032803*^9}, {3.555873196517317*^9, 3.555873196727844*^9}}],

Cell["We remind that ", "Text",
 CellChangeTimes->{{3.552194594181669*^9, 3.5521945964423313`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Log", "[", 
   RowBox[{
    FractionBox["1", "\[Rho]"], "/", 
    FractionBox["1", 
     SubscriptBox["\[Rho]", "asym"]]}], "]"}], "=", 
  RowBox[{"-", 
   FractionBox["\[Delta]\[Rho]", "\[Rho]"]}]}]], "Input",
 CellChangeTimes->{{3.555872400095169*^9, 3.5558724267038918`*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"tmp1", "=", 
  RowBox[{
   RowBox[{
    RowBox[{"Series", "[", 
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{"-", "1"}], "/", "\[Rho]"}], ")"}], "/.", "largevolume"}],
          "/.", "subJuk"}], "/.", 
        RowBox[{"u", "\[Rule]", 
         RowBox[{"2", "g", " ", "z"}]}]}], "/.", 
       RowBox[{"leadweak", "[", "4", "]"}]}], ",", 
      RowBox[{"{", 
       RowBox[{"g", ",", "0", ",", "4"}], "}"}]}], "]"}], "//", "Simplify"}], 
   "//", "Normal"}]}]], "Input",
 CellChangeTimes->{{3.5558724117023087`*^9, 3.555872463926442*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"-", 
   FractionBox["1", 
    RowBox[{"2", " ", "g", " ", 
     SqrtBox[
      RowBox[{"1", "-", 
       SuperscriptBox["z", "2"]}]]}]]}], "-", 
  FractionBox[
   RowBox[{"3", " ", "g"}], 
   RowBox[{"2", " ", 
    SqrtBox[
     RowBox[{"1", "-", 
      SuperscriptBox["z", "2"]}]]}]], "+", 
  FractionBox[
   RowBox[{"6", " ", 
    SuperscriptBox["g", "3"]}], 
   SqrtBox[
    RowBox[{"1", "-", 
     SuperscriptBox["z", "2"]}]]]}]], "Output",
 CellChangeTimes->{
  3.555872415987401*^9, {3.555872452556671*^9, 3.5558724643872223`*^9}, 
   3.56033683512888*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"tmp2", "=", 
  RowBox[{
   RowBox[{
    RowBox[{
     SuperscriptBox["g", "9"], 
     RowBox[{"(", 
      RowBox[{
       SubscriptBox["\[Delta]\[Rho]", "lead"], "+", 
       RowBox[{
        SuperscriptBox["g", "2"], 
        SubscriptBox["\[Delta]\[Rho]", "sublead"]}], "+", 
       RowBox[{
        SuperscriptBox["g", "4"], 
        SubscriptBox["\[Delta]\[Rho]", "sublead2"]}]}], ")"}]}], "/.", 
    "sub\[Rho]Ansatz"}], "/.", 
   RowBox[{"(", 
    RowBox[{"Rule", "@@@", 
     RowBox[{"Cases", "[", 
      RowBox[{
       RowBox[{"solut\[Rho]s", "/.", 
        RowBox[{"Rule", "\[Rule]", "List"}]}], ",", 
       RowBox[{"List", "[", 
        RowBox[{"a_", ",", "0"}], "]"}]}], "]"}]}], ")"}]}]}]], "Input",
 CellChangeTimes->{{3.5558725197330837`*^9, 3.555872556548987*^9}, {
  3.5558726634967213`*^9, 3.5558726647033777`*^9}, {3.555872704013234*^9, 
  3.555872705004931*^9}}],

Cell[BoxData[
 RowBox[{
  SuperscriptBox["g", "9"], " ", 
  RowBox[{"(", 
   RowBox[{
    RowBox[{
     SqrtBox[
      RowBox[{"1", "-", 
       SuperscriptBox["z", "2"]}]], " ", 
     RowBox[{
      SubscriptBox["\[Beta]", "lead"], "[", "0", "]"}]}], "+", 
    RowBox[{
     SuperscriptBox["g", "2"], " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{
        SqrtBox[
         RowBox[{"1", "-", 
          SuperscriptBox["z", "2"]}]], " ", 
        RowBox[{
         SubscriptBox["\[Beta]", "sublead"], "[", "0", "]"}]}], "+", 
       RowBox[{
        SuperscriptBox["z", "2"], " ", 
        SqrtBox[
         RowBox[{"1", "-", 
          SuperscriptBox["z", "2"]}]], " ", 
        RowBox[{
         SubscriptBox["\[Beta]", "sublead"], "[", "1", "]"}]}]}], ")"}]}], 
    "+", 
    RowBox[{
     SuperscriptBox["g", "4"], " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{
        SqrtBox[
         RowBox[{"1", "-", 
          SuperscriptBox["z", "2"]}]], " ", 
        RowBox[{
         SubscriptBox["\[Beta]", "sublead2"], "[", "0", "]"}]}], "+", 
       RowBox[{
        SuperscriptBox["z", "2"], " ", 
        SqrtBox[
         RowBox[{"1", "-", 
          SuperscriptBox["z", "2"]}]], " ", 
        RowBox[{
         SubscriptBox["\[Beta]", "sublead2"], "[", "1", "]"}]}], "+", 
       RowBox[{
        SuperscriptBox["z", "4"], " ", 
        SqrtBox[
         RowBox[{"1", "-", 
          SuperscriptBox["z", "2"]}]], " ", 
        RowBox[{
         SubscriptBox["\[Beta]", "sublead2"], "[", "2", "]"}]}]}], ")"}]}]}], 
   ")"}]}]], "Output",
 CellChangeTimes->{3.5558725573989573`*^9, 3.5558726658679647`*^9, 
  3.555872708268715*^9, 3.560336836343897*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"conth\[Rho]", "=", 
  RowBox[{"Collect", "[", 
   RowBox[{
    RowBox[{"Series", "[", 
     RowBox[{
      RowBox[{"kern", " ", "tmp1", " ", "tmp2"}], ",", 
      RowBox[{"{", 
       RowBox[{"g", ",", "0", ",", "14"}], "}"}]}], "]"}], ",", "g", ",", 
    RowBox[{
     RowBox[{"Integrate", "[", 
      RowBox[{
       FractionBox["#", 
        RowBox[{"\[Pi]", 
         SqrtBox[
          RowBox[{"1", "-", 
           SuperscriptBox["z", "2"]}]]}]], ",", 
       RowBox[{"{", 
        RowBox[{"z", ",", 
         RowBox[{"-", "1"}], ",", "1"}], "}"}]}], "]"}], "&"}]}], 
   "]"}]}]], "Input",
 CellChangeTimes->{{3.555872699046433*^9, 3.555872736723382*^9}, {
  3.555872823031831*^9, 3.555872828593458*^9}, {3.5558731521186523`*^9, 
  3.555873155338894*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   FractionBox["3", "4"], " ", "\[ImaginaryI]", " ", 
   SqrtBox["3"], " ", 
   SuperscriptBox["g", "12"], " ", 
   RowBox[{
    SubscriptBox["\[Beta]", "sublead"], "[", "1", "]"}]}], "-", 
  RowBox[{
   FractionBox["3", "4"], " ", "\[ImaginaryI]", " ", 
   SqrtBox["3"], " ", 
   SuperscriptBox["g", "14"], " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"3", " ", 
      RowBox[{
       SubscriptBox["\[Beta]", "sublead"], "[", "1", "]"}]}], "-", 
     RowBox[{
      SubscriptBox["\[Beta]", "sublead2"], "[", "1", "]"}], "-", 
     RowBox[{
      SubscriptBox["\[Beta]", "sublead2"], "[", "2", "]"}]}], 
    ")"}]}]}]], "Output",
 CellChangeTimes->{{3.55587271843585*^9, 3.555872738891471*^9}, 
   3.555872834324819*^9, {3.555872982734473*^9, 3.555873000822957*^9}, {
   3.555873143445497*^9, 3.5558731579135*^9}, 3.560336862610138*^9}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[{
 "Contribution from ",
 Cell[BoxData[
  FormBox[
   RowBox[{
    RowBox[{"Log", "[", 
     FractionBox[
      RowBox[{"1", "-", 
       RowBox[{
        SubscriptBox["Y", 
         RowBox[{"1", ",", "1"}]], 
        SubscriptBox["Y", 
         RowBox[{"2", ",", "2"}]]}]}], 
      SubscriptBox[
       RowBox[{"(", 
        RowBox[{"1", "-", 
         RowBox[{
          SubscriptBox["Y", 
           RowBox[{"1", ",", "1"}]], 
          SubscriptBox["Y", 
           RowBox[{"2", ",", "2"}]]}]}], ")"}], "asym"]], "]"}], "==", 
    "conthY11Y22"}], TraditionalForm]]]
}], "Subsubsection",
 CellChangeTimes->{{3.552194573693015*^9, 3.552194586631557*^9}, {
  3.552195423782762*^9, 3.552195451528096*^9}, {3.555874053686809*^9, 
  3.555874057466106*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Log", "[", 
   FractionBox[
    RowBox[{"1", "-", 
     RowBox[{
      SubscriptBox["Y", 
       RowBox[{"1", ",", "1"}]], 
      SubscriptBox["Y", 
       RowBox[{"2", ",", "2"}]]}]}], 
    SubscriptBox[
     RowBox[{"(", 
      RowBox[{"1", "-", 
       RowBox[{
        SubscriptBox["Y", 
         RowBox[{"1", ",", "1"}]], 
        SubscriptBox["Y", 
         RowBox[{"2", ",", "2"}]]}]}], ")"}], "asym"]], "]"}], "\[Equal]", 
  RowBox[{"Log", "[", 
   FractionBox[
    RowBox[{"1", "-", 
     RowBox[{"Y11Y22", 
      RowBox[{"(", 
       RowBox[{"1", "+", "o"}], ")"}]}]}], 
    RowBox[{"1", "-", "Y11Y22"}]], "]"}], "\[Equal]", 
  RowBox[{"o", 
   FractionBox[
    RowBox[{" ", "Y11Y22"}], 
    RowBox[{
     RowBox[{"-", "1"}], "+", "Y11Y22"}]]}], "==", 
  RowBox[{
   FractionBox[
    RowBox[{" ", "Y11Y22"}], 
    RowBox[{
     RowBox[{"-", "1"}], "+", "Y11Y22"}]], 
   RowBox[{"Log", "[", 
    FractionBox[
     RowBox[{
      SubscriptBox["Y", 
       RowBox[{"1", ",", "1"}]], 
      SubscriptBox["Y", 
       RowBox[{"2", ",", "2"}]]}], 
     SubscriptBox[
      RowBox[{"(", 
       RowBox[{
        SubscriptBox["Y", 
         RowBox[{"1", ",", "1"}]], 
        SubscriptBox["Y", 
         RowBox[{"2", ",", "2"}]]}], ")"}], "asym"]], "]"}]}], "\[Equal]", 
  "\[IndentingNewLine]", 
  RowBox[{
   FractionBox[
    RowBox[{" ", "Y11Y22"}], 
    RowBox[{
     RowBox[{"-", "1"}], "+", "Y11Y22"}]], 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"-", "4"}], "\[ImaginaryI]", " ", "g", 
     SqrtBox[
      RowBox[{"1", "-", 
       SuperscriptBox["z", "2"]}]], 
     RowBox[{"\[DoubleStruckCapitalC]", "[", 
      RowBox[{
       FractionBox["1", 
        RowBox[{
         RowBox[{"4", 
          SuperscriptBox["g", "2"], 
          SuperscriptBox["z", "2"]}], "-", 
         SuperscriptBox["u", "2"]}]], 
       FractionBox["H", 
        SqrtBox[
         RowBox[{"1", "-", 
          FractionBox[
           RowBox[{"4", 
            SuperscriptBox["g", "2"]}], 
           SuperscriptBox["u", "2"]]}]]]}], "]"}]}], ")"}]}]}]], "Input",
 CellChangeTimes->{{3.552195453278018*^9, 3.552195497757874*^9}, {
  3.555873272457108*^9, 3.555873298282538*^9}, {3.555873412927331*^9, 
  3.555873441120566*^9}}],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"Series", "[", 
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{
          FractionBox[
           RowBox[{" ", "Y11Y22"}], 
           RowBox[{
            RowBox[{"-", "1"}], "+", "Y11Y22"}]], "/.", "largevolume"}], "/.",
          "subFunsBethe"}], "/.", "subJuk"}], "/.", 
       RowBox[{"leadweak", "[", "4", "]"}]}], "/.", 
      RowBox[{"u", "\[Rule]", 
       RowBox[{"2", "g", " ", "z"}]}]}], ",", 
     RowBox[{"{", 
      RowBox[{"g", ",", "0", ",", "3"}], "}"}]}], "]"}], "//", "Simplify"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"tmp1", "=", 
  RowBox[{
   RowBox[{"%", "//", "FullSimplify"}], "//", "Normal"}]}]}], "Input",
 CellChangeTimes->{{3.5521955031953583`*^9, 3.5521955123162107`*^9}, {
  3.552195599887342*^9, 3.552195650005445*^9}, {3.5558734853231087`*^9, 
  3.555873486278224*^9}, {3.555873579143408*^9, 3.555873592358659*^9}, {
  3.555873859352264*^9, 3.5558738612814083`*^9}}],

Cell[BoxData[
 RowBox[{
  FractionBox["1", "2"], "+", 
  FractionBox["1", 
   RowBox[{"12", " ", "g", " ", 
    SqrtBox[
     RowBox[{"1", "-", 
      SuperscriptBox["z", "2"]}]]}]], "+", 
  FractionBox[
   RowBox[{"g", " ", 
    RowBox[{"(", 
     RowBox[{"4", "-", 
      RowBox[{"3", " ", 
       SuperscriptBox["z", "2"]}]}], ")"}]}], 
   RowBox[{"3", " ", 
    SqrtBox[
     RowBox[{"1", "-", 
      SuperscriptBox["z", "2"]}]]}]], "+", 
  FractionBox[
   RowBox[{
    SuperscriptBox["g", "3"], " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"-", "7"}], "+", 
      RowBox[{"6", " ", 
       SuperscriptBox["z", "2"]}]}], ")"}]}], 
   SqrtBox[
    RowBox[{"1", "-", 
     SuperscriptBox["z", "2"]}]]]}]], "Output",
 CellChangeTimes->{{3.5521955054096622`*^9, 3.552195513179824*^9}, {
   3.552195597572797*^9, 3.552195652164297*^9}, 3.5558735079787188`*^9, {
   3.55587358349611*^9, 3.555873596019369*^9}, 3.555873881120298*^9, 
   3.560336891400983*^9}]
}, Open  ]],

Cell[TextData[{
 Cell[BoxData[
  FormBox[
   FractionBox["1", "2"], TraditionalForm]]],
 " piece will be treated separately, because it explicitly cancels out by the \
corresponding term in \[ScriptCapitalF]."
}], "Text",
 CellChangeTimes->{{3.5559233266615353`*^9, 3.555923334084256*^9}, {
  3.555927935628765*^9, 3.555927959659596*^9}}],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"Series", "[", 
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{
          RowBox[{
           FractionBox[
            RowBox[{" ", "Y11Y22"}], 
            RowBox[{
             RowBox[{"-", "1"}], "+", "Y11Y22"}]], "-", 
           FractionBox["1", "2"]}], "/.", "largevolume"}], "/.", 
         "subFunsBethe"}], "/.", "subJuk"}], "/.", 
       RowBox[{"leadweak", "[", "4", "]"}]}], "/.", 
      RowBox[{"u", "\[Rule]", 
       RowBox[{"2", "g", " ", "z"}]}]}], ",", 
     RowBox[{"{", 
      RowBox[{"g", ",", "0", ",", "3"}], "}"}]}], "]"}], "//", "Simplify"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"tmp1", "=", 
  RowBox[{
   RowBox[{"%", "//", "FullSimplify"}], "//", "Normal"}]}]}], "Input",
 CellChangeTimes->{{3.555927916844989*^9, 3.555927918331521*^9}}],

Cell[BoxData[
 RowBox[{
  FractionBox["1", 
   RowBox[{"12", " ", "g", " ", 
    SqrtBox[
     RowBox[{"1", "-", 
      SuperscriptBox["z", "2"]}]]}]], "+", 
  FractionBox[
   RowBox[{"g", " ", 
    RowBox[{"(", 
     RowBox[{"4", "-", 
      RowBox[{"3", " ", 
       SuperscriptBox["z", "2"]}]}], ")"}]}], 
   RowBox[{"3", " ", 
    SqrtBox[
     RowBox[{"1", "-", 
      SuperscriptBox["z", "2"]}]]}]], "+", 
  FractionBox[
   RowBox[{
    SuperscriptBox["g", "3"], " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"-", "7"}], "+", 
      RowBox[{"6", " ", 
       SuperscriptBox["z", "2"]}]}], ")"}]}], 
   SqrtBox[
    RowBox[{"1", "-", 
     SuperscriptBox["z", "2"]}]]]}]], "Output",
 CellChangeTimes->{3.5559279222601748`*^9, 3.560336895060581*^9}]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"tmp2", "=", 
   RowBox[{
    RowBox[{"-", "4"}], "\[ImaginaryI]", " ", "g", 
    SqrtBox[
     RowBox[{"1", "-", 
      SuperscriptBox["z", "2"]}]], 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"Collect", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"(", 
          RowBox[{"Series", "[", 
           RowBox[{
            RowBox[{
             FractionBox["z", 
              RowBox[{
               RowBox[{"4", 
                SuperscriptBox["g", "2"], 
                SuperscriptBox["z", "2"]}], "-", 
               SuperscriptBox["u", "2"]}]], 
             FractionBox[
              RowBox[{
               SuperscriptBox["g", "8"], 
               RowBox[{"(", 
                RowBox[{
                 SubscriptBox["H", "lead"], "+", 
                 RowBox[{
                  SuperscriptBox["g", "2"], 
                  SubscriptBox["H", "sublead"]}], "+", 
                 RowBox[{
                  SuperscriptBox["g", "4"], 
                  SubscriptBox["H", "sublead2"]}]}], ")"}]}], 
              SqrtBox[
               RowBox[{"1", "-", 
                FractionBox[
                 RowBox[{"4", 
                  SuperscriptBox["g", "2"]}], 
                 SuperscriptBox["u", "2"]]}]]]}], ",", 
            RowBox[{"{", 
             RowBox[{"g", ",", "0", ",", "12"}], "}"}]}], "]"}], ")"}], "//", 
         "Normal"}], ",", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{
           SuperscriptBox["z", "_."], 
           SuperscriptBox["g", "_."]}], ",", "z", ",", "g"}], "}"}]}], "]"}], 
      "/.", 
      RowBox[{
       RowBox[{
        SuperscriptBox["z", "a_."], 
        SuperscriptBox["g", "b_."], "r_"}], "\[RuleDelayed]", 
       RowBox[{
        SuperscriptBox["z", 
         RowBox[{"a", "-", "1"}]], 
        SuperscriptBox["g", "b"], " ", 
        RowBox[{"\[DoubleStruckCapitalC]", "[", "r", "]"}]}]}]}], ")"}]}]}], 
  ";"}]], "Input",
 CellChangeTimes->{{3.555873597797863*^9, 3.5558738223643293`*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"conthY11Y22", "=", 
  RowBox[{"Collect", "[", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"Series", "[", 
       RowBox[{
        RowBox[{"kern", " ", "tmp1", " ", "tmp2"}], ",", 
        RowBox[{"{", 
         RowBox[{"g", ",", "0", ",", "14"}], "}"}]}], "]"}], "//", 
      "Simplify"}], "//", "Normal"}], ",", "g", ",", 
    RowBox[{
     RowBox[{"Integrate", "[", 
      RowBox[{
       FractionBox["#", 
        RowBox[{"\[Pi]", 
         SqrtBox[
          RowBox[{"1", "-", 
           SuperscriptBox["z", "2"]}]]}]], ",", 
       RowBox[{"{", 
        RowBox[{"z", ",", 
         RowBox[{"-", "1"}], ",", "1"}], "}"}]}], "]"}], "&"}]}], 
   "]"}]}]], "Input",
 CellChangeTimes->{{3.555873971318058*^9, 3.555873985827696*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"-", 
    FractionBox["1", "2"]}], " ", 
   SqrtBox["3"], " ", 
   SuperscriptBox["g", "12"], " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"\[DoubleStruckCapitalC]", "[", 
      RowBox[{"-", 
       FractionBox[
        RowBox[{"4", " ", 
         SubscriptBox[
          StyleBox["H",
           FontColor->RGBColor[0.54, 0.35, 0.15]], "lead"]}], 
        SuperscriptBox["u", "4"]]}], "]"}], "-", 
     RowBox[{"12", " ", 
      RowBox[{"\[DoubleStruckCapitalC]", "[", 
       RowBox[{"-", 
        FractionBox[
         SubscriptBox[
          StyleBox["H",
           FontColor->RGBColor[0.54, 0.35, 0.15]], "lead"], 
         SuperscriptBox["u", "2"]]}], "]"}]}]}], ")"}]}], "-", 
  RowBox[{
   FractionBox["1", "2"], " ", 
   SqrtBox["3"], " ", 
   SuperscriptBox["g", "14"], " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"\[DoubleStruckCapitalC]", "[", 
      RowBox[{"-", 
       FractionBox[
        RowBox[{"16", " ", 
         SubscriptBox[
          StyleBox["H",
           FontColor->RGBColor[0.54, 0.35, 0.15]], "lead"]}], 
        SuperscriptBox["u", "6"]]}], "]"}], "-", 
     RowBox[{"2", " ", 
      RowBox[{"\[DoubleStruckCapitalC]", "[", 
       RowBox[{"-", 
        FractionBox[
         RowBox[{"4", " ", 
          SubscriptBox[
           StyleBox["H",
            FontColor->RGBColor[0.54, 0.35, 0.15]], "lead"]}], 
         SuperscriptBox["u", "4"]]}], "]"}]}], "+", 
     RowBox[{"144", " ", 
      RowBox[{"\[DoubleStruckCapitalC]", "[", 
       RowBox[{"-", 
        FractionBox[
         SubscriptBox[
          StyleBox["H",
           FontColor->RGBColor[0.54, 0.35, 0.15]], "lead"], 
         SuperscriptBox["u", "2"]]}], "]"}]}], "+", 
     RowBox[{"\[DoubleStruckCapitalC]", "[", 
      RowBox[{"-", 
       FractionBox[
        RowBox[{"4", " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"2", " ", 
            SubscriptBox[
             StyleBox["H",
              FontColor->RGBColor[0.54, 0.35, 0.15]], "lead"]}], "+", 
           RowBox[{
            SuperscriptBox["u", "2"], " ", 
            SubscriptBox[
             StyleBox["H",
              FontColor->RGBColor[0.54, 0.35, 0.15]], "sublead"]}]}], ")"}]}], 
        SuperscriptBox["u", "6"]]}], "]"}], "-", 
     RowBox[{"12", " ", 
      RowBox[{"\[DoubleStruckCapitalC]", "[", 
       RowBox[{"-", 
        FractionBox[
         RowBox[{
          RowBox[{"2", " ", 
           SubscriptBox[
            StyleBox["H",
             FontColor->RGBColor[0.54, 0.35, 0.15]], "lead"]}], "+", 
          RowBox[{
           SuperscriptBox["u", "2"], " ", 
           SubscriptBox[
            StyleBox["H",
             FontColor->RGBColor[0.54, 0.35, 0.15]], "sublead"]}]}], 
         SuperscriptBox["u", "4"]]}], "]"}]}]}], ")"}]}]}]], "Output",
 CellChangeTimes->{{3.555873833158194*^9, 3.555873846739962*^9}, 
   3.555873913552908*^9, 3.555873990761409*^9, 3.555927929729237*^9, 
   3.555928382002399*^9, 3.560336898103199*^9}]
}, Open  ]]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[Cell[BoxData[
 RowBox[{
  RowBox[{"Log", "[", 
   RowBox[{
    FractionBox[
     RowBox[{
      SuperscriptBox[
       OverscriptBox[
        StyleBox["\[ScriptCapitalT]",
         FontColor->RGBColor[1, 0, 0]], 
        StyleBox["^",
         FontColor->RGBColor[1, 0, 0]]], 
       RowBox[{"[", 
        RowBox[{"-", "2"}], "]"}]], " "}], 
     SuperscriptBox[
      OverscriptBox[
       StyleBox["\[ScriptCapitalT]",
        FontColor->RGBColor[1, 0, 0]], 
       StyleBox["^",
        FontColor->RGBColor[1, 0, 0]]], 
      RowBox[{"[", 
       RowBox[{"+", "2"}], "]"}]]], "/", 
    SubscriptBox[
     RowBox[{"(", 
      FractionBox[
       RowBox[{
        SuperscriptBox[
         OverscriptBox[
          StyleBox["\[ScriptCapitalT]",
           FontColor->RGBColor[1, 0, 0]], 
          StyleBox["^",
           FontColor->RGBColor[1, 0, 0]]], 
         RowBox[{"[", 
          RowBox[{"-", "2"}], "]"}]], " "}], 
       SuperscriptBox[
        OverscriptBox[
         StyleBox["\[ScriptCapitalT]",
          FontColor->RGBColor[1, 0, 0]], 
         StyleBox["^",
          FontColor->RGBColor[1, 0, 0]]], 
        RowBox[{"[", 
         RowBox[{"+", "2"}], "]"}]]], ")"}], "asym"]}], "]"}], "==", 
  "contTh2"}]],
 CellChangeTimes->{{3.552205181043242*^9, 3.552205217682931*^9}, {
  3.5522052656677628`*^9, 3.5522053298096657`*^9}}]], "Subsection",
 CellChangeTimes->{{3.552205375767812*^9, 3.55220538309063*^9}, {
  3.552205844110306*^9, 3.5522058489016933`*^9}, {3.5537721902462673`*^9, 
  3.5537721973412437`*^9}, {3.5559587001737413`*^9, 3.555958700173893*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Log", "[", 
   RowBox[{
    FractionBox[
     RowBox[{
      SuperscriptBox[
       OverscriptBox[
        StyleBox["\[ScriptCapitalT]",
         FontColor->RGBColor[1, 0, 0]], 
        StyleBox["^",
         FontColor->RGBColor[1, 0, 0]]], 
       RowBox[{"[", 
        RowBox[{"-", "2"}], "]"}]], " "}], 
     SuperscriptBox[
      OverscriptBox[
       StyleBox["\[ScriptCapitalT]",
        FontColor->RGBColor[1, 0, 0]], 
       StyleBox["^",
        FontColor->RGBColor[1, 0, 0]]], 
      RowBox[{"[", 
       RowBox[{"+", "2"}], "]"}]]], "/", 
    SubscriptBox[
     RowBox[{"(", 
      FractionBox[
       RowBox[{
        SuperscriptBox[
         OverscriptBox[
          StyleBox["\[ScriptCapitalT]",
           FontColor->RGBColor[1, 0, 0]], 
          StyleBox["^",
           FontColor->RGBColor[1, 0, 0]]], 
         RowBox[{"[", 
          RowBox[{"-", "2"}], "]"}]], " "}], 
       SuperscriptBox[
        OverscriptBox[
         StyleBox["\[ScriptCapitalT]",
          FontColor->RGBColor[1, 0, 0]], 
         StyleBox["^",
          FontColor->RGBColor[1, 0, 0]]], 
        RowBox[{"[", 
         RowBox[{"+", "2"}], "]"}]]], ")"}], "asym"]}], "]"}], "\[Equal]", 
  RowBox[{"(", 
   RowBox[{
    FractionBox[
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        SuperscriptBox["\[ScriptCapitalC]", 
         RowBox[{"[", 
          RowBox[{"-", "1"}], "]"}]], "-", 
        SuperscriptBox["\[ScriptCapitalC]", 
         RowBox[{"[", 
          RowBox[{"-", "3"}], "]"}]]}], ")"}], 
      OverscriptBox["*", "^"], "\[Delta]\[Rho]"}], 
     SuperscriptBox[
      OverscriptBox[
       StyleBox["\[ScriptCapitalT]",
        FontColor->RGBColor[1, 0, 0]], 
       StyleBox["^",
        FontColor->RGBColor[1, 0, 0]]], 
      RowBox[{"[", 
       RowBox[{"-", "2"}], "]"}]]], "-", 
    RowBox[{"c", ".", "c"}]}], ")"}]}]], "Input",
 CellChangeTimes->{{3.553772235521481*^9, 3.553772279957571*^9}, {
  3.555957725230073*^9, 3.5559577256586657`*^9}, {3.5559577563570547`*^9, 
  3.555957797509214*^9}, {3.555957912392963*^9, 3.555957913472788*^9}, {
  3.5559586931980667`*^9, 3.555958697622611*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"tmp1", "=", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"Series", "[", 
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{
          RowBox[{
           FractionBox["1", 
            SuperscriptBox[
             OverscriptBox[
              StyleBox["\[ScriptCapitalT]",
               FontColor->RGBColor[1, 0, 0]], 
              StyleBox["^",
               FontColor->RGBColor[1, 0, 0]]], 
             RowBox[{"[", 
              RowBox[{"-", "2"}], "]"}]]], "/.", "largevolume"}], "/.", 
          "subJuk"}], "/.", 
         RowBox[{"u", "\[Rule]", 
          SubscriptBox["v", "0"]}]}], "/.", 
        RowBox[{"leadweak", "[", "4", "]"}]}], ",", 
       RowBox[{"{", 
        RowBox[{"g", ",", "0", ",", "8"}], "}"}]}], "]"}], "//.", 
     "densqrt3"}], "//", "Simplify"}], "//", "Normal"}]}]], "Input",
 CellChangeTimes->{{3.555957822087865*^9, 3.555957895373212*^9}, {
   3.555957927415238*^9, 3.555957927886791*^9}, 3.555958543210257*^9, {
   3.555958590422051*^9, 3.555958591490354*^9}}],

Cell[BoxData[
 RowBox[{"1", "+", 
  RowBox[{
   FractionBox["3", "7"], " ", 
   RowBox[{"(", 
    RowBox[{"2", "-", 
     RowBox[{"\[ImaginaryI]", " ", 
      SqrtBox["3"]}]}], ")"}], " ", 
   SuperscriptBox["g", "2"]}], "+", 
  RowBox[{
   FractionBox["6", "343"], " ", "\[ImaginaryI]", " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"445", " ", "\[ImaginaryI]"}], "+", 
     RowBox[{"114", " ", 
      SqrtBox["3"]}]}], ")"}], " ", 
   SuperscriptBox["g", "4"]}], "+", 
  FractionBox[
   RowBox[{"3", " ", 
    RowBox[{"(", 
     RowBox[{"381431", "-", 
      RowBox[{"60183", " ", "\[ImaginaryI]", " ", 
       SqrtBox["3"]}]}], ")"}], " ", 
    SuperscriptBox["g", "6"]}], "16807"], "-", 
  FractionBox[
   RowBox[{"3", " ", "\[ImaginaryI]", " ", 
    SuperscriptBox["g", "8"], " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       RowBox[{"-", "170315624"}], " ", "\[ImaginaryI]"}], "-", 
      RowBox[{"19976969", " ", 
       SqrtBox["3"]}], "+", 
      RowBox[{"403368", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          RowBox[{"-", "23"}], " ", "\[ImaginaryI]"}], "+", 
         RowBox[{"6", " ", 
          SqrtBox["3"]}]}], ")"}], " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "3"]}]}], ")"}]}], "823543"]}]], "Output",\

 CellChangeTimes->{{3.555957831501809*^9, 3.555957851955184*^9}, {
   3.5559578894735403`*^9, 3.555957928320983*^9}, {3.55595853657743*^9, 
   3.5559585438380413`*^9}, 3.555958591720715*^9, 3.5603369583854933`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"tmp2", "=", 
  RowBox[{"Collect", "[", 
   RowBox[{
    RowBox[{"Collect", "[", 
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{"Series", "[", 
          RowBox[{
           RowBox[{
            RowBox[{
             RowBox[{
              RowBox[{"-", 
               FractionBox[
                RowBox[{"2", "g"}], 
                RowBox[{"2", " ", "\[ImaginaryI]"}]]}], 
              RowBox[{"(", 
               RowBox[{
                FractionBox["1", 
                 RowBox[{"u", "-", 
                  FractionBox["\[ImaginaryI]", "2"], "-", 
                  RowBox[{"2", " ", "g", " ", "z"}]}]], "-", 
                FractionBox["1", 
                 RowBox[{"u", "-", 
                  FractionBox[
                   RowBox[{"3", "\[ImaginaryI]"}], "2"], "-", 
                  RowBox[{"2", " ", "g", " ", "z"}]}]]}], ")"}], 
              SuperscriptBox["g", "9"], 
              RowBox[{"(", 
               RowBox[{
                SubscriptBox["\[Delta]\[Rho]", "lead"], "+", 
                RowBox[{
                 SuperscriptBox["g", "2"], 
                 SubscriptBox["\[Delta]\[Rho]", "sublead"]}], "+", 
                RowBox[{
                 SuperscriptBox["g", "4"], 
                 SubscriptBox["\[Delta]\[Rho]", "sublead2"]}]}], ")"}]}], "/.", 
             RowBox[{"u", "\[Rule]", " ", 
              SubscriptBox["v", "0"]}]}], "/.", 
            RowBox[{"leadweak", "[", "4", "]"}]}], ",", 
           RowBox[{"{", 
            RowBox[{"g", ",", "0", ",", "14"}], "}"}]}], "]"}], "/.", 
         "sub\[Rho]Ansatz"}], "/.", 
        RowBox[{"(", 
         RowBox[{"Rule", "@@@", 
          RowBox[{"Cases", "[", 
           RowBox[{
            RowBox[{"solut\[Rho]s", "/.", 
             RowBox[{"Rule", "\[Rule]", "List"}]}], ",", 
            RowBox[{"List", "[", 
             RowBox[{"a_", ",", "0"}], "]"}]}], "]"}]}], ")"}]}], "//", 
       "Simplify"}], ",", "g", ",", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          RowBox[{"Simplify", "@", 
           RowBox[{"Integrate", "[", 
            RowBox[{
             FractionBox["#", "\[Pi]"], ",", 
             RowBox[{"{", 
              RowBox[{"z", ",", 
               RowBox[{"-", "1"}], ",", "1"}], "}"}]}], "]"}]}], "//.", 
          "densqrt3"}], "//", "Simplify"}], ")"}], "&"}]}], "]"}], ",", 
    RowBox[{"{", 
     RowBox[{"g", ",", 
      RowBox[{
       SubscriptBox["\[Beta]", "_"], "[", "_", "]"}], ",", 
      SqrtBox["3"]}], "}"}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.553772283692554*^9, 3.553772357740438*^9}, {
  3.555957811245809*^9, 3.5559578184685926`*^9}, {3.555957930525948*^9, 
  3.555958046257812*^9}, {3.5559580779333477`*^9, 3.555958199072961*^9}, {
  3.555958414232709*^9, 3.555958518684589*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     RowBox[{"-", 
      FractionBox["3", "7"]}], "+", 
     FractionBox[
      RowBox[{"3", " ", "\[ImaginaryI]", " ", 
       SqrtBox["3"]}], "14"]}], ")"}], " ", 
   SuperscriptBox["g", "10"], " ", 
   RowBox[{
    SubscriptBox["\[Beta]", "lead"], "[", "0", "]"}]}], "+", 
  RowBox[{
   SuperscriptBox["g", "12"], " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        FractionBox["1851", "686"], "-", 
        FractionBox[
         RowBox[{"495", " ", "\[ImaginaryI]", " ", 
          SqrtBox["3"]}], "686"]}], ")"}], " ", 
      RowBox[{
       SubscriptBox["\[Beta]", "lead"], "[", "0", "]"}]}], "+", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", 
         FractionBox["3", "7"]}], "+", 
        FractionBox[
         RowBox[{"3", " ", "\[ImaginaryI]", " ", 
          SqrtBox["3"]}], "14"]}], ")"}], " ", 
      RowBox[{
       SubscriptBox["\[Beta]", "sublead"], "[", "0", "]"}]}], "+", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", 
         FractionBox["3", "28"]}], "+", 
        FractionBox[
         RowBox[{"3", " ", "\[ImaginaryI]", " ", 
          SqrtBox["3"]}], "56"]}], ")"}], " ", 
      RowBox[{
       SubscriptBox["\[Beta]", "sublead"], "[", "1", "]"}]}]}], ")"}]}], "+", 
  
  RowBox[{
   SuperscriptBox["g", "14"], " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", 
         FractionBox["347268", "16807"]}], "+", 
        FractionBox[
         RowBox[{"69012", " ", "\[ImaginaryI]", " ", 
          SqrtBox["3"]}], "16807"]}], ")"}], " ", 
      RowBox[{
       SubscriptBox["\[Beta]", "lead"], "[", "0", "]"}]}], "+", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        FractionBox["1851", "686"], "-", 
        FractionBox[
         RowBox[{"495", " ", "\[ImaginaryI]", " ", 
          SqrtBox["3"]}], "686"]}], ")"}], " ", 
      RowBox[{
       SubscriptBox["\[Beta]", "sublead"], "[", "0", "]"}]}], "+", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        FractionBox["885", "1372"], "-", 
        FractionBox[
         RowBox[{"747", " ", "\[ImaginaryI]", " ", 
          SqrtBox["3"]}], "1372"]}], ")"}], " ", 
      RowBox[{
       SubscriptBox["\[Beta]", "sublead"], "[", "1", "]"}]}], "+", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", 
         FractionBox["3", "7"]}], "+", 
        FractionBox[
         RowBox[{"3", " ", "\[ImaginaryI]", " ", 
          SqrtBox["3"]}], "14"]}], ")"}], " ", 
      RowBox[{
       SubscriptBox["\[Beta]", "sublead2"], "[", "0", "]"}]}], "+", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", 
         FractionBox["3", "28"]}], "+", 
        FractionBox[
         RowBox[{"3", " ", "\[ImaginaryI]", " ", 
          SqrtBox["3"]}], "56"]}], ")"}], " ", 
      RowBox[{
       SubscriptBox["\[Beta]", "sublead2"], "[", "1", "]"}]}], "+", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", 
         FractionBox["3", "56"]}], "+", 
        FractionBox[
         RowBox[{"3", " ", "\[ImaginaryI]", " ", 
          SqrtBox["3"]}], "112"]}], ")"}], " ", 
      RowBox[{
       SubscriptBox["\[Beta]", "sublead2"], "[", "2", "]"}]}]}], 
    ")"}]}]}]], "Output",
 CellChangeTimes->{
  3.5537723587265778`*^9, 3.555958018219059*^9, {3.55595806631386*^9, 
   3.555958081702837*^9}, {3.5559581405944366`*^9, 3.5559581825939283`*^9}, 
   3.555958216632761*^9, 3.555958461757339*^9, {3.5559585046804447`*^9, 
   3.555958525724037*^9}, 3.560336978398279*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"contTh2", "=", 
  RowBox[{"Collect", "[", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"Series", "[", 
       RowBox[{
        RowBox[{
         RowBox[{
          RowBox[{"(", 
           RowBox[{"#", "-", 
            RowBox[{"(", 
             RowBox[{"#", "/.", "mconj"}], ")"}]}], ")"}], "&"}], "[", 
         RowBox[{"tmp1", " ", "tmp2"}], "]"}], ",", 
        RowBox[{"{", 
         RowBox[{"g", ",", "0", ",", "14"}], "}"}]}], "]"}], "//", "Normal"}],
      "//", "Expand"}], ",", 
    RowBox[{"{", 
     RowBox[{"g", ",", 
      RowBox[{
       SubscriptBox["\[Beta]", "_"], "[", "_", "]"}], ",", 
      SqrtBox["3"]}], "}"}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.555958571301457*^9, 3.555958647874802*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   FractionBox["3", "7"], " ", "\[ImaginaryI]", " ", 
   SqrtBox["3"], " ", 
   SuperscriptBox["g", "10"], " ", 
   RowBox[{
    SubscriptBox["\[Beta]", "lead"], "[", "0", "]"}]}], "+", 
  RowBox[{
   SuperscriptBox["g", "12"], " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{
      RowBox[{"-", 
       FractionBox["243", "343"]}], " ", "\[ImaginaryI]", " ", 
      SqrtBox["3"], " ", 
      RowBox[{
       SubscriptBox["\[Beta]", "lead"], "[", "0", "]"}]}], "+", 
     RowBox[{
      FractionBox["3", "7"], " ", "\[ImaginaryI]", " ", 
      SqrtBox["3"], " ", 
      RowBox[{
       SubscriptBox["\[Beta]", "sublead"], "[", "0", "]"}]}], "+", 
     RowBox[{
      FractionBox["3", "28"], " ", "\[ImaginaryI]", " ", 
      SqrtBox["3"], " ", 
      RowBox[{
       SubscriptBox["\[Beta]", "sublead"], "[", "1", "]"}]}]}], ")"}]}], "+", 
  
  RowBox[{
   SuperscriptBox["g", "14"], " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"-", 
      FractionBox[
       RowBox[{"6435", " ", "\[ImaginaryI]", " ", 
        SqrtBox["3"], " ", 
        RowBox[{
         SubscriptBox["\[Beta]", "lead"], "[", "0", "]"}]}], "16807"]}], "-", 
     
     RowBox[{
      FractionBox["243", "343"], " ", "\[ImaginaryI]", " ", 
      SqrtBox["3"], " ", 
      RowBox[{
       SubscriptBox["\[Beta]", "sublead"], "[", "0", "]"}]}], "-", 
     RowBox[{
      FractionBox["621", "686"], " ", "\[ImaginaryI]", " ", 
      SqrtBox["3"], " ", 
      RowBox[{
       SubscriptBox["\[Beta]", "sublead"], "[", "1", "]"}]}], "+", 
     RowBox[{
      FractionBox["3", "7"], " ", "\[ImaginaryI]", " ", 
      SqrtBox["3"], " ", 
      RowBox[{
       SubscriptBox["\[Beta]", "sublead2"], "[", "0", "]"}]}], "+", 
     RowBox[{
      FractionBox["3", "28"], " ", "\[ImaginaryI]", " ", 
      SqrtBox["3"], " ", 
      RowBox[{
       SubscriptBox["\[Beta]", "sublead2"], "[", "1", "]"}]}], "+", 
     RowBox[{
      FractionBox["3", "56"], " ", "\[ImaginaryI]", " ", 
      SqrtBox["3"], " ", 
      RowBox[{
       SubscriptBox["\[Beta]", "sublead2"], "[", "2", "]"}]}]}], 
    ")"}]}]}]], "Output",
 CellChangeTimes->{3.555958649406034*^9, 3.56033697859156*^9}]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[Cell[BoxData[
 RowBox[{
  RowBox[{"Log", "[", 
   RowBox[{
    FractionBox[
     SuperscriptBox[
      RowBox[{"(", 
       SubscriptBox[
        StyleBox["\[GothicCapitalT]",
         FontColor->RGBColor[0.54, 0.35, 0.15]], 
        RowBox[{"2", ",", "1"}]], ")"}], "+"], 
     SuperscriptBox[
      RowBox[{"(", 
       SubscriptBox[
        StyleBox["\[GothicCapitalT]",
         FontColor->RGBColor[0.54, 0.35, 0.15]], 
        RowBox[{"2", ",", "1"}]], ")"}], "-"]], "/", 
    SubscriptBox[
     RowBox[{"(", 
      FractionBox[
       SuperscriptBox[
        RowBox[{"(", 
         SubscriptBox[
          StyleBox["\[GothicCapitalT]",
           FontColor->RGBColor[0.54, 0.35, 0.15]], 
          RowBox[{"2", ",", "1"}]], ")"}], "+"], 
       SuperscriptBox[
        RowBox[{"(", 
         SubscriptBox[
          StyleBox["\[GothicCapitalT]",
           FontColor->RGBColor[0.54, 0.35, 0.15]], 
          RowBox[{"2", ",", "1"}]], ")"}], "-"]], ")"}], "asym"]}], "]"}], 
  "=", 
  RowBox[{"contTu\[Rho]2", "-", "contTuWh", "+", "contTuW2"}]}]],
 CellChangeTimes->{{3.552205181043242*^9, 3.552205217682931*^9}, {
  3.5522052656677628`*^9, 3.5522053298096657`*^9}}]], "Subsection",
 CellChangeTimes->{{3.552205375767812*^9, 3.55220538309063*^9}, {
  3.552205844110306*^9, 3.5522058489016933`*^9}, {3.5522059052663593`*^9, 
  3.552205905266498*^9}, {3.552206287185974*^9, 3.55220628860605*^9}, {
  3.5522193723097267`*^9, 3.552219374913515*^9}, {3.553772570067823*^9, 
  3.553772574118737*^9}, {3.5538298935727654`*^9, 3.553829958269196*^9}, {
  3.5538301754719467`*^9, 3.5538301850217543`*^9}, {3.555961294348217*^9, 
  3.555961294348373*^9}, {3.5559617608051662`*^9, 3.555961765997615*^9}, {
  3.555962334604189*^9, 3.5559623346043377`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Log", "[", 
   RowBox[{
    FractionBox[
     SuperscriptBox[
      RowBox[{"(", 
       SubscriptBox[
        StyleBox["\[GothicCapitalT]",
         FontColor->RGBColor[0.54, 0.35, 0.15]], 
        RowBox[{"2", ",", "1"}]], ")"}], "+"], 
     SuperscriptBox[
      RowBox[{"(", 
       SubscriptBox[
        StyleBox["\[GothicCapitalT]",
         FontColor->RGBColor[0.54, 0.35, 0.15]], 
        RowBox[{"2", ",", "1"}]], ")"}], "-"]], "/", 
    SubscriptBox[
     RowBox[{"(", 
      FractionBox[
       SuperscriptBox[
        RowBox[{"(", 
         SubscriptBox[
          StyleBox["\[GothicCapitalT]",
           FontColor->RGBColor[0.54, 0.35, 0.15]], 
          RowBox[{"2", ",", "1"}]], ")"}], "+"], 
       SuperscriptBox[
        RowBox[{"(", 
         SubscriptBox[
          StyleBox["\[GothicCapitalT]",
           FontColor->RGBColor[0.54, 0.35, 0.15]], 
          RowBox[{"2", ",", "1"}]], ")"}], "-"]], ")"}], "asym"]}], "]"}], "==", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox[
      RowBox[{
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          SuperscriptBox["\[ScriptCapitalC]", 
           RowBox[{"[", 
            RowBox[{"+", "2"}], "]"}]], "-", 
          SuperscriptBox["\[ScriptCapitalC]", 
           RowBox[{"[", 
            RowBox[{"-", "2"}], "]"}]]}], ")"}], 
        OverscriptBox["*", "^"], 
        SubscriptBox["\[Delta]\[Rho]", "2"]}], "-", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          SuperscriptBox["\[ScriptCapitalC]", 
           RowBox[{"[", 
            RowBox[{"+", "2"}], "]"}]], "-", 
          SuperscriptBox["\[ScriptCapitalC]", 
           RowBox[{"[", 
            RowBox[{"-", "2"}], "]"}]]}], ")"}], "*", 
        OverscriptBox["W", "^"]}], "+", 
       SubscriptBox["W", "2"]}], 
      SubscriptBox[
       RowBox[{"(", 
        RowBox[{
         SubsuperscriptBox[
          StyleBox["\[GothicQ]",
           FontColor->RGBColor[0.54, 0.35, 0.15]], "2", 
          RowBox[{"[", "2", "]"}]], "+", 
         SubsuperscriptBox[
          OverscriptBox[
           StyleBox["\[GothicQ]",
            FontColor->RGBColor[0.54, 0.35, 0.15]], 
           StyleBox["_",
            FontColor->RGBColor[0.54, 0.35, 0.15]]], "2", 
          RowBox[{"[", 
           RowBox[{"-", "2"}], "]"}]]}], ")"}], "asym"]], ")"}], "+"], "-", 
   "cc"}]}]], "Input",
 CellChangeTimes->{{3.5522064398846617`*^9, 3.5522064467358313`*^9}, {
  3.553772623304038*^9, 3.553772657698886*^9}, {3.553774456703649*^9, 
  3.553774461436727*^9}, {3.5559587815305*^9, 3.5559587874539623`*^9}, {
  3.555959389479803*^9, 3.555959389751789*^9}}],

Cell["Computing denominator.", "Text",
 CellChangeTimes->{{3.5559594003821707`*^9, 3.555959404533608*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"tmp1", "=", 
  RowBox[{"tmpden", "=", 
   RowBox[{"Collect", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"Series", "[", 
         RowBox[{
          RowBox[{
           RowBox[{
            RowBox[{
             RowBox[{
              RowBox[{
               RowBox[{
                FractionBox["1", 
                 RowBox[{
                  SubsuperscriptBox[
                   StyleBox["\[GothicQ]",
                    FontColor->RGBColor[0.54, 0.35, 0.15]], "2", 
                   RowBox[{"[", "3", "]"}]], "+", 
                  SubsuperscriptBox[
                   OverscriptBox[
                    StyleBox["\[GothicQ]",
                    FontColor->RGBColor[0.54, 0.35, 0.15]], 
                    StyleBox["_",
                    FontColor->RGBColor[0.54, 0.35, 0.15]]], "2", 
                   RowBox[{"[", 
                    RowBox[{"-", "1"}], "]"}]]}]], "/.", 
                RowBox[{"{", 
                 RowBox[{
                  RowBox[{"q$u", "\[Rule]", "q$"}], ",", 
                  RowBox[{"q$ub", "\[Rule]", "q$b"}]}], "}"}]}], "/.", 
               "largevolume"}], "/.", 
              RowBox[{
               RowBox[{"x", "[", "a_", "]"}], "\[RuleDelayed]", 
               RowBox[{"If", "[", 
                RowBox[{
                 RowBox[{"a", ">", "0"}], ",", 
                 RowBox[{"x$h", "[", "a", "]"}], ",", 
                 FractionBox["1", 
                  RowBox[{"x$h", "[", "a", "]"}]]}], "]"}]}]}], "/.", 
             "subJuk"}], "/.", 
            RowBox[{"u", "\[Rule]", 
             SubscriptBox["v", "0"]}]}], "/.", 
           RowBox[{"leadweak", "[", "4", "]"}]}], ",", 
          RowBox[{"{", 
           RowBox[{"g", ",", "0", ",", "8"}], "}"}]}], "]"}], "//", 
        "Simplify"}], ")"}], "//.", "densqrt3"}], ",", 
     RowBox[{"{", 
      RowBox[{"g", ",", 
       SqrtBox["3"]}], "}"}]}], "]"}]}]}]], "Input",
 CellChangeTimes->{{3.5559587428038893`*^9, 3.5559589394420424`*^9}, 
   3.555959218881966*^9, {3.5559596406194773`*^9, 3.555959651218796*^9}, {
   3.55596138138239*^9, 3.5559613828465767`*^9}}],

Cell[BoxData[
 RowBox[{
  FractionBox["3", "4"], "-", 
  FractionBox["\[ImaginaryI]", 
   RowBox[{"4", " ", 
    SqrtBox["3"]}]], "+", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     FractionBox["9", "28"], "-", 
     FractionBox[
      RowBox[{"11", " ", "\[ImaginaryI]"}], 
      RowBox[{"28", " ", 
       SqrtBox["3"]}]]}], ")"}], " ", 
   SuperscriptBox["g", "2"]}], "+", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     RowBox[{"-", 
      FractionBox["1737", "1372"]}], "+", 
     FractionBox[
      RowBox[{"3215", " ", "\[ImaginaryI]"}], 
      RowBox[{"1372", " ", 
       SqrtBox["3"]}]]}], ")"}], " ", 
   SuperscriptBox["g", "4"]}], "+", 
  RowBox[{
   SuperscriptBox["g", "6"], " ", 
   RowBox[{"(", 
    RowBox[{
     FractionBox["537363", "67228"], "+", 
     RowBox[{
      SqrtBox["3"], " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", 
         FractionBox[
          RowBox[{"878173", " ", "\[ImaginaryI]"}], "201684"]}], "-", 
        RowBox[{"4", " ", "\[ImaginaryI]", " ", 
         SubscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "3"]}]}], ")"}]}]}], ")"}]}], "+", 
  RowBox[{
   SuperscriptBox["g", "8"], " ", 
   RowBox[{"(", 
    RowBox[{
     FractionBox["1277356307", "2470629"], "+", 
     RowBox[{
      SqrtBox["3"], " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", 
         FractionBox[
          RowBox[{"833279974", " ", "\[ImaginaryI]"}], "2470629"]}], "-", 
        FractionBox[
         RowBox[{"1098", " ", "\[ImaginaryI]", " ", 
          SubscriptBox[
           StyleBox["\[Zeta]",
            FontWeight->Bold,
            FontColor->GrayLevel[0.4]], "3"]}], "49"]}], ")"}]}], "+", 
     FractionBox[
      RowBox[{"3474", " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "3"]}], "49"]}], ")"}]}]}]], "Output",
 CellChangeTimes->{
  3.5559592806394587`*^9, 3.5559593915679626`*^9, 3.5559606924073677`*^9, {
   3.5559613780244293`*^9, 3.55596138345255*^9}, 3.560337028682087*^9, 
   3.5603372055505037`*^9}]
}, Open  ]],

Cell["Now computing numerator", "Text",
 CellChangeTimes->{{3.5522065399523487`*^9, 3.552206543247525*^9}}],

Cell[CellGroupData[{

Cell[TextData[{
 "Contribution from ",
 Cell[BoxData[
  FormBox[
   SubscriptBox["\[Delta]\[Rho]", "2"], TraditionalForm]]]
}], "Subsubsection",
 CellChangeTimes->{{3.555961322412122*^9, 3.555961333363645*^9}}],

Cell[TextData[{
 "For the contribution from ",
 Cell[BoxData[
  FormBox[
   SubscriptBox["\[Delta]\[Rho]", "2"], TraditionalForm]]],
 ", I have to know ",
 Cell[BoxData[
  RowBox[{"M", "[", 
   SubscriptBox["\[Delta]\[Rho]2", "sublead3"], "]"}]],
  CellChangeTimes->{{3.555959440246872*^9, 3.555959597085898*^9}, {
   3.555959656956286*^9, 3.555959679234445*^9}, {3.5559597284806137`*^9, 
   3.555959762943166*^9}, {3.555959817172202*^9, 3.55595983699745*^9}}],
 ". This is done through the ",
 Cell[BoxData[
  FormBox[
   RowBox[{
    SubscriptBox["T", 
     RowBox[{"1", ",", "1"}]], "=", "0"}], TraditionalForm]]],
 " constraint."
}], "Text",
 CellChangeTimes->{{3.5559598454609003`*^9, 3.555959884194551*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"\[Delta]\[Rho]2sb3", "=", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{"Solve", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"eqnT11ZeroAtBetheroot", "[", 
           RowBox[{"[", "4", "]"}], "]"}], "\[Equal]", "0"}], ",", 
         RowBox[{"M", "[", 
          SubscriptBox["\[Delta]\[Rho]2", "sublead3"], "]"}]}], "]"}], "[", 
       RowBox[{"[", "1", "]"}], "]"}], "[", 
      RowBox[{"[", 
       RowBox[{"1", ",", "2"}], "]"}], "]"}], "/.", "sub\[Rho]Ansatz"}], "/.", 
    RowBox[{"(", 
     RowBox[{"Rule", "@@@", 
      RowBox[{"Cases", "[", 
       RowBox[{
        RowBox[{"solut\[Rho]s", "/.", 
         RowBox[{"Rule", "\[Rule]", "List"}]}], ",", 
        RowBox[{"List", "[", 
         RowBox[{"a_", ",", "0"}], "]"}]}], "]"}]}], ")"}]}]}], 
  ";"}]], "Input",
 CellChangeTimes->{{3.555960101853923*^9, 3.555960127180409*^9}, {
   3.555960171093954*^9, 3.5559601995276327`*^9}, 3.555960250725173*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{"tmpn", "=", 
   RowBox[{
    RowBox[{"Collect", "[", 
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{
          RowBox[{
           RowBox[{"(", 
            RowBox[{
             RowBox[{
              RowBox[{
               RowBox[{"Series", "[", 
                RowBox[{
                 RowBox[{
                  RowBox[{
                   RowBox[{
                    RowBox[{"-", 
                    FractionBox[
                    RowBox[{"2", "w", " ", "g"}], 
                    RowBox[{"2", " ", "\[ImaginaryI]"}]]}], 
                    RowBox[{"(", 
                    RowBox[{
                    FractionBox["1", 
                    RowBox[{"u", "+", 
                    FractionBox[
                    RowBox[{"3", "\[ImaginaryI]"}], "2"], "-", 
                    RowBox[{"2", "g", " ", "w"}]}]], "-", 
                    FractionBox["1", 
                    RowBox[{"u", "-", 
                    FractionBox["\[ImaginaryI]", "2"], "-", 
                    RowBox[{"2", "g", " ", "w"}]}]]}], ")"}], 
                    SuperscriptBox["g", "7"], 
                    RowBox[{"(", 
                    RowBox[{
                    SubscriptBox["\[Delta]\[Rho]2", "lead"], "+", 
                    RowBox[{
                    SuperscriptBox["g", "2"], 
                    SubscriptBox["\[Delta]\[Rho]2", "sublead"]}], "+", 
                    RowBox[{
                    SuperscriptBox["g", "4"], 
                    SubscriptBox["\[Delta]\[Rho]2", "sublead2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["g", "6"], "\[Delta]\[Rho]2sb"}]}], 
                    ")"}]}], "/.", 
                   RowBox[{"u", "\[Rule]", " ", 
                    SubscriptBox["v", "0"]}]}], "/.", 
                  RowBox[{"leadweak", "[", "4", "]"}]}], ",", 
                 RowBox[{"{", 
                  RowBox[{"g", ",", "0", ",", "14"}], "}"}]}], "]"}], "//.", 
               "densqrt3"}], "//", "Normal"}], "//", "Expand"}], ")"}], "/.", 
           
           RowBox[{
            SuperscriptBox["w", 
             RowBox[{"a_", "/;", 
              RowBox[{"EvenQ", "[", "a", "]"}]}]], "\[Rule]", "0"}]}], "/.", 
          RowBox[{
           RowBox[{
            SuperscriptBox["w", "a_."], 
            SubscriptBox["\[Delta]\[Rho]2", "b_"]}], "\[RuleDelayed]", 
           RowBox[{"M", "[", 
            RowBox[{
             SuperscriptBox["w", 
              RowBox[{"a", "-", "1"}]], 
             SubscriptBox["\[Delta]\[Rho]2", "b"]}], "]"}]}]}], "/.", 
         "sub\[Rho]Ansatz"}], "/.", 
        RowBox[{"(", 
         RowBox[{"Rule", "@@@", 
          RowBox[{"Cases", "[", 
           RowBox[{
            RowBox[{"solut\[Rho]s", "/.", 
             RowBox[{"Rule", "\[Rule]", "List"}]}], ",", 
            RowBox[{"List", "[", 
             RowBox[{"a_", ",", "0"}], "]"}]}], "]"}]}], ")"}]}], "//", 
       "Expand"}], ",", 
      RowBox[{"{", 
       RowBox[{"g", ",", 
        RowBox[{
         SubscriptBox["\[Beta]", "_"], "[", "_", "]"}], ",", 
        RowBox[{
         SubscriptBox["\[Alpha]", "_"], "[", "_", "]"}], ",", 
        SqrtBox["3"]}], "}"}], ",", "Simplify"}], "]"}], "/.", 
    RowBox[{
     RowBox[{"w", " ", "\[Delta]\[Rho]2sb"}], "->", "\[Delta]\[Rho]2sb"}]}]}],
   ";"}]], "Input",
 CellChangeTimes->{{3.555959440246872*^9, 3.555959597085898*^9}, {
   3.555959656956286*^9, 3.555959679234445*^9}, {3.5559597284806137`*^9, 
   3.555959762943166*^9}, {3.555959817172202*^9, 3.55595983699745*^9}, 
   3.555960150276371*^9, {3.555960259949939*^9, 3.555960400582122*^9}, {
   3.555960436221867*^9, 3.55596044881701*^9}, {3.555960483882102*^9, 
   3.555960528188892*^9}, 3.555960560102167*^9, {3.555960614052176*^9, 
   3.555960621470096*^9}}],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"Series", "[", 
    RowBox[{
     RowBox[{"tmp1", " ", "tmpn"}], ",", 
     RowBox[{"{", 
      RowBox[{"g", ",", "0", ",", "14"}], "}"}]}], "]"}], "//", "Normal"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"contTu\[Rho]2", "=", 
  RowBox[{"Collect", "[", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"(", 
       RowBox[{"%", "-", 
        RowBox[{"(", 
         RowBox[{"%", "/.", "mconj"}], ")"}]}], ")"}], "/.", 
      RowBox[{"\[Delta]\[Rho]2sb", "->", "\[Delta]\[Rho]2sb3"}]}], "//", 
     "Expand"}], ",", 
    RowBox[{"{", 
     RowBox[{"g", ",", 
      SqrtBox["3"], ",", 
      RowBox[{
       SubscriptBox["\[Beta]", "_"], "[", "_", "]"}], ",", 
      RowBox[{
       SubscriptBox["\[Alpha]", "_"], "[", "_", "]"}]}], "}"}]}], 
   "]"}]}]}], "Input",
 CellChangeTimes->{{3.555960687874434*^9, 3.5559607913417263`*^9}, {
  3.5559610752133904`*^9, 3.555961078124599*^9}, {3.55596125376224*^9, 
  3.555961263643443*^9}, {3.560337186748975*^9, 3.560337190471943*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   SqrtBox["3"], " ", 
   SuperscriptBox["g", "8"], " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{
      RowBox[{"-", 
       FractionBox["1", "2"]}], " ", "\[ImaginaryI]", " ", 
      RowBox[{
       SubscriptBox["\[Alpha]", "lead"], "[", "0", "]"}]}], "-", 
     RowBox[{
      FractionBox["1", "8"], " ", "\[ImaginaryI]", " ", 
      RowBox[{
       SubscriptBox["\[Alpha]", "lead"], "[", "1", "]"}]}]}], ")"}]}], "+", 
  RowBox[{
   SqrtBox["3"], " ", 
   SuperscriptBox["g", "10"], " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{
      FractionBox["17", "14"], " ", "\[ImaginaryI]", " ", 
      RowBox[{
       SubscriptBox["\[Alpha]", "lead"], "[", "0", "]"}]}], "+", 
     RowBox[{
      FractionBox["335", "392"], " ", "\[ImaginaryI]", " ", 
      RowBox[{
       SubscriptBox["\[Alpha]", "lead"], "[", "1", "]"}]}], "-", 
     RowBox[{
      FractionBox["1", "2"], " ", "\[ImaginaryI]", " ", 
      RowBox[{
       SubscriptBox["\[Alpha]", "sublead"], "[", "0", "]"}]}], "-", 
     RowBox[{
      FractionBox["1", "8"], " ", "\[ImaginaryI]", " ", 
      RowBox[{
       SubscriptBox["\[Alpha]", "sublead"], "[", "1", "]"}]}], "-", 
     RowBox[{
      FractionBox["1", "16"], " ", "\[ImaginaryI]", " ", 
      RowBox[{
       SubscriptBox["\[Alpha]", "sublead"], "[", "2", "]"}]}]}], ")"}]}], "+", 
  RowBox[{
   SqrtBox["3"], " ", 
   SuperscriptBox["g", "12"], " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{
      RowBox[{"-", 
       FractionBox["4233", "686"]}], " ", "\[ImaginaryI]", " ", 
      RowBox[{
       SubscriptBox["\[Alpha]", "lead"], "[", "0", "]"}]}], "-", 
     FractionBox[
      RowBox[{"72789", " ", "\[ImaginaryI]", " ", 
       RowBox[{
        SubscriptBox["\[Alpha]", "lead"], "[", "1", "]"}]}], "9604"], "+", 
     RowBox[{
      FractionBox["17", "14"], " ", "\[ImaginaryI]", " ", 
      RowBox[{
       SubscriptBox["\[Alpha]", "sublead"], "[", "0", "]"}]}], "+", 
     RowBox[{
      FractionBox["335", "392"], " ", "\[ImaginaryI]", " ", 
      RowBox[{
       SubscriptBox["\[Alpha]", "sublead"], "[", "1", "]"}]}], "+", 
     RowBox[{
      FractionBox["443", "784"], " ", "\[ImaginaryI]", " ", 
      RowBox[{
       SubscriptBox["\[Alpha]", "sublead"], "[", "2", "]"}]}], "-", 
     RowBox[{
      FractionBox["1", "2"], " ", "\[ImaginaryI]", " ", 
      RowBox[{
       SubscriptBox["\[Alpha]", "sublead2"], "[", "0", "]"}]}], "-", 
     RowBox[{
      FractionBox["1", "8"], " ", "\[ImaginaryI]", " ", 
      RowBox[{
       SubscriptBox["\[Alpha]", "sublead2"], "[", "1", "]"}]}], "-", 
     RowBox[{
      FractionBox["1", "16"], " ", "\[ImaginaryI]", " ", 
      RowBox[{
       SubscriptBox["\[Alpha]", "sublead2"], "[", "2", "]"}]}], "-", 
     RowBox[{
      FractionBox["5", "128"], " ", "\[ImaginaryI]", " ", 
      RowBox[{
       SubscriptBox["\[Alpha]", "sublead2"], "[", "3", "]"}]}]}], ")"}]}], 
  "+", 
  RowBox[{
   SqrtBox["3"], " ", 
   SuperscriptBox["g", "14"], " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{
      RowBox[{"-", 
       FractionBox["1", "3"]}], " ", "\[ImaginaryI]", " ", 
      RowBox[{"\[DoubleStruckCapitalC]", "[", 
       RowBox[{"-", 
        RowBox[{
         FractionBox["1", 
          RowBox[{"2187", " ", 
           SuperscriptBox[
            RowBox[{"(", 
             SuperscriptBox[
              StyleBox["Q0",
               FontColor->RGBColor[{
                  Rational[1, 2], 
                  Rational[1, 2], 0}]], "-"], ")"}], "4"], " ", 
           SuperscriptBox[
            RowBox[{"(", 
             SuperscriptBox[
              StyleBox["Q0",
               FontColor->RGBColor[{
                  Rational[1, 2], 
                  Rational[1, 2], 0}]], "+"], ")"}], "4"]}]], 
         RowBox[{"\[ImaginaryI]", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"9", " ", 
             SuperscriptBox[
              StyleBox["Q0",
               FontColor->RGBColor[{
                  Rational[1, 2], 
                  Rational[1, 2], 0}]], "-"], " ", 
             SuperscriptBox[
              StyleBox["Q0",
               FontColor->RGBColor[{
                  Rational[1, 2], 
                  Rational[1, 2], 0}]], "+"], " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"2", " ", 
                RowBox[{"(", 
                 RowBox[{"5", "-", 
                  RowBox[{"144", " ", 
                   SuperscriptBox["u", "2"]}], "-", 
                  RowBox[{"351", " ", 
                   SuperscriptBox["u", "4"]}], "+", 
                  RowBox[{"1404", " ", 
                   SuperscriptBox["u", "6"]}], "+", 
                  RowBox[{"729", " ", 
                   SuperscriptBox["u", "8"]}]}], ")"}], " ", 
                SubscriptBox[
                 StyleBox["W",
                  FontColor->RGBColor[0.54, 0.35, 0.15]], "sublead"]}], "+", 
               RowBox[{"9", " ", 
                SuperscriptBox[
                 StyleBox["Q0",
                  FontColor->RGBColor[{
                    Rational[1, 2], 
                    Rational[1, 2], 0}]], "-"], " ", 
                SuperscriptBox[
                 StyleBox["Q0",
                  FontColor->RGBColor[{
                    Rational[1, 2], 
                    Rational[1, 2], 0}]], "+"], " ", 
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{"4", " ", 
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", "1"}], "+", 
                    RowBox[{"3", " ", 
                    SuperscriptBox["u", "2"]}], "+", 
                    RowBox[{"27", " ", 
                    SuperscriptBox["u", "4"]}]}], ")"}], " ", 
                   SubscriptBox[
                    StyleBox["W",
                    FontColor->RGBColor[0.54, 0.35, 0.15]], "sublead2"]}], 
                  "+", 
                  RowBox[{
                   RowBox[{"(", 
                    RowBox[{"1", "+", 
                    RowBox[{"6", " ", 
                    SuperscriptBox["u", "2"]}], "+", 
                    RowBox[{"18", " ", 
                    SuperscriptBox["u", "4"]}], "+", 
                    RowBox[{"27", " ", 
                    SuperscriptBox["u", "6"]}]}], ")"}], " ", 
                   SubscriptBox[
                    StyleBox["W",
                    FontColor->RGBColor[0.54, 0.35, 0.15]], "sublead3"]}]}], 
                 ")"}]}]}], ")"}]}], "+", 
            RowBox[{"8", " ", 
             SubscriptBox[
              StyleBox["W",
               FontColor->RGBColor[0.54, 0.35, 0.15]], "lead"], " ", 
             RowBox[{"(", 
              RowBox[{"1", "+", 
               RowBox[{
                SuperscriptBox["u", "2"], " ", 
                RowBox[{"(", 
                 RowBox[{"255", "-", 
                  RowBox[{"9", " ", 
                   SubscriptBox[
                    StyleBox["\[Zeta]",
                    FontWeight->Bold,
                    FontColor->GrayLevel[0.4]], "3"]}]}], ")"}]}], "+", 
               RowBox[{"54", " ", 
                SuperscriptBox["u", "4"], " ", 
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{"-", "16"}], "+", 
                  SubscriptBox[
                   StyleBox["\[Zeta]",
                    FontWeight->Bold,
                    FontColor->GrayLevel[0.4]], "3"]}], ")"}]}], "+", 
               RowBox[{"6561", " ", 
                SuperscriptBox["u", "12"], " ", 
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{"-", "1"}], "+", 
                  SubscriptBox[
                   StyleBox["\[Zeta]",
                    FontWeight->Bold,
                    FontColor->GrayLevel[0.4]], "3"]}], ")"}]}], "-", 
               RowBox[{"3", " ", 
                SubscriptBox[
                 StyleBox["\[Zeta]",
                  FontWeight->Bold,
                  FontColor->GrayLevel[0.4]], "3"]}], "+", 
               RowBox[{"810", " ", 
                SuperscriptBox["u", "8"], " ", 
                RowBox[{"(", 
                 RowBox[{"2", "+", 
                  RowBox[{"3", " ", 
                   SubscriptBox[
                    StyleBox["\[Zeta]",
                    FontWeight->Bold,
                    FontColor->GrayLevel[0.4]], "3"]}]}], ")"}]}], "+", 
               RowBox[{"729", " ", 
                SuperscriptBox["u", "10"], " ", 
                RowBox[{"(", 
                 RowBox[{"3", "+", 
                  RowBox[{"7", " ", 
                   SubscriptBox[
                    StyleBox["\[Zeta]",
                    FontWeight->Bold,
                    FontColor->GrayLevel[0.4]], "3"]}]}], ")"}]}], "+", 
               RowBox[{"27", " ", 
                SuperscriptBox["u", "6"], " ", 
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{"-", "271"}], "+", 
                  RowBox[{"21", " ", 
                   SubscriptBox[
                    StyleBox["\[Zeta]",
                    FontWeight->Bold,
                    FontColor->GrayLevel[0.4]], "3"]}]}], ")"}]}]}], 
              ")"}]}]}], ")"}]}]}]}], "]"}]}], "+", 
     RowBox[{
      FractionBox["5371", "686"], " ", "\[ImaginaryI]", " ", 
      RowBox[{
       SubscriptBox["\[Alpha]", "sublead"], "[", "0", "]"}]}], "-", 
     FractionBox[
      RowBox[{"56741", " ", "\[ImaginaryI]", " ", 
       RowBox[{
        SubscriptBox["\[Alpha]", "sublead"], "[", "1", "]"}]}], "19208"], "-", 
     FractionBox[
      RowBox[{"17147", " ", "\[ImaginaryI]", " ", 
       RowBox[{
        SubscriptBox["\[Alpha]", "sublead"], "[", "2", "]"}]}], "5488"], "-", 
     
     RowBox[{
      FractionBox["11", "14"], " ", "\[ImaginaryI]", " ", 
      RowBox[{
       SubscriptBox["\[Alpha]", "sublead2"], "[", "0", "]"}]}], "+", 
     RowBox[{
      FractionBox["139", "392"], " ", "\[ImaginaryI]", " ", 
      RowBox[{
       SubscriptBox["\[Alpha]", "sublead2"], "[", "1", "]"}]}], "+", 
     RowBox[{
      FractionBox["247", "784"], " ", "\[ImaginaryI]", " ", 
      RowBox[{
       SubscriptBox["\[Alpha]", "sublead2"], "[", "2", "]"}]}], "+", 
     FractionBox[
      RowBox[{"1559", " ", "\[ImaginaryI]", " ", 
       RowBox[{
        SubscriptBox["\[Alpha]", "sublead2"], "[", "3", "]"}]}], "6272"], "+", 
     RowBox[{
      FractionBox["1", "3"], " ", "\[ImaginaryI]", " ", 
      SubscriptBox[
       StyleBox["W",
        FontColor->RGBColor[0.54, 0.35, 0.15]], 
       RowBox[{"1", ",", "v0", ",", "sublead3"}]]}], "+", 
     RowBox[{
      RowBox[{
       SubscriptBox["\[Alpha]", "lead"], "[", "1", "]"}], " ", 
      RowBox[{"(", 
       RowBox[{
        FractionBox[
         RowBox[{"12819977", " ", "\[ImaginaryI]"}], "470596"], "-", 
        RowBox[{"6", " ", "\[ImaginaryI]", " ", 
         SubscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "3"]}]}], ")"}]}], "+", 
     RowBox[{
      RowBox[{
       SubscriptBox["\[Alpha]", "lead"], "[", "0", "]"}], " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", 
         FractionBox[
          RowBox[{"2247821", " ", "\[ImaginaryI]"}], "33614"]}], "-", 
        RowBox[{"24", " ", "\[ImaginaryI]", " ", 
         SubscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "3"]}]}], ")"}]}]}], 
    ")"}]}]}]], "Output",
 CellChangeTimes->{
  3.555960705298842*^9, {3.555960743944848*^9, 3.555960792422225*^9}, 
   3.5559610786992197`*^9, 3.555961266284768*^9, {3.560337126952341*^9, 
   3.560337155414592*^9}, {3.560337187502145*^9, 3.560337217206129*^9}}]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 "Contribution from ",
 Cell[BoxData[
  FormBox[
   SubscriptBox["W", "2"], TraditionalForm]],
  FormatType->"TraditionalForm"]
}], "Subsubsection",
 CellChangeTimes->{
  3.55383020748068*^9, {3.553830700199875*^9, 3.5538307099398203`*^9}, {
   3.553830802049371*^9, 3.553830810573573*^9}, {3.553831134242115*^9, 
   3.553831137355349*^9}, {3.5538313716829157`*^9, 3.553831483505082*^9}, {
   3.555961735751958*^9, 3.555961748254781*^9}}],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"Collect", "[", 
   RowBox[{
    RowBox[{"Series", "[", 
     RowBox[{
      RowBox[{"tmpden", " ", 
       SuperscriptBox["g", "8"], 
       RowBox[{"(", 
        RowBox[{
         SubsuperscriptBox["W", 
          RowBox[{"2", ",", "v0", ",", "lead"}], "+"], "+", 
         RowBox[{
          SuperscriptBox["g", "2"], 
          SubsuperscriptBox["W", 
           RowBox[{"2", ",", "v0", ",", "sublead"}], "+"]}], "+", 
         RowBox[{
          SuperscriptBox["g", "4"], 
          SubsuperscriptBox["W", 
           RowBox[{"2", ",", "v0", ",", "sublead2"}], "+"]}], "+", 
         RowBox[{
          SuperscriptBox["g", "6"], 
          SubsuperscriptBox["W", 
           RowBox[{"2", ",", "v0", ",", "sublead3"}], "+"]}]}], ")"}]}], ",", 
      
      RowBox[{"{", 
       RowBox[{"g", ",", "0", ",", "14"}], "}"}]}], "]"}], ",", 
    RowBox[{"{", 
     RowBox[{"g", ",", 
      SubsuperscriptBox["W", "__", "+"], ",", 
      SqrtBox["3"]}], "}"}]}], "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"contTuW2", "=", 
  RowBox[{"Collect", "[", 
   RowBox[{
    RowBox[{"%", "-", 
     RowBox[{"(", 
      RowBox[{"%", "/.", "mconj"}], ")"}]}], ",", 
    RowBox[{"{", 
     RowBox[{"g", ",", 
      SubsuperscriptBox["W", "__", "+"], ",", 
      SubsuperscriptBox["W", "__", "-"], ",", 
      SqrtBox["3"]}], "}"}]}], "]"}]}]}], "Input",
 CellChangeTimes->{{3.55596139933344*^9, 3.555961552445332*^9}, {
  3.555961591430263*^9, 3.555961628751438*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   SuperscriptBox["g", "8"], " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", 
         FractionBox["3", "4"]}], "-", 
        FractionBox["\[ImaginaryI]", 
         RowBox[{"4", " ", 
          SqrtBox["3"]}]]}], ")"}], " ", 
      SubsuperscriptBox[
       StyleBox["W",
        FontColor->RGBColor[0.54, 0.35, 0.15]], 
       RowBox[{"2", ",", "v0", ",", "lead"}], "-"]}], "+", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        FractionBox["3", "4"], "-", 
        FractionBox["\[ImaginaryI]", 
         RowBox[{"4", " ", 
          SqrtBox["3"]}]]}], ")"}], " ", 
      SubsuperscriptBox[
       StyleBox["W",
        FontColor->RGBColor[0.54, 0.35, 0.15]], 
       RowBox[{"2", ",", "v0", ",", "lead"}], "+"]}]}], ")"}]}], "+", 
  RowBox[{
   SuperscriptBox["g", "10"], " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", 
         FractionBox["9", "28"]}], "-", 
        FractionBox[
         RowBox[{"11", " ", "\[ImaginaryI]"}], 
         RowBox[{"28", " ", 
          SqrtBox["3"]}]]}], ")"}], " ", 
      SubsuperscriptBox[
       StyleBox["W",
        FontColor->RGBColor[0.54, 0.35, 0.15]], 
       RowBox[{"2", ",", "v0", ",", "lead"}], "-"]}], "+", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        FractionBox["9", "28"], "-", 
        FractionBox[
         RowBox[{"11", " ", "\[ImaginaryI]"}], 
         RowBox[{"28", " ", 
          SqrtBox["3"]}]]}], ")"}], " ", 
      SubsuperscriptBox[
       StyleBox["W",
        FontColor->RGBColor[0.54, 0.35, 0.15]], 
       RowBox[{"2", ",", "v0", ",", "lead"}], "+"]}], "+", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", 
         FractionBox["3", "4"]}], "-", 
        FractionBox["\[ImaginaryI]", 
         RowBox[{"4", " ", 
          SqrtBox["3"]}]]}], ")"}], " ", 
      SubsuperscriptBox[
       StyleBox["W",
        FontColor->RGBColor[0.54, 0.35, 0.15]], 
       RowBox[{"2", ",", "v0", ",", "sublead"}], "-"]}], "+", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        FractionBox["3", "4"], "-", 
        FractionBox["\[ImaginaryI]", 
         RowBox[{"4", " ", 
          SqrtBox["3"]}]]}], ")"}], " ", 
      SubsuperscriptBox[
       StyleBox["W",
        FontColor->RGBColor[0.54, 0.35, 0.15]], 
       RowBox[{"2", ",", "v0", ",", "sublead"}], "+"]}]}], ")"}]}], "+", 
  RowBox[{
   SuperscriptBox["g", "12"], " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        FractionBox["1737", "1372"], "+", 
        FractionBox[
         RowBox[{"3215", " ", "\[ImaginaryI]"}], 
         RowBox[{"1372", " ", 
          SqrtBox["3"]}]]}], ")"}], " ", 
      SubsuperscriptBox[
       StyleBox["W",
        FontColor->RGBColor[0.54, 0.35, 0.15]], 
       RowBox[{"2", ",", "v0", ",", "lead"}], "-"]}], "+", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", 
         FractionBox["1737", "1372"]}], "+", 
        FractionBox[
         RowBox[{"3215", " ", "\[ImaginaryI]"}], 
         RowBox[{"1372", " ", 
          SqrtBox["3"]}]]}], ")"}], " ", 
      SubsuperscriptBox[
       StyleBox["W",
        FontColor->RGBColor[0.54, 0.35, 0.15]], 
       RowBox[{"2", ",", "v0", ",", "lead"}], "+"]}], "+", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", 
         FractionBox["9", "28"]}], "-", 
        FractionBox[
         RowBox[{"11", " ", "\[ImaginaryI]"}], 
         RowBox[{"28", " ", 
          SqrtBox["3"]}]]}], ")"}], " ", 
      SubsuperscriptBox[
       StyleBox["W",
        FontColor->RGBColor[0.54, 0.35, 0.15]], 
       RowBox[{"2", ",", "v0", ",", "sublead"}], "-"]}], "+", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        FractionBox["9", "28"], "-", 
        FractionBox[
         RowBox[{"11", " ", "\[ImaginaryI]"}], 
         RowBox[{"28", " ", 
          SqrtBox["3"]}]]}], ")"}], " ", 
      SubsuperscriptBox[
       StyleBox["W",
        FontColor->RGBColor[0.54, 0.35, 0.15]], 
       RowBox[{"2", ",", "v0", ",", "sublead"}], "+"]}], "+", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", 
         FractionBox["3", "4"]}], "-", 
        FractionBox["\[ImaginaryI]", 
         RowBox[{"4", " ", 
          SqrtBox["3"]}]]}], ")"}], " ", 
      SubsuperscriptBox[
       StyleBox["W",
        FontColor->RGBColor[0.54, 0.35, 0.15]], 
       RowBox[{"2", ",", "v0", ",", "sublead2"}], "-"]}], "+", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        FractionBox["3", "4"], "-", 
        FractionBox["\[ImaginaryI]", 
         RowBox[{"4", " ", 
          SqrtBox["3"]}]]}], ")"}], " ", 
      SubsuperscriptBox[
       StyleBox["W",
        FontColor->RGBColor[0.54, 0.35, 0.15]], 
       RowBox[{"2", ",", "v0", ",", "sublead2"}], "+"]}]}], ")"}]}], "+", 
  RowBox[{
   SuperscriptBox["g", "14"], " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        FractionBox["1737", "1372"], "+", 
        FractionBox[
         RowBox[{"3215", " ", "\[ImaginaryI]"}], 
         RowBox[{"1372", " ", 
          SqrtBox["3"]}]]}], ")"}], " ", 
      SubsuperscriptBox[
       StyleBox["W",
        FontColor->RGBColor[0.54, 0.35, 0.15]], 
       RowBox[{"2", ",", "v0", ",", "sublead"}], "-"]}], "+", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", 
         FractionBox["1737", "1372"]}], "+", 
        FractionBox[
         RowBox[{"3215", " ", "\[ImaginaryI]"}], 
         RowBox[{"1372", " ", 
          SqrtBox["3"]}]]}], ")"}], " ", 
      SubsuperscriptBox[
       StyleBox["W",
        FontColor->RGBColor[0.54, 0.35, 0.15]], 
       RowBox[{"2", ",", "v0", ",", "sublead"}], "+"]}], "+", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", 
         FractionBox["9", "28"]}], "-", 
        FractionBox[
         RowBox[{"11", " ", "\[ImaginaryI]"}], 
         RowBox[{"28", " ", 
          SqrtBox["3"]}]]}], ")"}], " ", 
      SubsuperscriptBox[
       StyleBox["W",
        FontColor->RGBColor[0.54, 0.35, 0.15]], 
       RowBox[{"2", ",", "v0", ",", "sublead2"}], "-"]}], "+", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        FractionBox["9", "28"], "-", 
        FractionBox[
         RowBox[{"11", " ", "\[ImaginaryI]"}], 
         RowBox[{"28", " ", 
          SqrtBox["3"]}]]}], ")"}], " ", 
      SubsuperscriptBox[
       StyleBox["W",
        FontColor->RGBColor[0.54, 0.35, 0.15]], 
       RowBox[{"2", ",", "v0", ",", "sublead2"}], "+"]}], "+", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", 
         FractionBox["3", "4"]}], "-", 
        FractionBox["\[ImaginaryI]", 
         RowBox[{"4", " ", 
          SqrtBox["3"]}]]}], ")"}], " ", 
      SubsuperscriptBox[
       StyleBox["W",
        FontColor->RGBColor[0.54, 0.35, 0.15]], 
       RowBox[{"2", ",", "v0", ",", "sublead3"}], "-"]}], "+", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        FractionBox["3", "4"], "-", 
        FractionBox["\[ImaginaryI]", 
         RowBox[{"4", " ", 
          SqrtBox["3"]}]]}], ")"}], " ", 
      SubsuperscriptBox[
       StyleBox["W",
        FontColor->RGBColor[0.54, 0.35, 0.15]], 
       RowBox[{"2", ",", "v0", ",", "sublead3"}], "+"]}], "+", 
     RowBox[{
      SubsuperscriptBox[
       StyleBox["W",
        FontColor->RGBColor[0.54, 0.35, 0.15]], 
       RowBox[{"2", ",", "v0", ",", "lead"}], "-"], " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", 
         FractionBox["537363", "67228"]}], "+", 
        RowBox[{
         SqrtBox["3"], " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"-", 
            FractionBox[
             RowBox[{"878173", " ", "\[ImaginaryI]"}], "201684"]}], "-", 
           RowBox[{"4", " ", "\[ImaginaryI]", " ", 
            SubscriptBox[
             StyleBox["\[Zeta]",
              FontWeight->Bold,
              FontColor->GrayLevel[0.4]], "3"]}]}], ")"}]}]}], ")"}]}], "+", 
     RowBox[{
      SubsuperscriptBox[
       StyleBox["W",
        FontColor->RGBColor[0.54, 0.35, 0.15]], 
       RowBox[{"2", ",", "v0", ",", "lead"}], "+"], " ", 
      RowBox[{"(", 
       RowBox[{
        FractionBox["537363", "67228"], "+", 
        RowBox[{
         SqrtBox["3"], " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"-", 
            FractionBox[
             RowBox[{"878173", " ", "\[ImaginaryI]"}], "201684"]}], "-", 
           RowBox[{"4", " ", "\[ImaginaryI]", " ", 
            SubscriptBox[
             StyleBox["\[Zeta]",
              FontWeight->Bold,
              FontColor->GrayLevel[0.4]], "3"]}]}], ")"}]}]}], ")"}]}]}], 
    ")"}]}]}]], "Output",
 CellChangeTimes->{{3.555961472144862*^9, 3.555961513305944*^9}, {
   3.555961599606495*^9, 3.555961629572899*^9}, 3.560337247361732*^9}]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 "Contribution from ",
 Cell[BoxData[
  FormBox[
   RowBox[{
    SubscriptBox["\[ScriptCapitalC]", "2"], 
    OverscriptBox["W", "^"]}], TraditionalForm]],
  FormatType->"TraditionalForm"]
}], "Subsubsection",
 CellChangeTimes->{
  3.55383020748068*^9, {3.553830700199875*^9, 3.5538307099398203`*^9}, {
   3.553830802049371*^9, 3.553830810573573*^9}, {3.553831134242115*^9, 
   3.553831137355349*^9}, {3.5538313716829157`*^9, 3.553831483505082*^9}, {
   3.555961735751958*^9, 3.555961748254781*^9}, {3.5559617787433558`*^9, 
   3.555961792725968*^9}}],

Cell[CellGroupData[{

Cell[BoxData["tmpden"], "Input",
 CellChangeTimes->{{3.560337311173614*^9, 3.560337312124398*^9}}],

Cell[BoxData[
 RowBox[{
  FractionBox["3", "4"], "-", 
  FractionBox["\[ImaginaryI]", 
   RowBox[{"4", " ", 
    SqrtBox["3"]}]], "+", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     FractionBox["9", "28"], "-", 
     FractionBox[
      RowBox[{"11", " ", "\[ImaginaryI]"}], 
      RowBox[{"28", " ", 
       SqrtBox["3"]}]]}], ")"}], " ", 
   SuperscriptBox["g", "2"]}], "+", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     RowBox[{"-", 
      FractionBox["1737", "1372"]}], "+", 
     FractionBox[
      RowBox[{"3215", " ", "\[ImaginaryI]"}], 
      RowBox[{"1372", " ", 
       SqrtBox["3"]}]]}], ")"}], " ", 
   SuperscriptBox["g", "4"]}], "+", 
  RowBox[{
   SuperscriptBox["g", "6"], " ", 
   RowBox[{"(", 
    RowBox[{
     FractionBox["537363", "67228"], "+", 
     RowBox[{
      SqrtBox["3"], " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", 
         FractionBox[
          RowBox[{"878173", " ", "\[ImaginaryI]"}], "201684"]}], "-", 
        RowBox[{"4", " ", "\[ImaginaryI]", " ", 
         SubscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "3"]}]}], ")"}]}]}], ")"}]}], "+", 
  RowBox[{
   SuperscriptBox["g", "8"], " ", 
   RowBox[{"(", 
    RowBox[{
     FractionBox["1277356307", "2470629"], "+", 
     RowBox[{
      SqrtBox["3"], " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", 
         FractionBox[
          RowBox[{"833279974", " ", "\[ImaginaryI]"}], "2470629"]}], "-", 
        FractionBox[
         RowBox[{"1098", " ", "\[ImaginaryI]", " ", 
          SubscriptBox[
           StyleBox["\[Zeta]",
            FontWeight->Bold,
            FontColor->GrayLevel[0.4]], "3"]}], "49"]}], ")"}]}], "+", 
     FractionBox[
      RowBox[{"3474", " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "3"]}], "49"]}], ")"}]}]}]], "Output",
 CellChangeTimes->{3.5603373125183897`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"tmpden", " ", 
   RowBox[{"(", 
    RowBox[{
     FractionBox["1", "2"], 
     RowBox[{"(", 
      RowBox[{
       FractionBox["1", 
        RowBox[{"u", "+", 
         FractionBox[
          RowBox[{"3", "\[ImaginaryI]"}], "2"], "-", "v"}]], "-", 
       FractionBox["1", 
        RowBox[{"u", "-", 
         FractionBox["\[ImaginaryI]", "2"], "-", "v"}]], "+", 
       FractionBox["1", 
        RowBox[{"u", "+", 
         FractionBox[
          RowBox[{"3", "\[ImaginaryI]"}], "2"], "+", "v"}]], "-", 
       FractionBox["1", 
        RowBox[{"u", "-", 
         FractionBox["\[ImaginaryI]", "2"], "+", "v"}]]}], ")"}]}], ")"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"Series", "[", 
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{"(", "%", ")"}], "+", 
         RowBox[{"(", 
          RowBox[{"%", "/.", "mconj"}], ")"}]}], "/.", 
        RowBox[{"u", "\[Rule]", 
         SubscriptBox["v", "0"]}]}], "/.", 
       RowBox[{"leadweak", "[", "4", "]"}]}], ",", 
      RowBox[{"{", 
       RowBox[{"g", ",", "0", ",", "6"}], "}"}]}], "]"}], "/.", 
    RowBox[{"v", "\[Rule]", "u"}]}], "//", "Simplify"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"%", "/.", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{"49", "+", 
      RowBox[{"186", " ", 
       SuperscriptBox["u", "2"]}], "+", 
      RowBox[{"567", " ", 
       SuperscriptBox["u", "4"]}], "+", 
      RowBox[{"378", " ", 
       SuperscriptBox["u", "6"]}], "+", 
      RowBox[{"81", " ", 
       SuperscriptBox["u", "8"]}]}], ")"}], "\[Rule]", 
    RowBox[{"(", 
     RowBox[{"81", 
      SuperscriptBox["Q0", "+"], 
      SuperscriptBox["Q0", "-"], 
      SuperscriptBox["Q0", 
       RowBox[{"[", 
        RowBox[{"+", "3"}], "]"}]], 
      SuperscriptBox["Q0", 
       RowBox[{"[", 
        RowBox[{"-", "3"}], "]"}]]}], ")"}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"contTuWh", "=", 
  RowBox[{"Collect", "[", 
   RowBox[{
    RowBox[{"Series", "[", 
     RowBox[{
      RowBox[{"%", " ", 
       SuperscriptBox["g", "8"], 
       RowBox[{"(", 
        RowBox[{
         SubscriptBox[
          OverscriptBox["W", "^"], "lead"], "+", 
         RowBox[{
          SuperscriptBox["g", "2"], 
          SubscriptBox[
           OverscriptBox["W", "^"], "sublead"]}], "+", 
         RowBox[{
          SuperscriptBox["g", "4"], 
          SubscriptBox[
           OverscriptBox["W", "^"], "sublead2"]}], "+", 
         RowBox[{
          SuperscriptBox["g", "6"], 
          SubscriptBox[
           OverscriptBox["W", "^"], "sublead3"]}]}], ")"}]}], ",", 
      RowBox[{"{", 
       RowBox[{"g", ",", "0", ",", "14"}], "}"}]}], "]"}], ",", "g", ",", 
    RowBox[{
     RowBox[{"\[DoubleStruckCapitalC]", "[", 
      RowBox[{"Collect", "[", 
       RowBox[{"#", ",", 
        SubscriptBox[
         OverscriptBox["W", "^"], "_"], ",", "Together"}], "]"}], "]"}], 
     "&"}]}], "]"}]}]}], "Input",
 CellChangeTimes->{{3.555961801624694*^9, 3.555961930094448*^9}, {
  3.555962032898609*^9, 3.555962238991325*^9}, {3.555962297110764*^9, 
  3.555962298897871*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   SuperscriptBox["g", "8"], " ", 
   RowBox[{"\[DoubleStruckCapitalC]", "[", 
    RowBox[{"-", 
     FractionBox[
      RowBox[{
       RowBox[{"(", 
        RowBox[{"49", "-", 
         RowBox[{"30", " ", 
          SuperscriptBox["u", "2"]}], "-", 
         RowBox[{"36", " ", 
          SuperscriptBox["u", "4"]}], "+", 
         RowBox[{"27", " ", 
          SuperscriptBox["u", "6"]}]}], ")"}], " ", 
       SubscriptBox[
        OverscriptBox[
         StyleBox["W",
          FontColor->RGBColor[0.54, 0.35, 0.15]], 
         StyleBox["^",
          FontColor->RGBColor[0.54, 0.35, 0.15]]], "lead"]}], 
      RowBox[{"27", " ", 
       SqrtBox["3"], " ", 
       SuperscriptBox[
        StyleBox["Q0",
         FontColor->RGBColor[{
            Rational[1, 2], 
            Rational[1, 2], 0}]], 
        RowBox[{"[", 
         RowBox[{"-", "3"}], "]"}]], " ", 
       SuperscriptBox[
        StyleBox["Q0",
         FontColor->RGBColor[{
            Rational[1, 2], 
            Rational[1, 2], 0}]], "-"], " ", 
       SuperscriptBox[
        StyleBox["Q0",
         FontColor->RGBColor[{
            Rational[1, 2], 
            Rational[1, 2], 0}]], "+"], " ", 
       SuperscriptBox[
        StyleBox["Q0",
         FontColor->RGBColor[{
            Rational[1, 2], 
            Rational[1, 2], 0}]], 
        RowBox[{"[", "3", "]"}]]}]]}], "]"}]}], "+", 
  RowBox[{
   SuperscriptBox["g", "10"], " ", 
   RowBox[{"\[DoubleStruckCapitalC]", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          RowBox[{
           RowBox[{"-", "33271"}], " ", 
           SqrtBox["3"]}], "-", 
          RowBox[{"841008", " ", 
           SqrtBox["3"], " ", 
           SuperscriptBox["u", "2"]}], "-", 
          RowBox[{"1159749", " ", 
           SqrtBox["3"], " ", 
           SuperscriptBox["u", "4"]}], "+", 
          RowBox[{"2382939", " ", 
           SqrtBox["3"], " ", 
           SuperscriptBox["u", "6"]}], "+", 
          RowBox[{"4990491", " ", 
           SqrtBox["3"], " ", 
           SuperscriptBox["u", "8"]}], "+", 
          RowBox[{"2654775", " ", 
           SqrtBox["3"], " ", 
           SuperscriptBox["u", "10"]}], "+", 
          RowBox[{"330966", " ", 
           SqrtBox["3"], " ", 
           SuperscriptBox["u", "12"]}], "-", 
          RowBox[{"24057", " ", 
           SqrtBox["3"], " ", 
           SuperscriptBox["u", "14"]}]}], ")"}], " ", 
        SubscriptBox[
         OverscriptBox[
          StyleBox["W",
           FontColor->RGBColor[0.54, 0.35, 0.15]], 
          StyleBox["^",
           FontColor->RGBColor[0.54, 0.35, 0.15]]], "lead"]}], ")"}], "/", 
      RowBox[{"(", 
       RowBox[{"45927", " ", 
        SuperscriptBox[
         RowBox[{"(", 
          SuperscriptBox[
           StyleBox["Q0",
            FontColor->RGBColor[{
               Rational[1, 2], 
               Rational[1, 2], 0}]], 
           RowBox[{"[", 
            RowBox[{"-", "3"}], "]"}]], ")"}], "2"], " ", 
        SuperscriptBox[
         RowBox[{"(", 
          SuperscriptBox[
           StyleBox["Q0",
            FontColor->RGBColor[{
               Rational[1, 2], 
               Rational[1, 2], 0}]], "-"], ")"}], "2"], " ", 
        SuperscriptBox[
         RowBox[{"(", 
          SuperscriptBox[
           StyleBox["Q0",
            FontColor->RGBColor[{
               Rational[1, 2], 
               Rational[1, 2], 0}]], "+"], ")"}], "2"], " ", 
        SuperscriptBox[
         RowBox[{"(", 
          SuperscriptBox[
           StyleBox["Q0",
            FontColor->RGBColor[{
               Rational[1, 2], 
               Rational[1, 2], 0}]], 
           RowBox[{"[", "3", "]"}]], ")"}], "2"]}], ")"}]}], "-", 
     FractionBox[
      RowBox[{
       RowBox[{"(", 
        RowBox[{"49", "-", 
         RowBox[{"30", " ", 
          SuperscriptBox["u", "2"]}], "-", 
         RowBox[{"36", " ", 
          SuperscriptBox["u", "4"]}], "+", 
         RowBox[{"27", " ", 
          SuperscriptBox["u", "6"]}]}], ")"}], " ", 
       SubscriptBox[
        OverscriptBox[
         StyleBox["W",
          FontColor->RGBColor[0.54, 0.35, 0.15]], 
         StyleBox["^",
          FontColor->RGBColor[0.54, 0.35, 0.15]]], "sublead"]}], 
      RowBox[{"27", " ", 
       SqrtBox["3"], " ", 
       SuperscriptBox[
        StyleBox["Q0",
         FontColor->RGBColor[{
            Rational[1, 2], 
            Rational[1, 2], 0}]], 
        RowBox[{"[", 
         RowBox[{"-", "3"}], "]"}]], " ", 
       SuperscriptBox[
        StyleBox["Q0",
         FontColor->RGBColor[{
            Rational[1, 2], 
            Rational[1, 2], 0}]], "-"], " ", 
       SuperscriptBox[
        StyleBox["Q0",
         FontColor->RGBColor[{
            Rational[1, 2], 
            Rational[1, 2], 0}]], "+"], " ", 
       SuperscriptBox[
        StyleBox["Q0",
         FontColor->RGBColor[{
            Rational[1, 2], 
            Rational[1, 2], 0}]], 
        RowBox[{"[", "3", "]"}]]}]]}], "]"}]}], "+", 
  RowBox[{
   SuperscriptBox["g", "12"], " ", 
   RowBox[{"\[DoubleStruckCapitalC]", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          RowBox[{"424023803", " ", 
           SqrtBox["3"]}], "+", 
          RowBox[{"3707799816", " ", 
           SqrtBox["3"], " ", 
           SuperscriptBox["u", "2"]}], "-", 
          RowBox[{"16479193416", " ", 
           SqrtBox["3"], " ", 
           SuperscriptBox["u", "4"]}], "-", 
          RowBox[{"102416977017", " ", 
           SqrtBox["3"], " ", 
           SuperscriptBox["u", "6"]}], "-", 
          RowBox[{"166315793319", " ", 
           SqrtBox["3"], " ", 
           SuperscriptBox["u", "8"]}], "-", 
          RowBox[{"160786675566", " ", 
           SqrtBox["3"], " ", 
           SuperscriptBox["u", "10"]}], "-", 
          RowBox[{"123265738116", " ", 
           SqrtBox["3"], " ", 
           SuperscriptBox["u", "12"]}], "-", 
          RowBox[{"60825607263", " ", 
           SqrtBox["3"], " ", 
           SuperscriptBox["u", "14"]}], "-", 
          RowBox[{"16708511601", " ", 
           SqrtBox["3"], " ", 
           SuperscriptBox["u", "16"]}], "-", 
          RowBox[{"2229887070", " ", 
           SqrtBox["3"], " ", 
           SuperscriptBox["u", "18"]}], "+", 
          RowBox[{"459991710", " ", 
           SqrtBox["3"], " ", 
           SuperscriptBox["u", "20"]}], "+", 
          RowBox[{"189842535", " ", 
           SqrtBox["3"], " ", 
           SuperscriptBox["u", "22"]}]}], ")"}], " ", 
        SubscriptBox[
         OverscriptBox[
          StyleBox["W",
           FontColor->RGBColor[0.54, 0.35, 0.15]], 
          StyleBox["^",
           FontColor->RGBColor[0.54, 0.35, 0.15]]], "lead"]}], ")"}], "/", 
      RowBox[{"(", 
       RowBox[{"60761421", " ", 
        SuperscriptBox[
         RowBox[{"(", 
          SuperscriptBox[
           StyleBox["Q0",
            FontColor->RGBColor[{
               Rational[1, 2], 
               Rational[1, 2], 0}]], 
           RowBox[{"[", 
            RowBox[{"-", "3"}], "]"}]], ")"}], "3"], " ", 
        SuperscriptBox[
         RowBox[{"(", 
          SuperscriptBox[
           StyleBox["Q0",
            FontColor->RGBColor[{
               Rational[1, 2], 
               Rational[1, 2], 0}]], "-"], ")"}], "3"], " ", 
        SuperscriptBox[
         RowBox[{"(", 
          SuperscriptBox[
           StyleBox["Q0",
            FontColor->RGBColor[{
               Rational[1, 2], 
               Rational[1, 2], 0}]], "+"], ")"}], "3"], " ", 
        SuperscriptBox[
         RowBox[{"(", 
          SuperscriptBox[
           StyleBox["Q0",
            FontColor->RGBColor[{
               Rational[1, 2], 
               Rational[1, 2], 0}]], 
           RowBox[{"[", "3", "]"}]], ")"}], "3"]}], ")"}]}], "+", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          RowBox[{
           RowBox[{"-", "33271"}], " ", 
           SqrtBox["3"]}], "-", 
          RowBox[{"841008", " ", 
           SqrtBox["3"], " ", 
           SuperscriptBox["u", "2"]}], "-", 
          RowBox[{"1159749", " ", 
           SqrtBox["3"], " ", 
           SuperscriptBox["u", "4"]}], "+", 
          RowBox[{"2382939", " ", 
           SqrtBox["3"], " ", 
           SuperscriptBox["u", "6"]}], "+", 
          RowBox[{"4990491", " ", 
           SqrtBox["3"], " ", 
           SuperscriptBox["u", "8"]}], "+", 
          RowBox[{"2654775", " ", 
           SqrtBox["3"], " ", 
           SuperscriptBox["u", "10"]}], "+", 
          RowBox[{"330966", " ", 
           SqrtBox["3"], " ", 
           SuperscriptBox["u", "12"]}], "-", 
          RowBox[{"24057", " ", 
           SqrtBox["3"], " ", 
           SuperscriptBox["u", "14"]}]}], ")"}], " ", 
        SubscriptBox[
         OverscriptBox[
          StyleBox["W",
           FontColor->RGBColor[0.54, 0.35, 0.15]], 
          StyleBox["^",
           FontColor->RGBColor[0.54, 0.35, 0.15]]], "sublead"]}], ")"}], "/", 
      
      RowBox[{"(", 
       RowBox[{"45927", " ", 
        SuperscriptBox[
         RowBox[{"(", 
          SuperscriptBox[
           StyleBox["Q0",
            FontColor->RGBColor[{
               Rational[1, 2], 
               Rational[1, 2], 0}]], 
           RowBox[{"[", 
            RowBox[{"-", "3"}], "]"}]], ")"}], "2"], " ", 
        SuperscriptBox[
         RowBox[{"(", 
          SuperscriptBox[
           StyleBox["Q0",
            FontColor->RGBColor[{
               Rational[1, 2], 
               Rational[1, 2], 0}]], "-"], ")"}], "2"], " ", 
        SuperscriptBox[
         RowBox[{"(", 
          SuperscriptBox[
           StyleBox["Q0",
            FontColor->RGBColor[{
               Rational[1, 2], 
               Rational[1, 2], 0}]], "+"], ")"}], "2"], " ", 
        SuperscriptBox[
         RowBox[{"(", 
          SuperscriptBox[
           StyleBox["Q0",
            FontColor->RGBColor[{
               Rational[1, 2], 
               Rational[1, 2], 0}]], 
           RowBox[{"[", "3", "]"}]], ")"}], "2"]}], ")"}]}], "-", 
     FractionBox[
      RowBox[{
       RowBox[{"(", 
        RowBox[{"49", "-", 
         RowBox[{"30", " ", 
          SuperscriptBox["u", "2"]}], "-", 
         RowBox[{"36", " ", 
          SuperscriptBox["u", "4"]}], "+", 
         RowBox[{"27", " ", 
          SuperscriptBox["u", "6"]}]}], ")"}], " ", 
       SubscriptBox[
        OverscriptBox[
         StyleBox["W",
          FontColor->RGBColor[0.54, 0.35, 0.15]], 
         StyleBox["^",
          FontColor->RGBColor[0.54, 0.35, 0.15]]], "sublead2"]}], 
      RowBox[{"27", " ", 
       SqrtBox["3"], " ", 
       SuperscriptBox[
        StyleBox["Q0",
         FontColor->RGBColor[{
            Rational[1, 2], 
            Rational[1, 2], 0}]], 
        RowBox[{"[", 
         RowBox[{"-", "3"}], "]"}]], " ", 
       SuperscriptBox[
        StyleBox["Q0",
         FontColor->RGBColor[{
            Rational[1, 2], 
            Rational[1, 2], 0}]], "-"], " ", 
       SuperscriptBox[
        StyleBox["Q0",
         FontColor->RGBColor[{
            Rational[1, 2], 
            Rational[1, 2], 0}]], "+"], " ", 
       SuperscriptBox[
        StyleBox["Q0",
         FontColor->RGBColor[{
            Rational[1, 2], 
            Rational[1, 2], 0}]], 
        RowBox[{"[", "3", "]"}]]}]]}], "]"}]}], "+", 
  RowBox[{
   SuperscriptBox["g", "14"], " ", 
   RowBox[{"\[DoubleStruckCapitalC]", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          RowBox[{"424023803", " ", 
           SqrtBox["3"]}], "+", 
          RowBox[{"3707799816", " ", 
           SqrtBox["3"], " ", 
           SuperscriptBox["u", "2"]}], "-", 
          RowBox[{"16479193416", " ", 
           SqrtBox["3"], " ", 
           SuperscriptBox["u", "4"]}], "-", 
          RowBox[{"102416977017", " ", 
           SqrtBox["3"], " ", 
           SuperscriptBox["u", "6"]}], "-", 
          RowBox[{"166315793319", " ", 
           SqrtBox["3"], " ", 
           SuperscriptBox["u", "8"]}], "-", 
          RowBox[{"160786675566", " ", 
           SqrtBox["3"], " ", 
           SuperscriptBox["u", "10"]}], "-", 
          RowBox[{"123265738116", " ", 
           SqrtBox["3"], " ", 
           SuperscriptBox["u", "12"]}], "-", 
          RowBox[{"60825607263", " ", 
           SqrtBox["3"], " ", 
           SuperscriptBox["u", "14"]}], "-", 
          RowBox[{"16708511601", " ", 
           SqrtBox["3"], " ", 
           SuperscriptBox["u", "16"]}], "-", 
          RowBox[{"2229887070", " ", 
           SqrtBox["3"], " ", 
           SuperscriptBox["u", "18"]}], "+", 
          RowBox[{"459991710", " ", 
           SqrtBox["3"], " ", 
           SuperscriptBox["u", "20"]}], "+", 
          RowBox[{"189842535", " ", 
           SqrtBox["3"], " ", 
           SuperscriptBox["u", "22"]}]}], ")"}], " ", 
        SubscriptBox[
         OverscriptBox[
          StyleBox["W",
           FontColor->RGBColor[0.54, 0.35, 0.15]], 
          StyleBox["^",
           FontColor->RGBColor[0.54, 0.35, 0.15]]], "sublead"]}], ")"}], "/", 
      
      RowBox[{"(", 
       RowBox[{"60761421", " ", 
        SuperscriptBox[
         RowBox[{"(", 
          SuperscriptBox[
           StyleBox["Q0",
            FontColor->RGBColor[{
               Rational[1, 2], 
               Rational[1, 2], 0}]], 
           RowBox[{"[", 
            RowBox[{"-", "3"}], "]"}]], ")"}], "3"], " ", 
        SuperscriptBox[
         RowBox[{"(", 
          SuperscriptBox[
           StyleBox["Q0",
            FontColor->RGBColor[{
               Rational[1, 2], 
               Rational[1, 2], 0}]], "-"], ")"}], "3"], " ", 
        SuperscriptBox[
         RowBox[{"(", 
          SuperscriptBox[
           StyleBox["Q0",
            FontColor->RGBColor[{
               Rational[1, 2], 
               Rational[1, 2], 0}]], "+"], ")"}], "3"], " ", 
        SuperscriptBox[
         RowBox[{"(", 
          SuperscriptBox[
           StyleBox["Q0",
            FontColor->RGBColor[{
               Rational[1, 2], 
               Rational[1, 2], 0}]], 
           RowBox[{"[", "3", "]"}]], ")"}], "3"]}], ")"}]}], "+", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          RowBox[{
           RowBox[{"-", "33271"}], " ", 
           SqrtBox["3"]}], "-", 
          RowBox[{"841008", " ", 
           SqrtBox["3"], " ", 
           SuperscriptBox["u", "2"]}], "-", 
          RowBox[{"1159749", " ", 
           SqrtBox["3"], " ", 
           SuperscriptBox["u", "4"]}], "+", 
          RowBox[{"2382939", " ", 
           SqrtBox["3"], " ", 
           SuperscriptBox["u", "6"]}], "+", 
          RowBox[{"4990491", " ", 
           SqrtBox["3"], " ", 
           SuperscriptBox["u", "8"]}], "+", 
          RowBox[{"2654775", " ", 
           SqrtBox["3"], " ", 
           SuperscriptBox["u", "10"]}], "+", 
          RowBox[{"330966", " ", 
           SqrtBox["3"], " ", 
           SuperscriptBox["u", "12"]}], "-", 
          RowBox[{"24057", " ", 
           SqrtBox["3"], " ", 
           SuperscriptBox["u", "14"]}]}], ")"}], " ", 
        SubscriptBox[
         OverscriptBox[
          StyleBox["W",
           FontColor->RGBColor[0.54, 0.35, 0.15]], 
          StyleBox["^",
           FontColor->RGBColor[0.54, 0.35, 0.15]]], "sublead2"]}], ")"}], "/", 
      RowBox[{"(", 
       RowBox[{"45927", " ", 
        SuperscriptBox[
         RowBox[{"(", 
          SuperscriptBox[
           StyleBox["Q0",
            FontColor->RGBColor[{
               Rational[1, 2], 
               Rational[1, 2], 0}]], 
           RowBox[{"[", 
            RowBox[{"-", "3"}], "]"}]], ")"}], "2"], " ", 
        SuperscriptBox[
         RowBox[{"(", 
          SuperscriptBox[
           StyleBox["Q0",
            FontColor->RGBColor[{
               Rational[1, 2], 
               Rational[1, 2], 0}]], "-"], ")"}], "2"], " ", 
        SuperscriptBox[
         RowBox[{"(", 
          SuperscriptBox[
           StyleBox["Q0",
            FontColor->RGBColor[{
               Rational[1, 2], 
               Rational[1, 2], 0}]], "+"], ")"}], "2"], " ", 
        SuperscriptBox[
         RowBox[{"(", 
          SuperscriptBox[
           StyleBox["Q0",
            FontColor->RGBColor[{
               Rational[1, 2], 
               Rational[1, 2], 0}]], 
           RowBox[{"[", "3", "]"}]], ")"}], "2"]}], ")"}]}], "-", 
     FractionBox[
      RowBox[{
       RowBox[{"(", 
        RowBox[{"49", "-", 
         RowBox[{"30", " ", 
          SuperscriptBox["u", "2"]}], "-", 
         RowBox[{"36", " ", 
          SuperscriptBox["u", "4"]}], "+", 
         RowBox[{"27", " ", 
          SuperscriptBox["u", "6"]}]}], ")"}], " ", 
       SubscriptBox[
        OverscriptBox[
         StyleBox["W",
          FontColor->RGBColor[0.54, 0.35, 0.15]], 
         StyleBox["^",
          FontColor->RGBColor[0.54, 0.35, 0.15]]], "sublead3"]}], 
      RowBox[{"27", " ", 
       SqrtBox["3"], " ", 
       SuperscriptBox[
        StyleBox["Q0",
         FontColor->RGBColor[{
            Rational[1, 2], 
            Rational[1, 2], 0}]], 
        RowBox[{"[", 
         RowBox[{"-", "3"}], "]"}]], " ", 
       SuperscriptBox[
        StyleBox["Q0",
         FontColor->RGBColor[{
            Rational[1, 2], 
            Rational[1, 2], 0}]], "-"], " ", 
       SuperscriptBox[
        StyleBox["Q0",
         FontColor->RGBColor[{
            Rational[1, 2], 
            Rational[1, 2], 0}]], "+"], " ", 
       SuperscriptBox[
        StyleBox["Q0",
         FontColor->RGBColor[{
            Rational[1, 2], 
            Rational[1, 2], 0}]], 
        RowBox[{"[", "3", "]"}]]}]], "+", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        SubscriptBox[
         OverscriptBox[
          StyleBox["W",
           FontColor->RGBColor[0.54, 0.35, 0.15]], 
          StyleBox["^",
           FontColor->RGBColor[0.54, 0.35, 0.15]]], "lead"], " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{
           RowBox[{"-", "21554005399927"}], " ", 
           SqrtBox["3"]}], "-", 
          RowBox[{"3254285593986", " ", 
           SqrtBox["3"], " ", 
           SuperscriptBox["u", "2"]}], "+", 
          RowBox[{"2278990349568891", " ", 
           SqrtBox["3"], " ", 
           SuperscriptBox["u", "4"]}], "+", 
          RowBox[{"6852069203236551", " ", 
           SqrtBox["3"], " ", 
           SuperscriptBox["u", "6"]}], "-", 
          RowBox[{"777176147562174", " ", 
           SqrtBox["3"], " ", 
           SuperscriptBox["u", "8"]}], "-", 
          RowBox[{"16004895252581061", " ", 
           SqrtBox["3"], " ", 
           SuperscriptBox["u", "10"]}], "-", 
          RowBox[{"6896853930479049", " ", 
           SqrtBox["3"], " ", 
           SuperscriptBox["u", "12"]}], "+", 
          RowBox[{"37949279382974916", " ", 
           SqrtBox["3"], " ", 
           SuperscriptBox["u", "14"]}], "+", 
          RowBox[{"82090396462384314", " ", 
           SqrtBox["3"], " ", 
           SuperscriptBox["u", "16"]}], "+", 
          RowBox[{"83341487760916167", " ", 
           SqrtBox["3"], " ", 
           SuperscriptBox["u", "18"]}], "+", 
          RowBox[{"50535160937103267", " ", 
           SqrtBox["3"], " ", 
           SuperscriptBox["u", "20"]}], "+", 
          RowBox[{"18368311870526580", " ", 
           SqrtBox["3"], " ", 
           SuperscriptBox["u", "22"]}], "+", 
          RowBox[{"3364087745954277", " ", 
           SqrtBox["3"], " ", 
           SuperscriptBox["u", "24"]}], "+", 
          RowBox[{"35239995667629", " ", 
           SqrtBox["3"], " ", 
           SuperscriptBox["u", "26"]}], "-", 
          RowBox[{"94603989192336", " ", 
           SqrtBox["3"], " ", 
           SuperscriptBox["u", "28"]}], "-", 
          RowBox[{"12600822706911", " ", 
           SqrtBox["3"], " ", 
           SuperscriptBox["u", "30"]}], "-", 
          RowBox[{"2325336249768", " ", 
           SqrtBox["3"], " ", 
           SubscriptBox[
            StyleBox["\[Zeta]",
             FontWeight->Bold,
             FontColor->GrayLevel[0.4]], "3"]}], "-", 
          RowBox[{"56601260493624", " ", 
           SqrtBox["3"], " ", 
           SuperscriptBox["u", "2"], " ", 
           SubscriptBox[
            StyleBox["\[Zeta]",
             FontWeight->Bold,
             FontColor->GrayLevel[0.4]], "3"]}], "-", 
          RowBox[{"464346419236560", " ", 
           SqrtBox["3"], " ", 
           SuperscriptBox["u", "4"], " ", 
           SubscriptBox[
            StyleBox["\[Zeta]",
             FontWeight->Bold,
             FontColor->GrayLevel[0.4]], "3"]}], "-", 
          RowBox[{"2338519257872280", " ", 
           SqrtBox["3"], " ", 
           SuperscriptBox["u", "6"], " ", 
           SubscriptBox[
            StyleBox["\[Zeta]",
             FontWeight->Bold,
             FontColor->GrayLevel[0.4]], "3"]}], "-", 
          RowBox[{"7632313417883448", " ", 
           SqrtBox["3"], " ", 
           SuperscriptBox["u", "8"], " ", 
           SubscriptBox[
            StyleBox["\[Zeta]",
             FontWeight->Bold,
             FontColor->GrayLevel[0.4]], "3"]}], "-", 
          RowBox[{"16859145795651936", " ", 
           SqrtBox["3"], " ", 
           SuperscriptBox["u", "10"], " ", 
           SubscriptBox[
            StyleBox["\[Zeta]",
             FontWeight->Bold,
             FontColor->GrayLevel[0.4]], "3"]}], "-", 
          RowBox[{"24017860915124328", " ", 
           SqrtBox["3"], " ", 
           SuperscriptBox["u", "12"], " ", 
           SubscriptBox[
            StyleBox["\[Zeta]",
             FontWeight->Bold,
             FontColor->GrayLevel[0.4]], "3"]}], "-", 
          RowBox[{"18979327336860072", " ", 
           SqrtBox["3"], " ", 
           SuperscriptBox["u", "14"], " ", 
           SubscriptBox[
            StyleBox["\[Zeta]",
             FontWeight->Bold,
             FontColor->GrayLevel[0.4]], "3"]}], "-", 
          RowBox[{"5117582398649112", " ", 
           SqrtBox["3"], " ", 
           SuperscriptBox["u", "16"], " ", 
           SubscriptBox[
            StyleBox["\[Zeta]",
             FontWeight->Bold,
             FontColor->GrayLevel[0.4]], "3"]}], "+", 
          RowBox[{"2354059479996000", " ", 
           SqrtBox["3"], " ", 
           SuperscriptBox["u", "18"], " ", 
           SubscriptBox[
            StyleBox["\[Zeta]",
             FontWeight->Bold,
             FontColor->GrayLevel[0.4]], "3"]}], "+", 
          RowBox[{"232920886895928", " ", 
           SqrtBox["3"], " ", 
           SuperscriptBox["u", "20"], " ", 
           SubscriptBox[
            StyleBox["\[Zeta]",
             FontWeight->Bold,
             FontColor->GrayLevel[0.4]], "3"]}], "-", 
          RowBox[{"2606622670950984", " ", 
           SqrtBox["3"], " ", 
           SuperscriptBox["u", "22"], " ", 
           SubscriptBox[
            StyleBox["\[Zeta]",
             FontWeight->Bold,
             FontColor->GrayLevel[0.4]], "3"]}], "-", 
          RowBox[{"2189537319643632", " ", 
           SqrtBox["3"], " ", 
           SuperscriptBox["u", "24"], " ", 
           SubscriptBox[
            StyleBox["\[Zeta]",
             FontWeight->Bold,
             FontColor->GrayLevel[0.4]], "3"]}], "-", 
          RowBox[{"817378676307144", " ", 
           SqrtBox["3"], " ", 
           SuperscriptBox["u", "26"], " ", 
           SubscriptBox[
            StyleBox["\[Zeta]",
             FontWeight->Bold,
             FontColor->GrayLevel[0.4]], "3"]}], "-", 
          RowBox[{"152414434527768", " ", 
           SqrtBox["3"], " ", 
           SuperscriptBox["u", "28"], " ", 
           SubscriptBox[
            StyleBox["\[Zeta]",
             FontWeight->Bold,
             FontColor->GrayLevel[0.4]], "3"]}], "-", 
          RowBox[{"11575779837552", " ", 
           SqrtBox["3"], " ", 
           SuperscriptBox["u", "30"], " ", 
           SubscriptBox[
            StyleBox["\[Zeta]",
             FontWeight->Bold,
             FontColor->GrayLevel[0.4]], "3"]}]}], ")"}]}], ")"}], "/", 
      RowBox[{"(", 
       RowBox[{"723486239847", " ", 
        SuperscriptBox[
         RowBox[{"(", 
          SuperscriptBox[
           StyleBox["Q0",
            FontColor->RGBColor[{
               Rational[1, 2], 
               Rational[1, 2], 0}]], 
           RowBox[{"[", 
            RowBox[{"-", "3"}], "]"}]], ")"}], "4"], " ", 
        SuperscriptBox[
         RowBox[{"(", 
          SuperscriptBox[
           StyleBox["Q0",
            FontColor->RGBColor[{
               Rational[1, 2], 
               Rational[1, 2], 0}]], "-"], ")"}], "4"], " ", 
        SuperscriptBox[
         RowBox[{"(", 
          SuperscriptBox[
           StyleBox["Q0",
            FontColor->RGBColor[{
               Rational[1, 2], 
               Rational[1, 2], 0}]], "+"], ")"}], "4"], " ", 
        SuperscriptBox[
         RowBox[{"(", 
          SuperscriptBox[
           StyleBox["Q0",
            FontColor->RGBColor[{
               Rational[1, 2], 
               Rational[1, 2], 0}]], 
           RowBox[{"[", "3", "]"}]], ")"}], "4"]}], ")"}]}]}], 
    "]"}]}]}]], "Output",
 CellChangeTimes->{3.5559621990005827`*^9, 3.555962239805408*^9, 
  3.555962300503039*^9, 3.5603373641764307`*^9}]
}, Open  ]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[Cell[BoxData[
 RowBox[{
  RowBox[{"\[DoubleStruckCapitalC]", "[", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"-", 
       FractionBox[
        RowBox[{"(", 
         RowBox[{"Kr1", "+", 
          RowBox[{
           SuperscriptBox["u", "2"], "Kr2"}]}], ")"}], 
        SqrtBox[
         RowBox[{"1", "-", 
          FractionBox[
           RowBox[{"4", 
            SuperscriptBox["g", "2"]}], 
           SuperscriptBox["u", "2"]]}]]]}], "+", 
      RowBox[{"2", "\[ImaginaryI]", " ", 
       SubscriptBox["v", "0"], " ", "u"}]}], ")"}], 
    FractionBox["H", 
     RowBox[{
      SuperscriptBox[
       StyleBox["Q",
        FontColor->RGBColor[0.8, 0, 0]], "-"], " ", 
      SuperscriptBox[
       StyleBox["Q",
        FontColor->RGBColor[0.8, 0, 0]], "+"]}]]}], "]"}], "\[Equal]", " ", 
  "contH"}]],
 CellChangeTimes->{{3.553775524449216*^9, 3.553775575150013*^9}, {
  3.553775653575102*^9, 3.553775669355048*^9}}]], "Subsection",
 CellChangeTimes->{
  3.5537757859374247`*^9, {3.553835562706273*^9, 3.553835563144486*^9}, {
   3.553836815957322*^9, 3.553836852092062*^9}, {3.5538371420445423`*^9, 
   3.553837148530995*^9}, {3.555965155809314*^9, 3.5559651570333643`*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"subsuplexpand", "=", 
  RowBox[{"subsupl", "/.", 
   RowBox[{
    RowBox[{"Rule", "[", 
     RowBox[{"a_", ",", "b_"}], "]"}], "\[RuleDelayed]", 
    RowBox[{"Rule", "[", 
     RowBox[{"a", ",", 
      RowBox[{
       RowBox[{
        RowBox[{"Series", "[", 
         RowBox[{
          RowBox[{"b", "/.", 
           RowBox[{"leadweak", "[", "4", "]"}]}], ",", 
          RowBox[{"{", 
           RowBox[{"g", ",", "0", ",", "6"}], "}"}]}], "]"}], "//", 
        "Simplify"}], "//", "Normal"}]}], "]"}]}]}]}]], "Input",
 CellChangeTimes->{{3.555963092685405*^9, 3.555963145942752*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"Kr1", "\[Rule]", 
    RowBox[{
     FractionBox["1", 
      RowBox[{"3", " ", 
       SqrtBox["3"]}]], "+", 
     FractionBox[
      RowBox[{"8", " ", 
       SuperscriptBox["g", "2"]}], 
      SqrtBox["3"]], "+", 
     FractionBox[
      RowBox[{"8", " ", 
       SuperscriptBox["g", "4"]}], 
      SqrtBox["3"]], "+", 
     FractionBox[
      RowBox[{"8", " ", 
       SuperscriptBox["g", "6"], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", "14"}], "+", 
         RowBox[{"9", " ", 
          SubscriptBox[
           StyleBox["\[Zeta]",
            FontWeight->Bold,
            FontColor->GrayLevel[0.4]], "3"]}]}], ")"}]}], 
      RowBox[{"3", " ", 
       SqrtBox["3"]}]]}]}], ",", 
   RowBox[{"Kr2", "\[Rule]", 
    RowBox[{
     RowBox[{"-", 
      FractionBox["1", 
       SqrtBox["3"]]}], "-", 
     FractionBox[
      RowBox[{"2", " ", 
       SuperscriptBox["g", "2"]}], 
      SqrtBox["3"]], "+", 
     FractionBox[
      RowBox[{"8", " ", 
       SuperscriptBox["g", "4"]}], 
      SqrtBox["3"]], "-", 
     FractionBox[
      RowBox[{"8", " ", 
       SuperscriptBox["g", "6"], " ", 
       RowBox[{"(", 
        RowBox[{"5", "+", 
         RowBox[{"6", " ", 
          SubscriptBox[
           StyleBox["\[Zeta]",
            FontWeight->Bold,
            FontColor->GrayLevel[0.4]], "3"]}]}], ")"}]}], 
      SqrtBox["3"]]}]}]}], "}"}]], "Output",
 CellChangeTimes->{
  3.555963044971229*^9, {3.555963125819392*^9, 3.555963146429749*^9}, 
   3.555964885493958*^9, 3.560338074214889*^9}]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"tmpfun", "=", 
   RowBox[{
    RowBox[{"Collect", "[", 
     RowBox[{"#", ",", 
      RowBox[{"{", 
       RowBox[{"g", ",", 
        RowBox[{
         SuperscriptBox[
          RowBox[{"Q0$", "[", "1", "]"}], "_."], 
         SuperscriptBox[
          RowBox[{"Q0$", "[", 
           RowBox[{"-", "1"}], "]"}], "_."]}], ",", 
        RowBox[{"Q0$", "[", "1", "]"}], ",", 
        RowBox[{"Q0$", "[", 
         RowBox[{"-", "1"}], "]"}], ",", 
        SqrtBox["3"]}], "}"}], ",", "Together"}], "]"}], "&"}]}], 
  ";"}]], "Input",
 CellChangeTimes->{{3.555963575957325*^9, 3.55596358725421*^9}, {
  3.5559642389897337`*^9, 3.5559642403697042`*^9}}],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"tmp", "=", 
   RowBox[{"tmp1", "=", 
    RowBox[{
     RowBox[{
      RowBox[{"Collect", "[", 
       RowBox[{"#", ",", 
        RowBox[{"{", 
         RowBox[{"g", ",", 
          RowBox[{
           SuperscriptBox[
            RowBox[{"Q0$", "[", "1", "]"}], "_."], 
           SuperscriptBox[
            RowBox[{"Q0$", "[", 
             RowBox[{"-", "1"}], "]"}], "_."]}], ",", 
          RowBox[{"Q0$", "[", "1", "]"}], ",", 
          RowBox[{"Q0$", "[", 
           RowBox[{"-", "1"}], "]"}]}], "}"}], ",", "Together"}], "]"}], 
      "&"}], "[", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"Series", "[", 
        RowBox[{
         RowBox[{
          RowBox[{
           FractionBox[
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", 
               FractionBox[
                RowBox[{"(", 
                 RowBox[{"Kr1", "+", 
                  RowBox[{
                   SuperscriptBox["v", "2"], "Kr2"}]}], ")"}], 
                SqrtBox[
                 RowBox[{"1", "-", 
                  FractionBox[
                   RowBox[{"4", 
                    SuperscriptBox["g", "2"]}], 
                   SuperscriptBox["v", "2"]]}]]]}], "+", 
              RowBox[{"2", "\[ImaginaryI]", " ", 
               SubscriptBox["v", "0"], " ", "v"}]}], ")"}], 
            RowBox[{
             SuperscriptBox["Q", "-"], 
             SuperscriptBox["Q", "+"]}]], "/.", "subsuplexpand"}], "/.", 
          RowBox[{"leadweak", "[", "4", "]"}]}], ",", 
         RowBox[{"{", 
          RowBox[{"g", ",", "0", ",", "6"}], "}"}]}], "]"}], "/.", 
       RowBox[{"v", "\[Rule]", "u"}]}], ")"}], "]"}]}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"iii", "=", "0"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"While", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"Not", "[", 
      RowBox[{"FreeQ", "[", 
       RowBox[{"tmp1", ",", 
        SuperscriptBox["Q0", "+"]}], "]"}], "]"}], "&&", 
     RowBox[{"iii", "<", "10"}]}], ",", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"tmp1", "=", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{"tmp1", "/.", 
         RowBox[{
          RowBox[{
           SuperscriptBox[
            RowBox[{"(", 
             SuperscriptBox["Q0", "-"], ")"}], "a_"], 
           SuperscriptBox[
            RowBox[{"(", 
             SuperscriptBox["Q0", "+"], ")"}], "b_."], "c_"}], 
          "\[RuleDelayed]", 
          RowBox[{"If", "[", 
           RowBox[{
            RowBox[{
             RowBox[{
              RowBox[{"-", "b"}], "-", "iii"}], ">", "0"}], ",", 
            RowBox[{
             SuperscriptBox[
              RowBox[{"Q0$", "[", 
               RowBox[{"-", "1"}], "]"}], "a"], 
             SuperscriptBox[
              RowBox[{"Q0$", "[", 
               RowBox[{"+", "1"}], "]"}], 
              RowBox[{"-", "iii"}]], " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"PolynomialQuotient", "[", 
                RowBox[{"c", ",", 
                 RowBox[{
                  SuperscriptBox[
                   RowBox[{"Q0$", "[", "1", "]"}], 
                   RowBox[{
                    RowBox[{"-", "b"}], "-", "iii"}]], "/.", "subQ0"}], ",", 
                 "u"}], "]"}], "+", 
               RowBox[{
                RowBox[{"PolynomialRemainder", "[", 
                 RowBox[{"c", ",", 
                  RowBox[{
                   SuperscriptBox[
                    RowBox[{"Q0$", "[", "1", "]"}], 
                    RowBox[{
                    RowBox[{"-", "b"}], "-", "iii"}]], "/.", "subQ0"}], ",", 
                  "u"}], "]"}], 
                SuperscriptBox[
                 RowBox[{"Q0$", "[", "1", "]"}], 
                 RowBox[{"b", "+", "iii"}]]}]}], ")"}]}], ",", 
            RowBox[{
             SuperscriptBox[
              RowBox[{"(", 
               SuperscriptBox["Q0", "-"], ")"}], "a"], 
             SuperscriptBox[
              RowBox[{"(", 
               SuperscriptBox["Q0", "+"], ")"}], "b"], "c"}]}], "]"}]}]}], 
        ")"}], "//", "tmpfun"}]}], ";", 
     RowBox[{"iii", "++"}]}]}], "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"{", 
  RowBox[{"iii", ",", 
   RowBox[{"FreeQ", "[", 
    RowBox[{"tmp1", ",", 
     RowBox[{"Q0$", "[", "1", "]"}]}], "]"}], ",", 
   RowBox[{
    RowBox[{
     RowBox[{"tmp1", "-", "tmp"}], "/.", "subQ0"}], "//", "Simplify"}]}], 
  "}"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"iii", "=."}], ";"}]}], "Input",
 CellChangeTimes->{{3.555963182435052*^9, 3.555963206662023*^9}, {
  3.555963275827456*^9, 3.5559634056935596`*^9}, {3.555963436440617*^9, 
  3.5559635316246147`*^9}, {3.5559636152318487`*^9, 3.555964040349286*^9}, {
  3.555964073294342*^9, 3.555964075326398*^9}, {3.555964189142824*^9, 
  3.555964193992112*^9}, {3.5559642994958973`*^9, 3.555964360849441*^9}, {
  3.555964394165148*^9, 3.555964440595708*^9}, {3.5559644874424553`*^9, 
  3.5559645144559593`*^9}, {3.5559646275998287`*^9, 3.5559646409336033`*^9}, {
  3.5559646944367113`*^9, 3.555964700856289*^9}, {3.555964772628791*^9, 
  3.55596484417798*^9}, {3.5559648807618103`*^9, 3.5559648808996067`*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"4", ",", "True", ",", "0"}], "}"}]], "Output",
 CellChangeTimes->{{3.555963910443857*^9, 3.5559639423488398`*^9}, 
   3.55596397759622*^9, {3.5559640079099293`*^9, 3.555964041371348*^9}, 
   3.555964200299213*^9, 3.555964243894903*^9, 3.555964846765277*^9, 
   3.5559648927285*^9, {3.560338077393179*^9, 3.560338099937345*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData["tmp1"], "Input",
 CellChangeTimes->{{3.5559640237955227`*^9, 3.555964024135602*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   SuperscriptBox["g", "2"], " ", 
   RowBox[{"(", 
    RowBox[{
     FractionBox["4", 
      RowBox[{"3", " ", 
       SqrtBox["3"], " ", 
       SuperscriptBox[
        RowBox[{"(", 
         SuperscriptBox[
          StyleBox["Q0",
           FontColor->RGBColor[{
              Rational[1, 2], 
              Rational[1, 2], 0}]], "-"], ")"}], "2"]}]], "+", 
     FractionBox[
      RowBox[{"2", " ", 
       RowBox[{"(", 
        RowBox[{"1", "+", 
         RowBox[{"3", " ", "\[ImaginaryI]", " ", "u"}], "+", 
         SuperscriptBox["u", "2"]}], ")"}]}], 
      RowBox[{
       SqrtBox["3"], " ", 
       SuperscriptBox["u", "2"], " ", 
       SuperscriptBox[
        StyleBox["Q0",
         FontColor->RGBColor[{
            Rational[1, 2], 
            Rational[1, 2], 0}]], "-"]}]]}], ")"}]}], "+", 
  RowBox[{
   SuperscriptBox["g", "4"], " ", 
   RowBox[{"(", 
    RowBox[{
     FractionBox["16", 
      RowBox[{"9", " ", 
       SqrtBox["3"], " ", 
       SuperscriptBox[
        RowBox[{"(", 
         SuperscriptBox[
          StyleBox["Q0",
           FontColor->RGBColor[{
              Rational[1, 2], 
              Rational[1, 2], 0}]], "-"], ")"}], "3"]}]], "+", 
     FractionBox[
      RowBox[{"2", " ", 
       RowBox[{"(", 
        RowBox[{"4", "+", 
         RowBox[{"12", " ", "\[ImaginaryI]", " ", "u"}], "+", 
         RowBox[{"7", " ", 
          SuperscriptBox["u", "2"]}]}], ")"}]}], 
      RowBox[{"3", " ", 
       SqrtBox["3"], " ", 
       SuperscriptBox["u", "2"], " ", 
       SuperscriptBox[
        RowBox[{"(", 
         SuperscriptBox[
          StyleBox["Q0",
           FontColor->RGBColor[{
              Rational[1, 2], 
              Rational[1, 2], 0}]], "-"], ")"}], "2"]}]], "-", 
     FractionBox[
      RowBox[{"2", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", "3"}], "-", 
         RowBox[{"9", " ", "\[ImaginaryI]", " ", "u"}], "+", 
         RowBox[{"7", " ", 
          SuperscriptBox["u", "2"]}], "+", 
         RowBox[{"6", " ", "\[ImaginaryI]", " ", 
          SuperscriptBox["u", "3"]}], "+", 
         RowBox[{"4", " ", 
          SuperscriptBox["u", "4"]}]}], ")"}]}], 
      RowBox[{
       SqrtBox["3"], " ", 
       SuperscriptBox["u", "4"], " ", 
       SuperscriptBox[
        StyleBox["Q0",
         FontColor->RGBColor[{
            Rational[1, 2], 
            Rational[1, 2], 0}]], "-"]}]]}], ")"}]}], "+", 
  FractionBox["1", 
   RowBox[{
    SqrtBox["3"], " ", 
    SuperscriptBox[
     StyleBox["Q0",
      FontColor->RGBColor[{
         Rational[1, 2], 
         Rational[1, 2], 0}]], "-"]}]], "+", 
  RowBox[{
   SuperscriptBox["g", "6"], " ", 
   RowBox[{"(", 
    RowBox[{
     FractionBox["64", 
      RowBox[{"27", " ", 
       SqrtBox["3"], " ", 
       SuperscriptBox[
        RowBox[{"(", 
         SuperscriptBox[
          StyleBox["Q0",
           FontColor->RGBColor[{
              Rational[1, 2], 
              Rational[1, 2], 0}]], "-"], ")"}], "4"]}]], "+", 
     FractionBox[
      RowBox[{"16", " ", 
       RowBox[{"(", 
        RowBox[{"2", "+", 
         RowBox[{"6", " ", "\[ImaginaryI]", " ", "u"}], "+", 
         RowBox[{"5", " ", 
          SuperscriptBox["u", "2"]}]}], ")"}]}], 
      RowBox[{"9", " ", 
       SqrtBox["3"], " ", 
       SuperscriptBox["u", "2"], " ", 
       SuperscriptBox[
        RowBox[{"(", 
         SuperscriptBox[
          StyleBox["Q0",
           FontColor->RGBColor[{
              Rational[1, 2], 
              Rational[1, 2], 0}]], "-"], ")"}], "3"]}]], "+", 
     FractionBox[
      RowBox[{"4", " ", 
       RowBox[{"(", 
        RowBox[{"6", "+", 
         RowBox[{"18", " ", "\[ImaginaryI]", " ", "u"}], "-", 
         RowBox[{"11", " ", 
          SuperscriptBox["u", "2"]}], "-", 
         RowBox[{"3", " ", "\[ImaginaryI]", " ", 
          SuperscriptBox["u", "3"]}], "-", 
         RowBox[{"11", " ", 
          SuperscriptBox["u", "4"]}], "+", 
         RowBox[{"6", " ", 
          SuperscriptBox["u", "4"], " ", 
          SubscriptBox[
           StyleBox["\[Zeta]",
            FontWeight->Bold,
            FontColor->GrayLevel[0.4]], "3"]}]}], ")"}]}], 
      RowBox[{"3", " ", 
       SqrtBox["3"], " ", 
       SuperscriptBox["u", "4"], " ", 
       SuperscriptBox[
        RowBox[{"(", 
         SuperscriptBox[
          StyleBox["Q0",
           FontColor->RGBColor[{
              Rational[1, 2], 
              Rational[1, 2], 0}]], "-"], ")"}], "2"]}]], "+", 
     FractionBox[
      RowBox[{"4", " ", 
       RowBox[{"(", 
        RowBox[{"5", "+", 
         RowBox[{"15", " ", "\[ImaginaryI]", " ", "u"}], "-", 
         RowBox[{"15", " ", 
          SuperscriptBox["u", "2"]}], "-", 
         RowBox[{"18", " ", "\[ImaginaryI]", " ", 
          SuperscriptBox["u", "3"]}], "+", 
         RowBox[{"23", " ", 
          SuperscriptBox["u", "4"]}], "+", 
         RowBox[{"18", " ", "\[ImaginaryI]", " ", 
          SuperscriptBox["u", "5"]}], "+", 
         RowBox[{"10", " ", 
          SuperscriptBox["u", "6"]}], "+", 
         RowBox[{"12", " ", 
          SuperscriptBox["u", "6"], " ", 
          SubscriptBox[
           StyleBox["\[Zeta]",
            FontWeight->Bold,
            FontColor->GrayLevel[0.4]], "3"]}]}], ")"}]}], 
      RowBox[{
       SqrtBox["3"], " ", 
       SuperscriptBox["u", "6"], " ", 
       SuperscriptBox[
        StyleBox["Q0",
         FontColor->RGBColor[{
            Rational[1, 2], 
            Rational[1, 2], 0}]], "-"]}]]}], ")"}]}]}]], "Output",
 CellChangeTimes->{3.5559642455462313`*^9, 3.555964848892762*^9, 
  3.555964895428759*^9, 3.560338104191368*^9}]
}, Open  ]],

Cell[TextData[{
 "Note a remarkable cancellation of poles from ",
 Cell[BoxData[
  FormBox[
   SuperscriptBox["Q0", "+"], TraditionalForm]]]
}], "Text",
 CellChangeTimes->{{3.5559649124033003`*^9, 3.5559649249346313`*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"contH", "=", 
  RowBox[{"Collect", "[", 
   RowBox[{
    RowBox[{"Series", "[", 
     RowBox[{
      RowBox[{"tmp1", " ", 
       SuperscriptBox["g", "8"], 
       RowBox[{"(", 
        RowBox[{
         SubscriptBox["H", "lead"], "+", 
         RowBox[{
          SuperscriptBox["g", "2"], 
          SubscriptBox["H", "sublead"]}], "+", 
         RowBox[{
          SuperscriptBox["g", "4"], 
          SubscriptBox["H", "sublead2"]}], "+", 
         RowBox[{
          SuperscriptBox["g", "6"], 
          SubscriptBox["H", "sublead3"]}]}], ")"}]}], ",", 
      RowBox[{"{", 
       RowBox[{"g", ",", "0", ",", "14"}], "}"}]}], "]"}], ",", "g", ",", 
    RowBox[{
     RowBox[{"\[DoubleStruckCapitalC]", "[", 
      RowBox[{"Collect", "[", 
       RowBox[{"#", ",", 
        RowBox[{"{", 
         RowBox[{
          SqrtBox["3"], ",", 
          SubscriptBox["H", "_"], ",", 
          SuperscriptBox["Q0", "-"]}], "}"}], ",", "Together"}], "]"}], "]"}],
      "&"}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.5559649763245068`*^9, 3.555965116940881*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   SuperscriptBox["g", "8"], " ", 
   RowBox[{"\[DoubleStruckCapitalC]", "[", 
    FractionBox[
     SubscriptBox[
      StyleBox["H",
       FontColor->RGBColor[0.54, 0.35, 0.15]], "lead"], 
     RowBox[{
      SqrtBox["3"], " ", 
      SuperscriptBox[
       StyleBox["Q0",
        FontColor->RGBColor[{
           Rational[1, 2], 
           Rational[1, 2], 0}]], "-"]}]], "]"}]}], "+", 
  RowBox[{
   SuperscriptBox["g", "10"], " ", 
   RowBox[{"\[DoubleStruckCapitalC]", "[", 
    RowBox[{
     SqrtBox["3"], " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          FractionBox["4", 
           RowBox[{"9", " ", 
            SuperscriptBox[
             RowBox[{"(", 
              SuperscriptBox[
               StyleBox["Q0",
                FontColor->RGBColor[{
                   Rational[1, 2], 
                   Rational[1, 2], 0}]], "-"], ")"}], "2"]}]], "+", 
          FractionBox[
           RowBox[{"2", " ", 
            RowBox[{"(", 
             RowBox[{"1", "+", 
              RowBox[{"3", " ", "\[ImaginaryI]", " ", "u"}], "+", 
              SuperscriptBox["u", "2"]}], ")"}]}], 
           RowBox[{"3", " ", 
            SuperscriptBox["u", "2"], " ", 
            SuperscriptBox[
             StyleBox["Q0",
              FontColor->RGBColor[{
                 Rational[1, 2], 
                 Rational[1, 2], 0}]], "-"]}]]}], ")"}], " ", 
        SubscriptBox[
         StyleBox["H",
          FontColor->RGBColor[0.54, 0.35, 0.15]], "lead"]}], "+", 
       FractionBox[
        SubscriptBox[
         StyleBox["H",
          FontColor->RGBColor[0.54, 0.35, 0.15]], "sublead"], 
        RowBox[{"3", " ", 
         SuperscriptBox[
          StyleBox["Q0",
           FontColor->RGBColor[{
              Rational[1, 2], 
              Rational[1, 2], 0}]], "-"]}]]}], ")"}]}], "]"}]}], "+", 
  RowBox[{
   SuperscriptBox["g", "12"], " ", 
   RowBox[{"\[DoubleStruckCapitalC]", "[", 
    RowBox[{
     SqrtBox["3"], " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          FractionBox["16", 
           RowBox[{"27", " ", 
            SuperscriptBox[
             RowBox[{"(", 
              SuperscriptBox[
               StyleBox["Q0",
                FontColor->RGBColor[{
                   Rational[1, 2], 
                   Rational[1, 2], 0}]], "-"], ")"}], "3"]}]], "+", 
          FractionBox[
           RowBox[{"2", " ", 
            RowBox[{"(", 
             RowBox[{"4", "+", 
              RowBox[{"12", " ", "\[ImaginaryI]", " ", "u"}], "+", 
              RowBox[{"7", " ", 
               SuperscriptBox["u", "2"]}]}], ")"}]}], 
           RowBox[{"9", " ", 
            SuperscriptBox["u", "2"], " ", 
            SuperscriptBox[
             RowBox[{"(", 
              SuperscriptBox[
               StyleBox["Q0",
                FontColor->RGBColor[{
                   Rational[1, 2], 
                   Rational[1, 2], 0}]], "-"], ")"}], "2"]}]], "-", 
          FractionBox[
           RowBox[{"2", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "3"}], "-", 
              RowBox[{"9", " ", "\[ImaginaryI]", " ", "u"}], "+", 
              RowBox[{"7", " ", 
               SuperscriptBox["u", "2"]}], "+", 
              RowBox[{"6", " ", "\[ImaginaryI]", " ", 
               SuperscriptBox["u", "3"]}], "+", 
              RowBox[{"4", " ", 
               SuperscriptBox["u", "4"]}]}], ")"}]}], 
           RowBox[{"3", " ", 
            SuperscriptBox["u", "4"], " ", 
            SuperscriptBox[
             StyleBox["Q0",
              FontColor->RGBColor[{
                 Rational[1, 2], 
                 Rational[1, 2], 0}]], "-"]}]]}], ")"}], " ", 
        SubscriptBox[
         StyleBox["H",
          FontColor->RGBColor[0.54, 0.35, 0.15]], "lead"]}], "+", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          FractionBox["4", 
           RowBox[{"9", " ", 
            SuperscriptBox[
             RowBox[{"(", 
              SuperscriptBox[
               StyleBox["Q0",
                FontColor->RGBColor[{
                   Rational[1, 2], 
                   Rational[1, 2], 0}]], "-"], ")"}], "2"]}]], "+", 
          FractionBox[
           RowBox[{"2", " ", 
            RowBox[{"(", 
             RowBox[{"1", "+", 
              RowBox[{"3", " ", "\[ImaginaryI]", " ", "u"}], "+", 
              SuperscriptBox["u", "2"]}], ")"}]}], 
           RowBox[{"3", " ", 
            SuperscriptBox["u", "2"], " ", 
            SuperscriptBox[
             StyleBox["Q0",
              FontColor->RGBColor[{
                 Rational[1, 2], 
                 Rational[1, 2], 0}]], "-"]}]]}], ")"}], " ", 
        SubscriptBox[
         StyleBox["H",
          FontColor->RGBColor[0.54, 0.35, 0.15]], "sublead"]}], "+", 
       FractionBox[
        SubscriptBox[
         StyleBox["H",
          FontColor->RGBColor[0.54, 0.35, 0.15]], "sublead2"], 
        RowBox[{"3", " ", 
         SuperscriptBox[
          StyleBox["Q0",
           FontColor->RGBColor[{
              Rational[1, 2], 
              Rational[1, 2], 0}]], "-"]}]]}], ")"}]}], "]"}]}], "+", 
  RowBox[{
   SuperscriptBox["g", "14"], " ", 
   RowBox[{"\[DoubleStruckCapitalC]", "[", 
    RowBox[{
     SqrtBox["3"], " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          FractionBox["16", 
           RowBox[{"27", " ", 
            SuperscriptBox[
             RowBox[{"(", 
              SuperscriptBox[
               StyleBox["Q0",
                FontColor->RGBColor[{
                   Rational[1, 2], 
                   Rational[1, 2], 0}]], "-"], ")"}], "3"]}]], "+", 
          FractionBox[
           RowBox[{"2", " ", 
            RowBox[{"(", 
             RowBox[{"4", "+", 
              RowBox[{"12", " ", "\[ImaginaryI]", " ", "u"}], "+", 
              RowBox[{"7", " ", 
               SuperscriptBox["u", "2"]}]}], ")"}]}], 
           RowBox[{"9", " ", 
            SuperscriptBox["u", "2"], " ", 
            SuperscriptBox[
             RowBox[{"(", 
              SuperscriptBox[
               StyleBox["Q0",
                FontColor->RGBColor[{
                   Rational[1, 2], 
                   Rational[1, 2], 0}]], "-"], ")"}], "2"]}]], "-", 
          FractionBox[
           RowBox[{"2", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "3"}], "-", 
              RowBox[{"9", " ", "\[ImaginaryI]", " ", "u"}], "+", 
              RowBox[{"7", " ", 
               SuperscriptBox["u", "2"]}], "+", 
              RowBox[{"6", " ", "\[ImaginaryI]", " ", 
               SuperscriptBox["u", "3"]}], "+", 
              RowBox[{"4", " ", 
               SuperscriptBox["u", "4"]}]}], ")"}]}], 
           RowBox[{"3", " ", 
            SuperscriptBox["u", "4"], " ", 
            SuperscriptBox[
             StyleBox["Q0",
              FontColor->RGBColor[{
                 Rational[1, 2], 
                 Rational[1, 2], 0}]], "-"]}]]}], ")"}], " ", 
        SubscriptBox[
         StyleBox["H",
          FontColor->RGBColor[0.54, 0.35, 0.15]], "sublead"]}], "+", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          FractionBox["4", 
           RowBox[{"9", " ", 
            SuperscriptBox[
             RowBox[{"(", 
              SuperscriptBox[
               StyleBox["Q0",
                FontColor->RGBColor[{
                   Rational[1, 2], 
                   Rational[1, 2], 0}]], "-"], ")"}], "2"]}]], "+", 
          FractionBox[
           RowBox[{"2", " ", 
            RowBox[{"(", 
             RowBox[{"1", "+", 
              RowBox[{"3", " ", "\[ImaginaryI]", " ", "u"}], "+", 
              SuperscriptBox["u", "2"]}], ")"}]}], 
           RowBox[{"3", " ", 
            SuperscriptBox["u", "2"], " ", 
            SuperscriptBox[
             StyleBox["Q0",
              FontColor->RGBColor[{
                 Rational[1, 2], 
                 Rational[1, 2], 0}]], "-"]}]]}], ")"}], " ", 
        SubscriptBox[
         StyleBox["H",
          FontColor->RGBColor[0.54, 0.35, 0.15]], "sublead2"]}], "+", 
       FractionBox[
        SubscriptBox[
         StyleBox["H",
          FontColor->RGBColor[0.54, 0.35, 0.15]], "sublead3"], 
        RowBox[{"3", " ", 
         SuperscriptBox[
          StyleBox["Q0",
           FontColor->RGBColor[{
              Rational[1, 2], 
              Rational[1, 2], 0}]], "-"]}]], "+", 
       RowBox[{
        SubscriptBox[
         StyleBox["H",
          FontColor->RGBColor[0.54, 0.35, 0.15]], "lead"], " ", 
        RowBox[{"(", 
         RowBox[{
          FractionBox["64", 
           RowBox[{"81", " ", 
            SuperscriptBox[
             RowBox[{"(", 
              SuperscriptBox[
               StyleBox["Q0",
                FontColor->RGBColor[{
                   Rational[1, 2], 
                   Rational[1, 2], 0}]], "-"], ")"}], "4"]}]], "+", 
          FractionBox[
           RowBox[{"16", " ", 
            RowBox[{"(", 
             RowBox[{"2", "+", 
              RowBox[{"6", " ", "\[ImaginaryI]", " ", "u"}], "+", 
              RowBox[{"5", " ", 
               SuperscriptBox["u", "2"]}]}], ")"}]}], 
           RowBox[{"27", " ", 
            SuperscriptBox["u", "2"], " ", 
            SuperscriptBox[
             RowBox[{"(", 
              SuperscriptBox[
               StyleBox["Q0",
                FontColor->RGBColor[{
                   Rational[1, 2], 
                   Rational[1, 2], 0}]], "-"], ")"}], "3"]}]], "+", 
          FractionBox[
           RowBox[{"4", " ", 
            RowBox[{"(", 
             RowBox[{"6", "+", 
              RowBox[{"18", " ", "\[ImaginaryI]", " ", "u"}], "-", 
              RowBox[{"11", " ", 
               SuperscriptBox["u", "2"]}], "-", 
              RowBox[{"3", " ", "\[ImaginaryI]", " ", 
               SuperscriptBox["u", "3"]}], "-", 
              RowBox[{"11", " ", 
               SuperscriptBox["u", "4"]}], "+", 
              RowBox[{"6", " ", 
               SuperscriptBox["u", "4"], " ", 
               SubscriptBox[
                StyleBox["\[Zeta]",
                 FontWeight->Bold,
                 FontColor->GrayLevel[0.4]], "3"]}]}], ")"}]}], 
           RowBox[{"9", " ", 
            SuperscriptBox["u", "4"], " ", 
            SuperscriptBox[
             RowBox[{"(", 
              SuperscriptBox[
               StyleBox["Q0",
                FontColor->RGBColor[{
                   Rational[1, 2], 
                   Rational[1, 2], 0}]], "-"], ")"}], "2"]}]], "+", 
          FractionBox[
           RowBox[{"4", " ", 
            RowBox[{"(", 
             RowBox[{"5", "+", 
              RowBox[{"15", " ", "\[ImaginaryI]", " ", "u"}], "-", 
              RowBox[{"15", " ", 
               SuperscriptBox["u", "2"]}], "-", 
              RowBox[{"18", " ", "\[ImaginaryI]", " ", 
               SuperscriptBox["u", "3"]}], "+", 
              RowBox[{"23", " ", 
               SuperscriptBox["u", "4"]}], "+", 
              RowBox[{"18", " ", "\[ImaginaryI]", " ", 
               SuperscriptBox["u", "5"]}], "+", 
              RowBox[{"10", " ", 
               SuperscriptBox["u", "6"]}], "+", 
              RowBox[{"12", " ", 
               SuperscriptBox["u", "6"], " ", 
               SubscriptBox[
                StyleBox["\[Zeta]",
                 FontWeight->Bold,
                 FontColor->GrayLevel[0.4]], "3"]}]}], ")"}]}], 
           RowBox[{"3", " ", 
            SuperscriptBox["u", "6"], " ", 
            SuperscriptBox[
             StyleBox["Q0",
              FontColor->RGBColor[{
                 Rational[1, 2], 
                 Rational[1, 2], 0}]], "-"]}]]}], ")"}]}]}], ")"}]}], 
    "]"}]}]}]], "Output",
 CellChangeTimes->{{3.5559650539591827`*^9, 3.5559650650275793`*^9}, 
   3.555965117782835*^9, 3.560338106202137*^9}]
}, Open  ]],

Cell[TextData[Cell[BoxData[
 RowBox[{"\[DoubleStruckCapitalC]", "[", 
  RowBox[{
   FractionBox[
    RowBox[{
     RowBox[{"-", "4"}], "\[ImaginaryI]", " ", 
     SubscriptBox["v", "0"], "v"}], 
    RowBox[{
     SuperscriptBox[
      StyleBox["Q",
       FontColor->RGBColor[0.8, 0, 0]], "+"], " ", 
     SuperscriptBox[
      StyleBox["Q",
       FontColor->RGBColor[0.8, 0, 0]], "-"]}]], 
   RowBox[{"Log", "[", 
    RowBox[{
     RowBox[{"(", 
      FractionBox[
       RowBox[{" ", 
        SuperscriptBox[
         StyleBox["\[ScriptCapitalT]",
          FontColor->RGBColor[1, 0, 0]], "+"], " "}], 
       SuperscriptBox[
        StyleBox["\[GothicCapitalT]",
         FontColor->RGBColor[0.54, 0.35, 0.15]], "+"]], ")"}], "/", 
     SubscriptBox[
      RowBox[{"(", 
       FractionBox[
        RowBox[{" ", 
         SuperscriptBox[
          StyleBox["\[ScriptCapitalT]",
           FontColor->RGBColor[1, 0, 0]], "+"], " "}], 
        SuperscriptBox[
         StyleBox["\[GothicCapitalT]",
          FontColor->RGBColor[0.54, 0.35, 0.15]], "+"]], ")"}], "asym"]}], 
    "]"}]}], "]"}]],
 CellChangeTimes->{{3.553775524449216*^9, 3.553775575150013*^9}, {
   3.553775653575102*^9, 3.553775669355048*^9}, 3.553828617589128*^9, {
   3.553835479511333*^9, 3.553835512876645*^9}}]], "Subsubsection",
 CellChangeTimes->{3.553836986906322*^9}]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  RowBox[{"\[DoubleStruckCapitalC]", "[", 
   RowBox[{
    FractionBox[
     RowBox[{
      RowBox[{"-", "4"}], "\[ImaginaryI]", " ", 
      SubscriptBox["v", "0"], "u"}], 
     RowBox[{
      SuperscriptBox[
       StyleBox["Q",
        FontColor->RGBColor[0.8, 0, 0]], "+"], " ", 
      SuperscriptBox[
       StyleBox["Q",
        FontColor->RGBColor[0.8, 0, 0]], "-"]}]], 
    RowBox[{"Log", "[", 
     RowBox[{
      RowBox[{"(", 
       FractionBox[
        RowBox[{" ", 
         SuperscriptBox[
          StyleBox["\[ScriptCapitalT]",
           FontColor->RGBColor[1, 0, 0]], "+"], " "}], 
        SuperscriptBox[
         StyleBox["\[GothicCapitalT]",
          FontColor->RGBColor[0.54, 0.35, 0.15]], "+"]], ")"}], "/", 
      SubscriptBox[
       RowBox[{"(", 
        FractionBox[
         RowBox[{" ", 
          SuperscriptBox[
           StyleBox["\[ScriptCapitalT]",
            FontColor->RGBColor[1, 0, 0]], "+"], " "}], 
         SuperscriptBox[
          StyleBox["\[GothicCapitalT]",
           FontColor->RGBColor[0.54, 0.35, 0.15]], "+"]], ")"}], "asym"]}], 
     "]"}]}], "]"}]],
  CellChangeTimes->{{3.553775524449216*^9, 3.553775575150013*^9}, {
    3.553775653575102*^9, 3.553775669355048*^9}, 3.553828617589128*^9, {
    3.553835479511333*^9, 3.553835512876645*^9}}],
 "= cont\[Rho]\[Rho]2+contW1-contW0"
}], "Subsection",
 CellChangeTimes->{
  3.5538369950294867`*^9, {3.553837137559949*^9, 3.553837137560096*^9}, {
   3.553844732107822*^9, 3.553844768594017*^9}, {3.555968559439457*^9, 
   3.555968560079029*^9}, 3.555969086037328*^9, {3.55597077298139*^9, 
   3.555970777292686*^9}}],

Cell[CellGroupData[{

Cell[TextData[{
 "(Correction from ",
 Cell[BoxData[
  FormBox[
   RowBox[{
    RowBox[{
     RowBox[{"\[Delta]\[Rho]", " ", "and", " ", "\[Delta]\[Rho]2"}], ")"}], 
    "=", " ", "cont\[Rho]\[Rho]2"}], TraditionalForm]]]
}], "Subsubsection",
 CellChangeTimes->{{3.5538370419675827`*^9, 3.553837048061277*^9}, {
  3.5538381110460463`*^9, 3.5538381271797953`*^9}, {3.555966410527584*^9, 
  3.555966413859695*^9}, {3.555966477445382*^9, 3.555966477445545*^9}, {
  3.555966686543717*^9, 3.555966689158783*^9}, {3.5559685546510897`*^9, 
  3.555968554651268*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"tmp1", "=", 
   RowBox[{"Collect", "[", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{"Series", "[", 
        RowBox[{
         RowBox[{
          RowBox[{
           RowBox[{
            RowBox[{
             FractionBox["1", 
              SuperscriptBox[
               StyleBox["\[ScriptCapitalT]",
                FontColor->RGBColor[1, 0, 0]], "+"]], "/.", "largevolume"}], "/.", 
            RowBox[{
             RowBox[{"x", "[", 
              RowBox[{"a_:", "0"}], "]"}], "\[RuleDelayed]", 
             RowBox[{"If", "[", 
              RowBox[{
               RowBox[{"a", ">", "0"}], ",", 
               RowBox[{"x$h", "[", "a", "]"}], ",", 
               FractionBox["1", 
                RowBox[{"x$h", "[", "a", "]"}]]}], "]"}]}]}], "/.", 
           "subJuk"}], "/.", 
          RowBox[{"leadweak", "[", "4", "]"}]}], ",", 
         RowBox[{"{", 
          RowBox[{"g", ",", "0", ",", "6"}], "}"}]}], "]"}], "//", 
       "Simplify"}], ")"}], ",", "g", ",", "Simplify"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"tmp2", "=", 
   RowBox[{"Collect", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"Series", "[", 
         RowBox[{
          RowBox[{
           RowBox[{
            RowBox[{
             RowBox[{
              FractionBox["1", 
               SuperscriptBox["\[GothicCapitalT]", "+"]], "/.", 
              "largevolume"}], "/.", 
             RowBox[{
              RowBox[{"x", "[", 
               RowBox[{"a_:", "0"}], "]"}], "\[RuleDelayed]", 
              RowBox[{"If", "[", 
               RowBox[{
                RowBox[{"a", ">", "0"}], ",", 
                RowBox[{"x$h", "[", "a", "]"}], ",", 
                FractionBox["1", 
                 RowBox[{"x$h", "[", "a", "]"}]]}], "]"}]}]}], "/.", 
            "subJuk"}], "/.", 
           RowBox[{"leadweak", "[", "4", "]"}]}], ",", 
          RowBox[{"{", 
           RowBox[{"g", ",", "0", ",", "6"}], "}"}]}], "]"}], "//", 
        "Simplify"}], ")"}], "/.", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{
         RowBox[{"-", "1"}], "+", 
         RowBox[{"3", " ", "\[ImaginaryI]", " ", "u"}], "+", 
         RowBox[{"3", " ", 
          SuperscriptBox["u", "2"]}]}], "\[Rule]", " ", 
        RowBox[{"3", 
         SuperscriptBox["Q0", "+"]}]}], "}"}]}], ",", "g", ",", "Simplify"}], 
    "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"tmp3", "=", 
   RowBox[{"Series", "[", 
    RowBox[{
     RowBox[{
      FractionBox[
       RowBox[{
        RowBox[{"-", "4"}], "\[ImaginaryI]", " ", 
        SubscriptBox["v", "0"], "u"}], 
       RowBox[{
        SuperscriptBox[
         StyleBox["Q",
          FontColor->RGBColor[0.8, 0, 0]], "+"], " ", 
        SuperscriptBox[
         StyleBox["Q",
          FontColor->RGBColor[0.8, 0, 0]], "-"]}]], "/.", 
      RowBox[{"leadweak", "[", "4", "]"}]}], ",", 
     RowBox[{"{", 
      RowBox[{"g", ",", "0", ",", "6"}], "}"}]}], "]"}]}], ";"}]}], "Input",
 CellChangeTimes->{{3.5559587428038893`*^9, 3.5559589394420424`*^9}, 
   3.555959218881966*^9, {3.5559596406194773`*^9, 3.555959651218796*^9}, {
   3.55596138138239*^9, 3.5559613828465767`*^9}, {3.555966588882784*^9, 
   3.555966644814075*^9}, {3.5559666774034977`*^9, 3.555966731944824*^9}, {
   3.555966769840405*^9, 3.5559668541229277`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"\[Delta]\[Rho]2sb3", "=", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{"Solve", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"eqnT11ZeroAtBetheroot", "[", 
           RowBox[{"[", "4", "]"}], "]"}], "\[Equal]", "0"}], ",", 
         RowBox[{"M", "[", 
          SubscriptBox["\[Delta]\[Rho]2", "sublead3"], "]"}]}], "]"}], "[", 
       RowBox[{"[", "1", "]"}], "]"}], "[", 
      RowBox[{"[", 
       RowBox[{"1", ",", "2"}], "]"}], "]"}], "/.", "sub\[Rho]Ansatz"}], "/.", 
    RowBox[{"(", 
     RowBox[{"Rule", "@@@", 
      RowBox[{"Cases", "[", 
       RowBox[{
        RowBox[{"solut\[Rho]s", "/.", 
         RowBox[{"Rule", "\[Rule]", "List"}]}], ",", 
        RowBox[{"List", "[", 
         RowBox[{"a_", ",", "0"}], "]"}]}], "]"}]}], ")"}]}]}], 
  ";"}]], "Input",
 CellChangeTimes->{{3.555960101853923*^9, 3.555960127180409*^9}, {
   3.555960171093954*^9, 3.5559601995276327`*^9}, 3.555960250725173*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{"tmp4", "=", 
   RowBox[{"Collect", "[", 
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{
             RowBox[{"Series", "[", 
              RowBox[{
               RowBox[{"(", 
                RowBox[{
                 RowBox[{"-", 
                  FractionBox[
                   RowBox[{"2", "w", " ", "g"}], 
                   RowBox[{"2", " ", "\[ImaginaryI]"}]]}], 
                 RowBox[{"(", 
                  RowBox[{
                   FractionBox["1", 
                    RowBox[{"u", "+", "\[ImaginaryI]", "-", 
                    RowBox[{"2", "g", " ", "w"}]}]], "-", 
                   FractionBox["1", 
                    RowBox[{"u", "-", 
                    RowBox[{"2", "g", " ", "w"}]}]]}], ")"}], 
                 SuperscriptBox["g", "9"], 
                 RowBox[{"(", 
                  RowBox[{
                   SubscriptBox["\[Delta]\[Rho]", "lead"], "+", 
                   RowBox[{
                    SuperscriptBox["g", "2"], 
                    SubscriptBox["\[Delta]\[Rho]", "sublead"]}], "+", 
                   RowBox[{
                    SuperscriptBox["g", "4"], 
                    SubscriptBox["\[Delta]\[Rho]", "sublead2"]}]}], ")"}]}], 
                ")"}], ",", 
               RowBox[{"{", 
                RowBox[{"g", ",", "0", ",", "14"}], "}"}]}], "]"}], "//", 
             "Normal"}], "//", "Expand"}], ")"}], "/.", 
          RowBox[{
           SuperscriptBox["w", 
            RowBox[{"a_", "/;", 
             RowBox[{"EvenQ", "[", "a", "]"}]}]], "\[Rule]", "0"}]}], "/.", 
         RowBox[{
          RowBox[{
           SuperscriptBox["w", "a_."], 
           SubscriptBox["\[Delta]\[Rho]", "b_"]}], "\[RuleDelayed]", 
          RowBox[{"M", "[", 
           RowBox[{
            SuperscriptBox["w", 
             RowBox[{"a", "-", "1"}]], 
            SubscriptBox["\[Delta]\[Rho]", "b"]}], "]"}]}]}], "/.", 
        "sub\[Rho]Ansatz"}], "/.", 
       RowBox[{"(", 
        RowBox[{"Rule", "@@@", 
         RowBox[{"Cases", "[", 
          RowBox[{
           RowBox[{"solut\[Rho]s", "/.", 
            RowBox[{"Rule", "\[Rule]", "List"}]}], ",", 
           RowBox[{"List", "[", 
            RowBox[{"a_", ",", "0"}], "]"}]}], "]"}]}], ")"}]}], "//", 
      "Expand"}], ",", 
     RowBox[{"{", 
      RowBox[{"g", ",", 
       RowBox[{
        SubscriptBox["\[Beta]", "_"], "[", "_", "]"}], ",", 
       RowBox[{
        SubscriptBox["\[Alpha]", "_"], "[", "_", "]"}]}], "}"}], ",", 
     "Together"}], "]"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.5559670605465813`*^9, 3.5559671102873163`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"tmp5", "=", 
   RowBox[{
    RowBox[{"Collect", "[", 
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{
          RowBox[{
           RowBox[{"(", 
            RowBox[{
             RowBox[{
              RowBox[{"Series", "[", 
               RowBox[{
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{"-", 
                   FractionBox[
                    RowBox[{"2", "w", " ", "g"}], 
                    RowBox[{"2", " ", "\[ImaginaryI]"}]]}], 
                  RowBox[{"(", 
                   RowBox[{
                    FractionBox["1", 
                    RowBox[{"u", "+", "\[ImaginaryI]", "-", 
                    RowBox[{"2", "g", " ", "w"}]}]], "-", 
                    FractionBox["1", 
                    RowBox[{"u", "-", 
                    RowBox[{"2", "g", " ", "w"}]}]]}], ")"}], 
                  SuperscriptBox["g", "7"], 
                  RowBox[{"(", 
                   RowBox[{
                    SubscriptBox["\[Delta]\[Rho]2", "lead"], "+", 
                    RowBox[{
                    SuperscriptBox["g", "2"], 
                    SubscriptBox["\[Delta]\[Rho]2", "sublead"]}], "+", 
                    RowBox[{
                    SuperscriptBox["g", "4"], 
                    SubscriptBox["\[Delta]\[Rho]2", "sublead2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["g", "6"], "\[Delta]\[Rho]2sb"}]}], 
                   ")"}]}], ")"}], ",", 
                RowBox[{"{", 
                 RowBox[{"g", ",", "0", ",", "14"}], "}"}]}], "]"}], "//", 
              "Normal"}], "//", "Expand"}], ")"}], "/.", 
           RowBox[{
            SuperscriptBox["w", 
             RowBox[{"a_", "/;", 
              RowBox[{"EvenQ", "[", "a", "]"}]}]], "\[Rule]", "0"}]}], "/.", 
          RowBox[{
           RowBox[{
            SuperscriptBox["w", "a_."], 
            SubscriptBox["\[Delta]\[Rho]2", "b_"]}], "\[RuleDelayed]", 
           RowBox[{"M", "[", 
            RowBox[{
             SuperscriptBox["w", 
              RowBox[{"a", "-", "1"}]], 
             SubscriptBox["\[Delta]\[Rho]2", "b"]}], "]"}]}]}], "/.", 
         "sub\[Rho]Ansatz"}], "/.", 
        RowBox[{"(", 
         RowBox[{"Rule", "@@@", 
          RowBox[{"Cases", "[", 
           RowBox[{
            RowBox[{"solut\[Rho]s", "/.", 
             RowBox[{"Rule", "\[Rule]", "List"}]}], ",", 
            RowBox[{"List", "[", 
             RowBox[{"a_", ",", "0"}], "]"}]}], "]"}]}], ")"}]}], "//", 
       "Expand"}], ",", 
      RowBox[{"{", 
       RowBox[{"g", ",", 
        RowBox[{
         SubscriptBox["\[Beta]", "_"], "[", "_", "]"}], ",", 
        RowBox[{
         SubscriptBox["\[Alpha]", "_"], "[", "_", "]"}]}], "}"}], ",", 
      "Together"}], "]"}], "/.", 
    RowBox[{
     RowBox[{"w", " ", "\[Delta]\[Rho]2sb"}], "->", "\[Delta]\[Rho]2sb"}]}]}],
   ";"}]], "Input",
 CellChangeTimes->{{3.555959440246872*^9, 3.555959597085898*^9}, {
   3.555959656956286*^9, 3.555959679234445*^9}, {3.5559597284806137`*^9, 
   3.555959762943166*^9}, {3.555959817172202*^9, 3.55595983699745*^9}, 
   3.555960150276371*^9, {3.555960259949939*^9, 3.555960400582122*^9}, {
   3.555960436221867*^9, 3.55596044881701*^9}, {3.555960483882102*^9, 
   3.555960528188892*^9}, 3.555960560102167*^9, {3.555960614052176*^9, 
   3.555960621470096*^9}, {3.55596688469585*^9, 3.555966897732308*^9}, {
   3.5559669377064867`*^9, 3.555966972102853*^9}, {3.555967043920801*^9, 
   3.5559670448844748`*^9}, {3.5559671175183687`*^9, 3.555967120085024*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{"iii", "=", "1"}], ";"}], "\[IndentingNewLine]", 
   RowBox[{"cont\[Rho]\[Rho]2", "=", 
    RowBox[{"Collect", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"Collect", "[", 
        RowBox[{
         RowBox[{"Series", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{"tmp1", " ", "tmp4"}], "-", 
              RowBox[{"tmp2", " ", "tmp5"}]}], ")"}], "tmp3"}], ",", 
           RowBox[{"{", 
            RowBox[{"g", ",", "0", ",", "14"}], "}"}]}], "]"}], ",", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"g", ",", 
            RowBox[{
             SubscriptBox["\[Alpha]", "_"], "[", "_", "]"}], ",", 
            RowBox[{
             SubscriptBox["\[Beta]", "_"], "[", "_", "]"}], ",", 
            "\[Zeta]list"}], "}"}], "//", "Flatten"}], ",", 
         RowBox[{
          RowBox[{"Integrate", "[", 
           RowBox[{
            FractionBox[
             RowBox[{
              RowBox[{"Simplify", "[", 
               RowBox[{
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{"NotebookDelete", "[", "prntmp", "]"}], ";", 
                  RowBox[{"prntmp", "=", 
                   RowBox[{"PrintTemporary", "[", 
                    RowBox[{"iii", "++"}], "]"}]}], ";", "#"}], ")"}], "/.", 
                "subQ0"}], "]"}], "/.", 
              RowBox[{"u", "\[Rule]", 
               RowBox[{"t", "-", 
                FractionBox["\[ImaginaryI]", "4"]}]}]}], 
             RowBox[{
              RowBox[{"-", "2"}], "\[Pi]", " ", "\[ImaginaryI]"}]], ",", 
            RowBox[{"{", 
             RowBox[{"t", ",", 
              RowBox[{"-", "\[Infinity]"}], ",", 
              RowBox[{"+", "\[Infinity]"}]}], "}"}]}], "]"}], "&"}]}], "]"}], 
       "/.", 
       RowBox[{"\[Delta]\[Rho]2sb", "->", "\[Delta]\[Rho]2sb3"}]}], ",", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"g", ",", 
         SqrtBox["3"], ",", 
         RowBox[{
          SubscriptBox["\[Alpha]", "_"], "[", "_", "]"}], ",", 
         RowBox[{
          SubscriptBox["\[Beta]", "_"], "[", "_", "]"}], ",", "\[Zeta]list"}],
         "}"}], "//", "Flatten"}]}], "]"}]}]}]}]], "Input",
 CellChangeTimes->{{3.555967496808302*^9, 3.555967780955585*^9}, {
   3.555967820018272*^9, 3.555967826196756*^9}, {3.555968027898286*^9, 
   3.5559681597673397`*^9}, {3.55596820810362*^9, 3.5559682396401567`*^9}, 
   3.555968316809183*^9, {3.555968456626768*^9, 3.555968474386544*^9}, {
   3.5559685140695353`*^9, 3.555968515356092*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   SqrtBox["3"], " ", 
   SuperscriptBox["g", "8"], " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{
      FractionBox["1", "4"], " ", "\[ImaginaryI]", " ", 
      RowBox[{
       SubscriptBox["\[Alpha]", "lead"], "[", "0", "]"}]}], "+", 
     RowBox[{
      FractionBox["1", "16"], " ", "\[ImaginaryI]", " ", 
      RowBox[{
       SubscriptBox["\[Alpha]", "lead"], "[", "1", "]"}]}]}], ")"}]}], "+", 
  RowBox[{
   SqrtBox["3"], " ", 
   SuperscriptBox["g", "10"], " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{
      RowBox[{"-", 
       FractionBox["17", "28"]}], " ", "\[ImaginaryI]", " ", 
      RowBox[{
       SubscriptBox["\[Alpha]", "lead"], "[", "0", "]"}]}], "+", 
     RowBox[{
      FractionBox["1213", "784"], " ", "\[ImaginaryI]", " ", 
      RowBox[{
       SubscriptBox["\[Alpha]", "lead"], "[", "1", "]"}]}], "+", 
     RowBox[{
      FractionBox["1", "4"], " ", "\[ImaginaryI]", " ", 
      RowBox[{
       SubscriptBox["\[Alpha]", "sublead"], "[", "0", "]"}]}], "+", 
     RowBox[{
      FractionBox["1", "16"], " ", "\[ImaginaryI]", " ", 
      RowBox[{
       SubscriptBox["\[Alpha]", "sublead"], "[", "1", "]"}]}], "+", 
     RowBox[{
      FractionBox["1", "32"], " ", "\[ImaginaryI]", " ", 
      RowBox[{
       SubscriptBox["\[Alpha]", "sublead"], "[", "2", "]"}]}], "-", 
     RowBox[{
      FractionBox["3", "7"], " ", "\[ImaginaryI]", " ", 
      RowBox[{
       SubscriptBox["\[Beta]", "lead"], "[", "0", "]"}]}]}], ")"}]}], "+", 
  RowBox[{
   SqrtBox["3"], " ", 
   SuperscriptBox["g", "12"], " ", 
   RowBox[{"(", 
    RowBox[{
     FractionBox[
      RowBox[{"78321", " ", "\[ImaginaryI]", " ", 
       RowBox[{
        SubscriptBox["\[Alpha]", "lead"], "[", "0", "]"}]}], "1372"], "-", 
     FractionBox[
      RowBox[{"1212", " ", "\[ImaginaryI]", " ", 
       RowBox[{
        SubscriptBox["\[Alpha]", "lead"], "[", "1", "]"}]}], "2401"], "-", 
     RowBox[{
      FractionBox["17", "28"], " ", "\[ImaginaryI]", " ", 
      RowBox[{
       SubscriptBox["\[Alpha]", "sublead"], "[", "0", "]"}]}], "+", 
     RowBox[{
      FractionBox["1213", "784"], " ", "\[ImaginaryI]", " ", 
      RowBox[{
       SubscriptBox["\[Alpha]", "sublead"], "[", "1", "]"}]}], "+", 
     FractionBox[
      RowBox[{"1879", " ", "\[ImaginaryI]", " ", 
       RowBox[{
        SubscriptBox["\[Alpha]", "sublead"], "[", "2", "]"}]}], "1568"], "+", 
     
     RowBox[{
      FractionBox["1", "4"], " ", "\[ImaginaryI]", " ", 
      RowBox[{
       SubscriptBox["\[Alpha]", "sublead2"], "[", "0", "]"}]}], "+", 
     RowBox[{
      FractionBox["1", "16"], " ", "\[ImaginaryI]", " ", 
      RowBox[{
       SubscriptBox["\[Alpha]", "sublead2"], "[", "1", "]"}]}], "+", 
     RowBox[{
      FractionBox["1", "32"], " ", "\[ImaginaryI]", " ", 
      RowBox[{
       SubscriptBox["\[Alpha]", "sublead2"], "[", "2", "]"}]}], "+", 
     RowBox[{
      FractionBox["5", "256"], " ", "\[ImaginaryI]", " ", 
      RowBox[{
       SubscriptBox["\[Alpha]", "sublead2"], "[", "3", "]"}]}], "+", 
     RowBox[{
      FractionBox["1272", "343"], " ", "\[ImaginaryI]", " ", 
      RowBox[{
       SubscriptBox["\[Beta]", "lead"], "[", "0", "]"}]}], "-", 
     RowBox[{
      FractionBox["3", "7"], " ", "\[ImaginaryI]", " ", 
      RowBox[{
       SubscriptBox["\[Beta]", "sublead"], "[", "0", "]"}]}], "-", 
     RowBox[{
      FractionBox["3", "28"], " ", "\[ImaginaryI]", " ", 
      RowBox[{
       SubscriptBox["\[Beta]", "sublead"], "[", "1", "]"}]}]}], ")"}]}], "+", 
  
  RowBox[{
   SqrtBox["3"], " ", 
   SuperscriptBox["g", "14"], " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{
      FractionBox["1", "6"], " ", "\[ImaginaryI]", " ", 
      RowBox[{"\[DoubleStruckCapitalC]", "[", 
       RowBox[{"-", 
        RowBox[{
         FractionBox["1", 
          RowBox[{"2187", " ", 
           SuperscriptBox[
            RowBox[{"(", 
             SuperscriptBox[
              StyleBox["Q0",
               FontColor->RGBColor[{
                  Rational[1, 2], 
                  Rational[1, 2], 0}]], "-"], ")"}], "4"], " ", 
           SuperscriptBox[
            RowBox[{"(", 
             SuperscriptBox[
              StyleBox["Q0",
               FontColor->RGBColor[{
                  Rational[1, 2], 
                  Rational[1, 2], 0}]], "+"], ")"}], "4"]}]], 
         RowBox[{"\[ImaginaryI]", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"9", " ", 
             SuperscriptBox[
              StyleBox["Q0",
               FontColor->RGBColor[{
                  Rational[1, 2], 
                  Rational[1, 2], 0}]], "-"], " ", 
             SuperscriptBox[
              StyleBox["Q0",
               FontColor->RGBColor[{
                  Rational[1, 2], 
                  Rational[1, 2], 0}]], "+"], " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"2", " ", 
                RowBox[{"(", 
                 RowBox[{"5", "-", 
                  RowBox[{"144", " ", 
                   SuperscriptBox["u", "2"]}], "-", 
                  RowBox[{"351", " ", 
                   SuperscriptBox["u", "4"]}], "+", 
                  RowBox[{"1404", " ", 
                   SuperscriptBox["u", "6"]}], "+", 
                  RowBox[{"729", " ", 
                   SuperscriptBox["u", "8"]}]}], ")"}], " ", 
                SubscriptBox[
                 StyleBox["W",
                  FontColor->RGBColor[0.54, 0.35, 0.15]], "sublead"]}], "+", 
               RowBox[{"9", " ", 
                SuperscriptBox[
                 StyleBox["Q0",
                  FontColor->RGBColor[{
                    Rational[1, 2], 
                    Rational[1, 2], 0}]], "-"], " ", 
                SuperscriptBox[
                 StyleBox["Q0",
                  FontColor->RGBColor[{
                    Rational[1, 2], 
                    Rational[1, 2], 0}]], "+"], " ", 
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{"4", " ", 
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", "1"}], "+", 
                    RowBox[{"3", " ", 
                    SuperscriptBox["u", "2"]}], "+", 
                    RowBox[{"27", " ", 
                    SuperscriptBox["u", "4"]}]}], ")"}], " ", 
                   SubscriptBox[
                    StyleBox["W",
                    FontColor->RGBColor[0.54, 0.35, 0.15]], "sublead2"]}], 
                  "+", 
                  RowBox[{
                   RowBox[{"(", 
                    RowBox[{"1", "+", 
                    RowBox[{"6", " ", 
                    SuperscriptBox["u", "2"]}], "+", 
                    RowBox[{"18", " ", 
                    SuperscriptBox["u", "4"]}], "+", 
                    RowBox[{"27", " ", 
                    SuperscriptBox["u", "6"]}]}], ")"}], " ", 
                   SubscriptBox[
                    StyleBox["W",
                    FontColor->RGBColor[0.54, 0.35, 0.15]], "sublead3"]}]}], 
                 ")"}]}]}], ")"}]}], "+", 
            RowBox[{"8", " ", 
             SubscriptBox[
              StyleBox["W",
               FontColor->RGBColor[0.54, 0.35, 0.15]], "lead"], " ", 
             RowBox[{"(", 
              RowBox[{"1", "+", 
               RowBox[{
                SuperscriptBox["u", "2"], " ", 
                RowBox[{"(", 
                 RowBox[{"255", "-", 
                  RowBox[{"9", " ", 
                   SubscriptBox[
                    StyleBox["\[Zeta]",
                    FontWeight->Bold,
                    FontColor->GrayLevel[0.4]], "3"]}]}], ")"}]}], "+", 
               RowBox[{"54", " ", 
                SuperscriptBox["u", "4"], " ", 
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{"-", "16"}], "+", 
                  SubscriptBox[
                   StyleBox["\[Zeta]",
                    FontWeight->Bold,
                    FontColor->GrayLevel[0.4]], "3"]}], ")"}]}], "+", 
               RowBox[{"6561", " ", 
                SuperscriptBox["u", "12"], " ", 
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{"-", "1"}], "+", 
                  SubscriptBox[
                   StyleBox["\[Zeta]",
                    FontWeight->Bold,
                    FontColor->GrayLevel[0.4]], "3"]}], ")"}]}], "-", 
               RowBox[{"3", " ", 
                SubscriptBox[
                 StyleBox["\[Zeta]",
                  FontWeight->Bold,
                  FontColor->GrayLevel[0.4]], "3"]}], "+", 
               RowBox[{"810", " ", 
                SuperscriptBox["u", "8"], " ", 
                RowBox[{"(", 
                 RowBox[{"2", "+", 
                  RowBox[{"3", " ", 
                   SubscriptBox[
                    StyleBox["\[Zeta]",
                    FontWeight->Bold,
                    FontColor->GrayLevel[0.4]], "3"]}]}], ")"}]}], "+", 
               RowBox[{"729", " ", 
                SuperscriptBox["u", "10"], " ", 
                RowBox[{"(", 
                 RowBox[{"3", "+", 
                  RowBox[{"7", " ", 
                   SubscriptBox[
                    StyleBox["\[Zeta]",
                    FontWeight->Bold,
                    FontColor->GrayLevel[0.4]], "3"]}]}], ")"}]}], "+", 
               RowBox[{"27", " ", 
                SuperscriptBox["u", "6"], " ", 
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{"-", "271"}], "+", 
                  RowBox[{"21", " ", 
                   SubscriptBox[
                    StyleBox["\[Zeta]",
                    FontWeight->Bold,
                    FontColor->GrayLevel[0.4]], "3"]}]}], ")"}]}]}], 
              ")"}]}]}], ")"}]}]}]}], "]"}]}], "+", 
     FractionBox[
      RowBox[{"68717", " ", "\[ImaginaryI]", " ", 
       RowBox[{
        SubscriptBox["\[Alpha]", "sublead"], "[", "0", "]"}]}], "1372"], "-", 
     
     FractionBox[
      RowBox[{"108229", " ", "\[ImaginaryI]", " ", 
       RowBox[{
        SubscriptBox["\[Alpha]", "sublead"], "[", "1", "]"}]}], "38416"], "-", 
     FractionBox[
      RowBox[{"89989", " ", "\[ImaginaryI]", " ", 
       RowBox[{
        SubscriptBox["\[Alpha]", "sublead"], "[", "2", "]"}]}], "10976"], "+", 
     RowBox[{
      FractionBox["11", "28"], " ", "\[ImaginaryI]", " ", 
      RowBox[{
       SubscriptBox["\[Alpha]", "sublead2"], "[", "0", "]"}]}], "+", 
     RowBox[{
      FractionBox["1409", "784"], " ", "\[ImaginaryI]", " ", 
      RowBox[{
       SubscriptBox["\[Alpha]", "sublead2"], "[", "1", "]"}]}], "+", 
     FractionBox[
      RowBox[{"2075", " ", "\[ImaginaryI]", " ", 
       RowBox[{
        SubscriptBox["\[Alpha]", "sublead2"], "[", "2", "]"}]}], "1568"], "+", 
     FractionBox[
      RowBox[{"12373", " ", "\[ImaginaryI]", " ", 
       RowBox[{
        SubscriptBox["\[Alpha]", "sublead2"], "[", "3", "]"}]}], "12544"], 
     "-", 
     FractionBox[
      RowBox[{"699459", " ", "\[ImaginaryI]", " ", 
       RowBox[{
        SubscriptBox["\[Beta]", "lead"], "[", "0", "]"}]}], "16807"], "+", 
     RowBox[{
      FractionBox["1272", "343"], " ", "\[ImaginaryI]", " ", 
      RowBox[{
       SubscriptBox["\[Beta]", "sublead"], "[", "0", "]"}]}], "+", 
     FractionBox[
      RowBox[{"2271", " ", "\[ImaginaryI]", " ", 
       RowBox[{
        SubscriptBox["\[Beta]", "sublead"], "[", "1", "]"}]}], "1372"], "-", 
     RowBox[{
      FractionBox["3", "7"], " ", "\[ImaginaryI]", " ", 
      RowBox[{
       SubscriptBox["\[Beta]", "sublead2"], "[", "0", "]"}]}], "-", 
     RowBox[{
      FractionBox["3", "28"], " ", "\[ImaginaryI]", " ", 
      RowBox[{
       SubscriptBox["\[Beta]", "sublead2"], "[", "1", "]"}]}], "-", 
     RowBox[{
      FractionBox["3", "56"], " ", "\[ImaginaryI]", " ", 
      RowBox[{
       SubscriptBox["\[Beta]", "sublead2"], "[", "2", "]"}]}], "-", 
     RowBox[{
      FractionBox["1", "6"], " ", "\[ImaginaryI]", " ", 
      SubscriptBox[
       StyleBox["W",
        FontColor->RGBColor[0.54, 0.35, 0.15]], 
       RowBox[{"1", ",", "v0", ",", "sublead3"}]]}], "+", 
     RowBox[{
      RowBox[{
       SubscriptBox["\[Alpha]", "lead"], "[", "1", "]"}], " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", 
         FractionBox[
          RowBox[{"10380745", " ", "\[ImaginaryI]"}], "117649"]}], "+", 
        RowBox[{"3", " ", "\[ImaginaryI]", " ", 
         SubscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "3"]}]}], ")"}]}], "+", 
     RowBox[{
      RowBox[{
       SubscriptBox["\[Alpha]", "lead"], "[", "0", "]"}], " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", 
         FractionBox[
          RowBox[{"57652327", " ", "\[ImaginaryI]"}], "67228"]}], "+", 
        RowBox[{"12", " ", "\[ImaginaryI]", " ", 
         SubscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "3"]}]}], ")"}]}]}], 
    ")"}]}]}]], "Output",
 CellChangeTimes->{3.5559684849538307`*^9, 3.555968525513155*^9, 
  3.560338167949469*^9}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[{
 "(Correction from ",
 Cell[BoxData[
  FormBox[
   RowBox[{
    SubscriptBox["W", "1"], ")"}], TraditionalForm]]],
 "=contW1"
}], "Subsubsection",
 CellChangeTimes->{{3.5538370419675827`*^9, 3.553837048061277*^9}, {
  3.5538381110460463`*^9, 3.553838142146912*^9}, {3.553838875507099*^9, 
  3.55383887550729*^9}, {3.553839603902988*^9, 3.5538396351236553`*^9}, {
  3.553840827313788*^9, 3.553840849442586*^9}, {3.5538411408384037`*^9, 
  3.553841140838573*^9}, {3.553858665399621*^9, 3.553858667959119*^9}, {
  3.555969056754427*^9, 3.555969058695148*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"contW1", "=", 
   RowBox[{"Collect", "[", 
    RowBox[{
     RowBox[{"Series", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"-", "tmp2"}], " ", "tmp3", " ", 
        SuperscriptBox["g", "8"], 
        RowBox[{"(", 
         RowBox[{
          SubsuperscriptBox["W", 
           RowBox[{"1", ",", "lead"}], "+"], "+", 
          RowBox[{
           SuperscriptBox["g", "2"], 
           SubsuperscriptBox["W", 
            RowBox[{"1", ",", "sublead"}], "+"]}], "+", 
          RowBox[{
           SuperscriptBox["g", "4"], 
           SubsuperscriptBox["W", 
            RowBox[{"1", ",", "sublead2"}], "+"]}], "+", 
          RowBox[{
           SuperscriptBox["g", "6"], 
           SubsuperscriptBox["W", 
            RowBox[{"1", ",", "sublead3"}], "+"]}]}], ")"}]}], ",", 
       RowBox[{"{", 
        RowBox[{"g", ",", "0", ",", "14"}], "}"}]}], "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"g", ",", 
       SqrtBox["3"]}], "}"}], ",", 
     RowBox[{
      RowBox[{"\[DoubleStruckCapitalC]", "[", 
       RowBox[{"Collect", "[", 
        RowBox[{"#", ",", 
         SubsuperscriptBox["W", "__", "+"], ",", "Simplify"}], "]"}], "]"}], 
      "&"}]}], "]"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.555968762460928*^9, 3.555968911496352*^9}, {
  3.555969025531631*^9, 3.5559690511974363`*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[{
 "(Correction from ",
 Cell[BoxData[
  FormBox[
   RowBox[{
    SubscriptBox["W", 
     RowBox[{"0", ",", "pv"}]], ")"}], TraditionalForm]]],
 "=-contW0"
}], "Subsubsection",
 CellChangeTimes->{{3.5538370419675827`*^9, 3.553837048061277*^9}, {
  3.5538381110460463`*^9, 3.553838142146912*^9}, {3.553838875507099*^9, 
  3.55383887550729*^9}, {3.553839603902988*^9, 3.5538396351236553`*^9}, {
  3.553840827313788*^9, 3.553840849442586*^9}, {3.5538411408384037`*^9, 
  3.553841140838573*^9}, {3.5538412289901953`*^9, 3.553841230787209*^9}, {
  3.553844598114683*^9, 3.553844625832514*^9}, {3.555970738454467*^9, 
  3.5559707421407423`*^9}}],

Cell["\<\
We take explicitly Cauchy integral\
\>", "Text",
 CellChangeTimes->{{3.553841247721435*^9, 3.553841256888839*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"tmp", "=", 
   RowBox[{"Series", "[", 
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{"-", 
        FractionBox["1", 
         RowBox[{"2", "\[Pi]", " ", "\[ImaginaryI]"}]]}], 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", "tmp2"}], " ", "tmp3"}], ")"}], 
       RowBox[{"(", 
        RowBox[{
         FractionBox["1", "2"], 
         RowBox[{"(", 
          RowBox[{
           FractionBox["1", 
            RowBox[{"u", "+", "\[ImaginaryI]", "-", "v"}]], "-", 
           FractionBox["1", 
            RowBox[{"u", "-", "v"}]], "+", 
           FractionBox["1", 
            RowBox[{"u", "+", "\[ImaginaryI]", "+", "v"}]], "-", 
           FractionBox["1", 
            RowBox[{"u", "+", "v"}]]}], ")"}]}], ")"}]}], "/.", 
      RowBox[{"leadweak", "[", "4", "]"}]}], ",", 
     RowBox[{"{", 
      RowBox[{"g", ",", "0", ",", "6"}], "}"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"tmp", "=", 
   RowBox[{"Collect", "[", 
    RowBox[{"tmp", ",", 
     RowBox[{"{", 
      RowBox[{"g", ",", 
       SubscriptBox["\[Zeta]", "_"]}], "}"}], ",", 
     RowBox[{
      RowBox[{"Integrate", "[", 
       RowBox[{
        RowBox[{
         RowBox[{
          RowBox[{"Simplify", "[", 
           RowBox[{"#", "/.", "subQ0"}], "]"}], "/.", 
          RowBox[{"u", "\[Rule]", 
           RowBox[{"t", "-", 
            FractionBox["\[ImaginaryI]", "4"]}]}]}], "/.", 
         RowBox[{"v", "\[Rule]", 
          RowBox[{"Zeta", "[", "177", "]"}]}]}], ",", 
        RowBox[{"{", 
         RowBox[{"t", ",", 
          RowBox[{"-", "\[Infinity]"}], ",", 
          RowBox[{"+", "\[Infinity]"}]}], "}"}]}], "]"}], "&"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"tmpi", "=", 
   RowBox[{"Collect", "[", 
    RowBox[{
     RowBox[{"tmp", "/.", 
      RowBox[{
       RowBox[{"Zeta", "[", "177", "]"}], "\[Rule]", "u"}]}], ",", "g", ",", 
     "Simplify"}], "]"}]}], ";"}]}], "Input",
 CellChangeTimes->{{3.553841237165841*^9, 3.553841416830242*^9}, {
   3.553841479143881*^9, 3.5538414978517237`*^9}, {3.553841582451865*^9, 
   3.553841688195084*^9}, {3.553841822058819*^9, 3.553841868617917*^9}, {
   3.553841903211454*^9, 3.553842002530138*^9}, {3.553842065664106*^9, 
   3.553842068624527*^9}, {3.5538425057997417`*^9, 3.553842524617256*^9}, {
   3.553842559287882*^9, 3.553842624048512*^9}, {3.55384273059509*^9, 
   3.553842735293068*^9}, {3.553844324254341*^9, 3.55384433164817*^9}, {
   3.553844367159975*^9, 3.553844400973049*^9}, {3.55596912590489*^9, 
   3.555969225404839*^9}, {3.555969295438005*^9, 3.5559693051948643`*^9}, 
   3.555969342127693*^9, {3.555969749029941*^9, 3.555969754196546*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"contW0", "=", 
   RowBox[{"Collect", "[", 
    RowBox[{
     RowBox[{"Series", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"(", 
         RowBox[{"tmpi", "/.", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{
             RowBox[{"1", "+", 
              RowBox[{"3", " ", 
               SuperscriptBox["u", "2"]}], "+", 
              RowBox[{"9", " ", 
               SuperscriptBox["u", "4"]}]}], "\[Rule]", 
             RowBox[{"9", 
              SuperscriptBox["Q0", "+"], 
              SuperscriptBox["Q0", "-"]}]}], ",", 
            RowBox[{
             RowBox[{"1", "+", 
              RowBox[{"4", " ", 
               SuperscriptBox["u", "2"]}], "+", 
              RowBox[{"12", " ", 
               SuperscriptBox["u", "4"]}], "+", 
              RowBox[{"9", " ", 
               SuperscriptBox["u", "6"]}]}], "\[Rule]", 
             RowBox[{"9", 
              SuperscriptBox["Q0", "+"], 
              SuperscriptBox["Q0", "-"], 
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["u", "2"], "+", "1"}], ")"}]}]}], ",", 
            RowBox[{
             RowBox[{"49", "+", 
              RowBox[{"88", " ", 
               SuperscriptBox["u", "2"]}], "+", 
              RowBox[{"48", " ", 
               SuperscriptBox["u", "4"]}], "+", 
              RowBox[{"9", " ", 
               SuperscriptBox["u", "6"]}]}], "->", 
             RowBox[{"9", " ", 
              RowBox[{"(", 
               RowBox[{"1", "+", 
                SuperscriptBox["u", "2"]}], ")"}], 
              SuperscriptBox["Q0", 
               RowBox[{"[", 
                RowBox[{"+", "3"}], "]"}]], 
              SuperscriptBox["Q0", 
               RowBox[{"[", 
                RowBox[{"-", "3"}], "]"}]]}]}], ",", 
            RowBox[{
             RowBox[{"49", "+", 
              RowBox[{"39", " ", 
               SuperscriptBox["u", "2"]}], "+", 
              RowBox[{"9", " ", 
               SuperscriptBox["u", "4"]}]}], "\[Rule]", 
             RowBox[{"9", 
              SuperscriptBox["Q0", 
               RowBox[{"[", 
                RowBox[{"+", "3"}], "]"}]], 
              SuperscriptBox["Q0", 
               RowBox[{"[", 
                RowBox[{"-", "3"}], "]"}]]}]}]}], "}"}]}], ")"}], 
        SuperscriptBox["g", "8"], 
        RowBox[{"(", 
         RowBox[{
          SubscriptBox[
           OverscriptBox["W", "^"], "lead"], "+", 
          RowBox[{
           SuperscriptBox["g", "2"], 
           SubscriptBox[
            OverscriptBox["W", "^"], "sublead"]}], "+", 
          RowBox[{
           SuperscriptBox["g", "4"], 
           SubscriptBox[
            OverscriptBox["W", "^"], "sublead2"]}], "+", 
          RowBox[{
           SuperscriptBox["g", "6"], 
           SubscriptBox[
            OverscriptBox["W", "^"], "sublead3"]}]}], ")"}]}], ",", 
       RowBox[{"{", 
        RowBox[{"g", ",", "0", ",", "14"}], "}"}]}], "]"}], ",", "g", ",", 
     RowBox[{
      RowBox[{"\[DoubleStruckCapitalC]", "[", 
       RowBox[{"Collect", "[", 
        RowBox[{"#", ",", 
         SubscriptBox[
          OverscriptBox["W", "^"], "_"], ",", "Together"}], "]"}], "]"}], 
      "&"}]}], "]"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.555969442583919*^9, 3.555969471250154*^9}, {
   3.5559695214484777`*^9, 3.555969579950097*^9}, {3.55596961735483*^9, 
   3.555969646820572*^9}, {3.555969676930901*^9, 3.5559696793714533`*^9}, {
   3.555969774304141*^9, 3.5559697785350323`*^9}, {3.555971036869606*^9, 
   3.5559711172437267`*^9}, 3.5603393984763937`*^9}]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell["\<\
Expression for m  (Integral expressions for m1,m2,m3,m4)\
\>", "Subsection",
 CellChangeTimes->{{3.550217670226611*^9, 3.550217673930208*^9}, {
  3.552219134772173*^9, 3.552219135418844*^9}, {3.552219564578795*^9, 
  3.552219565338008*^9}, {3.552352719957919*^9, 3.55235272421891*^9}, {
  3.552356867993417*^9, 3.552356876087286*^9}, {3.553845417299821*^9, 
  3.553845426365924*^9}, {3.553858725689411*^9, 3.55385873361895*^9}, {
  3.555970804100293*^9, 3.555970817385651*^9}, {3.568965370626471*^9, 
  3.568965372901875*^9}, {3.568968347271901*^9, 3.56896835422729*^9}}],

Cell["\<\
Here we compute only integral representations for m1, m2, m3, m4. They are \
stored to \[OpenCurlyDoubleQuote]manswer2.data\[CloseCurlyDoubleQuote]. 
We computed these quantities explicitly using ParallelCCompute which \
implements UpIntegrate routine in parallel to various pieces.\
\>", "Text",
 CellChangeTimes->{{3.5689684347934303`*^9, 3.5689685187006617`*^9}}],

Cell["\<\
The analytic answer (after integration) can be loaded as  list {m1,m2,m3,m4} \
by <<\[CloseCurlyDoubleQuote]manal.data\[CloseCurlyDoubleQuote]. First three \
orders of \[CapitalIota]\[Cross]m, are also stored in subIm, e.g\
\>", "Text",
 CellChangeTimes->{{3.568968573866188*^9, 3.568968677367251*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"\[ImaginaryI]", " ", "m2"}], "\[Equal]", 
  RowBox[{"(", 
   RowBox[{"Im2", "/.", "subIm"}], ")"}]}]], "Input",
 CellChangeTimes->{{3.5689686361938457`*^9, 3.568968657609064*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"\[ImaginaryI]", " ", "m2"}], "\[Equal]", 
  RowBox[{
   RowBox[{
    SqrtBox["3"], " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"-", "17496"}], "-", 
      RowBox[{"10368", " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "3"]}], "+", 
      RowBox[{"2592", " ", 
       SubsuperscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "3", "2"]}], "-", 
      RowBox[{"6552", " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "5"]}], "-", 
      RowBox[{"13608", " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "7"]}]}], ")"}]}], "+", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"15552", " ", "\[ImaginaryI]"}], "-", 
      RowBox[{"3888", " ", 
       SqrtBox["3"], " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "2"]}], "+", 
      RowBox[{"1944", " ", "\[ImaginaryI]", " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "3"]}]}], ")"}], " ", 
    SubsuperscriptBox[
     StyleBox["\[Eta]0",
      FontWeight->Bold,
      FontColor->RGBColor[0, 0.5, 0]], "2", "+"]}], "+", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{"5832", "-", 
      RowBox[{"1944", " ", "\[ImaginaryI]", " ", 
       SqrtBox["3"]}], "+", 
      RowBox[{"1944", " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "2"]}]}], ")"}], " ", 
    SubsuperscriptBox[
     StyleBox["\[Eta]0",
      FontWeight->Bold,
      FontColor->RGBColor[0, 0.5, 0]], "3", "+"]}], "+", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       RowBox[{"-", "3888"}], " ", "\[ImaginaryI]"}], "-", 
      RowBox[{"1944", " ", 
       SqrtBox["3"]}]}], ")"}], " ", 
    SubsuperscriptBox[
     StyleBox["\[Eta]0",
      FontWeight->Bold,
      FontColor->RGBColor[0, 0.5, 0]], "4", "+"]}], "+", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{"972", "+", 
      RowBox[{"1836", " ", "\[ImaginaryI]", " ", 
       SqrtBox["3"]}]}], ")"}], " ", 
    SubsuperscriptBox[
     StyleBox["\[Eta]0",
      FontWeight->Bold,
      FontColor->RGBColor[0, 0.5, 0]], "5", "+"]}], "-", 
   RowBox[{"648", " ", "\[ImaginaryI]", " ", 
    SubsuperscriptBox[
     StyleBox["\[Eta]0",
      FontWeight->Bold,
      FontColor->RGBColor[0, 0.5, 0]], "6", "+"]}], "+", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       RowBox[{"-", "11664"}], " ", "\[ImaginaryI]", " ", 
       SqrtBox["3"]}], "-", 
      RowBox[{"11664", " ", 
       SubsuperscriptBox[
        StyleBox["\[Eta]0",
         FontWeight->Bold,
         FontColor->RGBColor[0, 0.5, 0]], "2", "+"]}], "+", 
      RowBox[{"3888", " ", 
       SqrtBox["3"], " ", 
       SubsuperscriptBox[
        StyleBox["\[Eta]0",
         FontWeight->Bold,
         FontColor->RGBColor[0, 0.5, 0]], "3", "+"]}], "-", 
      RowBox[{"1944", " ", 
       SubsuperscriptBox[
        StyleBox["\[Eta]0",
         FontWeight->Bold,
         FontColor->RGBColor[0, 0.5, 0]], "4", "+"]}]}], ")"}], " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       RowBox[{"-", "\[ImaginaryI]"}], " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "1"]}], "+", 
      SubsuperscriptBox[
       OverscriptBox[
        StyleBox["\[Eta]0",
         FontWeight->Bold,
         FontColor->RGBColor[0, 0.5, 0]], 
        StyleBox["_",
         FontWeight->Bold,
         FontColor->RGBColor[0, 0.5, 0]]], "1", "-"]}], ")"}]}], "+", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       RowBox[{"-", "15552"}], " ", "\[ImaginaryI]"}], "-", 
      RowBox[{"3888", " ", 
       SqrtBox["3"], " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "2"]}], "-", 
      RowBox[{"1944", " ", "\[ImaginaryI]", " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "3"]}]}], ")"}], " ", 
    SubsuperscriptBox[
     OverscriptBox[
      StyleBox["\[Eta]0",
       FontWeight->Bold,
       FontColor->RGBColor[0, 0.5, 0]], 
      StyleBox["_",
       FontWeight->Bold,
       FontColor->RGBColor[0, 0.5, 0]]], "2", "-"]}], "+", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{"5832", "+", 
      RowBox[{"1944", " ", "\[ImaginaryI]", " ", 
       SqrtBox["3"]}], "+", 
      RowBox[{"1944", " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "2"]}]}], ")"}], " ", 
    SubsuperscriptBox[
     OverscriptBox[
      StyleBox["\[Eta]0",
       FontWeight->Bold,
       FontColor->RGBColor[0, 0.5, 0]], 
      StyleBox["_",
       FontWeight->Bold,
       FontColor->RGBColor[0, 0.5, 0]]], "3", "-"]}], "+", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"\[ImaginaryI]", " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "1"]}], "+", 
      SubsuperscriptBox[
       StyleBox["\[Eta]0",
        FontWeight->Bold,
        FontColor->RGBColor[0, 0.5, 0]], "1", "+"]}], ")"}], " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"11664", " ", "\[ImaginaryI]", " ", 
       SqrtBox["3"]}], "-", 
      RowBox[{"11664", " ", 
       SubsuperscriptBox[
        OverscriptBox[
         StyleBox["\[Eta]0",
          FontWeight->Bold,
          FontColor->RGBColor[0, 0.5, 0]], 
         StyleBox["_",
          FontWeight->Bold,
          FontColor->RGBColor[0, 0.5, 0]]], "2", "-"]}], "+", 
      RowBox[{"3888", " ", 
       SqrtBox["3"], " ", 
       SubsuperscriptBox[
        OverscriptBox[
         StyleBox["\[Eta]0",
          FontWeight->Bold,
          FontColor->RGBColor[0, 0.5, 0]], 
         StyleBox["_",
          FontWeight->Bold,
          FontColor->RGBColor[0, 0.5, 0]]], "3", "-"]}], "-", 
      RowBox[{"1944", " ", 
       SubsuperscriptBox[
        OverscriptBox[
         StyleBox["\[Eta]0",
          FontWeight->Bold,
          FontColor->RGBColor[0, 0.5, 0]], 
         StyleBox["_",
          FontWeight->Bold,
          FontColor->RGBColor[0, 0.5, 0]]], "4", "-"]}]}], ")"}]}], "+", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"3888", " ", "\[ImaginaryI]"}], "-", 
      RowBox[{"1944", " ", 
       SqrtBox["3"]}]}], ")"}], " ", 
    SubsuperscriptBox[
     OverscriptBox[
      StyleBox["\[Eta]0",
       FontWeight->Bold,
       FontColor->RGBColor[0, 0.5, 0]], 
      StyleBox["_",
       FontWeight->Bold,
       FontColor->RGBColor[0, 0.5, 0]]], "4", "-"]}], "+", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{"972", "-", 
      RowBox[{"1836", " ", "\[ImaginaryI]", " ", 
       SqrtBox["3"]}]}], ")"}], " ", 
    SubsuperscriptBox[
     OverscriptBox[
      StyleBox["\[Eta]0",
       FontWeight->Bold,
       FontColor->RGBColor[0, 0.5, 0]], 
      StyleBox["_",
       FontWeight->Bold,
       FontColor->RGBColor[0, 0.5, 0]]], "5", "-"]}], "+", 
   RowBox[{"648", " ", "\[ImaginaryI]", " ", 
    SubsuperscriptBox[
     OverscriptBox[
      StyleBox["\[Eta]0",
       FontWeight->Bold,
       FontColor->RGBColor[0, 0.5, 0]], 
      StyleBox["_",
       FontWeight->Bold,
       FontColor->RGBColor[0, 0.5, 0]]], "6", "-"]}]}]}]], "Output",
 CellChangeTimes->{{3.568968645513839*^9, 3.568968657853201*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"Coefficient", "[", 
  RowBox[{"cont\[Rho]\[Rho]2", ",", "g", ",", "8"}], 
  "]"}], "\[IndentingNewLine]", 
 RowBox[{"%", "/.", "solut\[Rho]s"}]}], "Input",
 CellChangeTimes->{{3.555972519928389*^9, 3.5559725425357103`*^9}, {
  3.555972579218165*^9, 3.555972677725834*^9}}],

Cell[BoxData[
 RowBox[{
  SqrtBox["3"], " ", 
  RowBox[{"(", 
   RowBox[{
    RowBox[{
     FractionBox["1", "4"], " ", "\[ImaginaryI]", " ", 
     RowBox[{
      SubscriptBox["\[Alpha]", "lead"], "[", "0", "]"}]}], "+", 
    RowBox[{
     FractionBox["1", "16"], " ", "\[ImaginaryI]", " ", 
     RowBox[{
      SubscriptBox["\[Alpha]", "lead"], "[", "1", "]"}]}]}], 
   ")"}]}]], "Output",
 CellChangeTimes->{{3.5559725819295464`*^9, 3.555972678256526*^9}, 
   3.56033821777868*^9}],

Cell[BoxData[
 RowBox[{
  SqrtBox["3"], " ", 
  RowBox[{"(", 
   RowBox[{
    RowBox[{
     FractionBox["1", "4"], " ", "\[ImaginaryI]", " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"-", "162"}], "+", 
       RowBox[{"\[DoubleStruckCapitalC]", "[", 
        FractionBox[
         RowBox[{"2", " ", 
          RowBox[{"(", 
           RowBox[{"\[ImaginaryI]", "+", "u"}], ")"}], " ", 
          SubscriptBox[
           StyleBox["H",
            FontColor->RGBColor[0.54, 0.35, 0.15]], "lead"]}], 
         RowBox[{"9", " ", 
          SuperscriptBox["u", "2"]}]], "]"}], "-", 
       RowBox[{
        FractionBox["1", "9"], " ", 
        RowBox[{"\[DoubleStruckCapitalC]", "[", 
         RowBox[{"-", 
          FractionBox[
           RowBox[{"4", " ", 
            RowBox[{"(", 
             RowBox[{"\[ImaginaryI]", "+", "u"}], ")"}], " ", 
            SubsuperscriptBox[
             StyleBox["W",
              FontColor->RGBColor[0.54, 0.35, 0.15]], 
             RowBox[{"1", ",", "lead"}], "+"]}], 
           SuperscriptBox[
            StyleBox["Q0",
             FontColor->RGBColor[{
                Rational[1, 2], 
                Rational[1, 2], 0}]], "+"]]}], "]"}]}], "+", 
       RowBox[{"\[DoubleStruckCapitalC]", "[", 
        RowBox[{"-", 
         FractionBox[
          RowBox[{"2", " ", "\[ImaginaryI]", " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"-", "1"}], "+", 
             RowBox[{"2", " ", 
              SuperscriptBox["u", "2"]}], "+", 
             RowBox[{"3", " ", 
              SuperscriptBox["u", "4"]}], "+", 
             RowBox[{"9", " ", 
              SuperscriptBox[
               StyleBox["Q0",
                FontColor->RGBColor[{
                   Rational[1, 2], 
                   Rational[1, 2], 0}]], "-"], " ", 
              SuperscriptBox[
               StyleBox["Q0",
                FontColor->RGBColor[{
                   Rational[1, 2], 
                   Rational[1, 2], 0}]], "+"]}]}], ")"}], " ", 
           SubscriptBox[
            OverscriptBox[
             StyleBox["W",
              FontColor->RGBColor[0.54, 0.35, 0.15]], 
             StyleBox["^",
              FontColor->RGBColor[0.54, 0.35, 0.15]]], "lead"]}], 
          RowBox[{"27", " ", 
           RowBox[{"(", 
            RowBox[{"1", "+", 
             SuperscriptBox["u", "2"]}], ")"}], " ", 
           SuperscriptBox[
            StyleBox["Q0",
             FontColor->RGBColor[{
                Rational[1, 2], 
                Rational[1, 2], 0}]], "-"], " ", 
           SuperscriptBox[
            StyleBox["Q0",
             FontColor->RGBColor[{
                Rational[1, 2], 
                Rational[1, 2], 0}]], "+"]}]]}], "]"}], "-", 
       RowBox[{
        FractionBox["2", "9"], " ", 
        SubscriptBox[
         StyleBox["W",
          FontColor->RGBColor[0.54, 0.35, 0.15]], 
         RowBox[{"1", ",", "v0", ",", "lead"}]]}], "+", 
       RowBox[{"60", " ", 
        SubscriptBox[
         StyleBox["\[Zeta]",
          FontWeight->Bold,
          FontColor->GrayLevel[0.4]], "2"]}], "+", 
       RowBox[{"24", " ", 
        SubsuperscriptBox[
         StyleBox["\[Zeta]",
          FontWeight->Bold,
          FontColor->GrayLevel[0.4]], "2", "2"]}], "-", 
       FractionBox[
        RowBox[{"16", " ", 
         SubsuperscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "2", "3"]}], "5"], "+", 
       RowBox[{"156", " ", 
        SubscriptBox[
         StyleBox["\[Zeta]",
          FontWeight->Bold,
          FontColor->GrayLevel[0.4]], "3"]}], "-", 
       RowBox[{"88", " ", 
        SubscriptBox[
         StyleBox["\[Zeta]",
          FontWeight->Bold,
          FontColor->GrayLevel[0.4]], "2"], " ", 
        SubscriptBox[
         StyleBox["\[Zeta]",
          FontWeight->Bold,
          FontColor->GrayLevel[0.4]], "3"]}], "+", 
       RowBox[{
        FractionBox["16", "5"], " ", 
        SubsuperscriptBox[
         StyleBox["\[Zeta]",
          FontWeight->Bold,
          FontColor->GrayLevel[0.4]], "2", "2"], " ", 
        SubscriptBox[
         StyleBox["\[Zeta]",
          FontWeight->Bold,
          FontColor->GrayLevel[0.4]], "3"]}], "-", 
       RowBox[{"8", " ", 
        SubsuperscriptBox[
         StyleBox["\[Zeta]",
          FontWeight->Bold,
          FontColor->GrayLevel[0.4]], "3", "2"]}]}], ")"}]}], "+", 
    RowBox[{
     FractionBox["1", "16"], " ", "\[ImaginaryI]", " ", 
     RowBox[{"(", 
      RowBox[{"648", "+", 
       RowBox[{"\[DoubleStruckCapitalC]", "[", 
        RowBox[{"-", 
         FractionBox[
          RowBox[{"8", " ", 
           RowBox[{"(", 
            RowBox[{"\[ImaginaryI]", "+", "u"}], ")"}], " ", 
           SubscriptBox[
            StyleBox["H",
             FontColor->RGBColor[0.54, 0.35, 0.15]], "lead"]}], 
          RowBox[{"9", " ", 
           SuperscriptBox["u", "2"]}]]}], "]"}], "+", 
       RowBox[{
        FractionBox["4", "9"], " ", 
        RowBox[{"\[DoubleStruckCapitalC]", "[", 
         RowBox[{"-", 
          FractionBox[
           RowBox[{"4", " ", 
            RowBox[{"(", 
             RowBox[{"\[ImaginaryI]", "+", "u"}], ")"}], " ", 
            SubsuperscriptBox[
             StyleBox["W",
              FontColor->RGBColor[0.54, 0.35, 0.15]], 
             RowBox[{"1", ",", "lead"}], "+"]}], 
           SuperscriptBox[
            StyleBox["Q0",
             FontColor->RGBColor[{
                Rational[1, 2], 
                Rational[1, 2], 0}]], "+"]]}], "]"}]}], "+", 
       RowBox[{"\[DoubleStruckCapitalC]", "[", 
        RowBox[{"-", 
         FractionBox[
          RowBox[{"8", " ", "\[ImaginaryI]", " ", 
           RowBox[{"(", 
            RowBox[{"4", "+", 
             RowBox[{"10", " ", 
              SuperscriptBox["u", "2"]}], "+", 
             RowBox[{"6", " ", 
              SuperscriptBox["u", "4"]}], "-", 
             RowBox[{"9", " ", 
              SuperscriptBox[
               StyleBox["Q0",
                FontColor->RGBColor[{
                   Rational[1, 2], 
                   Rational[1, 2], 0}]], "-"], " ", 
              SuperscriptBox[
               StyleBox["Q0",
                FontColor->RGBColor[{
                   Rational[1, 2], 
                   Rational[1, 2], 0}]], "+"]}]}], ")"}], " ", 
           SubscriptBox[
            OverscriptBox[
             StyleBox["W",
              FontColor->RGBColor[0.54, 0.35, 0.15]], 
             StyleBox["^",
              FontColor->RGBColor[0.54, 0.35, 0.15]]], "lead"]}], 
          RowBox[{"27", " ", 
           RowBox[{"(", 
            RowBox[{"1", "+", 
             SuperscriptBox["u", "2"]}], ")"}], " ", 
           SuperscriptBox[
            StyleBox["Q0",
             FontColor->RGBColor[{
                Rational[1, 2], 
                Rational[1, 2], 0}]], "-"], " ", 
           SuperscriptBox[
            StyleBox["Q0",
             FontColor->RGBColor[{
                Rational[1, 2], 
                Rational[1, 2], 0}]], "+"]}]]}], "]"}], "-", 
       RowBox[{
        FractionBox["16", "9"], " ", 
        SubscriptBox[
         StyleBox["W",
          FontColor->RGBColor[0.54, 0.35, 0.15]], 
         RowBox[{"1", ",", "v0", ",", "lead"}]]}], "-", 
       RowBox[{"240", " ", 
        SubscriptBox[
         StyleBox["\[Zeta]",
          FontWeight->Bold,
          FontColor->GrayLevel[0.4]], "2"]}], "-", 
       RowBox[{"96", " ", 
        SubsuperscriptBox[
         StyleBox["\[Zeta]",
          FontWeight->Bold,
          FontColor->GrayLevel[0.4]], "2", "2"]}], "+", 
       FractionBox[
        RowBox[{"64", " ", 
         SubsuperscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "2", "3"]}], "5"], "-", 
       RowBox[{"624", " ", 
        SubscriptBox[
         StyleBox["\[Zeta]",
          FontWeight->Bold,
          FontColor->GrayLevel[0.4]], "3"]}], "+", 
       RowBox[{"352", " ", 
        SubscriptBox[
         StyleBox["\[Zeta]",
          FontWeight->Bold,
          FontColor->GrayLevel[0.4]], "2"], " ", 
        SubscriptBox[
         StyleBox["\[Zeta]",
          FontWeight->Bold,
          FontColor->GrayLevel[0.4]], "3"]}], "-", 
       RowBox[{
        FractionBox["64", "5"], " ", 
        SubsuperscriptBox[
         StyleBox["\[Zeta]",
          FontWeight->Bold,
          FontColor->GrayLevel[0.4]], "2", "2"], " ", 
        SubscriptBox[
         StyleBox["\[Zeta]",
          FontWeight->Bold,
          FontColor->GrayLevel[0.4]], "3"]}], "+", 
       RowBox[{"32", " ", 
        SubsuperscriptBox[
         StyleBox["\[Zeta]",
          FontWeight->Bold,
          FontColor->GrayLevel[0.4]], "3", "2"]}]}], ")"}]}]}], 
   ")"}]}]], "Output",
 CellChangeTimes->{{3.5559725819295464`*^9, 3.555972678256526*^9}, 
   3.560338217791939*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"Coefficient", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", 
        RowBox[{"(", 
         RowBox[{
         "conth\[Rho]", "+", "conthY11Y22", "+", "conth\[ScriptCapitalF]"}], 
         ")"}]}], ",", "contTh2", ",", 
       RowBox[{"contTu\[Rho]2", "-", "contTuWh", "+", "contTuW2"}], ",", 
       "contH", ",", 
       RowBox[{"cont\[Rho]\[Rho]2", "+", "contW1", "-", "contW0"}]}], "}"}], 
     ",", "g", ",", "14"}], "]"}], "/.", 
   RowBox[{
    RowBox[{"\[DoubleStruckCapitalC]", "[", 
     RowBox[{"a_", "/;", 
      RowBox[{"FreeQ", "[", 
       RowBox[{"a", ",", "W$h"}], "]"}]}], "]"}], "\[Rule]", "0"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"Position", "[", 
  RowBox[{"%", ",", 
   RowBox[{"\[DoubleStruckCapitalC]", "[", 
    RowBox[{"a_", "/;", 
     RowBox[{"Not", "@", 
      RowBox[{"FreeQ", "[", 
       RowBox[{"a", ",", "W$h"}], "]"}]}]}], "]"}]}], 
  "]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Extract", "[", 
   RowBox[{"%%", ",", 
    RowBox[{"Position", "[", 
     RowBox[{"%%", ",", 
      RowBox[{"\[DoubleStruckCapitalC]", "[", 
       RowBox[{"a_", "/;", 
        RowBox[{"Not", "@", 
         RowBox[{"FreeQ", "[", 
          RowBox[{"a", ",", "W$h"}], "]"}]}]}], "]"}]}], "]"}]}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"%", "/.", 
  RowBox[{
   RowBox[{"\[DoubleStruckCapitalC]", "[", "a_", "]"}], "\[RuleDelayed]", 
   RowBox[{"Series", "[", 
    RowBox[{
     RowBox[{"a", "/.", "subQ0"}], ",", 
     RowBox[{"{", 
      RowBox[{"u", ",", "\[Infinity]", ",", 
       RowBox[{"-", "10"}]}], "}"}]}], "]"}]}]}]}], "Input",
 CellChangeTimes->{{3.5603390444760303`*^9, 3.560339137665861*^9}, 
   3.560339176526266*^9, {3.5603392129332113`*^9, 3.56033930796742*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"3", ",", "1", ",", "2"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"5", ",", "1", ",", "2"}], "}"}]}], "}"}]], "Output",
 CellChangeTimes->{{3.560339285600378*^9, 3.560339308262718*^9}, 
   3.5603394664938583`*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   InterpretationBox[
    SuperscriptBox[
     RowBox[{"O", "[", 
      FractionBox["1", "u"], "]"}], "2"],
    SeriesData[$CellContext`u, 
     DirectedInfinity[1], {}, 2, 2, 1],
    Editable->False], ",", 
   InterpretationBox[
    SuperscriptBox[
     RowBox[{"O", "[", 
      FractionBox["1", "u"], "]"}], "2"],
    SeriesData[$CellContext`u, 
     DirectedInfinity[1], {}, 2, 2, 1],
    Editable->False]}], "}"}]], "Output",
 CellChangeTimes->{{3.560339285600378*^9, 3.560339308262718*^9}, 
   3.560339466558261*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"Coefficient", "[", 
    RowBox[{"contW0", ",", "g", ",", "14"}], "]"}], "/.", 
   RowBox[{
    RowBox[{"\[DoubleStruckCapitalC]", "[", 
     RowBox[{"a_", "/;", 
      RowBox[{"FreeQ", "[", 
       RowBox[{"a", ",", "W$h"}], "]"}]}], "]"}], "\[Rule]", "0"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"Position", "[", 
  RowBox[{"%", ",", 
   RowBox[{"\[DoubleStruckCapitalC]", "[", 
    RowBox[{"a_", "/;", 
     RowBox[{"Not", "@", 
      RowBox[{"FreeQ", "[", 
       RowBox[{"a", ",", "W$h"}], "]"}]}]}], "]"}]}], 
  "]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Extract", "[", 
   RowBox[{"%%", ",", 
    RowBox[{"Position", "[", 
     RowBox[{"%%", ",", 
      RowBox[{"\[DoubleStruckCapitalC]", "[", 
       RowBox[{"a_", "/;", 
        RowBox[{"Not", "@", 
         RowBox[{"FreeQ", "[", 
          RowBox[{"a", ",", "W$h"}], "]"}]}]}], "]"}]}], "]"}]}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"%", "/.", 
  RowBox[{
   RowBox[{"\[DoubleStruckCapitalC]", "[", "a_", "]"}], "\[RuleDelayed]", 
   RowBox[{"Series", "[", 
    RowBox[{
     RowBox[{"a", "/.", "subQ0"}], ",", 
     RowBox[{"{", 
      RowBox[{"u", ",", "\[Infinity]", ",", 
       RowBox[{"-", "10"}]}], "}"}]}], "]"}]}]}]}], "Input",
 CellChangeTimes->{{3.560339323647812*^9, 3.560339335339652*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"{", "}"}], "}"}]], "Output",
 CellChangeTimes->{{3.560339328662475*^9, 3.5603393356431026`*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  InterpretationBox[
   RowBox[{
    RowBox[{"-", 
     FractionBox[
      RowBox[{"875907809541", " ", 
       RowBox[{"(", 
        RowBox[{
         SqrtBox["3"], " ", 
         SubscriptBox[
          OverscriptBox[
           StyleBox["W",
            FontColor->RGBColor[0.54, 0.35, 0.15]], 
           StyleBox["^",
            FontColor->RGBColor[0.54, 0.35, 0.15]]], "lead"]}], ")"}], " ", 
       SuperscriptBox["u", "18"]}], "33614"]}], "-", 
    FractionBox[
     RowBox[{"1792660251969", " ", 
      RowBox[{"(", 
       RowBox[{
        SqrtBox["3"], " ", 
        SubscriptBox[
         OverscriptBox[
          StyleBox["W",
           FontColor->RGBColor[0.54, 0.35, 0.15]], 
          StyleBox["^",
           FontColor->RGBColor[0.54, 0.35, 0.15]]], "lead"]}], ")"}], " ", 
      SuperscriptBox["u", "16"]}], "33614"], "+", 
    FractionBox[
     RowBox[{"62138362761", " ", 
      SqrtBox["3"], " ", 
      SubscriptBox[
       OverscriptBox[
        StyleBox["W",
         FontColor->RGBColor[0.54, 0.35, 0.15]], 
        StyleBox["^",
         FontColor->RGBColor[0.54, 0.35, 0.15]]], "lead"], " ", 
      SuperscriptBox["u", "14"]}], "16807"], "-", 
    FractionBox[
     RowBox[{"2867638267575", " ", 
      RowBox[{"(", 
       RowBox[{
        SqrtBox["3"], " ", 
        SubscriptBox[
         OverscriptBox[
          StyleBox["W",
           FontColor->RGBColor[0.54, 0.35, 0.15]], 
          StyleBox["^",
           FontColor->RGBColor[0.54, 0.35, 0.15]]], "lead"]}], ")"}], " ", 
      SuperscriptBox["u", "12"]}], "16807"], "+", 
    FractionBox[
     RowBox[{"19113345244521", " ", 
      SqrtBox["3"], " ", 
      SubscriptBox[
       OverscriptBox[
        StyleBox["W",
         FontColor->RGBColor[0.54, 0.35, 0.15]], 
        StyleBox["^",
         FontColor->RGBColor[0.54, 0.35, 0.15]]], "lead"], " ", 
      SuperscriptBox["u", "10"]}], "33614"], "+", 
    InterpretationBox[
     FractionBox["1", 
      SuperscriptBox[
       RowBox[{"O", "[", 
        FractionBox["1", "u"], "]"}], "9"]],
     SeriesData[$CellContext`u, 
      DirectedInfinity[1], {}, -18, -9, 1],
     Editable->False]}],
   SeriesData[$CellContext`u, 
    DirectedInfinity[
    1], {(Rational[-875907809541, 33614] 
      3^Rational[1, 2]) $CellContext`W$h[$CellContext`lead][0], 
     0, (Rational[-1792660251969, 33614] 
      3^Rational[1, 2]) $CellContext`W$h[$CellContext`lead][0], 
     0, (Rational[62138362761, 16807] 
      3^Rational[1, 2]) $CellContext`W$h[$CellContext`lead][0], 
     0, (Rational[-2867638267575, 16807] 
      3^Rational[1, 2]) $CellContext`W$h[$CellContext`lead][0], 
     0, (Rational[19113345244521, 33614] 
      3^Rational[1, 2]) $CellContext`W$h[$CellContext`lead][0]}, -18, -9, 1],
   Editable->False], "}"}]], "Output",
 CellChangeTimes->{{3.560339328662475*^9, 3.560339335656818*^9}}]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"manswertmp", "=", 
   RowBox[{
    RowBox[{
     RowBox[{"List", "@@", 
      RowBox[{"Collect", "[", 
       RowBox[{
        RowBox[{
         RowBox[{
          RowBox[{"{", 
           RowBox[{
            RowBox[{"-", 
             RowBox[{"(", 
              RowBox[{
              "conth\[Rho]", "+", "conthY11Y22", "+", 
               "conth\[ScriptCapitalF]"}], ")"}]}], ",", "contTh2", ",", 
            RowBox[{"contTu\[Rho]2", "-", "contTuWh", "+", "contTuW2"}], ",", 
            "contH", ",", 
            RowBox[{"cont\[Rho]\[Rho]2", "+", "contW1", "-", "contW0"}]}], 
           "}"}], "/.", 
          RowBox[{
           SubscriptBox["W", "a__"], "\[RuleDelayed]", 
           SubscriptBox[
            OverscriptBox["W", "^"], "a"]}]}], "//", "Total"}], ",", "g", ",", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{"#", "/.", "solut\[Rho]s"}], "//", "Expand"}], ")"}], "/.", 
            RowBox[{
             RowBox[{"\[DoubleStruckCapitalC]", "[", "a_", "]"}], 
             "\[RuleDelayed]", 
             RowBox[{"\[DoubleStruckCapitalC]", "[", 
              RowBox[{"a", "//", "Expand"}], "]"}]}]}], "//.", 
           "sub\[DoubleStruckCapitalC]simplify"}], ")"}], "&"}]}], "]"}]}], "/.", 
     RowBox[{
      RowBox[{"\[DoubleStruckCapitalC]", "[", 
       RowBox[{"a_", "/;", 
        RowBox[{"Not", "[", 
         RowBox[{"FreeQ", "[", 
          RowBox[{"a", ",", 
           RowBox[{
            RowBox[{"Q0$", "[", "3", "]"}], "|", 
            RowBox[{"Q0$", "[", 
             RowBox[{"-", "3"}], "]"}]}]}], "]"}], "]"}]}], "]"}], 
      "\[RuleDelayed]", 
      RowBox[{"\[DoubleStruckCapitalC]", "[", 
       RowBox[{"Collect", "[", 
        RowBox[{"a", ",", 
         SubscriptBox[
          OverscriptBox["W", "^"], "_"], ",", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{
             RowBox[{"Simplify", "[", 
              FractionBox[
               RowBox[{
                RowBox[{"Numerator", "[", "#", "]"}], "/.", "subQ0"}], 
               RowBox[{
                RowBox[{"Denominator", "[", "#", "]"}], "/.", 
                RowBox[{
                 RowBox[{"(", 
                  RowBox[{"xxx", ":", 
                   RowBox[{
                    RowBox[{"Q0$", "[", "3", "]"}], "|", 
                    RowBox[{"Q0$", "[", 
                    RowBox[{"-", "3"}], "]"}]}]}], ")"}], "\[RuleDelayed]", 
                 RowBox[{"(", 
                  RowBox[{"xxx", "/.", "subQ0"}], ")"}]}]}]], "]"}], "&"}], 
            "[", 
            RowBox[{"Together", "[", "#", "]"}], "]"}], ")"}], "&"}]}], "]"}],
        "]"}]}]}], "/.", 
    RowBox[{
     RowBox[{"\[DoubleStruckCapitalC]", "[", "0", "]"}], "\[Rule]", "0"}]}]}],
   ";"}]], "Input",
 CellChangeTimes->{{3.5603374890781927`*^9, 3.560337509729898*^9}, 
   3.5603382212305737`*^9, {3.560338952460677*^9, 3.560338952962839*^9}, {
   3.560339499710968*^9, 3.5603395005285063`*^9}, {3.5603399457654*^9, 
   3.560339952204267*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"manswertmp2", "=", 
   RowBox[{"manswertmp", "/.", 
    RowBox[{
     RowBox[{"\[DoubleStruckCapitalC]", "[", "a_", "]"}], "\[RuleDelayed]", 
     RowBox[{"\[DoubleStruckCapitalC]", "[", 
      RowBox[{"Collect", "[", 
       RowBox[{
        RowBox[{"Collect", "[", 
         RowBox[{"a", ",", 
          RowBox[{
           SubscriptBox[
            OverscriptBox["W", "^"], "_"], "|", 
           SubsuperscriptBox["W", "__", "+"], "|", 
           SubscriptBox["H", "_"]}], ",", 
          RowBox[{
           RowBox[{"(", 
            RowBox[{
             RowBox[{
              RowBox[{"apartQswise2", "[", 
               FractionBox[
                RowBox[{
                 RowBox[{"Numerator", "[", "#", "]"}], "/.", "subQ0"}], 
                RowBox[{"Denominator", "[", "#", "]"}]], "]"}], "&"}], "[", 
             RowBox[{"Together", "[", "#", "]"}], "]"}], ")"}], "&"}]}], 
         "]"}], ",", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
           RowBox[{
            SubscriptBox[
             OverscriptBox["W", "^"], "_"], "|", 
            SubsuperscriptBox["W", "__", "+"], "|", 
            SubscriptBox["H", "_"]}], ",", 
           RowBox[{
            RowBox[{"Q0$", "[", "1", "]"}], "|", 
            RowBox[{"Q0$", "[", 
             RowBox[{"-", "1"}], "]"}]}], ",", 
           SqrtBox["3"], ",", "\[Zeta]list"}], "}"}], "//", "Flatten"}], ",", 
        "Together"}], "]"}], "]"}]}]}]}], ";"}]], "Input",
 CellChangeTimes->{{3.560337637357608*^9, 3.56033764052208*^9}, 
   3.560338664644203*^9, {3.560339791599228*^9, 3.560339808328642*^9}, {
   3.560339961789481*^9, 3.560339964779636*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"Extract", "[", 
   RowBox[{
    RowBox[{"manswertmp2", "[", 
     RowBox[{"[", "4", "]"}], "]"}], ",", 
    RowBox[{"Position", "[", 
     RowBox[{
      RowBox[{"manswertmp2", "[", 
       RowBox[{"[", "4", "]"}], "]"}], ",", 
      RowBox[{"\[DoubleStruckCapitalC]", "[", 
       RowBox[{"a_", "/;", 
        RowBox[{"Not", "[", 
         RowBox[{"FreeQ", "[", 
          RowBox[{"a", ",", "W$h"}], "]"}], "]"}]}], "]"}]}], "]"}]}], "]"}], 
  "//", "Length"}]], "Input",
 CellChangeTimes->{{3.560338239800753*^9, 3.5603382916221857`*^9}, {
  3.560338679271655*^9, 3.56033869223175*^9}, {3.560339515655775*^9, 
  3.560339574709182*^9}, {3.560339608323749*^9, 3.560339651545929*^9}, {
  3.560339684880509*^9, 3.5603397401032047`*^9}, {3.560339814828535*^9, 
  3.560339880978161*^9}, {3.5603399138234453`*^9, 3.560339921544449*^9}, {
  3.5603399850141172`*^9, 3.5603399861481752`*^9}}],

Cell[BoxData["1"], "Output",
 CellChangeTimes->{
  3.560339740538258*^9, {3.560339822105014*^9, 3.560339881288992*^9}, {
   3.560339915962965*^9, 3.560339921966675*^9}, {3.560339975364684*^9, 
   3.5603399865560017`*^9}}]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"manswer", "=", 
   RowBox[{
    RowBox[{
     RowBox[{"List", "@@", 
      RowBox[{"Collect", "[", 
       RowBox[{
        RowBox[{
         RowBox[{
          RowBox[{"{", 
           RowBox[{
            RowBox[{"-", 
             RowBox[{"(", 
              RowBox[{
              "conth\[Rho]", "+", "conthY11Y22", "+", 
               "conth\[ScriptCapitalF]"}], ")"}]}], ",", "contTh2", ",", 
            RowBox[{"contTu\[Rho]2", "-", "contTuWh", "+", "contTuW2"}], ",", 
            "contH", ",", 
            RowBox[{"cont\[Rho]\[Rho]2", "+", "contW1", "-", "contW0"}]}], 
           "}"}], "/.", 
          RowBox[{
           SubscriptBox["W", "a__"], "\[RuleDelayed]", 
           SubscriptBox[
            OverscriptBox["W", "^"], "a"]}]}], "//", "Total"}], ",", "g", ",", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           RowBox[{"(", 
            RowBox[{
             RowBox[{"#", "/.", "solut\[Rho]s"}], "//", "Expand"}], ")"}], "//.",
            "sub\[DoubleStruckCapitalC]simplify"}], ")"}], "&"}]}], "]"}]}], "/.", 
     RowBox[{
      RowBox[{"\[DoubleStruckCapitalC]", "[", 
       RowBox[{"a_", "/;", 
        RowBox[{"Not", "[", 
         RowBox[{"FreeQ", "[", 
          RowBox[{"a", ",", 
           RowBox[{
            RowBox[{"Q0$", "[", "3", "]"}], "|", 
            RowBox[{"Q0$", "[", 
             RowBox[{"-", "3"}], "]"}]}]}], "]"}], "]"}]}], "]"}], 
      "\[RuleDelayed]", 
      RowBox[{"\[DoubleStruckCapitalC]", "[", 
       RowBox[{"Collect", "[", 
        RowBox[{"a", ",", 
         SubscriptBox[
          OverscriptBox["W", "^"], "_"], ",", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{
             RowBox[{"Simplify", "[", 
              FractionBox[
               RowBox[{
                RowBox[{"Numerator", "[", "#", "]"}], "/.", "subQ0"}], 
               RowBox[{
                RowBox[{"Denominator", "[", "#", "]"}], "/.", 
                RowBox[{
                 RowBox[{"(", 
                  RowBox[{"xxx", ":", 
                   RowBox[{
                    RowBox[{"Q0$", "[", "3", "]"}], "|", 
                    RowBox[{"Q0$", "[", 
                    RowBox[{"-", "3"}], "]"}]}]}], ")"}], "\[RuleDelayed]", 
                 RowBox[{"(", 
                  RowBox[{"xxx", "/.", "subQ0"}], ")"}]}]}]], "]"}], "&"}], 
            "[", 
            RowBox[{"Together", "[", "#", "]"}], "]"}], ")"}], "&"}]}], "]"}],
        "]"}]}]}], "/.", 
    RowBox[{
     RowBox[{"\[DoubleStruckCapitalC]", "[", "0", "]"}], "\[Rule]", "0"}]}]}],
   ";"}]], "Input",
 CellChangeTimes->{{3.555970886043532*^9, 3.555970953318738*^9}, {
  3.555970987214082*^9, 3.555970993157415*^9}, {3.5559712068137074`*^9, 
  3.5559712912297087`*^9}, {3.555971324886014*^9, 3.5559713357112427`*^9}, {
  3.555971381665537*^9, 3.555971467755447*^9}, {3.555971512850964*^9, 
  3.555971623927401*^9}, {3.555972490656789*^9, 3.555972514118569*^9}, {
  3.5559727293711433`*^9, 3.55597273405872*^9}, {3.555974356205782*^9, 
  3.5559743688836193`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"manswer2", "=", 
   RowBox[{"manswer", "/.", 
    RowBox[{
     RowBox[{"\[DoubleStruckCapitalC]", "[", "a_", "]"}], "\[RuleDelayed]", 
     RowBox[{"\[DoubleStruckCapitalC]", "[", 
      RowBox[{"Collect", "[", 
       RowBox[{
        RowBox[{"Collect", "[", 
         RowBox[{"a", ",", 
          RowBox[{
           SubscriptBox[
            OverscriptBox["W", "^"], "_"], "|", 
           SubsuperscriptBox["W", "__", "+"], "|", 
           SubscriptBox["H", "_"]}], ",", 
          RowBox[{
           RowBox[{"(", 
            RowBox[{
             RowBox[{
              RowBox[{"apartQswise", "[", 
               FractionBox[
                RowBox[{
                 RowBox[{"Numerator", "[", "#", "]"}], "/.", "subQ0"}], 
                RowBox[{"Denominator", "[", "#", "]"}]], "]"}], "&"}], "[", 
             RowBox[{"Together", "[", "#", "]"}], "]"}], ")"}], "&"}]}], 
         "]"}], ",", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
           RowBox[{
            SubscriptBox[
             OverscriptBox["W", "^"], "_"], "|", 
            SubsuperscriptBox["W", "__", "+"], "|", 
            SubscriptBox["H", "_"]}], ",", 
           RowBox[{
            RowBox[{"Q0$", "[", "1", "]"}], "|", 
            RowBox[{"Q0$", "[", 
             RowBox[{"-", "1"}], "]"}]}], ",", 
           SqrtBox["3"], ",", "\[Zeta]list"}], "}"}], "//", "Flatten"}], ",", 
        "Together"}], "]"}], "]"}]}]}]}], ";"}]], "Input",
 CellChangeTimes->{{3.5559718300772753`*^9, 3.55597194340414*^9}, {
  3.5559720037192907`*^9, 3.555972004057221*^9}, {3.555972897850429*^9, 
  3.555972969954962*^9}, {3.5559739508679857`*^9, 3.5559739567040462`*^9}, {
  3.5559741364815598`*^9, 3.555974232225295*^9}, {3.5559742669830093`*^9, 
  3.555974270839789*^9}, {3.5559744780084753`*^9, 3.555974480231059*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"SetDirectory", "[", 
  RowBox[{"NotebookDirectory", "[", "]"}], "]"}]], "Input",
 CellChangeTimes->{{3.5560346006403027`*^9, 3.556034609868433*^9}}],

Cell[BoxData["\<\"/Users/dmytrov/Dropbox/konishi7\"\>"], "Output",
 CellChangeTimes->{3.556034610253612*^9, 3.5603400021232853`*^9}]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"manswertmp2", ">>", "\"\<manswer2.data\>\""}], ";"}]], "Input",
 CellChangeTimes->{{3.556034587988665*^9, 3.5560346259383717`*^9}, {
  3.560339996868409*^9, 3.56033999701972*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"SetDirectory", "[", 
   RowBox[{"NotebookDirectory", "[", "]"}], "]"}], ";"}]], "Input",
 CellChangeTimes->{{3.559038509481771*^9, 3.559038519502283*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"manswer2", "=", 
   RowBox[{"<<", "manswer2.data"}]}], ";"}]], "Input"]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell["\<\
Correction to U and 5th order of H (leading double wrapping)\
\>", "Section",
 CellChangeTimes->{{3.5413970581295958`*^9, 3.541397061343525*^9}, {
   3.54988220878127*^9, 3.549882221850399*^9}, {3.552193238013246*^9, 
   3.5521932539051723`*^9}, 3.5537720339020433`*^9, {3.556010238345666*^9, 
   3.556010269789706*^9}, {3.56094011444121*^9, 3.560940116095921*^9}, {
   3.562235254765493*^9, 3.562235256652944*^9}, {3.562910524942194*^9, 
   3.56291052508632*^9}, {3.563513460250736*^9, 3.563513461711478*^9}, {
   3.568968938698444*^9, 3.568968955907486*^9}}],

Cell[CellGroupData[{

Cell["Checking asymptotic solution.", "Subsection",
 CellChangeTimes->{{3.556010273555931*^9, 3.556010275573719*^9}, {
  3.556010584484552*^9, 3.556010588033865*^9}}],

Cell["Equation on U reads", "Text",
 CellChangeTimes->{{3.5560102775818577`*^9, 3.556010280029276*^9}}],

Cell[BoxData[
 RowBox[{
  SuperscriptBox[
   RowBox[{"(", 
    RowBox[{
     FractionBox[
      SuperscriptBox[
       OverscriptBox[
        StyleBox["h",
         FontColor->RGBColor[0, 0.6, 0]], 
        StyleBox["^",
         FontColor->RGBColor[0, 0.6, 0]]], 
       RowBox[{"[", "2", "]"}]], 
      RowBox[{
       OverscriptBox[
        StyleBox["h",
         FontColor->RGBColor[0, 0.6, 0]], 
        StyleBox["^",
         FontColor->RGBColor[0, 0.6, 0]]], " "}]], 
     FractionBox[
      StyleBox["U",
       FontColor->RGBColor[0, 0.6, 0]], 
      SuperscriptBox[
       StyleBox["U",
        FontColor->RGBColor[0, 0.6, 0]], 
       RowBox[{"[", "2", "]"}]]]}], ")"}], "2"], "\[Equal]", 
  RowBox[{
   RowBox[{"(", 
    FractionBox[
     SubscriptBox[
      StyleBox["Y",
       FontColor->RGBColor[0, 0, 0.8]], 
      RowBox[{"1", ",", "1"}]], 
     SubscriptBox[
      StyleBox["Y",
       FontColor->RGBColor[0, 0, 0.8]], 
      RowBox[{"2", ",", "2"}]]], ")"}], 
   RowBox[{"(", 
    RowBox[{
     SubsuperscriptBox[
      StyleBox["Y",
       FontColor->RGBColor[0, 0, 0.8]], 
      RowBox[{"1", ",", "1"}], 
      RowBox[{"[", "2", "]"}]], " ", 
     SubsuperscriptBox[
      StyleBox["Y",
       FontColor->RGBColor[0, 0, 0.8]], 
      RowBox[{"2", ",", "2"}], 
      RowBox[{"[", "2", "]"}]]}], ")"}], 
   RowBox[{"(", 
    FractionBox[
     RowBox[{
      SubsuperscriptBox[
       StyleBox["\[GothicCapitalT]",
        FontColor->RGBColor[0.54, 0.35, 0.15]], 
       RowBox[{"0", ",", "0"}], "-"], " ", 
      SubsuperscriptBox[
       StyleBox["\[GothicCapitalT]",
        FontColor->RGBColor[0.54, 0.35, 0.15]], 
       RowBox[{"0", ",", "0"}], "+"]}], 
     RowBox[{
      SubscriptBox[
       StyleBox["\[GothicCapitalT]",
        FontColor->RGBColor[0.54, 0.35, 0.15]], 
       RowBox[{"1", ",", "0"}]], " ", 
      SubsuperscriptBox[
       StyleBox["\[GothicCapitalT]",
        FontColor->RGBColor[0.54, 0.35, 0.15]], 
       RowBox[{"1", ",", "0"}], 
       RowBox[{"[", "2", "]"}]]}]], ")"}], 
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox[
      RowBox[{
       SuperscriptBox[
        StyleBox["\[ScriptCapitalT]",
         FontColor->RGBColor[1, 0, 0]], "-"], " ", 
       SubscriptBox[
        StyleBox["\[GothicCapitalT]",
         FontColor->RGBColor[0.54, 0.35, 0.15]], 
        RowBox[{"2", ",", "1"}]]}], 
      RowBox[{
       SubscriptBox[
        StyleBox["\[ScriptCapitalT]",
         FontColor->RGBColor[1, 0, 0]], 
        RowBox[{"1", ",", "2"}]], " ", 
       SuperscriptBox[
        StyleBox["\[GothicCapitalT]",
         FontColor->RGBColor[0.54, 0.35, 0.15]], "-"]}]], ")"}], 
    "2"]}]}]], "Input",
 CellChangeTimes->{{3.55601028591969*^9, 3.5560104398516903`*^9}, {
  3.5560105231331882`*^9, 3.556010557803398*^9}}],

Cell["We will write down now asymptotic solution", "Text",
 CellChangeTimes->{{3.556010591665895*^9, 3.556010598505175*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      FractionBox[
       SubscriptBox["Y", 
        RowBox[{"1", ",", "1"}]], 
       SubscriptBox["Y", 
        RowBox[{"2", ",", "2"}]]], 
      FractionBox[
       SubsuperscriptBox[
        StyleBox["\[GothicCapitalT]",
         FontColor->RGBColor[0.54, 0.35, 0.15]], 
        RowBox[{"2", ",", "1"}], "2"], 
       SubsuperscriptBox[
        StyleBox["\[ScriptCapitalT]",
         FontColor->RGBColor[1, 0, 0]], 
        RowBox[{"1", ",", "2"}], "2"]]}], ")"}], "==", 
    RowBox[{
     SuperscriptBox[
      RowBox[{"(", 
       FractionBox["1", 
        RowBox[{
         SuperscriptBox[
          OverscriptBox[
           StyleBox["y",
            FontColor->RGBColor[0, 0.6, 0]], 
           StyleBox["^",
            FontColor->RGBColor[0, 0.6, 0]]], "-"], " ", 
         SuperscriptBox[
          OverscriptBox[
           StyleBox["y",
            FontColor->RGBColor[0, 0.6, 0]], 
           StyleBox["^",
            FontColor->RGBColor[0, 0.6, 0]]], "+"]}]], ")"}], "2"], 
     RowBox[{"(", 
      FractionBox[
       RowBox[{
        SuperscriptBox[
         StyleBox["\[GothicCapitalT]",
          FontColor->RGBColor[0.54, 0.35, 0.15]], "-"], 
        SubsuperscriptBox[
         StyleBox["\[GothicCapitalT]",
          FontColor->RGBColor[0.54, 0.35, 0.15]], "*", "-"], 
        SuperscriptBox[
         StyleBox["\[GothicCapitalT]",
          FontColor->RGBColor[0.54, 0.35, 0.15]], "+"], 
        SubsuperscriptBox[
         StyleBox["\[GothicCapitalT]",
          FontColor->RGBColor[0.54, 0.35, 0.15]], "*", "+"], " "}], 
       RowBox[{
        SuperscriptBox[
         StyleBox["\[ScriptCapitalT]",
          FontColor->RGBColor[1, 0, 0]], "-"], 
        SubsuperscriptBox[
         StyleBox["\[ScriptCapitalT]",
          FontColor->RGBColor[1, 0, 0]], "*", "-"], " ", 
        SuperscriptBox[
         StyleBox["\[ScriptCapitalT]",
          FontColor->RGBColor[1, 0, 0]], "+"], 
        SubsuperscriptBox[
         StyleBox["\[ScriptCapitalT]",
          FontColor->RGBColor[1, 0, 0]], "*", "+"]}]], ")"}]}]}], ",", 
   RowBox[{
    RowBox[{
     SubscriptBox["Y", 
      RowBox[{"1", ",", "1"}]], 
     SubscriptBox["Y", 
      RowBox[{"2", ",", "2"}]]}], "\[Equal]", 
    FractionBox[
     RowBox[{
      StyleBox["Bm",
       FontColor->RGBColor[0, 0.6, 0]], " ", 
      StyleBox["Rp",
       FontColor->RGBColor[0, 0.6, 0]]}], 
     RowBox[{
      StyleBox["Bp",
       FontColor->RGBColor[0, 0.6, 0]], " ", 
      StyleBox["Rm",
       FontColor->RGBColor[0, 0.6, 0]]}]]}], ",", 
   RowBox[{
    FractionBox[
     StyleBox["\[GothicCapitalT]",
      FontColor->RGBColor[0.54, 0.35, 0.15]], 
     RowBox[{
      SuperscriptBox[
       OverscriptBox[
        StyleBox["y",
         FontColor->RGBColor[0, 0.6, 0]], 
        StyleBox["^",
         FontColor->RGBColor[0, 0.6, 0]]], "-"], " ", 
      SuperscriptBox[
       OverscriptBox[
        StyleBox["y",
         FontColor->RGBColor[0, 0.6, 0]], 
        StyleBox["^",
         FontColor->RGBColor[0, 0.6, 0]]], "+"], 
      StyleBox["\[ScriptCapitalT]",
       FontColor->RGBColor[1, 0, 0]]}]], "\[Equal]", 
    FractionBox[
     RowBox[{
      SuperscriptBox["Bp", "-"], 
      SuperscriptBox["x", "-"]}], 
     RowBox[{
      SuperscriptBox["Bm", "+"], 
      SuperscriptBox["x", "+"]}]]}]}], "}"}]], "Input",
 CellChangeTimes->{{3.556010636107394*^9, 3.556010649272551*^9}, 
   3.556010804483919*^9}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{
      SuperscriptBox[
       RowBox[{"(", 
        FractionBox["1", 
         RowBox[{
          SuperscriptBox[
           OverscriptBox[
            StyleBox["y",
             FontColor->RGBColor[0, 0.6, 0]], 
            StyleBox["^",
             FontColor->RGBColor[0, 0.6, 0]]], "-"], " ", 
          SuperscriptBox[
           OverscriptBox[
            StyleBox["y",
             FontColor->RGBColor[0, 0.6, 0]], 
            StyleBox["^",
             FontColor->RGBColor[0, 0.6, 0]]], "+"]}]], ")"}], "2"], 
      RowBox[{"(", 
       FractionBox[
        RowBox[{
         SuperscriptBox[
          StyleBox["\[GothicCapitalT]",
           FontColor->RGBColor[0.54, 0.35, 0.15]], "-"], 
         SubsuperscriptBox[
          StyleBox["\[GothicCapitalT]",
           FontColor->RGBColor[0.54, 0.35, 0.15]], "\[FivePointedStar]", "-"], 
         SuperscriptBox[
          StyleBox["\[GothicCapitalT]",
           FontColor->RGBColor[0.54, 0.35, 0.15]], "+"], 
         SubsuperscriptBox[
          StyleBox["\[GothicCapitalT]",
           FontColor->RGBColor[0.54, 0.35, 0.15]], "\[FivePointedStar]", "+"],
          " "}], 
        RowBox[{
         SuperscriptBox[
          StyleBox["\[ScriptCapitalT]",
           FontColor->RGBColor[1, 0, 0]], "-"], 
         SubsuperscriptBox[
          StyleBox["\[ScriptCapitalT]",
           FontColor->RGBColor[1, 0, 0]], "\[FivePointedStar]", "-"], " ", 
         SuperscriptBox[
          StyleBox["\[ScriptCapitalT]",
           FontColor->RGBColor[1, 0, 0]], "+"], 
         SubsuperscriptBox[
          StyleBox["\[ScriptCapitalT]",
           FontColor->RGBColor[1, 0, 0]], "\[FivePointedStar]", "+"]}]], 
       ")"}], 
      RowBox[{"(", 
       RowBox[{
        FractionBox[
         RowBox[{
          StyleBox["Bm",
           FontColor->RGBColor[0, 0.6, 0]], " ", 
          StyleBox["Rp",
           FontColor->RGBColor[0, 0.6, 0]]}], 
         RowBox[{
          StyleBox["Bp",
           FontColor->RGBColor[0, 0.6, 0]], " ", 
          StyleBox["Rm",
           FontColor->RGBColor[0, 0.6, 0]]}]], "/.", 
        RowBox[{"Shift", "[", "2", "]"}]}], ")"}], 
      RowBox[{"(", 
       RowBox[{
        FractionBox[
         RowBox[{
          SubsuperscriptBox[
           StyleBox["\[GothicCapitalT]",
            FontColor->RGBColor[0.54, 0.35, 0.15]], 
           RowBox[{"0", ",", "0"}], "-"], " ", 
          SubsuperscriptBox[
           StyleBox["\[GothicCapitalT]",
            FontColor->RGBColor[0.54, 0.35, 0.15]], 
           RowBox[{"0", ",", "0"}], "+"]}], 
         RowBox[{
          SubscriptBox[
           StyleBox["\[GothicCapitalT]",
            FontColor->RGBColor[0.54, 0.35, 0.15]], 
           RowBox[{"1", ",", "0"}]], " ", 
          SubsuperscriptBox[
           StyleBox["\[GothicCapitalT]",
            FontColor->RGBColor[0.54, 0.35, 0.15]], 
           RowBox[{"1", ",", "0"}], 
           RowBox[{"[", "2", "]"}]]}]], "/.", "largevolume"}], ")"}], 
      SuperscriptBox[
       RowBox[{"(", 
        FractionBox[
         SuperscriptBox[
          StyleBox["\[ScriptCapitalT]",
           FontColor->RGBColor[1, 0, 0]], "-"], 
         RowBox[{" ", 
          SuperscriptBox[
           StyleBox["\[GothicCapitalT]",
            FontColor->RGBColor[0.54, 0.35, 0.15]], "-"]}]], ")"}], "2"]}], "//.", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{
        SubsuperscriptBox[
         StyleBox["\[GothicCapitalT]",
          FontColor->RGBColor[0.54, 0.35, 0.15]], "\[FivePointedStar]", 
         RowBox[{"[", 
          RowBox[{"r_", ":", "0"}], "]"}]], "\[RuleDelayed]", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{
             SuperscriptBox[
              OverscriptBox[
               StyleBox["y",
                FontColor->RGBColor[0, 0.6, 0]], 
               StyleBox["^",
                FontColor->RGBColor[0, 0.6, 0]]], "-"], " ", 
             SuperscriptBox[
              OverscriptBox[
               StyleBox["y",
                FontColor->RGBColor[0, 0.6, 0]], 
               StyleBox["^",
                FontColor->RGBColor[0, 0.6, 0]]], "+"], 
             FractionBox[
              RowBox[{
               SuperscriptBox["Bp", "-"], 
               SuperscriptBox["x", "-"]}], 
              RowBox[{
               SuperscriptBox["Bm", "+"], 
               SuperscriptBox["x", "+"]}]], 
             SubscriptBox["\[ScriptCapitalT]", "\[FivePointedStar]"]}], "/.", 
            
            RowBox[{"Shift", "[", "r", "]"}]}], ")"}], "/.", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"Bp", "\[Rule]", "Rp"}], ",", 
            RowBox[{"Bm", "\[Rule]", "Rm"}], ",", 
            RowBox[{"x", "\[Rule]", 
             FractionBox["1", "x"]}]}], "}"}]}], ")"}]}], ",", 
       RowBox[{
        SuperscriptBox[
         StyleBox["\[GothicCapitalT]",
          FontColor->RGBColor[0.54, 0.35, 0.15]], 
         RowBox[{"[", 
          RowBox[{"r_", ":", "0"}], "]"}]], "\[RuleDelayed]", " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{
           SuperscriptBox[
            OverscriptBox[
             StyleBox["y",
              FontColor->RGBColor[0, 0.6, 0]], 
             StyleBox["^",
              FontColor->RGBColor[0, 0.6, 0]]], "-"], " ", 
           SuperscriptBox[
            OverscriptBox[
             StyleBox["y",
              FontColor->RGBColor[0, 0.6, 0]], 
             StyleBox["^",
              FontColor->RGBColor[0, 0.6, 0]]], "+"], 
           FractionBox[
            RowBox[{
             SuperscriptBox["Bp", "-"], 
             SuperscriptBox["x", "-"]}], 
            RowBox[{
             SuperscriptBox["Bm", "+"], 
             SuperscriptBox["x", "+"]}]], "\[ScriptCapitalT]"}], "/.", 
          RowBox[{"Shift", "[", "r", "]"}]}], ")"}]}]}], "}"}]}], "//.", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{
       RowBox[{"bb_.", 
        SuperscriptBox[
         RowBox[{"(", 
          SuperscriptBox["Bp", 
           RowBox[{"[", 
            RowBox[{"r_:", "0"}], "]"}]], ")"}], "a_."], 
        SuperscriptBox[
         RowBox[{"(", 
          SuperscriptBox["Rp", 
           RowBox[{"[", 
            RowBox[{"r_:", "0"}], "]"}]], ")"}], "a_."]}], "\[RuleDelayed]", 
       " ", 
       RowBox[{"bb", 
        SuperscriptBox[
         RowBox[{"(", 
          SuperscriptBox["Q", 
           RowBox[{"[", 
            RowBox[{"r", "+", "1"}], "]"}]], ")"}], "a"]}]}], ",", 
      RowBox[{
       RowBox[{"bb_.", 
        SuperscriptBox[
         RowBox[{"(", 
          SuperscriptBox["Bm", 
           RowBox[{"[", 
            RowBox[{"r_:", "0"}], "]"}]], ")"}], "a_."], 
        SuperscriptBox[
         RowBox[{"(", 
          SuperscriptBox["Rm", 
           RowBox[{"[", 
            RowBox[{"r_:", "0"}], "]"}]], ")"}], "a_."]}], "\[RuleDelayed]", 
       RowBox[{"bb", " ", 
        SuperscriptBox[
         RowBox[{"(", 
          SuperscriptBox["Q", 
           RowBox[{"[", 
            RowBox[{"r", "-", "1"}], "]"}]], ")"}], "a"]}]}]}], "}"}]}], "/.", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"Rm", "\[Rule]", 
      FractionBox[
       SuperscriptBox["Q", "-"], "Bm"]}], ",", 
     RowBox[{
      SuperscriptBox["Rp", 
       RowBox[{"[", "2", "]"}]], "\[Rule]", 
      FractionBox[
       SuperscriptBox["Q", 
        RowBox[{"[", "3", "]"}]], 
       SuperscriptBox["Bp", 
        RowBox[{"[", "2", "]"}]]]}]}], "}"}]}], "//", "Factor"}]], "Input",
 CellChangeTimes->{{3.5560106869590893`*^9, 3.5560107457194242`*^9}, {
   3.5560107987178297`*^9, 3.556010825173634*^9}, {3.556011016118394*^9, 
   3.5560110503781233`*^9}, {3.556011085827742*^9, 3.55601117597302*^9}, {
   3.556011359407148*^9, 3.556011502980682*^9}, 3.556011558677383*^9, {
   3.5560115904545116`*^9, 3.556011613516683*^9}, {3.5560116574165983`*^9, 
   3.556011660397353*^9}}],

Cell[BoxData[
 FractionBox[
  RowBox[{
   SuperscriptBox[
    StyleBox["Bm",
     FontColor->RGBColor[0, 0.6, 0]], "2"], " ", 
   SuperscriptBox[
    StyleBox["x",
     FontColor->RGBColor[0, 0.6, 0]], "2"]}], 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     SuperscriptBox[
      StyleBox["Bp",
       FontColor->RGBColor[0, 0.6, 0]], 
      RowBox[{"[", "2", "]"}]], ")"}], "2"], " ", 
   SuperscriptBox[
    RowBox[{"(", 
     SuperscriptBox[
      StyleBox["x",
       FontColor->RGBColor[0, 0.6, 0]], 
      RowBox[{"[", "2", "]"}]], ")"}], "2"]}]]], "Output",
 CellChangeTimes->{
  3.556011365880456*^9, {3.556011435478147*^9, 3.5560115034454403`*^9}, {
   3.556011556864195*^9, 3.556011559119*^9}, 3.556011615053993*^9, 
   3.556011660662862*^9, 3.5629120396705112`*^9}]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  SuperscriptBox[
   RowBox[{"(", 
    RowBox[{
     FractionBox[
      SuperscriptBox[
       StyleBox["h",
        FontColor->RGBColor[0, 0.6, 0]], 
       RowBox[{"[", "2", "]"}]], 
      RowBox[{
       StyleBox["h",
        FontColor->RGBColor[0, 0.6, 0]], " "}]], 
     FractionBox[
      StyleBox["U",
       FontColor->RGBColor[0, 0.6, 0]], 
      SuperscriptBox[
       StyleBox["U",
        FontColor->RGBColor[0, 0.6, 0]], 
       RowBox[{"[", "2", "]"}]]]}], ")"}], "2"], "\[Equal]", 
  SuperscriptBox[
   RowBox[{"(", 
    FractionBox[
     RowBox[{
      StyleBox["Bm",
       FontColor->RGBColor[0, 0.6, 0]], " ", 
      StyleBox["x",
       FontColor->RGBColor[0, 0.6, 0]]}], 
     RowBox[{
      SuperscriptBox[
       StyleBox["Bp",
        FontColor->RGBColor[0, 0.6, 0]], 
       RowBox[{"[", "2", "]"}]], 
      SuperscriptBox[
       StyleBox["x",
        FontColor->RGBColor[0, 0.6, 0]], 
       RowBox[{"[", "2", "]"}]]}]], ")"}], "2"]}]], "Input",
 CellChangeTimes->{{3.556011655420064*^9, 3.556011693347484*^9}}],

Cell["So indeed we get what we should", "Text",
 CellChangeTimes->{{3.556011695680377*^9, 3.5560116997436438`*^9}}],

Cell[BoxData[
 RowBox[{
  StyleBox["U",
   FontColor->RGBColor[0, 0.6, 0]], "\[Equal]", " ", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     StyleBox["h",
      FontColor->RGBColor[0, 0.6, 0]], " ", 
     StyleBox["x",
      FontColor->RGBColor[0, 0.6, 0]]}], ")"}], 
   RowBox[{"(", 
    StyleBox["Bm",
     FontColor->RGBColor[0, 0.6, 0]], ")"}], 
   StyleBox[" ",
    FontColor->RGBColor[0, 0.6, 0]], 
   SuperscriptBox[
    RowBox[{"(", 
     RowBox[{"-", 
      FractionBox[
       StyleBox["Bm",
        FontColor->RGBColor[0, 0.6, 0]], 
       StyleBox["Bp",
        FontColor->RGBColor[0, 0.6, 0]]]}], ")"}], 
    FractionBox[
     SuperscriptBox["D", "2"], 
     RowBox[{"1", "-", 
      SuperscriptBox["D", "2"]}]]]}]}]], "Input",
 CellChangeTimes->{{3.556011701278757*^9, 3.556011721218904*^9}, {
   3.5560117567700443`*^9, 3.556011779248089*^9}, {3.556012260215728*^9, 
   3.556012275218451*^9}, 3.559579156938843*^9}],

Cell["Indeed we should get", "Text",
 CellChangeTimes->{{3.556012183191811*^9, 3.556012188901126*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{
    FractionBox[
     SuperscriptBox["V", "+"], 
     SuperscriptBox["V", "-"]], "=", 
    RowBox[{
     FractionBox[
      SuperscriptBox["Bp", "+"], 
      SuperscriptBox["Bm", "+"]], 
     SubscriptBox["\[Sigma]", "BES"]}]}], ",", 
   RowBox[{"U", "\[Equal]", 
    RowBox[{
     FractionBox["1", 
      SqrtBox[
       SubscriptBox["C", "\[GothicCapitalT]"]]], "Bm", " ", 
     FractionBox["V", 
      SuperscriptBox["x", 
       RowBox[{"L", "/", "2"}]]]}]}], ",", 
   RowBox[{
    OverscriptBox[
     StyleBox["h",
      FontColor->RGBColor[0, 0.6, 0]], 
     StyleBox["^",
      FontColor->RGBColor[0, 0.6, 0]]], "\[Equal]", 
    RowBox[{"const", " ", 
     SubscriptBox["\[Sigma]", "1"], 
     SuperscriptBox[
      OverscriptBox[
       StyleBox["x",
        FontColor->RGBColor[0, 0.6, 0]], 
       StyleBox["^",
        FontColor->RGBColor[0, 0.6, 0]]], 
      RowBox[{
       RowBox[{"-", 
        FractionBox["L", "2"]}], "-", "1"}]]}]}]}], "}"}]], "Input",
 CellChangeTimes->{{3.556012224951342*^9, 3.5560122384239063`*^9}, {
  3.562911672999539*^9, 3.562911673781588*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["\<\
Substracting asymptotic solution (explicit integrals to compute)\
\>", "Subsection",
 CellChangeTimes->{{3.556012370481061*^9, 3.5560123754779167`*^9}, {
   3.5609401485197983`*^9, 3.56094016511836*^9}, {3.56138235660651*^9, 
   3.5613823618484592`*^9}, 3.562235362937294*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Log", "[", 
   SuperscriptBox[
    RowBox[{"(", 
     RowBox[{
      FractionBox[
       SuperscriptBox[
        OverscriptBox[
         StyleBox["h",
          FontColor->RGBColor[0, 0.6, 0]], 
         StyleBox["^",
          FontColor->RGBColor[0, 0.6, 0]]], 
        RowBox[{"[", "2", "]"}]], 
       RowBox[{
        OverscriptBox[
         StyleBox["h",
          FontColor->RGBColor[0, 0.6, 0]], 
         StyleBox["^",
          FontColor->RGBColor[0, 0.6, 0]]], " "}]], 
      FractionBox[
       StyleBox["U",
        FontColor->RGBColor[0, 0.6, 0]], 
       SuperscriptBox[
        StyleBox["U",
         FontColor->RGBColor[0, 0.6, 0]], 
        RowBox[{"[", "2", "]"}]]]}], ")"}], "2"], "]"}], "\[Equal]", 
  RowBox[{"Log", "[", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      FractionBox[
       SubscriptBox[
        StyleBox["Y",
         FontColor->RGBColor[0, 0, 0.8]], 
        RowBox[{"1", ",", "1"}]], 
       SubscriptBox[
        StyleBox["Y",
         FontColor->RGBColor[0, 0, 0.8]], 
        RowBox[{"2", ",", "2"}]]], 
      SuperscriptBox[
       RowBox[{"(", 
        FractionBox[
         SubscriptBox[
          StyleBox["\[GothicCapitalT]",
           FontColor->RGBColor[0.54, 0.35, 0.15]], 
          RowBox[{"2", ",", "1"}]], 
         SubscriptBox[
          StyleBox["\[ScriptCapitalT]",
           FontColor->RGBColor[1, 0, 0]], 
          RowBox[{"1", ",", "2"}]]], ")"}], "2"]}], ")"}], 
    RowBox[{"(", 
     RowBox[{
      SubsuperscriptBox[
       StyleBox["Y",
        FontColor->RGBColor[0, 0, 0.8]], 
       RowBox[{"1", ",", "1"}], 
       RowBox[{"[", "2", "]"}]], " ", 
      SubsuperscriptBox[
       StyleBox["Y",
        FontColor->RGBColor[0, 0, 0.8]], 
       RowBox[{"2", ",", "2"}], 
       RowBox[{"[", "2", "]"}]]}], ")"}], 
    RowBox[{"(", 
     FractionBox[
      RowBox[{
       SubsuperscriptBox[
        StyleBox["\[GothicCapitalT]",
         FontColor->RGBColor[0.54, 0.35, 0.15]], 
        RowBox[{"0", ",", "0"}], "-"], " ", 
       SubsuperscriptBox[
        StyleBox["\[GothicCapitalT]",
         FontColor->RGBColor[0.54, 0.35, 0.15]], 
        RowBox[{"0", ",", "0"}], "+"]}], 
      RowBox[{
       SubscriptBox[
        StyleBox["\[GothicCapitalT]",
         FontColor->RGBColor[0.54, 0.35, 0.15]], 
        RowBox[{"1", ",", "0"}]], " ", 
       SubsuperscriptBox[
        StyleBox["\[GothicCapitalT]",
         FontColor->RGBColor[0.54, 0.35, 0.15]], 
        RowBox[{"1", ",", "0"}], 
        RowBox[{"[", "2", "]"}]]}]], ")"}], 
    SuperscriptBox[
     RowBox[{"(", 
      FractionBox[
       SuperscriptBox[
        StyleBox["\[ScriptCapitalT]",
         FontColor->RGBColor[1, 0, 0]], "-"], 
       RowBox[{" ", 
        SuperscriptBox[
         StyleBox["\[GothicCapitalT]",
          FontColor->RGBColor[0.54, 0.35, 0.15]], "-"]}]], ")"}], "2"]}], 
   "]"}]}]], "Input",
 CellChangeTimes->{{3.5560124326285963`*^9, 3.556012436710931*^9}, {
  3.556014568910144*^9, 3.55601458664167*^9}}],

Cell["We now remind equations Y11Y22 and Y11/Y22:", "Text",
 CellChangeTimes->{{3.556047314451645*^9, 3.5560473304332*^9}}],

Cell[BoxData[
 RowBox[{
  SubscriptBox[
   RowBox[{"(", 
    FractionBox[
     RowBox[{
      SubsuperscriptBox[
       StyleBox["\[GothicCapitalT]",
        FontColor->RGBColor[0.54, 0.35, 0.15]], 
       RowBox[{"0", ",", "0"}], "-"], " ", 
      SubsuperscriptBox[
       StyleBox["\[GothicCapitalT]",
        FontColor->RGBColor[0.54, 0.35, 0.15]], 
       RowBox[{"0", ",", "0"}], "+"]}], 
     RowBox[{
      SubscriptBox[
       StyleBox["\[GothicCapitalT]",
        FontColor->RGBColor[0.54, 0.35, 0.15]], 
       RowBox[{"1", ",", "0"}]], " ", 
      SubsuperscriptBox[
       StyleBox["\[GothicCapitalT]",
        FontColor->RGBColor[0.54, 0.35, 0.15]], 
       RowBox[{"1", ",", "0"}], 
       RowBox[{"[", "2", "]"}]]}]], ")"}], "r"], "\[Equal]", 
  FractionBox["1", 
   RowBox[{
    OverscriptBox[
     StyleBox["H",
      FontColor->RGBColor[0.54, 0.35, 0.15]], 
     StyleBox["_",
      FontColor->RGBColor[0.54, 0.35, 0.15]]], 
    RowBox[{"(", 
     SuperscriptBox[
      OverscriptBox[
       StyleBox["H",
        FontColor->RGBColor[0.54, 0.35, 0.15]], 
       StyleBox["_",
        FontColor->RGBColor[0.54, 0.35, 0.15]]], 
      RowBox[{"[", "2", "]"}]], ")"}]}]]}]], "Input",
 CellChangeTimes->{{3.556047352621961*^9, 3.5560473658437366`*^9}, {
  3.5629122928355293`*^9, 3.562912293192791*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Log", "[", 
    SubscriptBox[
     RowBox[{"(", 
      RowBox[{
       SubscriptBox["Y", 
        RowBox[{"1", ",", "1"}]], 
       SubscriptBox["Y", 
        RowBox[{"2", ",", "2"}]]}], ")"}], "r"], "]"}], "[", "v", "]"}], "=", 
  
  RowBox[{
   RowBox[{"Yf", "[", "v", "]"}], "\[Equal]", 
   RowBox[{
    OverscriptBox["H", "_"], "+", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{"-", 
        FractionBox["v", "g"]}], 
       SqrtBox[
        RowBox[{"1", "-", 
         FractionBox[
          RowBox[{"4", 
           SuperscriptBox["g", "2"]}], 
          SuperscriptBox["v", "2"]]}]]}], ")"}], 
     RowBox[{
      SubsuperscriptBox["\[Integral]", 
       RowBox[{"-", "\[Infinity]"}], 
       RowBox[{"+", "\[Infinity]"}]], 
      RowBox[{
       FractionBox["du", 
        RowBox[{
         RowBox[{"-", "2"}], "\[Pi]", " ", "\[ImaginaryI]"}]], 
       RowBox[{"(", 
        RowBox[{
         FractionBox["1", 
          RowBox[{"v", "-", "u"}]], "-", 
         FractionBox["1", 
          RowBox[{"v", "+", "u"}]]}], ")"}], 
       SuperscriptBox[
        RowBox[{"(", 
         RowBox[{
          FractionBox["1", 
           RowBox[{
            FractionBox["u", "g"], 
            SqrtBox[
             RowBox[{"1", "-", 
              FractionBox[
               RowBox[{"4", 
                SuperscriptBox["g", "2"]}], 
               SuperscriptBox["u", "2"]]}]]}]], "H"}], ")"}], 
        RowBox[{"[", 
         RowBox[{"-", "o"}], "]"}]]}]}]}]}]}]}]], "Input",
 CellChangeTimes->{
  3.556047342676474*^9, {3.5560473930653753`*^9, 3.556047448345768*^9}, {
   3.5609402896414137`*^9, 3.56094029409165*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Log", "[", 
    SubscriptBox[
     RowBox[{"(", 
      RowBox[{
       FractionBox[
        SubscriptBox["Y", 
         RowBox[{"1", ",", "1"}]], 
        SubscriptBox["Y", 
         RowBox[{"2", ",", "2"}]]], 
       SuperscriptBox[
        RowBox[{"(", 
         FractionBox[
          SubscriptBox[
           StyleBox["\[GothicCapitalT]",
            FontColor->RGBColor[0.54, 0.35, 0.15]], 
           RowBox[{"2", ",", "1"}]], 
          SubscriptBox[
           StyleBox["\[ScriptCapitalT]",
            FontColor->RGBColor[1, 0, 0]], 
           RowBox[{"1", ",", "2"}]]], ")"}], "2"]}], ")"}], "r"], "]"}], "[", 
   "v", "]"}], "=", 
  RowBox[{
   RowBox[{"Yof", "[", "v", "]"}], "\[Equal]", 
   RowBox[{
    OverscriptBox["H", "_"], "-", 
    RowBox[{"Log", "[", 
     SuperscriptBox[
      SubscriptBox[
       RowBox[{"(", 
        FractionBox[
         RowBox[{" ", 
          SuperscriptBox[
           StyleBox["\[ScriptCapitalT]",
            FontColor->RGBColor[1, 0, 0]], "-"], " "}], 
         SuperscriptBox[
          StyleBox["\[GothicCapitalT]",
           FontColor->RGBColor[0.54, 0.35, 0.15]], "-"]], ")"}], "r"], "2"], 
     "]"}], "+", 
    RowBox[{
     SubsuperscriptBox["\[Integral]", "\[Infinity]", 
      RowBox[{"+", "\[Infinity]"}]], 
     RowBox[{
      FractionBox["du", 
       RowBox[{
        RowBox[{"-", "2"}], "\[Pi]", " ", "\[ImaginaryI]"}]], 
      RowBox[{"(", 
       RowBox[{
        FractionBox["1", 
         RowBox[{"v", "-", "u"}]], "-", 
        FractionBox["1", 
         RowBox[{"v", "+", "u"}]]}], ")"}], 
      SuperscriptBox[
       RowBox[{"(", 
        RowBox[{"H", "-", 
         RowBox[{"Log", "[", 
          SuperscriptBox[
           SubscriptBox[
            RowBox[{"(", 
             FractionBox[
              RowBox[{" ", 
               SuperscriptBox[
                StyleBox["\[ScriptCapitalT]",
                 FontColor->RGBColor[1, 0, 0]], "+"], " "}], 
              SuperscriptBox[
               StyleBox["\[GothicCapitalT]",
                FontColor->RGBColor[0.54, 0.35, 0.15]], "+"]], ")"}], "r"], 
           "2"], "]"}]}], ")"}], 
       RowBox[{"[", 
        RowBox[{"-", "o"}], "]"}]]}]}]}]}]}]], "Input",
 CellChangeTimes->{{3.5560473834500113`*^9, 3.556047387933041*^9}, {
  3.556047450950101*^9, 3.55604745167168*^9}, {3.560940255796462*^9, 
  3.560940275770192*^9}}],

Cell["\<\
We see that many things cancel and we arrive at quite simple integral \
equation for Im[v]>0 (it should be so, U/h represent a special analytic \
combination):\
\>", "Text",
 CellChangeTimes->{{3.556047459715938*^9, 3.5560474747948513`*^9}, {
  3.556047721387048*^9, 3.55604772588302*^9}, {3.560941572241961*^9, 
  3.560941589895588*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Log", "[", 
    SubscriptBox[
     RowBox[{"(", 
      RowBox[{
       FractionBox[
        SuperscriptBox[
         OverscriptBox[
          StyleBox["h",
           FontColor->RGBColor[0, 0.6, 0]], 
          StyleBox["^",
           FontColor->RGBColor[0, 0.6, 0]]], 
         RowBox[{"[", "2", "]"}]], 
        RowBox[{
         OverscriptBox[
          StyleBox["h",
           FontColor->RGBColor[0, 0.6, 0]], 
          StyleBox["^",
           FontColor->RGBColor[0, 0.6, 0]]], " "}]], 
       FractionBox[
        StyleBox["U",
         FontColor->RGBColor[0, 0.6, 0]], 
        SuperscriptBox[
         StyleBox["U",
          FontColor->RGBColor[0, 0.6, 0]], 
         RowBox[{"[", "2", "]"}]]]}], ")"}], "r"], "]"}], "[", "v", "]"}], 
  "\[Equal]", 
  RowBox[{
   RowBox[{
    FractionBox["1", "2"], 
    RowBox[{"\[DoubleStruckCapitalC]", "[", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        FractionBox["1", 
         RowBox[{"v", "-", "u"}]], "-", 
        FractionBox["1", 
         RowBox[{"v", "+", "u"}]]}], ")"}], "H"}], "]"}]}], "+", 
   RowBox[{
    FractionBox["1", "2"], 
    RowBox[{"\[DoubleStruckCapitalC]", "[", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        FractionBox["1", 
         RowBox[{"v", "+", "\[ImaginaryI]", "-", "u"}]], "-", 
        FractionBox["1", 
         RowBox[{"v", "+", "\[ImaginaryI]", "+", "u"}]]}], ")"}], 
      FractionBox[
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", 
          FractionBox[
           RowBox[{"v", "+", "\[ImaginaryI]"}], "g"]}], 
         SqrtBox[
          RowBox[{"1", "-", 
           FractionBox[
            RowBox[{"4", 
             SuperscriptBox["g", "2"]}], 
            SuperscriptBox[
             RowBox[{"(", 
              RowBox[{"v", "+", "\[ImaginaryI]"}], ")"}], "2"]]}]]}], ")"}], 
       RowBox[{
        FractionBox["u", "g"], 
        SqrtBox[
         RowBox[{"1", "-", 
          FractionBox[
           RowBox[{"4", 
            SuperscriptBox["g", "2"]}], 
           SuperscriptBox["u", "2"]]}]]}]], "H"}], "]"}]}], "+", 
   RowBox[{"\[DoubleStruckCapitalC]", "[", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       FractionBox["1", 
        RowBox[{"v", "-", "u"}]], "-", 
       FractionBox["1", 
        RowBox[{"v", "+", "u"}]]}], ")"}], 
     RowBox[{"Log", "[", 
      SubscriptBox[
       RowBox[{"(", 
        FractionBox[
         RowBox[{
          SuperscriptBox[
           StyleBox["\[GothicCapitalT]",
            FontColor->RGBColor[0.54, 0.35, 0.15]], "+"], " "}], 
         SuperscriptBox[
          StyleBox["\[ScriptCapitalT]",
           FontColor->RGBColor[1, 0, 0]], "+"]], ")"}], "r"], "]"}]}], 
    "]"}]}]}]], "Input",
 CellChangeTimes->{{3.556047481854261*^9, 3.556047663808538*^9}, {
  3.556047728702054*^9, 3.55604773051369*^9}, {3.556048953105239*^9, 
  3.5560489553176203`*^9}, {3.5609416087569103`*^9, 3.560941657961896*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["Integrals with H = rltH", "Subsection",
 CellChangeTimes->{{3.55604775321795*^9, 3.556047756056683*^9}, 
   3.5609416733882627`*^9, 3.562247335635406*^9, {3.5629153018812637`*^9, 
   3.562915303374413*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   FractionBox["1", "2"], 
   RowBox[{"\[DoubleStruckCapitalC]", "[", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       FractionBox["1", 
        RowBox[{"v", "-", "u"}]], "-", 
       FractionBox["1", 
        RowBox[{"v", "+", "u"}]]}], ")"}], "H"}], "]"}]}], "+", 
  RowBox[{
   FractionBox["1", "2"], 
   RowBox[{"\[DoubleStruckCapitalC]", "[", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       FractionBox["1", 
        RowBox[{"v", "+", "\[ImaginaryI]", "-", "u"}]], "-", 
       FractionBox["1", 
        RowBox[{"v", "+", "\[ImaginaryI]", "+", "u"}]]}], ")"}], 
     FractionBox[
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", 
         FractionBox[
          RowBox[{"v", "+", "\[ImaginaryI]"}], "g"]}], 
        SqrtBox[
         RowBox[{"1", "-", 
          FractionBox[
           RowBox[{"4", 
            SuperscriptBox["g", "2"]}], 
           SuperscriptBox[
            RowBox[{"(", 
             RowBox[{"v", "+", "\[ImaginaryI]"}], ")"}], "2"]]}]]}], ")"}], 
      RowBox[{
       FractionBox["u", "g"], 
       SqrtBox[
        RowBox[{"1", "-", 
         FractionBox[
          RowBox[{"4", 
           SuperscriptBox["g", "2"]}], 
          SuperscriptBox["u", "2"]]}]]}]], "H"}], "]"}]}]}]], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ser1", "=", 
  RowBox[{"Apart", "[", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"Series", "[", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          RowBox[{
           FractionBox["1", "2"], 
           RowBox[{"(", 
            RowBox[{
             FractionBox["1", 
              RowBox[{"v", "-", "u"}]], "-", 
             FractionBox["1", 
              RowBox[{"v", "+", "u"}]]}], ")"}]}], "+", 
          RowBox[{
           FractionBox["1", "2"], 
           RowBox[{"(", 
            RowBox[{
             FractionBox["1", 
              RowBox[{"v", "+", "\[ImaginaryI]", "-", "u"}]], "-", 
             FractionBox["1", 
              RowBox[{"v", "+", "\[ImaginaryI]", "+", "u"}]]}], ")"}], 
           FractionBox[
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", 
               FractionBox[
                RowBox[{"v", "+", "\[ImaginaryI]"}], "g"]}], 
              SqrtBox[
               RowBox[{"1", "-", 
                FractionBox[
                 RowBox[{"4", 
                  SuperscriptBox["g", "2"]}], 
                 SuperscriptBox[
                  RowBox[{"(", 
                   RowBox[{"v", "+", "\[ImaginaryI]"}], ")"}], "2"]]}]]}], 
             ")"}], 
            RowBox[{
             FractionBox["u", "g"], 
             SqrtBox[
              RowBox[{"1", "-", 
               FractionBox[
                RowBox[{"4", 
                 SuperscriptBox["g", "2"]}], 
                SuperscriptBox["u", "2"]]}]]}]]}]}], ")"}], ",", 
        RowBox[{"{", 
         RowBox[{"g", ",", "0", ",", "0"}], "}"}]}], "]"}], "//", 
      "Simplify"}], "//", "Normal"}], ",", "u"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.55604910544945*^9, 3.556049131091072*^9}, 
   3.556049554844219*^9, {3.560941688509961*^9, 3.560941704485487*^9}, {
   3.560942687147101*^9, 3.560942694894885*^9}, {3.562247069116817*^9, 
   3.562247070961108*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"-", 
   FractionBox["1", 
    RowBox[{"2", " ", 
     RowBox[{"(", 
      RowBox[{"u", "-", "v"}], ")"}]}]]}], "+", 
  FractionBox["1", 
   RowBox[{"2", " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"-", "\[ImaginaryI]"}], "+", "u", "-", "v"}], ")"}]}]], "-", 
  FractionBox["1", 
   RowBox[{"2", " ", 
    RowBox[{"(", 
     RowBox[{"u", "+", "v"}], ")"}]}]], "-", 
  FractionBox["1", 
   RowBox[{"2", " ", 
    RowBox[{"(", 
     RowBox[{"\[ImaginaryI]", "+", "u", "+", "v"}], ")"}]}]]}]], "Output",
 CellChangeTimes->{
  3.55604955563029*^9, 3.5606204092624474`*^9, 3.560620951979719*^9, 
   3.560628439987013*^9, {3.560941698728346*^9, 3.560941705323628*^9}, 
   3.560942698668144*^9, 3.5614688665982*^9, {3.562247051760901*^9, 
   3.562247071395989*^9}, 3.562914030079558*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"$\[Delta]QCorrectiontoH", " ", "=", " ", "True"}], ";"}], 
  " "}], "\[IndentingNewLine]", 
 RowBox[{"H", "/.", 
  RowBox[{"leadweak", "[", "1", "]"}]}]}], "Input",
 CellChangeTimes->{{3.560620954647403*^9, 3.560620957601817*^9}, {
  3.560621069477974*^9, 3.560621084764955*^9}, {3.562914052633477*^9, 
  3.56291405502577*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   SuperscriptBox["g", "8"], " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{
      FractionBox["1", 
       SuperscriptBox[
        StyleBox["Q0",
         FontColor->RGBColor[{
            Rational[1, 2], 
            Rational[1, 2], 0}]], "+"]], 
      RowBox[{"(", 
       RowBox[{"108", "+", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{"54", "-", 
           RowBox[{"18", " ", "\[ImaginaryI]", " ", 
            SqrtBox["3"]}], "-", 
           RowBox[{"108", " ", "\[ImaginaryI]", " ", "u"}]}], ")"}], " ", 
         SubsuperscriptBox[
          StyleBox["\[Eta]0",
           FontWeight->Bold,
           FontColor->RGBColor[0, 0.5, 0]], "2", "+"]}], "+", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           RowBox[{
            RowBox[{"-", "18"}], " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "\[ImaginaryI]"}], "+", 
              SqrtBox["3"]}], ")"}]}], "+", 
           RowBox[{"36", " ", "\[ImaginaryI]", " ", 
            SqrtBox["3"], " ", "u"}]}], ")"}], " ", 
         SubsuperscriptBox[
          StyleBox["\[Eta]0",
           FontWeight->Bold,
           FontColor->RGBColor[0, 0.5, 0]], "3", "+"]}], "+", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{"9", "-", 
           RowBox[{"3", " ", "\[ImaginaryI]", " ", 
            SqrtBox["3"]}], "-", 
           RowBox[{"18", " ", "\[ImaginaryI]", " ", "u"}]}], ")"}], " ", 
         SubsuperscriptBox[
          StyleBox["\[Eta]0",
           FontWeight->Bold,
           FontColor->RGBColor[0, 0.5, 0]], "4", "+"]}], "+", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{"54", "+", 
           RowBox[{"18", " ", "\[ImaginaryI]", " ", 
            SqrtBox["3"]}], "-", 
           RowBox[{"108", " ", "\[ImaginaryI]", " ", "u"}]}], ")"}], " ", 
         SubsuperscriptBox[
          OverscriptBox[
           StyleBox["\[Eta]0",
            FontWeight->Bold,
            FontColor->RGBColor[0, 0.5, 0]], 
           StyleBox["_",
            FontWeight->Bold,
            FontColor->RGBColor[0, 0.5, 0]]], "2", "-"]}], "+", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           RowBox[{
            RowBox[{"-", "18"}], " ", 
            RowBox[{"(", 
             RowBox[{"\[ImaginaryI]", "+", 
              SqrtBox["3"]}], ")"}]}], "+", 
           RowBox[{"36", " ", "\[ImaginaryI]", " ", 
            SqrtBox["3"], " ", "u"}]}], ")"}], " ", 
         SubsuperscriptBox[
          OverscriptBox[
           StyleBox["\[Eta]0",
            FontWeight->Bold,
            FontColor->RGBColor[0, 0.5, 0]], 
           StyleBox["_",
            FontWeight->Bold,
            FontColor->RGBColor[0, 0.5, 0]]], "3", "-"]}], "+", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{"9", "+", 
           RowBox[{"3", " ", "\[ImaginaryI]", " ", 
            SqrtBox["3"]}], "-", 
           RowBox[{"18", " ", "\[ImaginaryI]", " ", "u"}]}], ")"}], " ", 
         SubsuperscriptBox[
          OverscriptBox[
           StyleBox["\[Eta]0",
            FontWeight->Bold,
            FontColor->RGBColor[0, 0.5, 0]], 
           StyleBox["_",
            FontWeight->Bold,
            FontColor->RGBColor[0, 0.5, 0]]], "4", "-"]}]}], ")"}]}], "+", 
     RowBox[{
      FractionBox["1", 
       SuperscriptBox[
        StyleBox["Q0",
         FontColor->RGBColor[{
            Rational[1, 2], 
            Rational[1, 2], 0}]], "-"]], 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "108"}], "+", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{"54", "+", 
           RowBox[{"18", " ", "\[ImaginaryI]", " ", 
            SqrtBox["3"]}], "+", 
           RowBox[{"108", " ", "\[ImaginaryI]", " ", "u"}]}], ")"}], " ", 
         SubsuperscriptBox[
          StyleBox["\[Eta]0",
           FontWeight->Bold,
           FontColor->RGBColor[0, 0.5, 0]], "2", "+"]}], "+", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           RowBox[{
            RowBox[{"-", "18"}], " ", 
            RowBox[{"(", 
             RowBox[{"\[ImaginaryI]", "+", 
              SqrtBox["3"]}], ")"}]}], "-", 
           RowBox[{"36", " ", "\[ImaginaryI]", " ", 
            SqrtBox["3"], " ", "u"}]}], ")"}], " ", 
         SubsuperscriptBox[
          StyleBox["\[Eta]0",
           FontWeight->Bold,
           FontColor->RGBColor[0, 0.5, 0]], "3", "+"]}], "+", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{"9", "+", 
           RowBox[{"3", " ", "\[ImaginaryI]", " ", 
            SqrtBox["3"]}], "+", 
           RowBox[{"18", " ", "\[ImaginaryI]", " ", "u"}]}], ")"}], " ", 
         SubsuperscriptBox[
          StyleBox["\[Eta]0",
           FontWeight->Bold,
           FontColor->RGBColor[0, 0.5, 0]], "4", "+"]}], "+", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{"54", "-", 
           RowBox[{"18", " ", "\[ImaginaryI]", " ", 
            SqrtBox["3"]}], "+", 
           RowBox[{"108", " ", "\[ImaginaryI]", " ", "u"}]}], ")"}], " ", 
         SubsuperscriptBox[
          OverscriptBox[
           StyleBox["\[Eta]0",
            FontWeight->Bold,
            FontColor->RGBColor[0, 0.5, 0]], 
           StyleBox["_",
            FontWeight->Bold,
            FontColor->RGBColor[0, 0.5, 0]]], "2", "-"]}], "+", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           RowBox[{
            RowBox[{"-", "18"}], " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", "\[ImaginaryI]"}], "+", 
              SqrtBox["3"]}], ")"}]}], "-", 
           RowBox[{"36", " ", "\[ImaginaryI]", " ", 
            SqrtBox["3"], " ", "u"}]}], ")"}], " ", 
         SubsuperscriptBox[
          OverscriptBox[
           StyleBox["\[Eta]0",
            FontWeight->Bold,
            FontColor->RGBColor[0, 0.5, 0]], 
           StyleBox["_",
            FontWeight->Bold,
            FontColor->RGBColor[0, 0.5, 0]]], "3", "-"]}], "+", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{"9", "-", 
           RowBox[{"3", " ", "\[ImaginaryI]", " ", 
            SqrtBox["3"]}], "+", 
           RowBox[{"18", " ", "\[ImaginaryI]", " ", "u"}]}], ")"}], " ", 
         SubsuperscriptBox[
          OverscriptBox[
           StyleBox["\[Eta]0",
            FontWeight->Bold,
            FontColor->RGBColor[0, 0.5, 0]], 
           StyleBox["_",
            FontWeight->Bold,
            FontColor->RGBColor[0, 0.5, 0]]], "4", "-"]}]}], ")"}]}]}], 
    ")"}]}], "+", 
  RowBox[{
   SuperscriptBox["g", "8"], " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"-", 
      FractionBox["6", 
       RowBox[{
        SuperscriptBox["u", "4"], " ", 
        SuperscriptBox[
         StyleBox["Q0",
          FontColor->RGBColor[{
             Rational[1, 2], 
             Rational[1, 2], 0}]], "-"]}]]}], "+", 
     FractionBox[
      RowBox[{"24", "-", 
       RowBox[{"36", " ", "\[ImaginaryI]", " ", "u"}]}], 
      RowBox[{
       SuperscriptBox["u", "4"], " ", 
       SuperscriptBox[
        StyleBox["Q0",
         FontColor->RGBColor[{
            Rational[1, 2], 
            Rational[1, 2], 0}]], "+"]}]], "+", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", 
         FractionBox["36", 
          SuperscriptBox["u", "4"]]}], "+", 
        FractionBox[
         RowBox[{
          RowBox[{"-", "12"}], "+", 
          FractionBox[
           RowBox[{"4", " ", "\[ImaginaryI]"}], "u"]}], 
         RowBox[{
          SuperscriptBox["u", "4"], " ", 
          SuperscriptBox[
           StyleBox["Q0",
            FontColor->RGBColor[{
               Rational[1, 2], 
               Rational[1, 2], 0}]], "-"]}]], "+", 
        FractionBox[
         RowBox[{
          RowBox[{"-", "12"}], "-", 
          FractionBox[
           RowBox[{"4", " ", "\[ImaginaryI]"}], "u"]}], 
         RowBox[{
          SuperscriptBox["u", "4"], " ", 
          SuperscriptBox[
           StyleBox["Q0",
            FontColor->RGBColor[{
               Rational[1, 2], 
               Rational[1, 2], 0}]], "+"]}]]}], ")"}], " ", 
      SubsuperscriptBox[
       StyleBox["\[Eta]",
        FontWeight->Bold,
        FontColor->RGBColor[0.8, 0, 0]], "2", 
       RowBox[{"[", "2", "]"}]]}], "+", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        FractionBox[
         RowBox[{"12", "-", 
          FractionBox[
           RowBox[{"8", " ", "\[ImaginaryI]"}], "u"]}], 
         RowBox[{
          SuperscriptBox["u", "3"], " ", 
          SuperscriptBox[
           StyleBox["Q0",
            FontColor->RGBColor[{
               Rational[1, 2], 
               Rational[1, 2], 0}]], "-"]}]], "+", 
        FractionBox[
         RowBox[{"12", "+", 
          FractionBox[
           RowBox[{"8", " ", "\[ImaginaryI]"}], "u"]}], 
         RowBox[{
          SuperscriptBox["u", "3"], " ", 
          SuperscriptBox[
           StyleBox["Q0",
            FontColor->RGBColor[{
               Rational[1, 2], 
               Rational[1, 2], 0}]], "+"]}]]}], ")"}], " ", 
      SubsuperscriptBox[
       StyleBox["\[Eta]",
        FontWeight->Bold,
        FontColor->RGBColor[0.8, 0, 0]], "3", 
       RowBox[{"[", "2", "]"}]]}], "+", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        FractionBox[
         RowBox[{"2", " ", "\[ImaginaryI]"}], 
         RowBox[{
          SuperscriptBox["u", "3"], " ", 
          SuperscriptBox[
           StyleBox["Q0",
            FontColor->RGBColor[{
               Rational[1, 2], 
               Rational[1, 2], 0}]], "-"]}]], "-", 
        FractionBox[
         RowBox[{"2", " ", "\[ImaginaryI]"}], 
         RowBox[{
          SuperscriptBox["u", "3"], " ", 
          SuperscriptBox[
           StyleBox["Q0",
            FontColor->RGBColor[{
               Rational[1, 2], 
               Rational[1, 2], 0}]], "+"]}]]}], ")"}], " ", 
      SubsuperscriptBox[
       StyleBox["\[Eta]",
        FontWeight->Bold,
        FontColor->RGBColor[0.8, 0, 0]], "4", 
       RowBox[{"[", "2", "]"}]]}]}], ")"}]}]}]], "Output",
 CellChangeTimes->{
  3.56062095974549*^9, {3.560621062735878*^9, 3.560621085407136*^9}, 
   3.561468870974163*^9, 3.562247055260264*^9, {3.562914043021166*^9, 
   3.562914055772491*^9}, {3.5629141554618893`*^9, 3.5629141939680433`*^9}}]
}, Open  ]],

Cell[TextData[{
 "Since  there is no ",
 Cell[BoxData[
  FormBox[
   OverscriptBox["\[Eta]", "_"], TraditionalForm]]],
 " at the leading order, it is convenient to close integration contour from \
above.  To don\[CloseCurlyQuote]t count bethe roots, we restore \[Alpha]-term."
}], "Text",
 CellChangeTimes->{{3.556048005847254*^9, 3.5560481115474367`*^9}, {
  3.560941840255352*^9, 3.560941864719119*^9}}],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"$\[Delta]QCorrectiontoH", " ", "=", " ", "True"}], ";"}], 
  " "}], "\[IndentingNewLine]", 
 RowBox[{"rltH", "=", 
  RowBox[{"(", 
   RowBox[{"Collect", "[", 
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{"-", 
         RowBox[{"Residue", "[", 
          RowBox[{
           RowBox[{
            RowBox[{
             RowBox[{
              RowBox[{
               RowBox[{"(", "ser1", ")"}], "H"}], "/.", 
              RowBox[{"leadweak", "[", "1", "]"}]}], "/.", "subQ0"}], "/.", 
            RowBox[{"TaylorOptions", "[", 
             RowBox[{
              RowBox[{"Variable", "\[Rule]", "u"}], ",", 
              RowBox[{"Order", "\[Rule]", 
               RowBox[{"-", "1"}]}], ",", 
              RowBox[{"Series", "\[Rule]", "False"}]}], "]"}]}], ",", 
           RowBox[{"{", 
            RowBox[{"u", ",", "0"}], "}"}]}], "]"}]}], "+", 
        RowBox[{
         FractionBox["1", "2"], 
         RowBox[{"(", 
          RowBox[{"H", "/.", 
           RowBox[{"leadweak", "[", "1", "]"}]}], ")"}]}], "-", 
        RowBox[{
         FractionBox["1", "2"], 
         RowBox[{"(", 
          RowBox[{
           RowBox[{
            RowBox[{
             RowBox[{"H", "/.", 
              RowBox[{"leadweak", "[", "1", "]"}]}], "/.", 
             RowBox[{"Shift", "[", "2", "]"}]}], "/.", 
            RowBox[{"u", "\[Rule]", 
             RowBox[{"u", "+", "\[ImaginaryI]"}]}]}], "//.", 
           RowBox[{"shiftm\[Eta]", "[", "4", "]"}]}], ")"}]}]}], "/.", 
       RowBox[{"v", "\[Rule]", "u"}]}], "//", "Expand"}], ",", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"g", ",", 
        SuperscriptBox["Q0", "-"], ",", 
        SuperscriptBox[
         StyleBox["Q0",
          FontColor->RGBColor[{
             Rational[1, 2], 
             Rational[1, 2], 0}]], "+"], ",", 
        SuperscriptBox[
         StyleBox["Q0",
          FontColor->RGBColor[{
             Rational[1, 2], 
             Rational[1, 2], 0}]], 
         RowBox[{"[", "3", "]"}]], ",", 
        RowBox[{
         RowBox[{"\[Eta]$", "[", "__", "]"}], "[", "_", "]"}], ",", 
        "\[Eta]0list"}], "}"}], "//", "Flatten"}], ",", 
     RowBox[{
      RowBox[{"Apart", "[", 
       RowBox[{"#", ",", "u"}], "]"}], "&"}]}], "]"}], ")"}]}]}], "Input",
 CellChangeTimes->{{3.556048091114605*^9, 3.556048225135532*^9}, {
   3.5560488421310673`*^9, 3.5560488519210253`*^9}, 3.55604917701404*^9, 
   3.556049574499086*^9, {3.5609418501183567`*^9, 3.560941926128718*^9}, {
   3.560942071185903*^9, 3.560942104260187*^9}, {3.560942517131068*^9, 
   3.560942517958596*^9}, {3.560942717598928*^9, 3.560942986266576*^9}, {
   3.562247078358482*^9, 3.562247079139969*^9}}],

Cell[BoxData[
 RowBox[{
  SuperscriptBox["g", "8"], " ", 
  RowBox[{"(", 
   RowBox[{
    RowBox[{"-", 
     FractionBox["18", 
      SuperscriptBox[
       RowBox[{"(", 
        RowBox[{"\[ImaginaryI]", "+", "u"}], ")"}], "6"]]}], "-", 
    FractionBox[
     RowBox[{"18", " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "3"}], "+", 
        RowBox[{"2", " ", 
         SubscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "2"]}]}], ")"}]}], 
     SuperscriptBox["u", "4"]], "+", 
    FractionBox[
     RowBox[{"18", " ", "\[ImaginaryI]", " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "9"}], "+", 
        RowBox[{"8", " ", 
         SubscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "3"]}]}], ")"}]}], 
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{"\[ImaginaryI]", "+", "u"}], ")"}], "3"]], "-", 
    FractionBox[
     RowBox[{"72", " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"3", " ", 
         SubscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "2"]}], "-", 
        RowBox[{"5", " ", 
         SubscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "4"]}]}], ")"}]}], 
     SuperscriptBox["u", "2"]], "+", 
    FractionBox[
     RowBox[{"18", " ", "\[ImaginaryI]", " ", 
      RowBox[{"(", 
       RowBox[{"9", "+", 
        RowBox[{"24", " ", 
         SubscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "3"]}], "-", 
        RowBox[{"40", " ", 
         SubscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "5"]}]}], ")"}]}], 
     RowBox[{"\[ImaginaryI]", "+", "u"}]], "+", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{"-", 
        FractionBox["18", 
         SuperscriptBox["u", "4"]]}], "+", 
       FractionBox["18", 
        SuperscriptBox[
         RowBox[{"(", 
          RowBox[{"\[ImaginaryI]", "+", "u"}], ")"}], "4"]]}], ")"}], " ", 
     SubsuperscriptBox[
      StyleBox["\[Eta]",
       FontWeight->Bold,
       FontColor->RGBColor[0.8, 0, 0]], "2", 
      RowBox[{"[", "2", "]"}]]}], "+", 
    RowBox[{
     FractionBox["1", 
      SuperscriptBox[
       StyleBox["Q0",
        FontColor->RGBColor[{
           Rational[1, 2], 
           Rational[1, 2], 0}]], "-"]], 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"-", "54"}], "-", 
       FractionBox["3", 
        SuperscriptBox["u", "4"]], "+", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          RowBox[{"9", " ", 
           RowBox[{"(", 
            RowBox[{"3", "+", 
             RowBox[{"\[ImaginaryI]", " ", 
              SqrtBox["3"]}]}], ")"}]}], "+", 
          RowBox[{"54", " ", "\[ImaginaryI]", " ", "u"}]}], ")"}], " ", 
        SubsuperscriptBox[
         StyleBox["\[Eta]0",
          FontWeight->Bold,
          FontColor->RGBColor[0, 0.5, 0]], "2", "+"]}], "+", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          RowBox[{
           RowBox[{"-", "9"}], " ", 
           RowBox[{"(", 
            RowBox[{"\[ImaginaryI]", "+", 
             SqrtBox["3"]}], ")"}]}], "-", 
          RowBox[{"18", " ", "\[ImaginaryI]", " ", 
           SqrtBox["3"], " ", "u"}]}], ")"}], " ", 
        SubsuperscriptBox[
         StyleBox["\[Eta]0",
          FontWeight->Bold,
          FontColor->RGBColor[0, 0.5, 0]], "3", "+"]}], "+", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          RowBox[{
           FractionBox["3", "2"], " ", 
           RowBox[{"(", 
            RowBox[{"3", "+", 
             RowBox[{"\[ImaginaryI]", " ", 
              SqrtBox["3"]}]}], ")"}]}], "+", 
          RowBox[{"9", " ", "\[ImaginaryI]", " ", "u"}]}], ")"}], " ", 
        SubsuperscriptBox[
         StyleBox["\[Eta]0",
          FontWeight->Bold,
          FontColor->RGBColor[0, 0.5, 0]], "4", "+"]}], "+", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          RowBox[{"9", " ", 
           RowBox[{"(", 
            RowBox[{"3", "-", 
             RowBox[{"\[ImaginaryI]", " ", 
              SqrtBox["3"]}]}], ")"}]}], "+", 
          RowBox[{"54", " ", "\[ImaginaryI]", " ", "u"}]}], ")"}], " ", 
        SubsuperscriptBox[
         OverscriptBox[
          StyleBox["\[Eta]0",
           FontWeight->Bold,
           FontColor->RGBColor[0, 0.5, 0]], 
          StyleBox["_",
           FontWeight->Bold,
           FontColor->RGBColor[0, 0.5, 0]]], "2", "-"]}], "+", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          RowBox[{
           RowBox[{"-", "9"}], " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"-", "\[ImaginaryI]"}], "+", 
             SqrtBox["3"]}], ")"}]}], "-", 
          RowBox[{"18", " ", "\[ImaginaryI]", " ", 
           SqrtBox["3"], " ", "u"}]}], ")"}], " ", 
        SubsuperscriptBox[
         OverscriptBox[
          StyleBox["\[Eta]0",
           FontWeight->Bold,
           FontColor->RGBColor[0, 0.5, 0]], 
          StyleBox["_",
           FontWeight->Bold,
           FontColor->RGBColor[0, 0.5, 0]]], "3", "-"]}], "+", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          RowBox[{
           FractionBox["3", "2"], " ", 
           RowBox[{"(", 
            RowBox[{"3", "-", 
             RowBox[{"\[ImaginaryI]", " ", 
              SqrtBox["3"]}]}], ")"}]}], "+", 
          RowBox[{"9", " ", "\[ImaginaryI]", " ", "u"}]}], ")"}], " ", 
        SubsuperscriptBox[
         OverscriptBox[
          StyleBox["\[Eta]0",
           FontWeight->Bold,
           FontColor->RGBColor[0, 0.5, 0]], 
          StyleBox["_",
           FontWeight->Bold,
           FontColor->RGBColor[0, 0.5, 0]]], "4", "-"]}], "+", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          FractionBox[
           RowBox[{"2", " ", "\[ImaginaryI]"}], 
           SuperscriptBox["u", "5"]], "-", 
          FractionBox["6", 
           SuperscriptBox["u", "4"]]}], ")"}], " ", 
        SubsuperscriptBox[
         StyleBox["\[Eta]",
          FontWeight->Bold,
          FontColor->RGBColor[0.8, 0, 0]], "2", 
         RowBox[{"[", "2", "]"}]]}], "+", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          RowBox[{"-", 
           FractionBox[
            RowBox[{"4", " ", "\[ImaginaryI]"}], 
            SuperscriptBox["u", "4"]]}], "+", 
          FractionBox["6", 
           SuperscriptBox["u", "3"]]}], ")"}], " ", 
        SubsuperscriptBox[
         StyleBox["\[Eta]",
          FontWeight->Bold,
          FontColor->RGBColor[0.8, 0, 0]], "3", 
         RowBox[{"[", "2", "]"}]]}], "+", 
       FractionBox[
        RowBox[{"\[ImaginaryI]", " ", 
         SubsuperscriptBox[
          StyleBox["\[Eta]",
           FontWeight->Bold,
           FontColor->RGBColor[0.8, 0, 0]], "4", 
          RowBox[{"[", "2", "]"}]]}], 
        SuperscriptBox["u", "3"]]}], ")"}]}], "+", 
    RowBox[{
     FractionBox["1", 
      SuperscriptBox[
       StyleBox["Q0",
        FontColor->RGBColor[{
           Rational[1, 2], 
           Rational[1, 2], 0}]], 
       RowBox[{"[", "3", "]"}]]], 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"-", "54"}], "+", 
       FractionBox["\[ImaginaryI]", 
        SuperscriptBox[
         RowBox[{"(", 
          RowBox[{"\[ImaginaryI]", "+", "u"}], ")"}], "7"]], "-", 
       FractionBox["12", 
        SuperscriptBox[
         RowBox[{"(", 
          RowBox[{"\[ImaginaryI]", "+", "u"}], ")"}], "4"]], "+", 
       FractionBox[
        RowBox[{"18", " ", "\[ImaginaryI]"}], 
        SuperscriptBox[
         RowBox[{"(", 
          RowBox[{"\[ImaginaryI]", "+", "u"}], ")"}], "3"]], "+", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          RowBox[{"9", " ", "\[ImaginaryI]", " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"9", " ", "\[ImaginaryI]"}], "+", 
             SqrtBox["3"]}], ")"}]}], "+", 
          RowBox[{"54", " ", "\[ImaginaryI]", " ", "u"}]}], ")"}], " ", 
        SubsuperscriptBox[
         StyleBox["\[Eta]0",
          FontWeight->Bold,
          FontColor->RGBColor[0, 0.5, 0]], "2", "+"]}], "+", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          RowBox[{"9", " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"-", "\[ImaginaryI]"}], "+", 
             RowBox[{"3", " ", 
              SqrtBox["3"]}]}], ")"}]}], "-", 
          RowBox[{"18", " ", "\[ImaginaryI]", " ", 
           SqrtBox["3"], " ", "u"}]}], ")"}], " ", 
        SubsuperscriptBox[
         StyleBox["\[Eta]0",
          FontWeight->Bold,
          FontColor->RGBColor[0, 0.5, 0]], "3", "+"]}], "+", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          RowBox[{
           FractionBox["3", "2"], " ", "\[ImaginaryI]", " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"9", " ", "\[ImaginaryI]"}], "+", 
             SqrtBox["3"]}], ")"}]}], "+", 
          RowBox[{"9", " ", "\[ImaginaryI]", " ", "u"}]}], ")"}], " ", 
        SubsuperscriptBox[
         StyleBox["\[Eta]0",
          FontWeight->Bold,
          FontColor->RGBColor[0, 0.5, 0]], "4", "+"]}], "+", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          RowBox[{
           RowBox[{"-", "9"}], " ", "\[ImaginaryI]", " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{
              RowBox[{"-", "9"}], " ", "\[ImaginaryI]"}], "+", 
             SqrtBox["3"]}], ")"}]}], "+", 
          RowBox[{"54", " ", "\[ImaginaryI]", " ", "u"}]}], ")"}], " ", 
        SubsuperscriptBox[
         OverscriptBox[
          StyleBox["\[Eta]0",
           FontWeight->Bold,
           FontColor->RGBColor[0, 0.5, 0]], 
          StyleBox["_",
           FontWeight->Bold,
           FontColor->RGBColor[0, 0.5, 0]]], "2", "-"]}], "+", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          RowBox[{"9", " ", 
           RowBox[{"(", 
            RowBox[{"\[ImaginaryI]", "+", 
             RowBox[{"3", " ", 
              SqrtBox["3"]}]}], ")"}]}], "-", 
          RowBox[{"18", " ", "\[ImaginaryI]", " ", 
           SqrtBox["3"], " ", "u"}]}], ")"}], " ", 
        SubsuperscriptBox[
         OverscriptBox[
          StyleBox["\[Eta]0",
           FontWeight->Bold,
           FontColor->RGBColor[0, 0.5, 0]], 
          StyleBox["_",
           FontWeight->Bold,
           FontColor->RGBColor[0, 0.5, 0]]], "3", "-"]}], "+", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          RowBox[{
           RowBox[{"-", 
            FractionBox["3", "2"]}], " ", "\[ImaginaryI]", " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{
              RowBox[{"-", "9"}], " ", "\[ImaginaryI]"}], "+", 
             SqrtBox["3"]}], ")"}]}], "+", 
          RowBox[{"9", " ", "\[ImaginaryI]", " ", "u"}]}], ")"}], " ", 
        SubsuperscriptBox[
         OverscriptBox[
          StyleBox["\[Eta]0",
           FontWeight->Bold,
           FontColor->RGBColor[0, 0.5, 0]], 
          StyleBox["_",
           FontWeight->Bold,
           FontColor->RGBColor[0, 0.5, 0]]], "4", "-"]}], "+", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          FractionBox[
           RowBox[{"2", " ", "\[ImaginaryI]"}], 
           SuperscriptBox[
            RowBox[{"(", 
             RowBox[{"\[ImaginaryI]", "+", "u"}], ")"}], "5"]], "+", 
          FractionBox["6", 
           SuperscriptBox[
            RowBox[{"(", 
             RowBox[{"\[ImaginaryI]", "+", "u"}], ")"}], "4"]]}], ")"}], " ", 
        
        SubsuperscriptBox[
         StyleBox["\[Eta]",
          FontWeight->Bold,
          FontColor->RGBColor[0.8, 0, 0]], "2", 
         RowBox[{"[", "2", "]"}]]}], "+", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          RowBox[{"-", 
           FractionBox[
            RowBox[{"4", " ", "\[ImaginaryI]"}], 
            SuperscriptBox[
             RowBox[{"(", 
              RowBox[{"\[ImaginaryI]", "+", "u"}], ")"}], "4"]]}], "-", 
          FractionBox["6", 
           SuperscriptBox[
            RowBox[{"(", 
             RowBox[{"\[ImaginaryI]", "+", "u"}], ")"}], "3"]]}], ")"}], " ", 
        
        SubsuperscriptBox[
         StyleBox["\[Eta]",
          FontWeight->Bold,
          FontColor->RGBColor[0.8, 0, 0]], "3", 
         RowBox[{"[", "2", "]"}]]}], "+", 
       FractionBox[
        RowBox[{"\[ImaginaryI]", " ", 
         SubsuperscriptBox[
          StyleBox["\[Eta]",
           FontWeight->Bold,
           FontColor->RGBColor[0.8, 0, 0]], "4", 
          RowBox[{"[", "2", "]"}]]}], 
        SuperscriptBox[
         RowBox[{"(", 
          RowBox[{"\[ImaginaryI]", "+", "u"}], ")"}], "3"]]}], ")"}]}], "+", 
    RowBox[{
     FractionBox["1", 
      SuperscriptBox[
       StyleBox["Q0",
        FontColor->RGBColor[{
           Rational[1, 2], 
           Rational[1, 2], 0}]], "+"]], 
     RowBox[{"(", 
      RowBox[{"108", "+", 
       FractionBox["12", 
        SuperscriptBox["u", "4"]], "-", 
       FractionBox[
        RowBox[{"18", " ", "\[ImaginaryI]"}], 
        SuperscriptBox["u", "3"]], "-", 
       FractionBox["\[ImaginaryI]", 
        SuperscriptBox[
         RowBox[{"(", 
          RowBox[{"\[ImaginaryI]", "+", "u"}], ")"}], "7"]], "+", 
       FractionBox["3", 
        SuperscriptBox[
         RowBox[{"(", 
          RowBox[{"\[ImaginaryI]", "+", "u"}], ")"}], "4"]], "+", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          RowBox[{"18", " ", 
           RowBox[{"(", 
            RowBox[{"3", "-", 
             RowBox[{"\[ImaginaryI]", " ", 
              SqrtBox["3"]}]}], ")"}]}], "-", 
          RowBox[{"108", " ", "\[ImaginaryI]", " ", "u"}]}], ")"}], " ", 
        SubsuperscriptBox[
         StyleBox["\[Eta]0",
          FontWeight->Bold,
          FontColor->RGBColor[0, 0.5, 0]], "2", "+"]}], "+", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          RowBox[{
           RowBox[{"-", "18"}], " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"-", "\[ImaginaryI]"}], "+", 
             SqrtBox["3"]}], ")"}]}], "+", 
          RowBox[{"36", " ", "\[ImaginaryI]", " ", 
           SqrtBox["3"], " ", "u"}]}], ")"}], " ", 
        SubsuperscriptBox[
         StyleBox["\[Eta]0",
          FontWeight->Bold,
          FontColor->RGBColor[0, 0.5, 0]], "3", "+"]}], "+", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          RowBox[{"3", " ", 
           RowBox[{"(", 
            RowBox[{"3", "-", 
             RowBox[{"\[ImaginaryI]", " ", 
              SqrtBox["3"]}]}], ")"}]}], "-", 
          RowBox[{"18", " ", "\[ImaginaryI]", " ", "u"}]}], ")"}], " ", 
        SubsuperscriptBox[
         StyleBox["\[Eta]0",
          FontWeight->Bold,
          FontColor->RGBColor[0, 0.5, 0]], "4", "+"]}], "+", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          RowBox[{"18", " ", 
           RowBox[{"(", 
            RowBox[{"3", "+", 
             RowBox[{"\[ImaginaryI]", " ", 
              SqrtBox["3"]}]}], ")"}]}], "-", 
          RowBox[{"108", " ", "\[ImaginaryI]", " ", "u"}]}], ")"}], " ", 
        SubsuperscriptBox[
         OverscriptBox[
          StyleBox["\[Eta]0",
           FontWeight->Bold,
           FontColor->RGBColor[0, 0.5, 0]], 
          StyleBox["_",
           FontWeight->Bold,
           FontColor->RGBColor[0, 0.5, 0]]], "2", "-"]}], "+", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          RowBox[{
           RowBox[{"-", "18"}], " ", 
           RowBox[{"(", 
            RowBox[{"\[ImaginaryI]", "+", 
             SqrtBox["3"]}], ")"}]}], "+", 
          RowBox[{"36", " ", "\[ImaginaryI]", " ", 
           SqrtBox["3"], " ", "u"}]}], ")"}], " ", 
        SubsuperscriptBox[
         OverscriptBox[
          StyleBox["\[Eta]0",
           FontWeight->Bold,
           FontColor->RGBColor[0, 0.5, 0]], 
          StyleBox["_",
           FontWeight->Bold,
           FontColor->RGBColor[0, 0.5, 0]]], "3", "-"]}], "+", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          RowBox[{"3", " ", 
           RowBox[{"(", 
            RowBox[{"3", "+", 
             RowBox[{"\[ImaginaryI]", " ", 
              SqrtBox["3"]}]}], ")"}]}], "-", 
          RowBox[{"18", " ", "\[ImaginaryI]", " ", "u"}]}], ")"}], " ", 
        SubsuperscriptBox[
         OverscriptBox[
          StyleBox["\[Eta]0",
           FontWeight->Bold,
           FontColor->RGBColor[0, 0.5, 0]], 
          StyleBox["_",
           FontWeight->Bold,
           FontColor->RGBColor[0, 0.5, 0]]], "4", "-"]}], "+", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          RowBox[{"-", 
           FractionBox[
            RowBox[{"2", " ", "\[ImaginaryI]"}], 
            SuperscriptBox["u", "5"]]}], "-", 
          FractionBox["6", 
           SuperscriptBox["u", "4"]], "-", 
          FractionBox[
           RowBox[{"2", " ", "\[ImaginaryI]"}], 
           SuperscriptBox[
            RowBox[{"(", 
             RowBox[{"\[ImaginaryI]", "+", "u"}], ")"}], "5"]], "+", 
          FractionBox["6", 
           SuperscriptBox[
            RowBox[{"(", 
             RowBox[{"\[ImaginaryI]", "+", "u"}], ")"}], "4"]]}], ")"}], " ", 
        
        SubsuperscriptBox[
         StyleBox["\[Eta]",
          FontWeight->Bold,
          FontColor->RGBColor[0.8, 0, 0]], "2", 
         RowBox[{"[", "2", "]"}]]}], "+", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          FractionBox[
           RowBox[{"4", " ", "\[ImaginaryI]"}], 
           SuperscriptBox["u", "4"]], "+", 
          FractionBox["6", 
           SuperscriptBox["u", "3"]], "+", 
          FractionBox[
           RowBox[{"4", " ", "\[ImaginaryI]"}], 
           SuperscriptBox[
            RowBox[{"(", 
             RowBox[{"\[ImaginaryI]", "+", "u"}], ")"}], "4"]], "-", 
          FractionBox["6", 
           SuperscriptBox[
            RowBox[{"(", 
             RowBox[{"\[ImaginaryI]", "+", "u"}], ")"}], "3"]]}], ")"}], " ", 
        
        SubsuperscriptBox[
         StyleBox["\[Eta]",
          FontWeight->Bold,
          FontColor->RGBColor[0.8, 0, 0]], "3", 
         RowBox[{"[", "2", "]"}]]}], "+", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          RowBox[{"-", 
           FractionBox["\[ImaginaryI]", 
            SuperscriptBox["u", "3"]]}], "-", 
          FractionBox["\[ImaginaryI]", 
           SuperscriptBox[
            RowBox[{"(", 
             RowBox[{"\[ImaginaryI]", "+", "u"}], ")"}], "3"]]}], ")"}], " ", 
        
        SubsuperscriptBox[
         StyleBox["\[Eta]",
          FontWeight->Bold,
          FontColor->RGBColor[0.8, 0, 0]], "4", 
         RowBox[{"[", "2", "]"}]]}]}], ")"}]}]}], ")"}]}]], "Output",
 CellChangeTimes->{{3.56094296360581*^9, 3.560943006760222*^9}, {
   3.561058529269882*^9, 3.561058547425127*^9}, 3.561468878289962*^9, 
   3.5622470865865993`*^9, 3.562914221373609*^9}]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"rltHcompare", "=", 
   RowBox[{"Collect", "[", 
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{"UpIntegrate", "[", 
        RowBox[{
         RowBox[{
          RowBox[{
           RowBox[{
            RowBox[{
             RowBox[{
              RowBox[{
               RowBox[{"-", 
                FractionBox["1", 
                 RowBox[{"2", "\[Pi]", " ", "\[ImaginaryI]"}]]}], 
               RowBox[{"(", 
                RowBox[{
                 RowBox[{"-", 
                  FractionBox["1", 
                   RowBox[{"2", " ", 
                    RowBox[{"(", 
                    RowBox[{"u", "-", "v"}], ")"}]}]]}], "+", 
                 FractionBox["1", 
                  RowBox[{"2", " ", 
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", "\[ImaginaryI]"}], "+", "u", "-", "v"}], 
                    ")"}]}]], "-", 
                 FractionBox["1", 
                  RowBox[{"2", " ", 
                   RowBox[{"(", 
                    RowBox[{"u", "+", "v"}], ")"}]}]], "-", 
                 FractionBox["1", 
                  RowBox[{"2", " ", 
                   RowBox[{"(", 
                    RowBox[{"\[ImaginaryI]", "+", "u", "+", "v"}], ")"}]}]]}],
                 ")"}], "H"}], "/.", 
              RowBox[{"leadweak", "[", "1", "]"}]}], "/.", "subQ0"}], "/.", 
            RowBox[{"v", "\[Rule]", 
             RowBox[{
              RowBox[{"Re", "[", "v", "]"}], "+", "\[ImaginaryI]"}]}]}], "/.", 
           RowBox[{"u", "\[Rule]", 
            RowBox[{"u", "-", 
             RowBox[{"\[ImaginaryI]", " ", "\[Epsilon]"}]}]}]}], "/.", 
          RowBox[{"Shift", "[", 
           RowBox[{
            RowBox[{"-", "2"}], "\[Epsilon]"}], "]"}]}], ",", "u"}], "]"}], "/.", 
       RowBox[{
        RowBox[{"Re", "[", "v", "]"}], "\[Rule]", 
        RowBox[{"u", "-", "\[ImaginaryI]"}]}]}], "//.", "EndSimplify"}], ",", 
     
     RowBox[{
      RowBox[{"{", 
       RowBox[{"g", ",", "\[Eta]list"}], "}"}], "//", "Flatten"}]}], "]"}]}], 
  ";"}]], "Input",
 CellChangeTimes->{{3.560942139501693*^9, 3.560942221337372*^9}, {
   3.5609422722368593`*^9, 3.560942372357411*^9}, 3.560943023291025*^9}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Collect", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       RowBox[{"rltHcompare", "-", "rltH"}], "/.", "subQ0"}], "//", 
      "RidOfBar"}], ")"}], "//.", "subZetaReduce"}], ",", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"g", ",", "\[Eta]list", ",", "\[Eta]0list"}], "}"}], "//", 
    "Flatten"}], ",", "Simplify"}], "]"}]], "Input",
 CellChangeTimes->{{3.560942374148312*^9, 3.560942469563657*^9}}],

Cell[BoxData["0"], "Output",
 CellChangeTimes->{{3.560942393109643*^9, 3.5609424700342073`*^9}, 
   3.560942531153206*^9, {3.56094305715945*^9, 3.560943060245105*^9}, 
   3.561058584254908*^9, 3.56146890314867*^9, 3.5622471181681213`*^9, 
   3.562914254303864*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"rltH2", "=", 
  RowBox[{"rltH", "/.", "subtousu"}]}]], "Input",
 CellChangeTimes->{{3.562247116962716*^9, 3.5622471257990627`*^9}, {
   3.5622471736696253`*^9, 3.562247208178742*^9}, {3.562247257897418*^9, 
   3.562247273311015*^9}, {3.562247323823586*^9, 3.56224732472558*^9}, 
   3.562914812765999*^9}],

Cell[BoxData[
 RowBox[{
  SuperscriptBox["g", "8"], " ", 
  RowBox[{"(", 
   RowBox[{
    RowBox[{"-", 
     FractionBox["18", 
      SuperscriptBox[
       RowBox[{"(", 
        SuperscriptBox[
         StyleBox["\[ScriptU]",
          FontColor->RGBColor[0, 0, 0.4]], 
         RowBox[{"[", "2", "]"}]], ")"}], "6"]]}], "-", 
    FractionBox[
     RowBox[{"18", " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "3"}], "+", 
        RowBox[{"2", " ", 
         SubscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "2"]}]}], ")"}]}], 
     SuperscriptBox[
      StyleBox["\[ScriptU]",
       FontColor->RGBColor[0, 0, 0.4]], "4"]], "+", 
    FractionBox[
     RowBox[{"18", " ", "\[ImaginaryI]", " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "9"}], "+", 
        RowBox[{"8", " ", 
         SubscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "3"]}]}], ")"}]}], 
     SuperscriptBox[
      RowBox[{"(", 
       SuperscriptBox[
        StyleBox["\[ScriptU]",
         FontColor->RGBColor[0, 0, 0.4]], 
        RowBox[{"[", "2", "]"}]], ")"}], "3"]], "-", 
    FractionBox[
     RowBox[{"72", " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"3", " ", 
         SubscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "2"]}], "-", 
        RowBox[{"5", " ", 
         SubscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "4"]}]}], ")"}]}], 
     SuperscriptBox[
      StyleBox["\[ScriptU]",
       FontColor->RGBColor[0, 0, 0.4]], "2"]], "+", 
    FractionBox[
     RowBox[{"18", " ", "\[ImaginaryI]", " ", 
      RowBox[{"(", 
       RowBox[{"9", "+", 
        RowBox[{"24", " ", 
         SubscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "3"]}], "-", 
        RowBox[{"40", " ", 
         SubscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "5"]}]}], ")"}]}], 
     SuperscriptBox[
      StyleBox["\[ScriptU]",
       FontColor->RGBColor[0, 0, 0.4]], 
      RowBox[{"[", "2", "]"}]]], "+", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{"-", 
        FractionBox["18", 
         SuperscriptBox[
          StyleBox["\[ScriptU]",
           FontColor->RGBColor[0, 0, 0.4]], "4"]]}], "+", 
       FractionBox["18", 
        SuperscriptBox[
         RowBox[{"(", 
          SuperscriptBox[
           StyleBox["\[ScriptU]",
            FontColor->RGBColor[0, 0, 0.4]], 
           RowBox[{"[", "2", "]"}]], ")"}], "4"]]}], ")"}], " ", 
     SubsuperscriptBox[
      StyleBox["\[Eta]",
       FontWeight->Bold,
       FontColor->RGBColor[0.8, 0, 0]], "2", 
      RowBox[{"[", "2", "]"}]]}], "+", 
    RowBox[{
     FractionBox["1", 
      RowBox[{
       SubsuperscriptBox[
        StyleBox["\[ScriptU]",
         FontColor->RGBColor[0, 0, 0.4]], 
        RowBox[{"-", "v0"}], "-"], " ", 
       SubsuperscriptBox[
        StyleBox["\[ScriptU]",
         FontColor->RGBColor[0, 0, 0.4]], "v0", "-"]}]], 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"-", "54"}], "-", 
       FractionBox["3", 
        SuperscriptBox[
         StyleBox["\[ScriptU]",
          FontColor->RGBColor[0, 0, 0.4]], "4"]], "+", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          RowBox[{"9", " ", 
           RowBox[{"(", 
            RowBox[{"3", "+", 
             RowBox[{"\[ImaginaryI]", " ", 
              SqrtBox["3"]}]}], ")"}]}], "+", 
          RowBox[{"54", " ", "\[ImaginaryI]", " ", "u"}]}], ")"}], " ", 
        SubsuperscriptBox[
         StyleBox["\[Eta]0",
          FontWeight->Bold,
          FontColor->RGBColor[0, 0.5, 0]], "2", "+"]}], "+", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          RowBox[{
           RowBox[{"-", "9"}], " ", 
           RowBox[{"(", 
            RowBox[{"\[ImaginaryI]", "+", 
             SqrtBox["3"]}], ")"}]}], "-", 
          RowBox[{"18", " ", "\[ImaginaryI]", " ", 
           SqrtBox["3"], " ", "u"}]}], ")"}], " ", 
        SubsuperscriptBox[
         StyleBox["\[Eta]0",
          FontWeight->Bold,
          FontColor->RGBColor[0, 0.5, 0]], "3", "+"]}], "+", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          RowBox[{
           FractionBox["3", "2"], " ", 
           RowBox[{"(", 
            RowBox[{"3", "+", 
             RowBox[{"\[ImaginaryI]", " ", 
              SqrtBox["3"]}]}], ")"}]}], "+", 
          RowBox[{"9", " ", "\[ImaginaryI]", " ", "u"}]}], ")"}], " ", 
        SubsuperscriptBox[
         StyleBox["\[Eta]0",
          FontWeight->Bold,
          FontColor->RGBColor[0, 0.5, 0]], "4", "+"]}], "+", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          RowBox[{"9", " ", 
           RowBox[{"(", 
            RowBox[{"3", "-", 
             RowBox[{"\[ImaginaryI]", " ", 
              SqrtBox["3"]}]}], ")"}]}], "+", 
          RowBox[{"54", " ", "\[ImaginaryI]", " ", "u"}]}], ")"}], " ", 
        SubsuperscriptBox[
         OverscriptBox[
          StyleBox["\[Eta]0",
           FontWeight->Bold,
           FontColor->RGBColor[0, 0.5, 0]], 
          StyleBox["_",
           FontWeight->Bold,
           FontColor->RGBColor[0, 0.5, 0]]], "2", "-"]}], "+", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          RowBox[{
           RowBox[{"-", "9"}], " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"-", "\[ImaginaryI]"}], "+", 
             SqrtBox["3"]}], ")"}]}], "-", 
          RowBox[{"18", " ", "\[ImaginaryI]", " ", 
           SqrtBox["3"], " ", "u"}]}], ")"}], " ", 
        SubsuperscriptBox[
         OverscriptBox[
          StyleBox["\[Eta]0",
           FontWeight->Bold,
           FontColor->RGBColor[0, 0.5, 0]], 
          StyleBox["_",
           FontWeight->Bold,
           FontColor->RGBColor[0, 0.5, 0]]], "3", "-"]}], "+", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          RowBox[{
           FractionBox["3", "2"], " ", 
           RowBox[{"(", 
            RowBox[{"3", "-", 
             RowBox[{"\[ImaginaryI]", " ", 
              SqrtBox["3"]}]}], ")"}]}], "+", 
          RowBox[{"9", " ", "\[ImaginaryI]", " ", "u"}]}], ")"}], " ", 
        SubsuperscriptBox[
         OverscriptBox[
          StyleBox["\[Eta]0",
           FontWeight->Bold,
           FontColor->RGBColor[0, 0.5, 0]], 
          StyleBox["_",
           FontWeight->Bold,
           FontColor->RGBColor[0, 0.5, 0]]], "4", "-"]}], "+", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          FractionBox[
           RowBox[{"2", " ", "\[ImaginaryI]"}], 
           SuperscriptBox[
            StyleBox["\[ScriptU]",
             FontColor->RGBColor[0, 0, 0.4]], "5"]], "-", 
          FractionBox["6", 
           SuperscriptBox[
            StyleBox["\[ScriptU]",
             FontColor->RGBColor[0, 0, 0.4]], "4"]]}], ")"}], " ", 
        SubsuperscriptBox[
         StyleBox["\[Eta]",
          FontWeight->Bold,
          FontColor->RGBColor[0.8, 0, 0]], "2", 
         RowBox[{"[", "2", "]"}]]}], "+", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          RowBox[{"-", 
           FractionBox[
            RowBox[{"4", " ", "\[ImaginaryI]"}], 
            SuperscriptBox[
             StyleBox["\[ScriptU]",
              FontColor->RGBColor[0, 0, 0.4]], "4"]]}], "+", 
          FractionBox["6", 
           SuperscriptBox[
            StyleBox["\[ScriptU]",
             FontColor->RGBColor[0, 0, 0.4]], "3"]]}], ")"}], " ", 
        SubsuperscriptBox[
         StyleBox["\[Eta]",
          FontWeight->Bold,
          FontColor->RGBColor[0.8, 0, 0]], "3", 
         RowBox[{"[", "2", "]"}]]}], "+", 
       FractionBox[
        RowBox[{"\[ImaginaryI]", " ", 
         SubsuperscriptBox[
          StyleBox["\[Eta]",
           FontWeight->Bold,
           FontColor->RGBColor[0.8, 0, 0]], "4", 
          RowBox[{"[", "2", "]"}]]}], 
        SuperscriptBox[
         StyleBox["\[ScriptU]",
          FontColor->RGBColor[0, 0, 0.4]], "3"]]}], ")"}]}], "+", 
    RowBox[{
     FractionBox["1", 
      RowBox[{
       SubsuperscriptBox[
        StyleBox["\[ScriptU]",
         FontColor->RGBColor[0, 0, 0.4]], 
        RowBox[{"-", "v0"}], "+"], " ", 
       SubsuperscriptBox[
        StyleBox["\[ScriptU]",
         FontColor->RGBColor[0, 0, 0.4]], "v0", "+"]}]], 
     RowBox[{"(", 
      RowBox[{"108", "+", 
       FractionBox["12", 
        SuperscriptBox[
         StyleBox["\[ScriptU]",
          FontColor->RGBColor[0, 0, 0.4]], "4"]], "-", 
       FractionBox[
        RowBox[{"18", " ", "\[ImaginaryI]"}], 
        SuperscriptBox[
         StyleBox["\[ScriptU]",
          FontColor->RGBColor[0, 0, 0.4]], "3"]], "-", 
       FractionBox["\[ImaginaryI]", 
        SuperscriptBox[
         RowBox[{"(", 
          SuperscriptBox[
           StyleBox["\[ScriptU]",
            FontColor->RGBColor[0, 0, 0.4]], 
           RowBox[{"[", "2", "]"}]], ")"}], "7"]], "+", 
       FractionBox["3", 
        SuperscriptBox[
         RowBox[{"(", 
          SuperscriptBox[
           StyleBox["\[ScriptU]",
            FontColor->RGBColor[0, 0, 0.4]], 
           RowBox[{"[", "2", "]"}]], ")"}], "4"]], "+", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          RowBox[{"18", " ", 
           RowBox[{"(", 
            RowBox[{"3", "-", 
             RowBox[{"\[ImaginaryI]", " ", 
              SqrtBox["3"]}]}], ")"}]}], "-", 
          RowBox[{"108", " ", "\[ImaginaryI]", " ", "u"}]}], ")"}], " ", 
        SubsuperscriptBox[
         StyleBox["\[Eta]0",
          FontWeight->Bold,
          FontColor->RGBColor[0, 0.5, 0]], "2", "+"]}], "+", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          RowBox[{
           RowBox[{"-", "18"}], " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"-", "\[ImaginaryI]"}], "+", 
             SqrtBox["3"]}], ")"}]}], "+", 
          RowBox[{"36", " ", "\[ImaginaryI]", " ", 
           SqrtBox["3"], " ", "u"}]}], ")"}], " ", 
        SubsuperscriptBox[
         StyleBox["\[Eta]0",
          FontWeight->Bold,
          FontColor->RGBColor[0, 0.5, 0]], "3", "+"]}], "+", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          RowBox[{"3", " ", 
           RowBox[{"(", 
            RowBox[{"3", "-", 
             RowBox[{"\[ImaginaryI]", " ", 
              SqrtBox["3"]}]}], ")"}]}], "-", 
          RowBox[{"18", " ", "\[ImaginaryI]", " ", "u"}]}], ")"}], " ", 
        SubsuperscriptBox[
         StyleBox["\[Eta]0",
          FontWeight->Bold,
          FontColor->RGBColor[0, 0.5, 0]], "4", "+"]}], "+", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          RowBox[{"18", " ", 
           RowBox[{"(", 
            RowBox[{"3", "+", 
             RowBox[{"\[ImaginaryI]", " ", 
              SqrtBox["3"]}]}], ")"}]}], "-", 
          RowBox[{"108", " ", "\[ImaginaryI]", " ", "u"}]}], ")"}], " ", 
        SubsuperscriptBox[
         OverscriptBox[
          StyleBox["\[Eta]0",
           FontWeight->Bold,
           FontColor->RGBColor[0, 0.5, 0]], 
          StyleBox["_",
           FontWeight->Bold,
           FontColor->RGBColor[0, 0.5, 0]]], "2", "-"]}], "+", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          RowBox[{
           RowBox[{"-", "18"}], " ", 
           RowBox[{"(", 
            RowBox[{"\[ImaginaryI]", "+", 
             SqrtBox["3"]}], ")"}]}], "+", 
          RowBox[{"36", " ", "\[ImaginaryI]", " ", 
           SqrtBox["3"], " ", "u"}]}], ")"}], " ", 
        SubsuperscriptBox[
         OverscriptBox[
          StyleBox["\[Eta]0",
           FontWeight->Bold,
           FontColor->RGBColor[0, 0.5, 0]], 
          StyleBox["_",
           FontWeight->Bold,
           FontColor->RGBColor[0, 0.5, 0]]], "3", "-"]}], "+", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          RowBox[{"3", " ", 
           RowBox[{"(", 
            RowBox[{"3", "+", 
             RowBox[{"\[ImaginaryI]", " ", 
              SqrtBox["3"]}]}], ")"}]}], "-", 
          RowBox[{"18", " ", "\[ImaginaryI]", " ", "u"}]}], ")"}], " ", 
        SubsuperscriptBox[
         OverscriptBox[
          StyleBox["\[Eta]0",
           FontWeight->Bold,
           FontColor->RGBColor[0, 0.5, 0]], 
          StyleBox["_",
           FontWeight->Bold,
           FontColor->RGBColor[0, 0.5, 0]]], "4", "-"]}], "+", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          RowBox[{"-", 
           FractionBox[
            RowBox[{"2", " ", "\[ImaginaryI]"}], 
            SuperscriptBox[
             StyleBox["\[ScriptU]",
              FontColor->RGBColor[0, 0, 0.4]], "5"]]}], "-", 
          FractionBox["6", 
           SuperscriptBox[
            StyleBox["\[ScriptU]",
             FontColor->RGBColor[0, 0, 0.4]], "4"]], "-", 
          FractionBox[
           RowBox[{"2", " ", "\[ImaginaryI]"}], 
           SuperscriptBox[
            RowBox[{"(", 
             SuperscriptBox[
              StyleBox["\[ScriptU]",
               FontColor->RGBColor[0, 0, 0.4]], 
              RowBox[{"[", "2", "]"}]], ")"}], "5"]], "+", 
          FractionBox["6", 
           SuperscriptBox[
            RowBox[{"(", 
             SuperscriptBox[
              StyleBox["\[ScriptU]",
               FontColor->RGBColor[0, 0, 0.4]], 
              RowBox[{"[", "2", "]"}]], ")"}], "4"]]}], ")"}], " ", 
        SubsuperscriptBox[
         StyleBox["\[Eta]",
          FontWeight->Bold,
          FontColor->RGBColor[0.8, 0, 0]], "2", 
         RowBox[{"[", "2", "]"}]]}], "+", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          FractionBox[
           RowBox[{"4", " ", "\[ImaginaryI]"}], 
           SuperscriptBox[
            StyleBox["\[ScriptU]",
             FontColor->RGBColor[0, 0, 0.4]], "4"]], "+", 
          FractionBox["6", 
           SuperscriptBox[
            StyleBox["\[ScriptU]",
             FontColor->RGBColor[0, 0, 0.4]], "3"]], "+", 
          FractionBox[
           RowBox[{"4", " ", "\[ImaginaryI]"}], 
           SuperscriptBox[
            RowBox[{"(", 
             SuperscriptBox[
              StyleBox["\[ScriptU]",
               FontColor->RGBColor[0, 0, 0.4]], 
              RowBox[{"[", "2", "]"}]], ")"}], "4"]], "-", 
          FractionBox["6", 
           SuperscriptBox[
            RowBox[{"(", 
             SuperscriptBox[
              StyleBox["\[ScriptU]",
               FontColor->RGBColor[0, 0, 0.4]], 
              RowBox[{"[", "2", "]"}]], ")"}], "3"]]}], ")"}], " ", 
        SubsuperscriptBox[
         StyleBox["\[Eta]",
          FontWeight->Bold,
          FontColor->RGBColor[0.8, 0, 0]], "3", 
         RowBox[{"[", "2", "]"}]]}], "+", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          RowBox[{"-", 
           FractionBox["\[ImaginaryI]", 
            SuperscriptBox[
             StyleBox["\[ScriptU]",
              FontColor->RGBColor[0, 0, 0.4]], "3"]]}], "-", 
          FractionBox["\[ImaginaryI]", 
           SuperscriptBox[
            RowBox[{"(", 
             SuperscriptBox[
              StyleBox["\[ScriptU]",
               FontColor->RGBColor[0, 0, 0.4]], 
              RowBox[{"[", "2", "]"}]], ")"}], "3"]]}], ")"}], " ", 
        SubsuperscriptBox[
         StyleBox["\[Eta]",
          FontWeight->Bold,
          FontColor->RGBColor[0.8, 0, 0]], "4", 
         RowBox[{"[", "2", "]"}]]}]}], ")"}]}], "+", 
    RowBox[{
     FractionBox["1", 
      RowBox[{
       SubsuperscriptBox[
        StyleBox["\[ScriptU]",
         FontColor->RGBColor[0, 0, 0.4]], 
        RowBox[{"-", "v0"}], 
        RowBox[{"[", "3", "]"}]], " ", 
       SubsuperscriptBox[
        StyleBox["\[ScriptU]",
         FontColor->RGBColor[0, 0, 0.4]], "v0", 
        RowBox[{"[", "3", "]"}]]}]], 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"-", "54"}], "+", 
       FractionBox["\[ImaginaryI]", 
        SuperscriptBox[
         RowBox[{"(", 
          SuperscriptBox[
           StyleBox["\[ScriptU]",
            FontColor->RGBColor[0, 0, 0.4]], 
           RowBox[{"[", "2", "]"}]], ")"}], "7"]], "-", 
       FractionBox["12", 
        SuperscriptBox[
         RowBox[{"(", 
          SuperscriptBox[
           StyleBox["\[ScriptU]",
            FontColor->RGBColor[0, 0, 0.4]], 
           RowBox[{"[", "2", "]"}]], ")"}], "4"]], "+", 
       FractionBox[
        RowBox[{"18", " ", "\[ImaginaryI]"}], 
        SuperscriptBox[
         RowBox[{"(", 
          SuperscriptBox[
           StyleBox["\[ScriptU]",
            FontColor->RGBColor[0, 0, 0.4]], 
           RowBox[{"[", "2", "]"}]], ")"}], "3"]], "+", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          RowBox[{"9", " ", "\[ImaginaryI]", " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"9", " ", "\[ImaginaryI]"}], "+", 
             SqrtBox["3"]}], ")"}]}], "+", 
          RowBox[{"54", " ", "\[ImaginaryI]", " ", "u"}]}], ")"}], " ", 
        SubsuperscriptBox[
         StyleBox["\[Eta]0",
          FontWeight->Bold,
          FontColor->RGBColor[0, 0.5, 0]], "2", "+"]}], "+", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          RowBox[{"9", " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"-", "\[ImaginaryI]"}], "+", 
             RowBox[{"3", " ", 
              SqrtBox["3"]}]}], ")"}]}], "-", 
          RowBox[{"18", " ", "\[ImaginaryI]", " ", 
           SqrtBox["3"], " ", "u"}]}], ")"}], " ", 
        SubsuperscriptBox[
         StyleBox["\[Eta]0",
          FontWeight->Bold,
          FontColor->RGBColor[0, 0.5, 0]], "3", "+"]}], "+", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          RowBox[{
           FractionBox["3", "2"], " ", "\[ImaginaryI]", " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"9", " ", "\[ImaginaryI]"}], "+", 
             SqrtBox["3"]}], ")"}]}], "+", 
          RowBox[{"9", " ", "\[ImaginaryI]", " ", "u"}]}], ")"}], " ", 
        SubsuperscriptBox[
         StyleBox["\[Eta]0",
          FontWeight->Bold,
          FontColor->RGBColor[0, 0.5, 0]], "4", "+"]}], "+", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          RowBox[{
           RowBox[{"-", "9"}], " ", "\[ImaginaryI]", " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{
              RowBox[{"-", "9"}], " ", "\[ImaginaryI]"}], "+", 
             SqrtBox["3"]}], ")"}]}], "+", 
          RowBox[{"54", " ", "\[ImaginaryI]", " ", "u"}]}], ")"}], " ", 
        SubsuperscriptBox[
         OverscriptBox[
          StyleBox["\[Eta]0",
           FontWeight->Bold,
           FontColor->RGBColor[0, 0.5, 0]], 
          StyleBox["_",
           FontWeight->Bold,
           FontColor->RGBColor[0, 0.5, 0]]], "2", "-"]}], "+", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          RowBox[{"9", " ", 
           RowBox[{"(", 
            RowBox[{"\[ImaginaryI]", "+", 
             RowBox[{"3", " ", 
              SqrtBox["3"]}]}], ")"}]}], "-", 
          RowBox[{"18", " ", "\[ImaginaryI]", " ", 
           SqrtBox["3"], " ", "u"}]}], ")"}], " ", 
        SubsuperscriptBox[
         OverscriptBox[
          StyleBox["\[Eta]0",
           FontWeight->Bold,
           FontColor->RGBColor[0, 0.5, 0]], 
          StyleBox["_",
           FontWeight->Bold,
           FontColor->RGBColor[0, 0.5, 0]]], "3", "-"]}], "+", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          RowBox[{
           RowBox[{"-", 
            FractionBox["3", "2"]}], " ", "\[ImaginaryI]", " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{
              RowBox[{"-", "9"}], " ", "\[ImaginaryI]"}], "+", 
             SqrtBox["3"]}], ")"}]}], "+", 
          RowBox[{"9", " ", "\[ImaginaryI]", " ", "u"}]}], ")"}], " ", 
        SubsuperscriptBox[
         OverscriptBox[
          StyleBox["\[Eta]0",
           FontWeight->Bold,
           FontColor->RGBColor[0, 0.5, 0]], 
          StyleBox["_",
           FontWeight->Bold,
           FontColor->RGBColor[0, 0.5, 0]]], "4", "-"]}], "+", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          FractionBox[
           RowBox[{"2", " ", "\[ImaginaryI]"}], 
           SuperscriptBox[
            RowBox[{"(", 
             SuperscriptBox[
              StyleBox["\[ScriptU]",
               FontColor->RGBColor[0, 0, 0.4]], 
              RowBox[{"[", "2", "]"}]], ")"}], "5"]], "+", 
          FractionBox["6", 
           SuperscriptBox[
            RowBox[{"(", 
             SuperscriptBox[
              StyleBox["\[ScriptU]",
               FontColor->RGBColor[0, 0, 0.4]], 
              RowBox[{"[", "2", "]"}]], ")"}], "4"]]}], ")"}], " ", 
        SubsuperscriptBox[
         StyleBox["\[Eta]",
          FontWeight->Bold,
          FontColor->RGBColor[0.8, 0, 0]], "2", 
         RowBox[{"[", "2", "]"}]]}], "+", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          RowBox[{"-", 
           FractionBox[
            RowBox[{"4", " ", "\[ImaginaryI]"}], 
            SuperscriptBox[
             RowBox[{"(", 
              SuperscriptBox[
               StyleBox["\[ScriptU]",
                FontColor->RGBColor[0, 0, 0.4]], 
               RowBox[{"[", "2", "]"}]], ")"}], "4"]]}], "-", 
          FractionBox["6", 
           SuperscriptBox[
            RowBox[{"(", 
             SuperscriptBox[
              StyleBox["\[ScriptU]",
               FontColor->RGBColor[0, 0, 0.4]], 
              RowBox[{"[", "2", "]"}]], ")"}], "3"]]}], ")"}], " ", 
        SubsuperscriptBox[
         StyleBox["\[Eta]",
          FontWeight->Bold,
          FontColor->RGBColor[0.8, 0, 0]], "3", 
         RowBox[{"[", "2", "]"}]]}], "+", 
       FractionBox[
        RowBox[{"\[ImaginaryI]", " ", 
         SubsuperscriptBox[
          StyleBox["\[Eta]",
           FontWeight->Bold,
           FontColor->RGBColor[0.8, 0, 0]], "4", 
          RowBox[{"[", "2", "]"}]]}], 
        SuperscriptBox[
         RowBox[{"(", 
          SuperscriptBox[
           StyleBox["\[ScriptU]",
            FontColor->RGBColor[0, 0, 0.4]], 
           RowBox[{"[", "2", "]"}]], ")"}], "3"]]}], ")"}]}]}], 
   ")"}]}]], "Output",
 CellChangeTimes->{{3.562247187133875*^9, 3.56224720847047*^9}, {
   3.562247238971909*^9, 3.562247273734145*^9}, 3.56224732548437*^9, 
   3.562914813055235*^9, 3.562914999437415*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"rltH3", "=", 
  RowBox[{"Collect", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"rltH2", "//", "funapartusu"}], "//", "funreduceusu"}], ",", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"g", ",", "\[Eta]list", ",", 
       RowBox[{
        RowBox[{"\[ScriptU]$", "[", "_", "]"}], "[", "_", "]"}], ",", 
       "\[Eta]0list", ",", 
       SqrtBox["3"]}], "}"}], "//", "Flatten"}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.5629150482334213`*^9, 3.562915058516782*^9}, {
  3.562915129640624*^9, 3.562915166736492*^9}, {3.562915212160584*^9, 
  3.562915214350272*^9}}],

Cell[BoxData[
 RowBox[{
  SuperscriptBox["g", "8"], " ", 
  RowBox[{"(", 
   RowBox[{
    RowBox[{"-", 
     FractionBox[
      RowBox[{"81", " ", "\[ImaginaryI]"}], 
      SuperscriptBox[
       StyleBox["\[ScriptU]",
        FontColor->RGBColor[0, 0, 0.4]], "3"]]}], "+", 
    FractionBox[
     RowBox[{"81", " ", "\[ImaginaryI]"}], 
     StyleBox["\[ScriptU]",
      FontColor->RGBColor[0, 0, 0.4]]], "-", 
    FractionBox["27", 
     SuperscriptBox[
      RowBox[{"(", 
       SuperscriptBox[
        StyleBox["\[ScriptU]",
         FontColor->RGBColor[0, 0, 0.4]], 
        RowBox[{"[", "2", "]"}]], ")"}], "4"]], "+", 
    FractionBox[
     RowBox[{"27", "-", 
      RowBox[{"36", " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "2"]}]}], 
     SuperscriptBox[
      StyleBox["\[ScriptU]",
       FontColor->RGBColor[0, 0, 0.4]], "4"]], "+", 
    FractionBox[
     RowBox[{
      RowBox[{
       RowBox[{"-", "81"}], " ", "\[ImaginaryI]"}], "+", 
      RowBox[{"144", " ", "\[ImaginaryI]", " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "3"]}]}], 
     SuperscriptBox[
      RowBox[{"(", 
       SuperscriptBox[
        StyleBox["\[ScriptU]",
         FontColor->RGBColor[0, 0, 0.4]], 
        RowBox[{"[", "2", "]"}]], ")"}], "3"]], "+", 
    FractionBox[
     RowBox[{
      RowBox[{
       RowBox[{"-", "216"}], " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "2"]}], "+", 
      RowBox[{"360", " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "4"]}]}], 
     SuperscriptBox[
      StyleBox["\[ScriptU]",
       FontColor->RGBColor[0, 0, 0.4]], "2"]], "+", 
    FractionBox[
     RowBox[{
      RowBox[{"81", " ", "\[ImaginaryI]"}], "+", 
      RowBox[{"432", " ", "\[ImaginaryI]", " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "3"]}], "-", 
      RowBox[{"720", " ", "\[ImaginaryI]", " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "5"]}]}], 
     SuperscriptBox[
      StyleBox["\[ScriptU]",
       FontColor->RGBColor[0, 0, 0.4]], 
      RowBox[{"[", "2", "]"}]]], "+", 
    FractionBox[
     RowBox[{
      RowBox[{"-", 
       FractionBox[
        RowBox[{"81", " ", "\[ImaginaryI]"}], "2"]}], "-", 
      FractionBox[
       RowBox[{"81", " ", 
        SqrtBox["3"]}], "2"], "+", 
      RowBox[{"54", " ", "\[ImaginaryI]", " ", 
       SubsuperscriptBox[
        StyleBox["\[Eta]0",
         FontWeight->Bold,
         FontColor->RGBColor[0, 0.5, 0]], "2", "+"]}], "-", 
      RowBox[{"18", " ", "\[ImaginaryI]", " ", 
       SqrtBox["3"], " ", 
       SubsuperscriptBox[
        StyleBox["\[Eta]0",
         FontWeight->Bold,
         FontColor->RGBColor[0, 0.5, 0]], "3", "+"]}], "+", 
      RowBox[{"9", " ", "\[ImaginaryI]", " ", 
       SubsuperscriptBox[
        StyleBox["\[Eta]0",
         FontWeight->Bold,
         FontColor->RGBColor[0, 0.5, 0]], "4", "+"]}]}], 
     SubsuperscriptBox[
      StyleBox["\[ScriptU]",
       FontColor->RGBColor[0, 0, 0.4]], 
      RowBox[{"-", "v0"}], "-"]], "+", 
    FractionBox[
     RowBox[{
      FractionBox[
       RowBox[{"81", " ", "\[ImaginaryI]"}], "2"], "-", 
      FractionBox[
       RowBox[{"81", " ", 
        SqrtBox["3"]}], "2"], "+", 
      RowBox[{"54", " ", "\[ImaginaryI]", " ", 
       SubsuperscriptBox[
        StyleBox["\[Eta]0",
         FontWeight->Bold,
         FontColor->RGBColor[0, 0.5, 0]], "2", "+"]}], "-", 
      RowBox[{"18", " ", "\[ImaginaryI]", " ", 
       SqrtBox["3"], " ", 
       SubsuperscriptBox[
        StyleBox["\[Eta]0",
         FontWeight->Bold,
         FontColor->RGBColor[0, 0.5, 0]], "3", "+"]}], "+", 
      RowBox[{"9", " ", "\[ImaginaryI]", " ", 
       SubsuperscriptBox[
        StyleBox["\[Eta]0",
         FontWeight->Bold,
         FontColor->RGBColor[0, 0.5, 0]], "4", "+"]}]}], 
     SubsuperscriptBox[
      StyleBox["\[ScriptU]",
       FontColor->RGBColor[0, 0, 0.4]], 
      RowBox[{"-", "v0"}], 
      RowBox[{"[", "3", "]"}]]], "+", 
    FractionBox[
     RowBox[{
      RowBox[{
       RowBox[{"-", "108"}], " ", "\[ImaginaryI]", " ", 
       SubsuperscriptBox[
        StyleBox["\[Eta]0",
         FontWeight->Bold,
         FontColor->RGBColor[0, 0.5, 0]], "2", "+"]}], "+", 
      RowBox[{"36", " ", "\[ImaginaryI]", " ", 
       SqrtBox["3"], " ", 
       SubsuperscriptBox[
        StyleBox["\[Eta]0",
         FontWeight->Bold,
         FontColor->RGBColor[0, 0.5, 0]], "3", "+"]}], "-", 
      RowBox[{"18", " ", "\[ImaginaryI]", " ", 
       SubsuperscriptBox[
        StyleBox["\[Eta]0",
         FontWeight->Bold,
         FontColor->RGBColor[0, 0.5, 0]], "4", "+"]}]}], 
     SubsuperscriptBox[
      StyleBox["\[ScriptU]",
       FontColor->RGBColor[0, 0, 0.4]], 
      RowBox[{"-", "v0"}], "+"]], "+", 
    FractionBox[
     RowBox[{
      RowBox[{"-", 
       FractionBox[
        RowBox[{"81", " ", "\[ImaginaryI]"}], "2"]}], "+", 
      FractionBox[
       RowBox[{"81", " ", 
        SqrtBox["3"]}], "2"], "+", 
      RowBox[{"54", " ", "\[ImaginaryI]", " ", 
       SubsuperscriptBox[
        OverscriptBox[
         StyleBox["\[Eta]0",
          FontWeight->Bold,
          FontColor->RGBColor[0, 0.5, 0]], 
         StyleBox["_",
          FontWeight->Bold,
          FontColor->RGBColor[0, 0.5, 0]]], "2", "-"]}], "-", 
      RowBox[{"18", " ", "\[ImaginaryI]", " ", 
       SqrtBox["3"], " ", 
       SubsuperscriptBox[
        OverscriptBox[
         StyleBox["\[Eta]0",
          FontWeight->Bold,
          FontColor->RGBColor[0, 0.5, 0]], 
         StyleBox["_",
          FontWeight->Bold,
          FontColor->RGBColor[0, 0.5, 0]]], "3", "-"]}], "+", 
      RowBox[{"9", " ", "\[ImaginaryI]", " ", 
       SubsuperscriptBox[
        OverscriptBox[
         StyleBox["\[Eta]0",
          FontWeight->Bold,
          FontColor->RGBColor[0, 0.5, 0]], 
         StyleBox["_",
          FontWeight->Bold,
          FontColor->RGBColor[0, 0.5, 0]]], "4", "-"]}]}], 
     SubsuperscriptBox[
      StyleBox["\[ScriptU]",
       FontColor->RGBColor[0, 0, 0.4]], "v0", "-"]], "+", 
    FractionBox[
     RowBox[{
      FractionBox[
       RowBox[{"81", " ", "\[ImaginaryI]"}], "2"], "+", 
      FractionBox[
       RowBox[{"81", " ", 
        SqrtBox["3"]}], "2"], "+", 
      RowBox[{"54", " ", "\[ImaginaryI]", " ", 
       SubsuperscriptBox[
        OverscriptBox[
         StyleBox["\[Eta]0",
          FontWeight->Bold,
          FontColor->RGBColor[0, 0.5, 0]], 
         StyleBox["_",
          FontWeight->Bold,
          FontColor->RGBColor[0, 0.5, 0]]], "2", "-"]}], "-", 
      RowBox[{"18", " ", "\[ImaginaryI]", " ", 
       SqrtBox["3"], " ", 
       SubsuperscriptBox[
        OverscriptBox[
         StyleBox["\[Eta]0",
          FontWeight->Bold,
          FontColor->RGBColor[0, 0.5, 0]], 
         StyleBox["_",
          FontWeight->Bold,
          FontColor->RGBColor[0, 0.5, 0]]], "3", "-"]}], "+", 
      RowBox[{"9", " ", "\[ImaginaryI]", " ", 
       SubsuperscriptBox[
        OverscriptBox[
         StyleBox["\[Eta]0",
          FontWeight->Bold,
          FontColor->RGBColor[0, 0.5, 0]], 
         StyleBox["_",
          FontWeight->Bold,
          FontColor->RGBColor[0, 0.5, 0]]], "4", "-"]}]}], 
     SubsuperscriptBox[
      StyleBox["\[ScriptU]",
       FontColor->RGBColor[0, 0, 0.4]], "v0", 
      RowBox[{"[", "3", "]"}]]], "+", 
    FractionBox[
     RowBox[{
      RowBox[{
       RowBox[{"-", "108"}], " ", "\[ImaginaryI]", " ", 
       SubsuperscriptBox[
        OverscriptBox[
         StyleBox["\[Eta]0",
          FontWeight->Bold,
          FontColor->RGBColor[0, 0.5, 0]], 
         StyleBox["_",
          FontWeight->Bold,
          FontColor->RGBColor[0, 0.5, 0]]], "2", "-"]}], "+", 
      RowBox[{"36", " ", "\[ImaginaryI]", " ", 
       SqrtBox["3"], " ", 
       SubsuperscriptBox[
        OverscriptBox[
         StyleBox["\[Eta]0",
          FontWeight->Bold,
          FontColor->RGBColor[0, 0.5, 0]], 
         StyleBox["_",
          FontWeight->Bold,
          FontColor->RGBColor[0, 0.5, 0]]], "3", "-"]}], "-", 
      RowBox[{"18", " ", "\[ImaginaryI]", " ", 
       SubsuperscriptBox[
        OverscriptBox[
         StyleBox["\[Eta]0",
          FontWeight->Bold,
          FontColor->RGBColor[0, 0.5, 0]], 
         StyleBox["_",
          FontWeight->Bold,
          FontColor->RGBColor[0, 0.5, 0]]], "4", "-"]}]}], 
     SubsuperscriptBox[
      StyleBox["\[ScriptU]",
       FontColor->RGBColor[0, 0, 0.4]], "v0", "+"]], "+", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{"-", 
        FractionBox["18", 
         SuperscriptBox[
          StyleBox["\[ScriptU]",
           FontColor->RGBColor[0, 0, 0.4]], "4"]]}], "-", 
       FractionBox["108", 
        SuperscriptBox[
         StyleBox["\[ScriptU]",
          FontColor->RGBColor[0, 0, 0.4]], "2"]], "+", 
       FractionBox["18", 
        SuperscriptBox[
         RowBox[{"(", 
          SuperscriptBox[
           StyleBox["\[ScriptU]",
            FontColor->RGBColor[0, 0, 0.4]], 
           RowBox[{"[", "2", "]"}]], ")"}], "4"]], "+", 
       FractionBox["108", 
        SuperscriptBox[
         RowBox[{"(", 
          SuperscriptBox[
           StyleBox["\[ScriptU]",
            FontColor->RGBColor[0, 0, 0.4]], 
           RowBox[{"[", "2", "]"}]], ")"}], "2"]], "-", 
       FractionBox[
        RowBox[{"54", " ", "\[ImaginaryI]"}], 
        SubsuperscriptBox[
         StyleBox["\[ScriptU]",
          FontColor->RGBColor[0, 0, 0.4]], 
         RowBox[{"-", "v0"}], "-"]], "+", 
       FractionBox[
        RowBox[{"108", " ", "\[ImaginaryI]"}], 
        SubsuperscriptBox[
         StyleBox["\[ScriptU]",
          FontColor->RGBColor[0, 0, 0.4]], 
         RowBox[{"-", "v0"}], "+"]], "-", 
       FractionBox[
        RowBox[{"54", " ", "\[ImaginaryI]"}], 
        SubsuperscriptBox[
         StyleBox["\[ScriptU]",
          FontColor->RGBColor[0, 0, 0.4]], 
         RowBox[{"-", "v0"}], 
         RowBox[{"[", "3", "]"}]]], "-", 
       FractionBox[
        RowBox[{"54", " ", "\[ImaginaryI]"}], 
        SubsuperscriptBox[
         StyleBox["\[ScriptU]",
          FontColor->RGBColor[0, 0, 0.4]], "v0", "-"]], "+", 
       FractionBox[
        RowBox[{"108", " ", "\[ImaginaryI]"}], 
        SubsuperscriptBox[
         StyleBox["\[ScriptU]",
          FontColor->RGBColor[0, 0, 0.4]], "v0", "+"]], "-", 
       FractionBox[
        RowBox[{"54", " ", "\[ImaginaryI]"}], 
        SubsuperscriptBox[
         StyleBox["\[ScriptU]",
          FontColor->RGBColor[0, 0, 0.4]], "v0", 
         RowBox[{"[", "3", "]"}]]]}], ")"}], " ", 
     SubsuperscriptBox[
      StyleBox["\[Eta]",
       FontWeight->Bold,
       FontColor->RGBColor[0.8, 0, 0]], "2", 
      RowBox[{"[", "2", "]"}]]}], "+", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       FractionBox["36", 
        SuperscriptBox[
         StyleBox["\[ScriptU]",
          FontColor->RGBColor[0, 0, 0.4]], "3"]], "-", 
       FractionBox["36", 
        SuperscriptBox[
         RowBox[{"(", 
          SuperscriptBox[
           StyleBox["\[ScriptU]",
            FontColor->RGBColor[0, 0, 0.4]], 
           RowBox[{"[", "2", "]"}]], ")"}], "3"]], "+", 
       FractionBox[
        RowBox[{"18", " ", "\[ImaginaryI]", " ", 
         SqrtBox["3"]}], 
        SubsuperscriptBox[
         StyleBox["\[ScriptU]",
          FontColor->RGBColor[0, 0, 0.4]], 
         RowBox[{"-", "v0"}], "-"]], "-", 
       FractionBox[
        RowBox[{"36", " ", "\[ImaginaryI]", " ", 
         SqrtBox["3"]}], 
        SubsuperscriptBox[
         StyleBox["\[ScriptU]",
          FontColor->RGBColor[0, 0, 0.4]], 
         RowBox[{"-", "v0"}], "+"]], "+", 
       FractionBox[
        RowBox[{"18", " ", "\[ImaginaryI]", " ", 
         SqrtBox["3"]}], 
        SubsuperscriptBox[
         StyleBox["\[ScriptU]",
          FontColor->RGBColor[0, 0, 0.4]], 
         RowBox[{"-", "v0"}], 
         RowBox[{"[", "3", "]"}]]], "-", 
       FractionBox[
        RowBox[{"18", " ", "\[ImaginaryI]", " ", 
         SqrtBox["3"]}], 
        SubsuperscriptBox[
         StyleBox["\[ScriptU]",
          FontColor->RGBColor[0, 0, 0.4]], "v0", "-"]], "+", 
       FractionBox[
        RowBox[{"36", " ", "\[ImaginaryI]", " ", 
         SqrtBox["3"]}], 
        SubsuperscriptBox[
         StyleBox["\[ScriptU]",
          FontColor->RGBColor[0, 0, 0.4]], "v0", "+"]], "-", 
       FractionBox[
        RowBox[{"18", " ", "\[ImaginaryI]", " ", 
         SqrtBox["3"]}], 
        SubsuperscriptBox[
         StyleBox["\[ScriptU]",
          FontColor->RGBColor[0, 0, 0.4]], "v0", 
         RowBox[{"[", "3", "]"}]]]}], ")"}], " ", 
     SubsuperscriptBox[
      StyleBox["\[Eta]",
       FontWeight->Bold,
       FontColor->RGBColor[0.8, 0, 0]], "3", 
      RowBox[{"[", "2", "]"}]]}], "+", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{"-", 
        FractionBox["18", 
         SuperscriptBox[
          StyleBox["\[ScriptU]",
           FontColor->RGBColor[0, 0, 0.4]], "2"]]}], "+", 
       FractionBox["18", 
        SuperscriptBox[
         RowBox[{"(", 
          SuperscriptBox[
           StyleBox["\[ScriptU]",
            FontColor->RGBColor[0, 0, 0.4]], 
           RowBox[{"[", "2", "]"}]], ")"}], "2"]], "-", 
       FractionBox[
        RowBox[{"9", " ", "\[ImaginaryI]"}], 
        SubsuperscriptBox[
         StyleBox["\[ScriptU]",
          FontColor->RGBColor[0, 0, 0.4]], 
         RowBox[{"-", "v0"}], "-"]], "+", 
       FractionBox[
        RowBox[{"18", " ", "\[ImaginaryI]"}], 
        SubsuperscriptBox[
         StyleBox["\[ScriptU]",
          FontColor->RGBColor[0, 0, 0.4]], 
         RowBox[{"-", "v0"}], "+"]], "-", 
       FractionBox[
        RowBox[{"9", " ", "\[ImaginaryI]"}], 
        SubsuperscriptBox[
         StyleBox["\[ScriptU]",
          FontColor->RGBColor[0, 0, 0.4]], 
         RowBox[{"-", "v0"}], 
         RowBox[{"[", "3", "]"}]]], "-", 
       FractionBox[
        RowBox[{"9", " ", "\[ImaginaryI]"}], 
        SubsuperscriptBox[
         StyleBox["\[ScriptU]",
          FontColor->RGBColor[0, 0, 0.4]], "v0", "-"]], "+", 
       FractionBox[
        RowBox[{"18", " ", "\[ImaginaryI]"}], 
        SubsuperscriptBox[
         StyleBox["\[ScriptU]",
          FontColor->RGBColor[0, 0, 0.4]], "v0", "+"]], "-", 
       FractionBox[
        RowBox[{"9", " ", "\[ImaginaryI]"}], 
        SubsuperscriptBox[
         StyleBox["\[ScriptU]",
          FontColor->RGBColor[0, 0, 0.4]], "v0", 
         RowBox[{"[", "3", "]"}]]]}], ")"}], " ", 
     SubsuperscriptBox[
      StyleBox["\[Eta]",
       FontWeight->Bold,
       FontColor->RGBColor[0.8, 0, 0]], "4", 
      RowBox[{"[", "2", "]"}]]}]}], ")"}]}]], "Output",
 CellChangeTimes->{{3.5629150543590517`*^9, 3.562915059280971*^9}, {
   3.562915144678303*^9, 3.562915167369379*^9}, 3.5629152151848907`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"rltH3", "-", "rltH"}], "/.", "subusu"}], "/.", "subQ0"}], "//", 
  "Simplify"}]], "Input",
 CellChangeTimes->{{3.562915243336894*^9, 3.562915251034831*^9}}],

Cell[BoxData["0"], "Output",
 CellChangeTimes->{3.562915253246723*^9}]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"rltH", "=", "rltH3"}], ";"}]], "Input",
 CellChangeTimes->{{3.562915258604002*^9, 3.562915261594112*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 "Computing \[Delta]\[GothicCapitalT], and answer for ",
 Cell[BoxData[
  RowBox[{
   RowBox[{"+", 
    RowBox[{"\[DoubleStruckCapitalC]", "[", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        FractionBox["1", 
         RowBox[{"v", "-", "u"}]], "-", 
        FractionBox["1", 
         RowBox[{"v", "+", "u"}]]}], ")"}], 
      RowBox[{"Log", "[", 
       SubscriptBox[
        RowBox[{"(", 
         FractionBox[
          RowBox[{
           SuperscriptBox[
            StyleBox["\[GothicCapitalT]",
             FontColor->RGBColor[0.54, 0.35, 0.15]], "+"], " "}], 
          SuperscriptBox[
           StyleBox["\[ScriptCapitalT]",
            FontColor->RGBColor[1, 0, 0]], "+"]], ")"}], "r"], "]"}]}], 
     "]"}]}], "=", "mrlt"}]],
  CellChangeTimes->{{3.556047481854261*^9, 3.556047663808538*^9}, {
   3.556047728702054*^9, 3.55604773051369*^9}, {3.556048953105239*^9, 
   3.5560489553176203`*^9}, {3.5609416087569103`*^9, 3.560941657961896*^9}}]
}], "Subsection",
 CellChangeTimes->{{3.5560151291481752`*^9, 3.556015132749507*^9}, 
   3.556015986287435*^9, {3.5606832120190897`*^9, 3.560683217153968*^9}, {
   3.562256636901291*^9, 3.562256643476776*^9}, 3.562256677056344*^9, {
   3.562259418712474*^9, 3.562259420508484*^9}}],

Cell[TextData[{
 "\[ScriptCapitalT] does not contribute to the leading order. Indeed, it is \
of order ",
 Cell[BoxData[
  FormBox[
   SuperscriptBox["g", "10"], TraditionalForm]],
  FormatType->"TraditionalForm"],
 ". \[GothicCapitalT] does contribute however. I will first compute this \
contribution very straightforwardly: first I find \[Delta]\[GothicCapitalT], \
then I perform another integration (below a workaround method is also done)."
}], "Text",
 CellChangeTimes->{{3.562915377051036*^9, 3.5629154645273247`*^9}}],

Cell[BoxData[
 RowBox[{"\[Delta]\[GothicCapitalT]", "=", 
  RowBox[{
   RowBox[{
    SubscriptBox["\[ScriptCapitalC]", "1"], 
    OverscriptBox["*", "^"], 
    SubscriptBox["\[Delta]\[Rho]", "2"]}], "-", 
   RowBox[{
    SubscriptBox["\[ScriptCapitalC]", "1"], "*", 
    OverscriptBox["W", "^"]}], "+", 
   SubscriptBox["W", "1"]}]}]], "Input",
 CellChangeTimes->{{3.5606832199249897`*^9, 3.560683255242652*^9}}],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"Collect", "[", 
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{
          RowBox[{
           RowBox[{"(", 
            RowBox[{
             RowBox[{
              RowBox[{"Series", "[", 
               RowBox[{
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{"-", 
                   FractionBox[
                    RowBox[{"2", "w", " ", "g"}], 
                    RowBox[{"2", " ", "\[ImaginaryI]"}]]}], 
                  RowBox[{"(", 
                   RowBox[{
                    FractionBox["1", 
                    RowBox[{"u", "+", 
                    FractionBox["\[ImaginaryI]", "2"], "-", 
                    RowBox[{"2", "g", " ", "w"}]}]], "-", 
                    FractionBox["1", 
                    RowBox[{"u", "-", 
                    FractionBox["\[ImaginaryI]", "2"], "-", 
                    RowBox[{"2", "g", " ", "w"}]}]]}], ")"}], 
                  SuperscriptBox["g", "7"], 
                  RowBox[{"(", 
                   SubscriptBox["\[Delta]\[Rho]2", "lead"], ")"}]}], ")"}], 
                ",", 
                RowBox[{"{", 
                 RowBox[{"g", ",", "0", ",", "8"}], "}"}]}], "]"}], "//", 
              "Normal"}], "//", "Expand"}], ")"}], "/.", 
           RowBox[{
            SuperscriptBox["w", 
             RowBox[{"a_", "/;", 
              RowBox[{"EvenQ", "[", "a", "]"}]}]], "\[Rule]", "0"}]}], "/.", 
          RowBox[{
           RowBox[{
            SuperscriptBox["w", "a_."], 
            SubscriptBox["\[Delta]\[Rho]2", "b_"]}], "\[RuleDelayed]", 
           RowBox[{"M", "[", 
            RowBox[{
             SuperscriptBox["w", 
              RowBox[{"a", "-", "1"}]], 
             SubscriptBox["\[Delta]\[Rho]2", "b"]}], "]"}]}]}], "/.", 
         "sub\[Rho]Ansatz"}], "/.", 
        RowBox[{"(", 
         RowBox[{"Rule", "@@@", 
          RowBox[{"Cases", "[", 
           RowBox[{
            RowBox[{"solut\[Rho]s", "/.", 
             RowBox[{"Rule", "\[Rule]", "List"}]}], ",", 
            RowBox[{"List", "[", 
             RowBox[{"a_", ",", "0"}], "]"}]}], "]"}]}], ")"}]}], "//", 
       "Expand"}], ",", 
      RowBox[{"{", 
       RowBox[{"g", ",", 
        RowBox[{
         SubscriptBox["\[Beta]", "_"], "[", "_", "]"}], ",", 
        RowBox[{
         SubscriptBox["\[Alpha]", "_"], "[", "_", "]"}]}], "}"}], ",", 
      "Together"}], "]"}], "/.", 
    RowBox[{"g", "\[Rule]", "1"}]}], "//", "Simplify"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"\[Rho]2term", "=", 
  RowBox[{"%", "/.", " ", 
   RowBox[{
    RowBox[{
     RowBox[{"4", " ", 
      RowBox[{
       SubscriptBox["\[Alpha]", "lead"], "[", "0", "]"}]}], "+", 
     RowBox[{
      SubscriptBox["\[Alpha]", "lead"], "[", "1", "]"}]}], "\[Rule]", " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"Expand", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"4", " ", 
          RowBox[{
           SubscriptBox["\[Alpha]", "lead"], "[", "0", "]"}]}], "+", 
         RowBox[{
          SubscriptBox["\[Alpha]", "lead"], "[", "1", "]"}]}], "/.", 
        "solut\[Rho]s"}], "]"}], "//.", 
      RowBox[{
       RowBox[{
        RowBox[{"a_.", " ", 
         RowBox[{"\[DoubleStruckCapitalC]", "[", "b_", "]"}]}], "+", 
        RowBox[{"d_.", " ", 
         RowBox[{"\[DoubleStruckCapitalC]", "[", "e_", "]"}]}]}], 
       "\[RuleDelayed]", 
       RowBox[{"\[DoubleStruckCapitalC]", "[", 
        RowBox[{
         RowBox[{
          RowBox[{
           RowBox[{"a", " ", "b"}], "+", 
           RowBox[{"d", " ", "e"}]}], "/.", "subQ0"}], "//", "Simplify"}], 
        "]"}]}]}], ")"}]}]}]}]}], "Input",
 CellChangeTimes->{
  3.562915884647059*^9, {3.562915993317417*^9, 3.5629159963100147`*^9}}],

Cell[BoxData[
 FractionBox[
  RowBox[{
   RowBox[{"\[DoubleStruckCapitalC]", "[", 
    RowBox[{"-", 
     FractionBox[
      RowBox[{"8", " ", "\[ImaginaryI]", " ", 
       RowBox[{"(", 
        RowBox[{"1", "+", 
         RowBox[{"3", " ", 
          SuperscriptBox["u", "2"]}]}], ")"}], " ", 
       SubscriptBox[
        OverscriptBox[
         StyleBox["W",
          FontColor->RGBColor[0.54, 0.35, 0.15]], 
         StyleBox["^",
          FontColor->RGBColor[0.54, 0.35, 0.15]]], "lead"]}], 
      RowBox[{"1", "+", 
       RowBox[{"3", " ", 
        SuperscriptBox["u", "2"]}], "+", 
       RowBox[{"9", " ", 
        SuperscriptBox["u", "4"]}]}]]}], "]"}], "-", 
   RowBox[{
    FractionBox["8", "3"], " ", 
    SubscriptBox[
     StyleBox["W",
      FontColor->RGBColor[0.54, 0.35, 0.15]], 
     RowBox[{"1", ",", "v0", ",", "lead"}]]}]}], 
  RowBox[{"2", "+", 
   RowBox[{"8", " ", 
    SuperscriptBox["u", "2"]}]}]]], "Output",
 CellChangeTimes->{3.562915885109825*^9, 3.562915962483963*^9, 
  3.5629159971478024`*^9, 3.562917059684307*^9, 3.562935251487569*^9, 
  3.563024767441972*^9, 3.563267565302229*^9}]
}, Open  ]],

Cell["\<\
I compute explicitly the integrals:\
\>", "Text",
 CellChangeTimes->{{3.562917064889492*^9, 3.562917074087873*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"Collect", "[", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{"Collect", "[", 
         RowBox[{
          RowBox[{"Series", "[", 
           RowBox[{
            RowBox[{
             RowBox[{
              RowBox[{
               RowBox[{
                RowBox[{"W", "/.", "subWq"}], "/.", "subq34"}], "/.", 
               "substandardq"}], "/.", 
              RowBox[{"{", 
               RowBox[{
                RowBox[{
                 OverscriptBox["\[Alpha]", "_"], "\[Rule]", "0"}], ",", 
                RowBox[{"\[Alpha]", "\[Rule]", "0"}]}], "}"}]}], "/.", 
             RowBox[{"leadweak", "[", "1", "]"}]}], ",", 
            RowBox[{"{", 
             RowBox[{"g", ",", "0", ",", "8"}], "}"}]}], "]"}], ",", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"g", ",", "\[Eta]list", ",", "Q0list"}], "}"}], "//", 
           "Flatten"}]}], "]"}], "/.", 
        RowBox[{"g", "\[Rule]", "1"}]}], "/.", "subtousu"}], "//", 
      "funapartusu"}], "//", "funreduceusu"}], ",", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"\[Eta]list", ",", 
       RowBox[{
        RowBox[{"\[ScriptU]$", "[", "_", "]"}], "[", "_", "]"}]}], "}"}], "//",
      "Flatten"}]}], "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"mtmp", "=", 
   RowBox[{"Collect", "[", 
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          RowBox[{"-", 
           FractionBox[
            RowBox[{"8", " ", "\[ImaginaryI]", " ", 
             RowBox[{"(", 
              RowBox[{"1", "+", 
               RowBox[{"3", " ", 
                SuperscriptBox["u", "2"]}]}], ")"}]}], 
            RowBox[{"9", 
             SuperscriptBox["Q0", "+"], 
             SuperscriptBox["Q0", "-"]}]]}], "/.", "subtousu"}], ")"}], "%"}],
        "//", "funapartusu"}], "//", "funreduceusu"}], ",", "canlist"}], 
    "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"tmp1", "=", 
   RowBox[{
    RowBox[{
     RowBox[{"UpIntegrate", "[", 
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{
          RowBox[{
           RowBox[{"-", 
            FractionBox["1", 
             RowBox[{"2", "\[Pi]", " ", "\[ImaginaryI]"}]]}], "mtmp"}], "/.", 
          "subusu"}], "/.", 
         RowBox[{"u", "\[Rule]", 
          RowBox[{"u", "-", 
           RowBox[{"\[ImaginaryI]", " ", "\[Epsilon]"}]}]}]}], "/.", 
        RowBox[{"Shift", "[", 
         RowBox[{
          RowBox[{"-", "2"}], "\[Epsilon]"}], "]"}]}], ",", "u"}], "]"}], "/.",
      "EndSimplify"}], "//", "fundeperiod"}]}], ";"}]}], "Input",
 CellChangeTimes->{{3.562916057922906*^9, 3.562916067933797*^9}, {
  3.5629161054061813`*^9, 3.562916319158293*^9}, {3.56291675713164*^9, 
  3.562916757716003*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"tmp2", "=", 
  RowBox[{"Collect", "[", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{
          RowBox[{
           FractionBox[
            RowBox[{"-", "8"}], "3"], 
           SubscriptBox["W", "1"]}], "/.", 
          RowBox[{"leadweak", "[", "1", "]"}]}], "/.", 
         RowBox[{"g", "\[Rule]", "1"}]}], "//.", 
        RowBox[{"shiftm\[Eta]", "[", "3", "]"}]}], "//.", 
       RowBox[{"shiftp\[Eta]b", "[", 
        RowBox[{"-", "3"}], "]"}]}], "/.", 
      RowBox[{"Taylorv0", "[", "0", "]"}]}], "//.", "densqrt3"}], ",", 
    "canlist"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.562916775111562*^9, 3.562916833054656*^9}, {
  3.562916872564835*^9, 3.562916880854116*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"-", "864"}], "+", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     RowBox[{"-", "432"}], "+", 
     RowBox[{"144", " ", "\[ImaginaryI]", " ", 
      SqrtBox["3"]}]}], ")"}], " ", 
   SubsuperscriptBox[
    StyleBox["\[Eta]0",
     FontWeight->Bold,
     FontColor->RGBColor[0, 0.5, 0]], "2", "+"]}], "+", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     RowBox[{
      RowBox[{"-", "144"}], " ", "\[ImaginaryI]"}], "+", 
     RowBox[{"144", " ", 
      SqrtBox["3"]}]}], ")"}], " ", 
   SubsuperscriptBox[
    StyleBox["\[Eta]0",
     FontWeight->Bold,
     FontColor->RGBColor[0, 0.5, 0]], "3", "+"]}], "+", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     RowBox[{"-", "168"}], "+", 
     RowBox[{"24", " ", "\[ImaginaryI]", " ", 
      SqrtBox["3"]}]}], ")"}], " ", 
   SubsuperscriptBox[
    StyleBox["\[Eta]0",
     FontWeight->Bold,
     FontColor->RGBColor[0, 0.5, 0]], "4", "+"]}], "+", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     RowBox[{"-", "432"}], "-", 
     RowBox[{"144", " ", "\[ImaginaryI]", " ", 
      SqrtBox["3"]}]}], ")"}], " ", 
   SubsuperscriptBox[
    OverscriptBox[
     StyleBox["\[Eta]0",
      FontWeight->Bold,
      FontColor->RGBColor[0, 0.5, 0]], 
     StyleBox["_",
      FontWeight->Bold,
      FontColor->RGBColor[0, 0.5, 0]]], "2", "-"]}], "-", 
  RowBox[{"32", " ", "\[ImaginaryI]", " ", 
   SqrtBox["3"], " ", 
   SubsuperscriptBox[
    StyleBox["\[Eta]0",
     FontWeight->Bold,
     FontColor->RGBColor[0, 0.5, 0]], "4", "+"], " ", 
   SubsuperscriptBox[
    OverscriptBox[
     StyleBox["\[Eta]0",
      FontWeight->Bold,
      FontColor->RGBColor[0, 0.5, 0]], 
     StyleBox["_",
      FontWeight->Bold,
      FontColor->RGBColor[0, 0.5, 0]]], "2", "-"]}], "+", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     RowBox[{"144", " ", "\[ImaginaryI]"}], "+", 
     RowBox[{"144", " ", 
      SqrtBox["3"]}]}], ")"}], " ", 
   SubsuperscriptBox[
    OverscriptBox[
     StyleBox["\[Eta]0",
      FontWeight->Bold,
      FontColor->RGBColor[0, 0.5, 0]], 
     StyleBox["_",
      FontWeight->Bold,
      FontColor->RGBColor[0, 0.5, 0]]], "3", "-"]}], "+", 
  RowBox[{"32", " ", "\[ImaginaryI]", " ", 
   SubsuperscriptBox[
    StyleBox["\[Eta]0",
     FontWeight->Bold,
     FontColor->RGBColor[0, 0.5, 0]], "4", "+"], " ", 
   SubsuperscriptBox[
    OverscriptBox[
     StyleBox["\[Eta]0",
      FontWeight->Bold,
      FontColor->RGBColor[0, 0.5, 0]], 
     StyleBox["_",
      FontWeight->Bold,
      FontColor->RGBColor[0, 0.5, 0]]], "3", "-"]}], "+", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     RowBox[{"-", "168"}], "-", 
     RowBox[{"24", " ", "\[ImaginaryI]", " ", 
      SqrtBox["3"]}]}], ")"}], " ", 
   SubsuperscriptBox[
    OverscriptBox[
     StyleBox["\[Eta]0",
      FontWeight->Bold,
      FontColor->RGBColor[0, 0.5, 0]], 
     StyleBox["_",
      FontWeight->Bold,
      FontColor->RGBColor[0, 0.5, 0]]], "4", "-"]}], "+", 
  RowBox[{"32", " ", "\[ImaginaryI]", " ", 
   SqrtBox["3"], " ", 
   SubsuperscriptBox[
    StyleBox["\[Eta]0",
     FontWeight->Bold,
     FontColor->RGBColor[0, 0.5, 0]], "2", "+"], " ", 
   SubsuperscriptBox[
    OverscriptBox[
     StyleBox["\[Eta]0",
      FontWeight->Bold,
      FontColor->RGBColor[0, 0.5, 0]], 
     StyleBox["_",
      FontWeight->Bold,
      FontColor->RGBColor[0, 0.5, 0]]], "4", "-"]}], "-", 
  RowBox[{"32", " ", "\[ImaginaryI]", " ", 
   SubsuperscriptBox[
    StyleBox["\[Eta]0",
     FontWeight->Bold,
     FontColor->RGBColor[0, 0.5, 0]], "3", "+"], " ", 
   SubsuperscriptBox[
    OverscriptBox[
     StyleBox["\[Eta]0",
      FontWeight->Bold,
      FontColor->RGBColor[0, 0.5, 0]], 
     StyleBox["_",
      FontWeight->Bold,
      FontColor->RGBColor[0, 0.5, 0]]], "4", "-"]}]}]], "Output",
 CellChangeTimes->{{3.562916786871257*^9, 3.562916826430635*^9}, 
   3.562916882248887*^9, 3.562917082770938*^9, 3.562935264280622*^9, {
   3.5630247786457853`*^9, 3.563024795548933*^9}, 3.563267575882925*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"\[Rho]2term", "=", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     FractionBox["1", 
      RowBox[{"8", " ", 
       RowBox[{
        RowBox[{"\[ScriptU]$", "[", "0", "]"}], "[", "1", "]"}], 
       RowBox[{
        RowBox[{"\[ScriptU]$", "[", "0", "]"}], "[", 
        RowBox[{"-", "1"}], "]"}]}]], "/.", "subapartusu"}], ")"}], 
   RowBox[{"Collect", "[", 
    RowBox[{
     RowBox[{"tmp1", "+", "tmp2"}], ",", "canlist"}], "]"}]}]}]], "Input",
 CellChangeTimes->{{3.562916843682181*^9, 3.562916867500524*^9}, 
   3.562916899198102*^9, {3.5629169426187143`*^9, 3.5629169759532824`*^9}, {
   3.562917037339172*^9, 3.562917037991082*^9}}],

Cell[BoxData[
 RowBox[{
  FractionBox["1", "8"], " ", 
  RowBox[{"(", 
   RowBox[{
    RowBox[{"-", 
     FractionBox["\[ImaginaryI]", 
      SuperscriptBox[
       StyleBox["\[ScriptU]",
        FontColor->RGBColor[0, 0, 0.4]], "-"]]}], "+", 
    FractionBox["\[ImaginaryI]", 
     SuperscriptBox[
      StyleBox["\[ScriptU]",
       FontColor->RGBColor[0, 0, 0.4]], "+"]]}], ")"}], " ", 
  RowBox[{"(", 
   RowBox[{
    RowBox[{"-", "1080"}], "-", 
    RowBox[{"432", " ", 
     SubscriptBox[
      StyleBox["\[Zeta]",
       FontWeight->Bold,
       FontColor->GrayLevel[0.4]], "2"]}], "+", 
    FractionBox[
     RowBox[{"1152", " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2", "2"]}], "5"], "+", 
    FractionBox[
     RowBox[{"10496", " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2", "3"]}], "35"], "-", 
    RowBox[{"3312", " ", 
     SubscriptBox[
      StyleBox["\[Zeta]",
       FontWeight->Bold,
       FontColor->GrayLevel[0.4]], "3"]}], "+", 
    RowBox[{"768", " ", 
     SubsuperscriptBox[
      StyleBox["\[Zeta]",
       FontWeight->Bold,
       FontColor->GrayLevel[0.4]], "3", "2"]}], "+", 
    RowBox[{"960", " ", 
     SubscriptBox[
      StyleBox["\[Zeta]",
       FontWeight->Bold,
       FontColor->GrayLevel[0.4]], "5"]}], "+", 
    RowBox[{"288", " ", "\[ImaginaryI]", " ", 
     SqrtBox["3"], " ", 
     SubsuperscriptBox[
      StyleBox["\[Eta]0",
       FontWeight->Bold,
       FontColor->RGBColor[0, 0.5, 0]], "2", "+"]}], "-", 
    RowBox[{"288", " ", "\[ImaginaryI]", " ", 
     SubsuperscriptBox[
      StyleBox["\[Eta]0",
       FontWeight->Bold,
       FontColor->RGBColor[0, 0.5, 0]], "3", "+"]}], "+", 
    RowBox[{"48", " ", "\[ImaginaryI]", " ", 
     SqrtBox["3"], " ", 
     SubsuperscriptBox[
      StyleBox["\[Eta]0",
       FontWeight->Bold,
       FontColor->RGBColor[0, 0.5, 0]], "4", "+"]}], "-", 
    RowBox[{"288", " ", "\[ImaginaryI]", " ", 
     SqrtBox["3"], " ", 
     SubsuperscriptBox[
      OverscriptBox[
       StyleBox["\[Eta]0",
        FontWeight->Bold,
        FontColor->RGBColor[0, 0.5, 0]], 
       StyleBox["_",
        FontWeight->Bold,
        FontColor->RGBColor[0, 0.5, 0]]], "2", "-"]}], "+", 
    RowBox[{"288", " ", "\[ImaginaryI]", " ", 
     SubsuperscriptBox[
      OverscriptBox[
       StyleBox["\[Eta]0",
        FontWeight->Bold,
        FontColor->RGBColor[0, 0.5, 0]], 
       StyleBox["_",
        FontWeight->Bold,
        FontColor->RGBColor[0, 0.5, 0]]], "3", "-"]}], "-", 
    RowBox[{"48", " ", "\[ImaginaryI]", " ", 
     SqrtBox["3"], " ", 
     SubsuperscriptBox[
      OverscriptBox[
       StyleBox["\[Eta]0",
        FontWeight->Bold,
        FontColor->RGBColor[0, 0.5, 0]], 
       StyleBox["_",
        FontWeight->Bold,
        FontColor->RGBColor[0, 0.5, 0]]], "4", "-"]}]}], ")"}]}]], "Output",
 CellChangeTimes->{{3.562916849267462*^9, 3.562916899770097*^9}, 
   3.562916976503851*^9, 3.562917042822281*^9, 3.5629170828692017`*^9, 
   3.562935264362191*^9, {3.563024778721992*^9, 3.563024795639113*^9}, 
   3.5632675760493193`*^9}]
}, Open  ]],

Cell["\<\
The same below is done by just applying CCcompute (can evaluate, it takes \
some time to get answer)\
\>", "Text",
 CellChangeTimes->{{3.562916986085425*^9, 3.562917008938752*^9}, {
  3.5629170466572857`*^9, 3.562917054256885*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"Collect", "[", 
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{
          RowBox[{
           RowBox[{"(", 
            RowBox[{
             RowBox[{
              RowBox[{"Series", "[", 
               RowBox[{
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{"-", 
                   FractionBox[
                    RowBox[{"2", "w", " ", "g"}], 
                    RowBox[{"2", " ", "\[ImaginaryI]"}]]}], 
                  RowBox[{"(", 
                   RowBox[{
                    FractionBox["1", 
                    RowBox[{"u", "+", 
                    FractionBox["\[ImaginaryI]", "2"], "-", 
                    RowBox[{"2", "g", " ", "w"}]}]], "-", 
                    FractionBox["1", 
                    RowBox[{"u", "-", 
                    FractionBox["\[ImaginaryI]", "2"], "-", 
                    RowBox[{"2", "g", " ", "w"}]}]]}], ")"}], 
                  SuperscriptBox["g", "7"], 
                  RowBox[{"(", 
                   SubscriptBox["\[Delta]\[Rho]2", "lead"], ")"}]}], ")"}], 
                ",", 
                RowBox[{"{", 
                 RowBox[{"g", ",", "0", ",", "8"}], "}"}]}], "]"}], "//", 
              "Normal"}], "//", "Expand"}], ")"}], "/.", 
           RowBox[{
            SuperscriptBox["w", 
             RowBox[{"a_", "/;", 
              RowBox[{"EvenQ", "[", "a", "]"}]}]], "\[Rule]", "0"}]}], "/.", 
          RowBox[{
           RowBox[{
            SuperscriptBox["w", "a_."], 
            SubscriptBox["\[Delta]\[Rho]2", "b_"]}], "\[RuleDelayed]", 
           RowBox[{"M", "[", 
            RowBox[{
             SuperscriptBox["w", 
              RowBox[{"a", "-", "1"}]], 
             SubscriptBox["\[Delta]\[Rho]2", "b"]}], "]"}]}]}], "/.", 
         "sub\[Rho]Ansatz"}], "/.", 
        RowBox[{"(", 
         RowBox[{"Rule", "@@@", 
          RowBox[{"Cases", "[", 
           RowBox[{
            RowBox[{"solut\[Rho]s", "/.", 
             RowBox[{"Rule", "\[Rule]", "List"}]}], ",", 
            RowBox[{"List", "[", 
             RowBox[{"a_", ",", "0"}], "]"}]}], "]"}]}], ")"}]}], "//", 
       "Expand"}], ",", 
      RowBox[{"{", 
       RowBox[{"g", ",", 
        RowBox[{
         SubscriptBox["\[Beta]", "_"], "[", "_", "]"}], ",", 
        RowBox[{
         SubscriptBox["\[Alpha]", "_"], "[", "_", "]"}]}], "}"}], ",", 
      "Together"}], "]"}], "/.", 
    RowBox[{"g", "\[Rule]", "1"}]}], "//", "Simplify"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"\[Rho]2term", "=", 
   RowBox[{"%", "/.", " ", 
    RowBox[{
     RowBox[{
      RowBox[{"4", " ", 
       RowBox[{
        SubscriptBox["\[Alpha]", "lead"], "[", "0", "]"}]}], "+", 
      RowBox[{
       SubscriptBox["\[Alpha]", "lead"], "[", "1", "]"}]}], "\[Rule]", " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{
        RowBox[{"Expand", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"4", " ", 
            RowBox[{
             SubscriptBox["\[Alpha]", "lead"], "[", "0", "]"}]}], "+", 
           RowBox[{
            SubscriptBox["\[Alpha]", "lead"], "[", "1", "]"}]}], "/.", 
          "solut\[Rho]s"}], "]"}], "//.", 
        RowBox[{
         RowBox[{
          RowBox[{"a_.", " ", 
           RowBox[{"\[DoubleStruckCapitalC]", "[", "b_", "]"}]}], "+", 
          RowBox[{"d_.", " ", 
           RowBox[{"\[DoubleStruckCapitalC]", "[", "e_", "]"}]}]}], 
         "\[RuleDelayed]", 
         RowBox[{"\[DoubleStruckCapitalC]", "[", 
          RowBox[{
           RowBox[{
            RowBox[{
             RowBox[{"a", " ", "b"}], "+", 
             RowBox[{"d", " ", "e"}]}], "/.", "subQ0"}], "//", "Simplify"}], 
          "]"}]}]}], "//", "ParallelCCompute"}], ")"}]}]}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"\[Rho]2term", "=", 
   RowBox[{
    RowBox[{
     RowBox[{"Collect", "[", 
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{
          RowBox[{
           RowBox[{"Collect", "[", 
            RowBox[{
             RowBox[{"\[Rho]2term", "/.", 
              RowBox[{
               RowBox[{
                RowBox[{"\[Eta]0$b", "[", "1", "]"}], "[", 
                RowBox[{"-", "1"}], "]"}], "\[Rule]", 
               RowBox[{"per", "-", 
                RowBox[{
                 RowBox[{"\[Eta]0$", "[", "1", "]"}], "[", "1", "]"}]}]}]}], 
             ",", "per", ",", "Expand"}], "]"}], "/.", 
           RowBox[{"per", "\[Rule]", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{
               RowBox[{"\[Eta]$", "[", "1", "]"}], "[", "1", "]"}], "+", 
              RowBox[{
               RowBox[{"\[Eta]$b", "[", "1", "]"}], "[", 
               RowBox[{"-", "1"}], "]"}]}], ")"}]}]}], "/.", "subdeperiod"}], 
         "//.", "subZetaReduce"}], "/.", "sub\[Eta]\[Eta]0"}], ",", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          FractionBox["1", 
           RowBox[{"2", "+", 
            RowBox[{"8", " ", 
             SuperscriptBox["u", "2"]}]}]], ",", "\[Eta]0list"}], "}"}], "//",
         "Flatten"}]}], "]"}], "/.", " ", 
     RowBox[{
      FractionBox["1", 
       RowBox[{"2", "+", 
        RowBox[{"8", 
         SuperscriptBox["u", "2"]}]}]], "\[Rule]", 
      FractionBox["1", 
       RowBox[{"8", " ", 
        RowBox[{
         RowBox[{"\[ScriptU]$", "[", "0", "]"}], "[", "1", "]"}], 
        RowBox[{
         RowBox[{"\[ScriptU]$", "[", "0", "]"}], "[", 
         RowBox[{"-", "1"}], "]"}]}]]}]}], "/.", "subapartusu"}]}], 
  ";"}]}], "Input",
 CellChangeTimes->{{3.560683271912657*^9, 3.560683299237474*^9}, {
   3.560683821415354*^9, 3.560683844040226*^9}, {3.560684113608021*^9, 
   3.560684155772542*^9}, {3.5607066259901037`*^9, 3.560706627925758*^9}, {
   3.562238958649353*^9, 3.5622389640028667`*^9}, {3.562917025105022*^9, 
   3.562917026383175*^9}, 3.56291708983039*^9}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"\[Rho]2term", "=", 
  RowBox[{
   RowBox[{
    RowBox[{"Collect", "[", 
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{
          RowBox[{"Collect", "[", 
           RowBox[{
            RowBox[{"\[Rho]2term", "/.", 
             RowBox[{
              RowBox[{
               RowBox[{"\[Eta]0$b", "[", "1", "]"}], "[", 
               RowBox[{"-", "1"}], "]"}], "\[Rule]", 
              RowBox[{"per", "-", 
               RowBox[{
                RowBox[{"\[Eta]0$", "[", "1", "]"}], "[", "1", "]"}]}]}]}], 
            ",", "per", ",", "Expand"}], "]"}], "/.", 
          RowBox[{"per", "\[Rule]", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{
              RowBox[{"\[Eta]$", "[", "1", "]"}], "[", "1", "]"}], "+", 
             RowBox[{
              RowBox[{"\[Eta]$b", "[", "1", "]"}], "[", 
              RowBox[{"-", "1"}], "]"}]}], ")"}]}]}], "/.", "subdeperiod"}], "//.",
         "subZetaReduce"}], "/.", "sub\[Eta]\[Eta]0"}], ",", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         FractionBox["1", 
          RowBox[{"2", "+", 
           RowBox[{"8", " ", 
            SuperscriptBox["u", "2"]}]}]], ",", "\[Eta]0list"}], "}"}], "//", 
       "Flatten"}]}], "]"}], "/.", " ", 
    RowBox[{
     FractionBox["1", 
      RowBox[{"2", "+", 
       RowBox[{"8", 
        SuperscriptBox["u", "2"]}]}]], "\[Rule]", 
     FractionBox["1", 
      RowBox[{"8", " ", 
       RowBox[{
        RowBox[{"\[ScriptU]$", "[", "0", "]"}], "[", "1", "]"}], 
       RowBox[{
        RowBox[{"\[ScriptU]$", "[", "0", "]"}], "[", 
        RowBox[{"-", "1"}], "]"}]}]]}]}], "/.", "subapartusu"}]}]], "Input",
 CellChangeTimes->{{3.562240153839213*^9, 3.562240255947525*^9}, {
  3.56224034558712*^9, 3.562240363671431*^9}, {3.56224180206395*^9, 
  3.562241828464191*^9}, {3.562245638682934*^9, 3.562245654903698*^9}}],

Cell[BoxData[
 RowBox[{
  FractionBox[
   RowBox[{"135", " ", "\[ImaginaryI]"}], 
   SuperscriptBox[
    StyleBox["\[ScriptU]",
     FontColor->RGBColor[0, 0, 0.4]], "-"]], "-", 
  FractionBox[
   RowBox[{"135", " ", "\[ImaginaryI]"}], 
   SuperscriptBox[
    StyleBox["\[ScriptU]",
     FontColor->RGBColor[0, 0, 0.4]], "+"]], "+", 
  FractionBox[
   RowBox[{"54", " ", "\[ImaginaryI]", " ", 
    SubscriptBox[
     StyleBox["\[Zeta]",
      FontWeight->Bold,
      FontColor->GrayLevel[0.4]], "2"]}], 
   SuperscriptBox[
    StyleBox["\[ScriptU]",
     FontColor->RGBColor[0, 0, 0.4]], "-"]], "-", 
  FractionBox[
   RowBox[{"54", " ", "\[ImaginaryI]", " ", 
    SubscriptBox[
     StyleBox["\[Zeta]",
      FontWeight->Bold,
      FontColor->GrayLevel[0.4]], "2"]}], 
   SuperscriptBox[
    StyleBox["\[ScriptU]",
     FontColor->RGBColor[0, 0, 0.4]], "+"]], "-", 
  FractionBox[
   RowBox[{"144", " ", "\[ImaginaryI]", " ", 
    SubsuperscriptBox[
     StyleBox["\[Zeta]",
      FontWeight->Bold,
      FontColor->GrayLevel[0.4]], "2", "2"]}], 
   RowBox[{"5", " ", 
    SuperscriptBox[
     StyleBox["\[ScriptU]",
      FontColor->RGBColor[0, 0, 0.4]], "-"]}]], "+", 
  FractionBox[
   RowBox[{"144", " ", "\[ImaginaryI]", " ", 
    SubsuperscriptBox[
     StyleBox["\[Zeta]",
      FontWeight->Bold,
      FontColor->GrayLevel[0.4]], "2", "2"]}], 
   RowBox[{"5", " ", 
    SuperscriptBox[
     StyleBox["\[ScriptU]",
      FontColor->RGBColor[0, 0, 0.4]], "+"]}]], "-", 
  FractionBox[
   RowBox[{"1312", " ", "\[ImaginaryI]", " ", 
    SubsuperscriptBox[
     StyleBox["\[Zeta]",
      FontWeight->Bold,
      FontColor->GrayLevel[0.4]], "2", "3"]}], 
   RowBox[{"35", " ", 
    SuperscriptBox[
     StyleBox["\[ScriptU]",
      FontColor->RGBColor[0, 0, 0.4]], "-"]}]], "+", 
  FractionBox[
   RowBox[{"1312", " ", "\[ImaginaryI]", " ", 
    SubsuperscriptBox[
     StyleBox["\[Zeta]",
      FontWeight->Bold,
      FontColor->GrayLevel[0.4]], "2", "3"]}], 
   RowBox[{"35", " ", 
    SuperscriptBox[
     StyleBox["\[ScriptU]",
      FontColor->RGBColor[0, 0, 0.4]], "+"]}]], "+", 
  FractionBox[
   RowBox[{"414", " ", "\[ImaginaryI]", " ", 
    SubscriptBox[
     StyleBox["\[Zeta]",
      FontWeight->Bold,
      FontColor->GrayLevel[0.4]], "3"]}], 
   SuperscriptBox[
    StyleBox["\[ScriptU]",
     FontColor->RGBColor[0, 0, 0.4]], "-"]], "-", 
  FractionBox[
   RowBox[{"414", " ", "\[ImaginaryI]", " ", 
    SubscriptBox[
     StyleBox["\[Zeta]",
      FontWeight->Bold,
      FontColor->GrayLevel[0.4]], "3"]}], 
   SuperscriptBox[
    StyleBox["\[ScriptU]",
     FontColor->RGBColor[0, 0, 0.4]], "+"]], "-", 
  FractionBox[
   RowBox[{"96", " ", "\[ImaginaryI]", " ", 
    SubsuperscriptBox[
     StyleBox["\[Zeta]",
      FontWeight->Bold,
      FontColor->GrayLevel[0.4]], "3", "2"]}], 
   SuperscriptBox[
    StyleBox["\[ScriptU]",
     FontColor->RGBColor[0, 0, 0.4]], "-"]], "+", 
  FractionBox[
   RowBox[{"96", " ", "\[ImaginaryI]", " ", 
    SubsuperscriptBox[
     StyleBox["\[Zeta]",
      FontWeight->Bold,
      FontColor->GrayLevel[0.4]], "3", "2"]}], 
   SuperscriptBox[
    StyleBox["\[ScriptU]",
     FontColor->RGBColor[0, 0, 0.4]], "+"]], "-", 
  FractionBox[
   RowBox[{"120", " ", "\[ImaginaryI]", " ", 
    SubscriptBox[
     StyleBox["\[Zeta]",
      FontWeight->Bold,
      FontColor->GrayLevel[0.4]], "5"]}], 
   SuperscriptBox[
    StyleBox["\[ScriptU]",
     FontColor->RGBColor[0, 0, 0.4]], "-"]], "+", 
  FractionBox[
   RowBox[{"120", " ", "\[ImaginaryI]", " ", 
    SubscriptBox[
     StyleBox["\[Zeta]",
      FontWeight->Bold,
      FontColor->GrayLevel[0.4]], "5"]}], 
   SuperscriptBox[
    StyleBox["\[ScriptU]",
     FontColor->RGBColor[0, 0, 0.4]], "+"]], "+", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     FractionBox[
      RowBox[{"36", " ", 
       SqrtBox["3"]}], 
      SuperscriptBox[
       StyleBox["\[ScriptU]",
        FontColor->RGBColor[0, 0, 0.4]], "-"]], "-", 
     FractionBox[
      RowBox[{"36", " ", 
       SqrtBox["3"]}], 
      SuperscriptBox[
       StyleBox["\[ScriptU]",
        FontColor->RGBColor[0, 0, 0.4]], "+"]]}], ")"}], " ", 
   SubsuperscriptBox[
    StyleBox["\[Eta]0",
     FontWeight->Bold,
     FontColor->RGBColor[0, 0.5, 0]], "2", "+"]}], "+", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     RowBox[{"-", 
      FractionBox["36", 
       SuperscriptBox[
        StyleBox["\[ScriptU]",
         FontColor->RGBColor[0, 0, 0.4]], "-"]]}], "+", 
     FractionBox["36", 
      SuperscriptBox[
       StyleBox["\[ScriptU]",
        FontColor->RGBColor[0, 0, 0.4]], "+"]]}], ")"}], " ", 
   SubsuperscriptBox[
    StyleBox["\[Eta]0",
     FontWeight->Bold,
     FontColor->RGBColor[0, 0.5, 0]], "3", "+"]}], "+", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     FractionBox[
      RowBox[{"6", " ", 
       SqrtBox["3"]}], 
      SuperscriptBox[
       StyleBox["\[ScriptU]",
        FontColor->RGBColor[0, 0, 0.4]], "-"]], "-", 
     FractionBox[
      RowBox[{"6", " ", 
       SqrtBox["3"]}], 
      SuperscriptBox[
       StyleBox["\[ScriptU]",
        FontColor->RGBColor[0, 0, 0.4]], "+"]]}], ")"}], " ", 
   SubsuperscriptBox[
    StyleBox["\[Eta]0",
     FontWeight->Bold,
     FontColor->RGBColor[0, 0.5, 0]], "4", "+"]}], "+", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     RowBox[{"-", 
      FractionBox[
       RowBox[{"36", " ", 
        SqrtBox["3"]}], 
       SuperscriptBox[
        StyleBox["\[ScriptU]",
         FontColor->RGBColor[0, 0, 0.4]], "-"]]}], "+", 
     FractionBox[
      RowBox[{"36", " ", 
       SqrtBox["3"]}], 
      SuperscriptBox[
       StyleBox["\[ScriptU]",
        FontColor->RGBColor[0, 0, 0.4]], "+"]]}], ")"}], " ", 
   SubsuperscriptBox[
    OverscriptBox[
     StyleBox["\[Eta]0",
      FontWeight->Bold,
      FontColor->RGBColor[0, 0.5, 0]], 
     StyleBox["_",
      FontWeight->Bold,
      FontColor->RGBColor[0, 0.5, 0]]], "2", "-"]}], "+", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     FractionBox["36", 
      SuperscriptBox[
       StyleBox["\[ScriptU]",
        FontColor->RGBColor[0, 0, 0.4]], "-"]], "-", 
     FractionBox["36", 
      SuperscriptBox[
       StyleBox["\[ScriptU]",
        FontColor->RGBColor[0, 0, 0.4]], "+"]]}], ")"}], " ", 
   SubsuperscriptBox[
    OverscriptBox[
     StyleBox["\[Eta]0",
      FontWeight->Bold,
      FontColor->RGBColor[0, 0.5, 0]], 
     StyleBox["_",
      FontWeight->Bold,
      FontColor->RGBColor[0, 0.5, 0]]], "3", "-"]}], "+", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     RowBox[{"-", 
      FractionBox[
       RowBox[{"6", " ", 
        SqrtBox["3"]}], 
       SuperscriptBox[
        StyleBox["\[ScriptU]",
         FontColor->RGBColor[0, 0, 0.4]], "-"]]}], "+", 
     FractionBox[
      RowBox[{"6", " ", 
       SqrtBox["3"]}], 
      SuperscriptBox[
       StyleBox["\[ScriptU]",
        FontColor->RGBColor[0, 0, 0.4]], "+"]]}], ")"}], " ", 
   SubsuperscriptBox[
    OverscriptBox[
     StyleBox["\[Eta]0",
      FontWeight->Bold,
      FontColor->RGBColor[0, 0.5, 0]], 
     StyleBox["_",
      FontWeight->Bold,
      FontColor->RGBColor[0, 0.5, 0]]], "4", "-"]}]}]], "Output",
 CellChangeTimes->{{3.562240335519855*^9, 3.562240364637472*^9}, 
   3.5622418331953907`*^9, {3.5622456394058123`*^9, 3.562245644643004*^9}, 
   3.5622456848266783`*^9, 3.562311103161456*^9, 3.5623113608787193`*^9, 
   3.563267611940379*^9}]
}, Open  ]],

Cell["\<\
Now we pass to computing W term.\
\>", "Text",
 CellChangeTimes->{{3.562917099456135*^9, 3.5629171136862392`*^9}}],

Cell["I will do it again by hands", "Text",
 CellChangeTimes->{{3.562917130205371*^9, 3.562917134669344*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"Collect", "[", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{"Collect", "[", 
         RowBox[{
          RowBox[{"Series", "[", 
           RowBox[{
            RowBox[{
             RowBox[{
              RowBox[{
               RowBox[{
                RowBox[{"W", "/.", "subWq"}], "/.", "subq34"}], "/.", 
               "substandardq"}], "/.", 
              RowBox[{"{", 
               RowBox[{
                RowBox[{
                 OverscriptBox["\[Alpha]", "_"], "\[Rule]", "0"}], ",", 
                RowBox[{"\[Alpha]", "\[Rule]", "0"}]}], "}"}]}], "/.", 
             RowBox[{"leadweak", "[", "1", "]"}]}], ",", 
            RowBox[{"{", 
             RowBox[{"g", ",", "0", ",", "8"}], "}"}]}], "]"}], ",", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"g", ",", "\[Eta]list", ",", "Q0list"}], "}"}], "//", 
           "Flatten"}]}], "]"}], "/.", 
        RowBox[{"g", "\[Rule]", "1"}]}], "/.", "subtousu"}], "//", 
      "funapartusu"}], "//", "funreduceusu"}], ",", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"\[Eta]list", ",", 
       RowBox[{
        RowBox[{"\[ScriptU]$", "[", "_", "]"}], "[", "_", "]"}]}], "}"}], "//",
      "Flatten"}]}], "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"UpIntegrate", "[", 
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{
          RowBox[{
           RowBox[{"(", 
            RowBox[{"-", 
             FractionBox["1", 
              RowBox[{"2", "\[Pi]", " ", "\[ImaginaryI]"}]]}], ")"}], 
           RowBox[{"symfun", "[", 
            RowBox[{"(", 
             RowBox[{
              FractionBox["1", 
               RowBox[{"v", "-", "u", "+", 
                FractionBox["\[ImaginaryI]", "2"]}]], "-", 
              FractionBox["1", 
               RowBox[{"v", "-", "u", "-", 
                FractionBox["\[ImaginaryI]", "2"]}]]}], ")"}], "]"}], 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"-", "%"}], "/.", "subusu"}], ")"}]}], "/.", 
          RowBox[{"v", "\[Rule]", 
           RowBox[{"Re", "[", "v", "]"}]}]}], "/.", 
         RowBox[{"u", "\[Rule]", 
          RowBox[{"u", "-", 
           RowBox[{"\[ImaginaryI]", " ", "\[Epsilon]"}]}]}]}], "/.", 
        RowBox[{"Shift", "[", 
         RowBox[{"-", "\[Epsilon]"}], "]"}]}], ",", "u"}], "]"}], "/.", 
     RowBox[{
      RowBox[{"Re", "[", "v", "]"}], "\[Rule]", "u"}]}], "/.", 
    "EndSimplify"}], "//", "fundeperiod"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Wterm", "=", 
   RowBox[{"%", "+", 
    RowBox[{"Collect", "[", 
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{
          SubscriptBox["W", "1"], "/.", 
          RowBox[{"leadweak", "[", "1", "]"}]}], "/.", 
         RowBox[{"g", "\[Rule]", "1"}]}], "/.", 
        RowBox[{"shiftm\[Eta]", "[", "3", "]"}]}], "/.", 
       RowBox[{"shiftp\[Eta]b", "[", 
        RowBox[{"-", "3"}], "]"}]}], ",", "\[Eta]list", ",", "Simplify"}], 
     "]"}]}]}], ";"}]}], "Input",
 CellChangeTimes->{{3.562917146651394*^9, 3.562917231477364*^9}, {
   3.5629172713199053`*^9, 3.562917319202753*^9}, 3.562920108864903*^9}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Wfinal", "=", 
  RowBox[{"Collect", "[", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         RowBox[{"Collect", "[", 
          RowBox[{
           RowBox[{
            RowBox[{
             RowBox[{"Collect", "[", 
              RowBox[{"Wterm", ",", "\[Eta]list", ",", 
               RowBox[{
                RowBox[{
                 RowBox[{
                  FractionBox[
                   RowBox[{"Numerator", "[", "#", "]"}], 
                   RowBox[{"Factor", "[", 
                    RowBox[{
                    RowBox[{"Denominator", "[", "#", "]"}], ",", 
                    RowBox[{"Extension", "\[Rule]", 
                    RowBox[{"\[ImaginaryI]", "+", 
                    SqrtBox["3"]}]}]}], "]"}]], "&"}], "/@", "#"}], "&"}]}], 
              "]"}], "/.", 
             RowBox[{
              SuperscriptBox[
               RowBox[{"(", 
                RowBox[{
                 RowBox[{"aa_", " ", "u"}], "+", "bb_."}], ")"}], 
               RowBox[{"a_", "/;", 
                RowBox[{"a", "<", "0"}]}]], "\[RuleDelayed]", 
              RowBox[{
               SuperscriptBox["aa", "a"], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{"u", "+", 
                  FractionBox["bb", "aa"]}], ")"}], "a"]}]}]}], "/.", 
            "subtousu"}], ",", "\[Eta]list", ",", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{"#", "//", "funapartusu"}], "//", "funreduceusu"}], 
             ")"}], "&"}]}], "]"}], "/.", "sub\[Eta]\[Eta]0"}], "//", 
        "fundeperiod"}], ")"}], "/.", "sub\[Eta]0\[Eta]"}], "//", 
     "FuntoMHZbasis"}], ",", "canlist"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.562917351383687*^9, 3.562917362380953*^9}, {
  3.562917610618855*^9, 3.56291764035511*^9}, {3.562917700625969*^9, 
  3.562917788492488*^9}, {3.562917824328024*^9, 3.562917847264904*^9}, {
  3.5629178909185038`*^9, 3.562917895422225*^9}, {3.562920111486669*^9, 
  3.5629201213316307`*^9}, {3.562920305736793*^9, 3.562920348522355*^9}, {
  3.562920439763135*^9, 3.562920440232408*^9}, {3.562920676341381*^9, 
  3.562920676898135*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"1296", " ", 
   SubscriptBox[
    StyleBox["\[Zeta]",
     FontWeight->Bold,
     FontColor->GrayLevel[0.4]], "3"]}], "+", 
  FractionBox[
   RowBox[{
    RowBox[{"108", " ", "\[ImaginaryI]"}], "+", 
    RowBox[{"54", " ", "\[ImaginaryI]", " ", 
     SubscriptBox[
      StyleBox["\[Zeta]",
       FontWeight->Bold,
       FontColor->GrayLevel[0.4]], "2"]}], "-", 
    FractionBox[
     RowBox[{"144", " ", "\[ImaginaryI]", " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2", "2"]}], "5"], "-", 
    FractionBox[
     RowBox[{"1312", " ", "\[ImaginaryI]", " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2", "3"]}], "35"], "+", 
    RowBox[{"18", " ", "\[ImaginaryI]", " ", 
     SubscriptBox[
      StyleBox["\[Zeta]",
       FontWeight->Bold,
       FontColor->GrayLevel[0.4]], "3"]}], "-", 
    RowBox[{"96", " ", "\[ImaginaryI]", " ", 
     SubsuperscriptBox[
      StyleBox["\[Zeta]",
       FontWeight->Bold,
       FontColor->GrayLevel[0.4]], "3", "2"]}]}], 
   SuperscriptBox[
    StyleBox["\[ScriptU]",
     FontColor->RGBColor[0, 0, 0.4]], "+"]], "+", 
  FractionBox[
   RowBox[{
    RowBox[{
     RowBox[{"-", "108"}], " ", "\[ImaginaryI]"}], "-", 
    RowBox[{"54", " ", "\[ImaginaryI]", " ", 
     SubscriptBox[
      StyleBox["\[Zeta]",
       FontWeight->Bold,
       FontColor->GrayLevel[0.4]], "2"]}], "+", 
    FractionBox[
     RowBox[{"144", " ", "\[ImaginaryI]", " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2", "2"]}], "5"], "+", 
    FractionBox[
     RowBox[{"1312", " ", "\[ImaginaryI]", " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2", "3"]}], "35"], "-", 
    RowBox[{"18", " ", "\[ImaginaryI]", " ", 
     SubscriptBox[
      StyleBox["\[Zeta]",
       FontWeight->Bold,
       FontColor->GrayLevel[0.4]], "3"]}], "+", 
    RowBox[{"96", " ", "\[ImaginaryI]", " ", 
     SubsuperscriptBox[
      StyleBox["\[Zeta]",
       FontWeight->Bold,
       FontColor->GrayLevel[0.4]], "3", "2"]}]}], 
   SuperscriptBox[
    StyleBox["\[ScriptU]",
     FontColor->RGBColor[0, 0, 0.4]], "-"]], "+", 
  FractionBox[
   RowBox[{
    RowBox[{"-", "27"}], "+", 
    RowBox[{"36", " ", 
     SubscriptBox[
      StyleBox["\[Zeta]",
       FontWeight->Bold,
       FontColor->GrayLevel[0.4]], "3"]}], "+", 
    RowBox[{"120", " ", 
     SubscriptBox[
      StyleBox["\[Zeta]",
       FontWeight->Bold,
       FontColor->GrayLevel[0.4]], "5"]}]}], 
   SuperscriptBox[
    RowBox[{"(", 
     SuperscriptBox[
      StyleBox["\[ScriptU]",
       FontColor->RGBColor[0, 0, 0.4]], "-"], ")"}], "2"]], "+", 
  FractionBox[
   RowBox[{
    RowBox[{"-", "27"}], "+", 
    RowBox[{"36", " ", 
     SubscriptBox[
      StyleBox["\[Zeta]",
       FontWeight->Bold,
       FontColor->GrayLevel[0.4]], "3"]}], "+", 
    RowBox[{"120", " ", 
     SubscriptBox[
      StyleBox["\[Zeta]",
       FontWeight->Bold,
       FontColor->GrayLevel[0.4]], "5"]}]}], 
   SuperscriptBox[
    RowBox[{"(", 
     SuperscriptBox[
      StyleBox["\[ScriptU]",
       FontColor->RGBColor[0, 0, 0.4]], "+"], ")"}], "2"]], "+", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     RowBox[{"-", 
      FractionBox[
       RowBox[{"90", " ", "\[ImaginaryI]"}], 
       SuperscriptBox[
        StyleBox["\[ScriptU]",
         FontColor->RGBColor[0, 0, 0.4]], "-"]]}], "-", 
     FractionBox[
      RowBox[{"72", " ", "\[ImaginaryI]"}], 
      SuperscriptBox[
       StyleBox["\[ScriptU]",
        FontColor->RGBColor[0, 0, 0.4]], "+"]], "+", 
     FractionBox[
      RowBox[{"18", "-", 
       RowBox[{"72", " ", 
        SubscriptBox[
         StyleBox["\[Zeta]",
          FontWeight->Bold,
          FontColor->GrayLevel[0.4]], "3"]}]}], 
      SuperscriptBox[
       RowBox[{"(", 
        SuperscriptBox[
         StyleBox["\[ScriptU]",
          FontColor->RGBColor[0, 0, 0.4]], "+"], ")"}], "2"]], "-", 
     RowBox[{"1296", " ", "\[ImaginaryI]", " ", "u", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3"]}], "+", 
     FractionBox[
      RowBox[{"72", " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "3"]}], 
      SuperscriptBox[
       RowBox[{"(", 
        SuperscriptBox[
         StyleBox["\[ScriptU]",
          FontColor->RGBColor[0, 0, 0.4]], "-"], ")"}], "2"]]}], ")"}], " ", 
   SubsuperscriptBox[
    StyleBox["\[Eta]",
     FontWeight->Bold,
     FontColor->RGBColor[0.8, 0, 0]], "2", "+"]}], "+", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     RowBox[{"108", " ", "\[ImaginaryI]"}], "+", 
     FractionBox[
      RowBox[{"18", " ", "\[ImaginaryI]"}], 
      SuperscriptBox[
       RowBox[{"(", 
        SuperscriptBox[
         StyleBox["\[ScriptU]",
          FontColor->RGBColor[0, 0, 0.4]], "+"], ")"}], "2"]], "+", 
     FractionBox[
      RowBox[{
       RowBox[{"-", "18"}], "-", 
       RowBox[{"48", " ", 
        SubscriptBox[
         StyleBox["\[Zeta]",
          FontWeight->Bold,
          FontColor->GrayLevel[0.4]], "3"]}]}], 
      SuperscriptBox[
       StyleBox["\[ScriptU]",
        FontColor->RGBColor[0, 0, 0.4]], "-"]], "+", 
     RowBox[{"144", " ", "\[ImaginaryI]", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3"]}], "+", 
     FractionBox[
      RowBox[{
       RowBox[{"-", "36"}], "+", 
       RowBox[{"48", " ", 
        SubscriptBox[
         StyleBox["\[Zeta]",
          FontWeight->Bold,
          FontColor->GrayLevel[0.4]], "3"]}]}], 
      SuperscriptBox[
       StyleBox["\[ScriptU]",
        FontColor->RGBColor[0, 0, 0.4]], "+"]]}], ")"}], " ", 
   SubsuperscriptBox[
    StyleBox["\[Eta]",
     FontWeight->Bold,
     FontColor->RGBColor[0.8, 0, 0]], "3", "+"]}], "+", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     RowBox[{"-", 
      FractionBox[
       RowBox[{"18", " ", "\[ImaginaryI]"}], 
       SuperscriptBox[
        StyleBox["\[ScriptU]",
         FontColor->RGBColor[0, 0, 0.4]], "-"]]}], "-", 
     FractionBox[
      RowBox[{"18", " ", "\[ImaginaryI]"}], 
      SuperscriptBox[
       StyleBox["\[ScriptU]",
        FontColor->RGBColor[0, 0, 0.4]], "+"]]}], ")"}], " ", 
   SubsuperscriptBox[
    StyleBox["\[Eta]",
     FontWeight->Bold,
     FontColor->RGBColor[0.8, 0, 0]], "4", "+"]}], "+", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     RowBox[{"216", " ", "u"}], "+", 
     FractionBox[
      RowBox[{"12", " ", "\[ImaginaryI]"}], 
      SuperscriptBox[
       RowBox[{"(", 
        SuperscriptBox[
         StyleBox["\[ScriptU]",
          FontColor->RGBColor[0, 0, 0.4]], "-"], ")"}], "2"]], "-", 
     FractionBox[
      RowBox[{"12", " ", "\[ImaginaryI]"}], 
      SuperscriptBox[
       RowBox[{"(", 
        SuperscriptBox[
         StyleBox["\[ScriptU]",
          FontColor->RGBColor[0, 0, 0.4]], "+"], ")"}], "2"]]}], ")"}], " ", 
   SubsuperscriptBox[
    StyleBox["\[Eta]",
     FontWeight->Bold,
     FontColor->RGBColor[0.8, 0, 0]], 
    RowBox[{"2", ",", "3"}], "+"]}], "+", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     RowBox[{"-", "36"}], "-", 
     FractionBox[
      RowBox[{"12", " ", "\[ImaginaryI]"}], 
      SuperscriptBox[
       StyleBox["\[ScriptU]",
        FontColor->RGBColor[0, 0, 0.4]], "-"]], "+", 
     FractionBox[
      RowBox[{"12", " ", "\[ImaginaryI]"}], 
      SuperscriptBox[
       StyleBox["\[ScriptU]",
        FontColor->RGBColor[0, 0, 0.4]], "+"]]}], ")"}], " ", 
   SubsuperscriptBox[
    StyleBox["\[Eta]",
     FontWeight->Bold,
     FontColor->RGBColor[0.8, 0, 0]], 
    RowBox[{"2", ",", "4"}], "+"]}], "+", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     RowBox[{
      RowBox[{"-", "216"}], " ", "u"}], "-", 
     FractionBox[
      RowBox[{"12", " ", "\[ImaginaryI]"}], 
      SuperscriptBox[
       RowBox[{"(", 
        SuperscriptBox[
         StyleBox["\[ScriptU]",
          FontColor->RGBColor[0, 0, 0.4]], "-"], ")"}], "2"]], "+", 
     FractionBox[
      RowBox[{"12", " ", "\[ImaginaryI]"}], 
      SuperscriptBox[
       RowBox[{"(", 
        SuperscriptBox[
         StyleBox["\[ScriptU]",
          FontColor->RGBColor[0, 0, 0.4]], "+"], ")"}], "2"]]}], ")"}], " ", 
   SubsuperscriptBox[
    StyleBox["\[Eta]",
     FontWeight->Bold,
     FontColor->RGBColor[0.8, 0, 0]], 
    RowBox[{"3", ",", "2"}], "+"]}], "+", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{"36", "+", 
     FractionBox[
      RowBox[{"12", " ", "\[ImaginaryI]"}], 
      SuperscriptBox[
       StyleBox["\[ScriptU]",
        FontColor->RGBColor[0, 0, 0.4]], "-"]], "-", 
     FractionBox[
      RowBox[{"12", " ", "\[ImaginaryI]"}], 
      SuperscriptBox[
       StyleBox["\[ScriptU]",
        FontColor->RGBColor[0, 0, 0.4]], "+"]]}], ")"}], " ", 
   SubsuperscriptBox[
    StyleBox["\[Eta]",
     FontWeight->Bold,
     FontColor->RGBColor[0.8, 0, 0]], 
    RowBox[{"4", ",", "2"}], "+"]}], "+", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     FractionBox["18", 
      SuperscriptBox[
       RowBox[{"(", 
        SuperscriptBox[
         StyleBox["\[ScriptU]",
          FontColor->RGBColor[0, 0, 0.4]], "-"], ")"}], "2"]], "+", 
     FractionBox[
      RowBox[{"72", " ", "\[ImaginaryI]"}], 
      SuperscriptBox[
       StyleBox["\[ScriptU]",
        FontColor->RGBColor[0, 0, 0.4]], "-"]], "+", 
     FractionBox[
      RowBox[{"90", " ", "\[ImaginaryI]"}], 
      SuperscriptBox[
       StyleBox["\[ScriptU]",
        FontColor->RGBColor[0, 0, 0.4]], "+"]]}], ")"}], " ", 
   SubsuperscriptBox[
    OverscriptBox[
     StyleBox["\[Eta]",
      FontWeight->Bold,
      FontColor->RGBColor[0.8, 0, 0]], 
     StyleBox["_",
      FontWeight->Bold,
      FontColor->RGBColor[0.8, 0, 0]]], "2", "-"]}], "+", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{"108", "+", 
     FractionBox[
      RowBox[{"36", " ", "\[ImaginaryI]"}], 
      SuperscriptBox[
       StyleBox["\[ScriptU]",
        FontColor->RGBColor[0, 0, 0.4]], "-"]], "-", 
     FractionBox[
      RowBox[{"36", " ", "\[ImaginaryI]"}], 
      SuperscriptBox[
       StyleBox["\[ScriptU]",
        FontColor->RGBColor[0, 0, 0.4]], "+"]]}], ")"}], " ", 
   SubsuperscriptBox[
    StyleBox["\[Eta]",
     FontWeight->Bold,
     FontColor->RGBColor[0.8, 0, 0]], "2", "+"], " ", 
   SubsuperscriptBox[
    OverscriptBox[
     StyleBox["\[Eta]",
      FontWeight->Bold,
      FontColor->RGBColor[0.8, 0, 0]], 
     StyleBox["_",
      FontWeight->Bold,
      FontColor->RGBColor[0.8, 0, 0]]], "2", "-"]}], "+", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     RowBox[{
      RowBox[{"-", "54"}], " ", "\[ImaginaryI]"}], "+", 
     RowBox[{"108", " ", "u"}], "+", 
     FractionBox[
      RowBox[{"12", " ", "\[ImaginaryI]"}], 
      SuperscriptBox[
       RowBox[{"(", 
        SuperscriptBox[
         StyleBox["\[ScriptU]",
          FontColor->RGBColor[0, 0, 0.4]], "-"], ")"}], "2"]], "+", 
     FractionBox["24", 
      SuperscriptBox[
       StyleBox["\[ScriptU]",
        FontColor->RGBColor[0, 0, 0.4]], "-"]], "-", 
     FractionBox["24", 
      SuperscriptBox[
       StyleBox["\[ScriptU]",
        FontColor->RGBColor[0, 0, 0.4]], "+"]]}], ")"}], " ", 
   SubsuperscriptBox[
    StyleBox["\[Eta]",
     FontWeight->Bold,
     FontColor->RGBColor[0.8, 0, 0]], "3", "+"], " ", 
   SubsuperscriptBox[
    OverscriptBox[
     StyleBox["\[Eta]",
      FontWeight->Bold,
      FontColor->RGBColor[0.8, 0, 0]], 
     StyleBox["_",
      FontWeight->Bold,
      FontColor->RGBColor[0.8, 0, 0]]], "2", "-"]}], "+", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     RowBox[{
      RowBox[{"-", "108"}], " ", "\[ImaginaryI]"}], "-", 
     FractionBox[
      RowBox[{"18", " ", "\[ImaginaryI]"}], 
      SuperscriptBox[
       RowBox[{"(", 
        SuperscriptBox[
         StyleBox["\[ScriptU]",
          FontColor->RGBColor[0, 0, 0.4]], "-"], ")"}], "2"]], "-", 
     FractionBox["36", 
      SuperscriptBox[
       StyleBox["\[ScriptU]",
        FontColor->RGBColor[0, 0, 0.4]], "-"]], "-", 
     FractionBox["18", 
      SuperscriptBox[
       StyleBox["\[ScriptU]",
        FontColor->RGBColor[0, 0, 0.4]], "+"]]}], ")"}], " ", 
   SubsuperscriptBox[
    OverscriptBox[
     StyleBox["\[Eta]",
      FontWeight->Bold,
      FontColor->RGBColor[0.8, 0, 0]], 
     StyleBox["_",
      FontWeight->Bold,
      FontColor->RGBColor[0.8, 0, 0]]], "3", "-"]}], "+", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     RowBox[{"54", " ", "\[ImaginaryI]"}], "-", 
     RowBox[{"108", " ", "u"}], "-", 
     FractionBox[
      RowBox[{"12", " ", "\[ImaginaryI]"}], 
      SuperscriptBox[
       RowBox[{"(", 
        SuperscriptBox[
         StyleBox["\[ScriptU]",
          FontColor->RGBColor[0, 0, 0.4]], "-"], ")"}], "2"]], "-", 
     FractionBox["24", 
      SuperscriptBox[
       StyleBox["\[ScriptU]",
        FontColor->RGBColor[0, 0, 0.4]], "-"]], "+", 
     FractionBox["24", 
      SuperscriptBox[
       StyleBox["\[ScriptU]",
        FontColor->RGBColor[0, 0, 0.4]], "+"]]}], ")"}], " ", 
   SubsuperscriptBox[
    StyleBox["\[Eta]",
     FontWeight->Bold,
     FontColor->RGBColor[0.8, 0, 0]], "2", "+"], " ", 
   SubsuperscriptBox[
    OverscriptBox[
     StyleBox["\[Eta]",
      FontWeight->Bold,
      FontColor->RGBColor[0.8, 0, 0]], 
     StyleBox["_",
      FontWeight->Bold,
      FontColor->RGBColor[0.8, 0, 0]]], "3", "-"]}], "+", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     RowBox[{"-", "36"}], "-", 
     FractionBox[
      RowBox[{"12", " ", "\[ImaginaryI]"}], 
      SuperscriptBox[
       StyleBox["\[ScriptU]",
        FontColor->RGBColor[0, 0, 0.4]], "-"]], "+", 
     FractionBox[
      RowBox[{"12", " ", "\[ImaginaryI]"}], 
      SuperscriptBox[
       StyleBox["\[ScriptU]",
        FontColor->RGBColor[0, 0, 0.4]], "+"]]}], ")"}], " ", 
   SubsuperscriptBox[
    StyleBox["\[Eta]",
     FontWeight->Bold,
     FontColor->RGBColor[0.8, 0, 0]], "3", "+"], " ", 
   SubsuperscriptBox[
    OverscriptBox[
     StyleBox["\[Eta]",
      FontWeight->Bold,
      FontColor->RGBColor[0.8, 0, 0]], 
     StyleBox["_",
      FontWeight->Bold,
      FontColor->RGBColor[0.8, 0, 0]]], "3", "-"]}], "+", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     FractionBox[
      RowBox[{"18", " ", "\[ImaginaryI]"}], 
      SuperscriptBox[
       StyleBox["\[ScriptU]",
        FontColor->RGBColor[0, 0, 0.4]], "-"]], "+", 
     FractionBox[
      RowBox[{"18", " ", "\[ImaginaryI]"}], 
      SuperscriptBox[
       StyleBox["\[ScriptU]",
        FontColor->RGBColor[0, 0, 0.4]], "+"]]}], ")"}], " ", 
   SubsuperscriptBox[
    OverscriptBox[
     StyleBox["\[Eta]",
      FontWeight->Bold,
      FontColor->RGBColor[0.8, 0, 0]], 
     StyleBox["_",
      FontWeight->Bold,
      FontColor->RGBColor[0.8, 0, 0]]], "4", "-"]}], "+", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{"36", "+", 
     FractionBox[
      RowBox[{"12", " ", "\[ImaginaryI]"}], 
      SuperscriptBox[
       StyleBox["\[ScriptU]",
        FontColor->RGBColor[0, 0, 0.4]], "-"]], "-", 
     FractionBox[
      RowBox[{"12", " ", "\[ImaginaryI]"}], 
      SuperscriptBox[
       StyleBox["\[ScriptU]",
        FontColor->RGBColor[0, 0, 0.4]], "+"]]}], ")"}], " ", 
   SubsuperscriptBox[
    StyleBox["\[Eta]",
     FontWeight->Bold,
     FontColor->RGBColor[0.8, 0, 0]], "2", "+"], " ", 
   SubsuperscriptBox[
    OverscriptBox[
     StyleBox["\[Eta]",
      FontWeight->Bold,
      FontColor->RGBColor[0.8, 0, 0]], 
     StyleBox["_",
      FontWeight->Bold,
      FontColor->RGBColor[0.8, 0, 0]]], "4", "-"]}]}]], "Output",
 CellChangeTimes->{{3.56291771467023*^9, 3.562917727502192*^9}, {
   3.5629177848944893`*^9, 3.562917793731745*^9}, 3.5629178528005447`*^9, 
   3.562917900868053*^9, {3.5629201167871532`*^9, 3.562920126466152*^9}, 
   3.562920161456265*^9, {3.5629203357414722`*^9, 3.562920349913971*^9}, 
   3.562920441314303*^9, 3.562920677684986*^9, 3.562935298854682*^9, 
   3.563024821642379*^9, 3.563267639019857*^9}]
}, Open  ]],

Cell["Here is another way to compute the sam thing", "Text",
 CellChangeTimes->{{3.562920429895876*^9, 3.562920437013989*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Wterm", "=", 
   RowBox[{"UpIntegrate", "[", 
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{"(", 
          RowBox[{"-", 
           FractionBox["1", 
            RowBox[{"2", "\[Pi]", " ", "\[ImaginaryI]"}]]}], ")"}], 
         RowBox[{"symfun", "[", 
          RowBox[{"(", 
           RowBox[{
            FractionBox["1", 
             RowBox[{"v", "-", "u", "+", 
              FractionBox["\[ImaginaryI]", "2"]}]], "-", 
            FractionBox["1", 
             RowBox[{"v", "-", "u", "-", 
              FractionBox["\[ImaginaryI]", "2"]}]]}], ")"}], "]"}], 
         RowBox[{"(", 
          RowBox[{
           RowBox[{
            RowBox[{"-", "W"}], "/.", 
            RowBox[{"leadweak", "[", "1", "]"}]}], "/.", 
           RowBox[{"g", "\[Rule]", "1"}]}], ")"}]}], "/.", 
        RowBox[{"v", "\[Rule]", 
         RowBox[{"Re", "[", "v", "]"}]}]}], "/.", 
       RowBox[{"u", "\[Rule]", 
        RowBox[{"u", "+", 
         RowBox[{"\[ImaginaryI]", " ", "\[Epsilon]"}]}]}]}], "/.", 
      RowBox[{"Shift", "[", 
       RowBox[{"+", "\[Epsilon]"}], "]"}]}], ",", "u"}], "]"}]}], 
  ";"}]], "Input",
 CellChangeTimes->{{3.560684473908403*^9, 3.5606846463746357`*^9}, {
  3.5606862253259153`*^9, 3.5606862285169563`*^9}, {3.5606862785008917`*^9, 
  3.560686283298913*^9}, {3.561058939905725*^9, 3.561058943064164*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Wterm2", "=", 
   RowBox[{
    RowBox[{"Wterm", "/.", 
     RowBox[{
      RowBox[{"Re", "[", "v", "]"}], "\[Rule]", "u"}]}], "/.", 
    "EndSimplify"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.56068465691813*^9, 3.560684698677639*^9}, {
   3.560684738478183*^9, 3.560684740607676*^9}, 3.560686311716695*^9, {
   3.561058892127194*^9, 3.561058902131019*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Wtermcomplete", "=", 
   RowBox[{"Wterm2", "+", 
    RowBox[{"Collect", "[", 
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{
          SubscriptBox["W", "1"], "/.", 
          RowBox[{"leadweak", "[", "1", "]"}]}], "/.", 
         RowBox[{"g", "\[Rule]", "1"}]}], "/.", 
        RowBox[{"shiftm\[Eta]", "[", "3", "]"}]}], "/.", 
       RowBox[{"shiftp\[Eta]b", "[", 
        RowBox[{"-", "3"}], "]"}]}], ",", "\[Eta]list", ",", "Simplify"}], 
     "]"}]}]}], ";"}]], "Input",
 CellChangeTimes->{{3.560685662060583*^9, 3.5606857242212887`*^9}}],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{"Collect", "[", 
        RowBox[{
         RowBox[{"Wtermcomplete", "/.", 
          RowBox[{
           RowBox[{
            RowBox[{"\[Eta]$b", "[", "1", "]"}], "[", 
            RowBox[{"-", "1"}], "]"}], "\[RuleDelayed]", 
           RowBox[{"(", 
            RowBox[{"per", "-", 
             RowBox[{
              RowBox[{"\[Eta]$", "[", "1", "]"}], "[", "1", "]"}]}], 
            ")"}]}]}], ",", "per", ",", "Expand"}], "]"}], "/.", 
       RowBox[{"per", "\[Rule]", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{
           RowBox[{"\[Eta]$", "[", "1", "]"}], "[", "1", "]"}], "+", 
          RowBox[{
           RowBox[{"\[Eta]$b", "[", "1", "]"}], "[", 
           RowBox[{"-", "1"}], "]"}]}], ")"}]}]}], "/.", "subdeperiod"}], "//.",
      "subZetaReduce"}], "//", "Expand"}], "//", "FuntoMHZbasis"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"ExpaCol", "[", 
   RowBox[{"%", ",", "\[Eta]patt", ",", "Simplify"}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"ExpaCol", "[", 
    RowBox[{"%", ",", 
     RowBox[{"Flatten", "[", 
      RowBox[{"Alternatives", "[", 
       RowBox[{
        FractionBox["1", 
         RowBox[{"1", "+", 
          RowBox[{"4", " ", 
           SuperscriptBox["u", "2"]}]}]], ",", "\[Eta]patt"}], "]"}], "]"}], 
     ",", "Factor"}], "]"}], "/.", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{
      RowBox[{"-", "1"}], "+", 
      RowBox[{"12", " ", 
       SuperscriptBox["u", "2"]}]}], "\[Rule]", 
     RowBox[{"12", " ", "Q0"}]}], "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Collect", "[", 
   RowBox[{"%", ",", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       StyleBox["Q0",
        FontColor->RGBColor[{
           Rational[1, 2], 
           Rational[1, 2], 0}]], 
       StyleBox[",",
        FontColor->RGBColor[{
           Rational[1, 2], 
           Rational[1, 2], 0}]], 
       RowBox[{"1", "+", 
        RowBox[{"4", " ", 
         SuperscriptBox["u", "2"]}]}], ",", "\[Eta]list", ",", 
       "\[Zeta]list"}], "}"}], "//", "Flatten"}], ",", "Simplify"}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"ExpaCol", "[", 
    RowBox[{"%", ",", 
     RowBox[{"Flatten", "[", 
      RowBox[{"Q0", "|", "\[Eta]patt"}], "]"}], ",", 
     RowBox[{
      RowBox[{"Apart", "[", 
       RowBox[{
        RowBox[{"Factor", "[", 
         RowBox[{"#", ",", 
          RowBox[{"Extension", "\[Rule]", "\[ImaginaryI]"}]}], "]"}], ",", 
        "u"}], "]"}], "&"}]}], "]"}], "/.", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{
      SuperscriptBox[
       RowBox[{"(", 
        RowBox[{
         RowBox[{"2", "u"}], "-", "\[ImaginaryI]"}], ")"}], 
       RowBox[{"a_", "/;", 
        RowBox[{"a", "<", "0"}]}]], ":>", 
      RowBox[{
       SuperscriptBox["2", "a"], 
       SuperscriptBox[
        RowBox[{
         RowBox[{"\[ScriptU]$", "[", "0", "]"}], "[", 
         RowBox[{"-", "1"}], "]"}], "a"]}]}], ",", 
     RowBox[{
      SuperscriptBox[
       RowBox[{"(", 
        RowBox[{
         RowBox[{"2", "u"}], "+", "\[ImaginaryI]"}], ")"}], 
       RowBox[{"a_", "/;", 
        RowBox[{"a", "<", "0"}]}]], ":>", 
      RowBox[{
       SuperscriptBox["2", "a"], 
       SuperscriptBox[
        RowBox[{
         RowBox[{"\[ScriptU]$", "[", "0", "]"}], "[", 
         RowBox[{"+", "1"}], "]"}], "a"]}]}]}], "}"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"Wfinal", "=", 
  RowBox[{
   RowBox[{"Collect", "[", 
    RowBox[{"%", ",", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"Q0", ",", "\[Eta]list", ",", 
        RowBox[{
         RowBox[{"\[ScriptU]$", "[", "_", "]"}], "[", "_", "]"}], ",", 
        "\[Zeta]list"}], "}"}], "//", "Flatten"}]}], "]"}], "/.", 
   RowBox[{"Q0", "\[Rule]", 
    RowBox[{
     SubscriptBox["\[ScriptU]", "v0"], 
     SubscriptBox["\[ScriptU]", 
      RowBox[{"-", "v0"}]]}]}]}]}]}], "Input",
 CellChangeTimes->{{3.562240426713138*^9, 3.5622404662392817`*^9}, {
  3.562240498218563*^9, 3.562240530295197*^9}, {3.5622405635083847`*^9, 
  3.562240740920087*^9}, {3.562240801817376*^9, 3.56224080255311*^9}, {
  3.562240851119385*^9, 3.5622408513099194`*^9}, {3.5622408840330753`*^9, 
  3.562240940187677*^9}, {3.562240975036911*^9, 3.562241108230191*^9}, {
  3.5622412696560183`*^9, 3.562241271663679*^9}, {3.562241320724802*^9, 
  3.562241340170829*^9}, {3.562241391569827*^9, 3.562241489133222*^9}, {
  3.56224156382843*^9, 3.5622416087128897`*^9}, {3.562245540144239*^9, 
  3.5622455437596083`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"1296", " ", 
   SubscriptBox[
    StyleBox["\[Zeta]",
     FontWeight->Bold,
     FontColor->GrayLevel[0.4]], "3"]}], "+", 
  FractionBox[
   RowBox[{
    RowBox[{"108", " ", "\[ImaginaryI]"}], "+", 
    RowBox[{"54", " ", "\[ImaginaryI]", " ", 
     SubscriptBox[
      StyleBox["\[Zeta]",
       FontWeight->Bold,
       FontColor->GrayLevel[0.4]], "2"]}], "-", 
    FractionBox[
     RowBox[{"144", " ", "\[ImaginaryI]", " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2", "2"]}], "5"], "-", 
    FractionBox[
     RowBox[{"1312", " ", "\[ImaginaryI]", " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2", "3"]}], "35"], "+", 
    RowBox[{"18", " ", "\[ImaginaryI]", " ", 
     SubscriptBox[
      StyleBox["\[Zeta]",
       FontWeight->Bold,
       FontColor->GrayLevel[0.4]], "3"]}], "-", 
    RowBox[{"96", " ", "\[ImaginaryI]", " ", 
     SubsuperscriptBox[
      StyleBox["\[Zeta]",
       FontWeight->Bold,
       FontColor->GrayLevel[0.4]], "3", "2"]}]}], 
   SuperscriptBox[
    StyleBox["\[ScriptU]",
     FontColor->RGBColor[0, 0, 0.4]], "+"]], "+", 
  FractionBox[
   RowBox[{
    RowBox[{
     RowBox[{"-", "108"}], " ", "\[ImaginaryI]"}], "-", 
    RowBox[{"54", " ", "\[ImaginaryI]", " ", 
     SubscriptBox[
      StyleBox["\[Zeta]",
       FontWeight->Bold,
       FontColor->GrayLevel[0.4]], "2"]}], "+", 
    FractionBox[
     RowBox[{"144", " ", "\[ImaginaryI]", " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2", "2"]}], "5"], "+", 
    FractionBox[
     RowBox[{"1312", " ", "\[ImaginaryI]", " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2", "3"]}], "35"], "-", 
    RowBox[{"18", " ", "\[ImaginaryI]", " ", 
     SubscriptBox[
      StyleBox["\[Zeta]",
       FontWeight->Bold,
       FontColor->GrayLevel[0.4]], "3"]}], "+", 
    RowBox[{"96", " ", "\[ImaginaryI]", " ", 
     SubsuperscriptBox[
      StyleBox["\[Zeta]",
       FontWeight->Bold,
       FontColor->GrayLevel[0.4]], "3", "2"]}]}], 
   SuperscriptBox[
    StyleBox["\[ScriptU]",
     FontColor->RGBColor[0, 0, 0.4]], "-"]], "+", 
  FractionBox[
   RowBox[{
    RowBox[{"-", "27"}], "+", 
    RowBox[{"36", " ", 
     SubscriptBox[
      StyleBox["\[Zeta]",
       FontWeight->Bold,
       FontColor->GrayLevel[0.4]], "3"]}], "+", 
    RowBox[{"120", " ", 
     SubscriptBox[
      StyleBox["\[Zeta]",
       FontWeight->Bold,
       FontColor->GrayLevel[0.4]], "5"]}]}], 
   SuperscriptBox[
    RowBox[{"(", 
     SuperscriptBox[
      StyleBox["\[ScriptU]",
       FontColor->RGBColor[0, 0, 0.4]], "-"], ")"}], "2"]], "+", 
  FractionBox[
   RowBox[{
    RowBox[{"-", "27"}], "+", 
    RowBox[{"36", " ", 
     SubscriptBox[
      StyleBox["\[Zeta]",
       FontWeight->Bold,
       FontColor->GrayLevel[0.4]], "3"]}], "+", 
    RowBox[{"120", " ", 
     SubscriptBox[
      StyleBox["\[Zeta]",
       FontWeight->Bold,
       FontColor->GrayLevel[0.4]], "5"]}]}], 
   SuperscriptBox[
    RowBox[{"(", 
     SuperscriptBox[
      StyleBox["\[ScriptU]",
       FontColor->RGBColor[0, 0, 0.4]], "+"], ")"}], "2"]], "+", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     RowBox[{"-", 
      FractionBox[
       RowBox[{"81", " ", "\[ImaginaryI]"}], 
       SuperscriptBox[
        StyleBox["\[ScriptU]",
         FontColor->RGBColor[0, 0, 0.4]], "-"]]}], "-", 
     FractionBox[
      RowBox[{"81", " ", "\[ImaginaryI]"}], 
      SuperscriptBox[
       StyleBox["\[ScriptU]",
        FontColor->RGBColor[0, 0, 0.4]], "+"]], "+", 
     FractionBox[
      RowBox[{"9", "-", 
       RowBox[{"72", " ", 
        SubscriptBox[
         StyleBox["\[Zeta]",
          FontWeight->Bold,
          FontColor->GrayLevel[0.4]], "3"]}]}], 
      SuperscriptBox[
       RowBox[{"(", 
        SuperscriptBox[
         StyleBox["\[ScriptU]",
          FontColor->RGBColor[0, 0, 0.4]], "+"], ")"}], "2"]], "-", 
     RowBox[{"1296", " ", "\[ImaginaryI]", " ", "u", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3"]}], "+", 
     FractionBox[
      RowBox[{
       RowBox[{"-", "9"}], "+", 
       RowBox[{"72", " ", 
        SubscriptBox[
         StyleBox["\[Zeta]",
          FontWeight->Bold,
          FontColor->GrayLevel[0.4]], "3"]}]}], 
      SuperscriptBox[
       RowBox[{"(", 
        SuperscriptBox[
         StyleBox["\[ScriptU]",
          FontColor->RGBColor[0, 0, 0.4]], "-"], ")"}], "2"]]}], ")"}], " ", 
   SubsuperscriptBox[
    StyleBox["\[Eta]",
     FontWeight->Bold,
     FontColor->RGBColor[0.8, 0, 0]], "2", "+"]}], "+", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     RowBox[{"108", " ", "\[ImaginaryI]"}], "+", 
     FractionBox[
      RowBox[{"18", " ", "\[ImaginaryI]"}], 
      SuperscriptBox[
       RowBox[{"(", 
        SuperscriptBox[
         StyleBox["\[ScriptU]",
          FontColor->RGBColor[0, 0, 0.4]], "+"], ")"}], "2"]], "+", 
     FractionBox[
      RowBox[{
       RowBox[{"-", "18"}], "-", 
       RowBox[{"48", " ", 
        SubscriptBox[
         StyleBox["\[Zeta]",
          FontWeight->Bold,
          FontColor->GrayLevel[0.4]], "3"]}]}], 
      SuperscriptBox[
       StyleBox["\[ScriptU]",
        FontColor->RGBColor[0, 0, 0.4]], "-"]], "+", 
     RowBox[{"144", " ", "\[ImaginaryI]", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3"]}], "+", 
     FractionBox[
      RowBox[{
       RowBox[{"-", "36"}], "+", 
       RowBox[{"48", " ", 
        SubscriptBox[
         StyleBox["\[Zeta]",
          FontWeight->Bold,
          FontColor->GrayLevel[0.4]], "3"]}]}], 
      SuperscriptBox[
       StyleBox["\[ScriptU]",
        FontColor->RGBColor[0, 0, 0.4]], "+"]]}], ")"}], " ", 
   SubsuperscriptBox[
    StyleBox["\[Eta]",
     FontWeight->Bold,
     FontColor->RGBColor[0.8, 0, 0]], "3", "+"]}], "+", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     RowBox[{"-", 
      FractionBox[
       RowBox[{"18", " ", "\[ImaginaryI]"}], 
       SuperscriptBox[
        StyleBox["\[ScriptU]",
         FontColor->RGBColor[0, 0, 0.4]], "-"]]}], "-", 
     FractionBox[
      RowBox[{"18", " ", "\[ImaginaryI]"}], 
      SuperscriptBox[
       StyleBox["\[ScriptU]",
        FontColor->RGBColor[0, 0, 0.4]], "+"]]}], ")"}], " ", 
   SubsuperscriptBox[
    StyleBox["\[Eta]",
     FontWeight->Bold,
     FontColor->RGBColor[0.8, 0, 0]], "4", "+"]}], "+", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     FractionBox["18", 
      SuperscriptBox[
       RowBox[{"(", 
        SuperscriptBox[
         StyleBox["\[ScriptU]",
          FontColor->RGBColor[0, 0, 0.4]], "-"], ")"}], "2"]], "+", 
     FractionBox[
      RowBox[{"72", " ", "\[ImaginaryI]"}], 
      SuperscriptBox[
       StyleBox["\[ScriptU]",
        FontColor->RGBColor[0, 0, 0.4]], "-"]], "+", 
     FractionBox[
      RowBox[{"90", " ", "\[ImaginaryI]"}], 
      SuperscriptBox[
       StyleBox["\[ScriptU]",
        FontColor->RGBColor[0, 0, 0.4]], "+"]]}], ")"}], " ", 
   SubsuperscriptBox[
    OverscriptBox[
     StyleBox["\[Eta]",
      FontWeight->Bold,
      FontColor->RGBColor[0.8, 0, 0]], 
     StyleBox["_",
      FontWeight->Bold,
      FontColor->RGBColor[0.8, 0, 0]]], "2", "-"]}], "+", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     RowBox[{
      RowBox[{"-", "108"}], " ", "\[ImaginaryI]"}], "-", 
     FractionBox[
      RowBox[{"18", " ", "\[ImaginaryI]"}], 
      SuperscriptBox[
       RowBox[{"(", 
        SuperscriptBox[
         StyleBox["\[ScriptU]",
          FontColor->RGBColor[0, 0, 0.4]], "-"], ")"}], "2"]], "-", 
     FractionBox["36", 
      SuperscriptBox[
       StyleBox["\[ScriptU]",
        FontColor->RGBColor[0, 0, 0.4]], "-"]], "-", 
     FractionBox["18", 
      SuperscriptBox[
       StyleBox["\[ScriptU]",
        FontColor->RGBColor[0, 0, 0.4]], "+"]]}], ")"}], " ", 
   SubsuperscriptBox[
    OverscriptBox[
     StyleBox["\[Eta]",
      FontWeight->Bold,
      FontColor->RGBColor[0.8, 0, 0]], 
     StyleBox["_",
      FontWeight->Bold,
      FontColor->RGBColor[0.8, 0, 0]]], "3", "-"]}], "+", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     FractionBox[
      RowBox[{"18", " ", "\[ImaginaryI]"}], 
      SuperscriptBox[
       StyleBox["\[ScriptU]",
        FontColor->RGBColor[0, 0, 0.4]], "-"]], "+", 
     FractionBox[
      RowBox[{"18", " ", "\[ImaginaryI]"}], 
      SuperscriptBox[
       StyleBox["\[ScriptU]",
        FontColor->RGBColor[0, 0, 0.4]], "+"]]}], ")"}], " ", 
   SubsuperscriptBox[
    OverscriptBox[
     StyleBox["\[Eta]",
      FontWeight->Bold,
      FontColor->RGBColor[0.8, 0, 0]], 
     StyleBox["_",
      FontWeight->Bold,
      FontColor->RGBColor[0.8, 0, 0]]], "4", "-"]}], "+", 
  RowBox[{
   SubscriptBox[
    StyleBox["\[ScriptU]",
     FontColor->RGBColor[0, 0, 0.4]], 
    RowBox[{"-", "v0"}]], " ", 
   SubscriptBox[
    StyleBox["\[ScriptU]",
     FontColor->RGBColor[0, 0, 0.4]], "v0"], " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", 
         FractionBox["27", 
          SuperscriptBox[
           RowBox[{"(", 
            SuperscriptBox[
             StyleBox["\[ScriptU]",
              FontColor->RGBColor[0, 0, 0.4]], "-"], ")"}], "2"]]}], "-", 
        FractionBox[
         RowBox[{"54", " ", "\[ImaginaryI]"}], 
         SuperscriptBox[
          StyleBox["\[ScriptU]",
           FontColor->RGBColor[0, 0, 0.4]], "-"]], "-", 
        FractionBox["27", 
         SuperscriptBox[
          RowBox[{"(", 
           SuperscriptBox[
            StyleBox["\[ScriptU]",
             FontColor->RGBColor[0, 0, 0.4]], "+"], ")"}], "2"]], "+", 
        FractionBox[
         RowBox[{"54", " ", "\[ImaginaryI]"}], 
         SuperscriptBox[
          StyleBox["\[ScriptU]",
           FontColor->RGBColor[0, 0, 0.4]], "+"]]}], ")"}], " ", 
      SubsuperscriptBox[
       StyleBox["\[Eta]",
        FontWeight->Bold,
        FontColor->RGBColor[0.8, 0, 0]], "2", "+"]}], "+", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", 
         FractionBox[
          RowBox[{"36", " ", "\[ImaginaryI]"}], 
          SuperscriptBox[
           RowBox[{"(", 
            SuperscriptBox[
             StyleBox["\[ScriptU]",
              FontColor->RGBColor[0, 0, 0.4]], "-"], ")"}], "2"]]}], "+", 
        FractionBox["108", 
         SuperscriptBox[
          StyleBox["\[ScriptU]",
           FontColor->RGBColor[0, 0, 0.4]], "-"]], "+", 
        FractionBox[
         RowBox[{"36", " ", "\[ImaginaryI]"}], 
         SuperscriptBox[
          RowBox[{"(", 
           SuperscriptBox[
            StyleBox["\[ScriptU]",
             FontColor->RGBColor[0, 0, 0.4]], "+"], ")"}], "2"]], "+", 
        FractionBox["108", 
         SuperscriptBox[
          StyleBox["\[ScriptU]",
           FontColor->RGBColor[0, 0, 0.4]], "+"]]}], ")"}], " ", 
      SubsuperscriptBox[
       StyleBox["\[Eta]",
        FontWeight->Bold,
        FontColor->RGBColor[0.8, 0, 0]], 
       RowBox[{"2", ",", "3"}], "+"]}], "+", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        FractionBox[
         RowBox[{"36", " ", "\[ImaginaryI]"}], 
         SuperscriptBox[
          StyleBox["\[ScriptU]",
           FontColor->RGBColor[0, 0, 0.4]], "-"]], "-", 
        FractionBox[
         RowBox[{"36", " ", "\[ImaginaryI]"}], 
         SuperscriptBox[
          StyleBox["\[ScriptU]",
           FontColor->RGBColor[0, 0, 0.4]], "+"]]}], ")"}], " ", 
      SubsuperscriptBox[
       StyleBox["\[Eta]",
        FontWeight->Bold,
        FontColor->RGBColor[0.8, 0, 0]], 
       RowBox[{"2", ",", "4"}], "+"]}], "+", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        FractionBox[
         RowBox[{"36", " ", "\[ImaginaryI]"}], 
         SuperscriptBox[
          RowBox[{"(", 
           SuperscriptBox[
            StyleBox["\[ScriptU]",
             FontColor->RGBColor[0, 0, 0.4]], "-"], ")"}], "2"]], "-", 
        FractionBox["108", 
         SuperscriptBox[
          StyleBox["\[ScriptU]",
           FontColor->RGBColor[0, 0, 0.4]], "-"]], "-", 
        FractionBox[
         RowBox[{"36", " ", "\[ImaginaryI]"}], 
         SuperscriptBox[
          RowBox[{"(", 
           SuperscriptBox[
            StyleBox["\[ScriptU]",
             FontColor->RGBColor[0, 0, 0.4]], "+"], ")"}], "2"]], "-", 
        FractionBox["108", 
         SuperscriptBox[
          StyleBox["\[ScriptU]",
           FontColor->RGBColor[0, 0, 0.4]], "+"]]}], ")"}], " ", 
      SubsuperscriptBox[
       StyleBox["\[Eta]",
        FontWeight->Bold,
        FontColor->RGBColor[0.8, 0, 0]], 
       RowBox[{"3", ",", "2"}], "+"]}], "+", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", 
         FractionBox[
          RowBox[{"36", " ", "\[ImaginaryI]"}], 
          SuperscriptBox[
           StyleBox["\[ScriptU]",
            FontColor->RGBColor[0, 0, 0.4]], "-"]]}], "+", 
        FractionBox[
         RowBox[{"36", " ", "\[ImaginaryI]"}], 
         SuperscriptBox[
          StyleBox["\[ScriptU]",
           FontColor->RGBColor[0, 0, 0.4]], "+"]]}], ")"}], " ", 
      SubsuperscriptBox[
       StyleBox["\[Eta]",
        FontWeight->Bold,
        FontColor->RGBColor[0.8, 0, 0]], 
       RowBox[{"4", ",", "2"}], "+"]}], "+", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", 
         FractionBox[
          RowBox[{"108", " ", "\[ImaginaryI]"}], 
          SuperscriptBox[
           StyleBox["\[ScriptU]",
            FontColor->RGBColor[0, 0, 0.4]], "-"]]}], "+", 
        FractionBox[
         RowBox[{"108", " ", "\[ImaginaryI]"}], 
         SuperscriptBox[
          StyleBox["\[ScriptU]",
           FontColor->RGBColor[0, 0, 0.4]], "+"]]}], ")"}], " ", 
      SubsuperscriptBox[
       StyleBox["\[Eta]",
        FontWeight->Bold,
        FontColor->RGBColor[0.8, 0, 0]], "2", "+"], " ", 
      SubsuperscriptBox[
       OverscriptBox[
        StyleBox["\[Eta]",
         FontWeight->Bold,
         FontColor->RGBColor[0.8, 0, 0]], 
        StyleBox["_",
         FontWeight->Bold,
         FontColor->RGBColor[0.8, 0, 0]]], "2", "-"]}], "+", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", 
         FractionBox[
          RowBox[{"36", " ", "\[ImaginaryI]"}], 
          SuperscriptBox[
           RowBox[{"(", 
            SuperscriptBox[
             StyleBox["\[ScriptU]",
              FontColor->RGBColor[0, 0, 0.4]], "-"], ")"}], "2"]]}], "+", 
        FractionBox["36", 
         SuperscriptBox[
          StyleBox["\[ScriptU]",
           FontColor->RGBColor[0, 0, 0.4]], "-"]], "+", 
        FractionBox["72", 
         SuperscriptBox[
          StyleBox["\[ScriptU]",
           FontColor->RGBColor[0, 0, 0.4]], "+"]]}], ")"}], " ", 
      SubsuperscriptBox[
       StyleBox["\[Eta]",
        FontWeight->Bold,
        FontColor->RGBColor[0.8, 0, 0]], "3", "+"], " ", 
      SubsuperscriptBox[
       OverscriptBox[
        StyleBox["\[Eta]",
         FontWeight->Bold,
         FontColor->RGBColor[0.8, 0, 0]], 
        StyleBox["_",
         FontWeight->Bold,
         FontColor->RGBColor[0.8, 0, 0]]], "2", "-"]}], "+", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        FractionBox[
         RowBox[{"36", " ", "\[ImaginaryI]"}], 
         SuperscriptBox[
          RowBox[{"(", 
           SuperscriptBox[
            StyleBox["\[ScriptU]",
             FontColor->RGBColor[0, 0, 0.4]], "-"], ")"}], "2"]], "-", 
        FractionBox["36", 
         SuperscriptBox[
          StyleBox["\[ScriptU]",
           FontColor->RGBColor[0, 0, 0.4]], "-"]], "-", 
        FractionBox["72", 
         SuperscriptBox[
          StyleBox["\[ScriptU]",
           FontColor->RGBColor[0, 0, 0.4]], "+"]]}], ")"}], " ", 
      SubsuperscriptBox[
       StyleBox["\[Eta]",
        FontWeight->Bold,
        FontColor->RGBColor[0.8, 0, 0]], "2", "+"], " ", 
      SubsuperscriptBox[
       OverscriptBox[
        StyleBox["\[Eta]",
         FontWeight->Bold,
         FontColor->RGBColor[0.8, 0, 0]], 
        StyleBox["_",
         FontWeight->Bold,
         FontColor->RGBColor[0.8, 0, 0]]], "3", "-"]}], "+", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        FractionBox[
         RowBox[{"36", " ", "\[ImaginaryI]"}], 
         SuperscriptBox[
          StyleBox["\[ScriptU]",
           FontColor->RGBColor[0, 0, 0.4]], "-"]], "-", 
        FractionBox[
         RowBox[{"36", " ", "\[ImaginaryI]"}], 
         SuperscriptBox[
          StyleBox["\[ScriptU]",
           FontColor->RGBColor[0, 0, 0.4]], "+"]]}], ")"}], " ", 
      SubsuperscriptBox[
       StyleBox["\[Eta]",
        FontWeight->Bold,
        FontColor->RGBColor[0.8, 0, 0]], "3", "+"], " ", 
      SubsuperscriptBox[
       OverscriptBox[
        StyleBox["\[Eta]",
         FontWeight->Bold,
         FontColor->RGBColor[0.8, 0, 0]], 
        StyleBox["_",
         FontWeight->Bold,
         FontColor->RGBColor[0.8, 0, 0]]], "3", "-"]}], "+", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", 
         FractionBox[
          RowBox[{"36", " ", "\[ImaginaryI]"}], 
          SuperscriptBox[
           StyleBox["\[ScriptU]",
            FontColor->RGBColor[0, 0, 0.4]], "-"]]}], "+", 
        FractionBox[
         RowBox[{"36", " ", "\[ImaginaryI]"}], 
         SuperscriptBox[
          StyleBox["\[ScriptU]",
           FontColor->RGBColor[0, 0, 0.4]], "+"]]}], ")"}], " ", 
      SubsuperscriptBox[
       StyleBox["\[Eta]",
        FontWeight->Bold,
        FontColor->RGBColor[0.8, 0, 0]], "2", "+"], " ", 
      SubsuperscriptBox[
       OverscriptBox[
        StyleBox["\[Eta]",
         FontWeight->Bold,
         FontColor->RGBColor[0.8, 0, 0]], 
        StyleBox["_",
         FontWeight->Bold,
         FontColor->RGBColor[0.8, 0, 0]]], "4", "-"]}]}], ")"}]}]}]], "Output",\

 CellChangeTimes->{
  3.562240430256199*^9, 3.5622404668119593`*^9, {3.5622404996677017`*^9, 
   3.562240530876124*^9}, {3.562240588727193*^9, 3.562240624251885*^9}, {
   3.5622406565196257`*^9, 3.562240741606886*^9}, 3.562240802963972*^9, 
   3.56224085187706*^9, {3.562240886960207*^9, 3.56224094309837*^9}, {
   3.562240997480475*^9, 3.5622410247801123`*^9}, {3.5622410769733477`*^9, 
   3.562241111893958*^9}, {3.5622412136712427`*^9, 3.562241233955854*^9}, 
   3.562241272226747*^9, {3.562241321370232*^9, 3.562241340783122*^9}, 
   3.562241373666748*^9, {3.562241436177109*^9, 3.5622414900519133`*^9}, {
   3.56224157129462*^9, 3.562241609348195*^9}, 3.5622418989496326`*^9, 
   3.562245246892529*^9, 3.5622455444600697`*^9, 3.562311139436166*^9, 
   3.562311378566532*^9, 3.5623114465885572`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"BoldCompute", "[", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{"Wfinal", "-", "Wtermcomplete"}], "/.", "subusu"}], "/.", 
      "subQ0"}], "/.", 
     RowBox[{"u", "\[Rule]", 
      RowBox[{"1", "/", "10"}]}]}], "/.", "subZetas"}], ",", 
   RowBox[{"1", "/", "10"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.560686978677907*^9, 3.560686998678824*^9}, {
   3.560687065014284*^9, 3.5606870863931093`*^9}, {3.560687277985526*^9, 
   3.5606872780971127`*^9}, {3.56068732413839*^9, 3.560687398694763*^9}, {
   3.562239726217998*^9, 3.562239763697289*^9}, 3.562241693643128*^9, {
   3.562241724711862*^9, 3.5622417254556837`*^9}, {3.56224178078378*^9, 
   3.5622417821803427`*^9}}],

Cell[BoxData[
 RowBox[{"0``14.475184252335252", "+", 
  RowBox[{"0``14.512497918215411", " ", "\[ImaginaryI]"}]}]], "Output",
 CellChangeTimes->{{3.560686994936658*^9, 3.5606869993309593`*^9}, {
   3.560687066176881*^9, 3.560687086786522*^9}, {3.5606872765781116`*^9, 
   3.5606872784893084`*^9}, {3.560687324849387*^9, 3.560687399291649*^9}, 
   3.560689985802809*^9, 3.5607069008425922`*^9, 3.5607077109723988`*^9, 
   3.56070809134825*^9, 3.560709107173493*^9, 3.560945060969562*^9, 
   3.561059007128356*^9, 3.561466434398694*^9, 3.5614673483673887`*^9, 
   3.561467488792815*^9, 3.561469253415552*^9, {3.562239733954628*^9, 
   3.562239764642211*^9}, 3.562241694423463*^9, 3.562241726046752*^9, 
   3.562241782856069*^9, 3.562245559195969*^9, 3.562245593388212*^9, 
   3.562311142710277*^9, 3.5623113787622547`*^9, 3.562311454077663*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"Series", "[", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"\[Rho]2term", "+", " ", "Wfinal"}], "/.", "subusu"}], "/.", 
     "subQ0"}], ",", 
    RowBox[{"{", 
     RowBox[{"u", ",", "v00", ",", "0"}], "}"}]}], "]"}], "/.", 
  "sub\[Eta]\[Eta]0"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Series", "[", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"\[Rho]2term", "+", " ", "Wfinal"}], "/.", "subusu"}], "/.", 
     "subQ0"}], ",", 
    RowBox[{"{", 
     RowBox[{"u", ",", 
      RowBox[{"-", "v00"}], ",", "0"}], "}"}]}], "]"}], "/.", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"\[Eta]$b", "[", "a_", "]"}], "[", 
      RowBox[{"-", "1"}], "]"}], "\[RuleDelayed]", 
     RowBox[{
      SuperscriptBox[
       RowBox[{"(", 
        RowBox[{"-", "1"}], ")"}], 
       RowBox[{"Total", "[", 
        RowBox[{"{", "a", "}"}], "]"}]], 
      RowBox[{
       RowBox[{"\[Eta]0$", "[", "a", "]"}], "[", "1", "]"}]}]}], ",", 
    RowBox[{
     RowBox[{
      RowBox[{"\[Eta]$", "[", "a_", "]"}], "[", "1", "]"}], "\[RuleDelayed]", 
     
     RowBox[{
      SuperscriptBox[
       RowBox[{"(", 
        RowBox[{"-", "1"}], ")"}], 
       RowBox[{"Total", "[", 
        RowBox[{"{", "a", "}"}], "]"}]], 
      RowBox[{
       RowBox[{"\[Eta]0$b", "[", "a", "]"}], "[", 
       RowBox[{"-", "1"}], "]"}]}]}]}], "}"}]}]}], "Input",
 CellChangeTimes->{{3.562241867170843*^9, 3.562241867841929*^9}, {
  3.562241912575892*^9, 3.5622419271338987`*^9}, {3.562920453378084*^9, 
  3.5629206659652567`*^9}, {3.563024830769285*^9, 3.563024832790847*^9}}],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"Series", "::", "ztest"}], "MessageName"], 
  RowBox[{
  ":", " "}], "\<\"Unable to decide whether numeric quantities \
\[NoBreak]\\!\\({\\(\\(\\(\\(36\\\\ \\@3\\)\\) + \\(432\\\\ \
\[ImaginaryI]\\)\\/\\((\\(\\(\\(\\(-3\\)\\)\\\\ \[ImaginaryI]\\)\\) + \
\\@3)\\)\\^2 - \\(432\\\\ \[ImaginaryI]\\)\\/\\((\\(\\(3\\\\ \[ImaginaryI]\\)\
\\) + \\@3)\\)\\^2\\)\\), \\(\\(\\(\\(\\(\\(-36\\)\\)\\\\ \\@3\\)\\) - \\(432\
\\\\ \[ImaginaryI]\\)\\/\\((\\(\\(\\(\\(-3\\)\\)\\\\ \[ImaginaryI]\\)\\) + \
\\@3)\\)\\^2 + \\(432\\\\ \[ImaginaryI]\\)\\/\\((\\(\\(3\\\\ \[ImaginaryI]\\)\
\\) + \\@3)\\)\\^2\\)\\), \\(\\(\\(\\(\\(\\(-54\\)\\)\\\\ \[ImaginaryI]\\)\\) \
+ \\(\\(18\\\\ \\@3\\)\\) + \\(432\\\\ \
\[ImaginaryI]\\)\\/\\((\\(\\(\\(\\(-3\\)\\)\\\\ \[ImaginaryI]\\)\\) + \
\\@3)\\)\\^2 + 144\\/\\(\\(\\(\\(\\(-3\\)\\)\\\\ \[ImaginaryI]\\)\\) + \
\\@3\\) - 144\\/\\(\\(\\(3\\\\ \[ImaginaryI]\\)\\) + \\@3\\)\\)\\), \\(\\(\\(\
\\(-\\(\\(\\(648\\\\ \[ImaginaryI]\\)\\/\\((\\(\[LeftSkeleton] 1 \
\[RightSkeleton]\\) \\(\[LeftSkeleton] 1 \
\[RightSkeleton]\\)\\)\\^2\\)\\)\\)\\) - 216\\/\\(\[LeftSkeleton] 1 \
\[RightSkeleton]\\) - 108\\/\\(\[LeftSkeleton] 1 \[RightSkeleton]\\)\\)\\), \
\\(\\(\[LeftSkeleton] 1 \[RightSkeleton]\\)\\), \\(\\(\\(\\(-36\\)\\) - \\(72\
\\\\ \[ImaginaryI]\\)\\/\\(\\(\\(\\(\\(-3\\)\\)\\\\ \[ImaginaryI]\\)\\) + \
\\@3\\) + \\(72\\\\ \[ImaginaryI]\\)\\/\\(\\(\\(3\\\\ \[ImaginaryI]\\)\\) + \
\\@3\\)\\)\\), \\(\\(108 + \\(216\\\\ \[ImaginaryI]\\)\\/\\(\\(\\(\\(\\(-3\\)\
\\)\\\\ \[ImaginaryI]\\)\\) + \\@3\\) - \\(216\\\\ \
\[ImaginaryI]\\)\\/\\(\\(\\(3\\\\ \[ImaginaryI]\\)\\) + \\@3\\)\\)\\), \\(\\(\
\\(\\(54\\\\ \[ImaginaryI]\\)\\) - \\(\\(18\\\\ \\@3\\)\\) - \\(432\\\\ \
\[ImaginaryI]\\)\\/\\((\\(\\(\\(\\(-3\\)\\)\\\\ \[ImaginaryI]\\)\\) + \
\\@3)\\)\\^2 - 144\\/\\(\\(\\(\\(\\(-3\\)\\)\\\\ \[ImaginaryI]\\)\\) + \
\\@3\\) + 144\\/\\(\\(\\(3\\\\ \[ImaginaryI]\\)\\) + \\@3\\)\\)\\)}\\)\
\[NoBreak] are equal to zero. Assuming they are. \\!\\(\\*ButtonBox[\\\"\
\[RightSkeleton]\\\", ButtonStyle->\\\"Link\\\", ButtonFrame->None, \
ButtonData:>\\\"paclet:ref/Series\\\", ButtonNote -> \
\\\"Series::ztest\\\"]\\)\"\>"}]], "Message", "MSG",
 CellChangeTimes->{3.563024834441276*^9}],

Cell[BoxData[
 InterpretationBox[
  SuperscriptBox[
   RowBox[{"O", "[", 
    RowBox[{"u", "-", 
     FractionBox["1", 
      RowBox[{"2", " ", 
       SqrtBox["3"]}]]}], "]"}], "1"],
  SeriesData[$CellContext`u, Rational[1, 2] 3^Rational[-1, 2], {}, 1, 1, 1],
  Editable->False]], "Output",
 CellChangeTimes->{{3.5622419031914883`*^9, 3.5622419280451517`*^9}, 
   3.5622455914346733`*^9, 3.5622456954220448`*^9, {3.562311145793679*^9, 
   3.5623111751058083`*^9}, 3.562311378973979*^9, 3.562311455076137*^9, {
   3.562920458487247*^9, 3.5629205728857527`*^9}, {3.562920605378059*^9, 
   3.5629206662838297`*^9}, {3.5629353088575487`*^9, 3.562935312092079*^9}, {
   3.5630248223438168`*^9, 3.5630248344767447`*^9}}],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"Series", "::", "ztest"}], "MessageName"], 
  RowBox[{
  ":", " "}], "\<\"Unable to decide whether numeric quantities \
\[NoBreak]\\!\\({\\(\\(\\(\\(\\(\\(-54\\)\\)\\\\ \[ImaginaryI]\\)\\) - \
\\(\\(18\\\\ \\@3\\)\\) + 144\\/\\(\\(\\(\\(\\(-3\\)\\)\\\\ \
\[ImaginaryI]\\)\\) + \\@3\\) + \\(432\\\\ \[ImaginaryI]\\)\\/\\((\\(\\(3\\\\ \
\[ImaginaryI]\\)\\) + \\@3)\\)\\^2 - 144\\/\\(\\(\\(3\\\\ \[ImaginaryI]\\)\\) \
+ \\@3\\)\\)\\), \\(\\(\\(\\(54\\\\ \[ImaginaryI]\\)\\) + \\(\\(18\\\\ \
\\@3\\)\\) - 144\\/\\(\\(\\(\\(\\(-3\\)\\)\\\\ \[ImaginaryI]\\)\\) + \\@3\\) \
- \\(432\\\\ \[ImaginaryI]\\)\\/\\((\\(\\(3\\\\ \[ImaginaryI]\\)\\) + \
\\@3)\\)\\^2 + 144\\/\\(\\(\\(3\\\\ \[ImaginaryI]\\)\\) + \\@3\\)\\)\\), \
\\(\\(108\\/\\(\\(\\(\\(\\(-3\\)\\)\\\\ \[ImaginaryI]\\)\\) + \\@3\\) - \
\\(648\\\\ \[ImaginaryI]\\)\\/\\((\\(\\(3\\\\ \[ImaginaryI]\\)\\) + \
\\@3)\\)\\^2 + 216\\/\\(\\(\\(3\\\\ \[ImaginaryI]\\)\\) + \\@3\\)\\)\\)}\\)\
\[NoBreak] are equal to zero. Assuming they are. \\!\\(\\*ButtonBox[\\\"\
\[RightSkeleton]\\\", ButtonStyle->\\\"Link\\\", ButtonFrame->None, \
ButtonData:>\\\"paclet:ref/Series\\\", ButtonNote -> \
\\\"Series::ztest\\\"]\\)\"\>"}]], "Message", "MSG",
 CellChangeTimes->{3.563024835572072*^9}],

Cell[BoxData[
 InterpretationBox[
  SuperscriptBox[
   RowBox[{"O", "[", 
    RowBox[{"u", "+", 
     FractionBox["1", 
      RowBox[{"2", " ", 
       SqrtBox["3"]}]]}], "]"}], "1"],
  SeriesData[$CellContext`u, Rational[-1, 2] 3^Rational[-1, 2], {}, 1, 1, 1],
  Editable->False]], "Output",
 CellChangeTimes->{{3.5622419031914883`*^9, 3.5622419280451517`*^9}, 
   3.5622455914346733`*^9, 3.5622456954220448`*^9, {3.562311145793679*^9, 
   3.5623111751058083`*^9}, 3.562311378973979*^9, 3.562311455076137*^9, {
   3.562920458487247*^9, 3.5629205728857527`*^9}, {3.562920605378059*^9, 
   3.5629206662838297`*^9}, {3.5629353088575487`*^9, 3.562935312092079*^9}, {
   3.5630248223438168`*^9, 3.563024835590786*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData["\[Rho]2term"], "Input",
 CellChangeTimes->{{3.5622417914149942`*^9, 3.562241793146448*^9}}],

Cell[BoxData[
 RowBox[{
  FractionBox["1", "8"], " ", 
  RowBox[{"(", 
   RowBox[{
    RowBox[{"-", 
     FractionBox["\[ImaginaryI]", 
      SuperscriptBox[
       StyleBox["\[ScriptU]",
        FontColor->RGBColor[0, 0, 0.4]], "-"]]}], "+", 
    FractionBox["\[ImaginaryI]", 
     SuperscriptBox[
      StyleBox["\[ScriptU]",
       FontColor->RGBColor[0, 0, 0.4]], "+"]]}], ")"}], " ", 
  RowBox[{"(", 
   RowBox[{
    RowBox[{"-", "1080"}], "-", 
    RowBox[{"432", " ", 
     SubscriptBox[
      StyleBox["\[Zeta]",
       FontWeight->Bold,
       FontColor->GrayLevel[0.4]], "2"]}], "+", 
    FractionBox[
     RowBox[{"1152", " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2", "2"]}], "5"], "+", 
    FractionBox[
     RowBox[{"10496", " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2", "3"]}], "35"], "-", 
    RowBox[{"3312", " ", 
     SubscriptBox[
      StyleBox["\[Zeta]",
       FontWeight->Bold,
       FontColor->GrayLevel[0.4]], "3"]}], "+", 
    RowBox[{"768", " ", 
     SubsuperscriptBox[
      StyleBox["\[Zeta]",
       FontWeight->Bold,
       FontColor->GrayLevel[0.4]], "3", "2"]}], "+", 
    RowBox[{"960", " ", 
     SubscriptBox[
      StyleBox["\[Zeta]",
       FontWeight->Bold,
       FontColor->GrayLevel[0.4]], "5"]}], "+", 
    RowBox[{"288", " ", "\[ImaginaryI]", " ", 
     SqrtBox["3"], " ", 
     SubsuperscriptBox[
      StyleBox["\[Eta]0",
       FontWeight->Bold,
       FontColor->RGBColor[0, 0.5, 0]], "2", "+"]}], "-", 
    RowBox[{"288", " ", "\[ImaginaryI]", " ", 
     SubsuperscriptBox[
      StyleBox["\[Eta]0",
       FontWeight->Bold,
       FontColor->RGBColor[0, 0.5, 0]], "3", "+"]}], "+", 
    RowBox[{"48", " ", "\[ImaginaryI]", " ", 
     SqrtBox["3"], " ", 
     SubsuperscriptBox[
      StyleBox["\[Eta]0",
       FontWeight->Bold,
       FontColor->RGBColor[0, 0.5, 0]], "4", "+"]}], "-", 
    RowBox[{"288", " ", "\[ImaginaryI]", " ", 
     SqrtBox["3"], " ", 
     SubsuperscriptBox[
      OverscriptBox[
       StyleBox["\[Eta]0",
        FontWeight->Bold,
        FontColor->RGBColor[0, 0.5, 0]], 
       StyleBox["_",
        FontWeight->Bold,
        FontColor->RGBColor[0, 0.5, 0]]], "2", "-"]}], "+", 
    RowBox[{"288", " ", "\[ImaginaryI]", " ", 
     SubsuperscriptBox[
      OverscriptBox[
       StyleBox["\[Eta]0",
        FontWeight->Bold,
        FontColor->RGBColor[0, 0.5, 0]], 
       StyleBox["_",
        FontWeight->Bold,
        FontColor->RGBColor[0, 0.5, 0]]], "3", "-"]}], "-", 
    RowBox[{"48", " ", "\[ImaginaryI]", " ", 
     SqrtBox["3"], " ", 
     SubsuperscriptBox[
      OverscriptBox[
       StyleBox["\[Eta]0",
        FontWeight->Bold,
        FontColor->RGBColor[0, 0.5, 0]], 
       StyleBox["_",
        FontWeight->Bold,
        FontColor->RGBColor[0, 0.5, 0]]], "4", "-"]}]}], ")"}]}]], "Output",
 CellChangeTimes->{3.56224179350879*^9, 3.562245747119685*^9, 
  3.5623114571529818`*^9, 3.562920671176445*^9, 3.562934390470922*^9, 
  3.562935314101803*^9}]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"\[Delta]\[GothicCapitalT]", "=", 
   RowBox[{"(", 
    RowBox[{"\[Rho]2term", "+", "Wfinal"}], ")"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.5606874250043907`*^9, 3.560687499437274*^9}, 
   3.560706925764044*^9, {3.56070911178249*^9, 3.560709132857202*^9}, {
   3.560709165369998*^9, 3.560709172159676*^9}, 3.5614667495515213`*^9, {
   3.561467111748952*^9, 3.5614671129845247`*^9}, 3.5622417191077747`*^9, 
   3.56224575453164*^9, {3.5622459853519783`*^9, 3.562245986160754*^9}}],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"Normal", "@", 
    RowBox[{"Series", "[", 
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{
         FractionBox["1", 
          RowBox[{
           RowBox[{"T$uh", "[", 
            RowBox[{"1", ",", "1"}], "]"}], "[", "0", "]"}]], "/.", 
         "largevolume"}], "/.", "subJuk"}], "/.", 
       RowBox[{"leadweak", "[", "1", "]"}]}], ",", 
      RowBox[{"{", 
       RowBox[{"g", ",", "0", ",", "1"}], "}"}]}], "]"}]}], "//", 
   "Simplify"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"denom", "=", 
  RowBox[{
   RowBox[{
    RowBox[{"%", "/.", 
     RowBox[{
      RowBox[{
       RowBox[{"-", "1"}], "+", 
       RowBox[{"12", " ", 
        SuperscriptBox["u", "2"]}]}], "\[Rule]", 
      RowBox[{"12", " ", 
       SubscriptBox[
        StyleBox["\[ScriptU]",
         FontColor->RGBColor[0, 0, 0.2]], 
        RowBox[{"-", "v0"}]], " ", 
       SubscriptBox[
        StyleBox["\[ScriptU]",
         FontColor->RGBColor[0, 0, 0.2]], "v0"]}]}]}], "//", "funapartusu"}], 
   "//", "funreduceusu"}]}]}], "Input",
 CellChangeTimes->{{3.560687505641439*^9, 3.560687562759841*^9}, 
   3.5622567153939457`*^9, {3.562920692566614*^9, 3.5629207067342167`*^9}}],

Cell[BoxData[
 RowBox[{"1", "+", 
  FractionBox["1", 
   RowBox[{
    SqrtBox["3"], " ", 
    SubscriptBox[
     StyleBox["\[ScriptU]",
      FontColor->RGBColor[0, 0, 0.4]], 
     RowBox[{"-", "v0"}]]}]], "-", 
  FractionBox["1", 
   RowBox[{
    SqrtBox["3"], " ", 
    SubscriptBox[
     StyleBox["\[ScriptU]",
      FontColor->RGBColor[0, 0, 0.4]], "v0"]}]]}]], "Output",
 CellChangeTimes->{3.5629207073124027`*^9, 3.562935319038286*^9}]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"toint", "=", 
   RowBox[{"Collect", "[", 
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          FractionBox["1", 
           RowBox[{"-", 
            RowBox[{
             RowBox[{"\[ScriptU]$", "[", 
              RowBox[{"-", "v"}], "]"}], "[", "0", "]"}]}]], "-", 
          FractionBox["1", 
           RowBox[{
            RowBox[{"\[ScriptU]$", "[", "v", "]"}], "[", "0", "]"}]]}], ")"}], 
        RowBox[{"(", 
         RowBox[{
          RowBox[{
           RowBox[{"\[Delta]\[GothicCapitalT]", " ", "denom"}], "/.", 
           RowBox[{"Shift", "[", "1", "]"}]}], "/.", 
          RowBox[{"u", "\[Rule]", 
           RowBox[{"u", "+", 
            RowBox[{"\[ImaginaryI]", "/", "2"}]}]}]}], ")"}]}], "//", 
       "funapartusu"}], "//", "funreduceusu"}], ",", "canlist", ",", 
     "mhold"}], "]"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.5629207392377653`*^9, 3.562920745635557*^9}, {
   3.5629207810708103`*^9, 3.562920806988276*^9}, {3.5629208619164553`*^9, 
   3.5629208632183437`*^9}, 3.562920898441484*^9, {3.5629214612036257`*^9, 
   3.562921461561792*^9}, {3.562934418989482*^9, 3.5629344212100077`*^9}, 
   3.5629353225234423`*^9}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"FreeQ", "[", 
  RowBox[{
   RowBox[{"Extract", "[", 
    RowBox[{"toint", ",", 
     RowBox[{"Position", "[", 
      RowBox[{"toint", ",", 
       RowBox[{"mhold", "[", "__", "]"}]}], "]"}]}], "]"}], ",", 
   RowBox[{
    RowBox[{"\[ScriptU]$", "[", "_", "]"}], "[", "_", "]"}]}], "]"}]], "Input",\

 CellChangeTimes->{{3.562921443902677*^9, 3.562921451892888*^9}}],

Cell[BoxData["True"], "Output",
 CellChangeTimes->{{3.5629214407000113`*^9, 3.5629214661405087`*^9}, 
   3.562934428461934*^9, 3.5629353260140467`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"Extract", "[", 
      RowBox[{"toint", ",", 
       RowBox[{"Position", "[", 
        RowBox[{"toint", ",", 
         RowBox[{"mhold", "[", "__", "]"}]}], "]"}]}], "]"}], "/.", 
     RowBox[{"mhold", "\[Rule]", "Identity"}]}], "/.", "subZetas"}], "/.", 
   RowBox[{"v", "\[Rule]", 
    RowBox[{"Random", "[", "]"}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"NumberQ", "/@", "%"}], "//", "Union"}]}], "Input",
 CellChangeTimes->{{3.562920904303843*^9, 3.562920947282731*^9}, {
  3.5629344358135223`*^9, 3.5629344371250563`*^9}}],

Cell[BoxData[
 RowBox[{"{", "True", "}"}]], "Output",
 CellChangeTimes->{{3.5629209149358997`*^9, 3.562920947694973*^9}, 
   3.562921467635303*^9, {3.562934430649764*^9, 3.5629344375195217`*^9}, 
   3.5629353274604397`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"mrlt", "=", 
  RowBox[{"Collect", "[", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{
          RowBox[{
           RowBox[{
            RowBox[{
             RowBox[{
              RowBox[{
               RowBox[{
                RowBox[{"Collect", "[", 
                 RowBox[{"toint", ",", 
                  RowBox[{"mhold", "[", "__", "]"}], ",", 
                  RowBox[{
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"UpIntegrate", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    FractionBox["#", 
                    RowBox[{"2", "\[Pi]", " ", "\[ImaginaryI]"}]]}], "/.", 
                    RowBox[{"v", "\[Rule]", 
                    RowBox[{
                    RowBox[{"Re", "[", "v", "]"}], "+", 
                    RowBox[{"2", "\[ImaginaryI]"}]}]}]}], "/.", 
                    RowBox[{"u", "\[Rule]", 
                    RowBox[{"u", "-", 
                    RowBox[{"\[ImaginaryI]", " ", "\[Epsilon]"}]}]}]}], "/.", 
                    
                    RowBox[{"Shift", "[", 
                    RowBox[{
                    RowBox[{"-", "2"}], "\[Epsilon]"}], "]"}]}], "/.", 
                    "subusu"}], ",", "u"}], "]"}], "/.", 
                    RowBox[{
                    RowBox[{"Re", "[", "v", "]"}], "\[Rule]", 
                    RowBox[{"u", "-", 
                    RowBox[{"2", "\[ImaginaryI]"}]}]}]}], "/.", 
                    "EndSimplify"}], ")"}], "&"}]}], "]"}], "/.", 
                RowBox[{"mhold", "\[Rule]", "Identity"}]}], "/.", 
               RowBox[{"v", "\[Rule]", "u"}]}], "/.", 
              RowBox[{
               RowBox[{
                SuperscriptBox[
                 RowBox[{"(", 
                  RowBox[{"u", "-", 
                   FractionBox["\[ImaginaryI]", "2"]}], ")"}], "2"], "-", 
                FractionBox["1", "12"]}], "\[Rule]", 
               SuperscriptBox["Q0", "-"]}]}], "/.", 
             RowBox[{
              RowBox[{
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{"u", "+", 
                  FractionBox["\[ImaginaryI]", "2"]}], ")"}], "2"], "-", 
               FractionBox["1", "12"]}], "\[Rule]", 
              SuperscriptBox["Q0", "+"]}]}], "/.", 
            RowBox[{
             RowBox[{
              SuperscriptBox[
               RowBox[{"(", 
                RowBox[{
                 RowBox[{"-", "u"}], "+", 
                 FractionBox["\[ImaginaryI]", "2"]}], ")"}], "2"], "-", 
              FractionBox["1", "12"]}], "\[Rule]", 
             SuperscriptBox["Q0", "-"]}]}], "/.", 
           RowBox[{
            RowBox[{
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                RowBox[{"-", "u"}], "-", 
                FractionBox["\[ImaginaryI]", "2"]}], ")"}], "2"], "-", 
             FractionBox["1", "12"]}], "\[Rule]", 
            SuperscriptBox["Q0", "+"]}]}], "/.", 
          RowBox[{
           SuperscriptBox[
            RowBox[{"(", 
             RowBox[{
              RowBox[{"a_", " ", "u"}], "+", "b_."}], ")"}], 
            RowBox[{"r_", "/;", 
             RowBox[{"r", "<", "0"}]}]], "\[RuleDelayed]", 
           RowBox[{
            SuperscriptBox["a", "r"], 
            SuperscriptBox[
             RowBox[{"(", 
              RowBox[{"u", "+", 
               FractionBox["b", "a"]}], ")"}], "r"]}]}]}], "/.", "subtousu"}],
         "//", "funapartusu"}], "//", "funreduceusu"}], "//", 
      "FuntoMHZbasis"}], "//", "fundeperiod"}], ",", "canlist"}], 
   "]"}]}]], "Input",
 CellChangeTimes->{{3.562920956509347*^9, 3.5629209620374947`*^9}, {
  3.562920996577433*^9, 3.562921066443619*^9}, {3.562921169303233*^9, 
  3.562921209633106*^9}, {3.5629212639352007`*^9, 3.5629213392738333`*^9}, {
  3.562921400471404*^9, 3.562921404532564*^9}, {3.5629215164082317`*^9, 
  3.5629215461026897`*^9}, {3.562921590103962*^9, 3.5629215984783278`*^9}, {
  3.562922138262929*^9, 3.56292215087079*^9}, {3.562935332977416*^9, 
  3.562935333402154*^9}}],

Cell[BoxData[
 RowBox[{
  FractionBox[
   RowBox[{"36", " ", 
    SubscriptBox[
     StyleBox["\[Zeta]",
      FontWeight->Bold,
      FontColor->GrayLevel[0.4]], "2"]}], 
   SuperscriptBox[
    StyleBox["\[ScriptU]",
     FontColor->RGBColor[0, 0, 0.4]], "4"]], "+", 
  FractionBox[
   RowBox[{
    RowBox[{"216", " ", 
     SubscriptBox[
      StyleBox["\[Zeta]",
       FontWeight->Bold,
       FontColor->GrayLevel[0.4]], "2"]}], "-", 
    RowBox[{"144", " ", 
     SubsuperscriptBox[
      StyleBox["\[Zeta]",
       FontWeight->Bold,
       FontColor->GrayLevel[0.4]], "2", "2"]}]}], 
   SuperscriptBox[
    StyleBox["\[ScriptU]",
     FontColor->RGBColor[0, 0, 0.4]], "2"]], "+", 
  FractionBox[
   RowBox[{"144", " ", "\[ImaginaryI]", " ", 
    SubscriptBox[
     StyleBox["\[Zeta]",
      FontWeight->Bold,
      FontColor->GrayLevel[0.4]], "3"]}], 
   SuperscriptBox[
    StyleBox["\[ScriptU]",
     FontColor->RGBColor[0, 0, 0.4]], "3"]], "+", 
  FractionBox[
   RowBox[{
    RowBox[{
     RowBox[{"-", "81"}], " ", "\[ImaginaryI]"}], "+", 
    RowBox[{"540", " ", "\[ImaginaryI]", " ", 
     SubscriptBox[
      StyleBox["\[Zeta]",
       FontWeight->Bold,
       FontColor->GrayLevel[0.4]], "3"]}], "-", 
    RowBox[{"360", " ", "\[ImaginaryI]", " ", 
     SubscriptBox[
      StyleBox["\[Zeta]",
       FontWeight->Bold,
       FontColor->GrayLevel[0.4]], "5"]}]}], 
   StyleBox["\[ScriptU]",
    FontColor->RGBColor[0, 0, 0.4]]], "+", 
  FractionBox[
   RowBox[{
    RowBox[{
     RowBox[{"-", "81"}], " ", "\[ImaginaryI]"}], "+", 
    RowBox[{"108", " ", "\[ImaginaryI]", " ", 
     SubscriptBox[
      StyleBox["\[Zeta]",
       FontWeight->Bold,
       FontColor->GrayLevel[0.4]], "3"]}], "+", 
    RowBox[{"360", " ", "\[ImaginaryI]", " ", 
     SubscriptBox[
      StyleBox["\[Zeta]",
       FontWeight->Bold,
       FontColor->GrayLevel[0.4]], "5"]}]}], 
   SuperscriptBox[
    StyleBox["\[ScriptU]",
     FontColor->RGBColor[0, 0, 0.4]], 
    RowBox[{"[", "2", "]"}]]], "+", 
  FractionBox[
   RowBox[{
    RowBox[{"81", " ", "\[ImaginaryI]"}], "+", 
    RowBox[{"81", " ", 
     SqrtBox["3"]}], "-", 
    RowBox[{"108", " ", "\[ImaginaryI]", " ", 
     SubsuperscriptBox[
      StyleBox["\[Eta]0",
       FontWeight->Bold,
       FontColor->RGBColor[0, 0.5, 0]], "2", "+"]}], "+", 
    RowBox[{"36", " ", "\[ImaginaryI]", " ", 
     SqrtBox["3"], " ", 
     SubsuperscriptBox[
      StyleBox["\[Eta]0",
       FontWeight->Bold,
       FontColor->RGBColor[0, 0.5, 0]], "3", "+"]}], "-", 
    RowBox[{"18", " ", "\[ImaginaryI]", " ", 
     SubsuperscriptBox[
      StyleBox["\[Eta]0",
       FontWeight->Bold,
       FontColor->RGBColor[0, 0.5, 0]], "4", "+"]}]}], 
   SubsuperscriptBox[
    StyleBox["\[ScriptU]",
     FontColor->RGBColor[0, 0, 0.4]], 
    RowBox[{"-", "v0"}], "-"]], "+", 
  FractionBox[
   RowBox[{
    RowBox[{"108", " ", "\[ImaginaryI]", " ", 
     SubsuperscriptBox[
      StyleBox["\[Eta]0",
       FontWeight->Bold,
       FontColor->RGBColor[0, 0.5, 0]], "2", "+"]}], "-", 
    RowBox[{"36", " ", "\[ImaginaryI]", " ", 
     SqrtBox["3"], " ", 
     SubsuperscriptBox[
      StyleBox["\[Eta]0",
       FontWeight->Bold,
       FontColor->RGBColor[0, 0.5, 0]], "3", "+"]}], "+", 
    RowBox[{"18", " ", "\[ImaginaryI]", " ", 
     SubsuperscriptBox[
      StyleBox["\[Eta]0",
       FontWeight->Bold,
       FontColor->RGBColor[0, 0.5, 0]], "4", "+"]}]}], 
   SubsuperscriptBox[
    StyleBox["\[ScriptU]",
     FontColor->RGBColor[0, 0, 0.4]], 
    RowBox[{"-", "v0"}], "+"]], "+", 
  FractionBox[
   RowBox[{
    RowBox[{"81", " ", "\[ImaginaryI]"}], "-", 
    RowBox[{"81", " ", 
     SqrtBox["3"]}], "-", 
    RowBox[{"108", " ", "\[ImaginaryI]", " ", 
     SubsuperscriptBox[
      OverscriptBox[
       StyleBox["\[Eta]0",
        FontWeight->Bold,
        FontColor->RGBColor[0, 0.5, 0]], 
       StyleBox["_",
        FontWeight->Bold,
        FontColor->RGBColor[0, 0.5, 0]]], "2", "-"]}], "+", 
    RowBox[{"36", " ", "\[ImaginaryI]", " ", 
     SqrtBox["3"], " ", 
     SubsuperscriptBox[
      OverscriptBox[
       StyleBox["\[Eta]0",
        FontWeight->Bold,
        FontColor->RGBColor[0, 0.5, 0]], 
       StyleBox["_",
        FontWeight->Bold,
        FontColor->RGBColor[0, 0.5, 0]]], "3", "-"]}], "-", 
    RowBox[{"18", " ", "\[ImaginaryI]", " ", 
     SubsuperscriptBox[
      OverscriptBox[
       StyleBox["\[Eta]0",
        FontWeight->Bold,
        FontColor->RGBColor[0, 0.5, 0]], 
       StyleBox["_",
        FontWeight->Bold,
        FontColor->RGBColor[0, 0.5, 0]]], "4", "-"]}]}], 
   SubsuperscriptBox[
    StyleBox["\[ScriptU]",
     FontColor->RGBColor[0, 0, 0.4]], "v0", "-"]], "+", 
  FractionBox[
   RowBox[{
    RowBox[{"108", " ", "\[ImaginaryI]", " ", 
     SubsuperscriptBox[
      OverscriptBox[
       StyleBox["\[Eta]0",
        FontWeight->Bold,
        FontColor->RGBColor[0, 0.5, 0]], 
       StyleBox["_",
        FontWeight->Bold,
        FontColor->RGBColor[0, 0.5, 0]]], "2", "-"]}], "-", 
    RowBox[{"36", " ", "\[ImaginaryI]", " ", 
     SqrtBox["3"], " ", 
     SubsuperscriptBox[
      OverscriptBox[
       StyleBox["\[Eta]0",
        FontWeight->Bold,
        FontColor->RGBColor[0, 0.5, 0]], 
       StyleBox["_",
        FontWeight->Bold,
        FontColor->RGBColor[0, 0.5, 0]]], "3", "-"]}], "+", 
    RowBox[{"18", " ", "\[ImaginaryI]", " ", 
     SubsuperscriptBox[
      OverscriptBox[
       StyleBox["\[Eta]0",
        FontWeight->Bold,
        FontColor->RGBColor[0, 0.5, 0]], 
       StyleBox["_",
        FontWeight->Bold,
        FontColor->RGBColor[0, 0.5, 0]]], "4", "-"]}]}], 
   SubsuperscriptBox[
    StyleBox["\[ScriptU]",
     FontColor->RGBColor[0, 0, 0.4]], "v0", "+"]], "+", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     FractionBox["36", 
      SuperscriptBox[
       StyleBox["\[ScriptU]",
        FontColor->RGBColor[0, 0, 0.4]], "4"]], "+", 
     FractionBox["216", 
      SuperscriptBox[
       StyleBox["\[ScriptU]",
        FontColor->RGBColor[0, 0, 0.4]], "2"]], "+", 
     FractionBox[
      RowBox[{"108", " ", "\[ImaginaryI]"}], 
      SubsuperscriptBox[
       StyleBox["\[ScriptU]",
        FontColor->RGBColor[0, 0, 0.4]], 
       RowBox[{"-", "v0"}], "-"]], "-", 
     FractionBox[
      RowBox[{"108", " ", "\[ImaginaryI]"}], 
      SubsuperscriptBox[
       StyleBox["\[ScriptU]",
        FontColor->RGBColor[0, 0, 0.4]], 
       RowBox[{"-", "v0"}], "+"]], "+", 
     FractionBox[
      RowBox[{"108", " ", "\[ImaginaryI]"}], 
      SubsuperscriptBox[
       StyleBox["\[ScriptU]",
        FontColor->RGBColor[0, 0, 0.4]], "v0", "-"]], "-", 
     FractionBox[
      RowBox[{"108", " ", "\[ImaginaryI]"}], 
      SubsuperscriptBox[
       StyleBox["\[ScriptU]",
        FontColor->RGBColor[0, 0, 0.4]], "v0", "+"]], "+", 
     FractionBox[
      RowBox[{
       RowBox[{"54", " ", "\[ImaginaryI]"}], "-", 
       RowBox[{"216", " ", "\[ImaginaryI]", " ", 
        SubscriptBox[
         StyleBox["\[Zeta]",
          FontWeight->Bold,
          FontColor->GrayLevel[0.4]], "3"]}]}], 
      SuperscriptBox[
       StyleBox["\[ScriptU]",
        FontColor->RGBColor[0, 0, 0.4]], 
       RowBox[{"[", "2", "]"}]]], "+", 
     FractionBox[
      RowBox[{
       RowBox[{
        RowBox[{"-", "54"}], " ", "\[ImaginaryI]"}], "+", 
       RowBox[{"216", " ", "\[ImaginaryI]", " ", 
        SubscriptBox[
         StyleBox["\[Zeta]",
          FontWeight->Bold,
          FontColor->GrayLevel[0.4]], "3"]}]}], 
      StyleBox["\[ScriptU]",
       FontColor->RGBColor[0, 0, 0.4]]], "+", 
     RowBox[{"648", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3"]}]}], ")"}], " ", 
   SubsuperscriptBox[
    StyleBox["\[Eta]",
     FontWeight->Bold,
     FontColor->RGBColor[0.8, 0, 0]], "2", 
    RowBox[{"[", "2", "]"}]]}], "+", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     RowBox[{"-", 
      FractionBox["72", 
       SuperscriptBox[
        StyleBox["\[ScriptU]",
         FontColor->RGBColor[0, 0, 0.4]], "3"]]}], "-", 
     FractionBox["54", 
      StyleBox["\[ScriptU]",
       FontColor->RGBColor[0, 0, 0.4]]], "-", 
     FractionBox["54", 
      SuperscriptBox[
       StyleBox["\[ScriptU]",
        FontColor->RGBColor[0, 0, 0.4]], 
       RowBox[{"[", "2", "]"}]]], "-", 
     FractionBox[
      RowBox[{"36", " ", "\[ImaginaryI]", " ", 
       SqrtBox["3"]}], 
      SubsuperscriptBox[
       StyleBox["\[ScriptU]",
        FontColor->RGBColor[0, 0, 0.4]], 
       RowBox[{"-", "v0"}], "-"]], "+", 
     FractionBox[
      RowBox[{"36", " ", "\[ImaginaryI]", " ", 
       SqrtBox["3"]}], 
      SubsuperscriptBox[
       StyleBox["\[ScriptU]",
        FontColor->RGBColor[0, 0, 0.4]], 
       RowBox[{"-", "v0"}], "+"]], "+", 
     FractionBox[
      RowBox[{"36", " ", "\[ImaginaryI]", " ", 
       SqrtBox["3"]}], 
      SubsuperscriptBox[
       StyleBox["\[ScriptU]",
        FontColor->RGBColor[0, 0, 0.4]], "v0", "-"]], "-", 
     FractionBox[
      RowBox[{"36", " ", "\[ImaginaryI]", " ", 
       SqrtBox["3"]}], 
      SubsuperscriptBox[
       StyleBox["\[ScriptU]",
        FontColor->RGBColor[0, 0, 0.4]], "v0", "+"]]}], ")"}], " ", 
   SubsuperscriptBox[
    StyleBox["\[Eta]",
     FontWeight->Bold,
     FontColor->RGBColor[0.8, 0, 0]], "3", 
    RowBox[{"[", "2", "]"}]]}], "+", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     FractionBox["36", 
      SuperscriptBox[
       StyleBox["\[ScriptU]",
        FontColor->RGBColor[0, 0, 0.4]], "2"]], "+", 
     FractionBox[
      RowBox[{"18", " ", "\[ImaginaryI]"}], 
      SubsuperscriptBox[
       StyleBox["\[ScriptU]",
        FontColor->RGBColor[0, 0, 0.4]], 
       RowBox[{"-", "v0"}], "-"]], "-", 
     FractionBox[
      RowBox[{"18", " ", "\[ImaginaryI]"}], 
      SubsuperscriptBox[
       StyleBox["\[ScriptU]",
        FontColor->RGBColor[0, 0, 0.4]], 
       RowBox[{"-", "v0"}], "+"]], "+", 
     FractionBox[
      RowBox[{"18", " ", "\[ImaginaryI]"}], 
      SubsuperscriptBox[
       StyleBox["\[ScriptU]",
        FontColor->RGBColor[0, 0, 0.4]], "v0", "-"]], "-", 
     FractionBox[
      RowBox[{"18", " ", "\[ImaginaryI]"}], 
      SubsuperscriptBox[
       StyleBox["\[ScriptU]",
        FontColor->RGBColor[0, 0, 0.4]], "v0", "+"]]}], ")"}], " ", 
   SubsuperscriptBox[
    StyleBox["\[Eta]",
     FontWeight->Bold,
     FontColor->RGBColor[0.8, 0, 0]], "4", 
    RowBox[{"[", "2", "]"}]]}], "+", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     RowBox[{"108", " ", "\[ImaginaryI]"}], "-", 
     FractionBox["36", 
      StyleBox["\[ScriptU]",
       FontColor->RGBColor[0, 0, 0.4]]], "+", 
     FractionBox["36", 
      SuperscriptBox[
       StyleBox["\[ScriptU]",
        FontColor->RGBColor[0, 0, 0.4]], 
       RowBox[{"[", "2", "]"}]]]}], ")"}], " ", 
   SubsuperscriptBox[
    StyleBox["\[Eta]",
     FontWeight->Bold,
     FontColor->RGBColor[0.8, 0, 0]], 
    RowBox[{"2", ",", "3"}], 
    RowBox[{"[", "2", "]"}]]}], "+", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     RowBox[{
      RowBox[{"-", "108"}], " ", "\[ImaginaryI]"}], "+", 
     FractionBox["36", 
      StyleBox["\[ScriptU]",
       FontColor->RGBColor[0, 0, 0.4]]], "-", 
     FractionBox["36", 
      SuperscriptBox[
       StyleBox["\[ScriptU]",
        FontColor->RGBColor[0, 0, 0.4]], 
       RowBox[{"[", "2", "]"}]]]}], ")"}], " ", 
   SubsuperscriptBox[
    StyleBox["\[Eta]",
     FontWeight->Bold,
     FontColor->RGBColor[0.8, 0, 0]], 
    RowBox[{"3", ",", "2"}], 
    RowBox[{"[", "2", "]"}]]}]}]], "Output",
 CellChangeTimes->{3.562920964048346*^9, 3.562921049811014*^9, 
  3.562921089397249*^9, 3.562921184281979*^9, 3.562921228824486*^9, 
  3.562921324202135*^9, 3.562921359500703*^9, 3.56292143409015*^9, 
  3.56292150541737*^9, 3.562921575948886*^9, 3.562921627792246*^9, 
  3.562922180163509*^9, 3.562934474041424*^9, 3.562935365838181*^9}]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"mrltold", "=", 
   RowBox[{
    FractionBox[
     RowBox[{"36", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2"]}], 
     SuperscriptBox[
      StyleBox["\[ScriptU]",
       FontColor->RGBColor[0, 0, 0.2]], "4"]], "+", 
    FractionBox[
     RowBox[{
      RowBox[{"216", " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "2"]}], "-", 
      RowBox[{"144", " ", 
       SubsuperscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "2", "2"]}]}], 
     SuperscriptBox[
      StyleBox["\[ScriptU]",
       FontColor->RGBColor[0, 0, 0.2]], "2"]], "+", 
    FractionBox[
     RowBox[{"144", " ", "\[ImaginaryI]", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3"]}], 
     SuperscriptBox[
      StyleBox["\[ScriptU]",
       FontColor->RGBColor[0, 0, 0.2]], "3"]], "+", 
    FractionBox[
     RowBox[{
      RowBox[{
       RowBox[{"-", "81"}], " ", "\[ImaginaryI]"}], "+", 
      RowBox[{"540", " ", "\[ImaginaryI]", " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "3"]}], "-", 
      RowBox[{"360", " ", "\[ImaginaryI]", " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "5"]}]}], 
     StyleBox["\[ScriptU]",
      FontColor->RGBColor[0, 0, 0.2]]], "+", 
    FractionBox[
     RowBox[{
      RowBox[{
       RowBox[{"-", "81"}], " ", "\[ImaginaryI]"}], "+", 
      RowBox[{"108", " ", "\[ImaginaryI]", " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "3"]}], "+", 
      RowBox[{"360", " ", "\[ImaginaryI]", " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "5"]}]}], 
     SuperscriptBox[
      StyleBox["\[ScriptU]",
       FontColor->RGBColor[0, 0, 0.2]], 
      RowBox[{"[", "2", "]"}]]], "+", 
    FractionBox[
     RowBox[{
      RowBox[{"81", " ", "\[ImaginaryI]"}], "+", 
      RowBox[{"81", " ", 
       SqrtBox["3"]}], "-", 
      RowBox[{"108", " ", "\[ImaginaryI]", " ", 
       SubsuperscriptBox[
        StyleBox["\[Eta]0",
         FontWeight->Bold,
         FontColor->RGBColor[0, 0.5, 0]], "2", "+"]}], "+", 
      RowBox[{"36", " ", "\[ImaginaryI]", " ", 
       SqrtBox["3"], " ", 
       SubsuperscriptBox[
        StyleBox["\[Eta]0",
         FontWeight->Bold,
         FontColor->RGBColor[0, 0.5, 0]], "3", "+"]}], "-", 
      RowBox[{"18", " ", "\[ImaginaryI]", " ", 
       SubsuperscriptBox[
        StyleBox["\[Eta]0",
         FontWeight->Bold,
         FontColor->RGBColor[0, 0.5, 0]], "4", "+"]}]}], 
     SubsuperscriptBox[
      StyleBox["\[ScriptU]",
       FontColor->RGBColor[0, 0, 0.2]], 
      RowBox[{"-", "v0"}], "-"]], "+", 
    FractionBox[
     RowBox[{
      RowBox[{"108", " ", "\[ImaginaryI]", " ", 
       SubsuperscriptBox[
        StyleBox["\[Eta]0",
         FontWeight->Bold,
         FontColor->RGBColor[0, 0.5, 0]], "2", "+"]}], "-", 
      RowBox[{"36", " ", "\[ImaginaryI]", " ", 
       SqrtBox["3"], " ", 
       SubsuperscriptBox[
        StyleBox["\[Eta]0",
         FontWeight->Bold,
         FontColor->RGBColor[0, 0.5, 0]], "3", "+"]}], "+", 
      RowBox[{"18", " ", "\[ImaginaryI]", " ", 
       SubsuperscriptBox[
        StyleBox["\[Eta]0",
         FontWeight->Bold,
         FontColor->RGBColor[0, 0.5, 0]], "4", "+"]}]}], 
     SubsuperscriptBox[
      StyleBox["\[ScriptU]",
       FontColor->RGBColor[0, 0, 0.2]], 
      RowBox[{"-", "v0"}], "+"]], "+", 
    FractionBox[
     RowBox[{
      RowBox[{"81", " ", "\[ImaginaryI]"}], "-", 
      RowBox[{"81", " ", 
       SqrtBox["3"]}], "-", 
      RowBox[{"108", " ", "\[ImaginaryI]", " ", 
       SubsuperscriptBox[
        OverscriptBox[
         StyleBox["\[Eta]0",
          FontWeight->Bold,
          FontColor->RGBColor[0, 0.5, 0]], 
         StyleBox["_",
          FontWeight->Bold,
          FontColor->RGBColor[0, 0.5, 0]]], "2", "-"]}], "+", 
      RowBox[{"36", " ", "\[ImaginaryI]", " ", 
       SqrtBox["3"], " ", 
       SubsuperscriptBox[
        OverscriptBox[
         StyleBox["\[Eta]0",
          FontWeight->Bold,
          FontColor->RGBColor[0, 0.5, 0]], 
         StyleBox["_",
          FontWeight->Bold,
          FontColor->RGBColor[0, 0.5, 0]]], "3", "-"]}], "-", 
      RowBox[{"18", " ", "\[ImaginaryI]", " ", 
       SubsuperscriptBox[
        OverscriptBox[
         StyleBox["\[Eta]0",
          FontWeight->Bold,
          FontColor->RGBColor[0, 0.5, 0]], 
         StyleBox["_",
          FontWeight->Bold,
          FontColor->RGBColor[0, 0.5, 0]]], "4", "-"]}]}], 
     SubsuperscriptBox[
      StyleBox["\[ScriptU]",
       FontColor->RGBColor[0, 0, 0.2]], "v0", "-"]], "+", 
    FractionBox[
     RowBox[{
      RowBox[{"108", " ", "\[ImaginaryI]", " ", 
       SubsuperscriptBox[
        OverscriptBox[
         StyleBox["\[Eta]0",
          FontWeight->Bold,
          FontColor->RGBColor[0, 0.5, 0]], 
         StyleBox["_",
          FontWeight->Bold,
          FontColor->RGBColor[0, 0.5, 0]]], "2", "-"]}], "-", 
      RowBox[{"36", " ", "\[ImaginaryI]", " ", 
       SqrtBox["3"], " ", 
       SubsuperscriptBox[
        OverscriptBox[
         StyleBox["\[Eta]0",
          FontWeight->Bold,
          FontColor->RGBColor[0, 0.5, 0]], 
         StyleBox["_",
          FontWeight->Bold,
          FontColor->RGBColor[0, 0.5, 0]]], "3", "-"]}], "+", 
      RowBox[{"18", " ", "\[ImaginaryI]", " ", 
       SubsuperscriptBox[
        OverscriptBox[
         StyleBox["\[Eta]0",
          FontWeight->Bold,
          FontColor->RGBColor[0, 0.5, 0]], 
         StyleBox["_",
          FontWeight->Bold,
          FontColor->RGBColor[0, 0.5, 0]]], "4", "-"]}]}], 
     SubsuperscriptBox[
      StyleBox["\[ScriptU]",
       FontColor->RGBColor[0, 0, 0.2]], "v0", "+"]], "+", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       FractionBox["36", 
        SuperscriptBox[
         StyleBox["\[ScriptU]",
          FontColor->RGBColor[0, 0, 0.2]], "4"]], "+", 
       FractionBox["216", 
        SuperscriptBox[
         StyleBox["\[ScriptU]",
          FontColor->RGBColor[0, 0, 0.2]], "2"]], "+", 
       FractionBox[
        RowBox[{"108", " ", "\[ImaginaryI]"}], 
        SubsuperscriptBox[
         StyleBox["\[ScriptU]",
          FontColor->RGBColor[0, 0, 0.2]], 
         RowBox[{"-", "v0"}], "-"]], "-", 
       FractionBox[
        RowBox[{"108", " ", "\[ImaginaryI]"}], 
        SubsuperscriptBox[
         StyleBox["\[ScriptU]",
          FontColor->RGBColor[0, 0, 0.2]], 
         RowBox[{"-", "v0"}], "+"]], "+", 
       FractionBox[
        RowBox[{"108", " ", "\[ImaginaryI]"}], 
        SubsuperscriptBox[
         StyleBox["\[ScriptU]",
          FontColor->RGBColor[0, 0, 0.2]], "v0", "-"]], "-", 
       FractionBox[
        RowBox[{"108", " ", "\[ImaginaryI]"}], 
        SubsuperscriptBox[
         StyleBox["\[ScriptU]",
          FontColor->RGBColor[0, 0, 0.2]], "v0", "+"]], "+", 
       FractionBox[
        RowBox[{
         RowBox[{"54", " ", "\[ImaginaryI]"}], "-", 
         RowBox[{"216", " ", "\[ImaginaryI]", " ", 
          SubscriptBox[
           StyleBox["\[Zeta]",
            FontWeight->Bold,
            FontColor->GrayLevel[0.4]], "3"]}]}], 
        SuperscriptBox[
         StyleBox["\[ScriptU]",
          FontColor->RGBColor[0, 0, 0.2]], 
         RowBox[{"[", "2", "]"}]]], "+", 
       FractionBox[
        RowBox[{
         RowBox[{
          RowBox[{"-", "54"}], " ", "\[ImaginaryI]"}], "+", 
         RowBox[{"216", " ", "\[ImaginaryI]", " ", 
          SubscriptBox[
           StyleBox["\[Zeta]",
            FontWeight->Bold,
            FontColor->GrayLevel[0.4]], "3"]}]}], 
        StyleBox["\[ScriptU]",
         FontColor->RGBColor[0, 0, 0.2]]], "+", 
       RowBox[{"648", " ", 
        SubscriptBox[
         StyleBox["\[Zeta]",
          FontWeight->Bold,
          FontColor->GrayLevel[0.4]], "3"]}]}], ")"}], " ", 
     SubsuperscriptBox[
      StyleBox["\[Eta]",
       FontWeight->Bold,
       FontColor->RGBColor[0.8, 0, 0]], "2", 
      RowBox[{"[", "2", "]"}]]}], "+", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{"-", 
        FractionBox["72", 
         SuperscriptBox[
          StyleBox["\[ScriptU]",
           FontColor->RGBColor[0, 0, 0.2]], "3"]]}], "-", 
       FractionBox["54", 
        StyleBox["\[ScriptU]",
         FontColor->RGBColor[0, 0, 0.2]]], "-", 
       FractionBox["54", 
        SuperscriptBox[
         StyleBox["\[ScriptU]",
          FontColor->RGBColor[0, 0, 0.2]], 
         RowBox[{"[", "2", "]"}]]], "-", 
       FractionBox[
        RowBox[{"36", " ", "\[ImaginaryI]", " ", 
         SqrtBox["3"]}], 
        SubsuperscriptBox[
         StyleBox["\[ScriptU]",
          FontColor->RGBColor[0, 0, 0.2]], 
         RowBox[{"-", "v0"}], "-"]], "+", 
       FractionBox[
        RowBox[{"36", " ", "\[ImaginaryI]", " ", 
         SqrtBox["3"]}], 
        SubsuperscriptBox[
         StyleBox["\[ScriptU]",
          FontColor->RGBColor[0, 0, 0.2]], 
         RowBox[{"-", "v0"}], "+"]], "+", 
       FractionBox[
        RowBox[{"36", " ", "\[ImaginaryI]", " ", 
         SqrtBox["3"]}], 
        SubsuperscriptBox[
         StyleBox["\[ScriptU]",
          FontColor->RGBColor[0, 0, 0.2]], "v0", "-"]], "-", 
       FractionBox[
        RowBox[{"36", " ", "\[ImaginaryI]", " ", 
         SqrtBox["3"]}], 
        SubsuperscriptBox[
         StyleBox["\[ScriptU]",
          FontColor->RGBColor[0, 0, 0.2]], "v0", "+"]]}], ")"}], " ", 
     SubsuperscriptBox[
      StyleBox["\[Eta]",
       FontWeight->Bold,
       FontColor->RGBColor[0.8, 0, 0]], "3", 
      RowBox[{"[", "2", "]"}]]}], "+", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       FractionBox["36", 
        SuperscriptBox[
         StyleBox["\[ScriptU]",
          FontColor->RGBColor[0, 0, 0.2]], "2"]], "+", 
       FractionBox[
        RowBox[{"18", " ", "\[ImaginaryI]"}], 
        SubsuperscriptBox[
         StyleBox["\[ScriptU]",
          FontColor->RGBColor[0, 0, 0.2]], 
         RowBox[{"-", "v0"}], "-"]], "-", 
       FractionBox[
        RowBox[{"18", " ", "\[ImaginaryI]"}], 
        SubsuperscriptBox[
         StyleBox["\[ScriptU]",
          FontColor->RGBColor[0, 0, 0.2]], 
         RowBox[{"-", "v0"}], "+"]], "+", 
       FractionBox[
        RowBox[{"18", " ", "\[ImaginaryI]"}], 
        SubsuperscriptBox[
         StyleBox["\[ScriptU]",
          FontColor->RGBColor[0, 0, 0.2]], "v0", "-"]], "-", 
       FractionBox[
        RowBox[{"18", " ", "\[ImaginaryI]"}], 
        SubsuperscriptBox[
         StyleBox["\[ScriptU]",
          FontColor->RGBColor[0, 0, 0.2]], "v0", "+"]]}], ")"}], " ", 
     SubsuperscriptBox[
      StyleBox["\[Eta]",
       FontWeight->Bold,
       FontColor->RGBColor[0.8, 0, 0]], "4", 
      RowBox[{"[", "2", "]"}]]}], "+", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{"108", " ", "\[ImaginaryI]"}], "-", 
       FractionBox["36", 
        StyleBox["\[ScriptU]",
         FontColor->RGBColor[0, 0, 0.2]]], "+", 
       FractionBox["36", 
        SuperscriptBox[
         StyleBox["\[ScriptU]",
          FontColor->RGBColor[0, 0, 0.2]], 
         RowBox[{"[", "2", "]"}]]]}], ")"}], " ", 
     SubsuperscriptBox[
      StyleBox["\[Eta]",
       FontWeight->Bold,
       FontColor->RGBColor[0.8, 0, 0]], 
      RowBox[{"2", ",", "3"}], 
      RowBox[{"[", "2", "]"}]]}], "+", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{
        RowBox[{"-", "108"}], " ", "\[ImaginaryI]"}], "+", 
       FractionBox["36", 
        StyleBox["\[ScriptU]",
         FontColor->RGBColor[0, 0, 0.2]]], "-", 
       FractionBox["36", 
        SuperscriptBox[
         StyleBox["\[ScriptU]",
          FontColor->RGBColor[0, 0, 0.2]], 
         RowBox[{"[", "2", "]"}]]]}], ")"}], " ", 
     SubsuperscriptBox[
      StyleBox["\[Eta]",
       FontWeight->Bold,
       FontColor->RGBColor[0.8, 0, 0]], 
      RowBox[{"3", ",", "2"}], 
      RowBox[{"[", "2", "]"}]]}]}]}], ";"}]], "Input",
 CellChangeTimes->{{3.562921672264619*^9, 3.562921676065593*^9}, {
  3.5629353594739437`*^9, 3.5629353610108643`*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"mrlt", "-", "mrltold"}]], "Input",
 CellChangeTimes->{{3.562921677397872*^9, 3.562921708842979*^9}, {
  3.5629220417031*^9, 3.562922055919012*^9}, {3.5629353688281097`*^9, 
  3.56293538700079*^9}}],

Cell[BoxData["0"], "Output",
 CellChangeTimes->{{3.562921681673429*^9, 3.5629217095008307`*^9}, {
  3.562922046423834*^9, 3.5629220564718323`*^9}, {3.562935373434146*^9, 
  3.5629353872631063`*^9}}]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"Log", "[", 
   SubscriptBox[
    RowBox[{"(", 
     OverscriptBox[
      StyleBox["h",
       FontColor->RGBColor[0, 0.6, 0]], 
      StyleBox["^",
       FontColor->RGBColor[0, 0.6, 0]]], ")"}], "r"], "]"}], "\[Equal]", 
  RowBox[{
   RowBox[{"const", " ", 
    SuperscriptBox["g", "8"]}], "+", 
   RowBox[{
    RowBox[{"O", "[", 
     SuperscriptBox["g", "10"], "]"}], "  ", 
    RowBox[{"(", 
     RowBox[{"conclusion", ":", " ", 
      RowBox[{
      "it", " ", "is", " ", "irrelevant", " ", "for", " ", "leading", " ", 
       "double", " ", "sc", " ", "of", " ", "U"}]}], 
     ")"}]}]}]}]], "Subsection",
 CellChangeTimes->{{3.552193297070553*^9, 3.5521933034819736`*^9}, {
  3.552205941187338*^9, 3.5522059414016953`*^9}, {3.5523672032119102`*^9, 
  3.552367210500926*^9}, {3.553772156125369*^9, 3.553772174865464*^9}, {
  3.553775562934312*^9, 3.553775563607533*^9}, {3.555874071749701*^9, 
  3.5558741029420433`*^9}, {3.555957685930942*^9, 3.5559577071023817`*^9}, {
  3.56085298655398*^9, 3.5608530379889*^9}, {3.560856546890081*^9, 
  3.560856549055603*^9}, {3.5614695317855062`*^9, 3.5614695412408857`*^9}, {
  3.562935485611362*^9, 3.562935543585163*^9}}],

Cell[CellGroupData[{

Cell["Init", "Subsubsection",
 CellChangeTimes->{{3.562936411626652*^9, 3.562936412043545*^9}}],

Cell[TextData[{
 "Asymptotically one found (up to an overall constant ",
 Cell[BoxData[
  FormBox[
   RowBox[{
    SubscriptBox["hh", "as"], "=", 
    RowBox[{
     SubscriptBox["\[Sigma]", "1"], 
     SuperscriptBox["xh", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{
         RowBox[{"-", "L"}], "/", "2"}], "-", "1"}], "}"}]]}]}], 
   TraditionalForm]]],
 "."
}], "Text",
 CellChangeTimes->{{3.552193343869741*^9, 3.552193372875533*^9}}],

Cell["We hence have to compute", "Text",
 CellChangeTimes->{{3.552193376010419*^9, 3.5521933786827497`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Log", "[", 
   SubscriptBox[
    RowBox[{"(", "h", ")"}], "r"], "]"}], "==", 
  RowBox[{"Log", "[", " ", 
   FractionBox[
    RowBox[{
     OverscriptBox[
      StyleBox["h",
       FontColor->RGBColor[0, 0.6, 0]], 
      StyleBox["^",
       FontColor->RGBColor[0, 0.6, 0]]], " ", 
     SuperscriptBox[
      OverscriptBox[
       StyleBox["x",
        FontColor->RGBColor[0, 0.6, 0]], 
       StyleBox["^",
        FontColor->RGBColor[0, 0.6, 0]]], 
      RowBox[{
       FractionBox["L", "2"], "+", "1"}]]}], 
    SubscriptBox["\[Sigma]", "1"]], "]"}], "==", 
  RowBox[{"\[ScriptCapitalZ]", "*", 
   RowBox[{"Log", "[", 
    SubscriptBox[
     RowBox[{"(", 
      FractionBox[
       RowBox[{
        SuperscriptBox[
         StyleBox["\[ScriptCapitalF]",
          FontColor->RGBColor[0, 0.6, 0]], "+"], 
        RowBox[{"(", 
         RowBox[{"1", "-", 
          RowBox[{
           SubscriptBox["Y", 
            RowBox[{"1", ",", "1"}]], 
           SubscriptBox["Y", 
            RowBox[{"2", ",", "2"}]]}]}], ")"}]}], "\[Rho]"], ")"}], "r"], 
    "]"}]}]}]], "Input",
 CellChangeTimes->{{3.5479657623344088`*^9, 3.5479658621787853`*^9}, {
   3.547965923675784*^9, 3.5479659385131187`*^9}, 3.5521933809999647`*^9, {
   3.5629356795425262`*^9, 3.562935705007962*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"\[ScriptCapitalZ]", "=", 
   RowBox[{
    RowBox[{
     RowBox[{"-", 
      FractionBox["1", 
       RowBox[{"2", "\[Pi]", " ", "\[ImaginaryI]"}]]}], 
     FractionBox[
      SqrtBox[
       RowBox[{
        RowBox[{"4", 
         SuperscriptBox["g", "2"]}], "-", 
        SuperscriptBox["u", "2"]}]], 
      SqrtBox[
       RowBox[{
        RowBox[{"4", 
         SuperscriptBox["g", "2"]}], "-", 
        SuperscriptBox["v", "2"]}]]], 
     FractionBox["1", 
      RowBox[{"u", "-", "v"}]], 
     RowBox[{"\[DifferentialD]", "v"}]}], "==", 
    RowBox[{
     RowBox[{"-", 
      FractionBox["1", 
       RowBox[{"2", "\[Pi]", " ", "\[ImaginaryI]"}]]}], 
     FractionBox[
      SqrtBox[
       RowBox[{
        RowBox[{"4", 
         SuperscriptBox["g", "2"]}], "-", 
        SuperscriptBox["u", "2"]}]], 
      SqrtBox[
       RowBox[{"1", "-", 
        SuperscriptBox["z", "2"]}]]], 
     FractionBox["1", 
      RowBox[{"u", "-", 
       RowBox[{"2", "g", " ", "z"}]}]], 
     RowBox[{"\[DifferentialD]", "z"}]}]}]}], " ", 
  RowBox[{"(*", " ", 
   RowBox[{"ordinary", " ", "regimve"}], " ", "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{"\[ScriptCapitalZ]", "=", 
  RowBox[{
   RowBox[{"-", 
    FractionBox["1", 
     RowBox[{"2", "\[Pi]", " ", "\[ImaginaryI]"}]]}], 
   FractionBox[
    SqrtBox[
     RowBox[{"1", "-", 
      SuperscriptBox["w", "2"]}]], 
    SqrtBox[
     RowBox[{"1", "-", 
      SuperscriptBox["z", "2"]}]]], 
   FractionBox["1", 
    RowBox[{"w", "-", "z"}]], 
   RowBox[{"\[DifferentialD]", "z"}]}]}]}], "Input",
 CellChangeTimes->{{3.552193605054901*^9, 3.5521936258780107`*^9}, {
  3.562935729981923*^9, 3.562935792378386*^9}}],

Cell[TextData[{
 "The integrand should be definitely computed in the double scaling regime. \
We first compute the integrand, and then apply \[ScriptCapitalZ] in ordinary \
and double scaling regime. Note that the order of magnitude in g of the \
answer is the same in both regimes. This is something specific about \
Zhukowsky kernel. Moreover, ",
 Cell[BoxData[
  FormBox[
   RowBox[{
    RowBox[{"\[ScriptCapitalZ]", "*", "const"}], "=", 
    RowBox[{
     FractionBox["1", "2"], "const"}]}], TraditionalForm]]],
 ", and of course this statement does not depend on the regime.  Since we are \
interesting only in the ratio ",
 Cell[BoxData[
  FormBox[
   RowBox[{
    SubscriptBox[
     RowBox[{"hh", "[", "2", "]"}], "r"], "/", 
    SubscriptBox[
     RowBox[{"hh", "[", "0", "]"}], "r"]}], TraditionalForm]],
  FormatType->"TraditionalForm"],
 ", we hence don\[CloseCurlyQuote]t care about overall normalization of ",
 Cell[BoxData[
  SubscriptBox[
   RowBox[{"(", 
    FractionBox[
     RowBox[{
      SuperscriptBox[
       StyleBox["\[ScriptCapitalF]",
        FontColor->RGBColor[0, 0.6, 0]], "+"], 
      RowBox[{"(", 
       RowBox[{"1", "-", 
        RowBox[{
         SubscriptBox["Y", 
          RowBox[{"1", ",", "1"}]], 
         SubscriptBox["Y", 
          RowBox[{"2", ",", "2"}]]}]}], ")"}]}], "\[Rho]"], ")"}], "r"]],
  CellChangeTimes->{{3.5479657623344088`*^9, 3.5479658621787853`*^9}, {
    3.547965923675784*^9, 3.5479659385131187`*^9}, 3.5521933809999647`*^9}],
 "."
}], "Text",
 CellChangeTimes->{{3.562935725635132*^9, 3.562935728351912*^9}, {
  3.5629358040366087`*^9, 3.56293595350054*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 "Contribution from ",
 Cell[BoxData[
  FormBox[
   RowBox[{"Log", "[", 
    RowBox[{
     FractionBox["1", "\[Rho]"], "/", 
     FractionBox["1", 
      SubscriptBox["\[Rho]", "asym"]]}], "]"}], TraditionalForm]]]
}], "Subsubsection",
 CellChangeTimes->{{3.552194573693015*^9, 3.552194586631557*^9}, {
  3.552195423782762*^9, 3.552195423851169*^9}, {3.5558723898227663`*^9, 
  3.555872393032803*^9}, {3.555873196517317*^9, 3.555873196727844*^9}, {
  3.560854916011812*^9, 3.560854917941217*^9}, {3.5629370657237186`*^9, 
  3.5629370658899813`*^9}}],

Cell["We remind that ", "Text",
 CellChangeTimes->{{3.552194594181669*^9, 3.5521945964423313`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Log", "[", 
   RowBox[{
    FractionBox["1", "\[Rho]"], "/", 
    FractionBox["1", 
     SubscriptBox["\[Rho]", "asym"]]}], "]"}], "=", 
  RowBox[{"-", 
   FractionBox["\[Delta]\[Rho]", "\[Rho]"]}]}]], "Input",
 CellChangeTimes->{{3.555872400095169*^9, 3.5558724267038918`*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"tmp1", "=", 
  RowBox[{
   RowBox[{
    RowBox[{"Series", "[", 
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{"-", "1"}], "/", "\[Rho]"}], ")"}], "/.", "largevolume"}],
          "/.", "subJuk"}], "/.", 
        RowBox[{"u", "\[Rule]", 
         RowBox[{"2", "g", " ", "z"}]}]}], "/.", 
       RowBox[{"leadweak", "[", "4", "]"}]}], ",", 
      RowBox[{"{", 
       RowBox[{"g", ",", "0", ",", "4"}], "}"}]}], "]"}], "//", "Simplify"}], 
   "//", "Normal"}]}]], "Input",
 CellChangeTimes->{{3.5558724117023087`*^9, 3.555872463926442*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"-", 
   FractionBox["1", 
    RowBox[{"2", " ", "g", " ", 
     SqrtBox[
      RowBox[{"1", "-", 
       SuperscriptBox["z", "2"]}]]}]]}], "-", 
  FractionBox[
   RowBox[{"3", " ", "g"}], 
   RowBox[{"2", " ", 
    SqrtBox[
     RowBox[{"1", "-", 
      SuperscriptBox["z", "2"]}]]}]], "+", 
  FractionBox[
   RowBox[{"6", " ", 
    SuperscriptBox["g", "3"]}], 
   SqrtBox[
    RowBox[{"1", "-", 
     SuperscriptBox["z", "2"]}]]]}]], "Output",
 CellChangeTimes->{
  3.555872415987401*^9, {3.555872452556671*^9, 3.5558724643872223`*^9}, 
   3.56033683512888*^9, 3.56085360549223*^9, 3.5629359717080517`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"tmp2", "=", 
  RowBox[{
   RowBox[{
    RowBox[{
     SuperscriptBox["g", "9"], 
     RowBox[{"(", 
      RowBox[{
       SubscriptBox["\[Delta]\[Rho]", "lead"], "+", 
       RowBox[{
        SuperscriptBox["g", "2"], 
        SubscriptBox["\[Delta]\[Rho]", "sublead"]}], "+", 
       RowBox[{
        SuperscriptBox["g", "4"], 
        SubscriptBox["\[Delta]\[Rho]", "sublead2"]}]}], ")"}]}], "/.", 
    "sub\[Rho]Ansatz"}], "/.", 
   RowBox[{"(", 
    RowBox[{"Rule", "@@@", 
     RowBox[{"Cases", "[", 
      RowBox[{
       RowBox[{"solut\[Rho]s", "/.", 
        RowBox[{"Rule", "\[Rule]", "List"}]}], ",", 
       RowBox[{"List", "[", 
        RowBox[{"a_", ",", "0"}], "]"}]}], "]"}]}], ")"}]}]}]], "Input",
 CellChangeTimes->{{3.5558725197330837`*^9, 3.555872556548987*^9}, {
  3.5558726634967213`*^9, 3.5558726647033777`*^9}, {3.555872704013234*^9, 
  3.555872705004931*^9}}],

Cell[BoxData[
 RowBox[{
  SuperscriptBox["g", "9"], " ", 
  RowBox[{"(", 
   RowBox[{
    RowBox[{
     SqrtBox[
      RowBox[{"1", "-", 
       SuperscriptBox["z", "2"]}]], " ", 
     RowBox[{
      SubscriptBox["\[Beta]", "lead"], "[", "0", "]"}]}], "+", 
    RowBox[{
     SuperscriptBox["g", "2"], " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{
        SqrtBox[
         RowBox[{"1", "-", 
          SuperscriptBox["z", "2"]}]], " ", 
        RowBox[{
         SubscriptBox["\[Beta]", "sublead"], "[", "0", "]"}]}], "+", 
       RowBox[{
        SuperscriptBox["z", "2"], " ", 
        SqrtBox[
         RowBox[{"1", "-", 
          SuperscriptBox["z", "2"]}]], " ", 
        RowBox[{
         SubscriptBox["\[Beta]", "sublead"], "[", "1", "]"}]}]}], ")"}]}], 
    "+", 
    RowBox[{
     SuperscriptBox["g", "4"], " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{
        SqrtBox[
         RowBox[{"1", "-", 
          SuperscriptBox["z", "2"]}]], " ", 
        RowBox[{
         SubscriptBox["\[Beta]", "sublead2"], "[", "0", "]"}]}], "+", 
       RowBox[{
        SuperscriptBox["z", "2"], " ", 
        SqrtBox[
         RowBox[{"1", "-", 
          SuperscriptBox["z", "2"]}]], " ", 
        RowBox[{
         SubscriptBox["\[Beta]", "sublead2"], "[", "1", "]"}]}], "+", 
       RowBox[{
        SuperscriptBox["z", "4"], " ", 
        SqrtBox[
         RowBox[{"1", "-", 
          SuperscriptBox["z", "2"]}]], " ", 
        RowBox[{
         SubscriptBox["\[Beta]", "sublead2"], "[", "2", "]"}]}]}], ")"}]}]}], 
   ")"}]}]], "Output",
 CellChangeTimes->{3.5558725573989573`*^9, 3.5558726658679647`*^9, 
  3.555872708268715*^9, 3.560336836343897*^9, 3.560853610981257*^9, 
  3.562935972561295*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"precon\[Rho]", "=", " ", 
  RowBox[{"Normal", "@", 
   RowBox[{"Series", "[", 
    RowBox[{
     RowBox[{"tmp1", " ", "tmp2"}], ",", 
     RowBox[{"{", 
      RowBox[{"g", ",", "0", ",", "10"}], "}"}]}], "]"}]}]}]], "Input",
 CellChangeTimes->{{3.560853632685874*^9, 3.560853670726804*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"-", 
    FractionBox["1", "2"]}], " ", 
   SuperscriptBox["g", "8"], " ", 
   RowBox[{
    SubscriptBox["\[Beta]", "lead"], "[", "0", "]"}]}], "+", 
  RowBox[{
   FractionBox["1", "2"], " ", 
   SuperscriptBox["g", "10"], " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{
      RowBox[{"-", "3"}], " ", 
      RowBox[{
       SubscriptBox["\[Beta]", "lead"], "[", "0", "]"}]}], "-", 
     RowBox[{
      SubscriptBox["\[Beta]", "sublead"], "[", "0", "]"}], "-", 
     RowBox[{
      SuperscriptBox["z", "2"], " ", 
      RowBox[{
       SubscriptBox["\[Beta]", "sublead"], "[", "1", "]"}]}]}], 
    ")"}]}]}]], "Output",
 CellChangeTimes->{{3.5608536544725237`*^9, 3.5608536711173363`*^9}, 
   3.562935974152958*^9}]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 "Contribution from ",
 Cell[BoxData[
  FormBox[
   RowBox[{"Log", "[", 
    FractionBox[
     RowBox[{"1", "-", 
      RowBox[{
       SubscriptBox["Y", 
        RowBox[{"1", ",", "1"}]], 
       SubscriptBox["Y", 
        RowBox[{"2", ",", "2"}]]}]}], 
     SubscriptBox[
      RowBox[{"(", 
       RowBox[{"1", "-", 
        RowBox[{
         SubscriptBox["Y", 
          RowBox[{"1", ",", "1"}]], 
         SubscriptBox["Y", 
          RowBox[{"2", ",", "2"}]]}]}], ")"}], "asym"]], "]"}], 
   TraditionalForm]]]
}], "Subsubsection",
 CellChangeTimes->{{3.552194573693015*^9, 3.552194586631557*^9}, {
  3.552195423782762*^9, 3.552195451528096*^9}, {3.555874053686809*^9, 
  3.555874057466106*^9}, {3.5608549217622538`*^9, 3.560854921762404*^9}, {
  3.5629360219227753`*^9, 3.562936021922933*^9}, {3.562937063860057*^9, 
  3.5629370644449177`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Log", "[", 
   FractionBox[
    RowBox[{"1", "-", 
     RowBox[{
      SubscriptBox["Y", 
       RowBox[{"1", ",", "1"}]], 
      SubscriptBox["Y", 
       RowBox[{"2", ",", "2"}]]}]}], 
    SubscriptBox[
     RowBox[{"(", 
      RowBox[{"1", "-", 
       RowBox[{
        SubscriptBox["Y", 
         RowBox[{"1", ",", "1"}]], 
        SubscriptBox["Y", 
         RowBox[{"2", ",", "2"}]]}]}], ")"}], "asym"]], "]"}], "\[Equal]", 
  RowBox[{"Log", "[", 
   FractionBox[
    RowBox[{"1", "-", 
     RowBox[{"Y11Y22as", 
      RowBox[{"(", 
       RowBox[{"1", "+", "o"}], ")"}]}]}], 
    RowBox[{"1", "-", "Y11Y22as"}]], "]"}], "\[Equal]", 
  RowBox[{"o", 
   FractionBox[
    RowBox[{" ", "Y11Y22as"}], 
    RowBox[{
     RowBox[{"-", "1"}], "+", "Y11Y22as"}]]}], "==", 
  RowBox[{
   FractionBox[
    RowBox[{" ", "Y11Y22as"}], 
    RowBox[{
     RowBox[{"-", "1"}], "+", "Y11Y22as"}]], 
   RowBox[{"Log", "[", 
    SubscriptBox[
     RowBox[{"(", 
      RowBox[{
       SubscriptBox["Y", 
        RowBox[{"1", ",", "1"}]], 
       SubscriptBox["Y", 
        RowBox[{"2", ",", "2"}]]}], ")"}], "r"], "]"}]}], "\[Equal]", 
  "\[IndentingNewLine]", 
  RowBox[{
   FractionBox[
    RowBox[{" ", "Y11Y22as"}], 
    RowBox[{
     RowBox[{"-", "1"}], "+", "Y11Y22as"}]], 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"-", "4"}], "\[ImaginaryI]", " ", "g", 
     SqrtBox[
      RowBox[{"1", "-", 
       SuperscriptBox["z", "2"]}]], 
     RowBox[{"\[DoubleStruckCapitalC]", "[", 
      RowBox[{
       FractionBox["1", 
        RowBox[{
         RowBox[{"4", 
          SuperscriptBox["g", "2"], 
          SuperscriptBox["z", "2"]}], "-", 
         SuperscriptBox["u", "2"]}]], 
       FractionBox["H", 
        SqrtBox[
         RowBox[{"1", "-", 
          FractionBox[
           RowBox[{"4", 
            SuperscriptBox["g", "2"]}], 
           SuperscriptBox["u", "2"]]}]]]}], "]"}]}], ")"}]}]}]], "Input",
 CellChangeTimes->{{3.552195453278018*^9, 3.552195497757874*^9}, {
  3.555873272457108*^9, 3.555873298282538*^9}, {3.555873412927331*^9, 
  3.555873441120566*^9}, {3.562936059143304*^9, 3.562936080280541*^9}}],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"Series", "[", 
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{
          FractionBox[
           RowBox[{" ", "Y11Y22"}], 
           RowBox[{
            RowBox[{"-", "1"}], "+", "Y11Y22"}]], "/.", "largevolume"}], "/.",
          "subFunsBethe"}], "/.", "subJuk"}], "/.", 
       RowBox[{"leadweak", "[", "4", "]"}]}], "/.", 
      RowBox[{"u", "\[Rule]", 
       RowBox[{"2", "g", " ", "z"}]}]}], ",", 
     RowBox[{"{", 
      RowBox[{"g", ",", "0", ",", "3"}], "}"}]}], "]"}], "//", "Simplify"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"tmp1", "=", 
  RowBox[{
   RowBox[{"%", "//", "FullSimplify"}], "//", "Normal"}]}]}], "Input",
 CellChangeTimes->{{3.5521955031953583`*^9, 3.5521955123162107`*^9}, {
  3.552195599887342*^9, 3.552195650005445*^9}, {3.5558734853231087`*^9, 
  3.555873486278224*^9}, {3.555873579143408*^9, 3.555873592358659*^9}, {
  3.555873859352264*^9, 3.5558738612814083`*^9}}],

Cell[BoxData[
 RowBox[{
  FractionBox["1", "2"], "+", 
  FractionBox["1", 
   RowBox[{"12", " ", "g", " ", 
    SqrtBox[
     RowBox[{"1", "-", 
      SuperscriptBox["z", "2"]}]]}]], "+", 
  FractionBox[
   RowBox[{"g", " ", 
    RowBox[{"(", 
     RowBox[{"4", "-", 
      RowBox[{"3", " ", 
       SuperscriptBox["z", "2"]}]}], ")"}]}], 
   RowBox[{"3", " ", 
    SqrtBox[
     RowBox[{"1", "-", 
      SuperscriptBox["z", "2"]}]]}]], "+", 
  FractionBox[
   RowBox[{
    SuperscriptBox["g", "3"], " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"-", "7"}], "+", 
      RowBox[{"6", " ", 
       SuperscriptBox["z", "2"]}]}], ")"}]}], 
   SqrtBox[
    RowBox[{"1", "-", 
     SuperscriptBox["z", "2"]}]]]}]], "Output",
 CellChangeTimes->{{3.5521955054096622`*^9, 3.552195513179824*^9}, {
   3.552195597572797*^9, 3.552195652164297*^9}, 3.5558735079787188`*^9, {
   3.55587358349611*^9, 3.555873596019369*^9}, 3.555873881120298*^9, 
   3.560336891400983*^9, 3.562936150242326*^9, 3.5629362157306223`*^9}]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"tmp2", "=", 
   RowBox[{
    RowBox[{"-", "4"}], "\[ImaginaryI]", " ", "g", 
    SqrtBox[
     RowBox[{"1", "-", 
      SuperscriptBox["z", "2"]}]], 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"Collect", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"(", 
          RowBox[{"Series", "[", 
           RowBox[{
            RowBox[{
             FractionBox["z", 
              RowBox[{
               RowBox[{"4", 
                SuperscriptBox["g", "2"], 
                SuperscriptBox["z", "2"]}], "-", 
               SuperscriptBox["u", "2"]}]], 
             FractionBox[
              RowBox[{
               SuperscriptBox["g", "8"], 
               RowBox[{"(", 
                RowBox[{
                 SubscriptBox["H", "lead"], "+", 
                 RowBox[{
                  SuperscriptBox["g", "2"], 
                  SubscriptBox["H", "sublead"]}], "+", 
                 RowBox[{
                  SuperscriptBox["g", "4"], 
                  SubscriptBox["H", "sublead2"]}]}], ")"}]}], 
              SqrtBox[
               RowBox[{"1", "-", 
                FractionBox[
                 RowBox[{"4", 
                  SuperscriptBox["g", "2"]}], 
                 SuperscriptBox["u", "2"]]}]]]}], ",", 
            RowBox[{"{", 
             RowBox[{"g", ",", "0", ",", "12"}], "}"}]}], "]"}], ")"}], "//", 
         "Normal"}], ",", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{
           SuperscriptBox["z", "_."], 
           SuperscriptBox["g", "_."]}], ",", "z", ",", "g"}], "}"}]}], "]"}], 
      "/.", 
      RowBox[{
       RowBox[{
        SuperscriptBox["z", "a_."], 
        SuperscriptBox["g", "b_."], "r_"}], "\[RuleDelayed]", 
       RowBox[{
        SuperscriptBox["z", 
         RowBox[{"a", "-", "1"}]], 
        SuperscriptBox["g", "b"], " ", 
        RowBox[{"\[DoubleStruckCapitalC]", "[", "r", "]"}]}]}]}], ")"}]}]}], 
  ";"}]], "Input",
 CellChangeTimes->{{3.555873597797863*^9, 3.5558738223643293`*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"preconY11Y22", "=", " ", 
  RowBox[{"Collect", "[", 
   RowBox[{
    RowBox[{"Series", "[", 
     RowBox[{
      RowBox[{"tmp1", " ", "tmp2"}], ",", 
      RowBox[{"{", 
       RowBox[{"g", ",", "0", ",", "9"}], "}"}]}], "]"}], ",", 
    RowBox[{"{", 
     RowBox[{"g", ",", "z"}], "}"}], ",", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{"#", "//.", "sub\[DoubleStruckCapitalC]simplify"}], ")"}], 
     "&"}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.5608541723975897`*^9, 3.560854268455309*^9}, 
   3.562936229765833*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"-", 
    FractionBox["1", "3"]}], " ", "\[ImaginaryI]", " ", 
   SuperscriptBox["g", "8"], " ", 
   RowBox[{"\[DoubleStruckCapitalC]", "[", 
    RowBox[{"-", 
     FractionBox[
      SubscriptBox[
       StyleBox["H",
        FontColor->RGBColor[0.54, 0.35, 0.15]], "lead"], 
      SuperscriptBox["u", "2"]]}], "]"}]}], "-", 
  RowBox[{"2", " ", "\[ImaginaryI]", " ", 
   SuperscriptBox["g", "9"], " ", 
   SqrtBox[
    RowBox[{"1", "-", 
     SuperscriptBox["z", "2"]}]], " ", 
   RowBox[{"\[DoubleStruckCapitalC]", "[", 
    RowBox[{"-", 
     FractionBox[
      SubscriptBox[
       StyleBox["H",
        FontColor->RGBColor[0.54, 0.35, 0.15]], "lead"], 
      SuperscriptBox["u", "2"]]}], "]"}]}]}]], "Output",
 CellChangeTimes->{{3.560854188158609*^9, 3.560854268749*^9}, 
   3.562936177242474*^9, {3.562936216590024*^9, 3.562936230432948*^9}}]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 "Contribution from ",
 Cell[BoxData[
  FormBox[
   RowBox[{"Log", "[", 
    FractionBox[
     SuperscriptBox[
      StyleBox["\[ScriptCapitalF]",
       FontColor->RGBColor[0, 0.6, 0]], "+"], 
     SubscriptBox[
      RowBox[{"(", 
       SuperscriptBox[
        StyleBox["\[ScriptCapitalF]",
         FontColor->RGBColor[0, 0.6, 0]], "+"], ")"}], "asym"]], "]"}], 
   TraditionalForm]]]
}], "Subsubsection",
 CellChangeTimes->{{3.552194573693015*^9, 3.552194586631557*^9}, {
  3.552195423782762*^9, 3.552195451528096*^9}, {3.5521965050485697`*^9, 
  3.552196518074411*^9}, {3.552196569144054*^9, 3.552196575356393*^9}, {
  3.552205045118082*^9, 3.55220504515469*^9}, {3.555874436885995*^9, 
  3.555874443483198*^9}, {3.555928460336525*^9, 3.555928464641596*^9}, {
  3.5608549240866327`*^9, 3.560854924086772*^9}, {3.562937062259419*^9, 
  3.5629370624502563`*^9}}],

Cell["\<\
We are changing sign-type regularization from the FiNLIE paper to something \
more invariant\
\>", "Text",
 CellChangeTimes->{{3.562936511390167*^9, 3.562936528275776*^9}, {
  3.568968791170999*^9, 3.568968807465411*^9}}],

Cell[BoxData[
 RowBox[{
  SuperscriptBox["\[ScriptCapitalF]", "+"], "=", 
  RowBox[{
   SubscriptBox["\[CapitalLambda]", "F"], 
   RowBox[{
    SubscriptBox["\[Product]", "j"], 
    RowBox[{
     RowBox[{"(", 
      RowBox[{"\[ImaginaryI]", " ", 
       RowBox[{"Cosh", "[", 
        RowBox[{"\[Pi]", " ", 
         RowBox[{"(", 
          RowBox[{"u", "-", 
           SubscriptBox["u", "j"]}], ")"}]}], "]"}]}], ")"}], 
     RowBox[{"Exp", "[", 
      RowBox[{
       SubscriptBox["\[Integral]", 
        OverscriptBox["Z", "\[Vee]"]], 
       RowBox[{
        FractionBox["dv", 
         RowBox[{"2", "\[ImaginaryI]"}]], 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"Coth", "[", 
           RowBox[{"\[Pi]", 
            RowBox[{"(", 
             RowBox[{"u", "-", "v"}], ")"}]}], "]"}], "+", 
          RowBox[{"Sign", "[", "v", "]"}]}], ")"}], 
        RowBox[{"Log", "[", 
         RowBox[{
          SubscriptBox["Y", 
           RowBox[{"1", ",", "1"}]], 
          SubscriptBox["Y", 
           RowBox[{"2", ",", "2"}]]}], "]"}]}]}], "]"}]}]}]}]}]], "Input",
 CellChangeTimes->{{3.547966072743767*^9, 3.54796607412173*^9}, {
  3.547966236317339*^9, 3.547966294388851*^9}, {3.547966826922048*^9, 
  3.5479668505432377`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Log", "[", 
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox["\[ScriptCapitalF]", 
      SubscriptBox["\[ScriptCapitalF]", "asym"]], ")"}], "+"], "]"}], "=", 
  RowBox[{
   RowBox[{"\[Integral]", 
    RowBox[{
     FractionBox["dv", 
      RowBox[{"2", "\[ImaginaryI]"}]], 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"Coth", "[", 
        RowBox[{"\[Pi]", 
         RowBox[{"(", 
          RowBox[{"u", "-", "v"}], ")"}]}], "]"}], "-", 
       SubscriptBox[
        RowBox[{"Coth", "[", 
         RowBox[{"\[Pi]", " ", "u"}], "]"}], "pv"]}], ")"}], 
     SubscriptBox[
      RowBox[{"Log", "[", 
       SubscriptBox[
        RowBox[{"(", 
         RowBox[{
          SubscriptBox["Y", 
           RowBox[{"1", ",", "1"}]], 
          SubscriptBox["Y", 
           RowBox[{"2", ",", "2"}]]}], ")"}], "r"], "]"}], "pv"]}]}], "+", 
   "const"}]}]], "Input",
 CellChangeTimes->{{3.547966491674753*^9, 3.547966543809491*^9}, {
   3.547966856640164*^9, 3.5479668725649157`*^9}, {3.5479669237629766`*^9, 
   3.547966932264473*^9}, 3.55219692680199*^9, {3.5521975315545397`*^9, 
   3.552197558495037*^9}, {3.562936535548952*^9, 3.5629365414209833`*^9}, {
   3.562936597281616*^9, 3.562936598105906*^9}, {3.562936673552699*^9, 
   3.5629366757553864`*^9}, {3.562936805288239*^9, 3.562936805613645*^9}}],

Cell["\<\
We consider v far from the real axis for the moment (say, in the UHP). But \
using the residue of Coth we can bring it to the real axis\
\>", "Text",
 CellChangeTimes->{{3.562936601904418*^9, 3.5629366331671352`*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Series", "[", 
  RowBox[{
   RowBox[{"Coth", "[", 
    RowBox[{"\[Pi]", " ", "u"}], "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"u", ",", "0", ",", 
     RowBox[{"-", "1"}]}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.562936634221208*^9, 3.562936654828315*^9}}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
   FractionBox["1", 
    RowBox[{"\[Pi]", " ", "u"}]], "+", 
   InterpretationBox[
    SuperscriptBox[
     RowBox[{"O", "[", "u", "]"}], "0"],
    SeriesData[$CellContext`u, 0, {}, -1, 0, 1],
    Editable->False]}],
  SeriesData[$CellContext`u, 0, {Pi^(-1)}, -1, 0, 1],
  Editable->False]], "Output",
 CellChangeTimes->{3.562936655230219*^9}]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"\[Integral]", 
   RowBox[{
    FractionBox["dv", 
     RowBox[{"2", "\[Pi]", " ", "\[ImaginaryI]"}]], 
    FractionBox["1", 
     RowBox[{"u", "-", "v"}]], 
    SubscriptBox[
     RowBox[{"Log", "[", 
      SubscriptBox[
       RowBox[{"(", 
        RowBox[{
         SubscriptBox["Y", 
          RowBox[{"1", ",", "1"}]], 
         SubscriptBox["Y", 
          RowBox[{"2", ",", "2"}]]}], ")"}], "r"], "]"}], "pv"]}]}], 
  "\[Equal]", 
  RowBox[{
   RowBox[{
    RowBox[{"-", 
     FractionBox["1", "2"]}], 
    RowBox[{"Log", "[", 
     SubscriptBox[
      RowBox[{"(", 
       RowBox[{
        SubscriptBox["Y", 
         RowBox[{"1", ",", "1"}]], 
        SubscriptBox["Y", 
         RowBox[{"2", ",", "2"}]]}], ")"}], "r"], "]"}]}], "+", 
   RowBox[{"\[Integral]", 
    RowBox[{
     FractionBox["dv", 
      RowBox[{"2", "\[Pi]", " ", "\[ImaginaryI]"}]], 
     SubscriptBox[
      RowBox[{"(", 
       RowBox[{
        FractionBox["1", 
         RowBox[{"u", "-", 
          RowBox[{"Re", "[", "v", "]"}]}]], 
        RowBox[{"Log", "[", 
         SubscriptBox[
          RowBox[{"(", 
           RowBox[{
            SubscriptBox["Y", 
             RowBox[{"1", ",", "1"}]], 
            SubscriptBox["Y", 
             RowBox[{"2", ",", "2"}]]}], ")"}], "r"], "]"}]}], ")"}], 
      "pv"]}]}]}]}]], "Input",
 CellChangeTimes->{{3.56293666440204*^9, 3.562936711004149*^9}, {
  3.562936792380061*^9, 3.562936798760304*^9}}],

Cell[TextData[{
 "Now, -1/2 precisely cancells ",
 Cell[BoxData[
  FormBox[
   SuperscriptBox["g", "odd"], TraditionalForm]],
  FormatType->"TraditionalForm"],
 " terms from ",
 Cell[BoxData[
  FormBox[
   RowBox[{"Log", "[", 
    SubscriptBox[
     RowBox[{"(", 
      RowBox[{"1", "-", "Y11Y22"}], ")"}], "r"], "]"}], TraditionalForm]],
  FormatType->"TraditionalForm"],
 ". We hence get for \[ScriptCapitalF] only nontrivial integral:"
}], "Text",
 CellChangeTimes->{{3.562936715023093*^9, 3.562936765113146*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Log", "[", 
   SubscriptBox[
    RowBox[{"(", 
     SuperscriptBox["\[ScriptCapitalF]", "+"], ")"}], "r"], "]"}], "=", 
  RowBox[{"\[Integral]", 
   RowBox[{
    FractionBox["dv", 
     RowBox[{"2", "\[ImaginaryI]"}]], 
    SubscriptBox[
     RowBox[{"(", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{"Coth", "[", 
          RowBox[{"\[Pi]", 
           RowBox[{"(", 
            RowBox[{"u", "-", "v"}], ")"}]}], "]"}], "-", 
         RowBox[{"Coth", "[", 
          RowBox[{"\[Pi]", " ", "v"}], "]"}]}], ")"}], 
       RowBox[{"Log", "[", 
        SubscriptBox[
         RowBox[{"(", 
          RowBox[{
           SubscriptBox["Y", 
            RowBox[{"1", ",", "1"}]], 
           SubscriptBox["Y", 
            RowBox[{"2", ",", "2"}]]}], ")"}], "r"], "]"}]}], ")"}], 
     "pv"]}]}]}]], "Input",
 CellChangeTimes->{{3.562936770220223*^9, 3.562936787533502*^9}, 
   3.562936901721937*^9}],

Cell[TextData[{
 "This is something easy to deal with. ",
 Cell[BoxData[
  FormBox[
   RowBox[{"Log", "[", 
    SubscriptBox[
     RowBox[{"(", 
      RowBox[{
       SubscriptBox["Y", 
        RowBox[{"1", ",", "1"}]], 
       SubscriptBox["Y", 
        RowBox[{"2", ",", "2"}]]}], ")"}], "r"], "]"}], TraditionalForm]],
  FormatType->"TraditionalForm"],
 " is of order ",
 Cell[BoxData[
  FormBox[
   SuperscriptBox["g", "8"], TraditionalForm]],
  FormatType->"TraditionalForm"],
 " and it is odd function (as a function slightly above or below real axis) . \
Hence we can symmetrize our expression to be explicitly symmetric in u (as it \
should). Therefore, when we expand in powers of g. We will get "
}], "Text",
 CellChangeTimes->{{3.5629368237503157`*^9, 3.5629370049116163`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"const1", " ", 
    SuperscriptBox["g", "8"]}], "+", 
   RowBox[{
    SuperscriptBox["z", "2"], "const2", " ", 
    SuperscriptBox["g", "10"]}], "+"}], "..."}]], "Input",
 CellChangeTimes->{{3.562936996587657*^9, 3.562937020495468*^9}}],

Cell[TextData[{
 "Again, at ",
 Cell[BoxData[
  FormBox[
   SuperscriptBox["g", "8"], TraditionalForm]]],
 " level nothing contributes. "
}], "Text",
 CellChangeTimes->{{3.562937022117443*^9, 3.56293703235703*^9}, 
   3.568968821585218*^9}]
}, Closed]],

Cell[CellGroupData[{

Cell["Summing up, ordingary regime and double scaling regime", "Subsubsection",
 CellChangeTimes->{{3.552194573693015*^9, 3.552194586631557*^9}, {
  3.552195423782762*^9, 3.552195451528096*^9}, {3.5521965050485697`*^9, 
  3.552196518074411*^9}, {3.552196569144054*^9, 3.552196575356393*^9}, {
  3.552205045118082*^9, 3.55220504515469*^9}, {3.555874436885995*^9, 
  3.555874443483198*^9}, {3.555928460336525*^9, 3.555928464641596*^9}, {
  3.5608549240866327`*^9, 3.560854950848559*^9}, {3.560855127809198*^9, 
  3.560855130833679*^9}}],

Cell[TextData[{
 "We just see that all three contributions are non-constant starting from ",
 Cell[BoxData[
  FormBox[
   SuperscriptBox["g", "10"], TraditionalForm]],
  FormatType->"TraditionalForm"],
 " ",
 Cell[BoxData[
  FormBox[
   RowBox[{"(", 
    SuperscriptBox["g", "9"]}], TraditionalForm]],
  FormatType->"TraditionalForm"],
 " cancells between F and Y11Y22). I.e. we ignore h at the leading order in \
wrapping."
}], "Text",
 CellChangeTimes->{{3.562936354579837*^9, 3.562936400641622*^9}}]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 "Computing ",
 Cell[BoxData[
  RowBox[{
   RowBox[{"Log", "[", 
    SubscriptBox["U", "r"], "]"}], "\[Equal]", "rltUr"}]]],
 " (up to normalization)"
}], "Subsection",
 CellChangeTimes->{{3.560711008215272*^9, 3.560711026763973*^9}, {
   3.5609475966599693`*^9, 3.560947602386325*^9}, {3.560948125088023*^9, 
   3.560948130358906*^9}, {3.561469521430273*^9, 3.561469524470936*^9}, {
   3.5622597524408503`*^9, 3.562259753159259*^9}, {3.5629370907802258`*^9, 
   3.562937114729435*^9}, {3.562937361368528*^9, 3.562937372382972*^9}, {
   3.562937709174718*^9, 3.562937715374341*^9}, {3.562937764662354*^9, 
   3.5629377740401907`*^9}, 3.568968845296513*^9}],

Cell["\<\
We get that in the leading order \
\>", "Text",
 CellChangeTimes->{{3.562937121354385*^9, 3.562937130528603*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Log", "[", 
    SubscriptBox[
     RowBox[{"(", 
      FractionBox[
       StyleBox["U",
        FontColor->RGBColor[0, 0.6, 0]], 
       SuperscriptBox[
        StyleBox["U",
         FontColor->RGBColor[0, 0.6, 0]], 
        RowBox[{"[", "2", "]"}]]], ")"}], "r"], "]"}], "[", "v", "]"}], 
  "\[Equal]", 
  RowBox[{"rltH", "+", "mrlt"}]}]], "Input",
 CellChangeTimes->{{3.56293714177387*^9, 3.562937146658639*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"rltUohr", "=", 
  RowBox[{"Collect", "[", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"rltH", "+", "mrlt"}], "/.", 
      RowBox[{"g", "\[Rule]", "1"}]}], "//.", "subZetaReduce"}], ",", 
    "canlist"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.562259649743128*^9, 3.562259695021154*^9}, {
  3.562937175061143*^9, 3.562937187249132*^9}}],

Cell[BoxData[
 RowBox[{
  FractionBox["27", 
   SuperscriptBox[
    StyleBox["\[ScriptU]",
     FontColor->RGBColor[0, 0, 0.4]], "4"]], "-", 
  FractionBox["27", 
   SuperscriptBox[
    RowBox[{"(", 
     SuperscriptBox[
      StyleBox["\[ScriptU]",
       FontColor->RGBColor[0, 0, 0.4]], 
      RowBox[{"[", "2", "]"}]], ")"}], "4"]], "+", 
  FractionBox[
   RowBox[{
    RowBox[{
     RowBox[{"-", "81"}], " ", "\[ImaginaryI]"}], "+", 
    RowBox[{"144", " ", "\[ImaginaryI]", " ", 
     SubscriptBox[
      StyleBox["\[Zeta]",
       FontWeight->Bold,
       FontColor->GrayLevel[0.4]], "3"]}]}], 
   SuperscriptBox[
    StyleBox["\[ScriptU]",
     FontColor->RGBColor[0, 0, 0.4]], "3"]], "+", 
  FractionBox[
   RowBox[{
    RowBox[{
     RowBox[{"-", "81"}], " ", "\[ImaginaryI]"}], "+", 
    RowBox[{"144", " ", "\[ImaginaryI]", " ", 
     SubscriptBox[
      StyleBox["\[Zeta]",
       FontWeight->Bold,
       FontColor->GrayLevel[0.4]], "3"]}]}], 
   SuperscriptBox[
    RowBox[{"(", 
     SuperscriptBox[
      StyleBox["\[ScriptU]",
       FontColor->RGBColor[0, 0, 0.4]], 
      RowBox[{"[", "2", "]"}]], ")"}], "3"]], "+", 
  FractionBox[
   RowBox[{
    RowBox[{"540", " ", "\[ImaginaryI]", " ", 
     SubscriptBox[
      StyleBox["\[Zeta]",
       FontWeight->Bold,
       FontColor->GrayLevel[0.4]], "3"]}], "-", 
    RowBox[{"360", " ", "\[ImaginaryI]", " ", 
     SubscriptBox[
      StyleBox["\[Zeta]",
       FontWeight->Bold,
       FontColor->GrayLevel[0.4]], "5"]}]}], 
   StyleBox["\[ScriptU]",
    FontColor->RGBColor[0, 0, 0.4]]], "+", 
  FractionBox[
   RowBox[{
    RowBox[{"540", " ", "\[ImaginaryI]", " ", 
     SubscriptBox[
      StyleBox["\[Zeta]",
       FontWeight->Bold,
       FontColor->GrayLevel[0.4]], "3"]}], "-", 
    RowBox[{"360", " ", "\[ImaginaryI]", " ", 
     SubscriptBox[
      StyleBox["\[Zeta]",
       FontWeight->Bold,
       FontColor->GrayLevel[0.4]], "5"]}]}], 
   SuperscriptBox[
    StyleBox["\[ScriptU]",
     FontColor->RGBColor[0, 0, 0.4]], 
    RowBox[{"[", "2", "]"}]]], "+", 
  FractionBox[
   RowBox[{
    FractionBox[
     RowBox[{"81", " ", "\[ImaginaryI]"}], "2"], "+", 
    FractionBox[
     RowBox[{"81", " ", 
      SqrtBox["3"]}], "2"], "-", 
    RowBox[{"54", " ", "\[ImaginaryI]", " ", 
     SubsuperscriptBox[
      StyleBox["\[Eta]0",
       FontWeight->Bold,
       FontColor->RGBColor[0, 0.5, 0]], "2", "+"]}], "+", 
    RowBox[{"18", " ", "\[ImaginaryI]", " ", 
     SqrtBox["3"], " ", 
     SubsuperscriptBox[
      StyleBox["\[Eta]0",
       FontWeight->Bold,
       FontColor->RGBColor[0, 0.5, 0]], "3", "+"]}], "-", 
    RowBox[{"9", " ", "\[ImaginaryI]", " ", 
     SubsuperscriptBox[
      StyleBox["\[Eta]0",
       FontWeight->Bold,
       FontColor->RGBColor[0, 0.5, 0]], "4", "+"]}]}], 
   SubsuperscriptBox[
    StyleBox["\[ScriptU]",
     FontColor->RGBColor[0, 0, 0.4]], 
    RowBox[{"-", "v0"}], "-"]], "+", 
  FractionBox[
   RowBox[{
    FractionBox[
     RowBox[{"81", " ", "\[ImaginaryI]"}], "2"], "-", 
    FractionBox[
     RowBox[{"81", " ", 
      SqrtBox["3"]}], "2"], "+", 
    RowBox[{"54", " ", "\[ImaginaryI]", " ", 
     SubsuperscriptBox[
      StyleBox["\[Eta]0",
       FontWeight->Bold,
       FontColor->RGBColor[0, 0.5, 0]], "2", "+"]}], "-", 
    RowBox[{"18", " ", "\[ImaginaryI]", " ", 
     SqrtBox["3"], " ", 
     SubsuperscriptBox[
      StyleBox["\[Eta]0",
       FontWeight->Bold,
       FontColor->RGBColor[0, 0.5, 0]], "3", "+"]}], "+", 
    RowBox[{"9", " ", "\[ImaginaryI]", " ", 
     SubsuperscriptBox[
      StyleBox["\[Eta]0",
       FontWeight->Bold,
       FontColor->RGBColor[0, 0.5, 0]], "4", "+"]}]}], 
   SubsuperscriptBox[
    StyleBox["\[ScriptU]",
     FontColor->RGBColor[0, 0, 0.4]], 
    RowBox[{"-", "v0"}], 
    RowBox[{"[", "3", "]"}]]], "+", 
  FractionBox[
   RowBox[{
    FractionBox[
     RowBox[{"81", " ", "\[ImaginaryI]"}], "2"], "-", 
    FractionBox[
     RowBox[{"81", " ", 
      SqrtBox["3"]}], "2"], "-", 
    RowBox[{"54", " ", "\[ImaginaryI]", " ", 
     SubsuperscriptBox[
      OverscriptBox[
       StyleBox["\[Eta]0",
        FontWeight->Bold,
        FontColor->RGBColor[0, 0.5, 0]], 
       StyleBox["_",
        FontWeight->Bold,
        FontColor->RGBColor[0, 0.5, 0]]], "2", "-"]}], "+", 
    RowBox[{"18", " ", "\[ImaginaryI]", " ", 
     SqrtBox["3"], " ", 
     SubsuperscriptBox[
      OverscriptBox[
       StyleBox["\[Eta]0",
        FontWeight->Bold,
        FontColor->RGBColor[0, 0.5, 0]], 
       StyleBox["_",
        FontWeight->Bold,
        FontColor->RGBColor[0, 0.5, 0]]], "3", "-"]}], "-", 
    RowBox[{"9", " ", "\[ImaginaryI]", " ", 
     SubsuperscriptBox[
      OverscriptBox[
       StyleBox["\[Eta]0",
        FontWeight->Bold,
        FontColor->RGBColor[0, 0.5, 0]], 
       StyleBox["_",
        FontWeight->Bold,
        FontColor->RGBColor[0, 0.5, 0]]], "4", "-"]}]}], 
   SubsuperscriptBox[
    StyleBox["\[ScriptU]",
     FontColor->RGBColor[0, 0, 0.4]], "v0", "-"]], "+", 
  FractionBox[
   RowBox[{
    FractionBox[
     RowBox[{"81", " ", "\[ImaginaryI]"}], "2"], "+", 
    FractionBox[
     RowBox[{"81", " ", 
      SqrtBox["3"]}], "2"], "+", 
    RowBox[{"54", " ", "\[ImaginaryI]", " ", 
     SubsuperscriptBox[
      OverscriptBox[
       StyleBox["\[Eta]0",
        FontWeight->Bold,
        FontColor->RGBColor[0, 0.5, 0]], 
       StyleBox["_",
        FontWeight->Bold,
        FontColor->RGBColor[0, 0.5, 0]]], "2", "-"]}], "-", 
    RowBox[{"18", " ", "\[ImaginaryI]", " ", 
     SqrtBox["3"], " ", 
     SubsuperscriptBox[
      OverscriptBox[
       StyleBox["\[Eta]0",
        FontWeight->Bold,
        FontColor->RGBColor[0, 0.5, 0]], 
       StyleBox["_",
        FontWeight->Bold,
        FontColor->RGBColor[0, 0.5, 0]]], "3", "-"]}], "+", 
    RowBox[{"9", " ", "\[ImaginaryI]", " ", 
     SubsuperscriptBox[
      OverscriptBox[
       StyleBox["\[Eta]0",
        FontWeight->Bold,
        FontColor->RGBColor[0, 0.5, 0]], 
       StyleBox["_",
        FontWeight->Bold,
        FontColor->RGBColor[0, 0.5, 0]]], "4", "-"]}]}], 
   SubsuperscriptBox[
    StyleBox["\[ScriptU]",
     FontColor->RGBColor[0, 0, 0.4]], "v0", 
    RowBox[{"[", "3", "]"}]]], "+", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     FractionBox["18", 
      SuperscriptBox[
       StyleBox["\[ScriptU]",
        FontColor->RGBColor[0, 0, 0.4]], "4"]], "+", 
     FractionBox["108", 
      SuperscriptBox[
       StyleBox["\[ScriptU]",
        FontColor->RGBColor[0, 0, 0.4]], "2"]], "+", 
     FractionBox["18", 
      SuperscriptBox[
       RowBox[{"(", 
        SuperscriptBox[
         StyleBox["\[ScriptU]",
          FontColor->RGBColor[0, 0, 0.4]], 
         RowBox[{"[", "2", "]"}]], ")"}], "4"]], "+", 
     FractionBox["108", 
      SuperscriptBox[
       RowBox[{"(", 
        SuperscriptBox[
         StyleBox["\[ScriptU]",
          FontColor->RGBColor[0, 0, 0.4]], 
         RowBox[{"[", "2", "]"}]], ")"}], "2"]], "+", 
     FractionBox[
      RowBox[{"54", " ", "\[ImaginaryI]"}], 
      SubsuperscriptBox[
       StyleBox["\[ScriptU]",
        FontColor->RGBColor[0, 0, 0.4]], 
       RowBox[{"-", "v0"}], "-"]], "-", 
     FractionBox[
      RowBox[{"54", " ", "\[ImaginaryI]"}], 
      SubsuperscriptBox[
       StyleBox["\[ScriptU]",
        FontColor->RGBColor[0, 0, 0.4]], 
       RowBox[{"-", "v0"}], 
       RowBox[{"[", "3", "]"}]]], "+", 
     FractionBox[
      RowBox[{"54", " ", "\[ImaginaryI]"}], 
      SubsuperscriptBox[
       StyleBox["\[ScriptU]",
        FontColor->RGBColor[0, 0, 0.4]], "v0", "-"]], "-", 
     FractionBox[
      RowBox[{"54", " ", "\[ImaginaryI]"}], 
      SubsuperscriptBox[
       StyleBox["\[ScriptU]",
        FontColor->RGBColor[0, 0, 0.4]], "v0", 
       RowBox[{"[", "3", "]"}]]], "+", 
     FractionBox[
      RowBox[{
       RowBox[{"54", " ", "\[ImaginaryI]"}], "-", 
       RowBox[{"216", " ", "\[ImaginaryI]", " ", 
        SubscriptBox[
         StyleBox["\[Zeta]",
          FontWeight->Bold,
          FontColor->GrayLevel[0.4]], "3"]}]}], 
      SuperscriptBox[
       StyleBox["\[ScriptU]",
        FontColor->RGBColor[0, 0, 0.4]], 
       RowBox[{"[", "2", "]"}]]], "+", 
     FractionBox[
      RowBox[{
       RowBox[{
        RowBox[{"-", "54"}], " ", "\[ImaginaryI]"}], "+", 
       RowBox[{"216", " ", "\[ImaginaryI]", " ", 
        SubscriptBox[
         StyleBox["\[Zeta]",
          FontWeight->Bold,
          FontColor->GrayLevel[0.4]], "3"]}]}], 
      StyleBox["\[ScriptU]",
       FontColor->RGBColor[0, 0, 0.4]]], "+", 
     RowBox[{"648", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3"]}]}], ")"}], " ", 
   SubsuperscriptBox[
    StyleBox["\[Eta]",
     FontWeight->Bold,
     FontColor->RGBColor[0.8, 0, 0]], "2", 
    RowBox[{"[", "2", "]"}]]}], "+", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     RowBox[{"-", 
      FractionBox["36", 
       SuperscriptBox[
        StyleBox["\[ScriptU]",
         FontColor->RGBColor[0, 0, 0.4]], "3"]]}], "-", 
     FractionBox["54", 
      StyleBox["\[ScriptU]",
       FontColor->RGBColor[0, 0, 0.4]]], "-", 
     FractionBox["36", 
      SuperscriptBox[
       RowBox[{"(", 
        SuperscriptBox[
         StyleBox["\[ScriptU]",
          FontColor->RGBColor[0, 0, 0.4]], 
         RowBox[{"[", "2", "]"}]], ")"}], "3"]], "-", 
     FractionBox["54", 
      SuperscriptBox[
       StyleBox["\[ScriptU]",
        FontColor->RGBColor[0, 0, 0.4]], 
       RowBox[{"[", "2", "]"}]]], "-", 
     FractionBox[
      RowBox[{"18", " ", "\[ImaginaryI]", " ", 
       SqrtBox["3"]}], 
      SubsuperscriptBox[
       StyleBox["\[ScriptU]",
        FontColor->RGBColor[0, 0, 0.4]], 
       RowBox[{"-", "v0"}], "-"]], "+", 
     FractionBox[
      RowBox[{"18", " ", "\[ImaginaryI]", " ", 
       SqrtBox["3"]}], 
      SubsuperscriptBox[
       StyleBox["\[ScriptU]",
        FontColor->RGBColor[0, 0, 0.4]], 
       RowBox[{"-", "v0"}], 
       RowBox[{"[", "3", "]"}]]], "+", 
     FractionBox[
      RowBox[{"18", " ", "\[ImaginaryI]", " ", 
       SqrtBox["3"]}], 
      SubsuperscriptBox[
       StyleBox["\[ScriptU]",
        FontColor->RGBColor[0, 0, 0.4]], "v0", "-"]], "-", 
     FractionBox[
      RowBox[{"18", " ", "\[ImaginaryI]", " ", 
       SqrtBox["3"]}], 
      SubsuperscriptBox[
       StyleBox["\[ScriptU]",
        FontColor->RGBColor[0, 0, 0.4]], "v0", 
       RowBox[{"[", "3", "]"}]]]}], ")"}], " ", 
   SubsuperscriptBox[
    StyleBox["\[Eta]",
     FontWeight->Bold,
     FontColor->RGBColor[0.8, 0, 0]], "3", 
    RowBox[{"[", "2", "]"}]]}], "+", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     FractionBox["18", 
      SuperscriptBox[
       StyleBox["\[ScriptU]",
        FontColor->RGBColor[0, 0, 0.4]], "2"]], "+", 
     FractionBox["18", 
      SuperscriptBox[
       RowBox[{"(", 
        SuperscriptBox[
         StyleBox["\[ScriptU]",
          FontColor->RGBColor[0, 0, 0.4]], 
         RowBox[{"[", "2", "]"}]], ")"}], "2"]], "+", 
     FractionBox[
      RowBox[{"9", " ", "\[ImaginaryI]"}], 
      SubsuperscriptBox[
       StyleBox["\[ScriptU]",
        FontColor->RGBColor[0, 0, 0.4]], 
       RowBox[{"-", "v0"}], "-"]], "-", 
     FractionBox[
      RowBox[{"9", " ", "\[ImaginaryI]"}], 
      SubsuperscriptBox[
       StyleBox["\[ScriptU]",
        FontColor->RGBColor[0, 0, 0.4]], 
       RowBox[{"-", "v0"}], 
       RowBox[{"[", "3", "]"}]]], "+", 
     FractionBox[
      RowBox[{"9", " ", "\[ImaginaryI]"}], 
      SubsuperscriptBox[
       StyleBox["\[ScriptU]",
        FontColor->RGBColor[0, 0, 0.4]], "v0", "-"]], "-", 
     FractionBox[
      RowBox[{"9", " ", "\[ImaginaryI]"}], 
      SubsuperscriptBox[
       StyleBox["\[ScriptU]",
        FontColor->RGBColor[0, 0, 0.4]], "v0", 
       RowBox[{"[", "3", "]"}]]]}], ")"}], " ", 
   SubsuperscriptBox[
    StyleBox["\[Eta]",
     FontWeight->Bold,
     FontColor->RGBColor[0.8, 0, 0]], "4", 
    RowBox[{"[", "2", "]"}]]}], "+", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     RowBox[{"108", " ", "\[ImaginaryI]"}], "-", 
     FractionBox["36", 
      StyleBox["\[ScriptU]",
       FontColor->RGBColor[0, 0, 0.4]]], "+", 
     FractionBox["36", 
      SuperscriptBox[
       StyleBox["\[ScriptU]",
        FontColor->RGBColor[0, 0, 0.4]], 
       RowBox[{"[", "2", "]"}]]]}], ")"}], " ", 
   SubsuperscriptBox[
    StyleBox["\[Eta]",
     FontWeight->Bold,
     FontColor->RGBColor[0.8, 0, 0]], 
    RowBox[{"2", ",", "3"}], 
    RowBox[{"[", "2", "]"}]]}], "+", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     RowBox[{
      RowBox[{"-", "108"}], " ", "\[ImaginaryI]"}], "+", 
     FractionBox["36", 
      StyleBox["\[ScriptU]",
       FontColor->RGBColor[0, 0, 0.4]]], "-", 
     FractionBox["36", 
      SuperscriptBox[
       StyleBox["\[ScriptU]",
        FontColor->RGBColor[0, 0, 0.4]], 
       RowBox[{"[", "2", "]"}]]]}], ")"}], " ", 
   SubsuperscriptBox[
    StyleBox["\[Eta]",
     FontWeight->Bold,
     FontColor->RGBColor[0.8, 0, 0]], 
    RowBox[{"3", ",", "2"}], 
    RowBox[{"[", "2", "]"}]]}]}]], "Output",
 CellChangeTimes->{
  3.5622596973828278`*^9, {3.5629371816859083`*^9, 3.562937188106206*^9}, 
   3.562937224045188*^9}]
}, Open  ]],

Cell[TextData[{
 "Note that in combination ",
 Cell[BoxData[
  FormBox[
   SubsuperscriptBox["\[ScriptU]", 
    RowBox[{"\[PlusMinus]", "v0"}], "+"], TraditionalForm]]],
 " disappear."
}], "Text",
 CellChangeTimes->{{3.562260476521285*^9, 3.562260497527587*^9}, {
  3.562937297244055*^9, 3.5629373019884157`*^9}}],

Cell["\<\
We can check that there actually no poles at any shifted Bethe roots\
\>", "Text",
 CellChangeTimes->{{3.562937310210335*^9, 3.56293732177604*^9}}],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"Series", "[", 
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{"rltUohr", "/.", "subusu"}], "/.", 
         RowBox[{"Shift", "[", "1", "]"}]}], "/.", 
        RowBox[{"u", "\[Rule]", 
         RowBox[{"u", "+", 
          FractionBox["\[ImaginaryI]", "2"]}]}]}], "/.", "subQ0"}], "/.", 
      RowBox[{"shiftm\[Eta]", "[", "3", "]"}]}], ",", 
     RowBox[{"{", 
      RowBox[{"u", ",", "v00", ",", 
       RowBox[{"-", "1"}]}], "}"}]}], "]"}], "/.", "sub\[Eta]\[Eta]0"}], "//",
   "Simplify"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Series", "[", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{"rltUohr", "/.", "subusu"}], "/.", 
        RowBox[{"Shift", "[", 
         RowBox[{"-", "1"}], "]"}]}], "/.", 
       RowBox[{"u", "\[Rule]", 
        RowBox[{"u", "-", 
         FractionBox["\[ImaginaryI]", "2"]}]}]}], "/.", "subQ0"}], "/.", 
     RowBox[{"shiftm\[Eta]", "[", "3", "]"}]}], ",", 
    RowBox[{"{", 
     RowBox[{"u", ",", "v00", ",", 
      RowBox[{"-", "1"}]}], "}"}]}], "]"}], "/.", 
  "sub\[Eta]\[Eta]0"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"Series", "[", 
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{"rltUohr", "/.", "subusu"}], "/.", 
         RowBox[{"Shift", "[", "1", "]"}]}], "/.", 
        RowBox[{"u", "\[Rule]", 
         RowBox[{"u", "+", 
          FractionBox["\[ImaginaryI]", "2"]}]}]}], "/.", "subQ0"}], "/.", 
      RowBox[{"shiftm\[Eta]", "[", "3", "]"}]}], ",", 
     RowBox[{"{", 
      RowBox[{"u", ",", 
       RowBox[{"-", "v00"}], ",", 
       RowBox[{"-", "1"}]}], "}"}]}], "]"}], "/.", 
   RowBox[{
    RowBox[{
     RowBox[{"\[Eta]$", "[", "aa_", "]"}], "[", "1", "]"}], "\[RuleDelayed]", 
    
    RowBox[{
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{"-", "1"}], ")"}], 
      RowBox[{"Total", "[", 
       RowBox[{"{", "aa", "}"}], "]"}]], 
     RowBox[{
      RowBox[{"\[Eta]0$b", "[", "aa", "]"}], "[", 
      RowBox[{"-", "1"}], "]"}]}]}]}], "//", 
  "Simplify"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Series", "[", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{"rltUohr", "/.", "subusu"}], "/.", 
        RowBox[{"Shift", "[", 
         RowBox[{"-", "1"}], "]"}]}], "/.", 
       RowBox[{"u", "\[Rule]", 
        RowBox[{"u", "-", 
         FractionBox["\[ImaginaryI]", "2"]}]}]}], "/.", "subQ0"}], "/.", 
     RowBox[{"shiftm\[Eta]", "[", "3", "]"}]}], ",", 
    RowBox[{"{", 
     RowBox[{"u", ",", 
      RowBox[{"-", "v00"}], ",", 
      RowBox[{"-", "1"}]}], "}"}]}], "]"}], "/.", 
  RowBox[{
   RowBox[{
    RowBox[{"\[Eta]$", "[", "aa_", "]"}], "[", "1", "]"}], "\[RuleDelayed]", 
   RowBox[{
    SuperscriptBox[
     RowBox[{"(", 
      RowBox[{"-", "1"}], ")"}], 
     RowBox[{"Total", "[", 
      RowBox[{"{", "aa", "}"}], "]"}]], 
    RowBox[{
     RowBox[{"\[Eta]0$b", "[", "aa", "]"}], "[", 
     RowBox[{"-", "1"}], "]"}]}]}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"Series", "[", 
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{"rltUohr", "/.", "subusu"}], "/.", 
         RowBox[{"Shift", "[", 
          RowBox[{"-", "3"}], "]"}]}], "/.", 
        RowBox[{"u", "\[Rule]", 
         RowBox[{"u", "+", 
          FractionBox[
           RowBox[{
            RowBox[{"-", "3"}], "\[ImaginaryI]"}], "2"]}]}]}], "/.", 
       "subQ0"}], "//.", 
      RowBox[{"shiftp\[Eta]", "[", 
       RowBox[{"-", "1"}], "]"}]}], ",", 
     RowBox[{"{", 
      RowBox[{"u", ",", "v00", ",", 
       RowBox[{"-", "1"}]}], "}"}]}], "]"}], "/.", "sub\[Eta]\[Eta]0"}], "//",
   "Simplify"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"Series", "[", 
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{"rltUohr", "/.", "subusu"}], "/.", 
         RowBox[{"Shift", "[", 
          RowBox[{"-", "3"}], "]"}]}], "/.", 
        RowBox[{"u", "\[Rule]", 
         RowBox[{"u", "-", 
          RowBox[{"3", 
           FractionBox["\[ImaginaryI]", "2"]}]}]}]}], "/.", "subQ0"}], "//.", 
      
      RowBox[{"shiftp\[Eta]", "[", 
       RowBox[{"-", "1"}], "]"}]}], ",", 
     RowBox[{"{", 
      RowBox[{"u", ",", 
       RowBox[{"-", "v00"}], ",", 
       RowBox[{"-", "1"}]}], "}"}]}], "]"}], "/.", 
   RowBox[{
    RowBox[{
     RowBox[{"\[Eta]$", "[", "aa_", "]"}], "[", "1", "]"}], "\[RuleDelayed]", 
    
    RowBox[{
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{"-", "1"}], ")"}], 
      RowBox[{"Total", "[", 
       RowBox[{"{", "aa", "}"}], "]"}]], 
     RowBox[{
      RowBox[{"\[Eta]0$b", "[", "aa", "]"}], "[", 
      RowBox[{"-", "1"}], "]"}]}]}]}], "//", "Simplify"}]}], "Input",
 CellChangeTimes->{{3.560711081299787*^9, 3.560711179588904*^9}, {
  3.560948281892606*^9, 3.560948314042735*^9}, {3.562259763670886*^9, 
  3.562259793523962*^9}, {3.562259924908134*^9, 3.562259960154456*^9}}],

Cell[BoxData[
 InterpretationBox[
  SuperscriptBox[
   RowBox[{"O", "[", 
    RowBox[{"u", "-", 
     FractionBox["1", 
      RowBox[{"2", " ", 
       SqrtBox["3"]}]]}], "]"}], "0"],
  SeriesData[$CellContext`u, Rational[1, 2] 3^Rational[-1, 2], {}, 0, 0, 1],
  Editable->False]], "Output",
 CellChangeTimes->{
  3.562259960689468*^9, {3.562937323670302*^9, 3.5629373292411947`*^9}}],

Cell[BoxData[
 InterpretationBox[
  SuperscriptBox[
   RowBox[{"O", "[", 
    RowBox[{"u", "-", 
     FractionBox["1", 
      RowBox[{"2", " ", 
       SqrtBox["3"]}]]}], "]"}], "0"],
  SeriesData[$CellContext`u, Rational[1, 2] 3^Rational[-1, 2], {}, 0, 0, 1],
  Editable->False]], "Output",
 CellChangeTimes->{
  3.562259960689468*^9, {3.562937323670302*^9, 3.5629373293058167`*^9}}],

Cell[BoxData[
 InterpretationBox[
  SuperscriptBox[
   RowBox[{"O", "[", 
    RowBox[{"u", "+", 
     FractionBox["1", 
      RowBox[{"2", " ", 
       SqrtBox["3"]}]]}], "]"}], "0"],
  SeriesData[$CellContext`u, Rational[-1, 2] 3^Rational[-1, 2], {}, 0, 0, 1],
  Editable->False]], "Output",
 CellChangeTimes->{
  3.562259960689468*^9, {3.562937323670302*^9, 3.562937329360471*^9}}],

Cell[BoxData[
 InterpretationBox[
  SuperscriptBox[
   RowBox[{"O", "[", 
    RowBox[{"u", "+", 
     FractionBox["1", 
      RowBox[{"2", " ", 
       SqrtBox["3"]}]]}], "]"}], "0"],
  SeriesData[$CellContext`u, Rational[-1, 2] 3^Rational[-1, 2], {}, 0, 0, 1],
  Editable->False]], "Output",
 CellChangeTimes->{
  3.562259960689468*^9, {3.562937323670302*^9, 3.562937329382681*^9}}],

Cell[BoxData[
 InterpretationBox[
  SuperscriptBox[
   RowBox[{"O", "[", 
    RowBox[{"u", "-", 
     FractionBox["1", 
      RowBox[{"2", " ", 
       SqrtBox["3"]}]]}], "]"}], "0"],
  SeriesData[$CellContext`u, Rational[1, 2] 3^Rational[-1, 2], {}, 0, 0, 1],
  Editable->False]], "Output",
 CellChangeTimes->{
  3.562259960689468*^9, {3.562937323670302*^9, 3.562937329414493*^9}}],

Cell[BoxData[
 InterpretationBox[
  SuperscriptBox[
   RowBox[{"O", "[", 
    RowBox[{"u", "+", 
     FractionBox["1", 
      RowBox[{"2", " ", 
       SqrtBox["3"]}]]}], "]"}], "0"],
  SeriesData[$CellContext`u, Rational[-1, 2] 3^Rational[-1, 2], {}, 0, 0, 1],
  Editable->False]], "Output",
 CellChangeTimes->{
  3.562259960689468*^9, {3.562937323670302*^9, 3.562937329432073*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"alldens", "=", 
  RowBox[{"List", "@@", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"Times", "@@", 
      RowBox[{"(", 
       RowBox[{"Denominator", "/@", 
        RowBox[{"List", "@@", "rltUohr"}]}], ")"}]}], "/.", 
     RowBox[{
      RowBox[{"Power", "[", 
       RowBox[{"a_", ",", "b_"}], "]"}], "\[RuleDelayed]", "a"}]}], 
    ")"}]}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Collect", "[", 
   RowBox[{"rltUohr", ",", 
    RowBox[{
     RowBox[{"\[ScriptU]$", "[", "_", "]"}], "[", "_", "]"}]}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"tmp", "=", 
  RowBox[{"Join", "[", 
   RowBox[{
    RowBox[{"Table", "[", 
     RowBox[{
      RowBox[{"Select", "[", 
       RowBox[{"%", ",", 
        RowBox[{
         RowBox[{
          RowBox[{"FreeQ", "[", 
           RowBox[{"#", ",", 
            RowBox[{"Alternatives", "@@", 
             RowBox[{"Drop", "[", 
              RowBox[{"alldens", ",", "i"}], "]"}]}]}], "]"}], "&&", 
          RowBox[{"Not", "@", 
           RowBox[{"FreeQ", "[", 
            RowBox[{"#", ",", 
             RowBox[{"alldens", "[", 
              RowBox[{"[", "i", "]"}], "]"}]}], "]"}]}]}], "&"}]}], "]"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{"i", ",", 
        RowBox[{"Length", "[", "alldens", "]"}]}], "}"}]}], "]"}], ",", 
    RowBox[{"{", 
     RowBox[{"Select", "[", 
      RowBox[{"%", ",", 
       RowBox[{
        RowBox[{"FreeQ", "[", 
         RowBox[{"#", ",", 
          RowBox[{"Alternatives", "@@", "alldens"}]}], "]"}], "&"}]}], "]"}], 
     "}"}]}], "]"}]}]}], "Input",
 CellChangeTimes->{{3.56226039110525*^9, 3.562260403873473*^9}, {
  3.5622605137510242`*^9, 3.562260583402296*^9}, {3.562937395012999*^9, 
  3.562937402419627*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   StyleBox["\[ScriptU]",
    FontColor->RGBColor[0, 0, 0.4]], ",", 
   SuperscriptBox[
    StyleBox["\[ScriptU]",
     FontColor->RGBColor[0, 0, 0.4]], 
    RowBox[{"[", "2", "]"}]], ",", 
   SubsuperscriptBox[
    StyleBox["\[ScriptU]",
     FontColor->RGBColor[0, 0, 0.4]], 
    RowBox[{"-", "v0"}], "-"], ",", 
   SubsuperscriptBox[
    StyleBox["\[ScriptU]",
     FontColor->RGBColor[0, 0, 0.4]], 
    RowBox[{"-", "v0"}], 
    RowBox[{"[", "3", "]"}]], ",", 
   SubsuperscriptBox[
    StyleBox["\[ScriptU]",
     FontColor->RGBColor[0, 0, 0.4]], "v0", "-"], ",", 
   SubsuperscriptBox[
    StyleBox["\[ScriptU]",
     FontColor->RGBColor[0, 0, 0.4]], "v0", 
    RowBox[{"[", "3", "]"}]]}], "}"}]], "Output",
 CellChangeTimes->{{3.562260377396742*^9, 3.56226040516564*^9}, {
   3.562260563701503*^9, 3.5622605837908278`*^9}, 3.562937408398106*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{
    FractionBox[
     RowBox[{"27", "+", 
      RowBox[{"18", " ", 
       SubsuperscriptBox[
        StyleBox["\[Eta]",
         FontWeight->Bold,
         FontColor->RGBColor[0.8, 0, 0]], "2", 
        RowBox[{"[", "2", "]"}]]}]}], 
     SuperscriptBox[
      StyleBox["\[ScriptU]",
       FontColor->RGBColor[0, 0, 0.4]], "4"]], "+", 
    FractionBox[
     RowBox[{
      RowBox[{
       RowBox[{"-", "81"}], " ", "\[ImaginaryI]"}], "+", 
      RowBox[{"144", " ", "\[ImaginaryI]", " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "3"]}], "-", 
      RowBox[{"36", " ", 
       SubsuperscriptBox[
        StyleBox["\[Eta]",
         FontWeight->Bold,
         FontColor->RGBColor[0.8, 0, 0]], "3", 
        RowBox[{"[", "2", "]"}]]}]}], 
     SuperscriptBox[
      StyleBox["\[ScriptU]",
       FontColor->RGBColor[0, 0, 0.4]], "3"]], "+", 
    FractionBox[
     RowBox[{
      RowBox[{"108", " ", 
       SubsuperscriptBox[
        StyleBox["\[Eta]",
         FontWeight->Bold,
         FontColor->RGBColor[0.8, 0, 0]], "2", 
        RowBox[{"[", "2", "]"}]]}], "+", 
      RowBox[{"18", " ", 
       SubsuperscriptBox[
        StyleBox["\[Eta]",
         FontWeight->Bold,
         FontColor->RGBColor[0.8, 0, 0]], "4", 
        RowBox[{"[", "2", "]"}]]}]}], 
     SuperscriptBox[
      StyleBox["\[ScriptU]",
       FontColor->RGBColor[0, 0, 0.4]], "2"]], "+", 
    FractionBox[
     RowBox[{
      RowBox[{"540", " ", "\[ImaginaryI]", " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "3"]}], "-", 
      RowBox[{"360", " ", "\[ImaginaryI]", " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "5"]}], "+", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          RowBox[{"-", "54"}], " ", "\[ImaginaryI]"}], "+", 
         RowBox[{"216", " ", "\[ImaginaryI]", " ", 
          SubscriptBox[
           StyleBox["\[Zeta]",
            FontWeight->Bold,
            FontColor->GrayLevel[0.4]], "3"]}]}], ")"}], " ", 
       SubsuperscriptBox[
        StyleBox["\[Eta]",
         FontWeight->Bold,
         FontColor->RGBColor[0.8, 0, 0]], "2", 
        RowBox[{"[", "2", "]"}]]}], "-", 
      RowBox[{"54", " ", 
       SubsuperscriptBox[
        StyleBox["\[Eta]",
         FontWeight->Bold,
         FontColor->RGBColor[0.8, 0, 0]], "3", 
        RowBox[{"[", "2", "]"}]]}], "-", 
      RowBox[{"36", " ", 
       SubsuperscriptBox[
        StyleBox["\[Eta]",
         FontWeight->Bold,
         FontColor->RGBColor[0.8, 0, 0]], 
        RowBox[{"2", ",", "3"}], 
        RowBox[{"[", "2", "]"}]]}], "+", 
      RowBox[{"36", " ", 
       SubsuperscriptBox[
        StyleBox["\[Eta]",
         FontWeight->Bold,
         FontColor->RGBColor[0.8, 0, 0]], 
        RowBox[{"3", ",", "2"}], 
        RowBox[{"[", "2", "]"}]]}]}], 
     StyleBox["\[ScriptU]",
      FontColor->RGBColor[0, 0, 0.4]]]}], ",", 
   RowBox[{
    FractionBox[
     RowBox[{
      RowBox[{"-", "27"}], "+", 
      RowBox[{"18", " ", 
       SubsuperscriptBox[
        StyleBox["\[Eta]",
         FontWeight->Bold,
         FontColor->RGBColor[0.8, 0, 0]], "2", 
        RowBox[{"[", "2", "]"}]]}]}], 
     SuperscriptBox[
      RowBox[{"(", 
       SuperscriptBox[
        StyleBox["\[ScriptU]",
         FontColor->RGBColor[0, 0, 0.4]], 
        RowBox[{"[", "2", "]"}]], ")"}], "4"]], "+", 
    FractionBox[
     RowBox[{
      RowBox[{
       RowBox[{"-", "81"}], " ", "\[ImaginaryI]"}], "+", 
      RowBox[{"144", " ", "\[ImaginaryI]", " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "3"]}], "-", 
      RowBox[{"36", " ", 
       SubsuperscriptBox[
        StyleBox["\[Eta]",
         FontWeight->Bold,
         FontColor->RGBColor[0.8, 0, 0]], "3", 
        RowBox[{"[", "2", "]"}]]}]}], 
     SuperscriptBox[
      RowBox[{"(", 
       SuperscriptBox[
        StyleBox["\[ScriptU]",
         FontColor->RGBColor[0, 0, 0.4]], 
        RowBox[{"[", "2", "]"}]], ")"}], "3"]], "+", 
    FractionBox[
     RowBox[{
      RowBox[{"108", " ", 
       SubsuperscriptBox[
        StyleBox["\[Eta]",
         FontWeight->Bold,
         FontColor->RGBColor[0.8, 0, 0]], "2", 
        RowBox[{"[", "2", "]"}]]}], "+", 
      RowBox[{"18", " ", 
       SubsuperscriptBox[
        StyleBox["\[Eta]",
         FontWeight->Bold,
         FontColor->RGBColor[0.8, 0, 0]], "4", 
        RowBox[{"[", "2", "]"}]]}]}], 
     SuperscriptBox[
      RowBox[{"(", 
       SuperscriptBox[
        StyleBox["\[ScriptU]",
         FontColor->RGBColor[0, 0, 0.4]], 
        RowBox[{"[", "2", "]"}]], ")"}], "2"]], "+", 
    FractionBox[
     RowBox[{
      RowBox[{"540", " ", "\[ImaginaryI]", " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "3"]}], "-", 
      RowBox[{"360", " ", "\[ImaginaryI]", " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "5"]}], "+", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{"54", " ", "\[ImaginaryI]"}], "-", 
         RowBox[{"216", " ", "\[ImaginaryI]", " ", 
          SubscriptBox[
           StyleBox["\[Zeta]",
            FontWeight->Bold,
            FontColor->GrayLevel[0.4]], "3"]}]}], ")"}], " ", 
       SubsuperscriptBox[
        StyleBox["\[Eta]",
         FontWeight->Bold,
         FontColor->RGBColor[0.8, 0, 0]], "2", 
        RowBox[{"[", "2", "]"}]]}], "-", 
      RowBox[{"54", " ", 
       SubsuperscriptBox[
        StyleBox["\[Eta]",
         FontWeight->Bold,
         FontColor->RGBColor[0.8, 0, 0]], "3", 
        RowBox[{"[", "2", "]"}]]}], "+", 
      RowBox[{"36", " ", 
       SubsuperscriptBox[
        StyleBox["\[Eta]",
         FontWeight->Bold,
         FontColor->RGBColor[0.8, 0, 0]], 
        RowBox[{"2", ",", "3"}], 
        RowBox[{"[", "2", "]"}]]}], "-", 
      RowBox[{"36", " ", 
       SubsuperscriptBox[
        StyleBox["\[Eta]",
         FontWeight->Bold,
         FontColor->RGBColor[0.8, 0, 0]], 
        RowBox[{"3", ",", "2"}], 
        RowBox[{"[", "2", "]"}]]}]}], 
     SuperscriptBox[
      StyleBox["\[ScriptU]",
       FontColor->RGBColor[0, 0, 0.4]], 
      RowBox[{"[", "2", "]"}]]]}], ",", 
   FractionBox[
    RowBox[{
     FractionBox[
      RowBox[{"81", " ", "\[ImaginaryI]"}], "2"], "+", 
     FractionBox[
      RowBox[{"81", " ", 
       SqrtBox["3"]}], "2"], "-", 
     RowBox[{"54", " ", "\[ImaginaryI]", " ", 
      SubsuperscriptBox[
       StyleBox["\[Eta]0",
        FontWeight->Bold,
        FontColor->RGBColor[0, 0.5, 0]], "2", "+"]}], "+", 
     RowBox[{"18", " ", "\[ImaginaryI]", " ", 
      SqrtBox["3"], " ", 
      SubsuperscriptBox[
       StyleBox["\[Eta]0",
        FontWeight->Bold,
        FontColor->RGBColor[0, 0.5, 0]], "3", "+"]}], "-", 
     RowBox[{"9", " ", "\[ImaginaryI]", " ", 
      SubsuperscriptBox[
       StyleBox["\[Eta]0",
        FontWeight->Bold,
        FontColor->RGBColor[0, 0.5, 0]], "4", "+"]}], "+", 
     RowBox[{"54", " ", "\[ImaginaryI]", " ", 
      SubsuperscriptBox[
       StyleBox["\[Eta]",
        FontWeight->Bold,
        FontColor->RGBColor[0.8, 0, 0]], "2", 
       RowBox[{"[", "2", "]"}]]}], "-", 
     RowBox[{"18", " ", "\[ImaginaryI]", " ", 
      SqrtBox["3"], " ", 
      SubsuperscriptBox[
       StyleBox["\[Eta]",
        FontWeight->Bold,
        FontColor->RGBColor[0.8, 0, 0]], "3", 
       RowBox[{"[", "2", "]"}]]}], "+", 
     RowBox[{"9", " ", "\[ImaginaryI]", " ", 
      SubsuperscriptBox[
       StyleBox["\[Eta]",
        FontWeight->Bold,
        FontColor->RGBColor[0.8, 0, 0]], "4", 
       RowBox[{"[", "2", "]"}]]}]}], 
    SubsuperscriptBox[
     StyleBox["\[ScriptU]",
      FontColor->RGBColor[0, 0, 0.4]], 
     RowBox[{"-", "v0"}], "-"]], ",", 
   FractionBox[
    RowBox[{
     FractionBox[
      RowBox[{"81", " ", "\[ImaginaryI]"}], "2"], "-", 
     FractionBox[
      RowBox[{"81", " ", 
       SqrtBox["3"]}], "2"], "+", 
     RowBox[{"54", " ", "\[ImaginaryI]", " ", 
      SubsuperscriptBox[
       StyleBox["\[Eta]0",
        FontWeight->Bold,
        FontColor->RGBColor[0, 0.5, 0]], "2", "+"]}], "-", 
     RowBox[{"18", " ", "\[ImaginaryI]", " ", 
      SqrtBox["3"], " ", 
      SubsuperscriptBox[
       StyleBox["\[Eta]0",
        FontWeight->Bold,
        FontColor->RGBColor[0, 0.5, 0]], "3", "+"]}], "+", 
     RowBox[{"9", " ", "\[ImaginaryI]", " ", 
      SubsuperscriptBox[
       StyleBox["\[Eta]0",
        FontWeight->Bold,
        FontColor->RGBColor[0, 0.5, 0]], "4", "+"]}], "-", 
     RowBox[{"54", " ", "\[ImaginaryI]", " ", 
      SubsuperscriptBox[
       StyleBox["\[Eta]",
        FontWeight->Bold,
        FontColor->RGBColor[0.8, 0, 0]], "2", 
       RowBox[{"[", "2", "]"}]]}], "+", 
     RowBox[{"18", " ", "\[ImaginaryI]", " ", 
      SqrtBox["3"], " ", 
      SubsuperscriptBox[
       StyleBox["\[Eta]",
        FontWeight->Bold,
        FontColor->RGBColor[0.8, 0, 0]], "3", 
       RowBox[{"[", "2", "]"}]]}], "-", 
     RowBox[{"9", " ", "\[ImaginaryI]", " ", 
      SubsuperscriptBox[
       StyleBox["\[Eta]",
        FontWeight->Bold,
        FontColor->RGBColor[0.8, 0, 0]], "4", 
       RowBox[{"[", "2", "]"}]]}]}], 
    SubsuperscriptBox[
     StyleBox["\[ScriptU]",
      FontColor->RGBColor[0, 0, 0.4]], 
     RowBox[{"-", "v0"}], 
     RowBox[{"[", "3", "]"}]]], ",", 
   FractionBox[
    RowBox[{
     FractionBox[
      RowBox[{"81", " ", "\[ImaginaryI]"}], "2"], "-", 
     FractionBox[
      RowBox[{"81", " ", 
       SqrtBox["3"]}], "2"], "-", 
     RowBox[{"54", " ", "\[ImaginaryI]", " ", 
      SubsuperscriptBox[
       OverscriptBox[
        StyleBox["\[Eta]0",
         FontWeight->Bold,
         FontColor->RGBColor[0, 0.5, 0]], 
        StyleBox["_",
         FontWeight->Bold,
         FontColor->RGBColor[0, 0.5, 0]]], "2", "-"]}], "+", 
     RowBox[{"18", " ", "\[ImaginaryI]", " ", 
      SqrtBox["3"], " ", 
      SubsuperscriptBox[
       OverscriptBox[
        StyleBox["\[Eta]0",
         FontWeight->Bold,
         FontColor->RGBColor[0, 0.5, 0]], 
        StyleBox["_",
         FontWeight->Bold,
         FontColor->RGBColor[0, 0.5, 0]]], "3", "-"]}], "-", 
     RowBox[{"9", " ", "\[ImaginaryI]", " ", 
      SubsuperscriptBox[
       OverscriptBox[
        StyleBox["\[Eta]0",
         FontWeight->Bold,
         FontColor->RGBColor[0, 0.5, 0]], 
        StyleBox["_",
         FontWeight->Bold,
         FontColor->RGBColor[0, 0.5, 0]]], "4", "-"]}], "+", 
     RowBox[{"54", " ", "\[ImaginaryI]", " ", 
      SubsuperscriptBox[
       StyleBox["\[Eta]",
        FontWeight->Bold,
        FontColor->RGBColor[0.8, 0, 0]], "2", 
       RowBox[{"[", "2", "]"}]]}], "+", 
     RowBox[{"18", " ", "\[ImaginaryI]", " ", 
      SqrtBox["3"], " ", 
      SubsuperscriptBox[
       StyleBox["\[Eta]",
        FontWeight->Bold,
        FontColor->RGBColor[0.8, 0, 0]], "3", 
       RowBox[{"[", "2", "]"}]]}], "+", 
     RowBox[{"9", " ", "\[ImaginaryI]", " ", 
      SubsuperscriptBox[
       StyleBox["\[Eta]",
        FontWeight->Bold,
        FontColor->RGBColor[0.8, 0, 0]], "4", 
       RowBox[{"[", "2", "]"}]]}]}], 
    SubsuperscriptBox[
     StyleBox["\[ScriptU]",
      FontColor->RGBColor[0, 0, 0.4]], "v0", "-"]], ",", 
   FractionBox[
    RowBox[{
     FractionBox[
      RowBox[{"81", " ", "\[ImaginaryI]"}], "2"], "+", 
     FractionBox[
      RowBox[{"81", " ", 
       SqrtBox["3"]}], "2"], "+", 
     RowBox[{"54", " ", "\[ImaginaryI]", " ", 
      SubsuperscriptBox[
       OverscriptBox[
        StyleBox["\[Eta]0",
         FontWeight->Bold,
         FontColor->RGBColor[0, 0.5, 0]], 
        StyleBox["_",
         FontWeight->Bold,
         FontColor->RGBColor[0, 0.5, 0]]], "2", "-"]}], "-", 
     RowBox[{"18", " ", "\[ImaginaryI]", " ", 
      SqrtBox["3"], " ", 
      SubsuperscriptBox[
       OverscriptBox[
        StyleBox["\[Eta]0",
         FontWeight->Bold,
         FontColor->RGBColor[0, 0.5, 0]], 
        StyleBox["_",
         FontWeight->Bold,
         FontColor->RGBColor[0, 0.5, 0]]], "3", "-"]}], "+", 
     RowBox[{"9", " ", "\[ImaginaryI]", " ", 
      SubsuperscriptBox[
       OverscriptBox[
        StyleBox["\[Eta]0",
         FontWeight->Bold,
         FontColor->RGBColor[0, 0.5, 0]], 
        StyleBox["_",
         FontWeight->Bold,
         FontColor->RGBColor[0, 0.5, 0]]], "4", "-"]}], "-", 
     RowBox[{"54", " ", "\[ImaginaryI]", " ", 
      SubsuperscriptBox[
       StyleBox["\[Eta]",
        FontWeight->Bold,
        FontColor->RGBColor[0.8, 0, 0]], "2", 
       RowBox[{"[", "2", "]"}]]}], "-", 
     RowBox[{"18", " ", "\[ImaginaryI]", " ", 
      SqrtBox["3"], " ", 
      SubsuperscriptBox[
       StyleBox["\[Eta]",
        FontWeight->Bold,
        FontColor->RGBColor[0.8, 0, 0]], "3", 
       RowBox[{"[", "2", "]"}]]}], "-", 
     RowBox[{"9", " ", "\[ImaginaryI]", " ", 
      SubsuperscriptBox[
       StyleBox["\[Eta]",
        FontWeight->Bold,
        FontColor->RGBColor[0.8, 0, 0]], "4", 
       RowBox[{"[", "2", "]"}]]}]}], 
    SubsuperscriptBox[
     StyleBox["\[ScriptU]",
      FontColor->RGBColor[0, 0, 0.4]], "v0", 
     RowBox[{"[", "3", "]"}]]], ",", 
   RowBox[{
    RowBox[{"648", " ", 
     SubscriptBox[
      StyleBox["\[Zeta]",
       FontWeight->Bold,
       FontColor->GrayLevel[0.4]], "3"], " ", 
     SubsuperscriptBox[
      StyleBox["\[Eta]",
       FontWeight->Bold,
       FontColor->RGBColor[0.8, 0, 0]], "2", 
      RowBox[{"[", "2", "]"}]]}], "+", 
    RowBox[{"108", " ", "\[ImaginaryI]", " ", 
     SubsuperscriptBox[
      StyleBox["\[Eta]",
       FontWeight->Bold,
       FontColor->RGBColor[0.8, 0, 0]], 
      RowBox[{"2", ",", "3"}], 
      RowBox[{"[", "2", "]"}]]}], "-", 
    RowBox[{"108", " ", "\[ImaginaryI]", " ", 
     SubsuperscriptBox[
      StyleBox["\[Eta]",
       FontWeight->Bold,
       FontColor->RGBColor[0.8, 0, 0]], 
      RowBox[{"3", ",", "2"}], 
      RowBox[{"[", "2", "]"}]]}]}]}], "}"}]], "Output",
 CellChangeTimes->{{3.562260377396742*^9, 3.56226040516564*^9}, {
   3.562260563701503*^9, 3.5622605837908278`*^9}, 3.56293740846842*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Total", "[", "tmp", "]"}], "-", "rltUohr"}], "//", 
  "Expand"}]], "Input",
 CellChangeTimes->{{3.56226058484706*^9, 3.562260594004837*^9}, {
  3.562937412390108*^9, 3.562937413085919*^9}}],

Cell[BoxData["0"], "Output",
 CellChangeTimes->{{3.5622605906909323`*^9, 3.562260594225081*^9}, 
   3.5629374134159193`*^9}]
}, Open  ]],

Cell["\<\
For the terms which do not depend on v0, I can apply UpIntegrate with \
properly chose contour\
\>", "Text",
 CellChangeTimes->{{3.562260666880443*^9, 3.562260691287387*^9}, {
  3.5622621071035347`*^9, 3.56226211516472*^9}}],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"UpIntegrate", "[", 
     RowBox[{
      RowBox[{
       FractionBox["1", 
        RowBox[{"2", "\[Pi]", " ", "\[ImaginaryI]"}]], 
       RowBox[{
        RowBox[{"\[Eta]$b", "[", "1", "]"}], "[", 
        RowBox[{"2", "\[ImaginaryI]", " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"Re", "[", "v", "]"}], "+", 
           RowBox[{"\[ImaginaryI]", "/", "8"}]}], ")"}]}], "]"}], 
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          RowBox[{
           RowBox[{
            RowBox[{"tmp", "[", 
             RowBox[{"[", "1", "]"}], "]"}], "+", 
            RowBox[{"tmp", "[", 
             RowBox[{"[", "2", "]"}], "]"}], "+", 
            RowBox[{"tmp", "[", 
             RowBox[{"[", 
              RowBox[{"-", "1"}], "]"}], "]"}]}], "/.", 
           RowBox[{"Shift", "[", "\[Epsilon]", "]"}]}], "/.", 
          RowBox[{"u", "\[Rule]", 
           RowBox[{"u", "+", 
            FractionBox[
             RowBox[{"\[ImaginaryI]", " ", "\[Epsilon]"}], "2"]}]}]}], "/.", 
         "subusu"}], ")"}]}], ",", "u"}], "]"}], "/.", 
    RowBox[{
     RowBox[{"Re", "[", "v", "]"}], "\[Rule]", 
     RowBox[{"u", "-", 
      RowBox[{"\[ImaginaryI]", "/", "8"}]}]}]}], "/.", "EndSimplify"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"%", "//", "FuntoMHZbasis"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"rlt1", "=", 
  RowBox[{"Collect", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"Collect", "[", 
      RowBox[{"%", ",", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"\[Eta]list", ",", "u"}], "}"}], "//", "Flatten"}]}], "]"}], 
     "/.", "subtousu"}], ",", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"\[Eta]list", ",", 
       RowBox[{
        RowBox[{"\[ScriptU]$", "[", "_", "]"}], "[", "_", "]"}]}], "}"}], "//",
      "Flatten"}]}], "]"}]}]}], "Input",
 CellChangeTimes->{{3.562260697044024*^9, 3.562260865848016*^9}, {
  3.5622609126470013`*^9, 3.562260912870384*^9}, {3.5622609450617*^9, 
  3.562260947017187*^9}, {3.562261106370558*^9, 3.5622611560539303`*^9}, {
  3.56226159548335*^9, 3.562261595665612*^9}, {3.562261653783861*^9, 
  3.562261822348838*^9}, {3.5622618682681303`*^9, 3.5622618747518806`*^9}, {
  3.562261931666959*^9, 3.56226204261769*^9}, {3.5622621291626577`*^9, 
  3.562262201843885*^9}, {3.5622622586658363`*^9, 3.5622623456630087`*^9}, {
  3.562262376332057*^9, 3.562262446769731*^9}, {3.562937431983604*^9, 
  3.562937435169608*^9}}],

Cell[BoxData[
 RowBox[{
  FractionBox["27", 
   SuperscriptBox[
    StyleBox["\[ScriptU]",
     FontColor->RGBColor[0, 0, 0.4]], "4"]], "+", 
  FractionBox[
   RowBox[{
    RowBox[{
     RowBox[{"-", "81"}], " ", "\[ImaginaryI]"}], "+", 
    RowBox[{"144", " ", "\[ImaginaryI]", " ", 
     SubscriptBox[
      StyleBox["\[Zeta]",
       FontWeight->Bold,
       FontColor->GrayLevel[0.4]], "3"]}]}], 
   SuperscriptBox[
    StyleBox["\[ScriptU]",
     FontColor->RGBColor[0, 0, 0.4]], "3"]], "+", 
  FractionBox[
   RowBox[{
    RowBox[{"540", " ", "\[ImaginaryI]", " ", 
     SubscriptBox[
      StyleBox["\[Zeta]",
       FontWeight->Bold,
       FontColor->GrayLevel[0.4]], "3"]}], "-", 
    RowBox[{"360", " ", "\[ImaginaryI]", " ", 
     SubscriptBox[
      StyleBox["\[Zeta]",
       FontWeight->Bold,
       FontColor->GrayLevel[0.4]], "5"]}]}], 
   StyleBox["\[ScriptU]",
    FontColor->RGBColor[0, 0, 0.4]]], "+", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     RowBox[{"432", " ", "\[ImaginaryI]", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3"]}], "-", 
     RowBox[{"720", " ", "\[ImaginaryI]", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "5"]}]}], ")"}], " ", 
   SubsuperscriptBox[
    StyleBox["\[Eta]",
     FontWeight->Bold,
     FontColor->RGBColor[0.8, 0, 0]], "1", 
    RowBox[{"[", "2", "]"}]]}], "+", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     FractionBox["18", 
      SuperscriptBox[
       StyleBox["\[ScriptU]",
        FontColor->RGBColor[0, 0, 0.4]], "4"]], "+", 
     FractionBox["108", 
      SuperscriptBox[
       StyleBox["\[ScriptU]",
        FontColor->RGBColor[0, 0, 0.4]], "2"]], "+", 
     FractionBox[
      RowBox[{
       RowBox[{
        RowBox[{"-", "54"}], " ", "\[ImaginaryI]"}], "+", 
       RowBox[{"216", " ", "\[ImaginaryI]", " ", 
        SubscriptBox[
         StyleBox["\[Zeta]",
          FontWeight->Bold,
          FontColor->GrayLevel[0.4]], "3"]}]}], 
      StyleBox["\[ScriptU]",
       FontColor->RGBColor[0, 0, 0.4]]], "+", 
     RowBox[{"648", " ", "\[ImaginaryI]", " ", "u", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3"]}]}], ")"}], " ", 
   SubsuperscriptBox[
    StyleBox["\[Eta]",
     FontWeight->Bold,
     FontColor->RGBColor[0.8, 0, 0]], "2", 
    RowBox[{"[", "2", "]"}]]}], "+", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     RowBox[{
      RowBox[{"-", "108"}], " ", "\[ImaginaryI]"}], "-", 
     FractionBox["36", 
      SuperscriptBox[
       StyleBox["\[ScriptU]",
        FontColor->RGBColor[0, 0, 0.4]], "3"]], "-", 
     FractionBox["54", 
      StyleBox["\[ScriptU]",
       FontColor->RGBColor[0, 0, 0.4]]], "+", 
     RowBox[{"72", " ", "\[ImaginaryI]", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3"]}]}], ")"}], " ", 
   SubsuperscriptBox[
    StyleBox["\[Eta]",
     FontWeight->Bold,
     FontColor->RGBColor[0.8, 0, 0]], "3", 
    RowBox[{"[", "2", "]"}]]}], "+", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{"54", "+", 
     FractionBox["18", 
      SuperscriptBox[
       StyleBox["\[ScriptU]",
        FontColor->RGBColor[0, 0, 0.4]], "2"]]}], ")"}], " ", 
   SubsuperscriptBox[
    StyleBox["\[Eta]",
     FontWeight->Bold,
     FontColor->RGBColor[0.8, 0, 0]], "4", 
    RowBox[{"[", "2", "]"}]]}], "+", 
  RowBox[{"108", " ", 
   SubsuperscriptBox[
    StyleBox["\[Eta]",
     FontWeight->Bold,
     FontColor->RGBColor[0.8, 0, 0]], 
    RowBox[{"2", ",", "2"}], 
    RowBox[{"[", "2", "]"}]]}], "+", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     RowBox[{
      RowBox[{"-", "108"}], " ", "u"}], "-", 
     FractionBox["36", 
      StyleBox["\[ScriptU]",
       FontColor->RGBColor[0, 0, 0.4]]]}], ")"}], " ", 
   SubsuperscriptBox[
    StyleBox["\[Eta]",
     FontWeight->Bold,
     FontColor->RGBColor[0.8, 0, 0]], 
    RowBox[{"2", ",", "3"}], 
    RowBox[{"[", "2", "]"}]]}], "+", 
  RowBox[{"36", " ", 
   SubsuperscriptBox[
    StyleBox["\[Eta]",
     FontWeight->Bold,
     FontColor->RGBColor[0.8, 0, 0]], 
    RowBox[{"2", ",", "4"}], 
    RowBox[{"[", "2", "]"}]]}], "+", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     RowBox[{"108", " ", "u"}], "+", 
     FractionBox["36", 
      StyleBox["\[ScriptU]",
       FontColor->RGBColor[0, 0, 0.4]]]}], ")"}], " ", 
   SubsuperscriptBox[
    StyleBox["\[Eta]",
     FontWeight->Bold,
     FontColor->RGBColor[0.8, 0, 0]], 
    RowBox[{"3", ",", "2"}], 
    RowBox[{"[", "2", "]"}]]}], "-", 
  RowBox[{"36", " ", 
   SubsuperscriptBox[
    StyleBox["\[Eta]",
     FontWeight->Bold,
     FontColor->RGBColor[0.8, 0, 0]], 
    RowBox[{"3", ",", "3"}], 
    RowBox[{"[", "2", "]"}]]}]}]], "Output",
 CellChangeTimes->{{3.562261813878364*^9, 3.562261823459292*^9}, 
   3.562261901218102*^9, {3.5622619498226957`*^9, 3.562261958617649*^9}, {
   3.562261990033951*^9, 3.562262018541417*^9}, 3.562262069612432*^9, {
   3.5622621530460463`*^9, 3.56226220388067*^9}, {3.562262260641959*^9, 
   3.562262346154091*^9}, {3.562262378556889*^9, 3.562262449088841*^9}, 
   3.562937451410149*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"rlt1", "-", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       RowBox[{"rlt1", "/.", 
        RowBox[{"Shift", "[", "2", "]"}]}], "/.", 
       RowBox[{"u", "\[Rule]", 
        RowBox[{"u", "+", "\[ImaginaryI]"}]}]}], "//.", 
      RowBox[{"shiftm\[Eta]", "[", "4", "]"}]}], ")"}], "-", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"tmp", "[", 
       RowBox[{"[", "1", "]"}], "]"}], "+", 
      RowBox[{"tmp", "[", 
       RowBox[{"[", "2", "]"}], "]"}], "+", 
      RowBox[{"tmp", "[", 
       RowBox[{"[", 
        RowBox[{"-", "1"}], "]"}], "]"}]}], ")"}]}], "/.", "subusu"}], "//", 
  "Simplify"}]], "Input",
 CellChangeTimes->{{3.562262204579294*^9, 3.562262255274918*^9}, 
   3.562262293044448*^9, {3.562262360006817*^9, 3.5622624043967237`*^9}, {
   3.562262463827425*^9, 3.56226247028913*^9}, {3.562937443382236*^9, 
   3.562937446967722*^9}}],

Cell[BoxData["0"], "Output",
 CellChangeTimes->{{3.562262215745693*^9, 3.562262262430407*^9}, 
   3.562262294001741*^9, {3.562262363161779*^9, 3.562262404840962*^9}, {
   3.562262465305491*^9, 3.5622624710696383`*^9}, 3.562937452975651*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"t1minus", "=", 
  RowBox[{
   RowBox[{"tmp", "[", 
    RowBox[{"[", "3", "]"}], "]"}], "+", 
   RowBox[{"tmp", "[", 
    RowBox[{"[", "5", "]"}], "]"}]}]}], "\[IndentingNewLine]", 
 RowBox[{"t3plus", "=", 
  RowBox[{
   RowBox[{"tmp", "[", 
    RowBox[{"[", "4", "]"}], "]"}], "+", 
   RowBox[{"tmp", "[", 
    RowBox[{"[", "6", "]"}], "]"}]}]}], "\[IndentingNewLine]", 
 RowBox[{"t1plus", "=", "0"}]}], "Input",
 CellChangeTimes->{{3.562262511812277*^9, 3.562262577228243*^9}, {
  3.562262632017578*^9, 3.562262677999955*^9}, {3.562937458101796*^9, 
  3.562937462956831*^9}}],

Cell[BoxData[
 RowBox[{
  FractionBox[
   RowBox[{
    FractionBox[
     RowBox[{"81", " ", "\[ImaginaryI]"}], "2"], "+", 
    FractionBox[
     RowBox[{"81", " ", 
      SqrtBox["3"]}], "2"], "-", 
    RowBox[{"54", " ", "\[ImaginaryI]", " ", 
     SubsuperscriptBox[
      StyleBox["\[Eta]0",
       FontWeight->Bold,
       FontColor->RGBColor[0, 0.5, 0]], "2", "+"]}], "+", 
    RowBox[{"18", " ", "\[ImaginaryI]", " ", 
     SqrtBox["3"], " ", 
     SubsuperscriptBox[
      StyleBox["\[Eta]0",
       FontWeight->Bold,
       FontColor->RGBColor[0, 0.5, 0]], "3", "+"]}], "-", 
    RowBox[{"9", " ", "\[ImaginaryI]", " ", 
     SubsuperscriptBox[
      StyleBox["\[Eta]0",
       FontWeight->Bold,
       FontColor->RGBColor[0, 0.5, 0]], "4", "+"]}], "+", 
    RowBox[{"54", " ", "\[ImaginaryI]", " ", 
     SubsuperscriptBox[
      StyleBox["\[Eta]",
       FontWeight->Bold,
       FontColor->RGBColor[0.8, 0, 0]], "2", 
      RowBox[{"[", "2", "]"}]]}], "-", 
    RowBox[{"18", " ", "\[ImaginaryI]", " ", 
     SqrtBox["3"], " ", 
     SubsuperscriptBox[
      StyleBox["\[Eta]",
       FontWeight->Bold,
       FontColor->RGBColor[0.8, 0, 0]], "3", 
      RowBox[{"[", "2", "]"}]]}], "+", 
    RowBox[{"9", " ", "\[ImaginaryI]", " ", 
     SubsuperscriptBox[
      StyleBox["\[Eta]",
       FontWeight->Bold,
       FontColor->RGBColor[0.8, 0, 0]], "4", 
      RowBox[{"[", "2", "]"}]]}]}], 
   SubsuperscriptBox[
    StyleBox["\[ScriptU]",
     FontColor->RGBColor[0, 0, 0.4]], 
    RowBox[{"-", "v0"}], "-"]], "+", 
  FractionBox[
   RowBox[{
    FractionBox[
     RowBox[{"81", " ", "\[ImaginaryI]"}], "2"], "-", 
    FractionBox[
     RowBox[{"81", " ", 
      SqrtBox["3"]}], "2"], "-", 
    RowBox[{"54", " ", "\[ImaginaryI]", " ", 
     SubsuperscriptBox[
      OverscriptBox[
       StyleBox["\[Eta]0",
        FontWeight->Bold,
        FontColor->RGBColor[0, 0.5, 0]], 
       StyleBox["_",
        FontWeight->Bold,
        FontColor->RGBColor[0, 0.5, 0]]], "2", "-"]}], "+", 
    RowBox[{"18", " ", "\[ImaginaryI]", " ", 
     SqrtBox["3"], " ", 
     SubsuperscriptBox[
      OverscriptBox[
       StyleBox["\[Eta]0",
        FontWeight->Bold,
        FontColor->RGBColor[0, 0.5, 0]], 
       StyleBox["_",
        FontWeight->Bold,
        FontColor->RGBColor[0, 0.5, 0]]], "3", "-"]}], "-", 
    RowBox[{"9", " ", "\[ImaginaryI]", " ", 
     SubsuperscriptBox[
      OverscriptBox[
       StyleBox["\[Eta]0",
        FontWeight->Bold,
        FontColor->RGBColor[0, 0.5, 0]], 
       StyleBox["_",
        FontWeight->Bold,
        FontColor->RGBColor[0, 0.5, 0]]], "4", "-"]}], "+", 
    RowBox[{"54", " ", "\[ImaginaryI]", " ", 
     SubsuperscriptBox[
      StyleBox["\[Eta]",
       FontWeight->Bold,
       FontColor->RGBColor[0.8, 0, 0]], "2", 
      RowBox[{"[", "2", "]"}]]}], "+", 
    RowBox[{"18", " ", "\[ImaginaryI]", " ", 
     SqrtBox["3"], " ", 
     SubsuperscriptBox[
      StyleBox["\[Eta]",
       FontWeight->Bold,
       FontColor->RGBColor[0.8, 0, 0]], "3", 
      RowBox[{"[", "2", "]"}]]}], "+", 
    RowBox[{"9", " ", "\[ImaginaryI]", " ", 
     SubsuperscriptBox[
      StyleBox["\[Eta]",
       FontWeight->Bold,
       FontColor->RGBColor[0.8, 0, 0]], "4", 
      RowBox[{"[", "2", "]"}]]}]}], 
   SubsuperscriptBox[
    StyleBox["\[ScriptU]",
     FontColor->RGBColor[0, 0, 0.4]], "v0", "-"]]}]], "Output",
 CellChangeTimes->{{3.5622625264191933`*^9, 3.562262577566063*^9}, {
   3.562262656815782*^9, 3.562262678456699*^9}, 3.5629374685390673`*^9}],

Cell[BoxData[
 RowBox[{
  FractionBox[
   RowBox[{
    FractionBox[
     RowBox[{"81", " ", "\[ImaginaryI]"}], "2"], "+", 
    FractionBox[
     RowBox[{"81", " ", 
      SqrtBox["3"]}], "2"], "+", 
    RowBox[{"54", " ", "\[ImaginaryI]", " ", 
     SubsuperscriptBox[
      OverscriptBox[
       StyleBox["\[Eta]0",
        FontWeight->Bold,
        FontColor->RGBColor[0, 0.5, 0]], 
       StyleBox["_",
        FontWeight->Bold,
        FontColor->RGBColor[0, 0.5, 0]]], "2", "-"]}], "-", 
    RowBox[{"18", " ", "\[ImaginaryI]", " ", 
     SqrtBox["3"], " ", 
     SubsuperscriptBox[
      OverscriptBox[
       StyleBox["\[Eta]0",
        FontWeight->Bold,
        FontColor->RGBColor[0, 0.5, 0]], 
       StyleBox["_",
        FontWeight->Bold,
        FontColor->RGBColor[0, 0.5, 0]]], "3", "-"]}], "+", 
    RowBox[{"9", " ", "\[ImaginaryI]", " ", 
     SubsuperscriptBox[
      OverscriptBox[
       StyleBox["\[Eta]0",
        FontWeight->Bold,
        FontColor->RGBColor[0, 0.5, 0]], 
       StyleBox["_",
        FontWeight->Bold,
        FontColor->RGBColor[0, 0.5, 0]]], "4", "-"]}], "-", 
    RowBox[{"54", " ", "\[ImaginaryI]", " ", 
     SubsuperscriptBox[
      StyleBox["\[Eta]",
       FontWeight->Bold,
       FontColor->RGBColor[0.8, 0, 0]], "2", 
      RowBox[{"[", "2", "]"}]]}], "-", 
    RowBox[{"18", " ", "\[ImaginaryI]", " ", 
     SqrtBox["3"], " ", 
     SubsuperscriptBox[
      StyleBox["\[Eta]",
       FontWeight->Bold,
       FontColor->RGBColor[0.8, 0, 0]], "3", 
      RowBox[{"[", "2", "]"}]]}], "-", 
    RowBox[{"9", " ", "\[ImaginaryI]", " ", 
     SubsuperscriptBox[
      StyleBox["\[Eta]",
       FontWeight->Bold,
       FontColor->RGBColor[0.8, 0, 0]], "4", 
      RowBox[{"[", "2", "]"}]]}]}], 
   SubsuperscriptBox[
    StyleBox["\[ScriptU]",
     FontColor->RGBColor[0, 0, 0.4]], "v0", 
    RowBox[{"[", "3", "]"}]]], "+", 
  FractionBox[
   RowBox[{
    FractionBox[
     RowBox[{"81", " ", "\[ImaginaryI]"}], "2"], "-", 
    FractionBox[
     RowBox[{"81", " ", 
      SqrtBox["3"]}], "2"], "+", 
    RowBox[{"54", " ", "\[ImaginaryI]", " ", 
     SubsuperscriptBox[
      StyleBox["\[Eta]0",
       FontWeight->Bold,
       FontColor->RGBColor[0, 0.5, 0]], "2", "+"]}], "-", 
    RowBox[{"18", " ", "\[ImaginaryI]", " ", 
     SqrtBox["3"], " ", 
     SubsuperscriptBox[
      StyleBox["\[Eta]0",
       FontWeight->Bold,
       FontColor->RGBColor[0, 0.5, 0]], "3", "+"]}], "+", 
    RowBox[{"9", " ", "\[ImaginaryI]", " ", 
     SubsuperscriptBox[
      StyleBox["\[Eta]0",
       FontWeight->Bold,
       FontColor->RGBColor[0, 0.5, 0]], "4", "+"]}], "-", 
    RowBox[{"54", " ", "\[ImaginaryI]", " ", 
     SubsuperscriptBox[
      StyleBox["\[Eta]",
       FontWeight->Bold,
       FontColor->RGBColor[0.8, 0, 0]], "2", 
      RowBox[{"[", "2", "]"}]]}], "+", 
    RowBox[{"18", " ", "\[ImaginaryI]", " ", 
     SqrtBox["3"], " ", 
     SubsuperscriptBox[
      StyleBox["\[Eta]",
       FontWeight->Bold,
       FontColor->RGBColor[0.8, 0, 0]], "3", 
      RowBox[{"[", "2", "]"}]]}], "-", 
    RowBox[{"9", " ", "\[ImaginaryI]", " ", 
     SubsuperscriptBox[
      StyleBox["\[Eta]",
       FontWeight->Bold,
       FontColor->RGBColor[0.8, 0, 0]], "4", 
      RowBox[{"[", "2", "]"}]]}]}], 
   SubsuperscriptBox[
    StyleBox["\[ScriptU]",
     FontColor->RGBColor[0, 0, 0.4]], 
    RowBox[{"-", "v0"}], 
    RowBox[{"[", "3", "]"}]]]}]], "Output",
 CellChangeTimes->{{3.5622625264191933`*^9, 3.562262577566063*^9}, {
   3.562262656815782*^9, 3.562262678456699*^9}, 3.5629374686005087`*^9}],

Cell[BoxData["0"], "Output",
 CellChangeTimes->{{3.5622625264191933`*^9, 3.562262577566063*^9}, {
   3.562262656815782*^9, 3.562262678456699*^9}, 3.56293746861646*^9}]
}, Open  ]],

Cell["Strategy is the following (t1plus is zero in fact):", "Text",
 CellChangeTimes->{{3.562262535939439*^9, 3.562262591009074*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    FractionBox["1", 
     RowBox[{"1", "-", 
      SuperscriptBox["D", "2"]}]], "t1minus"}], "+", 
   RowBox[{
    FractionBox["1", 
     RowBox[{"1", "-", 
      SuperscriptBox["D", "2"]}]], "t1plus"}], "+", 
   RowBox[{
    FractionBox["1", 
     RowBox[{"1", "-", 
      SuperscriptBox["D", "2"]}]], "t3plus"}]}], "\[Equal]", 
  RowBox[{"t1minus", "-", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"t3plus", "/.", 
      RowBox[{"Shift", "[", 
       RowBox[{"-", "2"}], "]"}]}], "/.", 
     RowBox[{"u", "\[Rule]", 
      RowBox[{"u", "-", "\[ImaginaryI]"}]}]}], ")"}], "+", 
   RowBox[{
    FractionBox["1", 
     RowBox[{"1", "-", 
      SuperscriptBox["D", "2"]}]], 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"t3plus", "/.", 
         RowBox[{"Shift", "[", 
          RowBox[{"-", "2"}], "]"}]}], "/.", 
        RowBox[{"u", "\[Rule]", 
         RowBox[{"u", "-", "\[ImaginaryI]"}]}]}], ")"}], "+", 
      RowBox[{"(", "t1plus", ")"}], "+", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"t1minus", "/.", 
         RowBox[{"Shift", "[", "2", "]"}]}], "/.", 
        RowBox[{"u", "\[Rule]", 
         RowBox[{"u", "+", "\[ImaginaryI]"}]}]}], ")"}]}], 
     ")"}]}]}]}]], "Input",
 CellChangeTimes->{{3.560858953847732*^9, 3.560859001221689*^9}, {
  3.560948605769051*^9, 3.560948673495119*^9}, {3.560948707102998*^9, 
  3.560948735729987*^9}, {3.562262579884151*^9, 3.562262609252162*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"tmp2", "=", 
   RowBox[{"Collect", "[", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           RowBox[{"t3plus", "/.", 
            RowBox[{"Shift", "[", 
             RowBox[{"-", "2"}], "]"}]}], "/.", 
           RowBox[{"u", "\[Rule]", 
            RowBox[{"u", "-", "\[ImaginaryI]"}]}]}], ")"}], "+", 
         RowBox[{"(", "t1plus", ")"}], "+", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"t1minus", "/.", 
            RowBox[{"Shift", "[", "2", "]"}]}], "/.", 
           RowBox[{"u", "\[Rule]", 
            RowBox[{"u", "+", "\[ImaginaryI]"}]}]}], ")"}]}], "//.", 
        RowBox[{"shiftm\[Eta]", "[", "4", "]"}]}], "//.", 
       RowBox[{"shiftp\[Eta]", "[", "0", "]"}]}], ")"}], ",", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{
         RowBox[{"\[ScriptU]$", "[", "_", "]"}], "[", "_", "]"}], ",", 
        "\[Eta]list"}], "}"}], "//", "Flatten"}]}], "]"}]}], 
  "\[IndentingNewLine]"}]], "Input",
 CellChangeTimes->{
  3.560948843462245*^9, 3.560948878089788*^9, {3.56226268246707*^9, 
   3.562262753462599*^9}, 3.562937521686455*^9}],

Cell[BoxData[
 RowBox[{
  FractionBox[
   RowBox[{
    RowBox[{"81", " ", "\[ImaginaryI]"}], "-", 
    FractionBox[
     RowBox[{"9", " ", "\[ImaginaryI]"}], 
     SuperscriptBox["u", "4"]], "+", 
    FractionBox[
     RowBox[{"18", " ", "\[ImaginaryI]", " ", 
      SqrtBox["3"]}], 
     SuperscriptBox["u", "3"]], "-", 
    FractionBox[
     RowBox[{"54", " ", "\[ImaginaryI]"}], 
     SuperscriptBox["u", "2"]], "-", 
    FractionBox[
     RowBox[{"9", " ", "\[ImaginaryI]"}], 
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{"\[ImaginaryI]", "+", "u"}], ")"}], "4"]], "+", 
    FractionBox[
     RowBox[{"18", " ", "\[ImaginaryI]", " ", 
      SqrtBox["3"]}], 
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{"\[ImaginaryI]", "+", "u"}], ")"}], "3"]], "-", 
    FractionBox[
     RowBox[{"54", " ", "\[ImaginaryI]"}], 
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{"\[ImaginaryI]", "+", "u"}], ")"}], "2"]]}], 
   SubsuperscriptBox[
    StyleBox["\[ScriptU]",
     FontColor->RGBColor[0, 0, 0.4]], 
    RowBox[{"-", "v0"}], "+"]], "+", 
  FractionBox[
   RowBox[{
    RowBox[{"81", " ", "\[ImaginaryI]"}], "-", 
    FractionBox[
     RowBox[{"9", " ", "\[ImaginaryI]"}], 
     SuperscriptBox["u", "4"]], "-", 
    FractionBox[
     RowBox[{"18", " ", "\[ImaginaryI]", " ", 
      SqrtBox["3"]}], 
     SuperscriptBox["u", "3"]], "-", 
    FractionBox[
     RowBox[{"54", " ", "\[ImaginaryI]"}], 
     SuperscriptBox["u", "2"]], "-", 
    FractionBox[
     RowBox[{"9", " ", "\[ImaginaryI]"}], 
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{"\[ImaginaryI]", "+", "u"}], ")"}], "4"]], "-", 
    FractionBox[
     RowBox[{"18", " ", "\[ImaginaryI]", " ", 
      SqrtBox["3"]}], 
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{"\[ImaginaryI]", "+", "u"}], ")"}], "3"]], "-", 
    FractionBox[
     RowBox[{"54", " ", "\[ImaginaryI]"}], 
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{"\[ImaginaryI]", "+", "u"}], ")"}], "2"]]}], 
   SubsuperscriptBox[
    StyleBox["\[ScriptU]",
     FontColor->RGBColor[0, 0, 0.4]], "v0", "+"]]}]], "Output",
 CellChangeTimes->{
  3.560948844237011*^9, 3.5609488791004343`*^9, 3.561469402372631*^9, {
   3.562262722621728*^9, 3.562262753899417*^9}, 3.562937529939274*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"tmp2", "=", 
   RowBox[{"Collect", "[", 
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{"Expand", "[", "tmp2", "]"}], "/.", "subtousu"}], "//.", 
      "subapartusu"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{
        RowBox[{"\[ScriptU]$", "[", "_", "]"}], "[", "_", "]"}], ",", 
       SqrtBox["3"]}], "}"}]}], "]"}]}], "\[IndentingNewLine]", 
  RowBox[{"(*", " ", 
   RowBox[{
   "we", " ", "see", " ", "that", " ", "poles", " ", "at", " ", "Bethe", " ", 
    "roots", " ", "cancel"}], " ", "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{"rlt2", "=", 
  RowBox[{"Collect", "[", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"tmp2", "/.", 
       RowBox[{
        SuperscriptBox[
         RowBox[{
          RowBox[{"\[ScriptU]$", "[", "0", "]"}], "[", "sh_", "]"}], 
         RowBox[{"pow_", "/;", 
          RowBox[{"pow", "<", "0"}]}]], "\[RuleDelayed]", 
        RowBox[{
         RowBox[{"\[Eta]$", "[", 
          RowBox[{"-", "pow"}], "]"}], "[", "sh", "]"}]}]}], "//.", 
      RowBox[{"shiftp\[Eta]", "[", "0", "]"}]}], "/.", "subtousu"}], ",", 
    RowBox[{"{", 
     RowBox[{"\[Eta]list", ",", 
      RowBox[{
       RowBox[{"\[ScriptU]$", "[", "_", "]"}], "[", "_", "]"}]}], "}"}]}], 
   "]"}]}]}], "Input",
 CellChangeTimes->{{3.562262754752026*^9, 3.562262796979486*^9}, {
  3.5622628360911703`*^9, 3.5622629227524548`*^9}, {3.562937533615108*^9, 
  3.562937543918365*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"-", 
   FractionBox["27", 
    SuperscriptBox[
     StyleBox["\[ScriptU]",
      FontColor->RGBColor[0, 0, 0.4]], "4"]]}], "-", 
  FractionBox[
   RowBox[{"81", " ", "\[ImaginaryI]"}], 
   SuperscriptBox[
    StyleBox["\[ScriptU]",
     FontColor->RGBColor[0, 0, 0.4]], "3"]], "+", 
  FractionBox[
   RowBox[{"81", " ", "\[ImaginaryI]"}], 
   StyleBox["\[ScriptU]",
    FontColor->RGBColor[0, 0, 0.4]]], "+", 
  FractionBox["27", 
   SuperscriptBox[
    RowBox[{"(", 
     SuperscriptBox[
      StyleBox["\[ScriptU]",
       FontColor->RGBColor[0, 0, 0.4]], 
      RowBox[{"[", "2", "]"}]], ")"}], "4"]], "-", 
  FractionBox[
   RowBox[{"81", " ", "\[ImaginaryI]"}], 
   SuperscriptBox[
    RowBox[{"(", 
     SuperscriptBox[
      StyleBox["\[ScriptU]",
       FontColor->RGBColor[0, 0, 0.4]], 
      RowBox[{"[", "2", "]"}]], ")"}], "3"]], "+", 
  FractionBox[
   RowBox[{"81", " ", "\[ImaginaryI]"}], 
   SuperscriptBox[
    StyleBox["\[ScriptU]",
     FontColor->RGBColor[0, 0, 0.4]], 
    RowBox[{"[", "2", "]"}]]]}]], "Output",
 CellChangeTimes->{{3.562262764865692*^9, 3.562262797385756*^9}, {
   3.5622629030399942`*^9, 3.5622629240681257`*^9}, 3.562937549572118*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{"-", 
   FractionBox["27", 
    SuperscriptBox[
     StyleBox["\[ScriptU]",
      FontColor->RGBColor[0, 0, 0.4]], "4"]]}], "-", 
  FractionBox[
   RowBox[{"81", " ", "\[ImaginaryI]"}], 
   SuperscriptBox[
    StyleBox["\[ScriptU]",
     FontColor->RGBColor[0, 0, 0.4]], "3"]], "+", 
  FractionBox[
   RowBox[{"81", " ", "\[ImaginaryI]"}], 
   StyleBox["\[ScriptU]",
    FontColor->RGBColor[0, 0, 0.4]]], "+", 
  RowBox[{"162", " ", "\[ImaginaryI]", " ", 
   SubsuperscriptBox[
    StyleBox["\[Eta]",
     FontWeight->Bold,
     FontColor->RGBColor[0.8, 0, 0]], "1", 
    RowBox[{"[", "2", "]"}]]}], "-", 
  RowBox[{"162", " ", "\[ImaginaryI]", " ", 
   SubsuperscriptBox[
    StyleBox["\[Eta]",
     FontWeight->Bold,
     FontColor->RGBColor[0.8, 0, 0]], "3", 
    RowBox[{"[", "2", "]"}]]}]}]], "Output",
 CellChangeTimes->{{3.562262764865692*^9, 3.562262797385756*^9}, {
   3.5622629030399942`*^9, 3.5622629240681257`*^9}, 3.562937549623391*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"rlt3", "=", 
  RowBox[{"Collect", "[", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{"t1minus", "-", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"t3plus", "/.", 
            RowBox[{"Shift", "[", 
             RowBox[{"-", "2"}], "]"}]}], "/.", 
           RowBox[{"u", "\[Rule]", 
            RowBox[{"u", "-", "\[ImaginaryI]"}]}]}], ")"}]}], "//.", 
        RowBox[{"shiftp\[Eta]", "[", "0", "]"}]}], "/.", "subtousu"}], "//", 
      "funapartusu"}], ")"}], ",", "canlist"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.562262973861288*^9, 3.562263056292745*^9}, {
  3.5622631076227016`*^9, 3.56226312155975*^9}, {3.562937567437249*^9, 
  3.562937634541956*^9}}],

Cell[BoxData[
 RowBox[{
  FractionBox["27", 
   SuperscriptBox[
    StyleBox["\[ScriptU]",
     FontColor->RGBColor[0, 0, 0.4]], "4"]], "+", 
  FractionBox[
   RowBox[{"81", " ", "\[ImaginaryI]"}], 
   SuperscriptBox[
    StyleBox["\[ScriptU]",
     FontColor->RGBColor[0, 0, 0.4]], "3"]], "-", 
  FractionBox[
   RowBox[{"81", " ", "\[ImaginaryI]"}], 
   StyleBox["\[ScriptU]",
    FontColor->RGBColor[0, 0, 0.4]]], "+", 
  FractionBox[
   RowBox[{
    RowBox[{
     RowBox[{"-", "54"}], " ", "\[ImaginaryI]", " ", 
     SubsuperscriptBox[
      StyleBox["\[Eta]0",
       FontWeight->Bold,
       FontColor->RGBColor[0, 0.5, 0]], "2", "+"]}], "+", 
    RowBox[{"18", " ", "\[ImaginaryI]", " ", 
     SqrtBox["3"], " ", 
     SubsuperscriptBox[
      StyleBox["\[Eta]0",
       FontWeight->Bold,
       FontColor->RGBColor[0, 0.5, 0]], "3", "+"]}], "-", 
    RowBox[{"9", " ", "\[ImaginaryI]", " ", 
     SubsuperscriptBox[
      StyleBox["\[Eta]0",
       FontWeight->Bold,
       FontColor->RGBColor[0, 0.5, 0]], "4", "+"]}]}], 
   SubsuperscriptBox[
    StyleBox["\[ScriptU]",
     FontColor->RGBColor[0, 0, 0.4]], 
    RowBox[{"-", "v0"}], "+"]], "+", 
  FractionBox[
   RowBox[{
    FractionBox[
     RowBox[{"81", " ", "\[ImaginaryI]"}], "2"], "+", 
    FractionBox[
     RowBox[{"81", " ", 
      SqrtBox["3"]}], "2"], "-", 
    RowBox[{"54", " ", "\[ImaginaryI]", " ", 
     SubsuperscriptBox[
      StyleBox["\[Eta]0",
       FontWeight->Bold,
       FontColor->RGBColor[0, 0.5, 0]], "2", "+"]}], "+", 
    RowBox[{"18", " ", "\[ImaginaryI]", " ", 
     SqrtBox["3"], " ", 
     SubsuperscriptBox[
      StyleBox["\[Eta]0",
       FontWeight->Bold,
       FontColor->RGBColor[0, 0.5, 0]], "3", "+"]}], "-", 
    RowBox[{"9", " ", "\[ImaginaryI]", " ", 
     SubsuperscriptBox[
      StyleBox["\[Eta]0",
       FontWeight->Bold,
       FontColor->RGBColor[0, 0.5, 0]], "4", "+"]}]}], 
   SubsuperscriptBox[
    StyleBox["\[ScriptU]",
     FontColor->RGBColor[0, 0, 0.4]], 
    RowBox[{"-", "v0"}], "-"]], "+", 
  FractionBox[
   RowBox[{
    RowBox[{
     RowBox[{"-", "54"}], " ", "\[ImaginaryI]", " ", 
     SubsuperscriptBox[
      OverscriptBox[
       StyleBox["\[Eta]0",
        FontWeight->Bold,
        FontColor->RGBColor[0, 0.5, 0]], 
       StyleBox["_",
        FontWeight->Bold,
        FontColor->RGBColor[0, 0.5, 0]]], "2", "-"]}], "+", 
    RowBox[{"18", " ", "\[ImaginaryI]", " ", 
     SqrtBox["3"], " ", 
     SubsuperscriptBox[
      OverscriptBox[
       StyleBox["\[Eta]0",
        FontWeight->Bold,
        FontColor->RGBColor[0, 0.5, 0]], 
       StyleBox["_",
        FontWeight->Bold,
        FontColor->RGBColor[0, 0.5, 0]]], "3", "-"]}], "-", 
    RowBox[{"9", " ", "\[ImaginaryI]", " ", 
     SubsuperscriptBox[
      OverscriptBox[
       StyleBox["\[Eta]0",
        FontWeight->Bold,
        FontColor->RGBColor[0, 0.5, 0]], 
       StyleBox["_",
        FontWeight->Bold,
        FontColor->RGBColor[0, 0.5, 0]]], "4", "-"]}]}], 
   SubsuperscriptBox[
    StyleBox["\[ScriptU]",
     FontColor->RGBColor[0, 0, 0.4]], "v0", "+"]], "+", 
  FractionBox[
   RowBox[{
    FractionBox[
     RowBox[{"81", " ", "\[ImaginaryI]"}], "2"], "-", 
    FractionBox[
     RowBox[{"81", " ", 
      SqrtBox["3"]}], "2"], "-", 
    RowBox[{"54", " ", "\[ImaginaryI]", " ", 
     SubsuperscriptBox[
      OverscriptBox[
       StyleBox["\[Eta]0",
        FontWeight->Bold,
        FontColor->RGBColor[0, 0.5, 0]], 
       StyleBox["_",
        FontWeight->Bold,
        FontColor->RGBColor[0, 0.5, 0]]], "2", "-"]}], "+", 
    RowBox[{"18", " ", "\[ImaginaryI]", " ", 
     SqrtBox["3"], " ", 
     SubsuperscriptBox[
      OverscriptBox[
       StyleBox["\[Eta]0",
        FontWeight->Bold,
        FontColor->RGBColor[0, 0.5, 0]], 
       StyleBox["_",
        FontWeight->Bold,
        FontColor->RGBColor[0, 0.5, 0]]], "3", "-"]}], "-", 
    RowBox[{"9", " ", "\[ImaginaryI]", " ", 
     SubsuperscriptBox[
      OverscriptBox[
       StyleBox["\[Eta]0",
        FontWeight->Bold,
        FontColor->RGBColor[0, 0.5, 0]], 
       StyleBox["_",
        FontWeight->Bold,
        FontColor->RGBColor[0, 0.5, 0]]], "4", "-"]}]}], 
   SubsuperscriptBox[
    StyleBox["\[ScriptU]",
     FontColor->RGBColor[0, 0, 0.4]], "v0", "-"]], "+", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     FractionBox[
      RowBox[{"54", " ", "\[ImaginaryI]"}], 
      SubsuperscriptBox[
       StyleBox["\[ScriptU]",
        FontColor->RGBColor[0, 0, 0.4]], 
       RowBox[{"-", "v0"}], "-"]], "+", 
     FractionBox[
      RowBox[{"54", " ", "\[ImaginaryI]"}], 
      SubsuperscriptBox[
       StyleBox["\[ScriptU]",
        FontColor->RGBColor[0, 0, 0.4]], 
       RowBox[{"-", "v0"}], "+"]], "+", 
     FractionBox[
      RowBox[{"54", " ", "\[ImaginaryI]"}], 
      SubsuperscriptBox[
       StyleBox["\[ScriptU]",
        FontColor->RGBColor[0, 0, 0.4]], "v0", "-"]], "+", 
     FractionBox[
      RowBox[{"54", " ", "\[ImaginaryI]"}], 
      SubsuperscriptBox[
       StyleBox["\[ScriptU]",
        FontColor->RGBColor[0, 0, 0.4]], "v0", "+"]]}], ")"}], " ", 
   SubsuperscriptBox[
    StyleBox["\[Eta]",
     FontWeight->Bold,
     FontColor->RGBColor[0.8, 0, 0]], "2", 
    RowBox[{"[", "2", "]"}]]}], "+", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     RowBox[{"-", 
      FractionBox[
       RowBox[{"18", " ", "\[ImaginaryI]", " ", 
        SqrtBox["3"]}], 
       SubsuperscriptBox[
        StyleBox["\[ScriptU]",
         FontColor->RGBColor[0, 0, 0.4]], 
        RowBox[{"-", "v0"}], "-"]]}], "-", 
     FractionBox[
      RowBox[{"18", " ", "\[ImaginaryI]", " ", 
       SqrtBox["3"]}], 
      SubsuperscriptBox[
       StyleBox["\[ScriptU]",
        FontColor->RGBColor[0, 0, 0.4]], 
       RowBox[{"-", "v0"}], "+"]], "+", 
     FractionBox[
      RowBox[{"18", " ", "\[ImaginaryI]", " ", 
       SqrtBox["3"]}], 
      SubsuperscriptBox[
       StyleBox["\[ScriptU]",
        FontColor->RGBColor[0, 0, 0.4]], "v0", "-"]], "+", 
     FractionBox[
      RowBox[{"18", " ", "\[ImaginaryI]", " ", 
       SqrtBox["3"]}], 
      SubsuperscriptBox[
       StyleBox["\[ScriptU]",
        FontColor->RGBColor[0, 0, 0.4]], "v0", "+"]]}], ")"}], " ", 
   SubsuperscriptBox[
    StyleBox["\[Eta]",
     FontWeight->Bold,
     FontColor->RGBColor[0.8, 0, 0]], "3", 
    RowBox[{"[", "2", "]"}]]}], "+", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     FractionBox[
      RowBox[{"9", " ", "\[ImaginaryI]"}], 
      SubsuperscriptBox[
       StyleBox["\[ScriptU]",
        FontColor->RGBColor[0, 0, 0.4]], 
       RowBox[{"-", "v0"}], "-"]], "+", 
     FractionBox[
      RowBox[{"9", " ", "\[ImaginaryI]"}], 
      SubsuperscriptBox[
       StyleBox["\[ScriptU]",
        FontColor->RGBColor[0, 0, 0.4]], 
       RowBox[{"-", "v0"}], "+"]], "+", 
     FractionBox[
      RowBox[{"9", " ", "\[ImaginaryI]"}], 
      SubsuperscriptBox[
       StyleBox["\[ScriptU]",
        FontColor->RGBColor[0, 0, 0.4]], "v0", "-"]], "+", 
     FractionBox[
      RowBox[{"9", " ", "\[ImaginaryI]"}], 
      SubsuperscriptBox[
       StyleBox["\[ScriptU]",
        FontColor->RGBColor[0, 0, 0.4]], "v0", "+"]]}], ")"}], " ", 
   SubsuperscriptBox[
    StyleBox["\[Eta]",
     FontWeight->Bold,
     FontColor->RGBColor[0.8, 0, 0]], "4", 
    RowBox[{"[", "2", "]"}]]}]}]], "Output",
 CellChangeTimes->{{3.562262954470986*^9, 3.562262999540784*^9}, 
   3.562263056715102*^9, {3.562263109520954*^9, 3.562263122142747*^9}, 
   3.562937635309867*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"rltUr", "=", 
  RowBox[{"Collect", "[", 
   RowBox[{
    RowBox[{"rlt3", "+", "rlt2", "+", "rlt1"}], ",", "canlist"}], 
   "]"}]}]], "Input",
 CellChangeTimes->{{3.56226319509442*^9, 3.562263248001504*^9}, {
  3.562937640572763*^9, 3.562937658516157*^9}}],

Cell[BoxData[
 RowBox[{
  FractionBox["27", 
   SuperscriptBox[
    StyleBox["\[ScriptU]",
     FontColor->RGBColor[0, 0, 0.4]], "4"]], "+", 
  FractionBox[
   RowBox[{
    RowBox[{
     RowBox[{"-", "81"}], " ", "\[ImaginaryI]"}], "+", 
    RowBox[{"144", " ", "\[ImaginaryI]", " ", 
     SubscriptBox[
      StyleBox["\[Zeta]",
       FontWeight->Bold,
       FontColor->GrayLevel[0.4]], "3"]}]}], 
   SuperscriptBox[
    StyleBox["\[ScriptU]",
     FontColor->RGBColor[0, 0, 0.4]], "3"]], "+", 
  FractionBox[
   RowBox[{
    RowBox[{"540", " ", "\[ImaginaryI]", " ", 
     SubscriptBox[
      StyleBox["\[Zeta]",
       FontWeight->Bold,
       FontColor->GrayLevel[0.4]], "3"]}], "-", 
    RowBox[{"360", " ", "\[ImaginaryI]", " ", 
     SubscriptBox[
      StyleBox["\[Zeta]",
       FontWeight->Bold,
       FontColor->GrayLevel[0.4]], "5"]}]}], 
   StyleBox["\[ScriptU]",
    FontColor->RGBColor[0, 0, 0.4]]], "+", 
  FractionBox[
   RowBox[{
    RowBox[{
     RowBox[{"-", "54"}], " ", "\[ImaginaryI]", " ", 
     SubsuperscriptBox[
      StyleBox["\[Eta]0",
       FontWeight->Bold,
       FontColor->RGBColor[0, 0.5, 0]], "2", "+"]}], "+", 
    RowBox[{"18", " ", "\[ImaginaryI]", " ", 
     SqrtBox["3"], " ", 
     SubsuperscriptBox[
      StyleBox["\[Eta]0",
       FontWeight->Bold,
       FontColor->RGBColor[0, 0.5, 0]], "3", "+"]}], "-", 
    RowBox[{"9", " ", "\[ImaginaryI]", " ", 
     SubsuperscriptBox[
      StyleBox["\[Eta]0",
       FontWeight->Bold,
       FontColor->RGBColor[0, 0.5, 0]], "4", "+"]}]}], 
   SubsuperscriptBox[
    StyleBox["\[ScriptU]",
     FontColor->RGBColor[0, 0, 0.4]], 
    RowBox[{"-", "v0"}], "+"]], "+", 
  FractionBox[
   RowBox[{
    FractionBox[
     RowBox[{"81", " ", "\[ImaginaryI]"}], "2"], "+", 
    FractionBox[
     RowBox[{"81", " ", 
      SqrtBox["3"]}], "2"], "-", 
    RowBox[{"54", " ", "\[ImaginaryI]", " ", 
     SubsuperscriptBox[
      StyleBox["\[Eta]0",
       FontWeight->Bold,
       FontColor->RGBColor[0, 0.5, 0]], "2", "+"]}], "+", 
    RowBox[{"18", " ", "\[ImaginaryI]", " ", 
     SqrtBox["3"], " ", 
     SubsuperscriptBox[
      StyleBox["\[Eta]0",
       FontWeight->Bold,
       FontColor->RGBColor[0, 0.5, 0]], "3", "+"]}], "-", 
    RowBox[{"9", " ", "\[ImaginaryI]", " ", 
     SubsuperscriptBox[
      StyleBox["\[Eta]0",
       FontWeight->Bold,
       FontColor->RGBColor[0, 0.5, 0]], "4", "+"]}]}], 
   SubsuperscriptBox[
    StyleBox["\[ScriptU]",
     FontColor->RGBColor[0, 0, 0.4]], 
    RowBox[{"-", "v0"}], "-"]], "+", 
  FractionBox[
   RowBox[{
    RowBox[{
     RowBox[{"-", "54"}], " ", "\[ImaginaryI]", " ", 
     SubsuperscriptBox[
      OverscriptBox[
       StyleBox["\[Eta]0",
        FontWeight->Bold,
        FontColor->RGBColor[0, 0.5, 0]], 
       StyleBox["_",
        FontWeight->Bold,
        FontColor->RGBColor[0, 0.5, 0]]], "2", "-"]}], "+", 
    RowBox[{"18", " ", "\[ImaginaryI]", " ", 
     SqrtBox["3"], " ", 
     SubsuperscriptBox[
      OverscriptBox[
       StyleBox["\[Eta]0",
        FontWeight->Bold,
        FontColor->RGBColor[0, 0.5, 0]], 
       StyleBox["_",
        FontWeight->Bold,
        FontColor->RGBColor[0, 0.5, 0]]], "3", "-"]}], "-", 
    RowBox[{"9", " ", "\[ImaginaryI]", " ", 
     SubsuperscriptBox[
      OverscriptBox[
       StyleBox["\[Eta]0",
        FontWeight->Bold,
        FontColor->RGBColor[0, 0.5, 0]], 
       StyleBox["_",
        FontWeight->Bold,
        FontColor->RGBColor[0, 0.5, 0]]], "4", "-"]}]}], 
   SubsuperscriptBox[
    StyleBox["\[ScriptU]",
     FontColor->RGBColor[0, 0, 0.4]], "v0", "+"]], "+", 
  FractionBox[
   RowBox[{
    FractionBox[
     RowBox[{"81", " ", "\[ImaginaryI]"}], "2"], "-", 
    FractionBox[
     RowBox[{"81", " ", 
      SqrtBox["3"]}], "2"], "-", 
    RowBox[{"54", " ", "\[ImaginaryI]", " ", 
     SubsuperscriptBox[
      OverscriptBox[
       StyleBox["\[Eta]0",
        FontWeight->Bold,
        FontColor->RGBColor[0, 0.5, 0]], 
       StyleBox["_",
        FontWeight->Bold,
        FontColor->RGBColor[0, 0.5, 0]]], "2", "-"]}], "+", 
    RowBox[{"18", " ", "\[ImaginaryI]", " ", 
     SqrtBox["3"], " ", 
     SubsuperscriptBox[
      OverscriptBox[
       StyleBox["\[Eta]0",
        FontWeight->Bold,
        FontColor->RGBColor[0, 0.5, 0]], 
       StyleBox["_",
        FontWeight->Bold,
        FontColor->RGBColor[0, 0.5, 0]]], "3", "-"]}], "-", 
    RowBox[{"9", " ", "\[ImaginaryI]", " ", 
     SubsuperscriptBox[
      OverscriptBox[
       StyleBox["\[Eta]0",
        FontWeight->Bold,
        FontColor->RGBColor[0, 0.5, 0]], 
       StyleBox["_",
        FontWeight->Bold,
        FontColor->RGBColor[0, 0.5, 0]]], "4", "-"]}]}], 
   SubsuperscriptBox[
    StyleBox["\[ScriptU]",
     FontColor->RGBColor[0, 0, 0.4]], "v0", "-"]], "+", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     RowBox[{"162", " ", "\[ImaginaryI]"}], "+", 
     RowBox[{"432", " ", "\[ImaginaryI]", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3"]}], "-", 
     RowBox[{"720", " ", "\[ImaginaryI]", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "5"]}]}], ")"}], " ", 
   SubsuperscriptBox[
    StyleBox["\[Eta]",
     FontWeight->Bold,
     FontColor->RGBColor[0.8, 0, 0]], "1", 
    RowBox[{"[", "2", "]"}]]}], "+", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     FractionBox["18", 
      SuperscriptBox[
       StyleBox["\[ScriptU]",
        FontColor->RGBColor[0, 0, 0.4]], "4"]], "+", 
     FractionBox["108", 
      SuperscriptBox[
       StyleBox["\[ScriptU]",
        FontColor->RGBColor[0, 0, 0.4]], "2"]], "+", 
     FractionBox[
      RowBox[{"54", " ", "\[ImaginaryI]"}], 
      SubsuperscriptBox[
       StyleBox["\[ScriptU]",
        FontColor->RGBColor[0, 0, 0.4]], 
       RowBox[{"-", "v0"}], "-"]], "+", 
     FractionBox[
      RowBox[{"54", " ", "\[ImaginaryI]"}], 
      SubsuperscriptBox[
       StyleBox["\[ScriptU]",
        FontColor->RGBColor[0, 0, 0.4]], 
       RowBox[{"-", "v0"}], "+"]], "+", 
     FractionBox[
      RowBox[{"54", " ", "\[ImaginaryI]"}], 
      SubsuperscriptBox[
       StyleBox["\[ScriptU]",
        FontColor->RGBColor[0, 0, 0.4]], "v0", "-"]], "+", 
     FractionBox[
      RowBox[{"54", " ", "\[ImaginaryI]"}], 
      SubsuperscriptBox[
       StyleBox["\[ScriptU]",
        FontColor->RGBColor[0, 0, 0.4]], "v0", "+"]], "+", 
     FractionBox[
      RowBox[{
       RowBox[{
        RowBox[{"-", "54"}], " ", "\[ImaginaryI]"}], "+", 
       RowBox[{"216", " ", "\[ImaginaryI]", " ", 
        SubscriptBox[
         StyleBox["\[Zeta]",
          FontWeight->Bold,
          FontColor->GrayLevel[0.4]], "3"]}]}], 
      StyleBox["\[ScriptU]",
       FontColor->RGBColor[0, 0, 0.4]]], "+", 
     RowBox[{"648", " ", "\[ImaginaryI]", " ", "u", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3"]}]}], ")"}], " ", 
   SubsuperscriptBox[
    StyleBox["\[Eta]",
     FontWeight->Bold,
     FontColor->RGBColor[0.8, 0, 0]], "2", 
    RowBox[{"[", "2", "]"}]]}], "+", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     RowBox[{
      RowBox[{"-", "270"}], " ", "\[ImaginaryI]"}], "-", 
     FractionBox["36", 
      SuperscriptBox[
       StyleBox["\[ScriptU]",
        FontColor->RGBColor[0, 0, 0.4]], "3"]], "-", 
     FractionBox["54", 
      StyleBox["\[ScriptU]",
       FontColor->RGBColor[0, 0, 0.4]]], "-", 
     FractionBox[
      RowBox[{"18", " ", "\[ImaginaryI]", " ", 
       SqrtBox["3"]}], 
      SubsuperscriptBox[
       StyleBox["\[ScriptU]",
        FontColor->RGBColor[0, 0, 0.4]], 
       RowBox[{"-", "v0"}], "-"]], "-", 
     FractionBox[
      RowBox[{"18", " ", "\[ImaginaryI]", " ", 
       SqrtBox["3"]}], 
      SubsuperscriptBox[
       StyleBox["\[ScriptU]",
        FontColor->RGBColor[0, 0, 0.4]], 
       RowBox[{"-", "v0"}], "+"]], "+", 
     FractionBox[
      RowBox[{"18", " ", "\[ImaginaryI]", " ", 
       SqrtBox["3"]}], 
      SubsuperscriptBox[
       StyleBox["\[ScriptU]",
        FontColor->RGBColor[0, 0, 0.4]], "v0", "-"]], "+", 
     FractionBox[
      RowBox[{"18", " ", "\[ImaginaryI]", " ", 
       SqrtBox["3"]}], 
      SubsuperscriptBox[
       StyleBox["\[ScriptU]",
        FontColor->RGBColor[0, 0, 0.4]], "v0", "+"]], "+", 
     RowBox[{"72", " ", "\[ImaginaryI]", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3"]}]}], ")"}], " ", 
   SubsuperscriptBox[
    StyleBox["\[Eta]",
     FontWeight->Bold,
     FontColor->RGBColor[0.8, 0, 0]], "3", 
    RowBox[{"[", "2", "]"}]]}], "+", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{"54", "+", 
     FractionBox["18", 
      SuperscriptBox[
       StyleBox["\[ScriptU]",
        FontColor->RGBColor[0, 0, 0.4]], "2"]], "+", 
     FractionBox[
      RowBox[{"9", " ", "\[ImaginaryI]"}], 
      SubsuperscriptBox[
       StyleBox["\[ScriptU]",
        FontColor->RGBColor[0, 0, 0.4]], 
       RowBox[{"-", "v0"}], "-"]], "+", 
     FractionBox[
      RowBox[{"9", " ", "\[ImaginaryI]"}], 
      SubsuperscriptBox[
       StyleBox["\[ScriptU]",
        FontColor->RGBColor[0, 0, 0.4]], 
       RowBox[{"-", "v0"}], "+"]], "+", 
     FractionBox[
      RowBox[{"9", " ", "\[ImaginaryI]"}], 
      SubsuperscriptBox[
       StyleBox["\[ScriptU]",
        FontColor->RGBColor[0, 0, 0.4]], "v0", "-"]], "+", 
     FractionBox[
      RowBox[{"9", " ", "\[ImaginaryI]"}], 
      SubsuperscriptBox[
       StyleBox["\[ScriptU]",
        FontColor->RGBColor[0, 0, 0.4]], "v0", "+"]]}], ")"}], " ", 
   SubsuperscriptBox[
    StyleBox["\[Eta]",
     FontWeight->Bold,
     FontColor->RGBColor[0.8, 0, 0]], "4", 
    RowBox[{"[", "2", "]"}]]}], "+", 
  RowBox[{"108", " ", 
   SubsuperscriptBox[
    StyleBox["\[Eta]",
     FontWeight->Bold,
     FontColor->RGBColor[0.8, 0, 0]], 
    RowBox[{"2", ",", "2"}], 
    RowBox[{"[", "2", "]"}]]}], "+", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     RowBox[{
      RowBox[{"-", "108"}], " ", "u"}], "-", 
     FractionBox["36", 
      StyleBox["\[ScriptU]",
       FontColor->RGBColor[0, 0, 0.4]]]}], ")"}], " ", 
   SubsuperscriptBox[
    StyleBox["\[Eta]",
     FontWeight->Bold,
     FontColor->RGBColor[0.8, 0, 0]], 
    RowBox[{"2", ",", "3"}], 
    RowBox[{"[", "2", "]"}]]}], "+", 
  RowBox[{"36", " ", 
   SubsuperscriptBox[
    StyleBox["\[Eta]",
     FontWeight->Bold,
     FontColor->RGBColor[0.8, 0, 0]], 
    RowBox[{"2", ",", "4"}], 
    RowBox[{"[", "2", "]"}]]}], "+", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     RowBox[{"108", " ", "u"}], "+", 
     FractionBox["36", 
      StyleBox["\[ScriptU]",
       FontColor->RGBColor[0, 0, 0.4]]]}], ")"}], " ", 
   SubsuperscriptBox[
    StyleBox["\[Eta]",
     FontWeight->Bold,
     FontColor->RGBColor[0.8, 0, 0]], 
    RowBox[{"3", ",", "2"}], 
    RowBox[{"[", "2", "]"}]]}], "-", 
  RowBox[{"36", " ", 
   SubsuperscriptBox[
    StyleBox["\[Eta]",
     FontWeight->Bold,
     FontColor->RGBColor[0.8, 0, 0]], 
    RowBox[{"3", ",", "3"}], 
    RowBox[{"[", "2", "]"}]]}]}]], "Output",
 CellChangeTimes->{{3.5622632240004263`*^9, 3.56226324863025*^9}, {
  3.5629376428421993`*^9, 3.562937658989472*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"rltUr", "-", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       RowBox[{"rltUr", "/.", 
        RowBox[{"Shift", "[", "2", "]"}]}], "/.", 
       RowBox[{"u", "\[Rule]", 
        RowBox[{"u", "+", "\[ImaginaryI]"}]}]}], "//.", 
      RowBox[{"shiftm\[Eta]", "[", "4", "]"}]}], ")"}], "-", "rltUohr"}], "/.",
    "subusu"}], "//", "Simplify"}]], "Input",
 CellChangeTimes->{{3.562263250452661*^9, 3.562263275423052*^9}, {
  3.562937661605398*^9, 3.562937664067659*^9}}],

Cell[BoxData["0"], "Output",
 CellChangeTimes->{
  3.562263278035713*^9, {3.562937650970742*^9, 3.562937665400448*^9}}]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"rltUr", "=", 
   RowBox[{
    FractionBox["27", 
     SuperscriptBox[
      StyleBox["\[ScriptU]",
       FontColor->RGBColor[0, 0, 0.4]], "4"]], "+", 
    FractionBox[
     RowBox[{
      RowBox[{
       RowBox[{"-", "81"}], " ", "\[ImaginaryI]"}], "+", 
      RowBox[{"144", " ", "\[ImaginaryI]", " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "3"]}]}], 
     SuperscriptBox[
      StyleBox["\[ScriptU]",
       FontColor->RGBColor[0, 0, 0.4]], "3"]], "+", 
    FractionBox[
     RowBox[{
      RowBox[{"540", " ", "\[ImaginaryI]", " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "3"]}], "-", 
      RowBox[{"360", " ", "\[ImaginaryI]", " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "5"]}]}], 
     StyleBox["\[ScriptU]",
      FontColor->RGBColor[0, 0, 0.4]]], "+", 
    FractionBox[
     RowBox[{
      RowBox[{
       RowBox[{"-", "54"}], " ", "\[ImaginaryI]", " ", 
       SubsuperscriptBox[
        StyleBox["\[Eta]0",
         FontWeight->Bold,
         FontColor->RGBColor[0, 0.5, 0]], "2", "+"]}], "+", 
      RowBox[{"18", " ", "\[ImaginaryI]", " ", 
       SqrtBox["3"], " ", 
       SubsuperscriptBox[
        StyleBox["\[Eta]0",
         FontWeight->Bold,
         FontColor->RGBColor[0, 0.5, 0]], "3", "+"]}], "-", 
      RowBox[{"9", " ", "\[ImaginaryI]", " ", 
       SubsuperscriptBox[
        StyleBox["\[Eta]0",
         FontWeight->Bold,
         FontColor->RGBColor[0, 0.5, 0]], "4", "+"]}]}], 
     SubsuperscriptBox[
      StyleBox["\[ScriptU]",
       FontColor->RGBColor[0, 0, 0.4]], 
      RowBox[{"-", "v0"}], "+"]], "+", 
    FractionBox[
     RowBox[{
      FractionBox[
       RowBox[{"81", " ", "\[ImaginaryI]"}], "2"], "+", 
      FractionBox[
       RowBox[{"81", " ", 
        SqrtBox["3"]}], "2"], "-", 
      RowBox[{"54", " ", "\[ImaginaryI]", " ", 
       SubsuperscriptBox[
        StyleBox["\[Eta]0",
         FontWeight->Bold,
         FontColor->RGBColor[0, 0.5, 0]], "2", "+"]}], "+", 
      RowBox[{"18", " ", "\[ImaginaryI]", " ", 
       SqrtBox["3"], " ", 
       SubsuperscriptBox[
        StyleBox["\[Eta]0",
         FontWeight->Bold,
         FontColor->RGBColor[0, 0.5, 0]], "3", "+"]}], "-", 
      RowBox[{"9", " ", "\[ImaginaryI]", " ", 
       SubsuperscriptBox[
        StyleBox["\[Eta]0",
         FontWeight->Bold,
         FontColor->RGBColor[0, 0.5, 0]], "4", "+"]}]}], 
     SubsuperscriptBox[
      StyleBox["\[ScriptU]",
       FontColor->RGBColor[0, 0, 0.4]], 
      RowBox[{"-", "v0"}], "-"]], "+", 
    FractionBox[
     RowBox[{
      RowBox[{
       RowBox[{"-", "54"}], " ", "\[ImaginaryI]", " ", 
       SubsuperscriptBox[
        OverscriptBox[
         StyleBox["\[Eta]0",
          FontWeight->Bold,
          FontColor->RGBColor[0, 0.5, 0]], 
         StyleBox["_",
          FontWeight->Bold,
          FontColor->RGBColor[0, 0.5, 0]]], "2", "-"]}], "+", 
      RowBox[{"18", " ", "\[ImaginaryI]", " ", 
       SqrtBox["3"], " ", 
       SubsuperscriptBox[
        OverscriptBox[
         StyleBox["\[Eta]0",
          FontWeight->Bold,
          FontColor->RGBColor[0, 0.5, 0]], 
         StyleBox["_",
          FontWeight->Bold,
          FontColor->RGBColor[0, 0.5, 0]]], "3", "-"]}], "-", 
      RowBox[{"9", " ", "\[ImaginaryI]", " ", 
       SubsuperscriptBox[
        OverscriptBox[
         StyleBox["\[Eta]0",
          FontWeight->Bold,
          FontColor->RGBColor[0, 0.5, 0]], 
         StyleBox["_",
          FontWeight->Bold,
          FontColor->RGBColor[0, 0.5, 0]]], "4", "-"]}]}], 
     SubsuperscriptBox[
      StyleBox["\[ScriptU]",
       FontColor->RGBColor[0, 0, 0.4]], "v0", "+"]], "+", 
    FractionBox[
     RowBox[{
      FractionBox[
       RowBox[{"81", " ", "\[ImaginaryI]"}], "2"], "-", 
      FractionBox[
       RowBox[{"81", " ", 
        SqrtBox["3"]}], "2"], "-", 
      RowBox[{"54", " ", "\[ImaginaryI]", " ", 
       SubsuperscriptBox[
        OverscriptBox[
         StyleBox["\[Eta]0",
          FontWeight->Bold,
          FontColor->RGBColor[0, 0.5, 0]], 
         StyleBox["_",
          FontWeight->Bold,
          FontColor->RGBColor[0, 0.5, 0]]], "2", "-"]}], "+", 
      RowBox[{"18", " ", "\[ImaginaryI]", " ", 
       SqrtBox["3"], " ", 
       SubsuperscriptBox[
        OverscriptBox[
         StyleBox["\[Eta]0",
          FontWeight->Bold,
          FontColor->RGBColor[0, 0.5, 0]], 
         StyleBox["_",
          FontWeight->Bold,
          FontColor->RGBColor[0, 0.5, 0]]], "3", "-"]}], "-", 
      RowBox[{"9", " ", "\[ImaginaryI]", " ", 
       SubsuperscriptBox[
        OverscriptBox[
         StyleBox["\[Eta]0",
          FontWeight->Bold,
          FontColor->RGBColor[0, 0.5, 0]], 
         StyleBox["_",
          FontWeight->Bold,
          FontColor->RGBColor[0, 0.5, 0]]], "4", "-"]}]}], 
     SubsuperscriptBox[
      StyleBox["\[ScriptU]",
       FontColor->RGBColor[0, 0, 0.4]], "v0", "-"]], "+", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{"162", " ", "\[ImaginaryI]"}], "+", 
       RowBox[{"432", " ", "\[ImaginaryI]", " ", 
        SubscriptBox[
         StyleBox["\[Zeta]",
          FontWeight->Bold,
          FontColor->GrayLevel[0.4]], "3"]}], "-", 
       RowBox[{"720", " ", "\[ImaginaryI]", " ", 
        SubscriptBox[
         StyleBox["\[Zeta]",
          FontWeight->Bold,
          FontColor->GrayLevel[0.4]], "5"]}]}], ")"}], " ", 
     SubsuperscriptBox[
      StyleBox["\[Eta]",
       FontWeight->Bold,
       FontColor->RGBColor[0.8, 0, 0]], "1", 
      RowBox[{"[", "2", "]"}]]}], "+", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       FractionBox["18", 
        SuperscriptBox[
         StyleBox["\[ScriptU]",
          FontColor->RGBColor[0, 0, 0.4]], "4"]], "+", 
       FractionBox["108", 
        SuperscriptBox[
         StyleBox["\[ScriptU]",
          FontColor->RGBColor[0, 0, 0.4]], "2"]], "+", 
       FractionBox[
        RowBox[{"54", " ", "\[ImaginaryI]"}], 
        SubsuperscriptBox[
         StyleBox["\[ScriptU]",
          FontColor->RGBColor[0, 0, 0.4]], 
         RowBox[{"-", "v0"}], "-"]], "+", 
       FractionBox[
        RowBox[{"54", " ", "\[ImaginaryI]"}], 
        SubsuperscriptBox[
         StyleBox["\[ScriptU]",
          FontColor->RGBColor[0, 0, 0.4]], 
         RowBox[{"-", "v0"}], "+"]], "+", 
       FractionBox[
        RowBox[{"54", " ", "\[ImaginaryI]"}], 
        SubsuperscriptBox[
         StyleBox["\[ScriptU]",
          FontColor->RGBColor[0, 0, 0.4]], "v0", "-"]], "+", 
       FractionBox[
        RowBox[{"54", " ", "\[ImaginaryI]"}], 
        SubsuperscriptBox[
         StyleBox["\[ScriptU]",
          FontColor->RGBColor[0, 0, 0.4]], "v0", "+"]], "+", 
       FractionBox[
        RowBox[{
         RowBox[{
          RowBox[{"-", "54"}], " ", "\[ImaginaryI]"}], "+", 
         RowBox[{"216", " ", "\[ImaginaryI]", " ", 
          SubscriptBox[
           StyleBox["\[Zeta]",
            FontWeight->Bold,
            FontColor->GrayLevel[0.4]], "3"]}]}], 
        StyleBox["\[ScriptU]",
         FontColor->RGBColor[0, 0, 0.4]]], "+", 
       RowBox[{"648", " ", "\[ImaginaryI]", " ", "u", " ", 
        SubscriptBox[
         StyleBox["\[Zeta]",
          FontWeight->Bold,
          FontColor->GrayLevel[0.4]], "3"]}]}], ")"}], " ", 
     SubsuperscriptBox[
      StyleBox["\[Eta]",
       FontWeight->Bold,
       FontColor->RGBColor[0.8, 0, 0]], "2", 
      RowBox[{"[", "2", "]"}]]}], "+", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{
        RowBox[{"-", "270"}], " ", "\[ImaginaryI]"}], "-", 
       FractionBox["36", 
        SuperscriptBox[
         StyleBox["\[ScriptU]",
          FontColor->RGBColor[0, 0, 0.4]], "3"]], "-", 
       FractionBox["54", 
        StyleBox["\[ScriptU]",
         FontColor->RGBColor[0, 0, 0.4]]], "-", 
       FractionBox[
        RowBox[{"18", " ", "\[ImaginaryI]", " ", 
         SqrtBox["3"]}], 
        SubsuperscriptBox[
         StyleBox["\[ScriptU]",
          FontColor->RGBColor[0, 0, 0.4]], 
         RowBox[{"-", "v0"}], "-"]], "-", 
       FractionBox[
        RowBox[{"18", " ", "\[ImaginaryI]", " ", 
         SqrtBox["3"]}], 
        SubsuperscriptBox[
         StyleBox["\[ScriptU]",
          FontColor->RGBColor[0, 0, 0.4]], 
         RowBox[{"-", "v0"}], "+"]], "+", 
       FractionBox[
        RowBox[{"18", " ", "\[ImaginaryI]", " ", 
         SqrtBox["3"]}], 
        SubsuperscriptBox[
         StyleBox["\[ScriptU]",
          FontColor->RGBColor[0, 0, 0.4]], "v0", "-"]], "+", 
       FractionBox[
        RowBox[{"18", " ", "\[ImaginaryI]", " ", 
         SqrtBox["3"]}], 
        SubsuperscriptBox[
         StyleBox["\[ScriptU]",
          FontColor->RGBColor[0, 0, 0.4]], "v0", "+"]], "+", 
       RowBox[{"72", " ", "\[ImaginaryI]", " ", 
        SubscriptBox[
         StyleBox["\[Zeta]",
          FontWeight->Bold,
          FontColor->GrayLevel[0.4]], "3"]}]}], ")"}], " ", 
     SubsuperscriptBox[
      StyleBox["\[Eta]",
       FontWeight->Bold,
       FontColor->RGBColor[0.8, 0, 0]], "3", 
      RowBox[{"[", "2", "]"}]]}], "+", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{"54", "+", 
       FractionBox["18", 
        SuperscriptBox[
         StyleBox["\[ScriptU]",
          FontColor->RGBColor[0, 0, 0.4]], "2"]], "+", 
       FractionBox[
        RowBox[{"9", " ", "\[ImaginaryI]"}], 
        SubsuperscriptBox[
         StyleBox["\[ScriptU]",
          FontColor->RGBColor[0, 0, 0.4]], 
         RowBox[{"-", "v0"}], "-"]], "+", 
       FractionBox[
        RowBox[{"9", " ", "\[ImaginaryI]"}], 
        SubsuperscriptBox[
         StyleBox["\[ScriptU]",
          FontColor->RGBColor[0, 0, 0.4]], 
         RowBox[{"-", "v0"}], "+"]], "+", 
       FractionBox[
        RowBox[{"9", " ", "\[ImaginaryI]"}], 
        SubsuperscriptBox[
         StyleBox["\[ScriptU]",
          FontColor->RGBColor[0, 0, 0.4]], "v0", "-"]], "+", 
       FractionBox[
        RowBox[{"9", " ", "\[ImaginaryI]"}], 
        SubsuperscriptBox[
         StyleBox["\[ScriptU]",
          FontColor->RGBColor[0, 0, 0.4]], "v0", "+"]]}], ")"}], " ", 
     SubsuperscriptBox[
      StyleBox["\[Eta]",
       FontWeight->Bold,
       FontColor->RGBColor[0.8, 0, 0]], "4", 
      RowBox[{"[", "2", "]"}]]}], "+", 
    RowBox[{"108", " ", 
     SubsuperscriptBox[
      StyleBox["\[Eta]",
       FontWeight->Bold,
       FontColor->RGBColor[0.8, 0, 0]], 
      RowBox[{"2", ",", "2"}], 
      RowBox[{"[", "2", "]"}]]}], "+", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{
        RowBox[{"-", "108"}], " ", "u"}], "-", 
       FractionBox["36", 
        StyleBox["\[ScriptU]",
         FontColor->RGBColor[0, 0, 0.4]]]}], ")"}], " ", 
     SubsuperscriptBox[
      StyleBox["\[Eta]",
       FontWeight->Bold,
       FontColor->RGBColor[0.8, 0, 0]], 
      RowBox[{"2", ",", "3"}], 
      RowBox[{"[", "2", "]"}]]}], "+", 
    RowBox[{"36", " ", 
     SubsuperscriptBox[
      StyleBox["\[Eta]",
       FontWeight->Bold,
       FontColor->RGBColor[0.8, 0, 0]], 
      RowBox[{"2", ",", "4"}], 
      RowBox[{"[", "2", "]"}]]}], "+", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{"108", " ", "u"}], "+", 
       FractionBox["36", 
        StyleBox["\[ScriptU]",
         FontColor->RGBColor[0, 0, 0.4]]]}], ")"}], " ", 
     SubsuperscriptBox[
      StyleBox["\[Eta]",
       FontWeight->Bold,
       FontColor->RGBColor[0.8, 0, 0]], 
      RowBox[{"3", ",", "2"}], 
      RowBox[{"[", "2", "]"}]]}], "-", 
    RowBox[{"36", " ", 
     SubsuperscriptBox[
      StyleBox["\[Eta]",
       FontWeight->Bold,
       FontColor->RGBColor[0.8, 0, 0]], 
      RowBox[{"3", ",", "3"}], 
      RowBox[{"[", "2", "]"}]]}]}]}], ";"}]], "Input",
 CellChangeTimes->{{3.563302168494049*^9, 3.563302172139955*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["\<\
Equation for normalization of U\
\>", "Subsection",
 CellChangeTimes->{{3.556012370481061*^9, 3.5560123754779167`*^9}, {
  3.5609401485197983`*^9, 3.56094016511836*^9}, {3.56138235660651*^9, 
  3.5613823618484592`*^9}, {3.561382444647675*^9, 3.561382454364394*^9}, {
  3.5629106228984613`*^9, 3.562910628408205*^9}}],

Cell["The departing equation is", "Text",
 CellChangeTimes->{{3.5613824567609463`*^9, 3.561382459828187*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"U", " ", 
   OverscriptBox["U", "_"]}], "==", 
  RowBox[{
   SqrtBox[
    RowBox[{
     SubsuperscriptBox["\[ScriptCapitalT]", 
      RowBox[{"0", ",", "0"}], "+"], 
     SubsuperscriptBox["\[ScriptCapitalT]", 
      RowBox[{"0", ",", "0"}], "-"]}]], 
   FractionBox[
    RowBox[{"(", 
     RowBox[{"1", "-", 
      RowBox[{
       SubscriptBox["Y", 
        RowBox[{"1", ",", "1"}]], 
       SubscriptBox["Y", 
        RowBox[{"2", ",", "2"}]]}]}], ")"}], 
    SubsuperscriptBox["\[GothicCapitalT]", 
     RowBox[{"0", ",", "1"}], "c"]]}]}]], "Input",
 CellChangeTimes->{3.5613825290398693`*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   SubsuperscriptBox["\[ScriptCapitalT]", 
    RowBox[{"0", ",", "0"}], "+"], 
   SubsuperscriptBox["\[ScriptCapitalT]", 
    RowBox[{"0", ",", "0"}], "-"]}], "==", 
  RowBox[{
   SubscriptBox["\[ScriptCapitalT]", 
    RowBox[{"0", ",", "1"}]], 
   SubscriptBox["\[ScriptCapitalT]", 
    RowBox[{"0", ",", 
     RowBox[{"-", "1"}]}]]}], "==", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     RowBox[{"U", " ", 
      OverscriptBox["U", "_"]}], ")"}], "2"], 
   SubscriptBox["\[ScriptCapitalT]", 
    RowBox[{"0", ",", "1"}]], 
   SubscriptBox["\[ScriptCapitalT]", 
    RowBox[{"0", ",", "1"}]]}]}]], "Input",
 CellChangeTimes->{{3.5614478495495234`*^9, 3.56144786998109*^9}, {
  3.562937949722299*^9, 3.562937949832452*^9}}],

Cell[BoxData[
 RowBox[{
  SubscriptBox["\[ScriptCapitalT]", 
   RowBox[{"0", ",", "1"}]], "==", 
  FractionBox[
   SubsuperscriptBox["\[GothicCapitalT]", 
    RowBox[{"0", ",", "1"}], "c"], 
   RowBox[{"(", 
    RowBox[{"1", "-", 
     RowBox[{
      SubscriptBox["Y", 
       RowBox[{"1", ",", "1"}]], 
      SubscriptBox["Y", 
       RowBox[{"2", ",", "2"}]]}]}], ")"}]]}]], "Input",
 CellChangeTimes->{{3.561447879707958*^9, 3.561447885877967*^9}}],

Cell["\<\
The first thing to do is to compute correction for this equation from \
wrappings. For this we has to first find porper double scaling equation for U.\
\>", "Text",
 CellChangeTimes->{{3.561382540529868*^9, 3.561382623342314*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Log", "[", 
    SubscriptBox[
     RowBox[{"(", 
      FractionBox[
       StyleBox["U",
        FontColor->RGBColor[0, 0.6, 0]], 
       SuperscriptBox[
        StyleBox["U",
         FontColor->RGBColor[0, 0.6, 0]], 
        RowBox[{"[", "2", "]"}]]], ")"}], "r"], "]"}], "[", "v", "]"}], 
  "\[Equal]", 
  RowBox[{
   RowBox[{
    FractionBox["1", "2"], 
    RowBox[{"\[DoubleStruckCapitalC]", "[", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        FractionBox["1", 
         RowBox[{"v", "-", "u"}]], "-", 
        FractionBox["1", 
         RowBox[{"v", "+", "u"}]]}], ")"}], "H"}], "]"}]}], "+", 
   RowBox[{
    FractionBox["1", "2"], 
    RowBox[{"\[DoubleStruckCapitalC]", "[", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        FractionBox["1", 
         RowBox[{"v", "+", "\[ImaginaryI]", "-", "u"}]], "-", 
        FractionBox["1", 
         RowBox[{"v", "+", "\[ImaginaryI]", "+", "u"}]]}], ")"}], 
      FractionBox[
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", 
          FractionBox[
           RowBox[{"v", "+", "\[ImaginaryI]"}], "g"]}], 
         SqrtBox[
          RowBox[{"1", "-", 
           FractionBox[
            RowBox[{"4", 
             SuperscriptBox["g", "2"]}], 
            SuperscriptBox[
             RowBox[{"(", 
              RowBox[{"v", "+", "\[ImaginaryI]"}], ")"}], "2"]]}]]}], ")"}], 
       RowBox[{
        FractionBox["u", "g"], 
        SqrtBox[
         RowBox[{"1", "-", 
          FractionBox[
           RowBox[{"4", 
            SuperscriptBox["g", "2"]}], 
           SuperscriptBox["u", "2"]]}]]}]], "H"}], "]"}]}], "+", 
   RowBox[{"\[DoubleStruckCapitalC]", "[", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       FractionBox["1", 
        RowBox[{"v", "-", "u"}]], "-", 
       FractionBox["1", 
        RowBox[{"v", "+", "u"}]]}], ")"}], 
     RowBox[{"Log", "[", 
      SubscriptBox[
       RowBox[{"(", 
        FractionBox[
         RowBox[{
          SuperscriptBox[
           StyleBox["\[GothicCapitalT]",
            FontColor->RGBColor[0.54, 0.35, 0.15]], "+"], " "}], 
         SuperscriptBox[
          StyleBox["\[ScriptCapitalT]",
           FontColor->RGBColor[1, 0, 0]], "+"]], ")"}], "r"], "]"}]}], 
    "]"}]}]}]], "Input",
 CellChangeTimes->{
  3.561382675670027*^9, 3.561382722815898*^9, {3.561446831819388*^9, 
   3.561446834832864*^9}, 3.562937986024357*^9}],

Cell[TextData[{
 "A nontrivial part is to bring v in  ",
 Cell[BoxData[
  FormBox[
   RowBox[{"(", 
    RowBox[{
     FractionBox["1", 
      RowBox[{"v", "-", "u"}]], "-", 
     FractionBox["1", 
      RowBox[{"v", "+", "u"}]]}], ")"}], TraditionalForm]]],
 " to the real axis. We hence introduce \[Epsilon]=\[ImaginaryI]/4 and use a \
possibility to shift contour, for v in the UHP. Then we will bring v to the "
}], "Text",
 CellChangeTimes->{{3.5613828283249483`*^9, 3.561382875452816*^9}, {
  3.561382939394115*^9, 3.561382943977477*^9}, {3.562938004500421*^9, 
  3.5629380050661488`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"\[DoubleStruckCapitalC]", "[", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      FractionBox["1", 
       RowBox[{"v", "-", 
        RowBox[{"(", 
         RowBox[{"u", "-", 
          FractionBox[
           RowBox[{"\[ImaginaryI]", " ", "\[Epsilon]"}], "4"]}], ")"}]}]], 
      "-", 
      FractionBox["1", 
       RowBox[{"v", "-", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"-", "u"}], "+", 
          FractionBox[
           RowBox[{"\[ImaginaryI]", " ", "\[Epsilon]"}], "4"]}], ")"}]}]]}], 
     ")"}], 
    RowBox[{"fun", "[", 
     RowBox[{"u", "-", 
      FractionBox[
       RowBox[{"\[ImaginaryI]", "  ", "\[Epsilon]"}], "4"]}], "]"}]}], "]"}], 
  "==", 
  RowBox[{"\[DoubleStruckCapitalC]", "[", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"-", 
      FractionBox[
       RowBox[{"fun", "[", 
        RowBox[{"u", "-", 
         FractionBox[
          RowBox[{"\[ImaginaryI]", "  ", "\[Epsilon]"}], "4"]}], "]"}], 
       RowBox[{
        RowBox[{"(", 
         RowBox[{"u", "-", 
          FractionBox[
           RowBox[{"\[ImaginaryI]", " ", "\[Epsilon]"}], "4"]}], ")"}], "-", 
        "v"}]]}], "-", 
     FractionBox[
      RowBox[{"fun", "[", 
       RowBox[{
        RowBox[{"-", "u"}], "-", 
        FractionBox[
         RowBox[{"\[ImaginaryI]", "  ", "\[Epsilon]"}], "4"]}], "]"}], 
      RowBox[{"v", "-", 
       RowBox[{"(", 
        RowBox[{"u", "+", 
         FractionBox[
          RowBox[{"\[ImaginaryI]", " ", "\[Epsilon]"}], "4"]}], ")"}]}]]}], 
    ")"}], "]"}], "==", 
  RowBox[{"\[DoubleStruckCapitalC]", "[", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"-", 
      FractionBox[
       RowBox[{"fun", "[", 
        RowBox[{"u", "-", 
         FractionBox[
          RowBox[{"\[ImaginaryI]", "  ", "\[Epsilon]"}], "4"]}], "]"}], 
       RowBox[{"u", "-", 
        RowBox[{"(", 
         RowBox[{"v", "+", 
          FractionBox[
           RowBox[{"\[ImaginaryI]", " ", "\[Epsilon]"}], "4"]}], ")"}]}]]}], 
     "+", 
     FractionBox[
      RowBox[{"fun", "[", 
       RowBox[{
        RowBox[{"-", "u"}], "-", 
        FractionBox[
         RowBox[{"\[ImaginaryI]", "  ", "\[Epsilon]"}], "4"]}], "]"}], 
      RowBox[{"u", "-", 
       RowBox[{"(", 
        RowBox[{"v", "-", 
         FractionBox[
          RowBox[{"\[ImaginaryI]", " ", "\[Epsilon]"}], "4"]}], ")"}]}]]}], 
    ")"}], "]"}], "\[Equal]", 
  RowBox[{"(*", " ", 
   RowBox[{
   "now", " ", "sending", " ", "v", " ", "to", " ", "the", " ", "real", " ", 
    "axis"}], " ", "*)"}], "==", 
  RowBox[{
   RowBox[{"-", 
    RowBox[{"fun", "[", 
     RowBox[{"-", "v"}], "]"}]}], "+", 
   RowBox[{"\[DoubleStruckCapitalC]", "[", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       FractionBox["1", 
        RowBox[{
         RowBox[{"Re", "[", "v", "]"}], "-", "u"}]], "-", 
       FractionBox["1", 
        RowBox[{
         RowBox[{"Re", "[", "v", "]"}], "+", "u"}]]}], ")"}], "fun"}], 
    "]"}]}]}]], "Input",
 CellChangeTimes->{{3.561382887417953*^9, 3.561382932160263*^9}, {
  3.561384925553718*^9, 3.561384985831064*^9}, {3.561385035198751*^9, 
  3.5613851187496147`*^9}, {3.5613851648040113`*^9, 3.56138516573042*^9}, {
  3.561385302041586*^9, 3.561385344327146*^9}, {3.5622360069482937`*^9, 
  3.562236028686739*^9}, {3.562308034056308*^9, 3.562308035654087*^9}}],

Cell["\<\
At this point we can expand normally. We have hence (with v on the real axis, \
and integration slightly below real axis):\
\>", "Text",
 CellChangeTimes->{{3.561385478745019*^9, 3.5613855418477097`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Log", "[", 
    SubscriptBox[
     RowBox[{"(", 
      FractionBox[
       StyleBox["U",
        FontColor->RGBColor[0, 0.6, 0]], 
       SuperscriptBox[
        StyleBox["U",
         FontColor->RGBColor[0, 0.6, 0]], 
        RowBox[{"[", "2", "]"}]]], ")"}], "r"], "]"}], "[", "v", "]"}], 
  "\[Equal]", 
  RowBox[{
   RowBox[{
    RowBox[{"-", 
     FractionBox["1", "2"]}], 
    OverscriptBox["H", "_"]}], "-", 
   RowBox[{"Log", "[", 
    SubscriptBox[
     RowBox[{"(", 
      FractionBox[
       RowBox[{
        SuperscriptBox[
         StyleBox["\[GothicCapitalT]",
          FontColor->RGBColor[0.54, 0.35, 0.15]], "-"], " "}], 
       SuperscriptBox[
        StyleBox["\[ScriptCapitalT]",
         FontColor->RGBColor[1, 0, 0]], "-"]], ")"}], "r"], "]"}], "+", 
   RowBox[{
    FractionBox["1", "2"], 
    RowBox[{"\[DoubleStruckCapitalC]", "[", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        FractionBox["1", 
         RowBox[{"v", "-", "u"}]], "-", 
        FractionBox["1", 
         RowBox[{"v", "+", "u"}]]}], ")"}], "H"}], "]"}]}], "+", 
   RowBox[{
    FractionBox["1", "2"], 
    RowBox[{"\[DoubleStruckCapitalC]", "[", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        FractionBox["1", 
         RowBox[{"v", "+", "\[ImaginaryI]", "-", "u"}]], "-", 
        FractionBox["1", 
         RowBox[{"v", "+", "\[ImaginaryI]", "+", "u"}]]}], ")"}], 
      FractionBox[
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", 
          FractionBox[
           RowBox[{"v", "+", "\[ImaginaryI]"}], "g"]}], 
         SqrtBox[
          RowBox[{"1", "-", 
           FractionBox[
            RowBox[{"4", 
             SuperscriptBox["g", "2"]}], 
            SuperscriptBox[
             RowBox[{"(", 
              RowBox[{"v", "+", "\[ImaginaryI]"}], ")"}], "2"]]}]]}], ")"}], 
       RowBox[{
        FractionBox["u", "g"], 
        SqrtBox[
         RowBox[{"1", "-", 
          FractionBox[
           RowBox[{"4", 
            SuperscriptBox["g", "2"]}], 
           SuperscriptBox["u", "2"]]}]]}]], "H"}], "]"}]}], "+", 
   RowBox[{"\[DoubleStruckCapitalC]", "[", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       FractionBox["1", 
        RowBox[{"v", "-", "u"}]], "-", 
       FractionBox["1", 
        RowBox[{"v", "+", "u"}]]}], ")"}], 
     RowBox[{"Log", "[", 
      SubscriptBox[
       RowBox[{"(", 
        FractionBox[
         RowBox[{
          SuperscriptBox[
           StyleBox["\[GothicCapitalT]",
            FontColor->RGBColor[0.54, 0.35, 0.15]], "+"], " "}], 
         SuperscriptBox[
          StyleBox["\[ScriptCapitalT]",
           FontColor->RGBColor[1, 0, 0]], "+"]], ")"}], "r"], "]"}]}], 
    "]"}]}]}]], "Input",
 CellChangeTimes->{{3.561385498106543*^9, 3.561385514647058*^9}, {
   3.561447047519516*^9, 3.561447067766657*^9}, {3.561447220549219*^9, 
   3.561447225515314*^9}, 3.5629382370888357`*^9}],

Cell[TextData[{
 "Recall now that ",
 Cell[BoxData[
  RowBox[{"H", "\[Congruent]", 
   RowBox[{"Log", "[", 
    SubscriptBox[
     RowBox[{"(", 
      FractionBox[
       SubscriptBox[
        StyleBox["\[GothicCapitalT]",
         FontColor->RGBColor[0.54, 0.35, 0.15]], 
        RowBox[{"1", ",", "0"}]], 
       SubsuperscriptBox[
        StyleBox["\[GothicCapitalT]",
         FontColor->RGBColor[0.54, 0.35, 0.15]], 
        RowBox[{"0", ",", "0"}], "+"]], ")"}], "r"], "]"}]}]],
  CellChangeTimes->{{3.561385619102685*^9, 3.561385619106113*^9}}],
 " and use equation above to compute ",
 Cell[BoxData[
  FormBox[
   RowBox[{"Log", "[", 
    SubscriptBox[
     RowBox[{"(", 
      RowBox[{"U", " ", 
       OverscriptBox["U", "_"]}], ")"}], "r"], "]"}], TraditionalForm]],
  FormatType->"TraditionalForm"],
 ". Substitute the answer to:"
}], "Text",
 CellChangeTimes->{{3.5613855292060966`*^9, 3.561385553354926*^9}, {
  3.561385624147732*^9, 3.561385630642788*^9}, {3.56293831613313*^9, 
  3.5629383477646646`*^9}}],

Cell[BoxData[
 RowBox[{"0", "==", 
  RowBox[{
   RowBox[{"Log", "[", 
    SubscriptBox[
     RowBox[{"(", 
      FractionBox[
       RowBox[{"(", 
        RowBox[{
         StyleBox["U",
          FontColor->RGBColor[0, 0.6, 0]], " ", 
         OverscriptBox[
          StyleBox["U",
           FontColor->RGBColor[0, 0.6, 0]], 
          StyleBox["_",
           FontColor->RGBColor[0, 0.6, 0]]]}], ")"}], 
       SqrtBox[
        RowBox[{
         SubsuperscriptBox["\[ScriptCapitalT]", 
          RowBox[{"0", ",", "0"}], "+"], 
         SubsuperscriptBox["\[ScriptCapitalT]", 
          RowBox[{"0", ",", "0"}], "-"]}]]], ")"}], "r"], "]"}], "-", 
   RowBox[{"Log", "[", 
    RowBox[{"(", 
     FractionBox[
      SubscriptBox[
       RowBox[{"(", 
        RowBox[{"1", "-", 
         RowBox[{
          SubscriptBox["Y", 
           RowBox[{"1", ",", "1"}]], 
          SubscriptBox["Y", 
           RowBox[{"2", ",", "2"}]]}]}], ")"}], "r"], 
      SubscriptBox[
       RowBox[{"(", 
        SubsuperscriptBox["\[GothicCapitalT]", 
         RowBox[{"0", ",", "1"}], "c"], ")"}], "r"]], ")"}], "]"}]}], "==", 
  RowBox[{
   RowBox[{"+", 
    RowBox[{"Log", "[", 
     SubscriptBox[
      RowBox[{"(", 
       RowBox[{
        SuperscriptBox[
         StyleBox["U",
          FontColor->RGBColor[0, 0.6, 0]], 
         RowBox[{"[", "2", "]"}]], 
        SuperscriptBox[
         OverscriptBox[
          StyleBox["U",
           FontColor->RGBColor[0, 0.6, 0]], 
          StyleBox["_",
           FontColor->RGBColor[0, 0.6, 0]]], 
         RowBox[{"[", 
          RowBox[{"-", "2"}], "]"}]]}], ")"}], "r"], "]"}]}], "-", 
   RowBox[{"Log", "[", 
    SubscriptBox[
     RowBox[{"(", 
      SubscriptBox[
       StyleBox["\[GothicCapitalT]",
        FontColor->RGBColor[0.54, 0.35, 0.15]], 
       RowBox[{"1", ",", "0"}]], ")"}], "r"], "]"}], "-", 
   RowBox[{"Log", "[", 
    SubscriptBox[
     RowBox[{"(", 
      RowBox[{
       FractionBox[
        RowBox[{
         SuperscriptBox[
          StyleBox["\[GothicCapitalT]",
           FontColor->RGBColor[0.54, 0.35, 0.15]], "-"], " "}], 
        SuperscriptBox[
         StyleBox["\[ScriptCapitalT]",
          FontColor->RGBColor[1, 0, 0]], "-"]], 
       FractionBox[
        RowBox[{
         SuperscriptBox[
          StyleBox["\[GothicCapitalT]",
           FontColor->RGBColor[0.54, 0.35, 0.15]], "+"], " "}], 
        SuperscriptBox[
         StyleBox["\[ScriptCapitalT]",
          FontColor->RGBColor[1, 0, 0]], "+"]]}], ")"}], "r"], "]"}], "-", 
   RowBox[{"Log", "[", 
    RowBox[{"(", 
     FractionBox[
      SubscriptBox[
       RowBox[{"(", 
        RowBox[{"1", "-", 
         RowBox[{
          SubscriptBox["Y", 
           RowBox[{"1", ",", "1"}]], 
          SubscriptBox["Y", 
           RowBox[{"2", ",", "2"}]]}]}], ")"}], "r"], 
      SubscriptBox[
       RowBox[{"(", 
        SubsuperscriptBox["\[GothicCapitalT]", 
         RowBox[{"0", ",", "1"}], "c"], ")"}], "r"]], ")"}], "]"}], "+", 
   RowBox[{"Re", "[", 
    RowBox[{
     RowBox[{"\[DoubleStruckCapitalC]", "[", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         FractionBox["1", 
          RowBox[{"v", "-", "u"}]], "-", 
         FractionBox["1", 
          RowBox[{"v", "+", "u"}]]}], ")"}], "H"}], "]"}], "+", 
     RowBox[{"\[DoubleStruckCapitalC]", "[", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         FractionBox["1", 
          RowBox[{"v", "+", "\[ImaginaryI]", "-", "u"}]], "-", 
         FractionBox["1", 
          RowBox[{"v", "+", "\[ImaginaryI]", "+", "u"}]]}], ")"}], 
       FractionBox[
        RowBox[{"(", 
         RowBox[{
          RowBox[{"-", 
           FractionBox[
            RowBox[{"v", "+", "\[ImaginaryI]"}], "g"]}], 
          SqrtBox[
           RowBox[{"1", "-", 
            FractionBox[
             RowBox[{"4", 
              SuperscriptBox["g", "2"]}], 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{"v", "+", "\[ImaginaryI]"}], ")"}], "2"]]}]]}], ")"}], 
        
        RowBox[{
         FractionBox["u", "g"], 
         SqrtBox[
          RowBox[{"1", "-", 
           FractionBox[
            RowBox[{"4", 
             SuperscriptBox["g", "2"]}], 
            SuperscriptBox["u", "2"]]}]]}]], "H"}], "]"}]}], "]"}], "+", 
   RowBox[{"2", " ", 
    RowBox[{"Re", "@", 
     RowBox[{"\[DoubleStruckCapitalC]", "[", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         FractionBox["1", 
          RowBox[{"v", "-", "u"}]], "-", 
         FractionBox["1", 
          RowBox[{"v", "+", "u"}]]}], ")"}], 
       RowBox[{"Log", "[", 
        SubscriptBox[
         RowBox[{"(", 
          FractionBox[
           RowBox[{
            SuperscriptBox[
             StyleBox["\[GothicCapitalT]",
              FontColor->RGBColor[0.54, 0.35, 0.15]], "+"], " "}], 
           SuperscriptBox[
            StyleBox["\[ScriptCapitalT]",
             FontColor->RGBColor[1, 0, 0]], "+"]], ")"}], "r"], "]"}]}], 
      "]"}]}]}]}], "\[Equal]", "\[IndentingNewLine]", "==", 
  RowBox[{
   RowBox[{"+", 
    RowBox[{"Log", "[", 
     RowBox[{
      SubscriptBox[
       RowBox[{"(", 
        RowBox[{
         SuperscriptBox[
          StyleBox["U",
           FontColor->RGBColor[0, 0.6, 0]], 
          RowBox[{"[", "2", "]"}]], 
         SuperscriptBox[
          OverscriptBox[
           StyleBox["U",
            FontColor->RGBColor[0, 0.6, 0]], 
           StyleBox["_",
            FontColor->RGBColor[0, 0.6, 0]]], 
          RowBox[{"[", 
           RowBox[{"-", "2"}], "]"}]]}], ")"}], "r"], 
      SubscriptBox[
       RowBox[{"(", 
        RowBox[{
         SuperscriptBox[
          StyleBox["\[ScriptCapitalT]",
           FontColor->RGBColor[1, 0, 0]], "-"], 
         SuperscriptBox[
          StyleBox["\[ScriptCapitalT]",
           FontColor->RGBColor[1, 0, 0]], "+"]}], ")"}], "r"]}], "]"}]}], "-", 
   RowBox[{"Log", "[", 
    SubscriptBox[
     RowBox[{"(", 
      SubscriptBox[
       StyleBox["\[GothicCapitalT]",
        FontColor->RGBColor[0.54, 0.35, 0.15]], 
       RowBox[{"1", ",", "0"}]], ")"}], "r"], "]"}], "-", 
   RowBox[{"Log", "[", 
    RowBox[{"(", 
     FractionBox[
      SubscriptBox[
       RowBox[{"(", 
        RowBox[{
         SuperscriptBox[
          StyleBox["\[GothicCapitalT]",
           FontColor->RGBColor[0.54, 0.35, 0.15]], "-"], 
         SuperscriptBox[
          StyleBox["\[GothicCapitalT]",
           FontColor->RGBColor[0.54, 0.35, 0.15]], "+"]}], " ", ")"}], "r"], 
      SubscriptBox[
       RowBox[{"(", 
        SubscriptBox[
         StyleBox["\[GothicCapitalT]",
          FontColor->RGBColor[0.54, 0.35, 0.15]], 
         RowBox[{"0", ",", "1"}]], ")"}], "r"]], ")"}], "]"}], "+", 
   RowBox[{"+", 
    RowBox[{"Re", "[", 
     RowBox[{
      RowBox[{"\[DoubleStruckCapitalC]", "[", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          FractionBox["1", 
           RowBox[{"v", "-", "u"}]], "-", 
          FractionBox["1", 
           RowBox[{"v", "+", "u"}]]}], ")"}], "H"}], "]"}], "+", 
      RowBox[{"\[DoubleStruckCapitalC]", "[", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          FractionBox["1", 
           RowBox[{"v", "+", "\[ImaginaryI]", "-", "u"}]], "-", 
          FractionBox["1", 
           RowBox[{"v", "+", "\[ImaginaryI]", "+", "u"}]]}], ")"}], 
        FractionBox[
         RowBox[{"(", 
          RowBox[{
           RowBox[{"-", 
            FractionBox[
             RowBox[{"v", "+", "\[ImaginaryI]"}], "g"]}], 
           SqrtBox[
            RowBox[{"1", "-", 
             FractionBox[
              RowBox[{"4", 
               SuperscriptBox["g", "2"]}], 
              SuperscriptBox[
               RowBox[{"(", 
                RowBox[{"v", "+", "\[ImaginaryI]"}], ")"}], "2"]]}]]}], ")"}], 
         RowBox[{
          FractionBox["u", "g"], 
          SqrtBox[
           RowBox[{"1", "-", 
            FractionBox[
             RowBox[{"4", 
              SuperscriptBox["g", "2"]}], 
             SuperscriptBox["u", "2"]]}]]}]], "H"}], "]"}]}], "]"}]}], "+", 
   RowBox[{"2", " ", 
    RowBox[{"Re", "@", 
     RowBox[{"\[DoubleStruckCapitalC]", "[", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         FractionBox["1", 
          RowBox[{"v", "-", "u"}]], "-", 
         FractionBox["1", 
          RowBox[{"v", "+", "u"}]]}], ")"}], 
       RowBox[{"Log", "[", 
        SubscriptBox[
         RowBox[{"(", 
          FractionBox[
           RowBox[{
            SuperscriptBox[
             StyleBox["\[GothicCapitalT]",
              FontColor->RGBColor[0.54, 0.35, 0.15]], "+"], " "}], 
           SuperscriptBox[
            StyleBox["\[ScriptCapitalT]",
             FontColor->RGBColor[1, 0, 0]], "+"]], ")"}], "r"], "]"}]}], 
      "]"}]}]}]}], "\[Equal]", "\[IndentingNewLine]", "==", 
  RowBox[{
   RowBox[{"+", 
    RowBox[{"Log", "[", 
     RowBox[{
      SubscriptBox[
       RowBox[{"(", 
        RowBox[{
         SuperscriptBox[
          StyleBox["U",
           FontColor->RGBColor[0, 0.6, 0]], 
          RowBox[{"[", "2", "]"}]], 
         SuperscriptBox[
          OverscriptBox[
           StyleBox["U",
            FontColor->RGBColor[0, 0.6, 0]], 
           StyleBox["_",
            FontColor->RGBColor[0, 0.6, 0]]], 
          RowBox[{"[", 
           RowBox[{"-", "2"}], "]"}]]}], ")"}], "r"], 
      SubscriptBox[
       RowBox[{"(", 
        FractionBox[
         RowBox[{
          SuperscriptBox[
           StyleBox["\[ScriptCapitalT]",
            FontColor->RGBColor[1, 0, 0]], "-"], 
          SuperscriptBox[
           StyleBox["\[ScriptCapitalT]",
            FontColor->RGBColor[1, 0, 0]], "+"]}], 
         SubscriptBox[
          StyleBox["\[GothicCapitalT]",
           FontColor->RGBColor[0.54, 0.35, 0.15]], 
          RowBox[{"1", ",", "0"}]]], ")"}], "r"]}], "]"}]}], "+", 
   RowBox[{"\[DoubleStruckCapitalC]", "[", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       FractionBox["1", 
        RowBox[{"v", "-", "u"}]], "-", 
       FractionBox["1", 
        RowBox[{"v", "+", "u"}]]}], ")"}], "H"}], "]"}], "+", 
   RowBox[{"\[DoubleStruckCapitalC]", "[", 
    RowBox[{
     FractionBox[
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           FractionBox["1", 
            RowBox[{"v", "+", "\[ImaginaryI]", "-", "u"}]], "-", 
           FractionBox["1", 
            RowBox[{"v", "+", "\[ImaginaryI]", "+", "u"}]]}], ")"}], 
         FractionBox[
          RowBox[{"(", 
           RowBox[{
            RowBox[{"-", 
             FractionBox[
              RowBox[{"v", "+", "\[ImaginaryI]"}], "g"]}], 
            SqrtBox[
             RowBox[{"1", "-", 
              FractionBox[
               RowBox[{"4", 
                SuperscriptBox["g", "2"]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{"v", "+", "\[ImaginaryI]"}], ")"}], "2"]]}]]}], 
           ")"}], 
          RowBox[{
           FractionBox["u", "g"], 
           SqrtBox[
            RowBox[{"1", "-", 
             FractionBox[
              RowBox[{"4", 
               SuperscriptBox["g", "2"]}], 
              SuperscriptBox["u", "2"]]}]]}]]}], "-", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           FractionBox["1", 
            RowBox[{"v", "-", "\[ImaginaryI]", "+", "u"}]], "-", 
           FractionBox["1", 
            RowBox[{"v", "-", "\[ImaginaryI]", "-", "u"}]]}], ")"}], 
         FractionBox[
          RowBox[{"(", 
           RowBox[{
            RowBox[{"-", 
             FractionBox[
              RowBox[{"v", "-", "\[ImaginaryI]"}], "g"]}], 
            SqrtBox[
             RowBox[{"1", "-", 
              FractionBox[
               RowBox[{"4", 
                SuperscriptBox["g", "2"]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{"v", "-", "\[ImaginaryI]"}], ")"}], "2"]]}]]}], 
           ")"}], 
          RowBox[{
           FractionBox[
            RowBox[{"-", "u"}], "g"], 
           SqrtBox[
            RowBox[{"1", "-", 
             FractionBox[
              RowBox[{"4", 
               SuperscriptBox["g", "2"]}], 
              SuperscriptBox["u", "2"]]}]]}]]}]}], ")"}], "2"], "H"}], "]"}], 
   "+", 
   RowBox[{"2", 
    RowBox[{"\[DoubleStruckCapitalC]", "[", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        FractionBox["1", 
         RowBox[{"v", "-", "u"}]], "-", 
        FractionBox["1", 
         RowBox[{"v", "+", "u"}]]}], ")"}], 
      RowBox[{"Log", "[", 
       SubscriptBox[
        RowBox[{"(", 
         FractionBox[
          RowBox[{
           SuperscriptBox[
            StyleBox["\[GothicCapitalT]",
             FontColor->RGBColor[0.54, 0.35, 0.15]], "+"], " "}], 
          SuperscriptBox[
           StyleBox["\[ScriptCapitalT]",
            FontColor->RGBColor[1, 0, 0]], "+"]], ")"}], "r"], "]"}]}], 
     "]"}]}], "-", 
   RowBox[{"Log", "[", 
    RowBox[{"(", 
     FractionBox[
      SubscriptBox[
       RowBox[{"(", 
        RowBox[{
         SuperscriptBox[
          StyleBox["\[GothicCapitalT]",
           FontColor->RGBColor[0.54, 0.35, 0.15]], "-"], 
         SuperscriptBox[
          StyleBox["\[GothicCapitalT]",
           FontColor->RGBColor[0.54, 0.35, 0.15]], "+"]}], " ", ")"}], "r"], 
      SubscriptBox[
       RowBox[{"(", 
        SubscriptBox[
         StyleBox["\[GothicCapitalT]",
          FontColor->RGBColor[0.54, 0.35, 0.15]], 
         RowBox[{"0", ",", "1"}]], ")"}], "r"]], ")"}], "]"}]}]}]], "Input",
 CellChangeTimes->{{3.561385564683025*^9, 3.5613855898394012`*^9}, {
   3.5613856457485533`*^9, 3.5613856603040752`*^9}, {3.561385742925062*^9, 
   3.561385899433226*^9}, {3.5613860763889923`*^9, 3.5613860814802427`*^9}, {
   3.561386136765773*^9, 3.5613862131541147`*^9}, {3.561386326341745*^9, 
   3.561386328398435*^9}, {3.561386363126471*^9, 3.5613864575805817`*^9}, {
   3.561386743548415*^9, 3.5613867439498796`*^9}, {3.561447125580657*^9, 
   3.561447132160644*^9}, {3.5614472334077682`*^9, 3.56144725894431*^9}, 
   3.561447310115383*^9, {3.561447340331964*^9, 3.561447437092498*^9}, {
   3.5614478974445133`*^9, 3.561447897650797*^9}, 3.561448057695528*^9, 
   3.562236367509132*^9, {3.562236902628665*^9, 3.5622369034391747`*^9}, {
   3.562237180607883*^9, 3.562237181945425*^9}, {3.562938301854785*^9, 
   3.56293830922396*^9}, {3.5629383961767263`*^9, 3.562938403096982*^9}, {
   3.5629384531232567`*^9, 3.562938460027605*^9}, {3.562938490159568*^9, 
   3.562938494885264*^9}, {3.5629386262995853`*^9, 3.5629386284311457`*^9}}],

Cell["\<\
As for the question for the leading 8 loop correction (btw we already \
disregarded h, so it is 8 loops only), the integral can be reduced to:\
\>", "Text",
 CellChangeTimes->{{3.561386463489559*^9, 3.561386478211195*^9}, {
  3.562938602625321*^9, 3.562938613270753*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Series", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      FractionBox["1", 
       RowBox[{"v", "-", "u"}]], "-", 
      FractionBox["1", 
       RowBox[{"v", "+", "u"}]]}], ")"}], "/.", 
    RowBox[{"v", "\[Rule]", 
     RowBox[{"2", "g", " ", "z"}]}]}], " ", ",", 
   RowBox[{"{", 
    RowBox[{"g", ",", "0", ",", "6"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.5613869662652197`*^9, 3.5613869727299137`*^9}}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
   RowBox[{"-", 
    FractionBox["2", "u"]}], "-", 
   FractionBox[
    RowBox[{"8", " ", 
     SuperscriptBox["z", "2"], " ", 
     SuperscriptBox["g", "2"]}], 
    SuperscriptBox["u", "3"]], "-", 
   FractionBox[
    RowBox[{"32", " ", 
     SuperscriptBox["z", "4"], " ", 
     SuperscriptBox["g", "4"]}], 
    SuperscriptBox["u", "5"]], "-", 
   FractionBox[
    RowBox[{"128", " ", 
     SuperscriptBox["z", "6"], " ", 
     SuperscriptBox["g", "6"]}], 
    SuperscriptBox["u", "7"]], "+", 
   InterpretationBox[
    SuperscriptBox[
     RowBox[{"O", "[", "g", "]"}], "7"],
    SeriesData[$CellContext`g, 0, {}, 0, 7, 1],
    Editable->False]}],
  SeriesData[$CellContext`g, 
   0, {(-2)/$CellContext`u, 0, (-8) $CellContext`u^(-3) $CellContext`z^2, 
    0, (-32) $CellContext`u^(-5) $CellContext`z^4, 
    0, (-128) $CellContext`u^(-7) $CellContext`z^6}, 0, 7, 1],
  Editable->False]], "Output",
 CellChangeTimes->{3.5613869736815157`*^9, 3.562938593101451*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"Series", "[", 
   RowBox[{
    RowBox[{
     FractionBox[
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           FractionBox["1", 
            RowBox[{"v", "+", "\[ImaginaryI]", "-", "u"}]], "-", 
           FractionBox["1", 
            RowBox[{"v", "+", "\[ImaginaryI]", "+", "u"}]]}], ")"}], 
         FractionBox[
          RowBox[{"(", 
           RowBox[{
            RowBox[{"-", 
             FractionBox[
              RowBox[{"v", "+", "\[ImaginaryI]"}], "g"]}], 
            SqrtBox[
             RowBox[{"1", "-", 
              FractionBox[
               RowBox[{"4", 
                SuperscriptBox["g", "2"]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{"v", "+", "\[ImaginaryI]"}], ")"}], "2"]]}]]}], 
           ")"}], 
          RowBox[{
           FractionBox["u", "g"], 
           SqrtBox[
            RowBox[{"1", "-", 
             FractionBox[
              RowBox[{"4", 
               SuperscriptBox["g", "2"]}], 
              SuperscriptBox["u", "2"]]}]]}]]}], "-", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           FractionBox["1", 
            RowBox[{"v", "-", "\[ImaginaryI]", "+", "u"}]], "-", 
           FractionBox["1", 
            RowBox[{"v", "-", "\[ImaginaryI]", "-", "u"}]]}], ")"}], 
         FractionBox[
          RowBox[{"(", 
           RowBox[{
            RowBox[{"-", 
             FractionBox[
              RowBox[{"v", "-", "\[ImaginaryI]"}], "g"]}], 
            SqrtBox[
             RowBox[{"1", "-", 
              FractionBox[
               RowBox[{"4", 
                SuperscriptBox["g", "2"]}], 
               SuperscriptBox[
                RowBox[{"(", 
                 RowBox[{"v", "-", "\[ImaginaryI]"}], ")"}], "2"]]}]]}], 
           ")"}], 
          RowBox[{
           FractionBox[
            RowBox[{"-", "u"}], "g"], 
           SqrtBox[
            RowBox[{"1", "-", 
             FractionBox[
              RowBox[{"4", 
               SuperscriptBox["g", "2"]}], 
              SuperscriptBox["u", "2"]]}]]}]]}]}], ")"}], "2"], "/.", 
     RowBox[{"v", "\[Rule]", 
      RowBox[{"2", "g", " ", "z"}]}]}], " ", ",", 
    RowBox[{"{", 
     RowBox[{"g", ",", "0", ",", "2"}], "}"}]}], "]"}], "//", 
  "Simplify"}]], "Input",
 CellChangeTimes->{{3.5622370729253798`*^9, 3.5622370919018*^9}, 
   3.562237196824435*^9, 3.562938590452076*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
   FractionBox[
    RowBox[{"2", " ", "\[ImaginaryI]"}], 
    RowBox[{"1", "+", 
     SuperscriptBox["u", "2"]}]], "+", 
   FractionBox[
    RowBox[{"4", " ", "\[ImaginaryI]", " ", 
     RowBox[{"(", 
      RowBox[{"1", "+", 
       SuperscriptBox["u", "6"], "+", 
       RowBox[{
        SuperscriptBox["u", "2"], " ", 
        RowBox[{"(", 
         RowBox[{"3", "-", 
          RowBox[{"2", " ", 
           SuperscriptBox["z", "2"]}]}], ")"}]}], "+", 
       RowBox[{
        SuperscriptBox["u", "4"], " ", 
        RowBox[{"(", 
         RowBox[{"3", "+", 
          RowBox[{"6", " ", 
           SuperscriptBox["z", "2"]}]}], ")"}]}]}], ")"}], " ", 
     SuperscriptBox["g", "2"]}], 
    RowBox[{
     SuperscriptBox["u", "2"], " ", 
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{"1", "+", 
        SuperscriptBox["u", "2"]}], ")"}], "3"]}]], "+", 
   InterpretationBox[
    SuperscriptBox[
     RowBox[{"O", "[", "g", "]"}], "3"],
    SeriesData[$CellContext`g, 0, {}, 0, 3, 1],
    Editable->False]}],
  SeriesData[$CellContext`g, 0, {
   Complex[0, 2]/(1 + $CellContext`u^2), 0, 
    Complex[0, 4] $CellContext`u^(-2) (1 + $CellContext`u^2)^(-3) (
     1 + $CellContext`u^6 + $CellContext`u^2 (3 - 
       2 $CellContext`z^2) + $CellContext`u^4 (3 + 6 $CellContext`z^2))}, 0, 
   3, 1],
  Editable->False]], "Output",
 CellChangeTimes->{{3.562237086630995*^9, 3.562237092517663*^9}, 
   3.56223719750849*^9, 3.562938595337101*^9}]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"+", 
   RowBox[{"Log", "[", 
    SubscriptBox[
     RowBox[{"(", 
      RowBox[{
       SuperscriptBox[
        StyleBox["U",
         FontColor->RGBColor[0, 0.6, 0]], 
        RowBox[{"[", "2", "]"}]], 
       SuperscriptBox[
        OverscriptBox[
         StyleBox["U",
          FontColor->RGBColor[0, 0.6, 0]], 
         StyleBox["_",
          FontColor->RGBColor[0, 0.6, 0]]], 
        RowBox[{"[", 
         RowBox[{"-", "2"}], "]"}]]}], ")"}], "r"], "]"}]}], "\[Equal]", 
  RowBox[{
   RowBox[{"Log", "[", 
    RowBox[{
     RowBox[{"(", 
      FractionBox[
       SubscriptBox[
        RowBox[{"(", 
         RowBox[{"1", "-", 
          RowBox[{
           SubscriptBox["Y", 
            RowBox[{"1", ",", "1"}]], 
           SubscriptBox["Y", 
            RowBox[{"2", ",", "2"}]]}]}], ")"}], "r"], 
       SubscriptBox[
        RowBox[{"(", 
         SubsuperscriptBox["\[GothicCapitalT]", 
          RowBox[{"0", ",", "1"}], "c"], ")"}], "r"]], ")"}], 
     SubscriptBox[
      RowBox[{"(", 
       RowBox[{
        SuperscriptBox[
         StyleBox["\[GothicCapitalT]",
          FontColor->RGBColor[0.54, 0.35, 0.15]], "-"], 
        SuperscriptBox[
         StyleBox["\[GothicCapitalT]",
          FontColor->RGBColor[0.54, 0.35, 0.15]], "+"]}], " ", ")"}], "r"]}], 
    "]"}], "+", 
   RowBox[{"Log", "[", 
    SubscriptBox[
     RowBox[{"(", 
      SubscriptBox[
       StyleBox["\[GothicCapitalT]",
        FontColor->RGBColor[0.54, 0.35, 0.15]], 
       RowBox[{"1", ",", "0"}]], ")"}], "r"], "]"}], "+", 
   RowBox[{"\[DoubleStruckCapitalC]", "[", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       FractionBox["2", "u"], "-", 
       FractionBox[
        RowBox[{"2", " ", "\[ImaginaryI]"}], 
        RowBox[{"1", "+", 
         SuperscriptBox["u", "2"]}]]}], ")"}], "H"}], "]"}], "+", 
   RowBox[{"\[DoubleStruckCapitalC]", "[", 
    RowBox[{
     FractionBox["4", "u"], 
     RowBox[{"Log", "[", 
      SubscriptBox[
       RowBox[{"(", 
        SuperscriptBox[
         StyleBox["\[GothicCapitalT]",
          FontColor->RGBColor[0.54, 0.35, 0.15]], "+"], ")"}], "r"], "]"}]}], 
    "]"}], "-", 
   RowBox[{"Log", "[", 
    SubscriptBox[
     RowBox[{"(", 
      RowBox[{
       SuperscriptBox[
        StyleBox["\[ScriptCapitalT]",
         FontColor->RGBColor[1, 0, 0]], "-"], 
       SuperscriptBox[
        StyleBox["\[ScriptCapitalT]",
         FontColor->RGBColor[1, 0, 0]], "+"]}], ")"}], "r"], 
    "]"}]}]}]], "Input",
 CellChangeTimes->{{3.561386514062299*^9, 3.561386523180409*^9}, {
   3.561386578105949*^9, 3.561386583994787*^9}, {3.561386769029749*^9, 
   3.5613867794913883`*^9}, {3.5614395433531227`*^9, 3.561439621599678*^9}, 
   3.561439718612031*^9, {3.56144213822748*^9, 3.561442172554162*^9}, {
   3.5614422453803673`*^9, 3.5614422461177464`*^9}, {3.5614643887266417`*^9, 
   3.5614644640112658`*^9}, {3.561466060612913*^9, 3.5614660626098623`*^9}, {
   3.562237110837349*^9, 3.5622371125031137`*^9}, {3.562237157630674*^9, 
   3.562237164270631*^9}, {3.562237201994412*^9, 3.562237221133685*^9}, 
   3.562237273821883*^9, 3.562938673994153*^9, {3.562938910724608*^9, 
   3.562938934532566*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 "Computing ",
 Cell[BoxData[
  FormBox[
   SubscriptBox["q", "2"], TraditionalForm]]],
 " up to five loops, both in double scaling and ordinary scaling"
}], "Subsection",
 CellChangeTimes->{{3.560866902544417*^9, 3.560866912004005*^9}, {
  3.561471202320683*^9, 3.561471239663786*^9}, {3.562940204499371*^9, 
  3.562940212145215*^9}, {3.562940302198717*^9, 3.5629403245158043`*^9}, {
  3.562941206494398*^9, 3.562941212941285*^9}}],

Cell[CellGroupData[{

Cell["Normal scaling", "Subsubsection",
 CellChangeTimes->{{3.562941200704056*^9, 3.5629412039976807`*^9}}],

Cell[BoxData[
 RowBox[{
  SubscriptBox["q", "2"], "=", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"-", "\[ImaginaryI]"}], " ", "u"}], "+", 
    RowBox[{"\[ScriptCapitalC]", "*", "\[Rho]2"}], "-", 
    RowBox[{"\[ScriptCapitalC]", "*", "W"}]}], "=", 
   RowBox[{
    SubscriptBox["q", 
     RowBox[{"2", ",", "as"}]], "+", 
    RowBox[{"\[ScriptCapitalC]", "*", 
     SubscriptBox["\[Delta]\[Rho]", "2"]}], "-", 
    RowBox[{"\[ScriptCapitalC]", "*", 
     SubscriptBox["W", "lead"]}]}]}]}]], "Input",
 CellChangeTimes->{{3.561471207188881*^9, 3.5614712255304956`*^9}, {
  3.561471297670479*^9, 3.561471310919034*^9}}],

Cell[TextData[{
 Cell[BoxData[
  FormBox[
   SubscriptBox["\[Delta]\[Rho]", "2"], TraditionalForm]]],
 " correction"
}], "Text",
 CellChangeTimes->{{3.561471314860096*^9, 3.561471319145516*^9}}],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"Collect", "[", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           RowBox[{
            RowBox[{"Series", "[", 
             RowBox[{
              RowBox[{"(", 
               RowBox[{
                RowBox[{"-", 
                 FractionBox[
                  RowBox[{"2", "w", " ", "g"}], 
                  RowBox[{"2", " ", "\[ImaginaryI]"}]]}], 
                RowBox[{"(", 
                 FractionBox["1", 
                  RowBox[{"u", "-", 
                   RowBox[{"2", "g", " ", "w"}]}]], ")"}], 
                SuperscriptBox["g", "7"], 
                RowBox[{"(", 
                 RowBox[{
                  SubscriptBox["\[Delta]\[Rho]2", "lead"], "+", 
                  RowBox[{
                   SuperscriptBox["g", "2"], 
                   SubscriptBox["\[Delta]\[Rho]2", "sublead"]}]}], ")"}]}], 
               ")"}], ",", 
              RowBox[{"{", 
               RowBox[{"g", ",", "0", ",", "9"}], "}"}]}], "]"}], "//", 
            "Normal"}], "//", "Expand"}], ")"}], "/.", 
         RowBox[{
          SuperscriptBox["w", 
           RowBox[{"a_", "/;", 
            RowBox[{"EvenQ", "[", "a", "]"}]}]], "\[Rule]", "0"}]}], "/.", 
        RowBox[{
         RowBox[{
          SuperscriptBox["w", "a_."], 
          SubscriptBox["\[Delta]\[Rho]2", "b_"]}], "\[RuleDelayed]", 
         RowBox[{"M", "[", 
          RowBox[{
           SuperscriptBox["w", 
            RowBox[{"a", "-", "1"}]], 
           SubscriptBox["\[Delta]\[Rho]2", "b"]}], "]"}]}]}], "/.", 
       "sub\[Rho]Ansatz"}], "/.", 
      RowBox[{"(", 
       RowBox[{"Rule", "@@@", 
        RowBox[{"Cases", "[", 
         RowBox[{
          RowBox[{"solut\[Rho]s", "/.", 
           RowBox[{"Rule", "\[Rule]", "List"}]}], ",", 
          RowBox[{"List", "[", 
           RowBox[{"a_", ",", "0"}], "]"}]}], "]"}]}], ")"}]}], "//", 
     "Expand"}], ",", 
    RowBox[{"{", 
     RowBox[{"g", ",", 
      RowBox[{
       SubscriptBox["\[Beta]", "_"], "[", "_", "]"}], ",", 
      RowBox[{
       SubscriptBox["\[Alpha]", "_"], "[", "_", "]"}]}], "}"}]}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Collect", "[", 
   RowBox[{"%", ",", "g", ",", "Simplify"}], "]"}], "/.", " ", 
  RowBox[{
   RowBox[{
    RowBox[{"4", " ", 
     RowBox[{
      SubscriptBox["\[Alpha]", "lead"], "[", "0", "]"}]}], "+", 
    RowBox[{
     SubscriptBox["\[Alpha]", "lead"], "[", "1", "]"}]}], "\[Rule]", " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"Expand", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"4", " ", 
         RowBox[{
          SubscriptBox["\[Alpha]", "lead"], "[", "0", "]"}]}], "+", 
        RowBox[{
         SubscriptBox["\[Alpha]", "lead"], "[", "1", "]"}]}], "/.", 
       "solut\[Rho]s"}], "]"}], "//.", 
     RowBox[{
      RowBox[{
       RowBox[{"a_.", " ", 
        RowBox[{"\[DoubleStruckCapitalC]", "[", "b_", "]"}]}], "+", 
       RowBox[{"d_.", " ", 
        RowBox[{"\[DoubleStruckCapitalC]", "[", "e_", "]"}]}]}], 
      "\[RuleDelayed]", 
      RowBox[{"\[DoubleStruckCapitalC]", "[", 
       RowBox[{
        RowBox[{
         RowBox[{
          RowBox[{"a", " ", "b"}], "+", 
          RowBox[{"d", " ", "e"}]}], "/.", "subQ0"}], "//", "Simplify"}], 
       "]"}]}]}], ")"}]}]}]}], "Input",
 CellChangeTimes->{{3.5629404415189657`*^9, 3.562940463327367*^9}, {
   3.562940506359597*^9, 3.562940537798473*^9}, {3.562940607127117*^9, 
   3.5629406131640167`*^9}, 3.563300885073784*^9}],

Cell[BoxData[
 FractionBox[
  RowBox[{"\[ImaginaryI]", " ", 
   SuperscriptBox["g", "8"], " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"\[DoubleStruckCapitalC]", "[", 
      RowBox[{"-", 
       FractionBox[
        RowBox[{"8", " ", "\[ImaginaryI]", " ", 
         RowBox[{"(", 
          RowBox[{"1", "+", 
           RowBox[{"3", " ", 
            SuperscriptBox["u", "2"]}]}], ")"}], " ", 
         SubscriptBox[
          OverscriptBox[
           StyleBox["W",
            FontColor->RGBColor[0.54, 0.35, 0.15]], 
           StyleBox["^",
            FontColor->RGBColor[0.54, 0.35, 0.15]]], "lead"]}], 
        RowBox[{"1", "+", 
         RowBox[{"3", " ", 
          SuperscriptBox["u", "2"]}], "+", 
         RowBox[{"9", " ", 
          SuperscriptBox["u", "4"]}]}]]}], "]"}], "-", 
     RowBox[{
      FractionBox["8", "3"], " ", 
      SubscriptBox[
       StyleBox["W",
        FontColor->RGBColor[0.54, 0.35, 0.15]], 
       RowBox[{"1", ",", "v0", ",", "lead"}]]}]}], ")"}]}], 
  RowBox[{"8", " ", "u"}]]], "Output",
 CellChangeTimes->{{3.562940486541848*^9, 3.5629405380200357`*^9}, {
   3.562940609769445*^9, 3.5629406135227423`*^9}, 3.562949312767509*^9, 
   3.563300891326494*^9}]
}, Open  ]],

Cell[BoxData[{
 RowBox[{
  RowBox[{"Collect", "[", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{"Collect", "[", 
         RowBox[{
          RowBox[{"Series", "[", 
           RowBox[{
            RowBox[{
             RowBox[{
              RowBox[{
               RowBox[{
                RowBox[{"W", "/.", "subWq"}], "/.", "subq34"}], "/.", 
               "substandardq"}], "/.", 
              RowBox[{"{", 
               RowBox[{
                RowBox[{
                 OverscriptBox["\[Alpha]", "_"], "\[Rule]", "0"}], ",", 
                RowBox[{"\[Alpha]", "\[Rule]", "0"}]}], "}"}]}], "/.", 
             RowBox[{"leadweak", "[", "1", "]"}]}], ",", 
            RowBox[{"{", 
             RowBox[{"g", ",", "0", ",", "8"}], "}"}]}], "]"}], ",", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"g", ",", "\[Eta]list", ",", "Q0list"}], "}"}], "//", 
           "Flatten"}]}], "]"}], "/.", 
        RowBox[{"g", "\[Rule]", "1"}]}], "/.", "subtousu"}], "//", 
      "funapartusu"}], "//", "funreduceusu"}], ",", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"\[Eta]list", ",", 
       RowBox[{
        RowBox[{"\[ScriptU]$", "[", "_", "]"}], "[", "_", "]"}]}], "}"}], "//",
      "Flatten"}]}], "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"mtmp", "=", 
   RowBox[{"Collect", "[", 
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          RowBox[{"-", 
           FractionBox[
            RowBox[{"8", " ", "\[ImaginaryI]", " ", 
             RowBox[{"(", 
              RowBox[{"1", "+", 
               RowBox[{"3", " ", 
                SuperscriptBox["u", "2"]}]}], ")"}]}], 
            RowBox[{"9", 
             SuperscriptBox["Q0", "+"], 
             SuperscriptBox["Q0", "-"]}]]}], "/.", "subtousu"}], ")"}], "%"}],
        "//", "funapartusu"}], "//", "funreduceusu"}], ",", "canlist"}], 
    "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"tmp1", "=", 
   RowBox[{
    RowBox[{
     RowBox[{"UpIntegrate", "[", 
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{
          RowBox[{
           RowBox[{"-", 
            FractionBox["1", 
             RowBox[{"2", "\[Pi]", " ", "\[ImaginaryI]"}]]}], "mtmp"}], "/.", 
          "subusu"}], "/.", 
         RowBox[{"u", "\[Rule]", 
          RowBox[{"u", "-", 
           RowBox[{"\[ImaginaryI]", " ", "\[Epsilon]"}]}]}]}], "/.", 
        RowBox[{"Shift", "[", 
         RowBox[{
          RowBox[{"-", "2"}], "\[Epsilon]"}], "]"}]}], ",", "u"}], "]"}], "/.",
      "EndSimplify"}], "//", "fundeperiod"}]}], ";"}]}], "Input",
 CellChangeTimes->{{3.562916057922906*^9, 3.562916067933797*^9}, {
  3.5629161054061813`*^9, 3.562916319158293*^9}, {3.56291675713164*^9, 
  3.562916757716003*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"tmp2", "=", 
  RowBox[{"Collect", "[", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{
          RowBox[{
           FractionBox[
            RowBox[{"-", "8"}], "3"], 
           SubscriptBox["W", "1"]}], "/.", 
          RowBox[{"leadweak", "[", "1", "]"}]}], "/.", 
         RowBox[{"g", "\[Rule]", "1"}]}], "//.", 
        RowBox[{"shiftm\[Eta]", "[", "3", "]"}]}], "//.", 
       RowBox[{"shiftp\[Eta]b", "[", 
        RowBox[{"-", "3"}], "]"}]}], "/.", 
      RowBox[{"Taylorv0", "[", "0", "]"}]}], "//.", "densqrt3"}], ",", 
    "canlist"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.562916775111562*^9, 3.562916833054656*^9}, {
  3.562916872564835*^9, 3.562916880854116*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"-", "864"}], "+", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     RowBox[{"-", "432"}], "+", 
     RowBox[{"144", " ", "\[ImaginaryI]", " ", 
      SqrtBox["3"]}]}], ")"}], " ", 
   SubsuperscriptBox[
    StyleBox["\[Eta]0",
     FontWeight->Bold,
     FontColor->RGBColor[0, 0.5, 0]], "2", "+"]}], "+", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     RowBox[{
      RowBox[{"-", "144"}], " ", "\[ImaginaryI]"}], "+", 
     RowBox[{"144", " ", 
      SqrtBox["3"]}]}], ")"}], " ", 
   SubsuperscriptBox[
    StyleBox["\[Eta]0",
     FontWeight->Bold,
     FontColor->RGBColor[0, 0.5, 0]], "3", "+"]}], "+", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     RowBox[{"-", "168"}], "+", 
     RowBox[{"24", " ", "\[ImaginaryI]", " ", 
      SqrtBox["3"]}]}], ")"}], " ", 
   SubsuperscriptBox[
    StyleBox["\[Eta]0",
     FontWeight->Bold,
     FontColor->RGBColor[0, 0.5, 0]], "4", "+"]}], "+", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     RowBox[{"-", "432"}], "-", 
     RowBox[{"144", " ", "\[ImaginaryI]", " ", 
      SqrtBox["3"]}]}], ")"}], " ", 
   SubsuperscriptBox[
    OverscriptBox[
     StyleBox["\[Eta]0",
      FontWeight->Bold,
      FontColor->RGBColor[0, 0.5, 0]], 
     StyleBox["_",
      FontWeight->Bold,
      FontColor->RGBColor[0, 0.5, 0]]], "2", "-"]}], "-", 
  RowBox[{"32", " ", "\[ImaginaryI]", " ", 
   SqrtBox["3"], " ", 
   SubsuperscriptBox[
    StyleBox["\[Eta]0",
     FontWeight->Bold,
     FontColor->RGBColor[0, 0.5, 0]], "4", "+"], " ", 
   SubsuperscriptBox[
    OverscriptBox[
     StyleBox["\[Eta]0",
      FontWeight->Bold,
      FontColor->RGBColor[0, 0.5, 0]], 
     StyleBox["_",
      FontWeight->Bold,
      FontColor->RGBColor[0, 0.5, 0]]], "2", "-"]}], "+", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     RowBox[{"144", " ", "\[ImaginaryI]"}], "+", 
     RowBox[{"144", " ", 
      SqrtBox["3"]}]}], ")"}], " ", 
   SubsuperscriptBox[
    OverscriptBox[
     StyleBox["\[Eta]0",
      FontWeight->Bold,
      FontColor->RGBColor[0, 0.5, 0]], 
     StyleBox["_",
      FontWeight->Bold,
      FontColor->RGBColor[0, 0.5, 0]]], "3", "-"]}], "+", 
  RowBox[{"32", " ", "\[ImaginaryI]", " ", 
   SubsuperscriptBox[
    StyleBox["\[Eta]0",
     FontWeight->Bold,
     FontColor->RGBColor[0, 0.5, 0]], "4", "+"], " ", 
   SubsuperscriptBox[
    OverscriptBox[
     StyleBox["\[Eta]0",
      FontWeight->Bold,
      FontColor->RGBColor[0, 0.5, 0]], 
     StyleBox["_",
      FontWeight->Bold,
      FontColor->RGBColor[0, 0.5, 0]]], "3", "-"]}], "+", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     RowBox[{"-", "168"}], "-", 
     RowBox[{"24", " ", "\[ImaginaryI]", " ", 
      SqrtBox["3"]}]}], ")"}], " ", 
   SubsuperscriptBox[
    OverscriptBox[
     StyleBox["\[Eta]0",
      FontWeight->Bold,
      FontColor->RGBColor[0, 0.5, 0]], 
     StyleBox["_",
      FontWeight->Bold,
      FontColor->RGBColor[0, 0.5, 0]]], "4", "-"]}], "+", 
  RowBox[{"32", " ", "\[ImaginaryI]", " ", 
   SqrtBox["3"], " ", 
   SubsuperscriptBox[
    StyleBox["\[Eta]0",
     FontWeight->Bold,
     FontColor->RGBColor[0, 0.5, 0]], "2", "+"], " ", 
   SubsuperscriptBox[
    OverscriptBox[
     StyleBox["\[Eta]0",
      FontWeight->Bold,
      FontColor->RGBColor[0, 0.5, 0]], 
     StyleBox["_",
      FontWeight->Bold,
      FontColor->RGBColor[0, 0.5, 0]]], "4", "-"]}], "-", 
  RowBox[{"32", " ", "\[ImaginaryI]", " ", 
   SubsuperscriptBox[
    StyleBox["\[Eta]0",
     FontWeight->Bold,
     FontColor->RGBColor[0, 0.5, 0]], "3", "+"], " ", 
   SubsuperscriptBox[
    OverscriptBox[
     StyleBox["\[Eta]0",
      FontWeight->Bold,
      FontColor->RGBColor[0, 0.5, 0]], 
     StyleBox["_",
      FontWeight->Bold,
      FontColor->RGBColor[0, 0.5, 0]]], "4", "-"]}]}]], "Output",
 CellChangeTimes->{3.5629407044634457`*^9, 3.5629493228995657`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Mterm", "=", 
  RowBox[{
   FractionBox[
    RowBox[{"\[ImaginaryI]", " ", 
     SuperscriptBox["g", "8"]}], 
    RowBox[{"8", "u"}]], 
   RowBox[{"(", 
    RowBox[{"tmp1", "+", "tmp2"}], ")"}]}]}]], "Input",
 CellChangeTimes->{{3.562940682375598*^9, 3.562940694653873*^9}, 
   3.562940747252109*^9}],

Cell[BoxData[
 RowBox[{
  FractionBox["1", 
   RowBox[{"8", " ", "u"}]], 
  RowBox[{"\[ImaginaryI]", " ", 
   SuperscriptBox["g", "8"], " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"-", "1080"}], "-", 
     RowBox[{"432", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2"]}], "+", 
     FractionBox[
      RowBox[{"1152", " ", 
       SubsuperscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "2", "2"]}], "5"], "+", 
     FractionBox[
      RowBox[{"10496", " ", 
       SubsuperscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "2", "3"]}], "35"], "-", 
     RowBox[{"3312", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3"]}], "+", 
     RowBox[{"768", " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3", "2"]}], "+", 
     RowBox[{"960", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "5"]}], "+", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "432"}], "+", 
        RowBox[{"144", " ", "\[ImaginaryI]", " ", 
         SqrtBox["3"]}]}], ")"}], " ", 
      SubsuperscriptBox[
       StyleBox["\[Eta]0",
        FontWeight->Bold,
        FontColor->RGBColor[0, 0.5, 0]], "2", "+"]}], "+", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"432", "+", 
        RowBox[{"144", " ", "\[ImaginaryI]", " ", 
         SqrtBox["3"]}]}], ")"}], " ", 
      SubsuperscriptBox[
       StyleBox["\[Eta]0",
        FontWeight->Bold,
        FontColor->RGBColor[0, 0.5, 0]], "2", "+"]}], "+", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         RowBox[{"-", "144"}], " ", "\[ImaginaryI]"}], "-", 
        RowBox[{"144", " ", 
         SqrtBox["3"]}]}], ")"}], " ", 
      SubsuperscriptBox[
       StyleBox["\[Eta]0",
        FontWeight->Bold,
        FontColor->RGBColor[0, 0.5, 0]], "3", "+"]}], "+", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         RowBox[{"-", "144"}], " ", "\[ImaginaryI]"}], "+", 
        RowBox[{"144", " ", 
         SqrtBox["3"]}]}], ")"}], " ", 
      SubsuperscriptBox[
       StyleBox["\[Eta]0",
        FontWeight->Bold,
        FontColor->RGBColor[0, 0.5, 0]], "3", "+"]}], "+", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "168"}], "+", 
        RowBox[{"24", " ", "\[ImaginaryI]", " ", 
         SqrtBox["3"]}]}], ")"}], " ", 
      SubsuperscriptBox[
       StyleBox["\[Eta]0",
        FontWeight->Bold,
        FontColor->RGBColor[0, 0.5, 0]], "4", "+"]}], "+", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"168", "+", 
        RowBox[{"24", " ", "\[ImaginaryI]", " ", 
         SqrtBox["3"]}]}], ")"}], " ", 
      SubsuperscriptBox[
       StyleBox["\[Eta]0",
        FontWeight->Bold,
        FontColor->RGBColor[0, 0.5, 0]], "4", "+"]}], "+", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "432"}], "-", 
        RowBox[{"144", " ", "\[ImaginaryI]", " ", 
         SqrtBox["3"]}]}], ")"}], " ", 
      SubsuperscriptBox[
       OverscriptBox[
        StyleBox["\[Eta]0",
         FontWeight->Bold,
         FontColor->RGBColor[0, 0.5, 0]], 
        StyleBox["_",
         FontWeight->Bold,
         FontColor->RGBColor[0, 0.5, 0]]], "2", "-"]}], "+", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"432", "-", 
        RowBox[{"144", " ", "\[ImaginaryI]", " ", 
         SqrtBox["3"]}]}], ")"}], " ", 
      SubsuperscriptBox[
       OverscriptBox[
        StyleBox["\[Eta]0",
         FontWeight->Bold,
         FontColor->RGBColor[0, 0.5, 0]], 
        StyleBox["_",
         FontWeight->Bold,
         FontColor->RGBColor[0, 0.5, 0]]], "2", "-"]}], "+", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"144", " ", "\[ImaginaryI]"}], "-", 
        RowBox[{"144", " ", 
         SqrtBox["3"]}]}], ")"}], " ", 
      SubsuperscriptBox[
       OverscriptBox[
        StyleBox["\[Eta]0",
         FontWeight->Bold,
         FontColor->RGBColor[0, 0.5, 0]], 
        StyleBox["_",
         FontWeight->Bold,
         FontColor->RGBColor[0, 0.5, 0]]], "3", "-"]}], "+", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"144", " ", "\[ImaginaryI]"}], "+", 
        RowBox[{"144", " ", 
         SqrtBox["3"]}]}], ")"}], " ", 
      SubsuperscriptBox[
       OverscriptBox[
        StyleBox["\[Eta]0",
         FontWeight->Bold,
         FontColor->RGBColor[0, 0.5, 0]], 
        StyleBox["_",
         FontWeight->Bold,
         FontColor->RGBColor[0, 0.5, 0]]], "3", "-"]}], "+", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "168"}], "-", 
        RowBox[{"24", " ", "\[ImaginaryI]", " ", 
         SqrtBox["3"]}]}], ")"}], " ", 
      SubsuperscriptBox[
       OverscriptBox[
        StyleBox["\[Eta]0",
         FontWeight->Bold,
         FontColor->RGBColor[0, 0.5, 0]], 
        StyleBox["_",
         FontWeight->Bold,
         FontColor->RGBColor[0, 0.5, 0]]], "4", "-"]}], "+", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"168", "-", 
        RowBox[{"24", " ", "\[ImaginaryI]", " ", 
         SqrtBox["3"]}]}], ")"}], " ", 
      SubsuperscriptBox[
       OverscriptBox[
        StyleBox["\[Eta]0",
         FontWeight->Bold,
         FontColor->RGBColor[0, 0.5, 0]], 
        StyleBox["_",
         FontWeight->Bold,
         FontColor->RGBColor[0, 0.5, 0]]], "4", "-"]}]}], ")"}]}]}]], "Output",\

 CellChangeTimes->{3.562940747610023*^9, 3.562949323038834*^9}]
}, Open  ]],

Cell["Now computing W term", "Text",
 CellChangeTimes->{{3.562940770658086*^9, 3.562940773712278*^9}}],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"toint", "=", 
   RowBox[{
    RowBox[{
     RowBox[{"-", 
      FractionBox["1", 
       RowBox[{"2", "\[Pi]", " ", "\[ImaginaryI]"}]]}], 
     FractionBox["1", "2"], 
     RowBox[{"(", 
      RowBox[{
       FractionBox["1", 
        RowBox[{"v", "-", "u"}]], "+", 
       FractionBox["1", 
        RowBox[{"v", "+", "u"}]]}], ")"}], "W"}], "/.", 
    RowBox[{"leadweak", "[", "1", "]"}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"UpIntegrate", "[", 
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{"toint", "/.", 
         RowBox[{"v", "\[Rule]", 
          RowBox[{
           RowBox[{"Re", "[", "v", "]"}], "+", 
           FractionBox["\[ImaginaryI]", "4"]}]}]}], "/.", 
        RowBox[{"u", "\[Rule]", 
         RowBox[{"u", "-", 
          RowBox[{"\[ImaginaryI]", " ", "\[Epsilon]"}]}]}]}], "/.", 
       RowBox[{"Shift", "[", 
        RowBox[{
         RowBox[{"-", "2"}], "\[Epsilon]"}], "]"}]}], ",", "u"}], "]"}], "/.", 
    RowBox[{
     RowBox[{"Re", "[", "v", "]"}], "\[Rule]", 
     RowBox[{"u", "-", 
      FractionBox["\[ImaginaryI]", "4"]}]}]}], "//.", "EndSimplify"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"Wterm", "=", 
  RowBox[{"Collect", "[", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{"Collect", "[", 
        RowBox[{"%", ",", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"g", ",", "\[Eta]list"}], "}"}], "//", "Flatten"}], ",", 
         "Simplify"}], "]"}], "/.", "subtousu"}], "//", "funapartusu"}], "//",
      "funreduceusu"}], ",", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"g", ",", "canlist"}], "}"}], "//", "Flatten"}]}], 
   "]"}]}]}], "Input",
 CellChangeTimes->{{3.561471654765839*^9, 3.5614717885162687`*^9}, {
  3.56294079889857*^9, 3.562940820504223*^9}, {3.562940933064206*^9, 
  3.5629409361585493`*^9}}],

Cell[BoxData[
 RowBox[{
  SuperscriptBox["g", "8"], " ", 
  RowBox[{"(", 
   RowBox[{
    RowBox[{
     RowBox[{"(", 
      RowBox[{"324", "+", 
       RowBox[{"648", " ", "\[ImaginaryI]", " ", "u"}]}], ")"}], " ", 
     SubscriptBox[
      StyleBox["\[Zeta]",
       FontWeight->Bold,
       FontColor->GrayLevel[0.4]], "3"]}], "+", 
    FractionBox[
     RowBox[{
      RowBox[{
       RowBox[{"-", "54"}], " ", "\[ImaginaryI]", " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "2"]}], "+", 
      FractionBox[
       RowBox[{"144", " ", "\[ImaginaryI]", " ", 
        SubsuperscriptBox[
         StyleBox["\[Zeta]",
          FontWeight->Bold,
          FontColor->GrayLevel[0.4]], "2", "2"]}], "5"], "+", 
      FractionBox[
       RowBox[{"1312", " ", "\[ImaginaryI]", " ", 
        SubsuperscriptBox[
         StyleBox["\[Zeta]",
          FontWeight->Bold,
          FontColor->GrayLevel[0.4]], "2", "3"]}], "35"], "-", 
      RowBox[{"18", " ", "\[ImaginaryI]", " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "3"]}], "+", 
      RowBox[{"96", " ", "\[ImaginaryI]", " ", 
       SubsuperscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "3", "2"]}]}], 
     StyleBox["\[ScriptU]",
      FontColor->RGBColor[0, 0, 0.4]]], "+", 
    FractionBox[
     RowBox[{
      RowBox[{"-", "27"}], "+", 
      RowBox[{"36", " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "3"]}], "+", 
      RowBox[{"120", " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "5"]}]}], 
     SuperscriptBox[
      StyleBox["\[ScriptU]",
       FontColor->RGBColor[0, 0, 0.4]], "2"]], "+", 
    RowBox[{
     SubsuperscriptBox[
      StyleBox["\[Eta]",
       FontWeight->Bold,
       FontColor->RGBColor[0.8, 0, 0]], "3", 
      RowBox[{"[", "2", "]"}]], " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"54", " ", "\[ImaginaryI]"}], "-", 
       RowBox[{"108", " ", "u"}], "+", 
       FractionBox[
        RowBox[{"18", " ", "\[ImaginaryI]"}], 
        SuperscriptBox[
         StyleBox["\[ScriptU]",
          FontColor->RGBColor[0, 0, 0.4]], "2"]], "+", 
       FractionBox[
        RowBox[{
         RowBox[{"-", "18"}], "-", 
         RowBox[{"48", " ", 
          SubscriptBox[
           StyleBox["\[Zeta]",
            FontWeight->Bold,
            FontColor->GrayLevel[0.4]], "3"]}]}], 
        StyleBox["\[ScriptU]",
         FontColor->RGBColor[0, 0, 0.4]]], "-", 
       RowBox[{"144", " ", "u", " ", 
        SubscriptBox[
         StyleBox["\[Zeta]",
          FontWeight->Bold,
          FontColor->GrayLevel[0.4]], "3"]}], "-", 
       RowBox[{"12", " ", "\[ImaginaryI]", " ", 
        SubsuperscriptBox[
         StyleBox["\[Eta]",
          FontWeight->Bold,
          FontColor->RGBColor[0.8, 0, 0]], "4", 
         RowBox[{"[", "2", "]"}]]}]}], ")"}]}], "+", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{"36", "-", 
       FractionBox[
        RowBox[{"18", " ", "\[ImaginaryI]"}], 
        StyleBox["\[ScriptU]",
         FontColor->RGBColor[0, 0, 0.4]]], "-", 
       RowBox[{"24", " ", 
        SubscriptBox[
         StyleBox["\[Zeta]",
          FontWeight->Bold,
          FontColor->GrayLevel[0.4]], "3"]}]}], ")"}], " ", 
     SubsuperscriptBox[
      StyleBox["\[Eta]",
       FontWeight->Bold,
       FontColor->RGBColor[0.8, 0, 0]], "4", 
      RowBox[{"[", "2", "]"}]]}], "+", 
    RowBox[{
     SubsuperscriptBox[
      StyleBox["\[Eta]",
       FontWeight->Bold,
       FontColor->RGBColor[0.8, 0, 0]], "2", 
      RowBox[{"[", "2", "]"}]], " ", 
     RowBox[{"(", 
      RowBox[{"54", "-", 
       FractionBox[
        RowBox[{"54", " ", "\[ImaginaryI]"}], 
        StyleBox["\[ScriptU]",
         FontColor->RGBColor[0, 0, 0.4]]], "+", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{"216", "+", 
          RowBox[{"648", " ", 
           SuperscriptBox["u", "2"]}]}], ")"}], " ", 
        SubscriptBox[
         StyleBox["\[Zeta]",
          FontWeight->Bold,
          FontColor->GrayLevel[0.4]], "3"]}], "+", 
       FractionBox[
        RowBox[{
         RowBox[{"-", "18"}], "+", 
         RowBox[{"72", " ", 
          SubscriptBox[
           StyleBox["\[Zeta]",
            FontWeight->Bold,
            FontColor->GrayLevel[0.4]], "3"]}]}], 
        SuperscriptBox[
         StyleBox["\[ScriptU]",
          FontColor->RGBColor[0, 0, 0.4]], "2"]], "+", 
       RowBox[{"240", " ", 
        SubscriptBox[
         StyleBox["\[Zeta]",
          FontWeight->Bold,
          FontColor->GrayLevel[0.4]], "5"]}], "+", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          RowBox[{
           RowBox[{"-", "36"}], " ", "\[ImaginaryI]"}], "-", 
          RowBox[{"108", " ", "\[ImaginaryI]", " ", 
           SuperscriptBox["u", "2"]}], "-", 
          FractionBox[
           RowBox[{"12", " ", "\[ImaginaryI]"}], 
           SuperscriptBox[
            StyleBox["\[ScriptU]",
             FontColor->RGBColor[0, 0, 0.4]], "2"]]}], ")"}], " ", 
        SubsuperscriptBox[
         StyleBox["\[Eta]",
          FontWeight->Bold,
          FontColor->RGBColor[0.8, 0, 0]], "3", 
         RowBox[{"[", "2", "]"}]]}], "+", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          RowBox[{"36", " ", "\[ImaginaryI]", " ", "u"}], "+", 
          FractionBox[
           RowBox[{"12", " ", "\[ImaginaryI]"}], 
           StyleBox["\[ScriptU]",
            FontColor->RGBColor[0, 0, 0.4]]]}], ")"}], " ", 
        SubsuperscriptBox[
         StyleBox["\[Eta]",
          FontWeight->Bold,
          FontColor->RGBColor[0.8, 0, 0]], "4", 
         RowBox[{"[", "2", "]"}]]}]}], ")"}]}], "+", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{"36", " ", "\[ImaginaryI]"}], "+", 
       RowBox[{"108", " ", "\[ImaginaryI]", " ", 
        SuperscriptBox["u", "2"]}], "+", 
       FractionBox[
        RowBox[{"12", " ", "\[ImaginaryI]"}], 
        SuperscriptBox[
         StyleBox["\[ScriptU]",
          FontColor->RGBColor[0, 0, 0.4]], "2"]]}], ")"}], " ", 
     SubsuperscriptBox[
      StyleBox["\[Eta]",
       FontWeight->Bold,
       FontColor->RGBColor[0.8, 0, 0]], "5", 
      RowBox[{"[", "2", "]"}]]}], "+", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{
        RowBox[{"-", "36"}], " ", "\[ImaginaryI]", " ", "u"}], "-", 
       FractionBox[
        RowBox[{"12", " ", "\[ImaginaryI]"}], 
        StyleBox["\[ScriptU]",
         FontColor->RGBColor[0, 0, 0.4]]]}], ")"}], " ", 
     SubsuperscriptBox[
      StyleBox["\[Eta]",
       FontWeight->Bold,
       FontColor->RGBColor[0.8, 0, 0]], "6", 
      RowBox[{"[", "2", "]"}]]}], "+", 
    RowBox[{"12", " ", "\[ImaginaryI]", " ", 
     SubsuperscriptBox[
      StyleBox["\[Eta]",
       FontWeight->Bold,
       FontColor->RGBColor[0.8, 0, 0]], "7", 
      RowBox[{"[", "2", "]"}]]}], "+", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{"72", " ", "\[ImaginaryI]"}], "+", 
       RowBox[{"216", " ", "\[ImaginaryI]", " ", 
        SuperscriptBox["u", "2"]}], "+", 
       FractionBox[
        RowBox[{"24", " ", "\[ImaginaryI]"}], 
        SuperscriptBox[
         StyleBox["\[ScriptU]",
          FontColor->RGBColor[0, 0, 0.4]], "2"]]}], ")"}], " ", 
     SubsuperscriptBox[
      StyleBox["\[Eta]",
       FontWeight->Bold,
       FontColor->RGBColor[0.8, 0, 0]], 
      RowBox[{"2", ",", "3"}], 
      RowBox[{"[", "2", "]"}]]}], "+", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{
        RowBox[{"-", "72"}], " ", "\[ImaginaryI]", " ", "u"}], "-", 
       FractionBox[
        RowBox[{"24", " ", "\[ImaginaryI]"}], 
        StyleBox["\[ScriptU]",
         FontColor->RGBColor[0, 0, 0.4]]]}], ")"}], " ", 
     SubsuperscriptBox[
      StyleBox["\[Eta]",
       FontWeight->Bold,
       FontColor->RGBColor[0.8, 0, 0]], 
      RowBox[{"2", ",", "4"}], 
      RowBox[{"[", "2", "]"}]]}], "+", 
    RowBox[{"24", " ", "\[ImaginaryI]", " ", 
     SubsuperscriptBox[
      StyleBox["\[Eta]",
       FontWeight->Bold,
       FontColor->RGBColor[0.8, 0, 0]], 
      RowBox[{"3", ",", "4"}], 
      RowBox[{"[", "2", "]"}]]}]}], ")"}]}]], "Output",
 CellChangeTimes->{{3.561471686835413*^9, 3.561471697775235*^9}, 
   3.561471748657173*^9, 3.56147179786961*^9, 3.562264740620071*^9, 
   3.562940835801983*^9, 3.56294094744308*^9, 3.562949334463331*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"q2fiveloop", "=", 
  RowBox[{"Collect", "[", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          RowBox[{
           RowBox[{
            RowBox[{
             RowBox[{"Normal", "@", 
              RowBox[{"Series", "[", 
               RowBox[{
                RowBox[{
                 RowBox[{
                  RowBox[{
                   RowBox[{
                    SubscriptBox["q", "2"], "/.", "largevolume"}], "/.", 
                   RowBox[{"x$", "\[Rule]", "x$h"}]}], "/.", "subJuk"}], "/.", 
                 RowBox[{"leadweak", "[", "5", "]"}]}], ",", 
                RowBox[{"{", 
                 RowBox[{"g", ",", "0", ",", "8"}], "}"}]}], "]"}]}], "/.", 
             "subIm"}], "/.", "subtousu"}], "//", "funapartusu"}], "//", 
          "funreduceusu"}], ")"}], "+", 
        RowBox[{"(", "Mterm", ")"}], "-", "Wterm"}], "/.", "subtousu"}], "//",
       "Expand"}], "//", "FuntoMHZbasis"}], ",", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"g", ",", "canlist"}], "}"}], "//", "Flatten"}]}], 
   "]"}]}]], "Input",
 CellChangeTimes->{{3.561471811839065*^9, 3.561471820832855*^9}, {
  3.561471885932499*^9, 3.5614719590862083`*^9}, {3.561472022362212*^9, 
  3.561472042567685*^9}, {3.561472175989295*^9, 3.5614721957934313`*^9}, {
  3.562941016190948*^9, 3.5629410886891317`*^9}, {3.562941161143037*^9, 
  3.5629411648701563`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"-", "\[ImaginaryI]"}], " ", "u"}], "+", 
  RowBox[{
   SuperscriptBox["g", "2"], " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"-", 
      FractionBox["\[ImaginaryI]", 
       RowBox[{"3", " ", 
        SuperscriptBox[
         StyleBox["\[ScriptU]",
          FontColor->RGBColor[0, 0, 0.4]], "3"]}]]}], "-", 
     FractionBox[
      RowBox[{"4", " ", "\[ImaginaryI]"}], 
      RowBox[{"3", " ", 
       StyleBox["\[ScriptU]",
        FontColor->RGBColor[0, 0, 0.4]]}]]}], ")"}]}], "+", 
  RowBox[{
   SuperscriptBox["g", "4"], " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"-", 
      FractionBox[
       RowBox[{"2", " ", "\[ImaginaryI]"}], 
       RowBox[{"3", " ", 
        SuperscriptBox[
         StyleBox["\[ScriptU]",
          FontColor->RGBColor[0, 0, 0.4]], "5"]}]]}], "-", 
     FractionBox[
      RowBox[{"4", " ", "\[ImaginaryI]"}], 
      RowBox[{"3", " ", 
       SuperscriptBox[
        StyleBox["\[ScriptU]",
         FontColor->RGBColor[0, 0, 0.4]], "3"]}]], "+", 
     FractionBox[
      RowBox[{"4", " ", "\[ImaginaryI]"}], 
      StyleBox["\[ScriptU]",
       FontColor->RGBColor[0, 0, 0.4]]]}], ")"}]}], "-", 
  FractionBox["\[ImaginaryI]", 
   RowBox[{"3", " ", 
    StyleBox["\[ScriptU]",
     FontColor->RGBColor[0, 0, 0.4]]}]], "+", 
  RowBox[{
   SuperscriptBox["g", "6"], " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"-", 
      FractionBox[
       RowBox[{"5", " ", "\[ImaginaryI]"}], 
       RowBox[{"3", " ", 
        SuperscriptBox[
         StyleBox["\[ScriptU]",
          FontColor->RGBColor[0, 0, 0.4]], "7"]}]]}], "-", 
     FractionBox[
      RowBox[{"8", " ", "\[ImaginaryI]"}], 
      RowBox[{"3", " ", 
       SuperscriptBox[
        StyleBox["\[ScriptU]",
         FontColor->RGBColor[0, 0, 0.4]], "5"]}]], "+", 
     FractionBox[
      RowBox[{"4", " ", "\[ImaginaryI]"}], 
      SuperscriptBox[
       StyleBox["\[ScriptU]",
        FontColor->RGBColor[0, 0, 0.4]], "3"]], "+", 
     FractionBox[
      RowBox[{
       RowBox[{
        RowBox[{"-", "25"}], " ", "\[ImaginaryI]"}], "-", 
       RowBox[{"8", " ", "\[ImaginaryI]", " ", 
        SubscriptBox[
         StyleBox["\[Zeta]",
          FontWeight->Bold,
          FontColor->GrayLevel[0.4]], "3"]}]}], 
      StyleBox["\[ScriptU]",
       FontColor->RGBColor[0, 0, 0.4]]]}], ")"}]}], "+", 
  RowBox[{
   SuperscriptBox["g", "8"], " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"-", 
      FractionBox[
       RowBox[{"14", " ", "\[ImaginaryI]"}], 
       RowBox[{"3", " ", 
        SuperscriptBox[
         StyleBox["\[ScriptU]",
          FontColor->RGBColor[0, 0, 0.4]], "9"]}]]}], "-", 
     FractionBox[
      RowBox[{"20", " ", "\[ImaginaryI]"}], 
      RowBox[{"3", " ", 
       SuperscriptBox[
        StyleBox["\[ScriptU]",
         FontColor->RGBColor[0, 0, 0.4]], "7"]}]], "+", 
     FractionBox[
      RowBox[{"8", " ", "\[ImaginaryI]"}], 
      SuperscriptBox[
       StyleBox["\[ScriptU]",
        FontColor->RGBColor[0, 0, 0.4]], "5"]], "+", 
     FractionBox[
      RowBox[{
       RowBox[{
        RowBox[{"-", "25"}], " ", "\[ImaginaryI]"}], "-", 
       RowBox[{"8", " ", "\[ImaginaryI]", " ", 
        SubscriptBox[
         StyleBox["\[Zeta]",
          FontWeight->Bold,
          FontColor->GrayLevel[0.4]], "3"]}]}], 
      SuperscriptBox[
       StyleBox["\[ScriptU]",
        FontColor->RGBColor[0, 0, 0.4]], "3"]], "+", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "324"}], "-", 
        RowBox[{"648", " ", "\[ImaginaryI]", " ", "u"}]}], ")"}], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3"]}], "+", 
     FractionBox[
      RowBox[{"27", "-", 
       RowBox[{"36", " ", 
        SubscriptBox[
         StyleBox["\[Zeta]",
          FontWeight->Bold,
          FontColor->GrayLevel[0.4]], "3"]}], "-", 
       RowBox[{"120", " ", 
        SubscriptBox[
         StyleBox["\[Zeta]",
          FontWeight->Bold,
          FontColor->GrayLevel[0.4]], "5"]}]}], 
      SuperscriptBox[
       StyleBox["\[ScriptU]",
        FontColor->RGBColor[0, 0, 0.4]], "2"]], "+", 
     FractionBox[
      RowBox[{
       RowBox[{"121", " ", "\[ImaginaryI]"}], "-", 
       RowBox[{"268", " ", "\[ImaginaryI]", " ", 
        SubscriptBox[
         StyleBox["\[Zeta]",
          FontWeight->Bold,
          FontColor->GrayLevel[0.4]], "3"]}], "+", 
       RowBox[{"280", " ", "\[ImaginaryI]", " ", 
        SubscriptBox[
         StyleBox["\[Zeta]",
          FontWeight->Bold,
          FontColor->GrayLevel[0.4]], "5"]}]}], 
      StyleBox["\[ScriptU]",
       FontColor->RGBColor[0, 0, 0.4]]], "+", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "54"}], "+", 
        FractionBox[
         RowBox[{"54", " ", "\[ImaginaryI]"}], 
         StyleBox["\[ScriptU]",
          FontColor->RGBColor[0, 0, 0.4]]], "+", 
        FractionBox[
         RowBox[{"18", "-", 
          RowBox[{"72", " ", 
           SubscriptBox[
            StyleBox["\[Zeta]",
             FontWeight->Bold,
             FontColor->GrayLevel[0.4]], "3"]}]}], 
         SuperscriptBox[
          StyleBox["\[ScriptU]",
           FontColor->RGBColor[0, 0, 0.4]], "2"]], "+", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           RowBox[{"-", "216"}], "-", 
           RowBox[{"648", " ", 
            SuperscriptBox["u", "2"]}]}], ")"}], " ", 
         SubscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "3"]}], "-", 
        RowBox[{"240", " ", 
         SubscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "5"]}]}], ")"}], " ", 
      SubsuperscriptBox[
       StyleBox["\[Eta]",
        FontWeight->Bold,
        FontColor->RGBColor[0.8, 0, 0]], "2", 
       RowBox[{"[", "2", "]"}]]}], "+", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         RowBox[{"-", "54"}], " ", "\[ImaginaryI]"}], "+", 
        RowBox[{"108", " ", "u"}], "-", 
        FractionBox[
         RowBox[{"18", " ", "\[ImaginaryI]"}], 
         SuperscriptBox[
          StyleBox["\[ScriptU]",
           FontColor->RGBColor[0, 0, 0.4]], "2"]], "+", 
        RowBox[{"144", " ", "u", " ", 
         SubscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "3"]}], "+", 
        FractionBox[
         RowBox[{"18", "+", 
          RowBox[{"48", " ", 
           SubscriptBox[
            StyleBox["\[Zeta]",
             FontWeight->Bold,
             FontColor->GrayLevel[0.4]], "3"]}]}], 
         StyleBox["\[ScriptU]",
          FontColor->RGBColor[0, 0, 0.4]]]}], ")"}], " ", 
      SubsuperscriptBox[
       StyleBox["\[Eta]",
        FontWeight->Bold,
        FontColor->RGBColor[0.8, 0, 0]], "3", 
       RowBox[{"[", "2", "]"}]]}], "+", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "36"}], "+", 
        FractionBox[
         RowBox[{"18", " ", "\[ImaginaryI]"}], 
         StyleBox["\[ScriptU]",
          FontColor->RGBColor[0, 0, 0.4]]], "+", 
        RowBox[{"24", " ", 
         SubscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "3"]}]}], ")"}], " ", 
      SubsuperscriptBox[
       StyleBox["\[Eta]",
        FontWeight->Bold,
        FontColor->RGBColor[0.8, 0, 0]], "4", 
       RowBox[{"[", "2", "]"}]]}], "+", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         RowBox[{"-", "36"}], " ", "\[ImaginaryI]"}], "-", 
        RowBox[{"108", " ", "\[ImaginaryI]", " ", 
         SuperscriptBox["u", "2"]}], "-", 
        FractionBox[
         RowBox[{"12", " ", "\[ImaginaryI]"}], 
         SuperscriptBox[
          StyleBox["\[ScriptU]",
           FontColor->RGBColor[0, 0, 0.4]], "2"]]}], ")"}], " ", 
      SubsuperscriptBox[
       StyleBox["\[Eta]",
        FontWeight->Bold,
        FontColor->RGBColor[0.8, 0, 0]], 
       RowBox[{"2", ",", "3"}], 
       RowBox[{"[", "2", "]"}]]}], "+", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"36", " ", "\[ImaginaryI]", " ", "u"}], "+", 
        FractionBox[
         RowBox[{"12", " ", "\[ImaginaryI]"}], 
         StyleBox["\[ScriptU]",
          FontColor->RGBColor[0, 0, 0.4]]]}], ")"}], " ", 
      SubsuperscriptBox[
       StyleBox["\[Eta]",
        FontWeight->Bold,
        FontColor->RGBColor[0.8, 0, 0]], 
       RowBox[{"2", ",", "4"}], 
       RowBox[{"[", "2", "]"}]]}], "+", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"36", " ", "\[ImaginaryI]"}], "+", 
        RowBox[{"108", " ", "\[ImaginaryI]", " ", 
         SuperscriptBox["u", "2"]}], "+", 
        FractionBox[
         RowBox[{"12", " ", "\[ImaginaryI]"}], 
         SuperscriptBox[
          StyleBox["\[ScriptU]",
           FontColor->RGBColor[0, 0, 0.4]], "2"]]}], ")"}], " ", 
      SubsuperscriptBox[
       StyleBox["\[Eta]",
        FontWeight->Bold,
        FontColor->RGBColor[0.8, 0, 0]], 
       RowBox[{"3", ",", "2"}], 
       RowBox[{"[", "2", "]"}]]}], "-", 
     RowBox[{"12", " ", "\[ImaginaryI]", " ", 
      SubsuperscriptBox[
       StyleBox["\[Eta]",
        FontWeight->Bold,
        FontColor->RGBColor[0.8, 0, 0]], 
       RowBox[{"3", ",", "4"}], 
       RowBox[{"[", "2", "]"}]]}], "+", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         RowBox[{"-", "36"}], " ", "\[ImaginaryI]", " ", "u"}], "-", 
        FractionBox[
         RowBox[{"12", " ", "\[ImaginaryI]"}], 
         StyleBox["\[ScriptU]",
          FontColor->RGBColor[0, 0, 0.4]]]}], ")"}], " ", 
      SubsuperscriptBox[
       StyleBox["\[Eta]",
        FontWeight->Bold,
        FontColor->RGBColor[0.8, 0, 0]], 
       RowBox[{"4", ",", "2"}], 
       RowBox[{"[", "2", "]"}]]}], "+", 
     RowBox[{"12", " ", "\[ImaginaryI]", " ", 
      SubsuperscriptBox[
       StyleBox["\[Eta]",
        FontWeight->Bold,
        FontColor->RGBColor[0.8, 0, 0]], 
       RowBox[{"4", ",", "3"}], 
       RowBox[{"[", "2", "]"}]]}]}], ")"}]}]}]], "Output",
 CellChangeTimes->{
  3.561471928870626*^9, 3.5614719599594517`*^9, {3.561472020684655*^9, 
   3.561472043011312*^9}, {3.561472183205531*^9, 3.561472196115549*^9}, 
   3.562264792064046*^9, {3.562941039760013*^9, 3.5629410894008303`*^9}, {
   3.562941150291224*^9, 3.56294116540104*^9}, 3.56294940063573*^9}]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell["Double scaling", "Subsubsection",
 CellChangeTimes->{{3.562941200704056*^9, 3.562941225231617*^9}}],

Cell["Here we have", "Text",
 CellChangeTimes->{{3.562953694402523*^9, 3.562953696192565*^9}}],

Cell[BoxData[
 RowBox[{
  SubscriptBox["\[Delta]q", "2"], "=", 
  RowBox[{
   RowBox[{
    FractionBox["1", "2"], 
    RowBox[{"(", 
     RowBox[{
      SubscriptBox["\[Delta]\[Rho]", "2"], "-", "W"}], ")"}]}], "+", 
   RowBox[{"\[ScriptCapitalC]", 
    SubscriptBox["*", "pv"], 
    RowBox[{"(", 
     RowBox[{
      SubscriptBox["\[Delta]\[Rho]", "2"], "-", "W"}], ")"}]}]}]}]], "Input",
 CellChangeTimes->{{3.5629536973723297`*^9, 3.562953710859193*^9}, {
  3.5629554450775146`*^9, 3.562955455864471*^9}}],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"Series", "[", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          RowBox[{
           RowBox[{
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{
                RowBox[{"Series", "[", 
                 RowBox[{
                  RowBox[{"(", 
                   RowBox[{"w", " ", 
                    SuperscriptBox["g", "7"], 
                    RowBox[{"(", 
                    RowBox[{
                    SubscriptBox["\[Delta]\[Rho]2", "lead"], "+", 
                    RowBox[{
                    SuperscriptBox["g", "2"], 
                    SubscriptBox["\[Delta]\[Rho]2", "sublead"]}]}], ")"}]}], 
                   ")"}], ",", 
                  RowBox[{"{", 
                   RowBox[{"g", ",", "0", ",", "9"}], "}"}]}], "]"}], "//", 
                "Normal"}], "//", "Expand"}], ")"}], "/.", 
             RowBox[{
              SuperscriptBox["w", 
               RowBox[{"a_", "/;", 
                RowBox[{"EvenQ", "[", "a", "]"}]}]], "\[Rule]", "0"}]}], "/.", 
            RowBox[{
             RowBox[{
              SuperscriptBox["w", "a_."], 
              SubscriptBox["\[Delta]\[Rho]2", "b_"]}], "\[RuleDelayed]", 
             RowBox[{"PV", "[", 
              RowBox[{
               SuperscriptBox["w", 
                RowBox[{"a", "-", "1"}]], 
               SubscriptBox["\[Delta]\[Rho]2", "b"]}], "]"}]}]}], "/.", 
           "sub\[Rho]Ansatz"}], "/.", 
          RowBox[{"(", 
           RowBox[{"Rule", "@@@", 
            RowBox[{"Cases", "[", 
             RowBox[{
              RowBox[{"solut\[Rho]s", "/.", 
               RowBox[{"Rule", "\[Rule]", "List"}]}], ",", 
              RowBox[{"List", "[", 
               RowBox[{"a_", ",", "0"}], "]"}]}], "]"}]}], ")"}]}], "//", 
         "Expand"}], ")"}], "+", 
       RowBox[{
        FractionBox["1", "2"], 
        SuperscriptBox["g", "7"], 
        RowBox[{"(", 
         RowBox[{
          SubscriptBox["\[Delta]\[Rho]2", "lead"], "+", 
          RowBox[{
           SuperscriptBox["g", "2"], 
           SubscriptBox["\[Delta]\[Rho]2", "sublead"]}]}], ")"}]}]}], "/.", 
      "sub\[Rho]Ansatz"}], "/.", 
     RowBox[{"(", 
      RowBox[{"Rule", "@@@", 
       RowBox[{"Cases", "[", 
        RowBox[{
         RowBox[{"solut\[Rho]s", "/.", 
          RowBox[{"Rule", "\[Rule]", "List"}]}], ",", 
         RowBox[{"List", "[", 
          RowBox[{"a_", ",", "0"}], "]"}]}], "]"}]}], ")"}]}], ",", 
    RowBox[{"{", 
     RowBox[{"g", ",", "0", ",", "9"}], "}"}]}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"tmp", "=", 
   RowBox[{"Collect", "[", 
    RowBox[{"%", ",", "zlist"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"iii", "=", "1"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"tmp2", "=", 
  RowBox[{"Collect", "[", 
   RowBox[{"%%", ",", "zlist", ",", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{
        RowBox[{"coef", "[", 
         RowBox[{"iii", "++"}], "]"}], "=", "#"}], ";", 
       RowBox[{"mcoef", "[", 
        RowBox[{"iii", "-", "1"}], "]"}]}], ")"}], "&"}]}], "]"}]}]}], "Input",\

 CellChangeTimes->{{3.5629418019645157`*^9, 3.562941810424646*^9}, {
  3.562941888878191*^9, 3.5629419963015213`*^9}, {3.562955483160632*^9, 
  3.562955486617279*^9}, {3.5629557038371468`*^9, 3.5629558564251223`*^9}, {
  3.562955887086885*^9, 3.562955908837655*^9}, {3.56295601237768*^9, 
  3.56295609138792*^9}, {3.56330097726659*^9, 3.5633009853015223`*^9}, {
  3.5633010250798397`*^9, 3.563301072114511*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   SuperscriptBox["g", "9"], " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{
      SqrtBox[
       RowBox[{"1", "-", 
        SuperscriptBox["z", "2"]}]], " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         SuperscriptBox["z", "4"], " ", 
         RowBox[{"mcoef", "[", "1", "]"}]}], "+", 
        RowBox[{
         SuperscriptBox["z", "2"], " ", 
         RowBox[{"mcoef", "[", "2", "]"}]}], "+", 
        RowBox[{"mcoef", "[", "3", "]"}]}], ")"}]}], "+", 
     RowBox[{
      SuperscriptBox["z", "5"], " ", 
      RowBox[{"mcoef", "[", "4", "]"}]}], "+", 
     RowBox[{
      SuperscriptBox["z", "3"], " ", 
      RowBox[{"mcoef", "[", "5", "]"}]}], "+", 
     RowBox[{"z", " ", 
      RowBox[{"mcoef", "[", "6", "]"}]}]}], ")"}]}], "+", 
  RowBox[{
   SuperscriptBox["g", "7"], " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{
      SqrtBox[
       RowBox[{"1", "-", 
        SuperscriptBox["z", "2"]}]], " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         SuperscriptBox["z", "2"], " ", 
         RowBox[{"mcoef", "[", "7", "]"}]}], "+", 
        RowBox[{"mcoef", "[", "8", "]"}]}], ")"}]}], "+", 
     RowBox[{
      SuperscriptBox["z", "3"], " ", 
      RowBox[{"mcoef", "[", "9", "]"}]}], "+", 
     RowBox[{"z", " ", 
      RowBox[{"mcoef", "[", "10", "]"}]}]}], ")"}]}]}]], "Output",
 CellChangeTimes->{{3.56295588493375*^9, 3.5629559095035*^9}, {
   3.562956058398355*^9, 3.562956091877756*^9}, 3.562997705087722*^9, {
   3.563300997319721*^9, 3.5633010725373087`*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"coefs", "=", 
  RowBox[{"Monitor", "[", 
   RowBox[{
    RowBox[{"Table", "[", 
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{"coef", "[", "i", "]"}], "/.", "solut\[Rho]s"}], "//", 
       "CCompute"}], ",", 
      RowBox[{"{", 
       RowBox[{"i", ",", "4"}], "}"}]}], "]"}], ",", "i"}], "]"}]}]], "Input",\

 CellChangeTimes->{{3.56295610605731*^9, 3.562956154000927*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"216", "-", 
    RowBox[{"216", " ", 
     SubscriptBox[
      StyleBox["\[Zeta]",
       FontWeight->Bold,
       FontColor->GrayLevel[0.4]], "2"]}], "+", 
    FractionBox[
     RowBox[{"432", " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2", "2"]}], "5"], "+", 
    FractionBox[
     RowBox[{"3936", " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2", "3"]}], "35"], "+", 
    RowBox[{"72", " ", 
     SubscriptBox[
      StyleBox["\[Zeta]",
       FontWeight->Bold,
       FontColor->GrayLevel[0.4]], "3"]}], "+", 
    RowBox[{"288", " ", 
     SubsuperscriptBox[
      StyleBox["\[Zeta]",
       FontWeight->Bold,
       FontColor->GrayLevel[0.4]], "3", "2"]}], "-", 
    RowBox[{"768", " ", 
     SubscriptBox[
      StyleBox["\[Zeta]",
       FontWeight->Bold,
       FontColor->GrayLevel[0.4]], "5"]}], "-", 
    RowBox[{"336", " ", 
     SubscriptBox[
      StyleBox["\[Zeta]",
       FontWeight->Bold,
       FontColor->GrayLevel[0.4]], "7"]}]}], ",", 
   RowBox[{
    RowBox[{"-", "189"}], "+", 
    RowBox[{"216", " ", "\[ImaginaryI]", " ", 
     SqrtBox["3"], " ", 
     SubscriptBox[
      StyleBox["\[Zeta]",
       FontWeight->Bold,
       FontColor->GrayLevel[0.4]], "2"]}], "+", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       FractionBox["36", "5"], "-", 
       RowBox[{"72", " ", "\[ImaginaryI]", " ", 
        SqrtBox["3"]}]}], ")"}], " ", 
     SubsuperscriptBox[
      StyleBox["\[Zeta]",
       FontWeight->Bold,
       FontColor->GrayLevel[0.4]], "2", "2"]}], "+", 
    FractionBox[
     RowBox[{"328", " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2", "3"]}], "35"], "-", 
    RowBox[{"432", " ", 
     SubscriptBox[
      StyleBox["\[Zeta]",
       FontWeight->Bold,
       FontColor->GrayLevel[0.4]], "3"]}], "+", 
    RowBox[{"24", " ", 
     SubsuperscriptBox[
      StyleBox["\[Zeta]",
       FontWeight->Bold,
       FontColor->GrayLevel[0.4]], "3", "2"]}], "+", 
    RowBox[{"312", " ", 
     SubscriptBox[
      StyleBox["\[Zeta]",
       FontWeight->Bold,
       FontColor->GrayLevel[0.4]], "5"]}], "+", 
    RowBox[{"84", " ", 
     SubscriptBox[
      StyleBox["\[Zeta]",
       FontWeight->Bold,
       FontColor->GrayLevel[0.4]], "7"]}], "-", 
    RowBox[{"216", " ", "\[ImaginaryI]", " ", 
     SubscriptBox[
      StyleBox["\[Zeta]",
       FontWeight->Bold,
       FontColor->GrayLevel[0.4]], "2"], " ", 
     SubsuperscriptBox[
      StyleBox["\[Eta]0",
       FontWeight->Bold,
       FontColor->RGBColor[0, 0.5, 0]], "1", "+"]}], "-", 
    RowBox[{"36", " ", "\[ImaginaryI]", " ", 
     SqrtBox["3"], " ", 
     SuperscriptBox[
      RowBox[{"(", 
       SubsuperscriptBox[
        StyleBox["\[Eta]0",
         FontWeight->Bold,
         FontColor->RGBColor[0, 0.5, 0]], "1", "+"], ")"}], "2"]}], "+", 
    RowBox[{"48", " ", "\[ImaginaryI]", " ", 
     SqrtBox["3"], " ", 
     SubscriptBox[
      StyleBox["\[Zeta]",
       FontWeight->Bold,
       FontColor->GrayLevel[0.4]], "2"], " ", 
     SuperscriptBox[
      RowBox[{"(", 
       SubsuperscriptBox[
        StyleBox["\[Eta]0",
         FontWeight->Bold,
         FontColor->RGBColor[0, 0.5, 0]], "1", "+"], ")"}], "2"]}], "+", 
    RowBox[{"36", " ", "\[ImaginaryI]", " ", 
     SuperscriptBox[
      RowBox[{"(", 
       SubsuperscriptBox[
        StyleBox["\[Eta]0",
         FontWeight->Bold,
         FontColor->RGBColor[0, 0.5, 0]], "1", "+"], ")"}], "3"]}], "-", 
    RowBox[{"6", " ", "\[ImaginaryI]", " ", 
     SqrtBox["3"], " ", 
     SuperscriptBox[
      RowBox[{"(", 
       SubsuperscriptBox[
        StyleBox["\[Eta]0",
         FontWeight->Bold,
         FontColor->RGBColor[0, 0.5, 0]], "1", "+"], ")"}], "4"]}], "+", 
    RowBox[{"72", " ", "\[ImaginaryI]", " ", 
     SqrtBox["3"], " ", 
     SubsuperscriptBox[
      StyleBox["\[Eta]0",
       FontWeight->Bold,
       FontColor->RGBColor[0, 0.5, 0]], "2", "+"]}], "-", 
    RowBox[{"72", " ", "\[ImaginaryI]", " ", 
     SubsuperscriptBox[
      StyleBox["\[Eta]0",
       FontWeight->Bold,
       FontColor->RGBColor[0, 0.5, 0]], "3", "+"]}], "+", 
    RowBox[{"12", " ", "\[ImaginaryI]", " ", 
     SqrtBox["3"], " ", 
     SubsuperscriptBox[
      StyleBox["\[Eta]0",
       FontWeight->Bold,
       FontColor->RGBColor[0, 0.5, 0]], "4", "+"]}], "-", 
    RowBox[{"216", " ", "\[ImaginaryI]", " ", 
     SubscriptBox[
      StyleBox["\[Zeta]",
       FontWeight->Bold,
       FontColor->GrayLevel[0.4]], "2"], " ", 
     SubsuperscriptBox[
      OverscriptBox[
       StyleBox["\[Eta]0",
        FontWeight->Bold,
        FontColor->RGBColor[0, 0.5, 0]], 
       StyleBox["_",
        FontWeight->Bold,
        FontColor->RGBColor[0, 0.5, 0]]], "1", "-"]}], "-", 
    RowBox[{"72", " ", "\[ImaginaryI]", " ", 
     SqrtBox["3"], " ", 
     SubsuperscriptBox[
      StyleBox["\[Eta]0",
       FontWeight->Bold,
       FontColor->RGBColor[0, 0.5, 0]], "1", "+"], " ", 
     SubsuperscriptBox[
      OverscriptBox[
       StyleBox["\[Eta]0",
        FontWeight->Bold,
        FontColor->RGBColor[0, 0.5, 0]], 
       StyleBox["_",
        FontWeight->Bold,
        FontColor->RGBColor[0, 0.5, 0]]], "1", "-"]}], "+", 
    RowBox[{"96", " ", "\[ImaginaryI]", " ", 
     SqrtBox["3"], " ", 
     SubscriptBox[
      StyleBox["\[Zeta]",
       FontWeight->Bold,
       FontColor->GrayLevel[0.4]], "2"], " ", 
     SubsuperscriptBox[
      StyleBox["\[Eta]0",
       FontWeight->Bold,
       FontColor->RGBColor[0, 0.5, 0]], "1", "+"], " ", 
     SubsuperscriptBox[
      OverscriptBox[
       StyleBox["\[Eta]0",
        FontWeight->Bold,
        FontColor->RGBColor[0, 0.5, 0]], 
       StyleBox["_",
        FontWeight->Bold,
        FontColor->RGBColor[0, 0.5, 0]]], "1", "-"]}], "+", 
    RowBox[{"108", " ", "\[ImaginaryI]", " ", 
     SuperscriptBox[
      RowBox[{"(", 
       SubsuperscriptBox[
        StyleBox["\[Eta]0",
         FontWeight->Bold,
         FontColor->RGBColor[0, 0.5, 0]], "1", "+"], ")"}], "2"], " ", 
     SubsuperscriptBox[
      OverscriptBox[
       StyleBox["\[Eta]0",
        FontWeight->Bold,
        FontColor->RGBColor[0, 0.5, 0]], 
       StyleBox["_",
        FontWeight->Bold,
        FontColor->RGBColor[0, 0.5, 0]]], "1", "-"]}], "-", 
    RowBox[{"24", " ", "\[ImaginaryI]", " ", 
     SqrtBox["3"], " ", 
     SuperscriptBox[
      RowBox[{"(", 
       SubsuperscriptBox[
        StyleBox["\[Eta]0",
         FontWeight->Bold,
         FontColor->RGBColor[0, 0.5, 0]], "1", "+"], ")"}], "3"], " ", 
     SubsuperscriptBox[
      OverscriptBox[
       StyleBox["\[Eta]0",
        FontWeight->Bold,
        FontColor->RGBColor[0, 0.5, 0]], 
       StyleBox["_",
        FontWeight->Bold,
        FontColor->RGBColor[0, 0.5, 0]]], "1", "-"]}], "-", 
    RowBox[{"36", " ", "\[ImaginaryI]", " ", 
     SqrtBox["3"], " ", 
     SuperscriptBox[
      RowBox[{"(", 
       SubsuperscriptBox[
        OverscriptBox[
         StyleBox["\[Eta]0",
          FontWeight->Bold,
          FontColor->RGBColor[0, 0.5, 0]], 
         StyleBox["_",
          FontWeight->Bold,
          FontColor->RGBColor[0, 0.5, 0]]], "1", "-"], ")"}], "2"]}], "+", 
    RowBox[{"48", " ", "\[ImaginaryI]", " ", 
     SqrtBox["3"], " ", 
     SubscriptBox[
      StyleBox["\[Zeta]",
       FontWeight->Bold,
       FontColor->GrayLevel[0.4]], "2"], " ", 
     SuperscriptBox[
      RowBox[{"(", 
       SubsuperscriptBox[
        OverscriptBox[
         StyleBox["\[Eta]0",
          FontWeight->Bold,
          FontColor->RGBColor[0, 0.5, 0]], 
         StyleBox["_",
          FontWeight->Bold,
          FontColor->RGBColor[0, 0.5, 0]]], "1", "-"], ")"}], "2"]}], "+", 
    RowBox[{"108", " ", "\[ImaginaryI]", " ", 
     SubsuperscriptBox[
      StyleBox["\[Eta]0",
       FontWeight->Bold,
       FontColor->RGBColor[0, 0.5, 0]], "1", "+"], " ", 
     SuperscriptBox[
      RowBox[{"(", 
       SubsuperscriptBox[
        OverscriptBox[
         StyleBox["\[Eta]0",
          FontWeight->Bold,
          FontColor->RGBColor[0, 0.5, 0]], 
         StyleBox["_",
          FontWeight->Bold,
          FontColor->RGBColor[0, 0.5, 0]]], "1", "-"], ")"}], "2"]}], "-", 
    RowBox[{"36", " ", "\[ImaginaryI]", " ", 
     SqrtBox["3"], " ", 
     SuperscriptBox[
      RowBox[{"(", 
       SubsuperscriptBox[
        StyleBox["\[Eta]0",
         FontWeight->Bold,
         FontColor->RGBColor[0, 0.5, 0]], "1", "+"], ")"}], "2"], " ", 
     SuperscriptBox[
      RowBox[{"(", 
       SubsuperscriptBox[
        OverscriptBox[
         StyleBox["\[Eta]0",
          FontWeight->Bold,
          FontColor->RGBColor[0, 0.5, 0]], 
         StyleBox["_",
          FontWeight->Bold,
          FontColor->RGBColor[0, 0.5, 0]]], "1", "-"], ")"}], "2"]}], "+", 
    RowBox[{"36", " ", "\[ImaginaryI]", " ", 
     SuperscriptBox[
      RowBox[{"(", 
       SubsuperscriptBox[
        OverscriptBox[
         StyleBox["\[Eta]0",
          FontWeight->Bold,
          FontColor->RGBColor[0, 0.5, 0]], 
         StyleBox["_",
          FontWeight->Bold,
          FontColor->RGBColor[0, 0.5, 0]]], "1", "-"], ")"}], "3"]}], "-", 
    RowBox[{"24", " ", "\[ImaginaryI]", " ", 
     SqrtBox["3"], " ", 
     SubsuperscriptBox[
      StyleBox["\[Eta]0",
       FontWeight->Bold,
       FontColor->RGBColor[0, 0.5, 0]], "1", "+"], " ", 
     SuperscriptBox[
      RowBox[{"(", 
       SubsuperscriptBox[
        OverscriptBox[
         StyleBox["\[Eta]0",
          FontWeight->Bold,
          FontColor->RGBColor[0, 0.5, 0]], 
         StyleBox["_",
          FontWeight->Bold,
          FontColor->RGBColor[0, 0.5, 0]]], "1", "-"], ")"}], "3"]}], "-", 
    RowBox[{"6", " ", "\[ImaginaryI]", " ", 
     SqrtBox["3"], " ", 
     SuperscriptBox[
      RowBox[{"(", 
       SubsuperscriptBox[
        OverscriptBox[
         StyleBox["\[Eta]0",
          FontWeight->Bold,
          FontColor->RGBColor[0, 0.5, 0]], 
         StyleBox["_",
          FontWeight->Bold,
          FontColor->RGBColor[0, 0.5, 0]]], "1", "-"], ")"}], "4"]}]}], ",", 
   RowBox[{
    RowBox[{"216", " ", "\[ImaginaryI]"}], "-", 
    RowBox[{"216", " ", "\[ImaginaryI]", " ", 
     SubscriptBox[
      StyleBox["\[Zeta]",
       FontWeight->Bold,
       FontColor->GrayLevel[0.4]], "2"]}], "+", 
    FractionBox[
     RowBox[{"432", " ", "\[ImaginaryI]", " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2", "2"]}], "5"], "+", 
    FractionBox[
     RowBox[{"3936", " ", "\[ImaginaryI]", " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2", "3"]}], "35"], "+", 
    RowBox[{"72", " ", "\[ImaginaryI]", " ", 
     SubscriptBox[
      StyleBox["\[Zeta]",
       FontWeight->Bold,
       FontColor->GrayLevel[0.4]], "3"]}], "+", 
    RowBox[{"288", " ", "\[ImaginaryI]", " ", 
     SubsuperscriptBox[
      StyleBox["\[Zeta]",
       FontWeight->Bold,
       FontColor->GrayLevel[0.4]], "3", "2"]}], "-", 
    RowBox[{"768", " ", "\[ImaginaryI]", " ", 
     SubscriptBox[
      StyleBox["\[Zeta]",
       FontWeight->Bold,
       FontColor->GrayLevel[0.4]], "5"]}], "-", 
    RowBox[{"336", " ", "\[ImaginaryI]", " ", 
     SubscriptBox[
      StyleBox["\[Zeta]",
       FontWeight->Bold,
       FontColor->GrayLevel[0.4]], "7"]}]}], ",", 
   RowBox[{
    RowBox[{
     RowBox[{"-", "297"}], " ", "\[ImaginaryI]"}], "+", 
    RowBox[{"108", " ", "\[ImaginaryI]", " ", 
     SubscriptBox[
      StyleBox["\[Zeta]",
       FontWeight->Bold,
       FontColor->GrayLevel[0.4]], "2"]}], "-", 
    RowBox[{"216", " ", 
     SqrtBox["3"], " ", 
     SubscriptBox[
      StyleBox["\[Zeta]",
       FontWeight->Bold,
       FontColor->GrayLevel[0.4]], "2"]}], "+", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{
        RowBox[{"-", "36"}], " ", "\[ImaginaryI]"}], "+", 
       RowBox[{"72", " ", 
        SqrtBox["3"]}]}], ")"}], " ", 
     SubsuperscriptBox[
      StyleBox["\[Zeta]",
       FontWeight->Bold,
       FontColor->GrayLevel[0.4]], "2", "2"]}], "-", 
    FractionBox[
     RowBox[{"328", " ", "\[ImaginaryI]", " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2", "3"]}], "7"], "-", 
    RowBox[{"468", " ", "\[ImaginaryI]", " ", 
     SubscriptBox[
      StyleBox["\[Zeta]",
       FontWeight->Bold,
       FontColor->GrayLevel[0.4]], "3"]}], "-", 
    RowBox[{"120", " ", "\[ImaginaryI]", " ", 
     SubsuperscriptBox[
      StyleBox["\[Zeta]",
       FontWeight->Bold,
       FontColor->GrayLevel[0.4]], "3", "2"]}], "+", 
    RowBox[{"696", " ", "\[ImaginaryI]", " ", 
     SubscriptBox[
      StyleBox["\[Zeta]",
       FontWeight->Bold,
       FontColor->GrayLevel[0.4]], "5"]}], "+", 
    RowBox[{"252", " ", "\[ImaginaryI]", " ", 
     SubscriptBox[
      StyleBox["\[Zeta]",
       FontWeight->Bold,
       FontColor->GrayLevel[0.4]], "7"]}], "+", 
    RowBox[{"216", " ", 
     SubscriptBox[
      StyleBox["\[Zeta]",
       FontWeight->Bold,
       FontColor->GrayLevel[0.4]], "2"], " ", 
     SubsuperscriptBox[
      StyleBox["\[Eta]0",
       FontWeight->Bold,
       FontColor->RGBColor[0, 0.5, 0]], "1", "+"]}], "+", 
    RowBox[{"36", " ", 
     SqrtBox["3"], " ", 
     SuperscriptBox[
      RowBox[{"(", 
       SubsuperscriptBox[
        StyleBox["\[Eta]0",
         FontWeight->Bold,
         FontColor->RGBColor[0, 0.5, 0]], "1", "+"], ")"}], "2"]}], "-", 
    RowBox[{"48", " ", 
     SqrtBox["3"], " ", 
     SubscriptBox[
      StyleBox["\[Zeta]",
       FontWeight->Bold,
       FontColor->GrayLevel[0.4]], "2"], " ", 
     SuperscriptBox[
      RowBox[{"(", 
       SubsuperscriptBox[
        StyleBox["\[Eta]0",
         FontWeight->Bold,
         FontColor->RGBColor[0, 0.5, 0]], "1", "+"], ")"}], "2"]}], "-", 
    RowBox[{"36", " ", 
     SuperscriptBox[
      RowBox[{"(", 
       SubsuperscriptBox[
        StyleBox["\[Eta]0",
         FontWeight->Bold,
         FontColor->RGBColor[0, 0.5, 0]], "1", "+"], ")"}], "3"]}], "+", 
    RowBox[{"6", " ", 
     SqrtBox["3"], " ", 
     SuperscriptBox[
      RowBox[{"(", 
       SubsuperscriptBox[
        StyleBox["\[Eta]0",
         FontWeight->Bold,
         FontColor->RGBColor[0, 0.5, 0]], "1", "+"], ")"}], "4"]}], "-", 
    RowBox[{"72", " ", 
     SqrtBox["3"], " ", 
     SubsuperscriptBox[
      StyleBox["\[Eta]0",
       FontWeight->Bold,
       FontColor->RGBColor[0, 0.5, 0]], "2", "+"]}], "+", 
    RowBox[{"72", " ", 
     SubsuperscriptBox[
      StyleBox["\[Eta]0",
       FontWeight->Bold,
       FontColor->RGBColor[0, 0.5, 0]], "3", "+"]}], "-", 
    RowBox[{"12", " ", 
     SqrtBox["3"], " ", 
     SubsuperscriptBox[
      StyleBox["\[Eta]0",
       FontWeight->Bold,
       FontColor->RGBColor[0, 0.5, 0]], "4", "+"]}], "+", 
    RowBox[{"216", " ", 
     SubscriptBox[
      StyleBox["\[Zeta]",
       FontWeight->Bold,
       FontColor->GrayLevel[0.4]], "2"], " ", 
     SubsuperscriptBox[
      OverscriptBox[
       StyleBox["\[Eta]0",
        FontWeight->Bold,
        FontColor->RGBColor[0, 0.5, 0]], 
       StyleBox["_",
        FontWeight->Bold,
        FontColor->RGBColor[0, 0.5, 0]]], "1", "-"]}], "+", 
    RowBox[{"72", " ", 
     SqrtBox["3"], " ", 
     SubsuperscriptBox[
      StyleBox["\[Eta]0",
       FontWeight->Bold,
       FontColor->RGBColor[0, 0.5, 0]], "1", "+"], " ", 
     SubsuperscriptBox[
      OverscriptBox[
       StyleBox["\[Eta]0",
        FontWeight->Bold,
        FontColor->RGBColor[0, 0.5, 0]], 
       StyleBox["_",
        FontWeight->Bold,
        FontColor->RGBColor[0, 0.5, 0]]], "1", "-"]}], "-", 
    RowBox[{"96", " ", 
     SqrtBox["3"], " ", 
     SubscriptBox[
      StyleBox["\[Zeta]",
       FontWeight->Bold,
       FontColor->GrayLevel[0.4]], "2"], " ", 
     SubsuperscriptBox[
      StyleBox["\[Eta]0",
       FontWeight->Bold,
       FontColor->RGBColor[0, 0.5, 0]], "1", "+"], " ", 
     SubsuperscriptBox[
      OverscriptBox[
       StyleBox["\[Eta]0",
        FontWeight->Bold,
        FontColor->RGBColor[0, 0.5, 0]], 
       StyleBox["_",
        FontWeight->Bold,
        FontColor->RGBColor[0, 0.5, 0]]], "1", "-"]}], "-", 
    RowBox[{"108", " ", 
     SuperscriptBox[
      RowBox[{"(", 
       SubsuperscriptBox[
        StyleBox["\[Eta]0",
         FontWeight->Bold,
         FontColor->RGBColor[0, 0.5, 0]], "1", "+"], ")"}], "2"], " ", 
     SubsuperscriptBox[
      OverscriptBox[
       StyleBox["\[Eta]0",
        FontWeight->Bold,
        FontColor->RGBColor[0, 0.5, 0]], 
       StyleBox["_",
        FontWeight->Bold,
        FontColor->RGBColor[0, 0.5, 0]]], "1", "-"]}], "+", 
    RowBox[{"24", " ", 
     SqrtBox["3"], " ", 
     SuperscriptBox[
      RowBox[{"(", 
       SubsuperscriptBox[
        StyleBox["\[Eta]0",
         FontWeight->Bold,
         FontColor->RGBColor[0, 0.5, 0]], "1", "+"], ")"}], "3"], " ", 
     SubsuperscriptBox[
      OverscriptBox[
       StyleBox["\[Eta]0",
        FontWeight->Bold,
        FontColor->RGBColor[0, 0.5, 0]], 
       StyleBox["_",
        FontWeight->Bold,
        FontColor->RGBColor[0, 0.5, 0]]], "1", "-"]}], "+", 
    RowBox[{"36", " ", 
     SqrtBox["3"], " ", 
     SuperscriptBox[
      RowBox[{"(", 
       SubsuperscriptBox[
        OverscriptBox[
         StyleBox["\[Eta]0",
          FontWeight->Bold,
          FontColor->RGBColor[0, 0.5, 0]], 
         StyleBox["_",
          FontWeight->Bold,
          FontColor->RGBColor[0, 0.5, 0]]], "1", "-"], ")"}], "2"]}], "-", 
    RowBox[{"48", " ", 
     SqrtBox["3"], " ", 
     SubscriptBox[
      StyleBox["\[Zeta]",
       FontWeight->Bold,
       FontColor->GrayLevel[0.4]], "2"], " ", 
     SuperscriptBox[
      RowBox[{"(", 
       SubsuperscriptBox[
        OverscriptBox[
         StyleBox["\[Eta]0",
          FontWeight->Bold,
          FontColor->RGBColor[0, 0.5, 0]], 
         StyleBox["_",
          FontWeight->Bold,
          FontColor->RGBColor[0, 0.5, 0]]], "1", "-"], ")"}], "2"]}], "-", 
    RowBox[{"108", " ", 
     SubsuperscriptBox[
      StyleBox["\[Eta]0",
       FontWeight->Bold,
       FontColor->RGBColor[0, 0.5, 0]], "1", "+"], " ", 
     SuperscriptBox[
      RowBox[{"(", 
       SubsuperscriptBox[
        OverscriptBox[
         StyleBox["\[Eta]0",
          FontWeight->Bold,
          FontColor->RGBColor[0, 0.5, 0]], 
         StyleBox["_",
          FontWeight->Bold,
          FontColor->RGBColor[0, 0.5, 0]]], "1", "-"], ")"}], "2"]}], "+", 
    RowBox[{"36", " ", 
     SqrtBox["3"], " ", 
     SuperscriptBox[
      RowBox[{"(", 
       SubsuperscriptBox[
        StyleBox["\[Eta]0",
         FontWeight->Bold,
         FontColor->RGBColor[0, 0.5, 0]], "1", "+"], ")"}], "2"], " ", 
     SuperscriptBox[
      RowBox[{"(", 
       SubsuperscriptBox[
        OverscriptBox[
         StyleBox["\[Eta]0",
          FontWeight->Bold,
          FontColor->RGBColor[0, 0.5, 0]], 
         StyleBox["_",
          FontWeight->Bold,
          FontColor->RGBColor[0, 0.5, 0]]], "1", "-"], ")"}], "2"]}], "-", 
    RowBox[{"36", " ", 
     SuperscriptBox[
      RowBox[{"(", 
       SubsuperscriptBox[
        OverscriptBox[
         StyleBox["\[Eta]0",
          FontWeight->Bold,
          FontColor->RGBColor[0, 0.5, 0]], 
         StyleBox["_",
          FontWeight->Bold,
          FontColor->RGBColor[0, 0.5, 0]]], "1", "-"], ")"}], "3"]}], "+", 
    RowBox[{"24", " ", 
     SqrtBox["3"], " ", 
     SubsuperscriptBox[
      StyleBox["\[Eta]0",
       FontWeight->Bold,
       FontColor->RGBColor[0, 0.5, 0]], "1", "+"], " ", 
     SuperscriptBox[
      RowBox[{"(", 
       SubsuperscriptBox[
        OverscriptBox[
         StyleBox["\[Eta]0",
          FontWeight->Bold,
          FontColor->RGBColor[0, 0.5, 0]], 
         StyleBox["_",
          FontWeight->Bold,
          FontColor->RGBColor[0, 0.5, 0]]], "1", "-"], ")"}], "3"]}], "+", 
    RowBox[{"6", " ", 
     SqrtBox["3"], " ", 
     SuperscriptBox[
      RowBox[{"(", 
       SubsuperscriptBox[
        OverscriptBox[
         StyleBox["\[Eta]0",
          FontWeight->Bold,
          FontColor->RGBColor[0, 0.5, 0]], 
         StyleBox["_",
          FontWeight->Bold,
          FontColor->RGBColor[0, 0.5, 0]]], "1", "-"], ")"}], "4"]}]}]}], 
  "}"}]], "Output",
 CellChangeTimes->{{3.5629561101447067`*^9, 3.562956134096149*^9}, 
   3.5629564179322777`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"coefs2", "=", 
  RowBox[{
   RowBox[{"coefs", "//.", "subZetaReduce"}], "//", 
   "fundeperiod"}]}]], "Input",
 CellChangeTimes->{{3.56295650852743*^9, 3.562956521778111*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"216", "-", 
    RowBox[{"216", " ", 
     SubscriptBox[
      StyleBox["\[Zeta]",
       FontWeight->Bold,
       FontColor->GrayLevel[0.4]], "2"]}], "+", 
    FractionBox[
     RowBox[{"432", " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2", "2"]}], "5"], "+", 
    FractionBox[
     RowBox[{"3936", " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2", "3"]}], "35"], "+", 
    RowBox[{"72", " ", 
     SubscriptBox[
      StyleBox["\[Zeta]",
       FontWeight->Bold,
       FontColor->GrayLevel[0.4]], "3"]}], "+", 
    RowBox[{"288", " ", 
     SubsuperscriptBox[
      StyleBox["\[Zeta]",
       FontWeight->Bold,
       FontColor->GrayLevel[0.4]], "3", "2"]}], "-", 
    RowBox[{"768", " ", 
     SubscriptBox[
      StyleBox["\[Zeta]",
       FontWeight->Bold,
       FontColor->GrayLevel[0.4]], "5"]}], "-", 
    RowBox[{"336", " ", 
     SubscriptBox[
      StyleBox["\[Zeta]",
       FontWeight->Bold,
       FontColor->GrayLevel[0.4]], "7"]}]}], ",", 
   RowBox[{
    RowBox[{"-", "189"}], "+", 
    FractionBox[
     RowBox[{"36", " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2", "2"]}], "5"], "+", 
    FractionBox[
     RowBox[{"328", " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2", "3"]}], "35"], "-", 
    RowBox[{"432", " ", 
     SubscriptBox[
      StyleBox["\[Zeta]",
       FontWeight->Bold,
       FontColor->GrayLevel[0.4]], "3"]}], "+", 
    RowBox[{"24", " ", 
     SubsuperscriptBox[
      StyleBox["\[Zeta]",
       FontWeight->Bold,
       FontColor->GrayLevel[0.4]], "3", "2"]}], "+", 
    RowBox[{"312", " ", 
     SubscriptBox[
      StyleBox["\[Zeta]",
       FontWeight->Bold,
       FontColor->GrayLevel[0.4]], "5"]}], "+", 
    RowBox[{"84", " ", 
     SubscriptBox[
      StyleBox["\[Zeta]",
       FontWeight->Bold,
       FontColor->GrayLevel[0.4]], "7"]}], "+", 
    RowBox[{"36", " ", "\[ImaginaryI]", " ", 
     SqrtBox["3"], " ", 
     SubsuperscriptBox[
      StyleBox["\[Eta]0",
       FontWeight->Bold,
       FontColor->RGBColor[0, 0.5, 0]], "2", "+"]}], "-", 
    RowBox[{"36", " ", "\[ImaginaryI]", " ", 
     SubsuperscriptBox[
      StyleBox["\[Eta]0",
       FontWeight->Bold,
       FontColor->RGBColor[0, 0.5, 0]], "3", "+"]}], "+", 
    RowBox[{"6", " ", "\[ImaginaryI]", " ", 
     SqrtBox["3"], " ", 
     SubsuperscriptBox[
      StyleBox["\[Eta]0",
       FontWeight->Bold,
       FontColor->RGBColor[0, 0.5, 0]], "4", "+"]}], "-", 
    RowBox[{"36", " ", "\[ImaginaryI]", " ", 
     SqrtBox["3"], " ", 
     SubsuperscriptBox[
      OverscriptBox[
       StyleBox["\[Eta]0",
        FontWeight->Bold,
        FontColor->RGBColor[0, 0.5, 0]], 
       StyleBox["_",
        FontWeight->Bold,
        FontColor->RGBColor[0, 0.5, 0]]], "2", "-"]}], "+", 
    RowBox[{"36", " ", "\[ImaginaryI]", " ", 
     SubsuperscriptBox[
      OverscriptBox[
       StyleBox["\[Eta]0",
        FontWeight->Bold,
        FontColor->RGBColor[0, 0.5, 0]], 
       StyleBox["_",
        FontWeight->Bold,
        FontColor->RGBColor[0, 0.5, 0]]], "3", "-"]}], "-", 
    RowBox[{"6", " ", "\[ImaginaryI]", " ", 
     SqrtBox["3"], " ", 
     SubsuperscriptBox[
      OverscriptBox[
       StyleBox["\[Eta]0",
        FontWeight->Bold,
        FontColor->RGBColor[0, 0.5, 0]], 
       StyleBox["_",
        FontWeight->Bold,
        FontColor->RGBColor[0, 0.5, 0]]], "4", "-"]}]}], ",", 
   RowBox[{
    RowBox[{"216", " ", "\[ImaginaryI]"}], "-", 
    RowBox[{"216", " ", "\[ImaginaryI]", " ", 
     SubscriptBox[
      StyleBox["\[Zeta]",
       FontWeight->Bold,
       FontColor->GrayLevel[0.4]], "2"]}], "+", 
    FractionBox[
     RowBox[{"432", " ", "\[ImaginaryI]", " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2", "2"]}], "5"], "+", 
    FractionBox[
     RowBox[{"3936", " ", "\[ImaginaryI]", " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2", "3"]}], "35"], "+", 
    RowBox[{"72", " ", "\[ImaginaryI]", " ", 
     SubscriptBox[
      StyleBox["\[Zeta]",
       FontWeight->Bold,
       FontColor->GrayLevel[0.4]], "3"]}], "+", 
    RowBox[{"288", " ", "\[ImaginaryI]", " ", 
     SubsuperscriptBox[
      StyleBox["\[Zeta]",
       FontWeight->Bold,
       FontColor->GrayLevel[0.4]], "3", "2"]}], "-", 
    RowBox[{"768", " ", "\[ImaginaryI]", " ", 
     SubscriptBox[
      StyleBox["\[Zeta]",
       FontWeight->Bold,
       FontColor->GrayLevel[0.4]], "5"]}], "-", 
    RowBox[{"336", " ", "\[ImaginaryI]", " ", 
     SubscriptBox[
      StyleBox["\[Zeta]",
       FontWeight->Bold,
       FontColor->GrayLevel[0.4]], "7"]}]}], ",", 
   RowBox[{
    RowBox[{
     RowBox[{"-", "297"}], " ", "\[ImaginaryI]"}], "+", 
    RowBox[{"108", " ", "\[ImaginaryI]", " ", 
     SubscriptBox[
      StyleBox["\[Zeta]",
       FontWeight->Bold,
       FontColor->GrayLevel[0.4]], "2"]}], "-", 
    RowBox[{"36", " ", "\[ImaginaryI]", " ", 
     SubsuperscriptBox[
      StyleBox["\[Zeta]",
       FontWeight->Bold,
       FontColor->GrayLevel[0.4]], "2", "2"]}], "-", 
    FractionBox[
     RowBox[{"328", " ", "\[ImaginaryI]", " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2", "3"]}], "7"], "-", 
    RowBox[{"468", " ", "\[ImaginaryI]", " ", 
     SubscriptBox[
      StyleBox["\[Zeta]",
       FontWeight->Bold,
       FontColor->GrayLevel[0.4]], "3"]}], "-", 
    RowBox[{"120", " ", "\[ImaginaryI]", " ", 
     SubsuperscriptBox[
      StyleBox["\[Zeta]",
       FontWeight->Bold,
       FontColor->GrayLevel[0.4]], "3", "2"]}], "+", 
    RowBox[{"696", " ", "\[ImaginaryI]", " ", 
     SubscriptBox[
      StyleBox["\[Zeta]",
       FontWeight->Bold,
       FontColor->GrayLevel[0.4]], "5"]}], "+", 
    RowBox[{"252", " ", "\[ImaginaryI]", " ", 
     SubscriptBox[
      StyleBox["\[Zeta]",
       FontWeight->Bold,
       FontColor->GrayLevel[0.4]], "7"]}], "-", 
    RowBox[{"36", " ", 
     SqrtBox["3"], " ", 
     SubsuperscriptBox[
      StyleBox["\[Eta]0",
       FontWeight->Bold,
       FontColor->RGBColor[0, 0.5, 0]], "2", "+"]}], "+", 
    RowBox[{"36", " ", 
     SubsuperscriptBox[
      StyleBox["\[Eta]0",
       FontWeight->Bold,
       FontColor->RGBColor[0, 0.5, 0]], "3", "+"]}], "-", 
    RowBox[{"6", " ", 
     SqrtBox["3"], " ", 
     SubsuperscriptBox[
      StyleBox["\[Eta]0",
       FontWeight->Bold,
       FontColor->RGBColor[0, 0.5, 0]], "4", "+"]}], "+", 
    RowBox[{"36", " ", 
     SqrtBox["3"], " ", 
     SubsuperscriptBox[
      OverscriptBox[
       StyleBox["\[Eta]0",
        FontWeight->Bold,
        FontColor->RGBColor[0, 0.5, 0]], 
       StyleBox["_",
        FontWeight->Bold,
        FontColor->RGBColor[0, 0.5, 0]]], "2", "-"]}], "-", 
    RowBox[{"36", " ", 
     SubsuperscriptBox[
      OverscriptBox[
       StyleBox["\[Eta]0",
        FontWeight->Bold,
        FontColor->RGBColor[0, 0.5, 0]], 
       StyleBox["_",
        FontWeight->Bold,
        FontColor->RGBColor[0, 0.5, 0]]], "3", "-"]}], "+", 
    RowBox[{"6", " ", 
     SqrtBox["3"], " ", 
     SubsuperscriptBox[
      OverscriptBox[
       StyleBox["\[Eta]0",
        FontWeight->Bold,
        FontColor->RGBColor[0, 0.5, 0]], 
       StyleBox["_",
        FontWeight->Bold,
        FontColor->RGBColor[0, 0.5, 0]]], "4", "-"]}]}]}], "}"}]], "Output",
 CellChangeTimes->{3.562956522995936*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Mterm", "=", 
  RowBox[{"tmp2", "/.", 
   RowBox[{
    RowBox[{"mcoef", "[", "i_", "]"}], "\[RuleDelayed]", 
    RowBox[{"coefs2", "[", 
     RowBox[{"[", "i", "]"}], "]"}]}]}]}]], "Input",
 CellChangeTimes->{{3.562956541382888*^9, 3.562956562104917*^9}}],

Cell[BoxData[
 RowBox[{
  SuperscriptBox["g", "7"], " ", 
  RowBox[{"(", 
   RowBox[{
    RowBox[{
     SuperscriptBox["z", "3"], " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"216", " ", "\[ImaginaryI]"}], "-", 
       RowBox[{"216", " ", "\[ImaginaryI]", " ", 
        SubscriptBox[
         StyleBox["\[Zeta]",
          FontWeight->Bold,
          FontColor->GrayLevel[0.4]], "2"]}], "+", 
       FractionBox[
        RowBox[{"432", " ", "\[ImaginaryI]", " ", 
         SubsuperscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "2", "2"]}], "5"], "+", 
       FractionBox[
        RowBox[{"3936", " ", "\[ImaginaryI]", " ", 
         SubsuperscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "2", "3"]}], "35"], "+", 
       RowBox[{"72", " ", "\[ImaginaryI]", " ", 
        SubscriptBox[
         StyleBox["\[Zeta]",
          FontWeight->Bold,
          FontColor->GrayLevel[0.4]], "3"]}], "+", 
       RowBox[{"288", " ", "\[ImaginaryI]", " ", 
        SubsuperscriptBox[
         StyleBox["\[Zeta]",
          FontWeight->Bold,
          FontColor->GrayLevel[0.4]], "3", "2"]}], "-", 
       RowBox[{"768", " ", "\[ImaginaryI]", " ", 
        SubscriptBox[
         StyleBox["\[Zeta]",
          FontWeight->Bold,
          FontColor->GrayLevel[0.4]], "5"]}], "-", 
       RowBox[{"336", " ", "\[ImaginaryI]", " ", 
        SubscriptBox[
         StyleBox["\[Zeta]",
          FontWeight->Bold,
          FontColor->GrayLevel[0.4]], "7"]}]}], ")"}]}], "+", 
    RowBox[{
     SqrtBox[
      RowBox[{"1", "-", 
       SuperscriptBox["z", "2"]}]], " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"-", "189"}], "+", 
       FractionBox[
        RowBox[{"36", " ", 
         SubsuperscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "2", "2"]}], "5"], "+", 
       FractionBox[
        RowBox[{"328", " ", 
         SubsuperscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "2", "3"]}], "35"], "-", 
       RowBox[{"432", " ", 
        SubscriptBox[
         StyleBox["\[Zeta]",
          FontWeight->Bold,
          FontColor->GrayLevel[0.4]], "3"]}], "+", 
       RowBox[{"24", " ", 
        SubsuperscriptBox[
         StyleBox["\[Zeta]",
          FontWeight->Bold,
          FontColor->GrayLevel[0.4]], "3", "2"]}], "+", 
       RowBox[{"312", " ", 
        SubscriptBox[
         StyleBox["\[Zeta]",
          FontWeight->Bold,
          FontColor->GrayLevel[0.4]], "5"]}], "+", 
       RowBox[{
        SuperscriptBox["z", "2"], " ", 
        RowBox[{"(", 
         RowBox[{"216", "-", 
          RowBox[{"216", " ", 
           SubscriptBox[
            StyleBox["\[Zeta]",
             FontWeight->Bold,
             FontColor->GrayLevel[0.4]], "2"]}], "+", 
          FractionBox[
           RowBox[{"432", " ", 
            SubsuperscriptBox[
             StyleBox["\[Zeta]",
              FontWeight->Bold,
              FontColor->GrayLevel[0.4]], "2", "2"]}], "5"], "+", 
          FractionBox[
           RowBox[{"3936", " ", 
            SubsuperscriptBox[
             StyleBox["\[Zeta]",
              FontWeight->Bold,
              FontColor->GrayLevel[0.4]], "2", "3"]}], "35"], "+", 
          RowBox[{"72", " ", 
           SubscriptBox[
            StyleBox["\[Zeta]",
             FontWeight->Bold,
             FontColor->GrayLevel[0.4]], "3"]}], "+", 
          RowBox[{"288", " ", 
           SubsuperscriptBox[
            StyleBox["\[Zeta]",
             FontWeight->Bold,
             FontColor->GrayLevel[0.4]], "3", "2"]}], "-", 
          RowBox[{"768", " ", 
           SubscriptBox[
            StyleBox["\[Zeta]",
             FontWeight->Bold,
             FontColor->GrayLevel[0.4]], "5"]}], "-", 
          RowBox[{"336", " ", 
           SubscriptBox[
            StyleBox["\[Zeta]",
             FontWeight->Bold,
             FontColor->GrayLevel[0.4]], "7"]}]}], ")"}]}], "+", 
       RowBox[{"84", " ", 
        SubscriptBox[
         StyleBox["\[Zeta]",
          FontWeight->Bold,
          FontColor->GrayLevel[0.4]], "7"]}], "+", 
       RowBox[{"36", " ", "\[ImaginaryI]", " ", 
        SqrtBox["3"], " ", 
        SubsuperscriptBox[
         StyleBox["\[Eta]0",
          FontWeight->Bold,
          FontColor->RGBColor[0, 0.5, 0]], "2", "+"]}], "-", 
       RowBox[{"36", " ", "\[ImaginaryI]", " ", 
        SubsuperscriptBox[
         StyleBox["\[Eta]0",
          FontWeight->Bold,
          FontColor->RGBColor[0, 0.5, 0]], "3", "+"]}], "+", 
       RowBox[{"6", " ", "\[ImaginaryI]", " ", 
        SqrtBox["3"], " ", 
        SubsuperscriptBox[
         StyleBox["\[Eta]0",
          FontWeight->Bold,
          FontColor->RGBColor[0, 0.5, 0]], "4", "+"]}], "-", 
       RowBox[{"36", " ", "\[ImaginaryI]", " ", 
        SqrtBox["3"], " ", 
        SubsuperscriptBox[
         OverscriptBox[
          StyleBox["\[Eta]0",
           FontWeight->Bold,
           FontColor->RGBColor[0, 0.5, 0]], 
          StyleBox["_",
           FontWeight->Bold,
           FontColor->RGBColor[0, 0.5, 0]]], "2", "-"]}], "+", 
       RowBox[{"36", " ", "\[ImaginaryI]", " ", 
        SubsuperscriptBox[
         OverscriptBox[
          StyleBox["\[Eta]0",
           FontWeight->Bold,
           FontColor->RGBColor[0, 0.5, 0]], 
          StyleBox["_",
           FontWeight->Bold,
           FontColor->RGBColor[0, 0.5, 0]]], "3", "-"]}], "-", 
       RowBox[{"6", " ", "\[ImaginaryI]", " ", 
        SqrtBox["3"], " ", 
        SubsuperscriptBox[
         OverscriptBox[
          StyleBox["\[Eta]0",
           FontWeight->Bold,
           FontColor->RGBColor[0, 0.5, 0]], 
          StyleBox["_",
           FontWeight->Bold,
           FontColor->RGBColor[0, 0.5, 0]]], "4", "-"]}]}], ")"}]}], "+", 
    RowBox[{"z", " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{
        RowBox[{"-", "297"}], " ", "\[ImaginaryI]"}], "+", 
       RowBox[{"108", " ", "\[ImaginaryI]", " ", 
        SubscriptBox[
         StyleBox["\[Zeta]",
          FontWeight->Bold,
          FontColor->GrayLevel[0.4]], "2"]}], "-", 
       RowBox[{"36", " ", "\[ImaginaryI]", " ", 
        SubsuperscriptBox[
         StyleBox["\[Zeta]",
          FontWeight->Bold,
          FontColor->GrayLevel[0.4]], "2", "2"]}], "-", 
       FractionBox[
        RowBox[{"328", " ", "\[ImaginaryI]", " ", 
         SubsuperscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "2", "3"]}], "7"], "-", 
       RowBox[{"468", " ", "\[ImaginaryI]", " ", 
        SubscriptBox[
         StyleBox["\[Zeta]",
          FontWeight->Bold,
          FontColor->GrayLevel[0.4]], "3"]}], "-", 
       RowBox[{"120", " ", "\[ImaginaryI]", " ", 
        SubsuperscriptBox[
         StyleBox["\[Zeta]",
          FontWeight->Bold,
          FontColor->GrayLevel[0.4]], "3", "2"]}], "+", 
       RowBox[{"696", " ", "\[ImaginaryI]", " ", 
        SubscriptBox[
         StyleBox["\[Zeta]",
          FontWeight->Bold,
          FontColor->GrayLevel[0.4]], "5"]}], "+", 
       RowBox[{"252", " ", "\[ImaginaryI]", " ", 
        SubscriptBox[
         StyleBox["\[Zeta]",
          FontWeight->Bold,
          FontColor->GrayLevel[0.4]], "7"]}], "-", 
       RowBox[{"36", " ", 
        SqrtBox["3"], " ", 
        SubsuperscriptBox[
         StyleBox["\[Eta]0",
          FontWeight->Bold,
          FontColor->RGBColor[0, 0.5, 0]], "2", "+"]}], "+", 
       RowBox[{"36", " ", 
        SubsuperscriptBox[
         StyleBox["\[Eta]0",
          FontWeight->Bold,
          FontColor->RGBColor[0, 0.5, 0]], "3", "+"]}], "-", 
       RowBox[{"6", " ", 
        SqrtBox["3"], " ", 
        SubsuperscriptBox[
         StyleBox["\[Eta]0",
          FontWeight->Bold,
          FontColor->RGBColor[0, 0.5, 0]], "4", "+"]}], "+", 
       RowBox[{"36", " ", 
        SqrtBox["3"], " ", 
        SubsuperscriptBox[
         OverscriptBox[
          StyleBox["\[Eta]0",
           FontWeight->Bold,
           FontColor->RGBColor[0, 0.5, 0]], 
          StyleBox["_",
           FontWeight->Bold,
           FontColor->RGBColor[0, 0.5, 0]]], "2", "-"]}], "-", 
       RowBox[{"36", " ", 
        SubsuperscriptBox[
         OverscriptBox[
          StyleBox["\[Eta]0",
           FontWeight->Bold,
           FontColor->RGBColor[0, 0.5, 0]], 
          StyleBox["_",
           FontWeight->Bold,
           FontColor->RGBColor[0, 0.5, 0]]], "3", "-"]}], "+", 
       RowBox[{"6", " ", 
        SqrtBox["3"], " ", 
        SubsuperscriptBox[
         OverscriptBox[
          StyleBox["\[Eta]0",
           FontWeight->Bold,
           FontColor->RGBColor[0, 0.5, 0]], 
          StyleBox["_",
           FontWeight->Bold,
           FontColor->RGBColor[0, 0.5, 0]]], "4", "-"]}]}], ")"}]}]}], 
   ")"}]}]], "Output",
 CellChangeTimes->{{3.562956550437601*^9, 3.5629565625091743`*^9}, 
   3.562997714322886*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ncoefs", "=", 
  RowBox[{"Monitor", "[", 
   RowBox[{
    RowBox[{"Table", "[", 
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{
          RowBox[{
           RowBox[{
            RowBox[{
             RowBox[{
              RowBox[{"coef", "[", "i", "]"}], "/.", "solut\[Rho]s"}], "/.", 
             RowBox[{
              SubscriptBox["H", "lead"], "\[Rule]", "H"}]}], "/.", 
            RowBox[{
             SubsuperscriptBox[
              StyleBox["W",
               FontColor->RGBColor[0.54, 0.35, 0.15]], 
              RowBox[{"1", ",", "lead"}], "+"], "\[Rule]", 
             SubsuperscriptBox["W", "1", "+"]}]}], "/.", " ", 
           RowBox[{
            SubscriptBox[
             OverscriptBox[
              StyleBox["W",
               FontColor->RGBColor[0.54, 0.35, 0.15]], 
              StyleBox["^",
               FontColor->RGBColor[0.54, 0.35, 0.15]]], "lead"], "\[Rule]", 
            "W"}]}], "/.", 
          RowBox[{"leadweak", "[", "1", "]"}]}], "/.", 
         RowBox[{"g", "\[Rule]", "1"}]}], "/.", "subZetas"}], "/.", 
       RowBox[{
        RowBox[{"\[DoubleStruckCapitalC]", "[", "a_", "]"}], "\[RuleDelayed]", 
        RowBox[{"specint", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"a", "/.", "subQ0"}], "/.", 
           RowBox[{
            RowBox[{"xxx", ":", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{
                RowBox[{"\[Eta]0$", "[", "_", "]"}], "[", "_", "]"}], "|", 
               RowBox[{
                RowBox[{"\[Eta]0$b", "[", "_", "]"}], "[", "_", "]"}]}], 
              ")"}]}], "\[RuleDelayed]", 
            RowBox[{"BoldCompute", "[", 
             RowBox[{"xxx", ",", "0", ",", "50"}], "]"}]}]}], ",", 
          RowBox[{
           RowBox[{"-", "\[ImaginaryI]"}], "/", "4"}]}], "]"}]}]}], ",", 
      RowBox[{"{", 
       RowBox[{"i", ",", "4"}], "}"}]}], "]"}], ",", "i"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.562956763832405*^9, 3.562956843893827*^9}, {
  3.5629568969016542`*^9, 3.5629570408966293`*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{
    FractionBox["1", "2"], " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{
        "-", "74.60994975979019046232399789049287411069`14.144946883112514"}],
         "+", 
        RowBox[{"0``20.04156818912621", " ", "\[ImaginaryI]"}]}], ")"}], "-", 
      
      RowBox[{
       FractionBox["16", "9"], " ", 
       SubscriptBox[
        StyleBox["W",
         FontColor->RGBColor[0.54, 0.35, 0.15]], 
        RowBox[{"1", ",", "v0", ",", "lead"}]]}]}], ")"}]}], ",", 
   RowBox[{
    FractionBox["1", "2"], " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
       "16.26653497003600918984481299667917650183`14.144136130439927", "+", 
        RowBox[{"0``20.64471145744143", " ", "\[ImaginaryI]"}]}], ")"}], "-", 
      
      RowBox[{
       FractionBox["2", "9"], " ", 
       SubscriptBox[
        StyleBox["W",
         FontColor->RGBColor[0.54, 0.35, 0.15]], 
        RowBox[{"1", ",", "v0", ",", "lead"}]]}]}], ")"}]}], ",", 
   RowBox[{
    FractionBox["1", "2"], " ", "\[ImaginaryI]", " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{
        "-", "74.60994975979019046232399789049287411069`14.144946883112514"}],
         "+", 
        RowBox[{"0``20.04156818912621", " ", "\[ImaginaryI]"}]}], ")"}], "-", 
      
      RowBox[{
       FractionBox["16", "9"], " ", 
       SubscriptBox[
        StyleBox["W",
         FontColor->RGBColor[0.54, 0.35, 0.15]], 
        RowBox[{"1", ",", "v0", ",", "lead"}]]}]}], ")"}]}], ",", 
   RowBox[{
    RowBox[{
     RowBox[{"-", 
      FractionBox["1", "4"]}], " ", "\[ImaginaryI]", " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{
         "-", "74.60994975979019046232399789049287411069`14.144946883112514"}]\
, "+", 
         RowBox[{"0``20.04156818912621", " ", "\[ImaginaryI]"}]}], ")"}], "-", 
       RowBox[{
        FractionBox["16", "9"], " ", 
        SubscriptBox[
         StyleBox["W",
          FontColor->RGBColor[0.54, 0.35, 0.15]], 
         RowBox[{"1", ",", "v0", ",", "lead"}]]}]}], ")"}]}], "+", 
    RowBox[{
     FractionBox["1", "2"], " ", "\[ImaginaryI]", " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{
        "16.26653497003600918984481299667917650183`14.144136130439927", "+", 
         RowBox[{"0``20.64471145744143", " ", "\[ImaginaryI]"}]}], ")"}], "-", 
       RowBox[{
        FractionBox["2", "9"], " ", 
        SubscriptBox[
         StyleBox["W",
          FontColor->RGBColor[0.54, 0.35, 0.15]], 
         RowBox[{"1", ",", "v0", ",", "lead"}]]}]}], ")"}]}]}]}], 
  "}"}]], "Output",
 CellChangeTimes->{{3.5629568972496853`*^9, 3.562956931369624*^9}, {
   3.5629570084370403`*^9, 3.562957029821166*^9}, 3.5629571350080748`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"BoldCompute", "[", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{"ncoefs", "/.", 
          RowBox[{
           SubscriptBox["W", 
            RowBox[{"1", ",", "v0", ",", "lead"}]], "\[Rule]", 
           SubscriptBox["W", "1"]}]}], "/.", 
         RowBox[{"leadweak", "[", "1", "]"}]}], "/.", 
        RowBox[{"g", "\[Rule]", "1"}]}], "/.", "subZetas"}], "/.", "subQ0"}], 
     "/.", 
     RowBox[{"u", "\[Rule]", "v00"}]}], ",", "v00"}], "]"}], "//", 
  "Chop"}]], "Input",
 CellChangeTimes->{{3.562957142976178*^9, 3.562957186408149*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{
   "-", "37.46597963532556455873201887024262400989`14.146815916187911"}], ",",
    "8.1131418905891959289761540077150648816`14.143059397946448", ",", 
   RowBox[{
    RowBox[{
    "-", "37.46597963532556455873201887024262400989`14.146815916187911"}], 
    " ", "\[ImaginaryI]"}], ",", 
   RowBox[{
   "26.84613170825197820834216344283637688654`14.14567723275014", " ", 
    "\[ImaginaryI]"}]}], "}"}]], "Output",
 CellChangeTimes->{{3.5629571725062437`*^9, 3.562957188001203*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"BoldCompute", "[", 
   RowBox[{"coefs", ",", "0"}], "]"}], "//", "Chop"}]], "Input",
 CellChangeTimes->{{3.562957188860696*^9, 3.562957206078649*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{
   "-", "37.46597963531880949578027610912632854318`18.06526301222227"}], ",", 
   "8.11314189058749764619851795953830921938`16.735435162169882", ",", 
   RowBox[{
    RowBox[{
    "-", "37.46597963531880949578027610912632854318`18.06526301222227"}], " ",
     "\[ImaginaryI]"}], ",", 
   RowBox[{
   "26.84613170824690239408865601410147349097`17.22020673708469", " ", 
    "\[ImaginaryI]"}]}], "}"}]], "Output",
 CellChangeTimes->{{3.562957190187361*^9, 3.562957206625601*^9}}]
}, Open  ]],

Cell[TextData[{
 "Integral of W does not contribute in the double scaling for ",
 Cell[BoxData[
  FormBox[
   SuperscriptBox["g", 
    RowBox[{"a", "<", "9"}]], TraditionalForm]],
  FormatType->"TraditionalForm"],
 ". Only residue giving  1/2W does. But ",
 Cell[BoxData[
  FormBox[
   SuperscriptBox["g", "8"], TraditionalForm]],
  FormatType->"TraditionalForm"],
 " term I should compute"
}], "Text",
 CellChangeTimes->{{3.562941487833909*^9, 3.562941531001856*^9}, {
  3.56295675755226*^9, 3.56295675824679*^9}, {3.5629572154368477`*^9, 
  3.562957233788815*^9}}],

Cell["First I compute residue", "Text",
 CellChangeTimes->{{3.562957224444536*^9, 3.562957229652206*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"tmpWres", "=", 
   RowBox[{"Collect", "[", 
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{
          RowBox[{
           RowBox[{
            RowBox[{
             RowBox[{
              RowBox[{
               RowBox[{
                RowBox[{
                 RowBox[{
                  RowBox[{
                   RowBox[{
                    RowBox[{"-", 
                    FractionBox["1", "2"]}], "W"}], "/.", "subWq"}], "/.", 
                  "subq34"}], "/.", 
                 RowBox[{"{", 
                  RowBox[{
                   RowBox[{
                    OverscriptBox["\[Alpha]", "_"], "\[Rule]", "0"}], ",", 
                   RowBox[{"\[Alpha]", "\[Rule]", "0"}]}], "}"}]}], "/.", 
                "largevolume"}], "/.", 
               RowBox[{
                FractionBox["1", "x"], "\[Rule]", "x"}]}], " ", "/.", 
              RowBox[{"x", "\[Rule]", 
               FractionBox["1", "x"]}]}], "/.", 
             RowBox[{"leadweak", "[", "3", "]"}]}], "/.", "subJuk"}], "/.", 
           "subQ0"}], "/.", 
          RowBox[{"u", "\[Rule]", 
           RowBox[{"2", "g", " ", "z"}]}]}], "/.", 
         RowBox[{"TaylorOptions", "[", 
          RowBox[{
           RowBox[{"Variable", "\[Rule]", "g"}], ",", 
           RowBox[{"Order", "\[Rule]", "8"}], ",", 
           RowBox[{"\[Eta]Factor", "\[Rule]", 
            RowBox[{"2", "z"}]}]}], "]"}]}], "/.", 
        RowBox[{
         SqrtBox[
          RowBox[{"4", "-", 
           RowBox[{"4", " ", 
            SuperscriptBox["z", "2"]}]}]], "\[Rule]", 
         RowBox[{"2", 
          SqrtBox[
           RowBox[{"1", "-", 
            SuperscriptBox["z", "2"]}]]}]}]}], "//.", "denz"}], "//.", 
      "subZetaReduce"}], ",", "zlist", ",", "Simplify"}], "]"}]}], 
  "\[IndentingNewLine]"}]], "Input",
 CellChangeTimes->{{3.562941511658555*^9, 3.562941701460149*^9}, {
  3.562956359149828*^9, 3.562956361451132*^9}, {3.5629572486402597`*^9, 
  3.562957249472123*^9}, {3.562957316741755*^9, 3.562957317153191*^9}, {
  3.5629977501662407`*^9, 3.562997763757565*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   SuperscriptBox["g", "6"], " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{
      RowBox[{"-", "3"}], " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "3"}], "+", 
        RowBox[{"2", " ", 
         SubscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "2"]}]}], ")"}], " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "3"}], "+", 
        RowBox[{"2", " ", 
         SubscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "3"]}]}], ")"}]}], "+", 
     RowBox[{"6", " ", 
      SuperscriptBox["z", "2"], " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "3"}], "+", 
        RowBox[{"2", " ", 
         SubscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "2"]}]}], ")"}], " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "3"}], "+", 
        RowBox[{"2", " ", 
         SubscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "3"]}]}], ")"}]}], "-", 
     RowBox[{"6", " ", "\[ImaginaryI]", " ", "z", " ", 
      SqrtBox[
       RowBox[{"1", "-", 
        SuperscriptBox["z", "2"]}]], " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "3"}], "+", 
        RowBox[{"2", " ", 
         SubscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "2"]}]}], ")"}], " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "3"}], "+", 
        RowBox[{"2", " ", 
         SubscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "3"]}]}], ")"}]}]}], ")"}]}], "+", 
  RowBox[{
   SuperscriptBox["g", "8"], " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{
      FractionBox["72", "5"], " ", 
      SuperscriptBox["z", "4"], " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"8", " ", 
         SubsuperscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "2", "2"], " ", 
         SubscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "3"]}], "+", 
        RowBox[{
         SubscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "2"], " ", 
         RowBox[{"(", 
          RowBox[{"60", "-", 
           RowBox[{"40", " ", 
            SubscriptBox[
             StyleBox["\[Zeta]",
              FontWeight->Bold,
              FontColor->GrayLevel[0.4]], "5"]}]}], ")"}]}], "-", 
        RowBox[{"15", " ", 
         RowBox[{"(", 
          RowBox[{"3", "+", 
           RowBox[{"4", " ", 
            SubscriptBox[
             StyleBox["\[Zeta]",
              FontWeight->Bold,
              FontColor->GrayLevel[0.4]], "3"]}], "-", 
           RowBox[{"4", " ", 
            SubscriptBox[
             StyleBox["\[Zeta]",
              FontWeight->Bold,
              FontColor->GrayLevel[0.4]], "5"]}]}], ")"}]}]}], ")"}]}], "+", 
     RowBox[{
      FractionBox["6", "5"], " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"36", " ", 
         SubsuperscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "2", "3"]}], "+", 
        RowBox[{"12", " ", 
         SubsuperscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "2", "2"], " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"-", "6"}], "+", 
           SubscriptBox[
            StyleBox["\[Zeta]",
             FontWeight->Bold,
             FontColor->GrayLevel[0.4]], "3"]}], ")"}]}], "-", 
        RowBox[{"10", " ", 
         SubscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "2"], " ", 
         RowBox[{"(", 
          RowBox[{"3", "+", 
           RowBox[{"8", " ", 
            SubscriptBox[
             StyleBox["\[Zeta]",
              FontWeight->Bold,
              FontColor->GrayLevel[0.4]], "3"]}], "-", 
           RowBox[{"3", " ", 
            SubscriptBox[
             StyleBox["\[Zeta]",
              FontWeight->Bold,
              FontColor->GrayLevel[0.4]], "5"]}]}], ")"}]}], "+", 
        RowBox[{"15", " ", 
         RowBox[{"(", 
          RowBox[{"27", "-", 
           RowBox[{"26", " ", 
            SubscriptBox[
             StyleBox["\[Zeta]",
              FontWeight->Bold,
              FontColor->GrayLevel[0.4]], "3"]}], "+", 
           RowBox[{"12", " ", 
            SubsuperscriptBox[
             StyleBox["\[Zeta]",
              FontWeight->Bold,
              FontColor->GrayLevel[0.4]], "3", "2"]}], "-", 
           RowBox[{"3", " ", 
            SubscriptBox[
             StyleBox["\[Zeta]",
              FontWeight->Bold,
              FontColor->GrayLevel[0.4]], "5"]}]}], ")"}]}]}], ")"}]}], "-", 
     RowBox[{
      FractionBox["6", "5"], " ", 
      SuperscriptBox["z", "2"], " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"72", " ", 
         SubsuperscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "2", "3"]}], "+", 
        RowBox[{"24", " ", 
         SubsuperscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "2", "2"], " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"-", "5"}], "+", 
           RowBox[{"2", " ", 
            SubscriptBox[
             StyleBox["\[Zeta]",
              FontWeight->Bold,
              FontColor->GrayLevel[0.4]], "3"]}]}], ")"}]}], "-", 
        RowBox[{"10", " ", 
         SubscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "2"], " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"-", "39"}], "+", 
           RowBox[{"22", " ", 
            SubscriptBox[
             StyleBox["\[Zeta]",
              FontWeight->Bold,
              FontColor->GrayLevel[0.4]], "3"]}], "+", 
           RowBox[{"10", " ", 
            SubscriptBox[
             StyleBox["\[Zeta]",
              FontWeight->Bold,
              FontColor->GrayLevel[0.4]], "5"]}]}], ")"}]}], "+", 
        RowBox[{"15", " ", 
         RowBox[{"(", 
          RowBox[{"27", "-", 
           RowBox[{"70", " ", 
            SubscriptBox[
             StyleBox["\[Zeta]",
              FontWeight->Bold,
              FontColor->GrayLevel[0.4]], "3"]}], "+", 
           RowBox[{"24", " ", 
            SubsuperscriptBox[
             StyleBox["\[Zeta]",
              FontWeight->Bold,
              FontColor->GrayLevel[0.4]], "3", "2"]}], "+", 
           RowBox[{"10", " ", 
            SubscriptBox[
             StyleBox["\[Zeta]",
              FontWeight->Bold,
              FontColor->GrayLevel[0.4]], "5"]}]}], ")"}]}]}], ")"}]}], "+", 
     RowBox[{
      SqrtBox[
       RowBox[{"1", "-", 
        SuperscriptBox["z", "2"]}]], " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         RowBox[{"-", 
          FractionBox["72", "5"]}], " ", "\[ImaginaryI]", " ", 
         SuperscriptBox["z", "3"], " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"8", " ", 
            SubsuperscriptBox[
             StyleBox["\[Zeta]",
              FontWeight->Bold,
              FontColor->GrayLevel[0.4]], "2", "2"], " ", 
            SubscriptBox[
             StyleBox["\[Zeta]",
              FontWeight->Bold,
              FontColor->GrayLevel[0.4]], "3"]}], "+", 
           RowBox[{
            SubscriptBox[
             StyleBox["\[Zeta]",
              FontWeight->Bold,
              FontColor->GrayLevel[0.4]], "2"], " ", 
            RowBox[{"(", 
             RowBox[{"60", "-", 
              RowBox[{"40", " ", 
               SubscriptBox[
                StyleBox["\[Zeta]",
                 FontWeight->Bold,
                 FontColor->GrayLevel[0.4]], "5"]}]}], ")"}]}], "-", 
           RowBox[{"15", " ", 
            RowBox[{"(", 
             RowBox[{"3", "+", 
              RowBox[{"4", " ", 
               SubscriptBox[
                StyleBox["\[Zeta]",
                 FontWeight->Bold,
                 FontColor->GrayLevel[0.4]], "3"]}], "-", 
              RowBox[{"4", " ", 
               SubscriptBox[
                StyleBox["\[Zeta]",
                 FontWeight->Bold,
                 FontColor->GrayLevel[0.4]], "5"]}]}], ")"}]}]}], ")"}]}], 
        "+", 
        RowBox[{
         FractionBox["6", "5"], " ", "\[ImaginaryI]", " ", "z", " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{
            RowBox[{"-", "120"}], " ", 
            SubsuperscriptBox[
             StyleBox["\[Zeta]",
              FontWeight->Bold,
              FontColor->GrayLevel[0.4]], "2", "2"]}], "+", 
           RowBox[{"72", " ", 
            SubsuperscriptBox[
             StyleBox["\[Zeta]",
              FontWeight->Bold,
              FontColor->GrayLevel[0.4]], "2", "3"]}], "+", 
           RowBox[{"15", " ", 
            RowBox[{"(", 
             RowBox[{"45", "-", 
              RowBox[{"46", " ", 
               SubscriptBox[
                StyleBox["\[Zeta]",
                 FontWeight->Bold,
                 FontColor->GrayLevel[0.4]], "3"]}], "+", 
              RowBox[{"24", " ", 
               SubsuperscriptBox[
                StyleBox["\[Zeta]",
                 FontWeight->Bold,
                 FontColor->GrayLevel[0.4]], "3", "2"]}], "-", 
              RowBox[{"14", " ", 
               SubscriptBox[
                StyleBox["\[Zeta]",
                 FontWeight->Bold,
                 FontColor->GrayLevel[0.4]], "5"]}]}], ")"}]}], "+", 
           RowBox[{
            SubscriptBox[
             StyleBox["\[Zeta]",
              FontWeight->Bold,
              FontColor->GrayLevel[0.4]], "2"], " ", 
            RowBox[{"(", 
             RowBox[{"30", "-", 
              RowBox[{"220", " ", 
               SubscriptBox[
                StyleBox["\[Zeta]",
                 FontWeight->Bold,
                 FontColor->GrayLevel[0.4]], "3"]}], "+", 
              RowBox[{"140", " ", 
               SubscriptBox[
                StyleBox["\[Zeta]",
                 FontWeight->Bold,
                 FontColor->GrayLevel[0.4]], "5"]}]}], ")"}]}]}], ")"}]}]}], 
       ")"}]}]}], ")"}]}]}]], "Output",
 CellChangeTimes->{{3.562941537524865*^9, 3.562941541954225*^9}, {
   3.5629415757833757`*^9, 3.5629416088605633`*^9}, {3.562941640709401*^9, 
   3.5629417023243856`*^9}, 3.5629564195034647`*^9, 3.5629572509851294`*^9, 
   3.5629573178097467`*^9, {3.562997741692691*^9, 3.562997772071649*^9}}]
}, Open  ]],

Cell["\<\
We will now perform integration. Only leading order is needed. But at leading \
order integral is zero, due to symmetric reasons! Hence we do not need to \
compute any integrals\
\>", "Text",
 CellChangeTimes->{{3.562957265842731*^9, 3.562957272410654*^9}, {
  3.562997789824093*^9, 3.562997795111912*^9}, {3.562998071996196*^9, 
  3.562998118538311*^9}}],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"SortBy", "[", 
    RowBox[{
     RowBox[{"List", "@@", 
      RowBox[{"Collect", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"Collect", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              SubscriptBox["q", 
               RowBox[{"2", ",", "\"\<as\>\""}]], "/.", 
              RowBox[{"asdsweak", "[", "5", "]"}]}], ")"}], "+", "Mterm", "+",
             "tmpWres"}], ",", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"zlist", ",", "\[Zeta]list"}], "}"}], "//", 
            "Flatten"}]}], "]"}], "/.", 
         RowBox[{
          SuperscriptBox["g", "a_."], "\[RuleDelayed]", 
          RowBox[{
           SuperscriptBox["g", 
            RowBox[{"a", " "}]], 
           SuperscriptBox["AAA", 
            RowBox[{
             RowBox[{"Floor", "[", 
              RowBox[{
               RowBox[{"a", "/", "2"}], "+", 
               RowBox[{"1", "/", "2"}]}], "]"}], "+", "1"}]]}]}]}], ",", 
        "AAA"}], "]"}]}], ",", 
     RowBox[{
      RowBox[{"Exponent", "[", 
       RowBox[{"#", ",", "AAA"}], "]"}], "&"}]}], "]"}], "/.", 
   RowBox[{"AAA", "\[Rule]", "1"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"tmp", "=", 
  RowBox[{"(", 
   RowBox[{
    RowBox[{
     RowBox[{"Collect", "[", 
      RowBox[{"#", ",", "g", ",", "Hold"}], "]"}], "&"}], "/@", "%"}], 
   ")"}]}]}], "Input",
 CellChangeTimes->{{3.562998147886595*^9, 3.562998346045611*^9}, {
  3.562998379060688*^9, 3.562998454304064*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   FractionBox[
    RowBox[{"Hold", "[", 
     RowBox[{
      RowBox[{"-", 
       FractionBox[
        RowBox[{"\[ImaginaryI]", " ", "z"}], "3"]}], "-", 
      FractionBox[
       SqrtBox[
        RowBox[{"1", "-", 
         SuperscriptBox["z", "2"]}]], "3"]}], "]"}], "g"], ",", 
   RowBox[{"g", " ", 
    RowBox[{"Hold", "[", 
     RowBox[{
      RowBox[{"-", 
       FractionBox[
        RowBox[{"10", " ", "\[ImaginaryI]", " ", "z"}], "3"]}], "-", 
      FractionBox[
       RowBox[{"4", " ", 
        SqrtBox[
         RowBox[{"1", "-", 
          SuperscriptBox["z", "2"]}]]}], "3"]}], "]"}]}], ",", 
   RowBox[{
    SuperscriptBox["g", "3"], " ", 
    RowBox[{"Hold", "[", 
     RowBox[{
      RowBox[{"4", " ", "\[ImaginaryI]", " ", "z"}], "+", 
      RowBox[{"4", " ", 
       SqrtBox[
        RowBox[{"1", "-", 
         SuperscriptBox["z", "2"]}]]}]}], "]"}]}], ",", 
   RowBox[{
    RowBox[{
     SuperscriptBox["g", "5"], " ", 
     RowBox[{"Hold", "[", 
      RowBox[{
       RowBox[{
        SqrtBox[
         RowBox[{"1", "-", 
          SuperscriptBox["z", "2"]}]], " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"-", "25"}], "-", 
          RowBox[{"8", " ", 
           SubscriptBox[
            StyleBox["\[Zeta]",
             FontWeight->Bold,
             FontColor->GrayLevel[0.4]], "3"]}]}], ")"}]}], "+", 
       RowBox[{"z", " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{
           RowBox[{"-", "25"}], " ", "\[ImaginaryI]"}], "-", 
          RowBox[{"8", " ", "\[ImaginaryI]", " ", 
           SubscriptBox[
            StyleBox["\[Zeta]",
             FontWeight->Bold,
             FontColor->GrayLevel[0.4]], "3"]}]}], ")"}]}]}], "]"}]}], "+", 
    RowBox[{
     SuperscriptBox["g", "6"], " ", 
     RowBox[{"Hold", "[", 
      RowBox[{
       RowBox[{"-", "27"}], "+", 
       RowBox[{"18", " ", 
        SubscriptBox[
         StyleBox["\[Zeta]",
          FontWeight->Bold,
          FontColor->GrayLevel[0.4]], "2"]}], "+", 
       RowBox[{"18", " ", 
        SubscriptBox[
         StyleBox["\[Zeta]",
          FontWeight->Bold,
          FontColor->GrayLevel[0.4]], "3"]}], "-", 
       RowBox[{"12", " ", 
        SubscriptBox[
         StyleBox["\[Zeta]",
          FontWeight->Bold,
          FontColor->GrayLevel[0.4]], "2"], " ", 
        SubscriptBox[
         StyleBox["\[Zeta]",
          FontWeight->Bold,
          FontColor->GrayLevel[0.4]], "3"]}], "+", 
       RowBox[{"z", " ", 
        SqrtBox[
         RowBox[{"1", "-", 
          SuperscriptBox["z", "2"]}]], " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{
           RowBox[{"-", "54"}], " ", "\[ImaginaryI]"}], "+", 
          RowBox[{"36", " ", "\[ImaginaryI]", " ", 
           SubscriptBox[
            StyleBox["\[Zeta]",
             FontWeight->Bold,
             FontColor->GrayLevel[0.4]], "2"]}], "+", 
          RowBox[{"36", " ", "\[ImaginaryI]", " ", 
           SubscriptBox[
            StyleBox["\[Zeta]",
             FontWeight->Bold,
             FontColor->GrayLevel[0.4]], "3"]}], "-", 
          RowBox[{"24", " ", "\[ImaginaryI]", " ", 
           SubscriptBox[
            StyleBox["\[Zeta]",
             FontWeight->Bold,
             FontColor->GrayLevel[0.4]], "2"], " ", 
           SubscriptBox[
            StyleBox["\[Zeta]",
             FontWeight->Bold,
             FontColor->GrayLevel[0.4]], "3"]}]}], ")"}]}], "+", 
       RowBox[{
        SuperscriptBox["z", "2"], " ", 
        RowBox[{"(", 
         RowBox[{"54", "-", 
          RowBox[{"36", " ", 
           SubscriptBox[
            StyleBox["\[Zeta]",
             FontWeight->Bold,
             FontColor->GrayLevel[0.4]], "2"]}], "-", 
          RowBox[{"36", " ", 
           SubscriptBox[
            StyleBox["\[Zeta]",
             FontWeight->Bold,
             FontColor->GrayLevel[0.4]], "3"]}], "+", 
          RowBox[{"24", " ", 
           SubscriptBox[
            StyleBox["\[Zeta]",
             FontWeight->Bold,
             FontColor->GrayLevel[0.4]], "2"], " ", 
           SubscriptBox[
            StyleBox["\[Zeta]",
             FontWeight->Bold,
             FontColor->GrayLevel[0.4]], "3"]}]}], ")"}]}]}], "]"}]}]}], ",", 
   
   RowBox[{
    RowBox[{
     SuperscriptBox["g", "8"], " ", 
     RowBox[{"Hold", "[", 
      RowBox[{"486", "-", 
       RowBox[{"36", " ", 
        SubscriptBox[
         StyleBox["\[Zeta]",
          FontWeight->Bold,
          FontColor->GrayLevel[0.4]], "2"]}], "-", 
       FractionBox[
        RowBox[{"432", " ", 
         SubsuperscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "2", "2"]}], "5"], "+", 
       FractionBox[
        RowBox[{"216", " ", 
         SubsuperscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "2", "3"]}], "5"], "-", 
       RowBox[{"468", " ", 
        SubscriptBox[
         StyleBox["\[Zeta]",
          FontWeight->Bold,
          FontColor->GrayLevel[0.4]], "3"]}], "-", 
       RowBox[{"96", " ", 
        SubscriptBox[
         StyleBox["\[Zeta]",
          FontWeight->Bold,
          FontColor->GrayLevel[0.4]], "2"], " ", 
        SubscriptBox[
         StyleBox["\[Zeta]",
          FontWeight->Bold,
          FontColor->GrayLevel[0.4]], "3"]}], "+", 
       RowBox[{
        FractionBox["72", "5"], " ", 
        SubsuperscriptBox[
         StyleBox["\[Zeta]",
          FontWeight->Bold,
          FontColor->GrayLevel[0.4]], "2", "2"], " ", 
        SubscriptBox[
         StyleBox["\[Zeta]",
          FontWeight->Bold,
          FontColor->GrayLevel[0.4]], "3"]}], "+", 
       RowBox[{"216", " ", 
        SubsuperscriptBox[
         StyleBox["\[Zeta]",
          FontWeight->Bold,
          FontColor->GrayLevel[0.4]], "3", "2"]}], "-", 
       RowBox[{"54", " ", 
        SubscriptBox[
         StyleBox["\[Zeta]",
          FontWeight->Bold,
          FontColor->GrayLevel[0.4]], "5"]}], "+", 
       RowBox[{"36", " ", 
        SubscriptBox[
         StyleBox["\[Zeta]",
          FontWeight->Bold,
          FontColor->GrayLevel[0.4]], "2"], " ", 
        SubscriptBox[
         StyleBox["\[Zeta]",
          FontWeight->Bold,
          FontColor->GrayLevel[0.4]], "5"]}], "+", 
       RowBox[{
        SuperscriptBox["z", "4"], " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"-", "648"}], "+", 
          RowBox[{"864", " ", 
           SubscriptBox[
            StyleBox["\[Zeta]",
             FontWeight->Bold,
             FontColor->GrayLevel[0.4]], "2"]}], "-", 
          RowBox[{"864", " ", 
           SubscriptBox[
            StyleBox["\[Zeta]",
             FontWeight->Bold,
             FontColor->GrayLevel[0.4]], "3"]}], "+", 
          RowBox[{
           FractionBox["576", "5"], " ", 
           SubsuperscriptBox[
            StyleBox["\[Zeta]",
             FontWeight->Bold,
             FontColor->GrayLevel[0.4]], "2", "2"], " ", 
           SubscriptBox[
            StyleBox["\[Zeta]",
             FontWeight->Bold,
             FontColor->GrayLevel[0.4]], "3"]}], "+", 
          RowBox[{"864", " ", 
           SubscriptBox[
            StyleBox["\[Zeta]",
             FontWeight->Bold,
             FontColor->GrayLevel[0.4]], "5"]}], "-", 
          RowBox[{"576", " ", 
           SubscriptBox[
            StyleBox["\[Zeta]",
             FontWeight->Bold,
             FontColor->GrayLevel[0.4]], "2"], " ", 
           SubscriptBox[
            StyleBox["\[Zeta]",
             FontWeight->Bold,
             FontColor->GrayLevel[0.4]], "5"]}]}], ")"}]}], "+", 
       RowBox[{
        SuperscriptBox["z", "2"], " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"-", "486"}], "-", 
          RowBox[{"468", " ", 
           SubscriptBox[
            StyleBox["\[Zeta]",
             FontWeight->Bold,
             FontColor->GrayLevel[0.4]], "2"]}], "+", 
          RowBox[{"144", " ", 
           SubsuperscriptBox[
            StyleBox["\[Zeta]",
             FontWeight->Bold,
             FontColor->GrayLevel[0.4]], "2", "2"]}], "-", 
          FractionBox[
           RowBox[{"432", " ", 
            SubsuperscriptBox[
             StyleBox["\[Zeta]",
              FontWeight->Bold,
              FontColor->GrayLevel[0.4]], "2", "3"]}], "5"], "+", 
          RowBox[{"1260", " ", 
           SubscriptBox[
            StyleBox["\[Zeta]",
             FontWeight->Bold,
             FontColor->GrayLevel[0.4]], "3"]}], "+", 
          RowBox[{"264", " ", 
           SubscriptBox[
            StyleBox["\[Zeta]",
             FontWeight->Bold,
             FontColor->GrayLevel[0.4]], "2"], " ", 
           SubscriptBox[
            StyleBox["\[Zeta]",
             FontWeight->Bold,
             FontColor->GrayLevel[0.4]], "3"]}], "-", 
          RowBox[{
           FractionBox["288", "5"], " ", 
           SubsuperscriptBox[
            StyleBox["\[Zeta]",
             FontWeight->Bold,
             FontColor->GrayLevel[0.4]], "2", "2"], " ", 
           SubscriptBox[
            StyleBox["\[Zeta]",
             FontWeight->Bold,
             FontColor->GrayLevel[0.4]], "3"]}], "-", 
          RowBox[{"432", " ", 
           SubsuperscriptBox[
            StyleBox["\[Zeta]",
             FontWeight->Bold,
             FontColor->GrayLevel[0.4]], "3", "2"]}], "-", 
          RowBox[{"180", " ", 
           SubscriptBox[
            StyleBox["\[Zeta]",
             FontWeight->Bold,
             FontColor->GrayLevel[0.4]], "5"]}], "+", 
          RowBox[{"120", " ", 
           SubscriptBox[
            StyleBox["\[Zeta]",
             FontWeight->Bold,
             FontColor->GrayLevel[0.4]], "2"], " ", 
           SubscriptBox[
            StyleBox["\[Zeta]",
             FontWeight->Bold,
             FontColor->GrayLevel[0.4]], "5"]}]}], ")"}]}], "+", 
       RowBox[{
        SqrtBox[
         RowBox[{"1", "-", 
          SuperscriptBox["z", "2"]}]], " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"z", " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"810", " ", "\[ImaginaryI]"}], "+", 
             RowBox[{"36", " ", "\[ImaginaryI]", " ", 
              SubscriptBox[
               StyleBox["\[Zeta]",
                FontWeight->Bold,
                FontColor->GrayLevel[0.4]], "2"]}], "-", 
             RowBox[{"144", " ", "\[ImaginaryI]", " ", 
              SubsuperscriptBox[
               StyleBox["\[Zeta]",
                FontWeight->Bold,
                FontColor->GrayLevel[0.4]], "2", "2"]}], "+", 
             FractionBox[
              RowBox[{"432", " ", "\[ImaginaryI]", " ", 
               SubsuperscriptBox[
                StyleBox["\[Zeta]",
                 FontWeight->Bold,
                 FontColor->GrayLevel[0.4]], "2", "3"]}], "5"], "-", 
             RowBox[{"828", " ", "\[ImaginaryI]", " ", 
              SubscriptBox[
               StyleBox["\[Zeta]",
                FontWeight->Bold,
                FontColor->GrayLevel[0.4]], "3"]}], "-", 
             RowBox[{"264", " ", "\[ImaginaryI]", " ", 
              SubscriptBox[
               StyleBox["\[Zeta]",
                FontWeight->Bold,
                FontColor->GrayLevel[0.4]], "2"], " ", 
              SubscriptBox[
               StyleBox["\[Zeta]",
                FontWeight->Bold,
                FontColor->GrayLevel[0.4]], "3"]}], "+", 
             RowBox[{"432", " ", "\[ImaginaryI]", " ", 
              SubsuperscriptBox[
               StyleBox["\[Zeta]",
                FontWeight->Bold,
                FontColor->GrayLevel[0.4]], "3", "2"]}], "-", 
             RowBox[{"252", " ", "\[ImaginaryI]", " ", 
              SubscriptBox[
               StyleBox["\[Zeta]",
                FontWeight->Bold,
                FontColor->GrayLevel[0.4]], "5"]}], "+", 
             RowBox[{"168", " ", "\[ImaginaryI]", " ", 
              SubscriptBox[
               StyleBox["\[Zeta]",
                FontWeight->Bold,
                FontColor->GrayLevel[0.4]], "2"], " ", 
              SubscriptBox[
               StyleBox["\[Zeta]",
                FontWeight->Bold,
                FontColor->GrayLevel[0.4]], "5"]}]}], ")"}]}], "+", 
          RowBox[{
           SuperscriptBox["z", "3"], " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"648", " ", "\[ImaginaryI]"}], "-", 
             RowBox[{"864", " ", "\[ImaginaryI]", " ", 
              SubscriptBox[
               StyleBox["\[Zeta]",
                FontWeight->Bold,
                FontColor->GrayLevel[0.4]], "2"]}], "+", 
             RowBox[{"864", " ", "\[ImaginaryI]", " ", 
              SubscriptBox[
               StyleBox["\[Zeta]",
                FontWeight->Bold,
                FontColor->GrayLevel[0.4]], "3"]}], "-", 
             RowBox[{
              FractionBox["576", "5"], " ", "\[ImaginaryI]", " ", 
              SubsuperscriptBox[
               StyleBox["\[Zeta]",
                FontWeight->Bold,
                FontColor->GrayLevel[0.4]], "2", "2"], " ", 
              SubscriptBox[
               StyleBox["\[Zeta]",
                FontWeight->Bold,
                FontColor->GrayLevel[0.4]], "3"]}], "-", 
             RowBox[{"864", " ", "\[ImaginaryI]", " ", 
              SubscriptBox[
               StyleBox["\[Zeta]",
                FontWeight->Bold,
                FontColor->GrayLevel[0.4]], "5"]}], "+", 
             RowBox[{"576", " ", "\[ImaginaryI]", " ", 
              SubscriptBox[
               StyleBox["\[Zeta]",
                FontWeight->Bold,
                FontColor->GrayLevel[0.4]], "2"], " ", 
              SubscriptBox[
               StyleBox["\[Zeta]",
                FontWeight->Bold,
                FontColor->GrayLevel[0.4]], "5"]}]}], ")"}]}]}], ")"}]}]}], 
      "]"}]}], "+", 
    RowBox[{
     SuperscriptBox["g", "7"], " ", 
     RowBox[{"Hold", "[", 
      RowBox[{
       RowBox[{"z", " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{
           RowBox[{"-", "41"}], " ", "\[ImaginaryI]"}], "+", 
          RowBox[{"108", " ", "\[ImaginaryI]", " ", 
           SubscriptBox[
            StyleBox["\[Zeta]",
             FontWeight->Bold,
             FontColor->GrayLevel[0.4]], "2"]}], "-", 
          RowBox[{"36", " ", "\[ImaginaryI]", " ", 
           SubsuperscriptBox[
            StyleBox["\[Zeta]",
             FontWeight->Bold,
             FontColor->GrayLevel[0.4]], "2", "2"]}], "-", 
          FractionBox[
           RowBox[{"328", " ", "\[ImaginaryI]", " ", 
            SubsuperscriptBox[
             StyleBox["\[Zeta]",
              FontWeight->Bold,
              FontColor->GrayLevel[0.4]], "2", "3"]}], "7"], "-", 
          RowBox[{"340", " ", "\[ImaginaryI]", " ", 
           SubscriptBox[
            StyleBox["\[Zeta]",
             FontWeight->Bold,
             FontColor->GrayLevel[0.4]], "3"]}], "-", 
          RowBox[{"120", " ", "\[ImaginaryI]", " ", 
           SubsuperscriptBox[
            StyleBox["\[Zeta]",
             FontWeight->Bold,
             FontColor->GrayLevel[0.4]], "3", "2"]}], "+", 
          RowBox[{"856", " ", "\[ImaginaryI]", " ", 
           SubscriptBox[
            StyleBox["\[Zeta]",
             FontWeight->Bold,
             FontColor->GrayLevel[0.4]], "5"]}], "+", 
          RowBox[{"252", " ", "\[ImaginaryI]", " ", 
           SubscriptBox[
            StyleBox["\[Zeta]",
             FontWeight->Bold,
             FontColor->GrayLevel[0.4]], "7"]}]}], ")"}]}], "+", 
       RowBox[{
        SuperscriptBox["z", "3"], " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"216", " ", "\[ImaginaryI]"}], "-", 
          RowBox[{"216", " ", "\[ImaginaryI]", " ", 
           SubscriptBox[
            StyleBox["\[Zeta]",
             FontWeight->Bold,
             FontColor->GrayLevel[0.4]], "2"]}], "+", 
          FractionBox[
           RowBox[{"432", " ", "\[ImaginaryI]", " ", 
            SubsuperscriptBox[
             StyleBox["\[Zeta]",
              FontWeight->Bold,
              FontColor->GrayLevel[0.4]], "2", "2"]}], "5"], "+", 
          FractionBox[
           RowBox[{"3936", " ", "\[ImaginaryI]", " ", 
            SubsuperscriptBox[
             StyleBox["\[Zeta]",
              FontWeight->Bold,
              FontColor->GrayLevel[0.4]], "2", "3"]}], "35"], "+", 
          RowBox[{"72", " ", "\[ImaginaryI]", " ", 
           SubscriptBox[
            StyleBox["\[Zeta]",
             FontWeight->Bold,
             FontColor->GrayLevel[0.4]], "3"]}], "+", 
          RowBox[{"288", " ", "\[ImaginaryI]", " ", 
           SubsuperscriptBox[
            StyleBox["\[Zeta]",
             FontWeight->Bold,
             FontColor->GrayLevel[0.4]], "3", "2"]}], "-", 
          RowBox[{"768", " ", "\[ImaginaryI]", " ", 
           SubscriptBox[
            StyleBox["\[Zeta]",
             FontWeight->Bold,
             FontColor->GrayLevel[0.4]], "5"]}], "-", 
          RowBox[{"336", " ", "\[ImaginaryI]", " ", 
           SubscriptBox[
            StyleBox["\[Zeta]",
             FontWeight->Bold,
             FontColor->GrayLevel[0.4]], "7"]}]}], ")"}]}], "+", 
       RowBox[{
        SqrtBox[
         RowBox[{"1", "-", 
          SuperscriptBox["z", "2"]}]], " ", 
        RowBox[{"(", 
         RowBox[{"67", "+", 
          FractionBox[
           RowBox[{"36", " ", 
            SubsuperscriptBox[
             StyleBox["\[Zeta]",
              FontWeight->Bold,
              FontColor->GrayLevel[0.4]], "2", "2"]}], "5"], "+", 
          FractionBox[
           RowBox[{"328", " ", 
            SubsuperscriptBox[
             StyleBox["\[Zeta]",
              FontWeight->Bold,
              FontColor->GrayLevel[0.4]], "2", "3"]}], "35"], "-", 
          RowBox[{"304", " ", 
           SubscriptBox[
            StyleBox["\[Zeta]",
             FontWeight->Bold,
             FontColor->GrayLevel[0.4]], "3"]}], "+", 
          RowBox[{"24", " ", 
           SubsuperscriptBox[
            StyleBox["\[Zeta]",
             FontWeight->Bold,
             FontColor->GrayLevel[0.4]], "3", "2"]}], "+", 
          RowBox[{"472", " ", 
           SubscriptBox[
            StyleBox["\[Zeta]",
             FontWeight->Bold,
             FontColor->GrayLevel[0.4]], "5"]}], "+", 
          RowBox[{
           SuperscriptBox["z", "2"], " ", 
           RowBox[{"(", 
            RowBox[{"216", "-", 
             RowBox[{"216", " ", 
              SubscriptBox[
               StyleBox["\[Zeta]",
                FontWeight->Bold,
                FontColor->GrayLevel[0.4]], "2"]}], "+", 
             FractionBox[
              RowBox[{"432", " ", 
               SubsuperscriptBox[
                StyleBox["\[Zeta]",
                 FontWeight->Bold,
                 FontColor->GrayLevel[0.4]], "2", "2"]}], "5"], "+", 
             FractionBox[
              RowBox[{"3936", " ", 
               SubsuperscriptBox[
                StyleBox["\[Zeta]",
                 FontWeight->Bold,
                 FontColor->GrayLevel[0.4]], "2", "3"]}], "35"], "+", 
             RowBox[{"72", " ", 
              SubscriptBox[
               StyleBox["\[Zeta]",
                FontWeight->Bold,
                FontColor->GrayLevel[0.4]], "3"]}], "+", 
             RowBox[{"288", " ", 
              SubsuperscriptBox[
               StyleBox["\[Zeta]",
                FontWeight->Bold,
                FontColor->GrayLevel[0.4]], "3", "2"]}], "-", 
             RowBox[{"768", " ", 
              SubscriptBox[
               StyleBox["\[Zeta]",
                FontWeight->Bold,
                FontColor->GrayLevel[0.4]], "5"]}], "-", 
             RowBox[{"336", " ", 
              SubscriptBox[
               StyleBox["\[Zeta]",
                FontWeight->Bold,
                FontColor->GrayLevel[0.4]], "7"]}]}], ")"}]}], "+", 
          RowBox[{"84", " ", 
           SubscriptBox[
            StyleBox["\[Zeta]",
             FontWeight->Bold,
             FontColor->GrayLevel[0.4]], "7"]}]}], ")"}]}]}], "]"}]}]}]}], 
  "}"}]], "Output",
 CellChangeTimes->{{3.562998157717149*^9, 3.562998247234288*^9}, {
  3.5629983158578453`*^9, 3.56299834649757*^9}, {3.5629983802395144`*^9, 
  3.562998454816156*^9}}]
}, Open  ]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Computing normalization of U", "Subsection",
 CellChangeTimes->{{3.562938987031782*^9, 3.5629389919257317`*^9}, {
  3.562998890393475*^9, 3.562998892345392*^9}, {3.563300807107538*^9, 
  3.563300807560355*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"+", 
   RowBox[{"Log", "[", 
    SubscriptBox[
     RowBox[{"(", 
      RowBox[{
       SuperscriptBox[
        StyleBox["U",
         FontColor->RGBColor[0, 0.6, 0]], 
        RowBox[{"[", "2", "]"}]], 
       SuperscriptBox[
        OverscriptBox[
         StyleBox["U",
          FontColor->RGBColor[0, 0.6, 0]], 
         StyleBox["_",
          FontColor->RGBColor[0, 0.6, 0]]], 
        RowBox[{"[", 
         RowBox[{"-", "2"}], "]"}]]}], ")"}], "r"], "]"}]}], "\[Equal]", 
  RowBox[{
   RowBox[{"Log", "[", 
    RowBox[{
     RowBox[{"(", 
      FractionBox[
       SubscriptBox[
        RowBox[{"(", 
         RowBox[{"1", "-", 
          RowBox[{
           SubscriptBox["Y", 
            RowBox[{"1", ",", "1"}]], 
           SubscriptBox["Y", 
            RowBox[{"2", ",", "2"}]]}]}], ")"}], "r"], 
       SubscriptBox[
        RowBox[{"(", 
         SubsuperscriptBox["\[GothicCapitalT]", 
          RowBox[{"0", ",", "1"}], "c"], ")"}], "r"]], ")"}], 
     SubscriptBox[
      RowBox[{"(", 
       RowBox[{
        SuperscriptBox[
         StyleBox["\[GothicCapitalT]",
          FontColor->RGBColor[0.54, 0.35, 0.15]], "-"], 
        SuperscriptBox[
         StyleBox["\[GothicCapitalT]",
          FontColor->RGBColor[0.54, 0.35, 0.15]], "+"]}], " ", ")"}], "r"]}], 
    "]"}], "+", 
   RowBox[{"Log", "[", 
    SubscriptBox[
     RowBox[{"(", 
      SubscriptBox[
       StyleBox["\[GothicCapitalT]",
        FontColor->RGBColor[0.54, 0.35, 0.15]], 
       RowBox[{"1", ",", "0"}]], ")"}], "r"], "]"}], "+", 
   RowBox[{"\[DoubleStruckCapitalC]", "[", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       FractionBox["2", "u"], "-", 
       FractionBox[
        RowBox[{"2", " ", "\[ImaginaryI]"}], 
        RowBox[{"1", "+", 
         SuperscriptBox["u", "2"]}]]}], ")"}], "H"}], "]"}], "+", 
   RowBox[{"\[DoubleStruckCapitalC]", "[", 
    RowBox[{
     FractionBox["4", "u"], 
     RowBox[{"Log", "[", 
      SubscriptBox[
       RowBox[{"(", 
        SuperscriptBox[
         StyleBox["\[GothicCapitalT]",
          FontColor->RGBColor[0.54, 0.35, 0.15]], "+"], ")"}], "r"], "]"}]}], 
    "]"}], "-", 
   RowBox[{"Log", "[", 
    SubscriptBox[
     RowBox[{"(", 
      RowBox[{
       SuperscriptBox[
        StyleBox["\[ScriptCapitalT]",
         FontColor->RGBColor[1, 0, 0]], "-"], 
       SuperscriptBox[
        StyleBox["\[ScriptCapitalT]",
         FontColor->RGBColor[1, 0, 0]], "+"]}], ")"}], "r"], 
    "]"}]}]}]], "Input"],

Cell[CellGroupData[{

Cell[TextData[{
 "Log[ ",
 Cell[BoxData[
  RowBox[{
   SubscriptBox[
    RowBox[{"(", 
     RowBox[{
      SuperscriptBox[
       StyleBox["\[GothicCapitalT]",
        FontColor->RGBColor[0.54, 0.35, 0.15]], "-"], " ", 
      SuperscriptBox[
       StyleBox["\[GothicCapitalT]",
        FontColor->RGBColor[0.54, 0.35, 0.15]], "+"]}], ")"}], "r"], "]"}]],
  CellChangeTimes->{{3.5467742886388063`*^9, 3.546774377540269*^9}}],
 "==ratLogT11rpT11rm \n(Contribution from everything)"
}], "Subsubsection",
 CellChangeTimes->{{3.546834634966998*^9, 3.546834643565124*^9}, {
   3.5468601889263153`*^9, 3.546860191509297*^9}, {3.546868207176361*^9, 
   3.5468682174960833`*^9}, {3.546871524691566*^9, 3.546871562789534*^9}, {
   3.54687186150214*^9, 3.5468719098230352`*^9}, {3.546871940645009*^9, 
   3.5468719406452*^9}, {3.546947906735064*^9, 3.546947952514098*^9}, 
   3.546947993171628*^9, {3.54970239032008*^9, 3.5497024197312727`*^9}, {
   3.549702466452436*^9, 3.549702473036686*^9}, {3.549702793519092*^9, 
   3.5497027972289553`*^9}, {3.553718936946206*^9, 3.553718938221333*^9}, {
   3.553719501846691*^9, 3.553719502548704*^9}, {3.553719606620242*^9, 
   3.553719610809867*^9}, {3.5537207631436863`*^9, 3.55372077748569*^9}, {
   3.55582251395887*^9, 3.555822529037299*^9}, {3.561464618548628*^9, 
   3.561464624058166*^9}, {3.562994040363517*^9, 3.562994062921185*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"+", 
   RowBox[{"Log", "[", 
    SubscriptBox[
     RowBox[{"(", 
      RowBox[{
       SuperscriptBox[
        StyleBox["U",
         FontColor->RGBColor[0, 0.6, 0]], 
        RowBox[{"[", "2", "]"}]], 
       SuperscriptBox[
        OverscriptBox[
         StyleBox["U",
          FontColor->RGBColor[0, 0.6, 0]], 
         StyleBox["_",
          FontColor->RGBColor[0, 0.6, 0]]], 
        RowBox[{"[", 
         RowBox[{"-", "2"}], "]"}]]}], ")"}], "r"], "]"}]}], "\[Equal]", 
  RowBox[{
   RowBox[{"Log", "[", 
    RowBox[{
     RowBox[{"(", 
      FractionBox[
       SubscriptBox[
        RowBox[{"(", 
         RowBox[{"1", "-", 
          RowBox[{
           SubscriptBox["Y", 
            RowBox[{"1", ",", "1"}]], 
           SubscriptBox["Y", 
            RowBox[{"2", ",", "2"}]]}]}], ")"}], "r"], 
       SubscriptBox[
        RowBox[{"(", 
         SubsuperscriptBox["\[GothicCapitalT]", 
          RowBox[{"0", ",", "1"}], "c"], ")"}], "r"]], ")"}], 
     SubscriptBox[
      RowBox[{"(", 
       RowBox[{
        SuperscriptBox[
         StyleBox["\[GothicCapitalT]",
          FontColor->RGBColor[0.54, 0.35, 0.15]], "-"], 
        SuperscriptBox[
         StyleBox["\[GothicCapitalT]",
          FontColor->RGBColor[0.54, 0.35, 0.15]], "+"]}], " ", ")"}], "r"]}], 
    "]"}], "+", 
   RowBox[{"Log", "[", 
    SubscriptBox[
     RowBox[{"(", 
      SubscriptBox[
       StyleBox["\[GothicCapitalT]",
        FontColor->RGBColor[0.54, 0.35, 0.15]], 
       RowBox[{"1", ",", "0"}]], ")"}], "r"], "]"}], "+", 
   RowBox[{"\[DoubleStruckCapitalC]", "[", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       FractionBox["2", "u"], "-", 
       FractionBox[
        RowBox[{"2", " ", "\[ImaginaryI]"}], 
        RowBox[{"1", "+", 
         SuperscriptBox["u", "2"]}]]}], ")"}], "H"}], "]"}], "+", 
   RowBox[{"\[DoubleStruckCapitalC]", "[", 
    RowBox[{
     FractionBox["4", "u"], 
     RowBox[{"Log", "[", 
      SubscriptBox[
       RowBox[{"(", 
        SuperscriptBox[
         StyleBox["\[GothicCapitalT]",
          FontColor->RGBColor[0.54, 0.35, 0.15]], "+"], ")"}], "r"], "]"}]}], 
    "]"}], "-", 
   RowBox[{"Log", "[", 
    SubscriptBox[
     RowBox[{"(", 
      RowBox[{
       SuperscriptBox[
        StyleBox["\[ScriptCapitalT]",
         FontColor->RGBColor[1, 0, 0]], "-"], 
       SuperscriptBox[
        StyleBox["\[ScriptCapitalT]",
         FontColor->RGBColor[1, 0, 0]], "+"]}], ")"}], "r"], 
    "]"}]}]}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{"+", 
   RowBox[{"Log", "[", 
    SubscriptBox[
     RowBox[{"(", 
      RowBox[{
       SuperscriptBox[
        StyleBox["U",
         FontColor->RGBColor[0, 0.6, 0]], 
        RowBox[{"[", "2", "]"}]], 
       SuperscriptBox[
        OverscriptBox[
         StyleBox["U",
          FontColor->RGBColor[0, 0.6, 0]], 
         StyleBox["_",
          FontColor->RGBColor[0, 0.6, 0]]], 
        RowBox[{"[", 
         RowBox[{"-", "2"}], "]"}]]}], ")"}], "r"], "]"}]}], "\[Equal]", 
  RowBox[{"Log", "[", 
   RowBox[{"(", 
    FractionBox[
     SubscriptBox[
      RowBox[{"(", 
       RowBox[{"1", "-", 
        RowBox[{
         SubscriptBox["Y", 
          RowBox[{"1", ",", "1"}]], 
         SubscriptBox["Y", 
          RowBox[{"2", ",", "2"}]]}]}], ")"}], "r"], 
     SubscriptBox[
      RowBox[{"(", 
       SubsuperscriptBox["\[GothicCapitalT]", 
        RowBox[{"0", ",", "1"}], "c"], ")"}], "r"]], ")"}], "]"}]}]], "Input",\

 CellChangeTimes->{{3.563078853305729*^9, 3.563078865169243*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"tmp2", "=", 
  RowBox[{
   RowBox[{"Collect", "[", 
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{"(", 
        RowBox[{
        "ToTW1", "+", "productq2Wint", "+", "productq2\[Delta]\[Rho]2", "+", 
         "productq2Wmp0"}], ")"}], "-", "ratLogT11rpT11rm"}], "/.", 
      "solut\[Rho]sexplicit"}], ",", "g", ",", "Simplify"}], "]"}], "//", 
   "CCompute"}]}]], "Input",
 CellChangeTimes->{{3.563078638849732*^9, 3.5630786573246307`*^9}, {
  3.5632794143049183`*^9, 3.563279422488269*^9}, {3.563279506508861*^9, 
  3.5632795249457827`*^9}, {3.56327968875886*^9, 3.563279689436219*^9}}],

Cell[BoxData["0"], "Output",
 CellChangeTimes->{3.563281620051756*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ratLogT11rpT11rm", "=", 
  RowBox[{"Collect", "[", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{
          RowBox[{
           RowBox[{
            RowBox[{
             RowBox[{
              RowBox[{
               RowBox[{
                RowBox[{
                 RowBox[{
                  RowBox[{"(", 
                   RowBox[{"Normal", "@", 
                    RowBox[{"dsLogRat", "[", 
                    RowBox[{
                    RowBox[{
                    SubsuperscriptBox["T", 
                    RowBox[{"1", ",", "1"}], "+"], 
                    SubsuperscriptBox["T", 
                    RowBox[{"1", ",", "1"}], "-"]}], ",", "9"}], "]"}]}], 
                   ")"}], "/.", 
                  RowBox[{"g", "\[Rule]", "1"}]}], "/.", 
                 RowBox[{"dsweak", "[", "2", "]"}]}], "/.", 
                RowBox[{"leadweak", "[", "2", "]"}]}], "/.", 
               RowBox[{"nsweak", "[", 
                RowBox[{"1", ",", 
                 RowBox[{"Only", "\[Rule]", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"(", 
                    RowBox[{"q$", "|", "q$b"}], ")"}], "[", 
                    RowBox[{"2", ",", "\"\<corr\>\""}], "]"}], "[", "_", 
                   "]"}]}]}], "]"}]}], "/.", 
              RowBox[{"nsweak", "[", "2", "]"}]}], "//.", 
             RowBox[{"shiftm\[Eta]", "[", "4", "]"}]}], "//.", 
            RowBox[{"shiftp\[Eta]b", "[", 
             RowBox[{"-", "4"}], "]"}]}], "/.", "subQ0"}], "/.", "subusu"}], "/.",
          "subIm"}], "/.", 
        RowBox[{"u", "\[Rule]", 
         RowBox[{"2", "g", " ", "z"}]}]}], "/.", 
       RowBox[{"TaylorOptions", "[", 
        RowBox[{
         RowBox[{"Variable", "\[Rule]", "g"}], ",", 
         RowBox[{"\[Eta]Factor", "\[Rule]", 
          RowBox[{"2", "z"}]}], ",", 
         RowBox[{"Order", "\[Rule]", "9"}], ",", 
         RowBox[{"Series", "->", 
          RowBox[{"{", "}"}]}]}], "]"}]}], "//.", "subZetaReduce"}], "//.", 
     "denz"}], ",", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"zlist", ",", "\[Zeta]list"}], "}"}], "//", "Flatten"}]}], 
   "]"}]}]], "Input",
 CellChangeTimes->{{3.563272914120475*^9, 3.5632729629245787`*^9}, {
   3.563279106236586*^9, 3.563279343261097*^9}, {3.563279379610547*^9, 
   3.563279390888023*^9}, {3.563279631777485*^9, 3.563279633977454*^9}, {
   3.5632797356785603`*^9, 3.563279736604946*^9}, {3.563281147153891*^9, 
   3.563281169797068*^9}, {3.563281243217923*^9, 3.5632812457591743`*^9}, {
   3.563281366271537*^9, 3.5632813793049498`*^9}, {3.5632815530766373`*^9, 
   3.563281567126587*^9}, 3.563281609513908*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   SuperscriptBox["g", "7"], " ", 
   SqrtBox[
    RowBox[{"1", "-", 
     SuperscriptBox["z", "2"]}]], " ", 
   RowBox[{"(", 
    RowBox[{"162", "-", 
     RowBox[{"108", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2"]}], "-", 
     RowBox[{"108", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3"]}], "+", 
     RowBox[{"72", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3"]}]}], ")"}]}], "+", 
  RowBox[{
   SuperscriptBox["g", "8"], " ", 
   RowBox[{"(", 
    RowBox[{"1134", "-", 
     RowBox[{"432", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2"]}], "+", 
     RowBox[{"216", " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2", "2"]}], "-", 
     FractionBox[
      RowBox[{"2976", " ", 
       SubsuperscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "2", "3"]}], "35"], "+", 
     RowBox[{"3024", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3"]}], "-", 
     RowBox[{"144", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3"]}], "-", 
     RowBox[{"216", " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3", "2"]}], "-", 
     RowBox[{"1872", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "5"]}], "-", 
     RowBox[{"504", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "7"]}], "+", 
     RowBox[{
      SuperscriptBox["z", "2"], " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "648"}], "+", 
        RowBox[{"648", " ", 
         SubscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "2"]}], "-", 
        FractionBox[
         RowBox[{"1296", " ", 
          SubsuperscriptBox[
           StyleBox["\[Zeta]",
            FontWeight->Bold,
            FontColor->GrayLevel[0.4]], "2", "2"]}], "5"], "-", 
        FractionBox[
         RowBox[{"11808", " ", 
          SubsuperscriptBox[
           StyleBox["\[Zeta]",
            FontWeight->Bold,
            FontColor->GrayLevel[0.4]], "2", "3"]}], "35"], "-", 
        RowBox[{"216", " ", 
         SubscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "3"]}], "-", 
        RowBox[{"864", " ", 
         SubsuperscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "3", "2"]}], "+", 
        RowBox[{"2304", " ", 
         SubscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "5"]}], "+", 
        RowBox[{"1008", " ", 
         SubscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "7"]}]}], ")"}]}], "-", 
     RowBox[{"216", " ", "\[ImaginaryI]", " ", 
      SqrtBox["3"], " ", 
      SubsuperscriptBox[
       StyleBox["\[Eta]0",
        FontWeight->Bold,
        FontColor->RGBColor[0, 0.5, 0]], "2", "+"]}], "+", 
     RowBox[{"216", " ", "\[ImaginaryI]", " ", 
      SubsuperscriptBox[
       StyleBox["\[Eta]0",
        FontWeight->Bold,
        FontColor->RGBColor[0, 0.5, 0]], "3", "+"]}], "-", 
     RowBox[{"36", " ", "\[ImaginaryI]", " ", 
      SqrtBox["3"], " ", 
      SubsuperscriptBox[
       StyleBox["\[Eta]0",
        FontWeight->Bold,
        FontColor->RGBColor[0, 0.5, 0]], "4", "+"]}], "+", 
     RowBox[{"216", " ", "\[ImaginaryI]", " ", 
      SqrtBox["3"], " ", 
      SubsuperscriptBox[
       OverscriptBox[
        StyleBox["\[Eta]0",
         FontWeight->Bold,
         FontColor->RGBColor[0, 0.5, 0]], 
        StyleBox["_",
         FontWeight->Bold,
         FontColor->RGBColor[0, 0.5, 0]]], "2", "-"]}], "-", 
     RowBox[{"216", " ", "\[ImaginaryI]", " ", 
      SubsuperscriptBox[
       OverscriptBox[
        StyleBox["\[Eta]0",
         FontWeight->Bold,
         FontColor->RGBColor[0, 0.5, 0]], 
        StyleBox["_",
         FontWeight->Bold,
         FontColor->RGBColor[0, 0.5, 0]]], "3", "-"]}], "+", 
     RowBox[{"36", " ", "\[ImaginaryI]", " ", 
      SqrtBox["3"], " ", 
      SubsuperscriptBox[
       OverscriptBox[
        StyleBox["\[Eta]0",
         FontWeight->Bold,
         FontColor->RGBColor[0, 0.5, 0]], 
        StyleBox["_",
         FontWeight->Bold,
         FontColor->RGBColor[0, 0.5, 0]]], "4", "-"]}]}], ")"}]}], "+", 
  RowBox[{
   SuperscriptBox["g", "9"], " ", 
   SqrtBox[
    RowBox[{"1", "-", 
     SuperscriptBox["z", "2"]}]], " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"-", "2268"}], "+", 
     RowBox[{"972", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2"]}], "+", 
     FractionBox[
      RowBox[{"2376", " ", 
       SubsuperscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "2", "2"]}], "5"], "-", 
     FractionBox[
      RowBox[{"1296", " ", 
       SubsuperscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "2", "3"]}], "5"], "+", 
     RowBox[{"7020", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3"]}], "+", 
     RowBox[{"72", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3"]}], "-", 
     RowBox[{
      FractionBox["288", "5"], " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2", "2"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3"]}], "-", 
     RowBox[{"1296", " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3", "2"]}], "+", 
     RowBox[{"1620", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "5"]}], "-", 
     RowBox[{"216", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "5"]}], "+", 
     RowBox[{
      SuperscriptBox["z", "2"], " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "1944"}], "+", 
        RowBox[{"2592", " ", 
         SubscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "2"]}], "-", 
        RowBox[{"2592", " ", 
         SubscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "3"]}], "+", 
        RowBox[{
         FractionBox["1728", "5"], " ", 
         SubsuperscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "2", "2"], " ", 
         SubscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "3"]}], "+", 
        RowBox[{"2592", " ", 
         SubscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "5"]}], "-", 
        RowBox[{"1728", " ", 
         SubscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "2"], " ", 
         SubscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "5"]}]}], ")"}]}], "-", 
     RowBox[{"3528", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "7"]}], "-", 
     RowBox[{"648", " ", "\[ImaginaryI]", " ", 
      SqrtBox["3"], " ", 
      SubsuperscriptBox[
       StyleBox["\[Eta]0",
        FontWeight->Bold,
        FontColor->RGBColor[0, 0.5, 0]], "2", "+"]}], "+", 
     RowBox[{"648", " ", "\[ImaginaryI]", " ", 
      SubsuperscriptBox[
       StyleBox["\[Eta]0",
        FontWeight->Bold,
        FontColor->RGBColor[0, 0.5, 0]], "3", "+"]}], "-", 
     RowBox[{"108", " ", "\[ImaginaryI]", " ", 
      SqrtBox["3"], " ", 
      SubsuperscriptBox[
       StyleBox["\[Eta]0",
        FontWeight->Bold,
        FontColor->RGBColor[0, 0.5, 0]], "4", "+"]}], "+", 
     RowBox[{"648", " ", "\[ImaginaryI]", " ", 
      SqrtBox["3"], " ", 
      SubsuperscriptBox[
       OverscriptBox[
        StyleBox["\[Eta]0",
         FontWeight->Bold,
         FontColor->RGBColor[0, 0.5, 0]], 
        StyleBox["_",
         FontWeight->Bold,
         FontColor->RGBColor[0, 0.5, 0]]], "2", "-"]}], "-", 
     RowBox[{"648", " ", "\[ImaginaryI]", " ", 
      SubsuperscriptBox[
       OverscriptBox[
        StyleBox["\[Eta]0",
         FontWeight->Bold,
         FontColor->RGBColor[0, 0.5, 0]], 
        StyleBox["_",
         FontWeight->Bold,
         FontColor->RGBColor[0, 0.5, 0]]], "3", "-"]}], "+", 
     RowBox[{"108", " ", "\[ImaginaryI]", " ", 
      SqrtBox["3"], " ", 
      SubsuperscriptBox[
       OverscriptBox[
        StyleBox["\[Eta]0",
         FontWeight->Bold,
         FontColor->RGBColor[0, 0.5, 0]], 
        StyleBox["_",
         FontWeight->Bold,
         FontColor->RGBColor[0, 0.5, 0]]], "4", "-"]}]}], ")"}]}]}]], "Output",\

 CellChangeTimes->{{3.563279098106179*^9, 3.5632791357322397`*^9}, {
   3.563279171712825*^9, 3.563279200797359*^9}, {3.5632792651570997`*^9, 
   3.563279272100412*^9}, {3.563279318611306*^9, 3.563279345227099*^9}, 
   3.563279392844195*^9, 3.563279635182242*^9, 3.563279773478127*^9, 
   3.5632811972469883`*^9, 3.563281273043565*^9, 3.56328145737149*^9, {
   3.563281599682946*^9, 3.563281612491877*^9}}]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[Cell[BoxData[
 FormBox[
  RowBox[{
   RowBox[{"Log", "[", 
    SubscriptBox[
     RowBox[{"(", 
      RowBox[{"1", "-", 
       RowBox[{
        SubscriptBox["Y", 
         RowBox[{"1", ",", "1"}]], 
        SubscriptBox["Y", 
         RowBox[{"2", ",", "2"}]]}]}], ")"}], "r"], "]"}], "==", 
   "preconY11Y22"}], TraditionalForm]]]], "Subsubsection",
 CellChangeTimes->CompressedData["
1:eJxTTMoPSmViYGAQBmIQvexj3E2e3FeO9aJFt0B0wpK5wZJAWtPnA5g+sOSp
rSyQfnVf3x5Ey/C0XXUC0r1c3DdA9LcCvRBnIF2hfQJMX6gsuhgEpPOqIfS6
+cYbdwHpF94RYNrArIC/qeiV4z5+FgEQ7eB/R6UVSOdx71AF0fvO85ZOBdKP
Fi4A03vifoboVb1yVAj4GQaigwJfx+kD6YTVe5NB9CuxHQzGQPqxkx8HiG6b
XNZiUvfK8YOf4CQQHfPPcAaItjmxag6InqW2buaXjleORvuj5oNoCaXVd0D0
rX0/74FodbvGDyD6xW/RjyD6GqfjDxC9hBtCAwAOwJwq
  "]],

Cell[BoxData[
 RowBox[{
  RowBox[{"Log", "[", 
   FractionBox[
    RowBox[{"1", "-", 
     RowBox[{
      SubscriptBox["Y", 
       RowBox[{"1", ",", "1"}]], 
      SubscriptBox["Y", 
       RowBox[{"2", ",", "2"}]]}]}], 
    SubscriptBox[
     RowBox[{"(", 
      RowBox[{"1", "-", 
       RowBox[{
        SubscriptBox["Y", 
         RowBox[{"1", ",", "1"}]], 
        SubscriptBox["Y", 
         RowBox[{"2", ",", "2"}]]}]}], ")"}], "asym"]], "]"}], "\[Equal]", 
  RowBox[{"Log", "[", 
   FractionBox[
    RowBox[{"1", "-", 
     RowBox[{"Y11Y22", 
      RowBox[{"(", 
       RowBox[{"1", "+", "o"}], ")"}]}]}], 
    RowBox[{"1", "-", "Y11Y22"}]], "]"}], "\[Equal]", 
  RowBox[{"o", 
   FractionBox[
    RowBox[{" ", "Y11Y22"}], 
    RowBox[{
     RowBox[{"-", "1"}], "+", "Y11Y22"}]]}], "==", 
  RowBox[{
   FractionBox[
    RowBox[{" ", "Y11Y22"}], 
    RowBox[{
     RowBox[{"-", "1"}], "+", "Y11Y22"}]], 
   RowBox[{"Log", "[", 
    FractionBox[
     RowBox[{
      SubscriptBox["Y", 
       RowBox[{"1", ",", "1"}]], 
      SubscriptBox["Y", 
       RowBox[{"2", ",", "2"}]]}], 
     SubscriptBox[
      RowBox[{"(", 
       RowBox[{
        SubscriptBox["Y", 
         RowBox[{"1", ",", "1"}]], 
        SubscriptBox["Y", 
         RowBox[{"2", ",", "2"}]]}], ")"}], "asym"]], "]"}]}], "\[Equal]", 
  "\[IndentingNewLine]", 
  RowBox[{
   FractionBox[
    RowBox[{" ", "Y11Y22"}], 
    RowBox[{
     RowBox[{"-", "1"}], "+", "Y11Y22"}]], 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"-", "4"}], "\[ImaginaryI]", " ", "g", 
     SqrtBox[
      RowBox[{"1", "-", 
       SuperscriptBox["z", "2"]}]], 
     RowBox[{"\[DoubleStruckCapitalC]", "[", 
      RowBox[{
       FractionBox["1", 
        RowBox[{
         RowBox[{"4", 
          SuperscriptBox["g", "2"], 
          SuperscriptBox["z", "2"]}], "-", 
         SuperscriptBox["u", "2"]}]], 
       FractionBox["H", 
        SqrtBox[
         RowBox[{"1", "-", 
          FractionBox[
           RowBox[{"4", 
            SuperscriptBox["g", "2"]}], 
           SuperscriptBox["u", "2"]]}]]]}], "]"}]}], ")"}]}]}]], "Input",
 CellChangeTimes->{{3.552195453278018*^9, 3.552195497757874*^9}, {
  3.555873272457108*^9, 3.555873298282538*^9}, {3.555873412927331*^9, 
  3.555873441120566*^9}}],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"Series", "[", 
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{
          FractionBox[
           RowBox[{" ", "Y11Y22"}], 
           RowBox[{
            RowBox[{"-", "1"}], "+", "Y11Y22"}]], "/.", "largevolume"}], "/.",
          "subFunsBethe"}], "/.", "subJuk"}], "/.", 
       RowBox[{"leadweak", "[", "4", "]"}]}], "/.", 
      RowBox[{"u", "\[Rule]", 
       RowBox[{"2", "g", " ", "z"}]}]}], ",", 
     RowBox[{"{", 
      RowBox[{"g", ",", "0", ",", "3"}], "}"}]}], "]"}], "//", "Simplify"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"tmp1", "=", 
  RowBox[{
   RowBox[{"%", "//", "FullSimplify"}], "//", "Normal"}]}]}], "Input",
 CellChangeTimes->{{3.5521955031953583`*^9, 3.5521955123162107`*^9}, {
  3.552195599887342*^9, 3.552195650005445*^9}, {3.5558734853231087`*^9, 
  3.555873486278224*^9}, {3.555873579143408*^9, 3.555873592358659*^9}, {
  3.555873859352264*^9, 3.5558738612814083`*^9}}],

Cell[BoxData[
 RowBox[{
  FractionBox["1", "2"], "+", 
  FractionBox["1", 
   RowBox[{"12", " ", "g", " ", 
    SqrtBox[
     RowBox[{"1", "-", 
      SuperscriptBox["z", "2"]}]]}]], "+", 
  FractionBox[
   RowBox[{"g", " ", 
    RowBox[{"(", 
     RowBox[{"4", "-", 
      RowBox[{"3", " ", 
       SuperscriptBox["z", "2"]}]}], ")"}]}], 
   RowBox[{"3", " ", 
    SqrtBox[
     RowBox[{"1", "-", 
      SuperscriptBox["z", "2"]}]]}]], "+", 
  FractionBox[
   RowBox[{
    SuperscriptBox["g", "3"], " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"-", "7"}], "+", 
      RowBox[{"6", " ", 
       SuperscriptBox["z", "2"]}]}], ")"}]}], 
   SqrtBox[
    RowBox[{"1", "-", 
     SuperscriptBox["z", "2"]}]]]}]], "Output",
 CellChangeTimes->{3.561465744195806*^9, 3.56146805264062*^9, 
  3.562238571612167*^9, 3.563004049868198*^9, 3.563025152067153*^9, 
  3.563281653612843*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"tmp2", "=", 
  RowBox[{
   RowBox[{"-", "4"}], "\[ImaginaryI]", " ", "g", 
   SqrtBox[
    RowBox[{"1", "-", 
     SuperscriptBox["z", "2"]}]], 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"ExpaCol", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"(", 
         RowBox[{"Series", "[", 
          RowBox[{
           RowBox[{
            FractionBox["z", 
             RowBox[{
              RowBox[{"4", 
               SuperscriptBox["g", "2"], 
               SuperscriptBox["z", "2"]}], "-", 
              SuperscriptBox["u", "2"]}]], 
            FractionBox[
             RowBox[{
              SuperscriptBox["g", "8"], 
              RowBox[{"(", 
               RowBox[{
                SubscriptBox["H", "lead"], "+", 
                RowBox[{
                 SuperscriptBox["g", "2"], 
                 SubscriptBox["H", "sublead"]}], "+", 
                RowBox[{
                 SuperscriptBox["g", "4"], 
                 SubscriptBox["H", "sublead2"]}]}], ")"}]}], 
             SqrtBox[
              RowBox[{"1", "-", 
               FractionBox[
                RowBox[{"4", 
                 SuperscriptBox["g", "2"]}], 
                SuperscriptBox["u", "2"]]}]]]}], ",", 
           RowBox[{"{", 
            RowBox[{"g", ",", "0", ",", "10"}], "}"}]}], "]"}], ")"}], "//", 
        "Normal"}], ",", 
       RowBox[{"z", "|", "g"}]}], "]"}], "/.", 
     RowBox[{
      RowBox[{
       SuperscriptBox["z", "a_."], 
       SuperscriptBox["g", "b_."], "r_"}], "\[RuleDelayed]", 
      RowBox[{
       SuperscriptBox["z", 
        RowBox[{"a", "-", "1"}]], 
       SuperscriptBox["g", "b"], " ", 
       RowBox[{"\[DoubleStruckCapitalC]", "[", "r", "]"}]}]}]}], 
    ")"}]}]}]], "Input",
 CellChangeTimes->{
  3.56146577326223*^9, {3.563004051699091*^9, 3.563004052401472*^9}, {
   3.5632817432301197`*^9, 3.563281749968275*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"-", "4"}], " ", "\[ImaginaryI]", " ", "g", " ", 
  SqrtBox[
   RowBox[{"1", "-", 
    SuperscriptBox["z", "2"]}]], " ", 
  RowBox[{"(", 
   RowBox[{
    RowBox[{
     SuperscriptBox["g", "10"], " ", 
     SuperscriptBox["z", "2"], " ", 
     RowBox[{"\[DoubleStruckCapitalC]", "[", 
      RowBox[{"-", 
       FractionBox[
        RowBox[{"4", " ", 
         SubscriptBox[
          StyleBox["H",
           FontColor->RGBColor[0.54, 0.35, 0.15]], "lead"]}], 
        SuperscriptBox["u", "4"]]}], "]"}]}], "+", 
    RowBox[{
     SuperscriptBox["g", "8"], " ", 
     RowBox[{"\[DoubleStruckCapitalC]", "[", 
      RowBox[{"-", 
       FractionBox[
        SubscriptBox[
         StyleBox["H",
          FontColor->RGBColor[0.54, 0.35, 0.15]], "lead"], 
        SuperscriptBox["u", "2"]]}], "]"}]}], "+", 
    RowBox[{
     SuperscriptBox["g", "10"], " ", 
     RowBox[{"\[DoubleStruckCapitalC]", "[", 
      RowBox[{
       RowBox[{"-", 
        FractionBox[
         RowBox[{"2", " ", 
          SubscriptBox[
           StyleBox["H",
            FontColor->RGBColor[0.54, 0.35, 0.15]], "lead"]}], 
         SuperscriptBox["u", "4"]]}], "-", 
       FractionBox[
        SubscriptBox[
         StyleBox["H",
          FontColor->RGBColor[0.54, 0.35, 0.15]], "sublead"], 
        SuperscriptBox["u", "2"]]}], "]"}]}]}], ")"}]}]], "Output",
 CellChangeTimes->{3.563281750601323*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"preconY11Y22", "=", " ", 
  RowBox[{"Collect", "[", 
   RowBox[{
    RowBox[{"Series", "[", 
     RowBox[{
      RowBox[{"tmp1", " ", "tmp2"}], ",", 
      RowBox[{"{", 
       RowBox[{"g", ",", "0", ",", "9"}], "}"}]}], "]"}], ",", 
    RowBox[{"{", 
     RowBox[{"g", ",", "z"}], "}"}], ",", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{"#", "//.", "sub\[DoubleStruckCapitalC]simplify"}], ")"}], 
     "&"}]}], "]"}]}], "\[IndentingNewLine]", 
 RowBox[{"preconY11Y22", "=", 
  RowBox[{"Collect", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"%", "//", "CCompute"}], "//", "fundeperiod"}], ",", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"zlist", ",", "\[Zeta]list"}], "}"}], "//", "Flatten"}]}], 
   "]"}]}]}], "Input",
 CellChangeTimes->{{3.5608541723975897`*^9, 3.560854268455309*^9}, 
   3.561442067744432*^9, {3.5630040730920153`*^9, 3.56300411565652*^9}, {
   3.5632817967968082`*^9, 3.563281802607424*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"-", 
    FractionBox["1", "3"]}], " ", "\[ImaginaryI]", " ", 
   SuperscriptBox["g", "8"], " ", 
   RowBox[{"\[DoubleStruckCapitalC]", "[", 
    RowBox[{"-", 
     FractionBox[
      SubscriptBox[
       StyleBox["H",
        FontColor->RGBColor[0.54, 0.35, 0.15]], "lead"], 
      SuperscriptBox["u", "2"]]}], "]"}]}], "-", 
  RowBox[{"2", " ", "\[ImaginaryI]", " ", 
   SuperscriptBox["g", "9"], " ", 
   SqrtBox[
    RowBox[{"1", "-", 
     SuperscriptBox["z", "2"]}]], " ", 
   RowBox[{"\[DoubleStruckCapitalC]", "[", 
    RowBox[{"-", 
     FractionBox[
      SubscriptBox[
       StyleBox["H",
        FontColor->RGBColor[0.54, 0.35, 0.15]], "lead"], 
      SuperscriptBox["u", "2"]]}], "]"}]}]}]], "Output",
 CellChangeTimes->{{3.560854188158609*^9, 3.560854268749*^9}, 
   3.561442068222645*^9, 3.561442205887044*^9, 3.561465776866138*^9, 
   3.5614680528512077`*^9, 3.562238599097251*^9, 3.563004054820569*^9, {
   3.563004085161869*^9, 3.563004116301241*^9}, 3.563004403438677*^9, 
   3.5630251521952553`*^9, 3.5632816641542473`*^9, 3.563281767443218*^9, 
   3.56328180306326*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   SuperscriptBox["g", "8"], " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"-", "324"}], "-", 
     RowBox[{"648", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3"]}], "-", 
     RowBox[{"144", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "5"]}], "+", 
     RowBox[{"672", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "7"]}], "+", 
     RowBox[{"108", " ", "\[ImaginaryI]", " ", 
      SqrtBox["3"], " ", 
      SubsuperscriptBox[
       StyleBox["\[Eta]0",
        FontWeight->Bold,
        FontColor->RGBColor[0, 0.5, 0]], "2", "+"]}], "-", 
     RowBox[{"108", " ", "\[ImaginaryI]", " ", 
      SubsuperscriptBox[
       StyleBox["\[Eta]0",
        FontWeight->Bold,
        FontColor->RGBColor[0, 0.5, 0]], "3", "+"]}], "+", 
     RowBox[{"18", " ", "\[ImaginaryI]", " ", 
      SqrtBox["3"], " ", 
      SubsuperscriptBox[
       StyleBox["\[Eta]0",
        FontWeight->Bold,
        FontColor->RGBColor[0, 0.5, 0]], "4", "+"]}], "-", 
     RowBox[{"108", " ", "\[ImaginaryI]", " ", 
      SqrtBox["3"], " ", 
      SubsuperscriptBox[
       OverscriptBox[
        StyleBox["\[Eta]0",
         FontWeight->Bold,
         FontColor->RGBColor[0, 0.5, 0]], 
        StyleBox["_",
         FontWeight->Bold,
         FontColor->RGBColor[0, 0.5, 0]]], "2", "-"]}], "+", 
     RowBox[{"108", " ", "\[ImaginaryI]", " ", 
      SubsuperscriptBox[
       OverscriptBox[
        StyleBox["\[Eta]0",
         FontWeight->Bold,
         FontColor->RGBColor[0, 0.5, 0]], 
        StyleBox["_",
         FontWeight->Bold,
         FontColor->RGBColor[0, 0.5, 0]]], "3", "-"]}], "-", 
     RowBox[{"18", " ", "\[ImaginaryI]", " ", 
      SqrtBox["3"], " ", 
      SubsuperscriptBox[
       OverscriptBox[
        StyleBox["\[Eta]0",
         FontWeight->Bold,
         FontColor->RGBColor[0, 0.5, 0]], 
        StyleBox["_",
         FontWeight->Bold,
         FontColor->RGBColor[0, 0.5, 0]]], "4", "-"]}]}], ")"}]}], "+", 
  RowBox[{
   SuperscriptBox["g", "9"], " ", 
   SqrtBox[
    RowBox[{"1", "-", 
     SuperscriptBox["z", "2"]}]], " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"-", "1944"}], "-", 
     RowBox[{"3888", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3"]}], "-", 
     RowBox[{"864", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "5"]}], "+", 
     RowBox[{"4032", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "7"]}], "+", 
     RowBox[{"648", " ", "\[ImaginaryI]", " ", 
      SqrtBox["3"], " ", 
      SubsuperscriptBox[
       StyleBox["\[Eta]0",
        FontWeight->Bold,
        FontColor->RGBColor[0, 0.5, 0]], "2", "+"]}], "-", 
     RowBox[{"648", " ", "\[ImaginaryI]", " ", 
      SubsuperscriptBox[
       StyleBox["\[Eta]0",
        FontWeight->Bold,
        FontColor->RGBColor[0, 0.5, 0]], "3", "+"]}], "+", 
     RowBox[{"108", " ", "\[ImaginaryI]", " ", 
      SqrtBox["3"], " ", 
      SubsuperscriptBox[
       StyleBox["\[Eta]0",
        FontWeight->Bold,
        FontColor->RGBColor[0, 0.5, 0]], "4", "+"]}], "-", 
     RowBox[{"648", " ", "\[ImaginaryI]", " ", 
      SqrtBox["3"], " ", 
      SubsuperscriptBox[
       OverscriptBox[
        StyleBox["\[Eta]0",
         FontWeight->Bold,
         FontColor->RGBColor[0, 0.5, 0]], 
        StyleBox["_",
         FontWeight->Bold,
         FontColor->RGBColor[0, 0.5, 0]]], "2", "-"]}], "+", 
     RowBox[{"648", " ", "\[ImaginaryI]", " ", 
      SubsuperscriptBox[
       OverscriptBox[
        StyleBox["\[Eta]0",
         FontWeight->Bold,
         FontColor->RGBColor[0, 0.5, 0]], 
        StyleBox["_",
         FontWeight->Bold,
         FontColor->RGBColor[0, 0.5, 0]]], "3", "-"]}], "-", 
     RowBox[{"108", " ", "\[ImaginaryI]", " ", 
      SqrtBox["3"], " ", 
      SubsuperscriptBox[
       OverscriptBox[
        StyleBox["\[Eta]0",
         FontWeight->Bold,
         FontColor->RGBColor[0, 0.5, 0]], 
        StyleBox["_",
         FontWeight->Bold,
         FontColor->RGBColor[0, 0.5, 0]]], "4", "-"]}]}], ")"}]}]}]], "Output",\

 CellChangeTimes->{{3.560854188158609*^9, 3.560854268749*^9}, 
   3.561442068222645*^9, 3.561442205887044*^9, 3.561465776866138*^9, 
   3.5614680528512077`*^9, 3.562238599097251*^9, 3.563004054820569*^9, {
   3.563004085161869*^9, 3.563004116301241*^9}, 3.563004403438677*^9, 
   3.5630251521952553`*^9, 3.5632816641542473`*^9, 3.563281767443218*^9, 
   3.563281807426537*^9}]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[Cell[BoxData[
 FormBox[
  RowBox[{"Log", "[", 
   RowBox[{
    SubscriptBox[
     RowBox[{"(", 
      SubscriptBox["\[GothicCapitalT]", 
       RowBox[{"1", ",", "0"}]], ")"}], "r"], "=", "rhsT10"}]}], 
  TraditionalForm]]]], "Subsubsection",
 CellChangeTimes->{{3.561465810412119*^9, 3.5614658266214314`*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"dsLogRat", "[", 
   RowBox[{
    SubscriptBox["T", 
     RowBox[{"1", ",", "0"}]], ",", "9"}], "]"}], "//", "Normal"}]], "Input",
 CellChangeTimes->{{3.563281864463664*^9, 3.5632818731285677`*^9}}],

Cell[BoxData[
 RowBox[{
  FractionBox["1", 
   RowBox[{"2", " ", 
    SuperscriptBox[
     StyleBox["Q",
      FontColor->RGBColor[0.8, 0, 0]], "-"], " ", 
    SuperscriptBox[
     StyleBox["Q",
      FontColor->RGBColor[0.8, 0, 0]], "+"]}]], 
  RowBox[{
   SuperscriptBox["g", "8"], " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{
      RowBox[{"-", "\[ImaginaryI]"}], " ", "\[Alpha]", " ", 
      SuperscriptBox[
       StyleBox["Q",
        FontColor->RGBColor[0.8, 0, 0]], "-"]}], "-", 
     RowBox[{"2", " ", "u", " ", "\[Alpha]", " ", 
      SuperscriptBox[
       StyleBox["Q",
        FontColor->RGBColor[0.8, 0, 0]], "-"]}], "+", 
     RowBox[{"\[ImaginaryI]", " ", 
      OverscriptBox["\[Alpha]", "_"], " ", 
      SuperscriptBox[
       StyleBox["Q",
        FontColor->RGBColor[0.8, 0, 0]], "-"]}], "+", 
     RowBox[{"2", " ", "u", " ", 
      OverscriptBox["\[Alpha]", "_"], " ", 
      SuperscriptBox[
       StyleBox["Q",
        FontColor->RGBColor[0.8, 0, 0]], "-"]}], "-", 
     RowBox[{"\[ImaginaryI]", " ", "\[Alpha]", " ", 
      SuperscriptBox[
       StyleBox["Q",
        FontColor->RGBColor[0.8, 0, 0]], "+"]}], "+", 
     RowBox[{"2", " ", "u", " ", "\[Alpha]", " ", 
      SuperscriptBox[
       StyleBox["Q",
        FontColor->RGBColor[0.8, 0, 0]], "+"]}], "+", 
     RowBox[{"\[ImaginaryI]", " ", 
      OverscriptBox["\[Alpha]", "_"], " ", 
      SuperscriptBox[
       StyleBox["Q",
        FontColor->RGBColor[0.8, 0, 0]], "+"]}], "-", 
     RowBox[{"2", " ", "u", " ", 
      OverscriptBox["\[Alpha]", "_"], " ", 
      SuperscriptBox[
       StyleBox["Q",
        FontColor->RGBColor[0.8, 0, 0]], "+"]}], "-", 
     RowBox[{"2", " ", "\[Alpha]", " ", 
      SuperscriptBox[
       StyleBox["Q",
        FontColor->RGBColor[0.8, 0, 0]], "-"], " ", 
      SubscriptBox["v", "0"]}], "-", 
     RowBox[{"2", " ", 
      OverscriptBox["\[Alpha]", "_"], " ", 
      SuperscriptBox[
       StyleBox["Q",
        FontColor->RGBColor[0.8, 0, 0]], "-"], " ", 
      SubscriptBox["v", "0"]}], "-", 
     RowBox[{"2", " ", "\[Alpha]", " ", 
      SuperscriptBox[
       StyleBox["Q",
        FontColor->RGBColor[0.8, 0, 0]], "+"], " ", 
      SubscriptBox["v", "0"]}], "-", 
     RowBox[{"2", " ", 
      OverscriptBox["\[Alpha]", "_"], " ", 
      SuperscriptBox[
       StyleBox["Q",
        FontColor->RGBColor[0.8, 0, 0]], "+"], " ", 
      SubscriptBox["v", "0"]}], "-", 
     RowBox[{"2", " ", 
      SubsuperscriptBox[
       StyleBox["q",
        FontColor->RGBColor[0, 0, 0.8]], 
       RowBox[{"2", ",", "4"}], "+"], " ", 
      SubsuperscriptBox[
       OverscriptBox[
        StyleBox["q",
         FontColor->RGBColor[0, 0, 0.8]], 
        StyleBox["_",
         FontColor->RGBColor[0, 0, 0.8]]], 
       RowBox[{"1", ",", "3"}], "-"]}], "-", 
     RowBox[{"4", " ", 
      SubsuperscriptBox[
       StyleBox["q",
        FontColor->RGBColor[0, 0, 0.8]], 
       RowBox[{"1", ",", "4"}], "+"], " ", 
      SubsuperscriptBox[
       OverscriptBox[
        StyleBox["q",
         FontColor->RGBColor[0, 0, 0.8]], 
        StyleBox["_",
         FontColor->RGBColor[0, 0, 0.8]]], 
       RowBox[{"1", ",", "4"}], "-"]}], "-", 
     RowBox[{"2", " ", 
      SubsuperscriptBox[
       StyleBox["q",
        FontColor->RGBColor[0, 0, 0.8]], 
       RowBox[{"1", ",", "3"}], "+"], " ", 
      SubsuperscriptBox[
       OverscriptBox[
        StyleBox["q",
         FontColor->RGBColor[0, 0, 0.8]], 
        StyleBox["_",
         FontColor->RGBColor[0, 0, 0.8]]], 
       RowBox[{"2", ",", "4"}], "-"]}]}], ")"}]}]}]], "Output",
 CellChangeTimes->{3.5632818737213287`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"dsLogRat", "[", 
    RowBox[{
     SubscriptBox["T", 
      RowBox[{"1", ",", "0"}]], ",", "9"}], "]"}], "//", "Normal"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"rhsT10", "=", 
  RowBox[{"Collect", "[", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{"%", "/.", 
          RowBox[{"g", "\[Rule]", "1"}]}], "/.", 
         RowBox[{"leadweak", "[", "2", "]"}]}], "/.", "subQ0"}], "/.", 
       RowBox[{"u", "\[Rule]", 
        RowBox[{"2", "g", " ", "z"}]}]}], "/.", 
      RowBox[{"TaylorOptions", "[", 
       RowBox[{
        RowBox[{"Variable", "\[Rule]", "g"}], ",", 
        RowBox[{"\[Eta]Factor", "\[Rule]", 
         RowBox[{"2", " ", "z"}]}], ",", 
        RowBox[{"Series", "\[Rule]", 
         RowBox[{"{", "}"}]}], ",", 
        RowBox[{"Order", "\[Rule]", "9"}]}], "]"}]}], "//.", 
     "subZetaReduce"}], ",", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"zlist", ",", "\[Zeta]list", ",", "\[Eta]0list"}], "}"}], "//", 
     "Flatten"}], ",", "Simplify"}], "]"}]}]}], "Input",
 CellChangeTimes->{{3.563004435744598*^9, 3.5630045240681667`*^9}, {
  3.563004585425638*^9, 3.563004585625593*^9}, {3.563020346735437*^9, 
  3.563020355958686*^9}, {3.563025170025098*^9, 3.563025176558277*^9}, {
  3.563281897841794*^9, 3.5632819115807247`*^9}, {3.563281949549157*^9, 
  3.5632819547006493`*^9}}],

Cell[BoxData[
 RowBox[{
  SuperscriptBox["g", "8"], " ", 
  RowBox[{"(", 
   RowBox[{"972", "-", 
    RowBox[{"648", " ", 
     SubscriptBox[
      StyleBox["\[Zeta]",
       FontWeight->Bold,
       FontColor->GrayLevel[0.4]], "2"]}], "+", 
    FractionBox[
     RowBox[{"1296", " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2", "2"]}], "5"], "-", 
    FractionBox[
     RowBox[{"144", " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2", "3"]}], "5"], "+", 
    RowBox[{"216", " ", 
     SubscriptBox[
      StyleBox["\[Zeta]",
       FontWeight->Bold,
       FontColor->GrayLevel[0.4]], "3"]}], "-", 
    RowBox[{"72", " ", 
     SubsuperscriptBox[
      StyleBox["\[Zeta]",
       FontWeight->Bold,
       FontColor->GrayLevel[0.4]], "3", "2"]}], "-", 
    RowBox[{"108", " ", "\[ImaginaryI]", " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{
        RowBox[{"-", "3"}], " ", "\[ImaginaryI]"}], "+", 
       SqrtBox["3"]}], ")"}], " ", 
     SubsuperscriptBox[
      StyleBox["\[Eta]0",
       FontWeight->Bold,
       FontColor->RGBColor[0, 0.5, 0]], "2", "+"]}], "+", 
    RowBox[{"108", " ", 
     RowBox[{"(", 
      RowBox[{"\[ImaginaryI]", "+", 
       SqrtBox["3"]}], ")"}], " ", 
     SubsuperscriptBox[
      StyleBox["\[Eta]0",
       FontWeight->Bold,
       FontColor->RGBColor[0, 0.5, 0]], "3", "+"]}], "+", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{"-", "54"}], "-", 
       RowBox[{"18", " ", "\[ImaginaryI]", " ", 
        SqrtBox["3"]}]}], ")"}], " ", 
     SubsuperscriptBox[
      StyleBox["\[Eta]0",
       FontWeight->Bold,
       FontColor->RGBColor[0, 0.5, 0]], "4", "+"]}], "+", 
    RowBox[{"108", " ", "\[ImaginaryI]", " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"3", " ", "\[ImaginaryI]"}], "+", 
       SqrtBox["3"]}], ")"}], " ", 
     SubsuperscriptBox[
      OverscriptBox[
       StyleBox["\[Eta]0",
        FontWeight->Bold,
        FontColor->RGBColor[0, 0.5, 0]], 
       StyleBox["_",
        FontWeight->Bold,
        FontColor->RGBColor[0, 0.5, 0]]], "2", "-"]}], "+", 
    RowBox[{"108", " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"-", "\[ImaginaryI]"}], "+", 
       SqrtBox["3"]}], ")"}], " ", 
     SubsuperscriptBox[
      OverscriptBox[
       StyleBox["\[Eta]0",
        FontWeight->Bold,
        FontColor->RGBColor[0, 0.5, 0]], 
       StyleBox["_",
        FontWeight->Bold,
        FontColor->RGBColor[0, 0.5, 0]]], "3", "-"]}], "+", 
    RowBox[{"18", " ", "\[ImaginaryI]", " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"3", " ", "\[ImaginaryI]"}], "+", 
       SqrtBox["3"]}], ")"}], " ", 
     SubsuperscriptBox[
      OverscriptBox[
       StyleBox["\[Eta]0",
        FontWeight->Bold,
        FontColor->RGBColor[0, 0.5, 0]], 
       StyleBox["_",
        FontWeight->Bold,
        FontColor->RGBColor[0, 0.5, 0]]], "4", "-"]}]}], ")"}]}]], "Output",
 CellChangeTimes->{
  3.563004445790999*^9, {3.5630044898731203`*^9, 3.5630045260391607`*^9}, 
   3.5630045874959507`*^9, 3.563019896591077*^9, 3.56301996714139*^9, {
   3.563020344756689*^9, 3.563020357296851*^9}, 3.5630205488987637`*^9, {
   3.563025159761138*^9, 3.563025178824545*^9}, 3.563027173811735*^9, 
   3.563081914614807*^9, {3.5632819026651363`*^9, 3.563281913509924*^9}, {
   3.563281951394792*^9, 3.563281956834969*^9}}]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[Cell[BoxData[
 FormBox[
  RowBox[{
   RowBox[{"Log", "[", 
    FractionBox[
     SubscriptBox["\[Rho]", 
      RowBox[{"2", ",", "asym"}]], 
     SubsuperscriptBox["\[GothicCapitalT]", 
      RowBox[{"0", ",", "1"}], "c"]], "]"}], "\[Equal]", 
   RowBox[{"-", "ratLogT01c"}]}], TraditionalForm]],
 FormatType->"TraditionalForm"]], "Subsubsection",
 CellChangeTimes->{{3.546860158703958*^9, 3.546860185529262*^9}, {
   3.546941201745359*^9, 3.54694121121525*^9}, {3.546942156630391*^9, 
   3.54694220195328*^9}, {3.546942439767205*^9, 3.546942458261949*^9}, 
   3.546943916010236*^9, 3.553714688798966*^9, {3.553718739365039*^9, 
   3.553718739365212*^9}, {3.553718832356677*^9, 3.553718835749504*^9}, {
   3.555796614741125*^9, 3.555796642521941*^9}, {3.555846358885466*^9, 
   3.555846358885632*^9}, {3.561443297574994*^9, 3.561443319878765*^9}, {
   3.563024325521633*^9, 3.56302435495133*^9}}],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"dsLogRat", "[", 
    RowBox[{
     SubscriptBox["T", 
      RowBox[{"0", ",", "1"}]], ",", "9"}], "]"}], "//", "Normal"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{"%", "/.", 
         RowBox[{"g", "\[Rule]", "1"}]}], "/.", 
        RowBox[{"dsweak", "[", "2", "]"}]}], "/.", 
       RowBox[{"nsweak", "[", "2", "]"}]}], "/.", 
      RowBox[{"leadweak", "[", "2", "]"}]}], "/.", "subQ0"}], "/.", 
    RowBox[{"u", "\[Rule]", 
     RowBox[{"2", "g", " ", "z"}]}]}], "/.", 
   RowBox[{"TaylorOptions", "[", 
    RowBox[{
     RowBox[{"Variable", "\[Rule]", "g"}], ",", 
     RowBox[{"\[Eta]Factor", "\[Rule]", 
      RowBox[{"2", "z"}]}], ",", 
     RowBox[{"Order", "\[Rule]", "9"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"ratLogT01c", "=", 
  RowBox[{"Collect", "[", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{"%", "//.", "denz"}], "//.", "subZetaReduce"}], "/.", 
      "subIm"}], "//", "Expand"}], ",", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"g", ",", 
       SqrtBox[
        RowBox[{"1", "-", 
         SuperscriptBox["z", "2"]}]], ",", "\[Zeta]list"}], "}"}], "//", 
     "Flatten"}], ",", "Simplify"}], "]"}]}]}], "Input",
 CellChangeTimes->{{3.563020561877759*^9, 3.56302072728476*^9}, {
   3.563020760807683*^9, 3.563020768608046*^9}, {3.563020960556119*^9, 
   3.5630210710937243`*^9}, {3.563023121075365*^9, 3.5630231238832817`*^9}, {
   3.563024163441079*^9, 3.563024170874432*^9}, {3.5630243211543503`*^9, 
   3.563024328637012*^9}, 3.563024377360428*^9, {3.563081972139367*^9, 
   3.56308203501889*^9}, {3.5630821811939983`*^9, 3.563082181929844*^9}, {
   3.5630822358291283`*^9, 3.5630822369187527`*^9}, {3.5632820158867073`*^9, 
   3.563282095903934*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   SuperscriptBox["g", "7"], " ", 
   SqrtBox[
    RowBox[{"1", "-", 
     SuperscriptBox["z", "2"]}]], " ", 
   RowBox[{"(", 
    RowBox[{"162", "-", 
     RowBox[{"108", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2"]}], "-", 
     RowBox[{"108", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3"]}], "+", 
     RowBox[{"72", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3"]}]}], ")"}]}], "+", 
  RowBox[{
   SuperscriptBox["g", "9"], " ", 
   SqrtBox[
    RowBox[{"1", "-", 
     SuperscriptBox["z", "2"]}]], " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{
      RowBox[{"-", "162"}], " ", 
      RowBox[{"(", 
       RowBox[{"25", "+", 
        RowBox[{"12", " ", 
         SuperscriptBox["z", "2"]}]}], ")"}]}], "+", 
     RowBox[{"324", " ", 
      RowBox[{"(", 
       RowBox[{"3", "+", 
        RowBox[{"8", " ", 
         SuperscriptBox["z", "2"]}]}], ")"}], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2"]}], "+", 
     FractionBox[
      RowBox[{"2376", " ", 
       SubsuperscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "2", "2"]}], "5"], "-", 
     FractionBox[
      RowBox[{"1296", " ", 
       SubsuperscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "2", "3"]}], "5"], "-", 
     RowBox[{"324", " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "11"}], "+", 
        RowBox[{"8", " ", 
         SuperscriptBox["z", "2"]}]}], ")"}], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3"]}], "+", 
     RowBox[{"72", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3"]}], "+", 
     RowBox[{
      FractionBox["288", "5"], " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "1"}], "+", 
        RowBox[{"6", " ", 
         SuperscriptBox["z", "2"]}]}], ")"}], " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2", "2"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3"]}], "-", 
     RowBox[{"1296", " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3", "2"]}], "+", 
     RowBox[{"324", " ", 
      RowBox[{"(", 
       RowBox[{"1", "+", 
        RowBox[{"8", " ", 
         SuperscriptBox["z", "2"]}]}], ")"}], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "5"]}], "-", 
     RowBox[{"216", " ", 
      RowBox[{"(", 
       RowBox[{"1", "+", 
        RowBox[{"8", " ", 
         SuperscriptBox["z", "2"]}]}], ")"}], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "5"]}]}], ")"}]}], "+", 
  RowBox[{
   SuperscriptBox["g", "8"], " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"324", " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "1"}], "+", 
        RowBox[{"2", " ", 
         SuperscriptBox["z", "2"]}]}], ")"}], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2"]}], "+", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"108", "-", 
        FractionBox[
         RowBox[{"1296", " ", 
          SuperscriptBox["z", "2"]}], "5"]}], ")"}], " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2", "2"]}], "-", 
     RowBox[{
      FractionBox["48", "35"], " ", 
      RowBox[{"(", 
       RowBox[{"31", "+", 
        RowBox[{"246", " ", 
         SuperscriptBox["z", "2"]}]}], ")"}], " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2", "3"]}], "+", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"1404", "-", 
        RowBox[{"216", " ", 
         SuperscriptBox["z", "2"]}]}], ")"}], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3"]}], "-", 
     RowBox[{"108", " ", 
      RowBox[{"(", 
       RowBox[{"1", "+", 
        RowBox[{"8", " ", 
         SuperscriptBox["z", "2"]}]}], ")"}], " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3", "2"]}], "+", 
     RowBox[{"72", " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "13"}], "+", 
        RowBox[{"32", " ", 
         SuperscriptBox["z", "2"]}]}], ")"}], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "5"]}], "+", 
     RowBox[{"252", " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "1"}], "+", 
        RowBox[{"4", " ", 
         SuperscriptBox["z", "2"]}]}], ")"}], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "7"]}], "-", 
     RowBox[{"9", " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"72", " ", 
         SuperscriptBox["z", "2"]}], "+", 
        RowBox[{"\[ImaginaryI]", " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"81", " ", "\[ImaginaryI]"}], "+", 
           RowBox[{"12", " ", 
            SqrtBox["3"], " ", 
            SubsuperscriptBox[
             StyleBox["\[Eta]0",
              FontWeight->Bold,
              FontColor->RGBColor[0, 0.5, 0]], "2", "+"]}], "-", 
           RowBox[{"12", " ", 
            SubsuperscriptBox[
             StyleBox["\[Eta]0",
              FontWeight->Bold,
              FontColor->RGBColor[0, 0.5, 0]], "3", "+"]}], "+", 
           RowBox[{"2", " ", 
            SqrtBox["3"], " ", 
            SubsuperscriptBox[
             StyleBox["\[Eta]0",
              FontWeight->Bold,
              FontColor->RGBColor[0, 0.5, 0]], "4", "+"]}], "-", 
           RowBox[{"12", " ", 
            SqrtBox["3"], " ", 
            SubsuperscriptBox[
             OverscriptBox[
              StyleBox["\[Eta]0",
               FontWeight->Bold,
               FontColor->RGBColor[0, 0.5, 0]], 
              StyleBox["_",
               FontWeight->Bold,
               FontColor->RGBColor[0, 0.5, 0]]], "2", "-"]}], "+", 
           RowBox[{"12", " ", 
            SubsuperscriptBox[
             OverscriptBox[
              StyleBox["\[Eta]0",
               FontWeight->Bold,
               FontColor->RGBColor[0, 0.5, 0]], 
              StyleBox["_",
               FontWeight->Bold,
               FontColor->RGBColor[0, 0.5, 0]]], "3", "-"]}], "-", 
           RowBox[{"2", " ", 
            SqrtBox["3"], " ", 
            SubsuperscriptBox[
             OverscriptBox[
              StyleBox["\[Eta]0",
               FontWeight->Bold,
               FontColor->RGBColor[0, 0.5, 0]], 
              StyleBox["_",
               FontWeight->Bold,
               FontColor->RGBColor[0, 0.5, 0]]], "4", "-"]}]}], ")"}]}]}], 
       ")"}]}]}], ")"}]}]}]], "Output",
 CellChangeTimes->{{3.56302057047145*^9, 3.5630205890392637`*^9}, {
   3.563020707423458*^9, 3.563020729174224*^9}, 3.563020771476727*^9, {
   3.5630209647013683`*^9, 3.5630210721330223`*^9}, {3.563023112980873*^9, 
   3.56302312472567*^9}, {3.5630241650033484`*^9, 3.563024172646908*^9}, 
   3.5630243794501123`*^9, 3.563025189570813*^9, 3.5630271843589153`*^9, {
   3.563082020882184*^9, 3.563082050748218*^9}, 3.563082184488924*^9, 
   3.563082464379698*^9, {3.563282046173884*^9, 3.563282096864048*^9}}]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[Cell[BoxData[
 RowBox[{
  RowBox[{"-", 
   RowBox[{"Log", "[", 
    RowBox[{
     SuperscriptBox[
      StyleBox["\[ScriptCapitalT]",
       FontColor->RGBColor[1, 0, 0]], "-"], " ", 
     SuperscriptBox[
      StyleBox["\[ScriptCapitalT]",
       FontColor->RGBColor[1, 0, 0]], "+"]}], "]"}]}], "\[Equal]", 
  "ratioTright"}]],
 CellChangeTimes->{{3.546687667733313*^9, 3.546687694430181*^9}, {
  3.546930060725745*^9, 3.546930086044445*^9}, {3.546930226332904*^9, 
  3.546930243522461*^9}, {3.546931545956169*^9, 
  3.546931547536798*^9}}]], "Subsubsection",
 CellChangeTimes->{
  3.546937572863883*^9, {3.5469381704542503`*^9, 3.546938184193096*^9}, {
   3.546939399028844*^9, 3.546939401121449*^9}, {3.553713948809174*^9, 
   3.553713948809338*^9}, {3.5537143203026648`*^9, 3.553714323049741*^9}, {
   3.5557966614846478`*^9, 3.55579666148482*^9}, {3.5614661043309917`*^9, 
   3.5614661126320744`*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{
      SuperscriptBox[
       StyleBox["\[ScriptCapitalC]", "Dafault"], 
       RowBox[{"[", "o", "]"}]], "\[Rule]", " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         FractionBox["1", "2"], "\[Delta]\[Rho]"}], "+", 
        RowBox[{"PV", "[", "\[Delta]\[Rho]", "]"}]}], ")"}]}], ",", 
     RowBox[{
      SuperscriptBox[
       StyleBox["\[ScriptCapitalC]", "Dafault"], 
       RowBox[{"[", 
        RowBox[{"-", "o"}], "]"}]], "\[Rule]", " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         RowBox[{"-", 
          FractionBox["1", "2"]}], "\[Delta]\[Rho]"}], "+", 
        RowBox[{"PV", "[", "\[Delta]\[Rho]", "]"}]}], ")"}]}], ",", 
     RowBox[{
      SuperscriptBox["\[ScriptCapitalC]", 
       RowBox[{"[", 
        RowBox[{"+", "2"}], "]"}]], "\[Rule]", " ", 
      RowBox[{"Normal", "@", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          RowBox[{"Expand", "/@", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"Series", "[", 
              RowBox[{
               RowBox[{
                RowBox[{"-", 
                 FractionBox[
                  RowBox[{"2", "g"}], 
                  RowBox[{"2", " ", "\[ImaginaryI]"}]]}], 
                FractionBox["w", 
                 RowBox[{
                  RowBox[{"2", "g", " ", "z"}], "+", "\[ImaginaryI]"}]]}], 
               ",", 
               RowBox[{"{", 
                RowBox[{"g", ",", "0", ",", "14"}], "}"}]}], "]"}], "/.", 
             RowBox[{"z", "\[Rule]", 
              RowBox[{"(", 
               RowBox[{"z", "-", "w"}], ")"}]}]}], ")"}]}], "/.", 
          RowBox[{
           SuperscriptBox["w", "a_."], "\[RuleDelayed]", 
           RowBox[{"If", "[", 
            RowBox[{
             RowBox[{"EvenQ", "[", "a", "]"}], ",", "0", ",", 
             SuperscriptBox["w", "a"]}], "]"}]}]}], "/.", 
         RowBox[{
          SuperscriptBox["w", "a_."], "\[RuleDelayed]", 
          RowBox[{"M", "[", 
           RowBox[{
            SuperscriptBox["w", 
             RowBox[{"a", "-", "1"}]], "\[Delta]\[Rho]"}], "]"}]}]}], 
        ")"}]}]}], ",", 
     RowBox[{
      SuperscriptBox["\[ScriptCapitalC]", 
       RowBox[{"[", 
        RowBox[{"-", "2"}], "]"}]], "\[Rule]", " ", 
      RowBox[{"Normal", "@", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          RowBox[{"Expand", "/@", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"Series", "[", 
              RowBox[{
               RowBox[{
                RowBox[{"-", 
                 FractionBox[
                  RowBox[{"2", "g"}], 
                  RowBox[{"2", " ", "\[ImaginaryI]"}]]}], 
                FractionBox["w", 
                 RowBox[{
                  RowBox[{"2", "g", " ", "z"}], "-", "\[ImaginaryI]"}]]}], 
               ",", 
               RowBox[{"{", 
                RowBox[{"g", ",", "0", ",", "14"}], "}"}]}], "]"}], "/.", 
             RowBox[{"z", "\[Rule]", 
              RowBox[{"(", 
               RowBox[{"z", "-", "w"}], ")"}]}]}], ")"}]}], "/.", 
          RowBox[{
           SuperscriptBox["w", "a_."], "\[RuleDelayed]", 
           RowBox[{"If", "[", 
            RowBox[{
             RowBox[{"EvenQ", "[", "a", "]"}], ",", "0", ",", 
             SuperscriptBox["w", "a"]}], "]"}]}]}], "/.", 
         RowBox[{
          SuperscriptBox["w", "a_."], "\[RuleDelayed]", 
          RowBox[{"M", "[", 
           RowBox[{
            SuperscriptBox["w", 
             RowBox[{"a", "-", "1"}]], "\[Delta]\[Rho]"}], "]"}]}]}], 
        ")"}]}]}]}], "}"}], "/.", 
   RowBox[{"\[Delta]\[Rho]", "\[Rule]", 
    RowBox[{"Expand", "[", 
     RowBox[{
      SuperscriptBox["g", "9"], 
      RowBox[{"(", 
       RowBox[{
        SubscriptBox["\[Delta]\[Rho]", "lead"], "+", 
        RowBox[{
         SuperscriptBox["g", "2"], 
         SubscriptBox["\[Delta]\[Rho]", "sublead"]}], "+", 
        RowBox[{
         SuperscriptBox["g", "4"], 
         SubscriptBox["\[Delta]\[Rho]", "sublead2"]}]}], ")"}]}], "]"}]}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{"%", "/.", 
        RowBox[{
         RowBox[{"PV", "[", "a_", "]"}], "\[RuleDelayed]", 
         RowBox[{"PV", "[", 
          RowBox[{"Expand", "[", "a", "]"}], "]"}]}]}], "//.", 
       RowBox[{
        RowBox[{"PV", "[", 
         RowBox[{
          RowBox[{
           SuperscriptBox["g", "a_."], "b_."}], "+", "c_"}], "]"}], 
        "\[RuleDelayed]", 
        RowBox[{
         RowBox[{
          SuperscriptBox["g", "a"], 
          RowBox[{"PV", "[", "b", "]"}]}], "+", 
         RowBox[{"PV", "[", "c", "]"}]}]}]}], "/.", 
      RowBox[{
       RowBox[{"PV", "[", 
        RowBox[{
         SuperscriptBox["g", "a_."], "b_."}], "]"}], "\[RuleDelayed]", 
       RowBox[{
        SuperscriptBox["g", "a"], 
        RowBox[{"PV", "[", "b", "]"}]}]}]}], "/.", 
     RowBox[{
      RowBox[{"M", "[", "a_", "]"}], "\[RuleDelayed]", 
      RowBox[{"M", "[", 
       RowBox[{"Expand", "[", "a", "]"}], "]"}]}]}], "//.", 
    RowBox[{
     RowBox[{"M", "[", 
      RowBox[{
       RowBox[{
        SuperscriptBox["g", "a_."], "b_."}], "+", "c_"}], "]"}], 
     "\[RuleDelayed]", 
     RowBox[{
      RowBox[{
       SuperscriptBox["g", "a"], 
       RowBox[{"M", "[", "b", "]"}]}], "+", 
      RowBox[{"M", "[", "c", "]"}]}]}]}], "/.", 
   RowBox[{
    RowBox[{"M", "[", 
     RowBox[{
      SuperscriptBox["g", "a_."], "b_."}], "]"}], "\[RuleDelayed]", 
    RowBox[{
     SuperscriptBox["g", "a"], 
     RowBox[{"M", "[", "b", "]"}]}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"tmpsubs", "=", 
   RowBox[{"%", "/.", 
    RowBox[{
     RowBox[{"Rule", "[", 
      RowBox[{"a_", ",", "b_"}], "]"}], "\[RuleDelayed]", 
     RowBox[{"Rule", "[", 
      RowBox[{"a", ",", 
       RowBox[{"Normal", "@", 
        RowBox[{"Series", "[", 
         RowBox[{"b", ",", 
          RowBox[{"{", 
           RowBox[{"g", ",", "0", ",", "21"}], "}"}]}], "]"}]}]}], 
      "]"}]}]}]}], ";"}]}], "Input",
 CellChangeTimes->{{3.5557926931303463`*^9, 3.555792731138949*^9}, {
  3.555793093764945*^9, 3.555793135131957*^9}, {3.555793486990962*^9, 
  3.5557935493591757`*^9}, {3.555793593986315*^9, 3.555793701494273*^9}, {
  3.555793743616707*^9, 3.555793794397271*^9}, {3.5557938466776657`*^9, 
  3.555793864501933*^9}, {3.555793900844964*^9, 3.5557939344919853`*^9}, {
  3.555793995318914*^9, 3.555794001438005*^9}, {3.555794054940826*^9, 
  3.555794103980994*^9}, {3.555794180073298*^9, 3.555794183201223*^9}, {
  3.5557943495763617`*^9, 3.555794354961646*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Log", "[", 
   FractionBox[
    StyleBox["\[ScriptCapitalT]",
     FontColor->RGBColor[1, 0, 0]], 
    SubscriptBox[
     StyleBox["\[ScriptCapitalT]",
      FontColor->RGBColor[1, 0, 0]], "asym"]], "]"}], "==", 
  FractionBox[
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      SuperscriptBox[
       StyleBox["\[ScriptCapitalC]", "Dafault"], "+"], "-", 
      SuperscriptBox["\[ScriptCapitalC]", "-"]}], ")"}], 
    OverscriptBox["*", "^"], "\[Delta]\[Rho]"}], 
   SubscriptBox[
    StyleBox["\[ScriptCapitalT]",
     FontColor->RGBColor[1, 0, 0]], "asym"]]}]], "Input",
 CellChangeTimes->{{3.555792380653092*^9, 3.555792391934897*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"-", 
   RowBox[{"Log", "[", 
    SubscriptBox[
     RowBox[{"(", 
      RowBox[{
       SuperscriptBox[
        StyleBox["\[ScriptCapitalT]",
         FontColor->RGBColor[1, 0, 0]], "-"], " ", 
       SuperscriptBox[
        StyleBox["\[ScriptCapitalT]",
         FontColor->RGBColor[1, 0, 0]], "+"]}], ")"}], "r"], "]"}]}], 
  "\[Equal]", 
  RowBox[{"-", 
   RowBox[{"(", 
    RowBox[{
     FractionBox[
      RowBox[{"(", 
       RowBox[{
        SuperscriptBox[
         StyleBox["\[ScriptCapitalC]", "Dafault"], 
         RowBox[{"[", 
          RowBox[{"+", "2"}], "]"}]], "-", 
        SuperscriptBox["\[ScriptCapitalC]", 
         RowBox[{"[", 
          RowBox[{"-", "o"}], "]"}]]}], ")"}], 
      RowBox[{
       SuperscriptBox[
        StyleBox["\[ScriptCapitalT]",
         FontColor->RGBColor[1, 0, 0]], "+"], "/.", "largevolume"}]], "+", 
     FractionBox[
      RowBox[{"(", 
       RowBox[{
        SuperscriptBox[
         StyleBox["\[ScriptCapitalC]", "Dafault"], 
         RowBox[{"[", 
          RowBox[{"+", "o"}], "]"}]], "-", 
        SuperscriptBox["\[ScriptCapitalC]", 
         RowBox[{"[", 
          RowBox[{"-", "2"}], "]"}]]}], ")"}], 
      RowBox[{
       SuperscriptBox[
        StyleBox["\[ScriptCapitalT]",
         FontColor->RGBColor[1, 0, 0]], "-"], "/.", "largevolume"}]]}], 
    ")"}]}]}]], "Input",
 CellChangeTimes->{{3.5557923593885603`*^9, 3.5557923852974243`*^9}, {
  3.555793154050644*^9, 3.555793247831085*^9}, {3.555793339732451*^9, 
  3.555793365775256*^9}, {3.561466130805558*^9, 3.56146615556593*^9}},
 EmphasizeSyntaxErrors->True],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"Series", "[", 
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{"-", 
         RowBox[{"(", 
          RowBox[{
           FractionBox[
            RowBox[{"(", 
             RowBox[{
              SuperscriptBox[
               StyleBox["\[ScriptCapitalC]", "Dafault"], 
               RowBox[{"[", 
                RowBox[{"+", "2"}], "]"}]], "-", 
              SuperscriptBox["\[ScriptCapitalC]", 
               RowBox[{"[", 
                RowBox[{"-", "o"}], "]"}]]}], ")"}], 
            RowBox[{
             SuperscriptBox[
              StyleBox["\[ScriptCapitalT]",
               FontColor->RGBColor[1, 0, 0]], "+"], "/.", "largevolume"}]], 
           "+", 
           FractionBox[
            RowBox[{"(", 
             RowBox[{
              SuperscriptBox[
               StyleBox["\[ScriptCapitalC]", "Dafault"], 
               RowBox[{"[", 
                RowBox[{"+", "o"}], "]"}]], "-", 
              SuperscriptBox["\[ScriptCapitalC]", 
               RowBox[{"[", 
                RowBox[{"-", "2"}], "]"}]]}], ")"}], 
            RowBox[{
             SuperscriptBox[
              StyleBox["\[ScriptCapitalT]",
               FontColor->RGBColor[1, 0, 0]], "-"], "/.", "largevolume"}]]}], 
          ")"}]}], "/.", "subJuk"}], "/.", 
       RowBox[{"u", "\[Rule]", 
        RowBox[{"2", "g", " ", "z"}]}]}], "/.", 
      RowBox[{"leadweak", "[", "3", "]"}]}], ",", 
     RowBox[{"{", 
      RowBox[{"g", ",", "0", ",", "2"}], "}"}]}], "]"}], "//", "Simplify"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"%", "/.", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         RowBox[{"-", "\[ImaginaryI]"}], " ", "z"}], "+", 
        SqrtBox[
         RowBox[{"1", "-", 
          SuperscriptBox["z", "2"]}]]}], ")"}], "\[Rule]", 
      FractionBox["1", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          RowBox[{"+", "\[ImaginaryI]"}], " ", "z"}], "+", 
         SqrtBox[
          RowBox[{"1", "-", 
           SuperscriptBox["z", "2"]}]]}], ")"}]]}]}], "//", "Simplify"}], "//",
    "Normal"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"ratioTright", "=", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{"Collect", "[", 
         RowBox[{"#", ",", 
          SqrtBox[
           RowBox[{"1", "-", 
            SuperscriptBox["z", "2"]}]]}], "]"}], "&"}], "/@", 
       RowBox[{"Series", "[", 
        RowBox[{
         RowBox[{"%", "/.", "tmpsubs"}], ",", 
         RowBox[{"{", 
          RowBox[{"g", ",", "0", ",", "9"}], "}"}]}], "]"}]}], "/.", 
      "subAnsatz"}], "/.", 
     RowBox[{"Extract", "[", 
      RowBox[{"solut\[Rho]s", ",", 
       RowBox[{"Position", "[", 
        RowBox[{"solut\[Rho]s", ",", 
         RowBox[{"Rule", "[", 
          RowBox[{"_", ",", "0"}], "]"}]}], "]"}]}], "]"}]}], "/.", 
    "solut\[Rho]sexplicit"}], "//", "Normal"}]}]}], "Input",
 CellChangeTimes->{{3.555793382372897*^9, 3.555793424351448*^9}, {
   3.555793457462407*^9, 3.555793469337389*^9}, {3.5557940170303707`*^9, 
   3.555794045516943*^9}, {3.5557941132338533`*^9, 3.5557941133217087`*^9}, {
   3.555794149944571*^9, 3.5557942095686007`*^9}, 3.555794364601985*^9, {
   3.5614661608720922`*^9, 3.561466208143837*^9}, {3.563024611323635*^9, 
   3.563024611609935*^9}, {3.5632821693685493`*^9, 3.563282186960471*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"-", 
   SuperscriptBox["g", "9"]}], " ", 
  SqrtBox[
   RowBox[{"1", "-", 
    SuperscriptBox["z", "2"]}]], " ", 
  RowBox[{"(", 
   RowBox[{
    RowBox[{"-", "162"}], "-", 
    RowBox[{"432", " ", 
     SubscriptBox[
      StyleBox["\[Zeta]",
       FontWeight->Bold,
       FontColor->GrayLevel[0.4]], "3"]}], "+", 
    RowBox[{"432", " ", 
     SubscriptBox[
      StyleBox["\[Zeta]",
       FontWeight->Bold,
       FontColor->GrayLevel[0.4]], "5"]}], "+", 
    RowBox[{"504", " ", 
     SubscriptBox[
      StyleBox["\[Zeta]",
       FontWeight->Bold,
       FontColor->GrayLevel[0.4]], "7"]}]}], ")"}]}]], "Output",
 CellChangeTimes->{{3.55579337482847*^9, 3.5557934261584167`*^9}, 
   3.555793470047677*^9, 3.555794008112857*^9, {3.555794046057785*^9, 
   3.555794074157858*^9}, {3.5557941104297733`*^9, 3.55579411366818*^9}, {
   3.555794150674142*^9, 3.555794210340721*^9}, 3.5557943668668327`*^9, 
   3.5558459157034187`*^9, {3.561466176593794*^9, 3.561466208525209*^9}, 
   3.5614680684108477`*^9, 3.56223873520168*^9, {3.563024608070737*^9, 
   3.563024612075655*^9}, 3.563024711795*^9, 3.563027212800016*^9, {
   3.5632821577600813`*^9, 3.563282187412483*^9}}]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[Cell[BoxData[
 RowBox[{
  RowBox[{"4", 
   RowBox[{"\[DoubleStruckCapitalC]", "[", 
    RowBox[{
     FractionBox["1", "u"], 
     RowBox[{"Log", "[", 
      SubscriptBox[
       RowBox[{"(", 
        SuperscriptBox[
         StyleBox["\[GothicCapitalT]",
          FontColor->RGBColor[0.54, 0.35, 0.15]], "+"], ")"}], "r"], "]"}]}], 
    "]"}]}], "==", "rltCT"}]],
 CellChangeTimes->{{3.561386514062299*^9, 3.561386523180409*^9}, {
   3.561386578105949*^9, 3.561386583994787*^9}, {3.561386769029749*^9, 
   3.5613867794913883`*^9}, {3.5614395433531227`*^9, 3.561439621599678*^9}, 
   3.561439718612031*^9, {3.56144213822748*^9, 3.561442172554162*^9}, {
   3.5614422453803673`*^9, 3.5614422461177464`*^9}, {3.5614643887266417`*^9, 
   3.5614644640112658`*^9}, {3.561466060612913*^9, 
   3.5614660626098623`*^9}}]], "Subsubsection",
 CellChangeTimes->{
  3.561466243363893*^9, {3.56146792094175*^9, 3.5614679213131247`*^9}}],

Cell[TextData[{
 "We will use result of computing \[Delta]\[GothicCapitalT] section to get ",
 Cell[BoxData[
  RowBox[{"Log", "[", 
   SubscriptBox[
    RowBox[{"(", 
     StyleBox["\[GothicCapitalT]",
      FontColor->RGBColor[0.54, 0.35, 0.15]], ")"}], "r"], "]"}]],
  CellChangeTimes->{{3.561386514062299*^9, 3.561386523180409*^9}, {
    3.561386578105949*^9, 3.561386583994787*^9}, {3.561386769029749*^9, 
    3.5613867794913883`*^9}, {3.5614395433531227`*^9, 3.561439621599678*^9}, 
    3.561439718612031*^9, {3.56144213822748*^9, 3.561442172554162*^9}, {
    3.5614422453803673`*^9, 3.5614422461177464`*^9}, {3.5614643887266417`*^9, 
    3.5614644640112658`*^9}, {3.561466060612913*^9, 
    3.5614660626098623`*^9}}],
 ". Then we will shift and integrate it"
}], "Text",
 CellChangeTimes->{{3.561466309640645*^9, 3.561466326966001*^9}, {
  3.561466474908064*^9, 3.561466491776785*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"tmp", "=", 
  RowBox[{
   RowBox[{"nsLogRat", "[", 
    RowBox[{
     SubsuperscriptBox["T", 
      RowBox[{"1", ",", "1"}], "+"], ",", "9"}], "]"}], "//", 
   "Normal"}]}]], "Input",
 CellChangeTimes->{{3.5632824884661818`*^9, 3.5632824888415337`*^9}}],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"nspowers", "::", "asymcheck"}], "MessageName"], 
  RowBox[{
  ":", " "}], "\<\"\[NoBreak]\\!\\(\\(\\(\\*StyleBox[\\\"q\\\", \
List[Rule[FontColor, RGBColor[0, 0, 0.8`]]]]\\)\\&\\(\\*StyleBox[\\\"_\\\", \
List[Rule[FontColor, RGBColor[0, 0, 0.8`]]]]\\)\\)\\_\\(2, \\\"as\\\"\\)\\)\
\[NoBreak] assumed to be in the ordinary regime\"\>"}]], "Message", "MSG",
 CellChangeTimes->{
  3.563282404543396*^9, {3.563282481454047*^9, 3.5632824902842407`*^9}}],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"nspowers", "::", "asymcheck"}], "MessageName"], 
  RowBox[{
  ":", " "}], "\<\"\[NoBreak]\\!\\(\\(\\(\\*StyleBox[\\\"q\\\", \
List[Rule[FontColor, RGBColor[0, 0, 0.8`]]]]\\)\\&\\(\\*StyleBox[\\\"_\\\", \
List[Rule[FontColor, RGBColor[0, 0, 0.8`]]]]\\)\\)\\_2\\)\[NoBreak] assumed \
to be in the ordinary regime\"\>"}]], "Message", "MSG",
 CellChangeTimes->{
  3.563282404543396*^9, {3.563282481454047*^9, 3.563282490306621*^9}}],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"nspowers", "::", "asymcheck"}], "MessageName"], 
  RowBox[{
  ":", " "}], "\<\"\[NoBreak]\\!\\(\\(\\(\\*StyleBox[\\\"q\\\", \
List[Rule[FontColor, RGBColor[0, 0, 0.8`]]]]\\)\\&\\(\\*StyleBox[\\\"_\\\", \
List[Rule[FontColor, RGBColor[0, 0, 0.8`]]]]\\)\\)\\_2\\)\[NoBreak] assumed \
to be in the ordinary regime\"\>"}]], "Message", "MSG",
 CellChangeTimes->{
  3.563282404543396*^9, {3.563282481454047*^9, 3.563282490322544*^9}}],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"General", "::", "stop"}], "MessageName"], 
  RowBox[{
  ":", " "}], "\<\"Further output of \[NoBreak]\\!\\(\\*StyleBox[\\(nspowers \
:: asymcheck\\), \\\"MessageName\\\"]\\)\[NoBreak] will be suppressed during \
this calculation. \\!\\(\\*ButtonBox[\\\"\[RightSkeleton]\\\", \
ButtonStyle->\\\"Link\\\", ButtonFrame->None, \
ButtonData:>\\\"paclet:ref/message/General/stop\\\", ButtonNote -> \
\\\"General::stop\\\"]\\)\"\>"}]], "Message", "MSG",
 CellChangeTimes->{
  3.563282404543396*^9, {3.563282481454047*^9, 3.563282490338543*^9}}],

Cell[BoxData[
 FractionBox[
  RowBox[{
   SuperscriptBox["g", "8"], " ", 
   RowBox[{"(", 
    RowBox[{
     SubsuperscriptBox[
      StyleBox["q",
       FontColor->RGBColor[0, 0, 0.8]], 
      RowBox[{"2", ",", "\<\"corr\"\>"}], 
      RowBox[{"[", "2", "]"}]], "+", 
     FractionBox[
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         SubsuperscriptBox[
          StyleBox["q",
           FontColor->RGBColor[0, 0, 0.8]], 
          RowBox[{"2", ",", "4"}], 
          RowBox[{"[", "3", "]"}]], "-", 
         RowBox[{
          SubsuperscriptBox[
           StyleBox["q",
            FontColor->RGBColor[0, 0, 0.8]], 
           RowBox[{"1", ",", "4"}], 
           RowBox[{"[", "3", "]"}]], " ", 
          SubsuperscriptBox[
           StyleBox["q",
            FontColor->RGBColor[0, 0, 0.8]], 
           RowBox[{"2", ",", "\<\"as\"\>"}], 
           RowBox[{"[", "2", "]"}]]}]}], ")"}], " ", 
       RowBox[{"(", 
        RowBox[{
         SubsuperscriptBox[
          OverscriptBox[
           StyleBox["q",
            FontColor->RGBColor[0, 0, 0.8]], 
           StyleBox["_",
            FontColor->RGBColor[0, 0, 0.8]]], 
          RowBox[{"1", ",", "4"}], "-"], "-", 
         RowBox[{
          SubsuperscriptBox[
           OverscriptBox[
            StyleBox["q",
             FontColor->RGBColor[0, 0, 0.8]], 
            StyleBox["_",
             FontColor->RGBColor[0, 0, 0.8]]], 
           RowBox[{"1", ",", "3"}], "-"], " ", 
          SubscriptBox[
           OverscriptBox[
            StyleBox["q",
             FontColor->RGBColor[0, 0, 0.8]], 
            StyleBox["_",
             FontColor->RGBColor[0, 0, 0.8]]], 
           RowBox[{"2", ",", "\<\"as\"\>"}]]}]}], ")"}]}], 
      RowBox[{
       SuperscriptBox[
        StyleBox["Q",
         FontColor->RGBColor[0.8, 0, 0]], "-"], " ", 
       SuperscriptBox[
        StyleBox["Q",
         FontColor->RGBColor[0.8, 0, 0]], 
        RowBox[{"[", "3", "]"}]]}]], "+", 
     FractionBox[
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         SubsuperscriptBox[
          StyleBox["q",
           FontColor->RGBColor[0, 0, 0.8]], 
          RowBox[{"1", ",", "4"}], 
          RowBox[{"[", "3", "]"}]], "-", 
         RowBox[{
          SubsuperscriptBox[
           StyleBox["q",
            FontColor->RGBColor[0, 0, 0.8]], 
           RowBox[{"1", ",", "3"}], 
           RowBox[{"[", "3", "]"}]], " ", 
          SubsuperscriptBox[
           StyleBox["q",
            FontColor->RGBColor[0, 0, 0.8]], 
           RowBox[{"2", ",", "\<\"as\"\>"}], 
           RowBox[{"[", "2", "]"}]]}]}], ")"}], " ", 
       RowBox[{"(", 
        RowBox[{
         SubsuperscriptBox[
          OverscriptBox[
           StyleBox["q",
            FontColor->RGBColor[0, 0, 0.8]], 
           StyleBox["_",
            FontColor->RGBColor[0, 0, 0.8]]], 
          RowBox[{"2", ",", "4"}], "-"], "-", 
         RowBox[{
          SubsuperscriptBox[
           OverscriptBox[
            StyleBox["q",
             FontColor->RGBColor[0, 0, 0.8]], 
            StyleBox["_",
             FontColor->RGBColor[0, 0, 0.8]]], 
           RowBox[{"1", ",", "4"}], "-"], " ", 
          SubscriptBox[
           OverscriptBox[
            StyleBox["q",
             FontColor->RGBColor[0, 0, 0.8]], 
            StyleBox["_",
             FontColor->RGBColor[0, 0, 0.8]]], 
           RowBox[{"2", ",", "\<\"as\"\>"}]]}]}], ")"}]}], 
      RowBox[{
       SuperscriptBox[
        StyleBox["Q",
         FontColor->RGBColor[0.8, 0, 0]], "-"], " ", 
       SuperscriptBox[
        StyleBox["Q",
         FontColor->RGBColor[0.8, 0, 0]], 
        RowBox[{"[", "3", "]"}]]}]], "+", 
     SubscriptBox[
      OverscriptBox[
       StyleBox["q",
        FontColor->RGBColor[0, 0, 0.8]], 
       StyleBox["_",
        FontColor->RGBColor[0, 0, 0.8]]], 
      RowBox[{"2", ",", "\<\"corr\"\>"}]]}], ")"}]}], 
  RowBox[{
   SubsuperscriptBox[
    StyleBox["q",
     FontColor->RGBColor[0, 0, 0.8]], 
    RowBox[{"2", ",", "\<\"as\"\>"}], 
    RowBox[{"[", "2", "]"}]], "+", 
   SubscriptBox[
    OverscriptBox[
     StyleBox["q",
      FontColor->RGBColor[0, 0, 0.8]], 
     StyleBox["_",
      FontColor->RGBColor[0, 0, 0.8]]], 
    RowBox[{"2", ",", "\<\"as\"\>"}]]}]]], "Output",
 CellChangeTimes->{
  3.5632824046129313`*^9, {3.563282481527465*^9, 3.563282490358973*^9}}]
}, Open  ]],

Cell["\<\
Here we first have to evaluate denominator\
\>", "Text",
 CellChangeTimes->{{3.5632824833684063`*^9, 3.563282494055584*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"den", "=", 
  RowBox[{
   RowBox[{"Apart", "[", 
    RowBox[{
     RowBox[{"Factor", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"Series", "[", 
         RowBox[{
          RowBox[{
           RowBox[{
            RowBox[{"1", "/", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"(", 
                RowBox[{"tmp", "/.", 
                 RowBox[{"g", "\[Rule]", "1"}]}], ")"}], "//", 
               "Denominator"}], ")"}]}], "/.", 
            RowBox[{"nsweak", "[", "2", "]"}]}], "/.", "subusu"}], ",", 
          RowBox[{"{", 
           RowBox[{"g", ",", "0", ",", "1"}], "}"}]}], "]"}], "//", 
        "Normal"}], ",", 
       RowBox[{"Extension", "\[Rule]", 
        RowBox[{"\[ImaginaryI]", "+", 
         SqrtBox["3"]}]}]}], "]"}], ",", "u"}], "]"}], "//.", 
   "subtousu"}]}]], "Input",
 CellChangeTimes->{{3.563282494732843*^9, 3.56328258192935*^9}}],

Cell[BoxData[
 RowBox[{"1", "+", 
  FractionBox["1", 
   RowBox[{
    SqrtBox["3"], " ", 
    SubsuperscriptBox[
     StyleBox["\[ScriptU]",
      FontColor->RGBColor[0, 0, 0.4]], 
     RowBox[{"-", "v0"}], "+"]}]], "-", 
  FractionBox["1", 
   RowBox[{
    SqrtBox["3"], " ", 
    SubsuperscriptBox[
     StyleBox["\[ScriptU]",
      FontColor->RGBColor[0, 0, 0.4]], "v0", "+"]}]]}]], "Output",
 CellChangeTimes->{{3.563282508931171*^9, 3.563282582261156*^9}}]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"tmp2", "=", 
   RowBox[{
    RowBox[{"Series", "[", 
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{"den", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"tmp", "/.", 
            RowBox[{"g", "\[Rule]", " ", "1"}]}], "//", "Numerator"}], 
          ")"}]}], "/.", 
        RowBox[{"nsweak", "[", "1", "]"}]}], "/.", 
       RowBox[{"leadweak", "[", "2", "]"}]}], ",", 
      RowBox[{"{", 
       RowBox[{"g", ",", "0", ",", "9"}], "}"}]}], "]"}], "//", "Normal"}]}], 
  ";"}]], "Input",
 CellChangeTimes->{{3.563282585828772*^9, 3.563282680567132*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"tmp3", "=", 
   RowBox[{"Collect", "[", 
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{"tmp2", "//.", 
          RowBox[{"shiftm\[Eta]", "[", "4", "]"}]}], "/.", "subtousu"}], "/.",
         "subQ0"}], "//", "funapartusu"}], "//", "funreduceusu"}], ",", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"g", ",", "canlist"}], "}"}], "//", "Flatten"}]}], "]"}]}], 
  ";"}]], "Input",
 CellChangeTimes->{{3.563282687452297*^9, 3.563282728897862*^9}, 
   3.5632829199160347`*^9}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"tmp4", "=", 
  RowBox[{"Collect", "[", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         FractionBox["4", "u"], "/.", "subtousu"}], ")"}], "tmp3"}], "//", 
      "funapartusu"}], "//", "funreduceusu"}], ",", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"g", ",", "canlist"}], "}"}], "//", "Flatten"}]}], 
   "]"}]}]], "Input"],

Cell[BoxData[
 RowBox[{
  SuperscriptBox["g", "8"], " ", 
  RowBox[{"(", 
   RowBox[{
    FractionBox[
     RowBox[{"1080", "+", 
      FractionBox[
       RowBox[{"4", " ", "Im1"}], 
       RowBox[{"3", " ", 
        SqrtBox["3"]}]], "+", 
      RowBox[{"3024", " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "3"]}], "-", 
      RowBox[{"5280", " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "5"]}]}], 
     StyleBox["\[ScriptU]",
      FontColor->RGBColor[0, 0, 0.4]]], "+", 
    FractionBox[
     RowBox[{"324", "-", 
      RowBox[{"432", " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "3"]}], "-", 
      RowBox[{"1440", " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "5"]}]}], 
     SuperscriptBox[
      StyleBox["\[ScriptU]",
       FontColor->RGBColor[0, 0, 0.4]], 
      RowBox[{"[", "2", "]"}]]], "+", 
    FractionBox[
     RowBox[{
      RowBox[{
       RowBox[{"-", "324"}], " ", "\[ImaginaryI]"}], "+", 
      RowBox[{"432", " ", "\[ImaginaryI]", " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "3"]}], "+", 
      RowBox[{"1440", " ", "\[ImaginaryI]", " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "5"]}]}], 
     SuperscriptBox[
      StyleBox["\[ScriptU]",
       FontColor->RGBColor[0, 0, 0.4]], "2"]], "+", 
    FractionBox[
     RowBox[{
      RowBox[{"-", "702"}], "+", 
      FractionBox[
       RowBox[{"2", " ", "\[ImaginaryI]", " ", "Im1"}], "3"], "+", 
      RowBox[{
       SqrtBox["3"], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"54", " ", "\[ImaginaryI]"}], "-", 
         FractionBox[
          RowBox[{"2", " ", "Im1"}], "9"], "+", 
         RowBox[{"864", " ", "\[ImaginaryI]", " ", 
          SubscriptBox[
           StyleBox["\[Zeta]",
            FontWeight->Bold,
            FontColor->GrayLevel[0.4]], "3"]}], "-", 
         RowBox[{"480", " ", "\[ImaginaryI]", " ", 
          SubscriptBox[
           StyleBox["\[Zeta]",
            FontWeight->Bold,
            FontColor->GrayLevel[0.4]], "5"]}]}], ")"}]}], "+", 
      RowBox[{"3360", " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "5"]}]}], 
     SubsuperscriptBox[
      StyleBox["\[ScriptU]",
       FontColor->RGBColor[0, 0, 0.4]], "v0", "+"]], "+", 
    FractionBox[
     RowBox[{
      RowBox[{"-", "702"}], "-", 
      FractionBox[
       RowBox[{"2", " ", "\[ImaginaryI]", " ", "Im1"}], "3"], "+", 
      RowBox[{
       SqrtBox["3"], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          RowBox[{"-", "54"}], " ", "\[ImaginaryI]"}], "-", 
         FractionBox[
          RowBox[{"2", " ", "Im1"}], "9"], "-", 
         RowBox[{"864", " ", "\[ImaginaryI]", " ", 
          SubscriptBox[
           StyleBox["\[Zeta]",
            FontWeight->Bold,
            FontColor->GrayLevel[0.4]], "3"]}], "+", 
         RowBox[{"480", " ", "\[ImaginaryI]", " ", 
          SubscriptBox[
           StyleBox["\[Zeta]",
            FontWeight->Bold,
            FontColor->GrayLevel[0.4]], "5"]}]}], ")"}]}], "+", 
      RowBox[{"3360", " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "5"]}]}], 
     SubsuperscriptBox[
      StyleBox["\[ScriptU]",
       FontColor->RGBColor[0, 0, 0.4]], 
      RowBox[{"-", "v0"}], "+"]], "+", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       FractionBox["216", 
        StyleBox["\[ScriptU]",
         FontColor->RGBColor[0, 0, 0.4]]], "+", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          RowBox[{
           RowBox[{"-", "5184"}], " ", "\[ImaginaryI]"}], "-", 
          RowBox[{"2592", " ", "u"}]}], ")"}], " ", 
        SubscriptBox[
         StyleBox["\[Zeta]",
          FontWeight->Bold,
          FontColor->GrayLevel[0.4]], "3"]}], "+", 
       FractionBox[
        RowBox[{
         RowBox[{"-", "216"}], "+", 
         RowBox[{"864", " ", 
          SubscriptBox[
           StyleBox["\[Zeta]",
            FontWeight->Bold,
            FontColor->GrayLevel[0.4]], "3"]}]}], 
        SuperscriptBox[
         StyleBox["\[ScriptU]",
          FontColor->RGBColor[0, 0, 0.4]], 
         RowBox[{"[", "2", "]"}]]], "+", 
       FractionBox[
        RowBox[{
         RowBox[{
          SqrtBox["3"], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{
             RowBox[{"-", "432"}], " ", "\[ImaginaryI]"}], "-", 
            RowBox[{"480", " ", "\[ImaginaryI]", " ", 
             SubscriptBox[
              StyleBox["\[Zeta]",
               FontWeight->Bold,
               FontColor->GrayLevel[0.4]], "5"]}]}], ")"}]}], "-", 
         RowBox[{"480", " ", 
          SubscriptBox[
           StyleBox["\[Zeta]",
            FontWeight->Bold,
            FontColor->GrayLevel[0.4]], "5"]}]}], 
        SubsuperscriptBox[
         StyleBox["\[ScriptU]",
          FontColor->RGBColor[0, 0, 0.4]], 
         RowBox[{"-", "v0"}], "+"]], "+", 
       FractionBox[
        RowBox[{
         RowBox[{
          SqrtBox["3"], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"432", " ", "\[ImaginaryI]"}], "+", 
            RowBox[{"480", " ", "\[ImaginaryI]", " ", 
             SubscriptBox[
              StyleBox["\[Zeta]",
               FontWeight->Bold,
               FontColor->GrayLevel[0.4]], "5"]}]}], ")"}]}], "-", 
         RowBox[{"480", " ", 
          SubscriptBox[
           StyleBox["\[Zeta]",
            FontWeight->Bold,
            FontColor->GrayLevel[0.4]], "5"]}]}], 
        SubsuperscriptBox[
         StyleBox["\[ScriptU]",
          FontColor->RGBColor[0, 0, 0.4]], "v0", "+"]]}], ")"}], " ", 
     SubsuperscriptBox[
      StyleBox["\[Eta]",
       FontWeight->Bold,
       FontColor->RGBColor[0.8, 0, 0]], "2", 
      RowBox[{"[", "2", "]"}]]}], "+", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{"-", 
        FractionBox[
         RowBox[{"648", " ", "\[ImaginaryI]"}], 
         StyleBox["\[ScriptU]",
          FontColor->RGBColor[0, 0, 0.4]]]}], "-", 
       FractionBox[
        RowBox[{"216", " ", "\[ImaginaryI]"}], 
        SuperscriptBox[
         StyleBox["\[ScriptU]",
          FontColor->RGBColor[0, 0, 0.4]], 
         RowBox[{"[", "2", "]"}]]], "+", 
       RowBox[{"576", " ", 
        SubscriptBox[
         StyleBox["\[Zeta]",
          FontWeight->Bold,
          FontColor->GrayLevel[0.4]], "3"]}], "+", 
       FractionBox[
        RowBox[{
         RowBox[{"432", " ", "\[ImaginaryI]"}], "+", 
         RowBox[{"288", " ", "\[ImaginaryI]", " ", 
          SubscriptBox[
           StyleBox["\[Zeta]",
            FontWeight->Bold,
            FontColor->GrayLevel[0.4]], "3"]}], "-", 
         RowBox[{"96", " ", 
          SqrtBox["3"], " ", 
          SubscriptBox[
           StyleBox["\[Zeta]",
            FontWeight->Bold,
            FontColor->GrayLevel[0.4]], "3"]}]}], 
        SubsuperscriptBox[
         StyleBox["\[ScriptU]",
          FontColor->RGBColor[0, 0, 0.4]], "v0", "+"]], "+", 
       FractionBox[
        RowBox[{
         RowBox[{"432", " ", "\[ImaginaryI]"}], "+", 
         RowBox[{"288", " ", "\[ImaginaryI]", " ", 
          SubscriptBox[
           StyleBox["\[Zeta]",
            FontWeight->Bold,
            FontColor->GrayLevel[0.4]], "3"]}], "+", 
         RowBox[{"96", " ", 
          SqrtBox["3"], " ", 
          SubscriptBox[
           StyleBox["\[Zeta]",
            FontWeight->Bold,
            FontColor->GrayLevel[0.4]], "3"]}]}], 
        SubsuperscriptBox[
         StyleBox["\[ScriptU]",
          FontColor->RGBColor[0, 0, 0.4]], 
         RowBox[{"-", "v0"}], "+"]]}], ")"}], " ", 
     SubsuperscriptBox[
      StyleBox["\[Eta]",
       FontWeight->Bold,
       FontColor->RGBColor[0.8, 0, 0]], "3", 
      RowBox[{"[", "2", "]"}]]}], "+", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       FractionBox["216", 
        StyleBox["\[ScriptU]",
         FontColor->RGBColor[0, 0, 0.4]]], "+", 
       FractionBox[
        RowBox[{
         RowBox[{"-", "108"}], "+", 
         RowBox[{
          SqrtBox["3"], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"108", " ", "\[ImaginaryI]"}], "-", 
            RowBox[{"48", " ", "\[ImaginaryI]", " ", 
             SubscriptBox[
              StyleBox["\[Zeta]",
               FontWeight->Bold,
               FontColor->GrayLevel[0.4]], "3"]}]}], ")"}]}], "+", 
         RowBox[{"48", " ", 
          SubscriptBox[
           StyleBox["\[Zeta]",
            FontWeight->Bold,
            FontColor->GrayLevel[0.4]], "3"]}]}], 
        SubsuperscriptBox[
         StyleBox["\[ScriptU]",
          FontColor->RGBColor[0, 0, 0.4]], "v0", "+"]], "+", 
       FractionBox[
        RowBox[{
         RowBox[{"-", "108"}], "+", 
         RowBox[{
          SqrtBox["3"], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{
             RowBox[{"-", "108"}], " ", "\[ImaginaryI]"}], "+", 
            RowBox[{"48", " ", "\[ImaginaryI]", " ", 
             SubscriptBox[
              StyleBox["\[Zeta]",
               FontWeight->Bold,
               FontColor->GrayLevel[0.4]], "3"]}]}], ")"}]}], "+", 
         RowBox[{"48", " ", 
          SubscriptBox[
           StyleBox["\[Zeta]",
            FontWeight->Bold,
            FontColor->GrayLevel[0.4]], "3"]}]}], 
        SubsuperscriptBox[
         StyleBox["\[ScriptU]",
          FontColor->RGBColor[0, 0, 0.4]], 
         RowBox[{"-", "v0"}], "+"]]}], ")"}], " ", 
     SubsuperscriptBox[
      StyleBox["\[Eta]",
       FontWeight->Bold,
       FontColor->RGBColor[0.8, 0, 0]], "4", 
      RowBox[{"[", "2", "]"}]]}], "+", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{"864", "-", 
       RowBox[{"432", " ", "\[ImaginaryI]", " ", "u"}], "+", 
       FractionBox[
        RowBox[{"144", " ", "\[ImaginaryI]"}], 
        SuperscriptBox[
         StyleBox["\[ScriptU]",
          FontColor->RGBColor[0, 0, 0.4]], 
         RowBox[{"[", "2", "]"}]]]}], ")"}], " ", 
     SubsuperscriptBox[
      StyleBox["\[Eta]",
       FontWeight->Bold,
       FontColor->RGBColor[0.8, 0, 0]], 
      RowBox[{"2", ",", "3"}], 
      RowBox[{"[", "2", "]"}]]}], "+", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{"144", " ", "\[ImaginaryI]"}], "+", 
       FractionBox[
        RowBox[{
         RowBox[{"-", "72"}], "+", 
         RowBox[{"24", " ", "\[ImaginaryI]", " ", 
          SqrtBox["3"]}]}], 
        SubsuperscriptBox[
         StyleBox["\[ScriptU]",
          FontColor->RGBColor[0, 0, 0.4]], 
         RowBox[{"-", "v0"}], "+"]], "+", 
       FractionBox[
        RowBox[{
         RowBox[{"-", "72"}], "-", 
         RowBox[{"24", " ", "\[ImaginaryI]", " ", 
          SqrtBox["3"]}]}], 
        SubsuperscriptBox[
         StyleBox["\[ScriptU]",
          FontColor->RGBColor[0, 0, 0.4]], "v0", "+"]]}], ")"}], " ", 
     SubsuperscriptBox[
      StyleBox["\[Eta]",
       FontWeight->Bold,
       FontColor->RGBColor[0.8, 0, 0]], 
      RowBox[{"2", ",", "4"}], 
      RowBox[{"[", "2", "]"}]]}], "+", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{"-", "864"}], "+", 
       RowBox[{"432", " ", "\[ImaginaryI]", " ", "u"}], "-", 
       FractionBox[
        RowBox[{"144", " ", "\[ImaginaryI]"}], 
        SuperscriptBox[
         StyleBox["\[ScriptU]",
          FontColor->RGBColor[0, 0, 0.4]], 
         RowBox[{"[", "2", "]"}]]]}], ")"}], " ", 
     SubsuperscriptBox[
      StyleBox["\[Eta]",
       FontWeight->Bold,
       FontColor->RGBColor[0.8, 0, 0]], 
      RowBox[{"3", ",", "2"}], 
      RowBox[{"[", "2", "]"}]]}], "+", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       FractionBox[
        RowBox[{
         RowBox[{
          RowBox[{"-", "24"}], " ", "\[ImaginaryI]"}], "+", 
         RowBox[{"24", " ", 
          SqrtBox["3"]}]}], 
        SubsuperscriptBox[
         StyleBox["\[ScriptU]",
          FontColor->RGBColor[0, 0, 0.4]], 
         RowBox[{"-", "v0"}], "+"]], "+", 
       FractionBox[
        RowBox[{
         RowBox[{
          RowBox[{"-", "24"}], " ", "\[ImaginaryI]"}], "-", 
         RowBox[{"24", " ", 
          SqrtBox["3"]}]}], 
        SubsuperscriptBox[
         StyleBox["\[ScriptU]",
          FontColor->RGBColor[0, 0, 0.4]], "v0", "+"]]}], ")"}], " ", 
     SubsuperscriptBox[
      StyleBox["\[Eta]",
       FontWeight->Bold,
       FontColor->RGBColor[0.8, 0, 0]], 
      RowBox[{"3", ",", "4"}], 
      RowBox[{"[", "2", "]"}]]}], "+", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{
        RowBox[{"-", "144"}], " ", "\[ImaginaryI]"}], "+", 
       FractionBox[
        RowBox[{"72", "-", 
         RowBox[{"24", " ", "\[ImaginaryI]", " ", 
          SqrtBox["3"]}]}], 
        SubsuperscriptBox[
         StyleBox["\[ScriptU]",
          FontColor->RGBColor[0, 0, 0.4]], 
         RowBox[{"-", "v0"}], "+"]], "+", 
       FractionBox[
        RowBox[{"72", "+", 
         RowBox[{"24", " ", "\[ImaginaryI]", " ", 
          SqrtBox["3"]}]}], 
        SubsuperscriptBox[
         StyleBox["\[ScriptU]",
          FontColor->RGBColor[0, 0, 0.4]], "v0", "+"]]}], ")"}], " ", 
     SubsuperscriptBox[
      StyleBox["\[Eta]",
       FontWeight->Bold,
       FontColor->RGBColor[0.8, 0, 0]], 
      RowBox[{"4", ",", "2"}], 
      RowBox[{"[", "2", "]"}]]}], "+", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       FractionBox[
        RowBox[{
         RowBox[{"24", " ", "\[ImaginaryI]"}], "-", 
         RowBox[{"24", " ", 
          SqrtBox["3"]}]}], 
        SubsuperscriptBox[
         StyleBox["\[ScriptU]",
          FontColor->RGBColor[0, 0, 0.4]], 
         RowBox[{"-", "v0"}], "+"]], "+", 
       FractionBox[
        RowBox[{
         RowBox[{"24", " ", "\[ImaginaryI]"}], "+", 
         RowBox[{"24", " ", 
          SqrtBox["3"]}]}], 
        SubsuperscriptBox[
         StyleBox["\[ScriptU]",
          FontColor->RGBColor[0, 0, 0.4]], "v0", "+"]]}], ")"}], " ", 
     SubsuperscriptBox[
      StyleBox["\[Eta]",
       FontWeight->Bold,
       FontColor->RGBColor[0.8, 0, 0]], 
      RowBox[{"4", ",", "3"}], 
      RowBox[{"[", "2", "]"}]]}], "+", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       FractionBox[
        RowBox[{
         RowBox[{
          RowBox[{"-", "216"}], " ", "\[ImaginaryI]"}], "+", 
         RowBox[{"864", " ", "\[ImaginaryI]", " ", 
          SubscriptBox[
           StyleBox["\[Zeta]",
            FontWeight->Bold,
            FontColor->GrayLevel[0.4]], "3"]}]}], 
        SuperscriptBox[
         StyleBox["\[ScriptU]",
          FontColor->RGBColor[0, 0, 0.4]], "2"]], "-", 
       RowBox[{"2592", " ", "u", " ", 
        SubscriptBox[
         StyleBox["\[Zeta]",
          FontWeight->Bold,
          FontColor->GrayLevel[0.4]], "3"]}], "-", 
       FractionBox[
        RowBox[{"1728", " ", 
         SubscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "3"]}], 
        StyleBox["\[ScriptU]",
         FontColor->RGBColor[0, 0, 0.4]]], "+", 
       FractionBox[
        RowBox[{
         RowBox[{
          SqrtBox["3"], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"432", " ", "\[ImaginaryI]"}], "-", 
            RowBox[{"480", " ", "\[ImaginaryI]", " ", 
             SubscriptBox[
              StyleBox["\[Zeta]",
               FontWeight->Bold,
               FontColor->GrayLevel[0.4]], "5"]}]}], ")"}]}], "-", 
         RowBox[{"480", " ", 
          SubscriptBox[
           StyleBox["\[Zeta]",
            FontWeight->Bold,
            FontColor->GrayLevel[0.4]], "5"]}]}], 
        SubsuperscriptBox[
         StyleBox["\[ScriptU]",
          FontColor->RGBColor[0, 0, 0.4]], 
         RowBox[{"-", "v0"}], "+"]], "+", 
       FractionBox[
        RowBox[{
         RowBox[{
          SqrtBox["3"], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{
             RowBox[{"-", "432"}], " ", "\[ImaginaryI]"}], "+", 
            RowBox[{"480", " ", "\[ImaginaryI]", " ", 
             SubscriptBox[
              StyleBox["\[Zeta]",
               FontWeight->Bold,
               FontColor->GrayLevel[0.4]], "5"]}]}], ")"}]}], "-", 
         RowBox[{"480", " ", 
          SubscriptBox[
           StyleBox["\[Zeta]",
            FontWeight->Bold,
            FontColor->GrayLevel[0.4]], "5"]}]}], 
        SubsuperscriptBox[
         StyleBox["\[ScriptU]",
          FontColor->RGBColor[0, 0, 0.4]], "v0", "+"]]}], ")"}], " ", 
     SubsuperscriptBox[
      OverscriptBox[
       StyleBox["\[Eta]",
        FontWeight->Bold,
        FontColor->RGBColor[0.8, 0, 0]], 
       StyleBox["_",
        FontWeight->Bold,
        FontColor->RGBColor[0.8, 0, 0]]], "2", 
      RowBox[{"[", 
       RowBox[{"-", "2"}], "]"}]]}], "+", 
    FractionBox[
     RowBox[{"432", " ", 
      SubsuperscriptBox[
       StyleBox["\[Eta]",
        FontWeight->Bold,
        FontColor->RGBColor[0.8, 0, 0]], "2", 
       RowBox[{"[", "2", "]"}]], " ", 
      SubsuperscriptBox[
       OverscriptBox[
        StyleBox["\[Eta]",
         FontWeight->Bold,
         FontColor->RGBColor[0.8, 0, 0]], 
        StyleBox["_",
         FontWeight->Bold,
         FontColor->RGBColor[0.8, 0, 0]]], "2", 
       RowBox[{"[", 
        RowBox[{"-", "2"}], "]"}]]}], 
     StyleBox["\[ScriptU]",
      FontColor->RGBColor[0, 0, 0.4]]], "+", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{"432", "-", 
       RowBox[{"432", " ", "\[ImaginaryI]", " ", "u"}], "-", 
       FractionBox[
        RowBox[{"288", " ", "\[ImaginaryI]"}], 
        StyleBox["\[ScriptU]",
         FontColor->RGBColor[0, 0, 0.4]]]}], ")"}], " ", 
     SubsuperscriptBox[
      StyleBox["\[Eta]",
       FontWeight->Bold,
       FontColor->RGBColor[0.8, 0, 0]], "3", 
      RowBox[{"[", "2", "]"}]], " ", 
     SubsuperscriptBox[
      OverscriptBox[
       StyleBox["\[Eta]",
        FontWeight->Bold,
        FontColor->RGBColor[0.8, 0, 0]], 
       StyleBox["_",
        FontWeight->Bold,
        FontColor->RGBColor[0.8, 0, 0]]], "2", 
      RowBox[{"[", 
       RowBox[{"-", "2"}], "]"}]]}], "+", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{"144", " ", "\[ImaginaryI]"}], "+", 
       FractionBox["144", 
        StyleBox["\[ScriptU]",
         FontColor->RGBColor[0, 0, 0.4]]], "+", 
       FractionBox[
        RowBox[{
         RowBox[{"-", "72"}], "+", 
         RowBox[{"24", " ", "\[ImaginaryI]", " ", 
          SqrtBox["3"]}]}], 
        SubsuperscriptBox[
         StyleBox["\[ScriptU]",
          FontColor->RGBColor[0, 0, 0.4]], 
         RowBox[{"-", "v0"}], "+"]], "+", 
       FractionBox[
        RowBox[{
         RowBox[{"-", "72"}], "-", 
         RowBox[{"24", " ", "\[ImaginaryI]", " ", 
          SqrtBox["3"]}]}], 
        SubsuperscriptBox[
         StyleBox["\[ScriptU]",
          FontColor->RGBColor[0, 0, 0.4]], "v0", "+"]]}], ")"}], " ", 
     SubsuperscriptBox[
      StyleBox["\[Eta]",
       FontWeight->Bold,
       FontColor->RGBColor[0.8, 0, 0]], "4", 
      RowBox[{"[", "2", "]"}]], " ", 
     SubsuperscriptBox[
      OverscriptBox[
       StyleBox["\[Eta]",
        FontWeight->Bold,
        FontColor->RGBColor[0.8, 0, 0]], 
       StyleBox["_",
        FontWeight->Bold,
        FontColor->RGBColor[0.8, 0, 0]]], "2", 
      RowBox[{"[", 
       RowBox[{"-", "2"}], "]"}]]}], "+", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       FractionBox["216", 
        SuperscriptBox[
         StyleBox["\[ScriptU]",
          FontColor->RGBColor[0, 0, 0.4]], "2"]], "+", 
       FractionBox[
        RowBox[{
         RowBox[{"864", " ", "\[ImaginaryI]"}], "-", 
         RowBox[{"576", " ", "\[ImaginaryI]", " ", 
          SubscriptBox[
           StyleBox["\[Zeta]",
            FontWeight->Bold,
            FontColor->GrayLevel[0.4]], "3"]}]}], 
        StyleBox["\[ScriptU]",
         FontColor->RGBColor[0, 0, 0.4]]], "+", 
       RowBox[{"576", " ", 
        SubscriptBox[
         StyleBox["\[Zeta]",
          FontWeight->Bold,
          FontColor->GrayLevel[0.4]], "3"]}], "+", 
       FractionBox[
        RowBox[{
         RowBox[{
          RowBox[{"-", "432"}], " ", "\[ImaginaryI]"}], "+", 
         RowBox[{"288", " ", "\[ImaginaryI]", " ", 
          SubscriptBox[
           StyleBox["\[Zeta]",
            FontWeight->Bold,
            FontColor->GrayLevel[0.4]], "3"]}], "-", 
         RowBox[{"96", " ", 
          SqrtBox["3"], " ", 
          SubscriptBox[
           StyleBox["\[Zeta]",
            FontWeight->Bold,
            FontColor->GrayLevel[0.4]], "3"]}]}], 
        SubsuperscriptBox[
         StyleBox["\[ScriptU]",
          FontColor->RGBColor[0, 0, 0.4]], "v0", "+"]], "+", 
       FractionBox[
        RowBox[{
         RowBox[{
          RowBox[{"-", "432"}], " ", "\[ImaginaryI]"}], "+", 
         RowBox[{"288", " ", "\[ImaginaryI]", " ", 
          SubscriptBox[
           StyleBox["\[Zeta]",
            FontWeight->Bold,
            FontColor->GrayLevel[0.4]], "3"]}], "+", 
         RowBox[{"96", " ", 
          SqrtBox["3"], " ", 
          SubscriptBox[
           StyleBox["\[Zeta]",
            FontWeight->Bold,
            FontColor->GrayLevel[0.4]], "3"]}]}], 
        SubsuperscriptBox[
         StyleBox["\[ScriptU]",
          FontColor->RGBColor[0, 0, 0.4]], 
         RowBox[{"-", "v0"}], "+"]]}], ")"}], " ", 
     SubsuperscriptBox[
      OverscriptBox[
       StyleBox["\[Eta]",
        FontWeight->Bold,
        FontColor->RGBColor[0.8, 0, 0]], 
       StyleBox["_",
        FontWeight->Bold,
        FontColor->RGBColor[0.8, 0, 0]]], "3", 
      RowBox[{"[", 
       RowBox[{"-", "2"}], "]"}]]}], "+", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{"-", "432"}], "+", 
       RowBox[{"432", " ", "\[ImaginaryI]", " ", "u"}], "+", 
       FractionBox[
        RowBox[{"288", " ", "\[ImaginaryI]"}], 
        StyleBox["\[ScriptU]",
         FontColor->RGBColor[0, 0, 0.4]]]}], ")"}], " ", 
     SubsuperscriptBox[
      StyleBox["\[Eta]",
       FontWeight->Bold,
       FontColor->RGBColor[0.8, 0, 0]], "2", 
      RowBox[{"[", "2", "]"}]], " ", 
     SubsuperscriptBox[
      OverscriptBox[
       StyleBox["\[Eta]",
        FontWeight->Bold,
        FontColor->RGBColor[0.8, 0, 0]], 
       StyleBox["_",
        FontWeight->Bold,
        FontColor->RGBColor[0.8, 0, 0]]], "3", 
      RowBox[{"[", 
       RowBox[{"-", "2"}], "]"}]]}], "-", 
    FractionBox[
     RowBox[{"144", " ", 
      SubsuperscriptBox[
       StyleBox["\[Eta]",
        FontWeight->Bold,
        FontColor->RGBColor[0.8, 0, 0]], "3", 
       RowBox[{"[", "2", "]"}]], " ", 
      SubsuperscriptBox[
       OverscriptBox[
        StyleBox["\[Eta]",
         FontWeight->Bold,
         FontColor->RGBColor[0.8, 0, 0]], 
        StyleBox["_",
         FontWeight->Bold,
         FontColor->RGBColor[0.8, 0, 0]]], "3", 
       RowBox[{"[", 
        RowBox[{"-", "2"}], "]"}]]}], 
     StyleBox["\[ScriptU]",
      FontColor->RGBColor[0, 0, 0.4]]], "+", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       FractionBox[
        RowBox[{
         RowBox[{
          RowBox[{"-", "24"}], " ", "\[ImaginaryI]"}], "+", 
         RowBox[{"24", " ", 
          SqrtBox["3"]}]}], 
        SubsuperscriptBox[
         StyleBox["\[ScriptU]",
          FontColor->RGBColor[0, 0, 0.4]], 
         RowBox[{"-", "v0"}], "+"]], "+", 
       FractionBox[
        RowBox[{
         RowBox[{
          RowBox[{"-", "24"}], " ", "\[ImaginaryI]"}], "-", 
         RowBox[{"24", " ", 
          SqrtBox["3"]}]}], 
        SubsuperscriptBox[
         StyleBox["\[ScriptU]",
          FontColor->RGBColor[0, 0, 0.4]], "v0", "+"]]}], ")"}], " ", 
     SubsuperscriptBox[
      StyleBox["\[Eta]",
       FontWeight->Bold,
       FontColor->RGBColor[0.8, 0, 0]], "4", 
      RowBox[{"[", "2", "]"}]], " ", 
     SubsuperscriptBox[
      OverscriptBox[
       StyleBox["\[Eta]",
        FontWeight->Bold,
        FontColor->RGBColor[0.8, 0, 0]], 
       StyleBox["_",
        FontWeight->Bold,
        FontColor->RGBColor[0.8, 0, 0]]], "3", 
      RowBox[{"[", 
       RowBox[{"-", "2"}], "]"}]]}], "+", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{"-", 
        FractionBox["216", 
         StyleBox["\[ScriptU]",
          FontColor->RGBColor[0, 0, 0.4]]]}], "+", 
       FractionBox[
        RowBox[{"108", "+", 
         RowBox[{
          SqrtBox["3"], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{
             RowBox[{"-", "108"}], " ", "\[ImaginaryI]"}], "-", 
            RowBox[{"48", " ", "\[ImaginaryI]", " ", 
             SubscriptBox[
              StyleBox["\[Zeta]",
               FontWeight->Bold,
               FontColor->GrayLevel[0.4]], "3"]}]}], ")"}]}], "+", 
         RowBox[{"48", " ", 
          SubscriptBox[
           StyleBox["\[Zeta]",
            FontWeight->Bold,
            FontColor->GrayLevel[0.4]], "3"]}]}], 
        SubsuperscriptBox[
         StyleBox["\[ScriptU]",
          FontColor->RGBColor[0, 0, 0.4]], "v0", "+"]], "+", 
       FractionBox[
        RowBox[{"108", "+", 
         RowBox[{
          SqrtBox["3"], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"108", " ", "\[ImaginaryI]"}], "+", 
            RowBox[{"48", " ", "\[ImaginaryI]", " ", 
             SubscriptBox[
              StyleBox["\[Zeta]",
               FontWeight->Bold,
               FontColor->GrayLevel[0.4]], "3"]}]}], ")"}]}], "+", 
         RowBox[{"48", " ", 
          SubscriptBox[
           StyleBox["\[Zeta]",
            FontWeight->Bold,
            FontColor->GrayLevel[0.4]], "3"]}]}], 
        SubsuperscriptBox[
         StyleBox["\[ScriptU]",
          FontColor->RGBColor[0, 0, 0.4]], 
         RowBox[{"-", "v0"}], "+"]]}], ")"}], " ", 
     SubsuperscriptBox[
      OverscriptBox[
       StyleBox["\[Eta]",
        FontWeight->Bold,
        FontColor->RGBColor[0.8, 0, 0]], 
       StyleBox["_",
        FontWeight->Bold,
        FontColor->RGBColor[0.8, 0, 0]]], "4", 
      RowBox[{"[", 
       RowBox[{"-", "2"}], "]"}]]}], "+", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{
        RowBox[{"-", "144"}], " ", "\[ImaginaryI]"}], "+", 
       FractionBox[
        RowBox[{"72", "-", 
         RowBox[{"24", " ", "\[ImaginaryI]", " ", 
          SqrtBox["3"]}]}], 
        SubsuperscriptBox[
         StyleBox["\[ScriptU]",
          FontColor->RGBColor[0, 0, 0.4]], 
         RowBox[{"-", "v0"}], "+"]], "+", 
       FractionBox[
        RowBox[{"72", "+", 
         RowBox[{"24", " ", "\[ImaginaryI]", " ", 
          SqrtBox["3"]}]}], 
        SubsuperscriptBox[
         StyleBox["\[ScriptU]",
          FontColor->RGBColor[0, 0, 0.4]], "v0", "+"]]}], ")"}], " ", 
     SubsuperscriptBox[
      StyleBox["\[Eta]",
       FontWeight->Bold,
       FontColor->RGBColor[0.8, 0, 0]], "2", 
      RowBox[{"[", "2", "]"}]], " ", 
     SubsuperscriptBox[
      OverscriptBox[
       StyleBox["\[Eta]",
        FontWeight->Bold,
        FontColor->RGBColor[0.8, 0, 0]], 
       StyleBox["_",
        FontWeight->Bold,
        FontColor->RGBColor[0.8, 0, 0]]], "4", 
      RowBox[{"[", 
       RowBox[{"-", "2"}], "]"}]]}], "+", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       FractionBox[
        RowBox[{
         RowBox[{"24", " ", "\[ImaginaryI]"}], "-", 
         RowBox[{"24", " ", 
          SqrtBox["3"]}]}], 
        SubsuperscriptBox[
         StyleBox["\[ScriptU]",
          FontColor->RGBColor[0, 0, 0.4]], 
         RowBox[{"-", "v0"}], "+"]], "+", 
       FractionBox[
        RowBox[{
         RowBox[{"24", " ", "\[ImaginaryI]"}], "+", 
         RowBox[{"24", " ", 
          SqrtBox["3"]}]}], 
        SubsuperscriptBox[
         StyleBox["\[ScriptU]",
          FontColor->RGBColor[0, 0, 0.4]], "v0", "+"]]}], ")"}], " ", 
     SubsuperscriptBox[
      StyleBox["\[Eta]",
       FontWeight->Bold,
       FontColor->RGBColor[0.8, 0, 0]], "3", 
      RowBox[{"[", "2", "]"}]], " ", 
     SubsuperscriptBox[
      OverscriptBox[
       StyleBox["\[Eta]",
        FontWeight->Bold,
        FontColor->RGBColor[0.8, 0, 0]], 
       StyleBox["_",
        FontWeight->Bold,
        FontColor->RGBColor[0.8, 0, 0]]], "4", 
      RowBox[{"[", 
       RowBox[{"-", "2"}], "]"}]]}], "+", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{"432", " ", "\[ImaginaryI]", " ", "u"}], "+", 
       FractionBox["144", 
        SuperscriptBox[
         StyleBox["\[ScriptU]",
          FontColor->RGBColor[0, 0, 0.4]], "2"]], "+", 
       FractionBox[
        RowBox[{"288", " ", "\[ImaginaryI]"}], 
        StyleBox["\[ScriptU]",
         FontColor->RGBColor[0, 0, 0.4]]]}], ")"}], " ", 
     SubsuperscriptBox[
      OverscriptBox[
       StyleBox["\[Eta]",
        FontWeight->Bold,
        FontColor->RGBColor[0.8, 0, 0]], 
       StyleBox["_",
        FontWeight->Bold,
        FontColor->RGBColor[0.8, 0, 0]]], 
      RowBox[{"2", ",", "3"}], 
      RowBox[{"[", 
       RowBox[{"-", "2"}], "]"}]]}], "+", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{
        RowBox[{"-", "144"}], " ", "\[ImaginaryI]"}], "-", 
       FractionBox["144", 
        StyleBox["\[ScriptU]",
         FontColor->RGBColor[0, 0, 0.4]]], "+", 
       FractionBox[
        RowBox[{"72", "-", 
         RowBox[{"24", " ", "\[ImaginaryI]", " ", 
          SqrtBox["3"]}]}], 
        SubsuperscriptBox[
         StyleBox["\[ScriptU]",
          FontColor->RGBColor[0, 0, 0.4]], 
         RowBox[{"-", "v0"}], "+"]], "+", 
       FractionBox[
        RowBox[{"72", "+", 
         RowBox[{"24", " ", "\[ImaginaryI]", " ", 
          SqrtBox["3"]}]}], 
        SubsuperscriptBox[
         StyleBox["\[ScriptU]",
          FontColor->RGBColor[0, 0, 0.4]], "v0", "+"]]}], ")"}], " ", 
     SubsuperscriptBox[
      OverscriptBox[
       StyleBox["\[Eta]",
        FontWeight->Bold,
        FontColor->RGBColor[0.8, 0, 0]], 
       StyleBox["_",
        FontWeight->Bold,
        FontColor->RGBColor[0.8, 0, 0]]], 
      RowBox[{"2", ",", "4"}], 
      RowBox[{"[", 
       RowBox[{"-", "2"}], "]"}]]}], "+", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{
        RowBox[{"-", "432"}], " ", "\[ImaginaryI]", " ", "u"}], "-", 
       FractionBox["144", 
        SuperscriptBox[
         StyleBox["\[ScriptU]",
          FontColor->RGBColor[0, 0, 0.4]], "2"]], "-", 
       FractionBox[
        RowBox[{"288", " ", "\[ImaginaryI]"}], 
        StyleBox["\[ScriptU]",
         FontColor->RGBColor[0, 0, 0.4]]]}], ")"}], " ", 
     SubsuperscriptBox[
      OverscriptBox[
       StyleBox["\[Eta]",
        FontWeight->Bold,
        FontColor->RGBColor[0.8, 0, 0]], 
       StyleBox["_",
        FontWeight->Bold,
        FontColor->RGBColor[0.8, 0, 0]]], 
      RowBox[{"3", ",", "2"}], 
      RowBox[{"[", 
       RowBox[{"-", "2"}], "]"}]]}], "+", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       FractionBox[
        RowBox[{
         RowBox[{"24", " ", "\[ImaginaryI]"}], "-", 
         RowBox[{"24", " ", 
          SqrtBox["3"]}]}], 
        SubsuperscriptBox[
         StyleBox["\[ScriptU]",
          FontColor->RGBColor[0, 0, 0.4]], 
         RowBox[{"-", "v0"}], "+"]], "+", 
       FractionBox[
        RowBox[{
         RowBox[{"24", " ", "\[ImaginaryI]"}], "+", 
         RowBox[{"24", " ", 
          SqrtBox["3"]}]}], 
        SubsuperscriptBox[
         StyleBox["\[ScriptU]",
          FontColor->RGBColor[0, 0, 0.4]], "v0", "+"]]}], ")"}], " ", 
     SubsuperscriptBox[
      OverscriptBox[
       StyleBox["\[Eta]",
        FontWeight->Bold,
        FontColor->RGBColor[0.8, 0, 0]], 
       StyleBox["_",
        FontWeight->Bold,
        FontColor->RGBColor[0.8, 0, 0]]], 
      RowBox[{"3", ",", "4"}], 
      RowBox[{"[", 
       RowBox[{"-", "2"}], "]"}]]}], "+", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{"144", " ", "\[ImaginaryI]"}], "+", 
       FractionBox["144", 
        StyleBox["\[ScriptU]",
         FontColor->RGBColor[0, 0, 0.4]]], "+", 
       FractionBox[
        RowBox[{
         RowBox[{"-", "72"}], "+", 
         RowBox[{"24", " ", "\[ImaginaryI]", " ", 
          SqrtBox["3"]}]}], 
        SubsuperscriptBox[
         StyleBox["\[ScriptU]",
          FontColor->RGBColor[0, 0, 0.4]], 
         RowBox[{"-", "v0"}], "+"]], "+", 
       FractionBox[
        RowBox[{
         RowBox[{"-", "72"}], "-", 
         RowBox[{"24", " ", "\[ImaginaryI]", " ", 
          SqrtBox["3"]}]}], 
        SubsuperscriptBox[
         StyleBox["\[ScriptU]",
          FontColor->RGBColor[0, 0, 0.4]], "v0", "+"]]}], ")"}], " ", 
     SubsuperscriptBox[
      OverscriptBox[
       StyleBox["\[Eta]",
        FontWeight->Bold,
        FontColor->RGBColor[0.8, 0, 0]], 
       StyleBox["_",
        FontWeight->Bold,
        FontColor->RGBColor[0.8, 0, 0]]], 
      RowBox[{"4", ",", "2"}], 
      RowBox[{"[", 
       RowBox[{"-", "2"}], "]"}]]}], "+", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       FractionBox[
        RowBox[{
         RowBox[{
          RowBox[{"-", "24"}], " ", "\[ImaginaryI]"}], "+", 
         RowBox[{"24", " ", 
          SqrtBox["3"]}]}], 
        SubsuperscriptBox[
         StyleBox["\[ScriptU]",
          FontColor->RGBColor[0, 0, 0.4]], 
         RowBox[{"-", "v0"}], "+"]], "+", 
       FractionBox[
        RowBox[{
         RowBox[{
          RowBox[{"-", "24"}], " ", "\[ImaginaryI]"}], "-", 
         RowBox[{"24", " ", 
          SqrtBox["3"]}]}], 
        SubsuperscriptBox[
         StyleBox["\[ScriptU]",
          FontColor->RGBColor[0, 0, 0.4]], "v0", "+"]]}], ")"}], " ", 
     SubsuperscriptBox[
      OverscriptBox[
       StyleBox["\[Eta]",
        FontWeight->Bold,
        FontColor->RGBColor[0.8, 0, 0]], 
       StyleBox["_",
        FontWeight->Bold,
        FontColor->RGBColor[0.8, 0, 0]]], 
      RowBox[{"4", ",", "3"}], 
      RowBox[{"[", 
       RowBox[{"-", "2"}], "]"}]]}]}], ")"}]}]], "Output",
 CellChangeTimes->{{3.563282682686755*^9, 3.56328274012922*^9}, {
  3.5632829269662724`*^9, 3.5632829390557013`*^9}}]
}, Open  ]],

Cell[BoxData[{
 RowBox[{
  RowBox[{"Collect", "[", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"tmp4", "/.", 
       RowBox[{
        RowBox[{"xxx", ":", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{
            RowBox[{"(", 
             RowBox[{"\[Eta]$", "|", "\[Eta]$b"}], ")"}], "[", "a__", "]"}], 
           "[", "_", "]"}], ")"}]}], "\[RuleDelayed]", 
        RowBox[{
         SuperscriptBox["\[Epsilon]", 
          RowBox[{
           RowBox[{"Total", "[", 
            RowBox[{"{", "a", "}"}], "]"}], "-", 
           RowBox[{"Length", "[", 
            RowBox[{"{", "a", "}"}], "]"}]}]], "xxx"}]}]}], "/.", 
      RowBox[{
       RowBox[{"xxx", ":", 
        RowBox[{
         RowBox[{"\[ScriptU]", "[", "__", "]"}], "[", "_", "]"}]}], 
       "\[RuleDelayed]", 
       FractionBox["xxx", "\[Epsilon]"]}]}], "/.", 
     RowBox[{"u", "\[Rule]", 
      FractionBox["u", 
       SuperscriptBox["\[Epsilon]", "50"]]}]}], ",", "\[Epsilon]"}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"{", 
   RowBox[{
    RowBox[{"singterms", "=", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"%", "/.", 
        RowBox[{
         SuperscriptBox["\[Epsilon]", 
          RowBox[{"a_", "/;", 
           RowBox[{"a", ">", "1"}]}]], "\[Rule]", "0"}]}], ")"}], "/.", 
      RowBox[{"\[Epsilon]", "\[Rule]", "1"}]}]}], ",", 
    RowBox[{"regterms", "=", 
     RowBox[{"Collect", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"tmp4", "-", "singterms"}], "/.", 
        RowBox[{"\[Epsilon]", "\[Rule]", "1"}]}], ",", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"g", ",", "canlist"}], "}"}], "//", "Flatten"}]}], "]"}]}]}],
    "}"}], ";"}]}], "Input",
 CellChangeTimes->{{3.563295851506853*^9, 3.563295950476725*^9}, {
   3.5632963979442472`*^9, 3.563296411130209*^9}, {3.563296543663842*^9, 
   3.563296593263411*^9}, 3.563296723970316*^9, 3.5632994633811207`*^9}],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"singuterms", "=", 
  RowBox[{"Collect", "[", 
   RowBox[{
    RowBox[{"Select", "[", 
     RowBox[{
      RowBox[{"singterms", "//", "Expand"}], ",", 
      RowBox[{
       RowBox[{"Not", "[", 
        RowBox[{"FreeQ", "[", 
         RowBox[{"#", ",", "\[ScriptU]$"}], "]"}], "]"}], "&"}]}], "]"}], ",",
     "canlist"}], "]"}]}], "\[IndentingNewLine]", 
 RowBox[{"singotherterms", "=", 
  RowBox[{"Collect", "[", 
   RowBox[{
    RowBox[{"singterms", "-", "singuterms"}], ",", "canlist"}], 
   "]"}]}]}], "Input",
 CellChangeTimes->{{3.563296762188036*^9, 3.563296807047641*^9}, {
  3.5632968882876377`*^9, 3.563297026792762*^9}, {3.563299165474897*^9, 
  3.563299179079302*^9}}],

Cell[BoxData[
 RowBox[{
  SuperscriptBox["g", "8"], " ", 
  RowBox[{"(", 
   RowBox[{
    FractionBox[
     RowBox[{"1080", "+", 
      FractionBox[
       RowBox[{"4", " ", "Im1"}], 
       RowBox[{"3", " ", 
        SqrtBox["3"]}]], "+", 
      RowBox[{"3024", " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "3"]}], "-", 
      RowBox[{"5280", " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "5"]}]}], 
     StyleBox["\[ScriptU]",
      FontColor->RGBColor[0, 0, 0.4]]], "+", 
    FractionBox[
     RowBox[{"324", "-", 
      RowBox[{"432", " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "3"]}], "-", 
      RowBox[{"1440", " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "5"]}]}], 
     SuperscriptBox[
      StyleBox["\[ScriptU]",
       FontColor->RGBColor[0, 0, 0.4]], 
      RowBox[{"[", "2", "]"}]]], "+", 
    FractionBox[
     RowBox[{
      RowBox[{"-", "702"}], "+", 
      FractionBox[
       RowBox[{"2", " ", "\[ImaginaryI]", " ", "Im1"}], "3"], "+", 
      RowBox[{
       SqrtBox["3"], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"54", " ", "\[ImaginaryI]"}], "-", 
         FractionBox[
          RowBox[{"2", " ", "Im1"}], "9"], "+", 
         RowBox[{"864", " ", "\[ImaginaryI]", " ", 
          SubscriptBox[
           StyleBox["\[Zeta]",
            FontWeight->Bold,
            FontColor->GrayLevel[0.4]], "3"]}], "-", 
         RowBox[{"480", " ", "\[ImaginaryI]", " ", 
          SubscriptBox[
           StyleBox["\[Zeta]",
            FontWeight->Bold,
            FontColor->GrayLevel[0.4]], "5"]}]}], ")"}]}], "+", 
      RowBox[{"3360", " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "5"]}]}], 
     SubsuperscriptBox[
      StyleBox["\[ScriptU]",
       FontColor->RGBColor[0, 0, 0.4]], "v0", "+"]], "+", 
    FractionBox[
     RowBox[{
      RowBox[{"-", "702"}], "-", 
      FractionBox[
       RowBox[{"2", " ", "\[ImaginaryI]", " ", "Im1"}], "3"], "+", 
      RowBox[{
       SqrtBox["3"], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          RowBox[{"-", "54"}], " ", "\[ImaginaryI]"}], "-", 
         FractionBox[
          RowBox[{"2", " ", "Im1"}], "9"], "-", 
         RowBox[{"864", " ", "\[ImaginaryI]", " ", 
          SubscriptBox[
           StyleBox["\[Zeta]",
            FontWeight->Bold,
            FontColor->GrayLevel[0.4]], "3"]}], "+", 
         RowBox[{"480", " ", "\[ImaginaryI]", " ", 
          SubscriptBox[
           StyleBox["\[Zeta]",
            FontWeight->Bold,
            FontColor->GrayLevel[0.4]], "5"]}]}], ")"}]}], "+", 
      RowBox[{"3360", " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "5"]}]}], 
     SubsuperscriptBox[
      StyleBox["\[ScriptU]",
       FontColor->RGBColor[0, 0, 0.4]], 
      RowBox[{"-", "v0"}], "+"]]}], ")"}]}]], "Output",
 CellChangeTimes->{{3.563296791681127*^9, 3.563296807518525*^9}, {
   3.563296889462265*^9, 3.5632969085094347`*^9}, {3.563297001274701*^9, 
   3.5632970270787077`*^9}, 3.56329829805404*^9, {3.5632991659719143`*^9, 
   3.563299179572975*^9}, 3.563299464949649*^9, 3.563299693887693*^9}],

Cell[BoxData[
 RowBox[{
  SuperscriptBox["g", "8"], " ", 
  RowBox[{"(", 
   RowBox[{
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{
        RowBox[{"-", "5184"}], " ", "\[ImaginaryI]"}], "-", 
       RowBox[{"2592", " ", "u"}]}], ")"}], " ", 
     SubscriptBox[
      StyleBox["\[Zeta]",
       FontWeight->Bold,
       FontColor->GrayLevel[0.4]], "3"], " ", 
     SubsuperscriptBox[
      StyleBox["\[Eta]",
       FontWeight->Bold,
       FontColor->RGBColor[0.8, 0, 0]], "2", 
      RowBox[{"[", "2", "]"}]]}], "-", 
    RowBox[{"432", " ", "\[ImaginaryI]", " ", "u", " ", 
     SubsuperscriptBox[
      StyleBox["\[Eta]",
       FontWeight->Bold,
       FontColor->RGBColor[0.8, 0, 0]], 
      RowBox[{"2", ",", "3"}], 
      RowBox[{"[", "2", "]"}]]}], "+", 
    RowBox[{"432", " ", "\[ImaginaryI]", " ", "u", " ", 
     SubsuperscriptBox[
      StyleBox["\[Eta]",
       FontWeight->Bold,
       FontColor->RGBColor[0.8, 0, 0]], 
      RowBox[{"3", ",", "2"}], 
      RowBox[{"[", "2", "]"}]]}], "-", 
    RowBox[{"2592", " ", "u", " ", 
     SubscriptBox[
      StyleBox["\[Zeta]",
       FontWeight->Bold,
       FontColor->GrayLevel[0.4]], "3"], " ", 
     SubsuperscriptBox[
      OverscriptBox[
       StyleBox["\[Eta]",
        FontWeight->Bold,
        FontColor->RGBColor[0.8, 0, 0]], 
       StyleBox["_",
        FontWeight->Bold,
        FontColor->RGBColor[0.8, 0, 0]]], "2", 
      RowBox[{"[", 
       RowBox[{"-", "2"}], "]"}]]}], "-", 
    RowBox[{"432", " ", "\[ImaginaryI]", " ", "u", " ", 
     SubsuperscriptBox[
      StyleBox["\[Eta]",
       FontWeight->Bold,
       FontColor->RGBColor[0.8, 0, 0]], "3", 
      RowBox[{"[", "2", "]"}]], " ", 
     SubsuperscriptBox[
      OverscriptBox[
       StyleBox["\[Eta]",
        FontWeight->Bold,
        FontColor->RGBColor[0.8, 0, 0]], 
       StyleBox["_",
        FontWeight->Bold,
        FontColor->RGBColor[0.8, 0, 0]]], "2", 
      RowBox[{"[", 
       RowBox[{"-", "2"}], "]"}]]}], "+", 
    RowBox[{"432", " ", "\[ImaginaryI]", " ", "u", " ", 
     SubsuperscriptBox[
      StyleBox["\[Eta]",
       FontWeight->Bold,
       FontColor->RGBColor[0.8, 0, 0]], "2", 
      RowBox[{"[", "2", "]"}]], " ", 
     SubsuperscriptBox[
      OverscriptBox[
       StyleBox["\[Eta]",
        FontWeight->Bold,
        FontColor->RGBColor[0.8, 0, 0]], 
       StyleBox["_",
        FontWeight->Bold,
        FontColor->RGBColor[0.8, 0, 0]]], "3", 
      RowBox[{"[", 
       RowBox[{"-", "2"}], "]"}]]}], "+", 
    RowBox[{"432", " ", "\[ImaginaryI]", " ", "u", " ", 
     SubsuperscriptBox[
      OverscriptBox[
       StyleBox["\[Eta]",
        FontWeight->Bold,
        FontColor->RGBColor[0.8, 0, 0]], 
       StyleBox["_",
        FontWeight->Bold,
        FontColor->RGBColor[0.8, 0, 0]]], 
      RowBox[{"2", ",", "3"}], 
      RowBox[{"[", 
       RowBox[{"-", "2"}], "]"}]]}], "-", 
    RowBox[{"432", " ", "\[ImaginaryI]", " ", "u", " ", 
     SubsuperscriptBox[
      OverscriptBox[
       StyleBox["\[Eta]",
        FontWeight->Bold,
        FontColor->RGBColor[0.8, 0, 0]], 
       StyleBox["_",
        FontWeight->Bold,
        FontColor->RGBColor[0.8, 0, 0]]], 
      RowBox[{"3", ",", "2"}], 
      RowBox[{"[", 
       RowBox[{"-", "2"}], "]"}]]}]}], ")"}]}]], "Output",
 CellChangeTimes->{{3.563296791681127*^9, 3.563296807518525*^9}, {
   3.563296889462265*^9, 3.5632969085094347`*^9}, {3.563297001274701*^9, 
   3.5632970270787077`*^9}, 3.56329829805404*^9, {3.5632991659719143`*^9, 
   3.563299179572975*^9}, 3.563299464949649*^9, 3.56329969391716*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"singuterms", "+", "singotherterms", "+", "regterms", "-", "tmp4"}],
   "//", "Expand"}]], "Input",
 CellChangeTimes->{{3.563299696039892*^9, 3.563299708356469*^9}}],

Cell[BoxData["0"], "Output",
 CellChangeTimes->{3.5632997086804943`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"intsinguterms", "=", 
  RowBox[{"UpIntegrate", "[", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{"-", 
         FractionBox["1", 
          RowBox[{"2", "\[Pi]", " ", "\[ImaginaryI]"}]]}], 
        RowBox[{"(", "singuterms", ")"}]}], "/.", 
       RowBox[{"Shift", "[", 
        RowBox[{
         RowBox[{"-", "2"}], "\[Epsilon]"}], "]"}]}], "/.", 
      RowBox[{"u", "\[Rule]", 
       RowBox[{"u", "-", 
        RowBox[{"\[ImaginaryI]", " ", "\[Epsilon]"}]}]}]}], "/.", "subusu"}], 
    ",", "u"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.563299104529779*^9, 3.563299105590105*^9}, {
  3.5632991567246227`*^9, 3.563299261204896*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   FractionBox["1", "9"], " ", 
   SuperscriptBox["g", "8"], " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"-", "9720"}], "-", 
     RowBox[{"4", " ", 
      SqrtBox["3"], " ", "Im1"}]}], ")"}]}], "-", 
  RowBox[{"3024", " ", 
   SuperscriptBox["g", "8"], " ", 
   SubscriptBox[
    StyleBox["\[Zeta]",
     FontWeight->Bold,
     FontColor->GrayLevel[0.4]], "3"]}], "+", 
  RowBox[{"5280", " ", 
   SuperscriptBox["g", "8"], " ", 
   SubscriptBox[
    StyleBox["\[Zeta]",
     FontWeight->Bold,
     FontColor->GrayLevel[0.4]], "5"]}]}]], "Output",
 CellChangeTimes->{3.563299468108007*^9, 3.5632997197271442`*^9}]
}, Open  ]],

Cell[BoxData[{
 RowBox[{"Select", "[", 
  RowBox[{
   RowBox[{"Collect", "[", 
    RowBox[{"singotherterms", ",", "u"}], "]"}], ",", 
   RowBox[{
    RowBox[{"Not", "@", 
     RowBox[{"FreeQ", "[", 
      RowBox[{"#", ",", "u"}], "]"}]}], "&"}]}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"%", "//", "symfun"}]}], "Input",
 CellChangeTimes->{{3.563299263054196*^9, 3.563299321454166*^9}, {
  3.563299363371057*^9, 3.563299383329378*^9}, {3.563299725199622*^9, 
  3.563299725710909*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  SuperscriptBox["g", "8"], " ", "u", " ", 
  RowBox[{"(", 
   RowBox[{
    RowBox[{
     RowBox[{"-", "2592"}], " ", 
     SubscriptBox[
      StyleBox["\[Zeta]",
       FontWeight->Bold,
       FontColor->GrayLevel[0.4]], "3"], " ", 
     SubsuperscriptBox[
      StyleBox["\[Eta]",
       FontWeight->Bold,
       FontColor->RGBColor[0.8, 0, 0]], "2", 
      RowBox[{"[", "2", "]"}]]}], "-", 
    RowBox[{"432", " ", "\[ImaginaryI]", " ", 
     SubsuperscriptBox[
      StyleBox["\[Eta]",
       FontWeight->Bold,
       FontColor->RGBColor[0.8, 0, 0]], 
      RowBox[{"2", ",", "3"}], 
      RowBox[{"[", "2", "]"}]]}], "+", 
    RowBox[{"432", " ", "\[ImaginaryI]", " ", 
     SubsuperscriptBox[
      StyleBox["\[Eta]",
       FontWeight->Bold,
       FontColor->RGBColor[0.8, 0, 0]], 
      RowBox[{"3", ",", "2"}], 
      RowBox[{"[", "2", "]"}]]}], "-", 
    RowBox[{"2592", " ", 
     SubscriptBox[
      StyleBox["\[Zeta]",
       FontWeight->Bold,
       FontColor->GrayLevel[0.4]], "3"], " ", 
     SubsuperscriptBox[
      OverscriptBox[
       StyleBox["\[Eta]",
        FontWeight->Bold,
        FontColor->RGBColor[0.8, 0, 0]], 
       StyleBox["_",
        FontWeight->Bold,
        FontColor->RGBColor[0.8, 0, 0]]], "2", 
      RowBox[{"[", 
       RowBox[{"-", "2"}], "]"}]]}], "-", 
    RowBox[{"432", " ", "\[ImaginaryI]", " ", 
     SubsuperscriptBox[
      StyleBox["\[Eta]",
       FontWeight->Bold,
       FontColor->RGBColor[0.8, 0, 0]], "3", 
      RowBox[{"[", "2", "]"}]], " ", 
     SubsuperscriptBox[
      OverscriptBox[
       StyleBox["\[Eta]",
        FontWeight->Bold,
        FontColor->RGBColor[0.8, 0, 0]], 
       StyleBox["_",
        FontWeight->Bold,
        FontColor->RGBColor[0.8, 0, 0]]], "2", 
      RowBox[{"[", 
       RowBox[{"-", "2"}], "]"}]]}], "+", 
    RowBox[{"432", " ", "\[ImaginaryI]", " ", 
     SubsuperscriptBox[
      StyleBox["\[Eta]",
       FontWeight->Bold,
       FontColor->RGBColor[0.8, 0, 0]], "2", 
      RowBox[{"[", "2", "]"}]], " ", 
     SubsuperscriptBox[
      OverscriptBox[
       StyleBox["\[Eta]",
        FontWeight->Bold,
        FontColor->RGBColor[0.8, 0, 0]], 
       StyleBox["_",
        FontWeight->Bold,
        FontColor->RGBColor[0.8, 0, 0]]], "3", 
      RowBox[{"[", 
       RowBox[{"-", "2"}], "]"}]]}], "+", 
    RowBox[{"432", " ", "\[ImaginaryI]", " ", 
     SubsuperscriptBox[
      OverscriptBox[
       StyleBox["\[Eta]",
        FontWeight->Bold,
        FontColor->RGBColor[0.8, 0, 0]], 
       StyleBox["_",
        FontWeight->Bold,
        FontColor->RGBColor[0.8, 0, 0]]], 
      RowBox[{"2", ",", "3"}], 
      RowBox[{"[", 
       RowBox[{"-", "2"}], "]"}]]}], "-", 
    RowBox[{"432", " ", "\[ImaginaryI]", " ", 
     SubsuperscriptBox[
      OverscriptBox[
       StyleBox["\[Eta]",
        FontWeight->Bold,
        FontColor->RGBColor[0.8, 0, 0]], 
       StyleBox["_",
        FontWeight->Bold,
        FontColor->RGBColor[0.8, 0, 0]]], 
      RowBox[{"3", ",", "2"}], 
      RowBox[{"[", 
       RowBox[{"-", "2"}], "]"}]]}]}], ")"}]}]], "Input",
 CellChangeTimes->{{3.56329984054298*^9, 3.563299841690197*^9}}],

Cell[BoxData["0"], "Output",
 CellChangeTimes->{
  3.563299105937284*^9, {3.56329915901348*^9, 3.563299180874687*^9}, 
   3.56329922553433*^9, {3.563299255855227*^9, 3.563299276734146*^9}, 
   3.563299322635603*^9, {3.563299365424323*^9, 3.563299391431534*^9}, 
   3.563299470188159*^9, 3.563299726227167*^9}]
}, Open  ]],

Cell["\<\
So, we have to compute only residute. Formally it is zero. But first we have \
to make convegent function\
\>", "Text",
 CellChangeTimes->{{3.563299753881325*^9, 3.563299761336916*^9}, {
  3.563300122287581*^9, 3.563300131437449*^9}, {3.5633002001104803`*^9, 
  3.563300213195435*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"funtoadd", "=", 
  RowBox[{
   RowBox[{"Series", "[", 
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{"singotherterms", "/.", "subusu"}], "/.", 
       RowBox[{
        RowBox[{
         RowBox[{"\[Eta]$", "[", "a__", "]"}], "[", "r_", "]"}], 
        "\[RuleDelayed]", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"Generic\[Eta]", "[", 
           RowBox[{
            RowBox[{"{", "a", "}"}], ",", "5"}], "]"}], "/.", 
          RowBox[{"t", "\[Rule]", 
           RowBox[{"u", "+", 
            RowBox[{"I", " ", 
             FractionBox["r", "2"]}]}]}]}], ")"}]}]}], "/.", 
      RowBox[{
       RowBox[{
        RowBox[{"\[Eta]$b", "[", "a__", "]"}], "[", "r_", "]"}], 
       "\[RuleDelayed]", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          RowBox[{"Generic\[Eta]", "[", 
           RowBox[{
            RowBox[{"{", "a", "}"}], ",", "5"}], "]"}], "/.", "mconj"}], "/.", 
         RowBox[{"t", "\[Rule]", 
          RowBox[{"u", "+", 
           RowBox[{"I", " ", 
            FractionBox["r", "2"]}]}]}]}], ")"}]}]}], ",", 
     RowBox[{"{", 
      RowBox[{"u", ",", "\[Infinity]", ",", "1"}], "}"}]}], "]"}], "//", 
   "Normal"}]}]], "Input",
 CellChangeTimes->{{3.5633001344268703`*^9, 3.5633001659466867`*^9}, {
  3.563300293934472*^9, 3.5633002958702583`*^9}, {3.563300378360592*^9, 
  3.563300379369832*^9}}],

Cell[BoxData[
 RowBox[{"-", 
  FractionBox[
   RowBox[{"2592", " ", 
    SuperscriptBox["g", "8"], " ", 
    SubscriptBox[
     StyleBox["\[Zeta]",
      FontWeight->Bold,
      FontColor->GrayLevel[0.4]], "3"]}], "u"]}]], "Output",
 CellChangeTimes->{3.5633001700959387`*^9, 3.56330037985395*^9}]
}, Open  ]],

Cell["\<\
So we have to add and substract this function. When we substracted, we cross \
with half of it real axis, and then everything is zero by symmetry. When we \
added, we cross completely real axis.  Hence we have to compute\
\>", "Text",
 CellChangeTimes->{{3.563300217178982*^9, 3.563300303913498*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"intsingotherterms", "=", 
  RowBox[{
   FractionBox["1", "2"], 
   RowBox[{"Coefficient", "[", 
    RowBox[{"funtoadd", ",", "u", ",", 
     RowBox[{"-", "1"}]}], "]"}]}]}]], "Input",
 CellChangeTimes->{{3.5633003710541983`*^9, 3.563300388128358*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"-", "1296"}], " ", 
  SuperscriptBox["g", "8"], " ", 
  SubscriptBox[
   StyleBox["\[Zeta]",
    FontWeight->Bold,
    FontColor->GrayLevel[0.4]], "3"]}]], "Output",
 CellChangeTimes->{3.5633003887089987`*^9}]
}, Open  ]],

Cell["\<\
It remains to compute regular terms\
\>", "Text",
 CellChangeTimes->{{3.563300402223105*^9, 3.563300407085225*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"intregterms", "=", 
  RowBox[{"Collect", "[", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{"UpIntegrate", "[", 
        RowBox[{
         RowBox[{
          RowBox[{
           RowBox[{
            RowBox[{
             RowBox[{"-", 
              FractionBox["1", 
               RowBox[{"2", "\[Pi]", " ", "\[ImaginaryI]"}]]}], "regterms"}], 
            "/.", 
            RowBox[{"Shift", "[", 
             RowBox[{
              RowBox[{"-", "2"}], "\[Epsilon]"}], "]"}]}], "/.", 
           RowBox[{"u", "\[Rule]", 
            RowBox[{"u", "-", 
             RowBox[{"\[ImaginaryI]", " ", "\[Epsilon]"}]}]}]}], "/.", 
          "subusu"}], ",", "u"}], "]"}], "/.", "EndSimplify"}], "//.", 
      "subZetaReduce"}], "//", "fundeperiod"}], ",", "canlist"}], 
   "]"}]}]], "Input",
 CellChangeTimes->{{3.563299414649097*^9, 3.56329944466322*^9}, {
  3.563299487650041*^9, 3.563299507962418*^9}}],

Cell[BoxData[
 RowBox[{
  SuperscriptBox["g", "8"], " ", 
  RowBox[{"(", 
   RowBox[{"1944", "-", 
    RowBox[{"1080", " ", 
     SubscriptBox[
      StyleBox["\[Zeta]",
       FontWeight->Bold,
       FontColor->GrayLevel[0.4]], "2"]}], "-", 
    RowBox[{"648", " ", 
     SubsuperscriptBox[
      StyleBox["\[Zeta]",
       FontWeight->Bold,
       FontColor->GrayLevel[0.4]], "2", "2"]}], "+", 
    FractionBox[
     RowBox[{"23136", " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2", "3"]}], "35"], "+", 
    RowBox[{"2376", " ", 
     SubscriptBox[
      StyleBox["\[Zeta]",
       FontWeight->Bold,
       FontColor->GrayLevel[0.4]], "3"]}], "+", 
    RowBox[{"288", " ", 
     SubscriptBox[
      StyleBox["\[Zeta]",
       FontWeight->Bold,
       FontColor->GrayLevel[0.4]], "2"], " ", 
     SubscriptBox[
      StyleBox["\[Zeta]",
       FontWeight->Bold,
       FontColor->GrayLevel[0.4]], "3"]}], "+", 
    RowBox[{"216", " ", 
     SubsuperscriptBox[
      StyleBox["\[Zeta]",
       FontWeight->Bold,
       FontColor->GrayLevel[0.4]], "3", "2"]}], "-", 
    RowBox[{"2880", " ", 
     SubscriptBox[
      StyleBox["\[Zeta]",
       FontWeight->Bold,
       FontColor->GrayLevel[0.4]], "5"]}], "+", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{"-", "648"}], "-", 
       RowBox[{"216", " ", "\[ImaginaryI]", " ", 
        SqrtBox["3"]}]}], ")"}], " ", 
     SubsuperscriptBox[
      StyleBox["\[Eta]0",
       FontWeight->Bold,
       FontColor->RGBColor[0, 0.5, 0]], "2", "+"]}], "+", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{"216", " ", "\[ImaginaryI]"}], "+", 
       RowBox[{"216", " ", 
        SqrtBox["3"]}]}], ")"}], " ", 
     SubsuperscriptBox[
      StyleBox["\[Eta]0",
       FontWeight->Bold,
       FontColor->RGBColor[0, 0.5, 0]], "3", "+"]}], "+", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{"-", "108"}], "-", 
       RowBox[{"36", " ", "\[ImaginaryI]", " ", 
        SqrtBox["3"]}]}], ")"}], " ", 
     SubsuperscriptBox[
      StyleBox["\[Eta]0",
       FontWeight->Bold,
       FontColor->RGBColor[0, 0.5, 0]], "4", "+"]}], "+", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{"-", "648"}], "+", 
       RowBox[{"216", " ", "\[ImaginaryI]", " ", 
        SqrtBox["3"]}]}], ")"}], " ", 
     SubsuperscriptBox[
      OverscriptBox[
       StyleBox["\[Eta]0",
        FontWeight->Bold,
        FontColor->RGBColor[0, 0.5, 0]], 
       StyleBox["_",
        FontWeight->Bold,
        FontColor->RGBColor[0, 0.5, 0]]], "2", "-"]}], "+", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{
        RowBox[{"-", "216"}], " ", "\[ImaginaryI]"}], "+", 
       RowBox[{"216", " ", 
        SqrtBox["3"]}]}], ")"}], " ", 
     SubsuperscriptBox[
      OverscriptBox[
       StyleBox["\[Eta]0",
        FontWeight->Bold,
        FontColor->RGBColor[0, 0.5, 0]], 
       StyleBox["_",
        FontWeight->Bold,
        FontColor->RGBColor[0, 0.5, 0]]], "3", "-"]}], "+", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{"-", "108"}], "+", 
       RowBox[{"36", " ", "\[ImaginaryI]", " ", 
        SqrtBox["3"]}]}], ")"}], " ", 
     SubsuperscriptBox[
      OverscriptBox[
       StyleBox["\[Eta]0",
        FontWeight->Bold,
        FontColor->RGBColor[0, 0.5, 0]], 
       StyleBox["_",
        FontWeight->Bold,
        FontColor->RGBColor[0, 0.5, 0]]], "4", "-"]}]}], ")"}]}]], "Output",
 CellChangeTimes->{3.5632995185416927`*^9, 3.563300417413837*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"rltCT", "=", 
  RowBox[{"Collect", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"intregterms", "+", "intsinguterms", "+", "intsingotherterms"}], 
     "/.", "subIm"}], ",", "canlist"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.563299594315194*^9, 3.563299645663198*^9}, {
   3.563300417786248*^9, 3.563300421823348*^9}, 3.563300533279089*^9}],

Cell[BoxData[
 RowBox[{
  SuperscriptBox["g", "8"], " ", 
  RowBox[{"(", 
   RowBox[{"324", "-", 
    RowBox[{"1080", " ", 
     SubscriptBox[
      StyleBox["\[Zeta]",
       FontWeight->Bold,
       FontColor->GrayLevel[0.4]], "2"]}], "-", 
    RowBox[{"648", " ", 
     SubsuperscriptBox[
      StyleBox["\[Zeta]",
       FontWeight->Bold,
       FontColor->GrayLevel[0.4]], "2", "2"]}], "+", 
    FractionBox[
     RowBox[{"23136", " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2", "3"]}], "35"], "-", 
    RowBox[{"2808", " ", 
     SubscriptBox[
      StyleBox["\[Zeta]",
       FontWeight->Bold,
       FontColor->GrayLevel[0.4]], "3"]}], "+", 
    RowBox[{"288", " ", 
     SubscriptBox[
      StyleBox["\[Zeta]",
       FontWeight->Bold,
       FontColor->GrayLevel[0.4]], "2"], " ", 
     SubscriptBox[
      StyleBox["\[Zeta]",
       FontWeight->Bold,
       FontColor->GrayLevel[0.4]], "3"]}], "+", 
    RowBox[{"216", " ", 
     SubsuperscriptBox[
      StyleBox["\[Zeta]",
       FontWeight->Bold,
       FontColor->GrayLevel[0.4]], "3", "2"]}], "+", 
    RowBox[{"1440", " ", 
     SubscriptBox[
      StyleBox["\[Zeta]",
       FontWeight->Bold,
       FontColor->GrayLevel[0.4]], "5"]}], "+", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{"-", "648"}], "+", 
       RowBox[{"216", " ", "\[ImaginaryI]", " ", 
        SqrtBox["3"]}]}], ")"}], " ", 
     SubsuperscriptBox[
      StyleBox["\[Eta]0",
       FontWeight->Bold,
       FontColor->RGBColor[0, 0.5, 0]], "2", "+"]}], "+", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{
        RowBox[{"-", "216"}], " ", "\[ImaginaryI]"}], "+", 
       RowBox[{"216", " ", 
        SqrtBox["3"]}]}], ")"}], " ", 
     SubsuperscriptBox[
      StyleBox["\[Eta]0",
       FontWeight->Bold,
       FontColor->RGBColor[0, 0.5, 0]], "3", "+"]}], "+", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{"-", "108"}], "+", 
       RowBox[{"36", " ", "\[ImaginaryI]", " ", 
        SqrtBox["3"]}]}], ")"}], " ", 
     SubsuperscriptBox[
      StyleBox["\[Eta]0",
       FontWeight->Bold,
       FontColor->RGBColor[0, 0.5, 0]], "4", "+"]}], "+", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{"-", "648"}], "-", 
       RowBox[{"216", " ", "\[ImaginaryI]", " ", 
        SqrtBox["3"]}]}], ")"}], " ", 
     SubsuperscriptBox[
      OverscriptBox[
       StyleBox["\[Eta]0",
        FontWeight->Bold,
        FontColor->RGBColor[0, 0.5, 0]], 
       StyleBox["_",
        FontWeight->Bold,
        FontColor->RGBColor[0, 0.5, 0]]], "2", "-"]}], "+", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{"216", " ", "\[ImaginaryI]"}], "+", 
       RowBox[{"216", " ", 
        SqrtBox["3"]}]}], ")"}], " ", 
     SubsuperscriptBox[
      OverscriptBox[
       StyleBox["\[Eta]0",
        FontWeight->Bold,
        FontColor->RGBColor[0, 0.5, 0]], 
       StyleBox["_",
        FontWeight->Bold,
        FontColor->RGBColor[0, 0.5, 0]]], "3", "-"]}], "+", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{"-", "108"}], "-", 
       RowBox[{"36", " ", "\[ImaginaryI]", " ", 
        SqrtBox["3"]}]}], ")"}], " ", 
     SubsuperscriptBox[
      OverscriptBox[
       StyleBox["\[Eta]0",
        FontWeight->Bold,
        FontColor->RGBColor[0, 0.5, 0]], 
       StyleBox["_",
        FontWeight->Bold,
        FontColor->RGBColor[0, 0.5, 0]]], "4", "-"]}]}], ")"}]}]], "Output",
 CellChangeTimes->{{3.563299615230102*^9, 3.563299646029996*^9}, 
   3.5633004232246847`*^9, 3.563300533985671*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"BoldCompute", "[", "rltCT", "]"}], "//", "Chop"}]], "Input",
 CellChangeTimes->{{3.563299620946375*^9, 3.563299625512293*^9}, {
   3.5633000478422813`*^9, 3.563300054018361*^9}, {3.5633004269357557`*^9, 
   3.5633004335997334`*^9}, 3.563300536538138*^9}],

Cell[BoxData[
 RowBox[{"4.20031993319979648385207967231255181046`16.432446256555643", " ", 
  SuperscriptBox["g", "8"]}]], "Output",
 CellChangeTimes->{{3.563299625933311*^9, 3.5632996467079372`*^9}, {
   3.563300050773101*^9, 3.56330005441495*^9}, {3.5633004274972067`*^9, 
   3.56330043397077*^9}, 3.563300536952736*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"specint", "[", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{"tmp4", "/.", "subusu"}], "/.", "subIm"}], "/.", "subZetas"}], 
     "/.", 
     RowBox[{"g", "\[Rule]", "1"}]}], "/.", 
    RowBox[{
     RowBox[{"xxx", ":", 
      RowBox[{
       RowBox[{
        RowBox[{"(", 
         RowBox[{"\[Eta]0$", "|", "\[Eta]0$b"}], ")"}], "[", "__", "]"}], "[",
        "_", "]"}]}], "\[RuleDelayed]", 
     RowBox[{"BoldCompute", "[", 
      RowBox[{"xxx", ",", "0", ",", "150"}], "]"}]}]}], ",", 
   RowBox[{
    RowBox[{"-", "\[ImaginaryI]"}], "/", "4"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.563299663485997*^9, 3.563299664642334*^9}}],

Cell[BoxData[
 RowBox[{"4.20043675582243720964663944310960585692`14.150514997831992", "+", 
  RowBox[{
  "1.8073899062050135066158486`0.7842724002556286*^-13", " ", 
   "\[ImaginaryI]"}]}]], "Output",
 CellChangeTimes->{3.5632996812109222`*^9, 3.563300453228527*^9}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["All together", "Subsubsection",
 CellChangeTimes->{
  3.561466243363893*^9, {3.56146792094175*^9, 3.561467934866007*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"normalUr", "=", 
  RowBox[{"Collect", "[", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{"Collect", "[", 
         RowBox[{
          RowBox[{
          "ratLogT11rpT11rm", "+", "preconY11Y22", "+", "rhsT10", "-", 
           "ratLogT01c", "+", "ratioTright", "+", "rltCT", "+", 
           RowBox[{
            SuperscriptBox["g", "8"], 
            RowBox[{"\[DoubleStruckCapitalC]", "[", 
             RowBox[{
              RowBox[{"(", 
               RowBox[{
                FractionBox["2", "u"], "-", 
                FractionBox[
                 RowBox[{"2", " ", "\[ImaginaryI]"}], 
                 RowBox[{"1", "+", 
                  SuperscriptBox["u", "2"]}]]}], ")"}], "H"}], "]"}]}]}], ",",
           "g", ",", "Simplify"}], "]"}], "/.", 
        RowBox[{
         RowBox[{"H$", "[", "0", "]"}], "\[Rule]", 
         SubscriptBox["H", "lead"]}]}], "/.", "solut\[Rho]sexplicit"}], "//", 
      "CCompute"}], "//", "fundeperiod"}], ",", "canlist", ",", "Simplify"}], 
   "]"}]}]], "Input",
 CellChangeTimes->{{3.56146793759584*^9, 3.561467939044826*^9}, {
   3.561468082870775*^9, 3.561468233869379*^9}, 3.562246937185014*^9, 
   3.563025046628727*^9, {3.563025199394888*^9, 3.563025221948286*^9}, {
   3.5630252935719137`*^9, 3.5630252972073717`*^9}, {3.563025331353942*^9, 
   3.56302536709659*^9}, {3.563025949017782*^9, 3.5630259522959623`*^9}, {
   3.5633005692296333`*^9, 3.563300587759947*^9}}],

Cell[BoxData[
 RowBox[{
  SuperscriptBox["g", "8"], " ", 
  RowBox[{"(", 
   RowBox[{
    RowBox[{"-", 
     FractionBox["27", "7"]}], "-", 
    FractionBox[
     RowBox[{"3744", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2"]}], "7"], "+", 
    FractionBox[
     RowBox[{"5364", " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2", "2"]}], "35"], "+", 
    FractionBox[
     RowBox[{"96", " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2", "3"]}], "7"], "-", 
    FractionBox[
     RowBox[{"15228", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3"]}], "7"], "+", 
    RowBox[{"144", " ", 
     SubscriptBox[
      StyleBox["\[Zeta]",
       FontWeight->Bold,
       FontColor->GrayLevel[0.4]], "2"], " ", 
     SubscriptBox[
      StyleBox["\[Zeta]",
       FontWeight->Bold,
       FontColor->GrayLevel[0.4]], "3"]}], "+", 
    RowBox[{"36", " ", 
     SubsuperscriptBox[
      StyleBox["\[Zeta]",
       FontWeight->Bold,
       FontColor->GrayLevel[0.4]], "3", "2"]}], "+", 
    RowBox[{"1800", " ", 
     SubscriptBox[
      StyleBox["\[Zeta]",
       FontWeight->Bold,
       FontColor->GrayLevel[0.4]], "5"]}], "+", 
    RowBox[{"420", " ", 
     SubscriptBox[
      StyleBox["\[Zeta]",
       FontWeight->Bold,
       FontColor->GrayLevel[0.4]], "7"]}], "+", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{"-", 
        FractionBox["1620", "7"]}], "+", 
       FractionBox[
        RowBox[{"432", " ", "\[ImaginaryI]", " ", 
         SqrtBox["3"]}], "7"]}], ")"}], " ", 
     SubsuperscriptBox[
      StyleBox["\[Eta]0",
       FontWeight->Bold,
       FontColor->RGBColor[0, 0.5, 0]], "2", "+"]}], "+", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{"-", 
        FractionBox[
         RowBox[{"432", " ", "\[ImaginaryI]"}], "7"]}], "+", 
       FractionBox[
        RowBox[{"540", " ", 
         SqrtBox["3"]}], "7"]}], ")"}], " ", 
     SubsuperscriptBox[
      StyleBox["\[Eta]0",
       FontWeight->Bold,
       FontColor->RGBColor[0, 0.5, 0]], "3", "+"]}], "+", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{"-", 
        FractionBox["270", "7"]}], "+", 
       FractionBox[
        RowBox[{"72", " ", "\[ImaginaryI]", " ", 
         SqrtBox["3"]}], "7"]}], ")"}], " ", 
     SubsuperscriptBox[
      StyleBox["\[Eta]0",
       FontWeight->Bold,
       FontColor->RGBColor[0, 0.5, 0]], "4", "+"]}], "+", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{"-", 
        FractionBox["1620", "7"]}], "-", 
       FractionBox[
        RowBox[{"432", " ", "\[ImaginaryI]", " ", 
         SqrtBox["3"]}], "7"]}], ")"}], " ", 
     SubsuperscriptBox[
      OverscriptBox[
       StyleBox["\[Eta]0",
        FontWeight->Bold,
        FontColor->RGBColor[0, 0.5, 0]], 
       StyleBox["_",
        FontWeight->Bold,
        FontColor->RGBColor[0, 0.5, 0]]], "2", "-"]}], "+", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       FractionBox[
        RowBox[{"432", " ", "\[ImaginaryI]"}], "7"], "+", 
       FractionBox[
        RowBox[{"540", " ", 
         SqrtBox["3"]}], "7"]}], ")"}], " ", 
     SubsuperscriptBox[
      OverscriptBox[
       StyleBox["\[Eta]0",
        FontWeight->Bold,
        FontColor->RGBColor[0, 0.5, 0]], 
       StyleBox["_",
        FontWeight->Bold,
        FontColor->RGBColor[0, 0.5, 0]]], "3", "-"]}], "+", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{"-", 
        FractionBox["270", "7"]}], "-", 
       FractionBox[
        RowBox[{"72", " ", "\[ImaginaryI]", " ", 
         SqrtBox["3"]}], "7"]}], ")"}], " ", 
     SubsuperscriptBox[
      OverscriptBox[
       StyleBox["\[Eta]0",
        FontWeight->Bold,
        FontColor->RGBColor[0, 0.5, 0]], 
       StyleBox["_",
        FontWeight->Bold,
        FontColor->RGBColor[0, 0.5, 0]]], "4", "-"]}]}], ")"}]}]], "Output",
 CellChangeTimes->{{3.561468183942168*^9, 3.561468234386386*^9}, 
   3.562246942383601*^9, {3.563025269664199*^9, 3.5630252977786627`*^9}, {
   3.563025338660275*^9, 3.563025350813686*^9}, 3.5630254287483063`*^9, 
   3.563025953172689*^9, 3.563027249782999*^9, 3.563082067627263*^9, 
   3.563300544987458*^9, {3.563300582432376*^9, 3.563300591837516*^9}}]
}, Open  ]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 "Explicit expressions for weak coupling of ",
 Cell[BoxData[
  FormBox[
   SubscriptBox["U", "asym"], TraditionalForm]]]
}], "Subsection",
 CellChangeTimes->{{3.55022664718054*^9, 3.5502266485896187`*^9}, {
  3.550226686196568*^9, 3.550226732809936*^9}, {3.550227649621166*^9, 
  3.5502276545232563`*^9}, {3.550230216917904*^9, 3.550230237193983*^9}, {
  3.5502963228101254`*^9, 3.550296325047329*^9}, {3.5614696072427387`*^9, 
  3.561469607734063*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"c", "[", 
    RowBox[{"r_", ",", "s_", ",", "n_"}], "]"}], ":=", 
   RowBox[{"2", 
    SuperscriptBox[
     RowBox[{"(", 
      RowBox[{"-", "1"}], ")"}], "n"], 
    RowBox[{"Sin", "[", 
     RowBox[{
      FractionBox["\[Pi]", "2"], 
      RowBox[{"(", 
       RowBox[{"r", "-", "s"}], ")"}]}], "]"}], 
    FractionBox[
     RowBox[{
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{"2", "n"}], "+", "r", "+", 
         RowBox[{"s", "\[Minus]", "1"}]}], ")"}], "!"}], 
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{"2", "n"}], "+", "r", "+", "s"}], ")"}], "!"}]}], 
     RowBox[{
      RowBox[{"n", "!"}], 
      RowBox[{
       RowBox[{"(", 
        RowBox[{"n", "+", "r"}], ")"}], "!"}], 
      RowBox[{
       RowBox[{"(", 
        RowBox[{"n", "+", "s"}], ")"}], "!"}], 
      RowBox[{
       RowBox[{"(", 
        RowBox[{"n", "+", "r", "+", "s"}], ")"}], "!"}]}]], 
    RowBox[{
     RowBox[{"\[Zeta]$", "[", 
      RowBox[{
       RowBox[{"2", "n"}], "+", "r", "+", "s"}], "]"}], "[", "0", "]"}]}]}], 
  ";"}]], "Input",
 CellChangeTimes->{{3.550230951518669*^9, 3.5502309719728518`*^9}, {
  3.555789604505701*^9, 3.555789608696155*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"drphase", "/.", 
  RowBox[{"leadweak", "[", "5", "]"}]}]], "Input",
 CellChangeTimes->{{3.555790098210623*^9, 3.5557901122285643`*^9}, {
  3.560866848332412*^9, 3.560866848756761*^9}}],

Cell[BoxData[
 RowBox[{
  FractionBox[
   RowBox[{"12", " ", 
    SuperscriptBox["g", "4"], " ", 
    SubscriptBox[
     StyleBox["\[Zeta]",
      FontWeight->Bold,
      FontColor->GrayLevel[0.4]], "3"]}], 
   SuperscriptBox[
    OverscriptBox[
     StyleBox["x",
      FontColor->RGBColor[0, 0.6, 0]], 
     StyleBox["^",
      FontColor->RGBColor[0, 0.6, 0]]], "2"]], "+", 
  RowBox[{
   SuperscriptBox["g", "6"], " ", 
   RowBox[{"(", 
    RowBox[{
     FractionBox[
      RowBox[{
       RowBox[{
        RowBox[{"-", "48"}], " ", 
        SubscriptBox[
         StyleBox["\[Zeta]",
          FontWeight->Bold,
          FontColor->GrayLevel[0.4]], "3"]}], "-", 
       RowBox[{"120", " ", 
        SubscriptBox[
         StyleBox["\[Zeta]",
          FontWeight->Bold,
          FontColor->GrayLevel[0.4]], "5"]}]}], 
      SuperscriptBox[
       OverscriptBox[
        StyleBox["x",
         FontColor->RGBColor[0, 0.6, 0]], 
        StyleBox["^",
         FontColor->RGBColor[0, 0.6, 0]]], "2"]], "-", 
     FractionBox[
      RowBox[{"12", " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "5"]}], 
      SuperscriptBox[
       OverscriptBox[
        StyleBox["x",
         FontColor->RGBColor[0, 0.6, 0]], 
        StyleBox["^",
         FontColor->RGBColor[0, 0.6, 0]]], "4"]]}], ")"}]}], "+", 
  RowBox[{
   SuperscriptBox["g", "8"], " ", 
   RowBox[{"(", 
    RowBox[{
     FractionBox[
      RowBox[{"12", " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "7"]}], 
      SuperscriptBox[
       OverscriptBox[
        StyleBox["x",
         FontColor->RGBColor[0, 0.6, 0]], 
        StyleBox["^",
         FontColor->RGBColor[0, 0.6, 0]]], "6"]], "+", 
     FractionBox[
      RowBox[{
       RowBox[{"48", " ", 
        SubscriptBox[
         StyleBox["\[Zeta]",
          FontWeight->Bold,
          FontColor->GrayLevel[0.4]], "5"]}], "+", 
       RowBox[{"252", " ", 
        SubscriptBox[
         StyleBox["\[Zeta]",
          FontWeight->Bold,
          FontColor->GrayLevel[0.4]], "7"]}]}], 
      SuperscriptBox[
       OverscriptBox[
        StyleBox["x",
         FontColor->RGBColor[0, 0.6, 0]], 
        StyleBox["^",
         FontColor->RGBColor[0, 0.6, 0]]], "4"]], "+", 
     FractionBox[
      RowBox[{
       RowBox[{"336", " ", 
        SubscriptBox[
         StyleBox["\[Zeta]",
          FontWeight->Bold,
          FontColor->GrayLevel[0.4]], "3"]}], "+", 
       RowBox[{"480", " ", 
        SubscriptBox[
         StyleBox["\[Zeta]",
          FontWeight->Bold,
          FontColor->GrayLevel[0.4]], "5"]}], "+", 
       RowBox[{"1260", " ", 
        SubscriptBox[
         StyleBox["\[Zeta]",
          FontWeight->Bold,
          FontColor->GrayLevel[0.4]], "7"]}]}], 
      SuperscriptBox[
       OverscriptBox[
        StyleBox["x",
         FontColor->RGBColor[0, 0.6, 0]], 
        StyleBox["^",
         FontColor->RGBColor[0, 0.6, 0]]], "2"]]}], ")"}]}], "+", 
  RowBox[{
   SuperscriptBox["g", "10"], " ", 
   RowBox[{"(", 
    RowBox[{
     FractionBox[
      RowBox[{
       RowBox[{
        RowBox[{"-", "2820"}], " ", 
        SubscriptBox[
         StyleBox["\[Zeta]",
          FontWeight->Bold,
          FontColor->GrayLevel[0.4]], "3"]}], "-", 
       RowBox[{"288", " ", 
        SubsuperscriptBox[
         StyleBox["\[Zeta]",
          FontWeight->Bold,
          FontColor->GrayLevel[0.4]], "3", "2"]}], "-", 
       RowBox[{"3576", " ", 
        SubscriptBox[
         StyleBox["\[Zeta]",
          FontWeight->Bold,
          FontColor->GrayLevel[0.4]], "5"]}], "-", 
       RowBox[{"5040", " ", 
        SubscriptBox[
         StyleBox["\[Zeta]",
          FontWeight->Bold,
          FontColor->GrayLevel[0.4]], "7"]}], "-", 
       RowBox[{"14112", " ", 
        SubscriptBox[
         StyleBox["\[Zeta]",
          FontWeight->Bold,
          FontColor->GrayLevel[0.4]], "9"]}]}], 
      SuperscriptBox[
       OverscriptBox[
        StyleBox["x",
         FontColor->RGBColor[0, 0.6, 0]], 
        StyleBox["^",
         FontColor->RGBColor[0, 0.6, 0]]], "2"]], "+", 
     FractionBox[
      RowBox[{
       RowBox[{
        RowBox[{"-", "336"}], " ", 
        SubscriptBox[
         StyleBox["\[Zeta]",
          FontWeight->Bold,
          FontColor->GrayLevel[0.4]], "5"]}], "-", 
       RowBox[{"1008", " ", 
        SubscriptBox[
         StyleBox["\[Zeta]",
          FontWeight->Bold,
          FontColor->GrayLevel[0.4]], "7"]}], "-", 
       RowBox[{"4032", " ", 
        SubscriptBox[
         StyleBox["\[Zeta]",
          FontWeight->Bold,
          FontColor->GrayLevel[0.4]], "9"]}]}], 
      SuperscriptBox[
       OverscriptBox[
        StyleBox["x",
         FontColor->RGBColor[0, 0.6, 0]], 
        StyleBox["^",
         FontColor->RGBColor[0, 0.6, 0]]], "4"]], "+", 
     FractionBox[
      RowBox[{
       RowBox[{
        RowBox[{"-", "48"}], " ", 
        SubscriptBox[
         StyleBox["\[Zeta]",
          FontWeight->Bold,
          FontColor->GrayLevel[0.4]], "7"]}], "-", 
       RowBox[{"432", " ", 
        SubscriptBox[
         StyleBox["\[Zeta]",
          FontWeight->Bold,
          FontColor->GrayLevel[0.4]], "9"]}]}], 
      SuperscriptBox[
       OverscriptBox[
        StyleBox["x",
         FontColor->RGBColor[0, 0.6, 0]], 
        StyleBox["^",
         FontColor->RGBColor[0, 0.6, 0]]], "6"]], "-", 
     FractionBox[
      RowBox[{"12", " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "9"]}], 
      SuperscriptBox[
       OverscriptBox[
        StyleBox["x",
         FontColor->RGBColor[0, 0.6, 0]], 
        StyleBox["^",
         FontColor->RGBColor[0, 0.6, 0]]], "8"]]}], ")"}]}], "+", 
  RowBox[{
   SuperscriptBox["g", "12"], " ", 
   RowBox[{"(", 
    RowBox[{
     FractionBox[
      RowBox[{"12", " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "11"]}], 
      SuperscriptBox[
       OverscriptBox[
        StyleBox["x",
         FontColor->RGBColor[0, 0.6, 0]], 
        StyleBox["^",
         FontColor->RGBColor[0, 0.6, 0]]], "10"]], "+", 
     FractionBox[
      RowBox[{
       RowBox[{"48", " ", 
        SubscriptBox[
         StyleBox["\[Zeta]",
          FontWeight->Bold,
          FontColor->GrayLevel[0.4]], "9"]}], "+", 
       RowBox[{"660", " ", 
        SubscriptBox[
         StyleBox["\[Zeta]",
          FontWeight->Bold,
          FontColor->GrayLevel[0.4]], "11"]}]}], 
      SuperscriptBox[
       OverscriptBox[
        StyleBox["x",
         FontColor->RGBColor[0, 0.6, 0]], 
        StyleBox["^",
         FontColor->RGBColor[0, 0.6, 0]]], "8"]], "+", 
     FractionBox[
      RowBox[{
       RowBox[{"336", " ", 
        SubscriptBox[
         StyleBox["\[Zeta]",
          FontWeight->Bold,
          FontColor->GrayLevel[0.4]], "7"]}], "+", 
       RowBox[{"1728", " ", 
        SubscriptBox[
         StyleBox["\[Zeta]",
          FontWeight->Bold,
          FontColor->GrayLevel[0.4]], "9"]}], "+", 
       RowBox[{"9900", " ", 
        SubscriptBox[
         StyleBox["\[Zeta]",
          FontWeight->Bold,
          FontColor->GrayLevel[0.4]], "11"]}]}], 
      SuperscriptBox[
       OverscriptBox[
        StyleBox["x",
         FontColor->RGBColor[0, 0.6, 0]], 
        StyleBox["^",
         FontColor->RGBColor[0, 0.6, 0]]], "6"]], "+", 
     FractionBox[
      RowBox[{
       RowBox[{"2820", " ", 
        SubscriptBox[
         StyleBox["\[Zeta]",
          FontWeight->Bold,
          FontColor->GrayLevel[0.4]], "5"]}], "+", 
       RowBox[{"288", " ", 
        SubscriptBox[
         StyleBox["\[Zeta]",
          FontWeight->Bold,
          FontColor->GrayLevel[0.4]], "3"], " ", 
        SubscriptBox[
         StyleBox["\[Zeta]",
          FontWeight->Bold,
          FontColor->GrayLevel[0.4]], "5"]}], "+", 
       RowBox[{"7596", " ", 
        SubscriptBox[
         StyleBox["\[Zeta]",
          FontWeight->Bold,
          FontColor->GrayLevel[0.4]], "7"]}], "+", 
       RowBox[{"16128", " ", 
        SubscriptBox[
         StyleBox["\[Zeta]",
          FontWeight->Bold,
          FontColor->GrayLevel[0.4]], "9"]}], "+", 
       RowBox[{"59400", " ", 
        SubscriptBox[
         StyleBox["\[Zeta]",
          FontWeight->Bold,
          FontColor->GrayLevel[0.4]], "11"]}]}], 
      SuperscriptBox[
       OverscriptBox[
        StyleBox["x",
         FontColor->RGBColor[0, 0.6, 0]], 
        StyleBox["^",
         FontColor->RGBColor[0, 0.6, 0]]], "4"]], "+", 
     FractionBox[
      RowBox[{
       RowBox[{"4320", " ", 
        SubsuperscriptBox[
         StyleBox["\[Zeta]",
          FontWeight->Bold,
          FontColor->GrayLevel[0.4]], "3", "2"]}], "+", 
       RowBox[{"31440", " ", 
        SubscriptBox[
         StyleBox["\[Zeta]",
          FontWeight->Bold,
          FontColor->GrayLevel[0.4]], "5"]}], "+", 
       RowBox[{
        SubscriptBox[
         StyleBox["\[Zeta]",
          FontWeight->Bold,
          FontColor->GrayLevel[0.4]], "3"], " ", 
        RowBox[{"(", 
         RowBox[{"26508", "+", 
          FractionBox[
           RowBox[{"4", " ", "Im1"}], 
           SqrtBox["3"]], "+", 
          RowBox[{"5760", " ", 
           SubscriptBox[
            StyleBox["\[Zeta]",
             FontWeight->Bold,
             FontColor->GrayLevel[0.4]], "5"]}]}], ")"}]}], "+", 
       RowBox[{"38736", " ", 
        SubscriptBox[
         StyleBox["\[Zeta]",
          FontWeight->Bold,
          FontColor->GrayLevel[0.4]], "7"]}], "+", 
       RowBox[{"56448", " ", 
        SubscriptBox[
         StyleBox["\[Zeta]",
          FontWeight->Bold,
          FontColor->GrayLevel[0.4]], "9"]}], "+", 
       RowBox[{"166320", " ", 
        SubscriptBox[
         StyleBox["\[Zeta]",
          FontWeight->Bold,
          FontColor->GrayLevel[0.4]], "11"]}]}], 
      SuperscriptBox[
       OverscriptBox[
        StyleBox["x",
         FontColor->RGBColor[0, 0.6, 0]], 
        StyleBox["^",
         FontColor->RGBColor[0, 0.6, 0]]], "2"]]}], ")"}]}]}]], "Output",
 CellChangeTimes->{{3.555790105548099*^9, 3.555790112721631*^9}, 
   3.560866853661522*^9, 3.560874710369837*^9, 3.561059969580626*^9, 
   3.561469613980692*^9, 3.5622636321415033`*^9, 3.56330117726306*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"tmpV", "=", 
   RowBox[{"(*", " ", 
    RowBox[{
    "this", " ", "includes", " ", "the", " ", "fact", " ", "that", " ", 
     "there", " ", "are", " ", "two", " ", "symmetric", " ", "Bethe", " ", 
     "roots"}], " ", "*)"}], 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"Collect", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"Series", "[", 
          RowBox[{
           RowBox[{
            RowBox[{
             RowBox[{"Sum", "[", 
              RowBox[{
               RowBox[{
                FractionBox[
                 RowBox[{"-", "2"}], 
                 RowBox[{
                  RowBox[{"2", "k"}], "+", "1"}]], 
                RowBox[{"(", 
                 RowBox[{
                  FractionBox["1", 
                   SuperscriptBox[
                    RowBox[{"(", 
                    SuperscriptBox[
                    OverscriptBox[
                    StyleBox["y",
                    FontColor->RGBColor[0, 0.6, 0]], 
                    StyleBox["^",
                    FontColor->RGBColor[0, 0.6, 0]]], "+"], ")"}], 
                    RowBox[{
                    RowBox[{"2", "k"}], "+", "1"}]]], "-", 
                  FractionBox["1", 
                   SuperscriptBox[
                    RowBox[{"(", 
                    SuperscriptBox[
                    OverscriptBox[
                    StyleBox["y",
                    FontColor->RGBColor[0, 0.6, 0]], 
                    StyleBox["^",
                    FontColor->RGBColor[0, 0.6, 0]]], "-"], ")"}], 
                    RowBox[{
                    RowBox[{"2", "k"}], "+", "1"}]]]}], ")"}], 
                FractionBox["1", 
                 SuperscriptBox[
                  OverscriptBox["x", "^"], 
                  RowBox[{
                   RowBox[{"2", "k"}], "+", "1"}]]]}], ",", 
               RowBox[{"{", 
                RowBox[{"k", ",", "0", ",", "5"}], "}"}]}], "]"}], "/.", 
             "subJuk"}], "/.", 
            RowBox[{"leadweak", "[", "5", "]"}]}], ",", 
           RowBox[{"{", 
            RowBox[{"g", ",", "0", ",", "8"}], "}"}]}], "]"}], "//", 
         "Normal"}], ",", "u", ",", "Simplify"}], "]"}], "/.", 
      RowBox[{
       SuperscriptBox["u", "a_."], "\[RuleDelayed]", 
       SubsuperscriptBox["\[Eta]", 
        RowBox[{"-", "a"}], 
        RowBox[{"[", "2", "]"}]]}]}], ")"}], "+", 
    RowBox[{"(*", 
     RowBox[{
     "contribution", " ", "from", " ", "the", " ", "dressing", " ", "phase"}],
      " ", "*)"}], 
    RowBox[{"+", 
     RowBox[{"(", 
      RowBox[{"drphase", "/.", 
       RowBox[{"leadweak", "[", "5", "]"}]}], ")"}]}]}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"tmpV", "=", 
  RowBox[{
   RowBox[{
    RowBox[{"Collect", "[", 
     RowBox[{"#", ",", 
      SubsuperscriptBox["\[Eta]", "_", 
       RowBox[{"[", "2", "]"}]], ",", "Simplify"}], "]"}], "&"}], "/@", 
   RowBox[{"Series", "[", 
    RowBox[{
     RowBox[{"Exp", "[", "tmpV", "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"g", ",", "0", ",", "8"}], "}"}]}], "]"}]}]}]}], "Input",
 CellChangeTimes->{{3.5409785710731773`*^9, 3.5409787444513063`*^9}, {
   3.540979196617437*^9, 3.540979273874674*^9}, {3.54097930854606*^9, 
   3.5409793101780643`*^9}, {3.540979379598606*^9, 3.540979380136709*^9}, {
   3.5409797406288*^9, 3.540979748366774*^9}, {3.540979779310378*^9, 
   3.5409797820452538`*^9}, 3.541012741467863*^9, {3.541012787511044*^9, 
   3.54101279022946*^9}, {3.541063821092331*^9, 3.5410638994626617`*^9}, {
   3.541063945767376*^9, 3.541063960232997*^9}, {3.541064014229698*^9, 
   3.541064014372715*^9}, {3.5502336636109533`*^9, 3.55023367999765*^9}, {
   3.550234685333322*^9, 3.550234699729247*^9}, 3.550234822363819*^9, {
   3.5502348549628*^9, 3.550234859357175*^9}, 3.550234892966872*^9, {
   3.550235148403988*^9, 3.550235205535935*^9}, {3.5502933959335403`*^9, 
   3.55029341476394*^9}, {3.552379699704681*^9, 3.5523797298066473`*^9}, {
   3.554629010208406*^9, 3.554629015007023*^9}, {3.555790262422866*^9, 
   3.555790284097692*^9}, {3.5608747297655563`*^9, 3.560874751916431*^9}, {
   3.562263658404909*^9, 3.562263658645289*^9}}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"1", "+", 
   RowBox[{"6", " ", "\[ImaginaryI]", " ", 
    SubsuperscriptBox[
     StyleBox["\[Eta]",
      FontWeight->Bold,
      FontColor->RGBColor[0.8, 0, 0]], "1", 
     RowBox[{"[", "2", "]"}]], " ", 
    SuperscriptBox["g", "2"]}], "+", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      FractionBox[
       RowBox[{"12", " ", 
        SubscriptBox[
         StyleBox["\[Zeta]",
          FontWeight->Bold,
          FontColor->GrayLevel[0.4]], "3"]}], 
       SuperscriptBox[
        OverscriptBox[
         StyleBox["x",
          FontColor->RGBColor[0, 0.6, 0]], 
         StyleBox["^",
          FontColor->RGBColor[0, 0.6, 0]]], "2"]], "-", 
      RowBox[{"24", " ", "\[ImaginaryI]", " ", 
       SubsuperscriptBox[
        StyleBox["\[Eta]",
         FontWeight->Bold,
         FontColor->RGBColor[0.8, 0, 0]], "1", 
        RowBox[{"[", "2", "]"}]]}], "-", 
      RowBox[{"18", " ", 
       SuperscriptBox[
        RowBox[{"(", 
         SubsuperscriptBox[
          StyleBox["\[Eta]",
           FontWeight->Bold,
           FontColor->RGBColor[0.8, 0, 0]], "1", 
          RowBox[{"[", "2", "]"}]], ")"}], "2"]}], "+", 
      RowBox[{"6", " ", "\[ImaginaryI]", " ", 
       SubsuperscriptBox[
        StyleBox["\[Eta]",
         FontWeight->Bold,
         FontColor->RGBColor[0.8, 0, 0]], "3", 
        RowBox[{"[", "2", "]"}]]}]}], ")"}], " ", 
    SuperscriptBox["g", "4"]}], "+", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"-", 
       FractionBox[
        RowBox[{"12", " ", 
         RowBox[{"(", 
          RowBox[{
           SubscriptBox[
            StyleBox["\[Zeta]",
             FontWeight->Bold,
             FontColor->GrayLevel[0.4]], "5"], "+", 
           RowBox[{"2", " ", 
            SuperscriptBox[
             OverscriptBox[
              StyleBox["x",
               FontColor->RGBColor[0, 0.6, 0]], 
              StyleBox["^",
               FontColor->RGBColor[0, 0.6, 0]]], "2"], " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"2", " ", 
               SubscriptBox[
                StyleBox["\[Zeta]",
                 FontWeight->Bold,
                 FontColor->GrayLevel[0.4]], "3"]}], "+", 
              RowBox[{"5", " ", 
               SubscriptBox[
                StyleBox["\[Zeta]",
                 FontWeight->Bold,
                 FontColor->GrayLevel[0.4]], "5"]}]}], ")"}]}]}], ")"}]}], 
        SuperscriptBox[
         OverscriptBox[
          StyleBox["x",
           FontColor->RGBColor[0, 0.6, 0]], 
          StyleBox["^",
           FontColor->RGBColor[0, 0.6, 0]]], "4"]]}], "+", 
      RowBox[{"144", " ", 
       SuperscriptBox[
        RowBox[{"(", 
         SubsuperscriptBox[
          StyleBox["\[Eta]",
           FontWeight->Bold,
           FontColor->RGBColor[0.8, 0, 0]], "1", 
          RowBox[{"[", "2", "]"}]], ")"}], "2"]}], "-", 
      RowBox[{"36", " ", "\[ImaginaryI]", " ", 
       SuperscriptBox[
        RowBox[{"(", 
         SubsuperscriptBox[
          StyleBox["\[Eta]",
           FontWeight->Bold,
           FontColor->RGBColor[0.8, 0, 0]], "1", 
          RowBox[{"[", "2", "]"}]], ")"}], "3"]}], "+", 
      RowBox[{
       SubsuperscriptBox[
        StyleBox["\[Eta]",
         FontWeight->Bold,
         FontColor->RGBColor[0.8, 0, 0]], "1", 
        RowBox[{"[", "2", "]"}]], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"72", " ", "\[ImaginaryI]", " ", 
          RowBox[{"(", 
           RowBox[{
            FractionBox["7", "3"], "+", 
            FractionBox[
             SubscriptBox[
              StyleBox["\[Zeta]",
               FontWeight->Bold,
               FontColor->GrayLevel[0.4]], "3"], 
             SuperscriptBox[
              OverscriptBox[
               StyleBox["x",
                FontColor->RGBColor[0, 0.6, 0]], 
               StyleBox["^",
                FontColor->RGBColor[0, 0.6, 0]]], "2"]]}], ")"}]}], "-", 
         RowBox[{"36", " ", 
          SubsuperscriptBox[
           StyleBox["\[Eta]",
            FontWeight->Bold,
            FontColor->RGBColor[0.8, 0, 0]], "3", 
           RowBox[{"[", "2", "]"}]]}]}], ")"}]}], "-", 
      RowBox[{"24", " ", "\[ImaginaryI]", " ", 
       SubsuperscriptBox[
        StyleBox["\[Eta]",
         FontWeight->Bold,
         FontColor->RGBColor[0.8, 0, 0]], "3", 
        RowBox[{"[", "2", "]"}]]}], "+", 
      RowBox[{"12", " ", "\[ImaginaryI]", " ", 
       SubsuperscriptBox[
        StyleBox["\[Eta]",
         FontWeight->Bold,
         FontColor->RGBColor[0.8, 0, 0]], "5", 
        RowBox[{"[", "2", "]"}]]}]}], ")"}], " ", 
    SuperscriptBox["g", "6"]}], "+", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      FractionBox[
       RowBox[{"12", " ", 
        RowBox[{"(", 
         RowBox[{
          SubscriptBox[
           StyleBox["\[Zeta]",
            FontWeight->Bold,
            FontColor->GrayLevel[0.4]], "7"], "+", 
          RowBox[{
           SuperscriptBox[
            OverscriptBox[
             StyleBox["x",
              FontColor->RGBColor[0, 0.6, 0]], 
             StyleBox["^",
              FontColor->RGBColor[0, 0.6, 0]]], "2"], " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"6", " ", 
              SubsuperscriptBox[
               StyleBox["\[Zeta]",
                FontWeight->Bold,
                FontColor->GrayLevel[0.4]], "3", "2"]}], "+", 
             RowBox[{"4", " ", 
              SubscriptBox[
               StyleBox["\[Zeta]",
                FontWeight->Bold,
                FontColor->GrayLevel[0.4]], "5"]}], "+", 
             RowBox[{"21", " ", 
              SubscriptBox[
               StyleBox["\[Zeta]",
                FontWeight->Bold,
                FontColor->GrayLevel[0.4]], "7"]}]}], ")"}]}], "+", 
          RowBox[{
           SuperscriptBox[
            OverscriptBox[
             StyleBox["x",
              FontColor->RGBColor[0, 0.6, 0]], 
             StyleBox["^",
              FontColor->RGBColor[0, 0.6, 0]]], "4"], " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"28", " ", 
              SubscriptBox[
               StyleBox["\[Zeta]",
                FontWeight->Bold,
                FontColor->GrayLevel[0.4]], "3"]}], "+", 
             RowBox[{"40", " ", 
              SubscriptBox[
               StyleBox["\[Zeta]",
                FontWeight->Bold,
                FontColor->GrayLevel[0.4]], "5"]}], "+", 
             RowBox[{"105", " ", 
              SubscriptBox[
               StyleBox["\[Zeta]",
                FontWeight->Bold,
                FontColor->GrayLevel[0.4]], "7"]}]}], ")"}]}]}], ")"}]}], 
       SuperscriptBox[
        OverscriptBox[
         StyleBox["x",
          FontColor->RGBColor[0, 0.6, 0]], 
         StyleBox["^",
          FontColor->RGBColor[0, 0.6, 0]]], "6"]], "+", 
      RowBox[{"432", " ", "\[ImaginaryI]", " ", 
       SuperscriptBox[
        RowBox[{"(", 
         SubsuperscriptBox[
          StyleBox["\[Eta]",
           FontWeight->Bold,
           FontColor->RGBColor[0.8, 0, 0]], "1", 
          RowBox[{"[", "2", "]"}]], ")"}], "3"]}], "+", 
      RowBox[{"54", " ", 
       SuperscriptBox[
        RowBox[{"(", 
         SubsuperscriptBox[
          StyleBox["\[Eta]",
           FontWeight->Bold,
           FontColor->RGBColor[0.8, 0, 0]], "1", 
          RowBox[{"[", "2", "]"}]], ")"}], "4"]}], "+", 
      RowBox[{
       SuperscriptBox[
        RowBox[{"(", 
         SubsuperscriptBox[
          StyleBox["\[Eta]",
           FontWeight->Bold,
           FontColor->RGBColor[0.8, 0, 0]], "1", 
          RowBox[{"[", "2", "]"}]], ")"}], "2"], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"216", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"-", "6"}], "-", 
            FractionBox[
             SubscriptBox[
              StyleBox["\[Zeta]",
               FontWeight->Bold,
               FontColor->GrayLevel[0.4]], "3"], 
             SuperscriptBox[
              OverscriptBox[
               StyleBox["x",
                FontColor->RGBColor[0, 0.6, 0]], 
               StyleBox["^",
                FontColor->RGBColor[0, 0.6, 0]]], "2"]]}], ")"}]}], "-", 
         RowBox[{"108", " ", "\[ImaginaryI]", " ", 
          SubsuperscriptBox[
           StyleBox["\[Eta]",
            FontWeight->Bold,
            FontColor->RGBColor[0.8, 0, 0]], "3", 
           RowBox[{"[", "2", "]"}]]}]}], ")"}]}], "+", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{"186", " ", "\[ImaginaryI]"}], "+", 
         FractionBox[
          RowBox[{"72", " ", "\[ImaginaryI]", " ", 
           SubscriptBox[
            StyleBox["\[Zeta]",
             FontWeight->Bold,
             FontColor->GrayLevel[0.4]], "3"]}], 
          SuperscriptBox[
           OverscriptBox[
            StyleBox["x",
             FontColor->RGBColor[0, 0.6, 0]], 
            StyleBox["^",
             FontColor->RGBColor[0, 0.6, 0]]], "2"]]}], ")"}], " ", 
       SubsuperscriptBox[
        StyleBox["\[Eta]",
         FontWeight->Bold,
         FontColor->RGBColor[0.8, 0, 0]], "3", 
        RowBox[{"[", "2", "]"}]]}], "-", 
      RowBox[{"18", " ", 
       SuperscriptBox[
        RowBox[{"(", 
         SubsuperscriptBox[
          StyleBox["\[Eta]",
           FontWeight->Bold,
           FontColor->RGBColor[0.8, 0, 0]], "3", 
          RowBox[{"[", "2", "]"}]], ")"}], "2"]}], "+", 
      RowBox[{
       SubsuperscriptBox[
        StyleBox["\[Eta]",
         FontWeight->Bold,
         FontColor->RGBColor[0.8, 0, 0]], "1", 
        RowBox[{"[", "2", "]"}]], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", 
          FractionBox[
           RowBox[{"6", " ", "\[ImaginaryI]", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{
               SuperscriptBox[
                OverscriptBox[
                 StyleBox["x",
                  FontColor->RGBColor[0, 0.6, 0]], 
                 StyleBox["^",
                  FontColor->RGBColor[0, 0.6, 0]]], "4"], " ", 
               RowBox[{"(", 
                RowBox[{"235", "+", 
                 RowBox[{"24", " ", 
                  SubscriptBox[
                   StyleBox["\[Zeta]",
                    FontWeight->Bold,
                    FontColor->GrayLevel[0.4]], "3"]}]}], ")"}]}], "+", 
              RowBox[{"12", " ", 
               SubscriptBox[
                StyleBox["\[Zeta]",
                 FontWeight->Bold,
                 FontColor->GrayLevel[0.4]], "5"]}], "+", 
              RowBox[{"24", " ", 
               SuperscriptBox[
                OverscriptBox[
                 StyleBox["x",
                  FontColor->RGBColor[0, 0.6, 0]], 
                 StyleBox["^",
                  FontColor->RGBColor[0, 0.6, 0]]], "2"], " ", 
               RowBox[{"(", 
                RowBox[{
                 RowBox[{"4", " ", 
                  SubscriptBox[
                   StyleBox["\[Zeta]",
                    FontWeight->Bold,
                    FontColor->GrayLevel[0.4]], "3"]}], "+", 
                 RowBox[{"5", " ", 
                  SubscriptBox[
                   StyleBox["\[Zeta]",
                    FontWeight->Bold,
                    FontColor->GrayLevel[0.4]], "5"]}]}], ")"}]}]}], ")"}]}], 
           
           SuperscriptBox[
            OverscriptBox[
             StyleBox["x",
              FontColor->RGBColor[0, 0.6, 0]], 
             StyleBox["^",
              FontColor->RGBColor[0, 0.6, 0]]], "4"]]}], "+", 
         RowBox[{"288", " ", 
          SubsuperscriptBox[
           StyleBox["\[Eta]",
            FontWeight->Bold,
            FontColor->RGBColor[0.8, 0, 0]], "3", 
           RowBox[{"[", "2", "]"}]]}], "-", 
         RowBox[{"72", " ", 
          SubsuperscriptBox[
           StyleBox["\[Eta]",
            FontWeight->Bold,
            FontColor->RGBColor[0.8, 0, 0]], "5", 
           RowBox[{"[", "2", "]"}]]}]}], ")"}]}], "-", 
      RowBox[{"48", " ", "\[ImaginaryI]", " ", 
       SubsuperscriptBox[
        StyleBox["\[Eta]",
         FontWeight->Bold,
         FontColor->RGBColor[0.8, 0, 0]], "5", 
        RowBox[{"[", "2", "]"}]]}], "+", 
      RowBox[{"30", " ", "\[ImaginaryI]", " ", 
       SubsuperscriptBox[
        StyleBox["\[Eta]",
         FontWeight->Bold,
         FontColor->RGBColor[0.8, 0, 0]], "7", 
        RowBox[{"[", "2", "]"}]]}]}], ")"}], " ", 
    SuperscriptBox["g", "8"]}], "+", 
   InterpretationBox[
    SuperscriptBox[
     RowBox[{"O", "[", "g", "]"}], "9"],
    SeriesData[$CellContext`g, 0, {}, 0, 9, 1],
    Editable->False]}],
  SeriesData[$CellContext`g, 0, {
   1, 0, Complex[0, 6] $CellContext`\[Eta]$[1][2], 0, 
    12 $CellContext`x$h[0]^(-2) $CellContext`\[Zeta]$[3][0] + 
    Complex[0, -24] $CellContext`\[Eta]$[1][2] - 
    18 $CellContext`\[Eta]$[1][2]^2 + 
    Complex[0, 6] $CellContext`\[Eta]$[3][2], 
    0, (-12) $CellContext`x$h[0]^(-4) ($CellContext`\[Zeta]$[5][0] + 
      2 $CellContext`x$h[0]^2 (2 $CellContext`\[Zeta]$[3][0] + 
        5 $CellContext`\[Zeta]$[5][0])) + 144 $CellContext`\[Eta]$[1][2]^2 + 
    Complex[0, -36] $CellContext`\[Eta]$[1][2]^3 + $CellContext`\[Eta]$[1][
      2] (Complex[0, 72] (
        Rational[
         7, 3] + $CellContext`x$h[0]^(-2) $CellContext`\[Zeta]$[3][0]) - 
      36 $CellContext`\[Eta]$[3][2]) + 
    Complex[0, -24] $CellContext`\[Eta]$[3][2] + 
    Complex[0, 12] $CellContext`\[Eta]$[5][2], 0, 
    12 $CellContext`x$h[0]^(-6) ($CellContext`\[Zeta]$[7][
       0] + $CellContext`x$h[0]^2 (6 $CellContext`\[Zeta]$[3][0]^2 + 
        4 $CellContext`\[Zeta]$[5][0] + 
        21 $CellContext`\[Zeta]$[7][0]) + $CellContext`x$h[0]^4 (
        28 $CellContext`\[Zeta]$[3][0] + 40 $CellContext`\[Zeta]$[5][0] + 
        105 $CellContext`\[Zeta]$[7][0])) + 
    Complex[0, 432] $CellContext`\[Eta]$[1][2]^3 + 
    54 $CellContext`\[Eta]$[1][2]^4 + $CellContext`\[Eta]$[1][2]^2 (
      216 (-6 - $CellContext`x$h[0]^(-2) $CellContext`\[Zeta]$[3][0]) + 
      Complex[0, -108] $CellContext`\[Eta]$[3][2]) + (Complex[0, 186] + 
      Complex[0, 72] $CellContext`x$h[0]^(-2) $CellContext`\[Zeta]$[3][
        0]) $CellContext`\[Eta]$[3][2] - 
    18 $CellContext`\[Eta]$[3][2]^2 + $CellContext`\[Eta]$[1][2] (
      Complex[0, -6] $CellContext`x$h[
         0]^(-4) ($CellContext`x$h[0]^4 (235 + 
          24 $CellContext`\[Zeta]$[3][0]) + 12 $CellContext`\[Zeta]$[5][0] + 
        24 $CellContext`x$h[0]^2 (4 $CellContext`\[Zeta]$[3][0] + 
          5 $CellContext`\[Zeta]$[5][0])) + 288 $CellContext`\[Eta]$[3][2] - 
      72 $CellContext`\[Eta]$[5][2]) + 
    Complex[0, -48] $CellContext`\[Eta]$[5][2] + 
    Complex[0, 30] $CellContext`\[Eta]$[7][2]}, 0, 9, 1],
  Editable->False]], "Output",
 CellChangeTimes->{{3.5409785914274693`*^9, 3.5409786616262417`*^9}, {
   3.5409787008458*^9, 3.540978744895681*^9}, {3.540979200299284*^9, 
   3.540979217278819*^9}, {3.5409792554850616`*^9, 3.540979310620092*^9}, 
   3.5409793491287947`*^9, 3.5409793813401546`*^9, {3.5409797412205877`*^9, 
   3.540979749082055*^9}, 3.5409797825471687`*^9, {3.541012724608779*^9, 
   3.541012741872033*^9}, 3.541012791706691*^9, {3.541063844393668*^9, 
   3.541063899887404*^9}, {3.541063948055781*^9, 3.541063960908539*^9}, 
   3.5410640148447933`*^9, 3.541064066452116*^9, 3.5502337091920443`*^9, {
   3.550234685940991*^9, 3.550234700149808*^9}, 3.5502348229162807`*^9, 
   3.5502348934621277`*^9, {3.5502351494742193`*^9, 3.5502351682300663`*^9}, 
   3.550235208023053*^9, {3.5502933967099657`*^9, 3.55029341523289*^9}, 
   3.552379618145382*^9, {3.5523797057233467`*^9, 3.5523797318632708`*^9}, 
   3.5546284190809803`*^9, 3.554629026259324*^9, 3.5546314373834047`*^9, 
   3.5557902867924347`*^9, 3.555790321489452*^9, 3.560874755304764*^9, 
   3.561059977689433*^9, 3.561469620770424*^9, 3.562263660576026*^9, 
   3.563301184100182*^9}]
}, Open  ]],

Cell["Now we compute weak coupling expansion of U:", "Text",
 CellChangeTimes->{{3.541064105847002*^9, 3.541064114388812*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"tmpU", "=", 
  RowBox[{
   RowBox[{
    RowBox[{"Collect", "[", 
     RowBox[{"#", ",", 
      SubscriptBox["\[Eta]", "_"], ",", "Simplify"}], "]"}], "&"}], "/@", 
   RowBox[{"(", 
    RowBox[{"Series", "[", 
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{"Series", "[", 
         RowBox[{
          RowBox[{
           RowBox[{
            RowBox[{
             RowBox[{
              RowBox[{
               RowBox[{
                FractionBox["1", 
                 RowBox[{
                  SqrtBox[
                   SubscriptBox["C", "\[GothicCapitalT]"]], "/.", "weak"}]], 
                "Bm", " ", 
                FractionBox[
                 RowBox[{"tmpV", "//", "Normal"}], 
                 SuperscriptBox["x", 
                  RowBox[{"L", "/", "2"}]]]}], "/.", "subFunsBethe"}], "/.", 
              RowBox[{"x$", "\[Rule]", "x$h"}]}], "/.", 
             RowBox[{"L", "\[Rule]", "2"}]}], "/.", "subJuk"}], "/.", 
           RowBox[{"leadweak", "[", "5", "]"}]}], ",", 
          RowBox[{"{", 
           RowBox[{"g", ",", "0", ",", "10"}], "}"}]}], "]"}], "//", 
        "FullSimplify"}], "//", "Normal"}], ",", 
      RowBox[{"{", 
       RowBox[{"g", ",", "0", ",", "10"}], "}"}]}], "]"}], ")"}]}]}]], "Input",\

 CellChangeTimes->{{3.541013251210978*^9, 3.54101340607852*^9}, {
   3.541013456953495*^9, 3.541013642193056*^9}, {3.541064121000519*^9, 
   3.5410642470922527`*^9}, {3.541064436168786*^9, 3.541064444551216*^9}, 
   3.550233785522223*^9, {3.550235265468643*^9, 3.550235267007942*^9}, {
   3.5502353546492653`*^9, 3.550235364869108*^9}, {3.550235526096923*^9, 
   3.5502355264146557`*^9}, {3.552379650932255*^9, 3.552379651818725*^9}, {
   3.552379742225943*^9, 3.552379767687807*^9}, {3.5608747782805967`*^9, 
   3.5608747946117153`*^9}, {3.560874836939397*^9, 3.560874837521428*^9}, {
   3.561469675223783*^9, 3.5614696764325113`*^9}, {3.563301240923182*^9, 
   3.563301241872725*^9}}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
   FractionBox[
    RowBox[{"\[ImaginaryI]", " ", 
     SqrtBox["2"], " ", 
     SuperscriptBox["g", "2"]}], "u"], "+", 
   FractionBox[
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{"2", " ", "\[ImaginaryI]"}], "-", 
       RowBox[{"3", " ", "u", " ", 
        RowBox[{"(", 
         RowBox[{"2", "+", 
          RowBox[{"u", " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{
              RowBox[{"-", "3"}], " ", "\[ImaginaryI]"}], "+", 
             RowBox[{"4", " ", 
              SubsuperscriptBox[
               StyleBox["\[Eta]",
                FontWeight->Bold,
                FontColor->RGBColor[0.8, 0, 0]], "1", 
               RowBox[{"[", "2", "]"}]]}]}], ")"}]}]}], ")"}]}]}], ")"}], " ", 
     SuperscriptBox["g", "4"]}], 
    RowBox[{
     SqrtBox["2"], " ", 
     SuperscriptBox["u", "3"]}]], "+", 
   FractionBox[
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{"16", " ", "\[ImaginaryI]"}], "+", 
       RowBox[{"3", " ", "u", " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"-", "16"}], "+", 
          RowBox[{"u", " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"4", " ", "\[ImaginaryI]"}], "+", 
             RowBox[{
              RowBox[{"(", 
               RowBox[{
                RowBox[{"-", "4"}], "-", 
                RowBox[{"51", " ", "\[ImaginaryI]", " ", "u"}]}], ")"}], " ", 
              "u"}], "-", 
             RowBox[{"8", " ", 
              RowBox[{"(", 
               RowBox[{"2", "+", 
                RowBox[{"u", " ", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"6", " ", "\[ImaginaryI]"}], "+", "u"}], ")"}]}]}],
                ")"}], " ", 
              SubsuperscriptBox[
               StyleBox["\[Eta]",
                FontWeight->Bold,
                FontColor->RGBColor[0.8, 0, 0]], "1", 
               RowBox[{"[", "2", "]"}]]}], "-", 
             RowBox[{"48", " ", "\[ImaginaryI]", " ", 
              SuperscriptBox["u", "2"], " ", 
              SuperscriptBox[
               RowBox[{"(", 
                SubsuperscriptBox[
                 StyleBox["\[Eta]",
                  FontWeight->Bold,
                  FontColor->RGBColor[0.8, 0, 0]], "1", 
                 RowBox[{"[", "2", "]"}]], ")"}], "2"]}]}], ")"}]}], "-", 
          RowBox[{"16", " ", 
           SuperscriptBox["u", "3"], " ", 
           SubsuperscriptBox[
            StyleBox["\[Eta]",
             FontWeight->Bold,
             FontColor->RGBColor[0.8, 0, 0]], "3", 
            RowBox[{"[", "2", "]"}]]}]}], ")"}]}]}], ")"}], " ", 
     SuperscriptBox["g", "6"]}], 
    RowBox[{"4", " ", 
     SqrtBox["2"], " ", 
     SuperscriptBox["u", "5"]}]], "+", 
   RowBox[{
    FractionBox["1", 
     RowBox[{"8", " ", 
      SqrtBox["2"], " ", 
      SuperscriptBox["u", "7"]}]], 
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{"80", " ", "\[ImaginaryI]"}], "+", 
       RowBox[{"3", " ", "u", " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"-", "80"}], "+", 
          RowBox[{"u", " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{
              RowBox[{"-", "64"}], " ", 
              SubsuperscriptBox[
               StyleBox["\[Eta]",
                FontWeight->Bold,
                FontColor->RGBColor[0.8, 0, 0]], "1", 
               RowBox[{"[", "2", "]"}]]}], "+", 
             RowBox[{"u", " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"-", "16"}], "-", 
                RowBox[{"192", " ", "\[ImaginaryI]", " ", 
                 SubsuperscriptBox[
                  StyleBox["\[Eta]",
                   FontWeight->Bold,
                   FontColor->RGBColor[0.8, 0, 0]], "1", 
                  RowBox[{"[", "2", "]"}]]}], "+", 
                RowBox[{"u", " ", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"-", "62"}], " ", "\[ImaginaryI]"}], "+", 
                   RowBox[{"64", " ", "\[ImaginaryI]", " ", 
                    SubscriptBox[
                    StyleBox["\[Zeta]",
                    FontWeight->Bold,
                    FontColor->GrayLevel[0.4]], "3"]}], "+", 
                   RowBox[{"16", " ", 
                    RowBox[{"(", 
                    RowBox[{"5", "-", 
                    RowBox[{"6", " ", "\[ImaginaryI]", " ", 
                    SubsuperscriptBox[
                    StyleBox["\[Eta]",
                    FontWeight->Bold,
                    FontColor->RGBColor[0.8, 0, 0]], "1", 
                    RowBox[{"[", "2", "]"}]]}]}], ")"}], " ", 
                    SubsuperscriptBox[
                    StyleBox["\[Eta]",
                    FontWeight->Bold,
                    FontColor->RGBColor[0.8, 0, 0]], "1", 
                    RowBox[{"[", "2", "]"}]]}], "+", 
                   RowBox[{"2", " ", "u", " ", 
                    RowBox[{"(", 
                    RowBox[{"73", "+", 
                    RowBox[{"24", " ", 
                    SubsuperscriptBox[
                    StyleBox["\[Eta]",
                    FontWeight->Bold,
                    FontColor->RGBColor[0.8, 0, 0]], "1", 
                    RowBox[{"[", "2", "]"}]], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"7", " ", "\[ImaginaryI]"}], "+", 
                    RowBox[{"6", " ", 
                    SubsuperscriptBox[
                    StyleBox["\[Eta]",
                    FontWeight->Bold,
                    FontColor->RGBColor[0.8, 0, 0]], "1", 
                    RowBox[{"[", "2", "]"}]]}]}], ")"}]}], "-", 
                    RowBox[{"48", " ", "\[ImaginaryI]", " ", 
                    SubsuperscriptBox[
                    StyleBox["\[Eta]",
                    FontWeight->Bold,
                    FontColor->RGBColor[0.8, 0, 0]], "3", 
                    RowBox[{"[", "2", "]"}]]}]}], ")"}]}], "-", 
                   RowBox[{"32", " ", 
                    SubsuperscriptBox[
                    StyleBox["\[Eta]",
                    FontWeight->Bold,
                    FontColor->RGBColor[0.8, 0, 0]], "3", 
                    RowBox[{"[", "2", "]"}]]}], "+", 
                   RowBox[{
                    SuperscriptBox["u", "2"], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"747", " ", "\[ImaginaryI]"}], "+", 
                    RowBox[{"4", " ", 
                    SubsuperscriptBox[
                    StyleBox["\[Eta]",
                    FontWeight->Bold,
                    FontColor->RGBColor[0.8, 0, 0]], "1", 
                    RowBox[{"[", "2", "]"}]], " ", 
                    RowBox[{"(", 
                    RowBox[{"73", "+", 
                    RowBox[{"12", " ", 
                    SubsuperscriptBox[
                    StyleBox["\[Eta]",
                    FontWeight->Bold,
                    FontColor->RGBColor[0.8, 0, 0]], "1", 
                    RowBox[{"[", "2", "]"}]], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"7", " ", "\[ImaginaryI]"}], "+", 
                    RowBox[{"4", " ", 
                    SubsuperscriptBox[
                    StyleBox["\[Eta]",
                    FontWeight->Bold,
                    FontColor->RGBColor[0.8, 0, 0]], "1", 
                    RowBox[{"[", "2", "]"}]]}]}], ")"}]}], "-", 
                    RowBox[{"48", " ", "\[ImaginaryI]", " ", 
                    SubsuperscriptBox[
                    StyleBox["\[Eta]",
                    FontWeight->Bold,
                    FontColor->RGBColor[0.8, 0, 0]], "3", 
                    RowBox[{"[", "2", "]"}]]}]}], ")"}]}], "-", 
                    RowBox[{"16", " ", 
                    SubsuperscriptBox[
                    StyleBox["\[Eta]",
                    FontWeight->Bold,
                    FontColor->RGBColor[0.8, 0, 0]], "3", 
                    RowBox[{"[", "2", "]"}]]}], "-", 
                    RowBox[{"64", " ", 
                    SubsuperscriptBox[
                    StyleBox["\[Eta]",
                    FontWeight->Bold,
                    FontColor->RGBColor[0.8, 0, 0]], "5", 
                    RowBox[{"[", "2", "]"}]]}]}], ")"}]}]}], ")"}]}]}], 
               ")"}]}]}], ")"}]}]}], ")"}]}]}], ")"}], " ", 
     SuperscriptBox["g", "8"]}]}], "+", 
   RowBox[{
    FractionBox["1", 
     RowBox[{"64", " ", 
      SqrtBox["2"], " ", 
      SuperscriptBox["u", "9"]}]], 
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{"1792", " ", "\[ImaginaryI]"}], "+", 
       RowBox[{"3", " ", "u", " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"-", "1792"}], "+", 
          RowBox[{"u", " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{
              RowBox[{"-", "64"}], " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"3", " ", "\[ImaginaryI]"}], "+", 
                RowBox[{"20", " ", 
                 SubsuperscriptBox[
                  StyleBox["\[Eta]",
                   FontWeight->Bold,
                   FontColor->RGBColor[0.8, 0, 0]], "1", 
                  RowBox[{"[", "2", "]"}]]}]}], ")"}]}], "+", 
             RowBox[{"u", " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"-", "320"}], "-", 
                RowBox[{"3840", " ", "\[ImaginaryI]", " ", 
                 SubsuperscriptBox[
                  StyleBox["\[Eta]",
                   FontWeight->Bold,
                   FontColor->RGBColor[0.8, 0, 0]], "1", 
                  RowBox[{"[", "2", "]"}]]}], "+", 
                RowBox[{"u", " ", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"32", " ", "\[ImaginaryI]", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", "21"}], "+", 
                    RowBox[{"48", " ", 
                    SubscriptBox[
                    StyleBox["\[Zeta]",
                    FontWeight->Bold,
                    FontColor->GrayLevel[0.4]], "3"]}], "-", 
                    RowBox[{"16", " ", 
                    SubsuperscriptBox[
                    StyleBox["\[Eta]",
                    FontWeight->Bold,
                    FontColor->RGBColor[0.8, 0, 0]], "1", 
                    RowBox[{"[", "2", "]"}]], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"4", " ", "\[ImaginaryI]"}], "+", 
                    RowBox[{"3", " ", 
                    SubsuperscriptBox[
                    StyleBox["\[Eta]",
                    FontWeight->Bold,
                    FontColor->RGBColor[0.8, 0, 0]], "1", 
                    RowBox[{"[", "2", "]"}]]}]}], ")"}]}], "+", 
                    RowBox[{"16", " ", "\[ImaginaryI]", " ", 
                    SubsuperscriptBox[
                    StyleBox["\[Eta]",
                    FontWeight->Bold,
                    FontColor->RGBColor[0.8, 0, 0]], "3", 
                    RowBox[{"[", "2", "]"}]]}]}], ")"}]}], "-", 
                   RowBox[{"32", " ", "u", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", "73"}], "+", 
                    RowBox[{"48", " ", 
                    SubscriptBox[
                    StyleBox["\[Zeta]",
                    FontWeight->Bold,
                    FontColor->GrayLevel[0.4]], "3"]}], "-", 
                    RowBox[{"24", " ", 
                    SubsuperscriptBox[
                    StyleBox["\[Eta]",
                    FontWeight->Bold,
                    FontColor->RGBColor[0.8, 0, 0]], "1", 
                    RowBox[{"[", "2", "]"}]], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"7", " ", "\[ImaginaryI]"}], "+", 
                    RowBox[{"6", " ", 
                    SubsuperscriptBox[
                    StyleBox["\[Eta]",
                    FontWeight->Bold,
                    FontColor->RGBColor[0.8, 0, 0]], "1", 
                    RowBox[{"[", "2", "]"}]]}]}], ")"}]}], "+", 
                    RowBox[{"48", " ", "\[ImaginaryI]", " ", 
                    SubsuperscriptBox[
                    StyleBox["\[Eta]",
                    FontWeight->Bold,
                    FontColor->RGBColor[0.8, 0, 0]], "3", 
                    RowBox[{"[", "2", "]"}]]}]}], ")"}]}], "+", 
                   RowBox[{"8", " ", 
                    SuperscriptBox["u", "3"], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", "1721"}], "+", 
                    RowBox[{"384", " ", 
                    SubscriptBox[
                    StyleBox["\[Zeta]",
                    FontWeight->Bold,
                    FontColor->GrayLevel[0.4]], "3"]}], "+", 
                    RowBox[{"336", " ", "\[ImaginaryI]", " ", 
                    SubsuperscriptBox[
                    StyleBox["\[Eta]",
                    FontWeight->Bold,
                    FontColor->RGBColor[0.8, 0, 0]], "3", 
                    RowBox[{"[", "2", "]"}]]}], "+", 
                    RowBox[{"36", " ", 
                    SubsuperscriptBox[
                    StyleBox["\[Eta]",
                    FontWeight->Bold,
                    FontColor->RGBColor[0.8, 0, 0]], "1", 
                    RowBox[{"[", "2", "]"}]], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "45"}], " ", "\[ImaginaryI]"}], "+", 
                    RowBox[{"4", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", "15"}], "+", 
                    RowBox[{"4", " ", "\[ImaginaryI]", " ", 
                    SubsuperscriptBox[
                    StyleBox["\[Eta]",
                    FontWeight->Bold,
                    FontColor->RGBColor[0.8, 0, 0]], "1", 
                    RowBox[{"[", "2", "]"}]]}]}], ")"}], " ", 
                    SubsuperscriptBox[
                    StyleBox["\[Eta]",
                    FontWeight->Bold,
                    FontColor->RGBColor[0.8, 0, 0]], "1", 
                    RowBox[{"[", "2", "]"}]]}], "+", 
                    RowBox[{"16", " ", 
                    SubsuperscriptBox[
                    StyleBox["\[Eta]",
                    FontWeight->Bold,
                    FontColor->RGBColor[0.8, 0, 0]], "3", 
                    RowBox[{"[", "2", "]"}]]}]}], ")"}]}], "-", 
                    RowBox[{"192", " ", "\[ImaginaryI]", " ", 
                    SubsuperscriptBox[
                    StyleBox["\[Eta]",
                    FontWeight->Bold,
                    FontColor->RGBColor[0.8, 0, 0]], "5", 
                    RowBox[{"[", "2", "]"}]]}]}], ")"}]}], "-", 
                   RowBox[{"8", " ", 
                    SuperscriptBox["u", "2"], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "581"}], " ", "\[ImaginaryI]"}], "+", 
                    RowBox[{"640", " ", "\[ImaginaryI]", " ", 
                    SubscriptBox[
                    StyleBox["\[Zeta]",
                    FontWeight->Bold,
                    FontColor->GrayLevel[0.4]], "5"]}], "+", 
                    RowBox[{"32", " ", 
                    SubscriptBox[
                    StyleBox["\[Zeta]",
                    FontWeight->Bold,
                    FontColor->GrayLevel[0.4]], "3"], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", "\[ImaginaryI]"}], "+", 
                    RowBox[{"12", " ", 
                    SubsuperscriptBox[
                    StyleBox["\[Eta]",
                    FontWeight->Bold,
                    FontColor->RGBColor[0.8, 0, 0]], "1", 
                    RowBox[{"[", "2", "]"}]]}]}], ")"}]}], "+", 
                    RowBox[{"4", " ", 
                    SubsuperscriptBox[
                    StyleBox["\[Eta]",
                    FontWeight->Bold,
                    FontColor->RGBColor[0.8, 0, 0]], "1", 
                    RowBox[{"[", "2", "]"}]], " ", 
                    RowBox[{"(", 
                    RowBox[{"83", "-", 
                    RowBox[{"12", " ", 
                    SubsuperscriptBox[
                    StyleBox["\[Eta]",
                    FontWeight->Bold,
                    FontColor->RGBColor[0.8, 0, 0]], "1", 
                    RowBox[{"[", "2", "]"}]], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"13", " ", "\[ImaginaryI]"}], "+", 
                    RowBox[{"4", " ", 
                    SubsuperscriptBox[
                    StyleBox["\[Eta]",
                    FontWeight->Bold,
                    FontColor->RGBColor[0.8, 0, 0]], "1", 
                    RowBox[{"[", "2", "]"}]]}]}], ")"}]}], "+", 
                    RowBox[{"48", " ", "\[ImaginaryI]", " ", 
                    SubsuperscriptBox[
                    StyleBox["\[Eta]",
                    FontWeight->Bold,
                    FontColor->RGBColor[0.8, 0, 0]], "3", 
                    RowBox[{"[", "2", "]"}]]}]}], ")"}]}], "-", 
                    RowBox[{"80", " ", 
                    SubsuperscriptBox[
                    StyleBox["\[Eta]",
                    FontWeight->Bold,
                    FontColor->RGBColor[0.8, 0, 0]], "3", 
                    RowBox[{"[", "2", "]"}]]}], "+", 
                    RowBox[{"64", " ", 
                    SubsuperscriptBox[
                    StyleBox["\[Eta]",
                    FontWeight->Bold,
                    FontColor->RGBColor[0.8, 0, 0]], "5", 
                    RowBox[{"[", "2", "]"}]]}]}], ")"}]}], "+", 
                   RowBox[{
                    SuperscriptBox["u", "4"], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "52167"}], " ", "\[ImaginaryI]"}], "-", 
                    RowBox[{"27536", " ", 
                    SubsuperscriptBox[
                    StyleBox["\[Eta]",
                    FontWeight->Bold,
                    FontColor->RGBColor[0.8, 0, 0]], "1", 
                    RowBox[{"[", "2", "]"}]]}], "+", 
                    RowBox[{"1568", " ", 
                    SubsuperscriptBox[
                    StyleBox["\[Eta]",
                    FontWeight->Bold,
                    FontColor->RGBColor[0.8, 0, 0]], "3", 
                    RowBox[{"[", "2", "]"}]]}], "+", 
                    RowBox[{"96", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"16", " ", 
                    SubscriptBox[
                    StyleBox["\[Zeta]",
                    FontWeight->Bold,
                    FontColor->GrayLevel[0.4]], "3"], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "3"}], " ", "\[ImaginaryI]"}], "+", 
                    RowBox[{"4", " ", 
                    SubsuperscriptBox[
                    StyleBox["\[Eta]",
                    FontWeight->Bold,
                    FontColor->RGBColor[0.8, 0, 0]], "1", 
                    RowBox[{"[", "2", "]"}]]}]}], ")"}]}], "+", 
                    RowBox[{"\[ImaginaryI]", " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"120", " ", "\[ImaginaryI]", " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    SubsuperscriptBox[
                    StyleBox["\[Eta]",
                    FontWeight->Bold,
                    FontColor->RGBColor[0.8, 0, 0]], "1", 
                    RowBox[{"[", "2", "]"}]], ")"}], "3"]}], "+", 
                    RowBox[{"24", " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    SubsuperscriptBox[
                    StyleBox["\[Eta]",
                    FontWeight->Bold,
                    FontColor->RGBColor[0.8, 0, 0]], "1", 
                    RowBox[{"[", "2", "]"}]], ")"}], "4"]}], "+", 
                    RowBox[{
                    SuperscriptBox[
                    RowBox[{"(", 
                    SubsuperscriptBox[
                    StyleBox["\[Eta]",
                    FontWeight->Bold,
                    FontColor->RGBColor[0.8, 0, 0]], "1", 
                    RowBox[{"[", "2", "]"}]], ")"}], "2"], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", "135"}], "-", 
                    RowBox[{"48", " ", "\[ImaginaryI]", " ", 
                    SubsuperscriptBox[
                    StyleBox["\[Eta]",
                    FontWeight->Bold,
                    FontColor->RGBColor[0.8, 0, 0]], "3", 
                    RowBox[{"[", "2", "]"}]]}]}], ")"}]}], "-", 
                    RowBox[{"8", " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    SubsuperscriptBox[
                    StyleBox["\[Eta]",
                    FontWeight->Bold,
                    FontColor->RGBColor[0.8, 0, 0]], "3", 
                    RowBox[{"[", "2", "]"}]], ")"}], "2"]}], "+", 
                    RowBox[{"8", " ", 
                    SubsuperscriptBox[
                    StyleBox["\[Eta]",
                    FontWeight->Bold,
                    FontColor->RGBColor[0.8, 0, 0]], "1", 
                    RowBox[{"[", "2", "]"}]], " ", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"7", " ", 
                    SubsuperscriptBox[
                    StyleBox["\[Eta]",
                    FontWeight->Bold,
                    FontColor->RGBColor[0.8, 0, 0]], "3", 
                    RowBox[{"[", "2", "]"}]]}], "-", 
                    RowBox[{"4", " ", 
                    SubsuperscriptBox[
                    StyleBox["\[Eta]",
                    FontWeight->Bold,
                    FontColor->RGBColor[0.8, 0, 0]], "5", 
                    RowBox[{"[", "2", "]"}]]}]}], ")"}]}]}], ")"}]}]}], 
                    ")"}]}], "-", 
                    RowBox[{"256", " ", 
                    SubsuperscriptBox[
                    StyleBox["\[Eta]",
                    FontWeight->Bold,
                    FontColor->RGBColor[0.8, 0, 0]], "5", 
                    RowBox[{"[", "2", "]"}]]}], "-", 
                    RowBox[{"1280", " ", 
                    SubsuperscriptBox[
                    StyleBox["\[Eta]",
                    FontWeight->Bold,
                    FontColor->RGBColor[0.8, 0, 0]], "7", 
                    RowBox[{"[", "2", "]"}]]}]}], ")"}]}]}], ")"}]}]}], 
               ")"}]}]}], ")"}]}]}], ")"}]}]}], ")"}], " ", 
     SuperscriptBox["g", "10"]}]}], "+", 
   InterpretationBox[
    SuperscriptBox[
     RowBox[{"O", "[", "g", "]"}], "11"],
    SeriesData[$CellContext`g, 0, {}, 2, 11, 1],
    Editable->False]}],
  SeriesData[$CellContext`g, 0, {
   Complex[0, 1] 2^Rational[1, 2]/$CellContext`u, 0, 
    2^Rational[-1, 2] $CellContext`u^(-3) (Complex[0, 2] - 
     3 $CellContext`u (
      2 + $CellContext`u (Complex[0, -3] + 4 $CellContext`\[Eta]$[1][2]))), 0,
     Rational[1, 4] 
    2^Rational[-1, 2] $CellContext`u^(-5) (Complex[0, 16] + 
     3 $CellContext`u (-16 + $CellContext`u (
         Complex[0, 4] + (-4 + Complex[0, -51] $CellContext`u) $CellContext`u - 
         8 (2 + $CellContext`u (
            Complex[0, 6] + $CellContext`u)) $CellContext`\[Eta]$[1][2] + 
         Complex[0, -48] $CellContext`u^2 $CellContext`\[Eta]$[1][2]^2) - 
       16 $CellContext`u^3 $CellContext`\[Eta]$[3][2])), 0, Rational[1, 8] 
    2^Rational[-1, 2] $CellContext`u^(-7) (Complex[0, 80] + 
     3 $CellContext`u (-80 + $CellContext`u ((-64) $CellContext`\[Eta]$[1][
           2] + $CellContext`u (-16 + 
           Complex[0, -192] $CellContext`\[Eta]$[1][2] + $CellContext`u (
             Complex[0, -62] + Complex[0, 64] $CellContext`\[Zeta]$[3][0] + 
             16 (5 + Complex[0, -6] $CellContext`\[Eta]$[1][
                 2]) $CellContext`\[Eta]$[1][2] + 
             2 $CellContext`u (73 + 
               24 $CellContext`\[Eta]$[1][2] (Complex[0, 7] + 
                 6 $CellContext`\[Eta]$[1][2]) + 
               Complex[0, -48] $CellContext`\[Eta]$[3][2]) - 
             32 $CellContext`\[Eta]$[3][
              2] + $CellContext`u^2 (Complex[0, 747] + 
               4 $CellContext`\[Eta]$[1][2] (73 + 
                 12 $CellContext`\[Eta]$[1][2] (Complex[0, 7] + 
                   4 $CellContext`\[Eta]$[1][2]) + 
                 Complex[0, -48] $CellContext`\[Eta]$[3][2]) - 
               16 $CellContext`\[Eta]$[3][2] - 
               64 $CellContext`\[Eta]$[5][2])))))), 0, Rational[1, 64] 
    2^Rational[-1, 2] $CellContext`u^(-9) (Complex[0, 1792] + 
     3 $CellContext`u (-1792 + $CellContext`u ((-64) (Complex[0, 3] + 
           20 $CellContext`\[Eta]$[1][2]) + $CellContext`u (-320 + 
           Complex[0, -3840] $CellContext`\[Eta]$[1][2] + $CellContext`u (
             Complex[0, 32] (-21 + 48 $CellContext`\[Zeta]$[3][0] - 
               16 $CellContext`\[Eta]$[1][2] (Complex[0, 4] + 
                3 $CellContext`\[Eta]$[1][2]) + 
               Complex[0, 16] $CellContext`\[Eta]$[3][2]) - 
             32 $CellContext`u (-73 + 48 $CellContext`\[Zeta]$[3][0] - 
              24 $CellContext`\[Eta]$[1][2] (Complex[0, 7] + 
               6 $CellContext`\[Eta]$[1][2]) + 
              Complex[0, 48] $CellContext`\[Eta]$[3][2]) + 
             8 $CellContext`u^3 (-1721 + 384 $CellContext`\[Zeta]$[3][0] + 
               Complex[0, 336] $CellContext`\[Eta]$[3][2] + 
               36 $CellContext`\[Eta]$[1][2] (Complex[0, -45] + 
                 4 (-15 + Complex[0, 4] $CellContext`\[Eta]$[1][
                    2]) $CellContext`\[Eta]$[1][2] + 
                 16 $CellContext`\[Eta]$[3][2]) + 
               Complex[0, -192] $CellContext`\[Eta]$[5][2]) - 
             8 $CellContext`u^2 (Complex[0, -581] + 
              Complex[0, 640] $CellContext`\[Zeta]$[5][0] + 
              32 $CellContext`\[Zeta]$[3][0] (Complex[0, -1] + 
                12 $CellContext`\[Eta]$[1][2]) + 
              4 $CellContext`\[Eta]$[1][2] (83 - 
                12 $CellContext`\[Eta]$[1][2] (Complex[0, 13] + 
                 4 $CellContext`\[Eta]$[1][2]) + 
                Complex[0, 48] $CellContext`\[Eta]$[3][2]) - 
              80 $CellContext`\[Eta]$[3][2] + 
              64 $CellContext`\[Eta]$[5][2]) + $CellContext`u^4 (
               Complex[0, -52167] - 27536 $CellContext`\[Eta]$[1][2] + 
               1568 $CellContext`\[Eta]$[3][2] + 
               96 (16 $CellContext`\[Zeta]$[3][0] (Complex[0, -3] + 
                   4 $CellContext`\[Eta]$[1][2]) + 
                 Complex[0, 1] (Complex[0, 120] $CellContext`\[Eta]$[1][2]^3 + 
                   24 $CellContext`\[Eta]$[1][2]^4 + $CellContext`\[Eta]$[1][
                    2]^2 (-135 + Complex[0, -48] $CellContext`\[Eta]$[3][2]) - 
                   8 $CellContext`\[Eta]$[3][2]^2 + 
                   8 $CellContext`\[Eta]$[1][2] (7 $CellContext`\[Eta]$[3][2] - 
                    4 $CellContext`\[Eta]$[5][2]))) - 
               256 $CellContext`\[Eta]$[5][2] - 
               1280 $CellContext`\[Eta]$[7][2]))))))}, 2, 11, 1],
  Editable->False]], "Output",
 CellChangeTimes->{{3.541013272723645*^9, 3.541013406702639*^9}, {
   3.541013461160734*^9, 3.541013551045024*^9}, 3.541013592746372*^9, {
   3.541013632827179*^9, 3.541013643435733*^9}, {3.541064139458004*^9, 
   3.541064247641694*^9}, 3.54106444525426*^9, 3.55023378880963*^9, 
   3.550235366794835*^9, {3.550235514317317*^9, 3.550235530059619*^9}, 
   3.550295059687756*^9, 3.552379655877864*^9, {3.552379746016097*^9, 
   3.552379768736043*^9}, 3.554628434665938*^9, 3.554629042049081*^9, 
   3.554631444939754*^9, 3.5557903488151712`*^9, 3.560874823742507*^9, 
   3.560874880951686*^9, 3.561059991182147*^9, 3.561060034605987*^9, 
   3.561469654040689*^9, 3.562263711597479*^9, {3.563301227771727*^9, 
   3.563301255322413*^9}}]
}, Open  ]],

Cell[TextData[{
 "We still have to write down a proper normalization factor. This task was \
not resoved in the FiNLIE paper. Above we already explained that \
asymptotically we have a simple equation that ",
 Cell[BoxData[
  FormBox[
   RowBox[{
    RowBox[{"V", " ", 
     OverscriptBox["V", "_"]}], "=", "1"}], TraditionalForm]],
  FormatType->"TraditionalForm"]
}], "Text",
 CellChangeTimes->{{3.546148460599266*^9, 3.546148487138751*^9}, {
  3.55023606868195*^9, 3.55023606880621*^9}, {3.550295109175932*^9, 
  3.5502951139594707`*^9}, {3.555790417270368*^9, 3.5557904201663303`*^9}, {
  3.555790761649184*^9, 3.5557907809018908`*^9}, {3.563301329617525*^9, 
  3.563301350559812*^9}}],

Cell["Let us see what we get perturbatively", "Text",
 CellChangeTimes->{{3.5461510514265137`*^9, 3.546151057041098*^9}}],

Cell[CellGroupData[{

Cell[BoxData["tmpV"], "Input",
 CellChangeTimes->{{3.563301362903171*^9, 3.563301364040661*^9}}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"1", "+", 
   RowBox[{"6", " ", "\[ImaginaryI]", " ", 
    SubsuperscriptBox[
     StyleBox["\[Eta]",
      FontWeight->Bold,
      FontColor->RGBColor[0.8, 0, 0]], "1", 
     RowBox[{"[", "2", "]"}]], " ", 
    SuperscriptBox["g", "2"]}], "+", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      FractionBox[
       RowBox[{"12", " ", 
        SubscriptBox[
         StyleBox["\[Zeta]",
          FontWeight->Bold,
          FontColor->GrayLevel[0.4]], "3"]}], 
       SuperscriptBox[
        OverscriptBox[
         StyleBox["x",
          FontColor->RGBColor[0, 0.6, 0]], 
         StyleBox["^",
          FontColor->RGBColor[0, 0.6, 0]]], "2"]], "-", 
      RowBox[{"24", " ", "\[ImaginaryI]", " ", 
       SubsuperscriptBox[
        StyleBox["\[Eta]",
         FontWeight->Bold,
         FontColor->RGBColor[0.8, 0, 0]], "1", 
        RowBox[{"[", "2", "]"}]]}], "-", 
      RowBox[{"18", " ", 
       SuperscriptBox[
        RowBox[{"(", 
         SubsuperscriptBox[
          StyleBox["\[Eta]",
           FontWeight->Bold,
           FontColor->RGBColor[0.8, 0, 0]], "1", 
          RowBox[{"[", "2", "]"}]], ")"}], "2"]}], "+", 
      RowBox[{"6", " ", "\[ImaginaryI]", " ", 
       SubsuperscriptBox[
        StyleBox["\[Eta]",
         FontWeight->Bold,
         FontColor->RGBColor[0.8, 0, 0]], "3", 
        RowBox[{"[", "2", "]"}]]}]}], ")"}], " ", 
    SuperscriptBox["g", "4"]}], "+", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"-", 
       FractionBox[
        RowBox[{"12", " ", 
         RowBox[{"(", 
          RowBox[{
           SubscriptBox[
            StyleBox["\[Zeta]",
             FontWeight->Bold,
             FontColor->GrayLevel[0.4]], "5"], "+", 
           RowBox[{"2", " ", 
            SuperscriptBox[
             OverscriptBox[
              StyleBox["x",
               FontColor->RGBColor[0, 0.6, 0]], 
              StyleBox["^",
               FontColor->RGBColor[0, 0.6, 0]]], "2"], " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"2", " ", 
               SubscriptBox[
                StyleBox["\[Zeta]",
                 FontWeight->Bold,
                 FontColor->GrayLevel[0.4]], "3"]}], "+", 
              RowBox[{"5", " ", 
               SubscriptBox[
                StyleBox["\[Zeta]",
                 FontWeight->Bold,
                 FontColor->GrayLevel[0.4]], "5"]}]}], ")"}]}]}], ")"}]}], 
        SuperscriptBox[
         OverscriptBox[
          StyleBox["x",
           FontColor->RGBColor[0, 0.6, 0]], 
          StyleBox["^",
           FontColor->RGBColor[0, 0.6, 0]]], "4"]]}], "+", 
      RowBox[{"144", " ", 
       SuperscriptBox[
        RowBox[{"(", 
         SubsuperscriptBox[
          StyleBox["\[Eta]",
           FontWeight->Bold,
           FontColor->RGBColor[0.8, 0, 0]], "1", 
          RowBox[{"[", "2", "]"}]], ")"}], "2"]}], "-", 
      RowBox[{"36", " ", "\[ImaginaryI]", " ", 
       SuperscriptBox[
        RowBox[{"(", 
         SubsuperscriptBox[
          StyleBox["\[Eta]",
           FontWeight->Bold,
           FontColor->RGBColor[0.8, 0, 0]], "1", 
          RowBox[{"[", "2", "]"}]], ")"}], "3"]}], "+", 
      RowBox[{
       SubsuperscriptBox[
        StyleBox["\[Eta]",
         FontWeight->Bold,
         FontColor->RGBColor[0.8, 0, 0]], "1", 
        RowBox[{"[", "2", "]"}]], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"72", " ", "\[ImaginaryI]", " ", 
          RowBox[{"(", 
           RowBox[{
            FractionBox["7", "3"], "+", 
            FractionBox[
             SubscriptBox[
              StyleBox["\[Zeta]",
               FontWeight->Bold,
               FontColor->GrayLevel[0.4]], "3"], 
             SuperscriptBox[
              OverscriptBox[
               StyleBox["x",
                FontColor->RGBColor[0, 0.6, 0]], 
               StyleBox["^",
                FontColor->RGBColor[0, 0.6, 0]]], "2"]]}], ")"}]}], "-", 
         RowBox[{"36", " ", 
          SubsuperscriptBox[
           StyleBox["\[Eta]",
            FontWeight->Bold,
            FontColor->RGBColor[0.8, 0, 0]], "3", 
           RowBox[{"[", "2", "]"}]]}]}], ")"}]}], "-", 
      RowBox[{"24", " ", "\[ImaginaryI]", " ", 
       SubsuperscriptBox[
        StyleBox["\[Eta]",
         FontWeight->Bold,
         FontColor->RGBColor[0.8, 0, 0]], "3", 
        RowBox[{"[", "2", "]"}]]}], "+", 
      RowBox[{"12", " ", "\[ImaginaryI]", " ", 
       SubsuperscriptBox[
        StyleBox["\[Eta]",
         FontWeight->Bold,
         FontColor->RGBColor[0.8, 0, 0]], "5", 
        RowBox[{"[", "2", "]"}]]}]}], ")"}], " ", 
    SuperscriptBox["g", "6"]}], "+", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      FractionBox[
       RowBox[{"12", " ", 
        RowBox[{"(", 
         RowBox[{
          SubscriptBox[
           StyleBox["\[Zeta]",
            FontWeight->Bold,
            FontColor->GrayLevel[0.4]], "7"], "+", 
          RowBox[{
           SuperscriptBox[
            OverscriptBox[
             StyleBox["x",
              FontColor->RGBColor[0, 0.6, 0]], 
             StyleBox["^",
              FontColor->RGBColor[0, 0.6, 0]]], "2"], " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"6", " ", 
              SubsuperscriptBox[
               StyleBox["\[Zeta]",
                FontWeight->Bold,
                FontColor->GrayLevel[0.4]], "3", "2"]}], "+", 
             RowBox[{"4", " ", 
              SubscriptBox[
               StyleBox["\[Zeta]",
                FontWeight->Bold,
                FontColor->GrayLevel[0.4]], "5"]}], "+", 
             RowBox[{"21", " ", 
              SubscriptBox[
               StyleBox["\[Zeta]",
                FontWeight->Bold,
                FontColor->GrayLevel[0.4]], "7"]}]}], ")"}]}], "+", 
          RowBox[{
           SuperscriptBox[
            OverscriptBox[
             StyleBox["x",
              FontColor->RGBColor[0, 0.6, 0]], 
             StyleBox["^",
              FontColor->RGBColor[0, 0.6, 0]]], "4"], " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"28", " ", 
              SubscriptBox[
               StyleBox["\[Zeta]",
                FontWeight->Bold,
                FontColor->GrayLevel[0.4]], "3"]}], "+", 
             RowBox[{"40", " ", 
              SubscriptBox[
               StyleBox["\[Zeta]",
                FontWeight->Bold,
                FontColor->GrayLevel[0.4]], "5"]}], "+", 
             RowBox[{"105", " ", 
              SubscriptBox[
               StyleBox["\[Zeta]",
                FontWeight->Bold,
                FontColor->GrayLevel[0.4]], "7"]}]}], ")"}]}]}], ")"}]}], 
       SuperscriptBox[
        OverscriptBox[
         StyleBox["x",
          FontColor->RGBColor[0, 0.6, 0]], 
         StyleBox["^",
          FontColor->RGBColor[0, 0.6, 0]]], "6"]], "+", 
      RowBox[{"432", " ", "\[ImaginaryI]", " ", 
       SuperscriptBox[
        RowBox[{"(", 
         SubsuperscriptBox[
          StyleBox["\[Eta]",
           FontWeight->Bold,
           FontColor->RGBColor[0.8, 0, 0]], "1", 
          RowBox[{"[", "2", "]"}]], ")"}], "3"]}], "+", 
      RowBox[{"54", " ", 
       SuperscriptBox[
        RowBox[{"(", 
         SubsuperscriptBox[
          StyleBox["\[Eta]",
           FontWeight->Bold,
           FontColor->RGBColor[0.8, 0, 0]], "1", 
          RowBox[{"[", "2", "]"}]], ")"}], "4"]}], "+", 
      RowBox[{
       SuperscriptBox[
        RowBox[{"(", 
         SubsuperscriptBox[
          StyleBox["\[Eta]",
           FontWeight->Bold,
           FontColor->RGBColor[0.8, 0, 0]], "1", 
          RowBox[{"[", "2", "]"}]], ")"}], "2"], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"216", " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"-", "6"}], "-", 
            FractionBox[
             SubscriptBox[
              StyleBox["\[Zeta]",
               FontWeight->Bold,
               FontColor->GrayLevel[0.4]], "3"], 
             SuperscriptBox[
              OverscriptBox[
               StyleBox["x",
                FontColor->RGBColor[0, 0.6, 0]], 
               StyleBox["^",
                FontColor->RGBColor[0, 0.6, 0]]], "2"]]}], ")"}]}], "-", 
         RowBox[{"108", " ", "\[ImaginaryI]", " ", 
          SubsuperscriptBox[
           StyleBox["\[Eta]",
            FontWeight->Bold,
            FontColor->RGBColor[0.8, 0, 0]], "3", 
           RowBox[{"[", "2", "]"}]]}]}], ")"}]}], "+", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{"186", " ", "\[ImaginaryI]"}], "+", 
         FractionBox[
          RowBox[{"72", " ", "\[ImaginaryI]", " ", 
           SubscriptBox[
            StyleBox["\[Zeta]",
             FontWeight->Bold,
             FontColor->GrayLevel[0.4]], "3"]}], 
          SuperscriptBox[
           OverscriptBox[
            StyleBox["x",
             FontColor->RGBColor[0, 0.6, 0]], 
            StyleBox["^",
             FontColor->RGBColor[0, 0.6, 0]]], "2"]]}], ")"}], " ", 
       SubsuperscriptBox[
        StyleBox["\[Eta]",
         FontWeight->Bold,
         FontColor->RGBColor[0.8, 0, 0]], "3", 
        RowBox[{"[", "2", "]"}]]}], "-", 
      RowBox[{"18", " ", 
       SuperscriptBox[
        RowBox[{"(", 
         SubsuperscriptBox[
          StyleBox["\[Eta]",
           FontWeight->Bold,
           FontColor->RGBColor[0.8, 0, 0]], "3", 
          RowBox[{"[", "2", "]"}]], ")"}], "2"]}], "+", 
      RowBox[{
       SubsuperscriptBox[
        StyleBox["\[Eta]",
         FontWeight->Bold,
         FontColor->RGBColor[0.8, 0, 0]], "1", 
        RowBox[{"[", "2", "]"}]], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", 
          FractionBox[
           RowBox[{"6", " ", "\[ImaginaryI]", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{
               SuperscriptBox[
                OverscriptBox[
                 StyleBox["x",
                  FontColor->RGBColor[0, 0.6, 0]], 
                 StyleBox["^",
                  FontColor->RGBColor[0, 0.6, 0]]], "4"], " ", 
               RowBox[{"(", 
                RowBox[{"235", "+", 
                 RowBox[{"24", " ", 
                  SubscriptBox[
                   StyleBox["\[Zeta]",
                    FontWeight->Bold,
                    FontColor->GrayLevel[0.4]], "3"]}]}], ")"}]}], "+", 
              RowBox[{"12", " ", 
               SubscriptBox[
                StyleBox["\[Zeta]",
                 FontWeight->Bold,
                 FontColor->GrayLevel[0.4]], "5"]}], "+", 
              RowBox[{"24", " ", 
               SuperscriptBox[
                OverscriptBox[
                 StyleBox["x",
                  FontColor->RGBColor[0, 0.6, 0]], 
                 StyleBox["^",
                  FontColor->RGBColor[0, 0.6, 0]]], "2"], " ", 
               RowBox[{"(", 
                RowBox[{
                 RowBox[{"4", " ", 
                  SubscriptBox[
                   StyleBox["\[Zeta]",
                    FontWeight->Bold,
                    FontColor->GrayLevel[0.4]], "3"]}], "+", 
                 RowBox[{"5", " ", 
                  SubscriptBox[
                   StyleBox["\[Zeta]",
                    FontWeight->Bold,
                    FontColor->GrayLevel[0.4]], "5"]}]}], ")"}]}]}], ")"}]}], 
           
           SuperscriptBox[
            OverscriptBox[
             StyleBox["x",
              FontColor->RGBColor[0, 0.6, 0]], 
             StyleBox["^",
              FontColor->RGBColor[0, 0.6, 0]]], "4"]]}], "+", 
         RowBox[{"288", " ", 
          SubsuperscriptBox[
           StyleBox["\[Eta]",
            FontWeight->Bold,
            FontColor->RGBColor[0.8, 0, 0]], "3", 
           RowBox[{"[", "2", "]"}]]}], "-", 
         RowBox[{"72", " ", 
          SubsuperscriptBox[
           StyleBox["\[Eta]",
            FontWeight->Bold,
            FontColor->RGBColor[0.8, 0, 0]], "5", 
           RowBox[{"[", "2", "]"}]]}]}], ")"}]}], "-", 
      RowBox[{"48", " ", "\[ImaginaryI]", " ", 
       SubsuperscriptBox[
        StyleBox["\[Eta]",
         FontWeight->Bold,
         FontColor->RGBColor[0.8, 0, 0]], "5", 
        RowBox[{"[", "2", "]"}]]}], "+", 
      RowBox[{"30", " ", "\[ImaginaryI]", " ", 
       SubsuperscriptBox[
        StyleBox["\[Eta]",
         FontWeight->Bold,
         FontColor->RGBColor[0.8, 0, 0]], "7", 
        RowBox[{"[", "2", "]"}]]}]}], ")"}], " ", 
    SuperscriptBox["g", "8"]}], "+", 
   InterpretationBox[
    SuperscriptBox[
     RowBox[{"O", "[", "g", "]"}], "9"],
    SeriesData[$CellContext`g, 0, {}, 0, 9, 1],
    Editable->False]}],
  SeriesData[$CellContext`g, 0, {
   1, 0, Complex[0, 6] $CellContext`\[Eta]$[1][2], 0, 
    12 $CellContext`x$h[0]^(-2) $CellContext`\[Zeta]$[3][0] + 
    Complex[0, -24] $CellContext`\[Eta]$[1][2] - 
    18 $CellContext`\[Eta]$[1][2]^2 + 
    Complex[0, 6] $CellContext`\[Eta]$[3][2], 
    0, (-12) $CellContext`x$h[0]^(-4) ($CellContext`\[Zeta]$[5][0] + 
      2 $CellContext`x$h[0]^2 (2 $CellContext`\[Zeta]$[3][0] + 
        5 $CellContext`\[Zeta]$[5][0])) + 144 $CellContext`\[Eta]$[1][2]^2 + 
    Complex[0, -36] $CellContext`\[Eta]$[1][2]^3 + $CellContext`\[Eta]$[1][
      2] (Complex[0, 72] (
        Rational[
         7, 3] + $CellContext`x$h[0]^(-2) $CellContext`\[Zeta]$[3][0]) - 
      36 $CellContext`\[Eta]$[3][2]) + 
    Complex[0, -24] $CellContext`\[Eta]$[3][2] + 
    Complex[0, 12] $CellContext`\[Eta]$[5][2], 0, 
    12 $CellContext`x$h[0]^(-6) ($CellContext`\[Zeta]$[7][
       0] + $CellContext`x$h[0]^2 (6 $CellContext`\[Zeta]$[3][0]^2 + 
        4 $CellContext`\[Zeta]$[5][0] + 
        21 $CellContext`\[Zeta]$[7][0]) + $CellContext`x$h[0]^4 (
        28 $CellContext`\[Zeta]$[3][0] + 40 $CellContext`\[Zeta]$[5][0] + 
        105 $CellContext`\[Zeta]$[7][0])) + 
    Complex[0, 432] $CellContext`\[Eta]$[1][2]^3 + 
    54 $CellContext`\[Eta]$[1][2]^4 + $CellContext`\[Eta]$[1][2]^2 (
      216 (-6 - $CellContext`x$h[0]^(-2) $CellContext`\[Zeta]$[3][0]) + 
      Complex[0, -108] $CellContext`\[Eta]$[3][2]) + (Complex[0, 186] + 
      Complex[0, 72] $CellContext`x$h[0]^(-2) $CellContext`\[Zeta]$[3][
        0]) $CellContext`\[Eta]$[3][2] - 
    18 $CellContext`\[Eta]$[3][2]^2 + $CellContext`\[Eta]$[1][2] (
      Complex[0, -6] $CellContext`x$h[
         0]^(-4) ($CellContext`x$h[0]^4 (235 + 
          24 $CellContext`\[Zeta]$[3][0]) + 12 $CellContext`\[Zeta]$[5][0] + 
        24 $CellContext`x$h[0]^2 (4 $CellContext`\[Zeta]$[3][0] + 
          5 $CellContext`\[Zeta]$[5][0])) + 288 $CellContext`\[Eta]$[3][2] - 
      72 $CellContext`\[Eta]$[5][2]) + 
    Complex[0, -48] $CellContext`\[Eta]$[5][2] + 
    Complex[0, 30] $CellContext`\[Eta]$[7][2]}, 0, 9, 1],
  Editable->False]], "Output",
 CellChangeTimes->{3.563301364340226*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"tmpV", " ", "/.", 
    RowBox[{"x$h", "\[Rule]", "x$"}]}], "//", "Normal"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"currentnorm", "=", 
  RowBox[{"Collect", "[", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{"%", 
          RowBox[{"(", 
           RowBox[{"%", "/.", "mconj"}], ")"}]}], "/.", "subJuk"}], "/.", 
        RowBox[{"u", "\[Rule]", 
         RowBox[{"2", "g", " ", "z"}]}]}], "/.", 
       RowBox[{"TaylorOptions", "[", 
        RowBox[{
         RowBox[{"Variable", "\[Rule]", "g"}], ",", 
         RowBox[{"\[Eta]Factor", "\[Rule]", 
          RowBox[{"2", "z"}]}], ",", 
         RowBox[{"Order", "\[Rule]", "9"}]}], "]"}]}], "//.", "denz"}], "//.",
      "subZetaReduce"}], ",", "zcanlist"}], "]"}]}]}], "Input",
 CellChangeTimes->{{3.563301388554677*^9, 3.563301423560893*^9}, {
  3.563301457505712*^9, 3.563301462784945*^9}, {3.563301540506032*^9, 
  3.563301560039084*^9}}],

Cell[BoxData[
 RowBox[{"1", "+", 
  RowBox[{"12", " ", 
   SuperscriptBox["g", "2"], " ", 
   SubscriptBox[
    StyleBox["\[Zeta]",
     FontWeight->Bold,
     FontColor->GrayLevel[0.4]], "1"]}], "+", 
  RowBox[{
   SuperscriptBox["g", "4"], " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{
      RowBox[{"-", "48"}], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "1"]}], "+", 
     RowBox[{"72", " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "1", "2"]}], "-", 
     RowBox[{"36", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3"]}]}], ")"}]}], "+", 
  RowBox[{
   SuperscriptBox["g", "6"], " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"336", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "1"]}], "-", 
     RowBox[{"576", " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "1", "2"]}], "+", 
     RowBox[{"288", " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "1", "3"]}], "+", 
     RowBox[{"144", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3"]}], "-", 
     RowBox[{"432", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "1"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3"]}], "+", 
     RowBox[{"240", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "5"]}]}], ")"}]}], "+", 
  RowBox[{
   SuperscriptBox["g", "8"], " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{
      RowBox[{"-", "2820"}], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "1"]}], "+", 
     RowBox[{"5184", " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "1", "2"]}], "-", 
     RowBox[{"3456", " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "1", "3"]}], "+", 
     RowBox[{"864", " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "1", "4"]}], "-", 
     RowBox[{"1044", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3"]}], "+", 
     RowBox[{"3168", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "1"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3"]}], "-", 
     RowBox[{"2592", " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "1", "2"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3"]}], "+", 
     RowBox[{"648", " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3", "2"]}], "-", 
     RowBox[{"960", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "5"]}], "+", 
     RowBox[{"2880", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "1"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "5"]}], "-", 
     RowBox[{"2100", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "7"]}]}], ")"}]}]}]], "Output",
 CellChangeTimes->{3.56330138269668*^9, 3.563301455546259*^9, 
  3.5633015168744383`*^9, 3.56330158797886*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"1", "+", 
   RowBox[{"12", " ", "EulerGamma", " ", 
    SuperscriptBox["g", "2"]}], "+", 
   RowBox[{"12", " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       RowBox[{"-", "4"}], " ", "EulerGamma"}], "+", 
      RowBox[{"6", " ", 
       SuperscriptBox["EulerGamma", "2"]}], "-", 
      RowBox[{"3", " ", 
       RowBox[{"Zeta", "[", "3", "]"}]}]}], ")"}], " ", 
    SuperscriptBox["g", "4"]}], "+", 
   RowBox[{"48", " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       RowBox[{"-", "12"}], " ", 
       SuperscriptBox["EulerGamma", "2"]}], "+", 
      RowBox[{"6", " ", 
       SuperscriptBox["EulerGamma", "3"]}], "+", 
      RowBox[{"EulerGamma", " ", 
       RowBox[{"(", 
        RowBox[{"7", "-", 
         RowBox[{"9", " ", 
          RowBox[{"Zeta", "[", "3", "]"}]}]}], ")"}]}], "+", 
      RowBox[{"3", " ", 
       RowBox[{"Zeta", "[", "3", "]"}]}], "+", 
      RowBox[{"5", " ", 
       RowBox[{"Zeta", "[", "5", "]"}]}]}], ")"}], " ", 
    SuperscriptBox["g", "6"]}], "+", 
   RowBox[{"12", " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       RowBox[{"-", "288"}], " ", 
       SuperscriptBox["EulerGamma", "3"]}], "+", 
      RowBox[{"72", " ", 
       SuperscriptBox["EulerGamma", "4"]}], "-", 
      RowBox[{"216", " ", 
       SuperscriptBox["EulerGamma", "2"], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", "2"}], "+", 
         RowBox[{"Zeta", "[", "3", "]"}]}], ")"}]}], "-", 
      RowBox[{"87", " ", 
       RowBox[{"Zeta", "[", "3", "]"}]}], "+", 
      RowBox[{"54", " ", 
       SuperscriptBox[
        RowBox[{"Zeta", "[", "3", "]"}], "2"]}], "-", 
      RowBox[{"80", " ", 
       RowBox[{"Zeta", "[", "5", "]"}]}], "+", 
      RowBox[{"EulerGamma", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"-", "235"}], "+", 
         RowBox[{"264", " ", 
          RowBox[{"Zeta", "[", "3", "]"}]}], "+", 
         RowBox[{"240", " ", 
          RowBox[{"Zeta", "[", "5", "]"}]}]}], ")"}]}], "-", 
      RowBox[{"175", " ", 
       RowBox[{"Zeta", "[", "7", "]"}]}]}], ")"}], " ", 
    SuperscriptBox["g", "8"]}], "+", 
   InterpretationBox[
    SuperscriptBox[
     RowBox[{"O", "[", "g", "]"}], "9"],
    SeriesData[$CellContext`g, 0, {}, 0, 18, 2],
    Editable->False]}],
  SeriesData[$CellContext`g, 0, {
   1, 0, 0, 0, 12 EulerGamma, 0, 0, 0, 
    12 ((-4) EulerGamma + 6 EulerGamma^2 - 3 Zeta[3]), 0, 0, 0, 
    48 ((-12) EulerGamma^2 + 6 EulerGamma^3 + EulerGamma (7 - 9 Zeta[3]) + 
     3 Zeta[3] + 5 Zeta[5]), 0, 0, 0, 
    12 ((-288) EulerGamma^3 + 
     72 EulerGamma^4 - (216 EulerGamma^2) (-2 + Zeta[3]) - 87 Zeta[3] + 
     54 Zeta[3]^2 - 80 Zeta[5] + 
     EulerGamma (-235 + 264 Zeta[3] + 240 Zeta[5]) - 175 Zeta[7])}, 0, 18, 2],
  
  Editable->False]], "Output",
 CellChangeTimes->{
  3.554629201858534*^9, {3.554629234024536*^9, 3.554629263284306*^9}, 
   3.554631466029188*^9, {3.554631498282246*^9, 3.5546315206267*^9}, {
   3.555790942365301*^9, 3.5557909602153673`*^9}, 3.5557910511313553`*^9, 
   3.55579120944219*^9, 3.555791239616622*^9, 3.56146977714701*^9, 
   3.5614698592858562`*^9, 3.5622638204227467`*^9}]
}, Open  ]],

Cell["\<\
Therefore, we got an additional normalization factor which should be taken \
into account\
\>", "Text",
 CellChangeTimes->{{3.546151133221838*^9, 3.546151146021626*^9}, {
  3.550295269617263*^9, 3.550295281712967*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"mynfactor", "=", 
  RowBox[{"Normal", "@", 
   RowBox[{"Series", "[", 
    RowBox[{
     FractionBox["1", 
      SqrtBox["currentnorm"]], ",", 
     RowBox[{"{", 
      RowBox[{"g", ",", "0", ",", "9"}], "}"}]}], "]"}]}]}]], "Input",
 CellChangeTimes->{{3.54615121069209*^9, 3.5461512420064096`*^9}, {
   3.5502938971383867`*^9, 3.550293904869433*^9}, 3.5523813908223333`*^9, {
   3.555791249134062*^9, 3.55579125573005*^9}, 3.561469932765257*^9, {
   3.563301641475149*^9, 3.563301646561595*^9}}],

Cell[BoxData[
 RowBox[{"1", "-", 
  RowBox[{"6", " ", 
   SuperscriptBox["g", "2"], " ", 
   SubscriptBox[
    StyleBox["\[Zeta]",
     FontWeight->Bold,
     FontColor->GrayLevel[0.4]], "1"]}], "+", 
  RowBox[{"6", " ", 
   SuperscriptBox["g", "4"], " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"4", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "1"]}], "+", 
     RowBox[{"3", " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "1", "2"]}], "+", 
     RowBox[{"3", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3"]}]}], ")"}]}], "-", 
  RowBox[{"12", " ", 
   SuperscriptBox["g", "6"], " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"14", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "1"]}], "+", 
     RowBox[{"12", " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "1", "2"]}], "+", 
     RowBox[{"3", " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "1", "3"]}], "+", 
     RowBox[{"6", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3"]}], "+", 
     RowBox[{"9", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "1"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3"]}], "+", 
     RowBox[{"10", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "5"]}]}], ")"}]}], "+", 
  RowBox[{"6", " ", 
   SuperscriptBox["g", "8"], " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"235", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "1"]}], "+", 
     RowBox[{"216", " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "1", "2"]}], "+", 
     RowBox[{"72", " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "1", "3"]}], "+", 
     RowBox[{"9", " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "1", "4"]}], "+", 
     RowBox[{"87", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3"]}], "+", 
     RowBox[{"168", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "1"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3"]}], "+", 
     RowBox[{"54", " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "1", "2"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3"]}], "+", 
     RowBox[{"27", " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3", "2"]}], "+", 
     RowBox[{"80", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "5"]}], "+", 
     RowBox[{"120", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "1"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "5"]}], "+", 
     RowBox[{"175", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "7"]}]}], ")"}]}]}]], "Output",
 CellChangeTimes->{{3.546151232812026*^9, 3.546151242601131*^9}, 
   3.550293907631228*^9, 3.5502953002281113`*^9, 3.5523813913651667`*^9, 
   3.555791261848412*^9, 3.561469933513276*^9, 3.563301647159876*^9}]
}, Open  ]],

Cell[BoxData["tmpU"], "Input",
 CellChangeTimes->{{3.5622638368010397`*^9, 3.5622638372952423`*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Uasnomralized", "=", 
  RowBox[{"Collect", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"Series", "[", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{"tmpU", 
         RowBox[{"(", "mynfactor", ")"}]}], ")"}], ",", 
       RowBox[{"{", 
        RowBox[{"g", ",", "0", ",", "10"}], "}"}]}], "]"}], "//.", 
     RowBox[{"shiftp\[Eta]", "[", "0", "]"}]}], ",", "canlist", ",", 
    RowBox[{
     RowBox[{"Apart", "[", 
      RowBox[{"#", ",", "u"}], "]"}], "&"}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.561469990490171*^9, 3.5614701370790586`*^9}, 
   3.5633016607570868`*^9, {3.563301693436926*^9, 3.563301709312059*^9}}],

Cell[BoxData[
 RowBox[{
  FractionBox[
   RowBox[{"\[ImaginaryI]", " ", 
    SqrtBox["2"], " ", 
    SuperscriptBox["g", "2"]}], "u"], "+", 
  RowBox[{
   SuperscriptBox["g", "4"], " ", 
   RowBox[{"(", 
    RowBox[{
     FractionBox[
      RowBox[{"\[ImaginaryI]", " ", 
       SqrtBox["2"]}], 
      SuperscriptBox["u", "3"]], "-", 
     FractionBox[
      RowBox[{"3", " ", 
       SqrtBox["2"]}], 
      SuperscriptBox["u", "2"]], "+", 
     FractionBox[
      RowBox[{"9", " ", "\[ImaginaryI]"}], 
      RowBox[{
       SqrtBox["2"], " ", "u"}]], "-", 
     FractionBox[
      RowBox[{"6", " ", "\[ImaginaryI]", " ", 
       SqrtBox["2"], " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "1"]}], "u"], "-", 
     FractionBox[
      RowBox[{"6", " ", 
       SqrtBox["2"], " ", 
       SubsuperscriptBox[
        StyleBox["\[Eta]",
         FontWeight->Bold,
         FontColor->RGBColor[0.8, 0, 0]], "1", 
        RowBox[{"[", "2", "]"}]]}], "u"]}], ")"}]}], "+", 
  RowBox[{
   SuperscriptBox["g", "6"], " ", 
   RowBox[{"(", 
    RowBox[{
     FractionBox[
      RowBox[{"2", " ", "\[ImaginaryI]", " ", 
       SqrtBox["2"]}], 
      SuperscriptBox["u", "5"]], "-", 
     FractionBox[
      RowBox[{"6", " ", 
       SqrtBox["2"]}], 
      SuperscriptBox["u", "4"]], "+", 
     FractionBox[
      RowBox[{"3", " ", "\[ImaginaryI]"}], 
      RowBox[{
       SqrtBox["2"], " ", 
       SuperscriptBox["u", "3"]}]], "-", 
     FractionBox["3", 
      RowBox[{
       SqrtBox["2"], " ", 
       SuperscriptBox["u", "2"]}]], "-", 
     FractionBox[
      RowBox[{"153", " ", "\[ImaginaryI]"}], 
      RowBox[{"4", " ", 
       SqrtBox["2"], " ", "u"}]], "+", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", 
         FractionBox[
          RowBox[{"6", " ", "\[ImaginaryI]", " ", 
           SqrtBox["2"]}], 
          SuperscriptBox["u", "3"]]}], "+", 
        FractionBox[
         RowBox[{"18", " ", 
          SqrtBox["2"]}], 
         SuperscriptBox["u", "2"]], "-", 
        FractionBox[
         RowBox[{"3", " ", "\[ImaginaryI]", " ", 
          SqrtBox["2"]}], "u"]}], ")"}], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "1"]}], "+", 
     FractionBox[
      RowBox[{"18", " ", "\[ImaginaryI]", " ", 
       SqrtBox["2"], " ", 
       SubsuperscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "1", "2"]}], "u"], "+", 
     FractionBox[
      RowBox[{"18", " ", "\[ImaginaryI]", " ", 
       SqrtBox["2"], " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "3"]}], "u"], "+", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", 
         FractionBox[
          RowBox[{"6", " ", 
           SqrtBox["2"]}], 
          SuperscriptBox["u", "3"]]}], "-", 
        FractionBox[
         RowBox[{"18", " ", "\[ImaginaryI]", " ", 
          SqrtBox["2"]}], 
         SuperscriptBox["u", "2"]], "-", 
        FractionBox[
         RowBox[{"3", " ", 
          SqrtBox["2"]}], "u"], "+", 
        FractionBox[
         RowBox[{"36", " ", 
          SqrtBox["2"], " ", 
          SubscriptBox[
           StyleBox["\[Zeta]",
            FontWeight->Bold,
            FontColor->GrayLevel[0.4]], "1"]}], "u"]}], ")"}], " ", 
      SubsuperscriptBox[
       StyleBox["\[Eta]",
        FontWeight->Bold,
        FontColor->RGBColor[0.8, 0, 0]], "1", 
       RowBox[{"[", "2", "]"}]]}], "-", 
     FractionBox[
      RowBox[{"18", " ", "\[ImaginaryI]", " ", 
       SqrtBox["2"], " ", 
       SuperscriptBox[
        RowBox[{"(", 
         SubsuperscriptBox[
          StyleBox["\[Eta]",
           FontWeight->Bold,
           FontColor->RGBColor[0.8, 0, 0]], "1", 
          RowBox[{"[", "2", "]"}]], ")"}], "2"]}], "u"], "-", 
     FractionBox[
      RowBox[{"6", " ", 
       SqrtBox["2"], " ", 
       SubsuperscriptBox[
        StyleBox["\[Eta]",
         FontWeight->Bold,
         FontColor->RGBColor[0.8, 0, 0]], "3", 
        RowBox[{"[", "2", "]"}]]}], "u"]}], ")"}]}], "+", 
  RowBox[{
   SuperscriptBox["g", "8"], " ", 
   RowBox[{"(", 
    RowBox[{
     FractionBox[
      RowBox[{"5", " ", "\[ImaginaryI]", " ", 
       SqrtBox["2"]}], 
      SuperscriptBox["u", "7"]], "-", 
     FractionBox[
      RowBox[{"15", " ", 
       SqrtBox["2"]}], 
      SuperscriptBox["u", "6"]], "-", 
     FractionBox[
      RowBox[{"3", " ", 
       SqrtBox["2"]}], 
      SuperscriptBox["u", "4"]], "-", 
     FractionBox[
      RowBox[{"93", " ", "\[ImaginaryI]"}], 
      RowBox[{"4", " ", 
       SqrtBox["2"], " ", 
       SuperscriptBox["u", "3"]}]], "+", 
     FractionBox["219", 
      RowBox[{"4", " ", 
       SqrtBox["2"], " ", 
       SuperscriptBox["u", "2"]}]], "+", 
     FractionBox[
      RowBox[{"2241", " ", "\[ImaginaryI]"}], 
      RowBox[{"8", " ", 
       SqrtBox["2"], " ", "u"}]], "+", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", 
         FractionBox[
          RowBox[{"12", " ", "\[ImaginaryI]", " ", 
           SqrtBox["2"]}], 
          SuperscriptBox["u", "5"]]}], "+", 
        FractionBox[
         RowBox[{"36", " ", 
          SqrtBox["2"]}], 
         SuperscriptBox["u", "4"]], "+", 
        FractionBox[
         RowBox[{"15", " ", "\[ImaginaryI]", " ", 
          SqrtBox["2"]}], 
         SuperscriptBox["u", "3"]], "-", 
        FractionBox[
         RowBox[{"63", " ", 
          SqrtBox["2"]}], 
         SuperscriptBox["u", "2"]], "+", 
        FractionBox[
         RowBox[{"219", " ", "\[ImaginaryI]"}], 
         RowBox[{"2", " ", 
          SqrtBox["2"], " ", "u"}]]}], ")"}], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "1"]}], "+", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        FractionBox[
         RowBox[{"18", " ", "\[ImaginaryI]", " ", 
          SqrtBox["2"]}], 
         SuperscriptBox["u", "3"]], "-", 
        FractionBox[
         RowBox[{"54", " ", 
          SqrtBox["2"]}], 
         SuperscriptBox["u", "2"]], "-", 
        FractionBox[
         RowBox[{"63", " ", "\[ImaginaryI]", " ", 
          SqrtBox["2"]}], "u"]}], ")"}], " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "1", "2"]}], "-", 
     FractionBox[
      RowBox[{"36", " ", "\[ImaginaryI]", " ", 
       SqrtBox["2"], " ", 
       SubsuperscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "1", "3"]}], "u"], "+", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        FractionBox[
         RowBox[{"30", " ", "\[ImaginaryI]", " ", 
          SqrtBox["2"]}], 
         SuperscriptBox["u", "3"]], "-", 
        FractionBox[
         RowBox[{"54", " ", 
          SqrtBox["2"]}], 
         SuperscriptBox["u", "2"]], "+", 
        FractionBox[
         RowBox[{"9", " ", "\[ImaginaryI]", " ", 
          SqrtBox["2"]}], "u"]}], ")"}], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3"]}], "-", 
     FractionBox[
      RowBox[{"108", " ", "\[ImaginaryI]", " ", 
       SqrtBox["2"], " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "1"], " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "3"]}], "u"], "-", 
     FractionBox[
      RowBox[{"120", " ", "\[ImaginaryI]", " ", 
       SqrtBox["2"], " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "5"]}], "u"], "+", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", 
         FractionBox[
          RowBox[{"18", " ", "\[ImaginaryI]", " ", 
           SqrtBox["2"]}], 
          SuperscriptBox["u", "3"]]}], "+", 
        FractionBox[
         RowBox[{"54", " ", 
          SqrtBox["2"]}], 
         SuperscriptBox["u", "2"]], "+", 
        FractionBox[
         RowBox[{"63", " ", "\[ImaginaryI]", " ", 
          SqrtBox["2"]}], "u"], "+", 
        FractionBox[
         RowBox[{"108", " ", "\[ImaginaryI]", " ", 
          SqrtBox["2"], " ", 
          SubscriptBox[
           StyleBox["\[Zeta]",
            FontWeight->Bold,
            FontColor->GrayLevel[0.4]], "1"]}], "u"]}], ")"}], " ", 
      SuperscriptBox[
       RowBox[{"(", 
        SubsuperscriptBox[
         StyleBox["\[Eta]",
          FontWeight->Bold,
          FontColor->RGBColor[0.8, 0, 0]], "1", 
         RowBox[{"[", "2", "]"}]], ")"}], "2"]}], "+", 
     FractionBox[
      RowBox[{"36", " ", 
       SqrtBox["2"], " ", 
       SuperscriptBox[
        RowBox[{"(", 
         SubsuperscriptBox[
          StyleBox["\[Eta]",
           FontWeight->Bold,
           FontColor->RGBColor[0.8, 0, 0]], "1", 
          RowBox[{"[", "2", "]"}]], ")"}], "3"]}], "u"], "+", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", 
         FractionBox[
          RowBox[{"6", " ", 
           SqrtBox["2"]}], 
          SuperscriptBox["u", "3"]]}], "-", 
        FractionBox[
         RowBox[{"18", " ", "\[ImaginaryI]", " ", 
          SqrtBox["2"]}], 
         SuperscriptBox["u", "2"]], "-", 
        FractionBox[
         RowBox[{"3", " ", 
          SqrtBox["2"]}], "u"], "+", 
        FractionBox[
         RowBox[{"36", " ", 
          SqrtBox["2"], " ", 
          SubscriptBox[
           StyleBox["\[Zeta]",
            FontWeight->Bold,
            FontColor->GrayLevel[0.4]], "1"]}], "u"]}], ")"}], " ", 
      SubsuperscriptBox[
       StyleBox["\[Eta]",
        FontWeight->Bold,
        FontColor->RGBColor[0.8, 0, 0]], "3", 
       RowBox[{"[", "2", "]"}]]}], "+", 
     RowBox[{
      SubsuperscriptBox[
       StyleBox["\[Eta]",
        FontWeight->Bold,
        FontColor->RGBColor[0.8, 0, 0]], "1", 
       RowBox[{"[", "2", "]"}]], " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", 
         FractionBox[
          RowBox[{"12", " ", 
           SqrtBox["2"]}], 
          SuperscriptBox["u", "5"]]}], "-", 
        FractionBox[
         RowBox[{"36", " ", "\[ImaginaryI]", " ", 
          SqrtBox["2"]}], 
         SuperscriptBox["u", "4"]], "+", 
        FractionBox[
         RowBox[{"15", " ", 
          SqrtBox["2"]}], 
         SuperscriptBox["u", "3"]], "+", 
        FractionBox[
         RowBox[{"63", " ", "\[ImaginaryI]", " ", 
          SqrtBox["2"]}], 
         SuperscriptBox["u", "2"]], "+", 
        FractionBox["219", 
         RowBox[{"2", " ", 
          SqrtBox["2"], " ", "u"}]], "+", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           FractionBox[
            RowBox[{"36", " ", 
             SqrtBox["2"]}], 
            SuperscriptBox["u", "3"]], "+", 
           FractionBox[
            RowBox[{"108", " ", "\[ImaginaryI]", " ", 
             SqrtBox["2"]}], 
            SuperscriptBox["u", "2"]], "-", 
           FractionBox[
            RowBox[{"126", " ", 
             SqrtBox["2"]}], "u"]}], ")"}], " ", 
         SubscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "1"]}], "-", 
        FractionBox[
         RowBox[{"108", " ", 
          SqrtBox["2"], " ", 
          SubsuperscriptBox[
           StyleBox["\[Zeta]",
            FontWeight->Bold,
            FontColor->GrayLevel[0.4]], "1", "2"]}], "u"], "-", 
        FractionBox[
         RowBox[{"108", " ", 
          SqrtBox["2"], " ", 
          SubscriptBox[
           StyleBox["\[Zeta]",
            FontWeight->Bold,
            FontColor->GrayLevel[0.4]], "3"]}], "u"], "-", 
        FractionBox[
         RowBox[{"36", " ", "\[ImaginaryI]", " ", 
          SqrtBox["2"], " ", 
          SubsuperscriptBox[
           StyleBox["\[Eta]",
            FontWeight->Bold,
            FontColor->RGBColor[0.8, 0, 0]], "3", 
           RowBox[{"[", "2", "]"}]]}], "u"]}], ")"}]}], "-", 
     FractionBox[
      RowBox[{"12", " ", 
       SqrtBox["2"], " ", 
       SubsuperscriptBox[
        StyleBox["\[Eta]",
         FontWeight->Bold,
         FontColor->RGBColor[0.8, 0, 0]], "5", 
        RowBox[{"[", "2", "]"}]]}], "u"]}], ")"}]}], "+", 
  RowBox[{
   SuperscriptBox["g", "10"], " ", 
   RowBox[{"(", 
    RowBox[{
     FractionBox[
      RowBox[{"14", " ", "\[ImaginaryI]", " ", 
       SqrtBox["2"]}], 
      SuperscriptBox["u", "9"]], "-", 
     FractionBox[
      RowBox[{"42", " ", 
       SqrtBox["2"]}], 
      SuperscriptBox["u", "8"]], "-", 
     FractionBox[
      RowBox[{"9", " ", "\[ImaginaryI]"}], 
      RowBox[{
       SqrtBox["2"], " ", 
       SuperscriptBox["u", "7"]}]], "-", 
     FractionBox["15", 
      RowBox[{
       SqrtBox["2"], " ", 
       SuperscriptBox["u", "6"]}]], "-", 
     FractionBox[
      RowBox[{"63", " ", "\[ImaginaryI]"}], 
      RowBox[{"2", " ", 
       SqrtBox["2"], " ", 
       SuperscriptBox["u", "5"]}]], "+", 
     FractionBox["219", 
      RowBox[{"2", " ", 
       SqrtBox["2"], " ", 
       SuperscriptBox["u", "4"]}]], "+", 
     FractionBox[
      RowBox[{"1743", " ", "\[ImaginaryI]"}], 
      RowBox[{"8", " ", 
       SqrtBox["2"], " ", 
       SuperscriptBox["u", "3"]}]], "-", 
     FractionBox["5163", 
      RowBox[{"8", " ", 
       SqrtBox["2"], " ", 
       SuperscriptBox["u", "2"]}]], "-", 
     FractionBox[
      RowBox[{"156501", " ", "\[ImaginaryI]"}], 
      RowBox[{"64", " ", 
       SqrtBox["2"], " ", "u"}]], "+", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", 
         FractionBox[
          RowBox[{"30", " ", "\[ImaginaryI]", " ", 
           SqrtBox["2"]}], 
          SuperscriptBox["u", "7"]]}], "+", 
        FractionBox[
         RowBox[{"90", " ", 
          SqrtBox["2"]}], 
         SuperscriptBox["u", "6"]], "+", 
        FractionBox[
         RowBox[{"48", " ", "\[ImaginaryI]", " ", 
          SqrtBox["2"]}], 
         SuperscriptBox["u", "5"]], "-", 
        FractionBox[
         RowBox[{"126", " ", 
          SqrtBox["2"]}], 
         SuperscriptBox["u", "4"]], "-", 
        FractionBox[
         RowBox[{"249", " ", "\[ImaginaryI]"}], 
         RowBox[{"2", " ", 
          SqrtBox["2"], " ", 
          SuperscriptBox["u", "3"]}]], "+", 
        FractionBox["1215", 
         RowBox[{"2", " ", 
          SqrtBox["2"], " ", 
          SuperscriptBox["u", "2"]}]], "-", 
        FractionBox[
         RowBox[{"5163", " ", "\[ImaginaryI]"}], 
         RowBox[{"4", " ", 
          SqrtBox["2"], " ", "u"}]]}], ")"}], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "1"]}], "+", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        FractionBox[
         RowBox[{"36", " ", "\[ImaginaryI]", " ", 
          SqrtBox["2"]}], 
         SuperscriptBox["u", "5"]], "-", 
        FractionBox[
         RowBox[{"108", " ", 
          SqrtBox["2"]}], 
         SuperscriptBox["u", "4"]], "-", 
        FractionBox[
         RowBox[{"117", " ", "\[ImaginaryI]", " ", 
          SqrtBox["2"]}], 
         SuperscriptBox["u", "3"]], "+", 
        FractionBox[
         RowBox[{"405", " ", 
          SqrtBox["2"]}], 
         SuperscriptBox["u", "2"]], "+", 
        FractionBox[
         RowBox[{"1215", " ", "\[ImaginaryI]"}], 
         RowBox[{"2", " ", 
          SqrtBox["2"], " ", "u"}]]}], ")"}], " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "1", "2"]}], "+", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", 
         FractionBox[
          RowBox[{"36", " ", "\[ImaginaryI]", " ", 
           SqrtBox["2"]}], 
          SuperscriptBox["u", "3"]]}], "+", 
        FractionBox[
         RowBox[{"108", " ", 
          SqrtBox["2"]}], 
         SuperscriptBox["u", "2"]], "+", 
        FractionBox[
         RowBox[{"270", " ", "\[ImaginaryI]", " ", 
          SqrtBox["2"]}], "u"]}], ")"}], " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "1", "3"]}], "+", 
     FractionBox[
      RowBox[{"54", " ", "\[ImaginaryI]", " ", 
       SqrtBox["2"], " ", 
       SubsuperscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "1", "4"]}], "u"], "+", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        FractionBox[
         RowBox[{"72", " ", "\[ImaginaryI]", " ", 
          SqrtBox["2"]}], 
         SuperscriptBox["u", "5"]], "-", 
        FractionBox[
         RowBox[{"144", " ", 
          SqrtBox["2"]}], 
         SuperscriptBox["u", "4"]], "-", 
        FractionBox[
         RowBox[{"39", " ", "\[ImaginaryI]", " ", 
          SqrtBox["2"]}], 
         SuperscriptBox["u", "3"]], "+", 
        FractionBox[
         RowBox[{"261", " ", 
          SqrtBox["2"]}], 
         SuperscriptBox["u", "2"]], "-", 
        FractionBox[
         RowBox[{"1017", " ", "\[ImaginaryI]"}], 
         RowBox[{"2", " ", 
          SqrtBox["2"], " ", "u"}]]}], ")"}], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3"]}], "+", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", 
         FractionBox[
          RowBox[{"180", " ", "\[ImaginaryI]", " ", 
           SqrtBox["2"]}], 
          SuperscriptBox["u", "3"]]}], "+", 
        FractionBox[
         RowBox[{"324", " ", 
          SqrtBox["2"]}], 
         SuperscriptBox["u", "2"]], "+", 
        FractionBox[
         RowBox[{"522", " ", "\[ImaginaryI]", " ", 
          SqrtBox["2"]}], "u"]}], ")"}], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "1"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3"]}], "+", 
     FractionBox[
      RowBox[{"324", " ", "\[ImaginaryI]", " ", 
       SqrtBox["2"], " ", 
       SubsuperscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "1", "2"], " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "3"]}], "u"], "+", 
     FractionBox[
      RowBox[{"162", " ", "\[ImaginaryI]", " ", 
       SqrtBox["2"], " ", 
       SubsuperscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "3", "2"]}], "u"], "+", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", 
         FractionBox[
          RowBox[{"240", " ", "\[ImaginaryI]", " ", 
           SqrtBox["2"]}], 
          SuperscriptBox["u", "3"]]}], "+", 
        FractionBox[
         RowBox[{"360", " ", 
          SqrtBox["2"]}], 
         SuperscriptBox["u", "2"]], "-", 
        FractionBox[
         RowBox[{"60", " ", "\[ImaginaryI]", " ", 
          SqrtBox["2"]}], "u"]}], ")"}], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "5"]}], "+", 
     FractionBox[
      RowBox[{"720", " ", "\[ImaginaryI]", " ", 
       SqrtBox["2"], " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "1"], " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "5"]}], "u"], "+", 
     FractionBox[
      RowBox[{"1050", " ", "\[ImaginaryI]", " ", 
       SqrtBox["2"], " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "7"]}], "u"], "+", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        FractionBox[
         RowBox[{"36", " ", 
          SqrtBox["2"]}], 
         SuperscriptBox["u", "3"]], "+", 
        FractionBox[
         RowBox[{"108", " ", "\[ImaginaryI]", " ", 
          SqrtBox["2"]}], 
         SuperscriptBox["u", "2"]], "-", 
        FractionBox[
         RowBox[{"270", " ", 
          SqrtBox["2"]}], "u"], "-", 
        FractionBox[
         RowBox[{"216", " ", 
          SqrtBox["2"], " ", 
          SubscriptBox[
           StyleBox["\[Zeta]",
            FontWeight->Bold,
            FontColor->GrayLevel[0.4]], "1"]}], "u"]}], ")"}], " ", 
      SuperscriptBox[
       RowBox[{"(", 
        SubsuperscriptBox[
         StyleBox["\[Eta]",
          FontWeight->Bold,
          FontColor->RGBColor[0.8, 0, 0]], "1", 
         RowBox[{"[", "2", "]"}]], ")"}], "3"]}], "+", 
     FractionBox[
      RowBox[{"54", " ", "\[ImaginaryI]", " ", 
       SqrtBox["2"], " ", 
       SuperscriptBox[
        RowBox[{"(", 
         SubsuperscriptBox[
          StyleBox["\[Eta]",
           FontWeight->Bold,
           FontColor->RGBColor[0.8, 0, 0]], "1", 
          RowBox[{"[", "2", "]"}]], ")"}], "4"]}], "u"], "+", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", 
         FractionBox[
          RowBox[{"12", " ", 
           SqrtBox["2"]}], 
          SuperscriptBox["u", "5"]]}], "-", 
        FractionBox[
         RowBox[{"36", " ", "\[ImaginaryI]", " ", 
          SqrtBox["2"]}], 
         SuperscriptBox["u", "4"]], "+", 
        FractionBox[
         RowBox[{"15", " ", 
          SqrtBox["2"]}], 
         SuperscriptBox["u", "3"]], "+", 
        FractionBox[
         RowBox[{"63", " ", "\[ImaginaryI]", " ", 
          SqrtBox["2"]}], 
         SuperscriptBox["u", "2"]], "+", 
        FractionBox["147", 
         RowBox[{"2", " ", 
          SqrtBox["2"], " ", "u"}]], "+", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           FractionBox[
            RowBox[{"36", " ", 
             SqrtBox["2"]}], 
            SuperscriptBox["u", "3"]], "+", 
           FractionBox[
            RowBox[{"108", " ", "\[ImaginaryI]", " ", 
             SqrtBox["2"]}], 
            SuperscriptBox["u", "2"]], "-", 
           FractionBox[
            RowBox[{"126", " ", 
             SqrtBox["2"]}], "u"]}], ")"}], " ", 
         SubscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "1"]}], "-", 
        FractionBox[
         RowBox[{"108", " ", 
          SqrtBox["2"], " ", 
          SubsuperscriptBox[
           StyleBox["\[Zeta]",
            FontWeight->Bold,
            FontColor->GrayLevel[0.4]], "1", "2"]}], "u"], "-", 
        FractionBox[
         RowBox[{"108", " ", 
          SqrtBox["2"], " ", 
          SubscriptBox[
           StyleBox["\[Zeta]",
            FontWeight->Bold,
            FontColor->GrayLevel[0.4]], "3"]}], "u"]}], ")"}], " ", 
      SubsuperscriptBox[
       StyleBox["\[Eta]",
        FontWeight->Bold,
        FontColor->RGBColor[0.8, 0, 0]], "3", 
       RowBox[{"[", "2", "]"}]]}], "-", 
     FractionBox[
      RowBox[{"18", " ", "\[ImaginaryI]", " ", 
       SqrtBox["2"], " ", 
       SuperscriptBox[
        RowBox[{"(", 
         SubsuperscriptBox[
          StyleBox["\[Eta]",
           FontWeight->Bold,
           FontColor->RGBColor[0.8, 0, 0]], "3", 
          RowBox[{"[", "2", "]"}]], ")"}], "2"]}], "u"], "+", 
     RowBox[{
      SuperscriptBox[
       RowBox[{"(", 
        SubsuperscriptBox[
         StyleBox["\[Eta]",
          FontWeight->Bold,
          FontColor->RGBColor[0.8, 0, 0]], "1", 
         RowBox[{"[", "2", "]"}]], ")"}], "2"], " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", 
         FractionBox[
          RowBox[{"36", " ", "\[ImaginaryI]", " ", 
           SqrtBox["2"]}], 
          SuperscriptBox["u", "5"]]}], "+", 
        FractionBox[
         RowBox[{"108", " ", 
          SqrtBox["2"]}], 
         SuperscriptBox["u", "4"]], "+", 
        FractionBox[
         RowBox[{"117", " ", "\[ImaginaryI]", " ", 
          SqrtBox["2"]}], 
         SuperscriptBox["u", "3"]], "-", 
        FractionBox[
         RowBox[{"405", " ", 
          SqrtBox["2"]}], 
         SuperscriptBox["u", "2"]], "-", 
        FractionBox[
         RowBox[{"1215", " ", "\[ImaginaryI]"}], 
         RowBox[{"2", " ", 
          SqrtBox["2"], " ", "u"}]], "+", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           FractionBox[
            RowBox[{"108", " ", "\[ImaginaryI]", " ", 
             SqrtBox["2"]}], 
            SuperscriptBox["u", "3"]], "-", 
           FractionBox[
            RowBox[{"324", " ", 
             SqrtBox["2"]}], 
            SuperscriptBox["u", "2"]], "-", 
           FractionBox[
            RowBox[{"810", " ", "\[ImaginaryI]", " ", 
             SqrtBox["2"]}], "u"]}], ")"}], " ", 
         SubscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "1"]}], "-", 
        FractionBox[
         RowBox[{"324", " ", "\[ImaginaryI]", " ", 
          SqrtBox["2"], " ", 
          SubsuperscriptBox[
           StyleBox["\[Zeta]",
            FontWeight->Bold,
            FontColor->GrayLevel[0.4]], "1", "2"]}], "u"], "-", 
        FractionBox[
         RowBox[{"324", " ", "\[ImaginaryI]", " ", 
          SqrtBox["2"], " ", 
          SubscriptBox[
           StyleBox["\[Zeta]",
            FontWeight->Bold,
            FontColor->GrayLevel[0.4]], "3"]}], "u"], "+", 
        FractionBox[
         RowBox[{"108", " ", 
          SqrtBox["2"], " ", 
          SubsuperscriptBox[
           StyleBox["\[Eta]",
            FontWeight->Bold,
            FontColor->RGBColor[0.8, 0, 0]], "3", 
           RowBox[{"[", "2", "]"}]]}], "u"]}], ")"}]}], "+", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", 
         FractionBox[
          RowBox[{"12", " ", 
           SqrtBox["2"]}], 
          SuperscriptBox["u", "3"]]}], "-", 
        FractionBox[
         RowBox[{"36", " ", "\[ImaginaryI]", " ", 
          SqrtBox["2"]}], 
         SuperscriptBox["u", "2"]], "-", 
        FractionBox[
         RowBox[{"6", " ", 
          SqrtBox["2"]}], "u"], "+", 
        FractionBox[
         RowBox[{"72", " ", 
          SqrtBox["2"], " ", 
          SubscriptBox[
           StyleBox["\[Zeta]",
            FontWeight->Bold,
            FontColor->GrayLevel[0.4]], "1"]}], "u"]}], ")"}], " ", 
      SubsuperscriptBox[
       StyleBox["\[Eta]",
        FontWeight->Bold,
        FontColor->RGBColor[0.8, 0, 0]], "5", 
       RowBox[{"[", "2", "]"}]]}], "+", 
     RowBox[{
      SubsuperscriptBox[
       StyleBox["\[Eta]",
        FontWeight->Bold,
        FontColor->RGBColor[0.8, 0, 0]], "1", 
       RowBox[{"[", "2", "]"}]], " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", 
         FractionBox[
          RowBox[{"30", " ", 
           SqrtBox["2"]}], 
          SuperscriptBox["u", "7"]]}], "-", 
        FractionBox[
         RowBox[{"90", " ", "\[ImaginaryI]", " ", 
          SqrtBox["2"]}], 
         SuperscriptBox["u", "6"]], "+", 
        FractionBox[
         RowBox[{"48", " ", 
          SqrtBox["2"]}], 
         SuperscriptBox["u", "5"]], "+", 
        FractionBox[
         RowBox[{"126", " ", "\[ImaginaryI]", " ", 
          SqrtBox["2"]}], 
         SuperscriptBox["u", "4"]], "-", 
        FractionBox["249", 
         RowBox[{"2", " ", 
          SqrtBox["2"], " ", 
          SuperscriptBox["u", "3"]}]], "-", 
        FractionBox[
         RowBox[{"1215", " ", "\[ImaginaryI]"}], 
         RowBox[{"2", " ", 
          SqrtBox["2"], " ", 
          SuperscriptBox["u", "2"]}]], "-", 
        FractionBox["5163", 
         RowBox[{"4", " ", 
          SqrtBox["2"], " ", "u"}]], "+", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           FractionBox[
            RowBox[{"72", " ", 
             SqrtBox["2"]}], 
            SuperscriptBox["u", "5"]], "+", 
           FractionBox[
            RowBox[{"216", " ", "\[ImaginaryI]", " ", 
             SqrtBox["2"]}], 
            SuperscriptBox["u", "4"]], "-", 
           FractionBox[
            RowBox[{"234", " ", 
             SqrtBox["2"]}], 
            SuperscriptBox["u", "3"]], "-", 
           FractionBox[
            RowBox[{"810", " ", "\[ImaginaryI]", " ", 
             SqrtBox["2"]}], 
            SuperscriptBox["u", "2"]], "+", 
           FractionBox["1215", 
            RowBox[{
             SqrtBox["2"], " ", "u"}]]}], ")"}], " ", 
         SubscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "1"]}], "+", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           RowBox[{"-", 
            FractionBox[
             RowBox[{"108", " ", 
              SqrtBox["2"]}], 
             SuperscriptBox["u", "3"]]}], "-", 
           FractionBox[
            RowBox[{"324", " ", "\[ImaginaryI]", " ", 
             SqrtBox["2"]}], 
            SuperscriptBox["u", "2"]], "+", 
           FractionBox[
            RowBox[{"810", " ", 
             SqrtBox["2"]}], "u"]}], ")"}], " ", 
         SubsuperscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "1", "2"]}], "+", 
        FractionBox[
         RowBox[{"216", " ", 
          SqrtBox["2"], " ", 
          SubsuperscriptBox[
           StyleBox["\[Zeta]",
            FontWeight->Bold,
            FontColor->GrayLevel[0.4]], "1", "3"]}], "u"], "+", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           RowBox[{"-", 
            FractionBox[
             RowBox[{"180", " ", 
              SqrtBox["2"]}], 
             SuperscriptBox["u", "3"]]}], "-", 
           FractionBox[
            RowBox[{"324", " ", "\[ImaginaryI]", " ", 
             SqrtBox["2"]}], 
            SuperscriptBox["u", "2"]], "+", 
           FractionBox[
            RowBox[{"522", " ", 
             SqrtBox["2"]}], "u"]}], ")"}], " ", 
         SubscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "3"]}], "+", 
        FractionBox[
         RowBox[{"648", " ", 
          SqrtBox["2"], " ", 
          SubscriptBox[
           StyleBox["\[Zeta]",
            FontWeight->Bold,
            FontColor->GrayLevel[0.4]], "1"], " ", 
          SubscriptBox[
           StyleBox["\[Zeta]",
            FontWeight->Bold,
            FontColor->GrayLevel[0.4]], "3"]}], "u"], "+", 
        FractionBox[
         RowBox[{"720", " ", 
          SqrtBox["2"], " ", 
          SubscriptBox[
           StyleBox["\[Zeta]",
            FontWeight->Bold,
            FontColor->GrayLevel[0.4]], "5"]}], "u"], "+", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           RowBox[{"-", 
            FractionBox[
             RowBox[{"36", " ", "\[ImaginaryI]", " ", 
              SqrtBox["2"]}], 
             SuperscriptBox["u", "3"]]}], "+", 
           FractionBox[
            RowBox[{"108", " ", 
             SqrtBox["2"]}], 
            SuperscriptBox["u", "2"]], "+", 
           FractionBox[
            RowBox[{"126", " ", "\[ImaginaryI]", " ", 
             SqrtBox["2"]}], "u"], "+", 
           FractionBox[
            RowBox[{"216", " ", "\[ImaginaryI]", " ", 
             SqrtBox["2"], " ", 
             SubscriptBox[
              StyleBox["\[Zeta]",
               FontWeight->Bold,
               FontColor->GrayLevel[0.4]], "1"]}], "u"]}], ")"}], " ", 
         SubsuperscriptBox[
          StyleBox["\[Eta]",
           FontWeight->Bold,
           FontColor->RGBColor[0.8, 0, 0]], "3", 
          RowBox[{"[", "2", "]"}]]}], "-", 
        FractionBox[
         RowBox[{"72", " ", "\[ImaginaryI]", " ", 
          SqrtBox["2"], " ", 
          SubsuperscriptBox[
           StyleBox["\[Eta]",
            FontWeight->Bold,
            FontColor->RGBColor[0.8, 0, 0]], "5", 
           RowBox[{"[", "2", "]"}]]}], "u"]}], ")"}]}], "-", 
     FractionBox[
      RowBox[{"30", " ", 
       SqrtBox["2"], " ", 
       SubsuperscriptBox[
        StyleBox["\[Eta]",
         FontWeight->Bold,
         FontColor->RGBColor[0.8, 0, 0]], "7", 
        RowBox[{"[", "2", "]"}]]}], "u"]}], ")"}]}]}]], "Output",
 CellChangeTimes->{{3.5614699999560423`*^9, 3.5614700551880093`*^9}, {
   3.561470090923437*^9, 3.56147013755545*^9}, 3.562263850963344*^9, 
   3.563301710890703*^9}]
}, Open  ]],

Cell["We will only bring it to canonical form now", "Text",
 CellChangeTimes->{{3.5622639375550623`*^9, 3.562263944713221*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Uasnomralized", "=", 
  RowBox[{"Collect", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"Uasnomralized", "/.", "subtousu"}], "//", "FuntoMHZbasis"}], 
    ",", "canlist"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.562263955444566*^9, 3.562264036218245*^9}, {
   3.563301733825892*^9, 3.563301738247178*^9}, 3.563301854020265*^9}],

Cell[BoxData[
 RowBox[{
  FractionBox[
   RowBox[{"\[ImaginaryI]", " ", 
    SqrtBox["2"], " ", 
    SuperscriptBox["g", "2"]}], 
   StyleBox["\[ScriptU]",
    FontColor->RGBColor[0, 0, 0.4]]], "+", 
  RowBox[{
   SuperscriptBox["g", "4"], " ", 
   RowBox[{"(", 
    RowBox[{
     FractionBox[
      RowBox[{"\[ImaginaryI]", " ", 
       SqrtBox["2"]}], 
      SuperscriptBox[
       StyleBox["\[ScriptU]",
        FontColor->RGBColor[0, 0, 0.4]], "3"]], "-", 
     FractionBox[
      RowBox[{"3", " ", 
       SqrtBox["2"]}], 
      SuperscriptBox[
       StyleBox["\[ScriptU]",
        FontColor->RGBColor[0, 0, 0.4]], "2"]], "+", 
     FractionBox[
      RowBox[{
       FractionBox[
        RowBox[{"9", " ", "\[ImaginaryI]"}], 
        SqrtBox["2"]], "-", 
       RowBox[{"6", " ", "\[ImaginaryI]", " ", 
        SqrtBox["2"], " ", 
        SubscriptBox[
         StyleBox["\[Zeta]",
          FontWeight->Bold,
          FontColor->GrayLevel[0.4]], "1"]}]}], 
      StyleBox["\[ScriptU]",
       FontColor->RGBColor[0, 0, 0.4]]], "-", 
     FractionBox[
      RowBox[{"6", " ", 
       SqrtBox["2"], " ", 
       SubsuperscriptBox[
        StyleBox["\[Eta]",
         FontWeight->Bold,
         FontColor->RGBColor[0.8, 0, 0]], "1", 
        RowBox[{"[", "2", "]"}]]}], 
      StyleBox["\[ScriptU]",
       FontColor->RGBColor[0, 0, 0.4]]]}], ")"}]}], "+", 
  RowBox[{
   SuperscriptBox["g", "6"], " ", 
   RowBox[{"(", 
    RowBox[{
     FractionBox[
      RowBox[{"2", " ", "\[ImaginaryI]", " ", 
       SqrtBox["2"]}], 
      SuperscriptBox[
       StyleBox["\[ScriptU]",
        FontColor->RGBColor[0, 0, 0.4]], "5"]], "-", 
     FractionBox[
      RowBox[{"6", " ", 
       SqrtBox["2"]}], 
      SuperscriptBox[
       StyleBox["\[ScriptU]",
        FontColor->RGBColor[0, 0, 0.4]], "4"]], "+", 
     FractionBox[
      RowBox[{
       FractionBox[
        RowBox[{"3", " ", "\[ImaginaryI]"}], 
        SqrtBox["2"]], "-", 
       RowBox[{"6", " ", "\[ImaginaryI]", " ", 
        SqrtBox["2"], " ", 
        SubscriptBox[
         StyleBox["\[Zeta]",
          FontWeight->Bold,
          FontColor->GrayLevel[0.4]], "1"]}]}], 
      SuperscriptBox[
       StyleBox["\[ScriptU]",
        FontColor->RGBColor[0, 0, 0.4]], "3"]], "+", 
     FractionBox[
      RowBox[{
       RowBox[{"-", 
        FractionBox["3", 
         SqrtBox["2"]]}], "+", 
       RowBox[{"18", " ", 
        SqrtBox["2"], " ", 
        SubscriptBox[
         StyleBox["\[Zeta]",
          FontWeight->Bold,
          FontColor->GrayLevel[0.4]], "1"]}]}], 
      SuperscriptBox[
       StyleBox["\[ScriptU]",
        FontColor->RGBColor[0, 0, 0.4]], "2"]], "+", 
     FractionBox[
      RowBox[{
       RowBox[{"-", 
        FractionBox[
         RowBox[{"153", " ", "\[ImaginaryI]"}], 
         RowBox[{"4", " ", 
          SqrtBox["2"]}]]}], "-", 
       RowBox[{"3", " ", "\[ImaginaryI]", " ", 
        SqrtBox["2"], " ", 
        SubscriptBox[
         StyleBox["\[Zeta]",
          FontWeight->Bold,
          FontColor->GrayLevel[0.4]], "1"]}], "+", 
       RowBox[{"18", " ", "\[ImaginaryI]", " ", 
        SqrtBox["2"], " ", 
        SubsuperscriptBox[
         StyleBox["\[Zeta]",
          FontWeight->Bold,
          FontColor->GrayLevel[0.4]], "1", "2"]}], "+", 
       RowBox[{"18", " ", "\[ImaginaryI]", " ", 
        SqrtBox["2"], " ", 
        SubscriptBox[
         StyleBox["\[Zeta]",
          FontWeight->Bold,
          FontColor->GrayLevel[0.4]], "3"]}]}], 
      StyleBox["\[ScriptU]",
       FontColor->RGBColor[0, 0, 0.4]]], "+", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", 
         FractionBox[
          RowBox[{"6", " ", 
           SqrtBox["2"]}], 
          SuperscriptBox[
           StyleBox["\[ScriptU]",
            FontColor->RGBColor[0, 0, 0.4]], "3"]]}], "-", 
        FractionBox[
         RowBox[{"18", " ", "\[ImaginaryI]", " ", 
          SqrtBox["2"]}], 
         SuperscriptBox[
          StyleBox["\[ScriptU]",
           FontColor->RGBColor[0, 0, 0.4]], "2"]], "+", 
        FractionBox[
         RowBox[{
          RowBox[{
           RowBox[{"-", "3"}], " ", 
           SqrtBox["2"]}], "+", 
          RowBox[{"36", " ", 
           SqrtBox["2"], " ", 
           SubscriptBox[
            StyleBox["\[Zeta]",
             FontWeight->Bold,
             FontColor->GrayLevel[0.4]], "1"]}]}], 
         StyleBox["\[ScriptU]",
          FontColor->RGBColor[0, 0, 0.4]]]}], ")"}], " ", 
      SubsuperscriptBox[
       StyleBox["\[Eta]",
        FontWeight->Bold,
        FontColor->RGBColor[0.8, 0, 0]], "1", 
       RowBox[{"[", "2", "]"}]]}], "-", 
     FractionBox[
      RowBox[{"18", " ", "\[ImaginaryI]", " ", 
       SqrtBox["2"], " ", 
       SubsuperscriptBox[
        StyleBox["\[Eta]",
         FontWeight->Bold,
         FontColor->RGBColor[0.8, 0, 0]], "2", 
        RowBox[{"[", "2", "]"}]]}], 
      StyleBox["\[ScriptU]",
       FontColor->RGBColor[0, 0, 0.4]]], "-", 
     FractionBox[
      RowBox[{"6", " ", 
       SqrtBox["2"], " ", 
       SubsuperscriptBox[
        StyleBox["\[Eta]",
         FontWeight->Bold,
         FontColor->RGBColor[0.8, 0, 0]], "3", 
        RowBox[{"[", "2", "]"}]]}], 
      StyleBox["\[ScriptU]",
       FontColor->RGBColor[0, 0, 0.4]]], "-", 
     FractionBox[
      RowBox[{"36", " ", "\[ImaginaryI]", " ", 
       SqrtBox["2"], " ", 
       SubsuperscriptBox[
        StyleBox["\[Eta]",
         FontWeight->Bold,
         FontColor->RGBColor[0.8, 0, 0]], 
        RowBox[{"1", ",", "1"}], 
        RowBox[{"[", "2", "]"}]]}], 
      StyleBox["\[ScriptU]",
       FontColor->RGBColor[0, 0, 0.4]]]}], ")"}]}], "+", 
  RowBox[{
   SuperscriptBox["g", "8"], " ", 
   RowBox[{"(", 
    RowBox[{
     FractionBox[
      RowBox[{"5", " ", "\[ImaginaryI]", " ", 
       SqrtBox["2"]}], 
      SuperscriptBox[
       StyleBox["\[ScriptU]",
        FontColor->RGBColor[0, 0, 0.4]], "7"]], "-", 
     FractionBox[
      RowBox[{"15", " ", 
       SqrtBox["2"]}], 
      SuperscriptBox[
       StyleBox["\[ScriptU]",
        FontColor->RGBColor[0, 0, 0.4]], "6"]], "-", 
     FractionBox[
      RowBox[{"12", " ", "\[ImaginaryI]", " ", 
       SqrtBox["2"], " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "1"]}], 
      SuperscriptBox[
       StyleBox["\[ScriptU]",
        FontColor->RGBColor[0, 0, 0.4]], "5"]], "+", 
     FractionBox[
      RowBox[{
       RowBox[{
        RowBox[{"-", "3"}], " ", 
        SqrtBox["2"]}], "+", 
       RowBox[{"36", " ", 
        SqrtBox["2"], " ", 
        SubscriptBox[
         StyleBox["\[Zeta]",
          FontWeight->Bold,
          FontColor->GrayLevel[0.4]], "1"]}]}], 
      SuperscriptBox[
       StyleBox["\[ScriptU]",
        FontColor->RGBColor[0, 0, 0.4]], "4"]], "+", 
     FractionBox[
      RowBox[{
       FractionBox["219", 
        RowBox[{"4", " ", 
         SqrtBox["2"]}]], "-", 
       RowBox[{"63", " ", 
        SqrtBox["2"], " ", 
        SubscriptBox[
         StyleBox["\[Zeta]",
          FontWeight->Bold,
          FontColor->GrayLevel[0.4]], "1"]}], "-", 
       RowBox[{"54", " ", 
        SqrtBox["2"], " ", 
        SubsuperscriptBox[
         StyleBox["\[Zeta]",
          FontWeight->Bold,
          FontColor->GrayLevel[0.4]], "1", "2"]}], "-", 
       RowBox[{"54", " ", 
        SqrtBox["2"], " ", 
        SubscriptBox[
         StyleBox["\[Zeta]",
          FontWeight->Bold,
          FontColor->GrayLevel[0.4]], "3"]}]}], 
      SuperscriptBox[
       StyleBox["\[ScriptU]",
        FontColor->RGBColor[0, 0, 0.4]], "2"]], "+", 
     FractionBox[
      RowBox[{
       RowBox[{"-", 
        FractionBox[
         RowBox[{"93", " ", "\[ImaginaryI]"}], 
         RowBox[{"4", " ", 
          SqrtBox["2"]}]]}], "+", 
       RowBox[{"15", " ", "\[ImaginaryI]", " ", 
        SqrtBox["2"], " ", 
        SubscriptBox[
         StyleBox["\[Zeta]",
          FontWeight->Bold,
          FontColor->GrayLevel[0.4]], "1"]}], "+", 
       RowBox[{"18", " ", "\[ImaginaryI]", " ", 
        SqrtBox["2"], " ", 
        SubsuperscriptBox[
         StyleBox["\[Zeta]",
          FontWeight->Bold,
          FontColor->GrayLevel[0.4]], "1", "2"]}], "+", 
       RowBox[{"30", " ", "\[ImaginaryI]", " ", 
        SqrtBox["2"], " ", 
        SubscriptBox[
         StyleBox["\[Zeta]",
          FontWeight->Bold,
          FontColor->GrayLevel[0.4]], "3"]}]}], 
      SuperscriptBox[
       StyleBox["\[ScriptU]",
        FontColor->RGBColor[0, 0, 0.4]], "3"]], "+", 
     FractionBox[
      RowBox[{
       FractionBox[
        RowBox[{"2241", " ", "\[ImaginaryI]"}], 
        RowBox[{"8", " ", 
         SqrtBox["2"]}]], "+", 
       FractionBox[
        RowBox[{"219", " ", "\[ImaginaryI]", " ", 
         SubscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "1"]}], 
        RowBox[{"2", " ", 
         SqrtBox["2"]}]], "-", 
       RowBox[{"63", " ", "\[ImaginaryI]", " ", 
        SqrtBox["2"], " ", 
        SubsuperscriptBox[
         StyleBox["\[Zeta]",
          FontWeight->Bold,
          FontColor->GrayLevel[0.4]], "1", "2"]}], "-", 
       RowBox[{"36", " ", "\[ImaginaryI]", " ", 
        SqrtBox["2"], " ", 
        SubsuperscriptBox[
         StyleBox["\[Zeta]",
          FontWeight->Bold,
          FontColor->GrayLevel[0.4]], "1", "3"]}], "+", 
       RowBox[{"9", " ", "\[ImaginaryI]", " ", 
        SqrtBox["2"], " ", 
        SubscriptBox[
         StyleBox["\[Zeta]",
          FontWeight->Bold,
          FontColor->GrayLevel[0.4]], "3"]}], "-", 
       RowBox[{"108", " ", "\[ImaginaryI]", " ", 
        SqrtBox["2"], " ", 
        SubscriptBox[
         StyleBox["\[Zeta]",
          FontWeight->Bold,
          FontColor->GrayLevel[0.4]], "1"], " ", 
        SubscriptBox[
         StyleBox["\[Zeta]",
          FontWeight->Bold,
          FontColor->GrayLevel[0.4]], "3"]}], "-", 
       RowBox[{"120", " ", "\[ImaginaryI]", " ", 
        SqrtBox["2"], " ", 
        SubscriptBox[
         StyleBox["\[Zeta]",
          FontWeight->Bold,
          FontColor->GrayLevel[0.4]], "5"]}]}], 
      StyleBox["\[ScriptU]",
       FontColor->RGBColor[0, 0, 0.4]]], "+", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", 
         FractionBox[
          RowBox[{"12", " ", 
           SqrtBox["2"]}], 
          SuperscriptBox[
           StyleBox["\[ScriptU]",
            FontColor->RGBColor[0, 0, 0.4]], "5"]]}], "-", 
        FractionBox[
         RowBox[{"36", " ", "\[ImaginaryI]", " ", 
          SqrtBox["2"]}], 
         SuperscriptBox[
          StyleBox["\[ScriptU]",
           FontColor->RGBColor[0, 0, 0.4]], "4"]], "+", 
        FractionBox[
         RowBox[{
          RowBox[{"63", " ", "\[ImaginaryI]", " ", 
           SqrtBox["2"]}], "+", 
          RowBox[{"108", " ", "\[ImaginaryI]", " ", 
           SqrtBox["2"], " ", 
           SubscriptBox[
            StyleBox["\[Zeta]",
             FontWeight->Bold,
             FontColor->GrayLevel[0.4]], "1"]}]}], 
         SuperscriptBox[
          StyleBox["\[ScriptU]",
           FontColor->RGBColor[0, 0, 0.4]], "2"]], "+", 
        FractionBox[
         RowBox[{
          RowBox[{"15", " ", 
           SqrtBox["2"]}], "+", 
          RowBox[{"36", " ", 
           SqrtBox["2"], " ", 
           SubscriptBox[
            StyleBox["\[Zeta]",
             FontWeight->Bold,
             FontColor->GrayLevel[0.4]], "1"]}]}], 
         SuperscriptBox[
          StyleBox["\[ScriptU]",
           FontColor->RGBColor[0, 0, 0.4]], "3"]], "+", 
        FractionBox[
         RowBox[{
          FractionBox["219", 
           RowBox[{"2", " ", 
            SqrtBox["2"]}]], "-", 
          RowBox[{"126", " ", 
           SqrtBox["2"], " ", 
           SubscriptBox[
            StyleBox["\[Zeta]",
             FontWeight->Bold,
             FontColor->GrayLevel[0.4]], "1"]}], "-", 
          RowBox[{"108", " ", 
           SqrtBox["2"], " ", 
           SubsuperscriptBox[
            StyleBox["\[Zeta]",
             FontWeight->Bold,
             FontColor->GrayLevel[0.4]], "1", "2"]}], "-", 
          RowBox[{"108", " ", 
           SqrtBox["2"], " ", 
           SubscriptBox[
            StyleBox["\[Zeta]",
             FontWeight->Bold,
             FontColor->GrayLevel[0.4]], "3"]}]}], 
         StyleBox["\[ScriptU]",
          FontColor->RGBColor[0, 0, 0.4]]]}], ")"}], " ", 
      SubsuperscriptBox[
       StyleBox["\[Eta]",
        FontWeight->Bold,
        FontColor->RGBColor[0.8, 0, 0]], "1", 
       RowBox[{"[", "2", "]"}]]}], "+", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", 
         FractionBox[
          RowBox[{"18", " ", "\[ImaginaryI]", " ", 
           SqrtBox["2"]}], 
          SuperscriptBox[
           StyleBox["\[ScriptU]",
            FontColor->RGBColor[0, 0, 0.4]], "3"]]}], "+", 
        FractionBox[
         RowBox[{"54", " ", 
          SqrtBox["2"]}], 
         SuperscriptBox[
          StyleBox["\[ScriptU]",
           FontColor->RGBColor[0, 0, 0.4]], "2"]], "+", 
        FractionBox[
         RowBox[{
          RowBox[{"63", " ", "\[ImaginaryI]", " ", 
           SqrtBox["2"]}], "+", 
          RowBox[{"108", " ", "\[ImaginaryI]", " ", 
           SqrtBox["2"], " ", 
           SubscriptBox[
            StyleBox["\[Zeta]",
             FontWeight->Bold,
             FontColor->GrayLevel[0.4]], "1"]}]}], 
         StyleBox["\[ScriptU]",
          FontColor->RGBColor[0, 0, 0.4]]]}], ")"}], " ", 
      SubsuperscriptBox[
       StyleBox["\[Eta]",
        FontWeight->Bold,
        FontColor->RGBColor[0.8, 0, 0]], "2", 
       RowBox[{"[", "2", "]"}]]}], "+", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", 
         FractionBox[
          RowBox[{"6", " ", 
           SqrtBox["2"]}], 
          SuperscriptBox[
           StyleBox["\[ScriptU]",
            FontColor->RGBColor[0, 0, 0.4]], "3"]]}], "-", 
        FractionBox[
         RowBox[{"18", " ", "\[ImaginaryI]", " ", 
          SqrtBox["2"]}], 
         SuperscriptBox[
          StyleBox["\[ScriptU]",
           FontColor->RGBColor[0, 0, 0.4]], "2"]], "+", 
        FractionBox[
         RowBox[{
          RowBox[{"33", " ", 
           SqrtBox["2"]}], "+", 
          RowBox[{"36", " ", 
           SqrtBox["2"], " ", 
           SubscriptBox[
            StyleBox["\[Zeta]",
             FontWeight->Bold,
             FontColor->GrayLevel[0.4]], "1"]}]}], 
         StyleBox["\[ScriptU]",
          FontColor->RGBColor[0, 0, 0.4]]]}], ")"}], " ", 
      SubsuperscriptBox[
       StyleBox["\[Eta]",
        FontWeight->Bold,
        FontColor->RGBColor[0.8, 0, 0]], "3", 
       RowBox[{"[", "2", "]"}]]}], "-", 
     FractionBox[
      RowBox[{"36", " ", "\[ImaginaryI]", " ", 
       SqrtBox["2"], " ", 
       SubsuperscriptBox[
        StyleBox["\[Eta]",
         FontWeight->Bold,
         FontColor->RGBColor[0.8, 0, 0]], "4", 
        RowBox[{"[", "2", "]"}]]}], 
      StyleBox["\[ScriptU]",
       FontColor->RGBColor[0, 0, 0.4]]], "-", 
     FractionBox[
      RowBox[{"12", " ", 
       SqrtBox["2"], " ", 
       SubsuperscriptBox[
        StyleBox["\[Eta]",
         FontWeight->Bold,
         FontColor->RGBColor[0.8, 0, 0]], "5", 
        RowBox[{"[", "2", "]"}]]}], 
      StyleBox["\[ScriptU]",
       FontColor->RGBColor[0, 0, 0.4]]], "+", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", 
         FractionBox[
          RowBox[{"36", " ", "\[ImaginaryI]", " ", 
           SqrtBox["2"]}], 
          SuperscriptBox[
           StyleBox["\[ScriptU]",
            FontColor->RGBColor[0, 0, 0.4]], "3"]]}], "+", 
        FractionBox[
         RowBox[{"108", " ", 
          SqrtBox["2"]}], 
         SuperscriptBox[
          StyleBox["\[ScriptU]",
           FontColor->RGBColor[0, 0, 0.4]], "2"]], "+", 
        FractionBox[
         RowBox[{
          RowBox[{"126", " ", "\[ImaginaryI]", " ", 
           SqrtBox["2"]}], "+", 
          RowBox[{"216", " ", "\[ImaginaryI]", " ", 
           SqrtBox["2"], " ", 
           SubscriptBox[
            StyleBox["\[Zeta]",
             FontWeight->Bold,
             FontColor->GrayLevel[0.4]], "1"]}]}], 
         StyleBox["\[ScriptU]",
          FontColor->RGBColor[0, 0, 0.4]]]}], ")"}], " ", 
      SubsuperscriptBox[
       StyleBox["\[Eta]",
        FontWeight->Bold,
        FontColor->RGBColor[0.8, 0, 0]], 
       RowBox[{"1", ",", "1"}], 
       RowBox[{"[", "2", "]"}]]}], "+", 
     FractionBox[
      RowBox[{"108", " ", 
       SqrtBox["2"], " ", 
       SubsuperscriptBox[
        StyleBox["\[Eta]",
         FontWeight->Bold,
         FontColor->RGBColor[0.8, 0, 0]], 
        RowBox[{"1", ",", "2"}], 
        RowBox[{"[", "2", "]"}]]}], 
      StyleBox["\[ScriptU]",
       FontColor->RGBColor[0, 0, 0.4]]], "-", 
     FractionBox[
      RowBox[{"36", " ", "\[ImaginaryI]", " ", 
       SqrtBox["2"], " ", 
       SubsuperscriptBox[
        StyleBox["\[Eta]",
         FontWeight->Bold,
         FontColor->RGBColor[0.8, 0, 0]], 
        RowBox[{"1", ",", "3"}], 
        RowBox[{"[", "2", "]"}]]}], 
      StyleBox["\[ScriptU]",
       FontColor->RGBColor[0, 0, 0.4]]], "+", 
     FractionBox[
      RowBox[{"108", " ", 
       SqrtBox["2"], " ", 
       SubsuperscriptBox[
        StyleBox["\[Eta]",
         FontWeight->Bold,
         FontColor->RGBColor[0.8, 0, 0]], 
        RowBox[{"2", ",", "1"}], 
        RowBox[{"[", "2", "]"}]]}], 
      StyleBox["\[ScriptU]",
       FontColor->RGBColor[0, 0, 0.4]]], "-", 
     FractionBox[
      RowBox[{"36", " ", "\[ImaginaryI]", " ", 
       SqrtBox["2"], " ", 
       SubsuperscriptBox[
        StyleBox["\[Eta]",
         FontWeight->Bold,
         FontColor->RGBColor[0.8, 0, 0]], 
        RowBox[{"3", ",", "1"}], 
        RowBox[{"[", "2", "]"}]]}], 
      StyleBox["\[ScriptU]",
       FontColor->RGBColor[0, 0, 0.4]]], "+", 
     FractionBox[
      RowBox[{"216", " ", 
       SqrtBox["2"], " ", 
       SubsuperscriptBox[
        StyleBox["\[Eta]",
         FontWeight->Bold,
         FontColor->RGBColor[0.8, 0, 0]], 
        RowBox[{"1", ",", "1", ",", "1"}], 
        RowBox[{"[", "2", "]"}]]}], 
      StyleBox["\[ScriptU]",
       FontColor->RGBColor[0, 0, 0.4]]]}], ")"}]}], "+", 
  RowBox[{
   SuperscriptBox["g", "10"], " ", 
   RowBox[{"(", 
    RowBox[{
     FractionBox[
      RowBox[{"14", " ", "\[ImaginaryI]", " ", 
       SqrtBox["2"]}], 
      SuperscriptBox[
       StyleBox["\[ScriptU]",
        FontColor->RGBColor[0, 0, 0.4]], "9"]], "-", 
     FractionBox[
      RowBox[{"42", " ", 
       SqrtBox["2"]}], 
      SuperscriptBox[
       StyleBox["\[ScriptU]",
        FontColor->RGBColor[0, 0, 0.4]], "8"]], "+", 
     FractionBox[
      RowBox[{
       RowBox[{"-", 
        FractionBox[
         RowBox[{"9", " ", "\[ImaginaryI]"}], 
         SqrtBox["2"]]}], "-", 
       RowBox[{"30", " ", "\[ImaginaryI]", " ", 
        SqrtBox["2"], " ", 
        SubscriptBox[
         StyleBox["\[Zeta]",
          FontWeight->Bold,
          FontColor->GrayLevel[0.4]], "1"]}]}], 
      SuperscriptBox[
       StyleBox["\[ScriptU]",
        FontColor->RGBColor[0, 0, 0.4]], "7"]], "+", 
     FractionBox[
      RowBox[{
       RowBox[{"-", 
        FractionBox["15", 
         SqrtBox["2"]]}], "+", 
       RowBox[{"90", " ", 
        SqrtBox["2"], " ", 
        SubscriptBox[
         StyleBox["\[Zeta]",
          FontWeight->Bold,
          FontColor->GrayLevel[0.4]], "1"]}]}], 
      SuperscriptBox[
       StyleBox["\[ScriptU]",
        FontColor->RGBColor[0, 0, 0.4]], "6"]], "+", 
     FractionBox[
      RowBox[{
       FractionBox["219", 
        RowBox[{"2", " ", 
         SqrtBox["2"]}]], "-", 
       RowBox[{"126", " ", 
        SqrtBox["2"], " ", 
        SubscriptBox[
         StyleBox["\[Zeta]",
          FontWeight->Bold,
          FontColor->GrayLevel[0.4]], "1"]}], "-", 
       RowBox[{"108", " ", 
        SqrtBox["2"], " ", 
        SubsuperscriptBox[
         StyleBox["\[Zeta]",
          FontWeight->Bold,
          FontColor->GrayLevel[0.4]], "1", "2"]}], "-", 
       RowBox[{"144", " ", 
        SqrtBox["2"], " ", 
        SubscriptBox[
         StyleBox["\[Zeta]",
          FontWeight->Bold,
          FontColor->GrayLevel[0.4]], "3"]}]}], 
      SuperscriptBox[
       StyleBox["\[ScriptU]",
        FontColor->RGBColor[0, 0, 0.4]], "4"]], "+", 
     FractionBox[
      RowBox[{
       RowBox[{"-", 
        FractionBox[
         RowBox[{"63", " ", "\[ImaginaryI]"}], 
         RowBox[{"2", " ", 
          SqrtBox["2"]}]]}], "+", 
       RowBox[{"48", " ", "\[ImaginaryI]", " ", 
        SqrtBox["2"], " ", 
        SubscriptBox[
         StyleBox["\[Zeta]",
          FontWeight->Bold,
          FontColor->GrayLevel[0.4]], "1"]}], "+", 
       RowBox[{"36", " ", "\[ImaginaryI]", " ", 
        SqrtBox["2"], " ", 
        SubsuperscriptBox[
         StyleBox["\[Zeta]",
          FontWeight->Bold,
          FontColor->GrayLevel[0.4]], "1", "2"]}], "+", 
       RowBox[{"72", " ", "\[ImaginaryI]", " ", 
        SqrtBox["2"], " ", 
        SubscriptBox[
         StyleBox["\[Zeta]",
          FontWeight->Bold,
          FontColor->GrayLevel[0.4]], "3"]}]}], 
      SuperscriptBox[
       StyleBox["\[ScriptU]",
        FontColor->RGBColor[0, 0, 0.4]], "5"]], "+", 
     FractionBox[
      RowBox[{
       FractionBox[
        RowBox[{"1743", " ", "\[ImaginaryI]"}], 
        RowBox[{"8", " ", 
         SqrtBox["2"]}]], "-", 
       FractionBox[
        RowBox[{"249", " ", "\[ImaginaryI]", " ", 
         SubscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "1"]}], 
        RowBox[{"2", " ", 
         SqrtBox["2"]}]], "-", 
       RowBox[{"117", " ", "\[ImaginaryI]", " ", 
        SqrtBox["2"], " ", 
        SubsuperscriptBox[
         StyleBox["\[Zeta]",
          FontWeight->Bold,
          FontColor->GrayLevel[0.4]], "1", "2"]}], "-", 
       RowBox[{"36", " ", "\[ImaginaryI]", " ", 
        SqrtBox["2"], " ", 
        SubsuperscriptBox[
         StyleBox["\[Zeta]",
          FontWeight->Bold,
          FontColor->GrayLevel[0.4]], "1", "3"]}], "-", 
       RowBox[{"39", " ", "\[ImaginaryI]", " ", 
        SqrtBox["2"], " ", 
        SubscriptBox[
         StyleBox["\[Zeta]",
          FontWeight->Bold,
          FontColor->GrayLevel[0.4]], "3"]}], "-", 
       RowBox[{"180", " ", "\[ImaginaryI]", " ", 
        SqrtBox["2"], " ", 
        SubscriptBox[
         StyleBox["\[Zeta]",
          FontWeight->Bold,
          FontColor->GrayLevel[0.4]], "1"], " ", 
        SubscriptBox[
         StyleBox["\[Zeta]",
          FontWeight->Bold,
          FontColor->GrayLevel[0.4]], "3"]}], "-", 
       RowBox[{"240", " ", "\[ImaginaryI]", " ", 
        SqrtBox["2"], " ", 
        SubscriptBox[
         StyleBox["\[Zeta]",
          FontWeight->Bold,
          FontColor->GrayLevel[0.4]], "5"]}]}], 
      SuperscriptBox[
       StyleBox["\[ScriptU]",
        FontColor->RGBColor[0, 0, 0.4]], "3"]], "+", 
     FractionBox[
      RowBox[{
       RowBox[{"-", 
        FractionBox["5163", 
         RowBox[{"8", " ", 
          SqrtBox["2"]}]]}], "+", 
       FractionBox[
        RowBox[{"1215", " ", 
         SubscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "1"]}], 
        RowBox[{"2", " ", 
         SqrtBox["2"]}]], "+", 
       RowBox[{"405", " ", 
        SqrtBox["2"], " ", 
        SubsuperscriptBox[
         StyleBox["\[Zeta]",
          FontWeight->Bold,
          FontColor->GrayLevel[0.4]], "1", "2"]}], "+", 
       RowBox[{"108", " ", 
        SqrtBox["2"], " ", 
        SubsuperscriptBox[
         StyleBox["\[Zeta]",
          FontWeight->Bold,
          FontColor->GrayLevel[0.4]], "1", "3"]}], "+", 
       RowBox[{"261", " ", 
        SqrtBox["2"], " ", 
        SubscriptBox[
         StyleBox["\[Zeta]",
          FontWeight->Bold,
          FontColor->GrayLevel[0.4]], "3"]}], "+", 
       RowBox[{"324", " ", 
        SqrtBox["2"], " ", 
        SubscriptBox[
         StyleBox["\[Zeta]",
          FontWeight->Bold,
          FontColor->GrayLevel[0.4]], "1"], " ", 
        SubscriptBox[
         StyleBox["\[Zeta]",
          FontWeight->Bold,
          FontColor->GrayLevel[0.4]], "3"]}], "+", 
       RowBox[{"360", " ", 
        SqrtBox["2"], " ", 
        SubscriptBox[
         StyleBox["\[Zeta]",
          FontWeight->Bold,
          FontColor->GrayLevel[0.4]], "5"]}]}], 
      SuperscriptBox[
       StyleBox["\[ScriptU]",
        FontColor->RGBColor[0, 0, 0.4]], "2"]], "+", 
     RowBox[{
      FractionBox["1", 
       StyleBox["\[ScriptU]",
        FontColor->RGBColor[0, 0, 0.4]]], 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", 
         FractionBox[
          RowBox[{"156501", " ", "\[ImaginaryI]"}], 
          RowBox[{"64", " ", 
           SqrtBox["2"]}]]}], "-", 
        FractionBox[
         RowBox[{"5163", " ", "\[ImaginaryI]", " ", 
          SubscriptBox[
           StyleBox["\[Zeta]",
            FontWeight->Bold,
            FontColor->GrayLevel[0.4]], "1"]}], 
         RowBox[{"4", " ", 
          SqrtBox["2"]}]], "+", 
        FractionBox[
         RowBox[{"1215", " ", "\[ImaginaryI]", " ", 
          SubsuperscriptBox[
           StyleBox["\[Zeta]",
            FontWeight->Bold,
            FontColor->GrayLevel[0.4]], "1", "2"]}], 
         RowBox[{"2", " ", 
          SqrtBox["2"]}]], "+", 
        RowBox[{"270", " ", "\[ImaginaryI]", " ", 
         SqrtBox["2"], " ", 
         SubsuperscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "1", "3"]}], "+", 
        RowBox[{"54", " ", "\[ImaginaryI]", " ", 
         SqrtBox["2"], " ", 
         SubsuperscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "1", "4"]}], "-", 
        FractionBox[
         RowBox[{"1017", " ", "\[ImaginaryI]", " ", 
          SubscriptBox[
           StyleBox["\[Zeta]",
            FontWeight->Bold,
            FontColor->GrayLevel[0.4]], "3"]}], 
         RowBox[{"2", " ", 
          SqrtBox["2"]}]], "+", 
        RowBox[{"522", " ", "\[ImaginaryI]", " ", 
         SqrtBox["2"], " ", 
         SubscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "1"], " ", 
         SubscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "3"]}], "+", 
        RowBox[{"324", " ", "\[ImaginaryI]", " ", 
         SqrtBox["2"], " ", 
         SubsuperscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "1", "2"], " ", 
         SubscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "3"]}], "+", 
        RowBox[{"162", " ", "\[ImaginaryI]", " ", 
         SqrtBox["2"], " ", 
         SubsuperscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "3", "2"]}], "-", 
        RowBox[{"60", " ", "\[ImaginaryI]", " ", 
         SqrtBox["2"], " ", 
         SubscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "5"]}], "+", 
        RowBox[{"720", " ", "\[ImaginaryI]", " ", 
         SqrtBox["2"], " ", 
         SubscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "1"], " ", 
         SubscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "5"]}], "+", 
        RowBox[{"1050", " ", "\[ImaginaryI]", " ", 
         SqrtBox["2"], " ", 
         SubscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "7"]}]}], ")"}]}], "+", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", 
         FractionBox[
          RowBox[{"30", " ", 
           SqrtBox["2"]}], 
          SuperscriptBox[
           StyleBox["\[ScriptU]",
            FontColor->RGBColor[0, 0, 0.4]], "7"]]}], "-", 
        FractionBox[
         RowBox[{"90", " ", "\[ImaginaryI]", " ", 
          SqrtBox["2"]}], 
         SuperscriptBox[
          StyleBox["\[ScriptU]",
           FontColor->RGBColor[0, 0, 0.4]], "6"]], "+", 
        FractionBox[
         RowBox[{
          RowBox[{"126", " ", "\[ImaginaryI]", " ", 
           SqrtBox["2"]}], "+", 
          RowBox[{"216", " ", "\[ImaginaryI]", " ", 
           SqrtBox["2"], " ", 
           SubscriptBox[
            StyleBox["\[Zeta]",
             FontWeight->Bold,
             FontColor->GrayLevel[0.4]], "1"]}]}], 
         SuperscriptBox[
          StyleBox["\[ScriptU]",
           FontColor->RGBColor[0, 0, 0.4]], "4"]], "+", 
        FractionBox[
         RowBox[{
          RowBox[{"48", " ", 
           SqrtBox["2"]}], "+", 
          RowBox[{"72", " ", 
           SqrtBox["2"], " ", 
           SubscriptBox[
            StyleBox["\[Zeta]",
             FontWeight->Bold,
             FontColor->GrayLevel[0.4]], "1"]}]}], 
         SuperscriptBox[
          StyleBox["\[ScriptU]",
           FontColor->RGBColor[0, 0, 0.4]], "5"]], "+", 
        FractionBox[
         RowBox[{
          RowBox[{"-", 
           FractionBox["249", 
            RowBox[{"2", " ", 
             SqrtBox["2"]}]]}], "-", 
          RowBox[{"234", " ", 
           SqrtBox["2"], " ", 
           SubscriptBox[
            StyleBox["\[Zeta]",
             FontWeight->Bold,
             FontColor->GrayLevel[0.4]], "1"]}], "-", 
          RowBox[{"108", " ", 
           SqrtBox["2"], " ", 
           SubsuperscriptBox[
            StyleBox["\[Zeta]",
             FontWeight->Bold,
             FontColor->GrayLevel[0.4]], "1", "2"]}], "-", 
          RowBox[{"180", " ", 
           SqrtBox["2"], " ", 
           SubscriptBox[
            StyleBox["\[Zeta]",
             FontWeight->Bold,
             FontColor->GrayLevel[0.4]], "3"]}]}], 
         SuperscriptBox[
          StyleBox["\[ScriptU]",
           FontColor->RGBColor[0, 0, 0.4]], "3"]], "+", 
        FractionBox[
         RowBox[{
          RowBox[{"-", 
           FractionBox[
            RowBox[{"1215", " ", "\[ImaginaryI]"}], 
            RowBox[{"2", " ", 
             SqrtBox["2"]}]]}], "-", 
          RowBox[{"810", " ", "\[ImaginaryI]", " ", 
           SqrtBox["2"], " ", 
           SubscriptBox[
            StyleBox["\[Zeta]",
             FontWeight->Bold,
             FontColor->GrayLevel[0.4]], "1"]}], "-", 
          RowBox[{"324", " ", "\[ImaginaryI]", " ", 
           SqrtBox["2"], " ", 
           SubsuperscriptBox[
            StyleBox["\[Zeta]",
             FontWeight->Bold,
             FontColor->GrayLevel[0.4]], "1", "2"]}], "-", 
          RowBox[{"324", " ", "\[ImaginaryI]", " ", 
           SqrtBox["2"], " ", 
           SubscriptBox[
            StyleBox["\[Zeta]",
             FontWeight->Bold,
             FontColor->GrayLevel[0.4]], "3"]}]}], 
         SuperscriptBox[
          StyleBox["\[ScriptU]",
           FontColor->RGBColor[0, 0, 0.4]], "2"]], "+", 
        FractionBox[
         RowBox[{
          RowBox[{"-", 
           FractionBox["5163", 
            RowBox[{"4", " ", 
             SqrtBox["2"]}]]}], "+", 
          FractionBox[
           RowBox[{"1215", " ", 
            SubscriptBox[
             StyleBox["\[Zeta]",
              FontWeight->Bold,
              FontColor->GrayLevel[0.4]], "1"]}], 
           SqrtBox["2"]], "+", 
          RowBox[{"810", " ", 
           SqrtBox["2"], " ", 
           SubsuperscriptBox[
            StyleBox["\[Zeta]",
             FontWeight->Bold,
             FontColor->GrayLevel[0.4]], "1", "2"]}], "+", 
          RowBox[{"216", " ", 
           SqrtBox["2"], " ", 
           SubsuperscriptBox[
            StyleBox["\[Zeta]",
             FontWeight->Bold,
             FontColor->GrayLevel[0.4]], "1", "3"]}], "+", 
          RowBox[{"522", " ", 
           SqrtBox["2"], " ", 
           SubscriptBox[
            StyleBox["\[Zeta]",
             FontWeight->Bold,
             FontColor->GrayLevel[0.4]], "3"]}], "+", 
          RowBox[{"648", " ", 
           SqrtBox["2"], " ", 
           SubscriptBox[
            StyleBox["\[Zeta]",
             FontWeight->Bold,
             FontColor->GrayLevel[0.4]], "1"], " ", 
           SubscriptBox[
            StyleBox["\[Zeta]",
             FontWeight->Bold,
             FontColor->GrayLevel[0.4]], "3"]}], "+", 
          RowBox[{"720", " ", 
           SqrtBox["2"], " ", 
           SubscriptBox[
            StyleBox["\[Zeta]",
             FontWeight->Bold,
             FontColor->GrayLevel[0.4]], "5"]}]}], 
         StyleBox["\[ScriptU]",
          FontColor->RGBColor[0, 0, 0.4]]]}], ")"}], " ", 
      SubsuperscriptBox[
       StyleBox["\[Eta]",
        FontWeight->Bold,
        FontColor->RGBColor[0.8, 0, 0]], "1", 
       RowBox[{"[", "2", "]"}]]}], "+", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", 
         FractionBox[
          RowBox[{"36", " ", "\[ImaginaryI]", " ", 
           SqrtBox["2"]}], 
          SuperscriptBox[
           StyleBox["\[ScriptU]",
            FontColor->RGBColor[0, 0, 0.4]], "5"]]}], "+", 
        FractionBox[
         RowBox[{"108", " ", 
          SqrtBox["2"]}], 
         SuperscriptBox[
          StyleBox["\[ScriptU]",
           FontColor->RGBColor[0, 0, 0.4]], "4"]], "+", 
        FractionBox[
         RowBox[{
          RowBox[{
           RowBox[{"-", "405"}], " ", 
           SqrtBox["2"]}], "-", 
          RowBox[{"324", " ", 
           SqrtBox["2"], " ", 
           SubscriptBox[
            StyleBox["\[Zeta]",
             FontWeight->Bold,
             FontColor->GrayLevel[0.4]], "1"]}]}], 
         SuperscriptBox[
          StyleBox["\[ScriptU]",
           FontColor->RGBColor[0, 0, 0.4]], "2"]], "+", 
        FractionBox[
         RowBox[{
          RowBox[{"117", " ", "\[ImaginaryI]", " ", 
           SqrtBox["2"]}], "+", 
          RowBox[{"108", " ", "\[ImaginaryI]", " ", 
           SqrtBox["2"], " ", 
           SubscriptBox[
            StyleBox["\[Zeta]",
             FontWeight->Bold,
             FontColor->GrayLevel[0.4]], "1"]}]}], 
         SuperscriptBox[
          StyleBox["\[ScriptU]",
           FontColor->RGBColor[0, 0, 0.4]], "3"]], "+", 
        FractionBox[
         RowBox[{
          RowBox[{"-", 
           FractionBox[
            RowBox[{"1215", " ", "\[ImaginaryI]"}], 
            RowBox[{"2", " ", 
             SqrtBox["2"]}]]}], "-", 
          RowBox[{"810", " ", "\[ImaginaryI]", " ", 
           SqrtBox["2"], " ", 
           SubscriptBox[
            StyleBox["\[Zeta]",
             FontWeight->Bold,
             FontColor->GrayLevel[0.4]], "1"]}], "-", 
          RowBox[{"324", " ", "\[ImaginaryI]", " ", 
           SqrtBox["2"], " ", 
           SubsuperscriptBox[
            StyleBox["\[Zeta]",
             FontWeight->Bold,
             FontColor->GrayLevel[0.4]], "1", "2"]}], "-", 
          RowBox[{"324", " ", "\[ImaginaryI]", " ", 
           SqrtBox["2"], " ", 
           SubscriptBox[
            StyleBox["\[Zeta]",
             FontWeight->Bold,
             FontColor->GrayLevel[0.4]], "3"]}]}], 
         StyleBox["\[ScriptU]",
          FontColor->RGBColor[0, 0, 0.4]]]}], ")"}], " ", 
      SubsuperscriptBox[
       StyleBox["\[Eta]",
        FontWeight->Bold,
        FontColor->RGBColor[0.8, 0, 0]], "2", 
       RowBox[{"[", "2", "]"}]]}], "+", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", 
         FractionBox[
          RowBox[{"12", " ", 
           SqrtBox["2"]}], 
          SuperscriptBox[
           StyleBox["\[ScriptU]",
            FontColor->RGBColor[0, 0, 0.4]], "5"]]}], "-", 
        FractionBox[
         RowBox[{"36", " ", "\[ImaginaryI]", " ", 
          SqrtBox["2"]}], 
         SuperscriptBox[
          StyleBox["\[ScriptU]",
           FontColor->RGBColor[0, 0, 0.4]], "4"]], "+", 
        FractionBox[
         RowBox[{
          RowBox[{"171", " ", "\[ImaginaryI]", " ", 
           SqrtBox["2"]}], "+", 
          RowBox[{"108", " ", "\[ImaginaryI]", " ", 
           SqrtBox["2"], " ", 
           SubscriptBox[
            StyleBox["\[Zeta]",
             FontWeight->Bold,
             FontColor->GrayLevel[0.4]], "1"]}]}], 
         SuperscriptBox[
          StyleBox["\[ScriptU]",
           FontColor->RGBColor[0, 0, 0.4]], "2"]], "+", 
        FractionBox[
         RowBox[{
          RowBox[{"51", " ", 
           SqrtBox["2"]}], "+", 
          RowBox[{"36", " ", 
           SqrtBox["2"], " ", 
           SubscriptBox[
            StyleBox["\[Zeta]",
             FontWeight->Bold,
             FontColor->GrayLevel[0.4]], "1"]}]}], 
         SuperscriptBox[
          StyleBox["\[ScriptU]",
           FontColor->RGBColor[0, 0, 0.4]], "3"]], "+", 
        FractionBox[
         RowBox[{
          RowBox[{"-", 
           FractionBox["933", 
            RowBox[{"2", " ", 
             SqrtBox["2"]}]]}], "-", 
          RowBox[{"342", " ", 
           SqrtBox["2"], " ", 
           SubscriptBox[
            StyleBox["\[Zeta]",
             FontWeight->Bold,
             FontColor->GrayLevel[0.4]], "1"]}], "-", 
          RowBox[{"108", " ", 
           SqrtBox["2"], " ", 
           SubsuperscriptBox[
            StyleBox["\[Zeta]",
             FontWeight->Bold,
             FontColor->GrayLevel[0.4]], "1", "2"]}], "-", 
          RowBox[{"108", " ", 
           SqrtBox["2"], " ", 
           SubscriptBox[
            StyleBox["\[Zeta]",
             FontWeight->Bold,
             FontColor->GrayLevel[0.4]], "3"]}]}], 
         StyleBox["\[ScriptU]",
          FontColor->RGBColor[0, 0, 0.4]]]}], ")"}], " ", 
      SubsuperscriptBox[
       StyleBox["\[Eta]",
        FontWeight->Bold,
        FontColor->RGBColor[0.8, 0, 0]], "3", 
       RowBox[{"[", "2", "]"}]]}], "+", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", 
         FractionBox[
          RowBox[{"36", " ", "\[ImaginaryI]", " ", 
           SqrtBox["2"]}], 
          SuperscriptBox[
           StyleBox["\[ScriptU]",
            FontColor->RGBColor[0, 0, 0.4]], "3"]]}], "+", 
        FractionBox[
         RowBox[{"108", " ", 
          SqrtBox["2"]}], 
         SuperscriptBox[
          StyleBox["\[ScriptU]",
           FontColor->RGBColor[0, 0, 0.4]], "2"]], "+", 
        FractionBox[
         RowBox[{
          RowBox[{"180", " ", "\[ImaginaryI]", " ", 
           SqrtBox["2"]}], "+", 
          RowBox[{"216", " ", "\[ImaginaryI]", " ", 
           SqrtBox["2"], " ", 
           SubscriptBox[
            StyleBox["\[Zeta]",
             FontWeight->Bold,
             FontColor->GrayLevel[0.4]], "1"]}]}], 
         StyleBox["\[ScriptU]",
          FontColor->RGBColor[0, 0, 0.4]]]}], ")"}], " ", 
      SubsuperscriptBox[
       StyleBox["\[Eta]",
        FontWeight->Bold,
        FontColor->RGBColor[0.8, 0, 0]], "4", 
       RowBox[{"[", "2", "]"}]]}], "+", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", 
         FractionBox[
          RowBox[{"12", " ", 
           SqrtBox["2"]}], 
          SuperscriptBox[
           StyleBox["\[ScriptU]",
            FontColor->RGBColor[0, 0, 0.4]], "3"]]}], "-", 
        FractionBox[
         RowBox[{"36", " ", "\[ImaginaryI]", " ", 
          SqrtBox["2"]}], 
         SuperscriptBox[
          StyleBox["\[ScriptU]",
           FontColor->RGBColor[0, 0, 0.4]], "2"]], "+", 
        FractionBox[
         RowBox[{
          RowBox[{"102", " ", 
           SqrtBox["2"]}], "+", 
          RowBox[{"72", " ", 
           SqrtBox["2"], " ", 
           SubscriptBox[
            StyleBox["\[Zeta]",
             FontWeight->Bold,
             FontColor->GrayLevel[0.4]], "1"]}]}], 
         StyleBox["\[ScriptU]",
          FontColor->RGBColor[0, 0, 0.4]]]}], ")"}], " ", 
      SubsuperscriptBox[
       StyleBox["\[Eta]",
        FontWeight->Bold,
        FontColor->RGBColor[0.8, 0, 0]], "5", 
       RowBox[{"[", "2", "]"}]]}], "-", 
     FractionBox[
      RowBox[{"90", " ", "\[ImaginaryI]", " ", 
       SqrtBox["2"], " ", 
       SubsuperscriptBox[
        StyleBox["\[Eta]",
         FontWeight->Bold,
         FontColor->RGBColor[0.8, 0, 0]], "6", 
        RowBox[{"[", "2", "]"}]]}], 
      StyleBox["\[ScriptU]",
       FontColor->RGBColor[0, 0, 0.4]]], "-", 
     FractionBox[
      RowBox[{"30", " ", 
       SqrtBox["2"], " ", 
       SubsuperscriptBox[
        StyleBox["\[Eta]",
         FontWeight->Bold,
         FontColor->RGBColor[0.8, 0, 0]], "7", 
        RowBox[{"[", "2", "]"}]]}], 
      StyleBox["\[ScriptU]",
       FontColor->RGBColor[0, 0, 0.4]]], "+", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", 
         FractionBox[
          RowBox[{"72", " ", "\[ImaginaryI]", " ", 
           SqrtBox["2"]}], 
          SuperscriptBox[
           StyleBox["\[ScriptU]",
            FontColor->RGBColor[0, 0, 0.4]], "5"]]}], "+", 
        FractionBox[
         RowBox[{"216", " ", 
          SqrtBox["2"]}], 
         SuperscriptBox[
          StyleBox["\[ScriptU]",
           FontColor->RGBColor[0, 0, 0.4]], "4"]], "+", 
        FractionBox[
         RowBox[{
          RowBox[{
           RowBox[{"-", "810"}], " ", 
           SqrtBox["2"]}], "-", 
          RowBox[{"648", " ", 
           SqrtBox["2"], " ", 
           SubscriptBox[
            StyleBox["\[Zeta]",
             FontWeight->Bold,
             FontColor->GrayLevel[0.4]], "1"]}]}], 
         SuperscriptBox[
          StyleBox["\[ScriptU]",
           FontColor->RGBColor[0, 0, 0.4]], "2"]], "+", 
        FractionBox[
         RowBox[{
          RowBox[{"234", " ", "\[ImaginaryI]", " ", 
           SqrtBox["2"]}], "+", 
          RowBox[{"216", " ", "\[ImaginaryI]", " ", 
           SqrtBox["2"], " ", 
           SubscriptBox[
            StyleBox["\[Zeta]",
             FontWeight->Bold,
             FontColor->GrayLevel[0.4]], "1"]}]}], 
         SuperscriptBox[
          StyleBox["\[ScriptU]",
           FontColor->RGBColor[0, 0, 0.4]], "3"]], "+", 
        FractionBox[
         RowBox[{
          RowBox[{"-", 
           FractionBox[
            RowBox[{"1215", " ", "\[ImaginaryI]"}], 
            SqrtBox["2"]]}], "-", 
          RowBox[{"1620", " ", "\[ImaginaryI]", " ", 
           SqrtBox["2"], " ", 
           SubscriptBox[
            StyleBox["\[Zeta]",
             FontWeight->Bold,
             FontColor->GrayLevel[0.4]], "1"]}], "-", 
          RowBox[{"648", " ", "\[ImaginaryI]", " ", 
           SqrtBox["2"], " ", 
           SubsuperscriptBox[
            StyleBox["\[Zeta]",
             FontWeight->Bold,
             FontColor->GrayLevel[0.4]], "1", "2"]}], "-", 
          RowBox[{"648", " ", "\[ImaginaryI]", " ", 
           SqrtBox["2"], " ", 
           SubscriptBox[
            StyleBox["\[Zeta]",
             FontWeight->Bold,
             FontColor->GrayLevel[0.4]], "3"]}]}], 
         StyleBox["\[ScriptU]",
          FontColor->RGBColor[0, 0, 0.4]]]}], ")"}], " ", 
      SubsuperscriptBox[
       StyleBox["\[Eta]",
        FontWeight->Bold,
        FontColor->RGBColor[0.8, 0, 0]], 
       RowBox[{"1", ",", "1"}], 
       RowBox[{"[", "2", "]"}]]}], "+", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        FractionBox[
         RowBox[{"108", " ", 
          SqrtBox["2"]}], 
         SuperscriptBox[
          StyleBox["\[ScriptU]",
           FontColor->RGBColor[0, 0, 0.4]], "3"]], "+", 
        FractionBox[
         RowBox[{"324", " ", "\[ImaginaryI]", " ", 
          SqrtBox["2"]}], 
         SuperscriptBox[
          StyleBox["\[ScriptU]",
           FontColor->RGBColor[0, 0, 0.4]], "2"]], "+", 
        FractionBox[
         RowBox[{
          RowBox[{
           RowBox[{"-", "810"}], " ", 
           SqrtBox["2"]}], "-", 
          RowBox[{"648", " ", 
           SqrtBox["2"], " ", 
           SubscriptBox[
            StyleBox["\[Zeta]",
             FontWeight->Bold,
             FontColor->GrayLevel[0.4]], "1"]}]}], 
         StyleBox["\[ScriptU]",
          FontColor->RGBColor[0, 0, 0.4]]]}], ")"}], " ", 
      SubsuperscriptBox[
       StyleBox["\[Eta]",
        FontWeight->Bold,
        FontColor->RGBColor[0.8, 0, 0]], 
       RowBox[{"1", ",", "2"}], 
       RowBox[{"[", "2", "]"}]]}], "+", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", 
         FractionBox[
          RowBox[{"36", " ", "\[ImaginaryI]", " ", 
           SqrtBox["2"]}], 
          SuperscriptBox[
           StyleBox["\[ScriptU]",
            FontColor->RGBColor[0, 0, 0.4]], "3"]]}], "+", 
        FractionBox[
         RowBox[{"108", " ", 
          SqrtBox["2"]}], 
         SuperscriptBox[
          StyleBox["\[ScriptU]",
           FontColor->RGBColor[0, 0, 0.4]], "2"]], "+", 
        FractionBox[
         RowBox[{
          RowBox[{"342", " ", "\[ImaginaryI]", " ", 
           SqrtBox["2"]}], "+", 
          RowBox[{"216", " ", "\[ImaginaryI]", " ", 
           SqrtBox["2"], " ", 
           SubscriptBox[
            StyleBox["\[Zeta]",
             FontWeight->Bold,
             FontColor->GrayLevel[0.4]], "1"]}]}], 
         StyleBox["\[ScriptU]",
          FontColor->RGBColor[0, 0, 0.4]]]}], ")"}], " ", 
      SubsuperscriptBox[
       StyleBox["\[Eta]",
        FontWeight->Bold,
        FontColor->RGBColor[0.8, 0, 0]], 
       RowBox[{"1", ",", "3"}], 
       RowBox[{"[", "2", "]"}]]}], "+", 
     FractionBox[
      RowBox[{"216", " ", 
       SqrtBox["2"], " ", 
       SubsuperscriptBox[
        StyleBox["\[Eta]",
         FontWeight->Bold,
         FontColor->RGBColor[0.8, 0, 0]], 
        RowBox[{"1", ",", "4"}], 
        RowBox[{"[", "2", "]"}]]}], 
      StyleBox["\[ScriptU]",
       FontColor->RGBColor[0, 0, 0.4]]], "-", 
     FractionBox[
      RowBox[{"72", " ", "\[ImaginaryI]", " ", 
       SqrtBox["2"], " ", 
       SubsuperscriptBox[
        StyleBox["\[Eta]",
         FontWeight->Bold,
         FontColor->RGBColor[0.8, 0, 0]], 
        RowBox[{"1", ",", "5"}], 
        RowBox[{"[", "2", "]"}]]}], 
      StyleBox["\[ScriptU]",
       FontColor->RGBColor[0, 0, 0.4]]], "+", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        FractionBox[
         RowBox[{"108", " ", 
          SqrtBox["2"]}], 
         SuperscriptBox[
          StyleBox["\[ScriptU]",
           FontColor->RGBColor[0, 0, 0.4]], "3"]], "+", 
        FractionBox[
         RowBox[{"324", " ", "\[ImaginaryI]", " ", 
          SqrtBox["2"]}], 
         SuperscriptBox[
          StyleBox["\[ScriptU]",
           FontColor->RGBColor[0, 0, 0.4]], "2"]], "+", 
        FractionBox[
         RowBox[{
          RowBox[{
           RowBox[{"-", "810"}], " ", 
           SqrtBox["2"]}], "-", 
          RowBox[{"648", " ", 
           SqrtBox["2"], " ", 
           SubscriptBox[
            StyleBox["\[Zeta]",
             FontWeight->Bold,
             FontColor->GrayLevel[0.4]], "1"]}]}], 
         StyleBox["\[ScriptU]",
          FontColor->RGBColor[0, 0, 0.4]]]}], ")"}], " ", 
      SubsuperscriptBox[
       StyleBox["\[Eta]",
        FontWeight->Bold,
        FontColor->RGBColor[0.8, 0, 0]], 
       RowBox[{"2", ",", "1"}], 
       RowBox[{"[", "2", "]"}]]}], "+", 
     FractionBox[
      RowBox[{"324", " ", "\[ImaginaryI]", " ", 
       SqrtBox["2"], " ", 
       SubsuperscriptBox[
        StyleBox["\[Eta]",
         FontWeight->Bold,
         FontColor->RGBColor[0.8, 0, 0]], 
        RowBox[{"2", ",", "2"}], 
        RowBox[{"[", "2", "]"}]]}], 
      StyleBox["\[ScriptU]",
       FontColor->RGBColor[0, 0, 0.4]]], "+", 
     FractionBox[
      RowBox[{"108", " ", 
       SqrtBox["2"], " ", 
       SubsuperscriptBox[
        StyleBox["\[Eta]",
         FontWeight->Bold,
         FontColor->RGBColor[0.8, 0, 0]], 
        RowBox[{"2", ",", "3"}], 
        RowBox[{"[", "2", "]"}]]}], 
      StyleBox["\[ScriptU]",
       FontColor->RGBColor[0, 0, 0.4]]], "+", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", 
         FractionBox[
          RowBox[{"36", " ", "\[ImaginaryI]", " ", 
           SqrtBox["2"]}], 
          SuperscriptBox[
           StyleBox["\[ScriptU]",
            FontColor->RGBColor[0, 0, 0.4]], "3"]]}], "+", 
        FractionBox[
         RowBox[{"108", " ", 
          SqrtBox["2"]}], 
         SuperscriptBox[
          StyleBox["\[ScriptU]",
           FontColor->RGBColor[0, 0, 0.4]], "2"]], "+", 
        FractionBox[
         RowBox[{
          RowBox[{"342", " ", "\[ImaginaryI]", " ", 
           SqrtBox["2"]}], "+", 
          RowBox[{"216", " ", "\[ImaginaryI]", " ", 
           SqrtBox["2"], " ", 
           SubscriptBox[
            StyleBox["\[Zeta]",
             FontWeight->Bold,
             FontColor->GrayLevel[0.4]], "1"]}]}], 
         StyleBox["\[ScriptU]",
          FontColor->RGBColor[0, 0, 0.4]]]}], ")"}], " ", 
      SubsuperscriptBox[
       StyleBox["\[Eta]",
        FontWeight->Bold,
        FontColor->RGBColor[0.8, 0, 0]], 
       RowBox[{"3", ",", "1"}], 
       RowBox[{"[", "2", "]"}]]}], "+", 
     FractionBox[
      RowBox[{"108", " ", 
       SqrtBox["2"], " ", 
       SubsuperscriptBox[
        StyleBox["\[Eta]",
         FontWeight->Bold,
         FontColor->RGBColor[0.8, 0, 0]], 
        RowBox[{"3", ",", "2"}], 
        RowBox[{"[", "2", "]"}]]}], 
      StyleBox["\[ScriptU]",
       FontColor->RGBColor[0, 0, 0.4]]], "-", 
     FractionBox[
      RowBox[{"36", " ", "\[ImaginaryI]", " ", 
       SqrtBox["2"], " ", 
       SubsuperscriptBox[
        StyleBox["\[Eta]",
         FontWeight->Bold,
         FontColor->RGBColor[0.8, 0, 0]], 
        RowBox[{"3", ",", "3"}], 
        RowBox[{"[", "2", "]"}]]}], 
      StyleBox["\[ScriptU]",
       FontColor->RGBColor[0, 0, 0.4]]], "+", 
     FractionBox[
      RowBox[{"216", " ", 
       SqrtBox["2"], " ", 
       SubsuperscriptBox[
        StyleBox["\[Eta]",
         FontWeight->Bold,
         FontColor->RGBColor[0.8, 0, 0]], 
        RowBox[{"4", ",", "1"}], 
        RowBox[{"[", "2", "]"}]]}], 
      StyleBox["\[ScriptU]",
       FontColor->RGBColor[0, 0, 0.4]]], "-", 
     FractionBox[
      RowBox[{"72", " ", "\[ImaginaryI]", " ", 
       SqrtBox["2"], " ", 
       SubsuperscriptBox[
        StyleBox["\[Eta]",
         FontWeight->Bold,
         FontColor->RGBColor[0.8, 0, 0]], 
        RowBox[{"5", ",", "1"}], 
        RowBox[{"[", "2", "]"}]]}], 
      StyleBox["\[ScriptU]",
       FontColor->RGBColor[0, 0, 0.4]]], "+", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        FractionBox[
         RowBox[{"216", " ", 
          SqrtBox["2"]}], 
         SuperscriptBox[
          StyleBox["\[ScriptU]",
           FontColor->RGBColor[0, 0, 0.4]], "3"]], "+", 
        FractionBox[
         RowBox[{"648", " ", "\[ImaginaryI]", " ", 
          SqrtBox["2"]}], 
         SuperscriptBox[
          StyleBox["\[ScriptU]",
           FontColor->RGBColor[0, 0, 0.4]], "2"]], "+", 
        FractionBox[
         RowBox[{
          RowBox[{
           RowBox[{"-", "1620"}], " ", 
           SqrtBox["2"]}], "-", 
          RowBox[{"1296", " ", 
           SqrtBox["2"], " ", 
           SubscriptBox[
            StyleBox["\[Zeta]",
             FontWeight->Bold,
             FontColor->GrayLevel[0.4]], "1"]}]}], 
         StyleBox["\[ScriptU]",
          FontColor->RGBColor[0, 0, 0.4]]]}], ")"}], " ", 
      SubsuperscriptBox[
       StyleBox["\[Eta]",
        FontWeight->Bold,
        FontColor->RGBColor[0.8, 0, 0]], 
       RowBox[{"1", ",", "1", ",", "1"}], 
       RowBox[{"[", "2", "]"}]]}], "+", 
     FractionBox[
      RowBox[{"648", " ", "\[ImaginaryI]", " ", 
       SqrtBox["2"], " ", 
       SubsuperscriptBox[
        StyleBox["\[Eta]",
         FontWeight->Bold,
         FontColor->RGBColor[0.8, 0, 0]], 
        RowBox[{"1", ",", "1", ",", "2"}], 
        RowBox[{"[", "2", "]"}]]}], 
      StyleBox["\[ScriptU]",
       FontColor->RGBColor[0, 0, 0.4]]], "+", 
     FractionBox[
      RowBox[{"216", " ", 
       SqrtBox["2"], " ", 
       SubsuperscriptBox[
        StyleBox["\[Eta]",
         FontWeight->Bold,
         FontColor->RGBColor[0.8, 0, 0]], 
        RowBox[{"1", ",", "1", ",", "3"}], 
        RowBox[{"[", "2", "]"}]]}], 
      StyleBox["\[ScriptU]",
       FontColor->RGBColor[0, 0, 0.4]]], "+", 
     FractionBox[
      RowBox[{"648", " ", "\[ImaginaryI]", " ", 
       SqrtBox["2"], " ", 
       SubsuperscriptBox[
        StyleBox["\[Eta]",
         FontWeight->Bold,
         FontColor->RGBColor[0.8, 0, 0]], 
        RowBox[{"1", ",", "2", ",", "1"}], 
        RowBox[{"[", "2", "]"}]]}], 
      StyleBox["\[ScriptU]",
       FontColor->RGBColor[0, 0, 0.4]]], "+", 
     FractionBox[
      RowBox[{"216", " ", 
       SqrtBox["2"], " ", 
       SubsuperscriptBox[
        StyleBox["\[Eta]",
         FontWeight->Bold,
         FontColor->RGBColor[0.8, 0, 0]], 
        RowBox[{"1", ",", "3", ",", "1"}], 
        RowBox[{"[", "2", "]"}]]}], 
      StyleBox["\[ScriptU]",
       FontColor->RGBColor[0, 0, 0.4]]], "+", 
     FractionBox[
      RowBox[{"648", " ", "\[ImaginaryI]", " ", 
       SqrtBox["2"], " ", 
       SubsuperscriptBox[
        StyleBox["\[Eta]",
         FontWeight->Bold,
         FontColor->RGBColor[0.8, 0, 0]], 
        RowBox[{"2", ",", "1", ",", "1"}], 
        RowBox[{"[", "2", "]"}]]}], 
      StyleBox["\[ScriptU]",
       FontColor->RGBColor[0, 0, 0.4]]], "+", 
     FractionBox[
      RowBox[{"216", " ", 
       SqrtBox["2"], " ", 
       SubsuperscriptBox[
        StyleBox["\[Eta]",
         FontWeight->Bold,
         FontColor->RGBColor[0.8, 0, 0]], 
        RowBox[{"3", ",", "1", ",", "1"}], 
        RowBox[{"[", "2", "]"}]]}], 
      StyleBox["\[ScriptU]",
       FontColor->RGBColor[0, 0, 0.4]]], "+", 
     FractionBox[
      RowBox[{"1296", " ", "\[ImaginaryI]", " ", 
       SqrtBox["2"], " ", 
       SubsuperscriptBox[
        StyleBox["\[Eta]",
         FontWeight->Bold,
         FontColor->RGBColor[0.8, 0, 0]], 
        RowBox[{"1", ",", "1", ",", "1", ",", "1"}], 
        RowBox[{"[", "2", "]"}]]}], 
      StyleBox["\[ScriptU]",
       FontColor->RGBColor[0, 0, 0.4]]]}], ")"}]}]}]], "Output",
 CellChangeTimes->{{3.562263947607465*^9, 3.562263960614731*^9}, {
   3.562264004890902*^9, 3.5622640386896667`*^9}, 3.5633017392885427`*^9, 
   3.563301854789668*^9}]
}, Open  ]],

Cell[BoxData[
 RowBox[{"AddNsDefinition", "[", 
  RowBox[{"{", 
   RowBox[{
    SuperscriptBox[
     RowBox[{
      RowBox[{"U$", "[", "\"\<as\>\"", "]"}], "[", "0", "]"}], "2"], ",", 
    RowBox[{"PrepareList", "[", 
     RowBox[{"Collect", "[", 
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{
          RowBox[{"Series", "[", 
           RowBox[{
            SuperscriptBox["Uasnomralized", "2"], ",", 
            RowBox[{"{", 
             RowBox[{"g", ",", "0", ",", "12"}], "}"}]}], "]"}], "//", 
          "FuntoMHZbasis"}], "//", "funapartusu"}], "//", "funreduceusu"}], 
       ",", "canlist"}], "]"}], "]"}]}], "}"}], "]"}]], "Input",
 CellChangeTimes->{{3.5633041456516523`*^9, 3.5633042248499527`*^9}}],

Cell[BoxData[
 RowBox[{"AddNsDefinition", "[", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{
     RowBox[{"U$", "[", "\"\<as\>\"", "]"}], "[", "0", "]"}], ",", 
    RowBox[{"PrepareList", "[", "Uasnomralized", "]"}]}], "}"}], 
  "]"}]], "Input",
 CellChangeTimes->{{3.563301908488207*^9, 3.5633019231361628`*^9}, {
  3.5633019634678383`*^9, 3.563301980525517*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["U up to 5 loops, and with proper normalization", "Subsection",
 CellChangeTimes->{{3.5614701475509453`*^9, 3.561470165253704*^9}, 
   3.568968928020924*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{"+", 
   RowBox[{"Log", "[", 
    SubscriptBox[
     RowBox[{"(", 
      RowBox[{
       SuperscriptBox[
        StyleBox["U",
         FontColor->RGBColor[0, 0.6, 0]], 
        RowBox[{"[", "2", "]"}]], 
       SuperscriptBox[
        OverscriptBox[
         StyleBox["U",
          FontColor->RGBColor[0, 0.6, 0]], 
         StyleBox["_",
          FontColor->RGBColor[0, 0.6, 0]]], 
        RowBox[{"[", 
         RowBox[{"-", "2"}], "]"}]]}], ")"}], "r"], "]"}]}], "\[Equal]", 
  RowBox[{"+", "normalUr"}]}]], "Input",
 CellChangeTimes->{{3.563302240637775*^9, 3.5633022723587017`*^9}, {
  3.563302359235985*^9, 3.563302363936371*^9}}],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{
          RowBox[{
           RowBox[{
            SuperscriptBox["g", 
             RowBox[{"8", " "}]], 
            RowBox[{"(", 
             RowBox[{"rltUr", "+", "\[CapitalLambda]norm"}], ")"}]}], "/.", 
           RowBox[{"Shift", "[", "2", "]"}]}], "/.", 
          RowBox[{"u", "\[Rule]", 
           RowBox[{"u", "+", "\[ImaginaryI]"}]}]}], "//.", 
         RowBox[{"shiftm\[Eta]", "[", "4", "]"}]}], "/.", "subusu"}], "/.", 
       RowBox[{"u", "\[Rule]", 
        RowBox[{"2", "g", " ", "z"}]}]}], "/.", 
      RowBox[{"TaylorOptions", "[", 
       RowBox[{
        RowBox[{"Variable", "\[Rule]", "g"}], ",", 
        RowBox[{"\[Eta]Factor", "\[Rule]", 
         RowBox[{"2", " ", "z"}]}], ",", 
        RowBox[{"Order", "\[Rule]", "8"}]}], "]"}]}], "//.", 
     "subZetaReduce"}], "//", "Simplify"}], "//", "Normal"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"(", 
    RowBox[{"%", "+", 
     RowBox[{"(", 
      RowBox[{"%", "/.", "mconj"}], ")"}]}], ")"}], "-", 
   RowBox[{"(", "normalUr", ")"}]}], "//", 
  "Simplify"}], "\[IndentingNewLine]", 
 RowBox[{"\[CapitalLambda]normfinal", "=", 
  RowBox[{"Collect", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"Solve", "[", 
      RowBox[{
       RowBox[{"%", "\[Equal]", "0"}], ",", "\[CapitalLambda]norm"}], "]"}], 
     "[", 
     RowBox[{"[", 
      RowBox[{"1", ",", "1", ",", "2"}], "]"}], "]"}], ",", "canlist"}], 
   "]"}]}]}], "Input",
 CellChangeTimes->{
  3.56226411028724*^9, {3.563302277302726*^9, 3.5633022783252974`*^9}, {
   3.563302379594418*^9, 3.563302416151733*^9}, {3.563302497033291*^9, 
   3.56330250789126*^9}, 3.563302540876687*^9}],

Cell[BoxData[
 RowBox[{
  SuperscriptBox["g", "8"], " ", 
  RowBox[{"(", 
   RowBox[{
    RowBox[{"2", " ", "\[CapitalLambda]norm"}], "+", 
    RowBox[{"3", " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"-", "81"}], "+", 
       RowBox[{"612", " ", 
        SubscriptBox[
         StyleBox["\[Zeta]",
          FontWeight->Bold,
          FontColor->GrayLevel[0.4]], "3"]}], "-", 
       RowBox[{"72", " ", 
        SubsuperscriptBox[
         StyleBox["\[Zeta]",
          FontWeight->Bold,
          FontColor->GrayLevel[0.4]], "3", "2"]}], "+", 
       RowBox[{"12", " ", 
        SubscriptBox[
         StyleBox["\[Zeta]",
          FontWeight->Bold,
          FontColor->GrayLevel[0.4]], "1"], " ", 
        RowBox[{"(", 
         RowBox[{"9", "+", 
          RowBox[{"24", " ", 
           SubscriptBox[
            StyleBox["\[Zeta]",
             FontWeight->Bold,
             FontColor->GrayLevel[0.4]], "3"]}], "-", 
          RowBox[{"40", " ", 
           SubscriptBox[
            StyleBox["\[Zeta]",
             FontWeight->Bold,
             FontColor->GrayLevel[0.4]], "5"]}]}], ")"}]}], "+", 
       RowBox[{"120", " ", 
        SubscriptBox[
         StyleBox["\[Zeta]",
          FontWeight->Bold,
          FontColor->GrayLevel[0.4]], "5"]}], "-", 
       RowBox[{"140", " ", 
        SubscriptBox[
         StyleBox["\[Zeta]",
          FontWeight->Bold,
          FontColor->GrayLevel[0.4]], "7"]}]}], ")"}]}]}], ")"}]}]], "Output",\

 CellChangeTimes->{3.5622641207165747`*^9, 3.563302311974115*^9, 
  3.563302417272134*^9, 3.5633025093473454`*^9, 3.563302541601534*^9}],

Cell[BoxData[
 RowBox[{
  FractionBox["243", "2"], "-", 
  RowBox[{"162", " ", 
   SubscriptBox[
    StyleBox["\[Zeta]",
     FontWeight->Bold,
     FontColor->GrayLevel[0.4]], "1"]}], "-", 
  RowBox[{"918", " ", 
   SubscriptBox[
    StyleBox["\[Zeta]",
     FontWeight->Bold,
     FontColor->GrayLevel[0.4]], "3"]}], "-", 
  RowBox[{"432", " ", 
   SubscriptBox[
    StyleBox["\[Zeta]",
     FontWeight->Bold,
     FontColor->GrayLevel[0.4]], "1"], " ", 
   SubscriptBox[
    StyleBox["\[Zeta]",
     FontWeight->Bold,
     FontColor->GrayLevel[0.4]], "3"]}], "+", 
  RowBox[{"108", " ", 
   SubsuperscriptBox[
    StyleBox["\[Zeta]",
     FontWeight->Bold,
     FontColor->GrayLevel[0.4]], "3", "2"]}], "-", 
  RowBox[{"180", " ", 
   SubscriptBox[
    StyleBox["\[Zeta]",
     FontWeight->Bold,
     FontColor->GrayLevel[0.4]], "5"]}], "+", 
  RowBox[{"720", " ", 
   SubscriptBox[
    StyleBox["\[Zeta]",
     FontWeight->Bold,
     FontColor->GrayLevel[0.4]], "1"], " ", 
   SubscriptBox[
    StyleBox["\[Zeta]",
     FontWeight->Bold,
     FontColor->GrayLevel[0.4]], "5"]}], "+", 
  RowBox[{"210", " ", 
   SubscriptBox[
    StyleBox["\[Zeta]",
     FontWeight->Bold,
     FontColor->GrayLevel[0.4]], "7"]}]}]], "Output",
 CellChangeTimes->{3.5622641207165747`*^9, 3.563302311974115*^9, 
  3.563302417272134*^9, 3.5633025093473454`*^9, 3.5633025416243153`*^9}]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"Log", "[", "U", "]"}], "==", 
  RowBox[{
   RowBox[{"Log", "[", 
    SubscriptBox[
     RowBox[{"(", 
      StyleBox["U",
       FontColor->RGBColor[0, 0.6, 0]], ")"}], "r"], "]"}], "+", 
   RowBox[{"Log", "[", 
    SubscriptBox[
     RowBox[{"(", 
      StyleBox["U",
       FontColor->RGBColor[0, 0.6, 0]], ")"}], "as"], "]"}]}]}]], "Input",
 CellChangeTimes->{{3.5633025777083607`*^9, 3.563302603289226*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"tmp", "=", 
   RowBox[{"Collect", "[", 
    RowBox[{
     RowBox[{"Series", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          SubscriptBox["U", "\"\<as\>\""], "/.", 
          RowBox[{"nsweak", "[", "5", "]"}]}], ")"}], " ", 
        RowBox[{"Exp", "[", 
         RowBox[{
          SuperscriptBox["g", "8"], 
          RowBox[{"(", 
           RowBox[{"rltUr", "+", "\[CapitalLambda]normfinal"}], ")"}]}], 
         "]"}]}], ",", 
       RowBox[{"{", 
        RowBox[{"g", ",", "0", ",", "10"}], "}"}]}], "]"}], ",", "canlist"}], 
    "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Ufiveloop", "=", 
   RowBox[{"Collect", "[", 
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{"tmp", "//.", "subtousu"}], "//", "funapartusu"}], "//", 
      "funreduceusu"}], ",", "canlist"}], "]"}]}], ";"}]}], "Input",
 CellChangeTimes->{{3.561470168236889*^9, 3.561470219998486*^9}, {
   3.561470261335863*^9, 3.561470271158421*^9}, {3.5614706497517014`*^9, 
   3.56147067150228*^9}, 3.5614707157511597`*^9, {3.5622642487681293`*^9, 
   3.5622643503494596`*^9}, {3.5622644108242064`*^9, 3.562264429719297*^9}, {
   3.563302630845771*^9, 3.5633026981205053`*^9}, 3.563302770175363*^9}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Select", "[", 
  RowBox[{
   RowBox[{"Ufiveloop", "//", "Expand"}], ",", 
   RowBox[{
    RowBox[{"Not", "@", 
     RowBox[{"FreeQ", "[", 
      RowBox[{"#", ",", "u"}], "]"}]}], "&"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.5622643584796143`*^9, 3.562264385169572*^9}}],

Cell[BoxData["0"], "Output",
 CellChangeTimes->{{3.562264362609809*^9, 3.562264385481571*^9}, 
   3.562264436674902*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Ufiveloopsquared", "=", 
  RowBox[{"Collect", "[", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{"Series", "[", 
         RowBox[{
          SuperscriptBox["Ufiveloop", "2"], ",", 
          RowBox[{"{", 
           RowBox[{"g", ",", "0", ",", "12"}], "}"}]}], "]"}], "//", 
        "Normal"}], "//", "funapartusu"}], "//", "funreduceusu"}], "//", 
     "FuntoMHZbasis"}], ",", "canlist"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.56330275856448*^9, 3.563302763570457*^9}, {
  3.5633028132105293`*^9, 3.563302861281427*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"-", 
   FractionBox[
    RowBox[{"2", " ", 
     SuperscriptBox["g", "4"]}], 
    SuperscriptBox[
     StyleBox["\[ScriptU]",
      FontColor->RGBColor[0, 0, 0.4]], "2"]]}], "+", 
  RowBox[{
   SuperscriptBox["g", "6"], " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"-", 
      FractionBox["4", 
       SuperscriptBox[
        StyleBox["\[ScriptU]",
         FontColor->RGBColor[0, 0, 0.4]], "4"]]}], "-", 
     FractionBox[
      RowBox[{"12", " ", "\[ImaginaryI]"}], 
      SuperscriptBox[
       StyleBox["\[ScriptU]",
        FontColor->RGBColor[0, 0, 0.4]], "3"]], "+", 
     FractionBox[
      RowBox[{
       RowBox[{"-", "18"}], "+", 
       RowBox[{"24", " ", 
        SubscriptBox[
         StyleBox["\[Zeta]",
          FontWeight->Bold,
          FontColor->GrayLevel[0.4]], "1"]}]}], 
      SuperscriptBox[
       StyleBox["\[ScriptU]",
        FontColor->RGBColor[0, 0, 0.4]], "2"]], "-", 
     FractionBox[
      RowBox[{"24", " ", "\[ImaginaryI]", " ", 
       SubsuperscriptBox[
        StyleBox["\[Eta]",
         FontWeight->Bold,
         FontColor->RGBColor[0.8, 0, 0]], "1", 
        RowBox[{"[", "2", "]"}]]}], 
      SuperscriptBox[
       StyleBox["\[ScriptU]",
        FontColor->RGBColor[0, 0, 0.4]], "2"]]}], ")"}]}], "+", 
  RowBox[{
   SuperscriptBox["g", "8"], " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"-", 
      FractionBox["10", 
       SuperscriptBox[
        StyleBox["\[ScriptU]",
         FontColor->RGBColor[0, 0, 0.4]], "6"]]}], "-", 
     FractionBox[
      RowBox[{"36", " ", "\[ImaginaryI]"}], 
      SuperscriptBox[
       StyleBox["\[ScriptU]",
        FontColor->RGBColor[0, 0, 0.4]], "5"]], "+", 
     FractionBox[
      RowBox[{
       RowBox[{
        RowBox[{"-", "60"}], " ", "\[ImaginaryI]"}], "+", 
       RowBox[{"144", " ", "\[ImaginaryI]", " ", 
        SubscriptBox[
         StyleBox["\[Zeta]",
          FontWeight->Bold,
          FontColor->GrayLevel[0.4]], "1"]}]}], 
      SuperscriptBox[
       StyleBox["\[ScriptU]",
        FontColor->RGBColor[0, 0, 0.4]], "3"]], "+", 
     FractionBox[
      RowBox[{
       RowBox[{"-", "6"}], "+", 
       RowBox[{"48", " ", 
        SubscriptBox[
         StyleBox["\[Zeta]",
          FontWeight->Bold,
          FontColor->GrayLevel[0.4]], "1"]}]}], 
      SuperscriptBox[
       StyleBox["\[ScriptU]",
        FontColor->RGBColor[0, 0, 0.4]], "4"]], "+", 
     FractionBox[
      RowBox[{"36", "+", 
       RowBox[{"120", " ", 
        SubscriptBox[
         StyleBox["\[Zeta]",
          FontWeight->Bold,
          FontColor->GrayLevel[0.4]], "1"]}], "-", 
       RowBox[{"144", " ", 
        SubsuperscriptBox[
         StyleBox["\[Zeta]",
          FontWeight->Bold,
          FontColor->GrayLevel[0.4]], "1", "2"]}], "-", 
       RowBox[{"72", " ", 
        SubscriptBox[
         StyleBox["\[Zeta]",
          FontWeight->Bold,
          FontColor->GrayLevel[0.4]], "3"]}]}], 
      SuperscriptBox[
       StyleBox["\[ScriptU]",
        FontColor->RGBColor[0, 0, 0.4]], "2"]], "+", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", 
         FractionBox[
          RowBox[{"48", " ", "\[ImaginaryI]"}], 
          SuperscriptBox[
           StyleBox["\[ScriptU]",
            FontColor->RGBColor[0, 0, 0.4]], "4"]]}], "+", 
        FractionBox["144", 
         SuperscriptBox[
          StyleBox["\[ScriptU]",
           FontColor->RGBColor[0, 0, 0.4]], "3"]], "+", 
        FractionBox[
         RowBox[{
          RowBox[{
           RowBox[{"-", "120"}], " ", "\[ImaginaryI]"}], "+", 
          RowBox[{"288", " ", "\[ImaginaryI]", " ", 
           SubscriptBox[
            StyleBox["\[Zeta]",
             FontWeight->Bold,
             FontColor->GrayLevel[0.4]], "1"]}]}], 
         SuperscriptBox[
          StyleBox["\[ScriptU]",
           FontColor->RGBColor[0, 0, 0.4]], "2"]]}], ")"}], " ", 
      SubsuperscriptBox[
       StyleBox["\[Eta]",
        FontWeight->Bold,
        FontColor->RGBColor[0.8, 0, 0]], "1", 
       RowBox[{"[", "2", "]"}]]}], "+", 
     FractionBox[
      RowBox[{"144", " ", 
       SubsuperscriptBox[
        StyleBox["\[Eta]",
         FontWeight->Bold,
         FontColor->RGBColor[0.8, 0, 0]], "2", 
        RowBox[{"[", "2", "]"}]]}], 
      SuperscriptBox[
       StyleBox["\[ScriptU]",
        FontColor->RGBColor[0, 0, 0.4]], "2"]], "-", 
     FractionBox[
      RowBox[{"24", " ", "\[ImaginaryI]", " ", 
       SubsuperscriptBox[
        StyleBox["\[Eta]",
         FontWeight->Bold,
         FontColor->RGBColor[0.8, 0, 0]], "3", 
        RowBox[{"[", "2", "]"}]]}], 
      SuperscriptBox[
       StyleBox["\[ScriptU]",
        FontColor->RGBColor[0, 0, 0.4]], "2"]], "+", 
     FractionBox[
      RowBox[{"288", " ", 
       SubsuperscriptBox[
        StyleBox["\[Eta]",
         FontWeight->Bold,
         FontColor->RGBColor[0.8, 0, 0]], 
        RowBox[{"1", ",", "1"}], 
        RowBox[{"[", "2", "]"}]]}], 
      SuperscriptBox[
       StyleBox["\[ScriptU]",
        FontColor->RGBColor[0, 0, 0.4]], "2"]]}], ")"}]}], "+", 
  RowBox[{
   SuperscriptBox["g", "10"], " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"-", 
      FractionBox["28", 
       SuperscriptBox[
        StyleBox["\[ScriptU]",
         FontColor->RGBColor[0, 0, 0.4]], "8"]]}], "-", 
     FractionBox[
      RowBox[{"108", " ", "\[ImaginaryI]"}], 
      SuperscriptBox[
       StyleBox["\[ScriptU]",
        FontColor->RGBColor[0, 0, 0.4]], "7"]], "+", 
     FractionBox[
      RowBox[{
       RowBox[{
        RowBox[{"-", "144"}], " ", "\[ImaginaryI]"}], "+", 
       RowBox[{"432", " ", "\[ImaginaryI]", " ", 
        SubscriptBox[
         StyleBox["\[Zeta]",
          FontWeight->Bold,
          FontColor->GrayLevel[0.4]], "1"]}]}], 
      SuperscriptBox[
       StyleBox["\[ScriptU]",
        FontColor->RGBColor[0, 0, 0.4]], "5"]], "+", 
     FractionBox[
      RowBox[{"30", "+", 
       RowBox[{"120", " ", 
        SubscriptBox[
         StyleBox["\[Zeta]",
          FontWeight->Bold,
          FontColor->GrayLevel[0.4]], "1"]}]}], 
      SuperscriptBox[
       StyleBox["\[ScriptU]",
        FontColor->RGBColor[0, 0, 0.4]], "6"]], "+", 
     FractionBox[
      RowBox[{"114", "-", 
       RowBox[{"120", " ", 
        SubscriptBox[
         StyleBox["\[Zeta]",
          FontWeight->Bold,
          FontColor->GrayLevel[0.4]], "1"]}], "-", 
       RowBox[{"288", " ", 
        SubsuperscriptBox[
         StyleBox["\[Zeta]",
          FontWeight->Bold,
          FontColor->GrayLevel[0.4]], "1", "2"]}], "-", 
       RowBox[{"192", " ", 
        SubscriptBox[
         StyleBox["\[Zeta]",
          FontWeight->Bold,
          FontColor->GrayLevel[0.4]], "3"]}]}], 
      SuperscriptBox[
       StyleBox["\[ScriptU]",
        FontColor->RGBColor[0, 0, 0.4]], "4"]], "+", 
     FractionBox[
      RowBox[{
       RowBox[{"312", " ", "\[ImaginaryI]"}], "+", 
       RowBox[{"144", " ", "\[ImaginaryI]", " ", 
        SubscriptBox[
         StyleBox["\[Zeta]",
          FontWeight->Bold,
          FontColor->GrayLevel[0.4]], "1"]}], "-", 
       RowBox[{"864", " ", "\[ImaginaryI]", " ", 
        SubsuperscriptBox[
         StyleBox["\[Zeta]",
          FontWeight->Bold,
          FontColor->GrayLevel[0.4]], "1", "2"]}], "-", 
       RowBox[{"432", " ", "\[ImaginaryI]", " ", 
        SubscriptBox[
         StyleBox["\[Zeta]",
          FontWeight->Bold,
          FontColor->GrayLevel[0.4]], "3"]}]}], 
      SuperscriptBox[
       StyleBox["\[ScriptU]",
        FontColor->RGBColor[0, 0, 0.4]], "3"]], "+", 
     FractionBox[
      RowBox[{
       RowBox[{"-", "216"}], "-", 
       RowBox[{"624", " ", 
        SubscriptBox[
         StyleBox["\[Zeta]",
          FontWeight->Bold,
          FontColor->GrayLevel[0.4]], "1"]}], "-", 
       RowBox[{"144", " ", 
        SubsuperscriptBox[
         StyleBox["\[Zeta]",
          FontWeight->Bold,
          FontColor->GrayLevel[0.4]], "1", "2"]}], "+", 
       RowBox[{"576", " ", 
        SubsuperscriptBox[
         StyleBox["\[Zeta]",
          FontWeight->Bold,
          FontColor->GrayLevel[0.4]], "1", "3"]}], "-", 
       RowBox[{"360", " ", 
        SubscriptBox[
         StyleBox["\[Zeta]",
          FontWeight->Bold,
          FontColor->GrayLevel[0.4]], "3"]}], "+", 
       RowBox[{"864", " ", 
        SubscriptBox[
         StyleBox["\[Zeta]",
          FontWeight->Bold,
          FontColor->GrayLevel[0.4]], "1"], " ", 
        SubscriptBox[
         StyleBox["\[Zeta]",
          FontWeight->Bold,
          FontColor->GrayLevel[0.4]], "3"]}], "+", 
       RowBox[{"480", " ", 
        SubscriptBox[
         StyleBox["\[Zeta]",
          FontWeight->Bold,
          FontColor->GrayLevel[0.4]], "5"]}]}], 
      SuperscriptBox[
       StyleBox["\[ScriptU]",
        FontColor->RGBColor[0, 0, 0.4]], "2"]], "+", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", 
         FractionBox[
          RowBox[{"120", " ", "\[ImaginaryI]"}], 
          SuperscriptBox[
           StyleBox["\[ScriptU]",
            FontColor->RGBColor[0, 0, 0.4]], "6"]]}], "+", 
        FractionBox["432", 
         SuperscriptBox[
          StyleBox["\[ScriptU]",
           FontColor->RGBColor[0, 0, 0.4]], "5"]], "+", 
        FractionBox[
         RowBox[{"144", "-", 
          RowBox[{"1728", " ", 
           SubscriptBox[
            StyleBox["\[Zeta]",
             FontWeight->Bold,
             FontColor->GrayLevel[0.4]], "1"]}]}], 
         SuperscriptBox[
          StyleBox["\[ScriptU]",
           FontColor->RGBColor[0, 0, 0.4]], "3"]], "+", 
        FractionBox[
         RowBox[{
          RowBox[{"120", " ", "\[ImaginaryI]"}], "+", 
          RowBox[{"576", " ", "\[ImaginaryI]", " ", 
           SubscriptBox[
            StyleBox["\[Zeta]",
             FontWeight->Bold,
             FontColor->GrayLevel[0.4]], "1"]}]}], 
         SuperscriptBox[
          StyleBox["\[ScriptU]",
           FontColor->RGBColor[0, 0, 0.4]], "4"]], "+", 
        FractionBox[
         RowBox[{
          RowBox[{"624", " ", "\[ImaginaryI]"}], "+", 
          RowBox[{"288", " ", "\[ImaginaryI]", " ", 
           SubscriptBox[
            StyleBox["\[Zeta]",
             FontWeight->Bold,
             FontColor->GrayLevel[0.4]], "1"]}], "-", 
          RowBox[{"1728", " ", "\[ImaginaryI]", " ", 
           SubsuperscriptBox[
            StyleBox["\[Zeta]",
             FontWeight->Bold,
             FontColor->GrayLevel[0.4]], "1", "2"]}], "-", 
          RowBox[{"864", " ", "\[ImaginaryI]", " ", 
           SubscriptBox[
            StyleBox["\[Zeta]",
             FontWeight->Bold,
             FontColor->GrayLevel[0.4]], "3"]}]}], 
         SuperscriptBox[
          StyleBox["\[ScriptU]",
           FontColor->RGBColor[0, 0, 0.4]], "2"]]}], ")"}], " ", 
      SubsuperscriptBox[
       StyleBox["\[Eta]",
        FontWeight->Bold,
        FontColor->RGBColor[0.8, 0, 0]], "1", 
       RowBox[{"[", "2", "]"}]]}], "+", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        FractionBox["288", 
         SuperscriptBox[
          StyleBox["\[ScriptU]",
           FontColor->RGBColor[0, 0, 0.4]], "4"]], "+", 
        FractionBox[
         RowBox[{"864", " ", "\[ImaginaryI]"}], 
         SuperscriptBox[
          StyleBox["\[ScriptU]",
           FontColor->RGBColor[0, 0, 0.4]], "3"]], "+", 
        FractionBox[
         RowBox[{"144", "-", 
          RowBox[{"1728", " ", 
           SubscriptBox[
            StyleBox["\[Zeta]",
             FontWeight->Bold,
             FontColor->GrayLevel[0.4]], "1"]}]}], 
         SuperscriptBox[
          StyleBox["\[ScriptU]",
           FontColor->RGBColor[0, 0, 0.4]], "2"]]}], ")"}], " ", 
      SubsuperscriptBox[
       StyleBox["\[Eta]",
        FontWeight->Bold,
        FontColor->RGBColor[0.8, 0, 0]], "2", 
       RowBox[{"[", "2", "]"}]]}], "+", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", 
         FractionBox[
          RowBox[{"48", " ", "\[ImaginaryI]"}], 
          SuperscriptBox[
           StyleBox["\[ScriptU]",
            FontColor->RGBColor[0, 0, 0.4]], "4"]]}], "+", 
        FractionBox["144", 
         SuperscriptBox[
          StyleBox["\[ScriptU]",
           FontColor->RGBColor[0, 0, 0.4]], "3"]], "+", 
        FractionBox[
         RowBox[{
          RowBox[{"456", " ", "\[ImaginaryI]"}], "+", 
          RowBox[{"288", " ", "\[ImaginaryI]", " ", 
           SubscriptBox[
            StyleBox["\[Zeta]",
             FontWeight->Bold,
             FontColor->GrayLevel[0.4]], "1"]}]}], 
         SuperscriptBox[
          StyleBox["\[ScriptU]",
           FontColor->RGBColor[0, 0, 0.4]], "2"]]}], ")"}], " ", 
      SubsuperscriptBox[
       StyleBox["\[Eta]",
        FontWeight->Bold,
        FontColor->RGBColor[0.8, 0, 0]], "3", 
       RowBox[{"[", "2", "]"}]]}], "+", 
     FractionBox[
      RowBox[{"288", " ", 
       SubsuperscriptBox[
        StyleBox["\[Eta]",
         FontWeight->Bold,
         FontColor->RGBColor[0.8, 0, 0]], "4", 
        RowBox[{"[", "2", "]"}]]}], 
      SuperscriptBox[
       StyleBox["\[ScriptU]",
        FontColor->RGBColor[0, 0, 0.4]], "2"]], "-", 
     FractionBox[
      RowBox[{"48", " ", "\[ImaginaryI]", " ", 
       SubsuperscriptBox[
        StyleBox["\[Eta]",
         FontWeight->Bold,
         FontColor->RGBColor[0.8, 0, 0]], "5", 
        RowBox[{"[", "2", "]"}]]}], 
      SuperscriptBox[
       StyleBox["\[ScriptU]",
        FontColor->RGBColor[0, 0, 0.4]], "2"]], "+", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        FractionBox["576", 
         SuperscriptBox[
          StyleBox["\[ScriptU]",
           FontColor->RGBColor[0, 0, 0.4]], "4"]], "+", 
        FractionBox[
         RowBox[{"1728", " ", "\[ImaginaryI]"}], 
         SuperscriptBox[
          StyleBox["\[ScriptU]",
           FontColor->RGBColor[0, 0, 0.4]], "3"]], "+", 
        FractionBox[
         RowBox[{"288", "-", 
          RowBox[{"3456", " ", 
           SubscriptBox[
            StyleBox["\[Zeta]",
             FontWeight->Bold,
             FontColor->GrayLevel[0.4]], "1"]}]}], 
         SuperscriptBox[
          StyleBox["\[ScriptU]",
           FontColor->RGBColor[0, 0, 0.4]], "2"]]}], ")"}], " ", 
      SubsuperscriptBox[
       StyleBox["\[Eta]",
        FontWeight->Bold,
        FontColor->RGBColor[0.8, 0, 0]], 
       RowBox[{"1", ",", "1"}], 
       RowBox[{"[", "2", "]"}]]}], "+", 
     FractionBox[
      RowBox[{"1728", " ", "\[ImaginaryI]", " ", 
       SubsuperscriptBox[
        StyleBox["\[Eta]",
         FontWeight->Bold,
         FontColor->RGBColor[0.8, 0, 0]], 
        RowBox[{"1", ",", "2"}], 
        RowBox[{"[", "2", "]"}]]}], 
      SuperscriptBox[
       StyleBox["\[ScriptU]",
        FontColor->RGBColor[0, 0, 0.4]], "2"]], "+", 
     FractionBox[
      RowBox[{"288", " ", 
       SubsuperscriptBox[
        StyleBox["\[Eta]",
         FontWeight->Bold,
         FontColor->RGBColor[0.8, 0, 0]], 
        RowBox[{"1", ",", "3"}], 
        RowBox[{"[", "2", "]"}]]}], 
      SuperscriptBox[
       StyleBox["\[ScriptU]",
        FontColor->RGBColor[0, 0, 0.4]], "2"]], "+", 
     FractionBox[
      RowBox[{"1728", " ", "\[ImaginaryI]", " ", 
       SubsuperscriptBox[
        StyleBox["\[Eta]",
         FontWeight->Bold,
         FontColor->RGBColor[0.8, 0, 0]], 
        RowBox[{"2", ",", "1"}], 
        RowBox[{"[", "2", "]"}]]}], 
      SuperscriptBox[
       StyleBox["\[ScriptU]",
        FontColor->RGBColor[0, 0, 0.4]], "2"]], "+", 
     FractionBox[
      RowBox[{"288", " ", 
       SubsuperscriptBox[
        StyleBox["\[Eta]",
         FontWeight->Bold,
         FontColor->RGBColor[0.8, 0, 0]], 
        RowBox[{"3", ",", "1"}], 
        RowBox[{"[", "2", "]"}]]}], 
      SuperscriptBox[
       StyleBox["\[ScriptU]",
        FontColor->RGBColor[0, 0, 0.4]], "2"]], "+", 
     FractionBox[
      RowBox[{"3456", " ", "\[ImaginaryI]", " ", 
       SubsuperscriptBox[
        StyleBox["\[Eta]",
         FontWeight->Bold,
         FontColor->RGBColor[0.8, 0, 0]], 
        RowBox[{"1", ",", "1", ",", "1"}], 
        RowBox[{"[", "2", "]"}]]}], 
      SuperscriptBox[
       StyleBox["\[ScriptU]",
        FontColor->RGBColor[0, 0, 0.4]], "2"]]}], ")"}]}], "+", 
  RowBox[{
   SuperscriptBox["g", "12"], " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"-", 
      FractionBox["84", 
       SuperscriptBox[
        StyleBox["\[ScriptU]",
         FontColor->RGBColor[0, 0, 0.4]], "10"]]}], "-", 
     FractionBox[
      RowBox[{"336", " ", "\[ImaginaryI]"}], 
      SuperscriptBox[
       StyleBox["\[ScriptU]",
        FontColor->RGBColor[0, 0, 0.4]], "9"]], "+", 
     FractionBox[
      RowBox[{
       RowBox[{
        RowBox[{"-", "360"}], " ", "\[ImaginaryI]"}], "+", 
       RowBox[{"1296", " ", "\[ImaginaryI]", " ", 
        SubscriptBox[
         StyleBox["\[Zeta]",
          FontWeight->Bold,
          FontColor->GrayLevel[0.4]], "1"]}]}], 
      SuperscriptBox[
       StyleBox["\[ScriptU]",
        FontColor->RGBColor[0, 0, 0.4]], "7"]], "+", 
     FractionBox[
      RowBox[{"168", "+", 
       RowBox[{"336", " ", 
        SubscriptBox[
         StyleBox["\[Zeta]",
          FontWeight->Bold,
          FontColor->GrayLevel[0.4]], "1"]}]}], 
      SuperscriptBox[
       StyleBox["\[ScriptU]",
        FontColor->RGBColor[0, 0, 0.4]], "8"]], "+", 
     FractionBox[
      RowBox[{"222", "-", 
       RowBox[{"840", " ", 
        SubscriptBox[
         StyleBox["\[Zeta]",
          FontWeight->Bold,
          FontColor->GrayLevel[0.4]], "1"]}], "-", 
       RowBox[{"720", " ", 
        SubsuperscriptBox[
         StyleBox["\[Zeta]",
          FontWeight->Bold,
          FontColor->GrayLevel[0.4]], "1", "2"]}], "-", 
       RowBox[{"552", " ", 
        SubscriptBox[
         StyleBox["\[Zeta]",
          FontWeight->Bold,
          FontColor->GrayLevel[0.4]], "3"]}]}], 
      SuperscriptBox[
       StyleBox["\[ScriptU]",
        FontColor->RGBColor[0, 0, 0.4]], "6"]], "+", 
     FractionBox[
      RowBox[{
       RowBox[{"1188", " ", "\[ImaginaryI]"}], "-", 
       RowBox[{"2592", " ", "\[ImaginaryI]", " ", 
        SubsuperscriptBox[
         StyleBox["\[Zeta]",
          FontWeight->Bold,
          FontColor->GrayLevel[0.4]], "1", "2"]}], "-", 
       RowBox[{"2160", " ", "\[ImaginaryI]", " ", 
        SubscriptBox[
         StyleBox["\[Zeta]",
          FontWeight->Bold,
          FontColor->GrayLevel[0.4]], "3"]}]}], 
      SuperscriptBox[
       StyleBox["\[ScriptU]",
        FontColor->RGBColor[0, 0, 0.4]], "5"]], "+", 
     FractionBox[
      RowBox[{
       RowBox[{
        RowBox[{"-", "2364"}], " ", "\[ImaginaryI]"}], "-", 
       RowBox[{"2592", " ", "\[ImaginaryI]", " ", 
        SubscriptBox[
         StyleBox["\[Zeta]",
          FontWeight->Bold,
          FontColor->GrayLevel[0.4]], "1"]}], "+", 
       RowBox[{"2592", " ", "\[ImaginaryI]", " ", 
        SubsuperscriptBox[
         StyleBox["\[Zeta]",
          FontWeight->Bold,
          FontColor->GrayLevel[0.4]], "1", "2"]}], "+", 
       RowBox[{"3456", " ", "\[ImaginaryI]", " ", 
        SubsuperscriptBox[
         StyleBox["\[Zeta]",
          FontWeight->Bold,
          FontColor->GrayLevel[0.4]], "1", "3"]}], "-", 
       RowBox[{"2304", " ", "\[ImaginaryI]", " ", 
        SubscriptBox[
         StyleBox["\[Zeta]",
          FontWeight->Bold,
          FontColor->GrayLevel[0.4]], "3"]}], "+", 
       RowBox[{"5184", " ", "\[ImaginaryI]", " ", 
        SubscriptBox[
         StyleBox["\[Zeta]",
          FontWeight->Bold,
          FontColor->GrayLevel[0.4]], "1"], " ", 
        SubscriptBox[
         StyleBox["\[Zeta]",
          FontWeight->Bold,
          FontColor->GrayLevel[0.4]], "3"]}], "+", 
       RowBox[{"4320", " ", "\[ImaginaryI]", " ", 
        SubscriptBox[
         StyleBox["\[Zeta]",
          FontWeight->Bold,
          FontColor->GrayLevel[0.4]], "5"]}]}], 
      SuperscriptBox[
       StyleBox["\[ScriptU]",
        FontColor->RGBColor[0, 0, 0.4]], "3"]], "+", 
     FractionBox[
      RowBox[{
       RowBox[{"-", "996"}], "-", 
       RowBox[{"312", " ", 
        SubscriptBox[
         StyleBox["\[Zeta]",
          FontWeight->Bold,
          FontColor->GrayLevel[0.4]], "1"]}], "+", 
       RowBox[{"1872", " ", 
        SubsuperscriptBox[
         StyleBox["\[Zeta]",
          FontWeight->Bold,
          FontColor->GrayLevel[0.4]], "1", "2"]}], "+", 
       RowBox[{"1152", " ", 
        SubsuperscriptBox[
         StyleBox["\[Zeta]",
          FontWeight->Bold,
          FontColor->GrayLevel[0.4]], "1", "3"]}], "+", 
       RowBox[{"120", " ", 
        SubscriptBox[
         StyleBox["\[Zeta]",
          FontWeight->Bold,
          FontColor->GrayLevel[0.4]], "3"]}], "+", 
       RowBox[{"2304", " ", 
        SubscriptBox[
         StyleBox["\[Zeta]",
          FontWeight->Bold,
          FontColor->GrayLevel[0.4]], "1"], " ", 
        SubscriptBox[
         StyleBox["\[Zeta]",
          FontWeight->Bold,
          FontColor->GrayLevel[0.4]], "3"]}], "+", 
       RowBox[{"1440", " ", 
        SubscriptBox[
         StyleBox["\[Zeta]",
          FontWeight->Bold,
          FontColor->GrayLevel[0.4]], "5"]}]}], 
      SuperscriptBox[
       StyleBox["\[ScriptU]",
        FontColor->RGBColor[0, 0, 0.4]], "4"]], "+", 
     FractionBox[
      RowBox[{
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          RowBox[{
           RowBox[{"-", "324"}], " ", "\[ImaginaryI]"}], "-", 
          RowBox[{"324", " ", 
           SqrtBox["3"]}]}], ")"}], " ", 
        SubsuperscriptBox[
         StyleBox["\[Eta]0",
          FontWeight->Bold,
          FontColor->RGBColor[0, 0.5, 0]], "2", "+"]}], "+", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{"324", "+", 
          RowBox[{"108", " ", "\[ImaginaryI]", " ", 
           SqrtBox["3"]}]}], ")"}], " ", 
        SubsuperscriptBox[
         StyleBox["\[Eta]0",
          FontWeight->Bold,
          FontColor->RGBColor[0, 0.5, 0]], "3", "+"]}], "+", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          RowBox[{
           RowBox[{"-", "54"}], " ", "\[ImaginaryI]"}], "-", 
          RowBox[{"54", " ", 
           SqrtBox["3"]}]}], ")"}], " ", 
        SubsuperscriptBox[
         StyleBox["\[Eta]0",
          FontWeight->Bold,
          FontColor->RGBColor[0, 0.5, 0]], "4", "+"]}]}], 
      SubsuperscriptBox[
       StyleBox["\[ScriptU]",
        FontColor->RGBColor[0, 0, 0.4]], 
       RowBox[{"-", "v0"}], "+"]], "+", 
     FractionBox[
      RowBox[{
       RowBox[{"972", " ", "\[ImaginaryI]"}], "+", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          RowBox[{
           RowBox[{"-", "324"}], " ", "\[ImaginaryI]"}], "+", 
          RowBox[{"324", " ", 
           SqrtBox["3"]}]}], ")"}], " ", 
        SubsuperscriptBox[
         StyleBox["\[Eta]0",
          FontWeight->Bold,
          FontColor->RGBColor[0, 0.5, 0]], "2", "+"]}], "+", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          RowBox[{"-", "324"}], "+", 
          RowBox[{"108", " ", "\[ImaginaryI]", " ", 
           SqrtBox["3"]}]}], ")"}], " ", 
        SubsuperscriptBox[
         StyleBox["\[Eta]0",
          FontWeight->Bold,
          FontColor->RGBColor[0, 0.5, 0]], "3", "+"]}], "+", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          RowBox[{
           RowBox[{"-", "54"}], " ", "\[ImaginaryI]"}], "+", 
          RowBox[{"54", " ", 
           SqrtBox["3"]}]}], ")"}], " ", 
        SubsuperscriptBox[
         StyleBox["\[Eta]0",
          FontWeight->Bold,
          FontColor->RGBColor[0, 0.5, 0]], "4", "+"]}]}], 
      SubsuperscriptBox[
       StyleBox["\[ScriptU]",
        FontColor->RGBColor[0, 0, 0.4]], 
       RowBox[{"-", "v0"}], "-"]], "+", 
     FractionBox[
      RowBox[{
       RowBox[{
        RowBox[{"-", "1944"}], " ", "\[ImaginaryI]"}], "+", 
       RowBox[{"648", " ", "\[ImaginaryI]", " ", 
        SubsuperscriptBox[
         StyleBox["\[Eta]0",
          FontWeight->Bold,
          FontColor->RGBColor[0, 0.5, 0]], "2", "+"]}], "-", 
       RowBox[{"216", " ", "\[ImaginaryI]", " ", 
        SqrtBox["3"], " ", 
        SubsuperscriptBox[
         StyleBox["\[Eta]0",
          FontWeight->Bold,
          FontColor->RGBColor[0, 0.5, 0]], "3", "+"]}], "+", 
       RowBox[{"108", " ", "\[ImaginaryI]", " ", 
        SubsuperscriptBox[
         StyleBox["\[Eta]0",
          FontWeight->Bold,
          FontColor->RGBColor[0, 0.5, 0]], "4", "+"]}], "+", 
       RowBox[{"648", " ", "\[ImaginaryI]", " ", 
        SubsuperscriptBox[
         OverscriptBox[
          StyleBox["\[Eta]0",
           FontWeight->Bold,
           FontColor->RGBColor[0, 0.5, 0]], 
          StyleBox["_",
           FontWeight->Bold,
           FontColor->RGBColor[0, 0.5, 0]]], "2", "-"]}], "-", 
       RowBox[{"216", " ", "\[ImaginaryI]", " ", 
        SqrtBox["3"], " ", 
        SubsuperscriptBox[
         OverscriptBox[
          StyleBox["\[Eta]0",
           FontWeight->Bold,
           FontColor->RGBColor[0, 0.5, 0]], 
          StyleBox["_",
           FontWeight->Bold,
           FontColor->RGBColor[0, 0.5, 0]]], "3", "-"]}], "+", 
       RowBox[{"108", " ", "\[ImaginaryI]", " ", 
        SubsuperscriptBox[
         OverscriptBox[
          StyleBox["\[Eta]0",
           FontWeight->Bold,
           FontColor->RGBColor[0, 0.5, 0]], 
          StyleBox["_",
           FontWeight->Bold,
           FontColor->RGBColor[0, 0.5, 0]]], "4", "-"]}]}], 
      StyleBox["\[ScriptU]",
       FontColor->RGBColor[0, 0, 0.4]]], "+", 
     RowBox[{
      FractionBox["1", 
       SuperscriptBox[
        StyleBox["\[ScriptU]",
         FontColor->RGBColor[0, 0, 0.4]], "2"]], 
      RowBox[{"(", 
       RowBox[{"2124", "+", 
        RowBox[{"5376", " ", 
         SubscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "1"]}], "+", 
        RowBox[{"2592", " ", 
         SubsuperscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "1", "2"]}], "-", 
        RowBox[{"1728", " ", 
         SubsuperscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "1", "3"]}], "-", 
        RowBox[{"1728", " ", 
         SubsuperscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "1", "4"]}], "+", 
        RowBox[{"5904", " ", 
         SubscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "3"]}], "+", 
        RowBox[{"2016", " ", 
         SubscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "1"], " ", 
         SubscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "3"]}], "-", 
        RowBox[{"5184", " ", 
         SubsuperscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "1", "2"], " ", 
         SubscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "3"]}], "-", 
        RowBox[{"1728", " ", 
         SubsuperscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "3", "2"]}], "+", 
        RowBox[{"3120", " ", 
         SubscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "5"]}], "-", 
        RowBox[{"8640", " ", 
         SubscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "1"], " ", 
         SubscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "5"]}], "-", 
        RowBox[{"5040", " ", 
         SubscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "7"]}], "-", 
        RowBox[{"216", " ", "\[ImaginaryI]", " ", 
         SqrtBox["3"], " ", 
         SubsuperscriptBox[
          StyleBox["\[Eta]0",
           FontWeight->Bold,
           FontColor->RGBColor[0, 0.5, 0]], "2", "+"]}], "+", 
        RowBox[{"216", " ", "\[ImaginaryI]", " ", 
         SubsuperscriptBox[
          StyleBox["\[Eta]0",
           FontWeight->Bold,
           FontColor->RGBColor[0, 0.5, 0]], "3", "+"]}], "-", 
        RowBox[{"36", " ", "\[ImaginaryI]", " ", 
         SqrtBox["3"], " ", 
         SubsuperscriptBox[
          StyleBox["\[Eta]0",
           FontWeight->Bold,
           FontColor->RGBColor[0, 0.5, 0]], "4", "+"]}], "+", 
        RowBox[{"216", " ", "\[ImaginaryI]", " ", 
         SqrtBox["3"], " ", 
         SubsuperscriptBox[
          OverscriptBox[
           StyleBox["\[Eta]0",
            FontWeight->Bold,
            FontColor->RGBColor[0, 0.5, 0]], 
           StyleBox["_",
            FontWeight->Bold,
            FontColor->RGBColor[0, 0.5, 0]]], "2", "-"]}], "-", 
        RowBox[{"216", " ", "\[ImaginaryI]", " ", 
         SubsuperscriptBox[
          OverscriptBox[
           StyleBox["\[Eta]0",
            FontWeight->Bold,
            FontColor->RGBColor[0, 0.5, 0]], 
           StyleBox["_",
            FontWeight->Bold,
            FontColor->RGBColor[0, 0.5, 0]]], "3", "-"]}], "+", 
        RowBox[{"36", " ", "\[ImaginaryI]", " ", 
         SqrtBox["3"], " ", 
         SubsuperscriptBox[
          OverscriptBox[
           StyleBox["\[Eta]0",
            FontWeight->Bold,
            FontColor->RGBColor[0, 0.5, 0]], 
           StyleBox["_",
            FontWeight->Bold,
            FontColor->RGBColor[0, 0.5, 0]]], "4", "-"]}]}], ")"}]}], "+", 
     FractionBox[
      RowBox[{
       RowBox[{"972", " ", "\[ImaginaryI]"}], "+", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          RowBox[{
           RowBox[{"-", "324"}], " ", "\[ImaginaryI]"}], "-", 
          RowBox[{"324", " ", 
           SqrtBox["3"]}]}], ")"}], " ", 
        SubsuperscriptBox[
         OverscriptBox[
          StyleBox["\[Eta]0",
           FontWeight->Bold,
           FontColor->RGBColor[0, 0.5, 0]], 
          StyleBox["_",
           FontWeight->Bold,
           FontColor->RGBColor[0, 0.5, 0]]], "2", "-"]}], "+", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{"324", "+", 
          RowBox[{"108", " ", "\[ImaginaryI]", " ", 
           SqrtBox["3"]}]}], ")"}], " ", 
        SubsuperscriptBox[
         OverscriptBox[
          StyleBox["\[Eta]0",
           FontWeight->Bold,
           FontColor->RGBColor[0, 0.5, 0]], 
          StyleBox["_",
           FontWeight->Bold,
           FontColor->RGBColor[0, 0.5, 0]]], "3", "-"]}], "+", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          RowBox[{
           RowBox[{"-", "54"}], " ", "\[ImaginaryI]"}], "-", 
          RowBox[{"54", " ", 
           SqrtBox["3"]}]}], ")"}], " ", 
        SubsuperscriptBox[
         OverscriptBox[
          StyleBox["\[Eta]0",
           FontWeight->Bold,
           FontColor->RGBColor[0, 0.5, 0]], 
          StyleBox["_",
           FontWeight->Bold,
           FontColor->RGBColor[0, 0.5, 0]]], "4", "-"]}]}], 
      SubsuperscriptBox[
       StyleBox["\[ScriptU]",
        FontColor->RGBColor[0, 0, 0.4]], "v0", "-"]], "+", 
     FractionBox[
      RowBox[{
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          RowBox[{
           RowBox[{"-", "324"}], " ", "\[ImaginaryI]"}], "+", 
          RowBox[{"324", " ", 
           SqrtBox["3"]}]}], ")"}], " ", 
        SubsuperscriptBox[
         OverscriptBox[
          StyleBox["\[Eta]0",
           FontWeight->Bold,
           FontColor->RGBColor[0, 0.5, 0]], 
          StyleBox["_",
           FontWeight->Bold,
           FontColor->RGBColor[0, 0.5, 0]]], "2", "-"]}], "+", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          RowBox[{"-", "324"}], "+", 
          RowBox[{"108", " ", "\[ImaginaryI]", " ", 
           SqrtBox["3"]}]}], ")"}], " ", 
        SubsuperscriptBox[
         OverscriptBox[
          StyleBox["\[Eta]0",
           FontWeight->Bold,
           FontColor->RGBColor[0, 0.5, 0]], 
          StyleBox["_",
           FontWeight->Bold,
           FontColor->RGBColor[0, 0.5, 0]]], "3", "-"]}], "+", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          RowBox[{
           RowBox[{"-", "54"}], " ", "\[ImaginaryI]"}], "+", 
          RowBox[{"54", " ", 
           SqrtBox["3"]}]}], ")"}], " ", 
        SubsuperscriptBox[
         OverscriptBox[
          StyleBox["\[Eta]0",
           FontWeight->Bold,
           FontColor->RGBColor[0, 0.5, 0]], 
          StyleBox["_",
           FontWeight->Bold,
           FontColor->RGBColor[0, 0.5, 0]]], "4", "-"]}]}], 
      SubsuperscriptBox[
       StyleBox["\[ScriptU]",
        FontColor->RGBColor[0, 0, 0.4]], "v0", "+"]], "+", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", 
         FractionBox[
          RowBox[{"336", " ", "\[ImaginaryI]"}], 
          SuperscriptBox[
           StyleBox["\[ScriptU]",
            FontColor->RGBColor[0, 0, 0.4]], "8"]]}], "+", 
        FractionBox["1296", 
         SuperscriptBox[
          StyleBox["\[ScriptU]",
           FontColor->RGBColor[0, 0, 0.4]], "7"]], "+", 
        FractionBox[
         RowBox[{
          RowBox[{"840", " ", "\[ImaginaryI]"}], "+", 
          RowBox[{"1440", " ", "\[ImaginaryI]", " ", 
           SubscriptBox[
            StyleBox["\[Zeta]",
             FontWeight->Bold,
             FontColor->GrayLevel[0.4]], "1"]}]}], 
         SuperscriptBox[
          StyleBox["\[ScriptU]",
           FontColor->RGBColor[0, 0, 0.4]], "6"]], "-", 
        FractionBox[
         RowBox[{"5184", " ", 
          SubscriptBox[
           StyleBox["\[Zeta]",
            FontWeight->Bold,
            FontColor->GrayLevel[0.4]], "1"]}], 
         SuperscriptBox[
          StyleBox["\[ScriptU]",
           FontColor->RGBColor[0, 0, 0.4]], "5"]], "+", 
        FractionBox[
         RowBox[{
          RowBox[{"312", " ", "\[ImaginaryI]"}], "-", 
          RowBox[{"3744", " ", "\[ImaginaryI]", " ", 
           SubscriptBox[
            StyleBox["\[Zeta]",
             FontWeight->Bold,
             FontColor->GrayLevel[0.4]], "1"]}], "-", 
          RowBox[{"3456", " ", "\[ImaginaryI]", " ", 
           SubsuperscriptBox[
            StyleBox["\[Zeta]",
             FontWeight->Bold,
             FontColor->GrayLevel[0.4]], "1", "2"]}], "-", 
          RowBox[{"2304", " ", "\[ImaginaryI]", " ", 
           SubscriptBox[
            StyleBox["\[Zeta]",
             FontWeight->Bold,
             FontColor->GrayLevel[0.4]], "3"]}]}], 
         SuperscriptBox[
          StyleBox["\[ScriptU]",
           FontColor->RGBColor[0, 0, 0.4]], "4"]], "+", 
        FractionBox[
         RowBox[{
          RowBox[{"-", "2592"}], "+", 
          RowBox[{"5184", " ", 
           SubscriptBox[
            StyleBox["\[Zeta]",
             FontWeight->Bold,
             FontColor->GrayLevel[0.4]], "1"]}], "+", 
          RowBox[{"10368", " ", 
           SubsuperscriptBox[
            StyleBox["\[Zeta]",
             FontWeight->Bold,
             FontColor->GrayLevel[0.4]], "1", "2"]}], "+", 
          RowBox[{"5184", " ", 
           SubscriptBox[
            StyleBox["\[Zeta]",
             FontWeight->Bold,
             FontColor->GrayLevel[0.4]], "3"]}]}], 
         SuperscriptBox[
          StyleBox["\[ScriptU]",
           FontColor->RGBColor[0, 0, 0.4]], "3"]], "+", 
        FractionBox[
         RowBox[{
          RowBox[{
           RowBox[{"-", "5376"}], " ", "\[ImaginaryI]"}], "-", 
          RowBox[{"5184", " ", "\[ImaginaryI]", " ", 
           SubscriptBox[
            StyleBox["\[Zeta]",
             FontWeight->Bold,
             FontColor->GrayLevel[0.4]], "1"]}], "+", 
          RowBox[{"5184", " ", "\[ImaginaryI]", " ", 
           SubsuperscriptBox[
            StyleBox["\[Zeta]",
             FontWeight->Bold,
             FontColor->GrayLevel[0.4]], "1", "2"]}], "+", 
          RowBox[{"6912", " ", "\[ImaginaryI]", " ", 
           SubsuperscriptBox[
            StyleBox["\[Zeta]",
             FontWeight->Bold,
             FontColor->GrayLevel[0.4]], "1", "3"]}], "-", 
          RowBox[{"2016", " ", "\[ImaginaryI]", " ", 
           SubscriptBox[
            StyleBox["\[Zeta]",
             FontWeight->Bold,
             FontColor->GrayLevel[0.4]], "3"]}], "+", 
          RowBox[{"10368", " ", "\[ImaginaryI]", " ", 
           SubscriptBox[
            StyleBox["\[Zeta]",
             FontWeight->Bold,
             FontColor->GrayLevel[0.4]], "1"], " ", 
           SubscriptBox[
            StyleBox["\[Zeta]",
             FontWeight->Bold,
             FontColor->GrayLevel[0.4]], "3"]}], "+", 
          RowBox[{"8640", " ", "\[ImaginaryI]", " ", 
           SubscriptBox[
            StyleBox["\[Zeta]",
             FontWeight->Bold,
             FontColor->GrayLevel[0.4]], "5"]}]}], 
         SuperscriptBox[
          StyleBox["\[ScriptU]",
           FontColor->RGBColor[0, 0, 0.4]], "2"]]}], ")"}], " ", 
      SubsuperscriptBox[
       StyleBox["\[Eta]",
        FontWeight->Bold,
        FontColor->RGBColor[0.8, 0, 0]], "1", 
       RowBox[{"[", "2", "]"}]]}], "+", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        FractionBox["648", 
         SuperscriptBox[
          StyleBox["\[ScriptU]",
           FontColor->RGBColor[0, 0, 0.4]], "6"]], "+", 
        FractionBox[
         RowBox[{"2592", " ", "\[ImaginaryI]"}], 
         SuperscriptBox[
          StyleBox["\[ScriptU]",
           FontColor->RGBColor[0, 0, 0.4]], "5"]], "+", 
        FractionBox[
         RowBox[{
          RowBox[{"324", " ", "\[ImaginaryI]"}], "-", 
          RowBox[{"324", " ", 
           SqrtBox["3"]}]}], 
         SubsuperscriptBox[
          StyleBox["\[ScriptU]",
           FontColor->RGBColor[0, 0, 0.4]], 
          RowBox[{"-", "v0"}], "-"]], "+", 
        FractionBox[
         RowBox[{
          RowBox[{"324", " ", "\[ImaginaryI]"}], "+", 
          RowBox[{"324", " ", 
           SqrtBox["3"]}]}], 
         SubsuperscriptBox[
          StyleBox["\[ScriptU]",
           FontColor->RGBColor[0, 0, 0.4]], 
          RowBox[{"-", "v0"}], "+"]], "+", 
        FractionBox[
         RowBox[{
          RowBox[{"324", " ", "\[ImaginaryI]"}], "+", 
          RowBox[{"324", " ", 
           SqrtBox["3"]}]}], 
         SubsuperscriptBox[
          StyleBox["\[ScriptU]",
           FontColor->RGBColor[0, 0, 0.4]], "v0", "-"]], "+", 
        FractionBox[
         RowBox[{
          RowBox[{"324", " ", "\[ImaginaryI]"}], "-", 
          RowBox[{"324", " ", 
           SqrtBox["3"]}]}], 
         SubsuperscriptBox[
          StyleBox["\[ScriptU]",
           FontColor->RGBColor[0, 0, 0.4]], "v0", "+"]], "+", 
        FractionBox[
         RowBox[{
          RowBox[{"-", "2304"}], "-", 
          RowBox[{"3456", " ", 
           SubscriptBox[
            StyleBox["\[Zeta]",
             FontWeight->Bold,
             FontColor->GrayLevel[0.4]], "1"]}]}], 
         SuperscriptBox[
          StyleBox["\[ScriptU]",
           FontColor->RGBColor[0, 0, 0.4]], "4"]], "+", 
        FractionBox[
         RowBox[{
          RowBox[{
           RowBox[{"-", "2376"}], " ", "\[ImaginaryI]"}], "-", 
          RowBox[{"10368", " ", "\[ImaginaryI]", " ", 
           SubscriptBox[
            StyleBox["\[Zeta]",
             FontWeight->Bold,
             FontColor->GrayLevel[0.4]], "1"]}], "-", 
          RowBox[{"864", " ", "\[ImaginaryI]", " ", 
           SubscriptBox[
            StyleBox["\[Zeta]",
             FontWeight->Bold,
             FontColor->GrayLevel[0.4]], "3"]}]}], 
         SuperscriptBox[
          StyleBox["\[ScriptU]",
           FontColor->RGBColor[0, 0, 0.4]], "3"]], "+", 
        FractionBox[
         RowBox[{
          RowBox[{
           RowBox[{"-", "1296"}], " ", "\[ImaginaryI]"}], "-", 
          RowBox[{"2592", " ", "\[ImaginaryI]", " ", 
           SubscriptBox[
            StyleBox["\[Zeta]",
             FontWeight->Bold,
             FontColor->GrayLevel[0.4]], "3"]}]}], 
         StyleBox["\[ScriptU]",
          FontColor->RGBColor[0, 0, 0.4]]], "+", 
        FractionBox[
         RowBox[{
          RowBox[{"-", "2592"}], "+", 
          RowBox[{"5184", " ", 
           SubscriptBox[
            StyleBox["\[Zeta]",
             FontWeight->Bold,
             FontColor->GrayLevel[0.4]], "1"]}], "+", 
          RowBox[{"10368", " ", 
           SubsuperscriptBox[
            StyleBox["\[Zeta]",
             FontWeight->Bold,
             FontColor->GrayLevel[0.4]], "1", "2"]}], "+", 
          RowBox[{"5184", " ", 
           SubscriptBox[
            StyleBox["\[Zeta]",
             FontWeight->Bold,
             FontColor->GrayLevel[0.4]], "3"]}]}], 
         SuperscriptBox[
          StyleBox["\[ScriptU]",
           FontColor->RGBColor[0, 0, 0.4]], "2"]]}], ")"}], " ", 
      SubsuperscriptBox[
       StyleBox["\[Eta]",
        FontWeight->Bold,
        FontColor->RGBColor[0.8, 0, 0]], "2", 
       RowBox[{"[", "2", "]"}]]}], "+", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", 
         FractionBox[
          RowBox[{"120", " ", "\[ImaginaryI]"}], 
          SuperscriptBox[
           StyleBox["\[ScriptU]",
            FontColor->RGBColor[0, 0, 0.4]], "6"]]}], "+", 
        FractionBox["576", 
         SuperscriptBox[
          StyleBox["\[ScriptU]",
           FontColor->RGBColor[0, 0, 0.4]], "5"]], "+", 
        FractionBox[
         RowBox[{"324", "-", 
          RowBox[{"108", " ", "\[ImaginaryI]", " ", 
           SqrtBox["3"]}]}], 
         SubsuperscriptBox[
          StyleBox["\[ScriptU]",
           FontColor->RGBColor[0, 0, 0.4]], 
          RowBox[{"-", "v0"}], "-"]], "+", 
        FractionBox[
         RowBox[{
          RowBox[{"-", "324"}], "-", 
          RowBox[{"108", " ", "\[ImaginaryI]", " ", 
           SqrtBox["3"]}]}], 
         SubsuperscriptBox[
          StyleBox["\[ScriptU]",
           FontColor->RGBColor[0, 0, 0.4]], 
          RowBox[{"-", "v0"}], "+"]], "+", 
        FractionBox[
         RowBox[{"324", "+", 
          RowBox[{"108", " ", "\[ImaginaryI]", " ", 
           SqrtBox["3"]}]}], 
         SubsuperscriptBox[
          StyleBox["\[ScriptU]",
           FontColor->RGBColor[0, 0, 0.4]], "v0", "-"]], "+", 
        FractionBox[
         RowBox[{
          RowBox[{"-", "324"}], "+", 
          RowBox[{"108", " ", "\[ImaginaryI]", " ", 
           SqrtBox["3"]}]}], 
         SubsuperscriptBox[
          StyleBox["\[ScriptU]",
           FontColor->RGBColor[0, 0, 0.4]], "v0", "+"]], "+", 
        FractionBox[
         RowBox[{
          RowBox[{"-", "3096"}], "-", 
          RowBox[{"1728", " ", 
           SubscriptBox[
            StyleBox["\[Zeta]",
             FontWeight->Bold,
             FontColor->GrayLevel[0.4]], "1"]}]}], 
         SuperscriptBox[
          StyleBox["\[ScriptU]",
           FontColor->RGBColor[0, 0, 0.4]], "3"]], "+", 
        FractionBox[
         RowBox[{
          RowBox[{"1272", " ", "\[ImaginaryI]"}], "+", 
          RowBox[{"576", " ", "\[ImaginaryI]", " ", 
           SubscriptBox[
            StyleBox["\[Zeta]",
             FontWeight->Bold,
             FontColor->GrayLevel[0.4]], "1"]}]}], 
         SuperscriptBox[
          StyleBox["\[ScriptU]",
           FontColor->RGBColor[0, 0, 0.4]], "4"]], "+", 
        FractionBox[
         RowBox[{
          RowBox[{
           RowBox[{"-", "528"}], " ", "\[ImaginaryI]"}], "-", 
          RowBox[{"6624", " ", "\[ImaginaryI]", " ", 
           SubscriptBox[
            StyleBox["\[Zeta]",
             FontWeight->Bold,
             FontColor->GrayLevel[0.4]], "1"]}], "-", 
          RowBox[{"1728", " ", "\[ImaginaryI]", " ", 
           SubsuperscriptBox[
            StyleBox["\[Zeta]",
             FontWeight->Bold,
             FontColor->GrayLevel[0.4]], "1", "2"]}], "-", 
          RowBox[{"1152", " ", "\[ImaginaryI]", " ", 
           SubscriptBox[
            StyleBox["\[Zeta]",
             FontWeight->Bold,
             FontColor->GrayLevel[0.4]], "3"]}]}], 
         SuperscriptBox[
          StyleBox["\[ScriptU]",
           FontColor->RGBColor[0, 0, 0.4]], "2"]]}], ")"}], " ", 
      SubsuperscriptBox[
       StyleBox["\[Eta]",
        FontWeight->Bold,
        FontColor->RGBColor[0.8, 0, 0]], "3", 
       RowBox[{"[", "2", "]"}]]}], "+", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        FractionBox["504", 
         SuperscriptBox[
          StyleBox["\[ScriptU]",
           FontColor->RGBColor[0, 0, 0.4]], "4"]], "+", 
        FractionBox[
         RowBox[{"1728", " ", "\[ImaginaryI]"}], 
         SuperscriptBox[
          StyleBox["\[ScriptU]",
           FontColor->RGBColor[0, 0, 0.4]], "3"]], "-", 
        FractionBox[
         RowBox[{"216", " ", "\[ImaginaryI]"}], 
         StyleBox["\[ScriptU]",
          FontColor->RGBColor[0, 0, 0.4]]], "+", 
        FractionBox[
         RowBox[{
          RowBox[{"54", " ", "\[ImaginaryI]"}], "-", 
          RowBox[{"54", " ", 
           SqrtBox["3"]}]}], 
         SubsuperscriptBox[
          StyleBox["\[ScriptU]",
           FontColor->RGBColor[0, 0, 0.4]], 
          RowBox[{"-", "v0"}], "-"]], "+", 
        FractionBox[
         RowBox[{
          RowBox[{"54", " ", "\[ImaginaryI]"}], "+", 
          RowBox[{"54", " ", 
           SqrtBox["3"]}]}], 
         SubsuperscriptBox[
          StyleBox["\[ScriptU]",
           FontColor->RGBColor[0, 0, 0.4]], 
          RowBox[{"-", "v0"}], "+"]], "+", 
        FractionBox[
         RowBox[{
          RowBox[{"54", " ", "\[ImaginaryI]"}], "+", 
          RowBox[{"54", " ", 
           SqrtBox["3"]}]}], 
         SubsuperscriptBox[
          StyleBox["\[ScriptU]",
           FontColor->RGBColor[0, 0, 0.4]], "v0", "-"]], "+", 
        FractionBox[
         RowBox[{
          RowBox[{"54", " ", "\[ImaginaryI]"}], "-", 
          RowBox[{"54", " ", 
           SqrtBox["3"]}]}], 
         SubsuperscriptBox[
          StyleBox["\[ScriptU]",
           FontColor->RGBColor[0, 0, 0.4]], "v0", "+"]], "+", 
        FractionBox[
         RowBox[{
          RowBox[{"-", "1656"}], "-", 
          RowBox[{"3456", " ", 
           SubscriptBox[
            StyleBox["\[Zeta]",
             FontWeight->Bold,
             FontColor->GrayLevel[0.4]], "1"]}]}], 
         SuperscriptBox[
          StyleBox["\[ScriptU]",
           FontColor->RGBColor[0, 0, 0.4]], "2"]]}], ")"}], " ", 
      SubsuperscriptBox[
       StyleBox["\[Eta]",
        FontWeight->Bold,
        FontColor->RGBColor[0.8, 0, 0]], "4", 
       RowBox[{"[", "2", "]"}]]}], "+", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", 
         FractionBox[
          RowBox[{"96", " ", "\[ImaginaryI]"}], 
          SuperscriptBox[
           StyleBox["\[ScriptU]",
            FontColor->RGBColor[0, 0, 0.4]], "4"]]}], "+", 
        FractionBox["288", 
         SuperscriptBox[
          StyleBox["\[ScriptU]",
           FontColor->RGBColor[0, 0, 0.4]], "3"]], "+", 
        FractionBox[
         RowBox[{
          RowBox[{"1488", " ", "\[ImaginaryI]"}], "+", 
          RowBox[{"576", " ", "\[ImaginaryI]", " ", 
           SubscriptBox[
            StyleBox["\[Zeta]",
             FontWeight->Bold,
             FontColor->GrayLevel[0.4]], "1"]}]}], 
         SuperscriptBox[
          StyleBox["\[ScriptU]",
           FontColor->RGBColor[0, 0, 0.4]], "2"]]}], ")"}], " ", 
      SubsuperscriptBox[
       StyleBox["\[Eta]",
        FontWeight->Bold,
        FontColor->RGBColor[0.8, 0, 0]], "5", 
       RowBox[{"[", "2", "]"}]]}], "+", 
     FractionBox[
      RowBox[{"720", " ", 
       SubsuperscriptBox[
        StyleBox["\[Eta]",
         FontWeight->Bold,
         FontColor->RGBColor[0.8, 0, 0]], "6", 
        RowBox[{"[", "2", "]"}]]}], 
      SuperscriptBox[
       StyleBox["\[ScriptU]",
        FontColor->RGBColor[0, 0, 0.4]], "2"]], "-", 
     FractionBox[
      RowBox[{"120", " ", "\[ImaginaryI]", " ", 
       SubsuperscriptBox[
        StyleBox["\[Eta]",
         FontWeight->Bold,
         FontColor->RGBColor[0.8, 0, 0]], "7", 
        RowBox[{"[", "2", "]"}]]}], 
      SuperscriptBox[
       StyleBox["\[ScriptU]",
        FontColor->RGBColor[0, 0, 0.4]], "2"]], "+", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        FractionBox["1440", 
         SuperscriptBox[
          StyleBox["\[ScriptU]",
           FontColor->RGBColor[0, 0, 0.4]], "6"]], "+", 
        FractionBox[
         RowBox[{"5184", " ", "\[ImaginaryI]"}], 
         SuperscriptBox[
          StyleBox["\[ScriptU]",
           FontColor->RGBColor[0, 0, 0.4]], "5"]], "+", 
        FractionBox[
         RowBox[{
          RowBox[{"-", "3744"}], "-", 
          RowBox[{"6912", " ", 
           SubscriptBox[
            StyleBox["\[Zeta]",
             FontWeight->Bold,
             FontColor->GrayLevel[0.4]], "1"]}]}], 
         SuperscriptBox[
          StyleBox["\[ScriptU]",
           FontColor->RGBColor[0, 0, 0.4]], "4"]], "+", 
        FractionBox[
         RowBox[{
          RowBox[{
           RowBox[{"-", "5184"}], " ", "\[ImaginaryI]"}], "-", 
          RowBox[{"20736", " ", "\[ImaginaryI]", " ", 
           SubscriptBox[
            StyleBox["\[Zeta]",
             FontWeight->Bold,
             FontColor->GrayLevel[0.4]], "1"]}]}], 
         SuperscriptBox[
          StyleBox["\[ScriptU]",
           FontColor->RGBColor[0, 0, 0.4]], "3"]], "+", 
        FractionBox[
         RowBox[{
          RowBox[{"-", "5184"}], "+", 
          RowBox[{"10368", " ", 
           SubscriptBox[
            StyleBox["\[Zeta]",
             FontWeight->Bold,
             FontColor->GrayLevel[0.4]], "1"]}], "+", 
          RowBox[{"20736", " ", 
           SubsuperscriptBox[
            StyleBox["\[Zeta]",
             FontWeight->Bold,
             FontColor->GrayLevel[0.4]], "1", "2"]}], "+", 
          RowBox[{"10368", " ", 
           SubscriptBox[
            StyleBox["\[Zeta]",
             FontWeight->Bold,
             FontColor->GrayLevel[0.4]], "3"]}]}], 
         SuperscriptBox[
          StyleBox["\[ScriptU]",
           FontColor->RGBColor[0, 0, 0.4]], "2"]]}], ")"}], " ", 
      SubsuperscriptBox[
       StyleBox["\[Eta]",
        FontWeight->Bold,
        FontColor->RGBColor[0.8, 0, 0]], 
       RowBox[{"1", ",", "1"}], 
       RowBox[{"[", "2", "]"}]]}], "+", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        FractionBox[
         RowBox[{"3456", " ", "\[ImaginaryI]"}], 
         SuperscriptBox[
          StyleBox["\[ScriptU]",
           FontColor->RGBColor[0, 0, 0.4]], "4"]], "-", 
        FractionBox["10368", 
         SuperscriptBox[
          StyleBox["\[ScriptU]",
           FontColor->RGBColor[0, 0, 0.4]], "3"]], "+", 
        FractionBox[
         RowBox[{
          RowBox[{
           RowBox[{"-", "5184"}], " ", "\[ImaginaryI]"}], "-", 
          RowBox[{"20736", " ", "\[ImaginaryI]", " ", 
           SubscriptBox[
            StyleBox["\[Zeta]",
             FontWeight->Bold,
             FontColor->GrayLevel[0.4]], "1"]}]}], 
         SuperscriptBox[
          StyleBox["\[ScriptU]",
           FontColor->RGBColor[0, 0, 0.4]], "2"]]}], ")"}], " ", 
      SubsuperscriptBox[
       StyleBox["\[Eta]",
        FontWeight->Bold,
        FontColor->RGBColor[0.8, 0, 0]], 
       RowBox[{"1", ",", "2"}], 
       RowBox[{"[", "2", "]"}]]}], "+", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        FractionBox["576", 
         SuperscriptBox[
          StyleBox["\[ScriptU]",
           FontColor->RGBColor[0, 0, 0.4]], "4"]], "+", 
        FractionBox[
         RowBox[{"1728", " ", "\[ImaginaryI]"}], 
         SuperscriptBox[
          StyleBox["\[ScriptU]",
           FontColor->RGBColor[0, 0, 0.4]], "3"]], "+", 
        FractionBox[
         RowBox[{
          RowBox[{"-", "6624"}], "-", 
          RowBox[{"3456", " ", 
           SubscriptBox[
            StyleBox["\[Zeta]",
             FontWeight->Bold,
             FontColor->GrayLevel[0.4]], "1"]}]}], 
         SuperscriptBox[
          StyleBox["\[ScriptU]",
           FontColor->RGBColor[0, 0, 0.4]], "2"]]}], ")"}], " ", 
      SubsuperscriptBox[
       StyleBox["\[Eta]",
        FontWeight->Bold,
        FontColor->RGBColor[0.8, 0, 0]], 
       RowBox[{"1", ",", "3"}], 
       RowBox[{"[", "2", "]"}]]}], "+", 
     FractionBox[
      RowBox[{"3456", " ", "\[ImaginaryI]", " ", 
       SubsuperscriptBox[
        StyleBox["\[Eta]",
         FontWeight->Bold,
         FontColor->RGBColor[0.8, 0, 0]], 
        RowBox[{"1", ",", "4"}], 
        RowBox[{"[", "2", "]"}]]}], 
      SuperscriptBox[
       StyleBox["\[ScriptU]",
        FontColor->RGBColor[0, 0, 0.4]], "2"]], "+", 
     FractionBox[
      RowBox[{"576", " ", 
       SubsuperscriptBox[
        StyleBox["\[Eta]",
         FontWeight->Bold,
         FontColor->RGBColor[0.8, 0, 0]], 
        RowBox[{"1", ",", "5"}], 
        RowBox[{"[", "2", "]"}]]}], 
      SuperscriptBox[
       StyleBox["\[ScriptU]",
        FontColor->RGBColor[0, 0, 0.4]], "2"]], "+", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        FractionBox[
         RowBox[{"3456", " ", "\[ImaginaryI]"}], 
         SuperscriptBox[
          StyleBox["\[ScriptU]",
           FontColor->RGBColor[0, 0, 0.4]], "4"]], "-", 
        FractionBox["10368", 
         SuperscriptBox[
          StyleBox["\[ScriptU]",
           FontColor->RGBColor[0, 0, 0.4]], "3"]], "+", 
        FractionBox[
         RowBox[{
          RowBox[{
           RowBox[{"-", "5184"}], " ", "\[ImaginaryI]"}], "-", 
          RowBox[{"20736", " ", "\[ImaginaryI]", " ", 
           SubscriptBox[
            StyleBox["\[Zeta]",
             FontWeight->Bold,
             FontColor->GrayLevel[0.4]], "1"]}]}], 
         SuperscriptBox[
          StyleBox["\[ScriptU]",
           FontColor->RGBColor[0, 0, 0.4]], "2"]]}], ")"}], " ", 
      SubsuperscriptBox[
       StyleBox["\[Eta]",
        FontWeight->Bold,
        FontColor->RGBColor[0.8, 0, 0]], 
       RowBox[{"2", ",", "1"}], 
       RowBox[{"[", "2", "]"}]]}], "-", 
     FractionBox[
      RowBox[{"10800", " ", 
       SubsuperscriptBox[
        StyleBox["\[Eta]",
         FontWeight->Bold,
         FontColor->RGBColor[0.8, 0, 0]], 
        RowBox[{"2", ",", "2"}], 
        RowBox[{"[", "2", "]"}]]}], 
      SuperscriptBox[
       StyleBox["\[ScriptU]",
        FontColor->RGBColor[0, 0, 0.4]], "2"]], "+", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        FractionBox["144", 
         SuperscriptBox[
          StyleBox["\[ScriptU]",
           FontColor->RGBColor[0, 0, 0.4]], "3"]], "+", 
        FractionBox[
         RowBox[{"1728", " ", "\[ImaginaryI]"}], 
         SuperscriptBox[
          StyleBox["\[ScriptU]",
           FontColor->RGBColor[0, 0, 0.4]], "2"]], "+", 
        FractionBox["432", 
         StyleBox["\[ScriptU]",
          FontColor->RGBColor[0, 0, 0.4]]]}], ")"}], " ", 
      SubsuperscriptBox[
       StyleBox["\[Eta]",
        FontWeight->Bold,
        FontColor->RGBColor[0.8, 0, 0]], 
       RowBox[{"2", ",", "3"}], 
       RowBox[{"[", "2", "]"}]]}], "-", 
     FractionBox[
      RowBox[{"144", " ", 
       SubsuperscriptBox[
        StyleBox["\[Eta]",
         FontWeight->Bold,
         FontColor->RGBColor[0.8, 0, 0]], 
        RowBox[{"2", ",", "4"}], 
        RowBox[{"[", "2", "]"}]]}], 
      SuperscriptBox[
       StyleBox["\[ScriptU]",
        FontColor->RGBColor[0, 0, 0.4]], "2"]], "+", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        FractionBox["576", 
         SuperscriptBox[
          StyleBox["\[ScriptU]",
           FontColor->RGBColor[0, 0, 0.4]], "4"]], "+", 
        FractionBox[
         RowBox[{"1728", " ", "\[ImaginaryI]"}], 
         SuperscriptBox[
          StyleBox["\[ScriptU]",
           FontColor->RGBColor[0, 0, 0.4]], "3"]], "+", 
        FractionBox[
         RowBox[{
          RowBox[{"-", "6624"}], "-", 
          RowBox[{"3456", " ", 
           SubscriptBox[
            StyleBox["\[Zeta]",
             FontWeight->Bold,
             FontColor->GrayLevel[0.4]], "1"]}]}], 
         SuperscriptBox[
          StyleBox["\[ScriptU]",
           FontColor->RGBColor[0, 0, 0.4]], "2"]]}], ")"}], " ", 
      SubsuperscriptBox[
       StyleBox["\[Eta]",
        FontWeight->Bold,
        FontColor->RGBColor[0.8, 0, 0]], 
       RowBox[{"3", ",", "1"}], 
       RowBox[{"[", "2", "]"}]]}], "+", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", 
         FractionBox["144", 
          SuperscriptBox[
           StyleBox["\[ScriptU]",
            FontColor->RGBColor[0, 0, 0.4]], "3"]]}], "+", 
        FractionBox[
         RowBox[{"1728", " ", "\[ImaginaryI]"}], 
         SuperscriptBox[
          StyleBox["\[ScriptU]",
           FontColor->RGBColor[0, 0, 0.4]], "2"]], "-", 
        FractionBox["432", 
         StyleBox["\[ScriptU]",
          FontColor->RGBColor[0, 0, 0.4]]]}], ")"}], " ", 
      SubsuperscriptBox[
       StyleBox["\[Eta]",
        FontWeight->Bold,
        FontColor->RGBColor[0.8, 0, 0]], 
       RowBox[{"3", ",", "2"}], 
       RowBox[{"[", "2", "]"}]]}], "+", 
     FractionBox[
      RowBox[{"432", " ", 
       SubsuperscriptBox[
        StyleBox["\[Eta]",
         FontWeight->Bold,
         FontColor->RGBColor[0.8, 0, 0]], 
        RowBox[{"3", ",", "3"}], 
        RowBox[{"[", "2", "]"}]]}], 
      SuperscriptBox[
       StyleBox["\[ScriptU]",
        FontColor->RGBColor[0, 0, 0.4]], "2"]], "+", 
     FractionBox[
      RowBox[{"3456", " ", "\[ImaginaryI]", " ", 
       SubsuperscriptBox[
        StyleBox["\[Eta]",
         FontWeight->Bold,
         FontColor->RGBColor[0.8, 0, 0]], 
        RowBox[{"4", ",", "1"}], 
        RowBox[{"[", "2", "]"}]]}], 
      SuperscriptBox[
       StyleBox["\[ScriptU]",
        FontColor->RGBColor[0, 0, 0.4]], "2"]], "+", 
     FractionBox[
      RowBox[{"576", " ", 
       SubsuperscriptBox[
        StyleBox["\[Eta]",
         FontWeight->Bold,
         FontColor->RGBColor[0.8, 0, 0]], 
        RowBox[{"5", ",", "1"}], 
        RowBox[{"[", "2", "]"}]]}], 
      SuperscriptBox[
       StyleBox["\[ScriptU]",
        FontColor->RGBColor[0, 0, 0.4]], "2"]], "+", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        FractionBox[
         RowBox[{"6912", " ", "\[ImaginaryI]"}], 
         SuperscriptBox[
          StyleBox["\[ScriptU]",
           FontColor->RGBColor[0, 0, 0.4]], "4"]], "-", 
        FractionBox["20736", 
         SuperscriptBox[
          StyleBox["\[ScriptU]",
           FontColor->RGBColor[0, 0, 0.4]], "3"]], "+", 
        FractionBox[
         RowBox[{
          RowBox[{
           RowBox[{"-", "10368"}], " ", "\[ImaginaryI]"}], "-", 
          RowBox[{"41472", " ", "\[ImaginaryI]", " ", 
           SubscriptBox[
            StyleBox["\[Zeta]",
             FontWeight->Bold,
             FontColor->GrayLevel[0.4]], "1"]}]}], 
         SuperscriptBox[
          StyleBox["\[ScriptU]",
           FontColor->RGBColor[0, 0, 0.4]], "2"]]}], ")"}], " ", 
      SubsuperscriptBox[
       StyleBox["\[Eta]",
        FontWeight->Bold,
        FontColor->RGBColor[0.8, 0, 0]], 
       RowBox[{"1", ",", "1", ",", "1"}], 
       RowBox[{"[", "2", "]"}]]}], "-", 
     FractionBox[
      RowBox[{"20736", " ", 
       SubsuperscriptBox[
        StyleBox["\[Eta]",
         FontWeight->Bold,
         FontColor->RGBColor[0.8, 0, 0]], 
        RowBox[{"1", ",", "1", ",", "2"}], 
        RowBox[{"[", "2", "]"}]]}], 
      SuperscriptBox[
       StyleBox["\[ScriptU]",
        FontColor->RGBColor[0, 0, 0.4]], "2"]], "+", 
     FractionBox[
      RowBox[{"3456", " ", "\[ImaginaryI]", " ", 
       SubsuperscriptBox[
        StyleBox["\[Eta]",
         FontWeight->Bold,
         FontColor->RGBColor[0.8, 0, 0]], 
        RowBox[{"1", ",", "1", ",", "3"}], 
        RowBox[{"[", "2", "]"}]]}], 
      SuperscriptBox[
       StyleBox["\[ScriptU]",
        FontColor->RGBColor[0, 0, 0.4]], "2"]], "-", 
     FractionBox[
      RowBox[{"20736", " ", 
       SubsuperscriptBox[
        StyleBox["\[Eta]",
         FontWeight->Bold,
         FontColor->RGBColor[0.8, 0, 0]], 
        RowBox[{"1", ",", "2", ",", "1"}], 
        RowBox[{"[", "2", "]"}]]}], 
      SuperscriptBox[
       StyleBox["\[ScriptU]",
        FontColor->RGBColor[0, 0, 0.4]], "2"]], "+", 
     FractionBox[
      RowBox[{"3456", " ", "\[ImaginaryI]", " ", 
       SubsuperscriptBox[
        StyleBox["\[Eta]",
         FontWeight->Bold,
         FontColor->RGBColor[0.8, 0, 0]], 
        RowBox[{"1", ",", "3", ",", "1"}], 
        RowBox[{"[", "2", "]"}]]}], 
      SuperscriptBox[
       StyleBox["\[ScriptU]",
        FontColor->RGBColor[0, 0, 0.4]], "2"]], "-", 
     FractionBox[
      RowBox[{"20736", " ", 
       SubsuperscriptBox[
        StyleBox["\[Eta]",
         FontWeight->Bold,
         FontColor->RGBColor[0.8, 0, 0]], 
        RowBox[{"2", ",", "1", ",", "1"}], 
        RowBox[{"[", "2", "]"}]]}], 
      SuperscriptBox[
       StyleBox["\[ScriptU]",
        FontColor->RGBColor[0, 0, 0.4]], "2"]], "+", 
     FractionBox[
      RowBox[{"3456", " ", "\[ImaginaryI]", " ", 
       SubsuperscriptBox[
        StyleBox["\[Eta]",
         FontWeight->Bold,
         FontColor->RGBColor[0.8, 0, 0]], 
        RowBox[{"3", ",", "1", ",", "1"}], 
        RowBox[{"[", "2", "]"}]]}], 
      SuperscriptBox[
       StyleBox["\[ScriptU]",
        FontColor->RGBColor[0, 0, 0.4]], "2"]], "-", 
     FractionBox[
      RowBox[{"41472", " ", 
       SubsuperscriptBox[
        StyleBox["\[Eta]",
         FontWeight->Bold,
         FontColor->RGBColor[0.8, 0, 0]], 
        RowBox[{"1", ",", "1", ",", "1", ",", "1"}], 
        RowBox[{"[", "2", "]"}]]}], 
      SuperscriptBox[
       StyleBox["\[ScriptU]",
        FontColor->RGBColor[0, 0, 0.4]], "2"]]}], ")"}]}]}]], "Output",
 CellChangeTimes->{{3.563302759716028*^9, 3.563302785935676*^9}, 
   3.563302863397468*^9}]
}, Open  ]],

Cell[BoxData[{
 RowBox[{
  RowBox[{"AddNsDefinition", "[", 
   RowBox[{"{", 
    RowBox[{
     SuperscriptBox[
      RowBox[{"U$", "[", "0", "]"}], "2"], ",", 
     RowBox[{"PrepareList", "[", "Ufiveloopsquared", "]"}]}], "}"}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"AddNsDefinition", "[", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"U$", "[", "0", "]"}], ",", 
     RowBox[{"PrepareList", "[", "Ufiveloop", "]"}]}], "}"}], "]"}], 
  ";"}]}], "Input",
 CellChangeTimes->{{3.5633028890061207`*^9, 3.563302914656678*^9}, {
  3.5633029514622183`*^9, 3.563302994307969*^9}, {3.563304277421791*^9, 
  3.563304314816065*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["q13fiveloop", "Subsection",
 CellChangeTimes->{{3.560866902544417*^9, 3.560866912004005*^9}, {
  3.5614767292850533`*^9, 3.5614767316090813`*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{
    OverscriptBox["Q", "~"], "=", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{"u", "-", 
       SubscriptBox["v", "0"], "-", "\[Alpha]"}], ")"}], 
     RowBox[{"(", 
      RowBox[{"u", "+", 
       SubscriptBox["v", "0"], "+", 
       OverscriptBox["\[Alpha]", "_"]}], ")"}]}]}], ",", 
   RowBox[{
    OverscriptBox[
     OverscriptBox["Q", "~"], "_"], "=", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{"u", "-", 
       SubscriptBox["v", "0"], "-", 
       OverscriptBox["\[Alpha]", "_"]}], ")"}], 
     RowBox[{"(", 
      RowBox[{"u", "+", 
       SubscriptBox["v", "0"], "+", "\[Alpha]"}], ")"}]}]}]}], "}"}]], "Input"],

Cell[BoxData[
 RowBox[{
  SubscriptBox["q", 
   RowBox[{"1", ",", "3"}]], "=", 
  RowBox[{
   SubscriptBox["q", 
    RowBox[{"1", ",", "2"}]], 
   FractionBox["D", 
    RowBox[{"1", "-", 
     SuperscriptBox["D", "2"]}]], 
   FractionBox["U", 
    RowBox[{
     SubsuperscriptBox["q", 
      RowBox[{"1", ",", "2"}], "+"], 
     SubsuperscriptBox["q", 
      RowBox[{"1", ",", "2"}], "-"]}]]}]}]], "Input",
 CellChangeTimes->{{3.563304544830415*^9, 3.563304565141852*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"tmp", "=", 
  RowBox[{"List", "@@", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"Series", "[", 
      RowBox[{
       RowBox[{
        RowBox[{
         FractionBox[
          SuperscriptBox["U", "2"], 
          RowBox[{
           SubsuperscriptBox["q", 
            RowBox[{"1", ",", "2"}], "+"], 
           SubsuperscriptBox["q", 
            RowBox[{"1", ",", "2"}], "-"]}]], "/.", "substandardq"}], "/.", 
        "nspowers"}], ",", 
       RowBox[{"{", 
        RowBox[{"g", ",", "0", ",", "12"}], "}"}]}], "]"}], "//", "Normal"}], 
    ")"}]}]}]], "Input",
 CellChangeTimes->{{3.563304570540576*^9, 3.5633046117643337`*^9}, {
  3.563304643288118*^9, 3.563304672067299*^9}, {3.563304776626068*^9, 
  3.5633047811434793`*^9}}],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"nspowers", "::", "asymcheck"}], "MessageName"], 
  RowBox[{
  ":", " "}], "\<\"\[NoBreak]\\!\\(\\*StyleBox[\\\"U\\\", \
List[Rule[FontColor, RGBColor[0, 0.6`, 0]]]]\\)\[NoBreak] assumed to be in \
the ordinary regime\"\>"}]], "Message", "MSG",
 CellChangeTimes->{{3.563304581685803*^9, 3.563304612154191*^9}, {
  3.5633046689234123`*^9, 3.563304672699585*^9}, {3.5633047774800797`*^9, 
  3.5633047813685513`*^9}, {3.5633050694023333`*^9, 3.56330507088867*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   FractionBox[
    RowBox[{
     SuperscriptBox["g", "4"], " ", 
     SuperscriptBox[
      StyleBox["U",
       FontColor->RGBColor[0, 0.6, 0]], "2"]}], 
    RowBox[{
     SuperscriptBox[
      StyleBox["Q",
       FontColor->RGBColor[0.8, 0, 0]], "-"], " ", 
     SuperscriptBox[
      StyleBox["Q",
       FontColor->RGBColor[0.8, 0, 0]], "+"]}]], ",", 
   RowBox[{
    SuperscriptBox["g", "12"], " ", 
    RowBox[{"(", 
     RowBox[{
      FractionBox[
       RowBox[{
        RowBox[{"\[ImaginaryI]", " ", "\[Alpha]"}], "+", 
        RowBox[{"2", " ", "u", " ", "\[Alpha]"}], "-", 
        RowBox[{"\[ImaginaryI]", " ", 
         OverscriptBox["\[Alpha]", "_"]}], "-", 
        RowBox[{"2", " ", "u", " ", 
         OverscriptBox["\[Alpha]", "_"]}], "+", 
        RowBox[{"2", " ", "\[Alpha]", " ", 
         SubscriptBox["v", "0"]}], "+", 
        RowBox[{"2", " ", 
         OverscriptBox["\[Alpha]", "_"], " ", 
         SubscriptBox["v", "0"]}]}], 
       RowBox[{"2", " ", 
        SuperscriptBox[
         StyleBox["Q",
          FontColor->RGBColor[0.8, 0, 0]], "-"], " ", 
        SuperscriptBox[
         RowBox[{"(", 
          SuperscriptBox[
           StyleBox["Q",
            FontColor->RGBColor[0.8, 0, 0]], "+"], ")"}], "2"]}]], "+", 
      FractionBox[
       RowBox[{
        RowBox[{
         RowBox[{"-", "\[ImaginaryI]"}], " ", "\[Alpha]"}], "+", 
        RowBox[{"2", " ", "u", " ", "\[Alpha]"}], "+", 
        RowBox[{"\[ImaginaryI]", " ", 
         OverscriptBox["\[Alpha]", "_"]}], "-", 
        RowBox[{"2", " ", "u", " ", 
         OverscriptBox["\[Alpha]", "_"]}], "+", 
        RowBox[{"2", " ", "\[Alpha]", " ", 
         SubscriptBox["v", "0"]}], "+", 
        RowBox[{"2", " ", 
         OverscriptBox["\[Alpha]", "_"], " ", 
         SubscriptBox["v", "0"]}]}], 
       RowBox[{"2", " ", 
        SuperscriptBox[
         RowBox[{"(", 
          SuperscriptBox[
           StyleBox["Q",
            FontColor->RGBColor[0.8, 0, 0]], "-"], ")"}], "2"], " ", 
        SuperscriptBox[
         StyleBox["Q",
          FontColor->RGBColor[0.8, 0, 0]], "+"]}]]}], ")"}], " ", 
    SuperscriptBox[
     StyleBox["U",
      FontColor->RGBColor[0, 0.6, 0]], "2"]}]}], "}"}]], "Output",
 CellChangeTimes->{{3.56330457398666*^9, 3.563304612176775*^9}, {
  3.563304668946034*^9, 3.56330467272224*^9}, {3.563304777500945*^9, 
  3.563304781389394*^9}, {3.563305069425745*^9, 3.5633050709096537`*^9}}]
}, Open  ]],

Cell[BoxData[{
 RowBox[{
  RowBox[{"tmp2", "=", 
   RowBox[{"Collect", "[", 
    RowBox[{
     RowBox[{"Collect", "[", 
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{"Series", "[", 
          RowBox[{
           RowBox[{
            RowBox[{
             RowBox[{
              RowBox[{"tmp", "[", 
               RowBox[{"[", "1", "]"}], "]"}], "/.", 
              RowBox[{"g", "\[Rule]", "1"}]}], "/.", 
             RowBox[{"nsweak", "[", "5", "]"}]}], "/.", 
            RowBox[{"leadweak", "[", "5", "]"}]}], ",", 
           RowBox[{"{", 
            RowBox[{"g", ",", "0", ",", "12"}], "}"}]}], "]"}], "/.", 
         "subtousu"}], "//", "Normal"}], ",", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"g", ",", "\[Eta]list"}], "}"}], "//", "Flatten"}], ",", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          RowBox[{"#", "//", "funapartusu"}], "//", "funreduceusu"}], ")"}], 
        "&"}]}], "]"}], ",", "canlist"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"tmp3", "=", 
   RowBox[{"Collect", "[", 
    RowBox[{
     RowBox[{"Collect", "[", 
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{"Series", "[", 
          RowBox[{
           RowBox[{
            RowBox[{
             RowBox[{
              RowBox[{"tmp", "[", 
               RowBox[{"[", "2", "]"}], "]"}], "/.", 
              RowBox[{"g", "\[Rule]", "1"}]}], "/.", 
             RowBox[{"nsweak", "[", "1", "]"}]}], "/.", 
            RowBox[{"leadweak", "[", "1", "]"}]}], ",", 
           RowBox[{"{", 
            RowBox[{"g", ",", "0", ",", "12"}], "}"}]}], "]"}], "/.", 
         "subtousu"}], "//", "Normal"}], ",", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"g", ",", "\[Eta]list"}], "}"}], "//", "Flatten"}], ",", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          RowBox[{"#", "//", "funapartusu"}], "//", "funreduceusu"}], ")"}], 
        "&"}]}], "]"}], ",", "canlist"}], "]"}]}], ";"}]}], "Input",
 CellChangeTimes->{{3.563304673772481*^9, 3.5633047662567863`*^9}, {
  3.5633048087145863`*^9, 3.563304898674024*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"tmp4", "=", 
   RowBox[{"Collect", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"tmp2", "+", "tmp3"}], "/.", "subIm"}], ",", "canlist"}], 
    "]"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.563304916556164*^9, 3.56330493236649*^9}, {
  3.563305062643449*^9, 3.563305063778968*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"thatsit", "=", 
   RowBox[{"Coefficient", "[", 
    RowBox[{"tmp4", ",", "g", ",", "12"}], "]"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.563305096988764*^9, 3.5633051075688972`*^9}}],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"FreeQ", "[", 
  RowBox[{"thatsit", ",", "u"}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"alldens", "=", 
  RowBox[{"List", "@@", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"Times", "@@", 
      RowBox[{"(", 
       RowBox[{"Denominator", "/@", 
        RowBox[{"List", "@@", 
         RowBox[{"Expand", "[", "tmp4", "]"}]}]}], ")"}]}], "/.", 
     RowBox[{
      RowBox[{"Power", "[", 
       RowBox[{"a_", ",", "b_"}], "]"}], "\[RuleDelayed]", "a"}]}], 
    ")"}]}]}]}], "Input",
 CellChangeTimes->{{3.562260141886765*^9, 3.562260196023489*^9}, {
  3.5622661368281927`*^9, 3.562266163874578*^9}, {3.5633051239394617`*^9, 
  3.5633051244112*^9}}],

Cell[BoxData["True"], "Output",
 CellChangeTimes->{{3.562260159709598*^9, 3.562260196551879*^9}, {
   3.562266146130375*^9, 3.562266164327821*^9}, 3.563305006559554*^9, {
   3.563305118553192*^9, 3.5633051250265923`*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   StyleBox["\[ScriptU]",
    FontColor->RGBColor[0, 0, 0.4]], ",", 
   SubsuperscriptBox[
    StyleBox["\[ScriptU]",
     FontColor->RGBColor[0, 0, 0.4]], 
    RowBox[{"-", "v0"}], "-"], ",", 
   SubsuperscriptBox[
    StyleBox["\[ScriptU]",
     FontColor->RGBColor[0, 0, 0.4]], 
    RowBox[{"-", "v0"}], "+"], ",", 
   SubsuperscriptBox[
    StyleBox["\[ScriptU]",
     FontColor->RGBColor[0, 0, 0.4]], "v0", "-"], ",", 
   SubsuperscriptBox[
    StyleBox["\[ScriptU]",
     FontColor->RGBColor[0, 0, 0.4]], "v0", "+"]}], "}"}]], "Output",
 CellChangeTimes->{{3.562260159709598*^9, 3.562260196551879*^9}, {
   3.562266146130375*^9, 3.562266164327821*^9}, 3.563305006559554*^9, {
   3.563305118553192*^9, 3.5633051251261168`*^9}}]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"thatsit", "=", "tmp4"}], ";"}]], "Input",
 CellChangeTimes->{{3.563305160094799*^9, 3.563305164245285*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"Collect", "[", 
   RowBox[{
    RowBox[{"thatsit", "//", "Expand"}], ",", 
    RowBox[{
     RowBox[{"\[ScriptU]$", "[", "_", "]"}], "[", "_", "]"}]}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"trm", "=", 
   RowBox[{"Join", "[", 
    RowBox[{
     RowBox[{"Table", "[", 
      RowBox[{
       RowBox[{"Select", "[", 
        RowBox[{"%", ",", 
         RowBox[{
          RowBox[{
           RowBox[{"FreeQ", "[", 
            RowBox[{"#", ",", 
             RowBox[{"Alternatives", "@@", 
              RowBox[{"Drop", "[", 
               RowBox[{"alldens", ",", "i"}], "]"}]}]}], "]"}], "&&", 
           RowBox[{"Not", "@", 
            RowBox[{"FreeQ", "[", 
             RowBox[{"#", ",", 
              RowBox[{"alldens", "[", 
               RowBox[{"[", "i", "]"}], "]"}]}], "]"}]}]}], "&"}]}], "]"}], 
       ",", 
       RowBox[{"{", 
        RowBox[{"i", ",", 
         RowBox[{"Length", "[", "alldens", "]"}]}], "}"}]}], "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"Select", "[", 
       RowBox[{"%", ",", 
        RowBox[{
         RowBox[{"FreeQ", "[", 
          RowBox[{"#", ",", 
           RowBox[{"Alternatives", "@@", "alldens"}]}], "]"}], "&"}]}], "]"}],
       "}"}]}], "]"}]}], ";"}]}], "Input",
 CellChangeTimes->{{3.56226039110525*^9, 3.562260403873473*^9}, {
  3.5622605137510242`*^9, 3.562260583402296*^9}, {3.5622661678240223`*^9, 
  3.562266180803206*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Length", "[", "trm", "]"}]], "Input",
 CellChangeTimes->{{3.562266220946697*^9, 3.562266223636744*^9}}],

Cell[BoxData["6"], "Output",
 CellChangeTimes->{3.5622662240390043`*^9, 3.563305178133552*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"trm", "[", 
  RowBox[{"[", 
   RowBox[{"-", "1"}], "]"}], "]"}]], "Input",
 CellChangeTimes->{{3.56226622516294*^9, 3.562266227410492*^9}}],

Cell[BoxData["0"], "Output",
 CellChangeTimes->{3.56226622781238*^9, 3.563305179523625*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Total", "[", "trm", "]"}], "-", "thatsit"}], "//", 
  "Expand"}]], "Input",
 CellChangeTimes->{{3.562266211546856*^9, 3.562266218540893*^9}}],

Cell[BoxData["0"], "Output",
 CellChangeTimes->{{3.56226621902826*^9, 3.562266233094*^9}, 
   3.5633051814918118`*^9}]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{
   FractionBox["1", 
    RowBox[{"1", "-", 
     SuperscriptBox["D", "2"]}]], 
   FractionBox[
    SuperscriptBox["U", "2"], 
    RowBox[{
     SuperscriptBox["Q0", "+"], 
     SuperscriptBox["Q0", "-"]}]]}], "\[Equal]", 
  RowBox[{"minsguys", "+", 
   RowBox[{
    FractionBox["1", 
     RowBox[{"1", "-", 
      SuperscriptBox["D", "2"]}]], 
    RowBox[{"(", 
     RowBox[{"plusguys", "+", 
      SuperscriptBox["minsguys", 
       RowBox[{"[", "2", "]"}]]}], ")"}]}], "+", 
   RowBox[{
    FractionBox["1", 
     RowBox[{"1", "-", 
      SuperscriptBox["D", "2"]}]], "othrguys"}]}]}]], "Input"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"othrguys", "=", 
   RowBox[{"trm", "[", 
    RowBox[{"[", "1", "]"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"plusguys", "=", 
   RowBox[{
    RowBox[{"trm", "[", 
     RowBox[{"[", "3", "]"}], "]"}], "+", 
    RowBox[{"trm", "[", 
     RowBox[{"[", "5", "]"}], "]"}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"minsguys", "=", 
   RowBox[{
    RowBox[{"trm", "[", 
     RowBox[{"[", "2", "]"}], "]"}], "+", 
    RowBox[{"trm", "[", 
     RowBox[{"[", "4", "]"}], "]"}]}]}], ";"}]}], "Input",
 CellChangeTimes->{{3.562266429309249*^9, 3.562266485972539*^9}, {
  3.562266516354813*^9, 3.56226651710714*^9}}],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"rlt1", "=", 
   RowBox[{
    RowBox[{
     RowBox[{"ExpaCol", "[", 
      RowBox[{
       RowBox[{"othrguys", " ", "AAA"}], ",", 
       RowBox[{"Flatten", "[", 
        RowBox[{"\[Eta]patt", "|", "\[ScriptU]", "|", "AAA"}], "]"}]}], "]"}],
      "/.", 
     RowBox[{
      RowBox[{"AAA", " ", 
       SuperscriptBox["\[ScriptU]", 
        RowBox[{"pow_", "/;", 
         RowBox[{"pow", "<", "0"}]}]], 
       RowBox[{
        RowBox[{"\[Eta]$", "[", "a__", "]"}], "[", "2", "]"}]}], 
      "\[RuleDelayed]", 
      RowBox[{
       RowBox[{"\[Eta]$", "[", 
        RowBox[{
         RowBox[{"-", "pow"}], ",", "a"}], "]"}], "[", "0", "]"}]}]}], "/.", 
    RowBox[{
     RowBox[{"AAA", " ", 
      SuperscriptBox["\[ScriptU]", 
       RowBox[{"pow_", "/;", 
        RowBox[{"pow", "<", "0"}]}]]}], "\[RuleDelayed]", 
     RowBox[{
      RowBox[{"\[Eta]$", "[", 
       RowBox[{"-", "pow"}], "]"}], "[", "0", "]"}]}]}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"FreeQ", "[", 
  RowBox[{"rlt1", ",", "AAA"}], "]"}]}], "Input",
 CellChangeTimes->{{3.562266257235344*^9, 3.562266372310899*^9}, 
   3.562266450691483*^9}],

Cell[BoxData["True"], "Output",
 CellChangeTimes->{{3.562266259444532*^9, 3.562266297307125*^9}, {
   3.562266355090972*^9, 3.562266372761181*^9}, 3.5622664608965263`*^9, 
   3.563305242627646*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"rlt1", "-", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"rlt1", "/.", 
          RowBox[{"Shift", "[", "2", "]"}]}], "/.", 
         RowBox[{"u", "\[Rule]", 
          RowBox[{"u", "+", "\[ImaginaryI]"}]}]}], ")"}]}], "/.", 
      RowBox[{"shiftp\[Eta]", "[", "0", "]"}]}], ")"}], "-", "othrguys"}], "/.",
    "subusu"}], "//", "Expand"}]], "Input",
 CellChangeTimes->{{3.562266374270647*^9, 3.56226640510187*^9}, 
   3.56226645961683*^9}],

Cell[BoxData["0"], "Output",
 CellChangeTimes->{{3.562266396326579*^9, 3.5622664057310534`*^9}, 
   3.562266461947289*^9, 3.5633052444215183`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"tmp", "=", 
   RowBox[{"Collect", "[", 
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{"plusguys", "+", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"minsguys", "/.", 
             RowBox[{"Shift", "[", "2", "]"}]}], "/.", 
            RowBox[{"u", "\[Rule]", 
             RowBox[{"u", "+", "\[ImaginaryI]"}]}]}], ")"}]}], "//.", 
         RowBox[{"shiftp\[Eta]", "[", "2", "]"}]}], "/.", "subtousu"}], "//", 
       "funapartusu"}], "//", "funreduceusu"}], ",", "canlist"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"rlt2", "=", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{"ExpaCol", "[", 
        RowBox[{
         RowBox[{"AAA", " ", "tmp"}], ",", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{"\[Eta]patt", "|", 
            RowBox[{
             RowBox[{"\[ScriptU]$", "[", "_", "]"}], "[", "_", "]"}], "|", 
            "AAA"}], ")"}], "//", "Flatten"}]}], "]"}], "/.", 
       RowBox[{"Shift", "[", 
        RowBox[{"-", "2"}], "]"}]}], "/.", 
      RowBox[{
       RowBox[{"AAA", " ", 
        SuperscriptBox["\[ScriptU]", 
         RowBox[{"pow_", "/;", 
          RowBox[{"pow", "<", "0"}]}]], 
        RowBox[{
         RowBox[{"\[Eta]$", "[", "a__", "]"}], "[", "2", "]"}]}], 
       "\[RuleDelayed]", 
       RowBox[{
        RowBox[{"\[Eta]$", "[", 
         RowBox[{
          RowBox[{"-", "pow"}], ",", "a"}], "]"}], "[", "0", "]"}]}]}], "/.", 
     
     RowBox[{
      RowBox[{"AAA", " ", 
       SuperscriptBox["\[ScriptU]", 
        RowBox[{"pow_", "/;", 
         RowBox[{"pow", "<", "0"}]}]]}], "\[RuleDelayed]", 
      RowBox[{
       RowBox[{"\[Eta]$", "[", 
        RowBox[{"-", "pow"}], "]"}], "[", "0", "]"}]}]}], "/.", 
    RowBox[{"Shift", "[", "2", "]"}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"rlt2", "-", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"rlt2", "/.", 
          RowBox[{"Shift", "[", "2", "]"}]}], "/.", 
         RowBox[{"u", "\[Rule]", 
          RowBox[{"u", "+", "\[ImaginaryI]"}]}]}], ")"}]}], "/.", 
      RowBox[{"shiftp\[Eta]", "[", "2", "]"}]}], ")"}], "-", "tmp"}], "/.", 
   "subusu"}], "//", "Expand"}]}], "Input",
 CellChangeTimes->{{3.562266496096838*^9, 3.5622665705123796`*^9}, {
  3.562266611871232*^9, 3.56226677824368*^9}}],

Cell[BoxData["0"], "Output",
 CellChangeTimes->{
  3.562266520547687*^9, 3.562266571854011*^9, 3.5622666152346888`*^9, 
   3.56226666620086*^9, {3.562266739785541*^9, 3.562266778856223*^9}, 
   3.56330525248144*^9}]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"preq13", "=", 
   RowBox[{"Collect", "[", 
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{
          RowBox[{
           RowBox[{"minsguys", "+", "rlt1", "+", "rlt2"}], "/.", 
           RowBox[{"Shift", "[", "1", "]"}]}], "/.", 
          RowBox[{"u", "\[Rule]", 
           RowBox[{"u", "+", 
            RowBox[{"\[ImaginaryI]", "/", "2"}]}]}]}], "//.", 
         RowBox[{"shiftm\[Eta]", "[", "3", "]"}]}], "//.", "subtousu"}], "//",
        "funapartusu"}], "//", "funreduceusu"}], ",", "canlist"}], "]"}]}], 
  ";"}]], "Input",
 CellChangeTimes->{{3.56226682426929*^9, 3.562266868028184*^9}, {
  3.563305330146161*^9, 3.563305372689372*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Collect", "[", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{
        RowBox[{"preq13", "/.", 
         RowBox[{"Shift", "[", 
          RowBox[{"-", "1"}], "]"}]}], "/.", 
        RowBox[{"u", "\[Rule]", 
         RowBox[{"u", "-", 
          RowBox[{"\[ImaginaryI]", "/", "2"}]}]}]}], "//.", 
       RowBox[{"shiftp\[Eta]", "[", "0", "]"}]}], ")"}], "-", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"preq13", "/.", 
        RowBox[{"Shift", "[", "1", "]"}]}], "/.", 
       RowBox[{"u", "\[Rule]", 
        RowBox[{"u", "+", 
         RowBox[{"\[ImaginaryI]", "/", "2"}]}]}]}], ")"}], "-", "tmp4"}], "/.",
     "subusu"}], ",", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"g", ",", "\[Eta]list"}], "}"}], "//", "Flatten"}], ",", 
   "Simplify"}], "]"}]], "Input",
 CellChangeTimes->{{3.563305375551408*^9, 3.5633054561835203`*^9}}],

Cell[BoxData["0"], "Output",
 CellChangeTimes->{3.563305377834938*^9, 3.5633054576633053`*^9}]
}, Open  ]],

Cell[TextData[{
 "It remains to multiply this expression on ",
 Cell[BoxData[
  FormBox[
   SubscriptBox["q", 
    RowBox[{"1", ",", "2"}]], TraditionalForm]],
  FormatType->"TraditionalForm"]
}], "Text",
 CellChangeTimes->{{3.563305465928132*^9, 3.5633054757081842`*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"Collect", "[", 
   RowBox[{
    RowBox[{"Series", "[", 
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{
          RowBox[{
           SubscriptBox["q", 
            RowBox[{"1", ",", "2"}]], "/.", "substandardq"}], "/.", 
          RowBox[{
           RowBox[{"xxx", ":", 
            RowBox[{"\[Alpha]", "|", 
             OverscriptBox["\[Alpha]", "_"]}]}], "\[RuleDelayed]", 
           RowBox[{"(", 
            RowBox[{"xxx", "/.", 
             RowBox[{"leadweak", "[", "1", "]"}]}], ")"}]}]}], "/.", 
         RowBox[{"leadweak", "[", "5", "]"}]}], "/.", "subIm"}], "/.", 
       "subQ0"}], ",", 
      RowBox[{"{", 
       RowBox[{"g", ",", "0", ",", "8"}], "}"}]}], "]"}], ",", "canlist"}], 
   "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"q13atfiveloops", "=", 
   RowBox[{"Collect", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"Normal", "@", 
       RowBox[{"Series", "[", 
        RowBox[{
         RowBox[{"%", " ", "preq13"}], ",", 
         RowBox[{"{", 
          RowBox[{"g", ",", "0", ",", "12"}], "}"}]}], "]"}]}], "//", 
      "funreduceusu"}], ",", "canlist"}], "]"}]}], ";"}]}], "Input",
 CellChangeTimes->{{3.5633054767824297`*^9, 3.563305601493984*^9}, {
  3.5633056342423487`*^9, 3.563305635138412*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Series", "[", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"q13atfiveloops", "-", 
      SubscriptBox["q", 
       RowBox[{"1", ",", "3"}]]}], "/.", 
     RowBox[{"leadweak", "[", "4", "]"}]}], "/.", "subQ0"}], ",", 
   RowBox[{"{", 
    RowBox[{"g", ",", "0", ",", "10"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.5633056103029222`*^9, 3.5633056127958813`*^9}, {
  3.563305667305888*^9, 3.563305686947042*^9}}],

Cell[BoxData[
 InterpretationBox[
  SuperscriptBox[
   RowBox[{"O", "[", "g", "]"}], "11"],
  SeriesData[$CellContext`g, 0, {}, 11, 11, 1],
  Editable->False]], "Output",
 CellChangeTimes->{{3.5633056823712473`*^9, 3.56330568814113*^9}}]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"AddNsDefinition", "[", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{
      RowBox[{"q$", "[", 
       RowBox[{"1", ",", "3"}], "]"}], "[", "0", "]"}], ",", 
     RowBox[{"PrepareList", "[", "q13atfiveloops", "]"}]}], "}"}], "]"}], 
  ";"}]], "Input",
 CellChangeTimes->{{3.563305692728593*^9, 3.5633057273526154`*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["q14fiveloop", "Subsection",
 CellChangeTimes->{{3.560866902544417*^9, 3.560866912004005*^9}, {
  3.5614767292850533`*^9, 3.5614767316090813`*^9}, {3.563305849778946*^9, 
  3.563305849873334*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{
    OverscriptBox["Q", "~"], "=", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{"u", "-", 
       SubscriptBox["v", "0"], "-", "\[Alpha]"}], ")"}], 
     RowBox[{"(", 
      RowBox[{"u", "+", 
       SubscriptBox["v", "0"], "+", 
       OverscriptBox["\[Alpha]", "_"]}], ")"}]}]}], ",", 
   RowBox[{
    OverscriptBox[
     OverscriptBox["Q", "~"], "_"], "=", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{"u", "-", 
       SubscriptBox["v", "0"], "-", 
       OverscriptBox["\[Alpha]", "_"]}], ")"}], 
     RowBox[{"(", 
      RowBox[{"u", "+", 
       SubscriptBox["v", "0"], "+", "\[Alpha]"}], ")"}]}]}]}], "}"}]], "Input"],

Cell[BoxData[
 RowBox[{
  SubscriptBox["q", 
   RowBox[{"1", ",", "4"}]], "=", 
  RowBox[{
   SubscriptBox["q", 
    RowBox[{"1", ",", "2"}]], 
   FractionBox["D", 
    RowBox[{"1", "-", 
     SuperscriptBox["D", "2"]}]], 
   FractionBox[
    RowBox[{
     SubscriptBox["q", "2"], "U"}], 
    RowBox[{
     SubsuperscriptBox["q", 
      RowBox[{"1", ",", "2"}], "+"], 
     SubsuperscriptBox["q", 
      RowBox[{"1", ",", "2"}], "-"]}]]}]}]], "Input",
 CellChangeTimes->{{3.563304544830415*^9, 3.563304565141852*^9}, {
  3.5633061662551622`*^9, 3.563306169655513*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"tmp", "=", 
  RowBox[{"List", "@@", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"Series", "[", 
      RowBox[{
       RowBox[{
        RowBox[{
         FractionBox[
          RowBox[{
           SubscriptBox["q", "2"], 
           SuperscriptBox["U", "2"]}], 
          RowBox[{
           SubsuperscriptBox["q", 
            RowBox[{"1", ",", "2"}], "+"], 
           SubsuperscriptBox["q", 
            RowBox[{"1", ",", "2"}], "-"]}]], "/.", "substandardq"}], "/.", 
        "nspowers"}], ",", 
       RowBox[{"{", 
        RowBox[{"g", ",", "0", ",", "12"}], "}"}]}], "]"}], "//", "Normal"}], 
    ")"}]}]}]], "Input",
 CellChangeTimes->{{3.563304570540576*^9, 3.5633046117643337`*^9}, {
  3.563304643288118*^9, 3.563304672067299*^9}, {3.563304776626068*^9, 
  3.5633047811434793`*^9}, {3.56330586941868*^9, 3.563305872110423*^9}}],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"nspowers", "::", "asymcheck"}], "MessageName"], 
  RowBox[{
  ":", " "}], "\<\"\[NoBreak]\\!\\(\\*StyleBox[\\\"U\\\", \
List[Rule[FontColor, RGBColor[0, 0.6`, 0]]]]\\)\[NoBreak] assumed to be in \
the ordinary regime\"\>"}]], "Message", "MSG",
 CellChangeTimes->{{3.563304581685803*^9, 3.563304612154191*^9}, {
   3.5633046689234123`*^9, 3.563304672699585*^9}, {3.5633047774800797`*^9, 
   3.5633047813685513`*^9}, {3.5633050694023333`*^9, 3.56330507088867*^9}, 
   3.563305872740823*^9}],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"nspowers", "::", "asymcheck"}], "MessageName"], 
  RowBox[{
  ":", " "}], "\<\"\[NoBreak]\\!\\(\\(\\*StyleBox[\\\"q\\\", \
List[Rule[FontColor, RGBColor[0, 0, 0.8`]]]]\\)\\_2\\)\[NoBreak] assumed to \
be in the ordinary regime\"\>"}]], "Message", "MSG",
 CellChangeTimes->{{3.563304581685803*^9, 3.563304612154191*^9}, {
   3.5633046689234123`*^9, 3.563304672699585*^9}, {3.5633047774800797`*^9, 
   3.5633047813685513`*^9}, {3.5633050694023333`*^9, 3.56330507088867*^9}, 
   3.563305872760654*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   FractionBox[
    RowBox[{
     SuperscriptBox["g", "4"], " ", 
     SuperscriptBox[
      StyleBox["U",
       FontColor->RGBColor[0, 0.6, 0]], "2"], " ", 
     SubscriptBox[
      StyleBox["q",
       FontColor->RGBColor[0, 0, 0.8]], "2"]}], 
    RowBox[{
     SuperscriptBox[
      StyleBox["Q",
       FontColor->RGBColor[0.8, 0, 0]], "-"], " ", 
     SuperscriptBox[
      StyleBox["Q",
       FontColor->RGBColor[0.8, 0, 0]], "+"]}]], ",", 
   RowBox[{
    SuperscriptBox["g", "12"], " ", 
    RowBox[{"(", 
     RowBox[{
      FractionBox[
       RowBox[{
        RowBox[{"\[ImaginaryI]", " ", "\[Alpha]"}], "+", 
        RowBox[{"2", " ", "u", " ", "\[Alpha]"}], "-", 
        RowBox[{"\[ImaginaryI]", " ", 
         OverscriptBox["\[Alpha]", "_"]}], "-", 
        RowBox[{"2", " ", "u", " ", 
         OverscriptBox["\[Alpha]", "_"]}], "+", 
        RowBox[{"2", " ", "\[Alpha]", " ", 
         SubscriptBox["v", "0"]}], "+", 
        RowBox[{"2", " ", 
         OverscriptBox["\[Alpha]", "_"], " ", 
         SubscriptBox["v", "0"]}]}], 
       RowBox[{"2", " ", 
        SuperscriptBox[
         StyleBox["Q",
          FontColor->RGBColor[0.8, 0, 0]], "-"], " ", 
        SuperscriptBox[
         RowBox[{"(", 
          SuperscriptBox[
           StyleBox["Q",
            FontColor->RGBColor[0.8, 0, 0]], "+"], ")"}], "2"]}]], "+", 
      FractionBox[
       RowBox[{
        RowBox[{
         RowBox[{"-", "\[ImaginaryI]"}], " ", "\[Alpha]"}], "+", 
        RowBox[{"2", " ", "u", " ", "\[Alpha]"}], "+", 
        RowBox[{"\[ImaginaryI]", " ", 
         OverscriptBox["\[Alpha]", "_"]}], "-", 
        RowBox[{"2", " ", "u", " ", 
         OverscriptBox["\[Alpha]", "_"]}], "+", 
        RowBox[{"2", " ", "\[Alpha]", " ", 
         SubscriptBox["v", "0"]}], "+", 
        RowBox[{"2", " ", 
         OverscriptBox["\[Alpha]", "_"], " ", 
         SubscriptBox["v", "0"]}]}], 
       RowBox[{"2", " ", 
        SuperscriptBox[
         RowBox[{"(", 
          SuperscriptBox[
           StyleBox["Q",
            FontColor->RGBColor[0.8, 0, 0]], "-"], ")"}], "2"], " ", 
        SuperscriptBox[
         StyleBox["Q",
          FontColor->RGBColor[0.8, 0, 0]], "+"]}]]}], ")"}], " ", 
    SuperscriptBox[
     StyleBox["U",
      FontColor->RGBColor[0, 0.6, 0]], "2"], " ", 
    SubscriptBox[
     StyleBox["q",
      FontColor->RGBColor[0, 0, 0.8]], "2"]}]}], "}"}]], "Output",
 CellChangeTimes->{{3.56330457398666*^9, 3.563304612176775*^9}, {
   3.563304668946034*^9, 3.56330467272224*^9}, {3.563304777500945*^9, 
   3.563304781389394*^9}, {3.563305069425745*^9, 3.5633050709096537`*^9}, 
   3.563305872778645*^9}]
}, Open  ]],

Cell[BoxData[{
 RowBox[{
  RowBox[{"tmp2", "=", 
   RowBox[{"Collect", "[", 
    RowBox[{
     RowBox[{"Collect", "[", 
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{"Series", "[", 
          RowBox[{
           RowBox[{
            RowBox[{
             RowBox[{
              RowBox[{"tmp", "[", 
               RowBox[{"[", "1", "]"}], "]"}], "/.", 
              RowBox[{"g", "\[Rule]", "1"}]}], "/.", 
             RowBox[{"nsweak", "[", "5", "]"}]}], "/.", 
            RowBox[{"leadweak", "[", "5", "]"}]}], ",", 
           RowBox[{"{", 
            RowBox[{"g", ",", "0", ",", "12"}], "}"}]}], "]"}], "/.", 
         "subtousu"}], "//", "Normal"}], ",", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"g", ",", "\[Eta]list"}], "}"}], "//", "Flatten"}], ",", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          RowBox[{"#", "//", "funapartusu"}], "//", "funreduceusu"}], ")"}], 
        "&"}]}], "]"}], ",", "canlist"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"tmp3", "=", 
   RowBox[{"Collect", "[", 
    RowBox[{
     RowBox[{"Collect", "[", 
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{"Series", "[", 
          RowBox[{
           RowBox[{
            RowBox[{
             RowBox[{
              RowBox[{"tmp", "[", 
               RowBox[{"[", "2", "]"}], "]"}], "/.", 
              RowBox[{"g", "\[Rule]", "1"}]}], "/.", 
             RowBox[{"nsweak", "[", "1", "]"}]}], "/.", 
            RowBox[{"leadweak", "[", "1", "]"}]}], ",", 
           RowBox[{"{", 
            RowBox[{"g", ",", "0", ",", "12"}], "}"}]}], "]"}], "/.", 
         "subtousu"}], "//", "Normal"}], ",", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"g", ",", "\[Eta]list"}], "}"}], "//", "Flatten"}], ",", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          RowBox[{"#", "//", "funapartusu"}], "//", "funreduceusu"}], ")"}], 
        "&"}]}], "]"}], ",", "canlist"}], "]"}]}], ";"}]}], "Input",
 CellChangeTimes->{{3.563304673772481*^9, 3.5633047662567863`*^9}, {
  3.5633048087145863`*^9, 3.563304898674024*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"tmp4", "=", 
   RowBox[{"Collect", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"tmp2", "+", "tmp3"}], "/.", "subIm"}], ",", "canlist"}], 
    "]"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.563304916556164*^9, 3.56330493236649*^9}, {
  3.563305062643449*^9, 3.563305063778968*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"thatsit", "=", 
   RowBox[{"Coefficient", "[", 
    RowBox[{"tmp4", ",", "g", ",", "12"}], "]"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.563305096988764*^9, 3.5633051075688972`*^9}}],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"FreeQ", "[", 
  RowBox[{"thatsit", ",", "u"}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"alldens", "=", 
  RowBox[{"List", "@@", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"Times", "@@", 
      RowBox[{"(", 
       RowBox[{"Denominator", "/@", 
        RowBox[{"List", "@@", 
         RowBox[{"Expand", "[", "tmp4", "]"}]}]}], ")"}]}], "/.", 
     RowBox[{
      RowBox[{"Power", "[", 
       RowBox[{"a_", ",", "b_"}], "]"}], "\[RuleDelayed]", "a"}]}], 
    ")"}]}]}]}], "Input",
 CellChangeTimes->{{3.562260141886765*^9, 3.562260196023489*^9}, {
  3.5622661368281927`*^9, 3.562266163874578*^9}, {3.5633051239394617`*^9, 
  3.5633051244112*^9}}],

Cell[BoxData["True"], "Output",
 CellChangeTimes->{{3.562260159709598*^9, 3.562260196551879*^9}, {
   3.562266146130375*^9, 3.562266164327821*^9}, 3.563305006559554*^9, {
   3.563305118553192*^9, 3.5633051250265923`*^9}, 3.5633059232660933`*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"81", ",", 
   StyleBox["\[ScriptU]",
    FontColor->RGBColor[0, 0, 0.4]], ",", 
   SubsuperscriptBox[
    StyleBox["\[ScriptU]",
     FontColor->RGBColor[0, 0, 0.4]], 
    RowBox[{"-", "v0"}], "-"], ",", 
   SubsuperscriptBox[
    StyleBox["\[ScriptU]",
     FontColor->RGBColor[0, 0, 0.4]], 
    RowBox[{"-", "v0"}], "+"], ",", 
   SubsuperscriptBox[
    StyleBox["\[ScriptU]",
     FontColor->RGBColor[0, 0, 0.4]], "v0", "-"], ",", 
   SubsuperscriptBox[
    StyleBox["\[ScriptU]",
     FontColor->RGBColor[0, 0, 0.4]], "v0", "+"]}], "}"}]], "Output",
 CellChangeTimes->{{3.562260159709598*^9, 3.562260196551879*^9}, {
   3.562266146130375*^9, 3.562266164327821*^9}, 3.563305006559554*^9, {
   3.563305118553192*^9, 3.5633051250265923`*^9}, 3.5633059234062366`*^9}]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"thatsit", "=", "tmp4"}], ";"}]], "Input",
 CellChangeTimes->{{3.563305160094799*^9, 3.563305164245285*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"Collect", "[", 
   RowBox[{
    RowBox[{"thatsit", "//", "Expand"}], ",", 
    RowBox[{
     RowBox[{"\[ScriptU]$", "[", "_", "]"}], "[", "_", "]"}]}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"trm", "=", 
   RowBox[{"Join", "[", 
    RowBox[{
     RowBox[{"Table", "[", 
      RowBox[{
       RowBox[{"Select", "[", 
        RowBox[{"%", ",", 
         RowBox[{
          RowBox[{
           RowBox[{"FreeQ", "[", 
            RowBox[{"#", ",", 
             RowBox[{"Alternatives", "@@", 
              RowBox[{"Drop", "[", 
               RowBox[{"alldens", ",", "i"}], "]"}]}]}], "]"}], "&&", 
           RowBox[{"Not", "@", 
            RowBox[{"FreeQ", "[", 
             RowBox[{"#", ",", 
              RowBox[{"alldens", "[", 
               RowBox[{"[", "i", "]"}], "]"}]}], "]"}]}]}], "&"}]}], "]"}], 
       ",", 
       RowBox[{"{", 
        RowBox[{"i", ",", 
         RowBox[{"Length", "[", "alldens", "]"}]}], "}"}]}], "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"Select", "[", 
       RowBox[{"%", ",", 
        RowBox[{
         RowBox[{"FreeQ", "[", 
          RowBox[{"#", ",", 
           RowBox[{"Alternatives", "@@", "alldens"}]}], "]"}], "&"}]}], "]"}],
       "}"}]}], "]"}]}], ";"}]}], "Input",
 CellChangeTimes->{{3.56226039110525*^9, 3.562260403873473*^9}, {
  3.5622605137510242`*^9, 3.562260583402296*^9}, {3.5622661678240223`*^9, 
  3.562266180803206*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Length", "[", "trm", "]"}]], "Input",
 CellChangeTimes->{{3.562266220946697*^9, 3.562266223636744*^9}}],

Cell[BoxData["7"], "Output",
 CellChangeTimes->{3.5622662240390043`*^9, 3.563305178133552*^9, 
  3.563305931733521*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"trm", "[", 
    RowBox[{"[", "1", "]"}], "]"}], ",", 
   RowBox[{"trm", "[", 
    RowBox[{"[", 
     RowBox[{"-", "1"}], "]"}], "]"}]}], "}"}]], "Input",
 CellChangeTimes->{{3.56226622516294*^9, 3.562266227410492*^9}, {
  3.563305951375497*^9, 3.563305965254093*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"0", ",", "0"}], "}"}]], "Output",
 CellChangeTimes->{
  3.56226622781238*^9, 3.563305179523625*^9, {3.563305932859268*^9, 
   3.5633059658625727`*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Total", "[", "trm", "]"}], "-", "thatsit"}], "//", 
  "Expand"}]], "Input",
 CellChangeTimes->{{3.562266211546856*^9, 3.562266218540893*^9}}],

Cell[BoxData["0"], "Output",
 CellChangeTimes->{{3.56226621902826*^9, 3.562266233094*^9}, 
   3.5633051814918118`*^9, 3.5633059403966837`*^9}]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{
   FractionBox["1", 
    RowBox[{"1", "-", 
     SuperscriptBox["D", "2"]}]], 
   FractionBox[
    SuperscriptBox["U", "2"], 
    RowBox[{
     SuperscriptBox["Q0", "+"], 
     SuperscriptBox["Q0", "-"]}]]}], "\[Equal]", 
  RowBox[{"minsguys", "+", 
   RowBox[{
    FractionBox["1", 
     RowBox[{"1", "-", 
      SuperscriptBox["D", "2"]}]], 
    RowBox[{"(", 
     RowBox[{"plusguys", "+", 
      SuperscriptBox["minsguys", 
       RowBox[{"[", "2", "]"}]]}], ")"}]}], "+", 
   RowBox[{
    FractionBox["1", 
     RowBox[{"1", "-", 
      SuperscriptBox["D", "2"]}]], "othrguys"}]}]}]], "Input"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"othrguys", "=", 
   RowBox[{"trm", "[", 
    RowBox[{"[", "2", "]"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"plusguys", "=", 
   RowBox[{
    RowBox[{"trm", "[", 
     RowBox[{"[", "4", "]"}], "]"}], "+", 
    RowBox[{"trm", "[", 
     RowBox[{"[", "6", "]"}], "]"}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"minsguys", "=", 
   RowBox[{
    RowBox[{"trm", "[", 
     RowBox[{"[", "3", "]"}], "]"}], "+", 
    RowBox[{"trm", "[", 
     RowBox[{"[", "5", "]"}], "]"}]}]}], ";"}]}], "Input",
 CellChangeTimes->{{3.562266429309249*^9, 3.562266485972539*^9}, {
  3.562266516354813*^9, 3.56226651710714*^9}, {3.563305971256566*^9, 
  3.563305991855835*^9}}],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"rlt1", "=", 
   RowBox[{
    RowBox[{
     RowBox[{"ExpaCol", "[", 
      RowBox[{
       RowBox[{"othrguys", " ", "AAA"}], ",", 
       RowBox[{"Flatten", "[", 
        RowBox[{"\[Eta]patt", "|", "\[ScriptU]", "|", "AAA"}], "]"}]}], "]"}],
      "/.", 
     RowBox[{
      RowBox[{"AAA", " ", 
       SuperscriptBox["\[ScriptU]", 
        RowBox[{"pow_", "/;", 
         RowBox[{"pow", "<", "0"}]}]], 
       RowBox[{
        RowBox[{"\[Eta]$", "[", "a__", "]"}], "[", "2", "]"}]}], 
      "\[RuleDelayed]", 
      RowBox[{
       RowBox[{"\[Eta]$", "[", 
        RowBox[{
         RowBox[{"-", "pow"}], ",", "a"}], "]"}], "[", "0", "]"}]}]}], "/.", 
    RowBox[{
     RowBox[{"AAA", " ", 
      SuperscriptBox["\[ScriptU]", 
       RowBox[{"pow_", "/;", 
        RowBox[{"pow", "<", "0"}]}]]}], "\[RuleDelayed]", 
     RowBox[{
      RowBox[{"\[Eta]$", "[", 
       RowBox[{"-", "pow"}], "]"}], "[", "0", "]"}]}]}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"FreeQ", "[", 
  RowBox[{"rlt1", ",", "AAA"}], "]"}]}], "Input",
 CellChangeTimes->{{3.562266257235344*^9, 3.562266372310899*^9}, 
   3.562266450691483*^9}],

Cell[BoxData["True"], "Output",
 CellChangeTimes->{{3.562266259444532*^9, 3.562266297307125*^9}, {
   3.562266355090972*^9, 3.562266372761181*^9}, 3.5622664608965263`*^9, 
   3.563305242627646*^9, 3.563306015304932*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"rlt1", "-", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"rlt1", "/.", 
          RowBox[{"Shift", "[", "2", "]"}]}], "/.", 
         RowBox[{"u", "\[Rule]", 
          RowBox[{"u", "+", "\[ImaginaryI]"}]}]}], ")"}]}], "/.", 
      RowBox[{"shiftp\[Eta]", "[", "0", "]"}]}], ")"}], "-", "othrguys"}], "/.",
    "subusu"}], "//", "Expand"}]], "Input",
 CellChangeTimes->{{3.562266374270647*^9, 3.56226640510187*^9}, 
   3.56226645961683*^9}],

Cell[BoxData["0"], "Output",
 CellChangeTimes->{{3.562266396326579*^9, 3.5622664057310534`*^9}, 
   3.562266461947289*^9, 3.5633052444215183`*^9, 3.563306017386361*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"tmp", "=", 
   RowBox[{"Collect", "[", 
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{"plusguys", "+", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"minsguys", "/.", 
             RowBox[{"Shift", "[", "2", "]"}]}], "/.", 
            RowBox[{"u", "\[Rule]", 
             RowBox[{"u", "+", "\[ImaginaryI]"}]}]}], ")"}]}], "//.", 
         RowBox[{"shiftp\[Eta]", "[", "2", "]"}]}], "/.", "subtousu"}], "//", 
       "funapartusu"}], "//", "funreduceusu"}], ",", "canlist"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"rlt2", "=", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{"ExpaCol", "[", 
        RowBox[{
         RowBox[{"AAA", " ", "tmp"}], ",", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{"\[Eta]patt", "|", 
            RowBox[{
             RowBox[{"\[ScriptU]$", "[", "_", "]"}], "[", "_", "]"}], "|", 
            "AAA"}], ")"}], "//", "Flatten"}]}], "]"}], "/.", 
       RowBox[{"Shift", "[", 
        RowBox[{"-", "2"}], "]"}]}], "/.", 
      RowBox[{
       RowBox[{"AAA", " ", 
        SuperscriptBox["\[ScriptU]", 
         RowBox[{"pow_", "/;", 
          RowBox[{"pow", "<", "0"}]}]], 
        RowBox[{
         RowBox[{"\[Eta]$", "[", "a__", "]"}], "[", "2", "]"}]}], 
       "\[RuleDelayed]", 
       RowBox[{
        RowBox[{"\[Eta]$", "[", 
         RowBox[{
          RowBox[{"-", "pow"}], ",", "a"}], "]"}], "[", "0", "]"}]}]}], "/.", 
     
     RowBox[{
      RowBox[{"AAA", " ", 
       SuperscriptBox["\[ScriptU]", 
        RowBox[{"pow_", "/;", 
         RowBox[{"pow", "<", "0"}]}]]}], "\[RuleDelayed]", 
      RowBox[{
       RowBox[{"\[Eta]$", "[", 
        RowBox[{"-", "pow"}], "]"}], "[", "0", "]"}]}]}], "/.", 
    RowBox[{"Shift", "[", "2", "]"}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"rlt2", "-", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"rlt2", "/.", 
          RowBox[{"Shift", "[", "2", "]"}]}], "/.", 
         RowBox[{"u", "\[Rule]", 
          RowBox[{"u", "+", "\[ImaginaryI]"}]}]}], ")"}]}], "/.", 
      RowBox[{"shiftp\[Eta]", "[", "2", "]"}]}], ")"}], "-", "tmp"}], "/.", 
   "subusu"}], "//", "Expand"}]}], "Input",
 CellChangeTimes->{{3.562266496096838*^9, 3.5622665705123796`*^9}, {
  3.562266611871232*^9, 3.56226677824368*^9}}],

Cell[BoxData["0"], "Output",
 CellChangeTimes->{
  3.562266520547687*^9, 3.562266571854011*^9, 3.5622666152346888`*^9, 
   3.56226666620086*^9, {3.562266739785541*^9, 3.562266778856223*^9}, 
   3.56330525248144*^9, 3.563306020173399*^9}]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"preq14", "=", 
   RowBox[{"Collect", "[", 
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{
          RowBox[{
           RowBox[{"minsguys", "+", "rlt1", "+", "rlt2"}], "/.", 
           RowBox[{"Shift", "[", "1", "]"}]}], "/.", 
          RowBox[{"u", "\[Rule]", 
           RowBox[{"u", "+", 
            RowBox[{"\[ImaginaryI]", "/", "2"}]}]}]}], "//.", 
         RowBox[{"shiftm\[Eta]", "[", "3", "]"}]}], "//.", "subtousu"}], "//",
        "funapartusu"}], "//", "funreduceusu"}], ",", "canlist"}], "]"}]}], 
  ";"}]], "Input",
 CellChangeTimes->{{3.56226682426929*^9, 3.562266868028184*^9}, {
  3.563305330146161*^9, 3.563305372689372*^9}, {3.563306026559514*^9, 
  3.563306026629833*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Collect", "[", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{
        RowBox[{"preq14", "/.", 
         RowBox[{"Shift", "[", 
          RowBox[{"-", "1"}], "]"}]}], "/.", 
        RowBox[{"u", "\[Rule]", 
         RowBox[{"u", "-", 
          RowBox[{"\[ImaginaryI]", "/", "2"}]}]}]}], "//.", 
       RowBox[{"shiftp\[Eta]", "[", "0", "]"}]}], ")"}], "-", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"preq14", "/.", 
        RowBox[{"Shift", "[", "1", "]"}]}], "/.", 
       RowBox[{"u", "\[Rule]", 
        RowBox[{"u", "+", 
         RowBox[{"\[ImaginaryI]", "/", "2"}]}]}]}], ")"}], "-", "tmp4"}], "/.",
     "subusu"}], ",", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"g", ",", "\[Eta]list"}], "}"}], "//", "Flatten"}], ",", 
   "Simplify"}], "]"}]], "Input",
 CellChangeTimes->{{3.563305375551408*^9, 3.5633054561835203`*^9}, {
  3.563306043826065*^9, 3.5633060465523*^9}}],

Cell[BoxData["0"], "Output",
 CellChangeTimes->{3.563305377834938*^9, 3.5633054576633053`*^9, 
  3.563306050213354*^9}]
}, Open  ]],

Cell[TextData[{
 "It remains to multiply this expression on ",
 Cell[BoxData[
  FormBox[
   SubscriptBox["q", 
    RowBox[{"1", ",", "2"}]], TraditionalForm]],
  FormatType->"TraditionalForm"]
}], "Text",
 CellChangeTimes->{{3.563305465928132*^9, 3.5633054757081842`*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"Collect", "[", 
   RowBox[{
    RowBox[{"Series", "[", 
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{
          RowBox[{
           SubscriptBox["q", 
            RowBox[{"1", ",", "2"}]], "/.", "substandardq"}], "/.", 
          RowBox[{
           RowBox[{"xxx", ":", 
            RowBox[{"\[Alpha]", "|", 
             OverscriptBox["\[Alpha]", "_"]}]}], "\[RuleDelayed]", 
           RowBox[{"(", 
            RowBox[{"xxx", "/.", 
             RowBox[{"leadweak", "[", "1", "]"}]}], ")"}]}]}], "/.", 
         RowBox[{"leadweak", "[", "5", "]"}]}], "/.", "subIm"}], "/.", 
       "subQ0"}], ",", 
      RowBox[{"{", 
       RowBox[{"g", ",", "0", ",", "8"}], "}"}]}], "]"}], ",", "canlist"}], 
   "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"q14atfiveloops", "=", 
   RowBox[{"Collect", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"Normal", "@", 
       RowBox[{"Series", "[", 
        RowBox[{
         RowBox[{"%", " ", "preq14"}], ",", 
         RowBox[{"{", 
          RowBox[{"g", ",", "0", ",", "12"}], "}"}]}], "]"}]}], "//", 
      "funreduceusu"}], ",", "canlist"}], "]"}]}], ";"}]}], "Input",
 CellChangeTimes->{{3.5633054767824297`*^9, 3.563305601493984*^9}, {
  3.5633056342423487`*^9, 3.563305635138412*^9}, {3.563306055859543*^9, 
  3.563306059219051*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Series", "[", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"q14atfiveloops", "-", 
      SubscriptBox["q", 
       RowBox[{"1", ",", "4"}]]}], "/.", 
     RowBox[{"leadweak", "[", "4", "]"}]}], "/.", "subQ0"}], ",", 
   RowBox[{"{", 
    RowBox[{"g", ",", "0", ",", "10"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.5633056103029222`*^9, 3.5633056127958813`*^9}, {
  3.563305667305888*^9, 3.563305686947042*^9}, {3.563306066836635*^9, 
  3.5633060693967953`*^9}}],

Cell[BoxData[
 InterpretationBox[
  SuperscriptBox[
   RowBox[{"O", "[", "g", "]"}], "11"],
  SeriesData[$CellContext`g, 0, {}, 11, 11, 1],
  Editable->False]], "Output",
 CellChangeTimes->{{3.5633056823712473`*^9, 3.56330568814113*^9}, 
   3.563306071805197*^9}]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"AddNsDefinition", "[", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{
      RowBox[{"q$", "[", 
       RowBox[{"1", ",", "4"}], "]"}], "[", "0", "]"}], ",", 
     RowBox[{"PrepareList", "[", "q14atfiveloops", "]"}]}], "}"}], "]"}], 
  ";"}]], "Input",
 CellChangeTimes->{{3.563305692728593*^9, 3.5633057273526154`*^9}, {
  3.563306076508762*^9, 3.563306079635378*^9}}],

Cell[BoxData["q14atfiveloops"], "Input",
 CellChangeTimes->{{3.563306085658636*^9, 3.563306088288556*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["q24fiveloop", "Subsection",
 CellChangeTimes->{{3.560866902544417*^9, 3.560866912004005*^9}, {
  3.5614767292850533`*^9, 3.5614767316090813`*^9}, {3.563305853256466*^9, 
  3.563305854384355*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{
    OverscriptBox["Q", "~"], "=", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{"u", "-", 
       SubscriptBox["v", "0"], "-", "\[Alpha]"}], ")"}], 
     RowBox[{"(", 
      RowBox[{"u", "+", 
       SubscriptBox["v", "0"], "+", 
       OverscriptBox["\[Alpha]", "_"]}], ")"}]}]}], ",", 
   RowBox[{
    OverscriptBox[
     OverscriptBox["Q", "~"], "_"], "=", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{"u", "-", 
       SubscriptBox["v", "0"], "-", 
       OverscriptBox["\[Alpha]", "_"]}], ")"}], 
     RowBox[{"(", 
      RowBox[{"u", "+", 
       SubscriptBox["v", "0"], "+", "\[Alpha]"}], ")"}]}]}]}], "}"}]], "Input"],

Cell[BoxData[
 RowBox[{
  SubscriptBox["q", 
   RowBox[{"2", ",", "4"}]], "=", 
  RowBox[{
   SubscriptBox["q", 
    RowBox[{"1", ",", "2"}]], 
   FractionBox["D", 
    RowBox[{"1", "-", 
     SuperscriptBox["D", "2"]}]], 
   FractionBox[
    RowBox[{
     SubsuperscriptBox["q", "2", "2"], "U"}], 
    RowBox[{
     SubsuperscriptBox["q", 
      RowBox[{"1", ",", "2"}], "+"], 
     SubsuperscriptBox["q", 
      RowBox[{"1", ",", "2"}], "-"]}]]}]}]], "Input",
 CellChangeTimes->{{3.563304544830415*^9, 3.563304565141852*^9}, {
  3.5633061547686357`*^9, 3.5633061613438797`*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"tmp", "=", 
  RowBox[{"List", "@@", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"Series", "[", 
      RowBox[{
       RowBox[{
        RowBox[{
         FractionBox[
          RowBox[{
           SubsuperscriptBox["q", "2", "2"], 
           SuperscriptBox["U", "2"]}], 
          RowBox[{
           SubsuperscriptBox["q", 
            RowBox[{"1", ",", "2"}], "+"], 
           SubsuperscriptBox["q", 
            RowBox[{"1", ",", "2"}], "-"]}]], "/.", "substandardq"}], "/.", 
        "nspowers"}], ",", 
       RowBox[{"{", 
        RowBox[{"g", ",", "0", ",", "12"}], "}"}]}], "]"}], "//", "Normal"}], 
    ")"}]}]}]], "Input",
 CellChangeTimes->{{3.563304570540576*^9, 3.5633046117643337`*^9}, {
  3.563304643288118*^9, 3.563304672067299*^9}, {3.563304776626068*^9, 
  3.5633047811434793`*^9}, {3.563306117365465*^9, 3.563306120619875*^9}}],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"nspowers", "::", "asymcheck"}], "MessageName"], 
  RowBox[{
  ":", " "}], "\<\"\[NoBreak]\\!\\(\\*StyleBox[\\\"U\\\", \
List[Rule[FontColor, RGBColor[0, 0.6`, 0]]]]\\)\[NoBreak] assumed to be in \
the ordinary regime\"\>"}]], "Message", "MSG",
 CellChangeTimes->{{3.563304581685803*^9, 3.563304612154191*^9}, {
   3.5633046689234123`*^9, 3.563304672699585*^9}, {3.5633047774800797`*^9, 
   3.5633047813685513`*^9}, {3.5633050694023333`*^9, 3.56330507088867*^9}, 
   3.563306121331674*^9}],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"nspowers", "::", "asymcheck"}], "MessageName"], 
  RowBox[{
  ":", " "}], "\<\"\[NoBreak]\\!\\(\\(\\*StyleBox[\\\"q\\\", \
List[Rule[FontColor, RGBColor[0, 0, 0.8`]]]]\\)\\_2\\)\[NoBreak] assumed to \
be in the ordinary regime\"\>"}]], "Message", "MSG",
 CellChangeTimes->{{3.563304581685803*^9, 3.563304612154191*^9}, {
   3.5633046689234123`*^9, 3.563304672699585*^9}, {3.5633047774800797`*^9, 
   3.5633047813685513`*^9}, {3.5633050694023333`*^9, 3.56330507088867*^9}, 
   3.563306121349846*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   FractionBox[
    RowBox[{
     SuperscriptBox["g", "4"], " ", 
     SuperscriptBox[
      StyleBox["U",
       FontColor->RGBColor[0, 0.6, 0]], "2"], " ", 
     SubsuperscriptBox[
      StyleBox["q",
       FontColor->RGBColor[0, 0, 0.8]], "2", "2"]}], 
    RowBox[{
     SuperscriptBox[
      StyleBox["Q",
       FontColor->RGBColor[0.8, 0, 0]], "-"], " ", 
     SuperscriptBox[
      StyleBox["Q",
       FontColor->RGBColor[0.8, 0, 0]], "+"]}]], ",", 
   RowBox[{
    SuperscriptBox["g", "12"], " ", 
    RowBox[{"(", 
     RowBox[{
      FractionBox[
       RowBox[{
        RowBox[{"\[ImaginaryI]", " ", "\[Alpha]"}], "+", 
        RowBox[{"2", " ", "u", " ", "\[Alpha]"}], "-", 
        RowBox[{"\[ImaginaryI]", " ", 
         OverscriptBox["\[Alpha]", "_"]}], "-", 
        RowBox[{"2", " ", "u", " ", 
         OverscriptBox["\[Alpha]", "_"]}], "+", 
        RowBox[{"2", " ", "\[Alpha]", " ", 
         SubscriptBox["v", "0"]}], "+", 
        RowBox[{"2", " ", 
         OverscriptBox["\[Alpha]", "_"], " ", 
         SubscriptBox["v", "0"]}]}], 
       RowBox[{"2", " ", 
        SuperscriptBox[
         StyleBox["Q",
          FontColor->RGBColor[0.8, 0, 0]], "-"], " ", 
        SuperscriptBox[
         RowBox[{"(", 
          SuperscriptBox[
           StyleBox["Q",
            FontColor->RGBColor[0.8, 0, 0]], "+"], ")"}], "2"]}]], "+", 
      FractionBox[
       RowBox[{
        RowBox[{
         RowBox[{"-", "\[ImaginaryI]"}], " ", "\[Alpha]"}], "+", 
        RowBox[{"2", " ", "u", " ", "\[Alpha]"}], "+", 
        RowBox[{"\[ImaginaryI]", " ", 
         OverscriptBox["\[Alpha]", "_"]}], "-", 
        RowBox[{"2", " ", "u", " ", 
         OverscriptBox["\[Alpha]", "_"]}], "+", 
        RowBox[{"2", " ", "\[Alpha]", " ", 
         SubscriptBox["v", "0"]}], "+", 
        RowBox[{"2", " ", 
         OverscriptBox["\[Alpha]", "_"], " ", 
         SubscriptBox["v", "0"]}]}], 
       RowBox[{"2", " ", 
        SuperscriptBox[
         RowBox[{"(", 
          SuperscriptBox[
           StyleBox["Q",
            FontColor->RGBColor[0.8, 0, 0]], "-"], ")"}], "2"], " ", 
        SuperscriptBox[
         StyleBox["Q",
          FontColor->RGBColor[0.8, 0, 0]], "+"]}]]}], ")"}], " ", 
    SuperscriptBox[
     StyleBox["U",
      FontColor->RGBColor[0, 0.6, 0]], "2"], " ", 
    SubsuperscriptBox[
     StyleBox["q",
      FontColor->RGBColor[0, 0, 0.8]], "2", "2"]}]}], "}"}]], "Output",
 CellChangeTimes->{{3.56330457398666*^9, 3.563304612176775*^9}, {
   3.563304668946034*^9, 3.56330467272224*^9}, {3.563304777500945*^9, 
   3.563304781389394*^9}, {3.563305069425745*^9, 3.5633050709096537`*^9}, 
   3.5633061213678923`*^9}]
}, Open  ]],

Cell[BoxData[{
 RowBox[{
  RowBox[{"tmp2", "=", 
   RowBox[{"Collect", "[", 
    RowBox[{
     RowBox[{"Collect", "[", 
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{"Series", "[", 
          RowBox[{
           RowBox[{
            RowBox[{
             RowBox[{
              RowBox[{"tmp", "[", 
               RowBox[{"[", "1", "]"}], "]"}], "/.", 
              RowBox[{"g", "\[Rule]", "1"}]}], "/.", 
             RowBox[{"nsweak", "[", "5", "]"}]}], "/.", 
            RowBox[{"leadweak", "[", "5", "]"}]}], ",", 
           RowBox[{"{", 
            RowBox[{"g", ",", "0", ",", "12"}], "}"}]}], "]"}], "/.", 
         "subtousu"}], "//", "Normal"}], ",", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"g", ",", "\[Eta]list"}], "}"}], "//", "Flatten"}], ",", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          RowBox[{"#", "//", "funapartusu"}], "//", "funreduceusu"}], ")"}], 
        "&"}]}], "]"}], ",", "canlist"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"tmp3", "=", 
   RowBox[{"Collect", "[", 
    RowBox[{
     RowBox[{"Collect", "[", 
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{"Series", "[", 
          RowBox[{
           RowBox[{
            RowBox[{
             RowBox[{
              RowBox[{"tmp", "[", 
               RowBox[{"[", "2", "]"}], "]"}], "/.", 
              RowBox[{"g", "\[Rule]", "1"}]}], "/.", 
             RowBox[{"nsweak", "[", "1", "]"}]}], "/.", 
            RowBox[{"leadweak", "[", "1", "]"}]}], ",", 
           RowBox[{"{", 
            RowBox[{"g", ",", "0", ",", "12"}], "}"}]}], "]"}], "/.", 
         "subtousu"}], "//", "Normal"}], ",", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"g", ",", "\[Eta]list"}], "}"}], "//", "Flatten"}], ",", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          RowBox[{"#", "//", "funapartusu"}], "//", "funreduceusu"}], ")"}], 
        "&"}]}], "]"}], ",", "canlist"}], "]"}]}], ";"}]}], "Input",
 CellChangeTimes->{{3.563304673772481*^9, 3.5633047662567863`*^9}, {
  3.5633048087145863`*^9, 3.563304898674024*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"tmp4", "=", 
   RowBox[{"Collect", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"tmp2", "+", "tmp3"}], "/.", "subIm"}], ",", "canlist"}], 
    "]"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.563304916556164*^9, 3.56330493236649*^9}, {
  3.563305062643449*^9, 3.563305063778968*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"thatsit", "=", 
   RowBox[{"Coefficient", "[", 
    RowBox[{"tmp4", ",", "g", ",", "12"}], "]"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.563305096988764*^9, 3.5633051075688972`*^9}}],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"FreeQ", "[", 
  RowBox[{"thatsit", ",", "u"}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"alldens", "=", 
  RowBox[{"List", "@@", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"Times", "@@", 
      RowBox[{"(", 
       RowBox[{"Denominator", "/@", 
        RowBox[{"List", "@@", 
         RowBox[{"Expand", "[", "tmp4", "]"}]}]}], ")"}]}], "/.", 
     RowBox[{
      RowBox[{"Power", "[", 
       RowBox[{"a_", ",", "b_"}], "]"}], "\[RuleDelayed]", "a"}]}], 
    ")"}]}]}]}], "Input",
 CellChangeTimes->{{3.562260141886765*^9, 3.562260196023489*^9}, {
  3.5622661368281927`*^9, 3.562266163874578*^9}, {3.5633051239394617`*^9, 
  3.5633051244112*^9}}],

Cell[BoxData["True"], "Output",
 CellChangeTimes->{{3.562260159709598*^9, 3.562260196551879*^9}, {
   3.562266146130375*^9, 3.562266164327821*^9}, 3.563305006559554*^9, {
   3.563305118553192*^9, 3.5633051250265923`*^9}, 3.563306176318161*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"531441", ",", 
   StyleBox["\[ScriptU]",
    FontColor->RGBColor[0, 0, 0.4]], ",", 
   SubsuperscriptBox[
    StyleBox["\[ScriptU]",
     FontColor->RGBColor[0, 0, 0.4]], 
    RowBox[{"-", "v0"}], "-"], ",", 
   SubsuperscriptBox[
    StyleBox["\[ScriptU]",
     FontColor->RGBColor[0, 0, 0.4]], 
    RowBox[{"-", "v0"}], "+"], ",", 
   SubsuperscriptBox[
    StyleBox["\[ScriptU]",
     FontColor->RGBColor[0, 0, 0.4]], "v0", "-"], ",", 
   SubsuperscriptBox[
    StyleBox["\[ScriptU]",
     FontColor->RGBColor[0, 0, 0.4]], "v0", "+"]}], "}"}]], "Output",
 CellChangeTimes->{{3.562260159709598*^9, 3.562260196551879*^9}, {
   3.562266146130375*^9, 3.562266164327821*^9}, 3.563305006559554*^9, {
   3.563305118553192*^9, 3.5633051250265923`*^9}, 3.5633061764258947`*^9}]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"thatsit", "=", "tmp4"}], ";"}]], "Input",
 CellChangeTimes->{{3.563305160094799*^9, 3.563305164245285*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"Collect", "[", 
   RowBox[{
    RowBox[{"thatsit", "//", "Expand"}], ",", 
    RowBox[{
     RowBox[{"\[ScriptU]$", "[", "_", "]"}], "[", "_", "]"}]}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"trm", "=", 
   RowBox[{"Join", "[", 
    RowBox[{
     RowBox[{"Table", "[", 
      RowBox[{
       RowBox[{"Select", "[", 
        RowBox[{"%", ",", 
         RowBox[{
          RowBox[{
           RowBox[{"FreeQ", "[", 
            RowBox[{"#", ",", 
             RowBox[{"Alternatives", "@@", 
              RowBox[{"Drop", "[", 
               RowBox[{"alldens", ",", "i"}], "]"}]}]}], "]"}], "&&", 
           RowBox[{"Not", "@", 
            RowBox[{"FreeQ", "[", 
             RowBox[{"#", ",", 
              RowBox[{"alldens", "[", 
               RowBox[{"[", "i", "]"}], "]"}]}], "]"}]}]}], "&"}]}], "]"}], 
       ",", 
       RowBox[{"{", 
        RowBox[{"i", ",", 
         RowBox[{"Length", "[", "alldens", "]"}]}], "}"}]}], "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"Select", "[", 
       RowBox[{"%", ",", 
        RowBox[{
         RowBox[{"FreeQ", "[", 
          RowBox[{"#", ",", 
           RowBox[{"Alternatives", "@@", "alldens"}]}], "]"}], "&"}]}], "]"}],
       "}"}]}], "]"}]}], ";"}]}], "Input",
 CellChangeTimes->{{3.56226039110525*^9, 3.562260403873473*^9}, {
  3.5622605137510242`*^9, 3.562260583402296*^9}, {3.5622661678240223`*^9, 
  3.562266180803206*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Length", "[", "trm", "]"}]], "Input",
 CellChangeTimes->{{3.562266220946697*^9, 3.562266223636744*^9}}],

Cell[BoxData["7"], "Output",
 CellChangeTimes->{3.5622662240390043`*^9, 3.563305178133552*^9, 
  3.563306176708552*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"trm", "[", 
    RowBox[{"[", "1", "]"}], "]"}], ",", 
   RowBox[{"trm", "[", 
    RowBox[{"[", 
     RowBox[{"-", "1"}], "]"}], "]"}]}], "}"}]], "Input",
 CellChangeTimes->{{3.56226622516294*^9, 3.562266227410492*^9}, {
  3.563306134206873*^9, 3.563306138598567*^9}}],

Cell[BoxData["0"], "Output",
 CellChangeTimes->{3.56226622781238*^9, 3.563305179523625*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Total", "[", "trm", "]"}], "-", "thatsit"}], "//", 
  "Expand"}]], "Input",
 CellChangeTimes->{{3.562266211546856*^9, 3.562266218540893*^9}}],

Cell[BoxData["0"], "Output",
 CellChangeTimes->{{3.56226621902826*^9, 3.562266233094*^9}, 
   3.5633051814918118`*^9}]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{
   FractionBox["1", 
    RowBox[{"1", "-", 
     SuperscriptBox["D", "2"]}]], 
   FractionBox[
    SuperscriptBox["U", "2"], 
    RowBox[{
     SuperscriptBox["Q0", "+"], 
     SuperscriptBox["Q0", "-"]}]]}], "\[Equal]", 
  RowBox[{"minsguys", "+", 
   RowBox[{
    FractionBox["1", 
     RowBox[{"1", "-", 
      SuperscriptBox["D", "2"]}]], 
    RowBox[{"(", 
     RowBox[{"plusguys", "+", 
      SuperscriptBox["minsguys", 
       RowBox[{"[", "2", "]"}]]}], ")"}]}], "+", 
   RowBox[{
    FractionBox["1", 
     RowBox[{"1", "-", 
      SuperscriptBox["D", "2"]}]], "othrguys"}]}]}]], "Input"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"othrguys", "=", 
   RowBox[{"trm", "[", 
    RowBox[{"[", "2", "]"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"plusguys", "=", 
   RowBox[{
    RowBox[{"trm", "[", 
     RowBox[{"[", "4", "]"}], "]"}], "+", 
    RowBox[{"trm", "[", 
     RowBox[{"[", "6", "]"}], "]"}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"minsguys", "=", 
   RowBox[{
    RowBox[{"trm", "[", 
     RowBox[{"[", "3", "]"}], "]"}], "+", 
    RowBox[{"trm", "[", 
     RowBox[{"[", "5", "]"}], "]"}]}]}], ";"}]}], "Input",
 CellChangeTimes->{{3.562266429309249*^9, 3.562266485972539*^9}, {
  3.562266516354813*^9, 3.56226651710714*^9}, {3.563306185608192*^9, 
  3.563306191663435*^9}}],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"rlt1", "=", 
   RowBox[{
    RowBox[{
     RowBox[{"ExpaCol", "[", 
      RowBox[{
       RowBox[{"othrguys", " ", "AAA"}], ",", 
       RowBox[{"Flatten", "[", 
        RowBox[{"\[Eta]patt", "|", "\[ScriptU]", "|", "AAA"}], "]"}]}], "]"}],
      "/.", 
     RowBox[{
      RowBox[{"AAA", " ", 
       SuperscriptBox["\[ScriptU]", 
        RowBox[{"pow_", "/;", 
         RowBox[{"pow", "<", "0"}]}]], 
       RowBox[{
        RowBox[{"\[Eta]$", "[", "a__", "]"}], "[", "2", "]"}]}], 
      "\[RuleDelayed]", 
      RowBox[{
       RowBox[{"\[Eta]$", "[", 
        RowBox[{
         RowBox[{"-", "pow"}], ",", "a"}], "]"}], "[", "0", "]"}]}]}], "/.", 
    RowBox[{
     RowBox[{"AAA", " ", 
      SuperscriptBox["\[ScriptU]", 
       RowBox[{"pow_", "/;", 
        RowBox[{"pow", "<", "0"}]}]]}], "\[RuleDelayed]", 
     RowBox[{
      RowBox[{"\[Eta]$", "[", 
       RowBox[{"-", "pow"}], "]"}], "[", "0", "]"}]}]}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"FreeQ", "[", 
  RowBox[{"rlt1", ",", "AAA"}], "]"}]}], "Input",
 CellChangeTimes->{{3.562266257235344*^9, 3.562266372310899*^9}, 
   3.562266450691483*^9}],

Cell[BoxData["True"], "Output",
 CellChangeTimes->{{3.562266259444532*^9, 3.562266297307125*^9}, {
   3.562266355090972*^9, 3.562266372761181*^9}, 3.5622664608965263`*^9, 
   3.563305242627646*^9, 3.563306195834263*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"rlt1", "-", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"rlt1", "/.", 
          RowBox[{"Shift", "[", "2", "]"}]}], "/.", 
         RowBox[{"u", "\[Rule]", 
          RowBox[{"u", "+", "\[ImaginaryI]"}]}]}], ")"}]}], "/.", 
      RowBox[{"shiftp\[Eta]", "[", "0", "]"}]}], ")"}], "-", "othrguys"}], "/.",
    "subusu"}], "//", "Expand"}]], "Input",
 CellChangeTimes->{{3.562266374270647*^9, 3.56226640510187*^9}, 
   3.56226645961683*^9}],

Cell[BoxData["0"], "Output",
 CellChangeTimes->{{3.562266396326579*^9, 3.5622664057310534`*^9}, 
   3.562266461947289*^9, 3.5633052444215183`*^9, 3.563306197689941*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"tmp", "=", 
   RowBox[{"Collect", "[", 
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{"plusguys", "+", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"minsguys", "/.", 
             RowBox[{"Shift", "[", "2", "]"}]}], "/.", 
            RowBox[{"u", "\[Rule]", 
             RowBox[{"u", "+", "\[ImaginaryI]"}]}]}], ")"}]}], "//.", 
         RowBox[{"shiftp\[Eta]", "[", "2", "]"}]}], "/.", "subtousu"}], "//", 
       "funapartusu"}], "//", "funreduceusu"}], ",", "canlist"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"rlt2", "=", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{"ExpaCol", "[", 
        RowBox[{
         RowBox[{"AAA", " ", "tmp"}], ",", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{"\[Eta]patt", "|", 
            RowBox[{
             RowBox[{"\[ScriptU]$", "[", "_", "]"}], "[", "_", "]"}], "|", 
            "AAA"}], ")"}], "//", "Flatten"}]}], "]"}], "/.", 
       RowBox[{"Shift", "[", 
        RowBox[{"-", "2"}], "]"}]}], "/.", 
      RowBox[{
       RowBox[{"AAA", " ", 
        SuperscriptBox["\[ScriptU]", 
         RowBox[{"pow_", "/;", 
          RowBox[{"pow", "<", "0"}]}]], 
        RowBox[{
         RowBox[{"\[Eta]$", "[", "a__", "]"}], "[", "2", "]"}]}], 
       "\[RuleDelayed]", 
       RowBox[{
        RowBox[{"\[Eta]$", "[", 
         RowBox[{
          RowBox[{"-", "pow"}], ",", "a"}], "]"}], "[", "0", "]"}]}]}], "/.", 
     
     RowBox[{
      RowBox[{"AAA", " ", 
       SuperscriptBox["\[ScriptU]", 
        RowBox[{"pow_", "/;", 
         RowBox[{"pow", "<", "0"}]}]]}], "\[RuleDelayed]", 
      RowBox[{
       RowBox[{"\[Eta]$", "[", 
        RowBox[{"-", "pow"}], "]"}], "[", "0", "]"}]}]}], "/.", 
    RowBox[{"Shift", "[", "2", "]"}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"rlt2", "-", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"rlt2", "/.", 
          RowBox[{"Shift", "[", "2", "]"}]}], "/.", 
         RowBox[{"u", "\[Rule]", 
          RowBox[{"u", "+", "\[ImaginaryI]"}]}]}], ")"}]}], "/.", 
      RowBox[{"shiftp\[Eta]", "[", "2", "]"}]}], ")"}], "-", "tmp"}], "/.", 
   "subusu"}], "//", "Expand"}]}], "Input",
 CellChangeTimes->{{3.562266496096838*^9, 3.5622665705123796`*^9}, {
  3.562266611871232*^9, 3.56226677824368*^9}}],

Cell[BoxData["0"], "Output",
 CellChangeTimes->{
  3.562266520547687*^9, 3.562266571854011*^9, 3.5622666152346888`*^9, 
   3.56226666620086*^9, {3.562266739785541*^9, 3.562266778856223*^9}, 
   3.56330525248144*^9, 3.563306199023076*^9}]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"preq24", "=", 
   RowBox[{"Collect", "[", 
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{
          RowBox[{
           RowBox[{"minsguys", "+", "rlt1", "+", "rlt2"}], "/.", 
           RowBox[{"Shift", "[", "1", "]"}]}], "/.", 
          RowBox[{"u", "\[Rule]", 
           RowBox[{"u", "+", 
            RowBox[{"\[ImaginaryI]", "/", "2"}]}]}]}], "//.", 
         RowBox[{"shiftm\[Eta]", "[", "3", "]"}]}], "//.", "subtousu"}], "//",
        "funapartusu"}], "//", "funreduceusu"}], ",", "canlist"}], "]"}]}], 
  ";"}]], "Input",
 CellChangeTimes->{{3.56226682426929*^9, 3.562266868028184*^9}, {
  3.563305330146161*^9, 3.563305372689372*^9}, {3.563306202657221*^9, 
  3.5633062033028193`*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Collect", "[", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{
        RowBox[{"preq24", "/.", 
         RowBox[{"Shift", "[", 
          RowBox[{"-", "1"}], "]"}]}], "/.", 
        RowBox[{"u", "\[Rule]", 
         RowBox[{"u", "-", 
          RowBox[{"\[ImaginaryI]", "/", "2"}]}]}]}], "//.", 
       RowBox[{"shiftp\[Eta]", "[", "0", "]"}]}], ")"}], "-", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"preq24", "/.", 
        RowBox[{"Shift", "[", "1", "]"}]}], "/.", 
       RowBox[{"u", "\[Rule]", 
        RowBox[{"u", "+", 
         RowBox[{"\[ImaginaryI]", "/", "2"}]}]}]}], ")"}], "-", "tmp4"}], "/.",
     "subusu"}], ",", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"g", ",", "\[Eta]list"}], "}"}], "//", "Flatten"}], ",", 
   "Simplify"}], "]"}]], "Input",
 CellChangeTimes->{{3.563305375551408*^9, 3.5633054561835203`*^9}, {
  3.56330621009237*^9, 3.56330621332727*^9}}],

Cell[BoxData["0"], "Output",
 CellChangeTimes->{3.563305377834938*^9, 3.5633054576633053`*^9, 
  3.563306214897204*^9}]
}, Open  ]],

Cell[TextData[{
 "It remains to multiply this expression on ",
 Cell[BoxData[
  FormBox[
   SubscriptBox["q", 
    RowBox[{"1", ",", "2"}]], TraditionalForm]],
  FormatType->"TraditionalForm"]
}], "Text",
 CellChangeTimes->{{3.563305465928132*^9, 3.5633054757081842`*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"Collect", "[", 
   RowBox[{
    RowBox[{"Series", "[", 
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{
          RowBox[{
           SubscriptBox["q", 
            RowBox[{"1", ",", "2"}]], "/.", "substandardq"}], "/.", 
          RowBox[{
           RowBox[{"xxx", ":", 
            RowBox[{"\[Alpha]", "|", 
             OverscriptBox["\[Alpha]", "_"]}]}], "\[RuleDelayed]", 
           RowBox[{"(", 
            RowBox[{"xxx", "/.", 
             RowBox[{"leadweak", "[", "1", "]"}]}], ")"}]}]}], "/.", 
         RowBox[{"leadweak", "[", "5", "]"}]}], "/.", "subIm"}], "/.", 
       "subQ0"}], ",", 
      RowBox[{"{", 
       RowBox[{"g", ",", "0", ",", "8"}], "}"}]}], "]"}], ",", "canlist"}], 
   "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"q24atfiveloops", "=", 
   RowBox[{"Collect", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"Normal", "@", 
       RowBox[{"Series", "[", 
        RowBox[{
         RowBox[{"%", " ", "preq24"}], ",", 
         RowBox[{"{", 
          RowBox[{"g", ",", "0", ",", "12"}], "}"}]}], "]"}]}], "//", 
      "funreduceusu"}], ",", "canlist"}], "]"}]}], ";"}]}], "Input",
 CellChangeTimes->{{3.5633054767824297`*^9, 3.563305601493984*^9}, {
  3.5633056342423487`*^9, 3.563305635138412*^9}, {3.563306218557611*^9, 
  3.563306222332995*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Series", "[", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"q24atfiveloops", "-", 
      SubscriptBox["q", 
       RowBox[{"2", ",", "4"}]]}], "/.", 
     RowBox[{"leadweak", "[", "4", "]"}]}], "/.", "subQ0"}], ",", 
   RowBox[{"{", 
    RowBox[{"g", ",", "0", ",", "10"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.5633056103029222`*^9, 3.5633056127958813`*^9}, {
  3.563305667305888*^9, 3.563305686947042*^9}, {3.563306227526043*^9, 
  3.563306231741786*^9}}],

Cell[BoxData[
 InterpretationBox[
  SuperscriptBox[
   RowBox[{"O", "[", "g", "]"}], "11"],
  SeriesData[$CellContext`g, 0, {}, 11, 11, 1],
  Editable->False]], "Output",
 CellChangeTimes->{{3.5633056823712473`*^9, 3.56330568814113*^9}, 
   3.563306236082868*^9}]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"AddNsDefinition", "[", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{
      RowBox[{"q$", "[", 
       RowBox[{"2", ",", "4"}], "]"}], "[", "0", "]"}], ",", 
     RowBox[{"PrepareList", "[", "q24atfiveloops", "]"}]}], "}"}], "]"}], 
  ";"}]], "Input",
 CellChangeTimes->{{3.563305692728593*^9, 3.5633057273526154`*^9}, {
  3.563306239868538*^9, 3.563306244813541*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["Finally computing H at fifth order!", "Subsection",
 CellChangeTimes->{{3.561478125748274*^9, 3.561478147379468*^9}}],

Cell["\<\
Note that we do not compute Hr1 at fifth order. This term gives zero if the \
contour of integration in the wrapping energy integral is at -3I/4. We will \
use this fact.\
\>", "Text",
 CellChangeTimes->{{3.568969004011692*^9, 3.568969041336934*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"tmp", "=", 
   RowBox[{"List", "@@", 
    RowBox[{"Collect", "[", 
     RowBox[{
      RowBox[{"nsLogRat", "[", 
       RowBox[{
        FractionBox[
         SubscriptBox["T", 
          RowBox[{"1", ",", "0"}]], 
         SubsuperscriptBox["T", 
          RowBox[{"0", ",", "0"}], "+"]], ",", "16"}], "]"}], ",", "g"}], 
     "]"}]}]}], ";"}]], "Input",
 CellChangeTimes->{{3.5633064127698917`*^9, 3.5633064744863567`*^9}}],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"nspowers", "::", "asymcheck"}], "MessageName"], 
  RowBox[{
  ":", " "}], "\<\"\[NoBreak]\\!\\(\\(\\*StyleBox[\\\"U\\\", \
List[Rule[FontColor, RGBColor[0, 0.6`, 0]]]]\\)\\&\\(\\*StyleBox[\\\"_\\\", \
List[Rule[FontColor, RGBColor[0, 0.6`, 0]]]]\\)\\)\[NoBreak] assumed to be in \
the ordinary regime\"\>"}]], "Message", "MSG",
 CellChangeTimes->{{3.563306426317608*^9, 3.5633064749351597`*^9}}],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"nspowers", "::", "asymcheck"}], "MessageName"], 
  RowBox[{
  ":", " "}], "\<\"\[NoBreak]\\!\\(\\(\\*StyleBox[\\\"U\\\", \
List[Rule[FontColor, RGBColor[0, 0.6`, 0]]]]\\)\\&\\(\\*StyleBox[\\\"_\\\", \
List[Rule[FontColor, RGBColor[0, 0.6`, 0]]]]\\)\\)\[NoBreak] assumed to be in \
the ordinary regime\"\>"}]], "Message", "MSG",
 CellChangeTimes->{{3.563306426317608*^9, 3.563306474954454*^9}}],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"nspowers", "::", "asymcheck"}], "MessageName"], 
  RowBox[{
  ":", " "}], "\<\"\[NoBreak]\\!\\(\\(\\(\\*StyleBox[\\\"q\\\", \
List[Rule[FontColor, RGBColor[0, 0, 0.8`]]]]\\)\\&\\(\\*StyleBox[\\\"_\\\", \
List[Rule[FontColor, RGBColor[0, 0, 0.8`]]]]\\)\\)\\_2\\)\[NoBreak] assumed \
to be in the ordinary regime\"\>"}]], "Message", "MSG",
 CellChangeTimes->{{3.563306426317608*^9, 3.563306474970501*^9}}],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"General", "::", "stop"}], "MessageName"], 
  RowBox[{
  ":", " "}], "\<\"Further output of \[NoBreak]\\!\\(\\*StyleBox[\\(nspowers \
:: asymcheck\\), \\\"MessageName\\\"]\\)\[NoBreak] will be suppressed during \
this calculation. \\!\\(\\*ButtonBox[\\\"\[RightSkeleton]\\\", \
ButtonStyle->\\\"Link\\\", ButtonFrame->None, \
ButtonData:>\\\"paclet:ref/message/General/stop\\\", ButtonNote -> \
\\\"General::stop\\\"]\\)\"\>"}]], "Message", "MSG",
 CellChangeTimes->{{3.563306426317608*^9, 3.563306474985571*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Series", "[", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{"Select", "[", 
        RowBox[{"#", ",", 
         RowBox[{
          RowBox[{"FreeQ", "[", 
           RowBox[{"#", ",", "q$"}], "]"}], "&"}]}], "]"}], "&"}], "/@", 
      RowBox[{"Collect", "[", 
       RowBox[{
        RowBox[{"tmp", "/.", 
         RowBox[{"g", "\[Rule]", "1"}]}], ",", 
        RowBox[{"{", 
         RowBox[{
          SuperscriptBox["Q", "+"], ",", 
          SuperscriptBox["Q", "-"]}], "}"}]}], "]"}]}], "/.", 
     RowBox[{"leadweak", "[", "1", "]"}]}], "/.", "subQ0"}], ",", 
   RowBox[{"{", 
    RowBox[{"u", ",", "\[Infinity]", ",", "1"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.563306475914753*^9, 3.563306491739077*^9}, {
  3.5633065500007257`*^9, 3.5633066460803957`*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   InterpretationBox[
    SuperscriptBox[
     RowBox[{"O", "[", 
      FractionBox["1", "u"], "]"}], "2"],
    SeriesData[$CellContext`u, 
     DirectedInfinity[1], {}, 2, 2, 1],
    Editable->False], ",", 
   InterpretationBox[
    SuperscriptBox[
     RowBox[{"O", "[", 
      FractionBox["1", "u"], "]"}], "2"],
    SeriesData[$CellContext`u, 
     DirectedInfinity[1], {}, 2, 2, 1],
    Editable->False]}], "}"}]], "Output",
 CellChangeTimes->{
  3.563306492605158*^9, {3.5633065519006*^9, 3.5633066490488453`*^9}}]
}, Open  ]],

Cell["\<\
The check above that we can disregard these Q-terms, integration over them \
will give zero anyway (if we start from -3I/4).\
\>", "Text",
 CellChangeTimes->{{3.5633066412978897`*^9, 3.56330667292028*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"tmp2", "=", 
  RowBox[{"Collect", "[", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"Select", "[", 
       RowBox[{
        RowBox[{"#", "//", "Expand"}], ",", 
        RowBox[{
         RowBox[{"Not", "@", 
          RowBox[{"FreeQ", "[", 
           RowBox[{"#", ",", "q$"}], "]"}]}], "&"}]}], "]"}], "&"}], "/@", 
     RowBox[{"Collect", "[", 
      RowBox[{
       RowBox[{"tmp", "/.", 
        RowBox[{"g", "\[Rule]", "1"}]}], ",", 
       RowBox[{"{", 
        RowBox[{
         SuperscriptBox["Q", "+"], ",", 
         SuperscriptBox["Q", "-"]}], "}"}]}], "]"}]}], ",", 
    RowBox[{"{", 
     RowBox[{"U", ",", 
      SuperscriptBox["Q", "+"], ",", 
      SuperscriptBox["Q", "-"]}], "}"}], ",", "Factor"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.5633066817350388`*^9, 3.5633067138281097`*^9}, {
  3.563317490041563*^9, 3.563317500925681*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   FractionBox[
    RowBox[{
     SuperscriptBox[
      OverscriptBox[
       StyleBox["U",
        FontColor->RGBColor[0, 0.6, 0]], 
       StyleBox["_",
        FontColor->RGBColor[0, 0.6, 0]]], "2"], " ", 
     RowBox[{"(", 
      RowBox[{
       SubsuperscriptBox[
        StyleBox["q",
         FontColor->RGBColor[0, 0, 0.8]], 
        RowBox[{"2", ",", "4"}], "+"], "+", 
       RowBox[{"2", " ", 
        SubsuperscriptBox[
         StyleBox["q",
          FontColor->RGBColor[0, 0, 0.8]], 
         RowBox[{"1", ",", "4"}], "+"], " ", 
        SubscriptBox[
         OverscriptBox[
          StyleBox["q",
           FontColor->RGBColor[0, 0, 0.8]], 
          StyleBox["_",
           FontColor->RGBColor[0, 0, 0.8]]], "2"]}], "+", 
       RowBox[{
        SubsuperscriptBox[
         StyleBox["q",
          FontColor->RGBColor[0, 0, 0.8]], 
         RowBox[{"1", ",", "3"}], "+"], " ", 
        SubsuperscriptBox[
         OverscriptBox[
          StyleBox["q",
           FontColor->RGBColor[0, 0, 0.8]], 
          StyleBox["_",
           FontColor->RGBColor[0, 0, 0.8]]], "2", "2"]}]}], ")"}]}], 
    RowBox[{
     SuperscriptBox[
      StyleBox["Q",
       FontColor->RGBColor[0.8, 0, 0]], "-"], " ", 
     SuperscriptBox[
      RowBox[{"(", 
       SuperscriptBox[
        StyleBox["Q",
         FontColor->RGBColor[0.8, 0, 0]], "+"], ")"}], "2"]}]], ",", 
   RowBox[{
    RowBox[{"-", 
     FractionBox[
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          RowBox[{"-", "\[ImaginaryI]"}], " ", "\[Alpha]"}], "+", 
         RowBox[{"2", " ", "u", " ", "\[Alpha]"}], "+", 
         RowBox[{"\[ImaginaryI]", " ", 
          OverscriptBox["\[Alpha]", "_"]}], "-", 
         RowBox[{"2", " ", "u", " ", 
          OverscriptBox["\[Alpha]", "_"]}], "-", 
         RowBox[{"2", " ", "\[Alpha]", " ", 
          SubscriptBox["v", "0"]}], "-", 
         RowBox[{"2", " ", 
          OverscriptBox["\[Alpha]", "_"], " ", 
          SubscriptBox["v", "0"]}]}], ")"}], " ", 
       SuperscriptBox[
        OverscriptBox[
         StyleBox["U",
          FontColor->RGBColor[0, 0.6, 0]], 
         StyleBox["_",
          FontColor->RGBColor[0, 0.6, 0]]], "2"], " ", 
       RowBox[{"(", 
        RowBox[{
         SubsuperscriptBox[
          StyleBox["q",
           FontColor->RGBColor[0, 0, 0.8]], 
          RowBox[{"2", ",", "4"}], "+"], "+", 
         RowBox[{"2", " ", 
          SubsuperscriptBox[
           StyleBox["q",
            FontColor->RGBColor[0, 0, 0.8]], 
           RowBox[{"1", ",", "4"}], "+"], " ", 
          SubscriptBox[
           OverscriptBox[
            StyleBox["q",
             FontColor->RGBColor[0, 0, 0.8]], 
            StyleBox["_",
             FontColor->RGBColor[0, 0, 0.8]]], "2"]}], "+", 
         RowBox[{
          SubsuperscriptBox[
           StyleBox["q",
            FontColor->RGBColor[0, 0, 0.8]], 
           RowBox[{"1", ",", "3"}], "+"], " ", 
          SubsuperscriptBox[
           OverscriptBox[
            StyleBox["q",
             FontColor->RGBColor[0, 0, 0.8]], 
            StyleBox["_",
             FontColor->RGBColor[0, 0, 0.8]]], "2", "2"]}]}], ")"}]}], 
      RowBox[{"2", " ", 
       SuperscriptBox[
        RowBox[{"(", 
         SuperscriptBox[
          StyleBox["Q",
           FontColor->RGBColor[0.8, 0, 0]], "-"], ")"}], "2"], " ", 
       SuperscriptBox[
        RowBox[{"(", 
         SuperscriptBox[
          StyleBox["Q",
           FontColor->RGBColor[0.8, 0, 0]], "+"], ")"}], "2"]}]]}], "+", 
    FractionBox[
     RowBox[{
      SuperscriptBox[
       OverscriptBox[
        StyleBox["U",
         FontColor->RGBColor[0, 0.6, 0]], 
        StyleBox["_",
         FontColor->RGBColor[0, 0.6, 0]]], "4"], " ", 
      SuperscriptBox[
       RowBox[{"(", 
        RowBox[{
         SubsuperscriptBox[
          StyleBox["q",
           FontColor->RGBColor[0, 0, 0.8]], 
          RowBox[{"2", ",", "4"}], "+"], "+", 
         RowBox[{"2", " ", 
          SubsuperscriptBox[
           StyleBox["q",
            FontColor->RGBColor[0, 0, 0.8]], 
           RowBox[{"1", ",", "4"}], "+"], " ", 
          SubscriptBox[
           OverscriptBox[
            StyleBox["q",
             FontColor->RGBColor[0, 0, 0.8]], 
            StyleBox["_",
             FontColor->RGBColor[0, 0, 0.8]]], "2"]}], "+", 
         RowBox[{
          SubsuperscriptBox[
           StyleBox["q",
            FontColor->RGBColor[0, 0, 0.8]], 
           RowBox[{"1", ",", "3"}], "+"], " ", 
          SubsuperscriptBox[
           OverscriptBox[
            StyleBox["q",
             FontColor->RGBColor[0, 0, 0.8]], 
            StyleBox["_",
             FontColor->RGBColor[0, 0, 0.8]]], "2", "2"]}]}], ")"}], "2"]}], 
     RowBox[{"2", " ", 
      SuperscriptBox[
       RowBox[{"(", 
        SuperscriptBox[
         StyleBox["Q",
          FontColor->RGBColor[0.8, 0, 0]], "-"], ")"}], "2"], " ", 
      SuperscriptBox[
       RowBox[{"(", 
        SuperscriptBox[
         StyleBox["Q",
          FontColor->RGBColor[0.8, 0, 0]], "+"], ")"}], "4"]}]], "+", 
    RowBox[{
     FractionBox["1", 
      SuperscriptBox[
       RowBox[{"(", 
        SuperscriptBox[
         StyleBox["Q",
          FontColor->RGBColor[0.8, 0, 0]], "+"], ")"}], "3"]], 
     RowBox[{"(", 
      RowBox[{
       FractionBox[
        RowBox[{"2", " ", 
         RowBox[{"(", 
          RowBox[{"\[Alpha]", "+", 
           OverscriptBox["\[Alpha]", "_"]}], ")"}], " ", 
         SubscriptBox["v", "0"], " ", 
         SuperscriptBox[
          OverscriptBox[
           StyleBox["U",
            FontColor->RGBColor[0, 0.6, 0]], 
           StyleBox["_",
            FontColor->RGBColor[0, 0.6, 0]]], "2"], " ", 
         RowBox[{"(", 
          RowBox[{
           SubsuperscriptBox[
            StyleBox["q",
             FontColor->RGBColor[0, 0, 0.8]], 
            RowBox[{"2", ",", "4"}], "+"], "+", 
           RowBox[{"2", " ", 
            SubsuperscriptBox[
             StyleBox["q",
              FontColor->RGBColor[0, 0, 0.8]], 
             RowBox[{"1", ",", "4"}], "+"], " ", 
            SubscriptBox[
             OverscriptBox[
              StyleBox["q",
               FontColor->RGBColor[0, 0, 0.8]], 
              StyleBox["_",
               FontColor->RGBColor[0, 0, 0.8]]], "2"]}], "+", 
           RowBox[{
            SubsuperscriptBox[
             StyleBox["q",
              FontColor->RGBColor[0, 0, 0.8]], 
             RowBox[{"1", ",", "3"}], "+"], " ", 
            SubsuperscriptBox[
             OverscriptBox[
              StyleBox["q",
               FontColor->RGBColor[0, 0, 0.8]], 
              StyleBox["_",
               FontColor->RGBColor[0, 0, 0.8]]], "2", "2"]}]}], ")"}]}], 
        SuperscriptBox[
         StyleBox["Q",
          FontColor->RGBColor[0.8, 0, 0]], "-"]], "+", 
       RowBox[{
        RowBox[{"1", "/", 
         SuperscriptBox[
          RowBox[{"(", 
           SuperscriptBox[
            StyleBox["Q",
             FontColor->RGBColor[0.8, 0, 0]], "-"], ")"}], "2"]}], 
        RowBox[{
         SuperscriptBox[
          OverscriptBox[
           StyleBox["U",
            FontColor->RGBColor[0, 0.6, 0]], 
           StyleBox["_",
            FontColor->RGBColor[0, 0.6, 0]]], "2"], " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{
            SuperscriptBox[
             RowBox[{"(", 
              SubsuperscriptBox[
               StyleBox["q",
                FontColor->RGBColor[0, 0, 0.8]], 
               RowBox[{"2", ",", "4"}], "+"], ")"}], "2"], " ", 
            SubsuperscriptBox[
             OverscriptBox[
              StyleBox["q",
               FontColor->RGBColor[0, 0, 0.8]], 
              StyleBox["_",
               FontColor->RGBColor[0, 0, 0.8]]], 
             RowBox[{"1", ",", "3"}], "-"]}], "+", 
           RowBox[{"2", " ", 
            SubsuperscriptBox[
             StyleBox["q",
              FontColor->RGBColor[0, 0, 0.8]], 
             RowBox[{"1", ",", "4"}], "+"], " ", 
            SubsuperscriptBox[
             StyleBox["q",
              FontColor->RGBColor[0, 0, 0.8]], 
             RowBox[{"2", ",", "4"}], "+"], " ", 
            SubscriptBox[
             OverscriptBox[
              StyleBox["q",
               FontColor->RGBColor[0, 0, 0.8]], 
              StyleBox["_",
               FontColor->RGBColor[0, 0, 0.8]]], "2"], " ", 
            SubsuperscriptBox[
             OverscriptBox[
              StyleBox["q",
               FontColor->RGBColor[0, 0, 0.8]], 
              StyleBox["_",
               FontColor->RGBColor[0, 0, 0.8]]], 
             RowBox[{"1", ",", "3"}], "-"]}], "+", 
           RowBox[{
            SuperscriptBox[
             RowBox[{"(", 
              SubsuperscriptBox[
               StyleBox["q",
                FontColor->RGBColor[0, 0, 0.8]], 
               RowBox[{"1", ",", "4"}], "+"], ")"}], "2"], " ", 
            SubsuperscriptBox[
             OverscriptBox[
              StyleBox["q",
               FontColor->RGBColor[0, 0, 0.8]], 
              StyleBox["_",
               FontColor->RGBColor[0, 0, 0.8]]], "2", "2"], " ", 
            SubsuperscriptBox[
             OverscriptBox[
              StyleBox["q",
               FontColor->RGBColor[0, 0, 0.8]], 
              StyleBox["_",
               FontColor->RGBColor[0, 0, 0.8]]], 
             RowBox[{"1", ",", "3"}], "-"]}], "+", 
           RowBox[{"2", " ", 
            SubsuperscriptBox[
             StyleBox["q",
              FontColor->RGBColor[0, 0, 0.8]], 
             RowBox[{"1", ",", "4"}], "+"], " ", 
            SubsuperscriptBox[
             StyleBox["q",
              FontColor->RGBColor[0, 0, 0.8]], 
             RowBox[{"2", ",", "4"}], "+"], " ", 
            SubsuperscriptBox[
             OverscriptBox[
              StyleBox["q",
               FontColor->RGBColor[0, 0, 0.8]], 
              StyleBox["_",
               FontColor->RGBColor[0, 0, 0.8]]], 
             RowBox[{"1", ",", "4"}], "-"]}], "+", 
           RowBox[{"2", " ", 
            SuperscriptBox[
             RowBox[{"(", 
              SubsuperscriptBox[
               StyleBox["q",
                FontColor->RGBColor[0, 0, 0.8]], 
               RowBox[{"1", ",", "4"}], "+"], ")"}], "2"], " ", 
            SubscriptBox[
             OverscriptBox[
              StyleBox["q",
               FontColor->RGBColor[0, 0, 0.8]], 
              StyleBox["_",
               FontColor->RGBColor[0, 0, 0.8]]], "2"], " ", 
            SubsuperscriptBox[
             OverscriptBox[
              StyleBox["q",
               FontColor->RGBColor[0, 0, 0.8]], 
              StyleBox["_",
               FontColor->RGBColor[0, 0, 0.8]]], 
             RowBox[{"1", ",", "4"}], "-"]}], "+", 
           RowBox[{"2", " ", 
            SubsuperscriptBox[
             StyleBox["q",
              FontColor->RGBColor[0, 0, 0.8]], 
             RowBox[{"1", ",", "3"}], "+"], " ", 
            SubsuperscriptBox[
             StyleBox["q",
              FontColor->RGBColor[0, 0, 0.8]], 
             RowBox[{"2", ",", "4"}], "+"], " ", 
            SubscriptBox[
             OverscriptBox[
              StyleBox["q",
               FontColor->RGBColor[0, 0, 0.8]], 
              StyleBox["_",
               FontColor->RGBColor[0, 0, 0.8]]], "2"], " ", 
            SubsuperscriptBox[
             OverscriptBox[
              StyleBox["q",
               FontColor->RGBColor[0, 0, 0.8]], 
              StyleBox["_",
               FontColor->RGBColor[0, 0, 0.8]]], 
             RowBox[{"1", ",", "4"}], "-"]}], "+", 
           RowBox[{"2", " ", 
            SubsuperscriptBox[
             StyleBox["q",
              FontColor->RGBColor[0, 0, 0.8]], 
             RowBox[{"1", ",", "3"}], "+"], " ", 
            SubsuperscriptBox[
             StyleBox["q",
              FontColor->RGBColor[0, 0, 0.8]], 
             RowBox[{"1", ",", "4"}], "+"], " ", 
            SubsuperscriptBox[
             OverscriptBox[
              StyleBox["q",
               FontColor->RGBColor[0, 0, 0.8]], 
              StyleBox["_",
               FontColor->RGBColor[0, 0, 0.8]]], "2", "2"], " ", 
            SubsuperscriptBox[
             OverscriptBox[
              StyleBox["q",
               FontColor->RGBColor[0, 0, 0.8]], 
              StyleBox["_",
               FontColor->RGBColor[0, 0, 0.8]]], 
             RowBox[{"1", ",", "4"}], "-"]}], "+", 
           RowBox[{
            SuperscriptBox[
             RowBox[{"(", 
              SubsuperscriptBox[
               StyleBox["q",
                FontColor->RGBColor[0, 0, 0.8]], 
               RowBox[{"1", ",", "4"}], "+"], ")"}], "2"], " ", 
            SubsuperscriptBox[
             OverscriptBox[
              StyleBox["q",
               FontColor->RGBColor[0, 0, 0.8]], 
              StyleBox["_",
               FontColor->RGBColor[0, 0, 0.8]]], 
             RowBox[{"2", ",", "4"}], "-"]}], "+", 
           RowBox[{"2", " ", 
            SubsuperscriptBox[
             StyleBox["q",
              FontColor->RGBColor[0, 0, 0.8]], 
             RowBox[{"1", ",", "3"}], "+"], " ", 
            SubsuperscriptBox[
             StyleBox["q",
              FontColor->RGBColor[0, 0, 0.8]], 
             RowBox[{"1", ",", "4"}], "+"], " ", 
            SubscriptBox[
             OverscriptBox[
              StyleBox["q",
               FontColor->RGBColor[0, 0, 0.8]], 
              StyleBox["_",
               FontColor->RGBColor[0, 0, 0.8]]], "2"], " ", 
            SubsuperscriptBox[
             OverscriptBox[
              StyleBox["q",
               FontColor->RGBColor[0, 0, 0.8]], 
              StyleBox["_",
               FontColor->RGBColor[0, 0, 0.8]]], 
             RowBox[{"2", ",", "4"}], "-"]}], "+", 
           RowBox[{
            SuperscriptBox[
             RowBox[{"(", 
              SubsuperscriptBox[
               StyleBox["q",
                FontColor->RGBColor[0, 0, 0.8]], 
               RowBox[{"1", ",", "3"}], "+"], ")"}], "2"], " ", 
            SubsuperscriptBox[
             OverscriptBox[
              StyleBox["q",
               FontColor->RGBColor[0, 0, 0.8]], 
              StyleBox["_",
               FontColor->RGBColor[0, 0, 0.8]]], "2", "2"], " ", 
            SubsuperscriptBox[
             OverscriptBox[
              StyleBox["q",
               FontColor->RGBColor[0, 0, 0.8]], 
              StyleBox["_",
               FontColor->RGBColor[0, 0, 0.8]]], 
             RowBox[{"2", ",", "4"}], "-"]}]}], ")"}]}]}]}], ")"}]}]}]}], 
  "}"}]], "Output",
 CellChangeTimes->{{3.563306687883974*^9, 3.563306714732193*^9}, {
  3.563317495300687*^9, 3.5633175088583307`*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{
        SubscriptBox["T", 
         RowBox[{"1", ",", "0"}]], "/.", "subTQ"}], "/.", "subpqb"}], "/.", 
      "substandardq"}], "/.", "subtoanalyticitystrips"}], "/.", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         RowBox[{"-", 
          SubsuperscriptBox[
           StyleBox["q",
            FontColor->RGBColor[0, 0, 0.8]], 
           RowBox[{"2", ",", "4"}], "+"]}], " ", 
         SubsuperscriptBox[
          OverscriptBox[
           StyleBox["q",
            FontColor->RGBColor[0, 0, 0.8]], 
           StyleBox["_",
            FontColor->RGBColor[0, 0, 0.8]]], 
          RowBox[{"1", ",", "3"}], "-"]}], "-", 
        RowBox[{"2", " ", 
         SubsuperscriptBox[
          StyleBox["q",
           FontColor->RGBColor[0, 0, 0.8]], 
          RowBox[{"1", ",", "4"}], "+"], " ", 
         SubsuperscriptBox[
          OverscriptBox[
           StyleBox["q",
            FontColor->RGBColor[0, 0, 0.8]], 
           StyleBox["_",
            FontColor->RGBColor[0, 0, 0.8]]], 
          RowBox[{"1", ",", "4"}], "-"]}], "-", 
        RowBox[{
         SubsuperscriptBox[
          StyleBox["q",
           FontColor->RGBColor[0, 0, 0.8]], 
          RowBox[{"1", ",", "3"}], "+"], " ", 
         SubsuperscriptBox[
          OverscriptBox[
           StyleBox["q",
            FontColor->RGBColor[0, 0, 0.8]], 
           StyleBox["_",
            FontColor->RGBColor[0, 0, 0.8]]], 
          RowBox[{"2", ",", "4"}], "-"]}]}], ")"}], "\[Rule]", 
      RowBox[{"-", "comb1"}]}], ")"}]}], ",", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"Collect", "[", 
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{
          SubsuperscriptBox["T", 
           RowBox[{"0", ",", "0"}], "+"], "/.", "subTQ"}], "/.", "subpqb"}], "/.",
         "substandardq"}], "/.", "subtoanalyticitystrips"}], ",", 
      RowBox[{"{", 
       RowBox[{
        OverscriptBox["U", "_"], ",", 
        RowBox[{
         RowBox[{"q$b", "[", 
          RowBox[{"1", ",", "2"}], "]"}], "[", "_", "]"}], ",", 
        RowBox[{
         RowBox[{"q$b", "[", 
          RowBox[{"1", ",", "2"}], "]"}], "[", "_", "]"}]}], "}"}]}], "]"}], "/.", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          RowBox[{"-", 
           SubsuperscriptBox[
            StyleBox["q",
             FontColor->RGBColor[0, 0, 0.8]], 
            RowBox[{"2", ",", "4"}], "+"]}], " ", 
          SubsuperscriptBox[
           OverscriptBox[
            StyleBox["q",
             FontColor->RGBColor[0, 0, 0.8]], 
            StyleBox["_",
             FontColor->RGBColor[0, 0, 0.8]]], 
           RowBox[{"1", ",", "3"}], "-"]}], "-", 
         RowBox[{"2", " ", 
          SubsuperscriptBox[
           StyleBox["q",
            FontColor->RGBColor[0, 0, 0.8]], 
           RowBox[{"1", ",", "4"}], "+"], " ", 
          SubsuperscriptBox[
           OverscriptBox[
            StyleBox["q",
             FontColor->RGBColor[0, 0, 0.8]], 
            StyleBox["_",
             FontColor->RGBColor[0, 0, 0.8]]], 
           RowBox[{"1", ",", "4"}], "-"]}], "-", 
         RowBox[{
          SubsuperscriptBox[
           StyleBox["q",
            FontColor->RGBColor[0, 0, 0.8]], 
           RowBox[{"1", ",", "3"}], "+"], " ", 
          SubsuperscriptBox[
           OverscriptBox[
            StyleBox["q",
             FontColor->RGBColor[0, 0, 0.8]], 
            StyleBox["_",
             FontColor->RGBColor[0, 0, 0.8]]], 
           RowBox[{"2", ",", "4"}], "-"]}]}], ")"}], "\[Rule]", 
       RowBox[{"-", "comb1"}]}], ",", 
      RowBox[{
       RowBox[{
        SuperscriptBox[
         OverscriptBox[
          StyleBox["U",
           FontColor->RGBColor[0, 0.6, 0]], 
          StyleBox["_",
           FontColor->RGBColor[0, 0.6, 0]]], "2"], " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"-", 
           SubsuperscriptBox[
            StyleBox["q",
             FontColor->RGBColor[0, 0, 0.8]], 
            RowBox[{"2", ",", "4"}], "+"]}], "-", 
          RowBox[{"2", " ", 
           SubsuperscriptBox[
            StyleBox["q",
             FontColor->RGBColor[0, 0, 0.8]], 
            RowBox[{"1", ",", "4"}], "+"], " ", 
           SubscriptBox[
            OverscriptBox[
             StyleBox["q",
              FontColor->RGBColor[0, 0, 0.8]], 
             StyleBox["_",
              FontColor->RGBColor[0, 0, 0.8]]], "2"]}], "-", 
          RowBox[{
           SubsuperscriptBox[
            StyleBox["q",
             FontColor->RGBColor[0, 0, 0.8]], 
            RowBox[{"1", ",", "3"}], "+"], " ", 
           SubsuperscriptBox[
            OverscriptBox[
             StyleBox["q",
              FontColor->RGBColor[0, 0, 0.8]], 
             StyleBox["_",
              FontColor->RGBColor[0, 0, 0.8]]], "2", "2"]}]}], ")"}]}], 
       "\[Rule]", 
       RowBox[{"-", "comb2"}]}]}], "}"}]}]}], "}"}]], "Input"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{
    RowBox[{"-", "comb1"}], "+", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{
        RowBox[{"-", "\[Alpha]"}], " ", 
        OverscriptBox["\[Alpha]", "_"]}], "+", 
       SuperscriptBox[
        StyleBox["Q",
         FontColor->RGBColor[0.8, 0, 0]], "-"], "+", 
       RowBox[{"\[Alpha]", " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"-", 
           FractionBox["\[ImaginaryI]", "2"]}], "+", "u", "-", 
          SubscriptBox["v", "0"]}], ")"}]}], "-", 
       RowBox[{
        OverscriptBox["\[Alpha]", "_"], " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"-", 
           FractionBox["\[ImaginaryI]", "2"]}], "+", "u", "+", 
          SubscriptBox["v", "0"]}], ")"}]}]}], ")"}], " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{
        RowBox[{"-", "\[Alpha]"}], " ", 
        OverscriptBox["\[Alpha]", "_"]}], "+", 
       SuperscriptBox[
        StyleBox["Q",
         FontColor->RGBColor[0.8, 0, 0]], "+"], "+", 
       RowBox[{
        OverscriptBox["\[Alpha]", "_"], " ", 
        RowBox[{"(", 
         RowBox[{
          FractionBox["\[ImaginaryI]", "2"], "+", "u", "-", 
          SubscriptBox["v", "0"]}], ")"}]}], "-", 
       RowBox[{"\[Alpha]", " ", 
        RowBox[{"(", 
         RowBox[{
          FractionBox["\[ImaginaryI]", "2"], "+", "u", "+", 
          SubscriptBox["v", "0"]}], ")"}]}]}], ")"}]}], "+", 
    RowBox[{
     SubsuperscriptBox[
      StyleBox["q",
       FontColor->RGBColor[0, 0, 0.8]], 
      RowBox[{"3", ",", "4"}], "+"], " ", 
     SubsuperscriptBox[
      OverscriptBox[
       StyleBox["q",
        FontColor->RGBColor[0, 0, 0.8]], 
       StyleBox["_",
        FontColor->RGBColor[0, 0, 0.8]]], 
      RowBox[{"3", ",", "4"}], "-"]}]}], ",", 
   RowBox[{
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{
        RowBox[{"-", "\[Alpha]"}], " ", 
        OverscriptBox["\[Alpha]", "_"]}], "+", 
       SuperscriptBox[
        StyleBox["Q",
         FontColor->RGBColor[0.8, 0, 0]], "+"], "+", 
       RowBox[{
        OverscriptBox["\[Alpha]", "_"], " ", 
        RowBox[{"(", 
         RowBox[{
          FractionBox["\[ImaginaryI]", "2"], "+", "u", "-", 
          SubscriptBox["v", "0"]}], ")"}]}], "-", 
       RowBox[{"\[Alpha]", " ", 
        RowBox[{"(", 
         RowBox[{
          FractionBox["\[ImaginaryI]", "2"], "+", "u", "+", 
          SubscriptBox["v", "0"]}], ")"}]}]}], ")"}], " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{
        RowBox[{"-", "\[Alpha]"}], " ", 
        OverscriptBox["\[Alpha]", "_"]}], "+", 
       SuperscriptBox[
        StyleBox["Q",
         FontColor->RGBColor[0.8, 0, 0]], "+"], "+", 
       RowBox[{"\[Alpha]", " ", 
        RowBox[{"(", 
         RowBox[{
          FractionBox["\[ImaginaryI]", "2"], "+", "u", "-", 
          SubscriptBox["v", "0"]}], ")"}]}], "-", 
       RowBox[{
        OverscriptBox["\[Alpha]", "_"], " ", 
        RowBox[{"(", 
         RowBox[{
          FractionBox["\[ImaginaryI]", "2"], "+", "u", "+", 
          SubscriptBox["v", "0"]}], ")"}]}]}], ")"}]}], "-", 
    FractionBox["comb2", 
     SubsuperscriptBox[
      OverscriptBox[
       StyleBox["q",
        FontColor->RGBColor[0, 0, 0.8]], 
       StyleBox["_",
        FontColor->RGBColor[0, 0, 0.8]]], 
      RowBox[{"1", ",", "2"}], "-"]], "-", 
    FractionBox[
     RowBox[{"comb1", " ", 
      SubsuperscriptBox[
       OverscriptBox[
        StyleBox["q",
         FontColor->RGBColor[0, 0, 0.8]], 
        StyleBox["_",
         FontColor->RGBColor[0, 0, 0.8]]], 
       RowBox[{"1", ",", "2"}], "+"]}], 
     SubsuperscriptBox[
      OverscriptBox[
       StyleBox["q",
        FontColor->RGBColor[0, 0, 0.8]], 
       StyleBox["_",
        FontColor->RGBColor[0, 0, 0.8]]], 
      RowBox[{"1", ",", "2"}], "-"]], "+", 
    RowBox[{
     SubsuperscriptBox[
      StyleBox["q",
       FontColor->RGBColor[0, 0, 0.8]], 
      RowBox[{"3", ",", "4"}], "+"], " ", 
     SubsuperscriptBox[
      OverscriptBox[
       StyleBox["q",
        FontColor->RGBColor[0, 0, 0.8]], 
       StyleBox["_",
        FontColor->RGBColor[0, 0, 0.8]]], 
      RowBox[{"3", ",", "4"}], "+"]}]}]}], "}"}]], "Output",
 CellChangeTimes->{3.563318935985236*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"ExpaCol", "[", 
      RowBox[{
       RowBox[{
        FractionBox[
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{
             RowBox[{"-", "\[Alpha]"}], " ", 
             OverscriptBox["\[Alpha]", "_"]}], "+", 
            SuperscriptBox[
             StyleBox["Q",
              FontColor->RGBColor[0.8, 0, 0]], "-"], "+", 
            RowBox[{"\[Alpha]", " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"-", 
                FractionBox["\[ImaginaryI]", "2"]}], "+", "u", "-", 
               SubscriptBox["v", "0"]}], ")"}]}], "-", 
            RowBox[{
             OverscriptBox["\[Alpha]", "_"], " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"-", 
                FractionBox["\[ImaginaryI]", "2"]}], "+", "u", "+", 
               SubscriptBox["v", "0"]}], ")"}]}]}], ")"}], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{
             RowBox[{"-", "\[Alpha]"}], " ", 
             OverscriptBox["\[Alpha]", "_"]}], "+", 
            SuperscriptBox[
             StyleBox["Q",
              FontColor->RGBColor[0.8, 0, 0]], "+"], "+", 
            RowBox[{
             OverscriptBox["\[Alpha]", "_"], " ", 
             RowBox[{"(", 
              RowBox[{
               FractionBox["\[ImaginaryI]", "2"], "+", "u", "-", 
               SubscriptBox["v", "0"]}], ")"}]}], "-", 
            RowBox[{"\[Alpha]", " ", 
             RowBox[{"(", 
              RowBox[{
               FractionBox["\[ImaginaryI]", "2"], "+", "u", "+", 
               SubscriptBox["v", "0"]}], ")"}]}]}], ")"}]}], 
         RowBox[{
          SuperscriptBox["Q", "-"], 
          SuperscriptBox[
           StyleBox["Q",
            FontColor->RGBColor[0.8, 0, 0]], "+"]}]], "-", 
        FractionBox[
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{
             RowBox[{"-", "\[Alpha]"}], " ", 
             OverscriptBox["\[Alpha]", "_"]}], "+", 
            SuperscriptBox[
             StyleBox["Q",
              FontColor->RGBColor[0.8, 0, 0]], "+"], "+", 
            RowBox[{
             OverscriptBox["\[Alpha]", "_"], " ", 
             RowBox[{"(", 
              RowBox[{
               FractionBox["\[ImaginaryI]", "2"], "+", "u", "-", 
               SubscriptBox["v", "0"]}], ")"}]}], "-", 
            RowBox[{"\[Alpha]", " ", 
             RowBox[{"(", 
              RowBox[{
               FractionBox["\[ImaginaryI]", "2"], "+", "u", "+", 
               SubscriptBox["v", "0"]}], ")"}]}]}], ")"}], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{
             RowBox[{"-", "\[Alpha]"}], " ", 
             OverscriptBox["\[Alpha]", "_"]}], "+", 
            SuperscriptBox[
             StyleBox["Q",
              FontColor->RGBColor[0.8, 0, 0]], "+"], "+", 
            RowBox[{"\[Alpha]", " ", 
             RowBox[{"(", 
              RowBox[{
               FractionBox["\[ImaginaryI]", "2"], "+", "u", "-", 
               SubscriptBox["v", "0"]}], ")"}]}], "-", 
            RowBox[{
             OverscriptBox["\[Alpha]", "_"], " ", 
             RowBox[{"(", 
              RowBox[{
               FractionBox["\[ImaginaryI]", "2"], "+", "u", "+", 
               SubscriptBox["v", "0"]}], ")"}]}]}], ")"}]}], 
         RowBox[{
          SuperscriptBox["Q", "+"], 
          SuperscriptBox[
           StyleBox["Q",
            FontColor->RGBColor[0.8, 0, 0]], "+"]}]]}], ",", 
       RowBox[{
        OverscriptBox["\[Alpha]", "_"], "|", "\[Alpha]"}], ",", "Simplify"}], 
      "]"}], "/.", 
     RowBox[{
      SuperscriptBox["\[Alpha]", "2"], "\[Rule]", "0"}]}], "/.", 
    RowBox[{
     SuperscriptBox[
      OverscriptBox["\[Alpha]", "_"], "2"], "\[Rule]", "0"}]}], "/.", 
   RowBox[{
    RowBox[{"\[Alpha]", " ", 
     OverscriptBox["\[Alpha]", "_"]}], " ", "\[Rule]", "0"}]}], "//", 
  "Together"}]], "Input",
 CellChangeTimes->{{3.5633192101395893`*^9, 3.563319292234867*^9}, {
  3.5633193310021276`*^9, 3.563319392427128*^9}, {3.563319488541422*^9, 
  3.563319502015697*^9}, {3.563319622926507*^9, 3.563319627166506*^9}}],

Cell[BoxData[
 FractionBox[
  RowBox[{
   RowBox[{
    RowBox[{"-", "\[ImaginaryI]"}], " ", "\[Alpha]", " ", 
    SuperscriptBox[
     StyleBox["Q",
      FontColor->RGBColor[0.8, 0, 0]], "-"]}], "-", 
   RowBox[{"2", " ", "u", " ", "\[Alpha]", " ", 
    SuperscriptBox[
     StyleBox["Q",
      FontColor->RGBColor[0.8, 0, 0]], "-"]}], "+", 
   RowBox[{"\[ImaginaryI]", " ", 
    OverscriptBox["\[Alpha]", "_"], " ", 
    SuperscriptBox[
     StyleBox["Q",
      FontColor->RGBColor[0.8, 0, 0]], "-"]}], "+", 
   RowBox[{"2", " ", "u", " ", 
    OverscriptBox["\[Alpha]", "_"], " ", 
    SuperscriptBox[
     StyleBox["Q",
      FontColor->RGBColor[0.8, 0, 0]], "-"]}], "-", 
   RowBox[{"\[ImaginaryI]", " ", "\[Alpha]", " ", 
    SuperscriptBox[
     StyleBox["Q",
      FontColor->RGBColor[0.8, 0, 0]], "+"]}], "+", 
   RowBox[{"2", " ", "u", " ", "\[Alpha]", " ", 
    SuperscriptBox[
     StyleBox["Q",
      FontColor->RGBColor[0.8, 0, 0]], "+"]}], "+", 
   RowBox[{"\[ImaginaryI]", " ", 
    OverscriptBox["\[Alpha]", "_"], " ", 
    SuperscriptBox[
     StyleBox["Q",
      FontColor->RGBColor[0.8, 0, 0]], "+"]}], "-", 
   RowBox[{"2", " ", "u", " ", 
    OverscriptBox["\[Alpha]", "_"], " ", 
    SuperscriptBox[
     StyleBox["Q",
      FontColor->RGBColor[0.8, 0, 0]], "+"]}], "+", 
   RowBox[{"2", " ", "\[Alpha]", " ", 
    SuperscriptBox[
     StyleBox["Q",
      FontColor->RGBColor[0.8, 0, 0]], "-"], " ", 
    SubscriptBox["v", "0"]}], "+", 
   RowBox[{"2", " ", 
    OverscriptBox["\[Alpha]", "_"], " ", 
    SuperscriptBox[
     StyleBox["Q",
      FontColor->RGBColor[0.8, 0, 0]], "-"], " ", 
    SubscriptBox["v", "0"]}], "-", 
   RowBox[{"2", " ", "\[Alpha]", " ", 
    SuperscriptBox[
     StyleBox["Q",
      FontColor->RGBColor[0.8, 0, 0]], "+"], " ", 
    SubscriptBox["v", "0"]}], "-", 
   RowBox[{"2", " ", 
    OverscriptBox["\[Alpha]", "_"], " ", 
    SuperscriptBox[
     StyleBox["Q",
      FontColor->RGBColor[0.8, 0, 0]], "+"], " ", 
    SubscriptBox["v", "0"]}]}], 
  RowBox[{"2", " ", 
   SuperscriptBox[
    StyleBox["Q",
     FontColor->RGBColor[0.8, 0, 0]], "-"], " ", 
   SuperscriptBox[
    StyleBox["Q",
     FontColor->RGBColor[0.8, 0, 0]], "+"]}]]], "Output",
 CellChangeTimes->{{3.563319249422529*^9, 3.563319292980885*^9}, {
   3.5633193315319557`*^9, 3.563319392920034*^9}, {3.5633194891676292`*^9, 
   3.563319502549656*^9}, 3.563319632443665*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  FractionBox[
   RowBox[{"comb1", " ", 
    RowBox[{"(", 
     RowBox[{
      FractionBox[
       RowBox[{
        RowBox[{
         RowBox[{"-", "\[ImaginaryI]"}], " ", "\[Alpha]"}], "+", 
        RowBox[{"2", " ", "u", " ", "\[Alpha]"}], "+", 
        RowBox[{"\[ImaginaryI]", " ", 
         OverscriptBox["\[Alpha]", "_"]}], "-", 
        RowBox[{"2", " ", "u", " ", 
         OverscriptBox["\[Alpha]", "_"]}], "-", 
        RowBox[{"2", " ", "\[Alpha]", " ", 
         SubscriptBox["v", "0"]}], "-", 
        RowBox[{"2", " ", 
         OverscriptBox["\[Alpha]", "_"], " ", 
         SubscriptBox["v", "0"]}]}], 
       RowBox[{"2", " ", 
        SuperscriptBox[
         RowBox[{"(", 
          SuperscriptBox[
           StyleBox["Q",
            FontColor->RGBColor[0.8, 0, 0]], "-"], ")"}], "2"], " ", 
        SuperscriptBox[
         StyleBox["Q",
          FontColor->RGBColor[0.8, 0, 0]], "+"]}]], "+", 
      FractionBox[
       RowBox[{
        RowBox[{
         RowBox[{"-", "\[ImaginaryI]"}], " ", "\[Alpha]"}], "-", 
        RowBox[{"2", " ", "u", " ", "\[Alpha]"}], "+", 
        RowBox[{"\[ImaginaryI]", " ", 
         OverscriptBox["\[Alpha]", "_"]}], "+", 
        RowBox[{"2", " ", "u", " ", 
         OverscriptBox["\[Alpha]", "_"]}], "+", 
        RowBox[{"2", " ", "\[Alpha]", " ", 
         SubscriptBox["v", "0"]}], "+", 
        RowBox[{"2", " ", 
         OverscriptBox["\[Alpha]", "_"], " ", 
         SubscriptBox["v", "0"]}]}], 
       RowBox[{"2", " ", 
        SuperscriptBox[
         StyleBox["Q",
          FontColor->RGBColor[0.8, 0, 0]], "-"], " ", 
        SuperscriptBox[
         RowBox[{"(", 
          SuperscriptBox[
           StyleBox["Q",
            FontColor->RGBColor[0.8, 0, 0]], "+"], ")"}], "2"]}]]}], ")"}]}], 
   
   FractionBox[
    RowBox[{
     RowBox[{
      RowBox[{"-", "\[ImaginaryI]"}], " ", "\[Alpha]", " ", 
      SuperscriptBox[
       StyleBox["Q",
        FontColor->RGBColor[0.8, 0, 0]], "-"]}], "-", 
     RowBox[{"2", " ", "u", " ", "\[Alpha]", " ", 
      SuperscriptBox[
       StyleBox["Q",
        FontColor->RGBColor[0.8, 0, 0]], "-"]}], "+", 
     RowBox[{"\[ImaginaryI]", " ", 
      OverscriptBox["\[Alpha]", "_"], " ", 
      SuperscriptBox[
       StyleBox["Q",
        FontColor->RGBColor[0.8, 0, 0]], "-"]}], "+", 
     RowBox[{"2", " ", "u", " ", 
      OverscriptBox["\[Alpha]", "_"], " ", 
      SuperscriptBox[
       StyleBox["Q",
        FontColor->RGBColor[0.8, 0, 0]], "-"]}], "-", 
     RowBox[{"\[ImaginaryI]", " ", "\[Alpha]", " ", 
      SuperscriptBox[
       StyleBox["Q",
        FontColor->RGBColor[0.8, 0, 0]], "+"]}], "+", 
     RowBox[{"2", " ", "u", " ", "\[Alpha]", " ", 
      SuperscriptBox[
       StyleBox["Q",
        FontColor->RGBColor[0.8, 0, 0]], "+"]}], "+", 
     RowBox[{"\[ImaginaryI]", " ", 
      OverscriptBox["\[Alpha]", "_"], " ", 
      SuperscriptBox[
       StyleBox["Q",
        FontColor->RGBColor[0.8, 0, 0]], "+"]}], "-", 
     RowBox[{"2", " ", "u", " ", 
      OverscriptBox["\[Alpha]", "_"], " ", 
      SuperscriptBox[
       StyleBox["Q",
        FontColor->RGBColor[0.8, 0, 0]], "+"]}], "+", 
     RowBox[{"2", " ", "\[Alpha]", " ", 
      SuperscriptBox[
       StyleBox["Q",
        FontColor->RGBColor[0.8, 0, 0]], "-"], " ", 
      SubscriptBox["v", "0"]}], "+", 
     RowBox[{"2", " ", 
      OverscriptBox["\[Alpha]", "_"], " ", 
      SuperscriptBox[
       StyleBox["Q",
        FontColor->RGBColor[0.8, 0, 0]], "-"], " ", 
      SubscriptBox["v", "0"]}], "-", 
     RowBox[{"2", " ", "\[Alpha]", " ", 
      SuperscriptBox[
       StyleBox["Q",
        FontColor->RGBColor[0.8, 0, 0]], "+"], " ", 
      SubscriptBox["v", "0"]}], "-", 
     RowBox[{"2", " ", 
      OverscriptBox["\[Alpha]", "_"], " ", 
      SuperscriptBox[
       StyleBox["Q",
        FontColor->RGBColor[0.8, 0, 0]], "+"], " ", 
      SubscriptBox["v", "0"]}]}], 
    RowBox[{"2", " ", 
     SuperscriptBox[
      StyleBox["Q",
       FontColor->RGBColor[0.8, 0, 0]], "-"], " ", 
     SuperscriptBox[
      StyleBox["Q",
       FontColor->RGBColor[0.8, 0, 0]], "+"]}]]], "//", "Simplify"}]], "Input",\

 CellChangeTimes->{{3.563319470537771*^9, 3.5633195087862453`*^9}, 
   3.5633196389636707`*^9}],

Cell[BoxData[
 FractionBox["comb1", 
  RowBox[{
   SuperscriptBox[
    StyleBox["Q",
     FontColor->RGBColor[0.8, 0, 0]], "-"], " ", 
   SuperscriptBox[
    StyleBox["Q",
     FontColor->RGBColor[0.8, 0, 0]], "+"]}]]], "Output",
 CellChangeTimes->{{3.563319479859646*^9, 3.5633195094302273`*^9}, 
   3.563319639574211*^9}]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  FractionBox[
   SuperscriptBox["Q", "+"], 
   SuperscriptBox["Q", "-"]], 
  FractionBox[
   SubscriptBox["T", 
    RowBox[{"1", ",", "0"}]], 
   SubsuperscriptBox["T", 
    RowBox[{"0", ",", "0"}], "+"]]}]], "Input",
 CellChangeTimes->{{3.563319104431169*^9, 3.5633191159655123`*^9}}],

Cell[CellGroupData[{

Cell[BoxData["rltnice"], "Input",
 CellChangeTimes->{{3.563318979936534*^9, 3.563318982095337*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   FractionBox["comb2", 
    RowBox[{
     SuperscriptBox[
      StyleBox["Q",
       FontColor->RGBColor[0.8, 0, 0]], "-"], " ", 
     SuperscriptBox[
      RowBox[{"(", 
       SuperscriptBox[
        StyleBox["Q",
         FontColor->RGBColor[0.8, 0, 0]], "+"], ")"}], "2"]}]], ",", 
   RowBox[{
    FractionBox[
     SuperscriptBox["comb2", "2"], 
     RowBox[{"2", " ", 
      SuperscriptBox[
       RowBox[{"(", 
        SuperscriptBox[
         StyleBox["Q",
          FontColor->RGBColor[0.8, 0, 0]], "-"], ")"}], "2"], " ", 
      SuperscriptBox[
       RowBox[{"(", 
        SuperscriptBox[
         StyleBox["Q",
          FontColor->RGBColor[0.8, 0, 0]], "+"], ")"}], "4"]}]], "+", 
    FractionBox[
     RowBox[{"comb1", " ", "comb2"}], 
     RowBox[{
      SuperscriptBox[
       RowBox[{"(", 
        SuperscriptBox[
         StyleBox["Q",
          FontColor->RGBColor[0.8, 0, 0]], "-"], ")"}], "2"], " ", 
      SuperscriptBox[
       RowBox[{"(", 
        SuperscriptBox[
         StyleBox["Q",
          FontColor->RGBColor[0.8, 0, 0]], "+"], ")"}], "3"]}]], "+", 
    FractionBox[
     RowBox[{"2", " ", "comb2", " ", 
      RowBox[{"(", 
       RowBox[{"\[Alpha]", "+", 
        OverscriptBox["\[Alpha]", "_"]}], ")"}], " ", 
      SubscriptBox["v", "0"]}], 
     RowBox[{
      SuperscriptBox[
       StyleBox["Q",
        FontColor->RGBColor[0.8, 0, 0]], "-"], " ", 
      SuperscriptBox[
       RowBox[{"(", 
        SuperscriptBox[
         StyleBox["Q",
          FontColor->RGBColor[0.8, 0, 0]], "+"], ")"}], "3"]}]], "+", 
    FractionBox[
     RowBox[{"comb2", " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"\[ImaginaryI]", " ", "\[Alpha]"}], "-", 
        RowBox[{"2", " ", "u", " ", "\[Alpha]"}], "-", 
        RowBox[{"\[ImaginaryI]", " ", 
         OverscriptBox["\[Alpha]", "_"]}], "+", 
        RowBox[{"2", " ", "u", " ", 
         OverscriptBox["\[Alpha]", "_"]}], "+", 
        RowBox[{"2", " ", "\[Alpha]", " ", 
         SubscriptBox["v", "0"]}], "+", 
        RowBox[{"2", " ", 
         OverscriptBox["\[Alpha]", "_"], " ", 
         SubscriptBox["v", "0"]}]}], ")"}]}], 
     RowBox[{"2", " ", 
      SuperscriptBox[
       RowBox[{"(", 
        SuperscriptBox[
         StyleBox["Q",
          FontColor->RGBColor[0.8, 0, 0]], "-"], ")"}], "2"], " ", 
      SuperscriptBox[
       RowBox[{"(", 
        SuperscriptBox[
         StyleBox["Q",
          FontColor->RGBColor[0.8, 0, 0]], "+"], ")"}], "2"]}]], "+", 
    FractionBox[
     RowBox[{
      SubsuperscriptBox[
       StyleBox["q",
        FontColor->RGBColor[0, 0, 0.8]], 
       RowBox[{"3", ",", "4"}], "+"], " ", 
      SubsuperscriptBox[
       OverscriptBox[
        StyleBox["q",
         FontColor->RGBColor[0, 0, 0.8]], 
        StyleBox["_",
         FontColor->RGBColor[0, 0, 0.8]]], 
       RowBox[{"3", ",", "4"}], "-"]}], 
     RowBox[{
      SuperscriptBox[
       StyleBox["Q",
        FontColor->RGBColor[0.8, 0, 0]], "-"], " ", 
      SuperscriptBox[
       StyleBox["Q",
        FontColor->RGBColor[0.8, 0, 0]], "+"]}]], "-", 
    FractionBox[
     RowBox[{
      SubsuperscriptBox[
       StyleBox["q",
        FontColor->RGBColor[0, 0, 0.8]], 
       RowBox[{"3", ",", "4"}], "+"], " ", 
      SubsuperscriptBox[
       OverscriptBox[
        StyleBox["q",
         FontColor->RGBColor[0, 0, 0.8]], 
        StyleBox["_",
         FontColor->RGBColor[0, 0, 0.8]]], 
       RowBox[{"3", ",", "4"}], "+"]}], 
     SuperscriptBox[
      RowBox[{"(", 
       SuperscriptBox[
        StyleBox["Q",
         FontColor->RGBColor[0.8, 0, 0]], "+"], ")"}], "2"]]}]}], 
  "}"}]], "Output",
 CellChangeTimes->{3.563318982782814*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"{", 
   RowBox[{"tmpT10", ",", "tmpT00p"}], "}"}], "=", 
  RowBox[{
   RowBox[{"Series", "[", 
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{
          RowBox[{
           RowBox[{
            RowBox[{
             RowBox[{
              SubscriptBox["T", 
               RowBox[{"1", ",", "0"}]], "/.", "subTQ"}], "/.", "subpqb"}], "/.",
             "substandardq"}], "/.", "subtoanalyticitystrips"}], "/.", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{
               RowBox[{"-", 
                SubsuperscriptBox[
                 StyleBox["q",
                  FontColor->RGBColor[0, 0, 0.8]], 
                 RowBox[{"2", ",", "4"}], "+"]}], " ", 
               SubsuperscriptBox[
                OverscriptBox[
                 StyleBox["q",
                  FontColor->RGBColor[0, 0, 0.8]], 
                 StyleBox["_",
                  FontColor->RGBColor[0, 0, 0.8]]], 
                RowBox[{"1", ",", "3"}], "-"]}], "-", 
              RowBox[{"2", " ", 
               SubsuperscriptBox[
                StyleBox["q",
                 FontColor->RGBColor[0, 0, 0.8]], 
                RowBox[{"1", ",", "4"}], "+"], " ", 
               SubsuperscriptBox[
                OverscriptBox[
                 StyleBox["q",
                  FontColor->RGBColor[0, 0, 0.8]], 
                 StyleBox["_",
                  FontColor->RGBColor[0, 0, 0.8]]], 
                RowBox[{"1", ",", "4"}], "-"]}], "-", 
              RowBox[{
               SubsuperscriptBox[
                StyleBox["q",
                 FontColor->RGBColor[0, 0, 0.8]], 
                RowBox[{"1", ",", "3"}], "+"], " ", 
               SubsuperscriptBox[
                OverscriptBox[
                 StyleBox["q",
                  FontColor->RGBColor[0, 0, 0.8]], 
                 StyleBox["_",
                  FontColor->RGBColor[0, 0, 0.8]]], 
                RowBox[{"2", ",", "4"}], "-"]}]}], ")"}], "\[Rule]", 
            RowBox[{"-", "comb1"}]}], ")"}]}], ",", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"Collect", "[", 
           RowBox[{
            RowBox[{
             RowBox[{
              RowBox[{
               RowBox[{
                SubsuperscriptBox["T", 
                 RowBox[{"0", ",", "0"}], "+"], "/.", "subTQ"}], "/.", 
               "subpqb"}], "/.", "substandardq"}], "/.", 
             "subtoanalyticitystrips"}], ",", 
            RowBox[{"{", 
             RowBox[{
              OverscriptBox["U", "_"], ",", 
              RowBox[{
               RowBox[{"q$b", "[", 
                RowBox[{"1", ",", "2"}], "]"}], "[", "_", "]"}], ",", 
              RowBox[{
               RowBox[{"q$b", "[", 
                RowBox[{"1", ",", "2"}], "]"}], "[", "_", "]"}]}], "}"}]}], 
           "]"}], "/.", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{
                RowBox[{"-", 
                 SubsuperscriptBox[
                  StyleBox["q",
                   FontColor->RGBColor[0, 0, 0.8]], 
                  RowBox[{"2", ",", "4"}], "+"]}], " ", 
                SubsuperscriptBox[
                 OverscriptBox[
                  StyleBox["q",
                   FontColor->RGBColor[0, 0, 0.8]], 
                  StyleBox["_",
                   FontColor->RGBColor[0, 0, 0.8]]], 
                 RowBox[{"1", ",", "3"}], "-"]}], "-", 
               RowBox[{"2", " ", 
                SubsuperscriptBox[
                 StyleBox["q",
                  FontColor->RGBColor[0, 0, 0.8]], 
                 RowBox[{"1", ",", "4"}], "+"], " ", 
                SubsuperscriptBox[
                 OverscriptBox[
                  StyleBox["q",
                   FontColor->RGBColor[0, 0, 0.8]], 
                  StyleBox["_",
                   FontColor->RGBColor[0, 0, 0.8]]], 
                 RowBox[{"1", ",", "4"}], "-"]}], "-", 
               RowBox[{
                SubsuperscriptBox[
                 StyleBox["q",
                  FontColor->RGBColor[0, 0, 0.8]], 
                 RowBox[{"1", ",", "3"}], "+"], " ", 
                SubsuperscriptBox[
                 OverscriptBox[
                  StyleBox["q",
                   FontColor->RGBColor[0, 0, 0.8]], 
                  StyleBox["_",
                   FontColor->RGBColor[0, 0, 0.8]]], 
                 RowBox[{"2", ",", "4"}], "-"]}]}], ")"}], "\[Rule]", 
             RowBox[{"-", "comb1"}]}], ",", 
            RowBox[{
             RowBox[{
              SuperscriptBox[
               OverscriptBox[
                StyleBox["U",
                 FontColor->RGBColor[0, 0.6, 0]], 
                StyleBox["_",
                 FontColor->RGBColor[0, 0.6, 0]]], "2"], " ", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"-", 
                 SubsuperscriptBox[
                  StyleBox["q",
                   FontColor->RGBColor[0, 0, 0.8]], 
                  RowBox[{"2", ",", "4"}], "+"]}], "-", 
                RowBox[{"2", " ", 
                 SubsuperscriptBox[
                  StyleBox["q",
                   FontColor->RGBColor[0, 0, 0.8]], 
                  RowBox[{"1", ",", "4"}], "+"], " ", 
                 SubscriptBox[
                  OverscriptBox[
                   StyleBox["q",
                    FontColor->RGBColor[0, 0, 0.8]], 
                   StyleBox["_",
                    FontColor->RGBColor[0, 0, 0.8]]], "2"]}], "-", 
                RowBox[{
                 SubsuperscriptBox[
                  StyleBox["q",
                   FontColor->RGBColor[0, 0, 0.8]], 
                  RowBox[{"1", ",", "3"}], "+"], " ", 
                 SubsuperscriptBox[
                  OverscriptBox[
                   StyleBox["q",
                    FontColor->RGBColor[0, 0, 0.8]], 
                   StyleBox["_",
                    FontColor->RGBColor[0, 0, 0.8]]], "2", "2"]}]}], ")"}]}], 
             "\[Rule]", 
             RowBox[{"-", "comb2"}]}]}], "}"}]}]}], "}"}], "/.", 
       "substandardq"}], "/.", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"xxx", ":", 
         RowBox[{"(", 
          RowBox[{
           OverscriptBox["\[Alpha]", "_"], "|", "\[Alpha]", "|", 
           RowBox[{
            RowBox[{
             RowBox[{"(", 
              RowBox[{"q$", "|", "q$b"}], ")"}], "[", 
             RowBox[{"3", ",", "4"}], "]"}], "[", "_", "]"}], "|", "comb1", 
           "|", "comb2"}], ")"}]}], "\[Rule]", 
        RowBox[{
         SuperscriptBox["g", "8"], "xxx"}]}], "}"}]}], ",", 
     RowBox[{"{", 
      RowBox[{"g", ",", "0", ",", "16"}], "}"}]}], "]"}], "//", 
   "Normal"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"Series", "[", 
    RowBox[{
     RowBox[{"Log", "[", 
      RowBox[{
       FractionBox["tmpT10", "tmpT00p"], 
       RowBox[{"(", 
        FractionBox[
         SuperscriptBox["Q", "+"], 
         SuperscriptBox["Q", "-"]], ")"}]}], "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"g", ",", "0", ",", "16"}], "}"}]}], "]"}], "//", "Normal"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"tmptry", "=", 
   RowBox[{
    RowBox[{"List", "@@", "%"}], "/.", 
    RowBox[{"g", "\[Rule]", "1"}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"Select", "[", 
     RowBox[{"#", ",", 
      RowBox[{
       RowBox[{"Not", "[", 
        RowBox[{"FreeQ", "[", 
         RowBox[{"#", ",", 
          RowBox[{"comb1", "|", "comb2", "|", 
           RowBox[{
            RowBox[{
             RowBox[{"(", 
              RowBox[{"q$", "|", "q$b"}], ")"}], "[", 
             RowBox[{"3", ",", "4"}], "]"}], "[", "_", "]"}]}]}], "]"}], 
        "]"}], "&"}]}], "]"}], "&"}], "/@", 
   RowBox[{"(", 
    RowBox[{"%", "//", "Expand"}], ")"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"rltnice", "=", 
  RowBox[{"ExpaCol", "[", 
   RowBox[{"%", ",", 
    RowBox[{
     RowBox[{"Q", "[", "1", "]"}], "|", 
     RowBox[{"Q", "[", 
      RowBox[{"-", "1"}], "]"}], "|", "comb1", "|", "comb2"}], ",", 
    "Factor"}], "]"}]}]}], "Input",
 CellChangeTimes->{{3.5633167537366457`*^9, 3.563317320319713*^9}, {
   3.5633196743437757`*^9, 3.56331971894768*^9}, 3.563319858292245*^9, {
   3.56331993453937*^9, 3.563319953225263*^9}, {3.563320027364551*^9, 
   3.563320055706966*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{
    RowBox[{
     SuperscriptBox[
      StyleBox["Q",
       FontColor->RGBColor[0.8, 0, 0]], "-"], " ", 
     SuperscriptBox[
      StyleBox["Q",
       FontColor->RGBColor[0.8, 0, 0]], "+"]}], "+", 
    RowBox[{
     SuperscriptBox["g", "8"], " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"-", "comb1"}], "-", 
       RowBox[{
        FractionBox["1", "2"], " ", "\[ImaginaryI]", " ", "\[Alpha]", " ", 
        SuperscriptBox[
         StyleBox["Q",
          FontColor->RGBColor[0.8, 0, 0]], "-"]}], "-", 
       RowBox[{"u", " ", "\[Alpha]", " ", 
        SuperscriptBox[
         StyleBox["Q",
          FontColor->RGBColor[0.8, 0, 0]], "-"]}], "+", 
       RowBox[{
        FractionBox["1", "2"], " ", "\[ImaginaryI]", " ", 
        OverscriptBox["\[Alpha]", "_"], " ", 
        SuperscriptBox[
         StyleBox["Q",
          FontColor->RGBColor[0.8, 0, 0]], "-"]}], "+", 
       RowBox[{"u", " ", 
        OverscriptBox["\[Alpha]", "_"], " ", 
        SuperscriptBox[
         StyleBox["Q",
          FontColor->RGBColor[0.8, 0, 0]], "-"]}], "-", 
       RowBox[{
        FractionBox["1", "2"], " ", "\[ImaginaryI]", " ", "\[Alpha]", " ", 
        SuperscriptBox[
         StyleBox["Q",
          FontColor->RGBColor[0.8, 0, 0]], "+"]}], "+", 
       RowBox[{"u", " ", "\[Alpha]", " ", 
        SuperscriptBox[
         StyleBox["Q",
          FontColor->RGBColor[0.8, 0, 0]], "+"]}], "+", 
       RowBox[{
        FractionBox["1", "2"], " ", "\[ImaginaryI]", " ", 
        OverscriptBox["\[Alpha]", "_"], " ", 
        SuperscriptBox[
         StyleBox["Q",
          FontColor->RGBColor[0.8, 0, 0]], "+"]}], "-", 
       RowBox[{"u", " ", 
        OverscriptBox["\[Alpha]", "_"], " ", 
        SuperscriptBox[
         StyleBox["Q",
          FontColor->RGBColor[0.8, 0, 0]], "+"]}], "-", 
       RowBox[{"\[Alpha]", " ", 
        SuperscriptBox[
         StyleBox["Q",
          FontColor->RGBColor[0.8, 0, 0]], "-"], " ", 
        SubscriptBox["v", "0"]}], "-", 
       RowBox[{
        OverscriptBox["\[Alpha]", "_"], " ", 
        SuperscriptBox[
         StyleBox["Q",
          FontColor->RGBColor[0.8, 0, 0]], "-"], " ", 
        SubscriptBox["v", "0"]}], "-", 
       RowBox[{"\[Alpha]", " ", 
        SuperscriptBox[
         StyleBox["Q",
          FontColor->RGBColor[0.8, 0, 0]], "+"], " ", 
        SubscriptBox["v", "0"]}], "-", 
       RowBox[{
        OverscriptBox["\[Alpha]", "_"], " ", 
        SuperscriptBox[
         StyleBox["Q",
          FontColor->RGBColor[0.8, 0, 0]], "+"], " ", 
        SubscriptBox["v", "0"]}]}], ")"}]}], "+", 
    RowBox[{
     SuperscriptBox["g", "16"], " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"-", 
        FractionBox[
         SuperscriptBox["\[Alpha]", "2"], "4"]}], "-", 
       RowBox[{
        SuperscriptBox["u", "2"], " ", 
        SuperscriptBox["\[Alpha]", "2"]}], "+", 
       FractionBox[
        RowBox[{"\[Alpha]", " ", 
         OverscriptBox["\[Alpha]", "_"]}], "2"], "+", 
       RowBox[{"2", " ", 
        SuperscriptBox["u", "2"], " ", "\[Alpha]", " ", 
        OverscriptBox["\[Alpha]", "_"]}], "-", 
       FractionBox[
        SuperscriptBox[
         OverscriptBox["\[Alpha]", "_"], "2"], "4"], "-", 
       RowBox[{
        SuperscriptBox["u", "2"], " ", 
        SuperscriptBox[
         OverscriptBox["\[Alpha]", "_"], "2"]}], "-", 
       RowBox[{"\[Alpha]", " ", 
        OverscriptBox["\[Alpha]", "_"], " ", 
        SuperscriptBox[
         StyleBox["Q",
          FontColor->RGBColor[0.8, 0, 0]], "-"]}], "-", 
       RowBox[{"\[Alpha]", " ", 
        OverscriptBox["\[Alpha]", "_"], " ", 
        SuperscriptBox[
         StyleBox["Q",
          FontColor->RGBColor[0.8, 0, 0]], "+"]}], "+", 
       RowBox[{"\[ImaginaryI]", " ", 
        SuperscriptBox["\[Alpha]", "2"], " ", 
        SubscriptBox["v", "0"]}], "-", 
       RowBox[{"\[ImaginaryI]", " ", 
        SuperscriptBox[
         OverscriptBox["\[Alpha]", "_"], "2"], " ", 
        SubscriptBox["v", "0"]}], "+", 
       RowBox[{
        SuperscriptBox["\[Alpha]", "2"], " ", 
        SubsuperscriptBox["v", "0", "2"]}], "+", 
       RowBox[{"2", " ", "\[Alpha]", " ", 
        OverscriptBox["\[Alpha]", "_"], " ", 
        SubsuperscriptBox["v", "0", "2"]}], "+", 
       RowBox[{
        SuperscriptBox[
         OverscriptBox["\[Alpha]", "_"], "2"], " ", 
        SubsuperscriptBox["v", "0", "2"]}], "+", 
       RowBox[{
        SubsuperscriptBox[
         StyleBox["q",
          FontColor->RGBColor[0, 0, 0.8]], 
         RowBox[{"3", ",", "4"}], "+"], " ", 
        SubsuperscriptBox[
         OverscriptBox[
          StyleBox["q",
           FontColor->RGBColor[0, 0, 0.8]], 
          StyleBox["_",
           FontColor->RGBColor[0, 0, 0.8]]], 
         RowBox[{"3", ",", "4"}], "-"]}]}], ")"}]}]}], ",", 
   RowBox[{
    SuperscriptBox[
     RowBox[{"(", 
      SuperscriptBox[
       StyleBox["Q",
        FontColor->RGBColor[0.8, 0, 0]], "+"], ")"}], "2"], "+", 
    RowBox[{
     SuperscriptBox["g", "8"], " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"-", 
        FractionBox["comb2", 
         SuperscriptBox[
          StyleBox["Q",
           FontColor->RGBColor[0.8, 0, 0]], "-"]]}], "-", 
       FractionBox[
        RowBox[{"comb1", " ", 
         SuperscriptBox[
          StyleBox["Q",
           FontColor->RGBColor[0.8, 0, 0]], "+"]}], 
        SuperscriptBox[
         StyleBox["Q",
          FontColor->RGBColor[0.8, 0, 0]], "-"]], "-", 
       RowBox[{"2", " ", "\[Alpha]", " ", 
        SuperscriptBox[
         StyleBox["Q",
          FontColor->RGBColor[0.8, 0, 0]], "+"], " ", 
        SubscriptBox["v", "0"]}], "-", 
       RowBox[{"2", " ", 
        OverscriptBox["\[Alpha]", "_"], " ", 
        SuperscriptBox[
         StyleBox["Q",
          FontColor->RGBColor[0.8, 0, 0]], "+"], " ", 
        SubscriptBox["v", "0"]}]}], ")"}]}], "+", 
    RowBox[{
     SuperscriptBox["g", "16"], " ", 
     RowBox[{"(", 
      RowBox[{
       FractionBox[
        SuperscriptBox["\[Alpha]", "2"], "4"], "-", 
       RowBox[{"\[ImaginaryI]", " ", "u", " ", 
        SuperscriptBox["\[Alpha]", "2"]}], "-", 
       RowBox[{
        SuperscriptBox["u", "2"], " ", 
        SuperscriptBox["\[Alpha]", "2"]}], "-", 
       FractionBox[
        RowBox[{"\[Alpha]", " ", 
         OverscriptBox["\[Alpha]", "_"]}], "2"], "+", 
       RowBox[{"2", " ", "\[ImaginaryI]", " ", "u", " ", "\[Alpha]", " ", 
        OverscriptBox["\[Alpha]", "_"]}], "+", 
       RowBox[{"2", " ", 
        SuperscriptBox["u", "2"], " ", "\[Alpha]", " ", 
        OverscriptBox["\[Alpha]", "_"]}], "+", 
       FractionBox[
        SuperscriptBox[
         OverscriptBox["\[Alpha]", "_"], "2"], "4"], "-", 
       RowBox[{"\[ImaginaryI]", " ", "u", " ", 
        SuperscriptBox[
         OverscriptBox["\[Alpha]", "_"], "2"]}], "-", 
       RowBox[{
        SuperscriptBox["u", "2"], " ", 
        SuperscriptBox[
         OverscriptBox["\[Alpha]", "_"], "2"]}], "-", 
       RowBox[{"2", " ", "\[Alpha]", " ", 
        OverscriptBox["\[Alpha]", "_"], " ", 
        SuperscriptBox[
         StyleBox["Q",
          FontColor->RGBColor[0.8, 0, 0]], "+"]}], "+", 
       RowBox[{
        SuperscriptBox["\[Alpha]", "2"], " ", 
        SubsuperscriptBox["v", "0", "2"]}], "+", 
       RowBox[{"2", " ", "\[Alpha]", " ", 
        OverscriptBox["\[Alpha]", "_"], " ", 
        SubsuperscriptBox["v", "0", "2"]}], "+", 
       RowBox[{
        SuperscriptBox[
         OverscriptBox["\[Alpha]", "_"], "2"], " ", 
        SubsuperscriptBox["v", "0", "2"]}], "+", 
       FractionBox[
        RowBox[{
         RowBox[{
          RowBox[{"-", "\[ImaginaryI]"}], " ", "comb2", " ", "\[Alpha]"}], 
         "+", 
         RowBox[{"2", " ", "comb2", " ", "u", " ", "\[Alpha]"}], "+", 
         RowBox[{"\[ImaginaryI]", " ", "comb2", " ", 
          OverscriptBox["\[Alpha]", "_"]}], "-", 
         RowBox[{"2", " ", "comb2", " ", "u", " ", 
          OverscriptBox["\[Alpha]", "_"]}], "-", 
         RowBox[{"2", " ", "comb2", " ", "\[Alpha]", " ", 
          SubscriptBox["v", "0"]}], "-", 
         RowBox[{"2", " ", "comb2", " ", 
          OverscriptBox["\[Alpha]", "_"], " ", 
          SubscriptBox["v", "0"]}]}], 
        RowBox[{"2", " ", 
         SuperscriptBox[
          RowBox[{"(", 
           SuperscriptBox[
            StyleBox["Q",
             FontColor->RGBColor[0.8, 0, 0]], "-"], ")"}], "2"]}]], "+", 
       RowBox[{
        FractionBox["1", 
         RowBox[{"2", " ", 
          SuperscriptBox[
           RowBox[{"(", 
            SuperscriptBox[
             StyleBox["Q",
              FontColor->RGBColor[0.8, 0, 0]], "-"], ")"}], "2"]}]], 
        RowBox[{"(", 
         RowBox[{
          RowBox[{
           RowBox[{"-", "\[ImaginaryI]"}], " ", "comb1", " ", "\[Alpha]", " ", 
           SuperscriptBox[
            StyleBox["Q",
             FontColor->RGBColor[0.8, 0, 0]], "-"]}], "-", 
          RowBox[{"2", " ", "comb1", " ", "u", " ", "\[Alpha]", " ", 
           SuperscriptBox[
            StyleBox["Q",
             FontColor->RGBColor[0.8, 0, 0]], "-"]}], "+", 
          RowBox[{"\[ImaginaryI]", " ", "comb1", " ", 
           OverscriptBox["\[Alpha]", "_"], " ", 
           SuperscriptBox[
            StyleBox["Q",
             FontColor->RGBColor[0.8, 0, 0]], "-"]}], "+", 
          RowBox[{"2", " ", "comb1", " ", "u", " ", 
           OverscriptBox["\[Alpha]", "_"], " ", 
           SuperscriptBox[
            StyleBox["Q",
             FontColor->RGBColor[0.8, 0, 0]], "-"]}], "-", 
          RowBox[{"\[ImaginaryI]", " ", "comb1", " ", "\[Alpha]", " ", 
           SuperscriptBox[
            StyleBox["Q",
             FontColor->RGBColor[0.8, 0, 0]], "+"]}], "+", 
          RowBox[{"2", " ", "comb1", " ", "u", " ", "\[Alpha]", " ", 
           SuperscriptBox[
            StyleBox["Q",
             FontColor->RGBColor[0.8, 0, 0]], "+"]}], "+", 
          RowBox[{"\[ImaginaryI]", " ", "comb1", " ", 
           OverscriptBox["\[Alpha]", "_"], " ", 
           SuperscriptBox[
            StyleBox["Q",
             FontColor->RGBColor[0.8, 0, 0]], "+"]}], "-", 
          RowBox[{"2", " ", "comb1", " ", "u", " ", 
           OverscriptBox["\[Alpha]", "_"], " ", 
           SuperscriptBox[
            StyleBox["Q",
             FontColor->RGBColor[0.8, 0, 0]], "+"]}], "+", 
          RowBox[{"2", " ", "comb1", " ", "\[Alpha]", " ", 
           SuperscriptBox[
            StyleBox["Q",
             FontColor->RGBColor[0.8, 0, 0]], "-"], " ", 
           SubscriptBox["v", "0"]}], "+", 
          RowBox[{"2", " ", "comb1", " ", 
           OverscriptBox["\[Alpha]", "_"], " ", 
           SuperscriptBox[
            StyleBox["Q",
             FontColor->RGBColor[0.8, 0, 0]], "-"], " ", 
           SubscriptBox["v", "0"]}], "-", 
          RowBox[{"2", " ", "comb1", " ", "\[Alpha]", " ", 
           SuperscriptBox[
            StyleBox["Q",
             FontColor->RGBColor[0.8, 0, 0]], "+"], " ", 
           SubscriptBox["v", "0"]}], "-", 
          RowBox[{"2", " ", "comb1", " ", 
           OverscriptBox["\[Alpha]", "_"], " ", 
           SuperscriptBox[
            StyleBox["Q",
             FontColor->RGBColor[0.8, 0, 0]], "+"], " ", 
           SubscriptBox["v", "0"]}]}], ")"}]}], "+", 
       RowBox[{
        SubsuperscriptBox[
         StyleBox["q",
          FontColor->RGBColor[0, 0, 0.8]], 
         RowBox[{"3", ",", "4"}], "+"], " ", 
        SubsuperscriptBox[
         OverscriptBox[
          StyleBox["q",
           FontColor->RGBColor[0, 0, 0.8]], 
          StyleBox["_",
           FontColor->RGBColor[0, 0, 0.8]]], 
         RowBox[{"3", ",", "4"}], "+"]}]}], ")"}]}]}]}], "}"}]], "Output",
 CellChangeTimes->{{3.563319832237336*^9, 3.563319858812169*^9}, {
  3.5633199385306*^9, 3.56331995486769*^9}, {3.563320033337227*^9, 
  3.563320056344095*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   FractionBox["comb2", 
    RowBox[{
     SuperscriptBox[
      StyleBox["Q",
       FontColor->RGBColor[0.8, 0, 0]], "-"], " ", 
     SuperscriptBox[
      RowBox[{"(", 
       SuperscriptBox[
        StyleBox["Q",
         FontColor->RGBColor[0.8, 0, 0]], "+"], ")"}], "2"]}]], ",", 
   RowBox[{
    FractionBox[
     SuperscriptBox["comb2", "2"], 
     RowBox[{"2", " ", 
      SuperscriptBox[
       RowBox[{"(", 
        SuperscriptBox[
         StyleBox["Q",
          FontColor->RGBColor[0.8, 0, 0]], "-"], ")"}], "2"], " ", 
      SuperscriptBox[
       RowBox[{"(", 
        SuperscriptBox[
         StyleBox["Q",
          FontColor->RGBColor[0.8, 0, 0]], "+"], ")"}], "4"]}]], "+", 
    FractionBox[
     RowBox[{"comb1", " ", "comb2"}], 
     RowBox[{
      SuperscriptBox[
       RowBox[{"(", 
        SuperscriptBox[
         StyleBox["Q",
          FontColor->RGBColor[0.8, 0, 0]], "-"], ")"}], "2"], " ", 
      SuperscriptBox[
       RowBox[{"(", 
        SuperscriptBox[
         StyleBox["Q",
          FontColor->RGBColor[0.8, 0, 0]], "+"], ")"}], "3"]}]], "+", 
    FractionBox[
     RowBox[{"2", " ", "comb2", " ", 
      RowBox[{"(", 
       RowBox[{"\[Alpha]", "+", 
        OverscriptBox["\[Alpha]", "_"]}], ")"}], " ", 
      SubscriptBox["v", "0"]}], 
     RowBox[{
      SuperscriptBox[
       StyleBox["Q",
        FontColor->RGBColor[0.8, 0, 0]], "-"], " ", 
      SuperscriptBox[
       RowBox[{"(", 
        SuperscriptBox[
         StyleBox["Q",
          FontColor->RGBColor[0.8, 0, 0]], "+"], ")"}], "3"]}]], "+", 
    FractionBox[
     RowBox[{"comb2", " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"\[ImaginaryI]", " ", "\[Alpha]"}], "-", 
        RowBox[{"2", " ", "u", " ", "\[Alpha]"}], "-", 
        RowBox[{"\[ImaginaryI]", " ", 
         OverscriptBox["\[Alpha]", "_"]}], "+", 
        RowBox[{"2", " ", "u", " ", 
         OverscriptBox["\[Alpha]", "_"]}], "+", 
        RowBox[{"2", " ", "\[Alpha]", " ", 
         SubscriptBox["v", "0"]}], "+", 
        RowBox[{"2", " ", 
         OverscriptBox["\[Alpha]", "_"], " ", 
         SubscriptBox["v", "0"]}]}], ")"}]}], 
     RowBox[{"2", " ", 
      SuperscriptBox[
       RowBox[{"(", 
        SuperscriptBox[
         StyleBox["Q",
          FontColor->RGBColor[0.8, 0, 0]], "-"], ")"}], "2"], " ", 
      SuperscriptBox[
       RowBox[{"(", 
        SuperscriptBox[
         StyleBox["Q",
          FontColor->RGBColor[0.8, 0, 0]], "+"], ")"}], "2"]}]], "+", 
    FractionBox[
     RowBox[{
      SubsuperscriptBox[
       StyleBox["q",
        FontColor->RGBColor[0, 0, 0.8]], 
       RowBox[{"3", ",", "4"}], "+"], " ", 
      SubsuperscriptBox[
       OverscriptBox[
        StyleBox["q",
         FontColor->RGBColor[0, 0, 0.8]], 
        StyleBox["_",
         FontColor->RGBColor[0, 0, 0.8]]], 
       RowBox[{"3", ",", "4"}], "-"]}], 
     RowBox[{
      SuperscriptBox[
       StyleBox["Q",
        FontColor->RGBColor[0.8, 0, 0]], "-"], " ", 
      SuperscriptBox[
       StyleBox["Q",
        FontColor->RGBColor[0.8, 0, 0]], "+"]}]], "-", 
    FractionBox[
     RowBox[{
      SubsuperscriptBox[
       StyleBox["q",
        FontColor->RGBColor[0, 0, 0.8]], 
       RowBox[{"3", ",", "4"}], "+"], " ", 
      SubsuperscriptBox[
       OverscriptBox[
        StyleBox["q",
         FontColor->RGBColor[0, 0, 0.8]], 
        StyleBox["_",
         FontColor->RGBColor[0, 0, 0.8]]], 
       RowBox[{"3", ",", "4"}], "+"]}], 
     SuperscriptBox[
      RowBox[{"(", 
       SuperscriptBox[
        StyleBox["Q",
         FontColor->RGBColor[0.8, 0, 0]], "+"], ")"}], "2"]]}]}], 
  "}"}]], "Output",
 CellChangeTimes->{{3.563319832237336*^9, 3.563319858812169*^9}, {
  3.5633199385306*^9, 3.56331995486769*^9}, {3.563320033337227*^9, 
  3.5633200564145603`*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{
     SubsuperscriptBox["T", 
      RowBox[{"0", ",", "0"}], "+"], "/.", "subTQ"}], "/.", "subpqb"}], "/.", 
   "substandardq"}], "/.", "subtoanalyticitystrips"}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     RowBox[{
      RowBox[{"-", "\[Alpha]"}], " ", 
      OverscriptBox["\[Alpha]", "_"]}], "+", 
     SuperscriptBox[
      StyleBox["Q",
       FontColor->RGBColor[0.8, 0, 0]], "+"], "+", 
     RowBox[{
      OverscriptBox["\[Alpha]", "_"], " ", 
      RowBox[{"(", 
       RowBox[{
        FractionBox["\[ImaginaryI]", "2"], "+", "u", "-", 
        SubscriptBox["v", "0"]}], ")"}]}], "-", 
     RowBox[{"\[Alpha]", " ", 
      RowBox[{"(", 
       RowBox[{
        FractionBox["\[ImaginaryI]", "2"], "+", "u", "+", 
        SubscriptBox["v", "0"]}], ")"}]}]}], ")"}], " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{
      RowBox[{"-", "\[Alpha]"}], " ", 
      OverscriptBox["\[Alpha]", "_"]}], "+", 
     SuperscriptBox[
      StyleBox["Q",
       FontColor->RGBColor[0.8, 0, 0]], "+"], "+", 
     RowBox[{"\[Alpha]", " ", 
      RowBox[{"(", 
       RowBox[{
        FractionBox["\[ImaginaryI]", "2"], "+", "u", "-", 
        SubscriptBox["v", "0"]}], ")"}]}], "-", 
     RowBox[{
      OverscriptBox["\[Alpha]", "_"], " ", 
      RowBox[{"(", 
       RowBox[{
        FractionBox["\[ImaginaryI]", "2"], "+", "u", "+", 
        SubscriptBox["v", "0"]}], ")"}]}]}], ")"}]}], "-", 
  FractionBox[
   RowBox[{
    SubsuperscriptBox[
     StyleBox["q",
      FontColor->RGBColor[0, 0, 0.8]], 
     RowBox[{"2", ",", "4"}], "+"], " ", 
    RowBox[{"(", 
     RowBox[{
      SuperscriptBox[
       OverscriptBox[
        StyleBox["U",
         FontColor->RGBColor[0, 0.6, 0]], 
        StyleBox["_",
         FontColor->RGBColor[0, 0.6, 0]]], "2"], "+", 
      RowBox[{
       SubsuperscriptBox[
        OverscriptBox[
         StyleBox["q",
          FontColor->RGBColor[0, 0, 0.8]], 
         StyleBox["_",
          FontColor->RGBColor[0, 0, 0.8]]], 
        RowBox[{"1", ",", "2"}], "+"], " ", 
       SubsuperscriptBox[
        OverscriptBox[
         StyleBox["q",
          FontColor->RGBColor[0, 0, 0.8]], 
         StyleBox["_",
          FontColor->RGBColor[0, 0, 0.8]]], 
        RowBox[{"1", ",", "3"}], "-"]}]}], ")"}]}], 
   SubsuperscriptBox[
    OverscriptBox[
     StyleBox["q",
      FontColor->RGBColor[0, 0, 0.8]], 
     StyleBox["_",
      FontColor->RGBColor[0, 0, 0.8]]], 
    RowBox[{"1", ",", "2"}], "-"]], "-", 
  FractionBox[
   RowBox[{"2", " ", 
    SubsuperscriptBox[
     StyleBox["q",
      FontColor->RGBColor[0, 0, 0.8]], 
     RowBox[{"1", ",", "4"}], "+"], " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       SuperscriptBox[
        OverscriptBox[
         StyleBox["U",
          FontColor->RGBColor[0, 0.6, 0]], 
         StyleBox["_",
          FontColor->RGBColor[0, 0.6, 0]]], "2"], " ", 
       SubscriptBox[
        OverscriptBox[
         StyleBox["q",
          FontColor->RGBColor[0, 0, 0.8]], 
         StyleBox["_",
          FontColor->RGBColor[0, 0, 0.8]]], "2"]}], "+", 
      RowBox[{
       SubsuperscriptBox[
        OverscriptBox[
         StyleBox["q",
          FontColor->RGBColor[0, 0, 0.8]], 
         StyleBox["_",
          FontColor->RGBColor[0, 0, 0.8]]], 
        RowBox[{"1", ",", "2"}], "+"], " ", 
       SubsuperscriptBox[
        OverscriptBox[
         StyleBox["q",
          FontColor->RGBColor[0, 0, 0.8]], 
         StyleBox["_",
          FontColor->RGBColor[0, 0, 0.8]]], 
        RowBox[{"1", ",", "4"}], "-"]}]}], ")"}]}], 
   SubsuperscriptBox[
    OverscriptBox[
     StyleBox["q",
      FontColor->RGBColor[0, 0, 0.8]], 
     StyleBox["_",
      FontColor->RGBColor[0, 0, 0.8]]], 
    RowBox[{"1", ",", "2"}], "-"]], "-", 
  FractionBox[
   RowBox[{
    SubsuperscriptBox[
     StyleBox["q",
      FontColor->RGBColor[0, 0, 0.8]], 
     RowBox[{"1", ",", "3"}], "+"], " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       SuperscriptBox[
        OverscriptBox[
         StyleBox["U",
          FontColor->RGBColor[0, 0.6, 0]], 
         StyleBox["_",
          FontColor->RGBColor[0, 0.6, 0]]], "2"], " ", 
       SubsuperscriptBox[
        OverscriptBox[
         StyleBox["q",
          FontColor->RGBColor[0, 0, 0.8]], 
         StyleBox["_",
          FontColor->RGBColor[0, 0, 0.8]]], "2", "2"]}], "+", 
      RowBox[{
       SubsuperscriptBox[
        OverscriptBox[
         StyleBox["q",
          FontColor->RGBColor[0, 0, 0.8]], 
         StyleBox["_",
          FontColor->RGBColor[0, 0, 0.8]]], 
        RowBox[{"1", ",", "2"}], "+"], " ", 
       SubsuperscriptBox[
        OverscriptBox[
         StyleBox["q",
          FontColor->RGBColor[0, 0, 0.8]], 
         StyleBox["_",
          FontColor->RGBColor[0, 0, 0.8]]], 
        RowBox[{"2", ",", "4"}], "-"]}]}], ")"}]}], 
   SubsuperscriptBox[
    OverscriptBox[
     StyleBox["q",
      FontColor->RGBColor[0, 0, 0.8]], 
     StyleBox["_",
      FontColor->RGBColor[0, 0, 0.8]]], 
    RowBox[{"1", ",", "2"}], "-"]], "+", 
  RowBox[{
   SubsuperscriptBox[
    StyleBox["q",
     FontColor->RGBColor[0, 0, 0.8]], 
    RowBox[{"3", ",", "4"}], "+"], " ", 
   SubsuperscriptBox[
    OverscriptBox[
     StyleBox["q",
      FontColor->RGBColor[0, 0, 0.8]], 
     StyleBox["_",
      FontColor->RGBColor[0, 0, 0.8]]], 
    RowBox[{"3", ",", "4"}], "+"]}]}]], "Output",
 CellChangeTimes->{3.5633197195219803`*^9, 3.563319796159533*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Coefficient", "[", 
  RowBox[{
   RowBox[{"tmptry", "[", 
    RowBox[{"[", "2", "]"}], "]"}], ",", "comb1"}], "]"}]], "Input",
 CellChangeTimes->{{3.5633196974526463`*^9, 3.563319709276596*^9}}],

Cell[BoxData[
 FractionBox["comb2", 
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     SuperscriptBox[
      StyleBox["Q",
       FontColor->RGBColor[0.8, 0, 0]], "-"], ")"}], "2"], " ", 
   SuperscriptBox[
    RowBox[{"(", 
     SuperscriptBox[
      StyleBox["Q",
       FontColor->RGBColor[0.8, 0, 0]], "+"], ")"}], "3"]}]]], "Output",
 CellChangeTimes->{{3.5633169157174664`*^9, 3.5633169578139677`*^9}, {
   3.563317056092793*^9, 3.563317073152194*^9}, {3.56331712446172*^9, 
   3.5633171523802223`*^9}, {3.563317189634364*^9, 3.563317320896697*^9}, 
   3.563317520106679*^9, {3.563319675115552*^9, 3.563319709964962*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"Collect", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"(", 
     RowBox[{"rltnice", "/.", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"comb1", "\[Rule]", 
         RowBox[{"-", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{
             RowBox[{"-", 
              SubsuperscriptBox[
               StyleBox["q",
                FontColor->RGBColor[0, 0, 0.8]], 
               RowBox[{"2", ",", "4"}], "+"]}], " ", 
             SubsuperscriptBox[
              OverscriptBox[
               StyleBox["q",
                FontColor->RGBColor[0, 0, 0.8]], 
               StyleBox["_",
                FontColor->RGBColor[0, 0, 0.8]]], 
              RowBox[{"1", ",", "3"}], "-"]}], "-", 
            RowBox[{"2", " ", 
             SubsuperscriptBox[
              StyleBox["q",
               FontColor->RGBColor[0, 0, 0.8]], 
              RowBox[{"1", ",", "4"}], "+"], " ", 
             SubsuperscriptBox[
              OverscriptBox[
               StyleBox["q",
                FontColor->RGBColor[0, 0, 0.8]], 
               StyleBox["_",
                FontColor->RGBColor[0, 0, 0.8]]], 
              RowBox[{"1", ",", "4"}], "-"]}], "-", 
            RowBox[{
             SubsuperscriptBox[
              StyleBox["q",
               FontColor->RGBColor[0, 0, 0.8]], 
              RowBox[{"1", ",", "3"}], "+"], " ", 
             SubsuperscriptBox[
              OverscriptBox[
               StyleBox["q",
                FontColor->RGBColor[0, 0, 0.8]], 
               StyleBox["_",
                FontColor->RGBColor[0, 0, 0.8]]], 
              RowBox[{"2", ",", "4"}], "-"]}]}], ")"}]}]}], ",", 
        RowBox[{"comb2", "\[Rule]", 
         RowBox[{
          RowBox[{"-", 
           SuperscriptBox[
            OverscriptBox[
             StyleBox["U",
              FontColor->RGBColor[0, 0.6, 0]], 
             StyleBox["_",
              FontColor->RGBColor[0, 0.6, 0]]], "2"]}], " ", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"-", 
             SubsuperscriptBox[
              StyleBox["q",
               FontColor->RGBColor[0, 0, 0.8]], 
              RowBox[{"2", ",", "4"}], "+"]}], "-", 
            RowBox[{"2", " ", 
             SubsuperscriptBox[
              StyleBox["q",
               FontColor->RGBColor[0, 0, 0.8]], 
              RowBox[{"1", ",", "4"}], "+"], " ", 
             SubscriptBox[
              OverscriptBox[
               StyleBox["q",
                FontColor->RGBColor[0, 0, 0.8]], 
               StyleBox["_",
                FontColor->RGBColor[0, 0, 0.8]]], "2"]}], "-", 
            RowBox[{
             SubsuperscriptBox[
              StyleBox["q",
               FontColor->RGBColor[0, 0, 0.8]], 
              RowBox[{"1", ",", "3"}], "+"], " ", 
             SubsuperscriptBox[
              OverscriptBox[
               StyleBox["q",
                FontColor->RGBColor[0, 0, 0.8]], 
               StyleBox["_",
                FontColor->RGBColor[0, 0, 0.8]]], "2", "2"]}]}], ")"}]}]}]}], 
       "}"}]}], ")"}], "-", "tmp2"}], ",", 
   OverscriptBox["U", "_"], ",", "Simplify"}], "]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"%", "/.", "subq34"}], "//.", "subtoanalyticitystrips"}], "/.", 
    "substandardq"}], "/.", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{
      OverscriptBox["\[Alpha]", "_"], "\[Rule]", "0"}], ",", 
     RowBox[{"\[Alpha]", "\[Rule]", "0"}]}], "}"}]}], "//", 
  "Simplify"}]}], "Input",
 CellChangeTimes->{{3.5633173220342627`*^9, 3.563317373037751*^9}, {
  3.5633174770728197`*^9, 3.563317477899617*^9}, {3.5633175245827837`*^9, 
  3.563317551996399*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"0", ",", 
   RowBox[{
    RowBox[{"-", 
     FractionBox[
      RowBox[{
       SuperscriptBox[
        OverscriptBox[
         StyleBox["U",
          FontColor->RGBColor[0, 0.6, 0]], 
         StyleBox["_",
          FontColor->RGBColor[0, 0.6, 0]]], "2"], " ", 
       RowBox[{"(", 
        RowBox[{
         SuperscriptBox[
          RowBox[{"(", 
           SubsuperscriptBox[
            StyleBox["q",
             FontColor->RGBColor[0, 0, 0.8]], 
            RowBox[{"1", ",", "4"}], "+"], ")"}], "2"], "-", 
         RowBox[{
          SubsuperscriptBox[
           StyleBox["q",
            FontColor->RGBColor[0, 0, 0.8]], 
           RowBox[{"1", ",", "3"}], "+"], " ", 
          SubsuperscriptBox[
           StyleBox["q",
            FontColor->RGBColor[0, 0, 0.8]], 
           RowBox[{"2", ",", "4"}], "+"]}]}], ")"}], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          SubsuperscriptBox[
           OverscriptBox[
            StyleBox["q",
             FontColor->RGBColor[0, 0, 0.8]], 
            StyleBox["_",
             FontColor->RGBColor[0, 0, 0.8]]], "2", "2"], " ", 
          SubsuperscriptBox[
           OverscriptBox[
            StyleBox["q",
             FontColor->RGBColor[0, 0, 0.8]], 
            StyleBox["_",
             FontColor->RGBColor[0, 0, 0.8]]], 
           RowBox[{"1", ",", "3"}], "-"]}], "-", 
         RowBox[{"2", " ", 
          SubscriptBox[
           OverscriptBox[
            StyleBox["q",
             FontColor->RGBColor[0, 0, 0.8]], 
            StyleBox["_",
             FontColor->RGBColor[0, 0, 0.8]]], "2"], " ", 
          SubsuperscriptBox[
           OverscriptBox[
            StyleBox["q",
             FontColor->RGBColor[0, 0, 0.8]], 
            StyleBox["_",
             FontColor->RGBColor[0, 0, 0.8]]], 
           RowBox[{"1", ",", "4"}], "-"]}], "+", 
         SubsuperscriptBox[
          OverscriptBox[
           StyleBox["q",
            FontColor->RGBColor[0, 0, 0.8]], 
           StyleBox["_",
            FontColor->RGBColor[0, 0, 0.8]]], 
          RowBox[{"2", ",", "4"}], "-"]}], ")"}]}], 
      RowBox[{
       SuperscriptBox[
        RowBox[{"(", 
         SuperscriptBox[
          StyleBox["Q",
           FontColor->RGBColor[0.8, 0, 0]], "-"], ")"}], "2"], " ", 
       SuperscriptBox[
        RowBox[{"(", 
         SuperscriptBox[
          StyleBox["Q",
           FontColor->RGBColor[0.8, 0, 0]], "+"], ")"}], "3"]}]]}], "+", 
    FractionBox[
     RowBox[{
      SubsuperscriptBox[
       StyleBox["q",
        FontColor->RGBColor[0, 0, 0.8]], 
       RowBox[{"3", ",", "4"}], "+"], " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         SuperscriptBox[
          StyleBox["Q",
           FontColor->RGBColor[0.8, 0, 0]], "+"], " ", 
         SubsuperscriptBox[
          OverscriptBox[
           StyleBox["q",
            FontColor->RGBColor[0, 0, 0.8]], 
           StyleBox["_",
            FontColor->RGBColor[0, 0, 0.8]]], 
          RowBox[{"3", ",", "4"}], "-"]}], "-", 
        RowBox[{
         SuperscriptBox[
          StyleBox["Q",
           FontColor->RGBColor[0.8, 0, 0]], "-"], " ", 
         SubsuperscriptBox[
          OverscriptBox[
           StyleBox["q",
            FontColor->RGBColor[0, 0, 0.8]], 
           StyleBox["_",
            FontColor->RGBColor[0, 0, 0.8]]], 
          RowBox[{"3", ",", "4"}], "+"]}]}], ")"}]}], 
     RowBox[{
      SuperscriptBox[
       StyleBox["Q",
        FontColor->RGBColor[0.8, 0, 0]], "-"], " ", 
      SuperscriptBox[
       RowBox[{"(", 
        SuperscriptBox[
         StyleBox["Q",
          FontColor->RGBColor[0.8, 0, 0]], "+"], ")"}], "2"]}]]}]}], 
  "}"}]], "Output",
 CellChangeTimes->{{3.5633173416732607`*^9, 3.5633173735408278`*^9}, {
  3.56331752547403*^9, 3.563317552850601*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"0", ",", "0"}], "}"}]], "Output",
 CellChangeTimes->{{3.5633173416732607`*^9, 3.5633173735408278`*^9}, {
  3.56331752547403*^9, 3.563317552877758*^9}}]
}, Open  ]],

Cell[BoxData[{
 RowBox[{
  RowBox[{"iii", "=", "1"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"mtmp1", "=", 
   RowBox[{"List", "@@", 
    RowBox[{"ExpaCol", "[", 
     RowBox[{
      RowBox[{"Series", "[", 
       RowBox[{
        RowBox[{
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            SubsuperscriptBox[
             StyleBox["q",
              FontColor->RGBColor[0, 0, 0.8]], 
             RowBox[{"2", ",", "4"}], "+"], "+", 
            RowBox[{
             SubscriptBox[
              OverscriptBox[
               StyleBox["q",
                FontColor->RGBColor[0, 0, 0.8]], 
               StyleBox["_",
                FontColor->RGBColor[0, 0, 0.8]]], "2"], " ", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"2", " ", 
                SubsuperscriptBox[
                 StyleBox["q",
                  FontColor->RGBColor[0, 0, 0.8]], 
                 RowBox[{"1", ",", "4"}], "+"]}], "+", 
               RowBox[{
                SubsuperscriptBox[
                 StyleBox["q",
                  FontColor->RGBColor[0, 0, 0.8]], 
                 RowBox[{"1", ",", "3"}], "+"], " ", 
                SubscriptBox[
                 OverscriptBox[
                  StyleBox["q",
                   FontColor->RGBColor[0, 0, 0.8]], 
                  StyleBox["_",
                   FontColor->RGBColor[0, 0, 0.8]]], "2"]}]}], ")"}]}]}], 
           ")"}], "/.", 
          RowBox[{"nsweak", "[", 
           RowBox[{"5", ",", 
            RowBox[{
             RowBox[{"Collect", "[", 
              RowBox[{
               RowBox[{
                RowBox[{"ReleaseHold", "[", "#", "]"}], "//.", 
                "subtopowerbasis"}], ",", "canlist"}], "]"}], "&"}]}], 
           "]"}]}], "/.", 
         RowBox[{
          RowBox[{"Conjugate", "[", "v0", "]"}], "\[Rule]", "v0"}]}], ",", 
        RowBox[{"{", 
         RowBox[{"g", ",", "0", ",", "12"}], "}"}]}], "]"}], ",", 
      "\[Eta]patt", ",", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{"NotebookDelete", "[", "tmpprn", "]"}], ";", 
         RowBox[{"tmpprn", "=", 
          RowBox[{"PrintTemporary", "[", 
           RowBox[{"iii", "++"}], "]"}]}], ";", 
         RowBox[{"Hold", "[", "#", "]"}]}], ")"}], "&"}]}], "]"}]}]}], 
  ";"}]}], "Input",
 CellChangeTimes->{{3.563307914858403*^9, 3.563307961217184*^9}, {
  3.563308000336336*^9, 3.563308065648044*^9}, {3.563308136293681*^9, 
  3.5633081470612907`*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"iii", "=", "1"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"mtmp12", "=", 
   RowBox[{"Collect", "[", 
    RowBox[{
     RowBox[{"mtmp1", "//", "ReleaseHold"}], ",", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"g", ",", "\[Eta]list"}], "}"}], "//", "Flatten"}], ",", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"NotebookDelete", "[", "tmpprn", "]"}], ";", 
        RowBox[{"tmpprn", "=", 
         RowBox[{"PrintTemporary", "[", 
          RowBox[{"iii", "++"}], "]"}]}], ";", 
        RowBox[{
         RowBox[{
          RowBox[{"#", "//.", "subtousu"}], "//", "funapartusu"}], "//", 
         "funreduceusu"}]}], ")"}], "&"}]}], "]"}]}], ";"}]}], "Input",
 CellChangeTimes->{{3.5633082096213923`*^9, 3.563308282856731*^9}, 
   3.563308336124784*^9, 3.563308440448083*^9}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"iii", "=", "1"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"mtmp2", "=", 
   RowBox[{"List", "@@", 
    RowBox[{"ExpaCol", "[", 
     RowBox[{
      RowBox[{"Series", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"Collect", "[", 
          RowBox[{
           RowBox[{
            RowBox[{
             RowBox[{
              SuperscriptBox[
               OverscriptBox["U", "_"], "2"], "/.", 
              RowBox[{"nsweak", "[", "5", "]"}]}], "/.", 
             RowBox[{
              RowBox[{"Conjugate", "[", "v0", "]"}], "\[Rule]", "v0"}]}], "//.",
             "subtopowerbasis"}], ",", "canlist"}], "]"}], 
         RowBox[{"Total", "[", "mtmp12", "]"}]}], ",", 
        RowBox[{"{", 
         RowBox[{"g", ",", "0", ",", "16"}], "}"}]}], "]"}], ",", 
      "\[Eta]patt", ",", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{"NotebookDelete", "[", "tmpprn", "]"}], ";", 
         RowBox[{"tmpprn", "=", 
          RowBox[{"PrintTemporary", "[", 
           RowBox[{"iii", "++"}], "]"}]}], ";", 
         RowBox[{"Hold", "[", "#", "]"}]}], ")"}], "&"}]}], "]"}]}]}], 
  ";"}]}], "Input",
 CellChangeTimes->{{3.563307789083159*^9, 3.563307874429761*^9}, {
   3.563308443245121*^9, 3.5633084710539713`*^9}, {3.563308510990068*^9, 
   3.563308536132718*^9}, 3.563308604043255*^9, {3.5633086414535313`*^9, 
   3.563308646020454*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"iii", "=", "1"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"mtmp22", "=", 
   RowBox[{"Collect", "[", 
    RowBox[{
     RowBox[{"mtmp2", "//", "ReleaseHold"}], ",", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"g", ",", "\[Eta]list"}], "}"}], "//", "Flatten"}], ",", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"NotebookDelete", "[", "tmpprn", "]"}], ";", 
        RowBox[{"tmpprn", "=", 
         RowBox[{"PrintTemporary", "[", 
          RowBox[{"iii", "++"}], "]"}]}], ";", 
        RowBox[{
         RowBox[{
          RowBox[{"#", "//.", "subtousu"}], "//", "funapartusu"}], "//", 
         "funreduceusu"}]}], ")"}], "&"}]}], "]"}]}], ";"}]}], "Input",
 CellChangeTimes->{{3.5633086156428022`*^9, 3.5633086178714437`*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"iii", "=", "1"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"mtmp3", "=", 
   RowBox[{"List", "@@", 
    RowBox[{"ExpaCol", "[", 
     RowBox[{
      RowBox[{"Series", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"Collect", "[", 
          RowBox[{
           RowBox[{
            RowBox[{
             RowBox[{
              RowBox[{
               RowBox[{"Series", "[", 
                RowBox[{
                 RowBox[{
                  RowBox[{
                   FractionBox["1", 
                    RowBox[{
                    SuperscriptBox[
                    StyleBox["Q",
                    FontColor->RGBColor[0.8, 0, 0]], "-"], " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    SuperscriptBox[
                    StyleBox["Q",
                    FontColor->RGBColor[0.8, 0, 0]], "+"], ")"}], "2"]}]], "/.", 
                   RowBox[{"leadweak", "[", "5", "]"}]}], "/.", "subIm"}], 
                 ",", 
                 RowBox[{"{", 
                  RowBox[{"g", ",", "0", ",", "8"}], "}"}]}], "]"}], "//.", 
               "subtousu"}], "/.", "subQ0"}], "//", "funapartusu"}], "//", 
            "funreduceusu"}], ",", "canlist"}], "]"}], 
         RowBox[{"Total", "[", "mtmp22", "]"}]}], ",", 
        RowBox[{"{", 
         RowBox[{"g", ",", "0", ",", "16"}], "}"}]}], "]"}], ",", 
      "\[Eta]patt", ",", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{"NotebookDelete", "[", "tmpprn", "]"}], ";", 
         RowBox[{"tmpprn", "=", 
          RowBox[{"PrintTemporary", "[", 
           RowBox[{"iii", "++"}], "]"}]}], ";", 
         RowBox[{"Hold", "[", "#", "]"}]}], ")"}], "&"}]}], "]"}]}]}], 
  ";"}]}], "Input",
 CellChangeTimes->{{3.563308787509088*^9, 3.56330895997904*^9}, {
   3.5633090110897503`*^9, 3.563309015175264*^9}, 3.5633090684946003`*^9}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"iii", "=", "1"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"mtmp32", "=", 
   RowBox[{"Collect", "[", 
    RowBox[{
     RowBox[{"mtmp3", "//", "ReleaseHold"}], ",", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"g", ",", "\[Eta]list"}], "}"}], "//", "Flatten"}], ",", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"NotebookDelete", "[", "tmpprn", "]"}], ";", 
        RowBox[{"tmpprn", "=", 
         RowBox[{"PrintTemporary", "[", 
          RowBox[{"iii", "++"}], "]"}]}], ";", 
        RowBox[{
         RowBox[{
          RowBox[{"#", "//.", "subtousu"}], "//", "funapartusu"}], "//", 
         "funreduceusu"}]}], ")"}], "&"}]}], "]"}]}], ";"}]}], "Input",
 CellChangeTimes->{{3.5633092104330673`*^9, 3.563309212727324*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"mtmp4", "=", 
   RowBox[{"Collect", "[", 
    RowBox[{
     RowBox[{"Total", "[", "mtmp32", "]"}], ",", "canlist"}], "]"}]}], 
  ";"}]], "Input",
 CellChangeTimes->{{3.563309368428698*^9, 3.563309391397152*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Collect", "[", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"(", 
      RowBox[{"mtmp4", "/.", 
       RowBox[{
        SuperscriptBox["g", 
         RowBox[{"a_", "/;", 
          RowBox[{"a", ">", "14"}]}]], "\[Rule]", "0"}]}], ")"}], "-", 
     RowBox[{"(", 
      RowBox[{"H", "/.", 
       RowBox[{"leadweak", "[", "4", "]"}]}], ")"}]}], "//.", 
    "subtopowerbasis"}], ",", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"g", ",", "\[Eta]list"}], "}"}], "//", "Flatten"}], ",", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{"#", "/.", "subusu"}], "/.", "subQ0"}], "/.", 
        RowBox[{"u", "\[Rule]", 
         RowBox[{"SetPrecision", "[", 
          RowBox[{
           RowBox[{"11", "/", "13"}], ",", "20"}], "]"}]}]}], "/.", 
       "subZetas"}], "//", "Chop"}], ")"}], "&"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.563309431295651*^9, 3.563309458474564*^9}, {
  3.563309495593631*^9, 3.5633097101346188`*^9}}],

Cell[BoxData["0"], "Output",
 CellChangeTimes->{{3.563309435876742*^9, 3.563309459293948*^9}, {
  3.563309571189019*^9, 3.563309721353776*^9}}]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"mtmp41", "=", 
   RowBox[{
    RowBox[{"ExpaCol", "[", 
     RowBox[{
      RowBox[{"Coefficient", "[", 
       RowBox[{"mtmp4", ",", "g", ",", "16"}], "]"}], ",", "\[Eta]patt", ",", 
      "Hold"}], "]"}], "//", "FuntoMHZbasis"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.563309730761427*^9, 3.563309781983416*^9}, {
  3.5633098177987328`*^9, 3.563309819517658*^9}, {3.563309993928871*^9, 
  3.563310078134922*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Hfivecontr1", "=", 
   RowBox[{"Collect", "[", 
    RowBox[{
     RowBox[{"mtmp41", "//", "ReleaseHold"}], ",", "canlist"}], "]"}]}], 
  ";"}]], "Input",
 CellChangeTimes->{{3.563310156143874*^9, 3.563310188781288*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"BoldCompute", "[", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"SeriesCoefficient", "[", 
       RowBox[{
        RowBox[{
         RowBox[{
          RowBox[{"Block", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"$RecursionLimit", "=", "\[Infinity]"}], "}"}], ",", 
            RowBox[{"BoldCompute", "[", 
             RowBox[{
              RowBox[{
               RowBox[{
                RowBox[{
                 RowBox[{
                  RowBox[{
                   RowBox[{
                    RowBox[{"tmp2", "[", 
                    RowBox[{"[", "1", "]"}], "]"}], "/.", 
                    RowBox[{"nsweak", "[", 
                    RowBox[{"5", ",", 
                    RowBox[{
                    RowBox[{"BoldCompute", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    RowBox[{"Collect", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"ReleaseHold", "[", "#", "]"}], "//.", 
                    "subtopowerbasis"}], ",", "canlist"}], "]"}], "/.", 
                    "subusu"}], "/.", "subQ0"}], "/.", 
                    RowBox[{"u", "\[Rule]", 
                    RowBox[{"3", "/", "13"}]}]}], ",", 
                    RowBox[{"3", "/", "13"}]}], "]"}], "&"}]}], "]"}]}], 
                   "\[IndentingNewLine]", "/.", 
                   RowBox[{
                    RowBox[{"Conjugate", "[", "v0", "]"}], "\[Rule]", 
                    "v0"}]}], "//.", "subtopowerbasis"}], "/.", "subusu"}], "/.",
                 "subQ0"}], "/.", 
               RowBox[{"u", "\[Rule]", 
                RowBox[{"3", "/", "13"}]}]}], ",", 
              RowBox[{"3", "/", "13"}]}], "]"}]}], "\[IndentingNewLine]", 
           "]"}], "/.", 
          RowBox[{"leadweak", "[", "5", "]"}]}], "/.", "subIm"}], ",", 
        RowBox[{"{", 
         RowBox[{"g", ",", "0", ",", "16"}], "}"}]}], "]"}], "/.", "subusu"}],
      "/.", "subQ0"}], "/.", 
    RowBox[{"u", "\[Rule]", 
     RowBox[{"3", "/", "13"}]}]}], ",", 
   RowBox[{"3", "/", "13"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.56331214453198*^9, 3.563312486804373*^9}}],

Cell[BoxData[
 RowBox[{"2.960823977297461115626876479707067314749008862925`17.\
518692770481376*^10", "+", 
  RowBox[{
  "8.24865710487607985558316232798601348757591079147`16.963667532442873*^9", 
   " ", "\[ImaginaryI]"}]}]], "Output",
 CellChangeTimes->{
  3.563312146358231*^9, 3.563312227148755*^9, 3.563312265403605*^9, 
   3.5633122966818247`*^9, 3.5633123583926353`*^9, 3.563312390087289*^9, {
   3.563312430924634*^9, 3.563312449957507*^9}, 3.563312496287881*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"BoldCompute", "[", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"Hfivecontr1", "//.", "subtopowerbasis"}], "/.", "subusu"}], "/.", 
    RowBox[{"u", "\[Rule]", 
     RowBox[{"3", "/", "13"}]}]}], ",", 
   RowBox[{"3", "/", "13"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.563312499272071*^9, 3.563312524071517*^9}}],

Cell[BoxData[
 RowBox[{"2.960823977297461115624912529878552912776300939757`17.\
98756982671423*^10", "+", 
  RowBox[{
  "8.24865710487607985556941234315927797379888985446`17.440328168160008*^9", 
   " ", "\[ImaginaryI]"}]}]], "Output",
 CellChangeTimes->{3.563312550127831*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"tmp2", "[", 
  RowBox[{"[", "2", "]"}], "]"}]], "Input",
 CellChangeTimes->{{3.563310667531657*^9, 3.5633106698314133`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"-", 
   FractionBox[
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{
        RowBox[{"-", "\[ImaginaryI]"}], " ", "\[Alpha]"}], "+", 
       RowBox[{"2", " ", "u", " ", "\[Alpha]"}], "+", 
       RowBox[{"\[ImaginaryI]", " ", 
        OverscriptBox["\[Alpha]", "_"]}], "-", 
       RowBox[{"2", " ", "u", " ", 
        OverscriptBox["\[Alpha]", "_"]}], "-", 
       RowBox[{"2", " ", "\[Alpha]", " ", 
        SubscriptBox["v", "0"]}], "-", 
       RowBox[{"2", " ", 
        OverscriptBox["\[Alpha]", "_"], " ", 
        SubscriptBox["v", "0"]}]}], ")"}], " ", 
     SuperscriptBox[
      OverscriptBox[
       StyleBox["U",
        FontColor->RGBColor[0, 0.6, 0]], 
       StyleBox["_",
        FontColor->RGBColor[0, 0.6, 0]]], "2"], " ", 
     RowBox[{"(", 
      RowBox[{
       SubsuperscriptBox[
        StyleBox["q",
         FontColor->RGBColor[0, 0, 0.8]], 
        RowBox[{"2", ",", "4"}], "+"], "+", 
       RowBox[{"2", " ", 
        SubsuperscriptBox[
         StyleBox["q",
          FontColor->RGBColor[0, 0, 0.8]], 
         RowBox[{"1", ",", "4"}], "+"], " ", 
        SubscriptBox[
         OverscriptBox[
          StyleBox["q",
           FontColor->RGBColor[0, 0, 0.8]], 
          StyleBox["_",
           FontColor->RGBColor[0, 0, 0.8]]], "2"]}], "+", 
       RowBox[{
        SubsuperscriptBox[
         StyleBox["q",
          FontColor->RGBColor[0, 0, 0.8]], 
         RowBox[{"1", ",", "3"}], "+"], " ", 
        SubsuperscriptBox[
         OverscriptBox[
          StyleBox["q",
           FontColor->RGBColor[0, 0, 0.8]], 
          StyleBox["_",
           FontColor->RGBColor[0, 0, 0.8]]], "2", "2"]}]}], ")"}]}], 
    RowBox[{"2", " ", 
     SuperscriptBox[
      RowBox[{"(", 
       SuperscriptBox[
        StyleBox["Q",
         FontColor->RGBColor[0.8, 0, 0]], "-"], ")"}], "2"], " ", 
     SuperscriptBox[
      RowBox[{"(", 
       SuperscriptBox[
        StyleBox["Q",
         FontColor->RGBColor[0.8, 0, 0]], "+"], ")"}], "2"]}]]}], "+", 
  FractionBox[
   RowBox[{
    SuperscriptBox[
     OverscriptBox[
      StyleBox["U",
       FontColor->RGBColor[0, 0.6, 0]], 
      StyleBox["_",
       FontColor->RGBColor[0, 0.6, 0]]], "4"], " ", 
    SuperscriptBox[
     RowBox[{"(", 
      RowBox[{
       SubsuperscriptBox[
        StyleBox["q",
         FontColor->RGBColor[0, 0, 0.8]], 
        RowBox[{"2", ",", "4"}], "+"], "+", 
       RowBox[{"2", " ", 
        SubsuperscriptBox[
         StyleBox["q",
          FontColor->RGBColor[0, 0, 0.8]], 
         RowBox[{"1", ",", "4"}], "+"], " ", 
        SubscriptBox[
         OverscriptBox[
          StyleBox["q",
           FontColor->RGBColor[0, 0, 0.8]], 
          StyleBox["_",
           FontColor->RGBColor[0, 0, 0.8]]], "2"]}], "+", 
       RowBox[{
        SubsuperscriptBox[
         StyleBox["q",
          FontColor->RGBColor[0, 0, 0.8]], 
         RowBox[{"1", ",", "3"}], "+"], " ", 
        SubsuperscriptBox[
         OverscriptBox[
          StyleBox["q",
           FontColor->RGBColor[0, 0, 0.8]], 
          StyleBox["_",
           FontColor->RGBColor[0, 0, 0.8]]], "2", "2"]}]}], ")"}], "2"]}], 
   RowBox[{"2", " ", 
    SuperscriptBox[
     RowBox[{"(", 
      SuperscriptBox[
       StyleBox["Q",
        FontColor->RGBColor[0.8, 0, 0]], "-"], ")"}], "2"], " ", 
    SuperscriptBox[
     RowBox[{"(", 
      SuperscriptBox[
       StyleBox["Q",
        FontColor->RGBColor[0.8, 0, 0]], "+"], ")"}], "4"]}]], "+", 
  RowBox[{
   FractionBox["1", 
    SuperscriptBox[
     RowBox[{"(", 
      SuperscriptBox[
       StyleBox["Q",
        FontColor->RGBColor[0.8, 0, 0]], "+"], ")"}], "3"]], 
   RowBox[{"(", 
    RowBox[{
     FractionBox[
      RowBox[{"2", " ", 
       RowBox[{"(", 
        RowBox[{"\[Alpha]", "+", 
         OverscriptBox["\[Alpha]", "_"]}], ")"}], " ", 
       SubscriptBox["v", "0"], " ", 
       SuperscriptBox[
        OverscriptBox[
         StyleBox["U",
          FontColor->RGBColor[0, 0.6, 0]], 
         StyleBox["_",
          FontColor->RGBColor[0, 0.6, 0]]], "2"], " ", 
       RowBox[{"(", 
        RowBox[{
         SubsuperscriptBox[
          StyleBox["q",
           FontColor->RGBColor[0, 0, 0.8]], 
          RowBox[{"2", ",", "4"}], "+"], "+", 
         RowBox[{"2", " ", 
          SubsuperscriptBox[
           StyleBox["q",
            FontColor->RGBColor[0, 0, 0.8]], 
           RowBox[{"1", ",", "4"}], "+"], " ", 
          SubscriptBox[
           OverscriptBox[
            StyleBox["q",
             FontColor->RGBColor[0, 0, 0.8]], 
            StyleBox["_",
             FontColor->RGBColor[0, 0, 0.8]]], "2"]}], "+", 
         RowBox[{
          SubsuperscriptBox[
           StyleBox["q",
            FontColor->RGBColor[0, 0, 0.8]], 
           RowBox[{"1", ",", "3"}], "+"], " ", 
          SubsuperscriptBox[
           OverscriptBox[
            StyleBox["q",
             FontColor->RGBColor[0, 0, 0.8]], 
            StyleBox["_",
             FontColor->RGBColor[0, 0, 0.8]]], "2", "2"]}]}], ")"}]}], 
      SuperscriptBox[
       StyleBox["Q",
        FontColor->RGBColor[0.8, 0, 0]], "-"]], "+", 
     RowBox[{
      RowBox[{"1", "/", 
       SuperscriptBox[
        RowBox[{"(", 
         SuperscriptBox[
          StyleBox["Q",
           FontColor->RGBColor[0.8, 0, 0]], "-"], ")"}], "2"]}], 
      RowBox[{
       SuperscriptBox[
        OverscriptBox[
         StyleBox["U",
          FontColor->RGBColor[0, 0.6, 0]], 
         StyleBox["_",
          FontColor->RGBColor[0, 0.6, 0]]], "2"], " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          SuperscriptBox[
           RowBox[{"(", 
            SubsuperscriptBox[
             StyleBox["q",
              FontColor->RGBColor[0, 0, 0.8]], 
             RowBox[{"2", ",", "4"}], "+"], ")"}], "2"], " ", 
          SubsuperscriptBox[
           OverscriptBox[
            StyleBox["q",
             FontColor->RGBColor[0, 0, 0.8]], 
            StyleBox["_",
             FontColor->RGBColor[0, 0, 0.8]]], 
           RowBox[{"1", ",", "3"}], "-"]}], "+", 
         RowBox[{"2", " ", 
          SubsuperscriptBox[
           StyleBox["q",
            FontColor->RGBColor[0, 0, 0.8]], 
           RowBox[{"1", ",", "4"}], "+"], " ", 
          SubsuperscriptBox[
           StyleBox["q",
            FontColor->RGBColor[0, 0, 0.8]], 
           RowBox[{"2", ",", "4"}], "+"], " ", 
          SubscriptBox[
           OverscriptBox[
            StyleBox["q",
             FontColor->RGBColor[0, 0, 0.8]], 
            StyleBox["_",
             FontColor->RGBColor[0, 0, 0.8]]], "2"], " ", 
          SubsuperscriptBox[
           OverscriptBox[
            StyleBox["q",
             FontColor->RGBColor[0, 0, 0.8]], 
            StyleBox["_",
             FontColor->RGBColor[0, 0, 0.8]]], 
           RowBox[{"1", ",", "3"}], "-"]}], "+", 
         RowBox[{
          SuperscriptBox[
           RowBox[{"(", 
            SubsuperscriptBox[
             StyleBox["q",
              FontColor->RGBColor[0, 0, 0.8]], 
             RowBox[{"1", ",", "4"}], "+"], ")"}], "2"], " ", 
          SubsuperscriptBox[
           OverscriptBox[
            StyleBox["q",
             FontColor->RGBColor[0, 0, 0.8]], 
            StyleBox["_",
             FontColor->RGBColor[0, 0, 0.8]]], "2", "2"], " ", 
          SubsuperscriptBox[
           OverscriptBox[
            StyleBox["q",
             FontColor->RGBColor[0, 0, 0.8]], 
            StyleBox["_",
             FontColor->RGBColor[0, 0, 0.8]]], 
           RowBox[{"1", ",", "3"}], "-"]}], "+", 
         RowBox[{"2", " ", 
          SubsuperscriptBox[
           StyleBox["q",
            FontColor->RGBColor[0, 0, 0.8]], 
           RowBox[{"1", ",", "4"}], "+"], " ", 
          SubsuperscriptBox[
           StyleBox["q",
            FontColor->RGBColor[0, 0, 0.8]], 
           RowBox[{"2", ",", "4"}], "+"], " ", 
          SubsuperscriptBox[
           OverscriptBox[
            StyleBox["q",
             FontColor->RGBColor[0, 0, 0.8]], 
            StyleBox["_",
             FontColor->RGBColor[0, 0, 0.8]]], 
           RowBox[{"1", ",", "4"}], "-"]}], "+", 
         RowBox[{"2", " ", 
          SuperscriptBox[
           RowBox[{"(", 
            SubsuperscriptBox[
             StyleBox["q",
              FontColor->RGBColor[0, 0, 0.8]], 
             RowBox[{"1", ",", "4"}], "+"], ")"}], "2"], " ", 
          SubscriptBox[
           OverscriptBox[
            StyleBox["q",
             FontColor->RGBColor[0, 0, 0.8]], 
            StyleBox["_",
             FontColor->RGBColor[0, 0, 0.8]]], "2"], " ", 
          SubsuperscriptBox[
           OverscriptBox[
            StyleBox["q",
             FontColor->RGBColor[0, 0, 0.8]], 
            StyleBox["_",
             FontColor->RGBColor[0, 0, 0.8]]], 
           RowBox[{"1", ",", "4"}], "-"]}], "+", 
         RowBox[{"2", " ", 
          SubsuperscriptBox[
           StyleBox["q",
            FontColor->RGBColor[0, 0, 0.8]], 
           RowBox[{"1", ",", "3"}], "+"], " ", 
          SubsuperscriptBox[
           StyleBox["q",
            FontColor->RGBColor[0, 0, 0.8]], 
           RowBox[{"2", ",", "4"}], "+"], " ", 
          SubscriptBox[
           OverscriptBox[
            StyleBox["q",
             FontColor->RGBColor[0, 0, 0.8]], 
            StyleBox["_",
             FontColor->RGBColor[0, 0, 0.8]]], "2"], " ", 
          SubsuperscriptBox[
           OverscriptBox[
            StyleBox["q",
             FontColor->RGBColor[0, 0, 0.8]], 
            StyleBox["_",
             FontColor->RGBColor[0, 0, 0.8]]], 
           RowBox[{"1", ",", "4"}], "-"]}], "+", 
         RowBox[{"2", " ", 
          SubsuperscriptBox[
           StyleBox["q",
            FontColor->RGBColor[0, 0, 0.8]], 
           RowBox[{"1", ",", "3"}], "+"], " ", 
          SubsuperscriptBox[
           StyleBox["q",
            FontColor->RGBColor[0, 0, 0.8]], 
           RowBox[{"1", ",", "4"}], "+"], " ", 
          SubsuperscriptBox[
           OverscriptBox[
            StyleBox["q",
             FontColor->RGBColor[0, 0, 0.8]], 
            StyleBox["_",
             FontColor->RGBColor[0, 0, 0.8]]], "2", "2"], " ", 
          SubsuperscriptBox[
           OverscriptBox[
            StyleBox["q",
             FontColor->RGBColor[0, 0, 0.8]], 
            StyleBox["_",
             FontColor->RGBColor[0, 0, 0.8]]], 
           RowBox[{"1", ",", "4"}], "-"]}], "+", 
         RowBox[{
          SuperscriptBox[
           RowBox[{"(", 
            SubsuperscriptBox[
             StyleBox["q",
              FontColor->RGBColor[0, 0, 0.8]], 
             RowBox[{"1", ",", "4"}], "+"], ")"}], "2"], " ", 
          SubsuperscriptBox[
           OverscriptBox[
            StyleBox["q",
             FontColor->RGBColor[0, 0, 0.8]], 
            StyleBox["_",
             FontColor->RGBColor[0, 0, 0.8]]], 
           RowBox[{"2", ",", "4"}], "-"]}], "+", 
         RowBox[{"2", " ", 
          SubsuperscriptBox[
           StyleBox["q",
            FontColor->RGBColor[0, 0, 0.8]], 
           RowBox[{"1", ",", "3"}], "+"], " ", 
          SubsuperscriptBox[
           StyleBox["q",
            FontColor->RGBColor[0, 0, 0.8]], 
           RowBox[{"1", ",", "4"}], "+"], " ", 
          SubscriptBox[
           OverscriptBox[
            StyleBox["q",
             FontColor->RGBColor[0, 0, 0.8]], 
            StyleBox["_",
             FontColor->RGBColor[0, 0, 0.8]]], "2"], " ", 
          SubsuperscriptBox[
           OverscriptBox[
            StyleBox["q",
             FontColor->RGBColor[0, 0, 0.8]], 
            StyleBox["_",
             FontColor->RGBColor[0, 0, 0.8]]], 
           RowBox[{"2", ",", "4"}], "-"]}], "+", 
         RowBox[{
          SuperscriptBox[
           RowBox[{"(", 
            SubsuperscriptBox[
             StyleBox["q",
              FontColor->RGBColor[0, 0, 0.8]], 
             RowBox[{"1", ",", "3"}], "+"], ")"}], "2"], " ", 
          SubsuperscriptBox[
           OverscriptBox[
            StyleBox["q",
             FontColor->RGBColor[0, 0, 0.8]], 
            StyleBox["_",
             FontColor->RGBColor[0, 0, 0.8]]], "2", "2"], " ", 
          SubsuperscriptBox[
           OverscriptBox[
            StyleBox["q",
             FontColor->RGBColor[0, 0, 0.8]], 
            StyleBox["_",
             FontColor->RGBColor[0, 0, 0.8]]], 
           RowBox[{"2", ",", "4"}], "-"]}]}], ")"}]}]}]}], 
    ")"}]}]}]], "Output",
 CellChangeTimes->{3.563310670335516*^9, 3.5633175698199797`*^9}]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"ntmp1", "=", 
   RowBox[{"List", "@@", 
    RowBox[{"Collect", "[", 
     RowBox[{
      RowBox[{"SeriesCoefficient", "[", 
       RowBox[{
        RowBox[{
         RowBox[{
          RowBox[{"tmp2", "[", 
           RowBox[{"[", "2", "]"}], "]"}], "/.", 
          RowBox[{"nsweak", "[", "1", "]"}]}], "/.", 
         RowBox[{"leadweak", "[", "1", "]"}]}], ",", 
        RowBox[{"{", 
         RowBox[{"g", ",", "0", ",", "16"}], "}"}]}], "]"}], ",", 
      "\[Eta]list"}], "]"}]}]}], ";"}]], "Input",
 CellChangeTimes->{{3.563310930326268*^9, 3.563310951552025*^9}, {
  3.56331109990545*^9, 3.563311132465889*^9}, {3.563311176270803*^9, 
  3.5633111982297688`*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"iii", "=", "1"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"ntmp2", "=", 
   RowBox[{
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{"NotebookDelete", "[", "tmpprn", "]"}], ";", 
       RowBox[{"tmpprn", "=", 
        RowBox[{"PrintTemporary", "[", 
         RowBox[{"iii", "++"}], "]"}]}], ";", 
       RowBox[{
        RowBox[{
         RowBox[{"#", "//.", "subtousu"}], "//", "funapartusu"}], "//", 
        "funreduceusu"}]}], ")"}], "&"}], "/@", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       RowBox[{"ExpaCol", "[", 
        RowBox[{"ntmp1", ",", 
         RowBox[{
          SuperscriptBox["Q0", "+"], "|", 
          SuperscriptBox["Q0", "-"]}]}], "]"}], "//.", "subtousu"}], "/.", 
      "subQ0"}], ")"}]}]}], ";"}]}], "Input",
 CellChangeTimes->{{3.5633109538915367`*^9, 3.5633109544134007`*^9}, {
  3.5633111196069193`*^9, 3.563311164221036*^9}, {3.5633112030378237`*^9, 
  3.563311246973722*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"ntmp3", "=", 
   RowBox[{
    RowBox[{"ExpaCol", "[", 
     RowBox[{"ntmp2", ",", "\[Eta]patt"}], "]"}], "//", "FuntoMHZbasis"}]}], 
  ";"}]], "Input",
 CellChangeTimes->{{3.563311363537899*^9, 3.563311418572016*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"iii", "=", "1"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"ntmp4", "=", 
   RowBox[{"ExpaCol", "[", 
    RowBox[{
     RowBox[{"Total", "[", "ntmp3", "]"}], ",", "\[Eta]patt", ",", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"NotebookDelete", "[", "tmpprn", "]"}], ";", 
        RowBox[{"tmpprn", "=", 
         RowBox[{"PrintTemporary", "[", 
          RowBox[{"iii", "++"}], "]"}]}], ";", 
        RowBox[{
         RowBox[{
          RowBox[{"#", "//.", "subtousu"}], "//", "funapartusu"}], "//", 
         "funreduceusu"}]}], ")"}], "&"}]}], "]"}]}], ";"}]}], "Input",
 CellChangeTimes->{{3.5633114215503187`*^9, 3.563311474066535*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Hfivecontr2", "=", 
   RowBox[{"Collect", "[", 
    RowBox[{"ntmp4", ",", "canlist"}], "]"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.563311506957436*^9, 3.563311526703731*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"BoldCompute", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"Hfivecontr2", "/.", "subusu"}], "/.", 
    RowBox[{"u", "\[Rule]", 
     RowBox[{"3", "/", "13"}]}]}], ",", 
   RowBox[{"3", "/", "13"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.563311548049986*^9, 3.5633115821333323`*^9}}],

Cell[BoxData[
 RowBox[{"623998.14365723540958736537506720708931923138`16.69645937550969", 
  "+", 
  RowBox[{
  "858261.90856324524773051108022533565069474578`16.834895915881667", " ", 
   "\[ImaginaryI]"}]}]], "Output",
 CellChangeTimes->{{3.563311576220057*^9, 3.563311583432713*^9}, 
   3.56331768821447*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"BoldCompute", "[", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"SeriesCoefficient", "[", 
       RowBox[{
        RowBox[{
         RowBox[{
          RowBox[{"tmp2", "[", 
           RowBox[{"[", "2", "]"}], "]"}], "/.", 
          RowBox[{"nsweak", "[", "1", "]"}]}], "/.", 
         RowBox[{"leadweak", "[", "1", "]"}]}], ",", 
        RowBox[{"{", 
         RowBox[{"g", ",", "0", ",", "16"}], "}"}]}], "]"}], "/.", "subusu"}],
      "/.", "subQ0"}], "/.", 
    RowBox[{"u", "\[Rule]", 
     RowBox[{"3", "/", "13"}]}]}], ",", 
   RowBox[{"3", "/", "13"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.563312604455278*^9, 3.5633126192442713`*^9}}],

Cell[BoxData[
 RowBox[{"623998.14365723540997397409890000797482736896`18.052886448138615", 
  "+", 
  RowBox[{
  "858261.90856324524806957472596263342221264296`18.05935414237897", " ", 
   "\[ImaginaryI]"}]}]], "Output",
 CellChangeTimes->{{3.5633126146941233`*^9, 3.563312620747178*^9}, 
   3.563317689090109*^9}]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"Hfive", "=", 
   RowBox[{"Collect", "[", 
    RowBox[{
     RowBox[{"Hfivecontr2", "+", "Hfivecontr1"}], ",", "canlist"}], "]"}]}], 
  ";"}]], "Input",
 CellChangeTimes->{{3.563311516854327*^9, 3.563311540876245*^9}}],

Cell[BoxData[
 RowBox[{"Hfive", ">>", "\"\<Hfivev3\>\""}]], "Input",
 CellChangeTimes->{{3.563321074104993*^9, 3.563321092398518*^9}}]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Energy (5,6,7,8 loops)", "Section",
 CellChangeTimes->{{3.538194756789219*^9, 3.538194772019889*^9}, 
   3.538292860253667*^9, {3.5388267421635056`*^9, 3.5388267452626824`*^9}, {
   3.540095920756257*^9, 3.540095943781209*^9}, 3.546685693009663*^9, {
   3.546685744290317*^9, 3.546685777805489*^9}, {3.546929303915393*^9, 
   3.5469293063369627`*^9}, {3.547188724626713*^9, 3.547188725591942*^9}, 
   3.5537123799033203`*^9, {3.553758844389677*^9, 3.553758901154191*^9}, {
   3.5537604007619877`*^9, 3.553760415773405*^9}, {3.553760459046934*^9, 
   3.553760468884115*^9}, {3.553866933634633*^9, 3.553866933789072*^9}, {
   3.568969217489607*^9, 3.568969219897523*^9}}],

Cell[CellGroupData[{

Cell["\<\
How correction to Bethe Ansatz influences energy\
\>", "Subsection",
 CellChangeTimes->{{3.5538535467983294`*^9, 3.5538535547419043`*^9}, 
   3.553857547931416*^9}],

Cell["Exact Bethe Ansatz reads", "Text",
 CellChangeTimes->{{3.55385357146253*^9, 3.553853577212883*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Log", "[", 
   RowBox[{
    RowBox[{"-", 
     FractionBox[
      SubsuperscriptBox[
       StyleBox["Y",
        FontColor->RGBColor[0, 0, 0.8]], 
       RowBox[{"2", ",", "2"}], "+"], 
      SubsuperscriptBox[
       StyleBox["Y",
        FontColor->RGBColor[0, 0, 0.8]], 
       RowBox[{"2", ",", "2"}], "-"]]}], 
    FractionBox[
     RowBox[{
      SubsuperscriptBox[
       StyleBox["\[ScriptCapitalT]",
        FontColor->RGBColor[1, 0, 0]], 
       RowBox[{"1", ",", "2"}], "+"], " "}], 
     RowBox[{
      SubsuperscriptBox[
       StyleBox["\[ScriptCapitalT]",
        FontColor->RGBColor[1, 0, 0]], 
       RowBox[{"1", ",", "2"}], "-"], " "}]], 
    FractionBox[
     RowBox[{
      SuperscriptBox[
       OverscriptBox[
        StyleBox["\[ScriptCapitalT]",
         FontColor->RGBColor[1, 0, 0]], 
        StyleBox["^",
         FontColor->RGBColor[1, 0, 0]]], 
       RowBox[{"[", 
        RowBox[{"-", "2"}], "]"}]], " "}], 
     SuperscriptBox[
      OverscriptBox[
       StyleBox["\[ScriptCapitalT]",
        FontColor->RGBColor[1, 0, 0]], 
       StyleBox["^",
        FontColor->RGBColor[1, 0, 0]]], 
      RowBox[{"[", 
       RowBox[{"+", "2"}], "]"}]]], 
    SuperscriptBox[
     RowBox[{"(", 
      FractionBox[
       SuperscriptBox[
        OverscriptBox[
         StyleBox["h",
          FontColor->RGBColor[0, 0.6, 0]], 
         StyleBox["^",
          FontColor->RGBColor[0, 0.6, 0]]], "+"], 
       SuperscriptBox[
        OverscriptBox[
         StyleBox["h",
          FontColor->RGBColor[0, 0.6, 0]], 
         StyleBox["^",
          FontColor->RGBColor[0, 0.6, 0]]], "-"]], ")"}], 
     RowBox[{"-", "2"}]]}], "]"}], "\[Equal]", 
  RowBox[{"\[Phi]", "[", 
   SubscriptBox["v", "0"], "]"}], "\[Equal]", "0"}]], "Input",
 CellChangeTimes->{{3.553853591856243*^9, 3.553853612609198*^9}}],

Cell["Now, we represent", "Text",
 CellChangeTimes->{{3.5538536306670732`*^9, 3.5538536338425503`*^9}}],

Cell[BoxData[
 RowBox[{"\[Phi]", "=", 
  RowBox[{
   SubscriptBox["\[Phi]", "as"], "+", 
   RowBox[{
    SuperscriptBox["g", "8"], "m1"}], "+", 
   RowBox[{
    SuperscriptBox["g", "10"], "m2"}], "+", 
   RowBox[{
    SuperscriptBox["g", "12"], "m3"}], "+", 
   RowBox[{
    SuperscriptBox["g", "14"], "m4"}]}]}]], "Input",
 CellChangeTimes->{{3.553853635467667*^9, 3.5538536505369587`*^9}, {
  3.55597482199514*^9, 3.5559748302561274`*^9}}],

Cell[TextData[{
 "It is important to check that ",
 Cell[BoxData[
  FormBox[
   RowBox[{
    SubscriptBox["\[Phi]", "as"], "[", "v", "]"}], TraditionalForm]]],
 " is exactly the same function as in the Beisert-Staudacher asymptotic Bethe \
Ansatz (not only at Bethe roots, but everywhere, because derivatives of ",
 Cell[BoxData[
  FormBox[
   SubscriptBox["\[Phi]", "as"], TraditionalForm]]],
 " also eneter the answer)"
}], "Text",
 CellChangeTimes->{
  3.553853585246242*^9, {3.5538536167394953`*^9, 3.553853626162984*^9}, {
   3.553853656365719*^9, 3.553853778477106*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     FractionBox[
      SuperscriptBox[
       OverscriptBox[
        StyleBox["h",
         FontColor->RGBColor[0, 0.6, 0]], 
        StyleBox["^",
         FontColor->RGBColor[0, 0.6, 0]]], "+"], 
      SuperscriptBox[
       OverscriptBox[
        StyleBox["h",
         FontColor->RGBColor[0, 0.6, 0]], 
        StyleBox["^",
         FontColor->RGBColor[0, 0.6, 0]]], "-"]], ")"}], 
    RowBox[{"-", "2"}]], "\[Equal]", 
   RowBox[{
    FractionBox[
     SuperscriptBox[
      RowBox[{"(", 
       SuperscriptBox[
        OverscriptBox[
         StyleBox["x",
          FontColor->RGBColor[0, 0.6, 0]], 
         StyleBox["^",
          FontColor->RGBColor[0, 0.6, 0]]], "+"], ")"}], "4"], 
     SuperscriptBox[
      RowBox[{"(", 
       SuperscriptBox[
        OverscriptBox[
         StyleBox["x",
          FontColor->RGBColor[0, 0.6, 0]], 
         StyleBox["^",
          FontColor->RGBColor[0, 0.6, 0]]], "-"], ")"}], "4"]], 
    FractionBox["1", 
     SubsuperscriptBox["\[Sigma]", "BES", "2"]]}]}], ",", " ", 
  RowBox[{"(*", " ", 
   RowBox[{
    RowBox[{"it", " ", "follows", " ", "from", "  ", 
     SubscriptBox[
      RowBox[{"(", 
       FractionBox[
        RowBox[{
         OverscriptBox[
          StyleBox["h",
           FontColor->RGBColor[0, 0.6, 0]], 
          StyleBox["^",
           FontColor->RGBColor[0, 0.6, 0]]], " ", 
         SuperscriptBox[
          OverscriptBox[
           StyleBox["x",
            FontColor->RGBColor[0, 0.6, 0]], 
           StyleBox["^",
            FontColor->RGBColor[0, 0.6, 0]]], 
          RowBox[{
           FractionBox["L", "2"], "+", "1"}]]}], 
        SubscriptBox["\[Sigma]", "1"]], ")"}], "asym"]}], "\[Equal]", " ", 
    "const"}], " ", "*)"}]}]], "Input",
 CellChangeTimes->{{3.5538538126378183`*^9, 3.553853917477817*^9}, {
  3.55385481501191*^9, 3.553854821562435*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      FractionBox[
       SubscriptBox["Y", 
        RowBox[{"1", ",", "1"}]], 
       SubscriptBox["Y", 
        RowBox[{"2", ",", "2"}]]], 
      FractionBox[
       SubsuperscriptBox[
        StyleBox["\[GothicCapitalT]",
         FontColor->RGBColor[0.54, 0.35, 0.15]], 
        RowBox[{"2", ",", "1"}], "2"], 
       SubsuperscriptBox[
        StyleBox["\[ScriptCapitalT]",
         FontColor->RGBColor[1, 0, 0]], 
        RowBox[{"1", ",", "2"}], "2"]]}], ")"}], "==", 
    RowBox[{
     SuperscriptBox[
      RowBox[{"(", 
       FractionBox["1", 
        RowBox[{
         SuperscriptBox[
          OverscriptBox[
           StyleBox["y",
            FontColor->RGBColor[0, 0.6, 0]], 
           StyleBox["^",
            FontColor->RGBColor[0, 0.6, 0]]], "-"], " ", 
         SuperscriptBox[
          OverscriptBox[
           StyleBox["y",
            FontColor->RGBColor[0, 0.6, 0]], 
           StyleBox["^",
            FontColor->RGBColor[0, 0.6, 0]]], "+"]}]], ")"}], "2"], 
     RowBox[{"(", 
      FractionBox[
       RowBox[{
        SuperscriptBox[
         StyleBox["\[GothicCapitalT]",
          FontColor->RGBColor[0.54, 0.35, 0.15]], "-"], 
        SubsuperscriptBox[
         StyleBox["\[GothicCapitalT]",
          FontColor->RGBColor[0.54, 0.35, 0.15]], "*", "-"], 
        SuperscriptBox[
         StyleBox["\[GothicCapitalT]",
          FontColor->RGBColor[0.54, 0.35, 0.15]], "+"], 
        SubsuperscriptBox[
         StyleBox["\[GothicCapitalT]",
          FontColor->RGBColor[0.54, 0.35, 0.15]], "*", "+"], " "}], 
       RowBox[{
        SuperscriptBox[
         StyleBox["\[ScriptCapitalT]",
          FontColor->RGBColor[1, 0, 0]], "-"], 
        SubsuperscriptBox[
         StyleBox["\[ScriptCapitalT]",
          FontColor->RGBColor[1, 0, 0]], "*", "-"], " ", 
        SuperscriptBox[
         StyleBox["\[ScriptCapitalT]",
          FontColor->RGBColor[1, 0, 0]], "+"], 
        SubsuperscriptBox[
         StyleBox["\[ScriptCapitalT]",
          FontColor->RGBColor[1, 0, 0]], "*", "+"]}]], ")"}]}], "\[Equal]", 
    RowBox[{
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{
        SuperscriptBox[
         OverscriptBox[
          StyleBox["y",
           FontColor->RGBColor[0, 0.6, 0]], 
          StyleBox["^",
           FontColor->RGBColor[0, 0.6, 0]]], "-"], " ", 
        SuperscriptBox[
         OverscriptBox[
          StyleBox["y",
           FontColor->RGBColor[0, 0.6, 0]], 
          StyleBox["^",
           FontColor->RGBColor[0, 0.6, 0]]], "+"]}], ")"}], "2"], 
     SuperscriptBox[
      RowBox[{"(", 
       FractionBox[
        RowBox[{
         SuperscriptBox[
          StyleBox["Bp",
           FontColor->RGBColor[0, 0.6, 0]], 
          RowBox[{"[", 
           RowBox[{"-", "2"}], "]"}]], " ", 
         SuperscriptBox[
          StyleBox["x",
           FontColor->RGBColor[0, 0.6, 0]], 
          RowBox[{"[", 
           RowBox[{"-", "2"}], "]"}]]}], 
        RowBox[{
         SuperscriptBox[
          StyleBox["Bm",
           FontColor->RGBColor[0, 0.6, 0]], 
          RowBox[{"[", 
           RowBox[{"+", "2"}], "]"}]], " ", 
         SuperscriptBox[
          StyleBox["x",
           FontColor->RGBColor[0, 0.6, 0]], 
          RowBox[{"[", 
           RowBox[{"+", "2"}], "]"}]]}]], ")"}], "2"], 
     RowBox[{"(", 
      FractionBox[
       SuperscriptBox[
        StyleBox["Q",
         FontColor->RGBColor[0.8, 0, 0]], "+"], 
       SuperscriptBox[
        StyleBox["Q",
         FontColor->RGBColor[0.8, 0, 0]], "-"]], ")"}]}]}], ",", 
   RowBox[{"Y11Y22", "==", 
    FractionBox[
     RowBox[{
      StyleBox["Bm",
       FontColor->RGBColor[0, 0.6, 0]], " ", 
      StyleBox["Rp",
       FontColor->RGBColor[0, 0.6, 0]]}], 
     RowBox[{
      StyleBox["Bp",
       FontColor->RGBColor[0, 0.6, 0]], " ", 
      StyleBox["Rm",
       FontColor->RGBColor[0, 0.6, 0]]}]]}]}], "}"}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"-", 
    FractionBox[
     SubsuperscriptBox[
      StyleBox["Y",
       FontColor->RGBColor[0, 0, 0.8]], 
      RowBox[{"2", ",", "2"}], "+"], 
     SubsuperscriptBox[
      StyleBox["Y",
       FontColor->RGBColor[0, 0, 0.8]], 
      RowBox[{"2", ",", "2"}], "-"]]}], 
   FractionBox[
    RowBox[{
     SubsuperscriptBox[
      StyleBox["\[ScriptCapitalT]",
       FontColor->RGBColor[1, 0, 0]], 
      RowBox[{"1", ",", "2"}], "+"], " "}], 
    RowBox[{
     SubsuperscriptBox[
      StyleBox["\[ScriptCapitalT]",
       FontColor->RGBColor[1, 0, 0]], 
      RowBox[{"1", ",", "2"}], "-"], " "}]], 
   FractionBox[
    RowBox[{
     SuperscriptBox[
      OverscriptBox[
       StyleBox["\[ScriptCapitalT]",
        FontColor->RGBColor[1, 0, 0]], 
       StyleBox["^",
        FontColor->RGBColor[1, 0, 0]]], 
      RowBox[{"[", 
       RowBox[{"-", "2"}], "]"}]], " "}], 
    SuperscriptBox[
     OverscriptBox[
      StyleBox["\[ScriptCapitalT]",
       FontColor->RGBColor[1, 0, 0]], 
      StyleBox["^",
       FontColor->RGBColor[1, 0, 0]]], 
     RowBox[{"[", 
      RowBox[{"+", "2"}], "]"}]]], 
   FractionBox[
    SuperscriptBox[
     RowBox[{"(", 
      SuperscriptBox[
       OverscriptBox[
        StyleBox["x",
         FontColor->RGBColor[0, 0.6, 0]], 
        StyleBox["^",
         FontColor->RGBColor[0, 0.6, 0]]], "+"], ")"}], "4"], 
    SuperscriptBox[
     RowBox[{"(", 
      SuperscriptBox[
       OverscriptBox[
        StyleBox["x",
         FontColor->RGBColor[0, 0.6, 0]], 
        StyleBox["^",
         FontColor->RGBColor[0, 0.6, 0]]], "-"], ")"}], "4"]], 
   FractionBox["1", 
    SubsuperscriptBox["\[Sigma]", "BES", "2"]]}], "\[Equal]", 
  RowBox[{
   FractionBox[
    RowBox[{"-", 
     SqrtBox[
      FractionBox[
       SuperscriptBox[
        RowBox[{"(", 
         FractionBox[
          RowBox[{
           StyleBox["Bm",
            FontColor->RGBColor[0, 0.6, 0]], " ", 
           StyleBox["Rp",
            FontColor->RGBColor[0, 0.6, 0]]}], 
          RowBox[{
           StyleBox["Bp",
            FontColor->RGBColor[0, 0.6, 0]], " ", 
           StyleBox["Rm",
            FontColor->RGBColor[0, 0.6, 0]]}]], ")"}], "+"], 
       SuperscriptBox[
        RowBox[{"(", 
         FractionBox[
          RowBox[{
           StyleBox["Bm",
            FontColor->RGBColor[0, 0.6, 0]], " ", 
           StyleBox["Rp",
            FontColor->RGBColor[0, 0.6, 0]]}], 
          RowBox[{
           StyleBox["Bp",
            FontColor->RGBColor[0, 0.6, 0]], " ", 
           StyleBox["Rm",
            FontColor->RGBColor[0, 0.6, 0]]}]], ")"}], "-"]]]}], 
    RowBox[{
     FractionBox[
      SuperscriptBox[
       RowBox[{"(", 
        FractionBox[
         RowBox[{
          SuperscriptBox[
           StyleBox["Bp",
            FontColor->RGBColor[0, 0.6, 0]], 
           RowBox[{"[", 
            RowBox[{"-", "2"}], "]"}]], " ", 
          SuperscriptBox[
           StyleBox["x",
            FontColor->RGBColor[0, 0.6, 0]], 
           RowBox[{"[", 
            RowBox[{"-", "2"}], "]"}]]}], 
         RowBox[{
          SuperscriptBox[
           StyleBox["Bm",
            FontColor->RGBColor[0, 0.6, 0]], 
           RowBox[{"[", 
            RowBox[{"+", "2"}], "]"}]], " ", 
          SuperscriptBox[
           StyleBox["x",
            FontColor->RGBColor[0, 0.6, 0]], 
           RowBox[{"[", 
            RowBox[{"+", "2"}], "]"}]]}]], ")"}], "+"], 
      SuperscriptBox[
       RowBox[{"(", 
        FractionBox[
         RowBox[{
          SuperscriptBox[
           StyleBox["Bp",
            FontColor->RGBColor[0, 0.6, 0]], 
           RowBox[{"[", 
            RowBox[{"-", "2"}], "]"}]], " ", 
          SuperscriptBox[
           StyleBox["x",
            FontColor->RGBColor[0, 0.6, 0]], 
           RowBox[{"[", 
            RowBox[{"-", "2"}], "]"}]]}], 
         RowBox[{
          SuperscriptBox[
           StyleBox["Bm",
            FontColor->RGBColor[0, 0.6, 0]], 
           RowBox[{"[", 
            RowBox[{"+", "2"}], "]"}]], " ", 
          SuperscriptBox[
           StyleBox["x",
            FontColor->RGBColor[0, 0.6, 0]], 
           RowBox[{"[", 
            RowBox[{"+", "2"}], "]"}]]}]], ")"}], "-"]], 
     SqrtBox[
      FractionBox[
       SuperscriptBox[
        RowBox[{"(", 
         RowBox[{
          SuperscriptBox[
           StyleBox["Q",
            FontColor->RGBColor[0.8, 0, 0]], "+"], "/", 
          SuperscriptBox[
           StyleBox["Q",
            FontColor->RGBColor[0.8, 0, 0]], "-"]}], ")"}], "+"], 
       SuperscriptBox[
        RowBox[{"(", 
         RowBox[{
          SuperscriptBox[
           StyleBox["Q",
            FontColor->RGBColor[0.8, 0, 0]], "+"], "/", 
          SuperscriptBox[
           StyleBox["Q",
            FontColor->RGBColor[0.8, 0, 0]], "-"]}], ")"}], "-"]]]}]], 
   FractionBox[
    SubsuperscriptBox[
     StyleBox["\[GothicCapitalT]",
      FontColor->RGBColor[0.54, 0.35, 0.15]], 
     RowBox[{"2", ",", "1"}], "+"], 
    SubsuperscriptBox[
     StyleBox["\[GothicCapitalT]",
      FontColor->RGBColor[0.54, 0.35, 0.15]], 
     RowBox[{"2", ",", "1"}], "-"]], 
   FractionBox[
    RowBox[{
     SuperscriptBox[
      OverscriptBox[
       StyleBox["\[ScriptCapitalT]",
        FontColor->RGBColor[1, 0, 0]], 
       StyleBox["^",
        FontColor->RGBColor[1, 0, 0]]], 
      RowBox[{"[", 
       RowBox[{"-", "2"}], "]"}]], " "}], 
    SuperscriptBox[
     OverscriptBox[
      StyleBox["\[ScriptCapitalT]",
       FontColor->RGBColor[1, 0, 0]], 
      StyleBox["^",
       FontColor->RGBColor[1, 0, 0]]], 
     RowBox[{"[", 
      RowBox[{"+", "2"}], "]"}]]], 
   FractionBox[
    SuperscriptBox[
     RowBox[{"(", 
      SuperscriptBox[
       OverscriptBox[
        StyleBox["x",
         FontColor->RGBColor[0, 0.6, 0]], 
        StyleBox["^",
         FontColor->RGBColor[0, 0.6, 0]]], "+"], ")"}], "4"], 
    SuperscriptBox[
     RowBox[{"(", 
      SuperscriptBox[
       OverscriptBox[
        StyleBox["x",
         FontColor->RGBColor[0, 0.6, 0]], 
        StyleBox["^",
         FontColor->RGBColor[0, 0.6, 0]]], "-"], ")"}], "4"]], 
   FractionBox["1", 
    SubsuperscriptBox["\[Sigma]", "BES", "2"]]}], "\[Equal]", 
  RowBox[{
   RowBox[{"-", 
    FractionBox[
     FractionBox[
      RowBox[{"(", 
       FractionBox[
        SuperscriptBox[
         StyleBox["Bm",
          FontColor->RGBColor[0, 0.6, 0]], "+"], 
        SuperscriptBox[
         StyleBox["Bp",
          FontColor->RGBColor[0, 0.6, 0]], "+"]], ")"}], 
      RowBox[{"(", 
       FractionBox[
        SuperscriptBox[
         StyleBox["Bm",
          FontColor->RGBColor[0, 0.6, 0]], "-"], 
        SuperscriptBox[
         StyleBox["Bp",
          FontColor->RGBColor[0, 0.6, 0]], "-"]], ")"}]], 
     FractionBox[
      RowBox[{"(", 
       FractionBox[
        RowBox[{
         SuperscriptBox[
          StyleBox["Bp",
           FontColor->RGBColor[0, 0.6, 0]], 
          RowBox[{"[", 
           RowBox[{"-", "1"}], "]"}]], " ", 
         SuperscriptBox[
          StyleBox["x",
           FontColor->RGBColor[0, 0.6, 0]], 
          RowBox[{"[", 
           RowBox[{"-", "1"}], "]"}]]}], 
        RowBox[{
         SuperscriptBox[
          StyleBox["Bm",
           FontColor->RGBColor[0, 0.6, 0]], 
          RowBox[{"[", 
           RowBox[{"+", "3"}], "]"}]], " ", 
         SuperscriptBox[
          StyleBox["x",
           FontColor->RGBColor[0, 0.6, 0]], 
          RowBox[{"[", 
           RowBox[{"+", "3"}], "]"}]]}]], ")"}], 
      RowBox[{"(", 
       FractionBox[
        RowBox[{
         SuperscriptBox[
          StyleBox["Bp",
           FontColor->RGBColor[0, 0.6, 0]], 
          RowBox[{"[", 
           RowBox[{"-", "3"}], "]"}]], " ", 
         SuperscriptBox[
          StyleBox["x",
           FontColor->RGBColor[0, 0.6, 0]], 
          RowBox[{"[", 
           RowBox[{"-", "3"}], "]"}]]}], 
        RowBox[{
         SuperscriptBox[
          StyleBox["Bm",
           FontColor->RGBColor[0, 0.6, 0]], 
          RowBox[{"[", 
           RowBox[{"+", "1"}], "]"}]], " ", 
         SuperscriptBox[
          StyleBox["x",
           FontColor->RGBColor[0, 0.6, 0]], 
          RowBox[{"[", 
           RowBox[{"+", "1"}], "]"}]]}]], ")"}]]]}], 
   FractionBox[
    SubsuperscriptBox[
     StyleBox["\[GothicCapitalT]",
      FontColor->RGBColor[0.54, 0.35, 0.15]], 
     RowBox[{"2", ",", "1"}], "+"], 
    SubsuperscriptBox[
     StyleBox["\[GothicCapitalT]",
      FontColor->RGBColor[0.54, 0.35, 0.15]], 
     RowBox[{"2", ",", "1"}], "-"]], 
   FractionBox[
    RowBox[{
     SuperscriptBox[
      OverscriptBox[
       StyleBox["\[ScriptCapitalT]",
        FontColor->RGBColor[1, 0, 0]], 
       StyleBox["^",
        FontColor->RGBColor[1, 0, 0]]], 
      RowBox[{"[", 
       RowBox[{"-", "2"}], "]"}]], " "}], 
    SuperscriptBox[
     OverscriptBox[
      StyleBox["\[ScriptCapitalT]",
       FontColor->RGBColor[1, 0, 0]], 
      StyleBox["^",
       FontColor->RGBColor[1, 0, 0]]], 
     RowBox[{"[", 
      RowBox[{"+", "2"}], "]"}]]], 
   FractionBox[
    SuperscriptBox[
     RowBox[{"(", 
      SuperscriptBox[
       OverscriptBox[
        StyleBox["x",
         FontColor->RGBColor[0, 0.6, 0]], 
        StyleBox["^",
         FontColor->RGBColor[0, 0.6, 0]]], "+"], ")"}], "4"], 
    SuperscriptBox[
     RowBox[{"(", 
      SuperscriptBox[
       OverscriptBox[
        StyleBox["x",
         FontColor->RGBColor[0, 0.6, 0]], 
        StyleBox["^",
         FontColor->RGBColor[0, 0.6, 0]]], "-"], ")"}], "4"]], 
   FractionBox["1", 
    SubsuperscriptBox["\[Sigma]", "BES", "2"]]}], "==", 
  RowBox[{
   RowBox[{"-", 
    RowBox[{"(", 
     FractionBox[
      RowBox[{
       SuperscriptBox[
        StyleBox["Bm",
         FontColor->RGBColor[0, 0.6, 0]], 
        RowBox[{"[", "3", "]"}]], " ", 
       SuperscriptBox[
        StyleBox["Bp",
         FontColor->RGBColor[0, 0.6, 0]], 
        RowBox[{"[", 
         RowBox[{"-", "3"}], "]"}]], " ", 
       SuperscriptBox[
        StyleBox["x",
         FontColor->RGBColor[0, 0.6, 0]], 
        RowBox[{"[", 
         RowBox[{"-", "3"}], "]"}]], " ", 
       SuperscriptBox[
        StyleBox["x",
         FontColor->RGBColor[0, 0.6, 0]], 
        RowBox[{"[", "3", "]"}]]}], 
      RowBox[{
       SuperscriptBox[
        StyleBox["Bm",
         FontColor->RGBColor[0, 0.6, 0]], "-"], " ", 
       SuperscriptBox[
        StyleBox["Bp",
         FontColor->RGBColor[0, 0.6, 0]], "+"], " ", 
       SuperscriptBox[
        StyleBox["x",
         FontColor->RGBColor[0, 0.6, 0]], "-"], " ", 
       SuperscriptBox[
        StyleBox["x",
         FontColor->RGBColor[0, 0.6, 0]], "+"]}]], ")"}]}], 
   FractionBox[
    SubsuperscriptBox[
     StyleBox["\[GothicCapitalT]",
      FontColor->RGBColor[0.54, 0.35, 0.15]], 
     RowBox[{"2", ",", "1"}], "+"], 
    SubsuperscriptBox[
     StyleBox["\[GothicCapitalT]",
      FontColor->RGBColor[0.54, 0.35, 0.15]], 
     RowBox[{"2", ",", "1"}], "-"]], 
   FractionBox[
    RowBox[{
     SuperscriptBox[
      OverscriptBox[
       StyleBox["\[ScriptCapitalT]",
        FontColor->RGBColor[1, 0, 0]], 
       StyleBox["^",
        FontColor->RGBColor[1, 0, 0]]], 
      RowBox[{"[", 
       RowBox[{"-", "2"}], "]"}]], " "}], 
    SuperscriptBox[
     OverscriptBox[
      StyleBox["\[ScriptCapitalT]",
       FontColor->RGBColor[1, 0, 0]], 
      StyleBox["^",
       FontColor->RGBColor[1, 0, 0]]], 
     RowBox[{"[", 
      RowBox[{"+", "2"}], "]"}]]], 
   FractionBox[
    SuperscriptBox[
     RowBox[{"(", 
      SuperscriptBox[
       OverscriptBox[
        StyleBox["x",
         FontColor->RGBColor[0, 0.6, 0]], 
        StyleBox["^",
         FontColor->RGBColor[0, 0.6, 0]]], "+"], ")"}], "4"], 
    SuperscriptBox[
     RowBox[{"(", 
      SuperscriptBox[
       OverscriptBox[
        StyleBox["x",
         FontColor->RGBColor[0, 0.6, 0]], 
        StyleBox["^",
         FontColor->RGBColor[0, 0.6, 0]]], "-"], ")"}], "4"]], 
   FractionBox["1", 
    SubsuperscriptBox["\[Sigma]", "BES", "2"]]}]}]], "Input",
 CellChangeTimes->{{3.553853935957232*^9, 3.5538539366080713`*^9}, {
  3.553853995360682*^9, 3.5538540304926033`*^9}, {3.55385406694669*^9, 
  3.553854146785877*^9}, {3.553854185370525*^9, 3.553854257488625*^9}, {
  3.553854848332038*^9, 3.553854853747715*^9}, {3.553855042067976*^9, 
  3.5538550698585043`*^9}}],

Cell["This should be equal to", "Text",
 CellChangeTimes->{{3.553855384278664*^9, 3.5538553940937023`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"-", 
   FractionBox[
    SuperscriptBox[
     RowBox[{"(", 
      SuperscriptBox[
       OverscriptBox[
        StyleBox["x",
         FontColor->RGBColor[0, 0.6, 0]], 
        StyleBox["^",
         FontColor->RGBColor[0, 0.6, 0]]], "+"], ")"}], "2"], 
    SuperscriptBox[
     RowBox[{"(", 
      SuperscriptBox[
       OverscriptBox[
        StyleBox["x",
         FontColor->RGBColor[0, 0.6, 0]], 
        StyleBox["^",
         FontColor->RGBColor[0, 0.6, 0]]], "-"], ")"}], "2"]]}], 
  FractionBox[
   SuperscriptBox[
    StyleBox["Q",
     FontColor->RGBColor[0.8, 0, 0]], 
    RowBox[{"[", "2", "]"}]], 
   SuperscriptBox[
    StyleBox["Q",
     FontColor->RGBColor[0.8, 0, 0]], 
    RowBox[{"[", 
     RowBox[{"-", "2"}], "]"}]]], 
  SuperscriptBox[
   RowBox[{"(", 
    FractionBox[
     SuperscriptBox[
      OverscriptBox[
       StyleBox["Bm",
        FontColor->RGBColor[0, 0.6, 0]], 
       StyleBox["^",
        FontColor->RGBColor[0, 0.6, 0]]], "-"], 
     SuperscriptBox[
      OverscriptBox[
       StyleBox["Bp",
        FontColor->RGBColor[0, 0.6, 0]], 
       StyleBox["^",
        FontColor->RGBColor[0, 0.6, 0]]], "+"]], ")"}], "2"], 
  FractionBox["1", 
   SubsuperscriptBox["\[Sigma]", "BES", "2"]]}]], "Input",
 CellChangeTimes->{{3.553855404698866*^9, 3.5538554338008633`*^9}}],

Cell[CellGroupData[{

Cell["First, let us check this at weak coupling (indeed, it works)", \
"Subsubsection",
 CellChangeTimes->{{3.553855446757505*^9, 3.55385546238708*^9}, {
  3.553855792502201*^9, 3.553855796158072*^9}}],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"ptmp", "=", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{"-", 
         RowBox[{"(", 
          FractionBox[
           RowBox[{
            SuperscriptBox[
             StyleBox["Bm",
              FontColor->RGBColor[0, 0.6, 0]], 
             RowBox[{"[", "3", "]"}]], " ", 
            SuperscriptBox[
             StyleBox["Bp",
              FontColor->RGBColor[0, 0.6, 0]], 
             RowBox[{"[", 
              RowBox[{"-", "3"}], "]"}]], " ", 
            SuperscriptBox[
             StyleBox["x",
              FontColor->RGBColor[0, 0.6, 0]], 
             RowBox[{"[", 
              RowBox[{"-", "3"}], "]"}]], " ", 
            SuperscriptBox[
             StyleBox["x",
              FontColor->RGBColor[0, 0.6, 0]], 
             RowBox[{"[", "3", "]"}]]}], 
           RowBox[{
            SuperscriptBox[
             StyleBox["Bm",
              FontColor->RGBColor[0, 0.6, 0]], "-"], " ", 
            SuperscriptBox[
             StyleBox["Bp",
              FontColor->RGBColor[0, 0.6, 0]], "+"], " ", 
            SuperscriptBox[
             StyleBox["x",
              FontColor->RGBColor[0, 0.6, 0]], "-"], " ", 
            SuperscriptBox[
             StyleBox["x",
              FontColor->RGBColor[0, 0.6, 0]], "+"]}]], ")"}]}], 
        FractionBox[
         SubsuperscriptBox[
          StyleBox["\[GothicCapitalT]",
           FontColor->RGBColor[0.54, 0.35, 0.15]], 
          RowBox[{"2", ",", "1"}], "+"], 
         SubsuperscriptBox[
          StyleBox["\[GothicCapitalT]",
           FontColor->RGBColor[0.54, 0.35, 0.15]], 
          RowBox[{"2", ",", "1"}], "-"]], 
        FractionBox[
         RowBox[{
          SuperscriptBox[
           OverscriptBox[
            StyleBox["\[ScriptCapitalT]",
             FontColor->RGBColor[1, 0, 0]], 
            StyleBox["^",
             FontColor->RGBColor[1, 0, 0]]], 
           RowBox[{"[", 
            RowBox[{"-", "2"}], "]"}]], " "}], 
         SuperscriptBox[
          OverscriptBox[
           StyleBox["\[ScriptCapitalT]",
            FontColor->RGBColor[1, 0, 0]], 
           StyleBox["^",
            FontColor->RGBColor[1, 0, 0]]], 
          RowBox[{"[", 
           RowBox[{"+", "2"}], "]"}]]], 
        FractionBox[
         SuperscriptBox[
          RowBox[{"(", 
           SuperscriptBox[
            OverscriptBox[
             StyleBox["x",
              FontColor->RGBColor[0, 0.6, 0]], 
             StyleBox["^",
              FontColor->RGBColor[0, 0.6, 0]]], "+"], ")"}], "4"], 
         SuperscriptBox[
          RowBox[{"(", 
           SuperscriptBox[
            OverscriptBox[
             StyleBox["x",
              FontColor->RGBColor[0, 0.6, 0]], 
             StyleBox["^",
              FontColor->RGBColor[0, 0.6, 0]]], "-"], ")"}], "4"]]}], "/.", 
       "subFunsBethe"}], "/.", "largevolume"}], "/.", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"x$", "[", 
        RowBox[{"a_", "/;", 
         RowBox[{"a", "\[NotEqual]", "0"}]}], "]"}], "\[RuleDelayed]", 
       SuperscriptBox[
        RowBox[{"(", 
         RowBox[{"x$h", "[", "a", "]"}], ")"}], 
        RowBox[{"Sign", "[", 
         RowBox[{"a", "+", 
          FractionBox["1", "2"]}], "]"}]]}], "}"}]}], ")"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"FreeQ", "[", 
  RowBox[{"ptmp", ",", "x$"}], "]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"ptmp", "=", 
   RowBox[{
    RowBox[{"Series", "[", 
     RowBox[{
      RowBox[{"ptmp", "/.", "subJuk"}], ",", 
      RowBox[{"{", 
       RowBox[{"g", ",", "0", ",", "5"}], "}"}]}], "]"}], "//", 
    "Simplify"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"tmp", "=", 
  RowBox[{
   RowBox[{"%", "/.", 
    RowBox[{"u", "\[Rule]", 
     SubscriptBox["v", "0"]}]}], "//", "Simplify"}]}]}], "Input",
 CellChangeTimes->{{3.553854604150633*^9, 3.553854747938027*^9}, 
   3.553854792599111*^9, {3.553854830029553*^9, 3.553854834498995*^9}, 
   3.553854934423443*^9, {3.553855078246171*^9, 3.553855079937169*^9}, {
   3.553855135685151*^9, 3.553855176672701*^9}, {3.553855268391349*^9, 
   3.553855310645946*^9}, {3.553855468852337*^9, 3.553855571069312*^9}, {
   3.553855637969679*^9, 3.553855690381568*^9}, {3.553855756472097*^9, 
   3.553855769401659*^9}}],

Cell[BoxData["True"], "Output",
 CellChangeTimes->{{3.553854612041041*^9, 3.5538546248293447`*^9}, {
   3.553854691539443*^9, 3.553854748364874*^9}, 3.553854793809843*^9, {
   3.5538548350419693`*^9, 3.553854858390807*^9}, 3.5538549349587593`*^9, 
   3.55385508670798*^9, {3.553855136174551*^9, 3.553855177120492*^9}, {
   3.553855269148182*^9, 3.553855318104307*^9}, 3.553855376803587*^9, 
   3.553855531925582*^9, 3.553855574365695*^9, 3.553855691118541*^9, {
   3.553855759036615*^9, 3.553855769710969*^9}}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
   FractionBox[
    SuperscriptBox[
     RowBox[{"(", 
      RowBox[{"\[ImaginaryI]", "+", 
       RowBox[{"2", " ", 
        SubscriptBox["v", "0"]}]}], ")"}], "3"], 
    SuperscriptBox[
     RowBox[{"(", 
      RowBox[{
       RowBox[{"-", "\[ImaginaryI]"}], "+", 
       RowBox[{"2", " ", 
        SubscriptBox["v", "0"]}]}], ")"}], "3"]], "+", 
   FractionBox[
    RowBox[{"128", " ", "\[ImaginaryI]", " ", 
     SubscriptBox["v", "0"], " ", 
     RowBox[{"(", 
      RowBox[{"\[ImaginaryI]", "+", 
       RowBox[{"2", " ", 
        SubscriptBox["v", "0"]}]}], ")"}], " ", 
     SuperscriptBox["g", "2"]}], 
    SuperscriptBox[
     RowBox[{"(", 
      RowBox[{
       RowBox[{"-", "\[ImaginaryI]"}], "+", 
       RowBox[{"2", " ", 
        SubscriptBox["v", "0"]}]}], ")"}], "5"]], "+", 
   FractionBox[
    RowBox[{"512", " ", "\[ImaginaryI]", " ", 
     SubscriptBox["v", "0"], " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"-", "3"}], "+", 
       RowBox[{"16", " ", "\[ImaginaryI]", " ", 
        SubscriptBox["v", "0"]}], "+", 
       RowBox[{"12", " ", 
        SubsuperscriptBox["v", "0", "2"]}]}], ")"}], " ", 
     SuperscriptBox["g", "4"]}], 
    RowBox[{
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "\[ImaginaryI]"}], "+", 
        RowBox[{"2", " ", 
         SubscriptBox["v", "0"]}]}], ")"}], "7"], " ", 
     RowBox[{"(", 
      RowBox[{"\[ImaginaryI]", "+", 
       RowBox[{"2", " ", 
        SubscriptBox["v", "0"]}]}], ")"}]}]], "+", 
   InterpretationBox[
    SuperscriptBox[
     RowBox[{"O", "[", "g", "]"}], "6"],
    SeriesData[$CellContext`g, 0, {}, 0, 6, 1],
    Editable->False]}],
  SeriesData[$CellContext`g, 
   0, {(Complex[0, -1] + 2 Subscript[$CellContext`v, 0])^(-3) (Complex[0, 1] + 
      2 Subscript[$CellContext`v, 0])^3, 0, Complex[0, 128] 
    Subscript[$CellContext`v, 0] (Complex[0, -1] + 
      2 Subscript[$CellContext`v, 0])^(-5) (Complex[0, 1] + 
     2 Subscript[$CellContext`v, 0]), 0, Complex[0, 512] 
    Subscript[$CellContext`v, 0] (Complex[0, -1] + 
      2 Subscript[$CellContext`v, 0])^(-7) (Complex[0, 1] + 
      2 Subscript[$CellContext`v, 0])^(-1) (-3 + 
     Complex[0, 16] Subscript[$CellContext`v, 0] + 
     12 Subscript[$CellContext`v, 0]^2)}, 0, 6, 1],
  Editable->False]], "Output",
 CellChangeTimes->{{3.553854612041041*^9, 3.5538546248293447`*^9}, {
   3.553854691539443*^9, 3.553854748364874*^9}, 3.553854793809843*^9, {
   3.5538548350419693`*^9, 3.553854858390807*^9}, 3.5538549349587593`*^9, 
   3.55385508670798*^9, {3.553855136174551*^9, 3.553855177120492*^9}, {
   3.553855269148182*^9, 3.553855318104307*^9}, 3.553855376803587*^9, 
   3.553855531925582*^9, 3.553855574365695*^9, 3.553855691118541*^9, {
   3.553855759036615*^9, 3.55385577004697*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"ptmp2", "=", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{"-", 
         FractionBox[
          SuperscriptBox[
           RowBox[{"(", 
            SuperscriptBox[
             OverscriptBox[
              StyleBox["x",
               FontColor->RGBColor[0, 0.6, 0]], 
              StyleBox["^",
               FontColor->RGBColor[0, 0.6, 0]]], "+"], ")"}], "2"], 
          SuperscriptBox[
           RowBox[{"(", 
            SuperscriptBox[
             OverscriptBox[
              StyleBox["x",
               FontColor->RGBColor[0, 0.6, 0]], 
              StyleBox["^",
               FontColor->RGBColor[0, 0.6, 0]]], "-"], ")"}], "2"]]}], 
        FractionBox[
         SuperscriptBox[
          StyleBox["Q",
           FontColor->RGBColor[0.8, 0, 0]], 
          RowBox[{"[", "2", "]"}]], 
         SuperscriptBox[
          StyleBox["Q",
           FontColor->RGBColor[0.8, 0, 0]], 
          RowBox[{"[", 
           RowBox[{"-", "2"}], "]"}]]], 
        SuperscriptBox[
         RowBox[{"(", 
          FractionBox[
           SuperscriptBox[
            StyleBox["Rm",
             FontColor->RGBColor[0, 0.6, 0]], "-"], 
           SuperscriptBox[
            StyleBox["Bp",
             FontColor->RGBColor[0, 0.6, 0]], "+"]], ")"}], "2"]}], "/.", 
       "subFunsBethe"}], "/.", "largevolume"}], "/.", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"x$", "[", 
        RowBox[{"a_", "/;", 
         RowBox[{"a", "\[NotEqual]", "0"}]}], "]"}], "\[RuleDelayed]", 
       SuperscriptBox[
        RowBox[{"(", 
         RowBox[{"x$h", "[", "a", "]"}], ")"}], 
        RowBox[{"Sign", "[", 
         RowBox[{"a", "+", 
          FractionBox["1", "2"]}], "]"}]]}], "}"}]}], ")"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"FreeQ", "[", 
  RowBox[{"ptmp2", ",", "x$"}], "]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"ptmp2", "=", 
   RowBox[{
    RowBox[{"Series", "[", 
     RowBox[{
      RowBox[{"ptmp2", "/.", "subJuk"}], ",", 
      RowBox[{"{", 
       RowBox[{"g", ",", "0", ",", "5"}], "}"}]}], "]"}], "//", 
    "Simplify"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"tmp2", "=", 
  RowBox[{
   RowBox[{"%", "/.", 
    RowBox[{"u", "\[Rule]", 
     SubscriptBox["v", "0"]}]}], "//", "Simplify"}]}]}], "Input",
 CellChangeTimes->{{3.553855698601701*^9, 3.5538557321726294`*^9}, {
  3.5538557755122213`*^9, 3.553855775815282*^9}}],

Cell[BoxData["True"], "Output",
 CellChangeTimes->{{3.553855723892992*^9, 3.553855732703876*^9}, 
   3.5538557760523443`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{
   FractionBox[
    SuperscriptBox[
     RowBox[{"(", 
      RowBox[{"\[ImaginaryI]", "+", 
       RowBox[{"2", " ", 
        SubscriptBox["v", "0"]}]}], ")"}], "3"], 
    SuperscriptBox[
     RowBox[{"(", 
      RowBox[{
       RowBox[{"-", "\[ImaginaryI]"}], "+", 
       RowBox[{"2", " ", 
        SubscriptBox["v", "0"]}]}], ")"}], "3"]], "+", 
   FractionBox[
    RowBox[{"128", " ", "\[ImaginaryI]", " ", 
     SubscriptBox["v", "0"], " ", 
     RowBox[{"(", 
      RowBox[{"\[ImaginaryI]", "+", 
       RowBox[{"2", " ", 
        SubscriptBox["v", "0"]}]}], ")"}], " ", 
     SuperscriptBox["g", "2"]}], 
    SuperscriptBox[
     RowBox[{"(", 
      RowBox[{
       RowBox[{"-", "\[ImaginaryI]"}], "+", 
       RowBox[{"2", " ", 
        SubscriptBox["v", "0"]}]}], ")"}], "5"]], "+", 
   FractionBox[
    RowBox[{"512", " ", "\[ImaginaryI]", " ", 
     SubscriptBox["v", "0"], " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"-", "3"}], "+", 
       RowBox[{"16", " ", "\[ImaginaryI]", " ", 
        SubscriptBox["v", "0"]}], "+", 
       RowBox[{"12", " ", 
        SubsuperscriptBox["v", "0", "2"]}]}], ")"}], " ", 
     SuperscriptBox["g", "4"]}], 
    RowBox[{
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "\[ImaginaryI]"}], "+", 
        RowBox[{"2", " ", 
         SubscriptBox["v", "0"]}]}], ")"}], "7"], " ", 
     RowBox[{"(", 
      RowBox[{"\[ImaginaryI]", "+", 
       RowBox[{"2", " ", 
        SubscriptBox["v", "0"]}]}], ")"}]}]], "+", 
   InterpretationBox[
    SuperscriptBox[
     RowBox[{"O", "[", "g", "]"}], "6"],
    SeriesData[$CellContext`g, 0, {}, 0, 6, 1],
    Editable->False]}],
  SeriesData[$CellContext`g, 
   0, {(Complex[0, -1] + 2 Subscript[$CellContext`v, 0])^(-3) (Complex[0, 1] + 
      2 Subscript[$CellContext`v, 0])^3, 0, Complex[0, 128] 
    Subscript[$CellContext`v, 0] (Complex[0, -1] + 
      2 Subscript[$CellContext`v, 0])^(-5) (Complex[0, 1] + 
     2 Subscript[$CellContext`v, 0]), 0, Complex[0, 512] 
    Subscript[$CellContext`v, 0] (Complex[0, -1] + 
      2 Subscript[$CellContext`v, 0])^(-7) (Complex[0, 1] + 
      2 Subscript[$CellContext`v, 0])^(-1) (-3 + 
     Complex[0, 16] Subscript[$CellContext`v, 0] + 
     12 Subscript[$CellContext`v, 0]^2)}, 0, 6, 1],
  Editable->False]], "Output",
 CellChangeTimes->{{3.553855723892992*^9, 3.553855732703876*^9}, 
   3.553855776376375*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"tmp", "-", "tmp2"}]], "Input",
 CellChangeTimes->{{3.553855735734173*^9, 3.553855744721582*^9}}],

Cell[BoxData[
 InterpretationBox[
  SuperscriptBox[
   RowBox[{"O", "[", "g", "]"}], "6"],
  SeriesData[$CellContext`g, 0, {}, 6, 6, 1],
  Editable->False]], "Output",
 CellChangeTimes->{{3.553855740013823*^9, 3.553855745061372*^9}, 
   3.553855777753353*^9}]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 "Now, we just ask ",
 StyleBox["Mathematica",
  FontSlant->"Italic"],
 " to simplify expression, and it can!"
}], "Subsubsection",
 CellChangeTimes->{{3.553855446757505*^9, 3.55385546238708*^9}, {
  3.553855792502201*^9, 3.5538558082856817`*^9}, {3.553855872203292*^9, 
  3.5538558750269737`*^9}, {3.5538559743912487`*^9, 3.55385598394341*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{
       FractionBox[
        RowBox[{
         RowBox[{"-", 
          RowBox[{"(", 
           FractionBox[
            RowBox[{
             SuperscriptBox[
              StyleBox["Bm",
               FontColor->RGBColor[0, 0.6, 0]], 
              RowBox[{"[", "3", "]"}]], " ", 
             SuperscriptBox[
              StyleBox["Bp",
               FontColor->RGBColor[0, 0.6, 0]], 
              RowBox[{"[", 
               RowBox[{"-", "3"}], "]"}]], " ", 
             SuperscriptBox[
              StyleBox["x",
               FontColor->RGBColor[0, 0.6, 0]], 
              RowBox[{"[", 
               RowBox[{"-", "3"}], "]"}]], " ", 
             SuperscriptBox[
              StyleBox["x",
               FontColor->RGBColor[0, 0.6, 0]], 
              RowBox[{"[", "3", "]"}]]}], 
            RowBox[{
             SuperscriptBox[
              StyleBox["Bm",
               FontColor->RGBColor[0, 0.6, 0]], "-"], " ", 
             SuperscriptBox[
              StyleBox["Bp",
               FontColor->RGBColor[0, 0.6, 0]], "+"], " ", 
             SuperscriptBox[
              StyleBox["x",
               FontColor->RGBColor[0, 0.6, 0]], "-"], " ", 
             SuperscriptBox[
              StyleBox["x",
               FontColor->RGBColor[0, 0.6, 0]], "+"]}]], ")"}]}], 
         FractionBox[
          SubsuperscriptBox[
           StyleBox["\[GothicCapitalT]",
            FontColor->RGBColor[0.54, 0.35, 0.15]], 
           RowBox[{"2", ",", "1"}], "+"], 
          SubsuperscriptBox[
           StyleBox["\[GothicCapitalT]",
            FontColor->RGBColor[0.54, 0.35, 0.15]], 
           RowBox[{"2", ",", "1"}], "-"]], 
         FractionBox[
          RowBox[{
           SuperscriptBox[
            OverscriptBox[
             StyleBox["\[ScriptCapitalT]",
              FontColor->RGBColor[1, 0, 0]], 
             StyleBox["^",
              FontColor->RGBColor[1, 0, 0]]], 
            RowBox[{"[", 
             RowBox[{"-", "2"}], "]"}]], " "}], 
          SuperscriptBox[
           OverscriptBox[
            StyleBox["\[ScriptCapitalT]",
             FontColor->RGBColor[1, 0, 0]], 
            StyleBox["^",
             FontColor->RGBColor[1, 0, 0]]], 
           RowBox[{"[", 
            RowBox[{"+", "2"}], "]"}]]], 
         FractionBox[
          SuperscriptBox[
           RowBox[{"(", 
            SuperscriptBox[
             OverscriptBox[
              StyleBox["x",
               FontColor->RGBColor[0, 0.6, 0]], 
              StyleBox["^",
               FontColor->RGBColor[0, 0.6, 0]]], "+"], ")"}], "4"], 
          SuperscriptBox[
           RowBox[{"(", 
            SuperscriptBox[
             OverscriptBox[
              StyleBox["x",
               FontColor->RGBColor[0, 0.6, 0]], 
              StyleBox["^",
               FontColor->RGBColor[0, 0.6, 0]]], "-"], ")"}], "4"]]}], 
        RowBox[{
         RowBox[{"-", 
          FractionBox[
           SuperscriptBox[
            RowBox[{"(", 
             SuperscriptBox[
              OverscriptBox[
               StyleBox["x",
                FontColor->RGBColor[0, 0.6, 0]], 
               StyleBox["^",
                FontColor->RGBColor[0, 0.6, 0]]], "+"], ")"}], "2"], 
           SuperscriptBox[
            RowBox[{"(", 
             SuperscriptBox[
              OverscriptBox[
               StyleBox["x",
                FontColor->RGBColor[0, 0.6, 0]], 
               StyleBox["^",
                FontColor->RGBColor[0, 0.6, 0]]], "-"], ")"}], "2"]]}], 
         FractionBox[
          SuperscriptBox[
           StyleBox["Q",
            FontColor->RGBColor[0.8, 0, 0]], 
           RowBox[{"[", "2", "]"}]], 
          SuperscriptBox[
           StyleBox["Q",
            FontColor->RGBColor[0.8, 0, 0]], 
           RowBox[{"[", 
            RowBox[{"-", "2"}], "]"}]]], 
         SuperscriptBox[
          RowBox[{"(", 
           FractionBox[
            SuperscriptBox[
             StyleBox["Rm",
              FontColor->RGBColor[0, 0.6, 0]], "-"], 
            SuperscriptBox[
             StyleBox["Bp",
              FontColor->RGBColor[0, 0.6, 0]], "+"]], ")"}], "2"]}]], "/.", 
       "subFunsBethe"}], "/.", "largevolume"}], "/.", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"x$", "[", 
        RowBox[{"a_", "/;", 
         RowBox[{"a", "\[NotEqual]", "0"}]}], "]"}], "\[RuleDelayed]", 
       SuperscriptBox[
        RowBox[{"(", 
         RowBox[{"x$h", "[", "a", "]"}], ")"}], 
        RowBox[{"Sign", "[", "a", "]"}]]}], "}"}]}], "/.", "subJuk"}], "/.", 
   RowBox[{
    SubscriptBox["v", "0"], "\[Rule]", "u"}]}], "//", "Simplify"}]], "Input",
 CellChangeTimes->{{3.553855827166157*^9, 3.553855887374506*^9}, {
   3.5538559458439693`*^9, 3.553855949463842*^9}, 3.553856352567884*^9}],

Cell[BoxData["1"], "Output",
 CellChangeTimes->{{3.553855935965232*^9, 3.553855985085361*^9}, 
   3.5538563535891647`*^9}]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell["Computation", "Subsubsection",
 CellChangeTimes->{{3.553855446757505*^9, 3.55385546238708*^9}, {
  3.553855792502201*^9, 3.5538558082856817`*^9}, {3.553855872203292*^9, 
  3.5538558750269737`*^9}, {3.5538559743912487`*^9, 3.55385598394341*^9}, {
  3.553857213664936*^9, 3.553857214822381*^9}}],

Cell[TextData[{
 "So conclusion is that we can replace ",
 Cell[BoxData[
  FormBox[
   SubscriptBox["\[Phi]", "as"], TraditionalForm]],
  FormatType->"TraditionalForm"],
 " with ",
 Cell[BoxData[
  FormBox[
   SubsuperscriptBox["\[Phi]", "as", "BS"], TraditionalForm]],
  FormatType->"TraditionalForm"],
 ", coming from Beisert-Staudacher Bethe equations. We will use this \
possibility. The logic is simple then"
}], "Text",
 CellChangeTimes->{{3.553855990038924*^9, 3.55385612296103*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    SubscriptBox["\[Phi]", "as"], "[", 
    RowBox[{
     SubscriptBox["v", 
      RowBox[{"0", ",", "asym"}]], "+", 
     RowBox[{
      SuperscriptBox["g", "8"], 
      SubscriptBox["\[Delta]v", "lead"]}], "+", 
     RowBox[{
      SuperscriptBox["g", "10"], 
      SubscriptBox["\[Delta]v", "sublead"]}]}], "]"}], "+", 
   RowBox[{
    SuperscriptBox["g", "8"], "m"}], "+", 
   RowBox[{
    SuperscriptBox["g", "10"], "m2"}]}], "\[Equal]", "0"}]], "Input",
 CellChangeTimes->{{3.553856126875071*^9, 3.5538561750909643`*^9}, {
  3.553856227744954*^9, 3.553856245558978*^9}}],

Cell[TextData[{
 "By construction m and m2 are numbers (not something like ",
 Cell[BoxData[
  FormBox[
   RowBox[{"m", "[", 
    SubscriptBox["v", "0"], "]"}], TraditionalForm]],
  FormatType->"TraditionalForm"],
 " which should be expanded in g and affect m2). By expanding ",
 Cell[BoxData[
  FormBox[
   SubscriptBox["\[Phi]", "as"], TraditionalForm]],
  FormatType->"TraditionalForm"],
 ", we get equation to fix ",
 Cell[BoxData[
  SubscriptBox["\[Delta]v", "lead"]],
  CellChangeTimes->{{3.553856126875071*^9, 3.5538561750909643`*^9}, {
   3.553856227744954*^9, 3.5538562300168324`*^9}}],
 " and ",
 Cell[BoxData[
  SubscriptBox["\[Delta]v", "sublead"]],
  CellChangeTimes->{{3.553856126875071*^9, 3.5538561750909643`*^9}, {
   3.553856227744954*^9, 3.5538562300168324`*^9}}],
 "."
}], "Text",
 CellChangeTimes->{{3.553856163735778*^9, 3.5538562918516483`*^9}}],

Cell["Now we implement this idea", "Text",
 CellChangeTimes->{{3.553856302297908*^9, 3.553856306513937*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"\[CapitalLambda]", "=", "7"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"\[Sigma]", "[", 
    RowBox[{"r_", ",", "s_", ",", "n_"}], "]"}], "=", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"-", "2"}], "\[ImaginaryI]"}], ")"}], 
    SuperscriptBox[
     RowBox[{"(", 
      RowBox[{"-", "1"}], ")"}], "n"], 
    RowBox[{"Sin", "[", 
     RowBox[{
      FractionBox["\[Pi]", "2"], 
      RowBox[{"(", 
       RowBox[{"r", "-", "s"}], ")"}]}], "]"}], 
    RowBox[{"Zeta", "[", 
     RowBox[{
      RowBox[{"2", "n"}], "+", "r", "+", "s"}], "]"}], 
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{"Gamma", "[", 
        RowBox[{
         RowBox[{"2", "n"}], "+", "r", "+", "s"}], "]"}], 
       RowBox[{"Gamma", "[", 
        RowBox[{
         RowBox[{"2", "n"}], "+", "r", "+", "s", "+", "1"}], "]"}]}], ")"}], 
     "/", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"Gamma", "[", 
        RowBox[{"n", "+", "1"}], "]"}], 
       RowBox[{"Gamma", "[", 
        RowBox[{"n", "+", "r", "+", "1"}], "]"}], 
       RowBox[{"Gamma", "[", 
        RowBox[{"n", "+", "s", "+", "1"}], "]"}], 
       RowBox[{"Gamma", "[", 
        RowBox[{"n", "+", "r", "+", "s", "+", "1"}], "]"}]}], ")"}]}]}]}], 
  ";"}]}], "Input",
 CellChangeTimes->{{3.552351851435109*^9, 3.552351867508997*^9}, {
   3.5523519179094667`*^9, 3.5523519181706333`*^9}, {3.5538566015442667`*^9, 
   3.5538566028794518`*^9}, {3.553857217554524*^9, 3.5538572179112864`*^9}, {
   3.553857279633211*^9, 3.553857297785171*^9}, 3.5559748910158367`*^9}],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"Series", "[", 
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"Log", "[", 
          RowBox[{
           SuperscriptBox[
            RowBox[{"(", 
             FractionBox[
              RowBox[{"xh", "[", 
               RowBox[{"+", "1"}], "]"}], 
              RowBox[{"xh", "[", 
               RowBox[{"-", "1"}], "]"}]], ")"}], "2"], 
           FractionBox[
            RowBox[{"u", "+", 
             FractionBox["\[ImaginaryI]", "2"]}], 
            RowBox[{"u", "-", 
             FractionBox["\[ImaginaryI]", "2"]}]], 
           SuperscriptBox[
            RowBox[{"(", 
             FractionBox[
              RowBox[{"1", "+", 
               FractionBox["1", 
                RowBox[{
                 RowBox[{"xh", "[", 
                  RowBox[{"-", "1"}], "]"}], 
                 RowBox[{"xh", "[", 
                  RowBox[{"-", "1"}], "]"}], " "}]]}], 
              RowBox[{"1", "+", 
               FractionBox["1", 
                RowBox[{
                 RowBox[{"xh", "[", 
                  RowBox[{"+", "1"}], "]"}], 
                 RowBox[{"xh", "[", 
                  RowBox[{"+", "1"}], "]"}]}]]}]], ")"}], "2"]}], "]"}], ",", 
         
         RowBox[{"Sum", "[", 
          RowBox[{
           RowBox[{"2", " ", 
            SuperscriptBox["g", 
             RowBox[{"r", "+", "s", "+", 
              RowBox[{"2", "n"}]}]], 
            RowBox[{"\[Sigma]", "[", 
             RowBox[{"r", ",", "s", ",", "n"}], "]"}], 
            RowBox[{"(", 
             RowBox[{
              FractionBox["1", 
               SuperscriptBox[
                RowBox[{"xh", "[", "1", "]"}], "r"]], "-", 
              FractionBox["1", 
               SuperscriptBox[
                RowBox[{"xh", "[", 
                 RowBox[{"-", "1"}], "]"}], "r"]]}], ")"}], 
            RowBox[{"(", 
             RowBox[{
              FractionBox["1", 
               SuperscriptBox[
                RowBox[{"xh", "[", "1", "]"}], "s"]], "-", 
              FractionBox["1", 
               SuperscriptBox[
                RowBox[{"xh", "[", 
                 RowBox[{"-", "1"}], "]"}], "s"]]}], ")"}], 
            RowBox[{"(", 
             RowBox[{"1", "-", 
              SuperscriptBox[
               RowBox[{"(", 
                RowBox[{"-", "1"}], ")"}], "s"]}], ")"}]}], ",", 
           RowBox[{"{", 
            RowBox[{"r", ",", "1", ",", "\[CapitalLambda]", ",", "1"}], "}"}],
            ",", 
           RowBox[{"{", 
            RowBox[{"s", ",", "1", ",", "\[CapitalLambda]", ",", "1"}], "}"}],
            ",", 
           RowBox[{"{", 
            RowBox[{"n", ",", "0", ",", 
             RowBox[{"\[CapitalLambda]", "-", "r", "-", "s"}]}], "}"}]}], 
          "]"}]}], "}"}], "/.", "subJuk"}], "/.", 
      RowBox[{"u", "\[Rule]", 
       RowBox[{
        FractionBox["1", 
         RowBox[{"2", 
          SqrtBox["3"]}]], "+", 
        RowBox[{
         SuperscriptBox["g", "2"], "\[Delta]u"}]}]}]}], ",", 
     RowBox[{"{", 
      RowBox[{"g", ",", "0", ",", 
       RowBox[{"2", " ", "\[CapitalLambda]"}]}], "}"}]}], "]"}], "//", 
   "FullSimplify"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"(", 
    RowBox[{"%", "//", "Total"}], ")"}], "+", 
   RowBox[{
    SuperscriptBox["g", "8"], "m1"}], "+", 
   RowBox[{
    SuperscriptBox["g", "10"], "m2"}], "+", 
   RowBox[{
    SuperscriptBox["g", "12"], "m3"}], "+", 
   RowBox[{
    SuperscriptBox["g", "14"], "m4"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"condition", "=", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{"%", "/.", 
      RowBox[{"\[Delta]u", "->", 
       RowBox[{"Sum", "[", 
        RowBox[{
         RowBox[{
          SubscriptBox["\[Lambda]", 
           RowBox[{"i", "+", "2"}]], 
          SuperscriptBox["g", 
           RowBox[{"2", "i"}]]}], ",", 
         RowBox[{"{", 
          RowBox[{"i", ",", "0", ",", "\[CapitalLambda]"}], "}"}]}], 
        "]"}]}]}], ")"}], "[", 
    RowBox[{"[", "3", "]"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"bethesolut", "=", 
  RowBox[{
   RowBox[{
    RowBox[{"Solve", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"DeleteCases", "[", 
        RowBox[{"condition", ",", "0"}], "]"}], "\[Equal]", "0"}], ",", 
      RowBox[{"Table", "[", 
       RowBox[{
        SubscriptBox["\[Lambda]", "i"], ",", 
        RowBox[{"{", 
         RowBox[{"i", ",", "2", ",", 
          RowBox[{"\[CapitalLambda]", "+", "1"}]}], "}"}]}], "]"}]}], "]"}], 
    "[", 
    RowBox[{"[", "1", "]"}], "]"}], "//", "Simplify"}]}]}], "Input",
 CellChangeTimes->{{3.549882547962368*^9, 3.549882568268237*^9}, {
   3.5498826146805162`*^9, 3.5498826276815577`*^9}, {3.552351879593645*^9, 
   3.5523518811873083`*^9}, {3.552351933551113*^9, 3.552351946983827*^9}, {
   3.552352065485135*^9, 3.552352066684208*^9}, {3.553856646637452*^9, 
   3.5538566817785273`*^9}, {3.553857222743487*^9, 3.553857226646655*^9}, {
   3.55385727746134*^9, 3.553857292731312*^9}, 3.555974886571327*^9}],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"Series", "::", "ztest1"}], "MessageName"], 
  RowBox[{
  ":", " "}], "\<\"Unable to decide whether numeric quantity \[NoBreak]\\!\\(\
\\(\\(-\\(\\(46656\\/\\((\\(\\(\\(\\(-3\\)\\)\\\\ \[ImaginaryI]\\)\\) + \\@3)\
\\)\\^6\\)\\)\\)\\) + 46656\\/\\((\\(\\(3\\\\ \[ImaginaryI]\\)\\) + \
\\@3)\\)\\^6\\)\[NoBreak] is equal to zero. Assuming it is. \
\\!\\(\\*ButtonBox[\\\"\[RightSkeleton]\\\", ButtonStyle->\\\"Link\\\", \
ButtonFrame->None, ButtonData:>\\\"paclet:ref/Series\\\", ButtonNote -> \
\\\"Series::ztest1\\\"]\\)\"\>"}]], "Message", "MSG",
 CellChangeTimes->{3.555974908116775*^9}]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"subtmp", "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{
      SubscriptBox["\[Lambda]", "2"], "\[Rule]", 
      FractionBox["4", 
       SqrtBox["3"]]}], ",", 
     RowBox[{
      SubscriptBox["\[Lambda]", "3"], "\[Rule]", 
      RowBox[{"-", 
       FractionBox["10", 
        SqrtBox["3"]]}]}], ",", 
     RowBox[{
      SubscriptBox["\[Lambda]", "4"], "\[Rule]", 
      FractionBox[
       RowBox[{"8", " ", 
        RowBox[{"(", 
         RowBox[{"7", "+", 
          RowBox[{"3", " ", 
           RowBox[{"Zeta", "[", "3", "]"}]}]}], ")"}]}], 
       SqrtBox["3"]]}], ",", 
     RowBox[{
      SubscriptBox["\[Lambda]", "5"], "\[Rule]", 
      RowBox[{
       RowBox[{"-", 
        FractionBox[
         RowBox[{"\[ImaginaryI]", " ", "m1"}], "9"]}], "-", 
       FractionBox[
        RowBox[{"461", "+", 
         RowBox[{"144", " ", 
          RowBox[{"Zeta", "[", "3", "]"}]}], "+", 
         RowBox[{"240", " ", 
          RowBox[{"Zeta", "[", "5", "]"}]}]}], 
        SqrtBox["3"]]}]}], ",", 
     RowBox[{
      SubscriptBox["\[Lambda]", "6"], "\[Rule]", 
      RowBox[{
       RowBox[{"-", 
        FractionBox[
         RowBox[{"4", " ", "\[ImaginaryI]", " ", "m1"}], "9"]}], "-", 
       FractionBox[
        RowBox[{"\[ImaginaryI]", " ", "m2"}], "9"], "+", 
       FractionBox[
        RowBox[{"4", " ", 
         RowBox[{"(", 
          RowBox[{"1133", "+", 
           RowBox[{"252", " ", 
            RowBox[{"Zeta", "[", "3", "]"}]}], "+", 
           RowBox[{"378", " ", 
            RowBox[{"Zeta", "[", "5", "]"}]}], "+", 
           RowBox[{"630", " ", 
            RowBox[{"Zeta", "[", "7", "]"}]}]}], ")"}]}], 
        SqrtBox["3"]]}]}], ",", 
     RowBox[{
      SubscriptBox["\[Lambda]", "7"], "\[Rule]", 
      RowBox[{
       RowBox[{
        RowBox[{"-", "15890"}], " ", 
        SqrtBox["3"]}], "+", 
       RowBox[{"2", " ", "\[ImaginaryI]", " ", "m1"}], "-", 
       FractionBox[
        RowBox[{"4", " ", "\[ImaginaryI]", " ", "m2"}], "9"], "-", 
       FractionBox[
        RowBox[{"\[ImaginaryI]", " ", "m3"}], "9"], "-", 
       RowBox[{"3112", " ", 
        SqrtBox["3"], " ", 
        RowBox[{"Zeta", "[", "3", "]"}]}], "-", 
       RowBox[{"96", " ", 
        SqrtBox["3"], " ", 
        SuperscriptBox[
         RowBox[{"Zeta", "[", "3", "]"}], "2"]}], "-", 
       RowBox[{"3888", " ", 
        SqrtBox["3"], " ", 
        RowBox[{"Zeta", "[", "5", "]"}]}], "-", 
       RowBox[{"5544", " ", 
        SqrtBox["3"], " ", 
        RowBox[{"Zeta", "[", "7", "]"}]}], "-", 
       RowBox[{"9408", " ", 
        SqrtBox["3"], " ", 
        RowBox[{"Zeta", "[", "9", "]"}]}]}]}], ",", 
     RowBox[{
      SubscriptBox["\[Lambda]", "8"], "\[Rule]", 
      RowBox[{
       RowBox[{"172616", " ", 
        SqrtBox["3"]}], "-", 
       RowBox[{"8", " ", "\[ImaginaryI]", " ", "m1"}], "+", 
       RowBox[{"2", " ", "\[ImaginaryI]", " ", "m2"}], "-", 
       FractionBox[
        RowBox[{"4", " ", "\[ImaginaryI]", " ", "m3"}], "9"], "-", 
       FractionBox[
        RowBox[{"\[ImaginaryI]", " ", "m4"}], "9"], "+", 
       RowBox[{"36576", " ", 
        SqrtBox["3"], " ", 
        RowBox[{"Zeta", "[", "3", "]"}]}], "+", 
       RowBox[{"192", " ", 
        SqrtBox["3"], " ", 
        SuperscriptBox[
         RowBox[{"Zeta", "[", "3", "]"}], "2"]}], "+", 
       RowBox[{"38272", " ", 
        SqrtBox["3"], " ", 
        RowBox[{"Zeta", "[", "5", "]"}]}], "+", 
       RowBox[{"1920", " ", 
        SqrtBox["3"], " ", 
        RowBox[{"Zeta", "[", "3", "]"}], " ", 
        RowBox[{"Zeta", "[", "5", "]"}]}], "+", 
       RowBox[{"45648", " ", 
        SqrtBox["3"], " ", 
        RowBox[{"Zeta", "[", "7", "]"}]}], "+", 
       RowBox[{"64512", " ", 
        SqrtBox["3"], " ", 
        RowBox[{"Zeta", "[", "9", "]"}]}], "+", 
       RowBox[{"110880", " ", 
        SqrtBox["3"], " ", 
        RowBox[{"Zeta", "[", "11", "]"}]}]}]}]}], "}"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.560861680563663*^9, 3.560861685150146*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    FractionBox["1", 
     RowBox[{"2", 
      SqrtBox["3"]}]], "+", 
    RowBox[{"Sum", "[", 
     RowBox[{
      RowBox[{
       SuperscriptBox["g", 
        RowBox[{"2", "i"}]], 
       SubscriptBox["\[Lambda]", 
        RowBox[{"i", "+", "1"}]]}], ",", 
      RowBox[{"{", 
       RowBox[{"i", ",", "7"}], "}"}]}], "]"}]}], "/.", "subtmp"}], "/.", 
  RowBox[{
   RowBox[{"Zeta", "[", "r_", "]"}], "\[RuleDelayed]", 
   RowBox[{
    RowBox[{"\[Zeta]$", "[", "r", "]"}], "[", "0", "]"}]}]}]], "Input",
 CellChangeTimes->{{3.560861652740629*^9, 3.560861690198121*^9}, {
  3.560861737044183*^9, 3.560861757499793*^9}}],

Cell[BoxData[
 RowBox[{
  FractionBox["1", 
   RowBox[{"2", " ", 
    SqrtBox["3"]}]], "+", 
  FractionBox[
   RowBox[{"4", " ", 
    SuperscriptBox["g", "2"]}], 
   SqrtBox["3"]], "-", 
  FractionBox[
   RowBox[{"10", " ", 
    SuperscriptBox["g", "4"]}], 
   SqrtBox["3"]], "+", 
  FractionBox[
   RowBox[{"8", " ", 
    SuperscriptBox["g", "6"], " ", 
    RowBox[{"(", 
     RowBox[{"7", "+", 
      RowBox[{"3", " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "3"]}]}], ")"}]}], 
   SqrtBox["3"]], "+", 
  RowBox[{
   SuperscriptBox["g", "8"], " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"-", 
      FractionBox[
       RowBox[{"\[ImaginaryI]", " ", "m1"}], "9"]}], "-", 
     FractionBox[
      RowBox[{"461", "+", 
       RowBox[{"144", " ", 
        SubscriptBox[
         StyleBox["\[Zeta]",
          FontWeight->Bold,
          FontColor->GrayLevel[0.4]], "3"]}], "+", 
       RowBox[{"240", " ", 
        SubscriptBox[
         StyleBox["\[Zeta]",
          FontWeight->Bold,
          FontColor->GrayLevel[0.4]], "5"]}]}], 
      SqrtBox["3"]]}], ")"}]}], "+", 
  RowBox[{
   SuperscriptBox["g", "10"], " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"-", 
      FractionBox[
       RowBox[{"4", " ", "\[ImaginaryI]", " ", "m1"}], "9"]}], "-", 
     FractionBox[
      RowBox[{"\[ImaginaryI]", " ", "m2"}], "9"], "+", 
     FractionBox[
      RowBox[{"4", " ", 
       RowBox[{"(", 
        RowBox[{"1133", "+", 
         RowBox[{"252", " ", 
          SubscriptBox[
           StyleBox["\[Zeta]",
            FontWeight->Bold,
            FontColor->GrayLevel[0.4]], "3"]}], "+", 
         RowBox[{"378", " ", 
          SubscriptBox[
           StyleBox["\[Zeta]",
            FontWeight->Bold,
            FontColor->GrayLevel[0.4]], "5"]}], "+", 
         RowBox[{"630", " ", 
          SubscriptBox[
           StyleBox["\[Zeta]",
            FontWeight->Bold,
            FontColor->GrayLevel[0.4]], "7"]}]}], ")"}]}], 
      SqrtBox["3"]]}], ")"}]}], "+", 
  RowBox[{
   SuperscriptBox["g", "12"], " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{
      RowBox[{"-", "15890"}], " ", 
      SqrtBox["3"]}], "+", 
     RowBox[{"2", " ", "\[ImaginaryI]", " ", "m1"}], "-", 
     FractionBox[
      RowBox[{"4", " ", "\[ImaginaryI]", " ", "m2"}], "9"], "-", 
     FractionBox[
      RowBox[{"\[ImaginaryI]", " ", "m3"}], "9"], "-", 
     RowBox[{"3112", " ", 
      SqrtBox["3"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3"]}], "-", 
     RowBox[{"96", " ", 
      SqrtBox["3"], " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3", "2"]}], "-", 
     RowBox[{"3888", " ", 
      SqrtBox["3"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "5"]}], "-", 
     RowBox[{"5544", " ", 
      SqrtBox["3"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "7"]}], "-", 
     RowBox[{"9408", " ", 
      SqrtBox["3"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "9"]}]}], ")"}]}], "+", 
  RowBox[{
   SuperscriptBox["g", "14"], " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"172616", " ", 
      SqrtBox["3"]}], "-", 
     RowBox[{"8", " ", "\[ImaginaryI]", " ", "m1"}], "+", 
     RowBox[{"2", " ", "\[ImaginaryI]", " ", "m2"}], "-", 
     FractionBox[
      RowBox[{"4", " ", "\[ImaginaryI]", " ", "m3"}], "9"], "-", 
     FractionBox[
      RowBox[{"\[ImaginaryI]", " ", "m4"}], "9"], "+", 
     RowBox[{"36576", " ", 
      SqrtBox["3"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3"]}], "+", 
     RowBox[{"192", " ", 
      SqrtBox["3"], " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3", "2"]}], "+", 
     RowBox[{"38272", " ", 
      SqrtBox["3"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "5"]}], "+", 
     RowBox[{"1920", " ", 
      SqrtBox["3"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "5"]}], "+", 
     RowBox[{"45648", " ", 
      SqrtBox["3"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "7"]}], "+", 
     RowBox[{"64512", " ", 
      SqrtBox["3"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "9"]}], "+", 
     RowBox[{"110880", " ", 
      SqrtBox["3"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "11"]}]}], ")"}]}]}]], "Output",
 CellChangeTimes->{{3.560861671737558*^9, 3.560861690823572*^9}, {
  3.560861743145677*^9, 3.5608617580167627`*^9}}]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    FractionBox["1", 
     RowBox[{"2", " ", 
      SqrtBox["3"]}]], "+", 
    FractionBox[
     RowBox[{"4", " ", 
      SuperscriptBox["g", "2"]}], 
     SqrtBox["3"]], "-", 
    FractionBox[
     RowBox[{"10", " ", 
      SuperscriptBox["g", "4"]}], 
     SqrtBox["3"]], "+", 
    FractionBox[
     RowBox[{"8", " ", 
      SuperscriptBox["g", "6"], " ", 
      RowBox[{"(", 
       RowBox[{"7", "+", 
        RowBox[{"3", " ", 
         SubscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "3"]}]}], ")"}]}], 
     SqrtBox["3"]], "+", 
    RowBox[{
     SuperscriptBox["g", "8"], " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"-", 
        FractionBox[
         RowBox[{"\[ImaginaryI]", " ", "m1"}], "9"]}], "-", 
       FractionBox[
        RowBox[{"461", "+", 
         RowBox[{"144", " ", 
          SubscriptBox[
           StyleBox["\[Zeta]",
            FontWeight->Bold,
            FontColor->GrayLevel[0.4]], "3"]}], "+", 
         RowBox[{"240", " ", 
          SubscriptBox[
           StyleBox["\[Zeta]",
            FontWeight->Bold,
            FontColor->GrayLevel[0.4]], "5"]}]}], 
        SqrtBox["3"]]}], ")"}]}], "+", 
    RowBox[{
     SuperscriptBox["g", "10"], " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"-", 
        FractionBox[
         RowBox[{"4", " ", "\[ImaginaryI]", " ", "m1"}], "9"]}], "-", 
       FractionBox[
        RowBox[{"\[ImaginaryI]", " ", "m2"}], "9"], "+", 
       FractionBox[
        RowBox[{"4", " ", 
         RowBox[{"(", 
          RowBox[{"1133", "+", 
           RowBox[{"252", " ", 
            SubscriptBox[
             StyleBox["\[Zeta]",
              FontWeight->Bold,
              FontColor->GrayLevel[0.4]], "3"]}], "+", 
           RowBox[{"378", " ", 
            SubscriptBox[
             StyleBox["\[Zeta]",
              FontWeight->Bold,
              FontColor->GrayLevel[0.4]], "5"]}], "+", 
           RowBox[{"630", " ", 
            SubscriptBox[
             StyleBox["\[Zeta]",
              FontWeight->Bold,
              FontColor->GrayLevel[0.4]], "7"]}]}], ")"}]}], 
        SqrtBox["3"]]}], ")"}]}], "+", 
    RowBox[{
     SuperscriptBox["g", "12"], " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{
        RowBox[{"-", "15890"}], " ", 
        SqrtBox["3"]}], "+", 
       RowBox[{"2", " ", "\[ImaginaryI]", " ", "m1"}], "-", 
       FractionBox[
        RowBox[{"4", " ", "\[ImaginaryI]", " ", "m2"}], "9"], "-", 
       FractionBox[
        RowBox[{"\[ImaginaryI]", " ", "m3"}], "9"], "-", 
       RowBox[{"3112", " ", 
        SqrtBox["3"], " ", 
        SubscriptBox[
         StyleBox["\[Zeta]",
          FontWeight->Bold,
          FontColor->GrayLevel[0.4]], "3"]}], "-", 
       RowBox[{"96", " ", 
        SqrtBox["3"], " ", 
        SubsuperscriptBox[
         StyleBox["\[Zeta]",
          FontWeight->Bold,
          FontColor->GrayLevel[0.4]], "3", "2"]}], "-", 
       RowBox[{"3888", " ", 
        SqrtBox["3"], " ", 
        SubscriptBox[
         StyleBox["\[Zeta]",
          FontWeight->Bold,
          FontColor->GrayLevel[0.4]], "5"]}], "-", 
       RowBox[{"5544", " ", 
        SqrtBox["3"], " ", 
        SubscriptBox[
         StyleBox["\[Zeta]",
          FontWeight->Bold,
          FontColor->GrayLevel[0.4]], "7"]}], "-", 
       RowBox[{"9408", " ", 
        SqrtBox["3"], " ", 
        SubscriptBox[
         StyleBox["\[Zeta]",
          FontWeight->Bold,
          FontColor->GrayLevel[0.4]], "9"]}]}], ")"}]}], "+", 
    RowBox[{
     SuperscriptBox["g", "14"], " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"172616", " ", 
        SqrtBox["3"]}], "-", 
       RowBox[{"8", " ", "\[ImaginaryI]", " ", "m1"}], "+", 
       RowBox[{"2", " ", "\[ImaginaryI]", " ", "m2"}], "-", 
       FractionBox[
        RowBox[{"4", " ", "\[ImaginaryI]", " ", "m3"}], "9"], "-", 
       FractionBox[
        RowBox[{"\[ImaginaryI]", " ", "m4"}], "9"], "+", 
       RowBox[{"36576", " ", 
        SqrtBox["3"], " ", 
        SubscriptBox[
         StyleBox["\[Zeta]",
          FontWeight->Bold,
          FontColor->GrayLevel[0.4]], "3"]}], "+", 
       RowBox[{"192", " ", 
        SqrtBox["3"], " ", 
        SubsuperscriptBox[
         StyleBox["\[Zeta]",
          FontWeight->Bold,
          FontColor->GrayLevel[0.4]], "3", "2"]}], "+", 
       RowBox[{"38272", " ", 
        SqrtBox["3"], " ", 
        SubscriptBox[
         StyleBox["\[Zeta]",
          FontWeight->Bold,
          FontColor->GrayLevel[0.4]], "5"]}], "+", 
       RowBox[{"1920", " ", 
        SqrtBox["3"], " ", 
        SubscriptBox[
         StyleBox["\[Zeta]",
          FontWeight->Bold,
          FontColor->GrayLevel[0.4]], "3"], " ", 
        SubscriptBox[
         StyleBox["\[Zeta]",
          FontWeight->Bold,
          FontColor->GrayLevel[0.4]], "5"]}], "+", 
       RowBox[{"45648", " ", 
        SqrtBox["3"], " ", 
        SubscriptBox[
         StyleBox["\[Zeta]",
          FontWeight->Bold,
          FontColor->GrayLevel[0.4]], "7"]}], "+", 
       RowBox[{"64512", " ", 
        SqrtBox["3"], " ", 
        SubscriptBox[
         StyleBox["\[Zeta]",
          FontWeight->Bold,
          FontColor->GrayLevel[0.4]], "9"]}], "+", 
       RowBox[{"110880", " ", 
        SqrtBox["3"], " ", 
        SubscriptBox[
         StyleBox["\[Zeta]",
          FontWeight->Bold,
          FontColor->GrayLevel[0.4]], "11"]}]}], ")"}]}]}], "/.", 
   "subZetas"}], "//", "N"}]], "Input",
 CellChangeTimes->{{3.5619982839725857`*^9, 3.5619982866939163`*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     RowBox[{
      RowBox[{"-", "15890"}], " ", 
      SqrtBox["3"]}], "+", 
     RowBox[{"2", " ", "\[ImaginaryI]", " ", "m1"}], "-", 
     FractionBox[
      RowBox[{"4", " ", "\[ImaginaryI]", " ", "m2"}], "9"], "-", 
     FractionBox[
      RowBox[{"\[ImaginaryI]", " ", "m3"}], "9"], "-", 
     RowBox[{"3112", " ", 
      SqrtBox["3"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3"]}], "-", 
     RowBox[{"96", " ", 
      SqrtBox["3"], " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3", "2"]}], "-", 
     RowBox[{"3888", " ", 
      SqrtBox["3"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "5"]}], "-", 
     RowBox[{"5544", " ", 
      SqrtBox["3"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "7"]}], "-", 
     RowBox[{"9408", " ", 
      SqrtBox["3"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "9"]}]}], ")"}], "/.", "subZetas"}], "//",
   "N"}]], "Input",
 CellChangeTimes->{{3.5619982524564533`*^9, 3.5619982651728067`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"-", "67235.22259594433`"}], "+", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{"0.`", "\[VeryThinSpace]", "+", 
     RowBox[{"2.`", " ", "\[ImaginaryI]"}]}], ")"}], " ", "m1"}], "-", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{"0.`", "\[VeryThinSpace]", "+", 
     RowBox[{"0.4444444444444444`", " ", "\[ImaginaryI]"}]}], ")"}], " ", 
   "m2"}], "-", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{"0.`", "\[VeryThinSpace]", "+", 
     RowBox[{"0.1111111111111111`", " ", "\[ImaginaryI]"}]}], ")"}], " ", 
   "m3"}]}]], "Output",
 CellChangeTimes->{{3.561998257068622*^9, 3.561998265603629*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    SuperscriptBox["g", "14"], " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"172616", " ", 
       SqrtBox["3"]}], "-", 
      RowBox[{"8", " ", "\[ImaginaryI]", " ", "m1"}], "+", 
      RowBox[{"2", " ", "\[ImaginaryI]", " ", "m2"}], "-", 
      FractionBox[
       RowBox[{"4", " ", "\[ImaginaryI]", " ", "m3"}], "9"], "-", 
      FractionBox[
       RowBox[{"\[ImaginaryI]", " ", "m4"}], "9"], "+", 
      RowBox[{"36576", " ", 
       SqrtBox["3"], " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "3"]}], "+", 
      RowBox[{"192", " ", 
       SqrtBox["3"], " ", 
       SubsuperscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "3", "2"]}], "+", 
      RowBox[{"38272", " ", 
       SqrtBox["3"], " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "5"]}], "+", 
      RowBox[{"1920", " ", 
       SqrtBox["3"], " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "3"], " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "5"]}], "+", 
      RowBox[{"45648", " ", 
       SqrtBox["3"], " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "7"]}], "+", 
      RowBox[{"64512", " ", 
       SqrtBox["3"], " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "9"]}], "+", 
      RowBox[{"110880", " ", 
       SqrtBox["3"], " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "11"]}]}], ")"}]}], "/.", "subZetas"}], "//",
   "N"}]], "Input",
 CellChangeTimes->{{3.561998225016214*^9, 3.561998230255763*^9}}],

Cell[BoxData[
 RowBox[{
  SuperscriptBox["g", "14"], " ", 
  RowBox[{"(", 
   RowBox[{"832326.322746783`", "\[VeryThinSpace]", "-", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{"0.`", "\[VeryThinSpace]", "+", 
       RowBox[{"8.`", " ", "\[ImaginaryI]"}]}], ")"}], " ", "m1"}], "+", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{"0.`", "\[VeryThinSpace]", "+", 
       RowBox[{"2.`", " ", "\[ImaginaryI]"}]}], ")"}], " ", "m2"}], "-", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{"0.`", "\[VeryThinSpace]", "+", 
       RowBox[{"0.4444444444444444`", " ", "\[ImaginaryI]"}]}], ")"}], " ", 
     "m3"}], "-", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{"0.`", "\[VeryThinSpace]", "+", 
       RowBox[{"0.1111111111111111`", " ", "\[ImaginaryI]"}]}], ")"}], " ", 
     "m4"}]}], ")"}]}]], "Output",
 CellChangeTimes->{3.561998230782606*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Collect", "[", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"-", 
      FractionBox[
       RowBox[{"\[ImaginaryI]", " ", "m1"}], "9"]}], "-", 
     FractionBox[
      RowBox[{"461", "+", 
       RowBox[{"144", " ", 
        SubscriptBox[
         StyleBox["\[Zeta]",
          FontWeight->Bold,
          FontColor->GrayLevel[0.4]], "3"]}], "+", 
       RowBox[{"240", " ", 
        SubscriptBox[
         StyleBox["\[Zeta]",
          FontWeight->Bold,
          FontColor->GrayLevel[0.4]], "5"]}]}], 
      SqrtBox["3"]]}], "/.", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"m1", "\[Rule]", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"manal", "[", 
          RowBox[{"[", "1", "]"}], "]"}], "/.", 
         RowBox[{"g", "\[Rule]", "1"}]}], ")"}]}], ",", 
      RowBox[{"m2", "->", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"manal", "[", 
          RowBox[{"[", "2", "]"}], "]"}], "/.", 
         RowBox[{"g", "\[Rule]", "1"}]}], ")"}]}]}], "}"}]}], ",", 
   RowBox[{"{", 
    RowBox[{
     SqrtBox["3"], ",", 
     SubscriptBox["\[Zeta]", "_"]}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{3.560861901436336*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"-", "216"}], " ", "\[ImaginaryI]", " ", 
   SubsuperscriptBox[
    StyleBox["\[Zeta]",
     FontWeight->Bold,
     FontColor->GrayLevel[0.4]], "2", "2"]}], "-", 
  RowBox[{"108", " ", "\[ImaginaryI]", " ", 
   SuperscriptBox[
    RowBox[{"(", 
     SubsuperscriptBox[
      StyleBox["\[Eta]0",
       FontWeight->Bold,
       FontColor->RGBColor[0, 0.5, 0]], "1", "+"], ")"}], "2"]}], "-", 
  RowBox[{"18", " ", "\[ImaginaryI]", " ", 
   SuperscriptBox[
    RowBox[{"(", 
     SubsuperscriptBox[
      StyleBox["\[Eta]0",
       FontWeight->Bold,
       FontColor->RGBColor[0, 0.5, 0]], "1", "+"], ")"}], "4"]}], "+", 
  RowBox[{"216", " ", "\[ImaginaryI]", " ", 
   SubsuperscriptBox[
    StyleBox["\[Eta]0",
     FontWeight->Bold,
     FontColor->RGBColor[0, 0.5, 0]], "2", "+"]}], "+", 
  RowBox[{"36", " ", "\[ImaginaryI]", " ", 
   SubsuperscriptBox[
    StyleBox["\[Eta]0",
     FontWeight->Bold,
     FontColor->RGBColor[0, 0.5, 0]], "4", "+"]}], "-", 
  RowBox[{"216", " ", "\[ImaginaryI]", " ", 
   SubsuperscriptBox[
    StyleBox["\[Eta]0",
     FontWeight->Bold,
     FontColor->RGBColor[0, 0.5, 0]], "1", "+"], " ", 
   SubsuperscriptBox[
    OverscriptBox[
     StyleBox["\[Eta]0",
      FontWeight->Bold,
      FontColor->RGBColor[0, 0.5, 0]], 
     StyleBox["_",
      FontWeight->Bold,
      FontColor->RGBColor[0, 0.5, 0]]], "1", "-"]}], "-", 
  RowBox[{"72", " ", "\[ImaginaryI]", " ", 
   SuperscriptBox[
    RowBox[{"(", 
     SubsuperscriptBox[
      StyleBox["\[Eta]0",
       FontWeight->Bold,
       FontColor->RGBColor[0, 0.5, 0]], "1", "+"], ")"}], "3"], " ", 
   SubsuperscriptBox[
    OverscriptBox[
     StyleBox["\[Eta]0",
      FontWeight->Bold,
      FontColor->RGBColor[0, 0.5, 0]], 
     StyleBox["_",
      FontWeight->Bold,
      FontColor->RGBColor[0, 0.5, 0]]], "1", "-"]}], "-", 
  RowBox[{"108", " ", "\[ImaginaryI]", " ", 
   SuperscriptBox[
    RowBox[{"(", 
     SubsuperscriptBox[
      OverscriptBox[
       StyleBox["\[Eta]0",
        FontWeight->Bold,
        FontColor->RGBColor[0, 0.5, 0]], 
       StyleBox["_",
        FontWeight->Bold,
        FontColor->RGBColor[0, 0.5, 0]]], "1", "-"], ")"}], "2"]}], "-", 
  RowBox[{"108", " ", "\[ImaginaryI]", " ", 
   SuperscriptBox[
    RowBox[{"(", 
     SubsuperscriptBox[
      StyleBox["\[Eta]0",
       FontWeight->Bold,
       FontColor->RGBColor[0, 0.5, 0]], "1", "+"], ")"}], "2"], " ", 
   SuperscriptBox[
    RowBox[{"(", 
     SubsuperscriptBox[
      OverscriptBox[
       StyleBox["\[Eta]0",
        FontWeight->Bold,
        FontColor->RGBColor[0, 0.5, 0]], 
       StyleBox["_",
        FontWeight->Bold,
        FontColor->RGBColor[0, 0.5, 0]]], "1", "-"], ")"}], "2"]}], "-", 
  RowBox[{"72", " ", "\[ImaginaryI]", " ", 
   SubsuperscriptBox[
    StyleBox["\[Eta]0",
     FontWeight->Bold,
     FontColor->RGBColor[0, 0.5, 0]], "1", "+"], " ", 
   SuperscriptBox[
    RowBox[{"(", 
     SubsuperscriptBox[
      OverscriptBox[
       StyleBox["\[Eta]0",
        FontWeight->Bold,
        FontColor->RGBColor[0, 0.5, 0]], 
       StyleBox["_",
        FontWeight->Bold,
        FontColor->RGBColor[0, 0.5, 0]]], "1", "-"], ")"}], "3"]}], "-", 
  RowBox[{"18", " ", "\[ImaginaryI]", " ", 
   SuperscriptBox[
    RowBox[{"(", 
     SubsuperscriptBox[
      OverscriptBox[
       StyleBox["\[Eta]0",
        FontWeight->Bold,
        FontColor->RGBColor[0, 0.5, 0]], 
       StyleBox["_",
        FontWeight->Bold,
        FontColor->RGBColor[0, 0.5, 0]]], "1", "-"], ")"}], "4"]}], "+", 
  RowBox[{
   SubscriptBox[
    StyleBox["\[Zeta]",
     FontWeight->Bold,
     FontColor->GrayLevel[0.4]], "2"], " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"648", " ", "\[ImaginaryI]"}], "+", 
     RowBox[{"144", " ", "\[ImaginaryI]", " ", 
      SuperscriptBox[
       RowBox[{"(", 
        SubsuperscriptBox[
         StyleBox["\[Eta]0",
          FontWeight->Bold,
          FontColor->RGBColor[0, 0.5, 0]], "1", "+"], ")"}], "2"]}], "+", 
     RowBox[{"288", " ", "\[ImaginaryI]", " ", 
      SubsuperscriptBox[
       StyleBox["\[Eta]0",
        FontWeight->Bold,
        FontColor->RGBColor[0, 0.5, 0]], "1", "+"], " ", 
      SubsuperscriptBox[
       OverscriptBox[
        StyleBox["\[Eta]0",
         FontWeight->Bold,
         FontColor->RGBColor[0, 0.5, 0]], 
        StyleBox["_",
         FontWeight->Bold,
         FontColor->RGBColor[0, 0.5, 0]]], "1", "-"]}], "+", 
     RowBox[{"144", " ", "\[ImaginaryI]", " ", 
      SuperscriptBox[
       RowBox[{"(", 
        SubsuperscriptBox[
         OverscriptBox[
          StyleBox["\[Eta]0",
           FontWeight->Bold,
           FontColor->RGBColor[0, 0.5, 0]], 
          StyleBox["_",
           FontWeight->Bold,
           FontColor->RGBColor[0, 0.5, 0]]], "1", "-"], ")"}], "2"]}]}], 
    ")"}]}], "+", 
  RowBox[{
   SqrtBox["3"], " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"-", 
      FractionBox["596", "3"]}], "-", 
     RowBox[{"120", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3"]}], "-", 
     RowBox[{"160", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "5"]}], "+", 
     RowBox[{"36", " ", "\[ImaginaryI]", " ", 
      SuperscriptBox[
       RowBox[{"(", 
        SubsuperscriptBox[
         StyleBox["\[Eta]0",
          FontWeight->Bold,
          FontColor->RGBColor[0, 0.5, 0]], "1", "+"], ")"}], "3"]}], "-", 
     RowBox[{"72", " ", "\[ImaginaryI]", " ", 
      SubsuperscriptBox[
       StyleBox["\[Eta]0",
        FontWeight->Bold,
        FontColor->RGBColor[0, 0.5, 0]], "3", "+"]}], "+", 
     RowBox[{
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2"], " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         RowBox[{"-", "216"}], " ", "\[ImaginaryI]", " ", 
         SubsuperscriptBox[
          StyleBox["\[Eta]0",
           FontWeight->Bold,
           FontColor->RGBColor[0, 0.5, 0]], "1", "+"]}], "-", 
        RowBox[{"216", " ", "\[ImaginaryI]", " ", 
         SubsuperscriptBox[
          OverscriptBox[
           StyleBox["\[Eta]0",
            FontWeight->Bold,
            FontColor->RGBColor[0, 0.5, 0]], 
           StyleBox["_",
            FontWeight->Bold,
            FontColor->RGBColor[0, 0.5, 0]]], "1", "-"]}]}], ")"}]}], "+", 
     RowBox[{"108", " ", "\[ImaginaryI]", " ", 
      SuperscriptBox[
       RowBox[{"(", 
        SubsuperscriptBox[
         StyleBox["\[Eta]0",
          FontWeight->Bold,
          FontColor->RGBColor[0, 0.5, 0]], "1", "+"], ")"}], "2"], " ", 
      SubsuperscriptBox[
       OverscriptBox[
        StyleBox["\[Eta]0",
         FontWeight->Bold,
         FontColor->RGBColor[0, 0.5, 0]], 
        StyleBox["_",
         FontWeight->Bold,
         FontColor->RGBColor[0, 0.5, 0]]], "1", "-"]}], "+", 
     RowBox[{"108", " ", "\[ImaginaryI]", " ", 
      SubsuperscriptBox[
       StyleBox["\[Eta]0",
        FontWeight->Bold,
        FontColor->RGBColor[0, 0.5, 0]], "1", "+"], " ", 
      SuperscriptBox[
       RowBox[{"(", 
        SubsuperscriptBox[
         OverscriptBox[
          StyleBox["\[Eta]0",
           FontWeight->Bold,
           FontColor->RGBColor[0, 0.5, 0]], 
          StyleBox["_",
           FontWeight->Bold,
           FontColor->RGBColor[0, 0.5, 0]]], "1", "-"], ")"}], "2"]}], "+", 
     RowBox[{"36", " ", "\[ImaginaryI]", " ", 
      SuperscriptBox[
       RowBox[{"(", 
        SubsuperscriptBox[
         OverscriptBox[
          StyleBox["\[Eta]0",
           FontWeight->Bold,
           FontColor->RGBColor[0, 0.5, 0]], 
          StyleBox["_",
           FontWeight->Bold,
           FontColor->RGBColor[0, 0.5, 0]]], "1", "-"], ")"}], "3"]}]}], 
    ")"}]}]}]], "Output",
 CellChangeTimes->{3.5608619019655533`*^9}]
}, Open  ]],

Cell[BoxData[""], "Input",
 CellChangeTimes->{{3.56086192916151*^9, 3.560861929850512*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Collect", "[", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"-", 
      FractionBox[
       RowBox[{"4", " ", "\[ImaginaryI]", " ", "m1"}], "9"]}], "-", 
     FractionBox[
      RowBox[{"\[ImaginaryI]", " ", "m2"}], "9"], "+", 
     FractionBox[
      RowBox[{"4", " ", 
       RowBox[{"(", 
        RowBox[{"1133", "+", 
         RowBox[{"252", " ", 
          SubscriptBox[
           StyleBox["\[Zeta]",
            FontWeight->Bold,
            FontColor->GrayLevel[0.4]], "3"]}], "+", 
         RowBox[{"378", " ", 
          SubscriptBox[
           StyleBox["\[Zeta]",
            FontWeight->Bold,
            FontColor->GrayLevel[0.4]], "5"]}], "+", 
         RowBox[{"630", " ", 
          SubscriptBox[
           StyleBox["\[Zeta]",
            FontWeight->Bold,
            FontColor->GrayLevel[0.4]], "7"]}]}], ")"}]}], 
      SqrtBox["3"]]}], "/.", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"m1", "\[Rule]", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"manal", "[", 
          RowBox[{"[", "1", "]"}], "]"}], "/.", 
         RowBox[{"g", "\[Rule]", "1"}]}], ")"}]}], ",", 
      RowBox[{"m2", "->", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"manal", "[", 
          RowBox[{"[", "2", "]"}], "]"}], "/.", 
         RowBox[{"g", "\[Rule]", "1"}]}], ")"}]}]}], "}"}]}], ",", 
   RowBox[{"{", 
    RowBox[{
     SqrtBox["3"], ",", 
     SubscriptBox["\[Zeta]", "_"]}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.560861723965884*^9, 3.560861733656105*^9}, {
  3.560861789508957*^9, 3.5608618045491343`*^9}, {3.5608618406400423`*^9, 
  3.560861877257656*^9}}],

Cell[BoxData[
 RowBox[{
  FractionBox[
   RowBox[{"10368", " ", "\[ImaginaryI]", " ", 
    SubsuperscriptBox[
     StyleBox["\[Zeta]",
      FontWeight->Bold,
      FontColor->GrayLevel[0.4]], "2", "3"]}], "5"], "+", 
  RowBox[{"1296", " ", "\[ImaginaryI]", " ", 
   SuperscriptBox[
    RowBox[{"(", 
     SubsuperscriptBox[
      StyleBox["\[Eta]0",
       FontWeight->Bold,
       FontColor->RGBColor[0, 0.5, 0]], "1", "+"], ")"}], "2"]}], "+", 
  RowBox[{"648", " ", 
   SuperscriptBox[
    RowBox[{"(", 
     SubsuperscriptBox[
      StyleBox["\[Eta]0",
       FontWeight->Bold,
       FontColor->RGBColor[0, 0.5, 0]], "1", "+"], ")"}], "3"]}], "-", 
  RowBox[{"504", " ", "\[ImaginaryI]", " ", 
   SuperscriptBox[
    RowBox[{"(", 
     SubsuperscriptBox[
      StyleBox["\[Eta]0",
       FontWeight->Bold,
       FontColor->RGBColor[0, 0.5, 0]], "1", "+"], ")"}], "4"]}], "+", 
  RowBox[{"108", " ", 
   SuperscriptBox[
    RowBox[{"(", 
     SubsuperscriptBox[
      StyleBox["\[Eta]0",
       FontWeight->Bold,
       FontColor->RGBColor[0, 0.5, 0]], "1", "+"], ")"}], "5"]}], "-", 
  RowBox[{"72", " ", "\[ImaginaryI]", " ", 
   SuperscriptBox[
    RowBox[{"(", 
     SubsuperscriptBox[
      StyleBox["\[Eta]0",
       FontWeight->Bold,
       FontColor->RGBColor[0, 0.5, 0]], "1", "+"], ")"}], "6"]}], "-", 
  RowBox[{"2592", " ", "\[ImaginaryI]", " ", 
   SubsuperscriptBox[
    StyleBox["\[Eta]0",
     FontWeight->Bold,
     FontColor->RGBColor[0, 0.5, 0]], "2", "+"]}], "-", 
  RowBox[{"1296", " ", 
   SubsuperscriptBox[
    StyleBox["\[Eta]0",
     FontWeight->Bold,
     FontColor->RGBColor[0, 0.5, 0]], "1", "+"], " ", 
   SubsuperscriptBox[
    StyleBox["\[Eta]0",
     FontWeight->Bold,
     FontColor->RGBColor[0, 0.5, 0]], "2", "+"]}], "+", 
  RowBox[{"1008", " ", "\[ImaginaryI]", " ", 
   SubsuperscriptBox[
    StyleBox["\[Eta]0",
     FontWeight->Bold,
     FontColor->RGBColor[0, 0.5, 0]], "4", "+"]}], "-", 
  RowBox[{"216", " ", 
   SubsuperscriptBox[
    StyleBox["\[Eta]0",
     FontWeight->Bold,
     FontColor->RGBColor[0, 0.5, 0]], "1", "+"], " ", 
   SubsuperscriptBox[
    StyleBox["\[Eta]0",
     FontWeight->Bold,
     FontColor->RGBColor[0, 0.5, 0]], "4", "+"]}], "+", 
  RowBox[{"144", " ", "\[ImaginaryI]", " ", 
   SubsuperscriptBox[
    StyleBox["\[Eta]0",
     FontWeight->Bold,
     FontColor->RGBColor[0, 0.5, 0]], "6", "+"]}], "+", 
  RowBox[{"2592", " ", "\[ImaginaryI]", " ", 
   SubsuperscriptBox[
    StyleBox["\[Eta]0",
     FontWeight->Bold,
     FontColor->RGBColor[0, 0.5, 0]], "1", "+"], " ", 
   SubsuperscriptBox[
    OverscriptBox[
     StyleBox["\[Eta]0",
      FontWeight->Bold,
      FontColor->RGBColor[0, 0.5, 0]], 
     StyleBox["_",
      FontWeight->Bold,
      FontColor->RGBColor[0, 0.5, 0]]], "1", "-"]}], "+", 
  RowBox[{"648", " ", 
   SuperscriptBox[
    RowBox[{"(", 
     SubsuperscriptBox[
      StyleBox["\[Eta]0",
       FontWeight->Bold,
       FontColor->RGBColor[0, 0.5, 0]], "1", "+"], ")"}], "2"], " ", 
   SubsuperscriptBox[
    OverscriptBox[
     StyleBox["\[Eta]0",
      FontWeight->Bold,
      FontColor->RGBColor[0, 0.5, 0]], 
     StyleBox["_",
      FontWeight->Bold,
      FontColor->RGBColor[0, 0.5, 0]]], "1", "-"]}], "-", 
  RowBox[{"2016", " ", "\[ImaginaryI]", " ", 
   SuperscriptBox[
    RowBox[{"(", 
     SubsuperscriptBox[
      StyleBox["\[Eta]0",
       FontWeight->Bold,
       FontColor->RGBColor[0, 0.5, 0]], "1", "+"], ")"}], "3"], " ", 
   SubsuperscriptBox[
    OverscriptBox[
     StyleBox["\[Eta]0",
      FontWeight->Bold,
      FontColor->RGBColor[0, 0.5, 0]], 
     StyleBox["_",
      FontWeight->Bold,
      FontColor->RGBColor[0, 0.5, 0]]], "1", "-"]}], "+", 
  RowBox[{"324", " ", 
   SuperscriptBox[
    RowBox[{"(", 
     SubsuperscriptBox[
      StyleBox["\[Eta]0",
       FontWeight->Bold,
       FontColor->RGBColor[0, 0.5, 0]], "1", "+"], ")"}], "4"], " ", 
   SubsuperscriptBox[
    OverscriptBox[
     StyleBox["\[Eta]0",
      FontWeight->Bold,
      FontColor->RGBColor[0, 0.5, 0]], 
     StyleBox["_",
      FontWeight->Bold,
      FontColor->RGBColor[0, 0.5, 0]]], "1", "-"]}], "-", 
  RowBox[{"432", " ", "\[ImaginaryI]", " ", 
   SuperscriptBox[
    RowBox[{"(", 
     SubsuperscriptBox[
      StyleBox["\[Eta]0",
       FontWeight->Bold,
       FontColor->RGBColor[0, 0.5, 0]], "1", "+"], ")"}], "5"], " ", 
   SubsuperscriptBox[
    OverscriptBox[
     StyleBox["\[Eta]0",
      FontWeight->Bold,
      FontColor->RGBColor[0, 0.5, 0]], 
     StyleBox["_",
      FontWeight->Bold,
      FontColor->RGBColor[0, 0.5, 0]]], "1", "-"]}], "+", 
  RowBox[{"1296", " ", 
   SubsuperscriptBox[
    StyleBox["\[Eta]0",
     FontWeight->Bold,
     FontColor->RGBColor[0, 0.5, 0]], "2", "+"], " ", 
   SubsuperscriptBox[
    OverscriptBox[
     StyleBox["\[Eta]0",
      FontWeight->Bold,
      FontColor->RGBColor[0, 0.5, 0]], 
     StyleBox["_",
      FontWeight->Bold,
      FontColor->RGBColor[0, 0.5, 0]]], "1", "-"]}], "+", 
  RowBox[{"216", " ", 
   SubsuperscriptBox[
    StyleBox["\[Eta]0",
     FontWeight->Bold,
     FontColor->RGBColor[0, 0.5, 0]], "4", "+"], " ", 
   SubsuperscriptBox[
    OverscriptBox[
     StyleBox["\[Eta]0",
      FontWeight->Bold,
      FontColor->RGBColor[0, 0.5, 0]], 
     StyleBox["_",
      FontWeight->Bold,
      FontColor->RGBColor[0, 0.5, 0]]], "1", "-"]}], "+", 
  RowBox[{"1296", " ", "\[ImaginaryI]", " ", 
   SuperscriptBox[
    RowBox[{"(", 
     SubsuperscriptBox[
      OverscriptBox[
       StyleBox["\[Eta]0",
        FontWeight->Bold,
        FontColor->RGBColor[0, 0.5, 0]], 
       StyleBox["_",
        FontWeight->Bold,
        FontColor->RGBColor[0, 0.5, 0]]], "1", "-"], ")"}], "2"]}], "-", 
  RowBox[{"648", " ", 
   SubsuperscriptBox[
    StyleBox["\[Eta]0",
     FontWeight->Bold,
     FontColor->RGBColor[0, 0.5, 0]], "1", "+"], " ", 
   SuperscriptBox[
    RowBox[{"(", 
     SubsuperscriptBox[
      OverscriptBox[
       StyleBox["\[Eta]0",
        FontWeight->Bold,
        FontColor->RGBColor[0, 0.5, 0]], 
       StyleBox["_",
        FontWeight->Bold,
        FontColor->RGBColor[0, 0.5, 0]]], "1", "-"], ")"}], "2"]}], "-", 
  RowBox[{"3024", " ", "\[ImaginaryI]", " ", 
   SuperscriptBox[
    RowBox[{"(", 
     SubsuperscriptBox[
      StyleBox["\[Eta]0",
       FontWeight->Bold,
       FontColor->RGBColor[0, 0.5, 0]], "1", "+"], ")"}], "2"], " ", 
   SuperscriptBox[
    RowBox[{"(", 
     SubsuperscriptBox[
      OverscriptBox[
       StyleBox["\[Eta]0",
        FontWeight->Bold,
        FontColor->RGBColor[0, 0.5, 0]], 
       StyleBox["_",
        FontWeight->Bold,
        FontColor->RGBColor[0, 0.5, 0]]], "1", "-"], ")"}], "2"]}], "+", 
  RowBox[{"216", " ", 
   SuperscriptBox[
    RowBox[{"(", 
     SubsuperscriptBox[
      StyleBox["\[Eta]0",
       FontWeight->Bold,
       FontColor->RGBColor[0, 0.5, 0]], "1", "+"], ")"}], "3"], " ", 
   SuperscriptBox[
    RowBox[{"(", 
     SubsuperscriptBox[
      OverscriptBox[
       StyleBox["\[Eta]0",
        FontWeight->Bold,
        FontColor->RGBColor[0, 0.5, 0]], 
       StyleBox["_",
        FontWeight->Bold,
        FontColor->RGBColor[0, 0.5, 0]]], "1", "-"], ")"}], "2"]}], "-", 
  RowBox[{"1080", " ", "\[ImaginaryI]", " ", 
   SuperscriptBox[
    RowBox[{"(", 
     SubsuperscriptBox[
      StyleBox["\[Eta]0",
       FontWeight->Bold,
       FontColor->RGBColor[0, 0.5, 0]], "1", "+"], ")"}], "4"], " ", 
   SuperscriptBox[
    RowBox[{"(", 
     SubsuperscriptBox[
      OverscriptBox[
       StyleBox["\[Eta]0",
        FontWeight->Bold,
        FontColor->RGBColor[0, 0.5, 0]], 
       StyleBox["_",
        FontWeight->Bold,
        FontColor->RGBColor[0, 0.5, 0]]], "1", "-"], ")"}], "2"]}], "-", 
  RowBox[{"648", " ", 
   SuperscriptBox[
    RowBox[{"(", 
     SubsuperscriptBox[
      OverscriptBox[
       StyleBox["\[Eta]0",
        FontWeight->Bold,
        FontColor->RGBColor[0, 0.5, 0]], 
       StyleBox["_",
        FontWeight->Bold,
        FontColor->RGBColor[0, 0.5, 0]]], "1", "-"], ")"}], "3"]}], "-", 
  RowBox[{"2016", " ", "\[ImaginaryI]", " ", 
   SubsuperscriptBox[
    StyleBox["\[Eta]0",
     FontWeight->Bold,
     FontColor->RGBColor[0, 0.5, 0]], "1", "+"], " ", 
   SuperscriptBox[
    RowBox[{"(", 
     SubsuperscriptBox[
      OverscriptBox[
       StyleBox["\[Eta]0",
        FontWeight->Bold,
        FontColor->RGBColor[0, 0.5, 0]], 
       StyleBox["_",
        FontWeight->Bold,
        FontColor->RGBColor[0, 0.5, 0]]], "1", "-"], ")"}], "3"]}], "-", 
  RowBox[{"216", " ", 
   SuperscriptBox[
    RowBox[{"(", 
     SubsuperscriptBox[
      StyleBox["\[Eta]0",
       FontWeight->Bold,
       FontColor->RGBColor[0, 0.5, 0]], "1", "+"], ")"}], "2"], " ", 
   SuperscriptBox[
    RowBox[{"(", 
     SubsuperscriptBox[
      OverscriptBox[
       StyleBox["\[Eta]0",
        FontWeight->Bold,
        FontColor->RGBColor[0, 0.5, 0]], 
       StyleBox["_",
        FontWeight->Bold,
        FontColor->RGBColor[0, 0.5, 0]]], "1", "-"], ")"}], "3"]}], "-", 
  RowBox[{"1440", " ", "\[ImaginaryI]", " ", 
   SuperscriptBox[
    RowBox[{"(", 
     SubsuperscriptBox[
      StyleBox["\[Eta]0",
       FontWeight->Bold,
       FontColor->RGBColor[0, 0.5, 0]], "1", "+"], ")"}], "3"], " ", 
   SuperscriptBox[
    RowBox[{"(", 
     SubsuperscriptBox[
      OverscriptBox[
       StyleBox["\[Eta]0",
        FontWeight->Bold,
        FontColor->RGBColor[0, 0.5, 0]], 
       StyleBox["_",
        FontWeight->Bold,
        FontColor->RGBColor[0, 0.5, 0]]], "1", "-"], ")"}], "3"]}], "-", 
  RowBox[{"504", " ", "\[ImaginaryI]", " ", 
   SuperscriptBox[
    RowBox[{"(", 
     SubsuperscriptBox[
      OverscriptBox[
       StyleBox["\[Eta]0",
        FontWeight->Bold,
        FontColor->RGBColor[0, 0.5, 0]], 
       StyleBox["_",
        FontWeight->Bold,
        FontColor->RGBColor[0, 0.5, 0]]], "1", "-"], ")"}], "4"]}], "-", 
  RowBox[{"324", " ", 
   SubsuperscriptBox[
    StyleBox["\[Eta]0",
     FontWeight->Bold,
     FontColor->RGBColor[0, 0.5, 0]], "1", "+"], " ", 
   SuperscriptBox[
    RowBox[{"(", 
     SubsuperscriptBox[
      OverscriptBox[
       StyleBox["\[Eta]0",
        FontWeight->Bold,
        FontColor->RGBColor[0, 0.5, 0]], 
       StyleBox["_",
        FontWeight->Bold,
        FontColor->RGBColor[0, 0.5, 0]]], "1", "-"], ")"}], "4"]}], "-", 
  RowBox[{"1080", " ", "\[ImaginaryI]", " ", 
   SuperscriptBox[
    RowBox[{"(", 
     SubsuperscriptBox[
      StyleBox["\[Eta]0",
       FontWeight->Bold,
       FontColor->RGBColor[0, 0.5, 0]], "1", "+"], ")"}], "2"], " ", 
   SuperscriptBox[
    RowBox[{"(", 
     SubsuperscriptBox[
      OverscriptBox[
       StyleBox["\[Eta]0",
        FontWeight->Bold,
        FontColor->RGBColor[0, 0.5, 0]], 
       StyleBox["_",
        FontWeight->Bold,
        FontColor->RGBColor[0, 0.5, 0]]], "1", "-"], ")"}], "4"]}], "-", 
  RowBox[{"108", " ", 
   SuperscriptBox[
    RowBox[{"(", 
     SubsuperscriptBox[
      OverscriptBox[
       StyleBox["\[Eta]0",
        FontWeight->Bold,
        FontColor->RGBColor[0, 0.5, 0]], 
       StyleBox["_",
        FontWeight->Bold,
        FontColor->RGBColor[0, 0.5, 0]]], "1", "-"], ")"}], "5"]}], "-", 
  RowBox[{"432", " ", "\[ImaginaryI]", " ", 
   SubsuperscriptBox[
    StyleBox["\[Eta]0",
     FontWeight->Bold,
     FontColor->RGBColor[0, 0.5, 0]], "1", "+"], " ", 
   SuperscriptBox[
    RowBox[{"(", 
     SubsuperscriptBox[
      OverscriptBox[
       StyleBox["\[Eta]0",
        FontWeight->Bold,
        FontColor->RGBColor[0, 0.5, 0]], 
       StyleBox["_",
        FontWeight->Bold,
        FontColor->RGBColor[0, 0.5, 0]]], "1", "-"], ")"}], "5"]}], "-", 
  RowBox[{"72", " ", "\[ImaginaryI]", " ", 
   SuperscriptBox[
    RowBox[{"(", 
     SubsuperscriptBox[
      OverscriptBox[
       StyleBox["\[Eta]0",
        FontWeight->Bold,
        FontColor->RGBColor[0, 0.5, 0]], 
       StyleBox["_",
        FontWeight->Bold,
        FontColor->RGBColor[0, 0.5, 0]]], "1", "-"], ")"}], "6"]}], "+", 
  RowBox[{
   SubscriptBox[
    StyleBox["\[Zeta]",
     FontWeight->Bold,
     FontColor->GrayLevel[0.4]], "3"], " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"216", " ", "\[ImaginaryI]", " ", 
      SuperscriptBox[
       RowBox[{"(", 
        SubsuperscriptBox[
         StyleBox["\[Eta]0",
          FontWeight->Bold,
          FontColor->RGBColor[0, 0.5, 0]], "1", "+"], ")"}], "2"]}], "-", 
     RowBox[{"432", " ", "\[ImaginaryI]", " ", 
      SubsuperscriptBox[
       StyleBox["\[Eta]0",
        FontWeight->Bold,
        FontColor->RGBColor[0, 0.5, 0]], "2", "+"]}], "+", 
     RowBox[{"432", " ", "\[ImaginaryI]", " ", 
      SubsuperscriptBox[
       StyleBox["\[Eta]0",
        FontWeight->Bold,
        FontColor->RGBColor[0, 0.5, 0]], "1", "+"], " ", 
      SubsuperscriptBox[
       OverscriptBox[
        StyleBox["\[Eta]0",
         FontWeight->Bold,
         FontColor->RGBColor[0, 0.5, 0]], 
        StyleBox["_",
         FontWeight->Bold,
         FontColor->RGBColor[0, 0.5, 0]]], "1", "-"]}], "+", 
     RowBox[{"216", " ", "\[ImaginaryI]", " ", 
      SuperscriptBox[
       RowBox[{"(", 
        SubsuperscriptBox[
         OverscriptBox[
          StyleBox["\[Eta]0",
           FontWeight->Bold,
           FontColor->RGBColor[0, 0.5, 0]], 
          StyleBox["_",
           FontWeight->Bold,
           FontColor->RGBColor[0, 0.5, 0]]], "1", "-"], ")"}], "2"]}]}], 
    ")"}]}], "+", 
  RowBox[{
   SubsuperscriptBox[
    StyleBox["\[Zeta]",
     FontWeight->Bold,
     FontColor->GrayLevel[0.4]], "2", "2"], " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{
      RowBox[{"-", "6048"}], " ", "\[ImaginaryI]"}], "+", 
     RowBox[{"1296", " ", 
      SubsuperscriptBox[
       StyleBox["\[Eta]0",
        FontWeight->Bold,
        FontColor->RGBColor[0, 0.5, 0]], "1", "+"]}], "-", 
     RowBox[{
      FractionBox["14688", "5"], " ", "\[ImaginaryI]", " ", 
      SuperscriptBox[
       RowBox[{"(", 
        SubsuperscriptBox[
         StyleBox["\[Eta]0",
          FontWeight->Bold,
          FontColor->RGBColor[0, 0.5, 0]], "1", "+"], ")"}], "2"]}], "-", 
     RowBox[{"1296", " ", 
      SubsuperscriptBox[
       OverscriptBox[
        StyleBox["\[Eta]0",
         FontWeight->Bold,
         FontColor->RGBColor[0, 0.5, 0]], 
        StyleBox["_",
         FontWeight->Bold,
         FontColor->RGBColor[0, 0.5, 0]]], "1", "-"]}], "-", 
     RowBox[{
      FractionBox["29376", "5"], " ", "\[ImaginaryI]", " ", 
      SubsuperscriptBox[
       StyleBox["\[Eta]0",
        FontWeight->Bold,
        FontColor->RGBColor[0, 0.5, 0]], "1", "+"], " ", 
      SubsuperscriptBox[
       OverscriptBox[
        StyleBox["\[Eta]0",
         FontWeight->Bold,
         FontColor->RGBColor[0, 0.5, 0]], 
        StyleBox["_",
         FontWeight->Bold,
         FontColor->RGBColor[0, 0.5, 0]]], "1", "-"]}], "-", 
     RowBox[{
      FractionBox["14688", "5"], " ", "\[ImaginaryI]", " ", 
      SuperscriptBox[
       RowBox[{"(", 
        SubsuperscriptBox[
         OverscriptBox[
          StyleBox["\[Eta]0",
           FontWeight->Bold,
           FontColor->RGBColor[0, 0.5, 0]], 
          StyleBox["_",
           FontWeight->Bold,
           FontColor->RGBColor[0, 0.5, 0]]], "1", "-"], ")"}], "2"]}]}], 
    ")"}]}], "+", 
  RowBox[{
   SubscriptBox[
    StyleBox["\[Zeta]",
     FontWeight->Bold,
     FontColor->GrayLevel[0.4]], "2"], " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{
      RowBox[{"-", "7776"}], " ", "\[ImaginaryI]"}], "-", 
     RowBox[{"1296", " ", "\[ImaginaryI]", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3"]}], "-", 
     RowBox[{"3888", " ", 
      SubsuperscriptBox[
       StyleBox["\[Eta]0",
        FontWeight->Bold,
        FontColor->RGBColor[0, 0.5, 0]], "1", "+"]}], "+", 
     RowBox[{"4032", " ", "\[ImaginaryI]", " ", 
      SuperscriptBox[
       RowBox[{"(", 
        SubsuperscriptBox[
         StyleBox["\[Eta]0",
          FontWeight->Bold,
          FontColor->RGBColor[0, 0.5, 0]], "1", "+"], ")"}], "2"]}], "-", 
     RowBox[{"864", " ", 
      SuperscriptBox[
       RowBox[{"(", 
        SubsuperscriptBox[
         StyleBox["\[Eta]0",
          FontWeight->Bold,
          FontColor->RGBColor[0, 0.5, 0]], "1", "+"], ")"}], "3"]}], "+", 
     RowBox[{"864", " ", "\[ImaginaryI]", " ", 
      SuperscriptBox[
       RowBox[{"(", 
        SubsuperscriptBox[
         StyleBox["\[Eta]0",
          FontWeight->Bold,
          FontColor->RGBColor[0, 0.5, 0]], "1", "+"], ")"}], "4"]}], "+", 
     RowBox[{"3888", " ", 
      SubsuperscriptBox[
       OverscriptBox[
        StyleBox["\[Eta]0",
         FontWeight->Bold,
         FontColor->RGBColor[0, 0.5, 0]], 
        StyleBox["_",
         FontWeight->Bold,
         FontColor->RGBColor[0, 0.5, 0]]], "1", "-"]}], "+", 
     RowBox[{"8064", " ", "\[ImaginaryI]", " ", 
      SubsuperscriptBox[
       StyleBox["\[Eta]0",
        FontWeight->Bold,
        FontColor->RGBColor[0, 0.5, 0]], "1", "+"], " ", 
      SubsuperscriptBox[
       OverscriptBox[
        StyleBox["\[Eta]0",
         FontWeight->Bold,
         FontColor->RGBColor[0, 0.5, 0]], 
        StyleBox["_",
         FontWeight->Bold,
         FontColor->RGBColor[0, 0.5, 0]]], "1", "-"]}], "-", 
     RowBox[{"864", " ", 
      SuperscriptBox[
       RowBox[{"(", 
        SubsuperscriptBox[
         StyleBox["\[Eta]0",
          FontWeight->Bold,
          FontColor->RGBColor[0, 0.5, 0]], "1", "+"], ")"}], "2"], " ", 
      SubsuperscriptBox[
       OverscriptBox[
        StyleBox["\[Eta]0",
         FontWeight->Bold,
         FontColor->RGBColor[0, 0.5, 0]], 
        StyleBox["_",
         FontWeight->Bold,
         FontColor->RGBColor[0, 0.5, 0]]], "1", "-"]}], "+", 
     RowBox[{"3456", " ", "\[ImaginaryI]", " ", 
      SuperscriptBox[
       RowBox[{"(", 
        SubsuperscriptBox[
         StyleBox["\[Eta]0",
          FontWeight->Bold,
          FontColor->RGBColor[0, 0.5, 0]], "1", "+"], ")"}], "3"], " ", 
      SubsuperscriptBox[
       OverscriptBox[
        StyleBox["\[Eta]0",
         FontWeight->Bold,
         FontColor->RGBColor[0, 0.5, 0]], 
        StyleBox["_",
         FontWeight->Bold,
         FontColor->RGBColor[0, 0.5, 0]]], "1", "-"]}], "+", 
     RowBox[{"4032", " ", "\[ImaginaryI]", " ", 
      SuperscriptBox[
       RowBox[{"(", 
        SubsuperscriptBox[
         OverscriptBox[
          StyleBox["\[Eta]0",
           FontWeight->Bold,
           FontColor->RGBColor[0, 0.5, 0]], 
          StyleBox["_",
           FontWeight->Bold,
           FontColor->RGBColor[0, 0.5, 0]]], "1", "-"], ")"}], "2"]}], "+", 
     RowBox[{"864", " ", 
      SubsuperscriptBox[
       StyleBox["\[Eta]0",
        FontWeight->Bold,
        FontColor->RGBColor[0, 0.5, 0]], "1", "+"], " ", 
      SuperscriptBox[
       RowBox[{"(", 
        SubsuperscriptBox[
         OverscriptBox[
          StyleBox["\[Eta]0",
           FontWeight->Bold,
           FontColor->RGBColor[0, 0.5, 0]], 
          StyleBox["_",
           FontWeight->Bold,
           FontColor->RGBColor[0, 0.5, 0]]], "1", "-"], ")"}], "2"]}], "+", 
     RowBox[{"5184", " ", "\[ImaginaryI]", " ", 
      SuperscriptBox[
       RowBox[{"(", 
        SubsuperscriptBox[
         StyleBox["\[Eta]0",
          FontWeight->Bold,
          FontColor->RGBColor[0, 0.5, 0]], "1", "+"], ")"}], "2"], " ", 
      SuperscriptBox[
       RowBox[{"(", 
        SubsuperscriptBox[
         OverscriptBox[
          StyleBox["\[Eta]0",
           FontWeight->Bold,
           FontColor->RGBColor[0, 0.5, 0]], 
          StyleBox["_",
           FontWeight->Bold,
           FontColor->RGBColor[0, 0.5, 0]]], "1", "-"], ")"}], "2"]}], "+", 
     RowBox[{"864", " ", 
      SuperscriptBox[
       RowBox[{"(", 
        SubsuperscriptBox[
         OverscriptBox[
          StyleBox["\[Eta]0",
           FontWeight->Bold,
           FontColor->RGBColor[0, 0.5, 0]], 
          StyleBox["_",
           FontWeight->Bold,
           FontColor->RGBColor[0, 0.5, 0]]], "1", "-"], ")"}], "3"]}], "+", 
     RowBox[{"3456", " ", "\[ImaginaryI]", " ", 
      SubsuperscriptBox[
       StyleBox["\[Eta]0",
        FontWeight->Bold,
        FontColor->RGBColor[0, 0.5, 0]], "1", "+"], " ", 
      SuperscriptBox[
       RowBox[{"(", 
        SubsuperscriptBox[
         OverscriptBox[
          StyleBox["\[Eta]0",
           FontWeight->Bold,
           FontColor->RGBColor[0, 0.5, 0]], 
          StyleBox["_",
           FontWeight->Bold,
           FontColor->RGBColor[0, 0.5, 0]]], "1", "-"], ")"}], "3"]}], "+", 
     RowBox[{"864", " ", "\[ImaginaryI]", " ", 
      SuperscriptBox[
       RowBox[{"(", 
        SubsuperscriptBox[
         OverscriptBox[
          StyleBox["\[Eta]0",
           FontWeight->Bold,
           FontColor->RGBColor[0, 0.5, 0]], 
          StyleBox["_",
           FontWeight->Bold,
           FontColor->RGBColor[0, 0.5, 0]]], "1", "-"], ")"}], "4"]}]}], 
    ")"}]}], "+", 
  RowBox[{
   SubscriptBox[
    StyleBox["\[Zeta]",
     FontWeight->Bold,
     FontColor->GrayLevel[0.4]], "1"], " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"2592", " ", "\[ImaginaryI]", " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2", "2"]}], "+", 
     RowBox[{"1296", " ", "\[ImaginaryI]", " ", 
      SuperscriptBox[
       RowBox[{"(", 
        SubsuperscriptBox[
         StyleBox["\[Eta]0",
          FontWeight->Bold,
          FontColor->RGBColor[0, 0.5, 0]], "1", "+"], ")"}], "2"]}], "+", 
     RowBox[{"216", " ", "\[ImaginaryI]", " ", 
      SuperscriptBox[
       RowBox[{"(", 
        SubsuperscriptBox[
         StyleBox["\[Eta]0",
          FontWeight->Bold,
          FontColor->RGBColor[0, 0.5, 0]], "1", "+"], ")"}], "4"]}], "-", 
     RowBox[{"2592", " ", "\[ImaginaryI]", " ", 
      SubsuperscriptBox[
       StyleBox["\[Eta]0",
        FontWeight->Bold,
        FontColor->RGBColor[0, 0.5, 0]], "2", "+"]}], "-", 
     RowBox[{"432", " ", "\[ImaginaryI]", " ", 
      SubsuperscriptBox[
       StyleBox["\[Eta]0",
        FontWeight->Bold,
        FontColor->RGBColor[0, 0.5, 0]], "4", "+"]}], "+", 
     RowBox[{"2592", " ", "\[ImaginaryI]", " ", 
      SubsuperscriptBox[
       StyleBox["\[Eta]0",
        FontWeight->Bold,
        FontColor->RGBColor[0, 0.5, 0]], "1", "+"], " ", 
      SubsuperscriptBox[
       OverscriptBox[
        StyleBox["\[Eta]0",
         FontWeight->Bold,
         FontColor->RGBColor[0, 0.5, 0]], 
        StyleBox["_",
         FontWeight->Bold,
         FontColor->RGBColor[0, 0.5, 0]]], "1", "-"]}], "+", 
     RowBox[{"864", " ", "\[ImaginaryI]", " ", 
      SuperscriptBox[
       RowBox[{"(", 
        SubsuperscriptBox[
         StyleBox["\[Eta]0",
          FontWeight->Bold,
          FontColor->RGBColor[0, 0.5, 0]], "1", "+"], ")"}], "3"], " ", 
      SubsuperscriptBox[
       OverscriptBox[
        StyleBox["\[Eta]0",
         FontWeight->Bold,
         FontColor->RGBColor[0, 0.5, 0]], 
        StyleBox["_",
         FontWeight->Bold,
         FontColor->RGBColor[0, 0.5, 0]]], "1", "-"]}], "+", 
     RowBox[{"1296", " ", "\[ImaginaryI]", " ", 
      SuperscriptBox[
       RowBox[{"(", 
        SubsuperscriptBox[
         OverscriptBox[
          StyleBox["\[Eta]0",
           FontWeight->Bold,
           FontColor->RGBColor[0, 0.5, 0]], 
          StyleBox["_",
           FontWeight->Bold,
           FontColor->RGBColor[0, 0.5, 0]]], "1", "-"], ")"}], "2"]}], "+", 
     RowBox[{"1296", " ", "\[ImaginaryI]", " ", 
      SuperscriptBox[
       RowBox[{"(", 
        SubsuperscriptBox[
         StyleBox["\[Eta]0",
          FontWeight->Bold,
          FontColor->RGBColor[0, 0.5, 0]], "1", "+"], ")"}], "2"], " ", 
      SuperscriptBox[
       RowBox[{"(", 
        SubsuperscriptBox[
         OverscriptBox[
          StyleBox["\[Eta]0",
           FontWeight->Bold,
           FontColor->RGBColor[0, 0.5, 0]], 
          StyleBox["_",
           FontWeight->Bold,
           FontColor->RGBColor[0, 0.5, 0]]], "1", "-"], ")"}], "2"]}], "+", 
     RowBox[{"864", " ", "\[ImaginaryI]", " ", 
      SubsuperscriptBox[
       StyleBox["\[Eta]0",
        FontWeight->Bold,
        FontColor->RGBColor[0, 0.5, 0]], "1", "+"], " ", 
      SuperscriptBox[
       RowBox[{"(", 
        SubsuperscriptBox[
         OverscriptBox[
          StyleBox["\[Eta]0",
           FontWeight->Bold,
           FontColor->RGBColor[0, 0.5, 0]], 
          StyleBox["_",
           FontWeight->Bold,
           FontColor->RGBColor[0, 0.5, 0]]], "1", "-"], ")"}], "3"]}], "+", 
     RowBox[{"216", " ", "\[ImaginaryI]", " ", 
      SuperscriptBox[
       RowBox[{"(", 
        SubsuperscriptBox[
         OverscriptBox[
          StyleBox["\[Eta]0",
           FontWeight->Bold,
           FontColor->RGBColor[0, 0.5, 0]], 
          StyleBox["_",
           FontWeight->Bold,
           FontColor->RGBColor[0, 0.5, 0]]], "1", "-"], ")"}], "4"]}], "+", 
     RowBox[{
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2"], " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         RowBox[{"-", "7776"}], " ", "\[ImaginaryI]"}], "-", 
        RowBox[{"1728", " ", "\[ImaginaryI]", " ", 
         SuperscriptBox[
          RowBox[{"(", 
           SubsuperscriptBox[
            StyleBox["\[Eta]0",
             FontWeight->Bold,
             FontColor->RGBColor[0, 0.5, 0]], "1", "+"], ")"}], "2"]}], "-", 
        RowBox[{"3456", " ", "\[ImaginaryI]", " ", 
         SubsuperscriptBox[
          StyleBox["\[Eta]0",
           FontWeight->Bold,
           FontColor->RGBColor[0, 0.5, 0]], "1", "+"], " ", 
         SubsuperscriptBox[
          OverscriptBox[
           StyleBox["\[Eta]0",
            FontWeight->Bold,
            FontColor->RGBColor[0, 0.5, 0]], 
           StyleBox["_",
            FontWeight->Bold,
            FontColor->RGBColor[0, 0.5, 0]]], "1", "-"]}], "-", 
        RowBox[{"1728", " ", "\[ImaginaryI]", " ", 
         SuperscriptBox[
          RowBox[{"(", 
           SubsuperscriptBox[
            OverscriptBox[
             StyleBox["\[Eta]0",
              FontWeight->Bold,
              FontColor->RGBColor[0, 0.5, 0]], 
             StyleBox["_",
              FontWeight->Bold,
              FontColor->RGBColor[0, 0.5, 0]]], "1", "-"], ")"}], "2"]}]}], 
       ")"}]}]}], ")"}]}], "+", 
  RowBox[{
   SqrtBox["3"], " ", 
   RowBox[{"(", 
    RowBox[{
     FractionBox["9824", "3"], "+", 
     RowBox[{"1200", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3"]}], "-", 
     RowBox[{"288", " ", 
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3", "2"]}], "+", 
     RowBox[{"912", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "5"]}], "+", 
     RowBox[{"2352", " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "7"]}], "-", 
     RowBox[{"1296", " ", "\[ImaginaryI]", " ", 
      SubsuperscriptBox[
       StyleBox["\[Eta]0",
        FontWeight->Bold,
        FontColor->RGBColor[0, 0.5, 0]], "1", "+"]}], "-", 
     RowBox[{"72", " ", "\[ImaginaryI]", " ", 
      SuperscriptBox[
       RowBox[{"(", 
        SubsuperscriptBox[
         StyleBox["\[Eta]0",
          FontWeight->Bold,
          FontColor->RGBColor[0, 0.5, 0]], "1", "+"], ")"}], "3"]}], "-", 
     RowBox[{"216", " ", 
      SuperscriptBox[
       RowBox[{"(", 
        SubsuperscriptBox[
         StyleBox["\[Eta]0",
          FontWeight->Bold,
          FontColor->RGBColor[0, 0.5, 0]], "1", "+"], ")"}], "4"]}], "+", 
     RowBox[{"204", " ", "\[ImaginaryI]", " ", 
      SuperscriptBox[
       RowBox[{"(", 
        SubsuperscriptBox[
         StyleBox["\[Eta]0",
          FontWeight->Bold,
          FontColor->RGBColor[0, 0.5, 0]], "1", "+"], ")"}], "5"]}], "+", 
     RowBox[{"144", " ", "\[ImaginaryI]", " ", 
      SubsuperscriptBox[
       StyleBox["\[Eta]0",
        FontWeight->Bold,
        FontColor->RGBColor[0, 0.5, 0]], "3", "+"]}], "+", 
     RowBox[{"432", " ", 
      SubsuperscriptBox[
       StyleBox["\[Eta]0",
        FontWeight->Bold,
        FontColor->RGBColor[0, 0.5, 0]], "1", "+"], " ", 
      SubsuperscriptBox[
       StyleBox["\[Eta]0",
        FontWeight->Bold,
        FontColor->RGBColor[0, 0.5, 0]], "3", "+"]}], "-", 
     RowBox[{"408", " ", "\[ImaginaryI]", " ", 
      SubsuperscriptBox[
       StyleBox["\[Eta]0",
        FontWeight->Bold,
        FontColor->RGBColor[0, 0.5, 0]], "5", "+"]}], "+", 
     RowBox[{
      SubsuperscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2", "2"], " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"4896", " ", "\[ImaginaryI]", " ", 
         SubsuperscriptBox[
          StyleBox["\[Eta]0",
           FontWeight->Bold,
           FontColor->RGBColor[0, 0.5, 0]], "1", "+"]}], "+", 
        RowBox[{"4896", " ", "\[ImaginaryI]", " ", 
         SubsuperscriptBox[
          OverscriptBox[
           StyleBox["\[Eta]0",
            FontWeight->Bold,
            FontColor->RGBColor[0, 0.5, 0]], 
           StyleBox["_",
            FontWeight->Bold,
            FontColor->RGBColor[0, 0.5, 0]]], "1", "-"]}]}], ")"}]}], "+", 
     RowBox[{"1296", " ", "\[ImaginaryI]", " ", 
      SubsuperscriptBox[
       OverscriptBox[
        StyleBox["\[Eta]0",
         FontWeight->Bold,
         FontColor->RGBColor[0, 0.5, 0]], 
        StyleBox["_",
         FontWeight->Bold,
         FontColor->RGBColor[0, 0.5, 0]]], "1", "-"]}], "-", 
     RowBox[{"216", " ", "\[ImaginaryI]", " ", 
      SuperscriptBox[
       RowBox[{"(", 
        SubsuperscriptBox[
         StyleBox["\[Eta]0",
          FontWeight->Bold,
          FontColor->RGBColor[0, 0.5, 0]], "1", "+"], ")"}], "2"], " ", 
      SubsuperscriptBox[
       OverscriptBox[
        StyleBox["\[Eta]0",
         FontWeight->Bold,
         FontColor->RGBColor[0, 0.5, 0]], 
        StyleBox["_",
         FontWeight->Bold,
         FontColor->RGBColor[0, 0.5, 0]]], "1", "-"]}], "-", 
     RowBox[{"432", " ", 
      SuperscriptBox[
       RowBox[{"(", 
        SubsuperscriptBox[
         StyleBox["\[Eta]0",
          FontWeight->Bold,
          FontColor->RGBColor[0, 0.5, 0]], "1", "+"], ")"}], "3"], " ", 
      SubsuperscriptBox[
       OverscriptBox[
        StyleBox["\[Eta]0",
         FontWeight->Bold,
         FontColor->RGBColor[0, 0.5, 0]], 
        StyleBox["_",
         FontWeight->Bold,
         FontColor->RGBColor[0, 0.5, 0]]], "1", "-"]}], "+", 
     RowBox[{"1020", " ", "\[ImaginaryI]", " ", 
      SuperscriptBox[
       RowBox[{"(", 
        SubsuperscriptBox[
         StyleBox["\[Eta]0",
          FontWeight->Bold,
          FontColor->RGBColor[0, 0.5, 0]], "1", "+"], ")"}], "4"], " ", 
      SubsuperscriptBox[
       OverscriptBox[
        StyleBox["\[Eta]0",
         FontWeight->Bold,
         FontColor->RGBColor[0, 0.5, 0]], 
        StyleBox["_",
         FontWeight->Bold,
         FontColor->RGBColor[0, 0.5, 0]]], "1", "-"]}], "-", 
     RowBox[{"432", " ", 
      SubsuperscriptBox[
       StyleBox["\[Eta]0",
        FontWeight->Bold,
        FontColor->RGBColor[0, 0.5, 0]], "3", "+"], " ", 
      SubsuperscriptBox[
       OverscriptBox[
        StyleBox["\[Eta]0",
         FontWeight->Bold,
         FontColor->RGBColor[0, 0.5, 0]], 
        StyleBox["_",
         FontWeight->Bold,
         FontColor->RGBColor[0, 0.5, 0]]], "1", "-"]}], "-", 
     RowBox[{"216", " ", "\[ImaginaryI]", " ", 
      SubsuperscriptBox[
       StyleBox["\[Eta]0",
        FontWeight->Bold,
        FontColor->RGBColor[0, 0.5, 0]], "1", "+"], " ", 
      SuperscriptBox[
       RowBox[{"(", 
        SubsuperscriptBox[
         OverscriptBox[
          StyleBox["\[Eta]0",
           FontWeight->Bold,
           FontColor->RGBColor[0, 0.5, 0]], 
          StyleBox["_",
           FontWeight->Bold,
           FontColor->RGBColor[0, 0.5, 0]]], "1", "-"], ")"}], "2"]}], "+", 
     RowBox[{"2040", " ", "\[ImaginaryI]", " ", 
      SuperscriptBox[
       RowBox[{"(", 
        SubsuperscriptBox[
         StyleBox["\[Eta]0",
          FontWeight->Bold,
          FontColor->RGBColor[0, 0.5, 0]], "1", "+"], ")"}], "3"], " ", 
      SuperscriptBox[
       RowBox[{"(", 
        SubsuperscriptBox[
         OverscriptBox[
          StyleBox["\[Eta]0",
           FontWeight->Bold,
           FontColor->RGBColor[0, 0.5, 0]], 
          StyleBox["_",
           FontWeight->Bold,
           FontColor->RGBColor[0, 0.5, 0]]], "1", "-"], ")"}], "2"]}], "-", 
     RowBox[{"72", " ", "\[ImaginaryI]", " ", 
      SuperscriptBox[
       RowBox[{"(", 
        SubsuperscriptBox[
         OverscriptBox[
          StyleBox["\[Eta]0",
           FontWeight->Bold,
           FontColor->RGBColor[0, 0.5, 0]], 
          StyleBox["_",
           FontWeight->Bold,
           FontColor->RGBColor[0, 0.5, 0]]], "1", "-"], ")"}], "3"]}], "+", 
     RowBox[{"432", " ", 
      SubsuperscriptBox[
       StyleBox["\[Eta]0",
        FontWeight->Bold,
        FontColor->RGBColor[0, 0.5, 0]], "1", "+"], " ", 
      SuperscriptBox[
       RowBox[{"(", 
        SubsuperscriptBox[
         OverscriptBox[
          StyleBox["\[Eta]0",
           FontWeight->Bold,
           FontColor->RGBColor[0, 0.5, 0]], 
          StyleBox["_",
           FontWeight->Bold,
           FontColor->RGBColor[0, 0.5, 0]]], "1", "-"], ")"}], "3"]}], "+", 
     RowBox[{"2040", " ", "\[ImaginaryI]", " ", 
      SuperscriptBox[
       RowBox[{"(", 
        SubsuperscriptBox[
         StyleBox["\[Eta]0",
          FontWeight->Bold,
          FontColor->RGBColor[0, 0.5, 0]], "1", "+"], ")"}], "2"], " ", 
      SuperscriptBox[
       RowBox[{"(", 
        SubsuperscriptBox[
         OverscriptBox[
          StyleBox["\[Eta]0",
           FontWeight->Bold,
           FontColor->RGBColor[0, 0.5, 0]], 
          StyleBox["_",
           FontWeight->Bold,
           FontColor->RGBColor[0, 0.5, 0]]], "1", "-"], ")"}], "3"]}], "+", 
     RowBox[{"216", " ", 
      SuperscriptBox[
       RowBox[{"(", 
        SubsuperscriptBox[
         OverscriptBox[
          StyleBox["\[Eta]0",
           FontWeight->Bold,
           FontColor->RGBColor[0, 0.5, 0]], 
          StyleBox["_",
           FontWeight->Bold,
           FontColor->RGBColor[0, 0.5, 0]]], "1", "-"], ")"}], "4"]}], "+", 
     RowBox[{"1020", " ", "\[ImaginaryI]", " ", 
      SubsuperscriptBox[
       StyleBox["\[Eta]0",
        FontWeight->Bold,
        FontColor->RGBColor[0, 0.5, 0]], "1", "+"], " ", 
      SuperscriptBox[
       RowBox[{"(", 
        SubsuperscriptBox[
         OverscriptBox[
          StyleBox["\[Eta]0",
           FontWeight->Bold,
           FontColor->RGBColor[0, 0.5, 0]], 
          StyleBox["_",
           FontWeight->Bold,
           FontColor->RGBColor[0, 0.5, 0]]], "1", "-"], ")"}], "4"]}], "+", 
     RowBox[{"204", " ", "\[ImaginaryI]", " ", 
      SuperscriptBox[
       RowBox[{"(", 
        SubsuperscriptBox[
         OverscriptBox[
          StyleBox["\[Eta]0",
           FontWeight->Bold,
           FontColor->RGBColor[0, 0.5, 0]], 
          StyleBox["_",
           FontWeight->Bold,
           FontColor->RGBColor[0, 0.5, 0]]], "1", "-"], ")"}], "5"]}], "+", 
     RowBox[{
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "1"], " ", 
      RowBox[{"(", 
       RowBox[{"2592", "-", 
        RowBox[{"432", " ", "\[ImaginaryI]", " ", 
         SuperscriptBox[
          RowBox[{"(", 
           SubsuperscriptBox[
            StyleBox["\[Eta]0",
             FontWeight->Bold,
             FontColor->RGBColor[0, 0.5, 0]], "1", "+"], ")"}], "3"]}], "+", 
        RowBox[{"864", " ", "\[ImaginaryI]", " ", 
         SubsuperscriptBox[
          StyleBox["\[Eta]0",
           FontWeight->Bold,
           FontColor->RGBColor[0, 0.5, 0]], "3", "+"]}], "+", 
        RowBox[{
         SubscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "2"], " ", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"2592", " ", "\[ImaginaryI]", " ", 
            SubsuperscriptBox[
             StyleBox["\[Eta]0",
              FontWeight->Bold,
              FontColor->RGBColor[0, 0.5, 0]], "1", "+"]}], "+", 
           RowBox[{"2592", " ", "\[ImaginaryI]", " ", 
            SubsuperscriptBox[
             OverscriptBox[
              StyleBox["\[Eta]0",
               FontWeight->Bold,
               FontColor->RGBColor[0, 0.5, 0]], 
              StyleBox["_",
               FontWeight->Bold,
               FontColor->RGBColor[0, 0.5, 0]]], "1", "-"]}]}], ")"}]}], "-", 
        
        RowBox[{"1296", " ", "\[ImaginaryI]", " ", 
         SuperscriptBox[
          RowBox[{"(", 
           SubsuperscriptBox[
            StyleBox["\[Eta]0",
             FontWeight->Bold,
             FontColor->RGBColor[0, 0.5, 0]], "1", "+"], ")"}], "2"], " ", 
         SubsuperscriptBox[
          OverscriptBox[
           StyleBox["\[Eta]0",
            FontWeight->Bold,
            FontColor->RGBColor[0, 0.5, 0]], 
           StyleBox["_",
            FontWeight->Bold,
            FontColor->RGBColor[0, 0.5, 0]]], "1", "-"]}], "-", 
        RowBox[{"1296", " ", "\[ImaginaryI]", " ", 
         SubsuperscriptBox[
          StyleBox["\[Eta]0",
           FontWeight->Bold,
           FontColor->RGBColor[0, 0.5, 0]], "1", "+"], " ", 
         SuperscriptBox[
          RowBox[{"(", 
           SubsuperscriptBox[
            OverscriptBox[
             StyleBox["\[Eta]0",
              FontWeight->Bold,
              FontColor->RGBColor[0, 0.5, 0]], 
             StyleBox["_",
              FontWeight->Bold,
              FontColor->RGBColor[0, 0.5, 0]]], "1", "-"], ")"}], "2"]}], "-", 
        RowBox[{"432", " ", "\[ImaginaryI]", " ", 
         SuperscriptBox[
          RowBox[{"(", 
           SubsuperscriptBox[
            OverscriptBox[
             StyleBox["\[Eta]0",
              FontWeight->Bold,
              FontColor->RGBColor[0, 0.5, 0]], 
             StyleBox["_",
              FontWeight->Bold,
              FontColor->RGBColor[0, 0.5, 0]]], "1", "-"], ")"}], "3"]}]}], 
       ")"}]}], "+", 
     RowBox[{
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "2"], " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"432", " ", "\[ImaginaryI]", " ", 
         SubsuperscriptBox[
          StyleBox["\[Eta]0",
           FontWeight->Bold,
           FontColor->RGBColor[0, 0.5, 0]], "1", "+"]}], "+", 
        RowBox[{"1296", " ", 
         SuperscriptBox[
          RowBox[{"(", 
           SubsuperscriptBox[
            StyleBox["\[Eta]0",
             FontWeight->Bold,
             FontColor->RGBColor[0, 0.5, 0]], "1", "+"], ")"}], "2"]}], "-", 
        RowBox[{"2040", " ", "\[ImaginaryI]", " ", 
         SuperscriptBox[
          RowBox[{"(", 
           SubsuperscriptBox[
            StyleBox["\[Eta]0",
             FontWeight->Bold,
             FontColor->RGBColor[0, 0.5, 0]], "1", "+"], ")"}], "3"]}], "+", 
        RowBox[{"432", " ", "\[ImaginaryI]", " ", 
         SubsuperscriptBox[
          OverscriptBox[
           StyleBox["\[Eta]0",
            FontWeight->Bold,
            FontColor->RGBColor[0, 0.5, 0]], 
           StyleBox["_",
            FontWeight->Bold,
            FontColor->RGBColor[0, 0.5, 0]]], "1", "-"]}], "-", 
        RowBox[{"6120", " ", "\[ImaginaryI]", " ", 
         SuperscriptBox[
          RowBox[{"(", 
           SubsuperscriptBox[
            StyleBox["\[Eta]0",
             FontWeight->Bold,
             FontColor->RGBColor[0, 0.5, 0]], "1", "+"], ")"}], "2"], " ", 
         SubsuperscriptBox[
          OverscriptBox[
           StyleBox["\[Eta]0",
            FontWeight->Bold,
            FontColor->RGBColor[0, 0.5, 0]], 
           StyleBox["_",
            FontWeight->Bold,
            FontColor->RGBColor[0, 0.5, 0]]], "1", "-"]}], "-", 
        RowBox[{"1296", " ", 
         SuperscriptBox[
          RowBox[{"(", 
           SubsuperscriptBox[
            OverscriptBox[
             StyleBox["\[Eta]0",
              FontWeight->Bold,
              FontColor->RGBColor[0, 0.5, 0]], 
             StyleBox["_",
              FontWeight->Bold,
              FontColor->RGBColor[0, 0.5, 0]]], "1", "-"], ")"}], "2"]}], "-", 
        RowBox[{"6120", " ", "\[ImaginaryI]", " ", 
         SubsuperscriptBox[
          StyleBox["\[Eta]0",
           FontWeight->Bold,
           FontColor->RGBColor[0, 0.5, 0]], "1", "+"], " ", 
         SuperscriptBox[
          RowBox[{"(", 
           SubsuperscriptBox[
            OverscriptBox[
             StyleBox["\[Eta]0",
              FontWeight->Bold,
              FontColor->RGBColor[0, 0.5, 0]], 
             StyleBox["_",
              FontWeight->Bold,
              FontColor->RGBColor[0, 0.5, 0]]], "1", "-"], ")"}], "2"]}], "-", 
        RowBox[{"2040", " ", "\[ImaginaryI]", " ", 
         SuperscriptBox[
          RowBox[{"(", 
           SubsuperscriptBox[
            OverscriptBox[
             StyleBox["\[Eta]0",
              FontWeight->Bold,
              FontColor->RGBColor[0, 0.5, 0]], 
             StyleBox["_",
              FontWeight->Bold,
              FontColor->RGBColor[0, 0.5, 0]]], "1", "-"], ")"}], "3"]}]}], 
       ")"}]}]}], ")"}]}]}]], "Output",
 CellChangeTimes->{{3.5608617955988073`*^9, 3.560861805032276*^9}, {
  3.560861864843979*^9, 3.560861878186927*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  SubscriptBox["v", "0"], "/.", 
  RowBox[{"leadweak", "[", "5", "]"}]}]], "Input",
 CellChangeTimes->{{3.560861507669065*^9, 3.560861513997072*^9}}],

Cell[BoxData[
 RowBox[{
  FractionBox["1", 
   RowBox[{"2", " ", 
    SqrtBox["3"]}]], "+", 
  FractionBox[
   RowBox[{"4", " ", 
    SuperscriptBox["g", "2"]}], 
   SqrtBox["3"]], "-", 
  FractionBox[
   RowBox[{"10", " ", 
    SuperscriptBox["g", "4"]}], 
   SqrtBox["3"]], "+", 
  RowBox[{
   SuperscriptBox["g", "6"], " ", 
   RowBox[{"(", 
    RowBox[{
     FractionBox["56", 
      SqrtBox["3"]], "+", 
     RowBox[{"8", " ", 
      SqrtBox["3"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3"]}]}], ")"}]}], "+", 
  RowBox[{
   SuperscriptBox["g", "8"], " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"-", 
      FractionBox["461", 
       SqrtBox["3"]]}], "-", 
     RowBox[{"48", " ", 
      SqrtBox["3"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "3"]}], "-", 
     RowBox[{"80", " ", 
      SqrtBox["3"], " ", 
      SubscriptBox[
       StyleBox["\[Zeta]",
        FontWeight->Bold,
        FontColor->GrayLevel[0.4]], "5"]}]}], ")"}]}]}]], "Output",
 CellChangeTimes->{3.560861514427602*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Collect", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"manal", "[", 
     RowBox[{"[", "1", "]"}], "]"}], "/.", 
    RowBox[{
     RowBox[{
      RowBox[{"\[Eta]0$b", "[", "1", "]"}], "[", 
      RowBox[{"-", "1"}], "]"}], "\[RuleDelayed]", 
     RowBox[{"per", "-", 
      RowBox[{
       RowBox[{"\[Eta]0$", "[", "1", "]"}], "[", "1", "]"}]}]}]}], ",", 
   RowBox[{"{", 
    RowBox[{"g", ",", "per"}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.560861526723691*^9, 3.5608615987316628`*^9}}],

Cell[BoxData[
 RowBox[{
  SuperscriptBox["g", "8"], " ", 
  RowBox[{"(", 
   RowBox[{
    RowBox[{
     RowBox[{"-", "405"}], " ", "\[ImaginaryI]", " ", 
     SqrtBox["3"]}], "-", 
    RowBox[{"324", " ", 
     SqrtBox["3"], " ", 
     SuperscriptBox["per", "3"]}], "+", 
    RowBox[{"162", " ", 
     SuperscriptBox["per", "4"]}], "+", 
    RowBox[{
     SuperscriptBox["per", "2"], " ", 
     RowBox[{"(", 
      RowBox[{"972", "-", 
       RowBox[{"1296", " ", 
        SubscriptBox[
         StyleBox["\[Zeta]",
          FontWeight->Bold,
          FontColor->GrayLevel[0.4]], "2"]}]}], ")"}]}], "-", 
    RowBox[{"5832", " ", 
     SubscriptBox[
      StyleBox["\[Zeta]",
       FontWeight->Bold,
       FontColor->GrayLevel[0.4]], "2"]}], "+", 
    RowBox[{"1944", " ", 
     SqrtBox["3"], " ", "per", " ", 
     SubscriptBox[
      StyleBox["\[Zeta]",
       FontWeight->Bold,
       FontColor->GrayLevel[0.4]], "2"]}], "+", 
    RowBox[{"1944", " ", 
     SubsuperscriptBox[
      StyleBox["\[Zeta]",
       FontWeight->Bold,
       FontColor->GrayLevel[0.4]], "2", "2"]}], "-", 
    RowBox[{"648", " ", "\[ImaginaryI]", " ", 
     SqrtBox["3"], " ", 
     SubscriptBox[
      StyleBox["\[Zeta]",
       FontWeight->Bold,
       FontColor->GrayLevel[0.4]], "3"]}], "-", 
    RowBox[{"720", " ", "\[ImaginaryI]", " ", 
     SqrtBox["3"], " ", 
     SubscriptBox[
      StyleBox["\[Zeta]",
       FontWeight->Bold,
       FontColor->GrayLevel[0.4]], "5"]}], "-", 
    RowBox[{"1944", " ", 
     SubsuperscriptBox[
      StyleBox["\[Eta]0",
       FontWeight->Bold,
       FontColor->RGBColor[0, 0.5, 0]], "2", "+"]}], "+", 
    RowBox[{"648", " ", 
     SqrtBox["3"], " ", 
     SubsuperscriptBox[
      StyleBox["\[Eta]0",
       FontWeight->Bold,
       FontColor->RGBColor[0, 0.5, 0]], "3", "+"]}], "-", 
    RowBox[{"324", " ", 
     SubsuperscriptBox[
      StyleBox["\[Eta]0",
       FontWeight->Bold,
       FontColor->RGBColor[0, 0.5, 0]], "4", "+"]}]}], ")"}]}]], "Output",
 CellChangeTimes->{{3.560861539611775*^9, 3.560861599275898*^9}}]
}, Open  ]],

Cell["Let us now see how this modifies expression for the energy", "Text",
 CellChangeTimes->{{3.549882673745883*^9, 3.5498826816959467`*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"Expand", "/@", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"Series", "[", 
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{
          RowBox[{
           RowBox[{"2", "-", 
            RowBox[{"4", " ", "\[ImaginaryI]", " ", "g", " ", 
             RowBox[{"(", 
              RowBox[{
               FractionBox["1", 
                SuperscriptBox[
                 OverscriptBox[
                  StyleBox["y",
                   FontColor->RGBColor[0, 0.6, 0]], 
                  StyleBox["^",
                   FontColor->RGBColor[0, 0.6, 0]]], "-"]], "-", 
               FractionBox["1", 
                SuperscriptBox[
                 OverscriptBox[
                  StyleBox["y",
                   FontColor->RGBColor[0, 0.6, 0]], 
                  StyleBox["^",
                   FontColor->RGBColor[0, 0.6, 0]]], "+"]]}], ")"}]}]}], "/.",
            "subJuk"}], "/.", 
          RowBox[{
           SubscriptBox["v", "0"], "\[Rule]", 
           RowBox[{
            FractionBox["1", 
             RowBox[{"2", 
              SqrtBox["3"]}]], "+", 
            RowBox[{
             SuperscriptBox["g", "2"], "\[Delta]u"}]}]}]}], "/.", 
         RowBox[{"\[Delta]u", "->", 
          RowBox[{"Sum", "[", 
           RowBox[{
            RowBox[{
             SubscriptBox["\[Lambda]", 
              RowBox[{"i", "+", "2"}]], 
             SuperscriptBox["g", 
              RowBox[{"2", "i"}]]}], ",", 
            RowBox[{"{", 
             RowBox[{"i", ",", "0", ",", "\[CapitalLambda]"}], "}"}]}], 
           "]"}]}]}], "/.", "bethesolut"}], ",", 
       RowBox[{"{", 
        RowBox[{"g", ",", "0", ",", "16"}], "}"}]}], "]"}], "//", 
     "Simplify"}], ")"}]}], "/.", 
  RowBox[{
   RowBox[{"Zeta", "[", "a_", "]"}], "\[RuleDelayed]", " ", 
   SubscriptBox["\[Zeta]", "a"]}]}]], "Input",
 CellChangeTimes->{{3.549882723242701*^9, 3.549882766432375*^9}, {
   3.5523519678036833`*^9, 3.552351969129526*^9}, {3.552352100697398*^9, 
   3.552352114503006*^9}, {3.553856880442696*^9, 3.553856891856968*^9}, {
   3.553857325881415*^9, 3.553857326137095*^9}, 3.555975358676763*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"2", "+", 
   RowBox[{"12", " ", 
    SuperscriptBox["g", "2"]}], "-", 
   RowBox[{"48", " ", 
    SuperscriptBox["g", "4"]}], "+", 
   RowBox[{"336", " ", 
    SuperscriptBox["g", "6"]}], "+", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"-", "2820"}], "-", 
      RowBox[{"288", " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "3"]}]}], ")"}], " ", 
    SuperscriptBox["g", "8"]}], "+", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{"26508", "+", 
      FractionBox[
       RowBox[{"4", " ", "\[ImaginaryI]", " ", "m1"}], 
       SqrtBox["3"]], "+", 
      RowBox[{"4320", " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "3"]}], "+", 
      RowBox[{"2880", " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "5"]}]}], ")"}], " ", 
    SuperscriptBox["g", "10"]}], "+", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"-", "269148"}], "-", 
      FractionBox[
       RowBox[{"20", " ", "\[ImaginaryI]", " ", "m1"}], 
       SqrtBox["3"]], "+", 
      FractionBox[
       RowBox[{"4", " ", "\[ImaginaryI]", " ", "m2"}], 
       SqrtBox["3"]], "-", 
      RowBox[{"55296", " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "3"]}], "-", 
      RowBox[{"44064", " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "5"]}], "-", 
      RowBox[{"30240", " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "7"]}]}], ")"}], " ", 
    SuperscriptBox["g", "12"]}], "+", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{"2877240", "+", 
      RowBox[{"56", " ", "\[ImaginaryI]", " ", 
       SqrtBox["3"], " ", "m1"}], "-", 
      FractionBox[
       RowBox[{"20", " ", "\[ImaginaryI]", " ", "m2"}], 
       SqrtBox["3"]], "+", 
      FractionBox[
       RowBox[{"4", " ", "\[ImaginaryI]", " ", "m3"}], 
       SqrtBox["3"]], "+", 
      RowBox[{"697536", " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "3"]}], "+", 
      RowBox[{"3456", " ", 
       SubsuperscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "3", "2"]}], "+", 
      RowBox[{"579744", " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "5"]}], "+", 
      RowBox[{"471744", " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "7"]}], "+", 
      RowBox[{"338688", " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "9"]}]}], ")"}], " ", 
    SuperscriptBox["g", "14"]}], "+", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"-", "31857132"}], "-", 
      FractionBox[
       RowBox[{"1844", " ", "\[ImaginaryI]", " ", "m1"}], 
       SqrtBox["3"]], "+", 
      RowBox[{"56", " ", "\[ImaginaryI]", " ", 
       SqrtBox["3"], " ", "m2"}], "-", 
      FractionBox[
       RowBox[{"20", " ", "\[ImaginaryI]", " ", "m3"}], 
       SqrtBox["3"]], "+", 
      FractionBox[
       RowBox[{"4", " ", "\[ImaginaryI]", " ", "m4"}], 
       SqrtBox["3"]], "-", 
      RowBox[{"8912160", " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "3"]}], "-", 
      RowBox[{"79488", " ", 
       SubsuperscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "3", "2"]}], "-", 
      RowBox[{"7486848", " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "5"]}], "-", 
      RowBox[{"69120", " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "3"], " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "5"]}], "-", 
      RowBox[{"6342624", " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "7"]}], "-", 
      RowBox[{"5370624", " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "9"]}], "-", 
      RowBox[{"3991680", " ", 
       SubscriptBox[
        StyleBox["\[Zeta]",
         FontWeight->Bold,
         FontColor->GrayLevel[0.4]], "11"]}]}], ")"}], " ", 
    SuperscriptBox["g", "16"]}], "+", 
   InterpretationBox[
    SuperscriptBox[
     RowBox[{"O", "[", "g", "]"}], "17"],
    SeriesData[$CellContext`g, 0, {}, 0, 17, 1],
    Editable->False]}],
  SeriesData[$CellContext`g, 0, {
   2, 0, 12, 0, -48, 0, 336, 0, -2820 - 288 $CellContext`\[Zeta]$[3][0], 0, 
    26508 + (Complex[0, 4] 3^Rational[-1, 2]) $CellContext`m1 + 
    4320 $CellContext`\[Zeta]$[3][0] + 2880 $CellContext`\[Zeta]$[5][0], 
    0, -269148 + (Complex[0, -20] 3^Rational[-1, 2]) $CellContext`m1 + (
      Complex[0, 4] 3^Rational[-1, 2]) $CellContext`m2 - 
    55296 $CellContext`\[Zeta]$[3][0] - 44064 $CellContext`\[Zeta]$[5][0] - 
    30240 $CellContext`\[Zeta]$[7][0], 0, 
    2877240 + (Complex[0, 56] 3^Rational[1, 2]) $CellContext`m1 + (
      Complex[0, -20] 3^Rational[-1, 2]) $CellContext`m2 + (Complex[0, 4] 
      3^Rational[-1, 2]) $CellContext`m3 + 697536 $CellContext`\[Zeta]$[3][0] + 
    3456 $CellContext`\[Zeta]$[3][0]^2 + 579744 $CellContext`\[Zeta]$[5][0] + 
    471744 $CellContext`\[Zeta]$[7][0] + 338688 $CellContext`\[Zeta]$[9][0], 
    0, -31857132 + (Complex[0, -1844] 3^Rational[-1, 2]) $CellContext`m1 + (
      Complex[0, 56] 3^Rational[1, 2]) $CellContext`m2 + (Complex[0, -20] 
      3^Rational[-1, 2]) $CellContext`m3 + (Complex[0, 4] 
      3^Rational[-1, 2]) $CellContext`m4 - 
    8912160 $CellContext`\[Zeta]$[3][0] - 79488 $CellContext`\[Zeta]$[3][0]^2 - 
    7486848 $CellContext`\[Zeta]$[5][0] - (
     69120 $CellContext`\[Zeta]$[3][0]) $CellContext`\[Zeta]$[5][0] - 
    6342624 $CellContext`\[Zeta]$[7][0] - 5370624 $CellContext`\[Zeta]$[9][0] - 
    3991680 $CellContext`\[Zeta]$[11][0]}, 0, 17, 1],
  Editable->False]], "Output",
 CellChangeTimes->{{3.5498827475057573`*^9, 3.5498827673534822`*^9}, {
   3.55235196406947*^9, 3.552351972717911*^9}, {3.5523520862076693`*^9, 
   3.552352116644101*^9}, {3.5538567027349997`*^9, 3.5538567263420763`*^9}, {
   3.553856890221643*^9, 3.5538568941446238`*^9}, {3.553857318719317*^9, 
   3.5538573377253523`*^9}, 3.555975003104319*^9, 3.555975360420142*^9, 
   3.555975404926256*^9}]
}, Open  ]]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell["\<\
Expression for the energy, through m1, m2,m3,m4 and integral of H\
\>", "Subsection",
 CellChangeTimes->{{3.5538535467983294`*^9, 3.5538535547419043`*^9}, {
  3.5538569700817423`*^9, 3.553856985143078*^9}, {3.568969270332765*^9, 
  3.5689692758795633`*^9}}],

Cell["\<\
I just summarize what a correction to the Asymptotic Bethe Ansatz energies.\
\>", "Text",
 CellChangeTimes->{{3.553857001270718*^9, 3.553857019454185*^9}, {
  3.553857789268722*^9, 3.553857789888013*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{
    SubscriptBox["E", "wrap"], "==", 
    RowBox[{"2", "\[ImaginaryI]", " ", 
     RowBox[{"\[DoubleStruckCapitalC]", "[", 
      FractionBox["H", 
       SqrtBox[
        RowBox[{"1", "-", 
         FractionBox[
          RowBox[{"4", 
           SuperscriptBox["g", "2"]}], 
          SuperscriptBox["u", "2"]]}]]], "]"}]}]}], ",", 
   RowBox[{
    RowBox[{"\[DoubleStruckCapitalC]", "[", 
     RowBox[{"f", "[", "v", "]"}], "]"}], "\[Congruent]", 
    RowBox[{
     SubsuperscriptBox["\[Integral]", 
      RowBox[{
       RowBox[{"-", "\[Infinity]"}], "-", 
       RowBox[{"\[ImaginaryI]", " ", "0"}]}], 
      RowBox[{
       RowBox[{"+", "\[Infinity]"}], "-", 
       RowBox[{"\[ImaginaryI]", " ", "0"}]}]], 
     RowBox[{
      FractionBox["dv", 
       RowBox[{
        RowBox[{"-", "2"}], "\[Pi]", " ", "\[ImaginaryI]"}]], 
      FractionBox["1", 
       RowBox[{"u", "-", "v"}]], 
      RowBox[{"f", "[", "v", "]"}]}]}]}]}], "}"}]], "Input",
 CellChangeTimes->{{3.553857570524857*^9, 3.553857671590493*^9}, 
   3.55385778521506*^9}],

Cell[TextData[{
 "Remark: ",
 Cell[BoxData[
  RowBox[{
   RowBox[{
    RowBox[{"if", " ", 
     RowBox[{"f", "[", "v", "]"}]}], "=", 
    RowBox[{
     RowBox[{"h", "[", "v", "]"}], 
     SubscriptBox[
      OverscriptBox["W", "^"], 
      RowBox[{"0", ",", "pv"}]]}]}], ",", " ", 
   RowBox[{"then", " ", "we", " ", "use", "  ", 
    RowBox[{"h", "[", 
     RowBox[{"v", "-", 
      RowBox[{"\[ImaginaryI]", " ", "0"}]}], "]"}], 
    FractionBox["1", "2"], 
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       SubscriptBox[
        OverscriptBox["W", "^"], "0"], "[", 
       RowBox[{"v", "+", 
        RowBox[{"\[ImaginaryI]", " ", "0"}]}], "]"}], "+", 
      RowBox[{
       SubscriptBox[
        OverscriptBox["W", "^"], "0"], "[", 
       RowBox[{"v", "-", 
        RowBox[{"\[ImaginaryI]", " ", "0"}]}], "]"}]}], ")"}]}]}]],
  CellChangeTimes->{{3.553857570524857*^9, 3.553857671590493*^9}}],
 " as an integrand function. However, typically h is even, or can be easily \
made even by symmetrization ",
 Cell[BoxData[
  FormBox[
   RowBox[{"(", 
    OverscriptBox["W", "^"]}], TraditionalForm]],
  FormatType->"TraditionalForm"],
 " is symmetric). When h is even,  it does not matter what prescription to \
take because there is no residue at 0."
}], "Text",
 CellChangeTimes->{{3.553857674500593*^9, 3.55385783385535*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["Compute energy up to 8 loops :", "Subsection",
 CellChangeTimes->{{3.5689838007101603`*^9, 3.568983808211174*^9}}],

Cell[CellGroupData[{

Cell["\<\
explicit computation of m1, m2, m3, m4 (time-consuming)\
\>", "Subsubsection",
 CellChangeTimes->{{3.568983876745463*^9, 3.56898388421669*^9}, {
  3.569014705884533*^9, 3.569014706153288*^9}, {3.569014790071886*^9, 
  3.5690147970854177`*^9}}],

Cell["\<\
 m1, m2, m3 and m4 in terms of explicit integrals are stored in the file \
manswer2.data
The integrals are computed by running the (very time consuming) command \
below, preferably on a computer with parallel kernels\
\>", "Text",
 CellChangeTimes->{{3.568983944087718*^9, 3.5689839911267548`*^9}, {
  3.568984121008606*^9, 3.568984154383325*^9}, {3.569014444070754*^9, 
  3.569014450835124*^9}}],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"manswer", "=", 
    RowBox[{"Get", "[", "\"\<manswer2.data\>\"", "]"}]}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"\[Section]Verbose", "=", "True"}], 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{
     RowBox[{"That", "'"}], "s", " ", "make", " ", "Mathematica", " ", 
     "display", " ", "lots", " ", "of", " ", "garbage"}], ",", " ", 
    RowBox[{
    "but", " ", "then", " ", "you", " ", "are", " ", "sure", " ", "it", " ", 
     "is", " ", "running"}]}], "*)"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"manal", "=", 
   RowBox[{"ConstantArray", "[", 
    RowBox[{
     RowBox[{"{", "}"}], ",", "4"}], "]"}]}], ";", 
  RowBox[{
   RowBox[{"manal", "[", 
    RowBox[{"[", "1", "]"}], "]"}], "=", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"manswer", "[", 
       RowBox[{"[", "1", "]"}], "]"}], "//", "ParallelCCompute"}], ")"}], "//.",
     "EndSimplify"}]}]}]}], "Input",
 CellChangeTimes->{{3.568984109435276*^9, 3.568984117186893*^9}, {
  3.568984172018873*^9, 3.5689842368063593`*^9}, {3.568984285586575*^9, 
  3.568984313886795*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"-", "405"}], " ", "\[ImaginaryI]", " ", 
   SqrtBox["3"]}], "-", 
  RowBox[{"5832", " ", 
   SubscriptBox[
    StyleBox["\[Zeta]",
     FontWeight->Bold,
     FontColor->GrayLevel[0.4]], "2"]}], "+", 
  RowBox[{"1944", " ", 
   SubsuperscriptBox[
    StyleBox["\[Zeta]",
     FontWeight->Bold,
     FontColor->GrayLevel[0.4]], "2", "2"]}], "-", 
  RowBox[{"648", " ", "\[ImaginaryI]", " ", 
   SqrtBox["3"], " ", 
   SubscriptBox[
    StyleBox["\[Zeta]",
     FontWeight->Bold,
     FontColor->GrayLevel[0.4]], "3"]}], "-", 
  RowBox[{"720", " ", "\[ImaginaryI]", " ", 
   SqrtBox["3"], " ", 
   SubscriptBox[
    StyleBox["\[Zeta]",
     FontWeight->Bold,
     FontColor->GrayLevel[0.4]], "5"]}], "+", 
  RowBox[{"1944", " ", 
   SqrtBox["3"], " ", 
   SubscriptBox[
    StyleBox["\[Zeta]",
     FontWeight->Bold,
     FontColor->GrayLevel[0.4]], "2"], " ", 
   SubsuperscriptBox[
    StyleBox["\[Eta]0",
     FontWeight->Bold,
     FontColor->RGBColor[0, 0.5, 0]], "1", "+"]}], "+", 
  RowBox[{"972", " ", 
   SuperscriptBox[
    RowBox[{"(", 
     SubsuperscriptBox[
      StyleBox["\[Eta]0",
       FontWeight->Bold,
       FontColor->RGBColor[0, 0.5, 0]], "1", "+"], ")"}], "2"]}], "-", 
  RowBox[{"1296", " ", 
   SubscriptBox[
    StyleBox["\[Zeta]",
     FontWeight->Bold,
     FontColor->GrayLevel[0.4]], "2"], " ", 
   SuperscriptBox[
    RowBox[{"(", 
     SubsuperscriptBox[
      StyleBox["\[Eta]0",
       FontWeight->Bold,
       FontColor->RGBColor[0, 0.5, 0]], "1", "+"], ")"}], "2"]}], "-", 
  RowBox[{"324", " ", 
   SqrtBox["3"], " ", 
   SuperscriptBox[
    RowBox[{"(", 
     SubsuperscriptBox[
      StyleBox["\[Eta]0",
       FontWeight->Bold,
       FontColor->RGBColor[0, 0.5, 0]], "1", "+"], ")"}], "3"]}], "+", 
  RowBox[{"162", " ", 
   SuperscriptBox[
    RowBox[{"(", 
     SubsuperscriptBox[
      StyleBox["\[Eta]0",
       FontWeight->Bold,
       FontColor->RGBColor[0, 0.5, 0]], "1", "+"], ")"}], "4"]}], "-", 
  RowBox[{"1944", " ", 
   SubsuperscriptBox[
    StyleBox["\[Eta]0",
     FontWeight->Bold,
     FontColor->RGBColor[0, 0.5, 0]], "2", "+"]}], "+", 
  RowBox[{"648", " ", 
   SqrtBox["3"], " ", 
   SubsuperscriptBox[
    StyleBox["\[Eta]0",
     FontWeight->Bold,
     FontColor->RGBColor[0, 0.5, 0]], "3", "+"]}], "-", 
  RowBox[{"324", " ", 
   SubsuperscriptBox[
    StyleBox["\[Eta]0",
     FontWeight->Bold,
     FontColor->RGBColor[0, 0.5, 0]], "4", "+"]}], "+", 
  RowBox[{"1944", " ", 
   SqrtBox["3"], " ", 
   SubscriptBox[
    StyleBox["\[Zeta]",
     FontWeight->Bold,
     FontColor->GrayLevel[0.4]], "2"], " ", 
   SubsuperscriptBox[
    OverscriptBox[
     StyleBox["\[Eta]0",
      FontWeight->Bold,
      FontColor->RGBColor[0, 0.5, 0]], 
     StyleBox["_",
      FontWeight->Bold,
      FontColor->RGBColor[0, 0.5, 0]]], "1", "-"]}], "+", 
  RowBox[{"1944", " ", 
   SubsuperscriptBox[
    StyleBox["\[Eta]0",
     FontWeight->Bold,
     FontColor->RGBColor[0, 0.5, 0]], "1", "+"], " ", 
   SubsuperscriptBox[
    OverscriptBox[
     StyleBox["\[Eta]0",
      FontWeight->Bold,
      FontColor->RGBColor[0, 0.5, 0]], 
     StyleBox["_",
      FontWeight->Bold,
      FontColor->RGBColor[0, 0.5, 0]]], "1", "-"]}], "-", 
  RowBox[{"2592", " ", 
   SubscriptBox[
    StyleBox["\[Zeta]",
     FontWeight->Bold,
     FontColor->GrayLevel[0.4]], "2"], " ", 
   SubsuperscriptBox[
    StyleBox["\[Eta]0",
     FontWeight->Bold,
     FontColor->RGBColor[0, 0.5, 0]], "1", "+"], " ", 
   SubsuperscriptBox[
    OverscriptBox[
     StyleBox["\[Eta]0",
      FontWeight->Bold,
      FontColor->RGBColor[0, 0.5, 0]], 
     StyleBox["_",
      FontWeight->Bold,
      FontColor->RGBColor[0, 0.5, 0]]], "1", "-"]}], "-", 
  RowBox[{"972", " ", 
   SqrtBox["3"], " ", 
   SuperscriptBox[
    RowBox[{"(", 
     SubsuperscriptBox[
      StyleBox["\[Eta]0",
       FontWeight->Bold,
       FontColor->RGBColor[0, 0.5, 0]], "1", "+"], ")"}], "2"], " ", 
   SubsuperscriptBox[
    OverscriptBox[
     StyleBox["\[Eta]0",
      FontWeight->Bold,
      FontColor->RGBColor[0, 0.5, 0]], 
     StyleBox["_",
      FontWeight->Bold,
      FontColor->RGBColor[0, 0.5, 0]]], "1", "-"]}], "+", 
  RowBox[{"648", " ", 
   SuperscriptBox[
    RowBox[{"(", 
     SubsuperscriptBox[
      StyleBox["\[Eta]0",
       FontWeight->Bold,
       FontColor->RGBColor[0, 0.5, 0]], "1", "+"], ")"}], "3"], " ", 
   SubsuperscriptBox[
    OverscriptBox[
     StyleBox["\[Eta]0",
      FontWeight->Bold,
      FontColor->RGBColor[0, 0.5, 0]], 
     StyleBox["_",
      FontWeight->Bold,
      FontColor->RGBColor[0, 0.5, 0]]], "1", "-"]}], "+", 
  RowBox[{"972", " ", 
   SuperscriptBox[
    RowBox[{"(", 
     SubsuperscriptBox[
      OverscriptBox[
       StyleBox["\[Eta]0",
        FontWeight->Bold,
        FontColor->RGBColor[0, 0.5, 0]], 
       StyleBox["_",
        FontWeight->Bold,
        FontColor->RGBColor[0, 0.5, 0]]], "1", "-"], ")"}], "2"]}], "-", 
  RowBox[{"1296", " ", 
   SubscriptBox[
    StyleBox["\[Zeta]",
     FontWeight->Bold,
     FontColor->GrayLevel[0.4]], "2"], " ", 
   SuperscriptBox[
    RowBox[{"(", 
     SubsuperscriptBox[
      OverscriptBox[
       StyleBox["\[Eta]0",
        FontWeight->Bold,
        FontColor->RGBColor[0, 0.5, 0]], 
       StyleBox["_",
        FontWeight->Bold,
        FontColor->RGBColor[0, 0.5, 0]]], "1", "-"], ")"}], "2"]}], "-", 
  RowBox[{"972", " ", 
   SqrtBox["3"], " ", 
   SubsuperscriptBox[
    StyleBox["\[Eta]0",
     FontWeight->Bold,
     FontColor->RGBColor[0, 0.5, 0]], "1", "+"], " ", 
   SuperscriptBox[
    RowBox[{"(", 
     SubsuperscriptBox[
      OverscriptBox[
       StyleBox["\[Eta]0",
        FontWeight->Bold,
        FontColor->RGBColor[0, 0.5, 0]], 
       StyleBox["_",
        FontWeight->Bold,
        FontColor->RGBColor[0, 0.5, 0]]], "1", "-"], ")"}], "2"]}], "+", 
  RowBox[{"972", " ", 
   SuperscriptBox[
    RowBox[{"(", 
     SubsuperscriptBox[
      StyleBox["\[Eta]0",
       FontWeight->Bold,
       FontColor->RGBColor[0, 0.5, 0]], "1", "+"], ")"}], "2"], " ", 
   SuperscriptBox[
    RowBox[{"(", 
     SubsuperscriptBox[
      OverscriptBox[
       StyleBox["\[Eta]0",
        FontWeight->Bold,
        FontColor->RGBColor[0, 0.5, 0]], 
       StyleBox["_",
        FontWeight->Bold,
        FontColor->RGBColor[0, 0.5, 0]]], "1", "-"], ")"}], "2"]}], "-", 
  RowBox[{"324", " ", 
   SqrtBox["3"], " ", 
   SuperscriptBox[
    RowBox[{"(", 
     SubsuperscriptBox[
      OverscriptBox[
       StyleBox["\[Eta]0",
        FontWeight->Bold,
        FontColor->RGBColor[0, 0.5, 0]], 
       StyleBox["_",
        FontWeight->Bold,
        FontColor->RGBColor[0, 0.5, 0]]], "1", "-"], ")"}], "3"]}], "+", 
  RowBox[{"648", " ", 
   SubsuperscriptBox[
    StyleBox["\[Eta]0",
     FontWeight->Bold,
     FontColor->RGBColor[0, 0.5, 0]], "1", "+"], " ", 
   SuperscriptBox[
    RowBox[{"(", 
     SubsuperscriptBox[
      OverscriptBox[
       StyleBox["\[Eta]0",
        FontWeight->Bold,
        FontColor->RGBColor[0, 0.5, 0]], 
       StyleBox["_",
        FontWeight->Bold,
        FontColor->RGBColor[0, 0.5, 0]]], "1", "-"], ")"}], "3"]}], "+", 
  RowBox[{"162", " ", 
   SuperscriptBox[
    RowBox[{"(", 
     SubsuperscriptBox[
      OverscriptBox[
       StyleBox["\[Eta]0",
        FontWeight->Bold,
        FontColor->RGBColor[0, 0.5, 0]], 
       StyleBox["_",
        FontWeight->Bold,
        FontColor->RGBColor[0, 0.5, 0]]], "1", "-"], ")"}], 
    "4"]}]}]], "Output",
 CellChangeTimes->{3.568984188865348*^9, 3.568984272143589*^9}]
}, Open  ]],

Cell["\<\
you can compute the next ones in the same way :\
\>", "Text",
 CellChangeTimes->{{3.56898432956798*^9, 3.5689843386236753`*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"manal", "[", 
    RowBox[{"[", "2", "]"}], "]"}], "=", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"manswer", "[", 
       RowBox[{"[", "2", "]"}], "]"}], "//", "ParallelCCompute"}], ")"}], "//.",
     "EndSimplify"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"manal", "[", 
    RowBox[{"[", "3", "]"}], "]"}], "=", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"manswer", "[", 
       RowBox[{"[", "3", "]"}], "]"}], "//", "ParallelCCompute"}], ")"}], "//.",
     "EndSimplify"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"manal", "[", 
    RowBox[{"[", "4", "]"}], "]"}], "=", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"manswer", "[", 
       RowBox[{"[", "4", "]"}], "]"}], "//", "ParallelCCompute"}], ")"}], "//.",
     "EndSimplify"}]}], ";"}]}], "Input",
 CellChangeTimes->{{3.568984180650135*^9, 3.5689841822024937`*^9}, {
  3.568984341729371*^9, 3.568984354290805*^9}}],

Cell[TextData[{
 "The most interested reader will, if he has several network-connected \
computers, perhaps be in interested in trying to use the functions \
PseudoparallelCompute implemented in UpWiseIntegrate.m\n\n\nOne would run\n",
 StyleBox["PrepareParallelComput[\[OpenCurlyDoubleQuote]CmptM1.data\
\[CloseCurlyDoubleQuote],manswer[[1]]];", "Code"],
 "\nto create a file where computers would share their computation for M1.\n\
Then many computers would run ",
 StyleBox["PseudoParallelCompute[\[OpenCurlyDoubleQuote]CmptM1.data\
\[CloseCurlyDoubleQuote]];", "Code"],
 " toperformed a shared computation."
}], "Text",
 CellChangeTimes->{{3.5689843617425613`*^9, 3.5689845520678663`*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["\<\
explicit computation of wrapping energy (time-consuming)\
\>", "Subsubsection",
 CellChangeTimes->{{3.568983911040834*^9, 3.568983928986823*^9}, {
   3.5690145914220667`*^9, 3.569014596021583*^9}, 3.5690148028884373`*^9}],

Cell["\<\
up to 7 loops, H is implemented into the package, hence the simple (though \
time consuming) code below computes what is expected :\
\>", "Text",
 CellChangeTimes->{{3.568984900427593*^9, 3.5689849437228203`*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Ewrap", "[", "4", "]"}]], "Input",
 CellChangeTimes->{3.568985120568245*^9}],

Cell[BoxData[
 RowBox[{"324", "+", 
  RowBox[{"864", " ", 
   SubscriptBox[
    StyleBox["\[Zeta]",
     FontWeight->Bold,
     FontColor->GrayLevel[0.4]], "3"]}], "-", 
  RowBox[{"1440", " ", 
   SubscriptBox[
    StyleBox["\[Zeta]",
     FontWeight->Bold,
     FontColor->GrayLevel[0.4]], "5"]}]}]], "Output",
 CellChangeTimes->{3.5689851288871613`*^9, 3.568986658884667*^9}]
}, Open  ]],

Cell[BoxData[{
 RowBox[{
  RowBox[{"Ewrap", "[", "5", "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Ewrap", "[", "6", "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Ewrap", "[", "7", "]"}], ";"}]}], "Input",
 CellChangeTimes->{{3.568985153423951*^9, 3.568985163758855*^9}}],

Cell["\<\
for 8 loops, by contrast, one has to load H from the file \
\[OpenCurlyDoubleQuote]Hfivev3\[CloseCurlyDoubleQuote] :\
\>", "Text",
 CellChangeTimes->{{3.568984946786504*^9, 3.5689849617102833`*^9}, {
   3.568984994075885*^9, 3.568985001970264*^9}, 3.5690145301609592`*^9}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"H5", "=", 
   RowBox[{
    RowBox[{"Get", "[", "\"\<Hfivev3\>\"", "]"}], "/.", "subusu"}]}], 
  ";"}], "\n", 
 RowBox[{
  RowBox[{"\[Section]RuleBeforeInt", "=", 
   RowBox[{"{", 
    RowBox[{"u", "->", 
     RowBox[{"u", "-", 
      RowBox[{"I", "/", "2"}]}]}], "}"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{"H5I", "=", 
   RowBox[{
    RowBox[{"H5", "//", "\[DoubleStruckCapitalC]"}], "//", "CCompute"}]}], 
  ";"}]}], "Input",
 CellChangeTimes->{3.569014542562483*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{"EWrapOth", "=", 
   RowBox[{
    RowBox[{"Block", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"ParallelCCompute", "=", "Identity"}], ",", 
        RowBox[{"CCompute", "=", "Identity"}]}], "}"}], ",", 
      RowBox[{"Ewrap", "[", "8", "]"}]}], "]"}], "/.", 
    RowBox[{
     RowBox[{
      RowBox[{"H$", "[", "subsubsubsublead", "]"}], "[", "0", "]"}], "->", 
     "0"}]}]}], ";", 
  RowBox[{
   RowBox[{"Ewrap", "[", "8", "]"}], "=", 
   RowBox[{
    RowBox[{
     RowBox[{"2", " ", "I", " ", "H5I"}], " ", "+", " ", "EWrapOth"}], " ", "//",
     " ", "ParallelCCompute"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.568985278923279*^9, 3.568985334338705*^9}}],

Cell["\<\
Save it all, in order to reload it easily :\
\>", "Text",
 CellChangeTimes->{{3.568985345032672*^9, 3.568985360640183*^9}, 
   3.5689865659028597`*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Block", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"XX", "=", 
      RowBox[{"DownValues", "@", "Ewrap"}]}], "}"}], ",", 
    RowBox[{"Block", "[", 
     RowBox[{
      RowBox[{"{", "Ewrap", "}"}], ",", 
      RowBox[{
       RowBox[{
        RowBox[{"DownValues", "[", "Ewrap", "]"}], "=", 
        RowBox[{"XX", "[", 
         RowBox[{"[", 
          RowBox[{";;", 
           RowBox[{"-", "2"}]}], "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"Save", "[", 
        RowBox[{
         RowBox[{"ToFileName", "[", 
          RowBox[{"$PathToPackages", ",", "\"\<NumericIntegrals.data\>\""}], 
          "]"}], ",", 
         RowBox[{"{", 
          RowBox[{"manal", ",", "Ewrap"}], "}"}]}], "]"}], ";"}]}], "]"}]}], 
   "]"}], ";"}]], "Input",
 CellChangeTimes->{{3.568990203162859*^9, 3.568990259036995*^9}}],

Cell["\<\
the above code aims at preventing the general value of Ewrap[lp_] from beeing \
saved\
\>", "Text",
 CellChangeTimes->{{3.568986799786729*^9, 3.5689868244257936`*^9}, {
  3.568990303683651*^9, 3.568990309017294*^9}, {3.569014582894107*^9, 
  3.5690145841817083`*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["\<\
loading precomputed m1, m2, m3, m4 and wrapping energy\
\>", "Subsubsection",
 CellChangeTimes->{{3.568983887424988*^9, 3.568983892912072*^9}, {
  3.568983930585053*^9, 3.568983935295397*^9}, {3.5690145979748707`*^9, 
  3.569014600380869*^9}, {3.569014805958597*^9, 3.5690148062532454`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Get", "[", "\"\<NumericIntegrals.data\>\"", "]"}], ";"}]], "Input",\

 CellChangeTimes->{{3.568986582602351*^9, 3.5689865902356977`*^9}}]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell["Final result", "Subsection",
 CellChangeTimes->{{3.568983896671784*^9, 3.568983939887683*^9}}],

Cell["\<\
If the computations above were skipped, essential precomputed data can be \
loaded by\
\>", "Text",
 CellChangeTimes->{{3.569014829347763*^9, 3.5690148555873423`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Get", "[", "\"\<NumericIntegrals.data\>\"", "]"}], ";"}]], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"\[Delta]E4", "=", 
  RowBox[{"Ewrap", "[", "4", "]"}]}]], "Input",
 CellChangeTimes->{{3.568990341115388*^9, 3.5689903502642813`*^9}}],

Cell[BoxData[
 RowBox[{"324", "+", 
  RowBox[{"864", " ", 
   SubscriptBox[
    StyleBox["\[Zeta]",
     FontWeight->Bold,
     FontColor->GrayLevel[0.4]], "3"]}], "-", 
  RowBox[{"1440", " ", 
   SubscriptBox[
    StyleBox["\[Zeta]",
     FontWeight->Bold,
     FontColor->GrayLevel[0.4]], "5"]}]}]], "Output",
 CellChangeTimes->{3.568990351981647*^9, 3.56899130428445*^9, 
  3.568993489131508*^9, 3.568993779172039*^9, 3.5690147126540413`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"\[Delta]E5", "=", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"(", 
       RowBox[{"4", " ", "I", " ", 
        RowBox[{"manal", "[", 
         RowBox[{"[", "1", "]"}], "]"}]}], ")"}], "/", 
      RowBox[{"Sqrt", "[", "3", "]"}]}], "+", 
     RowBox[{"Ewrap", "[", "5", "]"}]}], "/.", 
    RowBox[{"g", "\[Rule]", "1"}]}], "/.", "EndSimplify"}]}]], "Input",
 CellChangeTimes->{{3.56899035737033*^9, 3.568990385884788*^9}, {
  3.568990430739627*^9, 3.568990445164646*^9}, {3.56899061157579*^9, 
  3.5689906132774277`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"-", "11340"}], "+", 
  RowBox[{"2592", " ", 
   SubscriptBox[
    StyleBox["\[Zeta]",
     FontWeight->Bold,
     FontColor->GrayLevel[0.4]], "3"]}], "-", 
  RowBox[{"5184", " ", 
   SubsuperscriptBox[
    StyleBox["\[Zeta]",
     FontWeight->Bold,
     FontColor->GrayLevel[0.4]], "3", "2"]}], "-", 
  RowBox[{"11520", " ", 
   SubscriptBox[
    StyleBox["\[Zeta]",
     FontWeight->Bold,
     FontColor->GrayLevel[0.4]], "5"]}], "+", 
  RowBox[{"30240", " ", 
   SubscriptBox[
    StyleBox["\[Zeta]",
     FontWeight->Bold,
     FontColor->GrayLevel[0.4]], "7"]}]}]], "Output",
 CellChangeTimes->{
  3.568990386279282*^9, {3.568990437379827*^9, 3.568990445843937*^9}, 
   3.5689906137014017`*^9, 3.568991536328937*^9, 3.568993489264461*^9, 
   3.568993779302137*^9, 3.5690147141506147`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"\[Delta]E6", "=", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"4", " ", "I", " ", 
      RowBox[{
       RowBox[{"manal", "[", 
        RowBox[{"[", "2", "]"}], "]"}], "/", 
       RowBox[{"Sqrt", "[", "3", "]"}]}]}], "-", 
     RowBox[{"20", " ", "I", " ", 
      RowBox[{
       RowBox[{"manal", "[", 
        RowBox[{"[", "1", "]"}], "]"}], "/", 
       RowBox[{"Sqrt", "[", "3", "]"}]}]}], "+", 
     RowBox[{"Ewrap", "[", "6", "]"}]}], "/.", 
    RowBox[{"g", "->", "1"}]}], "/.", "EndSimplify"}]}]], "Input",
 CellChangeTimes->{{3.568990634958269*^9, 3.5689906486635027`*^9}}],

Cell[BoxData[
 RowBox[{"261468", "-", 
  RowBox[{"207360", " ", 
   SubscriptBox[
    StyleBox["\[Zeta]",
     FontWeight->Bold,
     FontColor->GrayLevel[0.4]], "3"]}], "-", 
  RowBox[{"20736", " ", 
   SubsuperscriptBox[
    StyleBox["\[Zeta]",
     FontWeight->Bold,
     FontColor->GrayLevel[0.4]], "3", "2"]}], "+", 
  RowBox[{"156384", " ", 
   SubscriptBox[
    StyleBox["\[Zeta]",
     FontWeight->Bold,
     FontColor->GrayLevel[0.4]], "5"]}], "+", 
  RowBox[{"155520", " ", 
   SubscriptBox[
    StyleBox["\[Zeta]",
     FontWeight->Bold,
     FontColor->GrayLevel[0.4]], "3"], " ", 
   SubscriptBox[
    StyleBox["\[Zeta]",
     FontWeight->Bold,
     FontColor->GrayLevel[0.4]], "5"]}], "+", 
  RowBox[{"105840", " ", 
   SubscriptBox[
    StyleBox["\[Zeta]",
     FontWeight->Bold,
     FontColor->GrayLevel[0.4]], "7"]}], "-", 
  RowBox[{"489888", " ", 
   SubscriptBox[
    StyleBox["\[Zeta]",
     FontWeight->Bold,
     FontColor->GrayLevel[0.4]], "9"]}]}]], "Output",
 CellChangeTimes->{3.568990650377684*^9, 3.568991537375506*^9, 
  3.5689934908373613`*^9, 3.5689937794661283`*^9, 3.5690147157670507`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"\[Delta]E7", "=", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"4", " ", "I", " ", 
      RowBox[{
       RowBox[{"manal", "[", 
        RowBox[{"[", "3", "]"}], "]"}], "/", 
       RowBox[{"Sqrt", "[", "3", "]"}]}]}], "-", 
     RowBox[{"20", " ", "I", " ", 
      RowBox[{
       RowBox[{"manal", "[", 
        RowBox[{"[", "2", "]"}], "]"}], "/", 
       RowBox[{"Sqrt", "[", "3", "]"}]}]}], "+", 
     RowBox[{"56", "I", " ", 
      RowBox[{"Sqrt", "[", "3", "]"}], 
      RowBox[{"manal", "[", 
       RowBox[{"[", "1", "]"}], "]"}]}], "+", 
     RowBox[{"Ewrap", "[", "7", "]"}]}], "/.", 
    RowBox[{"g", "->", "1"}]}], "/.", "EndSimplify"}]}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{"-", "5012280"}], "+", 
  RowBox[{"4532544", " ", 
   SubscriptBox[
    StyleBox["\[Zeta]",
     FontWeight->Bold,
     FontColor->GrayLevel[0.4]], "3"]}], "-", 
  RowBox[{"425088", " ", 
   SubsuperscriptBox[
    StyleBox["\[Zeta]",
     FontWeight->Bold,
     FontColor->GrayLevel[0.4]], "3", "2"]}], "+", 
  RowBox[{"124416", " ", 
   SubsuperscriptBox[
    StyleBox["\[Zeta]",
     FontWeight->Bold,
     FontColor->GrayLevel[0.4]], "3", "3"]}], "-", 
  RowBox[{"808992", " ", 
   SubscriptBox[
    StyleBox["\[Zeta]",
     FontWeight->Bold,
     FontColor->GrayLevel[0.4]], "5"]}], "+", 
  RowBox[{"411264", " ", 
   SubscriptBox[
    StyleBox["\[Zeta]",
     FontWeight->Bold,
     FontColor->GrayLevel[0.4]], "3"], " ", 
   SubscriptBox[
    StyleBox["\[Zeta]",
     FontWeight->Bold,
     FontColor->GrayLevel[0.4]], "5"]}], "-", 
  RowBox[{"993600", " ", 
   SubsuperscriptBox[
    StyleBox["\[Zeta]",
     FontWeight->Bold,
     FontColor->GrayLevel[0.4]], "5", "2"]}], "-", 
  RowBox[{"1726704", " ", 
   SubscriptBox[
    StyleBox["\[Zeta]",
     FontWeight->Bold,
     FontColor->GrayLevel[0.4]], "7"]}], "-", 
  RowBox[{"1935360", " ", 
   SubscriptBox[
    StyleBox["\[Zeta]",
     FontWeight->Bold,
     FontColor->GrayLevel[0.4]], "3"], " ", 
   SubscriptBox[
    StyleBox["\[Zeta]",
     FontWeight->Bold,
     FontColor->GrayLevel[0.4]], "7"]}], "-", 
  RowBox[{"1174176", " ", 
   SubscriptBox[
    StyleBox["\[Zeta]",
     FontWeight->Bold,
     FontColor->GrayLevel[0.4]], "9"]}], "+", 
  RowBox[{"7318080", " ", 
   SubscriptBox[
    StyleBox["\[Zeta]",
     FontWeight->Bold,
     FontColor->GrayLevel[0.4]], "11"]}]}]], "Output",
 CellChangeTimes->{3.5689906664088497`*^9, 3.568991539670302*^9, 
  3.5689934932208*^9, 3.5689937799763937`*^9, 3.569014717813065*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"E8", "=", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"Ewrap", "[", "8", "]"}], "+", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{
        RowBox[{"-", "31857132"}], "-", 
        FractionBox[
         RowBox[{
          RowBox[{"(", 
           RowBox[{"1844", " ", "\[ImaginaryI]"}], ")"}], " ", "m1"}], 
         SqrtBox["3"]], "+", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{"56", " ", "\[ImaginaryI]"}], ")"}], " ", 
         SqrtBox["3"], " ", "m2"}], "-", 
        FractionBox[
         RowBox[{
          RowBox[{"(", 
           RowBox[{"20", " ", "\[ImaginaryI]"}], ")"}], " ", "m3"}], 
         SqrtBox["3"]], "+", 
        FractionBox[
         RowBox[{
          RowBox[{"(", 
           RowBox[{"4", " ", "\[ImaginaryI]"}], ")"}], " ", "m4"}], 
         SqrtBox["3"]], "-", 
        RowBox[{"8912160", " ", 
         SubscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "3"]}], "-", 
        RowBox[{"79488", " ", 
         SubsuperscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "3", "2"]}], "-", 
        RowBox[{"7486848", " ", 
         SubscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "5"]}], "-", 
        RowBox[{"69120", " ", 
         SubscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "3"], " ", 
         SubscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "5"]}], "-", 
        RowBox[{"6342624", " ", 
         SubscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "7"]}], "-", 
        RowBox[{"5370624", " ", 
         SubscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "9"]}], "-", 
        RowBox[{"3991680", " ", 
         SubscriptBox[
          StyleBox["\[Zeta]",
           FontWeight->Bold,
           FontColor->GrayLevel[0.4]], "11"]}]}], "/.", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"m1", "->", 
          RowBox[{"manal", "[", 
           RowBox[{"[", "1", "]"}], "]"}]}], ",", 
         RowBox[{"m2", "->", 
          RowBox[{"manal", "[", 
           RowBox[{"[", "2", "]"}], "]"}]}], ",", 
         RowBox[{"m3", "->", 
          RowBox[{"manal", "[", 
           RowBox[{"[", "3", "]"}], "]"}]}], ",", 
         RowBox[{"m4", "->", 
          RowBox[{"manal", "[", 
           RowBox[{"[", "4", "]"}], "]"}]}]}], "}"}]}], ")"}]}], "/.", 
    RowBox[{"g", "->", "1"}]}], "/.", "EndSimplify"}]}]], "Input",
 CellChangeTimes->{{3.568990725175391*^9, 3.568990729366932*^9}, {
  3.568990786225315*^9, 3.568990786477214*^9}}],

Cell[BoxData[
 RowBox[{"54408192", "-", 
  RowBox[{"83496960", " ", 
   SubscriptBox[
    StyleBox["\[Zeta]",
     FontWeight->Bold,
     FontColor->GrayLevel[0.4]], "3"]}], "+", 
  RowBox[{
   FractionBox["90326016", "175"], " ", 
   SubsuperscriptBox[
    StyleBox["\[Zeta]",
     FontWeight->Bold,
     FontColor->GrayLevel[0.4]], "2", "4"], " ", 
   SubscriptBox[
    StyleBox["\[Zeta]",
     FontWeight->Bold,
     FontColor->GrayLevel[0.4]], "3"]}], "+", 
  RowBox[{"7934976", " ", 
   SubsuperscriptBox[
    StyleBox["\[Zeta]",
     FontWeight->Bold,
     FontColor->GrayLevel[0.4]], "3", "2"]}], "+", 
  RowBox[{"1990656", " ", 
   SubsuperscriptBox[
    StyleBox["\[Zeta]",
     FontWeight->Bold,
     FontColor->GrayLevel[0.4]], "3", "3"]}], "-", 
  RowBox[{"19678464", " ", 
   SubscriptBox[
    StyleBox["\[Zeta]",
     FontWeight->Bold,
     FontColor->GrayLevel[0.4]], "5"]}], "+", 
  RowBox[{
   FractionBox["46531584", "35"], " ", 
   SubsuperscriptBox[
    StyleBox["\[Zeta]",
     FontWeight->Bold,
     FontColor->GrayLevel[0.4]], "2", "3"], " ", 
   SubscriptBox[
    StyleBox["\[Zeta]",
     FontWeight->Bold,
     FontColor->GrayLevel[0.4]], "5"]}], "-", 
  RowBox[{"4354560", " ", 
   SubscriptBox[
    StyleBox["\[Zeta]",
     FontWeight->Bold,
     FontColor->GrayLevel[0.4]], "3"], " ", 
   SubscriptBox[
    StyleBox["\[Zeta]",
     FontWeight->Bold,
     FontColor->GrayLevel[0.4]], "5"]}], "-", 
  RowBox[{"3939840", " ", 
   SubsuperscriptBox[
    StyleBox["\[Zeta]",
     FontWeight->Bold,
     FontColor->GrayLevel[0.4]], "3", "2"], " ", 
   SubscriptBox[
    StyleBox["\[Zeta]",
     FontWeight->Bold,
     FontColor->GrayLevel[0.4]], "5"]}], "+", 
  RowBox[{"2384640", " ", 
   SubsuperscriptBox[
    StyleBox["\[Zeta]",
     FontWeight->Bold,
     FontColor->GrayLevel[0.4]], "5", "2"]}], "+", 
  RowBox[{"21868704", " ", 
   SubscriptBox[
    StyleBox["\[Zeta]",
     FontWeight->Bold,
     FontColor->GrayLevel[0.4]], "7"]}], "+", 
  RowBox[{"3421440", " ", 
   SubsuperscriptBox[
    StyleBox["\[Zeta]",
     FontWeight->Bold,
     FontColor->GrayLevel[0.4]], "2", "2"], " ", 
   SubscriptBox[
    StyleBox["\[Zeta]",
     FontWeight->Bold,
     FontColor->GrayLevel[0.4]], "7"]}], "-", 
  RowBox[{"6229440", " ", 
   SubscriptBox[
    StyleBox["\[Zeta]",
     FontWeight->Bold,
     FontColor->GrayLevel[0.4]], "3"], " ", 
   SubscriptBox[
    StyleBox["\[Zeta]",
     FontWeight->Bold,
     FontColor->GrayLevel[0.4]], "7"]}], "+", 
  RowBox[{"22256640", " ", 
   SubscriptBox[
    StyleBox["\[Zeta]",
     FontWeight->Bold,
     FontColor->GrayLevel[0.4]], "5"], " ", 
   SubscriptBox[
    StyleBox["\[Zeta]",
     FontWeight->Bold,
     FontColor->GrayLevel[0.4]], "7"]}], "+", 
  RowBox[{"9327744", " ", 
   SubscriptBox[
    StyleBox["\[Zeta]",
     FontWeight->Bold,
     FontColor->GrayLevel[0.4]], "9"]}], "+", 
  RowBox[{"12659328", " ", 
   SubscriptBox[
    StyleBox["\[Zeta]",
     FontWeight->Bold,
     FontColor->GrayLevel[0.4]], "2"], " ", 
   SubscriptBox[
    StyleBox["\[Zeta]",
     FontWeight->Bold,
     FontColor->GrayLevel[0.4]], "9"]}], "+", 
  RowBox[{"23224320", " ", 
   SubscriptBox[
    StyleBox["\[Zeta]",
     FontWeight->Bold,
     FontColor->GrayLevel[0.4]], "3"], " ", 
   SubscriptBox[
    StyleBox["\[Zeta]",
     FontWeight->Bold,
     FontColor->GrayLevel[0.4]], "9"]}], "-", 
  RowBox[{"26653968", " ", 
   SubscriptBox[
    StyleBox["\[Zeta]",
     FontWeight->Bold,
     FontColor->GrayLevel[0.4]], "11"]}], "-", 
  RowBox[{"106007616", " ", 
   SubscriptBox[
    StyleBox["\[Zeta]",
     FontWeight->Bold,
     FontColor->GrayLevel[0.4]], "13"]}], "-", 
  RowBox[{"684288", " ", 
   SubscriptBox[
    StyleBox["\[Zeta]",
     FontWeight->Bold,
     FontColor->GrayLevel[0.4]], 
    RowBox[{"1", ",", "2", ",", "8"}]]}], "+", 
  RowBox[{"248832", " ", 
   SuperscriptBox[
    RowBox[{"(", 
     SubsuperscriptBox[
      StyleBox["\[Eta]0",
       FontWeight->Bold,
       FontColor->RGBColor[0, 0.5, 0]], "4", "+"], ")"}], "2"]}], "-", 
  RowBox[{"497664", " ", 
   SubsuperscriptBox[
    StyleBox["\[Eta]0",
     FontWeight->Bold,
     FontColor->RGBColor[0, 0.5, 0]], "3", "+"], " ", 
   SubsuperscriptBox[
    StyleBox["\[Eta]0",
     FontWeight->Bold,
     FontColor->RGBColor[0, 0.5, 0]], "5", "+"]}], "+", 
  RowBox[{"248832", " ", 
   SubsuperscriptBox[
    StyleBox["\[Eta]0",
     FontWeight->Bold,
     FontColor->RGBColor[0, 0.5, 0]], "8", "+"]}], "+", 
  RowBox[{"497664", " ", 
   SubsuperscriptBox[
    StyleBox["\[Eta]0",
     FontWeight->Bold,
     FontColor->RGBColor[0, 0.5, 0]], "4", "+"], " ", 
   SubsuperscriptBox[
    StyleBox["\[Eta]0",
     FontWeight->Bold,
     FontColor->RGBColor[0, 0.5, 0]], 
    RowBox[{"1", ",", "3"}], "+"]}], "+", 
  RowBox[{"248832", " ", 
   SuperscriptBox[
    RowBox[{"(", 
     SubsuperscriptBox[
      StyleBox["\[Eta]0",
       FontWeight->Bold,
       FontColor->RGBColor[0, 0.5, 0]], 
      RowBox[{"1", ",", "3"}], "+"], ")"}], "2"]}], "-", 
  RowBox[{"497664", " ", 
   SubsuperscriptBox[
    StyleBox["\[Eta]0",
     FontWeight->Bold,
     FontColor->RGBColor[0, 0.5, 0]], "3", "+"], " ", 
   SubsuperscriptBox[
    StyleBox["\[Eta]0",
     FontWeight->Bold,
     FontColor->RGBColor[0, 0.5, 0]], 
    RowBox[{"1", ",", "4"}], "+"]}], "-", 
  RowBox[{"248832", " ", 
   SubsuperscriptBox[
    StyleBox["\[Eta]0",
     FontWeight->Bold,
     FontColor->RGBColor[0, 0.5, 0]], 
    RowBox[{"2", ",", "6"}], "+"]}], "+", 
  RowBox[{"497664", " ", 
   SubsuperscriptBox[
    StyleBox["\[Eta]0",
     FontWeight->Bold,
     FontColor->RGBColor[0, 0.5, 0]], 
    RowBox[{"3", ",", "5"}], "+"]}], "-", 
  RowBox[{"497664", " ", 
   SubsuperscriptBox[
    StyleBox["\[Eta]0",
     FontWeight->Bold,
     FontColor->RGBColor[0, 0.5, 0]], "3", "+"], " ", 
   SubsuperscriptBox[
    StyleBox["\[Eta]0",
     FontWeight->Bold,
     FontColor->RGBColor[0, 0.5, 0]], 
    RowBox[{"1", ",", "1", ",", "3"}], "+"]}], "-", 
  RowBox[{"497664", " ", 
   SubsuperscriptBox[
    StyleBox["\[Eta]0",
     FontWeight->Bold,
     FontColor->RGBColor[0, 0.5, 0]], 
    RowBox[{"2", ",", "3", ",", "3"}], "+"]}], "+", 
  RowBox[{"497664", " ", 
   SubsuperscriptBox[
    StyleBox["\[Eta]0",
     FontWeight->Bold,
     FontColor->RGBColor[0, 0.5, 0]], 
    RowBox[{"3", ",", "1", ",", "4"}], "+"]}], "+", 
  RowBox[{"497664", " ", 
   SubsuperscriptBox[
    StyleBox["\[Eta]0",
     FontWeight->Bold,
     FontColor->RGBColor[0, 0.5, 0]], 
    RowBox[{"3", ",", "1", ",", "1", ",", "3"}], "+"]}]}]], "Output",
 CellChangeTimes->{3.568993781811759*^9, 3.569014723853197*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"E8", "=", 
  RowBox[{
   RowBox[{
    RowBox[{"E8", "/.", " ", "sub\[Eta]0\[Eta]"}], " ", "//", " ", 
    "FuntoMHZbasis"}], "//", "EndSimplify"}]}]], "Input"],

Cell[BoxData[
 RowBox[{"54408192", "-", 
  RowBox[{"83496960", " ", 
   SubscriptBox[
    StyleBox["\[Zeta]",
     FontWeight->Bold,
     FontColor->GrayLevel[0.4]], "3"]}], "+", 
  RowBox[{
   FractionBox["90326016", "175"], " ", 
   SubsuperscriptBox[
    StyleBox["\[Zeta]",
     FontWeight->Bold,
     FontColor->GrayLevel[0.4]], "2", "4"], " ", 
   SubscriptBox[
    StyleBox["\[Zeta]",
     FontWeight->Bold,
     FontColor->GrayLevel[0.4]], "3"]}], "+", 
  RowBox[{"7934976", " ", 
   SubsuperscriptBox[
    StyleBox["\[Zeta]",
     FontWeight->Bold,
     FontColor->GrayLevel[0.4]], "3", "2"]}], "+", 
  RowBox[{"1990656", " ", 
   SubsuperscriptBox[
    StyleBox["\[Zeta]",
     FontWeight->Bold,
     FontColor->GrayLevel[0.4]], "3", "3"]}], "-", 
  RowBox[{"19678464", " ", 
   SubscriptBox[
    StyleBox["\[Zeta]",
     FontWeight->Bold,
     FontColor->GrayLevel[0.4]], "5"]}], "+", 
  RowBox[{
   FractionBox["46531584", "35"], " ", 
   SubsuperscriptBox[
    StyleBox["\[Zeta]",
     FontWeight->Bold,
     FontColor->GrayLevel[0.4]], "2", "3"], " ", 
   SubscriptBox[
    StyleBox["\[Zeta]",
     FontWeight->Bold,
     FontColor->GrayLevel[0.4]], "5"]}], "-", 
  RowBox[{"4354560", " ", 
   SubscriptBox[
    StyleBox["\[Zeta]",
     FontWeight->Bold,
     FontColor->GrayLevel[0.4]], "3"], " ", 
   SubscriptBox[
    StyleBox["\[Zeta]",
     FontWeight->Bold,
     FontColor->GrayLevel[0.4]], "5"]}], "-", 
  RowBox[{"3939840", " ", 
   SubsuperscriptBox[
    StyleBox["\[Zeta]",
     FontWeight->Bold,
     FontColor->GrayLevel[0.4]], "3", "2"], " ", 
   SubscriptBox[
    StyleBox["\[Zeta]",
     FontWeight->Bold,
     FontColor->GrayLevel[0.4]], "5"]}], "+", 
  RowBox[{"2384640", " ", 
   SubsuperscriptBox[
    StyleBox["\[Zeta]",
     FontWeight->Bold,
     FontColor->GrayLevel[0.4]], "5", "2"]}], "+", 
  RowBox[{"21868704", " ", 
   SubscriptBox[
    StyleBox["\[Zeta]",
     FontWeight->Bold,
     FontColor->GrayLevel[0.4]], "7"]}], "+", 
  RowBox[{"3421440", " ", 
   SubsuperscriptBox[
    StyleBox["\[Zeta]",
     FontWeight->Bold,
     FontColor->GrayLevel[0.4]], "2", "2"], " ", 
   SubscriptBox[
    StyleBox["\[Zeta]",
     FontWeight->Bold,
     FontColor->GrayLevel[0.4]], "7"]}], "-", 
  RowBox[{"6229440", " ", 
   SubscriptBox[
    StyleBox["\[Zeta]",
     FontWeight->Bold,
     FontColor->GrayLevel[0.4]], "3"], " ", 
   SubscriptBox[
    StyleBox["\[Zeta]",
     FontWeight->Bold,
     FontColor->GrayLevel[0.4]], "7"]}], "+", 
  RowBox[{"22256640", " ", 
   SubscriptBox[
    StyleBox["\[Zeta]",
     FontWeight->Bold,
     FontColor->GrayLevel[0.4]], "5"], " ", 
   SubscriptBox[
    StyleBox["\[Zeta]",
     FontWeight->Bold,
     FontColor->GrayLevel[0.4]], "7"]}], "+", 
  RowBox[{"9327744", " ", 
   SubscriptBox[
    StyleBox["\[Zeta]",
     FontWeight->Bold,
     FontColor->GrayLevel[0.4]], "9"]}], "+", 
  RowBox[{"12659328", " ", 
   SubscriptBox[
    StyleBox["\[Zeta]",
     FontWeight->Bold,
     FontColor->GrayLevel[0.4]], "2"], " ", 
   SubscriptBox[
    StyleBox["\[Zeta]",
     FontWeight->Bold,
     FontColor->GrayLevel[0.4]], "9"]}], "+", 
  RowBox[{"23224320", " ", 
   SubscriptBox[
    StyleBox["\[Zeta]",
     FontWeight->Bold,
     FontColor->GrayLevel[0.4]], "3"], " ", 
   SubscriptBox[
    StyleBox["\[Zeta]",
     FontWeight->Bold,
     FontColor->GrayLevel[0.4]], "9"]}], "-", 
  RowBox[{"26653968", " ", 
   SubscriptBox[
    StyleBox["\[Zeta]",
     FontWeight->Bold,
     FontColor->GrayLevel[0.4]], "11"]}], "-", 
  RowBox[{"106007616", " ", 
   SubscriptBox[
    StyleBox["\[Zeta]",
     FontWeight->Bold,
     FontColor->GrayLevel[0.4]], "13"]}], "-", 
  RowBox[{"684288", " ", 
   SubscriptBox[
    StyleBox["\[Zeta]",
     FontWeight->Bold,
     FontColor->GrayLevel[0.4]], 
    RowBox[{"1", ",", "2", ",", "8"}]]}]}]], "Output",
 CellChangeTimes->{3.568991752849741*^9, 3.568991892480823*^9, 
  3.568993785004081*^9, 3.569014738063324*^9}]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"E8ABA", "=", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"-", "31857132"}], "-", 
      RowBox[{"8912160", "*", 
       RowBox[{
        RowBox[{"\[Zeta]$", "[", "3", "]"}], "[", "0", "]"}]}], "-", 
      RowBox[{"79488", "*", 
       RowBox[{
        RowBox[{
         RowBox[{"\[Zeta]$", "[", "3", "]"}], "[", "0", "]"}], "^", "2"}]}], 
      "-", 
      RowBox[{"7486848", "*", 
       RowBox[{
        RowBox[{"\[Zeta]$", "[", "5", "]"}], "[", "0", "]"}]}], "-", 
      RowBox[{"69120", "*", 
       RowBox[{
        RowBox[{"\[Zeta]$", "[", "3", "]"}], "[", "0", "]"}], "*", 
       RowBox[{
        RowBox[{"\[Zeta]$", "[", "5", "]"}], "[", "0", "]"}]}], "-", 
      RowBox[{"6342624", "*", 
       RowBox[{
        RowBox[{"\[Zeta]$", "[", "7", "]"}], "[", "0", "]"}]}], "-", 
      RowBox[{"5370624", "*", 
       RowBox[{
        RowBox[{"\[Zeta]$", "[", "9", "]"}], "[", "0", "]"}]}], "-", 
      RowBox[{"3991680", "*", 
       RowBox[{
        RowBox[{"\[Zeta]$", "[", "11", "]"}], "[", "0", "]"}]}]}], ")"}], "/.",
     "EndSimplify"}]}], ";"}]], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"\[Delta]E8", "=", 
  RowBox[{
   RowBox[{"E8", "-", "E8ABA"}], "/.", "EndSimplify"}]}]], "Input",
 CellChangeTimes->{{3.568993798173856*^9, 3.568993815562728*^9}}],

Cell[BoxData[
 RowBox[{"86265324", "-", 
  RowBox[{"74584800", " ", 
   SubscriptBox[
    StyleBox["\[Zeta]",
     FontWeight->Bold,
     FontColor->GrayLevel[0.4]], "3"]}], "+", 
  RowBox[{
   FractionBox["90326016", "175"], " ", 
   SubsuperscriptBox[
    StyleBox["\[Zeta]",
     FontWeight->Bold,
     FontColor->GrayLevel[0.4]], "2", "4"], " ", 
   SubscriptBox[
    StyleBox["\[Zeta]",
     FontWeight->Bold,
     FontColor->GrayLevel[0.4]], "3"]}], "+", 
  RowBox[{"8014464", " ", 
   SubsuperscriptBox[
    StyleBox["\[Zeta]",
     FontWeight->Bold,
     FontColor->GrayLevel[0.4]], "3", "2"]}], "+", 
  RowBox[{"1990656", " ", 
   SubsuperscriptBox[
    StyleBox["\[Zeta]",
     FontWeight->Bold,
     FontColor->GrayLevel[0.4]], "3", "3"]}], "-", 
  RowBox[{"12191616", " ", 
   SubscriptBox[
    StyleBox["\[Zeta]",
     FontWeight->Bold,
     FontColor->GrayLevel[0.4]], "5"]}], "+", 
  RowBox[{
   FractionBox["46531584", "35"], " ", 
   SubsuperscriptBox[
    StyleBox["\[Zeta]",
     FontWeight->Bold,
     FontColor->GrayLevel[0.4]], "2", "3"], " ", 
   SubscriptBox[
    StyleBox["\[Zeta]",
     FontWeight->Bold,
     FontColor->GrayLevel[0.4]], "5"]}], "-", 
  RowBox[{"4285440", " ", 
   SubscriptBox[
    StyleBox["\[Zeta]",
     FontWeight->Bold,
     FontColor->GrayLevel[0.4]], "3"], " ", 
   SubscriptBox[
    StyleBox["\[Zeta]",
     FontWeight->Bold,
     FontColor->GrayLevel[0.4]], "5"]}], "-", 
  RowBox[{"3939840", " ", 
   SubsuperscriptBox[
    StyleBox["\[Zeta]",
     FontWeight->Bold,
     FontColor->GrayLevel[0.4]], "3", "2"], " ", 
   SubscriptBox[
    StyleBox["\[Zeta]",
     FontWeight->Bold,
     FontColor->GrayLevel[0.4]], "5"]}], "+", 
  RowBox[{"2384640", " ", 
   SubsuperscriptBox[
    StyleBox["\[Zeta]",
     FontWeight->Bold,
     FontColor->GrayLevel[0.4]], "5", "2"]}], "+", 
  RowBox[{"28211328", " ", 
   SubscriptBox[
    StyleBox["\[Zeta]",
     FontWeight->Bold,
     FontColor->GrayLevel[0.4]], "7"]}], "+", 
  RowBox[{"3421440", " ", 
   SubsuperscriptBox[
    StyleBox["\[Zeta]",
     FontWeight->Bold,
     FontColor->GrayLevel[0.4]], "2", "2"], " ", 
   SubscriptBox[
    StyleBox["\[Zeta]",
     FontWeight->Bold,
     FontColor->GrayLevel[0.4]], "7"]}], "-", 
  RowBox[{"6229440", " ", 
   SubscriptBox[
    StyleBox["\[Zeta]",
     FontWeight->Bold,
     FontColor->GrayLevel[0.4]], "3"], " ", 
   SubscriptBox[
    StyleBox["\[Zeta]",
     FontWeight->Bold,
     FontColor->GrayLevel[0.4]], "7"]}], "+", 
  RowBox[{"22256640", " ", 
   SubscriptBox[
    StyleBox["\[Zeta]",
     FontWeight->Bold,
     FontColor->GrayLevel[0.4]], "5"], " ", 
   SubscriptBox[
    StyleBox["\[Zeta]",
     FontWeight->Bold,
     FontColor->GrayLevel[0.4]], "7"]}], "+", 
  RowBox[{"14698368", " ", 
   SubscriptBox[
    StyleBox["\[Zeta]",
     FontWeight->Bold,
     FontColor->GrayLevel[0.4]], "9"]}], "+", 
  RowBox[{"12659328", " ", 
   SubscriptBox[
    StyleBox["\[Zeta]",
     FontWeight->Bold,
     FontColor->GrayLevel[0.4]], "2"], " ", 
   SubscriptBox[
    StyleBox["\[Zeta]",
     FontWeight->Bold,
     FontColor->GrayLevel[0.4]], "9"]}], "+", 
  RowBox[{"23224320", " ", 
   SubscriptBox[
    StyleBox["\[Zeta]",
     FontWeight->Bold,
     FontColor->GrayLevel[0.4]], "3"], " ", 
   SubscriptBox[
    StyleBox["\[Zeta]",
     FontWeight->Bold,
     FontColor->GrayLevel[0.4]], "9"]}], "-", 
  RowBox[{"22662288", " ", 
   SubscriptBox[
    StyleBox["\[Zeta]",
     FontWeight->Bold,
     FontColor->GrayLevel[0.4]], "11"]}], "-", 
  RowBox[{"106007616", " ", 
   SubscriptBox[
    StyleBox["\[Zeta]",
     FontWeight->Bold,
     FontColor->GrayLevel[0.4]], "13"]}], "-", 
  RowBox[{"684288", " ", 
   SubscriptBox[
    StyleBox["\[Zeta]",
     FontWeight->Bold,
     FontColor->GrayLevel[0.4]], 
    RowBox[{"1", ",", "2", ",", "8"}]]}]}]], "Output",
 CellChangeTimes->{3.568993824808707*^9, 3.569014750609213*^9}]
}, Open  ]]
}, Closed]]
}, Closed]]
},
WindowSize->{1271, 688},
WindowMargins->{{Automatic, 9}, {Automatic, 0}},
ShowSelection->True,
Magnification:>FEPrivate`If[
  FEPrivate`Equal[FEPrivate`$VersionNumber, 6.], 2., 2. Inherited],
FrontEndVersion->"8.0 for Mac OS X x86 (32-bit, 64-bit Kernel) (July 22, \
2012)",
StyleDefinitions->Notebook[{
   Cell[
    StyleData[StyleDefinitions -> "Default.nb"]], 
   Cell[
    StyleData["Subtitle"], FontSize -> 48, Background -> 
    RGBColor[0.87, 0.94, 1]], 
   Cell[
    StyleData["Subsubtitle"], FontSize -> 36, Background -> 
    RGBColor[0.87, 0.94, 1]]}, Visible -> False, FrontEndVersion -> 
  "8.0 for Mac OS X x86 (32-bit, 64-bit Kernel) (July 22, 2012)", 
  StyleDefinitions -> "PrivateStylesheetFormatting.nb"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[CellGroupData[{
Cell[579, 22, 161, 2, 134, "Section"],
Cell[743, 26, 1472, 38, 355, "Input",
 InitializationCell->True],
Cell[2218, 66, 1393, 29, 235, "Input"]
}, Closed]],
Cell[CellGroupData[{
Cell[3648, 100, 202, 4, 70, "Section"],
Cell[CellGroupData[{
Cell[3875, 108, 212, 3, 1088, "Subsection"],
Cell[4090, 113, 1546, 48, 2400, "Input"]
}, Closed]],
Cell[CellGroupData[{
Cell[5673, 166, 143, 2, 768, "Subsection"],
Cell[5819, 170, 1263, 42, 1520, "Input"],
Cell[7085, 214, 515, 15, 1280, "Text"],
Cell[CellGroupData[{
Cell[7625, 233, 509, 13, 864, "Input"],
Cell[8137, 248, 1669, 56, 2672, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[9843, 309, 184, 4, 864, "Input"],
Cell[10030, 315, 1029, 35, 1808, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[11096, 355, 954, 30, 1504, "Input"],
Cell[12053, 387, 587, 17, 944, "Output"]
}, Open  ]],
Cell[12655, 407, 822, 27, 1504, "Text"],
Cell[13480, 436, 1024, 34, 1200, "Input"],
Cell[14507, 472, 376, 13, 880, "Text"]
}, Closed]],
Cell[CellGroupData[{
Cell[14920, 490, 356, 9, 848, "Subsection"],
Cell[CellGroupData[{
Cell[15301, 503, 838, 25, 1040, "Input"],
Cell[16142, 530, 2541, 82, 2128, "Output"]
}, Open  ]],
Cell[18698, 615, 199, 4, 832, "Text"],
Cell[18900, 621, 2113, 69, 1680, "Input"],
Cell[21016, 692, 97, 1, 832, "Text"],
Cell[21116, 695, 2024, 64, 1680, "Input"],
Cell[23143, 761, 88, 1, 832, "Text"],
Cell[CellGroupData[{
Cell[23256, 766, 2735, 80, 3088, "Input"],
Cell[25994, 848, 242, 4, 864, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[26273, 857, 4514, 121, 7104, "Input"],
Cell[30790, 980, 257, 4, 944, "Output"]
}, Open  ]]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[31108, 991, 376, 10, 70, "Section"],
Cell[CellGroupData[{
Cell[31509, 1005, 345, 9, 272, "Subsection"],
Cell[31857, 1016, 7235, 230, 3504, "Input"],
Cell[39095, 1248, 261, 5, 1312, "Text"],
Cell[39359, 1255, 265, 8, 832, "Text"],
Cell[39627, 1265, 5685, 199, 3024, "Input"],
Cell[45315, 1466, 513, 16, 960, "Input"],
Cell[45831, 1484, 635, 19, 1392, "Text"],
Cell[46469, 1505, 856, 30, 1488, "Text"]
}, Closed]],
Cell[CellGroupData[{
Cell[47362, 1540, 197, 4, 192, "Subsection"],
Cell[47562, 1546, 1756, 58, 4000, "Input"],
Cell[CellGroupData[{
Cell[49343, 1608, 745, 23, 3648, "Input"],
Cell[50091, 1633, 763, 24, 1296, "Output"]
}, Open  ]],
Cell[50869, 1660, 517, 17, 896, "Text"],
Cell[51389, 1679, 1814, 60, 1504, "Text"]
}, Closed]],
Cell[CellGroupData[{
Cell[53240, 1744, 400, 9, 212, "Subsection"],
Cell[CellGroupData[{
Cell[53665, 1757, 454, 12, 1040, "Input"],
Cell[54122, 1771, 1405, 47, 1824, "Output"]
}, Open  ]],
Cell[55542, 1821, 296, 5, 832, "Text"],
Cell[55841, 1828, 2819, 88, 3104, "Input"],
Cell[58663, 1918, 96, 1, 832, "Text"],
Cell[58762, 1921, 2218, 68, 1808, "Input"],
Cell[60983, 1991, 99, 1, 832, "Text"],
Cell[CellGroupData[{
Cell[61107, 1996, 4831, 126, 7680, "Input"],
Cell[65941, 2124, 311, 4, 1216, "Output"]
}, Open  ]]
}, Closed]],
Cell[CellGroupData[{
Cell[66301, 2134, 329, 4, 192, "Subsection"],
Cell[66633, 2140, 492, 8, 1312, "Text"],
Cell[CellGroupData[{
Cell[67150, 2152, 277, 7, 864, "Input"],
Cell[67430, 2161, 1109, 38, 1920, "Output"]
}, Open  ]],
Cell[68554, 2202, 661, 11, 1792, "Text"],
Cell[CellGroupData[{
Cell[69240, 2217, 151, 3, 864, "Input"],
Cell[69394, 2222, 1412, 47, 2208, "Output"]
}, Open  ]],
Cell[70821, 2272, 1471, 46, 2480, "Text"],
Cell[72295, 2320, 388, 10, 896, "Text"],
Cell[CellGroupData[{
Cell[72708, 2334, 407, 11, 1024, "Input"],
Cell[73118, 2347, 2484, 77, 3264, "Output"]
}, Open  ]],
Cell[75617, 2427, 270, 8, 832, "Text"],
Cell[CellGroupData[{
Cell[75912, 2439, 725, 21, 2000, "Input"],
Cell[76640, 2462, 122, 2, 1216, "Output"]
}, Open  ]],
Cell[76777, 2467, 420, 7, 832, "Text"],
Cell[77200, 2476, 649, 21, 1600, "Input"],
Cell[CellGroupData[{
Cell[77874, 2501, 494, 14, 864, "Input"],
Cell[78371, 2517, 639, 20, 1712, "Output"]
}, Open  ]],
Cell[79025, 2540, 1001, 31, 864, "Text"],
Cell[80029, 2573, 714, 23, 1520, "Input"],
Cell[80746, 2598, 503, 12, 1376, "Text"],
Cell[81252, 2612, 212, 7, 832, "Text"],
Cell[81467, 2621, 2838, 97, 4880, "Input"],
Cell[84308, 2720, 152, 3, 832, "Text"],
Cell[84463, 2725, 1237, 42, 2048, "Input"],
Cell[CellGroupData[{
Cell[85725, 2771, 208, 4, 864, "Input"],
Cell[85936, 2777, 10392, 346, 8640, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[96365, 3128, 152, 3, 1376, "Input"],
Cell[96520, 3133, 1470, 50, 2096, "Output"]
}, Open  ]],
Cell[98005, 3186, 332, 8, 1104, "Text"],
Cell[98340, 3196, 2779, 90, 3968, "Input"],
Cell[CellGroupData[{
Cell[101144, 3290, 741, 26, 2096, "Input"],
Cell[101888, 3318, 2135, 74, 1968, "Output"]
}, Open  ]],
Cell[104038, 3395, 206, 4, 832, "Text"],
Cell[CellGroupData[{
Cell[104269, 3403, 1997, 57, 4112, "Input"],
Cell[106269, 3462, 1108, 35, 1424, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[107414, 3502, 4098, 100, 6368, "Input"],
Cell[111515, 3604, 6802, 177, 4304, "Output"]
}, Open  ]],
Cell[118332, 3784, 126, 1, 832, "Text"],
Cell[CellGroupData[{
Cell[118483, 3789, 130, 2, 864, "Input"],
Cell[118616, 3793, 1245, 42, 2176, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[119898, 3840, 2040, 52, 6112, "Input"],
Cell[121941, 3894, 8164, 214, 7296, "Output"]
}, Open  ]],
Cell[130120, 4111, 141, 1, 832, "Text"],
Cell[130264, 4114, 2877, 73, 7760, "Input"],
Cell[CellGroupData[{
Cell[133166, 4191, 2162, 72, 6720, "Input"],
Cell[135331, 4265, 377, 5, 1216, "Output"],
Cell[135711, 4272, 513, 11, 1760, "Output"],
Cell[136227, 4285, 537, 12, 1776, "Output"],
Cell[136767, 4299, 747, 19, 1776, "Output"]
}, Open  ]],
Cell[137529, 4321, 181, 2, 832, "Text"],
Cell[CellGroupData[{
Cell[137735, 4327, 224, 5, 864, "Input"],
Cell[137962, 4334, 809, 28, 1856, "Output"]
}, Open  ]],
Cell[138786, 4365, 1216, 32, 1312, "Text"],
Cell[CellGroupData[{
Cell[140027, 4401, 1499, 43, 2288, "Input"],
Cell[141529, 4446, 1828, 56, 1888, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[143394, 4507, 509, 16, 1520, "Input"],
Cell[143906, 4525, 1706, 55, 1888, "Output"]
}, Open  ]],
Cell[145627, 4583, 902, 28, 1600, "Input"],
Cell[146532, 4613, 1064, 38, 1168, "Text"],
Cell[147599, 4653, 2396, 77, 1936, "Input"],
Cell[149998, 4732, 1544, 52, 1632, "Input"],
Cell[151545, 4786, 1732, 57, 1520, "Input"],
Cell[153280, 4845, 186, 2, 832, "Text"],
Cell[153469, 4849, 121, 1, 832, "Text"],
Cell[CellGroupData[{
Cell[153615, 4854, 1447, 41, 2800, "Input"],
Cell[155065, 4897, 4454, 133, 4304, "Output"],
Cell[159522, 5032, 2922, 85, 2016, "Output"]
}, Open  ]],
Cell[162459, 5120, 551, 12, 1792, "Text"],
Cell[163013, 5134, 228, 5, 832, "Text"],
Cell[CellGroupData[{
Cell[163266, 5143, 414, 10, 1584, "Input"],
Cell[163683, 5155, 2943, 85, 2016, "Output"]
}, Open  ]],
Cell[166641, 5243, 172, 2, 832, "Text"],
Cell[CellGroupData[{
Cell[166838, 5249, 125, 2, 864, "Input"],
Cell[166966, 5253, 2794, 82, 2016, "Output"]
}, Open  ]],
Cell[169775, 5338, 188, 4, 832, "Text"],
Cell[CellGroupData[{
Cell[169988, 5346, 1335, 41, 2800, "Input"],
Cell[171326, 5389, 517, 14, 1376, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[171880, 5408, 652, 19, 1520, "Input"],
Cell[172535, 5429, 264, 7, 1296, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[172836, 5441, 328, 6, 768, "Subsubsection"],
Cell[173167, 5449, 126, 3, 832, "Text"],
Cell[173296, 5454, 605, 20, 1520, "Input"],
Cell[173904, 5476, 183, 4, 832, "Text"],
Cell[174090, 5482, 1475, 43, 2592, "Text"],
Cell[175568, 5527, 93, 1, 832, "Text"],
Cell[175664, 5530, 2797, 96, 3040, "Input"],
Cell[178464, 5628, 2000, 68, 2064, "Input"],
Cell[180467, 5698, 1986, 60, 1744, "Input"],
Cell[182456, 5760, 3064, 96, 3600, "Input"],
Cell[185523, 5858, 266, 5, 1312, "Text"],
Cell[185792, 5865, 1670, 52, 2304, "Input"],
Cell[187465, 5919, 1118, 32, 1776, "Text"],
Cell[188586, 5953, 415, 9, 832, "Text"],
Cell[189004, 5964, 828, 27, 1440, "Input"],
Cell[189835, 5993, 539, 18, 1040, "Text"],
Cell[190377, 6013, 2743, 90, 4560, "Input"],
Cell[193123, 6105, 137, 3, 832, "Text"],
Cell[193263, 6110, 250, 5, 832, "Text"]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[193562, 6121, 542, 16, 216, "Subsection"],
Cell[CellGroupData[{
Cell[194129, 6141, 146, 2, 768, "Subsubsection"],
Cell[194278, 6145, 501, 15, 896, "Text"],
Cell[CellGroupData[{
Cell[194804, 6164, 170, 4, 912, "Input"],
Cell[194977, 6170, 27487, 781, 13520, "Output"]
}, Open  ]],
Cell[222479, 6954, 210, 4, 832, "Text"],
Cell[CellGroupData[{
Cell[222714, 6962, 652, 19, 1440, "Input"],
Cell[223369, 6983, 1861, 61, 1376, "Output"],
Cell[225233, 7046, 2809, 88, 2592, "Output"]
}, Open  ]],
Cell[228057, 7137, 350, 11, 880, "Text"],
Cell[228410, 7150, 210, 4, 832, "Text"]
}, Closed]],
Cell[CellGroupData[{
Cell[228657, 7159, 97, 1, 512, "Subsubsection"],
Cell[228757, 7162, 6574, 216, 3776, "Input"],
Cell[235334, 7380, 1839, 47, 2016, "Text"],
Cell[CellGroupData[{
Cell[237198, 7431, 529, 13, 1360, "Input"],
Cell[237730, 7446, 572, 14, 1376, "Output"],
Cell[238305, 7462, 2825, 79, 2656, "Output"]
}, Open  ]],
Cell[241145, 7544, 251, 5, 832, "Text"],
Cell[241399, 7551, 638, 19, 912, "Text"],
Cell[242040, 7572, 5770, 190, 6672, "Input"],
Cell[247813, 7764, 2253, 69, 2816, "Text"],
Cell[250069, 7835, 1750, 59, 1616, "Input"],
Cell[251822, 7896, 330, 6, 1312, "Text"],
Cell[252155, 7904, 732, 25, 1584, "Input"],
Cell[252890, 7931, 87, 1, 832, "Text"],
Cell[252980, 7934, 873, 26, 992, "Input"],
Cell[253856, 7962, 466, 7, 1312, "Text"]
}, Closed]],
Cell[CellGroupData[{
Cell[254359, 7974, 256, 3, 512, "Subsubsection"],
Cell[254618, 7979, 201, 4, 832, "Text"],
Cell[254822, 7985, 359, 6, 832, "Text"],
Cell[255184, 7993, 2458, 83, 1616, "Input"],
Cell[257645, 8078, 873, 25, 1360, "Text"],
Cell[258521, 8105, 912, 26, 3424, "Input"],
Cell[259436, 8133, 132, 3, 832, "Text"],
Cell[CellGroupData[{
Cell[259593, 8140, 838, 23, 3152, "Input"],
Cell[260434, 8165, 4334, 137, 4096, "Output"],
Cell[264771, 8304, 846, 22, 1264, "Output"],
Cell[265620, 8328, 369, 6, 1216, "Output"],
Cell[265992, 8336, 297, 4, 1216, "Output"]
}, Open  ]],
Cell[266304, 8343, 164, 3, 832, "Text"],
Cell[CellGroupData[{
Cell[266493, 8350, 1433, 43, 2672, "Input"],
Cell[267929, 8395, 92, 1, 1216, "Output"]
}, Open  ]],
Cell[268036, 8399, 146, 2, 832, "Text"],
Cell[268185, 8403, 915, 30, 2528, "Input"],
Cell[269103, 8435, 185, 4, 832, "Text"],
Cell[CellGroupData[{
Cell[269313, 8443, 958, 26, 3152, "Input"],
Cell[270274, 8471, 7472, 248, 6032, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[277783, 8724, 1342, 37, 3584, "Input"],
Cell[279128, 8763, 9396, 282, 9360, "Output"]
}, Open  ]],
Cell[288539, 9048, 95, 1, 832, "Text"],
Cell[CellGroupData[{
Cell[288659, 9053, 1013, 30, 2496, "Input"],
Cell[289675, 9085, 18662, 558, 9840, "Output"]
}, Open  ]],
Cell[308352, 9646, 102, 1, 832, "Text"],
Cell[308457, 9649, 1198, 32, 3632, "Input"],
Cell[309658, 9683, 285, 5, 1312, "Text"],
Cell[CellGroupData[{
Cell[309968, 9692, 435, 12, 1264, "Input"],
Cell[310406, 9706, 143, 2, 1216, "Output"]
}, Open  ]]
}, Closed]],
Cell[CellGroupData[{
Cell[310598, 9714, 166, 2, 512, "Subsubsection"],
Cell[310767, 9718, 731, 16, 1376, "Text"],
Cell[311501, 9736, 2458, 83, 1616, "Input"],
Cell[CellGroupData[{
Cell[313984, 9823, 375, 12, 864, "Input"],
Cell[314362, 9837, 186, 3, 1216, "Output"]
}, Open  ]],
Cell[314563, 9843, 1275, 44, 1504, "Input"],
Cell[315841, 9889, 118, 1, 832, "Text"],
Cell[315962, 9892, 3103, 112, 2752, "Input"],
Cell[319068, 10006, 731, 25, 1104, "Text"],
Cell[CellGroupData[{
Cell[319824, 10035, 3775, 94, 8144, "Input"],
Cell[323602, 10131, 4389, 125, 4512, "Output"]
}, Open  ]],
Cell[328006, 10259, 236, 5, 1312, "Text"],
Cell[328245, 10266, 153, 3, 832, "Text"],
Cell[328401, 10271, 525, 18, 1568, "Input"],
Cell[328929, 10291, 484, 13, 832, "Text"],
Cell[329416, 10306, 3251, 113, 4256, "Input"],
Cell[332670, 10421, 981, 27, 2272, "Text"],
Cell[333654, 10450, 98, 1, 832, "Text"],
Cell[333755, 10453, 3199, 108, 4480, "Input"],
Cell[336957, 10563, 107, 1, 832, "Text"],
Cell[337067, 10566, 2161, 74, 3072, "Input"],
Cell[339231, 10642, 99, 1, 832, "Text"],
Cell[339333, 10645, 3563, 96, 8864, "Input"],
Cell[342899, 10743, 8795, 224, 19168, "Input"],
Cell[CellGroupData[{
Cell[351719, 10971, 1941, 49, 5072, "Input"],
Cell[353663, 11022, 478, 10, 672, "Message"],
Cell[354144, 11034, 476, 10, 672, "Message"],
Cell[354623, 11046, 476, 10, 672, "Message"],
Cell[355102, 11058, 531, 11, 672, "Message"]
}, Open  ]],
Cell[355648, 11072, 175, 4, 832, "Text"],
Cell[355826, 11078, 3904, 103, 9968, "Input"],
Cell[359733, 11183, 233, 6, 1216, "Input"],
Cell[359969, 11191, 254, 5, 864, "Input"],
Cell[CellGroupData[{
Cell[360248, 11200, 1445, 37, 5744, "Input"],
Cell[361696, 11239, 1929, 41, 2320, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[363662, 11285, 1046, 28, 2128, "Input"],
Cell[364711, 11315, 4480, 107, 3920, "Output"]
}, Open  ]],
Cell[369206, 11425, 137, 3, 832, "Text"],
Cell[CellGroupData[{
Cell[369368, 11432, 1246, 31, 2800, "Input"],
Cell[370617, 11465, 1990, 43, 2320, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[372644, 11513, 362, 11, 864, "Input"],
Cell[373009, 11526, 1527, 36, 3584, "Output"]
}, Open  ]],
Cell[374551, 11565, 225, 4, 1312, "Text"]
}, Closed]],
Cell[CellGroupData[{
Cell[374813, 11574, 417, 7, 512, "Subsubsection"],
Cell[375233, 11583, 201, 4, 832, "Text"],
Cell[375437, 11589, 1354, 36, 2480, "Input"],
Cell[CellGroupData[{
Cell[376816, 11629, 1411, 41, 1664, "Input"],
Cell[378230, 11672, 108655, 2830, 51088, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[486922, 14507, 169, 4, 912, "Input"],
Cell[487094, 14513, 6148, 176, 3552, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[493279, 14694, 844, 27, 2432, "Input"],
Cell[494126, 14723, 173, 2, 864, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[494336, 14730, 870, 28, 2048, "Input"],
Cell[495209, 14760, 877, 28, 976, "Output"]
}, Open  ]]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[496147, 14795, 852, 26, 256, "Subsection"],
Cell[CellGroupData[{
Cell[497024, 14825, 147, 2, 768, "Subsubsection"],
Cell[CellGroupData[{
Cell[497196, 14831, 256, 6, 1360, "Input"],
Cell[497455, 14839, 1033, 33, 1648, "Output"],
Cell[498491, 14874, 32372, 954, 42272, "Output"]
}, Open  ]]
}, Closed]],
Cell[CellGroupData[{
Cell[530912, 15834, 391, 13, 512, "Subsubsection"],
Cell[531306, 15849, 1557, 50, 1552, "Input"],
Cell[532866, 15901, 274, 7, 864, "Text"],
Cell[533143, 15910, 2889, 96, 1616, "Input"],
Cell[536035, 16008, 174, 4, 832, "Text"],
Cell[536212, 16014, 1984, 69, 3072, "Input"],
Cell[538199, 16085, 543, 16, 880, "Text"],
Cell[538745, 16103, 1347, 42, 1648, "Input"],
Cell[540095, 16147, 135, 3, 832, "Text"],
Cell[540233, 16152, 803, 25, 1376, "Text"],
Cell[541039, 16179, 2918, 94, 3104, "Input"],
Cell[CellGroupData[{
Cell[543982, 16277, 503, 15, 1824, "Input"],
Cell[544488, 16294, 2323, 67, 3408, "Output"]
}, Open  ]],
Cell[546826, 16364, 4939, 146, 9888, "Input"],
Cell[551768, 16512, 165, 4, 832, "Text"],
Cell[551936, 16518, 2967, 94, 5216, "Input"],
Cell[CellGroupData[{
Cell[554928, 16616, 1400, 39, 3632, "Input"],
Cell[556331, 16657, 331, 6, 1216, "Output"],
Cell[556665, 16665, 331, 6, 1216, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[557033, 16676, 241, 6, 1216, "Input"],
Cell[557277, 16684, 8097, 216, 7184, "Output"]
}, Open  ]]
}, Closed]],
Cell[CellGroupData[{
Cell[565423, 16906, 369, 11, 576, "Subsubsection"],
Cell[565795, 16919, 456, 11, 880, "Text"],
Cell[566254, 16932, 815, 29, 1424, "Input"],
Cell[CellGroupData[{
Cell[567094, 16965, 1658, 50, 3936, "Input"],
Cell[568755, 17017, 1986, 58, 2000, "Output"]
}, Open  ]],
Cell[570756, 17078, 191, 4, 832, "Text"]
}, Closed]],
Cell[CellGroupData[{
Cell[570984, 17087, 394, 7, 512, "Subsubsection"],
Cell[571381, 17096, 534, 18, 1024, "Input"],
Cell[571918, 17116, 201, 5, 832, "Text"],
Cell[CellGroupData[{
Cell[572144, 17125, 224, 5, 1216, "Input"],
Cell[572371, 17132, 7090, 223, 7392, "Output"]
}, Open  ]],
Cell[579476, 17358, 128, 1, 832, "Text"],
Cell[CellGroupData[{
Cell[579629, 17363, 502, 15, 1712, "Input"],
Cell[580134, 17380, 953, 28, 1824, "Output"]
}, Open  ]]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[581148, 17415, 363, 12, 248, "Subsection"],
Cell[CellGroupData[{
Cell[581536, 17431, 145, 2, 192, "Subsubsection"],
Cell[581684, 17435, 89, 1, 160, "Item"],
Cell[581776, 17438, 199, 6, 228, "Text"],
Cell[581978, 17446, 897, 27, 308, "Input"],
Cell[582878, 17475, 303, 6, 328, "Text"],
Cell[583184, 17483, 897, 27, 576, "Input"],
Cell[584084, 17512, 1065, 34, 600, "Input"],
Cell[585152, 17548, 119, 1, 208, "Text"],
Cell[585274, 17551, 4299, 145, 800, "Input"],
Cell[589576, 17698, 312, 6, 208, "Text"],
Cell[589891, 17706, 1379, 47, 404, "Input"],
Cell[591273, 17755, 2350, 73, 1100, "Text"],
Cell[593626, 17830, 563, 18, 396, "Input"],
Cell[594192, 17850, 268, 5, 208, "Text"]
}, Open  ]],
Cell[CellGroupData[{
Cell[594497, 17860, 261, 3, 192, "Subsubsection"],
Cell[594761, 17865, 1379, 47, 1616, "Input"],
Cell[596143, 17914, 337, 6, 864, "Input"],
Cell[596483, 17922, 601, 19, 1504, "Input"],
Cell[CellGroupData[{
Cell[597109, 17945, 3100, 78, 6304, "Input"],
Cell[600212, 18025, 1917, 46, 1488, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[602166, 18076, 1508, 42, 2000, "Input"],
Cell[CellGroupData[{
Cell[603699, 18122, 691, 15, 640, "Print"],
Cell[604393, 18139, 691, 15, 640, "Print"],
Cell[605087, 18156, 691, 15, 640, "Print"],
Cell[605781, 18173, 691, 15, 640, "Print"]
}, Open  ]],
Cell[606487, 18191, 546, 11, 864, "Output"]
}, Open  ]],
Cell[607048, 18205, 311, 9, 832, "Text"],
Cell[607362, 18216, 1957, 51, 4240, "Input"],
Cell[CellGroupData[{
Cell[609344, 18271, 131, 2, 864, "Input"],
Cell[609478, 18275, 157, 3, 864, "Output"]
}, Open  ]],
Cell[609650, 18281, 138, 3, 864, "Input"],
Cell[609791, 18286, 4296, 123, 7472, "Input"],
Cell[614090, 18411, 121, 3, 832, "Text"],
Cell[CellGroupData[{
Cell[614236, 18418, 1874, 48, 4144, "Input"],
Cell[616113, 18468, 5592, 160, 5376, "Output"]
}, Open  ]],
Cell[621720, 18631, 1379, 47, 1616, "Input"],
Cell[CellGroupData[{
Cell[623124, 18682, 186, 5, 1504, "Input"],
Cell[623313, 18689, 645, 23, 1056, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[623995, 18717, 2312, 61, 6272, "Input"],
Cell[626310, 18780, 769, 14, 864, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[627116, 18799, 787, 16, 864, "Input"],
Cell[CellGroupData[{
Cell[627928, 18819, 712, 13, 640, "Print"],
Cell[628643, 18834, 813, 17, 640, "Print"],
Cell[629459, 18853, 815, 17, 640, "Print"],
Cell[630277, 18872, 813, 17, 640, "Print"]
}, Open  ]],
Cell[631105, 18892, 2021, 52, 2368, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[633163, 18949, 131, 2, 864, "Input"],
Cell[633297, 18953, 157, 3, 864, "Output"]
}, Open  ]],
Cell[633469, 18959, 138, 3, 864, "Input"],
Cell[633610, 18964, 5934, 170, 9200, "Input"],
Cell[639547, 19136, 121, 3, 832, "Text"],
Cell[CellGroupData[{
Cell[639693, 19143, 1919, 48, 4144, "Input"],
Cell[641615, 19193, 3527, 107, 3712, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[645179, 19305, 2084, 62, 3872, "Input"],
Cell[647266, 19369, 36129, 686, 3056, "Output"]
}, Open  ]]
}, Closed]]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[683468, 20063, 694, 19, 75, "Section"],
Cell[CellGroupData[{
Cell[684187, 20086, 518, 14, 1168, "Subsection"],
Cell[684708, 20102, 125, 3, 832, "Text"],
Cell[684836, 20107, 885, 28, 1040, "Input"],
Cell[685724, 20137, 419, 12, 832, "Text"],
Cell[CellGroupData[{
Cell[686168, 20153, 2108, 59, 4240, "Input"],
Cell[688279, 20214, 322, 6, 864, "Output"]
}, Open  ]],
Cell[688616, 20223, 281, 9, 880, "Text"],
Cell[688900, 20234, 808, 27, 1472, "Input"],
Cell[CellGroupData[{
Cell[689733, 20265, 1717, 50, 2896, "Input"],
Cell[691453, 20317, 318, 7, 864, "Output"]
}, Open  ]]
}, Closed]],
Cell[CellGroupData[{
Cell[691820, 20330, 440, 10, 928, "Subsection"],
Cell[CellGroupData[{
Cell[692285, 20344, 97, 1, 768, "Subsubsection"],
Cell[692385, 20347, 971, 29, 1776, "Text"],
Cell[693359, 20378, 3419, 104, 4368, "Input"],
Cell[696781, 20484, 1065, 26, 1680, "Text"],
Cell[697849, 20512, 2969, 88, 4256, "Input"],
Cell[700821, 20602, 951, 14, 3712, "Text"],
Cell[701775, 20618, 1685, 52, 2176, "Input"],
Cell[703463, 20672, 142, 2, 832, "Text"],
Cell[703608, 20676, 489, 12, 1200, "Text"],
Cell[CellGroupData[{
Cell[704122, 20692, 1701, 51, 4480, "Input"],
Cell[705826, 20745, 38776, 644, 5824, 21625, 361, "CachedBoxData", "BoxData", \
"Output"]
}, Open  ]],
Cell[744617, 21392, 101, 1, 832, "Text"],
Cell[744721, 21395, 260, 6, 1312, "Text"],
Cell[CellGroupData[{
Cell[745006, 21405, 3521, 98, 7440, "Input"],
Cell[748530, 21505, 390, 6, 944, "Output"]
}, Open  ]],
Cell[748935, 21514, 201, 4, 832, "Text"],
Cell[749139, 21520, 881, 26, 1632, "Input"],
Cell[750023, 21548, 219, 4, 1312, "Text"],
Cell[750245, 21554, 263, 7, 912, "Input"],
Cell[750511, 21563, 659, 20, 896, "Text"],
Cell[751173, 21585, 299, 6, 1312, "Text"],
Cell[751475, 21593, 3210, 98, 5072, "Input"],
Cell[754688, 21693, 105, 1, 832, "Text"],
Cell[754796, 21696, 731, 25, 2080, "Input"],
Cell[755530, 21723, 1454, 46, 3328, "Text"]
}, Closed]],
Cell[CellGroupData[{
Cell[757021, 21774, 919, 28, 1696, "Subsubsection"],
Cell[757943, 21804, 112, 1, 832, "Text"],
Cell[758058, 21807, 734, 25, 1568, "Input"],
Cell[758795, 21834, 292, 9, 832, "Text"],
Cell[CellGroupData[{
Cell[759112, 21847, 1789, 55, 4272, "Input"],
Cell[760904, 21904, 620, 19, 1360, "Output"]
}, Open  ]],
Cell[761539, 21926, 941, 29, 1664, "Text"],
Cell[762483, 21957, 539, 10, 1312, "Text"],
Cell[CellGroupData[{
Cell[763047, 21971, 950, 27, 3808, "Input"],
Cell[764000, 22000, 712, 20, 1424, "Output"]
}, Open  ]],
Cell[764727, 22023, 170, 3, 832, "Text"],
Cell[CellGroupData[{
Cell[764922, 22030, 757, 24, 1584, "Input"],
Cell[765682, 22056, 2680, 82, 5968, "Output"]
}, Open  ]],
Cell[768377, 22141, 690, 20, 1520, "Text"],
Cell[769070, 22163, 3696, 127, 9792, "Input"],
Cell[772769, 22292, 812, 25, 2256, "Input"]
}, Closed]],
Cell[CellGroupData[{
Cell[773618, 22322, 1754, 56, 1856, "Subsubsection"],
Cell[775375, 22380, 2993, 95, 5072, "Input"],
Cell[778371, 22477, 573, 16, 1552, "Text"],
Cell[778947, 22495, 486, 15, 1376, "Text"],
Cell[779436, 22512, 4321, 143, 8080, "Input"],
Cell[783760, 22657, 396, 11, 1376, "Text"],
Cell[784159, 22670, 1446, 50, 2256, "Input"]
}, Closed]],
Cell[CellGroupData[{
Cell[785642, 22725, 2755, 85, 2336, "Subsubsection"],
Cell[788400, 22812, 2993, 95, 5072, "Input"],
Cell[791396, 22909, 102, 1, 832, "Text"],
Cell[791501, 22912, 691, 24, 1568, "Input"],
Cell[792195, 22938, 267, 5, 1312, "Text"],
Cell[792465, 22945, 2499, 81, 3184, "Input"],
Cell[794967, 23028, 2261, 74, 3184, "Input"],
Cell[797231, 23104, 7089, 220, 14896, "Input"],
Cell[804323, 23326, 143, 3, 832, "Text"],
Cell[804469, 23331, 1588, 54, 4144, "Input"],
Cell[806060, 23387, 91, 1, 832, "Text"],
Cell[806154, 23390, 2446, 81, 3792, "Input"],
Cell[808603, 23473, 196, 4, 832, "Text"],
Cell[CellGroupData[{
Cell[808824, 23481, 402, 13, 1024, "Input"],
Cell[809229, 23496, 1827, 57, 1568, "Output"]
}, Open  ]],
Cell[811071, 23556, 125, 3, 832, "Text"],
Cell[CellGroupData[{
Cell[811221, 23563, 1627, 49, 3952, "Input"],
Cell[812851, 23614, 3400, 107, 1600, "Output"]
}, Open  ]],
Cell[816266, 23724, 212, 4, 832, "Text"],
Cell[CellGroupData[{
Cell[816503, 23732, 324, 11, 1408, "Input"],
Cell[816830, 23745, 164, 4, 944, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[817031, 23754, 5007, 151, 3760, "Input"],
Cell[822041, 23907, 2605, 81, 1520, "Output"]
}, Open  ]],
Cell[824661, 23991, 3965, 112, 10096, "Input"],
Cell[CellGroupData[{
Cell[828651, 24107, 99, 1, 864, "Input"],
Cell[828753, 24110, 3681, 114, 7696, "Output"]
}, Open  ]]
}, Open  ]]
}, Closed]],
Cell[CellGroupData[{
Cell[832495, 24231, 423, 10, 944, "Subsection"],
Cell[CellGroupData[{
Cell[832943, 24245, 133, 3, 768, "Subsubsection"],
Cell[833079, 24250, 237, 5, 832, "Text"],
Cell[833319, 24257, 1429, 44, 1744, "Input"],
Cell[834751, 24303, 533, 15, 1552, "Input"],
Cell[835287, 24320, 152, 2, 832, "Text"],
Cell[835442, 24324, 764, 24, 1600, "Input"],
Cell[836209, 24350, 389, 12, 1280, "Text"],
Cell[836601, 24364, 3004, 90, 3152, "Input"],
Cell[839608, 24456, 126, 3, 832, "Text"]
}, Closed]],
Cell[CellGroupData[{
Cell[839771, 24464, 3818, 118, 1232, "Subsubsection"],
Cell[843592, 24584, 177, 4, 832, "Text"],
Cell[843772, 24590, 2133, 64, 1744, "Input"],
Cell[845908, 24656, 255, 5, 832, "Text"],
Cell[846166, 24663, 1080, 36, 1392, "Input"],
Cell[847249, 24701, 93, 1, 832, "Text"],
Cell[847345, 24704, 981, 35, 1664, "Input"],
Cell[848329, 24741, 3257, 108, 1968, "Input"],
Cell[851589, 24851, 1947, 67, 1744, "Input"]
}, Closed]],
Cell[CellGroupData[{
Cell[853573, 24923, 333, 6, 512, "Subsubsection"],
Cell[853909, 24931, 262, 5, 1312, "Text"],
Cell[854174, 24938, 1839, 56, 1744, "Input"],
Cell[856016, 24996, 1253, 27, 1744, "Text"],
Cell[857272, 25025, 871, 26, 1536, "Input"],
Cell[858146, 25053, 962, 24, 1264, "Text"],
Cell[859111, 25079, 2006, 60, 1600, "Input"],
Cell[861120, 25141, 636, 13, 1792, "Text"],
Cell[861759, 25156, 715, 22, 2048, "Text"],
Cell[862477, 25180, 2218, 65, 1536, "Input"],
Cell[864698, 25247, 210, 4, 832, "Text"],
Cell[864911, 25253, 952, 26, 2512, "Text"],
Cell[865866, 25281, 111, 1, 832, "Text"],
Cell[865980, 25284, 2675, 82, 1744, "Input"],
Cell[868658, 25368, 1813, 60, 1136, "Text"],
Cell[870474, 25430, 271, 6, 832, "Text"],
Cell[CellGroupData[{
Cell[870770, 25440, 566, 15, 864, "Input"],
Cell[871339, 25457, 1309, 42, 1728, "Output"]
}, Open  ]],
Cell[872663, 25502, 131, 1, 832, "Text"],
Cell[872797, 25505, 2099, 66, 1952, "Input"],
Cell[874899, 25573, 445, 9, 1792, "Text"],
Cell[CellGroupData[{
Cell[875369, 25586, 495, 14, 864, "Input"],
Cell[875867, 25602, 1308, 40, 1760, "Output"]
}, Open  ]],
Cell[877190, 25645, 260, 5, 832, "Text"],
Cell[877453, 25652, 2148, 64, 2016, "Input"],
Cell[CellGroupData[{
Cell[879626, 25720, 2796, 78, 3088, "Input"],
Cell[882425, 25800, 4217, 118, 1424, "Output"]
}, Open  ]],
Cell[886657, 25921, 314, 11, 880, "Text"],
Cell[CellGroupData[{
Cell[886996, 25936, 204, 7, 912, "Input"],
Cell[887203, 25945, 1044, 29, 1424, "Output"]
}, Open  ]],
Cell[888262, 25977, 1240, 41, 1088, "Text"],
Cell[889505, 26020, 3327, 111, 2624, "Input"],
Cell[892835, 26133, 353, 12, 976, "Text"],
Cell[893191, 26147, 253, 9, 912, "Input"],
Cell[893447, 26158, 2327, 67, 1648, "Input"],
Cell[895777, 26227, 1181, 36, 944, "Text"],
Cell[896961, 26265, 1677, 50, 912, "Input"],
Cell[CellGroupData[{
Cell[898663, 26319, 193, 5, 1392, "Input"],
Cell[898859, 26326, 484, 16, 1360, "Output"]
}, Open  ]],
Cell[899358, 26345, 109, 4, 1312, "Text"],
Cell[899470, 26351, 4458, 129, 1648, "Input"],
Cell[903931, 26482, 111, 1, 832, "Text"]
}, Closed]],
Cell[CellGroupData[{
Cell[904079, 26488, 3047, 89, 1760, "Subsubsection"],
Cell[907129, 26579, 383, 10, 1312, "Text"],
Cell[907515, 26591, 5954, 179, 5952, "Input"],
Cell[913472, 26772, 1953, 62, 1744, "Input"],
Cell[915428, 26836, 159, 3, 832, "Text"],
Cell[915590, 26841, 2652, 83, 3104, "Input"],
Cell[918245, 26926, 287, 9, 832, "Text"]
}, Closed]],
Cell[CellGroupData[{
Cell[918569, 26940, 4012, 115, 3136, "Subsubsection"],
Cell[922584, 27057, 185, 4, 832, "Text"],
Cell[922772, 27063, 5990, 178, 8784, "Input"],
Cell[928765, 27243, 2874, 87, 5536, "Input"],
Cell[CellGroupData[{
Cell[931664, 27334, 863, 26, 2256, "Input"],
Cell[932530, 27362, 185, 4, 864, "Output"]
}, Open  ]],
Cell[932730, 27369, 3606, 110, 3152, "Input"]
}, Closed]]
}, Open  ]],
Cell[CellGroupData[{
Cell[936385, 27485, 1359, 34, 1728, "Subsection"],
Cell[937747, 27521, 99, 1, 832, "Text"],
Cell[937849, 27524, 892, 25, 1632, "Input"],
Cell[938744, 27551, 135, 3, 832, "Text"],
Cell[938882, 27556, 478, 16, 1552, "Input"],
Cell[CellGroupData[{
Cell[939385, 27576, 523, 17, 1552, "Input"],
Cell[939911, 27595, 1110, 39, 1408, "Output"]
}, Open  ]],
Cell[941036, 27637, 5617, 198, 3024, "Input"],
Cell[CellGroupData[{
Cell[946678, 27839, 4572, 129, 7440, "Input"],
Cell[951253, 27970, 2023, 68, 1536, "Output"]
}, Open  ]],
Cell[953291, 28041, 130, 3, 832, "Text"],
Cell[953424, 28046, 2217, 72, 1680, "Input"],
Cell[955644, 28120, 148, 3, 832, "Text"],
Cell[CellGroupData[{
Cell[955817, 28127, 3270, 89, 5056, "Input"],
Cell[959090, 28218, 2969, 98, 1936, "Output"]
}, Open  ]],
Cell[962074, 28319, 124, 3, 832, "Text"],
Cell[CellGroupData[{
Cell[962223, 28326, 463, 10, 1408, "Input"],
Cell[962689, 28338, 3194, 109, 1936, "Output"]
}, Open  ]],
Cell[965898, 28450, 123, 3, 832, "Text"],
Cell[966024, 28455, 2711, 92, 3264, "Input"],
Cell[968738, 28549, 167, 3, 832, "Text"],
Cell[CellGroupData[{
Cell[968930, 28556, 2188, 59, 5632, "Input"],
Cell[971121, 28617, 310682, 5185, 2160, "Output"]
}, Open  ]],
Cell[1281818, 33805, 161, 3, 832, "Text"],
Cell[CellGroupData[{
Cell[1282004, 33812, 783, 26, 1520, "Input"],
Cell[1282790, 33840, 98, 1, 864, "Output"]
}, Open  ]],
Cell[1282903, 33844, 145, 3, 832, "Text"],
Cell[CellGroupData[{
Cell[1283073, 33851, 393, 8, 1360, "Input"],
Cell[1283469, 33861, 9344, 282, 6800, "Output"]
}, Open  ]],
Cell[1292828, 34146, 157, 3, 832, "Text"],
Cell[1292988, 34151, 237, 7, 864, "Input"],
Cell[CellGroupData[{
Cell[1293250, 34162, 1532, 42, 4064, "Input"],
Cell[1294785, 34206, 558, 13, 1408, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[1295380, 34224, 1394, 41, 4064, "Input"],
Cell[1296777, 34267, 359, 10, 1408, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[1297173, 34282, 1457, 41, 4064, "Input"],
Cell[1298633, 34325, 1842, 54, 1840, "Output"]
}, Open  ]],
Cell[1300490, 34382, 467, 12, 1392, "Text"]
}, Open  ]]
}, Closed]],
Cell[CellGroupData[{
Cell[1301006, 34400, 858, 15, 114, "Section"],
Cell[1301867, 34417, 263, 5, 1312, "Text"],
Cell[CellGroupData[{
Cell[1302155, 34426, 160, 2, 1104, "Subsection"],
Cell[1302318, 34430, 204, 5, 832, "Text"],
Cell[1302525, 34437, 1034, 35, 1264, "Text"],
Cell[1303562, 34474, 272, 6, 832, "Text"],
Cell[CellGroupData[{
Cell[1303859, 34484, 573, 16, 1376, "Input"],
Cell[1304435, 34502, 9008, 282, 12272, "Output"]
}, Open  ]],
Cell[1313458, 34787, 231, 4, 1312, "Text"],
Cell[CellGroupData[{
Cell[1313714, 34795, 446, 12, 1712, "Input"],
Cell[1314163, 34809, 715, 24, 1632, "Output"],
Cell[1314881, 34835, 4098, 125, 4640, "Output"]
}, Open  ]],
Cell[1318994, 34963, 199, 4, 832, "Text"],
Cell[CellGroupData[{
Cell[1319218, 34971, 346, 9, 1712, "Input"],
Cell[1319567, 34982, 3036, 79, 3632, "Output"]
}, Open  ]]
}, Closed]],
Cell[CellGroupData[{
Cell[1322652, 35067, 94, 1, 768, "Subsection"],
Cell[1322749, 35070, 106, 1, 832, "Text"],
Cell[1322858, 35073, 2536, 79, 1952, "Input"],
Cell[1325397, 35154, 786, 23, 976, "Text"],
Cell[1326186, 35179, 4101, 133, 5216, "Input"],
Cell[1330290, 35314, 730, 22, 1456, "Text"],
Cell[1331023, 35338, 5160, 149, 3312, "Input"],
Cell[1336186, 35489, 548, 20, 976, "Text"],
Cell[CellGroupData[{
Cell[1336759, 35513, 3717, 113, 2560, "Input"],
Cell[1340479, 35628, 4829, 135, 1552, "Output"]
}, Open  ]],
Cell[1345323, 35766, 3372, 97, 1488, "Text"],
Cell[1348698, 35865, 6352, 184, 3664, "Input"],
Cell[1355053, 36051, 975, 28, 944, "Text"],
Cell[1356031, 36081, 242, 4, 1312, "Text"],
Cell[1356276, 36087, 98, 1, 832, "Text"],
Cell[1356377, 36090, 5842, 165, 5152, "Input"],
Cell[1362222, 36257, 101, 1, 832, "Text"],
Cell[1362326, 36260, 7400, 211, 6176, "Input"],
Cell[1369729, 36473, 237, 5, 832, "Text"],
Cell[1369969, 36480, 1169, 35, 2640, "Text"]
}, Closed]],
Cell[CellGroupData[{
Cell[1371175, 36520, 1773, 45, 1984, "Subsection"],
Cell[1372951, 36567, 6667, 191, 10864, "Input"],
Cell[1379621, 36760, 672, 20, 1600, "Input"],
Cell[1380296, 36782, 3354, 103, 4160, "Input"],
Cell[CellGroupData[{
Cell[1383675, 36889, 3990, 114, 8208, "Input"],
Cell[1387668, 37005, 5094, 118, 4080, "Output"]
}, Open  ]]
}, Closed]],
Cell[CellGroupData[{
Cell[1392811, 37129, 2312, 66, 1488, "Subsection"],
Cell[1395126, 37197, 402, 11, 896, "Input"],
Cell[1395531, 37210, 4176, 125, 2960, "Input"],
Cell[CellGroupData[{
Cell[1399732, 37339, 4068, 115, 8208, "Input"],
Cell[1403803, 37456, 3958, 94, 3984, "Output"]
}, Open  ]]
}, Closed]],
Cell[CellGroupData[{
Cell[1407810, 37556, 1309, 32, 1408, "Subsection"],
Cell[1409122, 37590, 346, 9, 832, "Text"],
Cell[1409471, 37601, 590, 16, 944, "Input"],
Cell[1410064, 37619, 764, 26, 992, "Text"],
Cell[1410831, 37647, 2040, 60, 1024, "Text"],
Cell[1412874, 37709, 1380, 33, 1792, "Text"],
Cell[1414257, 37744, 636, 17, 1024, "Input"],
Cell[1414896, 37763, 620, 19, 1136, "Text"],
Cell[1415519, 37784, 932, 30, 1616, "Text"],
Cell[1416454, 37816, 425, 13, 912, "Text"],
Cell[1416882, 37831, 1037, 31, 1712, "Input"],
Cell[1417922, 37864, 165, 2, 832, "Text"],
Cell[1418090, 37868, 2164, 68, 3360, "Input"],
Cell[CellGroupData[{
Cell[1420279, 37940, 909, 25, 1984, "Input"],
Cell[1421191, 37967, 983, 30, 1568, "Output"]
}, Open  ]],
Cell[1422189, 38000, 878, 27, 1904, "Input"],
Cell[CellGroupData[{
Cell[1423092, 38031, 757, 21, 1984, "Input"],
Cell[1423852, 38054, 591, 18, 1536, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[1424480, 38077, 2744, 77, 5568, "Input"],
Cell[1427227, 38156, 1631, 50, 2720, "Output"]
}, Open  ]],
Cell[1428873, 38209, 368, 11, 976, "Text"],
Cell[CellGroupData[{
Cell[1429266, 38224, 1417, 48, 1552, "Input"],
Cell[1430686, 38274, 1720, 56, 1776, "Output"]
}, Open  ]],
Cell[1432421, 38333, 2333, 74, 4224, "Input"],
Cell[1434757, 38409, 1862, 60, 2128, "Input"],
Cell[CellGroupData[{
Cell[1436644, 38473, 2044, 59, 4416, "Input"],
Cell[1438691, 38534, 13569, 395, 6992, "Output"],
Cell[1452263, 38931, 391, 5, 864, "Output"]
}, Open  ]],
Cell[1452669, 38939, 1659, 44, 3344, "Input"],
Cell[CellGroupData[{
Cell[1454353, 38987, 1537, 42, 3808, "Input"],
Cell[1455893, 39031, 70958, 2204, 38352, "Output"]
}, Open  ]]
}, Closed]],
Cell[CellGroupData[{
Cell[1526900, 41241, 1406, 34, 1328, "Subsection"],
Cell[1528309, 41277, 2128, 67, 1872, "Input"],
Cell[1530440, 41346, 1087, 34, 1472, "Input"],
Cell[1531530, 41382, 1661, 48, 3968, "Input"]
}, Closed]],
Cell[CellGroupData[{
Cell[1533228, 41435, 1689, 42, 1776, "Subsection"],
Cell[1534920, 41479, 443, 12, 896, "Input"],
Cell[1535366, 41493, 431, 12, 1312, "Text"],
Cell[1535800, 41507, 1542, 48, 1600, "Input"],
Cell[CellGroupData[{
Cell[1537367, 41559, 610, 17, 1360, "Input"],
Cell[1537980, 41578, 755, 22, 1360, "Output"]
}, Open  ]],
Cell[1538750, 41603, 1240, 39, 1872, "Text"],
Cell[CellGroupData[{
Cell[1540015, 41646, 2013, 59, 2688, "Input"],
Cell[1542031, 41707, 4098, 131, 3456, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[1546166, 41843, 4571, 135, 11008, "Input"],
Cell[1550740, 41980, 161, 2, 864, "Output"]
}, Open  ]],
Cell[1550916, 41985, 1868, 52, 6416, "Input"],
Cell[1552787, 42039, 861, 24, 3168, "Input"],
Cell[CellGroupData[{
Cell[1553673, 42067, 538, 17, 2176, "Input"],
Cell[1554214, 42086, 6210, 178, 11664, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[1560461, 42269, 842, 25, 1840, "Input"],
Cell[1561306, 42296, 6433, 173, 8688, "Output"]
}, Open  ]],
Cell[1567754, 42472, 677, 21, 2160, "Input"],
Cell[CellGroupData[{
Cell[1568456, 42497, 489, 16, 2176, "Input"],
Cell[1568948, 42515, 4897, 142, 9616, "Output"]
}, Open  ]],
Cell[1573860, 42660, 154, 3, 832, "Text"],
Cell[CellGroupData[{
Cell[1574039, 42667, 910, 27, 1616, "Input"],
Cell[1574952, 42696, 2986, 88, 2528, "Output"]
}, Open  ]],
Cell[1577953, 42787, 698, 22, 2480, "Input"],
Cell[CellGroupData[{
Cell[1578676, 42813, 514, 17, 2176, "Input"],
Cell[1579193, 42832, 1973, 57, 4160, "Output"]
}, Open  ]]
}, Closed]],
Cell[CellGroupData[{
Cell[1581215, 42895, 7871, 207, 4544, "Subsection"],
Cell[1589089, 43104, 7042, 213, 5200, "Input"],
Cell[CellGroupData[{
Cell[1596156, 43321, 208, 6, 768, "Subsubsection"],
Cell[CellGroupData[{
Cell[1596389, 43331, 5132, 153, 6256, "Input"],
Cell[1601524, 43486, 14104, 427, 15552, "Output"]
}, Open  ]],
Cell[1615643, 43916, 171, 4, 832, "Text"],
Cell[1615817, 43922, 6236, 185, 10864, "Input"],
Cell[CellGroupData[{
Cell[1622078, 44111, 694, 19, 2160, "Input"],
Cell[1622775, 44132, 6257, 169, 8608, "Output"]
}, Open  ]]
}, Closed]],
Cell[CellGroupData[{
Cell[1629081, 44307, 297, 9, 720, "Subsubsection"],
Cell[1629381, 44318, 482, 17, 1008, "Text"],
Cell[1629866, 44337, 5296, 154, 6352, "Input"],
Cell[1635165, 44493, 2706, 86, 4192, "Input"],
Cell[1637874, 44581, 255, 5, 1312, "Text"],
Cell[CellGroupData[{
Cell[1638154, 44590, 1346, 41, 2704, "Input"],
Cell[1639503, 44633, 1088, 34, 1408, "Output"]
}, Open  ]],
Cell[1640606, 44670, 4039, 123, 4048, "Input"],
Cell[1644648, 44795, 153, 3, 832, "Text"],
Cell[CellGroupData[{
Cell[1644826, 44802, 8581, 204, 12960, "Input"],
Cell[1653410, 45008, 5822, 166, 7008, "Output"]
}, Open  ]],
Cell[1659247, 45177, 102, 1, 640, "Item"],
Cell[1659352, 45180, 557, 20, 976, "Text"],
Cell[CellGroupData[{
Cell[1659934, 45204, 2190, 64, 2128, "Input"],
Cell[1662127, 45270, 6379, 201, 4032, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[1668543, 45476, 4608, 135, 181760, "Input"],
Cell[1673154, 45613, 480, 7, 19456, "Output"]
}, Open  ]],
Cell[1673649, 45623, 1920, 53, 108288, "Input"],
Cell[1675572, 45678, 911, 25, 56320, "Input"],
Cell[CellGroupData[{
Cell[1676508, 45707, 590, 18, 2176, "Input"],
Cell[1677101, 45727, 4265, 118, 8320, "Output"]
}, Open  ]],
Cell[1681381, 45848, 172, 4, 864, "Input"],
Cell[1681556, 45854, 5783, 164, 6432, "Input"],
Cell[CellGroupData[{
Cell[1687364, 46022, 1316, 37, 2960, "Input"],
Cell[1688683, 46061, 42468, 1299, 38688, "Output"]
}, Open  ]]
}, Closed]]
}, Open  ]],
Cell[CellGroupData[{
Cell[1731212, 47367, 7635, 202, 3280, "Subsection"],
Cell[1738850, 47571, 130, 3, 13312, "Text"],
Cell[CellGroupData[{
Cell[1739005, 47578, 208, 6, 12288, "Subsubsection"],
Cell[CellGroupData[{
Cell[1739238, 47588, 5180, 153, 105728, "Input"],
Cell[1744421, 47743, 12502, 382, 209152, "Output"]
}, Open  ]],
Cell[1756938, 48128, 171, 4, 13312, "Text"],
Cell[1757112, 48134, 6234, 185, 179456, "Input"],
Cell[CellGroupData[{
Cell[1763371, 48323, 793, 21, 40192, "Input"],
Cell[1764167, 48346, 10123, 276, 215040, "Output"]
}, Open  ]]
}, Closed]],
Cell[CellGroupData[{
Cell[1774339, 48628, 297, 9, 11520, "Subsubsection"],
Cell[1774639, 48639, 482, 17, 16128, "Text"],
Cell[1775124, 48658, 5345, 155, 107264, "Input"],
Cell[1780472, 48815, 153, 3, 13312, "Text"],
Cell[CellGroupData[{
Cell[1780650, 48822, 9268, 224, 215552, "Input"],
Cell[1789921, 49048, 12834, 357, 239360, "Output"]
}, Open  ]],
Cell[1802770, 49408, 102, 1, 10240, "Item"],
Cell[1802875, 49411, 557, 20, 15616, "Text"],
Cell[CellGroupData[{
Cell[1803457, 49435, 2190, 64, 39680, "Input"],
Cell[1805650, 49501, 6375, 201, 70144, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[1812062, 49707, 4629, 135, 181760, "Input"],
Cell[1816694, 49844, 478, 7, 19456, "Output"]
}, Open  ]],
Cell[1817187, 49854, 1969, 54, 108288, "Input"],
Cell[1819159, 49910, 1006, 26, 56320, "Input"],
Cell[CellGroupData[{
Cell[1820190, 49940, 590, 18, 40448, "Input"],
Cell[1820783, 49960, 4317, 119, 138752, "Output"]
}, Open  ]],
Cell[1825115, 50082, 172, 4, 19456, "Input"],
Cell[1825290, 50088, 5832, 165, 108544, "Input"],
Cell[CellGroupData[{
Cell[1831147, 50257, 1318, 37, 52992, "Input"],
Cell[1832468, 50296, 38194, 1177, 575232, "Output"]
}, Open  ]]
}, Open  ]]
}, Closed]],
Cell[CellGroupData[{
Cell[1870723, 51480, 1486, 41, 1920, "Subsection"],
Cell[CellGroupData[{
Cell[1872234, 51525, 2294, 66, 107008, "Input"],
Cell[1874531, 51593, 3562, 97, 60160, "Output"]
}, Open  ]]
}, Closed]],
Cell[CellGroupData[{
Cell[1878142, 51696, 1230, 33, 1184, "Subsection"],
Cell[CellGroupData[{
Cell[1879397, 51733, 1847, 53, 79360, "Input"],
Cell[1881247, 51788, 2118, 67, 43520, "Output"]
}, Open  ]]
}, Closed]],
Cell[CellGroupData[{
Cell[1883414, 51861, 2783, 69, 1824, "Subsection"],
Cell[CellGroupData[{
Cell[1886222, 51934, 284, 6, 12288, "Subsubsection"],
Cell[1886509, 51942, 266, 5, 137756672, "Text"],
Cell[1886778, 51949, 556, 18, 235495424, "Input"],
Cell[1887337, 51969, 236, 5, 137756672, "Text"],
Cell[1887576, 51976, 695, 22, 287252480, "Input"],
Cell[1888274, 52000, 116, 1, 137756672, "Text"],
Cell[1888393, 52003, 1348, 44, 272064512, "Input"],
Cell[CellGroupData[{
Cell[1889766, 52051, 1291, 36, 421257216, "Input"],
Cell[1891060, 52089, 539, 19, 257785856, "Output"]
}, Open  ]],
Cell[1891614, 52111, 168, 2, 137756672, "Text"],
Cell[1891785, 52115, 1125, 39, 287252480, "Input"],
Cell[1892913, 52156, 90, 1, 137756672, "Text"],
Cell[1893006, 52159, 623, 18, 287252480, "Input"],
Cell[1893632, 52179, 128, 1, 137756672, "Text"]
}, Closed]],
Cell[CellGroupData[{
Cell[1893797, 52185, 107, 1, 8192, "Subsubsection"],
Cell[CellGroupData[{
Cell[1893929, 52190, 1708, 51, 71680, "Input"],
Cell[1895640, 52243, 105, 2, 13824, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[1895782, 52250, 1302, 40, 46080, "Input"],
Cell[1897087, 52292, 178, 3, 13824, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[1897302, 52300, 2050, 63, 77568, "Input"],
Cell[1899355, 52365, 107, 2, 13824, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[1899499, 52372, 447, 13, 31232, "Input"],
Cell[1899949, 52387, 166, 4, 13824, "Output"]
}, Open  ]]
}, Closed]],
Cell[CellGroupData[{
Cell[1900164, 52397, 175, 2, 8192, "Subsubsection"],
Cell[1900342, 52401, 406, 11, 14336, "Text"],
Cell[1900751, 52414, 1906, 60, 47104, "Input"],
Cell[CellGroupData[{
Cell[1902682, 52478, 403, 10, 19456, "Input"],
Cell[1903088, 52490, 2137, 58, 28160, "Output"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[1905274, 52554, 122, 1, 12288, "Subsubsection"],
Cell[1905399, 52557, 1241, 37, 30464, "Input"],
Cell[1906643, 52596, 2967, 88, 101120, "Input"],
Cell[CellGroupData[{
Cell[1909635, 52688, 1018, 28, 50688, "Input"],
Cell[1910656, 52718, 1406, 43, 32000, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[1912099, 52766, 1657, 48, 61184, "Input"],
Cell[1913759, 52816, 1063, 30, 22016, "Output"]
}, Open  ]]
}, Closed]],
Cell[CellGroupData[{
Cell[1914871, 52852, 148, 2, 8192, "Subsubsection"],
Cell[1915022, 52856, 1291, 37, 30464, "Input"],
Cell[1916316, 52895, 3023, 89, 101120, "Input"],
Cell[CellGroupData[{
Cell[1919364, 52988, 96, 1, 19456, "Input"],
Cell[1919463, 52991, 2769, 88, 64256, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[1922269, 53084, 1119, 29, 35072, "Input"],
Cell[1923391, 53115, 4629, 147, 86784, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[1928057, 53267, 1642, 47, 66304, "Input"],
Cell[1929702, 53316, 2266, 67, 51712, "Output"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[1932017, 53389, 472, 14, 14592, "Subsubsection"],
Cell[1932492, 53405, 178, 4, 13312, "Text"],
Cell[1932673, 53411, 468, 15, 15616, "Text"],
Cell[1933144, 53428, 1663, 48, 61184, "Input"],
Cell[CellGroupData[{
Cell[1934832, 53480, 2786, 80, 97792, "Input"],
Cell[1937621, 53562, 6268, 186, 100096, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[1943926, 53753, 1283, 37, 49664, "Input"],
Cell[1945212, 53792, 11591, 328, 180480, "Output"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[1956852, 54126, 287, 7, 12288, "Subsubsection"],
Cell[1957142, 54135, 950, 27, 35072, "Input"],
Cell[CellGroupData[{
Cell[1958117, 54166, 2463, 76, 65536, "Input"],
Cell[1960583, 54244, 8221, 232, 143104, "Output"]
}, Open  ]]
}, Open  ]]
}, Closed]],
Cell[CellGroupData[{
Cell[1968865, 54483, 396, 8, 768, "Subsection"],
Cell[1969264, 54493, 331, 6, 20992, "Text"],
Cell[1969598, 54501, 800, 24, 16384, "Input"],
Cell[1970401, 54527, 168, 3, 13312, "Text"],
Cell[CellGroupData[{
Cell[1970594, 54534, 2158, 63, 66048, "Input"],
Cell[1972755, 54599, 2884, 84, 66048, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[1975676, 54688, 2197, 60, 93440, "Input"],
Cell[1977876, 54750, 10856, 307, 136192, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[1988769, 55062, 981, 27, 51712, "Input"],
Cell[1989753, 55091, 14814, 398, 233728, "Output"]
}, Open  ]]
}, Closed]],
Cell[CellGroupData[{
Cell[2004616, 55495, 131, 2, 768, "Subsection"],
Cell[2004750, 55499, 111, 1, 13312, "Text"],
Cell[CellGroupData[{
Cell[2004886, 55504, 1690, 51, 60928, "Input"],
Cell[2006579, 55557, 44035, 1190, 628992, "Output"]
}, Open  ]],
Cell[2050629, 56750, 138, 2, 13312, "Text"],
Cell[CellGroupData[{
Cell[2050792, 56756, 1896, 55, 68608, "Input"],
Cell[2052691, 56813, 56754, 1605, 871680, "Output"]
}, Open  ]]
}, Closed]],
Cell[CellGroupData[{
Cell[2109494, 58424, 376, 7, 768, "Subsection"],
Cell[CellGroupData[{
Cell[2109895, 58435, 106, 1, 768, "Subsubsection"],
Cell[2110004, 58438, 705, 19, 2016, "Input"],
Cell[2110712, 58459, 301, 5, 864, "Input"],
Cell[2111016, 58466, 5302, 155, 7552, "Input"],
Cell[2116321, 58623, 348, 8, 1360, "Input"],
Cell[CellGroupData[{
Cell[2116694, 58635, 1883, 51, 5504, "Input"],
Cell[2118580, 58688, 16780, 498, 12896, "Output"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[2135409, 59192, 154, 2, 768, "Subsubsection"],
Cell[2135566, 59196, 761, 20, 3096576, "Input"],
Cell[2136330, 59218, 519, 11, 3981312, "Input"],
Cell[CellGroupData[{
Cell[2136874, 59233, 1942, 52, 14532608, "Input"],
Cell[2138819, 59287, 64785, 1913, 123764736, "Output"]
}, Open  ]]
}, Closed]],
Cell[CellGroupData[{
Cell[2203653, 61206, 202, 3, 512, "Subsubsection"],
Cell[2203858, 61211, 810, 21, 178397184, "Input"],
Cell[2204671, 61234, 607, 14, 229326848, "Input"],
Cell[CellGroupData[{
Cell[2205303, 61252, 2003, 54, 837804032, "Input"],
Cell[2207309, 61308, 193939, 5579, 2147483647, "Output"]
}, Open  ]]
}, Closed]],
Cell[CellGroupData[{
Cell[2401297, 66893, 208, 3, 512, "Subsubsection"],
Cell[2401508, 66898, 173, 4, 832, "Text"],
Cell[2401684, 66904, 3619, 97, 5392, "Input"],
Cell[2405306, 67003, 2751, 75, 3968, "Input"],
Cell[2408060, 67080, 238, 6, 864, "Input"],
Cell[CellGroupData[{
Cell[2408323, 67090, 38, 0, 864, "Input"],
Cell[2408364, 67092, 248875, 7096, 238816, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[2657276, 74193, 121, 2, 1424, "Input"],
Cell[2657400, 74197, 116, 2, 1280, "Output"]
}, Open  ]]
}, Open  ]]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[2657589, 74207, 312, 6, 70, "Section"],
Cell[CellGroupData[{
Cell[2657926, 74217, 94, 1, 544, "Subsection"],
Cell[2658023, 74220, 164, 2, 832, "Text"],
Cell[2658190, 74224, 1658, 57, 1728, "Input"],
Cell[2659851, 74283, 190, 4, 832, "Text"],
Cell[2660044, 74289, 3619, 116, 4272, "Input"],
Cell[2663666, 74407, 422, 15, 880, "Text"],
Cell[2664091, 74424, 6047, 191, 7568, "Input"],
Cell[2670141, 74617, 4978, 149, 6528, "Input"],
Cell[2675122, 74768, 5681, 179, 6928, "Input"],
Cell[2680806, 74949, 1723, 53, 1264, "Input"],
Cell[2682532, 75004, 160, 3, 832, "Text"],
Cell[CellGroupData[{
Cell[2682717, 75011, 175, 4, 864, "Input"],
Cell[2682895, 75017, 3531, 112, 7696, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[2686463, 75134, 208, 6, 1488, "Input"],
Cell[2686674, 75142, 339, 12, 1632, "Output"]
}, Open  ]],
Cell[2687028, 75157, 207, 6, 1200, "Input"]
}, Closed]],
Cell[CellGroupData[{
Cell[2687272, 75168, 1665, 47, 912, "Subsection"],
Cell[2688940, 75217, 448, 16, 896, "Text"],
Cell[2689391, 75235, 108, 1, 832, "Text"],
Cell[2689502, 75238, 1448, 46, 1824, "Input"],
Cell[2690953, 75286, 1136, 40, 2576, "Input"],
Cell[2692092, 75328, 464, 8, 1792, "Text"],
Cell[2692559, 75338, 705, 24, 1520, "Input"],
Cell[2693267, 75364, 183, 4, 832, "Text"],
Cell[2693453, 75370, 619, 19, 1200, "Input"],
Cell[2694075, 75391, 123, 3, 832, "Text"],
Cell[2694201, 75396, 1020, 28, 3888, "Text"],
Cell[CellGroupData[{
Cell[2695246, 75428, 836, 21, 1344, "Subsubsection"],
Cell[2696085, 75451, 130, 3, 832, "Text"],
Cell[2696218, 75456, 1247, 37, 1456, "Input"],
Cell[2697468, 75495, 1121, 32, 1456, "Input"],
Cell[2698592, 75529, 936, 25, 1616, "Text"],
Cell[2699531, 75556, 1209, 38, 2000, "Input"],
Cell[2700743, 75596, 637, 17, 1360, "Text"],
Cell[2701383, 75615, 1220, 38, 2048, "Input"],
Cell[2702606, 75655, 189, 4, 832, "Text"],
Cell[CellGroupData[{
Cell[2702820, 75663, 291, 8, 864, "Input"],
Cell[2703114, 75673, 387, 12, 1280, "Output"]
}, Open  ]],
Cell[2703516, 75688, 3448, 111, 3760, "Input"],
Cell[2706967, 75801, 157, 3, 832, "Text"],
Cell[2707127, 75806, 1622, 53, 4304, "Input"],
Cell[2708752, 75861, 331, 10, 912, "Input"],
Cell[2709086, 75873, 1838, 52, 4704, "Input"],
Cell[CellGroupData[{
Cell[2710949, 75929, 3230, 100, 5872, "Input"],
Cell[2714182, 76031, 2767, 78, 1424, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[2716986, 76114, 933, 28, 2256, "Input"],
Cell[2717922, 76144, 1969, 55, 2000, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[2719928, 76204, 437, 12, 1024, "Input"],
Cell[2720368, 76218, 1158, 36, 944, "Output"]
}, Open  ]],
Cell[2721541, 76257, 168, 3, 832, "Text"],
Cell[2721712, 76262, 1277, 40, 3168, "Input"],
Cell[2722992, 76304, 590, 16, 1360, "Text"],
Cell[2723585, 76322, 2993, 95, 5072, "Input"],
Cell[2726581, 76419, 615, 23, 2080, "Input"],
Cell[2727199, 76444, 1219, 40, 3040, "Input"],
Cell[CellGroupData[{
Cell[2728443, 76488, 988, 33, 3040, "Input"],
Cell[2729434, 76523, 226, 7, 1280, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[2729697, 76535, 150, 3, 864, "Input"],
Cell[2729850, 76540, 3460, 115, 3200, "Output"]
}, Open  ]],
Cell[2733325, 76658, 276, 5, 1312, "Text"],
Cell[CellGroupData[{
Cell[2733626, 76667, 711, 24, 3248, "Input"],
Cell[2734340, 76693, 679, 24, 1440, "Output"]
}, Open  ]],
Cell[2735034, 76720, 237, 4, 1312, "Text"],
Cell[CellGroupData[{
Cell[2735296, 76728, 1188, 37, 2464, "Input"],
Cell[2736487, 76767, 3495, 113, 4288, "Output"]
}, Open  ]],
Cell[2739997, 76883, 1170, 39, 3088, "Input"],
Cell[2741170, 76924, 16103, 494, 25872, "Input"],
Cell[2757276, 77420, 1473, 46, 2560, "Input"],
Cell[2758752, 77468, 1251, 38, 3136, "Input"],
Cell[CellGroupData[{
Cell[2760028, 77510, 2490, 69, 6576, "Input"],
Cell[2762521, 77581, 340, 6, 864, "Output"]
}, Open  ]],
Cell[2762876, 77590, 683, 21, 1408, "Input"],
Cell[CellGroupData[{
Cell[2763584, 77615, 3911, 100, 8832, "Input"],
Cell[2767498, 77717, 238, 3, 864, "Output"]
}, Open  ]],
Cell[2767751, 77723, 146, 3, 864, "Input"],
Cell[2767900, 77728, 234, 5, 1472, "Input"],
Cell[CellGroupData[{
Cell[2768159, 77737, 382, 11, 1584, "Input"],
Cell[2768544, 77750, 151, 3, 864, "Output"]
}, Open  ]],
Cell[2768710, 77756, 147, 3, 832, "Text"],
Cell[2768860, 77761, 1154, 28, 2784, "Text"],
Cell[2770017, 77791, 851, 29, 1568, "Input"],
Cell[2770871, 77822, 156, 3, 832, "Text"],
Cell[2771030, 77827, 111, 1, 832, "Text"],
Cell[2771144, 77830, 465, 12, 1424, "Input"],
Cell[2771612, 77844, 116, 1, 832, "Text"],
Cell[2771731, 77847, 413, 12, 1456, "Input"],
Cell[2772147, 77861, 478, 14, 1616, "Text"],
Cell[2772628, 77877, 1401, 45, 1584, "Input"],
Cell[2774032, 77924, 237, 4, 1312, "Text"],
Cell[2774272, 77930, 445, 14, 1408, "Input"],
Cell[2774720, 77946, 369, 6, 1312, "Text"],
Cell[2775092, 77954, 486, 12, 912, "Input"],
Cell[2775581, 77968, 2157, 64, 4656, "Input"],
Cell[2777741, 78034, 131, 1, 832, "Text"],
Cell[2777875, 78037, 1906, 61, 4656, "Input"],
Cell[2779784, 78100, 409, 13, 960, "Text"],
Cell[2780196, 78115, 3198, 97, 9504, "Input"],
Cell[2783397, 78214, 596, 13, 1664, "Text"],
Cell[2783996, 78229, 686, 17, 992, "Text"],
Cell[2784685, 78248, 382, 10, 1456, "Text"],
Cell[2785070, 78260, 2033, 61, 6000, "Input"],
Cell[CellGroupData[{
Cell[2787128, 78325, 6951, 180, 13552, "Input"],
Cell[2794082, 78507, 15695, 470, 13568, "Output"]
}, Open  ]],
Cell[2809792, 78980, 139, 1, 832, "Text"],
Cell[CellGroupData[{
Cell[2809956, 78985, 4527, 113, 10448, "Input"],
Cell[2814486, 79100, 1570, 34, 1664, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[2816093, 79139, 284, 7, 944, "Input"],
Cell[2816380, 79148, 2241, 72, 2016, "Output"]
}, Open  ]],
Cell[2818636, 79223, 163, 3, 832, "Text"],
Cell[CellGroupData[{
Cell[2818824, 79230, 446, 12, 1360, "Input"],
Cell[2819273, 79244, 10338, 314, 8624, "Output"]
}, Open  ]],
Cell[2829626, 79561, 449, 13, 1312, "Text"],
Cell[2830078, 79576, 1686, 57, 3024, "Input"],
Cell[2831767, 79635, 109, 1, 832, "Text"],
Cell[CellGroupData[{
Cell[2831901, 79640, 612, 19, 2992, "Input"],
Cell[2832516, 79661, 5666, 173, 4608, "Output"]
}, Open  ]],
Cell[2838197, 79837, 153, 3, 832, "Text"],
Cell[2838353, 79842, 1949, 61, 3104, "Input"],
Cell[2840305, 79905, 173, 4, 832, "Text"],
Cell[CellGroupData[{
Cell[2840503, 79913, 3373, 99, 5536, "Input"],
Cell[2843879, 80014, 3586, 117, 1105920, "Output"]
}, Closed]],
Cell[2847480, 80134, 149, 3, 672, "Text"],
Cell[CellGroupData[{
Cell[2847654, 80141, 1051, 31, 2752, "Input"],
Cell[2848708, 80174, 6658, 209, 1818624, "Output"]
}, Closed]],
Cell[2855381, 80386, 275, 7, 672, "Text"],
Cell[2855659, 80395, 142, 3, 832, "Text"],
Cell[2855804, 80400, 1644, 56, 2512, "Input"],
Cell[CellGroupData[{
Cell[2857473, 80460, 1676, 42, 4896, "Input"],
Cell[2859152, 80504, 3491, 98, 2800, "Output"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[2862692, 80608, 506, 14, 1312, "Subsubsection"],
Cell[2863201, 80624, 99, 1, 832, "Text"],
Cell[2863303, 80627, 313, 9, 1552, "Input"],
Cell[CellGroupData[{
Cell[2863641, 80640, 660, 20, 1840, "Input"],
Cell[2864304, 80662, 597, 22, 1536, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[2864938, 80689, 907, 26, 1520, "Input"],
Cell[2865848, 80717, 1675, 55, 2416, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[2867560, 80777, 785, 23, 2656, "Input"],
Cell[2868348, 80802, 875, 24, 1280, "Output"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[2869272, 80832, 769, 25, 1488, "Subsubsection"],
Cell[2870044, 80859, 2249, 78, 5840, "Input"],
Cell[CellGroupData[{
Cell[2872318, 80941, 1000, 27, 2800, "Input"],
Cell[2873321, 80970, 963, 32, 1600, "Output"]
}, Open  ]],
Cell[2874299, 81005, 338, 8, 1072, "Text"],
Cell[CellGroupData[{
Cell[2874662, 81017, 864, 26, 2800, "Input"],
Cell[2875529, 81045, 759, 28, 1600, "Output"]
}, Open  ]],
Cell[2876303, 81076, 2014, 60, 10640, "Input"],
Cell[CellGroupData[{
Cell[2878342, 81140, 767, 24, 2656, "Input"],
Cell[2879112, 81166, 2999, 89, 3952, "Output"]
}, Open  ]]
}, Open  ]]
}, Closed]],
Cell[CellGroupData[{
Cell[2882172, 81262, 1591, 47, 640, "Subsection"],
Cell[2883766, 81311, 2148, 67, 1776, "Input"],
Cell[CellGroupData[{
Cell[2885939, 81382, 1044, 29, 2640, "Input"],
Cell[2886986, 81413, 1551, 47, 2656, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[2888574, 81465, 2829, 74, 8304, "Input"],
Cell[2891406, 81541, 3614, 114, 8128, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[2895057, 81660, 755, 23, 2512, "Input"],
Cell[2895815, 81685, 2172, 66, 4848, "Output"]
}, Open  ]]
}, Closed]],
Cell[CellGroupData[{
Cell[2898036, 81757, 1763, 43, 704, "Subsection"],
Cell[2899802, 81802, 2654, 78, 2208, "Input"],
Cell[2902459, 81882, 106, 1, 832, "Text"],
Cell[CellGroupData[{
Cell[2902590, 81887, 2151, 55, 7568, "Input"],
Cell[2904744, 81944, 2109, 69, 3504, "Output"]
}, Open  ]],
Cell[2906868, 82016, 107, 1, 832, "Text"],
Cell[CellGroupData[{
Cell[2907000, 82021, 210, 6, 768, "Subsubsection"],
Cell[2907213, 82029, 713, 20, 880, "Text"],
Cell[2907929, 82051, 986, 27, 1360, "Input"],
Cell[2908918, 82080, 3806, 94, 7904, "Input"],
Cell[CellGroupData[{
Cell[2912749, 82178, 1032, 30, 2512, "Input"],
Cell[2913784, 82210, 11623, 310, 14160, "Output"]
}, Open  ]]
}, Closed]],
Cell[CellGroupData[{
Cell[2925456, 82526, 454, 11, 512, "Subsubsection"],
Cell[CellGroupData[{
Cell[2925935, 82541, 1492, 43, 3488, "Input"],
Cell[2927430, 82586, 8846, 278, 12896, "Output"]
}, Open  ]]
}, Closed]],
Cell[CellGroupData[{
Cell[2936325, 82870, 567, 14, 656, "Subsubsection"],
Cell[CellGroupData[{
Cell[2936917, 82888, 98, 1, 864, "Input"],
Cell[2937018, 82891, 1957, 66, 3504, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[2939012, 82962, 3145, 98, 5440, "Input"],
Cell[2942160, 83062, 25330, 751, 28368, "Output"]
}, Open  ]]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[2967551, 83820, 1210, 34, 1152, "Subsection"],
Cell[CellGroupData[{
Cell[2968786, 83858, 610, 17, 2320, "Input"],
Cell[2969399, 83877, 1575, 55, 2720, "Output"]
}, Open  ]],
Cell[2970989, 83935, 682, 20, 1200, "Input"],
Cell[CellGroupData[{
Cell[2971696, 83959, 5164, 139, 18128, "Input"],
Cell[2976863, 84100, 367, 6, 864, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[2977267, 84111, 98, 1, 864, "Input"],
Cell[2977368, 84114, 5621, 177, 6768, "Output"]
}, Open  ]],
Cell[2983004, 84294, 222, 6, 864, "Text"],
Cell[CellGroupData[{
Cell[2983251, 84304, 1084, 32, 2000, "Input"],
Cell[2984338, 84338, 11926, 338, 9680, "Output"]
}, Open  ]],
Cell[2996279, 84679, 1346, 39, 1264, "Subsubsection"]
}, Closed]],
Cell[CellGroupData[{
Cell[2997662, 84723, 1646, 46, 568, "Subsection"],
Cell[CellGroupData[{
Cell[2999333, 84773, 558, 13, 768, "Subsubsection"],
Cell[2999894, 84788, 3386, 95, 9488, "Input"],
Cell[3003283, 84885, 986, 27, 1360, "Input"],
Cell[3004272, 84914, 2719, 73, 5920, "Input"],
Cell[3006994, 84989, 3587, 87, 5920, "Input"],
Cell[CellGroupData[{
Cell[3010606, 85080, 2618, 66, 7392, "Input"],
Cell[3013227, 85148, 13061, 349, 18144, "Output"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[3026337, 85503, 572, 13, 768, "Subsubsection"],
Cell[3026912, 85518, 1343, 38, 3168, "Input"]
}, Open  ]],
Cell[CellGroupData[{
Cell[3028292, 85561, 653, 15, 912, "Subsubsection"],
Cell[3028948, 85578, 124, 3, 832, "Text"],
Cell[3029075, 85583, 2705, 71, 5568, "Input"],
Cell[3031783, 85656, 3590, 96, 5376, "Input"]
}, Open  ]]
}, Closed]],
Cell[CellGroupData[{
Cell[3035422, 85758, 581, 9, 384, "Subsection"],
Cell[3036006, 85769, 376, 6, 896, "Text"],
Cell[3036385, 85777, 312, 5, 656, "Text"],
Cell[CellGroupData[{
Cell[3036722, 85786, 214, 5, 432, "Input"],
Cell[3036939, 85793, 7597, 247, 2544, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[3044573, 86045, 297, 6, 680, "Input"],
Cell[3044873, 86053, 483, 15, 640, "Output"],
Cell[3045359, 86070, 8844, 256, 4168, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[3054240, 86331, 1797, 51, 1640, "Input"],
Cell[3056040, 86384, 285, 8, 432, "Output"],
Cell[3056328, 86394, 561, 18, 648, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[3056926, 86417, 1339, 39, 1160, "Input"],
Cell[3058268, 86458, 136, 3, 432, "Output"],
Cell[3058407, 86463, 2867, 82, 2088, "Output"]
}, Open  ]],
Cell[3061289, 86548, 3122, 82, 4656, "Input"],
Cell[3064414, 86632, 1676, 43, 2336, "Input"],
Cell[CellGroupData[{
Cell[3066115, 86679, 919, 21, 680, "Input"],
Cell[3067037, 86702, 221, 4, 432, "Output"]
}, Open  ]],
Cell[3067273, 86709, 3078, 79, 4352, "Input"],
Cell[3070354, 86790, 1849, 45, 2336, "Input"],
Cell[CellGroupData[{
Cell[3072228, 86839, 172, 3, 432, "Input"],
Cell[3072403, 86844, 132, 1, 432, "Output"]
}, Open  ]],
Cell[3072550, 86848, 214, 4, 432, "Input"],
Cell[3072767, 86854, 189, 4, 432, "Input"],
Cell[3072959, 86860, 106, 3, 432, "Input"]
}, Open  ]]
}, Closed]],
Cell[CellGroupData[{
Cell[3073114, 86869, 570, 9, 70, "Section"],
Cell[CellGroupData[{
Cell[3073709, 86882, 166, 2, 544, "Subsection"],
Cell[3073878, 86886, 103, 1, 832, "Text"],
Cell[3073984, 86889, 2778, 91, 1872, "Input"],
Cell[3076765, 86982, 124, 1, 832, "Text"],
Cell[3076892, 86985, 3477, 109, 1744, "Input"],
Cell[CellGroupData[{
Cell[3080394, 87098, 7908, 225, 6608, "Input"],
Cell[3088305, 87325, 782, 25, 1600, "Output"]
}, Open  ]],
Cell[3089102, 87353, 1062, 37, 1632, "Input"],
Cell[3090167, 87392, 115, 1, 832, "Text"],
Cell[3090285, 87395, 929, 30, 1760, "Input"],
Cell[3091217, 87427, 102, 1, 832, "Text"],
Cell[3091322, 87430, 1138, 38, 1600, "Input"]
}, Closed]],
Cell[CellGroupData[{
Cell[3092497, 87473, 286, 5, 384, "Subsection"],
Cell[3092786, 87480, 3007, 96, 1872, "Input"],
Cell[3095796, 87578, 123, 1, 832, "Text"],
Cell[3095922, 87581, 1317, 40, 1824, "Input"],
Cell[3097242, 87623, 1687, 57, 3792, "Input"],
Cell[3098932, 87682, 2406, 74, 2928, "Input"],
Cell[3101341, 87758, 348, 7, 1312, "Text"],
Cell[3101692, 87767, 2949, 94, 6272, "Input"]
}, Closed]],
Cell[CellGroupData[{
Cell[3104678, 87866, 212, 3, 384, "Subsection"],
Cell[3104893, 87871, 1278, 43, 3152, "Input"],
Cell[CellGroupData[{
Cell[3106196, 87918, 1947, 55, 5824, "Input"],
Cell[3108146, 87975, 822, 24, 1344, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[3109005, 88004, 375, 9, 1360, "Input"],
Cell[3109383, 88015, 10228, 305, 8048, "Output"]
}, Open  ]],
Cell[3119626, 88323, 405, 9, 1312, "Text"],
Cell[CellGroupData[{
Cell[3120056, 88336, 2727, 73, 6624, "Input"],
Cell[3122786, 88411, 18995, 571, 17504, "Output"]
}, Open  ]],
Cell[3141796, 88985, 2234, 59, 5008, "Input"],
Cell[CellGroupData[{
Cell[3144055, 89048, 459, 13, 1360, "Input"],
Cell[3144517, 89063, 264, 4, 864, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[3144818, 89072, 328, 6, 864, "Input"],
Cell[3145149, 89080, 22429, 666, 18864, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[3167615, 89751, 591, 15, 2000, "Input"],
Cell[3168209, 89768, 15093, 453, 12432, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[3183339, 90226, 216, 6, 864, "Input"],
Cell[3183558, 90234, 70, 1, 864, "Output"]
}, Open  ]],
Cell[3183643, 90238, 140, 3, 864, "Input"]
}, Closed]],
Cell[CellGroupData[{
Cell[3183820, 90246, 1263, 32, 536, "Subsection"],
Cell[3185086, 90280, 526, 11, 1856, "Text"],
Cell[3185615, 90293, 412, 11, 960, "Input"],
Cell[CellGroupData[{
Cell[3186052, 90308, 3791, 106, 7904, "Input"],
Cell[3189846, 90416, 1121, 33, 1840, "Output"]
}, Open  ]],
Cell[3190982, 90452, 125, 3, 832, "Text"],
Cell[3191110, 90457, 2813, 82, 6224, "Input"],
Cell[CellGroupData[{
Cell[3193948, 90543, 764, 22, 2816, "Input"],
Cell[3194715, 90567, 3954, 132, 2400, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[3198706, 90704, 661, 17, 1472, "Input"],
Cell[3199370, 90723, 3185, 98, 3872, "Output"]
}, Open  ]],
Cell[3202570, 90824, 241, 5, 832, "Text"],
Cell[3202814, 90831, 5919, 163, 12352, "Input"],
Cell[CellGroupData[{
Cell[3208758, 90998, 1901, 52, 4368, "Input"],
Cell[3210662, 91052, 7327, 248, 5136, "Output"]
}, Open  ]],
Cell[3218004, 91303, 124, 3, 832, "Text"],
Cell[3218131, 91308, 109, 1, 832, "Text"],
Cell[3218243, 91311, 3237, 91, 5856, "Input"],
Cell[CellGroupData[{
Cell[3221505, 91406, 2211, 54, 9696, "Input"],
Cell[3223719, 91462, 16079, 522, 11248, "Output"]
}, Open  ]],
Cell[3239813, 91987, 126, 1, 832, "Text"],
Cell[3239942, 91990, 1411, 38, 4256, "Input"],
Cell[3241356, 92030, 394, 10, 864, "Input"],
Cell[3241753, 92042, 611, 17, 1840, "Input"],
Cell[CellGroupData[{
Cell[3242389, 92063, 4596, 136, 6448, "Input"],
Cell[3246988, 92201, 18784, 582, 11344, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[3265809, 92788, 736, 17, 1360, "Input"],
Cell[3266548, 92807, 842, 12, 944, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[3267427, 92824, 1621, 50, 1984, "Input"],
Cell[3269051, 92876, 2246, 35, 5664, "Message"],
Cell[3271300, 92913, 715, 15, 1408, "Output"],
Cell[3272018, 92930, 1275, 21, 3824, "Message"],
Cell[3273296, 92953, 714, 15, 1408, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[3274047, 92973, 105, 1, 864, "Input"],
Cell[3274155, 92976, 3106, 97, 3872, "Output"]
}, Open  ]],
Cell[3277276, 93076, 517, 9, 864, "Input"],
Cell[CellGroupData[{
Cell[3277818, 93089, 1218, 37, 2944, "Input"],
Cell[3279039, 93128, 441, 15, 1440, "Output"]
}, Open  ]],
Cell[3279495, 93146, 1241, 32, 2896, "Input"],
Cell[CellGroupData[{
Cell[3280761, 93182, 389, 11, 864, "Input"],
Cell[3281153, 93195, 151, 2, 864, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[3281341, 93202, 616, 16, 1840, "Input"],
Cell[3281960, 93220, 223, 4, 864, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[3282220, 93229, 4287, 107, 8544, "Input"],
Cell[3286510, 93338, 11833, 373, 9968, "Output"]
}, Open  ]],
Cell[3298358, 93714, 12395, 372, 12944, "Input"],
Cell[CellGroupData[{
Cell[3310778, 94090, 221, 4, 864, "Input"],
Cell[3311002, 94096, 198, 3, 864, "Output"]
}, Open  ]]
}, Closed]],
Cell[CellGroupData[{
Cell[3311249, 94105, 1204, 29, 872, "Subsection"],
Cell[CellGroupData[{
Cell[3312478, 94138, 95, 1, 768, "Subsubsection"],
Cell[3312576, 94141, 448, 16, 516096, "Text"],
Cell[3313027, 94159, 108, 1, 475136, "Text"],
Cell[3313138, 94162, 1310, 41, 1056768, "Input"],
Cell[3314451, 94205, 1692, 57, 2383872, "Input"],
Cell[3316146, 94264, 1620, 43, 1769472, "Text"]
}, Closed]],
Cell[CellGroupData[{
Cell[3317803, 94312, 565, 14, 1056, "Subsubsection"],
Cell[3318371, 94328, 99, 1, 475136, "Text"],
Cell[3318473, 94331, 313, 9, 909312, "Input"],
Cell[CellGroupData[{
Cell[3318811, 94344, 660, 20, 491520, "Input"],
Cell[3319474, 94366, 642, 22, 1015808, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[3320153, 94393, 907, 26, 892928, "Input"],
Cell[3321063, 94421, 1722, 56, 1433600, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[3322822, 94482, 314, 8, 491520, "Input"],
Cell[3323139, 94492, 763, 25, 770048, "Output"]
}, Open  ]]
}, Closed]],
Cell[CellGroupData[{
Cell[3323951, 94523, 867, 26, 1232, "Subsubsection"],
Cell[3324821, 94551, 2149, 72, 5648, "Input"],
Cell[CellGroupData[{
Cell[3326995, 94627, 1000, 27, 2800, "Input"],
Cell[3327998, 94656, 1009, 32, 1600, "Output"]
}, Open  ]],
Cell[3329022, 94691, 2014, 60, 10640, "Input"],
Cell[CellGroupData[{
Cell[3331061, 94755, 551, 16, 1360, "Input"],
Cell[3331615, 94773, 896, 26, 1360, "Output"]
}, Open  ]]
}, Closed]],
Cell[CellGroupData[{
Cell[3332560, 94805, 882, 22, 1088, "Subsubsection"],
Cell[3333445, 94829, 231, 5, 832, "Text"],
Cell[3333679, 94836, 1247, 37, 1456, "Input"],
Cell[3334929, 94875, 1339, 36, 1600, "Input"],
Cell[3336271, 94913, 227, 4, 1312, "Text"],
Cell[CellGroupData[{
Cell[3336523, 94921, 289, 8, 864, "Input"],
Cell[3336815, 94931, 388, 12, 1280, "Output"]
}, Open  ]],
Cell[3337218, 94946, 1464, 50, 2656, "Input"],
Cell[3338685, 94998, 516, 16, 912, "Text"],
Cell[3339204, 95016, 955, 31, 1408, "Input"],
Cell[3340162, 95049, 788, 22, 1968, "Text"],
Cell[3340953, 95073, 282, 8, 944, "Input"],
Cell[3341238, 95083, 240, 8, 896, "Text"]
}, Closed]],
Cell[CellGroupData[{
Cell[3341515, 95096, 534, 7, 512, "Subsubsection"],
Cell[3342052, 95105, 502, 15, 1456, "Text"]
}, Open  ]]
}, Closed]],
Cell[CellGroupData[{
Cell[3342603, 95126, 672, 14, 392, "Subsection"],
Cell[3343278, 95142, 123, 3, 832, "Text"],
Cell[3343404, 95147, 463, 15, 1440, "Input"],
Cell[CellGroupData[{
Cell[3343892, 95166, 371, 10, 864, "Input"],
Cell[3344266, 95178, 13145, 422, 14368, "Output"]
}, Open  ]],
Cell[3357426, 95603, 313, 9, 912, "Text"],
Cell[3357742, 95614, 157, 3, 832, "Text"],
Cell[CellGroupData[{
Cell[3357924, 95621, 5037, 159, 11936, "Input"],
Cell[3362964, 95782, 384, 11, 1408, "Output"],
Cell[3363351, 95795, 384, 11, 1408, "Output"],
Cell[3363738, 95808, 383, 11, 1408, "Output"],
Cell[3364124, 95821, 383, 11, 1408, "Output"],
Cell[3364510, 95834, 382, 11, 1408, "Output"],
Cell[3364895, 95847, 383, 11, 1408, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[3365315, 95863, 1743, 52, 4720, "Input"],
Cell[3367061, 95917, 892, 26, 1072, "Output"],
Cell[3367956, 95945, 14320, 440, 12544, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[3382313, 96390, 236, 6, 864, "Input"],
Cell[3382552, 96398, 124, 2, 864, "Output"]
}, Open  ]],
Cell[3382691, 96403, 234, 5, 832, "Text"],
Cell[CellGroupData[{
Cell[3382950, 96412, 2484, 65, 4544, "Input"],
Cell[3385437, 96479, 5214, 169, 3392, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[3390688, 96653, 905, 25, 1360, "Input"],
Cell[3391596, 96680, 240, 3, 864, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[3391873, 96688, 601, 16, 1840, "Input"],
Cell[3392477, 96706, 3502, 106, 3168, "Output"],
Cell[3395982, 96814, 3552, 108, 3392, "Output"],
Cell[3399537, 96924, 167, 2, 864, "Output"]
}, Open  ]],
Cell[3399719, 96929, 133, 1, 832, "Text"],
Cell[3399855, 96932, 1490, 46, 3664, "Input"],
Cell[CellGroupData[{
Cell[3401370, 96982, 1202, 34, 3280, "Input"],
Cell[3402575, 97018, 2259, 69, 3408, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[3404871, 97092, 1453, 41, 3440, "Input"],
Cell[3406327, 97135, 1210, 38, 1520, "Output"],
Cell[3407540, 97175, 983, 29, 1344, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[3408560, 97209, 749, 20, 2320, "Input"],
Cell[3409312, 97231, 7437, 234, 5808, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[3416786, 97470, 279, 7, 864, "Input"],
Cell[3417068, 97479, 11213, 358, 9152, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[3428318, 97842, 519, 14, 1360, "Input"],
Cell[3428840, 97858, 119, 2, 864, "Output"]
}, Open  ]],
Cell[3428974, 97863, 11916, 359, 10480, "Input"]
}, Closed]],
Cell[CellGroupData[{
Cell[3440927, 98227, 326, 6, 384, "Subsection"],
Cell[3441256, 98235, 109, 1, 319488, "Text"],
Cell[3441368, 98238, 631, 21, 622592, "Input"],
Cell[3442002, 98261, 764, 23, 409600, "Input"],
Cell[3442769, 98286, 451, 14, 630784, "Input"],
Cell[3443223, 98302, 240, 4, 319488, "Text"],
Cell[3443466, 98308, 2420, 79, 1744896, "Input"],
Cell[3445889, 98389, 594, 15, 630784, "Text"],
Cell[3446486, 98406, 3323, 103, 2015232, "Input"],
Cell[3449812, 98511, 214, 4, 319488, "Text"],
Cell[3450029, 98517, 2926, 94, 1744896, "Input"],
Cell[3452958, 98613, 1021, 30, 548864, "Text"],
Cell[3453982, 98645, 14538, 436, 7372800, "Input"],
Cell[3468523, 99083, 281, 5, 319488, "Text"],
Cell[CellGroupData[{
Cell[3468829, 99092, 460, 14, 557056, "Input"],
Cell[3469292, 99108, 1012, 30, 573440, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[3470341, 99143, 2468, 75, 1662976, "Input"],
Cell[3472812, 99220, 1494, 44, 663552, "Output"]
}, Open  ]],
Cell[3474321, 99267, 3181, 92, 917504, "Input"]
}, Closed]],
Cell[CellGroupData[{
Cell[3477539, 99364, 448, 10, 384, "Subsection"],
Cell[CellGroupData[{
Cell[3478012, 99378, 107, 1, 768, "Subsubsection"],
Cell[3478122, 99381, 624, 17, 912, "Input"],
Cell[3478749, 99400, 194, 6, 832, "Text"],
Cell[CellGroupData[{
Cell[3478968, 99410, 3559, 102, 6752, "Input"],
Cell[3482530, 99514, 1203, 34, 1984, "Output"]
}, Open  ]],
Cell[3483748, 99551, 2813, 82, 6224, "Input"],
Cell[CellGroupData[{
Cell[3486586, 99637, 764, 22, 2816, "Input"],
Cell[3487353, 99661, 3812, 130, 2400, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[3491202, 99796, 324, 10, 1504, "Input"],
Cell[3491529, 99808, 5694, 184, 4832, "Output"]
}, Open  ]],
Cell[3497238, 99995, 102, 1, 832, "Text"],
Cell[CellGroupData[{
Cell[3497365, 100000, 1890, 58, 5184, "Input"],
Cell[3499258, 100060, 8556, 258, 8208, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[3507851, 100323, 1447, 37, 3280, "Input"],
Cell[3509301, 100362, 10431, 318, 7488, "Output"]
}, Open  ]]
}, Closed]],
Cell[CellGroupData[{
Cell[3519781, 100686, 105, 1, 512, "Subsubsection"],
Cell[3519889, 100689, 94, 1, 832, "Text"],
Cell[3519986, 100692, 508, 15, 1408, "Input"],
Cell[CellGroupData[{
Cell[3520519, 100711, 3620, 98, 6528, "Input"],
Cell[3524142, 100811, 1549, 48, 3408, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[3525728, 100864, 413, 13, 327680, "Input"],
Cell[3526144, 100879, 20520, 651, 3457024, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[3546701, 101535, 199, 5, 327680, "Input"],
Cell[3546903, 101542, 7733, 245, 1720320, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[3554673, 101792, 279, 7, 344064, "Input"],
Cell[3554955, 101801, 9015, 262, 2891776, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[3564007, 102068, 2087, 55, 1073152, "Input"],
Cell[3566097, 102125, 2850, 86, 1327104, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[3568984, 102216, 636, 19, 540672, "Input"],
Cell[3569623, 102237, 532, 13, 688128, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[3570192, 102255, 185, 4, 491520, "Input"],
Cell[3570380, 102261, 529, 13, 688128, "Output"]
}, Open  ]],
Cell[3570924, 102277, 566, 16, 516096, "Text"],
Cell[3571493, 102295, 105, 1, 319488, "Text"],
Cell[CellGroupData[{
Cell[3571623, 102300, 2132, 57, 5280, "Input"],
Cell[3573758, 102359, 10810, 321, 8032, "Output"]
}, Open  ]],
Cell[3584583, 102683, 365, 7, 1312, "Text"],
Cell[CellGroupData[{
Cell[3584973, 102694, 1550, 46, 3888, "Input"],
Cell[3586526, 102742, 20226, 571, 17072, "Output"]
}, Open  ]]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[3606813, 103320, 216, 3, 384, "Subsection"],
Cell[3607032, 103325, 2492, 82, 2944, "Input"],
Cell[CellGroupData[{
Cell[3609549, 103411, 1375, 27, 1184, "Subsubsection"],
Cell[3610927, 103440, 2492, 82, 1138688, "Input"],
Cell[3613422, 103524, 1034, 35, 679936, "Input"],
Cell[CellGroupData[{
Cell[3614481, 103563, 621, 15, 524288, "Input"],
Cell[3615105, 103580, 70, 1, 327680, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[3615212, 103586, 2708, 66, 1630208, "Input"],
Cell[3617923, 103654, 10627, 329, 3375104, "Output"]
}, Open  ]]
}, Closed]],
Cell[CellGroupData[{
Cell[3628599, 103989, 758, 20, 688, "Subsubsection"],
Cell[3629360, 104011, 2249, 78, 1736704, "Input"],
Cell[CellGroupData[{
Cell[3631634, 104093, 1000, 27, 942080, "Input"],
Cell[3632637, 104122, 881, 31, 696320, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[3633555, 104158, 1880, 56, 2908160, "Input"],
Cell[3635438, 104216, 1416, 44, 548864, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[3636891, 104265, 944, 26, 524288, "Input"],
Cell[3637838, 104293, 1137, 30, 548864, "Output"],
Cell[3638978, 104325, 4767, 143, 1007616, "Output"]
}, Open  ]]
}, Closed]],
Cell[CellGroupData[{
Cell[3643794, 104474, 324, 9, 688, "Subsubsection"],
Cell[CellGroupData[{
Cell[3644143, 104487, 232, 6, 352256, "Input"],
Cell[3644378, 104495, 3605, 109, 794624, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[3648020, 104609, 1415, 38, 1294336, "Input"],
Cell[3649438, 104649, 3451, 105, 1114112, "Output"]
}, Open  ]]
}, Closed]],
Cell[CellGroupData[{
Cell[3652938, 104760, 910, 18, 1088, "Subsubsection"],
Cell[CellGroupData[{
Cell[3653873, 104782, 1869, 51, 1433600, "Input"],
Cell[3655745, 104835, 8279, 257, 2686976, "Output"]
}, Open  ]]
}, Closed]],
Cell[CellGroupData[{
Cell[3664073, 105098, 920, 21, 512, "Subsubsection"],
Cell[3664996, 105121, 6667, 191, 3457024, "Input"],
Cell[3671666, 105314, 672, 20, 630784, "Input"],
Cell[3672341, 105336, 1616, 49, 655360, "Input"],
Cell[CellGroupData[{
Cell[3673982, 105389, 3440, 98, 2187264, "Input"],
Cell[3677425, 105489, 1208, 32, 458752, "Output"]
}, Open  ]]
}, Closed]],
Cell[CellGroupData[{
Cell[3678682, 105527, 937, 21, 848, "Subsubsection"],
Cell[3679622, 105550, 891, 18, 832, "Text"],
Cell[CellGroupData[{
Cell[3680538, 105572, 277, 8, 1024, "Input"],
Cell[3680818, 105582, 496, 10, 752, "Message"],
Cell[3681317, 105594, 476, 10, 704, "Message"],
Cell[3681796, 105606, 476, 10, 704, "Message"],
Cell[3682275, 105618, 585, 12, 672, "Message"],
Cell[3682863, 105632, 4347, 136, 3248, "Output"]
}, Open  ]],
Cell[3687225, 105771, 134, 3, 832, "Text"],
Cell[CellGroupData[{
Cell[3687384, 105778, 922, 27, 3328, "Input"],
Cell[3688309, 105807, 461, 15, 1472, "Output"]
}, Open  ]],
Cell[3688785, 105825, 617, 19, 1360, "Input"],
Cell[3689405, 105846, 558, 17, 1360, "Input"],
Cell[CellGroupData[{
Cell[3689988, 105867, 404, 14, 2256, "Input"],
Cell[3690395, 105883, 34268, 1067, 33472, "Output"]
}, Open  ]],
Cell[3724678, 106953, 1922, 56, 3552, "Input"],
Cell[CellGroupData[{
Cell[3726625, 107013, 705, 19, 1840, "Input"],
Cell[3727333, 107034, 3477, 104, 4800, "Output"],
Cell[3730813, 107140, 3562, 108, 1776, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[3734412, 107253, 199, 4, 864, "Input"],
Cell[3734614, 107259, 72, 1, 864, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[3734723, 107265, 702, 20, 1952, "Input"],
Cell[3735428, 107287, 653, 22, 1280, "Output"]
}, Open  ]],
Cell[3736096, 107312, 485, 12, 1360, "Input"],
Cell[CellGroupData[{
Cell[3736606, 107328, 3153, 101, 1984, "Input"],
Cell[3739762, 107431, 309, 5, 864, "Output"]
}, Open  ]],
Cell[3740086, 107439, 295, 6, 832, "Text"],
Cell[CellGroupData[{
Cell[3740406, 107449, 1389, 40, 4720, "Input"],
Cell[3741798, 107491, 297, 9, 1376, "Output"]
}, Open  ]],
Cell[3742110, 107503, 310, 5, 1312, "Text"],
Cell[CellGroupData[{
Cell[3742445, 107512, 275, 7, 1408, "Input"],
Cell[3742723, 107521, 244, 8, 944, "Output"]
}, Open  ]],
Cell[3742982, 107532, 125, 3, 832, "Text"],
Cell[CellGroupData[{
Cell[3743132, 107539, 949, 27, 3632, "Input"],
Cell[3744084, 107568, 3553, 118, 3488, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[3747674, 107691, 365, 8, 1360, "Input"],
Cell[3748042, 107701, 3602, 119, 3488, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[3751681, 107825, 289, 5, 864, "Input"],
Cell[3751973, 107832, 322, 5, 944, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[3752332, 107842, 693, 21, 1408, "Input"],
Cell[3753028, 107865, 266, 5, 944, "Output"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[3753343, 107876, 127, 2, 768, "Subsubsection"],
Cell[CellGroupData[{
Cell[3753495, 107882, 1484, 35, 1425408, "Input"],
Cell[3754982, 107919, 4444, 144, 1794048, "Output"]
}, Open  ]]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[3759487, 108070, 470, 10, 432, "Subsection"],
Cell[3759960, 108082, 1237, 42, 573440, "Input"],
Cell[CellGroupData[{
Cell[3761222, 108128, 208, 4, 327680, "Input"],
Cell[3761433, 108134, 10362, 344, 2572288, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[3771832, 108483, 4150, 101, 1794048, "Input"],
Cell[3775985, 108586, 15869, 423, 2629632, "Output"]
}, Open  ]],
Cell[3791869, 109012, 126, 1, 319488, "Text"],
Cell[CellGroupData[{
Cell[3792020, 109017, 1963, 47, 1908736, "Input"],
Cell[3793986, 109066, 28268, 640, 4964352, "Output"]
}, Open  ]],
Cell[3822269, 109709, 689, 15, 532480, "Text"],
Cell[3822961, 109726, 121, 1, 319488, "Text"],
Cell[CellGroupData[{
Cell[3823107, 109731, 96, 1, 327680, "Input"],
Cell[3823206, 109734, 14782, 408, 2629632, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[3838025, 110147, 1005, 28, 901120, "Input"],
Cell[3839033, 110177, 4173, 139, 786432, "Output"],
Cell[3843209, 110318, 3159, 86, 1163264, "Output"]
}, Open  ]],
Cell[3846383, 110407, 228, 5, 319488, "Text"],
Cell[CellGroupData[{
Cell[3846636, 110416, 521, 12, 614400, "Input"],
Cell[3847160, 110430, 4231, 138, 786432, "Output"]
}, Open  ]],
Cell[3851406, 110571, 100, 1, 327680, "Input"],
Cell[CellGroupData[{
Cell[3851531, 110576, 652, 17, 327680, "Input"],
Cell[3852186, 110595, 32236, 1015, 12705792, "Output"]
}, Open  ]],
Cell[3884437, 111613, 127, 1, 319488, "Text"],
Cell[CellGroupData[{
Cell[3884589, 111618, 352, 8, 327680, "Input"],
Cell[3884944, 111628, 54306, 1667, 17965056, "Output"]
}, Open  ]],
Cell[3939265, 113298, 733, 20, 1138688, "Input"],
Cell[3940001, 113320, 360, 9, 327680, "Input"]
}, Closed]],
Cell[CellGroupData[{
Cell[3940398, 113334, 162, 2, 384, "Subsection"],
Cell[3940563, 113338, 673, 21, 1040, "Input"],
Cell[CellGroupData[{
Cell[3941261, 113363, 1785, 52, 2896, "Input"],
Cell[3943049, 113417, 1604, 49, 1024, "Output"],
Cell[3944656, 113468, 1368, 47, 1280, "Output"]
}, Open  ]],
Cell[3946039, 113518, 446, 14, 896, "Input"],
Cell[3946488, 113534, 1266, 33, 2144, "Input"],
Cell[CellGroupData[{
Cell[3947779, 113571, 296, 8, 864, "Input"],
Cell[3948078, 113581, 120, 2, 864, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[3948235, 113588, 590, 16, 2128, "Input"],
Cell[3948828, 113606, 61851, 1844, 54800, "Output"]
}, Open  ]],
Cell[4010694, 115453, 644, 18, 1520, "Input"]
}, Closed]],
Cell[CellGroupData[{
Cell[4011375, 115476, 152, 2, 384, "Subsection"],
Cell[4011530, 115480, 680, 23, 1232, "Input"],
Cell[4012213, 115505, 472, 16, 1536, "Input"],
Cell[CellGroupData[{
Cell[4012710, 115525, 757, 22, 2208, "Input"],
Cell[4013470, 115549, 508, 10, 672, "Message"],
Cell[4013981, 115561, 2466, 70, 2544, "Output"]
}, Open  ]],
Cell[4016462, 115634, 2117, 61, 5200, "Input"],
Cell[4018582, 115697, 319, 9, 864, "Input"],
Cell[4018904, 115708, 219, 5, 864, "Input"],
Cell[CellGroupData[{
Cell[4019148, 115717, 671, 18, 1840, "Input"],
Cell[4019822, 115737, 221, 3, 864, "Output"],
Cell[4020046, 115742, 772, 21, 912, "Output"]
}, Open  ]],
Cell[4020833, 115766, 142, 3, 864, "Input"],
Cell[4020978, 115771, 1445, 42, 3760, "Input"],
Cell[CellGroupData[{
Cell[4022448, 115817, 127, 2, 864, "Input"],
Cell[4022578, 115821, 94, 1, 864, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[4022709, 115827, 163, 4, 864, "Input"],
Cell[4022875, 115833, 91, 1, 864, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[4023003, 115839, 188, 5, 864, "Input"],
Cell[4023194, 115846, 118, 2, 864, "Output"]
}, Open  ]],
Cell[4023327, 115851, 632, 23, 1552, "Input"],
Cell[4023962, 115876, 676, 20, 1840, "Input"],
Cell[CellGroupData[{
Cell[4024663, 115900, 1155, 35, 1952, "Input"],
Cell[4025821, 115937, 197, 3, 864, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[4026055, 115945, 545, 16, 1360, "Input"],
Cell[4026603, 115963, 146, 2, 864, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[4026786, 115970, 2440, 73, 5408, "Input"],
Cell[4029229, 116045, 215, 4, 864, "Output"]
}, Open  ]],
Cell[4029459, 116052, 726, 20, 2320, "Input"],
Cell[CellGroupData[{
Cell[4030210, 116076, 903, 27, 2320, "Input"],
Cell[4031116, 116105, 94, 1, 864, "Output"]
}, Open  ]],
Cell[4031225, 116109, 272, 8, 880, "Text"],
Cell[4031500, 116119, 1313, 38, 3344, "Input"],
Cell[CellGroupData[{
Cell[4032838, 116161, 447, 12, 912, "Input"],
Cell[4033288, 116175, 237, 6, 944, "Output"]
}, Open  ]],
Cell[4033540, 116184, 352, 10, 864, "Input"]
}, Closed]],
Cell[CellGroupData[{
Cell[4033929, 116199, 201, 3, 384, "Subsection"],
Cell[4034133, 116204, 680, 23, 475136, "Input"],
Cell[4034816, 116229, 568, 19, 598016, "Input"],
Cell[CellGroupData[{
Cell[4035409, 116252, 860, 24, 638976, "Input"],
Cell[4036272, 116278, 536, 11, 262144, "Message"],
Cell[4036811, 116291, 546, 11, 262144, "Message"],
Cell[4037360, 116304, 2673, 77, 729088, "Output"]
}, Open  ]],
Cell[4040048, 116384, 2117, 61, 901120, "Input"],
Cell[4042168, 116447, 319, 9, 327680, "Input"],
Cell[4042490, 116458, 219, 5, 327680, "Input"],
Cell[CellGroupData[{
Cell[4042734, 116467, 671, 18, 532480, "Input"],
Cell[4043408, 116487, 245, 3, 458752, "Output"],
Cell[4043656, 116492, 807, 21, 483328, "Output"]
}, Open  ]],
Cell[4044478, 116516, 142, 3, 327680, "Input"],
Cell[4044623, 116521, 1445, 42, 720896, "Input"],
Cell[CellGroupData[{
Cell[4046093, 116567, 127, 2, 327680, "Input"],
Cell[4046223, 116571, 119, 2, 458752, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[4046379, 116578, 319, 9, 327680, "Input"],
Cell[4046701, 116589, 191, 5, 458752, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[4046929, 116599, 188, 5, 327680, "Input"],
Cell[4047120, 116606, 142, 2, 458752, "Output"]
}, Open  ]],
Cell[4047277, 116611, 632, 23, 606208, "Input"],
Cell[4047912, 116636, 725, 21, 712704, "Input"],
Cell[CellGroupData[{
Cell[4048662, 116661, 1155, 35, 786432, "Input"],
Cell[4049820, 116698, 219, 3, 458752, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[4050076, 116706, 545, 16, 327680, "Input"],
Cell[4050624, 116724, 168, 2, 458752, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[4050829, 116731, 2440, 73, 1327104, "Input"],
Cell[4053272, 116806, 237, 4, 458752, "Output"]
}, Open  ]],
Cell[4053524, 116813, 775, 21, 524288, "Input"],
Cell[CellGroupData[{
Cell[4054324, 116838, 950, 28, 524288, "Input"],
Cell[4055277, 116868, 119, 2, 458752, "Output"]
}, Open  ]],
Cell[4055411, 116873, 272, 8, 344064, "Text"],
Cell[4055686, 116883, 1362, 39, 729088, "Input"],
Cell[CellGroupData[{
Cell[4057073, 116926, 498, 13, 352256, "Input"],
Cell[4057574, 116941, 263, 7, 491520, "Output"]
}, Open  ]],
Cell[4057852, 116951, 401, 11, 327680, "Input"],
Cell[4058256, 116964, 106, 1, 327680, "Input"]
}, Closed]],
Cell[CellGroupData[{
Cell[4058399, 116970, 201, 3, 384, "Subsection"],
Cell[4058603, 116975, 680, 23, 475136, "Input"],
Cell[4059286, 117000, 580, 19, 630784, "Input"],
Cell[CellGroupData[{
Cell[4059891, 117023, 871, 24, 630784, "Input"],
Cell[4060765, 117049, 536, 11, 262144, "Message"],
Cell[4061304, 117062, 546, 11, 262144, "Message"],
Cell[4061853, 117075, 2695, 77, 729088, "Output"]
}, Open  ]],
Cell[4064563, 117155, 2117, 61, 901120, "Input"],
Cell[4066683, 117218, 319, 9, 327680, "Input"],
Cell[4067005, 117229, 219, 5, 327680, "Input"],
Cell[CellGroupData[{
Cell[4067249, 117238, 671, 18, 532480, "Input"],
Cell[4067923, 117258, 243, 3, 458752, "Output"],
Cell[4068169, 117263, 811, 21, 483328, "Output"]
}, Open  ]],
Cell[4068995, 117287, 142, 3, 327680, "Input"],
Cell[4069140, 117292, 1445, 42, 720896, "Input"],
Cell[CellGroupData[{
Cell[4070610, 117338, 127, 2, 327680, "Input"],
Cell[4070740, 117342, 119, 2, 458752, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[4070896, 117349, 319, 9, 327680, "Input"],
Cell[4071218, 117360, 91, 1, 458752, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[4071346, 117366, 188, 5, 327680, "Input"],
Cell[4071537, 117373, 118, 2, 458752, "Output"]
}, Open  ]],
Cell[4071670, 117378, 632, 23, 606208, "Input"],
Cell[4072305, 117403, 725, 21, 712704, "Input"],
Cell[CellGroupData[{
Cell[4073055, 117428, 1155, 35, 786432, "Input"],
Cell[4074213, 117465, 219, 3, 458752, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[4074469, 117473, 545, 16, 327680, "Input"],
Cell[4075017, 117491, 168, 2, 458752, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[4075222, 117498, 2440, 73, 1327104, "Input"],
Cell[4077665, 117573, 237, 4, 458752, "Output"]
}, Open  ]],
Cell[4077917, 117580, 777, 21, 524288, "Input"],
Cell[CellGroupData[{
Cell[4078719, 117605, 950, 28, 524288, "Input"],
Cell[4079672, 117635, 119, 2, 458752, "Output"]
}, Open  ]],
Cell[4079806, 117640, 272, 8, 344064, "Text"],
Cell[4080081, 117650, 1362, 39, 729088, "Input"],
Cell[CellGroupData[{
Cell[4081468, 117693, 496, 13, 352256, "Input"],
Cell[4081967, 117708, 263, 7, 491520, "Output"]
}, Open  ]],
Cell[4082245, 117718, 401, 11, 327680, "Input"]
}, Closed]],
Cell[CellGroupData[{
Cell[4082683, 117734, 123, 1, 384, "Subsection"],
Cell[4082809, 117737, 260, 5, 656, "Text"],
Cell[CellGroupData[{
Cell[4083094, 117746, 460, 14, 784, "Input"],
Cell[4083557, 117762, 443, 9, 336, "Message"],
Cell[4084003, 117773, 441, 9, 336, "Message"],
Cell[4084447, 117784, 451, 9, 352, "Message"],
Cell[4084901, 117795, 560, 11, 336, "Message"]
}, Open  ]],
Cell[CellGroupData[{
Cell[4085498, 117811, 834, 24, 680, "Input"],
Cell[4086335, 117837, 560, 18, 648, "Output"]
}, Open  ]],
Cell[4086910, 117858, 215, 4, 656, "Text"],
Cell[CellGroupData[{
Cell[4087150, 117866, 886, 26, 680, "Input"],
Cell[4088039, 117894, 14701, 421, 3432, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[4102777, 118320, 5073, 153, 2080, "Input"],
Cell[4107853, 118475, 4263, 134, 2304, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[4112153, 118614, 4207, 114, 2768, "Input"],
Cell[4116363, 118730, 2396, 71, 928, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[4118796, 118806, 4239, 123, 1568, "Input"],
Cell[4123038, 118931, 323, 10, 664, "Output"]
}, Open  ]],
Cell[4123376, 118944, 310, 10, 792, "Input"],
Cell[CellGroupData[{
Cell[4123711, 118958, 99, 1, 432, "Input"],
Cell[4123813, 118961, 3696, 120, 1352, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[4127546, 119086, 8463, 230, 4824, "Input"],
Cell[4136012, 119318, 11871, 322, 5672, "Output"],
Cell[4147886, 119642, 3817, 122, 1352, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[4151740, 119769, 232, 7, 472, "Input"],
Cell[4151975, 119778, 5261, 175, 1312, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[4157273, 119958, 218, 5, 432, "Input"],
Cell[4157494, 119965, 630, 16, 704, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[4158161, 119986, 3686, 103, 1632, "Input"],
Cell[4161850, 120091, 3837, 119, 784, "Output"],
Cell[4165690, 120212, 191, 4, 432, "Output"]
}, Open  ]],
Cell[4165896, 120219, 2489, 69, 2712, "Input"],
Cell[4168388, 120290, 849, 23, 1160, "Input"],
Cell[4169240, 120315, 1416, 38, 2168, "Input"],
Cell[4170659, 120355, 803, 22, 1160, "Input"],
Cell[4171465, 120379, 1913, 51, 3992, "Input"],
Cell[4173381, 120432, 801, 22, 1160, "Input"],
Cell[4174185, 120456, 246, 7, 432, "Input"],
Cell[CellGroupData[{
Cell[4174456, 120467, 1014, 31, 1064, "Input"],
Cell[4175473, 120500, 143, 2, 432, "Output"]
}, Open  ]],
Cell[4175631, 120505, 451, 11, 432, "Input"],
Cell[4176085, 120518, 254, 7, 432, "Input"],
Cell[CellGroupData[{
Cell[4176364, 120529, 2251, 57, 2840, "Input"],
Cell[4178618, 120588, 471, 9, 472, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[4179126, 120602, 344, 9, 680, "Input"],
Cell[4179473, 120613, 277, 6, 472, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[4179787, 120624, 148, 3, 432, "Input"],
Cell[4179938, 120629, 12500, 373, 3104, "Output"]
}, Open  ]],
Cell[4192453, 121005, 703, 19, 920, "Input"],
Cell[4193159, 121026, 977, 28, 1424, "Input"],
Cell[4194139, 121056, 252, 7, 432, "Input"],
Cell[4194394, 121065, 710, 19, 1160, "Input"],
Cell[4195107, 121086, 213, 5, 432, "Input"],
Cell[CellGroupData[{
Cell[4195345, 121095, 304, 8, 432, "Input"],
Cell[4195652, 121105, 311, 7, 432, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[4196000, 121117, 692, 20, 920, "Input"],
Cell[4196695, 121139, 314, 7, 432, "Output"]
}, Open  ]],
Cell[4197024, 121149, 252, 7, 432, "Input"],
Cell[4197279, 121158, 134, 2, 432, "Input"]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[4197462, 121166, 675, 9, 70, "Section"],
Cell[CellGroupData[{
Cell[4198162, 121179, 174, 4, 136, "Subsection"],
Cell[4198339, 121185, 105, 1, 208, "Text"],
Cell[4198447, 121188, 1857, 61, 432, "Input"],
Cell[4200307, 121251, 103, 1, 208, "Text"],
Cell[4200413, 121254, 441, 13, 236, "Input"],
Cell[4200857, 121269, 576, 15, 328, "Text"],
Cell[4201436, 121286, 1921, 62, 448, "Input"],
Cell[4203360, 121350, 3968, 125, 740, "Input"],
Cell[4207331, 121477, 12367, 411, 2448, "Input"],
Cell[4219701, 121890, 107, 1, 416, "Text"],
Cell[4219811, 121893, 1340, 47, 856, "Input"],
Cell[CellGroupData[{
Cell[4221176, 121944, 201, 3, 384, "Subsubsection"],
Cell[CellGroupData[{
Cell[4221402, 121951, 4291, 122, 2147483647, "Input"],
Cell[4225696, 122075, 510, 7, 2147483647, "Output"],
Cell[4226209, 122084, 2817, 74, 2147483647, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[4229063, 122163, 2446, 75, 2147483647, "Input"],
Cell[4231512, 122240, 125, 2, 2147483647, "Output"],
Cell[4231640, 122244, 2431, 69, 2147483647, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[4234108, 122318, 120, 2, 1626767360, "Input"],
Cell[4234231, 122322, 259, 7, 2147483647, "Output"]
}, Open  ]]
}, Closed]],
Cell[CellGroupData[{
Cell[4234539, 122335, 361, 8, 256, "Subsubsection"],
Cell[CellGroupData[{
Cell[4234925, 122347, 4837, 139, 2147483647, "Input"],
Cell[4239765, 122488, 122, 2, 2147483647, "Output"]
}, Open  ]]
}, Closed]],
Cell[CellGroupData[{
Cell[4239936, 122496, 299, 4, 256, "Subsubsection"],
Cell[4240238, 122502, 490, 14, 712, "Text"],
Cell[4240731, 122518, 623, 19, 512, "Input"],
Cell[4241357, 122539, 868, 24, 656, "Text"],
Cell[4242228, 122565, 108, 1, 416, "Text"],
Cell[4242339, 122568, 1594, 46, 1432, "Input"],
Cell[CellGroupData[{
Cell[4243958, 122618, 5058, 143, 4616, "Input"],
Cell[4249019, 122763, 636, 12, 960, "Message"]
}, Open  ]],
Cell[4249670, 122778, 4004, 116, 4336, "Input"],
Cell[CellGroupData[{
Cell[4253699, 122898, 665, 21, 792, "Input"],
Cell[4254367, 122921, 5237, 174, 3360, "Output"]
}, Open  ]],
Cell[4259619, 123098, 5591, 176, 4072, "Input"],
Cell[CellGroupData[{
Cell[4265235, 123278, 1366, 44, 1240, "Input"],
Cell[4266604, 123324, 616, 17, 432, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[4267257, 123346, 1988, 62, 1520, "Input"],
Cell[4269248, 123410, 846, 23, 728, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[4270131, 123438, 1176, 39, 1232, "Input"],
Cell[4271310, 123479, 7874, 246, 2096, "Output"]
}, Open  ]],
Cell[4279199, 123728, 91, 1, 432, "Input"],
Cell[CellGroupData[{
Cell[4279315, 123733, 1633, 50, 1232, "Input"],
Cell[4280951, 123785, 41614, 1268, 8880, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[4322602, 125058, 173, 4, 432, "Input"],
Cell[4322778, 125064, 1151, 44, 752, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[4323966, 125113, 518, 15, 432, "Input"],
Cell[4324487, 125130, 2055, 66, 1160, "Output"]
}, Open  ]],
Cell[4326557, 125199, 142, 1, 416, "Text"],
Cell[CellGroupData[{
Cell[4326724, 125204, 2153, 58, 2064, "Input"],
Cell[4328880, 125264, 6858, 187, 3856, "Output"]
}, Open  ]]
}, Open  ]]
}, Closed]],
Cell[CellGroupData[{
Cell[4335799, 125458, 267, 5, 96, "Subsection"],
Cell[4336069, 125465, 214, 4, 416, "Text"],
Cell[4336286, 125471, 1093, 33, 1128, "Input"],
Cell[4337382, 125506, 1330, 40, 1056, "Text"]
}, Closed]],
Cell[CellGroupData[{
Cell[4338749, 125551, 120, 1, 96, "Subsection"],
Cell[CellGroupData[{
Cell[4338894, 125556, 253, 5, 192, "Subsubsection"],
Cell[4339150, 125563, 406, 8, 448, "Text"],
Cell[CellGroupData[{
Cell[4339581, 125575, 1153, 32, 820, "Input"],
Cell[4340737, 125609, 7527, 259, 864, "Output"]
}, Open  ]],
Cell[4348279, 125871, 138, 3, 208, "Text"],
Cell[4348420, 125876, 1018, 32, 460, "Input"],
Cell[4349441, 125910, 693, 12, 1168, "Text"]
}, Closed]],
Cell[CellGroupData[{
Cell[4350171, 125927, 231, 4, 128, "Subsubsection"],
Cell[4350405, 125933, 223, 4, 328, "Text"],
Cell[CellGroupData[{
Cell[4350653, 125941, 100, 2, 216, "Input"],
Cell[4350756, 125945, 377, 12, 216, "Output"]
}, Open  ]],
Cell[4351148, 125960, 298, 7, 460, "Input"],
Cell[4351449, 125969, 282, 5, 208, "Text"],
Cell[4351734, 125976, 504, 17, 460, "Input"],
Cell[4352241, 125995, 722, 21, 580, "Input"],
Cell[4352966, 126018, 161, 4, 208, "Text"],
Cell[4353130, 126024, 864, 25, 580, "Input"],
Cell[4353997, 126051, 277, 6, 208, "Text"]
}, Closed]],
Cell[CellGroupData[{
Cell[4354311, 126062, 301, 5, 128, "Subsubsection"],
Cell[4354615, 126069, 172, 4, 216, "Input"]
}, Open  ]]
}, Closed]],
Cell[CellGroupData[{
Cell[4354836, 126079, 100, 1, 96, "Subsection"],
Cell[4354939, 126082, 177, 4, 208, "Text"],
Cell[4355119, 126088, 102, 2, 216, "Input"],
Cell[CellGroupData[{
Cell[4355246, 126094, 158, 3, 216, "Input"],
Cell[4355407, 126099, 445, 13, 304, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[4355889, 126117, 566, 15, 216, "Input"],
Cell[4356458, 126134, 827, 26, 336, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[4357322, 126165, 612, 17, 340, "Input"],
Cell[4357937, 126184, 1124, 37, 336, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[4359098, 126226, 690, 20, 460, "Input"],
Cell[4359791, 126248, 1823, 62, 488, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[4361651, 126315, 2855, 84, 1404, "Input"],
Cell[4364509, 126401, 6591, 225, 1408, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[4371137, 126631, 183, 5, 216, "Input"],
Cell[4371323, 126638, 3925, 137, 948, "Output"]
}, Open  ]],
Cell[4375263, 126778, 1118, 32, 580, "Input"],
Cell[CellGroupData[{
Cell[4376406, 126814, 187, 4, 216, "Input"],
Cell[4376596, 126820, 3879, 136, 948, "Output"]
}, Open  ]]
}, Closed]]
}, Closed]]
}
]
*)

(* End of internal cache information *)
